# Copyright 2017 Google Inc.
#
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

# This file is generated semi-automatically with this command:
#   $ src/jumper/build_stages.py

#if defined(__MACH__)
    #define HIDDEN .private_extern
    #define FUNCTION(name)
    #define BALIGN4  .align 2
    #define BALIGN8  .align 3
    #define BALIGN16 .align 4
    #define BALIGN32 .align 5
#else
    .section .note.GNU-stack,"",%progbits
    #define HIDDEN .hidden
    #define FUNCTION(name) .type name,%function
    #define BALIGN4  .balign 4
    #define BALIGN8  .balign 8
    #define BALIGN16 .balign 16
    #define BALIGN32 .balign 32
#endif
.text
#if defined(__x86_64__)
BALIGN32

HIDDEN _sk_start_pipeline_skx
.globl _sk_start_pipeline_skx
FUNCTION(_sk_start_pipeline_skx)
_sk_start_pipeline_skx:
  .byte  85                                  // push          %rbp
  .byte  72,137,229                          // mov           %rsp,%rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  73,137,215                          // mov           %rdx,%r15
  .byte  72,137,243                          // mov           %rsi,%rbx
  .byte  72,137,125,208                      // mov           %rdi,-0x30(%rbp)
  .byte  76,137,198                          // mov           %r8,%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  73,137,197                          // mov           %rax,%r13
  .byte  73,137,246                          // mov           %rsi,%r14
  .byte  72,137,77,192                       // mov           %rcx,-0x40(%rbp)
  .byte  72,57,203                           // cmp           %rcx,%rbx
  .byte  15,131,152,0,0,0                    // jae           cb <_sk_start_pipeline_skx+0xcb>
  .byte  72,139,69,208                       // mov           -0x30(%rbp),%rax
  .byte  72,141,64,8                         // lea           0x8(%rax),%rax
  .byte  72,137,69,200                       // mov           %rax,-0x38(%rbp)
  .byte  72,139,85,208                       // mov           -0x30(%rbp),%rdx
  .byte  76,57,125,200                       // cmp           %r15,-0x38(%rbp)
  .byte  119,67                              // ja            8c <_sk_start_pipeline_skx+0x8c>
  .byte  76,139,101,208                      // mov           -0x30(%rbp),%r12
  .byte  49,255                              // xor           %edi,%edi
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  76,137,226                          // mov           %r12,%rdx
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  73,141,84,36,8                      // lea           0x8(%r12),%rdx
  .byte  73,131,196,16                       // add           $0x10,%r12
  .byte  77,57,252                           // cmp           %r15,%r12
  .byte  73,137,212                          // mov           %rdx,%r12
  .byte  118,193                             // jbe           4d <_sk_start_pipeline_skx+0x4d>
  .byte  76,137,255                          // mov           %r15,%rdi
  .byte  72,41,215                           // sub           %rdx,%rdi
  .byte  116,41                              // je            bd <_sk_start_pipeline_skx+0xbd>
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  72,131,195,1                        // add           $0x1,%rbx
  .byte  72,59,93,192                        // cmp           -0x40(%rbp),%rbx
  .byte  15,133,116,255,255,255              // jne           3f <_sk_start_pipeline_skx+0x3f>
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  197,248,119                         // vzeroupper
  .byte  195                                 // retq

HIDDEN _sk_just_return_skx
.globl _sk_just_return_skx
FUNCTION(_sk_just_return_skx)
_sk_just_return_skx:
  .byte  195                                 // retq

HIDDEN _sk_seed_shader_skx
.globl _sk_seed_shader_skx
FUNCTION(_sk_seed_shader_skx)
_sk_seed_shader_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,242,125,40,124,194               // vpbroadcastd  %edx,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  98,242,125,40,124,201               // vpbroadcastd  %ecx,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  98,241,116,56,88,13,18,161,3,0      // vaddps        0x3a112(%rip){1to8},%ymm1,%ymm1        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,21,11,161,3,0        // vbroadcastss  0x3a10b(%rip),%ymm2        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dither_skx
.globl _sk_dither_skx
FUNCTION(_sk_dither_skx)
_sk_dither_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,114,125,40,124,194               // vpbroadcastd  %edx,%ymm8
  .byte  197,61,254,5,141,162,3,0            // vpaddd        0x3a28d(%rip),%ymm8,%ymm8        # 3a3c0 <_sk_srcover_bgra_8888_sse2_lowp+0x458>
  .byte  98,114,125,40,124,201               // vpbroadcastd  %ecx,%ymm9
  .byte  196,65,53,239,200                   // vpxor         %ymm8,%ymm9,%ymm9
  .byte  196,98,125,88,21,213,160,3,0        // vpbroadcastd  0x3a0d5(%rip),%ymm10        # 3a21c <_sk_srcover_bgra_8888_sse2_lowp+0x2b4>
  .byte  196,65,53,219,218                   // vpand         %ymm10,%ymm9,%ymm11
  .byte  196,193,37,114,243,5                // vpslld        $0x5,%ymm11,%ymm11
  .byte  196,65,61,219,210                   // vpand         %ymm10,%ymm8,%ymm10
  .byte  196,193,45,114,242,4                // vpslld        $0x4,%ymm10,%ymm10
  .byte  196,98,125,88,37,186,160,3,0        // vpbroadcastd  0x3a0ba(%rip),%ymm12        # 3a220 <_sk_srcover_bgra_8888_sse2_lowp+0x2b8>
  .byte  196,98,125,88,45,181,160,3,0        // vpbroadcastd  0x3a0b5(%rip),%ymm13        # 3a224 <_sk_srcover_bgra_8888_sse2_lowp+0x2bc>
  .byte  196,65,53,219,245                   // vpand         %ymm13,%ymm9,%ymm14
  .byte  196,193,13,114,246,2                // vpslld        $0x2,%ymm14,%ymm14
  .byte  196,65,37,235,222                   // vpor          %ymm14,%ymm11,%ymm11
  .byte  196,65,61,219,237                   // vpand         %ymm13,%ymm8,%ymm13
  .byte  196,65,21,254,237                   // vpaddd        %ymm13,%ymm13,%ymm13
  .byte  196,65,21,235,210                   // vpor          %ymm10,%ymm13,%ymm10
  .byte  196,65,53,219,204                   // vpand         %ymm12,%ymm9,%ymm9
  .byte  196,193,53,114,209,1                // vpsrld        $0x1,%ymm9,%ymm9
  .byte  196,65,61,219,196                   // vpand         %ymm12,%ymm8,%ymm8
  .byte  196,193,61,114,208,2                // vpsrld        $0x2,%ymm8,%ymm8
  .byte  196,65,45,235,192                   // vpor          %ymm8,%ymm10,%ymm8
  .byte  196,65,61,235,195                   // vpor          %ymm11,%ymm8,%ymm8
  .byte  196,65,61,235,193                   // vpor          %ymm9,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,98,125,24,13,103,160,3,0        // vbroadcastss  0x3a067(%rip),%ymm9        # 3a228 <_sk_srcover_bgra_8888_sse2_lowp+0x2c0>
  .byte  98,114,61,56,168,13,97,160,3,0      // vfmadd213ps   0x3a061(%rip){1to8},%ymm8,%ymm9        # 3a22c <_sk_srcover_bgra_8888_sse2_lowp+0x2c4>
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  196,65,52,89,192                    // vmulps        %ymm8,%ymm9,%ymm8
  .byte  197,188,88,192                      // vaddps        %ymm0,%ymm8,%ymm0
  .byte  197,188,88,201                      // vaddps        %ymm1,%ymm8,%ymm1
  .byte  197,188,88,210                      // vaddps        %ymm2,%ymm8,%ymm2
  .byte  197,252,93,195                      // vminps        %ymm3,%ymm0,%ymm0
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,244,93,203                      // vminps        %ymm3,%ymm1,%ymm1
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,236,93,211                      // vminps        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,210                      // vmaxps        %ymm2,%ymm8,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_uniform_color_skx
.globl _sk_uniform_color_skx
FUNCTION(_sk_uniform_color_skx)
_sk_uniform_color_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,0                    // vbroadcastss  (%rax),%ymm0
  .byte  196,226,125,24,72,4                 // vbroadcastss  0x4(%rax),%ymm1
  .byte  196,226,125,24,80,8                 // vbroadcastss  0x8(%rax),%ymm2
  .byte  196,226,125,24,88,12                // vbroadcastss  0xc(%rax),%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_black_color_skx
.globl _sk_black_color_skx
FUNCTION(_sk_black_color_skx)
_sk_black_color_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,238,159,3,0       // vbroadcastss  0x39fee(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_white_color_skx
.globl _sk_white_color_skx
FUNCTION(_sk_white_color_skx)
_sk_white_color_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,5,213,159,3,0        // vbroadcastss  0x39fd5(%rip),%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  197,252,40,216                      // vmovaps       %ymm0,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_rgba_skx
.globl _sk_load_rgba_skx
FUNCTION(_sk_load_rgba_skx)
_sk_load_rgba_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,0                        // vmovups       (%rax),%ymm0
  .byte  197,252,16,72,32                    // vmovups       0x20(%rax),%ymm1
  .byte  197,252,16,80,64                    // vmovups       0x40(%rax),%ymm2
  .byte  197,252,16,88,96                    // vmovups       0x60(%rax),%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_rgba_skx
.globl _sk_store_rgba_skx
FUNCTION(_sk_store_rgba_skx)
_sk_store_rgba_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,17,0                        // vmovups       %ymm0,(%rax)
  .byte  197,252,17,72,32                    // vmovups       %ymm1,0x20(%rax)
  .byte  197,252,17,80,64                    // vmovups       %ymm2,0x40(%rax)
  .byte  197,252,17,88,96                    // vmovups       %ymm3,0x60(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clear_skx
.globl _sk_clear_skx
FUNCTION(_sk_clear_skx)
_sk_clear_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcatop_skx
.globl _sk_srcatop_skx
FUNCTION(_sk_srcatop_skx)
_sk_srcatop_skx:
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  196,98,125,24,5,116,159,3,0         // vbroadcastss  0x39f74(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,226,61,184,196                  // vfmadd231ps   %ymm4,%ymm8,%ymm0
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  196,226,61,184,205                  // vfmadd231ps   %ymm5,%ymm8,%ymm1
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  196,226,61,184,214                  // vfmadd231ps   %ymm6,%ymm8,%ymm2
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  196,194,69,168,216                  // vfmadd213ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstatop_skx
.globl _sk_dstatop_skx
FUNCTION(_sk_dstatop_skx)
_sk_dstatop_skx:
  .byte  196,98,125,24,5,67,159,3,0          // vbroadcastss  0x39f43(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,199                       // vsubps        %ymm7,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  196,226,101,184,196                 // vfmadd231ps   %ymm4,%ymm3,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  196,226,101,184,205                 // vfmadd231ps   %ymm5,%ymm3,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  196,226,101,184,214                 // vfmadd231ps   %ymm6,%ymm3,%ymm2
  .byte  197,60,89,195                       // vmulps        %ymm3,%ymm8,%ymm8
  .byte  196,194,69,168,216                  // vfmadd213ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcin_skx
.globl _sk_srcin_skx
FUNCTION(_sk_srcin_skx)
_sk_srcin_skx:
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstin_skx
.globl _sk_dstin_skx
FUNCTION(_sk_dstin_skx)
_sk_dstin_skx:
  .byte  197,228,89,196                      // vmulps        %ymm4,%ymm3,%ymm0
  .byte  197,228,89,205                      // vmulps        %ymm5,%ymm3,%ymm1
  .byte  197,228,89,214                      // vmulps        %ymm6,%ymm3,%ymm2
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcout_skx
.globl _sk_srcout_skx
FUNCTION(_sk_srcout_skx)
_sk_srcout_skx:
  .byte  196,98,125,24,5,230,158,3,0         // vbroadcastss  0x39ee6(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,199                       // vsubps        %ymm7,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstout_skx
.globl _sk_dstout_skx
FUNCTION(_sk_dstout_skx)
_sk_dstout_skx:
  .byte  196,226,125,24,5,197,158,3,0        // vbroadcastss  0x39ec5(%rip),%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,92,219                      // vsubps        %ymm3,%ymm0,%ymm3
  .byte  197,228,89,196                      // vmulps        %ymm4,%ymm3,%ymm0
  .byte  197,228,89,205                      // vmulps        %ymm5,%ymm3,%ymm1
  .byte  197,228,89,214                      // vmulps        %ymm6,%ymm3,%ymm2
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_skx
.globl _sk_srcover_skx
FUNCTION(_sk_srcover_skx)
_sk_srcover_skx:
  .byte  196,98,125,24,5,164,158,3,0         // vbroadcastss  0x39ea4(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,194,93,184,192                  // vfmadd231ps   %ymm8,%ymm4,%ymm0
  .byte  196,194,85,184,200                  // vfmadd231ps   %ymm8,%ymm5,%ymm1
  .byte  196,194,77,184,208                  // vfmadd231ps   %ymm8,%ymm6,%ymm2
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstover_skx
.globl _sk_dstover_skx
FUNCTION(_sk_dstover_skx)
_sk_dstover_skx:
  .byte  196,98,125,24,5,127,158,3,0         // vbroadcastss  0x39e7f(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,199                       // vsubps        %ymm7,%ymm8,%ymm8
  .byte  196,226,61,168,196                  // vfmadd213ps   %ymm4,%ymm8,%ymm0
  .byte  196,226,61,168,205                  // vfmadd213ps   %ymm5,%ymm8,%ymm1
  .byte  196,226,61,168,214                  // vfmadd213ps   %ymm6,%ymm8,%ymm2
  .byte  196,226,61,168,223                  // vfmadd213ps   %ymm7,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_modulate_skx
.globl _sk_modulate_skx
FUNCTION(_sk_modulate_skx)
_sk_modulate_skx:
  .byte  197,252,89,196                      // vmulps        %ymm4,%ymm0,%ymm0
  .byte  197,244,89,205                      // vmulps        %ymm5,%ymm1,%ymm1
  .byte  197,236,89,214                      // vmulps        %ymm6,%ymm2,%ymm2
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_multiply_skx
.globl _sk_multiply_skx
FUNCTION(_sk_multiply_skx)
_sk_multiply_skx:
  .byte  196,98,125,24,5,70,158,3,0          // vbroadcastss  0x39e46(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,207                       // vsubps        %ymm7,%ymm8,%ymm9
  .byte  197,52,89,208                       // vmulps        %ymm0,%ymm9,%ymm10
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,98,61,184,212                   // vfmadd231ps   %ymm4,%ymm8,%ymm10
  .byte  196,194,93,168,194                  // vfmadd213ps   %ymm10,%ymm4,%ymm0
  .byte  197,52,89,209                       // vmulps        %ymm1,%ymm9,%ymm10
  .byte  196,98,61,184,213                   // vfmadd231ps   %ymm5,%ymm8,%ymm10
  .byte  196,194,85,168,202                  // vfmadd213ps   %ymm10,%ymm5,%ymm1
  .byte  197,52,89,210                       // vmulps        %ymm2,%ymm9,%ymm10
  .byte  196,98,61,184,214                   // vfmadd231ps   %ymm6,%ymm8,%ymm10
  .byte  196,194,77,168,210                  // vfmadd213ps   %ymm10,%ymm6,%ymm2
  .byte  197,52,89,203                       // vmulps        %ymm3,%ymm9,%ymm9
  .byte  196,66,69,168,193                   // vfmadd213ps   %ymm9,%ymm7,%ymm8
  .byte  196,194,69,168,216                  // vfmadd213ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_plus__skx
.globl _sk_plus__skx
FUNCTION(_sk_plus__skx)
_sk_plus__skx:
  .byte  197,252,88,196                      // vaddps        %ymm4,%ymm0,%ymm0
  .byte  196,98,125,24,5,245,157,3,0         // vbroadcastss  0x39df5(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  197,244,88,205                      // vaddps        %ymm5,%ymm1,%ymm1
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  197,236,88,214                      // vaddps        %ymm6,%ymm2,%ymm2
  .byte  196,193,108,93,208                  // vminps        %ymm8,%ymm2,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_screen_skx
.globl _sk_screen_skx
FUNCTION(_sk_screen_skx)
_sk_screen_skx:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  196,194,93,172,192                  // vfnmadd213ps  %ymm8,%ymm4,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  196,194,85,172,200                  // vfnmadd213ps  %ymm8,%ymm5,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  196,194,77,172,208                  // vfnmadd213ps  %ymm8,%ymm6,%ymm2
  .byte  197,100,88,199                      // vaddps        %ymm7,%ymm3,%ymm8
  .byte  196,194,69,172,216                  // vfnmadd213ps  %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xor__skx
.globl _sk_xor__skx
FUNCTION(_sk_xor__skx)
_sk_xor__skx:
  .byte  196,98,125,24,5,160,157,3,0         // vbroadcastss  0x39da0(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,207                       // vsubps        %ymm7,%ymm8,%ymm9
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,226,61,184,196                  // vfmadd231ps   %ymm4,%ymm8,%ymm0
  .byte  197,180,89,201                      // vmulps        %ymm1,%ymm9,%ymm1
  .byte  196,226,61,184,205                  // vfmadd231ps   %ymm5,%ymm8,%ymm1
  .byte  197,180,89,210                      // vmulps        %ymm2,%ymm9,%ymm2
  .byte  196,226,61,184,214                  // vfmadd231ps   %ymm6,%ymm8,%ymm2
  .byte  197,180,89,219                      // vmulps        %ymm3,%ymm9,%ymm3
  .byte  196,98,69,168,195                   // vfmadd213ps   %ymm3,%ymm7,%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,195                      // vmovaps       %ymm8,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_darken_skx
.globl _sk_darken_skx
FUNCTION(_sk_darken_skx)
_sk_darken_skx:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,100,89,204                      // vmulps        %ymm4,%ymm3,%ymm9
  .byte  196,193,124,95,193                  // vmaxps        %ymm9,%ymm0,%ymm0
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  197,100,89,205                      // vmulps        %ymm5,%ymm3,%ymm9
  .byte  196,193,116,95,201                  // vmaxps        %ymm9,%ymm1,%ymm1
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  197,100,89,206                      // vmulps        %ymm6,%ymm3,%ymm9
  .byte  196,193,108,95,209                  // vmaxps        %ymm9,%ymm2,%ymm2
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,36,157,3,0          // vbroadcastss  0x39d24(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lighten_skx
.globl _sk_lighten_skx
FUNCTION(_sk_lighten_skx)
_sk_lighten_skx:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,100,89,204                      // vmulps        %ymm4,%ymm3,%ymm9
  .byte  196,193,124,93,193                  // vminps        %ymm9,%ymm0,%ymm0
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  197,100,89,205                      // vmulps        %ymm5,%ymm3,%ymm9
  .byte  196,193,116,93,201                  // vminps        %ymm9,%ymm1,%ymm1
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  197,100,89,206                      // vmulps        %ymm6,%ymm3,%ymm9
  .byte  196,193,108,93,209                  // vminps        %ymm9,%ymm2,%ymm2
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,207,156,3,0         // vbroadcastss  0x39ccf(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_difference_skx
.globl _sk_difference_skx
FUNCTION(_sk_difference_skx)
_sk_difference_skx:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,100,89,204                      // vmulps        %ymm4,%ymm3,%ymm9
  .byte  196,193,124,93,193                  // vminps        %ymm9,%ymm0,%ymm0
  .byte  197,252,88,192                      // vaddps        %ymm0,%ymm0,%ymm0
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  197,100,89,205                      // vmulps        %ymm5,%ymm3,%ymm9
  .byte  196,193,116,93,201                  // vminps        %ymm9,%ymm1,%ymm1
  .byte  197,244,88,201                      // vaddps        %ymm1,%ymm1,%ymm1
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  197,100,89,206                      // vmulps        %ymm6,%ymm3,%ymm9
  .byte  196,193,108,93,209                  // vminps        %ymm9,%ymm2,%ymm2
  .byte  197,236,88,210                      // vaddps        %ymm2,%ymm2,%ymm2
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,110,156,3,0         // vbroadcastss  0x39c6e(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_exclusion_skx
.globl _sk_exclusion_skx
FUNCTION(_sk_exclusion_skx)
_sk_exclusion_skx:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  197,252,89,196                      // vmulps        %ymm4,%ymm0,%ymm0
  .byte  197,252,88,192                      // vaddps        %ymm0,%ymm0,%ymm0
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  197,244,89,205                      // vmulps        %ymm5,%ymm1,%ymm1
  .byte  197,244,88,201                      // vaddps        %ymm1,%ymm1,%ymm1
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  197,236,89,214                      // vmulps        %ymm6,%ymm2,%ymm2
  .byte  197,236,88,210                      // vaddps        %ymm2,%ymm2,%ymm2
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,40,156,3,0          // vbroadcastss  0x39c28(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_colorburn_skx
.globl _sk_colorburn_skx
FUNCTION(_sk_colorburn_skx)
_sk_colorburn_skx:
  .byte  98,241,92,40,194,199,0              // vcmpeqps      %ymm7,%ymm4,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  196,98,125,24,13,5,156,3,0          // vbroadcastss  0x39c05(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,52,92,215                       // vsubps        %ymm7,%ymm9,%ymm10
  .byte  197,44,89,216                       // vmulps        %ymm0,%ymm10,%ymm11
  .byte  197,36,88,228                       // vaddps        %ymm4,%ymm11,%ymm12
  .byte  196,65,20,87,237                    // vxorps        %ymm13,%ymm13,%ymm13
  .byte  98,209,124,40,194,197,0             // vcmpeqps      %ymm13,%ymm0,%k0
  .byte  98,114,126,40,56,240                // vpmovm2d      %k0,%ymm14
  .byte  197,52,92,203                       // vsubps        %ymm3,%ymm9,%ymm9
  .byte  197,52,89,252                       // vmulps        %ymm4,%ymm9,%ymm15
  .byte  98,225,68,40,92,196                 // vsubps        %ymm4,%ymm7,%ymm16
  .byte  98,225,124,32,89,195                // vmulps        %ymm3,%ymm16,%ymm16
  .byte  98,242,125,40,76,192                // vrcp14ps      %ymm0,%ymm0
  .byte  98,241,124,32,89,192                // vmulps        %ymm0,%ymm16,%ymm0
  .byte  197,196,93,192                      // vminps        %ymm0,%ymm7,%ymm0
  .byte  197,196,92,192                      // vsubps        %ymm0,%ymm7,%ymm0
  .byte  196,194,101,168,195                 // vfmadd213ps   %ymm11,%ymm3,%ymm0
  .byte  197,132,88,192                      // vaddps        %ymm0,%ymm15,%ymm0
  .byte  196,195,125,74,199,224              // vblendvps     %ymm14,%ymm15,%ymm0,%ymm0
  .byte  196,195,125,74,196,128              // vblendvps     %ymm8,%ymm12,%ymm0,%ymm0
  .byte  98,241,84,40,194,199,0              // vcmpeqps      %ymm7,%ymm5,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  197,44,89,217                       // vmulps        %ymm1,%ymm10,%ymm11
  .byte  197,36,88,229                       // vaddps        %ymm5,%ymm11,%ymm12
  .byte  98,209,116,40,194,197,0             // vcmpeqps      %ymm13,%ymm1,%k0
  .byte  98,114,126,40,56,240                // vpmovm2d      %k0,%ymm14
  .byte  197,52,89,253                       // vmulps        %ymm5,%ymm9,%ymm15
  .byte  98,225,68,40,92,197                 // vsubps        %ymm5,%ymm7,%ymm16
  .byte  98,225,124,32,89,195                // vmulps        %ymm3,%ymm16,%ymm16
  .byte  98,242,125,40,76,201                // vrcp14ps      %ymm1,%ymm1
  .byte  98,241,124,32,89,201                // vmulps        %ymm1,%ymm16,%ymm1
  .byte  197,196,93,201                      // vminps        %ymm1,%ymm7,%ymm1
  .byte  197,196,92,201                      // vsubps        %ymm1,%ymm7,%ymm1
  .byte  196,194,101,168,203                 // vfmadd213ps   %ymm11,%ymm3,%ymm1
  .byte  197,132,88,201                      // vaddps        %ymm1,%ymm15,%ymm1
  .byte  196,195,117,74,207,224              // vblendvps     %ymm14,%ymm15,%ymm1,%ymm1
  .byte  196,195,117,74,204,128              // vblendvps     %ymm8,%ymm12,%ymm1,%ymm1
  .byte  98,241,76,40,194,199,0              // vcmpeqps      %ymm7,%ymm6,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  197,44,89,210                       // vmulps        %ymm2,%ymm10,%ymm10
  .byte  197,44,88,222                       // vaddps        %ymm6,%ymm10,%ymm11
  .byte  98,209,108,40,194,197,0             // vcmpeqps      %ymm13,%ymm2,%k0
  .byte  98,114,126,40,56,224                // vpmovm2d      %k0,%ymm12
  .byte  197,52,89,238                       // vmulps        %ymm6,%ymm9,%ymm13
  .byte  197,68,92,246                       // vsubps        %ymm6,%ymm7,%ymm14
  .byte  197,12,89,243                       // vmulps        %ymm3,%ymm14,%ymm14
  .byte  98,242,125,40,76,210                // vrcp14ps      %ymm2,%ymm2
  .byte  197,140,89,210                      // vmulps        %ymm2,%ymm14,%ymm2
  .byte  197,196,93,210                      // vminps        %ymm2,%ymm7,%ymm2
  .byte  197,196,92,210                      // vsubps        %ymm2,%ymm7,%ymm2
  .byte  196,194,101,168,210                 // vfmadd213ps   %ymm10,%ymm3,%ymm2
  .byte  197,148,88,210                      // vaddps        %ymm2,%ymm13,%ymm2
  .byte  196,195,109,74,213,192              // vblendvps     %ymm12,%ymm13,%ymm2,%ymm2
  .byte  196,195,109,74,211,128              // vblendvps     %ymm8,%ymm11,%ymm2,%ymm2
  .byte  196,194,69,184,217                  // vfmadd231ps   %ymm9,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_colordodge_skx
.globl _sk_colordodge_skx
FUNCTION(_sk_colordodge_skx)
_sk_colordodge_skx:
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  98,209,92,40,194,192,0              // vcmpeqps      %ymm8,%ymm4,%k0
  .byte  98,114,126,40,56,200                // vpmovm2d      %k0,%ymm9
  .byte  196,98,125,24,21,214,154,3,0        // vbroadcastss  0x39ad6(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,44,92,223                       // vsubps        %ymm7,%ymm10,%ymm11
  .byte  197,36,89,224                       // vmulps        %ymm0,%ymm11,%ymm12
  .byte  98,241,124,40,194,195,0             // vcmpeqps      %ymm3,%ymm0,%k0
  .byte  98,114,126,40,56,232                // vpmovm2d      %k0,%ymm13
  .byte  197,44,92,211                       // vsubps        %ymm3,%ymm10,%ymm10
  .byte  197,44,89,244                       // vmulps        %ymm4,%ymm10,%ymm14
  .byte  197,12,88,248                       // vaddps        %ymm0,%ymm14,%ymm15
  .byte  98,225,100,40,89,196                // vmulps        %ymm4,%ymm3,%ymm16
  .byte  197,228,92,192                      // vsubps        %ymm0,%ymm3,%ymm0
  .byte  98,242,125,40,76,192                // vrcp14ps      %ymm0,%ymm0
  .byte  98,241,124,32,89,192                // vmulps        %ymm0,%ymm16,%ymm0
  .byte  197,196,93,192                      // vminps        %ymm0,%ymm7,%ymm0
  .byte  196,194,101,168,196                 // vfmadd213ps   %ymm12,%ymm3,%ymm0
  .byte  197,140,88,192                      // vaddps        %ymm0,%ymm14,%ymm0
  .byte  196,195,125,74,199,208              // vblendvps     %ymm13,%ymm15,%ymm0,%ymm0
  .byte  196,195,125,74,196,144              // vblendvps     %ymm9,%ymm12,%ymm0,%ymm0
  .byte  98,209,84,40,194,192,0              // vcmpeqps      %ymm8,%ymm5,%k0
  .byte  98,114,126,40,56,200                // vpmovm2d      %k0,%ymm9
  .byte  197,36,89,225                       // vmulps        %ymm1,%ymm11,%ymm12
  .byte  98,241,116,40,194,195,0             // vcmpeqps      %ymm3,%ymm1,%k0
  .byte  98,114,126,40,56,232                // vpmovm2d      %k0,%ymm13
  .byte  197,44,89,245                       // vmulps        %ymm5,%ymm10,%ymm14
  .byte  197,12,88,249                       // vaddps        %ymm1,%ymm14,%ymm15
  .byte  98,225,100,40,89,197                // vmulps        %ymm5,%ymm3,%ymm16
  .byte  197,228,92,201                      // vsubps        %ymm1,%ymm3,%ymm1
  .byte  98,242,125,40,76,201                // vrcp14ps      %ymm1,%ymm1
  .byte  98,241,124,32,89,201                // vmulps        %ymm1,%ymm16,%ymm1
  .byte  197,196,93,201                      // vminps        %ymm1,%ymm7,%ymm1
  .byte  196,194,101,168,204                 // vfmadd213ps   %ymm12,%ymm3,%ymm1
  .byte  197,140,88,201                      // vaddps        %ymm1,%ymm14,%ymm1
  .byte  196,195,117,74,207,208              // vblendvps     %ymm13,%ymm15,%ymm1,%ymm1
  .byte  196,195,117,74,204,144              // vblendvps     %ymm9,%ymm12,%ymm1,%ymm1
  .byte  98,209,76,40,194,192,0              // vcmpeqps      %ymm8,%ymm6,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  197,36,89,202                       // vmulps        %ymm2,%ymm11,%ymm9
  .byte  98,241,108,40,194,195,0             // vcmpeqps      %ymm3,%ymm2,%k0
  .byte  98,114,126,40,56,216                // vpmovm2d      %k0,%ymm11
  .byte  197,44,89,230                       // vmulps        %ymm6,%ymm10,%ymm12
  .byte  197,28,88,234                       // vaddps        %ymm2,%ymm12,%ymm13
  .byte  197,100,89,246                      // vmulps        %ymm6,%ymm3,%ymm14
  .byte  197,228,92,210                      // vsubps        %ymm2,%ymm3,%ymm2
  .byte  98,242,125,40,76,210                // vrcp14ps      %ymm2,%ymm2
  .byte  197,140,89,210                      // vmulps        %ymm2,%ymm14,%ymm2
  .byte  197,196,93,210                      // vminps        %ymm2,%ymm7,%ymm2
  .byte  196,194,101,168,209                 // vfmadd213ps   %ymm9,%ymm3,%ymm2
  .byte  197,156,88,210                      // vaddps        %ymm2,%ymm12,%ymm2
  .byte  196,195,109,74,213,176              // vblendvps     %ymm11,%ymm13,%ymm2,%ymm2
  .byte  196,195,109,74,209,128              // vblendvps     %ymm8,%ymm9,%ymm2,%ymm2
  .byte  196,194,69,184,218                  // vfmadd231ps   %ymm10,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hardlight_skx
.globl _sk_hardlight_skx
FUNCTION(_sk_hardlight_skx)
_sk_hardlight_skx:
  .byte  196,98,125,24,5,206,153,3,0         // vbroadcastss  0x399ce(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,207                       // vsubps        %ymm7,%ymm8,%ymm9
  .byte  197,52,89,208                       // vmulps        %ymm0,%ymm9,%ymm10
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,98,61,184,212                   // vfmadd231ps   %ymm4,%ymm8,%ymm10
  .byte  197,124,88,216                      // vaddps        %ymm0,%ymm0,%ymm11
  .byte  98,241,36,40,194,195,2              // vcmpleps      %ymm3,%ymm11,%k0
  .byte  98,114,126,40,56,216                // vpmovm2d      %k0,%ymm11
  .byte  197,124,89,228                      // vmulps        %ymm4,%ymm0,%ymm12
  .byte  196,65,28,88,228                    // vaddps        %ymm12,%ymm12,%ymm12
  .byte  197,100,89,239                      // vmulps        %ymm7,%ymm3,%ymm13
  .byte  197,68,92,244                       // vsubps        %ymm4,%ymm7,%ymm14
  .byte  197,228,92,192                      // vsubps        %ymm0,%ymm3,%ymm0
  .byte  196,193,124,89,198                  // vmulps        %ymm14,%ymm0,%ymm0
  .byte  197,252,88,192                      // vaddps        %ymm0,%ymm0,%ymm0
  .byte  197,148,92,192                      // vsubps        %ymm0,%ymm13,%ymm0
  .byte  196,195,125,74,196,176              // vblendvps     %ymm11,%ymm12,%ymm0,%ymm0
  .byte  197,172,88,192                      // vaddps        %ymm0,%ymm10,%ymm0
  .byte  197,52,89,209                       // vmulps        %ymm1,%ymm9,%ymm10
  .byte  196,98,61,184,213                   // vfmadd231ps   %ymm5,%ymm8,%ymm10
  .byte  197,116,88,217                      // vaddps        %ymm1,%ymm1,%ymm11
  .byte  98,241,36,40,194,195,2              // vcmpleps      %ymm3,%ymm11,%k0
  .byte  98,114,126,40,56,216                // vpmovm2d      %k0,%ymm11
  .byte  197,116,89,229                      // vmulps        %ymm5,%ymm1,%ymm12
  .byte  196,65,28,88,228                    // vaddps        %ymm12,%ymm12,%ymm12
  .byte  197,68,92,245                       // vsubps        %ymm5,%ymm7,%ymm14
  .byte  197,228,92,201                      // vsubps        %ymm1,%ymm3,%ymm1
  .byte  196,193,116,89,206                  // vmulps        %ymm14,%ymm1,%ymm1
  .byte  197,244,88,201                      // vaddps        %ymm1,%ymm1,%ymm1
  .byte  197,148,92,201                      // vsubps        %ymm1,%ymm13,%ymm1
  .byte  196,195,117,74,204,176              // vblendvps     %ymm11,%ymm12,%ymm1,%ymm1
  .byte  197,172,88,201                      // vaddps        %ymm1,%ymm10,%ymm1
  .byte  197,52,89,202                       // vmulps        %ymm2,%ymm9,%ymm9
  .byte  196,98,61,184,206                   // vfmadd231ps   %ymm6,%ymm8,%ymm9
  .byte  197,108,88,210                      // vaddps        %ymm2,%ymm2,%ymm10
  .byte  98,241,44,40,194,195,2              // vcmpleps      %ymm3,%ymm10,%k0
  .byte  98,114,126,40,56,208                // vpmovm2d      %k0,%ymm10
  .byte  197,108,89,222                      // vmulps        %ymm6,%ymm2,%ymm11
  .byte  196,65,36,88,219                    // vaddps        %ymm11,%ymm11,%ymm11
  .byte  197,68,92,230                       // vsubps        %ymm6,%ymm7,%ymm12
  .byte  197,228,92,210                      // vsubps        %ymm2,%ymm3,%ymm2
  .byte  196,193,108,89,212                  // vmulps        %ymm12,%ymm2,%ymm2
  .byte  197,236,88,210                      // vaddps        %ymm2,%ymm2,%ymm2
  .byte  197,148,92,210                      // vsubps        %ymm2,%ymm13,%ymm2
  .byte  196,195,109,74,211,160              // vblendvps     %ymm10,%ymm11,%ymm2,%ymm2
  .byte  197,180,88,210                      // vaddps        %ymm2,%ymm9,%ymm2
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_overlay_skx
.globl _sk_overlay_skx
FUNCTION(_sk_overlay_skx)
_sk_overlay_skx:
  .byte  196,98,125,24,5,234,152,3,0         // vbroadcastss  0x398ea(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,207                       // vsubps        %ymm7,%ymm8,%ymm9
  .byte  197,52,89,208                       // vmulps        %ymm0,%ymm9,%ymm10
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,98,61,184,212                   // vfmadd231ps   %ymm4,%ymm8,%ymm10
  .byte  197,92,88,220                       // vaddps        %ymm4,%ymm4,%ymm11
  .byte  98,241,36,40,194,199,2              // vcmpleps      %ymm7,%ymm11,%k0
  .byte  98,114,126,40,56,216                // vpmovm2d      %k0,%ymm11
  .byte  197,124,89,228                      // vmulps        %ymm4,%ymm0,%ymm12
  .byte  196,65,28,88,228                    // vaddps        %ymm12,%ymm12,%ymm12
  .byte  197,100,89,239                      // vmulps        %ymm7,%ymm3,%ymm13
  .byte  197,68,92,244                       // vsubps        %ymm4,%ymm7,%ymm14
  .byte  197,228,92,192                      // vsubps        %ymm0,%ymm3,%ymm0
  .byte  196,193,124,89,198                  // vmulps        %ymm14,%ymm0,%ymm0
  .byte  197,252,88,192                      // vaddps        %ymm0,%ymm0,%ymm0
  .byte  197,148,92,192                      // vsubps        %ymm0,%ymm13,%ymm0
  .byte  196,195,125,74,196,176              // vblendvps     %ymm11,%ymm12,%ymm0,%ymm0
  .byte  197,172,88,192                      // vaddps        %ymm0,%ymm10,%ymm0
  .byte  197,52,89,209                       // vmulps        %ymm1,%ymm9,%ymm10
  .byte  196,98,61,184,213                   // vfmadd231ps   %ymm5,%ymm8,%ymm10
  .byte  197,84,88,221                       // vaddps        %ymm5,%ymm5,%ymm11
  .byte  98,241,36,40,194,199,2              // vcmpleps      %ymm7,%ymm11,%k0
  .byte  98,114,126,40,56,216                // vpmovm2d      %k0,%ymm11
  .byte  197,116,89,229                      // vmulps        %ymm5,%ymm1,%ymm12
  .byte  196,65,28,88,228                    // vaddps        %ymm12,%ymm12,%ymm12
  .byte  197,68,92,245                       // vsubps        %ymm5,%ymm7,%ymm14
  .byte  197,228,92,201                      // vsubps        %ymm1,%ymm3,%ymm1
  .byte  196,193,116,89,206                  // vmulps        %ymm14,%ymm1,%ymm1
  .byte  197,244,88,201                      // vaddps        %ymm1,%ymm1,%ymm1
  .byte  197,148,92,201                      // vsubps        %ymm1,%ymm13,%ymm1
  .byte  196,195,117,74,204,176              // vblendvps     %ymm11,%ymm12,%ymm1,%ymm1
  .byte  197,172,88,201                      // vaddps        %ymm1,%ymm10,%ymm1
  .byte  197,52,89,202                       // vmulps        %ymm2,%ymm9,%ymm9
  .byte  196,98,61,184,206                   // vfmadd231ps   %ymm6,%ymm8,%ymm9
  .byte  197,76,88,214                       // vaddps        %ymm6,%ymm6,%ymm10
  .byte  98,241,44,40,194,199,2              // vcmpleps      %ymm7,%ymm10,%k0
  .byte  98,114,126,40,56,208                // vpmovm2d      %k0,%ymm10
  .byte  197,108,89,222                      // vmulps        %ymm6,%ymm2,%ymm11
  .byte  196,65,36,88,219                    // vaddps        %ymm11,%ymm11,%ymm11
  .byte  197,68,92,230                       // vsubps        %ymm6,%ymm7,%ymm12
  .byte  197,228,92,210                      // vsubps        %ymm2,%ymm3,%ymm2
  .byte  196,193,108,89,212                  // vmulps        %ymm12,%ymm2,%ymm2
  .byte  197,236,88,210                      // vaddps        %ymm2,%ymm2,%ymm2
  .byte  197,148,92,210                      // vsubps        %ymm2,%ymm13,%ymm2
  .byte  196,195,109,74,211,160              // vblendvps     %ymm10,%ymm11,%ymm2,%ymm2
  .byte  197,180,88,210                      // vaddps        %ymm2,%ymm9,%ymm2
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_softlight_skx
.globl _sk_softlight_skx
FUNCTION(_sk_softlight_skx)
_sk_softlight_skx:
  .byte  98,225,124,40,40,194                // vmovaps       %ymm2,%ymm16
  .byte  98,225,124,40,40,225                // vmovaps       %ymm1,%ymm20
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  98,241,108,40,194,199,1             // vcmpltps      %ymm7,%ymm2,%k0
  .byte  98,242,126,40,56,200                // vpmovm2d      %k0,%ymm1
  .byte  197,92,94,207                       // vdivps        %ymm7,%ymm4,%ymm9
  .byte  196,67,109,74,201,16                // vblendvps     %ymm1,%ymm9,%ymm2,%ymm9
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  197,124,88,248                      // vaddps        %ymm0,%ymm0,%ymm15
  .byte  196,65,52,88,217                    // vaddps        %ymm9,%ymm9,%ymm11
  .byte  196,65,36,88,235                    // vaddps        %ymm11,%ymm11,%ymm13
  .byte  197,4,92,243                        // vsubps        %ymm3,%ymm15,%ymm14
  .byte  196,98,125,24,29,200,151,3,0        // vbroadcastss  0x397c8(%rip),%ymm11        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,36,92,225                    // vsubps        %ymm9,%ymm11,%ymm12
  .byte  196,98,13,168,227                   // vfmadd213ps   %ymm3,%ymm14,%ymm12
  .byte  197,156,89,212                      // vmulps        %ymm4,%ymm12,%ymm2
  .byte  196,66,21,168,237                   // vfmadd213ps   %ymm13,%ymm13,%ymm13
  .byte  98,226,125,40,24,21,195,151,3,0     // vbroadcastss  0x397c3(%rip),%ymm18        # 3a230 <_sk_srcover_bgra_8888_sse2_lowp+0x2c8>
  .byte  98,161,52,40,88,202                 // vaddps        %ymm18,%ymm9,%ymm17
  .byte  98,81,116,32,89,229                 // vmulps        %ymm13,%ymm17,%ymm12
  .byte  98,226,125,40,24,29,177,151,3,0     // vbroadcastss  0x397b1(%rip),%ymm19        # 3a234 <_sk_srcover_bgra_8888_sse2_lowp+0x2cc>
  .byte  98,50,53,40,184,227                 // vfmadd231ps   %ymm19,%ymm9,%ymm12
  .byte  98,194,125,40,78,201                // vrsqrt14ps    %ymm9,%ymm17
  .byte  98,162,125,40,76,201                // vrcp14ps      %ymm17,%ymm17
  .byte  98,81,116,32,92,201                 // vsubps        %ymm9,%ymm17,%ymm9
  .byte  197,12,89,247                       // vmulps        %ymm7,%ymm14,%ymm14
  .byte  98,225,92,40,88,204                 // vaddps        %ymm4,%ymm4,%ymm17
  .byte  98,161,116,32,88,201                // vaddps        %ymm17,%ymm17,%ymm17
  .byte  98,241,116,32,194,199,2             // vcmpleps      %ymm7,%ymm17,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  196,67,53,74,196,128                // vblendvps     %ymm8,%ymm12,%ymm9,%ymm8
  .byte  196,65,12,89,192                    // vmulps        %ymm8,%ymm14,%ymm8
  .byte  196,98,101,184,196                  // vfmadd231ps   %ymm4,%ymm3,%ymm8
  .byte  197,36,92,247                       // vsubps        %ymm7,%ymm11,%ymm14
  .byte  197,140,89,192                      // vmulps        %ymm0,%ymm14,%ymm0
  .byte  197,36,92,203                       // vsubps        %ymm3,%ymm11,%ymm9
  .byte  196,226,53,184,196                  // vfmadd231ps   %ymm4,%ymm9,%ymm0
  .byte  98,241,4,40,194,195,2               // vcmpleps      %ymm3,%ymm15,%k0
  .byte  98,114,126,40,56,224                // vpmovm2d      %k0,%ymm12
  .byte  196,227,61,74,210,192               // vblendvps     %ymm12,%ymm2,%ymm8,%ymm2
  .byte  197,252,88,194                      // vaddps        %ymm2,%ymm0,%ymm0
  .byte  197,212,94,215                      // vdivps        %ymm7,%ymm5,%ymm2
  .byte  196,227,45,74,210,16                // vblendvps     %ymm1,%ymm2,%ymm10,%ymm2
  .byte  98,49,92,32,88,196                  // vaddps        %ymm20,%ymm20,%ymm8
  .byte  197,108,88,226                      // vaddps        %ymm2,%ymm2,%ymm12
  .byte  196,65,28,88,228                    // vaddps        %ymm12,%ymm12,%ymm12
  .byte  197,60,92,251                       // vsubps        %ymm3,%ymm8,%ymm15
  .byte  98,225,36,40,92,202                 // vsubps        %ymm2,%ymm11,%ymm17
  .byte  98,226,5,40,168,203                 // vfmadd213ps   %ymm3,%ymm15,%ymm17
  .byte  98,113,116,32,89,237                // vmulps        %ymm5,%ymm17,%ymm13
  .byte  196,66,29,168,228                   // vfmadd213ps   %ymm12,%ymm12,%ymm12
  .byte  98,161,108,40,88,202                // vaddps        %ymm18,%ymm2,%ymm17
  .byte  98,81,116,32,89,228                 // vmulps        %ymm12,%ymm17,%ymm12
  .byte  98,50,109,40,184,227                // vfmadd231ps   %ymm19,%ymm2,%ymm12
  .byte  98,226,125,40,78,202                // vrsqrt14ps    %ymm2,%ymm17
  .byte  98,162,125,40,76,201                // vrcp14ps      %ymm17,%ymm17
  .byte  98,241,116,32,92,210                // vsubps        %ymm2,%ymm17,%ymm2
  .byte  197,4,89,255                        // vmulps        %ymm7,%ymm15,%ymm15
  .byte  98,225,84,40,88,205                 // vaddps        %ymm5,%ymm5,%ymm17
  .byte  98,161,116,32,88,201                // vaddps        %ymm17,%ymm17,%ymm17
  .byte  98,241,116,32,194,199,2             // vcmpleps      %ymm7,%ymm17,%k0
  .byte  98,114,126,40,56,208                // vpmovm2d      %k0,%ymm10
  .byte  196,195,109,74,212,160              // vblendvps     %ymm10,%ymm12,%ymm2,%ymm2
  .byte  197,132,89,210                      // vmulps        %ymm2,%ymm15,%ymm2
  .byte  196,226,101,184,213                 // vfmadd231ps   %ymm5,%ymm3,%ymm2
  .byte  98,49,12,40,89,212                  // vmulps        %ymm20,%ymm14,%ymm10
  .byte  196,98,53,184,213                   // vfmadd231ps   %ymm5,%ymm9,%ymm10
  .byte  98,241,60,40,194,195,2              // vcmpleps      %ymm3,%ymm8,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  196,195,109,74,213,128              // vblendvps     %ymm8,%ymm13,%ymm2,%ymm2
  .byte  197,44,88,194                       // vaddps        %ymm2,%ymm10,%ymm8
  .byte  197,204,94,215                      // vdivps        %ymm7,%ymm6,%ymm2
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,227,45,74,202,16                // vblendvps     %ymm1,%ymm2,%ymm10,%ymm1
  .byte  98,177,124,32,88,208                // vaddps        %ymm16,%ymm16,%ymm2
  .byte  197,116,88,209                      // vaddps        %ymm1,%ymm1,%ymm10
  .byte  196,65,44,88,210                    // vaddps        %ymm10,%ymm10,%ymm10
  .byte  197,108,92,227                      // vsubps        %ymm3,%ymm2,%ymm12
  .byte  197,36,92,217                       // vsubps        %ymm1,%ymm11,%ymm11
  .byte  196,98,29,168,219                   // vfmadd213ps   %ymm3,%ymm12,%ymm11
  .byte  197,36,89,222                       // vmulps        %ymm6,%ymm11,%ymm11
  .byte  196,66,45,168,210                   // vfmadd213ps   %ymm10,%ymm10,%ymm10
  .byte  98,49,116,40,88,234                 // vaddps        %ymm18,%ymm1,%ymm13
  .byte  196,65,20,89,210                    // vmulps        %ymm10,%ymm13,%ymm10
  .byte  98,50,117,40,184,211                // vfmadd231ps   %ymm19,%ymm1,%ymm10
  .byte  98,114,125,40,78,233                // vrsqrt14ps    %ymm1,%ymm13
  .byte  98,82,125,40,76,237                 // vrcp14ps      %ymm13,%ymm13
  .byte  197,148,92,201                      // vsubps        %ymm1,%ymm13,%ymm1
  .byte  197,28,89,231                       // vmulps        %ymm7,%ymm12,%ymm12
  .byte  197,76,88,238                       // vaddps        %ymm6,%ymm6,%ymm13
  .byte  196,65,20,88,237                    // vaddps        %ymm13,%ymm13,%ymm13
  .byte  98,241,20,40,194,199,2              // vcmpleps      %ymm7,%ymm13,%k0
  .byte  98,114,126,40,56,232                // vpmovm2d      %k0,%ymm13
  .byte  196,195,117,74,202,208              // vblendvps     %ymm13,%ymm10,%ymm1,%ymm1
  .byte  197,156,89,201                      // vmulps        %ymm1,%ymm12,%ymm1
  .byte  196,226,101,184,206                 // vfmadd231ps   %ymm6,%ymm3,%ymm1
  .byte  98,49,12,40,89,208                  // vmulps        %ymm16,%ymm14,%ymm10
  .byte  196,98,53,184,214                   // vfmadd231ps   %ymm6,%ymm9,%ymm10
  .byte  98,241,108,40,194,195,2             // vcmpleps      %ymm3,%ymm2,%k0
  .byte  98,242,126,40,56,208                // vpmovm2d      %k0,%ymm2
  .byte  196,195,117,74,203,32               // vblendvps     %ymm2,%ymm11,%ymm1,%ymm1
  .byte  197,172,88,209                      // vaddps        %ymm1,%ymm10,%ymm2
  .byte  196,194,69,184,217                  // vfmadd231ps   %ymm9,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,193                      // vmovaps       %ymm8,%ymm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hue_skx
.globl _sk_hue_skx
FUNCTION(_sk_hue_skx)
_sk_hue_skx:
  .byte  98,225,124,40,40,210                // vmovaps       %ymm2,%ymm18
  .byte  98,225,124,40,40,225                // vmovaps       %ymm1,%ymm20
  .byte  197,124,89,203                      // vmulps        %ymm3,%ymm0,%ymm9
  .byte  98,113,92,32,89,211                 // vmulps        %ymm3,%ymm20,%ymm10
  .byte  98,113,108,32,89,219                // vmulps        %ymm3,%ymm18,%ymm11
  .byte  197,84,95,198                       // vmaxps        %ymm6,%ymm5,%ymm8
  .byte  196,65,92,95,192                    // vmaxps        %ymm8,%ymm4,%ymm8
  .byte  197,84,93,230                       // vminps        %ymm6,%ymm5,%ymm12
  .byte  196,65,92,93,228                    // vminps        %ymm12,%ymm4,%ymm12
  .byte  196,65,60,92,196                    // vsubps        %ymm12,%ymm8,%ymm8
  .byte  197,60,89,227                       // vmulps        %ymm3,%ymm8,%ymm12
  .byte  196,65,44,93,195                    // vminps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,93,232                    // vminps        %ymm8,%ymm9,%ymm13
  .byte  196,65,44,95,195                    // vmaxps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,95,192                    // vmaxps        %ymm8,%ymm9,%ymm8
  .byte  196,65,60,92,245                    // vsubps        %ymm13,%ymm8,%ymm14
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  98,241,12,40,194,193,0              // vcmpeqps      %ymm1,%ymm14,%k0
  .byte  98,114,126,40,56,248                // vpmovm2d      %k0,%ymm15
  .byte  196,65,52,92,205                    // vsubps        %ymm13,%ymm9,%ymm9
  .byte  196,65,28,89,201                    // vmulps        %ymm9,%ymm12,%ymm9
  .byte  196,65,52,94,206                    // vdivps        %ymm14,%ymm9,%ymm9
  .byte  196,99,53,74,201,240                // vblendvps     %ymm15,%ymm1,%ymm9,%ymm9
  .byte  196,65,44,92,213                    // vsubps        %ymm13,%ymm10,%ymm10
  .byte  196,65,28,89,210                    // vmulps        %ymm10,%ymm12,%ymm10
  .byte  196,65,44,94,214                    // vdivps        %ymm14,%ymm10,%ymm10
  .byte  196,99,45,74,209,240                // vblendvps     %ymm15,%ymm1,%ymm10,%ymm10
  .byte  196,65,36,92,221                    // vsubps        %ymm13,%ymm11,%ymm11
  .byte  196,65,28,89,219                    // vmulps        %ymm11,%ymm12,%ymm11
  .byte  196,65,36,94,222                    // vdivps        %ymm14,%ymm11,%ymm11
  .byte  196,99,37,74,225,240                // vblendvps     %ymm15,%ymm1,%ymm11,%ymm12
  .byte  196,98,125,24,45,76,149,3,0         // vbroadcastss  0x3954c(%rip),%ymm13        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,98,125,24,53,71,149,3,0         // vbroadcastss  0x39547(%rip),%ymm14        # 3a23c <_sk_srcover_bgra_8888_sse2_lowp+0x2d4>
  .byte  196,65,84,89,254                    // vmulps        %ymm14,%ymm5,%ymm15
  .byte  196,66,93,184,253                   // vfmadd231ps   %ymm13,%ymm4,%ymm15
  .byte  98,226,125,40,24,5,55,149,3,0       // vbroadcastss  0x39537(%rip),%ymm16        # 3a240 <_sk_srcover_bgra_8888_sse2_lowp+0x2d8>
  .byte  98,50,77,40,184,248                 // vfmadd231ps   %ymm16,%ymm6,%ymm15
  .byte  196,65,44,89,222                    // vmulps        %ymm14,%ymm10,%ymm11
  .byte  196,66,53,184,221                   // vfmadd231ps   %ymm13,%ymm9,%ymm11
  .byte  98,50,29,40,184,216                 // vfmadd231ps   %ymm16,%ymm12,%ymm11
  .byte  196,66,101,170,251                  // vfmsub213ps   %ymm11,%ymm3,%ymm15
  .byte  196,65,52,88,207                    // vaddps        %ymm15,%ymm9,%ymm9
  .byte  196,65,44,88,223                    // vaddps        %ymm15,%ymm10,%ymm11
  .byte  196,65,28,88,215                    // vaddps        %ymm15,%ymm12,%ymm10
  .byte  197,100,89,231                      // vmulps        %ymm7,%ymm3,%ymm12
  .byte  196,65,36,93,250                    // vminps        %ymm10,%ymm11,%ymm15
  .byte  196,65,52,93,255                    // vminps        %ymm15,%ymm9,%ymm15
  .byte  98,193,36,40,95,202                 // vmaxps        %ymm10,%ymm11,%ymm17
  .byte  98,161,52,40,95,201                 // vmaxps        %ymm17,%ymm9,%ymm17
  .byte  196,65,36,89,246                    // vmulps        %ymm14,%ymm11,%ymm14
  .byte  196,66,53,184,245                   // vfmadd231ps   %ymm13,%ymm9,%ymm14
  .byte  98,50,45,40,184,240                 // vfmadd231ps   %ymm16,%ymm10,%ymm14
  .byte  98,209,116,40,194,199,2             // vcmpleps      %ymm15,%ymm1,%k0
  .byte  98,114,126,40,56,232                // vpmovm2d      %k0,%ymm13
  .byte  98,193,52,40,92,198                 // vsubps        %ymm14,%ymm9,%ymm16
  .byte  98,161,12,40,89,192                 // vmulps        %ymm16,%ymm14,%ymm16
  .byte  196,65,12,92,255                    // vsubps        %ymm15,%ymm14,%ymm15
  .byte  98,193,124,32,94,199                // vdivps        %ymm15,%ymm16,%ymm16
  .byte  98,49,12,40,88,192                  // vaddps        %ymm16,%ymm14,%ymm8
  .byte  196,67,61,74,193,208                // vblendvps     %ymm13,%ymm9,%ymm8,%ymm8
  .byte  98,177,28,40,194,193,1              // vcmpltps      %ymm17,%ymm12,%k0
  .byte  98,114,126,40,56,200                // vpmovm2d      %k0,%ymm9
  .byte  98,193,60,40,92,198                 // vsubps        %ymm14,%ymm8,%ymm16
  .byte  98,193,28,40,92,222                 // vsubps        %ymm14,%ymm12,%ymm19
  .byte  98,161,100,32,89,192                // vmulps        %ymm16,%ymm19,%ymm16
  .byte  98,193,116,32,92,206                // vsubps        %ymm14,%ymm17,%ymm17
  .byte  98,161,124,32,94,193                // vdivps        %ymm17,%ymm16,%ymm16
  .byte  98,177,12,40,88,208                 // vaddps        %ymm16,%ymm14,%ymm2
  .byte  196,227,61,74,210,144               // vblendvps     %ymm9,%ymm2,%ymm8,%ymm2
  .byte  197,236,95,209                      // vmaxps        %ymm1,%ymm2,%ymm2
  .byte  196,65,36,92,198                    // vsubps        %ymm14,%ymm11,%ymm8
  .byte  196,65,12,89,192                    // vmulps        %ymm8,%ymm14,%ymm8
  .byte  196,65,60,94,199                    // vdivps        %ymm15,%ymm8,%ymm8
  .byte  196,65,12,88,192                    // vaddps        %ymm8,%ymm14,%ymm8
  .byte  196,67,61,74,195,208                // vblendvps     %ymm13,%ymm11,%ymm8,%ymm8
  .byte  196,65,60,92,222                    // vsubps        %ymm14,%ymm8,%ymm11
  .byte  98,81,100,32,89,219                 // vmulps        %ymm11,%ymm19,%ymm11
  .byte  98,49,36,40,94,217                  // vdivps        %ymm17,%ymm11,%ymm11
  .byte  196,65,12,88,219                    // vaddps        %ymm11,%ymm14,%ymm11
  .byte  196,67,61,74,195,144                // vblendvps     %ymm9,%ymm11,%ymm8,%ymm8
  .byte  197,60,95,193                       // vmaxps        %ymm1,%ymm8,%ymm8
  .byte  196,65,44,92,222                    // vsubps        %ymm14,%ymm10,%ymm11
  .byte  196,65,12,89,219                    // vmulps        %ymm11,%ymm14,%ymm11
  .byte  196,65,36,94,223                    // vdivps        %ymm15,%ymm11,%ymm11
  .byte  196,65,12,88,219                    // vaddps        %ymm11,%ymm14,%ymm11
  .byte  196,67,37,74,210,208                // vblendvps     %ymm13,%ymm10,%ymm11,%ymm10
  .byte  196,65,44,92,222                    // vsubps        %ymm14,%ymm10,%ymm11
  .byte  98,81,100,32,89,219                 // vmulps        %ymm11,%ymm19,%ymm11
  .byte  98,49,36,40,94,217                  // vdivps        %ymm17,%ymm11,%ymm11
  .byte  196,65,12,88,219                    // vaddps        %ymm11,%ymm14,%ymm11
  .byte  196,67,45,74,203,144                // vblendvps     %ymm9,%ymm11,%ymm10,%ymm9
  .byte  197,52,95,201                       // vmaxps        %ymm1,%ymm9,%ymm9
  .byte  196,226,125,24,13,211,147,3,0       // vbroadcastss  0x393d3(%rip),%ymm1        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,116,92,215                      // vsubps        %ymm7,%ymm1,%ymm10
  .byte  197,172,89,192                      // vmulps        %ymm0,%ymm10,%ymm0
  .byte  197,116,92,219                      // vsubps        %ymm3,%ymm1,%ymm11
  .byte  196,226,37,184,196                  // vfmadd231ps   %ymm4,%ymm11,%ymm0
  .byte  197,252,88,194                      // vaddps        %ymm2,%ymm0,%ymm0
  .byte  98,177,44,40,89,204                 // vmulps        %ymm20,%ymm10,%ymm1
  .byte  196,226,37,184,205                  // vfmadd231ps   %ymm5,%ymm11,%ymm1
  .byte  196,193,116,88,200                  // vaddps        %ymm8,%ymm1,%ymm1
  .byte  98,177,44,40,89,210                 // vmulps        %ymm18,%ymm10,%ymm2
  .byte  196,98,77,168,218                   // vfmadd213ps   %ymm2,%ymm6,%ymm11
  .byte  196,193,36,88,209                   // vaddps        %ymm9,%ymm11,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,92,220                  // vsubps        %ymm12,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_saturation_skx
.globl _sk_saturation_skx
FUNCTION(_sk_saturation_skx)
_sk_saturation_skx:
  .byte  98,225,124,40,40,210                // vmovaps       %ymm2,%ymm18
  .byte  98,225,124,40,40,225                // vmovaps       %ymm1,%ymm20
  .byte  197,100,89,204                      // vmulps        %ymm4,%ymm3,%ymm9
  .byte  197,100,89,213                      // vmulps        %ymm5,%ymm3,%ymm10
  .byte  197,100,89,222                      // vmulps        %ymm6,%ymm3,%ymm11
  .byte  98,49,92,32,95,194                  // vmaxps        %ymm18,%ymm20,%ymm8
  .byte  196,65,124,95,192                   // vmaxps        %ymm8,%ymm0,%ymm8
  .byte  98,49,92,32,93,226                  // vminps        %ymm18,%ymm20,%ymm12
  .byte  196,65,124,93,228                   // vminps        %ymm12,%ymm0,%ymm12
  .byte  196,65,60,92,196                    // vsubps        %ymm12,%ymm8,%ymm8
  .byte  197,60,89,231                       // vmulps        %ymm7,%ymm8,%ymm12
  .byte  196,65,44,93,195                    // vminps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,93,232                    // vminps        %ymm8,%ymm9,%ymm13
  .byte  196,65,44,95,195                    // vmaxps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,95,192                    // vmaxps        %ymm8,%ymm9,%ymm8
  .byte  196,65,60,92,245                    // vsubps        %ymm13,%ymm8,%ymm14
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  98,241,12,40,194,193,0              // vcmpeqps      %ymm1,%ymm14,%k0
  .byte  98,114,126,40,56,248                // vpmovm2d      %k0,%ymm15
  .byte  196,65,52,92,205                    // vsubps        %ymm13,%ymm9,%ymm9
  .byte  196,65,28,89,201                    // vmulps        %ymm9,%ymm12,%ymm9
  .byte  196,65,52,94,206                    // vdivps        %ymm14,%ymm9,%ymm9
  .byte  196,99,53,74,201,240                // vblendvps     %ymm15,%ymm1,%ymm9,%ymm9
  .byte  196,65,44,92,213                    // vsubps        %ymm13,%ymm10,%ymm10
  .byte  196,65,28,89,210                    // vmulps        %ymm10,%ymm12,%ymm10
  .byte  196,65,44,94,214                    // vdivps        %ymm14,%ymm10,%ymm10
  .byte  196,99,45,74,209,240                // vblendvps     %ymm15,%ymm1,%ymm10,%ymm10
  .byte  196,65,36,92,221                    // vsubps        %ymm13,%ymm11,%ymm11
  .byte  196,65,28,89,219                    // vmulps        %ymm11,%ymm12,%ymm11
  .byte  196,65,36,94,222                    // vdivps        %ymm14,%ymm11,%ymm11
  .byte  196,99,37,74,225,240                // vblendvps     %ymm15,%ymm1,%ymm11,%ymm12
  .byte  196,98,125,24,45,8,147,3,0          // vbroadcastss  0x39308(%rip),%ymm13        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,98,125,24,53,3,147,3,0          // vbroadcastss  0x39303(%rip),%ymm14        # 3a23c <_sk_srcover_bgra_8888_sse2_lowp+0x2d4>
  .byte  196,65,84,89,254                    // vmulps        %ymm14,%ymm5,%ymm15
  .byte  196,66,93,184,253                   // vfmadd231ps   %ymm13,%ymm4,%ymm15
  .byte  98,226,125,40,24,5,243,146,3,0      // vbroadcastss  0x392f3(%rip),%ymm16        # 3a240 <_sk_srcover_bgra_8888_sse2_lowp+0x2d8>
  .byte  98,50,77,40,184,248                 // vfmadd231ps   %ymm16,%ymm6,%ymm15
  .byte  196,65,44,89,222                    // vmulps        %ymm14,%ymm10,%ymm11
  .byte  196,66,53,184,221                   // vfmadd231ps   %ymm13,%ymm9,%ymm11
  .byte  98,50,29,40,184,216                 // vfmadd231ps   %ymm16,%ymm12,%ymm11
  .byte  196,66,101,170,251                  // vfmsub213ps   %ymm11,%ymm3,%ymm15
  .byte  196,65,52,88,207                    // vaddps        %ymm15,%ymm9,%ymm9
  .byte  196,65,44,88,223                    // vaddps        %ymm15,%ymm10,%ymm11
  .byte  196,65,28,88,215                    // vaddps        %ymm15,%ymm12,%ymm10
  .byte  197,100,89,231                      // vmulps        %ymm7,%ymm3,%ymm12
  .byte  196,65,36,93,250                    // vminps        %ymm10,%ymm11,%ymm15
  .byte  196,65,52,93,255                    // vminps        %ymm15,%ymm9,%ymm15
  .byte  98,193,36,40,95,202                 // vmaxps        %ymm10,%ymm11,%ymm17
  .byte  98,161,52,40,95,201                 // vmaxps        %ymm17,%ymm9,%ymm17
  .byte  196,65,36,89,246                    // vmulps        %ymm14,%ymm11,%ymm14
  .byte  196,66,53,184,245                   // vfmadd231ps   %ymm13,%ymm9,%ymm14
  .byte  98,50,45,40,184,240                 // vfmadd231ps   %ymm16,%ymm10,%ymm14
  .byte  98,209,116,40,194,199,2             // vcmpleps      %ymm15,%ymm1,%k0
  .byte  98,114,126,40,56,232                // vpmovm2d      %k0,%ymm13
  .byte  98,193,52,40,92,198                 // vsubps        %ymm14,%ymm9,%ymm16
  .byte  98,161,12,40,89,192                 // vmulps        %ymm16,%ymm14,%ymm16
  .byte  196,65,12,92,255                    // vsubps        %ymm15,%ymm14,%ymm15
  .byte  98,193,124,32,94,199                // vdivps        %ymm15,%ymm16,%ymm16
  .byte  98,49,12,40,88,192                  // vaddps        %ymm16,%ymm14,%ymm8
  .byte  196,67,61,74,193,208                // vblendvps     %ymm13,%ymm9,%ymm8,%ymm8
  .byte  98,177,28,40,194,193,1              // vcmpltps      %ymm17,%ymm12,%k0
  .byte  98,114,126,40,56,200                // vpmovm2d      %k0,%ymm9
  .byte  98,193,60,40,92,198                 // vsubps        %ymm14,%ymm8,%ymm16
  .byte  98,193,28,40,92,222                 // vsubps        %ymm14,%ymm12,%ymm19
  .byte  98,161,100,32,89,192                // vmulps        %ymm16,%ymm19,%ymm16
  .byte  98,193,116,32,92,206                // vsubps        %ymm14,%ymm17,%ymm17
  .byte  98,161,124,32,94,193                // vdivps        %ymm17,%ymm16,%ymm16
  .byte  98,177,12,40,88,208                 // vaddps        %ymm16,%ymm14,%ymm2
  .byte  196,227,61,74,210,144               // vblendvps     %ymm9,%ymm2,%ymm8,%ymm2
  .byte  197,236,95,209                      // vmaxps        %ymm1,%ymm2,%ymm2
  .byte  196,65,36,92,198                    // vsubps        %ymm14,%ymm11,%ymm8
  .byte  196,65,12,89,192                    // vmulps        %ymm8,%ymm14,%ymm8
  .byte  196,65,60,94,199                    // vdivps        %ymm15,%ymm8,%ymm8
  .byte  196,65,12,88,192                    // vaddps        %ymm8,%ymm14,%ymm8
  .byte  196,67,61,74,195,208                // vblendvps     %ymm13,%ymm11,%ymm8,%ymm8
  .byte  196,65,60,92,222                    // vsubps        %ymm14,%ymm8,%ymm11
  .byte  98,81,100,32,89,219                 // vmulps        %ymm11,%ymm19,%ymm11
  .byte  98,49,36,40,94,217                  // vdivps        %ymm17,%ymm11,%ymm11
  .byte  196,65,12,88,219                    // vaddps        %ymm11,%ymm14,%ymm11
  .byte  196,67,61,74,195,144                // vblendvps     %ymm9,%ymm11,%ymm8,%ymm8
  .byte  197,60,95,193                       // vmaxps        %ymm1,%ymm8,%ymm8
  .byte  196,65,44,92,222                    // vsubps        %ymm14,%ymm10,%ymm11
  .byte  196,65,12,89,219                    // vmulps        %ymm11,%ymm14,%ymm11
  .byte  196,65,36,94,223                    // vdivps        %ymm15,%ymm11,%ymm11
  .byte  196,65,12,88,219                    // vaddps        %ymm11,%ymm14,%ymm11
  .byte  196,67,37,74,210,208                // vblendvps     %ymm13,%ymm10,%ymm11,%ymm10
  .byte  196,65,44,92,222                    // vsubps        %ymm14,%ymm10,%ymm11
  .byte  98,81,100,32,89,219                 // vmulps        %ymm11,%ymm19,%ymm11
  .byte  98,49,36,40,94,217                  // vdivps        %ymm17,%ymm11,%ymm11
  .byte  196,65,12,88,219                    // vaddps        %ymm11,%ymm14,%ymm11
  .byte  196,67,45,74,203,144                // vblendvps     %ymm9,%ymm11,%ymm10,%ymm9
  .byte  197,52,95,201                       // vmaxps        %ymm1,%ymm9,%ymm9
  .byte  196,226,125,24,13,143,145,3,0       // vbroadcastss  0x3918f(%rip),%ymm1        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,116,92,215                      // vsubps        %ymm7,%ymm1,%ymm10
  .byte  197,172,89,192                      // vmulps        %ymm0,%ymm10,%ymm0
  .byte  197,116,92,219                      // vsubps        %ymm3,%ymm1,%ymm11
  .byte  196,226,37,184,196                  // vfmadd231ps   %ymm4,%ymm11,%ymm0
  .byte  197,252,88,194                      // vaddps        %ymm2,%ymm0,%ymm0
  .byte  98,177,44,40,89,204                 // vmulps        %ymm20,%ymm10,%ymm1
  .byte  196,226,37,184,205                  // vfmadd231ps   %ymm5,%ymm11,%ymm1
  .byte  196,193,116,88,200                  // vaddps        %ymm8,%ymm1,%ymm1
  .byte  98,177,44,40,89,210                 // vmulps        %ymm18,%ymm10,%ymm2
  .byte  196,98,77,168,218                   // vfmadd213ps   %ymm2,%ymm6,%ymm11
  .byte  196,193,36,88,209                   // vaddps        %ymm9,%ymm11,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,92,220                  // vsubps        %ymm12,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_color_skx
.globl _sk_color_skx
FUNCTION(_sk_color_skx)
_sk_color_skx:
  .byte  197,124,89,199                      // vmulps        %ymm7,%ymm0,%ymm8
  .byte  197,116,89,207                      // vmulps        %ymm7,%ymm1,%ymm9
  .byte  197,108,89,223                      // vmulps        %ymm7,%ymm2,%ymm11
  .byte  196,98,125,24,37,88,145,3,0         // vbroadcastss  0x39158(%rip),%ymm12        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,98,125,24,45,83,145,3,0         // vbroadcastss  0x39153(%rip),%ymm13        # 3a23c <_sk_srcover_bgra_8888_sse2_lowp+0x2d4>
  .byte  196,65,84,89,245                    // vmulps        %ymm13,%ymm5,%ymm14
  .byte  196,66,93,184,244                   // vfmadd231ps   %ymm12,%ymm4,%ymm14
  .byte  196,98,125,24,61,68,145,3,0         // vbroadcastss  0x39144(%rip),%ymm15        # 3a240 <_sk_srcover_bgra_8888_sse2_lowp+0x2d8>
  .byte  196,66,77,184,247                   // vfmadd231ps   %ymm15,%ymm6,%ymm14
  .byte  196,65,52,89,213                    // vmulps        %ymm13,%ymm9,%ymm10
  .byte  196,66,61,184,212                   // vfmadd231ps   %ymm12,%ymm8,%ymm10
  .byte  196,66,37,184,215                   // vfmadd231ps   %ymm15,%ymm11,%ymm10
  .byte  196,66,101,170,242                  // vfmsub213ps   %ymm10,%ymm3,%ymm14
  .byte  196,65,60,88,198                    // vaddps        %ymm14,%ymm8,%ymm8
  .byte  196,65,52,88,214                    // vaddps        %ymm14,%ymm9,%ymm10
  .byte  196,65,36,88,206                    // vaddps        %ymm14,%ymm11,%ymm9
  .byte  98,225,100,40,89,231                // vmulps        %ymm7,%ymm3,%ymm20
  .byte  196,65,44,93,241                    // vminps        %ymm9,%ymm10,%ymm14
  .byte  196,65,60,93,246                    // vminps        %ymm14,%ymm8,%ymm14
  .byte  98,193,44,40,95,193                 // vmaxps        %ymm9,%ymm10,%ymm16
  .byte  98,161,60,40,95,192                 // vmaxps        %ymm16,%ymm8,%ymm16
  .byte  196,65,44,89,237                    // vmulps        %ymm13,%ymm10,%ymm13
  .byte  196,66,61,184,236                   // vfmadd231ps   %ymm12,%ymm8,%ymm13
  .byte  196,66,53,184,239                   // vfmadd231ps   %ymm15,%ymm9,%ymm13
  .byte  98,161,108,32,87,210                // vxorps        %ymm18,%ymm18,%ymm18
  .byte  98,209,108,32,194,198,2             // vcmpleps      %ymm14,%ymm18,%k0
  .byte  98,114,126,40,56,248                // vpmovm2d      %k0,%ymm15
  .byte  98,193,60,40,92,205                 // vsubps        %ymm13,%ymm8,%ymm17
  .byte  98,161,20,40,89,201                 // vmulps        %ymm17,%ymm13,%ymm17
  .byte  196,65,20,92,246                    // vsubps        %ymm14,%ymm13,%ymm14
  .byte  98,193,116,32,94,206                // vdivps        %ymm14,%ymm17,%ymm17
  .byte  98,49,20,40,88,225                  // vaddps        %ymm17,%ymm13,%ymm12
  .byte  196,67,29,74,192,240                // vblendvps     %ymm15,%ymm8,%ymm12,%ymm8
  .byte  98,177,92,32,194,192,1              // vcmpltps      %ymm16,%ymm20,%k0
  .byte  98,114,126,40,56,224                // vpmovm2d      %k0,%ymm12
  .byte  98,193,60,40,92,205                 // vsubps        %ymm13,%ymm8,%ymm17
  .byte  98,193,92,32,92,221                 // vsubps        %ymm13,%ymm20,%ymm19
  .byte  98,161,100,32,89,201                // vmulps        %ymm17,%ymm19,%ymm17
  .byte  98,193,124,32,92,197                // vsubps        %ymm13,%ymm16,%ymm16
  .byte  98,161,116,32,94,200                // vdivps        %ymm16,%ymm17,%ymm17
  .byte  98,49,20,40,88,217                  // vaddps        %ymm17,%ymm13,%ymm11
  .byte  196,67,61,74,195,192                // vblendvps     %ymm12,%ymm11,%ymm8,%ymm8
  .byte  98,49,60,40,95,194                  // vmaxps        %ymm18,%ymm8,%ymm8
  .byte  196,65,44,92,221                    // vsubps        %ymm13,%ymm10,%ymm11
  .byte  196,65,20,89,219                    // vmulps        %ymm11,%ymm13,%ymm11
  .byte  196,65,36,94,222                    // vdivps        %ymm14,%ymm11,%ymm11
  .byte  196,65,20,88,219                    // vaddps        %ymm11,%ymm13,%ymm11
  .byte  196,67,37,74,210,240                // vblendvps     %ymm15,%ymm10,%ymm11,%ymm10
  .byte  196,65,44,92,221                    // vsubps        %ymm13,%ymm10,%ymm11
  .byte  98,81,100,32,89,219                 // vmulps        %ymm11,%ymm19,%ymm11
  .byte  98,49,36,40,94,216                  // vdivps        %ymm16,%ymm11,%ymm11
  .byte  196,65,20,88,219                    // vaddps        %ymm11,%ymm13,%ymm11
  .byte  196,67,45,74,211,192                // vblendvps     %ymm12,%ymm11,%ymm10,%ymm10
  .byte  98,49,44,40,95,210                  // vmaxps        %ymm18,%ymm10,%ymm10
  .byte  196,65,52,92,221                    // vsubps        %ymm13,%ymm9,%ymm11
  .byte  196,65,20,89,219                    // vmulps        %ymm11,%ymm13,%ymm11
  .byte  196,65,36,94,222                    // vdivps        %ymm14,%ymm11,%ymm11
  .byte  196,65,20,88,219                    // vaddps        %ymm11,%ymm13,%ymm11
  .byte  196,67,37,74,201,240                // vblendvps     %ymm15,%ymm9,%ymm11,%ymm9
  .byte  196,65,52,92,221                    // vsubps        %ymm13,%ymm9,%ymm11
  .byte  98,81,100,32,89,219                 // vmulps        %ymm11,%ymm19,%ymm11
  .byte  98,49,36,40,94,216                  // vdivps        %ymm16,%ymm11,%ymm11
  .byte  196,65,20,88,219                    // vaddps        %ymm11,%ymm13,%ymm11
  .byte  196,67,53,74,203,192                // vblendvps     %ymm12,%ymm11,%ymm9,%ymm9
  .byte  98,49,52,40,95,202                  // vmaxps        %ymm18,%ymm9,%ymm9
  .byte  196,98,125,24,29,213,143,3,0        // vbroadcastss  0x38fd5(%rip),%ymm11        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,36,92,231                       // vsubps        %ymm7,%ymm11,%ymm12
  .byte  197,156,89,192                      // vmulps        %ymm0,%ymm12,%ymm0
  .byte  197,36,92,219                       // vsubps        %ymm3,%ymm11,%ymm11
  .byte  196,226,37,184,196                  // vfmadd231ps   %ymm4,%ymm11,%ymm0
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  197,156,89,201                      // vmulps        %ymm1,%ymm12,%ymm1
  .byte  196,226,37,184,205                  // vfmadd231ps   %ymm5,%ymm11,%ymm1
  .byte  196,193,116,88,202                  // vaddps        %ymm10,%ymm1,%ymm1
  .byte  197,156,89,210                      // vmulps        %ymm2,%ymm12,%ymm2
  .byte  196,98,77,168,218                   // vfmadd213ps   %ymm2,%ymm6,%ymm11
  .byte  196,193,36,88,209                   // vaddps        %ymm9,%ymm11,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  98,177,100,40,92,220                // vsubps        %ymm20,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_luminosity_skx
.globl _sk_luminosity_skx
FUNCTION(_sk_luminosity_skx)
_sk_luminosity_skx:
  .byte  197,100,89,196                      // vmulps        %ymm4,%ymm3,%ymm8
  .byte  197,100,89,205                      // vmulps        %ymm5,%ymm3,%ymm9
  .byte  197,100,89,222                      // vmulps        %ymm6,%ymm3,%ymm11
  .byte  196,98,125,24,37,160,143,3,0        // vbroadcastss  0x38fa0(%rip),%ymm12        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,98,125,24,45,155,143,3,0        // vbroadcastss  0x38f9b(%rip),%ymm13        # 3a23c <_sk_srcover_bgra_8888_sse2_lowp+0x2d4>
  .byte  196,65,116,89,245                   // vmulps        %ymm13,%ymm1,%ymm14
  .byte  196,66,125,184,244                  // vfmadd231ps   %ymm12,%ymm0,%ymm14
  .byte  196,98,125,24,61,140,143,3,0        // vbroadcastss  0x38f8c(%rip),%ymm15        # 3a240 <_sk_srcover_bgra_8888_sse2_lowp+0x2d8>
  .byte  196,66,109,184,247                  // vfmadd231ps   %ymm15,%ymm2,%ymm14
  .byte  196,65,52,89,213                    // vmulps        %ymm13,%ymm9,%ymm10
  .byte  196,66,61,184,212                   // vfmadd231ps   %ymm12,%ymm8,%ymm10
  .byte  196,66,37,184,215                   // vfmadd231ps   %ymm15,%ymm11,%ymm10
  .byte  196,66,69,170,242                   // vfmsub213ps   %ymm10,%ymm7,%ymm14
  .byte  196,65,60,88,198                    // vaddps        %ymm14,%ymm8,%ymm8
  .byte  196,65,52,88,214                    // vaddps        %ymm14,%ymm9,%ymm10
  .byte  196,65,36,88,206                    // vaddps        %ymm14,%ymm11,%ymm9
  .byte  98,225,100,40,89,231                // vmulps        %ymm7,%ymm3,%ymm20
  .byte  196,65,44,93,241                    // vminps        %ymm9,%ymm10,%ymm14
  .byte  196,65,60,93,246                    // vminps        %ymm14,%ymm8,%ymm14
  .byte  98,193,44,40,95,193                 // vmaxps        %ymm9,%ymm10,%ymm16
  .byte  98,161,60,40,95,192                 // vmaxps        %ymm16,%ymm8,%ymm16
  .byte  196,65,44,89,237                    // vmulps        %ymm13,%ymm10,%ymm13
  .byte  196,66,61,184,236                   // vfmadd231ps   %ymm12,%ymm8,%ymm13
  .byte  196,66,53,184,239                   // vfmadd231ps   %ymm15,%ymm9,%ymm13
  .byte  98,161,108,32,87,210                // vxorps        %ymm18,%ymm18,%ymm18
  .byte  98,209,108,32,194,198,2             // vcmpleps      %ymm14,%ymm18,%k0
  .byte  98,114,126,40,56,248                // vpmovm2d      %k0,%ymm15
  .byte  98,193,60,40,92,205                 // vsubps        %ymm13,%ymm8,%ymm17
  .byte  98,161,20,40,89,201                 // vmulps        %ymm17,%ymm13,%ymm17
  .byte  196,65,20,92,246                    // vsubps        %ymm14,%ymm13,%ymm14
  .byte  98,193,116,32,94,206                // vdivps        %ymm14,%ymm17,%ymm17
  .byte  98,49,20,40,88,225                  // vaddps        %ymm17,%ymm13,%ymm12
  .byte  196,67,29,74,192,240                // vblendvps     %ymm15,%ymm8,%ymm12,%ymm8
  .byte  98,177,92,32,194,192,1              // vcmpltps      %ymm16,%ymm20,%k0
  .byte  98,114,126,40,56,224                // vpmovm2d      %k0,%ymm12
  .byte  98,193,60,40,92,205                 // vsubps        %ymm13,%ymm8,%ymm17
  .byte  98,193,92,32,92,221                 // vsubps        %ymm13,%ymm20,%ymm19
  .byte  98,161,100,32,89,201                // vmulps        %ymm17,%ymm19,%ymm17
  .byte  98,193,124,32,92,197                // vsubps        %ymm13,%ymm16,%ymm16
  .byte  98,161,116,32,94,200                // vdivps        %ymm16,%ymm17,%ymm17
  .byte  98,49,20,40,88,217                  // vaddps        %ymm17,%ymm13,%ymm11
  .byte  196,67,61,74,195,192                // vblendvps     %ymm12,%ymm11,%ymm8,%ymm8
  .byte  98,49,60,40,95,194                  // vmaxps        %ymm18,%ymm8,%ymm8
  .byte  196,65,44,92,221                    // vsubps        %ymm13,%ymm10,%ymm11
  .byte  196,65,20,89,219                    // vmulps        %ymm11,%ymm13,%ymm11
  .byte  196,65,36,94,222                    // vdivps        %ymm14,%ymm11,%ymm11
  .byte  196,65,20,88,219                    // vaddps        %ymm11,%ymm13,%ymm11
  .byte  196,67,37,74,210,240                // vblendvps     %ymm15,%ymm10,%ymm11,%ymm10
  .byte  196,65,44,92,221                    // vsubps        %ymm13,%ymm10,%ymm11
  .byte  98,81,100,32,89,219                 // vmulps        %ymm11,%ymm19,%ymm11
  .byte  98,49,36,40,94,216                  // vdivps        %ymm16,%ymm11,%ymm11
  .byte  196,65,20,88,219                    // vaddps        %ymm11,%ymm13,%ymm11
  .byte  196,67,45,74,211,192                // vblendvps     %ymm12,%ymm11,%ymm10,%ymm10
  .byte  98,49,44,40,95,210                  // vmaxps        %ymm18,%ymm10,%ymm10
  .byte  196,65,52,92,221                    // vsubps        %ymm13,%ymm9,%ymm11
  .byte  196,65,20,89,219                    // vmulps        %ymm11,%ymm13,%ymm11
  .byte  196,65,36,94,222                    // vdivps        %ymm14,%ymm11,%ymm11
  .byte  196,65,20,88,219                    // vaddps        %ymm11,%ymm13,%ymm11
  .byte  196,67,37,74,201,240                // vblendvps     %ymm15,%ymm9,%ymm11,%ymm9
  .byte  196,65,52,92,221                    // vsubps        %ymm13,%ymm9,%ymm11
  .byte  98,81,100,32,89,219                 // vmulps        %ymm11,%ymm19,%ymm11
  .byte  98,49,36,40,94,216                  // vdivps        %ymm16,%ymm11,%ymm11
  .byte  196,65,20,88,219                    // vaddps        %ymm11,%ymm13,%ymm11
  .byte  196,67,53,74,203,192                // vblendvps     %ymm12,%ymm11,%ymm9,%ymm9
  .byte  98,49,52,40,95,202                  // vmaxps        %ymm18,%ymm9,%ymm9
  .byte  196,98,125,24,29,29,142,3,0         // vbroadcastss  0x38e1d(%rip),%ymm11        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,36,92,231                       // vsubps        %ymm7,%ymm11,%ymm12
  .byte  197,156,89,192                      // vmulps        %ymm0,%ymm12,%ymm0
  .byte  197,36,92,219                       // vsubps        %ymm3,%ymm11,%ymm11
  .byte  196,226,37,184,196                  // vfmadd231ps   %ymm4,%ymm11,%ymm0
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  197,156,89,201                      // vmulps        %ymm1,%ymm12,%ymm1
  .byte  196,226,37,184,205                  // vfmadd231ps   %ymm5,%ymm11,%ymm1
  .byte  196,193,116,88,202                  // vaddps        %ymm10,%ymm1,%ymm1
  .byte  197,156,89,210                      // vmulps        %ymm2,%ymm12,%ymm2
  .byte  196,98,77,168,218                   // vfmadd213ps   %ymm2,%ymm6,%ymm11
  .byte  196,193,36,88,209                   // vaddps        %ymm9,%ymm11,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  98,177,100,40,92,220                // vsubps        %ymm20,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_rgba_8888_skx
.globl _sk_srcover_rgba_8888_skx
FUNCTION(_sk_srcover_rgba_8888_skx)
_sk_srcover_rgba_8888_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,235,0,0,0                    // jne           1546 <_sk_srcover_rgba_8888_skx+0x10b>
  .byte  196,129,126,111,60,152              // vmovdqu       (%r8,%r11,4),%ymm7
  .byte  184,17,17,17,17                     // mov           $0x11111111,%eax
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,241,127,169,111,231              // vmovdqu8      %ymm7,%ymm4{%k1}{z}
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  197,213,114,215,8                   // vpsrld        $0x8,%ymm7,%ymm5
  .byte  98,241,127,169,111,237              // vmovdqu8      %ymm5,%ymm5{%k1}{z}
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  197,205,114,215,16                  // vpsrld        $0x10,%ymm7,%ymm6
  .byte  98,241,127,169,111,246              // vmovdqu8      %ymm6,%ymm6{%k1}{z}
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,252,91,246                      // vcvtdq2ps     %ymm6,%ymm6
  .byte  197,197,114,215,24                  // vpsrld        $0x18,%ymm7,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,98,125,24,13,111,141,3,0        // vbroadcastss  0x38d6f(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,52,92,203                       // vsubps        %ymm3,%ymm9,%ymm9
  .byte  196,98,125,24,21,142,141,3,0        // vbroadcastss  0x38d8e(%rip),%ymm10        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,193,124,89,194                  // vmulps        %ymm10,%ymm0,%ymm0
  .byte  196,194,93,184,193                  // vfmadd231ps   %ymm9,%ymm4,%ymm0
  .byte  196,193,116,89,202                  // vmulps        %ymm10,%ymm1,%ymm1
  .byte  196,194,85,184,201                  // vfmadd231ps   %ymm9,%ymm5,%ymm1
  .byte  196,193,108,89,210                  // vmulps        %ymm10,%ymm2,%ymm2
  .byte  196,194,77,184,209                  // vfmadd231ps   %ymm9,%ymm6,%ymm2
  .byte  196,193,100,89,218                  // vmulps        %ymm10,%ymm3,%ymm3
  .byte  196,194,69,184,217                  // vfmadd231ps   %ymm9,%ymm7,%ymm3
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  197,60,95,217                       // vmaxps        %ymm1,%ymm8,%ymm11
  .byte  196,65,36,93,218                    // vminps        %ymm10,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,193,37,114,243,8                // vpslld        $0x8,%ymm11,%ymm11
  .byte  196,65,37,235,201                   // vpor          %ymm9,%ymm11,%ymm9
  .byte  197,60,95,218                       // vmaxps        %ymm2,%ymm8,%ymm11
  .byte  196,65,36,93,218                    // vminps        %ymm10,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,193,37,114,243,16               // vpslld        $0x10,%ymm11,%ymm11
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,193,61,114,240,24               // vpslld        $0x18,%ymm8,%ymm8
  .byte  196,65,37,235,192                   // vpor          %ymm8,%ymm11,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,66                              // jne           157e <_sk_srcover_rgba_8888_skx+0x143>
  .byte  196,1,126,127,4,152                 // vmovdqu       %ymm8,(%r8,%r11,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,2,255,255,255                // ja            1461 <_sk_srcover_rgba_8888_skx+0x26>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,6,1,0,0                   // lea           0x106(%rip),%r10        # 1670 <_sk_srcover_rgba_8888_skx+0x235>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,60,152              // vmovd         (%r8,%r11,4),%xmm7
  .byte  233,227,254,255,255                 // jmpq          1461 <_sk_srcover_rgba_8888_skx+0x26>
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,179                             // ja            1542 <_sk_srcover_rgba_8888_skx+0x107>
  .byte  65,15,182,193                       // movzbl        %r9b,%eax
  .byte  76,141,13,242,0,0,0                 // lea           0xf2(%rip),%r9        # 168c <_sk_srcover_rgba_8888_skx+0x251>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,121,126,4,152                 // vmovd         %xmm8,(%r8,%r11,4)
  .byte  235,151                             // jmp           1542 <_sk_srcover_rgba_8888_skx+0x107>
  .byte  196,129,121,110,100,152,8           // vmovd         0x8(%r8,%r11,4),%xmm4
  .byte  176,4                               // mov           $0x4,%al
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,242,125,169,137,252              // vpexpandd     %ymm4,%ymm7{%k1}{z}
  .byte  196,130,121,53,36,152               // vpmovzxdq     (%r8,%r11,4),%xmm4
  .byte  197,249,112,228,232                 // vpshufd       $0xe8,%xmm4,%xmm4
  .byte  196,227,69,2,252,3                  // vpblendd      $0x3,%ymm4,%ymm7,%ymm7
  .byte  233,141,254,255,255                 // jmpq          1461 <_sk_srcover_rgba_8888_skx+0x26>
  .byte  196,129,121,110,100,152,24          // vmovd         0x18(%r8,%r11,4),%xmm4
  .byte  176,64                              // mov           $0x40,%al
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,242,125,169,137,252              // vpexpandd     %ymm4,%ymm7{%k1}{z}
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,129,122,111,36,152              // vmovdqu       (%r8,%r11,4),%xmm4
  .byte  196,227,93,2,255,240                // vpblendd      $0xf0,%ymm7,%ymm4,%ymm7
  .byte  233,65,254,255,255                  // jmpq          1461 <_sk_srcover_rgba_8888_skx+0x26>
  .byte  196,3,121,22,68,152,8,2             // vpextrd       $0x2,%xmm8,0x8(%r8,%r11,4)
  .byte  196,66,121,53,192                   // vpmovzxdq     %xmm8,%xmm8
  .byte  98,18,126,8,53,4,152                // vpmovqd       %xmm8,(%r8,%r11,4)
  .byte  233,9,255,255,255                   // jmpq          1542 <_sk_srcover_rgba_8888_skx+0x107>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,24,2            // vpextrd       $0x2,%xmm9,0x18(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,20,1            // vpextrd       $0x1,%xmm9,0x14(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,1,121,126,76,152,16             // vmovd         %xmm9,0x10(%r8,%r11,4)
  .byte  196,1,122,127,4,152                 // vmovdqu       %xmm8,(%r8,%r11,4)
  .byte  233,213,254,255,255                 // jmpq          1542 <_sk_srcover_rgba_8888_skx+0x107>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  3,255                               // add           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,78,255                          // decl          -0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  59,255                              // cmp           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,159,255,255,255,139             // lcall         *-0x74000001(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,119,255                         // pushq         -0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255,100,255,255                     // jmpq          *-0x1(%rdi,%rdi,8)
  .byte  255,23                              // callq         *(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,156,255,255,255,148,255         // lcall         *-0x6b0001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,214                             // callq         *%rsi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,201                             // dec           %ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  187,255,255,255,173                 // mov           $0xadffffff,%ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_srcover_bgra_8888_skx
.globl _sk_srcover_bgra_8888_skx
FUNCTION(_sk_srcover_bgra_8888_skx)
_sk_srcover_bgra_8888_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,235,0,0,0                    // jne           17b3 <_sk_srcover_bgra_8888_skx+0x10b>
  .byte  196,129,126,111,60,152              // vmovdqu       (%r8,%r11,4),%ymm7
  .byte  184,17,17,17,17                     // mov           $0x11111111,%eax
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,241,127,169,111,231              // vmovdqu8      %ymm7,%ymm4{%k1}{z}
  .byte  197,252,91,244                      // vcvtdq2ps     %ymm4,%ymm6
  .byte  197,221,114,215,8                   // vpsrld        $0x8,%ymm7,%ymm4
  .byte  98,241,127,169,111,228              // vmovdqu8      %ymm4,%ymm4{%k1}{z}
  .byte  197,252,91,236                      // vcvtdq2ps     %ymm4,%ymm5
  .byte  197,221,114,215,16                  // vpsrld        $0x10,%ymm7,%ymm4
  .byte  98,241,127,169,111,228              // vmovdqu8      %ymm4,%ymm4{%k1}{z}
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  197,197,114,215,24                  // vpsrld        $0x18,%ymm7,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,98,125,24,13,2,139,3,0          // vbroadcastss  0x38b02(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,52,92,203                       // vsubps        %ymm3,%ymm9,%ymm9
  .byte  196,98,125,24,21,33,139,3,0         // vbroadcastss  0x38b21(%rip),%ymm10        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,193,124,89,194                  // vmulps        %ymm10,%ymm0,%ymm0
  .byte  196,194,93,184,193                  // vfmadd231ps   %ymm9,%ymm4,%ymm0
  .byte  196,193,116,89,202                  // vmulps        %ymm10,%ymm1,%ymm1
  .byte  196,194,85,184,201                  // vfmadd231ps   %ymm9,%ymm5,%ymm1
  .byte  196,193,108,89,210                  // vmulps        %ymm10,%ymm2,%ymm2
  .byte  196,194,77,184,209                  // vfmadd231ps   %ymm9,%ymm6,%ymm2
  .byte  196,193,100,89,218                  // vmulps        %ymm10,%ymm3,%ymm3
  .byte  196,194,69,184,217                  // vfmadd231ps   %ymm9,%ymm7,%ymm3
  .byte  197,60,95,202                       // vmaxps        %ymm2,%ymm8,%ymm9
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  197,60,95,217                       // vmaxps        %ymm1,%ymm8,%ymm11
  .byte  196,65,36,93,218                    // vminps        %ymm10,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,193,37,114,243,8                // vpslld        $0x8,%ymm11,%ymm11
  .byte  196,65,37,235,201                   // vpor          %ymm9,%ymm11,%ymm9
  .byte  197,60,95,216                       // vmaxps        %ymm0,%ymm8,%ymm11
  .byte  196,65,36,93,218                    // vminps        %ymm10,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,193,37,114,243,16               // vpslld        $0x10,%ymm11,%ymm11
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,193,61,114,240,24               // vpslld        $0x18,%ymm8,%ymm8
  .byte  196,65,37,235,192                   // vpor          %ymm8,%ymm11,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,66                              // jne           17eb <_sk_srcover_bgra_8888_skx+0x143>
  .byte  196,1,126,127,4,152                 // vmovdqu       %ymm8,(%r8,%r11,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,2,255,255,255                // ja            16ce <_sk_srcover_bgra_8888_skx+0x26>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,5,1,0,0                   // lea           0x105(%rip),%r10        # 18dc <_sk_srcover_bgra_8888_skx+0x234>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,60,152              // vmovd         (%r8,%r11,4),%xmm7
  .byte  233,227,254,255,255                 // jmpq          16ce <_sk_srcover_bgra_8888_skx+0x26>
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,179                             // ja            17af <_sk_srcover_bgra_8888_skx+0x107>
  .byte  65,15,182,193                       // movzbl        %r9b,%eax
  .byte  76,141,13,241,0,0,0                 // lea           0xf1(%rip),%r9        # 18f8 <_sk_srcover_bgra_8888_skx+0x250>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,121,126,4,152                 // vmovd         %xmm8,(%r8,%r11,4)
  .byte  235,151                             // jmp           17af <_sk_srcover_bgra_8888_skx+0x107>
  .byte  196,129,121,110,100,152,8           // vmovd         0x8(%r8,%r11,4),%xmm4
  .byte  176,4                               // mov           $0x4,%al
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,242,125,169,137,252              // vpexpandd     %ymm4,%ymm7{%k1}{z}
  .byte  196,130,121,53,36,152               // vpmovzxdq     (%r8,%r11,4),%xmm4
  .byte  197,249,112,228,232                 // vpshufd       $0xe8,%xmm4,%xmm4
  .byte  196,227,69,2,252,3                  // vpblendd      $0x3,%ymm4,%ymm7,%ymm7
  .byte  233,141,254,255,255                 // jmpq          16ce <_sk_srcover_bgra_8888_skx+0x26>
  .byte  196,129,121,110,100,152,24          // vmovd         0x18(%r8,%r11,4),%xmm4
  .byte  176,64                              // mov           $0x40,%al
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,242,125,169,137,252              // vpexpandd     %ymm4,%ymm7{%k1}{z}
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,129,122,111,36,152              // vmovdqu       (%r8,%r11,4),%xmm4
  .byte  196,227,93,2,255,240                // vpblendd      $0xf0,%ymm7,%ymm4,%ymm7
  .byte  233,65,254,255,255                  // jmpq          16ce <_sk_srcover_bgra_8888_skx+0x26>
  .byte  196,3,121,22,68,152,8,2             // vpextrd       $0x2,%xmm8,0x8(%r8,%r11,4)
  .byte  196,66,121,53,192                   // vpmovzxdq     %xmm8,%xmm8
  .byte  98,18,126,8,53,4,152                // vpmovqd       %xmm8,(%r8,%r11,4)
  .byte  233,9,255,255,255                   // jmpq          17af <_sk_srcover_bgra_8888_skx+0x107>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,24,2            // vpextrd       $0x2,%xmm9,0x18(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,20,1            // vpextrd       $0x1,%xmm9,0x14(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,1,121,126,76,152,16             // vmovd         %xmm9,0x10(%r8,%r11,4)
  .byte  196,1,122,127,4,152                 // vmovdqu       %xmm8,(%r8,%r11,4)
  .byte  233,213,254,255,255                 // jmpq          17af <_sk_srcover_bgra_8888_skx+0x107>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  4,255                               // add           $0xff,%al
  .byte  255                                 // (bad)
  .byte  255,79,255                          // decl          -0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  60,255                              // cmp           $0xff,%al
  .byte  255                                 // (bad)
  .byte  255,160,255,255,255,140             // jmpq          *-0x73000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  120,255                             // js            18f1 <_sk_srcover_bgra_8888_skx+0x249>
  .byte  255                                 // (bad)
  .byte  255,101,255                         // jmpq          *-0x1(%rbp)
  .byte  255                                 // (bad)
  .byte  255,24                              // lcall         *(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,157,255,255,255,149             // lcall         *-0x6a000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,215                             // callq         *%rdi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,202                             // dec           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  188,255,255,255,174                 // mov           $0xaeffffff,%esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_clamp_0_skx
.globl _sk_clamp_0_skx
FUNCTION(_sk_clamp_0_skx)
_sk_clamp_0_skx:
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,193,124,95,192                  // vmaxps        %ymm8,%ymm0,%ymm0
  .byte  196,193,116,95,200                  // vmaxps        %ymm8,%ymm1,%ymm1
  .byte  196,193,108,95,208                  // vmaxps        %ymm8,%ymm2,%ymm2
  .byte  196,193,100,95,216                  // vmaxps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_1_skx
.globl _sk_clamp_1_skx
FUNCTION(_sk_clamp_1_skx)
_sk_clamp_1_skx:
  .byte  196,98,125,24,5,222,136,3,0         // vbroadcastss  0x388de(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  196,193,108,93,208                  // vminps        %ymm8,%ymm2,%ymm2
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_skx
.globl _sk_clamp_a_skx
FUNCTION(_sk_clamp_a_skx)
_sk_clamp_a_skx:
  .byte  98,241,100,56,93,29,188,136,3,0     // vminps        0x388bc(%rip){1to8},%ymm3,%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,93,195                      // vminps        %ymm3,%ymm0,%ymm0
  .byte  197,244,93,203                      // vminps        %ymm3,%ymm1,%ymm1
  .byte  197,236,93,211                      // vminps        %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_dst_skx
.globl _sk_clamp_a_dst_skx
FUNCTION(_sk_clamp_a_dst_skx)
_sk_clamp_a_dst_skx:
  .byte  98,241,68,56,93,61,162,136,3,0      // vminps        0x388a2(%rip){1to8},%ymm7,%ymm7        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,220,93,231                      // vminps        %ymm7,%ymm4,%ymm4
  .byte  197,212,93,239                      // vminps        %ymm7,%ymm5,%ymm5
  .byte  197,204,93,247                      // vminps        %ymm7,%ymm6,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_set_rgb_skx
.globl _sk_set_rgb_skx
FUNCTION(_sk_set_rgb_skx)
_sk_set_rgb_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,0                    // vbroadcastss  (%rax),%ymm0
  .byte  196,226,125,24,72,4                 // vbroadcastss  0x4(%rax),%ymm1
  .byte  196,226,125,24,80,8                 // vbroadcastss  0x8(%rax),%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_swap_rb_skx
.globl _sk_swap_rb_skx
FUNCTION(_sk_swap_rb_skx)
_sk_swap_rb_skx:
  .byte  197,124,40,192                      // vmovaps       %ymm0,%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,194                      // vmovaps       %ymm2,%ymm0
  .byte  197,124,41,194                      // vmovaps       %ymm8,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_invert_skx
.globl _sk_invert_skx
FUNCTION(_sk_invert_skx)
_sk_invert_skx:
  .byte  196,98,125,24,5,98,136,3,0          // vbroadcastss  0x38862(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  197,188,92,219                      // vsubps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_src_dst_skx
.globl _sk_move_src_dst_skx
FUNCTION(_sk_move_src_dst_skx)
_sk_move_src_dst_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,224                      // vmovaps       %ymm0,%ymm4
  .byte  197,252,40,233                      // vmovaps       %ymm1,%ymm5
  .byte  197,252,40,242                      // vmovaps       %ymm2,%ymm6
  .byte  197,252,40,251                      // vmovaps       %ymm3,%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_dst_src_skx
.globl _sk_move_dst_src_skx
FUNCTION(_sk_move_dst_src_skx)
_sk_move_dst_src_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,196                      // vmovaps       %ymm4,%ymm0
  .byte  197,252,40,205                      // vmovaps       %ymm5,%ymm1
  .byte  197,252,40,214                      // vmovaps       %ymm6,%ymm2
  .byte  197,252,40,223                      // vmovaps       %ymm7,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_skx
.globl _sk_premul_skx
FUNCTION(_sk_premul_skx)
_sk_premul_skx:
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  197,244,89,203                      // vmulps        %ymm3,%ymm1,%ymm1
  .byte  197,236,89,211                      // vmulps        %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_dst_skx
.globl _sk_premul_dst_skx
FUNCTION(_sk_premul_dst_skx)
_sk_premul_dst_skx:
  .byte  197,220,89,231                      // vmulps        %ymm7,%ymm4,%ymm4
  .byte  197,212,89,239                      // vmulps        %ymm7,%ymm5,%ymm5
  .byte  197,204,89,247                      // vmulps        %ymm7,%ymm6,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_unpremul_skx
.globl _sk_unpremul_skx
FUNCTION(_sk_unpremul_skx)
_sk_unpremul_skx:
  .byte  196,98,125,24,5,253,135,3,0         // vbroadcastss  0x387fd(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,94,195                       // vdivps        %ymm3,%ymm8,%ymm8
  .byte  98,241,60,56,194,5,30,136,3,0,1     // vcmpltps      0x3881e(%rip){1to8},%ymm8,%k0        # 3a248 <_sk_srcover_bgra_8888_sse2_lowp+0x2e0>
  .byte  98,114,126,40,56,200                // vpmovm2d      %k0,%ymm9
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,67,45,74,192,144                // vblendvps     %ymm9,%ymm8,%ymm10,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_from_srgb_skx
.globl _sk_from_srgb_skx
FUNCTION(_sk_from_srgb_skx)
_sk_from_srgb_skx:
  .byte  196,98,125,24,5,248,135,3,0         // vbroadcastss  0x387f8(%rip),%ymm8        # 3a24c <_sk_srcover_bgra_8888_sse2_lowp+0x2e4>
  .byte  196,65,124,89,200                   // vmulps        %ymm8,%ymm0,%ymm9
  .byte  197,124,89,208                      // vmulps        %ymm0,%ymm0,%ymm10
  .byte  196,98,125,24,29,234,135,3,0        // vbroadcastss  0x387ea(%rip),%ymm11        # 3a250 <_sk_srcover_bgra_8888_sse2_lowp+0x2e8>
  .byte  196,98,125,24,37,201,135,3,0        // vbroadcastss  0x387c9(%rip),%ymm12        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,65,124,40,236                   // vmovaps       %ymm12,%ymm13
  .byte  196,66,125,168,235                  // vfmadd213ps   %ymm11,%ymm0,%ymm13
  .byte  196,98,125,24,53,210,135,3,0        // vbroadcastss  0x387d2(%rip),%ymm14        # 3a254 <_sk_srcover_bgra_8888_sse2_lowp+0x2ec>
  .byte  196,66,45,168,238                   // vfmadd213ps   %ymm14,%ymm10,%ymm13
  .byte  196,98,125,24,21,200,135,3,0        // vbroadcastss  0x387c8(%rip),%ymm10        # 3a258 <_sk_srcover_bgra_8888_sse2_lowp+0x2f0>
  .byte  98,209,124,40,194,194,1             // vcmpltps      %ymm10,%ymm0,%k0
  .byte  98,242,126,40,56,192                // vpmovm2d      %k0,%ymm0
  .byte  196,195,21,74,193,0                 // vblendvps     %ymm0,%ymm9,%ymm13,%ymm0
  .byte  196,65,116,89,200                   // vmulps        %ymm8,%ymm1,%ymm9
  .byte  197,116,89,233                      // vmulps        %ymm1,%ymm1,%ymm13
  .byte  196,65,124,40,252                   // vmovaps       %ymm12,%ymm15
  .byte  196,66,117,168,251                  // vfmadd213ps   %ymm11,%ymm1,%ymm15
  .byte  196,66,21,168,254                   // vfmadd213ps   %ymm14,%ymm13,%ymm15
  .byte  98,209,116,40,194,194,1             // vcmpltps      %ymm10,%ymm1,%k0
  .byte  98,242,126,40,56,200                // vpmovm2d      %k0,%ymm1
  .byte  196,195,5,74,201,16                 // vblendvps     %ymm1,%ymm9,%ymm15,%ymm1
  .byte  196,65,108,89,192                   // vmulps        %ymm8,%ymm2,%ymm8
  .byte  197,108,89,202                      // vmulps        %ymm2,%ymm2,%ymm9
  .byte  196,66,109,168,227                  // vfmadd213ps   %ymm11,%ymm2,%ymm12
  .byte  196,66,53,168,230                   // vfmadd213ps   %ymm14,%ymm9,%ymm12
  .byte  98,209,108,40,194,194,1             // vcmpltps      %ymm10,%ymm2,%k0
  .byte  98,242,126,40,56,208                // vpmovm2d      %k0,%ymm2
  .byte  196,195,29,74,208,32                // vblendvps     %ymm2,%ymm8,%ymm12,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_from_srgb_dst_skx
.globl _sk_from_srgb_dst_skx
FUNCTION(_sk_from_srgb_dst_skx)
_sk_from_srgb_dst_skx:
  .byte  196,98,125,24,5,75,135,3,0          // vbroadcastss  0x3874b(%rip),%ymm8        # 3a24c <_sk_srcover_bgra_8888_sse2_lowp+0x2e4>
  .byte  196,65,92,89,200                    // vmulps        %ymm8,%ymm4,%ymm9
  .byte  197,92,89,212                       // vmulps        %ymm4,%ymm4,%ymm10
  .byte  196,98,125,24,29,61,135,3,0         // vbroadcastss  0x3873d(%rip),%ymm11        # 3a250 <_sk_srcover_bgra_8888_sse2_lowp+0x2e8>
  .byte  196,98,125,24,37,28,135,3,0         // vbroadcastss  0x3871c(%rip),%ymm12        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,65,124,40,236                   // vmovaps       %ymm12,%ymm13
  .byte  196,66,93,168,235                   // vfmadd213ps   %ymm11,%ymm4,%ymm13
  .byte  196,98,125,24,53,37,135,3,0         // vbroadcastss  0x38725(%rip),%ymm14        # 3a254 <_sk_srcover_bgra_8888_sse2_lowp+0x2ec>
  .byte  196,66,45,168,238                   // vfmadd213ps   %ymm14,%ymm10,%ymm13
  .byte  196,98,125,24,21,27,135,3,0         // vbroadcastss  0x3871b(%rip),%ymm10        # 3a258 <_sk_srcover_bgra_8888_sse2_lowp+0x2f0>
  .byte  98,209,92,40,194,194,1              // vcmpltps      %ymm10,%ymm4,%k0
  .byte  98,242,126,40,56,224                // vpmovm2d      %k0,%ymm4
  .byte  196,195,21,74,225,64                // vblendvps     %ymm4,%ymm9,%ymm13,%ymm4
  .byte  196,65,84,89,200                    // vmulps        %ymm8,%ymm5,%ymm9
  .byte  197,84,89,237                       // vmulps        %ymm5,%ymm5,%ymm13
  .byte  196,65,124,40,252                   // vmovaps       %ymm12,%ymm15
  .byte  196,66,85,168,251                   // vfmadd213ps   %ymm11,%ymm5,%ymm15
  .byte  196,66,21,168,254                   // vfmadd213ps   %ymm14,%ymm13,%ymm15
  .byte  98,209,84,40,194,194,1              // vcmpltps      %ymm10,%ymm5,%k0
  .byte  98,242,126,40,56,232                // vpmovm2d      %k0,%ymm5
  .byte  196,195,5,74,233,80                 // vblendvps     %ymm5,%ymm9,%ymm15,%ymm5
  .byte  196,65,76,89,192                    // vmulps        %ymm8,%ymm6,%ymm8
  .byte  197,76,89,206                       // vmulps        %ymm6,%ymm6,%ymm9
  .byte  196,66,77,168,227                   // vfmadd213ps   %ymm11,%ymm6,%ymm12
  .byte  196,66,53,168,230                   // vfmadd213ps   %ymm14,%ymm9,%ymm12
  .byte  98,209,76,40,194,194,1              // vcmpltps      %ymm10,%ymm6,%k0
  .byte  98,242,126,40,56,240                // vpmovm2d      %k0,%ymm6
  .byte  196,195,29,74,240,96                // vblendvps     %ymm6,%ymm8,%ymm12,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_to_srgb_skx
.globl _sk_to_srgb_skx
FUNCTION(_sk_to_srgb_skx)
_sk_to_srgb_skx:
  .byte  98,114,125,40,78,192                // vrsqrt14ps    %ymm0,%ymm8
  .byte  196,98,125,24,13,168,134,3,0        // vbroadcastss  0x386a8(%rip),%ymm9        # 3a25c <_sk_srcover_bgra_8888_sse2_lowp+0x2f4>
  .byte  196,65,124,89,209                   // vmulps        %ymm9,%ymm0,%ymm10
  .byte  196,98,125,24,29,158,134,3,0        // vbroadcastss  0x3869e(%rip),%ymm11        # 3a260 <_sk_srcover_bgra_8888_sse2_lowp+0x2f8>
  .byte  196,98,125,24,37,153,134,3,0        // vbroadcastss  0x38699(%rip),%ymm12        # 3a264 <_sk_srcover_bgra_8888_sse2_lowp+0x2fc>
  .byte  196,65,124,40,236                   // vmovaps       %ymm12,%ymm13
  .byte  196,66,61,168,235                   // vfmadd213ps   %ymm11,%ymm8,%ymm13
  .byte  196,98,125,24,53,138,134,3,0        // vbroadcastss  0x3868a(%rip),%ymm14        # 3a268 <_sk_srcover_bgra_8888_sse2_lowp+0x300>
  .byte  196,66,61,168,238                   // vfmadd213ps   %ymm14,%ymm8,%ymm13
  .byte  196,98,125,24,61,128,134,3,0        // vbroadcastss  0x38680(%rip),%ymm15        # 3a26c <_sk_srcover_bgra_8888_sse2_lowp+0x304>
  .byte  196,65,60,88,199                    // vaddps        %ymm15,%ymm8,%ymm8
  .byte  98,82,125,40,76,192                 // vrcp14ps      %ymm8,%ymm8
  .byte  196,65,20,89,192                    // vmulps        %ymm8,%ymm13,%ymm8
  .byte  196,98,125,24,45,107,134,3,0        // vbroadcastss  0x3866b(%rip),%ymm13        # 3a270 <_sk_srcover_bgra_8888_sse2_lowp+0x308>
  .byte  98,209,124,40,194,197,1             // vcmpltps      %ymm13,%ymm0,%k0
  .byte  98,242,126,40,56,192                // vpmovm2d      %k0,%ymm0
  .byte  196,195,61,74,194,0                 // vblendvps     %ymm0,%ymm10,%ymm8,%ymm0
  .byte  98,114,125,40,78,193                // vrsqrt14ps    %ymm1,%ymm8
  .byte  196,65,116,89,209                   // vmulps        %ymm9,%ymm1,%ymm10
  .byte  98,193,124,40,40,196                // vmovaps       %ymm12,%ymm16
  .byte  98,194,61,40,168,195                // vfmadd213ps   %ymm11,%ymm8,%ymm16
  .byte  98,194,61,40,168,198                // vfmadd213ps   %ymm14,%ymm8,%ymm16
  .byte  196,65,60,88,199                    // vaddps        %ymm15,%ymm8,%ymm8
  .byte  98,82,125,40,76,192                 // vrcp14ps      %ymm8,%ymm8
  .byte  98,81,124,32,89,192                 // vmulps        %ymm8,%ymm16,%ymm8
  .byte  98,209,116,40,194,197,1             // vcmpltps      %ymm13,%ymm1,%k0
  .byte  98,242,126,40,56,200                // vpmovm2d      %k0,%ymm1
  .byte  196,195,61,74,202,16                // vblendvps     %ymm1,%ymm10,%ymm8,%ymm1
  .byte  98,114,125,40,78,194                // vrsqrt14ps    %ymm2,%ymm8
  .byte  196,65,108,89,201                   // vmulps        %ymm9,%ymm2,%ymm9
  .byte  196,66,61,168,227                   // vfmadd213ps   %ymm11,%ymm8,%ymm12
  .byte  196,66,61,168,230                   // vfmadd213ps   %ymm14,%ymm8,%ymm12
  .byte  196,65,60,88,199                    // vaddps        %ymm15,%ymm8,%ymm8
  .byte  98,82,125,40,76,192                 // vrcp14ps      %ymm8,%ymm8
  .byte  196,65,28,89,192                    // vmulps        %ymm8,%ymm12,%ymm8
  .byte  98,209,108,40,194,197,1             // vcmpltps      %ymm13,%ymm2,%k0
  .byte  98,242,126,40,56,208                // vpmovm2d      %k0,%ymm2
  .byte  196,195,61,74,209,32                // vblendvps     %ymm2,%ymm9,%ymm8,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_rgb_to_hsl_skx
.globl _sk_rgb_to_hsl_skx
FUNCTION(_sk_rgb_to_hsl_skx)
_sk_rgb_to_hsl_skx:
  .byte  98,225,124,40,40,207                // vmovaps       %ymm7,%ymm17
  .byte  197,116,95,194                      // vmaxps        %ymm2,%ymm1,%ymm8
  .byte  196,65,124,95,200                   // vmaxps        %ymm8,%ymm0,%ymm9
  .byte  197,116,93,194                      // vminps        %ymm2,%ymm1,%ymm8
  .byte  196,65,124,93,208                   // vminps        %ymm8,%ymm0,%ymm10
  .byte  98,193,52,40,92,194                 // vsubps        %ymm10,%ymm9,%ymm16
  .byte  196,98,125,24,5,92,133,3,0          // vbroadcastss  0x3855c(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  98,49,60,40,94,224                  // vdivps        %ymm16,%ymm8,%ymm12
  .byte  98,209,52,40,194,194,0              // vcmpeqps      %ymm10,%ymm9,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  98,241,52,40,194,192,0              // vcmpeqps      %ymm0,%ymm9,%k0
  .byte  98,114,126,40,56,232                // vpmovm2d      %k0,%ymm13
  .byte  197,116,92,242                      // vsubps        %ymm2,%ymm1,%ymm14
  .byte  98,241,116,40,194,194,1             // vcmpltps      %ymm2,%ymm1,%k0
  .byte  98,114,126,40,56,248                // vpmovm2d      %k0,%ymm15
  .byte  196,98,125,24,29,126,133,3,0        // vbroadcastss  0x3857e(%rip),%ymm11        # 3a274 <_sk_srcover_bgra_8888_sse2_lowp+0x30c>
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  196,67,69,74,219,240                // vblendvps     %ymm15,%ymm11,%ymm7,%ymm11
  .byte  196,66,29,168,243                   // vfmadd213ps   %ymm11,%ymm12,%ymm14
  .byte  98,241,52,40,194,193,0              // vcmpeqps      %ymm1,%ymm9,%k0
  .byte  98,114,126,40,56,216                // vpmovm2d      %k0,%ymm11
  .byte  197,236,92,208                      // vsubps        %ymm0,%ymm2,%ymm2
  .byte  196,98,125,24,61,89,133,3,0         // vbroadcastss  0x38559(%rip),%ymm15        # 3a278 <_sk_srcover_bgra_8888_sse2_lowp+0x310>
  .byte  196,194,29,168,215                  // vfmadd213ps   %ymm15,%ymm12,%ymm2
  .byte  197,252,92,193                      // vsubps        %ymm1,%ymm0,%ymm0
  .byte  98,242,29,56,168,5,74,133,3,0       // vfmadd213ps   0x3854a(%rip){1to8},%ymm12,%ymm0        # 3a27c <_sk_srcover_bgra_8888_sse2_lowp+0x314>
  .byte  196,227,125,74,194,176              // vblendvps     %ymm11,%ymm2,%ymm0,%ymm0
  .byte  196,195,125,74,198,208              // vblendvps     %ymm13,%ymm14,%ymm0,%ymm0
  .byte  196,227,125,74,199,128              // vblendvps     %ymm8,%ymm7,%ymm0,%ymm0
  .byte  98,241,124,56,89,5,50,133,3,0       // vmulps        0x38532(%rip){1to8},%ymm0,%ymm0        # 3a280 <_sk_srcover_bgra_8888_sse2_lowp+0x318>
  .byte  196,193,52,88,202                   // vaddps        %ymm10,%ymm9,%ymm1
  .byte  196,98,125,24,29,184,132,3,0        // vbroadcastss  0x384b8(%rip),%ymm11        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,193,116,89,211                  // vmulps        %ymm11,%ymm1,%ymm2
  .byte  98,241,36,40,194,194,1              // vcmpltps      %ymm2,%ymm11,%k0
  .byte  98,114,126,40,56,216                // vpmovm2d      %k0,%ymm11
  .byte  196,65,4,92,201                     // vsubps        %ymm9,%ymm15,%ymm9
  .byte  196,65,52,92,202                    // vsubps        %ymm10,%ymm9,%ymm9
  .byte  196,195,117,74,201,176              // vblendvps     %ymm11,%ymm9,%ymm1,%ymm1
  .byte  98,241,124,32,94,201                // vdivps        %ymm1,%ymm16,%ymm1
  .byte  196,227,117,74,207,128              // vblendvps     %ymm8,%ymm7,%ymm1,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,177,124,40,40,249                // vmovaps       %ymm17,%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hsl_to_rgb_skx
.globl _sk_hsl_to_rgb_skx
FUNCTION(_sk_hsl_to_rgb_skx)
_sk_hsl_to_rgb_skx:
  .byte  98,225,124,40,40,215                // vmovaps       %ymm7,%ymm18
  .byte  98,225,124,40,40,230                // vmovaps       %ymm6,%ymm20
  .byte  98,226,125,40,24,5,106,132,3,0      // vbroadcastss  0x3846a(%rip),%ymm16        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  98,241,124,32,194,194,2             // vcmpleps      %ymm2,%ymm16,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  197,116,89,202                      // vmulps        %ymm2,%ymm1,%ymm9
  .byte  196,65,116,92,209                   // vsubps        %ymm9,%ymm1,%ymm10
  .byte  196,67,53,74,194,128                // vblendvps     %ymm8,%ymm10,%ymm9,%ymm8
  .byte  197,60,88,218                       // vaddps        %ymm2,%ymm8,%ymm11
  .byte  196,65,124,40,203                   // vmovaps       %ymm11,%ymm9
  .byte  98,114,109,56,186,13,159,132,3,0    // vfmsub231ps   0x3849f(%rip){1to8},%ymm2,%ymm9        # 3a278 <_sk_srcover_bgra_8888_sse2_lowp+0x310>
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  98,209,116,40,194,192,0             // vcmpeqps      %ymm8,%ymm1,%k0
  .byte  98,242,126,40,56,248                // vpmovm2d      %k0,%ymm7
  .byte  98,241,124,56,88,13,143,132,3,0     // vaddps        0x3848f(%rip){1to8},%ymm0,%ymm1        # 3a284 <_sk_srcover_bgra_8888_sse2_lowp+0x31c>
  .byte  196,99,125,8,193,1                  // vroundps      $0x1,%ymm1,%ymm8
  .byte  196,193,116,92,200                  // vsubps        %ymm8,%ymm1,%ymm1
  .byte  98,226,125,40,24,29,126,132,3,0     // vbroadcastss  0x3847e(%rip),%ymm19        # 3a288 <_sk_srcover_bgra_8888_sse2_lowp+0x320>
  .byte  98,241,100,32,194,193,2             // vcmpleps      %ymm1,%ymm19,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  196,65,36,92,241                    // vsubps        %ymm9,%ymm11,%ymm14
  .byte  196,98,125,24,61,79,132,3,0         // vbroadcastss  0x3844f(%rip),%ymm15        # 3a274 <_sk_srcover_bgra_8888_sse2_lowp+0x30c>
  .byte  196,65,116,89,231                   // vmulps        %ymm15,%ymm1,%ymm12
  .byte  98,226,125,40,24,13,72,132,3,0      // vbroadcastss  0x38448(%rip),%ymm17        # 3a27c <_sk_srcover_bgra_8888_sse2_lowp+0x314>
  .byte  98,81,116,32,92,212                 // vsubps        %ymm12,%ymm17,%ymm10
  .byte  196,66,13,168,209                   // vfmadd213ps   %ymm9,%ymm14,%ymm10
  .byte  196,67,45,74,193,128                // vblendvps     %ymm8,%ymm9,%ymm10,%ymm8
  .byte  98,241,124,32,194,193,2             // vcmpleps      %ymm1,%ymm16,%k0
  .byte  98,114,126,40,56,208                // vpmovm2d      %k0,%ymm10
  .byte  196,67,37,74,192,160                // vblendvps     %ymm10,%ymm8,%ymm11,%ymm8
  .byte  196,98,125,24,21,31,132,3,0         // vbroadcastss  0x3841f(%rip),%ymm10        # 3a280 <_sk_srcover_bgra_8888_sse2_lowp+0x318>
  .byte  98,241,44,40,194,193,2              // vcmpleps      %ymm1,%ymm10,%k0
  .byte  98,242,126,40,56,200                // vpmovm2d      %k0,%ymm1
  .byte  196,66,13,168,225                   // vfmadd213ps   %ymm9,%ymm14,%ymm12
  .byte  196,195,29,74,200,16                // vblendvps     %ymm1,%ymm8,%ymm12,%ymm1
  .byte  196,227,117,74,242,112              // vblendvps     %ymm7,%ymm2,%ymm1,%ymm6
  .byte  196,227,125,8,200,1                 // vroundps      $0x1,%ymm0,%ymm1
  .byte  197,252,92,201                      // vsubps        %ymm1,%ymm0,%ymm1
  .byte  98,241,100,32,194,193,2             // vcmpleps      %ymm1,%ymm19,%k0
  .byte  98,114,126,40,56,224                // vpmovm2d      %k0,%ymm12
  .byte  196,65,116,89,239                   // vmulps        %ymm15,%ymm1,%ymm13
  .byte  98,81,116,32,92,197                 // vsubps        %ymm13,%ymm17,%ymm8
  .byte  196,66,13,168,193                   // vfmadd213ps   %ymm9,%ymm14,%ymm8
  .byte  196,67,61,74,193,192                // vblendvps     %ymm12,%ymm9,%ymm8,%ymm8
  .byte  98,241,124,32,194,193,2             // vcmpleps      %ymm1,%ymm16,%k0
  .byte  98,114,126,40,56,224                // vpmovm2d      %k0,%ymm12
  .byte  196,67,37,74,192,192                // vblendvps     %ymm12,%ymm8,%ymm11,%ymm8
  .byte  98,241,44,40,194,193,2              // vcmpleps      %ymm1,%ymm10,%k0
  .byte  98,242,126,40,56,200                // vpmovm2d      %k0,%ymm1
  .byte  196,66,13,168,233                   // vfmadd213ps   %ymm9,%ymm14,%ymm13
  .byte  196,195,21,74,200,16                // vblendvps     %ymm1,%ymm8,%ymm13,%ymm1
  .byte  196,227,117,74,202,112              // vblendvps     %ymm7,%ymm2,%ymm1,%ymm1
  .byte  98,241,124,56,88,5,165,131,3,0      // vaddps        0x383a5(%rip){1to8},%ymm0,%ymm0        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  196,99,125,8,192,1                  // vroundps      $0x1,%ymm0,%ymm8
  .byte  196,193,124,92,192                  // vsubps        %ymm8,%ymm0,%ymm0
  .byte  98,241,100,32,194,192,2             // vcmpleps      %ymm0,%ymm19,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  196,65,124,89,231                   // vmulps        %ymm15,%ymm0,%ymm12
  .byte  98,81,116,32,92,236                 // vsubps        %ymm12,%ymm17,%ymm13
  .byte  196,66,13,168,233                   // vfmadd213ps   %ymm9,%ymm14,%ymm13
  .byte  196,67,21,74,193,128                // vblendvps     %ymm8,%ymm9,%ymm13,%ymm8
  .byte  98,241,124,32,194,192,2             // vcmpleps      %ymm0,%ymm16,%k0
  .byte  98,114,126,40,56,232                // vpmovm2d      %k0,%ymm13
  .byte  196,67,37,74,192,208                // vblendvps     %ymm13,%ymm8,%ymm11,%ymm8
  .byte  98,241,44,40,194,192,2              // vcmpleps      %ymm0,%ymm10,%k0
  .byte  98,242,126,40,56,192                // vpmovm2d      %k0,%ymm0
  .byte  196,66,13,184,204                   // vfmadd231ps   %ymm12,%ymm14,%ymm9
  .byte  196,195,53,74,192,0                 // vblendvps     %ymm0,%ymm8,%ymm9,%ymm0
  .byte  196,227,125,74,210,112              // vblendvps     %ymm7,%ymm2,%ymm0,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,198                      // vmovaps       %ymm6,%ymm0
  .byte  98,177,124,40,40,244                // vmovaps       %ymm20,%ymm6
  .byte  98,177,124,40,40,250                // vmovaps       %ymm18,%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_1_float_skx
.globl _sk_scale_1_float_skx
FUNCTION(_sk_scale_1_float_skx)
_sk_scale_1_float_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_u8_skx
.globl _sk_scale_u8_skx
FUNCTION(_sk_scale_u8_skx)
_sk_scale_u8_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,54                              // jne           1fc3 <_sk_scale_u8_skx+0x4e>
  .byte  196,2,121,48,4,24                   // vpmovzxbw     (%r8,%r11,1),%xmm8
  .byte  197,57,219,5,85,139,3,0             // vpand         0x38b55(%rip),%xmm8,%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,66,125,51,192                   // vpmovzxwd     %xmm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  98,113,60,56,89,5,225,130,3,0       // vmulps        0x382e1(%rip){1to8},%ymm8,%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,186                             // ja            1f93 <_sk_scale_u8_skx+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,140,0,0,0                 // lea           0x8c(%rip),%r10        # 2070 <_sk_scale_u8_skx+0xfb>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  235,155                             // jmp           1f93 <_sk_scale_u8_skx+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  197,57,196,192,2                    // vpinsrw       $0x2,%eax,%xmm8,%xmm8
  .byte  196,2,121,50,12,24                  // vpmovzxbq     (%r8,%r11,1),%xmm9
  .byte  196,65,121,112,201,232              // vpshufd       $0xe8,%xmm9,%xmm9
  .byte  196,65,123,112,201,232              // vpshuflw      $0xe8,%xmm9,%xmm9
  .byte  196,67,57,2,193,1                   // vpblendd      $0x1,%xmm9,%xmm8,%xmm8
  .byte  233,110,255,255,255                 // jmpq          1f93 <_sk_scale_u8_skx+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  197,57,196,192,6                    // vpinsrw       $0x6,%eax,%xmm8,%xmm8
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,57,196,192,5                    // vpinsrw       $0x5,%eax,%xmm8,%xmm8
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,57,196,192,4                    // vpinsrw       $0x4,%eax,%xmm8,%xmm8
  .byte  196,2,121,49,12,24                  // vpmovzxbd     (%r8,%r11,1),%xmm9
  .byte  196,65,123,112,201,232              // vpshuflw      $0xe8,%xmm9,%xmm9
  .byte  196,65,122,112,201,232              // vpshufhw      $0xe8,%xmm9,%xmm9
  .byte  196,65,121,112,201,232              // vpshufd       $0xe8,%xmm9,%xmm9
  .byte  196,67,49,2,192,12                  // vpblendd      $0xc,%xmm8,%xmm9,%xmm8
  .byte  233,37,255,255,255                  // jmpq          1f93 <_sk_scale_u8_skx+0x1e>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  125,255                             // jge           2071 <_sk_scale_u8_skx+0xfc>
  .byte  255                                 // (bad)
  .byte  255,152,255,255,255,136             // lcall         *-0x77000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  219,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,197                             // inc           %ebp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  181,255                             // mov           $0xff,%ch
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_scale_565_skx
.globl _sk_scale_565_skx
FUNCTION(_sk_scale_565_skx)
_sk_scale_565_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,145,0,0,0                    // jne           213c <_sk_scale_565_skx+0xb0>
  .byte  196,1,122,111,4,88                  // vmovdqu       (%r8,%r11,2),%xmm8
  .byte  196,66,125,51,192                   // vpmovzxwd     %xmm8,%ymm8
  .byte  98,113,61,56,219,13,212,129,3,0     // vpandd        0x381d4(%rip){1to8},%ymm8,%ymm9        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  196,65,124,91,201                   // vcvtdq2ps     %ymm9,%ymm9
  .byte  98,113,52,56,89,13,201,129,3,0      // vmulps        0x381c9(%rip){1to8},%ymm9,%ymm9        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  98,113,61,56,219,21,195,129,3,0     // vpandd        0x381c3(%rip){1to8},%ymm8,%ymm10        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  196,65,124,91,210                   // vcvtdq2ps     %ymm10,%ymm10
  .byte  98,113,44,56,89,21,184,129,3,0      // vmulps        0x381b8(%rip){1to8},%ymm10,%ymm10        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  98,113,61,56,219,5,178,129,3,0      // vpandd        0x381b2(%rip){1to8},%ymm8,%ymm8        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  98,113,60,56,89,5,167,129,3,0       // vmulps        0x381a7(%rip){1to8},%ymm8,%ymm8        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  98,241,100,40,194,199,1             // vcmpltps      %ymm7,%ymm3,%k0
  .byte  98,114,126,40,56,216                // vpmovm2d      %k0,%ymm11
  .byte  196,65,44,93,224                    // vminps        %ymm8,%ymm10,%ymm12
  .byte  196,65,52,93,228                    // vminps        %ymm12,%ymm9,%ymm12
  .byte  196,65,44,95,232                    // vmaxps        %ymm8,%ymm10,%ymm13
  .byte  196,65,52,95,237                    // vmaxps        %ymm13,%ymm9,%ymm13
  .byte  196,67,21,74,220,176                // vblendvps     %ymm11,%ymm12,%ymm13,%ymm11
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  197,172,89,201                      // vmulps        %ymm1,%ymm10,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,164,89,219                      // vmulps        %ymm3,%ymm11,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,91,255,255,255               // ja            20b1 <_sk_scale_565_skx+0x25>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,131,0,0,0                 // lea           0x83(%rip),%r10        # 21e4 <_sk_scale_565_skx+0x158>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  233,57,255,255,255                  // jmpq          20b1 <_sk_scale_565_skx+0x25>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,1,57,196,68,88,4,2              // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,2,121,52,12,88                  // vpmovzxwq     (%r8,%r11,2),%xmm9
  .byte  196,65,121,112,201,232              // vpshufd       $0xe8,%xmm9,%xmm9
  .byte  196,65,123,112,201,232              // vpshuflw      $0xe8,%xmm9,%xmm9
  .byte  196,67,57,2,193,1                   // vpblendd      $0x1,%xmm9,%xmm8,%xmm8
  .byte  233,15,255,255,255                  // jmpq          20b1 <_sk_scale_565_skx+0x25>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,1,57,196,68,88,12,6             // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,57,196,68,88,10,5             // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,57,196,68,88,8,4              // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,2,121,51,12,88                  // vpmovzxwd     (%r8,%r11,2),%xmm9
  .byte  196,65,123,112,201,232              // vpshuflw      $0xe8,%xmm9,%xmm9
  .byte  196,65,122,112,201,232              // vpshufhw      $0xe8,%xmm9,%xmm9
  .byte  196,65,121,112,201,132              // vpshufd       $0x84,%xmm9,%xmm9
  .byte  196,65,49,109,192                   // vpunpckhqdq   %xmm8,%xmm9,%xmm8
  .byte  233,208,254,255,255                 // jmpq          20b1 <_sk_scale_565_skx+0x25>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  134,255                             // xchg          %bh,%bh
  .byte  255                                 // (bad)
  .byte  255,161,255,255,255,148             // jmpq          *-0x6b000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  219,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,211                             // callq         *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,203                             // dec           %ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  190                                 // .byte         0xbe
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_lerp_1_float_skx
.globl _sk_lerp_1_float_skx
FUNCTION(_sk_lerp_1_float_skx)
_sk_lerp_1_float_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  196,226,61,168,196                  // vfmadd213ps   %ymm4,%ymm8,%ymm0
  .byte  197,244,92,205                      // vsubps        %ymm5,%ymm1,%ymm1
  .byte  196,226,61,168,205                  // vfmadd213ps   %ymm5,%ymm8,%ymm1
  .byte  197,236,92,214                      // vsubps        %ymm6,%ymm2,%ymm2
  .byte  196,226,61,168,214                  // vfmadd213ps   %ymm6,%ymm8,%ymm2
  .byte  197,228,92,223                      // vsubps        %ymm7,%ymm3,%ymm3
  .byte  196,226,61,168,223                  // vfmadd213ps   %ymm7,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lerp_u8_skx
.globl _sk_lerp_u8_skx
FUNCTION(_sk_lerp_u8_skx)
_sk_lerp_u8_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,74                              // jne           2291 <_sk_lerp_u8_skx+0x62>
  .byte  196,2,121,48,4,24                   // vpmovzxbw     (%r8,%r11,1),%xmm8
  .byte  197,57,219,5,155,136,3,0            // vpand         0x3889b(%rip),%xmm8,%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,66,125,51,192                   // vpmovzxwd     %xmm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  98,113,60,56,89,5,39,128,3,0        // vmulps        0x38027(%rip){1to8},%ymm8,%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  196,226,61,168,196                  // vfmadd213ps   %ymm4,%ymm8,%ymm0
  .byte  197,244,92,205                      // vsubps        %ymm5,%ymm1,%ymm1
  .byte  196,226,61,168,205                  // vfmadd213ps   %ymm5,%ymm8,%ymm1
  .byte  197,236,92,214                      // vsubps        %ymm6,%ymm2,%ymm2
  .byte  196,226,61,168,214                  // vfmadd213ps   %ymm6,%ymm8,%ymm2
  .byte  197,228,92,223                      // vsubps        %ymm7,%ymm3,%ymm3
  .byte  196,226,61,168,223                  // vfmadd213ps   %ymm7,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,166                             // ja            224d <_sk_lerp_u8_skx+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,138,0,0,0                 // lea           0x8a(%rip),%r10        # 233c <_sk_lerp_u8_skx+0x10d>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  235,135                             // jmp           224d <_sk_lerp_u8_skx+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  197,57,196,192,2                    // vpinsrw       $0x2,%eax,%xmm8,%xmm8
  .byte  196,2,121,50,12,24                  // vpmovzxbq     (%r8,%r11,1),%xmm9
  .byte  196,65,121,112,201,232              // vpshufd       $0xe8,%xmm9,%xmm9
  .byte  196,65,123,112,201,232              // vpshuflw      $0xe8,%xmm9,%xmm9
  .byte  196,67,57,2,193,1                   // vpblendd      $0x1,%xmm9,%xmm8,%xmm8
  .byte  233,90,255,255,255                  // jmpq          224d <_sk_lerp_u8_skx+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  197,57,196,192,6                    // vpinsrw       $0x6,%eax,%xmm8,%xmm8
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,57,196,192,5                    // vpinsrw       $0x5,%eax,%xmm8,%xmm8
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,57,196,192,4                    // vpinsrw       $0x4,%eax,%xmm8,%xmm8
  .byte  196,2,121,49,12,24                  // vpmovzxbd     (%r8,%r11,1),%xmm9
  .byte  196,65,123,112,201,232              // vpshuflw      $0xe8,%xmm9,%xmm9
  .byte  196,65,122,112,201,232              // vpshufhw      $0xe8,%xmm9,%xmm9
  .byte  196,65,121,112,201,232              // vpshufd       $0xe8,%xmm9,%xmm9
  .byte  196,67,49,2,192,12                  // vpblendd      $0xc,%xmm8,%xmm9,%xmm8
  .byte  233,17,255,255,255                  // jmpq          224d <_sk_lerp_u8_skx+0x1e>
  .byte  127,255                             // jg            233d <_sk_lerp_u8_skx+0x10e>
  .byte  255                                 // (bad)
  .byte  255,154,255,255,255,138             // lcall         *-0x75000001(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  221,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  183,255                             // mov           $0xff,%bh
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_lerp_565_skx
.globl _sk_lerp_565_skx
FUNCTION(_sk_lerp_565_skx)
_sk_lerp_565_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,165,0,0,0                    // jne           241c <_sk_lerp_565_skx+0xc4>
  .byte  196,1,122,111,4,88                  // vmovdqu       (%r8,%r11,2),%xmm8
  .byte  196,66,125,51,192                   // vpmovzxwd     %xmm8,%ymm8
  .byte  98,113,61,56,219,13,8,127,3,0       // vpandd        0x37f08(%rip){1to8},%ymm8,%ymm9        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  196,65,124,91,201                   // vcvtdq2ps     %ymm9,%ymm9
  .byte  98,113,52,56,89,13,253,126,3,0      // vmulps        0x37efd(%rip){1to8},%ymm9,%ymm9        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  98,113,61,56,219,21,247,126,3,0     // vpandd        0x37ef7(%rip){1to8},%ymm8,%ymm10        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  196,65,124,91,210                   // vcvtdq2ps     %ymm10,%ymm10
  .byte  98,113,44,56,89,21,236,126,3,0      // vmulps        0x37eec(%rip){1to8},%ymm10,%ymm10        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  98,113,61,56,219,5,230,126,3,0      // vpandd        0x37ee6(%rip){1to8},%ymm8,%ymm8        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  98,113,60,56,89,5,219,126,3,0       // vmulps        0x37edb(%rip){1to8},%ymm8,%ymm8        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  98,241,100,40,194,199,1             // vcmpltps      %ymm7,%ymm3,%k0
  .byte  98,114,126,40,56,216                // vpmovm2d      %k0,%ymm11
  .byte  196,65,44,93,224                    // vminps        %ymm8,%ymm10,%ymm12
  .byte  196,65,52,93,228                    // vminps        %ymm12,%ymm9,%ymm12
  .byte  196,65,44,95,232                    // vmaxps        %ymm8,%ymm10,%ymm13
  .byte  196,65,52,95,237                    // vmaxps        %ymm13,%ymm9,%ymm13
  .byte  196,67,21,74,220,176                // vblendvps     %ymm11,%ymm12,%ymm13,%ymm11
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  196,226,53,168,196                  // vfmadd213ps   %ymm4,%ymm9,%ymm0
  .byte  197,244,92,205                      // vsubps        %ymm5,%ymm1,%ymm1
  .byte  196,226,45,168,205                  // vfmadd213ps   %ymm5,%ymm10,%ymm1
  .byte  197,236,92,214                      // vsubps        %ymm6,%ymm2,%ymm2
  .byte  196,226,61,168,214                  // vfmadd213ps   %ymm6,%ymm8,%ymm2
  .byte  197,228,92,223                      // vsubps        %ymm7,%ymm3,%ymm3
  .byte  196,226,37,168,223                  // vfmadd213ps   %ymm7,%ymm11,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,71,255,255,255               // ja            237d <_sk_lerp_565_skx+0x25>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,131,0,0,0                 // lea           0x83(%rip),%r10        # 24c4 <_sk_lerp_565_skx+0x16c>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  233,37,255,255,255                  // jmpq          237d <_sk_lerp_565_skx+0x25>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,1,57,196,68,88,4,2              // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,2,121,52,12,88                  // vpmovzxwq     (%r8,%r11,2),%xmm9
  .byte  196,65,121,112,201,232              // vpshufd       $0xe8,%xmm9,%xmm9
  .byte  196,65,123,112,201,232              // vpshuflw      $0xe8,%xmm9,%xmm9
  .byte  196,67,57,2,193,1                   // vpblendd      $0x1,%xmm9,%xmm8,%xmm8
  .byte  233,251,254,255,255                 // jmpq          237d <_sk_lerp_565_skx+0x25>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,1,57,196,68,88,12,6             // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,57,196,68,88,10,5             // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,57,196,68,88,8,4              // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,2,121,51,12,88                  // vpmovzxwd     (%r8,%r11,2),%xmm9
  .byte  196,65,123,112,201,232              // vpshuflw      $0xe8,%xmm9,%xmm9
  .byte  196,65,122,112,201,232              // vpshufhw      $0xe8,%xmm9,%xmm9
  .byte  196,65,121,112,201,132              // vpshufd       $0x84,%xmm9,%xmm9
  .byte  196,65,49,109,192                   // vpunpckhqdq   %xmm8,%xmm9,%xmm8
  .byte  233,188,254,255,255                 // jmpq          237d <_sk_lerp_565_skx+0x25>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  134,255                             // xchg          %bh,%bh
  .byte  255                                 // (bad)
  .byte  255,161,255,255,255,148             // jmpq          *-0x6b000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  219,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,211                             // callq         *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,203                             // dec           %ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  190                                 // .byte         0xbe
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_tables_skx
.globl _sk_load_tables_skx
FUNCTION(_sk_load_tables_skx)
_sk_load_tables_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,124                             // jne           2566 <_sk_load_tables_skx+0x86>
  .byte  196,193,126,111,28,144              // vmovdqu       (%r8,%rdx,4),%ymm3
  .byte  65,184,17,17,17,17                  // mov           $0x11111111,%r8d
  .byte  196,193,123,146,200                 // kmovd         %r8d,%k1
  .byte  98,241,127,169,111,203              // vmovdqu8      %ymm3,%ymm1{%k1}{z}
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,194,109,146,4,136               // vgatherdps    %ymm2,(%r8,%ymm1,4),%ymm0
  .byte  197,245,114,211,8                   // vpsrld        $0x8,%ymm3,%ymm1
  .byte  98,241,127,169,111,209              // vmovdqu8      %ymm1,%ymm2{%k1}{z}
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,194,61,146,12,145               // vgatherdps    %ymm8,(%r9,%ymm2,4),%ymm1
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  72,139,64,24                        // mov           0x18(%rax),%rax
  .byte  197,181,114,211,16                  // vpsrld        $0x10,%ymm3,%ymm9
  .byte  98,81,127,169,111,201               // vmovdqu8      %ymm9,%ymm9{%k1}{z}
  .byte  196,162,61,146,20,136               // vgatherdps    %ymm8,(%rax,%ymm9,4),%ymm2
  .byte  197,229,114,211,24                  // vpsrld        $0x18,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  98,241,100,56,89,29,46,125,3,0      // vmulps        0x37d2e(%rip){1to8},%ymm3,%ymm3        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,229,239,219                     // vpxor         %ymm3,%ymm3,%ymm3
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,113,255,255,255              // ja            24f0 <_sk_load_tables_skx+0x10>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,142,0,0,0                 // lea           0x8e(%rip),%r10        # 2618 <_sk_load_tables_skx+0x138>
  .byte  79,99,12,138                        // movslq        (%r10,%r9,4),%r9
  .byte  77,1,209                            // add           %r10,%r9
  .byte  65,255,225                          // jmpq          *%r9
  .byte  196,193,121,110,28,144              // vmovd         (%r8,%rdx,4),%xmm3
  .byte  233,81,255,255,255                  // jmpq          24f0 <_sk_load_tables_skx+0x10>
  .byte  196,193,121,110,68,144,8            // vmovd         0x8(%r8,%rdx,4),%xmm0
  .byte  65,177,4                            // mov           $0x4,%r9b
  .byte  196,193,123,146,201                 // kmovd         %r9d,%k1
  .byte  98,242,125,169,137,216              // vpexpandd     %ymm0,%ymm3{%k1}{z}
  .byte  196,194,121,53,4,144                // vpmovzxdq     (%r8,%rdx,4),%xmm0
  .byte  197,249,112,192,232                 // vpshufd       $0xe8,%xmm0,%xmm0
  .byte  196,227,101,2,216,3                 // vpblendd      $0x3,%ymm0,%ymm3,%ymm3
  .byte  233,38,255,255,255                  // jmpq          24f0 <_sk_load_tables_skx+0x10>
  .byte  196,193,121,110,68,144,24           // vmovd         0x18(%r8,%rdx,4),%xmm0
  .byte  65,177,64                           // mov           $0x40,%r9b
  .byte  196,193,123,146,201                 // kmovd         %r9d,%k1
  .byte  98,242,125,169,137,216              // vpexpandd     %ymm0,%ymm3{%k1}{z}
  .byte  196,227,125,57,216,1                // vextracti128  $0x1,%ymm3,%xmm0
  .byte  196,195,121,34,68,144,20,1          // vpinsrd       $0x1,0x14(%r8,%rdx,4),%xmm0,%xmm0
  .byte  196,227,101,56,216,1                // vinserti128   $0x1,%xmm0,%ymm3,%ymm3
  .byte  196,227,125,57,216,1                // vextracti128  $0x1,%ymm3,%xmm0
  .byte  196,195,121,34,68,144,16,0          // vpinsrd       $0x0,0x10(%r8,%rdx,4),%xmm0,%xmm0
  .byte  196,227,101,56,216,1                // vinserti128   $0x1,%xmm0,%ymm3,%ymm3
  .byte  196,193,122,111,4,144               // vmovdqu       (%r8,%rdx,4),%xmm0
  .byte  196,227,125,2,219,240               // vpblendd      $0xf0,%ymm3,%ymm0,%ymm3
  .byte  233,216,254,255,255                 // jmpq          24f0 <_sk_load_tables_skx+0x10>
  .byte  124,255                             // jl            2619 <_sk_load_tables_skx+0x139>
  .byte  255                                 // (bad)
  .byte  255,156,255,255,255,135,255         // lcall         *-0x780001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  239                                 // out           %eax,(%dx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  219,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  178,255                             // mov           $0xff,%dl
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_tables_u16_be_skx
.globl _sk_load_tables_u16_be_skx
FUNCTION(_sk_load_tables_u16_be_skx)
_sk_load_tables_u16_be_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  76,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,210,0,0,0                    // jne           271c <_sk_load_tables_u16_be_skx+0xe8>
  .byte  196,1,121,16,4,72                   // vmovupd       (%r8,%r9,2),%xmm8
  .byte  196,129,121,16,84,72,16             // vmovupd       0x10(%r8,%r9,2),%xmm2
  .byte  196,129,121,16,92,72,32             // vmovupd       0x20(%r8,%r9,2),%xmm3
  .byte  196,1,122,111,76,72,48              // vmovdqu       0x30(%r8,%r9,2),%xmm9
  .byte  197,185,97,194                      // vpunpcklwd    %xmm2,%xmm8,%xmm0
  .byte  197,185,105,210                     // vpunpckhwd    %xmm2,%xmm8,%xmm2
  .byte  196,193,97,97,201                   // vpunpcklwd    %xmm9,%xmm3,%xmm1
  .byte  196,193,97,105,217                  // vpunpckhwd    %xmm9,%xmm3,%xmm3
  .byte  197,121,97,194                      // vpunpcklwd    %xmm2,%xmm0,%xmm8
  .byte  197,121,105,202                     // vpunpckhwd    %xmm2,%xmm0,%xmm9
  .byte  197,241,97,195                      // vpunpcklwd    %xmm3,%xmm1,%xmm0
  .byte  197,113,105,219                     // vpunpckhwd    %xmm3,%xmm1,%xmm11
  .byte  197,185,108,200                     // vpunpcklqdq   %xmm0,%xmm8,%xmm1
  .byte  197,57,109,192                      // vpunpckhqdq   %xmm0,%xmm8,%xmm8
  .byte  197,121,111,21,89,132,3,0           // vmovdqa       0x38459(%rip),%xmm10        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,193,113,219,194                 // vpand         %xmm10,%xmm1,%xmm0
  .byte  196,226,125,51,200                  // vpmovzxwd     %xmm0,%ymm1
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  196,194,109,146,4,136               // vgatherdps    %ymm2,(%r8,%ymm1,4),%ymm0
  .byte  196,193,49,108,219                  // vpunpcklqdq   %xmm11,%xmm9,%xmm3
  .byte  196,65,29,118,228                   // vpcmpeqd      %ymm12,%ymm12,%ymm12
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,193,57,219,202                  // vpand         %xmm10,%xmm8,%xmm1
  .byte  196,98,125,51,193                   // vpmovzxwd     %xmm1,%ymm8
  .byte  196,65,21,118,237                   // vpcmpeqd      %ymm13,%ymm13,%ymm13
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,130,21,146,12,129               // vgatherdps    %ymm13,(%r9,%ymm8,4),%ymm1
  .byte  72,139,64,24                        // mov           0x18(%rax),%rax
  .byte  196,193,97,219,218                  // vpand         %xmm10,%xmm3,%xmm3
  .byte  196,226,125,51,219                  // vpmovzxwd     %xmm3,%ymm3
  .byte  196,226,29,146,20,152               // vgatherdps    %ymm12,(%rax,%ymm3,4),%ymm2
  .byte  196,193,49,109,219                  // vpunpckhqdq   %xmm11,%xmm9,%xmm3
  .byte  197,185,113,243,8                   // vpsllw        $0x8,%xmm3,%xmm8
  .byte  197,225,113,211,8                   // vpsrlw        $0x8,%xmm3,%xmm3
  .byte  197,185,235,219                     // vpor          %xmm3,%xmm8,%xmm3
  .byte  196,226,125,51,219                  // vpmovzxwd     %xmm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  98,241,100,56,89,29,148,123,3,0     // vmulps        0x37b94(%rip){1to8},%ymm3,%ymm3        # 3a2ac <_sk_srcover_bgra_8888_sse2_lowp+0x344>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,123,16,4,72                   // vmovsd        (%r8,%r9,2),%xmm8
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,85                              // je            2782 <_sk_load_tables_u16_be_skx+0x14e>
  .byte  196,1,57,22,68,72,8                 // vmovhpd       0x8(%r8,%r9,2),%xmm8,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,72                              // jb            2782 <_sk_load_tables_u16_be_skx+0x14e>
  .byte  196,129,123,16,84,72,16             // vmovsd        0x10(%r8,%r9,2),%xmm2
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  116,72                              // je            278f <_sk_load_tables_u16_be_skx+0x15b>
  .byte  196,129,105,22,84,72,24             // vmovhpd       0x18(%r8,%r9,2),%xmm2,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,59                              // jb            278f <_sk_load_tables_u16_be_skx+0x15b>
  .byte  196,129,123,16,92,72,32             // vmovsd        0x20(%r8,%r9,2),%xmm3
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  15,132,0,255,255,255                // je            2665 <_sk_load_tables_u16_be_skx+0x31>
  .byte  196,129,97,22,92,72,40              // vmovhpd       0x28(%r8,%r9,2),%xmm3,%xmm3
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,130,239,254,255,255              // jb            2665 <_sk_load_tables_u16_be_skx+0x31>
  .byte  196,1,122,126,76,72,48              // vmovq         0x30(%r8,%r9,2),%xmm9
  .byte  233,227,254,255,255                 // jmpq          2665 <_sk_load_tables_u16_be_skx+0x31>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  197,233,87,210                      // vxorpd        %xmm2,%xmm2,%xmm2
  .byte  233,214,254,255,255                 // jmpq          2665 <_sk_load_tables_u16_be_skx+0x31>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  233,205,254,255,255                 // jmpq          2665 <_sk_load_tables_u16_be_skx+0x31>

HIDDEN _sk_load_tables_rgb_u16_be_skx
.globl _sk_load_tables_rgb_u16_be_skx
FUNCTION(_sk_load_tables_rgb_u16_be_skx)
_sk_load_tables_rgb_u16_be_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  76,141,12,82                        // lea           (%rdx,%rdx,2),%r9
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,203,0,0,0                    // jne           2875 <_sk_load_tables_rgb_u16_be_skx+0xdd>
  .byte  196,1,121,16,28,72                  // vmovupd       (%r8,%r9,2),%xmm11
  .byte  196,129,121,16,92,72,12             // vmovupd       0xc(%r8,%r9,2),%xmm3
  .byte  196,129,121,16,84,72,24             // vmovupd       0x18(%r8,%r9,2),%xmm2
  .byte  98,145,125,8,115,92,72,2,4          // vpsrldq       $0x4,0x20(%r8,%r9,2),%xmm0
  .byte  196,193,57,115,219,6                // vpsrldq       $0x6,%xmm11,%xmm8
  .byte  197,169,115,219,6                   // vpsrldq       $0x6,%xmm3,%xmm10
  .byte  197,241,115,218,6                   // vpsrldq       $0x6,%xmm2,%xmm1
  .byte  197,177,115,216,6                   // vpsrldq       $0x6,%xmm0,%xmm9
  .byte  196,193,113,97,201                  // vpunpcklwd    %xmm9,%xmm1,%xmm1
  .byte  197,233,97,192                      // vpunpcklwd    %xmm0,%xmm2,%xmm0
  .byte  196,193,57,97,210                   // vpunpcklwd    %xmm10,%xmm8,%xmm2
  .byte  197,161,97,219                      // vpunpcklwd    %xmm3,%xmm11,%xmm3
  .byte  197,97,97,194                       // vpunpcklwd    %xmm2,%xmm3,%xmm8
  .byte  197,225,105,210                     // vpunpckhwd    %xmm2,%xmm3,%xmm2
  .byte  197,249,97,217                      // vpunpcklwd    %xmm1,%xmm0,%xmm3
  .byte  197,249,105,193                     // vpunpckhwd    %xmm1,%xmm0,%xmm0
  .byte  197,105,108,200                     // vpunpcklqdq   %xmm0,%xmm2,%xmm9
  .byte  197,185,108,195                     // vpunpcklqdq   %xmm3,%xmm8,%xmm0
  .byte  197,121,111,21,226,130,3,0          // vmovdqa       0x382e2(%rip),%xmm10        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,193,121,219,194                 // vpand         %xmm10,%xmm0,%xmm0
  .byte  196,226,125,51,200                  // vpmovzxwd     %xmm0,%ymm1
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,194,109,146,4,136               // vgatherdps    %ymm2,(%r8,%ymm1,4),%ymm0
  .byte  197,185,109,203                     // vpunpckhqdq   %xmm3,%xmm8,%xmm1
  .byte  196,65,29,118,228                   // vpcmpeqd      %ymm12,%ymm12,%ymm12
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,193,113,219,202                 // vpand         %xmm10,%xmm1,%xmm1
  .byte  196,98,125,51,193                   // vpmovzxwd     %xmm1,%ymm8
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,65,37,118,219                   // vpcmpeqd      %ymm11,%ymm11,%ymm11
  .byte  196,130,37,146,12,129               // vgatherdps    %ymm11,(%r9,%ymm8,4),%ymm1
  .byte  72,139,64,24                        // mov           0x18(%rax),%rax
  .byte  196,193,49,219,218                  // vpand         %xmm10,%xmm9,%xmm3
  .byte  196,226,125,51,219                  // vpmovzxwd     %xmm3,%ymm3
  .byte  196,226,29,146,20,152               // vgatherdps    %ymm12,(%rax,%ymm3,4),%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,165,121,3,0       // vbroadcastss  0x379a5(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,4,72                // vmovd         (%r8,%r9,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,1,121,196,92,72,4,2             // vpinsrw       $0x2,0x4(%r8,%r9,2),%xmm0,%xmm11
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,31                              // jne           28ad <_sk_load_tables_rgb_u16_be_skx+0x115>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  197,225,239,219                     // vpxor         %xmm3,%xmm3,%xmm3
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  233,47,255,255,255                  // jmpq          27dc <_sk_load_tables_rgb_u16_be_skx+0x44>
  .byte  196,129,121,110,68,72,6             // vmovd         0x6(%r8,%r9,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,1,121,196,68,72,10,2            // vpinsrw       $0x2,0xa(%r8,%r9,2),%xmm0,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,48                              // jb            28f7 <_sk_load_tables_rgb_u16_be_skx+0x15f>
  .byte  196,129,121,110,68,72,12            // vmovd         0xc(%r8,%r9,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,129,121,196,92,72,16,2          // vpinsrw       $0x2,0x10(%r8,%r9,2),%xmm0,%xmm3
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  117,48                              // jne           2911 <_sk_load_tables_rgb_u16_be_skx+0x179>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  233,229,254,255,255                 // jmpq          27dc <_sk_load_tables_rgb_u16_be_skx+0x44>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  197,225,239,219                     // vpxor         %xmm3,%xmm3,%xmm3
  .byte  233,203,254,255,255                 // jmpq          27dc <_sk_load_tables_rgb_u16_be_skx+0x44>
  .byte  196,129,121,110,68,72,18            // vmovd         0x12(%r8,%r9,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,1,121,196,84,72,22,2            // vpinsrw       $0x2,0x16(%r8,%r9,2),%xmm0,%xmm10
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,39                              // jb            2952 <_sk_load_tables_rgb_u16_be_skx+0x1ba>
  .byte  196,129,121,110,68,72,24            // vmovd         0x18(%r8,%r9,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,129,121,196,84,72,28,2          // vpinsrw       $0x2,0x1c(%r8,%r9,2),%xmm0,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  117,30                              // jne           2963 <_sk_load_tables_rgb_u16_be_skx+0x1cb>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  233,138,254,255,255                 // jmpq          27dc <_sk_load_tables_rgb_u16_be_skx+0x44>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  233,121,254,255,255                 // jmpq          27dc <_sk_load_tables_rgb_u16_be_skx+0x44>
  .byte  196,129,121,110,68,72,30            // vmovd         0x1e(%r8,%r9,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,129,121,196,76,72,34,2          // vpinsrw       $0x2,0x22(%r8,%r9,2),%xmm0,%xmm1
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,25                              // jb            2996 <_sk_load_tables_rgb_u16_be_skx+0x1fe>
  .byte  196,129,121,110,68,72,36            // vmovd         0x24(%r8,%r9,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,129,121,196,68,72,40,2          // vpinsrw       $0x2,0x28(%r8,%r9,2),%xmm0,%xmm0
  .byte  233,70,254,255,255                  // jmpq          27dc <_sk_load_tables_rgb_u16_be_skx+0x44>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  233,61,254,255,255                  // jmpq          27dc <_sk_load_tables_rgb_u16_be_skx+0x44>

HIDDEN _sk_byte_tables_skx
.globl _sk_byte_tables_skx
FUNCTION(_sk_byte_tables_skx)
_sk_byte_tables_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,98,125,24,29,101,120,3,0        // vbroadcastss  0x37865(%rip),%ymm11        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,211                    // vminps        %ymm11,%ymm9,%ymm10
  .byte  196,98,125,24,13,131,120,3,0        // vbroadcastss  0x37883(%rip),%ymm9        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,65,44,89,209                    // vmulps        %ymm9,%ymm10,%ymm10
  .byte  196,65,125,91,210                   // vcvtps2dq     %ymm10,%ymm10
  .byte  196,65,249,126,208                  // vmovq         %xmm10,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  76,139,16                           // mov           (%rax),%r10
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,193,121,110,193                 // vmovd         %r9d,%xmm0
  .byte  196,67,249,22,209,1                 // vpextrq       $0x1,%xmm10,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,67,121,32,224,1                 // vpinsrb       $0x1,%r8d,%xmm0,%xmm12
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  196,99,125,57,208,1                 // vextracti128  $0x1,%ymm10,%xmm0
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,67,25,32,208,2                  // vpinsrb       $0x2,%r8d,%xmm12,%xmm10
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,41,32,209,3                  // vpinsrb       $0x3,%r9d,%xmm10,%xmm10
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,41,32,209,4                  // vpinsrb       $0x4,%r9d,%xmm10,%xmm10
  .byte  196,195,249,22,193,1                // vpextrq       $0x1,%xmm0,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,195,41,32,192,5                 // vpinsrb       $0x5,%r8d,%xmm10,%xmm0
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,195,121,32,192,6                // vpinsrb       $0x6,%r8d,%xmm0,%xmm0
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,121,32,209,7                 // vpinsrb       $0x7,%r9d,%xmm0,%xmm10
  .byte  197,188,95,193                      // vmaxps        %ymm1,%ymm8,%ymm0
  .byte  196,193,124,93,195                  // vminps        %ymm11,%ymm0,%ymm0
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,253,91,200                      // vcvtps2dq     %ymm0,%ymm1
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,193,121,110,194                 // vmovd         %r10d,%xmm0
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,1                // vpinsrb       $0x1,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,201,1                // vextracti128  $0x1,%ymm1,%xmm1
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,195,121,32,194,3                // vpinsrb       $0x3,%r10d,%xmm0,%xmm0
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,195,121,32,194,4                // vpinsrb       $0x4,%r10d,%xmm0,%xmm0
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,5                // vpinsrb       $0x5,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,6                // vpinsrb       $0x6,%r9d,%xmm0,%xmm0
  .byte  71,15,182,4,16                      // movzbl        (%r8,%r10,1),%r8d
  .byte  196,195,121,32,200,7                // vpinsrb       $0x7,%r8d,%xmm0,%xmm1
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  197,188,95,194                      // vmaxps        %ymm2,%ymm8,%ymm0
  .byte  196,193,124,93,195                  // vminps        %ymm11,%ymm0,%ymm0
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,253,91,208                      // vcvtps2dq     %ymm0,%ymm2
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,193,121,110,194                 // vmovd         %r10d,%xmm0
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,1                // vpinsrb       $0x1,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,210,1                // vextracti128  $0x1,%ymm2,%xmm2
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,195,121,32,194,3                // vpinsrb       $0x3,%r10d,%xmm0,%xmm0
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,195,121,32,194,4                // vpinsrb       $0x4,%r10d,%xmm0,%xmm0
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,5                // vpinsrb       $0x5,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,6                // vpinsrb       $0x6,%r9d,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,182,4,16                      // movzbl        (%r8,%r10,1),%r8d
  .byte  196,195,121,32,208,7                // vpinsrb       $0x7,%r8d,%xmm0,%xmm2
  .byte  76,139,72,24                        // mov           0x18(%rax),%r9
  .byte  197,188,95,195                      // vmaxps        %ymm3,%ymm8,%ymm0
  .byte  196,193,124,93,195                  // vminps        %ymm11,%ymm0,%ymm0
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  197,249,110,216                     // vmovd         %eax,%xmm3
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  67,15,182,4,1                       // movzbl        (%r9,%r8,1),%eax
  .byte  196,227,97,32,216,1                 // vpinsrb       $0x1,%eax,%xmm3,%xmm3
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,97,32,216,2                 // vpinsrb       $0x2,%eax,%xmm3,%xmm3
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  67,15,182,4,17                      // movzbl        (%r9,%r10,1),%eax
  .byte  196,227,97,32,216,3                 // vpinsrb       $0x3,%eax,%xmm3,%xmm3
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,97,32,216,4                 // vpinsrb       $0x4,%eax,%xmm3,%xmm3
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  67,15,182,4,1                       // movzbl        (%r9,%r8,1),%eax
  .byte  196,227,97,32,192,5                 // vpinsrb       $0x5,%eax,%xmm3,%xmm0
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,121,32,216,6                // vpinsrb       $0x6,%eax,%xmm0,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  67,15,182,4,17                      // movzbl        (%r9,%r10,1),%eax
  .byte  196,194,125,49,194                  // vpmovzxbd     %xmm10,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,5,57,118,3,0          // vbroadcastss  0x37639(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  196,226,125,49,201                  // vpmovzxbd     %xmm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  196,226,125,49,210                  // vpmovzxbd     %xmm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  196,227,97,32,216,7                 // vpinsrb       $0x7,%eax,%xmm3,%xmm3
  .byte  196,226,125,49,219                  // vpmovzxbd     %xmm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_byte_tables_rgb_skx
.globl _sk_byte_tables_rgb_skx
FUNCTION(_sk_byte_tables_rgb_skx)
_sk_byte_tables_rgb_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,24                        // mov           0x18(%rax),%r8d
  .byte  65,131,192,255                      // add           $0xffffffff,%r8d
  .byte  98,82,125,40,124,192                // vpbroadcastd  %r8d,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,52,95,208                       // vmaxps        %ymm0,%ymm9,%ymm10
  .byte  196,98,125,24,29,97,117,3,0         // vbroadcastss  0x37561(%rip),%ymm11        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,44,93,211                    // vminps        %ymm11,%ymm10,%ymm10
  .byte  196,65,44,89,208                    // vmulps        %ymm8,%ymm10,%ymm10
  .byte  196,65,125,91,210                   // vcvtps2dq     %ymm10,%ymm10
  .byte  196,65,249,126,208                  // vmovq         %xmm10,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  76,139,16                           // mov           (%rax),%r10
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,193,121,110,193                 // vmovd         %r9d,%xmm0
  .byte  196,67,249,22,209,1                 // vpextrq       $0x1,%xmm10,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,67,121,32,224,1                 // vpinsrb       $0x1,%r8d,%xmm0,%xmm12
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  196,99,125,57,208,1                 // vextracti128  $0x1,%ymm10,%xmm0
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,67,25,32,208,2                  // vpinsrb       $0x2,%r8d,%xmm12,%xmm10
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,41,32,209,3                  // vpinsrb       $0x3,%r9d,%xmm10,%xmm10
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,41,32,209,4                  // vpinsrb       $0x4,%r9d,%xmm10,%xmm10
  .byte  196,195,249,22,193,1                // vpextrq       $0x1,%xmm0,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,195,41,32,192,5                 // vpinsrb       $0x5,%r8d,%xmm10,%xmm0
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,195,121,32,192,6                // vpinsrb       $0x6,%r8d,%xmm0,%xmm0
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,121,32,209,7                 // vpinsrb       $0x7,%r9d,%xmm0,%xmm10
  .byte  197,180,95,193                      // vmaxps        %ymm1,%ymm9,%ymm0
  .byte  196,193,124,93,195                  // vminps        %ymm11,%ymm0,%ymm0
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,253,91,200                      // vcvtps2dq     %ymm0,%ymm1
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,193,121,110,194                 // vmovd         %r10d,%xmm0
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,1                // vpinsrb       $0x1,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,201,1                // vextracti128  $0x1,%ymm1,%xmm1
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,195,121,32,194,3                // vpinsrb       $0x3,%r10d,%xmm0,%xmm0
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,195,121,32,194,4                // vpinsrb       $0x4,%r10d,%xmm0,%xmm0
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,5                // vpinsrb       $0x5,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,6                // vpinsrb       $0x6,%r9d,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,182,4,16                      // movzbl        (%r8,%r10,1),%r8d
  .byte  196,195,121,32,200,7                // vpinsrb       $0x7,%r8d,%xmm0,%xmm1
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  197,180,95,194                      // vmaxps        %ymm2,%ymm9,%ymm0
  .byte  196,193,124,93,195                  // vminps        %ymm11,%ymm0,%ymm0
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  197,249,110,208                     // vmovd         %eax,%xmm2
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  67,15,182,4,1                       // movzbl        (%r9,%r8,1),%eax
  .byte  196,227,105,32,208,1                // vpinsrb       $0x1,%eax,%xmm2,%xmm2
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,105,32,208,2                // vpinsrb       $0x2,%eax,%xmm2,%xmm2
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  67,15,182,4,17                      // movzbl        (%r9,%r10,1),%eax
  .byte  196,227,105,32,208,3                // vpinsrb       $0x3,%eax,%xmm2,%xmm2
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,105,32,208,4                // vpinsrb       $0x4,%eax,%xmm2,%xmm2
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  67,15,182,4,1                       // movzbl        (%r9,%r8,1),%eax
  .byte  196,227,105,32,192,5                // vpinsrb       $0x5,%eax,%xmm2,%xmm0
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,121,32,208,6                // vpinsrb       $0x6,%eax,%xmm0,%xmm2
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  67,15,182,4,17                      // movzbl        (%r9,%r10,1),%eax
  .byte  196,194,125,49,194                  // vpmovzxbd     %xmm10,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,5,229,115,3,0         // vbroadcastss  0x373e5(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  196,226,125,49,201                  // vpmovzxbd     %xmm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  196,227,105,32,208,7                // vpinsrb       $0x7,%eax,%xmm2,%xmm2
  .byte  196,226,125,49,210                  // vpmovzxbd     %xmm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_r_skx
.globl _sk_table_r_skx
FUNCTION(_sk_table_r_skx)
_sk_table_r_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  131,192,255                         // add           $0xffffffff,%eax
  .byte  98,114,125,40,124,192               // vpbroadcastd  %eax,%ymm8
  .byte  196,65,124,91,200                   // vcvtdq2ps     %ymm8,%ymm9
  .byte  196,65,61,239,192                   // vpxor         %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  98,241,124,56,93,5,25,115,3,0       // vminps        0x37319(%rip){1to8},%ymm0,%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,66,53,146,4,128                 // vgatherdps    %ymm9,(%r8,%ymm0,4),%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_g_skx
.globl _sk_table_g_skx
FUNCTION(_sk_table_g_skx)
_sk_table_g_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  131,192,255                         // add           $0xffffffff,%eax
  .byte  98,114,125,40,124,192               // vpbroadcastd  %eax,%ymm8
  .byte  196,65,124,91,200                   // vcvtdq2ps     %ymm8,%ymm9
  .byte  196,65,61,239,192                   // vpxor         %ymm8,%ymm8,%ymm8
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  98,241,116,56,93,13,212,114,3,0     // vminps        0x372d4(%rip){1to8},%ymm1,%ymm1        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,116,89,201                  // vmulps        %ymm9,%ymm1,%ymm1
  .byte  197,253,91,201                      // vcvtps2dq     %ymm1,%ymm1
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,66,53,146,4,136                 // vgatherdps    %ymm9,(%r8,%ymm1,4),%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,193                      // vmovaps       %ymm8,%ymm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_b_skx
.globl _sk_table_b_skx
FUNCTION(_sk_table_b_skx)
_sk_table_b_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  131,192,255                         // add           $0xffffffff,%eax
  .byte  98,114,125,40,124,192               // vpbroadcastd  %eax,%ymm8
  .byte  196,65,124,91,200                   // vcvtdq2ps     %ymm8,%ymm9
  .byte  196,65,61,239,192                   // vpxor         %ymm8,%ymm8,%ymm8
  .byte  197,188,95,210                      // vmaxps        %ymm2,%ymm8,%ymm2
  .byte  98,241,108,56,93,21,143,114,3,0     // vminps        0x3728f(%rip){1to8},%ymm2,%ymm2        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,108,89,209                  // vmulps        %ymm9,%ymm2,%ymm2
  .byte  197,253,91,210                      // vcvtps2dq     %ymm2,%ymm2
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,66,53,146,4,144                 // vgatherdps    %ymm9,(%r8,%ymm2,4),%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,194                      // vmovaps       %ymm8,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_a_skx
.globl _sk_table_a_skx
FUNCTION(_sk_table_a_skx)
_sk_table_a_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  131,192,255                         // add           $0xffffffff,%eax
  .byte  98,114,125,40,124,192               // vpbroadcastd  %eax,%ymm8
  .byte  196,65,124,91,200                   // vcvtdq2ps     %ymm8,%ymm9
  .byte  196,65,61,239,192                   // vpxor         %ymm8,%ymm8,%ymm8
  .byte  197,188,95,219                      // vmaxps        %ymm3,%ymm8,%ymm3
  .byte  98,241,100,56,93,29,74,114,3,0      // vminps        0x3724a(%rip){1to8},%ymm3,%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,100,89,217                  // vmulps        %ymm9,%ymm3,%ymm3
  .byte  197,253,91,219                      // vcvtps2dq     %ymm3,%ymm3
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,66,53,146,4,152                 // vgatherdps    %ymm9,(%r8,%ymm3,4),%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,195                      // vmovaps       %ymm8,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_r_skx
.globl _sk_parametric_r_skx
FUNCTION(_sk_parametric_r_skx)
_sk_parametric_r_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,241,124,56,194,64,4,2            // vcmpleps      0x10(%rax){1to8},%ymm0,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  98,114,125,56,168,72,6              // vfmadd213ps   0x18(%rax){1to8},%ymm0,%ymm9
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  98,114,125,56,168,80,2              // vfmadd213ps   0x8(%rax){1to8},%ymm0,%ymm10
  .byte  196,226,125,24,0                    // vbroadcastss  (%rax),%ymm0
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  98,209,44,40,194,195,0              // vcmpeqps      %ymm11,%ymm10,%k0
  .byte  98,114,126,40,56,224                // vpmovm2d      %k0,%ymm12
  .byte  196,65,124,91,234                   // vcvtdq2ps     %ymm10,%ymm13
  .byte  196,98,125,24,53,119,114,3,0        // vbroadcastss  0x37277(%rip),%ymm14        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  98,114,21,56,168,53,117,114,3,0     // vfmadd213ps   0x37275(%rip){1to8},%ymm13,%ymm14        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  98,113,44,56,84,21,103,114,3,0      // vandps        0x37267(%rip){1to8},%ymm10,%ymm10        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  98,113,44,56,86,21,189,113,3,0      // vorps         0x371bd(%rip){1to8},%ymm10,%ymm10        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  98,114,45,56,188,53,91,114,3,0      // vfnmadd231ps  0x3725b(%rip){1to8},%ymm10,%ymm14        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  98,113,44,56,88,21,85,114,3,0       // vaddps        0x37255(%rip){1to8},%ymm10,%ymm10        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,98,125,24,45,80,114,3,0         // vbroadcastss  0x37250(%rip),%ymm13        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,20,94,210                    // vdivps        %ymm10,%ymm13,%ymm10
  .byte  196,65,12,92,210                    // vsubps        %ymm10,%ymm14,%ymm10
  .byte  196,193,124,89,194                  // vmulps        %ymm10,%ymm0,%ymm0
  .byte  196,99,125,8,208,1                  // vroundps      $0x1,%ymm0,%ymm10
  .byte  196,65,124,92,210                   // vsubps        %ymm10,%ymm0,%ymm10
  .byte  98,241,124,56,88,5,48,114,3,0       // vaddps        0x37230(%rip){1to8},%ymm0,%ymm0        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  98,242,45,56,188,5,42,114,3,0       // vfnmadd231ps  0x3722a(%rip){1to8},%ymm10,%ymm0        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,98,125,24,45,37,114,3,0         // vbroadcastss  0x37225(%rip),%ymm13        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  196,65,20,92,210                    // vsubps        %ymm10,%ymm13,%ymm10
  .byte  196,98,125,24,45,27,114,3,0         // vbroadcastss  0x3721b(%rip),%ymm13        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  196,65,20,94,210                    // vdivps        %ymm10,%ymm13,%ymm10
  .byte  196,193,124,88,194                  // vaddps        %ymm10,%ymm0,%ymm0
  .byte  98,241,124,56,89,5,11,114,3,0       // vmulps        0x3720b(%rip){1to8},%ymm0,%ymm0        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,195,125,74,195,192              // vblendvps     %ymm12,%ymm11,%ymm0,%ymm0
  .byte  196,98,125,24,80,20                 // vbroadcastss  0x14(%rax),%ymm10
  .byte  196,193,124,88,194                  // vaddps        %ymm10,%ymm0,%ymm0
  .byte  196,195,125,74,193,128              // vblendvps     %ymm8,%ymm9,%ymm0,%ymm0
  .byte  196,193,124,95,195                  // vmaxps        %ymm11,%ymm0,%ymm0
  .byte  98,241,124,56,93,5,33,113,3,0       // vminps        0x37121(%rip){1to8},%ymm0,%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_g_skx
.globl _sk_parametric_g_skx
FUNCTION(_sk_parametric_g_skx)
_sk_parametric_g_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,241,116,56,194,64,4,2            // vcmpleps      0x10(%rax){1to8},%ymm1,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  98,114,117,56,168,72,6              // vfmadd213ps   0x18(%rax){1to8},%ymm1,%ymm9
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  98,114,117,56,168,80,2              // vfmadd213ps   0x8(%rax){1to8},%ymm1,%ymm10
  .byte  196,226,125,24,8                    // vbroadcastss  (%rax),%ymm1
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  98,209,44,40,194,195,0              // vcmpeqps      %ymm11,%ymm10,%k0
  .byte  98,114,126,40,56,224                // vpmovm2d      %k0,%ymm12
  .byte  196,65,124,91,234                   // vcvtdq2ps     %ymm10,%ymm13
  .byte  196,98,125,24,53,102,113,3,0        // vbroadcastss  0x37166(%rip),%ymm14        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  98,114,21,56,168,53,100,113,3,0     // vfmadd213ps   0x37164(%rip){1to8},%ymm13,%ymm14        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  98,113,44,56,84,21,86,113,3,0       // vandps        0x37156(%rip){1to8},%ymm10,%ymm10        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  98,113,44,56,86,21,172,112,3,0      // vorps         0x370ac(%rip){1to8},%ymm10,%ymm10        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  98,114,45,56,188,53,74,113,3,0      // vfnmadd231ps  0x3714a(%rip){1to8},%ymm10,%ymm14        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  98,113,44,56,88,21,68,113,3,0       // vaddps        0x37144(%rip){1to8},%ymm10,%ymm10        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,98,125,24,45,63,113,3,0         // vbroadcastss  0x3713f(%rip),%ymm13        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,20,94,210                    // vdivps        %ymm10,%ymm13,%ymm10
  .byte  196,65,12,92,210                    // vsubps        %ymm10,%ymm14,%ymm10
  .byte  196,193,116,89,202                  // vmulps        %ymm10,%ymm1,%ymm1
  .byte  196,99,125,8,209,1                  // vroundps      $0x1,%ymm1,%ymm10
  .byte  196,65,116,92,210                   // vsubps        %ymm10,%ymm1,%ymm10
  .byte  98,241,116,56,88,13,31,113,3,0      // vaddps        0x3711f(%rip){1to8},%ymm1,%ymm1        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  98,242,45,56,188,13,25,113,3,0      // vfnmadd231ps  0x37119(%rip){1to8},%ymm10,%ymm1        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,98,125,24,45,20,113,3,0         // vbroadcastss  0x37114(%rip),%ymm13        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  196,65,20,92,210                    // vsubps        %ymm10,%ymm13,%ymm10
  .byte  196,98,125,24,45,10,113,3,0         // vbroadcastss  0x3710a(%rip),%ymm13        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  196,65,20,94,210                    // vdivps        %ymm10,%ymm13,%ymm10
  .byte  196,193,116,88,202                  // vaddps        %ymm10,%ymm1,%ymm1
  .byte  98,241,116,56,89,13,250,112,3,0     // vmulps        0x370fa(%rip){1to8},%ymm1,%ymm1        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  197,253,91,201                      // vcvtps2dq     %ymm1,%ymm1
  .byte  196,195,117,74,203,192              // vblendvps     %ymm12,%ymm11,%ymm1,%ymm1
  .byte  196,98,125,24,80,20                 // vbroadcastss  0x14(%rax),%ymm10
  .byte  196,193,116,88,202                  // vaddps        %ymm10,%ymm1,%ymm1
  .byte  196,195,117,74,201,128              // vblendvps     %ymm8,%ymm9,%ymm1,%ymm1
  .byte  196,193,116,95,203                  // vmaxps        %ymm11,%ymm1,%ymm1
  .byte  98,241,116,56,93,13,16,112,3,0      // vminps        0x37010(%rip){1to8},%ymm1,%ymm1        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_b_skx
.globl _sk_parametric_b_skx
FUNCTION(_sk_parametric_b_skx)
_sk_parametric_b_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,241,108,56,194,64,4,2            // vcmpleps      0x10(%rax){1to8},%ymm2,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  98,114,109,56,168,72,6              // vfmadd213ps   0x18(%rax){1to8},%ymm2,%ymm9
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  98,114,109,56,168,80,2              // vfmadd213ps   0x8(%rax){1to8},%ymm2,%ymm10
  .byte  196,226,125,24,16                   // vbroadcastss  (%rax),%ymm2
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  98,209,44,40,194,195,0              // vcmpeqps      %ymm11,%ymm10,%k0
  .byte  98,114,126,40,56,224                // vpmovm2d      %k0,%ymm12
  .byte  196,65,124,91,234                   // vcvtdq2ps     %ymm10,%ymm13
  .byte  196,98,125,24,53,85,112,3,0         // vbroadcastss  0x37055(%rip),%ymm14        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  98,114,21,56,168,53,83,112,3,0      // vfmadd213ps   0x37053(%rip){1to8},%ymm13,%ymm14        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  98,113,44,56,84,21,69,112,3,0       // vandps        0x37045(%rip){1to8},%ymm10,%ymm10        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  98,113,44,56,86,21,155,111,3,0      // vorps         0x36f9b(%rip){1to8},%ymm10,%ymm10        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  98,114,45,56,188,53,57,112,3,0      // vfnmadd231ps  0x37039(%rip){1to8},%ymm10,%ymm14        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  98,113,44,56,88,21,51,112,3,0       // vaddps        0x37033(%rip){1to8},%ymm10,%ymm10        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,98,125,24,45,46,112,3,0         // vbroadcastss  0x3702e(%rip),%ymm13        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,20,94,210                    // vdivps        %ymm10,%ymm13,%ymm10
  .byte  196,65,12,92,210                    // vsubps        %ymm10,%ymm14,%ymm10
  .byte  196,193,108,89,210                  // vmulps        %ymm10,%ymm2,%ymm2
  .byte  196,99,125,8,210,1                  // vroundps      $0x1,%ymm2,%ymm10
  .byte  196,65,108,92,210                   // vsubps        %ymm10,%ymm2,%ymm10
  .byte  98,241,108,56,88,21,14,112,3,0      // vaddps        0x3700e(%rip){1to8},%ymm2,%ymm2        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  98,242,45,56,188,21,8,112,3,0       // vfnmadd231ps  0x37008(%rip){1to8},%ymm10,%ymm2        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,98,125,24,45,3,112,3,0          // vbroadcastss  0x37003(%rip),%ymm13        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  196,65,20,92,210                    // vsubps        %ymm10,%ymm13,%ymm10
  .byte  196,98,125,24,45,249,111,3,0        // vbroadcastss  0x36ff9(%rip),%ymm13        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  196,65,20,94,210                    // vdivps        %ymm10,%ymm13,%ymm10
  .byte  196,193,108,88,210                  // vaddps        %ymm10,%ymm2,%ymm2
  .byte  98,241,108,56,89,21,233,111,3,0     // vmulps        0x36fe9(%rip){1to8},%ymm2,%ymm2        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  197,253,91,210                      // vcvtps2dq     %ymm2,%ymm2
  .byte  196,195,109,74,211,192              // vblendvps     %ymm12,%ymm11,%ymm2,%ymm2
  .byte  196,98,125,24,80,20                 // vbroadcastss  0x14(%rax),%ymm10
  .byte  196,193,108,88,210                  // vaddps        %ymm10,%ymm2,%ymm2
  .byte  196,195,109,74,209,128              // vblendvps     %ymm8,%ymm9,%ymm2,%ymm2
  .byte  196,193,108,95,211                  // vmaxps        %ymm11,%ymm2,%ymm2
  .byte  98,241,108,56,93,21,255,110,3,0     // vminps        0x36eff(%rip){1to8},%ymm2,%ymm2        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_a_skx
.globl _sk_parametric_a_skx
FUNCTION(_sk_parametric_a_skx)
_sk_parametric_a_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,241,100,56,194,64,4,2            // vcmpleps      0x10(%rax){1to8},%ymm3,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  98,114,101,56,168,72,6              // vfmadd213ps   0x18(%rax){1to8},%ymm3,%ymm9
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  98,114,101,56,168,80,2              // vfmadd213ps   0x8(%rax){1to8},%ymm3,%ymm10
  .byte  196,226,125,24,24                   // vbroadcastss  (%rax),%ymm3
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  98,209,44,40,194,195,0              // vcmpeqps      %ymm11,%ymm10,%k0
  .byte  98,114,126,40,56,224                // vpmovm2d      %k0,%ymm12
  .byte  196,65,124,91,234                   // vcvtdq2ps     %ymm10,%ymm13
  .byte  196,98,125,24,53,68,111,3,0         // vbroadcastss  0x36f44(%rip),%ymm14        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  98,114,21,56,168,53,66,111,3,0      // vfmadd213ps   0x36f42(%rip){1to8},%ymm13,%ymm14        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  98,113,44,56,84,21,52,111,3,0       // vandps        0x36f34(%rip){1to8},%ymm10,%ymm10        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  98,113,44,56,86,21,138,110,3,0      // vorps         0x36e8a(%rip){1to8},%ymm10,%ymm10        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  98,114,45,56,188,53,40,111,3,0      // vfnmadd231ps  0x36f28(%rip){1to8},%ymm10,%ymm14        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  98,113,44,56,88,21,34,111,3,0       // vaddps        0x36f22(%rip){1to8},%ymm10,%ymm10        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,98,125,24,45,29,111,3,0         // vbroadcastss  0x36f1d(%rip),%ymm13        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,20,94,210                    // vdivps        %ymm10,%ymm13,%ymm10
  .byte  196,65,12,92,210                    // vsubps        %ymm10,%ymm14,%ymm10
  .byte  196,193,100,89,218                  // vmulps        %ymm10,%ymm3,%ymm3
  .byte  196,99,125,8,211,1                  // vroundps      $0x1,%ymm3,%ymm10
  .byte  196,65,100,92,210                   // vsubps        %ymm10,%ymm3,%ymm10
  .byte  98,241,100,56,88,29,253,110,3,0     // vaddps        0x36efd(%rip){1to8},%ymm3,%ymm3        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  98,242,45,56,188,29,247,110,3,0     // vfnmadd231ps  0x36ef7(%rip){1to8},%ymm10,%ymm3        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,98,125,24,45,242,110,3,0        // vbroadcastss  0x36ef2(%rip),%ymm13        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  196,65,20,92,210                    // vsubps        %ymm10,%ymm13,%ymm10
  .byte  196,98,125,24,45,232,110,3,0        // vbroadcastss  0x36ee8(%rip),%ymm13        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  196,65,20,94,210                    // vdivps        %ymm10,%ymm13,%ymm10
  .byte  196,193,100,88,218                  // vaddps        %ymm10,%ymm3,%ymm3
  .byte  98,241,100,56,89,29,216,110,3,0     // vmulps        0x36ed8(%rip){1to8},%ymm3,%ymm3        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  197,253,91,219                      // vcvtps2dq     %ymm3,%ymm3
  .byte  196,195,101,74,219,192              // vblendvps     %ymm12,%ymm11,%ymm3,%ymm3
  .byte  196,98,125,24,80,20                 // vbroadcastss  0x14(%rax),%ymm10
  .byte  196,193,100,88,218                  // vaddps        %ymm10,%ymm3,%ymm3
  .byte  196,195,101,74,217,128              // vblendvps     %ymm8,%ymm9,%ymm3,%ymm3
  .byte  196,193,100,95,219                  // vmaxps        %ymm11,%ymm3,%ymm3
  .byte  98,241,100,56,93,29,238,109,3,0     // vminps        0x36dee(%rip){1to8},%ymm3,%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gamma_skx
.globl _sk_gamma_skx
FUNCTION(_sk_gamma_skx)
_sk_gamma_skx:
  .byte  98,97,124,40,40,199                 // vmovaps       %ymm7,%ymm24
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,226,125,40,24,16                 // vbroadcastss  (%rax),%ymm18
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  98,241,124,40,194,199,0             // vcmpeqps      %ymm7,%ymm0,%k0
  .byte  197,124,91,208                      // vcvtdq2ps     %ymm0,%ymm10
  .byte  196,98,125,24,29,92,110,3,0         // vbroadcastss  0x36e5c(%rip),%ymm11        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  196,98,125,24,37,87,110,3,0         // vbroadcastss  0x36e57(%rip),%ymm12        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  196,193,124,84,196                  // vandps        %ymm12,%ymm0,%ymm0
  .byte  196,98,125,24,45,169,109,3,0        // vbroadcastss  0x36da9(%rip),%ymm13        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,193,124,86,197                  // vorps         %ymm13,%ymm0,%ymm0
  .byte  196,98,125,24,53,63,110,3,0         // vbroadcastss  0x36e3f(%rip),%ymm14        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  196,66,37,168,214                   // vfmadd213ps   %ymm14,%ymm11,%ymm10
  .byte  196,98,125,24,61,53,110,3,0         // vbroadcastss  0x36e35(%rip),%ymm15        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,66,125,188,215                  // vfnmadd231ps  %ymm15,%ymm0,%ymm10
  .byte  98,226,125,40,24,5,42,110,3,0       // vbroadcastss  0x36e2a(%rip),%ymm16        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  98,177,124,40,88,192                // vaddps        %ymm16,%ymm0,%ymm0
  .byte  98,226,125,40,24,13,30,110,3,0      // vbroadcastss  0x36e1e(%rip),%ymm17        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  98,241,116,32,94,192                // vdivps        %ymm0,%ymm17,%ymm0
  .byte  197,172,92,192                      // vsubps        %ymm0,%ymm10,%ymm0
  .byte  98,177,124,40,89,194                // vmulps        %ymm18,%ymm0,%ymm0
  .byte  196,99,125,8,208,1                  // vroundps      $0x1,%ymm0,%ymm10
  .byte  98,114,126,40,56,200                // vpmovm2d      %k0,%ymm9
  .byte  196,65,124,92,210                   // vsubps        %ymm10,%ymm0,%ymm10
  .byte  98,226,125,40,24,29,247,109,3,0     // vbroadcastss  0x36df7(%rip),%ymm19        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  98,177,124,40,88,195                // vaddps        %ymm19,%ymm0,%ymm0
  .byte  98,226,125,40,24,37,235,109,3,0     // vbroadcastss  0x36deb(%rip),%ymm20        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  98,178,45,40,188,196                // vfnmadd231ps  %ymm20,%ymm10,%ymm0
  .byte  98,226,125,40,24,45,223,109,3,0     // vbroadcastss  0x36ddf(%rip),%ymm21        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  98,81,84,32,92,210                  // vsubps        %ymm10,%ymm21,%ymm10
  .byte  98,226,125,40,24,53,211,109,3,0     // vbroadcastss  0x36dd3(%rip),%ymm22        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  98,81,76,32,94,210                  // vdivps        %ymm10,%ymm22,%ymm10
  .byte  196,193,124,88,194                  // vaddps        %ymm10,%ymm0,%ymm0
  .byte  196,98,125,24,21,195,109,3,0        // vbroadcastss  0x36dc3(%rip),%ymm10        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  196,193,124,89,194                  // vmulps        %ymm10,%ymm0,%ymm0
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,227,125,74,199,144              // vblendvps     %ymm9,%ymm7,%ymm0,%ymm0
  .byte  98,241,116,40,194,199,0             // vcmpeqps      %ymm7,%ymm1,%k0
  .byte  98,114,126,40,56,200                // vpmovm2d      %k0,%ymm9
  .byte  98,225,124,40,91,249                // vcvtdq2ps     %ymm1,%ymm23
  .byte  196,193,116,84,204                  // vandps        %ymm12,%ymm1,%ymm1
  .byte  196,193,116,86,205                  // vorps         %ymm13,%ymm1,%ymm1
  .byte  98,194,37,40,168,254                // vfmadd213ps   %ymm14,%ymm11,%ymm23
  .byte  98,194,117,40,188,255               // vfnmadd231ps  %ymm15,%ymm1,%ymm23
  .byte  98,177,116,40,88,200                // vaddps        %ymm16,%ymm1,%ymm1
  .byte  98,241,116,32,94,201                // vdivps        %ymm1,%ymm17,%ymm1
  .byte  98,241,68,32,92,201                 // vsubps        %ymm1,%ymm23,%ymm1
  .byte  98,177,116,40,89,202                // vmulps        %ymm18,%ymm1,%ymm1
  .byte  196,99,125,8,193,1                  // vroundps      $0x1,%ymm1,%ymm8
  .byte  196,65,116,92,192                   // vsubps        %ymm8,%ymm1,%ymm8
  .byte  98,177,116,40,88,203                // vaddps        %ymm19,%ymm1,%ymm1
  .byte  98,178,61,40,188,204                // vfnmadd231ps  %ymm20,%ymm8,%ymm1
  .byte  98,81,84,32,92,192                  // vsubps        %ymm8,%ymm21,%ymm8
  .byte  98,81,76,32,94,192                  // vdivps        %ymm8,%ymm22,%ymm8
  .byte  196,193,116,88,200                  // vaddps        %ymm8,%ymm1,%ymm1
  .byte  196,193,116,89,202                  // vmulps        %ymm10,%ymm1,%ymm1
  .byte  197,253,91,201                      // vcvtps2dq     %ymm1,%ymm1
  .byte  196,227,117,74,207,144              // vblendvps     %ymm9,%ymm7,%ymm1,%ymm1
  .byte  98,241,108,40,194,199,0             // vcmpeqps      %ymm7,%ymm2,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  197,124,91,202                      // vcvtdq2ps     %ymm2,%ymm9
  .byte  196,193,108,84,212                  // vandps        %ymm12,%ymm2,%ymm2
  .byte  196,193,108,86,213                  // vorps         %ymm13,%ymm2,%ymm2
  .byte  196,66,37,168,206                   // vfmadd213ps   %ymm14,%ymm11,%ymm9
  .byte  196,66,109,188,207                  // vfnmadd231ps  %ymm15,%ymm2,%ymm9
  .byte  98,177,108,40,88,208                // vaddps        %ymm16,%ymm2,%ymm2
  .byte  98,241,116,32,94,210                // vdivps        %ymm2,%ymm17,%ymm2
  .byte  197,180,92,210                      // vsubps        %ymm2,%ymm9,%ymm2
  .byte  98,177,108,40,89,210                // vmulps        %ymm18,%ymm2,%ymm2
  .byte  196,99,125,8,202,1                  // vroundps      $0x1,%ymm2,%ymm9
  .byte  196,65,108,92,201                   // vsubps        %ymm9,%ymm2,%ymm9
  .byte  98,177,108,40,88,211                // vaddps        %ymm19,%ymm2,%ymm2
  .byte  98,178,53,40,188,212                // vfnmadd231ps  %ymm20,%ymm9,%ymm2
  .byte  98,81,84,32,92,201                  // vsubps        %ymm9,%ymm21,%ymm9
  .byte  98,81,76,32,94,201                  // vdivps        %ymm9,%ymm22,%ymm9
  .byte  196,193,108,88,209                  // vaddps        %ymm9,%ymm2,%ymm2
  .byte  196,193,108,89,210                  // vmulps        %ymm10,%ymm2,%ymm2
  .byte  197,253,91,210                      // vcvtps2dq     %ymm2,%ymm2
  .byte  196,227,109,74,215,128              // vblendvps     %ymm8,%ymm7,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,145,124,40,40,248                // vmovaps       %ymm24,%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gamma_dst_skx
.globl _sk_gamma_dst_skx
FUNCTION(_sk_gamma_dst_skx)
_sk_gamma_dst_skx:
  .byte  98,97,124,40,40,199                 // vmovaps       %ymm7,%ymm24
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,226,125,40,24,16                 // vbroadcastss  (%rax),%ymm18
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  98,241,92,40,194,199,0              // vcmpeqps      %ymm7,%ymm4,%k0
  .byte  197,124,91,212                      // vcvtdq2ps     %ymm4,%ymm10
  .byte  196,98,125,24,29,114,108,3,0        // vbroadcastss  0x36c72(%rip),%ymm11        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  196,98,125,24,37,109,108,3,0        // vbroadcastss  0x36c6d(%rip),%ymm12        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  196,193,92,84,228                   // vandps        %ymm12,%ymm4,%ymm4
  .byte  196,98,125,24,45,191,107,3,0        // vbroadcastss  0x36bbf(%rip),%ymm13        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,193,92,86,229                   // vorps         %ymm13,%ymm4,%ymm4
  .byte  196,98,125,24,53,85,108,3,0         // vbroadcastss  0x36c55(%rip),%ymm14        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  196,66,37,168,214                   // vfmadd213ps   %ymm14,%ymm11,%ymm10
  .byte  196,98,125,24,61,75,108,3,0         // vbroadcastss  0x36c4b(%rip),%ymm15        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,66,93,188,215                   // vfnmadd231ps  %ymm15,%ymm4,%ymm10
  .byte  98,226,125,40,24,5,64,108,3,0       // vbroadcastss  0x36c40(%rip),%ymm16        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  98,177,92,40,88,224                 // vaddps        %ymm16,%ymm4,%ymm4
  .byte  98,226,125,40,24,13,52,108,3,0      // vbroadcastss  0x36c34(%rip),%ymm17        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  98,241,116,32,94,228                // vdivps        %ymm4,%ymm17,%ymm4
  .byte  197,172,92,228                      // vsubps        %ymm4,%ymm10,%ymm4
  .byte  98,177,92,40,89,226                 // vmulps        %ymm18,%ymm4,%ymm4
  .byte  196,99,125,8,212,1                  // vroundps      $0x1,%ymm4,%ymm10
  .byte  98,114,126,40,56,200                // vpmovm2d      %k0,%ymm9
  .byte  196,65,92,92,210                    // vsubps        %ymm10,%ymm4,%ymm10
  .byte  98,226,125,40,24,29,13,108,3,0      // vbroadcastss  0x36c0d(%rip),%ymm19        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  98,177,92,40,88,227                 // vaddps        %ymm19,%ymm4,%ymm4
  .byte  98,226,125,40,24,37,1,108,3,0       // vbroadcastss  0x36c01(%rip),%ymm20        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  98,178,45,40,188,228                // vfnmadd231ps  %ymm20,%ymm10,%ymm4
  .byte  98,226,125,40,24,45,245,107,3,0     // vbroadcastss  0x36bf5(%rip),%ymm21        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  98,81,84,32,92,210                  // vsubps        %ymm10,%ymm21,%ymm10
  .byte  98,226,125,40,24,53,233,107,3,0     // vbroadcastss  0x36be9(%rip),%ymm22        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  98,81,76,32,94,210                  // vdivps        %ymm10,%ymm22,%ymm10
  .byte  196,193,92,88,226                   // vaddps        %ymm10,%ymm4,%ymm4
  .byte  196,98,125,24,21,217,107,3,0        // vbroadcastss  0x36bd9(%rip),%ymm10        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  196,193,92,89,226                   // vmulps        %ymm10,%ymm4,%ymm4
  .byte  197,253,91,228                      // vcvtps2dq     %ymm4,%ymm4
  .byte  196,227,93,74,231,144               // vblendvps     %ymm9,%ymm7,%ymm4,%ymm4
  .byte  98,241,84,40,194,199,0              // vcmpeqps      %ymm7,%ymm5,%k0
  .byte  98,114,126,40,56,200                // vpmovm2d      %k0,%ymm9
  .byte  98,225,124,40,91,253                // vcvtdq2ps     %ymm5,%ymm23
  .byte  196,193,84,84,236                   // vandps        %ymm12,%ymm5,%ymm5
  .byte  196,193,84,86,237                   // vorps         %ymm13,%ymm5,%ymm5
  .byte  98,194,37,40,168,254                // vfmadd213ps   %ymm14,%ymm11,%ymm23
  .byte  98,194,85,40,188,255                // vfnmadd231ps  %ymm15,%ymm5,%ymm23
  .byte  98,177,84,40,88,232                 // vaddps        %ymm16,%ymm5,%ymm5
  .byte  98,241,116,32,94,237                // vdivps        %ymm5,%ymm17,%ymm5
  .byte  98,241,68,32,92,237                 // vsubps        %ymm5,%ymm23,%ymm5
  .byte  98,177,84,40,89,234                 // vmulps        %ymm18,%ymm5,%ymm5
  .byte  196,99,125,8,197,1                  // vroundps      $0x1,%ymm5,%ymm8
  .byte  196,65,84,92,192                    // vsubps        %ymm8,%ymm5,%ymm8
  .byte  98,177,84,40,88,235                 // vaddps        %ymm19,%ymm5,%ymm5
  .byte  98,178,61,40,188,236                // vfnmadd231ps  %ymm20,%ymm8,%ymm5
  .byte  98,81,84,32,92,192                  // vsubps        %ymm8,%ymm21,%ymm8
  .byte  98,81,76,32,94,192                  // vdivps        %ymm8,%ymm22,%ymm8
  .byte  196,193,84,88,232                   // vaddps        %ymm8,%ymm5,%ymm5
  .byte  196,193,84,89,234                   // vmulps        %ymm10,%ymm5,%ymm5
  .byte  197,253,91,237                      // vcvtps2dq     %ymm5,%ymm5
  .byte  196,227,85,74,239,144               // vblendvps     %ymm9,%ymm7,%ymm5,%ymm5
  .byte  98,241,76,40,194,199,0              // vcmpeqps      %ymm7,%ymm6,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  197,124,91,206                      // vcvtdq2ps     %ymm6,%ymm9
  .byte  196,193,76,84,244                   // vandps        %ymm12,%ymm6,%ymm6
  .byte  196,193,76,86,245                   // vorps         %ymm13,%ymm6,%ymm6
  .byte  196,66,37,168,206                   // vfmadd213ps   %ymm14,%ymm11,%ymm9
  .byte  196,66,77,188,207                   // vfnmadd231ps  %ymm15,%ymm6,%ymm9
  .byte  98,177,76,40,88,240                 // vaddps        %ymm16,%ymm6,%ymm6
  .byte  98,241,116,32,94,246                // vdivps        %ymm6,%ymm17,%ymm6
  .byte  197,180,92,246                      // vsubps        %ymm6,%ymm9,%ymm6
  .byte  98,177,76,40,89,242                 // vmulps        %ymm18,%ymm6,%ymm6
  .byte  196,99,125,8,206,1                  // vroundps      $0x1,%ymm6,%ymm9
  .byte  196,65,76,92,201                    // vsubps        %ymm9,%ymm6,%ymm9
  .byte  98,177,76,40,88,243                 // vaddps        %ymm19,%ymm6,%ymm6
  .byte  98,178,53,40,188,244                // vfnmadd231ps  %ymm20,%ymm9,%ymm6
  .byte  98,81,84,32,92,201                  // vsubps        %ymm9,%ymm21,%ymm9
  .byte  98,81,76,32,94,201                  // vdivps        %ymm9,%ymm22,%ymm9
  .byte  196,193,76,88,241                   // vaddps        %ymm9,%ymm6,%ymm6
  .byte  196,193,76,89,242                   // vmulps        %ymm10,%ymm6,%ymm6
  .byte  197,253,91,246                      // vcvtps2dq     %ymm6,%ymm6
  .byte  196,227,77,74,247,128               // vblendvps     %ymm8,%ymm7,%ymm6,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,145,124,40,40,248                // vmovaps       %ymm24,%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lab_to_xyz_skx
.globl _sk_lab_to_xyz_skx
FUNCTION(_sk_lab_to_xyz_skx)
_sk_lab_to_xyz_skx:
  .byte  196,98,125,24,5,209,106,3,0         // vbroadcastss  0x36ad1(%rip),%ymm8        # 3a2dc <_sk_srcover_bgra_8888_sse2_lowp+0x374>
  .byte  196,98,125,24,13,48,106,3,0         // vbroadcastss  0x36a30(%rip),%ymm9        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,98,125,24,21,195,106,3,0        // vbroadcastss  0x36ac3(%rip),%ymm10        # 3a2e0 <_sk_srcover_bgra_8888_sse2_lowp+0x378>
  .byte  196,194,53,168,202                  // vfmadd213ps   %ymm10,%ymm9,%ymm1
  .byte  196,194,53,168,210                  // vfmadd213ps   %ymm10,%ymm9,%ymm2
  .byte  98,114,125,56,168,5,179,106,3,0     // vfmadd213ps   0x36ab3(%rip){1to8},%ymm0,%ymm8        # 3a2e4 <_sk_srcover_bgra_8888_sse2_lowp+0x37c>
  .byte  98,241,60,56,89,5,173,106,3,0       // vmulps        0x36aad(%rip){1to8},%ymm8,%ymm0        # 3a2e8 <_sk_srcover_bgra_8888_sse2_lowp+0x380>
  .byte  98,242,125,56,152,13,167,106,3,0    // vfmadd132ps   0x36aa7(%rip){1to8},%ymm0,%ymm1        # 3a2ec <_sk_srcover_bgra_8888_sse2_lowp+0x384>
  .byte  98,242,125,56,156,21,161,106,3,0    // vfnmadd132ps  0x36aa1(%rip){1to8},%ymm0,%ymm2        # 3a2f0 <_sk_srcover_bgra_8888_sse2_lowp+0x388>
  .byte  197,116,89,193                      // vmulps        %ymm1,%ymm1,%ymm8
  .byte  196,65,116,89,192                   // vmulps        %ymm8,%ymm1,%ymm8
  .byte  196,98,125,24,13,147,106,3,0        // vbroadcastss  0x36a93(%rip),%ymm9        # 3a2f4 <_sk_srcover_bgra_8888_sse2_lowp+0x38c>
  .byte  98,209,52,40,194,192,1              // vcmpltps      %ymm8,%ymm9,%k0
  .byte  98,114,126,40,56,208                // vpmovm2d      %k0,%ymm10
  .byte  196,98,125,24,29,129,106,3,0        // vbroadcastss  0x36a81(%rip),%ymm11        # 3a2f8 <_sk_srcover_bgra_8888_sse2_lowp+0x390>
  .byte  196,193,116,88,203                  // vaddps        %ymm11,%ymm1,%ymm1
  .byte  196,98,125,24,37,119,106,3,0        // vbroadcastss  0x36a77(%rip),%ymm12        # 3a2fc <_sk_srcover_bgra_8888_sse2_lowp+0x394>
  .byte  196,193,116,89,204                  // vmulps        %ymm12,%ymm1,%ymm1
  .byte  196,67,117,74,192,160               // vblendvps     %ymm10,%ymm8,%ymm1,%ymm8
  .byte  197,252,89,200                      // vmulps        %ymm0,%ymm0,%ymm1
  .byte  197,252,89,201                      // vmulps        %ymm1,%ymm0,%ymm1
  .byte  98,241,52,40,194,193,1              // vcmpltps      %ymm1,%ymm9,%k0
  .byte  98,114,126,40,56,208                // vpmovm2d      %k0,%ymm10
  .byte  196,193,124,88,195                  // vaddps        %ymm11,%ymm0,%ymm0
  .byte  196,193,124,89,196                  // vmulps        %ymm12,%ymm0,%ymm0
  .byte  196,227,125,74,201,160              // vblendvps     %ymm10,%ymm1,%ymm0,%ymm1
  .byte  197,236,89,194                      // vmulps        %ymm2,%ymm2,%ymm0
  .byte  197,236,89,192                      // vmulps        %ymm0,%ymm2,%ymm0
  .byte  98,241,52,40,194,192,1              // vcmpltps      %ymm0,%ymm9,%k0
  .byte  98,114,126,40,56,200                // vpmovm2d      %k0,%ymm9
  .byte  196,193,108,88,211                  // vaddps        %ymm11,%ymm2,%ymm2
  .byte  196,193,108,89,212                  // vmulps        %ymm12,%ymm2,%ymm2
  .byte  196,227,109,74,208,144              // vblendvps     %ymm9,%ymm0,%ymm2,%ymm2
  .byte  98,241,60,56,89,5,28,106,3,0        // vmulps        0x36a1c(%rip){1to8},%ymm8,%ymm0        # 3a300 <_sk_srcover_bgra_8888_sse2_lowp+0x398>
  .byte  98,241,108,56,89,21,22,106,3,0      // vmulps        0x36a16(%rip){1to8},%ymm2,%ymm2        # 3a304 <_sk_srcover_bgra_8888_sse2_lowp+0x39c>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_a8_skx
.globl _sk_load_a8_skx
FUNCTION(_sk_load_a8_skx)
_sk_load_a8_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,49                              // jne           393b <_sk_load_a8_skx+0x49>
  .byte  196,130,121,48,4,24                 // vpmovzxbw     (%r8,%r11,1),%xmm0
  .byte  197,249,219,5,216,113,3,0           // vpand         0x371d8(%rip),%xmm0,%xmm0        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,226,125,51,192                  // vpmovzxwd     %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  98,241,124,56,89,29,101,105,3,0     // vmulps        0x36965(%rip){1to8},%ymm0,%ymm3        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,192                             // ja            3910 <_sk_load_a8_skx+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,133,0,0,0                 // lea           0x85(%rip),%r10        # 39e0 <_sk_load_a8_skx+0xee>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  235,161                             // jmp           3910 <_sk_load_a8_skx+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,249,196,192,2                   // vpinsrw       $0x2,%eax,%xmm0,%xmm0
  .byte  196,130,121,50,12,24                // vpmovzxbq     (%r8,%r11,1),%xmm1
  .byte  197,249,112,201,232                 // vpshufd       $0xe8,%xmm1,%xmm1
  .byte  197,251,112,201,232                 // vpshuflw      $0xe8,%xmm1,%xmm1
  .byte  196,227,121,2,193,1                 // vpblendd      $0x1,%xmm1,%xmm0,%xmm0
  .byte  233,119,255,255,255                 // jmpq          3910 <_sk_load_a8_skx+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,249,196,192,6                   // vpinsrw       $0x6,%eax,%xmm0,%xmm0
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,249,196,192,5                   // vpinsrw       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,249,196,192,4                   // vpinsrw       $0x4,%eax,%xmm0,%xmm0
  .byte  196,130,121,49,12,24                // vpmovzxbd     (%r8,%r11,1),%xmm1
  .byte  197,251,112,201,232                 // vpshuflw      $0xe8,%xmm1,%xmm1
  .byte  197,250,112,201,232                 // vpshufhw      $0xe8,%xmm1,%xmm1
  .byte  197,249,112,201,232                 // vpshufd       $0xe8,%xmm1,%xmm1
  .byte  196,227,113,2,192,12                // vpblendd      $0xc,%xmm0,%xmm1,%xmm0
  .byte  233,50,255,255,255                  // jmpq          3910 <_sk_load_a8_skx+0x1e>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  132,255                             // test          %bh,%bh
  .byte  255                                 // (bad)
  .byte  255,158,255,255,255,143             // lcall         *-0x70000001(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  222,255                             // fdivrp        %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,211                             // callq         *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,200                             // dec           %eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  185                                 // .byte         0xb9
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_a8_dst_skx
.globl _sk_load_a8_dst_skx
FUNCTION(_sk_load_a8_dst_skx)
_sk_load_a8_dst_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,49                              // jne           3a45 <_sk_load_a8_dst_skx+0x49>
  .byte  196,130,121,48,36,24                // vpmovzxbw     (%r8,%r11,1),%xmm4
  .byte  197,217,219,37,206,112,3,0          // vpand         0x370ce(%rip),%xmm4,%xmm4        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,226,125,51,228                  // vpmovzxwd     %xmm4,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  98,241,92,56,89,61,91,104,3,0       // vmulps        0x3685b(%rip){1to8},%ymm4,%ymm7        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,192                             // ja            3a1a <_sk_load_a8_dst_skx+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,131,0,0,0                 // lea           0x83(%rip),%r10        # 3ae8 <_sk_load_a8_dst_skx+0xec>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  235,161                             // jmp           3a1a <_sk_load_a8_dst_skx+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  197,217,196,224,2                   // vpinsrw       $0x2,%eax,%xmm4,%xmm4
  .byte  196,130,121,50,44,24                // vpmovzxbq     (%r8,%r11,1),%xmm5
  .byte  197,249,112,237,232                 // vpshufd       $0xe8,%xmm5,%xmm5
  .byte  197,251,112,237,232                 // vpshuflw      $0xe8,%xmm5,%xmm5
  .byte  196,227,89,2,229,1                  // vpblendd      $0x1,%xmm5,%xmm4,%xmm4
  .byte  233,119,255,255,255                 // jmpq          3a1a <_sk_load_a8_dst_skx+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  197,217,196,224,6                   // vpinsrw       $0x6,%eax,%xmm4,%xmm4
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,217,196,224,5                   // vpinsrw       $0x5,%eax,%xmm4,%xmm4
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,217,196,224,4                   // vpinsrw       $0x4,%eax,%xmm4,%xmm4
  .byte  196,130,121,49,44,24                // vpmovzxbd     (%r8,%r11,1),%xmm5
  .byte  197,251,112,237,232                 // vpshuflw      $0xe8,%xmm5,%xmm5
  .byte  197,250,112,237,232                 // vpshufhw      $0xe8,%xmm5,%xmm5
  .byte  197,249,112,237,232                 // vpshufd       $0xe8,%xmm5,%xmm5
  .byte  196,227,81,2,228,12                 // vpblendd      $0xc,%xmm4,%xmm5,%xmm4
  .byte  233,50,255,255,255                  // jmpq          3a1a <_sk_load_a8_dst_skx+0x1e>
  .byte  134,255                             // xchg          %bh,%bh
  .byte  255                                 // (bad)
  .byte  255,160,255,255,255,145             // jmpq          *-0x6e000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,224                             // jmpq          *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,213                             // callq         *%rbp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,202                             // dec           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  187                                 // .byte         0xbb
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_a8_skx
.globl _sk_gather_a8_skx
FUNCTION(_sk_gather_a8_skx)
_sk_gather_a8_skx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  98,242,117,56,64,72,2               // vpmulld       0x8(%rax){1to8},%ymm1,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  196,227,249,22,192,1                // vpextrq       $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,194                 // vmovq         %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  71,15,182,28,24                     // movzbl        (%r8,%r11,1),%r11d
  .byte  196,193,121,110,195                 // vmovd         %r11d,%xmm0
  .byte  196,195,121,32,194,1                // vpinsrb       $0x1,%r10d,%xmm0,%xmm0
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,121,32,192,3                // vpinsrb       $0x3,%eax,%xmm0,%xmm0
  .byte  67,15,182,4,32                      // movzbl        (%r8,%r12,1),%eax
  .byte  196,227,121,32,192,4                // vpinsrb       $0x4,%eax,%xmm0,%xmm0
  .byte  67,15,182,4,56                      // movzbl        (%r8,%r15,1),%eax
  .byte  196,227,121,32,192,5                // vpinsrb       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,182,4,48                      // movzbl        (%r8,%r14,1),%eax
  .byte  196,227,121,32,192,6                // vpinsrb       $0x6,%eax,%xmm0,%xmm0
  .byte  65,15,182,4,24                      // movzbl        (%r8,%rbx,1),%eax
  .byte  196,227,121,32,192,7                // vpinsrb       $0x7,%eax,%xmm0,%xmm0
  .byte  196,226,125,49,192                  // vpmovzxbd     %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  98,241,124,56,89,29,158,102,3,0     // vmulps        0x3669e(%rip){1to8},%ymm0,%ymm3        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_a8_skx
.globl _sk_store_a8_skx
FUNCTION(_sk_store_a8_skx)
_sk_store_a8_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  98,113,60,56,93,5,233,101,3,0       // vminps        0x365e9(%rip){1to8},%ymm8,%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  98,113,60,56,89,5,11,102,3,0        // vmulps        0x3660b(%rip){1to8},%ymm8,%ymm8        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,66,57,43,193                    // vpackusdw     %xmm9,%xmm8,%xmm8
  .byte  197,57,103,192                      // vpackuswb     %xmm0,%xmm8,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           3c5c <_sk_store_a8_skx+0x53>
  .byte  196,1,121,214,4,24                  // vmovq         %xmm8,(%r8,%r11,1)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,235                             // ja            3c58 <_sk_store_a8_skx+0x4f>
  .byte  196,66,121,48,192                   // vpmovzxbw     %xmm8,%xmm8
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,79,0,0,0                  // lea           0x4f(%rip),%r10        # 3ccc <_sk_store_a8_skx+0xc3>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,3,121,20,4,24,0                 // vpextrb       $0x0,%xmm8,(%r8,%r11,1)
  .byte  235,201                             // jmp           3c58 <_sk_store_a8_skx+0x4f>
  .byte  196,3,121,20,68,24,2,4              // vpextrb       $0x4,%xmm8,0x2(%r8,%r11,1)
  .byte  196,66,121,49,192                   // vpmovzxbd     %xmm8,%xmm8
  .byte  98,18,126,8,50,4,24                 // vpmovqb       %xmm8,(%r8,%r11,1)
  .byte  235,179                             // jmp           3c58 <_sk_store_a8_skx+0x4f>
  .byte  196,3,121,20,68,24,6,12             // vpextrb       $0xc,%xmm8,0x6(%r8,%r11,1)
  .byte  196,3,121,20,68,24,5,10             // vpextrb       $0xa,%xmm8,0x5(%r8,%r11,1)
  .byte  196,3,121,20,68,24,4,8              // vpextrb       $0x8,%xmm8,0x4(%r8,%r11,1)
  .byte  196,66,121,48,192                   // vpmovzxbw     %xmm8,%xmm8
  .byte  98,18,126,8,49,4,24                 // vpmovdb       %xmm8,(%r8,%r11,1)
  .byte  235,141                             // jmp           3c58 <_sk_store_a8_skx+0x4f>
  .byte  144                                 // nop
  .byte  186,255,255,255,203                 // mov           $0xcbffffff,%edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,195                             // inc           %ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,241                             // push          %rcx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  233,255,255,255,225                 // jmpq          ffffffffe2003ce0 <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffe1fc9d78>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  217,255                             // fcos
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_g8_skx
.globl _sk_load_g8_skx
FUNCTION(_sk_load_g8_skx)
_sk_load_g8_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,54                              // jne           3d36 <_sk_load_g8_skx+0x4e>
  .byte  196,130,121,48,4,24                 // vpmovzxbw     (%r8,%r11,1),%xmm0
  .byte  197,249,219,5,226,109,3,0           // vpand         0x36de2(%rip),%xmm0,%xmm0        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,226,125,51,192                  // vpmovzxwd     %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  98,241,124,56,89,5,111,101,3,0      // vmulps        0x3656f(%rip){1to8},%ymm0,%ymm0        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,236,100,3,0       // vbroadcastss  0x364ec(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,187                             // ja            3d06 <_sk_load_g8_skx+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,134,0,0,0                 // lea           0x86(%rip),%r10        # 3ddc <_sk_load_g8_skx+0xf4>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  235,156                             // jmp           3d06 <_sk_load_g8_skx+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,249,196,192,2                   // vpinsrw       $0x2,%eax,%xmm0,%xmm0
  .byte  196,130,121,50,12,24                // vpmovzxbq     (%r8,%r11,1),%xmm1
  .byte  197,249,112,201,232                 // vpshufd       $0xe8,%xmm1,%xmm1
  .byte  197,251,112,201,232                 // vpshuflw      $0xe8,%xmm1,%xmm1
  .byte  196,227,121,2,193,1                 // vpblendd      $0x1,%xmm1,%xmm0,%xmm0
  .byte  233,114,255,255,255                 // jmpq          3d06 <_sk_load_g8_skx+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,249,196,192,6                   // vpinsrw       $0x6,%eax,%xmm0,%xmm0
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,249,196,192,5                   // vpinsrw       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,249,196,192,4                   // vpinsrw       $0x4,%eax,%xmm0,%xmm0
  .byte  196,130,121,49,12,24                // vpmovzxbd     (%r8,%r11,1),%xmm1
  .byte  197,251,112,201,232                 // vpshuflw      $0xe8,%xmm1,%xmm1
  .byte  197,250,112,201,232                 // vpshufhw      $0xe8,%xmm1,%xmm1
  .byte  197,249,112,201,232                 // vpshufd       $0xe8,%xmm1,%xmm1
  .byte  196,227,113,2,192,12                // vpblendd      $0xc,%xmm0,%xmm1,%xmm0
  .byte  233,45,255,255,255                  // jmpq          3d06 <_sk_load_g8_skx+0x1e>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  131,255,255                         // cmp           $0xffffffff,%edi
  .byte  255,157,255,255,255,142             // lcall         *-0x71000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  221,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  184                                 // .byte         0xb8
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_g8_dst_skx
.globl _sk_load_g8_dst_skx
FUNCTION(_sk_load_g8_dst_skx)
_sk_load_g8_dst_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,54                              // jne           3e46 <_sk_load_g8_dst_skx+0x4e>
  .byte  196,130,121,48,36,24                // vpmovzxbw     (%r8,%r11,1),%xmm4
  .byte  197,217,219,37,210,108,3,0          // vpand         0x36cd2(%rip),%xmm4,%xmm4        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,226,125,51,228                  // vpmovzxwd     %xmm4,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  98,241,92,56,89,37,95,100,3,0       // vmulps        0x3645f(%rip){1to8},%ymm4,%ymm4        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,61,220,99,3,0        // vbroadcastss  0x363dc(%rip),%ymm7        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,40,236                      // vmovaps       %ymm4,%ymm5
  .byte  197,252,40,244                      // vmovaps       %ymm4,%ymm6
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,187                             // ja            3e16 <_sk_load_g8_dst_skx+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,134,0,0,0                 // lea           0x86(%rip),%r10        # 3eec <_sk_load_g8_dst_skx+0xf4>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  235,156                             // jmp           3e16 <_sk_load_g8_dst_skx+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  197,217,196,224,2                   // vpinsrw       $0x2,%eax,%xmm4,%xmm4
  .byte  196,130,121,50,44,24                // vpmovzxbq     (%r8,%r11,1),%xmm5
  .byte  197,249,112,237,232                 // vpshufd       $0xe8,%xmm5,%xmm5
  .byte  197,251,112,237,232                 // vpshuflw      $0xe8,%xmm5,%xmm5
  .byte  196,227,89,2,229,1                  // vpblendd      $0x1,%xmm5,%xmm4,%xmm4
  .byte  233,114,255,255,255                 // jmpq          3e16 <_sk_load_g8_dst_skx+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  197,217,196,224,6                   // vpinsrw       $0x6,%eax,%xmm4,%xmm4
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,217,196,224,5                   // vpinsrw       $0x5,%eax,%xmm4,%xmm4
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,217,196,224,4                   // vpinsrw       $0x4,%eax,%xmm4,%xmm4
  .byte  196,130,121,49,44,24                // vpmovzxbd     (%r8,%r11,1),%xmm5
  .byte  197,251,112,237,232                 // vpshuflw      $0xe8,%xmm5,%xmm5
  .byte  197,250,112,237,232                 // vpshufhw      $0xe8,%xmm5,%xmm5
  .byte  197,249,112,237,232                 // vpshufd       $0xe8,%xmm5,%xmm5
  .byte  196,227,81,2,228,12                 // vpblendd      $0xc,%xmm4,%xmm5,%xmm4
  .byte  233,45,255,255,255                  // jmpq          3e16 <_sk_load_g8_dst_skx+0x1e>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  131,255,255                         // cmp           $0xffffffff,%edi
  .byte  255,157,255,255,255,142             // lcall         *-0x71000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  221,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  184                                 // .byte         0xb8
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_g8_skx
.globl _sk_gather_g8_skx
FUNCTION(_sk_gather_g8_skx)
_sk_gather_g8_skx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  98,242,117,56,64,72,2               // vpmulld       0x8(%rax){1to8},%ymm1,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  196,227,249,22,192,1                // vpextrq       $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,194                 // vmovq         %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  71,15,182,28,24                     // movzbl        (%r8,%r11,1),%r11d
  .byte  196,193,121,110,195                 // vmovd         %r11d,%xmm0
  .byte  196,195,121,32,194,1                // vpinsrb       $0x1,%r10d,%xmm0,%xmm0
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,121,32,192,3                // vpinsrb       $0x3,%eax,%xmm0,%xmm0
  .byte  67,15,182,4,32                      // movzbl        (%r8,%r12,1),%eax
  .byte  196,227,121,32,192,4                // vpinsrb       $0x4,%eax,%xmm0,%xmm0
  .byte  67,15,182,4,56                      // movzbl        (%r8,%r15,1),%eax
  .byte  196,227,121,32,192,5                // vpinsrb       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,182,4,48                      // movzbl        (%r8,%r14,1),%eax
  .byte  196,227,121,32,192,6                // vpinsrb       $0x6,%eax,%xmm0,%xmm0
  .byte  65,15,182,4,24                      // movzbl        (%r8,%rbx,1),%eax
  .byte  196,227,121,32,192,7                // vpinsrb       $0x7,%eax,%xmm0,%xmm0
  .byte  196,226,125,49,192                  // vpmovzxbd     %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  98,241,124,56,89,5,154,98,3,0       // vmulps        0x3629a(%rip){1to8},%ymm0,%ymm0        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,23,98,3,0         // vbroadcastss  0x36217(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_565_skx
.globl _sk_load_565_skx
FUNCTION(_sk_load_565_skx)
_sk_load_565_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,96                              // jne           408d <_sk_load_565_skx+0x7b>
  .byte  196,129,122,111,4,88                // vmovdqu       (%r8,%r11,2),%xmm0
  .byte  196,226,125,51,208                  // vpmovzxwd     %xmm0,%ymm2
  .byte  98,241,109,56,219,5,82,98,3,0       // vpandd        0x36252(%rip){1to8},%ymm2,%ymm0        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  98,241,124,56,89,5,72,98,3,0        // vmulps        0x36248(%rip){1to8},%ymm0,%ymm0        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  98,241,109,56,219,13,66,98,3,0      // vpandd        0x36242(%rip){1to8},%ymm2,%ymm1        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  98,241,116,56,89,13,56,98,3,0       // vmulps        0x36238(%rip){1to8},%ymm1,%ymm1        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  98,241,109,56,219,21,50,98,3,0      // vpandd        0x36232(%rip){1to8},%ymm2,%ymm2        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  98,241,108,56,89,21,40,98,3,0       // vmulps        0x36228(%rip){1to8},%ymm2,%ymm2        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,141,97,3,0        // vbroadcastss  0x3618d(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,145                             // ja            4033 <_sk_load_565_skx+0x21>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,123,0,0,0                 // lea           0x7b(%rip),%r10        # 4128 <_sk_load_565_skx+0x116>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  233,111,255,255,255                 // jmpq          4033 <_sk_load_565_skx+0x21>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,129,121,196,68,88,4,2           // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,130,121,52,12,88                // vpmovzxwq     (%r8,%r11,2),%xmm1
  .byte  197,249,112,201,232                 // vpshufd       $0xe8,%xmm1,%xmm1
  .byte  197,251,112,201,232                 // vpshuflw      $0xe8,%xmm1,%xmm1
  .byte  196,227,121,2,193,1                 // vpblendd      $0x1,%xmm1,%xmm0,%xmm0
  .byte  233,72,255,255,255                  // jmpq          4033 <_sk_load_565_skx+0x21>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,129,121,196,68,88,12,6          // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,196,68,88,10,5          // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,196,68,88,8,4           // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,130,121,51,12,88                // vpmovzxwd     (%r8,%r11,2),%xmm1
  .byte  197,251,112,201,232                 // vpshuflw      $0xe8,%xmm1,%xmm1
  .byte  197,250,112,201,232                 // vpshufhw      $0xe8,%xmm1,%xmm1
  .byte  197,249,112,201,132                 // vpshufd       $0x84,%xmm1,%xmm1
  .byte  197,241,109,192                     // vpunpckhqdq   %xmm0,%xmm1,%xmm0
  .byte  233,14,255,255,255                  // jmpq          4033 <_sk_load_565_skx+0x21>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  142,255                             // mov           %edi,%?
  .byte  255                                 // (bad)
  .byte  255,168,255,255,255,156             // ljmp          *-0x63000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  223,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,215                             // callq         *%rdi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,207                             // dec           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,195                             // inc           %ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_565_dst_skx
.globl _sk_load_565_dst_skx
FUNCTION(_sk_load_565_dst_skx)
_sk_load_565_dst_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,96                              // jne           41bf <_sk_load_565_dst_skx+0x7b>
  .byte  196,129,122,111,36,88               // vmovdqu       (%r8,%r11,2),%xmm4
  .byte  196,226,125,51,244                  // vpmovzxwd     %xmm4,%ymm6
  .byte  98,241,77,56,219,37,32,97,3,0       // vpandd        0x36120(%rip){1to8},%ymm6,%ymm4        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  98,241,92,56,89,37,22,97,3,0        // vmulps        0x36116(%rip){1to8},%ymm4,%ymm4        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  98,241,77,56,219,45,16,97,3,0       // vpandd        0x36110(%rip){1to8},%ymm6,%ymm5        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  98,241,84,56,89,45,6,97,3,0         // vmulps        0x36106(%rip){1to8},%ymm5,%ymm5        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  98,241,77,56,219,53,0,97,3,0        // vpandd        0x36100(%rip){1to8},%ymm6,%ymm6        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  197,252,91,246                      // vcvtdq2ps     %ymm6,%ymm6
  .byte  98,241,76,56,89,53,246,96,3,0       // vmulps        0x360f6(%rip){1to8},%ymm6,%ymm6        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,61,91,96,3,0         // vbroadcastss  0x3605b(%rip),%ymm7        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,145                             // ja            4165 <_sk_load_565_dst_skx+0x21>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,121,0,0,0                 // lea           0x79(%rip),%r10        # 4258 <_sk_load_565_dst_skx+0x114>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  233,111,255,255,255                 // jmpq          4165 <_sk_load_565_dst_skx+0x21>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,129,89,196,100,88,4,2           // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,130,121,52,44,88                // vpmovzxwq     (%r8,%r11,2),%xmm5
  .byte  197,249,112,237,232                 // vpshufd       $0xe8,%xmm5,%xmm5
  .byte  197,251,112,237,232                 // vpshuflw      $0xe8,%xmm5,%xmm5
  .byte  196,227,89,2,229,1                  // vpblendd      $0x1,%xmm5,%xmm4,%xmm4
  .byte  233,72,255,255,255                  // jmpq          4165 <_sk_load_565_dst_skx+0x21>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,129,89,196,100,88,12,6          // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,89,196,100,88,10,5          // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,89,196,100,88,8,4           // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,130,121,51,44,88                // vpmovzxwd     (%r8,%r11,2),%xmm5
  .byte  197,251,112,237,232                 // vpshuflw      $0xe8,%xmm5,%xmm5
  .byte  197,250,112,237,232                 // vpshufhw      $0xe8,%xmm5,%xmm5
  .byte  197,249,112,237,132                 // vpshufd       $0x84,%xmm5,%xmm5
  .byte  197,209,109,228                     // vpunpckhqdq   %xmm4,%xmm5,%xmm4
  .byte  233,14,255,255,255                  // jmpq          4165 <_sk_load_565_dst_skx+0x21>
  .byte  144                                 // nop
  .byte  144                                 // nop
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,170,255,255,255,158             // ljmp          *-0x61000001(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,225                             // jmpq          *%rcx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  217,255                             // fcos
  .byte  255                                 // (bad)
  .byte  255,209                             // callq         *%rcx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,197                             // inc           %ebp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_565_skx
.globl _sk_gather_565_skx
FUNCTION(_sk_gather_565_skx)
_sk_gather_565_skx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  98,242,117,56,64,72,2               // vpmulld       0x8(%rax){1to8},%ymm1,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  196,227,249,22,192,1                // vpextrq       $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,194                 // vmovq         %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,183,20,80                     // movzwl        (%r8,%r10,2),%r10d
  .byte  71,15,183,28,88                     // movzwl        (%r8,%r11,2),%r11d
  .byte  196,193,121,110,195                 // vmovd         %r11d,%xmm0
  .byte  196,193,121,196,194,1               // vpinsrw       $0x1,%r10d,%xmm0,%xmm0
  .byte  71,15,183,12,72                     // movzwl        (%r8,%r9,2),%r9d
  .byte  196,193,121,196,193,2               // vpinsrw       $0x2,%r9d,%xmm0,%xmm0
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,249,196,192,3                   // vpinsrw       $0x3,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,96                      // movzwl        (%r8,%r12,2),%eax
  .byte  197,249,196,192,4                   // vpinsrw       $0x4,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,120                     // movzwl        (%r8,%r15,2),%eax
  .byte  197,249,196,192,5                   // vpinsrw       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,112                     // movzwl        (%r8,%r14,2),%eax
  .byte  197,249,196,192,6                   // vpinsrw       $0x6,%eax,%xmm0,%xmm0
  .byte  65,15,183,4,88                      // movzwl        (%r8,%rbx,2),%eax
  .byte  197,249,196,192,7                   // vpinsrw       $0x7,%eax,%xmm0,%xmm0
  .byte  196,226,125,51,208                  // vpmovzxwd     %xmm0,%ymm2
  .byte  98,241,109,56,219,5,59,95,3,0       // vpandd        0x35f3b(%rip){1to8},%ymm2,%ymm0        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  98,241,124,56,89,5,49,95,3,0        // vmulps        0x35f31(%rip){1to8},%ymm0,%ymm0        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  98,241,109,56,219,13,43,95,3,0      // vpandd        0x35f2b(%rip){1to8},%ymm2,%ymm1        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  98,241,116,56,89,13,33,95,3,0       // vmulps        0x35f21(%rip){1to8},%ymm1,%ymm1        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  98,241,109,56,219,21,27,95,3,0      // vpandd        0x35f1b(%rip){1to8},%ymm2,%ymm2        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  98,241,108,56,89,21,17,95,3,0       // vmulps        0x35f11(%rip){1to8},%ymm2,%ymm2        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,118,94,3,0        // vbroadcastss  0x35e76(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_565_skx
.globl _sk_store_565_skx
FUNCTION(_sk_store_565_skx)
_sk_store_565_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,98,125,24,21,69,94,3,0          // vbroadcastss  0x35e45(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,39,95,3,0          // vbroadcastss  0x35f27(%rip),%ymm11        # 3a308 <_sk_srcover_bgra_8888_sse2_lowp+0x3a0>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  196,193,53,114,241,11               // vpslld        $0xb,%ymm9,%ymm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  98,113,28,56,89,37,8,95,3,0         // vmulps        0x35f08(%rip){1to8},%ymm12,%ymm12        # 3a30c <_sk_srcover_bgra_8888_sse2_lowp+0x3a4>
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,5                // vpslld        $0x5,%ymm12,%ymm12
  .byte  196,65,29,235,201                   // vpor          %ymm9,%ymm12,%ymm9
  .byte  197,60,95,194                       // vmaxps        %ymm2,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,66,57,43,193                    // vpackusdw     %xmm9,%xmm8,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           4446 <_sk_store_565_skx+0x9b>
  .byte  196,1,122,127,4,88                  // vmovdqu       %xmm8,(%r8,%r11,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,235                             // ja            4442 <_sk_store_565_skx+0x97>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,78,0,0,0                  // lea           0x4e(%rip),%r10        # 44b0 <_sk_store_565_skx+0x105>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,3,121,21,4,88,0                 // vpextrw       $0x0,%xmm8,(%r8,%r11,2)
  .byte  235,206                             // jmp           4442 <_sk_store_565_skx+0x97>
  .byte  196,3,121,21,68,88,4,2              // vpextrw       $0x2,%xmm8,0x4(%r8,%r11,2)
  .byte  196,66,121,52,192                   // vpmovzxwq     %xmm8,%xmm8
  .byte  98,18,126,8,52,4,88                 // vpmovqw       %xmm8,(%r8,%r11,2)
  .byte  235,184                             // jmp           4442 <_sk_store_565_skx+0x97>
  .byte  196,3,121,21,68,88,12,6             // vpextrw       $0x6,%xmm8,0xc(%r8,%r11,2)
  .byte  196,3,121,21,68,88,10,5             // vpextrw       $0x5,%xmm8,0xa(%r8,%r11,2)
  .byte  196,3,121,21,68,88,8,4              // vpextrw       $0x4,%xmm8,0x8(%r8,%r11,2)
  .byte  196,66,121,51,192                   // vpmovzxwd     %xmm8,%xmm8
  .byte  98,18,126,8,51,4,88                 // vpmovdw       %xmm8,(%r8,%r11,2)
  .byte  235,146                             // jmp           4442 <_sk_store_565_skx+0x97>
  .byte  187,255,255,255,204                 // mov           $0xccffffff,%ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,242                             // push          %rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  234                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,226                             // jmpq          *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  218,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_4444_skx
.globl _sk_load_4444_skx
FUNCTION(_sk_load_4444_skx)
_sk_load_4444_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,111                             // jne           4556 <_sk_load_4444_skx+0x8a>
  .byte  196,129,122,111,4,88                // vmovdqu       (%r8,%r11,2),%xmm0
  .byte  196,226,125,51,216                  // vpmovzxwd     %xmm0,%ymm3
  .byte  98,241,101,56,219,5,20,94,3,0       // vpandd        0x35e14(%rip){1to8},%ymm3,%ymm0        # 3a310 <_sk_srcover_bgra_8888_sse2_lowp+0x3a8>
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  98,241,124,56,89,5,10,94,3,0        // vmulps        0x35e0a(%rip){1to8},%ymm0,%ymm0        # 3a314 <_sk_srcover_bgra_8888_sse2_lowp+0x3ac>
  .byte  98,241,101,56,219,13,4,94,3,0       // vpandd        0x35e04(%rip){1to8},%ymm3,%ymm1        # 3a318 <_sk_srcover_bgra_8888_sse2_lowp+0x3b0>
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  98,241,116,56,89,13,250,93,3,0      // vmulps        0x35dfa(%rip){1to8},%ymm1,%ymm1        # 3a31c <_sk_srcover_bgra_8888_sse2_lowp+0x3b4>
  .byte  98,241,101,56,219,21,244,93,3,0     // vpandd        0x35df4(%rip){1to8},%ymm3,%ymm2        # 3a320 <_sk_srcover_bgra_8888_sse2_lowp+0x3b8>
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  98,241,108,56,89,21,234,93,3,0      // vmulps        0x35dea(%rip){1to8},%ymm2,%ymm2        # 3a324 <_sk_srcover_bgra_8888_sse2_lowp+0x3bc>
  .byte  98,241,101,56,219,29,228,93,3,0     // vpandd        0x35de4(%rip){1to8},%ymm3,%ymm3        # 3a328 <_sk_srcover_bgra_8888_sse2_lowp+0x3c0>
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  98,241,100,56,89,29,218,93,3,0      // vmulps        0x35dda(%rip){1to8},%ymm3,%ymm3        # 3a32c <_sk_srcover_bgra_8888_sse2_lowp+0x3c4>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,130                             // ja            44ed <_sk_load_4444_skx+0x21>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,122,0,0,0                 // lea           0x7a(%rip),%r10        # 45f0 <_sk_load_4444_skx+0x124>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  233,96,255,255,255                  // jmpq          44ed <_sk_load_4444_skx+0x21>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,129,121,196,68,88,4,2           // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,130,121,52,12,88                // vpmovzxwq     (%r8,%r11,2),%xmm1
  .byte  197,249,112,201,232                 // vpshufd       $0xe8,%xmm1,%xmm1
  .byte  197,251,112,201,232                 // vpshuflw      $0xe8,%xmm1,%xmm1
  .byte  196,227,121,2,193,1                 // vpblendd      $0x1,%xmm1,%xmm0,%xmm0
  .byte  233,57,255,255,255                  // jmpq          44ed <_sk_load_4444_skx+0x21>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,129,121,196,68,88,12,6          // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,196,68,88,10,5          // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,196,68,88,8,4           // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,130,121,51,12,88                // vpmovzxwd     (%r8,%r11,2),%xmm1
  .byte  197,251,112,201,232                 // vpshuflw      $0xe8,%xmm1,%xmm1
  .byte  197,250,112,201,232                 // vpshufhw      $0xe8,%xmm1,%xmm1
  .byte  197,249,112,201,132                 // vpshufd       $0x84,%xmm1,%xmm1
  .byte  197,241,109,192                     // vpunpckhqdq   %xmm0,%xmm1,%xmm0
  .byte  233,255,254,255,255                 // jmpq          44ed <_sk_load_4444_skx+0x21>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  143                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,169,255,255,255,157             // ljmp          *-0x62000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,224                             // jmpq          *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  216,255                             // fdivr         %st(7),%st
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_4444_dst_skx
.globl _sk_load_4444_dst_skx
FUNCTION(_sk_load_4444_dst_skx)
_sk_load_4444_dst_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,111                             // jne           4696 <_sk_load_4444_dst_skx+0x8a>
  .byte  196,129,122,111,36,88               // vmovdqu       (%r8,%r11,2),%xmm4
  .byte  196,226,125,51,252                  // vpmovzxwd     %xmm4,%ymm7
  .byte  98,241,69,56,219,37,212,92,3,0      // vpandd        0x35cd4(%rip){1to8},%ymm7,%ymm4        # 3a310 <_sk_srcover_bgra_8888_sse2_lowp+0x3a8>
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  98,241,92,56,89,37,202,92,3,0       // vmulps        0x35cca(%rip){1to8},%ymm4,%ymm4        # 3a314 <_sk_srcover_bgra_8888_sse2_lowp+0x3ac>
  .byte  98,241,69,56,219,45,196,92,3,0      // vpandd        0x35cc4(%rip){1to8},%ymm7,%ymm5        # 3a318 <_sk_srcover_bgra_8888_sse2_lowp+0x3b0>
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  98,241,84,56,89,45,186,92,3,0       // vmulps        0x35cba(%rip){1to8},%ymm5,%ymm5        # 3a31c <_sk_srcover_bgra_8888_sse2_lowp+0x3b4>
  .byte  98,241,69,56,219,53,180,92,3,0      // vpandd        0x35cb4(%rip){1to8},%ymm7,%ymm6        # 3a320 <_sk_srcover_bgra_8888_sse2_lowp+0x3b8>
  .byte  197,252,91,246                      // vcvtdq2ps     %ymm6,%ymm6
  .byte  98,241,76,56,89,53,170,92,3,0       // vmulps        0x35caa(%rip){1to8},%ymm6,%ymm6        # 3a324 <_sk_srcover_bgra_8888_sse2_lowp+0x3bc>
  .byte  98,241,69,56,219,61,164,92,3,0      // vpandd        0x35ca4(%rip){1to8},%ymm7,%ymm7        # 3a328 <_sk_srcover_bgra_8888_sse2_lowp+0x3c0>
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  98,241,68,56,89,61,154,92,3,0       // vmulps        0x35c9a(%rip){1to8},%ymm7,%ymm7        # 3a32c <_sk_srcover_bgra_8888_sse2_lowp+0x3c4>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,130                             // ja            462d <_sk_load_4444_dst_skx+0x21>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,122,0,0,0                 // lea           0x7a(%rip),%r10        # 4730 <_sk_load_4444_dst_skx+0x124>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  233,96,255,255,255                  // jmpq          462d <_sk_load_4444_dst_skx+0x21>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,129,89,196,100,88,4,2           // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,130,121,52,44,88                // vpmovzxwq     (%r8,%r11,2),%xmm5
  .byte  197,249,112,237,232                 // vpshufd       $0xe8,%xmm5,%xmm5
  .byte  197,251,112,237,232                 // vpshuflw      $0xe8,%xmm5,%xmm5
  .byte  196,227,89,2,229,1                  // vpblendd      $0x1,%xmm5,%xmm4,%xmm4
  .byte  233,57,255,255,255                  // jmpq          462d <_sk_load_4444_dst_skx+0x21>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,129,89,196,100,88,12,6          // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,89,196,100,88,10,5          // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,89,196,100,88,8,4           // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,130,121,51,44,88                // vpmovzxwd     (%r8,%r11,2),%xmm5
  .byte  197,251,112,237,232                 // vpshuflw      $0xe8,%xmm5,%xmm5
  .byte  197,250,112,237,232                 // vpshufhw      $0xe8,%xmm5,%xmm5
  .byte  197,249,112,237,132                 // vpshufd       $0x84,%xmm5,%xmm5
  .byte  197,209,109,228                     // vpunpckhqdq   %xmm4,%xmm5,%xmm4
  .byte  233,255,254,255,255                 // jmpq          462d <_sk_load_4444_dst_skx+0x21>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  143                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,169,255,255,255,157             // ljmp          *-0x62000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,224                             // jmpq          *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  216,255                             // fdivr         %st(7),%st
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_4444_skx
.globl _sk_gather_4444_skx
FUNCTION(_sk_gather_4444_skx)
_sk_gather_4444_skx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  98,242,117,56,64,72,2               // vpmulld       0x8(%rax){1to8},%ymm1,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  196,227,249,22,192,1                // vpextrq       $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,194                 // vmovq         %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,183,20,80                     // movzwl        (%r8,%r10,2),%r10d
  .byte  71,15,183,28,88                     // movzwl        (%r8,%r11,2),%r11d
  .byte  196,193,121,110,195                 // vmovd         %r11d,%xmm0
  .byte  196,193,121,196,194,1               // vpinsrw       $0x1,%r10d,%xmm0,%xmm0
  .byte  71,15,183,12,72                     // movzwl        (%r8,%r9,2),%r9d
  .byte  196,193,121,196,193,2               // vpinsrw       $0x2,%r9d,%xmm0,%xmm0
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,249,196,192,3                   // vpinsrw       $0x3,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,96                      // movzwl        (%r8,%r12,2),%eax
  .byte  197,249,196,192,4                   // vpinsrw       $0x4,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,120                     // movzwl        (%r8,%r15,2),%eax
  .byte  197,249,196,192,5                   // vpinsrw       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,112                     // movzwl        (%r8,%r14,2),%eax
  .byte  197,249,196,192,6                   // vpinsrw       $0x6,%eax,%xmm0,%xmm0
  .byte  65,15,183,4,88                      // movzwl        (%r8,%rbx,2),%eax
  .byte  197,249,196,192,7                   // vpinsrw       $0x7,%eax,%xmm0,%xmm0
  .byte  196,226,125,51,216                  // vpmovzxwd     %xmm0,%ymm3
  .byte  98,241,101,56,219,5,223,90,3,0      // vpandd        0x35adf(%rip){1to8},%ymm3,%ymm0        # 3a310 <_sk_srcover_bgra_8888_sse2_lowp+0x3a8>
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  98,241,124,56,89,5,213,90,3,0       // vmulps        0x35ad5(%rip){1to8},%ymm0,%ymm0        # 3a314 <_sk_srcover_bgra_8888_sse2_lowp+0x3ac>
  .byte  98,241,101,56,219,13,207,90,3,0     // vpandd        0x35acf(%rip){1to8},%ymm3,%ymm1        # 3a318 <_sk_srcover_bgra_8888_sse2_lowp+0x3b0>
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  98,241,116,56,89,13,197,90,3,0      // vmulps        0x35ac5(%rip){1to8},%ymm1,%ymm1        # 3a31c <_sk_srcover_bgra_8888_sse2_lowp+0x3b4>
  .byte  98,241,101,56,219,21,191,90,3,0     // vpandd        0x35abf(%rip){1to8},%ymm3,%ymm2        # 3a320 <_sk_srcover_bgra_8888_sse2_lowp+0x3b8>
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  98,241,108,56,89,21,181,90,3,0      // vmulps        0x35ab5(%rip){1to8},%ymm2,%ymm2        # 3a324 <_sk_srcover_bgra_8888_sse2_lowp+0x3bc>
  .byte  98,241,101,56,219,29,175,90,3,0     // vpandd        0x35aaf(%rip){1to8},%ymm3,%ymm3        # 3a328 <_sk_srcover_bgra_8888_sse2_lowp+0x3c0>
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  98,241,100,56,89,29,165,90,3,0      // vmulps        0x35aa5(%rip){1to8},%ymm3,%ymm3        # 3a32c <_sk_srcover_bgra_8888_sse2_lowp+0x3c4>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_4444_skx
.globl _sk_store_4444_skx
FUNCTION(_sk_store_4444_skx)
_sk_store_4444_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,98,125,24,21,94,89,3,0          // vbroadcastss  0x3595e(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,104,90,3,0         // vbroadcastss  0x35a68(%rip),%ymm11        # 3a330 <_sk_srcover_bgra_8888_sse2_lowp+0x3c8>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  196,193,53,114,241,12               // vpslld        $0xc,%ymm9,%ymm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,8                // vpslld        $0x8,%ymm12,%ymm12
  .byte  196,65,29,235,201                   // vpor          %ymm9,%ymm12,%ymm9
  .byte  197,60,95,226                       // vmaxps        %ymm2,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,4                // vpslld        $0x4,%ymm12,%ymm12
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,65,29,235,192                   // vpor          %ymm8,%ymm12,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,66,57,43,193                    // vpackusdw     %xmm9,%xmm8,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           4946 <_sk_store_4444_skx+0xb4>
  .byte  196,1,122,127,4,88                  // vmovdqu       %xmm8,(%r8,%r11,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,235                             // ja            4942 <_sk_store_4444_skx+0xb0>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,78,0,0,0                  // lea           0x4e(%rip),%r10        # 49b0 <_sk_store_4444_skx+0x11e>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,3,121,21,4,88,0                 // vpextrw       $0x0,%xmm8,(%r8,%r11,2)
  .byte  235,206                             // jmp           4942 <_sk_store_4444_skx+0xb0>
  .byte  196,3,121,21,68,88,4,2              // vpextrw       $0x2,%xmm8,0x4(%r8,%r11,2)
  .byte  196,66,121,52,192                   // vpmovzxwq     %xmm8,%xmm8
  .byte  98,18,126,8,52,4,88                 // vpmovqw       %xmm8,(%r8,%r11,2)
  .byte  235,184                             // jmp           4942 <_sk_store_4444_skx+0xb0>
  .byte  196,3,121,21,68,88,12,6             // vpextrw       $0x6,%xmm8,0xc(%r8,%r11,2)
  .byte  196,3,121,21,68,88,10,5             // vpextrw       $0x5,%xmm8,0xa(%r8,%r11,2)
  .byte  196,3,121,21,68,88,8,4              // vpextrw       $0x4,%xmm8,0x8(%r8,%r11,2)
  .byte  196,66,121,51,192                   // vpmovzxwd     %xmm8,%xmm8
  .byte  98,18,126,8,51,4,88                 // vpmovdw       %xmm8,(%r8,%r11,2)
  .byte  235,146                             // jmp           4942 <_sk_store_4444_skx+0xb0>
  .byte  187,255,255,255,204                 // mov           $0xccffffff,%ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,242                             // push          %rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  234                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,226                             // jmpq          *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  218,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_8888_skx
.globl _sk_load_8888_skx
FUNCTION(_sk_load_8888_skx)
_sk_load_8888_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,97                              // jne           4a49 <_sk_load_8888_skx+0x7d>
  .byte  196,129,126,111,28,152              // vmovdqu       (%r8,%r11,4),%ymm3
  .byte  184,17,17,17,17                     // mov           $0x11111111,%eax
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,241,127,169,111,195              // vmovdqu8      %ymm3,%ymm0{%k1}{z}
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,5,134,88,3,0          // vbroadcastss  0x35886(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  197,245,114,211,8                   // vpsrld        $0x8,%ymm3,%ymm1
  .byte  98,241,127,169,111,201              // vmovdqu8      %ymm1,%ymm1{%k1}{z}
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  197,237,114,211,16                  // vpsrld        $0x10,%ymm3,%ymm2
  .byte  98,241,127,169,111,210              // vmovdqu8      %ymm2,%ymm2{%k1}{z}
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  197,229,114,211,24                  // vpsrld        $0x18,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,229,239,219                     // vpxor         %ymm3,%ymm3,%ymm3
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,144                             // ja            49ee <_sk_load_8888_skx+0x22>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,139,0,0,0                 // lea           0x8b(%rip),%r10        # 4af4 <_sk_load_8888_skx+0x128>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,28,152              // vmovd         (%r8,%r11,4),%xmm3
  .byte  233,113,255,255,255                 // jmpq          49ee <_sk_load_8888_skx+0x22>
  .byte  196,129,121,110,68,152,8            // vmovd         0x8(%r8,%r11,4),%xmm0
  .byte  176,4                               // mov           $0x4,%al
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,242,125,169,137,216              // vpexpandd     %ymm0,%ymm3{%k1}{z}
  .byte  196,130,121,53,4,152                // vpmovzxdq     (%r8,%r11,4),%xmm0
  .byte  197,249,112,192,232                 // vpshufd       $0xe8,%xmm0,%xmm0
  .byte  196,227,101,2,216,3                 // vpblendd      $0x3,%ymm0,%ymm3,%ymm3
  .byte  233,72,255,255,255                  // jmpq          49ee <_sk_load_8888_skx+0x22>
  .byte  196,129,121,110,68,152,24           // vmovd         0x18(%r8,%r11,4),%xmm0
  .byte  176,64                              // mov           $0x40,%al
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,242,125,169,137,216              // vpexpandd     %ymm0,%ymm3{%k1}{z}
  .byte  196,227,125,57,216,1                // vextracti128  $0x1,%ymm3,%xmm0
  .byte  196,131,121,34,68,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm0,%xmm0
  .byte  196,227,101,56,216,1                // vinserti128   $0x1,%xmm0,%ymm3,%ymm3
  .byte  196,227,125,57,216,1                // vextracti128  $0x1,%ymm3,%xmm0
  .byte  196,131,121,34,68,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm0,%xmm0
  .byte  196,227,101,56,216,1                // vinserti128   $0x1,%xmm0,%ymm3,%ymm3
  .byte  196,129,122,111,4,152               // vmovdqu       (%r8,%r11,4),%xmm0
  .byte  196,227,125,2,219,240               // vpblendd      $0xf0,%ymm3,%ymm0,%ymm3
  .byte  233,252,254,255,255                 // jmpq          49ee <_sk_load_8888_skx+0x22>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  126,255                             // jle           4af5 <_sk_load_8888_skx+0x129>
  .byte  255                                 // (bad)
  .byte  255,156,255,255,255,137,255         // lcall         *-0x760001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  237                                 // in            (%dx),%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  217,255                             // fcos
  .byte  255                                 // (bad)
  .byte  255,197                             // inc           %ebp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  178,255                             // mov           $0xff,%dl
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_8888_dst_skx
.globl _sk_load_8888_dst_skx
FUNCTION(_sk_load_8888_dst_skx)
_sk_load_8888_dst_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,97                              // jne           4b8d <_sk_load_8888_dst_skx+0x7d>
  .byte  196,129,126,111,60,152              // vmovdqu       (%r8,%r11,4),%ymm7
  .byte  184,17,17,17,17                     // mov           $0x11111111,%eax
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,241,127,169,111,231              // vmovdqu8      %ymm7,%ymm4{%k1}{z}
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,98,125,24,5,66,87,3,0           // vbroadcastss  0x35742(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,92,89,224                   // vmulps        %ymm8,%ymm4,%ymm4
  .byte  197,213,114,215,8                   // vpsrld        $0x8,%ymm7,%ymm5
  .byte  98,241,127,169,111,237              // vmovdqu8      %ymm5,%ymm5{%k1}{z}
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  196,193,84,89,232                   // vmulps        %ymm8,%ymm5,%ymm5
  .byte  197,205,114,215,16                  // vpsrld        $0x10,%ymm7,%ymm6
  .byte  98,241,127,169,111,246              // vmovdqu8      %ymm6,%ymm6{%k1}{z}
  .byte  197,252,91,246                      // vcvtdq2ps     %ymm6,%ymm6
  .byte  196,193,76,89,240                   // vmulps        %ymm8,%ymm6,%ymm6
  .byte  197,197,114,215,24                  // vpsrld        $0x18,%ymm7,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,193,68,89,248                   // vmulps        %ymm8,%ymm7,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,144                             // ja            4b32 <_sk_load_8888_dst_skx+0x22>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,139,0,0,0                 // lea           0x8b(%rip),%r10        # 4c38 <_sk_load_8888_dst_skx+0x128>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,60,152              // vmovd         (%r8,%r11,4),%xmm7
  .byte  233,113,255,255,255                 // jmpq          4b32 <_sk_load_8888_dst_skx+0x22>
  .byte  196,129,121,110,100,152,8           // vmovd         0x8(%r8,%r11,4),%xmm4
  .byte  176,4                               // mov           $0x4,%al
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,242,125,169,137,252              // vpexpandd     %ymm4,%ymm7{%k1}{z}
  .byte  196,130,121,53,36,152               // vpmovzxdq     (%r8,%r11,4),%xmm4
  .byte  197,249,112,228,232                 // vpshufd       $0xe8,%xmm4,%xmm4
  .byte  196,227,69,2,252,3                  // vpblendd      $0x3,%ymm4,%ymm7,%ymm7
  .byte  233,72,255,255,255                  // jmpq          4b32 <_sk_load_8888_dst_skx+0x22>
  .byte  196,129,121,110,100,152,24          // vmovd         0x18(%r8,%r11,4),%xmm4
  .byte  176,64                              // mov           $0x40,%al
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,242,125,169,137,252              // vpexpandd     %ymm4,%ymm7{%k1}{z}
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,129,122,111,36,152              // vmovdqu       (%r8,%r11,4),%xmm4
  .byte  196,227,93,2,255,240                // vpblendd      $0xf0,%ymm7,%ymm4,%ymm7
  .byte  233,252,254,255,255                 // jmpq          4b32 <_sk_load_8888_dst_skx+0x22>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  126,255                             // jle           4c39 <_sk_load_8888_dst_skx+0x129>
  .byte  255                                 // (bad)
  .byte  255,156,255,255,255,137,255         // lcall         *-0x760001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  237                                 // in            (%dx),%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  217,255                             // fcos
  .byte  255                                 // (bad)
  .byte  255,197                             // inc           %ebp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  178,255                             // mov           $0xff,%dl
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_8888_skx
.globl _sk_gather_8888_skx
FUNCTION(_sk_gather_8888_skx)
_sk_gather_8888_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  98,242,117,56,64,72,2               // vpmulld       0x8(%rax){1to8},%ymm1,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  196,66,101,144,4,128                // vpgatherdd    %ymm3,(%r8,%ymm0,4),%ymm8
  .byte  184,17,17,17,17                     // mov           $0x11111111,%eax
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,209,127,169,111,192              // vmovdqu8      %ymm8,%ymm0{%k1}{z}
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,29,213,85,3,0        // vbroadcastss  0x355d5(%rip),%ymm3        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  196,193,117,114,208,8               // vpsrld        $0x8,%ymm8,%ymm1
  .byte  98,241,127,169,111,201              // vmovdqu8      %ymm1,%ymm1{%k1}{z}
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  197,244,89,203                      // vmulps        %ymm3,%ymm1,%ymm1
  .byte  196,193,109,114,208,16              // vpsrld        $0x10,%ymm8,%ymm2
  .byte  98,241,127,169,111,210              // vmovdqu8      %ymm2,%ymm2{%k1}{z}
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  197,236,89,211                      // vmulps        %ymm3,%ymm2,%ymm2
  .byte  196,193,61,114,208,24               // vpsrld        $0x18,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_8888_skx
.globl _sk_store_8888_skx
FUNCTION(_sk_store_8888_skx)
_sk_store_8888_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,98,125,24,21,245,84,3,0         // vbroadcastss  0x354f5(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,19,85,3,0          // vbroadcastss  0x35513(%rip),%ymm11        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,8                // vpslld        $0x8,%ymm12,%ymm12
  .byte  196,65,29,235,201                   // vpor          %ymm9,%ymm12,%ymm9
  .byte  197,60,95,226                       // vmaxps        %ymm2,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,16               // vpslld        $0x10,%ymm12,%ymm12
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,193,61,114,240,24               // vpslld        $0x18,%ymm8,%ymm8
  .byte  196,65,29,235,192                   // vpor          %ymm8,%ymm12,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           4da4 <_sk_store_8888_skx+0xaa>
  .byte  196,1,126,127,4,152                 // vmovdqu       %ymm8,(%r8,%r11,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,235                             // ja            4da0 <_sk_store_8888_skx+0xa6>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,88,0,0,0                  // lea           0x58(%rip),%r10        # 4e18 <_sk_store_8888_skx+0x11e>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,121,126,4,152                 // vmovd         %xmm8,(%r8,%r11,4)
  .byte  235,207                             // jmp           4da0 <_sk_store_8888_skx+0xa6>
  .byte  196,3,121,22,68,152,8,2             // vpextrd       $0x2,%xmm8,0x8(%r8,%r11,4)
  .byte  196,66,121,53,192                   // vpmovzxdq     %xmm8,%xmm8
  .byte  98,18,126,8,53,4,152                // vpmovqd       %xmm8,(%r8,%r11,4)
  .byte  235,185                             // jmp           4da0 <_sk_store_8888_skx+0xa6>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,24,2            // vpextrd       $0x2,%xmm9,0x18(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,20,1            // vpextrd       $0x1,%xmm9,0x14(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,1,121,126,76,152,16             // vmovd         %xmm9,0x10(%r8,%r11,4)
  .byte  196,1,122,127,4,152                 // vmovdqu       %xmm8,(%r8,%r11,4)
  .byte  235,136                             // jmp           4da0 <_sk_store_8888_skx+0xa6>
  .byte  177,255                             // mov           $0xff,%cl
  .byte  255                                 // (bad)
  .byte  255,193                             // inc           %ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  185,255,255,255,248                 // mov           $0xf8ffffff,%ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  235,255                             // jmp           4e29 <_sk_store_8888_skx+0x12f>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  221,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,207                             // dec           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_bgra_skx
.globl _sk_load_bgra_skx
FUNCTION(_sk_load_bgra_skx)
_sk_load_bgra_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,97                              // jne           4eb1 <_sk_load_bgra_skx+0x7d>
  .byte  196,129,126,111,28,152              // vmovdqu       (%r8,%r11,4),%ymm3
  .byte  184,17,17,17,17                     // mov           $0x11111111,%eax
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,241,127,169,111,195              // vmovdqu8      %ymm3,%ymm0{%k1}{z}
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,5,30,84,3,0           // vbroadcastss  0x3541e(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,124,89,208                  // vmulps        %ymm8,%ymm0,%ymm2
  .byte  197,253,114,211,8                   // vpsrld        $0x8,%ymm3,%ymm0
  .byte  98,241,127,169,111,192              // vmovdqu8      %ymm0,%ymm0{%k1}{z}
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,193,124,89,200                  // vmulps        %ymm8,%ymm0,%ymm1
  .byte  197,253,114,211,16                  // vpsrld        $0x10,%ymm3,%ymm0
  .byte  98,241,127,169,111,192              // vmovdqu8      %ymm0,%ymm0{%k1}{z}
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  197,229,114,211,24                  // vpsrld        $0x18,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,229,239,219                     // vpxor         %ymm3,%ymm3,%ymm3
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,144                             // ja            4e56 <_sk_load_bgra_skx+0x22>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,139,0,0,0                 // lea           0x8b(%rip),%r10        # 4f5c <_sk_load_bgra_skx+0x128>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,28,152              // vmovd         (%r8,%r11,4),%xmm3
  .byte  233,113,255,255,255                 // jmpq          4e56 <_sk_load_bgra_skx+0x22>
  .byte  196,129,121,110,68,152,8            // vmovd         0x8(%r8,%r11,4),%xmm0
  .byte  176,4                               // mov           $0x4,%al
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,242,125,169,137,216              // vpexpandd     %ymm0,%ymm3{%k1}{z}
  .byte  196,130,121,53,4,152                // vpmovzxdq     (%r8,%r11,4),%xmm0
  .byte  197,249,112,192,232                 // vpshufd       $0xe8,%xmm0,%xmm0
  .byte  196,227,101,2,216,3                 // vpblendd      $0x3,%ymm0,%ymm3,%ymm3
  .byte  233,72,255,255,255                  // jmpq          4e56 <_sk_load_bgra_skx+0x22>
  .byte  196,129,121,110,68,152,24           // vmovd         0x18(%r8,%r11,4),%xmm0
  .byte  176,64                              // mov           $0x40,%al
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,242,125,169,137,216              // vpexpandd     %ymm0,%ymm3{%k1}{z}
  .byte  196,227,125,57,216,1                // vextracti128  $0x1,%ymm3,%xmm0
  .byte  196,131,121,34,68,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm0,%xmm0
  .byte  196,227,101,56,216,1                // vinserti128   $0x1,%xmm0,%ymm3,%ymm3
  .byte  196,227,125,57,216,1                // vextracti128  $0x1,%ymm3,%xmm0
  .byte  196,131,121,34,68,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm0,%xmm0
  .byte  196,227,101,56,216,1                // vinserti128   $0x1,%xmm0,%ymm3,%ymm3
  .byte  196,129,122,111,4,152               // vmovdqu       (%r8,%r11,4),%xmm0
  .byte  196,227,125,2,219,240               // vpblendd      $0xf0,%ymm3,%ymm0,%ymm3
  .byte  233,252,254,255,255                 // jmpq          4e56 <_sk_load_bgra_skx+0x22>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  126,255                             // jle           4f5d <_sk_load_bgra_skx+0x129>
  .byte  255                                 // (bad)
  .byte  255,156,255,255,255,137,255         // lcall         *-0x760001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  237                                 // in            (%dx),%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  217,255                             // fcos
  .byte  255                                 // (bad)
  .byte  255,197                             // inc           %ebp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  178,255                             // mov           $0xff,%dl
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_bgra_dst_skx
.globl _sk_load_bgra_dst_skx
FUNCTION(_sk_load_bgra_dst_skx)
_sk_load_bgra_dst_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,97                              // jne           4ff5 <_sk_load_bgra_dst_skx+0x7d>
  .byte  196,129,126,111,60,152              // vmovdqu       (%r8,%r11,4),%ymm7
  .byte  184,17,17,17,17                     // mov           $0x11111111,%eax
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,241,127,169,111,231              // vmovdqu8      %ymm7,%ymm4{%k1}{z}
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,98,125,24,5,218,82,3,0          // vbroadcastss  0x352da(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,92,89,240                   // vmulps        %ymm8,%ymm4,%ymm6
  .byte  197,221,114,215,8                   // vpsrld        $0x8,%ymm7,%ymm4
  .byte  98,241,127,169,111,228              // vmovdqu8      %ymm4,%ymm4{%k1}{z}
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,193,92,89,232                   // vmulps        %ymm8,%ymm4,%ymm5
  .byte  197,221,114,215,16                  // vpsrld        $0x10,%ymm7,%ymm4
  .byte  98,241,127,169,111,228              // vmovdqu8      %ymm4,%ymm4{%k1}{z}
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,193,92,89,224                   // vmulps        %ymm8,%ymm4,%ymm4
  .byte  197,197,114,215,24                  // vpsrld        $0x18,%ymm7,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,193,68,89,248                   // vmulps        %ymm8,%ymm7,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,144                             // ja            4f9a <_sk_load_bgra_dst_skx+0x22>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,139,0,0,0                 // lea           0x8b(%rip),%r10        # 50a0 <_sk_load_bgra_dst_skx+0x128>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,60,152              // vmovd         (%r8,%r11,4),%xmm7
  .byte  233,113,255,255,255                 // jmpq          4f9a <_sk_load_bgra_dst_skx+0x22>
  .byte  196,129,121,110,100,152,8           // vmovd         0x8(%r8,%r11,4),%xmm4
  .byte  176,4                               // mov           $0x4,%al
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,242,125,169,137,252              // vpexpandd     %ymm4,%ymm7{%k1}{z}
  .byte  196,130,121,53,36,152               // vpmovzxdq     (%r8,%r11,4),%xmm4
  .byte  197,249,112,228,232                 // vpshufd       $0xe8,%xmm4,%xmm4
  .byte  196,227,69,2,252,3                  // vpblendd      $0x3,%ymm4,%ymm7,%ymm7
  .byte  233,72,255,255,255                  // jmpq          4f9a <_sk_load_bgra_dst_skx+0x22>
  .byte  196,129,121,110,100,152,24          // vmovd         0x18(%r8,%r11,4),%xmm4
  .byte  176,64                              // mov           $0x40,%al
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,242,125,169,137,252              // vpexpandd     %ymm4,%ymm7{%k1}{z}
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,129,122,111,36,152              // vmovdqu       (%r8,%r11,4),%xmm4
  .byte  196,227,93,2,255,240                // vpblendd      $0xf0,%ymm7,%ymm4,%ymm7
  .byte  233,252,254,255,255                 // jmpq          4f9a <_sk_load_bgra_dst_skx+0x22>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  126,255                             // jle           50a1 <_sk_load_bgra_dst_skx+0x129>
  .byte  255                                 // (bad)
  .byte  255,156,255,255,255,137,255         // lcall         *-0x760001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  237                                 // in            (%dx),%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  217,255                             // fcos
  .byte  255                                 // (bad)
  .byte  255,197                             // inc           %ebp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  178,255                             // mov           $0xff,%dl
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_bgra_skx
.globl _sk_gather_bgra_skx
FUNCTION(_sk_gather_bgra_skx)
_sk_gather_bgra_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  98,242,117,56,64,72,2               // vpmulld       0x8(%rax){1to8},%ymm1,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  196,66,101,144,4,128                // vpgatherdd    %ymm3,(%r8,%ymm0,4),%ymm8
  .byte  184,17,17,17,17                     // mov           $0x11111111,%eax
  .byte  197,251,146,200                     // kmovd         %eax,%k1
  .byte  98,209,127,169,111,192              // vmovdqu8      %ymm8,%ymm0{%k1}{z}
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,29,109,81,3,0        // vbroadcastss  0x3516d(%rip),%ymm3        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,252,89,211                      // vmulps        %ymm3,%ymm0,%ymm2
  .byte  196,193,125,114,208,8               // vpsrld        $0x8,%ymm8,%ymm0
  .byte  98,241,127,169,111,192              // vmovdqu8      %ymm0,%ymm0{%k1}{z}
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  197,252,89,203                      // vmulps        %ymm3,%ymm0,%ymm1
  .byte  196,193,125,114,208,16              // vpsrld        $0x10,%ymm8,%ymm0
  .byte  98,241,127,169,111,192              // vmovdqu8      %ymm0,%ymm0{%k1}{z}
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  196,193,61,114,208,24               // vpsrld        $0x18,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_bgra_skx
.globl _sk_store_bgra_skx
FUNCTION(_sk_store_bgra_skx)
_sk_store_bgra_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,202                       // vmaxps        %ymm2,%ymm8,%ymm9
  .byte  196,98,125,24,21,141,80,3,0         // vbroadcastss  0x3508d(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,171,80,3,0         // vbroadcastss  0x350ab(%rip),%ymm11        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,8                // vpslld        $0x8,%ymm12,%ymm12
  .byte  196,65,29,235,201                   // vpor          %ymm9,%ymm12,%ymm9
  .byte  197,60,95,224                       // vmaxps        %ymm0,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,16               // vpslld        $0x10,%ymm12,%ymm12
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,193,61,114,240,24               // vpslld        $0x18,%ymm8,%ymm8
  .byte  196,65,29,235,192                   // vpor          %ymm8,%ymm12,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           520c <_sk_store_bgra_skx+0xaa>
  .byte  196,1,126,127,4,152                 // vmovdqu       %ymm8,(%r8,%r11,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,128,193,255                      // add           $0xff,%r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,235                             // ja            5208 <_sk_store_bgra_skx+0xa6>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,88,0,0,0                  // lea           0x58(%rip),%r10        # 5280 <_sk_store_bgra_skx+0x11e>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,121,126,4,152                 // vmovd         %xmm8,(%r8,%r11,4)
  .byte  235,207                             // jmp           5208 <_sk_store_bgra_skx+0xa6>
  .byte  196,3,121,22,68,152,8,2             // vpextrd       $0x2,%xmm8,0x8(%r8,%r11,4)
  .byte  196,66,121,53,192                   // vpmovzxdq     %xmm8,%xmm8
  .byte  98,18,126,8,53,4,152                // vpmovqd       %xmm8,(%r8,%r11,4)
  .byte  235,185                             // jmp           5208 <_sk_store_bgra_skx+0xa6>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,24,2            // vpextrd       $0x2,%xmm9,0x18(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,20,1            // vpextrd       $0x1,%xmm9,0x14(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,1,121,126,76,152,16             // vmovd         %xmm9,0x10(%r8,%r11,4)
  .byte  196,1,122,127,4,152                 // vmovdqu       %xmm8,(%r8,%r11,4)
  .byte  235,136                             // jmp           5208 <_sk_store_bgra_skx+0xa6>
  .byte  177,255                             // mov           $0xff,%cl
  .byte  255                                 // (bad)
  .byte  255,193                             // inc           %ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  185,255,255,255,248                 // mov           $0xf8ffffff,%ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  235,255                             // jmp           5291 <_sk_store_bgra_skx+0x12f>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  221,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,207                             // dec           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_f16_skx
.globl _sk_load_f16_skx
FUNCTION(_sk_load_f16_skx)
_sk_load_f16_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,101                             // jne           531d <_sk_load_f16_skx+0x81>
  .byte  196,65,121,16,4,192                 // vmovupd       (%r8,%rax,8),%xmm8
  .byte  196,193,121,16,84,192,16            // vmovupd       0x10(%r8,%rax,8),%xmm2
  .byte  196,193,121,16,76,192,32            // vmovupd       0x20(%r8,%rax,8),%xmm1
  .byte  196,65,122,111,76,192,48            // vmovdqu       0x30(%r8,%rax,8),%xmm9
  .byte  197,185,97,194                      // vpunpcklwd    %xmm2,%xmm8,%xmm0
  .byte  197,185,105,210                     // vpunpckhwd    %xmm2,%xmm8,%xmm2
  .byte  196,65,113,97,193                   // vpunpcklwd    %xmm9,%xmm1,%xmm8
  .byte  196,193,113,105,217                 // vpunpckhwd    %xmm9,%xmm1,%xmm3
  .byte  197,249,97,202                      // vpunpcklwd    %xmm2,%xmm0,%xmm1
  .byte  197,121,105,202                     // vpunpckhwd    %xmm2,%xmm0,%xmm9
  .byte  197,185,97,195                      // vpunpcklwd    %xmm3,%xmm8,%xmm0
  .byte  197,241,108,208                     // vpunpcklqdq   %xmm0,%xmm1,%xmm2
  .byte  197,241,109,200                     // vpunpckhqdq   %xmm0,%xmm1,%xmm1
  .byte  196,226,125,19,194                  // vcvtph2ps     %xmm2,%ymm0
  .byte  196,226,125,19,201                  // vcvtph2ps     %xmm1,%ymm1
  .byte  197,185,105,219                     // vpunpckhwd    %xmm3,%xmm8,%xmm3
  .byte  197,177,108,211                     // vpunpcklqdq   %xmm3,%xmm9,%xmm2
  .byte  196,226,125,19,210                  // vcvtph2ps     %xmm2,%ymm2
  .byte  197,177,109,219                     // vpunpckhqdq   %xmm3,%xmm9,%xmm3
  .byte  196,226,125,19,219                  // vcvtph2ps     %xmm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,123,16,4,192                 // vmovsd        (%r8,%rax,8),%xmm8
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,85                              // je            5383 <_sk_load_f16_skx+0xe7>
  .byte  196,65,57,22,68,192,8               // vmovhpd       0x8(%r8,%rax,8),%xmm8,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,72                              // jb            5383 <_sk_load_f16_skx+0xe7>
  .byte  196,193,123,16,84,192,16            // vmovsd        0x10(%r8,%rax,8),%xmm2
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  116,72                              // je            5390 <_sk_load_f16_skx+0xf4>
  .byte  196,193,105,22,84,192,24            // vmovhpd       0x18(%r8,%rax,8),%xmm2,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,59                              // jb            5390 <_sk_load_f16_skx+0xf4>
  .byte  196,193,123,16,76,192,32            // vmovsd        0x20(%r8,%rax,8),%xmm1
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  15,132,109,255,255,255              // je            52d3 <_sk_load_f16_skx+0x37>
  .byte  196,193,113,22,76,192,40            // vmovhpd       0x28(%r8,%rax,8),%xmm1,%xmm1
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,130,92,255,255,255               // jb            52d3 <_sk_load_f16_skx+0x37>
  .byte  196,65,122,126,76,192,48            // vmovq         0x30(%r8,%rax,8),%xmm9
  .byte  233,80,255,255,255                  // jmpq          52d3 <_sk_load_f16_skx+0x37>
  .byte  197,241,87,201                      // vxorpd        %xmm1,%xmm1,%xmm1
  .byte  197,233,87,210                      // vxorpd        %xmm2,%xmm2,%xmm2
  .byte  233,67,255,255,255                  // jmpq          52d3 <_sk_load_f16_skx+0x37>
  .byte  197,241,87,201                      // vxorpd        %xmm1,%xmm1,%xmm1
  .byte  233,58,255,255,255                  // jmpq          52d3 <_sk_load_f16_skx+0x37>

HIDDEN _sk_load_f16_dst_skx
.globl _sk_load_f16_dst_skx
FUNCTION(_sk_load_f16_dst_skx)
_sk_load_f16_dst_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,101                             // jne           541a <_sk_load_f16_dst_skx+0x81>
  .byte  196,65,121,16,4,192                 // vmovupd       (%r8,%rax,8),%xmm8
  .byte  196,193,121,16,116,192,16           // vmovupd       0x10(%r8,%rax,8),%xmm6
  .byte  196,193,121,16,108,192,32           // vmovupd       0x20(%r8,%rax,8),%xmm5
  .byte  196,65,122,111,76,192,48            // vmovdqu       0x30(%r8,%rax,8),%xmm9
  .byte  197,185,97,230                      // vpunpcklwd    %xmm6,%xmm8,%xmm4
  .byte  197,185,105,246                     // vpunpckhwd    %xmm6,%xmm8,%xmm6
  .byte  196,65,81,97,193                    // vpunpcklwd    %xmm9,%xmm5,%xmm8
  .byte  196,193,81,105,249                  // vpunpckhwd    %xmm9,%xmm5,%xmm7
  .byte  197,217,97,238                      // vpunpcklwd    %xmm6,%xmm4,%xmm5
  .byte  197,89,105,206                      // vpunpckhwd    %xmm6,%xmm4,%xmm9
  .byte  197,185,97,231                      // vpunpcklwd    %xmm7,%xmm8,%xmm4
  .byte  197,209,108,244                     // vpunpcklqdq   %xmm4,%xmm5,%xmm6
  .byte  197,209,109,236                     // vpunpckhqdq   %xmm4,%xmm5,%xmm5
  .byte  196,226,125,19,230                  // vcvtph2ps     %xmm6,%ymm4
  .byte  196,226,125,19,237                  // vcvtph2ps     %xmm5,%ymm5
  .byte  197,185,105,255                     // vpunpckhwd    %xmm7,%xmm8,%xmm7
  .byte  197,177,108,247                     // vpunpcklqdq   %xmm7,%xmm9,%xmm6
  .byte  196,226,125,19,246                  // vcvtph2ps     %xmm6,%ymm6
  .byte  197,177,109,255                     // vpunpckhqdq   %xmm7,%xmm9,%xmm7
  .byte  196,226,125,19,255                  // vcvtph2ps     %xmm7,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,123,16,4,192                 // vmovsd        (%r8,%rax,8),%xmm8
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,85                              // je            5480 <_sk_load_f16_dst_skx+0xe7>
  .byte  196,65,57,22,68,192,8               // vmovhpd       0x8(%r8,%rax,8),%xmm8,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,72                              // jb            5480 <_sk_load_f16_dst_skx+0xe7>
  .byte  196,193,123,16,116,192,16           // vmovsd        0x10(%r8,%rax,8),%xmm6
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  116,72                              // je            548d <_sk_load_f16_dst_skx+0xf4>
  .byte  196,193,73,22,116,192,24            // vmovhpd       0x18(%r8,%rax,8),%xmm6,%xmm6
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,59                              // jb            548d <_sk_load_f16_dst_skx+0xf4>
  .byte  196,193,123,16,108,192,32           // vmovsd        0x20(%r8,%rax,8),%xmm5
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  15,132,109,255,255,255              // je            53d0 <_sk_load_f16_dst_skx+0x37>
  .byte  196,193,81,22,108,192,40            // vmovhpd       0x28(%r8,%rax,8),%xmm5,%xmm5
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,130,92,255,255,255               // jb            53d0 <_sk_load_f16_dst_skx+0x37>
  .byte  196,65,122,126,76,192,48            // vmovq         0x30(%r8,%rax,8),%xmm9
  .byte  233,80,255,255,255                  // jmpq          53d0 <_sk_load_f16_dst_skx+0x37>
  .byte  197,209,87,237                      // vxorpd        %xmm5,%xmm5,%xmm5
  .byte  197,201,87,246                      // vxorpd        %xmm6,%xmm6,%xmm6
  .byte  233,67,255,255,255                  // jmpq          53d0 <_sk_load_f16_dst_skx+0x37>
  .byte  197,209,87,237                      // vxorpd        %xmm5,%xmm5,%xmm5
  .byte  233,58,255,255,255                  // jmpq          53d0 <_sk_load_f16_dst_skx+0x37>

HIDDEN _sk_gather_f16_skx
.globl _sk_gather_f16_skx
FUNCTION(_sk_gather_f16_skx)
_sk_gather_f16_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  98,242,117,56,64,72,2               // vpmulld       0x8(%rax){1to8},%ymm1,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  197,237,239,210                     // vpxor         %ymm2,%ymm2,%ymm2
  .byte  196,194,245,144,20,192              // vpgatherdq    %ymm1,(%r8,%xmm0,8),%ymm2
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  196,66,229,144,4,192                // vpgatherdq    %ymm3,(%r8,%xmm0,8),%ymm8
  .byte  98,211,253,72,58,192,1              // vinserti64x4  $0x1,%ymm8,%zmm0,%zmm0
  .byte  98,211,237,72,58,200,1              // vinserti64x4  $0x1,%ymm8,%zmm2,%zmm1
  .byte  98,243,253,72,57,202,1              // vextracti64x2 $0x1,%zmm1,%xmm2
  .byte  98,243,253,72,57,195,2              // vextracti64x2 $0x2,%zmm0,%xmm3
  .byte  98,243,253,72,57,192,3              // vextracti64x2 $0x3,%zmm0,%xmm0
  .byte  197,113,97,194                      // vpunpcklwd    %xmm2,%xmm1,%xmm8
  .byte  197,241,105,202                     // vpunpckhwd    %xmm2,%xmm1,%xmm1
  .byte  197,225,97,208                      // vpunpcklwd    %xmm0,%xmm3,%xmm2
  .byte  197,225,105,216                     // vpunpckhwd    %xmm0,%xmm3,%xmm3
  .byte  197,185,97,193                      // vpunpcklwd    %xmm1,%xmm8,%xmm0
  .byte  197,57,105,193                      // vpunpckhwd    %xmm1,%xmm8,%xmm8
  .byte  197,233,97,203                      // vpunpcklwd    %xmm3,%xmm2,%xmm1
  .byte  197,121,108,201                     // vpunpcklqdq   %xmm1,%xmm0,%xmm9
  .byte  197,249,109,201                     // vpunpckhqdq   %xmm1,%xmm0,%xmm1
  .byte  196,194,125,19,193                  // vcvtph2ps     %xmm9,%ymm0
  .byte  196,226,125,19,201                  // vcvtph2ps     %xmm1,%ymm1
  .byte  197,233,105,219                     // vpunpckhwd    %xmm3,%xmm2,%xmm3
  .byte  197,185,108,211                     // vpunpcklqdq   %xmm3,%xmm8,%xmm2
  .byte  196,226,125,19,210                  // vcvtph2ps     %xmm2,%ymm2
  .byte  197,185,109,219                     // vpunpckhqdq   %xmm3,%xmm8,%xmm3
  .byte  196,226,125,19,219                  // vcvtph2ps     %xmm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_f16_skx
.globl _sk_store_f16_skx
FUNCTION(_sk_store_f16_skx)
_sk_store_f16_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  196,195,125,29,192,4                // vcvtps2ph     $0x4,%ymm0,%xmm8
  .byte  196,195,125,29,201,4                // vcvtps2ph     $0x4,%ymm1,%xmm9
  .byte  196,195,125,29,210,4                // vcvtps2ph     $0x4,%ymm2,%xmm10
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  196,195,125,29,219,4                // vcvtps2ph     $0x4,%ymm3,%xmm11
  .byte  196,65,57,97,225                    // vpunpcklwd    %xmm9,%xmm8,%xmm12
  .byte  196,65,57,105,193                   // vpunpckhwd    %xmm9,%xmm8,%xmm8
  .byte  196,65,41,97,203                    // vpunpcklwd    %xmm11,%xmm10,%xmm9
  .byte  196,65,41,105,235                   // vpunpckhwd    %xmm11,%xmm10,%xmm13
  .byte  196,65,25,98,217                    // vpunpckldq    %xmm9,%xmm12,%xmm11
  .byte  196,65,25,106,209                   // vpunpckhdq    %xmm9,%xmm12,%xmm10
  .byte  196,65,57,98,205                    // vpunpckldq    %xmm13,%xmm8,%xmm9
  .byte  196,65,57,106,197                   // vpunpckhdq    %xmm13,%xmm8,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,31                              // jne           55db <_sk_store_f16_skx+0x7b>
  .byte  196,65,122,127,28,192               // vmovdqu       %xmm11,(%r8,%rax,8)
  .byte  196,65,122,127,84,192,16            // vmovdqu       %xmm10,0x10(%r8,%rax,8)
  .byte  196,65,122,127,76,192,32            // vmovdqu       %xmm9,0x20(%r8,%rax,8)
  .byte  196,65,122,127,68,192,48            // vmovdqu       %xmm8,0x30(%r8,%rax,8)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,121,214,28,192               // vmovq         %xmm11,(%r8,%rax,8)
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,240                             // je            55d7 <_sk_store_f16_skx+0x77>
  .byte  196,65,121,23,92,192,8              // vmovhpd       %xmm11,0x8(%r8,%rax,8)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,227                             // jb            55d7 <_sk_store_f16_skx+0x77>
  .byte  196,65,121,214,84,192,16            // vmovq         %xmm10,0x10(%r8,%rax,8)
  .byte  116,218                             // je            55d7 <_sk_store_f16_skx+0x77>
  .byte  196,65,121,23,84,192,24             // vmovhpd       %xmm10,0x18(%r8,%rax,8)
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,205                             // jb            55d7 <_sk_store_f16_skx+0x77>
  .byte  196,65,121,214,76,192,32            // vmovq         %xmm9,0x20(%r8,%rax,8)
  .byte  116,196                             // je            55d7 <_sk_store_f16_skx+0x77>
  .byte  196,65,121,23,76,192,40             // vmovhpd       %xmm9,0x28(%r8,%rax,8)
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,183                             // jb            55d7 <_sk_store_f16_skx+0x77>
  .byte  196,65,121,214,68,192,48            // vmovq         %xmm8,0x30(%r8,%rax,8)
  .byte  235,174                             // jmp           55d7 <_sk_store_f16_skx+0x77>

HIDDEN _sk_load_u16_be_skx
.globl _sk_load_u16_be_skx
FUNCTION(_sk_load_u16_be_skx)
_sk_load_u16_be_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,204,0,0,0                    // jne           571c <_sk_load_u16_be_skx+0xf3>
  .byte  196,65,121,16,4,64                  // vmovupd       (%r8,%rax,2),%xmm8
  .byte  196,193,121,16,84,64,16             // vmovupd       0x10(%r8,%rax,2),%xmm2
  .byte  196,193,121,16,92,64,32             // vmovupd       0x20(%r8,%rax,2),%xmm3
  .byte  196,65,122,111,76,64,48             // vmovdqu       0x30(%r8,%rax,2),%xmm9
  .byte  197,185,97,194                      // vpunpcklwd    %xmm2,%xmm8,%xmm0
  .byte  197,185,105,210                     // vpunpckhwd    %xmm2,%xmm8,%xmm2
  .byte  196,193,97,97,201                   // vpunpcklwd    %xmm9,%xmm3,%xmm1
  .byte  196,193,97,105,217                  // vpunpckhwd    %xmm9,%xmm3,%xmm3
  .byte  197,121,97,194                      // vpunpcklwd    %xmm2,%xmm0,%xmm8
  .byte  197,121,105,202                     // vpunpckhwd    %xmm2,%xmm0,%xmm9
  .byte  197,241,97,211                      // vpunpcklwd    %xmm3,%xmm1,%xmm2
  .byte  197,113,105,219                     // vpunpckhwd    %xmm3,%xmm1,%xmm11
  .byte  197,185,108,194                     // vpunpcklqdq   %xmm2,%xmm8,%xmm0
  .byte  197,241,113,240,8                   // vpsllw        $0x8,%xmm0,%xmm1
  .byte  197,249,113,208,8                   // vpsrlw        $0x8,%xmm0,%xmm0
  .byte  197,241,235,192                     // vpor          %xmm0,%xmm1,%xmm0
  .byte  196,226,125,51,192                  // vpmovzxwd     %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,21,251,75,3,0         // vbroadcastss  0x34bfb(%rip),%ymm10        # 3a2ac <_sk_srcover_bgra_8888_sse2_lowp+0x344>
  .byte  196,193,124,89,194                  // vmulps        %ymm10,%ymm0,%ymm0
  .byte  197,185,109,202                     // vpunpckhqdq   %xmm2,%xmm8,%xmm1
  .byte  197,233,113,241,8                   // vpsllw        $0x8,%xmm1,%xmm2
  .byte  197,241,113,209,8                   // vpsrlw        $0x8,%xmm1,%xmm1
  .byte  197,233,235,201                     // vpor          %xmm1,%xmm2,%xmm1
  .byte  196,226,125,51,201                  // vpmovzxwd     %xmm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,202                  // vmulps        %ymm10,%ymm1,%ymm1
  .byte  196,193,49,108,211                  // vpunpcklqdq   %xmm11,%xmm9,%xmm2
  .byte  197,225,113,242,8                   // vpsllw        $0x8,%xmm2,%xmm3
  .byte  197,233,113,210,8                   // vpsrlw        $0x8,%xmm2,%xmm2
  .byte  197,225,235,210                     // vpor          %xmm2,%xmm3,%xmm2
  .byte  196,226,125,51,210                  // vpmovzxwd     %xmm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,210                  // vmulps        %ymm10,%ymm2,%ymm2
  .byte  196,193,49,109,219                  // vpunpckhqdq   %xmm11,%xmm9,%xmm3
  .byte  197,185,113,243,8                   // vpsllw        $0x8,%xmm3,%xmm8
  .byte  197,225,113,211,8                   // vpsrlw        $0x8,%xmm3,%xmm3
  .byte  197,185,235,219                     // vpor          %xmm3,%xmm8,%xmm3
  .byte  196,226,125,51,219                  // vpmovzxwd     %xmm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,218                  // vmulps        %ymm10,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,123,16,4,64                  // vmovsd        (%r8,%rax,2),%xmm8
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,85                              // je            5782 <_sk_load_u16_be_skx+0x159>
  .byte  196,65,57,22,68,64,8                // vmovhpd       0x8(%r8,%rax,2),%xmm8,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,72                              // jb            5782 <_sk_load_u16_be_skx+0x159>
  .byte  196,193,123,16,84,64,16             // vmovsd        0x10(%r8,%rax,2),%xmm2
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  116,72                              // je            578f <_sk_load_u16_be_skx+0x166>
  .byte  196,193,105,22,84,64,24             // vmovhpd       0x18(%r8,%rax,2),%xmm2,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,59                              // jb            578f <_sk_load_u16_be_skx+0x166>
  .byte  196,193,123,16,92,64,32             // vmovsd        0x20(%r8,%rax,2),%xmm3
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  15,132,6,255,255,255                // je            566b <_sk_load_u16_be_skx+0x42>
  .byte  196,193,97,22,92,64,40              // vmovhpd       0x28(%r8,%rax,2),%xmm3,%xmm3
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,130,245,254,255,255              // jb            566b <_sk_load_u16_be_skx+0x42>
  .byte  196,65,122,126,76,64,48             // vmovq         0x30(%r8,%rax,2),%xmm9
  .byte  233,233,254,255,255                 // jmpq          566b <_sk_load_u16_be_skx+0x42>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  197,233,87,210                      // vxorpd        %xmm2,%xmm2,%xmm2
  .byte  233,220,254,255,255                 // jmpq          566b <_sk_load_u16_be_skx+0x42>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  233,211,254,255,255                 // jmpq          566b <_sk_load_u16_be_skx+0x42>

HIDDEN _sk_load_rgb_u16_be_skx
.globl _sk_load_rgb_u16_be_skx
FUNCTION(_sk_load_rgb_u16_be_skx)
_sk_load_rgb_u16_be_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,137,208                          // mov           %rdx,%rax
  .byte  72,193,224,32                       // shl           $0x20,%rax
  .byte  72,141,4,64                         // lea           (%rax,%rax,2),%rax
  .byte  72,193,248,32                       // sar           $0x20,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,202,0,0,0                    // jne           588d <_sk_load_rgb_u16_be_skx+0xf5>
  .byte  196,65,121,16,28,64                 // vmovupd       (%r8,%rax,2),%xmm11
  .byte  196,193,121,16,92,64,12             // vmovupd       0xc(%r8,%rax,2),%xmm3
  .byte  196,193,121,16,84,64,24             // vmovupd       0x18(%r8,%rax,2),%xmm2
  .byte  98,209,125,8,115,92,64,2,4          // vpsrldq       $0x4,0x20(%r8,%rax,2),%xmm0
  .byte  196,193,57,115,219,6                // vpsrldq       $0x6,%xmm11,%xmm8
  .byte  197,169,115,219,6                   // vpsrldq       $0x6,%xmm3,%xmm10
  .byte  197,241,115,218,6                   // vpsrldq       $0x6,%xmm2,%xmm1
  .byte  197,177,115,216,6                   // vpsrldq       $0x6,%xmm0,%xmm9
  .byte  196,193,113,97,201                  // vpunpcklwd    %xmm9,%xmm1,%xmm1
  .byte  197,233,97,192                      // vpunpcklwd    %xmm0,%xmm2,%xmm0
  .byte  196,193,57,97,210                   // vpunpcklwd    %xmm10,%xmm8,%xmm2
  .byte  197,161,97,219                      // vpunpcklwd    %xmm3,%xmm11,%xmm3
  .byte  197,97,97,194                       // vpunpcklwd    %xmm2,%xmm3,%xmm8
  .byte  197,225,105,210                     // vpunpckhwd    %xmm2,%xmm3,%xmm2
  .byte  197,249,97,217                      // vpunpcklwd    %xmm1,%xmm0,%xmm3
  .byte  197,249,105,193                     // vpunpckhwd    %xmm1,%xmm0,%xmm0
  .byte  197,233,108,208                     // vpunpcklqdq   %xmm0,%xmm2,%xmm2
  .byte  197,185,108,195                     // vpunpcklqdq   %xmm3,%xmm8,%xmm0
  .byte  197,241,113,240,8                   // vpsllw        $0x8,%xmm0,%xmm1
  .byte  197,249,113,208,8                   // vpsrlw        $0x8,%xmm0,%xmm0
  .byte  197,241,235,192                     // vpor          %xmm0,%xmm1,%xmm0
  .byte  196,226,125,51,192                  // vpmovzxwd     %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,13,109,74,3,0         // vbroadcastss  0x34a6d(%rip),%ymm9        # 3a2ac <_sk_srcover_bgra_8888_sse2_lowp+0x344>
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,185,109,203                     // vpunpckhqdq   %xmm3,%xmm8,%xmm1
  .byte  197,225,113,241,8                   // vpsllw        $0x8,%xmm1,%xmm3
  .byte  197,241,113,209,8                   // vpsrlw        $0x8,%xmm1,%xmm1
  .byte  197,225,235,201                     // vpor          %xmm1,%xmm3,%xmm1
  .byte  196,226,125,51,201                  // vpmovzxwd     %xmm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,201                  // vmulps        %ymm9,%ymm1,%ymm1
  .byte  197,225,113,242,8                   // vpsllw        $0x8,%xmm2,%xmm3
  .byte  197,233,113,210,8                   // vpsrlw        $0x8,%xmm2,%xmm2
  .byte  197,225,235,210                     // vpor          %xmm2,%xmm3,%xmm2
  .byte  196,226,125,51,210                  // vpmovzxwd     %xmm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,209                  // vmulps        %ymm9,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,141,73,3,0        // vbroadcastss  0x3498d(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  255,224                             // jmpq          *%rax
  .byte  196,193,121,110,4,64                // vmovd         (%r8,%rax,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,65,121,196,92,64,4,2            // vpinsrw       $0x2,0x4(%r8,%rax,2),%xmm0,%xmm11
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,31                              // jne           58c5 <_sk_load_rgb_u16_be_skx+0x12d>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  197,225,239,219                     // vpxor         %xmm3,%xmm3,%xmm3
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  233,48,255,255,255                  // jmpq          57f5 <_sk_load_rgb_u16_be_skx+0x5d>
  .byte  196,193,121,110,68,64,6             // vmovd         0x6(%r8,%rax,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,65,121,196,68,64,10,2           // vpinsrw       $0x2,0xa(%r8,%rax,2),%xmm0,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,48                              // jb            590f <_sk_load_rgb_u16_be_skx+0x177>
  .byte  196,193,121,110,68,64,12            // vmovd         0xc(%r8,%rax,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,193,121,196,92,64,16,2          // vpinsrw       $0x2,0x10(%r8,%rax,2),%xmm0,%xmm3
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  117,48                              // jne           5929 <_sk_load_rgb_u16_be_skx+0x191>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  233,230,254,255,255                 // jmpq          57f5 <_sk_load_rgb_u16_be_skx+0x5d>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  197,225,239,219                     // vpxor         %xmm3,%xmm3,%xmm3
  .byte  233,204,254,255,255                 // jmpq          57f5 <_sk_load_rgb_u16_be_skx+0x5d>
  .byte  196,193,121,110,68,64,18            // vmovd         0x12(%r8,%rax,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,65,121,196,84,64,22,2           // vpinsrw       $0x2,0x16(%r8,%rax,2),%xmm0,%xmm10
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,39                              // jb            596a <_sk_load_rgb_u16_be_skx+0x1d2>
  .byte  196,193,121,110,68,64,24            // vmovd         0x18(%r8,%rax,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,193,121,196,84,64,28,2          // vpinsrw       $0x2,0x1c(%r8,%rax,2),%xmm0,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  117,30                              // jne           597b <_sk_load_rgb_u16_be_skx+0x1e3>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  233,139,254,255,255                 // jmpq          57f5 <_sk_load_rgb_u16_be_skx+0x5d>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  233,122,254,255,255                 // jmpq          57f5 <_sk_load_rgb_u16_be_skx+0x5d>
  .byte  196,193,121,110,68,64,30            // vmovd         0x1e(%r8,%rax,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,193,121,196,76,64,34,2          // vpinsrw       $0x2,0x22(%r8,%rax,2),%xmm0,%xmm1
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,25                              // jb            59ae <_sk_load_rgb_u16_be_skx+0x216>
  .byte  196,193,121,110,68,64,36            // vmovd         0x24(%r8,%rax,2),%xmm0
  .byte  196,65,49,87,201                    // vxorpd        %xmm9,%xmm9,%xmm9
  .byte  196,193,121,196,68,64,40,2          // vpinsrw       $0x2,0x28(%r8,%rax,2),%xmm0,%xmm0
  .byte  233,71,254,255,255                  // jmpq          57f5 <_sk_load_rgb_u16_be_skx+0x5d>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  233,62,254,255,255                  // jmpq          57f5 <_sk_load_rgb_u16_be_skx+0x5d>

HIDDEN _sk_store_u16_be_skx
.globl _sk_store_u16_be_skx
FUNCTION(_sk_store_u16_be_skx)
_sk_store_u16_be_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,98,125,24,21,49,72,3,0          // vbroadcastss  0x34831(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,63,73,3,0          // vbroadcastss  0x3493f(%rip),%ymm11        # 3a334 <_sk_srcover_bgra_8888_sse2_lowp+0x3cc>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  196,67,125,57,204,1                 // vextracti128  $0x1,%ymm9,%xmm12
  .byte  196,66,49,43,204                    // vpackusdw     %xmm12,%xmm9,%xmm9
  .byte  196,193,25,113,241,8                // vpsllw        $0x8,%xmm9,%xmm12
  .byte  196,193,49,113,209,8                // vpsrlw        $0x8,%xmm9,%xmm9
  .byte  196,65,25,235,201                   // vpor          %xmm9,%xmm12,%xmm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,67,125,57,229,1                 // vextracti128  $0x1,%ymm12,%xmm13
  .byte  196,66,25,43,229                    // vpackusdw     %xmm13,%xmm12,%xmm12
  .byte  196,193,17,113,244,8                // vpsllw        $0x8,%xmm12,%xmm13
  .byte  196,193,25,113,212,8                // vpsrlw        $0x8,%xmm12,%xmm12
  .byte  196,65,17,235,228                   // vpor          %xmm12,%xmm13,%xmm12
  .byte  197,60,95,234                       // vmaxps        %ymm2,%ymm8,%ymm13
  .byte  196,65,20,93,234                    // vminps        %ymm10,%ymm13,%ymm13
  .byte  196,65,20,89,235                    // vmulps        %ymm11,%ymm13,%ymm13
  .byte  196,65,125,91,237                   // vcvtps2dq     %ymm13,%ymm13
  .byte  196,67,125,57,238,1                 // vextracti128  $0x1,%ymm13,%xmm14
  .byte  196,66,17,43,238                    // vpackusdw     %xmm14,%xmm13,%xmm13
  .byte  196,193,9,113,245,8                 // vpsllw        $0x8,%xmm13,%xmm14
  .byte  196,193,17,113,213,8                // vpsrlw        $0x8,%xmm13,%xmm13
  .byte  196,65,9,235,237                    // vpor          %xmm13,%xmm14,%xmm13
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,67,125,57,194,1                 // vextracti128  $0x1,%ymm8,%xmm10
  .byte  196,66,57,43,194                    // vpackusdw     %xmm10,%xmm8,%xmm8
  .byte  196,193,41,113,240,8                // vpsllw        $0x8,%xmm8,%xmm10
  .byte  196,193,57,113,208,8                // vpsrlw        $0x8,%xmm8,%xmm8
  .byte  196,65,41,235,192                   // vpor          %xmm8,%xmm10,%xmm8
  .byte  196,65,49,97,212                    // vpunpcklwd    %xmm12,%xmm9,%xmm10
  .byte  196,65,49,105,228                   // vpunpckhwd    %xmm12,%xmm9,%xmm12
  .byte  196,65,17,97,200                    // vpunpcklwd    %xmm8,%xmm13,%xmm9
  .byte  196,65,17,105,192                   // vpunpckhwd    %xmm8,%xmm13,%xmm8
  .byte  196,65,41,98,217                    // vpunpckldq    %xmm9,%xmm10,%xmm11
  .byte  196,65,41,106,209                   // vpunpckhdq    %xmm9,%xmm10,%xmm10
  .byte  196,65,25,98,200                    // vpunpckldq    %xmm8,%xmm12,%xmm9
  .byte  196,65,25,106,192                   // vpunpckhdq    %xmm8,%xmm12,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,31                              // jne           5af4 <_sk_store_u16_be_skx+0x13d>
  .byte  196,65,122,127,28,64                // vmovdqu       %xmm11,(%r8,%rax,2)
  .byte  196,65,122,127,84,64,16             // vmovdqu       %xmm10,0x10(%r8,%rax,2)
  .byte  196,65,122,127,76,64,32             // vmovdqu       %xmm9,0x20(%r8,%rax,2)
  .byte  196,65,122,127,68,64,48             // vmovdqu       %xmm8,0x30(%r8,%rax,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,121,214,28,64                // vmovq         %xmm11,(%r8,%rax,2)
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,240                             // je            5af0 <_sk_store_u16_be_skx+0x139>
  .byte  196,65,121,23,92,64,8               // vmovhpd       %xmm11,0x8(%r8,%rax,2)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,227                             // jb            5af0 <_sk_store_u16_be_skx+0x139>
  .byte  196,65,121,214,84,64,16             // vmovq         %xmm10,0x10(%r8,%rax,2)
  .byte  116,218                             // je            5af0 <_sk_store_u16_be_skx+0x139>
  .byte  196,65,121,23,84,64,24              // vmovhpd       %xmm10,0x18(%r8,%rax,2)
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,205                             // jb            5af0 <_sk_store_u16_be_skx+0x139>
  .byte  196,65,121,214,76,64,32             // vmovq         %xmm9,0x20(%r8,%rax,2)
  .byte  116,196                             // je            5af0 <_sk_store_u16_be_skx+0x139>
  .byte  196,65,121,23,76,64,40              // vmovhpd       %xmm9,0x28(%r8,%rax,2)
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,183                             // jb            5af0 <_sk_store_u16_be_skx+0x139>
  .byte  196,65,121,214,68,64,48             // vmovq         %xmm8,0x30(%r8,%rax,2)
  .byte  235,174                             // jmp           5af0 <_sk_store_u16_be_skx+0x139>

HIDDEN _sk_load_f32_skx
.globl _sk_load_f32_skx
FUNCTION(_sk_load_f32_skx)
_sk_load_f32_skx:
  .byte  98,225,253,40,40,223                // vmovapd       %ymm7,%ymm19
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,197,87,255                      // vxorpd        %ymm7,%ymm7,%ymm7
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,135,63,1,0,0                     // ja            5c97 <_sk_load_f32_skx+0x155>
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  77,99,201                           // movslq        %r9d,%r9
  .byte  76,141,21,44,1,0,0                  // lea           0x12c(%rip),%r10        # 5ca8 <_sk_load_f32_skx+0x166>
  .byte  73,99,4,186                         // movslq        (%r10,%rdi,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  197,245,87,201                      // vxorpd        %ymm1,%ymm1,%ymm1
  .byte  196,65,45,87,210                    // vxorpd        %ymm10,%ymm10,%ymm10
  .byte  197,237,87,210                      // vxorpd        %ymm2,%ymm2,%ymm2
  .byte  98,161,253,32,87,192                // vxorpd        %ymm16,%ymm16,%ymm16
  .byte  196,65,29,87,228                    // vxorpd        %ymm12,%ymm12,%ymm12
  .byte  197,229,87,219                      // vxorpd        %ymm3,%ymm3,%ymm3
  .byte  196,65,37,87,219                    // vxorpd        %ymm11,%ymm11,%ymm11
  .byte  98,161,237,32,87,210                // vxorpd        %ymm18,%ymm18,%ymm18
  .byte  196,65,5,87,255                     // vxorpd        %ymm15,%ymm15,%ymm15
  .byte  196,65,13,87,246                    // vxorpd        %ymm14,%ymm14,%ymm14
  .byte  196,65,21,87,237                    // vxorpd        %ymm13,%ymm13,%ymm13
  .byte  98,161,245,32,87,201                // vxorpd        %ymm17,%ymm17,%ymm17
  .byte  196,65,61,87,192                    // vxorpd        %ymm8,%ymm8,%ymm8
  .byte  196,65,53,87,201                    // vxorpd        %ymm9,%ymm9,%ymm9
  .byte  197,253,87,192                      // vxorpd        %ymm0,%ymm0,%ymm0
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,16,68,136,112           // vmovupd       0x70(%r8,%r9,4),%xmm0
  .byte  196,227,125,6,248,40                // vperm2f128    $0x28,%ymm0,%ymm0,%ymm7
  .byte  196,129,121,16,68,136,96            // vmovupd       0x60(%r8,%r9,4),%xmm0
  .byte  196,227,125,6,200,40                // vperm2f128    $0x28,%ymm0,%ymm0,%ymm1
  .byte  196,129,121,16,68,136,80            // vmovupd       0x50(%r8,%r9,4),%xmm0
  .byte  196,227,125,6,208,40                // vperm2f128    $0x28,%ymm0,%ymm0,%ymm2
  .byte  197,125,40,209                      // vmovapd       %ymm1,%ymm10
  .byte  196,129,121,16,68,136,64            // vmovupd       0x40(%r8,%r9,4),%xmm0
  .byte  196,227,125,6,216,40                // vperm2f128    $0x28,%ymm0,%ymm0,%ymm3
  .byte  98,193,253,40,40,194                // vmovapd       %ymm10,%ymm16
  .byte  197,125,40,226                      // vmovapd       %ymm2,%ymm12
  .byte  196,129,121,16,68,136,48            // vmovupd       0x30(%r8,%r9,4),%xmm0
  .byte  196,227,125,13,255,12               // vblendpd      $0xc,%ymm7,%ymm0,%ymm7
  .byte  98,49,253,40,40,216                 // vmovapd       %ymm16,%ymm11
  .byte  98,193,253,40,40,212                // vmovapd       %ymm12,%ymm18
  .byte  197,125,40,251                      // vmovapd       %ymm3,%ymm15
  .byte  196,129,121,16,68,136,32            // vmovupd       0x20(%r8,%r9,4),%xmm0
  .byte  196,67,125,13,243,12                // vblendpd      $0xc,%ymm11,%ymm0,%ymm14
  .byte  98,49,253,40,40,234                 // vmovapd       %ymm18,%ymm13
  .byte  98,193,253,40,40,207                // vmovapd       %ymm15,%ymm17
  .byte  196,129,121,16,68,136,16            // vmovupd       0x10(%r8,%r9,4),%xmm0
  .byte  196,67,125,13,205,12                // vblendpd      $0xc,%ymm13,%ymm0,%ymm9
  .byte  196,65,125,40,198                   // vmovapd       %ymm14,%ymm8
  .byte  98,177,253,40,40,193                // vmovapd       %ymm17,%ymm0
  .byte  196,129,121,16,12,136               // vmovupd       (%r8,%r9,4),%xmm1
  .byte  196,227,117,13,200,12               // vblendpd      $0xc,%ymm0,%ymm1,%ymm1
  .byte  196,193,116,20,209                  // vunpcklps     %ymm9,%ymm1,%ymm2
  .byte  196,193,116,21,217                  // vunpckhps     %ymm9,%ymm1,%ymm3
  .byte  197,188,20,207                      // vunpcklps     %ymm7,%ymm8,%ymm1
  .byte  197,188,21,255                      // vunpckhps     %ymm7,%ymm8,%ymm7
  .byte  197,237,20,193                      // vunpcklpd     %ymm1,%ymm2,%ymm0
  .byte  197,237,21,201                      // vunpckhpd     %ymm1,%ymm2,%ymm1
  .byte  197,229,20,215                      // vunpcklpd     %ymm7,%ymm3,%ymm2
  .byte  197,229,21,223                      // vunpckhpd     %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,177,124,40,40,251                // vmovaps       %ymm19,%ymm7
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,61,87,192                    // vxorpd        %ymm8,%ymm8,%ymm8
  .byte  196,65,53,87,201                    // vxorpd        %ymm9,%ymm9,%ymm9
  .byte  197,245,87,201                      // vxorpd        %ymm1,%ymm1,%ymm1
  .byte  235,196                             // jmp           5c6b <_sk_load_f32_skx+0x129>
  .byte  144                                 // nop
  .byte  39                                  // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,183,255,255,255,159             // pushq         -0x60000001(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,134,255,255,255,105             // incl          0x69ffffff(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,82,255                          // callq         *-0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,65,255                          // incl          -0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,52,255                          // pushq         (%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_f32_dst_skx
.globl _sk_load_f32_dst_skx
FUNCTION(_sk_load_f32_dst_skx)
_sk_load_f32_dst_skx:
  .byte  98,225,253,40,40,219                // vmovapd       %ymm3,%ymm19
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,229,87,219                      // vxorpd        %ymm3,%ymm3,%ymm3
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,135,63,1,0,0                     // ja            5e1d <_sk_load_f32_dst_skx+0x155>
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  77,99,201                           // movslq        %r9d,%r9
  .byte  76,141,21,46,1,0,0                  // lea           0x12e(%rip),%r10        # 5e30 <_sk_load_f32_dst_skx+0x168>
  .byte  73,99,4,186                         // movslq        (%r10,%rdi,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  197,213,87,237                      // vxorpd        %ymm5,%ymm5,%ymm5
  .byte  196,65,45,87,210                    // vxorpd        %ymm10,%ymm10,%ymm10
  .byte  197,205,87,246                      // vxorpd        %ymm6,%ymm6,%ymm6
  .byte  98,161,253,32,87,192                // vxorpd        %ymm16,%ymm16,%ymm16
  .byte  196,65,29,87,228                    // vxorpd        %ymm12,%ymm12,%ymm12
  .byte  197,197,87,255                      // vxorpd        %ymm7,%ymm7,%ymm7
  .byte  196,65,37,87,219                    // vxorpd        %ymm11,%ymm11,%ymm11
  .byte  98,161,237,32,87,210                // vxorpd        %ymm18,%ymm18,%ymm18
  .byte  196,65,5,87,255                     // vxorpd        %ymm15,%ymm15,%ymm15
  .byte  196,65,13,87,246                    // vxorpd        %ymm14,%ymm14,%ymm14
  .byte  196,65,21,87,237                    // vxorpd        %ymm13,%ymm13,%ymm13
  .byte  98,161,245,32,87,201                // vxorpd        %ymm17,%ymm17,%ymm17
  .byte  196,65,61,87,192                    // vxorpd        %ymm8,%ymm8,%ymm8
  .byte  196,65,53,87,201                    // vxorpd        %ymm9,%ymm9,%ymm9
  .byte  197,221,87,228                      // vxorpd        %ymm4,%ymm4,%ymm4
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,16,92,136,112           // vmovupd       0x70(%r8,%r9,4),%xmm3
  .byte  196,227,125,6,219,40                // vperm2f128    $0x28,%ymm3,%ymm0,%ymm3
  .byte  196,129,121,16,100,136,96           // vmovupd       0x60(%r8,%r9,4),%xmm4
  .byte  196,227,125,6,236,40                // vperm2f128    $0x28,%ymm4,%ymm0,%ymm5
  .byte  196,129,121,16,100,136,80           // vmovupd       0x50(%r8,%r9,4),%xmm4
  .byte  196,227,125,6,244,40                // vperm2f128    $0x28,%ymm4,%ymm0,%ymm6
  .byte  197,125,40,213                      // vmovapd       %ymm5,%ymm10
  .byte  196,129,121,16,100,136,64           // vmovupd       0x40(%r8,%r9,4),%xmm4
  .byte  196,227,125,6,252,40                // vperm2f128    $0x28,%ymm4,%ymm0,%ymm7
  .byte  98,193,253,40,40,194                // vmovapd       %ymm10,%ymm16
  .byte  197,125,40,230                      // vmovapd       %ymm6,%ymm12
  .byte  196,129,121,16,100,136,48           // vmovupd       0x30(%r8,%r9,4),%xmm4
  .byte  196,227,93,13,219,12                // vblendpd      $0xc,%ymm3,%ymm4,%ymm3
  .byte  98,49,253,40,40,216                 // vmovapd       %ymm16,%ymm11
  .byte  98,193,253,40,40,212                // vmovapd       %ymm12,%ymm18
  .byte  197,125,40,255                      // vmovapd       %ymm7,%ymm15
  .byte  196,129,121,16,100,136,32           // vmovupd       0x20(%r8,%r9,4),%xmm4
  .byte  196,67,93,13,243,12                 // vblendpd      $0xc,%ymm11,%ymm4,%ymm14
  .byte  98,49,253,40,40,234                 // vmovapd       %ymm18,%ymm13
  .byte  98,193,253,40,40,207                // vmovapd       %ymm15,%ymm17
  .byte  196,129,121,16,100,136,16           // vmovupd       0x10(%r8,%r9,4),%xmm4
  .byte  196,67,93,13,205,12                 // vblendpd      $0xc,%ymm13,%ymm4,%ymm9
  .byte  196,65,125,40,198                   // vmovapd       %ymm14,%ymm8
  .byte  98,177,253,40,40,225                // vmovapd       %ymm17,%ymm4
  .byte  196,129,121,16,44,136               // vmovupd       (%r8,%r9,4),%xmm5
  .byte  196,227,85,13,236,12                // vblendpd      $0xc,%ymm4,%ymm5,%ymm5
  .byte  196,193,84,20,241                   // vunpcklps     %ymm9,%ymm5,%ymm6
  .byte  196,193,84,21,249                   // vunpckhps     %ymm9,%ymm5,%ymm7
  .byte  197,188,20,235                      // vunpcklps     %ymm3,%ymm8,%ymm5
  .byte  197,188,21,219                      // vunpckhps     %ymm3,%ymm8,%ymm3
  .byte  197,205,20,229                      // vunpcklpd     %ymm5,%ymm6,%ymm4
  .byte  197,205,21,237                      // vunpckhpd     %ymm5,%ymm6,%ymm5
  .byte  197,197,20,243                      // vunpcklpd     %ymm3,%ymm7,%ymm6
  .byte  197,197,21,251                      // vunpckhpd     %ymm3,%ymm7,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,177,124,40,40,219                // vmovaps       %ymm19,%ymm3
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,61,87,192                    // vxorpd        %ymm8,%ymm8,%ymm8
  .byte  196,65,53,87,201                    // vxorpd        %ymm9,%ymm9,%ymm9
  .byte  197,213,87,237                      // vxorpd        %ymm5,%ymm5,%ymm5
  .byte  235,196                             // jmp           5df1 <_sk_load_f32_dst_skx+0x129>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  37,255,255,255,181                  // and           $0xb5ffffff,%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,157,255,255,255,132             // lcall         *-0x7b000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,103,255                         // jmpq          *-0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255,80,255                          // callq         *-0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  63                                  // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,50                              // pushq         (%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_f32_skx
.globl _sk_store_f32_skx
FUNCTION(_sk_store_f32_skx)
_sk_store_f32_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  197,124,20,193                      // vunpcklps     %ymm1,%ymm0,%ymm8
  .byte  197,124,21,217                      // vunpckhps     %ymm1,%ymm0,%ymm11
  .byte  197,108,20,203                      // vunpcklps     %ymm3,%ymm2,%ymm9
  .byte  197,108,21,227                      // vunpckhps     %ymm3,%ymm2,%ymm12
  .byte  196,65,61,20,209                    // vunpcklpd     %ymm9,%ymm8,%ymm10
  .byte  196,65,61,21,201                    // vunpckhpd     %ymm9,%ymm8,%ymm9
  .byte  196,65,37,20,196                    // vunpcklpd     %ymm12,%ymm11,%ymm8
  .byte  196,65,37,21,220                    // vunpckhpd     %ymm12,%ymm11,%ymm11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,55                              // jne           5ecf <_sk_store_f32_skx+0x7f>
  .byte  196,67,45,24,225,1                  // vinsertf128   $0x1,%xmm9,%ymm10,%ymm12
  .byte  196,67,61,24,235,1                  // vinsertf128   $0x1,%xmm11,%ymm8,%ymm13
  .byte  196,67,45,6,201,49                  // vperm2f128    $0x31,%ymm9,%ymm10,%ymm9
  .byte  196,67,61,6,195,49                  // vperm2f128    $0x31,%ymm11,%ymm8,%ymm8
  .byte  196,65,125,17,36,128                // vmovupd       %ymm12,(%r8,%rax,4)
  .byte  196,65,125,17,108,128,32            // vmovupd       %ymm13,0x20(%r8,%rax,4)
  .byte  196,65,124,17,76,128,64             // vmovups       %ymm9,0x40(%r8,%rax,4)
  .byte  196,65,125,17,68,128,96             // vmovupd       %ymm8,0x60(%r8,%rax,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,121,17,20,128                // vmovupd       %xmm10,(%r8,%rax,4)
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,240                             // je            5ecb <_sk_store_f32_skx+0x7b>
  .byte  196,65,121,17,76,128,16             // vmovupd       %xmm9,0x10(%r8,%rax,4)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,227                             // jb            5ecb <_sk_store_f32_skx+0x7b>
  .byte  196,65,121,17,68,128,32             // vmovupd       %xmm8,0x20(%r8,%rax,4)
  .byte  116,218                             // je            5ecb <_sk_store_f32_skx+0x7b>
  .byte  196,65,121,17,92,128,48             // vmovupd       %xmm11,0x30(%r8,%rax,4)
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,205                             // jb            5ecb <_sk_store_f32_skx+0x7b>
  .byte  196,67,125,25,84,128,64,1           // vextractf128  $0x1,%ymm10,0x40(%r8,%rax,4)
  .byte  116,195                             // je            5ecb <_sk_store_f32_skx+0x7b>
  .byte  196,67,125,25,76,128,80,1           // vextractf128  $0x1,%ymm9,0x50(%r8,%rax,4)
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,181                             // jb            5ecb <_sk_store_f32_skx+0x7b>
  .byte  196,67,125,25,68,128,96,1           // vextractf128  $0x1,%ymm8,0x60(%r8,%rax,4)
  .byte  235,171                             // jmp           5ecb <_sk_store_f32_skx+0x7b>

HIDDEN _sk_repeat_x_skx
.globl _sk_repeat_x_skx
FUNCTION(_sk_repeat_x_skx)
_sk_repeat_x_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,113,124,56,89,64,1               // vmulps        0x4(%rax){1to8},%ymm0,%ymm8
  .byte  196,67,125,8,192,1                  // vroundps      $0x1,%ymm8,%ymm8
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,194,61,188,193                  // vfnmadd231ps  %ymm9,%ymm8,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_repeat_y_skx
.globl _sk_repeat_y_skx
FUNCTION(_sk_repeat_y_skx)
_sk_repeat_y_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,113,116,56,89,64,1               // vmulps        0x4(%rax){1to8},%ymm1,%ymm8
  .byte  196,67,125,8,192,1                  // vroundps      $0x1,%ymm8,%ymm8
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,194,61,188,201                  // vfnmadd231ps  %ymm9,%ymm8,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_x_skx
.globl _sk_mirror_x_skx
FUNCTION(_sk_mirror_x_skx)
_sk_mirror_x_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,122,16,0                        // vmovss        (%rax),%xmm8
  .byte  197,122,16,72,4                     // vmovss        0x4(%rax),%xmm9
  .byte  196,66,125,24,208                   // vbroadcastss  %xmm8,%ymm10
  .byte  196,65,124,92,218                   // vsubps        %ymm10,%ymm0,%ymm11
  .byte  196,193,58,88,192                   // vaddss        %xmm8,%xmm8,%xmm0
  .byte  196,98,125,24,192                   // vbroadcastss  %xmm0,%ymm8
  .byte  197,178,89,5,147,66,3,0             // vmulss        0x34293(%rip),%xmm9,%xmm0        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,226,125,24,192                  // vbroadcastss  %xmm0,%ymm0
  .byte  197,164,89,192                      // vmulps        %ymm0,%ymm11,%ymm0
  .byte  196,227,125,8,192,1                 // vroundps      $0x1,%ymm0,%ymm0
  .byte  196,194,61,172,195                  // vfnmadd213ps  %ymm11,%ymm8,%ymm0
  .byte  196,193,124,92,194                  // vsubps        %ymm10,%ymm0,%ymm0
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,92,192                       // vsubps        %ymm0,%ymm8,%ymm8
  .byte  197,188,84,192                      // vandps        %ymm0,%ymm8,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_y_skx
.globl _sk_mirror_y_skx
FUNCTION(_sk_mirror_y_skx)
_sk_mirror_y_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,122,16,0                        // vmovss        (%rax),%xmm8
  .byte  197,122,16,72,4                     // vmovss        0x4(%rax),%xmm9
  .byte  196,66,125,24,208                   // vbroadcastss  %xmm8,%ymm10
  .byte  196,65,116,92,218                   // vsubps        %ymm10,%ymm1,%ymm11
  .byte  196,193,58,88,200                   // vaddss        %xmm8,%xmm8,%xmm1
  .byte  196,98,125,24,193                   // vbroadcastss  %xmm1,%ymm8
  .byte  197,178,89,13,66,66,3,0             // vmulss        0x34242(%rip),%xmm9,%xmm1        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,226,125,24,201                  // vbroadcastss  %xmm1,%ymm1
  .byte  197,164,89,201                      // vmulps        %ymm1,%ymm11,%ymm1
  .byte  196,227,125,8,201,1                 // vroundps      $0x1,%ymm1,%ymm1
  .byte  196,194,61,172,203                  // vfnmadd213ps  %ymm11,%ymm8,%ymm1
  .byte  196,193,116,92,202                  // vsubps        %ymm10,%ymm1,%ymm1
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,92,193                       // vsubps        %ymm1,%ymm8,%ymm8
  .byte  197,188,84,201                      // vandps        %ymm1,%ymm8,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_x_1_skx
.globl _sk_clamp_x_1_skx
FUNCTION(_sk_clamp_x_1_skx)
_sk_clamp_x_1_skx:
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  98,241,124,56,93,5,9,66,3,0         // vminps        0x34209(%rip){1to8},%ymm0,%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_repeat_x_1_skx
.globl _sk_repeat_x_1_skx
FUNCTION(_sk_repeat_x_1_skx)
_sk_repeat_x_1_skx:
  .byte  196,99,125,8,192,1                  // vroundps      $0x1,%ymm0,%ymm8
  .byte  196,193,124,92,192                  // vsubps        %ymm8,%ymm0,%ymm0
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  98,241,124,56,93,5,231,65,3,0       // vminps        0x341e7(%rip){1to8},%ymm0,%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_x_1_skx
.globl _sk_mirror_x_1_skx
FUNCTION(_sk_mirror_x_1_skx)
_sk_mirror_x_1_skx:
  .byte  196,98,125,24,5,242,65,3,0          // vbroadcastss  0x341f2(%rip),%ymm8        # 3a230 <_sk_srcover_bgra_8888_sse2_lowp+0x2c8>
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  98,113,124,56,89,13,199,65,3,0      // vmulps        0x341c7(%rip){1to8},%ymm0,%ymm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,67,125,8,201,1                  // vroundps      $0x1,%ymm9,%ymm9
  .byte  196,65,52,88,201                    // vaddps        %ymm9,%ymm9,%ymm9
  .byte  196,193,124,92,193                  // vsubps        %ymm9,%ymm0,%ymm0
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,92,200                       // vsubps        %ymm0,%ymm8,%ymm9
  .byte  197,180,84,192                      // vandps        %ymm0,%ymm9,%ymm0
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  98,241,124,56,93,5,155,65,3,0       // vminps        0x3419b(%rip){1to8},%ymm0,%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_luminance_to_alpha_skx
.globl _sk_luminance_to_alpha_skx
FUNCTION(_sk_luminance_to_alpha_skx)
_sk_luminance_to_alpha_skx:
  .byte  98,241,116,56,89,29,173,66,3,0      // vmulps        0x342ad(%rip){1to8},%ymm1,%ymm3        # 3a338 <_sk_srcover_bgra_8888_sse2_lowp+0x3d0>
  .byte  98,242,125,56,184,29,167,66,3,0     // vfmadd231ps   0x342a7(%rip){1to8},%ymm0,%ymm3        # 3a33c <_sk_srcover_bgra_8888_sse2_lowp+0x3d4>
  .byte  98,242,109,56,184,29,161,66,3,0     // vfmadd231ps   0x342a1(%rip){1to8},%ymm2,%ymm3        # 3a340 <_sk_srcover_bgra_8888_sse2_lowp+0x3d8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_translate_skx
.globl _sk_matrix_translate_skx
FUNCTION(_sk_matrix_translate_skx)
_sk_matrix_translate_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  98,241,124,56,88,0                  // vaddps        (%rax){1to8},%ymm0,%ymm0
  .byte  98,241,116,56,88,72,1               // vaddps        0x4(%rax){1to8},%ymm1,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_scale_translate_skx
.globl _sk_matrix_scale_translate_skx
FUNCTION(_sk_matrix_scale_translate_skx)
_sk_matrix_scale_translate_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  98,242,61,56,168,64,2               // vfmadd213ps   0x8(%rax){1to8},%ymm8,%ymm0
  .byte  196,98,125,24,64,4                  // vbroadcastss  0x4(%rax),%ymm8
  .byte  98,242,61,56,168,72,3               // vfmadd213ps   0xc(%rax){1to8},%ymm8,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_2x3_skx
.globl _sk_matrix_2x3_skx
FUNCTION(_sk_matrix_2x3_skx)
_sk_matrix_2x3_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,98,125,24,64,8                  // vbroadcastss  0x8(%rax),%ymm8
  .byte  98,114,117,56,168,64,4              // vfmadd213ps   0x10(%rax){1to8},%ymm1,%ymm8
  .byte  196,66,125,184,193                  // vfmadd231ps   %ymm9,%ymm0,%ymm8
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  98,114,117,56,168,72,5              // vfmadd213ps   0x14(%rax){1to8},%ymm1,%ymm9
  .byte  196,66,125,184,202                  // vfmadd231ps   %ymm10,%ymm0,%ymm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,124,41,201                      // vmovaps       %ymm9,%ymm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_3x4_skx
.globl _sk_matrix_3x4_skx
FUNCTION(_sk_matrix_3x4_skx)
_sk_matrix_3x4_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,98,125,24,80,12                 // vbroadcastss  0xc(%rax),%ymm10
  .byte  196,98,125,24,64,24                 // vbroadcastss  0x18(%rax),%ymm8
  .byte  98,114,109,56,168,64,9              // vfmadd213ps   0x24(%rax){1to8},%ymm2,%ymm8
  .byte  196,66,117,184,194                  // vfmadd231ps   %ymm10,%ymm1,%ymm8
  .byte  196,66,125,184,193                  // vfmadd231ps   %ymm9,%ymm0,%ymm8
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  196,98,125,24,88,16                 // vbroadcastss  0x10(%rax),%ymm11
  .byte  196,98,125,24,72,28                 // vbroadcastss  0x1c(%rax),%ymm9
  .byte  98,114,109,56,168,72,10             // vfmadd213ps   0x28(%rax){1to8},%ymm2,%ymm9
  .byte  196,66,117,184,203                  // vfmadd231ps   %ymm11,%ymm1,%ymm9
  .byte  196,66,125,184,202                  // vfmadd231ps   %ymm10,%ymm0,%ymm9
  .byte  196,98,125,24,88,8                  // vbroadcastss  0x8(%rax),%ymm11
  .byte  196,98,125,24,96,20                 // vbroadcastss  0x14(%rax),%ymm12
  .byte  196,98,125,24,80,32                 // vbroadcastss  0x20(%rax),%ymm10
  .byte  98,114,109,56,168,80,11             // vfmadd213ps   0x2c(%rax){1to8},%ymm2,%ymm10
  .byte  196,66,117,184,212                  // vfmadd231ps   %ymm12,%ymm1,%ymm10
  .byte  196,66,125,184,211                  // vfmadd231ps   %ymm11,%ymm0,%ymm10
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,124,41,201                      // vmovaps       %ymm9,%ymm1
  .byte  197,124,41,210                      // vmovaps       %ymm10,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_4x5_skx
.globl _sk_matrix_4x5_skx
FUNCTION(_sk_matrix_4x5_skx)
_sk_matrix_4x5_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,98,125,24,80,16                 // vbroadcastss  0x10(%rax),%ymm10
  .byte  196,98,125,24,88,32                 // vbroadcastss  0x20(%rax),%ymm11
  .byte  196,98,125,24,64,48                 // vbroadcastss  0x30(%rax),%ymm8
  .byte  98,114,101,56,168,64,16             // vfmadd213ps   0x40(%rax){1to8},%ymm3,%ymm8
  .byte  196,66,109,184,195                  // vfmadd231ps   %ymm11,%ymm2,%ymm8
  .byte  196,66,117,184,194                  // vfmadd231ps   %ymm10,%ymm1,%ymm8
  .byte  196,66,125,184,193                  // vfmadd231ps   %ymm9,%ymm0,%ymm8
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  196,98,125,24,96,36                 // vbroadcastss  0x24(%rax),%ymm12
  .byte  196,98,125,24,72,52                 // vbroadcastss  0x34(%rax),%ymm9
  .byte  98,114,101,56,168,72,17             // vfmadd213ps   0x44(%rax){1to8},%ymm3,%ymm9
  .byte  196,66,109,184,204                  // vfmadd231ps   %ymm12,%ymm2,%ymm9
  .byte  196,66,117,184,203                  // vfmadd231ps   %ymm11,%ymm1,%ymm9
  .byte  196,66,125,184,202                  // vfmadd231ps   %ymm10,%ymm0,%ymm9
  .byte  196,98,125,24,88,8                  // vbroadcastss  0x8(%rax),%ymm11
  .byte  196,98,125,24,96,24                 // vbroadcastss  0x18(%rax),%ymm12
  .byte  196,98,125,24,104,40                // vbroadcastss  0x28(%rax),%ymm13
  .byte  196,98,125,24,80,56                 // vbroadcastss  0x38(%rax),%ymm10
  .byte  98,114,101,56,168,80,18             // vfmadd213ps   0x48(%rax){1to8},%ymm3,%ymm10
  .byte  196,66,109,184,213                  // vfmadd231ps   %ymm13,%ymm2,%ymm10
  .byte  196,66,117,184,212                  // vfmadd231ps   %ymm12,%ymm1,%ymm10
  .byte  196,66,125,184,211                  // vfmadd231ps   %ymm11,%ymm0,%ymm10
  .byte  196,98,125,24,96,12                 // vbroadcastss  0xc(%rax),%ymm12
  .byte  196,98,125,24,104,28                // vbroadcastss  0x1c(%rax),%ymm13
  .byte  196,98,125,24,112,44                // vbroadcastss  0x2c(%rax),%ymm14
  .byte  196,98,125,24,88,60                 // vbroadcastss  0x3c(%rax),%ymm11
  .byte  98,114,101,56,168,88,19             // vfmadd213ps   0x4c(%rax){1to8},%ymm3,%ymm11
  .byte  196,66,109,184,222                  // vfmadd231ps   %ymm14,%ymm2,%ymm11
  .byte  196,66,117,184,221                  // vfmadd231ps   %ymm13,%ymm1,%ymm11
  .byte  196,66,125,184,220                  // vfmadd231ps   %ymm12,%ymm0,%ymm11
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,124,41,201                      // vmovaps       %ymm9,%ymm1
  .byte  197,124,41,210                      // vmovaps       %ymm10,%ymm2
  .byte  197,124,41,219                      // vmovaps       %ymm11,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_4x3_skx
.globl _sk_matrix_4x3_skx
FUNCTION(_sk_matrix_4x3_skx)
_sk_matrix_4x3_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,16                   // vbroadcastss  (%rax),%ymm2
  .byte  196,98,125,24,64,16                 // vbroadcastss  0x10(%rax),%ymm8
  .byte  98,114,117,56,168,64,8              // vfmadd213ps   0x20(%rax){1to8},%ymm1,%ymm8
  .byte  196,98,125,184,194                  // vfmadd231ps   %ymm2,%ymm0,%ymm8
  .byte  196,226,125,24,80,4                 // vbroadcastss  0x4(%rax),%ymm2
  .byte  196,98,125,24,72,20                 // vbroadcastss  0x14(%rax),%ymm9
  .byte  98,114,117,56,168,72,9              // vfmadd213ps   0x24(%rax){1to8},%ymm1,%ymm9
  .byte  196,98,125,184,202                  // vfmadd231ps   %ymm2,%ymm0,%ymm9
  .byte  196,226,125,24,88,8                 // vbroadcastss  0x8(%rax),%ymm3
  .byte  196,226,125,24,80,24                // vbroadcastss  0x18(%rax),%ymm2
  .byte  98,242,117,56,168,80,10             // vfmadd213ps   0x28(%rax){1to8},%ymm1,%ymm2
  .byte  196,226,125,184,211                 // vfmadd231ps   %ymm3,%ymm0,%ymm2
  .byte  196,98,125,24,80,12                 // vbroadcastss  0xc(%rax),%ymm10
  .byte  196,226,125,24,88,28                // vbroadcastss  0x1c(%rax),%ymm3
  .byte  98,242,117,56,168,88,11             // vfmadd213ps   0x2c(%rax){1to8},%ymm1,%ymm3
  .byte  196,194,125,184,218                 // vfmadd231ps   %ymm10,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,124,41,201                      // vmovaps       %ymm9,%ymm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_perspective_skx
.globl _sk_matrix_perspective_skx
FUNCTION(_sk_matrix_perspective_skx)
_sk_matrix_perspective_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  196,98,125,24,72,4                  // vbroadcastss  0x4(%rax),%ymm9
  .byte  98,114,117,56,168,72,2              // vfmadd213ps   0x8(%rax){1to8},%ymm1,%ymm9
  .byte  196,66,125,184,200                  // vfmadd231ps   %ymm8,%ymm0,%ymm9
  .byte  196,98,125,24,64,12                 // vbroadcastss  0xc(%rax),%ymm8
  .byte  196,98,125,24,80,16                 // vbroadcastss  0x10(%rax),%ymm10
  .byte  98,114,117,56,168,80,5              // vfmadd213ps   0x14(%rax){1to8},%ymm1,%ymm10
  .byte  196,66,125,184,208                  // vfmadd231ps   %ymm8,%ymm0,%ymm10
  .byte  196,98,125,24,64,24                 // vbroadcastss  0x18(%rax),%ymm8
  .byte  196,98,125,24,88,28                 // vbroadcastss  0x1c(%rax),%ymm11
  .byte  98,114,117,56,168,88,8              // vfmadd213ps   0x20(%rax){1to8},%ymm1,%ymm11
  .byte  196,66,125,184,216                  // vfmadd231ps   %ymm8,%ymm0,%ymm11
  .byte  98,210,125,40,76,203                // vrcp14ps      %ymm11,%ymm1
  .byte  197,180,89,193                      // vmulps        %ymm1,%ymm9,%ymm0
  .byte  197,172,89,201                      // vmulps        %ymm1,%ymm10,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_gradient_skx
.globl _sk_evenly_spaced_gradient_skx
FUNCTION(_sk_evenly_spaced_gradient_skx)
_sk_evenly_spaced_gradient_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,8                            // mov           (%rax),%r9
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  77,141,81,255                       // lea           -0x1(%r9),%r10
  .byte  98,210,253,72,124,202               // vpbroadcastq  %r10,%zmm1
  .byte  98,241,255,72,122,201               // vcvtuqq2ps    %zmm1,%ymm1
  .byte  197,244,89,200                      // vmulps        %ymm0,%ymm1,%ymm1
  .byte  197,126,91,209                      // vcvttps2dq    %ymm1,%ymm10
  .byte  73,131,249,8                        // cmp           $0x8,%r9
  .byte  119,73                              // ja            639d <_sk_evenly_spaced_gradient_skx+0x70>
  .byte  196,66,45,22,0                      // vpermps       (%r8),%ymm10,%ymm8
  .byte  76,139,64,40                        // mov           0x28(%rax),%r8
  .byte  196,66,45,22,8                      // vpermps       (%r8),%ymm10,%ymm9
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  76,139,72,24                        // mov           0x18(%rax),%r9
  .byte  196,194,45,22,8                     // vpermps       (%r8),%ymm10,%ymm1
  .byte  76,139,64,48                        // mov           0x30(%rax),%r8
  .byte  196,66,45,22,24                     // vpermps       (%r8),%ymm10,%ymm11
  .byte  196,194,45,22,17                    // vpermps       (%r9),%ymm10,%ymm2
  .byte  76,139,64,56                        // mov           0x38(%rax),%r8
  .byte  196,66,45,22,32                     // vpermps       (%r8),%ymm10,%ymm12
  .byte  76,139,64,32                        // mov           0x20(%rax),%r8
  .byte  196,194,45,22,24                    // vpermps       (%r8),%ymm10,%ymm3
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  196,98,45,22,40                     // vpermps       (%rax),%ymm10,%ymm13
  .byte  233,147,0,0,0                       // jmpq          6430 <_sk_evenly_spaced_gradient_skx+0x103>
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,2,117,146,4,144                 // vgatherdps    %ymm1,(%r8,%ymm10,4),%ymm8
  .byte  76,139,64,40                        // mov           0x28(%rax),%r8
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  196,2,117,146,12,144                // vgatherdps    %ymm1,(%r8,%ymm10,4),%ymm9
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  76,139,72,24                        // mov           0x18(%rax),%r9
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,130,109,146,12,144              // vgatherdps    %ymm2,(%r8,%ymm10,4),%ymm1
  .byte  76,139,64,48                        // mov           0x30(%rax),%r8
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  196,2,109,146,28,144                // vgatherdps    %ymm2,(%r8,%ymm10,4),%ymm11
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,130,101,146,20,145              // vgatherdps    %ymm3,(%r9,%ymm10,4),%ymm2
  .byte  76,139,64,56                        // mov           0x38(%rax),%r8
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,65,28,87,228                    // vxorps        %ymm12,%ymm12,%ymm12
  .byte  196,2,101,146,36,144                // vgatherdps    %ymm3,(%r8,%ymm10,4),%ymm12
  .byte  196,65,13,118,246                   // vpcmpeqd      %ymm14,%ymm14,%ymm14
  .byte  76,139,64,32                        // mov           0x20(%rax),%r8
  .byte  196,65,21,118,237                   // vpcmpeqd      %ymm13,%ymm13,%ymm13
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,130,21,146,28,144               // vgatherdps    %ymm13,(%r8,%ymm10,4),%ymm3
  .byte  196,65,20,87,237                    // vxorps        %ymm13,%ymm13,%ymm13
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  196,34,13,146,44,144                // vgatherdps    %ymm14,(%rax,%ymm10,4),%ymm13
  .byte  196,66,125,168,193                  // vfmadd213ps   %ymm9,%ymm0,%ymm8
  .byte  196,194,125,168,203                 // vfmadd213ps   %ymm11,%ymm0,%ymm1
  .byte  196,194,125,168,212                 // vfmadd213ps   %ymm12,%ymm0,%ymm2
  .byte  196,194,125,168,221                 // vfmadd213ps   %ymm13,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gradient_skx
.globl _sk_gradient_skx
FUNCTION(_sk_gradient_skx)
_sk_gradient_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  73,131,248,1                        // cmp           $0x1,%r8
  .byte  15,134,229,0,0,0                    // jbe           6540 <_sk_gradient_skx+0xf4>
  .byte  76,139,72,72                        // mov           0x48(%rax),%r9
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  65,186,1,0,0,0                      // mov           $0x1,%r10d
  .byte  196,226,125,24,21,170,61,3,0        // vbroadcastss  0x33daa(%rip),%ymm2        # 3a21c <_sk_srcover_bgra_8888_sse2_lowp+0x2b4>
  .byte  196,65,53,239,201                   // vpxor         %ymm9,%ymm9,%ymm9
  .byte  196,130,125,24,28,145               // vbroadcastss  (%r9,%r10,4),%ymm3
  .byte  98,241,100,40,194,192,2             // vcmpleps      %ymm0,%ymm3,%k0
  .byte  98,242,126,40,56,216                // vpmovm2d      %k0,%ymm3
  .byte  196,227,117,74,218,48               // vblendvps     %ymm3,%ymm2,%ymm1,%ymm3
  .byte  197,53,254,203                      // vpaddd        %ymm3,%ymm9,%ymm9
  .byte  73,131,194,1                        // add           $0x1,%r10
  .byte  77,57,208                           // cmp           %r10,%r8
  .byte  117,218                             // jne           6477 <_sk_gradient_skx+0x2b>
  .byte  76,139,72,8                         // mov           0x8(%rax),%r9
  .byte  73,131,248,8                        // cmp           $0x8,%r8
  .byte  15,134,158,0,0,0                    // jbe           6549 <_sk_gradient_skx+0xfd>
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,2,117,146,4,137                 // vgatherdps    %ymm1,(%r9,%ymm9,4),%ymm8
  .byte  76,139,64,40                        // mov           0x28(%rax),%r8
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,2,117,146,20,136                // vgatherdps    %ymm1,(%r8,%ymm9,4),%ymm10
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  76,139,72,24                        // mov           0x18(%rax),%r9
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,130,109,146,12,136              // vgatherdps    %ymm2,(%r8,%ymm9,4),%ymm1
  .byte  76,139,64,48                        // mov           0x30(%rax),%r8
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  196,2,109,146,28,136                // vgatherdps    %ymm2,(%r8,%ymm9,4),%ymm11
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,130,101,146,20,137              // vgatherdps    %ymm3,(%r9,%ymm9,4),%ymm2
  .byte  76,139,64,56                        // mov           0x38(%rax),%r8
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,65,28,87,228                    // vxorps        %ymm12,%ymm12,%ymm12
  .byte  196,2,101,146,36,136                // vgatherdps    %ymm3,(%r8,%ymm9,4),%ymm12
  .byte  196,65,13,118,246                   // vpcmpeqd      %ymm14,%ymm14,%ymm14
  .byte  76,139,64,32                        // mov           0x20(%rax),%r8
  .byte  196,65,21,118,237                   // vpcmpeqd      %ymm13,%ymm13,%ymm13
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,130,21,146,28,136               // vgatherdps    %ymm13,(%r8,%ymm9,4),%ymm3
  .byte  196,65,20,87,237                    // vxorps        %ymm13,%ymm13,%ymm13
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  196,34,13,146,44,136                // vgatherdps    %ymm14,(%rax,%ymm9,4),%ymm13
  .byte  235,77                              // jmp           658d <_sk_gradient_skx+0x141>
  .byte  76,139,72,8                         // mov           0x8(%rax),%r9
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  196,66,53,22,1                      // vpermps       (%r9),%ymm9,%ymm8
  .byte  76,139,64,40                        // mov           0x28(%rax),%r8
  .byte  196,66,53,22,16                     // vpermps       (%r8),%ymm9,%ymm10
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  76,139,72,24                        // mov           0x18(%rax),%r9
  .byte  196,194,53,22,8                     // vpermps       (%r8),%ymm9,%ymm1
  .byte  76,139,64,48                        // mov           0x30(%rax),%r8
  .byte  196,66,53,22,24                     // vpermps       (%r8),%ymm9,%ymm11
  .byte  196,194,53,22,17                    // vpermps       (%r9),%ymm9,%ymm2
  .byte  76,139,64,56                        // mov           0x38(%rax),%r8
  .byte  196,66,53,22,32                     // vpermps       (%r8),%ymm9,%ymm12
  .byte  76,139,64,32                        // mov           0x20(%rax),%r8
  .byte  196,194,53,22,24                    // vpermps       (%r8),%ymm9,%ymm3
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  196,98,53,22,40                     // vpermps       (%rax),%ymm9,%ymm13
  .byte  196,66,125,168,194                  // vfmadd213ps   %ymm10,%ymm0,%ymm8
  .byte  196,194,125,168,203                 // vfmadd213ps   %ymm11,%ymm0,%ymm1
  .byte  196,194,125,168,212                 // vfmadd213ps   %ymm12,%ymm0,%ymm2
  .byte  196,194,125,168,221                 // vfmadd213ps   %ymm13,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_2_stop_gradient_skx
.globl _sk_evenly_spaced_2_stop_gradient_skx
FUNCTION(_sk_evenly_spaced_2_stop_gradient_skx)
_sk_evenly_spaced_2_stop_gradient_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  98,114,125,56,168,64,4              // vfmadd213ps   0x10(%rax){1to8},%ymm0,%ymm8
  .byte  196,226,125,24,72,4                 // vbroadcastss  0x4(%rax),%ymm1
  .byte  98,242,125,56,168,72,5              // vfmadd213ps   0x14(%rax){1to8},%ymm0,%ymm1
  .byte  196,226,125,24,80,8                 // vbroadcastss  0x8(%rax),%ymm2
  .byte  98,242,125,56,168,80,6              // vfmadd213ps   0x18(%rax){1to8},%ymm0,%ymm2
  .byte  196,226,125,24,88,12                // vbroadcastss  0xc(%rax),%ymm3
  .byte  98,242,125,56,168,88,7              // vfmadd213ps   0x1c(%rax){1to8},%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_unit_angle_skx
.globl _sk_xy_to_unit_angle_skx
FUNCTION(_sk_xy_to_unit_angle_skx)
_sk_xy_to_unit_angle_skx:
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,92,200                       // vsubps        %ymm0,%ymm8,%ymm9
  .byte  197,52,84,200                       // vandps        %ymm0,%ymm9,%ymm9
  .byte  197,60,92,209                       // vsubps        %ymm1,%ymm8,%ymm10
  .byte  197,44,84,209                       // vandps        %ymm1,%ymm10,%ymm10
  .byte  196,65,52,93,218                    // vminps        %ymm10,%ymm9,%ymm11
  .byte  196,65,52,95,226                    // vmaxps        %ymm10,%ymm9,%ymm12
  .byte  196,65,36,94,220                    // vdivps        %ymm12,%ymm11,%ymm11
  .byte  196,65,36,89,227                    // vmulps        %ymm11,%ymm11,%ymm12
  .byte  196,98,125,24,45,44,61,3,0          // vbroadcastss  0x33d2c(%rip),%ymm13        # 3a344 <_sk_srcover_bgra_8888_sse2_lowp+0x3dc>
  .byte  98,114,29,56,168,45,38,61,3,0       // vfmadd213ps   0x33d26(%rip){1to8},%ymm12,%ymm13        # 3a348 <_sk_srcover_bgra_8888_sse2_lowp+0x3e0>
  .byte  98,114,29,56,168,45,32,61,3,0       // vfmadd213ps   0x33d20(%rip){1to8},%ymm12,%ymm13        # 3a34c <_sk_srcover_bgra_8888_sse2_lowp+0x3e4>
  .byte  98,114,29,56,168,45,26,61,3,0       // vfmadd213ps   0x33d1a(%rip){1to8},%ymm12,%ymm13        # 3a350 <_sk_srcover_bgra_8888_sse2_lowp+0x3e8>
  .byte  196,65,36,89,221                    // vmulps        %ymm13,%ymm11,%ymm11
  .byte  98,209,52,40,194,194,1              // vcmpltps      %ymm10,%ymm9,%k0
  .byte  98,114,126,40,56,200                // vpmovm2d      %k0,%ymm9
  .byte  196,98,125,24,21,3,61,3,0           // vbroadcastss  0x33d03(%rip),%ymm10        # 3a354 <_sk_srcover_bgra_8888_sse2_lowp+0x3ec>
  .byte  196,65,44,92,211                    // vsubps        %ymm11,%ymm10,%ymm10
  .byte  196,67,37,74,202,144                // vblendvps     %ymm9,%ymm10,%ymm11,%ymm9
  .byte  98,209,124,40,194,192,1             // vcmpltps      %ymm8,%ymm0,%k0
  .byte  98,242,126,40,56,192                // vpmovm2d      %k0,%ymm0
  .byte  196,98,125,24,21,162,59,3,0         // vbroadcastss  0x33ba2(%rip),%ymm10        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,44,92,209                    // vsubps        %ymm9,%ymm10,%ymm10
  .byte  196,195,53,74,194,0                 // vblendvps     %ymm0,%ymm10,%ymm9,%ymm0
  .byte  98,209,116,40,194,192,1             // vcmpltps      %ymm8,%ymm1,%k0
  .byte  98,114,126,40,56,200                // vpmovm2d      %k0,%ymm9
  .byte  196,98,125,24,21,133,59,3,0         // vbroadcastss  0x33b85(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,44,92,208                       // vsubps        %ymm0,%ymm10,%ymm10
  .byte  196,195,125,74,194,144              // vblendvps     %ymm9,%ymm10,%ymm0,%ymm0
  .byte  98,209,124,40,194,192,3             // vcmpunordps   %ymm8,%ymm0,%k0
  .byte  98,114,126,40,56,200                // vpmovm2d      %k0,%ymm9
  .byte  196,195,125,74,192,144              // vblendvps     %ymm9,%ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_radius_skx
.globl _sk_xy_to_radius_skx
FUNCTION(_sk_xy_to_radius_skx)
_sk_xy_to_radius_skx:
  .byte  197,116,89,193                      // vmulps        %ymm1,%ymm1,%ymm8
  .byte  196,98,125,184,192                  // vfmadd231ps   %ymm0,%ymm0,%ymm8
  .byte  196,193,124,81,192                  // vsqrtps       %ymm8,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_quadratic_first_skx
.globl _sk_xy_to_2pt_conical_quadratic_first_skx
FUNCTION(_sk_xy_to_2pt_conical_quadratic_first_skx)
_sk_xy_to_2pt_conical_quadratic_first_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,64                 // vbroadcastss  0x40(%rax),%ymm8
  .byte  197,122,16,72,72                    // vmovss        0x48(%rax),%xmm9
  .byte  197,50,89,80,76                     // vmulss        0x4c(%rax),%xmm9,%xmm10
  .byte  196,66,125,24,210                   // vbroadcastss  %xmm10,%ymm10
  .byte  197,44,88,208                       // vaddps        %ymm0,%ymm10,%ymm10
  .byte  98,113,44,56,89,21,109,60,3,0       // vmulps        0x33c6d(%rip){1to8},%ymm10,%ymm10        # 3a358 <_sk_srcover_bgra_8888_sse2_lowp+0x3f0>
  .byte  197,116,89,217                      // vmulps        %ymm1,%ymm1,%ymm11
  .byte  196,98,125,184,216                  // vfmadd231ps   %ymm0,%ymm0,%ymm11
  .byte  196,193,50,89,193                   // vmulss        %xmm9,%xmm9,%xmm0
  .byte  196,226,125,24,192                  // vbroadcastss  %xmm0,%ymm0
  .byte  197,164,92,192                      // vsubps        %ymm0,%ymm11,%ymm0
  .byte  98,113,60,56,89,5,80,60,3,0         // vmulps        0x33c50(%rip){1to8},%ymm8,%ymm8        # 3a35c <_sk_srcover_bgra_8888_sse2_lowp+0x3f4>
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  196,194,45,184,194                  // vfmadd231ps   %ymm10,%ymm10,%ymm0
  .byte  197,252,81,192                      // vsqrtps       %ymm0,%ymm0
  .byte  196,98,125,24,64,68                 // vbroadcastss  0x44(%rax),%ymm8
  .byte  196,193,124,92,194                  // vsubps        %ymm10,%ymm0,%ymm0
  .byte  98,113,60,56,89,5,230,58,3,0        // vmulps        0x33ae6(%rip){1to8},%ymm8,%ymm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_quadratic_second_skx
.globl _sk_xy_to_2pt_conical_quadratic_second_skx
FUNCTION(_sk_xy_to_2pt_conical_quadratic_second_skx)
_sk_xy_to_2pt_conical_quadratic_second_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,64                 // vbroadcastss  0x40(%rax),%ymm8
  .byte  197,122,16,72,72                    // vmovss        0x48(%rax),%xmm9
  .byte  197,50,89,80,76                     // vmulss        0x4c(%rax),%xmm9,%xmm10
  .byte  196,66,125,24,210                   // vbroadcastss  %xmm10,%ymm10
  .byte  197,44,88,208                       // vaddps        %ymm0,%ymm10,%ymm10
  .byte  98,113,44,56,89,21,252,59,3,0       // vmulps        0x33bfc(%rip){1to8},%ymm10,%ymm10        # 3a358 <_sk_srcover_bgra_8888_sse2_lowp+0x3f0>
  .byte  197,116,89,217                      // vmulps        %ymm1,%ymm1,%ymm11
  .byte  196,98,125,184,216                  // vfmadd231ps   %ymm0,%ymm0,%ymm11
  .byte  196,193,50,89,193                   // vmulss        %xmm9,%xmm9,%xmm0
  .byte  196,226,125,24,192                  // vbroadcastss  %xmm0,%ymm0
  .byte  197,164,92,192                      // vsubps        %ymm0,%ymm11,%ymm0
  .byte  98,113,60,56,89,5,223,59,3,0        // vmulps        0x33bdf(%rip){1to8},%ymm8,%ymm8        # 3a35c <_sk_srcover_bgra_8888_sse2_lowp+0x3f4>
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  196,194,45,184,194                  // vfmadd231ps   %ymm10,%ymm10,%ymm0
  .byte  197,252,81,192                      // vsqrtps       %ymm0,%ymm0
  .byte  196,98,125,24,64,68                 // vbroadcastss  0x44(%rax),%ymm8
  .byte  98,113,44,56,87,13,198,59,3,0       // vxorps        0x33bc6(%rip){1to8},%ymm10,%ymm9        # 3a360 <_sk_srcover_bgra_8888_sse2_lowp+0x3f8>
  .byte  98,113,60,56,89,5,112,58,3,0        // vmulps        0x33a70(%rip){1to8},%ymm8,%ymm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,180,92,192                      // vsubps        %ymm0,%ymm9,%ymm0
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_linear_skx
.globl _sk_xy_to_2pt_conical_linear_skx
FUNCTION(_sk_xy_to_2pt_conical_linear_skx)
_sk_xy_to_2pt_conical_linear_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,122,16,64,72                    // vmovss        0x48(%rax),%xmm8
  .byte  197,58,89,72,76                     // vmulss        0x4c(%rax),%xmm8,%xmm9
  .byte  196,66,125,24,201                   // vbroadcastss  %xmm9,%ymm9
  .byte  197,52,88,200                       // vaddps        %ymm0,%ymm9,%ymm9
  .byte  98,113,52,56,89,13,136,59,3,0       // vmulps        0x33b88(%rip){1to8},%ymm9,%ymm9        # 3a358 <_sk_srcover_bgra_8888_sse2_lowp+0x3f0>
  .byte  197,116,89,209                      // vmulps        %ymm1,%ymm1,%ymm10
  .byte  196,98,125,184,208                  // vfmadd231ps   %ymm0,%ymm0,%ymm10
  .byte  196,193,58,89,192                   // vmulss        %xmm8,%xmm8,%xmm0
  .byte  196,226,125,24,192                  // vbroadcastss  %xmm0,%ymm0
  .byte  197,172,92,192                      // vsubps        %ymm0,%ymm10,%ymm0
  .byte  98,241,124,56,87,5,111,59,3,0       // vxorps        0x33b6f(%rip){1to8},%ymm0,%ymm0        # 3a360 <_sk_srcover_bgra_8888_sse2_lowp+0x3f8>
  .byte  196,193,124,94,193                  // vdivps        %ymm9,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mask_2pt_conical_degenerates_skx
.globl _sk_mask_2pt_conical_degenerates_skx
FUNCTION(_sk_mask_2pt_conical_degenerates_skx)
_sk_mask_2pt_conical_degenerates_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,76                 // vbroadcastss  0x4c(%rax),%ymm8
  .byte  98,114,125,56,168,64,18             // vfmadd213ps   0x48(%rax){1to8},%ymm0,%ymm8
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  98,209,60,40,194,193,1              // vcmpltps      %ymm9,%ymm8,%k0
  .byte  98,209,124,40,194,201,3             // vcmpunordps   %ymm9,%ymm0,%k1
  .byte  197,253,69,193                      // korb          %k1,%k0,%k0
  .byte  98,114,126,40,56,192                // vpmovm2d      %k0,%ymm8
  .byte  196,195,125,74,193,128              // vblendvps     %ymm8,%ymm9,%ymm0,%ymm0
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  196,67,45,74,193,128                // vblendvps     %ymm8,%ymm9,%ymm10,%ymm8
  .byte  197,124,17,0                        // vmovups       %ymm8,(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_apply_vector_mask_skx
.globl _sk_apply_vector_mask_skx
FUNCTION(_sk_apply_vector_mask_skx)
_sk_apply_vector_mask_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,16,0                        // vmovups       (%rax),%ymm8
  .byte  197,188,84,192                      // vandps        %ymm0,%ymm8,%ymm0
  .byte  197,188,84,201                      // vandps        %ymm1,%ymm8,%ymm1
  .byte  197,188,84,210                      // vandps        %ymm2,%ymm8,%ymm2
  .byte  197,188,84,219                      // vandps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_save_xy_skx
.globl _sk_save_xy_skx
FUNCTION(_sk_save_xy_skx)
_sk_save_xy_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,5,176,57,3,0          // vbroadcastss  0x339b0(%rip),%ymm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,124,88,200                   // vaddps        %ymm8,%ymm0,%ymm9
  .byte  196,67,125,8,209,1                  // vroundps      $0x1,%ymm9,%ymm10
  .byte  196,65,52,92,202                    // vsubps        %ymm10,%ymm9,%ymm9
  .byte  196,65,116,88,192                   // vaddps        %ymm8,%ymm1,%ymm8
  .byte  196,67,125,8,208,1                  // vroundps      $0x1,%ymm8,%ymm10
  .byte  196,65,60,92,194                    // vsubps        %ymm10,%ymm8,%ymm8
  .byte  197,252,17,0                        // vmovups       %ymm0,(%rax)
  .byte  197,252,17,72,64                    // vmovups       %ymm1,0x40(%rax)
  .byte  197,124,17,136,128,0,0,0            // vmovups       %ymm9,0x80(%rax)
  .byte  197,124,17,128,192,0,0,0            // vmovups       %ymm8,0xc0(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_accumulate_skx
.globl _sk_accumulate_skx
FUNCTION(_sk_accumulate_skx)
_sk_accumulate_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,16,128,0,1,0,0              // vmovups       0x100(%rax),%ymm8
  .byte  197,60,89,128,64,1,0,0              // vmulps        0x140(%rax),%ymm8,%ymm8
  .byte  196,226,61,184,224                  // vfmadd231ps   %ymm0,%ymm8,%ymm4
  .byte  196,226,61,184,233                  // vfmadd231ps   %ymm1,%ymm8,%ymm5
  .byte  196,226,61,184,242                  // vfmadd231ps   %ymm2,%ymm8,%ymm6
  .byte  196,98,101,168,199                  // vfmadd213ps   %ymm7,%ymm3,%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,199                      // vmovaps       %ymm8,%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_nx_skx
.globl _sk_bilinear_nx_skx
FUNCTION(_sk_bilinear_nx_skx)
_sk_bilinear_nx_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,0                        // vmovups       (%rax),%ymm0
  .byte  98,241,124,56,88,5,133,58,3,0       // vaddps        0x33a85(%rip){1to8},%ymm0,%ymm0        # 3a364 <_sk_srcover_bgra_8888_sse2_lowp+0x3fc>
  .byte  196,98,125,24,5,48,57,3,0           // vbroadcastss  0x33930(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,128,0,0,0             // vsubps        0x80(%rax),%ymm8,%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_px_skx
.globl _sk_bilinear_px_skx
FUNCTION(_sk_bilinear_px_skx)
_sk_bilinear_px_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,0                        // vmovups       (%rax),%ymm0
  .byte  197,124,16,128,128,0,0,0            // vmovups       0x80(%rax),%ymm8
  .byte  98,241,124,56,88,5,0,57,3,0         // vaddps        0x33900(%rip){1to8},%ymm0,%ymm0        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_ny_skx
.globl _sk_bilinear_ny_skx
FUNCTION(_sk_bilinear_ny_skx)
_sk_bilinear_ny_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,72,64                    // vmovups       0x40(%rax),%ymm1
  .byte  98,241,116,56,88,13,51,58,3,0       // vaddps        0x33a33(%rip){1to8},%ymm1,%ymm1        # 3a364 <_sk_srcover_bgra_8888_sse2_lowp+0x3fc>
  .byte  196,98,125,24,5,222,56,3,0          // vbroadcastss  0x338de(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,192,0,0,0             // vsubps        0xc0(%rax),%ymm8,%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_py_skx
.globl _sk_bilinear_py_skx
FUNCTION(_sk_bilinear_py_skx)
_sk_bilinear_py_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,72,64                    // vmovups       0x40(%rax),%ymm1
  .byte  197,124,16,128,192,0,0,0            // vmovups       0xc0(%rax),%ymm8
  .byte  98,241,116,56,88,13,173,56,3,0      // vaddps        0x338ad(%rip){1to8},%ymm1,%ymm1        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n3x_skx
.globl _sk_bicubic_n3x_skx
FUNCTION(_sk_bicubic_n3x_skx)
_sk_bicubic_n3x_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,0                        // vmovups       (%rax),%ymm0
  .byte  98,241,124,56,88,5,229,57,3,0       // vaddps        0x339e5(%rip){1to8},%ymm0,%ymm0        # 3a368 <_sk_srcover_bgra_8888_sse2_lowp+0x400>
  .byte  196,98,125,24,5,140,56,3,0          // vbroadcastss  0x3388c(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,128,0,0,0             // vsubps        0x80(%rax),%ymm8,%ymm8
  .byte  196,65,60,89,200                    // vmulps        %ymm8,%ymm8,%ymm9
  .byte  196,98,125,24,21,202,57,3,0         // vbroadcastss  0x339ca(%rip),%ymm10        # 3a36c <_sk_srcover_bgra_8888_sse2_lowp+0x404>
  .byte  98,114,61,56,168,21,224,56,3,0      // vfmadd213ps   0x338e0(%rip){1to8},%ymm8,%ymm10        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  196,65,44,89,193                    // vmulps        %ymm9,%ymm10,%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n1x_skx
.globl _sk_bicubic_n1x_skx
FUNCTION(_sk_bicubic_n1x_skx)
_sk_bicubic_n1x_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,0                        // vmovups       (%rax),%ymm0
  .byte  98,241,124,56,88,5,151,57,3,0       // vaddps        0x33997(%rip){1to8},%ymm0,%ymm0        # 3a364 <_sk_srcover_bgra_8888_sse2_lowp+0x3fc>
  .byte  196,98,125,24,5,66,56,3,0           // vbroadcastss  0x33842(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,128,0,0,0             // vsubps        0x80(%rax),%ymm8,%ymm8
  .byte  196,98,125,24,13,137,57,3,0         // vbroadcastss  0x33989(%rip),%ymm9        # 3a370 <_sk_srcover_bgra_8888_sse2_lowp+0x408>
  .byte  98,114,61,56,168,13,131,57,3,0      // vfmadd213ps   0x33983(%rip){1to8},%ymm8,%ymm9        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  98,114,61,56,168,13,25,56,3,0       // vfmadd213ps   0x33819(%rip){1to8},%ymm8,%ymm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  98,114,61,56,168,13,115,57,3,0      // vfmadd213ps   0x33973(%rip){1to8},%ymm8,%ymm9        # 3a378 <_sk_srcover_bgra_8888_sse2_lowp+0x410>
  .byte  197,124,17,136,0,1,0,0              // vmovups       %ymm9,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p1x_skx
.globl _sk_bicubic_p1x_skx
FUNCTION(_sk_bicubic_p1x_skx)
_sk_bicubic_p1x_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,5,248,55,3,0          // vbroadcastss  0x337f8(%rip),%ymm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,188,88,0                        // vaddps        (%rax),%ymm8,%ymm0
  .byte  197,124,16,136,128,0,0,0            // vmovups       0x80(%rax),%ymm9
  .byte  196,98,125,24,21,63,57,3,0          // vbroadcastss  0x3393f(%rip),%ymm10        # 3a370 <_sk_srcover_bgra_8888_sse2_lowp+0x408>
  .byte  98,114,53,56,168,21,57,57,3,0       // vfmadd213ps   0x33939(%rip){1to8},%ymm9,%ymm10        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  196,66,53,168,208                   // vfmadd213ps   %ymm8,%ymm9,%ymm10
  .byte  98,114,53,56,168,21,46,57,3,0       // vfmadd213ps   0x3392e(%rip){1to8},%ymm9,%ymm10        # 3a378 <_sk_srcover_bgra_8888_sse2_lowp+0x410>
  .byte  197,124,17,144,0,1,0,0              // vmovups       %ymm10,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p3x_skx
.globl _sk_bicubic_p3x_skx
FUNCTION(_sk_bicubic_p3x_skx)
_sk_bicubic_p3x_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,0                        // vmovups       (%rax),%ymm0
  .byte  197,124,16,128,128,0,0,0            // vmovups       0x80(%rax),%ymm8
  .byte  98,241,124,56,88,5,6,57,3,0         // vaddps        0x33906(%rip){1to8},%ymm0,%ymm0        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  196,65,60,89,200                    // vmulps        %ymm8,%ymm8,%ymm9
  .byte  196,98,125,24,21,240,56,3,0         // vbroadcastss  0x338f0(%rip),%ymm10        # 3a36c <_sk_srcover_bgra_8888_sse2_lowp+0x404>
  .byte  98,114,61,56,168,21,6,56,3,0        // vfmadd213ps   0x33806(%rip){1to8},%ymm8,%ymm10        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  196,65,52,89,194                    // vmulps        %ymm10,%ymm9,%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n3y_skx
.globl _sk_bicubic_n3y_skx
FUNCTION(_sk_bicubic_n3y_skx)
_sk_bicubic_n3y_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,72,64                    // vmovups       0x40(%rax),%ymm1
  .byte  98,241,116,56,88,13,192,56,3,0      // vaddps        0x338c0(%rip){1to8},%ymm1,%ymm1        # 3a368 <_sk_srcover_bgra_8888_sse2_lowp+0x400>
  .byte  196,98,125,24,5,103,55,3,0          // vbroadcastss  0x33767(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,192,0,0,0             // vsubps        0xc0(%rax),%ymm8,%ymm8
  .byte  196,65,60,89,200                    // vmulps        %ymm8,%ymm8,%ymm9
  .byte  196,98,125,24,21,165,56,3,0         // vbroadcastss  0x338a5(%rip),%ymm10        # 3a36c <_sk_srcover_bgra_8888_sse2_lowp+0x404>
  .byte  98,114,61,56,168,21,187,55,3,0      // vfmadd213ps   0x337bb(%rip){1to8},%ymm8,%ymm10        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  196,65,44,89,193                    // vmulps        %ymm9,%ymm10,%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n1y_skx
.globl _sk_bicubic_n1y_skx
FUNCTION(_sk_bicubic_n1y_skx)
_sk_bicubic_n1y_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,72,64                    // vmovups       0x40(%rax),%ymm1
  .byte  98,241,116,56,88,13,113,56,3,0      // vaddps        0x33871(%rip){1to8},%ymm1,%ymm1        # 3a364 <_sk_srcover_bgra_8888_sse2_lowp+0x3fc>
  .byte  196,98,125,24,5,28,55,3,0           // vbroadcastss  0x3371c(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,192,0,0,0             // vsubps        0xc0(%rax),%ymm8,%ymm8
  .byte  196,98,125,24,13,99,56,3,0          // vbroadcastss  0x33863(%rip),%ymm9        # 3a370 <_sk_srcover_bgra_8888_sse2_lowp+0x408>
  .byte  98,114,61,56,168,13,93,56,3,0       // vfmadd213ps   0x3385d(%rip){1to8},%ymm8,%ymm9        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  98,114,61,56,168,13,243,54,3,0      // vfmadd213ps   0x336f3(%rip){1to8},%ymm8,%ymm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  98,114,61,56,168,13,77,56,3,0       // vfmadd213ps   0x3384d(%rip){1to8},%ymm8,%ymm9        # 3a378 <_sk_srcover_bgra_8888_sse2_lowp+0x410>
  .byte  197,124,17,136,64,1,0,0             // vmovups       %ymm9,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p1y_skx
.globl _sk_bicubic_p1y_skx
FUNCTION(_sk_bicubic_p1y_skx)
_sk_bicubic_p1y_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,5,210,54,3,0          // vbroadcastss  0x336d2(%rip),%ymm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,188,88,72,64                    // vaddps        0x40(%rax),%ymm8,%ymm1
  .byte  197,124,16,136,192,0,0,0            // vmovups       0xc0(%rax),%ymm9
  .byte  196,98,125,24,21,24,56,3,0          // vbroadcastss  0x33818(%rip),%ymm10        # 3a370 <_sk_srcover_bgra_8888_sse2_lowp+0x408>
  .byte  98,114,53,56,168,21,18,56,3,0       // vfmadd213ps   0x33812(%rip){1to8},%ymm9,%ymm10        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  196,66,53,168,208                   // vfmadd213ps   %ymm8,%ymm9,%ymm10
  .byte  98,114,53,56,168,21,7,56,3,0        // vfmadd213ps   0x33807(%rip){1to8},%ymm9,%ymm10        # 3a378 <_sk_srcover_bgra_8888_sse2_lowp+0x410>
  .byte  197,124,17,144,64,1,0,0             // vmovups       %ymm10,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p3y_skx
.globl _sk_bicubic_p3y_skx
FUNCTION(_sk_bicubic_p3y_skx)
_sk_bicubic_p3y_skx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,72,64                    // vmovups       0x40(%rax),%ymm1
  .byte  197,124,16,128,192,0,0,0            // vmovups       0xc0(%rax),%ymm8
  .byte  98,241,116,56,88,13,222,55,3,0      // vaddps        0x337de(%rip){1to8},%ymm1,%ymm1        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  196,65,60,89,200                    // vmulps        %ymm8,%ymm8,%ymm9
  .byte  196,98,125,24,21,200,55,3,0         // vbroadcastss  0x337c8(%rip),%ymm10        # 3a36c <_sk_srcover_bgra_8888_sse2_lowp+0x404>
  .byte  98,114,61,56,168,21,222,54,3,0      // vfmadd213ps   0x336de(%rip){1to8},%ymm8,%ymm10        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  196,65,52,89,194                    // vmulps        %ymm10,%ymm9,%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_callback_skx
.globl _sk_callback_skx
FUNCTION(_sk_callback_skx)
_sk_callback_skx:
  .byte  85                                  // push          %rbp
  .byte  72,137,229                          // mov           %rsp,%rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,228,224                      // and           $0xffffffffffffffe0,%rsp
  .byte  72,129,236,160,0,0,0                // sub           $0xa0,%rsp
  .byte  197,252,41,124,36,96                // vmovaps       %ymm7,0x60(%rsp)
  .byte  197,252,41,116,36,64                // vmovaps       %ymm6,0x40(%rsp)
  .byte  197,252,41,108,36,32                // vmovaps       %ymm5,0x20(%rsp)
  .byte  197,252,41,36,36                    // vmovaps       %ymm4,(%rsp)
  .byte  73,137,206                          // mov           %rcx,%r14
  .byte  73,137,215                          // mov           %rdx,%r15
  .byte  73,137,253                          // mov           %rdi,%r13
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,137,195                          // mov           %rax,%rbx
  .byte  73,137,244                          // mov           %rsi,%r12
  .byte  197,252,20,225                      // vunpcklps     %ymm1,%ymm0,%ymm4
  .byte  197,252,21,193                      // vunpckhps     %ymm1,%ymm0,%ymm0
  .byte  197,236,20,203                      // vunpcklps     %ymm3,%ymm2,%ymm1
  .byte  197,236,21,211                      // vunpckhps     %ymm3,%ymm2,%ymm2
  .byte  197,221,20,217                      // vunpcklpd     %ymm1,%ymm4,%ymm3
  .byte  197,221,21,201                      // vunpckhpd     %ymm1,%ymm4,%ymm1
  .byte  197,253,20,226                      // vunpcklpd     %ymm2,%ymm0,%ymm4
  .byte  197,253,21,194                      // vunpckhpd     %ymm2,%ymm0,%ymm0
  .byte  196,227,101,24,209,1                // vinsertf128   $0x1,%xmm1,%ymm3,%ymm2
  .byte  196,227,93,24,232,1                 // vinsertf128   $0x1,%xmm0,%ymm4,%ymm5
  .byte  196,227,101,6,201,49                // vperm2f128    $0x31,%ymm1,%ymm3,%ymm1
  .byte  196,227,93,6,192,49                 // vperm2f128    $0x31,%ymm0,%ymm4,%ymm0
  .byte  197,253,17,83,8                     // vmovupd       %ymm2,0x8(%rbx)
  .byte  197,253,17,107,40                   // vmovupd       %ymm5,0x28(%rbx)
  .byte  197,253,17,75,72                    // vmovupd       %ymm1,0x48(%rbx)
  .byte  197,253,17,67,104                   // vmovupd       %ymm0,0x68(%rbx)
  .byte  77,133,237                          // test          %r13,%r13
  .byte  190,8,0,0,0                         // mov           $0x8,%esi
  .byte  65,15,69,245                        // cmovne        %r13d,%esi
  .byte  72,137,223                          // mov           %rbx,%rdi
  .byte  197,248,119                         // vzeroupper
  .byte  255,19                              // callq         *(%rbx)
  .byte  72,139,131,8,1,0,0                  // mov           0x108(%rbx),%rax
  .byte  197,248,16,0                        // vmovups       (%rax),%xmm0
  .byte  197,248,16,72,16                    // vmovups       0x10(%rax),%xmm1
  .byte  197,248,16,80,32                    // vmovups       0x20(%rax),%xmm2
  .byte  197,248,16,88,48                    // vmovups       0x30(%rax),%xmm3
  .byte  196,227,101,24,88,112,1             // vinsertf128   $0x1,0x70(%rax),%ymm3,%ymm3
  .byte  196,227,109,24,80,96,1              // vinsertf128   $0x1,0x60(%rax),%ymm2,%ymm2
  .byte  196,227,117,24,72,80,1              // vinsertf128   $0x1,0x50(%rax),%ymm1,%ymm1
  .byte  196,227,125,24,64,64,1              // vinsertf128   $0x1,0x40(%rax),%ymm0,%ymm0
  .byte  197,252,20,225                      // vunpcklps     %ymm1,%ymm0,%ymm4
  .byte  197,252,21,233                      // vunpckhps     %ymm1,%ymm0,%ymm5
  .byte  197,236,20,203                      // vunpcklps     %ymm3,%ymm2,%ymm1
  .byte  197,236,21,219                      // vunpckhps     %ymm3,%ymm2,%ymm3
  .byte  197,221,20,193                      // vunpcklpd     %ymm1,%ymm4,%ymm0
  .byte  197,221,21,201                      // vunpckhpd     %ymm1,%ymm4,%ymm1
  .byte  197,213,20,211                      // vunpcklpd     %ymm3,%ymm5,%ymm2
  .byte  197,213,21,219                      // vunpckhpd     %ymm3,%ymm5,%ymm3
  .byte  76,137,230                          // mov           %r12,%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,137,239                          // mov           %r13,%rdi
  .byte  76,137,250                          // mov           %r15,%rdx
  .byte  76,137,241                          // mov           %r14,%rcx
  .byte  197,252,40,36,36                    // vmovaps       (%rsp),%ymm4
  .byte  197,252,40,108,36,32                // vmovaps       0x20(%rsp),%ymm5
  .byte  197,252,40,116,36,64                // vmovaps       0x40(%rsp),%ymm6
  .byte  197,252,40,124,36,96                // vmovaps       0x60(%rsp),%ymm7
  .byte  72,141,101,216                      // lea           -0x28(%rbp),%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clut_3D_skx
.globl _sk_clut_3D_skx
FUNCTION(_sk_clut_3D_skx)
_sk_clut_3D_skx:
  .byte  72,129,236,24,1,0,0                 // sub           $0x118,%rsp
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,16                        // mov           0x10(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  98,82,125,40,124,193                // vpbroadcastd  %r9d,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,126,91,210                      // vcvttps2dq    %ymm2,%ymm10
  .byte  197,124,40,242                      // vmovaps       %ymm2,%ymm14
  .byte  197,124,17,116,36,224               // vmovups       %ymm14,-0x20(%rsp)
  .byte  196,65,121,110,192                  // vmovd         %r8d,%xmm8
  .byte  98,210,125,40,124,208               // vpbroadcastd  %r8d,%ymm2
  .byte  68,139,64,12                        // mov           0xc(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  98,82,125,40,124,201                // vpbroadcastd  %r9d,%ymm9
  .byte  196,65,124,91,201                   // vcvtdq2ps     %ymm9,%ymm9
  .byte  98,97,52,40,89,225                  // vmulps        %ymm1,%ymm9,%ymm28
  .byte  98,145,126,40,91,204                // vcvttps2dq    %ymm28,%ymm1
  .byte  197,254,127,140,36,128,0,0,0        // vmovdqu       %ymm1,0x80(%rsp)
  .byte  98,98,109,40,64,201                 // vpmulld       %ymm1,%ymm2,%ymm25
  .byte  98,81,53,32,254,202                 // vpaddd        %ymm10,%ymm25,%ymm9
  .byte  196,65,125,111,250                  // vmovdqa       %ymm10,%ymm15
  .byte  197,126,127,124,36,160              // vmovdqu       %ymm15,-0x60(%rsp)
  .byte  196,193,121,110,200                 // vmovd         %r8d,%xmm1
  .byte  196,194,117,64,200                  // vpmulld       %ymm8,%ymm1,%ymm1
  .byte  196,98,125,88,193                   // vpbroadcastd  %xmm1,%ymm8
  .byte  68,139,64,8                         // mov           0x8(%rax),%r8d
  .byte  65,131,192,255                      // add           $0xffffffff,%r8d
  .byte  98,210,125,40,124,200               // vpbroadcastd  %r8d,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  98,97,116,40,89,192                 // vmulps        %ymm0,%ymm1,%ymm24
  .byte  98,145,126,40,91,192                // vcvttps2dq    %ymm24,%ymm0
  .byte  197,254,127,68,36,128               // vmovdqu       %ymm0,-0x80(%rsp)
  .byte  98,226,61,40,64,224                 // vpmulld       %ymm0,%ymm8,%ymm20
  .byte  98,209,93,32,254,193                // vpaddd        %ymm9,%ymm20,%ymm0
  .byte  72,139,0                            // mov           (%rax),%rax
  .byte  98,98,125,40,88,29,210,53,3,0       // vpbroadcastd  0x335d2(%rip),%ymm27        # 3a380 <_sk_srcover_bgra_8888_sse2_lowp+0x418>
  .byte  98,146,125,40,64,195                // vpmulld       %ymm27,%ymm0,%ymm0
  .byte  196,65,45,239,210                   // vpxor         %ymm10,%ymm10,%ymm10
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,98,117,146,20,128               // vgatherdps    %ymm1,(%rax,%ymm0,4),%ymm10
  .byte  98,193,124,40,40,210                // vmovaps       %ymm10,%ymm18
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  197,125,250,209                     // vpsubd        %ymm1,%ymm0,%ymm10
  .byte  196,65,21,118,237                   // vpcmpeqd      %ymm13,%ymm13,%ymm13
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,65,37,118,219                   // vpcmpeqd      %ymm11,%ymm11,%ymm11
  .byte  196,162,37,146,12,144               // vgatherdps    %ymm11,(%rax,%ymm10,4),%ymm1
  .byte  98,97,124,40,40,233                 // vmovaps       %ymm1,%ymm29
  .byte  196,98,125,24,21,136,53,3,0         // vbroadcastss  0x33588(%rip),%ymm10        # 3a37c <_sk_srcover_bgra_8888_sse2_lowp+0x414>
  .byte  98,81,60,32,88,218                  // vaddps        %ymm10,%ymm24,%ymm11
  .byte  98,226,125,40,88,5,32,52,3,0        // vpbroadcastd  0x33420(%rip),%ymm16        # 3a224 <_sk_srcover_bgra_8888_sse2_lowp+0x2bc>
  .byte  98,177,125,40,254,192               // vpaddd        %ymm16,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,29,118,228                   // vpcmpeqd      %ymm12,%ymm12,%ymm12
  .byte  196,226,29,146,12,128               // vgatherdps    %ymm12,(%rax,%ymm0,4),%ymm1
  .byte  98,97,124,40,40,241                 // vmovaps       %ymm1,%ymm30
  .byte  196,193,126,91,195                  // vcvttps2dq    %ymm11,%ymm0
  .byte  98,226,61,40,64,232                 // vpmulld       %ymm0,%ymm8,%ymm21
  .byte  98,209,85,32,254,193                // vpaddd        %ymm9,%ymm21,%ymm0
  .byte  98,146,125,40,64,195                // vpmulld       %ymm27,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,226,61,146,12,128               // vgatherdps    %ymm8,(%rax,%ymm0,4),%ymm1
  .byte  197,252,17,140,36,224,0,0,0         // vmovups       %ymm1,0xe0(%rsp)
  .byte  196,65,125,250,197                  // vpsubd        %ymm13,%ymm0,%ymm8
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,162,53,146,12,128               // vgatherdps    %ymm9,(%rax,%ymm8,4),%ymm1
  .byte  197,252,17,140,36,192,0,0,0         // vmovups       %ymm1,0xc0(%rsp)
  .byte  98,81,28,32,88,194                  // vaddps        %ymm10,%ymm28,%ymm8
  .byte  196,65,126,91,192                   // vcvttps2dq    %ymm8,%ymm8
  .byte  98,177,125,40,254,192               // vpaddd        %ymm16,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,226,53,146,12,128               // vgatherdps    %ymm9,(%rax,%ymm0,4),%ymm1
  .byte  197,252,17,140,36,160,0,0,0         // vmovups       %ymm1,0xa0(%rsp)
  .byte  98,66,109,40,64,208                 // vpmulld       %ymm8,%ymm2,%ymm26
  .byte  98,209,45,32,254,199                // vpaddd        %ymm15,%ymm26,%ymm0
  .byte  98,177,125,40,254,212               // vpaddd        %ymm20,%ymm0,%ymm2
  .byte  98,146,109,40,64,211                // vpmulld       %ymm27,%ymm2,%ymm2
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,226,61,146,12,144               // vgatherdps    %ymm8,(%rax,%ymm2,4),%ymm1
  .byte  197,252,17,76,36,96                 // vmovups       %ymm1,0x60(%rsp)
  .byte  196,65,109,250,197                  // vpsubd        %ymm13,%ymm2,%ymm8
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,162,53,146,12,128               // vgatherdps    %ymm9,(%rax,%ymm8,4),%ymm1
  .byte  197,252,17,76,36,64                 // vmovups       %ymm1,0x40(%rsp)
  .byte  98,177,109,40,254,208               // vpaddd        %ymm16,%ymm2,%ymm2
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,226,61,146,12,144               // vgatherdps    %ymm8,(%rax,%ymm2,4),%ymm1
  .byte  197,252,17,76,36,32                 // vmovups       %ymm1,0x20(%rsp)
  .byte  98,241,85,32,254,192                // vpaddd        %ymm0,%ymm21,%ymm0
  .byte  98,146,125,40,64,195                // vpmulld       %ymm27,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,226,109,146,12,128              // vgatherdps    %ymm2,(%rax,%ymm0,4),%ymm1
  .byte  197,252,17,12,36                    // vmovups       %ymm1,(%rsp)
  .byte  196,193,125,250,213                 // vpsubd        %ymm13,%ymm0,%ymm2
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,226,61,146,12,144               // vgatherdps    %ymm8,(%rax,%ymm2,4),%ymm1
  .byte  197,252,17,76,36,192                // vmovups       %ymm1,-0x40(%rsp)
  .byte  98,177,125,40,254,192               // vpaddd        %ymm16,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,226,109,146,12,128              // vgatherdps    %ymm2,(%rax,%ymm0,4),%ymm1
  .byte  98,97,124,40,40,249                 // vmovaps       %ymm1,%ymm31
  .byte  196,193,12,88,194                   // vaddps        %ymm10,%ymm14,%ymm0
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  98,113,53,32,254,208                // vpaddd        %ymm0,%ymm25,%ymm10
  .byte  98,209,93,32,254,210                // vpaddd        %ymm10,%ymm20,%ymm2
  .byte  98,146,109,40,64,211                // vpmulld       %ymm27,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,98,53,146,4,144                 // vgatherdps    %ymm9,(%rax,%ymm2,4),%ymm8
  .byte  196,65,109,250,221                  // vpsubd        %ymm13,%ymm2,%ymm11
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  196,65,29,118,228                   // vpcmpeqd      %ymm12,%ymm12,%ymm12
  .byte  196,34,29,146,12,152                // vgatherdps    %ymm12,(%rax,%ymm11,4),%ymm9
  .byte  98,49,109,40,254,216                // vpaddd        %ymm16,%ymm2,%ymm11
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,29,118,228                   // vpcmpeqd      %ymm12,%ymm12,%ymm12
  .byte  196,162,29,146,12,152               // vgatherdps    %ymm12,(%rax,%ymm11,4),%ymm1
  .byte  98,225,124,40,40,249                // vmovaps       %ymm1,%ymm23
  .byte  98,81,85,32,254,210                 // vpaddd        %ymm10,%ymm21,%ymm10
  .byte  98,18,45,40,64,211                  // vpmulld       %ymm27,%ymm10,%ymm10
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,29,118,228                   // vpcmpeqd      %ymm12,%ymm12,%ymm12
  .byte  196,162,29,146,12,144               // vgatherdps    %ymm12,(%rax,%ymm10,4),%ymm1
  .byte  98,225,124,40,40,201                // vmovaps       %ymm1,%ymm17
  .byte  196,65,45,250,245                   // vpsubd        %ymm13,%ymm10,%ymm14
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,5,118,255                    // vpcmpeqd      %ymm15,%ymm15,%ymm15
  .byte  196,162,5,146,12,176                // vgatherdps    %ymm15,(%rax,%ymm14,4),%ymm1
  .byte  98,225,124,40,40,241                // vmovaps       %ymm1,%ymm22
  .byte  98,49,45,40,254,240                 // vpaddd        %ymm16,%ymm10,%ymm14
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,5,118,255                    // vpcmpeqd      %ymm15,%ymm15,%ymm15
  .byte  196,162,5,146,12,176                // vgatherdps    %ymm15,(%rax,%ymm14,4),%ymm1
  .byte  98,225,124,40,40,217                // vmovaps       %ymm1,%ymm19
  .byte  98,97,45,32,254,200                 // vpaddd        %ymm0,%ymm26,%ymm25
  .byte  98,177,53,32,254,196                // vpaddd        %ymm20,%ymm25,%ymm0
  .byte  98,18,125,40,64,243                 // vpmulld       %ymm27,%ymm0,%ymm14
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  196,65,5,118,255                    // vpcmpeqd      %ymm15,%ymm15,%ymm15
  .byte  196,162,5,146,4,176                 // vgatherdps    %ymm15,(%rax,%ymm14,4),%ymm0
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  196,193,13,250,202                  // vpsubd        %ymm10,%ymm14,%ymm1
  .byte  196,65,4,87,255                     // vxorps        %ymm15,%ymm15,%ymm15
  .byte  196,65,29,118,228                   // vpcmpeqd      %ymm12,%ymm12,%ymm12
  .byte  196,98,29,146,60,136                // vgatherdps    %ymm12,(%rax,%ymm1,4),%ymm15
  .byte  98,177,13,40,254,200                // vpaddd        %ymm16,%ymm14,%ymm1
  .byte  196,65,12,87,246                    // vxorps        %ymm14,%ymm14,%ymm14
  .byte  196,65,29,118,228                   // vpcmpeqd      %ymm12,%ymm12,%ymm12
  .byte  196,98,29,146,52,136                // vgatherdps    %ymm12,(%rax,%ymm1,4),%ymm14
  .byte  98,145,85,32,254,201                // vpaddd        %ymm25,%ymm21,%ymm1
  .byte  98,146,117,40,64,203                // vpmulld       %ymm27,%ymm1,%ymm1
  .byte  196,65,28,87,228                    // vxorps        %ymm12,%ymm12,%ymm12
  .byte  196,65,37,118,219                   // vpcmpeqd      %ymm11,%ymm11,%ymm11
  .byte  196,98,37,146,36,136                // vgatherdps    %ymm11,(%rax,%ymm1,4),%ymm12
  .byte  196,193,117,250,210                 // vpsubd        %ymm10,%ymm1,%ymm2
  .byte  196,65,37,118,219                   // vpcmpeqd      %ymm11,%ymm11,%ymm11
  .byte  196,65,21,239,237                   // vpxor         %ymm13,%ymm13,%ymm13
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  196,98,45,146,44,144                // vgatherdps    %ymm10,(%rax,%ymm2,4),%ymm13
  .byte  98,177,117,40,254,200               // vpaddd        %ymm16,%ymm1,%ymm1
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,98,37,146,20,136                // vgatherdps    %ymm11,(%rax,%ymm1,4),%ymm10
  .byte  197,252,16,140,36,224,0,0,0         // vmovups       0xe0(%rsp),%ymm1
  .byte  98,177,116,40,92,202                // vsubps        %ymm18,%ymm1,%ymm1
  .byte  197,252,16,84,36,128                // vmovups       -0x80(%rsp),%ymm2
  .byte  197,124,91,218                      // vcvtdq2ps     %ymm2,%ymm11
  .byte  98,81,60,32,92,219                  // vsubps        %ymm11,%ymm24,%ymm11
  .byte  98,178,37,40,168,202                // vfmadd213ps   %ymm18,%ymm11,%ymm1
  .byte  197,252,16,148,36,192,0,0,0         // vmovups       0xc0(%rsp),%ymm2
  .byte  98,129,108,40,92,197                // vsubps        %ymm29,%ymm2,%ymm16
  .byte  98,130,37,40,168,197                // vfmadd213ps   %ymm29,%ymm11,%ymm16
  .byte  197,252,16,148,36,160,0,0,0         // vmovups       0xa0(%rsp),%ymm2
  .byte  98,129,108,40,92,214                // vsubps        %ymm30,%ymm2,%ymm18
  .byte  98,130,37,40,168,214                // vfmadd213ps   %ymm30,%ymm11,%ymm18
  .byte  197,252,16,84,36,96                 // vmovups       0x60(%rsp),%ymm2
  .byte  98,225,124,40,16,36,36              // vmovups       (%rsp),%ymm20
  .byte  98,225,92,32,92,226                 // vsubps        %ymm2,%ymm20,%ymm20
  .byte  98,226,37,40,168,226                // vfmadd213ps   %ymm2,%ymm11,%ymm20
  .byte  197,252,16,84,36,64                 // vmovups       0x40(%rsp),%ymm2
  .byte  98,225,124,40,16,108,36,254         // vmovups       -0x40(%rsp),%ymm21
  .byte  98,225,84,32,92,234                 // vsubps        %ymm2,%ymm21,%ymm21
  .byte  98,226,37,40,168,234                // vfmadd213ps   %ymm2,%ymm11,%ymm21
  .byte  197,252,16,84,36,32                 // vmovups       0x20(%rsp),%ymm2
  .byte  98,97,4,32,92,194                   // vsubps        %ymm2,%ymm31,%ymm24
  .byte  98,98,37,40,168,194                 // vfmadd213ps   %ymm2,%ymm11,%ymm24
  .byte  98,65,116,32,92,200                 // vsubps        %ymm8,%ymm17,%ymm25
  .byte  98,66,37,40,168,200                 // vfmadd213ps   %ymm8,%ymm11,%ymm25
  .byte  197,252,16,148,36,128,0,0,0         // vmovups       0x80(%rsp),%ymm2
  .byte  197,124,91,194                      // vcvtdq2ps     %ymm2,%ymm8
  .byte  98,81,28,32,92,192                  // vsubps        %ymm8,%ymm28,%ymm8
  .byte  98,225,92,32,92,201                 // vsubps        %ymm1,%ymm20,%ymm17
  .byte  98,226,61,40,168,201                // vfmadd213ps   %ymm1,%ymm8,%ymm17
  .byte  98,161,84,32,92,224                 // vsubps        %ymm16,%ymm21,%ymm20
  .byte  98,162,61,40,168,224                // vfmadd213ps   %ymm16,%ymm8,%ymm20
  .byte  98,161,60,32,92,194                 // vsubps        %ymm18,%ymm24,%ymm16
  .byte  98,162,61,40,168,194                // vfmadd213ps   %ymm18,%ymm8,%ymm16
  .byte  98,209,76,32,92,201                 // vsubps        %ymm9,%ymm22,%ymm1
  .byte  196,194,37,168,201                  // vfmadd213ps   %ymm9,%ymm11,%ymm1
  .byte  98,49,100,32,92,207                 // vsubps        %ymm23,%ymm19,%ymm9
  .byte  98,50,37,40,168,207                 // vfmadd213ps   %ymm23,%ymm11,%ymm9
  .byte  197,156,92,208                      // vsubps        %ymm0,%ymm12,%ymm2
  .byte  196,226,37,168,208                  // vfmadd213ps   %ymm0,%ymm11,%ymm2
  .byte  196,193,20,92,199                   // vsubps        %ymm15,%ymm13,%ymm0
  .byte  196,194,37,168,199                  // vfmadd213ps   %ymm15,%ymm11,%ymm0
  .byte  196,65,44,92,214                    // vsubps        %ymm14,%ymm10,%ymm10
  .byte  196,66,37,168,214                   // vfmadd213ps   %ymm14,%ymm11,%ymm10
  .byte  98,145,108,40,92,209                // vsubps        %ymm25,%ymm2,%ymm2
  .byte  98,146,61,40,168,209                // vfmadd213ps   %ymm25,%ymm8,%ymm2
  .byte  197,124,92,217                      // vsubps        %ymm1,%ymm0,%ymm11
  .byte  196,98,61,168,217                   // vfmadd213ps   %ymm1,%ymm8,%ymm11
  .byte  196,65,44,92,209                    // vsubps        %ymm9,%ymm10,%ymm10
  .byte  196,66,61,168,209                   // vfmadd213ps   %ymm9,%ymm8,%ymm10
  .byte  197,252,16,68,36,160                // vmovups       -0x60(%rsp),%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  197,252,16,76,36,224                // vmovups       -0x20(%rsp),%ymm1
  .byte  197,116,92,192                      // vsubps        %ymm0,%ymm1,%ymm8
  .byte  98,177,108,40,92,193                // vsubps        %ymm17,%ymm2,%ymm0
  .byte  98,178,61,40,168,193                // vfmadd213ps   %ymm17,%ymm8,%ymm0
  .byte  98,177,36,40,92,204                 // vsubps        %ymm20,%ymm11,%ymm1
  .byte  98,178,61,40,168,204                // vfmadd213ps   %ymm20,%ymm8,%ymm1
  .byte  98,177,44,40,92,208                 // vsubps        %ymm16,%ymm10,%ymm2
  .byte  98,178,61,40,168,208                // vfmadd213ps   %ymm16,%ymm8,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,129,196,24,1,0,0                 // add           $0x118,%rsp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clut_4D_skx
.globl _sk_clut_4D_skx
FUNCTION(_sk_clut_4D_skx)
_sk_clut_4D_skx:
  .byte  72,129,236,88,5,0,0                 // sub           $0x558,%rsp
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,20                        // mov           0x14(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  98,82,125,40,124,193                // vpbroadcastd  %r9d,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  197,126,91,211                      // vcvttps2dq    %ymm3,%ymm10
  .byte  197,124,40,251                      // vmovaps       %ymm3,%ymm15
  .byte  197,124,17,188,36,160,2,0,0         // vmovups       %ymm15,0x2a0(%rsp)
  .byte  196,65,121,110,200                  // vmovd         %r8d,%xmm9
  .byte  98,210,125,40,124,216               // vpbroadcastd  %r8d,%ymm3
  .byte  68,139,64,16                        // mov           0x10(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  98,82,125,40,124,193                // vpbroadcastd  %r9d,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  197,60,89,194                       // vmulps        %ymm2,%ymm8,%ymm8
  .byte  196,193,126,91,208                  // vcvttps2dq    %ymm8,%ymm2
  .byte  98,193,124,40,40,248                // vmovaps       %ymm8,%ymm23
  .byte  98,225,124,40,17,124,36,14          // vmovups       %ymm23,0x1c0(%rsp)
  .byte  197,254,127,148,36,32,5,0,0         // vmovdqu       %ymm2,0x520(%rsp)
  .byte  98,226,101,40,64,218                // vpmulld       %ymm2,%ymm3,%ymm19
  .byte  98,81,101,32,254,194                // vpaddd        %ymm10,%ymm19,%ymm8
  .byte  98,193,253,40,111,210               // vmovdqa64     %ymm10,%ymm18
  .byte  98,225,254,40,127,84,36,33          // vmovdqu64     %ymm18,0x420(%rsp)
  .byte  196,65,121,110,208                  // vmovd         %r8d,%xmm10
  .byte  196,66,45,64,209                    // vpmulld       %ymm9,%ymm10,%ymm10
  .byte  196,66,125,88,202                   // vpbroadcastd  %xmm10,%ymm9
  .byte  68,139,64,12                        // mov           0xc(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  98,82,125,40,124,217                // vpbroadcastd  %r9d,%ymm11
  .byte  196,65,124,91,219                   // vcvtdq2ps     %ymm11,%ymm11
  .byte  197,164,89,209                      // vmulps        %ymm1,%ymm11,%ymm2
  .byte  197,254,91,202                      // vcvttps2dq    %ymm2,%ymm1
  .byte  98,97,124,40,40,202                 // vmovaps       %ymm2,%ymm25
  .byte  98,97,124,40,17,76,36,13            // vmovups       %ymm25,0x1a0(%rsp)
  .byte  197,254,127,140,36,0,5,0,0          // vmovdqu       %ymm1,0x500(%rsp)
  .byte  98,98,53,40,64,193                  // vpmulld       %ymm1,%ymm9,%ymm24
  .byte  98,209,61,32,254,200                // vpaddd        %ymm8,%ymm24,%ymm1
  .byte  196,65,121,110,216                  // vmovd         %r8d,%xmm11
  .byte  196,66,37,64,210                    // vpmulld       %ymm10,%ymm11,%ymm10
  .byte  196,66,125,88,210                   // vpbroadcastd  %xmm10,%ymm10
  .byte  68,139,64,8                         // mov           0x8(%rax),%r8d
  .byte  65,131,192,255                      // add           $0xffffffff,%r8d
  .byte  98,82,125,40,124,216                // vpbroadcastd  %r8d,%ymm11
  .byte  196,65,124,91,219                   // vcvtdq2ps     %ymm11,%ymm11
  .byte  98,97,36,40,89,224                  // vmulps        %ymm0,%ymm11,%ymm28
  .byte  98,129,126,40,91,236                // vcvttps2dq    %ymm28,%ymm21
  .byte  98,162,45,40,64,229                 // vpmulld       %ymm21,%ymm10,%ymm20
  .byte  98,241,93,32,254,193                // vpaddd        %ymm1,%ymm20,%ymm0
  .byte  72,139,0                            // mov           (%rax),%rax
  .byte  98,226,125,40,88,5,100,48,3,0       // vpbroadcastd  0x33064(%rip),%ymm16        # 3a380 <_sk_srcover_bgra_8888_sse2_lowp+0x418>
  .byte  98,50,125,40,64,216                 // vpmulld       %ymm16,%ymm0,%ymm11
  .byte  196,65,28,87,228                    // vxorps        %ymm12,%ymm12,%ymm12
  .byte  197,253,118,192                     // vpcmpeqd      %ymm0,%ymm0,%ymm0
  .byte  196,34,125,146,36,152               // vgatherdps    %ymm0,(%rax,%ymm11,4),%ymm12
  .byte  197,124,17,164,36,224,4,0,0         // vmovups       %ymm12,0x4e0(%rsp)
  .byte  196,65,13,118,246                   // vpcmpeqd      %ymm14,%ymm14,%ymm14
  .byte  196,193,37,250,198                  // vpsubd        %ymm14,%ymm11,%ymm0
  .byte  196,65,20,87,237                    // vxorps        %ymm13,%ymm13,%ymm13
  .byte  196,65,29,118,228                   // vpcmpeqd      %ymm12,%ymm12,%ymm12
  .byte  196,98,29,146,44,128                // vgatherdps    %ymm12,(%rax,%ymm0,4),%ymm13
  .byte  197,124,17,172,36,192,4,0,0         // vmovups       %ymm13,0x4c0(%rsp)
  .byte  196,226,125,24,5,22,48,3,0          // vbroadcastss  0x33016(%rip),%ymm0        # 3a37c <_sk_srcover_bgra_8888_sse2_lowp+0x414>
  .byte  98,113,28,32,88,224                 // vaddps        %ymm0,%ymm28,%ymm12
  .byte  98,226,125,40,88,13,174,46,3,0      // vpbroadcastd  0x32eae(%rip),%ymm17        # 3a224 <_sk_srcover_bgra_8888_sse2_lowp+0x2bc>
  .byte  98,49,37,40,254,217                 // vpaddd        %ymm17,%ymm11,%ymm11
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,21,118,237                   // vpcmpeqd      %ymm13,%ymm13,%ymm13
  .byte  196,162,21,146,20,152               // vgatherdps    %ymm13,(%rax,%ymm11,4),%ymm2
  .byte  197,252,17,148,36,160,4,0,0         // vmovups       %ymm2,0x4a0(%rsp)
  .byte  196,65,126,91,220                   // vcvttps2dq    %ymm12,%ymm11
  .byte  98,194,45,40,64,243                 // vpmulld       %ymm11,%ymm10,%ymm22
  .byte  98,241,77,32,254,201                // vpaddd        %ymm1,%ymm22,%ymm1
  .byte  98,178,117,40,64,200                // vpmulld       %ymm16,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  196,226,45,146,20,136               // vgatherdps    %ymm10,(%rax,%ymm1,4),%ymm2
  .byte  197,252,17,148,36,128,4,0,0         // vmovups       %ymm2,0x480(%rsp)
  .byte  196,65,117,250,214                  // vpsubd        %ymm14,%ymm1,%ymm10
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,37,118,219                   // vpcmpeqd      %ymm11,%ymm11,%ymm11
  .byte  196,162,37,146,20,144               // vgatherdps    %ymm11,(%rax,%ymm10,4),%ymm2
  .byte  197,252,17,148,36,96,4,0,0          // vmovups       %ymm2,0x460(%rsp)
  .byte  98,113,52,32,88,208                 // vaddps        %ymm0,%ymm25,%ymm10
  .byte  196,65,126,91,210                   // vcvttps2dq    %ymm10,%ymm10
  .byte  98,177,117,40,254,201               // vpaddd        %ymm17,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,37,118,219                   // vpcmpeqd      %ymm11,%ymm11,%ymm11
  .byte  196,226,37,146,20,136               // vgatherdps    %ymm11,(%rax,%ymm1,4),%ymm2
  .byte  197,252,17,148,36,64,4,0,0          // vmovups       %ymm2,0x440(%rsp)
  .byte  98,66,53,40,64,234                  // vpmulld       %ymm10,%ymm9,%ymm29
  .byte  98,209,21,32,254,200                // vpaddd        %ymm8,%ymm29,%ymm1
  .byte  98,49,117,40,254,196                // vpaddd        %ymm20,%ymm1,%ymm8
  .byte  98,50,61,40,64,192                  // vpmulld       %ymm16,%ymm8,%ymm8
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,162,53,146,20,128               // vgatherdps    %ymm9,(%rax,%ymm8,4),%ymm2
  .byte  197,252,17,148,36,0,4,0,0           // vmovups       %ymm2,0x400(%rsp)
  .byte  196,65,61,250,206                   // vpsubd        %ymm14,%ymm8,%ymm9
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  196,162,45,146,20,136               // vgatherdps    %ymm10,(%rax,%ymm9,4),%ymm2
  .byte  197,252,17,148,36,224,3,0,0         // vmovups       %ymm2,0x3e0(%rsp)
  .byte  98,49,61,40,254,193                 // vpaddd        %ymm17,%ymm8,%ymm8
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,162,53,146,20,128               // vgatherdps    %ymm9,(%rax,%ymm8,4),%ymm2
  .byte  197,252,17,148,36,192,3,0,0         // vmovups       %ymm2,0x3c0(%rsp)
  .byte  98,241,77,32,254,201                // vpaddd        %ymm1,%ymm22,%ymm1
  .byte  98,178,117,40,64,200                // vpmulld       %ymm16,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,226,61,146,20,136               // vgatherdps    %ymm8,(%rax,%ymm1,4),%ymm2
  .byte  197,252,17,148,36,160,3,0,0         // vmovups       %ymm2,0x3a0(%rsp)
  .byte  196,65,117,250,198                  // vpsubd        %ymm14,%ymm1,%ymm8
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,162,53,146,20,128               // vgatherdps    %ymm9,(%rax,%ymm8,4),%ymm2
  .byte  197,252,17,148,36,128,3,0,0         // vmovups       %ymm2,0x380(%rsp)
  .byte  98,177,117,40,254,201               // vpaddd        %ymm17,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,226,61,146,20,136               // vgatherdps    %ymm8,(%rax,%ymm1,4),%ymm2
  .byte  197,252,17,148,36,96,3,0,0          // vmovups       %ymm2,0x360(%rsp)
  .byte  98,241,68,32,88,200                 // vaddps        %ymm0,%ymm23,%ymm1
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  98,98,101,40,64,249                 // vpmulld       %ymm1,%ymm3,%ymm31
  .byte  98,177,5,32,254,202                 // vpaddd        %ymm18,%ymm31,%ymm1
  .byte  98,145,117,40,254,216               // vpaddd        %ymm24,%ymm1,%ymm3
  .byte  98,49,101,40,254,196                // vpaddd        %ymm20,%ymm3,%ymm8
  .byte  98,50,61,40,64,192                  // vpmulld       %ymm16,%ymm8,%ymm8
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,162,53,146,20,128               // vgatherdps    %ymm9,(%rax,%ymm8,4),%ymm2
  .byte  197,252,17,148,36,64,3,0,0          // vmovups       %ymm2,0x340(%rsp)
  .byte  196,65,61,250,206                   // vpsubd        %ymm14,%ymm8,%ymm9
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  196,162,45,146,20,136               // vgatherdps    %ymm10,(%rax,%ymm9,4),%ymm2
  .byte  197,252,17,148,36,32,3,0,0          // vmovups       %ymm2,0x320(%rsp)
  .byte  98,49,61,40,254,193                 // vpaddd        %ymm17,%ymm8,%ymm8
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,162,53,146,20,128               // vgatherdps    %ymm9,(%rax,%ymm8,4),%ymm2
  .byte  197,252,17,148,36,0,3,0,0           // vmovups       %ymm2,0x300(%rsp)
  .byte  98,241,77,32,254,219                // vpaddd        %ymm3,%ymm22,%ymm3
  .byte  98,178,101,40,64,216                // vpmulld       %ymm16,%ymm3,%ymm3
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,226,61,146,20,152               // vgatherdps    %ymm8,(%rax,%ymm3,4),%ymm2
  .byte  197,252,17,148,36,224,2,0,0         // vmovups       %ymm2,0x2e0(%rsp)
  .byte  196,65,101,250,198                  // vpsubd        %ymm14,%ymm3,%ymm8
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,162,53,146,20,128               // vgatherdps    %ymm9,(%rax,%ymm8,4),%ymm2
  .byte  197,252,17,148,36,192,2,0,0         // vmovups       %ymm2,0x2c0(%rsp)
  .byte  98,177,101,40,254,217               // vpaddd        %ymm17,%ymm3,%ymm3
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,226,61,146,20,152               // vgatherdps    %ymm8,(%rax,%ymm3,4),%ymm2
  .byte  197,252,17,148,36,128,2,0,0         // vmovups       %ymm2,0x280(%rsp)
  .byte  98,241,21,32,254,201                // vpaddd        %ymm1,%ymm29,%ymm1
  .byte  98,177,117,40,254,220               // vpaddd        %ymm20,%ymm1,%ymm3
  .byte  98,178,101,40,64,216                // vpmulld       %ymm16,%ymm3,%ymm3
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,226,61,146,20,152               // vgatherdps    %ymm8,(%rax,%ymm3,4),%ymm2
  .byte  197,252,17,148,36,96,2,0,0          // vmovups       %ymm2,0x260(%rsp)
  .byte  196,65,101,250,198                  // vpsubd        %ymm14,%ymm3,%ymm8
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,162,53,146,20,128               // vgatherdps    %ymm9,(%rax,%ymm8,4),%ymm2
  .byte  197,252,17,148,36,64,2,0,0          // vmovups       %ymm2,0x240(%rsp)
  .byte  98,177,101,40,254,217               // vpaddd        %ymm17,%ymm3,%ymm3
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,98,61,146,12,152                // vgatherdps    %ymm8,(%rax,%ymm3,4),%ymm9
  .byte  98,241,77,32,254,201                // vpaddd        %ymm1,%ymm22,%ymm1
  .byte  98,178,117,40,64,200                // vpmulld       %ymm16,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,226,101,146,20,136              // vgatherdps    %ymm3,(%rax,%ymm1,4),%ymm2
  .byte  197,252,17,148,36,32,2,0,0          // vmovups       %ymm2,0x220(%rsp)
  .byte  196,193,117,250,222                 // vpsubd        %ymm14,%ymm1,%ymm3
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,226,61,146,20,152               // vgatherdps    %ymm8,(%rax,%ymm3,4),%ymm2
  .byte  197,252,17,148,36,0,2,0,0           // vmovups       %ymm2,0x200(%rsp)
  .byte  98,177,117,40,254,201               // vpaddd        %ymm17,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,226,101,146,20,136              // vgatherdps    %ymm3,(%rax,%ymm1,4),%ymm2
  .byte  197,252,17,148,36,224,1,0,0         // vmovups       %ymm2,0x1e0(%rsp)
  .byte  197,132,88,192                      // vaddps        %ymm0,%ymm15,%ymm0
  .byte  98,97,126,40,91,240                 // vcvttps2dq    %ymm0,%ymm30
  .byte  98,145,101,32,254,198               // vpaddd        %ymm30,%ymm19,%ymm0
  .byte  98,241,61,32,254,200                // vpaddd        %ymm0,%ymm24,%ymm1
  .byte  98,241,93,32,254,209                // vpaddd        %ymm1,%ymm20,%ymm2
  .byte  98,178,109,40,64,208                // vpmulld       %ymm16,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,98,101,146,4,144                // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm8
  .byte  197,124,17,132,36,128,1,0,0         // vmovups       %ymm8,0x180(%rsp)
  .byte  196,193,109,250,222                 // vpsubd        %ymm14,%ymm2,%ymm3
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,98,61,146,20,152                // vgatherdps    %ymm8,(%rax,%ymm3,4),%ymm10
  .byte  197,124,17,148,36,96,1,0,0          // vmovups       %ymm10,0x160(%rsp)
  .byte  98,177,109,40,254,209               // vpaddd        %ymm17,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,98,101,146,4,144                // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm8
  .byte  98,241,77,32,254,201                // vpaddd        %ymm1,%ymm22,%ymm1
  .byte  98,178,117,40,64,200                // vpmulld       %ymm16,%ymm1,%ymm1
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,64,1,0,0          // vmovups       %ymm3,0x140(%rsp)
  .byte  196,193,117,250,214                 // vpsubd        %ymm14,%ymm1,%ymm2
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,98,101,146,20,144               // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm10
  .byte  197,124,17,148,36,32,1,0,0          // vmovups       %ymm10,0x120(%rsp)
  .byte  98,177,117,40,254,201               // vpaddd        %ymm17,%ymm1,%ymm1
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,0,1,0,0           // vmovups       %ymm3,0x100(%rsp)
  .byte  98,241,21,32,254,192                // vpaddd        %ymm0,%ymm29,%ymm0
  .byte  98,177,125,40,254,204               // vpaddd        %ymm20,%ymm0,%ymm1
  .byte  98,178,117,40,64,200                // vpmulld       %ymm16,%ymm1,%ymm1
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,224,0,0,0         // vmovups       %ymm3,0xe0(%rsp)
  .byte  196,193,117,250,214                 // vpsubd        %ymm14,%ymm1,%ymm2
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,98,101,146,20,144               // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm10
  .byte  197,124,17,148,36,192,0,0,0         // vmovups       %ymm10,0xc0(%rsp)
  .byte  98,177,117,40,254,201               // vpaddd        %ymm17,%ymm1,%ymm1
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,160,0,0,0         // vmovups       %ymm3,0xa0(%rsp)
  .byte  98,241,77,32,254,192                // vpaddd        %ymm0,%ymm22,%ymm0
  .byte  98,178,125,40,64,192                // vpmulld       %ymm16,%ymm0,%ymm0
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,226,117,146,20,128              // vgatherdps    %ymm1,(%rax,%ymm0,4),%ymm2
  .byte  197,252,17,148,36,128,0,0,0         // vmovups       %ymm2,0x80(%rsp)
  .byte  196,193,125,250,206                 // vpsubd        %ymm14,%ymm0,%ymm1
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,92,36,96                 // vmovups       %ymm3,0x60(%rsp)
  .byte  98,177,125,40,254,193               // vpaddd        %ymm17,%ymm0,%ymm0
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,226,117,146,20,128              // vgatherdps    %ymm1,(%rax,%ymm0,4),%ymm2
  .byte  197,252,17,84,36,64                 // vmovups       %ymm2,0x40(%rsp)
  .byte  98,145,5,32,254,198                 // vpaddd        %ymm30,%ymm31,%ymm0
  .byte  98,145,125,40,254,200               // vpaddd        %ymm24,%ymm0,%ymm1
  .byte  98,177,117,40,254,212               // vpaddd        %ymm20,%ymm1,%ymm2
  .byte  98,178,109,40,64,208                // vpmulld       %ymm16,%ymm2,%ymm2
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,98,101,146,20,144               // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm10
  .byte  197,124,17,84,36,32                 // vmovups       %ymm10,0x20(%rsp)
  .byte  196,193,109,250,222                 // vpsubd        %ymm14,%ymm2,%ymm3
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  196,98,45,146,28,152                // vgatherdps    %ymm10,(%rax,%ymm3,4),%ymm11
  .byte  197,124,17,28,36                    // vmovups       %ymm11,(%rsp)
  .byte  98,177,109,40,254,209               // vpaddd        %ymm17,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  196,226,45,146,28,144               // vgatherdps    %ymm10,(%rax,%ymm2,4),%ymm3
  .byte  98,225,124,40,40,251                // vmovaps       %ymm3,%ymm23
  .byte  98,241,77,32,254,201                // vpaddd        %ymm1,%ymm22,%ymm1
  .byte  98,178,117,40,64,200                // vpmulld       %ymm16,%ymm1,%ymm1
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,92,36,192                // vmovups       %ymm3,-0x40(%rsp)
  .byte  196,193,117,250,214                 // vpsubd        %ymm14,%ymm1,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  196,226,45,146,28,144               // vgatherdps    %ymm10,(%rax,%ymm2,4),%ymm3
  .byte  98,97,124,40,40,211                 // vmovaps       %ymm3,%ymm26
  .byte  98,177,117,40,254,201               // vpaddd        %ymm17,%ymm1,%ymm1
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  98,97,124,40,40,203                 // vmovaps       %ymm3,%ymm25
  .byte  98,97,21,32,254,192                 // vpaddd        %ymm0,%ymm29,%ymm24
  .byte  98,177,61,32,254,196                // vpaddd        %ymm20,%ymm24,%ymm0
  .byte  98,178,125,40,64,192                // vpmulld       %ymm16,%ymm0,%ymm0
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,226,117,146,20,128              // vgatherdps    %ymm1,(%rax,%ymm0,4),%ymm2
  .byte  98,225,124,40,40,218                // vmovaps       %ymm2,%ymm19
  .byte  196,193,125,250,214                 // vpsubd        %ymm14,%ymm0,%ymm2
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,5,118,255                    // vpcmpeqd      %ymm15,%ymm15,%ymm15
  .byte  196,226,5,146,12,144                // vgatherdps    %ymm15,(%rax,%ymm2,4),%ymm1
  .byte  98,225,124,40,40,209                // vmovaps       %ymm1,%ymm18
  .byte  98,177,125,40,254,209               // vpaddd        %ymm17,%ymm0,%ymm2
  .byte  196,65,28,87,228                    // vxorps        %ymm12,%ymm12,%ymm12
  .byte  196,65,5,118,255                    // vpcmpeqd      %ymm15,%ymm15,%ymm15
  .byte  196,98,5,146,36,144                 // vgatherdps    %ymm15,(%rax,%ymm2,4),%ymm12
  .byte  98,145,77,32,254,208                // vpaddd        %ymm24,%ymm22,%ymm2
  .byte  98,178,109,40,64,208                // vpmulld       %ymm16,%ymm2,%ymm2
  .byte  196,65,4,87,255                     // vxorps        %ymm15,%ymm15,%ymm15
  .byte  196,65,21,118,237                   // vpcmpeqd      %ymm13,%ymm13,%ymm13
  .byte  196,98,21,146,60,144                // vgatherdps    %ymm13,(%rax,%ymm2,4),%ymm15
  .byte  197,252,17,124,36,224               // vmovups       %ymm7,-0x20(%rsp)
  .byte  197,252,17,116,36,160               // vmovups       %ymm6,-0x60(%rsp)
  .byte  197,252,17,108,36,128               // vmovups       %ymm5,-0x80(%rsp)
  .byte  98,97,124,40,40,220                 // vmovaps       %ymm4,%ymm27
  .byte  196,65,109,250,238                  // vpsubd        %ymm14,%ymm2,%ymm13
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  196,34,45,146,28,168                // vgatherdps    %ymm10,(%rax,%ymm13,4),%ymm11
  .byte  98,177,109,40,254,209               // vpaddd        %ymm17,%ymm2,%ymm2
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,98,13,146,20,144                // vgatherdps    %ymm14,(%rax,%ymm2,4),%ymm10
  .byte  197,252,16,132,36,224,4,0,0         // vmovups       0x4e0(%rsp),%ymm0
  .byte  197,252,16,140,36,128,4,0,0         // vmovups       0x480(%rsp),%ymm1
  .byte  197,244,92,240                      // vsubps        %ymm0,%ymm1,%ymm6
  .byte  98,49,124,40,91,237                 // vcvtdq2ps     %ymm21,%ymm13
  .byte  98,81,28,32,92,237                  // vsubps        %ymm13,%ymm28,%ymm13
  .byte  196,226,21,168,240                  // vfmadd213ps   %ymm0,%ymm13,%ymm6
  .byte  197,252,16,132,36,192,4,0,0         // vmovups       0x4c0(%rsp),%ymm0
  .byte  197,252,16,140,36,96,4,0,0          // vmovups       0x460(%rsp),%ymm1
  .byte  197,116,92,240                      // vsubps        %ymm0,%ymm1,%ymm14
  .byte  196,98,21,168,240                   // vfmadd213ps   %ymm0,%ymm13,%ymm14
  .byte  197,252,16,132,36,160,4,0,0         // vmovups       0x4a0(%rsp),%ymm0
  .byte  197,252,16,140,36,64,4,0,0          // vmovups       0x440(%rsp),%ymm1
  .byte  98,225,116,40,92,192                // vsubps        %ymm0,%ymm1,%ymm16
  .byte  98,226,21,40,168,192                // vfmadd213ps   %ymm0,%ymm13,%ymm16
  .byte  197,252,16,132,36,0,4,0,0           // vmovups       0x400(%rsp),%ymm0
  .byte  197,252,16,140,36,160,3,0,0         // vmovups       0x3a0(%rsp),%ymm1
  .byte  98,225,116,40,92,200                // vsubps        %ymm0,%ymm1,%ymm17
  .byte  98,226,21,40,168,200                // vfmadd213ps   %ymm0,%ymm13,%ymm17
  .byte  197,252,16,132,36,224,3,0,0         // vmovups       0x3e0(%rsp),%ymm0
  .byte  197,252,16,140,36,128,3,0,0         // vmovups       0x380(%rsp),%ymm1
  .byte  98,225,116,40,92,224                // vsubps        %ymm0,%ymm1,%ymm20
  .byte  98,226,21,40,168,224                // vfmadd213ps   %ymm0,%ymm13,%ymm20
  .byte  197,252,16,132,36,192,3,0,0         // vmovups       0x3c0(%rsp),%ymm0
  .byte  197,252,16,140,36,96,3,0,0          // vmovups       0x360(%rsp),%ymm1
  .byte  98,225,116,40,92,232                // vsubps        %ymm0,%ymm1,%ymm21
  .byte  98,226,21,40,168,232                // vfmadd213ps   %ymm0,%ymm13,%ymm21
  .byte  197,252,16,132,36,64,3,0,0          // vmovups       0x340(%rsp),%ymm0
  .byte  197,252,16,140,36,224,2,0,0         // vmovups       0x2e0(%rsp),%ymm1
  .byte  98,225,116,40,92,240                // vsubps        %ymm0,%ymm1,%ymm22
  .byte  98,226,21,40,168,240                // vfmadd213ps   %ymm0,%ymm13,%ymm22
  .byte  197,252,16,132,36,32,3,0,0          // vmovups       0x320(%rsp),%ymm0
  .byte  197,252,16,140,36,192,2,0,0         // vmovups       0x2c0(%rsp),%ymm1
  .byte  98,97,116,40,92,192                 // vsubps        %ymm0,%ymm1,%ymm24
  .byte  98,98,21,40,168,192                 // vfmadd213ps   %ymm0,%ymm13,%ymm24
  .byte  197,252,16,132,36,0,3,0,0           // vmovups       0x300(%rsp),%ymm0
  .byte  197,252,16,140,36,128,2,0,0         // vmovups       0x280(%rsp),%ymm1
  .byte  98,97,116,40,92,224                 // vsubps        %ymm0,%ymm1,%ymm28
  .byte  98,98,21,40,168,224                 // vfmadd213ps   %ymm0,%ymm13,%ymm28
  .byte  197,252,16,132,36,96,2,0,0          // vmovups       0x260(%rsp),%ymm0
  .byte  197,252,16,140,36,32,2,0,0          // vmovups       0x220(%rsp),%ymm1
  .byte  98,97,116,40,92,232                 // vsubps        %ymm0,%ymm1,%ymm29
  .byte  98,98,21,40,168,232                 // vfmadd213ps   %ymm0,%ymm13,%ymm29
  .byte  197,252,16,132,36,64,2,0,0          // vmovups       0x240(%rsp),%ymm0
  .byte  197,252,16,140,36,0,2,0,0           // vmovups       0x200(%rsp),%ymm1
  .byte  98,97,116,40,92,240                 // vsubps        %ymm0,%ymm1,%ymm30
  .byte  98,98,21,40,168,240                 // vfmadd213ps   %ymm0,%ymm13,%ymm30
  .byte  197,252,16,132,36,224,1,0,0         // vmovups       0x1e0(%rsp),%ymm0
  .byte  98,65,124,40,92,249                 // vsubps        %ymm9,%ymm0,%ymm31
  .byte  98,66,21,40,168,249                 // vfmadd213ps   %ymm9,%ymm13,%ymm31
  .byte  197,252,16,132,36,128,1,0,0         // vmovups       0x180(%rsp),%ymm0
  .byte  197,252,16,140,36,64,1,0,0          // vmovups       0x140(%rsp),%ymm1
  .byte  197,244,92,216                      // vsubps        %ymm0,%ymm1,%ymm3
  .byte  196,226,21,168,216                  // vfmadd213ps   %ymm0,%ymm13,%ymm3
  .byte  197,252,16,132,36,96,1,0,0          // vmovups       0x160(%rsp),%ymm0
  .byte  197,252,16,140,36,32,1,0,0          // vmovups       0x120(%rsp),%ymm1
  .byte  197,244,92,224                      // vsubps        %ymm0,%ymm1,%ymm4
  .byte  196,226,21,168,224                  // vfmadd213ps   %ymm0,%ymm13,%ymm4
  .byte  197,252,16,132,36,0,1,0,0           // vmovups       0x100(%rsp),%ymm0
  .byte  196,193,124,92,232                  // vsubps        %ymm8,%ymm0,%ymm5
  .byte  196,194,21,168,232                  // vfmadd213ps   %ymm8,%ymm13,%ymm5
  .byte  197,252,16,132,36,224,0,0,0         // vmovups       0xe0(%rsp),%ymm0
  .byte  197,252,16,140,36,128,0,0,0         // vmovups       0x80(%rsp),%ymm1
  .byte  197,244,92,248                      // vsubps        %ymm0,%ymm1,%ymm7
  .byte  196,226,21,168,248                  // vfmadd213ps   %ymm0,%ymm13,%ymm7
  .byte  197,252,16,132,36,192,0,0,0         // vmovups       0xc0(%rsp),%ymm0
  .byte  197,252,16,76,36,96                 // vmovups       0x60(%rsp),%ymm1
  .byte  197,116,92,192                      // vsubps        %ymm0,%ymm1,%ymm8
  .byte  196,98,21,168,192                   // vfmadd213ps   %ymm0,%ymm13,%ymm8
  .byte  197,252,16,132,36,160,0,0,0         // vmovups       0xa0(%rsp),%ymm0
  .byte  197,252,16,76,36,64                 // vmovups       0x40(%rsp),%ymm1
  .byte  197,116,92,200                      // vsubps        %ymm0,%ymm1,%ymm9
  .byte  196,98,21,168,200                   // vfmadd213ps   %ymm0,%ymm13,%ymm9
  .byte  197,252,16,76,36,32                 // vmovups       0x20(%rsp),%ymm1
  .byte  197,252,16,68,36,192                // vmovups       -0x40(%rsp),%ymm0
  .byte  197,252,92,193                      // vsubps        %ymm1,%ymm0,%ymm0
  .byte  196,226,21,168,193                  // vfmadd213ps   %ymm1,%ymm13,%ymm0
  .byte  197,252,16,20,36                    // vmovups       (%rsp),%ymm2
  .byte  98,241,44,32,92,202                 // vsubps        %ymm2,%ymm26,%ymm1
  .byte  196,226,21,168,202                  // vfmadd213ps   %ymm2,%ymm13,%ymm1
  .byte  98,177,52,32,92,215                 // vsubps        %ymm23,%ymm25,%ymm2
  .byte  98,178,21,40,168,215                // vfmadd213ps   %ymm23,%ymm13,%ymm2
  .byte  98,49,4,40,92,251                   // vsubps        %ymm19,%ymm15,%ymm15
  .byte  98,50,21,40,168,251                 // vfmadd213ps   %ymm19,%ymm13,%ymm15
  .byte  98,49,36,40,92,218                  // vsubps        %ymm18,%ymm11,%ymm11
  .byte  98,50,21,40,168,218                 // vfmadd213ps   %ymm18,%ymm13,%ymm11
  .byte  196,65,44,92,212                    // vsubps        %ymm12,%ymm10,%ymm10
  .byte  196,66,21,168,212                   // vfmadd213ps   %ymm12,%ymm13,%ymm10
  .byte  197,124,16,164,36,0,5,0,0           // vmovups       0x500(%rsp),%ymm12
  .byte  196,65,124,91,228                   // vcvtdq2ps     %ymm12,%ymm12
  .byte  197,124,16,172,36,160,1,0,0         // vmovups       0x1a0(%rsp),%ymm13
  .byte  196,65,20,92,228                    // vsubps        %ymm12,%ymm13,%ymm12
  .byte  98,113,116,32,92,238                // vsubps        %ymm6,%ymm17,%ymm13
  .byte  196,98,29,168,238                   // vfmadd213ps   %ymm6,%ymm12,%ymm13
  .byte  98,209,92,32,92,246                 // vsubps        %ymm14,%ymm20,%ymm6
  .byte  196,194,29,168,246                  // vfmadd213ps   %ymm14,%ymm12,%ymm6
  .byte  98,49,84,32,92,240                  // vsubps        %ymm16,%ymm21,%ymm14
  .byte  98,50,29,40,168,240                 // vfmadd213ps   %ymm16,%ymm12,%ymm14
  .byte  98,161,20,32,92,198                 // vsubps        %ymm22,%ymm29,%ymm16
  .byte  98,162,29,40,168,198                // vfmadd213ps   %ymm22,%ymm12,%ymm16
  .byte  98,129,12,32,92,200                 // vsubps        %ymm24,%ymm30,%ymm17
  .byte  98,130,29,40,168,200                // vfmadd213ps   %ymm24,%ymm12,%ymm17
  .byte  98,129,4,32,92,228                  // vsubps        %ymm28,%ymm31,%ymm20
  .byte  98,130,29,40,168,228                // vfmadd213ps   %ymm28,%ymm12,%ymm20
  .byte  197,196,92,251                      // vsubps        %ymm3,%ymm7,%ymm7
  .byte  196,226,29,168,251                  // vfmadd213ps   %ymm3,%ymm12,%ymm7
  .byte  197,188,92,220                      // vsubps        %ymm4,%ymm8,%ymm3
  .byte  196,226,29,168,220                  // vfmadd213ps   %ymm4,%ymm12,%ymm3
  .byte  197,180,92,229                      // vsubps        %ymm5,%ymm9,%ymm4
  .byte  196,226,29,168,229                  // vfmadd213ps   %ymm5,%ymm12,%ymm4
  .byte  197,132,92,232                      // vsubps        %ymm0,%ymm15,%ymm5
  .byte  196,226,29,168,232                  // vfmadd213ps   %ymm0,%ymm12,%ymm5
  .byte  197,164,92,193                      // vsubps        %ymm1,%ymm11,%ymm0
  .byte  196,226,29,168,193                  // vfmadd213ps   %ymm1,%ymm12,%ymm0
  .byte  197,172,92,202                      // vsubps        %ymm2,%ymm10,%ymm1
  .byte  196,226,29,168,202                  // vfmadd213ps   %ymm2,%ymm12,%ymm1
  .byte  197,252,16,148,36,32,5,0,0          // vmovups       0x520(%rsp),%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  197,124,16,132,36,192,1,0,0         // vmovups       0x1c0(%rsp),%ymm8
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  98,81,124,32,92,197                 // vsubps        %ymm13,%ymm16,%ymm8
  .byte  196,66,109,168,197                  // vfmadd213ps   %ymm13,%ymm2,%ymm8
  .byte  98,113,116,32,92,206                // vsubps        %ymm6,%ymm17,%ymm9
  .byte  196,98,109,168,206                  // vfmadd213ps   %ymm6,%ymm2,%ymm9
  .byte  98,209,92,32,92,246                 // vsubps        %ymm14,%ymm20,%ymm6
  .byte  196,194,109,168,246                 // vfmadd213ps   %ymm14,%ymm2,%ymm6
  .byte  197,212,92,239                      // vsubps        %ymm7,%ymm5,%ymm5
  .byte  196,226,109,168,239                 // vfmadd213ps   %ymm7,%ymm2,%ymm5
  .byte  197,252,92,251                      // vsubps        %ymm3,%ymm0,%ymm7
  .byte  196,226,109,168,251                 // vfmadd213ps   %ymm3,%ymm2,%ymm7
  .byte  197,244,92,220                      // vsubps        %ymm4,%ymm1,%ymm3
  .byte  196,226,109,168,220                 // vfmadd213ps   %ymm4,%ymm2,%ymm3
  .byte  197,252,16,132,36,32,4,0,0          // vmovups       0x420(%rsp),%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  197,252,16,140,36,160,2,0,0         // vmovups       0x2a0(%rsp),%ymm1
  .byte  197,244,92,224                      // vsubps        %ymm0,%ymm1,%ymm4
  .byte  196,193,84,92,192                   // vsubps        %ymm8,%ymm5,%ymm0
  .byte  196,194,93,168,192                  // vfmadd213ps   %ymm8,%ymm4,%ymm0
  .byte  196,193,68,92,201                   // vsubps        %ymm9,%ymm7,%ymm1
  .byte  196,194,93,168,201                  // vfmadd213ps   %ymm9,%ymm4,%ymm1
  .byte  197,228,92,214                      // vsubps        %ymm6,%ymm3,%ymm2
  .byte  196,226,93,168,214                  // vfmadd213ps   %ymm6,%ymm4,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,76,37,3,0         // vbroadcastss  0x3254c(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  98,145,124,40,40,227                // vmovaps       %ymm27,%ymm4
  .byte  197,252,16,108,36,128               // vmovups       -0x80(%rsp),%ymm5
  .byte  197,252,16,116,36,160               // vmovups       -0x60(%rsp),%ymm6
  .byte  197,252,16,124,36,224               // vmovups       -0x20(%rsp),%ymm7
  .byte  72,129,196,88,5,0,0                 // add           $0x558,%rsp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gauss_a_to_rgba_skx
.globl _sk_gauss_a_to_rgba_skx
FUNCTION(_sk_gauss_a_to_rgba_skx)
_sk_gauss_a_to_rgba_skx:
  .byte  196,226,125,24,5,142,38,3,0         // vbroadcastss  0x3268e(%rip),%ymm0        # 3a384 <_sk_srcover_bgra_8888_sse2_lowp+0x41c>
  .byte  98,242,101,56,168,5,136,38,3,0      // vfmadd213ps   0x32688(%rip){1to8},%ymm3,%ymm0        # 3a388 <_sk_srcover_bgra_8888_sse2_lowp+0x420>
  .byte  98,242,101,56,168,5,130,38,3,0      // vfmadd213ps   0x32682(%rip){1to8},%ymm3,%ymm0        # 3a38c <_sk_srcover_bgra_8888_sse2_lowp+0x424>
  .byte  98,242,101,56,168,5,124,38,3,0      // vfmadd213ps   0x3267c(%rip){1to8},%ymm3,%ymm0        # 3a390 <_sk_srcover_bgra_8888_sse2_lowp+0x428>
  .byte  98,242,101,56,168,5,118,38,3,0      // vfmadd213ps   0x32676(%rip){1to8},%ymm3,%ymm0        # 3a394 <_sk_srcover_bgra_8888_sse2_lowp+0x42c>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  197,252,40,216                      // vmovaps       %ymm0,%ymm3
  .byte  255,224                             // jmpq          *%rax
  .byte  144                                 // nop
  .byte  144                                 // nop

HIDDEN _sk_start_pipeline_hsw
.globl _sk_start_pipeline_hsw
FUNCTION(_sk_start_pipeline_hsw)
_sk_start_pipeline_hsw:
  .byte  85                                  // push          %rbp
  .byte  72,137,229                          // mov           %rsp,%rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  73,137,215                          // mov           %rdx,%r15
  .byte  72,137,243                          // mov           %rsi,%rbx
  .byte  72,137,125,208                      // mov           %rdi,-0x30(%rbp)
  .byte  76,137,198                          // mov           %r8,%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  73,137,197                          // mov           %rax,%r13
  .byte  73,137,246                          // mov           %rsi,%r14
  .byte  72,137,77,192                       // mov           %rcx,-0x40(%rbp)
  .byte  72,57,203                           // cmp           %rcx,%rbx
  .byte  15,131,151,0,0,0                    // jae           7dfa <_sk_start_pipeline_hsw+0xca>
  .byte  72,139,69,208                       // mov           -0x30(%rbp),%rax
  .byte  72,141,64,8                         // lea           0x8(%rax),%rax
  .byte  72,137,69,200                       // mov           %rax,-0x38(%rbp)
  .byte  72,139,85,208                       // mov           -0x30(%rbp),%rdx
  .byte  76,57,125,200                       // cmp           %r15,-0x38(%rbp)
  .byte  119,67                              // ja            7dbc <_sk_start_pipeline_hsw+0x8c>
  .byte  76,139,101,208                      // mov           -0x30(%rbp),%r12
  .byte  49,255                              // xor           %edi,%edi
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  76,137,226                          // mov           %r12,%rdx
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  73,141,84,36,8                      // lea           0x8(%r12),%rdx
  .byte  73,131,196,16                       // add           $0x10,%r12
  .byte  77,57,252                           // cmp           %r15,%r12
  .byte  73,137,212                          // mov           %rdx,%r12
  .byte  118,193                             // jbe           7d7d <_sk_start_pipeline_hsw+0x4d>
  .byte  76,137,255                          // mov           %r15,%rdi
  .byte  72,41,215                           // sub           %rdx,%rdi
  .byte  116,41                              // je            7ded <_sk_start_pipeline_hsw+0xbd>
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  72,255,195                          // inc           %rbx
  .byte  72,59,93,192                        // cmp           -0x40(%rbp),%rbx
  .byte  15,133,117,255,255,255              // jne           7d6f <_sk_start_pipeline_hsw+0x3f>
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  197,248,119                         // vzeroupper
  .byte  195                                 // retq

HIDDEN _sk_just_return_hsw
.globl _sk_just_return_hsw
FUNCTION(_sk_just_return_hsw)
_sk_just_return_hsw:
  .byte  195                                 // retq

HIDDEN _sk_seed_shader_hsw
.globl _sk_seed_shader_hsw
FUNCTION(_sk_seed_shader_hsw)
_sk_seed_shader_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,249,110,194                     // vmovd         %edx,%xmm0
  .byte  196,226,125,88,192                  // vpbroadcastd  %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  197,249,110,201                     // vmovd         %ecx,%xmm1
  .byte  196,226,125,88,201                  // vpbroadcastd  %xmm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,226,125,24,21,222,35,3,0        // vbroadcastss  0x323de(%rip),%ymm2        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,244,88,202                      // vaddps        %ymm2,%ymm1,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,21,211,35,3,0        // vbroadcastss  0x323d3(%rip),%ymm2        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dither_hsw
.globl _sk_dither_hsw
FUNCTION(_sk_dither_hsw)
_sk_dither_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,121,110,194                     // vmovd         %edx,%xmm8
  .byte  196,66,125,88,192                   // vpbroadcastd  %xmm8,%ymm8
  .byte  197,61,254,5,114,37,3,0             // vpaddd        0x32572(%rip),%ymm8,%ymm8        # 3a3e0 <_sk_srcover_bgra_8888_sse2_lowp+0x478>
  .byte  197,121,110,201                     // vmovd         %ecx,%xmm9
  .byte  196,66,125,88,201                   // vpbroadcastd  %xmm9,%ymm9
  .byte  196,65,53,239,200                   // vpxor         %ymm8,%ymm9,%ymm9
  .byte  196,98,125,88,21,151,35,3,0         // vpbroadcastd  0x32397(%rip),%ymm10        # 3a21c <_sk_srcover_bgra_8888_sse2_lowp+0x2b4>
  .byte  196,65,53,219,218                   // vpand         %ymm10,%ymm9,%ymm11
  .byte  196,193,37,114,243,5                // vpslld        $0x5,%ymm11,%ymm11
  .byte  196,65,61,219,210                   // vpand         %ymm10,%ymm8,%ymm10
  .byte  196,193,45,114,242,4                // vpslld        $0x4,%ymm10,%ymm10
  .byte  196,98,125,88,37,124,35,3,0         // vpbroadcastd  0x3237c(%rip),%ymm12        # 3a220 <_sk_srcover_bgra_8888_sse2_lowp+0x2b8>
  .byte  196,98,125,88,45,119,35,3,0         // vpbroadcastd  0x32377(%rip),%ymm13        # 3a224 <_sk_srcover_bgra_8888_sse2_lowp+0x2bc>
  .byte  196,65,53,219,245                   // vpand         %ymm13,%ymm9,%ymm14
  .byte  196,193,13,114,246,2                // vpslld        $0x2,%ymm14,%ymm14
  .byte  196,65,37,235,222                   // vpor          %ymm14,%ymm11,%ymm11
  .byte  196,65,61,219,237                   // vpand         %ymm13,%ymm8,%ymm13
  .byte  196,65,21,254,237                   // vpaddd        %ymm13,%ymm13,%ymm13
  .byte  196,65,21,235,210                   // vpor          %ymm10,%ymm13,%ymm10
  .byte  196,65,53,219,204                   // vpand         %ymm12,%ymm9,%ymm9
  .byte  196,193,53,114,209,1                // vpsrld        $0x1,%ymm9,%ymm9
  .byte  196,65,61,219,196                   // vpand         %ymm12,%ymm8,%ymm8
  .byte  196,193,61,114,208,2                // vpsrld        $0x2,%ymm8,%ymm8
  .byte  196,65,45,235,192                   // vpor          %ymm8,%ymm10,%ymm8
  .byte  196,65,61,235,195                   // vpor          %ymm11,%ymm8,%ymm8
  .byte  196,65,61,235,193                   // vpor          %ymm9,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,98,125,24,13,41,35,3,0          // vbroadcastss  0x32329(%rip),%ymm9        # 3a228 <_sk_srcover_bgra_8888_sse2_lowp+0x2c0>
  .byte  196,98,125,24,21,36,35,3,0          // vbroadcastss  0x32324(%rip),%ymm10        # 3a22c <_sk_srcover_bgra_8888_sse2_lowp+0x2c4>
  .byte  196,66,61,184,209                   // vfmadd231ps   %ymm9,%ymm8,%ymm10
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  196,65,44,89,192                    // vmulps        %ymm8,%ymm10,%ymm8
  .byte  197,188,88,192                      // vaddps        %ymm0,%ymm8,%ymm0
  .byte  197,188,88,201                      // vaddps        %ymm1,%ymm8,%ymm1
  .byte  197,188,88,210                      // vaddps        %ymm2,%ymm8,%ymm2
  .byte  197,252,93,195                      // vminps        %ymm3,%ymm0,%ymm0
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,244,93,203                      // vminps        %ymm3,%ymm1,%ymm1
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,236,93,211                      // vminps        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,210                      // vmaxps        %ymm2,%ymm8,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_uniform_color_hsw
.globl _sk_uniform_color_hsw
FUNCTION(_sk_uniform_color_hsw)
_sk_uniform_color_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,0                    // vbroadcastss  (%rax),%ymm0
  .byte  196,226,125,24,72,4                 // vbroadcastss  0x4(%rax),%ymm1
  .byte  196,226,125,24,80,8                 // vbroadcastss  0x8(%rax),%ymm2
  .byte  196,226,125,24,88,12                // vbroadcastss  0xc(%rax),%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_black_color_hsw
.globl _sk_black_color_hsw
FUNCTION(_sk_black_color_hsw)
_sk_black_color_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,172,34,3,0        // vbroadcastss  0x322ac(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_white_color_hsw
.globl _sk_white_color_hsw
FUNCTION(_sk_white_color_hsw)
_sk_white_color_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,5,147,34,3,0         // vbroadcastss  0x32293(%rip),%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  197,252,40,216                      // vmovaps       %ymm0,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_rgba_hsw
.globl _sk_load_rgba_hsw
FUNCTION(_sk_load_rgba_hsw)
_sk_load_rgba_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,0                        // vmovups       (%rax),%ymm0
  .byte  197,252,16,72,32                    // vmovups       0x20(%rax),%ymm1
  .byte  197,252,16,80,64                    // vmovups       0x40(%rax),%ymm2
  .byte  197,252,16,88,96                    // vmovups       0x60(%rax),%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_rgba_hsw
.globl _sk_store_rgba_hsw
FUNCTION(_sk_store_rgba_hsw)
_sk_store_rgba_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,17,0                        // vmovups       %ymm0,(%rax)
  .byte  197,252,17,72,32                    // vmovups       %ymm1,0x20(%rax)
  .byte  197,252,17,80,64                    // vmovups       %ymm2,0x40(%rax)
  .byte  197,252,17,88,96                    // vmovups       %ymm3,0x60(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clear_hsw
.globl _sk_clear_hsw
FUNCTION(_sk_clear_hsw)
_sk_clear_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcatop_hsw
.globl _sk_srcatop_hsw
FUNCTION(_sk_srcatop_hsw)
_sk_srcatop_hsw:
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  196,98,125,24,5,50,34,3,0           // vbroadcastss  0x32232(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,226,61,184,196                  // vfmadd231ps   %ymm4,%ymm8,%ymm0
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  196,226,61,184,205                  // vfmadd231ps   %ymm5,%ymm8,%ymm1
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  196,226,61,184,214                  // vfmadd231ps   %ymm6,%ymm8,%ymm2
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  196,194,69,168,216                  // vfmadd213ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstatop_hsw
.globl _sk_dstatop_hsw
FUNCTION(_sk_dstatop_hsw)
_sk_dstatop_hsw:
  .byte  196,98,125,24,5,1,34,3,0            // vbroadcastss  0x32201(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,199                       // vsubps        %ymm7,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  196,226,101,184,196                 // vfmadd231ps   %ymm4,%ymm3,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  196,226,101,184,205                 // vfmadd231ps   %ymm5,%ymm3,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  196,226,101,184,214                 // vfmadd231ps   %ymm6,%ymm3,%ymm2
  .byte  197,60,89,195                       // vmulps        %ymm3,%ymm8,%ymm8
  .byte  196,194,69,168,216                  // vfmadd213ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcin_hsw
.globl _sk_srcin_hsw
FUNCTION(_sk_srcin_hsw)
_sk_srcin_hsw:
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstin_hsw
.globl _sk_dstin_hsw
FUNCTION(_sk_dstin_hsw)
_sk_dstin_hsw:
  .byte  197,228,89,196                      // vmulps        %ymm4,%ymm3,%ymm0
  .byte  197,228,89,205                      // vmulps        %ymm5,%ymm3,%ymm1
  .byte  197,228,89,214                      // vmulps        %ymm6,%ymm3,%ymm2
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcout_hsw
.globl _sk_srcout_hsw
FUNCTION(_sk_srcout_hsw)
_sk_srcout_hsw:
  .byte  196,98,125,24,5,164,33,3,0          // vbroadcastss  0x321a4(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,199                       // vsubps        %ymm7,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstout_hsw
.globl _sk_dstout_hsw
FUNCTION(_sk_dstout_hsw)
_sk_dstout_hsw:
  .byte  196,226,125,24,5,131,33,3,0         // vbroadcastss  0x32183(%rip),%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,92,219                      // vsubps        %ymm3,%ymm0,%ymm3
  .byte  197,228,89,196                      // vmulps        %ymm4,%ymm3,%ymm0
  .byte  197,228,89,205                      // vmulps        %ymm5,%ymm3,%ymm1
  .byte  197,228,89,214                      // vmulps        %ymm6,%ymm3,%ymm2
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_hsw
.globl _sk_srcover_hsw
FUNCTION(_sk_srcover_hsw)
_sk_srcover_hsw:
  .byte  196,98,125,24,5,98,33,3,0           // vbroadcastss  0x32162(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,194,93,184,192                  // vfmadd231ps   %ymm8,%ymm4,%ymm0
  .byte  196,194,85,184,200                  // vfmadd231ps   %ymm8,%ymm5,%ymm1
  .byte  196,194,77,184,208                  // vfmadd231ps   %ymm8,%ymm6,%ymm2
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstover_hsw
.globl _sk_dstover_hsw
FUNCTION(_sk_dstover_hsw)
_sk_dstover_hsw:
  .byte  196,98,125,24,5,61,33,3,0           // vbroadcastss  0x3213d(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,199                       // vsubps        %ymm7,%ymm8,%ymm8
  .byte  196,226,61,168,196                  // vfmadd213ps   %ymm4,%ymm8,%ymm0
  .byte  196,226,61,168,205                  // vfmadd213ps   %ymm5,%ymm8,%ymm1
  .byte  196,226,61,168,214                  // vfmadd213ps   %ymm6,%ymm8,%ymm2
  .byte  196,226,61,168,223                  // vfmadd213ps   %ymm7,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_modulate_hsw
.globl _sk_modulate_hsw
FUNCTION(_sk_modulate_hsw)
_sk_modulate_hsw:
  .byte  197,252,89,196                      // vmulps        %ymm4,%ymm0,%ymm0
  .byte  197,244,89,205                      // vmulps        %ymm5,%ymm1,%ymm1
  .byte  197,236,89,214                      // vmulps        %ymm6,%ymm2,%ymm2
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_multiply_hsw
.globl _sk_multiply_hsw
FUNCTION(_sk_multiply_hsw)
_sk_multiply_hsw:
  .byte  196,98,125,24,5,4,33,3,0            // vbroadcastss  0x32104(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,207                       // vsubps        %ymm7,%ymm8,%ymm9
  .byte  197,52,89,208                       // vmulps        %ymm0,%ymm9,%ymm10
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,98,61,184,212                   // vfmadd231ps   %ymm4,%ymm8,%ymm10
  .byte  196,194,93,168,194                  // vfmadd213ps   %ymm10,%ymm4,%ymm0
  .byte  197,52,89,209                       // vmulps        %ymm1,%ymm9,%ymm10
  .byte  196,98,61,184,213                   // vfmadd231ps   %ymm5,%ymm8,%ymm10
  .byte  196,194,85,168,202                  // vfmadd213ps   %ymm10,%ymm5,%ymm1
  .byte  197,52,89,210                       // vmulps        %ymm2,%ymm9,%ymm10
  .byte  196,98,61,184,214                   // vfmadd231ps   %ymm6,%ymm8,%ymm10
  .byte  196,194,77,168,210                  // vfmadd213ps   %ymm10,%ymm6,%ymm2
  .byte  197,52,89,203                       // vmulps        %ymm3,%ymm9,%ymm9
  .byte  196,66,69,168,193                   // vfmadd213ps   %ymm9,%ymm7,%ymm8
  .byte  196,194,69,168,216                  // vfmadd213ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_plus__hsw
.globl _sk_plus__hsw
FUNCTION(_sk_plus__hsw)
_sk_plus__hsw:
  .byte  197,252,88,196                      // vaddps        %ymm4,%ymm0,%ymm0
  .byte  196,98,125,24,5,179,32,3,0          // vbroadcastss  0x320b3(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  197,244,88,205                      // vaddps        %ymm5,%ymm1,%ymm1
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  197,236,88,214                      // vaddps        %ymm6,%ymm2,%ymm2
  .byte  196,193,108,93,208                  // vminps        %ymm8,%ymm2,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_screen_hsw
.globl _sk_screen_hsw
FUNCTION(_sk_screen_hsw)
_sk_screen_hsw:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  196,194,93,172,192                  // vfnmadd213ps  %ymm8,%ymm4,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  196,194,85,172,200                  // vfnmadd213ps  %ymm8,%ymm5,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  196,194,77,172,208                  // vfnmadd213ps  %ymm8,%ymm6,%ymm2
  .byte  197,100,88,199                      // vaddps        %ymm7,%ymm3,%ymm8
  .byte  196,194,69,172,216                  // vfnmadd213ps  %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xor__hsw
.globl _sk_xor__hsw
FUNCTION(_sk_xor__hsw)
_sk_xor__hsw:
  .byte  196,98,125,24,5,94,32,3,0           // vbroadcastss  0x3205e(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,207                       // vsubps        %ymm7,%ymm8,%ymm9
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,226,61,184,196                  // vfmadd231ps   %ymm4,%ymm8,%ymm0
  .byte  197,180,89,201                      // vmulps        %ymm1,%ymm9,%ymm1
  .byte  196,226,61,184,205                  // vfmadd231ps   %ymm5,%ymm8,%ymm1
  .byte  197,180,89,210                      // vmulps        %ymm2,%ymm9,%ymm2
  .byte  196,226,61,184,214                  // vfmadd231ps   %ymm6,%ymm8,%ymm2
  .byte  197,180,89,219                      // vmulps        %ymm3,%ymm9,%ymm3
  .byte  196,98,69,168,195                   // vfmadd213ps   %ymm3,%ymm7,%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,195                      // vmovaps       %ymm8,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_darken_hsw
.globl _sk_darken_hsw
FUNCTION(_sk_darken_hsw)
_sk_darken_hsw:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,100,89,204                      // vmulps        %ymm4,%ymm3,%ymm9
  .byte  196,193,124,95,193                  // vmaxps        %ymm9,%ymm0,%ymm0
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  197,100,89,205                      // vmulps        %ymm5,%ymm3,%ymm9
  .byte  196,193,116,95,201                  // vmaxps        %ymm9,%ymm1,%ymm1
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  197,100,89,206                      // vmulps        %ymm6,%ymm3,%ymm9
  .byte  196,193,108,95,209                  // vmaxps        %ymm9,%ymm2,%ymm2
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,226,31,3,0          // vbroadcastss  0x31fe2(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lighten_hsw
.globl _sk_lighten_hsw
FUNCTION(_sk_lighten_hsw)
_sk_lighten_hsw:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,100,89,204                      // vmulps        %ymm4,%ymm3,%ymm9
  .byte  196,193,124,93,193                  // vminps        %ymm9,%ymm0,%ymm0
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  197,100,89,205                      // vmulps        %ymm5,%ymm3,%ymm9
  .byte  196,193,116,93,201                  // vminps        %ymm9,%ymm1,%ymm1
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  197,100,89,206                      // vmulps        %ymm6,%ymm3,%ymm9
  .byte  196,193,108,93,209                  // vminps        %ymm9,%ymm2,%ymm2
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,141,31,3,0          // vbroadcastss  0x31f8d(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_difference_hsw
.globl _sk_difference_hsw
FUNCTION(_sk_difference_hsw)
_sk_difference_hsw:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,100,89,204                      // vmulps        %ymm4,%ymm3,%ymm9
  .byte  196,193,124,93,193                  // vminps        %ymm9,%ymm0,%ymm0
  .byte  197,252,88,192                      // vaddps        %ymm0,%ymm0,%ymm0
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  197,100,89,205                      // vmulps        %ymm5,%ymm3,%ymm9
  .byte  196,193,116,93,201                  // vminps        %ymm9,%ymm1,%ymm1
  .byte  197,244,88,201                      // vaddps        %ymm1,%ymm1,%ymm1
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  197,100,89,206                      // vmulps        %ymm6,%ymm3,%ymm9
  .byte  196,193,108,93,209                  // vminps        %ymm9,%ymm2,%ymm2
  .byte  197,236,88,210                      // vaddps        %ymm2,%ymm2,%ymm2
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,44,31,3,0           // vbroadcastss  0x31f2c(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_exclusion_hsw
.globl _sk_exclusion_hsw
FUNCTION(_sk_exclusion_hsw)
_sk_exclusion_hsw:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  197,252,89,196                      // vmulps        %ymm4,%ymm0,%ymm0
  .byte  197,252,88,192                      // vaddps        %ymm0,%ymm0,%ymm0
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  197,244,89,205                      // vmulps        %ymm5,%ymm1,%ymm1
  .byte  197,244,88,201                      // vaddps        %ymm1,%ymm1,%ymm1
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  197,236,89,214                      // vmulps        %ymm6,%ymm2,%ymm2
  .byte  197,236,88,210                      // vaddps        %ymm2,%ymm2,%ymm2
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,230,30,3,0          // vbroadcastss  0x31ee6(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_colorburn_hsw
.globl _sk_colorburn_hsw
FUNCTION(_sk_colorburn_hsw)
_sk_colorburn_hsw:
  .byte  196,98,125,24,5,208,30,3,0          // vbroadcastss  0x31ed0(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,207                       // vsubps        %ymm7,%ymm8,%ymm9
  .byte  197,52,89,216                       // vmulps        %ymm0,%ymm9,%ymm11
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,65,124,194,226,0                // vcmpeqps      %ymm10,%ymm0,%ymm12
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,68,92,236                       // vsubps        %ymm4,%ymm7,%ymm13
  .byte  197,20,89,235                       // vmulps        %ymm3,%ymm13,%ymm13
  .byte  197,252,83,192                      // vrcpps        %ymm0,%ymm0
  .byte  197,148,89,192                      // vmulps        %ymm0,%ymm13,%ymm0
  .byte  197,60,89,236                       // vmulps        %ymm4,%ymm8,%ymm13
  .byte  197,196,93,192                      // vminps        %ymm0,%ymm7,%ymm0
  .byte  197,196,92,192                      // vsubps        %ymm0,%ymm7,%ymm0
  .byte  196,194,101,168,195                 // vfmadd213ps   %ymm11,%ymm3,%ymm0
  .byte  197,148,88,192                      // vaddps        %ymm0,%ymm13,%ymm0
  .byte  196,195,125,74,197,192              // vblendvps     %ymm12,%ymm13,%ymm0,%ymm0
  .byte  197,92,194,231,0                    // vcmpeqps      %ymm7,%ymm4,%ymm12
  .byte  197,36,88,220                       // vaddps        %ymm4,%ymm11,%ymm11
  .byte  196,195,125,74,195,192              // vblendvps     %ymm12,%ymm11,%ymm0,%ymm0
  .byte  197,52,89,217                       // vmulps        %ymm1,%ymm9,%ymm11
  .byte  196,65,116,194,226,0                // vcmpeqps      %ymm10,%ymm1,%ymm12
  .byte  197,68,92,237                       // vsubps        %ymm5,%ymm7,%ymm13
  .byte  197,20,89,235                       // vmulps        %ymm3,%ymm13,%ymm13
  .byte  197,252,83,201                      // vrcpps        %ymm1,%ymm1
  .byte  197,148,89,201                      // vmulps        %ymm1,%ymm13,%ymm1
  .byte  197,60,89,237                       // vmulps        %ymm5,%ymm8,%ymm13
  .byte  197,196,93,201                      // vminps        %ymm1,%ymm7,%ymm1
  .byte  197,196,92,201                      // vsubps        %ymm1,%ymm7,%ymm1
  .byte  196,194,101,168,203                 // vfmadd213ps   %ymm11,%ymm3,%ymm1
  .byte  197,148,88,201                      // vaddps        %ymm1,%ymm13,%ymm1
  .byte  196,195,117,74,205,192              // vblendvps     %ymm12,%ymm13,%ymm1,%ymm1
  .byte  197,84,194,231,0                    // vcmpeqps      %ymm7,%ymm5,%ymm12
  .byte  197,36,88,221                       // vaddps        %ymm5,%ymm11,%ymm11
  .byte  196,195,117,74,203,192              // vblendvps     %ymm12,%ymm11,%ymm1,%ymm1
  .byte  197,52,89,202                       // vmulps        %ymm2,%ymm9,%ymm9
  .byte  196,65,108,194,210,0                // vcmpeqps      %ymm10,%ymm2,%ymm10
  .byte  197,68,92,222                       // vsubps        %ymm6,%ymm7,%ymm11
  .byte  197,36,89,219                       // vmulps        %ymm3,%ymm11,%ymm11
  .byte  197,252,83,210                      // vrcpps        %ymm2,%ymm2
  .byte  197,164,89,210                      // vmulps        %ymm2,%ymm11,%ymm2
  .byte  197,60,89,222                       // vmulps        %ymm6,%ymm8,%ymm11
  .byte  197,196,93,210                      // vminps        %ymm2,%ymm7,%ymm2
  .byte  197,196,92,210                      // vsubps        %ymm2,%ymm7,%ymm2
  .byte  196,194,101,168,209                 // vfmadd213ps   %ymm9,%ymm3,%ymm2
  .byte  197,164,88,210                      // vaddps        %ymm2,%ymm11,%ymm2
  .byte  196,195,109,74,211,160              // vblendvps     %ymm10,%ymm11,%ymm2,%ymm2
  .byte  197,76,194,215,0                    // vcmpeqps      %ymm7,%ymm6,%ymm10
  .byte  197,52,88,206                       // vaddps        %ymm6,%ymm9,%ymm9
  .byte  196,195,109,74,209,160              // vblendvps     %ymm10,%ymm9,%ymm2,%ymm2
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_colordodge_hsw
.globl _sk_colordodge_hsw
FUNCTION(_sk_colordodge_hsw)
_sk_colordodge_hsw:
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,98,125,24,13,224,29,3,0         // vbroadcastss  0x31de0(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,52,92,215                       // vsubps        %ymm7,%ymm9,%ymm10
  .byte  197,44,89,216                       // vmulps        %ymm0,%ymm10,%ymm11
  .byte  197,52,92,203                       // vsubps        %ymm3,%ymm9,%ymm9
  .byte  197,100,89,228                      // vmulps        %ymm4,%ymm3,%ymm12
  .byte  197,100,92,232                      // vsubps        %ymm0,%ymm3,%ymm13
  .byte  196,65,124,83,237                   // vrcpps        %ymm13,%ymm13
  .byte  196,65,28,89,229                    // vmulps        %ymm13,%ymm12,%ymm12
  .byte  197,52,89,236                       // vmulps        %ymm4,%ymm9,%ymm13
  .byte  196,65,68,93,228                    // vminps        %ymm12,%ymm7,%ymm12
  .byte  196,66,101,168,227                  // vfmadd213ps   %ymm11,%ymm3,%ymm12
  .byte  196,65,20,88,228                    // vaddps        %ymm12,%ymm13,%ymm12
  .byte  197,20,88,232                       // vaddps        %ymm0,%ymm13,%ymm13
  .byte  197,252,194,195,0                   // vcmpeqps      %ymm3,%ymm0,%ymm0
  .byte  196,195,29,74,197,0                 // vblendvps     %ymm0,%ymm13,%ymm12,%ymm0
  .byte  196,65,92,194,224,0                 // vcmpeqps      %ymm8,%ymm4,%ymm12
  .byte  196,195,125,74,195,192              // vblendvps     %ymm12,%ymm11,%ymm0,%ymm0
  .byte  197,44,89,217                       // vmulps        %ymm1,%ymm10,%ymm11
  .byte  197,100,89,229                      // vmulps        %ymm5,%ymm3,%ymm12
  .byte  197,100,92,233                      // vsubps        %ymm1,%ymm3,%ymm13
  .byte  196,65,124,83,237                   // vrcpps        %ymm13,%ymm13
  .byte  196,65,28,89,229                    // vmulps        %ymm13,%ymm12,%ymm12
  .byte  197,52,89,237                       // vmulps        %ymm5,%ymm9,%ymm13
  .byte  196,65,68,93,228                    // vminps        %ymm12,%ymm7,%ymm12
  .byte  196,66,101,168,227                  // vfmadd213ps   %ymm11,%ymm3,%ymm12
  .byte  196,65,20,88,228                    // vaddps        %ymm12,%ymm13,%ymm12
  .byte  197,20,88,233                       // vaddps        %ymm1,%ymm13,%ymm13
  .byte  197,244,194,203,0                   // vcmpeqps      %ymm3,%ymm1,%ymm1
  .byte  196,195,29,74,205,16                // vblendvps     %ymm1,%ymm13,%ymm12,%ymm1
  .byte  196,65,84,194,224,0                 // vcmpeqps      %ymm8,%ymm5,%ymm12
  .byte  196,195,117,74,203,192              // vblendvps     %ymm12,%ymm11,%ymm1,%ymm1
  .byte  197,44,89,210                       // vmulps        %ymm2,%ymm10,%ymm10
  .byte  197,100,89,222                      // vmulps        %ymm6,%ymm3,%ymm11
  .byte  197,100,92,226                      // vsubps        %ymm2,%ymm3,%ymm12
  .byte  196,65,124,83,228                   // vrcpps        %ymm12,%ymm12
  .byte  196,65,36,89,220                    // vmulps        %ymm12,%ymm11,%ymm11
  .byte  197,52,89,230                       // vmulps        %ymm6,%ymm9,%ymm12
  .byte  196,65,68,93,219                    // vminps        %ymm11,%ymm7,%ymm11
  .byte  196,66,101,168,218                  // vfmadd213ps   %ymm10,%ymm3,%ymm11
  .byte  196,65,28,88,219                    // vaddps        %ymm11,%ymm12,%ymm11
  .byte  197,28,88,226                       // vaddps        %ymm2,%ymm12,%ymm12
  .byte  197,236,194,211,0                   // vcmpeqps      %ymm3,%ymm2,%ymm2
  .byte  196,195,37,74,212,32                // vblendvps     %ymm2,%ymm12,%ymm11,%ymm2
  .byte  196,65,76,194,192,0                 // vcmpeqps      %ymm8,%ymm6,%ymm8
  .byte  196,195,109,74,210,128              // vblendvps     %ymm8,%ymm10,%ymm2,%ymm2
  .byte  196,194,69,184,217                  // vfmadd231ps   %ymm9,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hardlight_hsw
.globl _sk_hardlight_hsw
FUNCTION(_sk_hardlight_hsw)
_sk_hardlight_hsw:
  .byte  196,98,125,24,5,250,28,3,0          // vbroadcastss  0x31cfa(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,215                       // vsubps        %ymm7,%ymm8,%ymm10
  .byte  197,44,89,216                       // vmulps        %ymm0,%ymm10,%ymm11
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,98,61,184,220                   // vfmadd231ps   %ymm4,%ymm8,%ymm11
  .byte  197,124,88,200                      // vaddps        %ymm0,%ymm0,%ymm9
  .byte  197,52,194,227,2                    // vcmpleps      %ymm3,%ymm9,%ymm12
  .byte  197,124,89,204                      // vmulps        %ymm4,%ymm0,%ymm9
  .byte  196,65,52,88,233                    // vaddps        %ymm9,%ymm9,%ymm13
  .byte  197,100,89,207                      // vmulps        %ymm7,%ymm3,%ymm9
  .byte  197,68,92,244                       // vsubps        %ymm4,%ymm7,%ymm14
  .byte  197,228,92,192                      // vsubps        %ymm0,%ymm3,%ymm0
  .byte  196,193,124,89,198                  // vmulps        %ymm14,%ymm0,%ymm0
  .byte  197,252,88,192                      // vaddps        %ymm0,%ymm0,%ymm0
  .byte  197,180,92,192                      // vsubps        %ymm0,%ymm9,%ymm0
  .byte  196,195,125,74,197,192              // vblendvps     %ymm12,%ymm13,%ymm0,%ymm0
  .byte  197,164,88,192                      // vaddps        %ymm0,%ymm11,%ymm0
  .byte  197,44,89,217                       // vmulps        %ymm1,%ymm10,%ymm11
  .byte  196,98,61,184,221                   // vfmadd231ps   %ymm5,%ymm8,%ymm11
  .byte  197,116,88,225                      // vaddps        %ymm1,%ymm1,%ymm12
  .byte  197,28,194,227,2                    // vcmpleps      %ymm3,%ymm12,%ymm12
  .byte  197,116,89,237                      // vmulps        %ymm5,%ymm1,%ymm13
  .byte  196,65,20,88,237                    // vaddps        %ymm13,%ymm13,%ymm13
  .byte  197,68,92,245                       // vsubps        %ymm5,%ymm7,%ymm14
  .byte  197,228,92,201                      // vsubps        %ymm1,%ymm3,%ymm1
  .byte  196,193,116,89,206                  // vmulps        %ymm14,%ymm1,%ymm1
  .byte  197,244,88,201                      // vaddps        %ymm1,%ymm1,%ymm1
  .byte  197,180,92,201                      // vsubps        %ymm1,%ymm9,%ymm1
  .byte  196,195,117,74,205,192              // vblendvps     %ymm12,%ymm13,%ymm1,%ymm1
  .byte  197,164,88,201                      // vaddps        %ymm1,%ymm11,%ymm1
  .byte  197,44,89,210                       // vmulps        %ymm2,%ymm10,%ymm10
  .byte  196,98,61,184,214                   // vfmadd231ps   %ymm6,%ymm8,%ymm10
  .byte  197,108,88,218                      // vaddps        %ymm2,%ymm2,%ymm11
  .byte  197,36,194,219,2                    // vcmpleps      %ymm3,%ymm11,%ymm11
  .byte  197,108,89,230                      // vmulps        %ymm6,%ymm2,%ymm12
  .byte  196,65,28,88,228                    // vaddps        %ymm12,%ymm12,%ymm12
  .byte  197,68,92,238                       // vsubps        %ymm6,%ymm7,%ymm13
  .byte  197,228,92,210                      // vsubps        %ymm2,%ymm3,%ymm2
  .byte  196,193,108,89,213                  // vmulps        %ymm13,%ymm2,%ymm2
  .byte  197,236,88,210                      // vaddps        %ymm2,%ymm2,%ymm2
  .byte  197,180,92,210                      // vsubps        %ymm2,%ymm9,%ymm2
  .byte  196,195,109,74,212,176              // vblendvps     %ymm11,%ymm12,%ymm2,%ymm2
  .byte  197,172,88,210                      // vaddps        %ymm2,%ymm10,%ymm2
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_overlay_hsw
.globl _sk_overlay_hsw
FUNCTION(_sk_overlay_hsw)
_sk_overlay_hsw:
  .byte  196,98,125,24,5,46,28,3,0           // vbroadcastss  0x31c2e(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,215                       // vsubps        %ymm7,%ymm8,%ymm10
  .byte  197,44,89,216                       // vmulps        %ymm0,%ymm10,%ymm11
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,98,61,184,220                   // vfmadd231ps   %ymm4,%ymm8,%ymm11
  .byte  197,92,88,204                       // vaddps        %ymm4,%ymm4,%ymm9
  .byte  197,52,194,231,2                    // vcmpleps      %ymm7,%ymm9,%ymm12
  .byte  197,124,89,204                      // vmulps        %ymm4,%ymm0,%ymm9
  .byte  196,65,52,88,233                    // vaddps        %ymm9,%ymm9,%ymm13
  .byte  197,100,89,207                      // vmulps        %ymm7,%ymm3,%ymm9
  .byte  197,68,92,244                       // vsubps        %ymm4,%ymm7,%ymm14
  .byte  197,228,92,192                      // vsubps        %ymm0,%ymm3,%ymm0
  .byte  196,193,124,89,198                  // vmulps        %ymm14,%ymm0,%ymm0
  .byte  197,252,88,192                      // vaddps        %ymm0,%ymm0,%ymm0
  .byte  197,180,92,192                      // vsubps        %ymm0,%ymm9,%ymm0
  .byte  196,195,125,74,197,192              // vblendvps     %ymm12,%ymm13,%ymm0,%ymm0
  .byte  197,164,88,192                      // vaddps        %ymm0,%ymm11,%ymm0
  .byte  197,44,89,217                       // vmulps        %ymm1,%ymm10,%ymm11
  .byte  196,98,61,184,221                   // vfmadd231ps   %ymm5,%ymm8,%ymm11
  .byte  197,84,88,229                       // vaddps        %ymm5,%ymm5,%ymm12
  .byte  197,28,194,231,2                    // vcmpleps      %ymm7,%ymm12,%ymm12
  .byte  197,116,89,237                      // vmulps        %ymm5,%ymm1,%ymm13
  .byte  196,65,20,88,237                    // vaddps        %ymm13,%ymm13,%ymm13
  .byte  197,68,92,245                       // vsubps        %ymm5,%ymm7,%ymm14
  .byte  197,228,92,201                      // vsubps        %ymm1,%ymm3,%ymm1
  .byte  196,193,116,89,206                  // vmulps        %ymm14,%ymm1,%ymm1
  .byte  197,244,88,201                      // vaddps        %ymm1,%ymm1,%ymm1
  .byte  197,180,92,201                      // vsubps        %ymm1,%ymm9,%ymm1
  .byte  196,195,117,74,205,192              // vblendvps     %ymm12,%ymm13,%ymm1,%ymm1
  .byte  197,164,88,201                      // vaddps        %ymm1,%ymm11,%ymm1
  .byte  197,44,89,210                       // vmulps        %ymm2,%ymm10,%ymm10
  .byte  196,98,61,184,214                   // vfmadd231ps   %ymm6,%ymm8,%ymm10
  .byte  197,76,88,222                       // vaddps        %ymm6,%ymm6,%ymm11
  .byte  197,36,194,223,2                    // vcmpleps      %ymm7,%ymm11,%ymm11
  .byte  197,108,89,230                      // vmulps        %ymm6,%ymm2,%ymm12
  .byte  196,65,28,88,228                    // vaddps        %ymm12,%ymm12,%ymm12
  .byte  197,68,92,238                       // vsubps        %ymm6,%ymm7,%ymm13
  .byte  197,228,92,210                      // vsubps        %ymm2,%ymm3,%ymm2
  .byte  196,193,108,89,213                  // vmulps        %ymm13,%ymm2,%ymm2
  .byte  197,236,88,210                      // vaddps        %ymm2,%ymm2,%ymm2
  .byte  197,180,92,210                      // vsubps        %ymm2,%ymm9,%ymm2
  .byte  196,195,109,74,212,176              // vblendvps     %ymm11,%ymm12,%ymm2,%ymm2
  .byte  197,172,88,210                      // vaddps        %ymm2,%ymm10,%ymm2
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_softlight_hsw
.globl _sk_softlight_hsw
FUNCTION(_sk_softlight_hsw)
_sk_softlight_hsw:
  .byte  197,252,17,84,36,200                // vmovups       %ymm2,-0x38(%rsp)
  .byte  197,252,40,209                      // vmovaps       %ymm1,%ymm2
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,52,194,215,1                    // vcmpltps      %ymm7,%ymm9,%ymm10
  .byte  197,92,94,199                       // vdivps        %ymm7,%ymm4,%ymm8
  .byte  196,67,53,74,232,160                // vblendvps     %ymm10,%ymm8,%ymm9,%ymm13
  .byte  196,65,20,88,197                    // vaddps        %ymm13,%ymm13,%ymm8
  .byte  196,65,60,88,192                    // vaddps        %ymm8,%ymm8,%ymm8
  .byte  196,66,61,168,192                   // vfmadd213ps   %ymm8,%ymm8,%ymm8
  .byte  196,98,125,24,29,73,27,3,0          // vbroadcastss  0x31b49(%rip),%ymm11        # 3a230 <_sk_srcover_bgra_8888_sse2_lowp+0x2c8>
  .byte  196,65,20,88,227                    // vaddps        %ymm11,%ymm13,%ymm12
  .byte  196,65,28,89,192                    // vmulps        %ymm8,%ymm12,%ymm8
  .byte  196,98,125,24,37,58,27,3,0          // vbroadcastss  0x31b3a(%rip),%ymm12        # 3a234 <_sk_srcover_bgra_8888_sse2_lowp+0x2cc>
  .byte  196,66,21,184,196                   // vfmadd231ps   %ymm12,%ymm13,%ymm8
  .byte  196,65,124,82,245                   // vrsqrtps      %ymm13,%ymm14
  .byte  196,65,124,83,246                   // vrcpps        %ymm14,%ymm14
  .byte  196,65,12,92,245                    // vsubps        %ymm13,%ymm14,%ymm14
  .byte  197,92,88,252                       // vaddps        %ymm4,%ymm4,%ymm15
  .byte  196,65,4,88,255                     // vaddps        %ymm15,%ymm15,%ymm15
  .byte  197,4,194,255,2                     // vcmpleps      %ymm7,%ymm15,%ymm15
  .byte  196,67,13,74,240,240                // vblendvps     %ymm15,%ymm8,%ymm14,%ymm14
  .byte  197,116,88,249                      // vaddps        %ymm1,%ymm1,%ymm15
  .byte  196,98,125,24,5,233,26,3,0          // vbroadcastss  0x31ae9(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,60,92,237                    // vsubps        %ymm13,%ymm8,%ymm13
  .byte  197,132,92,195                      // vsubps        %ymm3,%ymm15,%ymm0
  .byte  196,98,125,168,235                  // vfmadd213ps   %ymm3,%ymm0,%ymm13
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  196,193,124,89,198                  // vmulps        %ymm14,%ymm0,%ymm0
  .byte  197,20,89,236                       // vmulps        %ymm4,%ymm13,%ymm13
  .byte  196,226,101,184,196                 // vfmadd231ps   %ymm4,%ymm3,%ymm0
  .byte  197,4,194,243,2                     // vcmpleps      %ymm3,%ymm15,%ymm14
  .byte  196,195,125,74,197,224              // vblendvps     %ymm14,%ymm13,%ymm0,%ymm0
  .byte  197,252,17,68,36,168                // vmovups       %ymm0,-0x58(%rsp)
  .byte  197,212,94,199                      // vdivps        %ymm7,%ymm5,%ymm0
  .byte  196,227,53,74,192,160               // vblendvps     %ymm10,%ymm0,%ymm9,%ymm0
  .byte  197,124,88,240                      // vaddps        %ymm0,%ymm0,%ymm14
  .byte  196,65,12,88,246                    // vaddps        %ymm14,%ymm14,%ymm14
  .byte  196,66,13,168,246                   // vfmadd213ps   %ymm14,%ymm14,%ymm14
  .byte  196,65,124,88,251                   // vaddps        %ymm11,%ymm0,%ymm15
  .byte  196,65,4,89,246                     // vmulps        %ymm14,%ymm15,%ymm14
  .byte  196,66,125,184,244                  // vfmadd231ps   %ymm12,%ymm0,%ymm14
  .byte  197,124,82,248                      // vrsqrtps      %ymm0,%ymm15
  .byte  196,65,124,83,255                   // vrcpps        %ymm15,%ymm15
  .byte  197,4,92,248                        // vsubps        %ymm0,%ymm15,%ymm15
  .byte  197,84,88,237                       // vaddps        %ymm5,%ymm5,%ymm13
  .byte  196,65,20,88,237                    // vaddps        %ymm13,%ymm13,%ymm13
  .byte  197,20,194,239,2                    // vcmpleps      %ymm7,%ymm13,%ymm13
  .byte  196,67,5,74,238,208                 // vblendvps     %ymm13,%ymm14,%ymm15,%ymm13
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,108,88,242                      // vaddps        %ymm2,%ymm2,%ymm14
  .byte  197,12,92,251                       // vsubps        %ymm3,%ymm14,%ymm15
  .byte  196,226,5,168,195                   // vfmadd213ps   %ymm3,%ymm15,%ymm0
  .byte  197,4,89,255                        // vmulps        %ymm7,%ymm15,%ymm15
  .byte  196,65,4,89,237                     // vmulps        %ymm13,%ymm15,%ymm13
  .byte  197,252,89,197                      // vmulps        %ymm5,%ymm0,%ymm0
  .byte  196,98,101,184,237                  // vfmadd231ps   %ymm5,%ymm3,%ymm13
  .byte  197,12,194,243,2                    // vcmpleps      %ymm3,%ymm14,%ymm14
  .byte  196,99,21,74,240,224                // vblendvps     %ymm14,%ymm0,%ymm13,%ymm14
  .byte  197,204,94,199                      // vdivps        %ymm7,%ymm6,%ymm0
  .byte  196,227,53,74,192,160               // vblendvps     %ymm10,%ymm0,%ymm9,%ymm0
  .byte  197,124,88,200                      // vaddps        %ymm0,%ymm0,%ymm9
  .byte  196,65,52,88,201                    // vaddps        %ymm9,%ymm9,%ymm9
  .byte  196,66,53,168,201                   // vfmadd213ps   %ymm9,%ymm9,%ymm9
  .byte  196,65,124,88,211                   // vaddps        %ymm11,%ymm0,%ymm10
  .byte  196,65,44,89,201                    // vmulps        %ymm9,%ymm10,%ymm9
  .byte  196,66,125,184,204                  // vfmadd231ps   %ymm12,%ymm0,%ymm9
  .byte  197,124,82,208                      // vrsqrtps      %ymm0,%ymm10
  .byte  196,65,124,83,210                   // vrcpps        %ymm10,%ymm10
  .byte  197,44,92,208                       // vsubps        %ymm0,%ymm10,%ymm10
  .byte  197,76,88,222                       // vaddps        %ymm6,%ymm6,%ymm11
  .byte  196,65,36,88,219                    // vaddps        %ymm11,%ymm11,%ymm11
  .byte  197,36,194,223,2                    // vcmpleps      %ymm7,%ymm11,%ymm11
  .byte  196,67,45,74,201,176                // vblendvps     %ymm11,%ymm9,%ymm10,%ymm9
  .byte  197,124,16,100,36,200               // vmovups       -0x38(%rsp),%ymm12
  .byte  196,65,28,88,212                    // vaddps        %ymm12,%ymm12,%ymm10
  .byte  197,44,92,219                       // vsubps        %ymm3,%ymm10,%ymm11
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  196,226,37,168,195                  // vfmadd213ps   %ymm3,%ymm11,%ymm0
  .byte  197,36,89,223                       // vmulps        %ymm7,%ymm11,%ymm11
  .byte  196,65,36,89,201                    // vmulps        %ymm9,%ymm11,%ymm9
  .byte  197,252,89,198                      // vmulps        %ymm6,%ymm0,%ymm0
  .byte  196,98,101,184,206                  // vfmadd231ps   %ymm6,%ymm3,%ymm9
  .byte  197,44,194,211,2                    // vcmpleps      %ymm3,%ymm10,%ymm10
  .byte  196,99,53,74,200,160                // vblendvps     %ymm10,%ymm0,%ymm9,%ymm9
  .byte  197,60,92,215                       // vsubps        %ymm7,%ymm8,%ymm10
  .byte  197,172,89,193                      // vmulps        %ymm1,%ymm10,%ymm0
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  196,226,61,184,196                  // vfmadd231ps   %ymm4,%ymm8,%ymm0
  .byte  197,252,88,68,36,168                // vaddps        -0x58(%rsp),%ymm0,%ymm0
  .byte  197,172,89,202                      // vmulps        %ymm2,%ymm10,%ymm1
  .byte  196,226,61,184,205                  // vfmadd231ps   %ymm5,%ymm8,%ymm1
  .byte  196,193,116,88,206                  // vaddps        %ymm14,%ymm1,%ymm1
  .byte  196,193,44,89,212                   // vmulps        %ymm12,%ymm10,%ymm2
  .byte  196,226,61,184,214                  // vfmadd231ps   %ymm6,%ymm8,%ymm2
  .byte  196,193,108,88,209                  // vaddps        %ymm9,%ymm2,%ymm2
  .byte  196,194,69,184,216                  // vfmadd231ps   %ymm8,%ymm7,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hue_hsw
.globl _sk_hue_hsw
FUNCTION(_sk_hue_hsw)
_sk_hue_hsw:
  .byte  197,124,40,194                      // vmovaps       %ymm2,%ymm8
  .byte  197,124,17,68,36,200                // vmovups       %ymm8,-0x38(%rsp)
  .byte  197,252,17,76,36,168                // vmovups       %ymm1,-0x58(%rsp)
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  197,108,89,203                      // vmulps        %ymm3,%ymm2,%ymm9
  .byte  197,116,89,211                      // vmulps        %ymm3,%ymm1,%ymm10
  .byte  197,60,89,219                       // vmulps        %ymm3,%ymm8,%ymm11
  .byte  197,84,95,198                       // vmaxps        %ymm6,%ymm5,%ymm8
  .byte  196,65,92,95,192                    // vmaxps        %ymm8,%ymm4,%ymm8
  .byte  197,84,93,230                       // vminps        %ymm6,%ymm5,%ymm12
  .byte  196,65,92,93,228                    // vminps        %ymm12,%ymm4,%ymm12
  .byte  196,65,60,92,196                    // vsubps        %ymm12,%ymm8,%ymm8
  .byte  197,60,89,227                       // vmulps        %ymm3,%ymm8,%ymm12
  .byte  196,65,44,93,195                    // vminps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,93,232                    // vminps        %ymm8,%ymm9,%ymm13
  .byte  196,65,44,95,195                    // vmaxps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,95,192                    // vmaxps        %ymm8,%ymm9,%ymm8
  .byte  196,65,60,92,245                    // vsubps        %ymm13,%ymm8,%ymm14
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,65,12,194,248,0                 // vcmpeqps      %ymm8,%ymm14,%ymm15
  .byte  196,65,52,92,205                    // vsubps        %ymm13,%ymm9,%ymm9
  .byte  196,65,28,89,201                    // vmulps        %ymm9,%ymm12,%ymm9
  .byte  196,65,52,94,206                    // vdivps        %ymm14,%ymm9,%ymm9
  .byte  196,67,53,74,200,240                // vblendvps     %ymm15,%ymm8,%ymm9,%ymm9
  .byte  196,65,44,92,213                    // vsubps        %ymm13,%ymm10,%ymm10
  .byte  196,65,28,89,210                    // vmulps        %ymm10,%ymm12,%ymm10
  .byte  196,65,44,94,214                    // vdivps        %ymm14,%ymm10,%ymm10
  .byte  196,195,45,74,200,240               // vblendvps     %ymm15,%ymm8,%ymm10,%ymm1
  .byte  196,65,36,92,213                    // vsubps        %ymm13,%ymm11,%ymm10
  .byte  196,65,28,89,210                    // vmulps        %ymm10,%ymm12,%ymm10
  .byte  196,65,44,94,214                    // vdivps        %ymm14,%ymm10,%ymm10
  .byte  196,67,45,74,224,240                // vblendvps     %ymm15,%ymm8,%ymm10,%ymm12
  .byte  196,98,125,24,53,1,25,3,0           // vbroadcastss  0x31901(%rip),%ymm14        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,98,125,24,61,252,24,3,0         // vbroadcastss  0x318fc(%rip),%ymm15        # 3a23c <_sk_srcover_bgra_8888_sse2_lowp+0x2d4>
  .byte  196,65,84,89,239                    // vmulps        %ymm15,%ymm5,%ymm13
  .byte  196,66,93,184,238                   // vfmadd231ps   %ymm14,%ymm4,%ymm13
  .byte  196,226,125,24,5,237,24,3,0         // vbroadcastss  0x318ed(%rip),%ymm0        # 3a240 <_sk_srcover_bgra_8888_sse2_lowp+0x2d8>
  .byte  196,98,77,184,232                   // vfmadd231ps   %ymm0,%ymm6,%ymm13
  .byte  196,65,116,89,215                   // vmulps        %ymm15,%ymm1,%ymm10
  .byte  196,66,53,184,214                   // vfmadd231ps   %ymm14,%ymm9,%ymm10
  .byte  196,98,29,184,208                   // vfmadd231ps   %ymm0,%ymm12,%ymm10
  .byte  196,66,101,170,234                  // vfmsub213ps   %ymm10,%ymm3,%ymm13
  .byte  196,65,52,88,213                    // vaddps        %ymm13,%ymm9,%ymm10
  .byte  196,65,116,88,221                   // vaddps        %ymm13,%ymm1,%ymm11
  .byte  196,65,28,88,229                    // vaddps        %ymm13,%ymm12,%ymm12
  .byte  196,193,36,93,204                   // vminps        %ymm12,%ymm11,%ymm1
  .byte  197,44,93,233                       // vminps        %ymm1,%ymm10,%ymm13
  .byte  196,65,36,89,207                    // vmulps        %ymm15,%ymm11,%ymm9
  .byte  196,66,45,184,206                   // vfmadd231ps   %ymm14,%ymm10,%ymm9
  .byte  196,98,29,184,200                   // vfmadd231ps   %ymm0,%ymm12,%ymm9
  .byte  196,193,44,92,193                   // vsubps        %ymm9,%ymm10,%ymm0
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  196,193,52,92,205                   // vsubps        %ymm13,%ymm9,%ymm1
  .byte  197,252,94,193                      // vdivps        %ymm1,%ymm0,%ymm0
  .byte  196,65,36,92,241                    // vsubps        %ymm9,%ymm11,%ymm14
  .byte  196,65,52,89,246                    // vmulps        %ymm14,%ymm9,%ymm14
  .byte  197,12,94,241                       // vdivps        %ymm1,%ymm14,%ymm14
  .byte  196,65,28,92,249                    // vsubps        %ymm9,%ymm12,%ymm15
  .byte  196,65,52,89,255                    // vmulps        %ymm15,%ymm9,%ymm15
  .byte  197,132,94,201                      // vdivps        %ymm1,%ymm15,%ymm1
  .byte  196,65,60,194,237,2                 // vcmpleps      %ymm13,%ymm8,%ymm13
  .byte  196,65,52,88,246                    // vaddps        %ymm14,%ymm9,%ymm14
  .byte  196,67,13,74,243,208                // vblendvps     %ymm13,%ymm11,%ymm14,%ymm14
  .byte  196,65,36,95,220                    // vmaxps        %ymm12,%ymm11,%ymm11
  .byte  197,180,88,201                      // vaddps        %ymm1,%ymm9,%ymm1
  .byte  196,195,117,74,204,208              // vblendvps     %ymm13,%ymm12,%ymm1,%ymm1
  .byte  197,180,88,192                      // vaddps        %ymm0,%ymm9,%ymm0
  .byte  196,195,125,74,194,208              // vblendvps     %ymm13,%ymm10,%ymm0,%ymm0
  .byte  197,100,89,231                      // vmulps        %ymm7,%ymm3,%ymm12
  .byte  196,65,44,95,211                    // vmaxps        %ymm11,%ymm10,%ymm10
  .byte  196,65,124,92,217                   // vsubps        %ymm9,%ymm0,%ymm11
  .byte  196,65,28,92,233                    // vsubps        %ymm9,%ymm12,%ymm13
  .byte  196,65,20,89,219                    // vmulps        %ymm11,%ymm13,%ymm11
  .byte  196,65,28,194,250,1                 // vcmpltps      %ymm10,%ymm12,%ymm15
  .byte  196,65,44,92,209                    // vsubps        %ymm9,%ymm10,%ymm10
  .byte  196,65,36,94,218                    // vdivps        %ymm10,%ymm11,%ymm11
  .byte  196,65,52,88,219                    // vaddps        %ymm11,%ymm9,%ymm11
  .byte  196,195,125,74,195,240              // vblendvps     %ymm15,%ymm11,%ymm0,%ymm0
  .byte  196,65,12,92,217                    // vsubps        %ymm9,%ymm14,%ymm11
  .byte  196,65,20,89,219                    // vmulps        %ymm11,%ymm13,%ymm11
  .byte  196,65,36,94,218                    // vdivps        %ymm10,%ymm11,%ymm11
  .byte  196,65,52,88,219                    // vaddps        %ymm11,%ymm9,%ymm11
  .byte  196,67,13,74,219,240                // vblendvps     %ymm15,%ymm11,%ymm14,%ymm11
  .byte  196,65,116,92,241                   // vsubps        %ymm9,%ymm1,%ymm14
  .byte  196,65,20,89,238                    // vmulps        %ymm14,%ymm13,%ymm13
  .byte  196,65,20,94,210                    // vdivps        %ymm10,%ymm13,%ymm10
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,195,117,74,201,240              // vblendvps     %ymm15,%ymm9,%ymm1,%ymm1
  .byte  196,193,124,95,192                  // vmaxps        %ymm8,%ymm0,%ymm0
  .byte  196,65,36,95,200                    // vmaxps        %ymm8,%ymm11,%ymm9
  .byte  196,65,116,95,192                   // vmaxps        %ymm8,%ymm1,%ymm8
  .byte  196,226,125,24,13,174,23,3,0        // vbroadcastss  0x317ae(%rip),%ymm1        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,116,92,215                      // vsubps        %ymm7,%ymm1,%ymm10
  .byte  197,172,89,210                      // vmulps        %ymm2,%ymm10,%ymm2
  .byte  197,116,92,219                      // vsubps        %ymm3,%ymm1,%ymm11
  .byte  196,226,37,184,212                  // vfmadd231ps   %ymm4,%ymm11,%ymm2
  .byte  197,236,88,192                      // vaddps        %ymm0,%ymm2,%ymm0
  .byte  197,172,89,76,36,168                // vmulps        -0x58(%rsp),%ymm10,%ymm1
  .byte  196,226,37,184,205                  // vfmadd231ps   %ymm5,%ymm11,%ymm1
  .byte  196,193,116,88,201                  // vaddps        %ymm9,%ymm1,%ymm1
  .byte  197,172,89,84,36,200                // vmulps        -0x38(%rsp),%ymm10,%ymm2
  .byte  196,98,77,168,218                   // vfmadd213ps   %ymm2,%ymm6,%ymm11
  .byte  196,193,36,88,208                   // vaddps        %ymm8,%ymm11,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,92,220                  // vsubps        %ymm12,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_saturation_hsw
.globl _sk_saturation_hsw
FUNCTION(_sk_saturation_hsw)
_sk_saturation_hsw:
  .byte  197,124,40,194                      // vmovaps       %ymm2,%ymm8
  .byte  197,252,17,76,36,168                // vmovups       %ymm1,-0x58(%rsp)
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  197,100,89,204                      // vmulps        %ymm4,%ymm3,%ymm9
  .byte  197,100,89,213                      // vmulps        %ymm5,%ymm3,%ymm10
  .byte  197,100,89,222                      // vmulps        %ymm6,%ymm3,%ymm11
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,252,17,68,36,200                // vmovups       %ymm0,-0x38(%rsp)
  .byte  197,116,95,192                      // vmaxps        %ymm0,%ymm1,%ymm8
  .byte  196,65,108,95,192                   // vmaxps        %ymm8,%ymm2,%ymm8
  .byte  197,116,93,224                      // vminps        %ymm0,%ymm1,%ymm12
  .byte  196,65,108,93,228                   // vminps        %ymm12,%ymm2,%ymm12
  .byte  196,65,60,92,196                    // vsubps        %ymm12,%ymm8,%ymm8
  .byte  197,60,89,231                       // vmulps        %ymm7,%ymm8,%ymm12
  .byte  196,65,44,93,195                    // vminps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,93,232                    // vminps        %ymm8,%ymm9,%ymm13
  .byte  196,65,44,95,195                    // vmaxps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,95,192                    // vmaxps        %ymm8,%ymm9,%ymm8
  .byte  196,65,60,92,245                    // vsubps        %ymm13,%ymm8,%ymm14
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,65,12,194,248,0                 // vcmpeqps      %ymm8,%ymm14,%ymm15
  .byte  196,65,52,92,205                    // vsubps        %ymm13,%ymm9,%ymm9
  .byte  196,65,28,89,201                    // vmulps        %ymm9,%ymm12,%ymm9
  .byte  196,65,52,94,206                    // vdivps        %ymm14,%ymm9,%ymm9
  .byte  196,67,53,74,200,240                // vblendvps     %ymm15,%ymm8,%ymm9,%ymm9
  .byte  196,65,44,92,213                    // vsubps        %ymm13,%ymm10,%ymm10
  .byte  196,65,28,89,210                    // vmulps        %ymm10,%ymm12,%ymm10
  .byte  196,65,44,94,214                    // vdivps        %ymm14,%ymm10,%ymm10
  .byte  196,195,45,74,200,240               // vblendvps     %ymm15,%ymm8,%ymm10,%ymm1
  .byte  196,65,36,92,213                    // vsubps        %ymm13,%ymm11,%ymm10
  .byte  196,65,28,89,210                    // vmulps        %ymm10,%ymm12,%ymm10
  .byte  196,65,44,94,214                    // vdivps        %ymm14,%ymm10,%ymm10
  .byte  196,67,45,74,224,240                // vblendvps     %ymm15,%ymm8,%ymm10,%ymm12
  .byte  196,98,125,24,53,225,22,3,0         // vbroadcastss  0x316e1(%rip),%ymm14        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,98,125,24,61,220,22,3,0         // vbroadcastss  0x316dc(%rip),%ymm15        # 3a23c <_sk_srcover_bgra_8888_sse2_lowp+0x2d4>
  .byte  196,65,84,89,239                    // vmulps        %ymm15,%ymm5,%ymm13
  .byte  196,66,93,184,238                   // vfmadd231ps   %ymm14,%ymm4,%ymm13
  .byte  196,226,125,24,5,205,22,3,0         // vbroadcastss  0x316cd(%rip),%ymm0        # 3a240 <_sk_srcover_bgra_8888_sse2_lowp+0x2d8>
  .byte  196,98,77,184,232                   // vfmadd231ps   %ymm0,%ymm6,%ymm13
  .byte  196,65,116,89,215                   // vmulps        %ymm15,%ymm1,%ymm10
  .byte  196,66,53,184,214                   // vfmadd231ps   %ymm14,%ymm9,%ymm10
  .byte  196,98,29,184,208                   // vfmadd231ps   %ymm0,%ymm12,%ymm10
  .byte  196,66,101,170,234                  // vfmsub213ps   %ymm10,%ymm3,%ymm13
  .byte  196,65,52,88,213                    // vaddps        %ymm13,%ymm9,%ymm10
  .byte  196,65,116,88,221                   // vaddps        %ymm13,%ymm1,%ymm11
  .byte  196,65,28,88,229                    // vaddps        %ymm13,%ymm12,%ymm12
  .byte  196,193,36,93,204                   // vminps        %ymm12,%ymm11,%ymm1
  .byte  197,44,93,233                       // vminps        %ymm1,%ymm10,%ymm13
  .byte  196,65,36,89,207                    // vmulps        %ymm15,%ymm11,%ymm9
  .byte  196,66,45,184,206                   // vfmadd231ps   %ymm14,%ymm10,%ymm9
  .byte  196,98,29,184,200                   // vfmadd231ps   %ymm0,%ymm12,%ymm9
  .byte  196,193,44,92,193                   // vsubps        %ymm9,%ymm10,%ymm0
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  196,193,52,92,205                   // vsubps        %ymm13,%ymm9,%ymm1
  .byte  197,252,94,193                      // vdivps        %ymm1,%ymm0,%ymm0
  .byte  196,65,36,92,241                    // vsubps        %ymm9,%ymm11,%ymm14
  .byte  196,65,52,89,246                    // vmulps        %ymm14,%ymm9,%ymm14
  .byte  197,12,94,241                       // vdivps        %ymm1,%ymm14,%ymm14
  .byte  196,65,28,92,249                    // vsubps        %ymm9,%ymm12,%ymm15
  .byte  196,65,52,89,255                    // vmulps        %ymm15,%ymm9,%ymm15
  .byte  197,132,94,201                      // vdivps        %ymm1,%ymm15,%ymm1
  .byte  196,65,60,194,237,2                 // vcmpleps      %ymm13,%ymm8,%ymm13
  .byte  196,65,52,88,246                    // vaddps        %ymm14,%ymm9,%ymm14
  .byte  196,67,13,74,243,208                // vblendvps     %ymm13,%ymm11,%ymm14,%ymm14
  .byte  196,65,36,95,220                    // vmaxps        %ymm12,%ymm11,%ymm11
  .byte  197,180,88,201                      // vaddps        %ymm1,%ymm9,%ymm1
  .byte  196,195,117,74,204,208              // vblendvps     %ymm13,%ymm12,%ymm1,%ymm1
  .byte  197,180,88,192                      // vaddps        %ymm0,%ymm9,%ymm0
  .byte  196,195,125,74,194,208              // vblendvps     %ymm13,%ymm10,%ymm0,%ymm0
  .byte  197,100,89,231                      // vmulps        %ymm7,%ymm3,%ymm12
  .byte  196,65,44,95,211                    // vmaxps        %ymm11,%ymm10,%ymm10
  .byte  196,65,124,92,217                   // vsubps        %ymm9,%ymm0,%ymm11
  .byte  196,65,28,92,233                    // vsubps        %ymm9,%ymm12,%ymm13
  .byte  196,65,20,89,219                    // vmulps        %ymm11,%ymm13,%ymm11
  .byte  196,65,28,194,250,1                 // vcmpltps      %ymm10,%ymm12,%ymm15
  .byte  196,65,44,92,209                    // vsubps        %ymm9,%ymm10,%ymm10
  .byte  196,65,36,94,218                    // vdivps        %ymm10,%ymm11,%ymm11
  .byte  196,65,52,88,219                    // vaddps        %ymm11,%ymm9,%ymm11
  .byte  196,195,125,74,195,240              // vblendvps     %ymm15,%ymm11,%ymm0,%ymm0
  .byte  196,65,12,92,217                    // vsubps        %ymm9,%ymm14,%ymm11
  .byte  196,65,20,89,219                    // vmulps        %ymm11,%ymm13,%ymm11
  .byte  196,65,36,94,218                    // vdivps        %ymm10,%ymm11,%ymm11
  .byte  196,65,52,88,219                    // vaddps        %ymm11,%ymm9,%ymm11
  .byte  196,67,13,74,219,240                // vblendvps     %ymm15,%ymm11,%ymm14,%ymm11
  .byte  196,65,116,92,241                   // vsubps        %ymm9,%ymm1,%ymm14
  .byte  196,65,20,89,238                    // vmulps        %ymm14,%ymm13,%ymm13
  .byte  196,65,20,94,210                    // vdivps        %ymm10,%ymm13,%ymm10
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,195,117,74,201,240              // vblendvps     %ymm15,%ymm9,%ymm1,%ymm1
  .byte  196,193,124,95,192                  // vmaxps        %ymm8,%ymm0,%ymm0
  .byte  196,65,36,95,200                    // vmaxps        %ymm8,%ymm11,%ymm9
  .byte  196,65,116,95,192                   // vmaxps        %ymm8,%ymm1,%ymm8
  .byte  196,226,125,24,13,142,21,3,0        // vbroadcastss  0x3158e(%rip),%ymm1        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,116,92,215                      // vsubps        %ymm7,%ymm1,%ymm10
  .byte  197,172,89,210                      // vmulps        %ymm2,%ymm10,%ymm2
  .byte  197,116,92,219                      // vsubps        %ymm3,%ymm1,%ymm11
  .byte  196,226,37,184,212                  // vfmadd231ps   %ymm4,%ymm11,%ymm2
  .byte  197,236,88,192                      // vaddps        %ymm0,%ymm2,%ymm0
  .byte  197,172,89,76,36,168                // vmulps        -0x58(%rsp),%ymm10,%ymm1
  .byte  196,226,37,184,205                  // vfmadd231ps   %ymm5,%ymm11,%ymm1
  .byte  196,193,116,88,201                  // vaddps        %ymm9,%ymm1,%ymm1
  .byte  197,172,89,84,36,200                // vmulps        -0x38(%rsp),%ymm10,%ymm2
  .byte  196,98,77,168,218                   // vfmadd213ps   %ymm2,%ymm6,%ymm11
  .byte  196,193,36,88,208                   // vaddps        %ymm8,%ymm11,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,92,220                  // vsubps        %ymm12,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_color_hsw
.globl _sk_color_hsw
FUNCTION(_sk_color_hsw)
_sk_color_hsw:
  .byte  197,124,40,202                      // vmovaps       %ymm2,%ymm9
  .byte  197,124,17,76,36,200                // vmovups       %ymm9,-0x38(%rsp)
  .byte  197,252,17,76,36,168                // vmovups       %ymm1,-0x58(%rsp)
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  197,108,89,199                      // vmulps        %ymm7,%ymm2,%ymm8
  .byte  197,116,89,215                      // vmulps        %ymm7,%ymm1,%ymm10
  .byte  197,52,89,223                       // vmulps        %ymm7,%ymm9,%ymm11
  .byte  196,98,125,24,45,67,21,3,0          // vbroadcastss  0x31543(%rip),%ymm13        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,98,125,24,53,62,21,3,0          // vbroadcastss  0x3153e(%rip),%ymm14        # 3a23c <_sk_srcover_bgra_8888_sse2_lowp+0x2d4>
  .byte  196,65,84,89,230                    // vmulps        %ymm14,%ymm5,%ymm12
  .byte  196,66,93,184,229                   // vfmadd231ps   %ymm13,%ymm4,%ymm12
  .byte  196,98,125,24,61,47,21,3,0          // vbroadcastss  0x3152f(%rip),%ymm15        # 3a240 <_sk_srcover_bgra_8888_sse2_lowp+0x2d8>
  .byte  196,66,77,184,231                   // vfmadd231ps   %ymm15,%ymm6,%ymm12
  .byte  196,65,44,89,206                    // vmulps        %ymm14,%ymm10,%ymm9
  .byte  196,66,61,184,205                   // vfmadd231ps   %ymm13,%ymm8,%ymm9
  .byte  196,66,37,184,207                   // vfmadd231ps   %ymm15,%ymm11,%ymm9
  .byte  196,66,101,170,225                  // vfmsub213ps   %ymm9,%ymm3,%ymm12
  .byte  196,65,60,88,204                    // vaddps        %ymm12,%ymm8,%ymm9
  .byte  196,65,44,88,212                    // vaddps        %ymm12,%ymm10,%ymm10
  .byte  196,65,36,88,220                    // vaddps        %ymm12,%ymm11,%ymm11
  .byte  196,65,44,93,195                    // vminps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,93,224                    // vminps        %ymm8,%ymm9,%ymm12
  .byte  196,65,44,89,198                    // vmulps        %ymm14,%ymm10,%ymm8
  .byte  196,66,53,184,197                   // vfmadd231ps   %ymm13,%ymm9,%ymm8
  .byte  196,66,37,184,199                   // vfmadd231ps   %ymm15,%ymm11,%ymm8
  .byte  196,65,52,92,232                    // vsubps        %ymm8,%ymm9,%ymm13
  .byte  196,65,60,89,237                    // vmulps        %ymm13,%ymm8,%ymm13
  .byte  196,65,60,92,244                    // vsubps        %ymm12,%ymm8,%ymm14
  .byte  196,193,20,94,198                   // vdivps        %ymm14,%ymm13,%ymm0
  .byte  196,65,44,92,248                    // vsubps        %ymm8,%ymm10,%ymm15
  .byte  196,65,60,89,255                    // vmulps        %ymm15,%ymm8,%ymm15
  .byte  196,65,4,94,254                     // vdivps        %ymm14,%ymm15,%ymm15
  .byte  196,65,36,92,232                    // vsubps        %ymm8,%ymm11,%ymm13
  .byte  196,65,60,89,237                    // vmulps        %ymm13,%ymm8,%ymm13
  .byte  196,65,20,94,238                    // vdivps        %ymm14,%ymm13,%ymm13
  .byte  196,65,12,87,246                    // vxorps        %ymm14,%ymm14,%ymm14
  .byte  196,65,12,194,228,2                 // vcmpleps      %ymm12,%ymm14,%ymm12
  .byte  196,65,60,88,255                    // vaddps        %ymm15,%ymm8,%ymm15
  .byte  196,67,5,74,250,192                 // vblendvps     %ymm12,%ymm10,%ymm15,%ymm15
  .byte  196,65,44,95,211                    // vmaxps        %ymm11,%ymm10,%ymm10
  .byte  196,65,60,88,237                    // vaddps        %ymm13,%ymm8,%ymm13
  .byte  196,67,21,74,219,192                // vblendvps     %ymm12,%ymm11,%ymm13,%ymm11
  .byte  197,188,88,192                      // vaddps        %ymm0,%ymm8,%ymm0
  .byte  196,195,125,74,201,192              // vblendvps     %ymm12,%ymm9,%ymm0,%ymm1
  .byte  197,100,89,231                      // vmulps        %ymm7,%ymm3,%ymm12
  .byte  196,65,52,95,202                    // vmaxps        %ymm10,%ymm9,%ymm9
  .byte  196,65,116,92,208                   // vsubps        %ymm8,%ymm1,%ymm10
  .byte  196,65,28,92,232                    // vsubps        %ymm8,%ymm12,%ymm13
  .byte  196,65,20,89,210                    // vmulps        %ymm10,%ymm13,%ymm10
  .byte  196,193,28,194,193,1                // vcmpltps      %ymm9,%ymm12,%ymm0
  .byte  196,65,52,92,200                    // vsubps        %ymm8,%ymm9,%ymm9
  .byte  196,65,44,94,209                    // vdivps        %ymm9,%ymm10,%ymm10
  .byte  196,65,60,88,210                    // vaddps        %ymm10,%ymm8,%ymm10
  .byte  196,195,117,74,202,0                // vblendvps     %ymm0,%ymm10,%ymm1,%ymm1
  .byte  196,65,4,92,208                     // vsubps        %ymm8,%ymm15,%ymm10
  .byte  196,65,20,89,210                    // vmulps        %ymm10,%ymm13,%ymm10
  .byte  196,65,44,94,209                    // vdivps        %ymm9,%ymm10,%ymm10
  .byte  196,65,60,88,210                    // vaddps        %ymm10,%ymm8,%ymm10
  .byte  196,67,5,74,210,0                   // vblendvps     %ymm0,%ymm10,%ymm15,%ymm10
  .byte  196,65,36,92,248                    // vsubps        %ymm8,%ymm11,%ymm15
  .byte  196,65,20,89,239                    // vmulps        %ymm15,%ymm13,%ymm13
  .byte  196,65,20,94,201                    // vdivps        %ymm9,%ymm13,%ymm9
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  196,195,37,74,192,0                 // vblendvps     %ymm0,%ymm8,%ymm11,%ymm0
  .byte  196,193,116,95,206                  // vmaxps        %ymm14,%ymm1,%ymm1
  .byte  196,65,44,95,198                    // vmaxps        %ymm14,%ymm10,%ymm8
  .byte  196,65,124,95,206                   // vmaxps        %ymm14,%ymm0,%ymm9
  .byte  196,226,125,24,5,229,19,3,0         // vbroadcastss  0x313e5(%rip),%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,124,92,215                      // vsubps        %ymm7,%ymm0,%ymm10
  .byte  197,172,89,210                      // vmulps        %ymm2,%ymm10,%ymm2
  .byte  197,124,92,219                      // vsubps        %ymm3,%ymm0,%ymm11
  .byte  196,226,37,184,212                  // vfmadd231ps   %ymm4,%ymm11,%ymm2
  .byte  197,236,88,193                      // vaddps        %ymm1,%ymm2,%ymm0
  .byte  197,172,89,76,36,168                // vmulps        -0x58(%rsp),%ymm10,%ymm1
  .byte  196,226,37,184,205                  // vfmadd231ps   %ymm5,%ymm11,%ymm1
  .byte  196,193,116,88,200                  // vaddps        %ymm8,%ymm1,%ymm1
  .byte  197,172,89,84,36,200                // vmulps        -0x38(%rsp),%ymm10,%ymm2
  .byte  196,98,77,168,218                   // vfmadd213ps   %ymm2,%ymm6,%ymm11
  .byte  196,193,36,88,209                   // vaddps        %ymm9,%ymm11,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,92,220                  // vsubps        %ymm12,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_luminosity_hsw
.globl _sk_luminosity_hsw
FUNCTION(_sk_luminosity_hsw)
_sk_luminosity_hsw:
  .byte  197,124,40,202                      // vmovaps       %ymm2,%ymm9
  .byte  197,124,17,76,36,168                // vmovups       %ymm9,-0x58(%rsp)
  .byte  197,252,17,76,36,200                // vmovups       %ymm1,-0x38(%rsp)
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  197,100,89,196                      // vmulps        %ymm4,%ymm3,%ymm8
  .byte  197,100,89,213                      // vmulps        %ymm5,%ymm3,%ymm10
  .byte  197,100,89,222                      // vmulps        %ymm6,%ymm3,%ymm11
  .byte  196,98,125,24,45,154,19,3,0         // vbroadcastss  0x3139a(%rip),%ymm13        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,98,125,24,53,149,19,3,0         // vbroadcastss  0x31395(%rip),%ymm14        # 3a23c <_sk_srcover_bgra_8888_sse2_lowp+0x2d4>
  .byte  196,65,116,89,230                   // vmulps        %ymm14,%ymm1,%ymm12
  .byte  196,66,109,184,229                  // vfmadd231ps   %ymm13,%ymm2,%ymm12
  .byte  196,98,125,24,61,134,19,3,0         // vbroadcastss  0x31386(%rip),%ymm15        # 3a240 <_sk_srcover_bgra_8888_sse2_lowp+0x2d8>
  .byte  196,66,53,184,231                   // vfmadd231ps   %ymm15,%ymm9,%ymm12
  .byte  196,65,44,89,206                    // vmulps        %ymm14,%ymm10,%ymm9
  .byte  196,66,61,184,205                   // vfmadd231ps   %ymm13,%ymm8,%ymm9
  .byte  196,66,37,184,207                   // vfmadd231ps   %ymm15,%ymm11,%ymm9
  .byte  196,66,69,170,225                   // vfmsub213ps   %ymm9,%ymm7,%ymm12
  .byte  196,65,60,88,204                    // vaddps        %ymm12,%ymm8,%ymm9
  .byte  196,65,44,88,212                    // vaddps        %ymm12,%ymm10,%ymm10
  .byte  196,65,36,88,220                    // vaddps        %ymm12,%ymm11,%ymm11
  .byte  196,65,44,93,195                    // vminps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,93,224                    // vminps        %ymm8,%ymm9,%ymm12
  .byte  196,65,44,89,198                    // vmulps        %ymm14,%ymm10,%ymm8
  .byte  196,66,53,184,197                   // vfmadd231ps   %ymm13,%ymm9,%ymm8
  .byte  196,66,37,184,199                   // vfmadd231ps   %ymm15,%ymm11,%ymm8
  .byte  196,65,52,92,232                    // vsubps        %ymm8,%ymm9,%ymm13
  .byte  196,65,60,89,237                    // vmulps        %ymm13,%ymm8,%ymm13
  .byte  196,65,60,92,244                    // vsubps        %ymm12,%ymm8,%ymm14
  .byte  196,193,20,94,198                   // vdivps        %ymm14,%ymm13,%ymm0
  .byte  196,65,44,92,248                    // vsubps        %ymm8,%ymm10,%ymm15
  .byte  196,65,60,89,255                    // vmulps        %ymm15,%ymm8,%ymm15
  .byte  196,65,4,94,254                     // vdivps        %ymm14,%ymm15,%ymm15
  .byte  196,65,36,92,232                    // vsubps        %ymm8,%ymm11,%ymm13
  .byte  196,65,60,89,237                    // vmulps        %ymm13,%ymm8,%ymm13
  .byte  196,65,20,94,238                    // vdivps        %ymm14,%ymm13,%ymm13
  .byte  196,65,12,87,246                    // vxorps        %ymm14,%ymm14,%ymm14
  .byte  196,65,12,194,228,2                 // vcmpleps      %ymm12,%ymm14,%ymm12
  .byte  196,65,60,88,255                    // vaddps        %ymm15,%ymm8,%ymm15
  .byte  196,67,5,74,250,192                 // vblendvps     %ymm12,%ymm10,%ymm15,%ymm15
  .byte  196,65,44,95,211                    // vmaxps        %ymm11,%ymm10,%ymm10
  .byte  196,65,60,88,237                    // vaddps        %ymm13,%ymm8,%ymm13
  .byte  196,67,21,74,219,192                // vblendvps     %ymm12,%ymm11,%ymm13,%ymm11
  .byte  197,188,88,192                      // vaddps        %ymm0,%ymm8,%ymm0
  .byte  196,195,125,74,201,192              // vblendvps     %ymm12,%ymm9,%ymm0,%ymm1
  .byte  197,100,89,231                      // vmulps        %ymm7,%ymm3,%ymm12
  .byte  196,65,52,95,202                    // vmaxps        %ymm10,%ymm9,%ymm9
  .byte  196,65,116,92,208                   // vsubps        %ymm8,%ymm1,%ymm10
  .byte  196,65,28,92,232                    // vsubps        %ymm8,%ymm12,%ymm13
  .byte  196,65,20,89,210                    // vmulps        %ymm10,%ymm13,%ymm10
  .byte  196,193,28,194,193,1                // vcmpltps      %ymm9,%ymm12,%ymm0
  .byte  196,65,52,92,200                    // vsubps        %ymm8,%ymm9,%ymm9
  .byte  196,65,44,94,209                    // vdivps        %ymm9,%ymm10,%ymm10
  .byte  196,65,60,88,210                    // vaddps        %ymm10,%ymm8,%ymm10
  .byte  196,195,117,74,202,0                // vblendvps     %ymm0,%ymm10,%ymm1,%ymm1
  .byte  196,65,4,92,208                     // vsubps        %ymm8,%ymm15,%ymm10
  .byte  196,65,20,89,210                    // vmulps        %ymm10,%ymm13,%ymm10
  .byte  196,65,44,94,209                    // vdivps        %ymm9,%ymm10,%ymm10
  .byte  196,65,60,88,210                    // vaddps        %ymm10,%ymm8,%ymm10
  .byte  196,67,5,74,210,0                   // vblendvps     %ymm0,%ymm10,%ymm15,%ymm10
  .byte  196,65,36,92,248                    // vsubps        %ymm8,%ymm11,%ymm15
  .byte  196,65,20,89,239                    // vmulps        %ymm15,%ymm13,%ymm13
  .byte  196,65,20,94,201                    // vdivps        %ymm9,%ymm13,%ymm9
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  196,195,37,74,192,0                 // vblendvps     %ymm0,%ymm8,%ymm11,%ymm0
  .byte  196,193,116,95,206                  // vmaxps        %ymm14,%ymm1,%ymm1
  .byte  196,65,44,95,198                    // vmaxps        %ymm14,%ymm10,%ymm8
  .byte  196,65,124,95,206                   // vmaxps        %ymm14,%ymm0,%ymm9
  .byte  196,226,125,24,5,60,18,3,0          // vbroadcastss  0x3123c(%rip),%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,124,92,215                      // vsubps        %ymm7,%ymm0,%ymm10
  .byte  197,172,89,210                      // vmulps        %ymm2,%ymm10,%ymm2
  .byte  197,124,92,219                      // vsubps        %ymm3,%ymm0,%ymm11
  .byte  196,226,37,184,212                  // vfmadd231ps   %ymm4,%ymm11,%ymm2
  .byte  197,236,88,193                      // vaddps        %ymm1,%ymm2,%ymm0
  .byte  197,172,89,76,36,200                // vmulps        -0x38(%rsp),%ymm10,%ymm1
  .byte  196,226,37,184,205                  // vfmadd231ps   %ymm5,%ymm11,%ymm1
  .byte  196,193,116,88,200                  // vaddps        %ymm8,%ymm1,%ymm1
  .byte  197,172,89,84,36,168                // vmulps        -0x58(%rsp),%ymm10,%ymm2
  .byte  196,98,77,168,218                   // vfmadd213ps   %ymm2,%ymm6,%ymm11
  .byte  196,193,36,88,209                   // vaddps        %ymm9,%ymm11,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,92,220                  // vsubps        %ymm12,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_rgba_8888_hsw
.globl _sk_srcover_rgba_8888_hsw
FUNCTION(_sk_srcover_rgba_8888_hsw)
_sk_srcover_rgba_8888_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,224,0,0,0                    // jne           911e <_sk_srcover_rgba_8888_hsw+0x100>
  .byte  196,129,126,111,60,152              // vmovdqu       (%r8,%r11,4),%ymm7
  .byte  197,197,219,37,180,19,3,0           // vpand         0x313b4(%rip),%ymm7,%ymm4        # 3a400 <_sk_srcover_bgra_8888_sse2_lowp+0x498>
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,226,69,0,45,199,19,3,0          // vpshufb       0x313c7(%rip),%ymm7,%ymm5        # 3a420 <_sk_srcover_bgra_8888_sse2_lowp+0x4b8>
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  196,226,69,0,53,218,19,3,0          // vpshufb       0x313da(%rip),%ymm7,%ymm6        # 3a440 <_sk_srcover_bgra_8888_sse2_lowp+0x4d8>
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,252,91,246                      // vcvtdq2ps     %ymm6,%ymm6
  .byte  197,197,114,215,24                  // vpsrld        $0x18,%ymm7,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,98,125,24,13,151,17,3,0         // vbroadcastss  0x31197(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,52,92,203                       // vsubps        %ymm3,%ymm9,%ymm9
  .byte  196,98,125,24,21,182,17,3,0         // vbroadcastss  0x311b6(%rip),%ymm10        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,193,124,89,194                  // vmulps        %ymm10,%ymm0,%ymm0
  .byte  196,194,93,184,193                  // vfmadd231ps   %ymm9,%ymm4,%ymm0
  .byte  196,193,116,89,202                  // vmulps        %ymm10,%ymm1,%ymm1
  .byte  196,194,85,184,201                  // vfmadd231ps   %ymm9,%ymm5,%ymm1
  .byte  196,193,108,89,210                  // vmulps        %ymm10,%ymm2,%ymm2
  .byte  196,194,77,184,209                  // vfmadd231ps   %ymm9,%ymm6,%ymm2
  .byte  196,193,100,89,218                  // vmulps        %ymm10,%ymm3,%ymm3
  .byte  196,194,69,184,217                  // vfmadd231ps   %ymm9,%ymm7,%ymm3
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  197,60,95,217                       // vmaxps        %ymm1,%ymm8,%ymm11
  .byte  196,65,36,93,218                    // vminps        %ymm10,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,193,37,114,243,8                // vpslld        $0x8,%ymm11,%ymm11
  .byte  196,65,37,235,201                   // vpor          %ymm9,%ymm11,%ymm9
  .byte  197,60,95,218                       // vmaxps        %ymm2,%ymm8,%ymm11
  .byte  196,65,36,93,218                    // vminps        %ymm10,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,193,37,114,243,16               // vpslld        $0x10,%ymm11,%ymm11
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,193,61,114,240,24               // vpslld        $0x18,%ymm8,%ymm8
  .byte  196,65,37,235,192                   // vpor          %ymm8,%ymm11,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,65                              // jne           9155 <_sk_srcover_rgba_8888_hsw+0x137>
  .byte  196,1,126,127,4,152                 // vmovdqu       %ymm8,(%r8,%r11,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,14,255,255,255               // ja            9044 <_sk_srcover_rgba_8888_hsw+0x26>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,255,0,0,0                 // lea           0xff(%rip),%r10        # 9240 <_sk_srcover_rgba_8888_hsw+0x222>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,60,152              // vmovd         (%r8,%r11,4),%xmm7
  .byte  233,239,254,255,255                 // jmpq          9044 <_sk_srcover_rgba_8888_hsw+0x26>
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,181                             // ja            911a <_sk_srcover_rgba_8888_hsw+0xfc>
  .byte  65,15,182,193                       // movzbl        %r9b,%eax
  .byte  76,141,13,236,0,0,0                 // lea           0xec(%rip),%r9        # 925c <_sk_srcover_rgba_8888_hsw+0x23e>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,121,126,4,152                 // vmovd         %xmm8,(%r8,%r11,4)
  .byte  235,153                             // jmp           911a <_sk_srcover_rgba_8888_hsw+0xfc>
  .byte  196,129,121,110,100,152,8           // vmovd         0x8(%r8,%r11,4),%xmm4
  .byte  196,226,121,89,228                  // vpbroadcastq  %xmm4,%xmm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,252,4                  // vpblendd      $0x4,%ymm4,%ymm5,%ymm7
  .byte  196,129,122,126,36,152              // vmovq         (%r8,%r11,4),%xmm4
  .byte  196,227,69,2,252,3                  // vpblendd      $0x3,%ymm4,%ymm7,%ymm7
  .byte  233,156,254,255,255                 // jmpq          9044 <_sk_srcover_rgba_8888_hsw+0x26>
  .byte  196,129,121,110,100,152,24          // vmovd         0x18(%r8,%r11,4),%xmm4
  .byte  196,226,125,89,228                  // vpbroadcastq  %xmm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,252,64                 // vpblendd      $0x40,%ymm4,%ymm5,%ymm7
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,129,122,111,36,152              // vmovdqu       (%r8,%r11,4),%xmm4
  .byte  196,227,93,2,255,240                // vpblendd      $0xf0,%ymm7,%ymm4,%ymm7
  .byte  233,77,254,255,255                  // jmpq          9044 <_sk_srcover_rgba_8888_hsw+0x26>
  .byte  196,3,121,22,68,152,8,2             // vpextrd       $0x2,%xmm8,0x8(%r8,%r11,4)
  .byte  196,1,121,214,4,152                 // vmovq         %xmm8,(%r8,%r11,4)
  .byte  233,16,255,255,255                  // jmpq          911a <_sk_srcover_rgba_8888_hsw+0xfc>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,24,2            // vpextrd       $0x2,%xmm9,0x18(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,20,1            // vpextrd       $0x1,%xmm9,0x14(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,1,121,126,76,152,16             // vmovd         %xmm9,0x10(%r8,%r11,4)
  .byte  196,1,122,127,4,152                 // vmovdqu       %xmm8,(%r8,%r11,4)
  .byte  233,220,254,255,255                 // jmpq          911a <_sk_srcover_rgba_8888_hsw+0xfc>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  10,255                              // or            %bh,%bh
  .byte  255                                 // (bad)
  .byte  255,87,255                          // callq         *-0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255,65,255                          // incl          -0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,166,255,255,255,146             // jmpq          *-0x6d000001(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  126,255                             // jle           9255 <_sk_srcover_rgba_8888_hsw+0x237>
  .byte  255                                 // (bad)
  .byte  255,104,255                         // ljmp          *-0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,29,255,255,255,163              // lcall         *-0x5c000001(%rip)        # ffffffffa4009260 <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffa3fcf2f8>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,155,255,255,255,215             // lcall         *-0x28000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,202                             // dec           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  188,255,255,255,174                 // mov           $0xaeffffff,%esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_srcover_bgra_8888_hsw
.globl _sk_srcover_bgra_8888_hsw
FUNCTION(_sk_srcover_bgra_8888_hsw)
_sk_srcover_bgra_8888_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,224,0,0,0                    // jne           9378 <_sk_srcover_bgra_8888_hsw+0x100>
  .byte  196,129,126,111,60,152              // vmovdqu       (%r8,%r11,4),%ymm7
  .byte  197,197,219,37,186,17,3,0           // vpand         0x311ba(%rip),%ymm7,%ymm4        # 3a460 <_sk_srcover_bgra_8888_sse2_lowp+0x4f8>
  .byte  197,252,91,244                      // vcvtdq2ps     %ymm4,%ymm6
  .byte  196,226,69,0,37,205,17,3,0          // vpshufb       0x311cd(%rip),%ymm7,%ymm4        # 3a480 <_sk_srcover_bgra_8888_sse2_lowp+0x518>
  .byte  197,252,91,236                      // vcvtdq2ps     %ymm4,%ymm5
  .byte  196,226,69,0,37,224,17,3,0          // vpshufb       0x311e0(%rip),%ymm7,%ymm4        # 3a4a0 <_sk_srcover_bgra_8888_sse2_lowp+0x538>
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  197,197,114,215,24                  // vpsrld        $0x18,%ymm7,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,98,125,24,13,61,15,3,0          // vbroadcastss  0x30f3d(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,52,92,203                       // vsubps        %ymm3,%ymm9,%ymm9
  .byte  196,98,125,24,21,92,15,3,0          // vbroadcastss  0x30f5c(%rip),%ymm10        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,193,124,89,194                  // vmulps        %ymm10,%ymm0,%ymm0
  .byte  196,194,93,184,193                  // vfmadd231ps   %ymm9,%ymm4,%ymm0
  .byte  196,193,116,89,202                  // vmulps        %ymm10,%ymm1,%ymm1
  .byte  196,194,85,184,201                  // vfmadd231ps   %ymm9,%ymm5,%ymm1
  .byte  196,193,108,89,210                  // vmulps        %ymm10,%ymm2,%ymm2
  .byte  196,194,77,184,209                  // vfmadd231ps   %ymm9,%ymm6,%ymm2
  .byte  196,193,100,89,218                  // vmulps        %ymm10,%ymm3,%ymm3
  .byte  196,194,69,184,217                  // vfmadd231ps   %ymm9,%ymm7,%ymm3
  .byte  197,60,95,202                       // vmaxps        %ymm2,%ymm8,%ymm9
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  197,60,95,217                       // vmaxps        %ymm1,%ymm8,%ymm11
  .byte  196,65,36,93,218                    // vminps        %ymm10,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,193,37,114,243,8                // vpslld        $0x8,%ymm11,%ymm11
  .byte  196,65,37,235,201                   // vpor          %ymm9,%ymm11,%ymm9
  .byte  197,60,95,216                       // vmaxps        %ymm0,%ymm8,%ymm11
  .byte  196,65,36,93,218                    // vminps        %ymm10,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,193,37,114,243,16               // vpslld        $0x10,%ymm11,%ymm11
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,193,61,114,240,24               // vpslld        $0x18,%ymm8,%ymm8
  .byte  196,65,37,235,192                   // vpor          %ymm8,%ymm11,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,65                              // jne           93af <_sk_srcover_bgra_8888_hsw+0x137>
  .byte  196,1,126,127,4,152                 // vmovdqu       %ymm8,(%r8,%r11,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,14,255,255,255               // ja            929e <_sk_srcover_bgra_8888_hsw+0x26>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,253,0,0,0                 // lea           0xfd(%rip),%r10        # 9498 <_sk_srcover_bgra_8888_hsw+0x220>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,60,152              // vmovd         (%r8,%r11,4),%xmm7
  .byte  233,239,254,255,255                 // jmpq          929e <_sk_srcover_bgra_8888_hsw+0x26>
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,181                             // ja            9374 <_sk_srcover_bgra_8888_hsw+0xfc>
  .byte  65,15,182,193                       // movzbl        %r9b,%eax
  .byte  76,141,13,234,0,0,0                 // lea           0xea(%rip),%r9        # 94b4 <_sk_srcover_bgra_8888_hsw+0x23c>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,121,126,4,152                 // vmovd         %xmm8,(%r8,%r11,4)
  .byte  235,153                             // jmp           9374 <_sk_srcover_bgra_8888_hsw+0xfc>
  .byte  196,129,121,110,100,152,8           // vmovd         0x8(%r8,%r11,4),%xmm4
  .byte  196,226,121,89,228                  // vpbroadcastq  %xmm4,%xmm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,252,4                  // vpblendd      $0x4,%ymm4,%ymm5,%ymm7
  .byte  196,129,122,126,36,152              // vmovq         (%r8,%r11,4),%xmm4
  .byte  196,227,69,2,252,3                  // vpblendd      $0x3,%ymm4,%ymm7,%ymm7
  .byte  233,156,254,255,255                 // jmpq          929e <_sk_srcover_bgra_8888_hsw+0x26>
  .byte  196,129,121,110,100,152,24          // vmovd         0x18(%r8,%r11,4),%xmm4
  .byte  196,226,125,89,228                  // vpbroadcastq  %xmm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,252,64                 // vpblendd      $0x40,%ymm4,%ymm5,%ymm7
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,129,122,111,36,152              // vmovdqu       (%r8,%r11,4),%xmm4
  .byte  196,227,93,2,255,240                // vpblendd      $0xf0,%ymm7,%ymm4,%ymm7
  .byte  233,77,254,255,255                  // jmpq          929e <_sk_srcover_bgra_8888_hsw+0x26>
  .byte  196,3,121,22,68,152,8,2             // vpextrd       $0x2,%xmm8,0x8(%r8,%r11,4)
  .byte  196,1,121,214,4,152                 // vmovq         %xmm8,(%r8,%r11,4)
  .byte  233,16,255,255,255                  // jmpq          9374 <_sk_srcover_bgra_8888_hsw+0xfc>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,24,2            // vpextrd       $0x2,%xmm9,0x18(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,20,1            // vpextrd       $0x1,%xmm9,0x14(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,1,121,126,76,152,16             // vmovd         %xmm9,0x10(%r8,%r11,4)
  .byte  196,1,122,127,4,152                 // vmovdqu       %xmm8,(%r8,%r11,4)
  .byte  233,220,254,255,255                 // jmpq          9374 <_sk_srcover_bgra_8888_hsw+0xfc>
  .byte  12,255                              // or            $0xff,%al
  .byte  255                                 // (bad)
  .byte  255,89,255                          // lcall         *-0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,67,255                          // incl          -0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,168,255,255,255,148             // ljmp          *-0x6b000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,128,255,255,255,106             // incl          0x6affffff(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,31                              // lcall         *(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,165,255,255,255,157             // jmpq          *-0x62000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  217,255                             // fcos
  .byte  255                                 // (bad)
  .byte  255,204                             // dec           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  190,255,255,255,176                 // mov           $0xb0ffffff,%esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_clamp_0_hsw
.globl _sk_clamp_0_hsw
FUNCTION(_sk_clamp_0_hsw)
_sk_clamp_0_hsw:
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,193,124,95,192                  // vmaxps        %ymm8,%ymm0,%ymm0
  .byte  196,193,116,95,200                  // vmaxps        %ymm8,%ymm1,%ymm1
  .byte  196,193,108,95,208                  // vmaxps        %ymm8,%ymm2,%ymm2
  .byte  196,193,100,95,216                  // vmaxps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_1_hsw
.globl _sk_clamp_1_hsw
FUNCTION(_sk_clamp_1_hsw)
_sk_clamp_1_hsw:
  .byte  196,98,125,24,5,34,13,3,0           // vbroadcastss  0x30d22(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  196,193,108,93,208                  // vminps        %ymm8,%ymm2,%ymm2
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_hsw
.globl _sk_clamp_a_hsw
FUNCTION(_sk_clamp_a_hsw)
_sk_clamp_a_hsw:
  .byte  196,98,125,24,5,1,13,3,0            // vbroadcastss  0x30d01(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  197,252,93,195                      // vminps        %ymm3,%ymm0,%ymm0
  .byte  197,244,93,203                      // vminps        %ymm3,%ymm1,%ymm1
  .byte  197,236,93,211                      // vminps        %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_dst_hsw
.globl _sk_clamp_a_dst_hsw
FUNCTION(_sk_clamp_a_dst_hsw)
_sk_clamp_a_dst_hsw:
  .byte  196,98,125,24,5,227,12,3,0          // vbroadcastss  0x30ce3(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,68,93,248                   // vminps        %ymm8,%ymm7,%ymm7
  .byte  197,220,93,231                      // vminps        %ymm7,%ymm4,%ymm4
  .byte  197,212,93,239                      // vminps        %ymm7,%ymm5,%ymm5
  .byte  197,204,93,247                      // vminps        %ymm7,%ymm6,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_set_rgb_hsw
.globl _sk_set_rgb_hsw
FUNCTION(_sk_set_rgb_hsw)
_sk_set_rgb_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,0                    // vbroadcastss  (%rax),%ymm0
  .byte  196,226,125,24,72,4                 // vbroadcastss  0x4(%rax),%ymm1
  .byte  196,226,125,24,80,8                 // vbroadcastss  0x8(%rax),%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_swap_rb_hsw
.globl _sk_swap_rb_hsw
FUNCTION(_sk_swap_rb_hsw)
_sk_swap_rb_hsw:
  .byte  197,124,40,192                      // vmovaps       %ymm0,%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,194                      // vmovaps       %ymm2,%ymm0
  .byte  197,124,41,194                      // vmovaps       %ymm8,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_invert_hsw
.globl _sk_invert_hsw
FUNCTION(_sk_invert_hsw)
_sk_invert_hsw:
  .byte  196,98,125,24,5,158,12,3,0          // vbroadcastss  0x30c9e(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  197,188,92,219                      // vsubps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_src_dst_hsw
.globl _sk_move_src_dst_hsw
FUNCTION(_sk_move_src_dst_hsw)
_sk_move_src_dst_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,224                      // vmovaps       %ymm0,%ymm4
  .byte  197,252,40,233                      // vmovaps       %ymm1,%ymm5
  .byte  197,252,40,242                      // vmovaps       %ymm2,%ymm6
  .byte  197,252,40,251                      // vmovaps       %ymm3,%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_dst_src_hsw
.globl _sk_move_dst_src_hsw
FUNCTION(_sk_move_dst_src_hsw)
_sk_move_dst_src_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,196                      // vmovaps       %ymm4,%ymm0
  .byte  197,252,40,205                      // vmovaps       %ymm5,%ymm1
  .byte  197,252,40,214                      // vmovaps       %ymm6,%ymm2
  .byte  197,252,40,223                      // vmovaps       %ymm7,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_hsw
.globl _sk_premul_hsw
FUNCTION(_sk_premul_hsw)
_sk_premul_hsw:
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  197,244,89,203                      // vmulps        %ymm3,%ymm1,%ymm1
  .byte  197,236,89,211                      // vmulps        %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_dst_hsw
.globl _sk_premul_dst_hsw
FUNCTION(_sk_premul_dst_hsw)
_sk_premul_dst_hsw:
  .byte  197,220,89,231                      // vmulps        %ymm7,%ymm4,%ymm4
  .byte  197,212,89,239                      // vmulps        %ymm7,%ymm5,%ymm5
  .byte  197,204,89,247                      // vmulps        %ymm7,%ymm6,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_unpremul_hsw
.globl _sk_unpremul_hsw
FUNCTION(_sk_unpremul_hsw)
_sk_unpremul_hsw:
  .byte  196,98,125,24,5,57,12,3,0           // vbroadcastss  0x30c39(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,94,195                       // vdivps        %ymm3,%ymm8,%ymm8
  .byte  196,98,125,24,13,92,12,3,0          // vbroadcastss  0x30c5c(%rip),%ymm9        # 3a248 <_sk_srcover_bgra_8888_sse2_lowp+0x2e0>
  .byte  196,65,60,194,201,1                 // vcmpltps      %ymm9,%ymm8,%ymm9
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,67,45,74,192,144                // vblendvps     %ymm9,%ymm8,%ymm10,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_from_srgb_hsw
.globl _sk_from_srgb_hsw
FUNCTION(_sk_from_srgb_hsw)
_sk_from_srgb_hsw:
  .byte  196,98,125,24,5,54,12,3,0           // vbroadcastss  0x30c36(%rip),%ymm8        # 3a24c <_sk_srcover_bgra_8888_sse2_lowp+0x2e4>
  .byte  196,65,124,89,200                   // vmulps        %ymm8,%ymm0,%ymm9
  .byte  197,124,89,208                      // vmulps        %ymm0,%ymm0,%ymm10
  .byte  196,98,125,24,29,40,12,3,0          // vbroadcastss  0x30c28(%rip),%ymm11        # 3a250 <_sk_srcover_bgra_8888_sse2_lowp+0x2e8>
  .byte  196,98,125,24,37,7,12,3,0           // vbroadcastss  0x30c07(%rip),%ymm12        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,65,124,40,236                   // vmovaps       %ymm12,%ymm13
  .byte  196,66,125,168,235                  // vfmadd213ps   %ymm11,%ymm0,%ymm13
  .byte  196,98,125,24,53,16,12,3,0          // vbroadcastss  0x30c10(%rip),%ymm14        # 3a254 <_sk_srcover_bgra_8888_sse2_lowp+0x2ec>
  .byte  196,66,45,168,238                   // vfmadd213ps   %ymm14,%ymm10,%ymm13
  .byte  196,98,125,24,21,6,12,3,0           // vbroadcastss  0x30c06(%rip),%ymm10        # 3a258 <_sk_srcover_bgra_8888_sse2_lowp+0x2f0>
  .byte  196,193,124,194,194,1               // vcmpltps      %ymm10,%ymm0,%ymm0
  .byte  196,195,21,74,193,0                 // vblendvps     %ymm0,%ymm9,%ymm13,%ymm0
  .byte  196,65,116,89,200                   // vmulps        %ymm8,%ymm1,%ymm9
  .byte  197,116,89,233                      // vmulps        %ymm1,%ymm1,%ymm13
  .byte  196,65,124,40,252                   // vmovaps       %ymm12,%ymm15
  .byte  196,66,117,168,251                  // vfmadd213ps   %ymm11,%ymm1,%ymm15
  .byte  196,66,21,168,254                   // vfmadd213ps   %ymm14,%ymm13,%ymm15
  .byte  196,193,116,194,202,1               // vcmpltps      %ymm10,%ymm1,%ymm1
  .byte  196,195,5,74,201,16                 // vblendvps     %ymm1,%ymm9,%ymm15,%ymm1
  .byte  196,65,108,89,192                   // vmulps        %ymm8,%ymm2,%ymm8
  .byte  197,108,89,202                      // vmulps        %ymm2,%ymm2,%ymm9
  .byte  196,66,109,168,227                  // vfmadd213ps   %ymm11,%ymm2,%ymm12
  .byte  196,66,53,168,230                   // vfmadd213ps   %ymm14,%ymm9,%ymm12
  .byte  196,193,108,194,210,1               // vcmpltps      %ymm10,%ymm2,%ymm2
  .byte  196,195,29,74,208,32                // vblendvps     %ymm2,%ymm8,%ymm12,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_from_srgb_dst_hsw
.globl _sk_from_srgb_dst_hsw
FUNCTION(_sk_from_srgb_dst_hsw)
_sk_from_srgb_dst_hsw:
  .byte  196,98,125,24,5,158,11,3,0          // vbroadcastss  0x30b9e(%rip),%ymm8        # 3a24c <_sk_srcover_bgra_8888_sse2_lowp+0x2e4>
  .byte  196,65,92,89,200                    // vmulps        %ymm8,%ymm4,%ymm9
  .byte  197,92,89,212                       // vmulps        %ymm4,%ymm4,%ymm10
  .byte  196,98,125,24,29,144,11,3,0         // vbroadcastss  0x30b90(%rip),%ymm11        # 3a250 <_sk_srcover_bgra_8888_sse2_lowp+0x2e8>
  .byte  196,98,125,24,37,111,11,3,0         // vbroadcastss  0x30b6f(%rip),%ymm12        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,65,124,40,236                   // vmovaps       %ymm12,%ymm13
  .byte  196,66,93,168,235                   // vfmadd213ps   %ymm11,%ymm4,%ymm13
  .byte  196,98,125,24,53,120,11,3,0         // vbroadcastss  0x30b78(%rip),%ymm14        # 3a254 <_sk_srcover_bgra_8888_sse2_lowp+0x2ec>
  .byte  196,66,45,168,238                   // vfmadd213ps   %ymm14,%ymm10,%ymm13
  .byte  196,98,125,24,21,110,11,3,0         // vbroadcastss  0x30b6e(%rip),%ymm10        # 3a258 <_sk_srcover_bgra_8888_sse2_lowp+0x2f0>
  .byte  196,193,92,194,226,1                // vcmpltps      %ymm10,%ymm4,%ymm4
  .byte  196,195,21,74,225,64                // vblendvps     %ymm4,%ymm9,%ymm13,%ymm4
  .byte  196,65,84,89,200                    // vmulps        %ymm8,%ymm5,%ymm9
  .byte  197,84,89,237                       // vmulps        %ymm5,%ymm5,%ymm13
  .byte  196,65,124,40,252                   // vmovaps       %ymm12,%ymm15
  .byte  196,66,85,168,251                   // vfmadd213ps   %ymm11,%ymm5,%ymm15
  .byte  196,66,21,168,254                   // vfmadd213ps   %ymm14,%ymm13,%ymm15
  .byte  196,193,84,194,234,1                // vcmpltps      %ymm10,%ymm5,%ymm5
  .byte  196,195,5,74,233,80                 // vblendvps     %ymm5,%ymm9,%ymm15,%ymm5
  .byte  196,65,76,89,192                    // vmulps        %ymm8,%ymm6,%ymm8
  .byte  197,76,89,206                       // vmulps        %ymm6,%ymm6,%ymm9
  .byte  196,66,77,168,227                   // vfmadd213ps   %ymm11,%ymm6,%ymm12
  .byte  196,66,53,168,230                   // vfmadd213ps   %ymm14,%ymm9,%ymm12
  .byte  196,193,76,194,242,1                // vcmpltps      %ymm10,%ymm6,%ymm6
  .byte  196,195,29,74,240,96                // vblendvps     %ymm6,%ymm8,%ymm12,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_to_srgb_hsw
.globl _sk_to_srgb_hsw
FUNCTION(_sk_to_srgb_hsw)
_sk_to_srgb_hsw:
  .byte  197,124,82,200                      // vrsqrtps      %ymm0,%ymm9
  .byte  196,98,125,24,5,18,11,3,0           // vbroadcastss  0x30b12(%rip),%ymm8        # 3a25c <_sk_srcover_bgra_8888_sse2_lowp+0x2f4>
  .byte  196,65,124,89,208                   // vmulps        %ymm8,%ymm0,%ymm10
  .byte  196,98,125,24,29,8,11,3,0           // vbroadcastss  0x30b08(%rip),%ymm11        # 3a260 <_sk_srcover_bgra_8888_sse2_lowp+0x2f8>
  .byte  196,98,125,24,37,3,11,3,0           // vbroadcastss  0x30b03(%rip),%ymm12        # 3a264 <_sk_srcover_bgra_8888_sse2_lowp+0x2fc>
  .byte  196,65,124,40,236                   // vmovaps       %ymm12,%ymm13
  .byte  196,66,53,168,235                   // vfmadd213ps   %ymm11,%ymm9,%ymm13
  .byte  196,98,125,24,53,36,12,3,0          // vbroadcastss  0x30c24(%rip),%ymm14        # 3a398 <_sk_srcover_bgra_8888_sse2_lowp+0x430>
  .byte  196,66,53,168,238                   // vfmadd213ps   %ymm14,%ymm9,%ymm13
  .byte  196,98,125,24,61,26,12,3,0          // vbroadcastss  0x30c1a(%rip),%ymm15        # 3a39c <_sk_srcover_bgra_8888_sse2_lowp+0x434>
  .byte  196,65,52,88,207                    // vaddps        %ymm15,%ymm9,%ymm9
  .byte  196,65,124,83,201                   // vrcpps        %ymm9,%ymm9
  .byte  196,65,20,89,201                    // vmulps        %ymm9,%ymm13,%ymm9
  .byte  196,98,125,24,45,214,10,3,0         // vbroadcastss  0x30ad6(%rip),%ymm13        # 3a270 <_sk_srcover_bgra_8888_sse2_lowp+0x308>
  .byte  196,193,124,194,197,1               // vcmpltps      %ymm13,%ymm0,%ymm0
  .byte  196,195,53,74,194,0                 // vblendvps     %ymm0,%ymm10,%ymm9,%ymm0
  .byte  197,124,82,201                      // vrsqrtps      %ymm1,%ymm9
  .byte  196,65,124,40,212                   // vmovaps       %ymm12,%ymm10
  .byte  196,66,53,168,211                   // vfmadd213ps   %ymm11,%ymm9,%ymm10
  .byte  196,66,53,168,214                   // vfmadd213ps   %ymm14,%ymm9,%ymm10
  .byte  196,65,52,88,207                    // vaddps        %ymm15,%ymm9,%ymm9
  .byte  196,65,124,83,201                   // vrcpps        %ymm9,%ymm9
  .byte  196,65,44,89,201                    // vmulps        %ymm9,%ymm10,%ymm9
  .byte  196,65,116,89,208                   // vmulps        %ymm8,%ymm1,%ymm10
  .byte  196,193,116,194,205,1               // vcmpltps      %ymm13,%ymm1,%ymm1
  .byte  196,195,53,74,202,16                // vblendvps     %ymm1,%ymm10,%ymm9,%ymm1
  .byte  197,124,82,202                      // vrsqrtps      %ymm2,%ymm9
  .byte  196,66,53,168,227                   // vfmadd213ps   %ymm11,%ymm9,%ymm12
  .byte  196,66,53,168,230                   // vfmadd213ps   %ymm14,%ymm9,%ymm12
  .byte  196,65,52,88,207                    // vaddps        %ymm15,%ymm9,%ymm9
  .byte  196,65,124,83,201                   // vrcpps        %ymm9,%ymm9
  .byte  196,65,28,89,201                    // vmulps        %ymm9,%ymm12,%ymm9
  .byte  196,65,108,89,192                   // vmulps        %ymm8,%ymm2,%ymm8
  .byte  196,193,108,194,213,1               // vcmpltps      %ymm13,%ymm2,%ymm2
  .byte  196,195,53,74,208,32                // vblendvps     %ymm2,%ymm8,%ymm9,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_rgb_to_hsl_hsw
.globl _sk_rgb_to_hsl_hsw
FUNCTION(_sk_rgb_to_hsl_hsw)
_sk_rgb_to_hsl_hsw:
  .byte  197,116,95,194                      // vmaxps        %ymm2,%ymm1,%ymm8
  .byte  196,65,124,95,192                   // vmaxps        %ymm8,%ymm0,%ymm8
  .byte  197,116,93,202                      // vminps        %ymm2,%ymm1,%ymm9
  .byte  196,65,124,93,201                   // vminps        %ymm9,%ymm0,%ymm9
  .byte  196,65,60,92,209                    // vsubps        %ymm9,%ymm8,%ymm10
  .byte  196,98,125,24,29,237,9,3,0          // vbroadcastss  0x309ed(%rip),%ymm11        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,36,94,218                    // vdivps        %ymm10,%ymm11,%ymm11
  .byte  197,116,92,226                      // vsubps        %ymm2,%ymm1,%ymm12
  .byte  197,116,194,234,1                   // vcmpltps      %ymm2,%ymm1,%ymm13
  .byte  196,98,125,24,53,50,10,3,0          // vbroadcastss  0x30a32(%rip),%ymm14        # 3a274 <_sk_srcover_bgra_8888_sse2_lowp+0x30c>
  .byte  196,65,4,87,255                     // vxorps        %ymm15,%ymm15,%ymm15
  .byte  196,67,5,74,238,208                 // vblendvps     %ymm13,%ymm14,%ymm15,%ymm13
  .byte  196,66,37,168,229                   // vfmadd213ps   %ymm13,%ymm11,%ymm12
  .byte  197,236,92,208                      // vsubps        %ymm0,%ymm2,%ymm2
  .byte  197,124,92,233                      // vsubps        %ymm1,%ymm0,%ymm13
  .byte  196,98,125,24,53,25,10,3,0          // vbroadcastss  0x30a19(%rip),%ymm14        # 3a27c <_sk_srcover_bgra_8888_sse2_lowp+0x314>
  .byte  196,66,37,168,238                   // vfmadd213ps   %ymm14,%ymm11,%ymm13
  .byte  196,98,125,24,53,7,10,3,0           // vbroadcastss  0x30a07(%rip),%ymm14        # 3a278 <_sk_srcover_bgra_8888_sse2_lowp+0x310>
  .byte  196,194,37,168,214                  // vfmadd213ps   %ymm14,%ymm11,%ymm2
  .byte  197,188,194,201,0                   // vcmpeqps      %ymm1,%ymm8,%ymm1
  .byte  196,227,21,74,202,16                // vblendvps     %ymm1,%ymm2,%ymm13,%ymm1
  .byte  197,188,194,192,0                   // vcmpeqps      %ymm0,%ymm8,%ymm0
  .byte  196,195,117,74,196,0                // vblendvps     %ymm0,%ymm12,%ymm1,%ymm0
  .byte  196,193,60,88,201                   // vaddps        %ymm9,%ymm8,%ymm1
  .byte  196,98,125,24,29,122,9,3,0          // vbroadcastss  0x3097a(%rip),%ymm11        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,193,116,89,211                  // vmulps        %ymm11,%ymm1,%ymm2
  .byte  197,36,194,218,1                    // vcmpltps      %ymm2,%ymm11,%ymm11
  .byte  196,65,12,92,224                    // vsubps        %ymm8,%ymm14,%ymm12
  .byte  196,65,28,92,225                    // vsubps        %ymm9,%ymm12,%ymm12
  .byte  196,195,117,74,204,176              // vblendvps     %ymm11,%ymm12,%ymm1,%ymm1
  .byte  196,65,60,194,193,0                 // vcmpeqps      %ymm9,%ymm8,%ymm8
  .byte  197,172,94,201                      // vdivps        %ymm1,%ymm10,%ymm1
  .byte  196,195,125,74,199,128              // vblendvps     %ymm8,%ymm15,%ymm0,%ymm0
  .byte  196,195,117,74,207,128              // vblendvps     %ymm8,%ymm15,%ymm1,%ymm1
  .byte  196,98,125,24,5,173,9,3,0           // vbroadcastss  0x309ad(%rip),%ymm8        # 3a280 <_sk_srcover_bgra_8888_sse2_lowp+0x318>
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hsl_to_rgb_hsw
.globl _sk_hsl_to_rgb_hsw
FUNCTION(_sk_hsl_to_rgb_hsw)
_sk_hsl_to_rgb_hsw:
  .byte  72,131,236,56                       // sub           $0x38,%rsp
  .byte  197,252,17,60,36                    // vmovups       %ymm7,(%rsp)
  .byte  197,252,17,116,36,224               // vmovups       %ymm6,-0x20(%rsp)
  .byte  197,252,17,108,36,192               // vmovups       %ymm5,-0x40(%rsp)
  .byte  197,252,17,100,36,160               // vmovups       %ymm4,-0x60(%rsp)
  .byte  197,252,17,92,36,128                // vmovups       %ymm3,-0x80(%rsp)
  .byte  197,252,40,233                      // vmovaps       %ymm1,%ymm5
  .byte  197,252,40,224                      // vmovaps       %ymm0,%ymm4
  .byte  196,98,125,24,5,6,9,3,0             // vbroadcastss  0x30906(%rip),%ymm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,60,194,202,2                    // vcmpleps      %ymm2,%ymm8,%ymm9
  .byte  197,84,89,210                       // vmulps        %ymm2,%ymm5,%ymm10
  .byte  196,65,84,92,218                    // vsubps        %ymm10,%ymm5,%ymm11
  .byte  196,67,45,74,203,144                // vblendvps     %ymm9,%ymm11,%ymm10,%ymm9
  .byte  197,52,88,210                       // vaddps        %ymm2,%ymm9,%ymm10
  .byte  196,98,125,24,13,73,9,3,0           // vbroadcastss  0x30949(%rip),%ymm9        # 3a278 <_sk_srcover_bgra_8888_sse2_lowp+0x310>
  .byte  196,66,109,170,202                  // vfmsub213ps   %ymm10,%ymm2,%ymm9
  .byte  196,98,125,24,29,71,9,3,0           // vbroadcastss  0x30947(%rip),%ymm11        # 3a284 <_sk_srcover_bgra_8888_sse2_lowp+0x31c>
  .byte  196,65,92,88,219                    // vaddps        %ymm11,%ymm4,%ymm11
  .byte  196,67,125,8,227,1                  // vroundps      $0x1,%ymm11,%ymm12
  .byte  196,65,36,92,252                    // vsubps        %ymm12,%ymm11,%ymm15
  .byte  196,65,44,92,217                    // vsubps        %ymm9,%ymm10,%ymm11
  .byte  196,98,125,24,45,25,9,3,0           // vbroadcastss  0x30919(%rip),%ymm13        # 3a274 <_sk_srcover_bgra_8888_sse2_lowp+0x30c>
  .byte  196,193,4,89,197                    // vmulps        %ymm13,%ymm15,%ymm0
  .byte  196,98,125,24,53,19,9,3,0           // vbroadcastss  0x30913(%rip),%ymm14        # 3a27c <_sk_srcover_bgra_8888_sse2_lowp+0x314>
  .byte  197,12,92,224                       // vsubps        %ymm0,%ymm14,%ymm12
  .byte  196,66,37,168,225                   // vfmadd213ps   %ymm9,%ymm11,%ymm12
  .byte  196,226,125,24,29,13,9,3,0          // vbroadcastss  0x3090d(%rip),%ymm3        # 3a288 <_sk_srcover_bgra_8888_sse2_lowp+0x320>
  .byte  196,193,100,194,255,2               // vcmpleps      %ymm15,%ymm3,%ymm7
  .byte  196,195,29,74,249,112               // vblendvps     %ymm7,%ymm9,%ymm12,%ymm7
  .byte  196,65,60,194,231,2                 // vcmpleps      %ymm15,%ymm8,%ymm12
  .byte  196,227,45,74,255,192               // vblendvps     %ymm12,%ymm7,%ymm10,%ymm7
  .byte  196,98,125,24,37,228,8,3,0          // vbroadcastss  0x308e4(%rip),%ymm12        # 3a280 <_sk_srcover_bgra_8888_sse2_lowp+0x318>
  .byte  196,65,28,194,255,2                 // vcmpleps      %ymm15,%ymm12,%ymm15
  .byte  196,194,37,168,193                  // vfmadd213ps   %ymm9,%ymm11,%ymm0
  .byte  196,99,125,74,255,240               // vblendvps     %ymm15,%ymm7,%ymm0,%ymm15
  .byte  196,227,125,8,196,1                 // vroundps      $0x1,%ymm4,%ymm0
  .byte  197,220,92,192                      // vsubps        %ymm0,%ymm4,%ymm0
  .byte  196,193,124,89,253                  // vmulps        %ymm13,%ymm0,%ymm7
  .byte  197,140,92,207                      // vsubps        %ymm7,%ymm14,%ymm1
  .byte  196,194,37,168,201                  // vfmadd213ps   %ymm9,%ymm11,%ymm1
  .byte  197,228,194,240,2                   // vcmpleps      %ymm0,%ymm3,%ymm6
  .byte  196,195,117,74,201,96               // vblendvps     %ymm6,%ymm9,%ymm1,%ymm1
  .byte  197,188,194,240,2                   // vcmpleps      %ymm0,%ymm8,%ymm6
  .byte  196,227,45,74,201,96                // vblendvps     %ymm6,%ymm1,%ymm10,%ymm1
  .byte  197,156,194,192,2                   // vcmpleps      %ymm0,%ymm12,%ymm0
  .byte  196,194,37,168,249                  // vfmadd213ps   %ymm9,%ymm11,%ymm7
  .byte  196,227,69,74,201,0                 // vblendvps     %ymm0,%ymm1,%ymm7,%ymm1
  .byte  196,226,125,24,5,152,8,3,0          // vbroadcastss  0x30898(%rip),%ymm0        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  197,220,88,192                      // vaddps        %ymm0,%ymm4,%ymm0
  .byte  196,227,125,8,224,1                 // vroundps      $0x1,%ymm0,%ymm4
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  197,228,194,216,2                   // vcmpleps      %ymm0,%ymm3,%ymm3
  .byte  196,193,124,89,229                  // vmulps        %ymm13,%ymm0,%ymm4
  .byte  197,140,92,244                      // vsubps        %ymm4,%ymm14,%ymm6
  .byte  196,194,37,168,241                  // vfmadd213ps   %ymm9,%ymm11,%ymm6
  .byte  196,195,77,74,217,48                // vblendvps     %ymm3,%ymm9,%ymm6,%ymm3
  .byte  197,188,194,240,2                   // vcmpleps      %ymm0,%ymm8,%ymm6
  .byte  196,227,45,74,219,96                // vblendvps     %ymm6,%ymm3,%ymm10,%ymm3
  .byte  196,98,37,184,204                   // vfmadd231ps   %ymm4,%ymm11,%ymm9
  .byte  197,156,194,192,2                   // vcmpleps      %ymm0,%ymm12,%ymm0
  .byte  196,227,53,74,219,0                 // vblendvps     %ymm0,%ymm3,%ymm9,%ymm3
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,212,194,224,0                   // vcmpeqps      %ymm0,%ymm5,%ymm4
  .byte  196,227,5,74,194,64                 // vblendvps     %ymm4,%ymm2,%ymm15,%ymm0
  .byte  196,227,117,74,202,64               // vblendvps     %ymm4,%ymm2,%ymm1,%ymm1
  .byte  196,227,101,74,210,64               // vblendvps     %ymm4,%ymm2,%ymm3,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,92,36,128                // vmovups       -0x80(%rsp),%ymm3
  .byte  197,252,16,100,36,160               // vmovups       -0x60(%rsp),%ymm4
  .byte  197,252,16,108,36,192               // vmovups       -0x40(%rsp),%ymm5
  .byte  197,252,16,116,36,224               // vmovups       -0x20(%rsp),%ymm6
  .byte  197,252,16,60,36                    // vmovups       (%rsp),%ymm7
  .byte  72,131,196,56                       // add           $0x38,%rsp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_1_float_hsw
.globl _sk_scale_1_float_hsw
FUNCTION(_sk_scale_1_float_hsw)
_sk_scale_1_float_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_u8_hsw
.globl _sk_scale_u8_hsw
FUNCTION(_sk_scale_u8_hsw)
_sk_scale_u8_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,58                              // jne           9ae3 <_sk_scale_u8_hsw+0x52>
  .byte  196,2,121,48,4,24                   // vpmovzxbw     (%r8,%r11,1),%xmm8
  .byte  197,57,219,5,57,16,3,0              // vpand         0x31039(%rip),%xmm8,%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,66,125,51,192                   // vpmovzxwd     %xmm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,98,125,24,13,198,7,3,0          // vbroadcastss  0x307c6(%rip),%ymm9        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,183                             // ja            9aaf <_sk_scale_u8_hsw+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,121,0,0,0                 // lea           0x79(%rip),%r10        # 9b7c <_sk_scale_u8_hsw+0xeb>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  235,152                             // jmp           9aaf <_sk_scale_u8_hsw+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  197,57,196,192,2                    // vpinsrw       $0x2,%eax,%xmm8,%xmm8
  .byte  67,15,183,4,24                      // movzwl        (%r8,%r11,1),%eax
  .byte  197,121,110,200                     // vmovd         %eax,%xmm9
  .byte  196,66,121,48,201                   // vpmovzxbw     %xmm9,%xmm9
  .byte  196,67,57,2,193,1                   // vpblendd      $0x1,%xmm9,%xmm8,%xmm8
  .byte  233,111,255,255,255                 // jmpq          9aaf <_sk_scale_u8_hsw+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  197,57,196,192,6                    // vpinsrw       $0x6,%eax,%xmm8,%xmm8
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,57,196,192,5                    // vpinsrw       $0x5,%eax,%xmm8,%xmm8
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,57,196,192,4                    // vpinsrw       $0x4,%eax,%xmm8,%xmm8
  .byte  196,1,121,110,12,24                 // vmovd         (%r8,%r11,1),%xmm9
  .byte  196,66,121,48,201                   // vpmovzxbw     %xmm9,%xmm9
  .byte  196,67,49,2,192,12                  // vpblendd      $0xc,%xmm8,%xmm9,%xmm8
  .byte  233,51,255,255,255                  // jmpq          9aaf <_sk_scale_u8_hsw+0x1e>
  .byte  144                                 // nop
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,171,255,255,255,155             // ljmp          *-0x64000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  234                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  223,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,212                             // callq         *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_scale_565_hsw
.globl _sk_scale_565_hsw
FUNCTION(_sk_scale_565_hsw)
_sk_scale_565_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,161,0,0,0                    // jne           9c58 <_sk_scale_565_hsw+0xc0>
  .byte  196,1,122,111,4,88                  // vmovdqu       (%r8,%r11,2),%xmm8
  .byte  196,66,125,51,192                   // vpmovzxwd     %xmm8,%ymm8
  .byte  196,98,125,88,13,201,6,3,0          // vpbroadcastd  0x306c9(%rip),%ymm9        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  196,65,61,219,201                   // vpand         %ymm9,%ymm8,%ymm9
  .byte  196,65,124,91,201                   // vcvtdq2ps     %ymm9,%ymm9
  .byte  196,98,125,24,21,186,6,3,0          // vbroadcastss  0x306ba(%rip),%ymm10        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  196,65,52,89,202                    // vmulps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,88,21,176,6,3,0          // vpbroadcastd  0x306b0(%rip),%ymm10        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  196,65,61,219,210                   // vpand         %ymm10,%ymm8,%ymm10
  .byte  196,65,124,91,210                   // vcvtdq2ps     %ymm10,%ymm10
  .byte  196,98,125,24,29,161,6,3,0          // vbroadcastss  0x306a1(%rip),%ymm11        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  196,65,44,89,211                    // vmulps        %ymm11,%ymm10,%ymm10
  .byte  196,98,125,88,29,151,6,3,0          // vpbroadcastd  0x30697(%rip),%ymm11        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  196,65,61,219,195                   // vpand         %ymm11,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,98,125,24,29,136,6,3,0          // vbroadcastss  0x30688(%rip),%ymm11        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  197,100,194,223,1                   // vcmpltps      %ymm7,%ymm3,%ymm11
  .byte  196,65,44,93,224                    // vminps        %ymm8,%ymm10,%ymm12
  .byte  196,65,52,93,228                    // vminps        %ymm12,%ymm9,%ymm12
  .byte  196,65,44,95,232                    // vmaxps        %ymm8,%ymm10,%ymm13
  .byte  196,65,52,95,237                    // vmaxps        %ymm13,%ymm9,%ymm13
  .byte  196,67,21,74,220,176                // vblendvps     %ymm11,%ymm12,%ymm13,%ymm11
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  197,172,89,201                      // vmulps        %ymm1,%ymm10,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,164,89,219                      // vmulps        %ymm3,%ymm11,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,76,255,255,255               // ja            9bbd <_sk_scale_565_hsw+0x25>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,100,0,0,0                 // lea           0x64(%rip),%r10        # 9ce0 <_sk_scale_565_hsw+0x148>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  233,42,255,255,255                  // jmpq          9bbd <_sk_scale_565_hsw+0x25>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,1,57,196,68,88,4,2              // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,121,110,12,88                 // vmovd         (%r8,%r11,2),%xmm9
  .byte  196,67,57,2,193,1                   // vpblendd      $0x1,%xmm9,%xmm8,%xmm8
  .byte  233,12,255,255,255                  // jmpq          9bbd <_sk_scale_565_hsw+0x25>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,1,57,196,68,88,12,6             // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,57,196,68,88,10,5             // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,57,196,68,88,8,4              // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,122,126,12,88                 // vmovq         (%r8,%r11,2),%xmm9
  .byte  196,67,49,2,192,12                  // vpblendd      $0xc,%xmm8,%xmm9,%xmm8
  .byte  233,222,254,255,255                 // jmpq          9bbd <_sk_scale_565_hsw+0x25>
  .byte  144                                 // nop
  .byte  165                                 // movsl         %ds:(%rsi),%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,192                             // inc           %eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,179,255,255,255,238             // pushq         -0x11000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,230                             // jmpq          *%rsi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  222,255                             // fdivrp        %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,209                             // callq         *%rcx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_lerp_1_float_hsw
.globl _sk_lerp_1_float_hsw
FUNCTION(_sk_lerp_1_float_hsw)
_sk_lerp_1_float_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  196,226,61,168,196                  // vfmadd213ps   %ymm4,%ymm8,%ymm0
  .byte  197,244,92,205                      // vsubps        %ymm5,%ymm1,%ymm1
  .byte  196,226,61,168,205                  // vfmadd213ps   %ymm5,%ymm8,%ymm1
  .byte  197,236,92,214                      // vsubps        %ymm6,%ymm2,%ymm2
  .byte  196,226,61,168,214                  // vfmadd213ps   %ymm6,%ymm8,%ymm2
  .byte  197,228,92,223                      // vsubps        %ymm7,%ymm3,%ymm3
  .byte  196,226,61,168,223                  // vfmadd213ps   %ymm7,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lerp_u8_hsw
.globl _sk_lerp_u8_hsw
FUNCTION(_sk_lerp_u8_hsw)
_sk_lerp_u8_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,78                              // jne           9d91 <_sk_lerp_u8_hsw+0x66>
  .byte  196,2,121,48,4,24                   // vpmovzxbw     (%r8,%r11,1),%xmm8
  .byte  197,57,219,5,159,13,3,0             // vpand         0x30d9f(%rip),%xmm8,%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,66,125,51,192                   // vpmovzxwd     %xmm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,98,125,24,13,44,5,3,0           // vbroadcastss  0x3052c(%rip),%ymm9        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  196,226,61,168,196                  // vfmadd213ps   %ymm4,%ymm8,%ymm0
  .byte  197,244,92,205                      // vsubps        %ymm5,%ymm1,%ymm1
  .byte  196,226,61,168,205                  // vfmadd213ps   %ymm5,%ymm8,%ymm1
  .byte  197,236,92,214                      // vsubps        %ymm6,%ymm2,%ymm2
  .byte  196,226,61,168,214                  // vfmadd213ps   %ymm6,%ymm8,%ymm2
  .byte  197,228,92,223                      // vsubps        %ymm7,%ymm3,%ymm3
  .byte  196,226,61,168,223                  // vfmadd213ps   %ymm7,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,163                             // ja            9d49 <_sk_lerp_u8_hsw+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,123,0,0,0                 // lea           0x7b(%rip),%r10        # 9e2c <_sk_lerp_u8_hsw+0x101>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  235,132                             // jmp           9d49 <_sk_lerp_u8_hsw+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  197,57,196,192,2                    // vpinsrw       $0x2,%eax,%xmm8,%xmm8
  .byte  67,15,183,4,24                      // movzwl        (%r8,%r11,1),%eax
  .byte  197,121,110,200                     // vmovd         %eax,%xmm9
  .byte  196,66,121,48,201                   // vpmovzxbw     %xmm9,%xmm9
  .byte  196,67,57,2,193,1                   // vpblendd      $0x1,%xmm9,%xmm8,%xmm8
  .byte  233,91,255,255,255                  // jmpq          9d49 <_sk_lerp_u8_hsw+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  197,57,196,192,6                    // vpinsrw       $0x6,%eax,%xmm8,%xmm8
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,57,196,192,5                    // vpinsrw       $0x5,%eax,%xmm8,%xmm8
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,57,196,192,4                    // vpinsrw       $0x4,%eax,%xmm8,%xmm8
  .byte  196,1,121,110,12,24                 // vmovd         (%r8,%r11,1),%xmm9
  .byte  196,66,121,48,201                   // vpmovzxbw     %xmm9,%xmm9
  .byte  196,67,49,2,192,12                  // vpblendd      $0xc,%xmm8,%xmm9,%xmm8
  .byte  233,31,255,255,255                  // jmpq          9d49 <_sk_lerp_u8_hsw+0x1e>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  142,255                             // mov           %edi,%?
  .byte  255                                 // (bad)
  .byte  255,169,255,255,255,153             // ljmp          *-0x66000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  232,255,255,255,221                 // callq         ffffffffde009e3c <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffddfcfed4>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,194                             // inc           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_lerp_565_hsw
.globl _sk_lerp_565_hsw
FUNCTION(_sk_lerp_565_hsw)
_sk_lerp_565_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,181,0,0,0                    // jne           9f1c <_sk_lerp_565_hsw+0xd4>
  .byte  196,1,122,111,4,88                  // vmovdqu       (%r8,%r11,2),%xmm8
  .byte  196,66,125,51,192                   // vpmovzxwd     %xmm8,%ymm8
  .byte  196,98,125,88,13,25,4,3,0           // vpbroadcastd  0x30419(%rip),%ymm9        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  196,65,61,219,201                   // vpand         %ymm9,%ymm8,%ymm9
  .byte  196,65,124,91,201                   // vcvtdq2ps     %ymm9,%ymm9
  .byte  196,98,125,24,21,10,4,3,0           // vbroadcastss  0x3040a(%rip),%ymm10        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  196,65,52,89,202                    // vmulps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,88,21,0,4,3,0            // vpbroadcastd  0x30400(%rip),%ymm10        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  196,65,61,219,210                   // vpand         %ymm10,%ymm8,%ymm10
  .byte  196,65,124,91,210                   // vcvtdq2ps     %ymm10,%ymm10
  .byte  196,98,125,24,29,241,3,3,0          // vbroadcastss  0x303f1(%rip),%ymm11        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  196,65,44,89,211                    // vmulps        %ymm11,%ymm10,%ymm10
  .byte  196,98,125,88,29,231,3,3,0          // vpbroadcastd  0x303e7(%rip),%ymm11        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  196,65,61,219,195                   // vpand         %ymm11,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,98,125,24,29,216,3,3,0          // vbroadcastss  0x303d8(%rip),%ymm11        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  197,100,194,223,1                   // vcmpltps      %ymm7,%ymm3,%ymm11
  .byte  196,65,44,93,224                    // vminps        %ymm8,%ymm10,%ymm12
  .byte  196,65,52,93,228                    // vminps        %ymm12,%ymm9,%ymm12
  .byte  196,65,44,95,232                    // vmaxps        %ymm8,%ymm10,%ymm13
  .byte  196,65,52,95,237                    // vmaxps        %ymm13,%ymm9,%ymm13
  .byte  196,67,21,74,220,176                // vblendvps     %ymm11,%ymm12,%ymm13,%ymm11
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  196,226,53,168,196                  // vfmadd213ps   %ymm4,%ymm9,%ymm0
  .byte  197,244,92,205                      // vsubps        %ymm5,%ymm1,%ymm1
  .byte  196,226,45,168,205                  // vfmadd213ps   %ymm5,%ymm10,%ymm1
  .byte  197,236,92,214                      // vsubps        %ymm6,%ymm2,%ymm2
  .byte  196,226,61,168,214                  // vfmadd213ps   %ymm6,%ymm8,%ymm2
  .byte  197,228,92,223                      // vsubps        %ymm7,%ymm3,%ymm3
  .byte  196,226,37,168,223                  // vfmadd213ps   %ymm7,%ymm11,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,56,255,255,255               // ja            9e6d <_sk_lerp_565_hsw+0x25>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,100,0,0,0                 // lea           0x64(%rip),%r10        # 9fa4 <_sk_lerp_565_hsw+0x15c>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  233,22,255,255,255                  // jmpq          9e6d <_sk_lerp_565_hsw+0x25>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,1,57,196,68,88,4,2              // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,121,110,12,88                 // vmovd         (%r8,%r11,2),%xmm9
  .byte  196,67,57,2,193,1                   // vpblendd      $0x1,%xmm9,%xmm8,%xmm8
  .byte  233,248,254,255,255                 // jmpq          9e6d <_sk_lerp_565_hsw+0x25>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,1,57,196,68,88,12,6             // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,57,196,68,88,10,5             // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,57,196,68,88,8,4              // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,122,126,12,88                 // vmovq         (%r8,%r11,2),%xmm9
  .byte  196,67,49,2,192,12                  // vpblendd      $0xc,%xmm8,%xmm9,%xmm8
  .byte  233,202,254,255,255                 // jmpq          9e6d <_sk_lerp_565_hsw+0x25>
  .byte  144                                 // nop
  .byte  165                                 // movsl         %ds:(%rsi),%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,192                             // inc           %eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,179,255,255,255,238             // pushq         -0x11000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,230                             // jmpq          *%rsi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  222,255                             // fdivrp        %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,209                             // callq         *%rcx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_tables_hsw
.globl _sk_load_tables_hsw
FUNCTION(_sk_load_tables_hsw)
_sk_load_tables_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,116                             // jne           a03e <_sk_load_tables_hsw+0x7e>
  .byte  196,193,126,111,28,144              // vmovdqu       (%r8,%rdx,4),%ymm3
  .byte  197,229,219,13,232,4,3,0            // vpand         0x304e8(%rip),%ymm3,%ymm1        # 3a4c0 <_sk_srcover_bgra_8888_sse2_lowp+0x558>
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,194,53,146,4,136                // vgatherdps    %ymm9,(%r8,%ymm1,4),%ymm0
  .byte  196,98,101,0,13,223,4,3,0           // vpshufb       0x304df(%rip),%ymm3,%ymm9        # 3a4e0 <_sk_srcover_bgra_8888_sse2_lowp+0x578>
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  196,130,45,146,12,137               // vgatherdps    %ymm10,(%r9,%ymm9,4),%ymm1
  .byte  72,139,64,24                        // mov           0x18(%rax),%rax
  .byte  196,98,101,0,13,227,4,3,0           // vpshufb       0x304e3(%rip),%ymm3,%ymm9        # 3a500 <_sk_srcover_bgra_8888_sse2_lowp+0x598>
  .byte  196,162,61,146,20,136               // vgatherdps    %ymm8,(%rax,%ymm9,4),%ymm2
  .byte  197,229,114,211,24                  // vpsrld        $0x18,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,98,125,24,5,91,2,3,0            // vbroadcastss  0x3025b(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,229,239,219                     // vpxor         %ymm3,%ymm3,%ymm3
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,122,255,255,255              // ja            9fd0 <_sk_load_tables_hsw+0x10>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,139,0,0,0                 // lea           0x8b(%rip),%r10        # a0ec <_sk_load_tables_hsw+0x12c>
  .byte  79,99,12,138                        // movslq        (%r10,%r9,4),%r9
  .byte  77,1,209                            // add           %r10,%r9
  .byte  65,255,225                          // jmpq          *%r9
  .byte  196,193,121,110,28,144              // vmovd         (%r8,%rdx,4),%xmm3
  .byte  233,90,255,255,255                  // jmpq          9fd0 <_sk_load_tables_hsw+0x10>
  .byte  196,193,121,110,68,144,8            // vmovd         0x8(%r8,%rdx,4),%xmm0
  .byte  196,226,121,89,192                  // vpbroadcastq  %xmm0,%xmm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,227,117,2,216,4                 // vpblendd      $0x4,%ymm0,%ymm1,%ymm3
  .byte  196,193,122,126,4,144               // vmovq         (%r8,%rdx,4),%xmm0
  .byte  196,227,101,2,216,3                 // vpblendd      $0x3,%ymm0,%ymm3,%ymm3
  .byte  233,51,255,255,255                  // jmpq          9fd0 <_sk_load_tables_hsw+0x10>
  .byte  196,193,121,110,68,144,24           // vmovd         0x18(%r8,%rdx,4),%xmm0
  .byte  196,226,125,89,192                  // vpbroadcastq  %xmm0,%ymm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,227,117,2,216,64                // vpblendd      $0x40,%ymm0,%ymm1,%ymm3
  .byte  196,227,125,57,216,1                // vextracti128  $0x1,%ymm3,%xmm0
  .byte  196,195,121,34,68,144,20,1          // vpinsrd       $0x1,0x14(%r8,%rdx,4),%xmm0,%xmm0
  .byte  196,227,101,56,216,1                // vinserti128   $0x1,%xmm0,%ymm3,%ymm3
  .byte  196,227,125,57,216,1                // vextracti128  $0x1,%ymm3,%xmm0
  .byte  196,195,121,34,68,144,16,0          // vpinsrd       $0x0,0x10(%r8,%rdx,4),%xmm0,%xmm0
  .byte  196,227,101,56,216,1                // vinserti128   $0x1,%xmm0,%ymm3,%ymm3
  .byte  196,193,122,111,4,144               // vmovdqu       (%r8,%rdx,4),%xmm0
  .byte  196,227,125,2,219,240               // vpblendd      $0xf0,%ymm3,%ymm0,%ymm3
  .byte  233,228,254,255,255                 // jmpq          9fd0 <_sk_load_tables_hsw+0x10>
  .byte  127,255                             // jg            a0ed <_sk_load_tables_hsw+0x12d>
  .byte  255                                 // (bad)
  .byte  255,160,255,255,255,138             // jmpq          *-0x75000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  239                                 // out           %eax,(%dx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  219,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  177,255                             // mov           $0xff,%cl
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_tables_u16_be_hsw
.globl _sk_load_tables_u16_be_hsw
FUNCTION(_sk_load_tables_u16_be_hsw)
_sk_load_tables_u16_be_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  76,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,215,0,0,0                    // jne           a1f5 <_sk_load_tables_u16_be_hsw+0xed>
  .byte  196,1,121,16,4,72                   // vmovupd       (%r8,%r9,2),%xmm8
  .byte  196,129,121,16,84,72,16             // vmovupd       0x10(%r8,%r9,2),%xmm2
  .byte  196,129,121,16,92,72,32             // vmovupd       0x20(%r8,%r9,2),%xmm3
  .byte  196,1,122,111,76,72,48              // vmovdqu       0x30(%r8,%r9,2),%xmm9
  .byte  197,185,97,194                      // vpunpcklwd    %xmm2,%xmm8,%xmm0
  .byte  197,185,105,210                     // vpunpckhwd    %xmm2,%xmm8,%xmm2
  .byte  196,193,97,97,201                   // vpunpcklwd    %xmm9,%xmm3,%xmm1
  .byte  196,193,97,105,217                  // vpunpckhwd    %xmm9,%xmm3,%xmm3
  .byte  197,121,97,194                      // vpunpcklwd    %xmm2,%xmm0,%xmm8
  .byte  197,121,105,202                     // vpunpckhwd    %xmm2,%xmm0,%xmm9
  .byte  197,241,97,195                      // vpunpcklwd    %xmm3,%xmm1,%xmm0
  .byte  197,113,105,243                     // vpunpckhwd    %xmm3,%xmm1,%xmm14
  .byte  197,185,108,200                     // vpunpcklqdq   %xmm0,%xmm8,%xmm1
  .byte  197,57,109,192                      // vpunpckhqdq   %xmm0,%xmm8,%xmm8
  .byte  196,65,49,108,214                   // vpunpcklqdq   %xmm14,%xmm9,%xmm10
  .byte  197,121,111,29,128,9,3,0            // vmovdqa       0x30980(%rip),%xmm11        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,193,113,219,195                 // vpand         %xmm11,%xmm1,%xmm0
  .byte  196,226,125,51,200                  // vpmovzxwd     %xmm0,%ymm1
  .byte  196,65,29,118,228                   // vpcmpeqd      %ymm12,%ymm12,%ymm12
  .byte  197,237,239,210                     // vpxor         %ymm2,%ymm2,%ymm2
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  196,65,21,118,237                   // vpcmpeqd      %ymm13,%ymm13,%ymm13
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  196,194,21,146,4,136                // vgatherdps    %ymm13,(%r8,%ymm1,4),%ymm0
  .byte  196,193,57,219,203                  // vpand         %xmm11,%xmm8,%xmm1
  .byte  196,98,125,51,193                   // vpmovzxwd     %xmm1,%ymm8
  .byte  196,65,21,118,237                   // vpcmpeqd      %ymm13,%ymm13,%ymm13
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,130,21,146,12,129               // vgatherdps    %ymm13,(%r9,%ymm8,4),%ymm1
  .byte  72,139,64,24                        // mov           0x18(%rax),%rax
  .byte  196,193,41,219,219                  // vpand         %xmm11,%xmm10,%xmm3
  .byte  196,226,125,51,219                  // vpmovzxwd     %xmm3,%ymm3
  .byte  196,226,29,146,20,152               // vgatherdps    %ymm12,(%rax,%ymm3,4),%ymm2
  .byte  196,193,49,109,222                  // vpunpckhqdq   %xmm14,%xmm9,%xmm3
  .byte  197,185,113,243,8                   // vpsllw        $0x8,%xmm3,%xmm8
  .byte  197,225,113,211,8                   // vpsrlw        $0x8,%xmm3,%xmm3
  .byte  197,185,235,219                     // vpor          %xmm3,%xmm8,%xmm3
  .byte  196,226,125,51,219                  // vpmovzxwd     %xmm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,98,125,24,5,192,0,3,0           // vbroadcastss  0x300c0(%rip),%ymm8        # 3a2ac <_sk_srcover_bgra_8888_sse2_lowp+0x344>
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,123,16,4,72                   // vmovsd        (%r8,%r9,2),%xmm8
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,85                              // je            a25b <_sk_load_tables_u16_be_hsw+0x153>
  .byte  196,1,57,22,68,72,8                 // vmovhpd       0x8(%r8,%r9,2),%xmm8,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,72                              // jb            a25b <_sk_load_tables_u16_be_hsw+0x153>
  .byte  196,129,123,16,84,72,16             // vmovsd        0x10(%r8,%r9,2),%xmm2
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  116,72                              // je            a268 <_sk_load_tables_u16_be_hsw+0x160>
  .byte  196,129,105,22,84,72,24             // vmovhpd       0x18(%r8,%r9,2),%xmm2,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,59                              // jb            a268 <_sk_load_tables_u16_be_hsw+0x160>
  .byte  196,129,123,16,92,72,32             // vmovsd        0x20(%r8,%r9,2),%xmm3
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  15,132,251,254,255,255              // je            a139 <_sk_load_tables_u16_be_hsw+0x31>
  .byte  196,129,97,22,92,72,40              // vmovhpd       0x28(%r8,%r9,2),%xmm3,%xmm3
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,130,234,254,255,255              // jb            a139 <_sk_load_tables_u16_be_hsw+0x31>
  .byte  196,1,122,126,76,72,48              // vmovq         0x30(%r8,%r9,2),%xmm9
  .byte  233,222,254,255,255                 // jmpq          a139 <_sk_load_tables_u16_be_hsw+0x31>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  197,233,87,210                      // vxorpd        %xmm2,%xmm2,%xmm2
  .byte  233,209,254,255,255                 // jmpq          a139 <_sk_load_tables_u16_be_hsw+0x31>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  233,200,254,255,255                 // jmpq          a139 <_sk_load_tables_u16_be_hsw+0x31>

HIDDEN _sk_load_tables_rgb_u16_be_hsw
.globl _sk_load_tables_rgb_u16_be_hsw
FUNCTION(_sk_load_tables_rgb_u16_be_hsw)
_sk_load_tables_rgb_u16_be_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  76,141,12,82                        // lea           (%rdx,%rdx,2),%r9
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,206,0,0,0                    // jne           a351 <_sk_load_tables_rgb_u16_be_hsw+0xe0>
  .byte  196,1,122,111,28,72                 // vmovdqu       (%r8,%r9,2),%xmm11
  .byte  196,129,122,111,92,72,12            // vmovdqu       0xc(%r8,%r9,2),%xmm3
  .byte  196,129,122,111,84,72,24            // vmovdqu       0x18(%r8,%r9,2),%xmm2
  .byte  196,129,122,111,68,72,32            // vmovdqu       0x20(%r8,%r9,2),%xmm0
  .byte  197,249,115,216,4                   // vpsrldq       $0x4,%xmm0,%xmm0
  .byte  196,193,57,115,219,6                // vpsrldq       $0x6,%xmm11,%xmm8
  .byte  197,169,115,219,6                   // vpsrldq       $0x6,%xmm3,%xmm10
  .byte  197,241,115,218,6                   // vpsrldq       $0x6,%xmm2,%xmm1
  .byte  197,177,115,216,6                   // vpsrldq       $0x6,%xmm0,%xmm9
  .byte  196,65,113,97,201                   // vpunpcklwd    %xmm9,%xmm1,%xmm9
  .byte  197,233,97,192                      // vpunpcklwd    %xmm0,%xmm2,%xmm0
  .byte  196,193,57,97,210                   // vpunpcklwd    %xmm10,%xmm8,%xmm2
  .byte  197,161,97,219                      // vpunpcklwd    %xmm3,%xmm11,%xmm3
  .byte  197,225,97,202                      // vpunpcklwd    %xmm2,%xmm3,%xmm1
  .byte  197,225,105,210                     // vpunpckhwd    %xmm2,%xmm3,%xmm2
  .byte  196,193,121,97,217                  // vpunpcklwd    %xmm9,%xmm0,%xmm3
  .byte  196,193,121,105,193                 // vpunpckhwd    %xmm9,%xmm0,%xmm0
  .byte  197,105,108,192                     // vpunpcklqdq   %xmm0,%xmm2,%xmm8
  .byte  197,241,108,195                     // vpunpcklqdq   %xmm3,%xmm1,%xmm0
  .byte  197,241,109,203                     // vpunpckhqdq   %xmm3,%xmm1,%xmm1
  .byte  197,249,111,29,0,8,3,0              // vmovdqa       0x30800(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  197,249,219,195                     // vpand         %xmm3,%xmm0,%xmm0
  .byte  196,98,125,51,200                   // vpmovzxwd     %xmm0,%ymm9
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  197,237,239,210                     // vpxor         %ymm2,%ymm2,%ymm2
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  196,65,37,118,219                   // vpcmpeqd      %ymm11,%ymm11,%ymm11
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  196,130,37,146,4,136                // vgatherdps    %ymm11,(%r8,%ymm9,4),%ymm0
  .byte  197,241,219,203                     // vpand         %xmm3,%xmm1,%xmm1
  .byte  196,98,125,51,201                   // vpmovzxwd     %xmm1,%ymm9
  .byte  196,65,37,118,219                   // vpcmpeqd      %ymm11,%ymm11,%ymm11
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,130,37,146,12,137               // vgatherdps    %ymm11,(%r9,%ymm9,4),%ymm1
  .byte  72,139,64,24                        // mov           0x18(%rax),%rax
  .byte  197,185,219,219                     // vpand         %xmm3,%xmm8,%xmm3
  .byte  196,226,125,51,219                  // vpmovzxwd     %xmm3,%ymm3
  .byte  196,226,45,146,20,152               // vgatherdps    %ymm10,(%rax,%ymm3,4),%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,201,254,2,0       // vbroadcastss  0x2fec9(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,4,72                // vmovd         (%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,1,121,196,92,72,4,2             // vpinsrw       $0x2,0x4(%r8,%r9,2),%xmm0,%xmm11
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,31                              // jne           a389 <_sk_load_tables_rgb_u16_be_hsw+0x118>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  197,225,239,219                     // vpxor         %xmm3,%xmm3,%xmm3
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  233,47,255,255,255                  // jmpq          a2b8 <_sk_load_tables_rgb_u16_be_hsw+0x47>
  .byte  196,129,121,110,68,72,6             // vmovd         0x6(%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,1,121,196,68,72,10,2            // vpinsrw       $0x2,0xa(%r8,%r9,2),%xmm0,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,48                              // jb            a3d3 <_sk_load_tables_rgb_u16_be_hsw+0x162>
  .byte  196,129,121,110,68,72,12            // vmovd         0xc(%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,129,121,196,92,72,16,2          // vpinsrw       $0x2,0x10(%r8,%r9,2),%xmm0,%xmm3
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  117,48                              // jne           a3ed <_sk_load_tables_rgb_u16_be_hsw+0x17c>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  233,229,254,255,255                 // jmpq          a2b8 <_sk_load_tables_rgb_u16_be_hsw+0x47>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  197,225,239,219                     // vpxor         %xmm3,%xmm3,%xmm3
  .byte  233,203,254,255,255                 // jmpq          a2b8 <_sk_load_tables_rgb_u16_be_hsw+0x47>
  .byte  196,129,121,110,68,72,18            // vmovd         0x12(%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,1,121,196,84,72,22,2            // vpinsrw       $0x2,0x16(%r8,%r9,2),%xmm0,%xmm10
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,39                              // jb            a42e <_sk_load_tables_rgb_u16_be_hsw+0x1bd>
  .byte  196,129,121,110,68,72,24            // vmovd         0x18(%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,129,121,196,84,72,28,2          // vpinsrw       $0x2,0x1c(%r8,%r9,2),%xmm0,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  117,30                              // jne           a43f <_sk_load_tables_rgb_u16_be_hsw+0x1ce>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  233,138,254,255,255                 // jmpq          a2b8 <_sk_load_tables_rgb_u16_be_hsw+0x47>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  233,121,254,255,255                 // jmpq          a2b8 <_sk_load_tables_rgb_u16_be_hsw+0x47>
  .byte  196,129,121,110,68,72,30            // vmovd         0x1e(%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,129,121,196,76,72,34,2          // vpinsrw       $0x2,0x22(%r8,%r9,2),%xmm0,%xmm1
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,25                              // jb            a472 <_sk_load_tables_rgb_u16_be_hsw+0x201>
  .byte  196,129,121,110,68,72,36            // vmovd         0x24(%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,129,121,196,68,72,40,2          // vpinsrw       $0x2,0x28(%r8,%r9,2),%xmm0,%xmm0
  .byte  233,70,254,255,255                  // jmpq          a2b8 <_sk_load_tables_rgb_u16_be_hsw+0x47>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  233,61,254,255,255                  // jmpq          a2b8 <_sk_load_tables_rgb_u16_be_hsw+0x47>

HIDDEN _sk_byte_tables_hsw
.globl _sk_byte_tables_hsw
FUNCTION(_sk_byte_tables_hsw)
_sk_byte_tables_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,98,125,24,29,137,253,2,0        // vbroadcastss  0x2fd89(%rip),%ymm11        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,211                    // vminps        %ymm11,%ymm9,%ymm10
  .byte  196,98,125,24,13,167,253,2,0        // vbroadcastss  0x2fda7(%rip),%ymm9        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,65,44,89,209                    // vmulps        %ymm9,%ymm10,%ymm10
  .byte  196,65,125,91,210                   // vcvtps2dq     %ymm10,%ymm10
  .byte  196,65,249,126,208                  // vmovq         %xmm10,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  76,139,16                           // mov           (%rax),%r10
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,193,121,110,193                 // vmovd         %r9d,%xmm0
  .byte  196,67,249,22,209,1                 // vpextrq       $0x1,%xmm10,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,67,121,32,224,1                 // vpinsrb       $0x1,%r8d,%xmm0,%xmm12
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  196,99,125,57,208,1                 // vextracti128  $0x1,%ymm10,%xmm0
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,67,25,32,208,2                  // vpinsrb       $0x2,%r8d,%xmm12,%xmm10
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,41,32,209,3                  // vpinsrb       $0x3,%r9d,%xmm10,%xmm10
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,41,32,209,4                  // vpinsrb       $0x4,%r9d,%xmm10,%xmm10
  .byte  196,195,249,22,193,1                // vpextrq       $0x1,%xmm0,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,195,41,32,192,5                 // vpinsrb       $0x5,%r8d,%xmm10,%xmm0
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,195,121,32,192,6                // vpinsrb       $0x6,%r8d,%xmm0,%xmm0
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,121,32,209,7                 // vpinsrb       $0x7,%r9d,%xmm0,%xmm10
  .byte  197,188,95,193                      // vmaxps        %ymm1,%ymm8,%ymm0
  .byte  196,193,124,93,195                  // vminps        %ymm11,%ymm0,%ymm0
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,253,91,200                      // vcvtps2dq     %ymm0,%ymm1
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,193,121,110,194                 // vmovd         %r10d,%xmm0
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,1                // vpinsrb       $0x1,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,201,1                // vextracti128  $0x1,%ymm1,%xmm1
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,195,121,32,194,3                // vpinsrb       $0x3,%r10d,%xmm0,%xmm0
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,195,121,32,194,4                // vpinsrb       $0x4,%r10d,%xmm0,%xmm0
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,5                // vpinsrb       $0x5,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,6                // vpinsrb       $0x6,%r9d,%xmm0,%xmm0
  .byte  71,15,182,4,16                      // movzbl        (%r8,%r10,1),%r8d
  .byte  196,195,121,32,200,7                // vpinsrb       $0x7,%r8d,%xmm0,%xmm1
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  197,188,95,194                      // vmaxps        %ymm2,%ymm8,%ymm0
  .byte  196,193,124,93,195                  // vminps        %ymm11,%ymm0,%ymm0
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,253,91,208                      // vcvtps2dq     %ymm0,%ymm2
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,193,121,110,194                 // vmovd         %r10d,%xmm0
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,1                // vpinsrb       $0x1,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,210,1                // vextracti128  $0x1,%ymm2,%xmm2
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,195,121,32,194,3                // vpinsrb       $0x3,%r10d,%xmm0,%xmm0
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,195,121,32,194,4                // vpinsrb       $0x4,%r10d,%xmm0,%xmm0
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,5                // vpinsrb       $0x5,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,6                // vpinsrb       $0x6,%r9d,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,182,4,16                      // movzbl        (%r8,%r10,1),%r8d
  .byte  196,195,121,32,208,7                // vpinsrb       $0x7,%r8d,%xmm0,%xmm2
  .byte  76,139,72,24                        // mov           0x18(%rax),%r9
  .byte  197,188,95,195                      // vmaxps        %ymm3,%ymm8,%ymm0
  .byte  196,193,124,93,195                  // vminps        %ymm11,%ymm0,%ymm0
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  197,249,110,216                     // vmovd         %eax,%xmm3
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  67,15,182,4,1                       // movzbl        (%r9,%r8,1),%eax
  .byte  196,227,97,32,216,1                 // vpinsrb       $0x1,%eax,%xmm3,%xmm3
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,97,32,216,2                 // vpinsrb       $0x2,%eax,%xmm3,%xmm3
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  67,15,182,4,17                      // movzbl        (%r9,%r10,1),%eax
  .byte  196,227,97,32,216,3                 // vpinsrb       $0x3,%eax,%xmm3,%xmm3
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,97,32,216,4                 // vpinsrb       $0x4,%eax,%xmm3,%xmm3
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  67,15,182,4,1                       // movzbl        (%r9,%r8,1),%eax
  .byte  196,227,97,32,192,5                 // vpinsrb       $0x5,%eax,%xmm3,%xmm0
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,121,32,216,6                // vpinsrb       $0x6,%eax,%xmm0,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  67,15,182,4,17                      // movzbl        (%r9,%r10,1),%eax
  .byte  196,194,125,49,194                  // vpmovzxbd     %xmm10,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,5,93,251,2,0          // vbroadcastss  0x2fb5d(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  196,226,125,49,201                  // vpmovzxbd     %xmm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  196,226,125,49,210                  // vpmovzxbd     %xmm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  196,227,97,32,216,7                 // vpinsrb       $0x7,%eax,%xmm3,%xmm3
  .byte  196,226,125,49,219                  // vpmovzxbd     %xmm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_byte_tables_rgb_hsw
.globl _sk_byte_tables_rgb_hsw
FUNCTION(_sk_byte_tables_rgb_hsw)
_sk_byte_tables_rgb_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,24                        // mov           0x18(%rax),%r8d
  .byte  65,255,200                          // dec           %r8d
  .byte  196,65,121,110,192                  // vmovd         %r8d,%xmm8
  .byte  196,66,125,88,192                   // vpbroadcastd  %xmm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,52,95,208                       // vmaxps        %ymm0,%ymm9,%ymm10
  .byte  196,98,125,24,29,130,250,2,0        // vbroadcastss  0x2fa82(%rip),%ymm11        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,44,93,211                    // vminps        %ymm11,%ymm10,%ymm10
  .byte  196,65,44,89,208                    // vmulps        %ymm8,%ymm10,%ymm10
  .byte  196,65,125,91,210                   // vcvtps2dq     %ymm10,%ymm10
  .byte  196,65,249,126,208                  // vmovq         %xmm10,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  76,139,16                           // mov           (%rax),%r10
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,193,121,110,193                 // vmovd         %r9d,%xmm0
  .byte  196,67,249,22,209,1                 // vpextrq       $0x1,%xmm10,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,67,121,32,224,1                 // vpinsrb       $0x1,%r8d,%xmm0,%xmm12
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  196,99,125,57,208,1                 // vextracti128  $0x1,%ymm10,%xmm0
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,67,25,32,208,2                  // vpinsrb       $0x2,%r8d,%xmm12,%xmm10
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,41,32,209,3                  // vpinsrb       $0x3,%r9d,%xmm10,%xmm10
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,41,32,209,4                  // vpinsrb       $0x4,%r9d,%xmm10,%xmm10
  .byte  196,195,249,22,193,1                // vpextrq       $0x1,%xmm0,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,195,41,32,192,5                 // vpinsrb       $0x5,%r8d,%xmm10,%xmm0
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,195,121,32,192,6                // vpinsrb       $0x6,%r8d,%xmm0,%xmm0
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,121,32,209,7                 // vpinsrb       $0x7,%r9d,%xmm0,%xmm10
  .byte  197,180,95,193                      // vmaxps        %ymm1,%ymm9,%ymm0
  .byte  196,193,124,93,195                  // vminps        %ymm11,%ymm0,%ymm0
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,253,91,200                      // vcvtps2dq     %ymm0,%ymm1
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,193,121,110,194                 // vmovd         %r10d,%xmm0
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,1                // vpinsrb       $0x1,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,201,1                // vextracti128  $0x1,%ymm1,%xmm1
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,195,121,32,194,3                // vpinsrb       $0x3,%r10d,%xmm0,%xmm0
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,195,121,32,194,4                // vpinsrb       $0x4,%r10d,%xmm0,%xmm0
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,5                // vpinsrb       $0x5,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,6                // vpinsrb       $0x6,%r9d,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,182,4,16                      // movzbl        (%r8,%r10,1),%r8d
  .byte  196,195,121,32,200,7                // vpinsrb       $0x7,%r8d,%xmm0,%xmm1
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  197,180,95,194                      // vmaxps        %ymm2,%ymm9,%ymm0
  .byte  196,193,124,93,195                  // vminps        %ymm11,%ymm0,%ymm0
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  197,249,110,208                     // vmovd         %eax,%xmm2
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  67,15,182,4,1                       // movzbl        (%r9,%r8,1),%eax
  .byte  196,227,105,32,208,1                // vpinsrb       $0x1,%eax,%xmm2,%xmm2
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,105,32,208,2                // vpinsrb       $0x2,%eax,%xmm2,%xmm2
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  67,15,182,4,17                      // movzbl        (%r9,%r10,1),%eax
  .byte  196,227,105,32,208,3                // vpinsrb       $0x3,%eax,%xmm2,%xmm2
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,105,32,208,4                // vpinsrb       $0x4,%eax,%xmm2,%xmm2
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  67,15,182,4,1                       // movzbl        (%r9,%r8,1),%eax
  .byte  196,227,105,32,192,5                // vpinsrb       $0x5,%eax,%xmm2,%xmm0
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,121,32,208,6                // vpinsrb       $0x6,%eax,%xmm0,%xmm2
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  67,15,182,4,17                      // movzbl        (%r9,%r10,1),%eax
  .byte  196,194,125,49,194                  // vpmovzxbd     %xmm10,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,5,6,249,2,0           // vbroadcastss  0x2f906(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  196,226,125,49,201                  // vpmovzxbd     %xmm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  196,227,105,32,208,7                // vpinsrb       $0x7,%eax,%xmm2,%xmm2
  .byte  196,226,125,49,210                  // vpmovzxbd     %xmm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_r_hsw
.globl _sk_table_r_hsw
FUNCTION(_sk_table_r_hsw)
_sk_table_r_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  196,66,125,88,192                   // vpbroadcastd  %xmm8,%ymm8
  .byte  196,65,124,91,200                   // vcvtdq2ps     %ymm8,%ymm9
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  196,98,125,24,21,57,248,2,0         // vbroadcastss  0x2f839(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,194                  // vminps        %ymm10,%ymm0,%ymm0
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,66,53,146,4,128                 // vgatherdps    %ymm9,(%r8,%ymm0,4),%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_g_hsw
.globl _sk_table_g_hsw
FUNCTION(_sk_table_g_hsw)
_sk_table_g_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  196,66,125,88,192                   // vpbroadcastd  %xmm8,%ymm8
  .byte  196,65,124,91,200                   // vcvtdq2ps     %ymm8,%ymm9
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  196,98,125,24,21,238,247,2,0        // vbroadcastss  0x2f7ee(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,116,93,202                  // vminps        %ymm10,%ymm1,%ymm1
  .byte  196,193,116,89,201                  // vmulps        %ymm9,%ymm1,%ymm1
  .byte  197,253,91,201                      // vcvtps2dq     %ymm1,%ymm1
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,66,53,146,4,136                 // vgatherdps    %ymm9,(%r8,%ymm1,4),%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,193                      // vmovaps       %ymm8,%ymm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_b_hsw
.globl _sk_table_b_hsw
FUNCTION(_sk_table_b_hsw)
_sk_table_b_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  196,66,125,88,192                   // vpbroadcastd  %xmm8,%ymm8
  .byte  196,65,124,91,200                   // vcvtdq2ps     %ymm8,%ymm9
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,210                      // vmaxps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,21,163,247,2,0        // vbroadcastss  0x2f7a3(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,108,93,210                  // vminps        %ymm10,%ymm2,%ymm2
  .byte  196,193,108,89,209                  // vmulps        %ymm9,%ymm2,%ymm2
  .byte  197,253,91,210                      // vcvtps2dq     %ymm2,%ymm2
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,66,53,146,4,144                 // vgatherdps    %ymm9,(%r8,%ymm2,4),%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,194                      // vmovaps       %ymm8,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_a_hsw
.globl _sk_table_a_hsw
FUNCTION(_sk_table_a_hsw)
_sk_table_a_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  196,66,125,88,192                   // vpbroadcastd  %xmm8,%ymm8
  .byte  196,65,124,91,200                   // vcvtdq2ps     %ymm8,%ymm9
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,219                      // vmaxps        %ymm3,%ymm8,%ymm3
  .byte  196,98,125,24,21,88,247,2,0         // vbroadcastss  0x2f758(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,100,93,218                  // vminps        %ymm10,%ymm3,%ymm3
  .byte  196,193,100,89,217                  // vmulps        %ymm9,%ymm3,%ymm3
  .byte  197,253,91,219                      // vcvtps2dq     %ymm3,%ymm3
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,66,53,146,4,152                 // vgatherdps    %ymm9,(%r8,%ymm3,4),%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,195                      // vmovaps       %ymm8,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_r_hsw
.globl _sk_parametric_r_hsw
FUNCTION(_sk_parametric_r_hsw)
_sk_parametric_r_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,16                 // vbroadcastss  0x10(%rax),%ymm8
  .byte  196,65,124,194,192,2                // vcmpleps      %ymm8,%ymm0,%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,98,125,24,80,24                 // vbroadcastss  0x18(%rax),%ymm10
  .byte  196,66,125,168,202                  // vfmadd213ps   %ymm10,%ymm0,%ymm9
  .byte  196,98,125,24,88,4                  // vbroadcastss  0x4(%rax),%ymm11
  .byte  196,98,125,24,80,8                  // vbroadcastss  0x8(%rax),%ymm10
  .byte  196,66,125,168,218                  // vfmadd213ps   %ymm10,%ymm0,%ymm11
  .byte  196,98,125,24,32                    // vbroadcastss  (%rax),%ymm12
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,36,194,208,0                    // vcmpeqps      %ymm0,%ymm11,%ymm10
  .byte  196,65,124,91,235                   // vcvtdq2ps     %ymm11,%ymm13
  .byte  196,98,125,24,53,131,247,2,0        // vbroadcastss  0x2f783(%rip),%ymm14        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  196,98,125,24,61,126,247,2,0        // vbroadcastss  0x2f77e(%rip),%ymm15        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  196,65,36,84,223                    // vandps        %ymm15,%ymm11,%ymm11
  .byte  196,98,125,24,61,208,246,2,0        // vbroadcastss  0x2f6d0(%rip),%ymm15        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,36,86,223                    // vorps         %ymm15,%ymm11,%ymm11
  .byte  196,98,125,24,61,102,247,2,0        // vbroadcastss  0x2f766(%rip),%ymm15        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  196,66,21,184,254                   // vfmadd231ps   %ymm14,%ymm13,%ymm15
  .byte  196,98,125,24,45,92,247,2,0         // vbroadcastss  0x2f75c(%rip),%ymm13        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,66,37,172,239                   // vfnmadd213ps  %ymm15,%ymm11,%ymm13
  .byte  196,98,125,24,53,82,247,2,0         // vbroadcastss  0x2f752(%rip),%ymm14        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,65,36,88,222                    // vaddps        %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,72,247,2,0         // vbroadcastss  0x2f748(%rip),%ymm14        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,12,94,219                    // vdivps        %ymm11,%ymm14,%ymm11
  .byte  196,65,20,92,219                    // vsubps        %ymm11,%ymm13,%ymm11
  .byte  196,65,28,89,219                    // vmulps        %ymm11,%ymm12,%ymm11
  .byte  196,67,125,8,227,1                  // vroundps      $0x1,%ymm11,%ymm12
  .byte  196,65,36,92,228                    // vsubps        %ymm12,%ymm11,%ymm12
  .byte  196,98,125,24,45,41,247,2,0         // vbroadcastss  0x2f729(%rip),%ymm13        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  196,65,36,88,221                    // vaddps        %ymm13,%ymm11,%ymm11
  .byte  196,98,125,24,45,31,247,2,0         // vbroadcastss  0x2f71f(%rip),%ymm13        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,66,29,172,235                   // vfnmadd213ps  %ymm11,%ymm12,%ymm13
  .byte  196,98,125,24,29,21,247,2,0         // vbroadcastss  0x2f715(%rip),%ymm11        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  196,65,36,92,220                    // vsubps        %ymm12,%ymm11,%ymm11
  .byte  196,98,125,24,37,11,247,2,0         // vbroadcastss  0x2f70b(%rip),%ymm12        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  196,65,28,94,219                    // vdivps        %ymm11,%ymm12,%ymm11
  .byte  196,65,20,88,219                    // vaddps        %ymm11,%ymm13,%ymm11
  .byte  196,98,125,24,37,252,246,2,0        // vbroadcastss  0x2f6fc(%rip),%ymm12        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  196,65,36,89,220                    // vmulps        %ymm12,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,99,37,74,208,160                // vblendvps     %ymm10,%ymm0,%ymm11,%ymm10
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,67,45,74,193,128                // vblendvps     %ymm8,%ymm9,%ymm10,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  196,98,125,24,5,14,246,2,0          // vbroadcastss  0x2f60e(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_g_hsw
.globl _sk_parametric_g_hsw
FUNCTION(_sk_parametric_g_hsw)
_sk_parametric_g_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,16                 // vbroadcastss  0x10(%rax),%ymm8
  .byte  196,65,116,194,192,2                // vcmpleps      %ymm8,%ymm1,%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,98,125,24,80,24                 // vbroadcastss  0x18(%rax),%ymm10
  .byte  196,66,117,168,202                  // vfmadd213ps   %ymm10,%ymm1,%ymm9
  .byte  196,98,125,24,88,4                  // vbroadcastss  0x4(%rax),%ymm11
  .byte  196,98,125,24,80,8                  // vbroadcastss  0x8(%rax),%ymm10
  .byte  196,66,117,168,218                  // vfmadd213ps   %ymm10,%ymm1,%ymm11
  .byte  196,98,125,24,32                    // vbroadcastss  (%rax),%ymm12
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,36,194,209,0                    // vcmpeqps      %ymm1,%ymm11,%ymm10
  .byte  196,65,124,91,235                   // vcvtdq2ps     %ymm11,%ymm13
  .byte  196,98,125,24,53,81,246,2,0         // vbroadcastss  0x2f651(%rip),%ymm14        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  196,98,125,24,61,76,246,2,0         // vbroadcastss  0x2f64c(%rip),%ymm15        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  196,65,36,84,223                    // vandps        %ymm15,%ymm11,%ymm11
  .byte  196,98,125,24,61,158,245,2,0        // vbroadcastss  0x2f59e(%rip),%ymm15        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,36,86,223                    // vorps         %ymm15,%ymm11,%ymm11
  .byte  196,98,125,24,61,52,246,2,0         // vbroadcastss  0x2f634(%rip),%ymm15        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  196,66,21,184,254                   // vfmadd231ps   %ymm14,%ymm13,%ymm15
  .byte  196,98,125,24,45,42,246,2,0         // vbroadcastss  0x2f62a(%rip),%ymm13        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,66,37,172,239                   // vfnmadd213ps  %ymm15,%ymm11,%ymm13
  .byte  196,98,125,24,53,32,246,2,0         // vbroadcastss  0x2f620(%rip),%ymm14        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,65,36,88,222                    // vaddps        %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,22,246,2,0         // vbroadcastss  0x2f616(%rip),%ymm14        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,12,94,219                    // vdivps        %ymm11,%ymm14,%ymm11
  .byte  196,65,20,92,219                    // vsubps        %ymm11,%ymm13,%ymm11
  .byte  196,65,28,89,219                    // vmulps        %ymm11,%ymm12,%ymm11
  .byte  196,67,125,8,227,1                  // vroundps      $0x1,%ymm11,%ymm12
  .byte  196,65,36,92,228                    // vsubps        %ymm12,%ymm11,%ymm12
  .byte  196,98,125,24,45,247,245,2,0        // vbroadcastss  0x2f5f7(%rip),%ymm13        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  196,65,36,88,221                    // vaddps        %ymm13,%ymm11,%ymm11
  .byte  196,98,125,24,45,237,245,2,0        // vbroadcastss  0x2f5ed(%rip),%ymm13        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,66,29,172,235                   // vfnmadd213ps  %ymm11,%ymm12,%ymm13
  .byte  196,98,125,24,29,227,245,2,0        // vbroadcastss  0x2f5e3(%rip),%ymm11        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  196,65,36,92,220                    // vsubps        %ymm12,%ymm11,%ymm11
  .byte  196,98,125,24,37,217,245,2,0        // vbroadcastss  0x2f5d9(%rip),%ymm12        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  196,65,28,94,219                    // vdivps        %ymm11,%ymm12,%ymm11
  .byte  196,65,20,88,219                    // vaddps        %ymm11,%ymm13,%ymm11
  .byte  196,98,125,24,37,202,245,2,0        // vbroadcastss  0x2f5ca(%rip),%ymm12        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  196,65,36,89,220                    // vmulps        %ymm12,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,99,37,74,209,160                // vblendvps     %ymm10,%ymm1,%ymm11,%ymm10
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,67,45,74,193,128                // vblendvps     %ymm8,%ymm9,%ymm10,%ymm8
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  196,98,125,24,5,220,244,2,0         // vbroadcastss  0x2f4dc(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_b_hsw
.globl _sk_parametric_b_hsw
FUNCTION(_sk_parametric_b_hsw)
_sk_parametric_b_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,16                 // vbroadcastss  0x10(%rax),%ymm8
  .byte  196,65,108,194,192,2                // vcmpleps      %ymm8,%ymm2,%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,98,125,24,80,24                 // vbroadcastss  0x18(%rax),%ymm10
  .byte  196,66,109,168,202                  // vfmadd213ps   %ymm10,%ymm2,%ymm9
  .byte  196,98,125,24,88,4                  // vbroadcastss  0x4(%rax),%ymm11
  .byte  196,98,125,24,80,8                  // vbroadcastss  0x8(%rax),%ymm10
  .byte  196,66,109,168,218                  // vfmadd213ps   %ymm10,%ymm2,%ymm11
  .byte  196,98,125,24,32                    // vbroadcastss  (%rax),%ymm12
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,36,194,210,0                    // vcmpeqps      %ymm2,%ymm11,%ymm10
  .byte  196,65,124,91,235                   // vcvtdq2ps     %ymm11,%ymm13
  .byte  196,98,125,24,53,31,245,2,0         // vbroadcastss  0x2f51f(%rip),%ymm14        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  196,98,125,24,61,26,245,2,0         // vbroadcastss  0x2f51a(%rip),%ymm15        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  196,65,36,84,223                    // vandps        %ymm15,%ymm11,%ymm11
  .byte  196,98,125,24,61,108,244,2,0        // vbroadcastss  0x2f46c(%rip),%ymm15        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,36,86,223                    // vorps         %ymm15,%ymm11,%ymm11
  .byte  196,98,125,24,61,2,245,2,0          // vbroadcastss  0x2f502(%rip),%ymm15        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  196,66,21,184,254                   // vfmadd231ps   %ymm14,%ymm13,%ymm15
  .byte  196,98,125,24,45,248,244,2,0        // vbroadcastss  0x2f4f8(%rip),%ymm13        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,66,37,172,239                   // vfnmadd213ps  %ymm15,%ymm11,%ymm13
  .byte  196,98,125,24,53,238,244,2,0        // vbroadcastss  0x2f4ee(%rip),%ymm14        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,65,36,88,222                    // vaddps        %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,228,244,2,0        // vbroadcastss  0x2f4e4(%rip),%ymm14        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,12,94,219                    // vdivps        %ymm11,%ymm14,%ymm11
  .byte  196,65,20,92,219                    // vsubps        %ymm11,%ymm13,%ymm11
  .byte  196,65,28,89,219                    // vmulps        %ymm11,%ymm12,%ymm11
  .byte  196,67,125,8,227,1                  // vroundps      $0x1,%ymm11,%ymm12
  .byte  196,65,36,92,228                    // vsubps        %ymm12,%ymm11,%ymm12
  .byte  196,98,125,24,45,197,244,2,0        // vbroadcastss  0x2f4c5(%rip),%ymm13        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  196,65,36,88,221                    // vaddps        %ymm13,%ymm11,%ymm11
  .byte  196,98,125,24,45,187,244,2,0        // vbroadcastss  0x2f4bb(%rip),%ymm13        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,66,29,172,235                   // vfnmadd213ps  %ymm11,%ymm12,%ymm13
  .byte  196,98,125,24,29,177,244,2,0        // vbroadcastss  0x2f4b1(%rip),%ymm11        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  196,65,36,92,220                    // vsubps        %ymm12,%ymm11,%ymm11
  .byte  196,98,125,24,37,167,244,2,0        // vbroadcastss  0x2f4a7(%rip),%ymm12        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  196,65,28,94,219                    // vdivps        %ymm11,%ymm12,%ymm11
  .byte  196,65,20,88,219                    // vaddps        %ymm11,%ymm13,%ymm11
  .byte  196,98,125,24,37,152,244,2,0        // vbroadcastss  0x2f498(%rip),%ymm12        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  196,65,36,89,220                    // vmulps        %ymm12,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,99,37,74,210,160                // vblendvps     %ymm10,%ymm2,%ymm11,%ymm10
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,67,45,74,193,128                // vblendvps     %ymm8,%ymm9,%ymm10,%ymm8
  .byte  197,188,95,210                      // vmaxps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,170,243,2,0         // vbroadcastss  0x2f3aa(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,108,93,208                  // vminps        %ymm8,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_a_hsw
.globl _sk_parametric_a_hsw
FUNCTION(_sk_parametric_a_hsw)
_sk_parametric_a_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,16                 // vbroadcastss  0x10(%rax),%ymm8
  .byte  196,65,100,194,192,2                // vcmpleps      %ymm8,%ymm3,%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,98,125,24,80,24                 // vbroadcastss  0x18(%rax),%ymm10
  .byte  196,66,101,168,202                  // vfmadd213ps   %ymm10,%ymm3,%ymm9
  .byte  196,98,125,24,88,4                  // vbroadcastss  0x4(%rax),%ymm11
  .byte  196,98,125,24,80,8                  // vbroadcastss  0x8(%rax),%ymm10
  .byte  196,66,101,168,218                  // vfmadd213ps   %ymm10,%ymm3,%ymm11
  .byte  196,98,125,24,32                    // vbroadcastss  (%rax),%ymm12
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,36,194,211,0                    // vcmpeqps      %ymm3,%ymm11,%ymm10
  .byte  196,65,124,91,235                   // vcvtdq2ps     %ymm11,%ymm13
  .byte  196,98,125,24,53,237,243,2,0        // vbroadcastss  0x2f3ed(%rip),%ymm14        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  196,98,125,24,61,232,243,2,0        // vbroadcastss  0x2f3e8(%rip),%ymm15        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  196,65,36,84,223                    // vandps        %ymm15,%ymm11,%ymm11
  .byte  196,98,125,24,61,58,243,2,0         // vbroadcastss  0x2f33a(%rip),%ymm15        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,36,86,223                    // vorps         %ymm15,%ymm11,%ymm11
  .byte  196,98,125,24,61,208,243,2,0        // vbroadcastss  0x2f3d0(%rip),%ymm15        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  196,66,21,184,254                   // vfmadd231ps   %ymm14,%ymm13,%ymm15
  .byte  196,98,125,24,45,198,243,2,0        // vbroadcastss  0x2f3c6(%rip),%ymm13        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,66,37,172,239                   // vfnmadd213ps  %ymm15,%ymm11,%ymm13
  .byte  196,98,125,24,53,188,243,2,0        // vbroadcastss  0x2f3bc(%rip),%ymm14        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,65,36,88,222                    // vaddps        %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,178,243,2,0        // vbroadcastss  0x2f3b2(%rip),%ymm14        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,12,94,219                    // vdivps        %ymm11,%ymm14,%ymm11
  .byte  196,65,20,92,219                    // vsubps        %ymm11,%ymm13,%ymm11
  .byte  196,65,28,89,219                    // vmulps        %ymm11,%ymm12,%ymm11
  .byte  196,67,125,8,227,1                  // vroundps      $0x1,%ymm11,%ymm12
  .byte  196,65,36,92,228                    // vsubps        %ymm12,%ymm11,%ymm12
  .byte  196,98,125,24,45,147,243,2,0        // vbroadcastss  0x2f393(%rip),%ymm13        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  196,65,36,88,221                    // vaddps        %ymm13,%ymm11,%ymm11
  .byte  196,98,125,24,45,137,243,2,0        // vbroadcastss  0x2f389(%rip),%ymm13        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,66,29,172,235                   // vfnmadd213ps  %ymm11,%ymm12,%ymm13
  .byte  196,98,125,24,29,127,243,2,0        // vbroadcastss  0x2f37f(%rip),%ymm11        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  196,65,36,92,220                    // vsubps        %ymm12,%ymm11,%ymm11
  .byte  196,98,125,24,37,117,243,2,0        // vbroadcastss  0x2f375(%rip),%ymm12        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  196,65,28,94,219                    // vdivps        %ymm11,%ymm12,%ymm11
  .byte  196,65,20,88,219                    // vaddps        %ymm11,%ymm13,%ymm11
  .byte  196,98,125,24,37,102,243,2,0        // vbroadcastss  0x2f366(%rip),%ymm12        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  196,65,36,89,220                    // vmulps        %ymm12,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,99,37,74,211,160                // vblendvps     %ymm10,%ymm3,%ymm11,%ymm10
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,67,45,74,193,128                // vblendvps     %ymm8,%ymm9,%ymm10,%ymm8
  .byte  197,188,95,219                      // vmaxps        %ymm3,%ymm8,%ymm3
  .byte  196,98,125,24,5,120,242,2,0         // vbroadcastss  0x2f278(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gamma_hsw
.globl _sk_gamma_hsw
FUNCTION(_sk_gamma_hsw)
_sk_gamma_hsw:
  .byte  72,129,236,248,0,0,0                // sub           $0xf8,%rsp
  .byte  197,252,17,188,36,192,0,0,0         // vmovups       %ymm7,0xc0(%rsp)
  .byte  197,252,17,180,36,160,0,0,0         // vmovups       %ymm6,0xa0(%rsp)
  .byte  197,252,17,172,36,128,0,0,0         // vmovups       %ymm5,0x80(%rsp)
  .byte  197,252,17,100,36,96                // vmovups       %ymm4,0x60(%rsp)
  .byte  197,252,17,92,36,64                 // vmovups       %ymm3,0x40(%rsp)
  .byte  197,252,17,84,36,224                // vmovups       %ymm2,-0x20(%rsp)
  .byte  197,252,17,12,36                    // vmovups       %ymm1,(%rsp)
  .byte  197,124,91,208                      // vcvtdq2ps     %ymm0,%ymm10
  .byte  196,98,125,24,29,193,242,2,0        // vbroadcastss  0x2f2c1(%rip),%ymm11        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  196,226,125,24,37,188,242,2,0       // vbroadcastss  0x2f2bc(%rip),%ymm4        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  197,124,84,228                      // vandps        %ymm4,%ymm0,%ymm12
  .byte  196,226,125,24,29,15,242,2,0        // vbroadcastss  0x2f20f(%rip),%ymm3        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,252,17,92,36,32                 // vmovups       %ymm3,0x20(%rsp)
  .byte  197,28,86,227                       // vorps         %ymm3,%ymm12,%ymm12
  .byte  196,98,125,24,45,160,242,2,0        // vbroadcastss  0x2f2a0(%rip),%ymm13        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  196,66,37,168,213                   // vfmadd213ps   %ymm13,%ymm11,%ymm10
  .byte  197,124,91,241                      // vcvtdq2ps     %ymm1,%ymm14
  .byte  196,66,37,168,245                   // vfmadd213ps   %ymm13,%ymm11,%ymm14
  .byte  197,124,91,250                      // vcvtdq2ps     %ymm2,%ymm15
  .byte  196,66,37,168,253                   // vfmadd213ps   %ymm13,%ymm11,%ymm15
  .byte  196,226,125,24,45,132,242,2,0       // vbroadcastss  0x2f284(%rip),%ymm5        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,98,29,188,213                   // vfnmadd231ps  %ymm5,%ymm12,%ymm10
  .byte  196,226,125,24,13,122,242,2,0       // vbroadcastss  0x2f27a(%rip),%ymm1        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  197,252,17,76,36,160                // vmovups       %ymm1,-0x60(%rsp)
  .byte  197,28,88,225                       // vaddps        %ymm1,%ymm12,%ymm12
  .byte  196,98,125,24,5,107,242,2,0         // vbroadcastss  0x2f26b(%rip),%ymm8        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,60,94,228                    // vdivps        %ymm12,%ymm8,%ymm12
  .byte  197,124,17,68,36,128                // vmovups       %ymm8,-0x80(%rsp)
  .byte  196,65,44,92,212                    // vsubps        %ymm12,%ymm10,%ymm10
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,40                    // vbroadcastss  (%rax),%ymm13
  .byte  196,65,44,89,213                    // vmulps        %ymm13,%ymm10,%ymm10
  .byte  196,195,125,8,250,1                 // vroundps      $0x1,%ymm10,%ymm7
  .byte  197,172,92,255                      // vsubps        %ymm7,%ymm10,%ymm7
  .byte  196,98,125,24,29,64,242,2,0         // vbroadcastss  0x2f240(%rip),%ymm11        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,98,125,24,37,54,242,2,0         // vbroadcastss  0x2f236(%rip),%ymm12        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,66,69,188,212                   // vfnmadd231ps  %ymm12,%ymm7,%ymm10
  .byte  196,98,125,24,13,44,242,2,0         // vbroadcastss  0x2f22c(%rip),%ymm9        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  197,180,92,255                      // vsubps        %ymm7,%ymm9,%ymm7
  .byte  196,226,125,24,13,35,242,2,0        // vbroadcastss  0x2f223(%rip),%ymm1        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  197,244,94,255                      // vdivps        %ymm7,%ymm1,%ymm7
  .byte  197,172,88,255                      // vaddps        %ymm7,%ymm10,%ymm7
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,193,124,194,242,0               // vcmpeqps      %ymm10,%ymm0,%ymm6
  .byte  196,226,125,24,29,11,242,2,0        // vbroadcastss  0x2f20b(%rip),%ymm3        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  197,196,89,251                      // vmulps        %ymm3,%ymm7,%ymm7
  .byte  197,253,91,255                      // vcvtps2dq     %ymm7,%ymm7
  .byte  196,195,69,74,194,96                // vblendvps     %ymm6,%ymm10,%ymm7,%ymm0
  .byte  197,252,17,68,36,192                // vmovups       %ymm0,-0x40(%rsp)
  .byte  197,252,16,4,36                     // vmovups       (%rsp),%ymm0
  .byte  197,252,84,244                      // vandps        %ymm4,%ymm0,%ymm6
  .byte  197,252,16,84,36,32                 // vmovups       0x20(%rsp),%ymm2
  .byte  197,204,86,242                      // vorps         %ymm2,%ymm6,%ymm6
  .byte  196,98,77,188,245                   // vfnmadd231ps  %ymm5,%ymm6,%ymm14
  .byte  197,252,16,124,36,160               // vmovups       -0x60(%rsp),%ymm7
  .byte  197,204,88,247                      // vaddps        %ymm7,%ymm6,%ymm6
  .byte  197,188,94,246                      // vdivps        %ymm6,%ymm8,%ymm6
  .byte  197,140,92,246                      // vsubps        %ymm6,%ymm14,%ymm6
  .byte  196,193,76,89,245                   // vmulps        %ymm13,%ymm6,%ymm6
  .byte  196,99,125,8,246,1                  // vroundps      $0x1,%ymm6,%ymm14
  .byte  196,65,76,92,246                    // vsubps        %ymm14,%ymm6,%ymm14
  .byte  196,193,76,88,243                   // vaddps        %ymm11,%ymm6,%ymm6
  .byte  196,194,13,188,244                  // vfnmadd231ps  %ymm12,%ymm14,%ymm6
  .byte  196,65,52,92,246                    // vsubps        %ymm14,%ymm9,%ymm14
  .byte  196,65,116,94,246                   // vdivps        %ymm14,%ymm1,%ymm14
  .byte  196,193,76,88,246                   // vaddps        %ymm14,%ymm6,%ymm6
  .byte  196,65,124,194,242,0                // vcmpeqps      %ymm10,%ymm0,%ymm14
  .byte  197,204,89,243                      // vmulps        %ymm3,%ymm6,%ymm6
  .byte  197,253,91,246                      // vcvtps2dq     %ymm6,%ymm6
  .byte  196,195,77,74,242,224               // vblendvps     %ymm14,%ymm10,%ymm6,%ymm6
  .byte  197,124,16,116,36,224               // vmovups       -0x20(%rsp),%ymm14
  .byte  197,12,84,196                       // vandps        %ymm4,%ymm14,%ymm8
  .byte  197,60,86,194                       // vorps         %ymm2,%ymm8,%ymm8
  .byte  196,98,61,188,253                   // vfnmadd231ps  %ymm5,%ymm8,%ymm15
  .byte  197,60,88,199                       // vaddps        %ymm7,%ymm8,%ymm8
  .byte  197,252,16,68,36,128                // vmovups       -0x80(%rsp),%ymm0
  .byte  196,193,124,94,232                  // vdivps        %ymm8,%ymm0,%ymm5
  .byte  197,132,92,237                      // vsubps        %ymm5,%ymm15,%ymm5
  .byte  196,193,84,89,237                   // vmulps        %ymm13,%ymm5,%ymm5
  .byte  196,99,125,8,197,1                  // vroundps      $0x1,%ymm5,%ymm8
  .byte  196,65,84,92,192                    // vsubps        %ymm8,%ymm5,%ymm8
  .byte  196,193,84,88,227                   // vaddps        %ymm11,%ymm5,%ymm4
  .byte  196,194,61,188,228                  // vfnmadd231ps  %ymm12,%ymm8,%ymm4
  .byte  196,193,52,92,208                   // vsubps        %ymm8,%ymm9,%ymm2
  .byte  197,244,94,202                      // vdivps        %ymm2,%ymm1,%ymm1
  .byte  197,220,88,201                      // vaddps        %ymm1,%ymm4,%ymm1
  .byte  197,244,89,195                      // vmulps        %ymm3,%ymm1,%ymm0
  .byte  196,193,12,194,202,0                // vcmpeqps      %ymm10,%ymm14,%ymm1
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,195,125,74,210,16               // vblendvps     %ymm1,%ymm10,%ymm0,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,68,36,192                // vmovups       -0x40(%rsp),%ymm0
  .byte  197,252,40,206                      // vmovaps       %ymm6,%ymm1
  .byte  197,252,16,92,36,64                 // vmovups       0x40(%rsp),%ymm3
  .byte  197,252,16,100,36,96                // vmovups       0x60(%rsp),%ymm4
  .byte  197,252,16,172,36,128,0,0,0         // vmovups       0x80(%rsp),%ymm5
  .byte  197,252,16,180,36,160,0,0,0         // vmovups       0xa0(%rsp),%ymm6
  .byte  197,252,16,188,36,192,0,0,0         // vmovups       0xc0(%rsp),%ymm7
  .byte  72,129,196,248,0,0,0                // add           $0xf8,%rsp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gamma_dst_hsw
.globl _sk_gamma_dst_hsw
FUNCTION(_sk_gamma_dst_hsw)
_sk_gamma_dst_hsw:
  .byte  72,129,236,216,0,0,0                // sub           $0xd8,%rsp
  .byte  197,252,17,188,36,160,0,0,0         // vmovups       %ymm7,0xa0(%rsp)
  .byte  197,252,17,116,36,128               // vmovups       %ymm6,-0x80(%rsp)
  .byte  197,252,17,156,36,128,0,0,0         // vmovups       %ymm3,0x80(%rsp)
  .byte  197,252,17,84,36,96                 // vmovups       %ymm2,0x60(%rsp)
  .byte  197,252,17,76,36,64                 // vmovups       %ymm1,0x40(%rsp)
  .byte  197,252,17,68,36,32                 // vmovups       %ymm0,0x20(%rsp)
  .byte  197,124,91,212                      // vcvtdq2ps     %ymm4,%ymm10
  .byte  196,98,125,24,29,141,240,2,0        // vbroadcastss  0x2f08d(%rip),%ymm11        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  196,226,125,24,5,136,240,2,0        // vbroadcastss  0x2f088(%rip),%ymm0        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  197,92,84,224                       // vandps        %ymm0,%ymm4,%ymm12
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  197,252,40,220                      // vmovaps       %ymm4,%ymm3
  .byte  196,226,125,24,5,211,239,2,0        // vbroadcastss  0x2efd3(%rip),%ymm0        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,252,17,4,36                     // vmovups       %ymm0,(%rsp)
  .byte  197,28,86,224                       // vorps         %ymm0,%ymm12,%ymm12
  .byte  196,98,125,24,45,101,240,2,0        // vbroadcastss  0x2f065(%rip),%ymm13        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  196,66,37,168,213                   // vfmadd213ps   %ymm13,%ymm11,%ymm10
  .byte  197,252,40,197                      // vmovaps       %ymm5,%ymm0
  .byte  197,124,91,240                      // vcvtdq2ps     %ymm0,%ymm14
  .byte  196,66,37,168,245                   // vfmadd213ps   %ymm13,%ymm11,%ymm14
  .byte  197,124,91,124,36,128               // vcvtdq2ps     -0x80(%rsp),%ymm15
  .byte  196,66,37,168,253                   // vfmadd213ps   %ymm13,%ymm11,%ymm15
  .byte  196,226,125,24,45,67,240,2,0        // vbroadcastss  0x2f043(%rip),%ymm5        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,98,29,188,213                   // vfnmadd231ps  %ymm5,%ymm12,%ymm10
  .byte  196,226,125,24,13,57,240,2,0        // vbroadcastss  0x2f039(%rip),%ymm1        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  197,252,17,76,36,192                // vmovups       %ymm1,-0x40(%rsp)
  .byte  197,28,88,225                       // vaddps        %ymm1,%ymm12,%ymm12
  .byte  196,98,125,24,13,42,240,2,0         // vbroadcastss  0x2f02a(%rip),%ymm9        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,52,94,228                    // vdivps        %ymm12,%ymm9,%ymm12
  .byte  197,124,17,76,36,160                // vmovups       %ymm9,-0x60(%rsp)
  .byte  196,65,44,92,212                    // vsubps        %ymm12,%ymm10,%ymm10
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,40                    // vbroadcastss  (%rax),%ymm13
  .byte  196,65,44,89,213                    // vmulps        %ymm13,%ymm10,%ymm10
  .byte  196,195,125,8,250,1                 // vroundps      $0x1,%ymm10,%ymm7
  .byte  197,172,92,255                      // vsubps        %ymm7,%ymm10,%ymm7
  .byte  196,98,125,24,29,255,239,2,0        // vbroadcastss  0x2efff(%rip),%ymm11        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,98,125,24,37,245,239,2,0        // vbroadcastss  0x2eff5(%rip),%ymm12        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,66,69,188,212                   // vfnmadd231ps  %ymm12,%ymm7,%ymm10
  .byte  196,98,125,24,5,235,239,2,0         // vbroadcastss  0x2efeb(%rip),%ymm8        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  197,188,92,255                      // vsubps        %ymm7,%ymm8,%ymm7
  .byte  196,226,125,24,13,226,239,2,0       // vbroadcastss  0x2efe2(%rip),%ymm1        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  197,244,94,255                      // vdivps        %ymm7,%ymm1,%ymm7
  .byte  197,172,88,255                      // vaddps        %ymm7,%ymm10,%ymm7
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,193,100,194,242,0               // vcmpeqps      %ymm10,%ymm3,%ymm6
  .byte  196,226,125,24,29,202,239,2,0       // vbroadcastss  0x2efca(%rip),%ymm3        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  197,196,89,251                      // vmulps        %ymm3,%ymm7,%ymm7
  .byte  197,253,91,255                      // vcvtps2dq     %ymm7,%ymm7
  .byte  196,195,69,74,226,96                // vblendvps     %ymm6,%ymm10,%ymm7,%ymm4
  .byte  197,252,17,100,36,224               // vmovups       %ymm4,-0x20(%rsp)
  .byte  197,252,40,226                      // vmovaps       %ymm2,%ymm4
  .byte  197,252,84,244                      // vandps        %ymm4,%ymm0,%ymm6
  .byte  197,252,16,20,36                    // vmovups       (%rsp),%ymm2
  .byte  197,204,86,242                      // vorps         %ymm2,%ymm6,%ymm6
  .byte  196,98,77,188,245                   // vfnmadd231ps  %ymm5,%ymm6,%ymm14
  .byte  197,252,16,124,36,192               // vmovups       -0x40(%rsp),%ymm7
  .byte  197,204,88,247                      // vaddps        %ymm7,%ymm6,%ymm6
  .byte  197,180,94,246                      // vdivps        %ymm6,%ymm9,%ymm6
  .byte  197,140,92,246                      // vsubps        %ymm6,%ymm14,%ymm6
  .byte  196,193,76,89,245                   // vmulps        %ymm13,%ymm6,%ymm6
  .byte  196,99,125,8,246,1                  // vroundps      $0x1,%ymm6,%ymm14
  .byte  196,65,76,92,246                    // vsubps        %ymm14,%ymm6,%ymm14
  .byte  196,193,76,88,243                   // vaddps        %ymm11,%ymm6,%ymm6
  .byte  196,194,13,188,244                  // vfnmadd231ps  %ymm12,%ymm14,%ymm6
  .byte  196,65,60,92,246                    // vsubps        %ymm14,%ymm8,%ymm14
  .byte  196,65,116,94,246                   // vdivps        %ymm14,%ymm1,%ymm14
  .byte  196,193,76,88,246                   // vaddps        %ymm14,%ymm6,%ymm6
  .byte  196,65,124,194,242,0                // vcmpeqps      %ymm10,%ymm0,%ymm14
  .byte  197,204,89,243                      // vmulps        %ymm3,%ymm6,%ymm6
  .byte  197,253,91,246                      // vcvtps2dq     %ymm6,%ymm6
  .byte  196,67,77,74,242,224                // vblendvps     %ymm14,%ymm10,%ymm6,%ymm14
  .byte  197,124,16,76,36,128                // vmovups       -0x80(%rsp),%ymm9
  .byte  197,180,84,244                      // vandps        %ymm4,%ymm9,%ymm6
  .byte  197,204,86,242                      // vorps         %ymm2,%ymm6,%ymm6
  .byte  196,98,77,188,253                   // vfnmadd231ps  %ymm5,%ymm6,%ymm15
  .byte  197,204,88,247                      // vaddps        %ymm7,%ymm6,%ymm6
  .byte  197,252,16,68,36,160                // vmovups       -0x60(%rsp),%ymm0
  .byte  197,252,94,238                      // vdivps        %ymm6,%ymm0,%ymm5
  .byte  197,132,92,237                      // vsubps        %ymm5,%ymm15,%ymm5
  .byte  196,193,84,89,237                   // vmulps        %ymm13,%ymm5,%ymm5
  .byte  196,227,125,8,245,1                 // vroundps      $0x1,%ymm5,%ymm6
  .byte  197,212,92,246                      // vsubps        %ymm6,%ymm5,%ymm6
  .byte  196,193,84,88,227                   // vaddps        %ymm11,%ymm5,%ymm4
  .byte  196,194,77,188,228                  // vfnmadd231ps  %ymm12,%ymm6,%ymm4
  .byte  197,188,92,214                      // vsubps        %ymm6,%ymm8,%ymm2
  .byte  197,244,94,202                      // vdivps        %ymm2,%ymm1,%ymm1
  .byte  197,220,88,201                      // vaddps        %ymm1,%ymm4,%ymm1
  .byte  197,244,89,195                      // vmulps        %ymm3,%ymm1,%ymm0
  .byte  196,193,52,194,202,0                // vcmpeqps      %ymm10,%ymm9,%ymm1
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,195,125,74,242,16               // vblendvps     %ymm1,%ymm10,%ymm0,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,68,36,32                 // vmovups       0x20(%rsp),%ymm0
  .byte  197,252,16,76,36,64                 // vmovups       0x40(%rsp),%ymm1
  .byte  197,252,16,84,36,96                 // vmovups       0x60(%rsp),%ymm2
  .byte  197,252,16,156,36,128,0,0,0         // vmovups       0x80(%rsp),%ymm3
  .byte  197,252,16,100,36,224               // vmovups       -0x20(%rsp),%ymm4
  .byte  197,124,41,245                      // vmovaps       %ymm14,%ymm5
  .byte  197,252,16,188,36,160,0,0,0         // vmovups       0xa0(%rsp),%ymm7
  .byte  72,129,196,216,0,0,0                // add           $0xd8,%rsp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lab_to_xyz_hsw
.globl _sk_lab_to_xyz_hsw
FUNCTION(_sk_lab_to_xyz_hsw)
_sk_lab_to_xyz_hsw:
  .byte  196,98,125,24,5,181,238,2,0         // vbroadcastss  0x2eeb5(%rip),%ymm8        # 3a2dc <_sk_srcover_bgra_8888_sse2_lowp+0x374>
  .byte  196,98,125,24,13,20,238,2,0         // vbroadcastss  0x2ee14(%rip),%ymm9        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,98,125,24,21,167,238,2,0        // vbroadcastss  0x2eea7(%rip),%ymm10        # 3a2e0 <_sk_srcover_bgra_8888_sse2_lowp+0x378>
  .byte  196,194,53,168,202                  // vfmadd213ps   %ymm10,%ymm9,%ymm1
  .byte  196,194,53,168,210                  // vfmadd213ps   %ymm10,%ymm9,%ymm2
  .byte  196,98,125,24,13,152,238,2,0        // vbroadcastss  0x2ee98(%rip),%ymm9        # 3a2e4 <_sk_srcover_bgra_8888_sse2_lowp+0x37c>
  .byte  196,66,125,184,200                  // vfmadd231ps   %ymm8,%ymm0,%ymm9
  .byte  196,226,125,24,5,142,238,2,0        // vbroadcastss  0x2ee8e(%rip),%ymm0        # 3a2e8 <_sk_srcover_bgra_8888_sse2_lowp+0x380>
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  196,98,125,24,5,133,238,2,0         // vbroadcastss  0x2ee85(%rip),%ymm8        # 3a2ec <_sk_srcover_bgra_8888_sse2_lowp+0x384>
  .byte  196,98,117,168,192                  // vfmadd213ps   %ymm0,%ymm1,%ymm8
  .byte  196,98,125,24,13,123,238,2,0        // vbroadcastss  0x2ee7b(%rip),%ymm9        # 3a2f0 <_sk_srcover_bgra_8888_sse2_lowp+0x388>
  .byte  196,98,109,172,200                  // vfnmadd213ps  %ymm0,%ymm2,%ymm9
  .byte  196,193,60,89,200                   // vmulps        %ymm8,%ymm8,%ymm1
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  196,226,125,24,21,104,238,2,0       // vbroadcastss  0x2ee68(%rip),%ymm2        # 3a2f4 <_sk_srcover_bgra_8888_sse2_lowp+0x38c>
  .byte  197,108,194,209,1                   // vcmpltps      %ymm1,%ymm2,%ymm10
  .byte  196,98,125,24,29,94,238,2,0         // vbroadcastss  0x2ee5e(%rip),%ymm11        # 3a2f8 <_sk_srcover_bgra_8888_sse2_lowp+0x390>
  .byte  196,65,60,88,195                    // vaddps        %ymm11,%ymm8,%ymm8
  .byte  196,98,125,24,37,84,238,2,0         // vbroadcastss  0x2ee54(%rip),%ymm12        # 3a2fc <_sk_srcover_bgra_8888_sse2_lowp+0x394>
  .byte  196,65,60,89,196                    // vmulps        %ymm12,%ymm8,%ymm8
  .byte  196,99,61,74,193,160                // vblendvps     %ymm10,%ymm1,%ymm8,%ymm8
  .byte  197,252,89,200                      // vmulps        %ymm0,%ymm0,%ymm1
  .byte  197,252,89,201                      // vmulps        %ymm1,%ymm0,%ymm1
  .byte  197,108,194,209,1                   // vcmpltps      %ymm1,%ymm2,%ymm10
  .byte  196,193,124,88,195                  // vaddps        %ymm11,%ymm0,%ymm0
  .byte  196,193,124,89,196                  // vmulps        %ymm12,%ymm0,%ymm0
  .byte  196,227,125,74,201,160              // vblendvps     %ymm10,%ymm1,%ymm0,%ymm1
  .byte  196,193,52,89,193                   // vmulps        %ymm9,%ymm9,%ymm0
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  197,236,194,208,1                   // vcmpltps      %ymm0,%ymm2,%ymm2
  .byte  196,65,52,88,203                    // vaddps        %ymm11,%ymm9,%ymm9
  .byte  196,65,52,89,204                    // vmulps        %ymm12,%ymm9,%ymm9
  .byte  196,227,53,74,208,32                // vblendvps     %ymm2,%ymm0,%ymm9,%ymm2
  .byte  196,226,125,24,5,9,238,2,0          // vbroadcastss  0x2ee09(%rip),%ymm0        # 3a300 <_sk_srcover_bgra_8888_sse2_lowp+0x398>
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  196,98,125,24,5,0,238,2,0           // vbroadcastss  0x2ee00(%rip),%ymm8        # 3a304 <_sk_srcover_bgra_8888_sse2_lowp+0x39c>
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_a8_hsw
.globl _sk_load_a8_hsw
FUNCTION(_sk_load_a8_hsw)
_sk_load_a8_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,52                              // jne           b559 <_sk_load_a8_hsw+0x4c>
  .byte  196,130,121,48,4,24                 // vpmovzxbw     (%r8,%r11,1),%xmm0
  .byte  197,249,219,5,189,245,2,0           // vpand         0x2f5bd(%rip),%xmm0,%xmm0        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,226,125,51,192                  // vpmovzxwd     %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,75,237,2,0        // vbroadcastss  0x2ed4b(%rip),%ymm1        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,252,89,217                      // vmulps        %ymm1,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,190                             // ja            b52b <_sk_load_a8_hsw+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,120,0,0,0                 // lea           0x78(%rip),%r10        # b5f0 <_sk_load_a8_hsw+0xe3>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  235,159                             // jmp           b52b <_sk_load_a8_hsw+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,249,196,192,2                   // vpinsrw       $0x2,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,24                      // movzwl        (%r8,%r11,1),%eax
  .byte  197,249,110,200                     // vmovd         %eax,%xmm1
  .byte  196,226,121,48,201                  // vpmovzxbw     %xmm1,%xmm1
  .byte  196,227,121,2,193,1                 // vpblendd      $0x1,%xmm1,%xmm0,%xmm0
  .byte  233,119,255,255,255                 // jmpq          b52b <_sk_load_a8_hsw+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,249,196,192,6                   // vpinsrw       $0x6,%eax,%xmm0,%xmm0
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,249,196,192,5                   // vpinsrw       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,249,196,192,4                   // vpinsrw       $0x4,%eax,%xmm0,%xmm0
  .byte  196,129,121,110,12,24               // vmovd         (%r8,%r11,1),%xmm1
  .byte  196,226,121,48,201                  // vpmovzxbw     %xmm1,%xmm1
  .byte  196,227,113,2,192,12                // vpblendd      $0xc,%xmm0,%xmm1,%xmm0
  .byte  233,60,255,255,255                  // jmpq          b52b <_sk_load_a8_hsw+0x1e>
  .byte  144                                 // nop
  .byte  145                                 // xchg          %eax,%ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,171,255,255,255,156             // ljmp          *-0x63000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  233,255,255,255,222                 // jmpq          ffffffffdf00b600 <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffdefd1698>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,211                             // callq         *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_a8_dst_hsw
.globl _sk_load_a8_dst_hsw
FUNCTION(_sk_load_a8_dst_hsw)
_sk_load_a8_dst_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,52                              // jne           b658 <_sk_load_a8_dst_hsw+0x4c>
  .byte  196,130,121,48,36,24                // vpmovzxbw     (%r8,%r11,1),%xmm4
  .byte  197,217,219,37,190,244,2,0          // vpand         0x2f4be(%rip),%xmm4,%xmm4        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,226,125,51,228                  // vpmovzxwd     %xmm4,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,226,125,24,45,76,236,2,0        // vbroadcastss  0x2ec4c(%rip),%ymm5        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,220,89,253                      // vmulps        %ymm5,%ymm4,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,190                             // ja            b62a <_sk_load_a8_dst_hsw+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,121,0,0,0                 // lea           0x79(%rip),%r10        # b6f0 <_sk_load_a8_dst_hsw+0xe4>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  235,159                             // jmp           b62a <_sk_load_a8_dst_hsw+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  197,217,196,224,2                   // vpinsrw       $0x2,%eax,%xmm4,%xmm4
  .byte  67,15,183,4,24                      // movzwl        (%r8,%r11,1),%eax
  .byte  197,249,110,232                     // vmovd         %eax,%xmm5
  .byte  196,226,121,48,237                  // vpmovzxbw     %xmm5,%xmm5
  .byte  196,227,89,2,229,1                  // vpblendd      $0x1,%xmm5,%xmm4,%xmm4
  .byte  233,119,255,255,255                 // jmpq          b62a <_sk_load_a8_dst_hsw+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  197,217,196,224,6                   // vpinsrw       $0x6,%eax,%xmm4,%xmm4
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,217,196,224,5                   // vpinsrw       $0x5,%eax,%xmm4,%xmm4
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,217,196,224,4                   // vpinsrw       $0x4,%eax,%xmm4,%xmm4
  .byte  196,129,121,110,44,24               // vmovd         (%r8,%r11,1),%xmm5
  .byte  196,226,121,48,237                  // vpmovzxbw     %xmm5,%xmm5
  .byte  196,227,81,2,228,12                 // vpblendd      $0xc,%xmm4,%xmm5,%xmm4
  .byte  233,60,255,255,255                  // jmpq          b62a <_sk_load_a8_dst_hsw+0x1e>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  144                                 // nop
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,170,255,255,255,155             // ljmp          *-0x64000001(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  232,255,255,255,221                 // callq         ffffffffde00b700 <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffddfd1798>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,195                             // inc           %ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_a8_hsw
.globl _sk_gather_a8_hsw
FUNCTION(_sk_gather_a8_hsw)
_sk_gather_a8_hsw:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  196,226,125,88,80,8                 // vpbroadcastd  0x8(%rax),%ymm2
  .byte  196,226,109,64,201                  // vpmulld       %ymm1,%ymm2,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  196,227,249,22,192,1                // vpextrq       $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,194                 // vmovq         %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  71,15,182,28,24                     // movzbl        (%r8,%r11,1),%r11d
  .byte  196,193,121,110,195                 // vmovd         %r11d,%xmm0
  .byte  196,195,121,32,194,1                // vpinsrb       $0x1,%r10d,%xmm0,%xmm0
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,121,32,192,3                // vpinsrb       $0x3,%eax,%xmm0,%xmm0
  .byte  67,15,182,4,32                      // movzbl        (%r8,%r12,1),%eax
  .byte  196,227,121,32,192,4                // vpinsrb       $0x4,%eax,%xmm0,%xmm0
  .byte  67,15,182,4,56                      // movzbl        (%r8,%r15,1),%eax
  .byte  196,227,121,32,192,5                // vpinsrb       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,182,4,48                      // movzbl        (%r8,%r14,1),%eax
  .byte  196,227,121,32,192,6                // vpinsrb       $0x6,%eax,%xmm0,%xmm0
  .byte  65,15,182,4,24                      // movzbl        (%r8,%rbx,1),%eax
  .byte  196,227,121,32,192,7                // vpinsrb       $0x7,%eax,%xmm0,%xmm0
  .byte  196,226,125,49,192                  // vpmovzxbd     %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,147,234,2,0       // vbroadcastss  0x2ea93(%rip),%ymm1        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,252,89,217                      // vmulps        %ymm1,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,237,239,210                     // vpxor         %ymm2,%ymm2,%ymm2
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_a8_hsw
.globl _sk_store_a8_hsw
FUNCTION(_sk_store_a8_hsw)
_sk_store_a8_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,98,125,24,13,219,233,2,0        // vbroadcastss  0x2e9db(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,60,93,193                    // vminps        %ymm9,%ymm8,%ymm8
  .byte  196,98,125,24,13,249,233,2,0        // vbroadcastss  0x2e9f9(%rip),%ymm9        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,66,57,43,193                    // vpackusdw     %xmm9,%xmm8,%xmm8
  .byte  197,57,103,192                      // vpackuswb     %xmm0,%xmm8,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           b873 <_sk_store_a8_hsw+0x5b>
  .byte  196,1,121,214,4,24                  // vmovq         %xmm8,(%r8,%r11,1)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,236                             // ja            b86f <_sk_store_a8_hsw+0x57>
  .byte  196,66,121,48,192                   // vpmovzxbw     %xmm8,%xmm8
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,85,0,0,0                  // lea           0x55(%rip),%r10        # b8e8 <_sk_store_a8_hsw+0xd0>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,3,121,20,4,24,0                 // vpextrb       $0x0,%xmm8,(%r8,%r11,1)
  .byte  235,202                             // jmp           b86f <_sk_store_a8_hsw+0x57>
  .byte  196,3,121,20,68,24,2,4              // vpextrb       $0x4,%xmm8,0x2(%r8,%r11,1)
  .byte  196,98,57,0,5,74,242,2,0            // vpshufb       0x2f24a(%rip),%xmm8,%xmm8        # 3ab00 <_sk_srcover_bgra_8888_sse2_lowp+0xb98>
  .byte  196,3,121,21,4,24,0                 // vpextrw       $0x0,%xmm8,(%r8,%r11,1)
  .byte  235,176                             // jmp           b86f <_sk_store_a8_hsw+0x57>
  .byte  196,3,121,20,68,24,6,12             // vpextrb       $0xc,%xmm8,0x6(%r8,%r11,1)
  .byte  196,3,121,20,68,24,5,10             // vpextrb       $0xa,%xmm8,0x5(%r8,%r11,1)
  .byte  196,3,121,20,68,24,4,8              // vpextrb       $0x8,%xmm8,0x4(%r8,%r11,1)
  .byte  196,98,57,0,5,48,242,2,0            // vpshufb       0x2f230(%rip),%xmm8,%xmm8        # 3ab10 <_sk_srcover_bgra_8888_sse2_lowp+0xba8>
  .byte  196,1,121,126,4,24                  // vmovd         %xmm8,(%r8,%r11,1)
  .byte  235,135                             // jmp           b86f <_sk_store_a8_hsw+0x57>
  .byte  180,255                             // mov           $0xff,%ah
  .byte  255                                 // (bad)
  .byte  255,197                             // inc           %ebp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  189,255,255,255,239                 // mov           $0xefffffff,%ebp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,231                             // jmpq          *%rdi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  223,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,215                             // callq         *%rdi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_g8_hsw
.globl _sk_load_g8_hsw
FUNCTION(_sk_load_g8_hsw)
_sk_load_g8_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,57                              // jne           b955 <_sk_load_g8_hsw+0x51>
  .byte  196,130,121,48,4,24                 // vpmovzxbw     (%r8,%r11,1),%xmm0
  .byte  197,249,219,5,198,241,2,0           // vpand         0x2f1c6(%rip),%xmm0,%xmm0        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,226,125,51,192                  // vpmovzxwd     %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,84,233,2,0        // vbroadcastss  0x2e954(%rip),%ymm1        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,252,89,193                      // vmulps        %ymm1,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,205,232,2,0       // vbroadcastss  0x2e8cd(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,185                             // ja            b922 <_sk_load_g8_hsw+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,120,0,0,0                 // lea           0x78(%rip),%r10        # b9ec <_sk_load_g8_hsw+0xe8>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  235,154                             // jmp           b922 <_sk_load_g8_hsw+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,249,196,192,2                   // vpinsrw       $0x2,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,24                      // movzwl        (%r8,%r11,1),%eax
  .byte  197,249,110,200                     // vmovd         %eax,%xmm1
  .byte  196,226,121,48,201                  // vpmovzxbw     %xmm1,%xmm1
  .byte  196,227,121,2,193,1                 // vpblendd      $0x1,%xmm1,%xmm0,%xmm0
  .byte  233,114,255,255,255                 // jmpq          b922 <_sk_load_g8_hsw+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,249,196,192,6                   // vpinsrw       $0x6,%eax,%xmm0,%xmm0
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,249,196,192,5                   // vpinsrw       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,249,196,192,4                   // vpinsrw       $0x4,%eax,%xmm0,%xmm0
  .byte  196,129,121,110,12,24               // vmovd         (%r8,%r11,1),%xmm1
  .byte  196,226,121,48,201                  // vpmovzxbw     %xmm1,%xmm1
  .byte  196,227,113,2,192,12                // vpblendd      $0xc,%xmm0,%xmm1,%xmm0
  .byte  233,55,255,255,255                  // jmpq          b922 <_sk_load_g8_hsw+0x1e>
  .byte  144                                 // nop
  .byte  145                                 // xchg          %eax,%ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,171,255,255,255,156             // ljmp          *-0x63000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  233,255,255,255,222                 // jmpq          ffffffffdf00b9fc <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffdefd1a94>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,211                             // callq         *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_g8_dst_hsw
.globl _sk_load_g8_dst_hsw
FUNCTION(_sk_load_g8_dst_hsw)
_sk_load_g8_dst_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,57                              // jne           ba59 <_sk_load_g8_dst_hsw+0x51>
  .byte  196,130,121,48,36,24                // vpmovzxbw     (%r8,%r11,1),%xmm4
  .byte  197,217,219,37,194,240,2,0          // vpand         0x2f0c2(%rip),%xmm4,%xmm4        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,226,125,51,228                  // vpmovzxwd     %xmm4,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,226,125,24,45,80,232,2,0        // vbroadcastss  0x2e850(%rip),%ymm5        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,220,89,229                      // vmulps        %ymm5,%ymm4,%ymm4
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,61,201,231,2,0       // vbroadcastss  0x2e7c9(%rip),%ymm7        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,40,236                      // vmovaps       %ymm4,%ymm5
  .byte  197,252,40,244                      // vmovaps       %ymm4,%ymm6
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,185                             // ja            ba26 <_sk_load_g8_dst_hsw+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,120,0,0,0                 // lea           0x78(%rip),%r10        # baf0 <_sk_load_g8_dst_hsw+0xe8>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  235,154                             // jmp           ba26 <_sk_load_g8_dst_hsw+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  197,217,196,224,2                   // vpinsrw       $0x2,%eax,%xmm4,%xmm4
  .byte  67,15,183,4,24                      // movzwl        (%r8,%r11,1),%eax
  .byte  197,249,110,232                     // vmovd         %eax,%xmm5
  .byte  196,226,121,48,237                  // vpmovzxbw     %xmm5,%xmm5
  .byte  196,227,89,2,229,1                  // vpblendd      $0x1,%xmm5,%xmm4,%xmm4
  .byte  233,114,255,255,255                 // jmpq          ba26 <_sk_load_g8_dst_hsw+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  197,217,196,224,6                   // vpinsrw       $0x6,%eax,%xmm4,%xmm4
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,217,196,224,5                   // vpinsrw       $0x5,%eax,%xmm4,%xmm4
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,217,196,224,4                   // vpinsrw       $0x4,%eax,%xmm4,%xmm4
  .byte  196,129,121,110,44,24               // vmovd         (%r8,%r11,1),%xmm5
  .byte  196,226,121,48,237                  // vpmovzxbw     %xmm5,%xmm5
  .byte  196,227,81,2,228,12                 // vpblendd      $0xc,%xmm4,%xmm5,%xmm4
  .byte  233,55,255,255,255                  // jmpq          ba26 <_sk_load_g8_dst_hsw+0x1e>
  .byte  144                                 // nop
  .byte  145                                 // xchg          %eax,%ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,171,255,255,255,156             // ljmp          *-0x63000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  233,255,255,255,222                 // jmpq          ffffffffdf00bb00 <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffdefd1b98>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,211                             // callq         *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_g8_hsw
.globl _sk_gather_g8_hsw
FUNCTION(_sk_gather_g8_hsw)
_sk_gather_g8_hsw:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  196,226,125,88,80,8                 // vpbroadcastd  0x8(%rax),%ymm2
  .byte  196,226,109,64,201                  // vpmulld       %ymm1,%ymm2,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  196,227,249,22,192,1                // vpextrq       $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,194                 // vmovq         %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  71,15,182,28,24                     // movzbl        (%r8,%r11,1),%r11d
  .byte  196,193,121,110,195                 // vmovd         %r11d,%xmm0
  .byte  196,195,121,32,194,1                // vpinsrb       $0x1,%r10d,%xmm0,%xmm0
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,121,32,192,3                // vpinsrb       $0x3,%eax,%xmm0,%xmm0
  .byte  67,15,182,4,32                      // movzbl        (%r8,%r12,1),%eax
  .byte  196,227,121,32,192,4                // vpinsrb       $0x4,%eax,%xmm0,%xmm0
  .byte  67,15,182,4,56                      // movzbl        (%r8,%r15,1),%eax
  .byte  196,227,121,32,192,5                // vpinsrb       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,182,4,48                      // movzbl        (%r8,%r14,1),%eax
  .byte  196,227,121,32,192,6                // vpinsrb       $0x6,%eax,%xmm0,%xmm0
  .byte  65,15,182,4,24                      // movzbl        (%r8,%rbx,1),%eax
  .byte  196,227,121,32,192,7                // vpinsrb       $0x7,%eax,%xmm0,%xmm0
  .byte  196,226,125,49,192                  // vpmovzxbd     %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,147,230,2,0       // vbroadcastss  0x2e693(%rip),%ymm1        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,252,89,193                      // vmulps        %ymm1,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,12,230,2,0        // vbroadcastss  0x2e60c(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_565_hsw
.globl _sk_load_565_hsw
FUNCTION(_sk_load_565_hsw)
_sk_load_565_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,114                             // jne           bcaa <_sk_load_565_hsw+0x8d>
  .byte  196,129,122,111,4,88                // vmovdqu       (%r8,%r11,2),%xmm0
  .byte  196,226,125,51,208                  // vpmovzxwd     %xmm0,%ymm2
  .byte  196,226,125,88,5,72,230,2,0         // vpbroadcastd  0x2e648(%rip),%ymm0        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  197,237,219,192                     // vpand         %ymm0,%ymm2,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,59,230,2,0        // vbroadcastss  0x2e63b(%rip),%ymm1        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  197,252,89,193                      // vmulps        %ymm1,%ymm0,%ymm0
  .byte  196,226,125,88,13,50,230,2,0        // vpbroadcastd  0x2e632(%rip),%ymm1        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  197,237,219,201                     // vpand         %ymm1,%ymm2,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,226,125,24,29,37,230,2,0        // vbroadcastss  0x2e625(%rip),%ymm3        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  197,244,89,203                      // vmulps        %ymm3,%ymm1,%ymm1
  .byte  196,226,125,88,29,28,230,2,0        // vpbroadcastd  0x2e61c(%rip),%ymm3        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  197,237,219,211                     // vpand         %ymm3,%ymm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,226,125,24,29,15,230,2,0        // vbroadcastss  0x2e60f(%rip),%ymm3        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  197,236,89,211                      // vmulps        %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,112,229,2,0       // vbroadcastss  0x2e570(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,128                             // ja            bc3e <_sk_load_565_hsw+0x21>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,99,0,0,0                  // lea           0x63(%rip),%r10        # bd2c <_sk_load_565_hsw+0x10f>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  233,94,255,255,255                  // jmpq          bc3e <_sk_load_565_hsw+0x21>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,129,121,196,68,88,4,2           // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,110,12,88               // vmovd         (%r8,%r11,2),%xmm1
  .byte  196,227,121,2,193,1                 // vpblendd      $0x1,%xmm1,%xmm0,%xmm0
  .byte  233,65,255,255,255                  // jmpq          bc3e <_sk_load_565_hsw+0x21>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,129,121,196,68,88,12,6          // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,196,68,88,10,5          // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,196,68,88,8,4           // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,122,126,12,88               // vmovq         (%r8,%r11,2),%xmm1
  .byte  196,227,113,2,192,12                // vpblendd      $0xc,%xmm0,%xmm1,%xmm0
  .byte  233,20,255,255,255                  // jmpq          bc3e <_sk_load_565_hsw+0x21>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  166                                 // cmpsb         %es:(%rdi),%ds:(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,192                             // inc           %eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,180,255,255,255,237,255         // pushq         -0x120001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,229                             // jmpq          *%rbp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  221,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,209                             // callq         *%rcx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_565_dst_hsw
.globl _sk_load_565_dst_hsw
FUNCTION(_sk_load_565_dst_hsw)
_sk_load_565_dst_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,114                             // jne           bdd5 <_sk_load_565_dst_hsw+0x8d>
  .byte  196,129,122,111,36,88               // vmovdqu       (%r8,%r11,2),%xmm4
  .byte  196,226,125,51,244                  // vpmovzxwd     %xmm4,%ymm6
  .byte  196,226,125,88,37,29,229,2,0        // vpbroadcastd  0x2e51d(%rip),%ymm4        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  197,205,219,228                     // vpand         %ymm4,%ymm6,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,226,125,24,45,16,229,2,0        // vbroadcastss  0x2e510(%rip),%ymm5        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  197,220,89,229                      // vmulps        %ymm5,%ymm4,%ymm4
  .byte  196,226,125,88,45,7,229,2,0         // vpbroadcastd  0x2e507(%rip),%ymm5        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  197,205,219,237                     // vpand         %ymm5,%ymm6,%ymm5
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  196,226,125,24,61,250,228,2,0       // vbroadcastss  0x2e4fa(%rip),%ymm7        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  197,212,89,239                      // vmulps        %ymm7,%ymm5,%ymm5
  .byte  196,226,125,88,61,241,228,2,0       // vpbroadcastd  0x2e4f1(%rip),%ymm7        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  197,205,219,247                     // vpand         %ymm7,%ymm6,%ymm6
  .byte  197,252,91,246                      // vcvtdq2ps     %ymm6,%ymm6
  .byte  196,226,125,24,61,228,228,2,0       // vbroadcastss  0x2e4e4(%rip),%ymm7        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  197,204,89,247                      // vmulps        %ymm7,%ymm6,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,61,69,228,2,0        // vbroadcastss  0x2e445(%rip),%ymm7        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,128                             // ja            bd69 <_sk_load_565_dst_hsw+0x21>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,100,0,0,0                 // lea           0x64(%rip),%r10        # be58 <_sk_load_565_dst_hsw+0x110>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  233,94,255,255,255                  // jmpq          bd69 <_sk_load_565_dst_hsw+0x21>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,129,89,196,100,88,4,2           // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,121,110,44,88               // vmovd         (%r8,%r11,2),%xmm5
  .byte  196,227,89,2,229,1                  // vpblendd      $0x1,%xmm5,%xmm4,%xmm4
  .byte  233,65,255,255,255                  // jmpq          bd69 <_sk_load_565_dst_hsw+0x21>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,129,89,196,100,88,12,6          // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,89,196,100,88,10,5          // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,89,196,100,88,8,4           // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,122,126,44,88               // vmovq         (%r8,%r11,2),%xmm5
  .byte  196,227,81,2,228,12                 // vpblendd      $0xc,%xmm4,%xmm5,%xmm4
  .byte  233,20,255,255,255                  // jmpq          bd69 <_sk_load_565_dst_hsw+0x21>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  165                                 // movsl         %ds:(%rsi),%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  191,255,255,255,179                 // mov           $0xb3ffffff,%edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  236                                 // in            (%dx),%al
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,228                             // jmpq          *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  220,255                             // fdivr         %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_565_hsw
.globl _sk_gather_565_hsw
FUNCTION(_sk_gather_565_hsw)
_sk_gather_565_hsw:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  196,226,125,88,80,8                 // vpbroadcastd  0x8(%rax),%ymm2
  .byte  196,226,109,64,201                  // vpmulld       %ymm1,%ymm2,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  196,227,249,22,192,1                // vpextrq       $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,194                 // vmovq         %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,183,20,80                     // movzwl        (%r8,%r10,2),%r10d
  .byte  71,15,183,28,88                     // movzwl        (%r8,%r11,2),%r11d
  .byte  196,193,121,110,195                 // vmovd         %r11d,%xmm0
  .byte  196,193,121,196,194,1               // vpinsrw       $0x1,%r10d,%xmm0,%xmm0
  .byte  71,15,183,12,72                     // movzwl        (%r8,%r9,2),%r9d
  .byte  196,193,121,196,193,2               // vpinsrw       $0x2,%r9d,%xmm0,%xmm0
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,249,196,192,3                   // vpinsrw       $0x3,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,96                      // movzwl        (%r8,%r12,2),%eax
  .byte  197,249,196,192,4                   // vpinsrw       $0x4,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,120                     // movzwl        (%r8,%r15,2),%eax
  .byte  197,249,196,192,5                   // vpinsrw       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,112                     // movzwl        (%r8,%r14,2),%eax
  .byte  197,249,196,192,6                   // vpinsrw       $0x6,%eax,%xmm0,%xmm0
  .byte  65,15,183,4,88                      // movzwl        (%r8,%rbx,2),%eax
  .byte  197,249,196,192,7                   // vpinsrw       $0x7,%eax,%xmm0,%xmm0
  .byte  196,226,125,51,208                  // vpmovzxwd     %xmm0,%ymm2
  .byte  196,226,125,88,5,56,227,2,0         // vpbroadcastd  0x2e338(%rip),%ymm0        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  197,237,219,192                     // vpand         %ymm0,%ymm2,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,43,227,2,0        // vbroadcastss  0x2e32b(%rip),%ymm1        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  197,252,89,193                      // vmulps        %ymm1,%ymm0,%ymm0
  .byte  196,226,125,88,13,34,227,2,0        // vpbroadcastd  0x2e322(%rip),%ymm1        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  197,237,219,201                     // vpand         %ymm1,%ymm2,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,226,125,24,29,21,227,2,0        // vbroadcastss  0x2e315(%rip),%ymm3        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  197,244,89,203                      // vmulps        %ymm3,%ymm1,%ymm1
  .byte  196,226,125,88,29,12,227,2,0        // vpbroadcastd  0x2e30c(%rip),%ymm3        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  197,237,219,211                     // vpand         %ymm3,%ymm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,226,125,24,29,255,226,2,0       // vbroadcastss  0x2e2ff(%rip),%ymm3        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  197,236,89,211                      // vmulps        %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,96,226,2,0        // vbroadcastss  0x2e260(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_565_hsw
.globl _sk_store_565_hsw
FUNCTION(_sk_store_565_hsw)
_sk_store_565_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,98,125,24,21,47,226,2,0         // vbroadcastss  0x2e22f(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,17,227,2,0         // vbroadcastss  0x2e311(%rip),%ymm11        # 3a308 <_sk_srcover_bgra_8888_sse2_lowp+0x3a0>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  196,193,53,114,241,11               // vpslld        $0xb,%ymm9,%ymm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,98,125,24,45,243,226,2,0        // vbroadcastss  0x2e2f3(%rip),%ymm13        # 3a30c <_sk_srcover_bgra_8888_sse2_lowp+0x3a4>
  .byte  196,65,28,89,229                    // vmulps        %ymm13,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,5                // vpslld        $0x5,%ymm12,%ymm12
  .byte  196,65,29,235,201                   // vpor          %ymm9,%ymm12,%ymm9
  .byte  197,60,95,194                       // vmaxps        %ymm2,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,66,57,43,193                    // vpackusdw     %xmm9,%xmm8,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           c060 <_sk_store_565_hsw+0x9f>
  .byte  196,1,122,127,4,88                  // vmovdqu       %xmm8,(%r8,%r11,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,236                             // ja            c05c <_sk_store_565_hsw+0x9b>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,69,0,0,0                  // lea           0x45(%rip),%r10        # c0c0 <_sk_store_565_hsw+0xff>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,3,121,21,4,88,0                 // vpextrw       $0x0,%xmm8,(%r8,%r11,2)
  .byte  235,207                             // jmp           c05c <_sk_store_565_hsw+0x9b>
  .byte  196,3,121,21,68,88,4,2              // vpextrw       $0x2,%xmm8,0x4(%r8,%r11,2)
  .byte  196,1,121,126,4,88                  // vmovd         %xmm8,(%r8,%r11,2)
  .byte  235,191                             // jmp           c05c <_sk_store_565_hsw+0x9b>
  .byte  196,3,121,21,68,88,12,6             // vpextrw       $0x6,%xmm8,0xc(%r8,%r11,2)
  .byte  196,3,121,21,68,88,10,5             // vpextrw       $0x5,%xmm8,0xa(%r8,%r11,2)
  .byte  196,3,121,21,68,88,8,4              // vpextrw       $0x4,%xmm8,0x8(%r8,%r11,2)
  .byte  196,1,121,214,4,88                  // vmovq         %xmm8,(%r8,%r11,2)
  .byte  235,159                             // jmp           c05c <_sk_store_565_hsw+0x9b>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  196                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,213                             // callq         *%rbp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,205                             // dec           %ebp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,245                             // push          %rbp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  237                                 // in            (%dx),%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,229                             // jmpq          *%rbp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  221,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_4444_hsw
.globl _sk_load_4444_hsw
FUNCTION(_sk_load_4444_hsw)
_sk_load_4444_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,138,0,0,0                    // jne           c185 <_sk_load_4444_hsw+0xa9>
  .byte  196,129,122,111,4,88                // vmovdqu       (%r8,%r11,2),%xmm0
  .byte  196,226,125,51,216                  // vpmovzxwd     %xmm0,%ymm3
  .byte  196,226,125,88,5,1,226,2,0          // vpbroadcastd  0x2e201(%rip),%ymm0        # 3a310 <_sk_srcover_bgra_8888_sse2_lowp+0x3a8>
  .byte  197,229,219,192                     // vpand         %ymm0,%ymm3,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,244,225,2,0       // vbroadcastss  0x2e1f4(%rip),%ymm1        # 3a314 <_sk_srcover_bgra_8888_sse2_lowp+0x3ac>
  .byte  197,252,89,193                      // vmulps        %ymm1,%ymm0,%ymm0
  .byte  196,226,125,88,13,235,225,2,0       // vpbroadcastd  0x2e1eb(%rip),%ymm1        # 3a318 <_sk_srcover_bgra_8888_sse2_lowp+0x3b0>
  .byte  197,229,219,201                     // vpand         %ymm1,%ymm3,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,226,125,24,21,222,225,2,0       // vbroadcastss  0x2e1de(%rip),%ymm2        # 3a31c <_sk_srcover_bgra_8888_sse2_lowp+0x3b4>
  .byte  197,244,89,202                      // vmulps        %ymm2,%ymm1,%ymm1
  .byte  196,226,125,88,21,213,225,2,0       // vpbroadcastd  0x2e1d5(%rip),%ymm2        # 3a320 <_sk_srcover_bgra_8888_sse2_lowp+0x3b8>
  .byte  197,229,219,210                     // vpand         %ymm2,%ymm3,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,98,125,24,5,200,225,2,0         // vbroadcastss  0x2e1c8(%rip),%ymm8        # 3a324 <_sk_srcover_bgra_8888_sse2_lowp+0x3bc>
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  196,98,125,88,5,190,225,2,0         // vpbroadcastd  0x2e1be(%rip),%ymm8        # 3a328 <_sk_srcover_bgra_8888_sse2_lowp+0x3c0>
  .byte  196,193,101,219,216                 // vpand         %ymm8,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,98,125,24,5,176,225,2,0         // vbroadcastss  0x2e1b0(%rip),%ymm8        # 3a32c <_sk_srcover_bgra_8888_sse2_lowp+0x3c4>
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,100,255,255,255              // ja            c101 <_sk_load_4444_hsw+0x25>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,100,0,0,0                 // lea           0x64(%rip),%r10        # c20c <_sk_load_4444_hsw+0x130>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  233,66,255,255,255                  // jmpq          c101 <_sk_load_4444_hsw+0x25>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,129,121,196,68,88,4,2           // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,110,12,88               // vmovd         (%r8,%r11,2),%xmm1
  .byte  196,227,121,2,193,1                 // vpblendd      $0x1,%xmm1,%xmm0,%xmm0
  .byte  233,37,255,255,255                  // jmpq          c101 <_sk_load_4444_hsw+0x25>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,129,121,196,68,88,12,6          // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,196,68,88,10,5          // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,196,68,88,8,4           // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,122,126,12,88               // vmovq         (%r8,%r11,2),%xmm1
  .byte  196,227,113,2,192,12                // vpblendd      $0xc,%xmm0,%xmm1,%xmm0
  .byte  233,248,254,255,255                 // jmpq          c101 <_sk_load_4444_hsw+0x25>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  165                                 // movsl         %ds:(%rsi),%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  191,255,255,255,179                 // mov           $0xb3ffffff,%edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  236                                 // in            (%dx),%al
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,228                             // jmpq          *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  220,255                             // fdivr         %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_4444_dst_hsw
.globl _sk_load_4444_dst_hsw
FUNCTION(_sk_load_4444_dst_hsw)
_sk_load_4444_dst_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,138,0,0,0                    // jne           c2d1 <_sk_load_4444_dst_hsw+0xa9>
  .byte  196,129,122,111,36,88               // vmovdqu       (%r8,%r11,2),%xmm4
  .byte  196,226,125,51,252                  // vpmovzxwd     %xmm4,%ymm7
  .byte  196,226,125,88,37,181,224,2,0       // vpbroadcastd  0x2e0b5(%rip),%ymm4        # 3a310 <_sk_srcover_bgra_8888_sse2_lowp+0x3a8>
  .byte  197,197,219,228                     // vpand         %ymm4,%ymm7,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,226,125,24,45,168,224,2,0       // vbroadcastss  0x2e0a8(%rip),%ymm5        # 3a314 <_sk_srcover_bgra_8888_sse2_lowp+0x3ac>
  .byte  197,220,89,229                      // vmulps        %ymm5,%ymm4,%ymm4
  .byte  196,226,125,88,45,159,224,2,0       // vpbroadcastd  0x2e09f(%rip),%ymm5        # 3a318 <_sk_srcover_bgra_8888_sse2_lowp+0x3b0>
  .byte  197,197,219,237                     // vpand         %ymm5,%ymm7,%ymm5
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  196,226,125,24,53,146,224,2,0       // vbroadcastss  0x2e092(%rip),%ymm6        # 3a31c <_sk_srcover_bgra_8888_sse2_lowp+0x3b4>
  .byte  197,212,89,238                      // vmulps        %ymm6,%ymm5,%ymm5
  .byte  196,226,125,88,53,137,224,2,0       // vpbroadcastd  0x2e089(%rip),%ymm6        # 3a320 <_sk_srcover_bgra_8888_sse2_lowp+0x3b8>
  .byte  197,197,219,246                     // vpand         %ymm6,%ymm7,%ymm6
  .byte  197,252,91,246                      // vcvtdq2ps     %ymm6,%ymm6
  .byte  196,98,125,24,5,124,224,2,0         // vbroadcastss  0x2e07c(%rip),%ymm8        # 3a324 <_sk_srcover_bgra_8888_sse2_lowp+0x3bc>
  .byte  196,193,76,89,240                   // vmulps        %ymm8,%ymm6,%ymm6
  .byte  196,98,125,88,5,114,224,2,0         // vpbroadcastd  0x2e072(%rip),%ymm8        # 3a328 <_sk_srcover_bgra_8888_sse2_lowp+0x3c0>
  .byte  196,193,69,219,248                  // vpand         %ymm8,%ymm7,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,98,125,24,5,100,224,2,0         // vbroadcastss  0x2e064(%rip),%ymm8        # 3a32c <_sk_srcover_bgra_8888_sse2_lowp+0x3c4>
  .byte  196,193,68,89,248                   // vmulps        %ymm8,%ymm7,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,100,255,255,255              // ja            c24d <_sk_load_4444_dst_hsw+0x25>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,100,0,0,0                 // lea           0x64(%rip),%r10        # c358 <_sk_load_4444_dst_hsw+0x130>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  233,66,255,255,255                  // jmpq          c24d <_sk_load_4444_dst_hsw+0x25>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,129,89,196,100,88,4,2           // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,121,110,44,88               // vmovd         (%r8,%r11,2),%xmm5
  .byte  196,227,89,2,229,1                  // vpblendd      $0x1,%xmm5,%xmm4,%xmm4
  .byte  233,37,255,255,255                  // jmpq          c24d <_sk_load_4444_dst_hsw+0x25>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,129,89,196,100,88,12,6          // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,89,196,100,88,10,5          // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,89,196,100,88,8,4           // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,122,126,44,88               // vmovq         (%r8,%r11,2),%xmm5
  .byte  196,227,81,2,228,12                 // vpblendd      $0xc,%xmm4,%xmm5,%xmm4
  .byte  233,248,254,255,255                 // jmpq          c24d <_sk_load_4444_dst_hsw+0x25>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  165                                 // movsl         %ds:(%rsi),%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  191,255,255,255,179                 // mov           $0xb3ffffff,%edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  236                                 // in            (%dx),%al
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,228                             // jmpq          *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  220,255                             // fdivr         %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_4444_hsw
.globl _sk_gather_4444_hsw
FUNCTION(_sk_gather_4444_hsw)
_sk_gather_4444_hsw:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  196,226,125,88,80,8                 // vpbroadcastd  0x8(%rax),%ymm2
  .byte  196,226,109,64,201                  // vpmulld       %ymm1,%ymm2,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  196,227,249,22,192,1                // vpextrq       $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,194                 // vmovq         %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,183,20,80                     // movzwl        (%r8,%r10,2),%r10d
  .byte  71,15,183,28,88                     // movzwl        (%r8,%r11,2),%r11d
  .byte  196,193,121,110,195                 // vmovd         %r11d,%xmm0
  .byte  196,193,121,196,194,1               // vpinsrw       $0x1,%r10d,%xmm0,%xmm0
  .byte  71,15,183,12,72                     // movzwl        (%r8,%r9,2),%r9d
  .byte  196,193,121,196,193,2               // vpinsrw       $0x2,%r9d,%xmm0,%xmm0
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,249,196,192,3                   // vpinsrw       $0x3,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,96                      // movzwl        (%r8,%r12,2),%eax
  .byte  197,249,196,192,4                   // vpinsrw       $0x4,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,120                     // movzwl        (%r8,%r15,2),%eax
  .byte  197,249,196,192,5                   // vpinsrw       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,112                     // movzwl        (%r8,%r14,2),%eax
  .byte  197,249,196,192,6                   // vpinsrw       $0x6,%eax,%xmm0,%xmm0
  .byte  65,15,183,4,88                      // movzwl        (%r8,%rbx,2),%eax
  .byte  197,249,196,192,7                   // vpinsrw       $0x7,%eax,%xmm0,%xmm0
  .byte  196,226,125,51,216                  // vpmovzxwd     %xmm0,%ymm3
  .byte  196,226,125,88,5,180,222,2,0        // vpbroadcastd  0x2deb4(%rip),%ymm0        # 3a310 <_sk_srcover_bgra_8888_sse2_lowp+0x3a8>
  .byte  197,229,219,192                     // vpand         %ymm0,%ymm3,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,167,222,2,0       // vbroadcastss  0x2dea7(%rip),%ymm1        # 3a314 <_sk_srcover_bgra_8888_sse2_lowp+0x3ac>
  .byte  197,252,89,193                      // vmulps        %ymm1,%ymm0,%ymm0
  .byte  196,226,125,88,13,158,222,2,0       // vpbroadcastd  0x2de9e(%rip),%ymm1        # 3a318 <_sk_srcover_bgra_8888_sse2_lowp+0x3b0>
  .byte  197,229,219,201                     // vpand         %ymm1,%ymm3,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,226,125,24,21,145,222,2,0       // vbroadcastss  0x2de91(%rip),%ymm2        # 3a31c <_sk_srcover_bgra_8888_sse2_lowp+0x3b4>
  .byte  197,244,89,202                      // vmulps        %ymm2,%ymm1,%ymm1
  .byte  196,226,125,88,21,136,222,2,0       // vpbroadcastd  0x2de88(%rip),%ymm2        # 3a320 <_sk_srcover_bgra_8888_sse2_lowp+0x3b8>
  .byte  197,229,219,210                     // vpand         %ymm2,%ymm3,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,98,125,24,5,123,222,2,0         // vbroadcastss  0x2de7b(%rip),%ymm8        # 3a324 <_sk_srcover_bgra_8888_sse2_lowp+0x3bc>
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  196,98,125,88,5,113,222,2,0         // vpbroadcastd  0x2de71(%rip),%ymm8        # 3a328 <_sk_srcover_bgra_8888_sse2_lowp+0x3c0>
  .byte  196,193,101,219,216                 // vpand         %ymm8,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,98,125,24,5,99,222,2,0          // vbroadcastss  0x2de63(%rip),%ymm8        # 3a32c <_sk_srcover_bgra_8888_sse2_lowp+0x3c4>
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_4444_hsw
.globl _sk_store_4444_hsw
FUNCTION(_sk_store_4444_hsw)
_sk_store_4444_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,98,125,24,21,23,221,2,0         // vbroadcastss  0x2dd17(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,33,222,2,0         // vbroadcastss  0x2de21(%rip),%ymm11        # 3a330 <_sk_srcover_bgra_8888_sse2_lowp+0x3c8>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  196,193,53,114,241,12               // vpslld        $0xc,%ymm9,%ymm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,8                // vpslld        $0x8,%ymm12,%ymm12
  .byte  196,65,29,235,201                   // vpor          %ymm9,%ymm12,%ymm9
  .byte  197,60,95,226                       // vmaxps        %ymm2,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,4                // vpslld        $0x4,%ymm12,%ymm12
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,65,29,235,192                   // vpor          %ymm8,%ymm12,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,66,57,43,193                    // vpackusdw     %xmm9,%xmm8,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           c58d <_sk_store_4444_hsw+0xb4>
  .byte  196,1,122,127,4,88                  // vmovdqu       %xmm8,(%r8,%r11,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,236                             // ja            c589 <_sk_store_4444_hsw+0xb0>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,68,0,0,0                  // lea           0x44(%rip),%r10        # c5ec <_sk_store_4444_hsw+0x113>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,3,121,21,4,88,0                 // vpextrw       $0x0,%xmm8,(%r8,%r11,2)
  .byte  235,207                             // jmp           c589 <_sk_store_4444_hsw+0xb0>
  .byte  196,3,121,21,68,88,4,2              // vpextrw       $0x2,%xmm8,0x4(%r8,%r11,2)
  .byte  196,1,121,126,4,88                  // vmovd         %xmm8,(%r8,%r11,2)
  .byte  235,191                             // jmp           c589 <_sk_store_4444_hsw+0xb0>
  .byte  196,3,121,21,68,88,12,6             // vpextrw       $0x6,%xmm8,0xc(%r8,%r11,2)
  .byte  196,3,121,21,68,88,10,5             // vpextrw       $0x5,%xmm8,0xa(%r8,%r11,2)
  .byte  196,3,121,21,68,88,8,4              // vpextrw       $0x4,%xmm8,0x8(%r8,%r11,2)
  .byte  196,1,121,214,4,88                  // vmovq         %xmm8,(%r8,%r11,2)
  .byte  235,159                             // jmp           c589 <_sk_store_4444_hsw+0xb0>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  197,255,255                         // (bad)
  .byte  255,214                             // callq         *%rsi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,206                             // dec           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,246                             // push          %rsi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  238                                 // out           %al,(%dx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,230                             // jmpq          *%rsi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  222,255                             // fdivrp        %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_8888_hsw
.globl _sk_load_8888_hsw
FUNCTION(_sk_load_8888_hsw)
_sk_load_8888_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,86                              // jne           c67a <_sk_load_8888_hsw+0x72>
  .byte  196,129,126,111,28,152              // vmovdqu       (%r8,%r11,4),%ymm3
  .byte  197,229,219,5,238,222,2,0           // vpand         0x2deee(%rip),%ymm3,%ymm0        # 3a520 <_sk_srcover_bgra_8888_sse2_lowp+0x5b8>
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,5,81,220,2,0          // vbroadcastss  0x2dc51(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  196,226,101,0,13,243,222,2,0        // vpshufb       0x2def3(%rip),%ymm3,%ymm1        # 3a540 <_sk_srcover_bgra_8888_sse2_lowp+0x5d8>
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  196,226,101,0,21,1,223,2,0          // vpshufb       0x2df01(%rip),%ymm3,%ymm2        # 3a560 <_sk_srcover_bgra_8888_sse2_lowp+0x5f8>
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  197,229,114,211,24                  // vpsrld        $0x18,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,229,239,219                     // vpxor         %ymm3,%ymm3,%ymm3
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,156                             // ja            c62a <_sk_load_8888_hsw+0x22>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,135,0,0,0                 // lea           0x87(%rip),%r10        # c720 <_sk_load_8888_hsw+0x118>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,28,152              // vmovd         (%r8,%r11,4),%xmm3
  .byte  235,128                             // jmp           c62a <_sk_load_8888_hsw+0x22>
  .byte  196,129,121,110,68,152,8            // vmovd         0x8(%r8,%r11,4),%xmm0
  .byte  196,226,121,89,192                  // vpbroadcastq  %xmm0,%xmm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,227,117,2,216,4                 // vpblendd      $0x4,%ymm0,%ymm1,%ymm3
  .byte  196,129,122,126,4,152               // vmovq         (%r8,%r11,4),%xmm0
  .byte  196,227,101,2,216,3                 // vpblendd      $0x3,%ymm0,%ymm3,%ymm3
  .byte  233,89,255,255,255                  // jmpq          c62a <_sk_load_8888_hsw+0x22>
  .byte  196,129,121,110,68,152,24           // vmovd         0x18(%r8,%r11,4),%xmm0
  .byte  196,226,125,89,192                  // vpbroadcastq  %xmm0,%ymm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,227,117,2,216,64                // vpblendd      $0x40,%ymm0,%ymm1,%ymm3
  .byte  196,227,125,57,216,1                // vextracti128  $0x1,%ymm3,%xmm0
  .byte  196,131,121,34,68,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm0,%xmm0
  .byte  196,227,101,56,216,1                // vinserti128   $0x1,%xmm0,%ymm3,%ymm3
  .byte  196,227,125,57,216,1                // vextracti128  $0x1,%ymm3,%xmm0
  .byte  196,131,121,34,68,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm0,%xmm0
  .byte  196,227,101,56,216,1                // vinserti128   $0x1,%xmm0,%ymm3,%ymm3
  .byte  196,129,122,111,4,152               // vmovdqu       (%r8,%r11,4),%xmm0
  .byte  196,227,125,2,219,240               // vpblendd      $0xf0,%ymm3,%ymm0,%ymm3
  .byte  233,10,255,255,255                  // jmpq          c62a <_sk_load_8888_hsw+0x22>
  .byte  130                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,160,255,255,255,138             // jmpq          *-0x75000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  239                                 // out           %eax,(%dx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  219,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  177,255                             // mov           $0xff,%cl
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_8888_dst_hsw
.globl _sk_load_8888_dst_hsw
FUNCTION(_sk_load_8888_dst_hsw)
_sk_load_8888_dst_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,86                              // jne           c7ae <_sk_load_8888_dst_hsw+0x72>
  .byte  196,129,126,111,60,152              // vmovdqu       (%r8,%r11,4),%ymm7
  .byte  197,197,219,37,26,222,2,0           // vpand         0x2de1a(%rip),%ymm7,%ymm4        # 3a580 <_sk_srcover_bgra_8888_sse2_lowp+0x618>
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,98,125,24,5,29,219,2,0          // vbroadcastss  0x2db1d(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,92,89,224                   // vmulps        %ymm8,%ymm4,%ymm4
  .byte  196,226,69,0,45,31,222,2,0          // vpshufb       0x2de1f(%rip),%ymm7,%ymm5        # 3a5a0 <_sk_srcover_bgra_8888_sse2_lowp+0x638>
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  196,193,84,89,232                   // vmulps        %ymm8,%ymm5,%ymm5
  .byte  196,226,69,0,53,45,222,2,0          // vpshufb       0x2de2d(%rip),%ymm7,%ymm6        # 3a5c0 <_sk_srcover_bgra_8888_sse2_lowp+0x658>
  .byte  197,252,91,246                      // vcvtdq2ps     %ymm6,%ymm6
  .byte  196,193,76,89,240                   // vmulps        %ymm8,%ymm6,%ymm6
  .byte  197,197,114,215,24                  // vpsrld        $0x18,%ymm7,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,193,68,89,248                   // vmulps        %ymm8,%ymm7,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,156                             // ja            c75e <_sk_load_8888_dst_hsw+0x22>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,135,0,0,0                 // lea           0x87(%rip),%r10        # c854 <_sk_load_8888_dst_hsw+0x118>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,60,152              // vmovd         (%r8,%r11,4),%xmm7
  .byte  235,128                             // jmp           c75e <_sk_load_8888_dst_hsw+0x22>
  .byte  196,129,121,110,100,152,8           // vmovd         0x8(%r8,%r11,4),%xmm4
  .byte  196,226,121,89,228                  // vpbroadcastq  %xmm4,%xmm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,252,4                  // vpblendd      $0x4,%ymm4,%ymm5,%ymm7
  .byte  196,129,122,126,36,152              // vmovq         (%r8,%r11,4),%xmm4
  .byte  196,227,69,2,252,3                  // vpblendd      $0x3,%ymm4,%ymm7,%ymm7
  .byte  233,89,255,255,255                  // jmpq          c75e <_sk_load_8888_dst_hsw+0x22>
  .byte  196,129,121,110,100,152,24          // vmovd         0x18(%r8,%r11,4),%xmm4
  .byte  196,226,125,89,228                  // vpbroadcastq  %xmm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,252,64                 // vpblendd      $0x40,%ymm4,%ymm5,%ymm7
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,129,122,111,36,152              // vmovdqu       (%r8,%r11,4),%xmm4
  .byte  196,227,93,2,255,240                // vpblendd      $0xf0,%ymm7,%ymm4,%ymm7
  .byte  233,10,255,255,255                  // jmpq          c75e <_sk_load_8888_dst_hsw+0x22>
  .byte  130                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,160,255,255,255,138             // jmpq          *-0x75000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  239                                 // out           %eax,(%dx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  219,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  177,255                             // mov           $0xff,%cl
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_8888_hsw
.globl _sk_gather_8888_hsw
FUNCTION(_sk_gather_8888_hsw)
_sk_gather_8888_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  196,226,125,88,80,8                 // vpbroadcastd  0x8(%rax),%ymm2
  .byte  196,226,109,64,201                  // vpmulld       %ymm1,%ymm2,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  196,66,101,144,4,128                // vpgatherdd    %ymm3,(%r8,%ymm0,4),%ymm8
  .byte  197,189,219,5,25,221,2,0            // vpand         0x2dd19(%rip),%ymm8,%ymm0        # 3a5e0 <_sk_srcover_bgra_8888_sse2_lowp+0x678>
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,29,188,217,2,0       // vbroadcastss  0x2d9bc(%rip),%ymm3        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  196,226,61,0,13,31,221,2,0          // vpshufb       0x2dd1f(%rip),%ymm8,%ymm1        # 3a600 <_sk_srcover_bgra_8888_sse2_lowp+0x698>
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  197,244,89,203                      // vmulps        %ymm3,%ymm1,%ymm1
  .byte  196,226,61,0,21,46,221,2,0          // vpshufb       0x2dd2e(%rip),%ymm8,%ymm2        # 3a620 <_sk_srcover_bgra_8888_sse2_lowp+0x6b8>
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  197,236,89,211                      // vmulps        %ymm3,%ymm2,%ymm2
  .byte  196,193,61,114,208,24               // vpsrld        $0x18,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_8888_hsw
.globl _sk_store_8888_hsw
FUNCTION(_sk_store_8888_hsw)
_sk_store_8888_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,98,125,24,21,226,216,2,0        // vbroadcastss  0x2d8e2(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,0,217,2,0          // vbroadcastss  0x2d900(%rip),%ymm11        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,8                // vpslld        $0x8,%ymm12,%ymm12
  .byte  196,65,29,235,201                   // vpor          %ymm9,%ymm12,%ymm9
  .byte  197,60,95,226                       // vmaxps        %ymm2,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,16               // vpslld        $0x10,%ymm12,%ymm12
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,193,61,114,240,24               // vpslld        $0x18,%ymm8,%ymm8
  .byte  196,65,29,235,192                   // vpor          %ymm8,%ymm12,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           c9b7 <_sk_store_8888_hsw+0xaa>
  .byte  196,1,126,127,4,152                 // vmovdqu       %ymm8,(%r8,%r11,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,236                             // ja            c9b3 <_sk_store_8888_hsw+0xa6>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,82,0,0,0                  // lea           0x52(%rip),%r10        # ca24 <_sk_store_8888_hsw+0x117>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,121,126,4,152                 // vmovd         %xmm8,(%r8,%r11,4)
  .byte  235,208                             // jmp           c9b3 <_sk_store_8888_hsw+0xa6>
  .byte  196,3,121,22,68,152,8,2             // vpextrd       $0x2,%xmm8,0x8(%r8,%r11,4)
  .byte  196,1,121,214,4,152                 // vmovq         %xmm8,(%r8,%r11,4)
  .byte  235,192                             // jmp           c9b3 <_sk_store_8888_hsw+0xa6>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,24,2            // vpextrd       $0x2,%xmm9,0x18(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,20,1            // vpextrd       $0x1,%xmm9,0x14(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,1,121,126,76,152,16             // vmovd         %xmm9,0x10(%r8,%r11,4)
  .byte  196,1,122,127,4,152                 // vmovdqu       %xmm8,(%r8,%r11,4)
  .byte  235,143                             // jmp           c9b3 <_sk_store_8888_hsw+0xa6>
  .byte  183,255                             // mov           $0xff,%bh
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  191,255,255,255,248                 // mov           $0xf8ffffff,%edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  235,255                             // jmp           ca35 <_sk_store_8888_hsw+0x128>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  221,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,207                             // dec           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_bgra_hsw
.globl _sk_load_bgra_hsw
FUNCTION(_sk_load_bgra_hsw)
_sk_load_bgra_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,86                              // jne           cab2 <_sk_load_bgra_hsw+0x72>
  .byte  196,129,126,111,28,152              // vmovdqu       (%r8,%r11,4),%ymm3
  .byte  197,229,219,5,214,219,2,0           // vpand         0x2dbd6(%rip),%ymm3,%ymm0        # 3a640 <_sk_srcover_bgra_8888_sse2_lowp+0x6d8>
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,5,25,216,2,0          // vbroadcastss  0x2d819(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,124,89,208                  // vmulps        %ymm8,%ymm0,%ymm2
  .byte  196,226,101,0,5,219,219,2,0         // vpshufb       0x2dbdb(%rip),%ymm3,%ymm0        # 3a660 <_sk_srcover_bgra_8888_sse2_lowp+0x6f8>
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,193,124,89,200                  // vmulps        %ymm8,%ymm0,%ymm1
  .byte  196,226,101,0,5,233,219,2,0         // vpshufb       0x2dbe9(%rip),%ymm3,%ymm0        # 3a680 <_sk_srcover_bgra_8888_sse2_lowp+0x718>
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  197,229,114,211,24                  // vpsrld        $0x18,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,229,239,219                     // vpxor         %ymm3,%ymm3,%ymm3
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,156                             // ja            ca62 <_sk_load_bgra_hsw+0x22>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,135,0,0,0                 // lea           0x87(%rip),%r10        # cb58 <_sk_load_bgra_hsw+0x118>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,28,152              // vmovd         (%r8,%r11,4),%xmm3
  .byte  235,128                             // jmp           ca62 <_sk_load_bgra_hsw+0x22>
  .byte  196,129,121,110,68,152,8            // vmovd         0x8(%r8,%r11,4),%xmm0
  .byte  196,226,121,89,192                  // vpbroadcastq  %xmm0,%xmm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,227,117,2,216,4                 // vpblendd      $0x4,%ymm0,%ymm1,%ymm3
  .byte  196,129,122,126,4,152               // vmovq         (%r8,%r11,4),%xmm0
  .byte  196,227,101,2,216,3                 // vpblendd      $0x3,%ymm0,%ymm3,%ymm3
  .byte  233,89,255,255,255                  // jmpq          ca62 <_sk_load_bgra_hsw+0x22>
  .byte  196,129,121,110,68,152,24           // vmovd         0x18(%r8,%r11,4),%xmm0
  .byte  196,226,125,89,192                  // vpbroadcastq  %xmm0,%ymm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,227,117,2,216,64                // vpblendd      $0x40,%ymm0,%ymm1,%ymm3
  .byte  196,227,125,57,216,1                // vextracti128  $0x1,%ymm3,%xmm0
  .byte  196,131,121,34,68,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm0,%xmm0
  .byte  196,227,101,56,216,1                // vinserti128   $0x1,%xmm0,%ymm3,%ymm3
  .byte  196,227,125,57,216,1                // vextracti128  $0x1,%ymm3,%xmm0
  .byte  196,131,121,34,68,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm0,%xmm0
  .byte  196,227,101,56,216,1                // vinserti128   $0x1,%xmm0,%ymm3,%ymm3
  .byte  196,129,122,111,4,152               // vmovdqu       (%r8,%r11,4),%xmm0
  .byte  196,227,125,2,219,240               // vpblendd      $0xf0,%ymm3,%ymm0,%ymm3
  .byte  233,10,255,255,255                  // jmpq          ca62 <_sk_load_bgra_hsw+0x22>
  .byte  130                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,160,255,255,255,138             // jmpq          *-0x75000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  239                                 // out           %eax,(%dx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  219,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  177,255                             // mov           $0xff,%cl
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_bgra_dst_hsw
.globl _sk_load_bgra_dst_hsw
FUNCTION(_sk_load_bgra_dst_hsw)
_sk_load_bgra_dst_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,86                              // jne           cbe6 <_sk_load_bgra_dst_hsw+0x72>
  .byte  196,129,126,111,60,152              // vmovdqu       (%r8,%r11,4),%ymm7
  .byte  197,197,219,37,2,219,2,0            // vpand         0x2db02(%rip),%ymm7,%ymm4        # 3a6a0 <_sk_srcover_bgra_8888_sse2_lowp+0x738>
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,98,125,24,5,229,214,2,0         // vbroadcastss  0x2d6e5(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,92,89,240                   // vmulps        %ymm8,%ymm4,%ymm6
  .byte  196,226,69,0,37,7,219,2,0           // vpshufb       0x2db07(%rip),%ymm7,%ymm4        # 3a6c0 <_sk_srcover_bgra_8888_sse2_lowp+0x758>
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,193,92,89,232                   // vmulps        %ymm8,%ymm4,%ymm5
  .byte  196,226,69,0,37,21,219,2,0          // vpshufb       0x2db15(%rip),%ymm7,%ymm4        # 3a6e0 <_sk_srcover_bgra_8888_sse2_lowp+0x778>
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,193,92,89,224                   // vmulps        %ymm8,%ymm4,%ymm4
  .byte  197,197,114,215,24                  // vpsrld        $0x18,%ymm7,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,193,68,89,248                   // vmulps        %ymm8,%ymm7,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,156                             // ja            cb96 <_sk_load_bgra_dst_hsw+0x22>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,135,0,0,0                 // lea           0x87(%rip),%r10        # cc8c <_sk_load_bgra_dst_hsw+0x118>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,60,152              // vmovd         (%r8,%r11,4),%xmm7
  .byte  235,128                             // jmp           cb96 <_sk_load_bgra_dst_hsw+0x22>
  .byte  196,129,121,110,100,152,8           // vmovd         0x8(%r8,%r11,4),%xmm4
  .byte  196,226,121,89,228                  // vpbroadcastq  %xmm4,%xmm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,252,4                  // vpblendd      $0x4,%ymm4,%ymm5,%ymm7
  .byte  196,129,122,126,36,152              // vmovq         (%r8,%r11,4),%xmm4
  .byte  196,227,69,2,252,3                  // vpblendd      $0x3,%ymm4,%ymm7,%ymm7
  .byte  233,89,255,255,255                  // jmpq          cb96 <_sk_load_bgra_dst_hsw+0x22>
  .byte  196,129,121,110,100,152,24          // vmovd         0x18(%r8,%r11,4),%xmm4
  .byte  196,226,125,89,228                  // vpbroadcastq  %xmm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,252,64                 // vpblendd      $0x40,%ymm4,%ymm5,%ymm7
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,227,125,57,252,1                // vextracti128  $0x1,%ymm7,%xmm4
  .byte  196,131,89,34,100,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,227,69,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm7,%ymm7
  .byte  196,129,122,111,36,152              // vmovdqu       (%r8,%r11,4),%xmm4
  .byte  196,227,93,2,255,240                // vpblendd      $0xf0,%ymm7,%ymm4,%ymm7
  .byte  233,10,255,255,255                  // jmpq          cb96 <_sk_load_bgra_dst_hsw+0x22>
  .byte  130                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,160,255,255,255,138             // jmpq          *-0x75000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  239                                 // out           %eax,(%dx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  219,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  177,255                             // mov           $0xff,%cl
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_bgra_hsw
.globl _sk_gather_bgra_hsw
FUNCTION(_sk_gather_bgra_hsw)
_sk_gather_bgra_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  196,226,125,88,80,8                 // vpbroadcastd  0x8(%rax),%ymm2
  .byte  196,226,109,64,201                  // vpmulld       %ymm1,%ymm2,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  196,66,101,144,4,128                // vpgatherdd    %ymm3,(%r8,%ymm0,4),%ymm8
  .byte  197,189,219,5,1,218,2,0             // vpand         0x2da01(%rip),%ymm8,%ymm0        # 3a700 <_sk_srcover_bgra_8888_sse2_lowp+0x798>
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,29,132,213,2,0       // vbroadcastss  0x2d584(%rip),%ymm3        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,252,89,211                      // vmulps        %ymm3,%ymm0,%ymm2
  .byte  196,226,61,0,5,7,218,2,0            // vpshufb       0x2da07(%rip),%ymm8,%ymm0        # 3a720 <_sk_srcover_bgra_8888_sse2_lowp+0x7b8>
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  197,252,89,203                      // vmulps        %ymm3,%ymm0,%ymm1
  .byte  196,226,61,0,5,22,218,2,0           // vpshufb       0x2da16(%rip),%ymm8,%ymm0        # 3a740 <_sk_srcover_bgra_8888_sse2_lowp+0x7d8>
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  196,193,61,114,208,24               // vpsrld        $0x18,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_bgra_hsw
.globl _sk_store_bgra_hsw
FUNCTION(_sk_store_bgra_hsw)
_sk_store_bgra_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,202                       // vmaxps        %ymm2,%ymm8,%ymm9
  .byte  196,98,125,24,21,170,212,2,0        // vbroadcastss  0x2d4aa(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,200,212,2,0        // vbroadcastss  0x2d4c8(%rip),%ymm11        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,8                // vpslld        $0x8,%ymm12,%ymm12
  .byte  196,65,29,235,201                   // vpor          %ymm9,%ymm12,%ymm9
  .byte  197,60,95,224                       // vmaxps        %ymm0,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,29,114,244,16               // vpslld        $0x10,%ymm12,%ymm12
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,193,61,114,240,24               // vpslld        $0x18,%ymm8,%ymm8
  .byte  196,65,29,235,192                   // vpor          %ymm8,%ymm12,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           cdef <_sk_store_bgra_hsw+0xaa>
  .byte  196,1,126,127,4,152                 // vmovdqu       %ymm8,(%r8,%r11,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,236                             // ja            cdeb <_sk_store_bgra_hsw+0xa6>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,82,0,0,0                  // lea           0x52(%rip),%r10        # ce5c <_sk_store_bgra_hsw+0x117>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,121,126,4,152                 // vmovd         %xmm8,(%r8,%r11,4)
  .byte  235,208                             // jmp           cdeb <_sk_store_bgra_hsw+0xa6>
  .byte  196,3,121,22,68,152,8,2             // vpextrd       $0x2,%xmm8,0x8(%r8,%r11,4)
  .byte  196,1,121,214,4,152                 // vmovq         %xmm8,(%r8,%r11,4)
  .byte  235,192                             // jmp           cdeb <_sk_store_bgra_hsw+0xa6>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,24,2            // vpextrd       $0x2,%xmm9,0x18(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,20,1            // vpextrd       $0x1,%xmm9,0x14(%r8,%r11,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,1,121,126,76,152,16             // vmovd         %xmm9,0x10(%r8,%r11,4)
  .byte  196,1,122,127,4,152                 // vmovdqu       %xmm8,(%r8,%r11,4)
  .byte  235,143                             // jmp           cdeb <_sk_store_bgra_hsw+0xa6>
  .byte  183,255                             // mov           $0xff,%bh
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  191,255,255,255,248                 // mov           $0xf8ffffff,%edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  235,255                             // jmp           ce6d <_sk_store_bgra_hsw+0x128>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  221,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,207                             // dec           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_f16_hsw
.globl _sk_load_f16_hsw
FUNCTION(_sk_load_f16_hsw)
_sk_load_f16_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,101                             // jne           cef9 <_sk_load_f16_hsw+0x81>
  .byte  196,65,121,16,4,192                 // vmovupd       (%r8,%rax,8),%xmm8
  .byte  196,193,121,16,84,192,16            // vmovupd       0x10(%r8,%rax,8),%xmm2
  .byte  196,193,121,16,92,192,32            // vmovupd       0x20(%r8,%rax,8),%xmm3
  .byte  196,65,122,111,76,192,48            // vmovdqu       0x30(%r8,%rax,8),%xmm9
  .byte  197,185,97,194                      // vpunpcklwd    %xmm2,%xmm8,%xmm0
  .byte  197,185,105,210                     // vpunpckhwd    %xmm2,%xmm8,%xmm2
  .byte  196,193,97,97,201                   // vpunpcklwd    %xmm9,%xmm3,%xmm1
  .byte  196,193,97,105,217                  // vpunpckhwd    %xmm9,%xmm3,%xmm3
  .byte  197,121,97,194                      // vpunpcklwd    %xmm2,%xmm0,%xmm8
  .byte  197,121,105,202                     // vpunpckhwd    %xmm2,%xmm0,%xmm9
  .byte  197,241,97,211                      // vpunpcklwd    %xmm3,%xmm1,%xmm2
  .byte  197,241,105,219                     // vpunpckhwd    %xmm3,%xmm1,%xmm3
  .byte  197,185,108,194                     // vpunpcklqdq   %xmm2,%xmm8,%xmm0
  .byte  196,226,125,19,192                  // vcvtph2ps     %xmm0,%ymm0
  .byte  197,185,109,202                     // vpunpckhqdq   %xmm2,%xmm8,%xmm1
  .byte  196,226,125,19,201                  // vcvtph2ps     %xmm1,%ymm1
  .byte  197,177,108,211                     // vpunpcklqdq   %xmm3,%xmm9,%xmm2
  .byte  196,226,125,19,210                  // vcvtph2ps     %xmm2,%ymm2
  .byte  197,177,109,219                     // vpunpckhqdq   %xmm3,%xmm9,%xmm3
  .byte  196,226,125,19,219                  // vcvtph2ps     %xmm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,123,16,4,192                 // vmovsd        (%r8,%rax,8),%xmm8
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,85                              // je            cf5f <_sk_load_f16_hsw+0xe7>
  .byte  196,65,57,22,68,192,8               // vmovhpd       0x8(%r8,%rax,8),%xmm8,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,72                              // jb            cf5f <_sk_load_f16_hsw+0xe7>
  .byte  196,193,123,16,84,192,16            // vmovsd        0x10(%r8,%rax,8),%xmm2
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  116,72                              // je            cf6c <_sk_load_f16_hsw+0xf4>
  .byte  196,193,105,22,84,192,24            // vmovhpd       0x18(%r8,%rax,8),%xmm2,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,59                              // jb            cf6c <_sk_load_f16_hsw+0xf4>
  .byte  196,193,123,16,92,192,32            // vmovsd        0x20(%r8,%rax,8),%xmm3
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  15,132,109,255,255,255              // je            ceaf <_sk_load_f16_hsw+0x37>
  .byte  196,193,97,22,92,192,40             // vmovhpd       0x28(%r8,%rax,8),%xmm3,%xmm3
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,130,92,255,255,255               // jb            ceaf <_sk_load_f16_hsw+0x37>
  .byte  196,65,122,126,76,192,48            // vmovq         0x30(%r8,%rax,8),%xmm9
  .byte  233,80,255,255,255                  // jmpq          ceaf <_sk_load_f16_hsw+0x37>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  197,233,87,210                      // vxorpd        %xmm2,%xmm2,%xmm2
  .byte  233,67,255,255,255                  // jmpq          ceaf <_sk_load_f16_hsw+0x37>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  233,58,255,255,255                  // jmpq          ceaf <_sk_load_f16_hsw+0x37>

HIDDEN _sk_load_f16_dst_hsw
.globl _sk_load_f16_dst_hsw
FUNCTION(_sk_load_f16_dst_hsw)
_sk_load_f16_dst_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,101                             // jne           cff6 <_sk_load_f16_dst_hsw+0x81>
  .byte  196,65,121,16,4,192                 // vmovupd       (%r8,%rax,8),%xmm8
  .byte  196,193,121,16,116,192,16           // vmovupd       0x10(%r8,%rax,8),%xmm6
  .byte  196,193,121,16,124,192,32           // vmovupd       0x20(%r8,%rax,8),%xmm7
  .byte  196,65,122,111,76,192,48            // vmovdqu       0x30(%r8,%rax,8),%xmm9
  .byte  197,185,97,230                      // vpunpcklwd    %xmm6,%xmm8,%xmm4
  .byte  197,185,105,246                     // vpunpckhwd    %xmm6,%xmm8,%xmm6
  .byte  196,193,65,97,233                   // vpunpcklwd    %xmm9,%xmm7,%xmm5
  .byte  196,193,65,105,249                  // vpunpckhwd    %xmm9,%xmm7,%xmm7
  .byte  197,89,97,198                       // vpunpcklwd    %xmm6,%xmm4,%xmm8
  .byte  197,89,105,206                      // vpunpckhwd    %xmm6,%xmm4,%xmm9
  .byte  197,209,97,247                      // vpunpcklwd    %xmm7,%xmm5,%xmm6
  .byte  197,209,105,255                     // vpunpckhwd    %xmm7,%xmm5,%xmm7
  .byte  197,185,108,230                     // vpunpcklqdq   %xmm6,%xmm8,%xmm4
  .byte  196,226,125,19,228                  // vcvtph2ps     %xmm4,%ymm4
  .byte  197,185,109,238                     // vpunpckhqdq   %xmm6,%xmm8,%xmm5
  .byte  196,226,125,19,237                  // vcvtph2ps     %xmm5,%ymm5
  .byte  197,177,108,247                     // vpunpcklqdq   %xmm7,%xmm9,%xmm6
  .byte  196,226,125,19,246                  // vcvtph2ps     %xmm6,%ymm6
  .byte  197,177,109,255                     // vpunpckhqdq   %xmm7,%xmm9,%xmm7
  .byte  196,226,125,19,255                  // vcvtph2ps     %xmm7,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,123,16,4,192                 // vmovsd        (%r8,%rax,8),%xmm8
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,85                              // je            d05c <_sk_load_f16_dst_hsw+0xe7>
  .byte  196,65,57,22,68,192,8               // vmovhpd       0x8(%r8,%rax,8),%xmm8,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,72                              // jb            d05c <_sk_load_f16_dst_hsw+0xe7>
  .byte  196,193,123,16,116,192,16           // vmovsd        0x10(%r8,%rax,8),%xmm6
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  116,72                              // je            d069 <_sk_load_f16_dst_hsw+0xf4>
  .byte  196,193,73,22,116,192,24            // vmovhpd       0x18(%r8,%rax,8),%xmm6,%xmm6
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,59                              // jb            d069 <_sk_load_f16_dst_hsw+0xf4>
  .byte  196,193,123,16,124,192,32           // vmovsd        0x20(%r8,%rax,8),%xmm7
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  15,132,109,255,255,255              // je            cfac <_sk_load_f16_dst_hsw+0x37>
  .byte  196,193,65,22,124,192,40            // vmovhpd       0x28(%r8,%rax,8),%xmm7,%xmm7
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,130,92,255,255,255               // jb            cfac <_sk_load_f16_dst_hsw+0x37>
  .byte  196,65,122,126,76,192,48            // vmovq         0x30(%r8,%rax,8),%xmm9
  .byte  233,80,255,255,255                  // jmpq          cfac <_sk_load_f16_dst_hsw+0x37>
  .byte  197,193,87,255                      // vxorpd        %xmm7,%xmm7,%xmm7
  .byte  197,201,87,246                      // vxorpd        %xmm6,%xmm6,%xmm6
  .byte  233,67,255,255,255                  // jmpq          cfac <_sk_load_f16_dst_hsw+0x37>
  .byte  197,193,87,255                      // vxorpd        %xmm7,%xmm7,%xmm7
  .byte  233,58,255,255,255                  // jmpq          cfac <_sk_load_f16_dst_hsw+0x37>

HIDDEN _sk_gather_f16_hsw
.globl _sk_gather_f16_hsw
FUNCTION(_sk_gather_f16_hsw)
_sk_gather_f16_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,88,80,12                // vpbroadcastd  0xc(%rax),%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,88,80,16                // vpbroadcastd  0x10(%rax),%ymm2
  .byte  197,237,254,211                     // vpaddd        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  196,226,125,88,80,8                 // vpbroadcastd  0x8(%rax),%ymm2
  .byte  196,226,109,64,201                  // vpmulld       %ymm1,%ymm2,%ymm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,245,254,192                     // vpaddd        %ymm0,%ymm1,%ymm0
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  197,237,239,210                     // vpxor         %ymm2,%ymm2,%ymm2
  .byte  196,194,245,144,20,192              // vpgatherdq    %ymm1,(%r8,%xmm0,8),%ymm2
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  196,66,229,144,4,192                // vpgatherdq    %ymm3,(%r8,%xmm0,8),%ymm8
  .byte  196,227,125,57,208,1                // vextracti128  $0x1,%ymm2,%xmm0
  .byte  196,99,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm1
  .byte  197,233,97,216                      // vpunpcklwd    %xmm0,%xmm2,%xmm3
  .byte  197,233,105,192                     // vpunpckhwd    %xmm0,%xmm2,%xmm0
  .byte  197,185,97,209                      // vpunpcklwd    %xmm1,%xmm8,%xmm2
  .byte  197,185,105,201                     // vpunpckhwd    %xmm1,%xmm8,%xmm1
  .byte  197,97,97,192                       // vpunpcklwd    %xmm0,%xmm3,%xmm8
  .byte  197,97,105,200                      // vpunpckhwd    %xmm0,%xmm3,%xmm9
  .byte  197,233,97,217                      // vpunpcklwd    %xmm1,%xmm2,%xmm3
  .byte  197,105,105,209                     // vpunpckhwd    %xmm1,%xmm2,%xmm10
  .byte  197,185,108,195                     // vpunpcklqdq   %xmm3,%xmm8,%xmm0
  .byte  196,226,125,19,192                  // vcvtph2ps     %xmm0,%ymm0
  .byte  197,185,109,203                     // vpunpckhqdq   %xmm3,%xmm8,%xmm1
  .byte  196,226,125,19,201                  // vcvtph2ps     %xmm1,%ymm1
  .byte  196,193,49,108,210                  // vpunpcklqdq   %xmm10,%xmm9,%xmm2
  .byte  196,226,125,19,210                  // vcvtph2ps     %xmm2,%ymm2
  .byte  196,193,49,109,218                  // vpunpckhqdq   %xmm10,%xmm9,%xmm3
  .byte  196,226,125,19,219                  // vcvtph2ps     %xmm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_f16_hsw
.globl _sk_store_f16_hsw
FUNCTION(_sk_store_f16_hsw)
_sk_store_f16_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  196,195,125,29,192,4                // vcvtps2ph     $0x4,%ymm0,%xmm8
  .byte  196,195,125,29,201,4                // vcvtps2ph     $0x4,%ymm1,%xmm9
  .byte  196,195,125,29,210,4                // vcvtps2ph     $0x4,%ymm2,%xmm10
  .byte  196,195,125,29,219,4                // vcvtps2ph     $0x4,%ymm3,%xmm11
  .byte  196,65,57,97,225                    // vpunpcklwd    %xmm9,%xmm8,%xmm12
  .byte  196,65,57,105,193                   // vpunpckhwd    %xmm9,%xmm8,%xmm8
  .byte  196,65,41,97,203                    // vpunpcklwd    %xmm11,%xmm10,%xmm9
  .byte  196,65,41,105,235                   // vpunpckhwd    %xmm11,%xmm10,%xmm13
  .byte  196,65,25,98,217                    // vpunpckldq    %xmm9,%xmm12,%xmm11
  .byte  196,65,25,106,209                   // vpunpckhdq    %xmm9,%xmm12,%xmm10
  .byte  196,65,57,98,205                    // vpunpckldq    %xmm13,%xmm8,%xmm9
  .byte  196,65,57,106,197                   // vpunpckhdq    %xmm13,%xmm8,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,31                              // jne           d1a6 <_sk_store_f16_hsw+0x7b>
  .byte  196,65,122,127,28,192               // vmovdqu       %xmm11,(%r8,%rax,8)
  .byte  196,65,122,127,84,192,16            // vmovdqu       %xmm10,0x10(%r8,%rax,8)
  .byte  196,65,122,127,76,192,32            // vmovdqu       %xmm9,0x20(%r8,%rax,8)
  .byte  196,65,122,127,68,192,48            // vmovdqu       %xmm8,0x30(%r8,%rax,8)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,121,214,28,192               // vmovq         %xmm11,(%r8,%rax,8)
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,240                             // je            d1a2 <_sk_store_f16_hsw+0x77>
  .byte  196,65,121,23,92,192,8              // vmovhpd       %xmm11,0x8(%r8,%rax,8)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,227                             // jb            d1a2 <_sk_store_f16_hsw+0x77>
  .byte  196,65,121,214,84,192,16            // vmovq         %xmm10,0x10(%r8,%rax,8)
  .byte  116,218                             // je            d1a2 <_sk_store_f16_hsw+0x77>
  .byte  196,65,121,23,84,192,24             // vmovhpd       %xmm10,0x18(%r8,%rax,8)
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,205                             // jb            d1a2 <_sk_store_f16_hsw+0x77>
  .byte  196,65,121,214,76,192,32            // vmovq         %xmm9,0x20(%r8,%rax,8)
  .byte  116,196                             // je            d1a2 <_sk_store_f16_hsw+0x77>
  .byte  196,65,121,23,76,192,40             // vmovhpd       %xmm9,0x28(%r8,%rax,8)
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,183                             // jb            d1a2 <_sk_store_f16_hsw+0x77>
  .byte  196,65,121,214,68,192,48            // vmovq         %xmm8,0x30(%r8,%rax,8)
  .byte  235,174                             // jmp           d1a2 <_sk_store_f16_hsw+0x77>

HIDDEN _sk_load_u16_be_hsw
.globl _sk_load_u16_be_hsw
FUNCTION(_sk_load_u16_be_hsw)
_sk_load_u16_be_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,204,0,0,0                    // jne           d2e7 <_sk_load_u16_be_hsw+0xf3>
  .byte  196,65,121,16,4,64                  // vmovupd       (%r8,%rax,2),%xmm8
  .byte  196,193,121,16,84,64,16             // vmovupd       0x10(%r8,%rax,2),%xmm2
  .byte  196,193,121,16,92,64,32             // vmovupd       0x20(%r8,%rax,2),%xmm3
  .byte  196,65,122,111,76,64,48             // vmovdqu       0x30(%r8,%rax,2),%xmm9
  .byte  197,185,97,194                      // vpunpcklwd    %xmm2,%xmm8,%xmm0
  .byte  197,185,105,210                     // vpunpckhwd    %xmm2,%xmm8,%xmm2
  .byte  196,193,97,97,201                   // vpunpcklwd    %xmm9,%xmm3,%xmm1
  .byte  196,193,97,105,217                  // vpunpckhwd    %xmm9,%xmm3,%xmm3
  .byte  197,121,97,194                      // vpunpcklwd    %xmm2,%xmm0,%xmm8
  .byte  197,121,105,202                     // vpunpckhwd    %xmm2,%xmm0,%xmm9
  .byte  197,241,97,211                      // vpunpcklwd    %xmm3,%xmm1,%xmm2
  .byte  197,113,105,219                     // vpunpckhwd    %xmm3,%xmm1,%xmm11
  .byte  197,185,108,194                     // vpunpcklqdq   %xmm2,%xmm8,%xmm0
  .byte  197,241,113,240,8                   // vpsllw        $0x8,%xmm0,%xmm1
  .byte  197,249,113,208,8                   // vpsrlw        $0x8,%xmm0,%xmm0
  .byte  197,241,235,192                     // vpor          %xmm0,%xmm1,%xmm0
  .byte  196,226,125,51,192                  // vpmovzxwd     %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,21,48,208,2,0         // vbroadcastss  0x2d030(%rip),%ymm10        # 3a2ac <_sk_srcover_bgra_8888_sse2_lowp+0x344>
  .byte  196,193,124,89,194                  // vmulps        %ymm10,%ymm0,%ymm0
  .byte  197,185,109,202                     // vpunpckhqdq   %xmm2,%xmm8,%xmm1
  .byte  197,233,113,241,8                   // vpsllw        $0x8,%xmm1,%xmm2
  .byte  197,241,113,209,8                   // vpsrlw        $0x8,%xmm1,%xmm1
  .byte  197,233,235,201                     // vpor          %xmm1,%xmm2,%xmm1
  .byte  196,226,125,51,201                  // vpmovzxwd     %xmm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,202                  // vmulps        %ymm10,%ymm1,%ymm1
  .byte  196,193,49,108,211                  // vpunpcklqdq   %xmm11,%xmm9,%xmm2
  .byte  197,225,113,242,8                   // vpsllw        $0x8,%xmm2,%xmm3
  .byte  197,233,113,210,8                   // vpsrlw        $0x8,%xmm2,%xmm2
  .byte  197,225,235,210                     // vpor          %xmm2,%xmm3,%xmm2
  .byte  196,226,125,51,210                  // vpmovzxwd     %xmm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,210                  // vmulps        %ymm10,%ymm2,%ymm2
  .byte  196,193,49,109,219                  // vpunpckhqdq   %xmm11,%xmm9,%xmm3
  .byte  197,185,113,243,8                   // vpsllw        $0x8,%xmm3,%xmm8
  .byte  197,225,113,211,8                   // vpsrlw        $0x8,%xmm3,%xmm3
  .byte  197,185,235,219                     // vpor          %xmm3,%xmm8,%xmm3
  .byte  196,226,125,51,219                  // vpmovzxwd     %xmm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,218                  // vmulps        %ymm10,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,123,16,4,64                  // vmovsd        (%r8,%rax,2),%xmm8
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,85                              // je            d34d <_sk_load_u16_be_hsw+0x159>
  .byte  196,65,57,22,68,64,8                // vmovhpd       0x8(%r8,%rax,2),%xmm8,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,72                              // jb            d34d <_sk_load_u16_be_hsw+0x159>
  .byte  196,193,123,16,84,64,16             // vmovsd        0x10(%r8,%rax,2),%xmm2
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  116,72                              // je            d35a <_sk_load_u16_be_hsw+0x166>
  .byte  196,193,105,22,84,64,24             // vmovhpd       0x18(%r8,%rax,2),%xmm2,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,59                              // jb            d35a <_sk_load_u16_be_hsw+0x166>
  .byte  196,193,123,16,92,64,32             // vmovsd        0x20(%r8,%rax,2),%xmm3
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  15,132,6,255,255,255                // je            d236 <_sk_load_u16_be_hsw+0x42>
  .byte  196,193,97,22,92,64,40              // vmovhpd       0x28(%r8,%rax,2),%xmm3,%xmm3
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,130,245,254,255,255              // jb            d236 <_sk_load_u16_be_hsw+0x42>
  .byte  196,65,122,126,76,64,48             // vmovq         0x30(%r8,%rax,2),%xmm9
  .byte  233,233,254,255,255                 // jmpq          d236 <_sk_load_u16_be_hsw+0x42>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  197,233,87,210                      // vxorpd        %xmm2,%xmm2,%xmm2
  .byte  233,220,254,255,255                 // jmpq          d236 <_sk_load_u16_be_hsw+0x42>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  233,211,254,255,255                 // jmpq          d236 <_sk_load_u16_be_hsw+0x42>

HIDDEN _sk_load_rgb_u16_be_hsw
.globl _sk_load_rgb_u16_be_hsw
FUNCTION(_sk_load_rgb_u16_be_hsw)
_sk_load_rgb_u16_be_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,137,208                          // mov           %rdx,%rax
  .byte  72,193,224,32                       // shl           $0x20,%rax
  .byte  72,141,4,64                         // lea           (%rax,%rax,2),%rax
  .byte  72,193,248,32                       // sar           $0x20,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,205,0,0,0                    // jne           d45b <_sk_load_rgb_u16_be_hsw+0xf8>
  .byte  196,65,122,111,28,64                // vmovdqu       (%r8,%rax,2),%xmm11
  .byte  196,193,122,111,92,64,12            // vmovdqu       0xc(%r8,%rax,2),%xmm3
  .byte  196,193,122,111,84,64,24            // vmovdqu       0x18(%r8,%rax,2),%xmm2
  .byte  196,193,122,111,68,64,32            // vmovdqu       0x20(%r8,%rax,2),%xmm0
  .byte  197,249,115,216,4                   // vpsrldq       $0x4,%xmm0,%xmm0
  .byte  196,193,57,115,219,6                // vpsrldq       $0x6,%xmm11,%xmm8
  .byte  197,169,115,219,6                   // vpsrldq       $0x6,%xmm3,%xmm10
  .byte  197,241,115,218,6                   // vpsrldq       $0x6,%xmm2,%xmm1
  .byte  197,177,115,216,6                   // vpsrldq       $0x6,%xmm0,%xmm9
  .byte  196,193,113,97,201                  // vpunpcklwd    %xmm9,%xmm1,%xmm1
  .byte  197,233,97,192                      // vpunpcklwd    %xmm0,%xmm2,%xmm0
  .byte  196,193,57,97,210                   // vpunpcklwd    %xmm10,%xmm8,%xmm2
  .byte  197,161,97,219                      // vpunpcklwd    %xmm3,%xmm11,%xmm3
  .byte  197,97,97,194                       // vpunpcklwd    %xmm2,%xmm3,%xmm8
  .byte  197,225,105,210                     // vpunpckhwd    %xmm2,%xmm3,%xmm2
  .byte  197,249,97,217                      // vpunpcklwd    %xmm1,%xmm0,%xmm3
  .byte  197,249,105,193                     // vpunpckhwd    %xmm1,%xmm0,%xmm0
  .byte  197,233,108,208                     // vpunpcklqdq   %xmm0,%xmm2,%xmm2
  .byte  197,185,108,195                     // vpunpcklqdq   %xmm3,%xmm8,%xmm0
  .byte  197,241,113,240,8                   // vpsllw        $0x8,%xmm0,%xmm1
  .byte  197,249,113,208,8                   // vpsrlw        $0x8,%xmm0,%xmm0
  .byte  197,241,235,192                     // vpor          %xmm0,%xmm1,%xmm0
  .byte  196,226,125,51,192                  // vpmovzxwd     %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,13,159,206,2,0        // vbroadcastss  0x2ce9f(%rip),%ymm9        # 3a2ac <_sk_srcover_bgra_8888_sse2_lowp+0x344>
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,185,109,203                     // vpunpckhqdq   %xmm3,%xmm8,%xmm1
  .byte  197,225,113,241,8                   // vpsllw        $0x8,%xmm1,%xmm3
  .byte  197,241,113,209,8                   // vpsrlw        $0x8,%xmm1,%xmm1
  .byte  197,225,235,201                     // vpor          %xmm1,%xmm3,%xmm1
  .byte  196,226,125,51,201                  // vpmovzxwd     %xmm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,201                  // vmulps        %ymm9,%ymm1,%ymm1
  .byte  197,225,113,242,8                   // vpsllw        $0x8,%xmm2,%xmm3
  .byte  197,233,113,210,8                   // vpsrlw        $0x8,%xmm2,%xmm2
  .byte  197,225,235,210                     // vpor          %xmm2,%xmm3,%xmm2
  .byte  196,226,125,51,210                  // vpmovzxwd     %xmm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,209                  // vmulps        %ymm9,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,191,205,2,0       // vbroadcastss  0x2cdbf(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  255,224                             // jmpq          *%rax
  .byte  196,193,121,110,4,64                // vmovd         (%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,65,121,196,92,64,4,2            // vpinsrw       $0x2,0x4(%r8,%rax,2),%xmm0,%xmm11
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,31                              // jne           d493 <_sk_load_rgb_u16_be_hsw+0x130>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  197,225,239,219                     // vpxor         %xmm3,%xmm3,%xmm3
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  233,48,255,255,255                  // jmpq          d3c3 <_sk_load_rgb_u16_be_hsw+0x60>
  .byte  196,193,121,110,68,64,6             // vmovd         0x6(%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,65,121,196,68,64,10,2           // vpinsrw       $0x2,0xa(%r8,%rax,2),%xmm0,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,48                              // jb            d4dd <_sk_load_rgb_u16_be_hsw+0x17a>
  .byte  196,193,121,110,68,64,12            // vmovd         0xc(%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,193,121,196,92,64,16,2          // vpinsrw       $0x2,0x10(%r8,%rax,2),%xmm0,%xmm3
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  117,48                              // jne           d4f7 <_sk_load_rgb_u16_be_hsw+0x194>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  233,230,254,255,255                 // jmpq          d3c3 <_sk_load_rgb_u16_be_hsw+0x60>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  197,225,239,219                     // vpxor         %xmm3,%xmm3,%xmm3
  .byte  233,204,254,255,255                 // jmpq          d3c3 <_sk_load_rgb_u16_be_hsw+0x60>
  .byte  196,193,121,110,68,64,18            // vmovd         0x12(%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,65,121,196,84,64,22,2           // vpinsrw       $0x2,0x16(%r8,%rax,2),%xmm0,%xmm10
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,39                              // jb            d538 <_sk_load_rgb_u16_be_hsw+0x1d5>
  .byte  196,193,121,110,68,64,24            // vmovd         0x18(%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,193,121,196,84,64,28,2          // vpinsrw       $0x2,0x1c(%r8,%rax,2),%xmm0,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  117,30                              // jne           d549 <_sk_load_rgb_u16_be_hsw+0x1e6>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  233,139,254,255,255                 // jmpq          d3c3 <_sk_load_rgb_u16_be_hsw+0x60>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  233,122,254,255,255                 // jmpq          d3c3 <_sk_load_rgb_u16_be_hsw+0x60>
  .byte  196,193,121,110,68,64,30            // vmovd         0x1e(%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,193,121,196,76,64,34,2          // vpinsrw       $0x2,0x22(%r8,%rax,2),%xmm0,%xmm1
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,25                              // jb            d57c <_sk_load_rgb_u16_be_hsw+0x219>
  .byte  196,193,121,110,68,64,36            // vmovd         0x24(%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,193,121,196,68,64,40,2          // vpinsrw       $0x2,0x28(%r8,%rax,2),%xmm0,%xmm0
  .byte  233,71,254,255,255                  // jmpq          d3c3 <_sk_load_rgb_u16_be_hsw+0x60>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  233,62,254,255,255                  // jmpq          d3c3 <_sk_load_rgb_u16_be_hsw+0x60>

HIDDEN _sk_store_u16_be_hsw
.globl _sk_store_u16_be_hsw
FUNCTION(_sk_store_u16_be_hsw)
_sk_store_u16_be_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,98,125,24,21,99,204,2,0         // vbroadcastss  0x2cc63(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,113,205,2,0        // vbroadcastss  0x2cd71(%rip),%ymm11        # 3a334 <_sk_srcover_bgra_8888_sse2_lowp+0x3cc>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  196,67,125,25,204,1                 // vextractf128  $0x1,%ymm9,%xmm12
  .byte  196,66,49,43,204                    // vpackusdw     %xmm12,%xmm9,%xmm9
  .byte  196,193,25,113,241,8                // vpsllw        $0x8,%xmm9,%xmm12
  .byte  196,193,49,113,209,8                // vpsrlw        $0x8,%xmm9,%xmm9
  .byte  196,65,25,235,201                   // vpor          %xmm9,%xmm12,%xmm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,67,125,25,229,1                 // vextractf128  $0x1,%ymm12,%xmm13
  .byte  196,66,25,43,229                    // vpackusdw     %xmm13,%xmm12,%xmm12
  .byte  196,193,17,113,244,8                // vpsllw        $0x8,%xmm12,%xmm13
  .byte  196,193,25,113,212,8                // vpsrlw        $0x8,%xmm12,%xmm12
  .byte  196,65,17,235,228                   // vpor          %xmm12,%xmm13,%xmm12
  .byte  197,60,95,234                       // vmaxps        %ymm2,%ymm8,%ymm13
  .byte  196,65,20,93,234                    // vminps        %ymm10,%ymm13,%ymm13
  .byte  196,65,20,89,235                    // vmulps        %ymm11,%ymm13,%ymm13
  .byte  196,65,125,91,237                   // vcvtps2dq     %ymm13,%ymm13
  .byte  196,67,125,25,238,1                 // vextractf128  $0x1,%ymm13,%xmm14
  .byte  196,66,17,43,238                    // vpackusdw     %xmm14,%xmm13,%xmm13
  .byte  196,193,9,113,245,8                 // vpsllw        $0x8,%xmm13,%xmm14
  .byte  196,193,17,113,213,8                // vpsrlw        $0x8,%xmm13,%xmm13
  .byte  196,65,9,235,237                    // vpor          %xmm13,%xmm14,%xmm13
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,67,125,25,194,1                 // vextractf128  $0x1,%ymm8,%xmm10
  .byte  196,66,57,43,194                    // vpackusdw     %xmm10,%xmm8,%xmm8
  .byte  196,193,41,113,240,8                // vpsllw        $0x8,%xmm8,%xmm10
  .byte  196,193,57,113,208,8                // vpsrlw        $0x8,%xmm8,%xmm8
  .byte  196,65,41,235,192                   // vpor          %xmm8,%xmm10,%xmm8
  .byte  196,65,49,97,212                    // vpunpcklwd    %xmm12,%xmm9,%xmm10
  .byte  196,65,49,105,228                   // vpunpckhwd    %xmm12,%xmm9,%xmm12
  .byte  196,65,17,97,200                    // vpunpcklwd    %xmm8,%xmm13,%xmm9
  .byte  196,65,17,105,192                   // vpunpckhwd    %xmm8,%xmm13,%xmm8
  .byte  196,65,41,98,217                    // vpunpckldq    %xmm9,%xmm10,%xmm11
  .byte  196,65,41,106,209                   // vpunpckhdq    %xmm9,%xmm10,%xmm10
  .byte  196,65,25,98,200                    // vpunpckldq    %xmm8,%xmm12,%xmm9
  .byte  196,65,25,106,192                   // vpunpckhdq    %xmm8,%xmm12,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,31                              // jne           d6c2 <_sk_store_u16_be_hsw+0x13d>
  .byte  196,65,122,127,28,64                // vmovdqu       %xmm11,(%r8,%rax,2)
  .byte  196,65,122,127,84,64,16             // vmovdqu       %xmm10,0x10(%r8,%rax,2)
  .byte  196,65,122,127,76,64,32             // vmovdqu       %xmm9,0x20(%r8,%rax,2)
  .byte  196,65,122,127,68,64,48             // vmovdqu       %xmm8,0x30(%r8,%rax,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,121,214,28,64                // vmovq         %xmm11,(%r8,%rax,2)
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,240                             // je            d6be <_sk_store_u16_be_hsw+0x139>
  .byte  196,65,121,23,92,64,8               // vmovhpd       %xmm11,0x8(%r8,%rax,2)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,227                             // jb            d6be <_sk_store_u16_be_hsw+0x139>
  .byte  196,65,121,214,84,64,16             // vmovq         %xmm10,0x10(%r8,%rax,2)
  .byte  116,218                             // je            d6be <_sk_store_u16_be_hsw+0x139>
  .byte  196,65,121,23,84,64,24              // vmovhpd       %xmm10,0x18(%r8,%rax,2)
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,205                             // jb            d6be <_sk_store_u16_be_hsw+0x139>
  .byte  196,65,121,214,76,64,32             // vmovq         %xmm9,0x20(%r8,%rax,2)
  .byte  116,196                             // je            d6be <_sk_store_u16_be_hsw+0x139>
  .byte  196,65,121,23,76,64,40              // vmovhpd       %xmm9,0x28(%r8,%rax,2)
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,183                             // jb            d6be <_sk_store_u16_be_hsw+0x139>
  .byte  196,65,121,214,68,64,48             // vmovq         %xmm8,0x30(%r8,%rax,2)
  .byte  235,174                             // jmp           d6be <_sk_store_u16_be_hsw+0x139>

HIDDEN _sk_load_f32_hsw
.globl _sk_load_f32_hsw
FUNCTION(_sk_load_f32_hsw)
_sk_load_f32_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,253,87,192                      // vxorpd        %ymm0,%ymm0,%ymm0
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,135,97,1,0,0                     // ja            d881 <_sk_load_f32_hsw+0x171>
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  197,253,17,100,36,128               // vmovupd       %ymm4,-0x80(%rsp)
  .byte  197,253,17,108,36,160               // vmovupd       %ymm5,-0x60(%rsp)
  .byte  197,253,17,116,36,192               // vmovupd       %ymm6,-0x40(%rsp)
  .byte  197,253,17,124,36,224               // vmovupd       %ymm7,-0x20(%rsp)
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  77,99,201                           // movslq        %r9d,%r9
  .byte  76,141,21,48,1,0,0                  // lea           0x130(%rip),%r10        # d890 <_sk_load_f32_hsw+0x180>
  .byte  73,99,4,186                         // movslq        (%r10,%rdi,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  197,221,87,228                      // vxorpd        %ymm4,%ymm4,%ymm4
  .byte  196,65,53,87,201                    // vxorpd        %ymm9,%ymm9,%ymm9
  .byte  197,237,87,210                      // vxorpd        %ymm2,%ymm2,%ymm2
  .byte  196,65,37,87,219                    // vxorpd        %ymm11,%ymm11,%ymm11
  .byte  196,65,29,87,228                    // vxorpd        %ymm12,%ymm12,%ymm12
  .byte  196,65,61,87,192                    // vxorpd        %ymm8,%ymm8,%ymm8
  .byte  196,65,13,87,246                    // vxorpd        %ymm14,%ymm14,%ymm14
  .byte  197,205,87,246                      // vxorpd        %ymm6,%ymm6,%ymm6
  .byte  196,65,5,87,255                     // vxorpd        %ymm15,%ymm15,%ymm15
  .byte  197,245,87,201                      // vxorpd        %ymm1,%ymm1,%ymm1
  .byte  196,65,21,87,237                    // vxorpd        %ymm13,%ymm13,%ymm13
  .byte  197,213,87,237                      // vxorpd        %ymm5,%ymm5,%ymm5
  .byte  197,229,87,219                      // vxorpd        %ymm3,%ymm3,%ymm3
  .byte  196,65,45,87,210                    // vxorpd        %ymm10,%ymm10,%ymm10
  .byte  197,197,87,255                      // vxorpd        %ymm7,%ymm7,%ymm7
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,16,68,136,112           // vmovupd       0x70(%r8,%r9,4),%xmm0
  .byte  196,227,125,6,192,40                // vperm2f128    $0x28,%ymm0,%ymm0,%ymm0
  .byte  196,129,121,16,76,136,96            // vmovupd       0x60(%r8,%r9,4),%xmm1
  .byte  196,227,125,6,225,40                // vperm2f128    $0x28,%ymm1,%ymm0,%ymm4
  .byte  196,129,121,16,76,136,80            // vmovupd       0x50(%r8,%r9,4),%xmm1
  .byte  196,227,125,6,209,40                // vperm2f128    $0x28,%ymm1,%ymm0,%ymm2
  .byte  197,125,40,204                      // vmovapd       %ymm4,%ymm9
  .byte  196,129,121,16,76,136,64            // vmovupd       0x40(%r8,%r9,4),%xmm1
  .byte  196,99,125,6,193,40                 // vperm2f128    $0x28,%ymm1,%ymm0,%ymm8
  .byte  196,65,125,40,217                   // vmovapd       %ymm9,%ymm11
  .byte  197,125,40,226                      // vmovapd       %ymm2,%ymm12
  .byte  196,129,121,16,76,136,48            // vmovupd       0x30(%r8,%r9,4),%xmm1
  .byte  196,227,117,13,192,12               // vblendpd      $0xc,%ymm0,%ymm1,%ymm0
  .byte  196,65,125,40,243                   // vmovapd       %ymm11,%ymm14
  .byte  197,125,41,230                      // vmovapd       %ymm12,%ymm6
  .byte  196,65,125,40,248                   // vmovapd       %ymm8,%ymm15
  .byte  196,129,121,16,76,136,32            // vmovupd       0x20(%r8,%r9,4),%xmm1
  .byte  196,195,117,13,206,12               // vblendpd      $0xc,%ymm14,%ymm1,%ymm1
  .byte  197,125,40,238                      // vmovapd       %ymm6,%ymm13
  .byte  197,125,41,253                      // vmovapd       %ymm15,%ymm5
  .byte  196,129,121,16,84,136,16            // vmovupd       0x10(%r8,%r9,4),%xmm2
  .byte  196,67,109,13,213,12                // vblendpd      $0xc,%ymm13,%ymm2,%ymm10
  .byte  197,253,40,217                      // vmovapd       %ymm1,%ymm3
  .byte  197,253,40,253                      // vmovapd       %ymm5,%ymm7
  .byte  196,129,121,16,12,136               // vmovupd       (%r8,%r9,4),%xmm1
  .byte  196,227,117,13,207,12               // vblendpd      $0xc,%ymm7,%ymm1,%ymm1
  .byte  197,252,16,124,36,224               // vmovups       -0x20(%rsp),%ymm7
  .byte  197,252,16,116,36,192               // vmovups       -0x40(%rsp),%ymm6
  .byte  197,252,16,108,36,160               // vmovups       -0x60(%rsp),%ymm5
  .byte  197,252,16,100,36,128               // vmovups       -0x80(%rsp),%ymm4
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  196,193,116,20,210                  // vunpcklps     %ymm10,%ymm1,%ymm2
  .byte  196,65,116,21,194                   // vunpckhps     %ymm10,%ymm1,%ymm8
  .byte  197,228,20,200                      // vunpcklps     %ymm0,%ymm3,%ymm1
  .byte  197,228,21,216                      // vunpckhps     %ymm0,%ymm3,%ymm3
  .byte  197,237,20,193                      // vunpcklpd     %ymm1,%ymm2,%ymm0
  .byte  197,237,21,201                      // vunpckhpd     %ymm1,%ymm2,%ymm1
  .byte  197,189,20,211                      // vunpcklpd     %ymm3,%ymm8,%ymm2
  .byte  197,189,21,219                      // vunpckhpd     %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  197,229,87,219                      // vxorpd        %ymm3,%ymm3,%ymm3
  .byte  196,65,45,87,210                    // vxorpd        %ymm10,%ymm10,%ymm10
  .byte  197,245,87,201                      // vxorpd        %ymm1,%ymm1,%ymm1
  .byte  235,203                             // jmp           d85b <_sk_load_f32_hsw+0x14b>
  .byte  29,255,255,255,163                  // sbb           $0xa3ffffff,%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,142,255,255,255,121             // decl          0x79ffffff(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,94,255                          // lcall         *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,72,255                          // decl          -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,55                              // pushq         (%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,42                              // ljmp          *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_f32_dst_hsw
.globl _sk_load_f32_dst_hsw
FUNCTION(_sk_load_f32_dst_hsw)
_sk_load_f32_dst_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,221,87,228                      // vxorpd        %ymm4,%ymm4,%ymm4
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,135,97,1,0,0                     // ja            da21 <_sk_load_f32_dst_hsw+0x171>
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  197,253,17,68,36,128                // vmovupd       %ymm0,-0x80(%rsp)
  .byte  197,253,17,76,36,160                // vmovupd       %ymm1,-0x60(%rsp)
  .byte  197,253,17,84,36,192                // vmovupd       %ymm2,-0x40(%rsp)
  .byte  197,253,17,92,36,224                // vmovupd       %ymm3,-0x20(%rsp)
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  77,99,201                           // movslq        %r9d,%r9
  .byte  76,141,21,48,1,0,0                  // lea           0x130(%rip),%r10        # da30 <_sk_load_f32_dst_hsw+0x180>
  .byte  73,99,4,186                         // movslq        (%r10,%rdi,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  197,253,87,192                      // vxorpd        %ymm0,%ymm0,%ymm0
  .byte  196,65,53,87,201                    // vxorpd        %ymm9,%ymm9,%ymm9
  .byte  197,205,87,246                      // vxorpd        %ymm6,%ymm6,%ymm6
  .byte  196,65,37,87,219                    // vxorpd        %ymm11,%ymm11,%ymm11
  .byte  196,65,29,87,228                    // vxorpd        %ymm12,%ymm12,%ymm12
  .byte  196,65,61,87,192                    // vxorpd        %ymm8,%ymm8,%ymm8
  .byte  196,65,13,87,246                    // vxorpd        %ymm14,%ymm14,%ymm14
  .byte  197,237,87,210                      // vxorpd        %ymm2,%ymm2,%ymm2
  .byte  196,65,5,87,255                     // vxorpd        %ymm15,%ymm15,%ymm15
  .byte  197,213,87,237                      // vxorpd        %ymm5,%ymm5,%ymm5
  .byte  196,65,21,87,237                    // vxorpd        %ymm13,%ymm13,%ymm13
  .byte  197,245,87,201                      // vxorpd        %ymm1,%ymm1,%ymm1
  .byte  197,197,87,255                      // vxorpd        %ymm7,%ymm7,%ymm7
  .byte  196,65,45,87,210                    // vxorpd        %ymm10,%ymm10,%ymm10
  .byte  197,229,87,219                      // vxorpd        %ymm3,%ymm3,%ymm3
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,16,68,136,112           // vmovupd       0x70(%r8,%r9,4),%xmm0
  .byte  196,227,125,6,224,40                // vperm2f128    $0x28,%ymm0,%ymm0,%ymm4
  .byte  196,129,121,16,68,136,96            // vmovupd       0x60(%r8,%r9,4),%xmm0
  .byte  196,227,125,6,192,40                // vperm2f128    $0x28,%ymm0,%ymm0,%ymm0
  .byte  196,129,121,16,76,136,80            // vmovupd       0x50(%r8,%r9,4),%xmm1
  .byte  196,227,125,6,241,40                // vperm2f128    $0x28,%ymm1,%ymm0,%ymm6
  .byte  197,125,40,200                      // vmovapd       %ymm0,%ymm9
  .byte  196,129,121,16,68,136,64            // vmovupd       0x40(%r8,%r9,4),%xmm0
  .byte  196,99,125,6,192,40                 // vperm2f128    $0x28,%ymm0,%ymm0,%ymm8
  .byte  196,65,125,40,217                   // vmovapd       %ymm9,%ymm11
  .byte  197,125,40,230                      // vmovapd       %ymm6,%ymm12
  .byte  196,129,121,16,68,136,48            // vmovupd       0x30(%r8,%r9,4),%xmm0
  .byte  196,227,125,13,228,12               // vblendpd      $0xc,%ymm4,%ymm0,%ymm4
  .byte  196,65,125,40,243                   // vmovapd       %ymm11,%ymm14
  .byte  197,125,41,226                      // vmovapd       %ymm12,%ymm2
  .byte  196,65,125,40,248                   // vmovapd       %ymm8,%ymm15
  .byte  196,129,121,16,68,136,32            // vmovupd       0x20(%r8,%r9,4),%xmm0
  .byte  196,195,125,13,238,12               // vblendpd      $0xc,%ymm14,%ymm0,%ymm5
  .byte  197,125,40,234                      // vmovapd       %ymm2,%ymm13
  .byte  197,125,41,249                      // vmovapd       %ymm15,%ymm1
  .byte  196,129,121,16,68,136,16            // vmovupd       0x10(%r8,%r9,4),%xmm0
  .byte  196,67,125,13,213,12                // vblendpd      $0xc,%ymm13,%ymm0,%ymm10
  .byte  197,253,40,253                      // vmovapd       %ymm5,%ymm7
  .byte  197,253,40,217                      // vmovapd       %ymm1,%ymm3
  .byte  196,129,121,16,4,136                // vmovupd       (%r8,%r9,4),%xmm0
  .byte  196,227,125,13,235,12               // vblendpd      $0xc,%ymm3,%ymm0,%ymm5
  .byte  197,252,16,92,36,224                // vmovups       -0x20(%rsp),%ymm3
  .byte  197,252,16,84,36,192                // vmovups       -0x40(%rsp),%ymm2
  .byte  197,252,16,76,36,160                // vmovups       -0x60(%rsp),%ymm1
  .byte  197,252,16,68,36,128                // vmovups       -0x80(%rsp),%ymm0
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  196,193,84,20,242                   // vunpcklps     %ymm10,%ymm5,%ymm6
  .byte  196,65,84,21,194                    // vunpckhps     %ymm10,%ymm5,%ymm8
  .byte  197,196,20,236                      // vunpcklps     %ymm4,%ymm7,%ymm5
  .byte  197,196,21,252                      // vunpckhps     %ymm4,%ymm7,%ymm7
  .byte  197,205,20,229                      // vunpcklpd     %ymm5,%ymm6,%ymm4
  .byte  197,205,21,237                      // vunpckhpd     %ymm5,%ymm6,%ymm5
  .byte  197,189,20,247                      // vunpcklpd     %ymm7,%ymm8,%ymm6
  .byte  197,189,21,255                      // vunpckhpd     %ymm7,%ymm8,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  197,197,87,255                      // vxorpd        %ymm7,%ymm7,%ymm7
  .byte  196,65,45,87,210                    // vxorpd        %ymm10,%ymm10,%ymm10
  .byte  197,213,87,237                      // vxorpd        %ymm5,%ymm5,%ymm5
  .byte  235,203                             // jmp           d9fb <_sk_load_f32_dst_hsw+0x14b>
  .byte  29,255,255,255,163                  // sbb           $0xa3ffffff,%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,142,255,255,255,121             // decl          0x79ffffff(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,94,255                          // lcall         *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,72,255                          // decl          -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,55                              // pushq         (%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,42                              // ljmp          *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_f32_hsw
.globl _sk_store_f32_hsw
FUNCTION(_sk_store_f32_hsw)
_sk_store_f32_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  197,124,20,193                      // vunpcklps     %ymm1,%ymm0,%ymm8
  .byte  197,124,21,217                      // vunpckhps     %ymm1,%ymm0,%ymm11
  .byte  197,108,20,203                      // vunpcklps     %ymm3,%ymm2,%ymm9
  .byte  197,108,21,227                      // vunpckhps     %ymm3,%ymm2,%ymm12
  .byte  196,65,61,20,209                    // vunpcklpd     %ymm9,%ymm8,%ymm10
  .byte  196,65,61,21,201                    // vunpckhpd     %ymm9,%ymm8,%ymm9
  .byte  196,65,37,20,196                    // vunpcklpd     %ymm12,%ymm11,%ymm8
  .byte  196,65,37,21,220                    // vunpckhpd     %ymm12,%ymm11,%ymm11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,55                              // jne           dacf <_sk_store_f32_hsw+0x7f>
  .byte  196,67,45,24,225,1                  // vinsertf128   $0x1,%xmm9,%ymm10,%ymm12
  .byte  196,67,61,24,235,1                  // vinsertf128   $0x1,%xmm11,%ymm8,%ymm13
  .byte  196,67,45,6,201,49                  // vperm2f128    $0x31,%ymm9,%ymm10,%ymm9
  .byte  196,67,61,6,195,49                  // vperm2f128    $0x31,%ymm11,%ymm8,%ymm8
  .byte  196,65,125,17,36,128                // vmovupd       %ymm12,(%r8,%rax,4)
  .byte  196,65,125,17,108,128,32            // vmovupd       %ymm13,0x20(%r8,%rax,4)
  .byte  196,65,125,17,76,128,64             // vmovupd       %ymm9,0x40(%r8,%rax,4)
  .byte  196,65,125,17,68,128,96             // vmovupd       %ymm8,0x60(%r8,%rax,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,121,17,20,128                // vmovupd       %xmm10,(%r8,%rax,4)
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,240                             // je            dacb <_sk_store_f32_hsw+0x7b>
  .byte  196,65,121,17,76,128,16             // vmovupd       %xmm9,0x10(%r8,%rax,4)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,227                             // jb            dacb <_sk_store_f32_hsw+0x7b>
  .byte  196,65,121,17,68,128,32             // vmovupd       %xmm8,0x20(%r8,%rax,4)
  .byte  116,218                             // je            dacb <_sk_store_f32_hsw+0x7b>
  .byte  196,65,121,17,92,128,48             // vmovupd       %xmm11,0x30(%r8,%rax,4)
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,205                             // jb            dacb <_sk_store_f32_hsw+0x7b>
  .byte  196,67,125,25,84,128,64,1           // vextractf128  $0x1,%ymm10,0x40(%r8,%rax,4)
  .byte  116,195                             // je            dacb <_sk_store_f32_hsw+0x7b>
  .byte  196,67,125,25,76,128,80,1           // vextractf128  $0x1,%ymm9,0x50(%r8,%rax,4)
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,181                             // jb            dacb <_sk_store_f32_hsw+0x7b>
  .byte  196,67,125,25,68,128,96,1           // vextractf128  $0x1,%ymm8,0x60(%r8,%rax,4)
  .byte  235,171                             // jmp           dacb <_sk_store_f32_hsw+0x7b>

HIDDEN _sk_repeat_x_hsw
.globl _sk_repeat_x_hsw
FUNCTION(_sk_repeat_x_hsw)
_sk_repeat_x_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,4                  // vbroadcastss  0x4(%rax),%ymm8
  .byte  197,60,89,192                       // vmulps        %ymm0,%ymm8,%ymm8
  .byte  196,67,125,8,192,1                  // vroundps      $0x1,%ymm8,%ymm8
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,194,61,188,193                  // vfnmadd231ps  %ymm9,%ymm8,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_repeat_y_hsw
.globl _sk_repeat_y_hsw
FUNCTION(_sk_repeat_y_hsw)
_sk_repeat_y_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,4                  // vbroadcastss  0x4(%rax),%ymm8
  .byte  197,60,89,193                       // vmulps        %ymm1,%ymm8,%ymm8
  .byte  196,67,125,8,192,1                  // vroundps      $0x1,%ymm8,%ymm8
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,194,61,188,201                  // vfnmadd231ps  %ymm9,%ymm8,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_x_hsw
.globl _sk_mirror_x_hsw
FUNCTION(_sk_mirror_x_hsw)
_sk_mirror_x_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,122,16,0                        // vmovss        (%rax),%xmm8
  .byte  197,122,16,72,4                     // vmovss        0x4(%rax),%xmm9
  .byte  196,66,125,24,208                   // vbroadcastss  %xmm8,%ymm10
  .byte  196,65,124,92,218                   // vsubps        %ymm10,%ymm0,%ymm11
  .byte  196,193,58,88,192                   // vaddss        %xmm8,%xmm8,%xmm0
  .byte  196,98,125,24,192                   // vbroadcastss  %xmm0,%ymm8
  .byte  197,178,89,5,141,198,2,0            // vmulss        0x2c68d(%rip),%xmm9,%xmm0        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,226,125,24,192                  // vbroadcastss  %xmm0,%ymm0
  .byte  197,164,89,192                      // vmulps        %ymm0,%ymm11,%ymm0
  .byte  196,227,125,8,192,1                 // vroundps      $0x1,%ymm0,%ymm0
  .byte  196,194,61,172,195                  // vfnmadd213ps  %ymm11,%ymm8,%ymm0
  .byte  196,193,124,92,194                  // vsubps        %ymm10,%ymm0,%ymm0
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,92,192                       // vsubps        %ymm0,%ymm8,%ymm8
  .byte  197,188,84,192                      // vandps        %ymm0,%ymm8,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_y_hsw
.globl _sk_mirror_y_hsw
FUNCTION(_sk_mirror_y_hsw)
_sk_mirror_y_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,122,16,0                        // vmovss        (%rax),%xmm8
  .byte  197,122,16,72,4                     // vmovss        0x4(%rax),%xmm9
  .byte  196,66,125,24,208                   // vbroadcastss  %xmm8,%ymm10
  .byte  196,65,116,92,218                   // vsubps        %ymm10,%ymm1,%ymm11
  .byte  196,193,58,88,200                   // vaddss        %xmm8,%xmm8,%xmm1
  .byte  196,98,125,24,193                   // vbroadcastss  %xmm1,%ymm8
  .byte  197,178,89,13,60,198,2,0            // vmulss        0x2c63c(%rip),%xmm9,%xmm1        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,226,125,24,201                  // vbroadcastss  %xmm1,%ymm1
  .byte  197,164,89,201                      // vmulps        %ymm1,%ymm11,%ymm1
  .byte  196,227,125,8,201,1                 // vroundps      $0x1,%ymm1,%ymm1
  .byte  196,194,61,172,203                  // vfnmadd213ps  %ymm11,%ymm8,%ymm1
  .byte  196,193,116,92,202                  // vsubps        %ymm10,%ymm1,%ymm1
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,92,193                       // vsubps        %ymm1,%ymm8,%ymm8
  .byte  197,188,84,201                      // vandps        %ymm1,%ymm8,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_x_1_hsw
.globl _sk_clamp_x_1_hsw
FUNCTION(_sk_clamp_x_1_hsw)
_sk_clamp_x_1_hsw:
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  196,98,125,24,5,4,198,2,0           // vbroadcastss  0x2c604(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_repeat_x_1_hsw
.globl _sk_repeat_x_1_hsw
FUNCTION(_sk_repeat_x_1_hsw)
_sk_repeat_x_1_hsw:
  .byte  196,99,125,8,192,1                  // vroundps      $0x1,%ymm0,%ymm8
  .byte  196,193,124,92,192                  // vsubps        %ymm8,%ymm0,%ymm0
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  196,98,125,24,5,222,197,2,0         // vbroadcastss  0x2c5de(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_x_1_hsw
.globl _sk_mirror_x_1_hsw
FUNCTION(_sk_mirror_x_1_hsw)
_sk_mirror_x_1_hsw:
  .byte  196,98,125,24,5,228,197,2,0         // vbroadcastss  0x2c5e4(%rip),%ymm8        # 3a230 <_sk_srcover_bgra_8888_sse2_lowp+0x2c8>
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,24,13,186,197,2,0        // vbroadcastss  0x2c5ba(%rip),%ymm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,124,89,201                   // vmulps        %ymm9,%ymm0,%ymm9
  .byte  196,67,125,8,201,1                  // vroundps      $0x1,%ymm9,%ymm9
  .byte  196,65,52,88,201                    // vaddps        %ymm9,%ymm9,%ymm9
  .byte  196,193,124,92,193                  // vsubps        %ymm9,%ymm0,%ymm0
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,92,200                       // vsubps        %ymm0,%ymm8,%ymm9
  .byte  197,180,84,192                      // vandps        %ymm0,%ymm9,%ymm0
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  196,98,125,24,5,138,197,2,0         // vbroadcastss  0x2c58a(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_luminance_to_alpha_hsw
.globl _sk_luminance_to_alpha_hsw
FUNCTION(_sk_luminance_to_alpha_hsw)
_sk_luminance_to_alpha_hsw:
  .byte  196,226,125,24,29,156,198,2,0       // vbroadcastss  0x2c69c(%rip),%ymm3        # 3a33c <_sk_srcover_bgra_8888_sse2_lowp+0x3d4>
  .byte  196,98,125,24,5,143,198,2,0         // vbroadcastss  0x2c68f(%rip),%ymm8        # 3a338 <_sk_srcover_bgra_8888_sse2_lowp+0x3d0>
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  196,226,125,184,203                 // vfmadd231ps   %ymm3,%ymm0,%ymm1
  .byte  196,226,125,24,29,132,198,2,0       // vbroadcastss  0x2c684(%rip),%ymm3        # 3a340 <_sk_srcover_bgra_8888_sse2_lowp+0x3d8>
  .byte  196,226,109,168,217                 // vfmadd213ps   %ymm1,%ymm2,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_translate_hsw
.globl _sk_matrix_translate_hsw
FUNCTION(_sk_matrix_translate_hsw)
_sk_matrix_translate_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  197,188,88,192                      // vaddps        %ymm0,%ymm8,%ymm0
  .byte  196,98,125,24,64,4                  // vbroadcastss  0x4(%rax),%ymm8
  .byte  197,188,88,201                      // vaddps        %ymm1,%ymm8,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_scale_translate_hsw
.globl _sk_matrix_scale_translate_hsw
FUNCTION(_sk_matrix_scale_translate_hsw)
_sk_matrix_scale_translate_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  196,98,125,24,72,8                  // vbroadcastss  0x8(%rax),%ymm9
  .byte  196,194,61,168,193                  // vfmadd213ps   %ymm9,%ymm8,%ymm0
  .byte  196,98,125,24,64,4                  // vbroadcastss  0x4(%rax),%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,194,61,168,201                  // vfmadd213ps   %ymm9,%ymm8,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_2x3_hsw
.globl _sk_matrix_2x3_hsw
FUNCTION(_sk_matrix_2x3_hsw)
_sk_matrix_2x3_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,98,125,24,80,8                  // vbroadcastss  0x8(%rax),%ymm10
  .byte  196,98,125,24,64,16                 // vbroadcastss  0x10(%rax),%ymm8
  .byte  196,66,117,184,194                  // vfmadd231ps   %ymm10,%ymm1,%ymm8
  .byte  196,66,125,184,193                  // vfmadd231ps   %ymm9,%ymm0,%ymm8
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  196,98,125,24,88,12                 // vbroadcastss  0xc(%rax),%ymm11
  .byte  196,98,125,24,72,20                 // vbroadcastss  0x14(%rax),%ymm9
  .byte  196,66,117,184,203                  // vfmadd231ps   %ymm11,%ymm1,%ymm9
  .byte  196,66,125,184,202                  // vfmadd231ps   %ymm10,%ymm0,%ymm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,124,41,201                      // vmovaps       %ymm9,%ymm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_3x4_hsw
.globl _sk_matrix_3x4_hsw
FUNCTION(_sk_matrix_3x4_hsw)
_sk_matrix_3x4_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,98,125,24,80,12                 // vbroadcastss  0xc(%rax),%ymm10
  .byte  196,98,125,24,88,24                 // vbroadcastss  0x18(%rax),%ymm11
  .byte  196,98,125,24,64,36                 // vbroadcastss  0x24(%rax),%ymm8
  .byte  196,66,109,184,195                  // vfmadd231ps   %ymm11,%ymm2,%ymm8
  .byte  196,66,117,184,194                  // vfmadd231ps   %ymm10,%ymm1,%ymm8
  .byte  196,66,125,184,193                  // vfmadd231ps   %ymm9,%ymm0,%ymm8
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  196,98,125,24,88,16                 // vbroadcastss  0x10(%rax),%ymm11
  .byte  196,98,125,24,96,28                 // vbroadcastss  0x1c(%rax),%ymm12
  .byte  196,98,125,24,72,40                 // vbroadcastss  0x28(%rax),%ymm9
  .byte  196,66,109,184,204                  // vfmadd231ps   %ymm12,%ymm2,%ymm9
  .byte  196,66,117,184,203                  // vfmadd231ps   %ymm11,%ymm1,%ymm9
  .byte  196,66,125,184,202                  // vfmadd231ps   %ymm10,%ymm0,%ymm9
  .byte  196,98,125,24,88,8                  // vbroadcastss  0x8(%rax),%ymm11
  .byte  196,98,125,24,96,20                 // vbroadcastss  0x14(%rax),%ymm12
  .byte  196,98,125,24,104,32                // vbroadcastss  0x20(%rax),%ymm13
  .byte  196,98,125,24,80,44                 // vbroadcastss  0x2c(%rax),%ymm10
  .byte  196,66,109,184,213                  // vfmadd231ps   %ymm13,%ymm2,%ymm10
  .byte  196,66,117,184,212                  // vfmadd231ps   %ymm12,%ymm1,%ymm10
  .byte  196,66,125,184,211                  // vfmadd231ps   %ymm11,%ymm0,%ymm10
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,124,41,201                      // vmovaps       %ymm9,%ymm1
  .byte  197,124,41,210                      // vmovaps       %ymm10,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_4x5_hsw
.globl _sk_matrix_4x5_hsw
FUNCTION(_sk_matrix_4x5_hsw)
_sk_matrix_4x5_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,98,125,24,80,16                 // vbroadcastss  0x10(%rax),%ymm10
  .byte  196,98,125,24,88,32                 // vbroadcastss  0x20(%rax),%ymm11
  .byte  196,98,125,24,96,48                 // vbroadcastss  0x30(%rax),%ymm12
  .byte  196,98,125,24,64,64                 // vbroadcastss  0x40(%rax),%ymm8
  .byte  196,66,101,184,196                  // vfmadd231ps   %ymm12,%ymm3,%ymm8
  .byte  196,66,109,184,195                  // vfmadd231ps   %ymm11,%ymm2,%ymm8
  .byte  196,66,117,184,194                  // vfmadd231ps   %ymm10,%ymm1,%ymm8
  .byte  196,66,125,184,193                  // vfmadd231ps   %ymm9,%ymm0,%ymm8
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  196,98,125,24,96,36                 // vbroadcastss  0x24(%rax),%ymm12
  .byte  196,98,125,24,104,52                // vbroadcastss  0x34(%rax),%ymm13
  .byte  196,98,125,24,72,68                 // vbroadcastss  0x44(%rax),%ymm9
  .byte  196,66,101,184,205                  // vfmadd231ps   %ymm13,%ymm3,%ymm9
  .byte  196,66,109,184,204                  // vfmadd231ps   %ymm12,%ymm2,%ymm9
  .byte  196,66,117,184,203                  // vfmadd231ps   %ymm11,%ymm1,%ymm9
  .byte  196,66,125,184,202                  // vfmadd231ps   %ymm10,%ymm0,%ymm9
  .byte  196,98,125,24,88,8                  // vbroadcastss  0x8(%rax),%ymm11
  .byte  196,98,125,24,96,24                 // vbroadcastss  0x18(%rax),%ymm12
  .byte  196,98,125,24,104,40                // vbroadcastss  0x28(%rax),%ymm13
  .byte  196,98,125,24,112,56                // vbroadcastss  0x38(%rax),%ymm14
  .byte  196,98,125,24,80,72                 // vbroadcastss  0x48(%rax),%ymm10
  .byte  196,66,101,184,214                  // vfmadd231ps   %ymm14,%ymm3,%ymm10
  .byte  196,66,109,184,213                  // vfmadd231ps   %ymm13,%ymm2,%ymm10
  .byte  196,66,117,184,212                  // vfmadd231ps   %ymm12,%ymm1,%ymm10
  .byte  196,66,125,184,211                  // vfmadd231ps   %ymm11,%ymm0,%ymm10
  .byte  196,98,125,24,96,12                 // vbroadcastss  0xc(%rax),%ymm12
  .byte  196,98,125,24,104,28                // vbroadcastss  0x1c(%rax),%ymm13
  .byte  196,98,125,24,112,44                // vbroadcastss  0x2c(%rax),%ymm14
  .byte  196,98,125,24,120,60                // vbroadcastss  0x3c(%rax),%ymm15
  .byte  196,98,125,24,88,76                 // vbroadcastss  0x4c(%rax),%ymm11
  .byte  196,66,101,184,223                  // vfmadd231ps   %ymm15,%ymm3,%ymm11
  .byte  196,66,109,184,222                  // vfmadd231ps   %ymm14,%ymm2,%ymm11
  .byte  196,66,117,184,221                  // vfmadd231ps   %ymm13,%ymm1,%ymm11
  .byte  196,66,125,184,220                  // vfmadd231ps   %ymm12,%ymm0,%ymm11
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,124,41,201                      // vmovaps       %ymm9,%ymm1
  .byte  197,124,41,210                      // vmovaps       %ymm10,%ymm2
  .byte  197,124,41,219                      // vmovaps       %ymm11,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_4x3_hsw
.globl _sk_matrix_4x3_hsw
FUNCTION(_sk_matrix_4x3_hsw)
_sk_matrix_4x3_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,16                   // vbroadcastss  (%rax),%ymm2
  .byte  196,226,125,24,88,16                // vbroadcastss  0x10(%rax),%ymm3
  .byte  196,98,125,24,64,32                 // vbroadcastss  0x20(%rax),%ymm8
  .byte  196,98,117,184,195                  // vfmadd231ps   %ymm3,%ymm1,%ymm8
  .byte  196,98,125,184,194                  // vfmadd231ps   %ymm2,%ymm0,%ymm8
  .byte  196,226,125,24,80,4                 // vbroadcastss  0x4(%rax),%ymm2
  .byte  196,226,125,24,88,20                // vbroadcastss  0x14(%rax),%ymm3
  .byte  196,98,125,24,72,36                 // vbroadcastss  0x24(%rax),%ymm9
  .byte  196,98,117,184,203                  // vfmadd231ps   %ymm3,%ymm1,%ymm9
  .byte  196,98,125,184,202                  // vfmadd231ps   %ymm2,%ymm0,%ymm9
  .byte  196,226,125,24,88,8                 // vbroadcastss  0x8(%rax),%ymm3
  .byte  196,98,125,24,80,24                 // vbroadcastss  0x18(%rax),%ymm10
  .byte  196,226,125,24,80,40                // vbroadcastss  0x28(%rax),%ymm2
  .byte  196,194,117,184,210                 // vfmadd231ps   %ymm10,%ymm1,%ymm2
  .byte  196,226,125,184,211                 // vfmadd231ps   %ymm3,%ymm0,%ymm2
  .byte  196,98,125,24,80,12                 // vbroadcastss  0xc(%rax),%ymm10
  .byte  196,98,125,24,88,28                 // vbroadcastss  0x1c(%rax),%ymm11
  .byte  196,226,125,24,88,44                // vbroadcastss  0x2c(%rax),%ymm3
  .byte  196,194,117,184,219                 // vfmadd231ps   %ymm11,%ymm1,%ymm3
  .byte  196,194,125,184,218                 // vfmadd231ps   %ymm10,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,124,41,201                      // vmovaps       %ymm9,%ymm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_perspective_hsw
.globl _sk_matrix_perspective_hsw
FUNCTION(_sk_matrix_perspective_hsw)
_sk_matrix_perspective_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  196,98,125,24,72,4                  // vbroadcastss  0x4(%rax),%ymm9
  .byte  196,98,125,24,80,8                  // vbroadcastss  0x8(%rax),%ymm10
  .byte  196,66,117,184,209                  // vfmadd231ps   %ymm9,%ymm1,%ymm10
  .byte  196,66,125,184,208                  // vfmadd231ps   %ymm8,%ymm0,%ymm10
  .byte  196,98,125,24,64,12                 // vbroadcastss  0xc(%rax),%ymm8
  .byte  196,98,125,24,72,16                 // vbroadcastss  0x10(%rax),%ymm9
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  196,66,117,184,217                  // vfmadd231ps   %ymm9,%ymm1,%ymm11
  .byte  196,66,125,184,216                  // vfmadd231ps   %ymm8,%ymm0,%ymm11
  .byte  196,98,125,24,64,24                 // vbroadcastss  0x18(%rax),%ymm8
  .byte  196,98,125,24,72,28                 // vbroadcastss  0x1c(%rax),%ymm9
  .byte  196,98,125,24,96,32                 // vbroadcastss  0x20(%rax),%ymm12
  .byte  196,66,117,184,225                  // vfmadd231ps   %ymm9,%ymm1,%ymm12
  .byte  196,66,125,184,224                  // vfmadd231ps   %ymm8,%ymm0,%ymm12
  .byte  196,193,124,83,204                  // vrcpps        %ymm12,%ymm1
  .byte  197,172,89,193                      // vmulps        %ymm1,%ymm10,%ymm0
  .byte  197,164,89,201                      // vmulps        %ymm1,%ymm11,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_gradient_hsw
.globl _sk_evenly_spaced_gradient_hsw
FUNCTION(_sk_evenly_spaced_gradient_hsw)
_sk_evenly_spaced_gradient_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,8                            // mov           (%rax),%r9
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  77,137,202                          // mov           %r9,%r10
  .byte  73,255,202                          // dec           %r10
  .byte  120,7                               // js            dfb4 <_sk_evenly_spaced_gradient_hsw+0x18>
  .byte  196,193,242,42,202                  // vcvtsi2ss     %r10,%xmm1,%xmm1
  .byte  235,22                              // jmp           dfca <_sk_evenly_spaced_gradient_hsw+0x2e>
  .byte  77,137,211                          // mov           %r10,%r11
  .byte  73,209,235                          // shr           %r11
  .byte  65,131,226,1                        // and           $0x1,%r10d
  .byte  77,9,218                            // or            %r11,%r10
  .byte  196,193,242,42,202                  // vcvtsi2ss     %r10,%xmm1,%xmm1
  .byte  197,242,88,201                      // vaddss        %xmm1,%xmm1,%xmm1
  .byte  196,226,125,24,201                  // vbroadcastss  %xmm1,%ymm1
  .byte  197,244,89,200                      // vmulps        %ymm0,%ymm1,%ymm1
  .byte  197,126,91,225                      // vcvttps2dq    %ymm1,%ymm12
  .byte  73,131,249,8                        // cmp           $0x8,%r9
  .byte  119,73                              // ja            e026 <_sk_evenly_spaced_gradient_hsw+0x8a>
  .byte  196,66,29,22,0                      // vpermps       (%r8),%ymm12,%ymm8
  .byte  76,139,64,40                        // mov           0x28(%rax),%r8
  .byte  196,66,29,22,8                      // vpermps       (%r8),%ymm12,%ymm9
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  76,139,72,24                        // mov           0x18(%rax),%r9
  .byte  196,194,29,22,8                     // vpermps       (%r8),%ymm12,%ymm1
  .byte  76,139,64,48                        // mov           0x30(%rax),%r8
  .byte  196,66,29,22,24                     // vpermps       (%r8),%ymm12,%ymm11
  .byte  196,194,29,22,17                    // vpermps       (%r9),%ymm12,%ymm2
  .byte  76,139,64,56                        // mov           0x38(%rax),%r8
  .byte  196,66,29,22,40                     // vpermps       (%r8),%ymm12,%ymm13
  .byte  76,139,64,32                        // mov           0x20(%rax),%r8
  .byte  196,194,29,22,24                    // vpermps       (%r8),%ymm12,%ymm3
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  196,98,29,22,16                     // vpermps       (%rax),%ymm12,%ymm10
  .byte  233,147,0,0,0                       // jmpq          e0b9 <_sk_evenly_spaced_gradient_hsw+0x11d>
  .byte  196,65,13,118,246                   // vpcmpeqd      %ymm14,%ymm14,%ymm14
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,2,117,146,4,160                 // vgatherdps    %ymm1,(%r8,%ymm12,4),%ymm8
  .byte  76,139,64,40                        // mov           0x28(%rax),%r8
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  196,2,117,146,12,160                // vgatherdps    %ymm1,(%r8,%ymm12,4),%ymm9
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  76,139,72,24                        // mov           0x18(%rax),%r9
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,130,109,146,12,160              // vgatherdps    %ymm2,(%r8,%ymm12,4),%ymm1
  .byte  76,139,64,48                        // mov           0x30(%rax),%r8
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  196,2,109,146,28,160                // vgatherdps    %ymm2,(%r8,%ymm12,4),%ymm11
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,130,101,146,20,161              // vgatherdps    %ymm3,(%r9,%ymm12,4),%ymm2
  .byte  76,139,64,56                        // mov           0x38(%rax),%r8
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,65,20,87,237                    // vxorps        %ymm13,%ymm13,%ymm13
  .byte  196,2,101,146,44,160                // vgatherdps    %ymm3,(%r8,%ymm12,4),%ymm13
  .byte  76,139,64,32                        // mov           0x20(%rax),%r8
  .byte  196,65,5,118,255                    // vpcmpeqd      %ymm15,%ymm15,%ymm15
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,130,5,146,28,160                // vgatherdps    %ymm15,(%r8,%ymm12,4),%ymm3
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  196,34,13,146,20,160                // vgatherdps    %ymm14,(%rax,%ymm12,4),%ymm10
  .byte  196,66,125,168,193                  // vfmadd213ps   %ymm9,%ymm0,%ymm8
  .byte  196,194,125,168,203                 // vfmadd213ps   %ymm11,%ymm0,%ymm1
  .byte  196,194,125,168,213                 // vfmadd213ps   %ymm13,%ymm0,%ymm2
  .byte  196,194,125,168,218                 // vfmadd213ps   %ymm10,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gradient_hsw
.globl _sk_gradient_hsw
FUNCTION(_sk_gradient_hsw)
_sk_gradient_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  73,131,248,1                        // cmp           $0x1,%r8
  .byte  15,134,220,0,0,0                    // jbe           e1c0 <_sk_gradient_hsw+0xeb>
  .byte  76,139,72,72                        // mov           0x48(%rax),%r9
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  65,186,1,0,0,0                      // mov           $0x1,%r10d
  .byte  196,226,125,24,21,33,193,2,0        // vbroadcastss  0x2c121(%rip),%ymm2        # 3a21c <_sk_srcover_bgra_8888_sse2_lowp+0x2b4>
  .byte  196,65,53,239,201                   // vpxor         %ymm9,%ymm9,%ymm9
  .byte  196,130,125,24,28,145               // vbroadcastss  (%r9,%r10,4),%ymm3
  .byte  197,228,194,216,2                   // vcmpleps      %ymm0,%ymm3,%ymm3
  .byte  196,227,117,74,218,48               // vblendvps     %ymm3,%ymm2,%ymm1,%ymm3
  .byte  197,53,254,203                      // vpaddd        %ymm3,%ymm9,%ymm9
  .byte  73,255,194                          // inc           %r10
  .byte  77,57,208                           // cmp           %r10,%r8
  .byte  117,227                             // jne           e100 <_sk_gradient_hsw+0x2b>
  .byte  76,139,72,8                         // mov           0x8(%rax),%r9
  .byte  73,131,248,8                        // cmp           $0x8,%r8
  .byte  15,134,158,0,0,0                    // jbe           e1c9 <_sk_gradient_hsw+0xf4>
  .byte  196,65,13,118,246                   // vpcmpeqd      %ymm14,%ymm14,%ymm14
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,2,117,146,4,137                 // vgatherdps    %ymm1,(%r9,%ymm9,4),%ymm8
  .byte  76,139,64,40                        // mov           0x28(%rax),%r8
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,2,117,146,20,136                // vgatherdps    %ymm1,(%r8,%ymm9,4),%ymm10
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  76,139,72,24                        // mov           0x18(%rax),%r9
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,130,109,146,12,136              // vgatherdps    %ymm2,(%r8,%ymm9,4),%ymm1
  .byte  76,139,64,48                        // mov           0x30(%rax),%r8
  .byte  196,65,28,87,228                    // vxorps        %ymm12,%ymm12,%ymm12
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,2,109,146,36,136                // vgatherdps    %ymm2,(%r8,%ymm9,4),%ymm12
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,130,101,146,20,137              // vgatherdps    %ymm3,(%r9,%ymm9,4),%ymm2
  .byte  76,139,64,56                        // mov           0x38(%rax),%r8
  .byte  196,65,20,87,237                    // vxorps        %ymm13,%ymm13,%ymm13
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,2,101,146,44,136                // vgatherdps    %ymm3,(%r8,%ymm9,4),%ymm13
  .byte  76,139,64,32                        // mov           0x20(%rax),%r8
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,65,5,118,255                    // vpcmpeqd      %ymm15,%ymm15,%ymm15
  .byte  196,130,5,146,28,136                // vgatherdps    %ymm15,(%r8,%ymm9,4),%ymm3
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  196,34,13,146,28,136                // vgatherdps    %ymm14,(%rax,%ymm9,4),%ymm11
  .byte  235,77                              // jmp           e20d <_sk_gradient_hsw+0x138>
  .byte  76,139,72,8                         // mov           0x8(%rax),%r9
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  196,66,53,22,1                      // vpermps       (%r9),%ymm9,%ymm8
  .byte  76,139,64,40                        // mov           0x28(%rax),%r8
  .byte  196,66,53,22,16                     // vpermps       (%r8),%ymm9,%ymm10
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  76,139,72,24                        // mov           0x18(%rax),%r9
  .byte  196,194,53,22,8                     // vpermps       (%r8),%ymm9,%ymm1
  .byte  76,139,64,48                        // mov           0x30(%rax),%r8
  .byte  196,66,53,22,32                     // vpermps       (%r8),%ymm9,%ymm12
  .byte  196,194,53,22,17                    // vpermps       (%r9),%ymm9,%ymm2
  .byte  76,139,64,56                        // mov           0x38(%rax),%r8
  .byte  196,66,53,22,40                     // vpermps       (%r8),%ymm9,%ymm13
  .byte  76,139,64,32                        // mov           0x20(%rax),%r8
  .byte  196,194,53,22,24                    // vpermps       (%r8),%ymm9,%ymm3
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  196,98,53,22,24                     // vpermps       (%rax),%ymm9,%ymm11
  .byte  196,66,125,168,194                  // vfmadd213ps   %ymm10,%ymm0,%ymm8
  .byte  196,194,125,168,204                 // vfmadd213ps   %ymm12,%ymm0,%ymm1
  .byte  196,194,125,168,213                 // vfmadd213ps   %ymm13,%ymm0,%ymm2
  .byte  196,194,125,168,219                 // vfmadd213ps   %ymm11,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_2_stop_gradient_hsw
.globl _sk_evenly_spaced_2_stop_gradient_hsw
FUNCTION(_sk_evenly_spaced_2_stop_gradient_hsw)
_sk_evenly_spaced_2_stop_gradient_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,8                    // vbroadcastss  (%rax),%ymm1
  .byte  196,98,125,24,64,16                 // vbroadcastss  0x10(%rax),%ymm8
  .byte  196,98,125,184,193                  // vfmadd231ps   %ymm1,%ymm0,%ymm8
  .byte  196,226,125,24,80,4                 // vbroadcastss  0x4(%rax),%ymm2
  .byte  196,226,125,24,72,20                // vbroadcastss  0x14(%rax),%ymm1
  .byte  196,226,125,184,202                 // vfmadd231ps   %ymm2,%ymm0,%ymm1
  .byte  196,226,125,24,88,8                 // vbroadcastss  0x8(%rax),%ymm3
  .byte  196,226,125,24,80,24                // vbroadcastss  0x18(%rax),%ymm2
  .byte  196,226,125,184,211                 // vfmadd231ps   %ymm3,%ymm0,%ymm2
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,226,125,24,88,28                // vbroadcastss  0x1c(%rax),%ymm3
  .byte  196,194,125,184,217                 // vfmadd231ps   %ymm9,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_unit_angle_hsw
.globl _sk_xy_to_unit_angle_hsw
FUNCTION(_sk_xy_to_unit_angle_hsw)
_sk_xy_to_unit_angle_hsw:
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,92,200                       // vsubps        %ymm0,%ymm8,%ymm9
  .byte  197,52,84,200                       // vandps        %ymm0,%ymm9,%ymm9
  .byte  197,60,92,209                       // vsubps        %ymm1,%ymm8,%ymm10
  .byte  197,44,84,209                       // vandps        %ymm1,%ymm10,%ymm10
  .byte  196,65,52,93,218                    // vminps        %ymm10,%ymm9,%ymm11
  .byte  196,65,52,95,226                    // vmaxps        %ymm10,%ymm9,%ymm12
  .byte  196,65,36,94,220                    // vdivps        %ymm12,%ymm11,%ymm11
  .byte  196,65,36,89,227                    // vmulps        %ymm11,%ymm11,%ymm12
  .byte  196,98,125,24,45,156,192,2,0        // vbroadcastss  0x2c09c(%rip),%ymm13        # 3a344 <_sk_srcover_bgra_8888_sse2_lowp+0x3dc>
  .byte  196,98,125,24,53,151,192,2,0        // vbroadcastss  0x2c097(%rip),%ymm14        # 3a348 <_sk_srcover_bgra_8888_sse2_lowp+0x3e0>
  .byte  196,66,29,184,245                   // vfmadd231ps   %ymm13,%ymm12,%ymm14
  .byte  196,98,125,24,45,141,192,2,0        // vbroadcastss  0x2c08d(%rip),%ymm13        # 3a34c <_sk_srcover_bgra_8888_sse2_lowp+0x3e4>
  .byte  196,66,29,184,238                   // vfmadd231ps   %ymm14,%ymm12,%ymm13
  .byte  196,98,125,24,53,131,192,2,0        // vbroadcastss  0x2c083(%rip),%ymm14        # 3a350 <_sk_srcover_bgra_8888_sse2_lowp+0x3e8>
  .byte  196,66,29,184,245                   // vfmadd231ps   %ymm13,%ymm12,%ymm14
  .byte  196,65,36,89,222                    // vmulps        %ymm14,%ymm11,%ymm11
  .byte  196,65,52,194,202,1                 // vcmpltps      %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,21,110,192,2,0        // vbroadcastss  0x2c06e(%rip),%ymm10        # 3a354 <_sk_srcover_bgra_8888_sse2_lowp+0x3ec>
  .byte  196,65,44,92,211                    // vsubps        %ymm11,%ymm10,%ymm10
  .byte  196,67,37,74,202,144                // vblendvps     %ymm9,%ymm10,%ymm11,%ymm9
  .byte  196,193,124,194,192,1               // vcmpltps      %ymm8,%ymm0,%ymm0
  .byte  196,98,125,24,21,20,191,2,0         // vbroadcastss  0x2bf14(%rip),%ymm10        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,44,92,209                    // vsubps        %ymm9,%ymm10,%ymm10
  .byte  196,195,53,74,194,0                 // vblendvps     %ymm0,%ymm10,%ymm9,%ymm0
  .byte  196,65,116,194,200,1                // vcmpltps      %ymm8,%ymm1,%ymm9
  .byte  196,98,125,24,21,254,190,2,0        // vbroadcastss  0x2befe(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,44,92,208                       // vsubps        %ymm0,%ymm10,%ymm10
  .byte  196,195,125,74,194,144              // vblendvps     %ymm9,%ymm10,%ymm0,%ymm0
  .byte  196,65,124,194,200,3                // vcmpunordps   %ymm8,%ymm0,%ymm9
  .byte  196,195,125,74,192,144              // vblendvps     %ymm9,%ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_radius_hsw
.globl _sk_xy_to_radius_hsw
FUNCTION(_sk_xy_to_radius_hsw)
_sk_xy_to_radius_hsw:
  .byte  197,116,89,193                      // vmulps        %ymm1,%ymm1,%ymm8
  .byte  196,98,125,184,192                  // vfmadd231ps   %ymm0,%ymm0,%ymm8
  .byte  196,193,124,81,192                  // vsqrtps       %ymm8,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_quadratic_first_hsw
.globl _sk_xy_to_2pt_conical_quadratic_first_hsw
FUNCTION(_sk_xy_to_2pt_conical_quadratic_first_hsw)
_sk_xy_to_2pt_conical_quadratic_first_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,64                 // vbroadcastss  0x40(%rax),%ymm8
  .byte  197,122,16,72,72                    // vmovss        0x48(%rax),%xmm9
  .byte  197,50,89,80,76                     // vmulss        0x4c(%rax),%xmm9,%xmm10
  .byte  196,66,125,24,210                   // vbroadcastss  %xmm10,%ymm10
  .byte  197,44,88,208                       // vaddps        %ymm0,%ymm10,%ymm10
  .byte  196,98,125,24,29,238,191,2,0        // vbroadcastss  0x2bfee(%rip),%ymm11        # 3a358 <_sk_srcover_bgra_8888_sse2_lowp+0x3f0>
  .byte  196,65,44,89,211                    // vmulps        %ymm11,%ymm10,%ymm10
  .byte  197,116,89,217                      // vmulps        %ymm1,%ymm1,%ymm11
  .byte  196,98,125,184,216                  // vfmadd231ps   %ymm0,%ymm0,%ymm11
  .byte  196,193,50,89,193                   // vmulss        %xmm9,%xmm9,%xmm0
  .byte  196,226,125,24,192                  // vbroadcastss  %xmm0,%ymm0
  .byte  197,164,92,192                      // vsubps        %ymm0,%ymm11,%ymm0
  .byte  196,98,125,24,13,205,191,2,0        // vbroadcastss  0x2bfcd(%rip),%ymm9        # 3a35c <_sk_srcover_bgra_8888_sse2_lowp+0x3f4>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  196,194,45,184,194                  // vfmadd231ps   %ymm10,%ymm10,%ymm0
  .byte  197,252,81,192                      // vsqrtps       %ymm0,%ymm0
  .byte  196,98,125,24,64,68                 // vbroadcastss  0x44(%rax),%ymm8
  .byte  196,193,124,92,194                  // vsubps        %ymm10,%ymm0,%ymm0
  .byte  196,98,125,24,13,95,190,2,0         // vbroadcastss  0x2be5f(%rip),%ymm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_quadratic_second_hsw
.globl _sk_xy_to_2pt_conical_quadratic_second_hsw
FUNCTION(_sk_xy_to_2pt_conical_quadratic_second_hsw)
_sk_xy_to_2pt_conical_quadratic_second_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,64                 // vbroadcastss  0x40(%rax),%ymm8
  .byte  197,122,16,72,72                    // vmovss        0x48(%rax),%xmm9
  .byte  197,50,89,80,76                     // vmulss        0x4c(%rax),%xmm9,%xmm10
  .byte  196,66,125,24,210                   // vbroadcastss  %xmm10,%ymm10
  .byte  197,44,88,208                       // vaddps        %ymm0,%ymm10,%ymm10
  .byte  196,98,125,24,29,113,191,2,0        // vbroadcastss  0x2bf71(%rip),%ymm11        # 3a358 <_sk_srcover_bgra_8888_sse2_lowp+0x3f0>
  .byte  196,65,44,89,211                    // vmulps        %ymm11,%ymm10,%ymm10
  .byte  197,116,89,217                      // vmulps        %ymm1,%ymm1,%ymm11
  .byte  196,98,125,184,216                  // vfmadd231ps   %ymm0,%ymm0,%ymm11
  .byte  196,193,50,89,193                   // vmulss        %xmm9,%xmm9,%xmm0
  .byte  196,226,125,24,192                  // vbroadcastss  %xmm0,%ymm0
  .byte  197,164,92,192                      // vsubps        %ymm0,%ymm11,%ymm0
  .byte  196,98,125,24,13,80,191,2,0         // vbroadcastss  0x2bf50(%rip),%ymm9        # 3a35c <_sk_srcover_bgra_8888_sse2_lowp+0x3f4>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  196,194,45,184,194                  // vfmadd231ps   %ymm10,%ymm10,%ymm0
  .byte  197,252,81,192                      // vsqrtps       %ymm0,%ymm0
  .byte  196,98,125,24,64,68                 // vbroadcastss  0x44(%rax),%ymm8
  .byte  196,98,125,24,13,51,191,2,0         // vbroadcastss  0x2bf33(%rip),%ymm9        # 3a360 <_sk_srcover_bgra_8888_sse2_lowp+0x3f8>
  .byte  196,65,44,87,201                    // vxorps        %ymm9,%ymm10,%ymm9
  .byte  197,180,92,192                      // vsubps        %ymm0,%ymm9,%ymm0
  .byte  196,98,125,24,13,213,189,2,0        // vbroadcastss  0x2bdd5(%rip),%ymm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_linear_hsw
.globl _sk_xy_to_2pt_conical_linear_hsw
FUNCTION(_sk_xy_to_2pt_conical_linear_hsw)
_sk_xy_to_2pt_conical_linear_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,122,16,64,72                    // vmovss        0x48(%rax),%xmm8
  .byte  197,58,89,72,76                     // vmulss        0x4c(%rax),%xmm8,%xmm9
  .byte  196,66,125,24,201                   // vbroadcastss  %xmm9,%ymm9
  .byte  197,52,88,200                       // vaddps        %ymm0,%ymm9,%ymm9
  .byte  196,98,125,24,21,237,190,2,0        // vbroadcastss  0x2beed(%rip),%ymm10        # 3a358 <_sk_srcover_bgra_8888_sse2_lowp+0x3f0>
  .byte  196,65,52,89,202                    // vmulps        %ymm10,%ymm9,%ymm9
  .byte  197,116,89,209                      // vmulps        %ymm1,%ymm1,%ymm10
  .byte  196,98,125,184,208                  // vfmadd231ps   %ymm0,%ymm0,%ymm10
  .byte  196,193,58,89,192                   // vmulss        %xmm8,%xmm8,%xmm0
  .byte  196,226,125,24,192                  // vbroadcastss  %xmm0,%ymm0
  .byte  197,172,92,192                      // vsubps        %ymm0,%ymm10,%ymm0
  .byte  196,98,125,24,5,208,190,2,0         // vbroadcastss  0x2bed0(%rip),%ymm8        # 3a360 <_sk_srcover_bgra_8888_sse2_lowp+0x3f8>
  .byte  196,193,124,87,192                  // vxorps        %ymm8,%ymm0,%ymm0
  .byte  196,193,124,94,193                  // vdivps        %ymm9,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mask_2pt_conical_degenerates_hsw
.globl _sk_mask_2pt_conical_degenerates_hsw
FUNCTION(_sk_mask_2pt_conical_degenerates_hsw)
_sk_mask_2pt_conical_degenerates_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,76                 // vbroadcastss  0x4c(%rax),%ymm8
  .byte  196,98,125,24,72,72                 // vbroadcastss  0x48(%rax),%ymm9
  .byte  196,66,125,184,200                  // vfmadd231ps   %ymm8,%ymm0,%ymm9
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,65,52,194,200,1                 // vcmpltps      %ymm8,%ymm9,%ymm9
  .byte  196,65,124,194,208,3                // vcmpunordps   %ymm8,%ymm0,%ymm10
  .byte  196,65,52,86,202                    // vorps         %ymm10,%ymm9,%ymm9
  .byte  196,195,125,74,192,144              // vblendvps     %ymm9,%ymm8,%ymm0,%ymm0
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  196,67,45,74,192,144                // vblendvps     %ymm9,%ymm8,%ymm10,%ymm8
  .byte  197,124,17,0                        // vmovups       %ymm8,(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_apply_vector_mask_hsw
.globl _sk_apply_vector_mask_hsw
FUNCTION(_sk_apply_vector_mask_hsw)
_sk_apply_vector_mask_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,16,0                        // vmovups       (%rax),%ymm8
  .byte  197,188,84,192                      // vandps        %ymm0,%ymm8,%ymm0
  .byte  197,188,84,201                      // vandps        %ymm1,%ymm8,%ymm1
  .byte  197,188,84,210                      // vandps        %ymm2,%ymm8,%ymm2
  .byte  197,188,84,219                      // vandps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_save_xy_hsw
.globl _sk_save_xy_hsw
FUNCTION(_sk_save_xy_hsw)
_sk_save_xy_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,5,15,189,2,0          // vbroadcastss  0x2bd0f(%rip),%ymm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,124,88,200                   // vaddps        %ymm8,%ymm0,%ymm9
  .byte  196,67,125,8,209,1                  // vroundps      $0x1,%ymm9,%ymm10
  .byte  196,65,52,92,202                    // vsubps        %ymm10,%ymm9,%ymm9
  .byte  196,65,116,88,192                   // vaddps        %ymm8,%ymm1,%ymm8
  .byte  196,67,125,8,208,1                  // vroundps      $0x1,%ymm8,%ymm10
  .byte  196,65,60,92,194                    // vsubps        %ymm10,%ymm8,%ymm8
  .byte  197,252,17,0                        // vmovups       %ymm0,(%rax)
  .byte  197,252,17,72,64                    // vmovups       %ymm1,0x40(%rax)
  .byte  197,124,17,136,128,0,0,0            // vmovups       %ymm9,0x80(%rax)
  .byte  197,124,17,128,192,0,0,0            // vmovups       %ymm8,0xc0(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_accumulate_hsw
.globl _sk_accumulate_hsw
FUNCTION(_sk_accumulate_hsw)
_sk_accumulate_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,16,128,0,1,0,0              // vmovups       0x100(%rax),%ymm8
  .byte  197,60,89,128,64,1,0,0              // vmulps        0x140(%rax),%ymm8,%ymm8
  .byte  196,226,61,184,224                  // vfmadd231ps   %ymm0,%ymm8,%ymm4
  .byte  196,226,61,184,233                  // vfmadd231ps   %ymm1,%ymm8,%ymm5
  .byte  196,226,61,184,242                  // vfmadd231ps   %ymm2,%ymm8,%ymm6
  .byte  196,98,101,168,199                  // vfmadd213ps   %ymm7,%ymm3,%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,199                      // vmovaps       %ymm8,%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_nx_hsw
.globl _sk_bilinear_nx_hsw
FUNCTION(_sk_bilinear_nx_hsw)
_sk_bilinear_nx_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,5,233,189,2,0        // vbroadcastss  0x2bde9(%rip),%ymm0        # 3a364 <_sk_srcover_bgra_8888_sse2_lowp+0x3fc>
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  196,98,125,24,5,144,188,2,0         // vbroadcastss  0x2bc90(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,128,0,0,0             // vsubps        0x80(%rax),%ymm8,%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_px_hsw
.globl _sk_bilinear_px_hsw
FUNCTION(_sk_bilinear_px_hsw)
_sk_bilinear_px_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,5,109,188,2,0        // vbroadcastss  0x2bc6d(%rip),%ymm0        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  197,124,16,128,128,0,0,0            // vmovups       0x80(%rax),%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_ny_hsw
.globl _sk_bilinear_ny_hsw
FUNCTION(_sk_bilinear_ny_hsw)
_sk_bilinear_ny_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,13,154,189,2,0       // vbroadcastss  0x2bd9a(%rip),%ymm1        # 3a364 <_sk_srcover_bgra_8888_sse2_lowp+0x3fc>
  .byte  197,244,88,72,64                    // vaddps        0x40(%rax),%ymm1,%ymm1
  .byte  196,98,125,24,5,64,188,2,0          // vbroadcastss  0x2bc40(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,192,0,0,0             // vsubps        0xc0(%rax),%ymm8,%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_py_hsw
.globl _sk_bilinear_py_hsw
FUNCTION(_sk_bilinear_py_hsw)
_sk_bilinear_py_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,13,29,188,2,0        // vbroadcastss  0x2bc1d(%rip),%ymm1        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,244,88,72,64                    // vaddps        0x40(%rax),%ymm1,%ymm1
  .byte  197,124,16,128,192,0,0,0            // vmovups       0xc0(%rax),%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n3x_hsw
.globl _sk_bicubic_n3x_hsw
FUNCTION(_sk_bicubic_n3x_hsw)
_sk_bicubic_n3x_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,5,77,189,2,0         // vbroadcastss  0x2bd4d(%rip),%ymm0        # 3a368 <_sk_srcover_bgra_8888_sse2_lowp+0x400>
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  196,98,125,24,5,240,187,2,0         // vbroadcastss  0x2bbf0(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,128,0,0,0             // vsubps        0x80(%rax),%ymm8,%ymm8
  .byte  196,65,60,89,200                    // vmulps        %ymm8,%ymm8,%ymm9
  .byte  196,98,125,24,21,78,188,2,0         // vbroadcastss  0x2bc4e(%rip),%ymm10        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  196,98,125,24,29,37,189,2,0         // vbroadcastss  0x2bd25(%rip),%ymm11        # 3a36c <_sk_srcover_bgra_8888_sse2_lowp+0x404>
  .byte  196,66,61,168,218                   // vfmadd213ps   %ymm10,%ymm8,%ymm11
  .byte  196,65,36,89,193                    // vmulps        %ymm9,%ymm11,%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n1x_hsw
.globl _sk_bicubic_n1x_hsw
FUNCTION(_sk_bicubic_n1x_hsw)
_sk_bicubic_n1x_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,5,252,188,2,0        // vbroadcastss  0x2bcfc(%rip),%ymm0        # 3a364 <_sk_srcover_bgra_8888_sse2_lowp+0x3fc>
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  196,98,125,24,5,163,187,2,0         // vbroadcastss  0x2bba3(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,128,0,0,0             // vsubps        0x80(%rax),%ymm8,%ymm8
  .byte  196,98,125,24,13,238,188,2,0        // vbroadcastss  0x2bcee(%rip),%ymm9        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  196,98,125,24,21,225,188,2,0        // vbroadcastss  0x2bce1(%rip),%ymm10        # 3a370 <_sk_srcover_bgra_8888_sse2_lowp+0x408>
  .byte  196,66,61,168,209                   // vfmadd213ps   %ymm9,%ymm8,%ymm10
  .byte  196,98,125,24,13,119,187,2,0        // vbroadcastss  0x2bb77(%rip),%ymm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,66,61,184,202                   // vfmadd231ps   %ymm10,%ymm8,%ymm9
  .byte  196,98,125,24,21,205,188,2,0        // vbroadcastss  0x2bccd(%rip),%ymm10        # 3a378 <_sk_srcover_bgra_8888_sse2_lowp+0x410>
  .byte  196,66,61,184,209                   // vfmadd231ps   %ymm9,%ymm8,%ymm10
  .byte  197,124,17,144,0,1,0,0              // vmovups       %ymm10,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p1x_hsw
.globl _sk_bicubic_p1x_hsw
FUNCTION(_sk_bicubic_p1x_hsw)
_sk_bicubic_p1x_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,5,77,187,2,0          // vbroadcastss  0x2bb4d(%rip),%ymm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,188,88,0                        // vaddps        (%rax),%ymm8,%ymm0
  .byte  197,124,16,136,128,0,0,0            // vmovups       0x80(%rax),%ymm9
  .byte  196,98,125,24,21,152,188,2,0        // vbroadcastss  0x2bc98(%rip),%ymm10        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  196,98,125,24,29,139,188,2,0        // vbroadcastss  0x2bc8b(%rip),%ymm11        # 3a370 <_sk_srcover_bgra_8888_sse2_lowp+0x408>
  .byte  196,66,53,168,218                   // vfmadd213ps   %ymm10,%ymm9,%ymm11
  .byte  196,66,53,168,216                   // vfmadd213ps   %ymm8,%ymm9,%ymm11
  .byte  196,98,125,24,5,128,188,2,0         // vbroadcastss  0x2bc80(%rip),%ymm8        # 3a378 <_sk_srcover_bgra_8888_sse2_lowp+0x410>
  .byte  196,66,53,184,195                   // vfmadd231ps   %ymm11,%ymm9,%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p3x_hsw
.globl _sk_bicubic_p3x_hsw
FUNCTION(_sk_bicubic_p3x_hsw)
_sk_bicubic_p3x_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,5,96,188,2,0         // vbroadcastss  0x2bc60(%rip),%ymm0        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  197,124,16,128,128,0,0,0            // vmovups       0x80(%rax),%ymm8
  .byte  196,65,60,89,200                    // vmulps        %ymm8,%ymm8,%ymm9
  .byte  196,98,125,24,21,94,187,2,0         // vbroadcastss  0x2bb5e(%rip),%ymm10        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  196,98,125,24,29,53,188,2,0         // vbroadcastss  0x2bc35(%rip),%ymm11        # 3a36c <_sk_srcover_bgra_8888_sse2_lowp+0x404>
  .byte  196,66,61,168,218                   // vfmadd213ps   %ymm10,%ymm8,%ymm11
  .byte  196,65,52,89,195                    // vmulps        %ymm11,%ymm9,%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n3y_hsw
.globl _sk_bicubic_n3y_hsw
FUNCTION(_sk_bicubic_n3y_hsw)
_sk_bicubic_n3y_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,13,16,188,2,0        // vbroadcastss  0x2bc10(%rip),%ymm1        # 3a368 <_sk_srcover_bgra_8888_sse2_lowp+0x400>
  .byte  197,244,88,72,64                    // vaddps        0x40(%rax),%ymm1,%ymm1
  .byte  196,98,125,24,5,178,186,2,0         // vbroadcastss  0x2bab2(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,192,0,0,0             // vsubps        0xc0(%rax),%ymm8,%ymm8
  .byte  196,65,60,89,200                    // vmulps        %ymm8,%ymm8,%ymm9
  .byte  196,98,125,24,21,16,187,2,0         // vbroadcastss  0x2bb10(%rip),%ymm10        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  196,98,125,24,29,231,187,2,0        // vbroadcastss  0x2bbe7(%rip),%ymm11        # 3a36c <_sk_srcover_bgra_8888_sse2_lowp+0x404>
  .byte  196,66,61,168,218                   // vfmadd213ps   %ymm10,%ymm8,%ymm11
  .byte  196,65,36,89,193                    // vmulps        %ymm9,%ymm11,%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n1y_hsw
.globl _sk_bicubic_n1y_hsw
FUNCTION(_sk_bicubic_n1y_hsw)
_sk_bicubic_n1y_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,13,190,187,2,0       // vbroadcastss  0x2bbbe(%rip),%ymm1        # 3a364 <_sk_srcover_bgra_8888_sse2_lowp+0x3fc>
  .byte  197,244,88,72,64                    // vaddps        0x40(%rax),%ymm1,%ymm1
  .byte  196,98,125,24,5,100,186,2,0         // vbroadcastss  0x2ba64(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,192,0,0,0             // vsubps        0xc0(%rax),%ymm8,%ymm8
  .byte  196,98,125,24,13,175,187,2,0        // vbroadcastss  0x2bbaf(%rip),%ymm9        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  196,98,125,24,21,162,187,2,0        // vbroadcastss  0x2bba2(%rip),%ymm10        # 3a370 <_sk_srcover_bgra_8888_sse2_lowp+0x408>
  .byte  196,66,61,168,209                   // vfmadd213ps   %ymm9,%ymm8,%ymm10
  .byte  196,98,125,24,13,56,186,2,0         // vbroadcastss  0x2ba38(%rip),%ymm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,66,61,184,202                   // vfmadd231ps   %ymm10,%ymm8,%ymm9
  .byte  196,98,125,24,21,142,187,2,0        // vbroadcastss  0x2bb8e(%rip),%ymm10        # 3a378 <_sk_srcover_bgra_8888_sse2_lowp+0x410>
  .byte  196,66,61,184,209                   // vfmadd231ps   %ymm9,%ymm8,%ymm10
  .byte  197,124,17,144,64,1,0,0             // vmovups       %ymm10,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p1y_hsw
.globl _sk_bicubic_p1y_hsw
FUNCTION(_sk_bicubic_p1y_hsw)
_sk_bicubic_p1y_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,5,14,186,2,0          // vbroadcastss  0x2ba0e(%rip),%ymm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,188,88,72,64                    // vaddps        0x40(%rax),%ymm8,%ymm1
  .byte  197,124,16,136,192,0,0,0            // vmovups       0xc0(%rax),%ymm9
  .byte  196,98,125,24,21,88,187,2,0         // vbroadcastss  0x2bb58(%rip),%ymm10        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  196,98,125,24,29,75,187,2,0         // vbroadcastss  0x2bb4b(%rip),%ymm11        # 3a370 <_sk_srcover_bgra_8888_sse2_lowp+0x408>
  .byte  196,66,53,168,218                   // vfmadd213ps   %ymm10,%ymm9,%ymm11
  .byte  196,66,53,168,216                   // vfmadd213ps   %ymm8,%ymm9,%ymm11
  .byte  196,98,125,24,5,64,187,2,0          // vbroadcastss  0x2bb40(%rip),%ymm8        # 3a378 <_sk_srcover_bgra_8888_sse2_lowp+0x410>
  .byte  196,66,53,184,195                   // vfmadd231ps   %ymm11,%ymm9,%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p3y_hsw
.globl _sk_bicubic_p3y_hsw
FUNCTION(_sk_bicubic_p3y_hsw)
_sk_bicubic_p3y_hsw:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,13,32,187,2,0        // vbroadcastss  0x2bb20(%rip),%ymm1        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  197,244,88,72,64                    // vaddps        0x40(%rax),%ymm1,%ymm1
  .byte  197,124,16,128,192,0,0,0            // vmovups       0xc0(%rax),%ymm8
  .byte  196,65,60,89,200                    // vmulps        %ymm8,%ymm8,%ymm9
  .byte  196,98,125,24,21,29,186,2,0         // vbroadcastss  0x2ba1d(%rip),%ymm10        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  196,98,125,24,29,244,186,2,0        // vbroadcastss  0x2baf4(%rip),%ymm11        # 3a36c <_sk_srcover_bgra_8888_sse2_lowp+0x404>
  .byte  196,66,61,168,218                   // vfmadd213ps   %ymm10,%ymm8,%ymm11
  .byte  196,65,52,89,195                    // vmulps        %ymm11,%ymm9,%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_callback_hsw
.globl _sk_callback_hsw
FUNCTION(_sk_callback_hsw)
_sk_callback_hsw:
  .byte  85                                  // push          %rbp
  .byte  72,137,229                          // mov           %rsp,%rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,228,224                      // and           $0xffffffffffffffe0,%rsp
  .byte  72,129,236,160,0,0,0                // sub           $0xa0,%rsp
  .byte  197,252,41,124,36,96                // vmovaps       %ymm7,0x60(%rsp)
  .byte  197,252,41,116,36,64                // vmovaps       %ymm6,0x40(%rsp)
  .byte  197,252,41,108,36,32                // vmovaps       %ymm5,0x20(%rsp)
  .byte  197,252,41,36,36                    // vmovaps       %ymm4,(%rsp)
  .byte  73,137,206                          // mov           %rcx,%r14
  .byte  73,137,215                          // mov           %rdx,%r15
  .byte  73,137,253                          // mov           %rdi,%r13
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,137,195                          // mov           %rax,%rbx
  .byte  73,137,244                          // mov           %rsi,%r12
  .byte  197,252,20,225                      // vunpcklps     %ymm1,%ymm0,%ymm4
  .byte  197,252,21,193                      // vunpckhps     %ymm1,%ymm0,%ymm0
  .byte  197,236,20,203                      // vunpcklps     %ymm3,%ymm2,%ymm1
  .byte  197,236,21,211                      // vunpckhps     %ymm3,%ymm2,%ymm2
  .byte  197,221,20,217                      // vunpcklpd     %ymm1,%ymm4,%ymm3
  .byte  197,221,21,201                      // vunpckhpd     %ymm1,%ymm4,%ymm1
  .byte  197,253,20,226                      // vunpcklpd     %ymm2,%ymm0,%ymm4
  .byte  197,253,21,194                      // vunpckhpd     %ymm2,%ymm0,%ymm0
  .byte  196,227,101,24,209,1                // vinsertf128   $0x1,%xmm1,%ymm3,%ymm2
  .byte  196,227,93,24,232,1                 // vinsertf128   $0x1,%xmm0,%ymm4,%ymm5
  .byte  196,227,101,6,201,49                // vperm2f128    $0x31,%ymm1,%ymm3,%ymm1
  .byte  196,227,93,6,192,49                 // vperm2f128    $0x31,%ymm0,%ymm4,%ymm0
  .byte  197,253,17,83,8                     // vmovupd       %ymm2,0x8(%rbx)
  .byte  197,253,17,107,40                   // vmovupd       %ymm5,0x28(%rbx)
  .byte  197,253,17,75,72                    // vmovupd       %ymm1,0x48(%rbx)
  .byte  197,253,17,67,104                   // vmovupd       %ymm0,0x68(%rbx)
  .byte  77,133,237                          // test          %r13,%r13
  .byte  190,8,0,0,0                         // mov           $0x8,%esi
  .byte  65,15,69,245                        // cmovne        %r13d,%esi
  .byte  72,137,223                          // mov           %rbx,%rdi
  .byte  197,248,119                         // vzeroupper
  .byte  255,19                              // callq         *(%rbx)
  .byte  72,139,131,8,1,0,0                  // mov           0x108(%rbx),%rax
  .byte  197,248,16,0                        // vmovups       (%rax),%xmm0
  .byte  197,248,16,72,16                    // vmovups       0x10(%rax),%xmm1
  .byte  197,248,16,80,32                    // vmovups       0x20(%rax),%xmm2
  .byte  197,248,16,88,48                    // vmovups       0x30(%rax),%xmm3
  .byte  196,227,101,24,88,112,1             // vinsertf128   $0x1,0x70(%rax),%ymm3,%ymm3
  .byte  196,227,109,24,80,96,1              // vinsertf128   $0x1,0x60(%rax),%ymm2,%ymm2
  .byte  196,227,117,24,72,80,1              // vinsertf128   $0x1,0x50(%rax),%ymm1,%ymm1
  .byte  196,227,125,24,64,64,1              // vinsertf128   $0x1,0x40(%rax),%ymm0,%ymm0
  .byte  197,252,20,225                      // vunpcklps     %ymm1,%ymm0,%ymm4
  .byte  197,252,21,233                      // vunpckhps     %ymm1,%ymm0,%ymm5
  .byte  197,236,20,203                      // vunpcklps     %ymm3,%ymm2,%ymm1
  .byte  197,236,21,219                      // vunpckhps     %ymm3,%ymm2,%ymm3
  .byte  197,221,20,193                      // vunpcklpd     %ymm1,%ymm4,%ymm0
  .byte  197,221,21,201                      // vunpckhpd     %ymm1,%ymm4,%ymm1
  .byte  197,213,20,211                      // vunpcklpd     %ymm3,%ymm5,%ymm2
  .byte  197,213,21,219                      // vunpckhpd     %ymm3,%ymm5,%ymm3
  .byte  76,137,230                          // mov           %r12,%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,137,239                          // mov           %r13,%rdi
  .byte  76,137,250                          // mov           %r15,%rdx
  .byte  76,137,241                          // mov           %r14,%rcx
  .byte  197,252,40,36,36                    // vmovaps       (%rsp),%ymm4
  .byte  197,252,40,108,36,32                // vmovaps       0x20(%rsp),%ymm5
  .byte  197,252,40,116,36,64                // vmovaps       0x40(%rsp),%ymm6
  .byte  197,252,40,124,36,96                // vmovaps       0x60(%rsp),%ymm7
  .byte  72,141,101,216                      // lea           -0x28(%rbp),%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clut_3D_hsw
.globl _sk_clut_3D_hsw
FUNCTION(_sk_clut_3D_hsw)
_sk_clut_3D_hsw:
  .byte  72,129,236,56,3,0,0                 // sub           $0x338,%rsp
  .byte  197,252,17,188,36,0,3,0,0           // vmovups       %ymm7,0x300(%rsp)
  .byte  197,252,17,180,36,224,2,0,0         // vmovups       %ymm6,0x2e0(%rsp)
  .byte  197,252,17,172,36,192,2,0,0         // vmovups       %ymm5,0x2c0(%rsp)
  .byte  197,252,17,164,36,160,2,0,0         // vmovups       %ymm4,0x2a0(%rsp)
  .byte  197,252,17,156,36,128,2,0,0         // vmovups       %ymm3,0x280(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,16                        // mov           0x10(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  196,193,121,110,217                 // vmovd         %r9d,%xmm3
  .byte  196,226,125,88,219                  // vpbroadcastd  %xmm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  197,228,89,210                      // vmulps        %ymm2,%ymm3,%ymm2
  .byte  197,254,91,234                      // vcvttps2dq    %ymm2,%ymm5
  .byte  197,252,40,242                      // vmovaps       %ymm2,%ymm6
  .byte  197,252,17,180,36,192,0,0,0         // vmovups       %ymm6,0xc0(%rsp)
  .byte  196,193,121,110,208                 // vmovd         %r8d,%xmm2
  .byte  196,193,121,110,216                 // vmovd         %r8d,%xmm3
  .byte  196,226,125,88,219                  // vpbroadcastd  %xmm3,%ymm3
  .byte  68,139,64,12                        // mov           0xc(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  196,193,121,110,225                 // vmovd         %r9d,%xmm4
  .byte  196,226,125,88,228                  // vpbroadcastd  %xmm4,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  197,220,89,201                      // vmulps        %ymm1,%ymm4,%ymm1
  .byte  197,254,91,225                      // vcvttps2dq    %ymm1,%ymm4
  .byte  197,254,127,164,36,96,2,0,0         // vmovdqu       %ymm4,0x260(%rsp)
  .byte  197,124,40,201                      // vmovaps       %ymm1,%ymm9
  .byte  197,124,17,140,36,224,1,0,0         // vmovups       %ymm9,0x1e0(%rsp)
  .byte  196,98,101,64,228                   // vpmulld       %ymm4,%ymm3,%ymm12
  .byte  197,157,254,205                     // vpaddd        %ymm5,%ymm12,%ymm1
  .byte  197,125,111,197                     // vmovdqa       %ymm5,%ymm8
  .byte  197,126,127,132,36,128,1,0,0        // vmovdqu       %ymm8,0x180(%rsp)
  .byte  196,193,121,110,224                 // vmovd         %r8d,%xmm4
  .byte  196,226,93,64,210                   // vpmulld       %ymm2,%ymm4,%ymm2
  .byte  196,226,125,88,226                  // vpbroadcastd  %xmm2,%ymm4
  .byte  68,139,64,8                         // mov           0x8(%rax),%r8d
  .byte  65,255,200                          // dec           %r8d
  .byte  196,193,121,110,208                 // vmovd         %r8d,%xmm2
  .byte  196,226,125,88,210                  // vpbroadcastd  %xmm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  197,236,89,192                      // vmulps        %ymm0,%ymm2,%ymm0
  .byte  197,254,91,208                      // vcvttps2dq    %ymm0,%ymm2
  .byte  197,254,127,148,36,64,2,0,0         // vmovdqu       %ymm2,0x240(%rsp)
  .byte  197,124,40,208                      // vmovaps       %ymm0,%ymm10
  .byte  197,124,17,148,36,192,1,0,0         // vmovups       %ymm10,0x1c0(%rsp)
  .byte  196,98,93,64,218                    // vpmulld       %ymm2,%ymm4,%ymm11
  .byte  72,139,0                            // mov           (%rax),%rax
  .byte  197,165,254,193                     // vpaddd        %ymm1,%ymm11,%ymm0
  .byte  196,98,125,88,61,182,184,2,0        // vpbroadcastd  0x2b8b6(%rip),%ymm15        # 3a380 <_sk_srcover_bgra_8888_sse2_lowp+0x418>
  .byte  196,194,125,64,199                  // vpmulld       %ymm15,%ymm0,%ymm0
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  196,226,109,146,44,128              // vgatherdps    %ymm2,(%rax,%ymm0,4),%ymm5
  .byte  197,252,17,172,36,32,2,0,0          // vmovups       %ymm5,0x220(%rsp)
  .byte  196,65,21,118,237                   // vpcmpeqd      %ymm13,%ymm13,%ymm13
  .byte  196,193,125,250,213                 // vpsubd        %ymm13,%ymm0,%ymm2
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  197,213,118,237                     // vpcmpeqd      %ymm5,%ymm5,%ymm5
  .byte  196,226,85,146,60,144               // vgatherdps    %ymm5,(%rax,%ymm2,4),%ymm7
  .byte  197,252,17,188,36,0,2,0,0           // vmovups       %ymm7,0x200(%rsp)
  .byte  196,226,125,88,61,20,183,2,0        // vpbroadcastd  0x2b714(%rip),%ymm7        # 3a224 <_sk_srcover_bgra_8888_sse2_lowp+0x2bc>
  .byte  197,253,254,199                     // vpaddd        %ymm7,%ymm0,%ymm0
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,213,118,237                     // vpcmpeqd      %ymm5,%ymm5,%ymm5
  .byte  196,226,85,146,20,128               // vgatherdps    %ymm5,(%rax,%ymm0,4),%ymm2
  .byte  197,252,17,148,36,32,1,0,0          // vmovups       %ymm2,0x120(%rsp)
  .byte  196,226,125,24,5,72,184,2,0         // vbroadcastss  0x2b848(%rip),%ymm0        # 3a37c <_sk_srcover_bgra_8888_sse2_lowp+0x414>
  .byte  197,172,88,232                      // vaddps        %ymm0,%ymm10,%ymm5
  .byte  197,254,91,237                      // vcvttps2dq    %ymm5,%ymm5
  .byte  196,226,93,64,213                   // vpmulld       %ymm5,%ymm4,%ymm2
  .byte  197,237,254,201                     // vpaddd        %ymm1,%ymm2,%ymm1
  .byte  196,194,117,64,207                  // vpmulld       %ymm15,%ymm1,%ymm1
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,226,93,146,44,136               // vgatherdps    %ymm4,(%rax,%ymm1,4),%ymm5
  .byte  197,252,17,172,36,160,1,0,0         // vmovups       %ymm5,0x1a0(%rsp)
  .byte  196,193,117,250,229                 // vpsubd        %ymm13,%ymm1,%ymm4
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  197,213,118,237                     // vpcmpeqd      %ymm5,%ymm5,%ymm5
  .byte  196,98,85,146,20,160                // vgatherdps    %ymm5,(%rax,%ymm4,4),%ymm10
  .byte  197,124,17,148,36,96,1,0,0          // vmovups       %ymm10,0x160(%rsp)
  .byte  197,245,254,207                     // vpaddd        %ymm7,%ymm1,%ymm1
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,226,93,146,44,136               // vgatherdps    %ymm4,(%rax,%ymm1,4),%ymm5
  .byte  197,252,17,172,36,64,1,0,0          // vmovups       %ymm5,0x140(%rsp)
  .byte  197,180,88,200                      // vaddps        %ymm0,%ymm9,%ymm1
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  196,98,101,64,201                   // vpmulld       %ymm1,%ymm3,%ymm9
  .byte  196,193,53,254,200                  // vpaddd        %ymm8,%ymm9,%ymm1
  .byte  196,193,117,254,219                 // vpaddd        %ymm11,%ymm1,%ymm3
  .byte  196,194,101,64,223                  // vpmulld       %ymm15,%ymm3,%ymm3
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,226,93,146,44,152               // vgatherdps    %ymm4,(%rax,%ymm3,4),%ymm5
  .byte  197,252,17,172,36,0,1,0,0           // vmovups       %ymm5,0x100(%rsp)
  .byte  196,193,101,250,229                 // vpsubd        %ymm13,%ymm3,%ymm4
  .byte  196,65,61,239,192                   // vpxor         %ymm8,%ymm8,%ymm8
  .byte  197,213,118,237                     // vpcmpeqd      %ymm5,%ymm5,%ymm5
  .byte  196,98,85,146,4,160                 // vgatherdps    %ymm5,(%rax,%ymm4,4),%ymm8
  .byte  197,124,17,132,36,224,0,0,0         // vmovups       %ymm8,0xe0(%rsp)
  .byte  197,229,254,223                     // vpaddd        %ymm7,%ymm3,%ymm3
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,226,93,146,44,152               // vgatherdps    %ymm4,(%rax,%ymm3,4),%ymm5
  .byte  197,252,17,172,36,160,0,0,0         // vmovups       %ymm5,0xa0(%rsp)
  .byte  197,237,254,201                     // vpaddd        %ymm1,%ymm2,%ymm1
  .byte  196,194,117,64,207                  // vpmulld       %ymm15,%ymm1,%ymm1
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,226,101,146,36,136              // vgatherdps    %ymm3,(%rax,%ymm1,4),%ymm4
  .byte  197,252,17,164,36,128,0,0,0         // vmovups       %ymm4,0x80(%rsp)
  .byte  196,193,117,250,221                 // vpsubd        %ymm13,%ymm1,%ymm3
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,226,93,146,44,152               // vgatherdps    %ymm4,(%rax,%ymm3,4),%ymm5
  .byte  197,252,17,108,36,96                // vmovups       %ymm5,0x60(%rsp)
  .byte  197,245,254,207                     // vpaddd        %ymm7,%ymm1,%ymm1
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,226,101,146,36,136              // vgatherdps    %ymm3,(%rax,%ymm1,4),%ymm4
  .byte  197,252,17,100,36,64                // vmovups       %ymm4,0x40(%rsp)
  .byte  197,204,88,192                      // vaddps        %ymm0,%ymm6,%ymm0
  .byte  197,126,91,208                      // vcvttps2dq    %ymm0,%ymm10
  .byte  196,193,29,254,218                  // vpaddd        %ymm10,%ymm12,%ymm3
  .byte  197,165,254,195                     // vpaddd        %ymm3,%ymm11,%ymm0
  .byte  196,194,125,64,199                  // vpmulld       %ymm15,%ymm0,%ymm0
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,226,117,146,36,128              // vgatherdps    %ymm1,(%rax,%ymm0,4),%ymm4
  .byte  197,252,17,100,36,32                // vmovups       %ymm4,0x20(%rsp)
  .byte  196,193,125,250,237                 // vpsubd        %ymm13,%ymm0,%ymm5
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,205,118,246                     // vpcmpeqd      %ymm6,%ymm6,%ymm6
  .byte  196,226,77,146,12,168               // vgatherdps    %ymm6,(%rax,%ymm5,4),%ymm1
  .byte  197,252,17,12,36                    // vmovups       %ymm1,(%rsp)
  .byte  197,253,254,239                     // vpaddd        %ymm7,%ymm0,%ymm5
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,205,118,246                     // vpcmpeqd      %ymm6,%ymm6,%ymm6
  .byte  196,226,77,146,4,168                // vgatherdps    %ymm6,(%rax,%ymm5,4),%ymm0
  .byte  197,252,17,68,36,224                // vmovups       %ymm0,-0x20(%rsp)
  .byte  197,237,254,219                     // vpaddd        %ymm3,%ymm2,%ymm3
  .byte  196,194,101,64,223                  // vpmulld       %ymm15,%ymm3,%ymm3
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,213,118,237                     // vpcmpeqd      %ymm5,%ymm5,%ymm5
  .byte  196,226,85,146,4,152                // vgatherdps    %ymm5,(%rax,%ymm3,4),%ymm0
  .byte  197,252,17,68,36,192                // vmovups       %ymm0,-0x40(%rsp)
  .byte  196,193,101,250,197                 // vpsubd        %ymm13,%ymm3,%ymm0
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,65,13,118,246                   // vpcmpeqd      %ymm14,%ymm14,%ymm14
  .byte  196,226,13,146,36,128               // vgatherdps    %ymm14,(%rax,%ymm0,4),%ymm4
  .byte  197,229,254,199                     // vpaddd        %ymm7,%ymm3,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,65,13,118,246                   // vpcmpeqd      %ymm14,%ymm14,%ymm14
  .byte  196,226,13,146,12,128               // vgatherdps    %ymm14,(%rax,%ymm0,4),%ymm1
  .byte  197,252,17,76,36,160                // vmovups       %ymm1,-0x60(%rsp)
  .byte  196,193,53,254,202                  // vpaddd        %ymm10,%ymm9,%ymm1
  .byte  196,65,117,254,211                  // vpaddd        %ymm11,%ymm1,%ymm10
  .byte  196,66,45,64,247                    // vpmulld       %ymm15,%ymm10,%ymm14
  .byte  196,65,45,239,210                   // vpxor         %ymm10,%ymm10,%ymm10
  .byte  196,65,29,118,228                   // vpcmpeqd      %ymm12,%ymm12,%ymm12
  .byte  196,34,29,146,20,176                // vgatherdps    %ymm12,(%rax,%ymm14,4),%ymm10
  .byte  196,65,13,250,229                   // vpsubd        %ymm13,%ymm14,%ymm12
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  196,65,37,118,219                   // vpcmpeqd      %ymm11,%ymm11,%ymm11
  .byte  196,162,37,146,4,160                // vgatherdps    %ymm11,(%rax,%ymm12,4),%ymm0
  .byte  197,252,17,68,36,128                // vmovups       %ymm0,-0x80(%rsp)
  .byte  197,13,254,223                      // vpaddd        %ymm7,%ymm14,%ymm11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,65,13,118,246                   // vpcmpeqd      %ymm14,%ymm14,%ymm14
  .byte  196,34,13,146,4,152                 // vgatherdps    %ymm14,(%rax,%ymm11,4),%ymm8
  .byte  197,237,254,201                     // vpaddd        %ymm1,%ymm2,%ymm1
  .byte  196,194,117,64,207                  // vpmulld       %ymm15,%ymm1,%ymm1
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  196,65,13,118,246                   // vpcmpeqd      %ymm14,%ymm14,%ymm14
  .byte  196,98,13,146,28,136                // vgatherdps    %ymm14,(%rax,%ymm1,4),%ymm11
  .byte  196,65,117,250,245                  // vpsubd        %ymm13,%ymm1,%ymm14
  .byte  196,65,5,239,255                    // vpxor         %ymm15,%ymm15,%ymm15
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,34,53,146,60,176                // vgatherdps    %ymm9,(%rax,%ymm14,4),%ymm15
  .byte  197,245,254,207                     // vpaddd        %ymm7,%ymm1,%ymm1
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  196,226,21,146,60,136               // vgatherdps    %ymm13,(%rax,%ymm1,4),%ymm7
  .byte  197,252,91,140,36,64,2,0,0          // vcvtdq2ps     0x240(%rsp),%ymm1
  .byte  197,252,16,132,36,192,1,0,0         // vmovups       0x1c0(%rsp),%ymm0
  .byte  197,252,92,201                      // vsubps        %ymm1,%ymm0,%ymm1
  .byte  197,252,16,132,36,32,2,0,0          // vmovups       0x220(%rsp),%ymm0
  .byte  197,252,16,156,36,160,1,0,0         // vmovups       0x1a0(%rsp),%ymm3
  .byte  197,100,92,200                      // vsubps        %ymm0,%ymm3,%ymm9
  .byte  196,98,117,168,200                  // vfmadd213ps   %ymm0,%ymm1,%ymm9
  .byte  197,252,16,132,36,0,2,0,0           // vmovups       0x200(%rsp),%ymm0
  .byte  197,252,16,156,36,96,1,0,0          // vmovups       0x160(%rsp),%ymm3
  .byte  197,100,92,232                      // vsubps        %ymm0,%ymm3,%ymm13
  .byte  196,98,117,168,232                  // vfmadd213ps   %ymm0,%ymm1,%ymm13
  .byte  197,252,16,148,36,32,1,0,0          // vmovups       0x120(%rsp),%ymm2
  .byte  197,252,16,132,36,64,1,0,0          // vmovups       0x140(%rsp),%ymm0
  .byte  197,124,92,242                      // vsubps        %ymm2,%ymm0,%ymm14
  .byte  196,98,117,168,242                  // vfmadd213ps   %ymm2,%ymm1,%ymm14
  .byte  197,252,16,132,36,0,1,0,0           // vmovups       0x100(%rsp),%ymm0
  .byte  197,252,16,148,36,128,0,0,0         // vmovups       0x80(%rsp),%ymm2
  .byte  197,108,92,224                      // vsubps        %ymm0,%ymm2,%ymm12
  .byte  196,98,117,168,224                  // vfmadd213ps   %ymm0,%ymm1,%ymm12
  .byte  197,252,16,132,36,224,0,0,0         // vmovups       0xe0(%rsp),%ymm0
  .byte  197,252,16,84,36,96                 // vmovups       0x60(%rsp),%ymm2
  .byte  197,236,92,232                      // vsubps        %ymm0,%ymm2,%ymm5
  .byte  196,226,117,168,232                 // vfmadd213ps   %ymm0,%ymm1,%ymm5
  .byte  197,252,16,132,36,160,0,0,0         // vmovups       0xa0(%rsp),%ymm0
  .byte  197,252,16,84,36,64                 // vmovups       0x40(%rsp),%ymm2
  .byte  197,236,92,240                      // vsubps        %ymm0,%ymm2,%ymm6
  .byte  196,226,117,168,240                 // vfmadd213ps   %ymm0,%ymm1,%ymm6
  .byte  197,252,16,84,36,32                 // vmovups       0x20(%rsp),%ymm2
  .byte  197,252,16,68,36,192                // vmovups       -0x40(%rsp),%ymm0
  .byte  197,252,92,194                      // vsubps        %ymm2,%ymm0,%ymm0
  .byte  196,226,117,168,194                 // vfmadd213ps   %ymm2,%ymm1,%ymm0
  .byte  197,252,16,28,36                    // vmovups       (%rsp),%ymm3
  .byte  197,220,92,211                      // vsubps        %ymm3,%ymm4,%ymm2
  .byte  196,226,117,168,211                 // vfmadd213ps   %ymm3,%ymm1,%ymm2
  .byte  197,252,16,100,36,224               // vmovups       -0x20(%rsp),%ymm4
  .byte  197,252,16,92,36,160                // vmovups       -0x60(%rsp),%ymm3
  .byte  197,228,92,220                      // vsubps        %ymm4,%ymm3,%ymm3
  .byte  196,226,117,168,220                 // vfmadd213ps   %ymm4,%ymm1,%ymm3
  .byte  196,65,36,92,218                    // vsubps        %ymm10,%ymm11,%ymm11
  .byte  196,66,117,168,218                  // vfmadd213ps   %ymm10,%ymm1,%ymm11
  .byte  197,252,16,100,36,128               // vmovups       -0x80(%rsp),%ymm4
  .byte  197,4,92,212                        // vsubps        %ymm4,%ymm15,%ymm10
  .byte  196,98,117,168,212                  // vfmadd213ps   %ymm4,%ymm1,%ymm10
  .byte  196,193,68,92,248                   // vsubps        %ymm8,%ymm7,%ymm7
  .byte  196,194,117,168,248                 // vfmadd213ps   %ymm8,%ymm1,%ymm7
  .byte  197,252,91,140,36,96,2,0,0          // vcvtdq2ps     0x260(%rsp),%ymm1
  .byte  197,124,16,132,36,224,1,0,0         // vmovups       0x1e0(%rsp),%ymm8
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  196,193,28,92,225                   // vsubps        %ymm9,%ymm12,%ymm4
  .byte  196,194,117,168,225                 // vfmadd213ps   %ymm9,%ymm1,%ymm4
  .byte  196,193,84,92,237                   // vsubps        %ymm13,%ymm5,%ymm5
  .byte  196,194,117,168,237                 // vfmadd213ps   %ymm13,%ymm1,%ymm5
  .byte  196,193,76,92,246                   // vsubps        %ymm14,%ymm6,%ymm6
  .byte  196,194,117,168,246                 // vfmadd213ps   %ymm14,%ymm1,%ymm6
  .byte  197,36,92,192                       // vsubps        %ymm0,%ymm11,%ymm8
  .byte  196,98,117,168,192                  // vfmadd213ps   %ymm0,%ymm1,%ymm8
  .byte  197,44,92,202                       // vsubps        %ymm2,%ymm10,%ymm9
  .byte  196,98,117,168,202                  // vfmadd213ps   %ymm2,%ymm1,%ymm9
  .byte  197,196,92,211                      // vsubps        %ymm3,%ymm7,%ymm2
  .byte  196,226,117,168,211                 // vfmadd213ps   %ymm3,%ymm1,%ymm2
  .byte  197,252,91,132,36,128,1,0,0         // vcvtdq2ps     0x180(%rsp),%ymm0
  .byte  197,252,16,140,36,192,0,0,0         // vmovups       0xc0(%rsp),%ymm1
  .byte  197,244,92,216                      // vsubps        %ymm0,%ymm1,%ymm3
  .byte  197,188,92,196                      // vsubps        %ymm4,%ymm8,%ymm0
  .byte  196,226,101,168,196                 // vfmadd213ps   %ymm4,%ymm3,%ymm0
  .byte  197,180,92,205                      // vsubps        %ymm5,%ymm9,%ymm1
  .byte  196,226,101,168,205                 // vfmadd213ps   %ymm5,%ymm3,%ymm1
  .byte  197,236,92,214                      // vsubps        %ymm6,%ymm2,%ymm2
  .byte  196,226,101,168,214                 // vfmadd213ps   %ymm6,%ymm3,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,156,36,128,2,0,0         // vmovups       0x280(%rsp),%ymm3
  .byte  197,252,16,164,36,160,2,0,0         // vmovups       0x2a0(%rsp),%ymm4
  .byte  197,252,16,172,36,192,2,0,0         // vmovups       0x2c0(%rsp),%ymm5
  .byte  197,252,16,180,36,224,2,0,0         // vmovups       0x2e0(%rsp),%ymm6
  .byte  197,252,16,188,36,0,3,0,0           // vmovups       0x300(%rsp),%ymm7
  .byte  72,129,196,56,3,0,0                 // add           $0x338,%rsp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clut_4D_hsw
.globl _sk_clut_4D_hsw
FUNCTION(_sk_clut_4D_hsw)
_sk_clut_4D_hsw:
  .byte  72,129,236,248,6,0,0                // sub           $0x6f8,%rsp
  .byte  197,252,17,188,36,192,6,0,0         // vmovups       %ymm7,0x6c0(%rsp)
  .byte  197,252,17,180,36,160,6,0,0         // vmovups       %ymm6,0x6a0(%rsp)
  .byte  197,252,17,172,36,128,6,0,0         // vmovups       %ymm5,0x680(%rsp)
  .byte  197,252,17,164,36,96,6,0,0          // vmovups       %ymm4,0x660(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,20                        // mov           0x14(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  196,193,121,110,225                 // vmovd         %r9d,%xmm4
  .byte  196,226,125,88,228                  // vpbroadcastd  %xmm4,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  197,220,89,219                      // vmulps        %ymm3,%ymm4,%ymm3
  .byte  197,252,17,156,36,32,1,0,0          // vmovups       %ymm3,0x120(%rsp)
  .byte  197,254,91,243                      // vcvttps2dq    %ymm3,%ymm6
  .byte  196,193,121,110,216                 // vmovd         %r8d,%xmm3
  .byte  196,193,121,110,224                 // vmovd         %r8d,%xmm4
  .byte  196,98,125,88,252                   // vpbroadcastd  %xmm4,%ymm15
  .byte  68,139,64,16                        // mov           0x10(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  196,193,121,110,233                 // vmovd         %r9d,%xmm5
  .byte  196,226,125,88,237                  // vpbroadcastd  %xmm5,%ymm5
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  197,212,89,210                      // vmulps        %ymm2,%ymm5,%ymm2
  .byte  197,254,91,234                      // vcvttps2dq    %ymm2,%ymm5
  .byte  197,254,127,172,36,64,6,0,0         // vmovdqu       %ymm5,0x640(%rsp)
  .byte  197,124,40,242                      // vmovaps       %ymm2,%ymm14
  .byte  197,124,17,180,36,224,5,0,0         // vmovups       %ymm14,0x5e0(%rsp)
  .byte  196,226,5,64,213                    // vpmulld       %ymm5,%ymm15,%ymm2
  .byte  197,254,127,84,36,160               // vmovdqu       %ymm2,-0x60(%rsp)
  .byte  197,237,254,230                     // vpaddd        %ymm6,%ymm2,%ymm4
  .byte  197,125,111,230                     // vmovdqa       %ymm6,%ymm12
  .byte  197,126,127,164,36,192,5,0,0        // vmovdqu       %ymm12,0x5c0(%rsp)
  .byte  196,193,121,110,232                 // vmovd         %r8d,%xmm5
  .byte  196,226,85,64,235                   // vpmulld       %ymm3,%ymm5,%ymm5
  .byte  196,226,125,88,221                  // vpbroadcastd  %xmm5,%ymm3
  .byte  68,139,64,12                        // mov           0xc(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  196,193,121,110,241                 // vmovd         %r9d,%xmm6
  .byte  196,226,125,88,246                  // vpbroadcastd  %xmm6,%ymm6
  .byte  197,252,91,246                      // vcvtdq2ps     %ymm6,%ymm6
  .byte  197,204,89,241                      // vmulps        %ymm1,%ymm6,%ymm6
  .byte  196,193,121,110,200                 // vmovd         %r8d,%xmm1
  .byte  196,226,117,64,205                  // vpmulld       %ymm5,%ymm1,%ymm1
  .byte  68,139,64,8                         // mov           0x8(%rax),%r8d
  .byte  65,255,200                          // dec           %r8d
  .byte  196,193,121,110,232                 // vmovd         %r8d,%xmm5
  .byte  196,226,125,88,237                  // vpbroadcastd  %xmm5,%ymm5
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  197,212,89,232                      // vmulps        %ymm0,%ymm5,%ymm5
  .byte  197,254,91,198                      // vcvttps2dq    %ymm6,%ymm0
  .byte  197,254,127,132,36,32,6,0,0         // vmovdqu       %ymm0,0x620(%rsp)
  .byte  197,252,17,180,36,0,6,0,0           // vmovups       %ymm6,0x600(%rsp)
  .byte  196,226,125,88,209                  // vpbroadcastd  %xmm1,%ymm2
  .byte  72,139,0                            // mov           (%rax),%rax
  .byte  196,226,101,64,192                  // vpmulld       %ymm0,%ymm3,%ymm0
  .byte  197,254,127,68,36,128               // vmovdqu       %ymm0,-0x80(%rsp)
  .byte  197,253,254,252                     // vpaddd        %ymm4,%ymm0,%ymm7
  .byte  197,254,91,197                      // vcvttps2dq    %ymm5,%ymm0
  .byte  197,252,40,205                      // vmovaps       %ymm5,%ymm1
  .byte  197,252,17,140,36,160,0,0,0         // vmovups       %ymm1,0xa0(%rsp)
  .byte  197,254,127,132,36,0,1,0,0          // vmovdqu       %ymm0,0x100(%rsp)
  .byte  196,98,109,64,200                   // vpmulld       %ymm0,%ymm2,%ymm9
  .byte  197,181,254,199                     // vpaddd        %ymm7,%ymm9,%ymm0
  .byte  196,98,125,88,21,225,178,2,0        // vpbroadcastd  0x2b2e1(%rip),%ymm10        # 3a380 <_sk_srcover_bgra_8888_sse2_lowp+0x418>
  .byte  196,194,125,64,194                  // vpmulld       %ymm10,%ymm0,%ymm0
  .byte  197,213,118,237                     // vpcmpeqd      %ymm5,%ymm5,%ymm5
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,98,85,146,4,128                 // vgatherdps    %ymm5,(%rax,%ymm0,4),%ymm8
  .byte  197,124,17,132,36,224,0,0,0         // vmovups       %ymm8,0xe0(%rsp)
  .byte  196,65,21,118,237                   // vpcmpeqd      %ymm13,%ymm13,%ymm13
  .byte  196,193,125,250,237                 // vpsubd        %ymm13,%ymm0,%ymm5
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  196,98,61,146,28,168                // vgatherdps    %ymm8,(%rax,%ymm5,4),%ymm11
  .byte  197,124,17,156,36,192,0,0,0         // vmovups       %ymm11,0xc0(%rsp)
  .byte  196,98,125,88,29,60,177,2,0         // vpbroadcastd  0x2b13c(%rip),%ymm11        # 3a224 <_sk_srcover_bgra_8888_sse2_lowp+0x2bc>
  .byte  196,193,125,254,195                 // vpaddd        %ymm11,%ymm0,%ymm0
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  196,226,61,146,44,128               // vgatherdps    %ymm8,(%rax,%ymm0,4),%ymm5
  .byte  197,252,17,108,36,32                // vmovups       %ymm5,0x20(%rsp)
  .byte  196,226,125,24,5,113,178,2,0        // vbroadcastss  0x2b271(%rip),%ymm0        # 3a37c <_sk_srcover_bgra_8888_sse2_lowp+0x414>
  .byte  197,116,88,192                      // vaddps        %ymm0,%ymm1,%ymm8
  .byte  196,65,126,91,192                   // vcvttps2dq    %ymm8,%ymm8
  .byte  196,194,109,64,232                  // vpmulld       %ymm8,%ymm2,%ymm5
  .byte  197,213,254,207                     // vpaddd        %ymm7,%ymm5,%ymm1
  .byte  196,194,117,64,202                  // vpmulld       %ymm10,%ymm1,%ymm1
  .byte  197,197,118,255                     // vpcmpeqd      %ymm7,%ymm7,%ymm7
  .byte  197,237,239,210                     // vpxor         %ymm2,%ymm2,%ymm2
  .byte  196,226,69,146,20,136               // vgatherdps    %ymm7,(%rax,%ymm1,4),%ymm2
  .byte  197,252,17,148,36,128,0,0,0         // vmovups       %ymm2,0x80(%rsp)
  .byte  196,193,117,250,253                 // vpsubd        %ymm13,%ymm1,%ymm7
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,226,61,146,20,184               // vgatherdps    %ymm8,(%rax,%ymm7,4),%ymm2
  .byte  197,252,17,84,36,96                 // vmovups       %ymm2,0x60(%rsp)
  .byte  196,193,117,254,203                 // vpaddd        %ymm11,%ymm1,%ymm1
  .byte  197,197,118,255                     // vpcmpeqd      %ymm7,%ymm7,%ymm7
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,226,69,146,20,136               // vgatherdps    %ymm7,(%rax,%ymm1,4),%ymm2
  .byte  197,252,17,84,36,64                 // vmovups       %ymm2,0x40(%rsp)
  .byte  197,204,88,200                      // vaddps        %ymm0,%ymm6,%ymm1
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  196,226,101,64,241                  // vpmulld       %ymm1,%ymm3,%ymm6
  .byte  197,205,254,204                     // vpaddd        %ymm4,%ymm6,%ymm1
  .byte  196,193,117,254,209                 // vpaddd        %ymm9,%ymm1,%ymm2
  .byte  196,194,109,64,210                  // vpmulld       %ymm10,%ymm2,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  196,226,101,146,36,144              // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm4
  .byte  197,252,17,164,36,96,5,0,0          // vmovups       %ymm4,0x560(%rsp)
  .byte  196,193,109,250,221                 // vpsubd        %ymm13,%ymm2,%ymm3
  .byte  197,197,118,255                     // vpcmpeqd      %ymm7,%ymm7,%ymm7
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,69,146,36,152               // vgatherdps    %ymm7,(%rax,%ymm3,4),%ymm4
  .byte  197,252,17,36,36                    // vmovups       %ymm4,(%rsp)
  .byte  196,193,109,254,211                 // vpaddd        %ymm11,%ymm2,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,101,146,36,144              // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm4
  .byte  197,252,17,100,36,224               // vmovups       %ymm4,-0x20(%rsp)
  .byte  197,213,254,201                     // vpaddd        %ymm1,%ymm5,%ymm1
  .byte  196,194,117,64,202                  // vpmulld       %ymm10,%ymm1,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,92,36,192                // vmovups       %ymm3,-0x40(%rsp)
  .byte  196,193,117,250,213                 // vpsubd        %ymm13,%ymm1,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,101,146,36,144              // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm4
  .byte  197,252,17,164,36,160,5,0,0         // vmovups       %ymm4,0x5a0(%rsp)
  .byte  196,193,117,254,203                 // vpaddd        %ymm11,%ymm1,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,128,5,0,0         // vmovups       %ymm3,0x580(%rsp)
  .byte  197,140,88,200                      // vaddps        %ymm0,%ymm14,%ymm1
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  196,98,5,64,249                     // vpmulld       %ymm1,%ymm15,%ymm15
  .byte  196,193,5,254,204                   // vpaddd        %ymm12,%ymm15,%ymm1
  .byte  197,126,111,68,36,128               // vmovdqu       -0x80(%rsp),%ymm8
  .byte  196,193,117,254,208                 // vpaddd        %ymm8,%ymm1,%ymm2
  .byte  196,193,109,254,217                 // vpaddd        %ymm9,%ymm2,%ymm3
  .byte  196,194,101,64,218                  // vpmulld       %ymm10,%ymm3,%ymm3
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  196,226,93,146,60,152               // vgatherdps    %ymm4,(%rax,%ymm3,4),%ymm7
  .byte  197,252,17,188,36,96,3,0,0          // vmovups       %ymm7,0x360(%rsp)
  .byte  196,193,101,250,229                 // vpsubd        %ymm13,%ymm3,%ymm4
  .byte  197,197,118,255                     // vpcmpeqd      %ymm7,%ymm7,%ymm7
  .byte  196,65,12,87,246                    // vxorps        %ymm14,%ymm14,%ymm14
  .byte  196,98,69,146,52,160                // vgatherdps    %ymm7,(%rax,%ymm4,4),%ymm14
  .byte  197,124,17,180,36,64,5,0,0          // vmovups       %ymm14,0x540(%rsp)
  .byte  196,193,101,254,219                 // vpaddd        %ymm11,%ymm3,%ymm3
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  196,226,93,146,60,152               // vgatherdps    %ymm4,(%rax,%ymm3,4),%ymm7
  .byte  197,252,17,188,36,192,4,0,0         // vmovups       %ymm7,0x4c0(%rsp)
  .byte  197,213,254,210                     // vpaddd        %ymm2,%ymm5,%ymm2
  .byte  196,194,109,64,210                  // vpmulld       %ymm10,%ymm2,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,101,146,36,144              // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm4
  .byte  197,252,17,164,36,32,5,0,0          // vmovups       %ymm4,0x520(%rsp)
  .byte  196,193,109,250,221                 // vpsubd        %ymm13,%ymm2,%ymm3
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,65,12,87,246                    // vxorps        %ymm14,%ymm14,%ymm14
  .byte  196,98,93,146,52,152                // vgatherdps    %ymm4,(%rax,%ymm3,4),%ymm14
  .byte  197,124,17,180,36,0,5,0,0           // vmovups       %ymm14,0x500(%rsp)
  .byte  196,193,109,254,211                 // vpaddd        %ymm11,%ymm2,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,101,146,36,144              // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm4
  .byte  197,252,17,164,36,224,4,0,0         // vmovups       %ymm4,0x4e0(%rsp)
  .byte  197,205,254,201                     // vpaddd        %ymm1,%ymm6,%ymm1
  .byte  196,193,117,254,209                 // vpaddd        %ymm9,%ymm1,%ymm2
  .byte  196,194,109,64,210                  // vpmulld       %ymm10,%ymm2,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,101,146,36,144              // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm4
  .byte  197,252,17,164,36,160,4,0,0         // vmovups       %ymm4,0x4a0(%rsp)
  .byte  196,193,109,250,221                 // vpsubd        %ymm13,%ymm2,%ymm3
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  196,226,93,146,60,152               // vgatherdps    %ymm4,(%rax,%ymm3,4),%ymm7
  .byte  197,252,17,188,36,128,4,0,0         // vmovups       %ymm7,0x480(%rsp)
  .byte  196,193,109,254,211                 // vpaddd        %ymm11,%ymm2,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,101,146,36,144              // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm4
  .byte  197,252,17,164,36,0,3,0,0           // vmovups       %ymm4,0x300(%rsp)
  .byte  197,213,254,201                     // vpaddd        %ymm1,%ymm5,%ymm1
  .byte  196,194,117,64,202                  // vpmulld       %ymm10,%ymm1,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,96,4,0,0          // vmovups       %ymm3,0x460(%rsp)
  .byte  196,193,117,250,213                 // vpsubd        %ymm13,%ymm1,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,101,146,36,144              // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm4
  .byte  197,252,17,164,36,64,4,0,0          // vmovups       %ymm4,0x440(%rsp)
  .byte  196,193,117,254,203                 // vpaddd        %ymm11,%ymm1,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,32,4,0,0          // vmovups       %ymm3,0x420(%rsp)
  .byte  197,252,88,132,36,32,1,0,0          // vaddps        0x120(%rsp),%ymm0,%ymm0
  .byte  197,254,91,248                      // vcvttps2dq    %ymm0,%ymm7
  .byte  197,197,254,68,36,160               // vpaddd        -0x60(%rsp),%ymm7,%ymm0
  .byte  197,189,254,200                     // vpaddd        %ymm0,%ymm8,%ymm1
  .byte  197,181,254,209                     // vpaddd        %ymm1,%ymm9,%ymm2
  .byte  196,194,109,64,210                  // vpmulld       %ymm10,%ymm2,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,101,146,36,144              // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm4
  .byte  197,252,17,100,36,160               // vmovups       %ymm4,-0x60(%rsp)
  .byte  196,193,109,250,221                 // vpsubd        %ymm13,%ymm2,%ymm3
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,65,12,87,246                    // vxorps        %ymm14,%ymm14,%ymm14
  .byte  196,98,93,146,52,152                // vgatherdps    %ymm4,(%rax,%ymm3,4),%ymm14
  .byte  197,124,17,180,36,0,4,0,0           // vmovups       %ymm14,0x400(%rsp)
  .byte  196,193,109,254,211                 // vpaddd        %ymm11,%ymm2,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,101,146,36,144              // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm4
  .byte  197,252,17,164,36,224,3,0,0         // vmovups       %ymm4,0x3e0(%rsp)
  .byte  197,213,254,201                     // vpaddd        %ymm1,%ymm5,%ymm1
  .byte  196,194,117,64,202                  // vpmulld       %ymm10,%ymm1,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,192,3,0,0         // vmovups       %ymm3,0x3c0(%rsp)
  .byte  196,193,117,250,213                 // vpsubd        %ymm13,%ymm1,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,101,146,36,144              // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm4
  .byte  197,252,17,164,36,160,3,0,0         // vmovups       %ymm4,0x3a0(%rsp)
  .byte  196,193,117,254,203                 // vpaddd        %ymm11,%ymm1,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,128,3,0,0         // vmovups       %ymm3,0x380(%rsp)
  .byte  197,205,254,192                     // vpaddd        %ymm0,%ymm6,%ymm0
  .byte  196,193,125,254,201                 // vpaddd        %ymm9,%ymm0,%ymm1
  .byte  196,194,117,64,202                  // vpmulld       %ymm10,%ymm1,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,32,3,0,0          // vmovups       %ymm3,0x320(%rsp)
  .byte  196,193,117,250,213                 // vpsubd        %ymm13,%ymm1,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,101,146,36,144              // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm4
  .byte  197,252,17,164,36,64,3,0,0          // vmovups       %ymm4,0x340(%rsp)
  .byte  196,193,117,254,203                 // vpaddd        %ymm11,%ymm1,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,128,2,0,0         // vmovups       %ymm3,0x280(%rsp)
  .byte  197,213,254,192                     // vpaddd        %ymm0,%ymm5,%ymm0
  .byte  196,194,125,64,194                  // vpmulld       %ymm10,%ymm0,%ymm0
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,226,117,146,20,128              // vgatherdps    %ymm1,(%rax,%ymm0,4),%ymm2
  .byte  197,252,17,148,36,224,2,0,0         // vmovups       %ymm2,0x2e0(%rsp)
  .byte  196,193,125,250,205                 // vpsubd        %ymm13,%ymm0,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,192,2,0,0         // vmovups       %ymm3,0x2c0(%rsp)
  .byte  196,193,125,254,195                 // vpaddd        %ymm11,%ymm0,%ymm0
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,226,117,146,20,128              // vgatherdps    %ymm1,(%rax,%ymm0,4),%ymm2
  .byte  197,252,17,148,36,160,2,0,0         // vmovups       %ymm2,0x2a0(%rsp)
  .byte  197,133,254,199                     // vpaddd        %ymm7,%ymm15,%ymm0
  .byte  196,193,125,254,200                 // vpaddd        %ymm8,%ymm0,%ymm1
  .byte  196,193,117,254,209                 // vpaddd        %ymm9,%ymm1,%ymm2
  .byte  196,194,109,64,210                  // vpmulld       %ymm10,%ymm2,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,101,146,36,144              // vgatherdps    %ymm3,(%rax,%ymm2,4),%ymm4
  .byte  197,252,17,100,36,128               // vmovups       %ymm4,-0x80(%rsp)
  .byte  196,193,109,250,221                 // vpsubd        %ymm13,%ymm2,%ymm3
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,226,61,146,36,152               // vgatherdps    %ymm8,(%rax,%ymm3,4),%ymm4
  .byte  197,252,17,164,36,96,2,0,0          // vmovups       %ymm4,0x260(%rsp)
  .byte  196,193,109,254,211                 // vpaddd        %ymm11,%ymm2,%ymm2
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,226,61,146,28,144               // vgatherdps    %ymm8,(%rax,%ymm2,4),%ymm3
  .byte  197,252,17,156,36,224,1,0,0         // vmovups       %ymm3,0x1e0(%rsp)
  .byte  197,213,254,201                     // vpaddd        %ymm1,%ymm5,%ymm1
  .byte  196,194,117,64,202                  // vpmulld       %ymm10,%ymm1,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,64,2,0,0          // vmovups       %ymm3,0x240(%rsp)
  .byte  196,193,117,250,213                 // vpsubd        %ymm13,%ymm1,%ymm2
  .byte  196,65,61,118,192                   // vpcmpeqd      %ymm8,%ymm8,%ymm8
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,226,61,146,28,144               // vgatherdps    %ymm8,(%rax,%ymm2,4),%ymm3
  .byte  197,252,17,156,36,32,2,0,0          // vmovups       %ymm3,0x220(%rsp)
  .byte  196,193,117,254,203                 // vpaddd        %ymm11,%ymm1,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,226,109,146,28,136              // vgatherdps    %ymm2,(%rax,%ymm1,4),%ymm3
  .byte  197,252,17,156,36,0,2,0,0           // vmovups       %ymm3,0x200(%rsp)
  .byte  197,205,254,216                     // vpaddd        %ymm0,%ymm6,%ymm3
  .byte  196,193,101,254,193                 // vpaddd        %ymm9,%ymm3,%ymm0
  .byte  196,194,125,64,194                  // vpmulld       %ymm10,%ymm0,%ymm0
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,226,109,146,12,128              // vgatherdps    %ymm2,(%rax,%ymm0,4),%ymm1
  .byte  197,252,17,140,36,192,1,0,0         // vmovups       %ymm1,0x1c0(%rsp)
  .byte  196,193,125,250,229                 // vpsubd        %ymm13,%ymm0,%ymm4
  .byte  197,245,118,201                     // vpcmpeqd      %ymm1,%ymm1,%ymm1
  .byte  196,65,29,239,228                   // vpxor         %ymm12,%ymm12,%ymm12
  .byte  196,98,117,146,36,160               // vgatherdps    %ymm1,(%rax,%ymm4,4),%ymm12
  .byte  196,193,125,254,203                 // vpaddd        %ymm11,%ymm0,%ymm1
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  196,226,93,146,4,136                // vgatherdps    %ymm4,(%rax,%ymm1,4),%ymm0
  .byte  197,252,17,132,36,160,1,0,0         // vmovups       %ymm0,0x1a0(%rsp)
  .byte  197,213,254,203                     // vpaddd        %ymm3,%ymm5,%ymm1
  .byte  196,194,117,64,202                  // vpmulld       %ymm10,%ymm1,%ymm1
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  196,226,101,146,4,136               // vgatherdps    %ymm3,(%rax,%ymm1,4),%ymm0
  .byte  197,252,17,132,36,128,1,0,0         // vmovups       %ymm0,0x180(%rsp)
  .byte  196,193,117,250,221                 // vpsubd        %ymm13,%ymm1,%ymm3
  .byte  196,65,45,118,210                   // vpcmpeqd      %ymm10,%ymm10,%ymm10
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  196,226,45,146,4,152                // vgatherdps    %ymm10,(%rax,%ymm3,4),%ymm0
  .byte  197,252,17,132,36,96,1,0,0          // vmovups       %ymm0,0x160(%rsp)
  .byte  196,193,117,254,203                 // vpaddd        %ymm11,%ymm1,%ymm1
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  196,226,21,146,4,136                // vgatherdps    %ymm13,(%rax,%ymm1,4),%ymm0
  .byte  197,252,17,132,36,64,1,0,0          // vmovups       %ymm0,0x140(%rsp)
  .byte  197,252,91,140,36,0,1,0,0           // vcvtdq2ps     0x100(%rsp),%ymm1
  .byte  197,252,16,132,36,160,0,0,0         // vmovups       0xa0(%rsp),%ymm0
  .byte  197,252,92,201                      // vsubps        %ymm1,%ymm0,%ymm1
  .byte  197,252,16,132,36,224,0,0,0         // vmovups       0xe0(%rsp),%ymm0
  .byte  197,252,16,148,36,128,0,0,0         // vmovups       0x80(%rsp),%ymm2
  .byte  197,108,92,248                      // vsubps        %ymm0,%ymm2,%ymm15
  .byte  196,98,117,168,248                  // vfmadd213ps   %ymm0,%ymm1,%ymm15
  .byte  197,252,16,132,36,192,0,0,0         // vmovups       0xc0(%rsp),%ymm0
  .byte  197,252,16,84,36,96                 // vmovups       0x60(%rsp),%ymm2
  .byte  197,108,92,240                      // vsubps        %ymm0,%ymm2,%ymm14
  .byte  196,98,117,168,240                  // vfmadd213ps   %ymm0,%ymm1,%ymm14
  .byte  197,252,16,108,36,32                // vmovups       0x20(%rsp),%ymm5
  .byte  197,252,16,68,36,64                 // vmovups       0x40(%rsp),%ymm0
  .byte  197,252,92,197                      // vsubps        %ymm5,%ymm0,%ymm0
  .byte  196,226,117,168,197                 // vfmadd213ps   %ymm5,%ymm1,%ymm0
  .byte  197,252,17,132,36,0,1,0,0           // vmovups       %ymm0,0x100(%rsp)
  .byte  197,252,16,68,36,192                // vmovups       -0x40(%rsp),%ymm0
  .byte  197,252,16,148,36,96,5,0,0          // vmovups       0x560(%rsp),%ymm2
  .byte  197,252,92,194                      // vsubps        %ymm2,%ymm0,%ymm0
  .byte  196,226,117,168,194                 // vfmadd213ps   %ymm2,%ymm1,%ymm0
  .byte  197,252,17,132,36,224,0,0,0         // vmovups       %ymm0,0xe0(%rsp)
  .byte  197,252,16,4,36                     // vmovups       (%rsp),%ymm0
  .byte  197,252,16,148,36,160,5,0,0         // vmovups       0x5a0(%rsp),%ymm2
  .byte  197,236,92,208                      // vsubps        %ymm0,%ymm2,%ymm2
  .byte  196,226,117,168,208                 // vfmadd213ps   %ymm0,%ymm1,%ymm2
  .byte  197,252,17,148,36,192,0,0,0         // vmovups       %ymm2,0xc0(%rsp)
  .byte  197,252,16,68,36,224                // vmovups       -0x20(%rsp),%ymm0
  .byte  197,252,16,148,36,128,5,0,0         // vmovups       0x580(%rsp),%ymm2
  .byte  197,236,92,208                      // vsubps        %ymm0,%ymm2,%ymm2
  .byte  196,226,117,168,208                 // vfmadd213ps   %ymm0,%ymm1,%ymm2
  .byte  197,252,17,148,36,160,0,0,0         // vmovups       %ymm2,0xa0(%rsp)
  .byte  197,252,16,132,36,32,5,0,0          // vmovups       0x520(%rsp),%ymm0
  .byte  197,252,16,148,36,96,3,0,0          // vmovups       0x360(%rsp),%ymm2
  .byte  197,124,92,210                      // vsubps        %ymm2,%ymm0,%ymm10
  .byte  196,98,117,168,210                  // vfmadd213ps   %ymm2,%ymm1,%ymm10
  .byte  197,252,16,132,36,64,5,0,0          // vmovups       0x540(%rsp),%ymm0
  .byte  197,252,16,148,36,0,5,0,0           // vmovups       0x500(%rsp),%ymm2
  .byte  197,108,92,216                      // vsubps        %ymm0,%ymm2,%ymm11
  .byte  196,98,117,168,216                  // vfmadd213ps   %ymm0,%ymm1,%ymm11
  .byte  197,252,16,132,36,224,4,0,0         // vmovups       0x4e0(%rsp),%ymm0
  .byte  197,252,16,148,36,192,4,0,0         // vmovups       0x4c0(%rsp),%ymm2
  .byte  197,124,92,202                      // vsubps        %ymm2,%ymm0,%ymm9
  .byte  196,98,117,168,202                  // vfmadd213ps   %ymm2,%ymm1,%ymm9
  .byte  197,252,16,132,36,160,4,0,0         // vmovups       0x4a0(%rsp),%ymm0
  .byte  197,252,16,148,36,96,4,0,0          // vmovups       0x460(%rsp),%ymm2
  .byte  197,236,92,208                      // vsubps        %ymm0,%ymm2,%ymm2
  .byte  196,226,117,168,208                 // vfmadd213ps   %ymm0,%ymm1,%ymm2
  .byte  197,252,17,148,36,128,0,0,0         // vmovups       %ymm2,0x80(%rsp)
  .byte  197,252,16,132,36,128,4,0,0         // vmovups       0x480(%rsp),%ymm0
  .byte  197,252,16,148,36,64,4,0,0          // vmovups       0x440(%rsp),%ymm2
  .byte  197,236,92,208                      // vsubps        %ymm0,%ymm2,%ymm2
  .byte  196,226,117,168,208                 // vfmadd213ps   %ymm0,%ymm1,%ymm2
  .byte  197,252,17,84,36,96                 // vmovups       %ymm2,0x60(%rsp)
  .byte  197,252,16,132,36,32,4,0,0          // vmovups       0x420(%rsp),%ymm0
  .byte  197,252,16,148,36,0,3,0,0           // vmovups       0x300(%rsp),%ymm2
  .byte  197,252,92,194                      // vsubps        %ymm2,%ymm0,%ymm0
  .byte  196,226,117,168,194                 // vfmadd213ps   %ymm2,%ymm1,%ymm0
  .byte  197,252,17,68,36,64                 // vmovups       %ymm0,0x40(%rsp)
  .byte  197,252,16,68,36,160                // vmovups       -0x60(%rsp),%ymm0
  .byte  197,252,16,148,36,192,3,0,0         // vmovups       0x3c0(%rsp),%ymm2
  .byte  197,236,92,248                      // vsubps        %ymm0,%ymm2,%ymm7
  .byte  196,226,117,168,248                 // vfmadd213ps   %ymm0,%ymm1,%ymm7
  .byte  197,252,16,132,36,0,4,0,0           // vmovups       0x400(%rsp),%ymm0
  .byte  197,252,16,148,36,160,3,0,0         // vmovups       0x3a0(%rsp),%ymm2
  .byte  197,108,92,192                      // vsubps        %ymm0,%ymm2,%ymm8
  .byte  196,98,117,168,192                  // vfmadd213ps   %ymm0,%ymm1,%ymm8
  .byte  197,252,16,132,36,224,3,0,0         // vmovups       0x3e0(%rsp),%ymm0
  .byte  197,252,16,148,36,128,3,0,0         // vmovups       0x380(%rsp),%ymm2
  .byte  197,236,92,240                      // vsubps        %ymm0,%ymm2,%ymm6
  .byte  196,226,117,168,240                 // vfmadd213ps   %ymm0,%ymm1,%ymm6
  .byte  197,252,16,132,36,32,3,0,0          // vmovups       0x320(%rsp),%ymm0
  .byte  197,252,16,148,36,224,2,0,0         // vmovups       0x2e0(%rsp),%ymm2
  .byte  197,236,92,208                      // vsubps        %ymm0,%ymm2,%ymm2
  .byte  196,226,117,168,208                 // vfmadd213ps   %ymm0,%ymm1,%ymm2
  .byte  197,252,17,84,36,32                 // vmovups       %ymm2,0x20(%rsp)
  .byte  197,252,16,132,36,64,3,0,0          // vmovups       0x340(%rsp),%ymm0
  .byte  197,252,16,148,36,192,2,0,0         // vmovups       0x2c0(%rsp),%ymm2
  .byte  197,236,92,208                      // vsubps        %ymm0,%ymm2,%ymm2
  .byte  196,226,117,168,208                 // vfmadd213ps   %ymm0,%ymm1,%ymm2
  .byte  197,252,17,20,36                    // vmovups       %ymm2,(%rsp)
  .byte  197,252,16,132,36,160,2,0,0         // vmovups       0x2a0(%rsp),%ymm0
  .byte  197,252,16,148,36,128,2,0,0         // vmovups       0x280(%rsp),%ymm2
  .byte  197,252,92,194                      // vsubps        %ymm2,%ymm0,%ymm0
  .byte  196,226,117,168,194                 // vfmadd213ps   %ymm2,%ymm1,%ymm0
  .byte  197,252,17,68,36,224                // vmovups       %ymm0,-0x20(%rsp)
  .byte  197,252,16,68,36,128                // vmovups       -0x80(%rsp),%ymm0
  .byte  197,252,16,148,36,64,2,0,0          // vmovups       0x240(%rsp),%ymm2
  .byte  197,236,92,208                      // vsubps        %ymm0,%ymm2,%ymm2
  .byte  196,226,117,168,208                 // vfmadd213ps   %ymm0,%ymm1,%ymm2
  .byte  197,252,16,132,36,96,2,0,0          // vmovups       0x260(%rsp),%ymm0
  .byte  197,252,16,156,36,32,2,0,0          // vmovups       0x220(%rsp),%ymm3
  .byte  197,228,92,216                      // vsubps        %ymm0,%ymm3,%ymm3
  .byte  196,226,117,168,216                 // vfmadd213ps   %ymm0,%ymm1,%ymm3
  .byte  197,252,16,132,36,0,2,0,0           // vmovups       0x200(%rsp),%ymm0
  .byte  197,252,16,172,36,224,1,0,0         // vmovups       0x1e0(%rsp),%ymm5
  .byte  197,252,92,229                      // vsubps        %ymm5,%ymm0,%ymm4
  .byte  196,226,117,168,229                 // vfmadd213ps   %ymm5,%ymm1,%ymm4
  .byte  197,252,16,132,36,192,1,0,0         // vmovups       0x1c0(%rsp),%ymm0
  .byte  197,252,16,172,36,128,1,0,0         // vmovups       0x180(%rsp),%ymm5
  .byte  197,84,92,232                       // vsubps        %ymm0,%ymm5,%ymm13
  .byte  196,98,117,168,232                  // vfmadd213ps   %ymm0,%ymm1,%ymm13
  .byte  197,252,16,132,36,96,1,0,0          // vmovups       0x160(%rsp),%ymm0
  .byte  196,193,124,92,196                  // vsubps        %ymm12,%ymm0,%ymm0
  .byte  196,194,117,168,196                 // vfmadd213ps   %ymm12,%ymm1,%ymm0
  .byte  197,252,17,68,36,192                // vmovups       %ymm0,-0x40(%rsp)
  .byte  197,252,16,132,36,160,1,0,0         // vmovups       0x1a0(%rsp),%ymm0
  .byte  197,252,16,172,36,64,1,0,0          // vmovups       0x140(%rsp),%ymm5
  .byte  197,84,92,224                       // vsubps        %ymm0,%ymm5,%ymm12
  .byte  196,98,117,168,224                  // vfmadd213ps   %ymm0,%ymm1,%ymm12
  .byte  197,252,91,140,36,32,6,0,0          // vcvtdq2ps     0x620(%rsp),%ymm1
  .byte  197,252,16,132,36,0,6,0,0           // vmovups       0x600(%rsp),%ymm0
  .byte  197,252,92,201                      // vsubps        %ymm1,%ymm0,%ymm1
  .byte  197,252,16,132,36,224,0,0,0         // vmovups       0xe0(%rsp),%ymm0
  .byte  196,193,124,92,199                  // vsubps        %ymm15,%ymm0,%ymm0
  .byte  196,194,117,168,199                 // vfmadd213ps   %ymm15,%ymm1,%ymm0
  .byte  197,252,16,172,36,192,0,0,0         // vmovups       0xc0(%rsp),%ymm5
  .byte  196,65,84,92,254                    // vsubps        %ymm14,%ymm5,%ymm15
  .byte  196,66,117,168,254                  // vfmadd213ps   %ymm14,%ymm1,%ymm15
  .byte  197,252,16,172,36,0,1,0,0           // vmovups       0x100(%rsp),%ymm5
  .byte  197,124,16,180,36,160,0,0,0         // vmovups       0xa0(%rsp),%ymm14
  .byte  197,12,92,245                       // vsubps        %ymm5,%ymm14,%ymm14
  .byte  196,98,117,168,245                  // vfmadd213ps   %ymm5,%ymm1,%ymm14
  .byte  197,252,16,172,36,128,0,0,0         // vmovups       0x80(%rsp),%ymm5
  .byte  196,193,84,92,234                   // vsubps        %ymm10,%ymm5,%ymm5
  .byte  196,194,117,168,234                 // vfmadd213ps   %ymm10,%ymm1,%ymm5
  .byte  197,124,16,84,36,96                 // vmovups       0x60(%rsp),%ymm10
  .byte  196,65,44,92,211                    // vsubps        %ymm11,%ymm10,%ymm10
  .byte  196,66,117,168,211                  // vfmadd213ps   %ymm11,%ymm1,%ymm10
  .byte  197,124,16,92,36,64                 // vmovups       0x40(%rsp),%ymm11
  .byte  196,65,36,92,217                    // vsubps        %ymm9,%ymm11,%ymm11
  .byte  196,66,117,168,217                  // vfmadd213ps   %ymm9,%ymm1,%ymm11
  .byte  197,124,16,76,36,32                 // vmovups       0x20(%rsp),%ymm9
  .byte  197,52,92,207                       // vsubps        %ymm7,%ymm9,%ymm9
  .byte  196,98,117,168,207                  // vfmadd213ps   %ymm7,%ymm1,%ymm9
  .byte  197,252,16,60,36                    // vmovups       (%rsp),%ymm7
  .byte  196,193,68,92,248                   // vsubps        %ymm8,%ymm7,%ymm7
  .byte  196,194,117,168,248                 // vfmadd213ps   %ymm8,%ymm1,%ymm7
  .byte  197,124,16,68,36,224                // vmovups       -0x20(%rsp),%ymm8
  .byte  197,60,92,198                       // vsubps        %ymm6,%ymm8,%ymm8
  .byte  196,98,117,168,198                  // vfmadd213ps   %ymm6,%ymm1,%ymm8
  .byte  197,148,92,242                      // vsubps        %ymm2,%ymm13,%ymm6
  .byte  196,226,117,168,242                 // vfmadd213ps   %ymm2,%ymm1,%ymm6
  .byte  197,252,16,84,36,192                // vmovups       -0x40(%rsp),%ymm2
  .byte  197,236,92,211                      // vsubps        %ymm3,%ymm2,%ymm2
  .byte  196,226,117,168,211                 // vfmadd213ps   %ymm3,%ymm1,%ymm2
  .byte  197,156,92,220                      // vsubps        %ymm4,%ymm12,%ymm3
  .byte  196,226,117,168,220                 // vfmadd213ps   %ymm4,%ymm1,%ymm3
  .byte  197,252,91,140,36,64,6,0,0          // vcvtdq2ps     0x640(%rsp),%ymm1
  .byte  197,252,16,164,36,224,5,0,0         // vmovups       0x5e0(%rsp),%ymm4
  .byte  197,220,92,201                      // vsubps        %ymm1,%ymm4,%ymm1
  .byte  197,212,92,224                      // vsubps        %ymm0,%ymm5,%ymm4
  .byte  196,226,117,168,224                 // vfmadd213ps   %ymm0,%ymm1,%ymm4
  .byte  196,193,44,92,239                   // vsubps        %ymm15,%ymm10,%ymm5
  .byte  196,194,117,168,239                 // vfmadd213ps   %ymm15,%ymm1,%ymm5
  .byte  196,65,36,92,214                    // vsubps        %ymm14,%ymm11,%ymm10
  .byte  196,66,117,168,214                  // vfmadd213ps   %ymm14,%ymm1,%ymm10
  .byte  196,193,76,92,193                   // vsubps        %ymm9,%ymm6,%ymm0
  .byte  196,194,117,168,193                 // vfmadd213ps   %ymm9,%ymm1,%ymm0
  .byte  197,236,92,215                      // vsubps        %ymm7,%ymm2,%ymm2
  .byte  196,226,117,168,215                 // vfmadd213ps   %ymm7,%ymm1,%ymm2
  .byte  196,193,100,92,216                  // vsubps        %ymm8,%ymm3,%ymm3
  .byte  196,194,117,168,216                 // vfmadd213ps   %ymm8,%ymm1,%ymm3
  .byte  197,252,91,140,36,192,5,0,0         // vcvtdq2ps     0x5c0(%rsp),%ymm1
  .byte  197,252,16,180,36,32,1,0,0          // vmovups       0x120(%rsp),%ymm6
  .byte  197,204,92,241                      // vsubps        %ymm1,%ymm6,%ymm6
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  196,226,77,168,196                  // vfmadd213ps   %ymm4,%ymm6,%ymm0
  .byte  197,236,92,205                      // vsubps        %ymm5,%ymm2,%ymm1
  .byte  196,226,77,168,205                  // vfmadd213ps   %ymm5,%ymm6,%ymm1
  .byte  196,193,100,92,210                  // vsubps        %ymm10,%ymm3,%ymm2
  .byte  196,194,77,168,210                  // vfmadd213ps   %ymm10,%ymm6,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,95,167,2,0        // vbroadcastss  0x2a75f(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,16,164,36,96,6,0,0          // vmovups       0x660(%rsp),%ymm4
  .byte  197,252,16,172,36,128,6,0,0         // vmovups       0x680(%rsp),%ymm5
  .byte  197,252,16,180,36,160,6,0,0         // vmovups       0x6a0(%rsp),%ymm6
  .byte  197,252,16,188,36,192,6,0,0         // vmovups       0x6c0(%rsp),%ymm7
  .byte  72,129,196,248,6,0,0                // add           $0x6f8,%rsp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gauss_a_to_rgba_hsw
.globl _sk_gauss_a_to_rgba_hsw
FUNCTION(_sk_gauss_a_to_rgba_hsw)
_sk_gauss_a_to_rgba_hsw:
  .byte  196,226,125,24,5,153,168,2,0        // vbroadcastss  0x2a899(%rip),%ymm0        # 3a388 <_sk_srcover_bgra_8888_sse2_lowp+0x420>
  .byte  196,226,125,24,13,140,168,2,0       // vbroadcastss  0x2a88c(%rip),%ymm1        # 3a384 <_sk_srcover_bgra_8888_sse2_lowp+0x41c>
  .byte  196,226,101,168,200                 // vfmadd213ps   %ymm0,%ymm3,%ymm1
  .byte  196,226,125,24,5,134,168,2,0        // vbroadcastss  0x2a886(%rip),%ymm0        # 3a38c <_sk_srcover_bgra_8888_sse2_lowp+0x424>
  .byte  196,226,101,184,193                 // vfmadd231ps   %ymm1,%ymm3,%ymm0
  .byte  196,226,125,24,13,124,168,2,0       // vbroadcastss  0x2a87c(%rip),%ymm1        # 3a390 <_sk_srcover_bgra_8888_sse2_lowp+0x428>
  .byte  196,226,101,184,200                 // vfmadd231ps   %ymm0,%ymm3,%ymm1
  .byte  196,226,125,24,5,114,168,2,0        // vbroadcastss  0x2a872(%rip),%ymm0        # 3a394 <_sk_srcover_bgra_8888_sse2_lowp+0x42c>
  .byte  196,226,101,184,193                 // vfmadd231ps   %ymm1,%ymm3,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  197,252,40,216                      // vmovaps       %ymm0,%ymm3
  .byte  255,224                             // jmpq          *%rax
  .byte  144                                 // nop

HIDDEN _sk_start_pipeline_avx
.globl _sk_start_pipeline_avx
FUNCTION(_sk_start_pipeline_avx)
_sk_start_pipeline_avx:
  .byte  85                                  // push          %rbp
  .byte  72,137,229                          // mov           %rsp,%rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  73,137,215                          // mov           %rdx,%r15
  .byte  72,137,243                          // mov           %rsi,%rbx
  .byte  72,137,125,208                      // mov           %rdi,-0x30(%rbp)
  .byte  76,137,198                          // mov           %r8,%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  73,137,197                          // mov           %rax,%r13
  .byte  73,137,246                          // mov           %rsi,%r14
  .byte  72,137,77,192                       // mov           %rcx,-0x40(%rbp)
  .byte  72,57,203                           // cmp           %rcx,%rbx
  .byte  15,131,151,0,0,0                    // jae           fc02 <_sk_start_pipeline_avx+0xca>
  .byte  72,139,69,208                       // mov           -0x30(%rbp),%rax
  .byte  72,141,64,8                         // lea           0x8(%rax),%rax
  .byte  72,137,69,200                       // mov           %rax,-0x38(%rbp)
  .byte  72,139,85,208                       // mov           -0x30(%rbp),%rdx
  .byte  76,57,125,200                       // cmp           %r15,-0x38(%rbp)
  .byte  119,67                              // ja            fbc4 <_sk_start_pipeline_avx+0x8c>
  .byte  76,139,101,208                      // mov           -0x30(%rbp),%r12
  .byte  49,255                              // xor           %edi,%edi
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  76,137,226                          // mov           %r12,%rdx
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  73,141,84,36,8                      // lea           0x8(%r12),%rdx
  .byte  73,131,196,16                       // add           $0x10,%r12
  .byte  77,57,252                           // cmp           %r15,%r12
  .byte  73,137,212                          // mov           %rdx,%r12
  .byte  118,193                             // jbe           fb85 <_sk_start_pipeline_avx+0x4d>
  .byte  76,137,255                          // mov           %r15,%rdi
  .byte  72,41,215                           // sub           %rdx,%rdi
  .byte  116,41                              // je            fbf5 <_sk_start_pipeline_avx+0xbd>
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  72,255,195                          // inc           %rbx
  .byte  72,59,93,192                        // cmp           -0x40(%rbp),%rbx
  .byte  15,133,117,255,255,255              // jne           fb77 <_sk_start_pipeline_avx+0x3f>
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  197,248,119                         // vzeroupper
  .byte  195                                 // retq

HIDDEN _sk_just_return_avx
.globl _sk_just_return_avx
FUNCTION(_sk_just_return_avx)
_sk_just_return_avx:
  .byte  195                                 // retq

HIDDEN _sk_seed_shader_avx
.globl _sk_seed_shader_avx
FUNCTION(_sk_seed_shader_avx)
_sk_seed_shader_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,249,110,194                     // vmovd         %edx,%xmm0
  .byte  197,249,112,192,0                   // vpshufd       $0x0,%xmm0,%xmm0
  .byte  196,227,125,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  197,249,110,201                     // vmovd         %ecx,%xmm1
  .byte  197,249,112,201,0                   // vpshufd       $0x0,%xmm1,%xmm1
  .byte  196,227,117,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,226,125,24,21,202,165,2,0       // vbroadcastss  0x2a5ca(%rip),%ymm2        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,244,88,202                      // vaddps        %ymm2,%ymm1,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,21,191,165,2,0       // vbroadcastss  0x2a5bf(%rip),%ymm2        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dither_avx
.globl _sk_dither_avx
FUNCTION(_sk_dither_avx)
_sk_dither_avx:
  .byte  197,121,110,194                     // vmovd         %edx,%xmm8
  .byte  196,65,121,112,192,0                // vpshufd       $0x0,%xmm8,%xmm8
  .byte  197,57,254,13,159,174,2,0           // vpaddd        0x2ae9f(%rip),%xmm8,%xmm9        # 3ab20 <_sk_srcover_bgra_8888_sse2_lowp+0xbb8>
  .byte  197,57,254,5,167,174,2,0            // vpaddd        0x2aea7(%rip),%xmm8,%xmm8        # 3ab30 <_sk_srcover_bgra_8888_sse2_lowp+0xbc8>
  .byte  196,67,53,24,208,1                  // vinsertf128   $0x1,%xmm8,%ymm9,%ymm10
  .byte  197,121,110,217                     // vmovd         %ecx,%xmm11
  .byte  196,65,121,112,219,0                // vpshufd       $0x0,%xmm11,%xmm11
  .byte  196,67,37,24,219,1                  // vinsertf128   $0x1,%xmm11,%ymm11,%ymm11
  .byte  196,65,36,87,218                    // vxorps        %ymm10,%ymm11,%ymm11
  .byte  196,98,125,24,21,111,165,2,0        // vbroadcastss  0x2a56f(%rip),%ymm10        # 3a21c <_sk_srcover_bgra_8888_sse2_lowp+0x2b4>
  .byte  196,65,36,84,210                    // vandps        %ymm10,%ymm11,%ymm10
  .byte  196,193,25,114,242,5                // vpslld        $0x5,%xmm10,%xmm12
  .byte  196,67,125,25,210,1                 // vextractf128  $0x1,%ymm10,%xmm10
  .byte  196,193,41,114,242,5                // vpslld        $0x5,%xmm10,%xmm10
  .byte  196,67,29,24,210,1                  // vinsertf128   $0x1,%xmm10,%ymm12,%ymm10
  .byte  197,123,18,37,158,182,2,0           // vmovddup      0x2b69e(%rip),%xmm12        # 3b370 <_sk_srcover_bgra_8888_sse2_lowp+0x1408>
  .byte  196,65,49,219,236                   // vpand         %xmm12,%xmm9,%xmm13
  .byte  196,193,17,114,245,4                // vpslld        $0x4,%xmm13,%xmm13
  .byte  196,65,57,219,228                   // vpand         %xmm12,%xmm8,%xmm12
  .byte  196,193,25,114,244,4                // vpslld        $0x4,%xmm12,%xmm12
  .byte  196,67,21,24,228,1                  // vinsertf128   $0x1,%xmm12,%ymm13,%ymm12
  .byte  196,98,125,24,45,45,165,2,0         // vbroadcastss  0x2a52d(%rip),%ymm13        # 3a224 <_sk_srcover_bgra_8888_sse2_lowp+0x2bc>
  .byte  196,65,36,84,237                    // vandps        %ymm13,%ymm11,%ymm13
  .byte  196,193,9,114,245,2                 // vpslld        $0x2,%xmm13,%xmm14
  .byte  196,67,125,25,237,1                 // vextractf128  $0x1,%ymm13,%xmm13
  .byte  196,193,17,114,245,2                // vpslld        $0x2,%xmm13,%xmm13
  .byte  196,67,13,24,237,1                  // vinsertf128   $0x1,%xmm13,%ymm14,%ymm13
  .byte  197,123,18,53,92,182,2,0            // vmovddup      0x2b65c(%rip),%xmm14        # 3b378 <_sk_srcover_bgra_8888_sse2_lowp+0x1410>
  .byte  196,65,49,219,254                   // vpand         %xmm14,%xmm9,%xmm15
  .byte  196,65,1,254,255                    // vpaddd        %xmm15,%xmm15,%xmm15
  .byte  196,65,57,219,246                   // vpand         %xmm14,%xmm8,%xmm14
  .byte  196,65,9,254,246                    // vpaddd        %xmm14,%xmm14,%xmm14
  .byte  196,67,5,24,246,1                   // vinsertf128   $0x1,%xmm14,%ymm15,%ymm14
  .byte  196,65,12,86,228                    // vorps         %ymm12,%ymm14,%ymm12
  .byte  196,98,125,24,53,220,164,2,0        // vbroadcastss  0x2a4dc(%rip),%ymm14        # 3a220 <_sk_srcover_bgra_8888_sse2_lowp+0x2b8>
  .byte  196,65,36,84,222                    // vandps        %ymm14,%ymm11,%ymm11
  .byte  196,193,9,114,211,1                 // vpsrld        $0x1,%xmm11,%xmm14
  .byte  196,67,125,25,219,1                 // vextractf128  $0x1,%ymm11,%xmm11
  .byte  196,193,33,114,211,1                // vpsrld        $0x1,%xmm11,%xmm11
  .byte  196,67,13,24,219,1                  // vinsertf128   $0x1,%xmm11,%ymm14,%ymm11
  .byte  196,65,20,86,219                    // vorps         %ymm11,%ymm13,%ymm11
  .byte  197,123,18,45,18,182,2,0            // vmovddup      0x2b612(%rip),%xmm13        # 3b380 <_sk_srcover_bgra_8888_sse2_lowp+0x1418>
  .byte  196,65,49,219,205                   // vpand         %xmm13,%xmm9,%xmm9
  .byte  196,65,57,219,197                   // vpand         %xmm13,%xmm8,%xmm8
  .byte  196,193,49,114,209,2                // vpsrld        $0x2,%xmm9,%xmm9
  .byte  196,193,57,114,208,2                // vpsrld        $0x2,%xmm8,%xmm8
  .byte  196,67,53,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm9,%ymm8
  .byte  196,65,28,86,192                    // vorps         %ymm8,%ymm12,%ymm8
  .byte  196,65,60,86,194                    // vorps         %ymm10,%ymm8,%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,65,60,86,195                    // vorps         %ymm11,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,98,125,24,13,127,164,2,0        // vbroadcastss  0x2a47f(%rip),%ymm9        # 3a228 <_sk_srcover_bgra_8888_sse2_lowp+0x2c0>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  196,98,125,24,13,117,164,2,0        // vbroadcastss  0x2a475(%rip),%ymm9        # 3a22c <_sk_srcover_bgra_8888_sse2_lowp+0x2c4>
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  197,188,88,192                      // vaddps        %ymm0,%ymm8,%ymm0
  .byte  197,188,88,201                      // vaddps        %ymm1,%ymm8,%ymm1
  .byte  197,188,88,210                      // vaddps        %ymm2,%ymm8,%ymm2
  .byte  197,252,93,195                      // vminps        %ymm3,%ymm0,%ymm0
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  197,244,93,203                      // vminps        %ymm3,%ymm1,%ymm1
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  197,236,93,211                      // vminps        %ymm3,%ymm2,%ymm2
  .byte  197,188,95,210                      // vmaxps        %ymm2,%ymm8,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_uniform_color_avx
.globl _sk_uniform_color_avx
FUNCTION(_sk_uniform_color_avx)
_sk_uniform_color_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,0                    // vbroadcastss  (%rax),%ymm0
  .byte  196,226,125,24,72,4                 // vbroadcastss  0x4(%rax),%ymm1
  .byte  196,226,125,24,80,8                 // vbroadcastss  0x8(%rax),%ymm2
  .byte  196,226,125,24,88,12                // vbroadcastss  0xc(%rax),%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_black_color_avx
.globl _sk_black_color_avx
FUNCTION(_sk_black_color_avx)
_sk_black_color_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,253,163,2,0       // vbroadcastss  0x2a3fd(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_white_color_avx
.globl _sk_white_color_avx
FUNCTION(_sk_white_color_avx)
_sk_white_color_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,5,228,163,2,0        // vbroadcastss  0x2a3e4(%rip),%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  197,252,40,216                      // vmovaps       %ymm0,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_rgba_avx
.globl _sk_load_rgba_avx
FUNCTION(_sk_load_rgba_avx)
_sk_load_rgba_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,0                        // vmovups       (%rax),%ymm0
  .byte  197,252,16,72,32                    // vmovups       0x20(%rax),%ymm1
  .byte  197,252,16,80,64                    // vmovups       0x40(%rax),%ymm2
  .byte  197,252,16,88,96                    // vmovups       0x60(%rax),%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_rgba_avx
.globl _sk_store_rgba_avx
FUNCTION(_sk_store_rgba_avx)
_sk_store_rgba_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,17,0                        // vmovups       %ymm0,(%rax)
  .byte  197,252,17,72,32                    // vmovups       %ymm1,0x20(%rax)
  .byte  197,252,17,80,64                    // vmovups       %ymm2,0x40(%rax)
  .byte  197,252,17,88,96                    // vmovups       %ymm3,0x60(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clear_avx
.globl _sk_clear_avx
FUNCTION(_sk_clear_avx)
_sk_clear_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcatop_avx
.globl _sk_srcatop_avx
FUNCTION(_sk_srcatop_avx)
_sk_srcatop_avx:
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  196,98,125,24,5,131,163,2,0         // vbroadcastss  0x2a383(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,60,89,204                       // vmulps        %ymm4,%ymm8,%ymm9
  .byte  197,180,88,192                      // vaddps        %ymm0,%ymm9,%ymm0
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  197,60,89,205                       // vmulps        %ymm5,%ymm8,%ymm9
  .byte  197,180,88,201                      // vaddps        %ymm1,%ymm9,%ymm1
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  197,60,89,206                       // vmulps        %ymm6,%ymm8,%ymm9
  .byte  197,180,88,210                      // vaddps        %ymm2,%ymm9,%ymm2
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  196,193,100,88,216                  // vaddps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstatop_avx
.globl _sk_dstatop_avx
FUNCTION(_sk_dstatop_avx)
_sk_dstatop_avx:
  .byte  197,100,89,196                      // vmulps        %ymm4,%ymm3,%ymm8
  .byte  196,98,125,24,13,65,163,2,0         // vbroadcastss  0x2a341(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,52,92,207                       // vsubps        %ymm7,%ymm9,%ymm9
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  197,188,88,192                      // vaddps        %ymm0,%ymm8,%ymm0
  .byte  197,100,89,197                      // vmulps        %ymm5,%ymm3,%ymm8
  .byte  197,180,89,201                      // vmulps        %ymm1,%ymm9,%ymm1
  .byte  197,188,88,201                      // vaddps        %ymm1,%ymm8,%ymm1
  .byte  197,100,89,198                      // vmulps        %ymm6,%ymm3,%ymm8
  .byte  197,180,89,210                      // vmulps        %ymm2,%ymm9,%ymm2
  .byte  197,188,88,210                      // vaddps        %ymm2,%ymm8,%ymm2
  .byte  197,100,89,199                      // vmulps        %ymm7,%ymm3,%ymm8
  .byte  197,180,89,219                      // vmulps        %ymm3,%ymm9,%ymm3
  .byte  197,188,88,219                      // vaddps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcin_avx
.globl _sk_srcin_avx
FUNCTION(_sk_srcin_avx)
_sk_srcin_avx:
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstin_avx
.globl _sk_dstin_avx
FUNCTION(_sk_dstin_avx)
_sk_dstin_avx:
  .byte  197,228,89,196                      // vmulps        %ymm4,%ymm3,%ymm0
  .byte  197,228,89,205                      // vmulps        %ymm5,%ymm3,%ymm1
  .byte  197,228,89,214                      // vmulps        %ymm6,%ymm3,%ymm2
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcout_avx
.globl _sk_srcout_avx
FUNCTION(_sk_srcout_avx)
_sk_srcout_avx:
  .byte  196,98,125,24,5,220,162,2,0         // vbroadcastss  0x2a2dc(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,199                       // vsubps        %ymm7,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstout_avx
.globl _sk_dstout_avx
FUNCTION(_sk_dstout_avx)
_sk_dstout_avx:
  .byte  196,226,125,24,5,187,162,2,0        // vbroadcastss  0x2a2bb(%rip),%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,92,219                      // vsubps        %ymm3,%ymm0,%ymm3
  .byte  197,228,89,196                      // vmulps        %ymm4,%ymm3,%ymm0
  .byte  197,228,89,205                      // vmulps        %ymm5,%ymm3,%ymm1
  .byte  197,228,89,214                      // vmulps        %ymm6,%ymm3,%ymm2
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_avx
.globl _sk_srcover_avx
FUNCTION(_sk_srcover_avx)
_sk_srcover_avx:
  .byte  196,98,125,24,5,154,162,2,0         // vbroadcastss  0x2a29a(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,60,89,204                       // vmulps        %ymm4,%ymm8,%ymm9
  .byte  197,180,88,192                      // vaddps        %ymm0,%ymm9,%ymm0
  .byte  197,60,89,205                       // vmulps        %ymm5,%ymm8,%ymm9
  .byte  197,180,88,201                      // vaddps        %ymm1,%ymm9,%ymm1
  .byte  197,60,89,206                       // vmulps        %ymm6,%ymm8,%ymm9
  .byte  197,180,88,210                      // vaddps        %ymm2,%ymm9,%ymm2
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  197,188,88,219                      // vaddps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstover_avx
.globl _sk_dstover_avx
FUNCTION(_sk_dstover_avx)
_sk_dstover_avx:
  .byte  196,98,125,24,5,105,162,2,0         // vbroadcastss  0x2a269(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,199                       // vsubps        %ymm7,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,252,88,196                      // vaddps        %ymm4,%ymm0,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,244,88,205                      // vaddps        %ymm5,%ymm1,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,236,88,214                      // vaddps        %ymm6,%ymm2,%ymm2
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_modulate_avx
.globl _sk_modulate_avx
FUNCTION(_sk_modulate_avx)
_sk_modulate_avx:
  .byte  197,252,89,196                      // vmulps        %ymm4,%ymm0,%ymm0
  .byte  197,244,89,205                      // vmulps        %ymm5,%ymm1,%ymm1
  .byte  197,236,89,214                      // vmulps        %ymm6,%ymm2,%ymm2
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_multiply_avx
.globl _sk_multiply_avx
FUNCTION(_sk_multiply_avx)
_sk_multiply_avx:
  .byte  196,98,125,24,5,36,162,2,0          // vbroadcastss  0x2a224(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,207                       // vsubps        %ymm7,%ymm8,%ymm9
  .byte  197,52,89,208                       // vmulps        %ymm0,%ymm9,%ymm10
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,60,89,220                       // vmulps        %ymm4,%ymm8,%ymm11
  .byte  196,65,36,88,210                    // vaddps        %ymm10,%ymm11,%ymm10
  .byte  197,252,89,196                      // vmulps        %ymm4,%ymm0,%ymm0
  .byte  196,193,124,88,194                  // vaddps        %ymm10,%ymm0,%ymm0
  .byte  197,52,89,209                       // vmulps        %ymm1,%ymm9,%ymm10
  .byte  197,60,89,221                       // vmulps        %ymm5,%ymm8,%ymm11
  .byte  196,65,36,88,210                    // vaddps        %ymm10,%ymm11,%ymm10
  .byte  197,244,89,205                      // vmulps        %ymm5,%ymm1,%ymm1
  .byte  196,193,116,88,202                  // vaddps        %ymm10,%ymm1,%ymm1
  .byte  197,52,89,210                       // vmulps        %ymm2,%ymm9,%ymm10
  .byte  197,60,89,222                       // vmulps        %ymm6,%ymm8,%ymm11
  .byte  196,65,36,88,210                    // vaddps        %ymm10,%ymm11,%ymm10
  .byte  197,236,89,214                      // vmulps        %ymm6,%ymm2,%ymm2
  .byte  196,193,108,88,210                  // vaddps        %ymm10,%ymm2,%ymm2
  .byte  197,52,89,203                       // vmulps        %ymm3,%ymm9,%ymm9
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,88,216                  // vaddps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_plus__avx
.globl _sk_plus__avx
FUNCTION(_sk_plus__avx)
_sk_plus__avx:
  .byte  197,252,88,196                      // vaddps        %ymm4,%ymm0,%ymm0
  .byte  196,98,125,24,5,179,161,2,0         // vbroadcastss  0x2a1b3(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  197,244,88,205                      // vaddps        %ymm5,%ymm1,%ymm1
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  197,236,88,214                      // vaddps        %ymm6,%ymm2,%ymm2
  .byte  196,193,108,93,208                  // vminps        %ymm8,%ymm2,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_screen_avx
.globl _sk_screen_avx
FUNCTION(_sk_screen_avx)
_sk_screen_avx:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  197,252,89,196                      // vmulps        %ymm4,%ymm0,%ymm0
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  197,244,89,205                      // vmulps        %ymm5,%ymm1,%ymm1
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  197,236,89,214                      // vmulps        %ymm6,%ymm2,%ymm2
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  197,100,88,199                      // vaddps        %ymm7,%ymm3,%ymm8
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  197,188,92,219                      // vsubps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xor__avx
.globl _sk_xor__avx
FUNCTION(_sk_xor__avx)
_sk_xor__avx:
  .byte  196,98,125,24,5,82,161,2,0          // vbroadcastss  0x2a152(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,207                       // vsubps        %ymm7,%ymm8,%ymm9
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,60,89,212                       // vmulps        %ymm4,%ymm8,%ymm10
  .byte  197,172,88,192                      // vaddps        %ymm0,%ymm10,%ymm0
  .byte  197,180,89,201                      // vmulps        %ymm1,%ymm9,%ymm1
  .byte  197,60,89,213                       // vmulps        %ymm5,%ymm8,%ymm10
  .byte  197,172,88,201                      // vaddps        %ymm1,%ymm10,%ymm1
  .byte  197,180,89,210                      // vmulps        %ymm2,%ymm9,%ymm2
  .byte  197,60,89,214                       // vmulps        %ymm6,%ymm8,%ymm10
  .byte  197,172,88,210                      // vaddps        %ymm2,%ymm10,%ymm2
  .byte  197,180,89,219                      // vmulps        %ymm3,%ymm9,%ymm3
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  197,188,88,219                      // vaddps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_darken_avx
.globl _sk_darken_avx
FUNCTION(_sk_darken_avx)
_sk_darken_avx:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,100,89,204                      // vmulps        %ymm4,%ymm3,%ymm9
  .byte  196,193,124,95,193                  // vmaxps        %ymm9,%ymm0,%ymm0
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  197,100,89,205                      // vmulps        %ymm5,%ymm3,%ymm9
  .byte  196,193,116,95,201                  // vmaxps        %ymm9,%ymm1,%ymm1
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  197,100,89,206                      // vmulps        %ymm6,%ymm3,%ymm9
  .byte  196,193,108,95,209                  // vmaxps        %ymm9,%ymm2,%ymm2
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,206,160,2,0         // vbroadcastss  0x2a0ce(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  197,188,88,219                      // vaddps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lighten_avx
.globl _sk_lighten_avx
FUNCTION(_sk_lighten_avx)
_sk_lighten_avx:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,100,89,204                      // vmulps        %ymm4,%ymm3,%ymm9
  .byte  196,193,124,93,193                  // vminps        %ymm9,%ymm0,%ymm0
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  197,100,89,205                      // vmulps        %ymm5,%ymm3,%ymm9
  .byte  196,193,116,93,201                  // vminps        %ymm9,%ymm1,%ymm1
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  197,100,89,206                      // vmulps        %ymm6,%ymm3,%ymm9
  .byte  196,193,108,93,209                  // vminps        %ymm9,%ymm2,%ymm2
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,118,160,2,0         // vbroadcastss  0x2a076(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  197,188,88,219                      // vaddps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_difference_avx
.globl _sk_difference_avx
FUNCTION(_sk_difference_avx)
_sk_difference_avx:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,100,89,204                      // vmulps        %ymm4,%ymm3,%ymm9
  .byte  196,193,124,93,193                  // vminps        %ymm9,%ymm0,%ymm0
  .byte  197,252,88,192                      // vaddps        %ymm0,%ymm0,%ymm0
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  197,244,89,207                      // vmulps        %ymm7,%ymm1,%ymm1
  .byte  197,100,89,205                      // vmulps        %ymm5,%ymm3,%ymm9
  .byte  196,193,116,93,201                  // vminps        %ymm9,%ymm1,%ymm1
  .byte  197,244,88,201                      // vaddps        %ymm1,%ymm1,%ymm1
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  197,236,89,215                      // vmulps        %ymm7,%ymm2,%ymm2
  .byte  197,100,89,206                      // vmulps        %ymm6,%ymm3,%ymm9
  .byte  196,193,108,93,209                  // vminps        %ymm9,%ymm2,%ymm2
  .byte  197,236,88,210                      // vaddps        %ymm2,%ymm2,%ymm2
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,18,160,2,0          // vbroadcastss  0x2a012(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  197,188,88,219                      // vaddps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_exclusion_avx
.globl _sk_exclusion_avx
FUNCTION(_sk_exclusion_avx)
_sk_exclusion_avx:
  .byte  197,124,88,196                      // vaddps        %ymm4,%ymm0,%ymm8
  .byte  197,252,89,196                      // vmulps        %ymm4,%ymm0,%ymm0
  .byte  197,252,88,192                      // vaddps        %ymm0,%ymm0,%ymm0
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,116,88,197                      // vaddps        %ymm5,%ymm1,%ymm8
  .byte  197,244,89,205                      // vmulps        %ymm5,%ymm1,%ymm1
  .byte  197,244,88,201                      // vaddps        %ymm1,%ymm1,%ymm1
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,108,88,198                      // vaddps        %ymm6,%ymm2,%ymm8
  .byte  197,236,89,214                      // vmulps        %ymm6,%ymm2,%ymm2
  .byte  197,236,88,210                      // vaddps        %ymm2,%ymm2,%ymm2
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,201,159,2,0         // vbroadcastss  0x29fc9(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  197,188,88,219                      // vaddps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_colorburn_avx
.globl _sk_colorburn_avx
FUNCTION(_sk_colorburn_avx)
_sk_colorburn_avx:
  .byte  196,98,125,24,5,176,159,2,0         // vbroadcastss  0x29fb0(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,207                       // vsubps        %ymm7,%ymm8,%ymm9
  .byte  197,52,89,216                       // vmulps        %ymm0,%ymm9,%ymm11
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,65,124,194,226,0                // vcmpeqps      %ymm10,%ymm0,%ymm12
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,68,92,236                       // vsubps        %ymm4,%ymm7,%ymm13
  .byte  197,20,89,235                       // vmulps        %ymm3,%ymm13,%ymm13
  .byte  197,252,83,192                      // vrcpps        %ymm0,%ymm0
  .byte  197,148,89,192                      // vmulps        %ymm0,%ymm13,%ymm0
  .byte  197,60,89,236                       // vmulps        %ymm4,%ymm8,%ymm13
  .byte  197,196,93,192                      // vminps        %ymm0,%ymm7,%ymm0
  .byte  197,196,92,192                      // vsubps        %ymm0,%ymm7,%ymm0
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  197,164,88,192                      // vaddps        %ymm0,%ymm11,%ymm0
  .byte  197,148,88,192                      // vaddps        %ymm0,%ymm13,%ymm0
  .byte  196,195,125,74,197,192              // vblendvps     %ymm12,%ymm13,%ymm0,%ymm0
  .byte  197,92,194,231,0                    // vcmpeqps      %ymm7,%ymm4,%ymm12
  .byte  197,36,88,220                       // vaddps        %ymm4,%ymm11,%ymm11
  .byte  196,195,125,74,195,192              // vblendvps     %ymm12,%ymm11,%ymm0,%ymm0
  .byte  197,52,89,217                       // vmulps        %ymm1,%ymm9,%ymm11
  .byte  196,65,116,194,226,0                // vcmpeqps      %ymm10,%ymm1,%ymm12
  .byte  197,68,92,237                       // vsubps        %ymm5,%ymm7,%ymm13
  .byte  197,20,89,235                       // vmulps        %ymm3,%ymm13,%ymm13
  .byte  197,252,83,201                      // vrcpps        %ymm1,%ymm1
  .byte  197,148,89,201                      // vmulps        %ymm1,%ymm13,%ymm1
  .byte  197,60,89,237                       // vmulps        %ymm5,%ymm8,%ymm13
  .byte  197,196,93,201                      // vminps        %ymm1,%ymm7,%ymm1
  .byte  197,196,92,201                      // vsubps        %ymm1,%ymm7,%ymm1
  .byte  197,244,89,203                      // vmulps        %ymm3,%ymm1,%ymm1
  .byte  197,164,88,201                      // vaddps        %ymm1,%ymm11,%ymm1
  .byte  197,148,88,201                      // vaddps        %ymm1,%ymm13,%ymm1
  .byte  196,195,117,74,205,192              // vblendvps     %ymm12,%ymm13,%ymm1,%ymm1
  .byte  197,84,194,231,0                    // vcmpeqps      %ymm7,%ymm5,%ymm12
  .byte  197,36,88,221                       // vaddps        %ymm5,%ymm11,%ymm11
  .byte  196,195,117,74,203,192              // vblendvps     %ymm12,%ymm11,%ymm1,%ymm1
  .byte  197,52,89,202                       // vmulps        %ymm2,%ymm9,%ymm9
  .byte  196,65,108,194,210,0                // vcmpeqps      %ymm10,%ymm2,%ymm10
  .byte  197,68,92,222                       // vsubps        %ymm6,%ymm7,%ymm11
  .byte  197,36,89,219                       // vmulps        %ymm3,%ymm11,%ymm11
  .byte  197,252,83,210                      // vrcpps        %ymm2,%ymm2
  .byte  197,164,89,210                      // vmulps        %ymm2,%ymm11,%ymm2
  .byte  197,60,89,222                       // vmulps        %ymm6,%ymm8,%ymm11
  .byte  197,196,93,210                      // vminps        %ymm2,%ymm7,%ymm2
  .byte  197,196,92,210                      // vsubps        %ymm2,%ymm7,%ymm2
  .byte  197,236,89,211                      // vmulps        %ymm3,%ymm2,%ymm2
  .byte  197,180,88,210                      // vaddps        %ymm2,%ymm9,%ymm2
  .byte  197,164,88,210                      // vaddps        %ymm2,%ymm11,%ymm2
  .byte  196,195,109,74,211,160              // vblendvps     %ymm10,%ymm11,%ymm2,%ymm2
  .byte  197,76,194,215,0                    // vcmpeqps      %ymm7,%ymm6,%ymm10
  .byte  197,52,88,206                       // vaddps        %ymm6,%ymm9,%ymm9
  .byte  196,195,109,74,209,160              // vblendvps     %ymm10,%ymm9,%ymm2,%ymm2
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  197,188,88,219                      // vaddps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_colordodge_avx
.globl _sk_colordodge_avx
FUNCTION(_sk_colordodge_avx)
_sk_colordodge_avx:
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,98,125,24,13,180,158,2,0        // vbroadcastss  0x29eb4(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,52,92,215                       // vsubps        %ymm7,%ymm9,%ymm10
  .byte  197,44,89,216                       // vmulps        %ymm0,%ymm10,%ymm11
  .byte  197,52,92,203                       // vsubps        %ymm3,%ymm9,%ymm9
  .byte  197,100,89,228                      // vmulps        %ymm4,%ymm3,%ymm12
  .byte  197,100,92,232                      // vsubps        %ymm0,%ymm3,%ymm13
  .byte  196,65,124,83,237                   // vrcpps        %ymm13,%ymm13
  .byte  196,65,28,89,229                    // vmulps        %ymm13,%ymm12,%ymm12
  .byte  197,52,89,236                       // vmulps        %ymm4,%ymm9,%ymm13
  .byte  196,65,68,93,228                    // vminps        %ymm12,%ymm7,%ymm12
  .byte  197,28,89,227                       // vmulps        %ymm3,%ymm12,%ymm12
  .byte  196,65,36,88,228                    // vaddps        %ymm12,%ymm11,%ymm12
  .byte  196,65,20,88,228                    // vaddps        %ymm12,%ymm13,%ymm12
  .byte  197,20,88,232                       // vaddps        %ymm0,%ymm13,%ymm13
  .byte  197,252,194,195,0                   // vcmpeqps      %ymm3,%ymm0,%ymm0
  .byte  196,195,29,74,197,0                 // vblendvps     %ymm0,%ymm13,%ymm12,%ymm0
  .byte  196,65,92,194,224,0                 // vcmpeqps      %ymm8,%ymm4,%ymm12
  .byte  196,195,125,74,195,192              // vblendvps     %ymm12,%ymm11,%ymm0,%ymm0
  .byte  197,44,89,217                       // vmulps        %ymm1,%ymm10,%ymm11
  .byte  197,100,89,229                      // vmulps        %ymm5,%ymm3,%ymm12
  .byte  197,100,92,233                      // vsubps        %ymm1,%ymm3,%ymm13
  .byte  196,65,124,83,237                   // vrcpps        %ymm13,%ymm13
  .byte  196,65,28,89,229                    // vmulps        %ymm13,%ymm12,%ymm12
  .byte  197,52,89,237                       // vmulps        %ymm5,%ymm9,%ymm13
  .byte  196,65,68,93,228                    // vminps        %ymm12,%ymm7,%ymm12
  .byte  197,28,89,227                       // vmulps        %ymm3,%ymm12,%ymm12
  .byte  196,65,36,88,228                    // vaddps        %ymm12,%ymm11,%ymm12
  .byte  196,65,20,88,228                    // vaddps        %ymm12,%ymm13,%ymm12
  .byte  197,20,88,233                       // vaddps        %ymm1,%ymm13,%ymm13
  .byte  197,244,194,203,0                   // vcmpeqps      %ymm3,%ymm1,%ymm1
  .byte  196,195,29,74,205,16                // vblendvps     %ymm1,%ymm13,%ymm12,%ymm1
  .byte  196,65,84,194,224,0                 // vcmpeqps      %ymm8,%ymm5,%ymm12
  .byte  196,195,117,74,203,192              // vblendvps     %ymm12,%ymm11,%ymm1,%ymm1
  .byte  197,44,89,210                       // vmulps        %ymm2,%ymm10,%ymm10
  .byte  197,100,89,222                      // vmulps        %ymm6,%ymm3,%ymm11
  .byte  197,100,92,226                      // vsubps        %ymm2,%ymm3,%ymm12
  .byte  196,65,124,83,228                   // vrcpps        %ymm12,%ymm12
  .byte  196,65,36,89,220                    // vmulps        %ymm12,%ymm11,%ymm11
  .byte  197,52,89,230                       // vmulps        %ymm6,%ymm9,%ymm12
  .byte  196,65,68,93,219                    // vminps        %ymm11,%ymm7,%ymm11
  .byte  197,36,89,219                       // vmulps        %ymm3,%ymm11,%ymm11
  .byte  196,65,44,88,219                    // vaddps        %ymm11,%ymm10,%ymm11
  .byte  196,65,28,88,219                    // vaddps        %ymm11,%ymm12,%ymm11
  .byte  197,28,88,226                       // vaddps        %ymm2,%ymm12,%ymm12
  .byte  197,236,194,211,0                   // vcmpeqps      %ymm3,%ymm2,%ymm2
  .byte  196,195,37,74,212,32                // vblendvps     %ymm2,%ymm12,%ymm11,%ymm2
  .byte  196,65,76,194,192,0                 // vcmpeqps      %ymm8,%ymm6,%ymm8
  .byte  196,195,109,74,210,128              // vblendvps     %ymm8,%ymm10,%ymm2,%ymm2
  .byte  197,52,89,199                       // vmulps        %ymm7,%ymm9,%ymm8
  .byte  197,188,88,219                      // vaddps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hardlight_avx
.globl _sk_hardlight_avx
FUNCTION(_sk_hardlight_avx)
_sk_hardlight_avx:
  .byte  196,98,125,24,5,191,157,2,0         // vbroadcastss  0x29dbf(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,215                       // vsubps        %ymm7,%ymm8,%ymm10
  .byte  197,44,89,200                       // vmulps        %ymm0,%ymm10,%ymm9
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,60,89,220                       // vmulps        %ymm4,%ymm8,%ymm11
  .byte  196,65,36,88,217                    // vaddps        %ymm9,%ymm11,%ymm11
  .byte  197,124,88,200                      // vaddps        %ymm0,%ymm0,%ymm9
  .byte  197,52,194,227,2                    // vcmpleps      %ymm3,%ymm9,%ymm12
  .byte  197,124,89,204                      // vmulps        %ymm4,%ymm0,%ymm9
  .byte  196,65,52,88,233                    // vaddps        %ymm9,%ymm9,%ymm13
  .byte  197,100,89,207                      // vmulps        %ymm7,%ymm3,%ymm9
  .byte  197,68,92,244                       // vsubps        %ymm4,%ymm7,%ymm14
  .byte  197,228,92,192                      // vsubps        %ymm0,%ymm3,%ymm0
  .byte  196,193,124,89,198                  // vmulps        %ymm14,%ymm0,%ymm0
  .byte  197,252,88,192                      // vaddps        %ymm0,%ymm0,%ymm0
  .byte  197,180,92,192                      // vsubps        %ymm0,%ymm9,%ymm0
  .byte  196,195,125,74,197,192              // vblendvps     %ymm12,%ymm13,%ymm0,%ymm0
  .byte  197,164,88,192                      // vaddps        %ymm0,%ymm11,%ymm0
  .byte  197,44,89,217                       // vmulps        %ymm1,%ymm10,%ymm11
  .byte  197,60,89,229                       // vmulps        %ymm5,%ymm8,%ymm12
  .byte  196,65,28,88,219                    // vaddps        %ymm11,%ymm12,%ymm11
  .byte  197,116,88,225                      // vaddps        %ymm1,%ymm1,%ymm12
  .byte  197,28,194,227,2                    // vcmpleps      %ymm3,%ymm12,%ymm12
  .byte  197,116,89,237                      // vmulps        %ymm5,%ymm1,%ymm13
  .byte  196,65,20,88,237                    // vaddps        %ymm13,%ymm13,%ymm13
  .byte  197,68,92,245                       // vsubps        %ymm5,%ymm7,%ymm14
  .byte  197,228,92,201                      // vsubps        %ymm1,%ymm3,%ymm1
  .byte  196,193,116,89,206                  // vmulps        %ymm14,%ymm1,%ymm1
  .byte  197,244,88,201                      // vaddps        %ymm1,%ymm1,%ymm1
  .byte  197,180,92,201                      // vsubps        %ymm1,%ymm9,%ymm1
  .byte  196,195,117,74,205,192              // vblendvps     %ymm12,%ymm13,%ymm1,%ymm1
  .byte  197,164,88,201                      // vaddps        %ymm1,%ymm11,%ymm1
  .byte  197,44,89,210                       // vmulps        %ymm2,%ymm10,%ymm10
  .byte  197,60,89,222                       // vmulps        %ymm6,%ymm8,%ymm11
  .byte  196,65,36,88,210                    // vaddps        %ymm10,%ymm11,%ymm10
  .byte  197,108,88,218                      // vaddps        %ymm2,%ymm2,%ymm11
  .byte  197,36,194,219,2                    // vcmpleps      %ymm3,%ymm11,%ymm11
  .byte  197,108,89,230                      // vmulps        %ymm6,%ymm2,%ymm12
  .byte  196,65,28,88,228                    // vaddps        %ymm12,%ymm12,%ymm12
  .byte  197,68,92,238                       // vsubps        %ymm6,%ymm7,%ymm13
  .byte  197,228,92,210                      // vsubps        %ymm2,%ymm3,%ymm2
  .byte  196,193,108,89,213                  // vmulps        %ymm13,%ymm2,%ymm2
  .byte  197,236,88,210                      // vaddps        %ymm2,%ymm2,%ymm2
  .byte  197,180,92,210                      // vsubps        %ymm2,%ymm9,%ymm2
  .byte  196,195,109,74,212,176              // vblendvps     %ymm11,%ymm12,%ymm2,%ymm2
  .byte  197,172,88,210                      // vaddps        %ymm2,%ymm10,%ymm2
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  197,188,88,219                      // vaddps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_overlay_avx
.globl _sk_overlay_avx
FUNCTION(_sk_overlay_avx)
_sk_overlay_avx:
  .byte  196,98,125,24,5,228,156,2,0         // vbroadcastss  0x29ce4(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,215                       // vsubps        %ymm7,%ymm8,%ymm10
  .byte  197,44,89,200                       // vmulps        %ymm0,%ymm10,%ymm9
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,60,89,220                       // vmulps        %ymm4,%ymm8,%ymm11
  .byte  196,65,36,88,217                    // vaddps        %ymm9,%ymm11,%ymm11
  .byte  197,92,88,204                       // vaddps        %ymm4,%ymm4,%ymm9
  .byte  197,52,194,231,2                    // vcmpleps      %ymm7,%ymm9,%ymm12
  .byte  197,124,89,204                      // vmulps        %ymm4,%ymm0,%ymm9
  .byte  196,65,52,88,233                    // vaddps        %ymm9,%ymm9,%ymm13
  .byte  197,100,89,207                      // vmulps        %ymm7,%ymm3,%ymm9
  .byte  197,68,92,244                       // vsubps        %ymm4,%ymm7,%ymm14
  .byte  197,228,92,192                      // vsubps        %ymm0,%ymm3,%ymm0
  .byte  196,193,124,89,198                  // vmulps        %ymm14,%ymm0,%ymm0
  .byte  197,252,88,192                      // vaddps        %ymm0,%ymm0,%ymm0
  .byte  197,180,92,192                      // vsubps        %ymm0,%ymm9,%ymm0
  .byte  196,195,125,74,197,192              // vblendvps     %ymm12,%ymm13,%ymm0,%ymm0
  .byte  197,164,88,192                      // vaddps        %ymm0,%ymm11,%ymm0
  .byte  197,44,89,217                       // vmulps        %ymm1,%ymm10,%ymm11
  .byte  197,60,89,229                       // vmulps        %ymm5,%ymm8,%ymm12
  .byte  196,65,28,88,219                    // vaddps        %ymm11,%ymm12,%ymm11
  .byte  197,84,88,229                       // vaddps        %ymm5,%ymm5,%ymm12
  .byte  197,28,194,231,2                    // vcmpleps      %ymm7,%ymm12,%ymm12
  .byte  197,116,89,237                      // vmulps        %ymm5,%ymm1,%ymm13
  .byte  196,65,20,88,237                    // vaddps        %ymm13,%ymm13,%ymm13
  .byte  197,68,92,245                       // vsubps        %ymm5,%ymm7,%ymm14
  .byte  197,228,92,201                      // vsubps        %ymm1,%ymm3,%ymm1
  .byte  196,193,116,89,206                  // vmulps        %ymm14,%ymm1,%ymm1
  .byte  197,244,88,201                      // vaddps        %ymm1,%ymm1,%ymm1
  .byte  197,180,92,201                      // vsubps        %ymm1,%ymm9,%ymm1
  .byte  196,195,117,74,205,192              // vblendvps     %ymm12,%ymm13,%ymm1,%ymm1
  .byte  197,164,88,201                      // vaddps        %ymm1,%ymm11,%ymm1
  .byte  197,44,89,210                       // vmulps        %ymm2,%ymm10,%ymm10
  .byte  197,60,89,222                       // vmulps        %ymm6,%ymm8,%ymm11
  .byte  196,65,36,88,210                    // vaddps        %ymm10,%ymm11,%ymm10
  .byte  197,76,88,222                       // vaddps        %ymm6,%ymm6,%ymm11
  .byte  197,36,194,223,2                    // vcmpleps      %ymm7,%ymm11,%ymm11
  .byte  197,108,89,230                      // vmulps        %ymm6,%ymm2,%ymm12
  .byte  196,65,28,88,228                    // vaddps        %ymm12,%ymm12,%ymm12
  .byte  197,68,92,238                       // vsubps        %ymm6,%ymm7,%ymm13
  .byte  197,228,92,210                      // vsubps        %ymm2,%ymm3,%ymm2
  .byte  196,193,108,89,213                  // vmulps        %ymm13,%ymm2,%ymm2
  .byte  197,236,88,210                      // vaddps        %ymm2,%ymm2,%ymm2
  .byte  197,180,92,210                      // vsubps        %ymm2,%ymm9,%ymm2
  .byte  196,195,109,74,212,176              // vblendvps     %ymm11,%ymm12,%ymm2,%ymm2
  .byte  197,172,88,210                      // vaddps        %ymm2,%ymm10,%ymm2
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  197,188,88,219                      // vaddps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_softlight_avx
.globl _sk_softlight_avx
FUNCTION(_sk_softlight_avx)
_sk_softlight_avx:
  .byte  197,252,17,84,36,200                // vmovups       %ymm2,-0x38(%rsp)
  .byte  197,252,40,209                      // vmovaps       %ymm1,%ymm2
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,52,194,215,1                    // vcmpltps      %ymm7,%ymm9,%ymm10
  .byte  197,92,94,199                       // vdivps        %ymm7,%ymm4,%ymm8
  .byte  196,67,53,74,224,160                // vblendvps     %ymm10,%ymm8,%ymm9,%ymm12
  .byte  196,65,28,88,196                    // vaddps        %ymm12,%ymm12,%ymm8
  .byte  196,65,60,88,192                    // vaddps        %ymm8,%ymm8,%ymm8
  .byte  196,65,60,89,216                    // vmulps        %ymm8,%ymm8,%ymm11
  .byte  196,65,60,88,195                    // vaddps        %ymm11,%ymm8,%ymm8
  .byte  196,98,125,24,29,235,155,2,0        // vbroadcastss  0x29beb(%rip),%ymm11        # 3a230 <_sk_srcover_bgra_8888_sse2_lowp+0x2c8>
  .byte  196,65,28,88,235                    // vaddps        %ymm11,%ymm12,%ymm13
  .byte  196,65,20,89,192                    // vmulps        %ymm8,%ymm13,%ymm8
  .byte  196,98,125,24,45,220,155,2,0        // vbroadcastss  0x29bdc(%rip),%ymm13        # 3a234 <_sk_srcover_bgra_8888_sse2_lowp+0x2cc>
  .byte  196,65,28,89,245                    // vmulps        %ymm13,%ymm12,%ymm14
  .byte  196,65,12,88,192                    // vaddps        %ymm8,%ymm14,%ymm8
  .byte  196,65,124,82,244                   // vrsqrtps      %ymm12,%ymm14
  .byte  196,65,124,83,246                   // vrcpps        %ymm14,%ymm14
  .byte  196,65,12,92,244                    // vsubps        %ymm12,%ymm14,%ymm14
  .byte  197,92,88,252                       // vaddps        %ymm4,%ymm4,%ymm15
  .byte  196,65,4,88,255                     // vaddps        %ymm15,%ymm15,%ymm15
  .byte  197,4,194,255,2                     // vcmpleps      %ymm7,%ymm15,%ymm15
  .byte  196,67,13,74,240,240                // vblendvps     %ymm15,%ymm8,%ymm14,%ymm14
  .byte  197,116,88,249                      // vaddps        %ymm1,%ymm1,%ymm15
  .byte  196,98,125,24,5,134,155,2,0         // vbroadcastss  0x29b86(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,60,92,228                    // vsubps        %ymm12,%ymm8,%ymm12
  .byte  197,132,92,195                      // vsubps        %ymm3,%ymm15,%ymm0
  .byte  196,65,124,89,228                   // vmulps        %ymm12,%ymm0,%ymm12
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  196,193,124,89,198                  // vmulps        %ymm14,%ymm0,%ymm0
  .byte  197,100,89,244                      // vmulps        %ymm4,%ymm3,%ymm14
  .byte  197,140,88,192                      // vaddps        %ymm0,%ymm14,%ymm0
  .byte  197,28,88,227                       // vaddps        %ymm3,%ymm12,%ymm12
  .byte  197,28,89,228                       // vmulps        %ymm4,%ymm12,%ymm12
  .byte  197,4,194,243,2                     // vcmpleps      %ymm3,%ymm15,%ymm14
  .byte  196,195,125,74,196,224              // vblendvps     %ymm14,%ymm12,%ymm0,%ymm0
  .byte  197,252,17,68,36,168                // vmovups       %ymm0,-0x58(%rsp)
  .byte  197,212,94,199                      // vdivps        %ymm7,%ymm5,%ymm0
  .byte  196,227,53,74,192,160               // vblendvps     %ymm10,%ymm0,%ymm9,%ymm0
  .byte  197,124,88,240                      // vaddps        %ymm0,%ymm0,%ymm14
  .byte  196,65,12,88,246                    // vaddps        %ymm14,%ymm14,%ymm14
  .byte  196,65,12,89,254                    // vmulps        %ymm14,%ymm14,%ymm15
  .byte  196,65,12,88,247                    // vaddps        %ymm15,%ymm14,%ymm14
  .byte  196,65,124,88,251                   // vaddps        %ymm11,%ymm0,%ymm15
  .byte  196,65,4,89,246                     // vmulps        %ymm14,%ymm15,%ymm14
  .byte  196,65,124,89,253                   // vmulps        %ymm13,%ymm0,%ymm15
  .byte  196,65,4,88,246                     // vaddps        %ymm14,%ymm15,%ymm14
  .byte  197,124,82,248                      // vrsqrtps      %ymm0,%ymm15
  .byte  196,65,124,83,255                   // vrcpps        %ymm15,%ymm15
  .byte  197,4,92,248                        // vsubps        %ymm0,%ymm15,%ymm15
  .byte  197,84,88,229                       // vaddps        %ymm5,%ymm5,%ymm12
  .byte  196,65,28,88,228                    // vaddps        %ymm12,%ymm12,%ymm12
  .byte  197,28,194,231,2                    // vcmpleps      %ymm7,%ymm12,%ymm12
  .byte  196,67,5,74,230,192                 // vblendvps     %ymm12,%ymm14,%ymm15,%ymm12
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,108,88,242                      // vaddps        %ymm2,%ymm2,%ymm14
  .byte  197,12,92,251                       // vsubps        %ymm3,%ymm14,%ymm15
  .byte  197,132,89,192                      // vmulps        %ymm0,%ymm15,%ymm0
  .byte  197,4,89,255                        // vmulps        %ymm7,%ymm15,%ymm15
  .byte  196,65,4,89,228                     // vmulps        %ymm12,%ymm15,%ymm12
  .byte  197,100,89,253                      // vmulps        %ymm5,%ymm3,%ymm15
  .byte  196,65,4,88,228                     // vaddps        %ymm12,%ymm15,%ymm12
  .byte  197,252,88,195                      // vaddps        %ymm3,%ymm0,%ymm0
  .byte  197,252,89,197                      // vmulps        %ymm5,%ymm0,%ymm0
  .byte  197,12,194,243,2                    // vcmpleps      %ymm3,%ymm14,%ymm14
  .byte  196,99,29,74,240,224                // vblendvps     %ymm14,%ymm0,%ymm12,%ymm14
  .byte  197,204,94,199                      // vdivps        %ymm7,%ymm6,%ymm0
  .byte  196,227,53,74,192,160               // vblendvps     %ymm10,%ymm0,%ymm9,%ymm0
  .byte  197,124,88,200                      // vaddps        %ymm0,%ymm0,%ymm9
  .byte  196,65,52,88,201                    // vaddps        %ymm9,%ymm9,%ymm9
  .byte  196,65,52,89,209                    // vmulps        %ymm9,%ymm9,%ymm10
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,65,124,88,211                   // vaddps        %ymm11,%ymm0,%ymm10
  .byte  196,65,44,89,201                    // vmulps        %ymm9,%ymm10,%ymm9
  .byte  196,65,124,89,213                   // vmulps        %ymm13,%ymm0,%ymm10
  .byte  196,65,44,88,201                    // vaddps        %ymm9,%ymm10,%ymm9
  .byte  197,124,82,208                      // vrsqrtps      %ymm0,%ymm10
  .byte  196,65,124,83,210                   // vrcpps        %ymm10,%ymm10
  .byte  197,44,92,208                       // vsubps        %ymm0,%ymm10,%ymm10
  .byte  197,76,88,222                       // vaddps        %ymm6,%ymm6,%ymm11
  .byte  196,65,36,88,219                    // vaddps        %ymm11,%ymm11,%ymm11
  .byte  197,36,194,223,2                    // vcmpleps      %ymm7,%ymm11,%ymm11
  .byte  196,67,45,74,201,176                // vblendvps     %ymm11,%ymm9,%ymm10,%ymm9
  .byte  197,124,16,100,36,200               // vmovups       -0x38(%rsp),%ymm12
  .byte  196,65,28,88,212                    // vaddps        %ymm12,%ymm12,%ymm10
  .byte  197,44,92,219                       // vsubps        %ymm3,%ymm10,%ymm11
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,164,89,192                      // vmulps        %ymm0,%ymm11,%ymm0
  .byte  197,36,89,223                       // vmulps        %ymm7,%ymm11,%ymm11
  .byte  196,65,36,89,201                    // vmulps        %ymm9,%ymm11,%ymm9
  .byte  197,100,89,222                      // vmulps        %ymm6,%ymm3,%ymm11
  .byte  196,65,36,88,201                    // vaddps        %ymm9,%ymm11,%ymm9
  .byte  197,252,88,195                      // vaddps        %ymm3,%ymm0,%ymm0
  .byte  197,252,89,198                      // vmulps        %ymm6,%ymm0,%ymm0
  .byte  197,44,194,211,2                    // vcmpleps      %ymm3,%ymm10,%ymm10
  .byte  196,99,53,74,200,160                // vblendvps     %ymm10,%ymm0,%ymm9,%ymm9
  .byte  197,60,92,215                       // vsubps        %ymm7,%ymm8,%ymm10
  .byte  197,172,89,193                      // vmulps        %ymm1,%ymm10,%ymm0
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,188,89,204                      // vmulps        %ymm4,%ymm8,%ymm1
  .byte  197,244,88,192                      // vaddps        %ymm0,%ymm1,%ymm0
  .byte  197,252,88,68,36,168                // vaddps        -0x58(%rsp),%ymm0,%ymm0
  .byte  197,172,89,202                      // vmulps        %ymm2,%ymm10,%ymm1
  .byte  197,188,89,213                      // vmulps        %ymm5,%ymm8,%ymm2
  .byte  197,236,88,201                      // vaddps        %ymm1,%ymm2,%ymm1
  .byte  196,193,116,88,206                  // vaddps        %ymm14,%ymm1,%ymm1
  .byte  196,193,44,89,212                   // vmulps        %ymm12,%ymm10,%ymm2
  .byte  197,60,89,214                       // vmulps        %ymm6,%ymm8,%ymm10
  .byte  197,172,88,210                      // vaddps        %ymm2,%ymm10,%ymm2
  .byte  196,193,108,88,209                  // vaddps        %ymm9,%ymm2,%ymm2
  .byte  197,60,89,199                       // vmulps        %ymm7,%ymm8,%ymm8
  .byte  197,188,88,219                      // vaddps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hue_avx
.globl _sk_hue_avx
FUNCTION(_sk_hue_avx)
_sk_hue_avx:
  .byte  197,252,17,84,36,200                // vmovups       %ymm2,-0x38(%rsp)
  .byte  197,124,40,193                      // vmovaps       %ymm1,%ymm8
  .byte  197,124,17,68,36,168                // vmovups       %ymm8,-0x58(%rsp)
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,116,89,203                      // vmulps        %ymm3,%ymm1,%ymm9
  .byte  197,60,89,211                       // vmulps        %ymm3,%ymm8,%ymm10
  .byte  197,108,89,219                      // vmulps        %ymm3,%ymm2,%ymm11
  .byte  197,84,95,198                       // vmaxps        %ymm6,%ymm5,%ymm8
  .byte  196,65,92,95,192                    // vmaxps        %ymm8,%ymm4,%ymm8
  .byte  197,84,93,230                       // vminps        %ymm6,%ymm5,%ymm12
  .byte  196,65,92,93,228                    // vminps        %ymm12,%ymm4,%ymm12
  .byte  196,65,60,92,196                    // vsubps        %ymm12,%ymm8,%ymm8
  .byte  197,60,89,227                       // vmulps        %ymm3,%ymm8,%ymm12
  .byte  196,65,44,93,195                    // vminps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,93,232                    // vminps        %ymm8,%ymm9,%ymm13
  .byte  196,65,44,95,195                    // vmaxps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,95,192                    // vmaxps        %ymm8,%ymm9,%ymm8
  .byte  196,65,60,92,245                    // vsubps        %ymm13,%ymm8,%ymm14
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,65,12,194,248,0                 // vcmpeqps      %ymm8,%ymm14,%ymm15
  .byte  196,65,52,92,205                    // vsubps        %ymm13,%ymm9,%ymm9
  .byte  196,65,28,89,201                    // vmulps        %ymm9,%ymm12,%ymm9
  .byte  196,65,52,94,206                    // vdivps        %ymm14,%ymm9,%ymm9
  .byte  196,67,53,74,200,240                // vblendvps     %ymm15,%ymm8,%ymm9,%ymm9
  .byte  196,65,44,92,213                    // vsubps        %ymm13,%ymm10,%ymm10
  .byte  196,65,28,89,210                    // vmulps        %ymm10,%ymm12,%ymm10
  .byte  196,65,44,94,214                    // vdivps        %ymm14,%ymm10,%ymm10
  .byte  196,67,45,74,208,240                // vblendvps     %ymm15,%ymm8,%ymm10,%ymm10
  .byte  196,65,36,92,221                    // vsubps        %ymm13,%ymm11,%ymm11
  .byte  196,65,28,89,219                    // vmulps        %ymm11,%ymm12,%ymm11
  .byte  196,65,36,94,222                    // vdivps        %ymm14,%ymm11,%ymm11
  .byte  196,67,37,74,224,240                // vblendvps     %ymm15,%ymm8,%ymm11,%ymm12
  .byte  196,98,125,24,53,105,153,2,0        // vbroadcastss  0x29969(%rip),%ymm14        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,65,92,89,222                    // vmulps        %ymm14,%ymm4,%ymm11
  .byte  196,98,125,24,61,95,153,2,0         // vbroadcastss  0x2995f(%rip),%ymm15        # 3a23c <_sk_srcover_bgra_8888_sse2_lowp+0x2d4>
  .byte  196,65,84,89,239                    // vmulps        %ymm15,%ymm5,%ymm13
  .byte  196,65,36,88,221                    // vaddps        %ymm13,%ymm11,%ymm11
  .byte  196,226,125,24,5,80,153,2,0         // vbroadcastss  0x29950(%rip),%ymm0        # 3a240 <_sk_srcover_bgra_8888_sse2_lowp+0x2d8>
  .byte  197,76,89,232                       // vmulps        %ymm0,%ymm6,%ymm13
  .byte  196,65,36,88,221                    // vaddps        %ymm13,%ymm11,%ymm11
  .byte  196,65,52,89,238                    // vmulps        %ymm14,%ymm9,%ymm13
  .byte  196,193,44,89,215                   // vmulps        %ymm15,%ymm10,%ymm2
  .byte  197,148,88,210                      // vaddps        %ymm2,%ymm13,%ymm2
  .byte  197,28,89,232                       // vmulps        %ymm0,%ymm12,%ymm13
  .byte  196,193,108,88,213                  // vaddps        %ymm13,%ymm2,%ymm2
  .byte  197,36,89,219                       // vmulps        %ymm3,%ymm11,%ymm11
  .byte  197,164,92,210                      // vsubps        %ymm2,%ymm11,%ymm2
  .byte  197,52,88,202                       // vaddps        %ymm2,%ymm9,%ymm9
  .byte  197,44,88,218                       // vaddps        %ymm2,%ymm10,%ymm11
  .byte  197,28,88,226                       // vaddps        %ymm2,%ymm12,%ymm12
  .byte  196,193,36,93,212                   // vminps        %ymm12,%ymm11,%ymm2
  .byte  197,52,93,234                       // vminps        %ymm2,%ymm9,%ymm13
  .byte  196,193,52,89,214                   // vmulps        %ymm14,%ymm9,%ymm2
  .byte  196,65,36,89,215                    // vmulps        %ymm15,%ymm11,%ymm10
  .byte  196,193,108,88,210                  // vaddps        %ymm10,%ymm2,%ymm2
  .byte  197,156,89,192                      // vmulps        %ymm0,%ymm12,%ymm0
  .byte  197,124,88,210                      // vaddps        %ymm2,%ymm0,%ymm10
  .byte  196,193,52,92,194                   // vsubps        %ymm10,%ymm9,%ymm0
  .byte  197,172,89,192                      // vmulps        %ymm0,%ymm10,%ymm0
  .byte  196,193,44,92,213                   // vsubps        %ymm13,%ymm10,%ymm2
  .byte  197,252,94,194                      // vdivps        %ymm2,%ymm0,%ymm0
  .byte  196,65,36,92,242                    // vsubps        %ymm10,%ymm11,%ymm14
  .byte  196,65,44,89,246                    // vmulps        %ymm14,%ymm10,%ymm14
  .byte  197,12,94,242                       // vdivps        %ymm2,%ymm14,%ymm14
  .byte  196,65,28,92,250                    // vsubps        %ymm10,%ymm12,%ymm15
  .byte  196,65,44,89,255                    // vmulps        %ymm15,%ymm10,%ymm15
  .byte  197,132,94,210                      // vdivps        %ymm2,%ymm15,%ymm2
  .byte  196,65,60,194,237,2                 // vcmpleps      %ymm13,%ymm8,%ymm13
  .byte  196,65,44,88,246                    // vaddps        %ymm14,%ymm10,%ymm14
  .byte  196,67,13,74,243,208                // vblendvps     %ymm13,%ymm11,%ymm14,%ymm14
  .byte  196,65,36,95,220                    // vmaxps        %ymm12,%ymm11,%ymm11
  .byte  197,172,88,210                      // vaddps        %ymm2,%ymm10,%ymm2
  .byte  196,195,109,74,212,208              // vblendvps     %ymm13,%ymm12,%ymm2,%ymm2
  .byte  197,172,88,192                      // vaddps        %ymm0,%ymm10,%ymm0
  .byte  196,195,125,74,193,208              // vblendvps     %ymm13,%ymm9,%ymm0,%ymm0
  .byte  197,100,89,231                      // vmulps        %ymm7,%ymm3,%ymm12
  .byte  196,65,52,95,203                    // vmaxps        %ymm11,%ymm9,%ymm9
  .byte  196,65,124,92,218                   // vsubps        %ymm10,%ymm0,%ymm11
  .byte  196,65,28,92,234                    // vsubps        %ymm10,%ymm12,%ymm13
  .byte  196,65,20,89,219                    // vmulps        %ymm11,%ymm13,%ymm11
  .byte  196,65,28,194,249,1                 // vcmpltps      %ymm9,%ymm12,%ymm15
  .byte  196,65,52,92,202                    // vsubps        %ymm10,%ymm9,%ymm9
  .byte  196,65,36,94,217                    // vdivps        %ymm9,%ymm11,%ymm11
  .byte  196,65,44,88,219                    // vaddps        %ymm11,%ymm10,%ymm11
  .byte  196,195,125,74,195,240              // vblendvps     %ymm15,%ymm11,%ymm0,%ymm0
  .byte  196,65,12,92,218                    // vsubps        %ymm10,%ymm14,%ymm11
  .byte  196,65,20,89,219                    // vmulps        %ymm11,%ymm13,%ymm11
  .byte  196,65,36,94,217                    // vdivps        %ymm9,%ymm11,%ymm11
  .byte  196,65,44,88,219                    // vaddps        %ymm11,%ymm10,%ymm11
  .byte  196,67,13,74,219,240                // vblendvps     %ymm15,%ymm11,%ymm14,%ymm11
  .byte  196,65,108,92,242                   // vsubps        %ymm10,%ymm2,%ymm14
  .byte  196,65,20,89,238                    // vmulps        %ymm14,%ymm13,%ymm13
  .byte  196,65,20,94,201                    // vdivps        %ymm9,%ymm13,%ymm9
  .byte  196,65,44,88,201                    // vaddps        %ymm9,%ymm10,%ymm9
  .byte  196,193,124,95,192                  // vmaxps        %ymm8,%ymm0,%ymm0
  .byte  196,65,36,95,208                    // vmaxps        %ymm8,%ymm11,%ymm10
  .byte  196,195,109,74,209,240              // vblendvps     %ymm15,%ymm9,%ymm2,%ymm2
  .byte  196,193,108,95,208                  // vmaxps        %ymm8,%ymm2,%ymm2
  .byte  196,98,125,24,5,253,151,2,0         // vbroadcastss  0x297fd(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,207                       // vsubps        %ymm7,%ymm8,%ymm9
  .byte  197,180,89,201                      // vmulps        %ymm1,%ymm9,%ymm1
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,60,89,220                       // vmulps        %ymm4,%ymm8,%ymm11
  .byte  197,164,88,201                      // vaddps        %ymm1,%ymm11,%ymm1
  .byte  197,244,88,192                      // vaddps        %ymm0,%ymm1,%ymm0
  .byte  197,180,89,76,36,168                // vmulps        -0x58(%rsp),%ymm9,%ymm1
  .byte  197,60,89,221                       // vmulps        %ymm5,%ymm8,%ymm11
  .byte  197,164,88,201                      // vaddps        %ymm1,%ymm11,%ymm1
  .byte  196,193,116,88,202                  // vaddps        %ymm10,%ymm1,%ymm1
  .byte  197,52,89,76,36,200                 // vmulps        -0x38(%rsp),%ymm9,%ymm9
  .byte  197,60,89,198                       // vmulps        %ymm6,%ymm8,%ymm8
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  197,188,88,210                      // vaddps        %ymm2,%ymm8,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,92,220                  // vsubps        %ymm12,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_saturation_avx
.globl _sk_saturation_avx
FUNCTION(_sk_saturation_avx)
_sk_saturation_avx:
  .byte  197,124,40,193                      // vmovaps       %ymm1,%ymm8
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,100,89,204                      // vmulps        %ymm4,%ymm3,%ymm9
  .byte  197,100,89,213                      // vmulps        %ymm5,%ymm3,%ymm10
  .byte  197,100,89,222                      // vmulps        %ymm6,%ymm3,%ymm11
  .byte  197,252,17,84,36,200                // vmovups       %ymm2,-0x38(%rsp)
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,252,17,68,36,168                // vmovups       %ymm0,-0x58(%rsp)
  .byte  197,124,95,194                      // vmaxps        %ymm2,%ymm0,%ymm8
  .byte  196,65,116,95,192                   // vmaxps        %ymm8,%ymm1,%ymm8
  .byte  197,124,93,226                      // vminps        %ymm2,%ymm0,%ymm12
  .byte  196,65,116,93,228                   // vminps        %ymm12,%ymm1,%ymm12
  .byte  196,65,60,92,196                    // vsubps        %ymm12,%ymm8,%ymm8
  .byte  197,60,89,231                       // vmulps        %ymm7,%ymm8,%ymm12
  .byte  196,65,44,93,195                    // vminps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,93,232                    // vminps        %ymm8,%ymm9,%ymm13
  .byte  196,65,44,95,195                    // vmaxps        %ymm11,%ymm10,%ymm8
  .byte  196,65,52,95,192                    // vmaxps        %ymm8,%ymm9,%ymm8
  .byte  196,65,60,92,245                    // vsubps        %ymm13,%ymm8,%ymm14
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,65,12,194,248,0                 // vcmpeqps      %ymm8,%ymm14,%ymm15
  .byte  196,65,52,92,205                    // vsubps        %ymm13,%ymm9,%ymm9
  .byte  196,65,28,89,201                    // vmulps        %ymm9,%ymm12,%ymm9
  .byte  196,65,52,94,206                    // vdivps        %ymm14,%ymm9,%ymm9
  .byte  196,67,53,74,200,240                // vblendvps     %ymm15,%ymm8,%ymm9,%ymm9
  .byte  196,65,44,92,213                    // vsubps        %ymm13,%ymm10,%ymm10
  .byte  196,65,28,89,210                    // vmulps        %ymm10,%ymm12,%ymm10
  .byte  196,65,44,94,214                    // vdivps        %ymm14,%ymm10,%ymm10
  .byte  196,67,45,74,208,240                // vblendvps     %ymm15,%ymm8,%ymm10,%ymm10
  .byte  196,65,36,92,221                    // vsubps        %ymm13,%ymm11,%ymm11
  .byte  196,65,28,89,219                    // vmulps        %ymm11,%ymm12,%ymm11
  .byte  196,65,36,94,222                    // vdivps        %ymm14,%ymm11,%ymm11
  .byte  196,67,37,74,224,240                // vblendvps     %ymm15,%ymm8,%ymm11,%ymm12
  .byte  196,98,125,24,53,39,151,2,0         // vbroadcastss  0x29727(%rip),%ymm14        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,65,92,89,222                    // vmulps        %ymm14,%ymm4,%ymm11
  .byte  196,98,125,24,61,29,151,2,0         // vbroadcastss  0x2971d(%rip),%ymm15        # 3a23c <_sk_srcover_bgra_8888_sse2_lowp+0x2d4>
  .byte  196,65,84,89,239                    // vmulps        %ymm15,%ymm5,%ymm13
  .byte  196,65,36,88,221                    // vaddps        %ymm13,%ymm11,%ymm11
  .byte  196,226,125,24,5,14,151,2,0         // vbroadcastss  0x2970e(%rip),%ymm0        # 3a240 <_sk_srcover_bgra_8888_sse2_lowp+0x2d8>
  .byte  197,76,89,232                       // vmulps        %ymm0,%ymm6,%ymm13
  .byte  196,65,36,88,221                    // vaddps        %ymm13,%ymm11,%ymm11
  .byte  196,65,52,89,238                    // vmulps        %ymm14,%ymm9,%ymm13
  .byte  196,193,44,89,215                   // vmulps        %ymm15,%ymm10,%ymm2
  .byte  197,148,88,210                      // vaddps        %ymm2,%ymm13,%ymm2
  .byte  197,28,89,232                       // vmulps        %ymm0,%ymm12,%ymm13
  .byte  196,193,108,88,213                  // vaddps        %ymm13,%ymm2,%ymm2
  .byte  197,36,89,219                       // vmulps        %ymm3,%ymm11,%ymm11
  .byte  197,164,92,210                      // vsubps        %ymm2,%ymm11,%ymm2
  .byte  197,52,88,202                       // vaddps        %ymm2,%ymm9,%ymm9
  .byte  197,44,88,218                       // vaddps        %ymm2,%ymm10,%ymm11
  .byte  197,28,88,226                       // vaddps        %ymm2,%ymm12,%ymm12
  .byte  196,193,36,93,212                   // vminps        %ymm12,%ymm11,%ymm2
  .byte  197,52,93,234                       // vminps        %ymm2,%ymm9,%ymm13
  .byte  196,193,52,89,214                   // vmulps        %ymm14,%ymm9,%ymm2
  .byte  196,65,36,89,215                    // vmulps        %ymm15,%ymm11,%ymm10
  .byte  196,193,108,88,210                  // vaddps        %ymm10,%ymm2,%ymm2
  .byte  197,156,89,192                      // vmulps        %ymm0,%ymm12,%ymm0
  .byte  197,124,88,210                      // vaddps        %ymm2,%ymm0,%ymm10
  .byte  196,193,52,92,194                   // vsubps        %ymm10,%ymm9,%ymm0
  .byte  197,172,89,192                      // vmulps        %ymm0,%ymm10,%ymm0
  .byte  196,193,44,92,213                   // vsubps        %ymm13,%ymm10,%ymm2
  .byte  197,252,94,194                      // vdivps        %ymm2,%ymm0,%ymm0
  .byte  196,65,36,92,242                    // vsubps        %ymm10,%ymm11,%ymm14
  .byte  196,65,44,89,246                    // vmulps        %ymm14,%ymm10,%ymm14
  .byte  197,12,94,242                       // vdivps        %ymm2,%ymm14,%ymm14
  .byte  196,65,28,92,250                    // vsubps        %ymm10,%ymm12,%ymm15
  .byte  196,65,44,89,255                    // vmulps        %ymm15,%ymm10,%ymm15
  .byte  197,132,94,210                      // vdivps        %ymm2,%ymm15,%ymm2
  .byte  196,65,60,194,237,2                 // vcmpleps      %ymm13,%ymm8,%ymm13
  .byte  196,65,44,88,246                    // vaddps        %ymm14,%ymm10,%ymm14
  .byte  196,67,13,74,243,208                // vblendvps     %ymm13,%ymm11,%ymm14,%ymm14
  .byte  196,65,36,95,220                    // vmaxps        %ymm12,%ymm11,%ymm11
  .byte  197,172,88,210                      // vaddps        %ymm2,%ymm10,%ymm2
  .byte  196,195,109,74,212,208              // vblendvps     %ymm13,%ymm12,%ymm2,%ymm2
  .byte  197,172,88,192                      // vaddps        %ymm0,%ymm10,%ymm0
  .byte  196,195,125,74,193,208              // vblendvps     %ymm13,%ymm9,%ymm0,%ymm0
  .byte  197,100,89,231                      // vmulps        %ymm7,%ymm3,%ymm12
  .byte  196,65,52,95,203                    // vmaxps        %ymm11,%ymm9,%ymm9
  .byte  196,65,124,92,218                   // vsubps        %ymm10,%ymm0,%ymm11
  .byte  196,65,28,92,234                    // vsubps        %ymm10,%ymm12,%ymm13
  .byte  196,65,20,89,219                    // vmulps        %ymm11,%ymm13,%ymm11
  .byte  196,65,28,194,249,1                 // vcmpltps      %ymm9,%ymm12,%ymm15
  .byte  196,65,52,92,202                    // vsubps        %ymm10,%ymm9,%ymm9
  .byte  196,65,36,94,217                    // vdivps        %ymm9,%ymm11,%ymm11
  .byte  196,65,44,88,219                    // vaddps        %ymm11,%ymm10,%ymm11
  .byte  196,195,125,74,195,240              // vblendvps     %ymm15,%ymm11,%ymm0,%ymm0
  .byte  196,65,12,92,218                    // vsubps        %ymm10,%ymm14,%ymm11
  .byte  196,65,20,89,219                    // vmulps        %ymm11,%ymm13,%ymm11
  .byte  196,65,36,94,217                    // vdivps        %ymm9,%ymm11,%ymm11
  .byte  196,65,44,88,219                    // vaddps        %ymm11,%ymm10,%ymm11
  .byte  196,67,13,74,219,240                // vblendvps     %ymm15,%ymm11,%ymm14,%ymm11
  .byte  196,65,108,92,242                   // vsubps        %ymm10,%ymm2,%ymm14
  .byte  196,65,20,89,238                    // vmulps        %ymm14,%ymm13,%ymm13
  .byte  196,65,20,94,201                    // vdivps        %ymm9,%ymm13,%ymm9
  .byte  196,65,44,88,201                    // vaddps        %ymm9,%ymm10,%ymm9
  .byte  196,193,124,95,192                  // vmaxps        %ymm8,%ymm0,%ymm0
  .byte  196,65,36,95,208                    // vmaxps        %ymm8,%ymm11,%ymm10
  .byte  196,195,109,74,209,240              // vblendvps     %ymm15,%ymm9,%ymm2,%ymm2
  .byte  196,193,108,95,208                  // vmaxps        %ymm8,%ymm2,%ymm2
  .byte  196,98,125,24,5,187,149,2,0         // vbroadcastss  0x295bb(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,207                       // vsubps        %ymm7,%ymm8,%ymm9
  .byte  197,180,89,201                      // vmulps        %ymm1,%ymm9,%ymm1
  .byte  197,60,92,195                       // vsubps        %ymm3,%ymm8,%ymm8
  .byte  197,60,89,220                       // vmulps        %ymm4,%ymm8,%ymm11
  .byte  197,164,88,201                      // vaddps        %ymm1,%ymm11,%ymm1
  .byte  197,244,88,192                      // vaddps        %ymm0,%ymm1,%ymm0
  .byte  197,180,89,76,36,168                // vmulps        -0x58(%rsp),%ymm9,%ymm1
  .byte  197,60,89,221                       // vmulps        %ymm5,%ymm8,%ymm11
  .byte  197,164,88,201                      // vaddps        %ymm1,%ymm11,%ymm1
  .byte  196,193,116,88,202                  // vaddps        %ymm10,%ymm1,%ymm1
  .byte  197,52,89,76,36,200                 // vmulps        -0x38(%rsp),%ymm9,%ymm9
  .byte  197,60,89,198                       // vmulps        %ymm6,%ymm8,%ymm8
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  197,188,88,210                      // vaddps        %ymm2,%ymm8,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,92,220                  // vsubps        %ymm12,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_color_avx
.globl _sk_color_avx
FUNCTION(_sk_color_avx)
_sk_color_avx:
  .byte  197,252,17,84,36,136                // vmovups       %ymm2,-0x78(%rsp)
  .byte  197,252,17,76,36,200                // vmovups       %ymm1,-0x38(%rsp)
  .byte  197,252,17,68,36,168                // vmovups       %ymm0,-0x58(%rsp)
  .byte  197,124,89,199                      // vmulps        %ymm7,%ymm0,%ymm8
  .byte  197,116,89,207                      // vmulps        %ymm7,%ymm1,%ymm9
  .byte  196,98,125,24,45,109,149,2,0        // vbroadcastss  0x2956d(%rip),%ymm13        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,65,92,89,213                    // vmulps        %ymm13,%ymm4,%ymm10
  .byte  196,98,125,24,53,99,149,2,0         // vbroadcastss  0x29563(%rip),%ymm14        # 3a23c <_sk_srcover_bgra_8888_sse2_lowp+0x2d4>
  .byte  196,65,84,89,222                    // vmulps        %ymm14,%ymm5,%ymm11
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,98,125,24,61,84,149,2,0         // vbroadcastss  0x29554(%rip),%ymm15        # 3a240 <_sk_srcover_bgra_8888_sse2_lowp+0x2d8>
  .byte  196,65,76,89,223                    // vmulps        %ymm15,%ymm6,%ymm11
  .byte  196,193,44,88,195                   // vaddps        %ymm11,%ymm10,%ymm0
  .byte  196,65,60,89,221                    // vmulps        %ymm13,%ymm8,%ymm11
  .byte  196,65,52,89,230                    // vmulps        %ymm14,%ymm9,%ymm12
  .byte  196,65,36,88,220                    // vaddps        %ymm12,%ymm11,%ymm11
  .byte  197,108,89,231                      // vmulps        %ymm7,%ymm2,%ymm12
  .byte  196,65,28,89,215                    // vmulps        %ymm15,%ymm12,%ymm10
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  196,193,124,92,194                  // vsubps        %ymm10,%ymm0,%ymm0
  .byte  197,60,88,192                       // vaddps        %ymm0,%ymm8,%ymm8
  .byte  197,52,88,208                       // vaddps        %ymm0,%ymm9,%ymm10
  .byte  197,28,88,216                       // vaddps        %ymm0,%ymm12,%ymm11
  .byte  196,193,44,93,195                   // vminps        %ymm11,%ymm10,%ymm0
  .byte  197,60,93,224                       // vminps        %ymm0,%ymm8,%ymm12
  .byte  196,193,60,89,197                   // vmulps        %ymm13,%ymm8,%ymm0
  .byte  196,65,44,89,206                    // vmulps        %ymm14,%ymm10,%ymm9
  .byte  196,193,124,88,193                  // vaddps        %ymm9,%ymm0,%ymm0
  .byte  196,65,36,89,207                    // vmulps        %ymm15,%ymm11,%ymm9
  .byte  197,52,88,200                       // vaddps        %ymm0,%ymm9,%ymm9
  .byte  196,193,60,92,193                   // vsubps        %ymm9,%ymm8,%ymm0
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  196,65,52,92,236                    // vsubps        %ymm12,%ymm9,%ymm13
  .byte  196,193,124,94,197                  // vdivps        %ymm13,%ymm0,%ymm0
  .byte  196,65,44,92,241                    // vsubps        %ymm9,%ymm10,%ymm14
  .byte  196,65,52,89,246                    // vmulps        %ymm14,%ymm9,%ymm14
  .byte  196,65,12,94,245                    // vdivps        %ymm13,%ymm14,%ymm14
  .byte  196,65,36,92,249                    // vsubps        %ymm9,%ymm11,%ymm15
  .byte  196,65,52,89,255                    // vmulps        %ymm15,%ymm9,%ymm15
  .byte  196,65,4,94,237                     // vdivps        %ymm13,%ymm15,%ymm13
  .byte  196,65,4,87,255                     // vxorps        %ymm15,%ymm15,%ymm15
  .byte  196,65,4,194,228,2                  // vcmpleps      %ymm12,%ymm15,%ymm12
  .byte  196,65,52,88,246                    // vaddps        %ymm14,%ymm9,%ymm14
  .byte  196,67,13,74,242,192                // vblendvps     %ymm12,%ymm10,%ymm14,%ymm14
  .byte  196,65,44,95,211                    // vmaxps        %ymm11,%ymm10,%ymm10
  .byte  196,65,52,88,237                    // vaddps        %ymm13,%ymm9,%ymm13
  .byte  196,67,21,74,219,192                // vblendvps     %ymm12,%ymm11,%ymm13,%ymm11
  .byte  197,180,88,192                      // vaddps        %ymm0,%ymm9,%ymm0
  .byte  196,195,125,74,200,192              // vblendvps     %ymm12,%ymm8,%ymm0,%ymm1
  .byte  197,100,89,231                      // vmulps        %ymm7,%ymm3,%ymm12
  .byte  196,65,60,95,194                    // vmaxps        %ymm10,%ymm8,%ymm8
  .byte  196,65,116,92,209                   // vsubps        %ymm9,%ymm1,%ymm10
  .byte  196,65,28,92,233                    // vsubps        %ymm9,%ymm12,%ymm13
  .byte  196,65,20,89,210                    // vmulps        %ymm10,%ymm13,%ymm10
  .byte  196,193,28,194,192,1                // vcmpltps      %ymm8,%ymm12,%ymm0
  .byte  196,65,60,92,193                    // vsubps        %ymm9,%ymm8,%ymm8
  .byte  196,65,44,94,208                    // vdivps        %ymm8,%ymm10,%ymm10
  .byte  196,65,52,88,210                    // vaddps        %ymm10,%ymm9,%ymm10
  .byte  196,195,117,74,202,0                // vblendvps     %ymm0,%ymm10,%ymm1,%ymm1
  .byte  196,65,12,92,209                    // vsubps        %ymm9,%ymm14,%ymm10
  .byte  196,65,20,89,210                    // vmulps        %ymm10,%ymm13,%ymm10
  .byte  196,65,44,94,208                    // vdivps        %ymm8,%ymm10,%ymm10
  .byte  196,65,52,88,210                    // vaddps        %ymm10,%ymm9,%ymm10
  .byte  196,67,13,74,210,0                  // vblendvps     %ymm0,%ymm10,%ymm14,%ymm10
  .byte  196,65,36,92,241                    // vsubps        %ymm9,%ymm11,%ymm14
  .byte  196,65,20,89,238                    // vmulps        %ymm14,%ymm13,%ymm13
  .byte  196,65,20,94,192                    // vdivps        %ymm8,%ymm13,%ymm8
  .byte  196,65,52,88,192                    // vaddps        %ymm8,%ymm9,%ymm8
  .byte  196,193,116,95,207                  // vmaxps        %ymm15,%ymm1,%ymm1
  .byte  196,65,44,95,207                    // vmaxps        %ymm15,%ymm10,%ymm9
  .byte  196,195,37,74,192,0                 // vblendvps     %ymm0,%ymm8,%ymm11,%ymm0
  .byte  196,65,124,95,199                   // vmaxps        %ymm15,%ymm0,%ymm8
  .byte  196,226,125,24,5,239,147,2,0        // vbroadcastss  0x293ef(%rip),%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,124,92,215                      // vsubps        %ymm7,%ymm0,%ymm10
  .byte  197,172,89,84,36,168                // vmulps        -0x58(%rsp),%ymm10,%ymm2
  .byte  197,124,92,219                      // vsubps        %ymm3,%ymm0,%ymm11
  .byte  197,164,89,196                      // vmulps        %ymm4,%ymm11,%ymm0
  .byte  197,252,88,194                      // vaddps        %ymm2,%ymm0,%ymm0
  .byte  197,252,88,193                      // vaddps        %ymm1,%ymm0,%ymm0
  .byte  197,172,89,76,36,200                // vmulps        -0x38(%rsp),%ymm10,%ymm1
  .byte  197,164,89,213                      // vmulps        %ymm5,%ymm11,%ymm2
  .byte  197,236,88,201                      // vaddps        %ymm1,%ymm2,%ymm1
  .byte  196,193,116,88,201                  // vaddps        %ymm9,%ymm1,%ymm1
  .byte  197,172,89,84,36,136                // vmulps        -0x78(%rsp),%ymm10,%ymm2
  .byte  197,36,89,206                       // vmulps        %ymm6,%ymm11,%ymm9
  .byte  197,180,88,210                      // vaddps        %ymm2,%ymm9,%ymm2
  .byte  196,193,108,88,208                  // vaddps        %ymm8,%ymm2,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,92,220                  // vsubps        %ymm12,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_luminosity_avx
.globl _sk_luminosity_avx
FUNCTION(_sk_luminosity_avx)
_sk_luminosity_avx:
  .byte  197,124,40,226                      // vmovaps       %ymm2,%ymm12
  .byte  197,124,17,100,36,168               // vmovups       %ymm12,-0x58(%rsp)
  .byte  197,252,17,76,36,200                // vmovups       %ymm1,-0x38(%rsp)
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  197,100,89,196                      // vmulps        %ymm4,%ymm3,%ymm8
  .byte  197,100,89,205                      // vmulps        %ymm5,%ymm3,%ymm9
  .byte  196,98,125,24,45,157,147,2,0        // vbroadcastss  0x2939d(%rip),%ymm13        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,65,108,89,213                   // vmulps        %ymm13,%ymm2,%ymm10
  .byte  196,98,125,24,53,147,147,2,0        // vbroadcastss  0x29393(%rip),%ymm14        # 3a23c <_sk_srcover_bgra_8888_sse2_lowp+0x2d4>
  .byte  196,65,116,89,222                   // vmulps        %ymm14,%ymm1,%ymm11
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,98,125,24,61,132,147,2,0        // vbroadcastss  0x29384(%rip),%ymm15        # 3a240 <_sk_srcover_bgra_8888_sse2_lowp+0x2d8>
  .byte  196,65,28,89,223                    // vmulps        %ymm15,%ymm12,%ymm11
  .byte  196,193,44,88,195                   // vaddps        %ymm11,%ymm10,%ymm0
  .byte  196,65,60,89,221                    // vmulps        %ymm13,%ymm8,%ymm11
  .byte  196,65,52,89,230                    // vmulps        %ymm14,%ymm9,%ymm12
  .byte  196,65,36,88,220                    // vaddps        %ymm12,%ymm11,%ymm11
  .byte  197,100,89,230                      // vmulps        %ymm6,%ymm3,%ymm12
  .byte  196,65,28,89,215                    // vmulps        %ymm15,%ymm12,%ymm10
  .byte  196,65,36,88,210                    // vaddps        %ymm10,%ymm11,%ymm10
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  196,193,124,92,194                  // vsubps        %ymm10,%ymm0,%ymm0
  .byte  197,60,88,192                       // vaddps        %ymm0,%ymm8,%ymm8
  .byte  197,52,88,208                       // vaddps        %ymm0,%ymm9,%ymm10
  .byte  197,28,88,216                       // vaddps        %ymm0,%ymm12,%ymm11
  .byte  196,193,44,93,195                   // vminps        %ymm11,%ymm10,%ymm0
  .byte  197,60,93,224                       // vminps        %ymm0,%ymm8,%ymm12
  .byte  196,193,60,89,197                   // vmulps        %ymm13,%ymm8,%ymm0
  .byte  196,65,44,89,206                    // vmulps        %ymm14,%ymm10,%ymm9
  .byte  196,193,124,88,193                  // vaddps        %ymm9,%ymm0,%ymm0
  .byte  196,65,36,89,207                    // vmulps        %ymm15,%ymm11,%ymm9
  .byte  197,52,88,200                       // vaddps        %ymm0,%ymm9,%ymm9
  .byte  196,193,60,92,193                   // vsubps        %ymm9,%ymm8,%ymm0
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  196,65,52,92,236                    // vsubps        %ymm12,%ymm9,%ymm13
  .byte  196,193,124,94,197                  // vdivps        %ymm13,%ymm0,%ymm0
  .byte  196,65,44,92,241                    // vsubps        %ymm9,%ymm10,%ymm14
  .byte  196,65,52,89,246                    // vmulps        %ymm14,%ymm9,%ymm14
  .byte  196,65,12,94,245                    // vdivps        %ymm13,%ymm14,%ymm14
  .byte  196,65,36,92,249                    // vsubps        %ymm9,%ymm11,%ymm15
  .byte  196,65,52,89,255                    // vmulps        %ymm15,%ymm9,%ymm15
  .byte  196,65,4,94,237                     // vdivps        %ymm13,%ymm15,%ymm13
  .byte  196,65,4,87,255                     // vxorps        %ymm15,%ymm15,%ymm15
  .byte  196,65,4,194,228,2                  // vcmpleps      %ymm12,%ymm15,%ymm12
  .byte  196,65,52,88,246                    // vaddps        %ymm14,%ymm9,%ymm14
  .byte  196,67,13,74,242,192                // vblendvps     %ymm12,%ymm10,%ymm14,%ymm14
  .byte  196,65,44,95,211                    // vmaxps        %ymm11,%ymm10,%ymm10
  .byte  196,65,52,88,237                    // vaddps        %ymm13,%ymm9,%ymm13
  .byte  196,67,21,74,219,192                // vblendvps     %ymm12,%ymm11,%ymm13,%ymm11
  .byte  197,180,88,192                      // vaddps        %ymm0,%ymm9,%ymm0
  .byte  196,195,125,74,200,192              // vblendvps     %ymm12,%ymm8,%ymm0,%ymm1
  .byte  197,100,89,231                      // vmulps        %ymm7,%ymm3,%ymm12
  .byte  196,65,60,95,194                    // vmaxps        %ymm10,%ymm8,%ymm8
  .byte  196,65,116,92,209                   // vsubps        %ymm9,%ymm1,%ymm10
  .byte  196,65,28,92,233                    // vsubps        %ymm9,%ymm12,%ymm13
  .byte  196,65,20,89,210                    // vmulps        %ymm10,%ymm13,%ymm10
  .byte  196,193,28,194,192,1                // vcmpltps      %ymm8,%ymm12,%ymm0
  .byte  196,65,60,92,193                    // vsubps        %ymm9,%ymm8,%ymm8
  .byte  196,65,44,94,208                    // vdivps        %ymm8,%ymm10,%ymm10
  .byte  196,65,52,88,210                    // vaddps        %ymm10,%ymm9,%ymm10
  .byte  196,195,117,74,202,0                // vblendvps     %ymm0,%ymm10,%ymm1,%ymm1
  .byte  196,65,12,92,209                    // vsubps        %ymm9,%ymm14,%ymm10
  .byte  196,65,20,89,210                    // vmulps        %ymm10,%ymm13,%ymm10
  .byte  196,65,44,94,208                    // vdivps        %ymm8,%ymm10,%ymm10
  .byte  196,65,52,88,210                    // vaddps        %ymm10,%ymm9,%ymm10
  .byte  196,67,13,74,210,0                  // vblendvps     %ymm0,%ymm10,%ymm14,%ymm10
  .byte  196,65,36,92,241                    // vsubps        %ymm9,%ymm11,%ymm14
  .byte  196,65,20,89,238                    // vmulps        %ymm14,%ymm13,%ymm13
  .byte  196,65,20,94,192                    // vdivps        %ymm8,%ymm13,%ymm8
  .byte  196,65,52,88,192                    // vaddps        %ymm8,%ymm9,%ymm8
  .byte  196,193,116,95,207                  // vmaxps        %ymm15,%ymm1,%ymm1
  .byte  196,65,44,95,207                    // vmaxps        %ymm15,%ymm10,%ymm9
  .byte  196,195,37,74,192,0                 // vblendvps     %ymm0,%ymm8,%ymm11,%ymm0
  .byte  196,65,124,95,199                   // vmaxps        %ymm15,%ymm0,%ymm8
  .byte  196,226,125,24,5,31,146,2,0         // vbroadcastss  0x2921f(%rip),%ymm0        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,124,92,215                      // vsubps        %ymm7,%ymm0,%ymm10
  .byte  197,172,89,210                      // vmulps        %ymm2,%ymm10,%ymm2
  .byte  197,124,92,219                      // vsubps        %ymm3,%ymm0,%ymm11
  .byte  197,164,89,196                      // vmulps        %ymm4,%ymm11,%ymm0
  .byte  197,252,88,194                      // vaddps        %ymm2,%ymm0,%ymm0
  .byte  197,252,88,193                      // vaddps        %ymm1,%ymm0,%ymm0
  .byte  197,172,89,76,36,200                // vmulps        -0x38(%rsp),%ymm10,%ymm1
  .byte  197,164,89,213                      // vmulps        %ymm5,%ymm11,%ymm2
  .byte  197,236,88,201                      // vaddps        %ymm1,%ymm2,%ymm1
  .byte  196,193,116,88,201                  // vaddps        %ymm9,%ymm1,%ymm1
  .byte  197,172,89,84,36,168                // vmulps        -0x58(%rsp),%ymm10,%ymm2
  .byte  197,36,89,206                       // vmulps        %ymm6,%ymm11,%ymm9
  .byte  197,180,88,210                      // vaddps        %ymm2,%ymm9,%ymm2
  .byte  196,193,108,88,208                  // vaddps        %ymm8,%ymm2,%ymm2
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,92,220                  // vsubps        %ymm12,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_rgba_8888_avx
.globl _sk_srcover_rgba_8888_avx
FUNCTION(_sk_srcover_rgba_8888_avx)
_sk_srcover_rgba_8888_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,87,1,0,0                     // jne           111bb <_sk_srcover_rgba_8888_avx+0x177>
  .byte  196,1,125,16,12,152                 // vmovupd       (%r8,%r11,4),%ymm9
  .byte  197,125,40,5,238,150,2,0            // vmovapd       0x296ee(%rip),%ymm8        # 3a760 <_sk_srcover_bgra_8888_sse2_lowp+0x7f8>
  .byte  196,193,53,84,224                   // vandpd        %ymm8,%ymm9,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,193,81,114,209,8                // vpsrld        $0x8,%xmm9,%xmm5
  .byte  196,99,125,25,207,1                 // vextractf128  $0x1,%ymm9,%xmm7
  .byte  197,201,114,215,8                   // vpsrld        $0x8,%xmm7,%xmm6
  .byte  196,227,85,24,238,1                 // vinsertf128   $0x1,%xmm6,%ymm5,%ymm5
  .byte  196,193,85,84,232                   // vandpd        %ymm8,%ymm5,%ymm5
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  196,193,41,114,209,16               // vpsrld        $0x10,%xmm9,%xmm10
  .byte  197,201,114,215,16                  // vpsrld        $0x10,%xmm7,%xmm6
  .byte  196,227,45,24,246,1                 // vinsertf128   $0x1,%xmm6,%ymm10,%ymm6
  .byte  196,193,77,84,240                   // vandpd        %ymm8,%ymm6,%ymm6
  .byte  196,65,61,87,192                    // vxorpd        %ymm8,%ymm8,%ymm8
  .byte  197,252,91,246                      // vcvtdq2ps     %ymm6,%ymm6
  .byte  196,193,49,114,209,24               // vpsrld        $0x18,%xmm9,%xmm9
  .byte  197,193,114,215,24                  // vpsrld        $0x18,%xmm7,%xmm7
  .byte  196,227,53,24,255,1                 // vinsertf128   $0x1,%xmm7,%ymm9,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,98,125,24,13,64,145,2,0         // vbroadcastss  0x29140(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,52,92,211                       // vsubps        %ymm3,%ymm9,%ymm10
  .byte  196,98,125,24,13,95,145,2,0         // vbroadcastss  0x2915f(%rip),%ymm9        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,44,89,220                       // vmulps        %ymm4,%ymm10,%ymm11
  .byte  196,193,124,88,195                  // vaddps        %ymm11,%ymm0,%ymm0
  .byte  196,193,116,89,201                  // vmulps        %ymm9,%ymm1,%ymm1
  .byte  197,44,89,221                       // vmulps        %ymm5,%ymm10,%ymm11
  .byte  196,193,116,88,203                  // vaddps        %ymm11,%ymm1,%ymm1
  .byte  196,193,108,89,209                  // vmulps        %ymm9,%ymm2,%ymm2
  .byte  197,44,89,222                       // vmulps        %ymm6,%ymm10,%ymm11
  .byte  196,193,108,88,211                  // vaddps        %ymm11,%ymm2,%ymm2
  .byte  196,193,100,89,217                  // vmulps        %ymm9,%ymm3,%ymm3
  .byte  197,44,89,215                       // vmulps        %ymm7,%ymm10,%ymm10
  .byte  196,193,100,88,218                  // vaddps        %ymm10,%ymm3,%ymm3
  .byte  197,60,95,208                       // vmaxps        %ymm0,%ymm8,%ymm10
  .byte  196,65,44,93,209                    // vminps        %ymm9,%ymm10,%ymm10
  .byte  196,65,125,91,210                   // vcvtps2dq     %ymm10,%ymm10
  .byte  197,60,95,217                       // vmaxps        %ymm1,%ymm8,%ymm11
  .byte  196,65,36,93,217                    // vminps        %ymm9,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,193,25,114,243,8                // vpslld        $0x8,%xmm11,%xmm12
  .byte  196,67,125,25,219,1                 // vextractf128  $0x1,%ymm11,%xmm11
  .byte  196,193,33,114,243,8                // vpslld        $0x8,%xmm11,%xmm11
  .byte  196,67,29,24,219,1                  // vinsertf128   $0x1,%xmm11,%ymm12,%ymm11
  .byte  196,65,37,86,210                    // vorpd         %ymm10,%ymm11,%ymm10
  .byte  197,60,95,218                       // vmaxps        %ymm2,%ymm8,%ymm11
  .byte  196,65,36,93,217                    // vminps        %ymm9,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,193,25,114,243,16               // vpslld        $0x10,%xmm11,%xmm12
  .byte  196,67,125,25,219,1                 // vextractf128  $0x1,%ymm11,%xmm11
  .byte  196,193,33,114,243,16               // vpslld        $0x10,%xmm11,%xmm11
  .byte  196,67,29,24,219,1                  // vinsertf128   $0x1,%xmm11,%ymm12,%ymm11
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,193                    // vminps        %ymm9,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,193,49,114,240,24               // vpslld        $0x18,%xmm8,%xmm9
  .byte  196,67,125,25,192,1                 // vextractf128  $0x1,%ymm8,%xmm8
  .byte  196,193,57,114,240,24               // vpslld        $0x18,%xmm8,%xmm8
  .byte  196,67,53,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm9,%ymm8
  .byte  196,65,37,86,192                    // vorpd         %ymm8,%ymm11,%ymm8
  .byte  196,65,45,86,192                    // vorpd         %ymm8,%ymm10,%ymm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,66                              // jne           111f3 <_sk_srcover_rgba_8888_avx+0x1af>
  .byte  196,1,124,17,4,152                  // vmovups       %ymm8,(%r8,%r11,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,150,254,255,255              // ja            1106a <_sk_srcover_rgba_8888_avx+0x26>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,5,1,0,0                   // lea           0x105(%rip),%r10        # 112e4 <_sk_srcover_rgba_8888_avx+0x2a0>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,122,16,12,152                 // vmovss        (%r8,%r11,4),%xmm9
  .byte  233,119,254,255,255                 // jmpq          1106a <_sk_srcover_rgba_8888_avx+0x26>
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,180                             // ja            111b7 <_sk_srcover_rgba_8888_avx+0x173>
  .byte  65,15,182,193                       // movzbl        %r9b,%eax
  .byte  76,141,13,242,0,0,0                 // lea           0xf2(%rip),%r9        # 11300 <_sk_srcover_rgba_8888_avx+0x2bc>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,121,126,4,152                 // vmovd         %xmm8,(%r8,%r11,4)
  .byte  235,152                             // jmp           111b7 <_sk_srcover_rgba_8888_avx+0x173>
  .byte  196,129,121,110,100,152,8           // vmovd         0x8(%r8,%r11,4),%xmm4
  .byte  197,249,112,228,68                  // vpshufd       $0x44,%xmm4,%xmm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  196,99,85,12,204,4                  // vblendps      $0x4,%ymm4,%ymm5,%ymm9
  .byte  196,129,123,16,36,152               // vmovsd        (%r8,%r11,4),%xmm4
  .byte  196,99,53,13,204,1                  // vblendpd      $0x1,%ymm4,%ymm9,%ymm9
  .byte  233,36,254,255,255                  // jmpq          1106a <_sk_srcover_rgba_8888_avx+0x26>
  .byte  196,129,121,110,100,152,24          // vmovd         0x18(%r8,%r11,4),%xmm4
  .byte  197,249,112,228,68                  // vpshufd       $0x44,%xmm4,%xmm4
  .byte  196,227,125,24,228,1                // vinsertf128   $0x1,%xmm4,%ymm0,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  196,99,85,12,204,64                 // vblendps      $0x40,%ymm4,%ymm5,%ymm9
  .byte  196,99,125,25,204,1                 // vextractf128  $0x1,%ymm9,%xmm4
  .byte  196,131,89,34,100,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,99,53,24,204,1                  // vinsertf128   $0x1,%xmm4,%ymm9,%ymm9
  .byte  196,99,125,25,204,1                 // vextractf128  $0x1,%ymm9,%xmm4
  .byte  196,131,89,34,100,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,99,53,24,204,1                  // vinsertf128   $0x1,%xmm4,%ymm9,%ymm9
  .byte  196,129,121,16,36,152               // vmovupd       (%r8,%r11,4),%xmm4
  .byte  196,67,93,13,201,12                 // vblendpd      $0xc,%ymm9,%ymm4,%ymm9
  .byte  233,207,253,255,255                 // jmpq          1106a <_sk_srcover_rgba_8888_avx+0x26>
  .byte  196,3,121,22,68,152,8,2             // vpextrd       $0x2,%xmm8,0x8(%r8,%r11,4)
  .byte  196,1,121,214,4,152                 // vmovq         %xmm8,(%r8,%r11,4)
  .byte  233,9,255,255,255                   // jmpq          111b7 <_sk_srcover_rgba_8888_avx+0x173>
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,24,2            // vpextrd       $0x2,%xmm9,0x18(%r8,%r11,4)
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,20,1            // vpextrd       $0x1,%xmm9,0x14(%r8,%r11,4)
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,1,121,126,76,152,16             // vmovd         %xmm9,0x10(%r8,%r11,4)
  .byte  196,1,121,17,4,152                  // vmovupd       %xmm8,(%r8,%r11,4)
  .byte  233,213,254,255,255                 // jmpq          111b7 <_sk_srcover_rgba_8888_avx+0x173>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  4,255                               // add           $0xff,%al
  .byte  255                                 // (bad)
  .byte  255,81,255                          // callq         *-0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  59,255                              // cmp           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,166,255,255,255,146             // jmpq          *-0x6d000001(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  126,255                             // jle           112f9 <_sk_srcover_rgba_8888_avx+0x2b5>
  .byte  255                                 // (bad)
  .byte  255,98,255                          // jmpq          *-0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,23                              // callq         *(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,163,255,255,255,155             // jmpq          *-0x64000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,215                             // callq         *%rdi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,202                             // dec           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  188,255,255,255,174                 // mov           $0xaeffffff,%esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_srcover_bgra_8888_avx
.globl _sk_srcover_bgra_8888_avx
FUNCTION(_sk_srcover_bgra_8888_avx)
_sk_srcover_bgra_8888_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,87,1,0,0                     // jne           11493 <_sk_srcover_bgra_8888_avx+0x177>
  .byte  196,1,125,16,12,152                 // vmovupd       (%r8,%r11,4),%ymm9
  .byte  197,125,40,5,54,148,2,0             // vmovapd       0x29436(%rip),%ymm8        # 3a780 <_sk_srcover_bgra_8888_sse2_lowp+0x818>
  .byte  196,193,53,84,232                   // vandpd        %ymm8,%ymm9,%ymm5
  .byte  197,252,91,245                      // vcvtdq2ps     %ymm5,%ymm6
  .byte  196,193,81,114,209,8                // vpsrld        $0x8,%xmm9,%xmm5
  .byte  196,99,125,25,207,1                 // vextractf128  $0x1,%ymm9,%xmm7
  .byte  197,217,114,215,8                   // vpsrld        $0x8,%xmm7,%xmm4
  .byte  196,227,85,24,228,1                 // vinsertf128   $0x1,%xmm4,%ymm5,%ymm4
  .byte  196,193,93,84,224                   // vandpd        %ymm8,%ymm4,%ymm4
  .byte  197,252,91,236                      // vcvtdq2ps     %ymm4,%ymm5
  .byte  196,193,41,114,209,16               // vpsrld        $0x10,%xmm9,%xmm10
  .byte  197,217,114,215,16                  // vpsrld        $0x10,%xmm7,%xmm4
  .byte  196,227,45,24,228,1                 // vinsertf128   $0x1,%xmm4,%ymm10,%ymm4
  .byte  196,193,93,84,224                   // vandpd        %ymm8,%ymm4,%ymm4
  .byte  196,65,61,87,192                    // vxorpd        %ymm8,%ymm8,%ymm8
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,193,49,114,209,24               // vpsrld        $0x18,%xmm9,%xmm9
  .byte  197,193,114,215,24                  // vpsrld        $0x18,%xmm7,%xmm7
  .byte  196,227,53,24,255,1                 // vinsertf128   $0x1,%xmm7,%ymm9,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,98,125,24,13,104,142,2,0        // vbroadcastss  0x28e68(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,52,92,211                       // vsubps        %ymm3,%ymm9,%ymm10
  .byte  196,98,125,24,13,135,142,2,0        // vbroadcastss  0x28e87(%rip),%ymm9        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,44,89,220                       // vmulps        %ymm4,%ymm10,%ymm11
  .byte  196,193,124,88,195                  // vaddps        %ymm11,%ymm0,%ymm0
  .byte  196,193,116,89,201                  // vmulps        %ymm9,%ymm1,%ymm1
  .byte  197,44,89,221                       // vmulps        %ymm5,%ymm10,%ymm11
  .byte  196,193,116,88,203                  // vaddps        %ymm11,%ymm1,%ymm1
  .byte  196,193,108,89,209                  // vmulps        %ymm9,%ymm2,%ymm2
  .byte  197,44,89,222                       // vmulps        %ymm6,%ymm10,%ymm11
  .byte  196,193,108,88,211                  // vaddps        %ymm11,%ymm2,%ymm2
  .byte  196,193,100,89,217                  // vmulps        %ymm9,%ymm3,%ymm3
  .byte  197,44,89,215                       // vmulps        %ymm7,%ymm10,%ymm10
  .byte  196,193,100,88,218                  // vaddps        %ymm10,%ymm3,%ymm3
  .byte  197,60,95,210                       // vmaxps        %ymm2,%ymm8,%ymm10
  .byte  196,65,44,93,209                    // vminps        %ymm9,%ymm10,%ymm10
  .byte  196,65,125,91,210                   // vcvtps2dq     %ymm10,%ymm10
  .byte  197,60,95,217                       // vmaxps        %ymm1,%ymm8,%ymm11
  .byte  196,65,36,93,217                    // vminps        %ymm9,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,193,25,114,243,8                // vpslld        $0x8,%xmm11,%xmm12
  .byte  196,67,125,25,219,1                 // vextractf128  $0x1,%ymm11,%xmm11
  .byte  196,193,33,114,243,8                // vpslld        $0x8,%xmm11,%xmm11
  .byte  196,67,29,24,219,1                  // vinsertf128   $0x1,%xmm11,%ymm12,%ymm11
  .byte  196,65,37,86,210                    // vorpd         %ymm10,%ymm11,%ymm10
  .byte  197,60,95,216                       // vmaxps        %ymm0,%ymm8,%ymm11
  .byte  196,65,36,93,217                    // vminps        %ymm9,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,193,25,114,243,16               // vpslld        $0x10,%xmm11,%xmm12
  .byte  196,67,125,25,219,1                 // vextractf128  $0x1,%ymm11,%xmm11
  .byte  196,193,33,114,243,16               // vpslld        $0x10,%xmm11,%xmm11
  .byte  196,67,29,24,219,1                  // vinsertf128   $0x1,%xmm11,%ymm12,%ymm11
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,193                    // vminps        %ymm9,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,193,49,114,240,24               // vpslld        $0x18,%xmm8,%xmm9
  .byte  196,67,125,25,192,1                 // vextractf128  $0x1,%ymm8,%xmm8
  .byte  196,193,57,114,240,24               // vpslld        $0x18,%xmm8,%xmm8
  .byte  196,67,53,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm9,%ymm8
  .byte  196,65,37,86,192                    // vorpd         %ymm8,%ymm11,%ymm8
  .byte  196,65,45,86,192                    // vorpd         %ymm8,%ymm10,%ymm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,66                              // jne           114cb <_sk_srcover_bgra_8888_avx+0x1af>
  .byte  196,1,124,17,4,152                  // vmovups       %ymm8,(%r8,%r11,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,150,254,255,255              // ja            11342 <_sk_srcover_bgra_8888_avx+0x26>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,5,1,0,0                   // lea           0x105(%rip),%r10        # 115bc <_sk_srcover_bgra_8888_avx+0x2a0>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,122,16,12,152                 // vmovss        (%r8,%r11,4),%xmm9
  .byte  233,119,254,255,255                 // jmpq          11342 <_sk_srcover_bgra_8888_avx+0x26>
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,180                             // ja            1148f <_sk_srcover_bgra_8888_avx+0x173>
  .byte  65,15,182,193                       // movzbl        %r9b,%eax
  .byte  76,141,13,242,0,0,0                 // lea           0xf2(%rip),%r9        # 115d8 <_sk_srcover_bgra_8888_avx+0x2bc>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,121,126,4,152                 // vmovd         %xmm8,(%r8,%r11,4)
  .byte  235,152                             // jmp           1148f <_sk_srcover_bgra_8888_avx+0x173>
  .byte  196,129,121,110,100,152,8           // vmovd         0x8(%r8,%r11,4),%xmm4
  .byte  197,249,112,228,68                  // vpshufd       $0x44,%xmm4,%xmm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  196,99,85,12,204,4                  // vblendps      $0x4,%ymm4,%ymm5,%ymm9
  .byte  196,129,123,16,36,152               // vmovsd        (%r8,%r11,4),%xmm4
  .byte  196,99,53,13,204,1                  // vblendpd      $0x1,%ymm4,%ymm9,%ymm9
  .byte  233,36,254,255,255                  // jmpq          11342 <_sk_srcover_bgra_8888_avx+0x26>
  .byte  196,129,121,110,100,152,24          // vmovd         0x18(%r8,%r11,4),%xmm4
  .byte  197,249,112,228,68                  // vpshufd       $0x44,%xmm4,%xmm4
  .byte  196,227,125,24,228,1                // vinsertf128   $0x1,%xmm4,%ymm0,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  196,99,85,12,204,64                 // vblendps      $0x40,%ymm4,%ymm5,%ymm9
  .byte  196,99,125,25,204,1                 // vextractf128  $0x1,%ymm9,%xmm4
  .byte  196,131,89,34,100,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,99,53,24,204,1                  // vinsertf128   $0x1,%xmm4,%ymm9,%ymm9
  .byte  196,99,125,25,204,1                 // vextractf128  $0x1,%ymm9,%xmm4
  .byte  196,131,89,34,100,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,99,53,24,204,1                  // vinsertf128   $0x1,%xmm4,%ymm9,%ymm9
  .byte  196,129,121,16,36,152               // vmovupd       (%r8,%r11,4),%xmm4
  .byte  196,67,93,13,201,12                 // vblendpd      $0xc,%ymm9,%ymm4,%ymm9
  .byte  233,207,253,255,255                 // jmpq          11342 <_sk_srcover_bgra_8888_avx+0x26>
  .byte  196,3,121,22,68,152,8,2             // vpextrd       $0x2,%xmm8,0x8(%r8,%r11,4)
  .byte  196,1,121,214,4,152                 // vmovq         %xmm8,(%r8,%r11,4)
  .byte  233,9,255,255,255                   // jmpq          1148f <_sk_srcover_bgra_8888_avx+0x173>
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,24,2            // vpextrd       $0x2,%xmm9,0x18(%r8,%r11,4)
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,20,1            // vpextrd       $0x1,%xmm9,0x14(%r8,%r11,4)
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,1,121,126,76,152,16             // vmovd         %xmm9,0x10(%r8,%r11,4)
  .byte  196,1,121,17,4,152                  // vmovupd       %xmm8,(%r8,%r11,4)
  .byte  233,213,254,255,255                 // jmpq          1148f <_sk_srcover_bgra_8888_avx+0x173>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  4,255                               // add           $0xff,%al
  .byte  255                                 // (bad)
  .byte  255,81,255                          // callq         *-0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  59,255                              // cmp           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,166,255,255,255,146             // jmpq          *-0x6d000001(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  126,255                             // jle           115d1 <_sk_srcover_bgra_8888_avx+0x2b5>
  .byte  255                                 // (bad)
  .byte  255,98,255                          // jmpq          *-0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,23                              // callq         *(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,163,255,255,255,155             // jmpq          *-0x64000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,215                             // callq         *%rdi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,202                             // dec           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  188,255,255,255,174                 // mov           $0xaeffffff,%esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_clamp_0_avx
.globl _sk_clamp_0_avx
FUNCTION(_sk_clamp_0_avx)
_sk_clamp_0_avx:
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,193,124,95,192                  // vmaxps        %ymm8,%ymm0,%ymm0
  .byte  196,193,116,95,200                  // vmaxps        %ymm8,%ymm1,%ymm1
  .byte  196,193,108,95,208                  // vmaxps        %ymm8,%ymm2,%ymm2
  .byte  196,193,100,95,216                  // vmaxps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_1_avx
.globl _sk_clamp_1_avx
FUNCTION(_sk_clamp_1_avx)
_sk_clamp_1_avx:
  .byte  196,98,125,24,5,254,139,2,0         // vbroadcastss  0x28bfe(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  196,193,108,93,208                  // vminps        %ymm8,%ymm2,%ymm2
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_avx
.globl _sk_clamp_a_avx
FUNCTION(_sk_clamp_a_avx)
_sk_clamp_a_avx:
  .byte  196,98,125,24,5,221,139,2,0         // vbroadcastss  0x28bdd(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  197,252,93,195                      // vminps        %ymm3,%ymm0,%ymm0
  .byte  197,244,93,203                      // vminps        %ymm3,%ymm1,%ymm1
  .byte  197,236,93,211                      // vminps        %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_dst_avx
.globl _sk_clamp_a_dst_avx
FUNCTION(_sk_clamp_a_dst_avx)
_sk_clamp_a_dst_avx:
  .byte  196,98,125,24,5,191,139,2,0         // vbroadcastss  0x28bbf(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,68,93,248                   // vminps        %ymm8,%ymm7,%ymm7
  .byte  197,220,93,231                      // vminps        %ymm7,%ymm4,%ymm4
  .byte  197,212,93,239                      // vminps        %ymm7,%ymm5,%ymm5
  .byte  197,204,93,247                      // vminps        %ymm7,%ymm6,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_set_rgb_avx
.globl _sk_set_rgb_avx
FUNCTION(_sk_set_rgb_avx)
_sk_set_rgb_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,0                    // vbroadcastss  (%rax),%ymm0
  .byte  196,226,125,24,72,4                 // vbroadcastss  0x4(%rax),%ymm1
  .byte  196,226,125,24,80,8                 // vbroadcastss  0x8(%rax),%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_swap_rb_avx
.globl _sk_swap_rb_avx
FUNCTION(_sk_swap_rb_avx)
_sk_swap_rb_avx:
  .byte  197,124,40,192                      // vmovaps       %ymm0,%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,194                      // vmovaps       %ymm2,%ymm0
  .byte  197,124,41,194                      // vmovaps       %ymm8,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_invert_avx
.globl _sk_invert_avx
FUNCTION(_sk_invert_avx)
_sk_invert_avx:
  .byte  196,98,125,24,5,122,139,2,0         // vbroadcastss  0x28b7a(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,188,92,192                      // vsubps        %ymm0,%ymm8,%ymm0
  .byte  197,188,92,201                      // vsubps        %ymm1,%ymm8,%ymm1
  .byte  197,188,92,210                      // vsubps        %ymm2,%ymm8,%ymm2
  .byte  197,188,92,219                      // vsubps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_src_dst_avx
.globl _sk_move_src_dst_avx
FUNCTION(_sk_move_src_dst_avx)
_sk_move_src_dst_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,224                      // vmovaps       %ymm0,%ymm4
  .byte  197,252,40,233                      // vmovaps       %ymm1,%ymm5
  .byte  197,252,40,242                      // vmovaps       %ymm2,%ymm6
  .byte  197,252,40,251                      // vmovaps       %ymm3,%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_dst_src_avx
.globl _sk_move_dst_src_avx
FUNCTION(_sk_move_dst_src_avx)
_sk_move_dst_src_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,196                      // vmovaps       %ymm4,%ymm0
  .byte  197,252,40,205                      // vmovaps       %ymm5,%ymm1
  .byte  197,252,40,214                      // vmovaps       %ymm6,%ymm2
  .byte  197,252,40,223                      // vmovaps       %ymm7,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_avx
.globl _sk_premul_avx
FUNCTION(_sk_premul_avx)
_sk_premul_avx:
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  197,244,89,203                      // vmulps        %ymm3,%ymm1,%ymm1
  .byte  197,236,89,211                      // vmulps        %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_dst_avx
.globl _sk_premul_dst_avx
FUNCTION(_sk_premul_dst_avx)
_sk_premul_dst_avx:
  .byte  197,220,89,231                      // vmulps        %ymm7,%ymm4,%ymm4
  .byte  197,212,89,239                      // vmulps        %ymm7,%ymm5,%ymm5
  .byte  197,204,89,247                      // vmulps        %ymm7,%ymm6,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_unpremul_avx
.globl _sk_unpremul_avx
FUNCTION(_sk_unpremul_avx)
_sk_unpremul_avx:
  .byte  196,98,125,24,5,21,139,2,0          // vbroadcastss  0x28b15(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,94,195                       // vdivps        %ymm3,%ymm8,%ymm8
  .byte  196,98,125,24,13,56,139,2,0         // vbroadcastss  0x28b38(%rip),%ymm9        # 3a248 <_sk_srcover_bgra_8888_sse2_lowp+0x2e0>
  .byte  196,65,60,194,201,1                 // vcmpltps      %ymm9,%ymm8,%ymm9
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,67,45,74,192,144                // vblendvps     %ymm9,%ymm8,%ymm10,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_from_srgb_avx
.globl _sk_from_srgb_avx
FUNCTION(_sk_from_srgb_avx)
_sk_from_srgb_avx:
  .byte  196,98,125,24,5,18,139,2,0          // vbroadcastss  0x28b12(%rip),%ymm8        # 3a24c <_sk_srcover_bgra_8888_sse2_lowp+0x2e4>
  .byte  196,65,124,89,200                   // vmulps        %ymm8,%ymm0,%ymm9
  .byte  197,124,89,208                      // vmulps        %ymm0,%ymm0,%ymm10
  .byte  196,98,125,24,29,236,138,2,0        // vbroadcastss  0x28aec(%rip),%ymm11        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,65,124,89,227                   // vmulps        %ymm11,%ymm0,%ymm12
  .byte  196,98,125,24,45,246,138,2,0        // vbroadcastss  0x28af6(%rip),%ymm13        # 3a250 <_sk_srcover_bgra_8888_sse2_lowp+0x2e8>
  .byte  196,65,28,88,229                    // vaddps        %ymm13,%ymm12,%ymm12
  .byte  196,65,44,89,212                    // vmulps        %ymm12,%ymm10,%ymm10
  .byte  196,98,125,24,37,231,138,2,0        // vbroadcastss  0x28ae7(%rip),%ymm12        # 3a254 <_sk_srcover_bgra_8888_sse2_lowp+0x2ec>
  .byte  196,65,44,88,212                    // vaddps        %ymm12,%ymm10,%ymm10
  .byte  196,98,125,24,53,221,138,2,0        // vbroadcastss  0x28add(%rip),%ymm14        # 3a258 <_sk_srcover_bgra_8888_sse2_lowp+0x2f0>
  .byte  196,193,124,194,198,1               // vcmpltps      %ymm14,%ymm0,%ymm0
  .byte  196,195,45,74,193,0                 // vblendvps     %ymm0,%ymm9,%ymm10,%ymm0
  .byte  196,65,116,89,200                   // vmulps        %ymm8,%ymm1,%ymm9
  .byte  197,116,89,209                      // vmulps        %ymm1,%ymm1,%ymm10
  .byte  196,65,116,89,251                   // vmulps        %ymm11,%ymm1,%ymm15
  .byte  196,65,4,88,253                     // vaddps        %ymm13,%ymm15,%ymm15
  .byte  196,65,44,89,215                    // vmulps        %ymm15,%ymm10,%ymm10
  .byte  196,65,44,88,212                    // vaddps        %ymm12,%ymm10,%ymm10
  .byte  196,193,116,194,206,1               // vcmpltps      %ymm14,%ymm1,%ymm1
  .byte  196,195,45,74,201,16                // vblendvps     %ymm1,%ymm9,%ymm10,%ymm1
  .byte  196,65,108,89,192                   // vmulps        %ymm8,%ymm2,%ymm8
  .byte  197,108,89,202                      // vmulps        %ymm2,%ymm2,%ymm9
  .byte  196,65,108,89,211                   // vmulps        %ymm11,%ymm2,%ymm10
  .byte  196,65,44,88,213                    // vaddps        %ymm13,%ymm10,%ymm10
  .byte  196,65,52,89,202                    // vmulps        %ymm10,%ymm9,%ymm9
  .byte  196,65,52,88,204                    // vaddps        %ymm12,%ymm9,%ymm9
  .byte  196,193,108,194,214,1               // vcmpltps      %ymm14,%ymm2,%ymm2
  .byte  196,195,53,74,208,32                // vblendvps     %ymm2,%ymm8,%ymm9,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_from_srgb_dst_avx
.globl _sk_from_srgb_dst_avx
FUNCTION(_sk_from_srgb_dst_avx)
_sk_from_srgb_dst_avx:
  .byte  196,98,125,24,5,102,138,2,0         // vbroadcastss  0x28a66(%rip),%ymm8        # 3a24c <_sk_srcover_bgra_8888_sse2_lowp+0x2e4>
  .byte  196,65,92,89,200                    // vmulps        %ymm8,%ymm4,%ymm9
  .byte  197,92,89,212                       // vmulps        %ymm4,%ymm4,%ymm10
  .byte  196,98,125,24,29,64,138,2,0         // vbroadcastss  0x28a40(%rip),%ymm11        # 3a238 <_sk_srcover_bgra_8888_sse2_lowp+0x2d0>
  .byte  196,65,92,89,227                    // vmulps        %ymm11,%ymm4,%ymm12
  .byte  196,98,125,24,45,74,138,2,0         // vbroadcastss  0x28a4a(%rip),%ymm13        # 3a250 <_sk_srcover_bgra_8888_sse2_lowp+0x2e8>
  .byte  196,65,28,88,229                    // vaddps        %ymm13,%ymm12,%ymm12
  .byte  196,65,44,89,212                    // vmulps        %ymm12,%ymm10,%ymm10
  .byte  196,98,125,24,37,59,138,2,0         // vbroadcastss  0x28a3b(%rip),%ymm12        # 3a254 <_sk_srcover_bgra_8888_sse2_lowp+0x2ec>
  .byte  196,65,44,88,212                    // vaddps        %ymm12,%ymm10,%ymm10
  .byte  196,98,125,24,53,49,138,2,0         // vbroadcastss  0x28a31(%rip),%ymm14        # 3a258 <_sk_srcover_bgra_8888_sse2_lowp+0x2f0>
  .byte  196,193,92,194,230,1                // vcmpltps      %ymm14,%ymm4,%ymm4
  .byte  196,195,45,74,225,64                // vblendvps     %ymm4,%ymm9,%ymm10,%ymm4
  .byte  196,65,84,89,200                    // vmulps        %ymm8,%ymm5,%ymm9
  .byte  197,84,89,213                       // vmulps        %ymm5,%ymm5,%ymm10
  .byte  196,65,84,89,251                    // vmulps        %ymm11,%ymm5,%ymm15
  .byte  196,65,4,88,253                     // vaddps        %ymm13,%ymm15,%ymm15
  .byte  196,65,44,89,215                    // vmulps        %ymm15,%ymm10,%ymm10
  .byte  196,65,44,88,212                    // vaddps        %ymm12,%ymm10,%ymm10
  .byte  196,193,84,194,238,1                // vcmpltps      %ymm14,%ymm5,%ymm5
  .byte  196,195,45,74,233,80                // vblendvps     %ymm5,%ymm9,%ymm10,%ymm5
  .byte  196,65,76,89,192                    // vmulps        %ymm8,%ymm6,%ymm8
  .byte  197,76,89,206                       // vmulps        %ymm6,%ymm6,%ymm9
  .byte  196,65,76,89,211                    // vmulps        %ymm11,%ymm6,%ymm10
  .byte  196,65,44,88,213                    // vaddps        %ymm13,%ymm10,%ymm10
  .byte  196,65,52,89,202                    // vmulps        %ymm10,%ymm9,%ymm9
  .byte  196,65,52,88,204                    // vaddps        %ymm12,%ymm9,%ymm9
  .byte  196,193,76,194,246,1                // vcmpltps      %ymm14,%ymm6,%ymm6
  .byte  196,195,53,74,240,96                // vblendvps     %ymm6,%ymm8,%ymm9,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_to_srgb_avx
.globl _sk_to_srgb_avx
FUNCTION(_sk_to_srgb_avx)
_sk_to_srgb_avx:
  .byte  197,124,82,200                      // vrsqrtps      %ymm0,%ymm9
  .byte  196,98,125,24,5,198,137,2,0         // vbroadcastss  0x289c6(%rip),%ymm8        # 3a25c <_sk_srcover_bgra_8888_sse2_lowp+0x2f4>
  .byte  196,65,124,89,208                   // vmulps        %ymm8,%ymm0,%ymm10
  .byte  196,98,125,24,29,192,137,2,0        // vbroadcastss  0x289c0(%rip),%ymm11        # 3a264 <_sk_srcover_bgra_8888_sse2_lowp+0x2fc>
  .byte  196,65,52,89,227                    // vmulps        %ymm11,%ymm9,%ymm12
  .byte  196,98,125,24,45,174,137,2,0        // vbroadcastss  0x289ae(%rip),%ymm13        # 3a260 <_sk_srcover_bgra_8888_sse2_lowp+0x2f8>
  .byte  196,65,28,88,229                    // vaddps        %ymm13,%ymm12,%ymm12
  .byte  196,65,52,89,228                    // vmulps        %ymm12,%ymm9,%ymm12
  .byte  196,98,125,24,53,211,138,2,0        // vbroadcastss  0x28ad3(%rip),%ymm14        # 3a398 <_sk_srcover_bgra_8888_sse2_lowp+0x430>
  .byte  196,65,28,88,230                    // vaddps        %ymm14,%ymm12,%ymm12
  .byte  196,98,125,24,61,201,138,2,0        // vbroadcastss  0x28ac9(%rip),%ymm15        # 3a39c <_sk_srcover_bgra_8888_sse2_lowp+0x434>
  .byte  196,65,52,88,207                    // vaddps        %ymm15,%ymm9,%ymm9
  .byte  196,65,124,83,201                   // vrcpps        %ymm9,%ymm9
  .byte  196,65,52,89,204                    // vmulps        %ymm12,%ymm9,%ymm9
  .byte  196,98,125,24,37,133,137,2,0        // vbroadcastss  0x28985(%rip),%ymm12        # 3a270 <_sk_srcover_bgra_8888_sse2_lowp+0x308>
  .byte  196,193,124,194,196,1               // vcmpltps      %ymm12,%ymm0,%ymm0
  .byte  196,195,53,74,194,0                 // vblendvps     %ymm0,%ymm10,%ymm9,%ymm0
  .byte  197,124,82,201                      // vrsqrtps      %ymm1,%ymm9
  .byte  196,65,52,89,211                    // vmulps        %ymm11,%ymm9,%ymm10
  .byte  196,65,44,88,213                    // vaddps        %ymm13,%ymm10,%ymm10
  .byte  196,65,52,89,210                    // vmulps        %ymm10,%ymm9,%ymm10
  .byte  196,65,44,88,214                    // vaddps        %ymm14,%ymm10,%ymm10
  .byte  196,65,52,88,207                    // vaddps        %ymm15,%ymm9,%ymm9
  .byte  196,65,124,83,201                   // vrcpps        %ymm9,%ymm9
  .byte  196,65,52,89,202                    // vmulps        %ymm10,%ymm9,%ymm9
  .byte  196,65,116,89,208                   // vmulps        %ymm8,%ymm1,%ymm10
  .byte  196,193,116,194,204,1               // vcmpltps      %ymm12,%ymm1,%ymm1
  .byte  196,195,53,74,202,16                // vblendvps     %ymm1,%ymm10,%ymm9,%ymm1
  .byte  197,124,82,202                      // vrsqrtps      %ymm2,%ymm9
  .byte  196,65,52,89,211                    // vmulps        %ymm11,%ymm9,%ymm10
  .byte  196,65,44,88,213                    // vaddps        %ymm13,%ymm10,%ymm10
  .byte  196,65,52,89,210                    // vmulps        %ymm10,%ymm9,%ymm10
  .byte  196,65,44,88,214                    // vaddps        %ymm14,%ymm10,%ymm10
  .byte  196,65,52,88,207                    // vaddps        %ymm15,%ymm9,%ymm9
  .byte  196,65,124,83,201                   // vrcpps        %ymm9,%ymm9
  .byte  196,65,52,89,202                    // vmulps        %ymm10,%ymm9,%ymm9
  .byte  196,65,108,89,192                   // vmulps        %ymm8,%ymm2,%ymm8
  .byte  196,193,108,194,212,1               // vcmpltps      %ymm12,%ymm2,%ymm2
  .byte  196,195,53,74,208,32                // vblendvps     %ymm2,%ymm8,%ymm9,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_rgb_to_hsl_avx
.globl _sk_rgb_to_hsl_avx
FUNCTION(_sk_rgb_to_hsl_avx)
_sk_rgb_to_hsl_avx:
  .byte  197,116,95,194                      // vmaxps        %ymm2,%ymm1,%ymm8
  .byte  196,65,124,95,192                   // vmaxps        %ymm8,%ymm0,%ymm8
  .byte  197,116,93,202                      // vminps        %ymm2,%ymm1,%ymm9
  .byte  196,65,124,93,201                   // vminps        %ymm9,%ymm0,%ymm9
  .byte  196,65,60,92,209                    // vsubps        %ymm9,%ymm8,%ymm10
  .byte  196,98,125,24,29,141,136,2,0        // vbroadcastss  0x2888d(%rip),%ymm11        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,36,94,218                    // vdivps        %ymm10,%ymm11,%ymm11
  .byte  197,116,92,226                      // vsubps        %ymm2,%ymm1,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  197,116,194,234,1                   // vcmpltps      %ymm2,%ymm1,%ymm13
  .byte  197,60,194,241,0                    // vcmpeqps      %ymm1,%ymm8,%ymm14
  .byte  197,236,92,208                      // vsubps        %ymm0,%ymm2,%ymm2
  .byte  196,193,108,89,211                  // vmulps        %ymm11,%ymm2,%ymm2
  .byte  197,252,92,201                      // vsubps        %ymm1,%ymm0,%ymm1
  .byte  196,193,116,89,203                  // vmulps        %ymm11,%ymm1,%ymm1
  .byte  196,98,125,24,29,190,136,2,0        // vbroadcastss  0x288be(%rip),%ymm11        # 3a27c <_sk_srcover_bgra_8888_sse2_lowp+0x314>
  .byte  196,193,116,88,203                  // vaddps        %ymm11,%ymm1,%ymm1
  .byte  196,98,125,24,29,172,136,2,0        // vbroadcastss  0x288ac(%rip),%ymm11        # 3a278 <_sk_srcover_bgra_8888_sse2_lowp+0x310>
  .byte  196,193,108,88,211                  // vaddps        %ymm11,%ymm2,%ymm2
  .byte  196,227,117,74,202,224              // vblendvps     %ymm14,%ymm2,%ymm1,%ymm1
  .byte  196,226,125,24,21,148,136,2,0       // vbroadcastss  0x28894(%rip),%ymm2        # 3a274 <_sk_srcover_bgra_8888_sse2_lowp+0x30c>
  .byte  196,65,12,87,246                    // vxorps        %ymm14,%ymm14,%ymm14
  .byte  196,227,13,74,210,208               // vblendvps     %ymm13,%ymm2,%ymm14,%ymm2
  .byte  197,188,194,192,0                   // vcmpeqps      %ymm0,%ymm8,%ymm0
  .byte  196,193,108,88,212                  // vaddps        %ymm12,%ymm2,%ymm2
  .byte  196,227,117,74,194,0                // vblendvps     %ymm0,%ymm2,%ymm1,%ymm0
  .byte  196,193,60,88,201                   // vaddps        %ymm9,%ymm8,%ymm1
  .byte  196,98,125,24,37,11,136,2,0         // vbroadcastss  0x2880b(%rip),%ymm12        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,193,116,89,212                  // vmulps        %ymm12,%ymm1,%ymm2
  .byte  197,28,194,226,1                    // vcmpltps      %ymm2,%ymm12,%ymm12
  .byte  196,65,36,92,216                    // vsubps        %ymm8,%ymm11,%ymm11
  .byte  196,65,36,92,217                    // vsubps        %ymm9,%ymm11,%ymm11
  .byte  196,195,117,74,203,192              // vblendvps     %ymm12,%ymm11,%ymm1,%ymm1
  .byte  196,65,60,194,193,0                 // vcmpeqps      %ymm9,%ymm8,%ymm8
  .byte  197,172,94,201                      // vdivps        %ymm1,%ymm10,%ymm1
  .byte  196,195,125,74,198,128              // vblendvps     %ymm8,%ymm14,%ymm0,%ymm0
  .byte  196,195,117,74,206,128              // vblendvps     %ymm8,%ymm14,%ymm1,%ymm1
  .byte  196,98,125,24,5,62,136,2,0          // vbroadcastss  0x2883e(%rip),%ymm8        # 3a280 <_sk_srcover_bgra_8888_sse2_lowp+0x318>
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hsl_to_rgb_avx
.globl _sk_hsl_to_rgb_avx
FUNCTION(_sk_hsl_to_rgb_avx)
_sk_hsl_to_rgb_avx:
  .byte  72,131,236,56                       // sub           $0x38,%rsp
  .byte  197,252,17,60,36                    // vmovups       %ymm7,(%rsp)
  .byte  197,252,17,116,36,224               // vmovups       %ymm6,-0x20(%rsp)
  .byte  197,252,17,108,36,192               // vmovups       %ymm5,-0x40(%rsp)
  .byte  197,252,17,100,36,160               // vmovups       %ymm4,-0x60(%rsp)
  .byte  197,252,17,92,36,128                // vmovups       %ymm3,-0x80(%rsp)
  .byte  197,252,40,225                      // vmovaps       %ymm1,%ymm4
  .byte  197,252,40,216                      // vmovaps       %ymm0,%ymm3
  .byte  196,98,125,24,5,151,135,2,0         // vbroadcastss  0x28797(%rip),%ymm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,60,194,202,2                    // vcmpleps      %ymm2,%ymm8,%ymm9
  .byte  197,92,89,210                       // vmulps        %ymm2,%ymm4,%ymm10
  .byte  196,65,92,92,218                    // vsubps        %ymm10,%ymm4,%ymm11
  .byte  196,67,45,74,203,144                // vblendvps     %ymm9,%ymm11,%ymm10,%ymm9
  .byte  197,52,88,210                       // vaddps        %ymm2,%ymm9,%ymm10
  .byte  197,108,88,202                      // vaddps        %ymm2,%ymm2,%ymm9
  .byte  196,65,52,92,202                    // vsubps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,221,135,2,0        // vbroadcastss  0x287dd(%rip),%ymm11        # 3a284 <_sk_srcover_bgra_8888_sse2_lowp+0x31c>
  .byte  196,65,100,88,219                   // vaddps        %ymm11,%ymm3,%ymm11
  .byte  196,67,125,8,227,1                  // vroundps      $0x1,%ymm11,%ymm12
  .byte  196,65,36,92,252                    // vsubps        %ymm12,%ymm11,%ymm15
  .byte  196,65,44,92,217                    // vsubps        %ymm9,%ymm10,%ymm11
  .byte  196,98,125,24,37,175,135,2,0        // vbroadcastss  0x287af(%rip),%ymm12        # 3a274 <_sk_srcover_bgra_8888_sse2_lowp+0x30c>
  .byte  196,193,4,89,196                    // vmulps        %ymm12,%ymm15,%ymm0
  .byte  196,98,125,24,45,169,135,2,0        // vbroadcastss  0x287a9(%rip),%ymm13        # 3a27c <_sk_srcover_bgra_8888_sse2_lowp+0x314>
  .byte  197,20,92,240                       // vsubps        %ymm0,%ymm13,%ymm14
  .byte  196,65,36,89,246                    // vmulps        %ymm14,%ymm11,%ymm14
  .byte  196,65,52,88,246                    // vaddps        %ymm14,%ymm9,%ymm14
  .byte  196,226,125,24,13,158,135,2,0       // vbroadcastss  0x2879e(%rip),%ymm1        # 3a288 <_sk_srcover_bgra_8888_sse2_lowp+0x320>
  .byte  196,193,116,194,255,2               // vcmpleps      %ymm15,%ymm1,%ymm7
  .byte  196,195,13,74,249,112               // vblendvps     %ymm7,%ymm9,%ymm14,%ymm7
  .byte  196,65,60,194,247,2                 // vcmpleps      %ymm15,%ymm8,%ymm14
  .byte  196,227,45,74,255,224               // vblendvps     %ymm14,%ymm7,%ymm10,%ymm7
  .byte  196,98,125,24,53,117,135,2,0        // vbroadcastss  0x28775(%rip),%ymm14        # 3a280 <_sk_srcover_bgra_8888_sse2_lowp+0x318>
  .byte  196,65,12,194,255,2                 // vcmpleps      %ymm15,%ymm14,%ymm15
  .byte  196,193,124,89,195                  // vmulps        %ymm11,%ymm0,%ymm0
  .byte  197,180,88,192                      // vaddps        %ymm0,%ymm9,%ymm0
  .byte  196,99,125,74,255,240               // vblendvps     %ymm15,%ymm7,%ymm0,%ymm15
  .byte  196,227,125,8,195,1                 // vroundps      $0x1,%ymm3,%ymm0
  .byte  197,228,92,192                      // vsubps        %ymm0,%ymm3,%ymm0
  .byte  196,193,124,89,252                  // vmulps        %ymm12,%ymm0,%ymm7
  .byte  197,148,92,247                      // vsubps        %ymm7,%ymm13,%ymm6
  .byte  197,164,89,246                      // vmulps        %ymm6,%ymm11,%ymm6
  .byte  197,180,88,246                      // vaddps        %ymm6,%ymm9,%ymm6
  .byte  197,244,194,232,2                   // vcmpleps      %ymm0,%ymm1,%ymm5
  .byte  196,195,77,74,233,80                // vblendvps     %ymm5,%ymm9,%ymm6,%ymm5
  .byte  197,188,194,240,2                   // vcmpleps      %ymm0,%ymm8,%ymm6
  .byte  196,227,45,74,237,96                // vblendvps     %ymm6,%ymm5,%ymm10,%ymm5
  .byte  197,140,194,192,2                   // vcmpleps      %ymm0,%ymm14,%ymm0
  .byte  197,164,89,247                      // vmulps        %ymm7,%ymm11,%ymm6
  .byte  197,180,88,246                      // vaddps        %ymm6,%ymm9,%ymm6
  .byte  196,227,77,74,237,0                 // vblendvps     %ymm0,%ymm5,%ymm6,%ymm5
  .byte  196,226,125,24,5,31,135,2,0         // vbroadcastss  0x2871f(%rip),%ymm0        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  197,228,88,192                      // vaddps        %ymm0,%ymm3,%ymm0
  .byte  196,227,125,8,216,1                 // vroundps      $0x1,%ymm0,%ymm3
  .byte  197,252,92,195                      // vsubps        %ymm3,%ymm0,%ymm0
  .byte  197,244,194,200,2                   // vcmpleps      %ymm0,%ymm1,%ymm1
  .byte  196,193,124,89,220                  // vmulps        %ymm12,%ymm0,%ymm3
  .byte  197,148,92,243                      // vsubps        %ymm3,%ymm13,%ymm6
  .byte  197,164,89,246                      // vmulps        %ymm6,%ymm11,%ymm6
  .byte  197,180,88,246                      // vaddps        %ymm6,%ymm9,%ymm6
  .byte  196,195,77,74,201,16                // vblendvps     %ymm1,%ymm9,%ymm6,%ymm1
  .byte  197,188,194,240,2                   // vcmpleps      %ymm0,%ymm8,%ymm6
  .byte  196,227,45,74,201,96                // vblendvps     %ymm6,%ymm1,%ymm10,%ymm1
  .byte  197,140,194,192,2                   // vcmpleps      %ymm0,%ymm14,%ymm0
  .byte  197,164,89,219                      // vmulps        %ymm3,%ymm11,%ymm3
  .byte  197,180,88,219                      // vaddps        %ymm3,%ymm9,%ymm3
  .byte  196,227,101,74,217,0                // vblendvps     %ymm0,%ymm1,%ymm3,%ymm3
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,220,194,224,0                   // vcmpeqps      %ymm0,%ymm4,%ymm4
  .byte  196,227,5,74,194,64                 // vblendvps     %ymm4,%ymm2,%ymm15,%ymm0
  .byte  196,227,85,74,202,64                // vblendvps     %ymm4,%ymm2,%ymm5,%ymm1
  .byte  196,227,101,74,210,64               // vblendvps     %ymm4,%ymm2,%ymm3,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,92,36,128                // vmovups       -0x80(%rsp),%ymm3
  .byte  197,252,16,100,36,160               // vmovups       -0x60(%rsp),%ymm4
  .byte  197,252,16,108,36,192               // vmovups       -0x40(%rsp),%ymm5
  .byte  197,252,16,116,36,224               // vmovups       -0x20(%rsp),%ymm6
  .byte  197,252,16,60,36                    // vmovups       (%rsp),%ymm7
  .byte  72,131,196,56                       // add           $0x38,%rsp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_1_float_avx
.globl _sk_scale_1_float_avx
FUNCTION(_sk_scale_1_float_avx)
_sk_scale_1_float_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_u8_avx
.globl _sk_scale_u8_avx
FUNCTION(_sk_scale_u8_avx)
_sk_scale_u8_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,75                              // jne           11c73 <_sk_scale_u8_avx+0x63>
  .byte  196,2,121,48,4,24                   // vpmovzxbw     (%r8,%r11,1),%xmm8
  .byte  197,57,219,5,186,142,2,0            // vpand         0x28eba(%rip),%xmm8,%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,66,121,51,200                   // vpmovzxwd     %xmm8,%xmm9
  .byte  196,65,121,112,192,78               // vpshufd       $0x4e,%xmm8,%xmm8
  .byte  196,66,121,51,192                   // vpmovzxwd     %xmm8,%xmm8
  .byte  196,67,53,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm9,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,98,125,24,13,54,134,2,0         // vbroadcastss  0x28636(%rip),%ymm9        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,188,89,219                      // vmulps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,166                             // ja            11c2e <_sk_scale_u8_avx+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,121,0,0,0                 // lea           0x79(%rip),%r10        # 11d0c <_sk_scale_u8_avx+0xfc>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  235,135                             // jmp           11c2e <_sk_scale_u8_avx+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  197,57,196,192,2                    // vpinsrw       $0x2,%eax,%xmm8,%xmm8
  .byte  67,15,183,4,24                      // movzwl        (%r8,%r11,1),%eax
  .byte  197,121,110,200                     // vmovd         %eax,%xmm9
  .byte  196,66,121,48,201                   // vpmovzxbw     %xmm9,%xmm9
  .byte  196,67,57,14,193,3                  // vpblendw      $0x3,%xmm9,%xmm8,%xmm8
  .byte  233,94,255,255,255                  // jmpq          11c2e <_sk_scale_u8_avx+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  197,57,196,192,6                    // vpinsrw       $0x6,%eax,%xmm8,%xmm8
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,57,196,192,5                    // vpinsrw       $0x5,%eax,%xmm8,%xmm8
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,57,196,192,4                    // vpinsrw       $0x4,%eax,%xmm8,%xmm8
  .byte  196,1,121,110,12,24                 // vmovd         (%r8,%r11,1),%xmm9
  .byte  196,66,121,48,201                   // vpmovzxbw     %xmm9,%xmm9
  .byte  196,67,49,14,192,240                // vpblendw      $0xf0,%xmm8,%xmm9,%xmm8
  .byte  233,34,255,255,255                  // jmpq          11c2e <_sk_scale_u8_avx+0x1e>
  .byte  144                                 // nop
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,171,255,255,255,155             // ljmp          *-0x64000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  234                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  223,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,212                             // callq         *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_scale_565_avx
.globl _sk_scale_565_avx
FUNCTION(_sk_scale_565_avx)
_sk_scale_565_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,178,0,0,0                    // jne           11df9 <_sk_scale_565_avx+0xd1>
  .byte  196,1,122,111,4,88                  // vmovdqu       (%r8,%r11,2),%xmm8
  .byte  196,66,121,51,200                   // vpmovzxwd     %xmm8,%xmm9
  .byte  196,65,121,112,192,78               // vpshufd       $0x4e,%xmm8,%xmm8
  .byte  196,66,121,51,192                   // vpmovzxwd     %xmm8,%xmm8
  .byte  196,67,53,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm9,%ymm8
  .byte  196,98,125,24,13,40,133,2,0         // vbroadcastss  0x28528(%rip),%ymm9        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  196,65,60,84,201                    // vandps        %ymm9,%ymm8,%ymm9
  .byte  196,65,124,91,201                   // vcvtdq2ps     %ymm9,%ymm9
  .byte  196,98,125,24,21,25,133,2,0         // vbroadcastss  0x28519(%rip),%ymm10        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  196,65,52,89,202                    // vmulps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,21,15,133,2,0         // vbroadcastss  0x2850f(%rip),%ymm10        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  196,65,60,84,210                    // vandps        %ymm10,%ymm8,%ymm10
  .byte  196,65,124,91,210                   // vcvtdq2ps     %ymm10,%ymm10
  .byte  196,98,125,24,29,0,133,2,0          // vbroadcastss  0x28500(%rip),%ymm11        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  196,65,44,89,211                    // vmulps        %ymm11,%ymm10,%ymm10
  .byte  196,98,125,24,29,246,132,2,0        // vbroadcastss  0x284f6(%rip),%ymm11        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  196,65,60,84,195                    // vandps        %ymm11,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,98,125,24,29,231,132,2,0        // vbroadcastss  0x284e7(%rip),%ymm11        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  197,100,194,223,1                   // vcmpltps      %ymm7,%ymm3,%ymm11
  .byte  196,65,44,93,224                    // vminps        %ymm8,%ymm10,%ymm12
  .byte  196,65,52,93,228                    // vminps        %ymm12,%ymm9,%ymm12
  .byte  196,65,44,95,232                    // vmaxps        %ymm8,%ymm10,%ymm13
  .byte  196,65,52,95,237                    // vmaxps        %ymm13,%ymm9,%ymm13
  .byte  196,67,21,74,220,176                // vblendvps     %ymm11,%ymm12,%ymm13,%ymm11
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  197,172,89,201                      // vmulps        %ymm1,%ymm10,%ymm1
  .byte  197,188,89,210                      // vmulps        %ymm2,%ymm8,%ymm2
  .byte  197,164,89,219                      // vmulps        %ymm3,%ymm11,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,59,255,255,255               // ja            11d4d <_sk_scale_565_avx+0x25>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,99,0,0,0                  // lea           0x63(%rip),%r10        # 11e80 <_sk_scale_565_avx+0x158>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  233,25,255,255,255                  // jmpq          11d4d <_sk_scale_565_avx+0x25>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,1,57,196,68,88,4,2              // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,121,110,12,88                 // vmovd         (%r8,%r11,2),%xmm9
  .byte  196,67,57,14,193,3                  // vpblendw      $0x3,%xmm9,%xmm8,%xmm8
  .byte  233,251,254,255,255                 // jmpq          11d4d <_sk_scale_565_avx+0x25>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,1,57,196,68,88,12,6             // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,57,196,68,88,10,5             // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,57,196,68,88,8,4              // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,122,126,12,88                 // vmovq         (%r8,%r11,2),%xmm9
  .byte  196,67,49,14,192,240                // vpblendw      $0xf0,%xmm8,%xmm9,%xmm8
  .byte  233,205,254,255,255                 // jmpq          11d4d <_sk_scale_565_avx+0x25>
  .byte  166                                 // cmpsb         %es:(%rdi),%ds:(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,193                             // inc           %ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,180,255,255,255,239,255         // pushq         -0x100001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,231                             // jmpq          *%rdi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  223,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_lerp_1_float_avx
.globl _sk_lerp_1_float_avx
FUNCTION(_sk_lerp_1_float_avx)
_sk_lerp_1_float_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  197,252,88,196                      // vaddps        %ymm4,%ymm0,%ymm0
  .byte  197,244,92,205                      // vsubps        %ymm5,%ymm1,%ymm1
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  197,244,88,205                      // vaddps        %ymm5,%ymm1,%ymm1
  .byte  197,236,92,214                      // vsubps        %ymm6,%ymm2,%ymm2
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  197,236,88,214                      // vaddps        %ymm6,%ymm2,%ymm2
  .byte  197,228,92,223                      // vsubps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lerp_u8_avx
.globl _sk_lerp_u8_avx
FUNCTION(_sk_lerp_u8_avx)
_sk_lerp_u8_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,111                             // jne           11f62 <_sk_lerp_u8_avx+0x87>
  .byte  196,2,121,48,4,24                   // vpmovzxbw     (%r8,%r11,1),%xmm8
  .byte  197,57,219,5,239,139,2,0            // vpand         0x28bef(%rip),%xmm8,%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,66,121,51,200                   // vpmovzxwd     %xmm8,%xmm9
  .byte  196,65,121,112,192,78               // vpshufd       $0x4e,%xmm8,%xmm8
  .byte  196,66,121,51,192                   // vpmovzxwd     %xmm8,%xmm8
  .byte  196,67,53,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm9,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,98,125,24,13,107,131,2,0        // vbroadcastss  0x2836b(%rip),%ymm9        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  197,252,88,196                      // vaddps        %ymm4,%ymm0,%ymm0
  .byte  197,244,92,205                      // vsubps        %ymm5,%ymm1,%ymm1
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  197,244,88,205                      // vaddps        %ymm5,%ymm1,%ymm1
  .byte  197,236,92,214                      // vsubps        %ymm6,%ymm2,%ymm2
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  197,236,88,214                      // vaddps        %ymm6,%ymm2,%ymm2
  .byte  197,228,92,223                      // vsubps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,130                             // ja            11ef9 <_sk_lerp_u8_avx+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,126,0,0,0                 // lea           0x7e(%rip),%r10        # 12000 <_sk_lerp_u8_avx+0x125>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  233,96,255,255,255                  // jmpq          11ef9 <_sk_lerp_u8_avx+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  197,57,196,192,2                    // vpinsrw       $0x2,%eax,%xmm8,%xmm8
  .byte  67,15,183,4,24                      // movzwl        (%r8,%r11,1),%eax
  .byte  197,121,110,200                     // vmovd         %eax,%xmm9
  .byte  196,66,121,48,201                   // vpmovzxbw     %xmm9,%xmm9
  .byte  196,67,57,14,193,3                  // vpblendw      $0x3,%xmm9,%xmm8,%xmm8
  .byte  233,55,255,255,255                  // jmpq          11ef9 <_sk_lerp_u8_avx+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  197,57,196,192,6                    // vpinsrw       $0x6,%eax,%xmm8,%xmm8
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,57,196,192,5                    // vpinsrw       $0x5,%eax,%xmm8,%xmm8
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,57,196,192,4                    // vpinsrw       $0x4,%eax,%xmm8,%xmm8
  .byte  196,1,121,110,12,24                 // vmovd         (%r8,%r11,1),%xmm9
  .byte  196,66,121,48,201                   // vpmovzxbw     %xmm9,%xmm9
  .byte  196,67,49,14,192,240                // vpblendw      $0xf0,%xmm8,%xmm9,%xmm8
  .byte  233,251,254,255,255                 // jmpq          11ef9 <_sk_lerp_u8_avx+0x1e>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  139,255                             // mov           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,169,255,255,255,153             // ljmp          *-0x66000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  232,255,255,255,221                 // callq         ffffffffde012010 <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffddfd80a8>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,194                             // inc           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_lerp_565_avx
.globl _sk_lerp_565_avx
FUNCTION(_sk_lerp_565_avx)
_sk_lerp_565_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,214,0,0,0                    // jne           12111 <_sk_lerp_565_avx+0xf5>
  .byte  196,1,122,111,4,88                  // vmovdqu       (%r8,%r11,2),%xmm8
  .byte  196,66,121,51,200                   // vpmovzxwd     %xmm8,%xmm9
  .byte  196,65,121,112,192,78               // vpshufd       $0x4e,%xmm8,%xmm8
  .byte  196,66,121,51,192                   // vpmovzxwd     %xmm8,%xmm8
  .byte  196,67,53,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm9,%ymm8
  .byte  196,98,125,24,13,52,130,2,0         // vbroadcastss  0x28234(%rip),%ymm9        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  196,65,60,84,201                    // vandps        %ymm9,%ymm8,%ymm9
  .byte  196,65,124,91,201                   // vcvtdq2ps     %ymm9,%ymm9
  .byte  196,98,125,24,21,37,130,2,0         // vbroadcastss  0x28225(%rip),%ymm10        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  196,65,52,89,202                    // vmulps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,21,27,130,2,0         // vbroadcastss  0x2821b(%rip),%ymm10        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  196,65,60,84,210                    // vandps        %ymm10,%ymm8,%ymm10
  .byte  196,65,124,91,210                   // vcvtdq2ps     %ymm10,%ymm10
  .byte  196,98,125,24,29,12,130,2,0         // vbroadcastss  0x2820c(%rip),%ymm11        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  196,65,44,89,211                    // vmulps        %ymm11,%ymm10,%ymm10
  .byte  196,98,125,24,29,2,130,2,0          // vbroadcastss  0x28202(%rip),%ymm11        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  196,65,60,84,195                    // vandps        %ymm11,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,98,125,24,29,243,129,2,0        // vbroadcastss  0x281f3(%rip),%ymm11        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  197,100,194,223,1                   // vcmpltps      %ymm7,%ymm3,%ymm11
  .byte  196,65,44,93,224                    // vminps        %ymm8,%ymm10,%ymm12
  .byte  196,65,52,93,228                    // vminps        %ymm12,%ymm9,%ymm12
  .byte  196,65,44,95,232                    // vmaxps        %ymm8,%ymm10,%ymm13
  .byte  196,65,52,95,237                    // vmaxps        %ymm13,%ymm9,%ymm13
  .byte  196,67,21,74,220,176                // vblendvps     %ymm11,%ymm12,%ymm13,%ymm11
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,252,88,196                      // vaddps        %ymm4,%ymm0,%ymm0
  .byte  197,244,92,205                      // vsubps        %ymm5,%ymm1,%ymm1
  .byte  196,193,116,89,202                  // vmulps        %ymm10,%ymm1,%ymm1
  .byte  197,244,88,205                      // vaddps        %ymm5,%ymm1,%ymm1
  .byte  197,236,92,214                      // vsubps        %ymm6,%ymm2,%ymm2
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  197,236,88,214                      // vaddps        %ymm6,%ymm2,%ymm2
  .byte  197,228,92,223                      // vsubps        %ymm7,%ymm3,%ymm3
  .byte  196,193,100,89,219                  // vmulps        %ymm11,%ymm3,%ymm3
  .byte  197,228,88,223                      // vaddps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,23,255,255,255               // ja            12041 <_sk_lerp_565_avx+0x25>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,99,0,0,0                  // lea           0x63(%rip),%r10        # 12198 <_sk_lerp_565_avx+0x17c>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  233,245,254,255,255                 // jmpq          12041 <_sk_lerp_565_avx+0x25>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,1,57,196,68,88,4,2              // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,121,110,12,88                 // vmovd         (%r8,%r11,2),%xmm9
  .byte  196,67,57,14,193,3                  // vpblendw      $0x3,%xmm9,%xmm8,%xmm8
  .byte  233,215,254,255,255                 // jmpq          12041 <_sk_lerp_565_avx+0x25>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,1,57,196,68,88,12,6             // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,57,196,68,88,10,5             // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,57,196,68,88,8,4              // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm8,%xmm8
  .byte  196,1,122,126,12,88                 // vmovq         (%r8,%r11,2),%xmm9
  .byte  196,67,49,14,192,240                // vpblendw      $0xf0,%xmm8,%xmm9,%xmm8
  .byte  233,169,254,255,255                 // jmpq          12041 <_sk_lerp_565_avx+0x25>
  .byte  166                                 // cmpsb         %es:(%rdi),%ds:(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,193                             // inc           %ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,180,255,255,255,239,255         // pushq         -0x100001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,231                             // jmpq          *%rdi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  223,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_tables_avx
.globl _sk_load_tables_avx
FUNCTION(_sk_load_tables_avx)
_sk_load_tables_avx:
  .byte  197,252,17,124,36,200               // vmovups       %ymm7,-0x38(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,4,2,0,0                      // jne           123cc <_sk_load_tables_avx+0x218>
  .byte  196,65,125,16,20,144                // vmovupd       (%r8,%rdx,4),%ymm10
  .byte  197,125,40,13,202,133,2,0           // vmovapd       0x285ca(%rip),%ymm9        # 3a7a0 <_sk_srcover_bgra_8888_sse2_lowp+0x838>
  .byte  196,193,45,84,201                   // vandpd        %ymm9,%ymm10,%ymm1
  .byte  196,227,125,25,200,1                // vextractf128  $0x1,%ymm1,%xmm0
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  76,139,80,8                         // mov           0x8(%rax),%r10
  .byte  196,129,122,16,20,138               // vmovss        (%r10,%r9,4),%xmm2
  .byte  196,195,249,22,193,1                // vpextrq       $0x1,%xmm0,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,131,105,33,4,130,16             // vinsertps     $0x10,(%r10,%r8,4),%xmm2,%xmm0
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  196,131,121,33,4,130,32             // vinsertps     $0x20,(%r10,%r8,4),%xmm0,%xmm0
  .byte  196,193,249,126,200                 // vmovq         %xmm1,%r8
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  196,3,121,33,4,138,48               // vinsertps     $0x30,(%r10,%r9,4),%xmm0,%xmm8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  196,129,122,16,20,138               // vmovss        (%r10,%r9,4),%xmm2
  .byte  196,195,249,22,201,1                // vpextrq       $0x1,%xmm1,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,131,105,33,12,130,16            // vinsertps     $0x10,(%r10,%r8,4),%xmm2,%xmm1
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  196,131,113,33,12,130,32            // vinsertps     $0x20,(%r10,%r8,4),%xmm1,%xmm1
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  196,3,113,33,36,138,48              // vinsertps     $0x30,(%r10,%r9,4),%xmm1,%xmm12
  .byte  196,193,105,114,210,8               // vpsrld        $0x8,%xmm10,%xmm2
  .byte  196,67,125,25,213,1                 // vextractf128  $0x1,%ymm10,%xmm13
  .byte  196,193,121,114,213,8               // vpsrld        $0x8,%xmm13,%xmm0
  .byte  196,227,109,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm2,%ymm0
  .byte  196,193,125,84,209                  // vandpd        %ymm9,%ymm0,%ymm2
  .byte  196,227,125,25,208,1                // vextractf128  $0x1,%ymm2,%xmm0
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  196,129,122,16,12,144               // vmovss        (%r8,%r10,4),%xmm1
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  196,3,113,33,52,136,16              // vinsertps     $0x10,(%r8,%r9,4),%xmm1,%xmm14
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  196,129,122,16,28,136               // vmovss        (%r8,%r9,4),%xmm3
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,129,122,16,12,144               // vmovss        (%r8,%r10,4),%xmm1
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  196,129,122,16,4,144                // vmovss        (%r8,%r10,4),%xmm0
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  196,3,121,33,28,136,16              // vinsertps     $0x10,(%r8,%r9,4),%xmm0,%xmm11
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  196,1,122,16,60,136                 // vmovss        (%r8,%r9,4),%xmm15
  .byte  196,195,29,24,192,1                 // vinsertf128   $0x1,%xmm8,%ymm12,%ymm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,9,33,219,32                 // vinsertps     $0x20,%xmm3,%xmm14,%xmm3
  .byte  196,227,97,33,249,48                // vinsertps     $0x30,%xmm1,%xmm3,%xmm7
  .byte  196,1,122,16,52,144                 // vmovss        (%r8,%r10,4),%xmm14
  .byte  76,139,72,24                        // mov           0x18(%rax),%r9
  .byte  196,193,97,114,210,16               // vpsrld        $0x10,%xmm10,%xmm3
  .byte  196,193,105,114,213,16              // vpsrld        $0x10,%xmm13,%xmm2
  .byte  196,227,101,24,210,1                // vinsertf128   $0x1,%xmm2,%ymm3,%ymm2
  .byte  196,65,109,84,201                   // vandpd        %ymm9,%ymm2,%ymm9
  .byte  196,99,125,25,202,1                 // vextractf128  $0x1,%ymm9,%xmm2
  .byte  196,193,249,126,208                 // vmovq         %xmm2,%r8
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  196,193,122,16,28,129               // vmovss        (%r9,%rax,4),%xmm3
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,3,97,33,36,129,16               // vinsertps     $0x10,(%r9,%r8,4),%xmm3,%xmm12
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  196,193,122,16,28,129               // vmovss        (%r9,%rax,4),%xmm3
  .byte  196,65,249,126,200                  // vmovq         %xmm9,%r8
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,129,122,16,20,145               // vmovss        (%r9,%r10,4),%xmm2
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  196,193,122,16,12,129               // vmovss        (%r9,%rax,4),%xmm1
  .byte  196,67,249,22,202,1                 // vpextrq       $0x1,%xmm9,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,3,113,33,12,129,16              // vinsertps     $0x10,(%r9,%r8,4),%xmm1,%xmm9
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  196,65,122,16,4,129                 // vmovss        (%r9,%rax,4),%xmm8
  .byte  196,195,33,33,207,32                // vinsertps     $0x20,%xmm15,%xmm11,%xmm1
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,1,122,16,28,145                 // vmovss        (%r9,%r10,4),%xmm11
  .byte  196,195,113,33,206,48               // vinsertps     $0x30,%xmm14,%xmm1,%xmm1
  .byte  196,227,117,24,207,1                // vinsertf128   $0x1,%xmm7,%ymm1,%ymm1
  .byte  196,227,25,33,219,32                // vinsertps     $0x20,%xmm3,%xmm12,%xmm3
  .byte  196,227,97,33,210,48                // vinsertps     $0x30,%xmm2,%xmm3,%xmm2
  .byte  196,195,49,33,216,32                // vinsertps     $0x20,%xmm8,%xmm9,%xmm3
  .byte  196,195,97,33,219,48                // vinsertps     $0x30,%xmm11,%xmm3,%xmm3
  .byte  196,227,101,24,210,1                // vinsertf128   $0x1,%xmm2,%ymm3,%ymm2
  .byte  196,193,97,114,210,24               // vpsrld        $0x18,%xmm10,%xmm3
  .byte  196,193,65,114,213,24               // vpsrld        $0x18,%xmm13,%xmm7
  .byte  196,227,101,24,223,1                // vinsertf128   $0x1,%xmm7,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,226,125,24,61,210,126,2,0       // vbroadcastss  0x27ed2(%rip),%ymm7        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,228,89,223                      // vmulps        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,124,36,200               // vmovups       -0x38(%rsp),%ymm7
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,233,253,255,255              // ja            121ce <_sk_load_tables_avx+0x1a>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,148,0,0,0                 // lea           0x94(%rip),%r10        # 12484 <_sk_load_tables_avx+0x2d0>
  .byte  79,99,12,138                        // movslq        (%r10,%r9,4),%r9
  .byte  77,1,209                            // add           %r10,%r9
  .byte  65,255,225                          // jmpq          *%r9
  .byte  196,65,122,16,20,144                // vmovss        (%r8,%rdx,4),%xmm10
  .byte  233,201,253,255,255                 // jmpq          121ce <_sk_load_tables_avx+0x1a>
  .byte  196,193,121,110,68,144,8            // vmovd         0x8(%r8,%rdx,4),%xmm0
  .byte  197,249,112,192,68                  // vpshufd       $0x44,%xmm0,%xmm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,99,117,12,208,4                 // vblendps      $0x4,%ymm0,%ymm1,%ymm10
  .byte  196,193,123,16,4,144                // vmovsd        (%r8,%rdx,4),%xmm0
  .byte  196,99,45,13,208,1                  // vblendpd      $0x1,%ymm0,%ymm10,%ymm10
  .byte  233,162,253,255,255                 // jmpq          121ce <_sk_load_tables_avx+0x1a>
  .byte  196,193,121,110,68,144,24           // vmovd         0x18(%r8,%rdx,4),%xmm0
  .byte  197,249,112,192,68                  // vpshufd       $0x44,%xmm0,%xmm0
  .byte  196,227,125,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,99,117,12,208,64                // vblendps      $0x40,%ymm0,%ymm1,%ymm10
  .byte  196,99,125,25,208,1                 // vextractf128  $0x1,%ymm10,%xmm0
  .byte  196,195,121,34,68,144,20,1          // vpinsrd       $0x1,0x14(%r8,%rdx,4),%xmm0,%xmm0
  .byte  196,99,45,24,208,1                  // vinsertf128   $0x1,%xmm0,%ymm10,%ymm10
  .byte  196,99,125,25,208,1                 // vextractf128  $0x1,%ymm10,%xmm0
  .byte  196,195,121,34,68,144,16,0          // vpinsrd       $0x0,0x10(%r8,%rdx,4),%xmm0,%xmm0
  .byte  196,99,45,24,208,1                  // vinsertf128   $0x1,%xmm0,%ymm10,%ymm10
  .byte  196,193,121,16,4,144                // vmovupd       (%r8,%rdx,4),%xmm0
  .byte  196,67,125,13,210,12                // vblendpd      $0xc,%ymm10,%ymm0,%ymm10
  .byte  233,77,253,255,255                  // jmpq          121ce <_sk_load_tables_avx+0x1a>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  118,255                             // jbe           12485 <_sk_load_tables_avx+0x2d1>
  .byte  255                                 // (bad)
  .byte  255,151,255,255,255,129             // callq         *-0x7e000001(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  236                                 // in            (%dx),%al
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  216,255                             // fdivr         %st(7),%st
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  168,255                             // test          $0xff,%al
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_tables_u16_be_avx
.globl _sk_load_tables_u16_be_avx
FUNCTION(_sk_load_tables_u16_be_avx)
_sk_load_tables_u16_be_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  76,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  197,252,17,124,36,200               // vmovups       %ymm7,-0x38(%rsp)
  .byte  197,252,17,116,36,168               // vmovups       %ymm6,-0x58(%rsp)
  .byte  15,133,75,2,0,0                     // jne           1270d <_sk_load_tables_u16_be_avx+0x26d>
  .byte  196,1,121,16,4,72                   // vmovupd       (%r8,%r9,2),%xmm8
  .byte  196,129,121,16,84,72,16             // vmovupd       0x10(%r8,%r9,2),%xmm2
  .byte  196,129,121,16,92,72,32             // vmovupd       0x20(%r8,%r9,2),%xmm3
  .byte  196,1,122,111,76,72,48              // vmovdqu       0x30(%r8,%r9,2),%xmm9
  .byte  197,185,97,194                      // vpunpcklwd    %xmm2,%xmm8,%xmm0
  .byte  197,185,105,210                     // vpunpckhwd    %xmm2,%xmm8,%xmm2
  .byte  196,193,97,97,201                   // vpunpcklwd    %xmm9,%xmm3,%xmm1
  .byte  196,193,97,105,217                  // vpunpckhwd    %xmm9,%xmm3,%xmm3
  .byte  197,121,97,202                      // vpunpcklwd    %xmm2,%xmm0,%xmm9
  .byte  197,121,105,194                     // vpunpckhwd    %xmm2,%xmm0,%xmm8
  .byte  197,241,97,195                      // vpunpcklwd    %xmm3,%xmm1,%xmm0
  .byte  197,113,105,227                     // vpunpckhwd    %xmm3,%xmm1,%xmm12
  .byte  197,177,108,208                     // vpunpcklqdq   %xmm0,%xmm9,%xmm2
  .byte  197,49,109,232                      // vpunpckhqdq   %xmm0,%xmm9,%xmm13
  .byte  196,65,57,108,212                   // vpunpcklqdq   %xmm12,%xmm8,%xmm10
  .byte  197,121,111,29,220,133,2,0          // vmovdqa       0x285dc(%rip),%xmm11        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,193,105,219,195                 // vpand         %xmm11,%xmm2,%xmm0
  .byte  197,249,112,208,78                  // vpshufd       $0x4e,%xmm0,%xmm2
  .byte  196,226,121,51,210                  // vpmovzxwd     %xmm2,%xmm2
  .byte  196,193,249,126,208                 // vmovq         %xmm2,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  76,139,80,8                         // mov           0x8(%rax),%r10
  .byte  196,129,122,16,28,138               // vmovss        (%r10,%r9,4),%xmm3
  .byte  196,195,249,22,209,1                // vpextrq       $0x1,%xmm2,%r9
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  196,3,97,33,12,2,16                 // vinsertps     $0x10,(%r10,%r8,1),%xmm3,%xmm9
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  196,129,122,16,28,130               // vmovss        (%r10,%r8,4),%xmm3
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  196,129,122,16,12,10                // vmovss        (%r10,%r9,1),%xmm1
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  196,129,122,16,20,138               // vmovss        (%r10,%r9,4),%xmm2
  .byte  196,195,249,22,193,1                // vpextrq       $0x1,%xmm0,%r9
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  196,131,105,33,4,2,16               // vinsertps     $0x10,(%r10,%r8,1),%xmm2,%xmm0
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  196,131,121,33,20,130,32            // vinsertps     $0x20,(%r10,%r8,4),%xmm0,%xmm2
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  196,227,49,33,195,32                // vinsertps     $0x20,%xmm3,%xmm9,%xmm0
  .byte  196,99,121,33,241,48                // vinsertps     $0x30,%xmm1,%xmm0,%xmm14
  .byte  196,3,105,33,12,10,48               // vinsertps     $0x30,(%r10,%r9,1),%xmm2,%xmm9
  .byte  196,193,17,219,203                  // vpand         %xmm11,%xmm13,%xmm1
  .byte  197,249,112,209,78                  // vpshufd       $0x4e,%xmm1,%xmm2
  .byte  196,226,121,51,210                  // vpmovzxwd     %xmm2,%xmm2
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  196,129,122,16,28,144               // vmovss        (%r8,%r10,4),%xmm3
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  196,226,121,51,193                  // vpmovzxwd     %xmm1,%xmm0
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  196,3,97,33,60,8,16                 // vinsertps     $0x10,(%r8,%r9,1),%xmm3,%xmm15
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  196,129,122,16,20,136               // vmovss        (%r8,%r9,4),%xmm2
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  73,193,234,30                       // shr           $0x1e,%r10
  .byte  196,129,122,16,28,16                // vmovss        (%r8,%r10,1),%xmm3
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  196,129,122,16,12,144               // vmovss        (%r8,%r10,4),%xmm1
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  196,131,113,33,4,8,16               // vinsertps     $0x10,(%r8,%r9,1),%xmm1,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,30                       // shr           $0x1e,%r10
  .byte  196,131,121,33,4,136,32             // vinsertps     $0x20,(%r8,%r9,4),%xmm0,%xmm0
  .byte  196,3,121,33,44,16,48               // vinsertps     $0x30,(%r8,%r10,1),%xmm0,%xmm13
  .byte  76,139,80,24                        // mov           0x18(%rax),%r10
  .byte  196,193,41,219,195                  // vpand         %xmm11,%xmm10,%xmm0
  .byte  197,249,112,200,78                  // vpshufd       $0x4e,%xmm0,%xmm1
  .byte  196,226,121,51,201                  // vpmovzxwd     %xmm1,%xmm1
  .byte  196,195,249,22,200,1                // vpextrq       $0x1,%xmm1,%r8
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  196,193,122,16,12,130               // vmovss        (%r10,%rax,4),%xmm1
  .byte  196,195,249,22,195,1                // vpextrq       $0x1,%xmm0,%r11
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  196,3,113,33,20,10,16               // vinsertps     $0x10,(%r10,%r9,1),%xmm1,%xmm10
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  196,65,122,16,28,130                // vmovss        (%r10,%rax,4),%xmm11
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  196,129,122,16,60,2                 // vmovss        (%r10,%r8,1),%xmm7
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  196,193,122,16,4,130                // vmovss        (%r10,%rax,4),%xmm0
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  196,131,121,33,4,10,16              // vinsertps     $0x10,(%r10,%r9,1),%xmm0,%xmm0
  .byte  68,137,216                          // mov           %r11d,%eax
  .byte  196,195,121,33,4,130,32             // vinsertps     $0x20,(%r10,%rax,4),%xmm0,%xmm0
  .byte  73,193,235,30                       // shr           $0x1e,%r11
  .byte  196,131,121,33,52,26,48             // vinsertps     $0x30,(%r10,%r11,1),%xmm0,%xmm6
  .byte  196,195,53,24,198,1                 // vinsertf128   $0x1,%xmm14,%ymm9,%ymm0
  .byte  196,227,1,33,202,32                 // vinsertps     $0x20,%xmm2,%xmm15,%xmm1
  .byte  196,227,113,33,203,48               // vinsertps     $0x30,%xmm3,%xmm1,%xmm1
  .byte  196,227,21,24,201,1                 // vinsertf128   $0x1,%xmm1,%ymm13,%ymm1
  .byte  196,195,41,33,211,32                // vinsertps     $0x20,%xmm11,%xmm10,%xmm2
  .byte  196,227,105,33,215,48               // vinsertps     $0x30,%xmm7,%xmm2,%xmm2
  .byte  196,227,77,24,210,1                 // vinsertf128   $0x1,%xmm2,%ymm6,%ymm2
  .byte  196,193,57,109,220                  // vpunpckhqdq   %xmm12,%xmm8,%xmm3
  .byte  197,201,113,243,8                   // vpsllw        $0x8,%xmm3,%xmm6
  .byte  197,225,113,211,8                   // vpsrlw        $0x8,%xmm3,%xmm3
  .byte  197,201,235,219                     // vpor          %xmm3,%xmm6,%xmm3
  .byte  196,226,121,51,243                  // vpmovzxwd     %xmm3,%xmm6
  .byte  197,249,112,219,78                  // vpshufd       $0x4e,%xmm3,%xmm3
  .byte  196,226,121,51,219                  // vpmovzxwd     %xmm3,%xmm3
  .byte  196,227,77,24,219,1                 // vinsertf128   $0x1,%xmm3,%ymm6,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,226,125,24,53,179,123,2,0       // vbroadcastss  0x27bb3(%rip),%ymm6        # 3a2ac <_sk_srcover_bgra_8888_sse2_lowp+0x344>
  .byte  197,228,89,222                      // vmulps        %ymm6,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,116,36,168               // vmovups       -0x58(%rsp),%ymm6
  .byte  197,252,16,124,36,200               // vmovups       -0x38(%rsp),%ymm7
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,123,16,4,72                   // vmovsd        (%r8,%r9,2),%xmm8
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,85                              // je            12773 <_sk_load_tables_u16_be_avx+0x2d3>
  .byte  196,1,57,22,68,72,8                 // vmovhpd       0x8(%r8,%r9,2),%xmm8,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,72                              // jb            12773 <_sk_load_tables_u16_be_avx+0x2d3>
  .byte  196,129,123,16,84,72,16             // vmovsd        0x10(%r8,%r9,2),%xmm2
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  116,72                              // je            12780 <_sk_load_tables_u16_be_avx+0x2e0>
  .byte  196,129,105,22,84,72,24             // vmovhpd       0x18(%r8,%r9,2),%xmm2,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,59                              // jb            12780 <_sk_load_tables_u16_be_avx+0x2e0>
  .byte  196,129,123,16,92,72,32             // vmovsd        0x20(%r8,%r9,2),%xmm3
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  15,132,135,253,255,255              // je            124dd <_sk_load_tables_u16_be_avx+0x3d>
  .byte  196,129,97,22,92,72,40              // vmovhpd       0x28(%r8,%r9,2),%xmm3,%xmm3
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,130,118,253,255,255              // jb            124dd <_sk_load_tables_u16_be_avx+0x3d>
  .byte  196,1,122,126,76,72,48              // vmovq         0x30(%r8,%r9,2),%xmm9
  .byte  233,106,253,255,255                 // jmpq          124dd <_sk_load_tables_u16_be_avx+0x3d>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  197,233,87,210                      // vxorpd        %xmm2,%xmm2,%xmm2
  .byte  233,93,253,255,255                  // jmpq          124dd <_sk_load_tables_u16_be_avx+0x3d>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  233,84,253,255,255                  // jmpq          124dd <_sk_load_tables_u16_be_avx+0x3d>

HIDDEN _sk_load_tables_rgb_u16_be_avx
.globl _sk_load_tables_rgb_u16_be_avx
FUNCTION(_sk_load_tables_rgb_u16_be_avx)
_sk_load_tables_rgb_u16_be_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  76,141,12,82                        // lea           (%rdx,%rdx,2),%r9
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  197,252,17,124,36,200               // vmovups       %ymm7,-0x38(%rsp)
  .byte  197,252,17,116,36,168               // vmovups       %ymm6,-0x58(%rsp)
  .byte  15,133,54,2,0,0                     // jne           129dd <_sk_load_tables_rgb_u16_be_avx+0x254>
  .byte  196,1,122,111,28,72                 // vmovdqu       (%r8,%r9,2),%xmm11
  .byte  196,129,122,111,92,72,12            // vmovdqu       0xc(%r8,%r9,2),%xmm3
  .byte  196,129,122,111,84,72,24            // vmovdqu       0x18(%r8,%r9,2),%xmm2
  .byte  196,129,122,111,68,72,32            // vmovdqu       0x20(%r8,%r9,2),%xmm0
  .byte  197,249,115,216,4                   // vpsrldq       $0x4,%xmm0,%xmm0
  .byte  196,193,57,115,219,6                // vpsrldq       $0x6,%xmm11,%xmm8
  .byte  197,169,115,219,6                   // vpsrldq       $0x6,%xmm3,%xmm10
  .byte  197,241,115,218,6                   // vpsrldq       $0x6,%xmm2,%xmm1
  .byte  197,177,115,216,6                   // vpsrldq       $0x6,%xmm0,%xmm9
  .byte  196,65,113,97,201                   // vpunpcklwd    %xmm9,%xmm1,%xmm9
  .byte  197,233,97,192                      // vpunpcklwd    %xmm0,%xmm2,%xmm0
  .byte  196,193,57,97,210                   // vpunpcklwd    %xmm10,%xmm8,%xmm2
  .byte  197,161,97,219                      // vpunpcklwd    %xmm3,%xmm11,%xmm3
  .byte  197,225,97,202                      // vpunpcklwd    %xmm2,%xmm3,%xmm1
  .byte  197,225,105,210                     // vpunpckhwd    %xmm2,%xmm3,%xmm2
  .byte  196,193,121,97,217                  // vpunpcklwd    %xmm9,%xmm0,%xmm3
  .byte  196,193,121,105,193                 // vpunpckhwd    %xmm9,%xmm0,%xmm0
  .byte  197,105,108,216                     // vpunpcklqdq   %xmm0,%xmm2,%xmm11
  .byte  197,241,108,211                     // vpunpcklqdq   %xmm3,%xmm1,%xmm2
  .byte  197,241,109,203                     // vpunpckhqdq   %xmm3,%xmm1,%xmm1
  .byte  197,121,111,53,220,130,2,0          // vmovdqa       0x282dc(%rip),%xmm14        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,193,105,219,214                 // vpand         %xmm14,%xmm2,%xmm2
  .byte  197,249,112,218,78                  // vpshufd       $0x4e,%xmm2,%xmm3
  .byte  196,226,121,51,219                  // vpmovzxwd     %xmm3,%xmm3
  .byte  196,193,249,126,216                 // vmovq         %xmm3,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  76,139,80,8                         // mov           0x8(%rax),%r10
  .byte  196,129,122,16,4,138                // vmovss        (%r10,%r9,4),%xmm0
  .byte  196,195,249,22,217,1                // vpextrq       $0x1,%xmm3,%r9
  .byte  196,226,121,51,210                  // vpmovzxwd     %xmm2,%xmm2
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  196,3,121,33,4,2,16                 // vinsertps     $0x10,(%r10,%r8,1),%xmm0,%xmm8
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  196,1,122,16,20,130                 // vmovss        (%r10,%r8,4),%xmm10
  .byte  196,193,249,126,208                 // vmovq         %xmm2,%r8
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  196,1,122,16,36,10                  // vmovss        (%r10,%r9,1),%xmm12
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  196,129,122,16,4,138                // vmovss        (%r10,%r9,4),%xmm0
  .byte  196,195,249,22,209,1                // vpextrq       $0x1,%xmm2,%r9
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  196,131,121,33,4,2,16               // vinsertps     $0x10,(%r10,%r8,1),%xmm0,%xmm0
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  196,131,121,33,4,130,32             // vinsertps     $0x20,(%r10,%r8,4),%xmm0,%xmm0
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  196,3,121,33,12,10,48               // vinsertps     $0x30,(%r10,%r9,1),%xmm0,%xmm9
  .byte  196,193,113,219,198                 // vpand         %xmm14,%xmm1,%xmm0
  .byte  197,249,112,200,78                  // vpshufd       $0x4e,%xmm0,%xmm1
  .byte  196,226,121,51,201                  // vpmovzxwd     %xmm1,%xmm1
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  196,129,122,16,20,144               // vmovss        (%r8,%r10,4),%xmm2
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  196,3,105,33,60,8,16                // vinsertps     $0x10,(%r8,%r9,1),%xmm2,%xmm15
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  196,129,122,16,20,136               // vmovss        (%r8,%r9,4),%xmm2
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  73,193,234,30                       // shr           $0x1e,%r10
  .byte  196,129,122,16,28,16                // vmovss        (%r8,%r10,1),%xmm3
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  196,129,122,16,12,144               // vmovss        (%r8,%r10,4),%xmm1
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  196,131,113,33,4,8,16               // vinsertps     $0x10,(%r8,%r9,1),%xmm1,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,30                       // shr           $0x1e,%r10
  .byte  196,131,121,33,4,136,32             // vinsertps     $0x20,(%r8,%r9,4),%xmm0,%xmm0
  .byte  196,3,121,33,44,16,48               // vinsertps     $0x30,(%r8,%r10,1),%xmm0,%xmm13
  .byte  76,139,80,24                        // mov           0x18(%rax),%r10
  .byte  196,193,33,219,198                  // vpand         %xmm14,%xmm11,%xmm0
  .byte  197,249,112,200,78                  // vpshufd       $0x4e,%xmm0,%xmm1
  .byte  196,226,121,51,201                  // vpmovzxwd     %xmm1,%xmm1
  .byte  196,195,249,22,200,1                // vpextrq       $0x1,%xmm1,%r8
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  196,193,122,16,12,130               // vmovss        (%r10,%rax,4),%xmm1
  .byte  196,195,249,22,195,1                // vpextrq       $0x1,%xmm0,%r11
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  196,3,113,33,28,10,16               // vinsertps     $0x10,(%r10,%r9,1),%xmm1,%xmm11
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  196,65,122,16,52,130                // vmovss        (%r10,%rax,4),%xmm14
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  196,129,122,16,60,2                 // vmovss        (%r10,%r8,1),%xmm7
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  196,193,122,16,4,130                // vmovss        (%r10,%rax,4),%xmm0
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  196,131,121,33,4,10,16              // vinsertps     $0x10,(%r10,%r9,1),%xmm0,%xmm0
  .byte  68,137,216                          // mov           %r11d,%eax
  .byte  196,195,121,33,4,130,32             // vinsertps     $0x20,(%r10,%rax,4),%xmm0,%xmm0
  .byte  73,193,235,30                       // shr           $0x1e,%r11
  .byte  196,131,121,33,52,26,48             // vinsertps     $0x30,(%r10,%r11,1),%xmm0,%xmm6
  .byte  196,195,57,33,194,32                // vinsertps     $0x20,%xmm10,%xmm8,%xmm0
  .byte  196,195,121,33,196,48               // vinsertps     $0x30,%xmm12,%xmm0,%xmm0
  .byte  196,227,53,24,192,1                 // vinsertf128   $0x1,%xmm0,%ymm9,%ymm0
  .byte  196,227,1,33,202,32                 // vinsertps     $0x20,%xmm2,%xmm15,%xmm1
  .byte  196,227,113,33,203,48               // vinsertps     $0x30,%xmm3,%xmm1,%xmm1
  .byte  196,227,21,24,201,1                 // vinsertf128   $0x1,%xmm1,%ymm13,%ymm1
  .byte  196,195,33,33,214,32                // vinsertps     $0x20,%xmm14,%xmm11,%xmm2
  .byte  196,227,105,33,215,48               // vinsertps     $0x30,%xmm7,%xmm2,%xmm2
  .byte  196,227,77,24,210,1                 // vinsertf128   $0x1,%xmm2,%ymm6,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,73,120,2,0        // vbroadcastss  0x27849(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,16,116,36,168               // vmovups       -0x58(%rsp),%ymm6
  .byte  197,252,16,124,36,200               // vmovups       -0x38(%rsp),%ymm7
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,110,4,72                // vmovd         (%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,1,121,196,92,72,4,2             // vpinsrw       $0x2,0x4(%r8,%r9,2),%xmm0,%xmm11
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,31                              // jne           12a15 <_sk_load_tables_rgb_u16_be_avx+0x28c>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  197,225,239,219                     // vpxor         %xmm3,%xmm3,%xmm3
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  233,199,253,255,255                 // jmpq          127dc <_sk_load_tables_rgb_u16_be_avx+0x53>
  .byte  196,129,121,110,68,72,6             // vmovd         0x6(%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,1,121,196,68,72,10,2            // vpinsrw       $0x2,0xa(%r8,%r9,2),%xmm0,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,48                              // jb            12a5f <_sk_load_tables_rgb_u16_be_avx+0x2d6>
  .byte  196,129,121,110,68,72,12            // vmovd         0xc(%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,129,121,196,92,72,16,2          // vpinsrw       $0x2,0x10(%r8,%r9,2),%xmm0,%xmm3
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  117,48                              // jne           12a79 <_sk_load_tables_rgb_u16_be_avx+0x2f0>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  233,125,253,255,255                 // jmpq          127dc <_sk_load_tables_rgb_u16_be_avx+0x53>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  197,225,239,219                     // vpxor         %xmm3,%xmm3,%xmm3
  .byte  233,99,253,255,255                  // jmpq          127dc <_sk_load_tables_rgb_u16_be_avx+0x53>
  .byte  196,129,121,110,68,72,18            // vmovd         0x12(%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,1,121,196,84,72,22,2            // vpinsrw       $0x2,0x16(%r8,%r9,2),%xmm0,%xmm10
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,39                              // jb            12aba <_sk_load_tables_rgb_u16_be_avx+0x331>
  .byte  196,129,121,110,68,72,24            // vmovd         0x18(%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,129,121,196,84,72,28,2          // vpinsrw       $0x2,0x1c(%r8,%r9,2),%xmm0,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  117,30                              // jne           12acb <_sk_load_tables_rgb_u16_be_avx+0x342>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  233,34,253,255,255                  // jmpq          127dc <_sk_load_tables_rgb_u16_be_avx+0x53>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  233,17,253,255,255                  // jmpq          127dc <_sk_load_tables_rgb_u16_be_avx+0x53>
  .byte  196,129,121,110,68,72,30            // vmovd         0x1e(%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,129,121,196,76,72,34,2          // vpinsrw       $0x2,0x22(%r8,%r9,2),%xmm0,%xmm1
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,25                              // jb            12afe <_sk_load_tables_rgb_u16_be_avx+0x375>
  .byte  196,129,121,110,68,72,36            // vmovd         0x24(%r8,%r9,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,129,121,196,68,72,40,2          // vpinsrw       $0x2,0x28(%r8,%r9,2),%xmm0,%xmm0
  .byte  233,222,252,255,255                 // jmpq          127dc <_sk_load_tables_rgb_u16_be_avx+0x53>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  233,213,252,255,255                 // jmpq          127dc <_sk_load_tables_rgb_u16_be_avx+0x53>

HIDDEN _sk_byte_tables_avx
.globl _sk_byte_tables_avx
FUNCTION(_sk_byte_tables_avx)
_sk_byte_tables_avx:
  .byte  197,252,17,124,36,200               // vmovups       %ymm7,-0x38(%rsp)
  .byte  197,252,40,254                      // vmovaps       %ymm6,%ymm7
  .byte  197,252,40,245                      // vmovaps       %ymm5,%ymm6
  .byte  197,252,40,236                      // vmovaps       %ymm4,%ymm5
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,180,95,192                      // vmaxps        %ymm0,%ymm9,%ymm0
  .byte  196,98,125,24,5,235,118,2,0         // vbroadcastss  0x276eb(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,24,21,9,119,2,0          // vbroadcastss  0x27709(%rip),%ymm10        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,193,124,89,194                  // vmulps        %ymm10,%ymm0,%ymm0
  .byte  197,125,91,216                      // vcvtps2dq     %ymm0,%ymm11
  .byte  196,65,249,126,216                  // vmovq         %xmm11,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  76,139,16                           // mov           (%rax),%r10
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,193,121,110,193                 // vmovd         %r9d,%xmm0
  .byte  196,67,249,22,217,1                 // vpextrq       $0x1,%xmm11,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,67,121,32,224,1                 // vpinsrb       $0x1,%r8d,%xmm0,%xmm12
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  196,99,125,25,216,1                 // vextractf128  $0x1,%ymm11,%xmm0
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,67,25,32,216,2                  // vpinsrb       $0x2,%r8d,%xmm12,%xmm11
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,33,32,217,3                  // vpinsrb       $0x3,%r9d,%xmm11,%xmm11
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,65,121,110,225                  // vmovd         %r9d,%xmm12
  .byte  196,195,249,22,193,1                // vpextrq       $0x1,%xmm0,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,195,25,32,192,1                 // vpinsrb       $0x1,%r8d,%xmm12,%xmm0
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,195,121,32,192,2                // vpinsrb       $0x2,%r8d,%xmm0,%xmm0
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,121,32,233,3                 // vpinsrb       $0x3,%r9d,%xmm0,%xmm13
  .byte  197,180,95,201                      // vmaxps        %ymm1,%ymm9,%ymm1
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  196,193,116,89,202                  // vmulps        %ymm10,%ymm1,%ymm1
  .byte  197,253,91,201                      // vcvtps2dq     %ymm1,%ymm1
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,193,121,110,194                 // vmovd         %r10d,%xmm0
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,1                // vpinsrb       $0x1,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,25,201,1                // vextractf128  $0x1,%ymm1,%xmm1
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,67,121,32,226,3                 // vpinsrb       $0x3,%r10d,%xmm0,%xmm12
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,193,121,110,194                 // vmovd         %r10d,%xmm0
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,1                // vpinsrb       $0x1,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  71,15,182,4,16                      // movzbl        (%r8,%r10,1),%r8d
  .byte  196,67,121,32,240,3                 // vpinsrb       $0x3,%r8d,%xmm0,%xmm14
  .byte  76,139,64,16                        // mov           0x10(%rax),%r8
  .byte  197,180,95,194                      // vmaxps        %ymm2,%ymm9,%ymm0
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,193,124,89,194                  // vmulps        %ymm10,%ymm0,%ymm0
  .byte  197,253,91,208                      // vcvtps2dq     %ymm0,%ymm2
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,193,121,110,194                 // vmovd         %r10d,%xmm0
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,1                // vpinsrb       $0x1,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,25,209,1                // vextractf128  $0x1,%ymm2,%xmm1
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,67,121,32,250,3                 // vpinsrb       $0x3,%r10d,%xmm0,%xmm15
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,193,121,110,194                 // vmovd         %r10d,%xmm0
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,1                // vpinsrb       $0x1,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  197,180,95,203                      // vmaxps        %ymm3,%ymm9,%ymm1
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,182,4,16                      // movzbl        (%r8,%r10,1),%r8d
  .byte  196,195,121,32,224,3                // vpinsrb       $0x3,%r8d,%xmm0,%xmm4
  .byte  76,139,72,24                        // mov           0x18(%rax),%r9
  .byte  196,193,116,93,192                  // vminps        %ymm8,%ymm1,%ymm0
  .byte  196,193,124,89,194                  // vmulps        %ymm10,%ymm0,%ymm0
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  197,249,110,200                     // vmovd         %eax,%xmm1
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  67,15,182,4,1                       // movzbl        (%r9,%r8,1),%eax
  .byte  196,227,113,32,200,1                // vpinsrb       $0x1,%eax,%xmm1,%xmm1
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,25,192,1                // vextractf128  $0x1,%ymm0,%xmm0
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,113,32,200,2                // vpinsrb       $0x2,%eax,%xmm1,%xmm1
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  67,15,182,4,17                      // movzbl        (%r9,%r10,1),%eax
  .byte  196,99,113,32,192,3                 // vpinsrb       $0x3,%eax,%xmm1,%xmm8
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  197,249,110,200                     // vmovd         %eax,%xmm1
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  67,15,182,4,1                       // movzbl        (%r9,%r8,1),%eax
  .byte  196,227,113,32,192,1                // vpinsrb       $0x1,%eax,%xmm1,%xmm0
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,121,32,216,2                // vpinsrb       $0x2,%eax,%xmm0,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  67,15,182,4,17                      // movzbl        (%r9,%r10,1),%eax
  .byte  196,194,121,49,195                  // vpmovzxbd     %xmm11,%xmm0
  .byte  196,194,121,49,205                  // vpmovzxbd     %xmm13,%xmm1
  .byte  196,227,125,24,193,1                // vinsertf128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,13,186,116,2,0        // vbroadcastss  0x274ba(%rip),%ymm9        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  196,194,121,49,204                  // vpmovzxbd     %xmm12,%xmm1
  .byte  196,194,121,49,214                  // vpmovzxbd     %xmm14,%xmm2
  .byte  196,227,117,24,202,1                // vinsertf128   $0x1,%xmm2,%ymm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,201                  // vmulps        %ymm9,%ymm1,%ymm1
  .byte  196,194,121,49,215                  // vpmovzxbd     %xmm15,%xmm2
  .byte  196,226,121,49,228                  // vpmovzxbd     %xmm4,%xmm4
  .byte  196,227,109,24,212,1                // vinsertf128   $0x1,%xmm4,%ymm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,209                  // vmulps        %ymm9,%ymm2,%ymm2
  .byte  196,194,121,49,224                  // vpmovzxbd     %xmm8,%xmm4
  .byte  196,227,97,32,216,3                 // vpinsrb       $0x3,%eax,%xmm3,%xmm3
  .byte  196,226,121,49,219                  // vpmovzxbd     %xmm3,%xmm3
  .byte  196,227,93,24,219,1                 // vinsertf128   $0x1,%xmm3,%ymm4,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,217                  // vmulps        %ymm9,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,229                      // vmovaps       %ymm5,%ymm4
  .byte  197,252,40,238                      // vmovaps       %ymm6,%ymm5
  .byte  197,252,40,247                      // vmovaps       %ymm7,%ymm6
  .byte  197,252,16,124,36,200               // vmovups       -0x38(%rsp),%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_byte_tables_rgb_avx
.globl _sk_byte_tables_rgb_avx
FUNCTION(_sk_byte_tables_rgb_avx)
_sk_byte_tables_rgb_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,24                        // mov           0x18(%rax),%r8d
  .byte  65,255,200                          // dec           %r8d
  .byte  196,65,121,110,192                  // vmovd         %r8d,%xmm8
  .byte  196,65,121,112,192,0                // vpshufd       $0x0,%xmm8,%xmm8
  .byte  196,67,61,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,180,95,192                      // vmaxps        %ymm0,%ymm9,%ymm0
  .byte  196,98,125,24,21,165,115,2,0        // vbroadcastss  0x273a5(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,194                  // vminps        %ymm10,%ymm0,%ymm0
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  197,125,91,216                      // vcvtps2dq     %ymm0,%ymm11
  .byte  196,65,249,126,216                  // vmovq         %xmm11,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  76,139,16                           // mov           (%rax),%r10
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,193,121,110,193                 // vmovd         %r9d,%xmm0
  .byte  196,67,249,22,217,1                 // vpextrq       $0x1,%xmm11,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,67,121,32,224,1                 // vpinsrb       $0x1,%r8d,%xmm0,%xmm12
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  196,99,125,25,216,1                 // vextractf128  $0x1,%ymm11,%xmm0
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,67,25,32,216,2                  // vpinsrb       $0x2,%r8d,%xmm12,%xmm11
  .byte  196,193,249,126,192                 // vmovq         %xmm0,%r8
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,33,32,217,3                  // vpinsrb       $0x3,%r9d,%xmm11,%xmm11
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,65,121,110,225                  // vmovd         %r9d,%xmm12
  .byte  196,195,249,22,193,1                // vpextrq       $0x1,%xmm0,%r9
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,195,25,32,192,1                 // vpinsrb       $0x1,%r8d,%xmm12,%xmm0
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,4,2                       // movzbl        (%r10,%r8,1),%r8d
  .byte  196,195,121,32,192,2                // vpinsrb       $0x2,%r8d,%xmm0,%xmm0
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  71,15,182,12,10                     // movzbl        (%r10,%r9,1),%r9d
  .byte  196,67,121,32,233,3                 // vpinsrb       $0x3,%r9d,%xmm0,%xmm13
  .byte  197,180,95,201                      // vmaxps        %ymm1,%ymm9,%ymm1
  .byte  196,193,116,93,202                  // vminps        %ymm10,%ymm1,%ymm1
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  197,253,91,201                      // vcvtps2dq     %ymm1,%ymm1
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,193,121,110,194                 // vmovd         %r10d,%xmm0
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,1                // vpinsrb       $0x1,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,25,201,1                // vextractf128  $0x1,%ymm1,%xmm1
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,67,121,32,226,3                 // vpinsrb       $0x3,%r10d,%xmm0,%xmm12
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  196,193,121,110,194                 // vmovd         %r10d,%xmm0
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,1                // vpinsrb       $0x1,%r9d,%xmm0,%xmm0
  .byte  69,137,209                          // mov           %r10d,%r9d
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  196,195,121,32,193,2                // vpinsrb       $0x2,%r9d,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,182,4,16                      // movzbl        (%r8,%r10,1),%r8d
  .byte  196,67,121,32,240,3                 // vpinsrb       $0x3,%r8d,%xmm0,%xmm14
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  197,180,95,194                      // vmaxps        %ymm2,%ymm9,%ymm0
  .byte  196,193,124,93,194                  // vminps        %ymm10,%ymm0,%ymm0
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  197,253,91,208                      // vcvtps2dq     %ymm0,%ymm2
  .byte  196,193,249,126,208                 // vmovq         %xmm2,%r8
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  67,15,182,4,1                       // movzbl        (%r9,%r8,1),%eax
  .byte  196,227,121,32,192,1                // vpinsrb       $0x1,%eax,%xmm0,%xmm0
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,25,210,1                // vextractf128  $0x1,%ymm2,%xmm2
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,227,121,32,192,2                // vpinsrb       $0x2,%eax,%xmm0,%xmm0
  .byte  196,193,249,126,208                 // vmovq         %xmm2,%r8
  .byte  67,15,182,4,17                      // movzbl        (%r9,%r10,1),%eax
  .byte  196,99,121,32,192,3                 // vpinsrb       $0x3,%eax,%xmm0,%xmm8
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  67,15,182,4,1                       // movzbl        (%r9,%r8,1),%eax
  .byte  196,227,121,32,192,1                // vpinsrb       $0x1,%eax,%xmm0,%xmm0
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  65,15,182,4,1                       // movzbl        (%r9,%rax,1),%eax
  .byte  196,99,121,32,208,2                 // vpinsrb       $0x2,%eax,%xmm0,%xmm10
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  67,15,182,4,17                      // movzbl        (%r9,%r10,1),%eax
  .byte  196,194,121,49,195                  // vpmovzxbd     %xmm11,%xmm0
  .byte  196,194,121,49,205                  // vpmovzxbd     %xmm13,%xmm1
  .byte  196,227,125,24,193,1                // vinsertf128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,13,35,114,2,0         // vbroadcastss  0x27223(%rip),%ymm9        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  196,194,121,49,204                  // vpmovzxbd     %xmm12,%xmm1
  .byte  196,194,121,49,214                  // vpmovzxbd     %xmm14,%xmm2
  .byte  196,227,117,24,202,1                // vinsertf128   $0x1,%xmm2,%ymm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,201                  // vmulps        %ymm9,%ymm1,%ymm1
  .byte  196,66,121,49,192                   // vpmovzxbd     %xmm8,%xmm8
  .byte  196,227,41,32,208,3                 // vpinsrb       $0x3,%eax,%xmm10,%xmm2
  .byte  196,226,121,49,210                  // vpmovzxbd     %xmm2,%xmm2
  .byte  196,227,61,24,210,1                 // vinsertf128   $0x1,%xmm2,%ymm8,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,209                  // vmulps        %ymm9,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_r_avx
.globl _sk_table_r_avx
FUNCTION(_sk_table_r_avx)
_sk_table_r_avx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  196,65,121,112,192,0                // vpshufd       $0x0,%xmm8,%xmm8
  .byte  196,67,61,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,180,95,192                      // vmaxps        %ymm0,%ymm9,%ymm0
  .byte  196,98,125,24,13,50,113,2,0         // vbroadcastss  0x27132(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,193                  // vminps        %ymm9,%ymm0,%ymm0
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,227,249,22,192,1                // vpextrq       $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,194                 // vmovq         %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,25,192,1                // vextractf128  $0x1,%ymm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  196,129,122,16,4,160                // vmovss        (%r8,%r12,4),%xmm0
  .byte  196,3,121,33,4,184,16               // vinsertps     $0x10,(%r8,%r15,4),%xmm0,%xmm8
  .byte  196,129,122,16,4,176                // vmovss        (%r8,%r14,4),%xmm0
  .byte  196,99,57,33,192,32                 // vinsertps     $0x20,%xmm0,%xmm8,%xmm8
  .byte  196,193,122,16,4,152                // vmovss        (%r8,%rbx,4),%xmm0
  .byte  196,99,57,33,192,48                 // vinsertps     $0x30,%xmm0,%xmm8,%xmm8
  .byte  196,129,122,16,4,152                // vmovss        (%r8,%r11,4),%xmm0
  .byte  196,3,121,33,12,144,16              // vinsertps     $0x10,(%r8,%r10,4),%xmm0,%xmm9
  .byte  196,129,122,16,4,136                // vmovss        (%r8,%r9,4),%xmm0
  .byte  196,99,49,33,200,32                 // vinsertps     $0x20,%xmm0,%xmm9,%xmm9
  .byte  196,193,122,16,4,128                // vmovss        (%r8,%rax,4),%xmm0
  .byte  196,227,49,33,192,48                // vinsertps     $0x30,%xmm0,%xmm9,%xmm0
  .byte  196,195,125,24,192,1                // vinsertf128   $0x1,%xmm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_g_avx
.globl _sk_table_g_avx
FUNCTION(_sk_table_g_avx)
_sk_table_g_avx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  196,65,121,112,192,0                // vpshufd       $0x0,%xmm8,%xmm8
  .byte  196,67,61,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,180,95,201                      // vmaxps        %ymm1,%ymm9,%ymm1
  .byte  196,98,125,24,13,89,112,2,0         // vbroadcastss  0x27059(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,116,93,201                  // vminps        %ymm9,%ymm1,%ymm1
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  197,253,91,201                      // vcvtps2dq     %ymm1,%ymm1
  .byte  196,227,249,22,200,1                // vpextrq       $0x1,%xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,202                 // vmovq         %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,25,201,1                // vextractf128  $0x1,%ymm1,%xmm1
  .byte  196,227,249,22,203,1                // vpextrq       $0x1,%xmm1,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,207                 // vmovq         %xmm1,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  196,129,122,16,12,160               // vmovss        (%r8,%r12,4),%xmm1
  .byte  196,3,113,33,4,184,16               // vinsertps     $0x10,(%r8,%r15,4),%xmm1,%xmm8
  .byte  196,129,122,16,12,176               // vmovss        (%r8,%r14,4),%xmm1
  .byte  196,99,57,33,193,32                 // vinsertps     $0x20,%xmm1,%xmm8,%xmm8
  .byte  196,193,122,16,12,152               // vmovss        (%r8,%rbx,4),%xmm1
  .byte  196,99,57,33,193,48                 // vinsertps     $0x30,%xmm1,%xmm8,%xmm8
  .byte  196,129,122,16,12,152               // vmovss        (%r8,%r11,4),%xmm1
  .byte  196,3,113,33,12,144,16              // vinsertps     $0x10,(%r8,%r10,4),%xmm1,%xmm9
  .byte  196,129,122,16,12,136               // vmovss        (%r8,%r9,4),%xmm1
  .byte  196,99,49,33,201,32                 // vinsertps     $0x20,%xmm1,%xmm9,%xmm9
  .byte  196,193,122,16,12,128               // vmovss        (%r8,%rax,4),%xmm1
  .byte  196,227,49,33,201,48                // vinsertps     $0x30,%xmm1,%xmm9,%xmm1
  .byte  196,195,117,24,200,1                // vinsertf128   $0x1,%xmm8,%ymm1,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_b_avx
.globl _sk_table_b_avx
FUNCTION(_sk_table_b_avx)
_sk_table_b_avx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  196,65,121,112,192,0                // vpshufd       $0x0,%xmm8,%xmm8
  .byte  196,67,61,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,180,95,210                      // vmaxps        %ymm2,%ymm9,%ymm2
  .byte  196,98,125,24,13,128,111,2,0        // vbroadcastss  0x26f80(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,108,93,209                  // vminps        %ymm9,%ymm2,%ymm2
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  197,253,91,210                      // vcvtps2dq     %ymm2,%ymm2
  .byte  196,227,249,22,208,1                // vpextrq       $0x1,%xmm2,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,210                 // vmovq         %xmm2,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,25,210,1                // vextractf128  $0x1,%ymm2,%xmm2
  .byte  196,227,249,22,211,1                // vpextrq       $0x1,%xmm2,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,215                 // vmovq         %xmm2,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  196,129,122,16,20,160               // vmovss        (%r8,%r12,4),%xmm2
  .byte  196,3,105,33,4,184,16               // vinsertps     $0x10,(%r8,%r15,4),%xmm2,%xmm8
  .byte  196,129,122,16,20,176               // vmovss        (%r8,%r14,4),%xmm2
  .byte  196,99,57,33,194,32                 // vinsertps     $0x20,%xmm2,%xmm8,%xmm8
  .byte  196,193,122,16,20,152               // vmovss        (%r8,%rbx,4),%xmm2
  .byte  196,99,57,33,194,48                 // vinsertps     $0x30,%xmm2,%xmm8,%xmm8
  .byte  196,129,122,16,20,152               // vmovss        (%r8,%r11,4),%xmm2
  .byte  196,3,105,33,12,144,16              // vinsertps     $0x10,(%r8,%r10,4),%xmm2,%xmm9
  .byte  196,129,122,16,20,136               // vmovss        (%r8,%r9,4),%xmm2
  .byte  196,99,49,33,202,32                 // vinsertps     $0x20,%xmm2,%xmm9,%xmm9
  .byte  196,193,122,16,20,128               // vmovss        (%r8,%rax,4),%xmm2
  .byte  196,227,49,33,210,48                // vinsertps     $0x30,%xmm2,%xmm9,%xmm2
  .byte  196,195,109,24,208,1                // vinsertf128   $0x1,%xmm8,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_a_avx
.globl _sk_table_a_avx
FUNCTION(_sk_table_a_avx)
_sk_table_a_avx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  196,65,121,112,192,0                // vpshufd       $0x0,%xmm8,%xmm8
  .byte  196,67,61,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm8,%ymm8
  .byte  196,65,124,91,192                   // vcvtdq2ps     %ymm8,%ymm8
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,180,95,219                      // vmaxps        %ymm3,%ymm9,%ymm3
  .byte  196,98,125,24,13,167,110,2,0        // vbroadcastss  0x26ea7(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,100,93,217                  // vminps        %ymm9,%ymm3,%ymm3
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  197,253,91,219                      // vcvtps2dq     %ymm3,%ymm3
  .byte  196,227,249,22,216,1                // vpextrq       $0x1,%xmm3,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,218                 // vmovq         %xmm3,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,25,219,1                // vextractf128  $0x1,%ymm3,%xmm3
  .byte  196,227,249,22,219,1                // vpextrq       $0x1,%xmm3,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,223                 // vmovq         %xmm3,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  196,129,122,16,28,160               // vmovss        (%r8,%r12,4),%xmm3
  .byte  196,3,97,33,4,184,16                // vinsertps     $0x10,(%r8,%r15,4),%xmm3,%xmm8
  .byte  196,129,122,16,28,176               // vmovss        (%r8,%r14,4),%xmm3
  .byte  196,99,57,33,195,32                 // vinsertps     $0x20,%xmm3,%xmm8,%xmm8
  .byte  196,193,122,16,28,152               // vmovss        (%r8,%rbx,4),%xmm3
  .byte  196,99,57,33,195,48                 // vinsertps     $0x30,%xmm3,%xmm8,%xmm8
  .byte  196,129,122,16,28,152               // vmovss        (%r8,%r11,4),%xmm3
  .byte  196,3,97,33,12,144,16               // vinsertps     $0x10,(%r8,%r10,4),%xmm3,%xmm9
  .byte  196,129,122,16,28,136               // vmovss        (%r8,%r9,4),%xmm3
  .byte  196,99,49,33,203,32                 // vinsertps     $0x20,%xmm3,%xmm9,%xmm9
  .byte  196,193,122,16,28,128               // vmovss        (%r8,%rax,4),%xmm3
  .byte  196,227,49,33,219,48                // vinsertps     $0x30,%xmm3,%xmm9,%xmm3
  .byte  196,195,101,24,216,1                // vinsertf128   $0x1,%xmm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_r_avx
.globl _sk_parametric_r_avx
FUNCTION(_sk_parametric_r_avx)
_sk_parametric_r_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,16                 // vbroadcastss  0x10(%rax),%ymm8
  .byte  196,65,124,194,192,2                // vcmpleps      %ymm8,%ymm0,%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,98,125,24,80,24                 // vbroadcastss  0x18(%rax),%ymm10
  .byte  197,52,89,200                       // vmulps        %ymm0,%ymm9,%ymm9
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  196,98,125,24,88,8                  // vbroadcastss  0x8(%rax),%ymm11
  .byte  197,172,89,192                      // vmulps        %ymm0,%ymm10,%ymm0
  .byte  196,65,124,88,219                   // vaddps        %ymm11,%ymm0,%ymm11
  .byte  196,98,125,24,32                    // vbroadcastss  (%rax),%ymm12
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,36,194,208,0                    // vcmpeqps      %ymm0,%ymm11,%ymm10
  .byte  196,65,124,91,235                   // vcvtdq2ps     %ymm11,%ymm13
  .byte  196,98,125,24,53,74,110,2,0         // vbroadcastss  0x26e4a(%rip),%ymm14        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  196,65,20,89,238                    // vmulps        %ymm14,%ymm13,%ymm13
  .byte  196,98,125,24,53,64,110,2,0         // vbroadcastss  0x26e40(%rip),%ymm14        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  196,65,36,84,222                    // vandps        %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,146,109,2,0        // vbroadcastss  0x26d92(%rip),%ymm14        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,36,86,222                    // vorps         %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,40,110,2,0         // vbroadcastss  0x26e28(%rip),%ymm14        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  196,65,20,88,238                    // vaddps        %ymm14,%ymm13,%ymm13
  .byte  196,98,125,24,53,30,110,2,0         // vbroadcastss  0x26e1e(%rip),%ymm14        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,65,36,89,246                    // vmulps        %ymm14,%ymm11,%ymm14
  .byte  196,65,20,92,238                    // vsubps        %ymm14,%ymm13,%ymm13
  .byte  196,98,125,24,53,15,110,2,0         // vbroadcastss  0x26e0f(%rip),%ymm14        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,65,36,88,222                    // vaddps        %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,5,110,2,0          // vbroadcastss  0x26e05(%rip),%ymm14        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,12,94,219                    // vdivps        %ymm11,%ymm14,%ymm11
  .byte  196,65,20,92,219                    // vsubps        %ymm11,%ymm13,%ymm11
  .byte  196,65,28,89,219                    // vmulps        %ymm11,%ymm12,%ymm11
  .byte  196,67,125,8,227,1                  // vroundps      $0x1,%ymm11,%ymm12
  .byte  196,65,36,92,228                    // vsubps        %ymm12,%ymm11,%ymm12
  .byte  196,98,125,24,45,230,109,2,0        // vbroadcastss  0x26de6(%rip),%ymm13        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  196,65,36,88,221                    // vaddps        %ymm13,%ymm11,%ymm11
  .byte  196,98,125,24,45,220,109,2,0        // vbroadcastss  0x26ddc(%rip),%ymm13        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,65,28,89,237                    // vmulps        %ymm13,%ymm12,%ymm13
  .byte  196,65,36,92,221                    // vsubps        %ymm13,%ymm11,%ymm11
  .byte  196,98,125,24,45,205,109,2,0        // vbroadcastss  0x26dcd(%rip),%ymm13        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  196,65,20,92,228                    // vsubps        %ymm12,%ymm13,%ymm12
  .byte  196,98,125,24,45,195,109,2,0        // vbroadcastss  0x26dc3(%rip),%ymm13        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  196,65,20,94,228                    // vdivps        %ymm12,%ymm13,%ymm12
  .byte  196,65,36,88,220                    // vaddps        %ymm12,%ymm11,%ymm11
  .byte  196,98,125,24,37,180,109,2,0        // vbroadcastss  0x26db4(%rip),%ymm12        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  196,65,36,89,220                    // vmulps        %ymm12,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,99,37,74,208,160                // vblendvps     %ymm10,%ymm0,%ymm11,%ymm10
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,67,45,74,193,128                // vblendvps     %ymm8,%ymm9,%ymm10,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  196,98,125,24,5,198,108,2,0         // vbroadcastss  0x26cc6(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_g_avx
.globl _sk_parametric_g_avx
FUNCTION(_sk_parametric_g_avx)
_sk_parametric_g_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,16                 // vbroadcastss  0x10(%rax),%ymm8
  .byte  196,65,116,194,192,2                // vcmpleps      %ymm8,%ymm1,%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,98,125,24,80,24                 // vbroadcastss  0x18(%rax),%ymm10
  .byte  197,52,89,201                       // vmulps        %ymm1,%ymm9,%ymm9
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  196,98,125,24,88,8                  // vbroadcastss  0x8(%rax),%ymm11
  .byte  197,172,89,201                      // vmulps        %ymm1,%ymm10,%ymm1
  .byte  196,65,116,88,219                   // vaddps        %ymm11,%ymm1,%ymm11
  .byte  196,98,125,24,32                    // vbroadcastss  (%rax),%ymm12
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,36,194,209,0                    // vcmpeqps      %ymm1,%ymm11,%ymm10
  .byte  196,65,124,91,235                   // vcvtdq2ps     %ymm11,%ymm13
  .byte  196,98,125,24,53,1,109,2,0          // vbroadcastss  0x26d01(%rip),%ymm14        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  196,65,20,89,238                    // vmulps        %ymm14,%ymm13,%ymm13
  .byte  196,98,125,24,53,247,108,2,0        // vbroadcastss  0x26cf7(%rip),%ymm14        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  196,65,36,84,222                    // vandps        %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,73,108,2,0         // vbroadcastss  0x26c49(%rip),%ymm14        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,36,86,222                    // vorps         %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,223,108,2,0        // vbroadcastss  0x26cdf(%rip),%ymm14        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  196,65,20,88,238                    // vaddps        %ymm14,%ymm13,%ymm13
  .byte  196,98,125,24,53,213,108,2,0        // vbroadcastss  0x26cd5(%rip),%ymm14        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,65,36,89,246                    // vmulps        %ymm14,%ymm11,%ymm14
  .byte  196,65,20,92,238                    // vsubps        %ymm14,%ymm13,%ymm13
  .byte  196,98,125,24,53,198,108,2,0        // vbroadcastss  0x26cc6(%rip),%ymm14        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,65,36,88,222                    // vaddps        %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,188,108,2,0        // vbroadcastss  0x26cbc(%rip),%ymm14        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,12,94,219                    // vdivps        %ymm11,%ymm14,%ymm11
  .byte  196,65,20,92,219                    // vsubps        %ymm11,%ymm13,%ymm11
  .byte  196,65,28,89,219                    // vmulps        %ymm11,%ymm12,%ymm11
  .byte  196,67,125,8,227,1                  // vroundps      $0x1,%ymm11,%ymm12
  .byte  196,65,36,92,228                    // vsubps        %ymm12,%ymm11,%ymm12
  .byte  196,98,125,24,45,157,108,2,0        // vbroadcastss  0x26c9d(%rip),%ymm13        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  196,65,36,88,221                    // vaddps        %ymm13,%ymm11,%ymm11
  .byte  196,98,125,24,45,147,108,2,0        // vbroadcastss  0x26c93(%rip),%ymm13        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,65,28,89,237                    // vmulps        %ymm13,%ymm12,%ymm13
  .byte  196,65,36,92,221                    // vsubps        %ymm13,%ymm11,%ymm11
  .byte  196,98,125,24,45,132,108,2,0        // vbroadcastss  0x26c84(%rip),%ymm13        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  196,65,20,92,228                    // vsubps        %ymm12,%ymm13,%ymm12
  .byte  196,98,125,24,45,122,108,2,0        // vbroadcastss  0x26c7a(%rip),%ymm13        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  196,65,20,94,228                    // vdivps        %ymm12,%ymm13,%ymm12
  .byte  196,65,36,88,220                    // vaddps        %ymm12,%ymm11,%ymm11
  .byte  196,98,125,24,37,107,108,2,0        // vbroadcastss  0x26c6b(%rip),%ymm12        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  196,65,36,89,220                    // vmulps        %ymm12,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,99,37,74,209,160                // vblendvps     %ymm10,%ymm1,%ymm11,%ymm10
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,67,45,74,193,128                // vblendvps     %ymm8,%ymm9,%ymm10,%ymm8
  .byte  197,188,95,201                      // vmaxps        %ymm1,%ymm8,%ymm1
  .byte  196,98,125,24,5,125,107,2,0         // vbroadcastss  0x26b7d(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_b_avx
.globl _sk_parametric_b_avx
FUNCTION(_sk_parametric_b_avx)
_sk_parametric_b_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,16                 // vbroadcastss  0x10(%rax),%ymm8
  .byte  196,65,108,194,192,2                // vcmpleps      %ymm8,%ymm2,%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,98,125,24,80,24                 // vbroadcastss  0x18(%rax),%ymm10
  .byte  197,52,89,202                       // vmulps        %ymm2,%ymm9,%ymm9
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  196,98,125,24,88,8                  // vbroadcastss  0x8(%rax),%ymm11
  .byte  197,172,89,210                      // vmulps        %ymm2,%ymm10,%ymm2
  .byte  196,65,108,88,219                   // vaddps        %ymm11,%ymm2,%ymm11
  .byte  196,98,125,24,32                    // vbroadcastss  (%rax),%ymm12
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,36,194,210,0                    // vcmpeqps      %ymm2,%ymm11,%ymm10
  .byte  196,65,124,91,235                   // vcvtdq2ps     %ymm11,%ymm13
  .byte  196,98,125,24,53,184,107,2,0        // vbroadcastss  0x26bb8(%rip),%ymm14        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  196,65,20,89,238                    // vmulps        %ymm14,%ymm13,%ymm13
  .byte  196,98,125,24,53,174,107,2,0        // vbroadcastss  0x26bae(%rip),%ymm14        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  196,65,36,84,222                    // vandps        %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,0,107,2,0          // vbroadcastss  0x26b00(%rip),%ymm14        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,36,86,222                    // vorps         %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,150,107,2,0        // vbroadcastss  0x26b96(%rip),%ymm14        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  196,65,20,88,238                    // vaddps        %ymm14,%ymm13,%ymm13
  .byte  196,98,125,24,53,140,107,2,0        // vbroadcastss  0x26b8c(%rip),%ymm14        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,65,36,89,246                    // vmulps        %ymm14,%ymm11,%ymm14
  .byte  196,65,20,92,238                    // vsubps        %ymm14,%ymm13,%ymm13
  .byte  196,98,125,24,53,125,107,2,0        // vbroadcastss  0x26b7d(%rip),%ymm14        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,65,36,88,222                    // vaddps        %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,115,107,2,0        // vbroadcastss  0x26b73(%rip),%ymm14        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,12,94,219                    // vdivps        %ymm11,%ymm14,%ymm11
  .byte  196,65,20,92,219                    // vsubps        %ymm11,%ymm13,%ymm11
  .byte  196,65,28,89,219                    // vmulps        %ymm11,%ymm12,%ymm11
  .byte  196,67,125,8,227,1                  // vroundps      $0x1,%ymm11,%ymm12
  .byte  196,65,36,92,228                    // vsubps        %ymm12,%ymm11,%ymm12
  .byte  196,98,125,24,45,84,107,2,0         // vbroadcastss  0x26b54(%rip),%ymm13        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  196,65,36,88,221                    // vaddps        %ymm13,%ymm11,%ymm11
  .byte  196,98,125,24,45,74,107,2,0         // vbroadcastss  0x26b4a(%rip),%ymm13        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,65,28,89,237                    // vmulps        %ymm13,%ymm12,%ymm13
  .byte  196,65,36,92,221                    // vsubps        %ymm13,%ymm11,%ymm11
  .byte  196,98,125,24,45,59,107,2,0         // vbroadcastss  0x26b3b(%rip),%ymm13        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  196,65,20,92,228                    // vsubps        %ymm12,%ymm13,%ymm12
  .byte  196,98,125,24,45,49,107,2,0         // vbroadcastss  0x26b31(%rip),%ymm13        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  196,65,20,94,228                    // vdivps        %ymm12,%ymm13,%ymm12
  .byte  196,65,36,88,220                    // vaddps        %ymm12,%ymm11,%ymm11
  .byte  196,98,125,24,37,34,107,2,0         // vbroadcastss  0x26b22(%rip),%ymm12        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  196,65,36,89,220                    // vmulps        %ymm12,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,99,37,74,210,160                // vblendvps     %ymm10,%ymm2,%ymm11,%ymm10
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,67,45,74,193,128                // vblendvps     %ymm8,%ymm9,%ymm10,%ymm8
  .byte  197,188,95,210                      // vmaxps        %ymm2,%ymm8,%ymm2
  .byte  196,98,125,24,5,52,106,2,0          // vbroadcastss  0x26a34(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,108,93,208                  // vminps        %ymm8,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_a_avx
.globl _sk_parametric_a_avx
FUNCTION(_sk_parametric_a_avx)
_sk_parametric_a_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,16                 // vbroadcastss  0x10(%rax),%ymm8
  .byte  196,65,100,194,192,2                // vcmpleps      %ymm8,%ymm3,%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,98,125,24,80,24                 // vbroadcastss  0x18(%rax),%ymm10
  .byte  197,52,89,203                       // vmulps        %ymm3,%ymm9,%ymm9
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  196,98,125,24,88,8                  // vbroadcastss  0x8(%rax),%ymm11
  .byte  197,172,89,219                      // vmulps        %ymm3,%ymm10,%ymm3
  .byte  196,65,100,88,219                   // vaddps        %ymm11,%ymm3,%ymm11
  .byte  196,98,125,24,32                    // vbroadcastss  (%rax),%ymm12
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,36,194,211,0                    // vcmpeqps      %ymm3,%ymm11,%ymm10
  .byte  196,65,124,91,235                   // vcvtdq2ps     %ymm11,%ymm13
  .byte  196,98,125,24,53,111,106,2,0        // vbroadcastss  0x26a6f(%rip),%ymm14        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  196,65,20,89,238                    // vmulps        %ymm14,%ymm13,%ymm13
  .byte  196,98,125,24,53,101,106,2,0        // vbroadcastss  0x26a65(%rip),%ymm14        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  196,65,36,84,222                    // vandps        %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,183,105,2,0        // vbroadcastss  0x269b7(%rip),%ymm14        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,36,86,222                    // vorps         %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,77,106,2,0         // vbroadcastss  0x26a4d(%rip),%ymm14        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  196,65,20,88,238                    // vaddps        %ymm14,%ymm13,%ymm13
  .byte  196,98,125,24,53,67,106,2,0         // vbroadcastss  0x26a43(%rip),%ymm14        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,65,36,89,246                    // vmulps        %ymm14,%ymm11,%ymm14
  .byte  196,65,20,92,238                    // vsubps        %ymm14,%ymm13,%ymm13
  .byte  196,98,125,24,53,52,106,2,0         // vbroadcastss  0x26a34(%rip),%ymm14        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,65,36,88,222                    // vaddps        %ymm14,%ymm11,%ymm11
  .byte  196,98,125,24,53,42,106,2,0         // vbroadcastss  0x26a2a(%rip),%ymm14        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  196,65,12,94,219                    // vdivps        %ymm11,%ymm14,%ymm11
  .byte  196,65,20,92,219                    // vsubps        %ymm11,%ymm13,%ymm11
  .byte  196,65,28,89,219                    // vmulps        %ymm11,%ymm12,%ymm11
  .byte  196,67,125,8,227,1                  // vroundps      $0x1,%ymm11,%ymm12
  .byte  196,65,36,92,228                    // vsubps        %ymm12,%ymm11,%ymm12
  .byte  196,98,125,24,45,11,106,2,0         // vbroadcastss  0x26a0b(%rip),%ymm13        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  196,65,36,88,221                    // vaddps        %ymm13,%ymm11,%ymm11
  .byte  196,98,125,24,45,1,106,2,0          // vbroadcastss  0x26a01(%rip),%ymm13        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,65,28,89,237                    // vmulps        %ymm13,%ymm12,%ymm13
  .byte  196,65,36,92,221                    // vsubps        %ymm13,%ymm11,%ymm11
  .byte  196,98,125,24,45,242,105,2,0        // vbroadcastss  0x269f2(%rip),%ymm13        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  196,65,20,92,228                    // vsubps        %ymm12,%ymm13,%ymm12
  .byte  196,98,125,24,45,232,105,2,0        // vbroadcastss  0x269e8(%rip),%ymm13        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  196,65,20,94,228                    // vdivps        %ymm12,%ymm13,%ymm12
  .byte  196,65,36,88,220                    // vaddps        %ymm12,%ymm11,%ymm11
  .byte  196,98,125,24,37,217,105,2,0        // vbroadcastss  0x269d9(%rip),%ymm12        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  196,65,36,89,220                    // vmulps        %ymm12,%ymm11,%ymm11
  .byte  196,65,125,91,219                   // vcvtps2dq     %ymm11,%ymm11
  .byte  196,99,37,74,211,160                // vblendvps     %ymm10,%ymm3,%ymm11,%ymm10
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,67,45,74,193,128                // vblendvps     %ymm8,%ymm9,%ymm10,%ymm8
  .byte  197,188,95,219                      // vmaxps        %ymm3,%ymm8,%ymm3
  .byte  196,98,125,24,5,235,104,2,0         // vbroadcastss  0x268eb(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gamma_avx
.globl _sk_gamma_avx
FUNCTION(_sk_gamma_avx)
_sk_gamma_avx:
  .byte  72,129,236,184,0,0,0                // sub           $0xb8,%rsp
  .byte  197,252,17,188,36,128,0,0,0         // vmovups       %ymm7,0x80(%rsp)
  .byte  197,252,17,116,36,96                // vmovups       %ymm6,0x60(%rsp)
  .byte  197,252,17,108,36,64                // vmovups       %ymm5,0x40(%rsp)
  .byte  197,252,17,100,36,32                // vmovups       %ymm4,0x20(%rsp)
  .byte  197,252,17,28,36                    // vmovups       %ymm3,(%rsp)
  .byte  197,252,17,84,36,224                // vmovups       %ymm2,-0x20(%rsp)
  .byte  197,252,17,76,36,128                // vmovups       %ymm1,-0x80(%rsp)
  .byte  197,252,40,224                      // vmovaps       %ymm0,%ymm4
  .byte  197,252,91,204                      // vcvtdq2ps     %ymm4,%ymm1
  .byte  196,226,125,24,5,54,105,2,0         // vbroadcastss  0x26936(%rip),%ymm0        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  197,244,89,200                      // vmulps        %ymm0,%ymm1,%ymm1
  .byte  197,124,40,192                      // vmovaps       %ymm0,%ymm8
  .byte  197,124,17,68,36,160                // vmovups       %ymm8,-0x60(%rsp)
  .byte  196,98,125,24,13,35,105,2,0         // vbroadcastss  0x26923(%rip),%ymm9        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  196,193,92,84,209                   // vandps        %ymm9,%ymm4,%ymm2
  .byte  196,98,125,24,21,117,104,2,0        // vbroadcastss  0x26875(%rip),%ymm10        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,193,108,86,210                  // vorps         %ymm10,%ymm2,%ymm2
  .byte  196,98,125,24,29,11,105,2,0         // vbroadcastss  0x2690b(%rip),%ymm11        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  196,193,116,88,203                  // vaddps        %ymm11,%ymm1,%ymm1
  .byte  196,98,125,24,37,1,105,2,0          // vbroadcastss  0x26901(%rip),%ymm12        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,193,108,89,220                  // vmulps        %ymm12,%ymm2,%ymm3
  .byte  197,244,92,203                      // vsubps        %ymm3,%ymm1,%ymm1
  .byte  196,98,125,24,45,243,104,2,0        // vbroadcastss  0x268f3(%rip),%ymm13        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,193,108,88,213                  // vaddps        %ymm13,%ymm2,%ymm2
  .byte  196,98,125,24,53,233,104,2,0        // vbroadcastss  0x268e9(%rip),%ymm14        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  197,140,94,210                      // vdivps        %ymm2,%ymm14,%ymm2
  .byte  197,244,92,202                      // vsubps        %ymm2,%ymm1,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,48                   // vbroadcastss  (%rax),%ymm6
  .byte  197,244,89,206                      // vmulps        %ymm6,%ymm1,%ymm1
  .byte  196,227,125,8,209,1                 // vroundps      $0x1,%ymm1,%ymm2
  .byte  197,244,92,234                      // vsubps        %ymm2,%ymm1,%ymm5
  .byte  196,98,125,24,61,199,104,2,0        // vbroadcastss  0x268c7(%rip),%ymm15        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  196,193,116,88,207                  // vaddps        %ymm15,%ymm1,%ymm1
  .byte  196,226,125,24,61,189,104,2,0       // vbroadcastss  0x268bd(%rip),%ymm7        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  197,212,89,215                      // vmulps        %ymm7,%ymm5,%ymm2
  .byte  197,244,92,194                      // vsubps        %ymm2,%ymm1,%ymm0
  .byte  196,226,125,24,29,176,104,2,0       // vbroadcastss  0x268b0(%rip),%ymm3        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  197,228,92,237                      // vsubps        %ymm5,%ymm3,%ymm5
  .byte  196,226,125,24,21,167,104,2,0       // vbroadcastss  0x268a7(%rip),%ymm2        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  197,236,94,237                      // vdivps        %ymm5,%ymm2,%ymm5
  .byte  197,252,88,197                      // vaddps        %ymm5,%ymm0,%ymm0
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,220,194,205,0                   // vcmpeqps      %ymm5,%ymm4,%ymm1
  .byte  196,226,125,24,37,145,104,2,0       // vbroadcastss  0x26891(%rip),%ymm4        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  197,252,89,196                      // vmulps        %ymm4,%ymm0,%ymm0
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,227,125,74,197,16               // vblendvps     %ymm1,%ymm5,%ymm0,%ymm0
  .byte  197,252,17,68,36,192                // vmovups       %ymm0,-0x40(%rsp)
  .byte  197,252,16,108,36,128               // vmovups       -0x80(%rsp),%ymm5
  .byte  197,252,91,197                      // vcvtdq2ps     %ymm5,%ymm0
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  196,193,84,84,201                   // vandps        %ymm9,%ymm5,%ymm1
  .byte  197,124,40,197                      // vmovaps       %ymm5,%ymm8
  .byte  196,193,116,86,202                  // vorps         %ymm10,%ymm1,%ymm1
  .byte  196,193,124,88,195                  // vaddps        %ymm11,%ymm0,%ymm0
  .byte  196,193,116,89,236                  // vmulps        %ymm12,%ymm1,%ymm5
  .byte  197,252,92,197                      // vsubps        %ymm5,%ymm0,%ymm0
  .byte  196,193,116,88,205                  // vaddps        %ymm13,%ymm1,%ymm1
  .byte  197,140,94,201                      // vdivps        %ymm1,%ymm14,%ymm1
  .byte  197,252,92,193                      // vsubps        %ymm1,%ymm0,%ymm0
  .byte  197,252,89,198                      // vmulps        %ymm6,%ymm0,%ymm0
  .byte  196,227,125,8,200,1                 // vroundps      $0x1,%ymm0,%ymm1
  .byte  197,252,92,201                      // vsubps        %ymm1,%ymm0,%ymm1
  .byte  196,193,124,88,199                  // vaddps        %ymm15,%ymm0,%ymm0
  .byte  197,244,89,239                      // vmulps        %ymm7,%ymm1,%ymm5
  .byte  197,252,92,197                      // vsubps        %ymm5,%ymm0,%ymm0
  .byte  197,228,92,201                      // vsubps        %ymm1,%ymm3,%ymm1
  .byte  197,236,94,201                      // vdivps        %ymm1,%ymm2,%ymm1
  .byte  197,252,88,193                      // vaddps        %ymm1,%ymm0,%ymm0
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,188,194,205,0                   // vcmpeqps      %ymm5,%ymm8,%ymm1
  .byte  197,252,89,196                      // vmulps        %ymm4,%ymm0,%ymm0
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,227,125,74,197,16               // vblendvps     %ymm1,%ymm5,%ymm0,%ymm0
  .byte  197,252,17,68,36,128                // vmovups       %ymm0,-0x80(%rsp)
  .byte  197,252,16,108,36,224               // vmovups       -0x20(%rsp),%ymm5
  .byte  197,252,91,197                      // vcvtdq2ps     %ymm5,%ymm0
  .byte  197,252,89,68,36,160                // vmulps        -0x60(%rsp),%ymm0,%ymm0
  .byte  196,193,84,84,201                   // vandps        %ymm9,%ymm5,%ymm1
  .byte  197,124,40,197                      // vmovaps       %ymm5,%ymm8
  .byte  196,193,116,86,202                  // vorps         %ymm10,%ymm1,%ymm1
  .byte  196,193,124,88,195                  // vaddps        %ymm11,%ymm0,%ymm0
  .byte  196,193,116,89,236                  // vmulps        %ymm12,%ymm1,%ymm5
  .byte  197,252,92,197                      // vsubps        %ymm5,%ymm0,%ymm0
  .byte  196,193,116,88,205                  // vaddps        %ymm13,%ymm1,%ymm1
  .byte  197,140,94,201                      // vdivps        %ymm1,%ymm14,%ymm1
  .byte  197,252,92,193                      // vsubps        %ymm1,%ymm0,%ymm0
  .byte  197,252,89,198                      // vmulps        %ymm6,%ymm0,%ymm0
  .byte  196,227,125,8,200,1                 // vroundps      $0x1,%ymm0,%ymm1
  .byte  197,252,92,201                      // vsubps        %ymm1,%ymm0,%ymm1
  .byte  196,193,124,88,199                  // vaddps        %ymm15,%ymm0,%ymm0
  .byte  197,244,89,239                      // vmulps        %ymm7,%ymm1,%ymm5
  .byte  197,252,92,197                      // vsubps        %ymm5,%ymm0,%ymm0
  .byte  197,228,92,201                      // vsubps        %ymm1,%ymm3,%ymm1
  .byte  197,236,94,201                      // vdivps        %ymm1,%ymm2,%ymm1
  .byte  197,252,88,193                      // vaddps        %ymm1,%ymm0,%ymm0
  .byte  197,252,89,196                      // vmulps        %ymm4,%ymm0,%ymm0
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,188,194,202,0                   // vcmpeqps      %ymm2,%ymm8,%ymm1
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,227,125,74,210,16               // vblendvps     %ymm1,%ymm2,%ymm0,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,68,36,192                // vmovups       -0x40(%rsp),%ymm0
  .byte  197,252,16,76,36,128                // vmovups       -0x80(%rsp),%ymm1
  .byte  197,252,16,28,36                    // vmovups       (%rsp),%ymm3
  .byte  197,252,16,100,36,32                // vmovups       0x20(%rsp),%ymm4
  .byte  197,252,16,108,36,64                // vmovups       0x40(%rsp),%ymm5
  .byte  197,252,16,116,36,96                // vmovups       0x60(%rsp),%ymm6
  .byte  197,252,16,188,36,128,0,0,0         // vmovups       0x80(%rsp),%ymm7
  .byte  72,129,196,184,0,0,0                // add           $0xb8,%rsp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gamma_dst_avx
.globl _sk_gamma_dst_avx
FUNCTION(_sk_gamma_dst_avx)
_sk_gamma_dst_avx:
  .byte  72,129,236,248,0,0,0                // sub           $0xf8,%rsp
  .byte  197,252,17,188,36,192,0,0,0         // vmovups       %ymm7,0xc0(%rsp)
  .byte  197,252,17,116,36,160               // vmovups       %ymm6,-0x60(%rsp)
  .byte  197,124,40,197                      // vmovaps       %ymm5,%ymm8
  .byte  197,252,17,156,36,160,0,0,0         // vmovups       %ymm3,0xa0(%rsp)
  .byte  197,252,17,148,36,128,0,0,0         // vmovups       %ymm2,0x80(%rsp)
  .byte  197,252,17,76,36,96                 // vmovups       %ymm1,0x60(%rsp)
  .byte  197,252,17,68,36,64                 // vmovups       %ymm0,0x40(%rsp)
  .byte  197,252,91,196                      // vcvtdq2ps     %ymm4,%ymm0
  .byte  196,226,125,24,29,230,102,2,0       // vbroadcastss  0x266e6(%rip),%ymm3        # 3a2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x348>
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  196,226,125,24,13,221,102,2,0       // vbroadcastss  0x266dd(%rip),%ymm1        # 3a2b4 <_sk_srcover_bgra_8888_sse2_lowp+0x34c>
  .byte  197,252,17,12,36                    // vmovups       %ymm1,(%rsp)
  .byte  197,220,84,201                      // vandps        %ymm1,%ymm4,%ymm1
  .byte  196,226,125,24,21,43,102,2,0        // vbroadcastss  0x2662b(%rip),%ymm2        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,252,17,84,36,224                // vmovups       %ymm2,-0x20(%rsp)
  .byte  197,244,86,202                      // vorps         %ymm2,%ymm1,%ymm1
  .byte  196,226,125,24,21,188,102,2,0       // vbroadcastss  0x266bc(%rip),%ymm2        # 3a2b8 <_sk_srcover_bgra_8888_sse2_lowp+0x350>
  .byte  197,252,17,84,36,192                // vmovups       %ymm2,-0x40(%rsp)
  .byte  197,252,88,194                      // vaddps        %ymm2,%ymm0,%ymm0
  .byte  196,98,125,24,37,173,102,2,0        // vbroadcastss  0x266ad(%rip),%ymm12        # 3a2bc <_sk_srcover_bgra_8888_sse2_lowp+0x354>
  .byte  196,193,116,89,212                  // vmulps        %ymm12,%ymm1,%ymm2
  .byte  197,252,92,194                      // vsubps        %ymm2,%ymm0,%ymm0
  .byte  196,98,125,24,45,159,102,2,0        // vbroadcastss  0x2669f(%rip),%ymm13        # 3a2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x358>
  .byte  196,193,116,88,205                  // vaddps        %ymm13,%ymm1,%ymm1
  .byte  196,98,125,24,53,149,102,2,0        // vbroadcastss  0x26695(%rip),%ymm14        # 3a2c4 <_sk_srcover_bgra_8888_sse2_lowp+0x35c>
  .byte  197,140,94,201                      // vdivps        %ymm1,%ymm14,%ymm1
  .byte  197,252,92,193                      // vsubps        %ymm1,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,40                   // vbroadcastss  (%rax),%ymm5
  .byte  197,252,89,197                      // vmulps        %ymm5,%ymm0,%ymm0
  .byte  196,227,125,8,200,1                 // vroundps      $0x1,%ymm0,%ymm1
  .byte  197,252,92,201                      // vsubps        %ymm1,%ymm0,%ymm1
  .byte  196,98,125,24,61,115,102,2,0        // vbroadcastss  0x26673(%rip),%ymm15        # 3a2c8 <_sk_srcover_bgra_8888_sse2_lowp+0x360>
  .byte  196,193,124,88,199                  // vaddps        %ymm15,%ymm0,%ymm0
  .byte  196,98,125,24,29,105,102,2,0        // vbroadcastss  0x26669(%rip),%ymm11        # 3a2cc <_sk_srcover_bgra_8888_sse2_lowp+0x364>
  .byte  196,193,116,89,211                  // vmulps        %ymm11,%ymm1,%ymm2
  .byte  197,252,92,194                      // vsubps        %ymm2,%ymm0,%ymm0
  .byte  196,98,125,24,21,91,102,2,0         // vbroadcastss  0x2665b(%rip),%ymm10        # 3a2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x368>
  .byte  197,172,92,241                      // vsubps        %ymm1,%ymm10,%ymm6
  .byte  196,98,125,24,13,82,102,2,0         // vbroadcastss  0x26652(%rip),%ymm9        # 3a2d4 <_sk_srcover_bgra_8888_sse2_lowp+0x36c>
  .byte  197,180,94,246                      // vdivps        %ymm6,%ymm9,%ymm6
  .byte  197,252,88,198                      // vaddps        %ymm6,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,220,194,225,0                   // vcmpeqps      %ymm1,%ymm4,%ymm4
  .byte  196,226,125,24,61,60,102,2,0        // vbroadcastss  0x2663c(%rip),%ymm7        # 3a2d8 <_sk_srcover_bgra_8888_sse2_lowp+0x370>
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,227,125,74,193,64               // vblendvps     %ymm4,%ymm1,%ymm0,%ymm0
  .byte  197,252,17,68,36,32                 // vmovups       %ymm0,0x20(%rsp)
  .byte  197,124,17,68,36,128                // vmovups       %ymm8,-0x80(%rsp)
  .byte  196,193,124,91,192                  // vcvtdq2ps     %ymm8,%ymm0
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  197,252,16,20,36                    // vmovups       (%rsp),%ymm2
  .byte  197,188,84,242                      // vandps        %ymm2,%ymm8,%ymm6
  .byte  197,252,16,76,36,224                // vmovups       -0x20(%rsp),%ymm1
  .byte  197,204,86,241                      // vorps         %ymm1,%ymm6,%ymm6
  .byte  197,252,16,100,36,192               // vmovups       -0x40(%rsp),%ymm4
  .byte  197,252,88,196                      // vaddps        %ymm4,%ymm0,%ymm0
  .byte  196,65,76,89,196                    // vmulps        %ymm12,%ymm6,%ymm8
  .byte  196,193,124,92,192                  // vsubps        %ymm8,%ymm0,%ymm0
  .byte  196,193,76,88,245                   // vaddps        %ymm13,%ymm6,%ymm6
  .byte  197,140,94,246                      // vdivps        %ymm6,%ymm14,%ymm6
  .byte  197,252,92,198                      // vsubps        %ymm6,%ymm0,%ymm0
  .byte  197,252,89,197                      // vmulps        %ymm5,%ymm0,%ymm0
  .byte  196,227,125,8,240,1                 // vroundps      $0x1,%ymm0,%ymm6
  .byte  197,252,92,246                      // vsubps        %ymm6,%ymm0,%ymm6
  .byte  196,193,124,88,199                  // vaddps        %ymm15,%ymm0,%ymm0
  .byte  196,65,76,89,195                    // vmulps        %ymm11,%ymm6,%ymm8
  .byte  196,193,124,92,192                  // vsubps        %ymm8,%ymm0,%ymm0
  .byte  197,172,92,246                      // vsubps        %ymm6,%ymm10,%ymm6
  .byte  197,180,94,246                      // vdivps        %ymm6,%ymm9,%ymm6
  .byte  197,252,88,198                      // vaddps        %ymm6,%ymm0,%ymm0
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,194,116,36,128,0            // vcmpeqps      -0x80(%rsp),%ymm8,%ymm6
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,195,125,74,192,96               // vblendvps     %ymm6,%ymm8,%ymm0,%ymm0
  .byte  197,252,17,68,36,128                // vmovups       %ymm0,-0x80(%rsp)
  .byte  197,252,16,116,36,160               // vmovups       -0x60(%rsp),%ymm6
  .byte  197,252,91,198                      // vcvtdq2ps     %ymm6,%ymm0
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  197,204,84,242                      // vandps        %ymm2,%ymm6,%ymm6
  .byte  197,204,86,241                      // vorps         %ymm1,%ymm6,%ymm6
  .byte  197,252,88,196                      // vaddps        %ymm4,%ymm0,%ymm0
  .byte  196,65,76,89,196                    // vmulps        %ymm12,%ymm6,%ymm8
  .byte  196,193,124,92,192                  // vsubps        %ymm8,%ymm0,%ymm0
  .byte  196,193,76,88,245                   // vaddps        %ymm13,%ymm6,%ymm6
  .byte  197,140,94,246                      // vdivps        %ymm6,%ymm14,%ymm6
  .byte  197,252,92,198                      // vsubps        %ymm6,%ymm0,%ymm0
  .byte  197,252,89,197                      // vmulps        %ymm5,%ymm0,%ymm0
  .byte  196,227,125,8,232,1                 // vroundps      $0x1,%ymm0,%ymm5
  .byte  197,252,92,237                      // vsubps        %ymm5,%ymm0,%ymm5
  .byte  196,193,124,88,199                  // vaddps        %ymm15,%ymm0,%ymm0
  .byte  196,193,84,89,243                   // vmulps        %ymm11,%ymm5,%ymm6
  .byte  197,252,92,198                      // vsubps        %ymm6,%ymm0,%ymm0
  .byte  197,172,92,221                      // vsubps        %ymm5,%ymm10,%ymm3
  .byte  197,180,94,211                      // vdivps        %ymm3,%ymm9,%ymm2
  .byte  197,252,88,194                      // vaddps        %ymm2,%ymm0,%ymm0
  .byte  197,252,89,199                      // vmulps        %ymm7,%ymm0,%ymm0
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,236,194,76,36,160,0             // vcmpeqps      -0x60(%rsp),%ymm2,%ymm1
  .byte  197,253,91,192                      // vcvtps2dq     %ymm0,%ymm0
  .byte  196,227,125,74,242,16               // vblendvps     %ymm1,%ymm2,%ymm0,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,68,36,64                 // vmovups       0x40(%rsp),%ymm0
  .byte  197,252,16,76,36,96                 // vmovups       0x60(%rsp),%ymm1
  .byte  197,252,16,148,36,128,0,0,0         // vmovups       0x80(%rsp),%ymm2
  .byte  197,252,16,156,36,160,0,0,0         // vmovups       0xa0(%rsp),%ymm3
  .byte  197,252,16,100,36,32                // vmovups       0x20(%rsp),%ymm4
  .byte  197,252,16,108,36,128               // vmovups       -0x80(%rsp),%ymm5
  .byte  197,252,16,188,36,192,0,0,0         // vmovups       0xc0(%rsp),%ymm7
  .byte  72,129,196,248,0,0,0                // add           $0xf8,%rsp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lab_to_xyz_avx
.globl _sk_lab_to_xyz_avx
FUNCTION(_sk_lab_to_xyz_avx)
_sk_lab_to_xyz_avx:
  .byte  196,98,125,24,5,231,100,2,0         // vbroadcastss  0x264e7(%rip),%ymm8        # 3a2dc <_sk_srcover_bgra_8888_sse2_lowp+0x374>
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,24,5,65,100,2,0          // vbroadcastss  0x26441(%rip),%ymm8        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  196,98,125,24,13,207,100,2,0        // vbroadcastss  0x264cf(%rip),%ymm9        # 3a2e0 <_sk_srcover_bgra_8888_sse2_lowp+0x378>
  .byte  196,193,116,88,201                  // vaddps        %ymm9,%ymm1,%ymm1
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  196,193,108,88,209                  // vaddps        %ymm9,%ymm2,%ymm2
  .byte  196,98,125,24,5,187,100,2,0         // vbroadcastss  0x264bb(%rip),%ymm8        # 3a2e4 <_sk_srcover_bgra_8888_sse2_lowp+0x37c>
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,24,5,177,100,2,0         // vbroadcastss  0x264b1(%rip),%ymm8        # 3a2e8 <_sk_srcover_bgra_8888_sse2_lowp+0x380>
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,24,5,167,100,2,0         // vbroadcastss  0x264a7(%rip),%ymm8        # 3a2ec <_sk_srcover_bgra_8888_sse2_lowp+0x384>
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  197,252,88,201                      // vaddps        %ymm1,%ymm0,%ymm1
  .byte  196,98,125,24,5,153,100,2,0         // vbroadcastss  0x26499(%rip),%ymm8        # 3a2f0 <_sk_srcover_bgra_8888_sse2_lowp+0x388>
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  197,252,92,210                      // vsubps        %ymm2,%ymm0,%ymm2
  .byte  197,116,89,193                      // vmulps        %ymm1,%ymm1,%ymm8
  .byte  196,65,116,89,192                   // vmulps        %ymm8,%ymm1,%ymm8
  .byte  196,98,125,24,13,130,100,2,0        // vbroadcastss  0x26482(%rip),%ymm9        # 3a2f4 <_sk_srcover_bgra_8888_sse2_lowp+0x38c>
  .byte  196,65,52,194,208,1                 // vcmpltps      %ymm8,%ymm9,%ymm10
  .byte  196,98,125,24,29,119,100,2,0        // vbroadcastss  0x26477(%rip),%ymm11        # 3a2f8 <_sk_srcover_bgra_8888_sse2_lowp+0x390>
  .byte  196,193,116,88,203                  // vaddps        %ymm11,%ymm1,%ymm1
  .byte  196,98,125,24,37,109,100,2,0        // vbroadcastss  0x2646d(%rip),%ymm12        # 3a2fc <_sk_srcover_bgra_8888_sse2_lowp+0x394>
  .byte  196,193,116,89,204                  // vmulps        %ymm12,%ymm1,%ymm1
  .byte  196,67,117,74,192,160               // vblendvps     %ymm10,%ymm8,%ymm1,%ymm8
  .byte  197,252,89,200                      // vmulps        %ymm0,%ymm0,%ymm1
  .byte  197,252,89,201                      // vmulps        %ymm1,%ymm0,%ymm1
  .byte  197,52,194,209,1                    // vcmpltps      %ymm1,%ymm9,%ymm10
  .byte  196,193,124,88,195                  // vaddps        %ymm11,%ymm0,%ymm0
  .byte  196,193,124,89,196                  // vmulps        %ymm12,%ymm0,%ymm0
  .byte  196,227,125,74,201,160              // vblendvps     %ymm10,%ymm1,%ymm0,%ymm1
  .byte  197,236,89,194                      // vmulps        %ymm2,%ymm2,%ymm0
  .byte  197,236,89,192                      // vmulps        %ymm0,%ymm2,%ymm0
  .byte  197,52,194,200,1                    // vcmpltps      %ymm0,%ymm9,%ymm9
  .byte  196,193,108,88,211                  // vaddps        %ymm11,%ymm2,%ymm2
  .byte  196,193,108,89,212                  // vmulps        %ymm12,%ymm2,%ymm2
  .byte  196,227,109,74,208,144              // vblendvps     %ymm9,%ymm0,%ymm2,%ymm2
  .byte  196,226,125,24,5,35,100,2,0         // vbroadcastss  0x26423(%rip),%ymm0        # 3a300 <_sk_srcover_bgra_8888_sse2_lowp+0x398>
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  196,98,125,24,5,26,100,2,0          // vbroadcastss  0x2641a(%rip),%ymm8        # 3a304 <_sk_srcover_bgra_8888_sse2_lowp+0x39c>
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_a8_avx
.globl _sk_load_a8_avx
FUNCTION(_sk_load_a8_avx)
_sk_load_a8_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,68                              // jne           13f4f <_sk_load_a8_avx+0x5c>
  .byte  196,130,121,48,4,24                 // vpmovzxbw     (%r8,%r11,1),%xmm0
  .byte  197,249,219,5,215,107,2,0           // vpand         0x26bd7(%rip),%xmm0,%xmm0        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,226,121,51,200                  // vpmovzxwd     %xmm0,%xmm1
  .byte  197,249,112,192,78                  // vpshufd       $0x4e,%xmm0,%xmm0
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  196,227,117,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,85,99,2,0         // vbroadcastss  0x26355(%rip),%ymm1        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,252,89,217                      // vmulps        %ymm1,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,174                             // ja            13f11 <_sk_load_a8_avx+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,122,0,0,0                 // lea           0x7a(%rip),%r10        # 13fe8 <_sk_load_a8_avx+0xf5>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  235,143                             // jmp           13f11 <_sk_load_a8_avx+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,249,196,192,2                   // vpinsrw       $0x2,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,24                      // movzwl        (%r8,%r11,1),%eax
  .byte  197,249,110,200                     // vmovd         %eax,%xmm1
  .byte  196,226,121,48,201                  // vpmovzxbw     %xmm1,%xmm1
  .byte  196,227,121,14,193,3                // vpblendw      $0x3,%xmm1,%xmm0,%xmm0
  .byte  233,103,255,255,255                 // jmpq          13f11 <_sk_load_a8_avx+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,249,196,192,6                   // vpinsrw       $0x6,%eax,%xmm0,%xmm0
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,249,196,192,5                   // vpinsrw       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,249,196,192,4                   // vpinsrw       $0x4,%eax,%xmm0,%xmm0
  .byte  196,129,121,110,12,24               // vmovd         (%r8,%r11,1),%xmm1
  .byte  196,226,121,48,201                  // vpmovzxbw     %xmm1,%xmm1
  .byte  196,227,113,14,192,240              // vpblendw      $0xf0,%xmm0,%xmm1,%xmm0
  .byte  233,44,255,255,255                  // jmpq          13f11 <_sk_load_a8_avx+0x1e>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  143                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,169,255,255,255,154             // ljmp          *-0x65000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,231                             // jmpq          *%rdi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  220,255                             // fdivr         %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,209                             // callq         *%rcx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,194                             // inc           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_a8_dst_avx
.globl _sk_load_a8_dst_avx
FUNCTION(_sk_load_a8_dst_avx)
_sk_load_a8_dst_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,68                              // jne           14060 <_sk_load_a8_dst_avx+0x5c>
  .byte  196,130,121,48,36,24                // vpmovzxbw     (%r8,%r11,1),%xmm4
  .byte  197,217,219,37,198,106,2,0          // vpand         0x26ac6(%rip),%xmm4,%xmm4        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,226,121,51,236                  // vpmovzxwd     %xmm4,%xmm5
  .byte  197,249,112,228,78                  // vpshufd       $0x4e,%xmm4,%xmm4
  .byte  196,226,121,51,228                  // vpmovzxwd     %xmm4,%xmm4
  .byte  196,227,85,24,228,1                 // vinsertf128   $0x1,%xmm4,%ymm5,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,226,125,24,45,68,98,2,0         // vbroadcastss  0x26244(%rip),%ymm5        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,220,89,253                      // vmulps        %ymm5,%ymm4,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,174                             // ja            14022 <_sk_load_a8_dst_avx+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,121,0,0,0                 // lea           0x79(%rip),%r10        # 140f8 <_sk_load_a8_dst_avx+0xf4>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  235,143                             // jmp           14022 <_sk_load_a8_dst_avx+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  197,217,196,224,2                   // vpinsrw       $0x2,%eax,%xmm4,%xmm4
  .byte  67,15,183,4,24                      // movzwl        (%r8,%r11,1),%eax
  .byte  197,249,110,232                     // vmovd         %eax,%xmm5
  .byte  196,226,121,48,237                  // vpmovzxbw     %xmm5,%xmm5
  .byte  196,227,89,14,229,3                 // vpblendw      $0x3,%xmm5,%xmm4,%xmm4
  .byte  233,103,255,255,255                 // jmpq          14022 <_sk_load_a8_dst_avx+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  197,217,196,224,6                   // vpinsrw       $0x6,%eax,%xmm4,%xmm4
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,217,196,224,5                   // vpinsrw       $0x5,%eax,%xmm4,%xmm4
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,217,196,224,4                   // vpinsrw       $0x4,%eax,%xmm4,%xmm4
  .byte  196,129,121,110,44,24               // vmovd         (%r8,%r11,1),%xmm5
  .byte  196,226,121,48,237                  // vpmovzxbw     %xmm5,%xmm5
  .byte  196,227,81,14,228,240               // vpblendw      $0xf0,%xmm4,%xmm5,%xmm4
  .byte  233,44,255,255,255                  // jmpq          14022 <_sk_load_a8_dst_avx+0x1e>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  144                                 // nop
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,170,255,255,255,155             // ljmp          *-0x64000001(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  232,255,255,255,221                 // callq         ffffffffde014108 <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffddfda1a0>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,195                             // inc           %ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_a8_avx
.globl _sk_gather_a8_avx
FUNCTION(_sk_gather_a8_avx)
_sk_gather_a8_avx:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,80,12                // vbroadcastss  0xc(%rax),%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  196,65,57,118,192                   // vpcmpeqd      %xmm8,%xmm8,%xmm8
  .byte  196,193,97,254,216                  // vpaddd        %xmm8,%xmm3,%xmm3
  .byte  196,193,105,254,208                 // vpaddd        %xmm8,%xmm2,%xmm2
  .byte  196,227,109,24,211,1                // vinsertf128   $0x1,%xmm3,%ymm2,%ymm2
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,180,95,192                      // vmaxps        %ymm0,%ymm9,%ymm0
  .byte  197,252,93,210                      // vminps        %ymm2,%ymm0,%ymm2
  .byte  196,226,125,24,64,16                // vbroadcastss  0x10(%rax),%ymm0
  .byte  196,227,125,25,195,1                // vextractf128  $0x1,%ymm0,%xmm3
  .byte  196,193,97,254,216                  // vpaddd        %xmm8,%xmm3,%xmm3
  .byte  196,193,121,254,192                 // vpaddd        %xmm8,%xmm0,%xmm0
  .byte  196,227,125,24,195,1                // vinsertf128   $0x1,%xmm3,%ymm0,%ymm0
  .byte  197,180,95,201                      // vmaxps        %ymm1,%ymm9,%ymm1
  .byte  197,244,93,192                      // vminps        %ymm0,%ymm1,%ymm0
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,200                      // vcvttps2dq    %ymm0,%ymm1
  .byte  197,249,110,64,8                    // vmovd         0x8(%rax),%xmm0
  .byte  197,249,112,216,0                   // vpshufd       $0x0,%xmm0,%xmm3
  .byte  196,226,97,64,193                   // vpmulld       %xmm1,%xmm3,%xmm0
  .byte  196,227,125,25,201,1                // vextractf128  $0x1,%ymm1,%xmm1
  .byte  196,226,97,64,201                   // vpmulld       %xmm1,%xmm3,%xmm1
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  197,241,254,203                     // vpaddd        %xmm3,%xmm1,%xmm1
  .byte  196,227,249,22,200,1                // vpextrq       $0x1,%xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,202                 // vmovq         %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  197,249,254,194                     // vpaddd        %xmm2,%xmm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,182,60,56                     // movzbl        (%r8,%r15,1),%r15d
  .byte  67,15,182,44,32                     // movzbl        (%r8,%r12,1),%ebp
  .byte  197,249,110,197                     // vmovd         %ebp,%xmm0
  .byte  196,195,121,32,199,1                // vpinsrb       $0x1,%r15d,%xmm0,%xmm0
  .byte  67,15,182,44,48                     // movzbl        (%r8,%r14,1),%ebp
  .byte  196,227,121,32,197,2                // vpinsrb       $0x2,%ebp,%xmm0,%xmm0
  .byte  65,15,182,28,24                     // movzbl        (%r8,%rbx,1),%ebx
  .byte  196,227,121,32,195,3                // vpinsrb       $0x3,%ebx,%xmm0,%xmm0
  .byte  196,226,121,49,192                  // vpmovzxbd     %xmm0,%xmm0
  .byte  67,15,182,44,16                     // movzbl        (%r8,%r10,1),%ebp
  .byte  67,15,182,28,24                     // movzbl        (%r8,%r11,1),%ebx
  .byte  197,249,110,203                     // vmovd         %ebx,%xmm1
  .byte  196,227,113,32,205,1                // vpinsrb       $0x1,%ebp,%xmm1,%xmm1
  .byte  67,15,182,44,8                      // movzbl        (%r8,%r9,1),%ebp
  .byte  196,227,113,32,205,2                // vpinsrb       $0x2,%ebp,%xmm1,%xmm1
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,113,32,200,3                // vpinsrb       $0x3,%eax,%xmm1,%xmm1
  .byte  196,226,121,49,201                  // vpmovzxbd     %xmm1,%xmm1
  .byte  196,227,125,24,193,1                // vinsertf128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,74,96,2,0         // vbroadcastss  0x2604a(%rip),%ymm1        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,252,89,217                      // vmulps        %ymm1,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_a8_avx
.globl _sk_store_a8_avx
FUNCTION(_sk_store_a8_avx)
_sk_store_a8_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,98,125,24,13,145,95,2,0         // vbroadcastss  0x25f91(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,60,93,193                    // vminps        %ymm9,%ymm8,%ymm8
  .byte  196,98,125,24,13,175,95,2,0         // vbroadcastss  0x25faf(%rip),%ymm9        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,66,57,43,193                    // vpackusdw     %xmm9,%xmm8,%xmm8
  .byte  197,57,103,192                      // vpackuswb     %xmm0,%xmm8,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           142bd <_sk_store_a8_avx+0x5b>
  .byte  196,1,121,214,4,24                  // vmovq         %xmm8,(%r8,%r11,1)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,236                             // ja            142b9 <_sk_store_a8_avx+0x57>
  .byte  196,66,121,48,192                   // vpmovzxbw     %xmm8,%xmm8
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,87,0,0,0                  // lea           0x57(%rip),%r10        # 14334 <_sk_store_a8_avx+0xd2>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,3,121,20,4,24,0                 // vpextrb       $0x0,%xmm8,(%r8,%r11,1)
  .byte  235,202                             // jmp           142b9 <_sk_store_a8_avx+0x57>
  .byte  196,3,121,20,68,24,2,4              // vpextrb       $0x4,%xmm8,0x2(%r8,%r11,1)
  .byte  196,98,57,0,5,0,104,2,0             // vpshufb       0x26800(%rip),%xmm8,%xmm8        # 3ab00 <_sk_srcover_bgra_8888_sse2_lowp+0xb98>
  .byte  196,3,121,21,4,24,0                 // vpextrw       $0x0,%xmm8,(%r8,%r11,1)
  .byte  235,176                             // jmp           142b9 <_sk_store_a8_avx+0x57>
  .byte  196,3,121,20,68,24,6,12             // vpextrb       $0xc,%xmm8,0x6(%r8,%r11,1)
  .byte  196,3,121,20,68,24,5,10             // vpextrb       $0xa,%xmm8,0x5(%r8,%r11,1)
  .byte  196,3,121,20,68,24,4,8              // vpextrb       $0x8,%xmm8,0x4(%r8,%r11,1)
  .byte  196,98,57,0,5,230,103,2,0           // vpshufb       0x267e6(%rip),%xmm8,%xmm8        # 3ab10 <_sk_srcover_bgra_8888_sse2_lowp+0xba8>
  .byte  196,1,121,126,4,24                  // vmovd         %xmm8,(%r8,%r11,1)
  .byte  235,135                             // jmp           142b9 <_sk_store_a8_avx+0x57>
  .byte  102,144                             // xchg          %ax,%ax
  .byte  178,255                             // mov           $0xff,%dl
  .byte  255                                 // (bad)
  .byte  255,195                             // inc           %ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  187,255,255,255,237                 // mov           $0xedffffff,%ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,229                             // jmpq          *%rbp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  221,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,213                             // callq         *%rbp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_g8_avx
.globl _sk_load_g8_avx
FUNCTION(_sk_load_g8_avx)
_sk_load_g8_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,73                              // jne           143b1 <_sk_load_g8_avx+0x61>
  .byte  196,130,121,48,4,24                 // vpmovzxbw     (%r8,%r11,1),%xmm0
  .byte  197,249,219,5,122,103,2,0           // vpand         0x2677a(%rip),%xmm0,%xmm0        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,226,121,51,200                  // vpmovzxwd     %xmm0,%xmm1
  .byte  197,249,112,192,78                  // vpshufd       $0x4e,%xmm0,%xmm0
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  196,227,117,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,248,94,2,0        // vbroadcastss  0x25ef8(%rip),%ymm1        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,252,89,193                      // vmulps        %ymm1,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,113,94,2,0        // vbroadcastss  0x25e71(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,169                             // ja            1436e <_sk_load_g8_avx+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,120,0,0,0                 // lea           0x78(%rip),%r10        # 14448 <_sk_load_g8_avx+0xf8>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  235,138                             // jmp           1436e <_sk_load_g8_avx+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,249,196,192,2                   // vpinsrw       $0x2,%eax,%xmm0,%xmm0
  .byte  67,15,183,4,24                      // movzwl        (%r8,%r11,1),%eax
  .byte  197,249,110,200                     // vmovd         %eax,%xmm1
  .byte  196,226,121,48,201                  // vpmovzxbw     %xmm1,%xmm1
  .byte  196,227,121,14,193,3                // vpblendw      $0x3,%xmm1,%xmm0,%xmm0
  .byte  233,98,255,255,255                  // jmpq          1436e <_sk_load_g8_avx+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,249,196,192,6                   // vpinsrw       $0x6,%eax,%xmm0,%xmm0
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,249,196,192,5                   // vpinsrw       $0x5,%eax,%xmm0,%xmm0
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,249,196,192,4                   // vpinsrw       $0x4,%eax,%xmm0,%xmm0
  .byte  196,129,121,110,12,24               // vmovd         (%r8,%r11,1),%xmm1
  .byte  196,226,121,48,201                  // vpmovzxbw     %xmm1,%xmm1
  .byte  196,227,113,14,192,240              // vpblendw      $0xf0,%xmm0,%xmm1,%xmm0
  .byte  233,39,255,255,255                  // jmpq          1436e <_sk_load_g8_avx+0x1e>
  .byte  144                                 // nop
  .byte  145                                 // xchg          %eax,%ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,171,255,255,255,156             // ljmp          *-0x63000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  233,255,255,255,222                 // jmpq          ffffffffdf014458 <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffdefda4f0>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,211                             // callq         *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_g8_dst_avx
.globl _sk_load_g8_dst_avx
FUNCTION(_sk_load_g8_dst_avx)
_sk_load_g8_dst_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,73                              // jne           144c5 <_sk_load_g8_dst_avx+0x61>
  .byte  196,130,121,48,36,24                // vpmovzxbw     (%r8,%r11,1),%xmm4
  .byte  197,217,219,37,102,102,2,0          // vpand         0x26666(%rip),%xmm4,%xmm4        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  196,226,121,51,236                  // vpmovzxwd     %xmm4,%xmm5
  .byte  197,249,112,228,78                  // vpshufd       $0x4e,%xmm4,%xmm4
  .byte  196,226,121,51,228                  // vpmovzxwd     %xmm4,%xmm4
  .byte  196,227,85,24,228,1                 // vinsertf128   $0x1,%xmm4,%ymm5,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,226,125,24,45,228,93,2,0        // vbroadcastss  0x25de4(%rip),%ymm5        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,220,89,229                      // vmulps        %ymm5,%ymm4,%ymm4
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,61,93,93,2,0         // vbroadcastss  0x25d5d(%rip),%ymm7        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,40,236                      // vmovaps       %ymm4,%ymm5
  .byte  197,252,40,244                      // vmovaps       %ymm4,%ymm6
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,169                             // ja            14482 <_sk_load_g8_dst_avx+0x1e>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,120,0,0,0                 // lea           0x78(%rip),%r10        # 1455c <_sk_load_g8_dst_avx+0xf8>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,182,4,24                      // movzbl        (%r8,%r11,1),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  235,138                             // jmp           14482 <_sk_load_g8_dst_avx+0x1e>
  .byte  67,15,182,68,24,2                   // movzbl        0x2(%r8,%r11,1),%eax
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  197,217,196,224,2                   // vpinsrw       $0x2,%eax,%xmm4,%xmm4
  .byte  67,15,183,4,24                      // movzwl        (%r8,%r11,1),%eax
  .byte  197,249,110,232                     // vmovd         %eax,%xmm5
  .byte  196,226,121,48,237                  // vpmovzxbw     %xmm5,%xmm5
  .byte  196,227,89,14,229,3                 // vpblendw      $0x3,%xmm5,%xmm4,%xmm4
  .byte  233,98,255,255,255                  // jmpq          14482 <_sk_load_g8_dst_avx+0x1e>
  .byte  67,15,182,68,24,6                   // movzbl        0x6(%r8,%r11,1),%eax
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  197,217,196,224,6                   // vpinsrw       $0x6,%eax,%xmm4,%xmm4
  .byte  67,15,182,68,24,5                   // movzbl        0x5(%r8,%r11,1),%eax
  .byte  197,217,196,224,5                   // vpinsrw       $0x5,%eax,%xmm4,%xmm4
  .byte  67,15,182,68,24,4                   // movzbl        0x4(%r8,%r11,1),%eax
  .byte  197,217,196,224,4                   // vpinsrw       $0x4,%eax,%xmm4,%xmm4
  .byte  196,129,121,110,44,24               // vmovd         (%r8,%r11,1),%xmm5
  .byte  196,226,121,48,237                  // vpmovzxbw     %xmm5,%xmm5
  .byte  196,227,81,14,228,240               // vpblendw      $0xf0,%xmm4,%xmm5,%xmm4
  .byte  233,39,255,255,255                  // jmpq          14482 <_sk_load_g8_dst_avx+0x1e>
  .byte  144                                 // nop
  .byte  145                                 // xchg          %eax,%ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,171,255,255,255,156             // ljmp          *-0x63000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  233,255,255,255,222                 // jmpq          ffffffffdf01456c <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffdefda604>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,211                             // callq         *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_g8_avx
.globl _sk_gather_g8_avx
FUNCTION(_sk_gather_g8_avx)
_sk_gather_g8_avx:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,80,12                // vbroadcastss  0xc(%rax),%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  196,65,57,118,192                   // vpcmpeqd      %xmm8,%xmm8,%xmm8
  .byte  196,193,97,254,216                  // vpaddd        %xmm8,%xmm3,%xmm3
  .byte  196,193,105,254,208                 // vpaddd        %xmm8,%xmm2,%xmm2
  .byte  196,227,109,24,211,1                // vinsertf128   $0x1,%xmm3,%ymm2,%ymm2
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,180,95,192                      // vmaxps        %ymm0,%ymm9,%ymm0
  .byte  197,252,93,210                      // vminps        %ymm2,%ymm0,%ymm2
  .byte  196,226,125,24,64,16                // vbroadcastss  0x10(%rax),%ymm0
  .byte  196,227,125,25,195,1                // vextractf128  $0x1,%ymm0,%xmm3
  .byte  196,193,97,254,216                  // vpaddd        %xmm8,%xmm3,%xmm3
  .byte  196,193,121,254,192                 // vpaddd        %xmm8,%xmm0,%xmm0
  .byte  196,227,125,24,195,1                // vinsertf128   $0x1,%xmm3,%ymm0,%ymm0
  .byte  197,180,95,201                      // vmaxps        %ymm1,%ymm9,%ymm1
  .byte  197,244,93,192                      // vminps        %ymm0,%ymm1,%ymm0
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,200                      // vcvttps2dq    %ymm0,%ymm1
  .byte  197,249,110,64,8                    // vmovd         0x8(%rax),%xmm0
  .byte  197,249,112,216,0                   // vpshufd       $0x0,%xmm0,%xmm3
  .byte  196,226,97,64,193                   // vpmulld       %xmm1,%xmm3,%xmm0
  .byte  196,227,125,25,201,1                // vextractf128  $0x1,%ymm1,%xmm1
  .byte  196,226,97,64,201                   // vpmulld       %xmm1,%xmm3,%xmm1
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  197,241,254,203                     // vpaddd        %xmm3,%xmm1,%xmm1
  .byte  196,227,249,22,200,1                // vpextrq       $0x1,%xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,202                 // vmovq         %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  197,249,254,194                     // vpaddd        %xmm2,%xmm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,182,60,56                     // movzbl        (%r8,%r15,1),%r15d
  .byte  67,15,182,44,32                     // movzbl        (%r8,%r12,1),%ebp
  .byte  197,249,110,197                     // vmovd         %ebp,%xmm0
  .byte  196,195,121,32,199,1                // vpinsrb       $0x1,%r15d,%xmm0,%xmm0
  .byte  67,15,182,44,48                     // movzbl        (%r8,%r14,1),%ebp
  .byte  196,227,121,32,197,2                // vpinsrb       $0x2,%ebp,%xmm0,%xmm0
  .byte  65,15,182,28,24                     // movzbl        (%r8,%rbx,1),%ebx
  .byte  196,227,121,32,195,3                // vpinsrb       $0x3,%ebx,%xmm0,%xmm0
  .byte  196,226,121,49,192                  // vpmovzxbd     %xmm0,%xmm0
  .byte  67,15,182,44,16                     // movzbl        (%r8,%r10,1),%ebp
  .byte  67,15,182,28,24                     // movzbl        (%r8,%r11,1),%ebx
  .byte  197,249,110,203                     // vmovd         %ebx,%xmm1
  .byte  196,227,113,32,205,1                // vpinsrb       $0x1,%ebp,%xmm1,%xmm1
  .byte  67,15,182,44,8                      // movzbl        (%r8,%r9,1),%ebp
  .byte  196,227,113,32,205,2                // vpinsrb       $0x2,%ebp,%xmm1,%xmm1
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,113,32,200,3                // vpinsrb       $0x3,%eax,%xmm1,%xmm1
  .byte  196,226,121,49,201                  // vpmovzxbd     %xmm1,%xmm1
  .byte  196,227,125,24,193,1                // vinsertf128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,230,91,2,0        // vbroadcastss  0x25be6(%rip),%ymm1        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  197,252,89,193                      // vmulps        %ymm1,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,95,91,2,0         // vbroadcastss  0x25b5f(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_565_avx
.globl _sk_load_565_avx
FUNCTION(_sk_load_565_avx)
_sk_load_565_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,130,0,0,0                    // jne           1476c <_sk_load_565_avx+0xa1>
  .byte  196,129,122,111,4,88                // vmovdqu       (%r8,%r11,2),%xmm0
  .byte  196,226,121,51,200                  // vpmovzxwd     %xmm0,%xmm1
  .byte  197,249,112,192,78                  // vpshufd       $0x4e,%xmm0,%xmm0
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  196,227,117,24,208,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm2
  .byte  196,226,125,24,5,134,91,2,0         // vbroadcastss  0x25b86(%rip),%ymm0        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  197,236,84,192                      // vandps        %ymm0,%ymm2,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,121,91,2,0        // vbroadcastss  0x25b79(%rip),%ymm1        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  197,252,89,193                      // vmulps        %ymm1,%ymm0,%ymm0
  .byte  196,226,125,24,13,112,91,2,0        // vbroadcastss  0x25b70(%rip),%ymm1        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  197,236,84,201                      // vandps        %ymm1,%ymm2,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,226,125,24,29,99,91,2,0         // vbroadcastss  0x25b63(%rip),%ymm3        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  197,244,89,203                      // vmulps        %ymm3,%ymm1,%ymm1
  .byte  196,226,125,24,29,90,91,2,0         // vbroadcastss  0x25b5a(%rip),%ymm3        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  197,236,84,211                      // vandps        %ymm3,%ymm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,226,125,24,29,77,91,2,0         // vbroadcastss  0x25b4d(%rip),%ymm3        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  197,236,89,211                      // vmulps        %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,174,90,2,0        // vbroadcastss  0x25aae(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,108,255,255,255              // ja            146f0 <_sk_load_565_avx+0x25>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,97,0,0,0                  // lea           0x61(%rip),%r10        # 147f0 <_sk_load_565_avx+0x125>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  233,74,255,255,255                  // jmpq          146f0 <_sk_load_565_avx+0x25>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,129,121,196,68,88,4,2           // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,110,12,88               // vmovd         (%r8,%r11,2),%xmm1
  .byte  196,227,121,14,193,3                // vpblendw      $0x3,%xmm1,%xmm0,%xmm0
  .byte  233,45,255,255,255                  // jmpq          146f0 <_sk_load_565_avx+0x25>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,129,121,196,68,88,12,6          // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,196,68,88,10,5          // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,196,68,88,8,4           // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,122,126,12,88               // vmovq         (%r8,%r11,2),%xmm1
  .byte  196,227,113,14,192,240              // vpblendw      $0xf0,%xmm0,%xmm1,%xmm0
  .byte  233,0,255,255,255                   // jmpq          146f0 <_sk_load_565_avx+0x25>
  .byte  168,255                             // test          $0xff,%al
  .byte  255                                 // (bad)
  .byte  255,194                             // inc           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,182,255,255,255,239             // pushq         -0x10000001(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,231                             // jmpq          *%rdi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  223,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,211                             // callq         *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_565_dst_avx
.globl _sk_load_565_dst_avx
FUNCTION(_sk_load_565_dst_avx)
_sk_load_565_dst_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,130,0,0,0                    // jne           148ad <_sk_load_565_dst_avx+0xa1>
  .byte  196,129,122,111,36,88               // vmovdqu       (%r8,%r11,2),%xmm4
  .byte  196,226,121,51,236                  // vpmovzxwd     %xmm4,%xmm5
  .byte  197,249,112,228,78                  // vpshufd       $0x4e,%xmm4,%xmm4
  .byte  196,226,121,51,228                  // vpmovzxwd     %xmm4,%xmm4
  .byte  196,227,85,24,244,1                 // vinsertf128   $0x1,%xmm4,%ymm5,%ymm6
  .byte  196,226,125,24,37,69,90,2,0         // vbroadcastss  0x25a45(%rip),%ymm4        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  197,204,84,228                      // vandps        %ymm4,%ymm6,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,226,125,24,45,56,90,2,0         // vbroadcastss  0x25a38(%rip),%ymm5        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  197,220,89,229                      // vmulps        %ymm5,%ymm4,%ymm4
  .byte  196,226,125,24,45,47,90,2,0         // vbroadcastss  0x25a2f(%rip),%ymm5        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  197,204,84,237                      // vandps        %ymm5,%ymm6,%ymm5
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  196,226,125,24,61,34,90,2,0         // vbroadcastss  0x25a22(%rip),%ymm7        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  197,212,89,239                      // vmulps        %ymm7,%ymm5,%ymm5
  .byte  196,226,125,24,61,25,90,2,0         // vbroadcastss  0x25a19(%rip),%ymm7        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  197,204,84,247                      // vandps        %ymm7,%ymm6,%ymm6
  .byte  197,252,91,246                      // vcvtdq2ps     %ymm6,%ymm6
  .byte  196,226,125,24,61,12,90,2,0         // vbroadcastss  0x25a0c(%rip),%ymm7        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  197,204,89,247                      // vmulps        %ymm7,%ymm6,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,61,109,89,2,0        // vbroadcastss  0x2596d(%rip),%ymm7        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,108,255,255,255              // ja            14831 <_sk_load_565_dst_avx+0x25>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,100,0,0,0                 // lea           0x64(%rip),%r10        # 14934 <_sk_load_565_dst_avx+0x128>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  233,74,255,255,255                  // jmpq          14831 <_sk_load_565_dst_avx+0x25>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,129,89,196,100,88,4,2           // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,121,110,44,88               // vmovd         (%r8,%r11,2),%xmm5
  .byte  196,227,89,14,229,3                 // vpblendw      $0x3,%xmm5,%xmm4,%xmm4
  .byte  233,45,255,255,255                  // jmpq          14831 <_sk_load_565_dst_avx+0x25>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,129,89,196,100,88,12,6          // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,89,196,100,88,10,5          // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,89,196,100,88,8,4           // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,122,126,44,88               // vmovq         (%r8,%r11,2),%xmm5
  .byte  196,227,81,14,228,240               // vpblendw      $0xf0,%xmm4,%xmm5,%xmm4
  .byte  233,0,255,255,255                   // jmpq          14831 <_sk_load_565_dst_avx+0x25>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  165                                 // movsl         %ds:(%rsi),%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  191,255,255,255,179                 // mov           $0xb3ffffff,%edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  236                                 // in            (%dx),%al
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,228                             // jmpq          *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  220,255                             // fdivr         %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_565_avx
.globl _sk_gather_565_avx
FUNCTION(_sk_gather_565_avx)
_sk_gather_565_avx:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,80,12                // vbroadcastss  0xc(%rax),%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  196,65,57,118,192                   // vpcmpeqd      %xmm8,%xmm8,%xmm8
  .byte  196,193,97,254,216                  // vpaddd        %xmm8,%xmm3,%xmm3
  .byte  196,193,105,254,208                 // vpaddd        %xmm8,%xmm2,%xmm2
  .byte  196,227,109,24,211,1                // vinsertf128   $0x1,%xmm3,%ymm2,%ymm2
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,180,95,192                      // vmaxps        %ymm0,%ymm9,%ymm0
  .byte  197,252,93,210                      // vminps        %ymm2,%ymm0,%ymm2
  .byte  196,226,125,24,64,16                // vbroadcastss  0x10(%rax),%ymm0
  .byte  196,227,125,25,195,1                // vextractf128  $0x1,%ymm0,%xmm3
  .byte  196,193,97,254,216                  // vpaddd        %xmm8,%xmm3,%xmm3
  .byte  196,193,121,254,192                 // vpaddd        %xmm8,%xmm0,%xmm0
  .byte  196,227,125,24,195,1                // vinsertf128   $0x1,%xmm3,%ymm0,%ymm0
  .byte  197,180,95,201                      // vmaxps        %ymm1,%ymm9,%ymm1
  .byte  197,244,93,192                      // vminps        %ymm0,%ymm1,%ymm0
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,200                      // vcvttps2dq    %ymm0,%ymm1
  .byte  197,249,110,64,8                    // vmovd         0x8(%rax),%xmm0
  .byte  197,249,112,216,0                   // vpshufd       $0x0,%xmm0,%xmm3
  .byte  196,226,97,64,193                   // vpmulld       %xmm1,%xmm3,%xmm0
  .byte  196,227,125,25,201,1                // vextractf128  $0x1,%ymm1,%xmm1
  .byte  196,226,97,64,201                   // vpmulld       %xmm1,%xmm3,%xmm1
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  197,241,254,203                     // vpaddd        %xmm3,%xmm1,%xmm1
  .byte  196,227,249,22,200,1                // vpextrq       $0x1,%xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,202                 // vmovq         %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  197,249,254,194                     // vpaddd        %xmm2,%xmm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,183,60,120                    // movzwl        (%r8,%r15,2),%r15d
  .byte  67,15,183,44,96                     // movzwl        (%r8,%r12,2),%ebp
  .byte  197,249,110,197                     // vmovd         %ebp,%xmm0
  .byte  196,193,121,196,199,1               // vpinsrw       $0x1,%r15d,%xmm0,%xmm0
  .byte  67,15,183,44,112                    // movzwl        (%r8,%r14,2),%ebp
  .byte  197,249,196,197,2                   // vpinsrw       $0x2,%ebp,%xmm0,%xmm0
  .byte  65,15,183,28,88                     // movzwl        (%r8,%rbx,2),%ebx
  .byte  197,249,196,195,3                   // vpinsrw       $0x3,%ebx,%xmm0,%xmm0
  .byte  67,15,183,44,88                     // movzwl        (%r8,%r11,2),%ebp
  .byte  197,249,196,197,4                   // vpinsrw       $0x4,%ebp,%xmm0,%xmm0
  .byte  67,15,183,44,80                     // movzwl        (%r8,%r10,2),%ebp
  .byte  197,249,196,197,5                   // vpinsrw       $0x5,%ebp,%xmm0,%xmm0
  .byte  67,15,183,44,72                     // movzwl        (%r8,%r9,2),%ebp
  .byte  197,249,196,197,6                   // vpinsrw       $0x6,%ebp,%xmm0,%xmm0
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,249,196,192,7                   // vpinsrw       $0x7,%eax,%xmm0,%xmm0
  .byte  196,226,121,51,200                  // vpmovzxwd     %xmm0,%xmm1
  .byte  197,249,112,192,78                  // vpshufd       $0x4e,%xmm0,%xmm0
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  196,227,117,24,208,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm2
  .byte  196,226,125,24,5,21,88,2,0          // vbroadcastss  0x25815(%rip),%ymm0        # 3a294 <_sk_srcover_bgra_8888_sse2_lowp+0x32c>
  .byte  197,236,84,192                      // vandps        %ymm0,%ymm2,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,8,88,2,0          // vbroadcastss  0x25808(%rip),%ymm1        # 3a298 <_sk_srcover_bgra_8888_sse2_lowp+0x330>
  .byte  197,252,89,193                      // vmulps        %ymm1,%ymm0,%ymm0
  .byte  196,226,125,24,13,255,87,2,0        // vbroadcastss  0x257ff(%rip),%ymm1        # 3a29c <_sk_srcover_bgra_8888_sse2_lowp+0x334>
  .byte  197,236,84,201                      // vandps        %ymm1,%ymm2,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,226,125,24,29,242,87,2,0        // vbroadcastss  0x257f2(%rip),%ymm3        # 3a2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x338>
  .byte  197,244,89,203                      // vmulps        %ymm3,%ymm1,%ymm1
  .byte  196,226,125,24,29,233,87,2,0        // vbroadcastss  0x257e9(%rip),%ymm3        # 3a2a4 <_sk_srcover_bgra_8888_sse2_lowp+0x33c>
  .byte  197,236,84,211                      // vandps        %ymm3,%ymm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,226,125,24,29,220,87,2,0        // vbroadcastss  0x257dc(%rip),%ymm3        # 3a2a8 <_sk_srcover_bgra_8888_sse2_lowp+0x340>
  .byte  197,236,89,211                      // vmulps        %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,61,87,2,0         // vbroadcastss  0x2573d(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_565_avx
.globl _sk_store_565_avx
FUNCTION(_sk_store_565_avx)
_sk_store_565_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,98,125,24,21,11,87,2,0          // vbroadcastss  0x2570b(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,237,87,2,0         // vbroadcastss  0x257ed(%rip),%ymm11        # 3a308 <_sk_srcover_bgra_8888_sse2_lowp+0x3a0>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  196,193,25,114,241,11               // vpslld        $0xb,%xmm9,%xmm12
  .byte  196,67,125,25,201,1                 // vextractf128  $0x1,%ymm9,%xmm9
  .byte  196,193,49,114,241,11               // vpslld        $0xb,%xmm9,%xmm9
  .byte  196,67,29,24,201,1                  // vinsertf128   $0x1,%xmm9,%ymm12,%ymm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,98,125,24,45,189,87,2,0         // vbroadcastss  0x257bd(%rip),%ymm13        # 3a30c <_sk_srcover_bgra_8888_sse2_lowp+0x3a4>
  .byte  196,65,28,89,229                    // vmulps        %ymm13,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,17,114,244,5                // vpslld        $0x5,%xmm12,%xmm13
  .byte  196,67,125,25,228,1                 // vextractf128  $0x1,%ymm12,%xmm12
  .byte  196,193,25,114,244,5                // vpslld        $0x5,%xmm12,%xmm12
  .byte  196,67,21,24,228,1                  // vinsertf128   $0x1,%xmm12,%ymm13,%ymm12
  .byte  196,65,29,86,201                    // vorpd         %ymm9,%ymm12,%ymm9
  .byte  197,60,95,194                       // vmaxps        %ymm2,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,65,53,86,192                    // vorpd         %ymm8,%ymm9,%ymm8
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,66,57,43,193                    // vpackusdw     %xmm9,%xmm8,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           14ba8 <_sk_store_565_avx+0xc3>
  .byte  196,1,122,127,4,88                  // vmovdqu       %xmm8,(%r8,%r11,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,236                             // ja            14ba4 <_sk_store_565_avx+0xbf>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,69,0,0,0                  // lea           0x45(%rip),%r10        # 14c08 <_sk_store_565_avx+0x123>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,3,121,21,4,88,0                 // vpextrw       $0x0,%xmm8,(%r8,%r11,2)
  .byte  235,207                             // jmp           14ba4 <_sk_store_565_avx+0xbf>
  .byte  196,3,121,21,68,88,4,2              // vpextrw       $0x2,%xmm8,0x4(%r8,%r11,2)
  .byte  196,1,121,126,4,88                  // vmovd         %xmm8,(%r8,%r11,2)
  .byte  235,191                             // jmp           14ba4 <_sk_store_565_avx+0xbf>
  .byte  196,3,121,21,68,88,12,6             // vpextrw       $0x6,%xmm8,0xc(%r8,%r11,2)
  .byte  196,3,121,21,68,88,10,5             // vpextrw       $0x5,%xmm8,0xa(%r8,%r11,2)
  .byte  196,3,121,21,68,88,8,4              // vpextrw       $0x4,%xmm8,0x8(%r8,%r11,2)
  .byte  196,1,121,214,4,88                  // vmovq         %xmm8,(%r8,%r11,2)
  .byte  235,159                             // jmp           14ba4 <_sk_store_565_avx+0xbf>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  196                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,213                             // callq         *%rbp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,205                             // dec           %ebp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,245                             // push          %rbp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  237                                 // in            (%dx),%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,229                             // jmpq          *%rbp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  221,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_4444_avx
.globl _sk_load_4444_avx
FUNCTION(_sk_load_4444_avx)
_sk_load_4444_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,154,0,0,0                    // jne           14cdd <_sk_load_4444_avx+0xb9>
  .byte  196,129,122,111,4,88                // vmovdqu       (%r8,%r11,2),%xmm0
  .byte  196,226,121,51,200                  // vpmovzxwd     %xmm0,%xmm1
  .byte  197,249,112,192,78                  // vpshufd       $0x4e,%xmm0,%xmm0
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  196,227,117,24,216,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm3
  .byte  196,226,125,24,5,169,86,2,0         // vbroadcastss  0x256a9(%rip),%ymm0        # 3a310 <_sk_srcover_bgra_8888_sse2_lowp+0x3a8>
  .byte  197,228,84,192                      // vandps        %ymm0,%ymm3,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,156,86,2,0        // vbroadcastss  0x2569c(%rip),%ymm1        # 3a314 <_sk_srcover_bgra_8888_sse2_lowp+0x3ac>
  .byte  197,252,89,193                      // vmulps        %ymm1,%ymm0,%ymm0
  .byte  196,226,125,24,13,147,86,2,0        // vbroadcastss  0x25693(%rip),%ymm1        # 3a318 <_sk_srcover_bgra_8888_sse2_lowp+0x3b0>
  .byte  197,228,84,201                      // vandps        %ymm1,%ymm3,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,226,125,24,21,134,86,2,0        // vbroadcastss  0x25686(%rip),%ymm2        # 3a31c <_sk_srcover_bgra_8888_sse2_lowp+0x3b4>
  .byte  197,244,89,202                      // vmulps        %ymm2,%ymm1,%ymm1
  .byte  196,226,125,24,21,125,86,2,0        // vbroadcastss  0x2567d(%rip),%ymm2        # 3a320 <_sk_srcover_bgra_8888_sse2_lowp+0x3b8>
  .byte  197,228,84,210                      // vandps        %ymm2,%ymm3,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,98,125,24,5,112,86,2,0          // vbroadcastss  0x25670(%rip),%ymm8        # 3a324 <_sk_srcover_bgra_8888_sse2_lowp+0x3bc>
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  196,98,125,24,5,102,86,2,0          // vbroadcastss  0x25666(%rip),%ymm8        # 3a328 <_sk_srcover_bgra_8888_sse2_lowp+0x3c0>
  .byte  196,193,100,84,216                  // vandps        %ymm8,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,98,125,24,5,88,86,2,0           // vbroadcastss  0x25658(%rip),%ymm8        # 3a32c <_sk_srcover_bgra_8888_sse2_lowp+0x3c4>
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,84,255,255,255               // ja            14c49 <_sk_load_4444_avx+0x25>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,100,0,0,0                 // lea           0x64(%rip),%r10        # 14d64 <_sk_load_4444_avx+0x140>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  233,50,255,255,255                  // jmpq          14c49 <_sk_load_4444_avx+0x25>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,129,121,196,68,88,4,2           // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,110,12,88               // vmovd         (%r8,%r11,2),%xmm1
  .byte  196,227,121,14,193,3                // vpblendw      $0x3,%xmm1,%xmm0,%xmm0
  .byte  233,21,255,255,255                  // jmpq          14c49 <_sk_load_4444_avx+0x25>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,129,121,196,68,88,12,6          // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,196,68,88,10,5          // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,121,196,68,88,8,4           // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm0,%xmm0
  .byte  196,129,122,126,12,88               // vmovq         (%r8,%r11,2),%xmm1
  .byte  196,227,113,14,192,240              // vpblendw      $0xf0,%xmm0,%xmm1,%xmm0
  .byte  233,232,254,255,255                 // jmpq          14c49 <_sk_load_4444_avx+0x25>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  165                                 // movsl         %ds:(%rsi),%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  191,255,255,255,179                 // mov           $0xb3ffffff,%edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  236                                 // in            (%dx),%al
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,228                             // jmpq          *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  220,255                             // fdivr         %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_4444_dst_avx
.globl _sk_load_4444_dst_avx
FUNCTION(_sk_load_4444_dst_avx)
_sk_load_4444_dst_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,154,0,0,0                    // jne           14e39 <_sk_load_4444_dst_avx+0xb9>
  .byte  196,129,122,111,36,88               // vmovdqu       (%r8,%r11,2),%xmm4
  .byte  196,226,121,51,236                  // vpmovzxwd     %xmm4,%xmm5
  .byte  197,249,112,228,78                  // vpshufd       $0x4e,%xmm4,%xmm4
  .byte  196,226,121,51,228                  // vpmovzxwd     %xmm4,%xmm4
  .byte  196,227,85,24,252,1                 // vinsertf128   $0x1,%xmm4,%ymm5,%ymm7
  .byte  196,226,125,24,37,77,85,2,0         // vbroadcastss  0x2554d(%rip),%ymm4        # 3a310 <_sk_srcover_bgra_8888_sse2_lowp+0x3a8>
  .byte  197,196,84,228                      // vandps        %ymm4,%ymm7,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,226,125,24,45,64,85,2,0         // vbroadcastss  0x25540(%rip),%ymm5        # 3a314 <_sk_srcover_bgra_8888_sse2_lowp+0x3ac>
  .byte  197,220,89,229                      // vmulps        %ymm5,%ymm4,%ymm4
  .byte  196,226,125,24,45,55,85,2,0         // vbroadcastss  0x25537(%rip),%ymm5        # 3a318 <_sk_srcover_bgra_8888_sse2_lowp+0x3b0>
  .byte  197,196,84,237                      // vandps        %ymm5,%ymm7,%ymm5
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  196,226,125,24,53,42,85,2,0         // vbroadcastss  0x2552a(%rip),%ymm6        # 3a31c <_sk_srcover_bgra_8888_sse2_lowp+0x3b4>
  .byte  197,212,89,238                      // vmulps        %ymm6,%ymm5,%ymm5
  .byte  196,226,125,24,53,33,85,2,0         // vbroadcastss  0x25521(%rip),%ymm6        # 3a320 <_sk_srcover_bgra_8888_sse2_lowp+0x3b8>
  .byte  197,196,84,246                      // vandps        %ymm6,%ymm7,%ymm6
  .byte  197,252,91,246                      // vcvtdq2ps     %ymm6,%ymm6
  .byte  196,98,125,24,5,20,85,2,0           // vbroadcastss  0x25514(%rip),%ymm8        # 3a324 <_sk_srcover_bgra_8888_sse2_lowp+0x3bc>
  .byte  196,193,76,89,240                   // vmulps        %ymm8,%ymm6,%ymm6
  .byte  196,98,125,24,5,10,85,2,0           // vbroadcastss  0x2550a(%rip),%ymm8        # 3a328 <_sk_srcover_bgra_8888_sse2_lowp+0x3c0>
  .byte  196,193,68,84,248                   // vandps        %ymm8,%ymm7,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,98,125,24,5,252,84,2,0          // vbroadcastss  0x254fc(%rip),%ymm8        # 3a32c <_sk_srcover_bgra_8888_sse2_lowp+0x3c4>
  .byte  196,193,68,89,248                   // vmulps        %ymm8,%ymm7,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,84,255,255,255               // ja            14da5 <_sk_load_4444_dst_avx+0x25>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,100,0,0,0                 // lea           0x64(%rip),%r10        # 14ec0 <_sk_load_4444_dst_avx+0x140>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  67,15,183,4,88                      // movzwl        (%r8,%r11,2),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  233,50,255,255,255                  // jmpq          14da5 <_sk_load_4444_dst_avx+0x25>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,129,89,196,100,88,4,2           // vpinsrw       $0x2,0x4(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,121,110,44,88               // vmovd         (%r8,%r11,2),%xmm5
  .byte  196,227,89,14,229,3                 // vpblendw      $0x3,%xmm5,%xmm4,%xmm4
  .byte  233,21,255,255,255                  // jmpq          14da5 <_sk_load_4444_dst_avx+0x25>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,129,89,196,100,88,12,6          // vpinsrw       $0x6,0xc(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,89,196,100,88,10,5          // vpinsrw       $0x5,0xa(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,89,196,100,88,8,4           // vpinsrw       $0x4,0x8(%r8,%r11,2),%xmm4,%xmm4
  .byte  196,129,122,126,44,88               // vmovq         (%r8,%r11,2),%xmm5
  .byte  196,227,81,14,228,240               // vpblendw      $0xf0,%xmm4,%xmm5,%xmm4
  .byte  233,232,254,255,255                 // jmpq          14da5 <_sk_load_4444_dst_avx+0x25>
  .byte  15,31,0                             // nopl          (%rax)
  .byte  165                                 // movsl         %ds:(%rsi),%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  191,255,255,255,179                 // mov           $0xb3ffffff,%edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  236                                 // in            (%dx),%al
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,228                             // jmpq          *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  220,255                             // fdivr         %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_4444_avx
.globl _sk_gather_4444_avx
FUNCTION(_sk_gather_4444_avx)
_sk_gather_4444_avx:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,80,12                // vbroadcastss  0xc(%rax),%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  196,65,57,118,192                   // vpcmpeqd      %xmm8,%xmm8,%xmm8
  .byte  196,193,97,254,216                  // vpaddd        %xmm8,%xmm3,%xmm3
  .byte  196,193,105,254,208                 // vpaddd        %xmm8,%xmm2,%xmm2
  .byte  196,227,109,24,211,1                // vinsertf128   $0x1,%xmm3,%ymm2,%ymm2
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,180,95,192                      // vmaxps        %ymm0,%ymm9,%ymm0
  .byte  197,252,93,210                      // vminps        %ymm2,%ymm0,%ymm2
  .byte  196,226,125,24,64,16                // vbroadcastss  0x10(%rax),%ymm0
  .byte  196,227,125,25,195,1                // vextractf128  $0x1,%ymm0,%xmm3
  .byte  196,193,97,254,216                  // vpaddd        %xmm8,%xmm3,%xmm3
  .byte  196,193,121,254,192                 // vpaddd        %xmm8,%xmm0,%xmm0
  .byte  196,227,125,24,195,1                // vinsertf128   $0x1,%xmm3,%ymm0,%ymm0
  .byte  197,180,95,201                      // vmaxps        %ymm1,%ymm9,%ymm1
  .byte  197,244,93,192                      // vminps        %ymm0,%ymm1,%ymm0
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,200                      // vcvttps2dq    %ymm0,%ymm1
  .byte  197,249,110,64,8                    // vmovd         0x8(%rax),%xmm0
  .byte  197,249,112,216,0                   // vpshufd       $0x0,%xmm0,%xmm3
  .byte  196,226,97,64,193                   // vpmulld       %xmm1,%xmm3,%xmm0
  .byte  196,227,125,25,201,1                // vextractf128  $0x1,%ymm1,%xmm1
  .byte  196,226,97,64,201                   // vpmulld       %xmm1,%xmm3,%xmm1
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  197,241,254,203                     // vpaddd        %xmm3,%xmm1,%xmm1
  .byte  196,227,249,22,200,1                // vpextrq       $0x1,%xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,202                 // vmovq         %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  197,249,254,194                     // vpaddd        %xmm2,%xmm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,183,60,120                    // movzwl        (%r8,%r15,2),%r15d
  .byte  67,15,183,44,96                     // movzwl        (%r8,%r12,2),%ebp
  .byte  197,249,110,197                     // vmovd         %ebp,%xmm0
  .byte  196,193,121,196,199,1               // vpinsrw       $0x1,%r15d,%xmm0,%xmm0
  .byte  67,15,183,44,112                    // movzwl        (%r8,%r14,2),%ebp
  .byte  197,249,196,197,2                   // vpinsrw       $0x2,%ebp,%xmm0,%xmm0
  .byte  65,15,183,28,88                     // movzwl        (%r8,%rbx,2),%ebx
  .byte  197,249,196,195,3                   // vpinsrw       $0x3,%ebx,%xmm0,%xmm0
  .byte  67,15,183,44,88                     // movzwl        (%r8,%r11,2),%ebp
  .byte  197,249,196,197,4                   // vpinsrw       $0x4,%ebp,%xmm0,%xmm0
  .byte  67,15,183,44,80                     // movzwl        (%r8,%r10,2),%ebp
  .byte  197,249,196,197,5                   // vpinsrw       $0x5,%ebp,%xmm0,%xmm0
  .byte  67,15,183,44,72                     // movzwl        (%r8,%r9,2),%ebp
  .byte  197,249,196,197,6                   // vpinsrw       $0x6,%ebp,%xmm0,%xmm0
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,249,196,192,7                   // vpinsrw       $0x7,%eax,%xmm0,%xmm0
  .byte  196,226,121,51,200                  // vpmovzxwd     %xmm0,%xmm1
  .byte  197,249,112,192,78                  // vpshufd       $0x4e,%xmm0,%xmm0
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  196,227,117,24,216,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm3
  .byte  196,226,125,24,5,5,83,2,0           // vbroadcastss  0x25305(%rip),%ymm0        # 3a310 <_sk_srcover_bgra_8888_sse2_lowp+0x3a8>
  .byte  197,228,84,192                      // vandps        %ymm0,%ymm3,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,226,125,24,13,248,82,2,0        // vbroadcastss  0x252f8(%rip),%ymm1        # 3a314 <_sk_srcover_bgra_8888_sse2_lowp+0x3ac>
  .byte  197,252,89,193                      // vmulps        %ymm1,%ymm0,%ymm0
  .byte  196,226,125,24,13,239,82,2,0        // vbroadcastss  0x252ef(%rip),%ymm1        # 3a318 <_sk_srcover_bgra_8888_sse2_lowp+0x3b0>
  .byte  197,228,84,201                      // vandps        %ymm1,%ymm3,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,226,125,24,21,226,82,2,0        // vbroadcastss  0x252e2(%rip),%ymm2        # 3a31c <_sk_srcover_bgra_8888_sse2_lowp+0x3b4>
  .byte  197,244,89,202                      // vmulps        %ymm2,%ymm1,%ymm1
  .byte  196,226,125,24,21,217,82,2,0        // vbroadcastss  0x252d9(%rip),%ymm2        # 3a320 <_sk_srcover_bgra_8888_sse2_lowp+0x3b8>
  .byte  197,228,84,210                      // vandps        %ymm2,%ymm3,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,98,125,24,5,204,82,2,0          // vbroadcastss  0x252cc(%rip),%ymm8        # 3a324 <_sk_srcover_bgra_8888_sse2_lowp+0x3bc>
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  196,98,125,24,5,194,82,2,0          // vbroadcastss  0x252c2(%rip),%ymm8        # 3a328 <_sk_srcover_bgra_8888_sse2_lowp+0x3c0>
  .byte  196,193,100,84,216                  // vandps        %ymm8,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,98,125,24,5,180,82,2,0          // vbroadcastss  0x252b4(%rip),%ymm8        # 3a32c <_sk_srcover_bgra_8888_sse2_lowp+0x3c4>
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_4444_avx
.globl _sk_store_4444_avx
FUNCTION(_sk_store_4444_avx)
_sk_store_4444_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,208                       // vmaxps        %ymm0,%ymm8,%ymm10
  .byte  196,98,125,24,13,103,81,2,0         // vbroadcastss  0x25167(%rip),%ymm9        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,44,93,209                    // vminps        %ymm9,%ymm10,%ymm10
  .byte  196,98,125,24,29,113,82,2,0         // vbroadcastss  0x25271(%rip),%ymm11        # 3a330 <_sk_srcover_bgra_8888_sse2_lowp+0x3c8>
  .byte  196,65,44,89,211                    // vmulps        %ymm11,%ymm10,%ymm10
  .byte  196,65,125,91,210                   // vcvtps2dq     %ymm10,%ymm10
  .byte  196,193,25,114,242,12               // vpslld        $0xc,%xmm10,%xmm12
  .byte  196,67,125,25,210,1                 // vextractf128  $0x1,%ymm10,%xmm10
  .byte  196,193,41,114,242,12               // vpslld        $0xc,%xmm10,%xmm10
  .byte  196,67,29,24,210,1                  // vinsertf128   $0x1,%xmm10,%ymm12,%ymm10
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,225                    // vminps        %ymm9,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,17,114,244,8                // vpslld        $0x8,%xmm12,%xmm13
  .byte  196,67,125,25,228,1                 // vextractf128  $0x1,%ymm12,%xmm12
  .byte  196,193,25,114,244,8                // vpslld        $0x8,%xmm12,%xmm12
  .byte  196,67,21,24,228,1                  // vinsertf128   $0x1,%xmm12,%ymm13,%ymm12
  .byte  196,65,29,86,210                    // vorpd         %ymm10,%ymm12,%ymm10
  .byte  197,60,95,226                       // vmaxps        %ymm2,%ymm8,%ymm12
  .byte  196,65,28,93,225                    // vminps        %ymm9,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,17,114,244,4                // vpslld        $0x4,%xmm12,%xmm13
  .byte  196,67,125,25,228,1                 // vextractf128  $0x1,%ymm12,%xmm12
  .byte  196,193,25,114,244,4                // vpslld        $0x4,%xmm12,%xmm12
  .byte  196,67,21,24,228,1                  // vinsertf128   $0x1,%xmm12,%ymm13,%ymm12
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,193                    // vminps        %ymm9,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,65,29,86,192                    // vorpd         %ymm8,%ymm12,%ymm8
  .byte  196,65,45,86,192                    // vorpd         %ymm8,%ymm10,%ymm8
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,66,57,43,193                    // vpackusdw     %xmm9,%xmm8,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           15173 <_sk_store_4444_avx+0xea>
  .byte  196,1,122,127,4,88                  // vmovdqu       %xmm8,(%r8,%r11,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,236                             // ja            1516f <_sk_store_4444_avx+0xe6>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,66,0,0,0                  // lea           0x42(%rip),%r10        # 151d0 <_sk_store_4444_avx+0x147>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,3,121,21,4,88,0                 // vpextrw       $0x0,%xmm8,(%r8,%r11,2)
  .byte  235,207                             // jmp           1516f <_sk_store_4444_avx+0xe6>
  .byte  196,3,121,21,68,88,4,2              // vpextrw       $0x2,%xmm8,0x4(%r8,%r11,2)
  .byte  196,1,121,126,4,88                  // vmovd         %xmm8,(%r8,%r11,2)
  .byte  235,191                             // jmp           1516f <_sk_store_4444_avx+0xe6>
  .byte  196,3,121,21,68,88,12,6             // vpextrw       $0x6,%xmm8,0xc(%r8,%r11,2)
  .byte  196,3,121,21,68,88,10,5             // vpextrw       $0x5,%xmm8,0xa(%r8,%r11,2)
  .byte  196,3,121,21,68,88,8,4              // vpextrw       $0x4,%xmm8,0x8(%r8,%r11,2)
  .byte  196,1,121,214,4,88                  // vmovq         %xmm8,(%r8,%r11,2)
  .byte  235,159                             // jmp           1516f <_sk_store_4444_avx+0xe6>
  .byte  199                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  216,255                             // fdivr         %st(7),%st
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  248                                 // clc
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,240                             // push          %rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  232,255,255,255,224                 // callq         ffffffffe10151e8 <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffe0fdb280>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_8888_avx
.globl _sk_load_8888_avx
FUNCTION(_sk_load_8888_avx)
_sk_load_8888_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,135,0,0,0                    // jne           15293 <_sk_load_8888_avx+0xa7>
  .byte  196,1,125,16,12,152                 // vmovupd       (%r8,%r11,4),%ymm9
  .byte  197,125,40,21,166,85,2,0            // vmovapd       0x255a6(%rip),%ymm10        # 3a7c0 <_sk_srcover_bgra_8888_sse2_lowp+0x858>
  .byte  196,193,53,84,194                   // vandpd        %ymm10,%ymm9,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,5,100,80,2,0          // vbroadcastss  0x25064(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  196,193,113,114,209,8               // vpsrld        $0x8,%xmm9,%xmm1
  .byte  196,99,125,25,203,1                 // vextractf128  $0x1,%ymm9,%xmm3
  .byte  197,233,114,211,8                   // vpsrld        $0x8,%xmm3,%xmm2
  .byte  196,227,117,24,202,1                // vinsertf128   $0x1,%xmm2,%ymm1,%ymm1
  .byte  196,193,117,84,202                  // vandpd        %ymm10,%ymm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  196,193,33,114,209,16               // vpsrld        $0x10,%xmm9,%xmm11
  .byte  197,233,114,211,16                  // vpsrld        $0x10,%xmm3,%xmm2
  .byte  196,227,37,24,210,1                 // vinsertf128   $0x1,%xmm2,%ymm11,%ymm2
  .byte  196,193,109,84,210                  // vandpd        %ymm10,%ymm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,208                  // vmulps        %ymm8,%ymm2,%ymm2
  .byte  196,193,49,114,209,24               // vpsrld        $0x18,%xmm9,%xmm9
  .byte  197,225,114,211,24                  // vpsrld        $0x18,%xmm3,%xmm3
  .byte  196,227,53,24,219,1                 // vinsertf128   $0x1,%xmm3,%ymm9,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,102,255,255,255              // ja            15212 <_sk_load_8888_avx+0x26>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,145,0,0,0                 // lea           0x91(%rip),%r10        # 15348 <_sk_load_8888_avx+0x15c>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,122,16,12,152                 // vmovss        (%r8,%r11,4),%xmm9
  .byte  233,71,255,255,255                  // jmpq          15212 <_sk_load_8888_avx+0x26>
  .byte  196,129,121,110,68,152,8            // vmovd         0x8(%r8,%r11,4),%xmm0
  .byte  197,249,112,192,68                  // vpshufd       $0x44,%xmm0,%xmm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,99,117,12,200,4                 // vblendps      $0x4,%ymm0,%ymm1,%ymm9
  .byte  196,129,123,16,4,152                // vmovsd        (%r8,%r11,4),%xmm0
  .byte  196,99,53,13,200,1                  // vblendpd      $0x1,%ymm0,%ymm9,%ymm9
  .byte  233,32,255,255,255                  // jmpq          15212 <_sk_load_8888_avx+0x26>
  .byte  196,129,121,110,68,152,24           // vmovd         0x18(%r8,%r11,4),%xmm0
  .byte  197,249,112,192,68                  // vpshufd       $0x44,%xmm0,%xmm0
  .byte  196,227,125,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,99,117,12,200,64                // vblendps      $0x40,%ymm0,%ymm1,%ymm9
  .byte  196,99,125,25,200,1                 // vextractf128  $0x1,%ymm9,%xmm0
  .byte  196,131,121,34,68,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm0,%xmm0
  .byte  196,99,53,24,200,1                  // vinsertf128   $0x1,%xmm0,%ymm9,%ymm9
  .byte  196,99,125,25,200,1                 // vextractf128  $0x1,%ymm9,%xmm0
  .byte  196,131,121,34,68,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm0,%xmm0
  .byte  196,99,53,24,200,1                  // vinsertf128   $0x1,%xmm0,%ymm9,%ymm9
  .byte  196,129,121,16,4,152                // vmovupd       (%r8,%r11,4),%xmm0
  .byte  196,67,125,13,201,12                // vblendpd      $0xc,%ymm9,%ymm0,%ymm9
  .byte  233,203,254,255,255                 // jmpq          15212 <_sk_load_8888_avx+0x26>
  .byte  144                                 // nop
  .byte  120,255                             // js            15349 <_sk_load_8888_avx+0x15d>
  .byte  255                                 // (bad)
  .byte  255,153,255,255,255,131             // lcall         *-0x7c000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  238                                 // out           %al,(%dx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  218,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,198                             // inc           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_8888_dst_avx
.globl _sk_load_8888_dst_avx
FUNCTION(_sk_load_8888_dst_avx)
_sk_load_8888_dst_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,135,0,0,0                    // jne           1540b <_sk_load_8888_dst_avx+0xa7>
  .byte  196,1,125,16,12,152                 // vmovupd       (%r8,%r11,4),%ymm9
  .byte  197,125,40,21,78,84,2,0             // vmovapd       0x2544e(%rip),%ymm10        # 3a7e0 <_sk_srcover_bgra_8888_sse2_lowp+0x878>
  .byte  196,193,53,84,226                   // vandpd        %ymm10,%ymm9,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,98,125,24,5,236,78,2,0          // vbroadcastss  0x24eec(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,92,89,224                   // vmulps        %ymm8,%ymm4,%ymm4
  .byte  196,193,81,114,209,8                // vpsrld        $0x8,%xmm9,%xmm5
  .byte  196,99,125,25,207,1                 // vextractf128  $0x1,%ymm9,%xmm7
  .byte  197,201,114,215,8                   // vpsrld        $0x8,%xmm7,%xmm6
  .byte  196,227,85,24,238,1                 // vinsertf128   $0x1,%xmm6,%ymm5,%ymm5
  .byte  196,193,85,84,234                   // vandpd        %ymm10,%ymm5,%ymm5
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  196,193,84,89,232                   // vmulps        %ymm8,%ymm5,%ymm5
  .byte  196,193,33,114,209,16               // vpsrld        $0x10,%xmm9,%xmm11
  .byte  197,201,114,215,16                  // vpsrld        $0x10,%xmm7,%xmm6
  .byte  196,227,37,24,246,1                 // vinsertf128   $0x1,%xmm6,%ymm11,%ymm6
  .byte  196,193,77,84,242                   // vandpd        %ymm10,%ymm6,%ymm6
  .byte  197,252,91,246                      // vcvtdq2ps     %ymm6,%ymm6
  .byte  196,193,76,89,240                   // vmulps        %ymm8,%ymm6,%ymm6
  .byte  196,193,49,114,209,24               // vpsrld        $0x18,%xmm9,%xmm9
  .byte  197,193,114,215,24                  // vpsrld        $0x18,%xmm7,%xmm7
  .byte  196,227,53,24,255,1                 // vinsertf128   $0x1,%xmm7,%ymm9,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,193,68,89,248                   // vmulps        %ymm8,%ymm7,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,102,255,255,255              // ja            1538a <_sk_load_8888_dst_avx+0x26>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,145,0,0,0                 // lea           0x91(%rip),%r10        # 154c0 <_sk_load_8888_dst_avx+0x15c>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,122,16,12,152                 // vmovss        (%r8,%r11,4),%xmm9
  .byte  233,71,255,255,255                  // jmpq          1538a <_sk_load_8888_dst_avx+0x26>
  .byte  196,129,121,110,100,152,8           // vmovd         0x8(%r8,%r11,4),%xmm4
  .byte  197,249,112,228,68                  // vpshufd       $0x44,%xmm4,%xmm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  196,99,85,12,204,4                  // vblendps      $0x4,%ymm4,%ymm5,%ymm9
  .byte  196,129,123,16,36,152               // vmovsd        (%r8,%r11,4),%xmm4
  .byte  196,99,53,13,204,1                  // vblendpd      $0x1,%ymm4,%ymm9,%ymm9
  .byte  233,32,255,255,255                  // jmpq          1538a <_sk_load_8888_dst_avx+0x26>
  .byte  196,129,121,110,100,152,24          // vmovd         0x18(%r8,%r11,4),%xmm4
  .byte  197,249,112,228,68                  // vpshufd       $0x44,%xmm4,%xmm4
  .byte  196,227,125,24,228,1                // vinsertf128   $0x1,%xmm4,%ymm0,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  196,99,85,12,204,64                 // vblendps      $0x40,%ymm4,%ymm5,%ymm9
  .byte  196,99,125,25,204,1                 // vextractf128  $0x1,%ymm9,%xmm4
  .byte  196,131,89,34,100,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,99,53,24,204,1                  // vinsertf128   $0x1,%xmm4,%ymm9,%ymm9
  .byte  196,99,125,25,204,1                 // vextractf128  $0x1,%ymm9,%xmm4
  .byte  196,131,89,34,100,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,99,53,24,204,1                  // vinsertf128   $0x1,%xmm4,%ymm9,%ymm9
  .byte  196,129,121,16,36,152               // vmovupd       (%r8,%r11,4),%xmm4
  .byte  196,67,93,13,201,12                 // vblendpd      $0xc,%ymm9,%ymm4,%ymm9
  .byte  233,203,254,255,255                 // jmpq          1538a <_sk_load_8888_dst_avx+0x26>
  .byte  144                                 // nop
  .byte  120,255                             // js            154c1 <_sk_load_8888_dst_avx+0x15d>
  .byte  255                                 // (bad)
  .byte  255,153,255,255,255,131             // lcall         *-0x7c000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  238                                 // out           %al,(%dx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  218,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,198                             // inc           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_8888_avx
.globl _sk_gather_8888_avx
FUNCTION(_sk_gather_8888_avx)
_sk_gather_8888_avx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,80,12                // vbroadcastss  0xc(%rax),%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  196,65,57,118,192                   // vpcmpeqd      %xmm8,%xmm8,%xmm8
  .byte  196,193,97,254,216                  // vpaddd        %xmm8,%xmm3,%xmm3
  .byte  196,193,105,254,208                 // vpaddd        %xmm8,%xmm2,%xmm2
  .byte  196,227,109,24,211,1                // vinsertf128   $0x1,%xmm3,%ymm2,%ymm2
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,180,95,192                      // vmaxps        %ymm0,%ymm9,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,24,80,16                // vbroadcastss  0x10(%rax),%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  196,193,97,254,216                  // vpaddd        %xmm8,%xmm3,%xmm3
  .byte  196,193,105,254,208                 // vpaddd        %xmm8,%xmm2,%xmm2
  .byte  196,227,109,24,211,1                // vinsertf128   $0x1,%xmm3,%ymm2,%ymm2
  .byte  197,180,95,201                      // vmaxps        %ymm1,%ymm9,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  197,249,110,80,8                    // vmovd         0x8(%rax),%xmm2
  .byte  197,249,112,210,0                   // vpshufd       $0x0,%xmm2,%xmm2
  .byte  196,226,105,64,217                  // vpmulld       %xmm1,%xmm2,%xmm3
  .byte  196,227,125,25,201,1                // vextractf128  $0x1,%ymm1,%xmm1
  .byte  196,226,105,64,201                  // vpmulld       %xmm1,%xmm2,%xmm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  196,227,125,25,194,1                // vextractf128  $0x1,%ymm0,%xmm2
  .byte  197,241,254,202                     // vpaddd        %xmm2,%xmm1,%xmm1
  .byte  196,225,249,126,200                 // vmovq         %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  197,225,254,192                     // vpaddd        %xmm0,%xmm3,%xmm0
  .byte  196,193,249,126,194                 // vmovq         %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,249,22,203,1                // vpextrq       $0x1,%xmm1,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,195,249,22,199,1                // vpextrq       $0x1,%xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  196,129,121,110,4,152               // vmovd         (%r8,%r11,4),%xmm0
  .byte  196,131,121,34,4,144,1              // vpinsrd       $0x1,(%r8,%r10,4),%xmm0,%xmm0
  .byte  196,131,121,34,4,160,2              // vpinsrd       $0x2,(%r8,%r12,4),%xmm0,%xmm0
  .byte  196,3,121,34,4,184,3                // vpinsrd       $0x3,(%r8,%r15,4),%xmm0,%xmm8
  .byte  196,129,121,110,4,136               // vmovd         (%r8,%r9,4),%xmm0
  .byte  196,195,121,34,4,128,1              // vpinsrd       $0x1,(%r8,%rax,4),%xmm0,%xmm0
  .byte  196,131,121,34,4,176,2              // vpinsrd       $0x2,(%r8,%r14,4),%xmm0,%xmm0
  .byte  196,195,121,34,28,152,3             // vpinsrd       $0x3,(%r8,%rbx,4),%xmm0,%xmm3
  .byte  196,227,61,24,195,1                 // vinsertf128   $0x1,%xmm3,%ymm8,%ymm0
  .byte  197,124,40,21,32,82,2,0             // vmovaps       0x25220(%rip),%ymm10        # 3a800 <_sk_srcover_bgra_8888_sse2_lowp+0x898>
  .byte  196,193,124,84,194                  // vandps        %ymm10,%ymm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,13,158,76,2,0         // vbroadcastss  0x24c9e(%rip),%ymm9        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  196,193,113,114,208,8               // vpsrld        $0x8,%xmm8,%xmm1
  .byte  197,233,114,211,8                   // vpsrld        $0x8,%xmm3,%xmm2
  .byte  196,227,117,24,202,1                // vinsertf128   $0x1,%xmm2,%ymm1,%ymm1
  .byte  196,193,116,84,202                  // vandps        %ymm10,%ymm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,201                  // vmulps        %ymm9,%ymm1,%ymm1
  .byte  196,193,33,114,208,16               // vpsrld        $0x10,%xmm8,%xmm11
  .byte  197,233,114,211,16                  // vpsrld        $0x10,%xmm3,%xmm2
  .byte  196,227,37,24,210,1                 // vinsertf128   $0x1,%xmm2,%ymm11,%ymm2
  .byte  196,193,108,84,210                  // vandps        %ymm10,%ymm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,209                  // vmulps        %ymm9,%ymm2,%ymm2
  .byte  196,193,57,114,208,24               // vpsrld        $0x18,%xmm8,%xmm8
  .byte  197,225,114,211,24                  // vpsrld        $0x18,%xmm3,%xmm3
  .byte  196,227,61,24,219,1                 // vinsertf128   $0x1,%xmm3,%ymm8,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,217                  // vmulps        %ymm9,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_8888_avx
.globl _sk_store_8888_avx
FUNCTION(_sk_store_8888_avx)
_sk_store_8888_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,98,125,24,21,149,75,2,0         // vbroadcastss  0x24b95(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,179,75,2,0         // vbroadcastss  0x24bb3(%rip),%ymm11        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,17,114,244,8                // vpslld        $0x8,%xmm12,%xmm13
  .byte  196,67,125,25,228,1                 // vextractf128  $0x1,%ymm12,%xmm12
  .byte  196,193,25,114,244,8                // vpslld        $0x8,%xmm12,%xmm12
  .byte  196,67,21,24,228,1                  // vinsertf128   $0x1,%xmm12,%ymm13,%ymm12
  .byte  196,65,29,86,201                    // vorpd         %ymm9,%ymm12,%ymm9
  .byte  197,60,95,226                       // vmaxps        %ymm2,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,17,114,244,16               // vpslld        $0x10,%xmm12,%xmm13
  .byte  196,67,125,25,228,1                 // vextractf128  $0x1,%ymm12,%xmm12
  .byte  196,193,25,114,244,16               // vpslld        $0x10,%xmm12,%xmm12
  .byte  196,67,21,24,228,1                  // vinsertf128   $0x1,%xmm12,%ymm13,%ymm12
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,193,41,114,240,24               // vpslld        $0x18,%xmm8,%xmm10
  .byte  196,67,125,25,192,1                 // vextractf128  $0x1,%ymm8,%xmm8
  .byte  196,193,57,114,240,24               // vpslld        $0x18,%xmm8,%xmm8
  .byte  196,67,45,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm10,%ymm8
  .byte  196,65,29,86,192                    // vorpd         %ymm8,%ymm12,%ymm8
  .byte  196,65,53,86,192                    // vorpd         %ymm8,%ymm9,%ymm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           1573a <_sk_store_8888_avx+0xe0>
  .byte  196,1,124,17,4,152                  // vmovups       %ymm8,(%r8,%r11,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,236                             // ja            15736 <_sk_store_8888_avx+0xdc>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,83,0,0,0                  // lea           0x53(%rip),%r10        # 157a8 <_sk_store_8888_avx+0x14e>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,121,126,4,152                 // vmovd         %xmm8,(%r8,%r11,4)
  .byte  235,208                             // jmp           15736 <_sk_store_8888_avx+0xdc>
  .byte  196,3,121,22,68,152,8,2             // vpextrd       $0x2,%xmm8,0x8(%r8,%r11,4)
  .byte  196,1,121,214,4,152                 // vmovq         %xmm8,(%r8,%r11,4)
  .byte  235,192                             // jmp           15736 <_sk_store_8888_avx+0xdc>
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,24,2            // vpextrd       $0x2,%xmm9,0x18(%r8,%r11,4)
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,20,1            // vpextrd       $0x1,%xmm9,0x14(%r8,%r11,4)
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,1,122,17,76,152,16              // vmovss        %xmm9,0x10(%r8,%r11,4)
  .byte  196,1,121,17,4,152                  // vmovupd       %xmm8,(%r8,%r11,4)
  .byte  235,143                             // jmp           15736 <_sk_store_8888_avx+0xdc>
  .byte  144                                 // nop
  .byte  182,255                             // mov           $0xff,%dh
  .byte  255                                 // (bad)
  .byte  255,198                             // inc           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  190,255,255,255,247                 // mov           $0xf7ffffff,%esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  234                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  220,255                             // fdivr         %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,206                             // dec           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_bgra_avx
.globl _sk_load_bgra_avx
FUNCTION(_sk_load_bgra_avx)
_sk_load_bgra_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,135,0,0,0                    // jne           1586b <_sk_load_bgra_avx+0xa7>
  .byte  196,1,125,16,12,152                 // vmovupd       (%r8,%r11,4),%ymm9
  .byte  197,125,40,21,46,80,2,0             // vmovapd       0x2502e(%rip),%ymm10        # 3a820 <_sk_srcover_bgra_8888_sse2_lowp+0x8b8>
  .byte  196,193,53,84,202                   // vandpd        %ymm10,%ymm9,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,98,125,24,5,140,74,2,0          // vbroadcastss  0x24a8c(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,116,89,208                  // vmulps        %ymm8,%ymm1,%ymm2
  .byte  196,193,113,114,209,8               // vpsrld        $0x8,%xmm9,%xmm1
  .byte  196,99,125,25,203,1                 // vextractf128  $0x1,%ymm9,%xmm3
  .byte  197,249,114,211,8                   // vpsrld        $0x8,%xmm3,%xmm0
  .byte  196,227,117,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  196,193,125,84,194                  // vandpd        %ymm10,%ymm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,193,124,89,200                  // vmulps        %ymm8,%ymm0,%ymm1
  .byte  196,193,33,114,209,16               // vpsrld        $0x10,%xmm9,%xmm11
  .byte  197,249,114,211,16                  // vpsrld        $0x10,%xmm3,%xmm0
  .byte  196,227,37,24,192,1                 // vinsertf128   $0x1,%xmm0,%ymm11,%ymm0
  .byte  196,193,125,84,194                  // vandpd        %ymm10,%ymm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  196,193,49,114,209,24               // vpsrld        $0x18,%xmm9,%xmm9
  .byte  197,225,114,211,24                  // vpsrld        $0x18,%xmm3,%xmm3
  .byte  196,227,53,24,219,1                 // vinsertf128   $0x1,%xmm3,%ymm9,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,216                  // vmulps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,102,255,255,255              // ja            157ea <_sk_load_bgra_avx+0x26>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,145,0,0,0                 // lea           0x91(%rip),%r10        # 15920 <_sk_load_bgra_avx+0x15c>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,122,16,12,152                 // vmovss        (%r8,%r11,4),%xmm9
  .byte  233,71,255,255,255                  // jmpq          157ea <_sk_load_bgra_avx+0x26>
  .byte  196,129,121,110,68,152,8            // vmovd         0x8(%r8,%r11,4),%xmm0
  .byte  197,249,112,192,68                  // vpshufd       $0x44,%xmm0,%xmm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,99,117,12,200,4                 // vblendps      $0x4,%ymm0,%ymm1,%ymm9
  .byte  196,129,123,16,4,152                // vmovsd        (%r8,%r11,4),%xmm0
  .byte  196,99,53,13,200,1                  // vblendpd      $0x1,%ymm0,%ymm9,%ymm9
  .byte  233,32,255,255,255                  // jmpq          157ea <_sk_load_bgra_avx+0x26>
  .byte  196,129,121,110,68,152,24           // vmovd         0x18(%r8,%r11,4),%xmm0
  .byte  197,249,112,192,68                  // vpshufd       $0x44,%xmm0,%xmm0
  .byte  196,227,125,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,99,117,12,200,64                // vblendps      $0x40,%ymm0,%ymm1,%ymm9
  .byte  196,99,125,25,200,1                 // vextractf128  $0x1,%ymm9,%xmm0
  .byte  196,131,121,34,68,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm0,%xmm0
  .byte  196,99,53,24,200,1                  // vinsertf128   $0x1,%xmm0,%ymm9,%ymm9
  .byte  196,99,125,25,200,1                 // vextractf128  $0x1,%ymm9,%xmm0
  .byte  196,131,121,34,68,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm0,%xmm0
  .byte  196,99,53,24,200,1                  // vinsertf128   $0x1,%xmm0,%ymm9,%ymm9
  .byte  196,129,121,16,4,152                // vmovupd       (%r8,%r11,4),%xmm0
  .byte  196,67,125,13,201,12                // vblendpd      $0xc,%ymm9,%ymm0,%ymm9
  .byte  233,203,254,255,255                 // jmpq          157ea <_sk_load_bgra_avx+0x26>
  .byte  144                                 // nop
  .byte  120,255                             // js            15921 <_sk_load_bgra_avx+0x15d>
  .byte  255                                 // (bad)
  .byte  255,153,255,255,255,131             // lcall         *-0x7c000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  238                                 // out           %al,(%dx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  218,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,198                             // inc           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_bgra_dst_avx
.globl _sk_load_bgra_dst_avx
FUNCTION(_sk_load_bgra_dst_avx)
_sk_load_bgra_dst_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,135,0,0,0                    // jne           159e3 <_sk_load_bgra_dst_avx+0xa7>
  .byte  196,1,125,16,12,152                 // vmovupd       (%r8,%r11,4),%ymm9
  .byte  197,125,40,21,214,78,2,0            // vmovapd       0x24ed6(%rip),%ymm10        # 3a840 <_sk_srcover_bgra_8888_sse2_lowp+0x8d8>
  .byte  196,193,53,84,234                   // vandpd        %ymm10,%ymm9,%ymm5
  .byte  197,252,91,237                      // vcvtdq2ps     %ymm5,%ymm5
  .byte  196,98,125,24,5,20,73,2,0           // vbroadcastss  0x24914(%rip),%ymm8        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,84,89,240                   // vmulps        %ymm8,%ymm5,%ymm6
  .byte  196,193,81,114,209,8                // vpsrld        $0x8,%xmm9,%xmm5
  .byte  196,99,125,25,207,1                 // vextractf128  $0x1,%ymm9,%xmm7
  .byte  197,217,114,215,8                   // vpsrld        $0x8,%xmm7,%xmm4
  .byte  196,227,85,24,228,1                 // vinsertf128   $0x1,%xmm4,%ymm5,%ymm4
  .byte  196,193,93,84,226                   // vandpd        %ymm10,%ymm4,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,193,92,89,232                   // vmulps        %ymm8,%ymm4,%ymm5
  .byte  196,193,33,114,209,16               // vpsrld        $0x10,%xmm9,%xmm11
  .byte  197,217,114,215,16                  // vpsrld        $0x10,%xmm7,%xmm4
  .byte  196,227,37,24,228,1                 // vinsertf128   $0x1,%xmm4,%ymm11,%ymm4
  .byte  196,193,93,84,226                   // vandpd        %ymm10,%ymm4,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  196,193,92,89,224                   // vmulps        %ymm8,%ymm4,%ymm4
  .byte  196,193,49,114,209,24               // vpsrld        $0x18,%xmm9,%xmm9
  .byte  197,193,114,215,24                  // vpsrld        $0x18,%xmm7,%xmm7
  .byte  196,227,53,24,255,1                 // vinsertf128   $0x1,%xmm7,%ymm9,%ymm7
  .byte  197,252,91,255                      // vcvtdq2ps     %ymm7,%ymm7
  .byte  196,193,68,89,248                   // vmulps        %ymm8,%ymm7,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  15,135,102,255,255,255              // ja            15962 <_sk_load_bgra_dst_avx+0x26>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,145,0,0,0                 // lea           0x91(%rip),%r10        # 15a98 <_sk_load_bgra_dst_avx+0x15c>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,122,16,12,152                 // vmovss        (%r8,%r11,4),%xmm9
  .byte  233,71,255,255,255                  // jmpq          15962 <_sk_load_bgra_dst_avx+0x26>
  .byte  196,129,121,110,100,152,8           // vmovd         0x8(%r8,%r11,4),%xmm4
  .byte  197,249,112,228,68                  // vpshufd       $0x44,%xmm4,%xmm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  196,99,85,12,204,4                  // vblendps      $0x4,%ymm4,%ymm5,%ymm9
  .byte  196,129,123,16,36,152               // vmovsd        (%r8,%r11,4),%xmm4
  .byte  196,99,53,13,204,1                  // vblendpd      $0x1,%ymm4,%ymm9,%ymm9
  .byte  233,32,255,255,255                  // jmpq          15962 <_sk_load_bgra_dst_avx+0x26>
  .byte  196,129,121,110,100,152,24          // vmovd         0x18(%r8,%r11,4),%xmm4
  .byte  197,249,112,228,68                  // vpshufd       $0x44,%xmm4,%xmm4
  .byte  196,227,125,24,228,1                // vinsertf128   $0x1,%xmm4,%ymm0,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  196,99,85,12,204,64                 // vblendps      $0x40,%ymm4,%ymm5,%ymm9
  .byte  196,99,125,25,204,1                 // vextractf128  $0x1,%ymm9,%xmm4
  .byte  196,131,89,34,100,152,20,1          // vpinsrd       $0x1,0x14(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,99,53,24,204,1                  // vinsertf128   $0x1,%xmm4,%ymm9,%ymm9
  .byte  196,99,125,25,204,1                 // vextractf128  $0x1,%ymm9,%xmm4
  .byte  196,131,89,34,100,152,16,0          // vpinsrd       $0x0,0x10(%r8,%r11,4),%xmm4,%xmm4
  .byte  196,99,53,24,204,1                  // vinsertf128   $0x1,%xmm4,%ymm9,%ymm9
  .byte  196,129,121,16,36,152               // vmovupd       (%r8,%r11,4),%xmm4
  .byte  196,67,93,13,201,12                 // vblendpd      $0xc,%ymm9,%ymm4,%ymm9
  .byte  233,203,254,255,255                 // jmpq          15962 <_sk_load_bgra_dst_avx+0x26>
  .byte  144                                 // nop
  .byte  120,255                             // js            15a99 <_sk_load_bgra_dst_avx+0x15d>
  .byte  255                                 // (bad)
  .byte  255,153,255,255,255,131             // lcall         *-0x7c000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  238                                 // out           %al,(%dx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  218,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,198                             // inc           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_bgra_avx
.globl _sk_gather_bgra_avx
FUNCTION(_sk_gather_bgra_avx)
_sk_gather_bgra_avx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,80,12                // vbroadcastss  0xc(%rax),%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  196,65,57,118,192                   // vpcmpeqd      %xmm8,%xmm8,%xmm8
  .byte  196,193,97,254,216                  // vpaddd        %xmm8,%xmm3,%xmm3
  .byte  196,193,105,254,208                 // vpaddd        %xmm8,%xmm2,%xmm2
  .byte  196,227,109,24,211,1                // vinsertf128   $0x1,%xmm3,%ymm2,%ymm2
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,180,95,192                      // vmaxps        %ymm0,%ymm9,%ymm0
  .byte  197,252,93,194                      // vminps        %ymm2,%ymm0,%ymm0
  .byte  196,226,125,24,80,16                // vbroadcastss  0x10(%rax),%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  196,193,97,254,216                  // vpaddd        %xmm8,%xmm3,%xmm3
  .byte  196,193,105,254,208                 // vpaddd        %xmm8,%xmm2,%xmm2
  .byte  196,227,109,24,211,1                // vinsertf128   $0x1,%xmm3,%ymm2,%ymm2
  .byte  197,180,95,201                      // vmaxps        %ymm1,%ymm9,%ymm1
  .byte  197,244,93,202                      // vminps        %ymm2,%ymm1,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  197,249,110,80,8                    // vmovd         0x8(%rax),%xmm2
  .byte  197,249,112,210,0                   // vpshufd       $0x0,%xmm2,%xmm2
  .byte  196,226,105,64,217                  // vpmulld       %xmm1,%xmm2,%xmm3
  .byte  196,227,125,25,201,1                // vextractf128  $0x1,%ymm1,%xmm1
  .byte  196,226,105,64,201                  // vpmulld       %xmm1,%xmm2,%xmm1
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  196,227,125,25,194,1                // vextractf128  $0x1,%ymm0,%xmm2
  .byte  197,241,254,202                     // vpaddd        %xmm2,%xmm1,%xmm1
  .byte  196,225,249,126,200                 // vmovq         %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  197,225,254,192                     // vpaddd        %xmm0,%xmm3,%xmm0
  .byte  196,193,249,126,194                 // vmovq         %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,249,22,203,1                // vpextrq       $0x1,%xmm1,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,195,249,22,199,1                // vpextrq       $0x1,%xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  196,129,121,110,4,152               // vmovd         (%r8,%r11,4),%xmm0
  .byte  196,131,121,34,4,144,1              // vpinsrd       $0x1,(%r8,%r10,4),%xmm0,%xmm0
  .byte  196,131,121,34,4,160,2              // vpinsrd       $0x2,(%r8,%r12,4),%xmm0,%xmm0
  .byte  196,3,121,34,4,184,3                // vpinsrd       $0x3,(%r8,%r15,4),%xmm0,%xmm8
  .byte  196,129,121,110,4,136               // vmovd         (%r8,%r9,4),%xmm0
  .byte  196,195,121,34,4,128,1              // vpinsrd       $0x1,(%r8,%rax,4),%xmm0,%xmm0
  .byte  196,131,121,34,4,176,2              // vpinsrd       $0x2,(%r8,%r14,4),%xmm0,%xmm0
  .byte  196,195,121,34,28,152,3             // vpinsrd       $0x3,(%r8,%rbx,4),%xmm0,%xmm3
  .byte  196,227,61,24,195,1                 // vinsertf128   $0x1,%xmm3,%ymm8,%ymm0
  .byte  197,124,40,13,168,76,2,0            // vmovaps       0x24ca8(%rip),%ymm9        # 3a860 <_sk_srcover_bgra_8888_sse2_lowp+0x8f8>
  .byte  196,193,124,84,193                  // vandps        %ymm9,%ymm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,21,198,70,2,0         // vbroadcastss  0x246c6(%rip),%ymm10        # 3a290 <_sk_srcover_bgra_8888_sse2_lowp+0x328>
  .byte  196,193,124,89,210                  // vmulps        %ymm10,%ymm0,%ymm2
  .byte  196,193,121,114,208,8               // vpsrld        $0x8,%xmm8,%xmm0
  .byte  197,241,114,211,8                   // vpsrld        $0x8,%xmm3,%xmm1
  .byte  196,227,125,24,193,1                // vinsertf128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,193,124,84,193                  // vandps        %ymm9,%ymm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,193,124,89,202                  // vmulps        %ymm10,%ymm0,%ymm1
  .byte  196,193,33,114,208,16               // vpsrld        $0x10,%xmm8,%xmm11
  .byte  197,249,114,211,16                  // vpsrld        $0x10,%xmm3,%xmm0
  .byte  196,227,37,24,192,1                 // vinsertf128   $0x1,%xmm0,%ymm11,%ymm0
  .byte  196,193,124,84,193                  // vandps        %ymm9,%ymm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,193,124,89,194                  // vmulps        %ymm10,%ymm0,%ymm0
  .byte  196,193,57,114,208,24               // vpsrld        $0x18,%xmm8,%xmm8
  .byte  197,225,114,211,24                  // vpsrld        $0x18,%xmm3,%xmm3
  .byte  196,227,61,24,219,1                 // vinsertf128   $0x1,%xmm3,%ymm8,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,218                  // vmulps        %ymm10,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_bgra_avx
.globl _sk_store_bgra_avx
FUNCTION(_sk_store_bgra_avx)
_sk_store_bgra_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,218                           // movslq        %edx,%r11
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,202                       // vmaxps        %ymm2,%ymm8,%ymm9
  .byte  196,98,125,24,21,189,69,2,0         // vbroadcastss  0x245bd(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,219,69,2,0         // vbroadcastss  0x245db(%rip),%ymm11        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,17,114,244,8                // vpslld        $0x8,%xmm12,%xmm13
  .byte  196,67,125,25,228,1                 // vextractf128  $0x1,%ymm12,%xmm12
  .byte  196,193,25,114,244,8                // vpslld        $0x8,%xmm12,%xmm12
  .byte  196,67,21,24,228,1                  // vinsertf128   $0x1,%xmm12,%ymm13,%ymm12
  .byte  196,65,29,86,201                    // vorpd         %ymm9,%ymm12,%ymm9
  .byte  197,60,95,224                       // vmaxps        %ymm0,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,193,17,114,244,16               // vpslld        $0x10,%xmm12,%xmm13
  .byte  196,67,125,25,228,1                 // vextractf128  $0x1,%ymm12,%xmm12
  .byte  196,193,25,114,244,16               // vpslld        $0x10,%xmm12,%xmm12
  .byte  196,67,21,24,228,1                  // vinsertf128   $0x1,%xmm12,%ymm13,%ymm12
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,193,41,114,240,24               // vpslld        $0x18,%xmm8,%xmm10
  .byte  196,67,125,25,192,1                 // vextractf128  $0x1,%ymm8,%xmm8
  .byte  196,193,57,114,240,24               // vpslld        $0x18,%xmm8,%xmm8
  .byte  196,67,45,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm10,%ymm8
  .byte  196,65,29,86,192                    // vorpd         %ymm8,%ymm12,%ymm8
  .byte  196,65,53,86,192                    // vorpd         %ymm8,%ymm9,%ymm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           15d12 <_sk_store_bgra_avx+0xe0>
  .byte  196,1,124,17,4,152                  // vmovups       %ymm8,(%r8,%r11,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,7                        // and           $0x7,%r9b
  .byte  65,254,201                          // dec           %r9b
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,236                             // ja            15d0e <_sk_store_bgra_avx+0xdc>
  .byte  69,15,182,201                       // movzbl        %r9b,%r9d
  .byte  76,141,21,83,0,0,0                  // lea           0x53(%rip),%r10        # 15d80 <_sk_store_bgra_avx+0x14e>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,1,121,126,4,152                 // vmovd         %xmm8,(%r8,%r11,4)
  .byte  235,208                             // jmp           15d0e <_sk_store_bgra_avx+0xdc>
  .byte  196,3,121,22,68,152,8,2             // vpextrd       $0x2,%xmm8,0x8(%r8,%r11,4)
  .byte  196,1,121,214,4,152                 // vmovq         %xmm8,(%r8,%r11,4)
  .byte  235,192                             // jmp           15d0e <_sk_store_bgra_avx+0xdc>
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,24,2            // vpextrd       $0x2,%xmm9,0x18(%r8,%r11,4)
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,3,121,22,76,152,20,1            // vpextrd       $0x1,%xmm9,0x14(%r8,%r11,4)
  .byte  196,67,125,25,193,1                 // vextractf128  $0x1,%ymm8,%xmm9
  .byte  196,1,122,17,76,152,16              // vmovss        %xmm9,0x10(%r8,%r11,4)
  .byte  196,1,121,17,4,152                  // vmovupd       %xmm8,(%r8,%r11,4)
  .byte  235,143                             // jmp           15d0e <_sk_store_bgra_avx+0xdc>
  .byte  144                                 // nop
  .byte  182,255                             // mov           $0xff,%dh
  .byte  255                                 // (bad)
  .byte  255,198                             // inc           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  190,255,255,255,247                 // mov           $0xf7ffffff,%esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  234                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  220,255                             // fdivr         %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,206                             // dec           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_f16_avx
.globl _sk_load_f16_avx
FUNCTION(_sk_load_f16_avx)
_sk_load_f16_avx:
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  197,252,17,124,36,224               // vmovups       %ymm7,-0x20(%rsp)
  .byte  197,252,17,116,36,192               // vmovups       %ymm6,-0x40(%rsp)
  .byte  197,252,17,108,36,160               // vmovups       %ymm5,-0x60(%rsp)
  .byte  197,252,17,100,36,128               // vmovups       %ymm4,-0x80(%rsp)
  .byte  15,133,31,2,0,0                     // jne           15ff7 <_sk_load_f16_avx+0x25b>
  .byte  196,65,121,16,4,192                 // vmovupd       (%r8,%rax,8),%xmm8
  .byte  196,193,121,16,84,192,16            // vmovupd       0x10(%r8,%rax,8),%xmm2
  .byte  196,193,121,16,92,192,32            // vmovupd       0x20(%r8,%rax,8),%xmm3
  .byte  196,65,122,111,76,192,48            // vmovdqu       0x30(%r8,%rax,8),%xmm9
  .byte  197,185,97,194                      // vpunpcklwd    %xmm2,%xmm8,%xmm0
  .byte  197,185,105,210                     // vpunpckhwd    %xmm2,%xmm8,%xmm2
  .byte  196,193,97,97,201                   // vpunpcklwd    %xmm9,%xmm3,%xmm1
  .byte  196,193,97,105,217                  // vpunpckhwd    %xmm9,%xmm3,%xmm3
  .byte  197,121,97,242                      // vpunpcklwd    %xmm2,%xmm0,%xmm14
  .byte  197,121,105,194                     // vpunpckhwd    %xmm2,%xmm0,%xmm8
  .byte  197,113,97,251                      // vpunpcklwd    %xmm3,%xmm1,%xmm15
  .byte  197,113,105,203                     // vpunpckhwd    %xmm3,%xmm1,%xmm9
  .byte  196,193,9,108,199                   // vpunpcklqdq   %xmm15,%xmm14,%xmm0
  .byte  196,226,121,51,200                  // vpmovzxwd     %xmm0,%xmm1
  .byte  197,249,112,192,78                  // vpshufd       $0x4e,%xmm0,%xmm0
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  197,123,18,21,87,85,2,0             // vmovddup      0x25557(%rip),%xmm10        # 3b388 <_sk_srcover_bgra_8888_sse2_lowp+0x1420>
  .byte  196,193,121,219,218                 // vpand         %xmm10,%xmm0,%xmm3
  .byte  196,98,121,24,29,97,69,2,0          // vbroadcastss  0x24561(%rip),%xmm11        # 3a3a0 <_sk_srcover_bgra_8888_sse2_lowp+0x438>
  .byte  197,33,102,227                      // vpcmpgtd      %xmm3,%xmm11,%xmm12
  .byte  196,193,113,219,210                 // vpand         %xmm10,%xmm1,%xmm2
  .byte  197,33,102,234                      // vpcmpgtd      %xmm2,%xmm11,%xmm13
  .byte  196,195,21,24,252,1                 // vinsertf128   $0x1,%xmm12,%ymm13,%ymm7
  .byte  197,123,18,37,54,85,2,0             // vmovddup      0x25536(%rip),%xmm12        # 3b390 <_sk_srcover_bgra_8888_sse2_lowp+0x1428>
  .byte  196,193,113,219,204                 // vpand         %xmm12,%xmm1,%xmm1
  .byte  197,241,114,241,16                  // vpslld        $0x10,%xmm1,%xmm1
  .byte  196,193,121,219,196                 // vpand         %xmm12,%xmm0,%xmm0
  .byte  197,249,114,240,16                  // vpslld        $0x10,%xmm0,%xmm0
  .byte  197,233,114,242,13                  // vpslld        $0xd,%xmm2,%xmm2
  .byte  197,241,235,202                     // vpor          %xmm2,%xmm1,%xmm1
  .byte  197,233,114,243,13                  // vpslld        $0xd,%xmm3,%xmm2
  .byte  197,249,235,194                     // vpor          %xmm2,%xmm0,%xmm0
  .byte  196,226,121,24,29,27,69,2,0         // vbroadcastss  0x2451b(%rip),%xmm3        # 3a3a4 <_sk_srcover_bgra_8888_sse2_lowp+0x43c>
  .byte  197,249,254,195                     // vpaddd        %xmm3,%xmm0,%xmm0
  .byte  197,241,254,203                     // vpaddd        %xmm3,%xmm1,%xmm1
  .byte  196,227,117,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,227,125,74,196,112              // vblendvps     %ymm7,%ymm4,%ymm0,%ymm0
  .byte  196,193,9,109,207                   // vpunpckhqdq   %xmm15,%xmm14,%xmm1
  .byte  196,226,121,51,209                  // vpmovzxwd     %xmm1,%xmm2
  .byte  197,249,112,201,78                  // vpshufd       $0x4e,%xmm1,%xmm1
  .byte  196,98,121,51,249                   // vpmovzxwd     %xmm1,%xmm15
  .byte  196,193,1,219,250                   // vpand         %xmm10,%xmm15,%xmm7
  .byte  197,33,102,247                      // vpcmpgtd      %xmm7,%xmm11,%xmm14
  .byte  196,193,105,219,202                 // vpand         %xmm10,%xmm2,%xmm1
  .byte  197,33,102,233                      // vpcmpgtd      %xmm1,%xmm11,%xmm13
  .byte  196,67,21,24,238,1                  // vinsertf128   $0x1,%xmm14,%ymm13,%ymm13
  .byte  196,193,105,219,212                 // vpand         %xmm12,%xmm2,%xmm2
  .byte  197,233,114,242,16                  // vpslld        $0x10,%xmm2,%xmm2
  .byte  197,241,114,241,13                  // vpslld        $0xd,%xmm1,%xmm1
  .byte  197,233,235,201                     // vpor          %xmm1,%xmm2,%xmm1
  .byte  196,193,1,219,212                   // vpand         %xmm12,%xmm15,%xmm2
  .byte  197,233,114,242,16                  // vpslld        $0x10,%xmm2,%xmm2
  .byte  197,193,114,247,13                  // vpslld        $0xd,%xmm7,%xmm7
  .byte  197,233,235,215                     // vpor          %xmm7,%xmm2,%xmm2
  .byte  197,233,254,211                     // vpaddd        %xmm3,%xmm2,%xmm2
  .byte  197,241,254,203                     // vpaddd        %xmm3,%xmm1,%xmm1
  .byte  196,227,117,24,202,1                // vinsertf128   $0x1,%xmm2,%ymm1,%ymm1
  .byte  196,227,117,74,204,208              // vblendvps     %ymm13,%ymm4,%ymm1,%ymm1
  .byte  196,193,57,108,209                  // vpunpcklqdq   %xmm9,%xmm8,%xmm2
  .byte  196,226,121,51,250                  // vpmovzxwd     %xmm2,%xmm7
  .byte  197,249,112,210,78                  // vpshufd       $0x4e,%xmm2,%xmm2
  .byte  196,98,121,51,234                   // vpmovzxwd     %xmm2,%xmm13
  .byte  196,65,17,219,250                   // vpand         %xmm10,%xmm13,%xmm15
  .byte  196,65,33,102,247                   // vpcmpgtd      %xmm15,%xmm11,%xmm14
  .byte  196,193,65,219,210                  // vpand         %xmm10,%xmm7,%xmm2
  .byte  197,161,102,242                     // vpcmpgtd      %xmm2,%xmm11,%xmm6
  .byte  196,195,77,24,246,1                 // vinsertf128   $0x1,%xmm14,%ymm6,%ymm6
  .byte  196,193,65,219,252                  // vpand         %xmm12,%xmm7,%xmm7
  .byte  197,193,114,247,16                  // vpslld        $0x10,%xmm7,%xmm7
  .byte  197,233,114,242,13                  // vpslld        $0xd,%xmm2,%xmm2
  .byte  197,193,235,210                     // vpor          %xmm2,%xmm7,%xmm2
  .byte  196,193,17,219,252                  // vpand         %xmm12,%xmm13,%xmm7
  .byte  197,193,114,247,16                  // vpslld        $0x10,%xmm7,%xmm7
  .byte  196,193,81,114,247,13               // vpslld        $0xd,%xmm15,%xmm5
  .byte  197,193,235,237                     // vpor          %xmm5,%xmm7,%xmm5
  .byte  197,209,254,235                     // vpaddd        %xmm3,%xmm5,%xmm5
  .byte  197,233,254,211                     // vpaddd        %xmm3,%xmm2,%xmm2
  .byte  196,227,109,24,213,1                // vinsertf128   $0x1,%xmm5,%ymm2,%ymm2
  .byte  196,227,109,74,212,96               // vblendvps     %ymm6,%ymm4,%ymm2,%ymm2
  .byte  196,193,57,109,233                  // vpunpckhqdq   %xmm9,%xmm8,%xmm5
  .byte  196,226,121,51,245                  // vpmovzxwd     %xmm5,%xmm6
  .byte  197,249,112,237,78                  // vpshufd       $0x4e,%xmm5,%xmm5
  .byte  196,226,121,51,237                  // vpmovzxwd     %xmm5,%xmm5
  .byte  196,65,81,219,202                   // vpand         %xmm10,%xmm5,%xmm9
  .byte  196,65,33,102,193                   // vpcmpgtd      %xmm9,%xmm11,%xmm8
  .byte  196,193,73,219,250                  // vpand         %xmm10,%xmm6,%xmm7
  .byte  197,33,102,215                      // vpcmpgtd      %xmm7,%xmm11,%xmm10
  .byte  196,67,45,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm10,%ymm8
  .byte  196,193,73,219,244                  // vpand         %xmm12,%xmm6,%xmm6
  .byte  196,193,81,219,236                  // vpand         %xmm12,%xmm5,%xmm5
  .byte  197,201,114,246,16                  // vpslld        $0x10,%xmm6,%xmm6
  .byte  197,193,114,247,13                  // vpslld        $0xd,%xmm7,%xmm7
  .byte  197,201,235,247                     // vpor          %xmm7,%xmm6,%xmm6
  .byte  197,209,114,245,16                  // vpslld        $0x10,%xmm5,%xmm5
  .byte  196,193,65,114,241,13               // vpslld        $0xd,%xmm9,%xmm7
  .byte  197,209,235,239                     // vpor          %xmm7,%xmm5,%xmm5
  .byte  197,209,254,235                     // vpaddd        %xmm3,%xmm5,%xmm5
  .byte  197,201,254,219                     // vpaddd        %xmm3,%xmm6,%xmm3
  .byte  196,227,101,24,221,1                // vinsertf128   $0x1,%xmm5,%ymm3,%ymm3
  .byte  196,227,101,74,220,128              // vblendvps     %ymm8,%ymm4,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,100,36,128               // vmovups       -0x80(%rsp),%ymm4
  .byte  197,252,16,108,36,160               // vmovups       -0x60(%rsp),%ymm5
  .byte  197,252,16,116,36,192               // vmovups       -0x40(%rsp),%ymm6
  .byte  197,252,16,124,36,224               // vmovups       -0x20(%rsp),%ymm7
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,123,16,4,192                 // vmovsd        (%r8,%rax,8),%xmm8
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,85                              // je            1605d <_sk_load_f16_avx+0x2c1>
  .byte  196,65,57,22,68,192,8               // vmovhpd       0x8(%r8,%rax,8),%xmm8,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,72                              // jb            1605d <_sk_load_f16_avx+0x2c1>
  .byte  196,193,123,16,84,192,16            // vmovsd        0x10(%r8,%rax,8),%xmm2
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  116,72                              // je            1606a <_sk_load_f16_avx+0x2ce>
  .byte  196,193,105,22,84,192,24            // vmovhpd       0x18(%r8,%rax,8),%xmm2,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,59                              // jb            1606a <_sk_load_f16_avx+0x2ce>
  .byte  196,193,123,16,92,192,32            // vmovsd        0x20(%r8,%rax,8),%xmm3
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  15,132,179,253,255,255              // je            15df3 <_sk_load_f16_avx+0x57>
  .byte  196,193,97,22,92,192,40             // vmovhpd       0x28(%r8,%rax,8),%xmm3,%xmm3
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,130,162,253,255,255              // jb            15df3 <_sk_load_f16_avx+0x57>
  .byte  196,65,122,126,76,192,48            // vmovq         0x30(%r8,%rax,8),%xmm9
  .byte  233,150,253,255,255                 // jmpq          15df3 <_sk_load_f16_avx+0x57>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  197,233,87,210                      // vxorpd        %xmm2,%xmm2,%xmm2
  .byte  233,137,253,255,255                 // jmpq          15df3 <_sk_load_f16_avx+0x57>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  233,128,253,255,255                 // jmpq          15df3 <_sk_load_f16_avx+0x57>

HIDDEN _sk_load_f16_dst_avx
.globl _sk_load_f16_dst_avx
FUNCTION(_sk_load_f16_dst_avx)
_sk_load_f16_dst_avx:
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  197,252,17,92,36,224                // vmovups       %ymm3,-0x20(%rsp)
  .byte  197,252,17,84,36,192                // vmovups       %ymm2,-0x40(%rsp)
  .byte  197,252,17,76,36,160                // vmovups       %ymm1,-0x60(%rsp)
  .byte  197,252,17,68,36,128                // vmovups       %ymm0,-0x80(%rsp)
  .byte  15,133,31,2,0,0                     // jne           162ce <_sk_load_f16_dst_avx+0x25b>
  .byte  196,65,121,16,4,192                 // vmovupd       (%r8,%rax,8),%xmm8
  .byte  196,193,121,16,116,192,16           // vmovupd       0x10(%r8,%rax,8),%xmm6
  .byte  196,193,121,16,124,192,32           // vmovupd       0x20(%r8,%rax,8),%xmm7
  .byte  196,65,122,111,76,192,48            // vmovdqu       0x30(%r8,%rax,8),%xmm9
  .byte  197,185,97,230                      // vpunpcklwd    %xmm6,%xmm8,%xmm4
  .byte  197,185,105,246                     // vpunpckhwd    %xmm6,%xmm8,%xmm6
  .byte  196,193,65,97,233                   // vpunpcklwd    %xmm9,%xmm7,%xmm5
  .byte  196,193,65,105,249                  // vpunpckhwd    %xmm9,%xmm7,%xmm7
  .byte  197,89,97,246                       // vpunpcklwd    %xmm6,%xmm4,%xmm14
  .byte  197,89,105,198                      // vpunpckhwd    %xmm6,%xmm4,%xmm8
  .byte  197,81,97,255                       // vpunpcklwd    %xmm7,%xmm5,%xmm15
  .byte  197,81,105,207                      // vpunpckhwd    %xmm7,%xmm5,%xmm9
  .byte  196,193,9,108,231                   // vpunpcklqdq   %xmm15,%xmm14,%xmm4
  .byte  196,226,121,51,236                  // vpmovzxwd     %xmm4,%xmm5
  .byte  197,249,112,228,78                  // vpshufd       $0x4e,%xmm4,%xmm4
  .byte  196,226,121,51,228                  // vpmovzxwd     %xmm4,%xmm4
  .byte  197,123,18,21,128,82,2,0            // vmovddup      0x25280(%rip),%xmm10        # 3b388 <_sk_srcover_bgra_8888_sse2_lowp+0x1420>
  .byte  196,193,89,219,250                  // vpand         %xmm10,%xmm4,%xmm7
  .byte  196,98,121,24,29,138,66,2,0         // vbroadcastss  0x2428a(%rip),%xmm11        # 3a3a0 <_sk_srcover_bgra_8888_sse2_lowp+0x438>
  .byte  197,33,102,231                      // vpcmpgtd      %xmm7,%xmm11,%xmm12
  .byte  196,193,81,219,242                  // vpand         %xmm10,%xmm5,%xmm6
  .byte  197,33,102,238                      // vpcmpgtd      %xmm6,%xmm11,%xmm13
  .byte  196,195,21,24,220,1                 // vinsertf128   $0x1,%xmm12,%ymm13,%ymm3
  .byte  197,123,18,37,95,82,2,0             // vmovddup      0x2525f(%rip),%xmm12        # 3b390 <_sk_srcover_bgra_8888_sse2_lowp+0x1428>
  .byte  196,193,81,219,236                  // vpand         %xmm12,%xmm5,%xmm5
  .byte  197,209,114,245,16                  // vpslld        $0x10,%xmm5,%xmm5
  .byte  196,193,89,219,228                  // vpand         %xmm12,%xmm4,%xmm4
  .byte  197,217,114,244,16                  // vpslld        $0x10,%xmm4,%xmm4
  .byte  197,201,114,246,13                  // vpslld        $0xd,%xmm6,%xmm6
  .byte  197,209,235,238                     // vpor          %xmm6,%xmm5,%xmm5
  .byte  197,201,114,247,13                  // vpslld        $0xd,%xmm7,%xmm6
  .byte  197,217,235,230                     // vpor          %xmm6,%xmm4,%xmm4
  .byte  196,226,121,24,61,68,66,2,0         // vbroadcastss  0x24244(%rip),%xmm7        # 3a3a4 <_sk_srcover_bgra_8888_sse2_lowp+0x43c>
  .byte  197,217,254,231                     // vpaddd        %xmm7,%xmm4,%xmm4
  .byte  197,209,254,239                     // vpaddd        %xmm7,%xmm5,%xmm5
  .byte  196,227,85,24,228,1                 // vinsertf128   $0x1,%xmm4,%ymm5,%ymm4
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  196,227,93,74,224,48                // vblendvps     %ymm3,%ymm0,%ymm4,%ymm4
  .byte  196,193,9,109,223                   // vpunpckhqdq   %xmm15,%xmm14,%xmm3
  .byte  196,226,121,51,235                  // vpmovzxwd     %xmm3,%xmm5
  .byte  197,249,112,219,78                  // vpshufd       $0x4e,%xmm3,%xmm3
  .byte  196,98,121,51,251                   // vpmovzxwd     %xmm3,%xmm15
  .byte  196,193,1,219,242                   // vpand         %xmm10,%xmm15,%xmm6
  .byte  197,33,102,246                      // vpcmpgtd      %xmm6,%xmm11,%xmm14
  .byte  196,193,81,219,218                  // vpand         %xmm10,%xmm5,%xmm3
  .byte  197,33,102,235                      // vpcmpgtd      %xmm3,%xmm11,%xmm13
  .byte  196,67,21,24,238,1                  // vinsertf128   $0x1,%xmm14,%ymm13,%ymm13
  .byte  196,193,81,219,236                  // vpand         %xmm12,%xmm5,%xmm5
  .byte  197,209,114,245,16                  // vpslld        $0x10,%xmm5,%xmm5
  .byte  197,225,114,243,13                  // vpslld        $0xd,%xmm3,%xmm3
  .byte  197,209,235,219                     // vpor          %xmm3,%xmm5,%xmm3
  .byte  196,193,1,219,236                   // vpand         %xmm12,%xmm15,%xmm5
  .byte  197,209,114,245,16                  // vpslld        $0x10,%xmm5,%xmm5
  .byte  197,201,114,246,13                  // vpslld        $0xd,%xmm6,%xmm6
  .byte  197,209,235,238                     // vpor          %xmm6,%xmm5,%xmm5
  .byte  197,209,254,239                     // vpaddd        %xmm7,%xmm5,%xmm5
  .byte  197,225,254,223                     // vpaddd        %xmm7,%xmm3,%xmm3
  .byte  196,227,101,24,221,1                // vinsertf128   $0x1,%xmm5,%ymm3,%ymm3
  .byte  196,227,101,74,232,208              // vblendvps     %ymm13,%ymm0,%ymm3,%ymm5
  .byte  196,193,57,108,217                  // vpunpcklqdq   %xmm9,%xmm8,%xmm3
  .byte  196,226,121,51,243                  // vpmovzxwd     %xmm3,%xmm6
  .byte  197,249,112,219,78                  // vpshufd       $0x4e,%xmm3,%xmm3
  .byte  196,98,121,51,235                   // vpmovzxwd     %xmm3,%xmm13
  .byte  196,65,17,219,250                   // vpand         %xmm10,%xmm13,%xmm15
  .byte  196,65,33,102,247                   // vpcmpgtd      %xmm15,%xmm11,%xmm14
  .byte  196,193,73,219,218                  // vpand         %xmm10,%xmm6,%xmm3
  .byte  197,161,102,211                     // vpcmpgtd      %xmm3,%xmm11,%xmm2
  .byte  196,195,109,24,214,1                // vinsertf128   $0x1,%xmm14,%ymm2,%ymm2
  .byte  196,193,73,219,244                  // vpand         %xmm12,%xmm6,%xmm6
  .byte  197,201,114,246,16                  // vpslld        $0x10,%xmm6,%xmm6
  .byte  197,225,114,243,13                  // vpslld        $0xd,%xmm3,%xmm3
  .byte  197,201,235,219                     // vpor          %xmm3,%xmm6,%xmm3
  .byte  196,193,17,219,244                  // vpand         %xmm12,%xmm13,%xmm6
  .byte  197,201,114,246,16                  // vpslld        $0x10,%xmm6,%xmm6
  .byte  196,193,113,114,247,13              // vpslld        $0xd,%xmm15,%xmm1
  .byte  197,201,235,201                     // vpor          %xmm1,%xmm6,%xmm1
  .byte  197,241,254,207                     // vpaddd        %xmm7,%xmm1,%xmm1
  .byte  197,225,254,223                     // vpaddd        %xmm7,%xmm3,%xmm3
  .byte  196,227,101,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm3,%ymm1
  .byte  196,227,117,74,240,32               // vblendvps     %ymm2,%ymm0,%ymm1,%ymm6
  .byte  196,193,57,109,201                  // vpunpckhqdq   %xmm9,%xmm8,%xmm1
  .byte  196,226,121,51,209                  // vpmovzxwd     %xmm1,%xmm2
  .byte  197,249,112,201,78                  // vpshufd       $0x4e,%xmm1,%xmm1
  .byte  196,226,121,51,201                  // vpmovzxwd     %xmm1,%xmm1
  .byte  196,65,113,219,202                  // vpand         %xmm10,%xmm1,%xmm9
  .byte  196,65,33,102,193                   // vpcmpgtd      %xmm9,%xmm11,%xmm8
  .byte  196,193,105,219,218                 // vpand         %xmm10,%xmm2,%xmm3
  .byte  197,33,102,211                      // vpcmpgtd      %xmm3,%xmm11,%xmm10
  .byte  196,67,45,24,192,1                  // vinsertf128   $0x1,%xmm8,%ymm10,%ymm8
  .byte  196,193,105,219,212                 // vpand         %xmm12,%xmm2,%xmm2
  .byte  196,193,113,219,204                 // vpand         %xmm12,%xmm1,%xmm1
  .byte  197,233,114,242,16                  // vpslld        $0x10,%xmm2,%xmm2
  .byte  197,225,114,243,13                  // vpslld        $0xd,%xmm3,%xmm3
  .byte  197,233,235,211                     // vpor          %xmm3,%xmm2,%xmm2
  .byte  197,241,114,241,16                  // vpslld        $0x10,%xmm1,%xmm1
  .byte  196,193,97,114,241,13               // vpslld        $0xd,%xmm9,%xmm3
  .byte  197,241,235,203                     // vpor          %xmm3,%xmm1,%xmm1
  .byte  197,241,254,207                     // vpaddd        %xmm7,%xmm1,%xmm1
  .byte  197,233,254,215                     // vpaddd        %xmm7,%xmm2,%xmm2
  .byte  196,227,109,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm2,%ymm1
  .byte  196,227,117,74,248,128              // vblendvps     %ymm8,%ymm0,%ymm1,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,68,36,128                // vmovups       -0x80(%rsp),%ymm0
  .byte  197,252,16,76,36,160                // vmovups       -0x60(%rsp),%ymm1
  .byte  197,252,16,84,36,192                // vmovups       -0x40(%rsp),%ymm2
  .byte  197,252,16,92,36,224                // vmovups       -0x20(%rsp),%ymm3
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,123,16,4,192                 // vmovsd        (%r8,%rax,8),%xmm8
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,85                              // je            16334 <_sk_load_f16_dst_avx+0x2c1>
  .byte  196,65,57,22,68,192,8               // vmovhpd       0x8(%r8,%rax,8),%xmm8,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,72                              // jb            16334 <_sk_load_f16_dst_avx+0x2c1>
  .byte  196,193,123,16,116,192,16           // vmovsd        0x10(%r8,%rax,8),%xmm6
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  116,72                              // je            16341 <_sk_load_f16_dst_avx+0x2ce>
  .byte  196,193,73,22,116,192,24            // vmovhpd       0x18(%r8,%rax,8),%xmm6,%xmm6
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,59                              // jb            16341 <_sk_load_f16_dst_avx+0x2ce>
  .byte  196,193,123,16,124,192,32           // vmovsd        0x20(%r8,%rax,8),%xmm7
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  15,132,179,253,255,255              // je            160ca <_sk_load_f16_dst_avx+0x57>
  .byte  196,193,65,22,124,192,40            // vmovhpd       0x28(%r8,%rax,8),%xmm7,%xmm7
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,130,162,253,255,255              // jb            160ca <_sk_load_f16_dst_avx+0x57>
  .byte  196,65,122,126,76,192,48            // vmovq         0x30(%r8,%rax,8),%xmm9
  .byte  233,150,253,255,255                 // jmpq          160ca <_sk_load_f16_dst_avx+0x57>
  .byte  197,193,87,255                      // vxorpd        %xmm7,%xmm7,%xmm7
  .byte  197,201,87,246                      // vxorpd        %xmm6,%xmm6,%xmm6
  .byte  233,137,253,255,255                 // jmpq          160ca <_sk_load_f16_dst_avx+0x57>
  .byte  197,193,87,255                      // vxorpd        %xmm7,%xmm7,%xmm7
  .byte  233,128,253,255,255                 // jmpq          160ca <_sk_load_f16_dst_avx+0x57>

HIDDEN _sk_gather_f16_avx
.globl _sk_gather_f16_avx
FUNCTION(_sk_gather_f16_avx)
_sk_gather_f16_avx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  197,252,17,124,36,224               // vmovups       %ymm7,-0x20(%rsp)
  .byte  197,252,17,116,36,192               // vmovups       %ymm6,-0x40(%rsp)
  .byte  197,252,17,108,36,160               // vmovups       %ymm5,-0x60(%rsp)
  .byte  197,252,17,100,36,128               // vmovups       %ymm4,-0x80(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,80,12                // vbroadcastss  0xc(%rax),%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  196,65,49,118,201                   // vpcmpeqd      %xmm9,%xmm9,%xmm9
  .byte  196,193,97,254,217                  // vpaddd        %xmm9,%xmm3,%xmm3
  .byte  196,193,105,254,209                 // vpaddd        %xmm9,%xmm2,%xmm2
  .byte  196,227,109,24,211,1                // vinsertf128   $0x1,%xmm3,%ymm2,%ymm2
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,220,95,192                      // vmaxps        %ymm0,%ymm4,%ymm0
  .byte  197,252,93,210                      // vminps        %ymm2,%ymm0,%ymm2
  .byte  196,226,125,24,64,16                // vbroadcastss  0x10(%rax),%ymm0
  .byte  196,227,125,25,195,1                // vextractf128  $0x1,%ymm0,%xmm3
  .byte  196,193,97,254,217                  // vpaddd        %xmm9,%xmm3,%xmm3
  .byte  196,193,121,254,193                 // vpaddd        %xmm9,%xmm0,%xmm0
  .byte  196,227,125,24,195,1                // vinsertf128   $0x1,%xmm3,%ymm0,%ymm0
  .byte  197,220,95,201                      // vmaxps        %ymm1,%ymm4,%ymm1
  .byte  197,244,93,192                      // vminps        %ymm0,%ymm1,%ymm0
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,200                      // vcvttps2dq    %ymm0,%ymm1
  .byte  197,249,110,64,8                    // vmovd         0x8(%rax),%xmm0
  .byte  197,249,112,216,0                   // vpshufd       $0x0,%xmm0,%xmm3
  .byte  196,226,97,64,193                   // vpmulld       %xmm1,%xmm3,%xmm0
  .byte  196,227,125,25,201,1                // vextractf128  $0x1,%ymm1,%xmm1
  .byte  196,226,97,64,201                   // vpmulld       %xmm1,%xmm3,%xmm1
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,227,125,25,211,1                // vextractf128  $0x1,%ymm2,%xmm3
  .byte  197,241,254,203                     // vpaddd        %xmm3,%xmm1,%xmm1
  .byte  196,227,249,22,200,1                // vpextrq       $0x1,%xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  196,193,249,126,202                 // vmovq         %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  197,249,254,194                     // vpaddd        %xmm2,%xmm0,%xmm0
  .byte  196,227,249,22,195,1                // vpextrq       $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  196,193,249,126,199                 // vmovq         %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  196,129,122,126,4,248               // vmovq         (%r8,%r15,8),%xmm0
  .byte  196,129,122,126,12,224              // vmovq         (%r8,%r12,8),%xmm1
  .byte  197,113,108,208                     // vpunpcklqdq   %xmm0,%xmm1,%xmm10
  .byte  196,193,122,126,12,216              // vmovq         (%r8,%rbx,8),%xmm1
  .byte  196,129,122,126,20,240              // vmovq         (%r8,%r14,8),%xmm2
  .byte  197,233,108,201                     // vpunpcklqdq   %xmm1,%xmm2,%xmm1
  .byte  196,129,122,126,20,208              // vmovq         (%r8,%r10,8),%xmm2
  .byte  196,129,122,126,28,216              // vmovq         (%r8,%r11,8),%xmm3
  .byte  197,225,108,210                     // vpunpcklqdq   %xmm2,%xmm3,%xmm2
  .byte  196,65,122,126,12,192               // vmovq         (%r8,%rax,8),%xmm9
  .byte  196,129,122,126,28,200              // vmovq         (%r8,%r9,8),%xmm3
  .byte  196,193,97,108,217                  // vpunpcklqdq   %xmm9,%xmm3,%xmm3
  .byte  197,169,97,193                      // vpunpcklwd    %xmm1,%xmm10,%xmm0
  .byte  197,169,105,201                     // vpunpckhwd    %xmm1,%xmm10,%xmm1
  .byte  197,105,97,211                      // vpunpcklwd    %xmm3,%xmm2,%xmm10
  .byte  197,233,105,211                     // vpunpckhwd    %xmm3,%xmm2,%xmm2
  .byte  197,121,97,241                      // vpunpcklwd    %xmm1,%xmm0,%xmm14
  .byte  197,121,105,201                     // vpunpckhwd    %xmm1,%xmm0,%xmm9
  .byte  197,41,97,250                       // vpunpcklwd    %xmm2,%xmm10,%xmm15
  .byte  197,41,105,210                      // vpunpckhwd    %xmm2,%xmm10,%xmm10
  .byte  196,193,9,108,199                   // vpunpcklqdq   %xmm15,%xmm14,%xmm0
  .byte  196,226,121,51,208                  // vpmovzxwd     %xmm0,%xmm2
  .byte  197,249,112,192,78                  // vpshufd       $0x4e,%xmm0,%xmm0
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  197,123,18,29,230,78,2,0            // vmovddup      0x24ee6(%rip),%xmm11        # 3b388 <_sk_srcover_bgra_8888_sse2_lowp+0x1420>
  .byte  196,193,121,219,219                 // vpand         %xmm11,%xmm0,%xmm3
  .byte  196,98,121,24,37,240,62,2,0         // vbroadcastss  0x23ef0(%rip),%xmm12        # 3a3a0 <_sk_srcover_bgra_8888_sse2_lowp+0x438>
  .byte  197,25,102,235                      // vpcmpgtd      %xmm3,%xmm12,%xmm13
  .byte  196,193,105,219,203                 // vpand         %xmm11,%xmm2,%xmm1
  .byte  197,25,102,193                      // vpcmpgtd      %xmm1,%xmm12,%xmm8
  .byte  196,67,61,24,197,1                  // vinsertf128   $0x1,%xmm13,%ymm8,%ymm8
  .byte  197,123,18,45,197,78,2,0            // vmovddup      0x24ec5(%rip),%xmm13        # 3b390 <_sk_srcover_bgra_8888_sse2_lowp+0x1428>
  .byte  196,193,105,219,213                 // vpand         %xmm13,%xmm2,%xmm2
  .byte  197,233,114,242,16                  // vpslld        $0x10,%xmm2,%xmm2
  .byte  197,241,114,241,13                  // vpslld        $0xd,%xmm1,%xmm1
  .byte  197,233,235,201                     // vpor          %xmm1,%xmm2,%xmm1
  .byte  196,193,121,219,197                 // vpand         %xmm13,%xmm0,%xmm0
  .byte  197,249,114,240,16                  // vpslld        $0x10,%xmm0,%xmm0
  .byte  197,233,114,243,13                  // vpslld        $0xd,%xmm3,%xmm2
  .byte  197,249,235,194                     // vpor          %xmm2,%xmm0,%xmm0
  .byte  196,226,121,24,29,170,62,2,0        // vbroadcastss  0x23eaa(%rip),%xmm3        # 3a3a4 <_sk_srcover_bgra_8888_sse2_lowp+0x43c>
  .byte  197,249,254,195                     // vpaddd        %xmm3,%xmm0,%xmm0
  .byte  197,241,254,203                     // vpaddd        %xmm3,%xmm1,%xmm1
  .byte  196,227,117,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  196,227,125,74,196,128              // vblendvps     %ymm8,%ymm4,%ymm0,%ymm0
  .byte  196,193,9,109,207                   // vpunpckhqdq   %xmm15,%xmm14,%xmm1
  .byte  196,226,121,51,209                  // vpmovzxwd     %xmm1,%xmm2
  .byte  197,249,112,201,78                  // vpshufd       $0x4e,%xmm1,%xmm1
  .byte  196,98,121,51,193                   // vpmovzxwd     %xmm1,%xmm8
  .byte  196,65,57,219,251                   // vpand         %xmm11,%xmm8,%xmm15
  .byte  196,65,25,102,247                   // vpcmpgtd      %xmm15,%xmm12,%xmm14
  .byte  196,193,105,219,203                 // vpand         %xmm11,%xmm2,%xmm1
  .byte  197,153,102,249                     // vpcmpgtd      %xmm1,%xmm12,%xmm7
  .byte  196,195,69,24,254,1                 // vinsertf128   $0x1,%xmm14,%ymm7,%ymm7
  .byte  196,193,105,219,213                 // vpand         %xmm13,%xmm2,%xmm2
  .byte  197,233,114,242,16                  // vpslld        $0x10,%xmm2,%xmm2
  .byte  197,241,114,241,13                  // vpslld        $0xd,%xmm1,%xmm1
  .byte  197,233,235,201                     // vpor          %xmm1,%xmm2,%xmm1
  .byte  196,193,57,219,213                  // vpand         %xmm13,%xmm8,%xmm2
  .byte  197,233,114,242,16                  // vpslld        $0x10,%xmm2,%xmm2
  .byte  196,193,73,114,247,13               // vpslld        $0xd,%xmm15,%xmm6
  .byte  197,233,235,214                     // vpor          %xmm6,%xmm2,%xmm2
  .byte  197,233,254,211                     // vpaddd        %xmm3,%xmm2,%xmm2
  .byte  197,241,254,203                     // vpaddd        %xmm3,%xmm1,%xmm1
  .byte  196,227,117,24,202,1                // vinsertf128   $0x1,%xmm2,%ymm1,%ymm1
  .byte  196,227,117,74,204,112              // vblendvps     %ymm7,%ymm4,%ymm1,%ymm1
  .byte  196,193,49,108,210                  // vpunpcklqdq   %xmm10,%xmm9,%xmm2
  .byte  196,226,121,51,242                  // vpmovzxwd     %xmm2,%xmm6
  .byte  197,249,112,210,78                  // vpshufd       $0x4e,%xmm2,%xmm2
  .byte  196,98,121,51,242                   // vpmovzxwd     %xmm2,%xmm14
  .byte  196,193,9,219,251                   // vpand         %xmm11,%xmm14,%xmm7
  .byte  197,25,102,199                      // vpcmpgtd      %xmm7,%xmm12,%xmm8
  .byte  196,193,73,219,211                  // vpand         %xmm11,%xmm6,%xmm2
  .byte  197,25,102,250                      // vpcmpgtd      %xmm2,%xmm12,%xmm15
  .byte  196,67,5,24,192,1                   // vinsertf128   $0x1,%xmm8,%ymm15,%ymm8
  .byte  196,193,73,219,245                  // vpand         %xmm13,%xmm6,%xmm6
  .byte  197,201,114,246,16                  // vpslld        $0x10,%xmm6,%xmm6
  .byte  197,233,114,242,13                  // vpslld        $0xd,%xmm2,%xmm2
  .byte  197,201,235,210                     // vpor          %xmm2,%xmm6,%xmm2
  .byte  196,193,9,219,245                   // vpand         %xmm13,%xmm14,%xmm6
  .byte  197,201,114,246,16                  // vpslld        $0x10,%xmm6,%xmm6
  .byte  197,193,114,247,13                  // vpslld        $0xd,%xmm7,%xmm7
  .byte  197,201,235,247                     // vpor          %xmm7,%xmm6,%xmm6
  .byte  197,201,254,243                     // vpaddd        %xmm3,%xmm6,%xmm6
  .byte  197,233,254,211                     // vpaddd        %xmm3,%xmm2,%xmm2
  .byte  196,227,109,24,214,1                // vinsertf128   $0x1,%xmm6,%ymm2,%ymm2
  .byte  196,227,109,74,212,128              // vblendvps     %ymm8,%ymm4,%ymm2,%ymm2
  .byte  196,193,49,109,242                  // vpunpckhqdq   %xmm10,%xmm9,%xmm6
  .byte  196,226,121,51,254                  // vpmovzxwd     %xmm6,%xmm7
  .byte  197,249,112,246,78                  // vpshufd       $0x4e,%xmm6,%xmm6
  .byte  196,98,121,51,214                   // vpmovzxwd     %xmm6,%xmm10
  .byte  196,65,41,219,195                   // vpand         %xmm11,%xmm10,%xmm8
  .byte  196,65,25,102,200                   // vpcmpgtd      %xmm8,%xmm12,%xmm9
  .byte  196,193,65,219,243                  // vpand         %xmm11,%xmm7,%xmm6
  .byte  197,25,102,222                      // vpcmpgtd      %xmm6,%xmm12,%xmm11
  .byte  196,67,37,24,201,1                  // vinsertf128   $0x1,%xmm9,%ymm11,%ymm9
  .byte  196,193,65,219,253                  // vpand         %xmm13,%xmm7,%xmm7
  .byte  196,65,41,219,213                   // vpand         %xmm13,%xmm10,%xmm10
  .byte  197,193,114,247,16                  // vpslld        $0x10,%xmm7,%xmm7
  .byte  197,201,114,246,13                  // vpslld        $0xd,%xmm6,%xmm6
  .byte  197,193,235,246                     // vpor          %xmm6,%xmm7,%xmm6
  .byte  196,193,65,114,242,16               // vpslld        $0x10,%xmm10,%xmm7
  .byte  196,193,81,114,240,13               // vpslld        $0xd,%xmm8,%xmm5
  .byte  197,193,235,237                     // vpor          %xmm5,%xmm7,%xmm5
  .byte  197,209,254,235                     // vpaddd        %xmm3,%xmm5,%xmm5
  .byte  197,201,254,219                     // vpaddd        %xmm3,%xmm6,%xmm3
  .byte  196,227,101,24,221,1                // vinsertf128   $0x1,%xmm5,%ymm3,%ymm3
  .byte  196,227,101,74,220,144              // vblendvps     %ymm9,%ymm4,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,100,36,128               // vmovups       -0x80(%rsp),%ymm4
  .byte  197,252,16,108,36,160               // vmovups       -0x60(%rsp),%ymm5
  .byte  197,252,16,116,36,192               // vmovups       -0x40(%rsp),%ymm6
  .byte  197,252,16,124,36,224               // vmovups       -0x20(%rsp),%ymm7
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_f16_avx
.globl _sk_store_f16_avx
FUNCTION(_sk_store_f16_avx)
_sk_store_f16_avx:
  .byte  72,131,236,56                       // sub           $0x38,%rsp
  .byte  197,252,17,60,36                    // vmovups       %ymm7,(%rsp)
  .byte  197,252,17,116,36,224               // vmovups       %ymm6,-0x20(%rsp)
  .byte  197,252,17,108,36,192               // vmovups       %ymm5,-0x40(%rsp)
  .byte  197,252,17,100,36,160               // vmovups       %ymm4,-0x60(%rsp)
  .byte  197,252,40,225                      // vmovaps       %ymm1,%ymm4
  .byte  196,98,125,24,5,204,60,2,0          // vbroadcastss  0x23ccc(%rip),%ymm8        # 3a360 <_sk_srcover_bgra_8888_sse2_lowp+0x3f8>
  .byte  196,65,124,84,216                   // vandps        %ymm8,%ymm0,%ymm11
  .byte  196,98,125,24,21,6,61,2,0           // vbroadcastss  0x23d06(%rip),%ymm10        # 3a3a8 <_sk_srcover_bgra_8888_sse2_lowp+0x440>
  .byte  196,65,124,84,226                   // vandps        %ymm10,%ymm0,%ymm12
  .byte  196,67,125,25,229,1                 // vextractf128  $0x1,%ymm12,%xmm13
  .byte  196,98,121,24,13,246,60,2,0         // vbroadcastss  0x23cf6(%rip),%xmm9        # 3a3ac <_sk_srcover_bgra_8888_sse2_lowp+0x444>
  .byte  196,65,49,102,245                   // vpcmpgtd      %xmm13,%xmm9,%xmm14
  .byte  196,65,49,102,252                   // vpcmpgtd      %xmm12,%xmm9,%xmm15
  .byte  196,67,5,24,246,1                   // vinsertf128   $0x1,%xmm14,%ymm15,%ymm14
  .byte  196,67,125,25,223,1                 // vextractf128  $0x1,%ymm11,%xmm15
  .byte  196,193,1,114,215,16                // vpsrld        $0x10,%xmm15,%xmm15
  .byte  196,193,33,114,211,16               // vpsrld        $0x10,%xmm11,%xmm11
  .byte  196,193,17,114,213,13               // vpsrld        $0xd,%xmm13,%xmm13
  .byte  196,65,17,254,239                   // vpaddd        %xmm15,%xmm13,%xmm13
  .byte  196,193,25,114,212,13               // vpsrld        $0xd,%xmm12,%xmm12
  .byte  196,65,25,254,227                   // vpaddd        %xmm11,%xmm12,%xmm12
  .byte  196,98,121,24,29,185,60,2,0         // vbroadcastss  0x23cb9(%rip),%xmm11        # 3a3b0 <_sk_srcover_bgra_8888_sse2_lowp+0x448>
  .byte  196,65,17,254,235                   // vpaddd        %xmm11,%xmm13,%xmm13
  .byte  196,65,25,254,227                   // vpaddd        %xmm11,%xmm12,%xmm12
  .byte  196,67,29,24,237,1                  // vinsertf128   $0x1,%xmm13,%ymm12,%ymm13
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,99,21,74,233,224                // vblendvps     %ymm14,%ymm1,%ymm13,%ymm13
  .byte  196,65,92,84,242                    // vandps        %ymm10,%ymm4,%ymm14
  .byte  196,67,125,25,247,1                 // vextractf128  $0x1,%ymm14,%xmm15
  .byte  196,193,49,102,255                  // vpcmpgtd      %xmm15,%xmm9,%xmm7
  .byte  196,65,49,102,230                   // vpcmpgtd      %xmm14,%xmm9,%xmm12
  .byte  196,227,29,24,255,1                 // vinsertf128   $0x1,%xmm7,%ymm12,%ymm7
  .byte  197,252,17,100,36,128               // vmovups       %ymm4,-0x80(%rsp)
  .byte  196,65,92,84,224                    // vandps        %ymm8,%ymm4,%ymm12
  .byte  196,99,125,25,230,1                 // vextractf128  $0x1,%ymm12,%xmm6
  .byte  197,201,114,214,16                  // vpsrld        $0x10,%xmm6,%xmm6
  .byte  196,193,81,114,215,13               // vpsrld        $0xd,%xmm15,%xmm5
  .byte  197,124,40,250                      // vmovaps       %ymm2,%ymm15
  .byte  197,209,254,238                     // vpaddd        %xmm6,%xmm5,%xmm5
  .byte  196,193,73,114,212,16               // vpsrld        $0x10,%xmm12,%xmm6
  .byte  196,193,89,114,214,13               // vpsrld        $0xd,%xmm14,%xmm4
  .byte  197,217,254,230                     // vpaddd        %xmm6,%xmm4,%xmm4
  .byte  196,193,81,254,235                  // vpaddd        %xmm11,%xmm5,%xmm5
  .byte  196,193,89,254,227                  // vpaddd        %xmm11,%xmm4,%xmm4
  .byte  196,227,93,24,229,1                 // vinsertf128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,99,93,74,241,112                // vblendvps     %ymm7,%ymm1,%ymm4,%ymm14
  .byte  196,193,4,84,226                    // vandps        %ymm10,%ymm15,%ymm4
  .byte  196,227,125,25,229,1                // vextractf128  $0x1,%ymm4,%xmm5
  .byte  197,177,102,245                     // vpcmpgtd      %xmm5,%xmm9,%xmm6
  .byte  197,177,102,252                     // vpcmpgtd      %xmm4,%xmm9,%xmm7
  .byte  196,227,69,24,246,1                 // vinsertf128   $0x1,%xmm6,%ymm7,%ymm6
  .byte  196,193,4,84,248                    // vandps        %ymm8,%ymm15,%ymm7
  .byte  196,227,125,25,250,1                // vextractf128  $0x1,%ymm7,%xmm2
  .byte  197,233,114,210,16                  // vpsrld        $0x10,%xmm2,%xmm2
  .byte  197,209,114,213,13                  // vpsrld        $0xd,%xmm5,%xmm5
  .byte  197,209,254,210                     // vpaddd        %xmm2,%xmm5,%xmm2
  .byte  197,209,114,215,16                  // vpsrld        $0x10,%xmm7,%xmm5
  .byte  197,217,114,212,13                  // vpsrld        $0xd,%xmm4,%xmm4
  .byte  197,217,254,229                     // vpaddd        %xmm5,%xmm4,%xmm4
  .byte  196,193,105,254,211                 // vpaddd        %xmm11,%xmm2,%xmm2
  .byte  196,193,89,254,227                  // vpaddd        %xmm11,%xmm4,%xmm4
  .byte  196,227,93,24,210,1                 // vinsertf128   $0x1,%xmm2,%ymm4,%ymm2
  .byte  196,99,109,74,225,96                // vblendvps     %ymm6,%ymm1,%ymm2,%ymm12
  .byte  196,193,100,84,226                  // vandps        %ymm10,%ymm3,%ymm4
  .byte  196,227,125,25,229,1                // vextractf128  $0x1,%ymm4,%xmm5
  .byte  197,177,102,245                     // vpcmpgtd      %xmm5,%xmm9,%xmm6
  .byte  197,177,102,252                     // vpcmpgtd      %xmm4,%xmm9,%xmm7
  .byte  196,227,69,24,246,1                 // vinsertf128   $0x1,%xmm6,%ymm7,%ymm6
  .byte  196,193,100,84,248                  // vandps        %ymm8,%ymm3,%ymm7
  .byte  196,227,125,25,250,1                // vextractf128  $0x1,%ymm7,%xmm2
  .byte  197,233,114,210,16                  // vpsrld        $0x10,%xmm2,%xmm2
  .byte  197,209,114,213,13                  // vpsrld        $0xd,%xmm5,%xmm5
  .byte  197,209,254,210                     // vpaddd        %xmm2,%xmm5,%xmm2
  .byte  197,209,114,215,16                  // vpsrld        $0x10,%xmm7,%xmm5
  .byte  197,217,114,212,13                  // vpsrld        $0xd,%xmm4,%xmm4
  .byte  197,217,254,229                     // vpaddd        %xmm5,%xmm4,%xmm4
  .byte  196,193,105,254,211                 // vpaddd        %xmm11,%xmm2,%xmm2
  .byte  196,193,89,254,227                  // vpaddd        %xmm11,%xmm4,%xmm4
  .byte  196,227,93,24,210,1                 // vinsertf128   $0x1,%xmm2,%ymm4,%ymm2
  .byte  196,227,109,74,201,96               // vblendvps     %ymm6,%ymm1,%ymm2,%ymm1
  .byte  196,99,125,25,234,1                 // vextractf128  $0x1,%ymm13,%xmm2
  .byte  196,226,17,43,210                   // vpackusdw     %xmm2,%xmm13,%xmm2
  .byte  196,99,125,25,244,1                 // vextractf128  $0x1,%ymm14,%xmm4
  .byte  196,226,9,43,228                    // vpackusdw     %xmm4,%xmm14,%xmm4
  .byte  196,99,125,25,229,1                 // vextractf128  $0x1,%ymm12,%xmm5
  .byte  196,226,25,43,245                   // vpackusdw     %xmm5,%xmm12,%xmm6
  .byte  196,227,125,25,205,1                // vextractf128  $0x1,%ymm1,%xmm5
  .byte  196,226,113,43,205                  // vpackusdw     %xmm5,%xmm1,%xmm1
  .byte  197,233,97,236                      // vpunpcklwd    %xmm4,%xmm2,%xmm5
  .byte  197,233,105,212                     // vpunpckhwd    %xmm4,%xmm2,%xmm2
  .byte  197,201,97,225                      // vpunpcklwd    %xmm1,%xmm6,%xmm4
  .byte  197,201,105,201                     // vpunpckhwd    %xmm1,%xmm6,%xmm1
  .byte  197,81,98,220                       // vpunpckldq    %xmm4,%xmm5,%xmm11
  .byte  197,81,106,212                      // vpunpckhdq    %xmm4,%xmm5,%xmm10
  .byte  197,105,98,201                      // vpunpckldq    %xmm1,%xmm2,%xmm9
  .byte  197,105,106,193                     // vpunpckhdq    %xmm1,%xmm2,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,68                              // jne           168ce <_sk_store_f16_avx+0x262>
  .byte  196,65,122,127,28,192               // vmovdqu       %xmm11,(%r8,%rax,8)
  .byte  196,65,122,127,84,192,16            // vmovdqu       %xmm10,0x10(%r8,%rax,8)
  .byte  196,65,122,127,76,192,32            // vmovdqu       %xmm9,0x20(%r8,%rax,8)
  .byte  196,65,122,127,68,192,48            // vmovdqu       %xmm8,0x30(%r8,%rax,8)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,76,36,128                // vmovups       -0x80(%rsp),%ymm1
  .byte  197,124,41,250                      // vmovaps       %ymm15,%ymm2
  .byte  197,252,16,100,36,160               // vmovups       -0x60(%rsp),%ymm4
  .byte  197,252,16,108,36,192               // vmovups       -0x40(%rsp),%ymm5
  .byte  197,252,16,116,36,224               // vmovups       -0x20(%rsp),%ymm6
  .byte  197,252,16,60,36                    // vmovups       (%rsp),%ymm7
  .byte  72,131,196,56                       // add           $0x38,%rsp
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,121,214,28,192               // vmovq         %xmm11,(%r8,%rax,8)
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,203                             // je            168a5 <_sk_store_f16_avx+0x239>
  .byte  196,65,121,23,92,192,8              // vmovhpd       %xmm11,0x8(%r8,%rax,8)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,190                             // jb            168a5 <_sk_store_f16_avx+0x239>
  .byte  196,65,121,214,84,192,16            // vmovq         %xmm10,0x10(%r8,%rax,8)
  .byte  116,181                             // je            168a5 <_sk_store_f16_avx+0x239>
  .byte  196,65,121,23,84,192,24             // vmovhpd       %xmm10,0x18(%r8,%rax,8)
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,168                             // jb            168a5 <_sk_store_f16_avx+0x239>
  .byte  196,65,121,214,76,192,32            // vmovq         %xmm9,0x20(%r8,%rax,8)
  .byte  116,159                             // je            168a5 <_sk_store_f16_avx+0x239>
  .byte  196,65,121,23,76,192,40             // vmovhpd       %xmm9,0x28(%r8,%rax,8)
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,146                             // jb            168a5 <_sk_store_f16_avx+0x239>
  .byte  196,65,121,214,68,192,48            // vmovq         %xmm8,0x30(%r8,%rax,8)
  .byte  235,137                             // jmp           168a5 <_sk_store_f16_avx+0x239>

HIDDEN _sk_load_u16_be_avx
.globl _sk_load_u16_be_avx
FUNCTION(_sk_load_u16_be_avx)
_sk_load_u16_be_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,12,1,0,0                     // jne           16a4f <_sk_load_u16_be_avx+0x133>
  .byte  196,65,121,16,4,64                  // vmovupd       (%r8,%rax,2),%xmm8
  .byte  196,193,121,16,84,64,16             // vmovupd       0x10(%r8,%rax,2),%xmm2
  .byte  196,193,121,16,92,64,32             // vmovupd       0x20(%r8,%rax,2),%xmm3
  .byte  196,65,122,111,76,64,48             // vmovdqu       0x30(%r8,%rax,2),%xmm9
  .byte  197,185,97,194                      // vpunpcklwd    %xmm2,%xmm8,%xmm0
  .byte  197,185,105,210                     // vpunpckhwd    %xmm2,%xmm8,%xmm2
  .byte  196,193,97,97,201                   // vpunpcklwd    %xmm9,%xmm3,%xmm1
  .byte  196,193,97,105,217                  // vpunpckhwd    %xmm9,%xmm3,%xmm3
  .byte  197,121,97,210                      // vpunpcklwd    %xmm2,%xmm0,%xmm10
  .byte  197,121,105,194                     // vpunpckhwd    %xmm2,%xmm0,%xmm8
  .byte  197,241,97,211                      // vpunpcklwd    %xmm3,%xmm1,%xmm2
  .byte  197,113,105,219                     // vpunpckhwd    %xmm3,%xmm1,%xmm11
  .byte  197,169,108,194                     // vpunpcklqdq   %xmm2,%xmm10,%xmm0
  .byte  197,241,113,240,8                   // vpsllw        $0x8,%xmm0,%xmm1
  .byte  197,249,113,208,8                   // vpsrlw        $0x8,%xmm0,%xmm0
  .byte  197,241,235,192                     // vpor          %xmm0,%xmm1,%xmm0
  .byte  196,226,121,51,200                  // vpmovzxwd     %xmm0,%xmm1
  .byte  197,249,112,192,78                  // vpshufd       $0x4e,%xmm0,%xmm0
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  196,227,117,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,13,248,56,2,0         // vbroadcastss  0x238f8(%rip),%ymm9        # 3a2ac <_sk_srcover_bgra_8888_sse2_lowp+0x344>
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,169,109,202                     // vpunpckhqdq   %xmm2,%xmm10,%xmm1
  .byte  197,233,113,241,8                   // vpsllw        $0x8,%xmm1,%xmm2
  .byte  197,241,113,209,8                   // vpsrlw        $0x8,%xmm1,%xmm1
  .byte  197,233,235,201                     // vpor          %xmm1,%xmm2,%xmm1
  .byte  196,226,121,51,209                  // vpmovzxwd     %xmm1,%xmm2
  .byte  197,249,112,201,78                  // vpshufd       $0x4e,%xmm1,%xmm1
  .byte  196,226,121,51,201                  // vpmovzxwd     %xmm1,%xmm1
  .byte  196,227,109,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm2,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,201                  // vmulps        %ymm9,%ymm1,%ymm1
  .byte  196,193,57,108,211                  // vpunpcklqdq   %xmm11,%xmm8,%xmm2
  .byte  197,225,113,242,8                   // vpsllw        $0x8,%xmm2,%xmm3
  .byte  197,233,113,210,8                   // vpsrlw        $0x8,%xmm2,%xmm2
  .byte  197,225,235,210                     // vpor          %xmm2,%xmm3,%xmm2
  .byte  196,226,121,51,218                  // vpmovzxwd     %xmm2,%xmm3
  .byte  197,249,112,210,78                  // vpshufd       $0x4e,%xmm2,%xmm2
  .byte  196,226,121,51,210                  // vpmovzxwd     %xmm2,%xmm2
  .byte  196,227,101,24,210,1                // vinsertf128   $0x1,%xmm2,%ymm3,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,209                  // vmulps        %ymm9,%ymm2,%ymm2
  .byte  196,193,57,109,219                  // vpunpckhqdq   %xmm11,%xmm8,%xmm3
  .byte  197,185,113,243,8                   // vpsllw        $0x8,%xmm3,%xmm8
  .byte  197,225,113,211,8                   // vpsrlw        $0x8,%xmm3,%xmm3
  .byte  197,185,235,219                     // vpor          %xmm3,%xmm8,%xmm3
  .byte  196,98,121,51,195                   // vpmovzxwd     %xmm3,%xmm8
  .byte  197,249,112,219,78                  // vpshufd       $0x4e,%xmm3,%xmm3
  .byte  196,226,121,51,219                  // vpmovzxwd     %xmm3,%xmm3
  .byte  196,227,61,24,219,1                 // vinsertf128   $0x1,%xmm3,%ymm8,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  196,193,100,89,217                  // vmulps        %ymm9,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,123,16,4,64                  // vmovsd        (%r8,%rax,2),%xmm8
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,85                              // je            16ab5 <_sk_load_u16_be_avx+0x199>
  .byte  196,65,57,22,68,64,8                // vmovhpd       0x8(%r8,%rax,2),%xmm8,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,72                              // jb            16ab5 <_sk_load_u16_be_avx+0x199>
  .byte  196,193,123,16,84,64,16             // vmovsd        0x10(%r8,%rax,2),%xmm2
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  116,72                              // je            16ac2 <_sk_load_u16_be_avx+0x1a6>
  .byte  196,193,105,22,84,64,24             // vmovhpd       0x18(%r8,%rax,2),%xmm2,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,59                              // jb            16ac2 <_sk_load_u16_be_avx+0x1a6>
  .byte  196,193,123,16,92,64,32             // vmovsd        0x20(%r8,%rax,2),%xmm3
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  15,132,198,254,255,255              // je            1695e <_sk_load_u16_be_avx+0x42>
  .byte  196,193,97,22,92,64,40              // vmovhpd       0x28(%r8,%rax,2),%xmm3,%xmm3
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,130,181,254,255,255              // jb            1695e <_sk_load_u16_be_avx+0x42>
  .byte  196,65,122,126,76,64,48             // vmovq         0x30(%r8,%rax,2),%xmm9
  .byte  233,169,254,255,255                 // jmpq          1695e <_sk_load_u16_be_avx+0x42>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  197,233,87,210                      // vxorpd        %xmm2,%xmm2,%xmm2
  .byte  233,156,254,255,255                 // jmpq          1695e <_sk_load_u16_be_avx+0x42>
  .byte  197,225,87,219                      // vxorpd        %xmm3,%xmm3,%xmm3
  .byte  233,147,254,255,255                 // jmpq          1695e <_sk_load_u16_be_avx+0x42>

HIDDEN _sk_load_rgb_u16_be_avx
.globl _sk_load_rgb_u16_be_avx
FUNCTION(_sk_load_rgb_u16_be_avx)
_sk_load_rgb_u16_be_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,137,208                          // mov           %rdx,%rax
  .byte  72,193,224,32                       // shl           $0x20,%rax
  .byte  72,141,4,64                         // lea           (%rax,%rax,2),%rax
  .byte  72,193,248,32                       // sar           $0x20,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,253,0,0,0                    // jne           16bf3 <_sk_load_rgb_u16_be_avx+0x128>
  .byte  196,65,122,111,28,64                // vmovdqu       (%r8,%rax,2),%xmm11
  .byte  196,193,122,111,92,64,12            // vmovdqu       0xc(%r8,%rax,2),%xmm3
  .byte  196,193,122,111,84,64,24            // vmovdqu       0x18(%r8,%rax,2),%xmm2
  .byte  196,193,122,111,68,64,32            // vmovdqu       0x20(%r8,%rax,2),%xmm0
  .byte  197,249,115,216,4                   // vpsrldq       $0x4,%xmm0,%xmm0
  .byte  196,193,57,115,219,6                // vpsrldq       $0x6,%xmm11,%xmm8
  .byte  197,169,115,219,6                   // vpsrldq       $0x6,%xmm3,%xmm10
  .byte  197,241,115,218,6                   // vpsrldq       $0x6,%xmm2,%xmm1
  .byte  197,177,115,216,6                   // vpsrldq       $0x6,%xmm0,%xmm9
  .byte  196,193,113,97,201                  // vpunpcklwd    %xmm9,%xmm1,%xmm1
  .byte  197,233,97,192                      // vpunpcklwd    %xmm0,%xmm2,%xmm0
  .byte  196,193,57,97,210                   // vpunpcklwd    %xmm10,%xmm8,%xmm2
  .byte  197,161,97,219                      // vpunpcklwd    %xmm3,%xmm11,%xmm3
  .byte  197,97,97,194                       // vpunpcklwd    %xmm2,%xmm3,%xmm8
  .byte  197,225,105,210                     // vpunpckhwd    %xmm2,%xmm3,%xmm2
  .byte  197,249,97,217                      // vpunpcklwd    %xmm1,%xmm0,%xmm3
  .byte  197,249,105,193                     // vpunpckhwd    %xmm1,%xmm0,%xmm0
  .byte  197,233,108,208                     // vpunpcklqdq   %xmm0,%xmm2,%xmm2
  .byte  197,185,108,195                     // vpunpcklqdq   %xmm3,%xmm8,%xmm0
  .byte  197,241,113,240,8                   // vpsllw        $0x8,%xmm0,%xmm1
  .byte  197,249,113,208,8                   // vpsrlw        $0x8,%xmm0,%xmm0
  .byte  197,241,235,192                     // vpor          %xmm0,%xmm1,%xmm0
  .byte  196,226,121,51,200                  // vpmovzxwd     %xmm0,%xmm1
  .byte  197,249,112,192,78                  // vpshufd       $0x4e,%xmm0,%xmm0
  .byte  196,226,121,51,192                  // vpmovzxwd     %xmm0,%xmm0
  .byte  196,227,117,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  196,98,125,24,13,39,55,2,0          // vbroadcastss  0x23727(%rip),%ymm9        # 3a2ac <_sk_srcover_bgra_8888_sse2_lowp+0x344>
  .byte  196,193,124,89,193                  // vmulps        %ymm9,%ymm0,%ymm0
  .byte  197,185,109,203                     // vpunpckhqdq   %xmm3,%xmm8,%xmm1
  .byte  197,225,113,241,8                   // vpsllw        $0x8,%xmm1,%xmm3
  .byte  197,241,113,209,8                   // vpsrlw        $0x8,%xmm1,%xmm1
  .byte  197,225,235,201                     // vpor          %xmm1,%xmm3,%xmm1
  .byte  196,226,121,51,217                  // vpmovzxwd     %xmm1,%xmm3
  .byte  197,249,112,201,78                  // vpshufd       $0x4e,%xmm1,%xmm1
  .byte  196,226,121,51,201                  // vpmovzxwd     %xmm1,%xmm1
  .byte  196,227,101,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm3,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  196,193,116,89,201                  // vmulps        %ymm9,%ymm1,%ymm1
  .byte  197,225,113,242,8                   // vpsllw        $0x8,%xmm2,%xmm3
  .byte  197,233,113,210,8                   // vpsrlw        $0x8,%xmm2,%xmm2
  .byte  197,225,235,210                     // vpor          %xmm2,%xmm3,%xmm2
  .byte  196,226,121,51,218                  // vpmovzxwd     %xmm2,%xmm3
  .byte  197,249,112,210,78                  // vpshufd       $0x4e,%xmm2,%xmm2
  .byte  196,226,121,51,210                  // vpmovzxwd     %xmm2,%xmm2
  .byte  196,227,101,24,210,1                // vinsertf128   $0x1,%xmm2,%ymm3,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,193,108,89,209                  // vmulps        %ymm9,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,39,54,2,0         // vbroadcastss  0x23627(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  255,224                             // jmpq          *%rax
  .byte  196,193,121,110,4,64                // vmovd         (%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,65,121,196,92,64,4,2            // vpinsrw       $0x2,0x4(%r8,%rax,2),%xmm0,%xmm11
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,31                              // jne           16c2b <_sk_load_rgb_u16_be_avx+0x160>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  197,225,239,219                     // vpxor         %xmm3,%xmm3,%xmm3
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  233,0,255,255,255                   // jmpq          16b2b <_sk_load_rgb_u16_be_avx+0x60>
  .byte  196,193,121,110,68,64,6             // vmovd         0x6(%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,65,121,196,68,64,10,2           // vpinsrw       $0x2,0xa(%r8,%rax,2),%xmm0,%xmm8
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,48                              // jb            16c75 <_sk_load_rgb_u16_be_avx+0x1aa>
  .byte  196,193,121,110,68,64,12            // vmovd         0xc(%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,193,121,196,92,64,16,2          // vpinsrw       $0x2,0x10(%r8,%rax,2),%xmm0,%xmm3
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  117,48                              // jne           16c8f <_sk_load_rgb_u16_be_avx+0x1c4>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  233,182,254,255,255                 // jmpq          16b2b <_sk_load_rgb_u16_be_avx+0x60>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  196,65,41,239,210                   // vpxor         %xmm10,%xmm10,%xmm10
  .byte  197,225,239,219                     // vpxor         %xmm3,%xmm3,%xmm3
  .byte  233,156,254,255,255                 // jmpq          16b2b <_sk_load_rgb_u16_be_avx+0x60>
  .byte  196,193,121,110,68,64,18            // vmovd         0x12(%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,65,121,196,84,64,22,2           // vpinsrw       $0x2,0x16(%r8,%rax,2),%xmm0,%xmm10
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,39                              // jb            16cd0 <_sk_load_rgb_u16_be_avx+0x205>
  .byte  196,193,121,110,68,64,24            // vmovd         0x18(%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,193,121,196,84,64,28,2          // vpinsrw       $0x2,0x1c(%r8,%rax,2),%xmm0,%xmm2
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  117,30                              // jne           16ce1 <_sk_load_rgb_u16_be_avx+0x216>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  233,91,254,255,255                  // jmpq          16b2b <_sk_load_rgb_u16_be_avx+0x60>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  197,241,239,201                     // vpxor         %xmm1,%xmm1,%xmm1
  .byte  197,233,239,210                     // vpxor         %xmm2,%xmm2,%xmm2
  .byte  233,74,254,255,255                  // jmpq          16b2b <_sk_load_rgb_u16_be_avx+0x60>
  .byte  196,193,121,110,68,64,30            // vmovd         0x1e(%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,193,121,196,76,64,34,2          // vpinsrw       $0x2,0x22(%r8,%rax,2),%xmm0,%xmm1
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,25                              // jb            16d14 <_sk_load_rgb_u16_be_avx+0x249>
  .byte  196,193,121,110,68,64,36            // vmovd         0x24(%r8,%rax,2),%xmm0
  .byte  196,65,49,239,201                   // vpxor         %xmm9,%xmm9,%xmm9
  .byte  196,193,121,196,68,64,40,2          // vpinsrw       $0x2,0x28(%r8,%rax,2),%xmm0,%xmm0
  .byte  233,23,254,255,255                  // jmpq          16b2b <_sk_load_rgb_u16_be_avx+0x60>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  233,14,254,255,255                  // jmpq          16b2b <_sk_load_rgb_u16_be_avx+0x60>

HIDDEN _sk_store_u16_be_avx
.globl _sk_store_u16_be_avx
FUNCTION(_sk_store_u16_be_avx)
_sk_store_u16_be_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,95,200                       // vmaxps        %ymm0,%ymm8,%ymm9
  .byte  196,98,125,24,21,203,52,2,0         // vbroadcastss  0x234cb(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,65,52,93,202                    // vminps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,29,217,53,2,0         // vbroadcastss  0x235d9(%rip),%ymm11        # 3a334 <_sk_srcover_bgra_8888_sse2_lowp+0x3cc>
  .byte  196,65,52,89,203                    // vmulps        %ymm11,%ymm9,%ymm9
  .byte  196,65,125,91,201                   // vcvtps2dq     %ymm9,%ymm9
  .byte  196,67,125,25,204,1                 // vextractf128  $0x1,%ymm9,%xmm12
  .byte  196,66,49,43,204                    // vpackusdw     %xmm12,%xmm9,%xmm9
  .byte  196,193,25,113,241,8                // vpsllw        $0x8,%xmm9,%xmm12
  .byte  196,193,49,113,209,8                // vpsrlw        $0x8,%xmm9,%xmm9
  .byte  196,65,25,235,201                   // vpor          %xmm9,%xmm12,%xmm9
  .byte  197,60,95,225                       // vmaxps        %ymm1,%ymm8,%ymm12
  .byte  196,65,28,93,226                    // vminps        %ymm10,%ymm12,%ymm12
  .byte  196,65,28,89,227                    // vmulps        %ymm11,%ymm12,%ymm12
  .byte  196,65,125,91,228                   // vcvtps2dq     %ymm12,%ymm12
  .byte  196,67,125,25,229,1                 // vextractf128  $0x1,%ymm12,%xmm13
  .byte  196,66,25,43,229                    // vpackusdw     %xmm13,%xmm12,%xmm12
  .byte  196,193,17,113,244,8                // vpsllw        $0x8,%xmm12,%xmm13
  .byte  196,193,25,113,212,8                // vpsrlw        $0x8,%xmm12,%xmm12
  .byte  196,65,17,235,228                   // vpor          %xmm12,%xmm13,%xmm12
  .byte  197,60,95,234                       // vmaxps        %ymm2,%ymm8,%ymm13
  .byte  196,65,20,93,234                    // vminps        %ymm10,%ymm13,%ymm13
  .byte  196,65,20,89,235                    // vmulps        %ymm11,%ymm13,%ymm13
  .byte  196,65,125,91,237                   // vcvtps2dq     %ymm13,%ymm13
  .byte  196,67,125,25,238,1                 // vextractf128  $0x1,%ymm13,%xmm14
  .byte  196,66,17,43,238                    // vpackusdw     %xmm14,%xmm13,%xmm13
  .byte  196,193,9,113,245,8                 // vpsllw        $0x8,%xmm13,%xmm14
  .byte  196,193,17,113,213,8                // vpsrlw        $0x8,%xmm13,%xmm13
  .byte  196,65,9,235,237                    // vpor          %xmm13,%xmm14,%xmm13
  .byte  197,60,95,195                       // vmaxps        %ymm3,%ymm8,%ymm8
  .byte  196,65,60,93,194                    // vminps        %ymm10,%ymm8,%ymm8
  .byte  196,65,60,89,195                    // vmulps        %ymm11,%ymm8,%ymm8
  .byte  196,65,125,91,192                   // vcvtps2dq     %ymm8,%ymm8
  .byte  196,67,125,25,194,1                 // vextractf128  $0x1,%ymm8,%xmm10
  .byte  196,66,57,43,194                    // vpackusdw     %xmm10,%xmm8,%xmm8
  .byte  196,193,41,113,240,8                // vpsllw        $0x8,%xmm8,%xmm10
  .byte  196,193,57,113,208,8                // vpsrlw        $0x8,%xmm8,%xmm8
  .byte  196,65,41,235,192                   // vpor          %xmm8,%xmm10,%xmm8
  .byte  196,65,49,97,212                    // vpunpcklwd    %xmm12,%xmm9,%xmm10
  .byte  196,65,49,105,228                   // vpunpckhwd    %xmm12,%xmm9,%xmm12
  .byte  196,65,17,97,200                    // vpunpcklwd    %xmm8,%xmm13,%xmm9
  .byte  196,65,17,105,192                   // vpunpckhwd    %xmm8,%xmm13,%xmm8
  .byte  196,65,41,98,217                    // vpunpckldq    %xmm9,%xmm10,%xmm11
  .byte  196,65,41,106,209                   // vpunpckhdq    %xmm9,%xmm10,%xmm10
  .byte  196,65,25,98,200                    // vpunpckldq    %xmm8,%xmm12,%xmm9
  .byte  196,65,25,106,192                   // vpunpckhdq    %xmm8,%xmm12,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,31                              // jne           16e5a <_sk_store_u16_be_avx+0x13d>
  .byte  196,65,122,127,28,64                // vmovdqu       %xmm11,(%r8,%rax,2)
  .byte  196,65,122,127,84,64,16             // vmovdqu       %xmm10,0x10(%r8,%rax,2)
  .byte  196,65,122,127,76,64,32             // vmovdqu       %xmm9,0x20(%r8,%rax,2)
  .byte  196,65,122,127,68,64,48             // vmovdqu       %xmm8,0x30(%r8,%rax,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,121,214,28,64                // vmovq         %xmm11,(%r8,%rax,2)
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,240                             // je            16e56 <_sk_store_u16_be_avx+0x139>
  .byte  196,65,121,23,92,64,8               // vmovhpd       %xmm11,0x8(%r8,%rax,2)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,227                             // jb            16e56 <_sk_store_u16_be_avx+0x139>
  .byte  196,65,121,214,84,64,16             // vmovq         %xmm10,0x10(%r8,%rax,2)
  .byte  116,218                             // je            16e56 <_sk_store_u16_be_avx+0x139>
  .byte  196,65,121,23,84,64,24              // vmovhpd       %xmm10,0x18(%r8,%rax,2)
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,205                             // jb            16e56 <_sk_store_u16_be_avx+0x139>
  .byte  196,65,121,214,76,64,32             // vmovq         %xmm9,0x20(%r8,%rax,2)
  .byte  116,196                             // je            16e56 <_sk_store_u16_be_avx+0x139>
  .byte  196,65,121,23,76,64,40              // vmovhpd       %xmm9,0x28(%r8,%rax,2)
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,183                             // jb            16e56 <_sk_store_u16_be_avx+0x139>
  .byte  196,65,121,214,68,64,48             // vmovq         %xmm8,0x30(%r8,%rax,2)
  .byte  235,174                             // jmp           16e56 <_sk_store_u16_be_avx+0x139>

HIDDEN _sk_load_f32_avx
.globl _sk_load_f32_avx
FUNCTION(_sk_load_f32_avx)
_sk_load_f32_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,253,87,192                      // vxorpd        %ymm0,%ymm0,%ymm0
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,135,97,1,0,0                     // ja            17019 <_sk_load_f32_avx+0x171>
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  197,253,17,100,36,128               // vmovupd       %ymm4,-0x80(%rsp)
  .byte  197,253,17,108,36,160               // vmovupd       %ymm5,-0x60(%rsp)
  .byte  197,253,17,116,36,192               // vmovupd       %ymm6,-0x40(%rsp)
  .byte  197,253,17,124,36,224               // vmovupd       %ymm7,-0x20(%rsp)
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  77,99,201                           // movslq        %r9d,%r9
  .byte  76,141,21,48,1,0,0                  // lea           0x130(%rip),%r10        # 17028 <_sk_load_f32_avx+0x180>
  .byte  73,99,4,186                         // movslq        (%r10,%rdi,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  197,221,87,228                      // vxorpd        %ymm4,%ymm4,%ymm4
  .byte  196,65,53,87,201                    // vxorpd        %ymm9,%ymm9,%ymm9
  .byte  197,237,87,210                      // vxorpd        %ymm2,%ymm2,%ymm2
  .byte  196,65,37,87,219                    // vxorpd        %ymm11,%ymm11,%ymm11
  .byte  196,65,29,87,228                    // vxorpd        %ymm12,%ymm12,%ymm12
  .byte  196,65,61,87,192                    // vxorpd        %ymm8,%ymm8,%ymm8
  .byte  196,65,13,87,246                    // vxorpd        %ymm14,%ymm14,%ymm14
  .byte  197,205,87,246                      // vxorpd        %ymm6,%ymm6,%ymm6
  .byte  196,65,5,87,255                     // vxorpd        %ymm15,%ymm15,%ymm15
  .byte  197,245,87,201                      // vxorpd        %ymm1,%ymm1,%ymm1
  .byte  196,65,21,87,237                    // vxorpd        %ymm13,%ymm13,%ymm13
  .byte  197,213,87,237                      // vxorpd        %ymm5,%ymm5,%ymm5
  .byte  197,229,87,219                      // vxorpd        %ymm3,%ymm3,%ymm3
  .byte  196,65,45,87,210                    // vxorpd        %ymm10,%ymm10,%ymm10
  .byte  197,197,87,255                      // vxorpd        %ymm7,%ymm7,%ymm7
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,16,68,136,112           // vmovupd       0x70(%r8,%r9,4),%xmm0
  .byte  196,227,125,6,192,40                // vperm2f128    $0x28,%ymm0,%ymm0,%ymm0
  .byte  196,129,121,16,76,136,96            // vmovupd       0x60(%r8,%r9,4),%xmm1
  .byte  196,227,125,6,225,40                // vperm2f128    $0x28,%ymm1,%ymm0,%ymm4
  .byte  196,129,121,16,76,136,80            // vmovupd       0x50(%r8,%r9,4),%xmm1
  .byte  196,227,125,6,209,40                // vperm2f128    $0x28,%ymm1,%ymm0,%ymm2
  .byte  197,125,40,204                      // vmovapd       %ymm4,%ymm9
  .byte  196,129,121,16,76,136,64            // vmovupd       0x40(%r8,%r9,4),%xmm1
  .byte  196,99,125,6,193,40                 // vperm2f128    $0x28,%ymm1,%ymm0,%ymm8
  .byte  196,65,125,40,217                   // vmovapd       %ymm9,%ymm11
  .byte  197,125,40,226                      // vmovapd       %ymm2,%ymm12
  .byte  196,129,121,16,76,136,48            // vmovupd       0x30(%r8,%r9,4),%xmm1
  .byte  196,227,117,13,192,12               // vblendpd      $0xc,%ymm0,%ymm1,%ymm0
  .byte  196,65,125,40,243                   // vmovapd       %ymm11,%ymm14
  .byte  197,125,41,230                      // vmovapd       %ymm12,%ymm6
  .byte  196,65,125,40,248                   // vmovapd       %ymm8,%ymm15
  .byte  196,129,121,16,76,136,32            // vmovupd       0x20(%r8,%r9,4),%xmm1
  .byte  196,195,117,13,206,12               // vblendpd      $0xc,%ymm14,%ymm1,%ymm1
  .byte  197,125,40,238                      // vmovapd       %ymm6,%ymm13
  .byte  197,125,41,253                      // vmovapd       %ymm15,%ymm5
  .byte  196,129,121,16,84,136,16            // vmovupd       0x10(%r8,%r9,4),%xmm2
  .byte  196,67,109,13,213,12                // vblendpd      $0xc,%ymm13,%ymm2,%ymm10
  .byte  197,253,40,217                      // vmovapd       %ymm1,%ymm3
  .byte  197,253,40,253                      // vmovapd       %ymm5,%ymm7
  .byte  196,129,121,16,12,136               // vmovupd       (%r8,%r9,4),%xmm1
  .byte  196,227,117,13,207,12               // vblendpd      $0xc,%ymm7,%ymm1,%ymm1
  .byte  197,252,16,124,36,224               // vmovups       -0x20(%rsp),%ymm7
  .byte  197,252,16,116,36,192               // vmovups       -0x40(%rsp),%ymm6
  .byte  197,252,16,108,36,160               // vmovups       -0x60(%rsp),%ymm5
  .byte  197,252,16,100,36,128               // vmovups       -0x80(%rsp),%ymm4
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  196,193,116,20,210                  // vunpcklps     %ymm10,%ymm1,%ymm2
  .byte  196,65,116,21,194                   // vunpckhps     %ymm10,%ymm1,%ymm8
  .byte  197,228,20,200                      // vunpcklps     %ymm0,%ymm3,%ymm1
  .byte  197,228,21,216                      // vunpckhps     %ymm0,%ymm3,%ymm3
  .byte  197,237,20,193                      // vunpcklpd     %ymm1,%ymm2,%ymm0
  .byte  197,237,21,201                      // vunpckhpd     %ymm1,%ymm2,%ymm1
  .byte  197,189,20,211                      // vunpcklpd     %ymm3,%ymm8,%ymm2
  .byte  197,189,21,219                      // vunpckhpd     %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  197,229,87,219                      // vxorpd        %ymm3,%ymm3,%ymm3
  .byte  196,65,45,87,210                    // vxorpd        %ymm10,%ymm10,%ymm10
  .byte  197,245,87,201                      // vxorpd        %ymm1,%ymm1,%ymm1
  .byte  235,203                             // jmp           16ff3 <_sk_load_f32_avx+0x14b>
  .byte  29,255,255,255,163                  // sbb           $0xa3ffffff,%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,142,255,255,255,121             // decl          0x79ffffff(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,94,255                          // lcall         *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,72,255                          // decl          -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,55                              // pushq         (%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,42                              // ljmp          *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_f32_dst_avx
.globl _sk_load_f32_dst_avx
FUNCTION(_sk_load_f32_dst_avx)
_sk_load_f32_dst_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,221,87,228                      // vxorpd        %ymm4,%ymm4,%ymm4
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  15,135,97,1,0,0                     // ja            171b9 <_sk_load_f32_dst_avx+0x171>
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  197,253,17,68,36,128                // vmovupd       %ymm0,-0x80(%rsp)
  .byte  197,253,17,76,36,160                // vmovupd       %ymm1,-0x60(%rsp)
  .byte  197,253,17,84,36,192                // vmovupd       %ymm2,-0x40(%rsp)
  .byte  197,253,17,92,36,224                // vmovupd       %ymm3,-0x20(%rsp)
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  77,99,201                           // movslq        %r9d,%r9
  .byte  76,141,21,48,1,0,0                  // lea           0x130(%rip),%r10        # 171c8 <_sk_load_f32_dst_avx+0x180>
  .byte  73,99,4,186                         // movslq        (%r10,%rdi,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  197,253,87,192                      // vxorpd        %ymm0,%ymm0,%ymm0
  .byte  196,65,53,87,201                    // vxorpd        %ymm9,%ymm9,%ymm9
  .byte  197,205,87,246                      // vxorpd        %ymm6,%ymm6,%ymm6
  .byte  196,65,37,87,219                    // vxorpd        %ymm11,%ymm11,%ymm11
  .byte  196,65,29,87,228                    // vxorpd        %ymm12,%ymm12,%ymm12
  .byte  196,65,61,87,192                    // vxorpd        %ymm8,%ymm8,%ymm8
  .byte  196,65,13,87,246                    // vxorpd        %ymm14,%ymm14,%ymm14
  .byte  197,237,87,210                      // vxorpd        %ymm2,%ymm2,%ymm2
  .byte  196,65,5,87,255                     // vxorpd        %ymm15,%ymm15,%ymm15
  .byte  197,213,87,237                      // vxorpd        %ymm5,%ymm5,%ymm5
  .byte  196,65,21,87,237                    // vxorpd        %ymm13,%ymm13,%ymm13
  .byte  197,245,87,201                      // vxorpd        %ymm1,%ymm1,%ymm1
  .byte  197,197,87,255                      // vxorpd        %ymm7,%ymm7,%ymm7
  .byte  196,65,45,87,210                    // vxorpd        %ymm10,%ymm10,%ymm10
  .byte  197,229,87,219                      // vxorpd        %ymm3,%ymm3,%ymm3
  .byte  255,224                             // jmpq          *%rax
  .byte  196,129,121,16,68,136,112           // vmovupd       0x70(%r8,%r9,4),%xmm0
  .byte  196,227,125,6,224,40                // vperm2f128    $0x28,%ymm0,%ymm0,%ymm4
  .byte  196,129,121,16,68,136,96            // vmovupd       0x60(%r8,%r9,4),%xmm0
  .byte  196,227,125,6,192,40                // vperm2f128    $0x28,%ymm0,%ymm0,%ymm0
  .byte  196,129,121,16,76,136,80            // vmovupd       0x50(%r8,%r9,4),%xmm1
  .byte  196,227,125,6,241,40                // vperm2f128    $0x28,%ymm1,%ymm0,%ymm6
  .byte  197,125,40,200                      // vmovapd       %ymm0,%ymm9
  .byte  196,129,121,16,68,136,64            // vmovupd       0x40(%r8,%r9,4),%xmm0
  .byte  196,99,125,6,192,40                 // vperm2f128    $0x28,%ymm0,%ymm0,%ymm8
  .byte  196,65,125,40,217                   // vmovapd       %ymm9,%ymm11
  .byte  197,125,40,230                      // vmovapd       %ymm6,%ymm12
  .byte  196,129,121,16,68,136,48            // vmovupd       0x30(%r8,%r9,4),%xmm0
  .byte  196,227,125,13,228,12               // vblendpd      $0xc,%ymm4,%ymm0,%ymm4
  .byte  196,65,125,40,243                   // vmovapd       %ymm11,%ymm14
  .byte  197,125,41,226                      // vmovapd       %ymm12,%ymm2
  .byte  196,65,125,40,248                   // vmovapd       %ymm8,%ymm15
  .byte  196,129,121,16,68,136,32            // vmovupd       0x20(%r8,%r9,4),%xmm0
  .byte  196,195,125,13,238,12               // vblendpd      $0xc,%ymm14,%ymm0,%ymm5
  .byte  197,125,40,234                      // vmovapd       %ymm2,%ymm13
  .byte  197,125,41,249                      // vmovapd       %ymm15,%ymm1
  .byte  196,129,121,16,68,136,16            // vmovupd       0x10(%r8,%r9,4),%xmm0
  .byte  196,67,125,13,213,12                // vblendpd      $0xc,%ymm13,%ymm0,%ymm10
  .byte  197,253,40,253                      // vmovapd       %ymm5,%ymm7
  .byte  197,253,40,217                      // vmovapd       %ymm1,%ymm3
  .byte  196,129,121,16,4,136                // vmovupd       (%r8,%r9,4),%xmm0
  .byte  196,227,125,13,235,12               // vblendpd      $0xc,%ymm3,%ymm0,%ymm5
  .byte  197,252,16,92,36,224                // vmovups       -0x20(%rsp),%ymm3
  .byte  197,252,16,84,36,192                // vmovups       -0x40(%rsp),%ymm2
  .byte  197,252,16,76,36,160                // vmovups       -0x60(%rsp),%ymm1
  .byte  197,252,16,68,36,128                // vmovups       -0x80(%rsp),%ymm0
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  196,193,84,20,242                   // vunpcklps     %ymm10,%ymm5,%ymm6
  .byte  196,65,84,21,194                    // vunpckhps     %ymm10,%ymm5,%ymm8
  .byte  197,196,20,236                      // vunpcklps     %ymm4,%ymm7,%ymm5
  .byte  197,196,21,252                      // vunpckhps     %ymm4,%ymm7,%ymm7
  .byte  197,205,20,229                      // vunpcklpd     %ymm5,%ymm6,%ymm4
  .byte  197,205,21,237                      // vunpckhpd     %ymm5,%ymm6,%ymm5
  .byte  197,189,20,247                      // vunpcklpd     %ymm7,%ymm8,%ymm6
  .byte  197,189,21,255                      // vunpckhpd     %ymm7,%ymm8,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  197,197,87,255                      // vxorpd        %ymm7,%ymm7,%ymm7
  .byte  196,65,45,87,210                    // vxorpd        %ymm10,%ymm10,%ymm10
  .byte  197,213,87,237                      // vxorpd        %ymm5,%ymm5,%ymm5
  .byte  235,203                             // jmp           17193 <_sk_load_f32_dst_avx+0x14b>
  .byte  29,255,255,255,163                  // sbb           $0xa3ffffff,%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,142,255,255,255,121             // decl          0x79ffffff(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,94,255                          // lcall         *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,72,255                          // decl          -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,55                              // pushq         (%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,42                              // ljmp          *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_f32_avx
.globl _sk_store_f32_avx
FUNCTION(_sk_store_f32_avx)
_sk_store_f32_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  197,124,20,193                      // vunpcklps     %ymm1,%ymm0,%ymm8
  .byte  197,124,21,217                      // vunpckhps     %ymm1,%ymm0,%ymm11
  .byte  197,108,20,203                      // vunpcklps     %ymm3,%ymm2,%ymm9
  .byte  197,108,21,227                      // vunpckhps     %ymm3,%ymm2,%ymm12
  .byte  196,65,61,20,209                    // vunpcklpd     %ymm9,%ymm8,%ymm10
  .byte  196,65,61,21,201                    // vunpckhpd     %ymm9,%ymm8,%ymm9
  .byte  196,65,37,20,196                    // vunpcklpd     %ymm12,%ymm11,%ymm8
  .byte  196,65,37,21,220                    // vunpckhpd     %ymm12,%ymm11,%ymm11
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,55                              // jne           17267 <_sk_store_f32_avx+0x7f>
  .byte  196,67,45,24,225,1                  // vinsertf128   $0x1,%xmm9,%ymm10,%ymm12
  .byte  196,67,61,24,235,1                  // vinsertf128   $0x1,%xmm11,%ymm8,%ymm13
  .byte  196,67,45,6,201,49                  // vperm2f128    $0x31,%ymm9,%ymm10,%ymm9
  .byte  196,67,61,6,195,49                  // vperm2f128    $0x31,%ymm11,%ymm8,%ymm8
  .byte  196,65,124,17,36,128                // vmovups       %ymm12,(%r8,%rax,4)
  .byte  196,65,124,17,108,128,32            // vmovups       %ymm13,0x20(%r8,%rax,4)
  .byte  196,65,125,17,76,128,64             // vmovupd       %ymm9,0x40(%r8,%rax,4)
  .byte  196,65,125,17,68,128,96             // vmovupd       %ymm8,0x60(%r8,%rax,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,121,17,20,128                // vmovupd       %xmm10,(%r8,%rax,4)
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,240                             // je            17263 <_sk_store_f32_avx+0x7b>
  .byte  196,65,121,17,76,128,16             // vmovupd       %xmm9,0x10(%r8,%rax,4)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,227                             // jb            17263 <_sk_store_f32_avx+0x7b>
  .byte  196,65,121,17,68,128,32             // vmovupd       %xmm8,0x20(%r8,%rax,4)
  .byte  116,218                             // je            17263 <_sk_store_f32_avx+0x7b>
  .byte  196,65,121,17,92,128,48             // vmovupd       %xmm11,0x30(%r8,%rax,4)
  .byte  72,131,255,5                        // cmp           $0x5,%rdi
  .byte  114,205                             // jb            17263 <_sk_store_f32_avx+0x7b>
  .byte  196,67,125,25,84,128,64,1           // vextractf128  $0x1,%ymm10,0x40(%r8,%rax,4)
  .byte  116,195                             // je            17263 <_sk_store_f32_avx+0x7b>
  .byte  196,67,125,25,76,128,80,1           // vextractf128  $0x1,%ymm9,0x50(%r8,%rax,4)
  .byte  72,131,255,7                        // cmp           $0x7,%rdi
  .byte  114,181                             // jb            17263 <_sk_store_f32_avx+0x7b>
  .byte  196,67,125,25,68,128,96,1           // vextractf128  $0x1,%ymm8,0x60(%r8,%rax,4)
  .byte  235,171                             // jmp           17263 <_sk_store_f32_avx+0x7b>

HIDDEN _sk_repeat_x_avx
.globl _sk_repeat_x_avx
FUNCTION(_sk_repeat_x_avx)
_sk_repeat_x_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,4                  // vbroadcastss  0x4(%rax),%ymm8
  .byte  197,60,89,192                       // vmulps        %ymm0,%ymm8,%ymm8
  .byte  196,67,125,8,192,1                  // vroundps      $0x1,%ymm8,%ymm8
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  196,193,124,92,192                  // vsubps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_repeat_y_avx
.globl _sk_repeat_y_avx
FUNCTION(_sk_repeat_y_avx)
_sk_repeat_y_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,4                  // vbroadcastss  0x4(%rax),%ymm8
  .byte  197,60,89,193                       // vmulps        %ymm1,%ymm8,%ymm8
  .byte  196,67,125,8,192,1                  // vroundps      $0x1,%ymm8,%ymm8
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  196,193,116,92,200                  // vsubps        %ymm8,%ymm1,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_x_avx
.globl _sk_mirror_x_avx
FUNCTION(_sk_mirror_x_avx)
_sk_mirror_x_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,122,16,0                        // vmovss        (%rax),%xmm8
  .byte  197,122,16,72,4                     // vmovss        0x4(%rax),%xmm9
  .byte  196,67,121,4,208,0                  // vpermilps     $0x0,%xmm8,%xmm10
  .byte  196,67,45,24,210,1                  // vinsertf128   $0x1,%xmm10,%ymm10,%ymm10
  .byte  196,65,124,92,218                   // vsubps        %ymm10,%ymm0,%ymm11
  .byte  196,193,58,88,192                   // vaddss        %xmm8,%xmm8,%xmm0
  .byte  196,227,121,4,192,0                 // vpermilps     $0x0,%xmm0,%xmm0
  .byte  196,99,125,24,192,1                 // vinsertf128   $0x1,%xmm0,%ymm0,%ymm8
  .byte  197,178,89,5,221,46,2,0             // vmulss        0x22edd(%rip),%xmm9,%xmm0        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,227,121,4,192,0                 // vpermilps     $0x0,%xmm0,%xmm0
  .byte  196,227,125,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm0,%ymm0
  .byte  197,164,89,192                      // vmulps        %ymm0,%ymm11,%ymm0
  .byte  196,227,125,8,192,1                 // vroundps      $0x1,%ymm0,%ymm0
  .byte  196,193,124,89,192                  // vmulps        %ymm8,%ymm0,%ymm0
  .byte  197,164,92,192                      // vsubps        %ymm0,%ymm11,%ymm0
  .byte  196,193,124,92,194                  // vsubps        %ymm10,%ymm0,%ymm0
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,92,192                       // vsubps        %ymm0,%ymm8,%ymm8
  .byte  197,188,84,192                      // vandps        %ymm0,%ymm8,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_y_avx
.globl _sk_mirror_y_avx
FUNCTION(_sk_mirror_y_avx)
_sk_mirror_y_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,122,16,0                        // vmovss        (%rax),%xmm8
  .byte  197,122,16,72,4                     // vmovss        0x4(%rax),%xmm9
  .byte  196,67,121,4,208,0                  // vpermilps     $0x0,%xmm8,%xmm10
  .byte  196,67,45,24,210,1                  // vinsertf128   $0x1,%xmm10,%ymm10,%ymm10
  .byte  196,65,116,92,218                   // vsubps        %ymm10,%ymm1,%ymm11
  .byte  196,193,58,88,200                   // vaddss        %xmm8,%xmm8,%xmm1
  .byte  196,227,121,4,201,0                 // vpermilps     $0x0,%xmm1,%xmm1
  .byte  196,99,117,24,193,1                 // vinsertf128   $0x1,%xmm1,%ymm1,%ymm8
  .byte  197,178,89,13,115,46,2,0            // vmulss        0x22e73(%rip),%xmm9,%xmm1        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,227,121,4,201,0                 // vpermilps     $0x0,%xmm1,%xmm1
  .byte  196,227,117,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm1,%ymm1
  .byte  197,164,89,201                      // vmulps        %ymm1,%ymm11,%ymm1
  .byte  196,227,125,8,201,1                 // vroundps      $0x1,%ymm1,%ymm1
  .byte  196,193,116,89,200                  // vmulps        %ymm8,%ymm1,%ymm1
  .byte  197,164,92,201                      // vsubps        %ymm1,%ymm11,%ymm1
  .byte  196,193,116,92,202                  // vsubps        %ymm10,%ymm1,%ymm1
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,92,193                       // vsubps        %ymm1,%ymm8,%ymm8
  .byte  197,188,84,201                      // vandps        %ymm1,%ymm8,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_x_1_avx
.globl _sk_clamp_x_1_avx
FUNCTION(_sk_clamp_x_1_avx)
_sk_clamp_x_1_avx:
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  196,98,125,24,5,48,46,2,0           // vbroadcastss  0x22e30(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_repeat_x_1_avx
.globl _sk_repeat_x_1_avx
FUNCTION(_sk_repeat_x_1_avx)
_sk_repeat_x_1_avx:
  .byte  196,99,125,8,192,1                  // vroundps      $0x1,%ymm0,%ymm8
  .byte  196,193,124,92,192                  // vsubps        %ymm8,%ymm0,%ymm0
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  196,98,125,24,5,10,46,2,0           // vbroadcastss  0x22e0a(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_x_1_avx
.globl _sk_mirror_x_1_avx
FUNCTION(_sk_mirror_x_1_avx)
_sk_mirror_x_1_avx:
  .byte  196,98,125,24,5,16,46,2,0           // vbroadcastss  0x22e10(%rip),%ymm8        # 3a230 <_sk_srcover_bgra_8888_sse2_lowp+0x2c8>
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,24,13,230,45,2,0         // vbroadcastss  0x22de6(%rip),%ymm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,124,89,201                   // vmulps        %ymm9,%ymm0,%ymm9
  .byte  196,67,125,8,201,1                  // vroundps      $0x1,%ymm9,%ymm9
  .byte  196,65,52,88,201                    // vaddps        %ymm9,%ymm9,%ymm9
  .byte  196,193,124,92,193                  // vsubps        %ymm9,%ymm0,%ymm0
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,92,200                       // vsubps        %ymm0,%ymm8,%ymm9
  .byte  197,180,84,192                      // vandps        %ymm0,%ymm9,%ymm0
  .byte  197,188,95,192                      // vmaxps        %ymm0,%ymm8,%ymm0
  .byte  196,98,125,24,5,182,45,2,0          // vbroadcastss  0x22db6(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_luminance_to_alpha_avx
.globl _sk_luminance_to_alpha_avx
FUNCTION(_sk_luminance_to_alpha_avx)
_sk_luminance_to_alpha_avx:
  .byte  196,226,125,24,29,200,46,2,0        // vbroadcastss  0x22ec8(%rip),%ymm3        # 3a33c <_sk_srcover_bgra_8888_sse2_lowp+0x3d4>
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  196,226,125,24,29,183,46,2,0        // vbroadcastss  0x22eb7(%rip),%ymm3        # 3a338 <_sk_srcover_bgra_8888_sse2_lowp+0x3d0>
  .byte  197,244,89,203                      // vmulps        %ymm3,%ymm1,%ymm1
  .byte  197,252,88,193                      // vaddps        %ymm1,%ymm0,%ymm0
  .byte  196,226,125,24,13,174,46,2,0        // vbroadcastss  0x22eae(%rip),%ymm1        # 3a340 <_sk_srcover_bgra_8888_sse2_lowp+0x3d8>
  .byte  197,236,89,201                      // vmulps        %ymm1,%ymm2,%ymm1
  .byte  197,252,88,217                      // vaddps        %ymm1,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_translate_avx
.globl _sk_matrix_translate_avx
FUNCTION(_sk_matrix_translate_avx)
_sk_matrix_translate_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  197,188,88,192                      // vaddps        %ymm0,%ymm8,%ymm0
  .byte  196,98,125,24,64,4                  // vbroadcastss  0x4(%rax),%ymm8
  .byte  197,188,88,201                      // vaddps        %ymm1,%ymm8,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_scale_translate_avx
.globl _sk_matrix_scale_translate_avx
FUNCTION(_sk_matrix_scale_translate_avx)
_sk_matrix_scale_translate_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  196,98,125,24,72,8                  // vbroadcastss  0x8(%rax),%ymm9
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  196,193,124,88,193                  // vaddps        %ymm9,%ymm0,%ymm0
  .byte  196,98,125,24,64,4                  // vbroadcastss  0x4(%rax),%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  197,188,89,201                      // vmulps        %ymm1,%ymm8,%ymm1
  .byte  196,193,116,88,201                  // vaddps        %ymm9,%ymm1,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_2x3_avx
.globl _sk_matrix_2x3_avx
FUNCTION(_sk_matrix_2x3_avx)
_sk_matrix_2x3_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  196,98,125,24,72,8                  // vbroadcastss  0x8(%rax),%ymm9
  .byte  196,98,125,24,80,16                 // vbroadcastss  0x10(%rax),%ymm10
  .byte  197,52,89,201                       // vmulps        %ymm1,%ymm9,%ymm9
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  197,60,89,192                       // vmulps        %ymm0,%ymm8,%ymm8
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  196,98,125,24,72,4                  // vbroadcastss  0x4(%rax),%ymm9
  .byte  196,98,125,24,80,12                 // vbroadcastss  0xc(%rax),%ymm10
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  197,172,89,201                      // vmulps        %ymm1,%ymm10,%ymm1
  .byte  196,193,116,88,203                  // vaddps        %ymm11,%ymm1,%ymm1
  .byte  197,180,89,192                      // vmulps        %ymm0,%ymm9,%ymm0
  .byte  197,252,88,201                      // vaddps        %ymm1,%ymm0,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_3x4_avx
.globl _sk_matrix_3x4_avx
FUNCTION(_sk_matrix_3x4_avx)
_sk_matrix_3x4_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,98,125,24,80,24                 // vbroadcastss  0x18(%rax),%ymm10
  .byte  196,98,125,24,88,36                 // vbroadcastss  0x24(%rax),%ymm11
  .byte  197,44,89,210                       // vmulps        %ymm2,%ymm10,%ymm10
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  197,52,89,201                       // vmulps        %ymm1,%ymm9,%ymm9
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  197,60,89,192                       // vmulps        %ymm0,%ymm8,%ymm8
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  196,98,125,24,72,4                  // vbroadcastss  0x4(%rax),%ymm9
  .byte  196,98,125,24,80,16                 // vbroadcastss  0x10(%rax),%ymm10
  .byte  196,98,125,24,88,28                 // vbroadcastss  0x1c(%rax),%ymm11
  .byte  196,98,125,24,96,40                 // vbroadcastss  0x28(%rax),%ymm12
  .byte  197,36,89,218                       // vmulps        %ymm2,%ymm11,%ymm11
  .byte  196,65,36,88,220                    // vaddps        %ymm12,%ymm11,%ymm11
  .byte  197,44,89,209                       // vmulps        %ymm1,%ymm10,%ymm10
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  197,52,89,200                       // vmulps        %ymm0,%ymm9,%ymm9
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,80,8                  // vbroadcastss  0x8(%rax),%ymm10
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  196,98,125,24,96,32                 // vbroadcastss  0x20(%rax),%ymm12
  .byte  196,98,125,24,104,44                // vbroadcastss  0x2c(%rax),%ymm13
  .byte  197,156,89,210                      // vmulps        %ymm2,%ymm12,%ymm2
  .byte  196,193,108,88,213                  // vaddps        %ymm13,%ymm2,%ymm2
  .byte  197,164,89,201                      // vmulps        %ymm1,%ymm11,%ymm1
  .byte  197,244,88,202                      // vaddps        %ymm2,%ymm1,%ymm1
  .byte  197,172,89,192                      // vmulps        %ymm0,%ymm10,%ymm0
  .byte  197,252,88,209                      // vaddps        %ymm1,%ymm0,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,124,41,201                      // vmovaps       %ymm9,%ymm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_4x5_avx
.globl _sk_matrix_4x5_avx
FUNCTION(_sk_matrix_4x5_avx)
_sk_matrix_4x5_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  196,98,125,24,72,16                 // vbroadcastss  0x10(%rax),%ymm9
  .byte  196,98,125,24,80,32                 // vbroadcastss  0x20(%rax),%ymm10
  .byte  196,98,125,24,88,48                 // vbroadcastss  0x30(%rax),%ymm11
  .byte  196,98,125,24,96,64                 // vbroadcastss  0x40(%rax),%ymm12
  .byte  197,36,89,219                       // vmulps        %ymm3,%ymm11,%ymm11
  .byte  196,65,36,88,220                    // vaddps        %ymm12,%ymm11,%ymm11
  .byte  197,44,89,210                       // vmulps        %ymm2,%ymm10,%ymm10
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  197,52,89,201                       // vmulps        %ymm1,%ymm9,%ymm9
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  197,60,89,192                       // vmulps        %ymm0,%ymm8,%ymm8
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  196,98,125,24,72,4                  // vbroadcastss  0x4(%rax),%ymm9
  .byte  196,98,125,24,80,20                 // vbroadcastss  0x14(%rax),%ymm10
  .byte  196,98,125,24,88,36                 // vbroadcastss  0x24(%rax),%ymm11
  .byte  196,98,125,24,96,52                 // vbroadcastss  0x34(%rax),%ymm12
  .byte  196,98,125,24,104,68                // vbroadcastss  0x44(%rax),%ymm13
  .byte  197,28,89,227                       // vmulps        %ymm3,%ymm12,%ymm12
  .byte  196,65,28,88,229                    // vaddps        %ymm13,%ymm12,%ymm12
  .byte  197,36,89,218                       // vmulps        %ymm2,%ymm11,%ymm11
  .byte  196,65,36,88,220                    // vaddps        %ymm12,%ymm11,%ymm11
  .byte  197,44,89,209                       // vmulps        %ymm1,%ymm10,%ymm10
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  197,52,89,200                       // vmulps        %ymm0,%ymm9,%ymm9
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,80,8                  // vbroadcastss  0x8(%rax),%ymm10
  .byte  196,98,125,24,88,24                 // vbroadcastss  0x18(%rax),%ymm11
  .byte  196,98,125,24,96,40                 // vbroadcastss  0x28(%rax),%ymm12
  .byte  196,98,125,24,104,56                // vbroadcastss  0x38(%rax),%ymm13
  .byte  196,98,125,24,112,72                // vbroadcastss  0x48(%rax),%ymm14
  .byte  197,20,89,235                       // vmulps        %ymm3,%ymm13,%ymm13
  .byte  196,65,20,88,238                    // vaddps        %ymm14,%ymm13,%ymm13
  .byte  197,28,89,226                       // vmulps        %ymm2,%ymm12,%ymm12
  .byte  196,65,28,88,229                    // vaddps        %ymm13,%ymm12,%ymm12
  .byte  197,36,89,217                       // vmulps        %ymm1,%ymm11,%ymm11
  .byte  196,65,36,88,220                    // vaddps        %ymm12,%ymm11,%ymm11
  .byte  197,44,89,208                       // vmulps        %ymm0,%ymm10,%ymm10
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,98,125,24,88,12                 // vbroadcastss  0xc(%rax),%ymm11
  .byte  196,98,125,24,96,28                 // vbroadcastss  0x1c(%rax),%ymm12
  .byte  196,98,125,24,104,44                // vbroadcastss  0x2c(%rax),%ymm13
  .byte  196,98,125,24,112,60                // vbroadcastss  0x3c(%rax),%ymm14
  .byte  196,98,125,24,120,76                // vbroadcastss  0x4c(%rax),%ymm15
  .byte  197,140,89,219                      // vmulps        %ymm3,%ymm14,%ymm3
  .byte  196,193,100,88,223                  // vaddps        %ymm15,%ymm3,%ymm3
  .byte  197,148,89,210                      // vmulps        %ymm2,%ymm13,%ymm2
  .byte  197,236,88,211                      // vaddps        %ymm3,%ymm2,%ymm2
  .byte  197,156,89,201                      // vmulps        %ymm1,%ymm12,%ymm1
  .byte  197,244,88,202                      // vaddps        %ymm2,%ymm1,%ymm1
  .byte  197,164,89,192                      // vmulps        %ymm0,%ymm11,%ymm0
  .byte  197,252,88,217                      // vaddps        %ymm1,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,124,41,201                      // vmovaps       %ymm9,%ymm1
  .byte  197,124,41,210                      // vmovaps       %ymm10,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_4x3_avx
.globl _sk_matrix_4x3_avx
FUNCTION(_sk_matrix_4x3_avx)
_sk_matrix_4x3_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,16                   // vbroadcastss  (%rax),%ymm2
  .byte  196,226,125,24,88,16                // vbroadcastss  0x10(%rax),%ymm3
  .byte  196,98,125,24,64,32                 // vbroadcastss  0x20(%rax),%ymm8
  .byte  197,228,89,217                      // vmulps        %ymm1,%ymm3,%ymm3
  .byte  196,193,100,88,216                  // vaddps        %ymm8,%ymm3,%ymm3
  .byte  197,236,89,208                      // vmulps        %ymm0,%ymm2,%ymm2
  .byte  197,108,88,195                      // vaddps        %ymm3,%ymm2,%ymm8
  .byte  196,226,125,24,80,4                 // vbroadcastss  0x4(%rax),%ymm2
  .byte  196,226,125,24,88,20                // vbroadcastss  0x14(%rax),%ymm3
  .byte  196,98,125,24,72,36                 // vbroadcastss  0x24(%rax),%ymm9
  .byte  197,228,89,217                      // vmulps        %ymm1,%ymm3,%ymm3
  .byte  196,193,100,88,217                  // vaddps        %ymm9,%ymm3,%ymm3
  .byte  197,236,89,208                      // vmulps        %ymm0,%ymm2,%ymm2
  .byte  197,108,88,203                      // vaddps        %ymm3,%ymm2,%ymm9
  .byte  196,226,125,24,80,8                 // vbroadcastss  0x8(%rax),%ymm2
  .byte  196,226,125,24,88,24                // vbroadcastss  0x18(%rax),%ymm3
  .byte  196,98,125,24,80,40                 // vbroadcastss  0x28(%rax),%ymm10
  .byte  197,228,89,217                      // vmulps        %ymm1,%ymm3,%ymm3
  .byte  196,193,100,88,218                  // vaddps        %ymm10,%ymm3,%ymm3
  .byte  197,236,89,208                      // vmulps        %ymm0,%ymm2,%ymm2
  .byte  197,236,88,211                      // vaddps        %ymm3,%ymm2,%ymm2
  .byte  196,226,125,24,88,12                // vbroadcastss  0xc(%rax),%ymm3
  .byte  196,98,125,24,80,28                 // vbroadcastss  0x1c(%rax),%ymm10
  .byte  196,98,125,24,88,44                 // vbroadcastss  0x2c(%rax),%ymm11
  .byte  197,172,89,201                      // vmulps        %ymm1,%ymm10,%ymm1
  .byte  196,193,116,88,203                  // vaddps        %ymm11,%ymm1,%ymm1
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,252,88,217                      // vaddps        %ymm1,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,124,41,201                      // vmovaps       %ymm9,%ymm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_perspective_avx
.globl _sk_matrix_perspective_avx
FUNCTION(_sk_matrix_perspective_avx)
_sk_matrix_perspective_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  196,98,125,24,72,4                  // vbroadcastss  0x4(%rax),%ymm9
  .byte  196,98,125,24,80,8                  // vbroadcastss  0x8(%rax),%ymm10
  .byte  197,52,89,201                       // vmulps        %ymm1,%ymm9,%ymm9
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  197,60,89,192                       // vmulps        %ymm0,%ymm8,%ymm8
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,98,125,24,80,16                 // vbroadcastss  0x10(%rax),%ymm10
  .byte  196,98,125,24,88,20                 // vbroadcastss  0x14(%rax),%ymm11
  .byte  197,44,89,209                       // vmulps        %ymm1,%ymm10,%ymm10
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  197,52,89,200                       // vmulps        %ymm0,%ymm9,%ymm9
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,80,24                 // vbroadcastss  0x18(%rax),%ymm10
  .byte  196,98,125,24,88,28                 // vbroadcastss  0x1c(%rax),%ymm11
  .byte  196,98,125,24,96,32                 // vbroadcastss  0x20(%rax),%ymm12
  .byte  197,164,89,201                      // vmulps        %ymm1,%ymm11,%ymm1
  .byte  196,193,116,88,204                  // vaddps        %ymm12,%ymm1,%ymm1
  .byte  197,172,89,192                      // vmulps        %ymm0,%ymm10,%ymm0
  .byte  197,252,88,193                      // vaddps        %ymm1,%ymm0,%ymm0
  .byte  197,252,83,200                      // vrcpps        %ymm0,%ymm1
  .byte  197,188,89,193                      // vmulps        %ymm1,%ymm8,%ymm0
  .byte  197,180,89,201                      // vmulps        %ymm1,%ymm9,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_gradient_avx
.globl _sk_evenly_spaced_gradient_avx
FUNCTION(_sk_evenly_spaced_gradient_avx)
_sk_evenly_spaced_gradient_avx:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  197,252,17,124,36,216               // vmovups       %ymm7,-0x28(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,139,24                           // mov           (%rax),%rbx
  .byte  72,139,104,8                        // mov           0x8(%rax),%rbp
  .byte  72,255,203                          // dec           %rbx
  .byte  120,7                               // js            17836 <_sk_evenly_spaced_gradient_avx+0x25>
  .byte  196,225,242,42,203                  // vcvtsi2ss     %rbx,%xmm1,%xmm1
  .byte  235,21                              // jmp           1784b <_sk_evenly_spaced_gradient_avx+0x3a>
  .byte  73,137,216                          // mov           %rbx,%r8
  .byte  73,209,232                          // shr           %r8
  .byte  131,227,1                           // and           $0x1,%ebx
  .byte  76,9,195                            // or            %r8,%rbx
  .byte  196,225,242,42,203                  // vcvtsi2ss     %rbx,%xmm1,%xmm1
  .byte  197,242,88,201                      // vaddss        %xmm1,%xmm1,%xmm1
  .byte  196,227,121,4,201,0                 // vpermilps     $0x0,%xmm1,%xmm1
  .byte  196,227,117,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm1,%ymm1
  .byte  197,244,89,200                      // vmulps        %ymm0,%ymm1,%ymm1
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  196,195,249,22,200,1                // vpextrq       $0x1,%xmm1,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,193,249,126,202                 // vmovq         %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,25,201,1                // vextractf128  $0x1,%ymm1,%xmm1
  .byte  196,195,249,22,207,1                // vpextrq       $0x1,%xmm1,%r15
  .byte  69,137,254                          // mov           %r15d,%r14d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  196,193,249,126,205                 // vmovq         %xmm1,%r13
  .byte  69,137,236                          // mov           %r13d,%r12d
  .byte  73,193,237,32                       // shr           $0x20,%r13
  .byte  196,161,122,16,76,165,0             // vmovss        0x0(%rbp,%r12,4),%xmm1
  .byte  196,163,113,33,76,173,0,16          // vinsertps     $0x10,0x0(%rbp,%r13,4),%xmm1,%xmm1
  .byte  196,161,122,16,84,181,0             // vmovss        0x0(%rbp,%r14,4),%xmm2
  .byte  196,33,122,16,68,189,0              // vmovss        0x0(%rbp,%r15,4),%xmm8
  .byte  196,161,122,16,92,157,0             // vmovss        0x0(%rbp,%r11,4),%xmm3
  .byte  196,35,97,33,76,149,0,16            // vinsertps     $0x10,0x0(%rbp,%r10,4),%xmm3,%xmm9
  .byte  196,161,122,16,124,141,0            // vmovss        0x0(%rbp,%r9,4),%xmm7
  .byte  196,33,122,16,92,133,0              // vmovss        0x0(%rbp,%r8,4),%xmm11
  .byte  196,99,113,33,226,32                // vinsertps     $0x20,%xmm2,%xmm1,%xmm12
  .byte  72,139,88,40                        // mov           0x28(%rax),%rbx
  .byte  196,161,122,16,20,163               // vmovss        (%rbx,%r12,4),%xmm2
  .byte  196,35,105,33,44,171,16             // vinsertps     $0x10,(%rbx,%r13,4),%xmm2,%xmm13
  .byte  196,161,122,16,28,179               // vmovss        (%rbx,%r14,4),%xmm3
  .byte  196,161,122,16,12,187               // vmovss        (%rbx,%r15,4),%xmm1
  .byte  196,161,122,16,20,155               // vmovss        (%rbx,%r11,4),%xmm2
  .byte  196,35,105,33,52,147,16             // vinsertps     $0x10,(%rbx,%r10,4),%xmm2,%xmm14
  .byte  196,33,122,16,60,139                // vmovss        (%rbx,%r9,4),%xmm15
  .byte  196,33,122,16,20,131                // vmovss        (%rbx,%r8,4),%xmm10
  .byte  196,67,25,33,192,48                 // vinsertps     $0x30,%xmm8,%xmm12,%xmm8
  .byte  196,227,49,33,215,32                // vinsertps     $0x20,%xmm7,%xmm9,%xmm2
  .byte  196,195,105,33,211,48               // vinsertps     $0x30,%xmm11,%xmm2,%xmm2
  .byte  196,67,109,24,192,1                 // vinsertf128   $0x1,%xmm8,%ymm2,%ymm8
  .byte  196,227,17,33,211,32                // vinsertps     $0x20,%xmm3,%xmm13,%xmm2
  .byte  196,99,105,33,201,48                // vinsertps     $0x30,%xmm1,%xmm2,%xmm9
  .byte  72,139,88,16                        // mov           0x10(%rax),%rbx
  .byte  196,161,122,16,20,163               // vmovss        (%rbx,%r12,4),%xmm2
  .byte  196,35,105,33,28,171,16             // vinsertps     $0x10,(%rbx,%r13,4),%xmm2,%xmm11
  .byte  196,33,122,16,36,179                // vmovss        (%rbx,%r14,4),%xmm12
  .byte  196,161,122,16,12,187               // vmovss        (%rbx,%r15,4),%xmm1
  .byte  196,161,122,16,60,155               // vmovss        (%rbx,%r11,4),%xmm7
  .byte  196,163,65,33,60,147,16             // vinsertps     $0x10,(%rbx,%r10,4),%xmm7,%xmm7
  .byte  196,161,122,16,28,139               // vmovss        (%rbx,%r9,4),%xmm3
  .byte  196,33,122,16,44,131                // vmovss        (%rbx,%r8,4),%xmm13
  .byte  196,195,9,33,215,32                 // vinsertps     $0x20,%xmm15,%xmm14,%xmm2
  .byte  196,195,105,33,210,48               // vinsertps     $0x30,%xmm10,%xmm2,%xmm2
  .byte  196,67,109,24,241,1                 // vinsertf128   $0x1,%xmm9,%ymm2,%ymm14
  .byte  196,195,33,33,212,32                // vinsertps     $0x20,%xmm12,%xmm11,%xmm2
  .byte  196,99,105,33,201,48                // vinsertps     $0x30,%xmm1,%xmm2,%xmm9
  .byte  196,99,65,33,211,32                 // vinsertps     $0x20,%xmm3,%xmm7,%xmm10
  .byte  72,139,88,48                        // mov           0x30(%rax),%rbx
  .byte  196,161,122,16,28,163               // vmovss        (%rbx,%r12,4),%xmm3
  .byte  196,35,97,33,28,171,16              // vinsertps     $0x10,(%rbx,%r13,4),%xmm3,%xmm11
  .byte  196,33,122,16,60,179                // vmovss        (%rbx,%r14,4),%xmm15
  .byte  196,33,122,16,36,187                // vmovss        (%rbx,%r15,4),%xmm12
  .byte  196,161,122,16,20,155               // vmovss        (%rbx,%r11,4),%xmm2
  .byte  196,163,105,33,20,147,16            // vinsertps     $0x10,(%rbx,%r10,4),%xmm2,%xmm2
  .byte  196,161,122,16,60,139               // vmovss        (%rbx,%r9,4),%xmm7
  .byte  196,161,122,16,28,131               // vmovss        (%rbx,%r8,4),%xmm3
  .byte  196,67,41,33,213,48                 // vinsertps     $0x30,%xmm13,%xmm10,%xmm10
  .byte  196,67,45,24,233,1                  // vinsertf128   $0x1,%xmm9,%ymm10,%ymm13
  .byte  196,195,33,33,207,32                // vinsertps     $0x20,%xmm15,%xmm11,%xmm1
  .byte  196,67,113,33,204,48                // vinsertps     $0x30,%xmm12,%xmm1,%xmm9
  .byte  196,227,105,33,215,32               // vinsertps     $0x20,%xmm7,%xmm2,%xmm2
  .byte  196,99,105,33,211,48                // vinsertps     $0x30,%xmm3,%xmm2,%xmm10
  .byte  72,139,88,24                        // mov           0x18(%rax),%rbx
  .byte  196,161,122,16,28,163               // vmovss        (%rbx,%r12,4),%xmm3
  .byte  196,35,97,33,28,171,16              // vinsertps     $0x10,(%rbx,%r13,4),%xmm3,%xmm11
  .byte  196,33,122,16,36,179                // vmovss        (%rbx,%r14,4),%xmm12
  .byte  196,33,122,16,60,187                // vmovss        (%rbx,%r15,4),%xmm15
  .byte  196,161,122,16,20,155               // vmovss        (%rbx,%r11,4),%xmm2
  .byte  196,163,105,33,20,147,16            // vinsertps     $0x10,(%rbx,%r10,4),%xmm2,%xmm2
  .byte  196,161,122,16,28,139               // vmovss        (%rbx,%r9,4),%xmm3
  .byte  196,161,122,16,60,131               // vmovss        (%rbx,%r8,4),%xmm7
  .byte  196,67,45,24,201,1                  // vinsertf128   $0x1,%xmm9,%ymm10,%ymm9
  .byte  196,195,33,33,204,32                // vinsertps     $0x20,%xmm12,%xmm11,%xmm1
  .byte  196,195,113,33,207,48               // vinsertps     $0x30,%xmm15,%xmm1,%xmm1
  .byte  196,227,105,33,211,32               // vinsertps     $0x20,%xmm3,%xmm2,%xmm2
  .byte  196,227,105,33,215,48               // vinsertps     $0x30,%xmm7,%xmm2,%xmm2
  .byte  196,99,109,24,209,1                 // vinsertf128   $0x1,%xmm1,%ymm2,%ymm10
  .byte  72,139,88,56                        // mov           0x38(%rax),%rbx
  .byte  196,161,122,16,12,163               // vmovss        (%rbx,%r12,4),%xmm1
  .byte  196,35,113,33,28,171,16             // vinsertps     $0x10,(%rbx,%r13,4),%xmm1,%xmm11
  .byte  196,33,122,16,36,179                // vmovss        (%rbx,%r14,4),%xmm12
  .byte  196,33,122,16,60,187                // vmovss        (%rbx,%r15,4),%xmm15
  .byte  196,161,122,16,60,155               // vmovss        (%rbx,%r11,4),%xmm7
  .byte  196,163,65,33,60,147,16             // vinsertps     $0x10,(%rbx,%r10,4),%xmm7,%xmm7
  .byte  196,161,122,16,12,139               // vmovss        (%rbx,%r9,4),%xmm1
  .byte  196,161,122,16,20,131               // vmovss        (%rbx,%r8,4),%xmm2
  .byte  196,195,33,33,220,32                // vinsertps     $0x20,%xmm12,%xmm11,%xmm3
  .byte  196,195,97,33,223,48                // vinsertps     $0x30,%xmm15,%xmm3,%xmm3
  .byte  196,227,65,33,201,32                // vinsertps     $0x20,%xmm1,%xmm7,%xmm1
  .byte  196,227,113,33,202,48               // vinsertps     $0x30,%xmm2,%xmm1,%xmm1
  .byte  196,99,117,24,219,1                 // vinsertf128   $0x1,%xmm3,%ymm1,%ymm11
  .byte  72,139,88,32                        // mov           0x20(%rax),%rbx
  .byte  196,161,122,16,12,163               // vmovss        (%rbx,%r12,4),%xmm1
  .byte  196,163,113,33,12,171,16            // vinsertps     $0x10,(%rbx,%r13,4),%xmm1,%xmm1
  .byte  196,161,122,16,20,179               // vmovss        (%rbx,%r14,4),%xmm2
  .byte  196,227,113,33,202,32               // vinsertps     $0x20,%xmm2,%xmm1,%xmm1
  .byte  196,161,122,16,20,187               // vmovss        (%rbx,%r15,4),%xmm2
  .byte  196,161,122,16,28,155               // vmovss        (%rbx,%r11,4),%xmm3
  .byte  196,35,97,33,36,147,16              // vinsertps     $0x10,(%rbx,%r10,4),%xmm3,%xmm12
  .byte  196,161,122,16,60,139               // vmovss        (%rbx,%r9,4),%xmm7
  .byte  196,161,122,16,28,131               // vmovss        (%rbx,%r8,4),%xmm3
  .byte  196,99,113,33,250,48                // vinsertps     $0x30,%xmm2,%xmm1,%xmm15
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  196,161,122,16,20,160               // vmovss        (%rax,%r12,4),%xmm2
  .byte  196,163,105,33,20,168,16            // vinsertps     $0x10,(%rax,%r13,4),%xmm2,%xmm2
  .byte  196,227,25,33,255,32                // vinsertps     $0x20,%xmm7,%xmm12,%xmm7
  .byte  196,161,122,16,12,176               // vmovss        (%rax,%r14,4),%xmm1
  .byte  196,227,65,33,219,48                // vinsertps     $0x30,%xmm3,%xmm7,%xmm3
  .byte  196,161,122,16,60,184               // vmovss        (%rax,%r15,4),%xmm7
  .byte  196,67,101,24,231,1                 // vinsertf128   $0x1,%xmm15,%ymm3,%ymm12
  .byte  196,161,122,16,28,152               // vmovss        (%rax,%r11,4),%xmm3
  .byte  196,163,97,33,28,144,16             // vinsertps     $0x10,(%rax,%r10,4),%xmm3,%xmm3
  .byte  196,227,105,33,201,32               // vinsertps     $0x20,%xmm1,%xmm2,%xmm1
  .byte  196,161,122,16,20,136               // vmovss        (%rax,%r9,4),%xmm2
  .byte  196,227,113,33,207,48               // vinsertps     $0x30,%xmm7,%xmm1,%xmm1
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,97,33,210,32                // vinsertps     $0x20,%xmm2,%xmm3,%xmm2
  .byte  196,227,105,33,215,48               // vinsertps     $0x30,%xmm7,%xmm2,%xmm2
  .byte  196,227,109,24,217,1                // vinsertf128   $0x1,%xmm1,%ymm2,%ymm3
  .byte  197,188,89,200                      // vmulps        %ymm0,%ymm8,%ymm1
  .byte  196,65,116,88,198                   // vaddps        %ymm14,%ymm1,%ymm8
  .byte  197,148,89,200                      // vmulps        %ymm0,%ymm13,%ymm1
  .byte  196,193,116,88,201                  // vaddps        %ymm9,%ymm1,%ymm1
  .byte  197,172,89,208                      // vmulps        %ymm0,%ymm10,%ymm2
  .byte  196,193,108,88,211                  // vaddps        %ymm11,%ymm2,%ymm2
  .byte  197,156,89,192                      // vmulps        %ymm0,%ymm12,%ymm0
  .byte  197,252,88,219                      // vaddps        %ymm3,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,252,16,124,36,216               // vmovups       -0x28(%rsp),%ymm7
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gradient_avx
.globl _sk_gradient_avx
FUNCTION(_sk_gradient_avx)
_sk_gradient_avx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  197,252,17,124,36,208               // vmovups       %ymm7,-0x30(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  73,131,248,2                        // cmp           $0x2,%r8
  .byte  114,81                              // jb            17be5 <_sk_gradient_avx+0x6f>
  .byte  72,139,88,72                        // mov           0x48(%rax),%rbx
  .byte  73,255,200                          // dec           %r8
  .byte  72,131,195,4                        // add           $0x4,%rbx
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  196,98,125,24,21,111,38,2,0         // vbroadcastss  0x2266f(%rip),%ymm10        # 3a21c <_sk_srcover_bgra_8888_sse2_lowp+0x2b4>
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  196,98,125,24,3                     // vbroadcastss  (%rbx),%ymm8
  .byte  197,60,194,192,2                    // vcmpleps      %ymm0,%ymm8,%ymm8
  .byte  196,67,53,74,194,128                // vblendvps     %ymm8,%ymm10,%ymm9,%ymm8
  .byte  196,99,125,25,194,1                 // vextractf128  $0x1,%ymm8,%xmm2
  .byte  196,227,125,25,203,1                // vextractf128  $0x1,%ymm1,%xmm3
  .byte  197,225,254,210                     // vpaddd        %xmm2,%xmm3,%xmm2
  .byte  196,193,113,254,200                 // vpaddd        %xmm8,%xmm1,%xmm1
  .byte  196,227,117,24,202,1                // vinsertf128   $0x1,%xmm2,%ymm1,%ymm1
  .byte  72,131,195,4                        // add           $0x4,%rbx
  .byte  73,255,200                          // dec           %r8
  .byte  117,204                             // jne           17bb1 <_sk_gradient_avx+0x3b>
  .byte  196,195,249,22,200,1                // vpextrq       $0x1,%xmm1,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,193,249,126,202                 // vmovq         %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,25,201,1                // vextractf128  $0x1,%ymm1,%xmm1
  .byte  196,195,249,22,207,1                // vpextrq       $0x1,%xmm1,%r15
  .byte  69,137,254                          // mov           %r15d,%r14d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  196,225,249,126,203                 // vmovq         %xmm1,%rbx
  .byte  65,137,220                          // mov           %ebx,%r12d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  76,139,104,8                        // mov           0x8(%rax),%r13
  .byte  196,129,122,16,76,165,0             // vmovss        0x0(%r13,%r12,4),%xmm1
  .byte  196,195,113,33,76,157,0,16          // vinsertps     $0x10,0x0(%r13,%rbx,4),%xmm1,%xmm1
  .byte  196,129,122,16,84,181,0             // vmovss        0x0(%r13,%r14,4),%xmm2
  .byte  196,1,122,16,68,189,0               // vmovss        0x0(%r13,%r15,4),%xmm8
  .byte  196,129,122,16,92,157,0             // vmovss        0x0(%r13,%r11,4),%xmm3
  .byte  196,3,97,33,76,149,0,16             // vinsertps     $0x10,0x0(%r13,%r10,4),%xmm3,%xmm9
  .byte  196,129,122,16,124,141,0            // vmovss        0x0(%r13,%r9,4),%xmm7
  .byte  196,1,122,16,92,133,0               // vmovss        0x0(%r13,%r8,4),%xmm11
  .byte  196,99,113,33,226,32                // vinsertps     $0x20,%xmm2,%xmm1,%xmm12
  .byte  76,139,104,40                       // mov           0x28(%rax),%r13
  .byte  196,129,122,16,84,165,0             // vmovss        0x0(%r13,%r12,4),%xmm2
  .byte  196,67,105,33,108,157,0,16          // vinsertps     $0x10,0x0(%r13,%rbx,4),%xmm2,%xmm13
  .byte  196,129,122,16,92,181,0             // vmovss        0x0(%r13,%r14,4),%xmm3
  .byte  196,129,122,16,76,189,0             // vmovss        0x0(%r13,%r15,4),%xmm1
  .byte  196,129,122,16,84,157,0             // vmovss        0x0(%r13,%r11,4),%xmm2
  .byte  196,3,105,33,116,149,0,16           // vinsertps     $0x10,0x0(%r13,%r10,4),%xmm2,%xmm14
  .byte  196,1,122,16,124,141,0              // vmovss        0x0(%r13,%r9,4),%xmm15
  .byte  196,1,122,16,84,133,0               // vmovss        0x0(%r13,%r8,4),%xmm10
  .byte  196,67,25,33,192,48                 // vinsertps     $0x30,%xmm8,%xmm12,%xmm8
  .byte  196,227,49,33,215,32                // vinsertps     $0x20,%xmm7,%xmm9,%xmm2
  .byte  196,195,105,33,211,48               // vinsertps     $0x30,%xmm11,%xmm2,%xmm2
  .byte  196,67,109,24,192,1                 // vinsertf128   $0x1,%xmm8,%ymm2,%ymm8
  .byte  196,227,17,33,211,32                // vinsertps     $0x20,%xmm3,%xmm13,%xmm2
  .byte  196,99,105,33,201,48                // vinsertps     $0x30,%xmm1,%xmm2,%xmm9
  .byte  76,139,104,16                       // mov           0x10(%rax),%r13
  .byte  196,129,122,16,84,165,0             // vmovss        0x0(%r13,%r12,4),%xmm2
  .byte  196,67,105,33,92,157,0,16           // vinsertps     $0x10,0x0(%r13,%rbx,4),%xmm2,%xmm11
  .byte  196,1,122,16,100,181,0              // vmovss        0x0(%r13,%r14,4),%xmm12
  .byte  196,129,122,16,76,189,0             // vmovss        0x0(%r13,%r15,4),%xmm1
  .byte  196,129,122,16,124,157,0            // vmovss        0x0(%r13,%r11,4),%xmm7
  .byte  196,131,65,33,124,149,0,16          // vinsertps     $0x10,0x0(%r13,%r10,4),%xmm7,%xmm7
  .byte  196,129,122,16,92,141,0             // vmovss        0x0(%r13,%r9,4),%xmm3
  .byte  196,1,122,16,108,133,0              // vmovss        0x0(%r13,%r8,4),%xmm13
  .byte  196,195,9,33,215,32                 // vinsertps     $0x20,%xmm15,%xmm14,%xmm2
  .byte  196,195,105,33,210,48               // vinsertps     $0x30,%xmm10,%xmm2,%xmm2
  .byte  196,67,109,24,241,1                 // vinsertf128   $0x1,%xmm9,%ymm2,%ymm14
  .byte  196,195,33,33,212,32                // vinsertps     $0x20,%xmm12,%xmm11,%xmm2
  .byte  196,99,105,33,201,48                // vinsertps     $0x30,%xmm1,%xmm2,%xmm9
  .byte  196,99,65,33,211,32                 // vinsertps     $0x20,%xmm3,%xmm7,%xmm10
  .byte  76,139,104,48                       // mov           0x30(%rax),%r13
  .byte  196,129,122,16,92,165,0             // vmovss        0x0(%r13,%r12,4),%xmm3
  .byte  196,67,97,33,92,157,0,16            // vinsertps     $0x10,0x0(%r13,%rbx,4),%xmm3,%xmm11
  .byte  196,1,122,16,124,181,0              // vmovss        0x0(%r13,%r14,4),%xmm15
  .byte  196,1,122,16,100,189,0              // vmovss        0x0(%r13,%r15,4),%xmm12
  .byte  196,129,122,16,84,157,0             // vmovss        0x0(%r13,%r11,4),%xmm2
  .byte  196,131,105,33,84,149,0,16          // vinsertps     $0x10,0x0(%r13,%r10,4),%xmm2,%xmm2
  .byte  196,129,122,16,124,141,0            // vmovss        0x0(%r13,%r9,4),%xmm7
  .byte  196,129,122,16,92,133,0             // vmovss        0x0(%r13,%r8,4),%xmm3
  .byte  196,67,41,33,213,48                 // vinsertps     $0x30,%xmm13,%xmm10,%xmm10
  .byte  196,67,45,24,233,1                  // vinsertf128   $0x1,%xmm9,%ymm10,%ymm13
  .byte  196,195,33,33,207,32                // vinsertps     $0x20,%xmm15,%xmm11,%xmm1
  .byte  196,67,113,33,204,48                // vinsertps     $0x30,%xmm12,%xmm1,%xmm9
  .byte  196,227,105,33,215,32               // vinsertps     $0x20,%xmm7,%xmm2,%xmm2
  .byte  196,99,105,33,211,48                // vinsertps     $0x30,%xmm3,%xmm2,%xmm10
  .byte  76,139,104,24                       // mov           0x18(%rax),%r13
  .byte  196,129,122,16,92,165,0             // vmovss        0x0(%r13,%r12,4),%xmm3
  .byte  196,67,97,33,92,157,0,16            // vinsertps     $0x10,0x0(%r13,%rbx,4),%xmm3,%xmm11
  .byte  196,1,122,16,100,181,0              // vmovss        0x0(%r13,%r14,4),%xmm12
  .byte  196,1,122,16,124,189,0              // vmovss        0x0(%r13,%r15,4),%xmm15
  .byte  196,129,122,16,84,157,0             // vmovss        0x0(%r13,%r11,4),%xmm2
  .byte  196,131,105,33,84,149,0,16          // vinsertps     $0x10,0x0(%r13,%r10,4),%xmm2,%xmm2
  .byte  196,129,122,16,92,141,0             // vmovss        0x0(%r13,%r9,4),%xmm3
  .byte  196,129,122,16,124,133,0            // vmovss        0x0(%r13,%r8,4),%xmm7
  .byte  196,67,45,24,201,1                  // vinsertf128   $0x1,%xmm9,%ymm10,%ymm9
  .byte  196,195,33,33,204,32                // vinsertps     $0x20,%xmm12,%xmm11,%xmm1
  .byte  196,195,113,33,207,48               // vinsertps     $0x30,%xmm15,%xmm1,%xmm1
  .byte  196,227,105,33,211,32               // vinsertps     $0x20,%xmm3,%xmm2,%xmm2
  .byte  196,227,105,33,215,48               // vinsertps     $0x30,%xmm7,%xmm2,%xmm2
  .byte  196,99,109,24,209,1                 // vinsertf128   $0x1,%xmm1,%ymm2,%ymm10
  .byte  76,139,104,56                       // mov           0x38(%rax),%r13
  .byte  196,129,122,16,76,165,0             // vmovss        0x0(%r13,%r12,4),%xmm1
  .byte  196,67,113,33,92,157,0,16           // vinsertps     $0x10,0x0(%r13,%rbx,4),%xmm1,%xmm11
  .byte  196,1,122,16,100,181,0              // vmovss        0x0(%r13,%r14,4),%xmm12
  .byte  196,1,122,16,124,189,0              // vmovss        0x0(%r13,%r15,4),%xmm15
  .byte  196,129,122,16,124,157,0            // vmovss        0x0(%r13,%r11,4),%xmm7
  .byte  196,131,65,33,124,149,0,16          // vinsertps     $0x10,0x0(%r13,%r10,4),%xmm7,%xmm7
  .byte  196,129,122,16,76,141,0             // vmovss        0x0(%r13,%r9,4),%xmm1
  .byte  196,129,122,16,84,133,0             // vmovss        0x0(%r13,%r8,4),%xmm2
  .byte  196,195,33,33,220,32                // vinsertps     $0x20,%xmm12,%xmm11,%xmm3
  .byte  196,195,97,33,223,48                // vinsertps     $0x30,%xmm15,%xmm3,%xmm3
  .byte  196,227,65,33,201,32                // vinsertps     $0x20,%xmm1,%xmm7,%xmm1
  .byte  196,227,113,33,202,48               // vinsertps     $0x30,%xmm2,%xmm1,%xmm1
  .byte  196,99,117,24,219,1                 // vinsertf128   $0x1,%xmm3,%ymm1,%ymm11
  .byte  76,139,104,32                       // mov           0x20(%rax),%r13
  .byte  196,129,122,16,76,165,0             // vmovss        0x0(%r13,%r12,4),%xmm1
  .byte  196,195,113,33,76,157,0,16          // vinsertps     $0x10,0x0(%r13,%rbx,4),%xmm1,%xmm1
  .byte  196,129,122,16,84,181,0             // vmovss        0x0(%r13,%r14,4),%xmm2
  .byte  196,227,113,33,202,32               // vinsertps     $0x20,%xmm2,%xmm1,%xmm1
  .byte  196,129,122,16,84,189,0             // vmovss        0x0(%r13,%r15,4),%xmm2
  .byte  196,129,122,16,92,157,0             // vmovss        0x0(%r13,%r11,4),%xmm3
  .byte  196,3,97,33,100,149,0,16            // vinsertps     $0x10,0x0(%r13,%r10,4),%xmm3,%xmm12
  .byte  196,129,122,16,124,141,0            // vmovss        0x0(%r13,%r9,4),%xmm7
  .byte  196,129,122,16,92,133,0             // vmovss        0x0(%r13,%r8,4),%xmm3
  .byte  196,99,113,33,250,48                // vinsertps     $0x30,%xmm2,%xmm1,%xmm15
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  196,161,122,16,20,160               // vmovss        (%rax,%r12,4),%xmm2
  .byte  196,227,105,33,20,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm2,%xmm2
  .byte  196,227,25,33,255,32                // vinsertps     $0x20,%xmm7,%xmm12,%xmm7
  .byte  196,161,122,16,12,176               // vmovss        (%rax,%r14,4),%xmm1
  .byte  196,227,65,33,219,48                // vinsertps     $0x30,%xmm3,%xmm7,%xmm3
  .byte  196,161,122,16,60,184               // vmovss        (%rax,%r15,4),%xmm7
  .byte  196,67,101,24,231,1                 // vinsertf128   $0x1,%xmm15,%ymm3,%ymm12
  .byte  196,161,122,16,28,152               // vmovss        (%rax,%r11,4),%xmm3
  .byte  196,163,97,33,28,144,16             // vinsertps     $0x10,(%rax,%r10,4),%xmm3,%xmm3
  .byte  196,227,105,33,201,32               // vinsertps     $0x20,%xmm1,%xmm2,%xmm1
  .byte  196,161,122,16,20,136               // vmovss        (%rax,%r9,4),%xmm2
  .byte  196,227,113,33,207,48               // vinsertps     $0x30,%xmm7,%xmm1,%xmm1
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,97,33,210,32                // vinsertps     $0x20,%xmm2,%xmm3,%xmm2
  .byte  196,227,105,33,215,48               // vinsertps     $0x30,%xmm7,%xmm2,%xmm2
  .byte  196,227,109,24,217,1                // vinsertf128   $0x1,%xmm1,%ymm2,%ymm3
  .byte  197,188,89,200                      // vmulps        %ymm0,%ymm8,%ymm1
  .byte  196,65,116,88,198                   // vaddps        %ymm14,%ymm1,%ymm8
  .byte  197,148,89,200                      // vmulps        %ymm0,%ymm13,%ymm1
  .byte  196,193,116,88,201                  // vaddps        %ymm9,%ymm1,%ymm1
  .byte  197,172,89,208                      // vmulps        %ymm0,%ymm10,%ymm2
  .byte  196,193,108,88,211                  // vaddps        %ymm11,%ymm2,%ymm2
  .byte  197,156,89,192                      // vmulps        %ymm0,%ymm12,%ymm0
  .byte  197,252,88,219                      // vaddps        %ymm3,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  197,252,16,124,36,208               // vmovups       -0x30(%rsp),%ymm7
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_2_stop_gradient_avx
.globl _sk_evenly_spaced_2_stop_gradient_avx
FUNCTION(_sk_evenly_spaced_2_stop_gradient_avx)
_sk_evenly_spaced_2_stop_gradient_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,8                    // vbroadcastss  (%rax),%ymm1
  .byte  196,226,125,24,80,16                // vbroadcastss  0x10(%rax),%ymm2
  .byte  197,244,89,200                      // vmulps        %ymm0,%ymm1,%ymm1
  .byte  197,116,88,194                      // vaddps        %ymm2,%ymm1,%ymm8
  .byte  196,226,125,24,72,4                 // vbroadcastss  0x4(%rax),%ymm1
  .byte  196,226,125,24,80,20                // vbroadcastss  0x14(%rax),%ymm2
  .byte  197,244,89,200                      // vmulps        %ymm0,%ymm1,%ymm1
  .byte  197,244,88,202                      // vaddps        %ymm2,%ymm1,%ymm1
  .byte  196,226,125,24,80,8                 // vbroadcastss  0x8(%rax),%ymm2
  .byte  196,226,125,24,88,24                // vbroadcastss  0x18(%rax),%ymm3
  .byte  197,236,89,208                      // vmulps        %ymm0,%ymm2,%ymm2
  .byte  197,236,88,211                      // vaddps        %ymm3,%ymm2,%ymm2
  .byte  196,226,125,24,88,12                // vbroadcastss  0xc(%rax),%ymm3
  .byte  196,98,125,24,72,28                 // vbroadcastss  0x1c(%rax),%ymm9
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  196,193,124,88,217                  // vaddps        %ymm9,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,192                      // vmovaps       %ymm8,%ymm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_unit_angle_avx
.globl _sk_xy_to_unit_angle_avx
FUNCTION(_sk_xy_to_unit_angle_avx)
_sk_xy_to_unit_angle_avx:
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,60,92,200                       // vsubps        %ymm0,%ymm8,%ymm9
  .byte  197,52,84,200                       // vandps        %ymm0,%ymm9,%ymm9
  .byte  197,60,92,209                       // vsubps        %ymm1,%ymm8,%ymm10
  .byte  197,44,84,209                       // vandps        %ymm1,%ymm10,%ymm10
  .byte  196,65,52,93,218                    // vminps        %ymm10,%ymm9,%ymm11
  .byte  196,65,52,95,226                    // vmaxps        %ymm10,%ymm9,%ymm12
  .byte  196,65,36,94,220                    // vdivps        %ymm12,%ymm11,%ymm11
  .byte  196,65,36,89,227                    // vmulps        %ymm11,%ymm11,%ymm12
  .byte  196,98,125,24,45,137,35,2,0         // vbroadcastss  0x22389(%rip),%ymm13        # 3a344 <_sk_srcover_bgra_8888_sse2_lowp+0x3dc>
  .byte  196,65,28,89,237                    // vmulps        %ymm13,%ymm12,%ymm13
  .byte  196,98,125,24,53,127,35,2,0         // vbroadcastss  0x2237f(%rip),%ymm14        # 3a348 <_sk_srcover_bgra_8888_sse2_lowp+0x3e0>
  .byte  196,65,20,88,238                    // vaddps        %ymm14,%ymm13,%ymm13
  .byte  196,65,28,89,237                    // vmulps        %ymm13,%ymm12,%ymm13
  .byte  196,98,125,24,53,112,35,2,0         // vbroadcastss  0x22370(%rip),%ymm14        # 3a34c <_sk_srcover_bgra_8888_sse2_lowp+0x3e4>
  .byte  196,65,20,88,238                    // vaddps        %ymm14,%ymm13,%ymm13
  .byte  196,65,28,89,229                    // vmulps        %ymm13,%ymm12,%ymm12
  .byte  196,98,125,24,45,97,35,2,0          // vbroadcastss  0x22361(%rip),%ymm13        # 3a350 <_sk_srcover_bgra_8888_sse2_lowp+0x3e8>
  .byte  196,65,28,88,229                    // vaddps        %ymm13,%ymm12,%ymm12
  .byte  196,65,36,89,220                    // vmulps        %ymm12,%ymm11,%ymm11
  .byte  196,65,52,194,202,1                 // vcmpltps      %ymm10,%ymm9,%ymm9
  .byte  196,98,125,24,21,76,35,2,0          // vbroadcastss  0x2234c(%rip),%ymm10        # 3a354 <_sk_srcover_bgra_8888_sse2_lowp+0x3ec>
  .byte  196,65,44,92,211                    // vsubps        %ymm11,%ymm10,%ymm10
  .byte  196,67,37,74,202,144                // vblendvps     %ymm9,%ymm10,%ymm11,%ymm9
  .byte  196,193,124,194,192,1               // vcmpltps      %ymm8,%ymm0,%ymm0
  .byte  196,98,125,24,21,242,33,2,0         // vbroadcastss  0x221f2(%rip),%ymm10        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,44,92,209                    // vsubps        %ymm9,%ymm10,%ymm10
  .byte  196,195,53,74,194,0                 // vblendvps     %ymm0,%ymm10,%ymm9,%ymm0
  .byte  196,65,116,194,200,1                // vcmpltps      %ymm8,%ymm1,%ymm9
  .byte  196,98,125,24,21,220,33,2,0         // vbroadcastss  0x221dc(%rip),%ymm10        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,44,92,208                       // vsubps        %ymm0,%ymm10,%ymm10
  .byte  196,195,125,74,194,144              // vblendvps     %ymm9,%ymm10,%ymm0,%ymm0
  .byte  196,65,124,194,200,3                // vcmpunordps   %ymm8,%ymm0,%ymm9
  .byte  196,195,125,74,192,144              // vblendvps     %ymm9,%ymm8,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_radius_avx
.globl _sk_xy_to_radius_avx
FUNCTION(_sk_xy_to_radius_avx)
_sk_xy_to_radius_avx:
  .byte  197,252,89,192                      // vmulps        %ymm0,%ymm0,%ymm0
  .byte  197,116,89,193                      // vmulps        %ymm1,%ymm1,%ymm8
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  197,252,81,192                      // vsqrtps       %ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_quadratic_first_avx
.globl _sk_xy_to_2pt_conical_quadratic_first_avx
FUNCTION(_sk_xy_to_2pt_conical_quadratic_first_avx)
_sk_xy_to_2pt_conical_quadratic_first_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,64                 // vbroadcastss  0x40(%rax),%ymm8
  .byte  197,122,16,72,72                    // vmovss        0x48(%rax),%xmm9
  .byte  197,50,89,80,76                     // vmulss        0x4c(%rax),%xmm9,%xmm10
  .byte  196,67,121,4,210,0                  // vpermilps     $0x0,%xmm10,%xmm10
  .byte  196,67,45,24,210,1                  // vinsertf128   $0x1,%xmm10,%ymm10,%ymm10
  .byte  197,44,88,208                       // vaddps        %ymm0,%ymm10,%ymm10
  .byte  196,98,125,24,29,194,34,2,0         // vbroadcastss  0x222c2(%rip),%ymm11        # 3a358 <_sk_srcover_bgra_8888_sse2_lowp+0x3f0>
  .byte  196,65,44,89,211                    // vmulps        %ymm11,%ymm10,%ymm10
  .byte  197,252,89,192                      // vmulps        %ymm0,%ymm0,%ymm0
  .byte  197,116,89,217                      // vmulps        %ymm1,%ymm1,%ymm11
  .byte  196,65,124,88,219                   // vaddps        %ymm11,%ymm0,%ymm11
  .byte  196,193,50,89,193                   // vmulss        %xmm9,%xmm9,%xmm0
  .byte  196,227,121,4,192,0                 // vpermilps     $0x0,%xmm0,%xmm0
  .byte  196,227,125,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm0,%ymm0
  .byte  197,164,92,192                      // vsubps        %ymm0,%ymm11,%ymm0
  .byte  196,98,125,24,13,150,34,2,0         // vbroadcastss  0x22296(%rip),%ymm9        # 3a35c <_sk_srcover_bgra_8888_sse2_lowp+0x3f4>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  196,65,44,89,194                    // vmulps        %ymm10,%ymm10,%ymm8
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  197,252,81,192                      // vsqrtps       %ymm0,%ymm0
  .byte  196,98,125,24,64,68                 // vbroadcastss  0x44(%rax),%ymm8
  .byte  196,193,124,92,194                  // vsubps        %ymm10,%ymm0,%ymm0
  .byte  196,98,125,24,13,35,33,2,0          // vbroadcastss  0x22123(%rip),%ymm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_quadratic_second_avx
.globl _sk_xy_to_2pt_conical_quadratic_second_avx
FUNCTION(_sk_xy_to_2pt_conical_quadratic_second_avx)
_sk_xy_to_2pt_conical_quadratic_second_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,64                 // vbroadcastss  0x40(%rax),%ymm8
  .byte  197,122,16,72,72                    // vmovss        0x48(%rax),%xmm9
  .byte  197,50,89,80,76                     // vmulss        0x4c(%rax),%xmm9,%xmm10
  .byte  196,67,121,4,210,0                  // vpermilps     $0x0,%xmm10,%xmm10
  .byte  196,67,45,24,210,1                  // vinsertf128   $0x1,%xmm10,%ymm10,%ymm10
  .byte  197,44,88,208                       // vaddps        %ymm0,%ymm10,%ymm10
  .byte  196,98,125,24,29,47,34,2,0          // vbroadcastss  0x2222f(%rip),%ymm11        # 3a358 <_sk_srcover_bgra_8888_sse2_lowp+0x3f0>
  .byte  196,65,44,89,211                    // vmulps        %ymm11,%ymm10,%ymm10
  .byte  197,252,89,192                      // vmulps        %ymm0,%ymm0,%ymm0
  .byte  197,116,89,217                      // vmulps        %ymm1,%ymm1,%ymm11
  .byte  196,65,124,88,219                   // vaddps        %ymm11,%ymm0,%ymm11
  .byte  196,193,50,89,193                   // vmulss        %xmm9,%xmm9,%xmm0
  .byte  196,227,121,4,192,0                 // vpermilps     $0x0,%xmm0,%xmm0
  .byte  196,227,125,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm0,%ymm0
  .byte  197,164,92,192                      // vsubps        %ymm0,%ymm11,%ymm0
  .byte  196,98,125,24,13,3,34,2,0           // vbroadcastss  0x22203(%rip),%ymm9        # 3a35c <_sk_srcover_bgra_8888_sse2_lowp+0x3f4>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  196,65,44,89,194                    // vmulps        %ymm10,%ymm10,%ymm8
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  197,252,81,192                      // vsqrtps       %ymm0,%ymm0
  .byte  196,98,125,24,64,68                 // vbroadcastss  0x44(%rax),%ymm8
  .byte  196,98,125,24,13,225,33,2,0         // vbroadcastss  0x221e1(%rip),%ymm9        # 3a360 <_sk_srcover_bgra_8888_sse2_lowp+0x3f8>
  .byte  196,65,44,87,201                    // vxorps        %ymm9,%ymm10,%ymm9
  .byte  197,180,92,192                      // vsubps        %ymm0,%ymm9,%ymm0
  .byte  196,98,125,24,13,131,32,2,0         // vbroadcastss  0x22083(%rip),%ymm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  197,188,89,192                      // vmulps        %ymm0,%ymm8,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_linear_avx
.globl _sk_xy_to_2pt_conical_linear_avx
FUNCTION(_sk_xy_to_2pt_conical_linear_avx)
_sk_xy_to_2pt_conical_linear_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,122,16,64,72                    // vmovss        0x48(%rax),%xmm8
  .byte  197,58,89,72,76                     // vmulss        0x4c(%rax),%xmm8,%xmm9
  .byte  196,67,121,4,201,0                  // vpermilps     $0x0,%xmm9,%xmm9
  .byte  196,67,53,24,201,1                  // vinsertf128   $0x1,%xmm9,%ymm9,%ymm9
  .byte  197,52,88,200                       // vaddps        %ymm0,%ymm9,%ymm9
  .byte  196,98,125,24,21,149,33,2,0         // vbroadcastss  0x22195(%rip),%ymm10        # 3a358 <_sk_srcover_bgra_8888_sse2_lowp+0x3f0>
  .byte  196,65,52,89,202                    // vmulps        %ymm10,%ymm9,%ymm9
  .byte  197,252,89,192                      // vmulps        %ymm0,%ymm0,%ymm0
  .byte  197,116,89,209                      // vmulps        %ymm1,%ymm1,%ymm10
  .byte  196,65,124,88,210                   // vaddps        %ymm10,%ymm0,%ymm10
  .byte  196,193,58,89,192                   // vmulss        %xmm8,%xmm8,%xmm0
  .byte  196,227,121,4,192,0                 // vpermilps     $0x0,%xmm0,%xmm0
  .byte  196,227,125,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm0,%ymm0
  .byte  197,172,92,192                      // vsubps        %ymm0,%ymm10,%ymm0
  .byte  196,98,125,24,5,109,33,2,0          // vbroadcastss  0x2216d(%rip),%ymm8        # 3a360 <_sk_srcover_bgra_8888_sse2_lowp+0x3f8>
  .byte  196,193,124,87,192                  // vxorps        %ymm8,%ymm0,%ymm0
  .byte  196,193,124,94,193                  // vdivps        %ymm9,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mask_2pt_conical_degenerates_avx
.globl _sk_mask_2pt_conical_degenerates_avx
FUNCTION(_sk_mask_2pt_conical_degenerates_avx)
_sk_mask_2pt_conical_degenerates_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,64,76                 // vbroadcastss  0x4c(%rax),%ymm8
  .byte  196,98,125,24,72,72                 // vbroadcastss  0x48(%rax),%ymm9
  .byte  197,60,89,192                       // vmulps        %ymm0,%ymm8,%ymm8
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  196,65,60,194,193,1                 // vcmpltps      %ymm9,%ymm8,%ymm8
  .byte  196,65,124,194,209,3                // vcmpunordps   %ymm9,%ymm0,%ymm10
  .byte  196,65,60,86,194                    // vorps         %ymm10,%ymm8,%ymm8
  .byte  196,195,125,74,193,128              // vblendvps     %ymm8,%ymm9,%ymm0,%ymm0
  .byte  196,65,52,194,209,15                // vcmptrueps    %ymm9,%ymm9,%ymm10
  .byte  196,67,45,74,193,128                // vblendvps     %ymm8,%ymm9,%ymm10,%ymm8
  .byte  197,124,17,0                        // vmovups       %ymm8,(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_apply_vector_mask_avx
.globl _sk_apply_vector_mask_avx
FUNCTION(_sk_apply_vector_mask_avx)
_sk_apply_vector_mask_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,16,0                        // vmovups       (%rax),%ymm8
  .byte  197,188,84,192                      // vandps        %ymm0,%ymm8,%ymm0
  .byte  197,188,84,201                      // vandps        %ymm1,%ymm8,%ymm1
  .byte  197,188,84,210                      // vandps        %ymm2,%ymm8,%ymm2
  .byte  197,188,84,219                      // vandps        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_save_xy_avx
.globl _sk_save_xy_avx
FUNCTION(_sk_save_xy_avx)
_sk_save_xy_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,5,167,31,2,0          // vbroadcastss  0x21fa7(%rip),%ymm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,124,88,200                   // vaddps        %ymm8,%ymm0,%ymm9
  .byte  196,67,125,8,209,1                  // vroundps      $0x1,%ymm9,%ymm10
  .byte  196,65,52,92,202                    // vsubps        %ymm10,%ymm9,%ymm9
  .byte  196,65,116,88,192                   // vaddps        %ymm8,%ymm1,%ymm8
  .byte  196,67,125,8,208,1                  // vroundps      $0x1,%ymm8,%ymm10
  .byte  196,65,60,92,194                    // vsubps        %ymm10,%ymm8,%ymm8
  .byte  197,252,17,0                        // vmovups       %ymm0,(%rax)
  .byte  197,252,17,72,64                    // vmovups       %ymm1,0x40(%rax)
  .byte  197,124,17,136,128,0,0,0            // vmovups       %ymm9,0x80(%rax)
  .byte  197,124,17,128,192,0,0,0            // vmovups       %ymm8,0xc0(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_accumulate_avx
.globl _sk_accumulate_avx
FUNCTION(_sk_accumulate_avx)
_sk_accumulate_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,16,128,0,1,0,0              // vmovups       0x100(%rax),%ymm8
  .byte  197,60,89,128,64,1,0,0              // vmulps        0x140(%rax),%ymm8,%ymm8
  .byte  197,60,89,200                       // vmulps        %ymm0,%ymm8,%ymm9
  .byte  197,180,88,228                      // vaddps        %ymm4,%ymm9,%ymm4
  .byte  197,60,89,201                       // vmulps        %ymm1,%ymm8,%ymm9
  .byte  197,180,88,237                      // vaddps        %ymm5,%ymm9,%ymm5
  .byte  197,60,89,202                       // vmulps        %ymm2,%ymm8,%ymm9
  .byte  197,180,88,246                      // vaddps        %ymm6,%ymm9,%ymm6
  .byte  197,60,89,195                       // vmulps        %ymm3,%ymm8,%ymm8
  .byte  197,188,88,255                      // vaddps        %ymm7,%ymm8,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_nx_avx
.globl _sk_bilinear_nx_avx
FUNCTION(_sk_bilinear_nx_avx)
_sk_bilinear_nx_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,5,121,32,2,0         // vbroadcastss  0x22079(%rip),%ymm0        # 3a364 <_sk_srcover_bgra_8888_sse2_lowp+0x3fc>
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  196,98,125,24,5,32,31,2,0           // vbroadcastss  0x21f20(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,128,0,0,0             // vsubps        0x80(%rax),%ymm8,%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_px_avx
.globl _sk_bilinear_px_avx
FUNCTION(_sk_bilinear_px_avx)
_sk_bilinear_px_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,5,253,30,2,0         // vbroadcastss  0x21efd(%rip),%ymm0        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  197,124,16,128,128,0,0,0            // vmovups       0x80(%rax),%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_ny_avx
.globl _sk_bilinear_ny_avx
FUNCTION(_sk_bilinear_ny_avx)
_sk_bilinear_ny_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,13,42,32,2,0         // vbroadcastss  0x2202a(%rip),%ymm1        # 3a364 <_sk_srcover_bgra_8888_sse2_lowp+0x3fc>
  .byte  197,244,88,72,64                    // vaddps        0x40(%rax),%ymm1,%ymm1
  .byte  196,98,125,24,5,208,30,2,0          // vbroadcastss  0x21ed0(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,192,0,0,0             // vsubps        0xc0(%rax),%ymm8,%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_py_avx
.globl _sk_bilinear_py_avx
FUNCTION(_sk_bilinear_py_avx)
_sk_bilinear_py_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,13,173,30,2,0        // vbroadcastss  0x21ead(%rip),%ymm1        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,244,88,72,64                    // vaddps        0x40(%rax),%ymm1,%ymm1
  .byte  197,124,16,128,192,0,0,0            // vmovups       0xc0(%rax),%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n3x_avx
.globl _sk_bicubic_n3x_avx
FUNCTION(_sk_bicubic_n3x_avx)
_sk_bicubic_n3x_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,5,221,31,2,0         // vbroadcastss  0x21fdd(%rip),%ymm0        # 3a368 <_sk_srcover_bgra_8888_sse2_lowp+0x400>
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  196,98,125,24,5,128,30,2,0          // vbroadcastss  0x21e80(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,128,0,0,0             // vsubps        0x80(%rax),%ymm8,%ymm8
  .byte  196,65,60,89,200                    // vmulps        %ymm8,%ymm8,%ymm9
  .byte  196,98,125,24,21,190,31,2,0         // vbroadcastss  0x21fbe(%rip),%ymm10        # 3a36c <_sk_srcover_bgra_8888_sse2_lowp+0x404>
  .byte  196,65,60,89,194                    // vmulps        %ymm10,%ymm8,%ymm8
  .byte  196,98,125,24,21,208,30,2,0         // vbroadcastss  0x21ed0(%rip),%ymm10        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  196,65,60,88,194                    // vaddps        %ymm10,%ymm8,%ymm8
  .byte  196,65,52,89,192                    // vmulps        %ymm8,%ymm9,%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n1x_avx
.globl _sk_bicubic_n1x_avx
FUNCTION(_sk_bicubic_n1x_avx)
_sk_bicubic_n1x_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,5,135,31,2,0         // vbroadcastss  0x21f87(%rip),%ymm0        # 3a364 <_sk_srcover_bgra_8888_sse2_lowp+0x3fc>
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  196,98,125,24,5,46,30,2,0           // vbroadcastss  0x21e2e(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,128,0,0,0             // vsubps        0x80(%rax),%ymm8,%ymm8
  .byte  196,98,125,24,13,117,31,2,0         // vbroadcastss  0x21f75(%rip),%ymm9        # 3a370 <_sk_srcover_bgra_8888_sse2_lowp+0x408>
  .byte  196,65,60,89,201                    // vmulps        %ymm9,%ymm8,%ymm9
  .byte  196,98,125,24,21,107,31,2,0         // vbroadcastss  0x21f6b(%rip),%ymm10        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,65,60,89,201                    // vmulps        %ymm9,%ymm8,%ymm9
  .byte  196,98,125,24,21,248,29,2,0         // vbroadcastss  0x21df8(%rip),%ymm10        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  196,98,125,24,13,73,31,2,0          // vbroadcastss  0x21f49(%rip),%ymm9        # 3a378 <_sk_srcover_bgra_8888_sse2_lowp+0x410>
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p1x_avx
.globl _sk_bicubic_p1x_avx
FUNCTION(_sk_bicubic_p1x_avx)
_sk_bicubic_p1x_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,5,201,29,2,0          // vbroadcastss  0x21dc9(%rip),%ymm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,188,88,0                        // vaddps        (%rax),%ymm8,%ymm0
  .byte  197,124,16,136,128,0,0,0            // vmovups       0x80(%rax),%ymm9
  .byte  196,98,125,24,21,16,31,2,0          // vbroadcastss  0x21f10(%rip),%ymm10        # 3a370 <_sk_srcover_bgra_8888_sse2_lowp+0x408>
  .byte  196,65,52,89,210                    // vmulps        %ymm10,%ymm9,%ymm10
  .byte  196,98,125,24,29,6,31,2,0           // vbroadcastss  0x21f06(%rip),%ymm11        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,65,52,89,210                    // vmulps        %ymm10,%ymm9,%ymm10
  .byte  196,65,44,88,192                    // vaddps        %ymm8,%ymm10,%ymm8
  .byte  196,65,52,89,192                    // vmulps        %ymm8,%ymm9,%ymm8
  .byte  196,98,125,24,13,237,30,2,0         // vbroadcastss  0x21eed(%rip),%ymm9        # 3a378 <_sk_srcover_bgra_8888_sse2_lowp+0x410>
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p3x_avx
.globl _sk_bicubic_p3x_avx
FUNCTION(_sk_bicubic_p3x_avx)
_sk_bicubic_p3x_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,5,205,30,2,0         // vbroadcastss  0x21ecd(%rip),%ymm0        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  197,124,16,128,128,0,0,0            // vmovups       0x80(%rax),%ymm8
  .byte  196,65,60,89,200                    // vmulps        %ymm8,%ymm8,%ymm9
  .byte  196,98,125,24,21,171,30,2,0         // vbroadcastss  0x21eab(%rip),%ymm10        # 3a36c <_sk_srcover_bgra_8888_sse2_lowp+0x404>
  .byte  196,65,60,89,194                    // vmulps        %ymm10,%ymm8,%ymm8
  .byte  196,98,125,24,21,189,29,2,0         // vbroadcastss  0x21dbd(%rip),%ymm10        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  196,65,60,88,194                    // vaddps        %ymm10,%ymm8,%ymm8
  .byte  196,65,52,89,192                    // vmulps        %ymm8,%ymm9,%ymm8
  .byte  197,124,17,128,0,1,0,0              // vmovups       %ymm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n3y_avx
.globl _sk_bicubic_n3y_avx
FUNCTION(_sk_bicubic_n3y_avx)
_sk_bicubic_n3y_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,13,120,30,2,0        // vbroadcastss  0x21e78(%rip),%ymm1        # 3a368 <_sk_srcover_bgra_8888_sse2_lowp+0x400>
  .byte  197,244,88,72,64                    // vaddps        0x40(%rax),%ymm1,%ymm1
  .byte  196,98,125,24,5,26,29,2,0           // vbroadcastss  0x21d1a(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,192,0,0,0             // vsubps        0xc0(%rax),%ymm8,%ymm8
  .byte  196,65,60,89,200                    // vmulps        %ymm8,%ymm8,%ymm9
  .byte  196,98,125,24,21,88,30,2,0          // vbroadcastss  0x21e58(%rip),%ymm10        # 3a36c <_sk_srcover_bgra_8888_sse2_lowp+0x404>
  .byte  196,65,60,89,194                    // vmulps        %ymm10,%ymm8,%ymm8
  .byte  196,98,125,24,21,106,29,2,0         // vbroadcastss  0x21d6a(%rip),%ymm10        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  196,65,60,88,194                    // vaddps        %ymm10,%ymm8,%ymm8
  .byte  196,65,52,89,192                    // vmulps        %ymm8,%ymm9,%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n1y_avx
.globl _sk_bicubic_n1y_avx
FUNCTION(_sk_bicubic_n1y_avx)
_sk_bicubic_n1y_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,13,33,30,2,0         // vbroadcastss  0x21e21(%rip),%ymm1        # 3a364 <_sk_srcover_bgra_8888_sse2_lowp+0x3fc>
  .byte  197,244,88,72,64                    // vaddps        0x40(%rax),%ymm1,%ymm1
  .byte  196,98,125,24,5,199,28,2,0          // vbroadcastss  0x21cc7(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,128,192,0,0,0             // vsubps        0xc0(%rax),%ymm8,%ymm8
  .byte  196,98,125,24,13,14,30,2,0          // vbroadcastss  0x21e0e(%rip),%ymm9        # 3a370 <_sk_srcover_bgra_8888_sse2_lowp+0x408>
  .byte  196,65,60,89,201                    // vmulps        %ymm9,%ymm8,%ymm9
  .byte  196,98,125,24,21,4,30,2,0           // vbroadcastss  0x21e04(%rip),%ymm10        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,65,60,89,201                    // vmulps        %ymm9,%ymm8,%ymm9
  .byte  196,98,125,24,21,145,28,2,0         // vbroadcastss  0x21c91(%rip),%ymm10        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,52,88,202                    // vaddps        %ymm10,%ymm9,%ymm9
  .byte  196,65,60,89,193                    // vmulps        %ymm9,%ymm8,%ymm8
  .byte  196,98,125,24,13,226,29,2,0         // vbroadcastss  0x21de2(%rip),%ymm9        # 3a378 <_sk_srcover_bgra_8888_sse2_lowp+0x410>
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p1y_avx
.globl _sk_bicubic_p1y_avx
FUNCTION(_sk_bicubic_p1y_avx)
_sk_bicubic_p1y_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,5,98,28,2,0           // vbroadcastss  0x21c62(%rip),%ymm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,188,88,72,64                    // vaddps        0x40(%rax),%ymm8,%ymm1
  .byte  197,124,16,136,192,0,0,0            // vmovups       0xc0(%rax),%ymm9
  .byte  196,98,125,24,21,168,29,2,0         // vbroadcastss  0x21da8(%rip),%ymm10        # 3a370 <_sk_srcover_bgra_8888_sse2_lowp+0x408>
  .byte  196,65,52,89,210                    // vmulps        %ymm10,%ymm9,%ymm10
  .byte  196,98,125,24,29,158,29,2,0         // vbroadcastss  0x21d9e(%rip),%ymm11        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  196,65,44,88,211                    // vaddps        %ymm11,%ymm10,%ymm10
  .byte  196,65,52,89,210                    // vmulps        %ymm10,%ymm9,%ymm10
  .byte  196,65,44,88,192                    // vaddps        %ymm8,%ymm10,%ymm8
  .byte  196,65,52,89,192                    // vmulps        %ymm8,%ymm9,%ymm8
  .byte  196,98,125,24,13,133,29,2,0         // vbroadcastss  0x21d85(%rip),%ymm9        # 3a378 <_sk_srcover_bgra_8888_sse2_lowp+0x410>
  .byte  196,65,60,88,193                    // vaddps        %ymm9,%ymm8,%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p3y_avx
.globl _sk_bicubic_p3y_avx
FUNCTION(_sk_bicubic_p3y_avx)
_sk_bicubic_p3y_avx:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,13,101,29,2,0        // vbroadcastss  0x21d65(%rip),%ymm1        # 3a374 <_sk_srcover_bgra_8888_sse2_lowp+0x40c>
  .byte  197,244,88,72,64                    // vaddps        0x40(%rax),%ymm1,%ymm1
  .byte  197,124,16,128,192,0,0,0            // vmovups       0xc0(%rax),%ymm8
  .byte  196,65,60,89,200                    // vmulps        %ymm8,%ymm8,%ymm9
  .byte  196,98,125,24,21,66,29,2,0          // vbroadcastss  0x21d42(%rip),%ymm10        # 3a36c <_sk_srcover_bgra_8888_sse2_lowp+0x404>
  .byte  196,65,60,89,194                    // vmulps        %ymm10,%ymm8,%ymm8
  .byte  196,98,125,24,21,84,28,2,0          // vbroadcastss  0x21c54(%rip),%ymm10        # 3a28c <_sk_srcover_bgra_8888_sse2_lowp+0x324>
  .byte  196,65,60,88,194                    // vaddps        %ymm10,%ymm8,%ymm8
  .byte  196,65,52,89,192                    // vmulps        %ymm8,%ymm9,%ymm8
  .byte  197,124,17,128,64,1,0,0             // vmovups       %ymm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_callback_avx
.globl _sk_callback_avx
FUNCTION(_sk_callback_avx)
_sk_callback_avx:
  .byte  85                                  // push          %rbp
  .byte  72,137,229                          // mov           %rsp,%rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,228,224                      // and           $0xffffffffffffffe0,%rsp
  .byte  72,129,236,160,0,0,0                // sub           $0xa0,%rsp
  .byte  197,252,41,124,36,96                // vmovaps       %ymm7,0x60(%rsp)
  .byte  197,252,41,116,36,64                // vmovaps       %ymm6,0x40(%rsp)
  .byte  197,252,41,108,36,32                // vmovaps       %ymm5,0x20(%rsp)
  .byte  197,252,41,36,36                    // vmovaps       %ymm4,(%rsp)
  .byte  73,137,206                          // mov           %rcx,%r14
  .byte  73,137,215                          // mov           %rdx,%r15
  .byte  73,137,253                          // mov           %rdi,%r13
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,137,195                          // mov           %rax,%rbx
  .byte  73,137,244                          // mov           %rsi,%r12
  .byte  197,252,20,225                      // vunpcklps     %ymm1,%ymm0,%ymm4
  .byte  197,252,21,193                      // vunpckhps     %ymm1,%ymm0,%ymm0
  .byte  197,236,20,203                      // vunpcklps     %ymm3,%ymm2,%ymm1
  .byte  197,236,21,211                      // vunpckhps     %ymm3,%ymm2,%ymm2
  .byte  197,221,20,217                      // vunpcklpd     %ymm1,%ymm4,%ymm3
  .byte  197,221,21,201                      // vunpckhpd     %ymm1,%ymm4,%ymm1
  .byte  197,253,20,226                      // vunpcklpd     %ymm2,%ymm0,%ymm4
  .byte  197,253,21,194                      // vunpckhpd     %ymm2,%ymm0,%ymm0
  .byte  196,227,101,24,209,1                // vinsertf128   $0x1,%xmm1,%ymm3,%ymm2
  .byte  196,227,93,24,232,1                 // vinsertf128   $0x1,%xmm0,%ymm4,%ymm5
  .byte  196,227,101,6,201,49                // vperm2f128    $0x31,%ymm1,%ymm3,%ymm1
  .byte  196,227,93,6,192,49                 // vperm2f128    $0x31,%ymm0,%ymm4,%ymm0
  .byte  197,252,17,83,8                     // vmovups       %ymm2,0x8(%rbx)
  .byte  197,252,17,107,40                   // vmovups       %ymm5,0x28(%rbx)
  .byte  197,253,17,75,72                    // vmovupd       %ymm1,0x48(%rbx)
  .byte  197,253,17,67,104                   // vmovupd       %ymm0,0x68(%rbx)
  .byte  77,133,237                          // test          %r13,%r13
  .byte  190,8,0,0,0                         // mov           $0x8,%esi
  .byte  65,15,69,245                        // cmovne        %r13d,%esi
  .byte  72,137,223                          // mov           %rbx,%rdi
  .byte  197,248,119                         // vzeroupper
  .byte  255,19                              // callq         *(%rbx)
  .byte  72,139,131,8,1,0,0                  // mov           0x108(%rbx),%rax
  .byte  197,248,16,0                        // vmovups       (%rax),%xmm0
  .byte  197,248,16,72,16                    // vmovups       0x10(%rax),%xmm1
  .byte  197,248,16,80,32                    // vmovups       0x20(%rax),%xmm2
  .byte  197,248,16,88,48                    // vmovups       0x30(%rax),%xmm3
  .byte  196,227,101,24,88,112,1             // vinsertf128   $0x1,0x70(%rax),%ymm3,%ymm3
  .byte  196,227,109,24,80,96,1              // vinsertf128   $0x1,0x60(%rax),%ymm2,%ymm2
  .byte  196,227,117,24,72,80,1              // vinsertf128   $0x1,0x50(%rax),%ymm1,%ymm1
  .byte  196,227,125,24,64,64,1              // vinsertf128   $0x1,0x40(%rax),%ymm0,%ymm0
  .byte  197,252,20,225                      // vunpcklps     %ymm1,%ymm0,%ymm4
  .byte  197,252,21,233                      // vunpckhps     %ymm1,%ymm0,%ymm5
  .byte  197,236,20,203                      // vunpcklps     %ymm3,%ymm2,%ymm1
  .byte  197,236,21,219                      // vunpckhps     %ymm3,%ymm2,%ymm3
  .byte  197,221,20,193                      // vunpcklpd     %ymm1,%ymm4,%ymm0
  .byte  197,221,21,201                      // vunpckhpd     %ymm1,%ymm4,%ymm1
  .byte  197,213,20,211                      // vunpcklpd     %ymm3,%ymm5,%ymm2
  .byte  197,213,21,219                      // vunpckhpd     %ymm3,%ymm5,%ymm3
  .byte  76,137,230                          // mov           %r12,%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,137,239                          // mov           %r13,%rdi
  .byte  76,137,250                          // mov           %r15,%rdx
  .byte  76,137,241                          // mov           %r14,%rcx
  .byte  197,252,40,36,36                    // vmovaps       (%rsp),%ymm4
  .byte  197,252,40,108,36,32                // vmovaps       0x20(%rsp),%ymm5
  .byte  197,252,40,116,36,64                // vmovaps       0x40(%rsp),%ymm6
  .byte  197,252,40,124,36,96                // vmovaps       0x60(%rsp),%ymm7
  .byte  72,141,101,216                      // lea           -0x28(%rbp),%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clut_3D_avx
.globl _sk_clut_3D_avx
FUNCTION(_sk_clut_3D_avx)
_sk_clut_3D_avx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,129,236,216,1,0,0                // sub           $0x1d8,%rsp
  .byte  197,252,17,188,36,160,1,0,0         // vmovups       %ymm7,0x1a0(%rsp)
  .byte  197,252,17,180,36,128,1,0,0         // vmovups       %ymm6,0x180(%rsp)
  .byte  197,252,17,172,36,96,1,0,0          // vmovups       %ymm5,0x160(%rsp)
  .byte  197,252,17,164,36,64,1,0,0          // vmovups       %ymm4,0x140(%rsp)
  .byte  197,252,17,156,36,32,1,0,0          // vmovups       %ymm3,0x120(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,16                        // mov           0x10(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  196,193,121,110,217                 // vmovd         %r9d,%xmm3
  .byte  197,249,112,219,0                   // vpshufd       $0x0,%xmm3,%xmm3
  .byte  196,227,101,24,219,1                // vinsertf128   $0x1,%xmm3,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  197,228,89,210                      // vmulps        %ymm2,%ymm3,%ymm2
  .byte  197,252,17,148,36,192,0,0,0         // vmovups       %ymm2,0xc0(%rsp)
  .byte  197,254,91,218                      // vcvttps2dq    %ymm2,%ymm3
  .byte  68,139,72,12                        // mov           0xc(%rax),%r9d
  .byte  69,141,81,255                       // lea           -0x1(%r9),%r10d
  .byte  196,193,121,110,210                 // vmovd         %r10d,%xmm2
  .byte  197,249,112,210,0                   // vpshufd       $0x0,%xmm2,%xmm2
  .byte  196,227,109,24,210,1                // vinsertf128   $0x1,%xmm2,%ymm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  197,236,89,201                      // vmulps        %ymm1,%ymm2,%ymm1
  .byte  197,252,17,76,36,192                // vmovups       %ymm1,-0x40(%rsp)
  .byte  197,254,91,225                      // vcvttps2dq    %ymm1,%ymm4
  .byte  196,193,121,110,200                 // vmovd         %r8d,%xmm1
  .byte  197,121,112,201,0                   // vpshufd       $0x0,%xmm1,%xmm9
  .byte  196,227,125,25,226,1                // vextractf128  $0x1,%ymm4,%xmm2
  .byte  197,253,111,244                     // vmovdqa       %ymm4,%ymm6
  .byte  197,254,127,116,36,64               // vmovdqu       %ymm6,0x40(%rsp)
  .byte  196,226,49,64,226                   // vpmulld       %xmm2,%xmm9,%xmm4
  .byte  197,249,127,164,36,144,0,0,0        // vmovdqa       %xmm4,0x90(%rsp)
  .byte  196,227,125,25,223,1                // vextractf128  $0x1,%ymm3,%xmm7
  .byte  197,249,127,124,36,224              // vmovdqa       %xmm7,-0x20(%rsp)
  .byte  197,253,111,235                     // vmovdqa       %ymm3,%ymm5
  .byte  197,254,127,172,36,160,0,0,0        // vmovdqu       %ymm5,0xa0(%rsp)
  .byte  196,193,121,110,209                 // vmovd         %r9d,%xmm2
  .byte  196,226,105,64,201                  // vpmulld       %xmm1,%xmm2,%xmm1
  .byte  197,249,112,217,0                   // vpshufd       $0x0,%xmm1,%xmm3
  .byte  68,139,64,8                         // mov           0x8(%rax),%r8d
  .byte  65,255,200                          // dec           %r8d
  .byte  196,193,121,110,200                 // vmovd         %r8d,%xmm1
  .byte  197,249,112,201,0                   // vpshufd       $0x0,%xmm1,%xmm1
  .byte  196,227,117,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  197,116,89,232                      // vmulps        %ymm0,%ymm1,%ymm13
  .byte  196,65,126,91,221                   // vcvttps2dq    %ymm13,%ymm11
  .byte  196,99,125,25,216,1                 // vextractf128  $0x1,%ymm11,%xmm0
  .byte  196,226,97,64,192                   // vpmulld       %xmm0,%xmm3,%xmm0
  .byte  197,249,127,68,36,176               // vmovdqa       %xmm0,-0x50(%rsp)
  .byte  72,139,0                            // mov           (%rax),%rax
  .byte  197,217,254,207                     // vpaddd        %xmm7,%xmm4,%xmm1
  .byte  197,249,254,193                     // vpaddd        %xmm1,%xmm0,%xmm0
  .byte  196,226,121,24,37,218,26,2,0        // vbroadcastss  0x21ada(%rip),%xmm4        # 3a380 <_sk_srcover_bgra_8888_sse2_lowp+0x418>
  .byte  196,98,121,64,228                   // vpmulld       %xmm4,%xmm0,%xmm12
  .byte  196,226,49,64,198                   // vpmulld       %xmm6,%xmm9,%xmm0
  .byte  197,249,127,132,36,128,0,0,0        // vmovdqa       %xmm0,0x80(%rsp)
  .byte  197,249,254,197                     // vpaddd        %xmm5,%xmm0,%xmm0
  .byte  196,194,97,64,211                   // vpmulld       %xmm11,%xmm3,%xmm2
  .byte  197,249,127,84,36,160               // vmovdqa       %xmm2,-0x60(%rsp)
  .byte  197,233,254,208                     // vpaddd        %xmm0,%xmm2,%xmm2
  .byte  196,226,105,64,212                  // vpmulld       %xmm4,%xmm2,%xmm2
  .byte  196,193,121,126,208                 // vmovd         %xmm2,%r8d
  .byte  196,195,121,22,209,1                // vpextrd       $0x1,%xmm2,%r9d
  .byte  196,195,121,22,210,2                // vpextrd       $0x2,%xmm2,%r10d
  .byte  196,195,121,22,211,3                // vpextrd       $0x3,%xmm2,%r11d
  .byte  196,65,121,126,231                  // vmovd         %xmm12,%r15d
  .byte  196,67,121,22,230,1                 // vpextrd       $0x1,%xmm12,%r14d
  .byte  196,67,121,22,228,2                 // vpextrd       $0x2,%xmm12,%r12d
  .byte  196,99,121,22,227,3                 // vpextrd       $0x3,%xmm12,%ebx
  .byte  196,161,122,16,44,184               // vmovss        (%rax,%r15,4),%xmm5
  .byte  196,163,81,33,44,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm5,%xmm5
  .byte  196,163,81,33,44,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm5,%xmm5
  .byte  196,227,81,33,44,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm5,%xmm5
  .byte  196,161,122,16,52,128               // vmovss        (%rax,%r8,4),%xmm6
  .byte  196,163,73,33,52,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm6,%xmm6
  .byte  196,163,73,33,52,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm6,%xmm6
  .byte  196,163,73,33,52,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm6,%xmm6
  .byte  196,99,77,24,245,1                  // vinsertf128   $0x1,%xmm5,%ymm6,%ymm14
  .byte  197,201,118,246                     // vpcmpeqd      %xmm6,%xmm6,%xmm6
  .byte  197,233,250,238                     // vpsubd        %xmm6,%xmm2,%xmm5
  .byte  196,195,249,22,232,1                // vpextrq       $0x1,%xmm5,%r8
  .byte  196,193,249,126,233                 // vmovq         %xmm5,%r9
  .byte  197,153,250,238                     // vpsubd        %xmm6,%xmm12,%xmm5
  .byte  196,195,249,22,234,1                // vpextrq       $0x1,%xmm5,%r10
  .byte  196,225,249,126,235                 // vmovq         %xmm5,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,44,152               // vmovss        (%rax,%r11,4),%xmm5
  .byte  196,227,81,33,44,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm5,%xmm5
  .byte  196,161,122,16,52,176               // vmovss        (%rax,%r14,4),%xmm6
  .byte  196,227,81,33,238,32                // vinsertps     $0x20,%xmm6,%xmm5,%xmm5
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,81,33,238,48                // vinsertps     $0x30,%xmm6,%xmm5,%xmm5
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,52,152                   // vmovss        (%rax,%rbx,4),%xmm6
  .byte  196,163,73,33,52,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm6,%xmm6
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,73,33,247,32                // vinsertps     $0x20,%xmm7,%xmm6,%xmm6
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,73,33,247,48                // vinsertps     $0x30,%xmm7,%xmm6,%xmm6
  .byte  196,227,77,24,237,1                 // vinsertf128   $0x1,%xmm5,%ymm6,%ymm5
  .byte  196,98,121,24,21,83,24,2,0          // vbroadcastss  0x21853(%rip),%xmm10        # 3a224 <_sk_srcover_bgra_8888_sse2_lowp+0x2bc>
  .byte  196,193,105,254,210                 // vpaddd        %xmm10,%xmm2,%xmm2
  .byte  196,195,249,22,208,1                // vpextrq       $0x1,%xmm2,%r8
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  196,193,25,254,210                  // vpaddd        %xmm10,%xmm12,%xmm2
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  196,225,249,126,211                 // vmovq         %xmm2,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,20,152               // vmovss        (%rax,%r11,4),%xmm2
  .byte  196,227,105,33,20,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm2,%xmm2
  .byte  196,161,122,16,52,176               // vmovss        (%rax,%r14,4),%xmm6
  .byte  196,227,105,33,214,32               // vinsertps     $0x20,%xmm6,%xmm2,%xmm2
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,105,33,214,48               // vinsertps     $0x30,%xmm6,%xmm2,%xmm2
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,52,152                   // vmovss        (%rax,%rbx,4),%xmm6
  .byte  196,163,73,33,52,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm6,%xmm6
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,73,33,247,32                // vinsertps     $0x20,%xmm7,%xmm6,%xmm6
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,73,33,247,48                // vinsertps     $0x30,%xmm7,%xmm6,%xmm6
  .byte  196,227,77,24,210,1                 // vinsertf128   $0x1,%xmm2,%ymm6,%ymm2
  .byte  196,226,125,24,61,23,25,2,0         // vbroadcastss  0x21917(%rip),%ymm7        # 3a37c <_sk_srcover_bgra_8888_sse2_lowp+0x414>
  .byte  197,148,88,247                      // vaddps        %ymm7,%ymm13,%ymm6
  .byte  197,124,40,231                      // vmovaps       %ymm7,%ymm12
  .byte  197,124,17,36,36                    // vmovups       %ymm12,(%rsp)
  .byte  197,254,91,246                      // vcvttps2dq    %ymm6,%ymm6
  .byte  196,227,125,25,247,1                // vextractf128  $0x1,%ymm6,%xmm7
  .byte  196,226,97,64,255                   // vpmulld       %xmm7,%xmm3,%xmm7
  .byte  197,249,127,124,36,144              // vmovdqa       %xmm7,-0x70(%rsp)
  .byte  196,226,97,64,222                   // vpmulld       %xmm6,%xmm3,%xmm3
  .byte  197,249,127,92,36,128               // vmovdqa       %xmm3,-0x80(%rsp)
  .byte  197,225,254,192                     // vpaddd        %xmm0,%xmm3,%xmm0
  .byte  197,193,254,201                     // vpaddd        %xmm1,%xmm7,%xmm1
  .byte  196,226,113,64,204                  // vpmulld       %xmm4,%xmm1,%xmm1
  .byte  196,226,121,64,220                  // vpmulld       %xmm4,%xmm0,%xmm3
  .byte  196,193,121,126,217                 // vmovd         %xmm3,%r9d
  .byte  196,195,121,22,216,1                // vpextrd       $0x1,%xmm3,%r8d
  .byte  196,195,121,22,218,2                // vpextrd       $0x2,%xmm3,%r10d
  .byte  196,195,121,22,219,3                // vpextrd       $0x3,%xmm3,%r11d
  .byte  196,193,121,126,207                 // vmovd         %xmm1,%r15d
  .byte  196,195,121,22,206,1                // vpextrd       $0x1,%xmm1,%r14d
  .byte  196,195,121,22,204,2                // vpextrd       $0x2,%xmm1,%r12d
  .byte  196,227,121,22,203,3                // vpextrd       $0x3,%xmm1,%ebx
  .byte  196,161,122,16,4,184                // vmovss        (%rax,%r15,4),%xmm0
  .byte  196,163,121,33,4,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm0,%xmm0
  .byte  196,163,121,33,4,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm0,%xmm0
  .byte  196,227,121,33,4,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,52,136               // vmovss        (%rax,%r9,4),%xmm6
  .byte  196,163,73,33,52,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm6,%xmm6
  .byte  196,163,73,33,52,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm6,%xmm6
  .byte  196,163,73,33,52,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm6,%xmm6
  .byte  196,99,77,24,192,1                  // vinsertf128   $0x1,%xmm0,%ymm6,%ymm8
  .byte  197,201,118,246                     // vpcmpeqd      %xmm6,%xmm6,%xmm6
  .byte  197,225,250,198                     // vpsubd        %xmm6,%xmm3,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  197,241,250,198                     // vpsubd        %xmm6,%xmm1,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,60,176               // vmovss        (%rax,%r14,4),%xmm7
  .byte  196,227,121,33,199,32               // vinsertps     $0x20,%xmm7,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,121,33,199,48               // vinsertps     $0x30,%xmm7,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,60,152                   // vmovss        (%rax,%rbx,4),%xmm7
  .byte  196,163,65,33,60,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm7,%xmm7
  .byte  196,33,122,16,60,144                // vmovss        (%rax,%r10,4),%xmm15
  .byte  196,195,65,33,255,32                // vinsertps     $0x20,%xmm15,%xmm7,%xmm7
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,52,128               // vmovss        (%rax,%r8,4),%xmm6
  .byte  196,227,65,33,246,48                // vinsertps     $0x30,%xmm6,%xmm7,%xmm6
  .byte  196,227,77,24,192,1                 // vinsertf128   $0x1,%xmm0,%ymm6,%ymm0
  .byte  196,193,97,254,218                  // vpaddd        %xmm10,%xmm3,%xmm3
  .byte  196,195,249,22,216,1                // vpextrq       $0x1,%xmm3,%r8
  .byte  196,193,249,126,217                 // vmovq         %xmm3,%r9
  .byte  196,193,113,254,202                 // vpaddd        %xmm10,%xmm1,%xmm1
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  196,225,249,126,203                 // vmovq         %xmm1,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,12,152               // vmovss        (%rax,%r11,4),%xmm1
  .byte  196,227,113,33,12,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm1,%xmm1
  .byte  196,161,122,16,28,176               // vmovss        (%rax,%r14,4),%xmm3
  .byte  196,227,113,33,203,32               // vinsertps     $0x20,%xmm3,%xmm1,%xmm1
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,113,33,203,48               // vinsertps     $0x30,%xmm3,%xmm1,%xmm1
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,28,152                   // vmovss        (%rax,%rbx,4),%xmm3
  .byte  196,163,97,33,28,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm3,%xmm3
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,97,33,222,32                // vinsertps     $0x20,%xmm6,%xmm3,%xmm3
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,52,128               // vmovss        (%rax,%r8,4),%xmm6
  .byte  196,227,97,33,222,48                // vinsertps     $0x30,%xmm6,%xmm3,%xmm3
  .byte  196,227,101,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm3,%ymm1
  .byte  196,193,124,91,219                  // vcvtdq2ps     %ymm11,%ymm3
  .byte  197,20,92,219                       // vsubps        %ymm3,%ymm13,%ymm11
  .byte  196,193,60,92,222                   // vsubps        %ymm14,%ymm8,%ymm3
  .byte  197,164,89,219                      // vmulps        %ymm3,%ymm11,%ymm3
  .byte  197,140,88,219                      // vaddps        %ymm3,%ymm14,%ymm3
  .byte  197,252,17,156,36,224,0,0,0         // vmovups       %ymm3,0xe0(%rsp)
  .byte  197,252,92,197                      // vsubps        %ymm5,%ymm0,%ymm0
  .byte  197,164,89,192                      // vmulps        %ymm0,%ymm11,%ymm0
  .byte  197,212,88,192                      // vaddps        %ymm0,%ymm5,%ymm0
  .byte  197,252,17,68,36,32                 // vmovups       %ymm0,0x20(%rsp)
  .byte  197,244,92,194                      // vsubps        %ymm2,%ymm1,%ymm0
  .byte  197,164,89,192                      // vmulps        %ymm0,%ymm11,%ymm0
  .byte  197,236,88,192                      // vaddps        %ymm0,%ymm2,%ymm0
  .byte  197,252,17,132,36,0,1,0,0           // vmovups       %ymm0,0x100(%rsp)
  .byte  197,156,88,68,36,192                // vaddps        -0x40(%rsp),%ymm12,%ymm0
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  196,226,49,64,200                   // vpmulld       %xmm0,%xmm9,%xmm1
  .byte  197,249,127,76,36,96                // vmovdqa       %xmm1,0x60(%rsp)
  .byte  196,227,125,25,192,1                // vextractf128  $0x1,%ymm0,%xmm0
  .byte  196,226,49,64,192                   // vpmulld       %xmm0,%xmm9,%xmm0
  .byte  197,249,127,68,36,112               // vmovdqa       %xmm0,0x70(%rsp)
  .byte  197,249,254,116,36,224              // vpaddd        -0x20(%rsp),%xmm0,%xmm6
  .byte  197,121,111,100,36,176              // vmovdqa       -0x50(%rsp),%xmm12
  .byte  196,193,73,254,196                  // vpaddd        %xmm12,%xmm6,%xmm0
  .byte  196,98,121,64,196                   // vpmulld       %xmm4,%xmm0,%xmm8
  .byte  197,241,254,140,36,160,0,0,0        // vpaddd        0xa0(%rsp),%xmm1,%xmm1
  .byte  197,249,111,108,36,160              // vmovdqa       -0x60(%rsp),%xmm5
  .byte  197,241,254,197                     // vpaddd        %xmm5,%xmm1,%xmm0
  .byte  196,226,121,64,196                  // vpmulld       %xmm4,%xmm0,%xmm0
  .byte  196,193,121,126,193                 // vmovd         %xmm0,%r9d
  .byte  196,195,121,22,192,1                // vpextrd       $0x1,%xmm0,%r8d
  .byte  196,195,121,22,194,2                // vpextrd       $0x2,%xmm0,%r10d
  .byte  196,195,121,22,195,3                // vpextrd       $0x3,%xmm0,%r11d
  .byte  196,65,121,126,199                  // vmovd         %xmm8,%r15d
  .byte  196,67,121,22,198,1                 // vpextrd       $0x1,%xmm8,%r14d
  .byte  196,67,121,22,196,2                 // vpextrd       $0x2,%xmm8,%r12d
  .byte  196,99,121,22,195,3                 // vpextrd       $0x3,%xmm8,%ebx
  .byte  196,161,122,16,60,184               // vmovss        (%rax,%r15,4),%xmm7
  .byte  196,163,65,33,60,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm7,%xmm7
  .byte  196,163,65,33,60,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm7,%xmm7
  .byte  196,227,65,33,60,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm7,%xmm7
  .byte  196,161,122,16,20,136               // vmovss        (%rax,%r9,4),%xmm2
  .byte  196,163,105,33,20,128,16            // vinsertps     $0x10,(%rax,%r8,4),%xmm2,%xmm2
  .byte  196,163,105,33,20,144,32            // vinsertps     $0x20,(%rax,%r10,4),%xmm2,%xmm2
  .byte  196,163,105,33,20,152,48            // vinsertps     $0x30,(%rax,%r11,4),%xmm2,%xmm2
  .byte  196,227,109,24,215,1                // vinsertf128   $0x1,%xmm7,%ymm2,%ymm2
  .byte  197,252,17,84,36,224                // vmovups       %ymm2,-0x20(%rsp)
  .byte  197,225,118,219                     // vpcmpeqd      %xmm3,%xmm3,%xmm3
  .byte  197,249,250,211                     // vpsubd        %xmm3,%xmm0,%xmm2
  .byte  196,195,249,22,208,1                // vpextrq       $0x1,%xmm2,%r8
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  197,185,250,211                     // vpsubd        %xmm3,%xmm8,%xmm2
  .byte  196,65,17,118,237                   // vpcmpeqd      %xmm13,%xmm13,%xmm13
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  196,225,249,126,211                 // vmovq         %xmm2,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,20,152               // vmovss        (%rax,%r11,4),%xmm2
  .byte  196,227,105,33,20,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm2,%xmm2
  .byte  196,161,122,16,60,176               // vmovss        (%rax,%r14,4),%xmm7
  .byte  196,227,105,33,215,32               // vinsertps     $0x20,%xmm7,%xmm2,%xmm2
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,105,33,215,48               // vinsertps     $0x30,%xmm7,%xmm2,%xmm2
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,60,152                   // vmovss        (%rax,%rbx,4),%xmm7
  .byte  196,163,65,33,60,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm7,%xmm7
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,65,33,219,32                // vinsertps     $0x20,%xmm3,%xmm7,%xmm3
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,97,33,223,48                // vinsertps     $0x30,%xmm7,%xmm3,%xmm3
  .byte  196,99,101,24,202,1                 // vinsertf128   $0x1,%xmm2,%ymm3,%ymm9
  .byte  196,193,121,254,194                 // vpaddd        %xmm10,%xmm0,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  196,193,57,254,194                  // vpaddd        %xmm10,%xmm8,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,20,176               // vmovss        (%rax,%r14,4),%xmm2
  .byte  196,227,121,33,194,32               // vinsertps     $0x20,%xmm2,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,20,144               // vmovss        (%rax,%r10,4),%xmm2
  .byte  196,227,121,33,194,48               // vinsertps     $0x30,%xmm2,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,20,152                   // vmovss        (%rax,%rbx,4),%xmm2
  .byte  196,163,105,33,20,136,16            // vinsertps     $0x10,(%rax,%r9,4),%xmm2,%xmm2
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,105,33,211,32               // vinsertps     $0x20,%xmm3,%xmm2,%xmm2
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,28,128               // vmovss        (%rax,%r8,4),%xmm3
  .byte  196,227,105,33,211,48               // vinsertps     $0x30,%xmm3,%xmm2,%xmm2
  .byte  196,99,109,24,192,1                 // vinsertf128   $0x1,%xmm0,%ymm2,%ymm8
  .byte  197,121,111,124,36,128              // vmovdqa       -0x80(%rsp),%xmm15
  .byte  197,129,254,193                     // vpaddd        %xmm1,%xmm15,%xmm0
  .byte  197,121,111,116,36,144              // vmovdqa       -0x70(%rsp),%xmm14
  .byte  197,137,254,206                     // vpaddd        %xmm6,%xmm14,%xmm1
  .byte  196,226,113,64,244                  // vpmulld       %xmm4,%xmm1,%xmm6
  .byte  196,226,121,64,204                  // vpmulld       %xmm4,%xmm0,%xmm1
  .byte  196,193,121,126,201                 // vmovd         %xmm1,%r9d
  .byte  196,195,121,22,200,1                // vpextrd       $0x1,%xmm1,%r8d
  .byte  196,195,121,22,202,2                // vpextrd       $0x2,%xmm1,%r10d
  .byte  196,195,121,22,203,3                // vpextrd       $0x3,%xmm1,%r11d
  .byte  196,193,121,126,247                 // vmovd         %xmm6,%r15d
  .byte  196,195,121,22,246,1                // vpextrd       $0x1,%xmm6,%r14d
  .byte  196,195,121,22,244,2                // vpextrd       $0x2,%xmm6,%r12d
  .byte  196,227,121,22,243,3                // vpextrd       $0x3,%xmm6,%ebx
  .byte  196,161,122,16,4,184                // vmovss        (%rax,%r15,4),%xmm0
  .byte  196,163,121,33,4,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm0,%xmm0
  .byte  196,163,121,33,4,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm0,%xmm0
  .byte  196,227,121,33,4,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,20,136               // vmovss        (%rax,%r9,4),%xmm2
  .byte  196,163,105,33,20,128,16            // vinsertps     $0x10,(%rax,%r8,4),%xmm2,%xmm2
  .byte  196,163,105,33,20,144,32            // vinsertps     $0x20,(%rax,%r10,4),%xmm2,%xmm2
  .byte  196,163,105,33,20,152,48            // vinsertps     $0x30,(%rax,%r11,4),%xmm2,%xmm2
  .byte  196,227,109,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm2,%ymm0
  .byte  196,193,113,250,213                 // vpsubd        %xmm13,%xmm1,%xmm2
  .byte  196,195,249,22,208,1                // vpextrq       $0x1,%xmm2,%r8
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  196,193,73,250,213                  // vpsubd        %xmm13,%xmm6,%xmm2
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  196,225,249,126,211                 // vmovq         %xmm2,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,20,152               // vmovss        (%rax,%r11,4),%xmm2
  .byte  196,227,105,33,20,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm2,%xmm2
  .byte  196,161,122,16,28,176               // vmovss        (%rax,%r14,4),%xmm3
  .byte  196,227,105,33,211,32               // vinsertps     $0x20,%xmm3,%xmm2,%xmm2
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,105,33,211,48               // vinsertps     $0x30,%xmm3,%xmm2,%xmm2
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,28,152                   // vmovss        (%rax,%rbx,4),%xmm3
  .byte  196,163,97,33,28,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm3,%xmm3
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,97,33,223,32                // vinsertps     $0x20,%xmm7,%xmm3,%xmm3
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,97,33,223,48                // vinsertps     $0x30,%xmm7,%xmm3,%xmm3
  .byte  196,99,101,24,234,1                 // vinsertf128   $0x1,%xmm2,%ymm3,%ymm13
  .byte  196,193,113,254,202                 // vpaddd        %xmm10,%xmm1,%xmm1
  .byte  196,195,249,22,200,1                // vpextrq       $0x1,%xmm1,%r8
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  196,193,73,254,202                  // vpaddd        %xmm10,%xmm6,%xmm1
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  196,225,249,126,203                 // vmovq         %xmm1,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,12,152               // vmovss        (%rax,%r11,4),%xmm1
  .byte  196,227,113,33,12,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm1,%xmm1
  .byte  196,161,122,16,20,176               // vmovss        (%rax,%r14,4),%xmm2
  .byte  196,227,113,33,202,32               // vinsertps     $0x20,%xmm2,%xmm1,%xmm1
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,20,144               // vmovss        (%rax,%r10,4),%xmm2
  .byte  196,227,113,33,202,48               // vinsertps     $0x30,%xmm2,%xmm1,%xmm1
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,20,152                   // vmovss        (%rax,%rbx,4),%xmm2
  .byte  196,163,105,33,20,136,16            // vinsertps     $0x10,(%rax,%r9,4),%xmm2,%xmm2
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,105,33,211,32               // vinsertps     $0x20,%xmm3,%xmm2,%xmm2
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,28,128               // vmovss        (%rax,%r8,4),%xmm3
  .byte  196,227,105,33,211,48               // vinsertps     $0x30,%xmm3,%xmm2,%xmm2
  .byte  196,227,109,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm2,%ymm1
  .byte  197,252,16,84,36,224                // vmovups       -0x20(%rsp),%ymm2
  .byte  197,252,92,194                      // vsubps        %ymm2,%ymm0,%ymm0
  .byte  197,164,89,192                      // vmulps        %ymm0,%ymm11,%ymm0
  .byte  197,236,88,208                      // vaddps        %ymm0,%ymm2,%ymm2
  .byte  196,193,20,92,193                   // vsubps        %ymm9,%ymm13,%ymm0
  .byte  197,164,89,192                      // vmulps        %ymm0,%ymm11,%ymm0
  .byte  197,180,88,216                      // vaddps        %ymm0,%ymm9,%ymm3
  .byte  196,193,116,92,192                  // vsubps        %ymm8,%ymm1,%ymm0
  .byte  197,164,89,192                      // vmulps        %ymm0,%ymm11,%ymm0
  .byte  197,188,88,200                      // vaddps        %ymm0,%ymm8,%ymm1
  .byte  197,252,91,68,36,64                 // vcvtdq2ps     0x40(%rsp),%ymm0
  .byte  197,252,16,116,36,192               // vmovups       -0x40(%rsp),%ymm6
  .byte  197,76,92,232                       // vsubps        %ymm0,%ymm6,%ymm13
  .byte  197,252,16,132,36,224,0,0,0         // vmovups       0xe0(%rsp),%ymm0
  .byte  197,236,92,208                      // vsubps        %ymm0,%ymm2,%ymm2
  .byte  197,148,89,210                      // vmulps        %ymm2,%ymm13,%ymm2
  .byte  197,252,88,194                      // vaddps        %ymm2,%ymm0,%ymm0
  .byte  197,252,17,68,36,192                // vmovups       %ymm0,-0x40(%rsp)
  .byte  197,252,16,68,36,32                 // vmovups       0x20(%rsp),%ymm0
  .byte  197,228,92,208                      // vsubps        %ymm0,%ymm3,%ymm2
  .byte  197,148,89,210                      // vmulps        %ymm2,%ymm13,%ymm2
  .byte  197,252,88,194                      // vaddps        %ymm2,%ymm0,%ymm0
  .byte  197,252,17,68,36,64                 // vmovups       %ymm0,0x40(%rsp)
  .byte  197,252,16,132,36,0,1,0,0           // vmovups       0x100(%rsp),%ymm0
  .byte  197,244,92,200                      // vsubps        %ymm0,%ymm1,%ymm1
  .byte  197,148,89,201                      // vmulps        %ymm1,%ymm13,%ymm1
  .byte  197,252,88,193                      // vaddps        %ymm1,%ymm0,%ymm0
  .byte  197,252,17,68,36,32                 // vmovups       %ymm0,0x20(%rsp)
  .byte  197,252,16,4,36                     // vmovups       (%rsp),%ymm0
  .byte  197,252,88,140,36,192,0,0,0         // vaddps        0xc0(%rsp),%ymm0,%ymm1
  .byte  197,126,91,201                      // vcvttps2dq    %ymm1,%ymm9
  .byte  196,99,125,25,200,1                 // vextractf128  $0x1,%ymm9,%xmm0
  .byte  197,249,127,4,36                    // vmovdqa       %xmm0,(%rsp)
  .byte  197,249,254,180,36,144,0,0,0        // vpaddd        0x90(%rsp),%xmm0,%xmm6
  .byte  197,177,254,156,36,128,0,0,0        // vpaddd        0x80(%rsp),%xmm9,%xmm3
  .byte  197,153,254,206                     // vpaddd        %xmm6,%xmm12,%xmm1
  .byte  196,226,113,64,204                  // vpmulld       %xmm4,%xmm1,%xmm1
  .byte  197,209,254,211                     // vpaddd        %xmm3,%xmm5,%xmm2
  .byte  196,226,105,64,212                  // vpmulld       %xmm4,%xmm2,%xmm2
  .byte  196,193,121,126,209                 // vmovd         %xmm2,%r9d
  .byte  196,195,121,22,208,1                // vpextrd       $0x1,%xmm2,%r8d
  .byte  196,195,121,22,210,2                // vpextrd       $0x2,%xmm2,%r10d
  .byte  196,195,121,22,211,3                // vpextrd       $0x3,%xmm2,%r11d
  .byte  196,193,121,126,207                 // vmovd         %xmm1,%r15d
  .byte  196,195,121,22,206,1                // vpextrd       $0x1,%xmm1,%r14d
  .byte  196,195,121,22,204,2                // vpextrd       $0x2,%xmm1,%r12d
  .byte  196,227,121,22,203,3                // vpextrd       $0x3,%xmm1,%ebx
  .byte  196,161,122,16,60,184               // vmovss        (%rax,%r15,4),%xmm7
  .byte  196,163,65,33,60,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm7,%xmm7
  .byte  196,163,65,33,60,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm7,%xmm7
  .byte  196,227,65,33,60,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm7,%xmm7
  .byte  196,161,122,16,4,136                // vmovss        (%rax,%r9,4),%xmm0
  .byte  196,163,121,33,4,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm0,%xmm0
  .byte  196,163,121,33,4,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm0,%xmm0
  .byte  196,163,121,33,4,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm0,%xmm0
  .byte  196,99,125,24,231,1                 // vinsertf128   $0x1,%xmm7,%ymm0,%ymm12
  .byte  197,209,118,237                     // vpcmpeqd      %xmm5,%xmm5,%xmm5
  .byte  197,233,250,197                     // vpsubd        %xmm5,%xmm2,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  197,241,250,197                     // vpsubd        %xmm5,%xmm1,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,60,176               // vmovss        (%rax,%r14,4),%xmm7
  .byte  196,227,121,33,199,32               // vinsertps     $0x20,%xmm7,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,121,33,199,48               // vinsertps     $0x30,%xmm7,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,60,152                   // vmovss        (%rax,%rbx,4),%xmm7
  .byte  196,163,65,33,60,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm7,%xmm7
  .byte  196,161,122,16,44,144               // vmovss        (%rax,%r10,4),%xmm5
  .byte  196,227,65,33,237,32                // vinsertps     $0x20,%xmm5,%xmm7,%xmm5
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,81,33,239,48                // vinsertps     $0x30,%xmm7,%xmm5,%xmm5
  .byte  196,227,85,24,248,1                 // vinsertf128   $0x1,%xmm0,%ymm5,%ymm7
  .byte  196,193,105,254,194                 // vpaddd        %xmm10,%xmm2,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  196,193,113,254,194                 // vpaddd        %xmm10,%xmm1,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,12,176               // vmovss        (%rax,%r14,4),%xmm1
  .byte  196,227,121,33,193,32               // vinsertps     $0x20,%xmm1,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,12,144               // vmovss        (%rax,%r10,4),%xmm1
  .byte  196,227,121,33,193,48               // vinsertps     $0x30,%xmm1,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,12,152                   // vmovss        (%rax,%rbx,4),%xmm1
  .byte  196,163,113,33,12,136,16            // vinsertps     $0x10,(%rax,%r9,4),%xmm1,%xmm1
  .byte  196,161,122,16,20,144               // vmovss        (%rax,%r10,4),%xmm2
  .byte  196,227,113,33,202,32               // vinsertps     $0x20,%xmm2,%xmm1,%xmm1
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,20,128               // vmovss        (%rax,%r8,4),%xmm2
  .byte  196,227,113,33,202,48               // vinsertps     $0x30,%xmm2,%xmm1,%xmm1
  .byte  196,99,117,24,192,1                 // vinsertf128   $0x1,%xmm0,%ymm1,%ymm8
  .byte  197,129,254,195                     // vpaddd        %xmm3,%xmm15,%xmm0
  .byte  197,137,254,206                     // vpaddd        %xmm6,%xmm14,%xmm1
  .byte  196,226,113,64,204                  // vpmulld       %xmm4,%xmm1,%xmm1
  .byte  196,226,121,64,212                  // vpmulld       %xmm4,%xmm0,%xmm2
  .byte  196,193,121,126,209                 // vmovd         %xmm2,%r9d
  .byte  196,195,121,22,208,1                // vpextrd       $0x1,%xmm2,%r8d
  .byte  196,195,121,22,210,2                // vpextrd       $0x2,%xmm2,%r10d
  .byte  196,195,121,22,211,3                // vpextrd       $0x3,%xmm2,%r11d
  .byte  196,193,121,126,207                 // vmovd         %xmm1,%r15d
  .byte  196,195,121,22,206,1                // vpextrd       $0x1,%xmm1,%r14d
  .byte  196,195,121,22,204,2                // vpextrd       $0x2,%xmm1,%r12d
  .byte  196,227,121,22,203,3                // vpextrd       $0x3,%xmm1,%ebx
  .byte  196,161,122,16,4,184                // vmovss        (%rax,%r15,4),%xmm0
  .byte  196,163,121,33,4,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm0,%xmm0
  .byte  196,163,121,33,4,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm0,%xmm0
  .byte  196,227,121,33,4,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,28,136               // vmovss        (%rax,%r9,4),%xmm3
  .byte  196,163,97,33,28,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm3,%xmm3
  .byte  196,227,101,24,216,1                // vinsertf128   $0x1,%xmm0,%ymm3,%ymm3
  .byte  197,209,118,237                     // vpcmpeqd      %xmm5,%xmm5,%xmm5
  .byte  197,233,250,197                     // vpsubd        %xmm5,%xmm2,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  197,241,250,197                     // vpsubd        %xmm5,%xmm1,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,44,176               // vmovss        (%rax,%r14,4),%xmm5
  .byte  196,227,121,33,197,32               // vinsertps     $0x20,%xmm5,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,44,144               // vmovss        (%rax,%r10,4),%xmm5
  .byte  196,227,121,33,197,48               // vinsertps     $0x30,%xmm5,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,44,152                   // vmovss        (%rax,%rbx,4),%xmm5
  .byte  196,163,81,33,44,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm5,%xmm5
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,81,33,238,32                // vinsertps     $0x20,%xmm6,%xmm5,%xmm5
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,52,128               // vmovss        (%rax,%r8,4),%xmm6
  .byte  196,227,81,33,238,48                // vinsertps     $0x30,%xmm6,%xmm5,%xmm5
  .byte  196,227,85,24,240,1                 // vinsertf128   $0x1,%xmm0,%ymm5,%ymm6
  .byte  196,193,105,254,194                 // vpaddd        %xmm10,%xmm2,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  196,193,113,254,194                 // vpaddd        %xmm10,%xmm1,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,12,176               // vmovss        (%rax,%r14,4),%xmm1
  .byte  196,227,121,33,193,32               // vinsertps     $0x20,%xmm1,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,12,144               // vmovss        (%rax,%r10,4),%xmm1
  .byte  196,227,121,33,193,48               // vinsertps     $0x30,%xmm1,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,12,152                   // vmovss        (%rax,%rbx,4),%xmm1
  .byte  196,163,113,33,12,136,16            // vinsertps     $0x10,(%rax,%r9,4),%xmm1,%xmm1
  .byte  196,161,122,16,20,144               // vmovss        (%rax,%r10,4),%xmm2
  .byte  196,227,113,33,202,32               // vinsertps     $0x20,%xmm2,%xmm1,%xmm1
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,20,128               // vmovss        (%rax,%r8,4),%xmm2
  .byte  196,227,113,33,202,48               // vinsertps     $0x30,%xmm2,%xmm1,%xmm1
  .byte  196,227,117,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  196,193,100,92,204                  // vsubps        %ymm12,%ymm3,%ymm1
  .byte  197,164,89,201                      // vmulps        %ymm1,%ymm11,%ymm1
  .byte  197,28,88,225                       // vaddps        %ymm1,%ymm12,%ymm12
  .byte  197,204,92,207                      // vsubps        %ymm7,%ymm6,%ymm1
  .byte  197,164,89,201                      // vmulps        %ymm1,%ymm11,%ymm1
  .byte  197,68,88,241                       // vaddps        %ymm1,%ymm7,%ymm14
  .byte  196,193,124,92,192                  // vsubps        %ymm8,%ymm0,%ymm0
  .byte  197,164,89,192                      // vmulps        %ymm0,%ymm11,%ymm0
  .byte  197,60,88,192                       // vaddps        %ymm0,%ymm8,%ymm8
  .byte  197,249,111,4,36                    // vmovdqa       (%rsp),%xmm0
  .byte  197,249,254,116,36,112              // vpaddd        0x70(%rsp),%xmm0,%xmm6
  .byte  197,177,254,76,36,96                // vpaddd        0x60(%rsp),%xmm9,%xmm1
  .byte  197,241,254,68,36,160               // vpaddd        -0x60(%rsp),%xmm1,%xmm0
  .byte  197,201,254,84,36,176               // vpaddd        -0x50(%rsp),%xmm6,%xmm2
  .byte  196,98,105,64,204                   // vpmulld       %xmm4,%xmm2,%xmm9
  .byte  196,226,121,64,220                  // vpmulld       %xmm4,%xmm0,%xmm3
  .byte  196,193,121,126,217                 // vmovd         %xmm3,%r9d
  .byte  196,195,121,22,216,1                // vpextrd       $0x1,%xmm3,%r8d
  .byte  196,195,121,22,218,2                // vpextrd       $0x2,%xmm3,%r10d
  .byte  196,195,121,22,219,3                // vpextrd       $0x3,%xmm3,%r11d
  .byte  196,65,121,126,207                  // vmovd         %xmm9,%r15d
  .byte  196,67,121,22,206,1                 // vpextrd       $0x1,%xmm9,%r14d
  .byte  196,67,121,22,204,2                 // vpextrd       $0x2,%xmm9,%r12d
  .byte  196,99,121,22,203,3                 // vpextrd       $0x3,%xmm9,%ebx
  .byte  196,161,122,16,4,184                // vmovss        (%rax,%r15,4),%xmm0
  .byte  196,163,121,33,4,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm0,%xmm0
  .byte  196,163,121,33,4,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm0,%xmm0
  .byte  196,227,121,33,4,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,20,136               // vmovss        (%rax,%r9,4),%xmm2
  .byte  196,163,105,33,20,128,16            // vinsertps     $0x10,(%rax,%r8,4),%xmm2,%xmm2
  .byte  196,163,105,33,20,144,32            // vinsertps     $0x20,(%rax,%r10,4),%xmm2,%xmm2
  .byte  196,163,105,33,20,152,48            // vinsertps     $0x30,(%rax,%r11,4),%xmm2,%xmm2
  .byte  196,227,109,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm2,%ymm0
  .byte  197,209,118,237                     // vpcmpeqd      %xmm5,%xmm5,%xmm5
  .byte  197,225,250,213                     // vpsubd        %xmm5,%xmm3,%xmm2
  .byte  196,195,249,22,208,1                // vpextrq       $0x1,%xmm2,%r8
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  197,177,250,213                     // vpsubd        %xmm5,%xmm9,%xmm2
  .byte  196,65,1,118,255                    // vpcmpeqd      %xmm15,%xmm15,%xmm15
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  196,225,249,126,211                 // vmovq         %xmm2,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,20,152               // vmovss        (%rax,%r11,4),%xmm2
  .byte  196,227,105,33,20,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm2,%xmm2
  .byte  196,161,122,16,44,176               // vmovss        (%rax,%r14,4),%xmm5
  .byte  196,227,105,33,213,32               // vinsertps     $0x20,%xmm5,%xmm2,%xmm2
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,44,144               // vmovss        (%rax,%r10,4),%xmm5
  .byte  196,227,105,33,213,48               // vinsertps     $0x30,%xmm5,%xmm2,%xmm2
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,44,152                   // vmovss        (%rax,%rbx,4),%xmm5
  .byte  196,163,81,33,44,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm5,%xmm5
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,81,33,239,32                // vinsertps     $0x20,%xmm7,%xmm5,%xmm5
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,81,33,239,48                // vinsertps     $0x30,%xmm7,%xmm5,%xmm5
  .byte  196,227,85,24,210,1                 // vinsertf128   $0x1,%xmm2,%ymm5,%ymm2
  .byte  196,193,97,254,218                  // vpaddd        %xmm10,%xmm3,%xmm3
  .byte  196,195,249,22,216,1                // vpextrq       $0x1,%xmm3,%r8
  .byte  196,193,249,126,217                 // vmovq         %xmm3,%r9
  .byte  196,193,49,254,218                  // vpaddd        %xmm10,%xmm9,%xmm3
  .byte  196,195,249,22,218,1                // vpextrq       $0x1,%xmm3,%r10
  .byte  196,225,249,126,219                 // vmovq         %xmm3,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,28,152               // vmovss        (%rax,%r11,4),%xmm3
  .byte  196,227,97,33,28,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm3,%xmm3
  .byte  196,161,122,16,44,176               // vmovss        (%rax,%r14,4),%xmm5
  .byte  196,227,97,33,221,32                // vinsertps     $0x20,%xmm5,%xmm3,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,44,144               // vmovss        (%rax,%r10,4),%xmm5
  .byte  196,227,97,33,221,48                // vinsertps     $0x30,%xmm5,%xmm3,%xmm3
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,44,152                   // vmovss        (%rax,%rbx,4),%xmm5
  .byte  196,163,81,33,44,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm5,%xmm5
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,81,33,239,32                // vinsertps     $0x20,%xmm7,%xmm5,%xmm5
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,81,33,239,48                // vinsertps     $0x30,%xmm7,%xmm5,%xmm5
  .byte  196,99,85,24,203,1                  // vinsertf128   $0x1,%xmm3,%ymm5,%ymm9
  .byte  197,241,254,76,36,128               // vpaddd        -0x80(%rsp),%xmm1,%xmm1
  .byte  197,201,254,92,36,144               // vpaddd        -0x70(%rsp),%xmm6,%xmm3
  .byte  196,226,97,64,220                   // vpmulld       %xmm4,%xmm3,%xmm3
  .byte  196,226,113,64,228                  // vpmulld       %xmm4,%xmm1,%xmm4
  .byte  196,193,121,126,225                 // vmovd         %xmm4,%r9d
  .byte  196,195,121,22,224,1                // vpextrd       $0x1,%xmm4,%r8d
  .byte  196,195,121,22,226,2                // vpextrd       $0x2,%xmm4,%r10d
  .byte  196,195,121,22,227,3                // vpextrd       $0x3,%xmm4,%r11d
  .byte  196,193,121,126,223                 // vmovd         %xmm3,%r15d
  .byte  196,195,121,22,222,1                // vpextrd       $0x1,%xmm3,%r14d
  .byte  196,195,121,22,220,2                // vpextrd       $0x2,%xmm3,%r12d
  .byte  196,227,121,22,219,3                // vpextrd       $0x3,%xmm3,%ebx
  .byte  196,161,122,16,12,184               // vmovss        (%rax,%r15,4),%xmm1
  .byte  196,163,113,33,12,176,16            // vinsertps     $0x10,(%rax,%r14,4),%xmm1,%xmm1
  .byte  196,163,113,33,12,160,32            // vinsertps     $0x20,(%rax,%r12,4),%xmm1,%xmm1
  .byte  196,227,113,33,12,152,48            // vinsertps     $0x30,(%rax,%rbx,4),%xmm1,%xmm1
  .byte  196,161,122,16,44,136               // vmovss        (%rax,%r9,4),%xmm5
  .byte  196,163,81,33,44,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm5,%xmm5
  .byte  196,163,81,33,44,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm5,%xmm5
  .byte  196,163,81,33,44,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm5,%xmm5
  .byte  196,227,85,24,201,1                 // vinsertf128   $0x1,%xmm1,%ymm5,%ymm1
  .byte  196,193,89,250,239                  // vpsubd        %xmm15,%xmm4,%xmm5
  .byte  196,195,249,22,232,1                // vpextrq       $0x1,%xmm5,%r8
  .byte  196,193,249,126,233                 // vmovq         %xmm5,%r9
  .byte  196,193,97,250,239                  // vpsubd        %xmm15,%xmm3,%xmm5
  .byte  196,195,249,22,234,1                // vpextrq       $0x1,%xmm5,%r10
  .byte  196,225,249,126,235                 // vmovq         %xmm5,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,44,152               // vmovss        (%rax,%r11,4),%xmm5
  .byte  196,227,81,33,44,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm5,%xmm5
  .byte  196,161,122,16,52,176               // vmovss        (%rax,%r14,4),%xmm6
  .byte  196,227,81,33,238,32                // vinsertps     $0x20,%xmm6,%xmm5,%xmm5
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,81,33,238,48                // vinsertps     $0x30,%xmm6,%xmm5,%xmm5
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,52,152                   // vmovss        (%rax,%rbx,4),%xmm6
  .byte  196,163,73,33,52,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm6,%xmm6
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,73,33,247,32                // vinsertps     $0x20,%xmm7,%xmm6,%xmm6
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,73,33,247,48                // vinsertps     $0x30,%xmm7,%xmm6,%xmm6
  .byte  196,227,77,24,245,1                 // vinsertf128   $0x1,%xmm5,%ymm6,%ymm6
  .byte  196,193,89,254,226                  // vpaddd        %xmm10,%xmm4,%xmm4
  .byte  196,195,249,22,224,1                // vpextrq       $0x1,%xmm4,%r8
  .byte  196,193,249,126,225                 // vmovq         %xmm4,%r9
  .byte  196,193,97,254,218                  // vpaddd        %xmm10,%xmm3,%xmm3
  .byte  196,195,249,22,218,1                // vpextrq       $0x1,%xmm3,%r10
  .byte  196,225,249,126,219                 // vmovq         %xmm3,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,28,152               // vmovss        (%rax,%r11,4),%xmm3
  .byte  196,227,97,33,28,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm3,%xmm3
  .byte  196,161,122,16,36,176               // vmovss        (%rax,%r14,4),%xmm4
  .byte  196,227,97,33,220,32                // vinsertps     $0x20,%xmm4,%xmm3,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,97,33,220,48                // vinsertps     $0x30,%xmm4,%xmm3,%xmm3
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,36,152                   // vmovss        (%rax,%rbx,4),%xmm4
  .byte  196,163,89,33,36,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm4,%xmm4
  .byte  196,161,122,16,44,144               // vmovss        (%rax,%r10,4),%xmm5
  .byte  196,227,89,33,229,32                // vinsertps     $0x20,%xmm5,%xmm4,%xmm4
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,44,128               // vmovss        (%rax,%r8,4),%xmm5
  .byte  196,227,89,33,229,48                // vinsertps     $0x30,%xmm5,%xmm4,%xmm4
  .byte  196,227,93,24,219,1                 // vinsertf128   $0x1,%xmm3,%ymm4,%ymm3
  .byte  197,244,92,200                      // vsubps        %ymm0,%ymm1,%ymm1
  .byte  197,164,89,201                      // vmulps        %ymm1,%ymm11,%ymm1
  .byte  197,252,88,193                      // vaddps        %ymm1,%ymm0,%ymm0
  .byte  197,204,92,202                      // vsubps        %ymm2,%ymm6,%ymm1
  .byte  197,164,89,201                      // vmulps        %ymm1,%ymm11,%ymm1
  .byte  197,236,88,201                      // vaddps        %ymm1,%ymm2,%ymm1
  .byte  196,193,100,92,209                  // vsubps        %ymm9,%ymm3,%ymm2
  .byte  197,164,89,210                      // vmulps        %ymm2,%ymm11,%ymm2
  .byte  197,180,88,210                      // vaddps        %ymm2,%ymm9,%ymm2
  .byte  196,193,124,92,196                  // vsubps        %ymm12,%ymm0,%ymm0
  .byte  197,148,89,192                      // vmulps        %ymm0,%ymm13,%ymm0
  .byte  197,156,88,192                      // vaddps        %ymm0,%ymm12,%ymm0
  .byte  196,193,116,92,206                  // vsubps        %ymm14,%ymm1,%ymm1
  .byte  197,148,89,201                      // vmulps        %ymm1,%ymm13,%ymm1
  .byte  197,140,88,201                      // vaddps        %ymm1,%ymm14,%ymm1
  .byte  196,193,108,92,208                  // vsubps        %ymm8,%ymm2,%ymm2
  .byte  197,148,89,210                      // vmulps        %ymm2,%ymm13,%ymm2
  .byte  197,188,88,210                      // vaddps        %ymm2,%ymm8,%ymm2
  .byte  197,252,91,156,36,160,0,0,0         // vcvtdq2ps     0xa0(%rsp),%ymm3
  .byte  197,252,16,164,36,192,0,0,0         // vmovups       0xc0(%rsp),%ymm4
  .byte  197,220,92,219                      // vsubps        %ymm3,%ymm4,%ymm3
  .byte  197,252,16,100,36,192               // vmovups       -0x40(%rsp),%ymm4
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,220,88,192                      // vaddps        %ymm0,%ymm4,%ymm0
  .byte  197,252,16,100,36,64                // vmovups       0x40(%rsp),%ymm4
  .byte  197,244,92,204                      // vsubps        %ymm4,%ymm1,%ymm1
  .byte  197,228,89,201                      // vmulps        %ymm1,%ymm3,%ymm1
  .byte  197,220,88,201                      // vaddps        %ymm1,%ymm4,%ymm1
  .byte  197,252,16,100,36,32                // vmovups       0x20(%rsp),%ymm4
  .byte  197,236,92,212                      // vsubps        %ymm4,%ymm2,%ymm2
  .byte  197,228,89,210                      // vmulps        %ymm2,%ymm3,%ymm2
  .byte  197,220,88,210                      // vaddps        %ymm2,%ymm4,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,156,36,32,1,0,0          // vmovups       0x120(%rsp),%ymm3
  .byte  197,252,16,164,36,64,1,0,0          // vmovups       0x140(%rsp),%ymm4
  .byte  197,252,16,172,36,96,1,0,0          // vmovups       0x160(%rsp),%ymm5
  .byte  197,252,16,180,36,128,1,0,0         // vmovups       0x180(%rsp),%ymm6
  .byte  197,252,16,188,36,160,1,0,0         // vmovups       0x1a0(%rsp),%ymm7
  .byte  72,129,196,216,1,0,0                // add           $0x1d8,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clut_4D_avx
.globl _sk_clut_4D_avx
FUNCTION(_sk_clut_4D_avx)
_sk_clut_4D_avx:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,129,236,216,2,0,0                // sub           $0x2d8,%rsp
  .byte  197,252,17,188,36,160,2,0,0         // vmovups       %ymm7,0x2a0(%rsp)
  .byte  197,252,17,180,36,128,2,0,0         // vmovups       %ymm6,0x280(%rsp)
  .byte  197,252,17,172,36,96,2,0,0          // vmovups       %ymm5,0x260(%rsp)
  .byte  197,252,17,164,36,64,2,0,0          // vmovups       %ymm4,0x240(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,20                        // mov           0x14(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  196,193,121,110,225                 // vmovd         %r9d,%xmm4
  .byte  197,249,112,228,0                   // vpshufd       $0x0,%xmm4,%xmm4
  .byte  196,227,93,24,228,1                 // vinsertf128   $0x1,%xmm4,%ymm4,%ymm4
  .byte  197,252,91,228                      // vcvtdq2ps     %ymm4,%ymm4
  .byte  197,92,89,203                       // vmulps        %ymm3,%ymm4,%ymm9
  .byte  197,124,17,140,36,224,1,0,0         // vmovups       %ymm9,0x1e0(%rsp)
  .byte  68,139,72,16                        // mov           0x10(%rax),%r9d
  .byte  69,141,81,255                       // lea           -0x1(%r9),%r10d
  .byte  196,193,121,110,218                 // vmovd         %r10d,%xmm3
  .byte  197,249,112,219,0                   // vpshufd       $0x0,%xmm3,%xmm3
  .byte  196,227,101,24,219,1                // vinsertf128   $0x1,%xmm3,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  197,228,89,210                      // vmulps        %ymm2,%ymm3,%ymm2
  .byte  197,252,17,148,36,0,1,0,0           // vmovups       %ymm2,0x100(%rsp)
  .byte  197,254,91,218                      // vcvttps2dq    %ymm2,%ymm3
  .byte  196,227,125,25,218,1                // vextractf128  $0x1,%ymm3,%xmm2
  .byte  197,253,111,251                     // vmovdqa       %ymm3,%ymm7
  .byte  197,254,127,188,36,64,1,0,0         // vmovdqu       %ymm7,0x140(%rsp)
  .byte  196,193,121,110,216                 // vmovd         %r8d,%xmm3
  .byte  197,249,112,227,0                   // vpshufd       $0x0,%xmm3,%xmm4
  .byte  196,226,89,64,242                   // vpmulld       %xmm2,%xmm4,%xmm6
  .byte  197,249,111,236                     // vmovdqa       %xmm4,%xmm5
  .byte  197,249,127,108,36,192              // vmovdqa       %xmm5,-0x40(%rsp)
  .byte  197,249,127,180,36,160,0,0,0        // vmovdqa       %xmm6,0xa0(%rsp)
  .byte  196,193,121,110,209                 // vmovd         %r9d,%xmm2
  .byte  196,226,105,64,211                  // vpmulld       %xmm3,%xmm2,%xmm2
  .byte  197,121,112,194,0                   // vpshufd       $0x0,%xmm2,%xmm8
  .byte  68,139,64,12                        // mov           0xc(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  196,193,121,110,217                 // vmovd         %r9d,%xmm3
  .byte  197,249,112,219,0                   // vpshufd       $0x0,%xmm3,%xmm3
  .byte  196,227,101,24,219,1                // vinsertf128   $0x1,%xmm3,%ymm3,%ymm3
  .byte  197,252,91,219                      // vcvtdq2ps     %ymm3,%ymm3
  .byte  197,228,89,201                      // vmulps        %ymm1,%ymm3,%ymm1
  .byte  197,252,17,140,36,128,0,0,0         // vmovups       %ymm1,0x80(%rsp)
  .byte  197,254,91,217                      // vcvttps2dq    %ymm1,%ymm3
  .byte  196,227,125,25,217,1                // vextractf128  $0x1,%ymm3,%xmm1
  .byte  197,125,111,211                     // vmovdqa       %ymm3,%ymm10
  .byte  197,126,127,148,36,192,0,0,0        // vmovdqu       %ymm10,0xc0(%rsp)
  .byte  196,226,57,64,217                   // vpmulld       %xmm1,%xmm8,%xmm3
  .byte  197,249,127,156,36,224,0,0,0        // vmovdqa       %xmm3,0xe0(%rsp)
  .byte  196,193,121,110,200                 // vmovd         %r8d,%xmm1
  .byte  196,226,113,64,202                  // vpmulld       %xmm2,%xmm1,%xmm1
  .byte  197,249,112,225,0                   // vpshufd       $0x0,%xmm1,%xmm4
  .byte  68,139,64,8                         // mov           0x8(%rax),%r8d
  .byte  65,255,200                          // dec           %r8d
  .byte  196,193,121,110,200                 // vmovd         %r8d,%xmm1
  .byte  197,249,112,201,0                   // vpshufd       $0x0,%xmm1,%xmm1
  .byte  196,227,117,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm1,%ymm1
  .byte  197,252,91,201                      // vcvtdq2ps     %ymm1,%ymm1
  .byte  197,116,89,248                      // vmulps        %ymm0,%ymm1,%ymm15
  .byte  196,65,126,91,223                   // vcvttps2dq    %ymm15,%ymm11
  .byte  196,99,125,25,216,1                 // vextractf128  $0x1,%ymm11,%xmm0
  .byte  196,226,89,64,208                   // vpmulld       %xmm0,%xmm4,%xmm2
  .byte  197,249,127,84,36,128               // vmovdqa       %xmm2,-0x80(%rsp)
  .byte  72,139,0                            // mov           (%rax),%rax
  .byte  196,193,126,91,201                  // vcvttps2dq    %ymm9,%ymm1
  .byte  197,254,127,140,36,192,1,0,0        // vmovdqu       %ymm1,0x1c0(%rsp)
  .byte  196,227,125,25,200,1                // vextractf128  $0x1,%ymm1,%xmm0
  .byte  197,249,127,68,36,96                // vmovdqa       %xmm0,0x60(%rsp)
  .byte  197,201,254,192                     // vpaddd        %xmm0,%xmm6,%xmm0
  .byte  197,249,127,68,36,32                // vmovdqa       %xmm0,0x20(%rsp)
  .byte  197,225,254,216                     // vpaddd        %xmm0,%xmm3,%xmm3
  .byte  197,233,254,195                     // vpaddd        %xmm3,%xmm2,%xmm0
  .byte  196,98,121,24,13,219,9,2,0          // vbroadcastss  0x209db(%rip),%xmm9        # 3a380 <_sk_srcover_bgra_8888_sse2_lowp+0x418>
  .byte  196,194,121,64,209                  // vpmulld       %xmm9,%xmm0,%xmm2
  .byte  196,226,81,64,199                   // vpmulld       %xmm7,%xmm5,%xmm0
  .byte  197,249,127,132,36,96,1,0,0         // vmovdqa       %xmm0,0x160(%rsp)
  .byte  197,121,254,241                     // vpaddd        %xmm1,%xmm0,%xmm14
  .byte  196,194,57,64,194                   // vpmulld       %xmm10,%xmm8,%xmm0
  .byte  197,249,127,68,36,240               // vmovdqa       %xmm0,-0x10(%rsp)
  .byte  196,193,121,254,206                 // vpaddd        %xmm14,%xmm0,%xmm1
  .byte  196,194,89,64,195                   // vpmulld       %xmm11,%xmm4,%xmm0
  .byte  197,249,127,68,36,144               // vmovdqa       %xmm0,-0x70(%rsp)
  .byte  197,249,254,193                     // vpaddd        %xmm1,%xmm0,%xmm0
  .byte  196,194,121,64,193                  // vpmulld       %xmm9,%xmm0,%xmm0
  .byte  196,193,121,126,192                 // vmovd         %xmm0,%r8d
  .byte  196,195,121,22,193,1                // vpextrd       $0x1,%xmm0,%r9d
  .byte  196,195,121,22,194,2                // vpextrd       $0x2,%xmm0,%r10d
  .byte  196,195,121,22,195,3                // vpextrd       $0x3,%xmm0,%r11d
  .byte  196,193,121,126,215                 // vmovd         %xmm2,%r15d
  .byte  196,195,121,22,214,1                // vpextrd       $0x1,%xmm2,%r14d
  .byte  196,195,121,22,212,2                // vpextrd       $0x2,%xmm2,%r12d
  .byte  196,227,121,22,211,3                // vpextrd       $0x3,%xmm2,%ebx
  .byte  196,161,122,16,44,184               // vmovss        (%rax,%r15,4),%xmm5
  .byte  196,163,81,33,44,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm5,%xmm5
  .byte  196,163,81,33,44,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm5,%xmm5
  .byte  196,227,81,33,44,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm5,%xmm5
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,163,65,33,60,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm7,%xmm7
  .byte  196,163,65,33,60,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm7,%xmm7
  .byte  196,163,65,33,60,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm7,%xmm7
  .byte  196,99,69,24,237,1                  // vinsertf128   $0x1,%xmm5,%ymm7,%ymm13
  .byte  197,201,118,246                     // vpcmpeqd      %xmm6,%xmm6,%xmm6
  .byte  197,249,250,238                     // vpsubd        %xmm6,%xmm0,%xmm5
  .byte  196,195,249,22,232,1                // vpextrq       $0x1,%xmm5,%r8
  .byte  196,193,249,126,233                 // vmovq         %xmm5,%r9
  .byte  197,233,250,238                     // vpsubd        %xmm6,%xmm2,%xmm5
  .byte  196,195,249,22,234,1                // vpextrq       $0x1,%xmm5,%r10
  .byte  196,225,249,126,235                 // vmovq         %xmm5,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,44,152               // vmovss        (%rax,%r11,4),%xmm5
  .byte  196,227,81,33,44,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm5,%xmm5
  .byte  196,161,122,16,60,176               // vmovss        (%rax,%r14,4),%xmm7
  .byte  196,227,81,33,239,32                // vinsertps     $0x20,%xmm7,%xmm5,%xmm5
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,81,33,239,48                // vinsertps     $0x30,%xmm7,%xmm5,%xmm5
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,60,152                   // vmovss        (%rax,%rbx,4),%xmm7
  .byte  196,163,65,33,60,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm7,%xmm7
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,65,33,246,32                // vinsertps     $0x20,%xmm6,%xmm7,%xmm6
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,73,33,247,48                // vinsertps     $0x30,%xmm7,%xmm6,%xmm6
  .byte  196,227,77,24,237,1                 // vinsertf128   $0x1,%xmm5,%ymm6,%ymm5
  .byte  196,98,121,24,21,68,7,2,0           // vbroadcastss  0x20744(%rip),%xmm10        # 3a224 <_sk_srcover_bgra_8888_sse2_lowp+0x2bc>
  .byte  196,193,121,254,194                 // vpaddd        %xmm10,%xmm0,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  196,193,105,254,194                 // vpaddd        %xmm10,%xmm2,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,20,176               // vmovss        (%rax,%r14,4),%xmm2
  .byte  196,227,121,33,194,32               // vinsertps     $0x20,%xmm2,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,20,144               // vmovss        (%rax,%r10,4),%xmm2
  .byte  196,227,121,33,194,48               // vinsertps     $0x30,%xmm2,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,20,152                   // vmovss        (%rax,%rbx,4),%xmm2
  .byte  196,163,105,33,20,136,16            // vinsertps     $0x10,(%rax,%r9,4),%xmm2,%xmm2
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,105,33,214,32               // vinsertps     $0x20,%xmm6,%xmm2,%xmm2
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,52,128               // vmovss        (%rax,%r8,4),%xmm6
  .byte  196,227,105,33,214,48               // vinsertps     $0x30,%xmm6,%xmm2,%xmm2
  .byte  196,227,109,24,208,1                // vinsertf128   $0x1,%xmm0,%ymm2,%ymm2
  .byte  196,98,125,24,37,8,8,2,0            // vbroadcastss  0x20808(%rip),%ymm12        # 3a37c <_sk_srcover_bgra_8888_sse2_lowp+0x414>
  .byte  196,193,4,88,196                    // vaddps        %ymm12,%ymm15,%ymm0
  .byte  197,124,17,36,36                    // vmovups       %ymm12,(%rsp)
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  196,227,125,25,198,1                // vextractf128  $0x1,%ymm0,%xmm6
  .byte  196,226,89,64,246                   // vpmulld       %xmm6,%xmm4,%xmm6
  .byte  197,249,127,116,36,176              // vmovdqa       %xmm6,-0x50(%rsp)
  .byte  196,226,89,64,192                   // vpmulld       %xmm0,%xmm4,%xmm0
  .byte  197,249,127,68,36,160               // vmovdqa       %xmm0,-0x60(%rsp)
  .byte  197,249,254,193                     // vpaddd        %xmm1,%xmm0,%xmm0
  .byte  197,201,254,203                     // vpaddd        %xmm3,%xmm6,%xmm1
  .byte  196,194,113,64,201                  // vpmulld       %xmm9,%xmm1,%xmm1
  .byte  196,194,121,64,225                  // vpmulld       %xmm9,%xmm0,%xmm4
  .byte  196,193,121,126,225                 // vmovd         %xmm4,%r9d
  .byte  196,195,121,22,224,1                // vpextrd       $0x1,%xmm4,%r8d
  .byte  196,195,121,22,226,2                // vpextrd       $0x2,%xmm4,%r10d
  .byte  196,195,121,22,227,3                // vpextrd       $0x3,%xmm4,%r11d
  .byte  196,193,121,126,207                 // vmovd         %xmm1,%r15d
  .byte  196,195,121,22,206,1                // vpextrd       $0x1,%xmm1,%r14d
  .byte  196,195,121,22,204,2                // vpextrd       $0x2,%xmm1,%r12d
  .byte  196,227,121,22,203,3                // vpextrd       $0x3,%xmm1,%ebx
  .byte  196,161,122,16,4,184                // vmovss        (%rax,%r15,4),%xmm0
  .byte  196,163,121,33,4,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm0,%xmm0
  .byte  196,163,121,33,4,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm0,%xmm0
  .byte  196,227,121,33,4,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,28,136               // vmovss        (%rax,%r9,4),%xmm3
  .byte  196,163,97,33,28,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm3,%xmm3
  .byte  196,227,101,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm3,%ymm0
  .byte  197,201,118,246                     // vpcmpeqd      %xmm6,%xmm6,%xmm6
  .byte  197,217,250,222                     // vpsubd        %xmm6,%xmm4,%xmm3
  .byte  196,195,249,22,216,1                // vpextrq       $0x1,%xmm3,%r8
  .byte  196,193,249,126,217                 // vmovq         %xmm3,%r9
  .byte  197,241,250,222                     // vpsubd        %xmm6,%xmm1,%xmm3
  .byte  196,195,249,22,218,1                // vpextrq       $0x1,%xmm3,%r10
  .byte  196,225,249,126,219                 // vmovq         %xmm3,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,28,152               // vmovss        (%rax,%r11,4),%xmm3
  .byte  196,227,97,33,28,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm3,%xmm3
  .byte  196,161,122,16,52,176               // vmovss        (%rax,%r14,4),%xmm6
  .byte  196,227,97,33,222,32                // vinsertps     $0x20,%xmm6,%xmm3,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,97,33,222,48                // vinsertps     $0x30,%xmm6,%xmm3,%xmm3
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,52,152                   // vmovss        (%rax,%rbx,4),%xmm6
  .byte  196,163,73,33,52,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm6,%xmm6
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,73,33,247,32                // vinsertps     $0x20,%xmm7,%xmm6,%xmm6
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,73,33,247,48                // vinsertps     $0x30,%xmm7,%xmm6,%xmm6
  .byte  196,227,77,24,219,1                 // vinsertf128   $0x1,%xmm3,%ymm6,%ymm3
  .byte  196,193,89,254,226                  // vpaddd        %xmm10,%xmm4,%xmm4
  .byte  196,195,249,22,224,1                // vpextrq       $0x1,%xmm4,%r8
  .byte  196,193,249,126,225                 // vmovq         %xmm4,%r9
  .byte  196,193,113,254,202                 // vpaddd        %xmm10,%xmm1,%xmm1
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  196,225,249,126,203                 // vmovq         %xmm1,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,12,152               // vmovss        (%rax,%r11,4),%xmm1
  .byte  196,227,113,33,12,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm1,%xmm1
  .byte  196,161,122,16,36,176               // vmovss        (%rax,%r14,4),%xmm4
  .byte  196,227,113,33,204,32               // vinsertps     $0x20,%xmm4,%xmm1,%xmm1
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,113,33,204,48               // vinsertps     $0x30,%xmm4,%xmm1,%xmm1
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,36,152                   // vmovss        (%rax,%rbx,4),%xmm4
  .byte  196,163,89,33,36,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm4,%xmm4
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,89,33,230,32                // vinsertps     $0x20,%xmm6,%xmm4,%xmm4
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,52,128               // vmovss        (%rax,%r8,4),%xmm6
  .byte  196,227,89,33,230,48                // vinsertps     $0x30,%xmm6,%xmm4,%xmm4
  .byte  196,227,93,24,201,1                 // vinsertf128   $0x1,%xmm1,%ymm4,%ymm1
  .byte  196,193,124,91,227                  // vcvtdq2ps     %ymm11,%ymm4
  .byte  197,4,92,252                        // vsubps        %ymm4,%ymm15,%ymm15
  .byte  196,193,124,92,197                  // vsubps        %ymm13,%ymm0,%ymm0
  .byte  197,132,89,192                      // vmulps        %ymm0,%ymm15,%ymm0
  .byte  197,148,88,192                      // vaddps        %ymm0,%ymm13,%ymm0
  .byte  197,252,17,132,36,32,1,0,0          // vmovups       %ymm0,0x120(%rsp)
  .byte  197,228,92,197                      // vsubps        %ymm5,%ymm3,%ymm0
  .byte  197,132,89,192                      // vmulps        %ymm0,%ymm15,%ymm0
  .byte  197,212,88,192                      // vaddps        %ymm0,%ymm5,%ymm0
  .byte  197,252,17,68,36,64                 // vmovups       %ymm0,0x40(%rsp)
  .byte  197,244,92,194                      // vsubps        %ymm2,%ymm1,%ymm0
  .byte  197,132,89,192                      // vmulps        %ymm0,%ymm15,%ymm0
  .byte  197,108,88,232                      // vaddps        %ymm0,%ymm2,%ymm13
  .byte  197,124,16,156,36,128,0,0,0         // vmovups       0x80(%rsp),%ymm11
  .byte  196,193,36,88,196                   // vaddps        %ymm12,%ymm11,%ymm0
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  196,226,57,64,200                   // vpmulld       %xmm0,%xmm8,%xmm1
  .byte  197,249,127,76,36,224               // vmovdqa       %xmm1,-0x20(%rsp)
  .byte  196,227,125,25,192,1                // vextractf128  $0x1,%ymm0,%xmm0
  .byte  196,226,57,64,192                   // vpmulld       %xmm0,%xmm8,%xmm0
  .byte  197,249,127,68,36,208               // vmovdqa       %xmm0,-0x30(%rsp)
  .byte  197,249,254,108,36,32               // vpaddd        0x20(%rsp),%xmm0,%xmm5
  .byte  196,193,113,254,198                 // vpaddd        %xmm14,%xmm1,%xmm0
  .byte  197,121,111,100,36,128              // vmovdqa       -0x80(%rsp),%xmm12
  .byte  196,193,81,254,204                  // vpaddd        %xmm12,%xmm5,%xmm1
  .byte  196,194,113,64,209                  // vpmulld       %xmm9,%xmm1,%xmm2
  .byte  197,121,111,68,36,144               // vmovdqa       -0x70(%rsp),%xmm8
  .byte  196,193,121,254,200                 // vpaddd        %xmm8,%xmm0,%xmm1
  .byte  196,194,113,64,241                  // vpmulld       %xmm9,%xmm1,%xmm6
  .byte  196,193,121,126,241                 // vmovd         %xmm6,%r9d
  .byte  196,195,121,22,240,1                // vpextrd       $0x1,%xmm6,%r8d
  .byte  196,195,121,22,242,2                // vpextrd       $0x2,%xmm6,%r10d
  .byte  196,195,121,22,243,3                // vpextrd       $0x3,%xmm6,%r11d
  .byte  196,193,121,126,215                 // vmovd         %xmm2,%r15d
  .byte  196,195,121,22,214,1                // vpextrd       $0x1,%xmm2,%r14d
  .byte  196,195,121,22,212,2                // vpextrd       $0x2,%xmm2,%r12d
  .byte  196,227,121,22,211,3                // vpextrd       $0x3,%xmm2,%ebx
  .byte  196,161,122,16,12,184               // vmovss        (%rax,%r15,4),%xmm1
  .byte  196,163,113,33,12,176,16            // vinsertps     $0x10,(%rax,%r14,4),%xmm1,%xmm1
  .byte  196,163,113,33,12,160,32            // vinsertps     $0x20,(%rax,%r12,4),%xmm1,%xmm1
  .byte  196,227,113,33,12,152,48            // vinsertps     $0x30,(%rax,%rbx,4),%xmm1,%xmm1
  .byte  196,161,122,16,28,136               // vmovss        (%rax,%r9,4),%xmm3
  .byte  196,163,97,33,28,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm3,%xmm3
  .byte  196,99,101,24,241,1                 // vinsertf128   $0x1,%xmm1,%ymm3,%ymm14
  .byte  197,225,118,219                     // vpcmpeqd      %xmm3,%xmm3,%xmm3
  .byte  197,201,250,203                     // vpsubd        %xmm3,%xmm6,%xmm1
  .byte  196,195,249,22,200,1                // vpextrq       $0x1,%xmm1,%r8
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  197,233,250,203                     // vpsubd        %xmm3,%xmm2,%xmm1
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  196,225,249,126,203                 // vmovq         %xmm1,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,12,152               // vmovss        (%rax,%r11,4),%xmm1
  .byte  196,227,113,33,12,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm1,%xmm1
  .byte  196,161,122,16,28,176               // vmovss        (%rax,%r14,4),%xmm3
  .byte  196,227,113,33,203,32               // vinsertps     $0x20,%xmm3,%xmm1,%xmm1
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,113,33,203,48               // vinsertps     $0x30,%xmm3,%xmm1,%xmm1
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,28,152                   // vmovss        (%rax,%rbx,4),%xmm3
  .byte  196,163,97,33,28,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm3,%xmm3
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,97,33,220,32                // vinsertps     $0x20,%xmm4,%xmm3,%xmm3
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,36,128               // vmovss        (%rax,%r8,4),%xmm4
  .byte  196,227,97,33,220,48                // vinsertps     $0x30,%xmm4,%xmm3,%xmm3
  .byte  196,227,101,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm3,%ymm1
  .byte  196,193,73,254,218                  // vpaddd        %xmm10,%xmm6,%xmm3
  .byte  196,195,249,22,216,1                // vpextrq       $0x1,%xmm3,%r8
  .byte  196,193,249,126,217                 // vmovq         %xmm3,%r9
  .byte  196,193,105,254,210                 // vpaddd        %xmm10,%xmm2,%xmm2
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  196,225,249,126,211                 // vmovq         %xmm2,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,20,152               // vmovss        (%rax,%r11,4),%xmm2
  .byte  196,227,105,33,20,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm2,%xmm2
  .byte  196,161,122,16,28,176               // vmovss        (%rax,%r14,4),%xmm3
  .byte  196,227,105,33,211,32               // vinsertps     $0x20,%xmm3,%xmm2,%xmm2
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,105,33,211,48               // vinsertps     $0x30,%xmm3,%xmm2,%xmm2
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,28,152                   // vmovss        (%rax,%rbx,4),%xmm3
  .byte  196,163,97,33,28,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm3,%xmm3
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,97,33,220,32                // vinsertps     $0x20,%xmm4,%xmm3,%xmm3
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,36,128               // vmovss        (%rax,%r8,4),%xmm4
  .byte  196,227,97,33,220,48                // vinsertps     $0x30,%xmm4,%xmm3,%xmm3
  .byte  196,227,101,24,242,1                // vinsertf128   $0x1,%xmm2,%ymm3,%ymm6
  .byte  197,249,254,68,36,160               // vpaddd        -0x60(%rsp),%xmm0,%xmm0
  .byte  197,209,254,84,36,176               // vpaddd        -0x50(%rsp),%xmm5,%xmm2
  .byte  196,194,105,64,209                  // vpmulld       %xmm9,%xmm2,%xmm2
  .byte  196,194,121,64,233                  // vpmulld       %xmm9,%xmm0,%xmm5
  .byte  196,193,121,126,233                 // vmovd         %xmm5,%r9d
  .byte  196,195,121,22,232,1                // vpextrd       $0x1,%xmm5,%r8d
  .byte  196,195,121,22,234,2                // vpextrd       $0x2,%xmm5,%r10d
  .byte  196,195,121,22,235,3                // vpextrd       $0x3,%xmm5,%r11d
  .byte  196,193,121,126,215                 // vmovd         %xmm2,%r15d
  .byte  196,195,121,22,214,1                // vpextrd       $0x1,%xmm2,%r14d
  .byte  196,195,121,22,212,2                // vpextrd       $0x2,%xmm2,%r12d
  .byte  196,227,121,22,211,3                // vpextrd       $0x3,%xmm2,%ebx
  .byte  196,161,122,16,4,184                // vmovss        (%rax,%r15,4),%xmm0
  .byte  196,163,121,33,4,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm0,%xmm0
  .byte  196,163,121,33,4,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm0,%xmm0
  .byte  196,227,121,33,4,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,28,136               // vmovss        (%rax,%r9,4),%xmm3
  .byte  196,163,97,33,28,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm3,%xmm3
  .byte  196,227,101,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm3,%ymm0
  .byte  197,217,118,228                     // vpcmpeqd      %xmm4,%xmm4,%xmm4
  .byte  197,209,250,220                     // vpsubd        %xmm4,%xmm5,%xmm3
  .byte  196,195,249,22,216,1                // vpextrq       $0x1,%xmm3,%r8
  .byte  196,193,249,126,217                 // vmovq         %xmm3,%r9
  .byte  197,233,250,220                     // vpsubd        %xmm4,%xmm2,%xmm3
  .byte  196,195,249,22,218,1                // vpextrq       $0x1,%xmm3,%r10
  .byte  196,225,249,126,219                 // vmovq         %xmm3,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,28,152               // vmovss        (%rax,%r11,4),%xmm3
  .byte  196,227,97,33,28,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm3,%xmm3
  .byte  196,161,122,16,36,176               // vmovss        (%rax,%r14,4),%xmm4
  .byte  196,227,97,33,220,32                // vinsertps     $0x20,%xmm4,%xmm3,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,97,33,220,48                // vinsertps     $0x30,%xmm4,%xmm3,%xmm3
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,36,152                   // vmovss        (%rax,%rbx,4),%xmm4
  .byte  196,163,89,33,36,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm4,%xmm4
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,89,33,231,32                // vinsertps     $0x20,%xmm7,%xmm4,%xmm4
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,89,33,231,48                // vinsertps     $0x30,%xmm7,%xmm4,%xmm4
  .byte  196,227,93,24,219,1                 // vinsertf128   $0x1,%xmm3,%ymm4,%ymm3
  .byte  196,193,81,254,226                  // vpaddd        %xmm10,%xmm5,%xmm4
  .byte  196,195,249,22,224,1                // vpextrq       $0x1,%xmm4,%r8
  .byte  196,193,249,126,225                 // vmovq         %xmm4,%r9
  .byte  196,193,105,254,210                 // vpaddd        %xmm10,%xmm2,%xmm2
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  196,225,249,126,211                 // vmovq         %xmm2,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,20,152               // vmovss        (%rax,%r11,4),%xmm2
  .byte  196,227,105,33,20,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm2,%xmm2
  .byte  196,161,122,16,36,176               // vmovss        (%rax,%r14,4),%xmm4
  .byte  196,227,105,33,212,32               // vinsertps     $0x20,%xmm4,%xmm2,%xmm2
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,105,33,212,48               // vinsertps     $0x30,%xmm4,%xmm2,%xmm2
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,36,152                   // vmovss        (%rax,%rbx,4),%xmm4
  .byte  196,163,89,33,36,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm4,%xmm4
  .byte  196,161,122,16,44,144               // vmovss        (%rax,%r10,4),%xmm5
  .byte  196,227,89,33,229,32                // vinsertps     $0x20,%xmm5,%xmm4,%xmm4
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,44,128               // vmovss        (%rax,%r8,4),%xmm5
  .byte  196,227,89,33,229,48                // vinsertps     $0x30,%xmm5,%xmm4,%xmm4
  .byte  196,227,93,24,210,1                 // vinsertf128   $0x1,%xmm2,%ymm4,%ymm2
  .byte  196,193,124,92,198                  // vsubps        %ymm14,%ymm0,%ymm0
  .byte  197,132,89,192                      // vmulps        %ymm0,%ymm15,%ymm0
  .byte  197,140,88,192                      // vaddps        %ymm0,%ymm14,%ymm0
  .byte  197,228,92,217                      // vsubps        %ymm1,%ymm3,%ymm3
  .byte  197,132,89,219                      // vmulps        %ymm3,%ymm15,%ymm3
  .byte  197,244,88,203                      // vaddps        %ymm3,%ymm1,%ymm1
  .byte  197,236,92,214                      // vsubps        %ymm6,%ymm2,%ymm2
  .byte  197,132,89,210                      // vmulps        %ymm2,%ymm15,%ymm2
  .byte  197,204,88,210                      // vaddps        %ymm2,%ymm6,%ymm2
  .byte  197,252,91,156,36,192,0,0,0         // vcvtdq2ps     0xc0(%rsp),%ymm3
  .byte  197,164,92,219                      // vsubps        %ymm3,%ymm11,%ymm3
  .byte  197,252,17,156,36,192,0,0,0         // vmovups       %ymm3,0xc0(%rsp)
  .byte  197,252,16,164,36,32,1,0,0          // vmovups       0x120(%rsp),%ymm4
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,220,88,192                      // vaddps        %ymm0,%ymm4,%ymm0
  .byte  197,252,17,132,36,128,0,0,0         // vmovups       %ymm0,0x80(%rsp)
  .byte  197,252,16,100,36,64                // vmovups       0x40(%rsp),%ymm4
  .byte  197,244,92,196                      // vsubps        %ymm4,%ymm1,%ymm0
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,220,88,192                      // vaddps        %ymm0,%ymm4,%ymm0
  .byte  197,252,17,68,36,64                 // vmovups       %ymm0,0x40(%rsp)
  .byte  196,193,108,92,197                  // vsubps        %ymm13,%ymm2,%ymm0
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,148,88,192                      // vaddps        %ymm0,%ymm13,%ymm0
  .byte  197,252,17,68,36,32                 // vmovups       %ymm0,0x20(%rsp)
  .byte  197,252,16,4,36                     // vmovups       (%rsp),%ymm0
  .byte  197,252,88,132,36,0,1,0,0           // vaddps        0x100(%rsp),%ymm0,%ymm0
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  196,227,125,25,193,1                // vextractf128  $0x1,%ymm0,%xmm1
  .byte  197,249,111,84,36,192               // vmovdqa       -0x40(%rsp),%xmm2
  .byte  196,226,105,64,201                  // vpmulld       %xmm1,%xmm2,%xmm1
  .byte  197,249,127,140,36,32,1,0,0         // vmovdqa       %xmm1,0x120(%rsp)
  .byte  196,226,105,64,192                  // vpmulld       %xmm0,%xmm2,%xmm0
  .byte  197,249,127,68,36,192               // vmovdqa       %xmm0,-0x40(%rsp)
  .byte  197,241,254,76,36,96                // vpaddd        0x60(%rsp),%xmm1,%xmm1
  .byte  197,249,127,140,36,176,1,0,0        // vmovdqa       %xmm1,0x1b0(%rsp)
  .byte  197,241,254,172,36,224,0,0,0        // vpaddd        0xe0(%rsp),%xmm1,%xmm5
  .byte  196,193,81,254,204                  // vpaddd        %xmm12,%xmm5,%xmm1
  .byte  196,194,113,64,225                  // vpmulld       %xmm9,%xmm1,%xmm4
  .byte  197,121,254,180,36,192,1,0,0        // vpaddd        0x1c0(%rsp),%xmm0,%xmm14
  .byte  197,137,254,84,36,240               // vpaddd        -0x10(%rsp),%xmm14,%xmm2
  .byte  196,193,105,254,248                 // vpaddd        %xmm8,%xmm2,%xmm7
  .byte  196,194,65,64,249                   // vpmulld       %xmm9,%xmm7,%xmm7
  .byte  196,193,121,126,249                 // vmovd         %xmm7,%r9d
  .byte  196,195,121,22,248,1                // vpextrd       $0x1,%xmm7,%r8d
  .byte  196,195,121,22,250,2                // vpextrd       $0x2,%xmm7,%r10d
  .byte  196,195,121,22,251,3                // vpextrd       $0x3,%xmm7,%r11d
  .byte  196,193,121,126,231                 // vmovd         %xmm4,%r15d
  .byte  196,195,121,22,230,1                // vpextrd       $0x1,%xmm4,%r14d
  .byte  196,195,121,22,228,2                // vpextrd       $0x2,%xmm4,%r12d
  .byte  196,227,121,22,227,3                // vpextrd       $0x3,%xmm4,%ebx
  .byte  196,161,122,16,28,184               // vmovss        (%rax,%r15,4),%xmm3
  .byte  196,163,97,33,28,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm3,%xmm3
  .byte  196,227,97,33,28,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm3,%xmm3
  .byte  196,161,122,16,52,136               // vmovss        (%rax,%r9,4),%xmm6
  .byte  196,163,73,33,52,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm6,%xmm6
  .byte  196,163,73,33,52,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm6,%xmm6
  .byte  196,163,73,33,52,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm6,%xmm6
  .byte  196,227,77,24,203,1                 // vinsertf128   $0x1,%xmm3,%ymm6,%ymm1
  .byte  197,249,118,192                     // vpcmpeqd      %xmm0,%xmm0,%xmm0
  .byte  197,193,250,216                     // vpsubd        %xmm0,%xmm7,%xmm3
  .byte  196,195,249,22,216,1                // vpextrq       $0x1,%xmm3,%r8
  .byte  196,193,249,126,217                 // vmovq         %xmm3,%r9
  .byte  197,217,250,216                     // vpsubd        %xmm0,%xmm4,%xmm3
  .byte  196,195,249,22,218,1                // vpextrq       $0x1,%xmm3,%r10
  .byte  196,225,249,126,219                 // vmovq         %xmm3,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,28,152               // vmovss        (%rax,%r11,4),%xmm3
  .byte  196,227,97,33,28,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm3,%xmm3
  .byte  196,161,122,16,52,176               // vmovss        (%rax,%r14,4),%xmm6
  .byte  196,227,97,33,222,32                // vinsertps     $0x20,%xmm6,%xmm3,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,97,33,222,48                // vinsertps     $0x30,%xmm6,%xmm3,%xmm3
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,52,152                   // vmovss        (%rax,%rbx,4),%xmm6
  .byte  196,163,73,33,52,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm6,%xmm6
  .byte  196,161,122,16,4,144                // vmovss        (%rax,%r10,4),%xmm0
  .byte  196,227,73,33,192,32                // vinsertps     $0x20,%xmm0,%xmm6,%xmm0
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,52,128               // vmovss        (%rax,%r8,4),%xmm6
  .byte  196,227,121,33,198,48               // vinsertps     $0x30,%xmm6,%xmm0,%xmm0
  .byte  196,99,125,24,235,1                 // vinsertf128   $0x1,%xmm3,%ymm0,%ymm13
  .byte  196,193,65,254,194                  // vpaddd        %xmm10,%xmm7,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  196,193,89,254,194                  // vpaddd        %xmm10,%xmm4,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,28,176               // vmovss        (%rax,%r14,4),%xmm3
  .byte  196,227,121,33,195,32               // vinsertps     $0x20,%xmm3,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,121,33,195,48               // vinsertps     $0x30,%xmm3,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,28,152                   // vmovss        (%rax,%rbx,4),%xmm3
  .byte  196,163,97,33,28,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm3,%xmm3
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,97,33,220,32                // vinsertps     $0x20,%xmm4,%xmm3,%xmm3
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,36,128               // vmovss        (%rax,%r8,4),%xmm4
  .byte  196,227,97,33,220,48                // vinsertps     $0x30,%xmm4,%xmm3,%xmm3
  .byte  196,99,101,24,216,1                 // vinsertf128   $0x1,%xmm0,%ymm3,%ymm11
  .byte  197,121,111,100,36,160              // vmovdqa       -0x60(%rsp),%xmm12
  .byte  197,153,254,194                     // vpaddd        %xmm2,%xmm12,%xmm0
  .byte  197,121,111,68,36,176               // vmovdqa       -0x50(%rsp),%xmm8
  .byte  197,185,254,213                     // vpaddd        %xmm5,%xmm8,%xmm2
  .byte  196,194,105,64,225                  // vpmulld       %xmm9,%xmm2,%xmm4
  .byte  196,194,121,64,233                  // vpmulld       %xmm9,%xmm0,%xmm5
  .byte  196,193,121,126,233                 // vmovd         %xmm5,%r9d
  .byte  196,195,121,22,232,1                // vpextrd       $0x1,%xmm5,%r8d
  .byte  196,195,121,22,234,2                // vpextrd       $0x2,%xmm5,%r10d
  .byte  196,195,121,22,235,3                // vpextrd       $0x3,%xmm5,%r11d
  .byte  196,193,121,126,231                 // vmovd         %xmm4,%r15d
  .byte  196,195,121,22,230,1                // vpextrd       $0x1,%xmm4,%r14d
  .byte  196,195,121,22,228,2                // vpextrd       $0x2,%xmm4,%r12d
  .byte  196,227,121,22,227,3                // vpextrd       $0x3,%xmm4,%ebx
  .byte  196,161,122,16,4,184                // vmovss        (%rax,%r15,4),%xmm0
  .byte  196,163,121,33,4,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm0,%xmm0
  .byte  196,163,121,33,4,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm0,%xmm0
  .byte  196,227,121,33,4,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,20,136               // vmovss        (%rax,%r9,4),%xmm2
  .byte  196,163,105,33,20,128,16            // vinsertps     $0x10,(%rax,%r8,4),%xmm2,%xmm2
  .byte  196,163,105,33,20,144,32            // vinsertps     $0x20,(%rax,%r10,4),%xmm2,%xmm2
  .byte  196,163,105,33,20,152,48            // vinsertps     $0x30,(%rax,%r11,4),%xmm2,%xmm2
  .byte  196,227,109,24,208,1                // vinsertf128   $0x1,%xmm0,%ymm2,%ymm2
  .byte  197,225,118,219                     // vpcmpeqd      %xmm3,%xmm3,%xmm3
  .byte  197,209,250,195                     // vpsubd        %xmm3,%xmm5,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  197,217,250,195                     // vpsubd        %xmm3,%xmm4,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,28,176               // vmovss        (%rax,%r14,4),%xmm3
  .byte  196,227,121,33,195,32               // vinsertps     $0x20,%xmm3,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,121,33,195,48               // vinsertps     $0x30,%xmm3,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,28,152                   // vmovss        (%rax,%rbx,4),%xmm3
  .byte  196,163,97,33,28,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm3,%xmm3
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,97,33,222,32                // vinsertps     $0x20,%xmm6,%xmm3,%xmm3
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,52,128               // vmovss        (%rax,%r8,4),%xmm6
  .byte  196,227,97,33,222,48                // vinsertps     $0x30,%xmm6,%xmm3,%xmm3
  .byte  196,227,101,24,248,1                // vinsertf128   $0x1,%xmm0,%ymm3,%ymm7
  .byte  196,193,81,254,194                  // vpaddd        %xmm10,%xmm5,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  196,193,89,254,194                  // vpaddd        %xmm10,%xmm4,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,28,176               // vmovss        (%rax,%r14,4),%xmm3
  .byte  196,227,121,33,195,32               // vinsertps     $0x20,%xmm3,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,121,33,195,48               // vinsertps     $0x30,%xmm3,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,28,152                   // vmovss        (%rax,%rbx,4),%xmm3
  .byte  196,163,97,33,28,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm3,%xmm3
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,97,33,220,32                // vinsertps     $0x20,%xmm4,%xmm3,%xmm3
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,36,128               // vmovss        (%rax,%r8,4),%xmm4
  .byte  196,227,97,33,220,48                // vinsertps     $0x30,%xmm4,%xmm3,%xmm3
  .byte  196,227,101,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm3,%ymm0
  .byte  197,236,92,209                      // vsubps        %ymm1,%ymm2,%ymm2
  .byte  197,132,89,210                      // vmulps        %ymm2,%ymm15,%ymm2
  .byte  197,244,88,202                      // vaddps        %ymm2,%ymm1,%ymm1
  .byte  197,252,17,76,36,96                 // vmovups       %ymm1,0x60(%rsp)
  .byte  196,193,68,92,213                   // vsubps        %ymm13,%ymm7,%ymm2
  .byte  197,132,89,210                      // vmulps        %ymm2,%ymm15,%ymm2
  .byte  197,148,88,202                      // vaddps        %ymm2,%ymm13,%ymm1
  .byte  197,252,17,140,36,32,2,0,0          // vmovups       %ymm1,0x220(%rsp)
  .byte  196,193,124,92,195                  // vsubps        %ymm11,%ymm0,%ymm0
  .byte  197,132,89,192                      // vmulps        %ymm0,%ymm15,%ymm0
  .byte  197,164,88,192                      // vaddps        %ymm0,%ymm11,%ymm0
  .byte  197,252,17,132,36,0,2,0,0           // vmovups       %ymm0,0x200(%rsp)
  .byte  197,249,111,132,36,176,1,0,0        // vmovdqa       0x1b0(%rsp),%xmm0
  .byte  197,249,254,108,36,208              // vpaddd        -0x30(%rsp),%xmm0,%xmm5
  .byte  197,137,254,100,36,224              // vpaddd        -0x20(%rsp),%xmm14,%xmm4
  .byte  197,209,254,68,36,128               // vpaddd        -0x80(%rsp),%xmm5,%xmm0
  .byte  196,66,121,64,217                   // vpmulld       %xmm9,%xmm0,%xmm11
  .byte  197,121,111,108,36,144              // vmovdqa       -0x70(%rsp),%xmm13
  .byte  196,193,89,254,197                  // vpaddd        %xmm13,%xmm4,%xmm0
  .byte  196,194,121,64,209                  // vpmulld       %xmm9,%xmm0,%xmm2
  .byte  196,193,121,126,209                 // vmovd         %xmm2,%r9d
  .byte  196,195,121,22,208,1                // vpextrd       $0x1,%xmm2,%r8d
  .byte  196,195,121,22,210,2                // vpextrd       $0x2,%xmm2,%r10d
  .byte  196,195,121,22,211,3                // vpextrd       $0x3,%xmm2,%r11d
  .byte  196,65,121,126,223                  // vmovd         %xmm11,%r15d
  .byte  196,67,121,22,222,1                 // vpextrd       $0x1,%xmm11,%r14d
  .byte  196,67,121,22,220,2                 // vpextrd       $0x2,%xmm11,%r12d
  .byte  196,99,121,22,219,3                 // vpextrd       $0x3,%xmm11,%ebx
  .byte  196,161,122,16,4,184                // vmovss        (%rax,%r15,4),%xmm0
  .byte  196,163,121,33,4,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm0,%xmm0
  .byte  196,163,121,33,4,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm0,%xmm0
  .byte  196,227,121,33,4,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,12,136               // vmovss        (%rax,%r9,4),%xmm1
  .byte  196,163,113,33,12,128,16            // vinsertps     $0x10,(%rax,%r8,4),%xmm1,%xmm1
  .byte  196,163,113,33,12,144,32            // vinsertps     $0x20,(%rax,%r10,4),%xmm1,%xmm1
  .byte  196,163,113,33,12,152,48            // vinsertps     $0x30,(%rax,%r11,4),%xmm1,%xmm1
  .byte  196,227,117,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  197,225,118,219                     // vpcmpeqd      %xmm3,%xmm3,%xmm3
  .byte  197,233,250,203                     // vpsubd        %xmm3,%xmm2,%xmm1
  .byte  196,195,249,22,200,1                // vpextrq       $0x1,%xmm1,%r8
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  197,161,250,203                     // vpsubd        %xmm3,%xmm11,%xmm1
  .byte  197,193,118,255                     // vpcmpeqd      %xmm7,%xmm7,%xmm7
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  196,225,249,126,203                 // vmovq         %xmm1,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,12,152               // vmovss        (%rax,%r11,4),%xmm1
  .byte  196,227,113,33,12,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm1,%xmm1
  .byte  196,161,122,16,28,176               // vmovss        (%rax,%r14,4),%xmm3
  .byte  196,227,113,33,203,32               // vinsertps     $0x20,%xmm3,%xmm1,%xmm1
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,113,33,203,48               // vinsertps     $0x30,%xmm3,%xmm1,%xmm1
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,28,152                   // vmovss        (%rax,%rbx,4),%xmm3
  .byte  196,163,97,33,28,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm3,%xmm3
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,97,33,222,32                // vinsertps     $0x20,%xmm6,%xmm3,%xmm3
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,52,128               // vmovss        (%rax,%r8,4),%xmm6
  .byte  196,227,97,33,222,48                // vinsertps     $0x30,%xmm6,%xmm3,%xmm3
  .byte  196,227,101,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm3,%ymm1
  .byte  196,193,105,254,210                 // vpaddd        %xmm10,%xmm2,%xmm2
  .byte  196,195,249,22,208,1                // vpextrq       $0x1,%xmm2,%r8
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  196,193,33,254,210                  // vpaddd        %xmm10,%xmm11,%xmm2
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  196,225,249,126,211                 // vmovq         %xmm2,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,20,152               // vmovss        (%rax,%r11,4),%xmm2
  .byte  196,227,105,33,20,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm2,%xmm2
  .byte  196,161,122,16,28,176               // vmovss        (%rax,%r14,4),%xmm3
  .byte  196,227,105,33,211,32               // vinsertps     $0x20,%xmm3,%xmm2,%xmm2
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,105,33,211,48               // vinsertps     $0x30,%xmm3,%xmm2,%xmm2
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,28,152                   // vmovss        (%rax,%rbx,4),%xmm3
  .byte  196,163,97,33,28,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm3,%xmm3
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,97,33,222,32                // vinsertps     $0x20,%xmm6,%xmm3,%xmm3
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,52,128               // vmovss        (%rax,%r8,4),%xmm6
  .byte  196,227,97,33,222,48                // vinsertps     $0x30,%xmm6,%xmm3,%xmm3
  .byte  196,99,101,24,218,1                 // vinsertf128   $0x1,%xmm2,%ymm3,%ymm11
  .byte  197,153,254,212                     // vpaddd        %xmm4,%xmm12,%xmm2
  .byte  197,185,254,221                     // vpaddd        %xmm5,%xmm8,%xmm3
  .byte  196,194,97,64,225                   // vpmulld       %xmm9,%xmm3,%xmm4
  .byte  196,194,105,64,233                  // vpmulld       %xmm9,%xmm2,%xmm5
  .byte  196,193,121,126,233                 // vmovd         %xmm5,%r9d
  .byte  196,195,121,22,232,1                // vpextrd       $0x1,%xmm5,%r8d
  .byte  196,195,121,22,234,2                // vpextrd       $0x2,%xmm5,%r10d
  .byte  196,195,121,22,235,3                // vpextrd       $0x3,%xmm5,%r11d
  .byte  196,193,121,126,231                 // vmovd         %xmm4,%r15d
  .byte  196,195,121,22,230,1                // vpextrd       $0x1,%xmm4,%r14d
  .byte  196,195,121,22,228,2                // vpextrd       $0x2,%xmm4,%r12d
  .byte  196,227,121,22,227,3                // vpextrd       $0x3,%xmm4,%ebx
  .byte  196,161,122,16,20,184               // vmovss        (%rax,%r15,4),%xmm2
  .byte  196,163,105,33,20,176,16            // vinsertps     $0x10,(%rax,%r14,4),%xmm2,%xmm2
  .byte  196,163,105,33,20,160,32            // vinsertps     $0x20,(%rax,%r12,4),%xmm2,%xmm2
  .byte  196,227,105,33,20,152,48            // vinsertps     $0x30,(%rax,%rbx,4),%xmm2,%xmm2
  .byte  196,161,122,16,28,136               // vmovss        (%rax,%r9,4),%xmm3
  .byte  196,163,97,33,28,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm3,%xmm3
  .byte  196,227,101,24,210,1                // vinsertf128   $0x1,%xmm2,%ymm3,%ymm2
  .byte  197,209,250,223                     // vpsubd        %xmm7,%xmm5,%xmm3
  .byte  196,195,249,22,216,1                // vpextrq       $0x1,%xmm3,%r8
  .byte  196,193,249,126,217                 // vmovq         %xmm3,%r9
  .byte  197,217,250,223                     // vpsubd        %xmm7,%xmm4,%xmm3
  .byte  196,195,249,22,218,1                // vpextrq       $0x1,%xmm3,%r10
  .byte  196,225,249,126,219                 // vmovq         %xmm3,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,28,152               // vmovss        (%rax,%r11,4),%xmm3
  .byte  196,227,97,33,28,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm3,%xmm3
  .byte  196,161,122,16,52,176               // vmovss        (%rax,%r14,4),%xmm6
  .byte  196,227,97,33,222,32                // vinsertps     $0x20,%xmm6,%xmm3,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,97,33,222,48                // vinsertps     $0x30,%xmm6,%xmm3,%xmm3
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,52,152                   // vmovss        (%rax,%rbx,4),%xmm6
  .byte  196,163,73,33,52,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm6,%xmm6
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,73,33,247,32                // vinsertps     $0x20,%xmm7,%xmm6,%xmm6
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,73,33,247,48                // vinsertps     $0x30,%xmm7,%xmm6,%xmm6
  .byte  196,99,77,24,243,1                  // vinsertf128   $0x1,%xmm3,%ymm6,%ymm14
  .byte  196,193,81,254,218                  // vpaddd        %xmm10,%xmm5,%xmm3
  .byte  196,195,249,22,216,1                // vpextrq       $0x1,%xmm3,%r8
  .byte  196,193,249,126,217                 // vmovq         %xmm3,%r9
  .byte  196,193,89,254,218                  // vpaddd        %xmm10,%xmm4,%xmm3
  .byte  196,195,249,22,218,1                // vpextrq       $0x1,%xmm3,%r10
  .byte  196,225,249,126,219                 // vmovq         %xmm3,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,28,152               // vmovss        (%rax,%r11,4),%xmm3
  .byte  196,227,97,33,28,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm3,%xmm3
  .byte  196,161,122,16,36,176               // vmovss        (%rax,%r14,4),%xmm4
  .byte  196,227,97,33,220,32                // vinsertps     $0x20,%xmm4,%xmm3,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,97,33,220,48                // vinsertps     $0x30,%xmm4,%xmm3,%xmm3
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,36,152                   // vmovss        (%rax,%rbx,4),%xmm4
  .byte  196,163,89,33,36,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm4,%xmm4
  .byte  196,161,122,16,44,144               // vmovss        (%rax,%r10,4),%xmm5
  .byte  196,227,89,33,229,32                // vinsertps     $0x20,%xmm5,%xmm4,%xmm4
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,44,128               // vmovss        (%rax,%r8,4),%xmm5
  .byte  196,227,89,33,229,48                // vinsertps     $0x30,%xmm5,%xmm4,%xmm4
  .byte  196,227,93,24,219,1                 // vinsertf128   $0x1,%xmm3,%ymm4,%ymm3
  .byte  197,236,92,208                      // vsubps        %ymm0,%ymm2,%ymm2
  .byte  197,124,17,188,36,128,1,0,0         // vmovups       %ymm15,0x180(%rsp)
  .byte  197,132,89,210                      // vmulps        %ymm2,%ymm15,%ymm2
  .byte  197,252,88,194                      // vaddps        %ymm2,%ymm0,%ymm0
  .byte  197,140,92,209                      // vsubps        %ymm1,%ymm14,%ymm2
  .byte  197,132,89,210                      // vmulps        %ymm2,%ymm15,%ymm2
  .byte  197,244,88,202                      // vaddps        %ymm2,%ymm1,%ymm1
  .byte  196,193,100,92,211                  // vsubps        %ymm11,%ymm3,%ymm2
  .byte  197,132,89,210                      // vmulps        %ymm2,%ymm15,%ymm2
  .byte  197,164,88,210                      // vaddps        %ymm2,%ymm11,%ymm2
  .byte  197,252,16,100,36,96                // vmovups       0x60(%rsp),%ymm4
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  197,252,16,156,36,192,0,0,0         // vmovups       0xc0(%rsp),%ymm3
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,220,88,192                      // vaddps        %ymm0,%ymm4,%ymm0
  .byte  197,252,16,164,36,32,2,0,0          // vmovups       0x220(%rsp),%ymm4
  .byte  197,244,92,204                      // vsubps        %ymm4,%ymm1,%ymm1
  .byte  197,228,89,201                      // vmulps        %ymm1,%ymm3,%ymm1
  .byte  197,220,88,201                      // vaddps        %ymm1,%ymm4,%ymm1
  .byte  197,252,16,164,36,0,2,0,0           // vmovups       0x200(%rsp),%ymm4
  .byte  197,236,92,212                      // vsubps        %ymm4,%ymm2,%ymm2
  .byte  197,228,89,210                      // vmulps        %ymm2,%ymm3,%ymm2
  .byte  197,220,88,210                      // vaddps        %ymm2,%ymm4,%ymm2
  .byte  197,252,91,156,36,64,1,0,0          // vcvtdq2ps     0x140(%rsp),%ymm3
  .byte  197,252,16,164,36,0,1,0,0           // vmovups       0x100(%rsp),%ymm4
  .byte  197,220,92,219                      // vsubps        %ymm3,%ymm4,%ymm3
  .byte  197,252,17,92,36,96                 // vmovups       %ymm3,0x60(%rsp)
  .byte  197,252,16,164,36,128,0,0,0         // vmovups       0x80(%rsp),%ymm4
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,220,88,192                      // vaddps        %ymm0,%ymm4,%ymm0
  .byte  197,252,17,132,36,0,1,0,0           // vmovups       %ymm0,0x100(%rsp)
  .byte  197,252,16,100,36,64                // vmovups       0x40(%rsp),%ymm4
  .byte  197,244,92,196                      // vsubps        %ymm4,%ymm1,%ymm0
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,220,88,192                      // vaddps        %ymm0,%ymm4,%ymm0
  .byte  197,252,17,132,36,64,1,0,0          // vmovups       %ymm0,0x140(%rsp)
  .byte  197,252,16,76,36,32                 // vmovups       0x20(%rsp),%ymm1
  .byte  197,236,92,193                      // vsubps        %ymm1,%ymm2,%ymm0
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,244,88,192                      // vaddps        %ymm0,%ymm1,%ymm0
  .byte  197,252,17,132,36,128,0,0,0         // vmovups       %ymm0,0x80(%rsp)
  .byte  197,252,16,4,36                     // vmovups       (%rsp),%ymm0
  .byte  197,252,88,132,36,224,1,0,0         // vaddps        0x1e0(%rsp),%ymm0,%ymm0
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,254,127,68,36,64                // vmovdqu       %ymm0,0x40(%rsp)
  .byte  197,249,254,148,36,96,1,0,0         // vpaddd        0x160(%rsp),%xmm0,%xmm2
  .byte  197,249,127,20,36                   // vmovdqa       %xmm2,(%rsp)
  .byte  196,227,125,25,192,1                // vextractf128  $0x1,%ymm0,%xmm0
  .byte  197,249,127,68,36,32                // vmovdqa       %xmm0,0x20(%rsp)
  .byte  197,121,254,188,36,160,0,0,0        // vpaddd        0xa0(%rsp),%xmm0,%xmm15
  .byte  197,129,254,172,36,224,0,0,0        // vpaddd        0xe0(%rsp),%xmm15,%xmm5
  .byte  197,249,111,100,36,128              // vmovdqa       -0x80(%rsp),%xmm4
  .byte  197,217,254,197                     // vpaddd        %xmm5,%xmm4,%xmm0
  .byte  196,194,121,64,201                  // vpmulld       %xmm9,%xmm0,%xmm1
  .byte  197,233,254,84,36,240               // vpaddd        -0x10(%rsp),%xmm2,%xmm2
  .byte  197,145,254,194                     // vpaddd        %xmm2,%xmm13,%xmm0
  .byte  196,194,121,64,193                  // vpmulld       %xmm9,%xmm0,%xmm0
  .byte  196,193,121,126,193                 // vmovd         %xmm0,%r9d
  .byte  196,195,121,22,192,1                // vpextrd       $0x1,%xmm0,%r8d
  .byte  196,195,121,22,194,2                // vpextrd       $0x2,%xmm0,%r10d
  .byte  196,195,121,22,195,3                // vpextrd       $0x3,%xmm0,%r11d
  .byte  196,193,121,126,207                 // vmovd         %xmm1,%r15d
  .byte  196,195,121,22,206,1                // vpextrd       $0x1,%xmm1,%r14d
  .byte  196,195,121,22,204,2                // vpextrd       $0x2,%xmm1,%r12d
  .byte  196,227,121,22,203,3                // vpextrd       $0x3,%xmm1,%ebx
  .byte  196,161,122,16,52,184               // vmovss        (%rax,%r15,4),%xmm6
  .byte  196,163,73,33,52,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm6,%xmm6
  .byte  196,163,73,33,52,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm6,%xmm6
  .byte  196,227,73,33,52,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm6,%xmm6
  .byte  196,161,122,16,60,136               // vmovss        (%rax,%r9,4),%xmm7
  .byte  196,163,65,33,60,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm7,%xmm7
  .byte  196,163,65,33,60,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm7,%xmm7
  .byte  196,163,65,33,60,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm7,%xmm7
  .byte  196,99,69,24,246,1                  // vinsertf128   $0x1,%xmm6,%ymm7,%ymm14
  .byte  197,225,118,219                     // vpcmpeqd      %xmm3,%xmm3,%xmm3
  .byte  197,249,250,243                     // vpsubd        %xmm3,%xmm0,%xmm6
  .byte  196,195,249,22,240,1                // vpextrq       $0x1,%xmm6,%r8
  .byte  196,193,249,126,241                 // vmovq         %xmm6,%r9
  .byte  197,241,250,243                     // vpsubd        %xmm3,%xmm1,%xmm6
  .byte  196,65,17,118,237                   // vpcmpeqd      %xmm13,%xmm13,%xmm13
  .byte  196,195,249,22,242,1                // vpextrq       $0x1,%xmm6,%r10
  .byte  196,225,249,126,243                 // vmovq         %xmm6,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,52,152               // vmovss        (%rax,%r11,4),%xmm6
  .byte  196,227,73,33,52,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm6,%xmm6
  .byte  196,161,122,16,60,176               // vmovss        (%rax,%r14,4),%xmm7
  .byte  196,227,73,33,247,32                // vinsertps     $0x20,%xmm7,%xmm6,%xmm6
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,73,33,247,48                // vinsertps     $0x30,%xmm7,%xmm6,%xmm6
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,60,152                   // vmovss        (%rax,%rbx,4),%xmm7
  .byte  196,163,65,33,60,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm7,%xmm7
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,65,33,219,32                // vinsertps     $0x20,%xmm3,%xmm7,%xmm3
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,97,33,223,48                // vinsertps     $0x30,%xmm7,%xmm3,%xmm3
  .byte  196,227,101,24,254,1                // vinsertf128   $0x1,%xmm6,%ymm3,%ymm7
  .byte  196,193,121,254,194                 // vpaddd        %xmm10,%xmm0,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  196,193,113,254,194                 // vpaddd        %xmm10,%xmm1,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,12,176               // vmovss        (%rax,%r14,4),%xmm1
  .byte  196,227,121,33,193,32               // vinsertps     $0x20,%xmm1,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,12,144               // vmovss        (%rax,%r10,4),%xmm1
  .byte  196,227,121,33,193,48               // vinsertps     $0x30,%xmm1,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,12,152                   // vmovss        (%rax,%rbx,4),%xmm1
  .byte  196,163,113,33,12,136,16            // vinsertps     $0x10,(%rax,%r9,4),%xmm1,%xmm1
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,113,33,203,32               // vinsertps     $0x20,%xmm3,%xmm1,%xmm1
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,28,128               // vmovss        (%rax,%r8,4),%xmm3
  .byte  196,227,113,33,203,48               // vinsertps     $0x30,%xmm3,%xmm1,%xmm1
  .byte  196,99,117,24,192,1                 // vinsertf128   $0x1,%xmm0,%ymm1,%ymm8
  .byte  197,121,111,100,36,160              // vmovdqa       -0x60(%rsp),%xmm12
  .byte  197,153,254,194                     // vpaddd        %xmm2,%xmm12,%xmm0
  .byte  197,121,111,92,36,176               // vmovdqa       -0x50(%rsp),%xmm11
  .byte  197,161,254,205                     // vpaddd        %xmm5,%xmm11,%xmm1
  .byte  196,194,113,64,201                  // vpmulld       %xmm9,%xmm1,%xmm1
  .byte  196,194,121,64,193                  // vpmulld       %xmm9,%xmm0,%xmm0
  .byte  196,193,121,126,193                 // vmovd         %xmm0,%r9d
  .byte  196,195,121,22,192,1                // vpextrd       $0x1,%xmm0,%r8d
  .byte  196,195,121,22,194,2                // vpextrd       $0x2,%xmm0,%r10d
  .byte  196,195,121,22,195,3                // vpextrd       $0x3,%xmm0,%r11d
  .byte  196,193,121,126,207                 // vmovd         %xmm1,%r15d
  .byte  196,195,121,22,206,1                // vpextrd       $0x1,%xmm1,%r14d
  .byte  196,195,121,22,204,2                // vpextrd       $0x2,%xmm1,%r12d
  .byte  196,227,121,22,203,3                // vpextrd       $0x3,%xmm1,%ebx
  .byte  196,161,122,16,20,184               // vmovss        (%rax,%r15,4),%xmm2
  .byte  196,163,105,33,20,176,16            // vinsertps     $0x10,(%rax,%r14,4),%xmm2,%xmm2
  .byte  196,163,105,33,20,160,32            // vinsertps     $0x20,(%rax,%r12,4),%xmm2,%xmm2
  .byte  196,227,105,33,20,152,48            // vinsertps     $0x30,(%rax,%rbx,4),%xmm2,%xmm2
  .byte  196,161,122,16,28,136               // vmovss        (%rax,%r9,4),%xmm3
  .byte  196,163,97,33,28,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm3,%xmm3
  .byte  196,227,101,24,210,1                // vinsertf128   $0x1,%xmm2,%ymm3,%ymm2
  .byte  196,193,121,250,221                 // vpsubd        %xmm13,%xmm0,%xmm3
  .byte  196,195,249,22,216,1                // vpextrq       $0x1,%xmm3,%r8
  .byte  196,193,249,126,217                 // vmovq         %xmm3,%r9
  .byte  196,193,113,250,221                 // vpsubd        %xmm13,%xmm1,%xmm3
  .byte  196,195,249,22,218,1                // vpextrq       $0x1,%xmm3,%r10
  .byte  196,225,249,126,219                 // vmovq         %xmm3,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,28,152               // vmovss        (%rax,%r11,4),%xmm3
  .byte  196,227,97,33,28,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm3,%xmm3
  .byte  196,161,122,16,44,176               // vmovss        (%rax,%r14,4),%xmm5
  .byte  196,227,97,33,221,32                // vinsertps     $0x20,%xmm5,%xmm3,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,44,144               // vmovss        (%rax,%r10,4),%xmm5
  .byte  196,227,97,33,221,48                // vinsertps     $0x30,%xmm5,%xmm3,%xmm3
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,44,152                   // vmovss        (%rax,%rbx,4),%xmm5
  .byte  196,163,81,33,44,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm5,%xmm5
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,81,33,238,32                // vinsertps     $0x20,%xmm6,%xmm5,%xmm5
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,52,128               // vmovss        (%rax,%r8,4),%xmm6
  .byte  196,227,81,33,238,48                // vinsertps     $0x30,%xmm6,%xmm5,%xmm5
  .byte  196,227,85,24,235,1                 // vinsertf128   $0x1,%xmm3,%ymm5,%ymm5
  .byte  196,193,121,254,194                 // vpaddd        %xmm10,%xmm0,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  196,193,113,254,194                 // vpaddd        %xmm10,%xmm1,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,12,176               // vmovss        (%rax,%r14,4),%xmm1
  .byte  196,227,121,33,193,32               // vinsertps     $0x20,%xmm1,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,12,144               // vmovss        (%rax,%r10,4),%xmm1
  .byte  196,227,121,33,193,48               // vinsertps     $0x30,%xmm1,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,12,152                   // vmovss        (%rax,%rbx,4),%xmm1
  .byte  196,163,113,33,12,136,16            // vinsertps     $0x10,(%rax,%r9,4),%xmm1,%xmm1
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,113,33,203,32               // vinsertps     $0x20,%xmm3,%xmm1,%xmm1
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,28,128               // vmovss        (%rax,%r8,4),%xmm3
  .byte  196,227,113,33,203,48               // vinsertps     $0x30,%xmm3,%xmm1,%xmm1
  .byte  196,227,117,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  196,193,108,92,206                  // vsubps        %ymm14,%ymm2,%ymm1
  .byte  197,252,16,148,36,128,1,0,0         // vmovups       0x180(%rsp),%ymm2
  .byte  197,236,89,201                      // vmulps        %ymm1,%ymm2,%ymm1
  .byte  197,12,88,241                       // vaddps        %ymm1,%ymm14,%ymm14
  .byte  197,212,92,207                      // vsubps        %ymm7,%ymm5,%ymm1
  .byte  197,236,89,201                      // vmulps        %ymm1,%ymm2,%ymm1
  .byte  197,196,88,201                      // vaddps        %ymm1,%ymm7,%ymm1
  .byte  197,252,17,140,36,160,0,0,0         // vmovups       %ymm1,0xa0(%rsp)
  .byte  196,193,124,92,192                  // vsubps        %ymm8,%ymm0,%ymm0
  .byte  197,236,89,192                      // vmulps        %ymm0,%ymm2,%ymm0
  .byte  197,60,88,192                       // vaddps        %ymm0,%ymm8,%ymm8
  .byte  197,129,254,68,36,208               // vpaddd        -0x30(%rsp),%xmm15,%xmm0
  .byte  197,249,111,12,36                   // vmovdqa       (%rsp),%xmm1
  .byte  197,241,254,124,36,224              // vpaddd        -0x20(%rsp),%xmm1,%xmm7
  .byte  197,249,254,204                     // vpaddd        %xmm4,%xmm0,%xmm1
  .byte  196,194,113,64,201                  // vpmulld       %xmm9,%xmm1,%xmm1
  .byte  197,121,111,124,36,144              // vmovdqa       -0x70(%rsp),%xmm15
  .byte  196,193,65,254,215                  // vpaddd        %xmm15,%xmm7,%xmm2
  .byte  196,194,105,64,209                  // vpmulld       %xmm9,%xmm2,%xmm2
  .byte  196,193,121,126,209                 // vmovd         %xmm2,%r9d
  .byte  196,195,121,22,208,1                // vpextrd       $0x1,%xmm2,%r8d
  .byte  196,195,121,22,210,2                // vpextrd       $0x2,%xmm2,%r10d
  .byte  196,195,121,22,211,3                // vpextrd       $0x3,%xmm2,%r11d
  .byte  196,193,121,126,207                 // vmovd         %xmm1,%r15d
  .byte  196,195,121,22,206,1                // vpextrd       $0x1,%xmm1,%r14d
  .byte  196,195,121,22,204,2                // vpextrd       $0x2,%xmm1,%r12d
  .byte  196,227,121,22,203,3                // vpextrd       $0x3,%xmm1,%ebx
  .byte  196,161,122,16,28,184               // vmovss        (%rax,%r15,4),%xmm3
  .byte  196,163,97,33,28,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm3,%xmm3
  .byte  196,227,97,33,28,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm3,%xmm3
  .byte  196,161,122,16,36,136               // vmovss        (%rax,%r9,4),%xmm4
  .byte  196,163,89,33,36,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm4,%xmm4
  .byte  196,163,89,33,36,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm4,%xmm4
  .byte  196,163,89,33,36,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm4,%xmm4
  .byte  196,227,93,24,227,1                 // vinsertf128   $0x1,%xmm3,%ymm4,%ymm4
  .byte  197,209,118,237                     // vpcmpeqd      %xmm5,%xmm5,%xmm5
  .byte  197,233,250,221                     // vpsubd        %xmm5,%xmm2,%xmm3
  .byte  196,195,249,22,216,1                // vpextrq       $0x1,%xmm3,%r8
  .byte  196,193,249,126,217                 // vmovq         %xmm3,%r9
  .byte  197,241,250,221                     // vpsubd        %xmm5,%xmm1,%xmm3
  .byte  196,195,249,22,218,1                // vpextrq       $0x1,%xmm3,%r10
  .byte  196,225,249,126,219                 // vmovq         %xmm3,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,28,152               // vmovss        (%rax,%r11,4),%xmm3
  .byte  196,227,97,33,28,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm3,%xmm3
  .byte  196,161,122,16,44,176               // vmovss        (%rax,%r14,4),%xmm5
  .byte  196,227,97,33,221,32                // vinsertps     $0x20,%xmm5,%xmm3,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,44,144               // vmovss        (%rax,%r10,4),%xmm5
  .byte  196,227,97,33,221,48                // vinsertps     $0x30,%xmm5,%xmm3,%xmm3
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,44,152                   // vmovss        (%rax,%rbx,4),%xmm5
  .byte  196,163,81,33,44,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm5,%xmm5
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,81,33,238,32                // vinsertps     $0x20,%xmm6,%xmm5,%xmm5
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,52,128               // vmovss        (%rax,%r8,4),%xmm6
  .byte  196,227,81,33,238,48                // vinsertps     $0x30,%xmm6,%xmm5,%xmm5
  .byte  196,227,85,24,235,1                 // vinsertf128   $0x1,%xmm3,%ymm5,%ymm5
  .byte  196,193,105,254,210                 // vpaddd        %xmm10,%xmm2,%xmm2
  .byte  196,195,249,22,208,1                // vpextrq       $0x1,%xmm2,%r8
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  196,193,113,254,202                 // vpaddd        %xmm10,%xmm1,%xmm1
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  196,225,249,126,203                 // vmovq         %xmm1,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,12,152               // vmovss        (%rax,%r11,4),%xmm1
  .byte  196,227,113,33,12,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm1,%xmm1
  .byte  196,161,122,16,20,176               // vmovss        (%rax,%r14,4),%xmm2
  .byte  196,227,113,33,202,32               // vinsertps     $0x20,%xmm2,%xmm1,%xmm1
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,20,144               // vmovss        (%rax,%r10,4),%xmm2
  .byte  196,227,113,33,202,48               // vinsertps     $0x30,%xmm2,%xmm1,%xmm1
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,20,152                   // vmovss        (%rax,%rbx,4),%xmm2
  .byte  196,163,105,33,20,136,16            // vinsertps     $0x10,(%rax,%r9,4),%xmm2,%xmm2
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,105,33,211,32               // vinsertps     $0x20,%xmm3,%xmm2,%xmm2
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,28,128               // vmovss        (%rax,%r8,4),%xmm3
  .byte  196,227,105,33,211,48               // vinsertps     $0x30,%xmm3,%xmm2,%xmm2
  .byte  196,99,109,24,233,1                 // vinsertf128   $0x1,%xmm1,%ymm2,%ymm13
  .byte  197,153,254,215                     // vpaddd        %xmm7,%xmm12,%xmm2
  .byte  197,161,254,192                     // vpaddd        %xmm0,%xmm11,%xmm0
  .byte  196,65,121,111,227                  // vmovdqa       %xmm11,%xmm12
  .byte  196,194,121,64,201                  // vpmulld       %xmm9,%xmm0,%xmm1
  .byte  196,194,105,64,209                  // vpmulld       %xmm9,%xmm2,%xmm2
  .byte  196,193,121,126,209                 // vmovd         %xmm2,%r9d
  .byte  196,195,121,22,208,1                // vpextrd       $0x1,%xmm2,%r8d
  .byte  196,195,121,22,210,2                // vpextrd       $0x2,%xmm2,%r10d
  .byte  196,195,121,22,211,3                // vpextrd       $0x3,%xmm2,%r11d
  .byte  196,193,121,126,207                 // vmovd         %xmm1,%r15d
  .byte  196,195,121,22,206,1                // vpextrd       $0x1,%xmm1,%r14d
  .byte  196,195,121,22,204,2                // vpextrd       $0x2,%xmm1,%r12d
  .byte  196,227,121,22,203,3                // vpextrd       $0x3,%xmm1,%ebx
  .byte  196,161,122,16,4,184                // vmovss        (%rax,%r15,4),%xmm0
  .byte  196,163,121,33,4,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm0,%xmm0
  .byte  196,163,121,33,4,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm0,%xmm0
  .byte  196,227,121,33,4,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,28,136               // vmovss        (%rax,%r9,4),%xmm3
  .byte  196,163,97,33,28,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm3,%xmm3
  .byte  196,227,101,24,192,1                // vinsertf128   $0x1,%xmm0,%ymm3,%ymm0
  .byte  197,201,118,246                     // vpcmpeqd      %xmm6,%xmm6,%xmm6
  .byte  197,233,250,222                     // vpsubd        %xmm6,%xmm2,%xmm3
  .byte  196,195,249,22,216,1                // vpextrq       $0x1,%xmm3,%r8
  .byte  196,193,249,126,217                 // vmovq         %xmm3,%r9
  .byte  197,241,250,222                     // vpsubd        %xmm6,%xmm1,%xmm3
  .byte  196,195,249,22,218,1                // vpextrq       $0x1,%xmm3,%r10
  .byte  196,225,249,126,219                 // vmovq         %xmm3,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,28,152               // vmovss        (%rax,%r11,4),%xmm3
  .byte  196,227,97,33,28,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm3,%xmm3
  .byte  196,161,122,16,52,176               // vmovss        (%rax,%r14,4),%xmm6
  .byte  196,227,97,33,222,32                // vinsertps     $0x20,%xmm6,%xmm3,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,97,33,222,48                // vinsertps     $0x30,%xmm6,%xmm3,%xmm3
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,52,152                   // vmovss        (%rax,%rbx,4),%xmm6
  .byte  196,163,73,33,52,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm6,%xmm6
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,73,33,247,32                // vinsertps     $0x20,%xmm7,%xmm6,%xmm6
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,73,33,247,48                // vinsertps     $0x30,%xmm7,%xmm6,%xmm6
  .byte  196,227,77,24,243,1                 // vinsertf128   $0x1,%xmm3,%ymm6,%ymm6
  .byte  196,193,105,254,210                 // vpaddd        %xmm10,%xmm2,%xmm2
  .byte  196,195,249,22,208,1                // vpextrq       $0x1,%xmm2,%r8
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  196,193,113,254,202                 // vpaddd        %xmm10,%xmm1,%xmm1
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  196,225,249,126,203                 // vmovq         %xmm1,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,12,152               // vmovss        (%rax,%r11,4),%xmm1
  .byte  196,227,113,33,12,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm1,%xmm1
  .byte  196,161,122,16,20,176               // vmovss        (%rax,%r14,4),%xmm2
  .byte  196,227,113,33,202,32               // vinsertps     $0x20,%xmm2,%xmm1,%xmm1
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,20,144               // vmovss        (%rax,%r10,4),%xmm2
  .byte  196,227,113,33,202,48               // vinsertps     $0x30,%xmm2,%xmm1,%xmm1
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,20,152                   // vmovss        (%rax,%rbx,4),%xmm2
  .byte  196,163,105,33,20,136,16            // vinsertps     $0x10,(%rax,%r9,4),%xmm2,%xmm2
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,105,33,211,32               // vinsertps     $0x20,%xmm3,%xmm2,%xmm2
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,28,128               // vmovss        (%rax,%r8,4),%xmm3
  .byte  196,227,105,33,211,48               // vinsertps     $0x30,%xmm3,%xmm2,%xmm2
  .byte  196,227,109,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm2,%ymm1
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  197,252,16,156,36,128,1,0,0         // vmovups       0x180(%rsp),%ymm3
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,220,88,192                      // vaddps        %ymm0,%ymm4,%ymm0
  .byte  197,204,92,213                      // vsubps        %ymm5,%ymm6,%ymm2
  .byte  197,228,89,210                      // vmulps        %ymm2,%ymm3,%ymm2
  .byte  197,212,88,210                      // vaddps        %ymm2,%ymm5,%ymm2
  .byte  196,193,116,92,205                  // vsubps        %ymm13,%ymm1,%ymm1
  .byte  197,228,89,201                      // vmulps        %ymm1,%ymm3,%ymm1
  .byte  197,148,88,201                      // vaddps        %ymm1,%ymm13,%ymm1
  .byte  196,193,124,92,198                  // vsubps        %ymm14,%ymm0,%ymm0
  .byte  197,252,16,156,36,192,0,0,0         // vmovups       0xc0(%rsp),%ymm3
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,140,88,192                      // vaddps        %ymm0,%ymm14,%ymm0
  .byte  197,252,17,4,36                     // vmovups       %ymm0,(%rsp)
  .byte  197,252,16,164,36,160,0,0,0         // vmovups       0xa0(%rsp),%ymm4
  .byte  197,236,92,196                      // vsubps        %ymm4,%ymm2,%ymm0
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,220,88,192                      // vaddps        %ymm0,%ymm4,%ymm0
  .byte  197,252,17,132,36,160,0,0,0         // vmovups       %ymm0,0xa0(%rsp)
  .byte  196,193,116,92,192                  // vsubps        %ymm8,%ymm1,%ymm0
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,188,88,192                      // vaddps        %ymm0,%ymm8,%ymm0
  .byte  197,252,17,132,36,96,1,0,0          // vmovups       %ymm0,0x160(%rsp)
  .byte  197,254,111,68,36,64                // vmovdqu       0x40(%rsp),%ymm0
  .byte  197,121,254,116,36,192              // vpaddd        -0x40(%rsp),%xmm0,%xmm14
  .byte  197,249,111,68,36,32                // vmovdqa       0x20(%rsp),%xmm0
  .byte  197,121,254,172,36,32,1,0,0         // vpaddd        0x120(%rsp),%xmm0,%xmm13
  .byte  197,145,254,188,36,224,0,0,0        // vpaddd        0xe0(%rsp),%xmm13,%xmm7
  .byte  197,137,254,108,36,240              // vpaddd        -0x10(%rsp),%xmm14,%xmm5
  .byte  197,193,254,76,36,128               // vpaddd        -0x80(%rsp),%xmm7,%xmm1
  .byte  196,194,113,64,209                  // vpmulld       %xmm9,%xmm1,%xmm2
  .byte  196,193,81,254,207                  // vpaddd        %xmm15,%xmm5,%xmm1
  .byte  196,194,113,64,225                  // vpmulld       %xmm9,%xmm1,%xmm4
  .byte  196,193,121,126,225                 // vmovd         %xmm4,%r9d
  .byte  196,195,121,22,224,1                // vpextrd       $0x1,%xmm4,%r8d
  .byte  196,195,121,22,226,2                // vpextrd       $0x2,%xmm4,%r10d
  .byte  196,195,121,22,227,3                // vpextrd       $0x3,%xmm4,%r11d
  .byte  196,193,121,126,215                 // vmovd         %xmm2,%r15d
  .byte  196,195,121,22,214,1                // vpextrd       $0x1,%xmm2,%r14d
  .byte  196,195,121,22,212,2                // vpextrd       $0x2,%xmm2,%r12d
  .byte  196,227,121,22,211,3                // vpextrd       $0x3,%xmm2,%ebx
  .byte  196,161,122,16,12,184               // vmovss        (%rax,%r15,4),%xmm1
  .byte  196,163,113,33,12,176,16            // vinsertps     $0x10,(%rax,%r14,4),%xmm1,%xmm1
  .byte  196,163,113,33,12,160,32            // vinsertps     $0x20,(%rax,%r12,4),%xmm1,%xmm1
  .byte  196,227,113,33,12,152,48            // vinsertps     $0x30,(%rax,%rbx,4),%xmm1,%xmm1
  .byte  196,161,122,16,28,136               // vmovss        (%rax,%r9,4),%xmm3
  .byte  196,163,97,33,28,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm3,%xmm3
  .byte  196,227,101,24,217,1                // vinsertf128   $0x1,%xmm1,%ymm3,%ymm3
  .byte  197,249,118,192                     // vpcmpeqd      %xmm0,%xmm0,%xmm0
  .byte  197,217,250,200                     // vpsubd        %xmm0,%xmm4,%xmm1
  .byte  196,195,249,22,200,1                // vpextrq       $0x1,%xmm1,%r8
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  197,233,250,200                     // vpsubd        %xmm0,%xmm2,%xmm1
  .byte  196,65,1,118,255                    // vpcmpeqd      %xmm15,%xmm15,%xmm15
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  196,225,249,126,203                 // vmovq         %xmm1,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,12,152               // vmovss        (%rax,%r11,4),%xmm1
  .byte  196,227,113,33,12,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm1,%xmm1
  .byte  196,161,122,16,52,176               // vmovss        (%rax,%r14,4),%xmm6
  .byte  196,227,113,33,206,32               // vinsertps     $0x20,%xmm6,%xmm1,%xmm1
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,113,33,206,48               // vinsertps     $0x30,%xmm6,%xmm1,%xmm1
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,52,152                   // vmovss        (%rax,%rbx,4),%xmm6
  .byte  196,163,73,33,52,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm6,%xmm6
  .byte  196,161,122,16,4,144                // vmovss        (%rax,%r10,4),%xmm0
  .byte  196,227,73,33,192,32                // vinsertps     $0x20,%xmm0,%xmm6,%xmm0
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,52,128               // vmovss        (%rax,%r8,4),%xmm6
  .byte  196,227,121,33,198,48               // vinsertps     $0x30,%xmm6,%xmm0,%xmm0
  .byte  196,227,125,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm0,%ymm1
  .byte  196,193,89,254,194                  // vpaddd        %xmm10,%xmm4,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  196,193,105,254,194                 // vpaddd        %xmm10,%xmm2,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,20,176               // vmovss        (%rax,%r14,4),%xmm2
  .byte  196,227,121,33,194,32               // vinsertps     $0x20,%xmm2,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,20,144               // vmovss        (%rax,%r10,4),%xmm2
  .byte  196,227,121,33,194,48               // vinsertps     $0x30,%xmm2,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,20,152                   // vmovss        (%rax,%rbx,4),%xmm2
  .byte  196,163,105,33,20,136,16            // vinsertps     $0x10,(%rax,%r9,4),%xmm2,%xmm2
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,105,33,212,32               // vinsertps     $0x20,%xmm4,%xmm2,%xmm2
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,36,128               // vmovss        (%rax,%r8,4),%xmm4
  .byte  196,227,105,33,212,48               // vinsertps     $0x30,%xmm4,%xmm2,%xmm2
  .byte  196,99,109,24,216,1                 // vinsertf128   $0x1,%xmm0,%ymm2,%ymm11
  .byte  197,121,111,68,36,160               // vmovdqa       -0x60(%rsp),%xmm8
  .byte  197,185,254,197                     // vpaddd        %xmm5,%xmm8,%xmm0
  .byte  197,153,254,215                     // vpaddd        %xmm7,%xmm12,%xmm2
  .byte  196,194,105,64,233                  // vpmulld       %xmm9,%xmm2,%xmm5
  .byte  196,194,121,64,225                  // vpmulld       %xmm9,%xmm0,%xmm4
  .byte  196,193,121,126,225                 // vmovd         %xmm4,%r9d
  .byte  196,195,121,22,224,1                // vpextrd       $0x1,%xmm4,%r8d
  .byte  196,195,121,22,226,2                // vpextrd       $0x2,%xmm4,%r10d
  .byte  196,195,121,22,227,3                // vpextrd       $0x3,%xmm4,%r11d
  .byte  196,193,121,126,239                 // vmovd         %xmm5,%r15d
  .byte  196,195,121,22,238,1                // vpextrd       $0x1,%xmm5,%r14d
  .byte  196,195,121,22,236,2                // vpextrd       $0x2,%xmm5,%r12d
  .byte  196,227,121,22,235,3                // vpextrd       $0x3,%xmm5,%ebx
  .byte  196,161,122,16,4,184                // vmovss        (%rax,%r15,4),%xmm0
  .byte  196,163,121,33,4,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm0,%xmm0
  .byte  196,163,121,33,4,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm0,%xmm0
  .byte  196,227,121,33,4,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,20,136               // vmovss        (%rax,%r9,4),%xmm2
  .byte  196,163,105,33,20,128,16            // vinsertps     $0x10,(%rax,%r8,4),%xmm2,%xmm2
  .byte  196,163,105,33,20,144,32            // vinsertps     $0x20,(%rax,%r10,4),%xmm2,%xmm2
  .byte  196,163,105,33,20,152,48            // vinsertps     $0x30,(%rax,%r11,4),%xmm2,%xmm2
  .byte  196,227,109,24,208,1                // vinsertf128   $0x1,%xmm0,%ymm2,%ymm2
  .byte  196,193,89,250,199                  // vpsubd        %xmm15,%xmm4,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  196,193,81,250,199                  // vpsubd        %xmm15,%xmm5,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,52,176               // vmovss        (%rax,%r14,4),%xmm6
  .byte  196,227,121,33,198,32               // vinsertps     $0x20,%xmm6,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,121,33,198,48               // vinsertps     $0x30,%xmm6,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,52,152                   // vmovss        (%rax,%rbx,4),%xmm6
  .byte  196,163,73,33,52,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm6,%xmm6
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,73,33,247,32                // vinsertps     $0x20,%xmm7,%xmm6,%xmm6
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,73,33,247,48                // vinsertps     $0x30,%xmm7,%xmm6,%xmm6
  .byte  196,227,77,24,240,1                 // vinsertf128   $0x1,%xmm0,%ymm6,%ymm6
  .byte  196,193,89,254,194                  // vpaddd        %xmm10,%xmm4,%xmm0
  .byte  196,195,249,22,192,1                // vpextrq       $0x1,%xmm0,%r8
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  196,193,81,254,194                  // vpaddd        %xmm10,%xmm5,%xmm0
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  196,225,249,126,195                 // vmovq         %xmm0,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,4,152                // vmovss        (%rax,%r11,4),%xmm0
  .byte  196,227,121,33,4,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,36,176               // vmovss        (%rax,%r14,4),%xmm4
  .byte  196,227,121,33,196,32               // vinsertps     $0x20,%xmm4,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,121,33,196,48               // vinsertps     $0x30,%xmm4,%xmm0,%xmm0
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,36,152                   // vmovss        (%rax,%rbx,4),%xmm4
  .byte  196,163,89,33,36,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm4,%xmm4
  .byte  196,161,122,16,44,144               // vmovss        (%rax,%r10,4),%xmm5
  .byte  196,227,89,33,229,32                // vinsertps     $0x20,%xmm5,%xmm4,%xmm4
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,44,128               // vmovss        (%rax,%r8,4),%xmm5
  .byte  196,227,89,33,229,48                // vinsertps     $0x30,%xmm5,%xmm4,%xmm4
  .byte  196,227,93,24,192,1                 // vinsertf128   $0x1,%xmm0,%ymm4,%ymm0
  .byte  197,236,92,211                      // vsubps        %ymm3,%ymm2,%ymm2
  .byte  197,252,16,164,36,128,1,0,0         // vmovups       0x180(%rsp),%ymm4
  .byte  197,220,89,210                      // vmulps        %ymm2,%ymm4,%ymm2
  .byte  197,228,88,210                      // vaddps        %ymm2,%ymm3,%ymm2
  .byte  197,252,17,148,36,224,0,0,0         // vmovups       %ymm2,0xe0(%rsp)
  .byte  197,204,92,209                      // vsubps        %ymm1,%ymm6,%ymm2
  .byte  197,220,89,210                      // vmulps        %ymm2,%ymm4,%ymm2
  .byte  197,116,88,250                      // vaddps        %ymm2,%ymm1,%ymm15
  .byte  196,193,124,92,195                  // vsubps        %ymm11,%ymm0,%ymm0
  .byte  197,220,89,192                      // vmulps        %ymm0,%ymm4,%ymm0
  .byte  197,124,40,228                      // vmovaps       %ymm4,%ymm12
  .byte  197,36,88,216                       // vaddps        %ymm0,%ymm11,%ymm11
  .byte  197,145,254,124,36,208              // vpaddd        -0x30(%rsp),%xmm13,%xmm7
  .byte  197,137,254,68,36,224               // vpaddd        -0x20(%rsp),%xmm14,%xmm0
  .byte  197,249,254,76,36,144               // vpaddd        -0x70(%rsp),%xmm0,%xmm1
  .byte  197,193,254,84,36,128               // vpaddd        -0x80(%rsp),%xmm7,%xmm2
  .byte  196,66,105,64,241                   // vpmulld       %xmm9,%xmm2,%xmm14
  .byte  196,194,113,64,209                  // vpmulld       %xmm9,%xmm1,%xmm2
  .byte  196,193,121,126,209                 // vmovd         %xmm2,%r9d
  .byte  196,195,121,22,208,1                // vpextrd       $0x1,%xmm2,%r8d
  .byte  196,195,121,22,210,2                // vpextrd       $0x2,%xmm2,%r10d
  .byte  196,195,121,22,211,3                // vpextrd       $0x3,%xmm2,%r11d
  .byte  196,65,121,126,247                  // vmovd         %xmm14,%r15d
  .byte  196,67,121,22,246,1                 // vpextrd       $0x1,%xmm14,%r14d
  .byte  196,67,121,22,244,2                 // vpextrd       $0x2,%xmm14,%r12d
  .byte  196,99,121,22,243,3                 // vpextrd       $0x3,%xmm14,%ebx
  .byte  196,161,122,16,12,184               // vmovss        (%rax,%r15,4),%xmm1
  .byte  196,163,113,33,12,176,16            // vinsertps     $0x10,(%rax,%r14,4),%xmm1,%xmm1
  .byte  196,163,113,33,12,160,32            // vinsertps     $0x20,(%rax,%r12,4),%xmm1,%xmm1
  .byte  196,227,113,33,12,152,48            // vinsertps     $0x30,(%rax,%rbx,4),%xmm1,%xmm1
  .byte  196,161,122,16,28,136               // vmovss        (%rax,%r9,4),%xmm3
  .byte  196,163,97,33,28,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm3,%xmm3
  .byte  196,163,97,33,28,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm3,%xmm3
  .byte  196,227,101,24,201,1                // vinsertf128   $0x1,%xmm1,%ymm3,%ymm1
  .byte  197,217,118,228                     // vpcmpeqd      %xmm4,%xmm4,%xmm4
  .byte  197,233,250,220                     // vpsubd        %xmm4,%xmm2,%xmm3
  .byte  196,195,249,22,216,1                // vpextrq       $0x1,%xmm3,%r8
  .byte  196,193,249,126,217                 // vmovq         %xmm3,%r9
  .byte  197,137,250,220                     // vpsubd        %xmm4,%xmm14,%xmm3
  .byte  197,201,118,246                     // vpcmpeqd      %xmm6,%xmm6,%xmm6
  .byte  196,195,249,22,218,1                // vpextrq       $0x1,%xmm3,%r10
  .byte  196,225,249,126,219                 // vmovq         %xmm3,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,28,152               // vmovss        (%rax,%r11,4),%xmm3
  .byte  196,227,97,33,28,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm3,%xmm3
  .byte  196,161,122,16,44,176               // vmovss        (%rax,%r14,4),%xmm5
  .byte  196,227,97,33,221,32                // vinsertps     $0x20,%xmm5,%xmm3,%xmm3
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,44,144               // vmovss        (%rax,%r10,4),%xmm5
  .byte  196,227,97,33,221,48                // vinsertps     $0x30,%xmm5,%xmm3,%xmm3
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,44,152                   // vmovss        (%rax,%rbx,4),%xmm5
  .byte  196,163,81,33,44,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm5,%xmm5
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,81,33,228,32                // vinsertps     $0x20,%xmm4,%xmm5,%xmm4
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,44,128               // vmovss        (%rax,%r8,4),%xmm5
  .byte  196,227,89,33,229,48                // vinsertps     $0x30,%xmm5,%xmm4,%xmm4
  .byte  196,227,93,24,235,1                 // vinsertf128   $0x1,%xmm3,%ymm4,%ymm5
  .byte  196,193,105,254,210                 // vpaddd        %xmm10,%xmm2,%xmm2
  .byte  196,195,249,22,208,1                // vpextrq       $0x1,%xmm2,%r8
  .byte  196,193,249,126,209                 // vmovq         %xmm2,%r9
  .byte  196,193,9,254,210                   // vpaddd        %xmm10,%xmm14,%xmm2
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  196,225,249,126,211                 // vmovq         %xmm2,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,20,152               // vmovss        (%rax,%r11,4),%xmm2
  .byte  196,227,105,33,20,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm2,%xmm2
  .byte  196,161,122,16,28,176               // vmovss        (%rax,%r14,4),%xmm3
  .byte  196,227,105,33,211,32               // vinsertps     $0x20,%xmm3,%xmm2,%xmm2
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,105,33,211,48               // vinsertps     $0x30,%xmm3,%xmm2,%xmm2
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,28,152                   // vmovss        (%rax,%rbx,4),%xmm3
  .byte  196,163,97,33,28,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm3,%xmm3
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,97,33,220,32                // vinsertps     $0x20,%xmm4,%xmm3,%xmm3
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,36,128               // vmovss        (%rax,%r8,4),%xmm4
  .byte  196,227,97,33,220,48                // vinsertps     $0x30,%xmm4,%xmm3,%xmm3
  .byte  196,99,101,24,242,1                 // vinsertf128   $0x1,%xmm2,%ymm3,%ymm14
  .byte  197,185,254,192                     // vpaddd        %xmm0,%xmm8,%xmm0
  .byte  197,193,254,84,36,176               // vpaddd        -0x50(%rsp),%xmm7,%xmm2
  .byte  196,194,105,64,209                  // vpmulld       %xmm9,%xmm2,%xmm2
  .byte  196,194,121,64,217                  // vpmulld       %xmm9,%xmm0,%xmm3
  .byte  196,193,121,126,217                 // vmovd         %xmm3,%r9d
  .byte  196,195,121,22,216,1                // vpextrd       $0x1,%xmm3,%r8d
  .byte  196,195,121,22,218,2                // vpextrd       $0x2,%xmm3,%r10d
  .byte  196,195,121,22,219,3                // vpextrd       $0x3,%xmm3,%r11d
  .byte  196,193,121,126,215                 // vmovd         %xmm2,%r15d
  .byte  196,195,121,22,214,1                // vpextrd       $0x1,%xmm2,%r14d
  .byte  196,195,121,22,212,2                // vpextrd       $0x2,%xmm2,%r12d
  .byte  196,227,121,22,211,3                // vpextrd       $0x3,%xmm2,%ebx
  .byte  196,161,122,16,4,184                // vmovss        (%rax,%r15,4),%xmm0
  .byte  196,163,121,33,4,176,16             // vinsertps     $0x10,(%rax,%r14,4),%xmm0,%xmm0
  .byte  196,163,121,33,4,160,32             // vinsertps     $0x20,(%rax,%r12,4),%xmm0,%xmm0
  .byte  196,227,121,33,4,152,48             // vinsertps     $0x30,(%rax,%rbx,4),%xmm0,%xmm0
  .byte  196,161,122,16,36,136               // vmovss        (%rax,%r9,4),%xmm4
  .byte  196,163,89,33,36,128,16             // vinsertps     $0x10,(%rax,%r8,4),%xmm4,%xmm4
  .byte  196,163,89,33,36,144,32             // vinsertps     $0x20,(%rax,%r10,4),%xmm4,%xmm4
  .byte  196,163,89,33,36,152,48             // vinsertps     $0x30,(%rax,%r11,4),%xmm4,%xmm4
  .byte  196,227,93,24,192,1                 // vinsertf128   $0x1,%xmm0,%ymm4,%ymm0
  .byte  197,225,250,230                     // vpsubd        %xmm6,%xmm3,%xmm4
  .byte  196,195,249,22,224,1                // vpextrq       $0x1,%xmm4,%r8
  .byte  196,193,249,126,225                 // vmovq         %xmm4,%r9
  .byte  197,233,250,230                     // vpsubd        %xmm6,%xmm2,%xmm4
  .byte  196,195,249,22,226,1                // vpextrq       $0x1,%xmm4,%r10
  .byte  196,225,249,126,227                 // vmovq         %xmm4,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,36,152               // vmovss        (%rax,%r11,4),%xmm4
  .byte  196,227,89,33,36,152,16             // vinsertps     $0x10,(%rax,%rbx,4),%xmm4,%xmm4
  .byte  196,161,122,16,60,176               // vmovss        (%rax,%r14,4),%xmm7
  .byte  196,227,89,33,231,32                // vinsertps     $0x20,%xmm7,%xmm4,%xmm4
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,60,144               // vmovss        (%rax,%r10,4),%xmm7
  .byte  196,227,89,33,231,48                // vinsertps     $0x30,%xmm7,%xmm4,%xmm4
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,60,152                   // vmovss        (%rax,%rbx,4),%xmm7
  .byte  196,163,65,33,60,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm7,%xmm7
  .byte  196,161,122,16,52,144               // vmovss        (%rax,%r10,4),%xmm6
  .byte  196,227,65,33,246,32                // vinsertps     $0x20,%xmm6,%xmm7,%xmm6
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,60,128               // vmovss        (%rax,%r8,4),%xmm7
  .byte  196,227,73,33,247,48                // vinsertps     $0x30,%xmm7,%xmm6,%xmm6
  .byte  196,227,77,24,252,1                 // vinsertf128   $0x1,%xmm4,%ymm6,%ymm7
  .byte  196,193,97,254,218                  // vpaddd        %xmm10,%xmm3,%xmm3
  .byte  196,195,249,22,216,1                // vpextrq       $0x1,%xmm3,%r8
  .byte  196,193,249,126,217                 // vmovq         %xmm3,%r9
  .byte  196,193,105,254,210                 // vpaddd        %xmm10,%xmm2,%xmm2
  .byte  196,195,249,22,210,1                // vpextrq       $0x1,%xmm2,%r10
  .byte  196,225,249,126,211                 // vmovq         %xmm2,%rbx
  .byte  65,137,219                          // mov           %ebx,%r11d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  196,161,122,16,20,152               // vmovss        (%rax,%r11,4),%xmm2
  .byte  196,227,105,33,20,152,16            // vinsertps     $0x10,(%rax,%rbx,4),%xmm2,%xmm2
  .byte  196,161,122,16,28,176               // vmovss        (%rax,%r14,4),%xmm3
  .byte  196,227,105,33,211,32               // vinsertps     $0x20,%xmm3,%xmm2,%xmm2
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,161,122,16,28,144               // vmovss        (%rax,%r10,4),%xmm3
  .byte  196,227,105,33,211,48               // vinsertps     $0x30,%xmm3,%xmm2,%xmm2
  .byte  68,137,203                          // mov           %r9d,%ebx
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,194                          // mov           %r8d,%r10d
  .byte  197,250,16,28,152                   // vmovss        (%rax,%rbx,4),%xmm3
  .byte  196,163,97,33,28,136,16             // vinsertps     $0x10,(%rax,%r9,4),%xmm3,%xmm3
  .byte  196,161,122,16,36,144               // vmovss        (%rax,%r10,4),%xmm4
  .byte  196,227,97,33,220,32                // vinsertps     $0x20,%xmm4,%xmm3,%xmm3
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  196,161,122,16,36,128               // vmovss        (%rax,%r8,4),%xmm4
  .byte  196,227,97,33,220,48                // vinsertps     $0x30,%xmm4,%xmm3,%xmm3
  .byte  196,227,101,24,210,1                // vinsertf128   $0x1,%xmm2,%ymm3,%ymm2
  .byte  197,252,92,193                      // vsubps        %ymm1,%ymm0,%ymm0
  .byte  197,156,89,192                      // vmulps        %ymm0,%ymm12,%ymm0
  .byte  197,244,88,192                      // vaddps        %ymm0,%ymm1,%ymm0
  .byte  197,196,92,205                      // vsubps        %ymm5,%ymm7,%ymm1
  .byte  197,156,89,201                      // vmulps        %ymm1,%ymm12,%ymm1
  .byte  197,212,88,201                      // vaddps        %ymm1,%ymm5,%ymm1
  .byte  196,193,108,92,214                  // vsubps        %ymm14,%ymm2,%ymm2
  .byte  197,156,89,210                      // vmulps        %ymm2,%ymm12,%ymm2
  .byte  197,140,88,210                      // vaddps        %ymm2,%ymm14,%ymm2
  .byte  197,252,16,164,36,224,0,0,0         // vmovups       0xe0(%rsp),%ymm4
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  197,252,16,156,36,192,0,0,0         // vmovups       0xc0(%rsp),%ymm3
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,220,88,192                      // vaddps        %ymm0,%ymm4,%ymm0
  .byte  196,193,116,92,207                  // vsubps        %ymm15,%ymm1,%ymm1
  .byte  197,228,89,201                      // vmulps        %ymm1,%ymm3,%ymm1
  .byte  197,132,88,201                      // vaddps        %ymm1,%ymm15,%ymm1
  .byte  196,193,108,92,211                  // vsubps        %ymm11,%ymm2,%ymm2
  .byte  197,228,89,210                      // vmulps        %ymm2,%ymm3,%ymm2
  .byte  197,164,88,210                      // vaddps        %ymm2,%ymm11,%ymm2
  .byte  197,252,16,36,36                    // vmovups       (%rsp),%ymm4
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  197,252,16,92,36,96                 // vmovups       0x60(%rsp),%ymm3
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,220,88,192                      // vaddps        %ymm0,%ymm4,%ymm0
  .byte  197,252,16,164,36,160,0,0,0         // vmovups       0xa0(%rsp),%ymm4
  .byte  197,244,92,204                      // vsubps        %ymm4,%ymm1,%ymm1
  .byte  197,228,89,201                      // vmulps        %ymm1,%ymm3,%ymm1
  .byte  197,220,88,201                      // vaddps        %ymm1,%ymm4,%ymm1
  .byte  197,252,16,164,36,96,1,0,0          // vmovups       0x160(%rsp),%ymm4
  .byte  197,236,92,212                      // vsubps        %ymm4,%ymm2,%ymm2
  .byte  197,228,89,210                      // vmulps        %ymm2,%ymm3,%ymm2
  .byte  197,220,88,210                      // vaddps        %ymm2,%ymm4,%ymm2
  .byte  197,252,91,156,36,192,1,0,0         // vcvtdq2ps     0x1c0(%rsp),%ymm3
  .byte  197,252,16,164,36,224,1,0,0         // vmovups       0x1e0(%rsp),%ymm4
  .byte  197,220,92,219                      // vsubps        %ymm3,%ymm4,%ymm3
  .byte  197,252,16,164,36,0,1,0,0           // vmovups       0x100(%rsp),%ymm4
  .byte  197,252,92,196                      // vsubps        %ymm4,%ymm0,%ymm0
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  197,220,88,192                      // vaddps        %ymm0,%ymm4,%ymm0
  .byte  197,252,16,164,36,64,1,0,0          // vmovups       0x140(%rsp),%ymm4
  .byte  197,244,92,204                      // vsubps        %ymm4,%ymm1,%ymm1
  .byte  197,228,89,201                      // vmulps        %ymm1,%ymm3,%ymm1
  .byte  197,220,88,201                      // vaddps        %ymm1,%ymm4,%ymm1
  .byte  197,252,16,164,36,128,0,0,0         // vmovups       0x80(%rsp),%ymm4
  .byte  197,236,92,212                      // vsubps        %ymm4,%ymm2,%ymm2
  .byte  197,228,89,210                      // vmulps        %ymm2,%ymm3,%ymm2
  .byte  197,220,88,210                      // vaddps        %ymm2,%ymm4,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,29,101,233,1,0       // vbroadcastss  0x1e965(%rip),%ymm3        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,252,16,164,36,64,2,0,0          // vmovups       0x240(%rsp),%ymm4
  .byte  197,252,16,172,36,96,2,0,0          // vmovups       0x260(%rsp),%ymm5
  .byte  197,252,16,180,36,128,2,0,0         // vmovups       0x280(%rsp),%ymm6
  .byte  197,252,16,188,36,160,2,0,0         // vmovups       0x2a0(%rsp),%ymm7
  .byte  72,129,196,216,2,0,0                // add           $0x2d8,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gauss_a_to_rgba_avx
.globl _sk_gauss_a_to_rgba_avx
FUNCTION(_sk_gauss_a_to_rgba_avx)
_sk_gauss_a_to_rgba_avx:
  .byte  196,226,125,24,5,148,234,1,0        // vbroadcastss  0x1ea94(%rip),%ymm0        # 3a384 <_sk_srcover_bgra_8888_sse2_lowp+0x41c>
  .byte  197,228,89,192                      // vmulps        %ymm0,%ymm3,%ymm0
  .byte  196,226,125,24,13,139,234,1,0       // vbroadcastss  0x1ea8b(%rip),%ymm1        # 3a388 <_sk_srcover_bgra_8888_sse2_lowp+0x420>
  .byte  197,252,88,193                      // vaddps        %ymm1,%ymm0,%ymm0
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  196,226,125,24,13,126,234,1,0       // vbroadcastss  0x1ea7e(%rip),%ymm1        # 3a38c <_sk_srcover_bgra_8888_sse2_lowp+0x424>
  .byte  197,252,88,193                      // vaddps        %ymm1,%ymm0,%ymm0
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  196,226,125,24,13,113,234,1,0       // vbroadcastss  0x1ea71(%rip),%ymm1        # 3a390 <_sk_srcover_bgra_8888_sse2_lowp+0x428>
  .byte  197,252,88,193                      // vaddps        %ymm1,%ymm0,%ymm0
  .byte  197,252,89,195                      // vmulps        %ymm3,%ymm0,%ymm0
  .byte  196,226,125,24,13,100,234,1,0       // vbroadcastss  0x1ea64(%rip),%ymm1        # 3a394 <_sk_srcover_bgra_8888_sse2_lowp+0x42c>
  .byte  197,252,88,193                      // vaddps        %ymm1,%ymm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  197,252,40,208                      // vmovaps       %ymm0,%ymm2
  .byte  197,252,40,216                      // vmovaps       %ymm0,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_start_pipeline_sse41
.globl _sk_start_pipeline_sse41
FUNCTION(_sk_start_pipeline_sse41)
_sk_start_pipeline_sse41:
  .byte  85                                  // push          %rbp
  .byte  72,137,229                          // mov           %rsp,%rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  73,137,215                          // mov           %rdx,%r15
  .byte  72,137,243                          // mov           %rsi,%rbx
  .byte  72,137,125,208                      // mov           %rdi,-0x30(%rbp)
  .byte  76,137,198                          // mov           %r8,%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  73,137,197                          // mov           %rax,%r13
  .byte  73,137,246                          // mov           %rsi,%r14
  .byte  72,137,77,192                       // mov           %rcx,-0x40(%rbp)
  .byte  72,57,203                           // cmp           %rcx,%rbx
  .byte  15,131,131,0,0,0                    // jae           1b9fa <_sk_start_pipeline_sse41+0xb6>
  .byte  72,139,69,208                       // mov           -0x30(%rbp),%rax
  .byte  72,141,64,4                         // lea           0x4(%rax),%rax
  .byte  72,137,69,200                       // mov           %rax,-0x38(%rbp)
  .byte  76,57,125,200                       // cmp           %r15,-0x38(%rbp)
  .byte  72,139,85,208                       // mov           -0x30(%rbp),%rdx
  .byte  119,59                              // ja            1b9c8 <_sk_start_pipeline_sse41+0x84>
  .byte  76,139,101,208                      // mov           -0x30(%rbp),%r12
  .byte  49,255                              // xor           %edi,%edi
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  76,137,226                          // mov           %r12,%rdx
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  73,141,84,36,4                      // lea           0x4(%r12),%rdx
  .byte  73,131,196,8                        // add           $0x8,%r12
  .byte  77,57,252                           // cmp           %r15,%r12
  .byte  73,137,212                          // mov           %rdx,%r12
  .byte  118,201                             // jbe           1b991 <_sk_start_pipeline_sse41+0x4d>
  .byte  76,137,255                          // mov           %r15,%rdi
  .byte  72,41,215                           // sub           %rdx,%rdi
  .byte  116,33                              // je            1b9f1 <_sk_start_pipeline_sse41+0xad>
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  72,255,195                          // inc           %rbx
  .byte  72,59,93,192                        // cmp           -0x40(%rbp),%rbx
  .byte  117,137                             // jne           1b983 <_sk_start_pipeline_sse41+0x3f>
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  195                                 // retq

HIDDEN _sk_just_return_sse41
.globl _sk_just_return_sse41
FUNCTION(_sk_just_return_sse41)
_sk_just_return_sse41:
  .byte  195                                 // retq

HIDDEN _sk_seed_shader_sse41
.globl _sk_seed_shader_sse41
FUNCTION(_sk_seed_shader_sse41)
_sk_seed_shader_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,110,194                      // movd          %edx,%xmm0
  .byte  102,15,112,192,0                    // pshufd        $0x0,%xmm0,%xmm0
  .byte  15,91,200                           // cvtdq2ps      %xmm0,%xmm1
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  102,15,110,201                      // movd          %ecx,%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,88,13,15,241,1,0                 // addps         0x1f10f(%rip),%xmm1        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,21,22,241,1,0                 // movaps        0x1f116(%rip),%xmm2        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dither_sse41
.globl _sk_dither_sse41
FUNCTION(_sk_dither_sse41)
_sk_dither_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,68,15,110,194                   // movd          %edx,%xmm8
  .byte  102,69,15,112,192,0                 // pshufd        $0x0,%xmm8,%xmm8
  .byte  102,68,15,254,5,191,240,1,0         // paddd         0x1f0bf(%rip),%xmm8        # 3ab20 <_sk_srcover_bgra_8888_sse2_lowp+0xbb8>
  .byte  102,68,15,110,201                   // movd          %ecx,%xmm9
  .byte  102,69,15,112,201,0                 // pshufd        $0x0,%xmm9,%xmm9
  .byte  102,69,15,239,200                   // pxor          %xmm8,%xmm9
  .byte  102,68,15,111,21,230,240,1,0        // movdqa        0x1f0e6(%rip),%xmm10        # 3ab60 <_sk_srcover_bgra_8888_sse2_lowp+0xbf8>
  .byte  102,69,15,111,217                   // movdqa        %xmm9,%xmm11
  .byte  102,69,15,219,218                   // pand          %xmm10,%xmm11
  .byte  102,65,15,114,243,5                 // pslld         $0x5,%xmm11
  .byte  102,69,15,219,208                   // pand          %xmm8,%xmm10
  .byte  102,65,15,114,242,4                 // pslld         $0x4,%xmm10
  .byte  102,68,15,111,37,210,240,1,0        // movdqa        0x1f0d2(%rip),%xmm12        # 3ab70 <_sk_srcover_bgra_8888_sse2_lowp+0xc08>
  .byte  102,68,15,111,45,217,240,1,0        // movdqa        0x1f0d9(%rip),%xmm13        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,69,15,111,241                   // movdqa        %xmm9,%xmm14
  .byte  102,69,15,219,245                   // pand          %xmm13,%xmm14
  .byte  102,65,15,114,246,2                 // pslld         $0x2,%xmm14
  .byte  102,69,15,235,243                   // por           %xmm11,%xmm14
  .byte  102,69,15,219,232                   // pand          %xmm8,%xmm13
  .byte  102,69,15,254,237                   // paddd         %xmm13,%xmm13
  .byte  102,69,15,235,234                   // por           %xmm10,%xmm13
  .byte  102,69,15,219,204                   // pand          %xmm12,%xmm9
  .byte  102,65,15,114,209,1                 // psrld         $0x1,%xmm9
  .byte  102,69,15,219,196                   // pand          %xmm12,%xmm8
  .byte  102,65,15,114,208,2                 // psrld         $0x2,%xmm8
  .byte  102,69,15,235,197                   // por           %xmm13,%xmm8
  .byte  102,69,15,235,198                   // por           %xmm14,%xmm8
  .byte  102,69,15,235,193                   // por           %xmm9,%xmm8
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  68,15,89,5,148,240,1,0              // mulps         0x1f094(%rip),%xmm8        # 3ab90 <_sk_srcover_bgra_8888_sse2_lowp+0xc28>
  .byte  68,15,88,5,156,240,1,0              // addps         0x1f09c(%rip),%xmm8        # 3aba0 <_sk_srcover_bgra_8888_sse2_lowp+0xc38>
  .byte  243,68,15,16,16                     // movss         (%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  69,15,89,208                        // mulps         %xmm8,%xmm10
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  68,15,88,210                        // addps         %xmm2,%xmm10
  .byte  15,93,195                           // minps         %xmm3,%xmm0
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  68,15,95,192                        // maxps         %xmm0,%xmm8
  .byte  15,93,203                           // minps         %xmm3,%xmm1
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  68,15,95,201                        // maxps         %xmm1,%xmm9
  .byte  68,15,93,211                        // minps         %xmm3,%xmm10
  .byte  65,15,95,210                        // maxps         %xmm10,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_uniform_color_sse41
.globl _sk_uniform_color_sse41
FUNCTION(_sk_uniform_color_sse41)
_sk_uniform_color_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,80,8                      // movss         0x8(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,88,12                     // movss         0xc(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_black_color_sse41
.globl _sk_black_color_sse41
FUNCTION(_sk_black_color_sse41)
_sk_black_color_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,210,239,1,0                // movaps        0x1efd2(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_white_color_sse41
.globl _sk_white_color_sse41
FUNCTION(_sk_white_color_sse41)
_sk_white_color_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,5,190,239,1,0                 // movaps        0x1efbe(%rip),%xmm0        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_rgba_sse41
.globl _sk_load_rgba_sse41
FUNCTION(_sk_load_rgba_sse41)
_sk_load_rgba_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  15,16,72,16                         // movups        0x10(%rax),%xmm1
  .byte  15,16,80,32                         // movups        0x20(%rax),%xmm2
  .byte  15,16,88,48                         // movups        0x30(%rax),%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_rgba_sse41
.globl _sk_store_rgba_sse41
FUNCTION(_sk_store_rgba_sse41)
_sk_store_rgba_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,17,0                             // movups        %xmm0,(%rax)
  .byte  15,17,72,16                         // movups        %xmm1,0x10(%rax)
  .byte  15,17,80,32                         // movups        %xmm2,0x20(%rax)
  .byte  15,17,88,48                         // movups        %xmm3,0x30(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clear_sse41
.globl _sk_clear_sse41
FUNCTION(_sk_clear_sse41)
_sk_clear_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcatop_sse41
.globl _sk_srcatop_sse41
FUNCTION(_sk_srcatop_sse41)
_sk_srcatop_sse41:
  .byte  15,89,199                           // mulps         %xmm7,%xmm0
  .byte  68,15,40,5,110,239,1,0              // movaps        0x1ef6e(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,204                        // mulps         %xmm4,%xmm9
  .byte  65,15,88,193                        // addps         %xmm9,%xmm0
  .byte  15,89,207                           // mulps         %xmm7,%xmm1
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  65,15,88,201                        // addps         %xmm9,%xmm1
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  65,15,88,209                        // addps         %xmm9,%xmm2
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  65,15,88,216                        // addps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstatop_sse41
.globl _sk_dstatop_sse41
FUNCTION(_sk_dstatop_sse41)
_sk_dstatop_sse41:
  .byte  68,15,40,195                        // movaps        %xmm3,%xmm8
  .byte  68,15,89,196                        // mulps         %xmm4,%xmm8
  .byte  68,15,40,13,33,239,1,0              // movaps        0x1ef21(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,207                        // subps         %xmm7,%xmm9
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  68,15,40,195                        // movaps        %xmm3,%xmm8
  .byte  68,15,89,197                        // mulps         %xmm5,%xmm8
  .byte  65,15,89,201                        // mulps         %xmm9,%xmm1
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  68,15,40,195                        // movaps        %xmm3,%xmm8
  .byte  68,15,89,198                        // mulps         %xmm6,%xmm8
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  65,15,88,208                        // addps         %xmm8,%xmm2
  .byte  68,15,89,203                        // mulps         %xmm3,%xmm9
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  65,15,88,217                        // addps         %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcin_sse41
.globl _sk_srcin_sse41
FUNCTION(_sk_srcin_sse41)
_sk_srcin_sse41:
  .byte  15,89,199                           // mulps         %xmm7,%xmm0
  .byte  15,89,207                           // mulps         %xmm7,%xmm1
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstin_sse41
.globl _sk_dstin_sse41
FUNCTION(_sk_dstin_sse41)
_sk_dstin_sse41:
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcout_sse41
.globl _sk_srcout_sse41
FUNCTION(_sk_srcout_sse41)
_sk_srcout_sse41:
  .byte  68,15,40,5,181,238,1,0              // movaps        0x1eeb5(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,199                        // subps         %xmm7,%xmm8
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstout_sse41
.globl _sk_dstout_sse41
FUNCTION(_sk_dstout_sse41)
_sk_dstout_sse41:
  .byte  68,15,40,5,149,238,1,0              // movaps        0x1ee95(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,216                        // movaps        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_sse41
.globl _sk_srcover_sse41
FUNCTION(_sk_srcover_sse41)
_sk_srcover_sse41:
  .byte  68,15,40,5,104,238,1,0              // movaps        0x1ee68(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,204                        // mulps         %xmm4,%xmm9
  .byte  65,15,88,193                        // addps         %xmm9,%xmm0
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  65,15,88,201                        // addps         %xmm9,%xmm1
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  65,15,88,209                        // addps         %xmm9,%xmm2
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  65,15,88,216                        // addps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstover_sse41
.globl _sk_dstover_sse41
FUNCTION(_sk_dstover_sse41)
_sk_dstover_sse41:
  .byte  68,15,40,5,44,238,1,0               // movaps        0x1ee2c(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,199                        // subps         %xmm7,%xmm8
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_modulate_sse41
.globl _sk_modulate_sse41
FUNCTION(_sk_modulate_sse41)
_sk_modulate_sse41:
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_multiply_sse41
.globl _sk_multiply_sse41
FUNCTION(_sk_multiply_sse41)
_sk_multiply_sse41:
  .byte  68,15,40,5,240,237,1,0              // movaps        0x1edf0(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,92,207                        // subps         %xmm7,%xmm9
  .byte  69,15,40,209                        // movaps        %xmm9,%xmm10
  .byte  68,15,89,208                        // mulps         %xmm0,%xmm10
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  68,15,89,220                        // mulps         %xmm4,%xmm11
  .byte  69,15,88,218                        // addps         %xmm10,%xmm11
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  65,15,88,195                        // addps         %xmm11,%xmm0
  .byte  69,15,40,209                        // movaps        %xmm9,%xmm10
  .byte  68,15,89,209                        // mulps         %xmm1,%xmm10
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  68,15,89,221                        // mulps         %xmm5,%xmm11
  .byte  69,15,88,218                        // addps         %xmm10,%xmm11
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  69,15,40,209                        // movaps        %xmm9,%xmm10
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  68,15,89,222                        // mulps         %xmm6,%xmm11
  .byte  69,15,88,218                        // addps         %xmm10,%xmm11
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  65,15,88,211                        // addps         %xmm11,%xmm2
  .byte  68,15,89,203                        // mulps         %xmm3,%xmm9
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  69,15,88,193                        // addps         %xmm9,%xmm8
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  65,15,88,216                        // addps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_plus__sse41
.globl _sk_plus__sse41
FUNCTION(_sk_plus__sse41)
_sk_plus__sse41:
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  68,15,40,5,113,237,1,0              // movaps        0x1ed71(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_screen_sse41
.globl _sk_screen_sse41
FUNCTION(_sk_screen_sse41)
_sk_screen_sse41:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  68,15,89,196                        // mulps         %xmm4,%xmm8
  .byte  65,15,92,192                        // subps         %xmm8,%xmm0
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  68,15,88,197                        // addps         %xmm5,%xmm8
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  68,15,92,193                        // subps         %xmm1,%xmm8
  .byte  68,15,40,202                        // movaps        %xmm2,%xmm9
  .byte  68,15,88,206                        // addps         %xmm6,%xmm9
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  68,15,92,202                        // subps         %xmm2,%xmm9
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  68,15,88,215                        // addps         %xmm7,%xmm10
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  68,15,92,211                        // subps         %xmm3,%xmm10
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  65,15,40,218                        // movaps        %xmm10,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xor__sse41
.globl _sk_xor__sse41
FUNCTION(_sk_xor__sse41)
_sk_xor__sse41:
  .byte  68,15,40,195                        // movaps        %xmm3,%xmm8
  .byte  15,40,29,253,236,1,0                // movaps        0x1ecfd(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,92,207                        // subps         %xmm7,%xmm9
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  65,15,92,216                        // subps         %xmm8,%xmm3
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  68,15,89,212                        // mulps         %xmm4,%xmm10
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  65,15,89,201                        // mulps         %xmm9,%xmm1
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  68,15,89,213                        // mulps         %xmm5,%xmm10
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  68,15,89,214                        // mulps         %xmm6,%xmm10
  .byte  65,15,88,210                        // addps         %xmm10,%xmm2
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  65,15,88,217                        // addps         %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_darken_sse41
.globl _sk_darken_sse41
FUNCTION(_sk_darken_sse41)
_sk_darken_sse41:
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  68,15,89,207                        // mulps         %xmm7,%xmm9
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  68,15,95,201                        // maxps         %xmm1,%xmm9
  .byte  65,15,92,193                        // subps         %xmm9,%xmm0
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  69,15,95,193                        // maxps         %xmm9,%xmm8
  .byte  65,15,92,200                        // subps         %xmm8,%xmm1
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  68,15,88,198                        // addps         %xmm6,%xmm8
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  65,15,95,209                        // maxps         %xmm9,%xmm2
  .byte  68,15,92,194                        // subps         %xmm2,%xmm8
  .byte  15,40,21,88,236,1,0                 // movaps        0x1ec58(%rip),%xmm2        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lighten_sse41
.globl _sk_lighten_sse41
FUNCTION(_sk_lighten_sse41)
_sk_lighten_sse41:
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  68,15,89,207                        // mulps         %xmm7,%xmm9
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  68,15,93,201                        // minps         %xmm1,%xmm9
  .byte  65,15,92,193                        // subps         %xmm9,%xmm0
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  69,15,93,193                        // minps         %xmm9,%xmm8
  .byte  65,15,92,200                        // subps         %xmm8,%xmm1
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  68,15,88,198                        // addps         %xmm6,%xmm8
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  65,15,93,209                        // minps         %xmm9,%xmm2
  .byte  68,15,92,194                        // subps         %xmm2,%xmm8
  .byte  15,40,21,237,235,1,0                // movaps        0x1ebed(%rip),%xmm2        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_difference_sse41
.globl _sk_difference_sse41
FUNCTION(_sk_difference_sse41)
_sk_difference_sse41:
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  68,15,89,207                        // mulps         %xmm7,%xmm9
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  68,15,93,201                        // minps         %xmm1,%xmm9
  .byte  69,15,88,201                        // addps         %xmm9,%xmm9
  .byte  65,15,92,193                        // subps         %xmm9,%xmm0
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  69,15,93,193                        // minps         %xmm9,%xmm8
  .byte  69,15,88,192                        // addps         %xmm8,%xmm8
  .byte  65,15,92,200                        // subps         %xmm8,%xmm1
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  68,15,88,198                        // addps         %xmm6,%xmm8
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  65,15,93,209                        // minps         %xmm9,%xmm2
  .byte  15,88,210                           // addps         %xmm2,%xmm2
  .byte  68,15,92,194                        // subps         %xmm2,%xmm8
  .byte  15,40,21,119,235,1,0                // movaps        0x1eb77(%rip),%xmm2        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_exclusion_sse41
.globl _sk_exclusion_sse41
FUNCTION(_sk_exclusion_sse41)
_sk_exclusion_sse41:
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  68,15,89,197                        // mulps         %xmm5,%xmm8
  .byte  69,15,88,192                        // addps         %xmm8,%xmm8
  .byte  65,15,92,200                        // subps         %xmm8,%xmm1
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  68,15,88,198                        // addps         %xmm6,%xmm8
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,88,210                           // addps         %xmm2,%xmm2
  .byte  68,15,92,194                        // subps         %xmm2,%xmm8
  .byte  15,40,21,39,235,1,0                 // movaps        0x1eb27(%rip),%xmm2        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_colorburn_sse41
.globl _sk_colorburn_sse41
FUNCTION(_sk_colorburn_sse41)
_sk_colorburn_sse41:
  .byte  68,15,40,29,14,235,1,0              // movaps        0x1eb0e(%rip),%xmm11        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,227                        // movaps        %xmm11,%xmm12
  .byte  68,15,92,231                        // subps         %xmm7,%xmm12
  .byte  69,15,40,204                        // movaps        %xmm12,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  68,15,40,199                        // movaps        %xmm7,%xmm8
  .byte  68,15,92,196                        // subps         %xmm4,%xmm8
  .byte  68,15,89,195                        // mulps         %xmm3,%xmm8
  .byte  68,15,83,208                        // rcpps         %xmm0,%xmm10
  .byte  69,15,89,208                        // mulps         %xmm8,%xmm10
  .byte  68,15,40,239                        // movaps        %xmm7,%xmm13
  .byte  69,15,93,234                        // minps         %xmm10,%xmm13
  .byte  68,15,40,199                        // movaps        %xmm7,%xmm8
  .byte  69,15,92,197                        // subps         %xmm13,%xmm8
  .byte  68,15,89,195                        // mulps         %xmm3,%xmm8
  .byte  69,15,88,193                        // addps         %xmm9,%xmm8
  .byte  68,15,88,204                        // addps         %xmm4,%xmm9
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  68,15,92,219                        // subps         %xmm3,%xmm11
  .byte  69,15,40,235                        // movaps        %xmm11,%xmm13
  .byte  68,15,89,236                        // mulps         %xmm4,%xmm13
  .byte  65,15,194,194,0                     // cmpeqps       %xmm10,%xmm0
  .byte  69,15,88,197                        // addps         %xmm13,%xmm8
  .byte  102,69,15,56,20,197                 // blendvps      %xmm0,%xmm13,%xmm8
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,194,199,0                        // cmpeqps       %xmm7,%xmm0
  .byte  102,69,15,56,20,193                 // blendvps      %xmm0,%xmm9,%xmm8
  .byte  69,15,40,236                        // movaps        %xmm12,%xmm13
  .byte  68,15,89,233                        // mulps         %xmm1,%xmm13
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  68,15,83,201                        // rcpps         %xmm1,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  65,15,93,193                        // minps         %xmm9,%xmm0
  .byte  68,15,40,207                        // movaps        %xmm7,%xmm9
  .byte  68,15,92,200                        // subps         %xmm0,%xmm9
  .byte  69,15,40,243                        // movaps        %xmm11,%xmm14
  .byte  68,15,89,245                        // mulps         %xmm5,%xmm14
  .byte  65,15,194,202,0                     // cmpeqps       %xmm10,%xmm1
  .byte  68,15,89,203                        // mulps         %xmm3,%xmm9
  .byte  69,15,88,205                        // addps         %xmm13,%xmm9
  .byte  69,15,88,206                        // addps         %xmm14,%xmm9
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  102,69,15,56,20,206                 // blendvps      %xmm0,%xmm14,%xmm9
  .byte  68,15,88,237                        // addps         %xmm5,%xmm13
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,194,199,0                        // cmpeqps       %xmm7,%xmm0
  .byte  102,69,15,56,20,205                 // blendvps      %xmm0,%xmm13,%xmm9
  .byte  68,15,89,226                        // mulps         %xmm2,%xmm12
  .byte  68,15,194,210,0                     // cmpeqps       %xmm2,%xmm10
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  15,92,198                           // subps         %xmm6,%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,83,202                           // rcpps         %xmm2,%xmm1
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  15,93,193                           // minps         %xmm1,%xmm0
  .byte  15,40,215                           // movaps        %xmm7,%xmm2
  .byte  15,92,208                           // subps         %xmm0,%xmm2
  .byte  65,15,40,203                        // movaps        %xmm11,%xmm1
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  65,15,88,212                        // addps         %xmm12,%xmm2
  .byte  15,88,209                           // addps         %xmm1,%xmm2
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  102,15,56,20,209                    // blendvps      %xmm0,%xmm1,%xmm2
  .byte  68,15,88,230                        // addps         %xmm6,%xmm12
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,194,199,0                        // cmpeqps       %xmm7,%xmm0
  .byte  102,65,15,56,20,212                 // blendvps      %xmm0,%xmm12,%xmm2
  .byte  68,15,89,223                        // mulps         %xmm7,%xmm11
  .byte  65,15,88,219                        // addps         %xmm11,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_colordodge_sse41
.globl _sk_colordodge_sse41
FUNCTION(_sk_colordodge_sse41)
_sk_colordodge_sse41:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  68,15,40,21,216,233,1,0             // movaps        0x1e9d8(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,218                        // movaps        %xmm10,%xmm11
  .byte  68,15,92,223                        // subps         %xmm7,%xmm11
  .byte  69,15,40,227                        // movaps        %xmm11,%xmm12
  .byte  69,15,89,224                        // mulps         %xmm8,%xmm12
  .byte  68,15,40,235                        // movaps        %xmm3,%xmm13
  .byte  68,15,89,236                        // mulps         %xmm4,%xmm13
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  65,15,92,192                        // subps         %xmm8,%xmm0
  .byte  68,15,83,200                        // rcpps         %xmm0,%xmm9
  .byte  69,15,89,205                        // mulps         %xmm13,%xmm9
  .byte  68,15,40,239                        // movaps        %xmm7,%xmm13
  .byte  68,15,40,247                        // movaps        %xmm7,%xmm14
  .byte  69,15,93,241                        // minps         %xmm9,%xmm14
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,194,195,0                        // cmpeqps       %xmm3,%xmm0
  .byte  68,15,89,243                        // mulps         %xmm3,%xmm14
  .byte  69,15,88,244                        // addps         %xmm12,%xmm14
  .byte  102,69,15,56,20,240                 // blendvps      %xmm0,%xmm8,%xmm14
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,92,211                        // subps         %xmm3,%xmm10
  .byte  69,15,40,194                        // movaps        %xmm10,%xmm8
  .byte  68,15,89,196                        // mulps         %xmm4,%xmm8
  .byte  69,15,88,198                        // addps         %xmm14,%xmm8
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  65,15,194,193,0                     // cmpeqps       %xmm9,%xmm0
  .byte  102,69,15,56,20,196                 // blendvps      %xmm0,%xmm12,%xmm8
  .byte  68,15,40,227                        // movaps        %xmm3,%xmm12
  .byte  68,15,89,229                        // mulps         %xmm5,%xmm12
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,83,192                           // rcpps         %xmm0,%xmm0
  .byte  65,15,89,196                        // mulps         %xmm12,%xmm0
  .byte  69,15,40,227                        // movaps        %xmm11,%xmm12
  .byte  68,15,89,225                        // mulps         %xmm1,%xmm12
  .byte  68,15,93,232                        // minps         %xmm0,%xmm13
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,194,195,0                        // cmpeqps       %xmm3,%xmm0
  .byte  68,15,89,235                        // mulps         %xmm3,%xmm13
  .byte  69,15,88,236                        // addps         %xmm12,%xmm13
  .byte  102,68,15,56,20,233                 // blendvps      %xmm0,%xmm1,%xmm13
  .byte  65,15,40,202                        // movaps        %xmm10,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  65,15,88,205                        // addps         %xmm13,%xmm1
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  65,15,194,193,0                     // cmpeqps       %xmm9,%xmm0
  .byte  102,65,15,56,20,204                 // blendvps      %xmm0,%xmm12,%xmm1
  .byte  68,15,40,227                        // movaps        %xmm3,%xmm12
  .byte  68,15,89,230                        // mulps         %xmm6,%xmm12
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,92,194                           // subps         %xmm2,%xmm0
  .byte  15,83,192                           // rcpps         %xmm0,%xmm0
  .byte  65,15,89,196                        // mulps         %xmm12,%xmm0
  .byte  68,15,40,231                        // movaps        %xmm7,%xmm12
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  68,15,93,224                        // minps         %xmm0,%xmm12
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,194,195,0                        // cmpeqps       %xmm3,%xmm0
  .byte  68,15,89,227                        // mulps         %xmm3,%xmm12
  .byte  69,15,88,227                        // addps         %xmm11,%xmm12
  .byte  102,68,15,56,20,226                 // blendvps      %xmm0,%xmm2,%xmm12
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  65,15,88,212                        // addps         %xmm12,%xmm2
  .byte  68,15,194,206,0                     // cmpeqps       %xmm6,%xmm9
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,65,15,56,20,211                 // blendvps      %xmm0,%xmm11,%xmm2
  .byte  68,15,89,215                        // mulps         %xmm7,%xmm10
  .byte  65,15,88,218                        // addps         %xmm10,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hardlight_sse41
.globl _sk_hardlight_sse41
FUNCTION(_sk_hardlight_sse41)
_sk_hardlight_sse41:
  .byte  15,41,116,36,232                    // movaps        %xmm6,-0x18(%rsp)
  .byte  68,15,40,229                        // movaps        %xmm5,%xmm12
  .byte  15,40,244                           // movaps        %xmm4,%xmm6
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  68,15,40,21,163,232,1,0             // movaps        0x1e8a3(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,40,234                        // movaps        %xmm10,%xmm5
  .byte  15,92,239                           // subps         %xmm7,%xmm5
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  68,15,92,212                        // subps         %xmm4,%xmm10
  .byte  69,15,40,194                        // movaps        %xmm10,%xmm8
  .byte  68,15,89,198                        // mulps         %xmm6,%xmm8
  .byte  68,15,88,192                        // addps         %xmm0,%xmm8
  .byte  68,15,40,252                        // movaps        %xmm4,%xmm15
  .byte  69,15,92,249                        // subps         %xmm9,%xmm15
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  68,15,40,239                        // movaps        %xmm7,%xmm13
  .byte  68,15,40,247                        // movaps        %xmm7,%xmm14
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  15,92,198                           // subps         %xmm6,%xmm0
  .byte  65,15,89,199                        // mulps         %xmm15,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  68,15,40,251                        // movaps        %xmm3,%xmm15
  .byte  68,15,92,248                        // subps         %xmm0,%xmm15
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,194,196,2                        // cmpleps       %xmm4,%xmm0
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  69,15,88,201                        // addps         %xmm9,%xmm9
  .byte  102,69,15,56,20,249                 // blendvps      %xmm0,%xmm9,%xmm15
  .byte  68,15,40,221                        // movaps        %xmm5,%xmm11
  .byte  68,15,89,217                        // mulps         %xmm1,%xmm11
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  69,15,40,204                        // movaps        %xmm12,%xmm9
  .byte  69,15,92,233                        // subps         %xmm9,%xmm13
  .byte  68,15,89,232                        // mulps         %xmm0,%xmm13
  .byte  69,15,88,237                        // addps         %xmm13,%xmm13
  .byte  68,15,40,227                        // movaps        %xmm3,%xmm12
  .byte  69,15,92,229                        // subps         %xmm13,%xmm12
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,194,196,2                        // cmpleps       %xmm4,%xmm0
  .byte  65,15,89,201                        // mulps         %xmm9,%xmm1
  .byte  69,15,40,233                        // movaps        %xmm9,%xmm13
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  102,68,15,56,20,225                 // blendvps      %xmm0,%xmm1,%xmm12
  .byte  65,15,40,202                        // movaps        %xmm10,%xmm1
  .byte  69,15,40,202                        // movaps        %xmm10,%xmm9
  .byte  68,15,89,215                        // mulps         %xmm7,%xmm10
  .byte  69,15,88,199                        // addps         %xmm15,%xmm8
  .byte  65,15,89,205                        // mulps         %xmm13,%xmm1
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  65,15,88,204                        // addps         %xmm12,%xmm1
  .byte  15,89,234                           // mulps         %xmm2,%xmm5
  .byte  68,15,40,92,36,232                  // movaps        -0x18(%rsp),%xmm11
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  68,15,88,205                        // addps         %xmm5,%xmm9
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,194,196,2                        // cmpleps       %xmm4,%xmm0
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,92,234                           // subps         %xmm2,%xmm5
  .byte  65,15,89,211                        // mulps         %xmm11,%xmm2
  .byte  15,88,210                           // addps         %xmm2,%xmm2
  .byte  69,15,92,243                        // subps         %xmm11,%xmm14
  .byte  68,15,89,245                        // mulps         %xmm5,%xmm14
  .byte  69,15,88,246                        // addps         %xmm14,%xmm14
  .byte  65,15,92,222                        // subps         %xmm14,%xmm3
  .byte  102,15,56,20,218                    // blendvps      %xmm0,%xmm2,%xmm3
  .byte  68,15,88,203                        // addps         %xmm3,%xmm9
  .byte  65,15,88,226                        // addps         %xmm10,%xmm4
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  65,15,40,237                        // movaps        %xmm13,%xmm5
  .byte  65,15,40,243                        // movaps        %xmm11,%xmm6
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_overlay_sse41
.globl _sk_overlay_sse41
FUNCTION(_sk_overlay_sse41)
_sk_overlay_sse41:
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,40,240                        // movaps        %xmm0,%xmm14
  .byte  68,15,40,21,120,231,1,0             // movaps        0x1e778(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,218                        // movaps        %xmm10,%xmm11
  .byte  68,15,92,223                        // subps         %xmm7,%xmm11
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  65,15,89,198                        // mulps         %xmm14,%xmm0
  .byte  68,15,92,211                        // subps         %xmm3,%xmm10
  .byte  69,15,40,194                        // movaps        %xmm10,%xmm8
  .byte  68,15,89,196                        // mulps         %xmm4,%xmm8
  .byte  68,15,88,192                        // addps         %xmm0,%xmm8
  .byte  68,15,40,235                        // movaps        %xmm3,%xmm13
  .byte  69,15,92,238                        // subps         %xmm14,%xmm13
  .byte  68,15,89,244                        // mulps         %xmm4,%xmm14
  .byte  15,40,207                           // movaps        %xmm7,%xmm1
  .byte  15,92,204                           // subps         %xmm4,%xmm1
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,194,199,2                        // cmpleps       %xmm7,%xmm0
  .byte  69,15,88,246                        // addps         %xmm14,%xmm14
  .byte  68,15,40,227                        // movaps        %xmm3,%xmm12
  .byte  68,15,89,231                        // mulps         %xmm7,%xmm12
  .byte  65,15,89,205                        // mulps         %xmm13,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  69,15,40,236                        // movaps        %xmm12,%xmm13
  .byte  68,15,92,233                        // subps         %xmm1,%xmm13
  .byte  102,69,15,56,20,238                 // blendvps      %xmm0,%xmm14,%xmm13
  .byte  69,15,88,197                        // addps         %xmm13,%xmm8
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  65,15,40,202                        // movaps        %xmm10,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  68,15,40,235                        // movaps        %xmm3,%xmm13
  .byte  69,15,92,233                        // subps         %xmm9,%xmm13
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  68,15,40,247                        // movaps        %xmm7,%xmm14
  .byte  68,15,92,245                        // subps         %xmm5,%xmm14
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,194,199,2                        // cmpleps       %xmm7,%xmm0
  .byte  69,15,88,201                        // addps         %xmm9,%xmm9
  .byte  69,15,89,245                        // mulps         %xmm13,%xmm14
  .byte  69,15,88,246                        // addps         %xmm14,%xmm14
  .byte  69,15,40,236                        // movaps        %xmm12,%xmm13
  .byte  69,15,92,238                        // subps         %xmm14,%xmm13
  .byte  102,69,15,56,20,233                 // blendvps      %xmm0,%xmm9,%xmm13
  .byte  65,15,88,205                        // addps         %xmm13,%xmm1
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  69,15,40,202                        // movaps        %xmm10,%xmm9
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  69,15,88,203                        // addps         %xmm11,%xmm9
  .byte  68,15,40,219                        // movaps        %xmm3,%xmm11
  .byte  68,15,92,218                        // subps         %xmm2,%xmm11
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  68,15,40,239                        // movaps        %xmm7,%xmm13
  .byte  68,15,92,238                        // subps         %xmm6,%xmm13
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,194,199,2                        // cmpleps       %xmm7,%xmm0
  .byte  15,88,210                           // addps         %xmm2,%xmm2
  .byte  69,15,89,235                        // mulps         %xmm11,%xmm13
  .byte  69,15,88,237                        // addps         %xmm13,%xmm13
  .byte  69,15,92,229                        // subps         %xmm13,%xmm12
  .byte  102,68,15,56,20,226                 // blendvps      %xmm0,%xmm2,%xmm12
  .byte  69,15,88,204                        // addps         %xmm12,%xmm9
  .byte  68,15,89,215                        // mulps         %xmm7,%xmm10
  .byte  65,15,88,218                        // addps         %xmm10,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_softlight_sse41
.globl _sk_softlight_sse41
FUNCTION(_sk_softlight_sse41)
_sk_softlight_sse41:
  .byte  15,41,116,36,216                    // movaps        %xmm6,-0x28(%rsp)
  .byte  15,40,244                           // movaps        %xmm4,%xmm6
  .byte  15,41,84,36,232                     // movaps        %xmm2,-0x18(%rsp)
  .byte  15,41,76,36,200                     // movaps        %xmm1,-0x38(%rsp)
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,194,207,1                     // cmpltps       %xmm7,%xmm9
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,94,199                           // divps         %xmm7,%xmm0
  .byte  65,15,84,193                        // andps         %xmm9,%xmm0
  .byte  15,40,13,63,230,1,0                 // movaps        0x1e63f(%rip),%xmm1        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,40,209                        // movaps        %xmm1,%xmm10
  .byte  68,15,92,208                        // subps         %xmm0,%xmm10
  .byte  68,15,40,240                        // movaps        %xmm0,%xmm14
  .byte  68,15,40,248                        // movaps        %xmm0,%xmm15
  .byte  15,82,208                           // rsqrtps       %xmm0,%xmm2
  .byte  68,15,83,218                        // rcpps         %xmm2,%xmm11
  .byte  68,15,92,216                        // subps         %xmm0,%xmm11
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,89,210                           // mulps         %xmm2,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  68,15,40,45,109,230,1,0             // movaps        0x1e66d(%rip),%xmm13        # 3abb0 <_sk_srcover_bgra_8888_sse2_lowp+0xc48>
  .byte  69,15,88,245                        // addps         %xmm13,%xmm14
  .byte  68,15,89,242                        // mulps         %xmm2,%xmm14
  .byte  68,15,40,37,109,230,1,0             // movaps        0x1e66d(%rip),%xmm12        # 3abc0 <_sk_srcover_bgra_8888_sse2_lowp+0xc58>
  .byte  69,15,89,252                        // mulps         %xmm12,%xmm15
  .byte  69,15,88,254                        // addps         %xmm14,%xmm15
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,194,199,2                        // cmpleps       %xmm7,%xmm0
  .byte  102,69,15,56,20,223                 // blendvps      %xmm0,%xmm15,%xmm11
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  68,15,88,211                        // addps         %xmm3,%xmm10
  .byte  68,15,89,214                        // mulps         %xmm6,%xmm10
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  68,15,88,218                        // addps         %xmm2,%xmm11
  .byte  15,194,195,2                        // cmpleps       %xmm3,%xmm0
  .byte  102,69,15,56,20,218                 // blendvps      %xmm0,%xmm10,%xmm11
  .byte  68,15,40,213                        // movaps        %xmm5,%xmm10
  .byte  68,15,94,215                        // divps         %xmm7,%xmm10
  .byte  69,15,84,209                        // andps         %xmm9,%xmm10
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,89,210                           // mulps         %xmm2,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  65,15,88,197                        // addps         %xmm13,%xmm0
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,89,212                        // mulps         %xmm12,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  65,15,82,194                        // rsqrtps       %xmm10,%xmm0
  .byte  68,15,83,240                        // rcpps         %xmm0,%xmm14
  .byte  69,15,92,242                        // subps         %xmm10,%xmm14
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,194,199,2                        // cmpleps       %xmm7,%xmm0
  .byte  102,68,15,56,20,242                 // blendvps      %xmm0,%xmm2,%xmm14
  .byte  68,15,40,249                        // movaps        %xmm1,%xmm15
  .byte  69,15,92,250                        // subps         %xmm10,%xmm15
  .byte  15,40,108,36,200                    // movaps        -0x38(%rsp),%xmm5
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  68,15,89,250                        // mulps         %xmm2,%xmm15
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  68,15,89,242                        // mulps         %xmm2,%xmm14
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,41,100,36,184                    // movaps        %xmm4,-0x48(%rsp)
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  68,15,88,242                        // addps         %xmm2,%xmm14
  .byte  68,15,88,251                        // addps         %xmm3,%xmm15
  .byte  68,15,89,252                        // mulps         %xmm4,%xmm15
  .byte  15,194,195,2                        // cmpleps       %xmm3,%xmm0
  .byte  102,69,15,56,20,247                 // blendvps      %xmm0,%xmm15,%xmm14
  .byte  68,15,40,249                        // movaps        %xmm1,%xmm15
  .byte  15,40,100,36,216                    // movaps        -0x28(%rsp),%xmm4
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,94,199                           // divps         %xmm7,%xmm0
  .byte  65,15,84,193                        // andps         %xmm9,%xmm0
  .byte  68,15,40,209                        // movaps        %xmm1,%xmm10
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  68,15,88,232                        // addps         %xmm0,%xmm13
  .byte  68,15,89,224                        // mulps         %xmm0,%xmm12
  .byte  15,82,208                           // rsqrtps       %xmm0,%xmm2
  .byte  68,15,83,202                        // rcpps         %xmm2,%xmm9
  .byte  68,15,92,200                        // subps         %xmm0,%xmm9
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,89,210                           // mulps         %xmm2,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  68,15,89,234                        // mulps         %xmm2,%xmm13
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,194,199,2                        // cmpleps       %xmm7,%xmm0
  .byte  102,69,15,56,20,204                 // blendvps      %xmm0,%xmm12,%xmm9
  .byte  68,15,40,100,36,232                 // movaps        -0x18(%rsp),%xmm12
  .byte  65,15,40,196                        // movaps        %xmm12,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  68,15,89,202                        // mulps         %xmm2,%xmm9
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  68,15,88,202                        // addps         %xmm2,%xmm9
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,194,195,2                        // cmpleps       %xmm3,%xmm0
  .byte  102,68,15,56,20,201                 // blendvps      %xmm0,%xmm1,%xmm9
  .byte  68,15,92,255                        // subps         %xmm7,%xmm15
  .byte  69,15,89,199                        // mulps         %xmm15,%xmm8
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  65,15,89,207                        // mulps         %xmm15,%xmm1
  .byte  69,15,89,252                        // mulps         %xmm12,%xmm15
  .byte  68,15,92,211                        // subps         %xmm3,%xmm10
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  68,15,88,192                        // addps         %xmm0,%xmm8
  .byte  69,15,88,195                        // addps         %xmm11,%xmm8
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  15,40,108,36,184                    // movaps        -0x48(%rsp),%xmm5
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  65,15,88,206                        // addps         %xmm14,%xmm1
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,40,212                           // movaps        %xmm4,%xmm2
  .byte  65,15,88,199                        // addps         %xmm15,%xmm0
  .byte  68,15,88,200                        // addps         %xmm0,%xmm9
  .byte  68,15,89,215                        // mulps         %xmm7,%xmm10
  .byte  65,15,88,218                        // addps         %xmm10,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  15,40,242                           // movaps        %xmm2,%xmm6
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hue_sse41
.globl _sk_hue_sse41
FUNCTION(_sk_hue_sse41)
_sk_hue_sse41:
  .byte  15,41,124,36,152                    // movaps        %xmm7,-0x68(%rsp)
  .byte  68,15,40,246                        // movaps        %xmm6,%xmm14
  .byte  15,40,244                           // movaps        %xmm4,%xmm6
  .byte  68,15,40,195                        // movaps        %xmm3,%xmm8
  .byte  15,41,84,36,232                     // movaps        %xmm2,-0x18(%rsp)
  .byte  15,41,76,36,216                     // movaps        %xmm1,-0x28(%rsp)
  .byte  68,15,40,208                        // movaps        %xmm0,%xmm10
  .byte  68,15,41,84,36,200                  // movaps        %xmm10,-0x38(%rsp)
  .byte  69,15,89,208                        // mulps         %xmm8,%xmm10
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  68,15,40,234                        // movaps        %xmm2,%xmm13
  .byte  69,15,89,232                        // mulps         %xmm8,%xmm13
  .byte  68,15,40,205                        // movaps        %xmm5,%xmm9
  .byte  68,15,40,221                        // movaps        %xmm5,%xmm11
  .byte  15,41,108,36,184                    // movaps        %xmm5,-0x48(%rsp)
  .byte  69,15,95,222                        // maxps         %xmm14,%xmm11
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  68,15,40,230                        // movaps        %xmm6,%xmm12
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  65,15,95,211                        // maxps         %xmm11,%xmm2
  .byte  65,15,40,230                        // movaps        %xmm14,%xmm4
  .byte  15,41,100,36,168                    // movaps        %xmm4,-0x58(%rsp)
  .byte  68,15,93,204                        // minps         %xmm4,%xmm9
  .byte  65,15,93,249                        // minps         %xmm9,%xmm7
  .byte  15,92,215                           // subps         %xmm7,%xmm2
  .byte  15,40,249                           // movaps        %xmm1,%xmm7
  .byte  65,15,93,253                        // minps         %xmm13,%xmm7
  .byte  65,15,40,218                        // movaps        %xmm10,%xmm3
  .byte  15,93,223                           // minps         %xmm7,%xmm3
  .byte  15,40,249                           // movaps        %xmm1,%xmm7
  .byte  65,15,95,253                        // maxps         %xmm13,%xmm7
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  15,95,199                           // maxps         %xmm7,%xmm0
  .byte  15,40,253                           // movaps        %xmm5,%xmm7
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,92,195                           // subps         %xmm3,%xmm0
  .byte  68,15,92,211                        // subps         %xmm3,%xmm10
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  68,15,92,235                        // subps         %xmm3,%xmm13
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  68,15,94,208                        // divps         %xmm0,%xmm10
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,94,200                           // divps         %xmm0,%xmm1
  .byte  68,15,89,234                        // mulps         %xmm2,%xmm13
  .byte  68,15,94,232                        // divps         %xmm0,%xmm13
  .byte  15,194,195,4                        // cmpneqps      %xmm3,%xmm0
  .byte  68,15,84,208                        // andps         %xmm0,%xmm10
  .byte  15,84,200                           // andps         %xmm0,%xmm1
  .byte  68,15,84,232                        // andps         %xmm0,%xmm13
  .byte  15,40,5,216,227,1,0                 // movaps        0x1e3d8(%rip),%xmm0        # 3abd0 <_sk_srcover_bgra_8888_sse2_lowp+0xc68>
  .byte  68,15,89,224                        // mulps         %xmm0,%xmm12
  .byte  15,40,21,221,227,1,0                // movaps        0x1e3dd(%rip),%xmm2        # 3abe0 <_sk_srcover_bgra_8888_sse2_lowp+0xc78>
  .byte  15,89,250                           // mulps         %xmm2,%xmm7
  .byte  65,15,88,252                        // addps         %xmm12,%xmm7
  .byte  68,15,40,53,222,227,1,0             // movaps        0x1e3de(%rip),%xmm14        # 3abf0 <_sk_srcover_bgra_8888_sse2_lowp+0xc88>
  .byte  68,15,40,252                        // movaps        %xmm4,%xmm15
  .byte  69,15,89,254                        // mulps         %xmm14,%xmm15
  .byte  68,15,88,255                        // addps         %xmm7,%xmm15
  .byte  65,15,40,218                        // movaps        %xmm10,%xmm3
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,40,249                           // movaps        %xmm1,%xmm7
  .byte  15,89,250                           // mulps         %xmm2,%xmm7
  .byte  15,88,251                           // addps         %xmm3,%xmm7
  .byte  65,15,40,221                        // movaps        %xmm13,%xmm3
  .byte  65,15,89,222                        // mulps         %xmm14,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  69,15,89,248                        // mulps         %xmm8,%xmm15
  .byte  68,15,92,251                        // subps         %xmm3,%xmm15
  .byte  69,15,88,215                        // addps         %xmm15,%xmm10
  .byte  65,15,88,207                        // addps         %xmm15,%xmm1
  .byte  69,15,88,253                        // addps         %xmm13,%xmm15
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  65,15,93,223                        // minps         %xmm15,%xmm3
  .byte  65,15,40,250                        // movaps        %xmm10,%xmm7
  .byte  15,93,251                           // minps         %xmm3,%xmm7
  .byte  65,15,89,194                        // mulps         %xmm10,%xmm0
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  69,15,89,247                        // mulps         %xmm15,%xmm14
  .byte  68,15,88,242                        // addps         %xmm2,%xmm14
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,194,207,2                     // cmpleps       %xmm7,%xmm9
  .byte  65,15,40,222                        // movaps        %xmm14,%xmm3
  .byte  15,92,223                           // subps         %xmm7,%xmm3
  .byte  69,15,40,234                        // movaps        %xmm10,%xmm13
  .byte  69,15,92,238                        // subps         %xmm14,%xmm13
  .byte  69,15,89,238                        // mulps         %xmm14,%xmm13
  .byte  68,15,94,235                        // divps         %xmm3,%xmm13
  .byte  69,15,88,238                        // addps         %xmm14,%xmm13
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,69,15,56,20,234                 // blendvps      %xmm0,%xmm10,%xmm13
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  65,15,95,199                        // maxps         %xmm15,%xmm0
  .byte  68,15,95,208                        // maxps         %xmm0,%xmm10
  .byte  65,15,40,248                        // movaps        %xmm8,%xmm7
  .byte  15,40,108,36,152                    // movaps        -0x68(%rsp),%xmm5
  .byte  15,89,253                           // mulps         %xmm5,%xmm7
  .byte  15,40,231                           // movaps        %xmm7,%xmm4
  .byte  65,15,194,226,1                     // cmpltps       %xmm10,%xmm4
  .byte  65,15,40,213                        // movaps        %xmm13,%xmm2
  .byte  65,15,92,214                        // subps         %xmm14,%xmm2
  .byte  68,15,40,223                        // movaps        %xmm7,%xmm11
  .byte  69,15,92,222                        // subps         %xmm14,%xmm11
  .byte  65,15,89,211                        // mulps         %xmm11,%xmm2
  .byte  69,15,92,214                        // subps         %xmm14,%xmm10
  .byte  65,15,94,210                        // divps         %xmm10,%xmm2
  .byte  65,15,88,214                        // addps         %xmm14,%xmm2
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  102,68,15,56,20,234                 // blendvps      %xmm0,%xmm2,%xmm13
  .byte  68,15,40,225                        // movaps        %xmm1,%xmm12
  .byte  69,15,92,230                        // subps         %xmm14,%xmm12
  .byte  69,15,89,230                        // mulps         %xmm14,%xmm12
  .byte  68,15,94,227                        // divps         %xmm3,%xmm12
  .byte  69,15,88,230                        // addps         %xmm14,%xmm12
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,68,15,56,20,225                 // blendvps      %xmm0,%xmm1,%xmm12
  .byte  65,15,40,204                        // movaps        %xmm12,%xmm1
  .byte  65,15,92,206                        // subps         %xmm14,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  65,15,94,202                        // divps         %xmm10,%xmm1
  .byte  65,15,88,206                        // addps         %xmm14,%xmm1
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  102,68,15,56,20,225                 // blendvps      %xmm0,%xmm1,%xmm12
  .byte  65,15,40,207                        // movaps        %xmm15,%xmm1
  .byte  65,15,92,206                        // subps         %xmm14,%xmm1
  .byte  65,15,89,206                        // mulps         %xmm14,%xmm1
  .byte  15,94,203                           // divps         %xmm3,%xmm1
  .byte  65,15,88,206                        // addps         %xmm14,%xmm1
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,65,15,56,20,207                 // blendvps      %xmm0,%xmm15,%xmm1
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  65,15,92,214                        // subps         %xmm14,%xmm2
  .byte  65,15,89,211                        // mulps         %xmm11,%xmm2
  .byte  65,15,94,210                        // divps         %xmm10,%xmm2
  .byte  65,15,88,214                        // addps         %xmm14,%xmm2
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  102,15,56,20,202                    // blendvps      %xmm0,%xmm2,%xmm1
  .byte  68,15,40,13,242,225,1,0             // movaps        0x1e1f2(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,40,225                        // movaps        %xmm9,%xmm4
  .byte  15,92,229                           // subps         %xmm5,%xmm4
  .byte  15,40,68,36,200                     // movaps        -0x38(%rsp),%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,40,92,36,216                     // movaps        -0x28(%rsp),%xmm3
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  15,89,100,36,232                    // mulps         -0x18(%rsp),%xmm4
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  68,15,88,197                        // addps         %xmm5,%xmm8
  .byte  68,15,40,213                        // movaps        %xmm5,%xmm10
  .byte  68,15,92,199                        // subps         %xmm7,%xmm8
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  68,15,95,234                        // maxps         %xmm2,%xmm13
  .byte  68,15,95,226                        // maxps         %xmm2,%xmm12
  .byte  15,95,202                           // maxps         %xmm2,%xmm1
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  65,15,88,197                        // addps         %xmm13,%xmm0
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  15,40,108,36,184                    // movaps        -0x48(%rsp),%xmm5
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  65,15,88,220                        // addps         %xmm12,%xmm3
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,40,92,36,168                     // movaps        -0x58(%rsp),%xmm3
  .byte  68,15,89,203                        // mulps         %xmm3,%xmm9
  .byte  68,15,88,204                        // addps         %xmm4,%xmm9
  .byte  68,15,88,201                        // addps         %xmm1,%xmm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  15,40,243                           // movaps        %xmm3,%xmm6
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  65,15,40,216                        // movaps        %xmm8,%xmm3
  .byte  65,15,40,250                        // movaps        %xmm10,%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_saturation_sse41
.globl _sk_saturation_sse41
FUNCTION(_sk_saturation_sse41)
_sk_saturation_sse41:
  .byte  68,15,40,206                        // movaps        %xmm6,%xmm9
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  15,41,76,36,216                     // movaps        %xmm1,-0x28(%rsp)
  .byte  15,41,68,36,200                     // movaps        %xmm0,-0x38(%rsp)
  .byte  68,15,40,212                        // movaps        %xmm4,%xmm10
  .byte  68,15,89,213                        // mulps         %xmm5,%xmm10
  .byte  68,15,40,220                        // movaps        %xmm4,%xmm11
  .byte  68,15,89,222                        // mulps         %xmm6,%xmm11
  .byte  68,15,40,196                        // movaps        %xmm4,%xmm8
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  69,15,40,241                        // movaps        %xmm9,%xmm14
  .byte  68,15,41,116,36,184                 // movaps        %xmm14,-0x48(%rsp)
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  68,15,40,202                        // movaps        %xmm2,%xmm9
  .byte  68,15,41,76,36,232                  // movaps        %xmm9,-0x18(%rsp)
  .byte  65,15,95,217                        // maxps         %xmm9,%xmm3
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,95,211                           // maxps         %xmm3,%xmm2
  .byte  68,15,40,225                        // movaps        %xmm1,%xmm12
  .byte  69,15,93,225                        // minps         %xmm9,%xmm12
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  65,15,93,220                        // minps         %xmm12,%xmm3
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  68,15,40,231                        // movaps        %xmm7,%xmm12
  .byte  68,15,41,100,36,168                 // movaps        %xmm12,-0x58(%rsp)
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  65,15,40,218                        // movaps        %xmm10,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  65,15,95,192                        // maxps         %xmm8,%xmm0
  .byte  65,15,40,250                        // movaps        %xmm10,%xmm7
  .byte  15,95,248                           // maxps         %xmm0,%xmm7
  .byte  15,92,251                           // subps         %xmm3,%xmm7
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  68,15,92,211                        // subps         %xmm3,%xmm10
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  68,15,94,215                        // divps         %xmm7,%xmm10
  .byte  68,15,92,219                        // subps         %xmm3,%xmm11
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  68,15,94,223                        // divps         %xmm7,%xmm11
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  68,15,89,194                        // mulps         %xmm2,%xmm8
  .byte  68,15,94,199                        // divps         %xmm7,%xmm8
  .byte  15,194,248,4                        // cmpneqps      %xmm0,%xmm7
  .byte  68,15,84,215                        // andps         %xmm7,%xmm10
  .byte  68,15,84,223                        // andps         %xmm7,%xmm11
  .byte  68,15,84,199                        // andps         %xmm7,%xmm8
  .byte  15,40,21,28,225,1,0                 // movaps        0x1e11c(%rip),%xmm2        # 3abd0 <_sk_srcover_bgra_8888_sse2_lowp+0xc68>
  .byte  15,40,221                           // movaps        %xmm5,%xmm3
  .byte  15,89,218                           // mulps         %xmm2,%xmm3
  .byte  15,40,13,31,225,1,0                 // movaps        0x1e11f(%rip),%xmm1        # 3abe0 <_sk_srcover_bgra_8888_sse2_lowp+0xc78>
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  15,88,251                           // addps         %xmm3,%xmm7
  .byte  68,15,40,45,30,225,1,0              // movaps        0x1e11e(%rip),%xmm13        # 3abf0 <_sk_srcover_bgra_8888_sse2_lowp+0xc88>
  .byte  69,15,89,245                        // mulps         %xmm13,%xmm14
  .byte  68,15,88,247                        // addps         %xmm7,%xmm14
  .byte  65,15,40,218                        // movaps        %xmm10,%xmm3
  .byte  15,89,218                           // mulps         %xmm2,%xmm3
  .byte  65,15,40,251                        // movaps        %xmm11,%xmm7
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  15,88,251                           // addps         %xmm3,%xmm7
  .byte  65,15,40,216                        // movaps        %xmm8,%xmm3
  .byte  65,15,89,221                        // mulps         %xmm13,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  68,15,89,244                        // mulps         %xmm4,%xmm14
  .byte  68,15,92,243                        // subps         %xmm3,%xmm14
  .byte  69,15,88,214                        // addps         %xmm14,%xmm10
  .byte  69,15,88,222                        // addps         %xmm14,%xmm11
  .byte  69,15,88,240                        // addps         %xmm8,%xmm14
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  65,15,93,198                        // minps         %xmm14,%xmm0
  .byte  65,15,40,218                        // movaps        %xmm10,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  65,15,89,210                        // mulps         %xmm10,%xmm2
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  69,15,89,238                        // mulps         %xmm14,%xmm13
  .byte  68,15,88,233                        // addps         %xmm1,%xmm13
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,194,203,2                     // cmpleps       %xmm3,%xmm9
  .byte  65,15,40,253                        // movaps        %xmm13,%xmm7
  .byte  15,92,251                           // subps         %xmm3,%xmm7
  .byte  69,15,40,250                        // movaps        %xmm10,%xmm15
  .byte  69,15,92,253                        // subps         %xmm13,%xmm15
  .byte  69,15,89,253                        // mulps         %xmm13,%xmm15
  .byte  68,15,94,255                        // divps         %xmm7,%xmm15
  .byte  69,15,88,253                        // addps         %xmm13,%xmm15
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,69,15,56,20,250                 // blendvps      %xmm0,%xmm10,%xmm15
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  65,15,95,198                        // maxps         %xmm14,%xmm0
  .byte  68,15,95,208                        // maxps         %xmm0,%xmm10
  .byte  15,40,212                           // movaps        %xmm4,%xmm2
  .byte  65,15,89,212                        // mulps         %xmm12,%xmm2
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  69,15,194,194,1                     // cmpltps       %xmm10,%xmm8
  .byte  65,15,40,223                        // movaps        %xmm15,%xmm3
  .byte  65,15,92,221                        // subps         %xmm13,%xmm3
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  65,15,92,205                        // subps         %xmm13,%xmm1
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  69,15,92,213                        // subps         %xmm13,%xmm10
  .byte  65,15,94,218                        // divps         %xmm10,%xmm3
  .byte  65,15,88,221                        // addps         %xmm13,%xmm3
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  102,68,15,56,20,251                 // blendvps      %xmm0,%xmm3,%xmm15
  .byte  69,15,40,227                        // movaps        %xmm11,%xmm12
  .byte  69,15,92,229                        // subps         %xmm13,%xmm12
  .byte  69,15,89,229                        // mulps         %xmm13,%xmm12
  .byte  68,15,94,231                        // divps         %xmm7,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,69,15,56,20,227                 // blendvps      %xmm0,%xmm11,%xmm12
  .byte  65,15,40,220                        // movaps        %xmm12,%xmm3
  .byte  65,15,92,221                        // subps         %xmm13,%xmm3
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  65,15,94,218                        // divps         %xmm10,%xmm3
  .byte  65,15,88,221                        // addps         %xmm13,%xmm3
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  102,68,15,56,20,227                 // blendvps      %xmm0,%xmm3,%xmm12
  .byte  69,15,40,222                        // movaps        %xmm14,%xmm11
  .byte  69,15,92,221                        // subps         %xmm13,%xmm11
  .byte  69,15,89,221                        // mulps         %xmm13,%xmm11
  .byte  68,15,94,223                        // divps         %xmm7,%xmm11
  .byte  69,15,88,221                        // addps         %xmm13,%xmm11
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,69,15,56,20,222                 // blendvps      %xmm0,%xmm14,%xmm11
  .byte  65,15,40,251                        // movaps        %xmm11,%xmm7
  .byte  65,15,92,253                        // subps         %xmm13,%xmm7
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  65,15,94,250                        // divps         %xmm10,%xmm7
  .byte  65,15,88,253                        // addps         %xmm13,%xmm7
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  102,68,15,56,20,223                 // blendvps      %xmm0,%xmm7,%xmm11
  .byte  68,15,40,13,52,223,1,0              // movaps        0x1df34(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  68,15,92,204                        // subps         %xmm4,%xmm9
  .byte  15,40,124,36,168                    // movaps        -0x58(%rsp),%xmm7
  .byte  15,88,231                           // addps         %xmm7,%xmm4
  .byte  15,92,226                           // subps         %xmm2,%xmm4
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  68,15,95,248                        // maxps         %xmm0,%xmm15
  .byte  68,15,95,224                        // maxps         %xmm0,%xmm12
  .byte  68,15,95,216                        // maxps         %xmm0,%xmm11
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  68,15,92,199                        // subps         %xmm7,%xmm8
  .byte  15,40,68,36,200                     // movaps        -0x38(%rsp),%xmm0
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  65,15,88,199                        // addps         %xmm15,%xmm0
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,40,84,36,216                     // movaps        -0x28(%rsp),%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,88,209                           // addps         %xmm1,%xmm2
  .byte  65,15,88,212                        // addps         %xmm12,%xmm2
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  68,15,89,68,36,232                  // mulps         -0x18(%rsp),%xmm8
  .byte  15,40,84,36,184                     // movaps        -0x48(%rsp),%xmm2
  .byte  68,15,89,202                        // mulps         %xmm2,%xmm9
  .byte  69,15,88,200                        // addps         %xmm8,%xmm9
  .byte  69,15,88,203                        // addps         %xmm11,%xmm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,40,238                           // movaps        %xmm6,%xmm5
  .byte  15,40,242                           // movaps        %xmm2,%xmm6
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_color_sse41
.globl _sk_color_sse41
FUNCTION(_sk_color_sse41)
_sk_color_sse41:
  .byte  68,15,40,230                        // movaps        %xmm6,%xmm12
  .byte  68,15,41,100,36,200                 // movaps        %xmm12,-0x38(%rsp)
  .byte  68,15,40,221                        // movaps        %xmm5,%xmm11
  .byte  68,15,41,92,36,216                  // movaps        %xmm11,-0x28(%rsp)
  .byte  68,15,40,212                        // movaps        %xmm4,%xmm10
  .byte  68,15,41,84,36,232                  // movaps        %xmm10,-0x18(%rsp)
  .byte  15,40,243                           // movaps        %xmm3,%xmm6
  .byte  15,41,84,36,184                     // movaps        %xmm2,-0x48(%rsp)
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  69,15,40,240                        // movaps        %xmm8,%xmm14
  .byte  15,40,231                           // movaps        %xmm7,%xmm4
  .byte  68,15,89,244                        // mulps         %xmm4,%xmm14
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  68,15,40,13,239,222,1,0             // movaps        0x1deef(%rip),%xmm9        # 3abd0 <_sk_srcover_bgra_8888_sse2_lowp+0xc68>
  .byte  65,15,40,250                        // movaps        %xmm10,%xmm7
  .byte  65,15,89,249                        // mulps         %xmm9,%xmm7
  .byte  68,15,40,21,239,222,1,0             // movaps        0x1deef(%rip),%xmm10        # 3abe0 <_sk_srcover_bgra_8888_sse2_lowp+0xc78>
  .byte  65,15,40,219                        // movaps        %xmm11,%xmm3
  .byte  65,15,89,218                        // mulps         %xmm10,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  68,15,40,29,236,222,1,0             // movaps        0x1deec(%rip),%xmm11        # 3abf0 <_sk_srcover_bgra_8888_sse2_lowp+0xc88>
  .byte  69,15,40,236                        // movaps        %xmm12,%xmm13
  .byte  69,15,89,235                        // mulps         %xmm11,%xmm13
  .byte  68,15,88,235                        // addps         %xmm3,%xmm13
  .byte  65,15,40,222                        // movaps        %xmm14,%xmm3
  .byte  65,15,89,217                        // mulps         %xmm9,%xmm3
  .byte  15,40,249                           // movaps        %xmm1,%xmm7
  .byte  65,15,89,250                        // mulps         %xmm10,%xmm7
  .byte  15,88,251                           // addps         %xmm3,%xmm7
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  65,15,89,219                        // mulps         %xmm11,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  68,15,89,238                        // mulps         %xmm6,%xmm13
  .byte  68,15,92,235                        // subps         %xmm3,%xmm13
  .byte  69,15,88,245                        // addps         %xmm13,%xmm14
  .byte  65,15,88,205                        // addps         %xmm13,%xmm1
  .byte  68,15,88,232                        // addps         %xmm0,%xmm13
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  65,15,93,197                        // minps         %xmm13,%xmm0
  .byte  65,15,40,222                        // movaps        %xmm14,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  69,15,89,206                        // mulps         %xmm14,%xmm9
  .byte  68,15,89,209                        // mulps         %xmm1,%xmm10
  .byte  69,15,88,209                        // addps         %xmm9,%xmm10
  .byte  69,15,89,221                        // mulps         %xmm13,%xmm11
  .byte  69,15,88,218                        // addps         %xmm10,%xmm11
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,194,203,2                     // cmpleps       %xmm3,%xmm9
  .byte  69,15,40,230                        // movaps        %xmm14,%xmm12
  .byte  69,15,92,227                        // subps         %xmm11,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  65,15,40,251                        // movaps        %xmm11,%xmm7
  .byte  15,92,251                           // subps         %xmm3,%xmm7
  .byte  68,15,94,231                        // divps         %xmm7,%xmm12
  .byte  69,15,88,227                        // addps         %xmm11,%xmm12
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,69,15,56,20,230                 // blendvps      %xmm0,%xmm14,%xmm12
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  65,15,95,197                        // maxps         %xmm13,%xmm0
  .byte  65,15,40,214                        // movaps        %xmm14,%xmm2
  .byte  15,95,208                           // maxps         %xmm0,%xmm2
  .byte  15,40,222                           // movaps        %xmm6,%xmm3
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  68,15,194,210,1                     // cmpltps       %xmm2,%xmm10
  .byte  69,15,40,244                        // movaps        %xmm12,%xmm14
  .byte  69,15,92,243                        // subps         %xmm11,%xmm14
  .byte  68,15,40,251                        // movaps        %xmm3,%xmm15
  .byte  69,15,92,251                        // subps         %xmm11,%xmm15
  .byte  69,15,89,247                        // mulps         %xmm15,%xmm14
  .byte  65,15,92,211                        // subps         %xmm11,%xmm2
  .byte  68,15,94,242                        // divps         %xmm2,%xmm14
  .byte  69,15,88,243                        // addps         %xmm11,%xmm14
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  102,69,15,56,20,230                 // blendvps      %xmm0,%xmm14,%xmm12
  .byte  68,15,40,241                        // movaps        %xmm1,%xmm14
  .byte  69,15,92,243                        // subps         %xmm11,%xmm14
  .byte  69,15,89,243                        // mulps         %xmm11,%xmm14
  .byte  68,15,94,247                        // divps         %xmm7,%xmm14
  .byte  69,15,88,243                        // addps         %xmm11,%xmm14
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,68,15,56,20,241                 // blendvps      %xmm0,%xmm1,%xmm14
  .byte  65,15,40,206                        // movaps        %xmm14,%xmm1
  .byte  65,15,92,203                        // subps         %xmm11,%xmm1
  .byte  65,15,89,207                        // mulps         %xmm15,%xmm1
  .byte  15,94,202                           // divps         %xmm2,%xmm1
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  102,68,15,56,20,241                 // blendvps      %xmm0,%xmm1,%xmm14
  .byte  65,15,40,205                        // movaps        %xmm13,%xmm1
  .byte  65,15,92,203                        // subps         %xmm11,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  15,94,207                           // divps         %xmm7,%xmm1
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,65,15,56,20,205                 // blendvps      %xmm0,%xmm13,%xmm1
  .byte  15,40,249                           // movaps        %xmm1,%xmm7
  .byte  65,15,92,251                        // subps         %xmm11,%xmm7
  .byte  65,15,89,255                        // mulps         %xmm15,%xmm7
  .byte  15,94,250                           // divps         %xmm2,%xmm7
  .byte  65,15,88,251                        // addps         %xmm11,%xmm7
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  102,15,56,20,207                    // blendvps      %xmm0,%xmm7,%xmm1
  .byte  68,15,40,13,248,220,1,0             // movaps        0x1dcf8(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  15,89,68,36,184                     // mulps         -0x48(%rsp),%xmm0
  .byte  68,15,92,206                        // subps         %xmm6,%xmm9
  .byte  15,88,244                           // addps         %xmm4,%xmm6
  .byte  15,40,252                           // movaps        %xmm4,%xmm7
  .byte  15,92,243                           // subps         %xmm3,%xmm6
  .byte  15,40,222                           // movaps        %xmm6,%xmm3
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  68,15,95,226                        // maxps         %xmm2,%xmm12
  .byte  68,15,95,242                        // maxps         %xmm2,%xmm14
  .byte  15,95,202                           // maxps         %xmm2,%xmm1
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  15,40,100,36,232                    // movaps        -0x18(%rsp),%xmm4
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  68,15,88,194                        // addps         %xmm2,%xmm8
  .byte  69,15,88,196                        // addps         %xmm12,%xmm8
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  15,40,116,36,216                    // movaps        -0x28(%rsp),%xmm6
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  68,15,40,213                        // movaps        %xmm5,%xmm10
  .byte  68,15,88,210                        // addps         %xmm2,%xmm10
  .byte  69,15,88,214                        // addps         %xmm14,%xmm10
  .byte  15,40,84,36,200                     // movaps        -0x38(%rsp),%xmm2
  .byte  68,15,89,202                        // mulps         %xmm2,%xmm9
  .byte  68,15,88,200                        // addps         %xmm0,%xmm9
  .byte  68,15,88,201                        // addps         %xmm1,%xmm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,238                           // movaps        %xmm6,%xmm5
  .byte  15,40,242                           // movaps        %xmm2,%xmm6
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  65,15,40,202                        // movaps        %xmm10,%xmm1
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_luminosity_sse41
.globl _sk_luminosity_sse41
FUNCTION(_sk_luminosity_sse41)
_sk_luminosity_sse41:
  .byte  15,41,116,36,200                    // movaps        %xmm6,-0x38(%rsp)
  .byte  15,41,108,36,232                    // movaps        %xmm5,-0x18(%rsp)
  .byte  68,15,40,196                        // movaps        %xmm4,%xmm8
  .byte  68,15,41,68,36,216                  // movaps        %xmm8,-0x28(%rsp)
  .byte  15,41,84,36,184                     // movaps        %xmm2,-0x48(%rsp)
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  68,15,40,219                        // movaps        %xmm3,%xmm11
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  68,15,40,5,192,220,1,0              // movaps        0x1dcc0(%rip),%xmm8        # 3abd0 <_sk_srcover_bgra_8888_sse2_lowp+0xc68>
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  68,15,40,21,196,220,1,0             // movaps        0x1dcc4(%rip),%xmm10        # 3abe0 <_sk_srcover_bgra_8888_sse2_lowp+0xc78>
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  65,15,89,234                        // mulps         %xmm10,%xmm5
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  68,15,40,37,194,220,1,0             // movaps        0x1dcc2(%rip),%xmm12        # 3abf0 <_sk_srcover_bgra_8888_sse2_lowp+0xc88>
  .byte  68,15,40,242                        // movaps        %xmm2,%xmm14
  .byte  69,15,89,244                        // mulps         %xmm12,%xmm14
  .byte  68,15,88,245                        // addps         %xmm5,%xmm14
  .byte  65,15,40,235                        // movaps        %xmm11,%xmm5
  .byte  65,15,89,232                        // mulps         %xmm8,%xmm5
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  65,15,89,210                        // mulps         %xmm10,%xmm2
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  65,15,89,236                        // mulps         %xmm12,%xmm5
  .byte  15,88,234                           // addps         %xmm2,%xmm5
  .byte  68,15,89,247                        // mulps         %xmm7,%xmm14
  .byte  68,15,92,245                        // subps         %xmm5,%xmm14
  .byte  69,15,88,222                        // addps         %xmm14,%xmm11
  .byte  69,15,88,206                        // addps         %xmm14,%xmm9
  .byte  68,15,88,240                        // addps         %xmm0,%xmm14
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,93,198                        // minps         %xmm14,%xmm0
  .byte  65,15,40,235                        // movaps        %xmm11,%xmm5
  .byte  15,93,232                           // minps         %xmm0,%xmm5
  .byte  69,15,89,195                        // mulps         %xmm11,%xmm8
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,208                        // addps         %xmm8,%xmm10
  .byte  69,15,89,230                        // mulps         %xmm14,%xmm12
  .byte  69,15,88,226                        // addps         %xmm10,%xmm12
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  68,15,194,213,2                     // cmpleps       %xmm5,%xmm10
  .byte  69,15,40,235                        // movaps        %xmm11,%xmm13
  .byte  69,15,92,236                        // subps         %xmm12,%xmm13
  .byte  69,15,89,236                        // mulps         %xmm12,%xmm13
  .byte  65,15,40,244                        // movaps        %xmm12,%xmm6
  .byte  15,92,245                           // subps         %xmm5,%xmm6
  .byte  68,15,94,238                        // divps         %xmm6,%xmm13
  .byte  69,15,88,236                        // addps         %xmm12,%xmm13
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  102,69,15,56,20,235                 // blendvps      %xmm0,%xmm11,%xmm13
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,95,198                        // maxps         %xmm14,%xmm0
  .byte  65,15,40,211                        // movaps        %xmm11,%xmm2
  .byte  15,95,208                           // maxps         %xmm0,%xmm2
  .byte  15,40,235                           // movaps        %xmm3,%xmm5
  .byte  15,89,239                           // mulps         %xmm7,%xmm5
  .byte  68,15,40,221                        // movaps        %xmm5,%xmm11
  .byte  68,15,194,218,1                     // cmpltps       %xmm2,%xmm11
  .byte  69,15,40,197                        // movaps        %xmm13,%xmm8
  .byte  69,15,92,196                        // subps         %xmm12,%xmm8
  .byte  68,15,40,253                        // movaps        %xmm5,%xmm15
  .byte  69,15,92,252                        // subps         %xmm12,%xmm15
  .byte  69,15,89,199                        // mulps         %xmm15,%xmm8
  .byte  65,15,92,212                        // subps         %xmm12,%xmm2
  .byte  68,15,94,194                        // divps         %xmm2,%xmm8
  .byte  69,15,88,196                        // addps         %xmm12,%xmm8
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  102,69,15,56,20,232                 // blendvps      %xmm0,%xmm8,%xmm13
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  69,15,92,196                        // subps         %xmm12,%xmm8
  .byte  69,15,89,196                        // mulps         %xmm12,%xmm8
  .byte  68,15,94,198                        // divps         %xmm6,%xmm8
  .byte  69,15,88,196                        // addps         %xmm12,%xmm8
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  102,69,15,56,20,193                 // blendvps      %xmm0,%xmm9,%xmm8
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  69,15,92,204                        // subps         %xmm12,%xmm9
  .byte  69,15,89,207                        // mulps         %xmm15,%xmm9
  .byte  68,15,94,202                        // divps         %xmm2,%xmm9
  .byte  69,15,88,204                        // addps         %xmm12,%xmm9
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  102,69,15,56,20,193                 // blendvps      %xmm0,%xmm9,%xmm8
  .byte  69,15,40,206                        // movaps        %xmm14,%xmm9
  .byte  69,15,92,204                        // subps         %xmm12,%xmm9
  .byte  69,15,89,204                        // mulps         %xmm12,%xmm9
  .byte  68,15,94,206                        // divps         %xmm6,%xmm9
  .byte  69,15,88,204                        // addps         %xmm12,%xmm9
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  102,69,15,56,20,206                 // blendvps      %xmm0,%xmm14,%xmm9
  .byte  65,15,40,241                        // movaps        %xmm9,%xmm6
  .byte  65,15,92,244                        // subps         %xmm12,%xmm6
  .byte  65,15,89,247                        // mulps         %xmm15,%xmm6
  .byte  15,94,242                           // divps         %xmm2,%xmm6
  .byte  65,15,88,244                        // addps         %xmm12,%xmm6
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  102,68,15,56,20,206                 // blendvps      %xmm0,%xmm6,%xmm9
  .byte  15,40,5,200,218,1,0                 // movaps        0x1dac8(%rip),%xmm0        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,92,215                           // subps         %xmm7,%xmm2
  .byte  15,89,226                           // mulps         %xmm2,%xmm4
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,89,84,36,184                     // mulps         -0x48(%rsp),%xmm2
  .byte  15,92,195                           // subps         %xmm3,%xmm0
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  15,92,221                           // subps         %xmm5,%xmm3
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  68,15,95,237                        // maxps         %xmm5,%xmm13
  .byte  68,15,95,197                        // maxps         %xmm5,%xmm8
  .byte  68,15,95,205                        // maxps         %xmm5,%xmm9
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  68,15,40,84,36,216                  // movaps        -0x28(%rsp),%xmm10
  .byte  65,15,89,234                        // mulps         %xmm10,%xmm5
  .byte  15,88,229                           // addps         %xmm5,%xmm4
  .byte  65,15,88,229                        // addps         %xmm13,%xmm4
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,40,108,36,232                    // movaps        -0x18(%rsp),%xmm5
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  15,40,116,36,200                    // movaps        -0x38(%rsp),%xmm6
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  68,15,88,200                        // addps         %xmm0,%xmm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  65,15,40,226                        // movaps        %xmm10,%xmm4
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_rgba_8888_sse41
.globl _sk_srcover_rgba_8888_sse41
FUNCTION(_sk_srcover_rgba_8888_sse41)
_sk_srcover_rgba_8888_sse41:
  .byte  102,68,15,111,200                   // movdqa        %xmm0,%xmm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,0,1,0,0                      // jne           1d21a <_sk_srcover_rgba_8888_sse41+0x125>
  .byte  243,65,15,111,4,128                 // movdqu        (%r8,%rax,4),%xmm0
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  102,15,111,37,213,218,1,0           // movdqa        0x1dad5(%rip),%xmm4        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,15,219,224                      // pand          %xmm0,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,56,0,45,209,218,1,0          // pshufb        0x1dad1(%rip),%xmm5        # 3ac10 <_sk_srcover_bgra_8888_sse2_lowp+0xca8>
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  102,15,111,240                      // movdqa        %xmm0,%xmm6
  .byte  102,15,56,0,53,209,218,1,0          // pshufb        0x1dad1(%rip),%xmm6        # 3ac20 <_sk_srcover_bgra_8888_sse2_lowp+0xcb8>
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  102,15,114,208,24                   // psrld         $0x18,%xmm0
  .byte  15,91,248                           // cvtdq2ps      %xmm0,%xmm7
  .byte  68,15,40,5,234,217,1,0              // movaps        0x1d9ea(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  68,15,40,37,190,218,1,0             // movaps        0x1dabe(%rip),%xmm12        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  69,15,89,204                        // mulps         %xmm12,%xmm9
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  65,15,88,193                        // addps         %xmm9,%xmm0
  .byte  65,15,89,204                        // mulps         %xmm12,%xmm1
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  68,15,88,201                        // addps         %xmm1,%xmm9
  .byte  65,15,89,212                        // mulps         %xmm12,%xmm2
  .byte  69,15,40,208                        // movaps        %xmm8,%xmm10
  .byte  68,15,89,214                        // mulps         %xmm6,%xmm10
  .byte  68,15,88,210                        // addps         %xmm2,%xmm10
  .byte  65,15,89,220                        // mulps         %xmm12,%xmm3
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  68,15,88,195                        // addps         %xmm3,%xmm8
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,95,200                           // maxps         %xmm0,%xmm1
  .byte  65,15,93,204                        // minps         %xmm12,%xmm1
  .byte  102,15,91,201                       // cvtps2dq      %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  65,15,95,209                        // maxps         %xmm9,%xmm2
  .byte  65,15,93,212                        // minps         %xmm12,%xmm2
  .byte  102,15,91,210                       // cvtps2dq      %xmm2,%xmm2
  .byte  102,15,114,242,8                    // pslld         $0x8,%xmm2
  .byte  102,15,235,209                      // por           %xmm1,%xmm2
  .byte  102,15,87,201                       // xorpd         %xmm1,%xmm1
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,93,204                        // minps         %xmm12,%xmm1
  .byte  102,15,91,217                       // cvtps2dq      %xmm1,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  69,15,95,216                        // maxps         %xmm8,%xmm11
  .byte  69,15,93,220                        // minps         %xmm12,%xmm11
  .byte  102,65,15,91,203                    // cvtps2dq      %xmm11,%xmm1
  .byte  102,15,114,241,24                   // pslld         $0x18,%xmm1
  .byte  102,15,235,203                      // por           %xmm3,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  117,84                              // jne           1d258 <_sk_srcover_rgba_8888_sse41+0x163>
  .byte  243,65,15,127,12,128                // movdqu        %xmm1,(%r8,%rax,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,40,216                        // movaps        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,91                              // je            1d282 <_sk_srcover_rgba_8888_sse41+0x18d>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,22                              // je            1d247 <_sk_srcover_rgba_8888_sse41+0x152>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  15,133,229,254,255,255              // jne           1d120 <_sk_srcover_rgba_8888_sse41+0x2b>
  .byte  102,65,15,110,68,128,8              // movd          0x8(%r8,%rax,4),%xmm0
  .byte  102,15,112,192,69                   // pshufd        $0x45,%xmm0,%xmm0
  .byte  243,65,15,126,36,128                // movq          (%r8,%rax,4),%xmm4
  .byte  102,15,58,14,196,15                 // pblendw       $0xf,%xmm4,%xmm0
  .byte  233,200,254,255,255                 // jmpq          1d120 <_sk_srcover_rgba_8888_sse41+0x2b>
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,40                              // je            1d28d <_sk_srcover_rgba_8888_sse41+0x198>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,15                              // je            1d27a <_sk_srcover_rgba_8888_sse41+0x185>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,153                             // jne           1d20a <_sk_srcover_rgba_8888_sse41+0x115>
  .byte  102,65,15,58,22,76,128,8,2          // pextrd        $0x2,%xmm1,0x8(%r8,%rax,4)
  .byte  102,65,15,214,12,128                // movq          %xmm1,(%r8,%rax,4)
  .byte  235,136                             // jmp           1d20a <_sk_srcover_rgba_8888_sse41+0x115>
  .byte  102,65,15,110,4,128                 // movd          (%r8,%rax,4),%xmm0
  .byte  233,147,254,255,255                 // jmpq          1d120 <_sk_srcover_rgba_8888_sse41+0x2b>
  .byte  102,65,15,126,12,128                // movd          %xmm1,(%r8,%rax,4)
  .byte  233,114,255,255,255                 // jmpq          1d20a <_sk_srcover_rgba_8888_sse41+0x115>

HIDDEN _sk_srcover_bgra_8888_sse41
.globl _sk_srcover_bgra_8888_sse41
FUNCTION(_sk_srcover_bgra_8888_sse41)
_sk_srcover_bgra_8888_sse41:
  .byte  102,68,15,111,200                   // movdqa        %xmm0,%xmm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,0,1,0,0                      // jne           1d3bd <_sk_srcover_bgra_8888_sse41+0x125>
  .byte  243,65,15,111,4,128                 // movdqu        (%r8,%rax,4),%xmm0
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  102,15,111,37,50,217,1,0            // movdqa        0x1d932(%rip),%xmm4        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,15,219,224                      // pand          %xmm0,%xmm4
  .byte  15,91,244                           // cvtdq2ps      %xmm4,%xmm6
  .byte  102,15,111,224                      // movdqa        %xmm0,%xmm4
  .byte  102,15,56,0,37,46,217,1,0           // pshufb        0x1d92e(%rip),%xmm4        # 3ac10 <_sk_srcover_bgra_8888_sse2_lowp+0xca8>
  .byte  15,91,236                           // cvtdq2ps      %xmm4,%xmm5
  .byte  102,15,111,224                      // movdqa        %xmm0,%xmm4
  .byte  102,15,56,0,37,46,217,1,0           // pshufb        0x1d92e(%rip),%xmm4        # 3ac20 <_sk_srcover_bgra_8888_sse2_lowp+0xcb8>
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  102,15,114,208,24                   // psrld         $0x18,%xmm0
  .byte  15,91,248                           // cvtdq2ps      %xmm0,%xmm7
  .byte  68,15,40,5,71,216,1,0               // movaps        0x1d847(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  68,15,40,37,27,217,1,0              // movaps        0x1d91b(%rip),%xmm12        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  69,15,89,204                        // mulps         %xmm12,%xmm9
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  65,15,88,193                        // addps         %xmm9,%xmm0
  .byte  65,15,89,204                        // mulps         %xmm12,%xmm1
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  68,15,88,201                        // addps         %xmm1,%xmm9
  .byte  65,15,89,212                        // mulps         %xmm12,%xmm2
  .byte  69,15,40,208                        // movaps        %xmm8,%xmm10
  .byte  68,15,89,214                        // mulps         %xmm6,%xmm10
  .byte  68,15,88,210                        // addps         %xmm2,%xmm10
  .byte  65,15,89,220                        // mulps         %xmm12,%xmm3
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  68,15,88,195                        // addps         %xmm3,%xmm8
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,93,204                        // minps         %xmm12,%xmm1
  .byte  102,15,91,201                       // cvtps2dq      %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  65,15,95,209                        // maxps         %xmm9,%xmm2
  .byte  65,15,93,212                        // minps         %xmm12,%xmm2
  .byte  102,15,91,210                       // cvtps2dq      %xmm2,%xmm2
  .byte  102,15,114,242,8                    // pslld         $0x8,%xmm2
  .byte  102,15,235,209                      // por           %xmm1,%xmm2
  .byte  102,15,87,201                       // xorpd         %xmm1,%xmm1
  .byte  15,95,200                           // maxps         %xmm0,%xmm1
  .byte  65,15,93,204                        // minps         %xmm12,%xmm1
  .byte  102,15,91,217                       // cvtps2dq      %xmm1,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  69,15,95,216                        // maxps         %xmm8,%xmm11
  .byte  69,15,93,220                        // minps         %xmm12,%xmm11
  .byte  102,65,15,91,203                    // cvtps2dq      %xmm11,%xmm1
  .byte  102,15,114,241,24                   // pslld         $0x18,%xmm1
  .byte  102,15,235,203                      // por           %xmm3,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  117,84                              // jne           1d3fb <_sk_srcover_bgra_8888_sse41+0x163>
  .byte  243,65,15,127,12,128                // movdqu        %xmm1,(%r8,%rax,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,40,216                        // movaps        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,91                              // je            1d425 <_sk_srcover_bgra_8888_sse41+0x18d>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,22                              // je            1d3ea <_sk_srcover_bgra_8888_sse41+0x152>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  15,133,229,254,255,255              // jne           1d2c3 <_sk_srcover_bgra_8888_sse41+0x2b>
  .byte  102,65,15,110,68,128,8              // movd          0x8(%r8,%rax,4),%xmm0
  .byte  102,15,112,192,69                   // pshufd        $0x45,%xmm0,%xmm0
  .byte  243,65,15,126,36,128                // movq          (%r8,%rax,4),%xmm4
  .byte  102,15,58,14,196,15                 // pblendw       $0xf,%xmm4,%xmm0
  .byte  233,200,254,255,255                 // jmpq          1d2c3 <_sk_srcover_bgra_8888_sse41+0x2b>
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,40                              // je            1d430 <_sk_srcover_bgra_8888_sse41+0x198>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,15                              // je            1d41d <_sk_srcover_bgra_8888_sse41+0x185>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,153                             // jne           1d3ad <_sk_srcover_bgra_8888_sse41+0x115>
  .byte  102,65,15,58,22,76,128,8,2          // pextrd        $0x2,%xmm1,0x8(%r8,%rax,4)
  .byte  102,65,15,214,12,128                // movq          %xmm1,(%r8,%rax,4)
  .byte  235,136                             // jmp           1d3ad <_sk_srcover_bgra_8888_sse41+0x115>
  .byte  102,65,15,110,4,128                 // movd          (%r8,%rax,4),%xmm0
  .byte  233,147,254,255,255                 // jmpq          1d2c3 <_sk_srcover_bgra_8888_sse41+0x2b>
  .byte  102,65,15,126,12,128                // movd          %xmm1,(%r8,%rax,4)
  .byte  233,114,255,255,255                 // jmpq          1d3ad <_sk_srcover_bgra_8888_sse41+0x115>

HIDDEN _sk_clamp_0_sse41
.globl _sk_clamp_0_sse41
FUNCTION(_sk_clamp_0_sse41)
_sk_clamp_0_sse41:
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  65,15,95,192                        // maxps         %xmm8,%xmm0
  .byte  65,15,95,200                        // maxps         %xmm8,%xmm1
  .byte  65,15,95,208                        // maxps         %xmm8,%xmm2
  .byte  65,15,95,216                        // maxps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_1_sse41
.globl _sk_clamp_1_sse41
FUNCTION(_sk_clamp_1_sse41)
_sk_clamp_1_sse41:
  .byte  68,15,40,5,245,214,1,0              // movaps        0x1d6f5(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_sse41
.globl _sk_clamp_a_sse41
FUNCTION(_sk_clamp_a_sse41)
_sk_clamp_a_sse41:
  .byte  15,93,29,218,214,1,0                // minps         0x1d6da(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,93,195                           // minps         %xmm3,%xmm0
  .byte  15,93,203                           // minps         %xmm3,%xmm1
  .byte  15,93,211                           // minps         %xmm3,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_dst_sse41
.globl _sk_clamp_a_dst_sse41
FUNCTION(_sk_clamp_a_dst_sse41)
_sk_clamp_a_dst_sse41:
  .byte  15,93,61,198,214,1,0                // minps         0x1d6c6(%rip),%xmm7        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,93,231                           // minps         %xmm7,%xmm4
  .byte  15,93,239                           // minps         %xmm7,%xmm5
  .byte  15,93,247                           // minps         %xmm7,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_set_rgb_sse41
.globl _sk_set_rgb_sse41
FUNCTION(_sk_set_rgb_sse41)
_sk_set_rgb_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,80,8                      // movss         0x8(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_swap_rb_sse41
.globl _sk_swap_rb_sse41
FUNCTION(_sk_swap_rb_sse41)
_sk_swap_rb_sse41:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_invert_sse41
.globl _sk_invert_sse41
FUNCTION(_sk_invert_sse41)
_sk_invert_sse41:
  .byte  68,15,40,5,130,214,1,0              // movaps        0x1d682(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,92,200                        // subps         %xmm0,%xmm9
  .byte  69,15,40,208                        // movaps        %xmm8,%xmm10
  .byte  68,15,92,209                        // subps         %xmm1,%xmm10
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  68,15,92,218                        // subps         %xmm2,%xmm11
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,40,202                        // movaps        %xmm10,%xmm1
  .byte  65,15,40,211                        // movaps        %xmm11,%xmm2
  .byte  65,15,40,216                        // movaps        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_src_dst_sse41
.globl _sk_move_src_dst_sse41
FUNCTION(_sk_move_src_dst_sse41)
_sk_move_src_dst_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,40,242                           // movaps        %xmm2,%xmm6
  .byte  15,40,251                           // movaps        %xmm3,%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_dst_src_sse41
.globl _sk_move_dst_src_sse41
FUNCTION(_sk_move_dst_src_sse41)
_sk_move_dst_src_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,40,223                           // movaps        %xmm7,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_sse41
.globl _sk_premul_sse41
FUNCTION(_sk_premul_sse41)
_sk_premul_sse41:
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_dst_sse41
.globl _sk_premul_dst_sse41
FUNCTION(_sk_premul_dst_sse41)
_sk_premul_dst_sse41:
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,89,239                           // mulps         %xmm7,%xmm5
  .byte  15,89,247                           // mulps         %xmm7,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_unpremul_sse41
.globl _sk_unpremul_sse41
FUNCTION(_sk_unpremul_sse41)
_sk_unpremul_sse41:
  .byte  68,15,40,5,16,214,1,0               // movaps        0x1d610(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,94,195                        // divps         %xmm3,%xmm8
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,194,13,239,214,1,0,1          // cmpltps       0x1d6ef(%rip),%xmm9        # 3ac40 <_sk_srcover_bgra_8888_sse2_lowp+0xcd8>
  .byte  69,15,84,200                        // andps         %xmm8,%xmm9
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  65,15,89,201                        // mulps         %xmm9,%xmm1
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_from_srgb_sse41
.globl _sk_from_srgb_sse41
FUNCTION(_sk_from_srgb_sse41)
_sk_from_srgb_sse41:
  .byte  68,15,40,29,227,214,1,0             // movaps        0x1d6e3(%rip),%xmm11        # 3ac50 <_sk_srcover_bgra_8888_sse2_lowp+0xce8>
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  68,15,40,208                        // movaps        %xmm0,%xmm10
  .byte  69,15,89,210                        // mulps         %xmm10,%xmm10
  .byte  68,15,40,37,75,214,1,0              // movaps        0x1d64b(%rip),%xmm12        # 3abd0 <_sk_srcover_bgra_8888_sse2_lowp+0xc68>
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  69,15,89,196                        // mulps         %xmm12,%xmm8
  .byte  68,15,40,45,203,214,1,0             // movaps        0x1d6cb(%rip),%xmm13        # 3ac60 <_sk_srcover_bgra_8888_sse2_lowp+0xcf8>
  .byte  69,15,88,197                        // addps         %xmm13,%xmm8
  .byte  69,15,89,194                        // mulps         %xmm10,%xmm8
  .byte  68,15,40,53,203,214,1,0             // movaps        0x1d6cb(%rip),%xmm14        # 3ac70 <_sk_srcover_bgra_8888_sse2_lowp+0xd08>
  .byte  69,15,88,198                        // addps         %xmm14,%xmm8
  .byte  68,15,40,61,207,214,1,0             // movaps        0x1d6cf(%rip),%xmm15        # 3ac80 <_sk_srcover_bgra_8888_sse2_lowp+0xd18>
  .byte  65,15,194,199,1                     // cmpltps       %xmm15,%xmm0
  .byte  102,69,15,56,20,193                 // blendvps      %xmm0,%xmm9,%xmm8
  .byte  68,15,40,209                        // movaps        %xmm1,%xmm10
  .byte  69,15,89,211                        // mulps         %xmm11,%xmm10
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  69,15,89,204                        // mulps         %xmm12,%xmm9
  .byte  69,15,88,205                        // addps         %xmm13,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  69,15,88,206                        // addps         %xmm14,%xmm9
  .byte  65,15,194,207,1                     // cmpltps       %xmm15,%xmm1
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  102,69,15,56,20,202                 // blendvps      %xmm0,%xmm10,%xmm9
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  68,15,40,210                        // movaps        %xmm2,%xmm10
  .byte  69,15,89,210                        // mulps         %xmm10,%xmm10
  .byte  68,15,89,226                        // mulps         %xmm2,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  69,15,89,212                        // mulps         %xmm12,%xmm10
  .byte  69,15,88,214                        // addps         %xmm14,%xmm10
  .byte  65,15,194,215,1                     // cmpltps       %xmm15,%xmm2
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  102,69,15,56,20,211                 // blendvps      %xmm0,%xmm11,%xmm10
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_from_srgb_dst_sse41
.globl _sk_from_srgb_dst_sse41
FUNCTION(_sk_from_srgb_dst_sse41)
_sk_from_srgb_dst_sse41:
  .byte  68,15,40,204                        // movaps        %xmm4,%xmm9
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  68,15,40,29,26,214,1,0              // movaps        0x1d61a(%rip),%xmm11        # 3ac50 <_sk_srcover_bgra_8888_sse2_lowp+0xce8>
  .byte  69,15,40,209                        // movaps        %xmm9,%xmm10
  .byte  69,15,89,211                        // mulps         %xmm11,%xmm10
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  68,15,40,37,131,213,1,0             // movaps        0x1d583(%rip),%xmm12        # 3abd0 <_sk_srcover_bgra_8888_sse2_lowp+0xc68>
  .byte  65,15,89,228                        // mulps         %xmm12,%xmm4
  .byte  68,15,40,45,7,214,1,0               // movaps        0x1d607(%rip),%xmm13        # 3ac60 <_sk_srcover_bgra_8888_sse2_lowp+0xcf8>
  .byte  65,15,88,229                        // addps         %xmm13,%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  68,15,40,53,8,214,1,0               // movaps        0x1d608(%rip),%xmm14        # 3ac70 <_sk_srcover_bgra_8888_sse2_lowp+0xd08>
  .byte  65,15,88,230                        // addps         %xmm14,%xmm4
  .byte  68,15,40,61,12,214,1,0              // movaps        0x1d60c(%rip),%xmm15        # 3ac80 <_sk_srcover_bgra_8888_sse2_lowp+0xd18>
  .byte  69,15,194,207,1                     // cmpltps       %xmm15,%xmm9
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,65,15,56,20,226                 // blendvps      %xmm0,%xmm10,%xmm4
  .byte  68,15,40,213                        // movaps        %xmm5,%xmm10
  .byte  69,15,89,211                        // mulps         %xmm11,%xmm10
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  68,15,40,205                        // movaps        %xmm5,%xmm9
  .byte  69,15,89,204                        // mulps         %xmm12,%xmm9
  .byte  69,15,88,205                        // addps         %xmm13,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  69,15,88,206                        // addps         %xmm14,%xmm9
  .byte  65,15,194,239,1                     // cmpltps       %xmm15,%xmm5
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  102,69,15,56,20,202                 // blendvps      %xmm0,%xmm10,%xmm9
  .byte  68,15,89,222                        // mulps         %xmm6,%xmm11
  .byte  68,15,40,214                        // movaps        %xmm6,%xmm10
  .byte  69,15,89,210                        // mulps         %xmm10,%xmm10
  .byte  68,15,89,230                        // mulps         %xmm6,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  69,15,89,212                        // mulps         %xmm12,%xmm10
  .byte  69,15,88,214                        // addps         %xmm14,%xmm10
  .byte  65,15,194,247,1                     // cmpltps       %xmm15,%xmm6
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  102,69,15,56,20,211                 // blendvps      %xmm0,%xmm11,%xmm10
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  65,15,40,233                        // movaps        %xmm9,%xmm5
  .byte  65,15,40,242                        // movaps        %xmm10,%xmm6
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_to_srgb_sse41
.globl _sk_to_srgb_sse41
FUNCTION(_sk_to_srgb_sse41)
_sk_to_srgb_sse41:
  .byte  15,41,124,36,232                    // movaps        %xmm7,-0x18(%rsp)
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  68,15,82,192                        // rsqrtps       %xmm0,%xmm8
  .byte  68,15,40,29,128,213,1,0             // movaps        0x1d580(%rip),%xmm11        # 3ac90 <_sk_srcover_bgra_8888_sse2_lowp+0xd28>
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  68,15,40,37,128,213,1,0             // movaps        0x1d580(%rip),%xmm12        # 3aca0 <_sk_srcover_bgra_8888_sse2_lowp+0xd38>
  .byte  69,15,40,248                        // movaps        %xmm8,%xmm15
  .byte  69,15,89,252                        // mulps         %xmm12,%xmm15
  .byte  68,15,40,21,128,213,1,0             // movaps        0x1d580(%rip),%xmm10        # 3acb0 <_sk_srcover_bgra_8888_sse2_lowp+0xd48>
  .byte  69,15,88,250                        // addps         %xmm10,%xmm15
  .byte  69,15,89,248                        // mulps         %xmm8,%xmm15
  .byte  68,15,40,45,128,213,1,0             // movaps        0x1d580(%rip),%xmm13        # 3acc0 <_sk_srcover_bgra_8888_sse2_lowp+0xd58>
  .byte  69,15,88,253                        // addps         %xmm13,%xmm15
  .byte  68,15,40,53,132,213,1,0             // movaps        0x1d584(%rip),%xmm14        # 3acd0 <_sk_srcover_bgra_8888_sse2_lowp+0xd68>
  .byte  69,15,88,198                        // addps         %xmm14,%xmm8
  .byte  69,15,83,192                        // rcpps         %xmm8,%xmm8
  .byte  69,15,89,199                        // mulps         %xmm15,%xmm8
  .byte  68,15,40,61,128,213,1,0             // movaps        0x1d580(%rip),%xmm15        # 3ace0 <_sk_srcover_bgra_8888_sse2_lowp+0xd78>
  .byte  65,15,194,199,1                     // cmpltps       %xmm15,%xmm0
  .byte  102,69,15,56,20,193                 // blendvps      %xmm0,%xmm9,%xmm8
  .byte  68,15,82,202                        // rsqrtps       %xmm2,%xmm9
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,89,196                        // mulps         %xmm12,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  65,15,88,197                        // addps         %xmm13,%xmm0
  .byte  69,15,88,206                        // addps         %xmm14,%xmm9
  .byte  69,15,83,201                        // rcpps         %xmm9,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  65,15,194,215,1                     // cmpltps       %xmm15,%xmm2
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  102,68,15,56,20,201                 // blendvps      %xmm0,%xmm1,%xmm9
  .byte  15,82,195                           // rsqrtps       %xmm3,%xmm0
  .byte  68,15,89,224                        // mulps         %xmm0,%xmm12
  .byte  69,15,88,226                        // addps         %xmm10,%xmm12
  .byte  68,15,89,224                        // mulps         %xmm0,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  65,15,88,198                        // addps         %xmm14,%xmm0
  .byte  68,15,83,208                        // rcpps         %xmm0,%xmm10
  .byte  69,15,89,212                        // mulps         %xmm12,%xmm10
  .byte  68,15,89,219                        // mulps         %xmm3,%xmm11
  .byte  65,15,194,223,1                     // cmpltps       %xmm15,%xmm3
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  102,69,15,56,20,211                 // blendvps      %xmm0,%xmm11,%xmm10
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,40,238                           // movaps        %xmm6,%xmm5
  .byte  15,40,247                           // movaps        %xmm7,%xmm6
  .byte  15,40,124,36,232                    // movaps        -0x18(%rsp),%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_rgb_to_hsl_sse41
.globl _sk_rgb_to_hsl_sse41
FUNCTION(_sk_rgb_to_hsl_sse41)
_sk_rgb_to_hsl_sse41:
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  15,95,194                           // maxps         %xmm2,%xmm0
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  68,15,95,216                        // maxps         %xmm0,%xmm11
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  15,93,194                           // minps         %xmm2,%xmm0
  .byte  69,15,40,224                        // movaps        %xmm8,%xmm12
  .byte  68,15,93,224                        // minps         %xmm0,%xmm12
  .byte  65,15,40,203                        // movaps        %xmm11,%xmm1
  .byte  65,15,92,204                        // subps         %xmm12,%xmm1
  .byte  68,15,40,53,39,211,1,0              // movaps        0x1d327(%rip),%xmm14        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,94,241                        // divps         %xmm1,%xmm14
  .byte  69,15,40,211                        // movaps        %xmm11,%xmm10
  .byte  69,15,194,208,0                     // cmpeqps       %xmm8,%xmm10
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  15,92,194                           // subps         %xmm2,%xmm0
  .byte  65,15,89,198                        // mulps         %xmm14,%xmm0
  .byte  69,15,40,249                        // movaps        %xmm9,%xmm15
  .byte  68,15,194,250,1                     // cmpltps       %xmm2,%xmm15
  .byte  68,15,84,61,158,212,1,0             // andps         0x1d49e(%rip),%xmm15        # 3acf0 <_sk_srcover_bgra_8888_sse2_lowp+0xd88>
  .byte  68,15,88,248                        // addps         %xmm0,%xmm15
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  65,15,194,193,0                     // cmpeqps       %xmm9,%xmm0
  .byte  65,15,92,208                        // subps         %xmm8,%xmm2
  .byte  65,15,89,214                        // mulps         %xmm14,%xmm2
  .byte  68,15,40,45,145,212,1,0             // movaps        0x1d491(%rip),%xmm13        # 3ad00 <_sk_srcover_bgra_8888_sse2_lowp+0xd98>
  .byte  65,15,88,213                        // addps         %xmm13,%xmm2
  .byte  69,15,92,193                        // subps         %xmm9,%xmm8
  .byte  69,15,89,198                        // mulps         %xmm14,%xmm8
  .byte  68,15,88,5,141,212,1,0              // addps         0x1d48d(%rip),%xmm8        # 3ad10 <_sk_srcover_bgra_8888_sse2_lowp+0xda8>
  .byte  102,68,15,56,20,194                 // blendvps      %xmm0,%xmm2,%xmm8
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  102,69,15,56,20,199                 // blendvps      %xmm0,%xmm15,%xmm8
  .byte  68,15,89,5,133,212,1,0              // mulps         0x1d485(%rip),%xmm8        # 3ad20 <_sk_srcover_bgra_8888_sse2_lowp+0xdb8>
  .byte  69,15,40,203                        // movaps        %xmm11,%xmm9
  .byte  69,15,194,204,4                     // cmpneqps      %xmm12,%xmm9
  .byte  69,15,84,193                        // andps         %xmm9,%xmm8
  .byte  69,15,92,235                        // subps         %xmm11,%xmm13
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  15,40,5,137,210,1,0                 // movaps        0x1d289(%rip),%xmm0        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  65,15,40,211                        // movaps        %xmm11,%xmm2
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,194,194,1                        // cmpltps       %xmm2,%xmm0
  .byte  69,15,92,236                        // subps         %xmm12,%xmm13
  .byte  102,69,15,56,20,221                 // blendvps      %xmm0,%xmm13,%xmm11
  .byte  65,15,94,203                        // divps         %xmm11,%xmm1
  .byte  65,15,84,201                        // andps         %xmm9,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hsl_to_rgb_sse41
.globl _sk_hsl_to_rgb_sse41
FUNCTION(_sk_hsl_to_rgb_sse41)
_sk_hsl_to_rgb_sse41:
  .byte  15,41,124,36,232                    // movaps        %xmm7,-0x18(%rsp)
  .byte  15,41,116,36,216                    // movaps        %xmm6,-0x28(%rsp)
  .byte  15,41,108,36,200                    // movaps        %xmm5,-0x38(%rsp)
  .byte  15,41,100,36,184                    // movaps        %xmm4,-0x48(%rsp)
  .byte  15,41,92,36,168                     // movaps        %xmm3,-0x58(%rsp)
  .byte  68,15,40,208                        // movaps        %xmm0,%xmm10
  .byte  68,15,40,13,63,210,1,0              // movaps        0x1d23f(%rip),%xmm9        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  15,194,194,2                        // cmpleps       %xmm2,%xmm0
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,89,234                           // mulps         %xmm2,%xmm5
  .byte  15,92,221                           // subps         %xmm5,%xmm3
  .byte  102,15,56,20,235                    // blendvps      %xmm0,%xmm3,%xmm5
  .byte  15,88,234                           // addps         %xmm2,%xmm5
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  15,41,84,36,152                     // movaps        %xmm2,-0x68(%rsp)
  .byte  69,15,88,192                        // addps         %xmm8,%xmm8
  .byte  68,15,92,197                        // subps         %xmm5,%xmm8
  .byte  68,15,40,53,250,211,1,0             // movaps        0x1d3fa(%rip),%xmm14        # 3ad30 <_sk_srcover_bgra_8888_sse2_lowp+0xdc8>
  .byte  69,15,88,242                        // addps         %xmm10,%xmm14
  .byte  102,65,15,58,8,198,1                // roundps       $0x1,%xmm14,%xmm0
  .byte  68,15,92,240                        // subps         %xmm0,%xmm14
  .byte  68,15,40,29,243,211,1,0             // movaps        0x1d3f3(%rip),%xmm11        # 3ad40 <_sk_srcover_bgra_8888_sse2_lowp+0xdd8>
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  65,15,194,198,2                     // cmpleps       %xmm14,%xmm0
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  65,15,92,240                        // subps         %xmm8,%xmm6
  .byte  15,40,61,140,211,1,0                // movaps        0x1d38c(%rip),%xmm7        # 3acf0 <_sk_srcover_bgra_8888_sse2_lowp+0xd88>
  .byte  69,15,40,238                        // movaps        %xmm14,%xmm13
  .byte  68,15,89,239                        // mulps         %xmm7,%xmm13
  .byte  15,40,29,157,211,1,0                // movaps        0x1d39d(%rip),%xmm3        # 3ad10 <_sk_srcover_bgra_8888_sse2_lowp+0xda8>
  .byte  68,15,40,227                        // movaps        %xmm3,%xmm12
  .byte  69,15,92,229                        // subps         %xmm13,%xmm12
  .byte  68,15,89,230                        // mulps         %xmm6,%xmm12
  .byte  69,15,88,224                        // addps         %xmm8,%xmm12
  .byte  102,69,15,56,20,224                 // blendvps      %xmm0,%xmm8,%xmm12
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,194,198,2                     // cmpleps       %xmm14,%xmm0
  .byte  68,15,40,253                        // movaps        %xmm5,%xmm15
  .byte  102,69,15,56,20,252                 // blendvps      %xmm0,%xmm12,%xmm15
  .byte  68,15,40,37,124,211,1,0             // movaps        0x1d37c(%rip),%xmm12        # 3ad20 <_sk_srcover_bgra_8888_sse2_lowp+0xdb8>
  .byte  65,15,40,196                        // movaps        %xmm12,%xmm0
  .byte  65,15,194,198,2                     // cmpleps       %xmm14,%xmm0
  .byte  68,15,89,238                        // mulps         %xmm6,%xmm13
  .byte  69,15,88,232                        // addps         %xmm8,%xmm13
  .byte  102,69,15,56,20,239                 // blendvps      %xmm0,%xmm15,%xmm13
  .byte  69,15,87,246                        // xorps         %xmm14,%xmm14
  .byte  68,15,194,241,0                     // cmpeqps       %xmm1,%xmm14
  .byte  65,15,40,198                        // movaps        %xmm14,%xmm0
  .byte  102,68,15,56,20,234                 // blendvps      %xmm0,%xmm2,%xmm13
  .byte  102,65,15,58,8,194,1                // roundps       $0x1,%xmm10,%xmm0
  .byte  69,15,40,250                        // movaps        %xmm10,%xmm15
  .byte  68,15,92,248                        // subps         %xmm0,%xmm15
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  65,15,194,199,2                     // cmpleps       %xmm15,%xmm0
  .byte  65,15,40,207                        // movaps        %xmm15,%xmm1
  .byte  15,89,207                           // mulps         %xmm7,%xmm1
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,92,209                           // subps         %xmm1,%xmm2
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  65,15,88,208                        // addps         %xmm8,%xmm2
  .byte  102,65,15,56,20,208                 // blendvps      %xmm0,%xmm8,%xmm2
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,194,199,2                     // cmpleps       %xmm15,%xmm0
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  102,15,56,20,226                    // blendvps      %xmm0,%xmm2,%xmm4
  .byte  65,15,40,196                        // movaps        %xmm12,%xmm0
  .byte  65,15,194,199,2                     // cmpleps       %xmm15,%xmm0
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  102,15,56,20,204                    // blendvps      %xmm0,%xmm4,%xmm1
  .byte  65,15,40,198                        // movaps        %xmm14,%xmm0
  .byte  15,40,84,36,152                     // movaps        -0x68(%rsp),%xmm2
  .byte  102,15,56,20,202                    // blendvps      %xmm0,%xmm2,%xmm1
  .byte  68,15,88,21,20,211,1,0              // addps         0x1d314(%rip),%xmm10        # 3ad50 <_sk_srcover_bgra_8888_sse2_lowp+0xde8>
  .byte  102,65,15,58,8,194,1                // roundps       $0x1,%xmm10,%xmm0
  .byte  68,15,92,208                        // subps         %xmm0,%xmm10
  .byte  69,15,194,218,2                     // cmpleps       %xmm10,%xmm11
  .byte  65,15,89,250                        // mulps         %xmm10,%xmm7
  .byte  15,92,223                           // subps         %xmm7,%xmm3
  .byte  15,89,222                           // mulps         %xmm6,%xmm3
  .byte  65,15,88,216                        // addps         %xmm8,%xmm3
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  102,65,15,56,20,216                 // blendvps      %xmm0,%xmm8,%xmm3
  .byte  69,15,194,202,2                     // cmpleps       %xmm10,%xmm9
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,15,56,20,235                    // blendvps      %xmm0,%xmm3,%xmm5
  .byte  69,15,194,226,2                     // cmpleps       %xmm10,%xmm12
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  68,15,88,199                        // addps         %xmm7,%xmm8
  .byte  65,15,40,196                        // movaps        %xmm12,%xmm0
  .byte  102,68,15,56,20,197                 // blendvps      %xmm0,%xmm5,%xmm8
  .byte  65,15,40,198                        // movaps        %xmm14,%xmm0
  .byte  102,68,15,56,20,194                 // blendvps      %xmm0,%xmm2,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,197                        // movaps        %xmm13,%xmm0
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  15,40,92,36,168                     // movaps        -0x58(%rsp),%xmm3
  .byte  15,40,100,36,184                    // movaps        -0x48(%rsp),%xmm4
  .byte  15,40,108,36,200                    // movaps        -0x38(%rsp),%xmm5
  .byte  15,40,116,36,216                    // movaps        -0x28(%rsp),%xmm6
  .byte  15,40,124,36,232                    // movaps        -0x18(%rsp),%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_1_float_sse41
.globl _sk_scale_1_float_sse41
FUNCTION(_sk_scale_1_float_sse41)
_sk_scale_1_float_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_u8_sse41
.globl _sk_scale_u8_sse41
FUNCTION(_sk_scale_u8_sse41)
_sk_scale_u8_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,52                              // jne           1db23 <_sk_scale_u8_sse41+0x4c>
  .byte  102,71,15,56,49,4,16                // pmovzxbd      (%r8,%r10,1),%xmm8
  .byte  102,68,15,219,5,1,209,1,0           // pand          0x1d101(%rip),%xmm8        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  68,15,89,5,85,210,1,0               // mulps         0x1d255(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  68,15,89,195                        // mulps         %xmm3,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,216                        // movaps        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,59                              // je            1db6b <_sk_scale_u8_sse41+0x94>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,23                              // je            1db52 <_sk_scale_u8_sse41+0x7b>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,181                             // jne           1daf6 <_sk_scale_u8_sse41+0x1f>
  .byte  67,15,182,68,16,2                   // movzbl        0x2(%r8,%r10,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,192,69                // pshufd        $0x45,%xmm8,%xmm8
  .byte  67,15,183,4,16                      // movzwl        (%r8,%r10,1),%eax
  .byte  102,68,15,110,200                   // movd          %eax,%xmm9
  .byte  102,69,15,56,49,201                 // pmovzxbd      %xmm9,%xmm9
  .byte  102,69,15,58,14,193,15              // pblendw       $0xf,%xmm9,%xmm8
  .byte  235,139                             // jmp           1daf6 <_sk_scale_u8_sse41+0x1f>
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  233,124,255,255,255                 // jmpq          1daf6 <_sk_scale_u8_sse41+0x1f>

HIDDEN _sk_scale_565_sse41
.globl _sk_scale_565_sse41
FUNCTION(_sk_scale_565_sse41)
_sk_scale_565_sse41:
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,159,0,0,0                    // jne           1dc3d <_sk_scale_565_sse41+0xc3>
  .byte  102,71,15,56,51,28,80               // pmovzxwd      (%r8,%r10,2),%xmm11
  .byte  102,15,111,5,195,209,1,0            // movdqa        0x1d1c3(%rip),%xmm0        # 3ad70 <_sk_srcover_bgra_8888_sse2_lowp+0xe08>
  .byte  102,65,15,219,195                   // pand          %xmm11,%xmm0
  .byte  68,15,91,200                        // cvtdq2ps      %xmm0,%xmm9
  .byte  68,15,89,13,194,209,1,0             // mulps         0x1d1c2(%rip),%xmm9        # 3ad80 <_sk_srcover_bgra_8888_sse2_lowp+0xe18>
  .byte  102,15,111,5,202,209,1,0            // movdqa        0x1d1ca(%rip),%xmm0        # 3ad90 <_sk_srcover_bgra_8888_sse2_lowp+0xe28>
  .byte  102,65,15,219,195                   // pand          %xmm11,%xmm0
  .byte  68,15,91,208                        // cvtdq2ps      %xmm0,%xmm10
  .byte  68,15,89,21,201,209,1,0             // mulps         0x1d1c9(%rip),%xmm10        # 3ada0 <_sk_srcover_bgra_8888_sse2_lowp+0xe38>
  .byte  102,68,15,219,29,208,209,1,0        // pand          0x1d1d0(%rip),%xmm11        # 3adb0 <_sk_srcover_bgra_8888_sse2_lowp+0xe48>
  .byte  69,15,91,219                        // cvtdq2ps      %xmm11,%xmm11
  .byte  68,15,89,29,212,209,1,0             // mulps         0x1d1d4(%rip),%xmm11        # 3adc0 <_sk_srcover_bgra_8888_sse2_lowp+0xe58>
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,194,199,1                        // cmpltps       %xmm7,%xmm0
  .byte  69,15,40,226                        // movaps        %xmm10,%xmm12
  .byte  69,15,93,227                        // minps         %xmm11,%xmm12
  .byte  69,15,40,233                        // movaps        %xmm9,%xmm13
  .byte  69,15,93,236                        // minps         %xmm12,%xmm13
  .byte  69,15,40,242                        // movaps        %xmm10,%xmm14
  .byte  69,15,95,243                        // maxps         %xmm11,%xmm14
  .byte  69,15,40,225                        // movaps        %xmm9,%xmm12
  .byte  69,15,95,230                        // maxps         %xmm14,%xmm12
  .byte  102,69,15,56,20,229                 // blendvps      %xmm0,%xmm13,%xmm12
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  68,15,89,209                        // mulps         %xmm1,%xmm10
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  68,15,89,227                        // mulps         %xmm3,%xmm12
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,40,202                        // movaps        %xmm10,%xmm1
  .byte  65,15,40,211                        // movaps        %xmm11,%xmm2
  .byte  65,15,40,220                        // movaps        %xmm12,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,60                              // je            1dc86 <_sk_scale_565_sse41+0x10c>
  .byte  102,69,15,239,219                   // pxor          %xmm11,%xmm11
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,26                              // je            1dc6f <_sk_scale_565_sse41+0xf5>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  15,133,70,255,255,255               // jne           1dba5 <_sk_scale_565_sse41+0x2b>
  .byte  67,15,183,68,80,4                   // movzwl        0x4(%r8,%r10,2),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,68,15,112,216,69                // pshufd        $0x45,%xmm0,%xmm11
  .byte  102,67,15,110,4,80                  // movd          (%r8,%r10,2),%xmm0
  .byte  102,15,56,51,192                    // pmovzxwd      %xmm0,%xmm0
  .byte  102,68,15,58,14,216,15              // pblendw       $0xf,%xmm0,%xmm11
  .byte  233,31,255,255,255                  // jmpq          1dba5 <_sk_scale_565_sse41+0x2b>
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  102,68,15,110,216                   // movd          %eax,%xmm11
  .byte  233,16,255,255,255                  // jmpq          1dba5 <_sk_scale_565_sse41+0x2b>

HIDDEN _sk_lerp_1_float_sse41
.globl _sk_lerp_1_float_sse41
FUNCTION(_sk_lerp_1_float_sse41)
_sk_lerp_1_float_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  15,92,214                           // subps         %xmm6,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  15,92,223                           // subps         %xmm7,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lerp_u8_sse41
.globl _sk_lerp_u8_sse41
FUNCTION(_sk_lerp_u8_sse41)
_sk_lerp_u8_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,72                              // jne           1dd2d <_sk_lerp_u8_sse41+0x60>
  .byte  102,71,15,56,49,4,16                // pmovzxbd      (%r8,%r10,1),%xmm8
  .byte  102,68,15,219,5,11,207,1,0          // pand          0x1cf0b(%rip),%xmm8        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  68,15,89,5,95,208,1,0               // mulps         0x1d05f(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  15,92,214                           // subps         %xmm6,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  15,92,223                           // subps         %xmm7,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,62                              // je            1dd78 <_sk_lerp_u8_sse41+0xab>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,23                              // je            1dd5c <_sk_lerp_u8_sse41+0x8f>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,161                             // jne           1dcec <_sk_lerp_u8_sse41+0x1f>
  .byte  67,15,182,68,16,2                   // movzbl        0x2(%r8,%r10,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,192,69                // pshufd        $0x45,%xmm8,%xmm8
  .byte  67,15,183,4,16                      // movzwl        (%r8,%r10,1),%eax
  .byte  102,68,15,110,200                   // movd          %eax,%xmm9
  .byte  102,69,15,56,49,201                 // pmovzxbd      %xmm9,%xmm9
  .byte  102,69,15,58,14,193,15              // pblendw       $0xf,%xmm9,%xmm8
  .byte  233,116,255,255,255                 // jmpq          1dcec <_sk_lerp_u8_sse41+0x1f>
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  233,101,255,255,255                 // jmpq          1dcec <_sk_lerp_u8_sse41+0x1f>

HIDDEN _sk_lerp_565_sse41
.globl _sk_lerp_565_sse41
FUNCTION(_sk_lerp_565_sse41)
_sk_lerp_565_sse41:
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,165,0,0,0                    // jne           1de50 <_sk_lerp_565_sse41+0xc9>
  .byte  102,71,15,56,51,20,80               // pmovzxwd      (%r8,%r10,2),%xmm10
  .byte  102,15,111,5,182,207,1,0            // movdqa        0x1cfb6(%rip),%xmm0        # 3ad70 <_sk_srcover_bgra_8888_sse2_lowp+0xe08>
  .byte  102,65,15,219,194                   // pand          %xmm10,%xmm0
  .byte  68,15,91,200                        // cvtdq2ps      %xmm0,%xmm9
  .byte  68,15,89,13,181,207,1,0             // mulps         0x1cfb5(%rip),%xmm9        # 3ad80 <_sk_srcover_bgra_8888_sse2_lowp+0xe18>
  .byte  102,15,111,5,189,207,1,0            // movdqa        0x1cfbd(%rip),%xmm0        # 3ad90 <_sk_srcover_bgra_8888_sse2_lowp+0xe28>
  .byte  102,65,15,219,194                   // pand          %xmm10,%xmm0
  .byte  68,15,91,216                        // cvtdq2ps      %xmm0,%xmm11
  .byte  68,15,89,29,188,207,1,0             // mulps         0x1cfbc(%rip),%xmm11        # 3ada0 <_sk_srcover_bgra_8888_sse2_lowp+0xe38>
  .byte  102,68,15,219,21,195,207,1,0        // pand          0x1cfc3(%rip),%xmm10        # 3adb0 <_sk_srcover_bgra_8888_sse2_lowp+0xe48>
  .byte  69,15,91,210                        // cvtdq2ps      %xmm10,%xmm10
  .byte  68,15,89,21,199,207,1,0             // mulps         0x1cfc7(%rip),%xmm10        # 3adc0 <_sk_srcover_bgra_8888_sse2_lowp+0xe58>
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,194,199,1                        // cmpltps       %xmm7,%xmm0
  .byte  69,15,40,227                        // movaps        %xmm11,%xmm12
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  69,15,93,218                        // minps         %xmm10,%xmm11
  .byte  69,15,40,233                        // movaps        %xmm9,%xmm13
  .byte  68,15,92,196                        // subps         %xmm4,%xmm8
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  69,15,93,203                        // minps         %xmm11,%xmm9
  .byte  69,15,95,226                        // maxps         %xmm10,%xmm12
  .byte  69,15,95,236                        // maxps         %xmm12,%xmm13
  .byte  102,69,15,56,20,233                 // blendvps      %xmm0,%xmm9,%xmm13
  .byte  68,15,88,196                        // addps         %xmm4,%xmm8
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  15,92,214                           // subps         %xmm6,%xmm2
  .byte  65,15,89,210                        // mulps         %xmm10,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  15,92,223                           // subps         %xmm7,%xmm3
  .byte  65,15,89,221                        // mulps         %xmm13,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,60                              // je            1de99 <_sk_lerp_565_sse41+0x112>
  .byte  102,69,15,239,210                   // pxor          %xmm10,%xmm10
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,26                              // je            1de82 <_sk_lerp_565_sse41+0xfb>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  15,133,64,255,255,255               // jne           1ddb2 <_sk_lerp_565_sse41+0x2b>
  .byte  67,15,183,68,80,4                   // movzwl        0x4(%r8,%r10,2),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,68,15,112,208,69                // pshufd        $0x45,%xmm0,%xmm10
  .byte  102,67,15,110,4,80                  // movd          (%r8,%r10,2),%xmm0
  .byte  102,15,56,51,192                    // pmovzxwd      %xmm0,%xmm0
  .byte  102,68,15,58,14,208,15              // pblendw       $0xf,%xmm0,%xmm10
  .byte  233,25,255,255,255                  // jmpq          1ddb2 <_sk_lerp_565_sse41+0x2b>
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  102,68,15,110,208                   // movd          %eax,%xmm10
  .byte  233,10,255,255,255                  // jmpq          1ddb2 <_sk_lerp_565_sse41+0x2b>

HIDDEN _sk_load_tables_sse41
.globl _sk_load_tables_sse41
FUNCTION(_sk_load_tables_sse41)
_sk_load_tables_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,20,1,0,0                     // jne           1dfca <_sk_load_tables_sse41+0x122>
  .byte  243,69,15,111,4,144                 // movdqu        (%r8,%rdx,4),%xmm8
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  102,15,111,5,57,205,1,0             // movdqa        0x1cd39(%rip),%xmm0        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,65,15,219,192                   // pand          %xmm8,%xmm0
  .byte  102,73,15,58,22,192,1               // pextrq        $0x1,%xmm0,%r8
  .byte  102,73,15,126,193                   // movq          %xmm0,%r9
  .byte  69,15,182,209                       // movzbl        %r9b,%r10d
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  69,15,182,216                       // movzbl        %r8b,%r11d
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  72,139,88,8                         // mov           0x8(%rax),%rbx
  .byte  76,139,112,16                       // mov           0x10(%rax),%r14
  .byte  243,66,15,16,4,147                  // movss         (%rbx,%r10,4),%xmm0
  .byte  102,66,15,58,33,4,11,16             // insertps      $0x10,(%rbx,%r9,1),%xmm0
  .byte  102,66,15,58,33,4,155,32            // insertps      $0x20,(%rbx,%r11,4),%xmm0
  .byte  102,66,15,58,33,4,3,48              // insertps      $0x30,(%rbx,%r8,1),%xmm0
  .byte  102,65,15,111,200                   // movdqa        %xmm8,%xmm1
  .byte  102,15,56,0,13,244,204,1,0          // pshufb        0x1ccf4(%rip),%xmm1        # 3ac10 <_sk_srcover_bgra_8888_sse2_lowp+0xca8>
  .byte  102,73,15,58,22,200,1               // pextrq        $0x1,%xmm1,%r8
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  68,15,182,203                       // movzbl        %bl,%r9d
  .byte  72,193,235,30                       // shr           $0x1e,%rbx
  .byte  69,15,182,208                       // movzbl        %r8b,%r10d
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  243,67,15,16,12,142                 // movss         (%r14,%r9,4),%xmm1
  .byte  102,65,15,58,33,12,30,16            // insertps      $0x10,(%r14,%rbx,1),%xmm1
  .byte  243,67,15,16,20,150                 // movss         (%r14,%r10,4),%xmm2
  .byte  102,15,58,33,202,32                 // insertps      $0x20,%xmm2,%xmm1
  .byte  243,67,15,16,20,6                   // movss         (%r14,%r8,1),%xmm2
  .byte  102,15,58,33,202,48                 // insertps      $0x30,%xmm2,%xmm1
  .byte  76,139,64,24                        // mov           0x18(%rax),%r8
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  102,15,56,0,21,176,204,1,0          // pshufb        0x1ccb0(%rip),%xmm2        # 3ac20 <_sk_srcover_bgra_8888_sse2_lowp+0xcb8>
  .byte  102,72,15,58,22,211,1               // pextrq        $0x1,%xmm2,%rbx
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  68,15,182,200                       // movzbl        %al,%r9d
  .byte  72,193,232,30                       // shr           $0x1e,%rax
  .byte  68,15,182,211                       // movzbl        %bl,%r10d
  .byte  72,193,235,30                       // shr           $0x1e,%rbx
  .byte  243,67,15,16,20,136                 // movss         (%r8,%r9,4),%xmm2
  .byte  102,65,15,58,33,20,0,16             // insertps      $0x10,(%r8,%rax,1),%xmm2
  .byte  243,67,15,16,28,144                 // movss         (%r8,%r10,4),%xmm3
  .byte  102,15,58,33,211,32                 // insertps      $0x20,%xmm3,%xmm2
  .byte  243,65,15,16,28,24                  // movss         (%r8,%rbx,1),%xmm3
  .byte  102,15,58,33,211,48                 // insertps      $0x30,%xmm3,%xmm2
  .byte  102,65,15,114,208,24                // psrld         $0x18,%xmm8
  .byte  65,15,91,216                        // cvtdq2ps      %xmm8,%xmm3
  .byte  15,89,29,157,205,1,0                // mulps         0x1cd9d(%rip),%xmm3        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,52                              // je            1e00b <_sk_load_tables_sse41+0x163>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,23                              // je            1dff9 <_sk_load_tables_sse41+0x151>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  15,133,208,254,255,255              // jne           1debc <_sk_load_tables_sse41+0x14>
  .byte  102,65,15,110,68,144,8              // movd          0x8(%r8,%rdx,4),%xmm0
  .byte  102,68,15,112,192,69                // pshufd        $0x45,%xmm0,%xmm8
  .byte  243,65,15,126,4,144                 // movq          (%r8,%rdx,4),%xmm0
  .byte  102,68,15,58,14,192,15              // pblendw       $0xf,%xmm0,%xmm8
  .byte  233,177,254,255,255                 // jmpq          1debc <_sk_load_tables_sse41+0x14>
  .byte  102,69,15,110,4,144                 // movd          (%r8,%rdx,4),%xmm8
  .byte  233,166,254,255,255                 // jmpq          1debc <_sk_load_tables_sse41+0x14>

HIDDEN _sk_load_tables_u16_be_sse41
.globl _sk_load_tables_u16_be_sse41
FUNCTION(_sk_load_tables_u16_be_sse41)
_sk_load_tables_u16_be_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  76,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,95,1,0,0                     // jne           1e18b <_sk_load_tables_u16_be_sse41+0x175>
  .byte  102,67,15,16,4,72                   // movupd        (%r8,%r9,2),%xmm0
  .byte  243,67,15,111,76,72,16              // movdqu        0x10(%r8,%r9,2),%xmm1
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  102,68,15,40,200                    // movapd        %xmm0,%xmm9
  .byte  102,68,15,97,201                    // punpcklwd     %xmm1,%xmm9
  .byte  102,15,105,193                      // punpckhwd     %xmm1,%xmm0
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  102,68,15,105,200                   // punpckhwd     %xmm0,%xmm9
  .byte  102,68,15,111,5,111,205,1,0         // movdqa        0x1cd6f(%rip),%xmm8        # 3add0 <_sk_srcover_bgra_8888_sse2_lowp+0xe68>
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,65,15,219,192                   // pand          %xmm8,%xmm0
  .byte  102,15,56,51,192                    // pmovzxwd      %xmm0,%xmm0
  .byte  102,73,15,58,22,192,1               // pextrq        $0x1,%xmm0,%r8
  .byte  102,73,15,126,193                   // movq          %xmm0,%r9
  .byte  69,15,182,209                       // movzbl        %r9b,%r10d
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  69,15,182,216                       // movzbl        %r8b,%r11d
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  72,139,88,8                         // mov           0x8(%rax),%rbx
  .byte  76,139,112,16                       // mov           0x10(%rax),%r14
  .byte  243,66,15,16,4,147                  // movss         (%rbx,%r10,4),%xmm0
  .byte  102,66,15,58,33,4,11,16             // insertps      $0x10,(%rbx,%r9,1),%xmm0
  .byte  243,66,15,16,20,155                 // movss         (%rbx,%r11,4),%xmm2
  .byte  102,15,58,33,194,32                 // insertps      $0x20,%xmm2,%xmm0
  .byte  243,66,15,16,20,3                   // movss         (%rbx,%r8,1),%xmm2
  .byte  102,15,58,33,194,48                 // insertps      $0x30,%xmm2,%xmm0
  .byte  102,15,56,0,13,30,205,1,0           // pshufb        0x1cd1e(%rip),%xmm1        # 3ade0 <_sk_srcover_bgra_8888_sse2_lowp+0xe78>
  .byte  102,15,56,51,201                    // pmovzxwd      %xmm1,%xmm1
  .byte  102,73,15,58,22,200,1               // pextrq        $0x1,%xmm1,%r8
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  68,15,182,203                       // movzbl        %bl,%r9d
  .byte  72,193,235,30                       // shr           $0x1e,%rbx
  .byte  69,15,182,208                       // movzbl        %r8b,%r10d
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  243,67,15,16,12,142                 // movss         (%r14,%r9,4),%xmm1
  .byte  102,65,15,58,33,12,30,16            // insertps      $0x10,(%r14,%rbx,1),%xmm1
  .byte  243,67,15,16,20,150                 // movss         (%r14,%r10,4),%xmm2
  .byte  102,15,58,33,202,32                 // insertps      $0x20,%xmm2,%xmm1
  .byte  243,67,15,16,20,6                   // movss         (%r14,%r8,1),%xmm2
  .byte  102,15,58,33,202,48                 // insertps      $0x30,%xmm2,%xmm1
  .byte  76,139,64,24                        // mov           0x18(%rax),%r8
  .byte  102,69,15,219,193                   // pand          %xmm9,%xmm8
  .byte  102,65,15,56,51,208                 // pmovzxwd      %xmm8,%xmm2
  .byte  102,72,15,58,22,211,1               // pextrq        $0x1,%xmm2,%rbx
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  68,15,182,200                       // movzbl        %al,%r9d
  .byte  72,193,232,30                       // shr           $0x1e,%rax
  .byte  68,15,182,211                       // movzbl        %bl,%r10d
  .byte  72,193,235,30                       // shr           $0x1e,%rbx
  .byte  243,67,15,16,20,136                 // movss         (%r8,%r9,4),%xmm2
  .byte  102,65,15,58,33,20,0,16             // insertps      $0x10,(%r8,%rax,1),%xmm2
  .byte  243,67,15,16,28,144                 // movss         (%r8,%r10,4),%xmm3
  .byte  102,15,58,33,211,32                 // insertps      $0x20,%xmm3,%xmm2
  .byte  243,65,15,16,28,24                  // movss         (%r8,%rbx,1),%xmm3
  .byte  102,15,58,33,211,48                 // insertps      $0x30,%xmm3,%xmm2
  .byte  102,65,15,112,217,78                // pshufd        $0x4e,%xmm9,%xmm3
  .byte  102,68,15,111,195                   // movdqa        %xmm3,%xmm8
  .byte  102,65,15,113,240,8                 // psllw         $0x8,%xmm8
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,65,15,235,216                   // por           %xmm8,%xmm3
  .byte  102,15,56,51,219                    // pmovzxwd      %xmm3,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,29,108,204,1,0                // mulps         0x1cc6c(%rip),%xmm3        # 3adf0 <_sk_srcover_bgra_8888_sse2_lowp+0xe88>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  255,224                             // jmpq          *%rax
  .byte  242,67,15,16,4,72                   // movsd         (%r8,%r9,2),%xmm0
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,13                              // jne           1e1a4 <_sk_load_tables_u16_be_sse41+0x18e>
  .byte  243,15,126,192                      // movq          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  233,149,254,255,255                 // jmpq          1e039 <_sk_load_tables_u16_be_sse41+0x23>
  .byte  102,67,15,22,68,72,8                // movhpd        0x8(%r8,%r9,2),%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  15,130,128,254,255,255              // jb            1e039 <_sk_load_tables_u16_be_sse41+0x23>
  .byte  243,67,15,126,76,72,16              // movq          0x10(%r8,%r9,2),%xmm1
  .byte  233,116,254,255,255                 // jmpq          1e039 <_sk_load_tables_u16_be_sse41+0x23>

HIDDEN _sk_load_tables_rgb_u16_be_sse41
.globl _sk_load_tables_rgb_u16_be_sse41
FUNCTION(_sk_load_tables_rgb_u16_be_sse41)
_sk_load_tables_rgb_u16_be_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  76,141,12,82                        // lea           (%rdx,%rdx,2),%r9
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,79,1,0,0                     // jne           1e326 <_sk_load_tables_rgb_u16_be_sse41+0x161>
  .byte  243,67,15,111,20,72                 // movdqu        (%r8,%r9,2),%xmm2
  .byte  243,67,15,111,76,72,8               // movdqu        0x8(%r8,%r9,2),%xmm1
  .byte  102,15,115,217,4                    // psrldq        $0x4,%xmm1
  .byte  102,68,15,111,202                   // movdqa        %xmm2,%xmm9
  .byte  102,65,15,115,217,6                 // psrldq        $0x6,%xmm9
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,115,216,6                    // psrldq        $0x6,%xmm0
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  102,68,15,97,200                    // punpcklwd     %xmm0,%xmm9
  .byte  102,15,97,209                       // punpcklwd     %xmm1,%xmm2
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,65,15,97,201                    // punpcklwd     %xmm9,%xmm1
  .byte  102,68,15,111,5,181,203,1,0         // movdqa        0x1cbb5(%rip),%xmm8        # 3add0 <_sk_srcover_bgra_8888_sse2_lowp+0xe68>
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,65,15,219,192                   // pand          %xmm8,%xmm0
  .byte  102,15,56,51,192                    // pmovzxwd      %xmm0,%xmm0
  .byte  102,73,15,58,22,192,1               // pextrq        $0x1,%xmm0,%r8
  .byte  102,73,15,126,193                   // movq          %xmm0,%r9
  .byte  69,15,182,209                       // movzbl        %r9b,%r10d
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  69,15,182,216                       // movzbl        %r8b,%r11d
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  72,139,88,8                         // mov           0x8(%rax),%rbx
  .byte  76,139,112,16                       // mov           0x10(%rax),%r14
  .byte  243,66,15,16,4,147                  // movss         (%rbx,%r10,4),%xmm0
  .byte  102,66,15,58,33,4,11,16             // insertps      $0x10,(%rbx,%r9,1),%xmm0
  .byte  243,66,15,16,28,155                 // movss         (%rbx,%r11,4),%xmm3
  .byte  102,15,58,33,195,32                 // insertps      $0x20,%xmm3,%xmm0
  .byte  243,66,15,16,28,3                   // movss         (%rbx,%r8,1),%xmm3
  .byte  102,15,58,33,195,48                 // insertps      $0x30,%xmm3,%xmm0
  .byte  102,15,56,0,13,100,203,1,0          // pshufb        0x1cb64(%rip),%xmm1        # 3ade0 <_sk_srcover_bgra_8888_sse2_lowp+0xe78>
  .byte  102,15,56,51,201                    // pmovzxwd      %xmm1,%xmm1
  .byte  102,73,15,58,22,200,1               // pextrq        $0x1,%xmm1,%r8
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  68,15,182,203                       // movzbl        %bl,%r9d
  .byte  72,193,235,30                       // shr           $0x1e,%rbx
  .byte  69,15,182,208                       // movzbl        %r8b,%r10d
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  243,67,15,16,12,142                 // movss         (%r14,%r9,4),%xmm1
  .byte  102,65,15,58,33,12,30,16            // insertps      $0x10,(%r14,%rbx,1),%xmm1
  .byte  243,67,15,16,28,150                 // movss         (%r14,%r10,4),%xmm3
  .byte  102,15,58,33,203,32                 // insertps      $0x20,%xmm3,%xmm1
  .byte  243,67,15,16,28,6                   // movss         (%r14,%r8,1),%xmm3
  .byte  102,15,58,33,203,48                 // insertps      $0x30,%xmm3,%xmm1
  .byte  76,139,64,24                        // mov           0x18(%rax),%r8
  .byte  102,65,15,105,209                   // punpckhwd     %xmm9,%xmm2
  .byte  102,65,15,219,208                   // pand          %xmm8,%xmm2
  .byte  102,15,56,51,210                    // pmovzxwd      %xmm2,%xmm2
  .byte  102,72,15,58,22,211,1               // pextrq        $0x1,%xmm2,%rbx
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  68,15,182,200                       // movzbl        %al,%r9d
  .byte  72,193,232,30                       // shr           $0x1e,%rax
  .byte  68,15,182,211                       // movzbl        %bl,%r10d
  .byte  72,193,235,30                       // shr           $0x1e,%rbx
  .byte  243,67,15,16,20,136                 // movss         (%r8,%r9,4),%xmm2
  .byte  102,65,15,58,33,20,0,16             // insertps      $0x10,(%r8,%rax,1),%xmm2
  .byte  243,67,15,16,28,144                 // movss         (%r8,%r10,4),%xmm3
  .byte  102,15,58,33,211,32                 // insertps      $0x20,%xmm3,%xmm2
  .byte  243,65,15,16,28,24                  // movss         (%r8,%rbx,1),%xmm3
  .byte  102,15,58,33,211,48                 // insertps      $0x30,%xmm3,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,47,200,1,0                 // movaps        0x1c82f(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  255,224                             // jmpq          *%rax
  .byte  102,67,15,110,20,72                 // movd          (%r8,%r9,2),%xmm2
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,67,15,196,84,72,4,2             // pinsrw        $0x2,0x4(%r8,%r9,2),%xmm2
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,14                              // jne           1e34c <_sk_load_tables_rgb_u16_be_sse41+0x187>
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  233,177,254,255,255                 // jmpq          1e1fd <_sk_load_tables_rgb_u16_be_sse41+0x38>
  .byte  102,71,15,110,76,72,6               // movd          0x6(%r8,%r9,2),%xmm9
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,71,15,196,76,72,10,2            // pinsrw        $0x2,0xa(%r8,%r9,2),%xmm9
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,24                              // jb            1e37d <_sk_load_tables_rgb_u16_be_sse41+0x1b8>
  .byte  102,67,15,110,76,72,12              // movd          0xc(%r8,%r9,2),%xmm1
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,67,15,196,76,72,16,2            // pinsrw        $0x2,0x10(%r8,%r9,2),%xmm1
  .byte  233,128,254,255,255                 // jmpq          1e1fd <_sk_load_tables_rgb_u16_be_sse41+0x38>
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  233,119,254,255,255                 // jmpq          1e1fd <_sk_load_tables_rgb_u16_be_sse41+0x38>

HIDDEN _sk_byte_tables_sse41
.globl _sk_byte_tables_sse41
FUNCTION(_sk_byte_tables_sse41)
_sk_byte_tables_sse41:
  .byte  85                                  // push          %rbp
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  68,15,95,216                        // maxps         %xmm0,%xmm11
  .byte  68,15,40,13,176,199,1,0             // movaps        0x1c7b0(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,217                        // minps         %xmm9,%xmm11
  .byte  68,15,40,21,132,200,1,0             // movaps        0x1c884(%rip),%xmm10        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  69,15,89,218                        // mulps         %xmm10,%xmm11
  .byte  102,65,15,91,195                    // cvtps2dq      %xmm11,%xmm0
  .byte  102,73,15,58,22,192,1               // pextrq        $0x1,%xmm0,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  77,137,194                          // mov           %r8,%r10
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,73,15,126,192                   // movq          %xmm0,%r8
  .byte  69,137,195                          // mov           %r8d,%r11d
  .byte  77,137,198                          // mov           %r8,%r14
  .byte  73,193,238,32                       // shr           $0x20,%r14
  .byte  72,139,24                           // mov           (%rax),%rbx
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  70,15,182,52,51                     // movzbl        (%rbx,%r14,1),%r14d
  .byte  66,15,182,44,27                     // movzbl        (%rbx,%r11,1),%ebp
  .byte  102,15,110,197                      // movd          %ebp,%xmm0
  .byte  102,65,15,58,32,198,1               // pinsrb        $0x1,%r14d,%xmm0
  .byte  66,15,182,44,11                     // movzbl        (%rbx,%r9,1),%ebp
  .byte  102,15,58,32,197,2                  // pinsrb        $0x2,%ebp,%xmm0
  .byte  66,15,182,44,19                     // movzbl        (%rbx,%r10,1),%ebp
  .byte  102,15,58,32,197,3                  // pinsrb        $0x3,%ebp,%xmm0
  .byte  102,15,56,49,192                    // pmovzxbd      %xmm0,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  68,15,40,29,73,201,1,0              // movaps        0x1c949(%rip),%xmm11        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,195                        // mulps         %xmm11,%xmm0
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,225                        // minps         %xmm9,%xmm12
  .byte  69,15,89,226                        // mulps         %xmm10,%xmm12
  .byte  102,65,15,91,204                    // cvtps2dq      %xmm12,%xmm1
  .byte  102,72,15,58,22,205,1               // pextrq        $0x1,%xmm1,%rbp
  .byte  65,137,233                          // mov           %ebp,%r9d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  65,137,218                          // mov           %ebx,%r10d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,15,182,28,24                     // movzbl        (%r8,%rbx,1),%r11d
  .byte  67,15,182,28,16                     // movzbl        (%r8,%r10,1),%ebx
  .byte  102,15,110,203                      // movd          %ebx,%xmm1
  .byte  102,65,15,58,32,203,1               // pinsrb        $0x1,%r11d,%xmm1
  .byte  67,15,182,28,8                      // movzbl        (%r8,%r9,1),%ebx
  .byte  102,15,58,32,203,2                  // pinsrb        $0x2,%ebx,%xmm1
  .byte  65,15,182,44,40                     // movzbl        (%r8,%rbp,1),%ebp
  .byte  102,15,58,32,205,3                  // pinsrb        $0x3,%ebp,%xmm1
  .byte  102,15,56,49,201                    // pmovzxbd      %xmm1,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,226                        // maxps         %xmm2,%xmm12
  .byte  69,15,93,225                        // minps         %xmm9,%xmm12
  .byte  69,15,89,226                        // mulps         %xmm10,%xmm12
  .byte  102,65,15,91,212                    // cvtps2dq      %xmm12,%xmm2
  .byte  102,72,15,58,22,211,1               // pextrq        $0x1,%xmm2,%rbx
  .byte  65,137,216                          // mov           %ebx,%r8d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,72,15,126,213                   // movq          %xmm2,%rbp
  .byte  65,137,234                          // mov           %ebp,%r10d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  69,15,182,28,41                     // movzbl        (%r9,%rbp,1),%r11d
  .byte  67,15,182,44,17                     // movzbl        (%r9,%r10,1),%ebp
  .byte  102,15,110,213                      // movd          %ebp,%xmm2
  .byte  102,65,15,58,32,211,1               // pinsrb        $0x1,%r11d,%xmm2
  .byte  67,15,182,44,1                      // movzbl        (%r9,%r8,1),%ebp
  .byte  102,15,58,32,213,2                  // pinsrb        $0x2,%ebp,%xmm2
  .byte  65,15,182,44,25                     // movzbl        (%r9,%rbx,1),%ebp
  .byte  102,15,58,32,213,3                  // pinsrb        $0x3,%ebp,%xmm2
  .byte  102,15,56,49,210                    // pmovzxbd      %xmm2,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  65,15,89,211                        // mulps         %xmm11,%xmm2
  .byte  72,139,64,24                        // mov           0x18(%rax),%rax
  .byte  68,15,95,195                        // maxps         %xmm3,%xmm8
  .byte  69,15,93,193                        // minps         %xmm9,%xmm8
  .byte  69,15,89,194                        // mulps         %xmm10,%xmm8
  .byte  102,65,15,91,216                    // cvtps2dq      %xmm8,%xmm3
  .byte  102,72,15,58,22,221,1               // pextrq        $0x1,%xmm3,%rbp
  .byte  65,137,232                          // mov           %ebp,%r8d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  102,72,15,126,219                   // movq          %xmm3,%rbx
  .byte  65,137,217                          // mov           %ebx,%r9d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  68,15,182,20,24                     // movzbl        (%rax,%rbx,1),%r10d
  .byte  66,15,182,28,8                      // movzbl        (%rax,%r9,1),%ebx
  .byte  102,15,110,219                      // movd          %ebx,%xmm3
  .byte  102,65,15,58,32,218,1               // pinsrb        $0x1,%r10d,%xmm3
  .byte  66,15,182,28,0                      // movzbl        (%rax,%r8,1),%ebx
  .byte  102,15,58,32,219,2                  // pinsrb        $0x2,%ebx,%xmm3
  .byte  15,182,4,40                         // movzbl        (%rax,%rbp,1),%eax
  .byte  102,15,58,32,216,3                  // pinsrb        $0x3,%eax,%xmm3
  .byte  102,15,56,49,219                    // pmovzxbd      %xmm3,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  65,15,89,219                        // mulps         %xmm11,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_byte_tables_rgb_sse41
.globl _sk_byte_tables_rgb_sse41
FUNCTION(_sk_byte_tables_rgb_sse41)
_sk_byte_tables_rgb_sse41:
  .byte  85                                  // push          %rbp
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,24                        // mov           0x18(%rax),%r8d
  .byte  65,255,200                          // dec           %r8d
  .byte  102,69,15,110,192                   // movd          %r8d,%xmm8
  .byte  102,69,15,112,192,0                 // pshufd        $0x0,%xmm8,%xmm8
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  68,15,95,216                        // maxps         %xmm0,%xmm11
  .byte  68,15,40,21,200,197,1,0             // movaps        0x1c5c8(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,218                        // minps         %xmm10,%xmm11
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  102,65,15,91,195                    // cvtps2dq      %xmm11,%xmm0
  .byte  102,73,15,58,22,192,1               // pextrq        $0x1,%xmm0,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  77,137,194                          // mov           %r8,%r10
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,73,15,126,192                   // movq          %xmm0,%r8
  .byte  69,137,195                          // mov           %r8d,%r11d
  .byte  77,137,198                          // mov           %r8,%r14
  .byte  73,193,238,32                       // shr           $0x20,%r14
  .byte  72,139,24                           // mov           (%rax),%rbx
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  70,15,182,52,51                     // movzbl        (%rbx,%r14,1),%r14d
  .byte  66,15,182,44,27                     // movzbl        (%rbx,%r11,1),%ebp
  .byte  102,15,110,197                      // movd          %ebp,%xmm0
  .byte  102,65,15,58,32,198,1               // pinsrb        $0x1,%r14d,%xmm0
  .byte  66,15,182,44,11                     // movzbl        (%rbx,%r9,1),%ebp
  .byte  102,15,58,32,197,2                  // pinsrb        $0x2,%ebp,%xmm0
  .byte  66,15,182,44,19                     // movzbl        (%rbx,%r10,1),%ebp
  .byte  102,15,58,32,197,3                  // pinsrb        $0x3,%ebp,%xmm0
  .byte  102,15,56,49,192                    // pmovzxbd      %xmm0,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  68,15,40,29,105,199,1,0             // movaps        0x1c769(%rip),%xmm11        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,195                        // mulps         %xmm11,%xmm0
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,89,224                        // mulps         %xmm8,%xmm12
  .byte  102,65,15,91,204                    // cvtps2dq      %xmm12,%xmm1
  .byte  102,72,15,58,22,205,1               // pextrq        $0x1,%xmm1,%rbp
  .byte  65,137,233                          // mov           %ebp,%r9d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  65,137,218                          // mov           %ebx,%r10d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,15,182,28,24                     // movzbl        (%r8,%rbx,1),%r11d
  .byte  67,15,182,28,16                     // movzbl        (%r8,%r10,1),%ebx
  .byte  102,15,110,203                      // movd          %ebx,%xmm1
  .byte  102,65,15,58,32,203,1               // pinsrb        $0x1,%r11d,%xmm1
  .byte  67,15,182,28,8                      // movzbl        (%r8,%r9,1),%ebx
  .byte  102,15,58,32,203,2                  // pinsrb        $0x2,%ebx,%xmm1
  .byte  65,15,182,44,40                     // movzbl        (%r8,%rbp,1),%ebp
  .byte  102,15,58,32,205,3                  // pinsrb        $0x3,%ebp,%xmm1
  .byte  102,15,56,49,201                    // pmovzxbd      %xmm1,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  72,139,64,16                        // mov           0x10(%rax),%rax
  .byte  68,15,95,202                        // maxps         %xmm2,%xmm9
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  102,65,15,91,209                    // cvtps2dq      %xmm9,%xmm2
  .byte  102,72,15,58,22,213,1               // pextrq        $0x1,%xmm2,%rbp
  .byte  65,137,232                          // mov           %ebp,%r8d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  102,72,15,126,211                   // movq          %xmm2,%rbx
  .byte  65,137,217                          // mov           %ebx,%r9d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  68,15,182,20,24                     // movzbl        (%rax,%rbx,1),%r10d
  .byte  66,15,182,28,8                      // movzbl        (%rax,%r9,1),%ebx
  .byte  102,15,110,211                      // movd          %ebx,%xmm2
  .byte  102,65,15,58,32,210,1               // pinsrb        $0x1,%r10d,%xmm2
  .byte  66,15,182,28,0                      // movzbl        (%rax,%r8,1),%ebx
  .byte  102,15,58,32,211,2                  // pinsrb        $0x2,%ebx,%xmm2
  .byte  15,182,4,40                         // movzbl        (%rax,%rbp,1),%eax
  .byte  102,15,58,32,208,3                  // pinsrb        $0x3,%eax,%xmm2
  .byte  102,15,56,49,210                    // pmovzxbd      %xmm2,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  65,15,89,211                        // mulps         %xmm11,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_r_sse41
.globl _sk_table_r_sse41
FUNCTION(_sk_table_r_sse41)
_sk_table_r_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,192,0                 // pshufd        $0x0,%xmm8,%xmm8
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,93,13,89,196,1,0              // minps         0x1c459(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  102,65,15,91,193                    // cvtps2dq      %xmm9,%xmm0
  .byte  102,72,15,58,22,192,1               // pextrq        $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,194                   // movq          %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  243,67,15,16,4,152                  // movss         (%r8,%r11,4),%xmm0
  .byte  102,67,15,58,33,4,144,16            // insertps      $0x10,(%r8,%r10,4),%xmm0
  .byte  243,71,15,16,4,136                  // movss         (%r8,%r9,4),%xmm8
  .byte  102,65,15,58,33,192,32              // insertps      $0x20,%xmm8,%xmm0
  .byte  243,69,15,16,4,128                  // movss         (%r8,%rax,4),%xmm8
  .byte  102,65,15,58,33,192,48              // insertps      $0x30,%xmm8,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_g_sse41
.globl _sk_table_g_sse41
FUNCTION(_sk_table_g_sse41)
_sk_table_g_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,192,0                 // pshufd        $0x0,%xmm8,%xmm8
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,201                        // maxps         %xmm1,%xmm9
  .byte  68,15,93,13,225,195,1,0             // minps         0x1c3e1(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  102,65,15,91,201                    // cvtps2dq      %xmm9,%xmm1
  .byte  102,72,15,58,22,200,1               // pextrq        $0x1,%xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  243,67,15,16,12,152                 // movss         (%r8,%r11,4),%xmm1
  .byte  102,67,15,58,33,12,144,16           // insertps      $0x10,(%r8,%r10,4),%xmm1
  .byte  243,71,15,16,4,136                  // movss         (%r8,%r9,4),%xmm8
  .byte  102,65,15,58,33,200,32              // insertps      $0x20,%xmm8,%xmm1
  .byte  243,69,15,16,4,128                  // movss         (%r8,%rax,4),%xmm8
  .byte  102,65,15,58,33,200,48              // insertps      $0x30,%xmm8,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_b_sse41
.globl _sk_table_b_sse41
FUNCTION(_sk_table_b_sse41)
_sk_table_b_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,192,0                 // pshufd        $0x0,%xmm8,%xmm8
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,202                        // maxps         %xmm2,%xmm9
  .byte  68,15,93,13,105,195,1,0             // minps         0x1c369(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  102,65,15,91,209                    // cvtps2dq      %xmm9,%xmm2
  .byte  102,72,15,58,22,208,1               // pextrq        $0x1,%xmm2,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,210                   // movq          %xmm2,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  243,67,15,16,20,152                 // movss         (%r8,%r11,4),%xmm2
  .byte  102,67,15,58,33,20,144,16           // insertps      $0x10,(%r8,%r10,4),%xmm2
  .byte  243,71,15,16,4,136                  // movss         (%r8,%r9,4),%xmm8
  .byte  102,65,15,58,33,208,32              // insertps      $0x20,%xmm8,%xmm2
  .byte  243,69,15,16,4,128                  // movss         (%r8,%rax,4),%xmm8
  .byte  102,65,15,58,33,208,48              // insertps      $0x30,%xmm8,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_a_sse41
.globl _sk_table_a_sse41
FUNCTION(_sk_table_a_sse41)
_sk_table_a_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,192,0                 // pshufd        $0x0,%xmm8,%xmm8
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,203                        // maxps         %xmm3,%xmm9
  .byte  68,15,93,13,241,194,1,0             // minps         0x1c2f1(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  102,65,15,91,217                    // cvtps2dq      %xmm9,%xmm3
  .byte  102,72,15,58,22,216,1               // pextrq        $0x1,%xmm3,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,218                   // movq          %xmm3,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  243,67,15,16,28,152                 // movss         (%r8,%r11,4),%xmm3
  .byte  102,67,15,58,33,28,144,16           // insertps      $0x10,(%r8,%r10,4),%xmm3
  .byte  243,71,15,16,4,136                  // movss         (%r8,%r9,4),%xmm8
  .byte  102,65,15,58,33,216,32              // insertps      $0x20,%xmm8,%xmm3
  .byte  243,69,15,16,4,128                  // movss         (%r8,%rax,4),%xmm8
  .byte  102,65,15,58,33,216,48              // insertps      $0x30,%xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_r_sse41
.globl _sk_parametric_r_sse41
FUNCTION(_sk_parametric_r_sse41)
_sk_parametric_r_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,16                  // movss         0x10(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  243,68,15,16,72,12                  // movss         0xc(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  243,68,15,16,80,4                   // movss         0x4(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  68,15,89,208                        // mulps         %xmm0,%xmm10
  .byte  65,15,194,192,2                     // cmpleps       %xmm8,%xmm0
  .byte  243,68,15,16,64,24                  // movss         0x18(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  69,15,88,200                        // addps         %xmm8,%xmm9
  .byte  243,68,15,16,32                     // movss         (%rax),%xmm12
  .byte  243,68,15,16,64,8                   // movss         0x8(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  69,15,88,208                        // addps         %xmm8,%xmm10
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  69,15,91,194                        // cvtdq2ps      %xmm10,%xmm8
  .byte  68,15,89,5,234,196,1,0              // mulps         0x1c4ea(%rip),%xmm8        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  68,15,40,45,242,196,1,0             // movaps        0x1c4f2(%rip),%xmm13        # 3ae10 <_sk_srcover_bgra_8888_sse2_lowp+0xea8>
  .byte  69,15,84,234                        // andps         %xmm10,%xmm13
  .byte  68,15,86,45,22,194,1,0              // orps          0x1c216(%rip),%xmm13        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,88,5,238,196,1,0              // addps         0x1c4ee(%rip),%xmm8        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  68,15,40,53,246,196,1,0             // movaps        0x1c4f6(%rip),%xmm14        # 3ae30 <_sk_srcover_bgra_8888_sse2_lowp+0xec8>
  .byte  69,15,89,245                        // mulps         %xmm13,%xmm14
  .byte  69,15,92,198                        // subps         %xmm14,%xmm8
  .byte  68,15,88,45,246,196,1,0             // addps         0x1c4f6(%rip),%xmm13        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  68,15,40,53,254,196,1,0             // movaps        0x1c4fe(%rip),%xmm14        # 3ae50 <_sk_srcover_bgra_8888_sse2_lowp+0xee8>
  .byte  69,15,94,245                        // divps         %xmm13,%xmm14
  .byte  69,15,92,198                        // subps         %xmm14,%xmm8
  .byte  69,15,89,196                        // mulps         %xmm12,%xmm8
  .byte  102,69,15,58,8,224,1                // roundps       $0x1,%xmm8,%xmm12
  .byte  69,15,40,232                        // movaps        %xmm8,%xmm13
  .byte  69,15,92,236                        // subps         %xmm12,%xmm13
  .byte  68,15,88,5,235,196,1,0              // addps         0x1c4eb(%rip),%xmm8        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  68,15,40,37,243,196,1,0             // movaps        0x1c4f3(%rip),%xmm12        # 3ae70 <_sk_srcover_bgra_8888_sse2_lowp+0xf08>
  .byte  69,15,89,229                        // mulps         %xmm13,%xmm12
  .byte  69,15,92,196                        // subps         %xmm12,%xmm8
  .byte  68,15,40,37,243,196,1,0             // movaps        0x1c4f3(%rip),%xmm12        # 3ae80 <_sk_srcover_bgra_8888_sse2_lowp+0xf18>
  .byte  69,15,92,229                        // subps         %xmm13,%xmm12
  .byte  68,15,40,45,247,196,1,0             // movaps        0x1c4f7(%rip),%xmm13        # 3ae90 <_sk_srcover_bgra_8888_sse2_lowp+0xf28>
  .byte  69,15,94,236                        // divps         %xmm12,%xmm13
  .byte  69,15,88,232                        // addps         %xmm8,%xmm13
  .byte  68,15,89,45,247,196,1,0             // mulps         0x1c4f7(%rip),%xmm13        # 3aea0 <_sk_srcover_bgra_8888_sse2_lowp+0xf38>
  .byte  102,69,15,91,197                    // cvtps2dq      %xmm13,%xmm8
  .byte  69,15,194,211,4                     // cmpneqps      %xmm11,%xmm10
  .byte  69,15,84,208                        // andps         %xmm8,%xmm10
  .byte  243,68,15,16,64,20                  // movss         0x14(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  69,15,88,194                        // addps         %xmm10,%xmm8
  .byte  102,69,15,56,20,193                 // blendvps      %xmm0,%xmm9,%xmm8
  .byte  69,15,95,195                        // maxps         %xmm11,%xmm8
  .byte  68,15,93,5,120,193,1,0              // minps         0x1c178(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_g_sse41
.globl _sk_parametric_g_sse41
FUNCTION(_sk_parametric_g_sse41)
_sk_parametric_g_sse41:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,88,16                  // movss         0x10(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,72,12                  // movss         0xc(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  243,68,15,16,80,4                   // movss         0x4(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  68,15,89,209                        // mulps         %xmm1,%xmm10
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  65,15,194,195,2                     // cmpleps       %xmm11,%xmm0
  .byte  243,15,16,72,24                     // movss         0x18(%rax),%xmm1
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  68,15,88,201                        // addps         %xmm1,%xmm9
  .byte  243,68,15,16,32                     // movss         (%rax),%xmm12
  .byte  243,15,16,72,8                      // movss         0x8(%rax),%xmm1
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  68,15,88,209                        // addps         %xmm1,%xmm10
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  69,15,91,242                        // cvtdq2ps      %xmm10,%xmm14
  .byte  68,15,89,53,181,195,1,0             // mulps         0x1c3b5(%rip),%xmm14        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  68,15,40,45,189,195,1,0             // movaps        0x1c3bd(%rip),%xmm13        # 3ae10 <_sk_srcover_bgra_8888_sse2_lowp+0xea8>
  .byte  69,15,84,234                        // andps         %xmm10,%xmm13
  .byte  68,15,86,45,225,192,1,0             // orps          0x1c0e1(%rip),%xmm13        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,88,53,185,195,1,0             // addps         0x1c3b9(%rip),%xmm14        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  15,40,13,194,195,1,0                // movaps        0x1c3c2(%rip),%xmm1        # 3ae30 <_sk_srcover_bgra_8888_sse2_lowp+0xec8>
  .byte  65,15,89,205                        // mulps         %xmm13,%xmm1
  .byte  68,15,92,241                        // subps         %xmm1,%xmm14
  .byte  68,15,88,45,194,195,1,0             // addps         0x1c3c2(%rip),%xmm13        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  15,40,13,203,195,1,0                // movaps        0x1c3cb(%rip),%xmm1        # 3ae50 <_sk_srcover_bgra_8888_sse2_lowp+0xee8>
  .byte  65,15,94,205                        // divps         %xmm13,%xmm1
  .byte  68,15,92,241                        // subps         %xmm1,%xmm14
  .byte  69,15,89,244                        // mulps         %xmm12,%xmm14
  .byte  102,69,15,58,8,230,1                // roundps       $0x1,%xmm14,%xmm12
  .byte  69,15,40,238                        // movaps        %xmm14,%xmm13
  .byte  69,15,92,236                        // subps         %xmm12,%xmm13
  .byte  68,15,88,53,184,195,1,0             // addps         0x1c3b8(%rip),%xmm14        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  15,40,13,193,195,1,0                // movaps        0x1c3c1(%rip),%xmm1        # 3ae70 <_sk_srcover_bgra_8888_sse2_lowp+0xf08>
  .byte  65,15,89,205                        // mulps         %xmm13,%xmm1
  .byte  68,15,92,241                        // subps         %xmm1,%xmm14
  .byte  68,15,40,37,193,195,1,0             // movaps        0x1c3c1(%rip),%xmm12        # 3ae80 <_sk_srcover_bgra_8888_sse2_lowp+0xf18>
  .byte  69,15,92,229                        // subps         %xmm13,%xmm12
  .byte  15,40,13,198,195,1,0                // movaps        0x1c3c6(%rip),%xmm1        # 3ae90 <_sk_srcover_bgra_8888_sse2_lowp+0xf28>
  .byte  65,15,94,204                        // divps         %xmm12,%xmm1
  .byte  65,15,88,206                        // addps         %xmm14,%xmm1
  .byte  15,89,13,199,195,1,0                // mulps         0x1c3c7(%rip),%xmm1        # 3aea0 <_sk_srcover_bgra_8888_sse2_lowp+0xf38>
  .byte  102,15,91,201                       // cvtps2dq      %xmm1,%xmm1
  .byte  69,15,194,211,4                     // cmpneqps      %xmm11,%xmm10
  .byte  68,15,84,209                        // andps         %xmm1,%xmm10
  .byte  243,15,16,72,20                     // movss         0x14(%rax),%xmm1
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  102,65,15,56,20,201                 // blendvps      %xmm0,%xmm9,%xmm1
  .byte  65,15,95,203                        // maxps         %xmm11,%xmm1
  .byte  15,93,13,76,192,1,0                 // minps         0x1c04c(%rip),%xmm1        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_b_sse41
.globl _sk_parametric_b_sse41
FUNCTION(_sk_parametric_b_sse41)
_sk_parametric_b_sse41:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,88,16                  // movss         0x10(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,72,12                  // movss         0xc(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,202                        // mulps         %xmm2,%xmm9
  .byte  243,68,15,16,80,4                   // movss         0x4(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  65,15,194,195,2                     // cmpleps       %xmm11,%xmm0
  .byte  243,15,16,80,24                     // movss         0x18(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  68,15,88,202                        // addps         %xmm2,%xmm9
  .byte  243,68,15,16,32                     // movss         (%rax),%xmm12
  .byte  243,15,16,80,8                      // movss         0x8(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  68,15,88,210                        // addps         %xmm2,%xmm10
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  69,15,91,242                        // cvtdq2ps      %xmm10,%xmm14
  .byte  68,15,89,53,137,194,1,0             // mulps         0x1c289(%rip),%xmm14        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  68,15,40,45,145,194,1,0             // movaps        0x1c291(%rip),%xmm13        # 3ae10 <_sk_srcover_bgra_8888_sse2_lowp+0xea8>
  .byte  69,15,84,234                        // andps         %xmm10,%xmm13
  .byte  68,15,86,45,181,191,1,0             // orps          0x1bfb5(%rip),%xmm13        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,88,53,141,194,1,0             // addps         0x1c28d(%rip),%xmm14        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  15,40,21,150,194,1,0                // movaps        0x1c296(%rip),%xmm2        # 3ae30 <_sk_srcover_bgra_8888_sse2_lowp+0xec8>
  .byte  65,15,89,213                        // mulps         %xmm13,%xmm2
  .byte  68,15,92,242                        // subps         %xmm2,%xmm14
  .byte  68,15,88,45,150,194,1,0             // addps         0x1c296(%rip),%xmm13        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  15,40,21,159,194,1,0                // movaps        0x1c29f(%rip),%xmm2        # 3ae50 <_sk_srcover_bgra_8888_sse2_lowp+0xee8>
  .byte  65,15,94,213                        // divps         %xmm13,%xmm2
  .byte  68,15,92,242                        // subps         %xmm2,%xmm14
  .byte  69,15,89,244                        // mulps         %xmm12,%xmm14
  .byte  102,69,15,58,8,230,1                // roundps       $0x1,%xmm14,%xmm12
  .byte  69,15,40,238                        // movaps        %xmm14,%xmm13
  .byte  69,15,92,236                        // subps         %xmm12,%xmm13
  .byte  68,15,88,53,140,194,1,0             // addps         0x1c28c(%rip),%xmm14        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  15,40,21,149,194,1,0                // movaps        0x1c295(%rip),%xmm2        # 3ae70 <_sk_srcover_bgra_8888_sse2_lowp+0xf08>
  .byte  65,15,89,213                        // mulps         %xmm13,%xmm2
  .byte  68,15,92,242                        // subps         %xmm2,%xmm14
  .byte  68,15,40,37,149,194,1,0             // movaps        0x1c295(%rip),%xmm12        # 3ae80 <_sk_srcover_bgra_8888_sse2_lowp+0xf18>
  .byte  69,15,92,229                        // subps         %xmm13,%xmm12
  .byte  15,40,21,154,194,1,0                // movaps        0x1c29a(%rip),%xmm2        # 3ae90 <_sk_srcover_bgra_8888_sse2_lowp+0xf28>
  .byte  65,15,94,212                        // divps         %xmm12,%xmm2
  .byte  65,15,88,214                        // addps         %xmm14,%xmm2
  .byte  15,89,21,155,194,1,0                // mulps         0x1c29b(%rip),%xmm2        # 3aea0 <_sk_srcover_bgra_8888_sse2_lowp+0xf38>
  .byte  102,15,91,210                       // cvtps2dq      %xmm2,%xmm2
  .byte  69,15,194,211,4                     // cmpneqps      %xmm11,%xmm10
  .byte  68,15,84,210                        // andps         %xmm2,%xmm10
  .byte  243,15,16,80,20                     // movss         0x14(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  65,15,88,210                        // addps         %xmm10,%xmm2
  .byte  102,65,15,56,20,209                 // blendvps      %xmm0,%xmm9,%xmm2
  .byte  65,15,95,211                        // maxps         %xmm11,%xmm2
  .byte  15,93,21,32,191,1,0                 // minps         0x1bf20(%rip),%xmm2        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_a_sse41
.globl _sk_parametric_a_sse41
FUNCTION(_sk_parametric_a_sse41)
_sk_parametric_a_sse41:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,88,16                  // movss         0x10(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,72,12                  // movss         0xc(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,203                        // mulps         %xmm3,%xmm9
  .byte  243,68,15,16,80,4                   // movss         0x4(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  68,15,89,211                        // mulps         %xmm3,%xmm10
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  65,15,194,195,2                     // cmpleps       %xmm11,%xmm0
  .byte  243,15,16,88,24                     // movss         0x18(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  68,15,88,203                        // addps         %xmm3,%xmm9
  .byte  243,68,15,16,32                     // movss         (%rax),%xmm12
  .byte  243,15,16,88,8                      // movss         0x8(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  68,15,88,211                        // addps         %xmm3,%xmm10
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  69,15,91,242                        // cvtdq2ps      %xmm10,%xmm14
  .byte  68,15,89,53,93,193,1,0              // mulps         0x1c15d(%rip),%xmm14        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  68,15,40,45,101,193,1,0             // movaps        0x1c165(%rip),%xmm13        # 3ae10 <_sk_srcover_bgra_8888_sse2_lowp+0xea8>
  .byte  69,15,84,234                        // andps         %xmm10,%xmm13
  .byte  68,15,86,45,137,190,1,0             // orps          0x1be89(%rip),%xmm13        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,88,53,97,193,1,0              // addps         0x1c161(%rip),%xmm14        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  15,40,29,106,193,1,0                // movaps        0x1c16a(%rip),%xmm3        # 3ae30 <_sk_srcover_bgra_8888_sse2_lowp+0xec8>
  .byte  65,15,89,221                        // mulps         %xmm13,%xmm3
  .byte  68,15,92,243                        // subps         %xmm3,%xmm14
  .byte  68,15,88,45,106,193,1,0             // addps         0x1c16a(%rip),%xmm13        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  15,40,29,115,193,1,0                // movaps        0x1c173(%rip),%xmm3        # 3ae50 <_sk_srcover_bgra_8888_sse2_lowp+0xee8>
  .byte  65,15,94,221                        // divps         %xmm13,%xmm3
  .byte  68,15,92,243                        // subps         %xmm3,%xmm14
  .byte  69,15,89,244                        // mulps         %xmm12,%xmm14
  .byte  102,69,15,58,8,230,1                // roundps       $0x1,%xmm14,%xmm12
  .byte  69,15,40,238                        // movaps        %xmm14,%xmm13
  .byte  69,15,92,236                        // subps         %xmm12,%xmm13
  .byte  68,15,88,53,96,193,1,0              // addps         0x1c160(%rip),%xmm14        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  15,40,29,105,193,1,0                // movaps        0x1c169(%rip),%xmm3        # 3ae70 <_sk_srcover_bgra_8888_sse2_lowp+0xf08>
  .byte  65,15,89,221                        // mulps         %xmm13,%xmm3
  .byte  68,15,92,243                        // subps         %xmm3,%xmm14
  .byte  68,15,40,37,105,193,1,0             // movaps        0x1c169(%rip),%xmm12        # 3ae80 <_sk_srcover_bgra_8888_sse2_lowp+0xf18>
  .byte  69,15,92,229                        // subps         %xmm13,%xmm12
  .byte  15,40,29,110,193,1,0                // movaps        0x1c16e(%rip),%xmm3        # 3ae90 <_sk_srcover_bgra_8888_sse2_lowp+0xf28>
  .byte  65,15,94,220                        // divps         %xmm12,%xmm3
  .byte  65,15,88,222                        // addps         %xmm14,%xmm3
  .byte  15,89,29,111,193,1,0                // mulps         0x1c16f(%rip),%xmm3        # 3aea0 <_sk_srcover_bgra_8888_sse2_lowp+0xf38>
  .byte  102,15,91,219                       // cvtps2dq      %xmm3,%xmm3
  .byte  69,15,194,211,4                     // cmpneqps      %xmm11,%xmm10
  .byte  68,15,84,211                        // andps         %xmm3,%xmm10
  .byte  243,15,16,88,20                     // movss         0x14(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  65,15,88,218                        // addps         %xmm10,%xmm3
  .byte  102,65,15,56,20,217                 // blendvps      %xmm0,%xmm9,%xmm3
  .byte  65,15,95,219                        // maxps         %xmm11,%xmm3
  .byte  15,93,29,244,189,1,0                // minps         0x1bdf4(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gamma_sse41
.globl _sk_gamma_sse41
FUNCTION(_sk_gamma_sse41)
_sk_gamma_sse41:
  .byte  15,41,124,36,232                    // movaps        %xmm7,-0x18(%rsp)
  .byte  15,41,116,36,216                    // movaps        %xmm6,-0x28(%rsp)
  .byte  15,41,108,36,200                    // movaps        %xmm5,-0x38(%rsp)
  .byte  15,41,100,36,184                    // movaps        %xmm4,-0x48(%rsp)
  .byte  15,41,92,36,168                     // movaps        %xmm3,-0x58(%rsp)
  .byte  68,15,40,226                        // movaps        %xmm2,%xmm12
  .byte  68,15,40,209                        // movaps        %xmm1,%xmm10
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,91,244                           // cvtdq2ps      %xmm4,%xmm6
  .byte  15,40,5,110,192,1,0                 // movaps        0x1c06e(%rip),%xmm0        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  15,89,240                           // mulps         %xmm0,%xmm6
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  68,15,40,5,112,192,1,0              // movaps        0x1c070(%rip),%xmm8        # 3ae10 <_sk_srcover_bgra_8888_sse2_lowp+0xea8>
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  65,15,84,192                        // andps         %xmm8,%xmm0
  .byte  15,86,5,146,189,1,0                 // orps          0x1bd92(%rip),%xmm0        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,88,53,107,192,1,0                // addps         0x1c06b(%rip),%xmm6        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  68,15,40,29,115,192,1,0             // movaps        0x1c073(%rip),%xmm11        # 3ae30 <_sk_srcover_bgra_8888_sse2_lowp+0xec8>
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  15,92,241                           // subps         %xmm1,%xmm6
  .byte  68,15,40,61,113,192,1,0             // movaps        0x1c071(%rip),%xmm15        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  65,15,88,199                        // addps         %xmm15,%xmm0
  .byte  68,15,40,53,117,192,1,0             // movaps        0x1c075(%rip),%xmm14        # 3ae50 <_sk_srcover_bgra_8888_sse2_lowp+0xee8>
  .byte  65,15,40,206                        // movaps        %xmm14,%xmm1
  .byte  15,94,200                           // divps         %xmm0,%xmm1
  .byte  15,92,241                           // subps         %xmm1,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,16                        // movss         (%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,89,242                           // mulps         %xmm2,%xmm6
  .byte  102,15,58,8,198,1                   // roundps       $0x1,%xmm6,%xmm0
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,88,53,91,192,1,0                 // addps         0x1c05b(%rip),%xmm6        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  15,40,29,116,192,1,0                // movaps        0x1c074(%rip),%xmm3        # 3ae80 <_sk_srcover_bgra_8888_sse2_lowp+0xf18>
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,92,201                        // subps         %xmm1,%xmm9
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,40,13,82,192,1,0                 // movaps        0x1c052(%rip),%xmm1        # 3ae70 <_sk_srcover_bgra_8888_sse2_lowp+0xf08>
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,92,240                           // subps         %xmm0,%xmm6
  .byte  68,15,40,45,100,192,1,0             // movaps        0x1c064(%rip),%xmm13        # 3ae90 <_sk_srcover_bgra_8888_sse2_lowp+0xf28>
  .byte  65,15,40,197                        // movaps        %xmm13,%xmm0
  .byte  65,15,94,193                        // divps         %xmm9,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  68,15,40,13,97,192,1,0              // movaps        0x1c061(%rip),%xmm9        # 3aea0 <_sk_srcover_bgra_8888_sse2_lowp+0xf38>
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  102,15,91,192                       // cvtps2dq      %xmm0,%xmm0
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,194,230,4                        // cmpneqps      %xmm6,%xmm4
  .byte  15,84,224                           // andps         %xmm0,%xmm4
  .byte  65,15,91,194                        // cvtdq2ps      %xmm10,%xmm0
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  65,15,40,250                        // movaps        %xmm10,%xmm7
  .byte  65,15,84,248                        // andps         %xmm8,%xmm7
  .byte  15,40,53,217,188,1,0                // movaps        0x1bcd9(%rip),%xmm6        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,86,254                           // orps          %xmm6,%xmm7
  .byte  15,88,5,175,191,1,0                 // addps         0x1bfaf(%rip),%xmm0        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  15,40,239                           // movaps        %xmm7,%xmm5
  .byte  65,15,89,235                        // mulps         %xmm11,%xmm5
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  65,15,88,255                        // addps         %xmm15,%xmm7
  .byte  65,15,40,238                        // movaps        %xmm14,%xmm5
  .byte  15,94,239                           // divps         %xmm7,%xmm5
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  102,15,58,8,232,1                   // roundps       $0x1,%xmm0,%xmm5
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  15,92,253                           // subps         %xmm5,%xmm7
  .byte  68,15,40,61,192,191,1,0             // movaps        0x1bfc0(%rip),%xmm15        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  65,15,88,199                        // addps         %xmm15,%xmm0
  .byte  15,40,235                           // movaps        %xmm3,%xmm5
  .byte  15,92,239                           // subps         %xmm7,%xmm5
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  15,92,199                           // subps         %xmm7,%xmm0
  .byte  65,15,40,253                        // movaps        %xmm13,%xmm7
  .byte  15,94,253                           // divps         %xmm5,%xmm7
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  65,15,89,249                        // mulps         %xmm9,%xmm7
  .byte  102,15,91,199                       // cvtps2dq      %xmm7,%xmm0
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  68,15,194,215,4                     // cmpneqps      %xmm7,%xmm10
  .byte  68,15,84,208                        // andps         %xmm0,%xmm10
  .byte  65,15,91,196                        // cvtdq2ps      %xmm12,%xmm0
  .byte  15,89,5,39,191,1,0                  // mulps         0x1bf27(%rip),%xmm0        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  69,15,84,196                        // andps         %xmm12,%xmm8
  .byte  68,15,86,198                        // orps          %xmm6,%xmm8
  .byte  15,88,5,56,191,1,0                  // addps         0x1bf38(%rip),%xmm0        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  65,15,92,195                        // subps         %xmm11,%xmm0
  .byte  68,15,88,5,72,191,1,0               // addps         0x1bf48(%rip),%xmm8        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  69,15,94,240                        // divps         %xmm8,%xmm14
  .byte  65,15,92,198                        // subps         %xmm14,%xmm0
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  102,15,58,8,208,1                   // roundps       $0x1,%xmm0,%xmm2
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  15,92,234                           // subps         %xmm2,%xmm5
  .byte  65,15,88,199                        // addps         %xmm15,%xmm0
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,92,221                           // subps         %xmm5,%xmm3
  .byte  68,15,94,235                        // divps         %xmm3,%xmm13
  .byte  68,15,88,232                        // addps         %xmm0,%xmm13
  .byte  69,15,89,233                        // mulps         %xmm9,%xmm13
  .byte  68,15,194,231,4                     // cmpneqps      %xmm7,%xmm12
  .byte  102,65,15,91,197                    // cvtps2dq      %xmm13,%xmm0
  .byte  68,15,84,224                        // andps         %xmm0,%xmm12
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  65,15,40,202                        // movaps        %xmm10,%xmm1
  .byte  65,15,40,212                        // movaps        %xmm12,%xmm2
  .byte  15,40,92,36,168                     // movaps        -0x58(%rsp),%xmm3
  .byte  15,40,100,36,184                    // movaps        -0x48(%rsp),%xmm4
  .byte  15,40,108,36,200                    // movaps        -0x38(%rsp),%xmm5
  .byte  15,40,116,36,216                    // movaps        -0x28(%rsp),%xmm6
  .byte  15,40,124,36,232                    // movaps        -0x18(%rsp),%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gamma_dst_sse41
.globl _sk_gamma_dst_sse41
FUNCTION(_sk_gamma_dst_sse41)
_sk_gamma_dst_sse41:
  .byte  15,41,124,36,232                    // movaps        %xmm7,-0x18(%rsp)
  .byte  68,15,40,230                        // movaps        %xmm6,%xmm12
  .byte  68,15,40,213                        // movaps        %xmm5,%xmm10
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,41,92,36,216                     // movaps        %xmm3,-0x28(%rsp)
  .byte  15,41,84,36,200                     // movaps        %xmm2,-0x38(%rsp)
  .byte  15,41,76,36,184                     // movaps        %xmm1,-0x48(%rsp)
  .byte  15,41,68,36,168                     // movaps        %xmm0,-0x58(%rsp)
  .byte  15,91,221                           // cvtdq2ps      %xmm5,%xmm3
  .byte  15,40,5,116,190,1,0                 // movaps        0x1be74(%rip),%xmm0        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  68,15,40,5,118,190,1,0              // movaps        0x1be76(%rip),%xmm8        # 3ae10 <_sk_srcover_bgra_8888_sse2_lowp+0xea8>
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  65,15,84,192                        // andps         %xmm8,%xmm0
  .byte  15,86,5,152,187,1,0                 // orps          0x1bb98(%rip),%xmm0        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,88,29,113,190,1,0                // addps         0x1be71(%rip),%xmm3        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  68,15,40,29,121,190,1,0             // movaps        0x1be79(%rip),%xmm11        # 3ae30 <_sk_srcover_bgra_8888_sse2_lowp+0xec8>
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  15,92,217                           // subps         %xmm1,%xmm3
  .byte  68,15,40,61,119,190,1,0             // movaps        0x1be77(%rip),%xmm15        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  65,15,88,199                        // addps         %xmm15,%xmm0
  .byte  68,15,40,53,123,190,1,0             // movaps        0x1be7b(%rip),%xmm14        # 3ae50 <_sk_srcover_bgra_8888_sse2_lowp+0xee8>
  .byte  65,15,40,206                        // movaps        %xmm14,%xmm1
  .byte  15,94,200                           // divps         %xmm0,%xmm1
  .byte  15,92,217                           // subps         %xmm1,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,16                        // movss         (%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,89,218                           // mulps         %xmm2,%xmm3
  .byte  102,15,58,8,195,1                   // roundps       $0x1,%xmm3,%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,88,29,97,190,1,0                 // addps         0x1be61(%rip),%xmm3        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  15,40,37,122,190,1,0                // movaps        0x1be7a(%rip),%xmm4        # 3ae80 <_sk_srcover_bgra_8888_sse2_lowp+0xf18>
  .byte  68,15,40,204                        // movaps        %xmm4,%xmm9
  .byte  68,15,92,201                        // subps         %xmm1,%xmm9
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,40,13,88,190,1,0                 // movaps        0x1be58(%rip),%xmm1        # 3ae70 <_sk_srcover_bgra_8888_sse2_lowp+0xf08>
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,92,216                           // subps         %xmm0,%xmm3
  .byte  68,15,40,45,106,190,1,0             // movaps        0x1be6a(%rip),%xmm13        # 3ae90 <_sk_srcover_bgra_8888_sse2_lowp+0xf28>
  .byte  65,15,40,197                        // movaps        %xmm13,%xmm0
  .byte  65,15,94,193                        // divps         %xmm9,%xmm0
  .byte  15,88,195                           // addps         %xmm3,%xmm0
  .byte  68,15,40,13,103,190,1,0             // movaps        0x1be67(%rip),%xmm9        # 3aea0 <_sk_srcover_bgra_8888_sse2_lowp+0xf38>
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  102,15,91,192                       // cvtps2dq      %xmm0,%xmm0
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,194,235,4                        // cmpneqps      %xmm3,%xmm5
  .byte  15,84,232                           // andps         %xmm0,%xmm5
  .byte  65,15,91,194                        // cvtdq2ps      %xmm10,%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  65,15,40,250                        // movaps        %xmm10,%xmm7
  .byte  65,15,84,248                        // andps         %xmm8,%xmm7
  .byte  15,40,29,223,186,1,0                // movaps        0x1badf(%rip),%xmm3        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,86,251                           // orps          %xmm3,%xmm7
  .byte  15,88,5,181,189,1,0                 // addps         0x1bdb5(%rip),%xmm0        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  15,40,247                           // movaps        %xmm7,%xmm6
  .byte  65,15,89,243                        // mulps         %xmm11,%xmm6
  .byte  15,92,198                           // subps         %xmm6,%xmm0
  .byte  65,15,88,255                        // addps         %xmm15,%xmm7
  .byte  65,15,40,246                        // movaps        %xmm14,%xmm6
  .byte  15,94,247                           // divps         %xmm7,%xmm6
  .byte  15,92,198                           // subps         %xmm6,%xmm0
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  102,15,58,8,240,1                   // roundps       $0x1,%xmm0,%xmm6
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  15,92,254                           // subps         %xmm6,%xmm7
  .byte  68,15,40,61,198,189,1,0             // movaps        0x1bdc6(%rip),%xmm15        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  65,15,88,199                        // addps         %xmm15,%xmm0
  .byte  15,40,244                           // movaps        %xmm4,%xmm6
  .byte  15,92,247                           // subps         %xmm7,%xmm6
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  15,92,199                           // subps         %xmm7,%xmm0
  .byte  65,15,40,253                        // movaps        %xmm13,%xmm7
  .byte  15,94,254                           // divps         %xmm6,%xmm7
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  65,15,89,249                        // mulps         %xmm9,%xmm7
  .byte  102,15,91,199                       // cvtps2dq      %xmm7,%xmm0
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  68,15,194,215,4                     // cmpneqps      %xmm7,%xmm10
  .byte  68,15,84,208                        // andps         %xmm0,%xmm10
  .byte  65,15,91,196                        // cvtdq2ps      %xmm12,%xmm0
  .byte  15,89,5,45,189,1,0                  // mulps         0x1bd2d(%rip),%xmm0        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  69,15,84,196                        // andps         %xmm12,%xmm8
  .byte  68,15,86,195                        // orps          %xmm3,%xmm8
  .byte  15,88,5,62,189,1,0                  // addps         0x1bd3e(%rip),%xmm0        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  65,15,92,195                        // subps         %xmm11,%xmm0
  .byte  68,15,88,5,78,189,1,0               // addps         0x1bd4e(%rip),%xmm8        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  69,15,94,240                        // divps         %xmm8,%xmm14
  .byte  65,15,92,198                        // subps         %xmm14,%xmm0
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  102,15,58,8,208,1                   // roundps       $0x1,%xmm0,%xmm2
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,92,242                           // subps         %xmm2,%xmm6
  .byte  65,15,88,199                        // addps         %xmm15,%xmm0
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,92,230                           // subps         %xmm6,%xmm4
  .byte  68,15,94,236                        // divps         %xmm4,%xmm13
  .byte  68,15,88,232                        // addps         %xmm0,%xmm13
  .byte  69,15,89,233                        // mulps         %xmm9,%xmm13
  .byte  68,15,194,231,4                     // cmpneqps      %xmm7,%xmm12
  .byte  102,65,15,91,197                    // cvtps2dq      %xmm13,%xmm0
  .byte  68,15,84,224                        // andps         %xmm0,%xmm12
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,68,36,168                     // movaps        -0x58(%rsp),%xmm0
  .byte  15,40,76,36,184                     // movaps        -0x48(%rsp),%xmm1
  .byte  15,40,84,36,200                     // movaps        -0x38(%rsp),%xmm2
  .byte  15,40,92,36,216                     // movaps        -0x28(%rsp),%xmm3
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  65,15,40,234                        // movaps        %xmm10,%xmm5
  .byte  65,15,40,244                        // movaps        %xmm12,%xmm6
  .byte  15,40,124,36,232                    // movaps        -0x18(%rsp),%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lab_to_xyz_sse41
.globl _sk_lab_to_xyz_sse41
FUNCTION(_sk_lab_to_xyz_sse41)
_sk_lab_to_xyz_sse41:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  68,15,89,5,76,189,1,0               // mulps         0x1bd4c(%rip),%xmm8        # 3aeb0 <_sk_srcover_bgra_8888_sse2_lowp+0xf48>
  .byte  68,15,40,13,196,186,1,0             // movaps        0x1bac4(%rip),%xmm9        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  65,15,89,201                        // mulps         %xmm9,%xmm1
  .byte  15,40,5,73,189,1,0                  // movaps        0x1bd49(%rip),%xmm0        # 3aec0 <_sk_srcover_bgra_8888_sse2_lowp+0xf58>
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  68,15,88,5,71,189,1,0               // addps         0x1bd47(%rip),%xmm8        # 3aed0 <_sk_srcover_bgra_8888_sse2_lowp+0xf68>
  .byte  68,15,89,5,79,189,1,0               // mulps         0x1bd4f(%rip),%xmm8        # 3aee0 <_sk_srcover_bgra_8888_sse2_lowp+0xf78>
  .byte  15,89,13,88,189,1,0                 // mulps         0x1bd58(%rip),%xmm1        # 3aef0 <_sk_srcover_bgra_8888_sse2_lowp+0xf88>
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  15,89,21,93,189,1,0                 // mulps         0x1bd5d(%rip),%xmm2        # 3af00 <_sk_srcover_bgra_8888_sse2_lowp+0xf98>
  .byte  69,15,40,208                        // movaps        %xmm8,%xmm10
  .byte  68,15,92,210                        // subps         %xmm2,%xmm10
  .byte  68,15,40,217                        // movaps        %xmm1,%xmm11
  .byte  69,15,89,219                        // mulps         %xmm11,%xmm11
  .byte  68,15,89,217                        // mulps         %xmm1,%xmm11
  .byte  68,15,40,13,81,189,1,0              // movaps        0x1bd51(%rip),%xmm9        # 3af10 <_sk_srcover_bgra_8888_sse2_lowp+0xfa8>
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,194,195,1                     // cmpltps       %xmm11,%xmm0
  .byte  15,40,21,81,189,1,0                 // movaps        0x1bd51(%rip),%xmm2        # 3af20 <_sk_srcover_bgra_8888_sse2_lowp+0xfb8>
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  68,15,40,37,86,189,1,0              // movaps        0x1bd56(%rip),%xmm12        # 3af30 <_sk_srcover_bgra_8888_sse2_lowp+0xfc8>
  .byte  65,15,89,204                        // mulps         %xmm12,%xmm1
  .byte  102,65,15,56,20,203                 // blendvps      %xmm0,%xmm11,%xmm1
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  69,15,89,219                        // mulps         %xmm11,%xmm11
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,194,195,1                     // cmpltps       %xmm11,%xmm0
  .byte  68,15,88,194                        // addps         %xmm2,%xmm8
  .byte  69,15,89,196                        // mulps         %xmm12,%xmm8
  .byte  102,69,15,56,20,195                 // blendvps      %xmm0,%xmm11,%xmm8
  .byte  69,15,40,218                        // movaps        %xmm10,%xmm11
  .byte  69,15,89,219                        // mulps         %xmm11,%xmm11
  .byte  69,15,89,218                        // mulps         %xmm10,%xmm11
  .byte  69,15,194,203,1                     // cmpltps       %xmm11,%xmm9
  .byte  65,15,88,210                        // addps         %xmm10,%xmm2
  .byte  65,15,89,212                        // mulps         %xmm12,%xmm2
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,65,15,56,20,211                 // blendvps      %xmm0,%xmm11,%xmm2
  .byte  15,89,13,15,189,1,0                 // mulps         0x1bd0f(%rip),%xmm1        # 3af40 <_sk_srcover_bgra_8888_sse2_lowp+0xfd8>
  .byte  15,89,21,24,189,1,0                 // mulps         0x1bd18(%rip),%xmm2        # 3af50 <_sk_srcover_bgra_8888_sse2_lowp+0xfe8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_a8_sse41
.globl _sk_load_a8_sse41
FUNCTION(_sk_load_a8_sse41)
_sk_load_a8_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,39                              // jne           1f282 <_sk_load_a8_sse41+0x3f>
  .byte  102,67,15,56,49,4,16                // pmovzxbd      (%r8,%r10,1),%xmm0
  .byte  102,15,219,5,150,185,1,0            // pand          0x1b996(%rip),%xmm0        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  15,91,216                           // cvtdq2ps      %xmm0,%xmm3
  .byte  15,89,29,236,186,1,0                // mulps         0x1baec(%rip),%xmm3        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,53                              // je            1f2c4 <_sk_load_a8_sse41+0x81>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            1f2ae <_sk_load_a8_sse41+0x6b>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,195                             // jne           1f262 <_sk_load_a8_sse41+0x1f>
  .byte  67,15,182,68,16,2                   // movzbl        0x2(%r8,%r10,1),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,15,112,192,69                   // pshufd        $0x45,%xmm0,%xmm0
  .byte  67,15,183,4,16                      // movzwl        (%r8,%r10,1),%eax
  .byte  102,15,110,200                      // movd          %eax,%xmm1
  .byte  102,15,56,49,201                    // pmovzxbd      %xmm1,%xmm1
  .byte  102,15,58,14,193,15                 // pblendw       $0xf,%xmm1,%xmm0
  .byte  235,158                             // jmp           1f262 <_sk_load_a8_sse41+0x1f>
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  235,147                             // jmp           1f262 <_sk_load_a8_sse41+0x1f>

HIDDEN _sk_load_a8_dst_sse41
.globl _sk_load_a8_dst_sse41
FUNCTION(_sk_load_a8_dst_sse41)
_sk_load_a8_dst_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,39                              // jne           1f30e <_sk_load_a8_dst_sse41+0x3f>
  .byte  102,67,15,56,49,36,16               // pmovzxbd      (%r8,%r10,1),%xmm4
  .byte  102,15,219,37,10,185,1,0            // pand          0x1b90a(%rip),%xmm4        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  15,91,252                           // cvtdq2ps      %xmm4,%xmm7
  .byte  15,89,61,96,186,1,0                 // mulps         0x1ba60(%rip),%xmm7        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,53                              // je            1f350 <_sk_load_a8_dst_sse41+0x81>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            1f33a <_sk_load_a8_dst_sse41+0x6b>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,195                             // jne           1f2ee <_sk_load_a8_dst_sse41+0x1f>
  .byte  67,15,182,68,16,2                   // movzbl        0x2(%r8,%r10,1),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  102,15,112,228,69                   // pshufd        $0x45,%xmm4,%xmm4
  .byte  67,15,183,4,16                      // movzwl        (%r8,%r10,1),%eax
  .byte  102,15,110,232                      // movd          %eax,%xmm5
  .byte  102,15,56,49,237                    // pmovzxbd      %xmm5,%xmm5
  .byte  102,15,58,14,229,15                 // pblendw       $0xf,%xmm5,%xmm4
  .byte  235,158                             // jmp           1f2ee <_sk_load_a8_dst_sse41+0x1f>
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  235,147                             // jmp           1f2ee <_sk_load_a8_dst_sse41+0x1f>

HIDDEN _sk_gather_a8_sse41
.globl _sk_gather_a8_sse41
FUNCTION(_sk_gather_a8_sse41)
_sk_gather_a8_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,80,12                     // movss         0xc(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,69,15,118,192                   // pcmpeqd       %xmm8,%xmm8
  .byte  102,65,15,254,208                   // paddd         %xmm8,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,93,202                        // minps         %xmm2,%xmm9
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,192                   // paddd         %xmm8,%xmm0
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,56,64,200                    // pmulld        %xmm0,%xmm1
  .byte  243,65,15,91,193                    // cvttps2dq     %xmm9,%xmm0
  .byte  102,15,254,193                      // paddd         %xmm1,%xmm0
  .byte  102,72,15,58,22,192,1               // pextrq        $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,194                   // movq          %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  71,15,182,28,24                     // movzbl        (%r8,%r11,1),%r11d
  .byte  102,65,15,110,195                   // movd          %r11d,%xmm0
  .byte  102,65,15,58,32,194,1               // pinsrb        $0x1,%r10d,%xmm0
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  102,65,15,58,32,193,2               // pinsrb        $0x2,%r9d,%xmm0
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  102,15,58,32,192,3                  // pinsrb        $0x3,%eax,%xmm0
  .byte  102,15,56,49,192                    // pmovzxbd      %xmm0,%xmm0
  .byte  15,91,216                           // cvtdq2ps      %xmm0,%xmm3
  .byte  15,89,29,88,185,1,0                 // mulps         0x1b958(%rip),%xmm3        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_a8_sse41
.globl _sk_store_a8_sse41
FUNCTION(_sk_store_a8_sse41)
_sk_store_a8_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  68,15,95,195                        // maxps         %xmm3,%xmm8
  .byte  68,15,93,5,23,183,1,0               // minps         0x1b717(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,89,5,239,183,1,0              // mulps         0x1b7ef(%rip),%xmm8        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  102,69,15,91,192                    // cvtps2dq      %xmm8,%xmm8
  .byte  102,68,15,56,43,192                 // packusdw      %xmm0,%xmm8
  .byte  102,68,15,103,192                   // packuswb      %xmm0,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,13                              // jne           1f463 <_sk_store_a8_sse41+0x4d>
  .byte  102,68,15,126,192                   // movd          %xmm8,%eax
  .byte  67,137,4,16                         // mov           %eax,(%r8,%r10,1)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,56,49,192                 // pmovzxbd      %xmm8,%xmm8
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,41                              // je            1f49f <_sk_store_a8_sse41+0x89>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,15                              // je            1f48b <_sk_store_a8_sse41+0x75>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,221                             // jne           1f45f <_sk_store_a8_sse41+0x49>
  .byte  102,71,15,58,20,68,16,2,8           // pextrb        $0x8,%xmm8,0x2(%r8,%r10,1)
  .byte  102,68,15,56,0,5,203,186,1,0        // pshufb        0x1bacb(%rip),%xmm8        # 3af60 <_sk_srcover_bgra_8888_sse2_lowp+0xff8>
  .byte  102,71,15,58,21,4,16,0              // pextrw        $0x0,%xmm8,(%r8,%r10,1)
  .byte  235,192                             // jmp           1f45f <_sk_store_a8_sse41+0x49>
  .byte  102,71,15,58,20,4,16,0              // pextrb        $0x0,%xmm8,(%r8,%r10,1)
  .byte  235,182                             // jmp           1f45f <_sk_store_a8_sse41+0x49>

HIDDEN _sk_load_g8_sse41
.globl _sk_load_g8_sse41
FUNCTION(_sk_load_g8_sse41)
_sk_load_g8_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,42                              // jne           1f4eb <_sk_load_g8_sse41+0x42>
  .byte  102,67,15,56,49,4,16                // pmovzxbd      (%r8,%r10,1),%xmm0
  .byte  102,15,219,5,48,183,1,0             // pand          0x1b730(%rip),%xmm0        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,5,134,184,1,0                 // mulps         0x1b886(%rip),%xmm0        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,109,182,1,0                // movaps        0x1b66d(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,53                              // je            1f52d <_sk_load_g8_sse41+0x84>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            1f517 <_sk_load_g8_sse41+0x6e>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,192                             // jne           1f4c8 <_sk_load_g8_sse41+0x1f>
  .byte  67,15,182,68,16,2                   // movzbl        0x2(%r8,%r10,1),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,15,112,192,69                   // pshufd        $0x45,%xmm0,%xmm0
  .byte  67,15,183,4,16                      // movzwl        (%r8,%r10,1),%eax
  .byte  102,15,110,200                      // movd          %eax,%xmm1
  .byte  102,15,56,49,201                    // pmovzxbd      %xmm1,%xmm1
  .byte  102,15,58,14,193,15                 // pblendw       $0xf,%xmm1,%xmm0
  .byte  235,155                             // jmp           1f4c8 <_sk_load_g8_sse41+0x1f>
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  235,144                             // jmp           1f4c8 <_sk_load_g8_sse41+0x1f>

HIDDEN _sk_load_g8_dst_sse41
.globl _sk_load_g8_dst_sse41
FUNCTION(_sk_load_g8_dst_sse41)
_sk_load_g8_dst_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,42                              // jne           1f57a <_sk_load_g8_dst_sse41+0x42>
  .byte  102,67,15,56,49,36,16               // pmovzxbd      (%r8,%r10,1),%xmm4
  .byte  102,15,219,37,161,182,1,0           // pand          0x1b6a1(%rip),%xmm4        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,37,247,183,1,0                // mulps         0x1b7f7(%rip),%xmm4        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,61,222,181,1,0                // movaps        0x1b5de(%rip),%xmm7        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,40,244                           // movaps        %xmm4,%xmm6
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,53                              // je            1f5bc <_sk_load_g8_dst_sse41+0x84>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            1f5a6 <_sk_load_g8_dst_sse41+0x6e>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,192                             // jne           1f557 <_sk_load_g8_dst_sse41+0x1f>
  .byte  67,15,182,68,16,2                   // movzbl        0x2(%r8,%r10,1),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  102,15,112,228,69                   // pshufd        $0x45,%xmm4,%xmm4
  .byte  67,15,183,4,16                      // movzwl        (%r8,%r10,1),%eax
  .byte  102,15,110,232                      // movd          %eax,%xmm5
  .byte  102,15,56,49,237                    // pmovzxbd      %xmm5,%xmm5
  .byte  102,15,58,14,229,15                 // pblendw       $0xf,%xmm5,%xmm4
  .byte  235,155                             // jmp           1f557 <_sk_load_g8_dst_sse41+0x1f>
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  235,144                             // jmp           1f557 <_sk_load_g8_dst_sse41+0x1f>

HIDDEN _sk_gather_g8_sse41
.globl _sk_gather_g8_sse41
FUNCTION(_sk_gather_g8_sse41)
_sk_gather_g8_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,80,12                     // movss         0xc(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,69,15,118,192                   // pcmpeqd       %xmm8,%xmm8
  .byte  102,65,15,254,208                   // paddd         %xmm8,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,93,202                        // minps         %xmm2,%xmm9
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,192                   // paddd         %xmm8,%xmm0
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,56,64,200                    // pmulld        %xmm0,%xmm1
  .byte  243,65,15,91,193                    // cvttps2dq     %xmm9,%xmm0
  .byte  102,15,254,193                      // paddd         %xmm1,%xmm0
  .byte  102,72,15,58,22,192,1               // pextrq        $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,194                   // movq          %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  71,15,182,28,24                     // movzbl        (%r8,%r11,1),%r11d
  .byte  102,65,15,110,195                   // movd          %r11d,%xmm0
  .byte  102,65,15,58,32,194,1               // pinsrb        $0x1,%r10d,%xmm0
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  102,65,15,58,32,193,2               // pinsrb        $0x2,%r9d,%xmm0
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  102,15,58,32,192,3                  // pinsrb        $0x3,%eax,%xmm0
  .byte  102,15,56,49,192                    // pmovzxbd      %xmm0,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,5,236,182,1,0                 // mulps         0x1b6ec(%rip),%xmm0        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,211,180,1,0                // movaps        0x1b4d3(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_565_sse41
.globl _sk_load_565_sse41
FUNCTION(_sk_load_565_sse41)
_sk_load_565_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,80                              // jne           1f6f0 <_sk_load_565_sse41+0x6b>
  .byte  102,67,15,56,51,20,80               // pmovzxwd      (%r8,%r10,2),%xmm2
  .byte  102,15,111,5,193,182,1,0            // movdqa        0x1b6c1(%rip),%xmm0        # 3ad70 <_sk_srcover_bgra_8888_sse2_lowp+0xe08>
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,5,195,182,1,0                 // mulps         0x1b6c3(%rip),%xmm0        # 3ad80 <_sk_srcover_bgra_8888_sse2_lowp+0xe18>
  .byte  102,15,111,13,203,182,1,0           // movdqa        0x1b6cb(%rip),%xmm1        # 3ad90 <_sk_srcover_bgra_8888_sse2_lowp+0xe28>
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,13,205,182,1,0                // mulps         0x1b6cd(%rip),%xmm1        # 3ada0 <_sk_srcover_bgra_8888_sse2_lowp+0xe38>
  .byte  102,15,219,21,213,182,1,0           // pand          0x1b6d5(%rip),%xmm2        # 3adb0 <_sk_srcover_bgra_8888_sse2_lowp+0xe48>
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,21,219,182,1,0                // mulps         0x1b6db(%rip),%xmm2        # 3adc0 <_sk_srcover_bgra_8888_sse2_lowp+0xe58>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,98,180,1,0                 // movaps        0x1b462(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,53                              // je            1f732 <_sk_load_565_sse41+0xad>
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            1f71c <_sk_load_565_sse41+0x97>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,154                             // jne           1f6a7 <_sk_load_565_sse41+0x22>
  .byte  67,15,183,68,80,4                   // movzwl        0x4(%r8,%r10,2),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,15,112,208,69                   // pshufd        $0x45,%xmm0,%xmm2
  .byte  102,67,15,110,4,80                  // movd          (%r8,%r10,2),%xmm0
  .byte  102,15,56,51,192                    // pmovzxwd      %xmm0,%xmm0
  .byte  102,15,58,14,208,15                 // pblendw       $0xf,%xmm0,%xmm2
  .byte  233,117,255,255,255                 // jmpq          1f6a7 <_sk_load_565_sse41+0x22>
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  102,15,110,208                      // movd          %eax,%xmm2
  .byte  233,103,255,255,255                 // jmpq          1f6a7 <_sk_load_565_sse41+0x22>

HIDDEN _sk_load_565_dst_sse41
.globl _sk_load_565_dst_sse41
FUNCTION(_sk_load_565_dst_sse41)
_sk_load_565_dst_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,80                              // jne           1f7ab <_sk_load_565_dst_sse41+0x6b>
  .byte  102,67,15,56,51,52,80               // pmovzxwd      (%r8,%r10,2),%xmm6
  .byte  102,15,111,37,6,182,1,0             // movdqa        0x1b606(%rip),%xmm4        # 3ad70 <_sk_srcover_bgra_8888_sse2_lowp+0xe08>
  .byte  102,15,219,230                      // pand          %xmm6,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,37,8,182,1,0                  // mulps         0x1b608(%rip),%xmm4        # 3ad80 <_sk_srcover_bgra_8888_sse2_lowp+0xe18>
  .byte  102,15,111,45,16,182,1,0            // movdqa        0x1b610(%rip),%xmm5        # 3ad90 <_sk_srcover_bgra_8888_sse2_lowp+0xe28>
  .byte  102,15,219,238                      // pand          %xmm6,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  15,89,45,18,182,1,0                 // mulps         0x1b612(%rip),%xmm5        # 3ada0 <_sk_srcover_bgra_8888_sse2_lowp+0xe38>
  .byte  102,15,219,53,26,182,1,0            // pand          0x1b61a(%rip),%xmm6        # 3adb0 <_sk_srcover_bgra_8888_sse2_lowp+0xe48>
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,89,53,32,182,1,0                 // mulps         0x1b620(%rip),%xmm6        # 3adc0 <_sk_srcover_bgra_8888_sse2_lowp+0xe58>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,61,167,179,1,0                // movaps        0x1b3a7(%rip),%xmm7        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,53                              // je            1f7ed <_sk_load_565_dst_sse41+0xad>
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            1f7d7 <_sk_load_565_dst_sse41+0x97>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,154                             // jne           1f762 <_sk_load_565_dst_sse41+0x22>
  .byte  67,15,183,68,80,4                   // movzwl        0x4(%r8,%r10,2),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  102,15,112,244,69                   // pshufd        $0x45,%xmm4,%xmm6
  .byte  102,67,15,110,36,80                 // movd          (%r8,%r10,2),%xmm4
  .byte  102,15,56,51,228                    // pmovzxwd      %xmm4,%xmm4
  .byte  102,15,58,14,244,15                 // pblendw       $0xf,%xmm4,%xmm6
  .byte  233,117,255,255,255                 // jmpq          1f762 <_sk_load_565_dst_sse41+0x22>
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  102,15,110,240                      // movd          %eax,%xmm6
  .byte  233,103,255,255,255                 // jmpq          1f762 <_sk_load_565_dst_sse41+0x22>

HIDDEN _sk_gather_565_sse41
.globl _sk_gather_565_sse41
FUNCTION(_sk_gather_565_sse41)
_sk_gather_565_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,80,12                     // movss         0xc(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,69,15,118,192                   // pcmpeqd       %xmm8,%xmm8
  .byte  102,65,15,254,208                   // paddd         %xmm8,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,93,202                        // minps         %xmm2,%xmm9
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,192                   // paddd         %xmm8,%xmm0
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,56,64,200                    // pmulld        %xmm0,%xmm1
  .byte  243,65,15,91,193                    // cvttps2dq     %xmm9,%xmm0
  .byte  102,15,254,193                      // paddd         %xmm1,%xmm0
  .byte  102,72,15,58,22,192,1               // pextrq        $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,194                   // movq          %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,183,20,80                     // movzwl        (%r8,%r10,2),%r10d
  .byte  71,15,183,28,88                     // movzwl        (%r8,%r11,2),%r11d
  .byte  102,65,15,110,195                   // movd          %r11d,%xmm0
  .byte  102,65,15,196,194,1                 // pinsrw        $0x1,%r10d,%xmm0
  .byte  71,15,183,12,72                     // movzwl        (%r8,%r9,2),%r9d
  .byte  102,65,15,196,193,2                 // pinsrw        $0x2,%r9d,%xmm0
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  102,15,196,192,3                    // pinsrw        $0x3,%eax,%xmm0
  .byte  102,15,56,51,208                    // pmovzxwd      %xmm0,%xmm2
  .byte  102,15,111,5,205,180,1,0            // movdqa        0x1b4cd(%rip),%xmm0        # 3ad70 <_sk_srcover_bgra_8888_sse2_lowp+0xe08>
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,5,207,180,1,0                 // mulps         0x1b4cf(%rip),%xmm0        # 3ad80 <_sk_srcover_bgra_8888_sse2_lowp+0xe18>
  .byte  102,15,111,13,215,180,1,0           // movdqa        0x1b4d7(%rip),%xmm1        # 3ad90 <_sk_srcover_bgra_8888_sse2_lowp+0xe28>
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,13,217,180,1,0                // mulps         0x1b4d9(%rip),%xmm1        # 3ada0 <_sk_srcover_bgra_8888_sse2_lowp+0xe38>
  .byte  102,15,219,21,225,180,1,0           // pand          0x1b4e1(%rip),%xmm2        # 3adb0 <_sk_srcover_bgra_8888_sse2_lowp+0xe48>
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,21,231,180,1,0                // mulps         0x1b4e7(%rip),%xmm2        # 3adc0 <_sk_srcover_bgra_8888_sse2_lowp+0xe58>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,110,178,1,0                // movaps        0x1b26e(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_565_sse41
.globl _sk_store_565_sse41
FUNCTION(_sk_store_565_sse41)
_sk_store_565_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,40,21,66,178,1,0              // movaps        0x1b242(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  68,15,40,29,86,182,1,0              // movaps        0x1b656(%rip),%xmm11        # 3af70 <_sk_srcover_bgra_8888_sse2_lowp+0x1008>
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  102,65,15,114,241,11                // pslld         $0xb,%xmm9
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  68,15,89,37,67,182,1,0              // mulps         0x1b643(%rip),%xmm12        # 3af80 <_sk_srcover_bgra_8888_sse2_lowp+0x1018>
  .byte  102,69,15,91,228                    // cvtps2dq      %xmm12,%xmm12
  .byte  102,65,15,114,244,5                 // pslld         $0x5,%xmm12
  .byte  68,15,95,194                        // maxps         %xmm2,%xmm8
  .byte  69,15,93,194                        // minps         %xmm10,%xmm8
  .byte  69,15,89,195                        // mulps         %xmm11,%xmm8
  .byte  102,69,15,91,192                    // cvtps2dq      %xmm8,%xmm8
  .byte  102,69,15,86,193                    // orpd          %xmm9,%xmm8
  .byte  102,69,15,86,196                    // orpd          %xmm12,%xmm8
  .byte  102,68,15,56,43,192                 // packusdw      %xmm0,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           1f978 <_sk_store_565_sse41+0x94>
  .byte  102,69,15,214,4,64                  // movq          %xmm8,(%r8,%rax,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,56,51,192                 // pmovzxwd      %xmm8,%xmm8
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,35                              // je            1f9ae <_sk_store_565_sse41+0xca>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,15                              // je            1f9a0 <_sk_store_565_sse41+0xbc>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,221                             // jne           1f974 <_sk_store_565_sse41+0x90>
  .byte  102,69,15,58,21,68,64,4,4           // pextrw        $0x4,%xmm8,0x4(%r8,%rax,2)
  .byte  242,69,15,112,192,232               // pshuflw       $0xe8,%xmm8,%xmm8
  .byte  102,69,15,126,4,64                  // movd          %xmm8,(%r8,%rax,2)
  .byte  235,198                             // jmp           1f974 <_sk_store_565_sse41+0x90>
  .byte  102,69,15,58,21,4,64,0              // pextrw        $0x0,%xmm8,(%r8,%rax,2)
  .byte  235,188                             // jmp           1f974 <_sk_store_565_sse41+0x90>

HIDDEN _sk_load_4444_sse41
.globl _sk_load_4444_sse41
FUNCTION(_sk_load_4444_sse41)
_sk_load_4444_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,95                              // jne           1fa32 <_sk_load_4444_sse41+0x7a>
  .byte  102,67,15,56,51,28,80               // pmovzxwd      (%r8,%r10,2),%xmm3
  .byte  102,15,111,5,174,181,1,0            // movdqa        0x1b5ae(%rip),%xmm0        # 3af90 <_sk_srcover_bgra_8888_sse2_lowp+0x1028>
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,5,176,181,1,0                 // mulps         0x1b5b0(%rip),%xmm0        # 3afa0 <_sk_srcover_bgra_8888_sse2_lowp+0x1038>
  .byte  102,15,111,13,184,181,1,0           // movdqa        0x1b5b8(%rip),%xmm1        # 3afb0 <_sk_srcover_bgra_8888_sse2_lowp+0x1048>
  .byte  102,15,219,203                      // pand          %xmm3,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,13,186,181,1,0                // mulps         0x1b5ba(%rip),%xmm1        # 3afc0 <_sk_srcover_bgra_8888_sse2_lowp+0x1058>
  .byte  102,15,111,21,194,181,1,0           // movdqa        0x1b5c2(%rip),%xmm2        # 3afd0 <_sk_srcover_bgra_8888_sse2_lowp+0x1068>
  .byte  102,15,219,211                      // pand          %xmm3,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,21,196,181,1,0                // mulps         0x1b5c4(%rip),%xmm2        # 3afe0 <_sk_srcover_bgra_8888_sse2_lowp+0x1078>
  .byte  102,15,219,29,204,181,1,0           // pand          0x1b5cc(%rip),%xmm3        # 3aff0 <_sk_srcover_bgra_8888_sse2_lowp+0x1088>
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,29,210,181,1,0                // mulps         0x1b5d2(%rip),%xmm3        # 3b000 <_sk_srcover_bgra_8888_sse2_lowp+0x1098>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,53                              // je            1fa74 <_sk_load_4444_sse41+0xbc>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            1fa5e <_sk_load_4444_sse41+0xa6>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,139                             // jne           1f9da <_sk_load_4444_sse41+0x22>
  .byte  67,15,183,68,80,4                   // movzwl        0x4(%r8,%r10,2),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,15,112,216,69                   // pshufd        $0x45,%xmm0,%xmm3
  .byte  102,67,15,110,4,80                  // movd          (%r8,%r10,2),%xmm0
  .byte  102,15,56,51,192                    // pmovzxwd      %xmm0,%xmm0
  .byte  102,15,58,14,216,15                 // pblendw       $0xf,%xmm0,%xmm3
  .byte  233,102,255,255,255                 // jmpq          1f9da <_sk_load_4444_sse41+0x22>
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  102,15,110,216                      // movd          %eax,%xmm3
  .byte  233,88,255,255,255                  // jmpq          1f9da <_sk_load_4444_sse41+0x22>

HIDDEN _sk_load_4444_dst_sse41
.globl _sk_load_4444_dst_sse41
FUNCTION(_sk_load_4444_dst_sse41)
_sk_load_4444_dst_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,95                              // jne           1fafc <_sk_load_4444_dst_sse41+0x7a>
  .byte  102,67,15,56,51,60,80               // pmovzxwd      (%r8,%r10,2),%xmm7
  .byte  102,15,111,37,228,180,1,0           // movdqa        0x1b4e4(%rip),%xmm4        # 3af90 <_sk_srcover_bgra_8888_sse2_lowp+0x1028>
  .byte  102,15,219,231                      // pand          %xmm7,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,37,230,180,1,0                // mulps         0x1b4e6(%rip),%xmm4        # 3afa0 <_sk_srcover_bgra_8888_sse2_lowp+0x1038>
  .byte  102,15,111,45,238,180,1,0           // movdqa        0x1b4ee(%rip),%xmm5        # 3afb0 <_sk_srcover_bgra_8888_sse2_lowp+0x1048>
  .byte  102,15,219,239                      // pand          %xmm7,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  15,89,45,240,180,1,0                // mulps         0x1b4f0(%rip),%xmm5        # 3afc0 <_sk_srcover_bgra_8888_sse2_lowp+0x1058>
  .byte  102,15,111,53,248,180,1,0           // movdqa        0x1b4f8(%rip),%xmm6        # 3afd0 <_sk_srcover_bgra_8888_sse2_lowp+0x1068>
  .byte  102,15,219,247                      // pand          %xmm7,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,89,53,250,180,1,0                // mulps         0x1b4fa(%rip),%xmm6        # 3afe0 <_sk_srcover_bgra_8888_sse2_lowp+0x1078>
  .byte  102,15,219,61,2,181,1,0             // pand          0x1b502(%rip),%xmm7        # 3aff0 <_sk_srcover_bgra_8888_sse2_lowp+0x1088>
  .byte  15,91,255                           // cvtdq2ps      %xmm7,%xmm7
  .byte  15,89,61,8,181,1,0                  // mulps         0x1b508(%rip),%xmm7        # 3b000 <_sk_srcover_bgra_8888_sse2_lowp+0x1098>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,53                              // je            1fb3e <_sk_load_4444_dst_sse41+0xbc>
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            1fb28 <_sk_load_4444_dst_sse41+0xa6>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,139                             // jne           1faa4 <_sk_load_4444_dst_sse41+0x22>
  .byte  67,15,183,68,80,4                   // movzwl        0x4(%r8,%r10,2),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  102,15,112,252,69                   // pshufd        $0x45,%xmm4,%xmm7
  .byte  102,67,15,110,36,80                 // movd          (%r8,%r10,2),%xmm4
  .byte  102,15,56,51,228                    // pmovzxwd      %xmm4,%xmm4
  .byte  102,15,58,14,252,15                 // pblendw       $0xf,%xmm4,%xmm7
  .byte  233,102,255,255,255                 // jmpq          1faa4 <_sk_load_4444_dst_sse41+0x22>
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  102,15,110,248                      // movd          %eax,%xmm7
  .byte  233,88,255,255,255                  // jmpq          1faa4 <_sk_load_4444_dst_sse41+0x22>

HIDDEN _sk_gather_4444_sse41
.globl _sk_gather_4444_sse41
FUNCTION(_sk_gather_4444_sse41)
_sk_gather_4444_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,80,12                     // movss         0xc(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,69,15,118,192                   // pcmpeqd       %xmm8,%xmm8
  .byte  102,65,15,254,208                   // paddd         %xmm8,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,93,202                        // minps         %xmm2,%xmm9
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,192                   // paddd         %xmm8,%xmm0
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,56,64,200                    // pmulld        %xmm0,%xmm1
  .byte  243,65,15,91,193                    // cvttps2dq     %xmm9,%xmm0
  .byte  102,15,254,193                      // paddd         %xmm1,%xmm0
  .byte  102,72,15,58,22,192,1               // pextrq        $0x1,%xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,194                   // movq          %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,183,20,80                     // movzwl        (%r8,%r10,2),%r10d
  .byte  71,15,183,28,88                     // movzwl        (%r8,%r11,2),%r11d
  .byte  102,65,15,110,195                   // movd          %r11d,%xmm0
  .byte  102,65,15,196,194,1                 // pinsrw        $0x1,%r10d,%xmm0
  .byte  71,15,183,12,72                     // movzwl        (%r8,%r9,2),%r9d
  .byte  102,65,15,196,193,2                 // pinsrw        $0x2,%r9d,%xmm0
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  102,15,196,192,3                    // pinsrw        $0x3,%eax,%xmm0
  .byte  102,15,56,51,216                    // pmovzxwd      %xmm0,%xmm3
  .byte  102,15,111,5,156,179,1,0            // movdqa        0x1b39c(%rip),%xmm0        # 3af90 <_sk_srcover_bgra_8888_sse2_lowp+0x1028>
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,5,158,179,1,0                 // mulps         0x1b39e(%rip),%xmm0        # 3afa0 <_sk_srcover_bgra_8888_sse2_lowp+0x1038>
  .byte  102,15,111,13,166,179,1,0           // movdqa        0x1b3a6(%rip),%xmm1        # 3afb0 <_sk_srcover_bgra_8888_sse2_lowp+0x1048>
  .byte  102,15,219,203                      // pand          %xmm3,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,13,168,179,1,0                // mulps         0x1b3a8(%rip),%xmm1        # 3afc0 <_sk_srcover_bgra_8888_sse2_lowp+0x1058>
  .byte  102,15,111,21,176,179,1,0           // movdqa        0x1b3b0(%rip),%xmm2        # 3afd0 <_sk_srcover_bgra_8888_sse2_lowp+0x1068>
  .byte  102,15,219,211                      // pand          %xmm3,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,21,178,179,1,0                // mulps         0x1b3b2(%rip),%xmm2        # 3afe0 <_sk_srcover_bgra_8888_sse2_lowp+0x1078>
  .byte  102,15,219,29,186,179,1,0           // pand          0x1b3ba(%rip),%xmm3        # 3aff0 <_sk_srcover_bgra_8888_sse2_lowp+0x1088>
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,29,192,179,1,0                // mulps         0x1b3c0(%rip),%xmm3        # 3b000 <_sk_srcover_bgra_8888_sse2_lowp+0x1098>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_4444_sse41
.globl _sk_store_4444_sse41
FUNCTION(_sk_store_4444_sse41)
_sk_store_4444_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,40,21,226,174,1,0             // movaps        0x1aee2(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  68,15,40,29,150,179,1,0             // movaps        0x1b396(%rip),%xmm11        # 3b010 <_sk_srcover_bgra_8888_sse2_lowp+0x10a8>
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  102,65,15,114,241,12                // pslld         $0xc,%xmm9
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  102,69,15,91,228                    // cvtps2dq      %xmm12,%xmm12
  .byte  102,65,15,114,244,8                 // pslld         $0x8,%xmm12
  .byte  102,69,15,235,225                   // por           %xmm9,%xmm12
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  68,15,95,202                        // maxps         %xmm2,%xmm9
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  102,65,15,114,241,4                 // pslld         $0x4,%xmm9
  .byte  68,15,95,195                        // maxps         %xmm3,%xmm8
  .byte  69,15,93,194                        // minps         %xmm10,%xmm8
  .byte  69,15,89,195                        // mulps         %xmm11,%xmm8
  .byte  102,69,15,91,192                    // cvtps2dq      %xmm8,%xmm8
  .byte  102,69,15,86,193                    // orpd          %xmm9,%xmm8
  .byte  102,69,15,86,196                    // orpd          %xmm12,%xmm8
  .byte  102,68,15,56,43,192                 // packusdw      %xmm0,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           1fcf5 <_sk_store_4444_sse41+0xb1>
  .byte  102,69,15,214,4,64                  // movq          %xmm8,(%r8,%rax,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,56,51,192                 // pmovzxwd      %xmm8,%xmm8
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,35                              // je            1fd2b <_sk_store_4444_sse41+0xe7>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,15                              // je            1fd1d <_sk_store_4444_sse41+0xd9>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,221                             // jne           1fcf1 <_sk_store_4444_sse41+0xad>
  .byte  102,69,15,58,21,68,64,4,4           // pextrw        $0x4,%xmm8,0x4(%r8,%rax,2)
  .byte  242,69,15,112,192,232               // pshuflw       $0xe8,%xmm8,%xmm8
  .byte  102,69,15,126,4,64                  // movd          %xmm8,(%r8,%rax,2)
  .byte  235,198                             // jmp           1fcf1 <_sk_store_4444_sse41+0xad>
  .byte  102,69,15,58,21,4,64,0              // pextrw        $0x0,%xmm8,(%r8,%rax,2)
  .byte  235,188                             // jmp           1fcf1 <_sk_store_4444_sse41+0xad>

HIDDEN _sk_load_8888_sse41
.globl _sk_load_8888_sse41
FUNCTION(_sk_load_8888_sse41)
_sk_load_8888_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,89                              // jne           1fdaa <_sk_load_8888_sse41+0x75>
  .byte  243,65,15,111,28,128                // movdqu        (%r8,%rax,4),%xmm3
  .byte  102,15,111,5,161,174,1,0            // movdqa        0x1aea1(%rip),%xmm0        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  68,15,40,5,242,175,1,0              // movaps        0x1aff2(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,56,0,13,145,174,1,0          // pshufb        0x1ae91(%rip),%xmm1        # 3ac10 <_sk_srcover_bgra_8888_sse2_lowp+0xca8>
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,56,0,21,141,174,1,0          // pshufb        0x1ae8d(%rip),%xmm2        # 3ac20 <_sk_srcover_bgra_8888_sse2_lowp+0xcb8>
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,45                              // je            1fde4 <_sk_load_8888_sse41+0xaf>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,18                              // je            1fdd3 <_sk_load_8888_sse41+0x9e>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,144                             // jne           1fd57 <_sk_load_8888_sse41+0x22>
  .byte  102,65,15,110,68,128,8              // movd          0x8(%r8,%rax,4),%xmm0
  .byte  102,15,112,216,69                   // pshufd        $0x45,%xmm0,%xmm3
  .byte  243,65,15,126,4,128                 // movq          (%r8,%rax,4),%xmm0
  .byte  102,15,58,14,216,15                 // pblendw       $0xf,%xmm0,%xmm3
  .byte  233,115,255,255,255                 // jmpq          1fd57 <_sk_load_8888_sse41+0x22>
  .byte  102,65,15,110,28,128                // movd          (%r8,%rax,4),%xmm3
  .byte  233,104,255,255,255                 // jmpq          1fd57 <_sk_load_8888_sse41+0x22>

HIDDEN _sk_load_8888_dst_sse41
.globl _sk_load_8888_dst_sse41
FUNCTION(_sk_load_8888_dst_sse41)
_sk_load_8888_dst_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,89                              // jne           1fe64 <_sk_load_8888_dst_sse41+0x75>
  .byte  243,65,15,111,60,128                // movdqu        (%r8,%rax,4),%xmm7
  .byte  102,15,111,37,231,173,1,0           // movdqa        0x1ade7(%rip),%xmm4        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,15,219,231                      // pand          %xmm7,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  68,15,40,5,56,175,1,0               // movaps        0x1af38(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,224                        // mulps         %xmm8,%xmm4
  .byte  102,15,111,239                      // movdqa        %xmm7,%xmm5
  .byte  102,15,56,0,45,215,173,1,0          // pshufb        0x1add7(%rip),%xmm5        # 3ac10 <_sk_srcover_bgra_8888_sse2_lowp+0xca8>
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  65,15,89,232                        // mulps         %xmm8,%xmm5
  .byte  102,15,111,247                      // movdqa        %xmm7,%xmm6
  .byte  102,15,56,0,53,211,173,1,0          // pshufb        0x1add3(%rip),%xmm6        # 3ac20 <_sk_srcover_bgra_8888_sse2_lowp+0xcb8>
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  65,15,89,240                        // mulps         %xmm8,%xmm6
  .byte  102,15,114,215,24                   // psrld         $0x18,%xmm7
  .byte  15,91,255                           // cvtdq2ps      %xmm7,%xmm7
  .byte  65,15,89,248                        // mulps         %xmm8,%xmm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,45                              // je            1fe9e <_sk_load_8888_dst_sse41+0xaf>
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,18                              // je            1fe8d <_sk_load_8888_dst_sse41+0x9e>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,144                             // jne           1fe11 <_sk_load_8888_dst_sse41+0x22>
  .byte  102,65,15,110,100,128,8             // movd          0x8(%r8,%rax,4),%xmm4
  .byte  102,15,112,252,69                   // pshufd        $0x45,%xmm4,%xmm7
  .byte  243,65,15,126,36,128                // movq          (%r8,%rax,4),%xmm4
  .byte  102,15,58,14,252,15                 // pblendw       $0xf,%xmm4,%xmm7
  .byte  233,115,255,255,255                 // jmpq          1fe11 <_sk_load_8888_dst_sse41+0x22>
  .byte  102,65,15,110,60,128                // movd          (%r8,%rax,4),%xmm7
  .byte  233,104,255,255,255                 // jmpq          1fe11 <_sk_load_8888_dst_sse41+0x22>

HIDDEN _sk_gather_8888_sse41
.globl _sk_gather_8888_sse41
FUNCTION(_sk_gather_8888_sse41)
_sk_gather_8888_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,80,12                     // movss         0xc(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,69,15,118,192                   // pcmpeqd       %xmm8,%xmm8
  .byte  102,65,15,254,208                   // paddd         %xmm8,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,93,202                        // minps         %xmm2,%xmm9
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,192                   // paddd         %xmm8,%xmm0
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,56,64,200                    // pmulld        %xmm0,%xmm1
  .byte  243,65,15,91,193                    // cvttps2dq     %xmm9,%xmm0
  .byte  102,15,254,193                      // paddd         %xmm1,%xmm0
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,58,22,194,1               // pextrq        $0x1,%xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,67,15,110,28,136                // movd          (%r8,%r9,4),%xmm3
  .byte  102,65,15,58,34,28,128,1            // pinsrd        $0x1,(%r8,%rax,4),%xmm3
  .byte  102,67,15,58,34,28,152,2            // pinsrd        $0x2,(%r8,%r11,4),%xmm3
  .byte  102,67,15,58,34,28,144,3            // pinsrd        $0x3,(%r8,%r10,4),%xmm3
  .byte  102,15,111,5,192,172,1,0            // movdqa        0x1acc0(%rip),%xmm0        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  68,15,40,5,17,174,1,0               // movaps        0x1ae11(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,56,0,13,176,172,1,0          // pshufb        0x1acb0(%rip),%xmm1        # 3ac10 <_sk_srcover_bgra_8888_sse2_lowp+0xca8>
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,56,0,21,172,172,1,0          // pshufb        0x1acac(%rip),%xmm2        # 3ac20 <_sk_srcover_bgra_8888_sse2_lowp+0xcb8>
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_8888_sse41
.globl _sk_store_8888_sse41
FUNCTION(_sk_store_8888_sse41)
_sk_store_8888_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,40,21,154,171,1,0             // movaps        0x1ab9a(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  68,15,40,29,110,172,1,0             // movaps        0x1ac6e(%rip),%xmm11        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  102,69,15,91,228                    // cvtps2dq      %xmm12,%xmm12
  .byte  102,65,15,114,244,8                 // pslld         $0x8,%xmm12
  .byte  102,69,15,235,225                   // por           %xmm9,%xmm12
  .byte  102,69,15,87,201                    // xorpd         %xmm9,%xmm9
  .byte  68,15,95,202                        // maxps         %xmm2,%xmm9
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  102,65,15,114,241,16                // pslld         $0x10,%xmm9
  .byte  68,15,95,195                        // maxps         %xmm3,%xmm8
  .byte  69,15,93,194                        // minps         %xmm10,%xmm8
  .byte  69,15,89,195                        // mulps         %xmm11,%xmm8
  .byte  102,69,15,91,192                    // cvtps2dq      %xmm8,%xmm8
  .byte  102,65,15,114,240,24                // pslld         $0x18,%xmm8
  .byte  102,69,15,235,193                   // por           %xmm9,%xmm8
  .byte  102,69,15,235,196                   // por           %xmm12,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           20037 <_sk_store_8888_sse41+0xac>
  .byte  243,69,15,127,4,128                 // movdqu        %xmm8,(%r8,%rax,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,29                              // je            20061 <_sk_store_8888_sse41+0xd6>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,15                              // je            20059 <_sk_store_8888_sse41+0xce>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,227                             // jne           20033 <_sk_store_8888_sse41+0xa8>
  .byte  102,69,15,58,22,68,128,8,2          // pextrd        $0x2,%xmm8,0x8(%r8,%rax,4)
  .byte  102,69,15,214,4,128                 // movq          %xmm8,(%r8,%rax,4)
  .byte  235,210                             // jmp           20033 <_sk_store_8888_sse41+0xa8>
  .byte  102,69,15,126,4,128                 // movd          %xmm8,(%r8,%rax,4)
  .byte  235,202                             // jmp           20033 <_sk_store_8888_sse41+0xa8>

HIDDEN _sk_load_bgra_sse41
.globl _sk_load_bgra_sse41
FUNCTION(_sk_load_bgra_sse41)
_sk_load_bgra_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,89                              // jne           200de <_sk_load_bgra_sse41+0x75>
  .byte  243,65,15,111,28,128                // movdqu        (%r8,%rax,4),%xmm3
  .byte  102,15,111,5,109,171,1,0            // movdqa        0x1ab6d(%rip),%xmm0        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  15,91,208                           // cvtdq2ps      %xmm0,%xmm2
  .byte  68,15,40,5,190,172,1,0              // movaps        0x1acbe(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,56,0,5,93,171,1,0            // pshufb        0x1ab5d(%rip),%xmm0        # 3ac10 <_sk_srcover_bgra_8888_sse2_lowp+0xca8>
  .byte  15,91,200                           // cvtdq2ps      %xmm0,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,56,0,5,89,171,1,0            // pshufb        0x1ab59(%rip),%xmm0        # 3ac20 <_sk_srcover_bgra_8888_sse2_lowp+0xcb8>
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,45                              // je            20118 <_sk_load_bgra_sse41+0xaf>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,18                              // je            20107 <_sk_load_bgra_sse41+0x9e>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,144                             // jne           2008b <_sk_load_bgra_sse41+0x22>
  .byte  102,65,15,110,68,128,8              // movd          0x8(%r8,%rax,4),%xmm0
  .byte  102,15,112,216,69                   // pshufd        $0x45,%xmm0,%xmm3
  .byte  243,65,15,126,4,128                 // movq          (%r8,%rax,4),%xmm0
  .byte  102,15,58,14,216,15                 // pblendw       $0xf,%xmm0,%xmm3
  .byte  233,115,255,255,255                 // jmpq          2008b <_sk_load_bgra_sse41+0x22>
  .byte  102,65,15,110,28,128                // movd          (%r8,%rax,4),%xmm3
  .byte  233,104,255,255,255                 // jmpq          2008b <_sk_load_bgra_sse41+0x22>

HIDDEN _sk_load_bgra_dst_sse41
.globl _sk_load_bgra_dst_sse41
FUNCTION(_sk_load_bgra_dst_sse41)
_sk_load_bgra_dst_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,89                              // jne           20198 <_sk_load_bgra_dst_sse41+0x75>
  .byte  243,65,15,111,60,128                // movdqu        (%r8,%rax,4),%xmm7
  .byte  102,15,111,37,179,170,1,0           // movdqa        0x1aab3(%rip),%xmm4        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,15,219,231                      // pand          %xmm7,%xmm4
  .byte  15,91,244                           // cvtdq2ps      %xmm4,%xmm6
  .byte  68,15,40,5,4,172,1,0                // movaps        0x1ac04(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,240                        // mulps         %xmm8,%xmm6
  .byte  102,15,111,231                      // movdqa        %xmm7,%xmm4
  .byte  102,15,56,0,37,163,170,1,0          // pshufb        0x1aaa3(%rip),%xmm4        # 3ac10 <_sk_srcover_bgra_8888_sse2_lowp+0xca8>
  .byte  15,91,236                           // cvtdq2ps      %xmm4,%xmm5
  .byte  65,15,89,232                        // mulps         %xmm8,%xmm5
  .byte  102,15,111,231                      // movdqa        %xmm7,%xmm4
  .byte  102,15,56,0,37,159,170,1,0          // pshufb        0x1aa9f(%rip),%xmm4        # 3ac20 <_sk_srcover_bgra_8888_sse2_lowp+0xcb8>
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  65,15,89,224                        // mulps         %xmm8,%xmm4
  .byte  102,15,114,215,24                   // psrld         $0x18,%xmm7
  .byte  15,91,255                           // cvtdq2ps      %xmm7,%xmm7
  .byte  65,15,89,248                        // mulps         %xmm8,%xmm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,45                              // je            201d2 <_sk_load_bgra_dst_sse41+0xaf>
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,18                              // je            201c1 <_sk_load_bgra_dst_sse41+0x9e>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,144                             // jne           20145 <_sk_load_bgra_dst_sse41+0x22>
  .byte  102,65,15,110,100,128,8             // movd          0x8(%r8,%rax,4),%xmm4
  .byte  102,15,112,252,69                   // pshufd        $0x45,%xmm4,%xmm7
  .byte  243,65,15,126,36,128                // movq          (%r8,%rax,4),%xmm4
  .byte  102,15,58,14,252,15                 // pblendw       $0xf,%xmm4,%xmm7
  .byte  233,115,255,255,255                 // jmpq          20145 <_sk_load_bgra_dst_sse41+0x22>
  .byte  102,65,15,110,60,128                // movd          (%r8,%rax,4),%xmm7
  .byte  233,104,255,255,255                 // jmpq          20145 <_sk_load_bgra_dst_sse41+0x22>

HIDDEN _sk_gather_bgra_sse41
.globl _sk_gather_bgra_sse41
FUNCTION(_sk_gather_bgra_sse41)
_sk_gather_bgra_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,80,12                     // movss         0xc(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,69,15,118,192                   // pcmpeqd       %xmm8,%xmm8
  .byte  102,65,15,254,208                   // paddd         %xmm8,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,93,202                        // minps         %xmm2,%xmm9
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,192                   // paddd         %xmm8,%xmm0
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,56,64,200                    // pmulld        %xmm0,%xmm1
  .byte  243,65,15,91,193                    // cvttps2dq     %xmm9,%xmm0
  .byte  102,15,254,193                      // paddd         %xmm1,%xmm0
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,58,22,194,1               // pextrq        $0x1,%xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,67,15,110,28,136                // movd          (%r8,%r9,4),%xmm3
  .byte  102,65,15,58,34,28,128,1            // pinsrd        $0x1,(%r8,%rax,4),%xmm3
  .byte  102,67,15,58,34,28,152,2            // pinsrd        $0x2,(%r8,%r11,4),%xmm3
  .byte  102,67,15,58,34,28,144,3            // pinsrd        $0x3,(%r8,%r10,4),%xmm3
  .byte  102,15,111,5,140,169,1,0            // movdqa        0x1a98c(%rip),%xmm0        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  15,91,208                           // cvtdq2ps      %xmm0,%xmm2
  .byte  68,15,40,5,221,170,1,0              // movaps        0x1aadd(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,56,0,5,124,169,1,0           // pshufb        0x1a97c(%rip),%xmm0        # 3ac10 <_sk_srcover_bgra_8888_sse2_lowp+0xca8>
  .byte  15,91,200                           // cvtdq2ps      %xmm0,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,56,0,5,120,169,1,0           // pshufb        0x1a978(%rip),%xmm0        # 3ac20 <_sk_srcover_bgra_8888_sse2_lowp+0xcb8>
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_bgra_sse41
.globl _sk_store_bgra_sse41
FUNCTION(_sk_store_bgra_sse41)
_sk_store_bgra_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,202                        // maxps         %xmm2,%xmm9
  .byte  68,15,40,21,102,168,1,0             // movaps        0x1a866(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  68,15,40,29,58,169,1,0              // movaps        0x1a93a(%rip),%xmm11        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  102,69,15,91,228                    // cvtps2dq      %xmm12,%xmm12
  .byte  102,65,15,114,244,8                 // pslld         $0x8,%xmm12
  .byte  102,69,15,235,225                   // por           %xmm9,%xmm12
  .byte  102,69,15,87,201                    // xorpd         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  102,65,15,114,241,16                // pslld         $0x10,%xmm9
  .byte  68,15,95,195                        // maxps         %xmm3,%xmm8
  .byte  69,15,93,194                        // minps         %xmm10,%xmm8
  .byte  69,15,89,195                        // mulps         %xmm11,%xmm8
  .byte  102,69,15,91,192                    // cvtps2dq      %xmm8,%xmm8
  .byte  102,65,15,114,240,24                // pslld         $0x18,%xmm8
  .byte  102,69,15,235,193                   // por           %xmm9,%xmm8
  .byte  102,69,15,235,196                   // por           %xmm12,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           2036b <_sk_store_bgra_sse41+0xac>
  .byte  243,69,15,127,4,128                 // movdqu        %xmm8,(%r8,%rax,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,29                              // je            20395 <_sk_store_bgra_sse41+0xd6>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,15                              // je            2038d <_sk_store_bgra_sse41+0xce>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,227                             // jne           20367 <_sk_store_bgra_sse41+0xa8>
  .byte  102,69,15,58,22,68,128,8,2          // pextrd        $0x2,%xmm8,0x8(%r8,%rax,4)
  .byte  102,69,15,214,4,128                 // movq          %xmm8,(%r8,%rax,4)
  .byte  235,210                             // jmp           20367 <_sk_store_bgra_sse41+0xa8>
  .byte  102,69,15,126,4,128                 // movd          %xmm8,(%r8,%rax,4)
  .byte  235,202                             // jmp           20367 <_sk_store_bgra_sse41+0xa8>

HIDDEN _sk_load_f16_sse41
.globl _sk_load_f16_sse41
FUNCTION(_sk_load_f16_sse41)
_sk_load_f16_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,68,1,0,0                     // jne           20501 <_sk_load_f16_sse41+0x164>
  .byte  102,65,15,16,4,192                  // movupd        (%r8,%rax,8),%xmm0
  .byte  243,65,15,111,76,192,16             // movdqu        0x10(%r8,%rax,8),%xmm1
  .byte  102,68,15,40,200                    // movapd        %xmm0,%xmm9
  .byte  102,68,15,97,201                    // punpcklwd     %xmm1,%xmm9
  .byte  102,15,105,193                      // punpckhwd     %xmm1,%xmm0
  .byte  102,69,15,111,225                   // movdqa        %xmm9,%xmm12
  .byte  102,68,15,97,224                    // punpcklwd     %xmm0,%xmm12
  .byte  102,68,15,105,200                   // punpckhwd     %xmm0,%xmm9
  .byte  102,65,15,56,51,212                 // pmovzxwd      %xmm12,%xmm2
  .byte  102,68,15,111,5,42,172,1,0          // movdqa        0x1ac2a(%rip),%xmm8        # 3b020 <_sk_srcover_bgra_8888_sse2_lowp+0x10b8>
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,65,15,219,200                   // pand          %xmm8,%xmm1
  .byte  102,68,15,111,21,40,172,1,0         // movdqa        0x1ac28(%rip),%xmm10        # 3b030 <_sk_srcover_bgra_8888_sse2_lowp+0x10c8>
  .byte  102,65,15,219,210                   // pand          %xmm10,%xmm2
  .byte  102,15,111,29,43,172,1,0            // movdqa        0x1ac2b(%rip),%xmm3        # 3b040 <_sk_srcover_bgra_8888_sse2_lowp+0x10d8>
  .byte  102,15,114,241,16                   // pslld         $0x10,%xmm1
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,56,63,195                    // pmaxud        %xmm3,%xmm0
  .byte  102,15,118,194                      // pcmpeqd       %xmm2,%xmm0
  .byte  102,15,114,242,13                   // pslld         $0xd,%xmm2
  .byte  102,15,235,209                      // por           %xmm1,%xmm2
  .byte  102,68,15,111,29,23,172,1,0         // movdqa        0x1ac17(%rip),%xmm11        # 3b050 <_sk_srcover_bgra_8888_sse2_lowp+0x10e8>
  .byte  102,65,15,254,211                   // paddd         %xmm11,%xmm2
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  102,65,15,112,204,238               // pshufd        $0xee,%xmm12,%xmm1
  .byte  102,15,56,51,209                    // pmovzxwd      %xmm1,%xmm2
  .byte  102,68,15,111,226                   // movdqa        %xmm2,%xmm12
  .byte  102,69,15,219,224                   // pand          %xmm8,%xmm12
  .byte  102,65,15,219,210                   // pand          %xmm10,%xmm2
  .byte  102,65,15,114,244,16                // pslld         $0x10,%xmm12
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,56,63,203                    // pmaxud        %xmm3,%xmm1
  .byte  102,15,118,202                      // pcmpeqd       %xmm2,%xmm1
  .byte  102,15,114,242,13                   // pslld         $0xd,%xmm2
  .byte  102,65,15,235,212                   // por           %xmm12,%xmm2
  .byte  102,65,15,254,211                   // paddd         %xmm11,%xmm2
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  102,69,15,56,51,225                 // pmovzxwd      %xmm9,%xmm12
  .byte  102,69,15,111,236                   // movdqa        %xmm12,%xmm13
  .byte  102,69,15,219,232                   // pand          %xmm8,%xmm13
  .byte  102,69,15,219,226                   // pand          %xmm10,%xmm12
  .byte  102,65,15,114,245,16                // pslld         $0x10,%xmm13
  .byte  102,65,15,111,212                   // movdqa        %xmm12,%xmm2
  .byte  102,15,56,63,211                    // pmaxud        %xmm3,%xmm2
  .byte  102,65,15,118,212                   // pcmpeqd       %xmm12,%xmm2
  .byte  102,65,15,114,244,13                // pslld         $0xd,%xmm12
  .byte  102,69,15,235,229                   // por           %xmm13,%xmm12
  .byte  102,69,15,254,227                   // paddd         %xmm11,%xmm12
  .byte  102,65,15,219,212                   // pand          %xmm12,%xmm2
  .byte  102,69,15,112,201,238               // pshufd        $0xee,%xmm9,%xmm9
  .byte  102,69,15,56,51,201                 // pmovzxwd      %xmm9,%xmm9
  .byte  102,69,15,219,193                   // pand          %xmm9,%xmm8
  .byte  102,69,15,219,202                   // pand          %xmm10,%xmm9
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,56,63,217                 // pmaxud        %xmm9,%xmm3
  .byte  102,65,15,118,217                   // pcmpeqd       %xmm9,%xmm3
  .byte  102,65,15,114,241,13                // pslld         $0xd,%xmm9
  .byte  102,69,15,235,200                   // por           %xmm8,%xmm9
  .byte  102,69,15,254,203                   // paddd         %xmm11,%xmm9
  .byte  102,65,15,219,217                   // pand          %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  242,65,15,16,4,192                  // movsd         (%r8,%rax,8),%xmm0
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,13                              // jne           2051a <_sk_load_f16_sse41+0x17d>
  .byte  243,15,126,192                      // movq          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  233,176,254,255,255                 // jmpq          203ca <_sk_load_f16_sse41+0x2d>
  .byte  102,65,15,22,68,192,8               // movhpd        0x8(%r8,%rax,8),%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  15,130,155,254,255,255              // jb            203ca <_sk_load_f16_sse41+0x2d>
  .byte  243,65,15,126,76,192,16             // movq          0x10(%r8,%rax,8),%xmm1
  .byte  233,143,254,255,255                 // jmpq          203ca <_sk_load_f16_sse41+0x2d>

HIDDEN _sk_load_f16_dst_sse41
.globl _sk_load_f16_dst_sse41
FUNCTION(_sk_load_f16_dst_sse41)
_sk_load_f16_dst_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,68,1,0,0                     // jne           2069f <_sk_load_f16_dst_sse41+0x164>
  .byte  102,65,15,16,36,192                 // movupd        (%r8,%rax,8),%xmm4
  .byte  243,65,15,111,108,192,16            // movdqu        0x10(%r8,%rax,8),%xmm5
  .byte  102,68,15,40,204                    // movapd        %xmm4,%xmm9
  .byte  102,68,15,97,205                    // punpcklwd     %xmm5,%xmm9
  .byte  102,15,105,229                      // punpckhwd     %xmm5,%xmm4
  .byte  102,69,15,111,225                   // movdqa        %xmm9,%xmm12
  .byte  102,68,15,97,228                    // punpcklwd     %xmm4,%xmm12
  .byte  102,68,15,105,204                   // punpckhwd     %xmm4,%xmm9
  .byte  102,65,15,56,51,244                 // pmovzxwd      %xmm12,%xmm6
  .byte  102,68,15,111,5,140,170,1,0         // movdqa        0x1aa8c(%rip),%xmm8        # 3b020 <_sk_srcover_bgra_8888_sse2_lowp+0x10b8>
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,65,15,219,232                   // pand          %xmm8,%xmm5
  .byte  102,68,15,111,21,138,170,1,0        // movdqa        0x1aa8a(%rip),%xmm10        # 3b030 <_sk_srcover_bgra_8888_sse2_lowp+0x10c8>
  .byte  102,65,15,219,242                   // pand          %xmm10,%xmm6
  .byte  102,15,111,61,141,170,1,0           // movdqa        0x1aa8d(%rip),%xmm7        # 3b040 <_sk_srcover_bgra_8888_sse2_lowp+0x10d8>
  .byte  102,15,114,245,16                   // pslld         $0x10,%xmm5
  .byte  102,15,111,230                      // movdqa        %xmm6,%xmm4
  .byte  102,15,56,63,231                    // pmaxud        %xmm7,%xmm4
  .byte  102,15,118,230                      // pcmpeqd       %xmm6,%xmm4
  .byte  102,15,114,246,13                   // pslld         $0xd,%xmm6
  .byte  102,15,235,245                      // por           %xmm5,%xmm6
  .byte  102,68,15,111,29,121,170,1,0        // movdqa        0x1aa79(%rip),%xmm11        # 3b050 <_sk_srcover_bgra_8888_sse2_lowp+0x10e8>
  .byte  102,65,15,254,243                   // paddd         %xmm11,%xmm6
  .byte  102,15,219,230                      // pand          %xmm6,%xmm4
  .byte  102,65,15,112,236,238               // pshufd        $0xee,%xmm12,%xmm5
  .byte  102,15,56,51,245                    // pmovzxwd      %xmm5,%xmm6
  .byte  102,68,15,111,230                   // movdqa        %xmm6,%xmm12
  .byte  102,69,15,219,224                   // pand          %xmm8,%xmm12
  .byte  102,65,15,219,242                   // pand          %xmm10,%xmm6
  .byte  102,65,15,114,244,16                // pslld         $0x10,%xmm12
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,15,56,63,239                    // pmaxud        %xmm7,%xmm5
  .byte  102,15,118,238                      // pcmpeqd       %xmm6,%xmm5
  .byte  102,15,114,246,13                   // pslld         $0xd,%xmm6
  .byte  102,65,15,235,244                   // por           %xmm12,%xmm6
  .byte  102,65,15,254,243                   // paddd         %xmm11,%xmm6
  .byte  102,15,219,238                      // pand          %xmm6,%xmm5
  .byte  102,69,15,56,51,225                 // pmovzxwd      %xmm9,%xmm12
  .byte  102,69,15,111,236                   // movdqa        %xmm12,%xmm13
  .byte  102,69,15,219,232                   // pand          %xmm8,%xmm13
  .byte  102,69,15,219,226                   // pand          %xmm10,%xmm12
  .byte  102,65,15,114,245,16                // pslld         $0x10,%xmm13
  .byte  102,65,15,111,244                   // movdqa        %xmm12,%xmm6
  .byte  102,15,56,63,247                    // pmaxud        %xmm7,%xmm6
  .byte  102,65,15,118,244                   // pcmpeqd       %xmm12,%xmm6
  .byte  102,65,15,114,244,13                // pslld         $0xd,%xmm12
  .byte  102,69,15,235,229                   // por           %xmm13,%xmm12
  .byte  102,69,15,254,227                   // paddd         %xmm11,%xmm12
  .byte  102,65,15,219,244                   // pand          %xmm12,%xmm6
  .byte  102,69,15,112,201,238               // pshufd        $0xee,%xmm9,%xmm9
  .byte  102,69,15,56,51,201                 // pmovzxwd      %xmm9,%xmm9
  .byte  102,69,15,219,193                   // pand          %xmm9,%xmm8
  .byte  102,69,15,219,202                   // pand          %xmm10,%xmm9
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,56,63,249                 // pmaxud        %xmm9,%xmm7
  .byte  102,65,15,118,249                   // pcmpeqd       %xmm9,%xmm7
  .byte  102,65,15,114,241,13                // pslld         $0xd,%xmm9
  .byte  102,69,15,235,200                   // por           %xmm8,%xmm9
  .byte  102,69,15,254,203                   // paddd         %xmm11,%xmm9
  .byte  102,65,15,219,249                   // pand          %xmm9,%xmm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  242,65,15,16,36,192                 // movsd         (%r8,%rax,8),%xmm4
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,13                              // jne           206b8 <_sk_load_f16_dst_sse41+0x17d>
  .byte  243,15,126,228                      // movq          %xmm4,%xmm4
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  233,176,254,255,255                 // jmpq          20568 <_sk_load_f16_dst_sse41+0x2d>
  .byte  102,65,15,22,100,192,8              // movhpd        0x8(%r8,%rax,8),%xmm4
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  15,130,155,254,255,255              // jb            20568 <_sk_load_f16_dst_sse41+0x2d>
  .byte  243,65,15,126,108,192,16            // movq          0x10(%r8,%rax,8),%xmm5
  .byte  233,143,254,255,255                 // jmpq          20568 <_sk_load_f16_dst_sse41+0x2d>

HIDDEN _sk_gather_f16_sse41
.globl _sk_gather_f16_sse41
FUNCTION(_sk_gather_f16_sse41)
_sk_gather_f16_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,80,12                     // movss         0xc(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,69,15,118,192                   // pcmpeqd       %xmm8,%xmm8
  .byte  102,65,15,254,208                   // paddd         %xmm8,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,93,202                        // minps         %xmm2,%xmm9
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,192                   // paddd         %xmm8,%xmm0
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,56,64,200                    // pmulld        %xmm0,%xmm1
  .byte  243,65,15,91,193                    // cvttps2dq     %xmm9,%xmm0
  .byte  102,15,254,193                      // paddd         %xmm1,%xmm0
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,58,22,194,1               // pextrq        $0x1,%xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  243,67,15,126,4,208                 // movq          (%r8,%r10,8),%xmm0
  .byte  243,67,15,126,12,216                // movq          (%r8,%r11,8),%xmm1
  .byte  102,15,108,200                      // punpcklqdq    %xmm0,%xmm1
  .byte  243,65,15,126,4,192                 // movq          (%r8,%rax,8),%xmm0
  .byte  243,67,15,126,20,200                // movq          (%r8,%r9,8),%xmm2
  .byte  102,15,108,208                      // punpcklqdq    %xmm0,%xmm2
  .byte  102,68,15,111,202                   // movdqa        %xmm2,%xmm9
  .byte  102,68,15,97,201                    // punpcklwd     %xmm1,%xmm9
  .byte  102,15,105,209                      // punpckhwd     %xmm1,%xmm2
  .byte  102,69,15,111,225                   // movdqa        %xmm9,%xmm12
  .byte  102,68,15,97,226                    // punpcklwd     %xmm2,%xmm12
  .byte  102,68,15,105,202                   // punpckhwd     %xmm2,%xmm9
  .byte  102,65,15,56,51,212                 // pmovzxwd      %xmm12,%xmm2
  .byte  102,68,15,111,5,138,168,1,0         // movdqa        0x1a88a(%rip),%xmm8        # 3b020 <_sk_srcover_bgra_8888_sse2_lowp+0x10b8>
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,65,15,219,200                   // pand          %xmm8,%xmm1
  .byte  102,68,15,111,21,136,168,1,0        // movdqa        0x1a888(%rip),%xmm10        # 3b030 <_sk_srcover_bgra_8888_sse2_lowp+0x10c8>
  .byte  102,65,15,219,210                   // pand          %xmm10,%xmm2
  .byte  102,15,111,29,139,168,1,0           // movdqa        0x1a88b(%rip),%xmm3        # 3b040 <_sk_srcover_bgra_8888_sse2_lowp+0x10d8>
  .byte  102,15,114,241,16                   // pslld         $0x10,%xmm1
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,56,63,195                    // pmaxud        %xmm3,%xmm0
  .byte  102,15,118,194                      // pcmpeqd       %xmm2,%xmm0
  .byte  102,15,114,242,13                   // pslld         $0xd,%xmm2
  .byte  102,15,235,209                      // por           %xmm1,%xmm2
  .byte  102,68,15,111,29,119,168,1,0        // movdqa        0x1a877(%rip),%xmm11        # 3b050 <_sk_srcover_bgra_8888_sse2_lowp+0x10e8>
  .byte  102,65,15,254,211                   // paddd         %xmm11,%xmm2
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  102,65,15,112,204,238               // pshufd        $0xee,%xmm12,%xmm1
  .byte  102,15,56,51,209                    // pmovzxwd      %xmm1,%xmm2
  .byte  102,68,15,111,226                   // movdqa        %xmm2,%xmm12
  .byte  102,69,15,219,224                   // pand          %xmm8,%xmm12
  .byte  102,65,15,219,210                   // pand          %xmm10,%xmm2
  .byte  102,65,15,114,244,16                // pslld         $0x10,%xmm12
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,56,63,203                    // pmaxud        %xmm3,%xmm1
  .byte  102,15,118,202                      // pcmpeqd       %xmm2,%xmm1
  .byte  102,15,114,242,13                   // pslld         $0xd,%xmm2
  .byte  102,65,15,235,212                   // por           %xmm12,%xmm2
  .byte  102,65,15,254,211                   // paddd         %xmm11,%xmm2
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  102,69,15,56,51,225                 // pmovzxwd      %xmm9,%xmm12
  .byte  102,69,15,111,236                   // movdqa        %xmm12,%xmm13
  .byte  102,69,15,219,232                   // pand          %xmm8,%xmm13
  .byte  102,69,15,219,226                   // pand          %xmm10,%xmm12
  .byte  102,65,15,114,245,16                // pslld         $0x10,%xmm13
  .byte  102,65,15,111,212                   // movdqa        %xmm12,%xmm2
  .byte  102,15,56,63,211                    // pmaxud        %xmm3,%xmm2
  .byte  102,65,15,118,212                   // pcmpeqd       %xmm12,%xmm2
  .byte  102,65,15,114,244,13                // pslld         $0xd,%xmm12
  .byte  102,69,15,235,229                   // por           %xmm13,%xmm12
  .byte  102,69,15,254,227                   // paddd         %xmm11,%xmm12
  .byte  102,65,15,219,212                   // pand          %xmm12,%xmm2
  .byte  102,69,15,112,201,238               // pshufd        $0xee,%xmm9,%xmm9
  .byte  102,69,15,56,51,201                 // pmovzxwd      %xmm9,%xmm9
  .byte  102,69,15,219,193                   // pand          %xmm9,%xmm8
  .byte  102,69,15,219,202                   // pand          %xmm10,%xmm9
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,56,63,217                 // pmaxud        %xmm9,%xmm3
  .byte  102,65,15,118,217                   // pcmpeqd       %xmm9,%xmm3
  .byte  102,65,15,114,241,13                // pslld         $0xd,%xmm9
  .byte  102,69,15,235,200                   // por           %xmm8,%xmm9
  .byte  102,69,15,254,203                   // paddd         %xmm11,%xmm9
  .byte  102,65,15,219,217                   // pand          %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_f16_sse41
.globl _sk_store_f16_sse41
FUNCTION(_sk_store_f16_sse41)
_sk_store_f16_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  102,68,15,111,13,159,167,1,0        // movdqa        0x1a79f(%rip),%xmm9        # 3b060 <_sk_srcover_bgra_8888_sse2_lowp+0x10f8>
  .byte  102,68,15,111,224                   // movdqa        %xmm0,%xmm12
  .byte  102,69,15,219,225                   // pand          %xmm9,%xmm12
  .byte  102,68,15,111,29,156,167,1,0        // movdqa        0x1a79c(%rip),%xmm11        # 3b070 <_sk_srcover_bgra_8888_sse2_lowp+0x1108>
  .byte  102,68,15,111,232                   // movdqa        %xmm0,%xmm13
  .byte  102,69,15,219,235                   // pand          %xmm11,%xmm13
  .byte  102,68,15,111,21,153,167,1,0        // movdqa        0x1a799(%rip),%xmm10        # 3b080 <_sk_srcover_bgra_8888_sse2_lowp+0x1118>
  .byte  102,65,15,114,212,16                // psrld         $0x10,%xmm12
  .byte  102,69,15,111,197                   // movdqa        %xmm13,%xmm8
  .byte  102,69,15,56,63,194                 // pmaxud        %xmm10,%xmm8
  .byte  102,69,15,118,197                   // pcmpeqd       %xmm13,%xmm8
  .byte  102,65,15,114,213,13                // psrld         $0xd,%xmm13
  .byte  102,69,15,254,236                   // paddd         %xmm12,%xmm13
  .byte  102,68,15,111,37,127,167,1,0        // movdqa        0x1a77f(%rip),%xmm12        # 3b090 <_sk_srcover_bgra_8888_sse2_lowp+0x1128>
  .byte  102,69,15,254,236                   // paddd         %xmm12,%xmm13
  .byte  102,69,15,219,197                   // pand          %xmm13,%xmm8
  .byte  102,68,15,56,43,192                 // packusdw      %xmm0,%xmm8
  .byte  102,68,15,111,233                   // movdqa        %xmm1,%xmm13
  .byte  102,69,15,219,233                   // pand          %xmm9,%xmm13
  .byte  102,68,15,111,241                   // movdqa        %xmm1,%xmm14
  .byte  102,69,15,219,243                   // pand          %xmm11,%xmm14
  .byte  102,65,15,114,213,16                // psrld         $0x10,%xmm13
  .byte  102,69,15,111,254                   // movdqa        %xmm14,%xmm15
  .byte  102,69,15,56,63,250                 // pmaxud        %xmm10,%xmm15
  .byte  102,69,15,118,254                   // pcmpeqd       %xmm14,%xmm15
  .byte  102,65,15,114,214,13                // psrld         $0xd,%xmm14
  .byte  102,69,15,254,245                   // paddd         %xmm13,%xmm14
  .byte  102,69,15,254,244                   // paddd         %xmm12,%xmm14
  .byte  102,69,15,219,254                   // pand          %xmm14,%xmm15
  .byte  102,68,15,56,43,248                 // packusdw      %xmm0,%xmm15
  .byte  102,69,15,97,199                    // punpcklwd     %xmm15,%xmm8
  .byte  102,68,15,111,242                   // movdqa        %xmm2,%xmm14
  .byte  102,69,15,219,241                   // pand          %xmm9,%xmm14
  .byte  102,68,15,111,250                   // movdqa        %xmm2,%xmm15
  .byte  102,69,15,219,251                   // pand          %xmm11,%xmm15
  .byte  102,65,15,114,214,16                // psrld         $0x10,%xmm14
  .byte  102,69,15,111,239                   // movdqa        %xmm15,%xmm13
  .byte  102,69,15,56,63,234                 // pmaxud        %xmm10,%xmm13
  .byte  102,69,15,118,239                   // pcmpeqd       %xmm15,%xmm13
  .byte  102,65,15,114,215,13                // psrld         $0xd,%xmm15
  .byte  102,69,15,254,254                   // paddd         %xmm14,%xmm15
  .byte  102,69,15,254,252                   // paddd         %xmm12,%xmm15
  .byte  102,69,15,219,239                   // pand          %xmm15,%xmm13
  .byte  102,68,15,56,43,232                 // packusdw      %xmm0,%xmm13
  .byte  102,68,15,219,203                   // pand          %xmm3,%xmm9
  .byte  102,68,15,219,219                   // pand          %xmm3,%xmm11
  .byte  102,65,15,114,209,16                // psrld         $0x10,%xmm9
  .byte  102,69,15,56,63,211                 // pmaxud        %xmm11,%xmm10
  .byte  102,69,15,118,211                   // pcmpeqd       %xmm11,%xmm10
  .byte  102,65,15,114,211,13                // psrld         $0xd,%xmm11
  .byte  102,69,15,254,217                   // paddd         %xmm9,%xmm11
  .byte  102,69,15,254,220                   // paddd         %xmm12,%xmm11
  .byte  102,69,15,219,211                   // pand          %xmm11,%xmm10
  .byte  102,68,15,56,43,208                 // packusdw      %xmm0,%xmm10
  .byte  102,69,15,97,234                    // punpcklwd     %xmm10,%xmm13
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,69,15,98,205                    // punpckldq     %xmm13,%xmm9
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,21                              // jne           20a0f <_sk_store_f16_sse41+0x16e>
  .byte  69,15,17,12,192                     // movups        %xmm9,(%r8,%rax,8)
  .byte  102,69,15,106,197                   // punpckhdq     %xmm13,%xmm8
  .byte  243,69,15,127,68,192,16             // movdqu        %xmm8,0x10(%r8,%rax,8)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,214,12,192                // movq          %xmm9,(%r8,%rax,8)
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,240                             // je            20a0b <_sk_store_f16_sse41+0x16a>
  .byte  102,69,15,23,76,192,8               // movhpd        %xmm9,0x8(%r8,%rax,8)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,227                             // jb            20a0b <_sk_store_f16_sse41+0x16a>
  .byte  102,69,15,106,197                   // punpckhdq     %xmm13,%xmm8
  .byte  102,69,15,214,68,192,16             // movq          %xmm8,0x10(%r8,%rax,8)
  .byte  235,213                             // jmp           20a0b <_sk_store_f16_sse41+0x16a>

HIDDEN _sk_load_u16_be_sse41
.globl _sk_load_u16_be_sse41
FUNCTION(_sk_load_u16_be_sse41)
_sk_load_u16_be_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,185,0,0,0                    // jne           20b16 <_sk_load_u16_be_sse41+0xe0>
  .byte  102,65,15,16,4,64                   // movupd        (%r8,%rax,2),%xmm0
  .byte  243,65,15,111,76,64,16              // movdqu        0x10(%r8,%rax,2),%xmm1
  .byte  102,15,40,208                       // movapd        %xmm0,%xmm2
  .byte  102,15,97,209                       // punpcklwd     %xmm1,%xmm2
  .byte  102,15,105,193                      // punpckhwd     %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  102,15,105,208                      // punpckhwd     %xmm0,%xmm2
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,113,240,8                    // psllw         $0x8,%xmm0
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,235,200                      // por           %xmm0,%xmm1
  .byte  102,15,56,51,193                    // pmovzxwd      %xmm1,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  68,15,40,5,71,163,1,0               // movaps        0x1a347(%rip),%xmm8        # 3adf0 <_sk_srcover_bgra_8888_sse2_lowp+0xe88>
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,113,241,8                    // psllw         $0x8,%xmm1
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,235,217                      // por           %xmm1,%xmm3
  .byte  102,15,56,51,203                    // pmovzxwd      %xmm3,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  102,68,15,111,202                   // movdqa        %xmm2,%xmm9
  .byte  102,65,15,113,241,8                 // psllw         $0x8,%xmm9
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,65,15,235,209                   // por           %xmm9,%xmm2
  .byte  102,15,56,51,210                    // pmovzxwd      %xmm2,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  102,68,15,111,203                   // movdqa        %xmm3,%xmm9
  .byte  102,65,15,113,241,8                 // psllw         $0x8,%xmm9
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,65,15,235,217                   // por           %xmm9,%xmm3
  .byte  102,15,56,51,219                    // pmovzxwd      %xmm3,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  242,65,15,16,4,64                   // movsd         (%r8,%rax,2),%xmm0
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,13                              // jne           20b2f <_sk_load_u16_be_sse41+0xf9>
  .byte  243,15,126,192                      // movq          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  233,59,255,255,255                  // jmpq          20a6a <_sk_load_u16_be_sse41+0x34>
  .byte  102,65,15,22,68,64,8                // movhpd        0x8(%r8,%rax,2),%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  15,130,38,255,255,255               // jb            20a6a <_sk_load_u16_be_sse41+0x34>
  .byte  243,65,15,126,76,64,16              // movq          0x10(%r8,%rax,2),%xmm1
  .byte  233,26,255,255,255                  // jmpq          20a6a <_sk_load_u16_be_sse41+0x34>

HIDDEN _sk_load_rgb_u16_be_sse41
.globl _sk_load_rgb_u16_be_sse41
FUNCTION(_sk_load_rgb_u16_be_sse41)
_sk_load_rgb_u16_be_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,137,208                          // mov           %rdx,%rax
  .byte  72,193,224,32                       // shl           $0x20,%rax
  .byte  72,141,4,64                         // lea           (%rax,%rax,2),%rax
  .byte  72,193,248,32                       // sar           $0x20,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,170,0,0,0                    // jne           20c25 <_sk_load_rgb_u16_be_sse41+0xd5>
  .byte  243,65,15,111,20,64                 // movdqu        (%r8,%rax,2),%xmm2
  .byte  243,65,15,111,92,64,8               // movdqu        0x8(%r8,%rax,2),%xmm3
  .byte  102,15,115,219,4                    // psrldq        $0x4,%xmm3
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,115,216,6                    // psrldq        $0x6,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,115,217,6                    // psrldq        $0x6,%xmm1
  .byte  102,15,97,193                       // punpcklwd     %xmm1,%xmm0
  .byte  102,15,97,211                       // punpcklwd     %xmm3,%xmm2
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,15,105,208                      // punpckhwd     %xmm0,%xmm2
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,113,240,8                    // psllw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,235,200                      // por           %xmm0,%xmm1
  .byte  102,15,56,51,193                    // pmovzxwd      %xmm1,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  68,15,40,5,22,162,1,0               // movaps        0x1a216(%rip),%xmm8        # 3adf0 <_sk_srcover_bgra_8888_sse2_lowp+0xe88>
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,113,241,8                    // psllw         $0x8,%xmm1
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,235,217                      // por           %xmm1,%xmm3
  .byte  102,15,56,51,203                    // pmovzxwd      %xmm3,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,113,243,8                    // psllw         $0x8,%xmm3
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,235,211                      // por           %xmm3,%xmm2
  .byte  102,15,56,51,210                    // pmovzxwd      %xmm2,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,45,159,1,0                 // movaps        0x19f2d(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  255,224                             // jmpq          *%rax
  .byte  102,65,15,110,20,64                 // movd          (%r8,%rax,2),%xmm2
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,65,15,196,84,64,4,2             // pinsrw        $0x2,0x4(%r8,%rax,2),%xmm2
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,13                              // jne           20c4a <_sk_load_rgb_u16_be_sse41+0xfa>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  233,85,255,255,255                  // jmpq          20b9f <_sk_load_rgb_u16_be_sse41+0x4f>
  .byte  102,65,15,110,68,64,6               // movd          0x6(%r8,%rax,2),%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,65,15,196,68,64,10,2            // pinsrw        $0x2,0xa(%r8,%rax,2),%xmm0
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,24                              // jb            20c7b <_sk_load_rgb_u16_be_sse41+0x12b>
  .byte  102,65,15,110,92,64,12              // movd          0xc(%r8,%rax,2),%xmm3
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,65,15,196,92,64,16,2            // pinsrw        $0x2,0x10(%r8,%rax,2),%xmm3
  .byte  233,36,255,255,255                  // jmpq          20b9f <_sk_load_rgb_u16_be_sse41+0x4f>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  233,27,255,255,255                  // jmpq          20b9f <_sk_load_rgb_u16_be_sse41+0x4f>

HIDDEN _sk_store_u16_be_sse41
.globl _sk_store_u16_be_sse41
FUNCTION(_sk_store_u16_be_sse41)
_sk_store_u16_be_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  68,15,95,192                        // maxps         %xmm0,%xmm8
  .byte  68,15,40,21,154,158,1,0             // movaps        0x19e9a(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,194                        // minps         %xmm10,%xmm8
  .byte  68,15,40,29,222,163,1,0             // movaps        0x1a3de(%rip),%xmm11        # 3b0a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1138>
  .byte  69,15,89,195                        // mulps         %xmm11,%xmm8
  .byte  102,69,15,91,192                    // cvtps2dq      %xmm8,%xmm8
  .byte  102,68,15,56,43,192                 // packusdw      %xmm0,%xmm8
  .byte  102,69,15,111,224                   // movdqa        %xmm8,%xmm12
  .byte  102,65,15,113,244,8                 // psllw         $0x8,%xmm12
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  102,69,15,235,196                   // por           %xmm12,%xmm8
  .byte  102,69,15,239,228                   // pxor          %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  102,69,15,91,228                    // cvtps2dq      %xmm12,%xmm12
  .byte  102,68,15,56,43,224                 // packusdw      %xmm0,%xmm12
  .byte  102,69,15,111,236                   // movdqa        %xmm12,%xmm13
  .byte  102,65,15,113,245,8                 // psllw         $0x8,%xmm13
  .byte  102,65,15,113,212,8                 // psrlw         $0x8,%xmm12
  .byte  102,69,15,235,229                   // por           %xmm13,%xmm12
  .byte  102,69,15,97,196                    // punpcklwd     %xmm12,%xmm8
  .byte  102,69,15,239,228                   // pxor          %xmm12,%xmm12
  .byte  68,15,95,226                        // maxps         %xmm2,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  102,69,15,91,228                    // cvtps2dq      %xmm12,%xmm12
  .byte  102,68,15,56,43,224                 // packusdw      %xmm0,%xmm12
  .byte  102,69,15,111,236                   // movdqa        %xmm12,%xmm13
  .byte  102,65,15,113,245,8                 // psllw         $0x8,%xmm13
  .byte  102,65,15,113,212,8                 // psrlw         $0x8,%xmm12
  .byte  102,69,15,235,229                   // por           %xmm13,%xmm12
  .byte  68,15,95,203                        // maxps         %xmm3,%xmm9
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  102,68,15,56,43,200                 // packusdw      %xmm0,%xmm9
  .byte  102,69,15,111,209                   // movdqa        %xmm9,%xmm10
  .byte  102,65,15,113,242,8                 // psllw         $0x8,%xmm10
  .byte  102,65,15,113,209,8                 // psrlw         $0x8,%xmm9
  .byte  102,69,15,235,202                   // por           %xmm10,%xmm9
  .byte  102,69,15,97,225                    // punpcklwd     %xmm9,%xmm12
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,69,15,98,204                    // punpckldq     %xmm12,%xmm9
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,21                              // jne           20da6 <_sk_store_u16_be_sse41+0x122>
  .byte  69,15,17,12,64                      // movups        %xmm9,(%r8,%rax,2)
  .byte  102,69,15,106,196                   // punpckhdq     %xmm12,%xmm8
  .byte  243,69,15,127,68,64,16              // movdqu        %xmm8,0x10(%r8,%rax,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,214,12,64                 // movq          %xmm9,(%r8,%rax,2)
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,240                             // je            20da2 <_sk_store_u16_be_sse41+0x11e>
  .byte  102,69,15,23,76,64,8                // movhpd        %xmm9,0x8(%r8,%rax,2)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,227                             // jb            20da2 <_sk_store_u16_be_sse41+0x11e>
  .byte  102,69,15,106,196                   // punpckhdq     %xmm12,%xmm8
  .byte  102,69,15,214,68,64,16              // movq          %xmm8,0x10(%r8,%rax,2)
  .byte  235,213                             // jmp           20da2 <_sk_store_u16_be_sse41+0x11e>

HIDDEN _sk_load_f32_sse41
.globl _sk_load_f32_sse41
FUNCTION(_sk_load_f32_sse41)
_sk_load_f32_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  69,15,16,4,128                      // movups        (%r8,%rax,4),%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,66                              // jne           20e38 <_sk_load_f32_sse41+0x6b>
  .byte  65,15,16,68,128,16                  // movups        0x10(%r8,%rax,4),%xmm0
  .byte  65,15,16,92,128,32                  // movups        0x20(%r8,%rax,4),%xmm3
  .byte  69,15,16,76,128,48                  // movups        0x30(%r8,%rax,4),%xmm9
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  15,20,208                           // unpcklps      %xmm0,%xmm2
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  65,15,20,201                        // unpcklps      %xmm9,%xmm1
  .byte  68,15,21,192                        // unpckhps      %xmm0,%xmm8
  .byte  65,15,21,217                        // unpckhps      %xmm9,%xmm3
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  102,15,20,193                       // unpcklpd      %xmm1,%xmm0
  .byte  15,18,202                           // movhlps       %xmm2,%xmm1
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  65,15,18,216                        // movhlps       %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,8                               // jne           20e4a <_sk_load_f32_sse41+0x7d>
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  235,190                             // jmp           20e08 <_sk_load_f32_sse41+0x3b>
  .byte  65,15,16,68,128,16                  // movups        0x10(%r8,%rax,4),%xmm0
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,8                               // jb            20e5e <_sk_load_f32_sse41+0x91>
  .byte  65,15,16,92,128,32                  // movups        0x20(%r8,%rax,4),%xmm3
  .byte  235,170                             // jmp           20e08 <_sk_load_f32_sse41+0x3b>
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  235,165                             // jmp           20e08 <_sk_load_f32_sse41+0x3b>

HIDDEN _sk_load_f32_dst_sse41
.globl _sk_load_f32_dst_sse41
FUNCTION(_sk_load_f32_dst_sse41)
_sk_load_f32_dst_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  69,15,16,4,128                      // movups        (%r8,%rax,4),%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,66                              // jne           20ece <_sk_load_f32_dst_sse41+0x6b>
  .byte  65,15,16,100,128,16                 // movups        0x10(%r8,%rax,4),%xmm4
  .byte  65,15,16,124,128,32                 // movups        0x20(%r8,%rax,4),%xmm7
  .byte  69,15,16,76,128,48                  // movups        0x30(%r8,%rax,4),%xmm9
  .byte  65,15,40,240                        // movaps        %xmm8,%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  15,40,239                           // movaps        %xmm7,%xmm5
  .byte  65,15,20,233                        // unpcklps      %xmm9,%xmm5
  .byte  68,15,21,196                        // unpckhps      %xmm4,%xmm8
  .byte  65,15,21,249                        // unpckhps      %xmm9,%xmm7
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  102,15,20,229                       // unpcklpd      %xmm5,%xmm4
  .byte  15,18,238                           // movhlps       %xmm6,%xmm5
  .byte  65,15,40,240                        // movaps        %xmm8,%xmm6
  .byte  102,15,20,247                       // unpcklpd      %xmm7,%xmm6
  .byte  65,15,18,248                        // movhlps       %xmm8,%xmm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,8                               // jne           20ee0 <_sk_load_f32_dst_sse41+0x7d>
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  235,190                             // jmp           20e9e <_sk_load_f32_dst_sse41+0x3b>
  .byte  65,15,16,100,128,16                 // movups        0x10(%r8,%rax,4),%xmm4
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,8                               // jb            20ef4 <_sk_load_f32_dst_sse41+0x91>
  .byte  65,15,16,124,128,32                 // movups        0x20(%r8,%rax,4),%xmm7
  .byte  235,170                             // jmp           20e9e <_sk_load_f32_dst_sse41+0x3b>
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  235,165                             // jmp           20e9e <_sk_load_f32_dst_sse41+0x3b>

HIDDEN _sk_store_f32_sse41
.globl _sk_store_f32_sse41
FUNCTION(_sk_store_f32_sse41)
_sk_store_f32_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  68,15,20,201                        // unpcklps      %xmm1,%xmm9
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  68,15,20,195                        // unpcklps      %xmm3,%xmm8
  .byte  68,15,40,208                        // movaps        %xmm0,%xmm10
  .byte  68,15,21,209                        // unpckhps      %xmm1,%xmm10
  .byte  68,15,40,218                        // movaps        %xmm2,%xmm11
  .byte  68,15,21,219                        // unpckhps      %xmm3,%xmm11
  .byte  69,15,40,225                        // movaps        %xmm9,%xmm12
  .byte  102,69,15,20,224                    // unpcklpd      %xmm8,%xmm12
  .byte  69,15,18,193                        // movhlps       %xmm9,%xmm8
  .byte  69,15,40,202                        // movaps        %xmm10,%xmm9
  .byte  102,69,15,20,203                    // unpcklpd      %xmm11,%xmm9
  .byte  102,69,15,17,36,128                 // movupd        %xmm12,(%r8,%rax,4)
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,29                              // jne           20f76 <_sk_store_f32_sse41+0x7d>
  .byte  102,69,15,21,211                    // unpckhpd      %xmm11,%xmm10
  .byte  69,15,17,68,128,16                  // movups        %xmm8,0x10(%r8,%rax,4)
  .byte  102,69,15,17,76,128,32              // movupd        %xmm9,0x20(%r8,%rax,4)
  .byte  102,69,15,17,84,128,48              // movupd        %xmm10,0x30(%r8,%rax,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,246                             // je            20f72 <_sk_store_f32_sse41+0x79>
  .byte  69,15,17,68,128,16                  // movups        %xmm8,0x10(%r8,%rax,4)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,234                             // jb            20f72 <_sk_store_f32_sse41+0x79>
  .byte  102,69,15,17,76,128,32              // movupd        %xmm9,0x20(%r8,%rax,4)
  .byte  235,225                             // jmp           20f72 <_sk_store_f32_sse41+0x79>

HIDDEN _sk_repeat_x_sse41
.globl _sk_repeat_x_sse41
FUNCTION(_sk_repeat_x_sse41)
_sk_repeat_x_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  102,69,15,58,8,201,1                // roundps       $0x1,%xmm9,%xmm9
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  65,15,92,192                        // subps         %xmm8,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_repeat_y_sse41
.globl _sk_repeat_y_sse41
FUNCTION(_sk_repeat_y_sse41)
_sk_repeat_y_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  102,69,15,58,8,201,1                // roundps       $0x1,%xmm9,%xmm9
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  65,15,92,200                        // subps         %xmm8,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_x_sse41
.globl _sk_mirror_x_sse41
FUNCTION(_sk_mirror_x_sse41)
_sk_mirror_x_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,40,208                        // movaps        %xmm8,%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  65,15,92,194                        // subps         %xmm10,%xmm0
  .byte  243,69,15,88,192                    // addss         %xmm8,%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  243,68,15,89,13,250,145,1,0         // mulss         0x191fa(%rip),%xmm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  102,69,15,58,8,201,1                // roundps       $0x1,%xmm9,%xmm9
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  65,15,92,193                        // subps         %xmm9,%xmm0
  .byte  65,15,92,194                        // subps         %xmm10,%xmm0
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  68,15,92,192                        // subps         %xmm0,%xmm8
  .byte  65,15,84,192                        // andps         %xmm8,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_y_sse41
.globl _sk_mirror_y_sse41
FUNCTION(_sk_mirror_y_sse41)
_sk_mirror_y_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,40,208                        // movaps        %xmm8,%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  65,15,92,202                        // subps         %xmm10,%xmm1
  .byte  243,69,15,88,192                    // addss         %xmm8,%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  243,68,15,89,13,161,145,1,0         // mulss         0x191a1(%rip),%xmm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  102,69,15,58,8,201,1                // roundps       $0x1,%xmm9,%xmm9
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  65,15,92,201                        // subps         %xmm9,%xmm1
  .byte  65,15,92,202                        // subps         %xmm10,%xmm1
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  68,15,92,193                        // subps         %xmm1,%xmm8
  .byte  65,15,84,200                        // andps         %xmm8,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_x_1_sse41
.globl _sk_clamp_x_1_sse41
FUNCTION(_sk_clamp_x_1_sse41)
_sk_clamp_x_1_sse41:
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  68,15,95,192                        // maxps         %xmm0,%xmm8
  .byte  68,15,93,5,161,154,1,0              // minps         0x19aa1(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_repeat_x_1_sse41
.globl _sk_repeat_x_1_sse41
FUNCTION(_sk_repeat_x_1_sse41)
_sk_repeat_x_1_sse41:
  .byte  102,68,15,58,8,192,1                // roundps       $0x1,%xmm0,%xmm8
  .byte  65,15,92,192                        // subps         %xmm8,%xmm0
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  68,15,95,192                        // maxps         %xmm0,%xmm8
  .byte  68,15,93,5,126,154,1,0              // minps         0x19a7e(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_x_1_sse41
.globl _sk_mirror_x_1_sse41
FUNCTION(_sk_mirror_x_1_sse41)
_sk_mirror_x_1_sse41:
  .byte  68,15,40,5,206,154,1,0              // movaps        0x19ace(%rip),%xmm8        # 3abb0 <_sk_srcover_bgra_8888_sse2_lowp+0xc48>
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  68,15,40,13,82,154,1,0              // movaps        0x19a52(%rip),%xmm9        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  102,69,15,58,8,201,1                // roundps       $0x1,%xmm9,%xmm9
  .byte  69,15,88,201                        // addps         %xmm9,%xmm9
  .byte  65,15,92,193                        // subps         %xmm9,%xmm0
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,92,200                        // subps         %xmm0,%xmm9
  .byte  68,15,84,200                        // andps         %xmm0,%xmm9
  .byte  69,15,95,193                        // maxps         %xmm9,%xmm8
  .byte  68,15,93,5,47,154,1,0               // minps         0x19a2f(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_luminance_to_alpha_sse41
.globl _sk_luminance_to_alpha_sse41
FUNCTION(_sk_luminance_to_alpha_sse41)
_sk_luminance_to_alpha_sse41:
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,89,5,125,159,1,0                 // mulps         0x19f7d(%rip),%xmm0        # 3b0b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1148>
  .byte  15,89,13,134,159,1,0                // mulps         0x19f86(%rip),%xmm1        # 3b0c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1158>
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  15,89,29,140,159,1,0                // mulps         0x19f8c(%rip),%xmm3        # 3b0d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1168>
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_translate_sse41
.globl _sk_matrix_translate_sse41
FUNCTION(_sk_matrix_translate_sse41)
_sk_matrix_translate_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  65,15,88,201                        // addps         %xmm9,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_scale_translate_sse41
.globl _sk_matrix_scale_translate_sse41
FUNCTION(_sk_matrix_scale_translate_sse41)
_sk_matrix_scale_translate_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  65,15,89,201                        // mulps         %xmm9,%xmm1
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_2x3_sse41
.globl _sk_matrix_2x3_sse41
FUNCTION(_sk_matrix_2x3_sse41)
_sk_matrix_2x3_sse41:
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,16                  // movss         0x10(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,68,15,16,80,12                  // movss         0xc(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,20                  // movss         0x14(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_3x4_sse41
.globl _sk_matrix_3x4_sse41
FUNCTION(_sk_matrix_3x4_sse41)
_sk_matrix_3x4_sse41:
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,68,15,16,80,12                  // movss         0xc(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,24                  // movss         0x18(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,36                  // movss         0x24(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,68,15,16,80,16                  // movss         0x10(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,28                  // movss         0x1c(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,40                  // movss         0x28(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,20                  // movss         0x14(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,32                  // movss         0x20(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,104,44                 // movss         0x2c(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  68,15,89,226                        // mulps         %xmm2,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  69,15,89,217                        // mulps         %xmm9,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,208                        // mulps         %xmm8,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_4x5_sse41
.globl _sk_matrix_4x5_sse41
FUNCTION(_sk_matrix_4x5_sse41)
_sk_matrix_4x5_sse41:
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,68,15,16,80,16                  // movss         0x10(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,32                  // movss         0x20(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,48                  // movss         0x30(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,104,64                 // movss         0x40(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  68,15,89,227                        // mulps         %xmm3,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,68,15,16,80,20                  // movss         0x14(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,36                  // movss         0x24(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,52                  // movss         0x34(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,104,68                 // movss         0x44(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  68,15,89,227                        // mulps         %xmm3,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,24                  // movss         0x18(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,40                  // movss         0x28(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,104,56                 // movss         0x38(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  243,68,15,16,112,72                 // movss         0x48(%rax),%xmm14
  .byte  69,15,198,246,0                     // shufps        $0x0,%xmm14,%xmm14
  .byte  68,15,89,235                        // mulps         %xmm3,%xmm13
  .byte  69,15,88,238                        // addps         %xmm14,%xmm13
  .byte  68,15,89,226                        // mulps         %xmm2,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  69,15,89,217                        // mulps         %xmm9,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,208                        // mulps         %xmm8,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  243,68,15,16,88,12                  // movss         0xc(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,28                  // movss         0x1c(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,104,44                 // movss         0x2c(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  243,68,15,16,112,60                 // movss         0x3c(%rax),%xmm14
  .byte  69,15,198,246,0                     // shufps        $0x0,%xmm14,%xmm14
  .byte  243,68,15,16,120,76                 // movss         0x4c(%rax),%xmm15
  .byte  69,15,198,255,0                     // shufps        $0x0,%xmm15,%xmm15
  .byte  68,15,89,243                        // mulps         %xmm3,%xmm14
  .byte  69,15,88,247                        // addps         %xmm15,%xmm14
  .byte  68,15,89,234                        // mulps         %xmm2,%xmm13
  .byte  69,15,88,238                        // addps         %xmm14,%xmm13
  .byte  69,15,89,225                        // mulps         %xmm9,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,40,219                        // movaps        %xmm11,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_4x3_sse41
.globl _sk_matrix_4x3_sse41
FUNCTION(_sk_matrix_4x3_sse41)
_sk_matrix_4x3_sse41:
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,15,16,80,16                     // movss         0x10(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,88,32                     // movss         0x20(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,80,20                     // movss         0x14(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,88,36                     // movss         0x24(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  243,15,16,80,8                      // movss         0x8(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,88,24                     // movss         0x18(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  243,68,15,16,80,40                  // movss         0x28(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  65,15,89,217                        // mulps         %xmm9,%xmm3
  .byte  65,15,88,218                        // addps         %xmm10,%xmm3
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  243,15,16,88,12                     // movss         0xc(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  243,68,15,16,80,28                  // movss         0x1c(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,44                  // movss         0x2c(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  65,15,88,218                        // addps         %xmm10,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_perspective_sse41
.globl _sk_matrix_perspective_sse41
FUNCTION(_sk_matrix_perspective_sse41)
_sk_matrix_perspective_sse41:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,193                        // addps         %xmm9,%xmm0
  .byte  243,68,15,16,72,12                  // movss         0xc(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  243,68,15,16,80,16                  // movss         0x10(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,20                  // movss         0x14(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  68,15,89,209                        // mulps         %xmm1,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  243,68,15,16,80,24                  // movss         0x18(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,28                  // movss         0x1c(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,32                  // movss         0x20(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  68,15,89,217                        // mulps         %xmm1,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,208                        // mulps         %xmm8,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,83,202                        // rcpps         %xmm10,%xmm1
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_gradient_sse41
.globl _sk_evenly_spaced_gradient_sse41
FUNCTION(_sk_evenly_spaced_gradient_sse41)
_sk_evenly_spaced_gradient_sse41:
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,139,24                           // mov           (%rax),%rbx
  .byte  76,139,112,8                        // mov           0x8(%rax),%r14
  .byte  72,255,203                          // dec           %rbx
  .byte  120,7                               // js            215e4 <_sk_evenly_spaced_gradient_sse41+0x18>
  .byte  243,72,15,42,203                    // cvtsi2ss      %rbx,%xmm1
  .byte  235,21                              // jmp           215f9 <_sk_evenly_spaced_gradient_sse41+0x2d>
  .byte  73,137,216                          // mov           %rbx,%r8
  .byte  73,209,232                          // shr           %r8
  .byte  131,227,1                           // and           $0x1,%ebx
  .byte  76,9,195                            // or            %r8,%rbx
  .byte  243,72,15,42,203                    // cvtsi2ss      %rbx,%xmm1
  .byte  243,15,88,201                       // addss         %xmm1,%xmm1
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,73,15,58,22,200,1               // pextrq        $0x1,%xmm1,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  243,71,15,16,4,158                  // movss         (%r14,%r11,4),%xmm8
  .byte  102,71,15,58,33,4,150,16            // insertps      $0x10,(%r14,%r10,4),%xmm8
  .byte  243,67,15,16,12,142                 // movss         (%r14,%r9,4),%xmm1
  .byte  102,68,15,58,33,193,32              // insertps      $0x20,%xmm1,%xmm8
  .byte  243,67,15,16,12,134                 // movss         (%r14,%r8,4),%xmm1
  .byte  102,68,15,58,33,193,48              // insertps      $0x30,%xmm1,%xmm8
  .byte  72,139,88,40                        // mov           0x28(%rax),%rbx
  .byte  243,70,15,16,12,155                 // movss         (%rbx,%r11,4),%xmm9
  .byte  102,70,15,58,33,12,147,16           // insertps      $0x10,(%rbx,%r10,4),%xmm9
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  102,68,15,58,33,201,32              // insertps      $0x20,%xmm1,%xmm9
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  102,68,15,58,33,201,48              // insertps      $0x30,%xmm1,%xmm9
  .byte  72,139,88,16                        // mov           0x10(%rax),%rbx
  .byte  243,66,15,16,12,155                 // movss         (%rbx,%r11,4),%xmm1
  .byte  102,66,15,58,33,12,147,16           // insertps      $0x10,(%rbx,%r10,4),%xmm1
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  102,15,58,33,202,32                 // insertps      $0x20,%xmm2,%xmm1
  .byte  243,66,15,16,20,131                 // movss         (%rbx,%r8,4),%xmm2
  .byte  102,15,58,33,202,48                 // insertps      $0x30,%xmm2,%xmm1
  .byte  72,139,88,48                        // mov           0x30(%rax),%rbx
  .byte  243,70,15,16,20,155                 // movss         (%rbx,%r11,4),%xmm10
  .byte  102,70,15,58,33,20,147,16           // insertps      $0x10,(%rbx,%r10,4),%xmm10
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  102,68,15,58,33,210,32              // insertps      $0x20,%xmm2,%xmm10
  .byte  243,66,15,16,20,131                 // movss         (%rbx,%r8,4),%xmm2
  .byte  102,68,15,58,33,210,48              // insertps      $0x30,%xmm2,%xmm10
  .byte  72,139,88,24                        // mov           0x18(%rax),%rbx
  .byte  243,66,15,16,20,155                 // movss         (%rbx,%r11,4),%xmm2
  .byte  102,66,15,58,33,20,147,16           // insertps      $0x10,(%rbx,%r10,4),%xmm2
  .byte  243,66,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm3
  .byte  102,15,58,33,211,32                 // insertps      $0x20,%xmm3,%xmm2
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  102,15,58,33,211,48                 // insertps      $0x30,%xmm3,%xmm2
  .byte  72,139,88,56                        // mov           0x38(%rax),%rbx
  .byte  243,70,15,16,28,155                 // movss         (%rbx,%r11,4),%xmm11
  .byte  102,70,15,58,33,28,147,16           // insertps      $0x10,(%rbx,%r10,4),%xmm11
  .byte  243,66,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm3
  .byte  102,68,15,58,33,219,32              // insertps      $0x20,%xmm3,%xmm11
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  102,68,15,58,33,219,48              // insertps      $0x30,%xmm3,%xmm11
  .byte  72,139,88,32                        // mov           0x20(%rax),%rbx
  .byte  243,66,15,16,28,155                 // movss         (%rbx,%r11,4),%xmm3
  .byte  102,66,15,58,33,28,147,16           // insertps      $0x10,(%rbx,%r10,4),%xmm3
  .byte  243,70,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm12
  .byte  102,65,15,58,33,220,32              // insertps      $0x20,%xmm12,%xmm3
  .byte  243,70,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm12
  .byte  102,65,15,58,33,220,48              // insertps      $0x30,%xmm12,%xmm3
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  243,70,15,16,36,152                 // movss         (%rax,%r11,4),%xmm12
  .byte  102,70,15,58,33,36,144,16           // insertps      $0x10,(%rax,%r10,4),%xmm12
  .byte  243,70,15,16,44,136                 // movss         (%rax,%r9,4),%xmm13
  .byte  102,69,15,58,33,229,32              // insertps      $0x20,%xmm13,%xmm12
  .byte  243,70,15,16,44,128                 // movss         (%rax,%r8,4),%xmm13
  .byte  102,69,15,58,33,229,48              // insertps      $0x30,%xmm13,%xmm12
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  69,15,88,193                        // addps         %xmm9,%xmm8
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  65,15,88,211                        // addps         %xmm11,%xmm2
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  65,15,88,220                        // addps         %xmm12,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gradient_sse41
.globl _sk_gradient_sse41
FUNCTION(_sk_gradient_sse41)
_sk_gradient_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  73,131,248,2                        // cmp           $0x2,%r8
  .byte  114,41                              // jb            217d6 <_sk_gradient_sse41+0x38>
  .byte  76,139,72,72                        // mov           0x48(%rax),%r9
  .byte  73,255,200                          // dec           %r8
  .byte  73,131,193,4                        // add           $0x4,%r9
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  243,65,15,16,17                     // movss         (%r9),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,194,208,2                        // cmpleps       %xmm0,%xmm2
  .byte  102,15,250,202                      // psubd         %xmm2,%xmm1
  .byte  73,131,193,4                        // add           $0x4,%r9
  .byte  73,255,200                          // dec           %r8
  .byte  117,230                             // jne           217bc <_sk_gradient_sse41+0x1e>
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  102,73,15,58,22,200,1               // pextrq        $0x1,%xmm1,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  72,139,88,8                         // mov           0x8(%rax),%rbx
  .byte  76,139,112,16                       // mov           0x10(%rax),%r14
  .byte  243,70,15,16,4,155                  // movss         (%rbx,%r11,4),%xmm8
  .byte  102,70,15,58,33,4,147,16            // insertps      $0x10,(%rbx,%r10,4),%xmm8
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  102,68,15,58,33,193,32              // insertps      $0x20,%xmm1,%xmm8
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  102,68,15,58,33,193,48              // insertps      $0x30,%xmm1,%xmm8
  .byte  72,139,88,40                        // mov           0x28(%rax),%rbx
  .byte  243,70,15,16,12,155                 // movss         (%rbx,%r11,4),%xmm9
  .byte  102,70,15,58,33,12,147,16           // insertps      $0x10,(%rbx,%r10,4),%xmm9
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  102,68,15,58,33,201,32              // insertps      $0x20,%xmm1,%xmm9
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  102,68,15,58,33,201,48              // insertps      $0x30,%xmm1,%xmm9
  .byte  243,67,15,16,12,158                 // movss         (%r14,%r11,4),%xmm1
  .byte  102,67,15,58,33,12,150,16           // insertps      $0x10,(%r14,%r10,4),%xmm1
  .byte  243,67,15,16,20,142                 // movss         (%r14,%r9,4),%xmm2
  .byte  102,15,58,33,202,32                 // insertps      $0x20,%xmm2,%xmm1
  .byte  243,67,15,16,20,134                 // movss         (%r14,%r8,4),%xmm2
  .byte  102,15,58,33,202,48                 // insertps      $0x30,%xmm2,%xmm1
  .byte  72,139,88,48                        // mov           0x30(%rax),%rbx
  .byte  243,70,15,16,20,155                 // movss         (%rbx,%r11,4),%xmm10
  .byte  102,70,15,58,33,20,147,16           // insertps      $0x10,(%rbx,%r10,4),%xmm10
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  102,68,15,58,33,210,32              // insertps      $0x20,%xmm2,%xmm10
  .byte  243,66,15,16,20,131                 // movss         (%rbx,%r8,4),%xmm2
  .byte  102,68,15,58,33,210,48              // insertps      $0x30,%xmm2,%xmm10
  .byte  72,139,88,24                        // mov           0x18(%rax),%rbx
  .byte  243,66,15,16,20,155                 // movss         (%rbx,%r11,4),%xmm2
  .byte  102,66,15,58,33,20,147,16           // insertps      $0x10,(%rbx,%r10,4),%xmm2
  .byte  243,66,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm3
  .byte  102,15,58,33,211,32                 // insertps      $0x20,%xmm3,%xmm2
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  102,15,58,33,211,48                 // insertps      $0x30,%xmm3,%xmm2
  .byte  72,139,88,56                        // mov           0x38(%rax),%rbx
  .byte  243,70,15,16,28,155                 // movss         (%rbx,%r11,4),%xmm11
  .byte  102,70,15,58,33,28,147,16           // insertps      $0x10,(%rbx,%r10,4),%xmm11
  .byte  243,66,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm3
  .byte  102,68,15,58,33,219,32              // insertps      $0x20,%xmm3,%xmm11
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  102,68,15,58,33,219,48              // insertps      $0x30,%xmm3,%xmm11
  .byte  72,139,88,32                        // mov           0x20(%rax),%rbx
  .byte  243,66,15,16,28,155                 // movss         (%rbx,%r11,4),%xmm3
  .byte  102,66,15,58,33,28,147,16           // insertps      $0x10,(%rbx,%r10,4),%xmm3
  .byte  243,70,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm12
  .byte  102,65,15,58,33,220,32              // insertps      $0x20,%xmm12,%xmm3
  .byte  243,70,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm12
  .byte  102,65,15,58,33,220,48              // insertps      $0x30,%xmm12,%xmm3
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  243,70,15,16,36,152                 // movss         (%rax,%r11,4),%xmm12
  .byte  102,70,15,58,33,36,144,16           // insertps      $0x10,(%rax,%r10,4),%xmm12
  .byte  243,70,15,16,44,136                 // movss         (%rax,%r9,4),%xmm13
  .byte  102,69,15,58,33,229,32              // insertps      $0x20,%xmm13,%xmm12
  .byte  243,70,15,16,44,128                 // movss         (%rax,%r8,4),%xmm13
  .byte  102,69,15,58,33,229,48              // insertps      $0x30,%xmm13,%xmm12
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  69,15,88,193                        // addps         %xmm9,%xmm8
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  65,15,88,211                        // addps         %xmm11,%xmm2
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  65,15,88,220                        // addps         %xmm12,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_2_stop_gradient_sse41
.globl _sk_evenly_spaced_2_stop_gradient_sse41
FUNCTION(_sk_evenly_spaced_2_stop_gradient_sse41)
_sk_evenly_spaced_2_stop_gradient_sse41:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,15,16,80,16                     // movss         0x10(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,80,20                     // movss         0x14(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  243,15,16,80,8                      // movss         0x8(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,88,24                     // movss         0x18(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  243,15,16,88,12                     // movss         0xc(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  243,68,15,16,72,28                  // movss         0x1c(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  65,15,88,217                        // addps         %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_unit_angle_sse41
.globl _sk_xy_to_unit_angle_sse41
FUNCTION(_sk_xy_to_unit_angle_sse41)
_sk_xy_to_unit_angle_sse41:
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  65,15,92,193                        // subps         %xmm9,%xmm0
  .byte  65,15,84,193                        // andps         %xmm9,%xmm0
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  68,15,92,217                        // subps         %xmm1,%xmm11
  .byte  68,15,84,217                        // andps         %xmm1,%xmm11
  .byte  68,15,40,224                        // movaps        %xmm0,%xmm12
  .byte  69,15,93,227                        // minps         %xmm11,%xmm12
  .byte  68,15,40,208                        // movaps        %xmm0,%xmm10
  .byte  69,15,95,211                        // maxps         %xmm11,%xmm10
  .byte  69,15,94,226                        // divps         %xmm10,%xmm12
  .byte  69,15,40,236                        // movaps        %xmm12,%xmm13
  .byte  69,15,89,237                        // mulps         %xmm13,%xmm13
  .byte  68,15,40,21,182,150,1,0             // movaps        0x196b6(%rip),%xmm10        # 3b0e0 <_sk_srcover_bgra_8888_sse2_lowp+0x1178>
  .byte  69,15,89,213                        // mulps         %xmm13,%xmm10
  .byte  68,15,88,21,186,150,1,0             // addps         0x196ba(%rip),%xmm10        # 3b0f0 <_sk_srcover_bgra_8888_sse2_lowp+0x1188>
  .byte  69,15,89,213                        // mulps         %xmm13,%xmm10
  .byte  68,15,88,21,190,150,1,0             // addps         0x196be(%rip),%xmm10        # 3b100 <_sk_srcover_bgra_8888_sse2_lowp+0x1198>
  .byte  69,15,89,213                        // mulps         %xmm13,%xmm10
  .byte  68,15,88,21,194,150,1,0             // addps         0x196c2(%rip),%xmm10        # 3b110 <_sk_srcover_bgra_8888_sse2_lowp+0x11a8>
  .byte  69,15,89,212                        // mulps         %xmm12,%xmm10
  .byte  65,15,194,195,1                     // cmpltps       %xmm11,%xmm0
  .byte  68,15,40,29,193,150,1,0             // movaps        0x196c1(%rip),%xmm11        # 3b120 <_sk_srcover_bgra_8888_sse2_lowp+0x11b8>
  .byte  69,15,92,218                        // subps         %xmm10,%xmm11
  .byte  102,69,15,56,20,211                 // blendvps      %xmm0,%xmm11,%xmm10
  .byte  69,15,194,200,1                     // cmpltps       %xmm8,%xmm9
  .byte  68,15,40,29,202,144,1,0             // movaps        0x190ca(%rip),%xmm11        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  69,15,92,218                        // subps         %xmm10,%xmm11
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,69,15,56,20,211                 // blendvps      %xmm0,%xmm11,%xmm10
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  65,15,194,192,1                     // cmpltps       %xmm8,%xmm0
  .byte  68,15,40,13,188,144,1,0             // movaps        0x190bc(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,202                        // subps         %xmm10,%xmm9
  .byte  102,69,15,56,20,209                 // blendvps      %xmm0,%xmm9,%xmm10
  .byte  69,15,194,194,7                     // cmpordps      %xmm10,%xmm8
  .byte  69,15,84,194                        // andps         %xmm10,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_radius_sse41
.globl _sk_xy_to_radius_sse41
FUNCTION(_sk_xy_to_radius_sse41)
_sk_xy_to_radius_sse41:
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  68,15,88,192                        // addps         %xmm0,%xmm8
  .byte  65,15,81,192                        // sqrtps        %xmm8,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_quadratic_first_sse41
.globl _sk_xy_to_2pt_conical_quadratic_first_sse41
FUNCTION(_sk_xy_to_2pt_conical_quadratic_first_sse41)
_sk_xy_to_2pt_conical_quadratic_first_sse41:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,80,64                  // movss         0x40(%rax),%xmm10
  .byte  243,15,16,64,68                     // movss         0x44(%rax),%xmm0
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,72                  // movss         0x48(%rax),%xmm11
  .byte  243,68,15,16,72,76                  // movss         0x4c(%rax),%xmm9
  .byte  243,69,15,89,203                    // mulss         %xmm11,%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  69,15,88,200                        // addps         %xmm8,%xmm9
  .byte  68,15,89,13,50,150,1,0              // mulps         0x19632(%rip),%xmm9        # 3b130 <_sk_srcover_bgra_8888_sse2_lowp+0x11c8>
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  68,15,40,225                        // movaps        %xmm1,%xmm12
  .byte  69,15,89,228                        // mulps         %xmm12,%xmm12
  .byte  69,15,88,224                        // addps         %xmm8,%xmm12
  .byte  243,69,15,89,219                    // mulss         %xmm11,%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,92,227                        // subps         %xmm11,%xmm12
  .byte  68,15,89,21,28,150,1,0              // mulps         0x1961c(%rip),%xmm10        # 3b140 <_sk_srcover_bgra_8888_sse2_lowp+0x11d8>
  .byte  69,15,89,212                        // mulps         %xmm12,%xmm10
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  69,15,88,194                        // addps         %xmm10,%xmm8
  .byte  69,15,81,192                        // sqrtps        %xmm8,%xmm8
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  69,15,92,193                        // subps         %xmm9,%xmm8
  .byte  15,89,5,249,143,1,0                 // mulps         0x18ff9(%rip),%xmm0        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_quadratic_second_sse41
.globl _sk_xy_to_2pt_conical_quadratic_second_sse41
FUNCTION(_sk_xy_to_2pt_conical_quadratic_second_sse41)
_sk_xy_to_2pt_conical_quadratic_second_sse41:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,80,64                  // movss         0x40(%rax),%xmm10
  .byte  243,15,16,64,68                     // movss         0x44(%rax),%xmm0
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,72                  // movss         0x48(%rax),%xmm11
  .byte  243,68,15,16,72,76                  // movss         0x4c(%rax),%xmm9
  .byte  243,69,15,89,203                    // mulss         %xmm11,%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  69,15,88,200                        // addps         %xmm8,%xmm9
  .byte  68,15,89,13,169,149,1,0             // mulps         0x195a9(%rip),%xmm9        # 3b130 <_sk_srcover_bgra_8888_sse2_lowp+0x11c8>
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  68,15,40,225                        // movaps        %xmm1,%xmm12
  .byte  69,15,89,228                        // mulps         %xmm12,%xmm12
  .byte  69,15,88,224                        // addps         %xmm8,%xmm12
  .byte  243,69,15,89,219                    // mulss         %xmm11,%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,92,227                        // subps         %xmm11,%xmm12
  .byte  68,15,89,21,147,149,1,0             // mulps         0x19593(%rip),%xmm10        # 3b140 <_sk_srcover_bgra_8888_sse2_lowp+0x11d8>
  .byte  69,15,89,212                        // mulps         %xmm12,%xmm10
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  69,15,88,194                        // addps         %xmm10,%xmm8
  .byte  69,15,81,192                        // sqrtps        %xmm8,%xmm8
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  68,15,87,13,147,148,1,0             // xorps         0x19493(%rip),%xmm9        # 3b060 <_sk_srcover_bgra_8888_sse2_lowp+0x10f8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  15,89,5,104,143,1,0                 // mulps         0x18f68(%rip),%xmm0        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_linear_sse41
.globl _sk_xy_to_2pt_conical_linear_sse41
FUNCTION(_sk_xy_to_2pt_conical_linear_sse41)
_sk_xy_to_2pt_conical_linear_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,72                  // movss         0x48(%rax),%xmm8
  .byte  243,68,15,16,72,76                  // movss         0x4c(%rax),%xmm9
  .byte  243,69,15,89,200                    // mulss         %xmm8,%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,88,200                        // addps         %xmm0,%xmm9
  .byte  68,15,89,13,44,149,1,0              // mulps         0x1952c(%rip),%xmm9        # 3b130 <_sk_srcover_bgra_8888_sse2_lowp+0x11c8>
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  68,15,40,209                        // movaps        %xmm1,%xmm10
  .byte  69,15,89,210                        // mulps         %xmm10,%xmm10
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  243,69,15,89,192                    // mulss         %xmm8,%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  65,15,92,192                        // subps         %xmm8,%xmm0
  .byte  15,87,5,56,148,1,0                  // xorps         0x19438(%rip),%xmm0        # 3b060 <_sk_srcover_bgra_8888_sse2_lowp+0x10f8>
  .byte  65,15,94,193                        // divps         %xmm9,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mask_2pt_conical_degenerates_sse41
.globl _sk_mask_2pt_conical_degenerates_sse41
FUNCTION(_sk_mask_2pt_conical_degenerates_sse41)
_sk_mask_2pt_conical_degenerates_sse41:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,64,72                     // movss         0x48(%rax),%xmm0
  .byte  243,68,15,16,72,76                  // movss         0x4c(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  68,15,88,200                        // addps         %xmm0,%xmm9
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  69,15,194,202,1                     // cmpltps       %xmm10,%xmm9
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  65,15,194,194,3                     // cmpunordps    %xmm10,%xmm0
  .byte  65,15,86,193                        // orps          %xmm9,%xmm0
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,68,15,239,200                   // pxor          %xmm0,%xmm9
  .byte  102,69,15,56,20,194                 // blendvps      %xmm0,%xmm10,%xmm8
  .byte  243,68,15,127,8                     // movdqu        %xmm9,(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_apply_vector_mask_sse41
.globl _sk_apply_vector_mask_sse41
FUNCTION(_sk_apply_vector_mask_sse41)
_sk_apply_vector_mask_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,15,16,0                          // movups        (%rax),%xmm8
  .byte  65,15,84,192                        // andps         %xmm8,%xmm0
  .byte  65,15,84,200                        // andps         %xmm8,%xmm1
  .byte  65,15,84,208                        // andps         %xmm8,%xmm2
  .byte  65,15,84,216                        // andps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_save_xy_sse41
.globl _sk_save_xy_sse41
FUNCTION(_sk_save_xy_sse41)
_sk_save_xy_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,15,40,5,151,142,1,0              // movaps        0x18e97(%rip),%xmm8        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,17,0                             // movups        %xmm0,(%rax)
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  69,15,88,200                        // addps         %xmm8,%xmm9
  .byte  102,69,15,58,8,209,1                // roundps       $0x1,%xmm9,%xmm10
  .byte  69,15,92,202                        // subps         %xmm10,%xmm9
  .byte  68,15,88,193                        // addps         %xmm1,%xmm8
  .byte  102,69,15,58,8,208,1                // roundps       $0x1,%xmm8,%xmm10
  .byte  69,15,92,194                        // subps         %xmm10,%xmm8
  .byte  15,17,72,64                         // movups        %xmm1,0x40(%rax)
  .byte  68,15,17,136,128,0,0,0              // movups        %xmm9,0x80(%rax)
  .byte  68,15,17,128,192,0,0,0              // movups        %xmm8,0xc0(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_accumulate_sse41
.globl _sk_accumulate_sse41
FUNCTION(_sk_accumulate_sse41)
_sk_accumulate_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,15,16,128,0,1,0,0                // movups        0x100(%rax),%xmm8
  .byte  68,15,16,136,64,1,0,0               // movups        0x140(%rax),%xmm9
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  65,15,88,224                        // addps         %xmm8,%xmm4
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  68,15,89,193                        // mulps         %xmm1,%xmm8
  .byte  65,15,88,232                        // addps         %xmm8,%xmm5
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  68,15,89,194                        // mulps         %xmm2,%xmm8
  .byte  65,15,88,240                        // addps         %xmm8,%xmm6
  .byte  68,15,89,203                        // mulps         %xmm3,%xmm9
  .byte  65,15,88,249                        // addps         %xmm9,%xmm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_nx_sse41
.globl _sk_bilinear_nx_sse41
FUNCTION(_sk_bilinear_nx_sse41)
_sk_bilinear_nx_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  68,15,16,128,128,0,0,0              // movups        0x80(%rax),%xmm8
  .byte  15,88,5,16,148,1,0                  // addps         0x19410(%rip),%xmm0        # 3b150 <_sk_srcover_bgra_8888_sse2_lowp+0x11e8>
  .byte  68,15,40,13,8,142,1,0               // movaps        0x18e08(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  68,15,17,136,0,1,0,0                // movups        %xmm9,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_px_sse41
.globl _sk_bilinear_px_sse41
FUNCTION(_sk_bilinear_px_sse41)
_sk_bilinear_px_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  68,15,16,128,128,0,0,0              // movups        0x80(%rax),%xmm8
  .byte  15,88,5,212,141,1,0                 // addps         0x18dd4(%rip),%xmm0        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,17,128,0,1,0,0                // movups        %xmm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_ny_sse41
.globl _sk_bilinear_ny_sse41
FUNCTION(_sk_bilinear_ny_sse41)
_sk_bilinear_ny_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,72,64                         // movups        0x40(%rax),%xmm1
  .byte  68,15,16,128,192,0,0,0              // movups        0xc0(%rax),%xmm8
  .byte  15,88,13,195,147,1,0                // addps         0x193c3(%rip),%xmm1        # 3b150 <_sk_srcover_bgra_8888_sse2_lowp+0x11e8>
  .byte  68,15,40,13,187,141,1,0             // movaps        0x18dbb(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  68,15,17,136,64,1,0,0               // movups        %xmm9,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_py_sse41
.globl _sk_bilinear_py_sse41
FUNCTION(_sk_bilinear_py_sse41)
_sk_bilinear_py_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,72,64                         // movups        0x40(%rax),%xmm1
  .byte  68,15,16,128,192,0,0,0              // movups        0xc0(%rax),%xmm8
  .byte  15,88,13,134,141,1,0                // addps         0x18d86(%rip),%xmm1        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,17,128,64,1,0,0               // movups        %xmm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n3x_sse41
.globl _sk_bicubic_n3x_sse41
FUNCTION(_sk_bicubic_n3x_sse41)
_sk_bicubic_n3x_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  68,15,16,128,128,0,0,0              // movups        0x80(%rax),%xmm8
  .byte  15,88,5,134,147,1,0                 // addps         0x19386(%rip),%xmm0        # 3b160 <_sk_srcover_bgra_8888_sse2_lowp+0x11f8>
  .byte  68,15,40,13,110,141,1,0             // movaps        0x18d6e(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  68,15,89,13,122,147,1,0             // mulps         0x1937a(%rip),%xmm9        # 3b170 <_sk_srcover_bgra_8888_sse2_lowp+0x1208>
  .byte  68,15,88,13,82,143,1,0              // addps         0x18f52(%rip),%xmm9        # 3ad50 <_sk_srcover_bgra_8888_sse2_lowp+0xde8>
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  68,15,17,136,0,1,0,0                // movups        %xmm9,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n1x_sse41
.globl _sk_bicubic_n1x_sse41
FUNCTION(_sk_bicubic_n1x_sse41)
_sk_bicubic_n1x_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  68,15,16,128,128,0,0,0              // movups        0x80(%rax),%xmm8
  .byte  15,88,5,46,147,1,0                  // addps         0x1932e(%rip),%xmm0        # 3b150 <_sk_srcover_bgra_8888_sse2_lowp+0x11e8>
  .byte  68,15,40,13,38,141,1,0              // movaps        0x18d26(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  68,15,40,5,74,147,1,0               // movaps        0x1934a(%rip),%xmm8        # 3b180 <_sk_srcover_bgra_8888_sse2_lowp+0x1218>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,88,5,78,147,1,0               // addps         0x1934e(%rip),%xmm8        # 3b190 <_sk_srcover_bgra_8888_sse2_lowp+0x1228>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,88,5,242,140,1,0              // addps         0x18cf2(%rip),%xmm8        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,88,5,70,147,1,0               // addps         0x19346(%rip),%xmm8        # 3b1a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1238>
  .byte  68,15,17,128,0,1,0,0                // movups        %xmm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p1x_sse41
.globl _sk_bicubic_p1x_sse41
FUNCTION(_sk_bicubic_p1x_sse41)
_sk_bicubic_p1x_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,15,40,5,208,140,1,0              // movaps        0x18cd0(%rip),%xmm8        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  68,15,16,136,128,0,0,0              // movups        0x80(%rax),%xmm9
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  68,15,40,21,249,146,1,0             // movaps        0x192f9(%rip),%xmm10        # 3b180 <_sk_srcover_bgra_8888_sse2_lowp+0x1218>
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  68,15,88,21,253,146,1,0             // addps         0x192fd(%rip),%xmm10        # 3b190 <_sk_srcover_bgra_8888_sse2_lowp+0x1228>
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,208                        // addps         %xmm8,%xmm10
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  68,15,88,21,249,146,1,0             // addps         0x192f9(%rip),%xmm10        # 3b1a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1238>
  .byte  68,15,17,144,0,1,0,0                // movups        %xmm10,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p3x_sse41
.globl _sk_bicubic_p3x_sse41
FUNCTION(_sk_bicubic_p3x_sse41)
_sk_bicubic_p3x_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  68,15,16,128,128,0,0,0              // movups        0x80(%rax),%xmm8
  .byte  15,88,5,201,146,1,0                 // addps         0x192c9(%rip),%xmm0        # 3b190 <_sk_srcover_bgra_8888_sse2_lowp+0x1228>
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  69,15,89,201                        // mulps         %xmm9,%xmm9
  .byte  68,15,89,5,153,146,1,0              // mulps         0x19299(%rip),%xmm8        # 3b170 <_sk_srcover_bgra_8888_sse2_lowp+0x1208>
  .byte  68,15,88,5,113,142,1,0              // addps         0x18e71(%rip),%xmm8        # 3ad50 <_sk_srcover_bgra_8888_sse2_lowp+0xde8>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,17,128,0,1,0,0                // movups        %xmm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n3y_sse41
.globl _sk_bicubic_n3y_sse41
FUNCTION(_sk_bicubic_n3y_sse41)
_sk_bicubic_n3y_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,72,64                         // movups        0x40(%rax),%xmm1
  .byte  68,15,16,128,192,0,0,0              // movups        0xc0(%rax),%xmm8
  .byte  15,88,13,92,146,1,0                 // addps         0x1925c(%rip),%xmm1        # 3b160 <_sk_srcover_bgra_8888_sse2_lowp+0x11f8>
  .byte  68,15,40,13,68,140,1,0              // movaps        0x18c44(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  68,15,89,13,80,146,1,0              // mulps         0x19250(%rip),%xmm9        # 3b170 <_sk_srcover_bgra_8888_sse2_lowp+0x1208>
  .byte  68,15,88,13,40,142,1,0              // addps         0x18e28(%rip),%xmm9        # 3ad50 <_sk_srcover_bgra_8888_sse2_lowp+0xde8>
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  68,15,17,136,64,1,0,0               // movups        %xmm9,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n1y_sse41
.globl _sk_bicubic_n1y_sse41
FUNCTION(_sk_bicubic_n1y_sse41)
_sk_bicubic_n1y_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,72,64                         // movups        0x40(%rax),%xmm1
  .byte  68,15,16,128,192,0,0,0              // movups        0xc0(%rax),%xmm8
  .byte  15,88,13,3,146,1,0                  // addps         0x19203(%rip),%xmm1        # 3b150 <_sk_srcover_bgra_8888_sse2_lowp+0x11e8>
  .byte  68,15,40,13,251,139,1,0             // movaps        0x18bfb(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  68,15,40,5,31,146,1,0               // movaps        0x1921f(%rip),%xmm8        # 3b180 <_sk_srcover_bgra_8888_sse2_lowp+0x1218>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,88,5,35,146,1,0               // addps         0x19223(%rip),%xmm8        # 3b190 <_sk_srcover_bgra_8888_sse2_lowp+0x1228>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,88,5,199,139,1,0              // addps         0x18bc7(%rip),%xmm8        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,88,5,27,146,1,0               // addps         0x1921b(%rip),%xmm8        # 3b1a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1238>
  .byte  68,15,17,128,64,1,0,0               // movups        %xmm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p1y_sse41
.globl _sk_bicubic_p1y_sse41
FUNCTION(_sk_bicubic_p1y_sse41)
_sk_bicubic_p1y_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,15,40,5,165,139,1,0              // movaps        0x18ba5(%rip),%xmm8        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,16,72,64                         // movups        0x40(%rax),%xmm1
  .byte  68,15,16,136,192,0,0,0              // movups        0xc0(%rax),%xmm9
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  68,15,40,21,205,145,1,0             // movaps        0x191cd(%rip),%xmm10        # 3b180 <_sk_srcover_bgra_8888_sse2_lowp+0x1218>
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  68,15,88,21,209,145,1,0             // addps         0x191d1(%rip),%xmm10        # 3b190 <_sk_srcover_bgra_8888_sse2_lowp+0x1228>
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,208                        // addps         %xmm8,%xmm10
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  68,15,88,21,205,145,1,0             // addps         0x191cd(%rip),%xmm10        # 3b1a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1238>
  .byte  68,15,17,144,64,1,0,0               // movups        %xmm10,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p3y_sse41
.globl _sk_bicubic_p3y_sse41
FUNCTION(_sk_bicubic_p3y_sse41)
_sk_bicubic_p3y_sse41:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,72,64                         // movups        0x40(%rax),%xmm1
  .byte  68,15,16,128,192,0,0,0              // movups        0xc0(%rax),%xmm8
  .byte  15,88,13,156,145,1,0                // addps         0x1919c(%rip),%xmm1        # 3b190 <_sk_srcover_bgra_8888_sse2_lowp+0x1228>
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  69,15,89,201                        // mulps         %xmm9,%xmm9
  .byte  68,15,89,5,108,145,1,0              // mulps         0x1916c(%rip),%xmm8        # 3b170 <_sk_srcover_bgra_8888_sse2_lowp+0x1208>
  .byte  68,15,88,5,68,141,1,0               // addps         0x18d44(%rip),%xmm8        # 3ad50 <_sk_srcover_bgra_8888_sse2_lowp+0xde8>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,17,128,64,1,0,0               // movups        %xmm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_callback_sse41
.globl _sk_callback_sse41
FUNCTION(_sk_callback_sse41)
_sk_callback_sse41:
  .byte  85                                  // push          %rbp
  .byte  72,137,229                          // mov           %rsp,%rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,236,72                       // sub           $0x48,%rsp
  .byte  15,41,125,144                       // movaps        %xmm7,-0x70(%rbp)
  .byte  15,41,117,160                       // movaps        %xmm6,-0x60(%rbp)
  .byte  15,41,109,176                       // movaps        %xmm5,-0x50(%rbp)
  .byte  15,41,101,192                       // movaps        %xmm4,-0x40(%rbp)
  .byte  73,137,206                          // mov           %rcx,%r14
  .byte  73,137,215                          // mov           %rdx,%r15
  .byte  73,137,253                          // mov           %rdi,%r13
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,137,195                          // mov           %rax,%rbx
  .byte  73,137,244                          // mov           %rsi,%r12
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,20,225                           // unpcklps      %xmm1,%xmm4
  .byte  15,40,234                           // movaps        %xmm2,%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  15,21,193                           // unpckhps      %xmm1,%xmm0
  .byte  15,21,211                           // unpckhps      %xmm3,%xmm2
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  102,15,20,205                       // unpcklpd      %xmm5,%xmm1
  .byte  15,18,236                           // movhlps       %xmm4,%xmm5
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  102,15,20,218                       // unpcklpd      %xmm2,%xmm3
  .byte  102,15,17,75,8                      // movupd        %xmm1,0x8(%rbx)
  .byte  15,18,208                           // movhlps       %xmm0,%xmm2
  .byte  15,17,107,24                        // movups        %xmm5,0x18(%rbx)
  .byte  102,15,17,91,40                     // movupd        %xmm3,0x28(%rbx)
  .byte  15,17,83,56                         // movups        %xmm2,0x38(%rbx)
  .byte  77,133,237                          // test          %r13,%r13
  .byte  190,4,0,0,0                         // mov           $0x4,%esi
  .byte  65,15,69,245                        // cmovne        %r13d,%esi
  .byte  72,137,223                          // mov           %rbx,%rdi
  .byte  255,19                              // callq         *(%rbx)
  .byte  72,139,131,8,1,0,0                  // mov           0x108(%rbx),%rax
  .byte  15,16,32                            // movups        (%rax),%xmm4
  .byte  15,16,64,16                         // movups        0x10(%rax),%xmm0
  .byte  15,16,88,32                         // movups        0x20(%rax),%xmm3
  .byte  15,16,80,48                         // movups        0x30(%rax),%xmm2
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,20,202                           // unpcklps      %xmm2,%xmm1
  .byte  15,21,224                           // unpckhps      %xmm0,%xmm4
  .byte  15,21,218                           // unpckhps      %xmm2,%xmm3
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  102,15,20,193                       // unpcklpd      %xmm1,%xmm0
  .byte  15,18,205                           // movhlps       %xmm5,%xmm1
  .byte  15,40,212                           // movaps        %xmm4,%xmm2
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  15,18,220                           // movhlps       %xmm4,%xmm3
  .byte  76,137,230                          // mov           %r12,%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,137,239                          // mov           %r13,%rdi
  .byte  76,137,250                          // mov           %r15,%rdx
  .byte  76,137,241                          // mov           %r14,%rcx
  .byte  15,40,101,192                       // movaps        -0x40(%rbp),%xmm4
  .byte  15,40,109,176                       // movaps        -0x50(%rbp),%xmm5
  .byte  15,40,117,160                       // movaps        -0x60(%rbp),%xmm6
  .byte  15,40,125,144                       // movaps        -0x70(%rbp),%xmm7
  .byte  72,131,196,72                       // add           $0x48,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clut_3D_sse41
.globl _sk_clut_3D_sse41
FUNCTION(_sk_clut_3D_sse41)
_sk_clut_3D_sse41:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,236,56                       // sub           $0x38,%rsp
  .byte  15,41,124,36,32                     // movaps        %xmm7,0x20(%rsp)
  .byte  15,41,116,36,16                     // movaps        %xmm6,0x10(%rsp)
  .byte  15,41,44,36                         // movaps        %xmm5,(%rsp)
  .byte  15,41,100,36,240                    // movaps        %xmm4,-0x10(%rsp)
  .byte  15,41,92,36,224                     // movaps        %xmm3,-0x20(%rsp)
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  72,137,76,36,136                    // mov           %rcx,-0x78(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,16                        // mov           0x10(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  102,65,15,110,193                   // movd          %r9d,%xmm0
  .byte  102,15,112,192,0                    // pshufd        $0x0,%xmm0,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,41,68,36,208                     // movaps        %xmm0,-0x30(%rsp)
  .byte  243,15,91,240                       // cvttps2dq     %xmm0,%xmm6
  .byte  15,40,37,87,144,1,0                 // movaps        0x19057(%rip),%xmm4        # 3b1b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1248>
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,41,68,36,176                     // movaps        %xmm0,-0x50(%rsp)
  .byte  102,65,15,110,208                   // movd          %r8d,%xmm2
  .byte  102,68,15,112,202,0                 // pshufd        $0x0,%xmm2,%xmm9
  .byte  68,139,64,12                        // mov           0xc(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  102,65,15,110,233                   // movd          %r9d,%xmm5
  .byte  102,15,112,237,0                    // pshufd        $0x0,%xmm5,%xmm5
  .byte  15,91,253                           // cvtdq2ps      %xmm5,%xmm7
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  15,41,124,36,144                    // movaps        %xmm7,-0x70(%rsp)
  .byte  243,15,91,239                       // cvttps2dq     %xmm7,%xmm5
  .byte  102,15,127,108,36,160               // movdqa        %xmm5,-0x60(%rsp)
  .byte  15,40,207                           // movaps        %xmm7,%xmm1
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  243,68,15,91,209                    // cvttps2dq     %xmm1,%xmm10
  .byte  102,69,15,56,64,209                 // pmulld        %xmm9,%xmm10
  .byte  102,68,15,56,64,205                 // pmulld        %xmm5,%xmm9
  .byte  102,65,15,110,192                   // movd          %r8d,%xmm0
  .byte  102,15,56,64,194                    // pmulld        %xmm2,%xmm0
  .byte  68,139,64,8                         // mov           0x8(%rax),%r8d
  .byte  65,255,200                          // dec           %r8d
  .byte  102,65,15,110,200                   // movd          %r8d,%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  68,15,91,217                        // cvtdq2ps      %xmm1,%xmm11
  .byte  68,15,89,219                        // mulps         %xmm3,%xmm11
  .byte  102,65,15,111,209                   // movdqa        %xmm9,%xmm2
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,15,127,108,36,192               // movdqa        %xmm5,-0x40(%rsp)
  .byte  102,15,254,213                      // paddd         %xmm5,%xmm2
  .byte  102,68,15,112,192,0                 // pshufd        $0x0,%xmm0,%xmm8
  .byte  65,15,88,227                        // addps         %xmm11,%xmm4
  .byte  243,68,15,91,244                    // cvttps2dq     %xmm4,%xmm14
  .byte  102,69,15,56,64,240                 // pmulld        %xmm8,%xmm14
  .byte  243,65,15,91,195                    // cvttps2dq     %xmm11,%xmm0
  .byte  102,68,15,56,64,192                 // pmulld        %xmm0,%xmm8
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,254,218                      // paddd         %xmm2,%xmm3
  .byte  102,68,15,111,37,174,143,1,0        // movdqa        0x18fae(%rip),%xmm12        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,65,15,56,64,220                 // pmulld        %xmm12,%xmm3
  .byte  102,15,118,228                      // pcmpeqd       %xmm4,%xmm4
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,250,204                      // psubd         %xmm4,%xmm1
  .byte  102,69,15,118,237                   // pcmpeqd       %xmm13,%xmm13
  .byte  102,73,15,58,22,200,1               // pextrq        $0x1,%xmm1,%r8
  .byte  102,73,15,126,201                   // movq          %xmm1,%r9
  .byte  72,139,0                            // mov           (%rax),%rax
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,195                          // mov           %r8d,%r11d
  .byte  243,66,15,16,12,144                 // movss         (%rax,%r10,4),%xmm1
  .byte  102,66,15,58,33,12,136,16           // insertps      $0x10,(%rax,%r9,4),%xmm1
  .byte  243,66,15,16,36,152                 // movss         (%rax,%r11,4),%xmm4
  .byte  102,15,58,33,204,32                 // insertps      $0x20,%xmm4,%xmm1
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,36,128                 // movss         (%rax,%r8,4),%xmm4
  .byte  102,15,58,33,204,48                 // insertps      $0x30,%xmm4,%xmm1
  .byte  102,65,15,126,216                   // movd          %xmm3,%r8d
  .byte  102,65,15,58,22,217,1               // pextrd        $0x1,%xmm3,%r9d
  .byte  102,65,15,58,22,218,2               // pextrd        $0x2,%xmm3,%r10d
  .byte  102,65,15,58,22,219,3               // pextrd        $0x3,%xmm3,%r11d
  .byte  102,15,111,37,242,136,1,0           // movdqa        0x188f2(%rip),%xmm4        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,15,254,220                      // paddd         %xmm4,%xmm3
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,73,15,58,22,222,1               // pextrq        $0x1,%xmm3,%r14
  .byte  102,72,15,126,219                   // movq          %xmm3,%rbx
  .byte  65,137,223                          // mov           %ebx,%r15d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,244                          // mov           %r14d,%r12d
  .byte  243,66,15,16,36,184                 // movss         (%rax,%r15,4),%xmm4
  .byte  102,15,58,33,36,152,16              // insertps      $0x10,(%rax,%rbx,4),%xmm4
  .byte  243,66,15,16,28,160                 // movss         (%rax,%r12,4),%xmm3
  .byte  102,15,58,33,227,32                 // insertps      $0x20,%xmm3,%xmm4
  .byte  73,193,238,32                       // shr           $0x20,%r14
  .byte  243,66,15,16,28,176                 // movss         (%rax,%r14,4),%xmm3
  .byte  102,15,58,33,227,48                 // insertps      $0x30,%xmm3,%xmm4
  .byte  102,65,15,254,214                   // paddd         %xmm14,%xmm2
  .byte  102,65,15,56,64,212                 // pmulld        %xmm12,%xmm2
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,65,15,250,221                   // psubd         %xmm13,%xmm3
  .byte  102,69,15,118,255                   // pcmpeqd       %xmm15,%xmm15
  .byte  102,73,15,58,22,222,1               // pextrq        $0x1,%xmm3,%r14
  .byte  102,72,15,126,219                   // movq          %xmm3,%rbx
  .byte  65,137,223                          // mov           %ebx,%r15d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,244                          // mov           %r14d,%r12d
  .byte  243,66,15,16,28,184                 // movss         (%rax,%r15,4),%xmm3
  .byte  102,15,58,33,28,152,16              // insertps      $0x10,(%rax,%rbx,4),%xmm3
  .byte  243,66,15,16,52,160                 // movss         (%rax,%r12,4),%xmm6
  .byte  102,15,58,33,222,32                 // insertps      $0x20,%xmm6,%xmm3
  .byte  73,193,238,32                       // shr           $0x20,%r14
  .byte  243,66,15,16,52,176                 // movss         (%rax,%r14,4),%xmm6
  .byte  102,15,58,33,222,48                 // insertps      $0x30,%xmm6,%xmm3
  .byte  102,65,15,126,213                   // movd          %xmm2,%r13d
  .byte  102,65,15,58,22,214,1               // pextrd        $0x1,%xmm2,%r14d
  .byte  102,65,15,58,22,215,2               // pextrd        $0x2,%xmm2,%r15d
  .byte  102,65,15,58,22,212,3               // pextrd        $0x3,%xmm2,%r12d
  .byte  102,15,254,215                      // paddd         %xmm7,%xmm2
  .byte  102,68,15,111,239                   // movdqa        %xmm7,%xmm13
  .byte  102,72,15,58,22,211,1               // pextrq        $0x1,%xmm2,%rbx
  .byte  102,72,15,126,213                   // movq          %xmm2,%rbp
  .byte  137,233                             // mov           %ebp,%ecx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  243,15,16,60,136                    // movss         (%rax,%rcx,4),%xmm7
  .byte  102,15,58,33,60,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm7
  .byte  137,217                             // mov           %ebx,%ecx
  .byte  243,15,16,20,136                    // movss         (%rax,%rcx,4),%xmm2
  .byte  102,15,58,33,250,32                 // insertps      $0x20,%xmm2,%xmm7
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  243,15,16,20,152                    // movss         (%rax,%rbx,4),%xmm2
  .byte  102,15,58,33,250,48                 // insertps      $0x30,%xmm2,%xmm7
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  68,15,92,216                        // subps         %xmm0,%xmm11
  .byte  243,66,15,16,20,128                 // movss         (%rax,%r8,4),%xmm2
  .byte  102,66,15,58,33,20,136,16           // insertps      $0x10,(%rax,%r9,4),%xmm2
  .byte  102,66,15,58,33,20,144,32           // insertps      $0x20,(%rax,%r10,4),%xmm2
  .byte  102,66,15,58,33,20,152,48           // insertps      $0x30,(%rax,%r11,4),%xmm2
  .byte  243,66,15,16,4,168                  // movss         (%rax,%r13,4),%xmm0
  .byte  102,66,15,58,33,4,176,16            // insertps      $0x10,(%rax,%r14,4),%xmm0
  .byte  102,66,15,58,33,4,184,32            // insertps      $0x20,(%rax,%r15,4),%xmm0
  .byte  102,66,15,58,33,4,160,48            // insertps      $0x30,(%rax,%r12,4),%xmm0
  .byte  15,92,194                           // subps         %xmm2,%xmm0
  .byte  65,15,89,195                        // mulps         %xmm11,%xmm0
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,92,217                           // subps         %xmm1,%xmm3
  .byte  65,15,89,219                        // mulps         %xmm11,%xmm3
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  15,92,252                           // subps         %xmm4,%xmm7
  .byte  65,15,89,251                        // mulps         %xmm11,%xmm7
  .byte  15,88,252                           // addps         %xmm4,%xmm7
  .byte  102,65,15,111,226                   // movdqa        %xmm10,%xmm4
  .byte  102,15,254,229                      // paddd         %xmm5,%xmm4
  .byte  102,15,111,204                      // movdqa        %xmm4,%xmm1
  .byte  102,65,15,254,200                   // paddd         %xmm8,%xmm1
  .byte  102,65,15,56,64,204                 // pmulld        %xmm12,%xmm1
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  102,15,58,22,205,1                  // pextrd        $0x1,%xmm1,%ebp
  .byte  102,65,15,58,22,200,2               // pextrd        $0x2,%xmm1,%r8d
  .byte  102,15,58,22,203,3                  // pextrd        $0x3,%xmm1,%ebx
  .byte  243,15,16,20,136                    // movss         (%rax,%rcx,4),%xmm2
  .byte  102,15,58,33,20,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm2
  .byte  102,66,15,58,33,20,128,32           // insertps      $0x20,(%rax,%r8,4),%xmm2
  .byte  243,15,16,52,152                    // movss         (%rax,%rbx,4),%xmm6
  .byte  102,15,58,33,214,48                 // insertps      $0x30,%xmm6,%xmm2
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,65,15,250,247                   // psubd         %xmm15,%xmm6
  .byte  102,69,15,118,255                   // pcmpeqd       %xmm15,%xmm15
  .byte  102,72,15,58,22,241,1               // pextrq        $0x1,%xmm6,%rcx
  .byte  102,72,15,126,245                   // movq          %xmm6,%rbp
  .byte  65,137,232                          // mov           %ebp,%r8d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  137,203                             // mov           %ecx,%ebx
  .byte  243,66,15,16,52,128                 // movss         (%rax,%r8,4),%xmm6
  .byte  102,15,58,33,52,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm6
  .byte  243,15,16,44,152                    // movss         (%rax,%rbx,4),%xmm5
  .byte  102,15,58,33,245,32                 // insertps      $0x20,%xmm5,%xmm6
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,44,136                    // movss         (%rax,%rcx,4),%xmm5
  .byte  102,15,58,33,245,48                 // insertps      $0x30,%xmm5,%xmm6
  .byte  102,65,15,254,205                   // paddd         %xmm13,%xmm1
  .byte  102,72,15,58,22,201,1               // pextrq        $0x1,%xmm1,%rcx
  .byte  102,72,15,126,205                   // movq          %xmm1,%rbp
  .byte  65,137,232                          // mov           %ebp,%r8d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  137,203                             // mov           %ecx,%ebx
  .byte  243,66,15,16,12,128                 // movss         (%rax,%r8,4),%xmm1
  .byte  102,15,58,33,12,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm1
  .byte  243,15,16,44,152                    // movss         (%rax,%rbx,4),%xmm5
  .byte  102,15,58,33,205,32                 // insertps      $0x20,%xmm5,%xmm1
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,44,136                    // movss         (%rax,%rcx,4),%xmm5
  .byte  102,15,58,33,205,48                 // insertps      $0x30,%xmm5,%xmm1
  .byte  102,65,15,254,230                   // paddd         %xmm14,%xmm4
  .byte  102,65,15,56,64,228                 // pmulld        %xmm12,%xmm4
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,65,15,250,239                   // psubd         %xmm15,%xmm5
  .byte  102,72,15,58,22,233,1               // pextrq        $0x1,%xmm5,%rcx
  .byte  102,72,15,126,237                   // movq          %xmm5,%rbp
  .byte  65,137,232                          // mov           %ebp,%r8d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  137,203                             // mov           %ecx,%ebx
  .byte  243,70,15,16,36,128                 // movss         (%rax,%r8,4),%xmm12
  .byte  102,68,15,58,33,36,168,16           // insertps      $0x10,(%rax,%rbp,4),%xmm12
  .byte  243,15,16,44,152                    // movss         (%rax,%rbx,4),%xmm5
  .byte  102,68,15,58,33,229,32              // insertps      $0x20,%xmm5,%xmm12
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,44,136                    // movss         (%rax,%rcx,4),%xmm5
  .byte  102,68,15,58,33,229,48              // insertps      $0x30,%xmm5,%xmm12
  .byte  102,65,15,126,224                   // movd          %xmm4,%r8d
  .byte  102,65,15,58,22,227,1               // pextrd        $0x1,%xmm4,%r11d
  .byte  102,65,15,58,22,226,2               // pextrd        $0x2,%xmm4,%r10d
  .byte  102,65,15,58,22,225,3               // pextrd        $0x3,%xmm4,%r9d
  .byte  102,65,15,254,229                   // paddd         %xmm13,%xmm4
  .byte  102,72,15,58,22,225,1               // pextrq        $0x1,%xmm4,%rcx
  .byte  102,72,15,126,227                   // movq          %xmm4,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  137,205                             // mov           %ecx,%ebp
  .byte  243,70,15,16,60,176                 // movss         (%rax,%r14,4),%xmm15
  .byte  102,68,15,58,33,60,152,16           // insertps      $0x10,(%rax,%rbx,4),%xmm15
  .byte  243,15,16,36,168                    // movss         (%rax,%rbp,4),%xmm4
  .byte  102,68,15,58,33,252,32              // insertps      $0x20,%xmm4,%xmm15
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,36,136                    // movss         (%rax,%rcx,4),%xmm4
  .byte  102,68,15,58,33,252,48              // insertps      $0x30,%xmm4,%xmm15
  .byte  243,66,15,16,36,128                 // movss         (%rax,%r8,4),%xmm4
  .byte  102,66,15,58,33,36,152,16           // insertps      $0x10,(%rax,%r11,4),%xmm4
  .byte  102,66,15,58,33,36,144,32           // insertps      $0x20,(%rax,%r10,4),%xmm4
  .byte  102,66,15,58,33,36,136,48           // insertps      $0x30,(%rax,%r9,4),%xmm4
  .byte  15,92,226                           // subps         %xmm2,%xmm4
  .byte  65,15,89,227                        // mulps         %xmm11,%xmm4
  .byte  15,88,226                           // addps         %xmm2,%xmm4
  .byte  68,15,92,230                        // subps         %xmm6,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  68,15,88,230                        // addps         %xmm6,%xmm12
  .byte  68,15,92,249                        // subps         %xmm1,%xmm15
  .byte  69,15,89,251                        // mulps         %xmm11,%xmm15
  .byte  68,15,88,249                        // addps         %xmm1,%xmm15
  .byte  15,91,76,36,160                     // cvtdq2ps      -0x60(%rsp),%xmm1
  .byte  68,15,40,108,36,144                 // movaps        -0x70(%rsp),%xmm13
  .byte  68,15,92,233                        // subps         %xmm1,%xmm13
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  65,15,89,229                        // mulps         %xmm13,%xmm4
  .byte  15,88,224                           // addps         %xmm0,%xmm4
  .byte  68,15,92,227                        // subps         %xmm3,%xmm12
  .byte  69,15,89,229                        // mulps         %xmm13,%xmm12
  .byte  68,15,88,227                        // addps         %xmm3,%xmm12
  .byte  68,15,92,255                        // subps         %xmm7,%xmm15
  .byte  69,15,89,253                        // mulps         %xmm13,%xmm15
  .byte  68,15,88,255                        // addps         %xmm7,%xmm15
  .byte  243,15,91,84,36,176                 // cvttps2dq     -0x50(%rsp),%xmm2
  .byte  102,68,15,254,202                   // paddd         %xmm2,%xmm9
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  102,65,15,254,193                   // paddd         %xmm9,%xmm0
  .byte  102,15,111,45,189,139,1,0           // movdqa        0x18bbd(%rip),%xmm5        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,15,56,64,197                    // pmulld        %xmm5,%xmm0
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,118,246                      // pcmpeqd       %xmm6,%xmm6
  .byte  102,15,250,206                      // psubd         %xmm6,%xmm1
  .byte  102,72,15,58,22,201,1               // pextrq        $0x1,%xmm1,%rcx
  .byte  102,72,15,126,205                   // movq          %xmm1,%rbp
  .byte  137,235                             // mov           %ebp,%ebx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  65,137,200                          // mov           %ecx,%r8d
  .byte  243,15,16,12,152                    // movss         (%rax,%rbx,4),%xmm1
  .byte  102,15,58,33,12,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm1
  .byte  243,66,15,16,28,128                 // movss         (%rax,%r8,4),%xmm3
  .byte  102,15,58,33,203,32                 // insertps      $0x20,%xmm3,%xmm1
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,28,136                    // movss         (%rax,%rcx,4),%xmm3
  .byte  102,15,58,33,203,48                 // insertps      $0x30,%xmm3,%xmm1
  .byte  102,65,15,126,192                   // movd          %xmm0,%r8d
  .byte  102,65,15,58,22,193,1               // pextrd        $0x1,%xmm0,%r9d
  .byte  102,65,15,58,22,194,2               // pextrd        $0x2,%xmm0,%r10d
  .byte  102,65,15,58,22,195,3               // pextrd        $0x3,%xmm0,%r11d
  .byte  102,15,111,61,14,133,1,0            // movdqa        0x1850e(%rip),%xmm7        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,15,254,199                      // paddd         %xmm7,%xmm0
  .byte  102,72,15,58,22,193,1               // pextrq        $0x1,%xmm0,%rcx
  .byte  102,72,15,126,195                   // movq          %xmm0,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  65,137,206                          // mov           %ecx,%r14d
  .byte  243,15,16,4,168                     // movss         (%rax,%rbp,4),%xmm0
  .byte  102,15,58,33,4,152,16               // insertps      $0x10,(%rax,%rbx,4),%xmm0
  .byte  243,66,15,16,28,176                 // movss         (%rax,%r14,4),%xmm3
  .byte  102,15,58,33,195,32                 // insertps      $0x20,%xmm3,%xmm0
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,28,136                    // movss         (%rax,%rcx,4),%xmm3
  .byte  102,15,58,33,195,48                 // insertps      $0x30,%xmm3,%xmm0
  .byte  102,69,15,254,206                   // paddd         %xmm14,%xmm9
  .byte  102,68,15,56,64,205                 // pmulld        %xmm5,%xmm9
  .byte  102,65,15,111,217                   // movdqa        %xmm9,%xmm3
  .byte  102,15,250,222                      // psubd         %xmm6,%xmm3
  .byte  102,72,15,58,22,217,1               // pextrq        $0x1,%xmm3,%rcx
  .byte  102,72,15,126,219                   // movq          %xmm3,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  65,137,206                          // mov           %ecx,%r14d
  .byte  243,15,16,52,168                    // movss         (%rax,%rbp,4),%xmm6
  .byte  102,15,58,33,52,152,16              // insertps      $0x10,(%rax,%rbx,4),%xmm6
  .byte  243,66,15,16,28,176                 // movss         (%rax,%r14,4),%xmm3
  .byte  102,15,58,33,243,32                 // insertps      $0x20,%xmm3,%xmm6
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,28,136                    // movss         (%rax,%rcx,4),%xmm3
  .byte  102,15,58,33,243,48                 // insertps      $0x30,%xmm3,%xmm6
  .byte  102,69,15,126,205                   // movd          %xmm9,%r13d
  .byte  102,69,15,58,22,207,1               // pextrd        $0x1,%xmm9,%r15d
  .byte  102,69,15,58,22,204,2               // pextrd        $0x2,%xmm9,%r12d
  .byte  102,69,15,58,22,206,3               // pextrd        $0x3,%xmm9,%r14d
  .byte  102,68,15,254,207                   // paddd         %xmm7,%xmm9
  .byte  102,76,15,58,22,203,1               // pextrq        $0x1,%xmm9,%rbx
  .byte  102,76,15,126,205                   // movq          %xmm9,%rbp
  .byte  137,233                             // mov           %ebp,%ecx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  243,15,16,60,136                    // movss         (%rax,%rcx,4),%xmm7
  .byte  102,15,58,33,60,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm7
  .byte  137,217                             // mov           %ebx,%ecx
  .byte  243,15,16,28,136                    // movss         (%rax,%rcx,4),%xmm3
  .byte  102,15,58,33,251,32                 // insertps      $0x20,%xmm3,%xmm7
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  243,15,16,28,152                    // movss         (%rax,%rbx,4),%xmm3
  .byte  102,15,58,33,251,48                 // insertps      $0x30,%xmm3,%xmm7
  .byte  243,66,15,16,44,128                 // movss         (%rax,%r8,4),%xmm5
  .byte  102,66,15,58,33,44,136,16           // insertps      $0x10,(%rax,%r9,4),%xmm5
  .byte  102,66,15,58,33,44,144,32           // insertps      $0x20,(%rax,%r10,4),%xmm5
  .byte  102,66,15,58,33,44,152,48           // insertps      $0x30,(%rax,%r11,4),%xmm5
  .byte  243,66,15,16,28,168                 // movss         (%rax,%r13,4),%xmm3
  .byte  102,66,15,58,33,28,184,16           // insertps      $0x10,(%rax,%r15,4),%xmm3
  .byte  102,66,15,58,33,28,160,32           // insertps      $0x20,(%rax,%r12,4),%xmm3
  .byte  102,66,15,58,33,28,176,48           // insertps      $0x30,(%rax,%r14,4),%xmm3
  .byte  15,92,221                           // subps         %xmm5,%xmm3
  .byte  65,15,89,219                        // mulps         %xmm11,%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  15,92,241                           // subps         %xmm1,%xmm6
  .byte  65,15,89,243                        // mulps         %xmm11,%xmm6
  .byte  15,88,241                           // addps         %xmm1,%xmm6
  .byte  15,92,248                           // subps         %xmm0,%xmm7
  .byte  65,15,89,251                        // mulps         %xmm11,%xmm7
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  102,68,15,254,210                   // paddd         %xmm2,%xmm10
  .byte  102,69,15,254,194                   // paddd         %xmm10,%xmm8
  .byte  102,15,111,13,249,137,1,0           // movdqa        0x189f9(%rip),%xmm1        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,68,15,56,64,193                 // pmulld        %xmm1,%xmm8
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  102,15,118,237                      // pcmpeqd       %xmm5,%xmm5
  .byte  102,15,250,197                      // psubd         %xmm5,%xmm0
  .byte  102,72,15,58,22,193,1               // pextrq        $0x1,%xmm0,%rcx
  .byte  102,72,15,126,197                   // movq          %xmm0,%rbp
  .byte  137,235                             // mov           %ebp,%ebx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  65,137,200                          // mov           %ecx,%r8d
  .byte  243,68,15,16,12,152                 // movss         (%rax,%rbx,4),%xmm9
  .byte  102,68,15,58,33,12,168,16           // insertps      $0x10,(%rax,%rbp,4),%xmm9
  .byte  243,66,15,16,4,128                  // movss         (%rax,%r8,4),%xmm0
  .byte  102,68,15,58,33,200,32              // insertps      $0x20,%xmm0,%xmm9
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,4,136                     // movss         (%rax,%rcx,4),%xmm0
  .byte  102,68,15,58,33,200,48              // insertps      $0x30,%xmm0,%xmm9
  .byte  102,69,15,126,192                   // movd          %xmm8,%r8d
  .byte  102,69,15,58,22,193,1               // pextrd        $0x1,%xmm8,%r9d
  .byte  102,69,15,58,22,194,2               // pextrd        $0x2,%xmm8,%r10d
  .byte  102,69,15,58,22,195,3               // pextrd        $0x3,%xmm8,%r11d
  .byte  102,15,111,21,68,131,1,0            // movdqa        0x18344(%rip),%xmm2        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,68,15,254,194                   // paddd         %xmm2,%xmm8
  .byte  102,76,15,58,22,193,1               // pextrq        $0x1,%xmm8,%rcx
  .byte  102,76,15,126,195                   // movq          %xmm8,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  65,137,206                          // mov           %ecx,%r14d
  .byte  243,68,15,16,4,168                  // movss         (%rax,%rbp,4),%xmm8
  .byte  102,68,15,58,33,4,152,16            // insertps      $0x10,(%rax,%rbx,4),%xmm8
  .byte  243,66,15,16,4,176                  // movss         (%rax,%r14,4),%xmm0
  .byte  102,68,15,58,33,192,32              // insertps      $0x20,%xmm0,%xmm8
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,4,136                     // movss         (%rax,%rcx,4),%xmm0
  .byte  102,68,15,58,33,192,48              // insertps      $0x30,%xmm0,%xmm8
  .byte  102,69,15,254,214                   // paddd         %xmm14,%xmm10
  .byte  102,68,15,56,64,209                 // pmulld        %xmm1,%xmm10
  .byte  102,65,15,111,194                   // movdqa        %xmm10,%xmm0
  .byte  102,15,250,197                      // psubd         %xmm5,%xmm0
  .byte  102,72,15,58,22,193,1               // pextrq        $0x1,%xmm0,%rcx
  .byte  102,72,15,126,195                   // movq          %xmm0,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  65,137,206                          // mov           %ecx,%r14d
  .byte  243,15,16,12,168                    // movss         (%rax,%rbp,4),%xmm1
  .byte  102,15,58,33,12,152,16              // insertps      $0x10,(%rax,%rbx,4),%xmm1
  .byte  243,66,15,16,4,176                  // movss         (%rax,%r14,4),%xmm0
  .byte  102,15,58,33,200,32                 // insertps      $0x20,%xmm0,%xmm1
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,4,136                     // movss         (%rax,%rcx,4),%xmm0
  .byte  102,15,58,33,200,48                 // insertps      $0x30,%xmm0,%xmm1
  .byte  102,69,15,126,213                   // movd          %xmm10,%r13d
  .byte  102,69,15,58,22,215,1               // pextrd        $0x1,%xmm10,%r15d
  .byte  102,69,15,58,22,212,2               // pextrd        $0x2,%xmm10,%r12d
  .byte  102,69,15,58,22,214,3               // pextrd        $0x3,%xmm10,%r14d
  .byte  102,68,15,254,210                   // paddd         %xmm2,%xmm10
  .byte  102,76,15,58,22,211,1               // pextrq        $0x1,%xmm10,%rbx
  .byte  102,76,15,126,213                   // movq          %xmm10,%rbp
  .byte  137,233                             // mov           %ebp,%ecx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  243,15,16,20,136                    // movss         (%rax,%rcx,4),%xmm2
  .byte  102,15,58,33,20,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm2
  .byte  137,217                             // mov           %ebx,%ecx
  .byte  243,15,16,4,136                     // movss         (%rax,%rcx,4),%xmm0
  .byte  102,15,58,33,208,32                 // insertps      $0x20,%xmm0,%xmm2
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  243,15,16,4,152                     // movss         (%rax,%rbx,4),%xmm0
  .byte  102,15,58,33,208,48                 // insertps      $0x30,%xmm0,%xmm2
  .byte  243,66,15,16,44,128                 // movss         (%rax,%r8,4),%xmm5
  .byte  102,66,15,58,33,44,136,16           // insertps      $0x10,(%rax,%r9,4),%xmm5
  .byte  102,66,15,58,33,44,144,32           // insertps      $0x20,(%rax,%r10,4),%xmm5
  .byte  102,66,15,58,33,44,152,48           // insertps      $0x30,(%rax,%r11,4),%xmm5
  .byte  243,66,15,16,4,168                  // movss         (%rax,%r13,4),%xmm0
  .byte  102,66,15,58,33,4,184,16            // insertps      $0x10,(%rax,%r15,4),%xmm0
  .byte  102,66,15,58,33,4,160,32            // insertps      $0x20,(%rax,%r12,4),%xmm0
  .byte  102,66,15,58,33,4,176,48            // insertps      $0x30,(%rax,%r14,4),%xmm0
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  65,15,89,195                        // mulps         %xmm11,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  65,15,92,201                        // subps         %xmm9,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  65,15,88,201                        // addps         %xmm9,%xmm1
  .byte  65,15,92,208                        // subps         %xmm8,%xmm2
  .byte  65,15,89,211                        // mulps         %xmm11,%xmm2
  .byte  65,15,88,208                        // addps         %xmm8,%xmm2
  .byte  15,92,195                           // subps         %xmm3,%xmm0
  .byte  65,15,89,197                        // mulps         %xmm13,%xmm0
  .byte  15,88,195                           // addps         %xmm3,%xmm0
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  65,15,89,205                        // mulps         %xmm13,%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,92,215                           // subps         %xmm7,%xmm2
  .byte  65,15,89,213                        // mulps         %xmm13,%xmm2
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  15,91,92,36,192                     // cvtdq2ps      -0x40(%rsp),%xmm3
  .byte  15,40,108,36,208                    // movaps        -0x30(%rsp),%xmm5
  .byte  15,92,235                           // subps         %xmm3,%xmm5
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  65,15,92,204                        // subps         %xmm12,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  65,15,88,204                        // addps         %xmm12,%xmm1
  .byte  65,15,92,215                        // subps         %xmm15,%xmm2
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  65,15,88,215                        // addps         %xmm15,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,139,76,36,136                    // mov           -0x78(%rsp),%rcx
  .byte  15,40,92,36,224                     // movaps        -0x20(%rsp),%xmm3
  .byte  15,40,100,36,240                    // movaps        -0x10(%rsp),%xmm4
  .byte  15,40,44,36                         // movaps        (%rsp),%xmm5
  .byte  15,40,116,36,16                     // movaps        0x10(%rsp),%xmm6
  .byte  15,40,124,36,32                     // movaps        0x20(%rsp),%xmm7
  .byte  72,131,196,56                       // add           $0x38,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clut_4D_sse41
.globl _sk_clut_4D_sse41
FUNCTION(_sk_clut_4D_sse41)
_sk_clut_4D_sse41:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,129,236,136,0,0,0                // sub           $0x88,%rsp
  .byte  15,41,124,36,112                    // movaps        %xmm7,0x70(%rsp)
  .byte  15,41,116,36,96                     // movaps        %xmm6,0x60(%rsp)
  .byte  15,41,108,36,80                     // movaps        %xmm5,0x50(%rsp)
  .byte  15,41,100,36,64                     // movaps        %xmm4,0x40(%rsp)
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  72,137,76,36,248                    // mov           %rcx,-0x8(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,20                        // mov           0x14(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  102,65,15,110,201                   // movd          %r9d,%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,41,76,36,48                      // movaps        %xmm1,0x30(%rsp)
  .byte  243,15,91,249                       // cvttps2dq     %xmm1,%xmm7
  .byte  15,40,29,87,135,1,0                 // movaps        0x18757(%rip),%xmm3        # 3b1b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1248>
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  15,41,76,36,160                     // movaps        %xmm1,-0x60(%rsp)
  .byte  102,65,15,110,232                   // movd          %r8d,%xmm5
  .byte  102,68,15,112,237,0                 // pshufd        $0x0,%xmm5,%xmm13
  .byte  68,139,64,16                        // mov           0x10(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  102,65,15,110,201                   // movd          %r9d,%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,41,76,36,224                     // movaps        %xmm1,-0x20(%rsp)
  .byte  243,15,91,209                       // cvttps2dq     %xmm1,%xmm2
  .byte  102,15,127,84,36,32                 // movdqa        %xmm2,0x20(%rsp)
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,65,15,56,64,205                 // pmulld        %xmm13,%xmm1
  .byte  102,15,127,76,36,144                // movdqa        %xmm1,-0x70(%rsp)
  .byte  102,68,15,56,64,234                 // pmulld        %xmm2,%xmm13
  .byte  102,65,15,110,240                   // movd          %r8d,%xmm6
  .byte  102,15,56,64,245                    // pmulld        %xmm5,%xmm6
  .byte  68,139,64,12                        // mov           0xc(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  102,65,15,110,201                   // movd          %r9d,%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  15,91,209                           // cvtdq2ps      %xmm1,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  68,139,72,8                         // mov           0x8(%rax),%r9d
  .byte  65,255,201                          // dec           %r9d
  .byte  102,65,15,110,201                   // movd          %r9d,%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  68,15,91,225                        // cvtdq2ps      %xmm1,%xmm12
  .byte  68,15,89,224                        // mulps         %xmm0,%xmm12
  .byte  102,65,15,111,229                   // movdqa        %xmm13,%xmm4
  .byte  102,15,127,124,36,16                // movdqa        %xmm7,0x10(%rsp)
  .byte  102,15,254,231                      // paddd         %xmm7,%xmm4
  .byte  102,65,15,110,232                   // movd          %r8d,%xmm5
  .byte  102,15,56,64,238                    // pmulld        %xmm6,%xmm5
  .byte  102,68,15,112,246,0                 // pshufd        $0x0,%xmm6,%xmm14
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,88,195                           // addps         %xmm3,%xmm0
  .byte  243,68,15,91,192                    // cvttps2dq     %xmm0,%xmm8
  .byte  102,69,15,56,64,198                 // pmulld        %xmm14,%xmm8
  .byte  102,68,15,127,68,36,208             // movdqa        %xmm8,-0x30(%rsp)
  .byte  243,15,91,194                       // cvttps2dq     %xmm2,%xmm0
  .byte  102,15,127,68,36,128                // movdqa        %xmm0,-0x80(%rsp)
  .byte  102,68,15,56,64,240                 // pmulld        %xmm0,%xmm14
  .byte  102,65,15,111,206                   // movdqa        %xmm14,%xmm1
  .byte  102,15,254,204                      // paddd         %xmm4,%xmm1
  .byte  102,68,15,112,253,0                 // pshufd        $0x0,%xmm5,%xmm15
  .byte  65,15,88,220                        // addps         %xmm12,%xmm3
  .byte  243,68,15,91,203                    // cvttps2dq     %xmm3,%xmm9
  .byte  102,69,15,56,64,207                 // pmulld        %xmm15,%xmm9
  .byte  243,65,15,91,236                    // cvttps2dq     %xmm12,%xmm5
  .byte  102,68,15,56,64,253                 // pmulld        %xmm5,%xmm15
  .byte  102,65,15,111,223                   // movdqa        %xmm15,%xmm3
  .byte  102,15,254,217                      // paddd         %xmm1,%xmm3
  .byte  102,68,15,111,29,86,134,1,0         // movdqa        0x18656(%rip),%xmm11        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,65,15,56,64,219                 // pmulld        %xmm11,%xmm3
  .byte  102,15,118,192                      // pcmpeqd       %xmm0,%xmm0
  .byte  102,15,111,243                      // movdqa        %xmm3,%xmm6
  .byte  102,15,250,240                      // psubd         %xmm0,%xmm6
  .byte  102,73,15,58,22,240,1               // pextrq        $0x1,%xmm6,%r8
  .byte  102,73,15,126,241                   // movq          %xmm6,%r9
  .byte  72,139,0                            // mov           (%rax),%rax
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  69,137,195                          // mov           %r8d,%r11d
  .byte  243,66,15,16,60,144                 // movss         (%rax,%r10,4),%xmm7
  .byte  102,66,15,58,33,60,136,16           // insertps      $0x10,(%rax,%r9,4),%xmm7
  .byte  243,66,15,16,52,152                 // movss         (%rax,%r11,4),%xmm6
  .byte  102,15,58,33,254,32                 // insertps      $0x20,%xmm6,%xmm7
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,52,128                 // movss         (%rax,%r8,4),%xmm6
  .byte  102,15,58,33,254,48                 // insertps      $0x30,%xmm6,%xmm7
  .byte  102,65,15,126,216                   // movd          %xmm3,%r8d
  .byte  102,65,15,58,22,217,1               // pextrd        $0x1,%xmm3,%r9d
  .byte  102,65,15,58,22,218,2               // pextrd        $0x2,%xmm3,%r10d
  .byte  102,65,15,58,22,219,3               // pextrd        $0x3,%xmm3,%r11d
  .byte  102,68,15,111,21,158,127,1,0        // movdqa        0x17f9e(%rip),%xmm10        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,65,15,254,218                   // paddd         %xmm10,%xmm3
  .byte  102,73,15,58,22,222,1               // pextrq        $0x1,%xmm3,%r14
  .byte  102,72,15,126,219                   // movq          %xmm3,%rbx
  .byte  65,137,223                          // mov           %ebx,%r15d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,244                          // mov           %r14d,%r12d
  .byte  243,66,15,16,4,184                  // movss         (%rax,%r15,4),%xmm0
  .byte  102,15,58,33,4,152,16               // insertps      $0x10,(%rax,%rbx,4),%xmm0
  .byte  243,66,15,16,28,160                 // movss         (%rax,%r12,4),%xmm3
  .byte  102,15,58,33,195,32                 // insertps      $0x20,%xmm3,%xmm0
  .byte  73,193,238,32                       // shr           $0x20,%r14
  .byte  243,66,15,16,28,176                 // movss         (%rax,%r14,4),%xmm3
  .byte  102,15,58,33,195,48                 // insertps      $0x30,%xmm3,%xmm0
  .byte  102,68,15,127,76,36,176             // movdqa        %xmm9,-0x50(%rsp)
  .byte  102,65,15,254,201                   // paddd         %xmm9,%xmm1
  .byte  102,65,15,56,64,203                 // pmulld        %xmm11,%xmm1
  .byte  102,15,111,217                      // movdqa        %xmm1,%xmm3
  .byte  102,15,250,29,140,133,1,0           // psubd         0x1858c(%rip),%xmm3        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,73,15,58,22,222,1               // pextrq        $0x1,%xmm3,%r14
  .byte  102,72,15,126,219                   // movq          %xmm3,%rbx
  .byte  65,137,223                          // mov           %ebx,%r15d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  69,137,244                          // mov           %r14d,%r12d
  .byte  243,66,15,16,28,184                 // movss         (%rax,%r15,4),%xmm3
  .byte  102,15,58,33,28,152,16              // insertps      $0x10,(%rax,%rbx,4),%xmm3
  .byte  243,66,15,16,52,160                 // movss         (%rax,%r12,4),%xmm6
  .byte  102,15,58,33,222,32                 // insertps      $0x20,%xmm6,%xmm3
  .byte  73,193,238,32                       // shr           $0x20,%r14
  .byte  243,66,15,16,52,176                 // movss         (%rax,%r14,4),%xmm6
  .byte  102,15,58,33,222,48                 // insertps      $0x30,%xmm6,%xmm3
  .byte  102,65,15,126,205                   // movd          %xmm1,%r13d
  .byte  102,65,15,58,22,206,1               // pextrd        $0x1,%xmm1,%r14d
  .byte  102,65,15,58,22,207,2               // pextrd        $0x2,%xmm1,%r15d
  .byte  102,65,15,58,22,204,3               // pextrd        $0x3,%xmm1,%r12d
  .byte  102,65,15,254,202                   // paddd         %xmm10,%xmm1
  .byte  102,72,15,58,22,203,1               // pextrq        $0x1,%xmm1,%rbx
  .byte  102,72,15,126,205                   // movq          %xmm1,%rbp
  .byte  137,233                             // mov           %ebp,%ecx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  243,15,16,12,136                    // movss         (%rax,%rcx,4),%xmm1
  .byte  102,15,58,33,12,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm1
  .byte  137,217                             // mov           %ebx,%ecx
  .byte  243,15,16,52,136                    // movss         (%rax,%rcx,4),%xmm6
  .byte  102,15,58,33,206,32                 // insertps      $0x20,%xmm6,%xmm1
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  243,15,16,52,152                    // movss         (%rax,%rbx,4),%xmm6
  .byte  102,15,58,33,206,48                 // insertps      $0x30,%xmm6,%xmm1
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  68,15,92,229                        // subps         %xmm5,%xmm12
  .byte  243,66,15,16,44,128                 // movss         (%rax,%r8,4),%xmm5
  .byte  102,66,15,58,33,44,136,16           // insertps      $0x10,(%rax,%r9,4),%xmm5
  .byte  102,66,15,58,33,44,144,32           // insertps      $0x20,(%rax,%r10,4),%xmm5
  .byte  102,66,15,58,33,44,152,48           // insertps      $0x30,(%rax,%r11,4),%xmm5
  .byte  243,66,15,16,52,168                 // movss         (%rax,%r13,4),%xmm6
  .byte  102,66,15,58,33,52,176,16           // insertps      $0x10,(%rax,%r14,4),%xmm6
  .byte  102,66,15,58,33,52,184,32           // insertps      $0x20,(%rax,%r15,4),%xmm6
  .byte  102,66,15,58,33,52,160,48           // insertps      $0x30,(%rax,%r12,4),%xmm6
  .byte  15,92,245                           // subps         %xmm5,%xmm6
  .byte  65,15,89,244                        // mulps         %xmm12,%xmm6
  .byte  15,88,245                           // addps         %xmm5,%xmm6
  .byte  15,92,223                           // subps         %xmm7,%xmm3
  .byte  65,15,89,220                        // mulps         %xmm12,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  65,15,89,204                        // mulps         %xmm12,%xmm1
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  102,65,15,254,224                   // paddd         %xmm8,%xmm4
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,68,15,127,124,36,192            // movdqa        %xmm15,-0x40(%rsp)
  .byte  102,65,15,254,199                   // paddd         %xmm15,%xmm0
  .byte  102,65,15,56,64,195                 // pmulld        %xmm11,%xmm0
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,250,45,108,132,1,0           // psubd         0x1846c(%rip),%xmm5        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,69,15,118,192                   // pcmpeqd       %xmm8,%xmm8
  .byte  102,72,15,58,22,233,1               // pextrq        $0x1,%xmm5,%rcx
  .byte  102,72,15,126,237                   // movq          %xmm5,%rbp
  .byte  65,137,232                          // mov           %ebp,%r8d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  137,203                             // mov           %ecx,%ebx
  .byte  243,66,15,16,60,128                 // movss         (%rax,%r8,4),%xmm7
  .byte  102,15,58,33,60,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm7
  .byte  243,15,16,44,152                    // movss         (%rax,%rbx,4),%xmm5
  .byte  102,15,58,33,253,32                 // insertps      $0x20,%xmm5,%xmm7
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,44,136                    // movss         (%rax,%rcx,4),%xmm5
  .byte  102,15,58,33,253,48                 // insertps      $0x30,%xmm5,%xmm7
  .byte  102,65,15,126,193                   // movd          %xmm0,%r9d
  .byte  102,65,15,58,22,195,1               // pextrd        $0x1,%xmm0,%r11d
  .byte  102,65,15,58,22,194,2               // pextrd        $0x2,%xmm0,%r10d
  .byte  102,65,15,58,22,192,3               // pextrd        $0x3,%xmm0,%r8d
  .byte  102,65,15,254,194                   // paddd         %xmm10,%xmm0
  .byte  102,72,15,58,22,193,1               // pextrq        $0x1,%xmm0,%rcx
  .byte  102,72,15,126,195                   // movq          %xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  137,205                             // mov           %ecx,%ebp
  .byte  243,66,15,16,4,176                  // movss         (%rax,%r14,4),%xmm0
  .byte  102,15,58,33,4,152,16               // insertps      $0x10,(%rax,%rbx,4),%xmm0
  .byte  243,15,16,44,168                    // movss         (%rax,%rbp,4),%xmm5
  .byte  102,15,58,33,197,32                 // insertps      $0x20,%xmm5,%xmm0
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,44,136                    // movss         (%rax,%rcx,4),%xmm5
  .byte  102,15,58,33,197,48                 // insertps      $0x30,%xmm5,%xmm0
  .byte  102,65,15,254,225                   // paddd         %xmm9,%xmm4
  .byte  102,65,15,56,64,227                 // pmulld        %xmm11,%xmm4
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,65,15,250,232                   // psubd         %xmm8,%xmm5
  .byte  102,72,15,58,22,233,1               // pextrq        $0x1,%xmm5,%rcx
  .byte  102,72,15,126,235                   // movq          %xmm5,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  137,205                             // mov           %ecx,%ebp
  .byte  243,70,15,16,4,176                  // movss         (%rax,%r14,4),%xmm8
  .byte  102,68,15,58,33,4,152,16            // insertps      $0x10,(%rax,%rbx,4),%xmm8
  .byte  243,15,16,44,168                    // movss         (%rax,%rbp,4),%xmm5
  .byte  102,68,15,58,33,197,32              // insertps      $0x20,%xmm5,%xmm8
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,44,136                    // movss         (%rax,%rcx,4),%xmm5
  .byte  102,68,15,58,33,197,48              // insertps      $0x30,%xmm5,%xmm8
  .byte  102,65,15,126,231                   // movd          %xmm4,%r15d
  .byte  102,65,15,58,22,228,1               // pextrd        $0x1,%xmm4,%r12d
  .byte  102,65,15,58,22,229,2               // pextrd        $0x2,%xmm4,%r13d
  .byte  102,65,15,58,22,230,3               // pextrd        $0x3,%xmm4,%r14d
  .byte  102,65,15,254,226                   // paddd         %xmm10,%xmm4
  .byte  102,72,15,58,22,225,1               // pextrq        $0x1,%xmm4,%rcx
  .byte  102,72,15,126,227                   // movq          %xmm4,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  243,68,15,16,12,168                 // movss         (%rax,%rbp,4),%xmm9
  .byte  102,68,15,58,33,12,152,16           // insertps      $0x10,(%rax,%rbx,4),%xmm9
  .byte  137,203                             // mov           %ecx,%ebx
  .byte  243,15,16,36,152                    // movss         (%rax,%rbx,4),%xmm4
  .byte  102,68,15,58,33,204,32              // insertps      $0x20,%xmm4,%xmm9
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,36,136                    // movss         (%rax,%rcx,4),%xmm4
  .byte  102,68,15,58,33,204,48              // insertps      $0x30,%xmm4,%xmm9
  .byte  243,66,15,16,36,136                 // movss         (%rax,%r9,4),%xmm4
  .byte  102,66,15,58,33,36,152,16           // insertps      $0x10,(%rax,%r11,4),%xmm4
  .byte  102,66,15,58,33,36,144,32           // insertps      $0x20,(%rax,%r10,4),%xmm4
  .byte  102,66,15,58,33,36,128,48           // insertps      $0x30,(%rax,%r8,4),%xmm4
  .byte  243,66,15,16,44,184                 // movss         (%rax,%r15,4),%xmm5
  .byte  102,66,15,58,33,44,160,16           // insertps      $0x10,(%rax,%r12,4),%xmm5
  .byte  102,66,15,58,33,44,168,32           // insertps      $0x20,(%rax,%r13,4),%xmm5
  .byte  102,66,15,58,33,44,176,48           // insertps      $0x30,(%rax,%r14,4),%xmm5
  .byte  15,92,236                           // subps         %xmm4,%xmm5
  .byte  65,15,89,236                        // mulps         %xmm12,%xmm5
  .byte  15,88,236                           // addps         %xmm4,%xmm5
  .byte  68,15,92,199                        // subps         %xmm7,%xmm8
  .byte  69,15,89,196                        // mulps         %xmm12,%xmm8
  .byte  68,15,88,199                        // addps         %xmm7,%xmm8
  .byte  68,15,92,200                        // subps         %xmm0,%xmm9
  .byte  69,15,89,204                        // mulps         %xmm12,%xmm9
  .byte  68,15,88,200                        // addps         %xmm0,%xmm9
  .byte  15,91,68,36,128                     // cvtdq2ps      -0x80(%rsp),%xmm0
  .byte  15,92,208                           // subps         %xmm0,%xmm2
  .byte  15,41,84,36,128                     // movaps        %xmm2,-0x80(%rsp)
  .byte  15,92,238                           // subps         %xmm6,%xmm5
  .byte  15,89,234                           // mulps         %xmm2,%xmm5
  .byte  15,88,238                           // addps         %xmm6,%xmm5
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  68,15,89,194                        // mulps         %xmm2,%xmm8
  .byte  68,15,88,195                        // addps         %xmm3,%xmm8
  .byte  68,15,92,201                        // subps         %xmm1,%xmm9
  .byte  68,15,89,202                        // mulps         %xmm2,%xmm9
  .byte  68,15,88,201                        // addps         %xmm1,%xmm9
  .byte  102,15,111,68,36,144                // movdqa        -0x70(%rsp),%xmm0
  .byte  102,15,254,68,36,16                 // paddd         0x10(%rsp),%xmm0
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,65,15,254,206                   // paddd         %xmm14,%xmm1
  .byte  102,15,111,217                      // movdqa        %xmm1,%xmm3
  .byte  102,65,15,254,223                   // paddd         %xmm15,%xmm3
  .byte  102,65,15,111,211                   // movdqa        %xmm11,%xmm2
  .byte  102,15,56,64,218                    // pmulld        %xmm2,%xmm3
  .byte  102,15,126,217                      // movd          %xmm3,%ecx
  .byte  102,15,58,22,221,1                  // pextrd        $0x1,%xmm3,%ebp
  .byte  102,65,15,58,22,216,2               // pextrd        $0x2,%xmm3,%r8d
  .byte  102,15,58,22,219,3                  // pextrd        $0x3,%xmm3,%ebx
  .byte  243,68,15,16,20,136                 // movss         (%rax,%rcx,4),%xmm10
  .byte  102,68,15,58,33,20,168,16           // insertps      $0x10,(%rax,%rbp,4),%xmm10
  .byte  102,70,15,58,33,20,128,32           // insertps      $0x20,(%rax,%r8,4),%xmm10
  .byte  243,15,16,36,152                    // movss         (%rax,%rbx,4),%xmm4
  .byte  102,68,15,58,33,212,48              // insertps      $0x30,%xmm4,%xmm10
  .byte  102,15,111,227                      // movdqa        %xmm3,%xmm4
  .byte  102,15,118,246                      // pcmpeqd       %xmm6,%xmm6
  .byte  102,15,250,230                      // psubd         %xmm6,%xmm4
  .byte  102,72,15,58,22,225,1               // pextrq        $0x1,%xmm4,%rcx
  .byte  102,72,15,126,229                   // movq          %xmm4,%rbp
  .byte  65,137,232                          // mov           %ebp,%r8d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  137,203                             // mov           %ecx,%ebx
  .byte  243,70,15,16,28,128                 // movss         (%rax,%r8,4),%xmm11
  .byte  102,68,15,58,33,28,168,16           // insertps      $0x10,(%rax,%rbp,4),%xmm11
  .byte  243,15,16,36,152                    // movss         (%rax,%rbx,4),%xmm4
  .byte  102,68,15,58,33,220,32              // insertps      $0x20,%xmm4,%xmm11
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,36,136                    // movss         (%rax,%rcx,4),%xmm4
  .byte  102,68,15,58,33,220,48              // insertps      $0x30,%xmm4,%xmm11
  .byte  102,15,111,61,144,123,1,0           // movdqa        0x17b90(%rip),%xmm7        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,15,254,223                      // paddd         %xmm7,%xmm3
  .byte  102,72,15,58,22,217,1               // pextrq        $0x1,%xmm3,%rcx
  .byte  102,72,15,126,221                   // movq          %xmm3,%rbp
  .byte  65,137,232                          // mov           %ebp,%r8d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  137,203                             // mov           %ecx,%ebx
  .byte  243,66,15,16,36,128                 // movss         (%rax,%r8,4),%xmm4
  .byte  102,15,58,33,36,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm4
  .byte  243,15,16,28,152                    // movss         (%rax,%rbx,4),%xmm3
  .byte  102,15,58,33,227,32                 // insertps      $0x20,%xmm3,%xmm4
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,28,136                    // movss         (%rax,%rcx,4),%xmm3
  .byte  102,15,58,33,227,48                 // insertps      $0x30,%xmm3,%xmm4
  .byte  102,68,15,111,124,36,176            // movdqa        -0x50(%rsp),%xmm15
  .byte  102,65,15,254,207                   // paddd         %xmm15,%xmm1
  .byte  102,15,56,64,202                    // pmulld        %xmm2,%xmm1
  .byte  102,15,111,217                      // movdqa        %xmm1,%xmm3
  .byte  102,15,250,222                      // psubd         %xmm6,%xmm3
  .byte  102,72,15,58,22,217,1               // pextrq        $0x1,%xmm3,%rcx
  .byte  102,72,15,126,221                   // movq          %xmm3,%rbp
  .byte  65,137,232                          // mov           %ebp,%r8d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  137,203                             // mov           %ecx,%ebx
  .byte  243,66,15,16,52,128                 // movss         (%rax,%r8,4),%xmm6
  .byte  102,15,58,33,52,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm6
  .byte  243,15,16,28,152                    // movss         (%rax,%rbx,4),%xmm3
  .byte  102,15,58,33,243,32                 // insertps      $0x20,%xmm3,%xmm6
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,28,136                    // movss         (%rax,%rcx,4),%xmm3
  .byte  102,15,58,33,243,48                 // insertps      $0x30,%xmm3,%xmm6
  .byte  102,65,15,126,201                   // movd          %xmm1,%r9d
  .byte  102,65,15,58,22,203,1               // pextrd        $0x1,%xmm1,%r11d
  .byte  102,65,15,58,22,202,2               // pextrd        $0x2,%xmm1,%r10d
  .byte  102,65,15,58,22,200,3               // pextrd        $0x3,%xmm1,%r8d
  .byte  102,15,254,207                      // paddd         %xmm7,%xmm1
  .byte  102,72,15,58,22,201,1               // pextrq        $0x1,%xmm1,%rcx
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  137,205                             // mov           %ecx,%ebp
  .byte  243,66,15,16,60,176                 // movss         (%rax,%r14,4),%xmm7
  .byte  102,15,58,33,60,152,16              // insertps      $0x10,(%rax,%rbx,4),%xmm7
  .byte  243,15,16,12,168                    // movss         (%rax,%rbp,4),%xmm1
  .byte  102,15,58,33,249,32                 // insertps      $0x20,%xmm1,%xmm7
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,12,136                    // movss         (%rax,%rcx,4),%xmm1
  .byte  102,15,58,33,249,48                 // insertps      $0x30,%xmm1,%xmm7
  .byte  243,66,15,16,28,136                 // movss         (%rax,%r9,4),%xmm3
  .byte  102,66,15,58,33,28,152,16           // insertps      $0x10,(%rax,%r11,4),%xmm3
  .byte  102,66,15,58,33,28,144,32           // insertps      $0x20,(%rax,%r10,4),%xmm3
  .byte  102,66,15,58,33,28,128,48           // insertps      $0x30,(%rax,%r8,4),%xmm3
  .byte  65,15,92,218                        // subps         %xmm10,%xmm3
  .byte  68,15,41,36,36                      // movaps        %xmm12,(%rsp)
  .byte  65,15,89,220                        // mulps         %xmm12,%xmm3
  .byte  65,15,88,218                        // addps         %xmm10,%xmm3
  .byte  65,15,92,243                        // subps         %xmm11,%xmm6
  .byte  65,15,89,244                        // mulps         %xmm12,%xmm6
  .byte  65,15,88,243                        // addps         %xmm11,%xmm6
  .byte  15,92,252                           // subps         %xmm4,%xmm7
  .byte  65,15,89,252                        // mulps         %xmm12,%xmm7
  .byte  15,88,252                           // addps         %xmm4,%xmm7
  .byte  102,15,254,68,36,208                // paddd         -0x30(%rsp),%xmm0
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,254,76,36,192                // paddd         -0x40(%rsp),%xmm1
  .byte  102,68,15,111,218                   // movdqa        %xmm2,%xmm11
  .byte  102,65,15,56,64,203                 // pmulld        %xmm11,%xmm1
  .byte  102,15,111,225                      // movdqa        %xmm1,%xmm4
  .byte  102,69,15,118,228                   // pcmpeqd       %xmm12,%xmm12
  .byte  102,65,15,250,228                   // psubd         %xmm12,%xmm4
  .byte  102,72,15,58,22,225,1               // pextrq        $0x1,%xmm4,%rcx
  .byte  102,72,15,126,229                   // movq          %xmm4,%rbp
  .byte  65,137,232                          // mov           %ebp,%r8d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  137,203                             // mov           %ecx,%ebx
  .byte  243,66,15,16,36,128                 // movss         (%rax,%r8,4),%xmm4
  .byte  102,15,58,33,36,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm4
  .byte  243,15,16,20,152                    // movss         (%rax,%rbx,4),%xmm2
  .byte  102,15,58,33,226,32                 // insertps      $0x20,%xmm2,%xmm4
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,20,136                    // movss         (%rax,%rcx,4),%xmm2
  .byte  102,15,58,33,226,48                 // insertps      $0x30,%xmm2,%xmm4
  .byte  102,65,15,126,200                   // movd          %xmm1,%r8d
  .byte  102,65,15,58,22,201,1               // pextrd        $0x1,%xmm1,%r9d
  .byte  102,65,15,58,22,202,2               // pextrd        $0x2,%xmm1,%r10d
  .byte  102,65,15,58,22,203,3               // pextrd        $0x3,%xmm1,%r11d
  .byte  102,68,15,111,21,212,121,1,0        // movdqa        0x179d4(%rip),%xmm10        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,65,15,254,202                   // paddd         %xmm10,%xmm1
  .byte  102,72,15,58,22,201,1               // pextrq        $0x1,%xmm1,%rcx
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  137,205                             // mov           %ecx,%ebp
  .byte  243,66,15,16,12,176                 // movss         (%rax,%r14,4),%xmm1
  .byte  102,15,58,33,12,152,16              // insertps      $0x10,(%rax,%rbx,4),%xmm1
  .byte  243,15,16,20,168                    // movss         (%rax,%rbp,4),%xmm2
  .byte  102,15,58,33,202,32                 // insertps      $0x20,%xmm2,%xmm1
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,20,136                    // movss         (%rax,%rcx,4),%xmm2
  .byte  102,15,58,33,202,48                 // insertps      $0x30,%xmm2,%xmm1
  .byte  102,65,15,254,199                   // paddd         %xmm15,%xmm0
  .byte  102,65,15,56,64,195                 // pmulld        %xmm11,%xmm0
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,65,15,250,212                   // psubd         %xmm12,%xmm2
  .byte  102,72,15,58,22,209,1               // pextrq        $0x1,%xmm2,%rcx
  .byte  102,72,15,126,211                   // movq          %xmm2,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  137,205                             // mov           %ecx,%ebp
  .byte  243,70,15,16,60,176                 // movss         (%rax,%r14,4),%xmm15
  .byte  102,68,15,58,33,60,152,16           // insertps      $0x10,(%rax,%rbx,4),%xmm15
  .byte  243,15,16,20,168                    // movss         (%rax,%rbp,4),%xmm2
  .byte  102,68,15,58,33,250,32              // insertps      $0x20,%xmm2,%xmm15
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,20,136                    // movss         (%rax,%rcx,4),%xmm2
  .byte  102,68,15,58,33,250,48              // insertps      $0x30,%xmm2,%xmm15
  .byte  102,65,15,126,199                   // movd          %xmm0,%r15d
  .byte  102,65,15,58,22,196,1               // pextrd        $0x1,%xmm0,%r12d
  .byte  102,65,15,58,22,197,2               // pextrd        $0x2,%xmm0,%r13d
  .byte  102,65,15,58,22,198,3               // pextrd        $0x3,%xmm0,%r14d
  .byte  102,65,15,254,194                   // paddd         %xmm10,%xmm0
  .byte  102,72,15,58,22,193,1               // pextrq        $0x1,%xmm0,%rcx
  .byte  102,72,15,126,195                   // movq          %xmm0,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  243,68,15,16,28,168                 // movss         (%rax,%rbp,4),%xmm11
  .byte  102,68,15,58,33,28,152,16           // insertps      $0x10,(%rax,%rbx,4),%xmm11
  .byte  137,203                             // mov           %ecx,%ebx
  .byte  243,15,16,4,152                     // movss         (%rax,%rbx,4),%xmm0
  .byte  102,68,15,58,33,216,32              // insertps      $0x20,%xmm0,%xmm11
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,4,136                     // movss         (%rax,%rcx,4),%xmm0
  .byte  102,68,15,58,33,216,48              // insertps      $0x30,%xmm0,%xmm11
  .byte  243,66,15,16,4,128                  // movss         (%rax,%r8,4),%xmm0
  .byte  102,66,15,58,33,4,136,16            // insertps      $0x10,(%rax,%r9,4),%xmm0
  .byte  102,66,15,58,33,4,144,32            // insertps      $0x20,(%rax,%r10,4),%xmm0
  .byte  102,66,15,58,33,4,152,48            // insertps      $0x30,(%rax,%r11,4),%xmm0
  .byte  243,70,15,16,20,184                 // movss         (%rax,%r15,4),%xmm10
  .byte  102,70,15,58,33,20,160,16           // insertps      $0x10,(%rax,%r12,4),%xmm10
  .byte  102,70,15,58,33,20,168,32           // insertps      $0x20,(%rax,%r13,4),%xmm10
  .byte  102,70,15,58,33,20,176,48           // insertps      $0x30,(%rax,%r14,4),%xmm10
  .byte  68,15,92,208                        // subps         %xmm0,%xmm10
  .byte  68,15,40,36,36                      // movaps        (%rsp),%xmm12
  .byte  69,15,89,212                        // mulps         %xmm12,%xmm10
  .byte  68,15,88,208                        // addps         %xmm0,%xmm10
  .byte  68,15,92,252                        // subps         %xmm4,%xmm15
  .byte  69,15,89,252                        // mulps         %xmm12,%xmm15
  .byte  68,15,88,252                        // addps         %xmm4,%xmm15
  .byte  68,15,92,217                        // subps         %xmm1,%xmm11
  .byte  69,15,89,220                        // mulps         %xmm12,%xmm11
  .byte  68,15,88,217                        // addps         %xmm1,%xmm11
  .byte  68,15,92,211                        // subps         %xmm3,%xmm10
  .byte  15,40,68,36,128                     // movaps        -0x80(%rsp),%xmm0
  .byte  68,15,89,208                        // mulps         %xmm0,%xmm10
  .byte  68,15,88,211                        // addps         %xmm3,%xmm10
  .byte  68,15,92,254                        // subps         %xmm6,%xmm15
  .byte  68,15,89,248                        // mulps         %xmm0,%xmm15
  .byte  68,15,88,254                        // addps         %xmm6,%xmm15
  .byte  68,15,92,223                        // subps         %xmm7,%xmm11
  .byte  68,15,89,216                        // mulps         %xmm0,%xmm11
  .byte  68,15,88,223                        // addps         %xmm7,%xmm11
  .byte  15,91,68,36,32                      // cvtdq2ps      0x20(%rsp),%xmm0
  .byte  15,40,76,36,224                     // movaps        -0x20(%rsp),%xmm1
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,41,76,36,224                     // movaps        %xmm1,-0x20(%rsp)
  .byte  68,15,92,213                        // subps         %xmm5,%xmm10
  .byte  68,15,89,209                        // mulps         %xmm1,%xmm10
  .byte  68,15,88,213                        // addps         %xmm5,%xmm10
  .byte  69,15,92,248                        // subps         %xmm8,%xmm15
  .byte  68,15,89,249                        // mulps         %xmm1,%xmm15
  .byte  69,15,88,248                        // addps         %xmm8,%xmm15
  .byte  69,15,92,217                        // subps         %xmm9,%xmm11
  .byte  68,15,89,217                        // mulps         %xmm1,%xmm11
  .byte  69,15,88,217                        // addps         %xmm9,%xmm11
  .byte  243,15,91,68,36,160                 // cvttps2dq     -0x60(%rsp),%xmm0
  .byte  102,15,127,68,36,160                // movdqa        %xmm0,-0x60(%rsp)
  .byte  102,68,15,254,232                   // paddd         %xmm0,%xmm13
  .byte  102,65,15,111,222                   // movdqa        %xmm14,%xmm3
  .byte  102,65,15,254,221                   // paddd         %xmm13,%xmm3
  .byte  102,15,111,124,36,192               // movdqa        -0x40(%rsp),%xmm7
  .byte  102,15,111,199                      // movdqa        %xmm7,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  102,15,111,21,46,126,1,0            // movdqa        0x17e2e(%rip),%xmm2        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,15,56,64,194                    // pmulld        %xmm2,%xmm0
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,69,15,118,192                   // pcmpeqd       %xmm8,%xmm8
  .byte  102,65,15,250,200                   // psubd         %xmm8,%xmm1
  .byte  102,72,15,58,22,201,1               // pextrq        $0x1,%xmm1,%rcx
  .byte  102,72,15,126,205                   // movq          %xmm1,%rbp
  .byte  137,235                             // mov           %ebp,%ebx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  65,137,200                          // mov           %ecx,%r8d
  .byte  243,15,16,44,152                    // movss         (%rax,%rbx,4),%xmm5
  .byte  102,15,58,33,44,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm5
  .byte  243,66,15,16,12,128                 // movss         (%rax,%r8,4),%xmm1
  .byte  102,15,58,33,233,32                 // insertps      $0x20,%xmm1,%xmm5
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,12,136                    // movss         (%rax,%rcx,4),%xmm1
  .byte  102,15,58,33,233,48                 // insertps      $0x30,%xmm1,%xmm5
  .byte  102,65,15,126,192                   // movd          %xmm0,%r8d
  .byte  102,65,15,58,22,193,1               // pextrd        $0x1,%xmm0,%r9d
  .byte  102,65,15,58,22,194,2               // pextrd        $0x2,%xmm0,%r10d
  .byte  102,65,15,58,22,195,3               // pextrd        $0x3,%xmm0,%r11d
  .byte  102,15,111,37,125,119,1,0           // movdqa        0x1777d(%rip),%xmm4        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,15,254,196                      // paddd         %xmm4,%xmm0
  .byte  102,72,15,58,22,193,1               // pextrq        $0x1,%xmm0,%rcx
  .byte  102,72,15,126,195                   // movq          %xmm0,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  65,137,206                          // mov           %ecx,%r14d
  .byte  243,15,16,52,168                    // movss         (%rax,%rbp,4),%xmm6
  .byte  102,15,58,33,52,152,16              // insertps      $0x10,(%rax,%rbx,4),%xmm6
  .byte  243,66,15,16,4,176                  // movss         (%rax,%r14,4),%xmm0
  .byte  102,15,58,33,240,32                 // insertps      $0x20,%xmm0,%xmm6
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,4,136                     // movss         (%rax,%rcx,4),%xmm0
  .byte  102,15,58,33,240,48                 // insertps      $0x30,%xmm0,%xmm6
  .byte  102,68,15,111,76,36,176             // movdqa        -0x50(%rsp),%xmm9
  .byte  102,65,15,254,217                   // paddd         %xmm9,%xmm3
  .byte  102,15,56,64,218                    // pmulld        %xmm2,%xmm3
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,65,15,250,192                   // psubd         %xmm8,%xmm0
  .byte  102,72,15,58,22,193,1               // pextrq        $0x1,%xmm0,%rcx
  .byte  102,72,15,126,195                   // movq          %xmm0,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  65,137,206                          // mov           %ecx,%r14d
  .byte  243,15,16,4,168                     // movss         (%rax,%rbp,4),%xmm0
  .byte  102,15,58,33,4,152,16               // insertps      $0x10,(%rax,%rbx,4),%xmm0
  .byte  243,66,15,16,12,176                 // movss         (%rax,%r14,4),%xmm1
  .byte  102,15,58,33,193,32                 // insertps      $0x20,%xmm1,%xmm0
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,12,136                    // movss         (%rax,%rcx,4),%xmm1
  .byte  102,15,58,33,193,48                 // insertps      $0x30,%xmm1,%xmm0
  .byte  102,65,15,126,221                   // movd          %xmm3,%r13d
  .byte  102,65,15,58,22,223,1               // pextrd        $0x1,%xmm3,%r15d
  .byte  102,65,15,58,22,220,2               // pextrd        $0x2,%xmm3,%r12d
  .byte  102,65,15,58,22,222,3               // pextrd        $0x3,%xmm3,%r14d
  .byte  102,15,254,220                      // paddd         %xmm4,%xmm3
  .byte  102,68,15,111,196                   // movdqa        %xmm4,%xmm8
  .byte  102,72,15,58,22,219,1               // pextrq        $0x1,%xmm3,%rbx
  .byte  102,72,15,126,221                   // movq          %xmm3,%rbp
  .byte  137,233                             // mov           %ebp,%ecx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  243,15,16,28,136                    // movss         (%rax,%rcx,4),%xmm3
  .byte  102,15,58,33,28,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm3
  .byte  137,217                             // mov           %ebx,%ecx
  .byte  243,15,16,12,136                    // movss         (%rax,%rcx,4),%xmm1
  .byte  102,15,58,33,217,32                 // insertps      $0x20,%xmm1,%xmm3
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  243,15,16,12,152                    // movss         (%rax,%rbx,4),%xmm1
  .byte  102,15,58,33,217,48                 // insertps      $0x30,%xmm1,%xmm3
  .byte  243,66,15,16,12,128                 // movss         (%rax,%r8,4),%xmm1
  .byte  102,66,15,58,33,12,136,16           // insertps      $0x10,(%rax,%r9,4),%xmm1
  .byte  102,66,15,58,33,12,144,32           // insertps      $0x20,(%rax,%r10,4),%xmm1
  .byte  102,66,15,58,33,12,152,48           // insertps      $0x30,(%rax,%r11,4),%xmm1
  .byte  243,66,15,16,36,168                 // movss         (%rax,%r13,4),%xmm4
  .byte  102,66,15,58,33,36,184,16           // insertps      $0x10,(%rax,%r15,4),%xmm4
  .byte  102,66,15,58,33,36,160,32           // insertps      $0x20,(%rax,%r12,4),%xmm4
  .byte  102,66,15,58,33,36,176,48           // insertps      $0x30,(%rax,%r14,4),%xmm4
  .byte  15,92,225                           // subps         %xmm1,%xmm4
  .byte  65,15,89,228                        // mulps         %xmm12,%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  65,15,89,196                        // mulps         %xmm12,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,92,222                           // subps         %xmm6,%xmm3
  .byte  65,15,89,220                        // mulps         %xmm12,%xmm3
  .byte  15,88,222                           // addps         %xmm6,%xmm3
  .byte  102,68,15,254,108,36,208            // paddd         -0x30(%rsp),%xmm13
  .byte  102,65,15,111,205                   // movdqa        %xmm13,%xmm1
  .byte  102,15,254,207                      // paddd         %xmm7,%xmm1
  .byte  102,68,15,111,226                   // movdqa        %xmm2,%xmm12
  .byte  102,65,15,56,64,204                 // pmulld        %xmm12,%xmm1
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,15,250,21,89,124,1,0            // psubd         0x17c59(%rip),%xmm2        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,72,15,58,22,209,1               // pextrq        $0x1,%xmm2,%rcx
  .byte  102,72,15,126,213                   // movq          %xmm2,%rbp
  .byte  137,235                             // mov           %ebp,%ebx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  65,137,200                          // mov           %ecx,%r8d
  .byte  243,15,16,44,152                    // movss         (%rax,%rbx,4),%xmm5
  .byte  102,15,58,33,44,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm5
  .byte  243,66,15,16,20,128                 // movss         (%rax,%r8,4),%xmm2
  .byte  102,15,58,33,234,32                 // insertps      $0x20,%xmm2,%xmm5
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,20,136                    // movss         (%rax,%rcx,4),%xmm2
  .byte  102,15,58,33,234,48                 // insertps      $0x30,%xmm2,%xmm5
  .byte  102,65,15,126,200                   // movd          %xmm1,%r8d
  .byte  102,65,15,58,22,201,1               // pextrd        $0x1,%xmm1,%r9d
  .byte  102,65,15,58,22,202,2               // pextrd        $0x2,%xmm1,%r10d
  .byte  102,65,15,58,22,203,3               // pextrd        $0x3,%xmm1,%r11d
  .byte  102,65,15,254,200                   // paddd         %xmm8,%xmm1
  .byte  102,72,15,58,22,201,1               // pextrq        $0x1,%xmm1,%rcx
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  65,137,206                          // mov           %ecx,%r14d
  .byte  243,15,16,52,168                    // movss         (%rax,%rbp,4),%xmm6
  .byte  102,15,58,33,52,152,16              // insertps      $0x10,(%rax,%rbx,4),%xmm6
  .byte  243,66,15,16,12,176                 // movss         (%rax,%r14,4),%xmm1
  .byte  102,15,58,33,241,32                 // insertps      $0x20,%xmm1,%xmm6
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,12,136                    // movss         (%rax,%rcx,4),%xmm1
  .byte  102,15,58,33,241,48                 // insertps      $0x30,%xmm1,%xmm6
  .byte  102,69,15,254,233                   // paddd         %xmm9,%xmm13
  .byte  102,65,15,111,249                   // movdqa        %xmm9,%xmm7
  .byte  102,69,15,56,64,236                 // pmulld        %xmm12,%xmm13
  .byte  102,65,15,111,205                   // movdqa        %xmm13,%xmm1
  .byte  102,15,250,13,165,123,1,0           // psubd         0x17ba5(%rip),%xmm1        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,72,15,58,22,201,1               // pextrq        $0x1,%xmm1,%rcx
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  65,137,206                          // mov           %ecx,%r14d
  .byte  243,68,15,16,12,168                 // movss         (%rax,%rbp,4),%xmm9
  .byte  102,68,15,58,33,12,152,16           // insertps      $0x10,(%rax,%rbx,4),%xmm9
  .byte  243,66,15,16,12,176                 // movss         (%rax,%r14,4),%xmm1
  .byte  102,68,15,58,33,201,32              // insertps      $0x20,%xmm1,%xmm9
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,12,136                    // movss         (%rax,%rcx,4),%xmm1
  .byte  102,68,15,58,33,201,48              // insertps      $0x30,%xmm1,%xmm9
  .byte  102,69,15,126,237                   // movd          %xmm13,%r13d
  .byte  102,69,15,58,22,239,1               // pextrd        $0x1,%xmm13,%r15d
  .byte  102,69,15,58,22,236,2               // pextrd        $0x2,%xmm13,%r12d
  .byte  102,69,15,58,22,238,3               // pextrd        $0x3,%xmm13,%r14d
  .byte  102,69,15,254,232                   // paddd         %xmm8,%xmm13
  .byte  102,76,15,58,22,235,1               // pextrq        $0x1,%xmm13,%rbx
  .byte  102,76,15,126,237                   // movq          %xmm13,%rbp
  .byte  137,233                             // mov           %ebp,%ecx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  243,68,15,16,4,136                  // movss         (%rax,%rcx,4),%xmm8
  .byte  102,68,15,58,33,4,168,16            // insertps      $0x10,(%rax,%rbp,4),%xmm8
  .byte  137,217                             // mov           %ebx,%ecx
  .byte  243,15,16,12,136                    // movss         (%rax,%rcx,4),%xmm1
  .byte  102,68,15,58,33,193,32              // insertps      $0x20,%xmm1,%xmm8
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  243,15,16,12,152                    // movss         (%rax,%rbx,4),%xmm1
  .byte  102,68,15,58,33,193,48              // insertps      $0x30,%xmm1,%xmm8
  .byte  243,66,15,16,12,128                 // movss         (%rax,%r8,4),%xmm1
  .byte  102,66,15,58,33,12,136,16           // insertps      $0x10,(%rax,%r9,4),%xmm1
  .byte  102,66,15,58,33,12,144,32           // insertps      $0x20,(%rax,%r10,4),%xmm1
  .byte  102,66,15,58,33,12,152,48           // insertps      $0x30,(%rax,%r11,4),%xmm1
  .byte  243,70,15,16,36,168                 // movss         (%rax,%r13,4),%xmm12
  .byte  102,70,15,58,33,36,184,16           // insertps      $0x10,(%rax,%r15,4),%xmm12
  .byte  102,70,15,58,33,36,160,32           // insertps      $0x20,(%rax,%r12,4),%xmm12
  .byte  102,70,15,58,33,36,176,48           // insertps      $0x30,(%rax,%r14,4),%xmm12
  .byte  68,15,92,225                        // subps         %xmm1,%xmm12
  .byte  68,15,40,44,36                      // movaps        (%rsp),%xmm13
  .byte  69,15,89,229                        // mulps         %xmm13,%xmm12
  .byte  68,15,88,225                        // addps         %xmm1,%xmm12
  .byte  68,15,92,205                        // subps         %xmm5,%xmm9
  .byte  69,15,89,205                        // mulps         %xmm13,%xmm9
  .byte  68,15,88,205                        // addps         %xmm5,%xmm9
  .byte  68,15,92,198                        // subps         %xmm6,%xmm8
  .byte  69,15,89,197                        // mulps         %xmm13,%xmm8
  .byte  68,15,88,198                        // addps         %xmm6,%xmm8
  .byte  68,15,92,228                        // subps         %xmm4,%xmm12
  .byte  15,40,76,36,128                     // movaps        -0x80(%rsp),%xmm1
  .byte  68,15,89,225                        // mulps         %xmm1,%xmm12
  .byte  68,15,88,228                        // addps         %xmm4,%xmm12
  .byte  68,15,92,200                        // subps         %xmm0,%xmm9
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  68,15,88,200                        // addps         %xmm0,%xmm9
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  68,15,89,193                        // mulps         %xmm1,%xmm8
  .byte  68,15,88,195                        // addps         %xmm3,%xmm8
  .byte  102,15,111,68,36,144                // movdqa        -0x70(%rsp),%xmm0
  .byte  102,15,254,68,36,160                // paddd         -0x60(%rsp),%xmm0
  .byte  102,15,127,68,36,144                // movdqa        %xmm0,-0x70(%rsp)
  .byte  102,68,15,254,240                   // paddd         %xmm0,%xmm14
  .byte  102,65,15,111,206                   // movdqa        %xmm14,%xmm1
  .byte  102,15,111,108,36,192               // movdqa        -0x40(%rsp),%xmm5
  .byte  102,15,254,205                      // paddd         %xmm5,%xmm1
  .byte  102,15,111,37,60,122,1,0            // movdqa        0x17a3c(%rip),%xmm4        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,15,56,64,204                    // pmulld        %xmm4,%xmm1
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,118,246                      // pcmpeqd       %xmm6,%xmm6
  .byte  102,15,250,198                      // psubd         %xmm6,%xmm0
  .byte  102,72,15,58,22,193,1               // pextrq        $0x1,%xmm0,%rcx
  .byte  102,72,15,126,197                   // movq          %xmm0,%rbp
  .byte  137,235                             // mov           %ebp,%ebx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  65,137,200                          // mov           %ecx,%r8d
  .byte  243,15,16,4,152                     // movss         (%rax,%rbx,4),%xmm0
  .byte  102,15,58,33,4,168,16               // insertps      $0x10,(%rax,%rbp,4),%xmm0
  .byte  243,66,15,16,20,128                 // movss         (%rax,%r8,4),%xmm2
  .byte  102,15,58,33,194,32                 // insertps      $0x20,%xmm2,%xmm0
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,20,136                    // movss         (%rax,%rcx,4),%xmm2
  .byte  102,15,58,33,194,48                 // insertps      $0x30,%xmm2,%xmm0
  .byte  102,65,15,126,200                   // movd          %xmm1,%r8d
  .byte  102,65,15,58,22,201,1               // pextrd        $0x1,%xmm1,%r9d
  .byte  102,65,15,58,22,202,2               // pextrd        $0x2,%xmm1,%r10d
  .byte  102,65,15,58,22,203,3               // pextrd        $0x3,%xmm1,%r11d
  .byte  102,15,111,29,141,115,1,0           // movdqa        0x1738d(%rip),%xmm3        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,15,254,203                      // paddd         %xmm3,%xmm1
  .byte  102,72,15,58,22,201,1               // pextrq        $0x1,%xmm1,%rcx
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  65,137,206                          // mov           %ecx,%r14d
  .byte  243,15,16,12,168                    // movss         (%rax,%rbp,4),%xmm1
  .byte  102,15,58,33,12,152,16              // insertps      $0x10,(%rax,%rbx,4),%xmm1
  .byte  243,66,15,16,20,176                 // movss         (%rax,%r14,4),%xmm2
  .byte  102,15,58,33,202,32                 // insertps      $0x20,%xmm2,%xmm1
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,20,136                    // movss         (%rax,%rcx,4),%xmm2
  .byte  102,15,58,33,202,48                 // insertps      $0x30,%xmm2,%xmm1
  .byte  102,68,15,254,247                   // paddd         %xmm7,%xmm14
  .byte  102,68,15,56,64,244                 // pmulld        %xmm4,%xmm14
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,65,15,111,214                   // movdqa        %xmm14,%xmm2
  .byte  102,15,250,214                      // psubd         %xmm6,%xmm2
  .byte  102,72,15,58,22,209,1               // pextrq        $0x1,%xmm2,%rcx
  .byte  102,72,15,126,211                   // movq          %xmm2,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  65,137,206                          // mov           %ecx,%r14d
  .byte  243,15,16,52,168                    // movss         (%rax,%rbp,4),%xmm6
  .byte  102,15,58,33,52,152,16              // insertps      $0x10,(%rax,%rbx,4),%xmm6
  .byte  243,66,15,16,20,176                 // movss         (%rax,%r14,4),%xmm2
  .byte  102,15,58,33,242,32                 // insertps      $0x20,%xmm2,%xmm6
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,20,136                    // movss         (%rax,%rcx,4),%xmm2
  .byte  102,15,58,33,242,48                 // insertps      $0x30,%xmm2,%xmm6
  .byte  102,69,15,126,245                   // movd          %xmm14,%r13d
  .byte  102,69,15,58,22,247,1               // pextrd        $0x1,%xmm14,%r15d
  .byte  102,69,15,58,22,244,2               // pextrd        $0x2,%xmm14,%r12d
  .byte  102,69,15,58,22,246,3               // pextrd        $0x3,%xmm14,%r14d
  .byte  102,68,15,254,243                   // paddd         %xmm3,%xmm14
  .byte  102,76,15,58,22,243,1               // pextrq        $0x1,%xmm14,%rbx
  .byte  102,76,15,126,245                   // movq          %xmm14,%rbp
  .byte  137,233                             // mov           %ebp,%ecx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  243,15,16,36,136                    // movss         (%rax,%rcx,4),%xmm4
  .byte  102,15,58,33,36,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm4
  .byte  137,217                             // mov           %ebx,%ecx
  .byte  243,15,16,20,136                    // movss         (%rax,%rcx,4),%xmm2
  .byte  102,15,58,33,226,32                 // insertps      $0x20,%xmm2,%xmm4
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  243,15,16,20,152                    // movss         (%rax,%rbx,4),%xmm2
  .byte  102,15,58,33,226,48                 // insertps      $0x30,%xmm2,%xmm4
  .byte  243,66,15,16,20,128                 // movss         (%rax,%r8,4),%xmm2
  .byte  102,66,15,58,33,20,136,16           // insertps      $0x10,(%rax,%r9,4),%xmm2
  .byte  102,66,15,58,33,20,144,32           // insertps      $0x20,(%rax,%r10,4),%xmm2
  .byte  102,66,15,58,33,20,152,48           // insertps      $0x30,(%rax,%r11,4),%xmm2
  .byte  243,66,15,16,28,168                 // movss         (%rax,%r13,4),%xmm3
  .byte  102,66,15,58,33,28,184,16           // insertps      $0x10,(%rax,%r15,4),%xmm3
  .byte  102,66,15,58,33,28,160,32           // insertps      $0x20,(%rax,%r12,4),%xmm3
  .byte  102,66,15,58,33,28,176,48           // insertps      $0x30,(%rax,%r14,4),%xmm3
  .byte  15,92,218                           // subps         %xmm2,%xmm3
  .byte  65,15,89,221                        // mulps         %xmm13,%xmm3
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  15,92,240                           // subps         %xmm0,%xmm6
  .byte  65,15,89,245                        // mulps         %xmm13,%xmm6
  .byte  15,88,240                           // addps         %xmm0,%xmm6
  .byte  15,92,225                           // subps         %xmm1,%xmm4
  .byte  65,15,89,229                        // mulps         %xmm13,%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  102,15,111,68,36,144                // movdqa        -0x70(%rsp),%xmm0
  .byte  102,15,254,68,36,208                // paddd         -0x30(%rsp),%xmm0
  .byte  102,15,254,232                      // paddd         %xmm0,%xmm5
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,15,56,64,239                    // pmulld        %xmm7,%xmm5
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,250,5,109,120,1,0            // psubd         0x1786d(%rip),%xmm0        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,72,15,58,22,193,1               // pextrq        $0x1,%xmm0,%rcx
  .byte  102,72,15,126,197                   // movq          %xmm0,%rbp
  .byte  137,235                             // mov           %ebp,%ebx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  65,137,200                          // mov           %ecx,%r8d
  .byte  243,15,16,44,152                    // movss         (%rax,%rbx,4),%xmm5
  .byte  102,15,58,33,44,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm5
  .byte  243,66,15,16,4,128                  // movss         (%rax,%r8,4),%xmm0
  .byte  102,15,58,33,232,32                 // insertps      $0x20,%xmm0,%xmm5
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,4,136                     // movss         (%rax,%rcx,4),%xmm0
  .byte  102,15,58,33,232,48                 // insertps      $0x30,%xmm0,%xmm5
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,65,15,126,192                   // movd          %xmm0,%r8d
  .byte  102,65,15,58,22,193,1               // pextrd        $0x1,%xmm0,%r9d
  .byte  102,65,15,58,22,194,2               // pextrd        $0x2,%xmm0,%r10d
  .byte  102,65,15,58,22,195,3               // pextrd        $0x3,%xmm0,%r11d
  .byte  102,15,254,5,187,113,1,0            // paddd         0x171bb(%rip),%xmm0        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,72,15,58,22,193,1               // pextrq        $0x1,%xmm0,%rcx
  .byte  102,72,15,126,195                   // movq          %xmm0,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  65,137,206                          // mov           %ecx,%r14d
  .byte  243,68,15,16,52,168                 // movss         (%rax,%rbp,4),%xmm14
  .byte  102,68,15,58,33,52,152,16           // insertps      $0x10,(%rax,%rbx,4),%xmm14
  .byte  243,66,15,16,4,176                  // movss         (%rax,%r14,4),%xmm0
  .byte  102,68,15,58,33,240,32              // insertps      $0x20,%xmm0,%xmm14
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,4,136                     // movss         (%rax,%rcx,4),%xmm0
  .byte  102,68,15,58,33,240,48              // insertps      $0x30,%xmm0,%xmm14
  .byte  102,15,254,84,36,176                // paddd         -0x50(%rsp),%xmm2
  .byte  102,15,56,64,215                    // pmulld        %xmm7,%xmm2
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,250,5,180,119,1,0            // psubd         0x177b4(%rip),%xmm0        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,72,15,58,22,193,1               // pextrq        $0x1,%xmm0,%rcx
  .byte  102,72,15,126,195                   // movq          %xmm0,%rbx
  .byte  137,221                             // mov           %ebx,%ebp
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  65,137,206                          // mov           %ecx,%r14d
  .byte  243,15,16,12,168                    // movss         (%rax,%rbp,4),%xmm1
  .byte  102,15,58,33,12,152,16              // insertps      $0x10,(%rax,%rbx,4),%xmm1
  .byte  243,66,15,16,4,176                  // movss         (%rax,%r14,4),%xmm0
  .byte  102,15,58,33,200,32                 // insertps      $0x20,%xmm0,%xmm1
  .byte  72,193,233,32                       // shr           $0x20,%rcx
  .byte  243,15,16,4,136                     // movss         (%rax,%rcx,4),%xmm0
  .byte  102,15,58,33,200,48                 // insertps      $0x30,%xmm0,%xmm1
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,65,15,126,197                   // movd          %xmm0,%r13d
  .byte  102,65,15,58,22,199,1               // pextrd        $0x1,%xmm0,%r15d
  .byte  102,65,15,58,22,196,2               // pextrd        $0x2,%xmm0,%r12d
  .byte  102,65,15,58,22,198,3               // pextrd        $0x3,%xmm0,%r14d
  .byte  102,15,254,5,2,113,1,0              // paddd         0x17102(%rip),%xmm0        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,72,15,58,22,195,1               // pextrq        $0x1,%xmm0,%rbx
  .byte  102,72,15,126,197                   // movq          %xmm0,%rbp
  .byte  137,233                             // mov           %ebp,%ecx
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  243,15,16,20,136                    // movss         (%rax,%rcx,4),%xmm2
  .byte  102,15,58,33,20,168,16              // insertps      $0x10,(%rax,%rbp,4),%xmm2
  .byte  137,217                             // mov           %ebx,%ecx
  .byte  243,15,16,4,136                     // movss         (%rax,%rcx,4),%xmm0
  .byte  102,15,58,33,208,32                 // insertps      $0x20,%xmm0,%xmm2
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  243,15,16,4,152                     // movss         (%rax,%rbx,4),%xmm0
  .byte  102,15,58,33,208,48                 // insertps      $0x30,%xmm0,%xmm2
  .byte  243,66,15,16,60,128                 // movss         (%rax,%r8,4),%xmm7
  .byte  102,66,15,58,33,60,136,16           // insertps      $0x10,(%rax,%r9,4),%xmm7
  .byte  102,66,15,58,33,60,144,32           // insertps      $0x20,(%rax,%r10,4),%xmm7
  .byte  102,66,15,58,33,60,152,48           // insertps      $0x30,(%rax,%r11,4),%xmm7
  .byte  243,66,15,16,4,168                  // movss         (%rax,%r13,4),%xmm0
  .byte  102,66,15,58,33,4,184,16            // insertps      $0x10,(%rax,%r15,4),%xmm0
  .byte  102,66,15,58,33,4,160,32            // insertps      $0x20,(%rax,%r12,4),%xmm0
  .byte  102,66,15,58,33,4,176,48            // insertps      $0x30,(%rax,%r14,4),%xmm0
  .byte  15,92,199                           // subps         %xmm7,%xmm0
  .byte  65,15,89,197                        // mulps         %xmm13,%xmm0
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  65,15,89,205                        // mulps         %xmm13,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  65,15,92,214                        // subps         %xmm14,%xmm2
  .byte  65,15,89,213                        // mulps         %xmm13,%xmm2
  .byte  65,15,88,214                        // addps         %xmm14,%xmm2
  .byte  15,92,195                           // subps         %xmm3,%xmm0
  .byte  15,40,108,36,128                    // movaps        -0x80(%rsp),%xmm5
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,88,195                           // addps         %xmm3,%xmm0
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,92,212                           // subps         %xmm4,%xmm2
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  65,15,92,196                        // subps         %xmm12,%xmm0
  .byte  15,40,92,36,224                     // movaps        -0x20(%rsp),%xmm3
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  65,15,88,196                        // addps         %xmm12,%xmm0
  .byte  65,15,92,201                        // subps         %xmm9,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  65,15,88,201                        // addps         %xmm9,%xmm1
  .byte  65,15,92,208                        // subps         %xmm8,%xmm2
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  65,15,88,208                        // addps         %xmm8,%xmm2
  .byte  15,91,92,36,16                      // cvtdq2ps      0x10(%rsp),%xmm3
  .byte  15,40,100,36,48                     // movaps        0x30(%rsp),%xmm4
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  65,15,92,194                        // subps         %xmm10,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  65,15,92,207                        // subps         %xmm15,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  65,15,88,207                        // addps         %xmm15,%xmm1
  .byte  65,15,92,211                        // subps         %xmm11,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  65,15,88,211                        // addps         %xmm11,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,191,111,1,0                // movaps        0x16fbf(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  72,139,76,36,248                    // mov           -0x8(%rsp),%rcx
  .byte  15,40,100,36,64                     // movaps        0x40(%rsp),%xmm4
  .byte  15,40,108,36,80                     // movaps        0x50(%rsp),%xmm5
  .byte  15,40,116,36,96                     // movaps        0x60(%rsp),%xmm6
  .byte  15,40,124,36,112                    // movaps        0x70(%rsp),%xmm7
  .byte  72,129,196,136,0,0,0                // add           $0x88,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gauss_a_to_rgba_sse41
.globl _sk_gauss_a_to_rgba_sse41
FUNCTION(_sk_gauss_a_to_rgba_sse41)
_sk_gauss_a_to_rgba_sse41:
  .byte  15,40,5,28,118,1,0                  // movaps        0x1761c(%rip),%xmm0        # 3b1e0 <_sk_srcover_bgra_8888_sse2_lowp+0x1278>
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,5,34,118,1,0                  // addps         0x17622(%rip),%xmm0        # 3b1f0 <_sk_srcover_bgra_8888_sse2_lowp+0x1288>
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,5,40,118,1,0                  // addps         0x17628(%rip),%xmm0        # 3b200 <_sk_srcover_bgra_8888_sse2_lowp+0x1298>
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,5,46,118,1,0                  // addps         0x1762e(%rip),%xmm0        # 3b210 <_sk_srcover_bgra_8888_sse2_lowp+0x12a8>
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,5,52,118,1,0                  // addps         0x17634(%rip),%xmm0        # 3b220 <_sk_srcover_bgra_8888_sse2_lowp+0x12b8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_start_pipeline_sse2
.globl _sk_start_pipeline_sse2
FUNCTION(_sk_start_pipeline_sse2)
_sk_start_pipeline_sse2:
  .byte  85                                  // push          %rbp
  .byte  72,137,229                          // mov           %rsp,%rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  73,137,215                          // mov           %rdx,%r15
  .byte  72,137,243                          // mov           %rsi,%rbx
  .byte  72,137,125,208                      // mov           %rdi,-0x30(%rbp)
  .byte  76,137,198                          // mov           %r8,%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  73,137,197                          // mov           %rax,%r13
  .byte  73,137,246                          // mov           %rsi,%r14
  .byte  72,137,77,192                       // mov           %rcx,-0x40(%rbp)
  .byte  72,57,203                           // cmp           %rcx,%rbx
  .byte  15,131,131,0,0,0                    // jae           23caf <_sk_start_pipeline_sse2+0xb6>
  .byte  72,139,69,208                       // mov           -0x30(%rbp),%rax
  .byte  72,141,64,4                         // lea           0x4(%rax),%rax
  .byte  72,137,69,200                       // mov           %rax,-0x38(%rbp)
  .byte  76,57,125,200                       // cmp           %r15,-0x38(%rbp)
  .byte  72,139,85,208                       // mov           -0x30(%rbp),%rdx
  .byte  119,59                              // ja            23c7d <_sk_start_pipeline_sse2+0x84>
  .byte  76,139,101,208                      // mov           -0x30(%rbp),%r12
  .byte  49,255                              // xor           %edi,%edi
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  76,137,226                          // mov           %r12,%rdx
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  73,141,84,36,4                      // lea           0x4(%r12),%rdx
  .byte  73,131,196,8                        // add           $0x8,%r12
  .byte  77,57,252                           // cmp           %r15,%r12
  .byte  73,137,212                          // mov           %rdx,%r12
  .byte  118,201                             // jbe           23c46 <_sk_start_pipeline_sse2+0x4d>
  .byte  76,137,255                          // mov           %r15,%rdi
  .byte  72,41,215                           // sub           %rdx,%rdi
  .byte  116,33                              // je            23ca6 <_sk_start_pipeline_sse2+0xad>
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  72,255,195                          // inc           %rbx
  .byte  72,59,93,192                        // cmp           -0x40(%rbp),%rbx
  .byte  117,137                             // jne           23c38 <_sk_start_pipeline_sse2+0x3f>
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  195                                 // retq

HIDDEN _sk_just_return_sse2
.globl _sk_just_return_sse2
FUNCTION(_sk_just_return_sse2)
_sk_just_return_sse2:
  .byte  195                                 // retq

HIDDEN _sk_seed_shader_sse2
.globl _sk_seed_shader_sse2
FUNCTION(_sk_seed_shader_sse2)
_sk_seed_shader_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,110,194                      // movd          %edx,%xmm0
  .byte  102,15,112,192,0                    // pshufd        $0x0,%xmm0,%xmm0
  .byte  15,91,200                           // cvtdq2ps      %xmm0,%xmm1
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  102,15,110,201                      // movd          %ecx,%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,88,13,90,110,1,0                 // addps         0x16e5a(%rip),%xmm1        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,21,97,110,1,0                 // movaps        0x16e61(%rip),%xmm2        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dither_sse2
.globl _sk_dither_sse2
FUNCTION(_sk_dither_sse2)
_sk_dither_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,68,15,110,194                   // movd          %edx,%xmm8
  .byte  102,69,15,112,192,0                 // pshufd        $0x0,%xmm8,%xmm8
  .byte  102,68,15,254,5,10,110,1,0          // paddd         0x16e0a(%rip),%xmm8        # 3ab20 <_sk_srcover_bgra_8888_sse2_lowp+0xbb8>
  .byte  102,68,15,110,201                   // movd          %ecx,%xmm9
  .byte  102,69,15,112,201,0                 // pshufd        $0x0,%xmm9,%xmm9
  .byte  102,69,15,239,200                   // pxor          %xmm8,%xmm9
  .byte  102,68,15,111,21,49,110,1,0         // movdqa        0x16e31(%rip),%xmm10        # 3ab60 <_sk_srcover_bgra_8888_sse2_lowp+0xbf8>
  .byte  102,69,15,111,217                   // movdqa        %xmm9,%xmm11
  .byte  102,69,15,219,218                   // pand          %xmm10,%xmm11
  .byte  102,65,15,114,243,5                 // pslld         $0x5,%xmm11
  .byte  102,69,15,219,208                   // pand          %xmm8,%xmm10
  .byte  102,65,15,114,242,4                 // pslld         $0x4,%xmm10
  .byte  102,68,15,111,37,29,110,1,0         // movdqa        0x16e1d(%rip),%xmm12        # 3ab70 <_sk_srcover_bgra_8888_sse2_lowp+0xc08>
  .byte  102,68,15,111,45,36,110,1,0         // movdqa        0x16e24(%rip),%xmm13        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,69,15,111,241                   // movdqa        %xmm9,%xmm14
  .byte  102,69,15,219,245                   // pand          %xmm13,%xmm14
  .byte  102,65,15,114,246,2                 // pslld         $0x2,%xmm14
  .byte  102,69,15,235,243                   // por           %xmm11,%xmm14
  .byte  102,69,15,219,232                   // pand          %xmm8,%xmm13
  .byte  102,69,15,254,237                   // paddd         %xmm13,%xmm13
  .byte  102,69,15,235,234                   // por           %xmm10,%xmm13
  .byte  102,69,15,219,204                   // pand          %xmm12,%xmm9
  .byte  102,65,15,114,209,1                 // psrld         $0x1,%xmm9
  .byte  102,69,15,219,196                   // pand          %xmm12,%xmm8
  .byte  102,65,15,114,208,2                 // psrld         $0x2,%xmm8
  .byte  102,69,15,235,197                   // por           %xmm13,%xmm8
  .byte  102,69,15,235,198                   // por           %xmm14,%xmm8
  .byte  102,69,15,235,193                   // por           %xmm9,%xmm8
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  68,15,89,5,223,109,1,0              // mulps         0x16ddf(%rip),%xmm8        # 3ab90 <_sk_srcover_bgra_8888_sse2_lowp+0xc28>
  .byte  68,15,88,5,231,109,1,0              // addps         0x16de7(%rip),%xmm8        # 3aba0 <_sk_srcover_bgra_8888_sse2_lowp+0xc38>
  .byte  243,68,15,16,16                     // movss         (%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  69,15,89,208                        // mulps         %xmm8,%xmm10
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  68,15,88,210                        // addps         %xmm2,%xmm10
  .byte  15,93,195                           // minps         %xmm3,%xmm0
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  68,15,95,192                        // maxps         %xmm0,%xmm8
  .byte  15,93,203                           // minps         %xmm3,%xmm1
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  68,15,95,201                        // maxps         %xmm1,%xmm9
  .byte  68,15,93,211                        // minps         %xmm3,%xmm10
  .byte  65,15,95,210                        // maxps         %xmm10,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_uniform_color_sse2
.globl _sk_uniform_color_sse2
FUNCTION(_sk_uniform_color_sse2)
_sk_uniform_color_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,80,8                      // movss         0x8(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,88,12                     // movss         0xc(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_black_color_sse2
.globl _sk_black_color_sse2
FUNCTION(_sk_black_color_sse2)
_sk_black_color_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,29,109,1,0                 // movaps        0x16d1d(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_white_color_sse2
.globl _sk_white_color_sse2
FUNCTION(_sk_white_color_sse2)
_sk_white_color_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,5,9,109,1,0                   // movaps        0x16d09(%rip),%xmm0        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_rgba_sse2
.globl _sk_load_rgba_sse2
FUNCTION(_sk_load_rgba_sse2)
_sk_load_rgba_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  15,16,72,16                         // movups        0x10(%rax),%xmm1
  .byte  15,16,80,32                         // movups        0x20(%rax),%xmm2
  .byte  15,16,88,48                         // movups        0x30(%rax),%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_rgba_sse2
.globl _sk_store_rgba_sse2
FUNCTION(_sk_store_rgba_sse2)
_sk_store_rgba_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,17,0                             // movups        %xmm0,(%rax)
  .byte  15,17,72,16                         // movups        %xmm1,0x10(%rax)
  .byte  15,17,80,32                         // movups        %xmm2,0x20(%rax)
  .byte  15,17,88,48                         // movups        %xmm3,0x30(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clear_sse2
.globl _sk_clear_sse2
FUNCTION(_sk_clear_sse2)
_sk_clear_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcatop_sse2
.globl _sk_srcatop_sse2
FUNCTION(_sk_srcatop_sse2)
_sk_srcatop_sse2:
  .byte  15,89,199                           // mulps         %xmm7,%xmm0
  .byte  68,15,40,5,185,108,1,0              // movaps        0x16cb9(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,204                        // mulps         %xmm4,%xmm9
  .byte  65,15,88,193                        // addps         %xmm9,%xmm0
  .byte  15,89,207                           // mulps         %xmm7,%xmm1
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  65,15,88,201                        // addps         %xmm9,%xmm1
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  65,15,88,209                        // addps         %xmm9,%xmm2
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  65,15,88,216                        // addps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstatop_sse2
.globl _sk_dstatop_sse2
FUNCTION(_sk_dstatop_sse2)
_sk_dstatop_sse2:
  .byte  68,15,40,195                        // movaps        %xmm3,%xmm8
  .byte  68,15,89,196                        // mulps         %xmm4,%xmm8
  .byte  68,15,40,13,108,108,1,0             // movaps        0x16c6c(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,207                        // subps         %xmm7,%xmm9
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  68,15,40,195                        // movaps        %xmm3,%xmm8
  .byte  68,15,89,197                        // mulps         %xmm5,%xmm8
  .byte  65,15,89,201                        // mulps         %xmm9,%xmm1
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  68,15,40,195                        // movaps        %xmm3,%xmm8
  .byte  68,15,89,198                        // mulps         %xmm6,%xmm8
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  65,15,88,208                        // addps         %xmm8,%xmm2
  .byte  68,15,89,203                        // mulps         %xmm3,%xmm9
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  65,15,88,217                        // addps         %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcin_sse2
.globl _sk_srcin_sse2
FUNCTION(_sk_srcin_sse2)
_sk_srcin_sse2:
  .byte  15,89,199                           // mulps         %xmm7,%xmm0
  .byte  15,89,207                           // mulps         %xmm7,%xmm1
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstin_sse2
.globl _sk_dstin_sse2
FUNCTION(_sk_dstin_sse2)
_sk_dstin_sse2:
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcout_sse2
.globl _sk_srcout_sse2
FUNCTION(_sk_srcout_sse2)
_sk_srcout_sse2:
  .byte  68,15,40,5,0,108,1,0                // movaps        0x16c00(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,199                        // subps         %xmm7,%xmm8
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstout_sse2
.globl _sk_dstout_sse2
FUNCTION(_sk_dstout_sse2)
_sk_dstout_sse2:
  .byte  68,15,40,5,224,107,1,0              // movaps        0x16be0(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,216                        // movaps        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_sse2
.globl _sk_srcover_sse2
FUNCTION(_sk_srcover_sse2)
_sk_srcover_sse2:
  .byte  68,15,40,5,179,107,1,0              // movaps        0x16bb3(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,204                        // mulps         %xmm4,%xmm9
  .byte  65,15,88,193                        // addps         %xmm9,%xmm0
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  65,15,88,201                        // addps         %xmm9,%xmm1
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  65,15,88,209                        // addps         %xmm9,%xmm2
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  65,15,88,216                        // addps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstover_sse2
.globl _sk_dstover_sse2
FUNCTION(_sk_dstover_sse2)
_sk_dstover_sse2:
  .byte  68,15,40,5,119,107,1,0              // movaps        0x16b77(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,199                        // subps         %xmm7,%xmm8
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_modulate_sse2
.globl _sk_modulate_sse2
FUNCTION(_sk_modulate_sse2)
_sk_modulate_sse2:
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_multiply_sse2
.globl _sk_multiply_sse2
FUNCTION(_sk_multiply_sse2)
_sk_multiply_sse2:
  .byte  68,15,40,5,59,107,1,0               // movaps        0x16b3b(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,92,207                        // subps         %xmm7,%xmm9
  .byte  69,15,40,209                        // movaps        %xmm9,%xmm10
  .byte  68,15,89,208                        // mulps         %xmm0,%xmm10
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  68,15,89,220                        // mulps         %xmm4,%xmm11
  .byte  69,15,88,218                        // addps         %xmm10,%xmm11
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  65,15,88,195                        // addps         %xmm11,%xmm0
  .byte  69,15,40,209                        // movaps        %xmm9,%xmm10
  .byte  68,15,89,209                        // mulps         %xmm1,%xmm10
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  68,15,89,221                        // mulps         %xmm5,%xmm11
  .byte  69,15,88,218                        // addps         %xmm10,%xmm11
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  69,15,40,209                        // movaps        %xmm9,%xmm10
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  68,15,89,222                        // mulps         %xmm6,%xmm11
  .byte  69,15,88,218                        // addps         %xmm10,%xmm11
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  65,15,88,211                        // addps         %xmm11,%xmm2
  .byte  68,15,89,203                        // mulps         %xmm3,%xmm9
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  69,15,88,193                        // addps         %xmm9,%xmm8
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  65,15,88,216                        // addps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_plus__sse2
.globl _sk_plus__sse2
FUNCTION(_sk_plus__sse2)
_sk_plus__sse2:
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  68,15,40,5,188,106,1,0              // movaps        0x16abc(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_screen_sse2
.globl _sk_screen_sse2
FUNCTION(_sk_screen_sse2)
_sk_screen_sse2:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  68,15,89,196                        // mulps         %xmm4,%xmm8
  .byte  65,15,92,192                        // subps         %xmm8,%xmm0
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  68,15,88,197                        // addps         %xmm5,%xmm8
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  68,15,92,193                        // subps         %xmm1,%xmm8
  .byte  68,15,40,202                        // movaps        %xmm2,%xmm9
  .byte  68,15,88,206                        // addps         %xmm6,%xmm9
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  68,15,92,202                        // subps         %xmm2,%xmm9
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  68,15,88,215                        // addps         %xmm7,%xmm10
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  68,15,92,211                        // subps         %xmm3,%xmm10
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  65,15,40,218                        // movaps        %xmm10,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xor__sse2
.globl _sk_xor__sse2
FUNCTION(_sk_xor__sse2)
_sk_xor__sse2:
  .byte  68,15,40,195                        // movaps        %xmm3,%xmm8
  .byte  15,40,29,72,106,1,0                 // movaps        0x16a48(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,92,207                        // subps         %xmm7,%xmm9
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  65,15,92,216                        // subps         %xmm8,%xmm3
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  68,15,89,212                        // mulps         %xmm4,%xmm10
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  65,15,89,201                        // mulps         %xmm9,%xmm1
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  68,15,89,213                        // mulps         %xmm5,%xmm10
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  68,15,89,214                        // mulps         %xmm6,%xmm10
  .byte  65,15,88,210                        // addps         %xmm10,%xmm2
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  65,15,88,217                        // addps         %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_darken_sse2
.globl _sk_darken_sse2
FUNCTION(_sk_darken_sse2)
_sk_darken_sse2:
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  68,15,89,207                        // mulps         %xmm7,%xmm9
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  68,15,95,201                        // maxps         %xmm1,%xmm9
  .byte  65,15,92,193                        // subps         %xmm9,%xmm0
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  69,15,95,193                        // maxps         %xmm9,%xmm8
  .byte  65,15,92,200                        // subps         %xmm8,%xmm1
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  68,15,88,198                        // addps         %xmm6,%xmm8
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  65,15,95,209                        // maxps         %xmm9,%xmm2
  .byte  68,15,92,194                        // subps         %xmm2,%xmm8
  .byte  15,40,21,163,105,1,0                // movaps        0x169a3(%rip),%xmm2        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lighten_sse2
.globl _sk_lighten_sse2
FUNCTION(_sk_lighten_sse2)
_sk_lighten_sse2:
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  68,15,89,207                        // mulps         %xmm7,%xmm9
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  68,15,93,201                        // minps         %xmm1,%xmm9
  .byte  65,15,92,193                        // subps         %xmm9,%xmm0
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  69,15,93,193                        // minps         %xmm9,%xmm8
  .byte  65,15,92,200                        // subps         %xmm8,%xmm1
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  68,15,88,198                        // addps         %xmm6,%xmm8
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  65,15,93,209                        // minps         %xmm9,%xmm2
  .byte  68,15,92,194                        // subps         %xmm2,%xmm8
  .byte  15,40,21,56,105,1,0                 // movaps        0x16938(%rip),%xmm2        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_difference_sse2
.globl _sk_difference_sse2
FUNCTION(_sk_difference_sse2)
_sk_difference_sse2:
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  68,15,89,207                        // mulps         %xmm7,%xmm9
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  68,15,93,201                        // minps         %xmm1,%xmm9
  .byte  69,15,88,201                        // addps         %xmm9,%xmm9
  .byte  65,15,92,193                        // subps         %xmm9,%xmm0
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  69,15,93,193                        // minps         %xmm9,%xmm8
  .byte  69,15,88,192                        // addps         %xmm8,%xmm8
  .byte  65,15,92,200                        // subps         %xmm8,%xmm1
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  68,15,88,198                        // addps         %xmm6,%xmm8
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  65,15,93,209                        // minps         %xmm9,%xmm2
  .byte  15,88,210                           // addps         %xmm2,%xmm2
  .byte  68,15,92,194                        // subps         %xmm2,%xmm8
  .byte  15,40,21,194,104,1,0                // movaps        0x168c2(%rip),%xmm2        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_exclusion_sse2
.globl _sk_exclusion_sse2
FUNCTION(_sk_exclusion_sse2)
_sk_exclusion_sse2:
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  68,15,89,197                        // mulps         %xmm5,%xmm8
  .byte  69,15,88,192                        // addps         %xmm8,%xmm8
  .byte  65,15,92,200                        // subps         %xmm8,%xmm1
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  68,15,88,198                        // addps         %xmm6,%xmm8
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,88,210                           // addps         %xmm2,%xmm2
  .byte  68,15,92,194                        // subps         %xmm2,%xmm8
  .byte  15,40,21,114,104,1,0                // movaps        0x16872(%rip),%xmm2        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_colorburn_sse2
.globl _sk_colorburn_sse2
FUNCTION(_sk_colorburn_sse2)
_sk_colorburn_sse2:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  68,15,40,13,85,104,1,0              // movaps        0x16855(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,209                        // movaps        %xmm9,%xmm10
  .byte  68,15,92,215                        // subps         %xmm7,%xmm10
  .byte  69,15,40,218                        // movaps        %xmm10,%xmm11
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  69,15,83,224                        // rcpps         %xmm8,%xmm12
  .byte  68,15,89,224                        // mulps         %xmm0,%xmm12
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  65,15,93,196                        // minps         %xmm12,%xmm0
  .byte  68,15,40,231                        // movaps        %xmm7,%xmm12
  .byte  68,15,92,224                        // subps         %xmm0,%xmm12
  .byte  68,15,89,227                        // mulps         %xmm3,%xmm12
  .byte  69,15,88,227                        // addps         %xmm11,%xmm12
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  68,15,92,203                        // subps         %xmm3,%xmm9
  .byte  69,15,40,233                        // movaps        %xmm9,%xmm13
  .byte  68,15,89,236                        // mulps         %xmm4,%xmm13
  .byte  69,15,194,195,0                     // cmpeqps       %xmm11,%xmm8
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  69,15,84,232                        // andps         %xmm8,%xmm13
  .byte  69,15,85,196                        // andnps        %xmm12,%xmm8
  .byte  68,15,40,228                        // movaps        %xmm4,%xmm12
  .byte  68,15,194,231,0                     // cmpeqps       %xmm7,%xmm12
  .byte  69,15,86,197                        // orps          %xmm13,%xmm8
  .byte  65,15,84,196                        // andps         %xmm12,%xmm0
  .byte  69,15,85,224                        // andnps        %xmm8,%xmm12
  .byte  65,15,86,196                        // orps          %xmm12,%xmm0
  .byte  69,15,40,194                        // movaps        %xmm10,%xmm8
  .byte  68,15,89,193                        // mulps         %xmm1,%xmm8
  .byte  68,15,40,231                        // movaps        %xmm7,%xmm12
  .byte  68,15,92,229                        // subps         %xmm5,%xmm12
  .byte  68,15,89,227                        // mulps         %xmm3,%xmm12
  .byte  68,15,83,233                        // rcpps         %xmm1,%xmm13
  .byte  69,15,89,236                        // mulps         %xmm12,%xmm13
  .byte  68,15,40,231                        // movaps        %xmm7,%xmm12
  .byte  69,15,93,229                        // minps         %xmm13,%xmm12
  .byte  68,15,40,239                        // movaps        %xmm7,%xmm13
  .byte  69,15,92,236                        // subps         %xmm12,%xmm13
  .byte  69,15,40,225                        // movaps        %xmm9,%xmm12
  .byte  68,15,89,229                        // mulps         %xmm5,%xmm12
  .byte  65,15,194,203,0                     // cmpeqps       %xmm11,%xmm1
  .byte  68,15,89,235                        // mulps         %xmm3,%xmm13
  .byte  69,15,88,232                        // addps         %xmm8,%xmm13
  .byte  69,15,88,236                        // addps         %xmm12,%xmm13
  .byte  68,15,84,225                        // andps         %xmm1,%xmm12
  .byte  65,15,85,205                        // andnps        %xmm13,%xmm1
  .byte  68,15,88,197                        // addps         %xmm5,%xmm8
  .byte  65,15,86,204                        // orps          %xmm12,%xmm1
  .byte  68,15,40,229                        // movaps        %xmm5,%xmm12
  .byte  68,15,194,231,0                     // cmpeqps       %xmm7,%xmm12
  .byte  69,15,84,196                        // andps         %xmm12,%xmm8
  .byte  68,15,85,225                        // andnps        %xmm1,%xmm12
  .byte  69,15,86,196                        // orps          %xmm12,%xmm8
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  68,15,194,218,0                     // cmpeqps       %xmm2,%xmm11
  .byte  15,40,207                           // movaps        %xmm7,%xmm1
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,83,210                           // rcpps         %xmm2,%xmm2
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  15,40,207                           // movaps        %xmm7,%xmm1
  .byte  15,93,202                           // minps         %xmm2,%xmm1
  .byte  15,40,215                           // movaps        %xmm7,%xmm2
  .byte  15,92,209                           // subps         %xmm1,%xmm2
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  65,15,88,210                        // addps         %xmm10,%xmm2
  .byte  15,88,209                           // addps         %xmm1,%xmm2
  .byte  65,15,84,203                        // andps         %xmm11,%xmm1
  .byte  68,15,85,218                        // andnps        %xmm2,%xmm11
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  68,15,86,217                        // orps          %xmm1,%xmm11
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,194,207,0                        // cmpeqps       %xmm7,%xmm1
  .byte  15,84,209                           // andps         %xmm1,%xmm2
  .byte  65,15,85,203                        // andnps        %xmm11,%xmm1
  .byte  15,86,209                           // orps          %xmm1,%xmm2
  .byte  68,15,89,207                        // mulps         %xmm7,%xmm9
  .byte  65,15,88,217                        // addps         %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_colordodge_sse2
.globl _sk_colordodge_sse2
FUNCTION(_sk_colordodge_sse2)
_sk_colordodge_sse2:
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  68,15,40,21,253,102,1,0             // movaps        0x166fd(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,218                        // movaps        %xmm10,%xmm11
  .byte  68,15,92,223                        // subps         %xmm7,%xmm11
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  68,15,40,227                        // movaps        %xmm3,%xmm12
  .byte  68,15,89,228                        // mulps         %xmm4,%xmm12
  .byte  68,15,40,195                        // movaps        %xmm3,%xmm8
  .byte  69,15,92,193                        // subps         %xmm9,%xmm8
  .byte  69,15,83,192                        // rcpps         %xmm8,%xmm8
  .byte  69,15,89,196                        // mulps         %xmm12,%xmm8
  .byte  68,15,40,231                        // movaps        %xmm7,%xmm12
  .byte  68,15,40,239                        // movaps        %xmm7,%xmm13
  .byte  69,15,93,232                        // minps         %xmm8,%xmm13
  .byte  69,15,40,241                        // movaps        %xmm9,%xmm14
  .byte  68,15,194,243,0                     // cmpeqps       %xmm3,%xmm14
  .byte  68,15,89,235                        // mulps         %xmm3,%xmm13
  .byte  68,15,88,232                        // addps         %xmm0,%xmm13
  .byte  69,15,84,206                        // andps         %xmm14,%xmm9
  .byte  69,15,85,245                        // andnps        %xmm13,%xmm14
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  68,15,92,211                        // subps         %xmm3,%xmm10
  .byte  69,15,86,241                        // orps          %xmm9,%xmm14
  .byte  69,15,40,202                        // movaps        %xmm10,%xmm9
  .byte  68,15,89,204                        // mulps         %xmm4,%xmm9
  .byte  69,15,88,241                        // addps         %xmm9,%xmm14
  .byte  68,15,40,204                        // movaps        %xmm4,%xmm9
  .byte  69,15,194,200,0                     // cmpeqps       %xmm8,%xmm9
  .byte  65,15,84,193                        // andps         %xmm9,%xmm0
  .byte  69,15,85,206                        // andnps        %xmm14,%xmm9
  .byte  65,15,86,193                        // orps          %xmm9,%xmm0
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  68,15,40,235                        // movaps        %xmm3,%xmm13
  .byte  68,15,92,233                        // subps         %xmm1,%xmm13
  .byte  69,15,83,237                        // rcpps         %xmm13,%xmm13
  .byte  69,15,89,233                        // mulps         %xmm9,%xmm13
  .byte  69,15,40,203                        // movaps        %xmm11,%xmm9
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  69,15,93,229                        // minps         %xmm13,%xmm12
  .byte  68,15,40,233                        // movaps        %xmm1,%xmm13
  .byte  68,15,194,235,0                     // cmpeqps       %xmm3,%xmm13
  .byte  68,15,89,227                        // mulps         %xmm3,%xmm12
  .byte  69,15,88,225                        // addps         %xmm9,%xmm12
  .byte  65,15,84,205                        // andps         %xmm13,%xmm1
  .byte  69,15,85,236                        // andnps        %xmm12,%xmm13
  .byte  68,15,86,233                        // orps          %xmm1,%xmm13
  .byte  65,15,40,202                        // movaps        %xmm10,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  68,15,88,233                        // addps         %xmm1,%xmm13
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  65,15,194,200,0                     // cmpeqps       %xmm8,%xmm1
  .byte  68,15,84,201                        // andps         %xmm1,%xmm9
  .byte  65,15,85,205                        // andnps        %xmm13,%xmm1
  .byte  68,15,86,201                        // orps          %xmm1,%xmm9
  .byte  68,15,40,227                        // movaps        %xmm3,%xmm12
  .byte  68,15,89,230                        // mulps         %xmm6,%xmm12
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,92,202                           // subps         %xmm2,%xmm1
  .byte  68,15,83,233                        // rcpps         %xmm1,%xmm13
  .byte  69,15,89,236                        // mulps         %xmm12,%xmm13
  .byte  68,15,40,231                        // movaps        %xmm7,%xmm12
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  69,15,93,229                        // minps         %xmm13,%xmm12
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,194,203,0                        // cmpeqps       %xmm3,%xmm1
  .byte  68,15,89,227                        // mulps         %xmm3,%xmm12
  .byte  69,15,88,227                        // addps         %xmm11,%xmm12
  .byte  15,84,209                           // andps         %xmm1,%xmm2
  .byte  65,15,85,204                        // andnps        %xmm12,%xmm1
  .byte  15,86,202                           // orps          %xmm2,%xmm1
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  68,15,194,198,0                     // cmpeqps       %xmm6,%xmm8
  .byte  69,15,84,216                        // andps         %xmm8,%xmm11
  .byte  68,15,85,193                        // andnps        %xmm1,%xmm8
  .byte  69,15,86,195                        // orps          %xmm11,%xmm8
  .byte  68,15,89,215                        // mulps         %xmm7,%xmm10
  .byte  65,15,88,218                        // addps         %xmm10,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hardlight_sse2
.globl _sk_hardlight_sse2
FUNCTION(_sk_hardlight_sse2)
_sk_hardlight_sse2:
  .byte  15,41,116,36,232                    // movaps        %xmm6,-0x18(%rsp)
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  68,15,40,29,166,101,1,0             // movaps        0x165a6(%rip),%xmm11        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,211                        // movaps        %xmm11,%xmm10
  .byte  68,15,92,215                        // subps         %xmm7,%xmm10
  .byte  69,15,40,194                        // movaps        %xmm10,%xmm8
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  68,15,92,219                        // subps         %xmm3,%xmm11
  .byte  69,15,40,203                        // movaps        %xmm11,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  69,15,88,200                        // addps         %xmm8,%xmm9
  .byte  68,15,40,195                        // movaps        %xmm3,%xmm8
  .byte  68,15,92,192                        // subps         %xmm0,%xmm8
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  68,15,40,239                        // movaps        %xmm7,%xmm13
  .byte  68,15,40,247                        // movaps        %xmm7,%xmm14
  .byte  68,15,40,255                        // movaps        %xmm7,%xmm15
  .byte  68,15,92,253                        // subps         %xmm5,%xmm15
  .byte  69,15,89,248                        // mulps         %xmm8,%xmm15
  .byte  69,15,88,255                        // addps         %xmm15,%xmm15
  .byte  68,15,40,228                        // movaps        %xmm4,%xmm12
  .byte  69,15,92,231                        // subps         %xmm15,%xmm12
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  69,15,88,192                        // addps         %xmm8,%xmm8
  .byte  68,15,194,195,2                     // cmpleps       %xmm3,%xmm8
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  65,15,84,192                        // andps         %xmm8,%xmm0
  .byte  69,15,85,196                        // andnps        %xmm12,%xmm8
  .byte  68,15,86,192                        // orps          %xmm0,%xmm8
  .byte  69,15,40,251                        // movaps        %xmm11,%xmm15
  .byte  69,15,40,227                        // movaps        %xmm11,%xmm12
  .byte  68,15,89,223                        // mulps         %xmm7,%xmm11
  .byte  69,15,88,193                        // addps         %xmm9,%xmm8
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  68,15,89,254                        // mulps         %xmm6,%xmm15
  .byte  68,15,88,248                        // addps         %xmm0,%xmm15
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  68,15,92,238                        // subps         %xmm6,%xmm13
  .byte  68,15,89,232                        // mulps         %xmm0,%xmm13
  .byte  69,15,88,237                        // addps         %xmm13,%xmm13
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  65,15,92,197                        // subps         %xmm13,%xmm0
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  69,15,88,201                        // addps         %xmm9,%xmm9
  .byte  68,15,194,203,2                     // cmpleps       %xmm3,%xmm9
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  65,15,84,201                        // andps         %xmm9,%xmm1
  .byte  68,15,85,200                        // andnps        %xmm0,%xmm9
  .byte  68,15,86,201                        // orps          %xmm1,%xmm9
  .byte  69,15,88,207                        // addps         %xmm15,%xmm9
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  68,15,40,108,36,232                 // movaps        -0x18(%rsp),%xmm13
  .byte  69,15,89,229                        // mulps         %xmm13,%xmm12
  .byte  69,15,88,226                        // addps         %xmm10,%xmm12
  .byte  68,15,40,210                        // movaps        %xmm2,%xmm10
  .byte  69,15,88,210                        // addps         %xmm10,%xmm10
  .byte  68,15,194,211,2                     // cmpleps       %xmm3,%xmm10
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,92,194                           // subps         %xmm2,%xmm0
  .byte  65,15,89,213                        // mulps         %xmm13,%xmm2
  .byte  15,88,210                           // addps         %xmm2,%xmm2
  .byte  69,15,92,245                        // subps         %xmm13,%xmm14
  .byte  68,15,89,240                        // mulps         %xmm0,%xmm14
  .byte  69,15,88,246                        // addps         %xmm14,%xmm14
  .byte  65,15,92,230                        // subps         %xmm14,%xmm4
  .byte  65,15,84,210                        // andps         %xmm10,%xmm2
  .byte  68,15,85,212                        // andnps        %xmm4,%xmm10
  .byte  68,15,86,210                        // orps          %xmm2,%xmm10
  .byte  69,15,88,212                        // addps         %xmm12,%xmm10
  .byte  65,15,88,219                        // addps         %xmm11,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,40,238                           // movaps        %xmm6,%xmm5
  .byte  65,15,40,245                        // movaps        %xmm13,%xmm6
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_overlay_sse2
.globl _sk_overlay_sse2
FUNCTION(_sk_overlay_sse2)
_sk_overlay_sse2:
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  68,15,40,232                        // movaps        %xmm0,%xmm13
  .byte  68,15,40,13,100,100,1,0             // movaps        0x16464(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,209                        // movaps        %xmm9,%xmm10
  .byte  68,15,92,215                        // subps         %xmm7,%xmm10
  .byte  69,15,40,218                        // movaps        %xmm10,%xmm11
  .byte  69,15,89,221                        // mulps         %xmm13,%xmm11
  .byte  68,15,92,203                        // subps         %xmm3,%xmm9
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  65,15,88,195                        // addps         %xmm11,%xmm0
  .byte  68,15,40,227                        // movaps        %xmm3,%xmm12
  .byte  69,15,92,229                        // subps         %xmm13,%xmm12
  .byte  68,15,89,236                        // mulps         %xmm4,%xmm13
  .byte  68,15,40,247                        // movaps        %xmm7,%xmm14
  .byte  68,15,92,244                        // subps         %xmm4,%xmm14
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,194,207,2                        // cmpleps       %xmm7,%xmm1
  .byte  69,15,88,237                        // addps         %xmm13,%xmm13
  .byte  68,15,40,219                        // movaps        %xmm3,%xmm11
  .byte  68,15,89,223                        // mulps         %xmm7,%xmm11
  .byte  69,15,89,244                        // mulps         %xmm12,%xmm14
  .byte  69,15,88,246                        // addps         %xmm14,%xmm14
  .byte  69,15,40,227                        // movaps        %xmm11,%xmm12
  .byte  69,15,92,230                        // subps         %xmm14,%xmm12
  .byte  68,15,84,233                        // andps         %xmm1,%xmm13
  .byte  65,15,85,204                        // andnps        %xmm12,%xmm1
  .byte  65,15,86,205                        // orps          %xmm13,%xmm1
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  69,15,40,226                        // movaps        %xmm10,%xmm12
  .byte  69,15,89,224                        // mulps         %xmm8,%xmm12
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  65,15,88,204                        // addps         %xmm12,%xmm1
  .byte  68,15,40,227                        // movaps        %xmm3,%xmm12
  .byte  69,15,92,224                        // subps         %xmm8,%xmm12
  .byte  68,15,89,197                        // mulps         %xmm5,%xmm8
  .byte  68,15,40,239                        // movaps        %xmm7,%xmm13
  .byte  68,15,92,237                        // subps         %xmm5,%xmm13
  .byte  68,15,40,245                        // movaps        %xmm5,%xmm14
  .byte  69,15,88,246                        // addps         %xmm14,%xmm14
  .byte  68,15,194,247,2                     // cmpleps       %xmm7,%xmm14
  .byte  69,15,88,192                        // addps         %xmm8,%xmm8
  .byte  69,15,89,236                        // mulps         %xmm12,%xmm13
  .byte  69,15,88,237                        // addps         %xmm13,%xmm13
  .byte  69,15,40,227                        // movaps        %xmm11,%xmm12
  .byte  69,15,92,229                        // subps         %xmm13,%xmm12
  .byte  69,15,84,198                        // andps         %xmm14,%xmm8
  .byte  69,15,85,244                        // andnps        %xmm12,%xmm14
  .byte  69,15,86,240                        // orps          %xmm8,%xmm14
  .byte  65,15,88,206                        // addps         %xmm14,%xmm1
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  68,15,89,198                        // mulps         %xmm6,%xmm8
  .byte  69,15,88,194                        // addps         %xmm10,%xmm8
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  68,15,92,210                        // subps         %xmm2,%xmm10
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  68,15,40,231                        // movaps        %xmm7,%xmm12
  .byte  68,15,92,230                        // subps         %xmm6,%xmm12
  .byte  68,15,40,238                        // movaps        %xmm6,%xmm13
  .byte  69,15,88,237                        // addps         %xmm13,%xmm13
  .byte  68,15,194,239,2                     // cmpleps       %xmm7,%xmm13
  .byte  15,88,210                           // addps         %xmm2,%xmm2
  .byte  69,15,89,226                        // mulps         %xmm10,%xmm12
  .byte  69,15,88,228                        // addps         %xmm12,%xmm12
  .byte  69,15,92,220                        // subps         %xmm12,%xmm11
  .byte  65,15,84,213                        // andps         %xmm13,%xmm2
  .byte  69,15,85,235                        // andnps        %xmm11,%xmm13
  .byte  68,15,86,234                        // orps          %xmm2,%xmm13
  .byte  69,15,88,197                        // addps         %xmm13,%xmm8
  .byte  68,15,89,207                        // mulps         %xmm7,%xmm9
  .byte  65,15,88,217                        // addps         %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_softlight_sse2
.globl _sk_softlight_sse2
FUNCTION(_sk_softlight_sse2)
_sk_softlight_sse2:
  .byte  15,41,116,36,216                    // movaps        %xmm6,-0x28(%rsp)
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,41,84,36,232                     // movaps        %xmm2,-0x18(%rsp)
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,194,231,1                     // cmpltps       %xmm7,%xmm12
  .byte  68,15,40,213                        // movaps        %xmm5,%xmm10
  .byte  68,15,94,215                        // divps         %xmm7,%xmm10
  .byte  69,15,84,212                        // andps         %xmm12,%xmm10
  .byte  68,15,40,13,17,99,1,0               // movaps        0x16311(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,249                        // movaps        %xmm9,%xmm15
  .byte  69,15,92,250                        // subps         %xmm10,%xmm15
  .byte  69,15,40,218                        // movaps        %xmm10,%xmm11
  .byte  69,15,40,234                        // movaps        %xmm10,%xmm13
  .byte  65,15,82,194                        // rsqrtps       %xmm10,%xmm0
  .byte  15,83,200                           // rcpps         %xmm0,%xmm1
  .byte  65,15,92,202                        // subps         %xmm10,%xmm1
  .byte  69,15,88,210                        // addps         %xmm10,%xmm10
  .byte  69,15,88,210                        // addps         %xmm10,%xmm10
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  68,15,40,53,59,99,1,0               // movaps        0x1633b(%rip),%xmm14        # 3abb0 <_sk_srcover_bgra_8888_sse2_lowp+0xc48>
  .byte  69,15,88,222                        // addps         %xmm14,%xmm11
  .byte  68,15,89,216                        // mulps         %xmm0,%xmm11
  .byte  68,15,40,21,59,99,1,0               // movaps        0x1633b(%rip),%xmm10        # 3abc0 <_sk_srcover_bgra_8888_sse2_lowp+0xc58>
  .byte  69,15,89,234                        // mulps         %xmm10,%xmm13
  .byte  69,15,88,235                        // addps         %xmm11,%xmm13
  .byte  15,88,228                           // addps         %xmm4,%xmm4
  .byte  15,88,228                           // addps         %xmm4,%xmm4
  .byte  15,194,231,2                        // cmpleps       %xmm7,%xmm4
  .byte  68,15,84,236                        // andps         %xmm4,%xmm13
  .byte  15,85,225                           // andnps        %xmm1,%xmm4
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  65,15,86,229                        // orps          %xmm13,%xmm4
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  68,15,89,249                        // mulps         %xmm1,%xmm15
  .byte  15,89,207                           // mulps         %xmm7,%xmm1
  .byte  15,89,225                           // mulps         %xmm1,%xmm4
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  69,15,40,217                        // movaps        %xmm9,%xmm11
  .byte  68,15,92,219                        // subps         %xmm3,%xmm11
  .byte  65,15,40,203                        // movaps        %xmm11,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  69,15,40,233                        // movaps        %xmm9,%xmm13
  .byte  68,15,92,239                        // subps         %xmm7,%xmm13
  .byte  69,15,89,197                        // mulps         %xmm13,%xmm8
  .byte  68,15,88,193                        // addps         %xmm1,%xmm8
  .byte  68,15,88,251                        // addps         %xmm3,%xmm15
  .byte  68,15,89,253                        // mulps         %xmm5,%xmm15
  .byte  15,194,195,2                        // cmpleps       %xmm3,%xmm0
  .byte  68,15,84,248                        // andps         %xmm0,%xmm15
  .byte  15,85,196                           // andnps        %xmm4,%xmm0
  .byte  65,15,86,199                        // orps          %xmm15,%xmm0
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  68,15,40,198                        // movaps        %xmm6,%xmm8
  .byte  68,15,94,199                        // divps         %xmm7,%xmm8
  .byte  69,15,84,196                        // andps         %xmm12,%xmm8
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,89,228                           // mulps         %xmm4,%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  65,15,88,206                        // addps         %xmm14,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  69,15,40,249                        // movaps        %xmm9,%xmm15
  .byte  69,15,92,248                        // subps         %xmm8,%xmm15
  .byte  65,15,82,224                        // rsqrtps       %xmm8,%xmm4
  .byte  15,83,228                           // rcpps         %xmm4,%xmm4
  .byte  65,15,92,224                        // subps         %xmm8,%xmm4
  .byte  69,15,89,194                        // mulps         %xmm10,%xmm8
  .byte  68,15,88,193                        // addps         %xmm1,%xmm8
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,194,207,2                        // cmpleps       %xmm7,%xmm1
  .byte  68,15,84,193                        // andps         %xmm1,%xmm8
  .byte  15,85,204                           // andnps        %xmm4,%xmm1
  .byte  65,15,86,200                        // orps          %xmm8,%xmm1
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  69,15,88,192                        // addps         %xmm8,%xmm8
  .byte  65,15,40,224                        // movaps        %xmm8,%xmm4
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  68,15,89,252                        // mulps         %xmm4,%xmm15
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  65,15,40,227                        // movaps        %xmm11,%xmm4
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  65,15,89,213                        // mulps         %xmm13,%xmm2
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  68,15,88,251                        // addps         %xmm3,%xmm15
  .byte  68,15,89,254                        // mulps         %xmm6,%xmm15
  .byte  68,15,194,195,2                     // cmpleps       %xmm3,%xmm8
  .byte  69,15,84,248                        // andps         %xmm8,%xmm15
  .byte  68,15,85,193                        // andnps        %xmm1,%xmm8
  .byte  69,15,86,199                        // orps          %xmm15,%xmm8
  .byte  68,15,88,194                        // addps         %xmm2,%xmm8
  .byte  68,15,40,124,36,216                 // movaps        -0x28(%rsp),%xmm15
  .byte  65,15,40,207                        // movaps        %xmm15,%xmm1
  .byte  15,94,207                           // divps         %xmm7,%xmm1
  .byte  65,15,84,204                        // andps         %xmm12,%xmm1
  .byte  68,15,92,201                        // subps         %xmm1,%xmm9
  .byte  68,15,88,241                        // addps         %xmm1,%xmm14
  .byte  68,15,89,209                        // mulps         %xmm1,%xmm10
  .byte  15,82,209                           // rsqrtps       %xmm1,%xmm2
  .byte  15,83,210                           // rcpps         %xmm2,%xmm2
  .byte  15,92,209                           // subps         %xmm1,%xmm2
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,89,228                           // mulps         %xmm4,%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  68,15,89,244                        // mulps         %xmm4,%xmm14
  .byte  69,15,88,214                        // addps         %xmm14,%xmm10
  .byte  65,15,40,207                        // movaps        %xmm15,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,194,207,2                        // cmpleps       %xmm7,%xmm1
  .byte  68,15,84,209                        // andps         %xmm1,%xmm10
  .byte  15,85,202                           // andnps        %xmm2,%xmm1
  .byte  15,40,84,36,232                     // movaps        -0x18(%rsp),%xmm2
  .byte  68,15,89,234                        // mulps         %xmm2,%xmm13
  .byte  15,88,210                           // addps         %xmm2,%xmm2
  .byte  65,15,86,202                        // orps          %xmm10,%xmm1
  .byte  15,40,226                           // movaps        %xmm2,%xmm4
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  68,15,89,204                        // mulps         %xmm4,%xmm9
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  65,15,89,231                        // mulps         %xmm15,%xmm4
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  65,15,40,227                        // movaps        %xmm11,%xmm4
  .byte  65,15,89,231                        // mulps         %xmm15,%xmm4
  .byte  65,15,88,229                        // addps         %xmm13,%xmm4
  .byte  68,15,88,203                        // addps         %xmm3,%xmm9
  .byte  69,15,89,207                        // mulps         %xmm15,%xmm9
  .byte  69,15,40,215                        // movaps        %xmm15,%xmm10
  .byte  15,194,211,2                        // cmpleps       %xmm3,%xmm2
  .byte  68,15,84,202                        // andps         %xmm2,%xmm9
  .byte  15,85,209                           // andnps        %xmm1,%xmm2
  .byte  65,15,86,209                        // orps          %xmm9,%xmm2
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  68,15,89,223                        // mulps         %xmm7,%xmm11
  .byte  65,15,88,219                        // addps         %xmm11,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,40,238                           // movaps        %xmm6,%xmm5
  .byte  65,15,40,242                        // movaps        %xmm10,%xmm6
  .byte  65,15,40,200                        // movaps        %xmm8,%xmm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hue_sse2
.globl _sk_hue_sse2
FUNCTION(_sk_hue_sse2)
_sk_hue_sse2:
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  68,15,89,203                        // mulps         %xmm3,%xmm9
  .byte  68,15,40,209                        // movaps        %xmm1,%xmm10
  .byte  68,15,40,225                        // movaps        %xmm1,%xmm12
  .byte  68,15,89,211                        // mulps         %xmm3,%xmm10
  .byte  68,15,40,5,206,96,1,0               // movaps        0x160ce(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  15,40,207                           // movaps        %xmm7,%xmm1
  .byte  68,15,92,217                        // subps         %xmm1,%xmm11
  .byte  65,15,89,195                        // mulps         %xmm11,%xmm0
  .byte  15,41,68,36,232                     // movaps        %xmm0,-0x18(%rsp)
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  68,15,41,100,36,216                 // movaps        %xmm12,-0x28(%rsp)
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  68,15,40,229                        // movaps        %xmm5,%xmm12
  .byte  68,15,40,237                        // movaps        %xmm5,%xmm13
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,41,68,36,200                     // movaps        %xmm0,-0x38(%rsp)
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  68,15,95,239                        // maxps         %xmm7,%xmm13
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  68,15,40,245                        // movaps        %xmm5,%xmm14
  .byte  68,15,40,253                        // movaps        %xmm5,%xmm15
  .byte  69,15,95,253                        // maxps         %xmm13,%xmm15
  .byte  68,15,93,231                        // minps         %xmm7,%xmm12
  .byte  69,15,93,244                        // minps         %xmm12,%xmm14
  .byte  69,15,92,254                        // subps         %xmm14,%xmm15
  .byte  69,15,40,226                        // movaps        %xmm10,%xmm12
  .byte  68,15,93,226                        // minps         %xmm2,%xmm12
  .byte  69,15,40,233                        // movaps        %xmm9,%xmm13
  .byte  69,15,93,236                        // minps         %xmm12,%xmm13
  .byte  69,15,40,226                        // movaps        %xmm10,%xmm12
  .byte  68,15,95,226                        // maxps         %xmm2,%xmm12
  .byte  69,15,40,241                        // movaps        %xmm9,%xmm14
  .byte  69,15,95,244                        // maxps         %xmm12,%xmm14
  .byte  69,15,92,245                        // subps         %xmm13,%xmm14
  .byte  69,15,92,205                        // subps         %xmm13,%xmm9
  .byte  69,15,92,213                        // subps         %xmm13,%xmm10
  .byte  65,15,92,213                        // subps         %xmm13,%xmm2
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  68,15,89,251                        // mulps         %xmm3,%xmm15
  .byte  69,15,89,207                        // mulps         %xmm15,%xmm9
  .byte  69,15,89,215                        // mulps         %xmm15,%xmm10
  .byte  65,15,89,215                        // mulps         %xmm15,%xmm2
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  69,15,94,206                        // divps         %xmm14,%xmm9
  .byte  69,15,94,214                        // divps         %xmm14,%xmm10
  .byte  65,15,94,214                        // divps         %xmm14,%xmm2
  .byte  69,15,194,244,4                     // cmpneqps      %xmm12,%xmm14
  .byte  69,15,84,206                        // andps         %xmm14,%xmm9
  .byte  69,15,84,214                        // andps         %xmm14,%xmm10
  .byte  65,15,84,214                        // andps         %xmm14,%xmm2
  .byte  68,15,40,61,139,96,1,0              // movaps        0x1608b(%rip),%xmm15        # 3abd0 <_sk_srcover_bgra_8888_sse2_lowp+0xc68>
  .byte  65,15,89,231                        // mulps         %xmm15,%xmm4
  .byte  15,40,5,144,96,1,0                  // movaps        0x16090(%rip),%xmm0        # 3abe0 <_sk_srcover_bgra_8888_sse2_lowp+0xc78>
  .byte  15,89,240                           // mulps         %xmm0,%xmm6
  .byte  15,88,244                           // addps         %xmm4,%xmm6
  .byte  68,15,40,53,146,96,1,0              // movaps        0x16092(%rip),%xmm14        # 3abf0 <_sk_srcover_bgra_8888_sse2_lowp+0xc88>
  .byte  68,15,40,239                        // movaps        %xmm7,%xmm13
  .byte  69,15,89,238                        // mulps         %xmm14,%xmm13
  .byte  68,15,88,238                        // addps         %xmm6,%xmm13
  .byte  65,15,40,225                        // movaps        %xmm9,%xmm4
  .byte  65,15,89,231                        // mulps         %xmm15,%xmm4
  .byte  65,15,40,242                        // movaps        %xmm10,%xmm6
  .byte  15,89,240                           // mulps         %xmm0,%xmm6
  .byte  15,88,244                           // addps         %xmm4,%xmm6
  .byte  15,40,226                           // movaps        %xmm2,%xmm4
  .byte  65,15,89,230                        // mulps         %xmm14,%xmm4
  .byte  15,88,230                           // addps         %xmm6,%xmm4
  .byte  68,15,89,235                        // mulps         %xmm3,%xmm13
  .byte  68,15,92,236                        // subps         %xmm4,%xmm13
  .byte  69,15,88,205                        // addps         %xmm13,%xmm9
  .byte  69,15,88,213                        // addps         %xmm13,%xmm10
  .byte  68,15,88,234                        // addps         %xmm2,%xmm13
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,93,213                        // minps         %xmm13,%xmm2
  .byte  65,15,40,241                        // movaps        %xmm9,%xmm6
  .byte  15,93,242                           // minps         %xmm2,%xmm6
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,95,213                        // maxps         %xmm13,%xmm2
  .byte  65,15,40,225                        // movaps        %xmm9,%xmm4
  .byte  15,95,226                           // maxps         %xmm2,%xmm4
  .byte  69,15,89,249                        // mulps         %xmm9,%xmm15
  .byte  65,15,89,194                        // mulps         %xmm10,%xmm0
  .byte  65,15,88,199                        // addps         %xmm15,%xmm0
  .byte  69,15,89,245                        // mulps         %xmm13,%xmm14
  .byte  68,15,88,240                        // addps         %xmm0,%xmm14
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,194,214,2                        // cmpleps       %xmm6,%xmm2
  .byte  69,15,40,254                        // movaps        %xmm14,%xmm15
  .byte  68,15,92,254                        // subps         %xmm6,%xmm15
  .byte  65,15,40,241                        // movaps        %xmm9,%xmm6
  .byte  65,15,92,246                        // subps         %xmm14,%xmm6
  .byte  65,15,89,246                        // mulps         %xmm14,%xmm6
  .byte  65,15,94,247                        // divps         %xmm15,%xmm6
  .byte  65,15,88,246                        // addps         %xmm14,%xmm6
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,85,198                           // andnps        %xmm6,%xmm0
  .byte  68,15,84,202                        // andps         %xmm2,%xmm9
  .byte  68,15,86,200                        // orps          %xmm0,%xmm9
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,41,76,36,184                     // movaps        %xmm1,-0x48(%rsp)
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  15,92,216                           // subps         %xmm0,%xmm3
  .byte  15,41,92,36,168                     // movaps        %xmm3,-0x58(%rsp)
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,194,196,1                        // cmpltps       %xmm4,%xmm0
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  65,15,85,201                        // andnps        %xmm9,%xmm1
  .byte  69,15,92,206                        // subps         %xmm14,%xmm9
  .byte  65,15,92,246                        // subps         %xmm14,%xmm6
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  65,15,92,230                        // subps         %xmm14,%xmm4
  .byte  68,15,94,204                        // divps         %xmm4,%xmm9
  .byte  69,15,88,206                        // addps         %xmm14,%xmm9
  .byte  68,15,84,200                        // andps         %xmm0,%xmm9
  .byte  68,15,86,201                        // orps          %xmm1,%xmm9
  .byte  65,15,40,202                        // movaps        %xmm10,%xmm1
  .byte  65,15,92,206                        // subps         %xmm14,%xmm1
  .byte  65,15,89,206                        // mulps         %xmm14,%xmm1
  .byte  65,15,94,207                        // divps         %xmm15,%xmm1
  .byte  65,15,88,206                        // addps         %xmm14,%xmm1
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,85,217                           // andnps        %xmm1,%xmm3
  .byte  68,15,84,210                        // andps         %xmm2,%xmm10
  .byte  68,15,86,211                        // orps          %xmm3,%xmm10
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  65,15,85,202                        // andnps        %xmm10,%xmm1
  .byte  69,15,92,214                        // subps         %xmm14,%xmm10
  .byte  68,15,89,214                        // mulps         %xmm6,%xmm10
  .byte  68,15,94,212                        // divps         %xmm4,%xmm10
  .byte  69,15,88,214                        // addps         %xmm14,%xmm10
  .byte  68,15,84,208                        // andps         %xmm0,%xmm10
  .byte  68,15,86,209                        // orps          %xmm1,%xmm10
  .byte  65,15,40,205                        // movaps        %xmm13,%xmm1
  .byte  65,15,92,206                        // subps         %xmm14,%xmm1
  .byte  65,15,89,206                        // mulps         %xmm14,%xmm1
  .byte  65,15,94,207                        // divps         %xmm15,%xmm1
  .byte  65,15,88,206                        // addps         %xmm14,%xmm1
  .byte  68,15,84,234                        // andps         %xmm2,%xmm13
  .byte  15,85,209                           // andnps        %xmm1,%xmm2
  .byte  65,15,86,213                        // orps          %xmm13,%xmm2
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,85,202                           // andnps        %xmm2,%xmm1
  .byte  65,15,92,214                        // subps         %xmm14,%xmm2
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,94,212                           // divps         %xmm4,%xmm2
  .byte  65,15,88,214                        // addps         %xmm14,%xmm2
  .byte  15,84,208                           // andps         %xmm0,%xmm2
  .byte  15,86,209                           // orps          %xmm1,%xmm2
  .byte  69,15,95,204                        // maxps         %xmm12,%xmm9
  .byte  69,15,95,212                        // maxps         %xmm12,%xmm10
  .byte  65,15,95,212                        // maxps         %xmm12,%xmm2
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,40,76,36,232                     // movaps        -0x18(%rsp),%xmm1
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  65,15,88,201                        // addps         %xmm9,%xmm1
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  65,15,40,216                        // movaps        %xmm8,%xmm3
  .byte  15,40,116,36,200                    // movaps        -0x38(%rsp),%xmm6
  .byte  15,89,222                           // mulps         %xmm6,%xmm3
  .byte  15,40,76,36,216                     // movaps        -0x28(%rsp),%xmm1
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  69,15,88,195                        // addps         %xmm11,%xmm8
  .byte  68,15,88,194                        // addps         %xmm2,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,40,238                           // movaps        %xmm6,%xmm5
  .byte  15,40,247                           // movaps        %xmm7,%xmm6
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  15,40,92,36,168                     // movaps        -0x58(%rsp),%xmm3
  .byte  15,40,124,36,184                    // movaps        -0x48(%rsp),%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_saturation_sse2
.globl _sk_saturation_sse2
FUNCTION(_sk_saturation_sse2)
_sk_saturation_sse2:
  .byte  68,15,40,231                        // movaps        %xmm7,%xmm12
  .byte  68,15,40,198                        // movaps        %xmm6,%xmm8
  .byte  15,40,251                           // movaps        %xmm3,%xmm7
  .byte  68,15,40,216                        // movaps        %xmm0,%xmm11
  .byte  68,15,40,215                        // movaps        %xmm7,%xmm10
  .byte  68,15,89,212                        // mulps         %xmm4,%xmm10
  .byte  15,40,244                           // movaps        %xmm4,%xmm6
  .byte  15,41,116,36,184                    // movaps        %xmm6,-0x48(%rsp)
  .byte  68,15,40,207                        // movaps        %xmm7,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  15,41,108,36,200                    // movaps        %xmm5,-0x38(%rsp)
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  69,15,40,232                        // movaps        %xmm8,%xmm13
  .byte  68,15,41,108,36,168                 // movaps        %xmm13,-0x58(%rsp)
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,41,100,36,216                    // movaps        %xmm4,-0x28(%rsp)
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,41,84,36,232                     // movaps        %xmm2,-0x18(%rsp)
  .byte  15,95,218                           // maxps         %xmm2,%xmm3
  .byte  65,15,40,203                        // movaps        %xmm11,%xmm1
  .byte  15,95,203                           // maxps         %xmm3,%xmm1
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,93,218                           // minps         %xmm2,%xmm3
  .byte  65,15,40,211                        // movaps        %xmm11,%xmm2
  .byte  15,93,211                           // minps         %xmm3,%xmm2
  .byte  15,92,202                           // subps         %xmm2,%xmm1
  .byte  65,15,89,204                        // mulps         %xmm12,%xmm1
  .byte  65,15,40,228                        // movaps        %xmm12,%xmm4
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  15,93,208                           // minps         %xmm0,%xmm2
  .byte  69,15,40,194                        // movaps        %xmm10,%xmm8
  .byte  68,15,93,194                        // minps         %xmm2,%xmm8
  .byte  65,15,40,209                        // movaps        %xmm9,%xmm2
  .byte  15,95,208                           // maxps         %xmm0,%xmm2
  .byte  65,15,40,218                        // movaps        %xmm10,%xmm3
  .byte  15,95,218                           // maxps         %xmm2,%xmm3
  .byte  65,15,92,216                        // subps         %xmm8,%xmm3
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  69,15,92,208                        // subps         %xmm8,%xmm10
  .byte  68,15,89,209                        // mulps         %xmm1,%xmm10
  .byte  68,15,94,211                        // divps         %xmm3,%xmm10
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  68,15,94,203                        // divps         %xmm3,%xmm9
  .byte  65,15,92,192                        // subps         %xmm8,%xmm0
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,94,195                           // divps         %xmm3,%xmm0
  .byte  15,194,218,4                        // cmpneqps      %xmm2,%xmm3
  .byte  68,15,84,211                        // andps         %xmm3,%xmm10
  .byte  68,15,84,203                        // andps         %xmm3,%xmm9
  .byte  15,84,195                           // andps         %xmm3,%xmm0
  .byte  68,15,40,5,228,93,1,0               // movaps        0x15de4(%rip),%xmm8        # 3abd0 <_sk_srcover_bgra_8888_sse2_lowp+0xc68>
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,40,13,230,93,1,0                 // movaps        0x15de6(%rip),%xmm1        # 3abe0 <_sk_srcover_bgra_8888_sse2_lowp+0xc78>
  .byte  15,40,221                           // movaps        %xmm5,%xmm3
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  68,15,40,37,229,93,1,0              // movaps        0x15de5(%rip),%xmm12        # 3abf0 <_sk_srcover_bgra_8888_sse2_lowp+0xc88>
  .byte  69,15,89,236                        // mulps         %xmm12,%xmm13
  .byte  68,15,88,235                        // addps         %xmm3,%xmm13
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  65,15,40,217                        // movaps        %xmm9,%xmm3
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  65,15,89,212                        // mulps         %xmm12,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  68,15,89,239                        // mulps         %xmm7,%xmm13
  .byte  68,15,92,234                        // subps         %xmm2,%xmm13
  .byte  69,15,88,213                        // addps         %xmm13,%xmm10
  .byte  69,15,88,205                        // addps         %xmm13,%xmm9
  .byte  68,15,88,232                        // addps         %xmm0,%xmm13
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,93,197                        // minps         %xmm13,%xmm0
  .byte  65,15,40,218                        // movaps        %xmm10,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,95,197                        // maxps         %xmm13,%xmm0
  .byte  69,15,40,242                        // movaps        %xmm10,%xmm14
  .byte  68,15,95,240                        // maxps         %xmm0,%xmm14
  .byte  69,15,89,194                        // mulps         %xmm10,%xmm8
  .byte  65,15,89,201                        // mulps         %xmm9,%xmm1
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  69,15,89,229                        // mulps         %xmm13,%xmm12
  .byte  68,15,88,225                        // addps         %xmm1,%xmm12
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,194,211,2                        // cmpleps       %xmm3,%xmm2
  .byte  65,15,40,244                        // movaps        %xmm12,%xmm6
  .byte  15,92,243                           // subps         %xmm3,%xmm6
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  65,15,92,196                        // subps         %xmm12,%xmm0
  .byte  65,15,89,196                        // mulps         %xmm12,%xmm0
  .byte  15,94,198                           // divps         %xmm6,%xmm0
  .byte  65,15,88,196                        // addps         %xmm12,%xmm0
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,85,200                           // andnps        %xmm0,%xmm1
  .byte  68,15,84,210                        // andps         %xmm2,%xmm10
  .byte  68,15,86,209                        // orps          %xmm1,%xmm10
  .byte  15,40,223                           // movaps        %xmm7,%xmm3
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,89,221                           // mulps         %xmm5,%xmm3
  .byte  68,15,40,5,154,92,1,0               // movaps        0x15c9a(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,40,224                        // movaps        %xmm8,%xmm4
  .byte  68,15,92,199                        // subps         %xmm7,%xmm8
  .byte  15,88,253                           // addps         %xmm5,%xmm7
  .byte  15,92,251                           // subps         %xmm3,%xmm7
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  65,15,194,222,1                     // cmpltps       %xmm14,%xmm3
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  65,15,85,194                        // andnps        %xmm10,%xmm0
  .byte  69,15,92,212                        // subps         %xmm12,%xmm10
  .byte  65,15,92,204                        // subps         %xmm12,%xmm1
  .byte  68,15,89,209                        // mulps         %xmm1,%xmm10
  .byte  69,15,92,244                        // subps         %xmm12,%xmm14
  .byte  69,15,94,214                        // divps         %xmm14,%xmm10
  .byte  69,15,88,212                        // addps         %xmm12,%xmm10
  .byte  68,15,84,211                        // andps         %xmm3,%xmm10
  .byte  68,15,86,208                        // orps          %xmm0,%xmm10
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,92,196                        // subps         %xmm12,%xmm0
  .byte  65,15,89,196                        // mulps         %xmm12,%xmm0
  .byte  15,94,198                           // divps         %xmm6,%xmm0
  .byte  65,15,88,196                        // addps         %xmm12,%xmm0
  .byte  68,15,40,250                        // movaps        %xmm2,%xmm15
  .byte  68,15,85,248                        // andnps        %xmm0,%xmm15
  .byte  68,15,84,202                        // andps         %xmm2,%xmm9
  .byte  69,15,86,207                        // orps          %xmm15,%xmm9
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  65,15,85,193                        // andnps        %xmm9,%xmm0
  .byte  69,15,92,204                        // subps         %xmm12,%xmm9
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  69,15,94,206                        // divps         %xmm14,%xmm9
  .byte  69,15,88,204                        // addps         %xmm12,%xmm9
  .byte  68,15,84,203                        // andps         %xmm3,%xmm9
  .byte  68,15,86,200                        // orps          %xmm0,%xmm9
  .byte  65,15,40,197                        // movaps        %xmm13,%xmm0
  .byte  65,15,92,196                        // subps         %xmm12,%xmm0
  .byte  65,15,89,196                        // mulps         %xmm12,%xmm0
  .byte  15,94,198                           // divps         %xmm6,%xmm0
  .byte  65,15,88,196                        // addps         %xmm12,%xmm0
  .byte  68,15,84,234                        // andps         %xmm2,%xmm13
  .byte  15,85,208                           // andnps        %xmm0,%xmm2
  .byte  65,15,86,213                        // orps          %xmm13,%xmm2
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,85,194                           // andnps        %xmm2,%xmm0
  .byte  65,15,92,212                        // subps         %xmm12,%xmm2
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  65,15,94,214                        // divps         %xmm14,%xmm2
  .byte  65,15,88,212                        // addps         %xmm12,%xmm2
  .byte  15,84,211                           // andps         %xmm3,%xmm2
  .byte  15,86,208                           // orps          %xmm0,%xmm2
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  68,15,95,208                        // maxps         %xmm0,%xmm10
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  15,95,208                           // maxps         %xmm0,%xmm2
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,40,92,36,184                     // movaps        -0x48(%rsp),%xmm3
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  68,15,40,229                        // movaps        %xmm5,%xmm12
  .byte  65,15,92,228                        // subps         %xmm12,%xmm4
  .byte  68,15,89,220                        // mulps         %xmm4,%xmm11
  .byte  68,15,88,216                        // addps         %xmm0,%xmm11
  .byte  69,15,88,218                        // addps         %xmm10,%xmm11
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,40,108,36,200                    // movaps        -0x38(%rsp),%xmm5
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,40,76,36,216                     // movaps        -0x28(%rsp),%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  65,15,88,201                        // addps         %xmm9,%xmm1
  .byte  15,89,100,36,232                    // mulps         -0x18(%rsp),%xmm4
  .byte  15,40,68,36,168                     // movaps        -0x58(%rsp),%xmm0
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  68,15,88,196                        // addps         %xmm4,%xmm8
  .byte  68,15,88,194                        // addps         %xmm2,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  15,40,223                           // movaps        %xmm7,%xmm3
  .byte  65,15,40,252                        // movaps        %xmm12,%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_color_sse2
.globl _sk_color_sse2
FUNCTION(_sk_color_sse2)
_sk_color_sse2:
  .byte  68,15,40,199                        // movaps        %xmm7,%xmm8
  .byte  68,15,40,230                        // movaps        %xmm6,%xmm12
  .byte  68,15,41,100,36,216                 // movaps        %xmm12,-0x28(%rsp)
  .byte  68,15,40,221                        // movaps        %xmm5,%xmm11
  .byte  68,15,41,92,36,232                  // movaps        %xmm11,-0x18(%rsp)
  .byte  15,40,244                           // movaps        %xmm4,%xmm6
  .byte  15,41,84,36,184                     // movaps        %xmm2,-0x48(%rsp)
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  68,15,40,207                        // movaps        %xmm7,%xmm9
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  68,15,40,213                        // movaps        %xmm5,%xmm10
  .byte  69,15,89,208                        // mulps         %xmm8,%xmm10
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  68,15,40,45,168,91,1,0              // movaps        0x15ba8(%rip),%xmm13        # 3abd0 <_sk_srcover_bgra_8888_sse2_lowp+0xc68>
  .byte  68,15,40,198                        // movaps        %xmm6,%xmm8
  .byte  69,15,89,197                        // mulps         %xmm13,%xmm8
  .byte  68,15,40,53,168,91,1,0              // movaps        0x15ba8(%rip),%xmm14        # 3abe0 <_sk_srcover_bgra_8888_sse2_lowp+0xc78>
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  65,15,89,198                        // mulps         %xmm14,%xmm0
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  68,15,40,29,164,91,1,0              // movaps        0x15ba4(%rip),%xmm11        # 3abf0 <_sk_srcover_bgra_8888_sse2_lowp+0xc88>
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  68,15,88,224                        // addps         %xmm0,%xmm12
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,89,197                        // mulps         %xmm13,%xmm0
  .byte  69,15,40,250                        // movaps        %xmm10,%xmm15
  .byte  69,15,89,254                        // mulps         %xmm14,%xmm15
  .byte  68,15,88,248                        // addps         %xmm0,%xmm15
  .byte  68,15,40,5,224,90,1,0               // movaps        0x15ae0(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,40,224                        // movaps        %xmm8,%xmm4
  .byte  15,92,226                           // subps         %xmm2,%xmm4
  .byte  15,89,252                           // mulps         %xmm4,%xmm7
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,40,76,36,184                     // movaps        -0x48(%rsp),%xmm1
  .byte  15,89,225                           // mulps         %xmm1,%xmm4
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  65,15,89,195                        // mulps         %xmm11,%xmm0
  .byte  65,15,88,199                        // addps         %xmm15,%xmm0
  .byte  68,15,89,227                        // mulps         %xmm3,%xmm12
  .byte  68,15,92,224                        // subps         %xmm0,%xmm12
  .byte  69,15,88,204                        // addps         %xmm12,%xmm9
  .byte  69,15,88,212                        // addps         %xmm12,%xmm10
  .byte  68,15,88,225                        // addps         %xmm1,%xmm12
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  65,15,93,196                        // minps         %xmm12,%xmm0
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  15,93,200                           // minps         %xmm0,%xmm1
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  65,15,95,196                        // maxps         %xmm12,%xmm0
  .byte  69,15,40,249                        // movaps        %xmm9,%xmm15
  .byte  68,15,95,248                        // maxps         %xmm0,%xmm15
  .byte  69,15,89,233                        // mulps         %xmm9,%xmm13
  .byte  69,15,89,242                        // mulps         %xmm10,%xmm14
  .byte  69,15,88,245                        // addps         %xmm13,%xmm14
  .byte  69,15,89,220                        // mulps         %xmm12,%xmm11
  .byte  69,15,88,222                        // addps         %xmm14,%xmm11
  .byte  69,15,87,237                        // xorps         %xmm13,%xmm13
  .byte  68,15,194,233,2                     // cmpleps       %xmm1,%xmm13
  .byte  69,15,40,243                        // movaps        %xmm11,%xmm14
  .byte  68,15,92,241                        // subps         %xmm1,%xmm14
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  65,15,92,203                        // subps         %xmm11,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  65,15,94,206                        // divps         %xmm14,%xmm1
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  65,15,40,197                        // movaps        %xmm13,%xmm0
  .byte  15,85,193                           // andnps        %xmm1,%xmm0
  .byte  69,15,84,205                        // andps         %xmm13,%xmm9
  .byte  68,15,86,200                        // orps          %xmm0,%xmm9
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,41,84,36,200                     // movaps        %xmm2,-0x38(%rsp)
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  15,92,216                           // subps         %xmm0,%xmm3
  .byte  15,41,92,36,184                     // movaps        %xmm3,-0x48(%rsp)
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  65,15,194,199,1                     // cmpltps       %xmm15,%xmm0
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  65,15,85,201                        // andnps        %xmm9,%xmm1
  .byte  69,15,92,203                        // subps         %xmm11,%xmm9
  .byte  65,15,92,219                        // subps         %xmm11,%xmm3
  .byte  68,15,89,203                        // mulps         %xmm3,%xmm9
  .byte  69,15,92,251                        // subps         %xmm11,%xmm15
  .byte  69,15,94,207                        // divps         %xmm15,%xmm9
  .byte  69,15,88,203                        // addps         %xmm11,%xmm9
  .byte  68,15,84,200                        // andps         %xmm0,%xmm9
  .byte  68,15,86,201                        // orps          %xmm1,%xmm9
  .byte  65,15,40,202                        // movaps        %xmm10,%xmm1
  .byte  65,15,92,203                        // subps         %xmm11,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  65,15,94,206                        // divps         %xmm14,%xmm1
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  65,15,40,213                        // movaps        %xmm13,%xmm2
  .byte  15,85,209                           // andnps        %xmm1,%xmm2
  .byte  69,15,84,213                        // andps         %xmm13,%xmm10
  .byte  68,15,86,210                        // orps          %xmm2,%xmm10
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  65,15,85,202                        // andnps        %xmm10,%xmm1
  .byte  69,15,92,211                        // subps         %xmm11,%xmm10
  .byte  68,15,89,211                        // mulps         %xmm3,%xmm10
  .byte  69,15,94,215                        // divps         %xmm15,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  68,15,84,208                        // andps         %xmm0,%xmm10
  .byte  68,15,86,209                        // orps          %xmm1,%xmm10
  .byte  65,15,40,204                        // movaps        %xmm12,%xmm1
  .byte  65,15,92,203                        // subps         %xmm11,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  65,15,94,206                        // divps         %xmm14,%xmm1
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  69,15,84,229                        // andps         %xmm13,%xmm12
  .byte  68,15,85,233                        // andnps        %xmm1,%xmm13
  .byte  69,15,86,236                        // orps          %xmm12,%xmm13
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  65,15,85,205                        // andnps        %xmm13,%xmm1
  .byte  69,15,92,235                        // subps         %xmm11,%xmm13
  .byte  68,15,89,235                        // mulps         %xmm3,%xmm13
  .byte  69,15,94,239                        // divps         %xmm15,%xmm13
  .byte  69,15,88,235                        // addps         %xmm11,%xmm13
  .byte  68,15,84,232                        // andps         %xmm0,%xmm13
  .byte  68,15,86,233                        // orps          %xmm1,%xmm13
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,95,208                        // maxps         %xmm0,%xmm10
  .byte  68,15,95,232                        // maxps         %xmm0,%xmm13
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  65,15,88,249                        // addps         %xmm9,%xmm7
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,40,84,36,232                     // movaps        -0x18(%rsp),%xmm2
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  65,15,88,234                        // addps         %xmm10,%xmm5
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,40,68,36,216                     // movaps        -0x28(%rsp),%xmm0
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  68,15,88,196                        // addps         %xmm4,%xmm8
  .byte  69,15,88,197                        // addps         %xmm13,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  15,40,234                           // movaps        %xmm2,%xmm5
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  15,40,92,36,184                     // movaps        -0x48(%rsp),%xmm3
  .byte  15,40,124,36,200                    // movaps        -0x38(%rsp),%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_luminosity_sse2
.globl _sk_luminosity_sse2
FUNCTION(_sk_luminosity_sse2)
_sk_luminosity_sse2:
  .byte  68,15,40,215                        // movaps        %xmm7,%xmm10
  .byte  15,41,116,36,200                    // movaps        %xmm6,-0x38(%rsp)
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  15,41,116,36,232                    // movaps        %xmm6,-0x18(%rsp)
  .byte  15,41,100,36,216                    // movaps        %xmm4,-0x28(%rsp)
  .byte  15,40,235                           // movaps        %xmm3,%xmm5
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  68,15,40,205                        // movaps        %xmm5,%xmm9
  .byte  68,15,89,204                        // mulps         %xmm4,%xmm9
  .byte  15,89,222                           // mulps         %xmm6,%xmm3
  .byte  68,15,40,37,103,89,1,0              // movaps        0x15967(%rip),%xmm12        # 3abd0 <_sk_srcover_bgra_8888_sse2_lowp+0xc68>
  .byte  68,15,40,199                        // movaps        %xmm7,%xmm8
  .byte  69,15,89,196                        // mulps         %xmm12,%xmm8
  .byte  68,15,40,45,103,89,1,0              // movaps        0x15967(%rip),%xmm13        # 3abe0 <_sk_srcover_bgra_8888_sse2_lowp+0xc78>
  .byte  68,15,40,241                        // movaps        %xmm1,%xmm14
  .byte  69,15,89,245                        // mulps         %xmm13,%xmm14
  .byte  69,15,88,240                        // addps         %xmm8,%xmm14
  .byte  68,15,40,29,99,89,1,0               // movaps        0x15963(%rip),%xmm11        # 3abf0 <_sk_srcover_bgra_8888_sse2_lowp+0xc88>
  .byte  68,15,40,5,187,88,1,0               // movaps        0x158bb(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,248                        // movaps        %xmm8,%xmm15
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  68,15,92,248                        // subps         %xmm0,%xmm15
  .byte  65,15,89,255                        // mulps         %xmm15,%xmm7
  .byte  65,15,89,207                        // mulps         %xmm15,%xmm1
  .byte  15,41,76,36,184                     // movaps        %xmm1,-0x48(%rsp)
  .byte  68,15,89,250                        // mulps         %xmm2,%xmm15
  .byte  65,15,89,211                        // mulps         %xmm11,%xmm2
  .byte  65,15,88,214                        // addps         %xmm14,%xmm2
  .byte  69,15,40,241                        // movaps        %xmm9,%xmm14
  .byte  69,15,89,244                        // mulps         %xmm12,%xmm14
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  69,15,89,213                        // mulps         %xmm13,%xmm10
  .byte  69,15,88,214                        // addps         %xmm14,%xmm10
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,40,116,36,200                    // movaps        -0x38(%rsp),%xmm6
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  68,15,40,244                        // movaps        %xmm4,%xmm14
  .byte  69,15,89,243                        // mulps         %xmm11,%xmm14
  .byte  69,15,88,242                        // addps         %xmm10,%xmm14
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  65,15,92,214                        // subps         %xmm14,%xmm2
  .byte  68,15,88,202                        // addps         %xmm2,%xmm9
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  68,15,93,210                        // minps         %xmm2,%xmm10
  .byte  65,15,40,225                        // movaps        %xmm9,%xmm4
  .byte  65,15,93,226                        // minps         %xmm10,%xmm4
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  68,15,95,210                        // maxps         %xmm2,%xmm10
  .byte  69,15,40,241                        // movaps        %xmm9,%xmm14
  .byte  69,15,95,242                        // maxps         %xmm10,%xmm14
  .byte  69,15,89,225                        // mulps         %xmm9,%xmm12
  .byte  68,15,89,235                        // mulps         %xmm3,%xmm13
  .byte  69,15,88,236                        // addps         %xmm12,%xmm13
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  69,15,88,221                        // addps         %xmm13,%xmm11
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,194,228,2                     // cmpleps       %xmm4,%xmm12
  .byte  69,15,40,211                        // movaps        %xmm11,%xmm10
  .byte  68,15,92,212                        // subps         %xmm4,%xmm10
  .byte  65,15,40,225                        // movaps        %xmm9,%xmm4
  .byte  65,15,92,227                        // subps         %xmm11,%xmm4
  .byte  65,15,89,227                        // mulps         %xmm11,%xmm4
  .byte  65,15,94,226                        // divps         %xmm10,%xmm4
  .byte  65,15,88,227                        // addps         %xmm11,%xmm4
  .byte  69,15,40,236                        // movaps        %xmm12,%xmm13
  .byte  68,15,85,236                        // andnps        %xmm4,%xmm13
  .byte  69,15,84,204                        // andps         %xmm12,%xmm9
  .byte  69,15,86,205                        // orps          %xmm13,%xmm9
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,41,68,36,168                     // movaps        %xmm0,-0x58(%rsp)
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  68,15,92,197                        // subps         %xmm5,%xmm8
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  15,92,236                           // subps         %xmm4,%xmm5
  .byte  68,15,40,236                        // movaps        %xmm4,%xmm13
  .byte  65,15,194,230,1                     // cmpltps       %xmm14,%xmm4
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  65,15,85,193                        // andnps        %xmm9,%xmm0
  .byte  69,15,92,203                        // subps         %xmm11,%xmm9
  .byte  69,15,92,235                        // subps         %xmm11,%xmm13
  .byte  69,15,89,205                        // mulps         %xmm13,%xmm9
  .byte  69,15,92,243                        // subps         %xmm11,%xmm14
  .byte  69,15,94,206                        // divps         %xmm14,%xmm9
  .byte  69,15,88,203                        // addps         %xmm11,%xmm9
  .byte  68,15,84,204                        // andps         %xmm4,%xmm9
  .byte  68,15,86,200                        // orps          %xmm0,%xmm9
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  65,15,92,195                        // subps         %xmm11,%xmm0
  .byte  65,15,89,195                        // mulps         %xmm11,%xmm0
  .byte  65,15,94,194                        // divps         %xmm10,%xmm0
  .byte  65,15,88,195                        // addps         %xmm11,%xmm0
  .byte  65,15,40,204                        // movaps        %xmm12,%xmm1
  .byte  15,85,200                           // andnps        %xmm0,%xmm1
  .byte  65,15,84,220                        // andps         %xmm12,%xmm3
  .byte  15,86,217                           // orps          %xmm1,%xmm3
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,85,195                           // andnps        %xmm3,%xmm0
  .byte  65,15,92,219                        // subps         %xmm11,%xmm3
  .byte  65,15,89,221                        // mulps         %xmm13,%xmm3
  .byte  65,15,94,222                        // divps         %xmm14,%xmm3
  .byte  65,15,88,219                        // addps         %xmm11,%xmm3
  .byte  15,84,220                           // andps         %xmm4,%xmm3
  .byte  15,86,216                           // orps          %xmm0,%xmm3
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  65,15,92,195                        // subps         %xmm11,%xmm0
  .byte  65,15,89,195                        // mulps         %xmm11,%xmm0
  .byte  65,15,94,194                        // divps         %xmm10,%xmm0
  .byte  65,15,88,195                        // addps         %xmm11,%xmm0
  .byte  65,15,84,212                        // andps         %xmm12,%xmm2
  .byte  68,15,85,224                        // andnps        %xmm0,%xmm12
  .byte  68,15,86,226                        // orps          %xmm2,%xmm12
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  65,15,85,196                        // andnps        %xmm12,%xmm0
  .byte  69,15,92,227                        // subps         %xmm11,%xmm12
  .byte  69,15,89,229                        // mulps         %xmm13,%xmm12
  .byte  69,15,94,230                        // divps         %xmm14,%xmm12
  .byte  69,15,88,227                        // addps         %xmm11,%xmm12
  .byte  68,15,84,228                        // andps         %xmm4,%xmm12
  .byte  68,15,86,224                        // orps          %xmm0,%xmm12
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  15,95,216                           // maxps         %xmm0,%xmm3
  .byte  68,15,95,224                        // maxps         %xmm0,%xmm12
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,40,100,36,216                    // movaps        -0x28(%rsp),%xmm4
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  65,15,88,249                        // addps         %xmm9,%xmm7
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  68,15,40,84,36,232                  // movaps        -0x18(%rsp),%xmm10
  .byte  65,15,89,194                        // mulps         %xmm10,%xmm0
  .byte  15,40,76,36,184                     // movaps        -0x48(%rsp),%xmm1
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  68,15,89,198                        // mulps         %xmm6,%xmm8
  .byte  69,15,88,199                        // addps         %xmm15,%xmm8
  .byte  69,15,88,196                        // addps         %xmm12,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  15,40,221                           // movaps        %xmm5,%xmm3
  .byte  65,15,40,234                        // movaps        %xmm10,%xmm5
  .byte  15,40,124,36,168                    // movaps        -0x58(%rsp),%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_rgba_8888_sse2
.globl _sk_srcover_rgba_8888_sse2
FUNCTION(_sk_srcover_rgba_8888_sse2)
_sk_srcover_rgba_8888_sse2:
  .byte  102,68,15,111,200                   // movdqa        %xmm0,%xmm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,4,1,0,0                      // jne           255a5 <_sk_srcover_rgba_8888_sse2+0x129>
  .byte  243,65,15,111,4,128                 // movdqu        (%r8,%rax,4),%xmm0
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  102,15,111,53,78,87,1,0             // movdqa        0x1574e(%rip),%xmm6        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,15,111,224                      // movdqa        %xmm0,%xmm4
  .byte  102,15,219,230                      // pand          %xmm6,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,114,213,8                    // psrld         $0x8,%xmm5
  .byte  102,15,219,238                      // pand          %xmm6,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  102,15,114,215,16                   // psrld         $0x10,%xmm7
  .byte  102,15,219,254                      // pand          %xmm6,%xmm7
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  15,91,247                           // cvtdq2ps      %xmm7,%xmm6
  .byte  102,15,114,208,24                   // psrld         $0x18,%xmm0
  .byte  15,91,248                           // cvtdq2ps      %xmm0,%xmm7
  .byte  68,15,40,5,95,86,1,0                // movaps        0x1565f(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  68,15,40,37,51,87,1,0               // movaps        0x15733(%rip),%xmm12        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  69,15,89,204                        // mulps         %xmm12,%xmm9
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  65,15,88,193                        // addps         %xmm9,%xmm0
  .byte  65,15,89,204                        // mulps         %xmm12,%xmm1
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  68,15,88,201                        // addps         %xmm1,%xmm9
  .byte  65,15,89,212                        // mulps         %xmm12,%xmm2
  .byte  69,15,40,208                        // movaps        %xmm8,%xmm10
  .byte  68,15,89,214                        // mulps         %xmm6,%xmm10
  .byte  68,15,88,210                        // addps         %xmm2,%xmm10
  .byte  65,15,89,220                        // mulps         %xmm12,%xmm3
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  68,15,88,195                        // addps         %xmm3,%xmm8
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,95,200                           // maxps         %xmm0,%xmm1
  .byte  65,15,93,204                        // minps         %xmm12,%xmm1
  .byte  102,15,91,201                       // cvtps2dq      %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  65,15,95,209                        // maxps         %xmm9,%xmm2
  .byte  65,15,93,212                        // minps         %xmm12,%xmm2
  .byte  102,15,91,210                       // cvtps2dq      %xmm2,%xmm2
  .byte  102,15,114,242,8                    // pslld         $0x8,%xmm2
  .byte  102,15,235,209                      // por           %xmm1,%xmm2
  .byte  102,15,87,201                       // xorpd         %xmm1,%xmm1
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,93,204                        // minps         %xmm12,%xmm1
  .byte  102,15,91,217                       // cvtps2dq      %xmm1,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  69,15,95,216                        // maxps         %xmm8,%xmm11
  .byte  69,15,93,220                        // minps         %xmm12,%xmm11
  .byte  102,65,15,91,203                    // cvtps2dq      %xmm11,%xmm1
  .byte  102,15,114,241,24                   // pslld         $0x18,%xmm1
  .byte  102,15,235,203                      // por           %xmm3,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  117,78                              // jne           255dd <_sk_srcover_rgba_8888_sse2+0x161>
  .byte  243,65,15,127,12,128                // movdqu        %xmm1,(%r8,%rax,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,40,216                        // movaps        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,88                              // je            2560a <_sk_srcover_rgba_8888_sse2+0x18e>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,22                              // je            255d2 <_sk_srcover_rgba_8888_sse2+0x156>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  15,133,225,254,255,255              // jne           254a7 <_sk_srcover_rgba_8888_sse2+0x2b>
  .byte  102,65,15,110,68,128,8              // movd          0x8(%r8,%rax,4),%xmm0
  .byte  102,15,112,192,69                   // pshufd        $0x45,%xmm0,%xmm0
  .byte  102,65,15,18,4,128                  // movlpd        (%r8,%rax,4),%xmm0
  .byte  233,202,254,255,255                 // jmpq          254a7 <_sk_srcover_rgba_8888_sse2+0x2b>
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,43                              // je            25615 <_sk_srcover_rgba_8888_sse2+0x199>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,18                              // je            25602 <_sk_srcover_rgba_8888_sse2+0x186>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,159                             // jne           25595 <_sk_srcover_rgba_8888_sse2+0x119>
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,65,15,126,84,128,8              // movd          %xmm2,0x8(%r8,%rax,4)
  .byte  102,65,15,214,12,128                // movq          %xmm1,(%r8,%rax,4)
  .byte  235,139                             // jmp           25595 <_sk_srcover_rgba_8888_sse2+0x119>
  .byte  102,65,15,110,4,128                 // movd          (%r8,%rax,4),%xmm0
  .byte  233,146,254,255,255                 // jmpq          254a7 <_sk_srcover_rgba_8888_sse2+0x2b>
  .byte  102,65,15,126,12,128                // movd          %xmm1,(%r8,%rax,4)
  .byte  233,117,255,255,255                 // jmpq          25595 <_sk_srcover_rgba_8888_sse2+0x119>

HIDDEN _sk_srcover_bgra_8888_sse2
.globl _sk_srcover_bgra_8888_sse2
FUNCTION(_sk_srcover_bgra_8888_sse2)
_sk_srcover_bgra_8888_sse2:
  .byte  102,68,15,111,200                   // movdqa        %xmm0,%xmm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,4,1,0,0                      // jne           25749 <_sk_srcover_bgra_8888_sse2+0x129>
  .byte  243,65,15,111,4,128                 // movdqu        (%r8,%rax,4),%xmm0
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  102,15,111,37,170,85,1,0            // movdqa        0x155aa(%rip),%xmm4        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,219,236                      // pand          %xmm4,%xmm5
  .byte  15,91,245                           // cvtdq2ps      %xmm5,%xmm6
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,114,213,8                    // psrld         $0x8,%xmm5
  .byte  102,15,219,236                      // pand          %xmm4,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  102,15,114,215,16                   // psrld         $0x10,%xmm7
  .byte  102,15,219,252                      // pand          %xmm4,%xmm7
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  15,91,231                           // cvtdq2ps      %xmm7,%xmm4
  .byte  102,15,114,208,24                   // psrld         $0x18,%xmm0
  .byte  15,91,248                           // cvtdq2ps      %xmm0,%xmm7
  .byte  68,15,40,5,187,84,1,0               // movaps        0x154bb(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  68,15,40,37,143,85,1,0              // movaps        0x1558f(%rip),%xmm12        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  69,15,89,204                        // mulps         %xmm12,%xmm9
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  65,15,88,193                        // addps         %xmm9,%xmm0
  .byte  65,15,89,204                        // mulps         %xmm12,%xmm1
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,89,205                        // mulps         %xmm5,%xmm9
  .byte  68,15,88,201                        // addps         %xmm1,%xmm9
  .byte  65,15,89,212                        // mulps         %xmm12,%xmm2
  .byte  69,15,40,208                        // movaps        %xmm8,%xmm10
  .byte  68,15,89,214                        // mulps         %xmm6,%xmm10
  .byte  68,15,88,210                        // addps         %xmm2,%xmm10
  .byte  65,15,89,220                        // mulps         %xmm12,%xmm3
  .byte  68,15,89,199                        // mulps         %xmm7,%xmm8
  .byte  68,15,88,195                        // addps         %xmm3,%xmm8
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,93,204                        // minps         %xmm12,%xmm1
  .byte  102,15,91,201                       // cvtps2dq      %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  65,15,95,209                        // maxps         %xmm9,%xmm2
  .byte  65,15,93,212                        // minps         %xmm12,%xmm2
  .byte  102,15,91,210                       // cvtps2dq      %xmm2,%xmm2
  .byte  102,15,114,242,8                    // pslld         $0x8,%xmm2
  .byte  102,15,235,209                      // por           %xmm1,%xmm2
  .byte  102,15,87,201                       // xorpd         %xmm1,%xmm1
  .byte  15,95,200                           // maxps         %xmm0,%xmm1
  .byte  65,15,93,204                        // minps         %xmm12,%xmm1
  .byte  102,15,91,217                       // cvtps2dq      %xmm1,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  69,15,95,216                        // maxps         %xmm8,%xmm11
  .byte  69,15,93,220                        // minps         %xmm12,%xmm11
  .byte  102,65,15,91,203                    // cvtps2dq      %xmm11,%xmm1
  .byte  102,15,114,241,24                   // pslld         $0x18,%xmm1
  .byte  102,15,235,203                      // por           %xmm3,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  117,78                              // jne           25781 <_sk_srcover_bgra_8888_sse2+0x161>
  .byte  243,65,15,127,12,128                // movdqu        %xmm1,(%r8,%rax,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,40,216                        // movaps        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,88                              // je            257ae <_sk_srcover_bgra_8888_sse2+0x18e>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,22                              // je            25776 <_sk_srcover_bgra_8888_sse2+0x156>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  15,133,225,254,255,255              // jne           2564b <_sk_srcover_bgra_8888_sse2+0x2b>
  .byte  102,65,15,110,68,128,8              // movd          0x8(%r8,%rax,4),%xmm0
  .byte  102,15,112,192,69                   // pshufd        $0x45,%xmm0,%xmm0
  .byte  102,65,15,18,4,128                  // movlpd        (%r8,%rax,4),%xmm0
  .byte  233,202,254,255,255                 // jmpq          2564b <_sk_srcover_bgra_8888_sse2+0x2b>
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,43                              // je            257b9 <_sk_srcover_bgra_8888_sse2+0x199>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,18                              // je            257a6 <_sk_srcover_bgra_8888_sse2+0x186>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,159                             // jne           25739 <_sk_srcover_bgra_8888_sse2+0x119>
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,65,15,126,84,128,8              // movd          %xmm2,0x8(%r8,%rax,4)
  .byte  102,65,15,214,12,128                // movq          %xmm1,(%r8,%rax,4)
  .byte  235,139                             // jmp           25739 <_sk_srcover_bgra_8888_sse2+0x119>
  .byte  102,65,15,110,4,128                 // movd          (%r8,%rax,4),%xmm0
  .byte  233,146,254,255,255                 // jmpq          2564b <_sk_srcover_bgra_8888_sse2+0x2b>
  .byte  102,65,15,126,12,128                // movd          %xmm1,(%r8,%rax,4)
  .byte  233,117,255,255,255                 // jmpq          25739 <_sk_srcover_bgra_8888_sse2+0x119>

HIDDEN _sk_clamp_0_sse2
.globl _sk_clamp_0_sse2
FUNCTION(_sk_clamp_0_sse2)
_sk_clamp_0_sse2:
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  65,15,95,192                        // maxps         %xmm8,%xmm0
  .byte  65,15,95,200                        // maxps         %xmm8,%xmm1
  .byte  65,15,95,208                        // maxps         %xmm8,%xmm2
  .byte  65,15,95,216                        // maxps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_1_sse2
.globl _sk_clamp_1_sse2
FUNCTION(_sk_clamp_1_sse2)
_sk_clamp_1_sse2:
  .byte  68,15,40,5,108,83,1,0               // movaps        0x1536c(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_sse2
.globl _sk_clamp_a_sse2
FUNCTION(_sk_clamp_a_sse2)
_sk_clamp_a_sse2:
  .byte  15,93,29,81,83,1,0                  // minps         0x15351(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,93,195                           // minps         %xmm3,%xmm0
  .byte  15,93,203                           // minps         %xmm3,%xmm1
  .byte  15,93,211                           // minps         %xmm3,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_dst_sse2
.globl _sk_clamp_a_dst_sse2
FUNCTION(_sk_clamp_a_dst_sse2)
_sk_clamp_a_dst_sse2:
  .byte  15,93,61,61,83,1,0                  // minps         0x1533d(%rip),%xmm7        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,93,231                           // minps         %xmm7,%xmm4
  .byte  15,93,239                           // minps         %xmm7,%xmm5
  .byte  15,93,247                           // minps         %xmm7,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_set_rgb_sse2
.globl _sk_set_rgb_sse2
FUNCTION(_sk_set_rgb_sse2)
_sk_set_rgb_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,80,8                      // movss         0x8(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_swap_rb_sse2
.globl _sk_swap_rb_sse2
FUNCTION(_sk_swap_rb_sse2)
_sk_swap_rb_sse2:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_invert_sse2
.globl _sk_invert_sse2
FUNCTION(_sk_invert_sse2)
_sk_invert_sse2:
  .byte  68,15,40,5,249,82,1,0               // movaps        0x152f9(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,92,200                        // subps         %xmm0,%xmm9
  .byte  69,15,40,208                        // movaps        %xmm8,%xmm10
  .byte  68,15,92,209                        // subps         %xmm1,%xmm10
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  68,15,92,218                        // subps         %xmm2,%xmm11
  .byte  68,15,92,195                        // subps         %xmm3,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,40,202                        // movaps        %xmm10,%xmm1
  .byte  65,15,40,211                        // movaps        %xmm11,%xmm2
  .byte  65,15,40,216                        // movaps        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_src_dst_sse2
.globl _sk_move_src_dst_sse2
FUNCTION(_sk_move_src_dst_sse2)
_sk_move_src_dst_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,40,242                           // movaps        %xmm2,%xmm6
  .byte  15,40,251                           // movaps        %xmm3,%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_dst_src_sse2
.globl _sk_move_dst_src_sse2
FUNCTION(_sk_move_dst_src_sse2)
_sk_move_dst_src_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,40,223                           // movaps        %xmm7,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_sse2
.globl _sk_premul_sse2
FUNCTION(_sk_premul_sse2)
_sk_premul_sse2:
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_dst_sse2
.globl _sk_premul_dst_sse2
FUNCTION(_sk_premul_dst_sse2)
_sk_premul_dst_sse2:
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,89,239                           // mulps         %xmm7,%xmm5
  .byte  15,89,247                           // mulps         %xmm7,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_unpremul_sse2
.globl _sk_unpremul_sse2
FUNCTION(_sk_unpremul_sse2)
_sk_unpremul_sse2:
  .byte  68,15,40,5,135,82,1,0               // movaps        0x15287(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,94,195                        // divps         %xmm3,%xmm8
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  68,15,194,13,102,83,1,0,1           // cmpltps       0x15366(%rip),%xmm9        # 3ac40 <_sk_srcover_bgra_8888_sse2_lowp+0xcd8>
  .byte  69,15,84,200                        // andps         %xmm8,%xmm9
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  65,15,89,201                        // mulps         %xmm9,%xmm1
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_from_srgb_sse2
.globl _sk_from_srgb_sse2
FUNCTION(_sk_from_srgb_sse2)
_sk_from_srgb_sse2:
  .byte  68,15,40,5,90,83,1,0                // movaps        0x1535a(%rip),%xmm8        # 3ac50 <_sk_srcover_bgra_8888_sse2_lowp+0xce8>
  .byte  68,15,40,232                        // movaps        %xmm0,%xmm13
  .byte  69,15,89,232                        // mulps         %xmm8,%xmm13
  .byte  68,15,40,216                        // movaps        %xmm0,%xmm11
  .byte  69,15,89,219                        // mulps         %xmm11,%xmm11
  .byte  68,15,40,13,194,82,1,0              // movaps        0x152c2(%rip),%xmm9        # 3abd0 <_sk_srcover_bgra_8888_sse2_lowp+0xc68>
  .byte  68,15,40,240                        // movaps        %xmm0,%xmm14
  .byte  69,15,89,241                        // mulps         %xmm9,%xmm14
  .byte  68,15,40,21,66,83,1,0               // movaps        0x15342(%rip),%xmm10        # 3ac60 <_sk_srcover_bgra_8888_sse2_lowp+0xcf8>
  .byte  69,15,88,242                        // addps         %xmm10,%xmm14
  .byte  69,15,89,243                        // mulps         %xmm11,%xmm14
  .byte  68,15,40,29,66,83,1,0               // movaps        0x15342(%rip),%xmm11        # 3ac70 <_sk_srcover_bgra_8888_sse2_lowp+0xd08>
  .byte  69,15,88,243                        // addps         %xmm11,%xmm14
  .byte  68,15,40,37,70,83,1,0               // movaps        0x15346(%rip),%xmm12        # 3ac80 <_sk_srcover_bgra_8888_sse2_lowp+0xd18>
  .byte  65,15,194,196,1                     // cmpltps       %xmm12,%xmm0
  .byte  68,15,84,232                        // andps         %xmm0,%xmm13
  .byte  65,15,85,198                        // andnps        %xmm14,%xmm0
  .byte  65,15,86,197                        // orps          %xmm13,%xmm0
  .byte  68,15,40,233                        // movaps        %xmm1,%xmm13
  .byte  69,15,89,232                        // mulps         %xmm8,%xmm13
  .byte  68,15,40,241                        // movaps        %xmm1,%xmm14
  .byte  69,15,89,246                        // mulps         %xmm14,%xmm14
  .byte  68,15,40,249                        // movaps        %xmm1,%xmm15
  .byte  69,15,89,249                        // mulps         %xmm9,%xmm15
  .byte  69,15,88,250                        // addps         %xmm10,%xmm15
  .byte  69,15,89,254                        // mulps         %xmm14,%xmm15
  .byte  69,15,88,251                        // addps         %xmm11,%xmm15
  .byte  65,15,194,204,1                     // cmpltps       %xmm12,%xmm1
  .byte  68,15,84,233                        // andps         %xmm1,%xmm13
  .byte  65,15,85,207                        // andnps        %xmm15,%xmm1
  .byte  65,15,86,205                        // orps          %xmm13,%xmm1
  .byte  68,15,89,194                        // mulps         %xmm2,%xmm8
  .byte  68,15,40,234                        // movaps        %xmm2,%xmm13
  .byte  69,15,89,237                        // mulps         %xmm13,%xmm13
  .byte  68,15,89,202                        // mulps         %xmm2,%xmm9
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  69,15,89,205                        // mulps         %xmm13,%xmm9
  .byte  69,15,88,203                        // addps         %xmm11,%xmm9
  .byte  65,15,194,212,1                     // cmpltps       %xmm12,%xmm2
  .byte  68,15,84,194                        // andps         %xmm2,%xmm8
  .byte  65,15,85,209                        // andnps        %xmm9,%xmm2
  .byte  65,15,86,208                        // orps          %xmm8,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_from_srgb_dst_sse2
.globl _sk_from_srgb_dst_sse2
FUNCTION(_sk_from_srgb_dst_sse2)
_sk_from_srgb_dst_sse2:
  .byte  68,15,40,5,151,82,1,0               // movaps        0x15297(%rip),%xmm8        # 3ac50 <_sk_srcover_bgra_8888_sse2_lowp+0xce8>
  .byte  68,15,40,236                        // movaps        %xmm4,%xmm13
  .byte  69,15,89,232                        // mulps         %xmm8,%xmm13
  .byte  68,15,40,220                        // movaps        %xmm4,%xmm11
  .byte  69,15,89,219                        // mulps         %xmm11,%xmm11
  .byte  68,15,40,13,255,81,1,0              // movaps        0x151ff(%rip),%xmm9        # 3abd0 <_sk_srcover_bgra_8888_sse2_lowp+0xc68>
  .byte  68,15,40,244                        // movaps        %xmm4,%xmm14
  .byte  69,15,89,241                        // mulps         %xmm9,%xmm14
  .byte  68,15,40,21,127,82,1,0              // movaps        0x1527f(%rip),%xmm10        # 3ac60 <_sk_srcover_bgra_8888_sse2_lowp+0xcf8>
  .byte  69,15,88,242                        // addps         %xmm10,%xmm14
  .byte  69,15,89,243                        // mulps         %xmm11,%xmm14
  .byte  68,15,40,29,127,82,1,0              // movaps        0x1527f(%rip),%xmm11        # 3ac70 <_sk_srcover_bgra_8888_sse2_lowp+0xd08>
  .byte  69,15,88,243                        // addps         %xmm11,%xmm14
  .byte  68,15,40,37,131,82,1,0              // movaps        0x15283(%rip),%xmm12        # 3ac80 <_sk_srcover_bgra_8888_sse2_lowp+0xd18>
  .byte  65,15,194,228,1                     // cmpltps       %xmm12,%xmm4
  .byte  68,15,84,236                        // andps         %xmm4,%xmm13
  .byte  65,15,85,230                        // andnps        %xmm14,%xmm4
  .byte  65,15,86,229                        // orps          %xmm13,%xmm4
  .byte  68,15,40,237                        // movaps        %xmm5,%xmm13
  .byte  69,15,89,232                        // mulps         %xmm8,%xmm13
  .byte  68,15,40,245                        // movaps        %xmm5,%xmm14
  .byte  69,15,89,246                        // mulps         %xmm14,%xmm14
  .byte  68,15,40,253                        // movaps        %xmm5,%xmm15
  .byte  69,15,89,249                        // mulps         %xmm9,%xmm15
  .byte  69,15,88,250                        // addps         %xmm10,%xmm15
  .byte  69,15,89,254                        // mulps         %xmm14,%xmm15
  .byte  69,15,88,251                        // addps         %xmm11,%xmm15
  .byte  65,15,194,236,1                     // cmpltps       %xmm12,%xmm5
  .byte  68,15,84,237                        // andps         %xmm5,%xmm13
  .byte  65,15,85,239                        // andnps        %xmm15,%xmm5
  .byte  65,15,86,237                        // orps          %xmm13,%xmm5
  .byte  68,15,89,198                        // mulps         %xmm6,%xmm8
  .byte  68,15,40,238                        // movaps        %xmm6,%xmm13
  .byte  69,15,89,237                        // mulps         %xmm13,%xmm13
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  69,15,89,205                        // mulps         %xmm13,%xmm9
  .byte  69,15,88,203                        // addps         %xmm11,%xmm9
  .byte  65,15,194,244,1                     // cmpltps       %xmm12,%xmm6
  .byte  68,15,84,198                        // andps         %xmm6,%xmm8
  .byte  65,15,85,241                        // andnps        %xmm9,%xmm6
  .byte  65,15,86,240                        // orps          %xmm8,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_to_srgb_sse2
.globl _sk_to_srgb_sse2
FUNCTION(_sk_to_srgb_sse2)
_sk_to_srgb_sse2:
  .byte  68,15,82,232                        // rsqrtps       %xmm0,%xmm13
  .byte  68,15,40,5,16,82,1,0                // movaps        0x15210(%rip),%xmm8        # 3ac90 <_sk_srcover_bgra_8888_sse2_lowp+0xd28>
  .byte  68,15,40,240                        // movaps        %xmm0,%xmm14
  .byte  69,15,89,240                        // mulps         %xmm8,%xmm14
  .byte  68,15,40,13,16,82,1,0               // movaps        0x15210(%rip),%xmm9        # 3aca0 <_sk_srcover_bgra_8888_sse2_lowp+0xd38>
  .byte  69,15,40,253                        // movaps        %xmm13,%xmm15
  .byte  69,15,89,249                        // mulps         %xmm9,%xmm15
  .byte  68,15,40,21,16,82,1,0               // movaps        0x15210(%rip),%xmm10        # 3acb0 <_sk_srcover_bgra_8888_sse2_lowp+0xd48>
  .byte  69,15,88,250                        // addps         %xmm10,%xmm15
  .byte  69,15,89,253                        // mulps         %xmm13,%xmm15
  .byte  68,15,40,29,16,82,1,0               // movaps        0x15210(%rip),%xmm11        # 3acc0 <_sk_srcover_bgra_8888_sse2_lowp+0xd58>
  .byte  69,15,88,251                        // addps         %xmm11,%xmm15
  .byte  68,15,40,37,20,82,1,0               // movaps        0x15214(%rip),%xmm12        # 3acd0 <_sk_srcover_bgra_8888_sse2_lowp+0xd68>
  .byte  69,15,88,236                        // addps         %xmm12,%xmm13
  .byte  69,15,83,237                        // rcpps         %xmm13,%xmm13
  .byte  69,15,89,239                        // mulps         %xmm15,%xmm13
  .byte  68,15,40,61,16,82,1,0               // movaps        0x15210(%rip),%xmm15        # 3ace0 <_sk_srcover_bgra_8888_sse2_lowp+0xd78>
  .byte  65,15,194,199,1                     // cmpltps       %xmm15,%xmm0
  .byte  68,15,84,240                        // andps         %xmm0,%xmm14
  .byte  65,15,85,197                        // andnps        %xmm13,%xmm0
  .byte  65,15,86,198                        // orps          %xmm14,%xmm0
  .byte  68,15,82,233                        // rsqrtps       %xmm1,%xmm13
  .byte  69,15,40,245                        // movaps        %xmm13,%xmm14
  .byte  69,15,89,241                        // mulps         %xmm9,%xmm14
  .byte  69,15,88,242                        // addps         %xmm10,%xmm14
  .byte  69,15,89,245                        // mulps         %xmm13,%xmm14
  .byte  69,15,88,243                        // addps         %xmm11,%xmm14
  .byte  69,15,88,236                        // addps         %xmm12,%xmm13
  .byte  69,15,83,237                        // rcpps         %xmm13,%xmm13
  .byte  69,15,89,238                        // mulps         %xmm14,%xmm13
  .byte  68,15,40,241                        // movaps        %xmm1,%xmm14
  .byte  69,15,89,240                        // mulps         %xmm8,%xmm14
  .byte  65,15,194,207,1                     // cmpltps       %xmm15,%xmm1
  .byte  68,15,84,241                        // andps         %xmm1,%xmm14
  .byte  65,15,85,205                        // andnps        %xmm13,%xmm1
  .byte  65,15,86,206                        // orps          %xmm14,%xmm1
  .byte  68,15,82,234                        // rsqrtps       %xmm2,%xmm13
  .byte  69,15,89,205                        // mulps         %xmm13,%xmm9
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  69,15,89,205                        // mulps         %xmm13,%xmm9
  .byte  69,15,88,203                        // addps         %xmm11,%xmm9
  .byte  69,15,88,236                        // addps         %xmm12,%xmm13
  .byte  69,15,83,213                        // rcpps         %xmm13,%xmm10
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  68,15,89,194                        // mulps         %xmm2,%xmm8
  .byte  65,15,194,215,1                     // cmpltps       %xmm15,%xmm2
  .byte  68,15,84,194                        // andps         %xmm2,%xmm8
  .byte  65,15,85,210                        // andnps        %xmm10,%xmm2
  .byte  65,15,86,208                        // orps          %xmm8,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_rgb_to_hsl_sse2
.globl _sk_rgb_to_hsl_sse2
FUNCTION(_sk_rgb_to_hsl_sse2)
_sk_rgb_to_hsl_sse2:
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  15,95,194                           // maxps         %xmm2,%xmm0
  .byte  69,15,40,208                        // movaps        %xmm8,%xmm10
  .byte  68,15,95,208                        // maxps         %xmm0,%xmm10
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  15,93,194                           // minps         %xmm2,%xmm0
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  68,15,93,216                        // minps         %xmm0,%xmm11
  .byte  65,15,40,202                        // movaps        %xmm10,%xmm1
  .byte  65,15,92,203                        // subps         %xmm11,%xmm1
  .byte  68,15,40,45,195,79,1,0              // movaps        0x14fc3(%rip),%xmm13        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,94,233                        // divps         %xmm1,%xmm13
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  65,15,194,192,0                     // cmpeqps       %xmm8,%xmm0
  .byte  69,15,40,225                        // movaps        %xmm9,%xmm12
  .byte  68,15,92,226                        // subps         %xmm2,%xmm12
  .byte  69,15,89,229                        // mulps         %xmm13,%xmm12
  .byte  69,15,40,241                        // movaps        %xmm9,%xmm14
  .byte  68,15,194,242,1                     // cmpltps       %xmm2,%xmm14
  .byte  68,15,84,53,57,81,1,0               // andps         0x15139(%rip),%xmm14        # 3acf0 <_sk_srcover_bgra_8888_sse2_lowp+0xd88>
  .byte  69,15,88,244                        // addps         %xmm12,%xmm14
  .byte  69,15,40,250                        // movaps        %xmm10,%xmm15
  .byte  69,15,194,249,0                     // cmpeqps       %xmm9,%xmm15
  .byte  65,15,92,208                        // subps         %xmm8,%xmm2
  .byte  65,15,89,213                        // mulps         %xmm13,%xmm2
  .byte  68,15,40,37,44,81,1,0               // movaps        0x1512c(%rip),%xmm12        # 3ad00 <_sk_srcover_bgra_8888_sse2_lowp+0xd98>
  .byte  65,15,88,212                        // addps         %xmm12,%xmm2
  .byte  69,15,92,193                        // subps         %xmm9,%xmm8
  .byte  69,15,89,197                        // mulps         %xmm13,%xmm8
  .byte  68,15,88,5,40,81,1,0                // addps         0x15128(%rip),%xmm8        # 3ad10 <_sk_srcover_bgra_8888_sse2_lowp+0xda8>
  .byte  65,15,84,215                        // andps         %xmm15,%xmm2
  .byte  69,15,85,248                        // andnps        %xmm8,%xmm15
  .byte  68,15,86,250                        // orps          %xmm2,%xmm15
  .byte  68,15,84,240                        // andps         %xmm0,%xmm14
  .byte  65,15,85,199                        // andnps        %xmm15,%xmm0
  .byte  65,15,86,198                        // orps          %xmm14,%xmm0
  .byte  15,89,5,25,81,1,0                   // mulps         0x15119(%rip),%xmm0        # 3ad20 <_sk_srcover_bgra_8888_sse2_lowp+0xdb8>
  .byte  69,15,40,194                        // movaps        %xmm10,%xmm8
  .byte  69,15,194,195,4                     // cmpneqps      %xmm11,%xmm8
  .byte  65,15,84,192                        // andps         %xmm8,%xmm0
  .byte  69,15,92,226                        // subps         %xmm10,%xmm12
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  68,15,40,13,28,79,1,0               // movaps        0x14f1c(%rip),%xmm9        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  68,15,194,202,1                     // cmpltps       %xmm2,%xmm9
  .byte  69,15,92,227                        // subps         %xmm11,%xmm12
  .byte  69,15,84,225                        // andps         %xmm9,%xmm12
  .byte  69,15,85,202                        // andnps        %xmm10,%xmm9
  .byte  69,15,86,204                        // orps          %xmm12,%xmm9
  .byte  65,15,94,201                        // divps         %xmm9,%xmm1
  .byte  65,15,84,200                        // andps         %xmm8,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hsl_to_rgb_sse2
.globl _sk_hsl_to_rgb_sse2
FUNCTION(_sk_hsl_to_rgb_sse2)
_sk_hsl_to_rgb_sse2:
  .byte  15,41,124,36,232                    // movaps        %xmm7,-0x18(%rsp)
  .byte  15,41,116,36,216                    // movaps        %xmm6,-0x28(%rsp)
  .byte  15,41,108,36,200                    // movaps        %xmm5,-0x38(%rsp)
  .byte  15,41,100,36,184                    // movaps        %xmm4,-0x48(%rsp)
  .byte  15,41,92,36,168                     // movaps        %xmm3,-0x58(%rsp)
  .byte  68,15,40,218                        // movaps        %xmm2,%xmm11
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  68,15,40,13,203,78,1,0              // movaps        0x14ecb(%rip),%xmm9        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  69,15,40,209                        // movaps        %xmm9,%xmm10
  .byte  69,15,194,211,2                     // cmpleps       %xmm11,%xmm10
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,194,217,0                        // cmpeqps       %xmm1,%xmm3
  .byte  15,40,251                           // movaps        %xmm3,%xmm7
  .byte  15,41,124,36,136                    // movaps        %xmm7,-0x78(%rsp)
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  65,15,84,194                        // andps         %xmm10,%xmm0
  .byte  68,15,85,209                        // andnps        %xmm1,%xmm10
  .byte  68,15,86,208                        // orps          %xmm0,%xmm10
  .byte  68,15,41,92,36,152                  // movaps        %xmm11,-0x68(%rsp)
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  69,15,88,219                        // addps         %xmm11,%xmm11
  .byte  69,15,92,218                        // subps         %xmm10,%xmm11
  .byte  15,40,5,116,80,1,0                  // movaps        0x15074(%rip),%xmm0        # 3ad30 <_sk_srcover_bgra_8888_sse2_lowp+0xdc8>
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  243,15,91,200                       // cvttps2dq     %xmm0,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  15,194,217,1                        // cmpltps       %xmm1,%xmm3
  .byte  15,84,29,124,78,1,0                 // andps         0x14e7c(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  68,15,40,45,94,80,1,0               // movaps        0x1505e(%rip),%xmm13        # 3ad40 <_sk_srcover_bgra_8888_sse2_lowp+0xdd8>
  .byte  69,15,40,197                        // movaps        %xmm13,%xmm8
  .byte  68,15,194,192,2                     // cmpleps       %xmm0,%xmm8
  .byte  69,15,40,242                        // movaps        %xmm10,%xmm14
  .byte  69,15,92,243                        // subps         %xmm11,%xmm14
  .byte  65,15,40,217                        // movaps        %xmm9,%xmm3
  .byte  15,194,216,2                        // cmpleps       %xmm0,%xmm3
  .byte  15,40,21,30,80,1,0                  // movaps        0x1501e(%rip),%xmm2        # 3ad20 <_sk_srcover_bgra_8888_sse2_lowp+0xdb8>
  .byte  68,15,40,250                        // movaps        %xmm2,%xmm15
  .byte  68,15,194,248,2                     // cmpleps       %xmm0,%xmm15
  .byte  15,40,13,222,79,1,0                 // movaps        0x14fde(%rip),%xmm1        # 3acf0 <_sk_srcover_bgra_8888_sse2_lowp+0xd88>
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,40,45,244,79,1,0                 // movaps        0x14ff4(%rip),%xmm5        # 3ad10 <_sk_srcover_bgra_8888_sse2_lowp+0xda8>
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  65,15,89,230                        // mulps         %xmm14,%xmm4
  .byte  65,15,88,227                        // addps         %xmm11,%xmm4
  .byte  69,15,40,227                        // movaps        %xmm11,%xmm12
  .byte  69,15,84,224                        // andps         %xmm8,%xmm12
  .byte  68,15,85,196                        // andnps        %xmm4,%xmm8
  .byte  69,15,86,196                        // orps          %xmm12,%xmm8
  .byte  68,15,84,195                        // andps         %xmm3,%xmm8
  .byte  65,15,85,218                        // andnps        %xmm10,%xmm3
  .byte  65,15,86,216                        // orps          %xmm8,%xmm3
  .byte  65,15,89,198                        // mulps         %xmm14,%xmm0
  .byte  65,15,88,195                        // addps         %xmm11,%xmm0
  .byte  65,15,84,223                        // andps         %xmm15,%xmm3
  .byte  68,15,85,248                        // andnps        %xmm0,%xmm15
  .byte  68,15,86,251                        // orps          %xmm3,%xmm15
  .byte  68,15,40,199                        // movaps        %xmm7,%xmm8
  .byte  69,15,85,199                        // andnps        %xmm15,%xmm8
  .byte  243,15,91,198                       // cvttps2dq     %xmm6,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,40,222                           // movaps        %xmm6,%xmm3
  .byte  15,194,216,1                        // cmpltps       %xmm0,%xmm3
  .byte  15,84,29,217,77,1,0                 // andps         0x14dd9(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,92,195                           // subps         %xmm3,%xmm0
  .byte  68,15,40,230                        // movaps        %xmm6,%xmm12
  .byte  68,15,92,224                        // subps         %xmm0,%xmm12
  .byte  69,15,40,253                        // movaps        %xmm13,%xmm15
  .byte  69,15,194,252,2                     // cmpleps       %xmm12,%xmm15
  .byte  65,15,40,225                        // movaps        %xmm9,%xmm4
  .byte  65,15,194,228,2                     // cmpleps       %xmm12,%xmm4
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  65,15,194,220,2                     // cmpleps       %xmm12,%xmm3
  .byte  68,15,89,225                        // mulps         %xmm1,%xmm12
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  65,15,92,196                        // subps         %xmm12,%xmm0
  .byte  65,15,89,198                        // mulps         %xmm14,%xmm0
  .byte  65,15,88,195                        // addps         %xmm11,%xmm0
  .byte  65,15,40,251                        // movaps        %xmm11,%xmm7
  .byte  65,15,84,255                        // andps         %xmm15,%xmm7
  .byte  68,15,85,248                        // andnps        %xmm0,%xmm15
  .byte  68,15,86,255                        // orps          %xmm7,%xmm15
  .byte  68,15,84,252                        // andps         %xmm4,%xmm15
  .byte  65,15,85,226                        // andnps        %xmm10,%xmm4
  .byte  65,15,86,231                        // orps          %xmm15,%xmm4
  .byte  69,15,89,230                        // mulps         %xmm14,%xmm12
  .byte  69,15,88,227                        // addps         %xmm11,%xmm12
  .byte  15,84,227                           // andps         %xmm3,%xmm4
  .byte  65,15,85,220                        // andnps        %xmm12,%xmm3
  .byte  15,86,220                           // orps          %xmm4,%xmm3
  .byte  15,40,124,36,136                    // movaps        -0x78(%rsp),%xmm7
  .byte  15,40,231                           // movaps        %xmm7,%xmm4
  .byte  15,85,227                           // andnps        %xmm3,%xmm4
  .byte  15,88,53,97,79,1,0                  // addps         0x14f61(%rip),%xmm6        # 3ad50 <_sk_srcover_bgra_8888_sse2_lowp+0xde8>
  .byte  243,15,91,198                       // cvttps2dq     %xmm6,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,40,222                           // movaps        %xmm6,%xmm3
  .byte  15,194,216,1                        // cmpltps       %xmm0,%xmm3
  .byte  15,84,29,76,77,1,0                  // andps         0x14d4c(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,92,195                           // subps         %xmm3,%xmm0
  .byte  15,92,240                           // subps         %xmm0,%xmm6
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  65,15,89,238                        // mulps         %xmm14,%xmm5
  .byte  65,15,89,206                        // mulps         %xmm14,%xmm1
  .byte  65,15,88,235                        // addps         %xmm11,%xmm5
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  68,15,194,238,2                     // cmpleps       %xmm6,%xmm13
  .byte  69,15,84,221                        // andps         %xmm13,%xmm11
  .byte  68,15,85,237                        // andnps        %xmm5,%xmm13
  .byte  69,15,86,235                        // orps          %xmm11,%xmm13
  .byte  68,15,194,206,2                     // cmpleps       %xmm6,%xmm9
  .byte  69,15,84,233                        // andps         %xmm9,%xmm13
  .byte  69,15,85,202                        // andnps        %xmm10,%xmm9
  .byte  69,15,86,205                        // orps          %xmm13,%xmm9
  .byte  15,194,214,2                        // cmpleps       %xmm6,%xmm2
  .byte  68,15,84,202                        // andps         %xmm2,%xmm9
  .byte  15,85,209                           // andnps        %xmm1,%xmm2
  .byte  65,15,86,209                        // orps          %xmm9,%xmm2
  .byte  15,40,68,36,152                     // movaps        -0x68(%rsp),%xmm0
  .byte  15,40,207                           // movaps        %xmm7,%xmm1
  .byte  15,84,193                           // andps         %xmm1,%xmm0
  .byte  15,85,202                           // andnps        %xmm2,%xmm1
  .byte  68,15,86,192                        // orps          %xmm0,%xmm8
  .byte  15,86,224                           // orps          %xmm0,%xmm4
  .byte  15,86,193                           // orps          %xmm1,%xmm0
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  15,40,92,36,168                     // movaps        -0x58(%rsp),%xmm3
  .byte  15,40,100,36,184                    // movaps        -0x48(%rsp),%xmm4
  .byte  15,40,108,36,200                    // movaps        -0x38(%rsp),%xmm5
  .byte  15,40,116,36,216                    // movaps        -0x28(%rsp),%xmm6
  .byte  15,40,124,36,232                    // movaps        -0x18(%rsp),%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_1_float_sse2
.globl _sk_scale_1_float_sse2
FUNCTION(_sk_scale_1_float_sse2)
_sk_scale_1_float_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_u8_sse2
.globl _sk_scale_u8_sse2
FUNCTION(_sk_scale_u8_sse2)
_sk_scale_u8_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,61                              // jne           25f05 <_sk_scale_u8_sse2+0x55>
  .byte  102,71,15,110,4,16                  // movd          (%r8,%r10,1),%xmm8
  .byte  102,68,15,96,192                    // punpcklbw     %xmm0,%xmm8
  .byte  102,68,15,97,192                    // punpcklwd     %xmm0,%xmm8
  .byte  102,68,15,219,5,31,77,1,0           // pand          0x14d1f(%rip),%xmm8        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  68,15,89,5,115,78,1,0               // mulps         0x14e73(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  68,15,89,195                        // mulps         %xmm3,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,216                        // movaps        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,61                              // je            25f4f <_sk_scale_u8_sse2+0x9f>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,23                              // je            25f34 <_sk_scale_u8_sse2+0x84>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,181                             // jne           25ed8 <_sk_scale_u8_sse2+0x28>
  .byte  67,15,182,68,16,2                   // movzbl        0x2(%r8,%r10,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,192,69                // pshufd        $0x45,%xmm8,%xmm8
  .byte  67,15,183,4,16                      // movzwl        (%r8,%r10,1),%eax
  .byte  102,68,15,110,200                   // movd          %eax,%xmm9
  .byte  102,68,15,96,200                    // punpcklbw     %xmm0,%xmm9
  .byte  102,68,15,97,200                    // punpcklwd     %xmm0,%xmm9
  .byte  242,69,15,16,193                    // movsd         %xmm9,%xmm8
  .byte  235,137                             // jmp           25ed8 <_sk_scale_u8_sse2+0x28>
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  233,122,255,255,255                 // jmpq          25ed8 <_sk_scale_u8_sse2+0x28>

HIDDEN _sk_scale_565_sse2
.globl _sk_scale_565_sse2
FUNCTION(_sk_scale_565_sse2)
_sk_scale_565_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,173,0,0,0                    // jne           2602a <_sk_scale_565_sse2+0xcc>
  .byte  243,71,15,126,20,80                 // movq          (%r8,%r10,2),%xmm10
  .byte  102,68,15,97,208                    // punpcklwd     %xmm0,%xmm10
  .byte  102,68,15,111,5,223,77,1,0          // movdqa        0x14ddf(%rip),%xmm8        # 3ad70 <_sk_srcover_bgra_8888_sse2_lowp+0xe08>
  .byte  102,69,15,219,194                   // pand          %xmm10,%xmm8
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  68,15,89,5,222,77,1,0               // mulps         0x14dde(%rip),%xmm8        # 3ad80 <_sk_srcover_bgra_8888_sse2_lowp+0xe18>
  .byte  102,68,15,111,13,229,77,1,0         // movdqa        0x14de5(%rip),%xmm9        # 3ad90 <_sk_srcover_bgra_8888_sse2_lowp+0xe28>
  .byte  102,69,15,219,202                   // pand          %xmm10,%xmm9
  .byte  69,15,91,201                        // cvtdq2ps      %xmm9,%xmm9
  .byte  68,15,89,13,228,77,1,0              // mulps         0x14de4(%rip),%xmm9        # 3ada0 <_sk_srcover_bgra_8888_sse2_lowp+0xe38>
  .byte  102,68,15,219,21,235,77,1,0         // pand          0x14deb(%rip),%xmm10        # 3adb0 <_sk_srcover_bgra_8888_sse2_lowp+0xe48>
  .byte  69,15,91,210                        // cvtdq2ps      %xmm10,%xmm10
  .byte  68,15,89,21,239,77,1,0              // mulps         0x14def(%rip),%xmm10        # 3adc0 <_sk_srcover_bgra_8888_sse2_lowp+0xe58>
  .byte  68,15,40,219                        // movaps        %xmm3,%xmm11
  .byte  68,15,194,223,1                     // cmpltps       %xmm7,%xmm11
  .byte  69,15,40,225                        // movaps        %xmm9,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,40,232                        // movaps        %xmm8,%xmm13
  .byte  69,15,93,236                        // minps         %xmm12,%xmm13
  .byte  69,15,40,225                        // movaps        %xmm9,%xmm12
  .byte  69,15,95,226                        // maxps         %xmm10,%xmm12
  .byte  69,15,40,240                        // movaps        %xmm8,%xmm14
  .byte  69,15,95,244                        // maxps         %xmm12,%xmm14
  .byte  69,15,84,235                        // andps         %xmm11,%xmm13
  .byte  69,15,85,222                        // andnps        %xmm14,%xmm11
  .byte  69,15,86,221                        // orps          %xmm13,%xmm11
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  68,15,89,219                        // mulps         %xmm3,%xmm11
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,40,219                        // movaps        %xmm11,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,60                              // je            26073 <_sk_scale_565_sse2+0x115>
  .byte  102,69,15,239,210                   // pxor          %xmm10,%xmm10
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,27                              // je            2605d <_sk_scale_565_sse2+0xff>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  15,133,60,255,255,255               // jne           25f88 <_sk_scale_565_sse2+0x2a>
  .byte  67,15,183,68,80,4                   // movzwl        0x4(%r8,%r10,2),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,208,69                // pshufd        $0x45,%xmm8,%xmm10
  .byte  102,71,15,110,4,80                  // movd          (%r8,%r10,2),%xmm8
  .byte  242,69,15,112,192,212               // pshuflw       $0xd4,%xmm8,%xmm8
  .byte  242,69,15,16,208                    // movsd         %xmm8,%xmm10
  .byte  233,21,255,255,255                  // jmpq          25f88 <_sk_scale_565_sse2+0x2a>
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  102,68,15,110,208                   // movd          %eax,%xmm10
  .byte  233,6,255,255,255                   // jmpq          25f88 <_sk_scale_565_sse2+0x2a>

HIDDEN _sk_lerp_1_float_sse2
.globl _sk_lerp_1_float_sse2
FUNCTION(_sk_lerp_1_float_sse2)
_sk_lerp_1_float_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  15,92,214                           // subps         %xmm6,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  15,92,223                           // subps         %xmm7,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lerp_u8_sse2
.globl _sk_lerp_u8_sse2
FUNCTION(_sk_lerp_u8_sse2)
_sk_lerp_u8_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,81                              // jne           26123 <_sk_lerp_u8_sse2+0x69>
  .byte  102,71,15,110,4,16                  // movd          (%r8,%r10,1),%xmm8
  .byte  102,68,15,96,192                    // punpcklbw     %xmm0,%xmm8
  .byte  102,68,15,97,192                    // punpcklwd     %xmm0,%xmm8
  .byte  102,68,15,219,5,21,75,1,0           // pand          0x14b15(%rip),%xmm8        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  68,15,89,5,105,76,1,0               // mulps         0x14c69(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  15,92,214                           // subps         %xmm6,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  15,92,223                           // subps         %xmm7,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,64                              // je            26170 <_sk_lerp_u8_sse2+0xb6>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,23                              // je            26152 <_sk_lerp_u8_sse2+0x98>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,161                             // jne           260e2 <_sk_lerp_u8_sse2+0x28>
  .byte  67,15,182,68,16,2                   // movzbl        0x2(%r8,%r10,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,192,69                // pshufd        $0x45,%xmm8,%xmm8
  .byte  67,15,183,4,16                      // movzwl        (%r8,%r10,1),%eax
  .byte  102,68,15,110,200                   // movd          %eax,%xmm9
  .byte  102,68,15,96,200                    // punpcklbw     %xmm0,%xmm9
  .byte  102,68,15,97,200                    // punpcklwd     %xmm0,%xmm9
  .byte  242,69,15,16,193                    // movsd         %xmm9,%xmm8
  .byte  233,114,255,255,255                 // jmpq          260e2 <_sk_lerp_u8_sse2+0x28>
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  233,99,255,255,255                  // jmpq          260e2 <_sk_lerp_u8_sse2+0x28>

HIDDEN _sk_lerp_565_sse2
.globl _sk_lerp_565_sse2
FUNCTION(_sk_lerp_565_sse2)
_sk_lerp_565_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,173,0,0,0                    // jne           2624b <_sk_lerp_565_sse2+0xcc>
  .byte  243,71,15,126,4,80                  // movq          (%r8,%r10,2),%xmm8
  .byte  102,68,15,97,192                    // punpcklwd     %xmm0,%xmm8
  .byte  102,68,15,111,13,190,75,1,0         // movdqa        0x14bbe(%rip),%xmm9        # 3ad70 <_sk_srcover_bgra_8888_sse2_lowp+0xe08>
  .byte  102,69,15,219,200                   // pand          %xmm8,%xmm9
  .byte  69,15,91,201                        // cvtdq2ps      %xmm9,%xmm9
  .byte  68,15,89,13,189,75,1,0              // mulps         0x14bbd(%rip),%xmm9        # 3ad80 <_sk_srcover_bgra_8888_sse2_lowp+0xe18>
  .byte  102,68,15,111,21,196,75,1,0         // movdqa        0x14bc4(%rip),%xmm10        # 3ad90 <_sk_srcover_bgra_8888_sse2_lowp+0xe28>
  .byte  102,69,15,219,208                   // pand          %xmm8,%xmm10
  .byte  69,15,91,218                        // cvtdq2ps      %xmm10,%xmm11
  .byte  68,15,89,29,195,75,1,0              // mulps         0x14bc3(%rip),%xmm11        # 3ada0 <_sk_srcover_bgra_8888_sse2_lowp+0xe38>
  .byte  102,68,15,219,5,202,75,1,0          // pand          0x14bca(%rip),%xmm8        # 3adb0 <_sk_srcover_bgra_8888_sse2_lowp+0xe48>
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  68,15,89,5,206,75,1,0               // mulps         0x14bce(%rip),%xmm8        # 3adc0 <_sk_srcover_bgra_8888_sse2_lowp+0xe58>
  .byte  68,15,40,211                        // movaps        %xmm3,%xmm10
  .byte  68,15,194,215,1                     // cmpltps       %xmm7,%xmm10
  .byte  69,15,40,227                        // movaps        %xmm11,%xmm12
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  69,15,93,216                        // minps         %xmm8,%xmm11
  .byte  69,15,40,233                        // movaps        %xmm9,%xmm13
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  69,15,93,203                        // minps         %xmm11,%xmm9
  .byte  69,15,95,224                        // maxps         %xmm8,%xmm12
  .byte  69,15,95,236                        // maxps         %xmm12,%xmm13
  .byte  69,15,84,202                        // andps         %xmm10,%xmm9
  .byte  69,15,85,213                        // andnps        %xmm13,%xmm10
  .byte  69,15,86,209                        // orps          %xmm9,%xmm10
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  15,92,214                           // subps         %xmm6,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  15,92,223                           // subps         %xmm7,%xmm3
  .byte  65,15,89,218                        // mulps         %xmm10,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,60                              // je            26294 <_sk_lerp_565_sse2+0x115>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,27                              // je            2627e <_sk_lerp_565_sse2+0xff>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  15,133,60,255,255,255               // jne           261a9 <_sk_lerp_565_sse2+0x2a>
  .byte  67,15,183,68,80,4                   // movzwl        0x4(%r8,%r10,2),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,192,69                // pshufd        $0x45,%xmm8,%xmm8
  .byte  102,71,15,110,12,80                 // movd          (%r8,%r10,2),%xmm9
  .byte  242,69,15,112,201,212               // pshuflw       $0xd4,%xmm9,%xmm9
  .byte  242,69,15,16,193                    // movsd         %xmm9,%xmm8
  .byte  233,21,255,255,255                  // jmpq          261a9 <_sk_lerp_565_sse2+0x2a>
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  233,6,255,255,255                   // jmpq          261a9 <_sk_lerp_565_sse2+0x2a>

HIDDEN _sk_load_tables_sse2
.globl _sk_load_tables_sse2
FUNCTION(_sk_load_tables_sse2)
_sk_load_tables_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,34,1,0,0                     // jne           263d3 <_sk_load_tables_sse2+0x130>
  .byte  243,69,15,111,12,144                // movdqu        (%r8,%rdx,4),%xmm9
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  102,68,15,111,5,61,73,1,0           // movdqa        0x1493d(%rip),%xmm8        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,65,15,219,192                   // pand          %xmm8,%xmm0
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,73,15,126,200                   // movq          %xmm1,%r8
  .byte  102,73,15,126,193                   // movq          %xmm0,%r9
  .byte  69,15,182,209                       // movzbl        %r9b,%r10d
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  69,15,182,216                       // movzbl        %r8b,%r11d
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  72,139,88,8                         // mov           0x8(%rax),%rbx
  .byte  76,139,112,16                       // mov           0x10(%rax),%r14
  .byte  243,66,15,16,12,11                  // movss         (%rbx,%r9,1),%xmm1
  .byte  243,66,15,16,4,147                  // movss         (%rbx,%r10,4),%xmm0
  .byte  15,20,193                           // unpcklps      %xmm1,%xmm0
  .byte  243,66,15,16,12,3                   // movss         (%rbx,%r8,1),%xmm1
  .byte  243,66,15,16,20,155                 // movss         (%rbx,%r11,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  102,15,20,194                       // unpcklpd      %xmm2,%xmm0
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  102,15,114,209,8                    // psrld         $0x8,%xmm1
  .byte  102,65,15,219,200                   // pand          %xmm8,%xmm1
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,73,15,126,208                   // movq          %xmm2,%r8
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  68,15,182,203                       // movzbl        %bl,%r9d
  .byte  72,193,235,30                       // shr           $0x1e,%rbx
  .byte  69,15,182,208                       // movzbl        %r8b,%r10d
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  243,65,15,16,20,30                  // movss         (%r14,%rbx,1),%xmm2
  .byte  243,67,15,16,12,142                 // movss         (%r14,%r9,4),%xmm1
  .byte  15,20,202                           // unpcklps      %xmm2,%xmm1
  .byte  243,67,15,16,20,6                   // movss         (%r14,%r8,1),%xmm2
  .byte  243,67,15,16,28,150                 // movss         (%r14,%r10,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  102,15,20,203                       // unpcklpd      %xmm3,%xmm1
  .byte  76,139,64,24                        // mov           0x18(%rax),%r8
  .byte  102,65,15,111,209                   // movdqa        %xmm9,%xmm2
  .byte  102,15,114,210,16                   // psrld         $0x10,%xmm2
  .byte  102,65,15,219,208                   // pand          %xmm8,%xmm2
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,72,15,126,219                   // movq          %xmm3,%rbx
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  68,15,182,200                       // movzbl        %al,%r9d
  .byte  72,193,232,30                       // shr           $0x1e,%rax
  .byte  68,15,182,211                       // movzbl        %bl,%r10d
  .byte  72,193,235,30                       // shr           $0x1e,%rbx
  .byte  243,65,15,16,28,0                   // movss         (%r8,%rax,1),%xmm3
  .byte  243,67,15,16,20,136                 // movss         (%r8,%r9,4),%xmm2
  .byte  15,20,211                           // unpcklps      %xmm3,%xmm2
  .byte  243,69,15,16,4,24                   // movss         (%r8,%rbx,1),%xmm8
  .byte  243,67,15,16,28,144                 // movss         (%r8,%r10,4),%xmm3
  .byte  65,15,20,216                        // unpcklps      %xmm8,%xmm3
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  102,65,15,114,209,24                // psrld         $0x18,%xmm9
  .byte  65,15,91,217                        // cvtdq2ps      %xmm9,%xmm3
  .byte  15,89,29,148,73,1,0                 // mulps         0x14994(%rip),%xmm3        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,45                              // je            2640d <_sk_load_tables_sse2+0x16a>
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,23                              // je            26402 <_sk_load_tables_sse2+0x15f>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  15,133,194,254,255,255              // jne           262b7 <_sk_load_tables_sse2+0x14>
  .byte  102,65,15,110,68,144,8              // movd          0x8(%r8,%rdx,4),%xmm0
  .byte  102,68,15,112,200,69                // pshufd        $0x45,%xmm0,%xmm9
  .byte  102,69,15,18,12,144                 // movlpd        (%r8,%rdx,4),%xmm9
  .byte  233,170,254,255,255                 // jmpq          262b7 <_sk_load_tables_sse2+0x14>
  .byte  102,69,15,110,12,144                // movd          (%r8,%rdx,4),%xmm9
  .byte  233,159,254,255,255                 // jmpq          262b7 <_sk_load_tables_sse2+0x14>

HIDDEN _sk_load_tables_u16_be_sse2
.globl _sk_load_tables_u16_be_sse2
FUNCTION(_sk_load_tables_u16_be_sse2)
_sk_load_tables_u16_be_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  76,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,93,1,0,0                     // jne           2658b <_sk_load_tables_u16_be_sse2+0x173>
  .byte  102,67,15,16,4,72                   // movupd        (%r8,%r9,2),%xmm0
  .byte  243,67,15,111,76,72,16              // movdqu        0x10(%r8,%r9,2),%xmm1
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  102,68,15,40,200                    // movapd        %xmm0,%xmm9
  .byte  102,68,15,97,201                    // punpcklwd     %xmm1,%xmm9
  .byte  102,15,105,193                      // punpckhwd     %xmm1,%xmm0
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  102,68,15,105,200                   // punpckhwd     %xmm0,%xmm9
  .byte  102,15,111,21,110,73,1,0            // movdqa        0x1496e(%rip),%xmm2        # 3add0 <_sk_srcover_bgra_8888_sse2_lowp+0xe68>
  .byte  102,15,112,217,238                  // pshufd        $0xee,%xmm1,%xmm3
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,65,15,97,200                    // punpcklwd     %xmm8,%xmm1
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,73,15,126,192                   // movq          %xmm0,%r8
  .byte  102,73,15,126,201                   // movq          %xmm1,%r9
  .byte  69,15,182,209                       // movzbl        %r9b,%r10d
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  69,15,182,216                       // movzbl        %r8b,%r11d
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  72,139,88,8                         // mov           0x8(%rax),%rbx
  .byte  76,139,112,16                       // mov           0x10(%rax),%r14
  .byte  243,66,15,16,12,11                  // movss         (%rbx,%r9,1),%xmm1
  .byte  243,66,15,16,4,147                  // movss         (%rbx,%r10,4),%xmm0
  .byte  15,20,193                           // unpcklps      %xmm1,%xmm0
  .byte  243,70,15,16,20,3                   // movss         (%rbx,%r8,1),%xmm10
  .byte  243,66,15,16,12,155                 // movss         (%rbx,%r11,4),%xmm1
  .byte  65,15,20,202                        // unpcklps      %xmm10,%xmm1
  .byte  102,15,20,193                       // unpcklpd      %xmm1,%xmm0
  .byte  102,15,219,218                      // pand          %xmm2,%xmm3
  .byte  102,65,15,97,216                    // punpcklwd     %xmm8,%xmm3
  .byte  102,15,112,203,78                   // pshufd        $0x4e,%xmm3,%xmm1
  .byte  102,73,15,126,200                   // movq          %xmm1,%r8
  .byte  102,72,15,126,219                   // movq          %xmm3,%rbx
  .byte  68,15,182,203                       // movzbl        %bl,%r9d
  .byte  72,193,235,30                       // shr           $0x1e,%rbx
  .byte  69,15,182,208                       // movzbl        %r8b,%r10d
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  243,65,15,16,28,30                  // movss         (%r14,%rbx,1),%xmm3
  .byte  243,67,15,16,12,142                 // movss         (%r14,%r9,4),%xmm1
  .byte  15,20,203                           // unpcklps      %xmm3,%xmm1
  .byte  243,71,15,16,20,6                   // movss         (%r14,%r8,1),%xmm10
  .byte  243,67,15,16,28,150                 // movss         (%r14,%r10,4),%xmm3
  .byte  65,15,20,218                        // unpcklps      %xmm10,%xmm3
  .byte  102,15,20,203                       // unpcklpd      %xmm3,%xmm1
  .byte  76,139,64,24                        // mov           0x18(%rax),%r8
  .byte  102,65,15,219,209                   // pand          %xmm9,%xmm2
  .byte  102,65,15,97,208                    // punpcklwd     %xmm8,%xmm2
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,72,15,126,219                   // movq          %xmm3,%rbx
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  68,15,182,200                       // movzbl        %al,%r9d
  .byte  72,193,232,30                       // shr           $0x1e,%rax
  .byte  68,15,182,211                       // movzbl        %bl,%r10d
  .byte  72,193,235,30                       // shr           $0x1e,%rbx
  .byte  243,65,15,16,28,0                   // movss         (%r8,%rax,1),%xmm3
  .byte  243,67,15,16,20,136                 // movss         (%r8,%r9,4),%xmm2
  .byte  15,20,211                           // unpcklps      %xmm3,%xmm2
  .byte  243,69,15,16,20,24                  // movss         (%r8,%rbx,1),%xmm10
  .byte  243,67,15,16,28,144                 // movss         (%r8,%r10,4),%xmm3
  .byte  65,15,20,218                        // unpcklps      %xmm10,%xmm3
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  102,65,15,112,217,78                // pshufd        $0x4e,%xmm9,%xmm3
  .byte  102,68,15,111,203                   // movdqa        %xmm3,%xmm9
  .byte  102,65,15,113,241,8                 // psllw         $0x8,%xmm9
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,65,15,235,217                   // por           %xmm9,%xmm3
  .byte  102,65,15,97,216                    // punpcklwd     %xmm8,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,29,108,72,1,0                 // mulps         0x1486c(%rip),%xmm3        # 3adf0 <_sk_srcover_bgra_8888_sse2_lowp+0xe88>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  255,224                             // jmpq          *%rax
  .byte  242,67,15,16,4,72                   // movsd         (%r8,%r9,2),%xmm0
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,13                              // jne           265a4 <_sk_load_tables_u16_be_sse2+0x18c>
  .byte  243,15,126,192                      // movq          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  233,151,254,255,255                 // jmpq          2643b <_sk_load_tables_u16_be_sse2+0x23>
  .byte  102,67,15,22,68,72,8                // movhpd        0x8(%r8,%r9,2),%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  15,130,130,254,255,255              // jb            2643b <_sk_load_tables_u16_be_sse2+0x23>
  .byte  243,67,15,126,76,72,16              // movq          0x10(%r8,%r9,2),%xmm1
  .byte  233,118,254,255,255                 // jmpq          2643b <_sk_load_tables_u16_be_sse2+0x23>

HIDDEN _sk_load_tables_rgb_u16_be_sse2
.globl _sk_load_tables_rgb_u16_be_sse2
FUNCTION(_sk_load_tables_rgb_u16_be_sse2)
_sk_load_tables_rgb_u16_be_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  76,141,12,82                        // lea           (%rdx,%rdx,2),%r9
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,81,1,0,0                     // jne           26728 <_sk_load_tables_rgb_u16_be_sse2+0x163>
  .byte  243,67,15,111,20,72                 // movdqu        (%r8,%r9,2),%xmm2
  .byte  243,67,15,111,76,72,8               // movdqu        0x8(%r8,%r9,2),%xmm1
  .byte  102,15,115,217,4                    // psrldq        $0x4,%xmm1
  .byte  102,68,15,111,210                   // movdqa        %xmm2,%xmm10
  .byte  102,65,15,115,218,6                 // psrldq        $0x6,%xmm10
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,115,216,6                    // psrldq        $0x6,%xmm0
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  102,68,15,97,208                    // punpcklwd     %xmm0,%xmm10
  .byte  102,15,97,209                       // punpcklwd     %xmm1,%xmm2
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,65,15,97,194                    // punpcklwd     %xmm10,%xmm0
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,68,15,111,5,176,71,1,0          // movdqa        0x147b0(%rip),%xmm8        # 3add0 <_sk_srcover_bgra_8888_sse2_lowp+0xe68>
  .byte  102,65,15,219,192                   // pand          %xmm8,%xmm0
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  102,65,15,97,193                    // punpcklwd     %xmm9,%xmm0
  .byte  102,15,112,216,78                   // pshufd        $0x4e,%xmm0,%xmm3
  .byte  102,73,15,126,216                   // movq          %xmm3,%r8
  .byte  102,73,15,126,193                   // movq          %xmm0,%r9
  .byte  69,15,182,209                       // movzbl        %r9b,%r10d
  .byte  73,193,233,30                       // shr           $0x1e,%r9
  .byte  69,15,182,216                       // movzbl        %r8b,%r11d
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  72,139,88,8                         // mov           0x8(%rax),%rbx
  .byte  76,139,112,16                       // mov           0x10(%rax),%r14
  .byte  243,66,15,16,28,11                  // movss         (%rbx,%r9,1),%xmm3
  .byte  243,66,15,16,4,147                  // movss         (%rbx,%r10,4),%xmm0
  .byte  15,20,195                           // unpcklps      %xmm3,%xmm0
  .byte  243,70,15,16,28,3                   // movss         (%rbx,%r8,1),%xmm11
  .byte  243,66,15,16,28,155                 // movss         (%rbx,%r11,4),%xmm3
  .byte  65,15,20,219                        // unpcklps      %xmm11,%xmm3
  .byte  102,15,20,195                       // unpcklpd      %xmm3,%xmm0
  .byte  102,65,15,219,200                   // pand          %xmm8,%xmm1
  .byte  102,65,15,97,201                    // punpcklwd     %xmm9,%xmm1
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,73,15,126,216                   // movq          %xmm3,%r8
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  68,15,182,203                       // movzbl        %bl,%r9d
  .byte  72,193,235,30                       // shr           $0x1e,%rbx
  .byte  69,15,182,208                       // movzbl        %r8b,%r10d
  .byte  73,193,232,30                       // shr           $0x1e,%r8
  .byte  243,65,15,16,28,30                  // movss         (%r14,%rbx,1),%xmm3
  .byte  243,67,15,16,12,142                 // movss         (%r14,%r9,4),%xmm1
  .byte  15,20,203                           // unpcklps      %xmm3,%xmm1
  .byte  243,71,15,16,28,6                   // movss         (%r14,%r8,1),%xmm11
  .byte  243,67,15,16,28,150                 // movss         (%r14,%r10,4),%xmm3
  .byte  65,15,20,219                        // unpcklps      %xmm11,%xmm3
  .byte  102,15,20,203                       // unpcklpd      %xmm3,%xmm1
  .byte  76,139,64,24                        // mov           0x18(%rax),%r8
  .byte  102,65,15,105,210                   // punpckhwd     %xmm10,%xmm2
  .byte  102,65,15,219,208                   // pand          %xmm8,%xmm2
  .byte  102,65,15,97,209                    // punpcklwd     %xmm9,%xmm2
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,72,15,126,219                   // movq          %xmm3,%rbx
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  68,15,182,200                       // movzbl        %al,%r9d
  .byte  72,193,232,30                       // shr           $0x1e,%rax
  .byte  68,15,182,211                       // movzbl        %bl,%r10d
  .byte  72,193,235,30                       // shr           $0x1e,%rbx
  .byte  243,65,15,16,28,0                   // movss         (%r8,%rax,1),%xmm3
  .byte  243,67,15,16,20,136                 // movss         (%r8,%r9,4),%xmm2
  .byte  15,20,211                           // unpcklps      %xmm3,%xmm2
  .byte  243,69,15,16,4,24                   // movss         (%r8,%rbx,1),%xmm8
  .byte  243,67,15,16,28,144                 // movss         (%r8,%r10,4),%xmm3
  .byte  65,15,20,216                        // unpcklps      %xmm8,%xmm3
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,45,68,1,0                  // movaps        0x1442d(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  255,224                             // jmpq          *%rax
  .byte  102,67,15,110,20,72                 // movd          (%r8,%r9,2),%xmm2
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,67,15,196,84,72,4,2             // pinsrw        $0x2,0x4(%r8,%r9,2),%xmm2
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,14                              // jne           2674e <_sk_load_tables_rgb_u16_be_sse2+0x189>
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,69,15,239,210                   // pxor          %xmm10,%xmm10
  .byte  233,175,254,255,255                 // jmpq          265fd <_sk_load_tables_rgb_u16_be_sse2+0x38>
  .byte  102,71,15,110,84,72,6               // movd          0x6(%r8,%r9,2),%xmm10
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,71,15,196,84,72,10,2            // pinsrw        $0x2,0xa(%r8,%r9,2),%xmm10
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,24                              // jb            2677f <_sk_load_tables_rgb_u16_be_sse2+0x1ba>
  .byte  102,67,15,110,76,72,12              // movd          0xc(%r8,%r9,2),%xmm1
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,67,15,196,76,72,16,2            // pinsrw        $0x2,0x10(%r8,%r9,2),%xmm1
  .byte  233,126,254,255,255                 // jmpq          265fd <_sk_load_tables_rgb_u16_be_sse2+0x38>
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  233,117,254,255,255                 // jmpq          265fd <_sk_load_tables_rgb_u16_be_sse2+0x38>

HIDDEN _sk_byte_tables_sse2
.globl _sk_byte_tables_sse2
FUNCTION(_sk_byte_tables_sse2)
_sk_byte_tables_sse2:
  .byte  85                                  // push          %rbp
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  68,15,95,216                        // maxps         %xmm0,%xmm11
  .byte  68,15,40,13,173,67,1,0              // movaps        0x143ad(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,217                        // minps         %xmm9,%xmm11
  .byte  68,15,40,21,129,68,1,0              // movaps        0x14481(%rip),%xmm10        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  69,15,89,218                        // mulps         %xmm10,%xmm11
  .byte  102,65,15,91,195                    // cvtps2dq      %xmm11,%xmm0
  .byte  102,73,15,126,192                   // movq          %xmm0,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  77,137,194                          // mov           %r8,%r10
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,15,112,192,78                   // pshufd        $0x4e,%xmm0,%xmm0
  .byte  102,73,15,126,192                   // movq          %xmm0,%r8
  .byte  69,137,195                          // mov           %r8d,%r11d
  .byte  77,137,198                          // mov           %r8,%r14
  .byte  73,193,238,32                       // shr           $0x20,%r14
  .byte  72,139,24                           // mov           (%rax),%rbx
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  70,15,182,28,27                     // movzbl        (%rbx,%r11,1),%r11d
  .byte  66,15,182,44,51                     // movzbl        (%rbx,%r14,1),%ebp
  .byte  193,229,8                           // shl           $0x8,%ebp
  .byte  68,9,221                            // or            %r11d,%ebp
  .byte  70,15,182,12,11                     // movzbl        (%rbx,%r9,1),%r9d
  .byte  66,15,182,28,19                     // movzbl        (%rbx,%r10,1),%ebx
  .byte  193,227,8                           // shl           $0x8,%ebx
  .byte  68,9,203                            // or            %r9d,%ebx
  .byte  102,15,110,195                      // movd          %ebx,%xmm0
  .byte  102,15,196,197,1                    // pinsrw        $0x1,%ebp,%xmm0
  .byte  102,65,15,96,192                    // punpcklbw     %xmm8,%xmm0
  .byte  102,65,15,97,192                    // punpcklwd     %xmm8,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  68,15,40,29,64,69,1,0               // movaps        0x14540(%rip),%xmm11        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,195                        // mulps         %xmm11,%xmm0
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,225                        // minps         %xmm9,%xmm12
  .byte  69,15,89,226                        // mulps         %xmm10,%xmm12
  .byte  102,65,15,91,204                    // cvtps2dq      %xmm12,%xmm1
  .byte  102,72,15,126,205                   // movq          %xmm1,%rbp
  .byte  65,137,233                          // mov           %ebp,%r9d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  102,15,112,201,78                   // pshufd        $0x4e,%xmm1,%xmm1
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  65,137,218                          // mov           %ebx,%r10d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  65,15,182,28,24                     // movzbl        (%r8,%rbx,1),%ebx
  .byte  193,227,8                           // shl           $0x8,%ebx
  .byte  68,9,211                            // or            %r10d,%ebx
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  65,15,182,44,40                     // movzbl        (%r8,%rbp,1),%ebp
  .byte  193,229,8                           // shl           $0x8,%ebp
  .byte  68,9,205                            // or            %r9d,%ebp
  .byte  102,15,110,205                      // movd          %ebp,%xmm1
  .byte  102,15,196,203,1                    // pinsrw        $0x1,%ebx,%xmm1
  .byte  102,65,15,96,200                    // punpcklbw     %xmm8,%xmm1
  .byte  102,65,15,97,200                    // punpcklwd     %xmm8,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,226                        // maxps         %xmm2,%xmm12
  .byte  69,15,93,225                        // minps         %xmm9,%xmm12
  .byte  69,15,89,226                        // mulps         %xmm10,%xmm12
  .byte  102,65,15,91,212                    // cvtps2dq      %xmm12,%xmm2
  .byte  102,72,15,126,211                   // movq          %xmm2,%rbx
  .byte  65,137,216                          // mov           %ebx,%r8d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,15,112,210,78                   // pshufd        $0x4e,%xmm2,%xmm2
  .byte  102,72,15,126,213                   // movq          %xmm2,%rbp
  .byte  65,137,234                          // mov           %ebp,%r10d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  71,15,182,20,17                     // movzbl        (%r9,%r10,1),%r10d
  .byte  65,15,182,44,41                     // movzbl        (%r9,%rbp,1),%ebp
  .byte  193,229,8                           // shl           $0x8,%ebp
  .byte  68,9,213                            // or            %r10d,%ebp
  .byte  71,15,182,4,1                       // movzbl        (%r9,%r8,1),%r8d
  .byte  65,15,182,28,25                     // movzbl        (%r9,%rbx,1),%ebx
  .byte  193,227,8                           // shl           $0x8,%ebx
  .byte  68,9,195                            // or            %r8d,%ebx
  .byte  102,15,110,211                      // movd          %ebx,%xmm2
  .byte  102,15,196,213,1                    // pinsrw        $0x1,%ebp,%xmm2
  .byte  102,65,15,96,208                    // punpcklbw     %xmm8,%xmm2
  .byte  102,65,15,97,208                    // punpcklwd     %xmm8,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  65,15,89,211                        // mulps         %xmm11,%xmm2
  .byte  72,139,64,24                        // mov           0x18(%rax),%rax
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,227                        // maxps         %xmm3,%xmm12
  .byte  69,15,93,225                        // minps         %xmm9,%xmm12
  .byte  69,15,89,226                        // mulps         %xmm10,%xmm12
  .byte  102,65,15,91,220                    // cvtps2dq      %xmm12,%xmm3
  .byte  102,72,15,126,221                   // movq          %xmm3,%rbp
  .byte  65,137,232                          // mov           %ebp,%r8d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  102,15,112,219,78                   // pshufd        $0x4e,%xmm3,%xmm3
  .byte  102,72,15,126,219                   // movq          %xmm3,%rbx
  .byte  65,137,217                          // mov           %ebx,%r9d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  70,15,182,12,8                      // movzbl        (%rax,%r9,1),%r9d
  .byte  15,182,28,24                        // movzbl        (%rax,%rbx,1),%ebx
  .byte  193,227,8                           // shl           $0x8,%ebx
  .byte  68,9,203                            // or            %r9d,%ebx
  .byte  70,15,182,4,0                       // movzbl        (%rax,%r8,1),%r8d
  .byte  15,182,4,40                         // movzbl        (%rax,%rbp,1),%eax
  .byte  193,224,8                           // shl           $0x8,%eax
  .byte  68,9,192                            // or            %r8d,%eax
  .byte  102,15,110,216                      // movd          %eax,%xmm3
  .byte  102,15,196,219,1                    // pinsrw        $0x1,%ebx,%xmm3
  .byte  102,65,15,96,216                    // punpcklbw     %xmm8,%xmm3
  .byte  102,65,15,97,216                    // punpcklwd     %xmm8,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  65,15,89,219                        // mulps         %xmm11,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_byte_tables_rgb_sse2
.globl _sk_byte_tables_rgb_sse2
FUNCTION(_sk_byte_tables_rgb_sse2)
_sk_byte_tables_rgb_sse2:
  .byte  85                                  // push          %rbp
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,24                        // mov           0x18(%rax),%r8d
  .byte  65,255,200                          // dec           %r8d
  .byte  102,69,15,110,192                   // movd          %r8d,%xmm8
  .byte  102,69,15,112,192,0                 // pshufd        $0x0,%xmm8,%xmm8
  .byte  69,15,91,200                        // cvtdq2ps      %xmm8,%xmm9
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  69,15,87,219                        // xorps         %xmm11,%xmm11
  .byte  68,15,95,216                        // maxps         %xmm0,%xmm11
  .byte  68,15,40,21,169,65,1,0              // movaps        0x141a9(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,218                        // minps         %xmm10,%xmm11
  .byte  69,15,89,217                        // mulps         %xmm9,%xmm11
  .byte  102,65,15,91,195                    // cvtps2dq      %xmm11,%xmm0
  .byte  102,73,15,126,192                   // movq          %xmm0,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  77,137,194                          // mov           %r8,%r10
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,15,112,192,78                   // pshufd        $0x4e,%xmm0,%xmm0
  .byte  102,73,15,126,192                   // movq          %xmm0,%r8
  .byte  69,137,195                          // mov           %r8d,%r11d
  .byte  77,137,198                          // mov           %r8,%r14
  .byte  73,193,238,32                       // shr           $0x20,%r14
  .byte  72,139,24                           // mov           (%rax),%rbx
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  70,15,182,28,27                     // movzbl        (%rbx,%r11,1),%r11d
  .byte  66,15,182,44,51                     // movzbl        (%rbx,%r14,1),%ebp
  .byte  193,229,8                           // shl           $0x8,%ebp
  .byte  68,9,221                            // or            %r11d,%ebp
  .byte  70,15,182,12,11                     // movzbl        (%rbx,%r9,1),%r9d
  .byte  66,15,182,28,19                     // movzbl        (%rbx,%r10,1),%ebx
  .byte  193,227,8                           // shl           $0x8,%ebx
  .byte  68,9,203                            // or            %r9d,%ebx
  .byte  102,15,110,195                      // movd          %ebx,%xmm0
  .byte  102,15,196,197,1                    // pinsrw        $0x1,%ebp,%xmm0
  .byte  102,65,15,96,192                    // punpcklbw     %xmm8,%xmm0
  .byte  102,65,15,97,192                    // punpcklwd     %xmm8,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  68,15,40,29,68,67,1,0               // movaps        0x14344(%rip),%xmm11        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,195                        // mulps         %xmm11,%xmm0
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,89,225                        // mulps         %xmm9,%xmm12
  .byte  102,65,15,91,204                    // cvtps2dq      %xmm12,%xmm1
  .byte  102,72,15,126,205                   // movq          %xmm1,%rbp
  .byte  65,137,233                          // mov           %ebp,%r9d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  102,15,112,201,78                   // pshufd        $0x4e,%xmm1,%xmm1
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  65,137,218                          // mov           %ebx,%r10d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  65,15,182,28,24                     // movzbl        (%r8,%rbx,1),%ebx
  .byte  193,227,8                           // shl           $0x8,%ebx
  .byte  68,9,211                            // or            %r10d,%ebx
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  65,15,182,44,40                     // movzbl        (%r8,%rbp,1),%ebp
  .byte  193,229,8                           // shl           $0x8,%ebp
  .byte  68,9,205                            // or            %r9d,%ebp
  .byte  102,15,110,205                      // movd          %ebp,%xmm1
  .byte  102,15,196,203,1                    // pinsrw        $0x1,%ebx,%xmm1
  .byte  102,65,15,96,200                    // punpcklbw     %xmm8,%xmm1
  .byte  102,65,15,97,200                    // punpcklwd     %xmm8,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  72,139,64,16                        // mov           0x10(%rax),%rax
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,226                        // maxps         %xmm2,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,89,225                        // mulps         %xmm9,%xmm12
  .byte  102,65,15,91,212                    // cvtps2dq      %xmm12,%xmm2
  .byte  102,72,15,126,213                   // movq          %xmm2,%rbp
  .byte  65,137,232                          // mov           %ebp,%r8d
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  102,15,112,210,78                   // pshufd        $0x4e,%xmm2,%xmm2
  .byte  102,72,15,126,211                   // movq          %xmm2,%rbx
  .byte  65,137,217                          // mov           %ebx,%r9d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  70,15,182,12,8                      // movzbl        (%rax,%r9,1),%r9d
  .byte  15,182,28,24                        // movzbl        (%rax,%rbx,1),%ebx
  .byte  193,227,8                           // shl           $0x8,%ebx
  .byte  68,9,203                            // or            %r9d,%ebx
  .byte  70,15,182,4,0                       // movzbl        (%rax,%r8,1),%r8d
  .byte  15,182,4,40                         // movzbl        (%rax,%rbp,1),%eax
  .byte  193,224,8                           // shl           $0x8,%eax
  .byte  68,9,192                            // or            %r8d,%eax
  .byte  102,15,110,208                      // movd          %eax,%xmm2
  .byte  102,15,196,211,1                    // pinsrw        $0x1,%ebx,%xmm2
  .byte  102,65,15,96,208                    // punpcklbw     %xmm8,%xmm2
  .byte  102,65,15,97,208                    // punpcklwd     %xmm8,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  65,15,89,211                        // mulps         %xmm11,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_r_sse2
.globl _sk_table_r_sse2
FUNCTION(_sk_table_r_sse2)
_sk_table_r_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,192,0                 // pshufd        $0x0,%xmm8,%xmm8
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,93,13,37,64,1,0               // minps         0x14025(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  102,69,15,91,193                    // cvtps2dq      %xmm9,%xmm8
  .byte  102,65,15,112,192,78                // pshufd        $0x4e,%xmm8,%xmm0
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,77,15,126,194                   // movq          %xmm8,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  243,71,15,16,4,144                  // movss         (%r8,%r10,4),%xmm8
  .byte  243,67,15,16,4,152                  // movss         (%r8,%r11,4),%xmm0
  .byte  65,15,20,192                        // unpcklps      %xmm8,%xmm0
  .byte  243,69,15,16,4,128                  // movss         (%r8,%rax,4),%xmm8
  .byte  243,71,15,16,12,136                 // movss         (%r8,%r9,4),%xmm9
  .byte  69,15,20,200                        // unpcklps      %xmm8,%xmm9
  .byte  102,65,15,20,193                    // unpcklpd      %xmm9,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_g_sse2
.globl _sk_table_g_sse2
FUNCTION(_sk_table_g_sse2)
_sk_table_g_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,192,0                 // pshufd        $0x0,%xmm8,%xmm8
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,201                        // maxps         %xmm1,%xmm9
  .byte  68,15,93,13,172,63,1,0              // minps         0x13fac(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  102,69,15,91,193                    // cvtps2dq      %xmm9,%xmm8
  .byte  102,65,15,112,200,78                // pshufd        $0x4e,%xmm8,%xmm1
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,77,15,126,194                   // movq          %xmm8,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  243,71,15,16,4,144                  // movss         (%r8,%r10,4),%xmm8
  .byte  243,67,15,16,12,152                 // movss         (%r8,%r11,4),%xmm1
  .byte  65,15,20,200                        // unpcklps      %xmm8,%xmm1
  .byte  243,69,15,16,4,128                  // movss         (%r8,%rax,4),%xmm8
  .byte  243,71,15,16,12,136                 // movss         (%r8,%r9,4),%xmm9
  .byte  69,15,20,200                        // unpcklps      %xmm8,%xmm9
  .byte  102,65,15,20,201                    // unpcklpd      %xmm9,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_b_sse2
.globl _sk_table_b_sse2
FUNCTION(_sk_table_b_sse2)
_sk_table_b_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,192,0                 // pshufd        $0x0,%xmm8,%xmm8
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,202                        // maxps         %xmm2,%xmm9
  .byte  68,15,93,13,51,63,1,0               // minps         0x13f33(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  102,69,15,91,193                    // cvtps2dq      %xmm9,%xmm8
  .byte  102,65,15,112,208,78                // pshufd        $0x4e,%xmm8,%xmm2
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,77,15,126,194                   // movq          %xmm8,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  243,71,15,16,4,144                  // movss         (%r8,%r10,4),%xmm8
  .byte  243,67,15,16,20,152                 // movss         (%r8,%r11,4),%xmm2
  .byte  65,15,20,208                        // unpcklps      %xmm8,%xmm2
  .byte  243,69,15,16,4,128                  // movss         (%r8,%rax,4),%xmm8
  .byte  243,71,15,16,12,136                 // movss         (%r8,%r9,4),%xmm9
  .byte  69,15,20,200                        // unpcklps      %xmm8,%xmm9
  .byte  102,65,15,20,209                    // unpcklpd      %xmm9,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_table_a_sse2
.globl _sk_table_a_sse2
FUNCTION(_sk_table_a_sse2)
_sk_table_a_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  139,64,8                            // mov           0x8(%rax),%eax
  .byte  255,200                             // dec           %eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,112,192,0                 // pshufd        $0x0,%xmm8,%xmm8
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,203                        // maxps         %xmm3,%xmm9
  .byte  68,15,93,13,186,62,1,0              // minps         0x13eba(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  102,69,15,91,193                    // cvtps2dq      %xmm9,%xmm8
  .byte  102,65,15,112,216,78                // pshufd        $0x4e,%xmm8,%xmm3
  .byte  102,72,15,126,216                   // movq          %xmm3,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,77,15,126,194                   // movq          %xmm8,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  243,71,15,16,4,144                  // movss         (%r8,%r10,4),%xmm8
  .byte  243,67,15,16,28,152                 // movss         (%r8,%r11,4),%xmm3
  .byte  65,15,20,216                        // unpcklps      %xmm8,%xmm3
  .byte  243,69,15,16,4,128                  // movss         (%r8,%rax,4),%xmm8
  .byte  243,71,15,16,12,136                 // movss         (%r8,%r9,4),%xmm9
  .byte  69,15,20,200                        // unpcklps      %xmm8,%xmm9
  .byte  102,65,15,20,217                    // unpcklpd      %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_r_sse2
.globl _sk_parametric_r_sse2
FUNCTION(_sk_parametric_r_sse2)
_sk_parametric_r_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,80,16                  // movss         0x10(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  65,15,194,194,2                     // cmpleps       %xmm10,%xmm0
  .byte  243,68,15,16,80,24                  // movss         0x18(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  69,15,88,194                        // addps         %xmm10,%xmm8
  .byte  243,68,15,16,32                     // movss         (%rax),%xmm12
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  69,15,91,217                        // cvtdq2ps      %xmm9,%xmm11
  .byte  68,15,89,29,178,64,1,0              // mulps         0x140b2(%rip),%xmm11        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  68,15,40,45,186,64,1,0              // movaps        0x140ba(%rip),%xmm13        # 3ae10 <_sk_srcover_bgra_8888_sse2_lowp+0xea8>
  .byte  69,15,84,233                        // andps         %xmm9,%xmm13
  .byte  68,15,86,45,222,61,1,0              // orps          0x13dde(%rip),%xmm13        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,88,29,182,64,1,0              // addps         0x140b6(%rip),%xmm11        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  68,15,40,53,190,64,1,0              // movaps        0x140be(%rip),%xmm14        # 3ae30 <_sk_srcover_bgra_8888_sse2_lowp+0xec8>
  .byte  69,15,89,245                        // mulps         %xmm13,%xmm14
  .byte  69,15,92,222                        // subps         %xmm14,%xmm11
  .byte  68,15,88,45,190,64,1,0              // addps         0x140be(%rip),%xmm13        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  68,15,40,53,198,64,1,0              // movaps        0x140c6(%rip),%xmm14        # 3ae50 <_sk_srcover_bgra_8888_sse2_lowp+0xee8>
  .byte  69,15,94,245                        // divps         %xmm13,%xmm14
  .byte  69,15,92,222                        // subps         %xmm14,%xmm11
  .byte  69,15,89,220                        // mulps         %xmm12,%xmm11
  .byte  243,69,15,91,227                    // cvttps2dq     %xmm11,%xmm12
  .byte  69,15,91,236                        // cvtdq2ps      %xmm12,%xmm13
  .byte  69,15,40,243                        // movaps        %xmm11,%xmm14
  .byte  69,15,194,245,1                     // cmpltps       %xmm13,%xmm14
  .byte  68,15,40,37,160,61,1,0              // movaps        0x13da0(%rip),%xmm12        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,84,244                        // andps         %xmm12,%xmm14
  .byte  69,15,92,238                        // subps         %xmm14,%xmm13
  .byte  69,15,40,243                        // movaps        %xmm11,%xmm14
  .byte  69,15,92,245                        // subps         %xmm13,%xmm14
  .byte  68,15,88,29,152,64,1,0              // addps         0x14098(%rip),%xmm11        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  68,15,40,45,160,64,1,0              // movaps        0x140a0(%rip),%xmm13        # 3ae70 <_sk_srcover_bgra_8888_sse2_lowp+0xf08>
  .byte  69,15,89,238                        // mulps         %xmm14,%xmm13
  .byte  69,15,92,221                        // subps         %xmm13,%xmm11
  .byte  68,15,40,45,160,64,1,0              // movaps        0x140a0(%rip),%xmm13        # 3ae80 <_sk_srcover_bgra_8888_sse2_lowp+0xf18>
  .byte  69,15,92,238                        // subps         %xmm14,%xmm13
  .byte  68,15,40,53,164,64,1,0              // movaps        0x140a4(%rip),%xmm14        # 3ae90 <_sk_srcover_bgra_8888_sse2_lowp+0xf28>
  .byte  69,15,94,245                        // divps         %xmm13,%xmm14
  .byte  69,15,88,243                        // addps         %xmm11,%xmm14
  .byte  68,15,89,53,164,64,1,0              // mulps         0x140a4(%rip),%xmm14        # 3aea0 <_sk_srcover_bgra_8888_sse2_lowp+0xf38>
  .byte  102,69,15,91,222                    // cvtps2dq      %xmm14,%xmm11
  .byte  69,15,194,202,4                     // cmpneqps      %xmm10,%xmm9
  .byte  69,15,84,203                        // andps         %xmm11,%xmm9
  .byte  243,68,15,16,88,20                  // movss         0x14(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,88,217                        // addps         %xmm9,%xmm11
  .byte  68,15,84,192                        // andps         %xmm0,%xmm8
  .byte  65,15,85,195                        // andnps        %xmm11,%xmm0
  .byte  65,15,86,192                        // orps          %xmm8,%xmm0
  .byte  65,15,95,194                        // maxps         %xmm10,%xmm0
  .byte  65,15,93,196                        // minps         %xmm12,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_g_sse2
.globl _sk_parametric_g_sse2
FUNCTION(_sk_parametric_g_sse2)
_sk_parametric_g_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,80,16                  // movss         0x10(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  68,15,89,193                        // mulps         %xmm1,%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  65,15,194,202,2                     // cmpleps       %xmm10,%xmm1
  .byte  243,68,15,16,80,24                  // movss         0x18(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  69,15,88,194                        // addps         %xmm10,%xmm8
  .byte  243,68,15,16,32                     // movss         (%rax),%xmm12
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  69,15,91,217                        // cvtdq2ps      %xmm9,%xmm11
  .byte  68,15,89,29,103,63,1,0              // mulps         0x13f67(%rip),%xmm11        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  68,15,40,45,111,63,1,0              // movaps        0x13f6f(%rip),%xmm13        # 3ae10 <_sk_srcover_bgra_8888_sse2_lowp+0xea8>
  .byte  69,15,84,233                        // andps         %xmm9,%xmm13
  .byte  68,15,86,45,147,60,1,0              // orps          0x13c93(%rip),%xmm13        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,88,29,107,63,1,0              // addps         0x13f6b(%rip),%xmm11        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  68,15,40,53,115,63,1,0              // movaps        0x13f73(%rip),%xmm14        # 3ae30 <_sk_srcover_bgra_8888_sse2_lowp+0xec8>
  .byte  69,15,89,245                        // mulps         %xmm13,%xmm14
  .byte  69,15,92,222                        // subps         %xmm14,%xmm11
  .byte  68,15,88,45,115,63,1,0              // addps         0x13f73(%rip),%xmm13        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  68,15,40,53,123,63,1,0              // movaps        0x13f7b(%rip),%xmm14        # 3ae50 <_sk_srcover_bgra_8888_sse2_lowp+0xee8>
  .byte  69,15,94,245                        // divps         %xmm13,%xmm14
  .byte  69,15,92,222                        // subps         %xmm14,%xmm11
  .byte  69,15,89,220                        // mulps         %xmm12,%xmm11
  .byte  243,69,15,91,227                    // cvttps2dq     %xmm11,%xmm12
  .byte  69,15,91,236                        // cvtdq2ps      %xmm12,%xmm13
  .byte  69,15,40,243                        // movaps        %xmm11,%xmm14
  .byte  69,15,194,245,1                     // cmpltps       %xmm13,%xmm14
  .byte  68,15,40,37,85,60,1,0               // movaps        0x13c55(%rip),%xmm12        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,84,244                        // andps         %xmm12,%xmm14
  .byte  69,15,92,238                        // subps         %xmm14,%xmm13
  .byte  69,15,40,243                        // movaps        %xmm11,%xmm14
  .byte  69,15,92,245                        // subps         %xmm13,%xmm14
  .byte  68,15,88,29,77,63,1,0               // addps         0x13f4d(%rip),%xmm11        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  68,15,40,45,85,63,1,0               // movaps        0x13f55(%rip),%xmm13        # 3ae70 <_sk_srcover_bgra_8888_sse2_lowp+0xf08>
  .byte  69,15,89,238                        // mulps         %xmm14,%xmm13
  .byte  69,15,92,221                        // subps         %xmm13,%xmm11
  .byte  68,15,40,45,85,63,1,0               // movaps        0x13f55(%rip),%xmm13        # 3ae80 <_sk_srcover_bgra_8888_sse2_lowp+0xf18>
  .byte  69,15,92,238                        // subps         %xmm14,%xmm13
  .byte  68,15,40,53,89,63,1,0               // movaps        0x13f59(%rip),%xmm14        # 3ae90 <_sk_srcover_bgra_8888_sse2_lowp+0xf28>
  .byte  69,15,94,245                        // divps         %xmm13,%xmm14
  .byte  69,15,88,243                        // addps         %xmm11,%xmm14
  .byte  68,15,89,53,89,63,1,0               // mulps         0x13f59(%rip),%xmm14        # 3aea0 <_sk_srcover_bgra_8888_sse2_lowp+0xf38>
  .byte  102,69,15,91,222                    // cvtps2dq      %xmm14,%xmm11
  .byte  69,15,194,202,4                     // cmpneqps      %xmm10,%xmm9
  .byte  69,15,84,203                        // andps         %xmm11,%xmm9
  .byte  243,68,15,16,88,20                  // movss         0x14(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,88,217                        // addps         %xmm9,%xmm11
  .byte  68,15,84,193                        // andps         %xmm1,%xmm8
  .byte  65,15,85,203                        // andnps        %xmm11,%xmm1
  .byte  65,15,86,200                        // orps          %xmm8,%xmm1
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,93,204                        // minps         %xmm12,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_b_sse2
.globl _sk_parametric_b_sse2
FUNCTION(_sk_parametric_b_sse2)
_sk_parametric_b_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,80,16                  // movss         0x10(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  68,15,89,194                        // mulps         %xmm2,%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,202                        // mulps         %xmm2,%xmm9
  .byte  65,15,194,210,2                     // cmpleps       %xmm10,%xmm2
  .byte  243,68,15,16,80,24                  // movss         0x18(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  69,15,88,194                        // addps         %xmm10,%xmm8
  .byte  243,68,15,16,32                     // movss         (%rax),%xmm12
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  69,15,91,217                        // cvtdq2ps      %xmm9,%xmm11
  .byte  68,15,89,29,28,62,1,0               // mulps         0x13e1c(%rip),%xmm11        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  68,15,40,45,36,62,1,0               // movaps        0x13e24(%rip),%xmm13        # 3ae10 <_sk_srcover_bgra_8888_sse2_lowp+0xea8>
  .byte  69,15,84,233                        // andps         %xmm9,%xmm13
  .byte  68,15,86,45,72,59,1,0               // orps          0x13b48(%rip),%xmm13        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,88,29,32,62,1,0               // addps         0x13e20(%rip),%xmm11        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  68,15,40,53,40,62,1,0               // movaps        0x13e28(%rip),%xmm14        # 3ae30 <_sk_srcover_bgra_8888_sse2_lowp+0xec8>
  .byte  69,15,89,245                        // mulps         %xmm13,%xmm14
  .byte  69,15,92,222                        // subps         %xmm14,%xmm11
  .byte  68,15,88,45,40,62,1,0               // addps         0x13e28(%rip),%xmm13        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  68,15,40,53,48,62,1,0               // movaps        0x13e30(%rip),%xmm14        # 3ae50 <_sk_srcover_bgra_8888_sse2_lowp+0xee8>
  .byte  69,15,94,245                        // divps         %xmm13,%xmm14
  .byte  69,15,92,222                        // subps         %xmm14,%xmm11
  .byte  69,15,89,220                        // mulps         %xmm12,%xmm11
  .byte  243,69,15,91,227                    // cvttps2dq     %xmm11,%xmm12
  .byte  69,15,91,236                        // cvtdq2ps      %xmm12,%xmm13
  .byte  69,15,40,243                        // movaps        %xmm11,%xmm14
  .byte  69,15,194,245,1                     // cmpltps       %xmm13,%xmm14
  .byte  68,15,40,37,10,59,1,0               // movaps        0x13b0a(%rip),%xmm12        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,84,244                        // andps         %xmm12,%xmm14
  .byte  69,15,92,238                        // subps         %xmm14,%xmm13
  .byte  69,15,40,243                        // movaps        %xmm11,%xmm14
  .byte  69,15,92,245                        // subps         %xmm13,%xmm14
  .byte  68,15,88,29,2,62,1,0                // addps         0x13e02(%rip),%xmm11        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  68,15,40,45,10,62,1,0               // movaps        0x13e0a(%rip),%xmm13        # 3ae70 <_sk_srcover_bgra_8888_sse2_lowp+0xf08>
  .byte  69,15,89,238                        // mulps         %xmm14,%xmm13
  .byte  69,15,92,221                        // subps         %xmm13,%xmm11
  .byte  68,15,40,45,10,62,1,0               // movaps        0x13e0a(%rip),%xmm13        # 3ae80 <_sk_srcover_bgra_8888_sse2_lowp+0xf18>
  .byte  69,15,92,238                        // subps         %xmm14,%xmm13
  .byte  68,15,40,53,14,62,1,0               // movaps        0x13e0e(%rip),%xmm14        # 3ae90 <_sk_srcover_bgra_8888_sse2_lowp+0xf28>
  .byte  69,15,94,245                        // divps         %xmm13,%xmm14
  .byte  69,15,88,243                        // addps         %xmm11,%xmm14
  .byte  68,15,89,53,14,62,1,0               // mulps         0x13e0e(%rip),%xmm14        # 3aea0 <_sk_srcover_bgra_8888_sse2_lowp+0xf38>
  .byte  102,69,15,91,222                    // cvtps2dq      %xmm14,%xmm11
  .byte  69,15,194,202,4                     // cmpneqps      %xmm10,%xmm9
  .byte  69,15,84,203                        // andps         %xmm11,%xmm9
  .byte  243,68,15,16,88,20                  // movss         0x14(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,88,217                        // addps         %xmm9,%xmm11
  .byte  68,15,84,194                        // andps         %xmm2,%xmm8
  .byte  65,15,85,211                        // andnps        %xmm11,%xmm2
  .byte  65,15,86,208                        // orps          %xmm8,%xmm2
  .byte  65,15,95,210                        // maxps         %xmm10,%xmm2
  .byte  65,15,93,212                        // minps         %xmm12,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_parametric_a_sse2
.globl _sk_parametric_a_sse2
FUNCTION(_sk_parametric_a_sse2)
_sk_parametric_a_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,80,16                  // movss         0x10(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  68,15,89,195                        // mulps         %xmm3,%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,203                        // mulps         %xmm3,%xmm9
  .byte  65,15,194,218,2                     // cmpleps       %xmm10,%xmm3
  .byte  243,68,15,16,80,24                  // movss         0x18(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  69,15,88,194                        // addps         %xmm10,%xmm8
  .byte  243,68,15,16,32                     // movss         (%rax),%xmm12
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  69,15,91,217                        // cvtdq2ps      %xmm9,%xmm11
  .byte  68,15,89,29,209,60,1,0              // mulps         0x13cd1(%rip),%xmm11        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  68,15,40,45,217,60,1,0              // movaps        0x13cd9(%rip),%xmm13        # 3ae10 <_sk_srcover_bgra_8888_sse2_lowp+0xea8>
  .byte  69,15,84,233                        // andps         %xmm9,%xmm13
  .byte  68,15,86,45,253,57,1,0              // orps          0x139fd(%rip),%xmm13        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,88,29,213,60,1,0              // addps         0x13cd5(%rip),%xmm11        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  68,15,40,53,221,60,1,0              // movaps        0x13cdd(%rip),%xmm14        # 3ae30 <_sk_srcover_bgra_8888_sse2_lowp+0xec8>
  .byte  69,15,89,245                        // mulps         %xmm13,%xmm14
  .byte  69,15,92,222                        // subps         %xmm14,%xmm11
  .byte  68,15,88,45,221,60,1,0              // addps         0x13cdd(%rip),%xmm13        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  68,15,40,53,229,60,1,0              // movaps        0x13ce5(%rip),%xmm14        # 3ae50 <_sk_srcover_bgra_8888_sse2_lowp+0xee8>
  .byte  69,15,94,245                        // divps         %xmm13,%xmm14
  .byte  69,15,92,222                        // subps         %xmm14,%xmm11
  .byte  69,15,89,220                        // mulps         %xmm12,%xmm11
  .byte  243,69,15,91,227                    // cvttps2dq     %xmm11,%xmm12
  .byte  69,15,91,236                        // cvtdq2ps      %xmm12,%xmm13
  .byte  69,15,40,243                        // movaps        %xmm11,%xmm14
  .byte  69,15,194,245,1                     // cmpltps       %xmm13,%xmm14
  .byte  68,15,40,37,191,57,1,0              // movaps        0x139bf(%rip),%xmm12        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,84,244                        // andps         %xmm12,%xmm14
  .byte  69,15,92,238                        // subps         %xmm14,%xmm13
  .byte  69,15,40,243                        // movaps        %xmm11,%xmm14
  .byte  69,15,92,245                        // subps         %xmm13,%xmm14
  .byte  68,15,88,29,183,60,1,0              // addps         0x13cb7(%rip),%xmm11        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  68,15,40,45,191,60,1,0              // movaps        0x13cbf(%rip),%xmm13        # 3ae70 <_sk_srcover_bgra_8888_sse2_lowp+0xf08>
  .byte  69,15,89,238                        // mulps         %xmm14,%xmm13
  .byte  69,15,92,221                        // subps         %xmm13,%xmm11
  .byte  68,15,40,45,191,60,1,0              // movaps        0x13cbf(%rip),%xmm13        # 3ae80 <_sk_srcover_bgra_8888_sse2_lowp+0xf18>
  .byte  69,15,92,238                        // subps         %xmm14,%xmm13
  .byte  68,15,40,53,195,60,1,0              // movaps        0x13cc3(%rip),%xmm14        # 3ae90 <_sk_srcover_bgra_8888_sse2_lowp+0xf28>
  .byte  69,15,94,245                        // divps         %xmm13,%xmm14
  .byte  69,15,88,243                        // addps         %xmm11,%xmm14
  .byte  68,15,89,53,195,60,1,0              // mulps         0x13cc3(%rip),%xmm14        # 3aea0 <_sk_srcover_bgra_8888_sse2_lowp+0xf38>
  .byte  102,69,15,91,222                    // cvtps2dq      %xmm14,%xmm11
  .byte  69,15,194,202,4                     // cmpneqps      %xmm10,%xmm9
  .byte  69,15,84,203                        // andps         %xmm11,%xmm9
  .byte  243,68,15,16,88,20                  // movss         0x14(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,88,217                        // addps         %xmm9,%xmm11
  .byte  68,15,84,195                        // andps         %xmm3,%xmm8
  .byte  65,15,85,219                        // andnps        %xmm11,%xmm3
  .byte  65,15,86,216                        // orps          %xmm8,%xmm3
  .byte  65,15,95,218                        // maxps         %xmm10,%xmm3
  .byte  65,15,93,220                        // minps         %xmm12,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gamma_sse2
.globl _sk_gamma_sse2
FUNCTION(_sk_gamma_sse2)
_sk_gamma_sse2:
  .byte  15,41,124,36,232                    // movaps        %xmm7,-0x18(%rsp)
  .byte  15,41,116,36,216                    // movaps        %xmm6,-0x28(%rsp)
  .byte  15,41,108,36,200                    // movaps        %xmm5,-0x38(%rsp)
  .byte  15,41,100,36,184                    // movaps        %xmm4,-0x48(%rsp)
  .byte  15,41,92,36,168                     // movaps        %xmm3,-0x58(%rsp)
  .byte  68,15,40,226                        // movaps        %xmm2,%xmm12
  .byte  68,15,40,209                        // movaps        %xmm1,%xmm10
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,91,244                           // cvtdq2ps      %xmm4,%xmm6
  .byte  15,40,5,192,59,1,0                  // movaps        0x13bc0(%rip),%xmm0        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  15,89,240                           // mulps         %xmm0,%xmm6
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  68,15,40,5,194,59,1,0               // movaps        0x13bc2(%rip),%xmm8        # 3ae10 <_sk_srcover_bgra_8888_sse2_lowp+0xea8>
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  65,15,84,192                        // andps         %xmm8,%xmm0
  .byte  15,86,5,228,56,1,0                  // orps          0x138e4(%rip),%xmm0        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,88,53,189,59,1,0                 // addps         0x13bbd(%rip),%xmm6        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  68,15,40,29,197,59,1,0              // movaps        0x13bc5(%rip),%xmm11        # 3ae30 <_sk_srcover_bgra_8888_sse2_lowp+0xec8>
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  15,92,241                           // subps         %xmm1,%xmm6
  .byte  68,15,40,61,195,59,1,0              // movaps        0x13bc3(%rip),%xmm15        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  65,15,88,199                        // addps         %xmm15,%xmm0
  .byte  68,15,40,45,199,59,1,0              // movaps        0x13bc7(%rip),%xmm13        # 3ae50 <_sk_srcover_bgra_8888_sse2_lowp+0xee8>
  .byte  65,15,40,205                        // movaps        %xmm13,%xmm1
  .byte  15,94,200                           // divps         %xmm0,%xmm1
  .byte  15,92,241                           // subps         %xmm1,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,24                        // movss         (%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  243,15,91,198                       // cvttps2dq     %xmm6,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,194,200,1                        // cmpltps       %xmm0,%xmm1
  .byte  15,84,13,155,56,1,0                 // andps         0x1389b(%rip),%xmm1        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,88,53,155,59,1,0                 // addps         0x13b9b(%rip),%xmm6        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  15,40,21,180,59,1,0                 // movaps        0x13bb4(%rip),%xmm2        # 3ae80 <_sk_srcover_bgra_8888_sse2_lowp+0xf18>
  .byte  68,15,40,202                        // movaps        %xmm2,%xmm9
  .byte  68,15,92,201                        // subps         %xmm1,%xmm9
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,40,13,146,59,1,0                 // movaps        0x13b92(%rip),%xmm1        # 3ae70 <_sk_srcover_bgra_8888_sse2_lowp+0xf08>
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,92,240                           // subps         %xmm0,%xmm6
  .byte  68,15,40,53,164,59,1,0              // movaps        0x13ba4(%rip),%xmm14        # 3ae90 <_sk_srcover_bgra_8888_sse2_lowp+0xf28>
  .byte  65,15,40,198                        // movaps        %xmm14,%xmm0
  .byte  65,15,94,193                        // divps         %xmm9,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  68,15,40,13,161,59,1,0              // movaps        0x13ba1(%rip),%xmm9        # 3aea0 <_sk_srcover_bgra_8888_sse2_lowp+0xf38>
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  102,15,91,192                       // cvtps2dq      %xmm0,%xmm0
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,194,230,4                        // cmpneqps      %xmm6,%xmm4
  .byte  15,84,224                           // andps         %xmm0,%xmm4
  .byte  65,15,91,194                        // cvtdq2ps      %xmm10,%xmm0
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  65,15,40,250                        // movaps        %xmm10,%xmm7
  .byte  65,15,84,248                        // andps         %xmm8,%xmm7
  .byte  15,40,53,25,56,1,0                  // movaps        0x13819(%rip),%xmm6        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,86,254                           // orps          %xmm6,%xmm7
  .byte  15,88,5,239,58,1,0                  // addps         0x13aef(%rip),%xmm0        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  15,40,239                           // movaps        %xmm7,%xmm5
  .byte  65,15,89,235                        // mulps         %xmm11,%xmm5
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  65,15,88,255                        // addps         %xmm15,%xmm7
  .byte  65,15,40,237                        // movaps        %xmm13,%xmm5
  .byte  15,94,239                           // divps         %xmm7,%xmm5
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  243,15,91,232                       // cvttps2dq     %xmm0,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  15,194,253,1                        // cmpltps       %xmm5,%xmm7
  .byte  68,15,40,61,238,55,1,0              // movaps        0x137ee(%rip),%xmm15        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,84,255                        // andps         %xmm15,%xmm7
  .byte  15,92,239                           // subps         %xmm7,%xmm5
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  15,92,253                           // subps         %xmm5,%xmm7
  .byte  15,88,5,234,58,1,0                  // addps         0x13aea(%rip),%xmm0        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  15,40,234                           // movaps        %xmm2,%xmm5
  .byte  15,92,239                           // subps         %xmm7,%xmm5
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  15,92,199                           // subps         %xmm7,%xmm0
  .byte  65,15,40,254                        // movaps        %xmm14,%xmm7
  .byte  15,94,253                           // divps         %xmm5,%xmm7
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  65,15,89,249                        // mulps         %xmm9,%xmm7
  .byte  102,15,91,199                       // cvtps2dq      %xmm7,%xmm0
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  68,15,194,215,4                     // cmpneqps      %xmm7,%xmm10
  .byte  68,15,84,208                        // andps         %xmm0,%xmm10
  .byte  65,15,91,196                        // cvtdq2ps      %xmm12,%xmm0
  .byte  15,89,5,85,58,1,0                   // mulps         0x13a55(%rip),%xmm0        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  69,15,84,196                        // andps         %xmm12,%xmm8
  .byte  68,15,86,198                        // orps          %xmm6,%xmm8
  .byte  15,88,5,102,58,1,0                  // addps         0x13a66(%rip),%xmm0        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  65,15,92,195                        // subps         %xmm11,%xmm0
  .byte  68,15,88,5,118,58,1,0               // addps         0x13a76(%rip),%xmm8        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  69,15,94,232                        // divps         %xmm8,%xmm13
  .byte  65,15,92,197                        // subps         %xmm13,%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  243,15,91,216                       // cvttps2dq     %xmm0,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  15,194,235,1                        // cmpltps       %xmm3,%xmm5
  .byte  65,15,84,239                        // andps         %xmm15,%xmm5
  .byte  15,92,221                           // subps         %xmm5,%xmm3
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  15,92,235                           // subps         %xmm3,%xmm5
  .byte  15,88,5,105,58,1,0                  // addps         0x13a69(%rip),%xmm0        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,92,213                           // subps         %xmm5,%xmm2
  .byte  68,15,94,242                        // divps         %xmm2,%xmm14
  .byte  68,15,88,240                        // addps         %xmm0,%xmm14
  .byte  69,15,89,241                        // mulps         %xmm9,%xmm14
  .byte  68,15,194,231,4                     // cmpneqps      %xmm7,%xmm12
  .byte  102,65,15,91,198                    // cvtps2dq      %xmm14,%xmm0
  .byte  68,15,84,224                        // andps         %xmm0,%xmm12
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  65,15,40,202                        // movaps        %xmm10,%xmm1
  .byte  65,15,40,212                        // movaps        %xmm12,%xmm2
  .byte  15,40,92,36,168                     // movaps        -0x58(%rsp),%xmm3
  .byte  15,40,100,36,184                    // movaps        -0x48(%rsp),%xmm4
  .byte  15,40,108,36,200                    // movaps        -0x38(%rsp),%xmm5
  .byte  15,40,116,36,216                    // movaps        -0x28(%rsp),%xmm6
  .byte  15,40,124,36,232                    // movaps        -0x18(%rsp),%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gamma_dst_sse2
.globl _sk_gamma_dst_sse2
FUNCTION(_sk_gamma_dst_sse2)
_sk_gamma_dst_sse2:
  .byte  15,41,124,36,232                    // movaps        %xmm7,-0x18(%rsp)
  .byte  68,15,40,230                        // movaps        %xmm6,%xmm12
  .byte  68,15,40,213                        // movaps        %xmm5,%xmm10
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,41,92,36,216                     // movaps        %xmm3,-0x28(%rsp)
  .byte  15,41,84,36,200                     // movaps        %xmm2,-0x38(%rsp)
  .byte  15,41,76,36,184                     // movaps        %xmm1,-0x48(%rsp)
  .byte  15,41,68,36,168                     // movaps        %xmm0,-0x58(%rsp)
  .byte  15,91,221                           // cvtdq2ps      %xmm5,%xmm3
  .byte  15,40,5,144,57,1,0                  // movaps        0x13990(%rip),%xmm0        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  68,15,40,5,146,57,1,0               // movaps        0x13992(%rip),%xmm8        # 3ae10 <_sk_srcover_bgra_8888_sse2_lowp+0xea8>
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  65,15,84,192                        // andps         %xmm8,%xmm0
  .byte  15,86,5,180,54,1,0                  // orps          0x136b4(%rip),%xmm0        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,88,29,141,57,1,0                 // addps         0x1398d(%rip),%xmm3        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  68,15,40,29,149,57,1,0              // movaps        0x13995(%rip),%xmm11        # 3ae30 <_sk_srcover_bgra_8888_sse2_lowp+0xec8>
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  15,92,217                           // subps         %xmm1,%xmm3
  .byte  68,15,40,61,147,57,1,0              // movaps        0x13993(%rip),%xmm15        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  65,15,88,199                        // addps         %xmm15,%xmm0
  .byte  68,15,40,45,151,57,1,0              // movaps        0x13997(%rip),%xmm13        # 3ae50 <_sk_srcover_bgra_8888_sse2_lowp+0xee8>
  .byte  65,15,40,205                        // movaps        %xmm13,%xmm1
  .byte  15,94,200                           // divps         %xmm0,%xmm1
  .byte  15,92,217                           // subps         %xmm1,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,32                        // movss         (%rax),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,194,200,1                        // cmpltps       %xmm0,%xmm1
  .byte  15,84,13,107,54,1,0                 // andps         0x1366b(%rip),%xmm1        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,88,29,107,57,1,0                 // addps         0x1396b(%rip),%xmm3        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  15,40,21,132,57,1,0                 // movaps        0x13984(%rip),%xmm2        # 3ae80 <_sk_srcover_bgra_8888_sse2_lowp+0xf18>
  .byte  68,15,40,202                        // movaps        %xmm2,%xmm9
  .byte  68,15,92,201                        // subps         %xmm1,%xmm9
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,40,13,98,57,1,0                  // movaps        0x13962(%rip),%xmm1        # 3ae70 <_sk_srcover_bgra_8888_sse2_lowp+0xf08>
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,92,216                           // subps         %xmm0,%xmm3
  .byte  68,15,40,53,116,57,1,0              // movaps        0x13974(%rip),%xmm14        # 3ae90 <_sk_srcover_bgra_8888_sse2_lowp+0xf28>
  .byte  65,15,40,198                        // movaps        %xmm14,%xmm0
  .byte  65,15,94,193                        // divps         %xmm9,%xmm0
  .byte  15,88,195                           // addps         %xmm3,%xmm0
  .byte  68,15,40,13,113,57,1,0              // movaps        0x13971(%rip),%xmm9        # 3aea0 <_sk_srcover_bgra_8888_sse2_lowp+0xf38>
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  102,15,91,192                       // cvtps2dq      %xmm0,%xmm0
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,194,235,4                        // cmpneqps      %xmm3,%xmm5
  .byte  15,84,232                           // andps         %xmm0,%xmm5
  .byte  65,15,91,194                        // cvtdq2ps      %xmm10,%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  65,15,40,250                        // movaps        %xmm10,%xmm7
  .byte  65,15,84,248                        // andps         %xmm8,%xmm7
  .byte  15,40,29,233,53,1,0                 // movaps        0x135e9(%rip),%xmm3        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,86,251                           // orps          %xmm3,%xmm7
  .byte  15,88,5,191,56,1,0                  // addps         0x138bf(%rip),%xmm0        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  15,40,247                           // movaps        %xmm7,%xmm6
  .byte  65,15,89,243                        // mulps         %xmm11,%xmm6
  .byte  15,92,198                           // subps         %xmm6,%xmm0
  .byte  65,15,88,255                        // addps         %xmm15,%xmm7
  .byte  65,15,40,245                        // movaps        %xmm13,%xmm6
  .byte  15,94,247                           // divps         %xmm7,%xmm6
  .byte  15,92,198                           // subps         %xmm6,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  243,15,91,240                       // cvttps2dq     %xmm0,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  15,194,254,1                        // cmpltps       %xmm6,%xmm7
  .byte  68,15,40,61,190,53,1,0              // movaps        0x135be(%rip),%xmm15        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,84,255                        // andps         %xmm15,%xmm7
  .byte  15,92,247                           // subps         %xmm7,%xmm6
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  15,92,254                           // subps         %xmm6,%xmm7
  .byte  15,88,5,186,56,1,0                  // addps         0x138ba(%rip),%xmm0        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  15,40,242                           // movaps        %xmm2,%xmm6
  .byte  15,92,247                           // subps         %xmm7,%xmm6
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  15,92,199                           // subps         %xmm7,%xmm0
  .byte  65,15,40,254                        // movaps        %xmm14,%xmm7
  .byte  15,94,254                           // divps         %xmm6,%xmm7
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  65,15,89,249                        // mulps         %xmm9,%xmm7
  .byte  102,15,91,199                       // cvtps2dq      %xmm7,%xmm0
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  68,15,194,215,4                     // cmpneqps      %xmm7,%xmm10
  .byte  68,15,84,208                        // andps         %xmm0,%xmm10
  .byte  65,15,91,196                        // cvtdq2ps      %xmm12,%xmm0
  .byte  15,89,5,37,56,1,0                   // mulps         0x13825(%rip),%xmm0        # 3ae00 <_sk_srcover_bgra_8888_sse2_lowp+0xe98>
  .byte  69,15,84,196                        // andps         %xmm12,%xmm8
  .byte  68,15,86,195                        // orps          %xmm3,%xmm8
  .byte  15,88,5,54,56,1,0                   // addps         0x13836(%rip),%xmm0        # 3ae20 <_sk_srcover_bgra_8888_sse2_lowp+0xeb8>
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  65,15,92,195                        // subps         %xmm11,%xmm0
  .byte  68,15,88,5,70,56,1,0                // addps         0x13846(%rip),%xmm8        # 3ae40 <_sk_srcover_bgra_8888_sse2_lowp+0xed8>
  .byte  69,15,94,232                        // divps         %xmm8,%xmm13
  .byte  65,15,92,197                        // subps         %xmm13,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  243,15,91,224                       // cvttps2dq     %xmm0,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,194,244,1                        // cmpltps       %xmm4,%xmm6
  .byte  65,15,84,247                        // andps         %xmm15,%xmm6
  .byte  15,92,230                           // subps         %xmm6,%xmm4
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,92,244                           // subps         %xmm4,%xmm6
  .byte  15,88,5,57,56,1,0                   // addps         0x13839(%rip),%xmm0        # 3ae60 <_sk_srcover_bgra_8888_sse2_lowp+0xef8>
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,92,214                           // subps         %xmm6,%xmm2
  .byte  68,15,94,242                        // divps         %xmm2,%xmm14
  .byte  68,15,88,240                        // addps         %xmm0,%xmm14
  .byte  69,15,89,241                        // mulps         %xmm9,%xmm14
  .byte  68,15,194,231,4                     // cmpneqps      %xmm7,%xmm12
  .byte  102,65,15,91,198                    // cvtps2dq      %xmm14,%xmm0
  .byte  68,15,84,224                        // andps         %xmm0,%xmm12
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,68,36,168                     // movaps        -0x58(%rsp),%xmm0
  .byte  15,40,76,36,184                     // movaps        -0x48(%rsp),%xmm1
  .byte  15,40,84,36,200                     // movaps        -0x38(%rsp),%xmm2
  .byte  15,40,92,36,216                     // movaps        -0x28(%rsp),%xmm3
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  65,15,40,234                        // movaps        %xmm10,%xmm5
  .byte  65,15,40,244                        // movaps        %xmm12,%xmm6
  .byte  15,40,124,36,232                    // movaps        -0x18(%rsp),%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lab_to_xyz_sse2
.globl _sk_lab_to_xyz_sse2
FUNCTION(_sk_lab_to_xyz_sse2)
_sk_lab_to_xyz_sse2:
  .byte  15,89,5,55,56,1,0                   // mulps         0x13837(%rip),%xmm0        # 3aeb0 <_sk_srcover_bgra_8888_sse2_lowp+0xf48>
  .byte  68,15,40,5,175,53,1,0               // movaps        0x135af(%rip),%xmm8        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  68,15,40,13,51,56,1,0               // movaps        0x13833(%rip),%xmm9        # 3aec0 <_sk_srcover_bgra_8888_sse2_lowp+0xf58>
  .byte  65,15,88,201                        // addps         %xmm9,%xmm1
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  65,15,88,209                        // addps         %xmm9,%xmm2
  .byte  15,88,5,48,56,1,0                   // addps         0x13830(%rip),%xmm0        # 3aed0 <_sk_srcover_bgra_8888_sse2_lowp+0xf68>
  .byte  15,89,5,57,56,1,0                   // mulps         0x13839(%rip),%xmm0        # 3aee0 <_sk_srcover_bgra_8888_sse2_lowp+0xf78>
  .byte  15,89,13,66,56,1,0                  // mulps         0x13842(%rip),%xmm1        # 3aef0 <_sk_srcover_bgra_8888_sse2_lowp+0xf88>
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  15,89,21,72,56,1,0                  // mulps         0x13848(%rip),%xmm2        # 3af00 <_sk_srcover_bgra_8888_sse2_lowp+0xf98>
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  68,15,92,202                        // subps         %xmm2,%xmm9
  .byte  68,15,40,225                        // movaps        %xmm1,%xmm12
  .byte  69,15,89,228                        // mulps         %xmm12,%xmm12
  .byte  68,15,89,225                        // mulps         %xmm1,%xmm12
  .byte  15,40,21,61,56,1,0                  // movaps        0x1383d(%rip),%xmm2        # 3af10 <_sk_srcover_bgra_8888_sse2_lowp+0xfa8>
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  69,15,194,196,1                     // cmpltps       %xmm12,%xmm8
  .byte  68,15,40,21,60,56,1,0               // movaps        0x1383c(%rip),%xmm10        # 3af20 <_sk_srcover_bgra_8888_sse2_lowp+0xfb8>
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  68,15,40,29,64,56,1,0               // movaps        0x13840(%rip),%xmm11        # 3af30 <_sk_srcover_bgra_8888_sse2_lowp+0xfc8>
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  69,15,84,224                        // andps         %xmm8,%xmm12
  .byte  68,15,85,193                        // andnps        %xmm1,%xmm8
  .byte  69,15,86,196                        // orps          %xmm12,%xmm8
  .byte  68,15,40,224                        // movaps        %xmm0,%xmm12
  .byte  69,15,89,228                        // mulps         %xmm12,%xmm12
  .byte  68,15,89,224                        // mulps         %xmm0,%xmm12
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  65,15,194,204,1                     // cmpltps       %xmm12,%xmm1
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  65,15,89,195                        // mulps         %xmm11,%xmm0
  .byte  68,15,84,225                        // andps         %xmm1,%xmm12
  .byte  15,85,200                           // andnps        %xmm0,%xmm1
  .byte  65,15,86,204                        // orps          %xmm12,%xmm1
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  15,194,208,1                        // cmpltps       %xmm0,%xmm2
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  15,84,194                           // andps         %xmm2,%xmm0
  .byte  65,15,85,209                        // andnps        %xmm9,%xmm2
  .byte  15,86,208                           // orps          %xmm0,%xmm2
  .byte  68,15,89,5,240,55,1,0               // mulps         0x137f0(%rip),%xmm8        # 3af40 <_sk_srcover_bgra_8888_sse2_lowp+0xfd8>
  .byte  15,89,21,249,55,1,0                 // mulps         0x137f9(%rip),%xmm2        # 3af50 <_sk_srcover_bgra_8888_sse2_lowp+0xfe8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_a8_sse2
.globl _sk_load_a8_sse2
FUNCTION(_sk_load_a8_sse2)
_sk_load_a8_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,46                              // jne           277a5 <_sk_load_a8_sse2+0x46>
  .byte  102,67,15,110,4,16                  // movd          (%r8,%r10,1),%xmm0
  .byte  102,15,96,192                       // punpcklbw     %xmm0,%xmm0
  .byte  102,15,97,192                       // punpcklwd     %xmm0,%xmm0
  .byte  102,15,219,5,115,52,1,0             // pand          0x13473(%rip),%xmm0        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  15,91,216                           // cvtdq2ps      %xmm0,%xmm3
  .byte  15,89,29,201,53,1,0                 // mulps         0x135c9(%rip),%xmm3        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  102,15,87,201                       // xorpd         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,54                              // je            277e8 <_sk_load_a8_sse2+0x89>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            277d1 <_sk_load_a8_sse2+0x72>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,195                             // jne           27785 <_sk_load_a8_sse2+0x26>
  .byte  67,15,182,68,16,2                   // movzbl        0x2(%r8,%r10,1),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,15,112,192,69                   // pshufd        $0x45,%xmm0,%xmm0
  .byte  67,15,183,4,16                      // movzwl        (%r8,%r10,1),%eax
  .byte  102,15,110,200                      // movd          %eax,%xmm1
  .byte  102,15,96,200                       // punpcklbw     %xmm0,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  242,15,16,193                       // movsd         %xmm1,%xmm0
  .byte  235,157                             // jmp           27785 <_sk_load_a8_sse2+0x26>
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  235,146                             // jmp           27785 <_sk_load_a8_sse2+0x26>

HIDDEN _sk_load_a8_dst_sse2
.globl _sk_load_a8_dst_sse2
FUNCTION(_sk_load_a8_dst_sse2)
_sk_load_a8_dst_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,46                              // jne           27839 <_sk_load_a8_dst_sse2+0x46>
  .byte  102,67,15,110,36,16                 // movd          (%r8,%r10,1),%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  102,15,97,224                       // punpcklwd     %xmm0,%xmm4
  .byte  102,15,219,37,223,51,1,0            // pand          0x133df(%rip),%xmm4        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  15,91,252                           // cvtdq2ps      %xmm4,%xmm7
  .byte  15,89,61,53,53,1,0                  // mulps         0x13535(%rip),%xmm7        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  102,15,87,237                       // xorpd         %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,54                              // je            2787c <_sk_load_a8_dst_sse2+0x89>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            27865 <_sk_load_a8_dst_sse2+0x72>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,195                             // jne           27819 <_sk_load_a8_dst_sse2+0x26>
  .byte  67,15,182,68,16,2                   // movzbl        0x2(%r8,%r10,1),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  102,15,112,228,69                   // pshufd        $0x45,%xmm4,%xmm4
  .byte  67,15,183,4,16                      // movzwl        (%r8,%r10,1),%eax
  .byte  102,15,110,232                      // movd          %eax,%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  102,15,97,232                       // punpcklwd     %xmm0,%xmm5
  .byte  242,15,16,229                       // movsd         %xmm5,%xmm4
  .byte  235,157                             // jmp           27819 <_sk_load_a8_dst_sse2+0x26>
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  235,146                             // jmp           27819 <_sk_load_a8_dst_sse2+0x26>

HIDDEN _sk_gather_a8_sse2
.globl _sk_gather_a8_sse2
FUNCTION(_sk_gather_a8_sse2)
_sk_gather_a8_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,88,12                     // movss         0xc(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,65,15,254,217                   // paddd         %xmm9,%xmm3
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,95,208                           // maxps         %xmm0,%xmm2
  .byte  15,93,211                           // minps         %xmm3,%xmm2
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,193                   // paddd         %xmm9,%xmm0
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,216,245                  // pshufd        $0xf5,%xmm0,%xmm3
  .byte  102,15,244,217                      // pmuludq       %xmm1,%xmm3
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,203,232                  // pshufd        $0xe8,%xmm3,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,15,91,202                       // cvttps2dq     %xmm2,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,73,15,126,194                   // movq          %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,182,28,24                     // movzbl        (%r8,%r11,1),%r11d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  65,193,226,8                        // shl           $0x8,%r10d
  .byte  69,9,218                            // or            %r11d,%r10d
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  193,224,8                           // shl           $0x8,%eax
  .byte  68,9,200                            // or            %r9d,%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,65,15,196,194,1                 // pinsrw        $0x1,%r10d,%xmm0
  .byte  102,65,15,96,192                    // punpcklbw     %xmm8,%xmm0
  .byte  102,65,15,97,192                    // punpcklwd     %xmm8,%xmm0
  .byte  15,91,216                           // cvtdq2ps      %xmm0,%xmm3
  .byte  15,89,29,15,52,1,0                  // mulps         0x1340f(%rip),%xmm3        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_a8_sse2
.globl _sk_store_a8_sse2
FUNCTION(_sk_store_a8_sse2)
_sk_store_a8_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  68,15,95,195                        // maxps         %xmm3,%xmm8
  .byte  68,15,93,5,206,49,1,0               // minps         0x131ce(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  68,15,89,5,166,50,1,0               // mulps         0x132a6(%rip),%xmm8        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  102,69,15,91,192                    // cvtps2dq      %xmm8,%xmm8
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,114,224,16                // psrad         $0x10,%xmm8
  .byte  102,68,15,107,192                   // packssdw      %xmm0,%xmm8
  .byte  102,68,15,103,192                   // packuswb      %xmm0,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,13                              // jne           279b7 <_sk_store_a8_sse2+0x58>
  .byte  102,68,15,126,192                   // movd          %xmm8,%eax
  .byte  67,137,4,16                         // mov           %eax,(%r8,%r10,1)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,68,15,96,192                    // punpcklbw     %xmm0,%xmm8
  .byte  102,68,15,97,192                    // punpcklwd     %xmm0,%xmm8
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,54                              // je            27a04 <_sk_store_a8_sse2+0xa5>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,17                              // je            279e5 <_sk_store_a8_sse2+0x86>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,217                             // jne           279b3 <_sk_store_a8_sse2+0x54>
  .byte  102,65,15,197,192,4                 // pextrw        $0x4,%xmm8,%eax
  .byte  67,136,68,16,2                      // mov           %al,0x2(%r8,%r10,1)
  .byte  102,68,15,219,5,18,50,1,0           // pand          0x13212(%rip),%xmm8        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,69,15,103,192                   // packuswb      %xmm8,%xmm8
  .byte  102,69,15,103,192                   // packuswb      %xmm8,%xmm8
  .byte  102,68,15,126,192                   // movd          %xmm8,%eax
  .byte  102,67,137,4,16                     // mov           %ax,(%r8,%r10,1)
  .byte  235,175                             // jmp           279b3 <_sk_store_a8_sse2+0x54>
  .byte  102,68,15,126,192                   // movd          %xmm8,%eax
  .byte  67,136,4,16                         // mov           %al,(%r8,%r10,1)
  .byte  235,164                             // jmp           279b3 <_sk_store_a8_sse2+0x54>

HIDDEN _sk_load_g8_sse2
.globl _sk_load_g8_sse2
FUNCTION(_sk_load_g8_sse2)
_sk_load_g8_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,49                              // jne           27a58 <_sk_load_g8_sse2+0x49>
  .byte  102,67,15,110,4,16                  // movd          (%r8,%r10,1),%xmm0
  .byte  102,15,96,192                       // punpcklbw     %xmm0,%xmm0
  .byte  102,15,97,192                       // punpcklwd     %xmm0,%xmm0
  .byte  102,15,219,5,195,49,1,0             // pand          0x131c3(%rip),%xmm0        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,5,25,51,1,0                   // mulps         0x13319(%rip),%xmm0        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,0,49,1,0                   // movaps        0x13100(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,54                              // je            27a9b <_sk_load_g8_sse2+0x8c>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            27a84 <_sk_load_g8_sse2+0x75>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,192                             // jne           27a35 <_sk_load_g8_sse2+0x26>
  .byte  67,15,182,68,16,2                   // movzbl        0x2(%r8,%r10,1),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,15,112,192,69                   // pshufd        $0x45,%xmm0,%xmm0
  .byte  67,15,183,4,16                      // movzwl        (%r8,%r10,1),%eax
  .byte  102,15,110,200                      // movd          %eax,%xmm1
  .byte  102,15,96,200                       // punpcklbw     %xmm0,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  242,15,16,193                       // movsd         %xmm1,%xmm0
  .byte  235,154                             // jmp           27a35 <_sk_load_g8_sse2+0x26>
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  235,143                             // jmp           27a35 <_sk_load_g8_sse2+0x26>

HIDDEN _sk_load_g8_dst_sse2
.globl _sk_load_g8_dst_sse2
FUNCTION(_sk_load_g8_dst_sse2)
_sk_load_g8_dst_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,49                              // jne           27aef <_sk_load_g8_dst_sse2+0x49>
  .byte  102,67,15,110,36,16                 // movd          (%r8,%r10,1),%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  102,15,97,224                       // punpcklwd     %xmm0,%xmm4
  .byte  102,15,219,37,44,49,1,0             // pand          0x1312c(%rip),%xmm4        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,37,130,50,1,0                 // mulps         0x13282(%rip),%xmm4        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,61,105,48,1,0                 // movaps        0x13069(%rip),%xmm7        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,40,244                           // movaps        %xmm4,%xmm6
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,54                              // je            27b32 <_sk_load_g8_dst_sse2+0x8c>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            27b1b <_sk_load_g8_dst_sse2+0x75>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,192                             // jne           27acc <_sk_load_g8_dst_sse2+0x26>
  .byte  67,15,182,68,16,2                   // movzbl        0x2(%r8,%r10,1),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  102,15,112,228,69                   // pshufd        $0x45,%xmm4,%xmm4
  .byte  67,15,183,4,16                      // movzwl        (%r8,%r10,1),%eax
  .byte  102,15,110,232                      // movd          %eax,%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  102,15,97,232                       // punpcklwd     %xmm0,%xmm5
  .byte  242,15,16,229                       // movsd         %xmm5,%xmm4
  .byte  235,154                             // jmp           27acc <_sk_load_g8_dst_sse2+0x26>
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  235,143                             // jmp           27acc <_sk_load_g8_dst_sse2+0x26>

HIDDEN _sk_gather_g8_sse2
.globl _sk_gather_g8_sse2
FUNCTION(_sk_gather_g8_sse2)
_sk_gather_g8_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,88,12                     // movss         0xc(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,65,15,254,217                   // paddd         %xmm9,%xmm3
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,95,208                           // maxps         %xmm0,%xmm2
  .byte  15,93,211                           // minps         %xmm3,%xmm2
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,193                   // paddd         %xmm9,%xmm0
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,216,245                  // pshufd        $0xf5,%xmm0,%xmm3
  .byte  102,15,244,217                      // pmuludq       %xmm1,%xmm3
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,203,232                  // pshufd        $0xe8,%xmm3,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,15,91,202                       // cvttps2dq     %xmm2,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,73,15,126,194                   // movq          %xmm0,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,182,28,24                     // movzbl        (%r8,%r11,1),%r11d
  .byte  71,15,182,20,16                     // movzbl        (%r8,%r10,1),%r10d
  .byte  65,193,226,8                        // shl           $0x8,%r10d
  .byte  69,9,218                            // or            %r11d,%r10d
  .byte  71,15,182,12,8                      // movzbl        (%r8,%r9,1),%r9d
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  193,224,8                           // shl           $0x8,%eax
  .byte  68,9,200                            // or            %r9d,%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,65,15,196,194,1                 // pinsrw        $0x1,%r10d,%xmm0
  .byte  102,65,15,96,192                    // punpcklbw     %xmm8,%xmm0
  .byte  102,65,15,97,192                    // punpcklwd     %xmm8,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,5,89,49,1,0                   // mulps         0x13159(%rip),%xmm0        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,64,47,1,0                  // movaps        0x12f40(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_565_sse2
.globl _sk_load_565_sse2
FUNCTION(_sk_load_565_sse2)
_sk_load_565_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,83                              // jne           27c86 <_sk_load_565_sse2+0x6e>
  .byte  243,67,15,126,20,80                 // movq          (%r8,%r10,2),%xmm2
  .byte  102,15,97,208                       // punpcklwd     %xmm0,%xmm2
  .byte  102,15,111,5,43,49,1,0              // movdqa        0x1312b(%rip),%xmm0        # 3ad70 <_sk_srcover_bgra_8888_sse2_lowp+0xe08>
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,5,45,49,1,0                   // mulps         0x1312d(%rip),%xmm0        # 3ad80 <_sk_srcover_bgra_8888_sse2_lowp+0xe18>
  .byte  102,15,111,13,53,49,1,0             // movdqa        0x13135(%rip),%xmm1        # 3ad90 <_sk_srcover_bgra_8888_sse2_lowp+0xe28>
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,13,55,49,1,0                  // mulps         0x13137(%rip),%xmm1        # 3ada0 <_sk_srcover_bgra_8888_sse2_lowp+0xe38>
  .byte  102,15,219,21,63,49,1,0             // pand          0x1313f(%rip),%xmm2        # 3adb0 <_sk_srcover_bgra_8888_sse2_lowp+0xe48>
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,21,69,49,1,0                  // mulps         0x13145(%rip),%xmm2        # 3adc0 <_sk_srcover_bgra_8888_sse2_lowp+0xe58>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,204,46,1,0                 // movaps        0x12ecc(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,51                              // je            27cc6 <_sk_load_565_sse2+0xae>
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            27cb2 <_sk_load_565_sse2+0x9a>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,154                             // jne           27c3d <_sk_load_565_sse2+0x25>
  .byte  67,15,183,68,80,4                   // movzwl        0x4(%r8,%r10,2),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,15,112,208,69                   // pshufd        $0x45,%xmm0,%xmm2
  .byte  102,67,15,110,4,80                  // movd          (%r8,%r10,2),%xmm0
  .byte  242,15,112,192,212                  // pshuflw       $0xd4,%xmm0,%xmm0
  .byte  242,15,16,208                       // movsd         %xmm0,%xmm2
  .byte  233,119,255,255,255                 // jmpq          27c3d <_sk_load_565_sse2+0x25>
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  102,15,110,208                      // movd          %eax,%xmm2
  .byte  233,105,255,255,255                 // jmpq          27c3d <_sk_load_565_sse2+0x25>

HIDDEN _sk_load_565_dst_sse2
.globl _sk_load_565_dst_sse2
FUNCTION(_sk_load_565_dst_sse2)
_sk_load_565_dst_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,83                              // jne           27d42 <_sk_load_565_dst_sse2+0x6e>
  .byte  243,67,15,126,52,80                 // movq          (%r8,%r10,2),%xmm6
  .byte  102,15,97,240                       // punpcklwd     %xmm0,%xmm6
  .byte  102,15,111,37,111,48,1,0            // movdqa        0x1306f(%rip),%xmm4        # 3ad70 <_sk_srcover_bgra_8888_sse2_lowp+0xe08>
  .byte  102,15,219,230                      // pand          %xmm6,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,37,113,48,1,0                 // mulps         0x13071(%rip),%xmm4        # 3ad80 <_sk_srcover_bgra_8888_sse2_lowp+0xe18>
  .byte  102,15,111,45,121,48,1,0            // movdqa        0x13079(%rip),%xmm5        # 3ad90 <_sk_srcover_bgra_8888_sse2_lowp+0xe28>
  .byte  102,15,219,238                      // pand          %xmm6,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  15,89,45,123,48,1,0                 // mulps         0x1307b(%rip),%xmm5        # 3ada0 <_sk_srcover_bgra_8888_sse2_lowp+0xe38>
  .byte  102,15,219,53,131,48,1,0            // pand          0x13083(%rip),%xmm6        # 3adb0 <_sk_srcover_bgra_8888_sse2_lowp+0xe48>
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,89,53,137,48,1,0                 // mulps         0x13089(%rip),%xmm6        # 3adc0 <_sk_srcover_bgra_8888_sse2_lowp+0xe58>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,61,16,46,1,0                  // movaps        0x12e10(%rip),%xmm7        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,51                              // je            27d82 <_sk_load_565_dst_sse2+0xae>
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            27d6e <_sk_load_565_dst_sse2+0x9a>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,154                             // jne           27cf9 <_sk_load_565_dst_sse2+0x25>
  .byte  67,15,183,68,80,4                   // movzwl        0x4(%r8,%r10,2),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  102,15,112,244,69                   // pshufd        $0x45,%xmm4,%xmm6
  .byte  102,67,15,110,36,80                 // movd          (%r8,%r10,2),%xmm4
  .byte  242,15,112,228,212                  // pshuflw       $0xd4,%xmm4,%xmm4
  .byte  242,15,16,244                       // movsd         %xmm4,%xmm6
  .byte  233,119,255,255,255                 // jmpq          27cf9 <_sk_load_565_dst_sse2+0x25>
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  102,15,110,240                      // movd          %eax,%xmm6
  .byte  233,105,255,255,255                 // jmpq          27cf9 <_sk_load_565_dst_sse2+0x25>

HIDDEN _sk_gather_565_sse2
.globl _sk_gather_565_sse2
FUNCTION(_sk_gather_565_sse2)
_sk_gather_565_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,88,12                     // movss         0xc(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,65,15,254,217                   // paddd         %xmm9,%xmm3
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,95,208                           // maxps         %xmm0,%xmm2
  .byte  15,93,211                           // minps         %xmm3,%xmm2
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,193                   // paddd         %xmm9,%xmm0
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,216,245                  // pshufd        $0xf5,%xmm0,%xmm3
  .byte  102,15,244,217                      // pmuludq       %xmm1,%xmm3
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,203,232                  // pshufd        $0xe8,%xmm3,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,15,91,202                       // cvttps2dq     %xmm2,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,183,20,80                     // movzwl        (%r8,%r10,2),%r10d
  .byte  71,15,183,28,88                     // movzwl        (%r8,%r11,2),%r11d
  .byte  102,65,15,110,211                   // movd          %r11d,%xmm2
  .byte  102,65,15,196,210,1                 // pinsrw        $0x1,%r10d,%xmm2
  .byte  71,15,183,12,72                     // movzwl        (%r8,%r9,2),%r9d
  .byte  102,65,15,196,209,2                 // pinsrw        $0x2,%r9d,%xmm2
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  102,15,196,208,3                    // pinsrw        $0x3,%eax,%xmm2
  .byte  102,65,15,97,208                    // punpcklwd     %xmm8,%xmm2
  .byte  102,15,111,5,30,47,1,0              // movdqa        0x12f1e(%rip),%xmm0        # 3ad70 <_sk_srcover_bgra_8888_sse2_lowp+0xe08>
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,5,32,47,1,0                   // mulps         0x12f20(%rip),%xmm0        # 3ad80 <_sk_srcover_bgra_8888_sse2_lowp+0xe18>
  .byte  102,15,111,13,40,47,1,0             // movdqa        0x12f28(%rip),%xmm1        # 3ad90 <_sk_srcover_bgra_8888_sse2_lowp+0xe28>
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,13,42,47,1,0                  // mulps         0x12f2a(%rip),%xmm1        # 3ada0 <_sk_srcover_bgra_8888_sse2_lowp+0xe38>
  .byte  102,15,219,21,50,47,1,0             // pand          0x12f32(%rip),%xmm2        # 3adb0 <_sk_srcover_bgra_8888_sse2_lowp+0xe48>
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,21,56,47,1,0                  // mulps         0x12f38(%rip),%xmm2        # 3adc0 <_sk_srcover_bgra_8888_sse2_lowp+0xe58>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,191,44,1,0                 // movaps        0x12cbf(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_565_sse2
.globl _sk_store_565_sse2
FUNCTION(_sk_store_565_sse2)
_sk_store_565_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,40,21,147,44,1,0              // movaps        0x12c93(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  68,15,40,29,167,48,1,0              // movaps        0x130a7(%rip),%xmm11        # 3af70 <_sk_srcover_bgra_8888_sse2_lowp+0x1008>
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  102,65,15,114,241,11                // pslld         $0xb,%xmm9
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  68,15,89,37,148,48,1,0              // mulps         0x13094(%rip),%xmm12        # 3af80 <_sk_srcover_bgra_8888_sse2_lowp+0x1018>
  .byte  102,69,15,91,228                    // cvtps2dq      %xmm12,%xmm12
  .byte  102,65,15,114,244,5                 // pslld         $0x5,%xmm12
  .byte  68,15,95,194                        // maxps         %xmm2,%xmm8
  .byte  69,15,93,194                        // minps         %xmm10,%xmm8
  .byte  69,15,89,195                        // mulps         %xmm11,%xmm8
  .byte  102,69,15,91,192                    // cvtps2dq      %xmm8,%xmm8
  .byte  102,69,15,86,193                    // orpd          %xmm9,%xmm8
  .byte  102,69,15,86,196                    // orpd          %xmm12,%xmm8
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,114,224,16                // psrad         $0x10,%xmm8
  .byte  102,68,15,107,192                   // packssdw      %xmm0,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           27f32 <_sk_store_565_sse2+0x9f>
  .byte  102,71,15,214,4,80                  // movq          %xmm8,(%r8,%r10,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,68,15,97,192                    // punpcklwd     %xmm0,%xmm8
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,38                              // je            27f6a <_sk_store_565_sse2+0xd7>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,18                              // je            27f5c <_sk_store_565_sse2+0xc9>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,222                             // jne           27f2e <_sk_store_565_sse2+0x9b>
  .byte  102,65,15,197,192,4                 // pextrw        $0x4,%xmm8,%eax
  .byte  102,67,137,68,80,4                  // mov           %ax,0x4(%r8,%r10,2)
  .byte  242,69,15,112,192,232               // pshuflw       $0xe8,%xmm8,%xmm8
  .byte  102,71,15,126,4,80                  // movd          %xmm8,(%r8,%r10,2)
  .byte  235,196                             // jmp           27f2e <_sk_store_565_sse2+0x9b>
  .byte  102,68,15,126,192                   // movd          %xmm8,%eax
  .byte  102,67,137,4,80                     // mov           %ax,(%r8,%r10,2)
  .byte  235,184                             // jmp           27f2e <_sk_store_565_sse2+0x9b>

HIDDEN _sk_load_4444_sse2
.globl _sk_load_4444_sse2
FUNCTION(_sk_load_4444_sse2)
_sk_load_4444_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,98                              // jne           27ff3 <_sk_load_4444_sse2+0x7d>
  .byte  243,67,15,126,28,80                 // movq          (%r8,%r10,2),%xmm3
  .byte  102,15,97,216                       // punpcklwd     %xmm0,%xmm3
  .byte  102,15,111,5,237,47,1,0             // movdqa        0x12fed(%rip),%xmm0        # 3af90 <_sk_srcover_bgra_8888_sse2_lowp+0x1028>
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,5,239,47,1,0                  // mulps         0x12fef(%rip),%xmm0        # 3afa0 <_sk_srcover_bgra_8888_sse2_lowp+0x1038>
  .byte  102,15,111,13,247,47,1,0            // movdqa        0x12ff7(%rip),%xmm1        # 3afb0 <_sk_srcover_bgra_8888_sse2_lowp+0x1048>
  .byte  102,15,219,203                      // pand          %xmm3,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,13,249,47,1,0                 // mulps         0x12ff9(%rip),%xmm1        # 3afc0 <_sk_srcover_bgra_8888_sse2_lowp+0x1058>
  .byte  102,15,111,21,1,48,1,0              // movdqa        0x13001(%rip),%xmm2        # 3afd0 <_sk_srcover_bgra_8888_sse2_lowp+0x1068>
  .byte  102,15,219,211                      // pand          %xmm3,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,21,3,48,1,0                   // mulps         0x13003(%rip),%xmm2        # 3afe0 <_sk_srcover_bgra_8888_sse2_lowp+0x1078>
  .byte  102,15,219,29,11,48,1,0             // pand          0x1300b(%rip),%xmm3        # 3aff0 <_sk_srcover_bgra_8888_sse2_lowp+0x1088>
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,29,17,48,1,0                  // mulps         0x13011(%rip),%xmm3        # 3b000 <_sk_srcover_bgra_8888_sse2_lowp+0x1098>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,51                              // je            28033 <_sk_load_4444_sse2+0xbd>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            2801f <_sk_load_4444_sse2+0xa9>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,139                             // jne           27f9b <_sk_load_4444_sse2+0x25>
  .byte  67,15,183,68,80,4                   // movzwl        0x4(%r8,%r10,2),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,15,112,216,69                   // pshufd        $0x45,%xmm0,%xmm3
  .byte  102,67,15,110,4,80                  // movd          (%r8,%r10,2),%xmm0
  .byte  242,15,112,192,212                  // pshuflw       $0xd4,%xmm0,%xmm0
  .byte  242,15,16,216                       // movsd         %xmm0,%xmm3
  .byte  233,104,255,255,255                 // jmpq          27f9b <_sk_load_4444_sse2+0x25>
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  102,15,110,216                      // movd          %eax,%xmm3
  .byte  233,90,255,255,255                  // jmpq          27f9b <_sk_load_4444_sse2+0x25>

HIDDEN _sk_load_4444_dst_sse2
.globl _sk_load_4444_dst_sse2
FUNCTION(_sk_load_4444_dst_sse2)
_sk_load_4444_dst_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,98                              // jne           280be <_sk_load_4444_dst_sse2+0x7d>
  .byte  243,67,15,126,60,80                 // movq          (%r8,%r10,2),%xmm7
  .byte  102,15,97,248                       // punpcklwd     %xmm0,%xmm7
  .byte  102,15,111,37,34,47,1,0             // movdqa        0x12f22(%rip),%xmm4        # 3af90 <_sk_srcover_bgra_8888_sse2_lowp+0x1028>
  .byte  102,15,219,231                      // pand          %xmm7,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,37,36,47,1,0                  // mulps         0x12f24(%rip),%xmm4        # 3afa0 <_sk_srcover_bgra_8888_sse2_lowp+0x1038>
  .byte  102,15,111,45,44,47,1,0             // movdqa        0x12f2c(%rip),%xmm5        # 3afb0 <_sk_srcover_bgra_8888_sse2_lowp+0x1048>
  .byte  102,15,219,239                      // pand          %xmm7,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  15,89,45,46,47,1,0                  // mulps         0x12f2e(%rip),%xmm5        # 3afc0 <_sk_srcover_bgra_8888_sse2_lowp+0x1058>
  .byte  102,15,111,53,54,47,1,0             // movdqa        0x12f36(%rip),%xmm6        # 3afd0 <_sk_srcover_bgra_8888_sse2_lowp+0x1068>
  .byte  102,15,219,247                      // pand          %xmm7,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,89,53,56,47,1,0                  // mulps         0x12f38(%rip),%xmm6        # 3afe0 <_sk_srcover_bgra_8888_sse2_lowp+0x1078>
  .byte  102,15,219,61,64,47,1,0             // pand          0x12f40(%rip),%xmm7        # 3aff0 <_sk_srcover_bgra_8888_sse2_lowp+0x1088>
  .byte  15,91,255                           // cvtdq2ps      %xmm7,%xmm7
  .byte  15,89,61,70,47,1,0                  // mulps         0x12f46(%rip),%xmm7        # 3b000 <_sk_srcover_bgra_8888_sse2_lowp+0x1098>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,51                              // je            280fe <_sk_load_4444_dst_sse2+0xbd>
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,21                              // je            280ea <_sk_load_4444_dst_sse2+0xa9>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,139                             // jne           28066 <_sk_load_4444_dst_sse2+0x25>
  .byte  67,15,183,68,80,4                   // movzwl        0x4(%r8,%r10,2),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  102,15,112,252,69                   // pshufd        $0x45,%xmm4,%xmm7
  .byte  102,67,15,110,36,80                 // movd          (%r8,%r10,2),%xmm4
  .byte  242,15,112,228,212                  // pshuflw       $0xd4,%xmm4,%xmm4
  .byte  242,15,16,252                       // movsd         %xmm4,%xmm7
  .byte  233,104,255,255,255                 // jmpq          28066 <_sk_load_4444_dst_sse2+0x25>
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  102,15,110,248                      // movd          %eax,%xmm7
  .byte  233,90,255,255,255                  // jmpq          28066 <_sk_load_4444_dst_sse2+0x25>

HIDDEN _sk_gather_4444_sse2
.globl _sk_gather_4444_sse2
FUNCTION(_sk_gather_4444_sse2)
_sk_gather_4444_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,88,12                     // movss         0xc(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,65,15,254,217                   // paddd         %xmm9,%xmm3
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,95,208                           // maxps         %xmm0,%xmm2
  .byte  15,93,211                           // minps         %xmm3,%xmm2
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,193                   // paddd         %xmm9,%xmm0
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,216,245                  // pshufd        $0xf5,%xmm0,%xmm3
  .byte  102,15,244,217                      // pmuludq       %xmm1,%xmm3
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,203,232                  // pshufd        $0xe8,%xmm3,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,15,91,202                       // cvttps2dq     %xmm2,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  71,15,183,20,80                     // movzwl        (%r8,%r10,2),%r10d
  .byte  71,15,183,28,88                     // movzwl        (%r8,%r11,2),%r11d
  .byte  102,65,15,110,219                   // movd          %r11d,%xmm3
  .byte  102,65,15,196,218,1                 // pinsrw        $0x1,%r10d,%xmm3
  .byte  71,15,183,12,72                     // movzwl        (%r8,%r9,2),%r9d
  .byte  102,65,15,196,217,2                 // pinsrw        $0x2,%r9d,%xmm3
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  102,15,196,216,3                    // pinsrw        $0x3,%eax,%xmm3
  .byte  102,65,15,97,216                    // punpcklwd     %xmm8,%xmm3
  .byte  102,15,111,5,194,45,1,0             // movdqa        0x12dc2(%rip),%xmm0        # 3af90 <_sk_srcover_bgra_8888_sse2_lowp+0x1028>
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,5,196,45,1,0                  // mulps         0x12dc4(%rip),%xmm0        # 3afa0 <_sk_srcover_bgra_8888_sse2_lowp+0x1038>
  .byte  102,15,111,13,204,45,1,0            // movdqa        0x12dcc(%rip),%xmm1        # 3afb0 <_sk_srcover_bgra_8888_sse2_lowp+0x1048>
  .byte  102,15,219,203                      // pand          %xmm3,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,13,206,45,1,0                 // mulps         0x12dce(%rip),%xmm1        # 3afc0 <_sk_srcover_bgra_8888_sse2_lowp+0x1058>
  .byte  102,15,111,21,214,45,1,0            // movdqa        0x12dd6(%rip),%xmm2        # 3afd0 <_sk_srcover_bgra_8888_sse2_lowp+0x1068>
  .byte  102,15,219,211                      // pand          %xmm3,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,21,216,45,1,0                 // mulps         0x12dd8(%rip),%xmm2        # 3afe0 <_sk_srcover_bgra_8888_sse2_lowp+0x1078>
  .byte  102,15,219,29,224,45,1,0            // pand          0x12de0(%rip),%xmm3        # 3aff0 <_sk_srcover_bgra_8888_sse2_lowp+0x1088>
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,29,230,45,1,0                 // mulps         0x12de6(%rip),%xmm3        # 3b000 <_sk_srcover_bgra_8888_sse2_lowp+0x1098>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_4444_sse2
.globl _sk_store_4444_sse2
FUNCTION(_sk_store_4444_sse2)
_sk_store_4444_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  76,99,210                           // movslq        %edx,%r10
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,40,21,8,41,1,0                // movaps        0x12908(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  68,15,40,29,188,45,1,0              // movaps        0x12dbc(%rip),%xmm11        # 3b010 <_sk_srcover_bgra_8888_sse2_lowp+0x10a8>
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  102,65,15,114,241,12                // pslld         $0xc,%xmm9
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  102,69,15,91,228                    // cvtps2dq      %xmm12,%xmm12
  .byte  102,65,15,114,244,8                 // pslld         $0x8,%xmm12
  .byte  102,69,15,235,225                   // por           %xmm9,%xmm12
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  68,15,95,202                        // maxps         %xmm2,%xmm9
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  102,65,15,114,241,4                 // pslld         $0x4,%xmm9
  .byte  68,15,95,195                        // maxps         %xmm3,%xmm8
  .byte  69,15,93,194                        // minps         %xmm10,%xmm8
  .byte  69,15,89,195                        // mulps         %xmm11,%xmm8
  .byte  102,69,15,91,192                    // cvtps2dq      %xmm8,%xmm8
  .byte  102,69,15,86,193                    // orpd          %xmm9,%xmm8
  .byte  102,69,15,86,196                    // orpd          %xmm12,%xmm8
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,114,224,16                // psrad         $0x10,%xmm8
  .byte  102,68,15,107,192                   // packssdw      %xmm0,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           282da <_sk_store_4444_sse2+0xbc>
  .byte  102,71,15,214,4,80                  // movq          %xmm8,(%r8,%r10,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,68,15,97,192                    // punpcklwd     %xmm0,%xmm8
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,38                              // je            28312 <_sk_store_4444_sse2+0xf4>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,18                              // je            28304 <_sk_store_4444_sse2+0xe6>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,222                             // jne           282d6 <_sk_store_4444_sse2+0xb8>
  .byte  102,65,15,197,192,4                 // pextrw        $0x4,%xmm8,%eax
  .byte  102,67,137,68,80,4                  // mov           %ax,0x4(%r8,%r10,2)
  .byte  242,69,15,112,192,232               // pshuflw       $0xe8,%xmm8,%xmm8
  .byte  102,71,15,126,4,80                  // movd          %xmm8,(%r8,%r10,2)
  .byte  235,196                             // jmp           282d6 <_sk_store_4444_sse2+0xb8>
  .byte  102,68,15,126,192                   // movd          %xmm8,%eax
  .byte  102,67,137,4,80                     // mov           %ax,(%r8,%r10,2)
  .byte  235,184                             // jmp           282d6 <_sk_store_4444_sse2+0xb8>

HIDDEN _sk_load_8888_sse2
.globl _sk_load_8888_sse2
FUNCTION(_sk_load_8888_sse2)
_sk_load_8888_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,98                              // jne           2839c <_sk_load_8888_sse2+0x7e>
  .byte  243,69,15,111,12,128                // movdqu        (%r8,%rax,4),%xmm9
  .byte  102,15,111,21,184,40,1,0            // movdqa        0x128b8(%rip),%xmm2        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  68,15,40,5,4,42,1,0                 // movaps        0x12a04(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  102,15,114,209,8                    // psrld         $0x8,%xmm1
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  102,65,15,111,217                   // movdqa        %xmm9,%xmm3
  .byte  102,15,114,211,16                   // psrld         $0x10,%xmm3
  .byte  102,15,219,218                      // pand          %xmm2,%xmm3
  .byte  15,91,211                           // cvtdq2ps      %xmm3,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  102,65,15,114,209,24                // psrld         $0x18,%xmm9
  .byte  65,15,91,217                        // cvtdq2ps      %xmm9,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,41                              // je            283d2 <_sk_load_8888_sse2+0xb4>
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,19                              // je            283c7 <_sk_load_8888_sse2+0xa9>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,134                             // jne           28340 <_sk_load_8888_sse2+0x22>
  .byte  102,65,15,110,68,128,8              // movd          0x8(%r8,%rax,4),%xmm0
  .byte  102,68,15,112,200,69                // pshufd        $0x45,%xmm0,%xmm9
  .byte  102,69,15,18,12,128                 // movlpd        (%r8,%rax,4),%xmm9
  .byte  233,110,255,255,255                 // jmpq          28340 <_sk_load_8888_sse2+0x22>
  .byte  102,69,15,110,12,128                // movd          (%r8,%rax,4),%xmm9
  .byte  233,99,255,255,255                  // jmpq          28340 <_sk_load_8888_sse2+0x22>

HIDDEN _sk_load_8888_dst_sse2
.globl _sk_load_8888_dst_sse2
FUNCTION(_sk_load_8888_dst_sse2)
_sk_load_8888_dst_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,98                              // jne           2845b <_sk_load_8888_dst_sse2+0x7e>
  .byte  243,69,15,111,12,128                // movdqu        (%r8,%rax,4),%xmm9
  .byte  102,15,111,53,249,39,1,0            // movdqa        0x127f9(%rip),%xmm6        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,65,15,111,225                   // movdqa        %xmm9,%xmm4
  .byte  102,15,219,230                      // pand          %xmm6,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  68,15,40,5,69,41,1,0                // movaps        0x12945(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,224                        // mulps         %xmm8,%xmm4
  .byte  102,65,15,111,233                   // movdqa        %xmm9,%xmm5
  .byte  102,15,114,213,8                    // psrld         $0x8,%xmm5
  .byte  102,15,219,238                      // pand          %xmm6,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  65,15,89,232                        // mulps         %xmm8,%xmm5
  .byte  102,65,15,111,249                   // movdqa        %xmm9,%xmm7
  .byte  102,15,114,215,16                   // psrld         $0x10,%xmm7
  .byte  102,15,219,254                      // pand          %xmm6,%xmm7
  .byte  15,91,247                           // cvtdq2ps      %xmm7,%xmm6
  .byte  65,15,89,240                        // mulps         %xmm8,%xmm6
  .byte  102,65,15,114,209,24                // psrld         $0x18,%xmm9
  .byte  65,15,91,249                        // cvtdq2ps      %xmm9,%xmm7
  .byte  65,15,89,248                        // mulps         %xmm8,%xmm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,41                              // je            28491 <_sk_load_8888_dst_sse2+0xb4>
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,19                              // je            28486 <_sk_load_8888_dst_sse2+0xa9>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,134                             // jne           283ff <_sk_load_8888_dst_sse2+0x22>
  .byte  102,65,15,110,100,128,8             // movd          0x8(%r8,%rax,4),%xmm4
  .byte  102,68,15,112,204,69                // pshufd        $0x45,%xmm4,%xmm9
  .byte  102,69,15,18,12,128                 // movlpd        (%r8,%rax,4),%xmm9
  .byte  233,110,255,255,255                 // jmpq          283ff <_sk_load_8888_dst_sse2+0x22>
  .byte  102,69,15,110,12,128                // movd          (%r8,%rax,4),%xmm9
  .byte  233,99,255,255,255                  // jmpq          283ff <_sk_load_8888_dst_sse2+0x22>

HIDDEN _sk_gather_8888_sse2
.globl _sk_gather_8888_sse2
FUNCTION(_sk_gather_8888_sse2)
_sk_gather_8888_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,80,12                     // movss         0xc(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,69,15,118,192                   // pcmpeqd       %xmm8,%xmm8
  .byte  102,65,15,254,208                   // paddd         %xmm8,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,93,202                        // minps         %xmm2,%xmm9
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,192                   // paddd         %xmm8,%xmm0
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,208,245                  // pshufd        $0xf5,%xmm0,%xmm2
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,202,232                  // pshufd        $0xe8,%xmm2,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,65,15,91,201                    // cvttps2dq     %xmm9,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,67,15,110,4,144                 // movd          (%r8,%r10,4),%xmm0
  .byte  102,71,15,110,12,152                // movd          (%r8,%r11,4),%xmm9
  .byte  102,68,15,98,200                    // punpckldq     %xmm0,%xmm9
  .byte  102,65,15,110,4,128                 // movd          (%r8,%rax,4),%xmm0
  .byte  102,67,15,110,12,136                // movd          (%r8,%r9,4),%xmm1
  .byte  102,15,98,200                       // punpckldq     %xmm0,%xmm1
  .byte  102,68,15,108,201                   // punpcklqdq    %xmm1,%xmm9
  .byte  102,15,111,21,172,38,1,0            // movdqa        0x126ac(%rip),%xmm2        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  68,15,40,5,248,39,1,0               // movaps        0x127f8(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  102,15,114,209,8                    // psrld         $0x8,%xmm1
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  102,65,15,111,217                   // movdqa        %xmm9,%xmm3
  .byte  102,15,114,211,16                   // psrld         $0x10,%xmm3
  .byte  102,15,219,218                      // pand          %xmm2,%xmm3
  .byte  15,91,211                           // cvtdq2ps      %xmm3,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  102,65,15,114,209,24                // psrld         $0x18,%xmm9
  .byte  65,15,91,217                        // cvtdq2ps      %xmm9,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_8888_sse2
.globl _sk_store_8888_sse2
FUNCTION(_sk_store_8888_sse2)
_sk_store_8888_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,40,21,125,37,1,0              // movaps        0x1257d(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  68,15,40,29,81,38,1,0               // movaps        0x12651(%rip),%xmm11        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  102,69,15,91,228                    // cvtps2dq      %xmm12,%xmm12
  .byte  102,65,15,114,244,8                 // pslld         $0x8,%xmm12
  .byte  102,69,15,235,225                   // por           %xmm9,%xmm12
  .byte  102,69,15,87,201                    // xorpd         %xmm9,%xmm9
  .byte  68,15,95,202                        // maxps         %xmm2,%xmm9
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  102,65,15,114,241,16                // pslld         $0x10,%xmm9
  .byte  68,15,95,195                        // maxps         %xmm3,%xmm8
  .byte  69,15,93,194                        // minps         %xmm10,%xmm8
  .byte  69,15,89,195                        // mulps         %xmm11,%xmm8
  .byte  102,69,15,91,192                    // cvtps2dq      %xmm8,%xmm8
  .byte  102,65,15,114,240,24                // pslld         $0x18,%xmm8
  .byte  102,69,15,235,193                   // por           %xmm9,%xmm8
  .byte  102,69,15,235,196                   // por           %xmm12,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           28654 <_sk_store_8888_sse2+0xac>
  .byte  243,69,15,127,4,128                 // movdqu        %xmm8,(%r8,%rax,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,33                              // je            28682 <_sk_store_8888_sse2+0xda>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,19                              // je            2867a <_sk_store_8888_sse2+0xd2>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,227                             // jne           28650 <_sk_store_8888_sse2+0xa8>
  .byte  102,69,15,112,200,78                // pshufd        $0x4e,%xmm8,%xmm9
  .byte  102,69,15,126,76,128,8              // movd          %xmm9,0x8(%r8,%rax,4)
  .byte  102,69,15,214,4,128                 // movq          %xmm8,(%r8,%rax,4)
  .byte  235,206                             // jmp           28650 <_sk_store_8888_sse2+0xa8>
  .byte  102,69,15,126,4,128                 // movd          %xmm8,(%r8,%rax,4)
  .byte  235,198                             // jmp           28650 <_sk_store_8888_sse2+0xa8>

HIDDEN _sk_load_bgra_sse2
.globl _sk_load_bgra_sse2
FUNCTION(_sk_load_bgra_sse2)
_sk_load_bgra_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,98                              // jne           28708 <_sk_load_bgra_sse2+0x7e>
  .byte  243,69,15,111,12,128                // movdqu        (%r8,%rax,4),%xmm9
  .byte  102,15,111,5,76,37,1,0              // movdqa        0x1254c(%rip),%xmm0        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  102,15,219,200                      // pand          %xmm0,%xmm1
  .byte  15,91,209                           // cvtdq2ps      %xmm1,%xmm2
  .byte  68,15,40,5,152,38,1,0               // movaps        0x12698(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  102,15,114,209,8                    // psrld         $0x8,%xmm1
  .byte  102,15,219,200                      // pand          %xmm0,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  102,65,15,111,217                   // movdqa        %xmm9,%xmm3
  .byte  102,15,114,211,16                   // psrld         $0x10,%xmm3
  .byte  102,15,219,216                      // pand          %xmm0,%xmm3
  .byte  15,91,195                           // cvtdq2ps      %xmm3,%xmm0
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  102,65,15,114,209,24                // psrld         $0x18,%xmm9
  .byte  65,15,91,217                        // cvtdq2ps      %xmm9,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,41                              // je            2873e <_sk_load_bgra_sse2+0xb4>
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,19                              // je            28733 <_sk_load_bgra_sse2+0xa9>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,134                             // jne           286ac <_sk_load_bgra_sse2+0x22>
  .byte  102,65,15,110,68,128,8              // movd          0x8(%r8,%rax,4),%xmm0
  .byte  102,68,15,112,200,69                // pshufd        $0x45,%xmm0,%xmm9
  .byte  102,69,15,18,12,128                 // movlpd        (%r8,%rax,4),%xmm9
  .byte  233,110,255,255,255                 // jmpq          286ac <_sk_load_bgra_sse2+0x22>
  .byte  102,69,15,110,12,128                // movd          (%r8,%rax,4),%xmm9
  .byte  233,99,255,255,255                  // jmpq          286ac <_sk_load_bgra_sse2+0x22>

HIDDEN _sk_load_bgra_dst_sse2
.globl _sk_load_bgra_dst_sse2
FUNCTION(_sk_load_bgra_dst_sse2)
_sk_load_bgra_dst_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,98                              // jne           287c7 <_sk_load_bgra_dst_sse2+0x7e>
  .byte  243,69,15,111,12,128                // movdqu        (%r8,%rax,4),%xmm9
  .byte  102,15,111,37,141,36,1,0            // movdqa        0x1248d(%rip),%xmm4        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,65,15,111,233                   // movdqa        %xmm9,%xmm5
  .byte  102,15,219,236                      // pand          %xmm4,%xmm5
  .byte  15,91,245                           // cvtdq2ps      %xmm5,%xmm6
  .byte  68,15,40,5,217,37,1,0               // movaps        0x125d9(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,240                        // mulps         %xmm8,%xmm6
  .byte  102,65,15,111,233                   // movdqa        %xmm9,%xmm5
  .byte  102,15,114,213,8                    // psrld         $0x8,%xmm5
  .byte  102,15,219,236                      // pand          %xmm4,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  65,15,89,232                        // mulps         %xmm8,%xmm5
  .byte  102,65,15,111,249                   // movdqa        %xmm9,%xmm7
  .byte  102,15,114,215,16                   // psrld         $0x10,%xmm7
  .byte  102,15,219,252                      // pand          %xmm4,%xmm7
  .byte  15,91,231                           // cvtdq2ps      %xmm7,%xmm4
  .byte  65,15,89,224                        // mulps         %xmm8,%xmm4
  .byte  102,65,15,114,209,24                // psrld         $0x18,%xmm9
  .byte  65,15,91,249                        // cvtdq2ps      %xmm9,%xmm7
  .byte  65,15,89,248                        // mulps         %xmm8,%xmm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,41                              // je            287fd <_sk_load_bgra_dst_sse2+0xb4>
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,19                              // je            287f2 <_sk_load_bgra_dst_sse2+0xa9>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,134                             // jne           2876b <_sk_load_bgra_dst_sse2+0x22>
  .byte  102,65,15,110,100,128,8             // movd          0x8(%r8,%rax,4),%xmm4
  .byte  102,68,15,112,204,69                // pshufd        $0x45,%xmm4,%xmm9
  .byte  102,69,15,18,12,128                 // movlpd        (%r8,%rax,4),%xmm9
  .byte  233,110,255,255,255                 // jmpq          2876b <_sk_load_bgra_dst_sse2+0x22>
  .byte  102,69,15,110,12,128                // movd          (%r8,%rax,4),%xmm9
  .byte  233,99,255,255,255                  // jmpq          2876b <_sk_load_bgra_dst_sse2+0x22>

HIDDEN _sk_gather_bgra_sse2
.globl _sk_gather_bgra_sse2
FUNCTION(_sk_gather_bgra_sse2)
_sk_gather_bgra_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,80,12                     // movss         0xc(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,69,15,118,192                   // pcmpeqd       %xmm8,%xmm8
  .byte  102,65,15,254,208                   // paddd         %xmm8,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  68,15,93,202                        // minps         %xmm2,%xmm9
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,192                   // paddd         %xmm8,%xmm0
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,208,245                  // pshufd        $0xf5,%xmm0,%xmm2
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,202,232                  // pshufd        $0xe8,%xmm2,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,65,15,91,201                    // cvttps2dq     %xmm9,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,67,15,110,4,144                 // movd          (%r8,%r10,4),%xmm0
  .byte  102,71,15,110,12,152                // movd          (%r8,%r11,4),%xmm9
  .byte  102,68,15,98,200                    // punpckldq     %xmm0,%xmm9
  .byte  102,65,15,110,4,128                 // movd          (%r8,%rax,4),%xmm0
  .byte  102,67,15,110,12,136                // movd          (%r8,%r9,4),%xmm1
  .byte  102,15,98,200                       // punpckldq     %xmm0,%xmm1
  .byte  102,68,15,108,201                   // punpcklqdq    %xmm1,%xmm9
  .byte  102,15,111,5,64,35,1,0              // movdqa        0x12340(%rip),%xmm0        # 3ac00 <_sk_srcover_bgra_8888_sse2_lowp+0xc98>
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  102,15,219,200                      // pand          %xmm0,%xmm1
  .byte  15,91,209                           // cvtdq2ps      %xmm1,%xmm2
  .byte  68,15,40,5,140,36,1,0               // movaps        0x1248c(%rip),%xmm8        # 3ad60 <_sk_srcover_bgra_8888_sse2_lowp+0xdf8>
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  102,15,114,209,8                    // psrld         $0x8,%xmm1
  .byte  102,15,219,200                      // pand          %xmm0,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  102,65,15,111,217                   // movdqa        %xmm9,%xmm3
  .byte  102,15,114,211,16                   // psrld         $0x10,%xmm3
  .byte  102,15,219,216                      // pand          %xmm0,%xmm3
  .byte  15,91,195                           // cvtdq2ps      %xmm3,%xmm0
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  102,65,15,114,209,24                // psrld         $0x18,%xmm9
  .byte  65,15,91,217                        // cvtdq2ps      %xmm9,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_bgra_sse2
.globl _sk_store_bgra_sse2
FUNCTION(_sk_store_bgra_sse2)
_sk_store_bgra_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,95,202                        // maxps         %xmm2,%xmm9
  .byte  68,15,40,21,17,34,1,0               // movaps        0x12211(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  68,15,40,29,229,34,1,0              // movaps        0x122e5(%rip),%xmm11        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  102,69,15,91,228                    // cvtps2dq      %xmm12,%xmm12
  .byte  102,65,15,114,244,8                 // pslld         $0x8,%xmm12
  .byte  102,69,15,235,225                   // por           %xmm9,%xmm12
  .byte  102,69,15,87,201                    // xorpd         %xmm9,%xmm9
  .byte  68,15,95,200                        // maxps         %xmm0,%xmm9
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  102,65,15,114,241,16                // pslld         $0x10,%xmm9
  .byte  68,15,95,195                        // maxps         %xmm3,%xmm8
  .byte  69,15,93,194                        // minps         %xmm10,%xmm8
  .byte  69,15,89,195                        // mulps         %xmm11,%xmm8
  .byte  102,69,15,91,192                    // cvtps2dq      %xmm8,%xmm8
  .byte  102,65,15,114,240,24                // pslld         $0x18,%xmm8
  .byte  102,69,15,235,193                   // por           %xmm9,%xmm8
  .byte  102,69,15,235,196                   // por           %xmm12,%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,10                              // jne           289c0 <_sk_store_bgra_sse2+0xac>
  .byte  243,69,15,127,4,128                 // movdqu        %xmm8,(%r8,%rax,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,137,249                          // mov           %edi,%r9d
  .byte  65,128,225,3                        // and           $0x3,%r9b
  .byte  65,128,249,1                        // cmp           $0x1,%r9b
  .byte  116,33                              // je            289ee <_sk_store_bgra_sse2+0xda>
  .byte  65,128,249,2                        // cmp           $0x2,%r9b
  .byte  116,19                              // je            289e6 <_sk_store_bgra_sse2+0xd2>
  .byte  65,128,249,3                        // cmp           $0x3,%r9b
  .byte  117,227                             // jne           289bc <_sk_store_bgra_sse2+0xa8>
  .byte  102,69,15,112,200,78                // pshufd        $0x4e,%xmm8,%xmm9
  .byte  102,69,15,126,76,128,8              // movd          %xmm9,0x8(%r8,%rax,4)
  .byte  102,69,15,214,4,128                 // movq          %xmm8,(%r8,%rax,4)
  .byte  235,206                             // jmp           289bc <_sk_store_bgra_sse2+0xa8>
  .byte  102,69,15,126,4,128                 // movd          %xmm8,(%r8,%rax,4)
  .byte  235,198                             // jmp           289bc <_sk_store_bgra_sse2+0xa8>

HIDDEN _sk_load_f16_sse2
.globl _sk_load_f16_sse2
FUNCTION(_sk_load_f16_sse2)
_sk_load_f16_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,47,1,0,0                     // jne           28b45 <_sk_load_f16_sse2+0x14f>
  .byte  102,65,15,16,4,192                  // movupd        (%r8,%rax,8),%xmm0
  .byte  243,65,15,111,76,192,16             // movdqu        0x10(%r8,%rax,8),%xmm1
  .byte  102,68,15,40,192                    // movapd        %xmm0,%xmm8
  .byte  102,68,15,97,193                    // punpcklwd     %xmm1,%xmm8
  .byte  102,15,105,193                      // punpckhwd     %xmm1,%xmm0
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  102,15,97,208                       // punpcklwd     %xmm0,%xmm2
  .byte  102,68,15,105,192                   // punpckhwd     %xmm0,%xmm8
  .byte  102,69,15,239,210                   // pxor          %xmm10,%xmm10
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,65,15,97,202                    // punpcklwd     %xmm10,%xmm1
  .byte  102,68,15,111,13,202,37,1,0         // movdqa        0x125ca(%rip),%xmm9        # 3b020 <_sk_srcover_bgra_8888_sse2_lowp+0x10b8>
  .byte  102,68,15,111,225                   // movdqa        %xmm1,%xmm12
  .byte  102,69,15,219,225                   // pand          %xmm9,%xmm12
  .byte  102,68,15,111,29,199,37,1,0         // movdqa        0x125c7(%rip),%xmm11        # 3b030 <_sk_srcover_bgra_8888_sse2_lowp+0x10c8>
  .byte  102,65,15,219,203                   // pand          %xmm11,%xmm1
  .byte  102,15,111,29,202,37,1,0            // movdqa        0x125ca(%rip),%xmm3        # 3b040 <_sk_srcover_bgra_8888_sse2_lowp+0x10d8>
  .byte  102,65,15,114,244,16                // pslld         $0x10,%xmm12
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,102,193                      // pcmpgtd       %xmm1,%xmm0
  .byte  102,15,114,241,13                   // pslld         $0xd,%xmm1
  .byte  102,65,15,235,204                   // por           %xmm12,%xmm1
  .byte  102,68,15,111,37,185,37,1,0         // movdqa        0x125b9(%rip),%xmm12        # 3b050 <_sk_srcover_bgra_8888_sse2_lowp+0x10e8>
  .byte  102,65,15,254,204                   // paddd         %xmm12,%xmm1
  .byte  102,15,223,193                      // pandn         %xmm1,%xmm0
  .byte  102,65,15,105,210                   // punpckhwd     %xmm10,%xmm2
  .byte  102,68,15,111,234                   // movdqa        %xmm2,%xmm13
  .byte  102,69,15,219,233                   // pand          %xmm9,%xmm13
  .byte  102,65,15,219,211                   // pand          %xmm11,%xmm2
  .byte  102,65,15,114,245,16                // pslld         $0x10,%xmm13
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,102,202                      // pcmpgtd       %xmm2,%xmm1
  .byte  102,15,114,242,13                   // pslld         $0xd,%xmm2
  .byte  102,65,15,235,213                   // por           %xmm13,%xmm2
  .byte  102,65,15,254,212                   // paddd         %xmm12,%xmm2
  .byte  102,15,223,202                      // pandn         %xmm2,%xmm1
  .byte  102,69,15,111,232                   // movdqa        %xmm8,%xmm13
  .byte  102,69,15,97,234                    // punpcklwd     %xmm10,%xmm13
  .byte  102,69,15,111,245                   // movdqa        %xmm13,%xmm14
  .byte  102,69,15,219,241                   // pand          %xmm9,%xmm14
  .byte  102,69,15,219,235                   // pand          %xmm11,%xmm13
  .byte  102,65,15,114,246,16                // pslld         $0x10,%xmm14
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,65,15,102,213                   // pcmpgtd       %xmm13,%xmm2
  .byte  102,65,15,114,245,13                // pslld         $0xd,%xmm13
  .byte  102,69,15,235,238                   // por           %xmm14,%xmm13
  .byte  102,69,15,254,236                   // paddd         %xmm12,%xmm13
  .byte  102,65,15,223,213                   // pandn         %xmm13,%xmm2
  .byte  102,69,15,105,194                   // punpckhwd     %xmm10,%xmm8
  .byte  102,69,15,219,200                   // pand          %xmm8,%xmm9
  .byte  102,69,15,219,195                   // pand          %xmm11,%xmm8
  .byte  102,65,15,114,241,16                // pslld         $0x10,%xmm9
  .byte  102,65,15,102,216                   // pcmpgtd       %xmm8,%xmm3
  .byte  102,65,15,114,240,13                // pslld         $0xd,%xmm8
  .byte  102,69,15,235,193                   // por           %xmm9,%xmm8
  .byte  102,69,15,254,196                   // paddd         %xmm12,%xmm8
  .byte  102,65,15,223,216                   // pandn         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  242,65,15,16,4,192                  // movsd         (%r8,%rax,8),%xmm0
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,13                              // jne           28b5e <_sk_load_f16_sse2+0x168>
  .byte  243,15,126,192                      // movq          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  233,197,254,255,255                 // jmpq          28a23 <_sk_load_f16_sse2+0x2d>
  .byte  102,65,15,22,68,192,8               // movhpd        0x8(%r8,%rax,8),%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  15,130,176,254,255,255              // jb            28a23 <_sk_load_f16_sse2+0x2d>
  .byte  243,65,15,126,76,192,16             // movq          0x10(%r8,%rax,8),%xmm1
  .byte  233,164,254,255,255                 // jmpq          28a23 <_sk_load_f16_sse2+0x2d>

HIDDEN _sk_load_f16_dst_sse2
.globl _sk_load_f16_dst_sse2
FUNCTION(_sk_load_f16_dst_sse2)
_sk_load_f16_dst_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,47,1,0,0                     // jne           28cce <_sk_load_f16_dst_sse2+0x14f>
  .byte  102,65,15,16,36,192                 // movupd        (%r8,%rax,8),%xmm4
  .byte  243,65,15,111,108,192,16            // movdqu        0x10(%r8,%rax,8),%xmm5
  .byte  102,68,15,40,196                    // movapd        %xmm4,%xmm8
  .byte  102,68,15,97,197                    // punpcklwd     %xmm5,%xmm8
  .byte  102,15,105,229                      // punpckhwd     %xmm5,%xmm4
  .byte  102,65,15,111,240                   // movdqa        %xmm8,%xmm6
  .byte  102,15,97,244                       // punpcklwd     %xmm4,%xmm6
  .byte  102,68,15,105,196                   // punpckhwd     %xmm4,%xmm8
  .byte  102,69,15,239,210                   // pxor          %xmm10,%xmm10
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,65,15,97,234                    // punpcklwd     %xmm10,%xmm5
  .byte  102,68,15,111,13,65,36,1,0          // movdqa        0x12441(%rip),%xmm9        # 3b020 <_sk_srcover_bgra_8888_sse2_lowp+0x10b8>
  .byte  102,68,15,111,229                   // movdqa        %xmm5,%xmm12
  .byte  102,69,15,219,225                   // pand          %xmm9,%xmm12
  .byte  102,68,15,111,29,62,36,1,0          // movdqa        0x1243e(%rip),%xmm11        # 3b030 <_sk_srcover_bgra_8888_sse2_lowp+0x10c8>
  .byte  102,65,15,219,235                   // pand          %xmm11,%xmm5
  .byte  102,15,111,61,65,36,1,0             // movdqa        0x12441(%rip),%xmm7        # 3b040 <_sk_srcover_bgra_8888_sse2_lowp+0x10d8>
  .byte  102,65,15,114,244,16                // pslld         $0x10,%xmm12
  .byte  102,15,111,231                      // movdqa        %xmm7,%xmm4
  .byte  102,15,102,229                      // pcmpgtd       %xmm5,%xmm4
  .byte  102,15,114,245,13                   // pslld         $0xd,%xmm5
  .byte  102,65,15,235,236                   // por           %xmm12,%xmm5
  .byte  102,68,15,111,37,48,36,1,0          // movdqa        0x12430(%rip),%xmm12        # 3b050 <_sk_srcover_bgra_8888_sse2_lowp+0x10e8>
  .byte  102,65,15,254,236                   // paddd         %xmm12,%xmm5
  .byte  102,15,223,229                      // pandn         %xmm5,%xmm4
  .byte  102,65,15,105,242                   // punpckhwd     %xmm10,%xmm6
  .byte  102,68,15,111,238                   // movdqa        %xmm6,%xmm13
  .byte  102,69,15,219,233                   // pand          %xmm9,%xmm13
  .byte  102,65,15,219,243                   // pand          %xmm11,%xmm6
  .byte  102,65,15,114,245,16                // pslld         $0x10,%xmm13
  .byte  102,15,111,239                      // movdqa        %xmm7,%xmm5
  .byte  102,15,102,238                      // pcmpgtd       %xmm6,%xmm5
  .byte  102,15,114,246,13                   // pslld         $0xd,%xmm6
  .byte  102,65,15,235,245                   // por           %xmm13,%xmm6
  .byte  102,65,15,254,244                   // paddd         %xmm12,%xmm6
  .byte  102,15,223,238                      // pandn         %xmm6,%xmm5
  .byte  102,69,15,111,232                   // movdqa        %xmm8,%xmm13
  .byte  102,69,15,97,234                    // punpcklwd     %xmm10,%xmm13
  .byte  102,69,15,111,245                   // movdqa        %xmm13,%xmm14
  .byte  102,69,15,219,241                   // pand          %xmm9,%xmm14
  .byte  102,69,15,219,235                   // pand          %xmm11,%xmm13
  .byte  102,65,15,114,246,16                // pslld         $0x10,%xmm14
  .byte  102,15,111,247                      // movdqa        %xmm7,%xmm6
  .byte  102,65,15,102,245                   // pcmpgtd       %xmm13,%xmm6
  .byte  102,65,15,114,245,13                // pslld         $0xd,%xmm13
  .byte  102,69,15,235,238                   // por           %xmm14,%xmm13
  .byte  102,69,15,254,236                   // paddd         %xmm12,%xmm13
  .byte  102,65,15,223,245                   // pandn         %xmm13,%xmm6
  .byte  102,69,15,105,194                   // punpckhwd     %xmm10,%xmm8
  .byte  102,69,15,219,200                   // pand          %xmm8,%xmm9
  .byte  102,69,15,219,195                   // pand          %xmm11,%xmm8
  .byte  102,65,15,114,241,16                // pslld         $0x10,%xmm9
  .byte  102,65,15,102,248                   // pcmpgtd       %xmm8,%xmm7
  .byte  102,65,15,114,240,13                // pslld         $0xd,%xmm8
  .byte  102,69,15,235,193                   // por           %xmm9,%xmm8
  .byte  102,69,15,254,196                   // paddd         %xmm12,%xmm8
  .byte  102,65,15,223,248                   // pandn         %xmm8,%xmm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  242,65,15,16,36,192                 // movsd         (%r8,%rax,8),%xmm4
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,13                              // jne           28ce7 <_sk_load_f16_dst_sse2+0x168>
  .byte  243,15,126,228                      // movq          %xmm4,%xmm4
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  233,197,254,255,255                 // jmpq          28bac <_sk_load_f16_dst_sse2+0x2d>
  .byte  102,65,15,22,100,192,8              // movhpd        0x8(%r8,%rax,8),%xmm4
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  15,130,176,254,255,255              // jb            28bac <_sk_load_f16_dst_sse2+0x2d>
  .byte  243,65,15,126,108,192,16            // movq          0x10(%r8,%rax,8),%xmm5
  .byte  233,164,254,255,255                 // jmpq          28bac <_sk_load_f16_dst_sse2+0x2d>

HIDDEN _sk_gather_f16_sse2
.globl _sk_gather_f16_sse2
FUNCTION(_sk_gather_f16_sse2)
_sk_gather_f16_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,80,12                     // movss         0xc(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,65,15,254,209                   // paddd         %xmm9,%xmm2
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,95,216                           // maxps         %xmm0,%xmm3
  .byte  15,93,218                           // minps         %xmm2,%xmm3
  .byte  243,15,16,64,16                     // movss         0x10(%rax),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,65,15,254,193                   // paddd         %xmm9,%xmm0
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,95,209                           // maxps         %xmm1,%xmm2
  .byte  15,93,208                           // minps         %xmm0,%xmm2
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,15,91,194                       // cvttps2dq     %xmm2,%xmm0
  .byte  102,15,110,72,8                     // movd          0x8(%rax),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,208,245                  // pshufd        $0xf5,%xmm0,%xmm2
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,202,232                  // pshufd        $0xe8,%xmm2,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,15,91,203                       // cvttps2dq     %xmm3,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  243,67,15,126,4,208                 // movq          (%r8,%r10,8),%xmm0
  .byte  243,67,15,126,12,216                // movq          (%r8,%r11,8),%xmm1
  .byte  102,15,108,200                      // punpcklqdq    %xmm0,%xmm1
  .byte  243,65,15,126,4,192                 // movq          (%r8,%rax,8),%xmm0
  .byte  243,67,15,126,20,200                // movq          (%r8,%r9,8),%xmm2
  .byte  102,15,108,208                      // punpcklqdq    %xmm0,%xmm2
  .byte  102,68,15,111,201                   // movdqa        %xmm1,%xmm9
  .byte  102,68,15,97,202                    // punpcklwd     %xmm2,%xmm9
  .byte  102,15,105,202                      // punpckhwd     %xmm2,%xmm1
  .byte  102,65,15,111,209                   // movdqa        %xmm9,%xmm2
  .byte  102,15,97,209                       // punpcklwd     %xmm1,%xmm2
  .byte  102,68,15,105,201                   // punpckhwd     %xmm1,%xmm9
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,65,15,97,200                    // punpcklwd     %xmm8,%xmm1
  .byte  102,68,15,111,21,63,34,1,0          // movdqa        0x1223f(%rip),%xmm10        # 3b020 <_sk_srcover_bgra_8888_sse2_lowp+0x10b8>
  .byte  102,68,15,111,225                   // movdqa        %xmm1,%xmm12
  .byte  102,69,15,219,226                   // pand          %xmm10,%xmm12
  .byte  102,68,15,111,29,60,34,1,0          // movdqa        0x1223c(%rip),%xmm11        # 3b030 <_sk_srcover_bgra_8888_sse2_lowp+0x10c8>
  .byte  102,65,15,219,203                   // pand          %xmm11,%xmm1
  .byte  102,15,111,29,63,34,1,0             // movdqa        0x1223f(%rip),%xmm3        # 3b040 <_sk_srcover_bgra_8888_sse2_lowp+0x10d8>
  .byte  102,65,15,114,244,16                // pslld         $0x10,%xmm12
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,102,193                      // pcmpgtd       %xmm1,%xmm0
  .byte  102,15,114,241,13                   // pslld         $0xd,%xmm1
  .byte  102,65,15,235,204                   // por           %xmm12,%xmm1
  .byte  102,68,15,111,37,46,34,1,0          // movdqa        0x1222e(%rip),%xmm12        # 3b050 <_sk_srcover_bgra_8888_sse2_lowp+0x10e8>
  .byte  102,65,15,254,204                   // paddd         %xmm12,%xmm1
  .byte  102,15,223,193                      // pandn         %xmm1,%xmm0
  .byte  102,65,15,105,208                   // punpckhwd     %xmm8,%xmm2
  .byte  102,68,15,111,234                   // movdqa        %xmm2,%xmm13
  .byte  102,69,15,219,234                   // pand          %xmm10,%xmm13
  .byte  102,65,15,219,211                   // pand          %xmm11,%xmm2
  .byte  102,65,15,114,245,16                // pslld         $0x10,%xmm13
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,102,202                      // pcmpgtd       %xmm2,%xmm1
  .byte  102,15,114,242,13                   // pslld         $0xd,%xmm2
  .byte  102,65,15,235,213                   // por           %xmm13,%xmm2
  .byte  102,65,15,254,212                   // paddd         %xmm12,%xmm2
  .byte  102,15,223,202                      // pandn         %xmm2,%xmm1
  .byte  102,69,15,111,233                   // movdqa        %xmm9,%xmm13
  .byte  102,69,15,97,232                    // punpcklwd     %xmm8,%xmm13
  .byte  102,69,15,111,245                   // movdqa        %xmm13,%xmm14
  .byte  102,69,15,219,242                   // pand          %xmm10,%xmm14
  .byte  102,69,15,219,235                   // pand          %xmm11,%xmm13
  .byte  102,65,15,114,246,16                // pslld         $0x10,%xmm14
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,65,15,102,213                   // pcmpgtd       %xmm13,%xmm2
  .byte  102,65,15,114,245,13                // pslld         $0xd,%xmm13
  .byte  102,69,15,235,238                   // por           %xmm14,%xmm13
  .byte  102,69,15,254,236                   // paddd         %xmm12,%xmm13
  .byte  102,65,15,223,213                   // pandn         %xmm13,%xmm2
  .byte  102,69,15,105,200                   // punpckhwd     %xmm8,%xmm9
  .byte  102,69,15,219,209                   // pand          %xmm9,%xmm10
  .byte  102,69,15,219,203                   // pand          %xmm11,%xmm9
  .byte  102,65,15,114,242,16                // pslld         $0x10,%xmm10
  .byte  102,65,15,102,217                   // pcmpgtd       %xmm9,%xmm3
  .byte  102,65,15,114,241,13                // pslld         $0xd,%xmm9
  .byte  102,69,15,235,202                   // por           %xmm10,%xmm9
  .byte  102,69,15,254,204                   // paddd         %xmm12,%xmm9
  .byte  102,65,15,223,217                   // pandn         %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_store_f16_sse2
.globl _sk_store_f16_sse2
FUNCTION(_sk_store_f16_sse2)
_sk_store_f16_sse2:
  .byte  15,41,124,36,232                    // movaps        %xmm7,-0x18(%rsp)
  .byte  102,68,15,111,29,130,33,1,0         // movdqa        0x12182(%rip),%xmm11        # 3b060 <_sk_srcover_bgra_8888_sse2_lowp+0x10f8>
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  102,69,15,219,195                   // pand          %xmm11,%xmm8
  .byte  102,68,15,111,21,127,33,1,0         // movdqa        0x1217f(%rip),%xmm10        # 3b070 <_sk_srcover_bgra_8888_sse2_lowp+0x1108>
  .byte  102,68,15,111,240                   // movdqa        %xmm0,%xmm14
  .byte  102,69,15,219,242                   // pand          %xmm10,%xmm14
  .byte  102,15,111,61,125,33,1,0            // movdqa        0x1217d(%rip),%xmm7        # 3b080 <_sk_srcover_bgra_8888_sse2_lowp+0x1118>
  .byte  102,68,15,111,37,36,35,1,0          // movdqa        0x12324(%rip),%xmm12        # 3b230 <_sk_srcover_bgra_8888_sse2_lowp+0x12c8>
  .byte  102,68,15,111,248                   // movdqa        %xmm0,%xmm15
  .byte  102,65,15,114,247,3                 // pslld         $0x3,%xmm15
  .byte  102,69,15,219,252                   // pand          %xmm12,%xmm15
  .byte  102,69,15,254,248                   // paddd         %xmm8,%xmm15
  .byte  102,68,15,111,45,214,29,1,0         // movdqa        0x11dd6(%rip),%xmm13        # 3ad00 <_sk_srcover_bgra_8888_sse2_lowp+0xd98>
  .byte  102,69,15,254,253                   // paddd         %xmm13,%xmm15
  .byte  102,65,15,114,231,16                // psrad         $0x10,%xmm15
  .byte  102,68,15,111,199                   // movdqa        %xmm7,%xmm8
  .byte  102,69,15,102,198                   // pcmpgtd       %xmm14,%xmm8
  .byte  102,69,15,223,199                   // pandn         %xmm15,%xmm8
  .byte  102,68,15,111,241                   // movdqa        %xmm1,%xmm14
  .byte  102,69,15,219,243                   // pand          %xmm11,%xmm14
  .byte  102,68,15,111,249                   // movdqa        %xmm1,%xmm15
  .byte  102,65,15,114,247,3                 // pslld         $0x3,%xmm15
  .byte  102,69,15,219,252                   // pand          %xmm12,%xmm15
  .byte  102,69,15,254,254                   // paddd         %xmm14,%xmm15
  .byte  102,68,15,111,241                   // movdqa        %xmm1,%xmm14
  .byte  102,69,15,219,242                   // pand          %xmm10,%xmm14
  .byte  102,68,15,111,207                   // movdqa        %xmm7,%xmm9
  .byte  102,69,15,102,206                   // pcmpgtd       %xmm14,%xmm9
  .byte  102,68,15,107,192                   // packssdw      %xmm0,%xmm8
  .byte  102,69,15,254,253                   // paddd         %xmm13,%xmm15
  .byte  102,65,15,114,231,16                // psrad         $0x10,%xmm15
  .byte  102,69,15,223,207                   // pandn         %xmm15,%xmm9
  .byte  102,68,15,107,200                   // packssdw      %xmm0,%xmm9
  .byte  102,69,15,97,193                    // punpcklwd     %xmm9,%xmm8
  .byte  102,68,15,111,202                   // movdqa        %xmm2,%xmm9
  .byte  102,69,15,219,203                   // pand          %xmm11,%xmm9
  .byte  102,68,15,111,250                   // movdqa        %xmm2,%xmm15
  .byte  102,65,15,114,247,3                 // pslld         $0x3,%xmm15
  .byte  102,69,15,219,252                   // pand          %xmm12,%xmm15
  .byte  102,69,15,254,249                   // paddd         %xmm9,%xmm15
  .byte  102,68,15,111,202                   // movdqa        %xmm2,%xmm9
  .byte  102,69,15,219,202                   // pand          %xmm10,%xmm9
  .byte  102,68,15,111,247                   // movdqa        %xmm7,%xmm14
  .byte  102,69,15,102,241                   // pcmpgtd       %xmm9,%xmm14
  .byte  102,69,15,254,253                   // paddd         %xmm13,%xmm15
  .byte  102,65,15,114,231,16                // psrad         $0x10,%xmm15
  .byte  102,69,15,223,247                   // pandn         %xmm15,%xmm14
  .byte  102,68,15,111,203                   // movdqa        %xmm3,%xmm9
  .byte  102,65,15,114,241,3                 // pslld         $0x3,%xmm9
  .byte  102,69,15,219,204                   // pand          %xmm12,%xmm9
  .byte  102,68,15,219,219                   // pand          %xmm3,%xmm11
  .byte  102,69,15,254,203                   // paddd         %xmm11,%xmm9
  .byte  102,69,15,254,205                   // paddd         %xmm13,%xmm9
  .byte  102,68,15,219,211                   // pand          %xmm3,%xmm10
  .byte  102,65,15,102,250                   // pcmpgtd       %xmm10,%xmm7
  .byte  102,65,15,114,225,16                // psrad         $0x10,%xmm9
  .byte  102,65,15,223,249                   // pandn         %xmm9,%xmm7
  .byte  102,68,15,107,240                   // packssdw      %xmm0,%xmm14
  .byte  102,15,107,248                      // packssdw      %xmm0,%xmm7
  .byte  102,68,15,97,247                    // punpcklwd     %xmm7,%xmm14
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  73,193,224,3                        // shl           $0x3,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,99,194                           // movslq        %edx,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,37                              // jne           2905c <_sk_store_f16_sse2+0x18c>
  .byte  102,65,15,111,248                   // movdqa        %xmm8,%xmm7
  .byte  102,65,15,98,254                    // punpckldq     %xmm14,%xmm7
  .byte  243,65,15,127,60,192                // movdqu        %xmm7,(%r8,%rax,8)
  .byte  102,69,15,106,198                   // punpckhdq     %xmm14,%xmm8
  .byte  243,69,15,127,68,192,16             // movdqu        %xmm8,0x10(%r8,%rax,8)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,124,36,232                    // movaps        -0x18(%rsp),%xmm7
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,69,15,98,206                    // punpckldq     %xmm14,%xmm9
  .byte  102,69,15,214,12,192                // movq          %xmm9,(%r8,%rax,8)
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,225                             // je            29053 <_sk_store_f16_sse2+0x183>
  .byte  102,69,15,23,76,192,8               // movhpd        %xmm9,0x8(%r8,%rax,8)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,212                             // jb            29053 <_sk_store_f16_sse2+0x183>
  .byte  102,69,15,106,198                   // punpckhdq     %xmm14,%xmm8
  .byte  102,69,15,214,68,192,16             // movq          %xmm8,0x10(%r8,%rax,8)
  .byte  235,198                             // jmp           29053 <_sk_store_f16_sse2+0x183>

HIDDEN _sk_load_u16_be_sse2
.globl _sk_load_u16_be_sse2
FUNCTION(_sk_load_u16_be_sse2)
_sk_load_u16_be_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,190,0,0,0                    // jne           29172 <_sk_load_u16_be_sse2+0xe5>
  .byte  102,65,15,16,4,64                   // movupd        (%r8,%rax,2),%xmm0
  .byte  243,65,15,111,76,64,16              // movdqu        0x10(%r8,%rax,2),%xmm1
  .byte  102,15,40,208                       // movapd        %xmm0,%xmm2
  .byte  102,15,97,209                       // punpcklwd     %xmm1,%xmm2
  .byte  102,15,105,193                      // punpckhwd     %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  102,15,105,208                      // punpckhwd     %xmm0,%xmm2
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,113,240,8                    // psllw         $0x8,%xmm0
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,235,200                      // por           %xmm0,%xmm1
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  102,65,15,97,201                    // punpcklwd     %xmm9,%xmm1
  .byte  15,91,193                           // cvtdq2ps      %xmm1,%xmm0
  .byte  68,15,40,5,235,28,1,0               // movaps        0x11ceb(%rip),%xmm8        # 3adf0 <_sk_srcover_bgra_8888_sse2_lowp+0xe88>
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,113,241,8                    // psllw         $0x8,%xmm1
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,235,217                      // por           %xmm1,%xmm3
  .byte  102,65,15,97,217                    // punpcklwd     %xmm9,%xmm3
  .byte  15,91,203                           // cvtdq2ps      %xmm3,%xmm1
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  102,68,15,111,210                   // movdqa        %xmm2,%xmm10
  .byte  102,65,15,113,242,8                 // psllw         $0x8,%xmm10
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,65,15,235,210                   // por           %xmm10,%xmm2
  .byte  102,65,15,97,209                    // punpcklwd     %xmm9,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  102,68,15,111,211                   // movdqa        %xmm3,%xmm10
  .byte  102,65,15,113,242,8                 // psllw         $0x8,%xmm10
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,65,15,235,218                   // por           %xmm10,%xmm3
  .byte  102,65,15,97,217                    // punpcklwd     %xmm9,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  242,65,15,16,4,64                   // movsd         (%r8,%rax,2),%xmm0
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,13                              // jne           2918b <_sk_load_u16_be_sse2+0xfe>
  .byte  243,15,126,192                      // movq          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  233,54,255,255,255                  // jmpq          290c1 <_sk_load_u16_be_sse2+0x34>
  .byte  102,65,15,22,68,64,8                // movhpd        0x8(%r8,%rax,2),%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  15,130,33,255,255,255               // jb            290c1 <_sk_load_u16_be_sse2+0x34>
  .byte  243,65,15,126,76,64,16              // movq          0x10(%r8,%rax,2),%xmm1
  .byte  233,21,255,255,255                  // jmpq          290c1 <_sk_load_u16_be_sse2+0x34>

HIDDEN _sk_load_rgb_u16_be_sse2
.globl _sk_load_rgb_u16_be_sse2
FUNCTION(_sk_load_rgb_u16_be_sse2)
_sk_load_rgb_u16_be_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,72,8                          // movslq        0x8(%rax),%r9
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,193                       // imul          %r9,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  72,137,208                          // mov           %rdx,%rax
  .byte  72,193,224,32                       // shl           $0x20,%rax
  .byte  72,141,4,64                         // lea           (%rax,%rax,2),%rax
  .byte  72,193,248,32                       // sar           $0x20,%rax
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  15,133,175,0,0,0                    // jne           29286 <_sk_load_rgb_u16_be_sse2+0xda>
  .byte  243,65,15,111,20,64                 // movdqu        (%r8,%rax,2),%xmm2
  .byte  243,65,15,111,92,64,8               // movdqu        0x8(%r8,%rax,2),%xmm3
  .byte  102,15,115,219,4                    // psrldq        $0x4,%xmm3
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,115,216,6                    // psrldq        $0x6,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,115,217,6                    // psrldq        $0x6,%xmm1
  .byte  102,15,97,193                       // punpcklwd     %xmm1,%xmm0
  .byte  102,15,97,211                       // punpcklwd     %xmm3,%xmm2
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,15,105,208                      // punpckhwd     %xmm0,%xmm2
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,113,240,8                    // psllw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,235,200                      // por           %xmm0,%xmm1
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,65,15,97,200                    // punpcklwd     %xmm8,%xmm1
  .byte  15,91,193                           // cvtdq2ps      %xmm1,%xmm0
  .byte  68,15,40,13,181,27,1,0              // movaps        0x11bb5(%rip),%xmm9        # 3adf0 <_sk_srcover_bgra_8888_sse2_lowp+0xe88>
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,113,241,8                    // psllw         $0x8,%xmm1
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,235,217                      // por           %xmm1,%xmm3
  .byte  102,65,15,97,216                    // punpcklwd     %xmm8,%xmm3
  .byte  15,91,203                           // cvtdq2ps      %xmm3,%xmm1
  .byte  65,15,89,201                        // mulps         %xmm9,%xmm1
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,113,243,8                    // psllw         $0x8,%xmm3
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,235,211                      // por           %xmm3,%xmm2
  .byte  102,65,15,97,208                    // punpcklwd     %xmm8,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,204,24,1,0                 // movaps        0x118cc(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  255,224                             // jmpq          *%rax
  .byte  102,65,15,110,20,64                 // movd          (%r8,%rax,2),%xmm2
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,65,15,196,84,64,4,2             // pinsrw        $0x2,0x4(%r8,%rax,2),%xmm2
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,13                              // jne           292ab <_sk_load_rgb_u16_be_sse2+0xff>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  233,80,255,255,255                  // jmpq          291fb <_sk_load_rgb_u16_be_sse2+0x4f>
  .byte  102,65,15,110,68,64,6               // movd          0x6(%r8,%rax,2),%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,65,15,196,68,64,10,2            // pinsrw        $0x2,0xa(%r8,%rax,2),%xmm0
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,24                              // jb            292dc <_sk_load_rgb_u16_be_sse2+0x130>
  .byte  102,65,15,110,92,64,12              // movd          0xc(%r8,%rax,2),%xmm3
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,65,15,196,92,64,16,2            // pinsrw        $0x2,0x10(%r8,%rax,2),%xmm3
  .byte  233,31,255,255,255                  // jmpq          291fb <_sk_load_rgb_u16_be_sse2+0x4f>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  233,22,255,255,255                  // jmpq          291fb <_sk_load_rgb_u16_be_sse2+0x4f>

HIDDEN _sk_store_u16_be_sse2
.globl _sk_store_u16_be_sse2
FUNCTION(_sk_store_u16_be_sse2)
_sk_store_u16_be_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  68,15,95,192                        // maxps         %xmm0,%xmm8
  .byte  68,15,40,21,57,24,1,0               // movaps        0x11839(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,93,194                        // minps         %xmm10,%xmm8
  .byte  68,15,40,29,125,29,1,0              // movaps        0x11d7d(%rip),%xmm11        # 3b0a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1138>
  .byte  69,15,89,195                        // mulps         %xmm11,%xmm8
  .byte  102,69,15,91,192                    // cvtps2dq      %xmm8,%xmm8
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,114,224,16                // psrad         $0x10,%xmm8
  .byte  102,68,15,107,192                   // packssdw      %xmm0,%xmm8
  .byte  102,69,15,111,224                   // movdqa        %xmm8,%xmm12
  .byte  102,65,15,113,244,8                 // psllw         $0x8,%xmm12
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  102,69,15,235,196                   // por           %xmm12,%xmm8
  .byte  102,69,15,239,228                   // pxor          %xmm12,%xmm12
  .byte  68,15,95,225                        // maxps         %xmm1,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  102,69,15,91,228                    // cvtps2dq      %xmm12,%xmm12
  .byte  102,65,15,114,244,16                // pslld         $0x10,%xmm12
  .byte  102,65,15,114,228,16                // psrad         $0x10,%xmm12
  .byte  102,68,15,107,224                   // packssdw      %xmm0,%xmm12
  .byte  102,69,15,111,236                   // movdqa        %xmm12,%xmm13
  .byte  102,65,15,113,245,8                 // psllw         $0x8,%xmm13
  .byte  102,65,15,113,212,8                 // psrlw         $0x8,%xmm12
  .byte  102,69,15,235,229                   // por           %xmm13,%xmm12
  .byte  102,69,15,97,196                    // punpcklwd     %xmm12,%xmm8
  .byte  102,69,15,239,228                   // pxor          %xmm12,%xmm12
  .byte  68,15,95,226                        // maxps         %xmm2,%xmm12
  .byte  69,15,93,226                        // minps         %xmm10,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  102,69,15,91,228                    // cvtps2dq      %xmm12,%xmm12
  .byte  102,65,15,114,244,16                // pslld         $0x10,%xmm12
  .byte  102,65,15,114,228,16                // psrad         $0x10,%xmm12
  .byte  102,68,15,107,224                   // packssdw      %xmm0,%xmm12
  .byte  102,69,15,111,236                   // movdqa        %xmm12,%xmm13
  .byte  102,65,15,113,245,8                 // psllw         $0x8,%xmm13
  .byte  102,65,15,113,212,8                 // psrlw         $0x8,%xmm12
  .byte  102,69,15,235,229                   // por           %xmm13,%xmm12
  .byte  68,15,95,203                        // maxps         %xmm3,%xmm9
  .byte  69,15,93,202                        // minps         %xmm10,%xmm9
  .byte  69,15,89,203                        // mulps         %xmm11,%xmm9
  .byte  102,69,15,91,201                    // cvtps2dq      %xmm9,%xmm9
  .byte  102,65,15,114,241,16                // pslld         $0x10,%xmm9
  .byte  102,65,15,114,225,16                // psrad         $0x10,%xmm9
  .byte  102,68,15,107,200                   // packssdw      %xmm0,%xmm9
  .byte  102,69,15,111,209                   // movdqa        %xmm9,%xmm10
  .byte  102,65,15,113,242,8                 // psllw         $0x8,%xmm10
  .byte  102,65,15,113,209,8                 // psrlw         $0x8,%xmm9
  .byte  102,69,15,235,202                   // por           %xmm10,%xmm9
  .byte  102,69,15,97,225                    // punpcklwd     %xmm9,%xmm12
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,69,15,98,204                    // punpckldq     %xmm12,%xmm9
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,21                              // jne           29433 <_sk_store_u16_be_sse2+0x14e>
  .byte  69,15,17,12,64                      // movups        %xmm9,(%r8,%rax,2)
  .byte  102,69,15,106,196                   // punpckhdq     %xmm12,%xmm8
  .byte  243,69,15,127,68,64,16              // movdqu        %xmm8,0x10(%r8,%rax,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,214,12,64                 // movq          %xmm9,(%r8,%rax,2)
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,240                             // je            2942f <_sk_store_u16_be_sse2+0x14a>
  .byte  102,69,15,23,76,64,8                // movhpd        %xmm9,0x8(%r8,%rax,2)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,227                             // jb            2942f <_sk_store_u16_be_sse2+0x14a>
  .byte  102,69,15,106,196                   // punpckhdq     %xmm12,%xmm8
  .byte  102,69,15,214,68,64,16              // movq          %xmm8,0x10(%r8,%rax,2)
  .byte  235,213                             // jmp           2942f <_sk_store_u16_be_sse2+0x14a>

HIDDEN _sk_load_f32_sse2
.globl _sk_load_f32_sse2
FUNCTION(_sk_load_f32_sse2)
_sk_load_f32_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  69,15,16,4,128                      // movups        (%r8,%rax,4),%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,66                              // jne           294c5 <_sk_load_f32_sse2+0x6b>
  .byte  65,15,16,68,128,16                  // movups        0x10(%r8,%rax,4),%xmm0
  .byte  65,15,16,92,128,32                  // movups        0x20(%r8,%rax,4),%xmm3
  .byte  69,15,16,76,128,48                  // movups        0x30(%r8,%rax,4),%xmm9
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  15,20,208                           // unpcklps      %xmm0,%xmm2
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  65,15,20,201                        // unpcklps      %xmm9,%xmm1
  .byte  68,15,21,192                        // unpckhps      %xmm0,%xmm8
  .byte  65,15,21,217                        // unpckhps      %xmm9,%xmm3
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  102,15,20,193                       // unpcklpd      %xmm1,%xmm0
  .byte  15,18,202                           // movhlps       %xmm2,%xmm1
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  65,15,18,216                        // movhlps       %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,8                               // jne           294d7 <_sk_load_f32_sse2+0x7d>
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  235,190                             // jmp           29495 <_sk_load_f32_sse2+0x3b>
  .byte  65,15,16,68,128,16                  // movups        0x10(%r8,%rax,4),%xmm0
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,8                               // jb            294eb <_sk_load_f32_sse2+0x91>
  .byte  65,15,16,92,128,32                  // movups        0x20(%r8,%rax,4),%xmm3
  .byte  235,170                             // jmp           29495 <_sk_load_f32_sse2+0x3b>
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  235,165                             // jmp           29495 <_sk_load_f32_sse2+0x3b>

HIDDEN _sk_load_f32_dst_sse2
.globl _sk_load_f32_dst_sse2
FUNCTION(_sk_load_f32_dst_sse2)
_sk_load_f32_dst_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  69,15,16,4,128                      // movups        (%r8,%rax,4),%xmm8
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,66                              // jne           2955b <_sk_load_f32_dst_sse2+0x6b>
  .byte  65,15,16,100,128,16                 // movups        0x10(%r8,%rax,4),%xmm4
  .byte  65,15,16,124,128,32                 // movups        0x20(%r8,%rax,4),%xmm7
  .byte  69,15,16,76,128,48                  // movups        0x30(%r8,%rax,4),%xmm9
  .byte  65,15,40,240                        // movaps        %xmm8,%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  15,40,239                           // movaps        %xmm7,%xmm5
  .byte  65,15,20,233                        // unpcklps      %xmm9,%xmm5
  .byte  68,15,21,196                        // unpckhps      %xmm4,%xmm8
  .byte  65,15,21,249                        // unpckhps      %xmm9,%xmm7
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  102,15,20,229                       // unpcklpd      %xmm5,%xmm4
  .byte  15,18,238                           // movhlps       %xmm6,%xmm5
  .byte  65,15,40,240                        // movaps        %xmm8,%xmm6
  .byte  102,15,20,247                       // unpcklpd      %xmm7,%xmm6
  .byte  65,15,18,248                        // movhlps       %xmm8,%xmm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  117,8                               // jne           2956d <_sk_load_f32_dst_sse2+0x7d>
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  235,190                             // jmp           2952b <_sk_load_f32_dst_sse2+0x3b>
  .byte  65,15,16,100,128,16                 // movups        0x10(%r8,%rax,4),%xmm4
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,8                               // jb            29581 <_sk_load_f32_dst_sse2+0x91>
  .byte  65,15,16,124,128,32                 // movups        0x20(%r8,%rax,4),%xmm7
  .byte  235,170                             // jmp           2952b <_sk_load_f32_dst_sse2+0x3b>
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  235,165                             // jmp           2952b <_sk_load_f32_dst_sse2+0x3b>

HIDDEN _sk_store_f32_sse2
.globl _sk_store_f32_sse2
FUNCTION(_sk_store_f32_sse2)
_sk_store_f32_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,141,12,149,0,0,0,0               // lea           0x0(,%rdx,4),%r9d
  .byte  76,99,80,8                          // movslq        0x8(%rax),%r10
  .byte  76,99,193                           // movslq        %ecx,%r8
  .byte  77,15,175,194                       // imul          %r10,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  73,99,193                           // movslq        %r9d,%rax
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  68,15,20,201                        // unpcklps      %xmm1,%xmm9
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  68,15,20,195                        // unpcklps      %xmm3,%xmm8
  .byte  68,15,40,208                        // movaps        %xmm0,%xmm10
  .byte  68,15,21,209                        // unpckhps      %xmm1,%xmm10
  .byte  68,15,40,218                        // movaps        %xmm2,%xmm11
  .byte  68,15,21,219                        // unpckhps      %xmm3,%xmm11
  .byte  69,15,40,225                        // movaps        %xmm9,%xmm12
  .byte  102,69,15,20,224                    // unpcklpd      %xmm8,%xmm12
  .byte  69,15,18,193                        // movhlps       %xmm9,%xmm8
  .byte  69,15,40,202                        // movaps        %xmm10,%xmm9
  .byte  102,69,15,20,203                    // unpcklpd      %xmm11,%xmm9
  .byte  102,69,15,17,36,128                 // movupd        %xmm12,(%r8,%rax,4)
  .byte  72,133,255                          // test          %rdi,%rdi
  .byte  117,29                              // jne           29603 <_sk_store_f32_sse2+0x7d>
  .byte  102,69,15,21,211                    // unpckhpd      %xmm11,%xmm10
  .byte  69,15,17,68,128,16                  // movups        %xmm8,0x10(%r8,%rax,4)
  .byte  102,69,15,17,76,128,32              // movupd        %xmm9,0x20(%r8,%rax,4)
  .byte  102,69,15,17,84,128,48              // movupd        %xmm10,0x30(%r8,%rax,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  72,131,255,1                        // cmp           $0x1,%rdi
  .byte  116,246                             // je            295ff <_sk_store_f32_sse2+0x79>
  .byte  69,15,17,68,128,16                  // movups        %xmm8,0x10(%r8,%rax,4)
  .byte  72,131,255,3                        // cmp           $0x3,%rdi
  .byte  114,234                             // jb            295ff <_sk_store_f32_sse2+0x79>
  .byte  102,69,15,17,76,128,32              // movupd        %xmm9,0x20(%r8,%rax,4)
  .byte  235,225                             // jmp           295ff <_sk_store_f32_sse2+0x79>

HIDDEN _sk_repeat_x_sse2
.globl _sk_repeat_x_sse2
FUNCTION(_sk_repeat_x_sse2)
_sk_repeat_x_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  243,69,15,91,209                    // cvttps2dq     %xmm9,%xmm10
  .byte  69,15,91,210                        // cvtdq2ps      %xmm10,%xmm10
  .byte  69,15,194,202,1                     // cmpltps       %xmm10,%xmm9
  .byte  68,15,84,13,6,21,1,0                // andps         0x11506(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,209                        // subps         %xmm9,%xmm10
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  69,15,89,194                        // mulps         %xmm10,%xmm8
  .byte  65,15,92,192                        // subps         %xmm8,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_repeat_y_sse2
.globl _sk_repeat_y_sse2
FUNCTION(_sk_repeat_y_sse2)
_sk_repeat_y_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  243,69,15,91,209                    // cvttps2dq     %xmm9,%xmm10
  .byte  69,15,91,210                        // cvtdq2ps      %xmm10,%xmm10
  .byte  69,15,194,202,1                     // cmpltps       %xmm10,%xmm9
  .byte  68,15,84,13,197,20,1,0              // andps         0x114c5(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,209                        // subps         %xmm9,%xmm10
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  69,15,89,194                        // mulps         %xmm10,%xmm8
  .byte  65,15,92,200                        // subps         %xmm8,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_x_sse2
.globl _sk_mirror_x_sse2
FUNCTION(_sk_mirror_x_sse2)
_sk_mirror_x_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,40,208                        // movaps        %xmm8,%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  65,15,92,194                        // subps         %xmm10,%xmm0
  .byte  243,69,15,88,192                    // addss         %xmm8,%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  243,68,15,89,13,71,11,1,0           // mulss         0x10b47(%rip),%xmm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  243,69,15,91,217                    // cvttps2dq     %xmm9,%xmm11
  .byte  69,15,91,219                        // cvtdq2ps      %xmm11,%xmm11
  .byte  69,15,194,203,1                     // cmpltps       %xmm11,%xmm9
  .byte  68,15,84,13,100,20,1,0              // andps         0x11464(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  69,15,92,217                        // subps         %xmm9,%xmm11
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  65,15,92,195                        // subps         %xmm11,%xmm0
  .byte  65,15,92,194                        // subps         %xmm10,%xmm0
  .byte  68,15,92,224                        // subps         %xmm0,%xmm12
  .byte  65,15,84,196                        // andps         %xmm12,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_y_sse2
.globl _sk_mirror_y_sse2
FUNCTION(_sk_mirror_y_sse2)
_sk_mirror_y_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,40,208                        // movaps        %xmm8,%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  65,15,92,202                        // subps         %xmm10,%xmm1
  .byte  243,69,15,88,192                    // addss         %xmm8,%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  243,68,15,89,13,219,10,1,0          // mulss         0x10adb(%rip),%xmm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  243,69,15,91,217                    // cvttps2dq     %xmm9,%xmm11
  .byte  69,15,91,219                        // cvtdq2ps      %xmm11,%xmm11
  .byte  69,15,194,203,1                     // cmpltps       %xmm11,%xmm9
  .byte  68,15,84,13,248,19,1,0              // andps         0x113f8(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,87,228                        // xorps         %xmm12,%xmm12
  .byte  69,15,92,217                        // subps         %xmm9,%xmm11
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  65,15,92,203                        // subps         %xmm11,%xmm1
  .byte  65,15,92,202                        // subps         %xmm10,%xmm1
  .byte  68,15,92,225                        // subps         %xmm1,%xmm12
  .byte  65,15,84,204                        // andps         %xmm12,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_x_1_sse2
.globl _sk_clamp_x_1_sse2
FUNCTION(_sk_clamp_x_1_sse2)
_sk_clamp_x_1_sse2:
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  68,15,95,192                        // maxps         %xmm0,%xmm8
  .byte  68,15,93,5,200,19,1,0               // minps         0x113c8(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_repeat_x_1_sse2
.globl _sk_repeat_x_1_sse2
FUNCTION(_sk_repeat_x_1_sse2)
_sk_repeat_x_1_sse2:
  .byte  243,68,15,91,192                    // cvttps2dq     %xmm0,%xmm8
  .byte  69,15,91,200                        // cvtdq2ps      %xmm8,%xmm9
  .byte  68,15,40,208                        // movaps        %xmm0,%xmm10
  .byte  69,15,194,209,1                     // cmpltps       %xmm9,%xmm10
  .byte  68,15,40,29,166,19,1,0              // movaps        0x113a6(%rip),%xmm11        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,84,211                        // andps         %xmm11,%xmm10
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  69,15,92,202                        // subps         %xmm10,%xmm9
  .byte  65,15,92,193                        // subps         %xmm9,%xmm0
  .byte  68,15,95,192                        // maxps         %xmm0,%xmm8
  .byte  69,15,93,195                        // minps         %xmm11,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_x_1_sse2
.globl _sk_mirror_x_1_sse2
FUNCTION(_sk_mirror_x_1_sse2)
_sk_mirror_x_1_sse2:
  .byte  68,15,40,13,222,19,1,0              // movaps        0x113de(%rip),%xmm9        # 3abb0 <_sk_srcover_bgra_8888_sse2_lowp+0xc48>
  .byte  65,15,88,193                        // addps         %xmm9,%xmm0
  .byte  68,15,40,21,98,19,1,0               // movaps        0x11362(%rip),%xmm10        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,89,208                        // mulps         %xmm0,%xmm10
  .byte  243,69,15,91,194                    // cvttps2dq     %xmm10,%xmm8
  .byte  69,15,91,216                        // cvtdq2ps      %xmm8,%xmm11
  .byte  69,15,194,211,1                     // cmpltps       %xmm11,%xmm10
  .byte  68,15,40,37,88,19,1,0               // movaps        0x11358(%rip),%xmm12        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,84,212                        // andps         %xmm12,%xmm10
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  69,15,92,218                        // subps         %xmm10,%xmm11
  .byte  69,15,88,219                        // addps         %xmm11,%xmm11
  .byte  65,15,92,195                        // subps         %xmm11,%xmm0
  .byte  65,15,88,193                        // addps         %xmm9,%xmm0
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  68,15,92,200                        // subps         %xmm0,%xmm9
  .byte  68,15,84,200                        // andps         %xmm0,%xmm9
  .byte  69,15,95,193                        // maxps         %xmm9,%xmm8
  .byte  69,15,93,196                        // minps         %xmm12,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_luminance_to_alpha_sse2
.globl _sk_luminance_to_alpha_sse2
FUNCTION(_sk_luminance_to_alpha_sse2)
_sk_luminance_to_alpha_sse2:
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,89,5,122,24,1,0                  // mulps         0x1187a(%rip),%xmm0        # 3b0b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1148>
  .byte  15,89,13,131,24,1,0                 // mulps         0x11883(%rip),%xmm1        # 3b0c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1158>
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  15,89,29,137,24,1,0                 // mulps         0x11889(%rip),%xmm3        # 3b0d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1168>
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_translate_sse2
.globl _sk_matrix_translate_sse2
FUNCTION(_sk_matrix_translate_sse2)
_sk_matrix_translate_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  65,15,88,201                        // addps         %xmm9,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_scale_translate_sse2
.globl _sk_matrix_scale_translate_sse2
FUNCTION(_sk_matrix_scale_translate_sse2)
_sk_matrix_scale_translate_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  65,15,89,201                        // mulps         %xmm9,%xmm1
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_2x3_sse2
.globl _sk_matrix_2x3_sse2
FUNCTION(_sk_matrix_2x3_sse2)
_sk_matrix_2x3_sse2:
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,16                  // movss         0x10(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,68,15,16,80,12                  // movss         0xc(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,20                  // movss         0x14(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_3x4_sse2
.globl _sk_matrix_3x4_sse2
FUNCTION(_sk_matrix_3x4_sse2)
_sk_matrix_3x4_sse2:
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,68,15,16,80,12                  // movss         0xc(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,24                  // movss         0x18(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,36                  // movss         0x24(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,68,15,16,80,16                  // movss         0x10(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,28                  // movss         0x1c(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,40                  // movss         0x28(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,20                  // movss         0x14(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,32                  // movss         0x20(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,104,44                 // movss         0x2c(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  68,15,89,226                        // mulps         %xmm2,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  69,15,89,217                        // mulps         %xmm9,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,208                        // mulps         %xmm8,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_4x5_sse2
.globl _sk_matrix_4x5_sse2
FUNCTION(_sk_matrix_4x5_sse2)
_sk_matrix_4x5_sse2:
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,68,15,16,80,16                  // movss         0x10(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,32                  // movss         0x20(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,48                  // movss         0x30(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,104,64                 // movss         0x40(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  68,15,89,227                        // mulps         %xmm3,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,68,15,16,80,20                  // movss         0x14(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,36                  // movss         0x24(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,52                  // movss         0x34(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,104,68                 // movss         0x44(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  68,15,89,227                        // mulps         %xmm3,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,24                  // movss         0x18(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,40                  // movss         0x28(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,104,56                 // movss         0x38(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  243,68,15,16,112,72                 // movss         0x48(%rax),%xmm14
  .byte  69,15,198,246,0                     // shufps        $0x0,%xmm14,%xmm14
  .byte  68,15,89,235                        // mulps         %xmm3,%xmm13
  .byte  69,15,88,238                        // addps         %xmm14,%xmm13
  .byte  68,15,89,226                        // mulps         %xmm2,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  69,15,89,217                        // mulps         %xmm9,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,208                        // mulps         %xmm8,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  243,68,15,16,88,12                  // movss         0xc(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,28                  // movss         0x1c(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,104,44                 // movss         0x2c(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  243,68,15,16,112,60                 // movss         0x3c(%rax),%xmm14
  .byte  69,15,198,246,0                     // shufps        $0x0,%xmm14,%xmm14
  .byte  243,68,15,16,120,76                 // movss         0x4c(%rax),%xmm15
  .byte  69,15,198,255,0                     // shufps        $0x0,%xmm15,%xmm15
  .byte  68,15,89,243                        // mulps         %xmm3,%xmm14
  .byte  69,15,88,247                        // addps         %xmm15,%xmm14
  .byte  68,15,89,234                        // mulps         %xmm2,%xmm13
  .byte  69,15,88,238                        // addps         %xmm14,%xmm13
  .byte  69,15,89,225                        // mulps         %xmm9,%xmm12
  .byte  69,15,88,229                        // addps         %xmm13,%xmm12
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,40,219                        // movaps        %xmm11,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_4x3_sse2
.globl _sk_matrix_4x3_sse2
FUNCTION(_sk_matrix_4x3_sse2)
_sk_matrix_4x3_sse2:
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,15,16,80,16                     // movss         0x10(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,88,32                     // movss         0x20(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,80,20                     // movss         0x14(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,88,36                     // movss         0x24(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  243,15,16,80,8                      // movss         0x8(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,88,24                     // movss         0x18(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  243,68,15,16,80,40                  // movss         0x28(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  65,15,89,217                        // mulps         %xmm9,%xmm3
  .byte  65,15,88,218                        // addps         %xmm10,%xmm3
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  243,15,16,88,12                     // movss         0xc(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  243,68,15,16,80,28                  // movss         0x1c(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,44                  // movss         0x2c(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  65,15,88,218                        // addps         %xmm10,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_perspective_sse2
.globl _sk_matrix_perspective_sse2
FUNCTION(_sk_matrix_perspective_sse2)
_sk_matrix_perspective_sse2:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,193                        // addps         %xmm9,%xmm0
  .byte  243,68,15,16,72,12                  // movss         0xc(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  243,68,15,16,80,16                  // movss         0x10(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,20                  // movss         0x14(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  68,15,89,209                        // mulps         %xmm1,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  243,68,15,16,80,24                  // movss         0x18(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,28                  // movss         0x1c(%rax),%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,96,32                  // movss         0x20(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  68,15,89,217                        // mulps         %xmm1,%xmm11
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  69,15,89,208                        // mulps         %xmm8,%xmm10
  .byte  69,15,88,211                        // addps         %xmm11,%xmm10
  .byte  65,15,83,202                        // rcpps         %xmm10,%xmm1
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_gradient_sse2
.globl _sk_evenly_spaced_gradient_sse2
FUNCTION(_sk_evenly_spaced_gradient_sse2)
_sk_evenly_spaced_gradient_sse2:
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,139,24                           // mov           (%rax),%rbx
  .byte  76,139,112,8                        // mov           0x8(%rax),%r14
  .byte  72,255,203                          // dec           %rbx
  .byte  120,7                               // js            29ce7 <_sk_evenly_spaced_gradient_sse2+0x18>
  .byte  243,72,15,42,203                    // cvtsi2ss      %rbx,%xmm1
  .byte  235,21                              // jmp           29cfc <_sk_evenly_spaced_gradient_sse2+0x2d>
  .byte  73,137,216                          // mov           %rbx,%r8
  .byte  73,209,232                          // shr           %r8
  .byte  131,227,1                           // and           $0x1,%ebx
  .byte  76,9,195                            // or            %r8,%rbx
  .byte  243,72,15,42,203                    // cvtsi2ss      %rbx,%xmm1
  .byte  243,15,88,201                       // addss         %xmm1,%xmm1
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,73,15,126,209                   // movq          %xmm2,%r9
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  102,73,15,126,203                   // movq          %xmm1,%r11
  .byte  69,137,218                          // mov           %r11d,%r10d
  .byte  73,193,235,32                       // shr           $0x20,%r11
  .byte  243,67,15,16,12,158                 // movss         (%r14,%r11,4),%xmm1
  .byte  243,71,15,16,4,150                  // movss         (%r14,%r10,4),%xmm8
  .byte  68,15,20,193                        // unpcklps      %xmm1,%xmm8
  .byte  243,67,15,16,12,142                 // movss         (%r14,%r9,4),%xmm1
  .byte  243,67,15,16,20,134                 // movss         (%r14,%r8,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  102,68,15,20,194                    // unpcklpd      %xmm2,%xmm8
  .byte  72,139,88,40                        // mov           0x28(%rax),%rbx
  .byte  243,66,15,16,12,155                 // movss         (%rbx,%r11,4),%xmm1
  .byte  243,70,15,16,12,147                 // movss         (%rbx,%r10,4),%xmm9
  .byte  68,15,20,201                        // unpcklps      %xmm1,%xmm9
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  243,66,15,16,20,131                 // movss         (%rbx,%r8,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  102,68,15,20,202                    // unpcklpd      %xmm2,%xmm9
  .byte  72,139,88,16                        // mov           0x10(%rax),%rbx
  .byte  243,66,15,16,20,155                 // movss         (%rbx,%r11,4),%xmm2
  .byte  243,66,15,16,12,147                 // movss         (%rbx,%r10,4),%xmm1
  .byte  15,20,202                           // unpcklps      %xmm2,%xmm1
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  102,15,20,203                       // unpcklpd      %xmm3,%xmm1
  .byte  72,139,88,48                        // mov           0x30(%rax),%rbx
  .byte  243,66,15,16,20,155                 // movss         (%rbx,%r11,4),%xmm2
  .byte  243,70,15,16,20,147                 // movss         (%rbx,%r10,4),%xmm10
  .byte  68,15,20,210                        // unpcklps      %xmm2,%xmm10
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  102,68,15,20,211                    // unpcklpd      %xmm3,%xmm10
  .byte  72,139,88,24                        // mov           0x18(%rax),%rbx
  .byte  243,66,15,16,28,155                 // movss         (%rbx,%r11,4),%xmm3
  .byte  243,66,15,16,20,147                 // movss         (%rbx,%r10,4),%xmm2
  .byte  15,20,211                           // unpcklps      %xmm3,%xmm2
  .byte  243,70,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm11
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  65,15,20,219                        // unpcklps      %xmm11,%xmm3
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  72,139,88,56                        // mov           0x38(%rax),%rbx
  .byte  243,66,15,16,28,155                 // movss         (%rbx,%r11,4),%xmm3
  .byte  243,70,15,16,28,147                 // movss         (%rbx,%r10,4),%xmm11
  .byte  68,15,20,219                        // unpcklps      %xmm3,%xmm11
  .byte  243,70,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm12
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  65,15,20,220                        // unpcklps      %xmm12,%xmm3
  .byte  102,68,15,20,219                    // unpcklpd      %xmm3,%xmm11
  .byte  72,139,88,32                        // mov           0x20(%rax),%rbx
  .byte  243,70,15,16,36,155                 // movss         (%rbx,%r11,4),%xmm12
  .byte  243,66,15,16,28,147                 // movss         (%rbx,%r10,4),%xmm3
  .byte  65,15,20,220                        // unpcklps      %xmm12,%xmm3
  .byte  243,70,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm12
  .byte  243,70,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm13
  .byte  69,15,20,236                        // unpcklps      %xmm12,%xmm13
  .byte  102,65,15,20,221                    // unpcklpd      %xmm13,%xmm3
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  243,70,15,16,36,152                 // movss         (%rax,%r11,4),%xmm12
  .byte  243,70,15,16,44,144                 // movss         (%rax,%r10,4),%xmm13
  .byte  69,15,20,236                        // unpcklps      %xmm12,%xmm13
  .byte  243,70,15,16,36,136                 // movss         (%rax,%r9,4),%xmm12
  .byte  243,70,15,16,52,128                 // movss         (%rax,%r8,4),%xmm14
  .byte  69,15,20,244                        // unpcklps      %xmm12,%xmm14
  .byte  102,69,15,20,238                    // unpcklpd      %xmm14,%xmm13
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  69,15,88,193                        // addps         %xmm9,%xmm8
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  65,15,88,211                        // addps         %xmm11,%xmm2
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  65,15,88,221                        // addps         %xmm13,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gradient_sse2
.globl _sk_gradient_sse2
FUNCTION(_sk_gradient_sse2)
_sk_gradient_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  73,131,248,2                        // cmp           $0x2,%r8
  .byte  114,41                              // jb            29ec0 <_sk_gradient_sse2+0x38>
  .byte  76,139,72,72                        // mov           0x48(%rax),%r9
  .byte  73,255,200                          // dec           %r8
  .byte  73,131,193,4                        // add           $0x4,%r9
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  243,65,15,16,17                     // movss         (%r9),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,194,208,2                        // cmpleps       %xmm0,%xmm2
  .byte  102,15,250,202                      // psubd         %xmm2,%xmm1
  .byte  73,131,193,4                        // add           $0x4,%r9
  .byte  73,255,200                          // dec           %r8
  .byte  117,230                             // jne           29ea6 <_sk_gradient_sse2+0x1e>
  .byte  65,86                               // push          %r14
  .byte  83                                  // push          %rbx
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,73,15,126,209                   // movq          %xmm2,%r9
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  102,73,15,126,203                   // movq          %xmm1,%r11
  .byte  69,137,218                          // mov           %r11d,%r10d
  .byte  73,193,235,32                       // shr           $0x20,%r11
  .byte  72,139,88,8                         // mov           0x8(%rax),%rbx
  .byte  76,139,112,16                       // mov           0x10(%rax),%r14
  .byte  243,66,15,16,12,155                 // movss         (%rbx,%r11,4),%xmm1
  .byte  243,70,15,16,4,147                  // movss         (%rbx,%r10,4),%xmm8
  .byte  68,15,20,193                        // unpcklps      %xmm1,%xmm8
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  243,66,15,16,20,131                 // movss         (%rbx,%r8,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  102,68,15,20,194                    // unpcklpd      %xmm2,%xmm8
  .byte  72,139,88,40                        // mov           0x28(%rax),%rbx
  .byte  243,66,15,16,12,155                 // movss         (%rbx,%r11,4),%xmm1
  .byte  243,70,15,16,12,147                 // movss         (%rbx,%r10,4),%xmm9
  .byte  68,15,20,201                        // unpcklps      %xmm1,%xmm9
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  243,66,15,16,20,131                 // movss         (%rbx,%r8,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  102,68,15,20,202                    // unpcklpd      %xmm2,%xmm9
  .byte  243,67,15,16,20,158                 // movss         (%r14,%r11,4),%xmm2
  .byte  243,67,15,16,12,150                 // movss         (%r14,%r10,4),%xmm1
  .byte  15,20,202                           // unpcklps      %xmm2,%xmm1
  .byte  243,67,15,16,20,142                 // movss         (%r14,%r9,4),%xmm2
  .byte  243,67,15,16,28,134                 // movss         (%r14,%r8,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  102,15,20,203                       // unpcklpd      %xmm3,%xmm1
  .byte  72,139,88,48                        // mov           0x30(%rax),%rbx
  .byte  243,66,15,16,20,155                 // movss         (%rbx,%r11,4),%xmm2
  .byte  243,70,15,16,20,147                 // movss         (%rbx,%r10,4),%xmm10
  .byte  68,15,20,210                        // unpcklps      %xmm2,%xmm10
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  102,68,15,20,211                    // unpcklpd      %xmm3,%xmm10
  .byte  72,139,88,24                        // mov           0x18(%rax),%rbx
  .byte  243,66,15,16,28,155                 // movss         (%rbx,%r11,4),%xmm3
  .byte  243,66,15,16,20,147                 // movss         (%rbx,%r10,4),%xmm2
  .byte  15,20,211                           // unpcklps      %xmm3,%xmm2
  .byte  243,70,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm11
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  65,15,20,219                        // unpcklps      %xmm11,%xmm3
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  72,139,88,56                        // mov           0x38(%rax),%rbx
  .byte  243,66,15,16,28,155                 // movss         (%rbx,%r11,4),%xmm3
  .byte  243,70,15,16,28,147                 // movss         (%rbx,%r10,4),%xmm11
  .byte  68,15,20,219                        // unpcklps      %xmm3,%xmm11
  .byte  243,70,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm12
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  65,15,20,220                        // unpcklps      %xmm12,%xmm3
  .byte  102,68,15,20,219                    // unpcklpd      %xmm3,%xmm11
  .byte  72,139,88,32                        // mov           0x20(%rax),%rbx
  .byte  243,70,15,16,36,155                 // movss         (%rbx,%r11,4),%xmm12
  .byte  243,66,15,16,28,147                 // movss         (%rbx,%r10,4),%xmm3
  .byte  65,15,20,220                        // unpcklps      %xmm12,%xmm3
  .byte  243,70,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm12
  .byte  243,70,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm13
  .byte  69,15,20,236                        // unpcklps      %xmm12,%xmm13
  .byte  102,65,15,20,221                    // unpcklpd      %xmm13,%xmm3
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  243,70,15,16,36,152                 // movss         (%rax,%r11,4),%xmm12
  .byte  243,70,15,16,44,144                 // movss         (%rax,%r10,4),%xmm13
  .byte  69,15,20,236                        // unpcklps      %xmm12,%xmm13
  .byte  243,70,15,16,36,136                 // movss         (%rax,%r9,4),%xmm12
  .byte  243,70,15,16,52,128                 // movss         (%rax,%r8,4),%xmm14
  .byte  69,15,20,244                        // unpcklps      %xmm12,%xmm14
  .byte  102,69,15,20,238                    // unpcklpd      %xmm14,%xmm13
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  69,15,88,193                        // addps         %xmm9,%xmm8
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  65,15,88,211                        // addps         %xmm11,%xmm2
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  65,15,88,221                        // addps         %xmm13,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  91                                  // pop           %rbx
  .byte  65,94                               // pop           %r14
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_2_stop_gradient_sse2
.globl _sk_evenly_spaced_2_stop_gradient_sse2
FUNCTION(_sk_evenly_spaced_2_stop_gradient_sse2)
_sk_evenly_spaced_2_stop_gradient_sse2:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,15,16,80,16                     // movss         0x10(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,80,20                     // movss         0x14(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  243,15,16,80,8                      // movss         0x8(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,88,24                     // movss         0x18(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  65,15,89,208                        // mulps         %xmm8,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  243,15,16,88,12                     // movss         0xc(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  243,68,15,16,72,28                  // movss         0x1c(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  65,15,88,217                        // addps         %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_unit_angle_sse2
.globl _sk_xy_to_unit_angle_sse2
FUNCTION(_sk_xy_to_unit_angle_sse2)
_sk_xy_to_unit_angle_sse2:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  69,15,84,200                        // andps         %xmm8,%xmm9
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  68,15,92,209                        // subps         %xmm1,%xmm10
  .byte  68,15,84,209                        // andps         %xmm1,%xmm10
  .byte  69,15,40,217                        // movaps        %xmm9,%xmm11
  .byte  69,15,93,218                        // minps         %xmm10,%xmm11
  .byte  69,15,40,225                        // movaps        %xmm9,%xmm12
  .byte  69,15,95,226                        // maxps         %xmm10,%xmm12
  .byte  69,15,94,220                        // divps         %xmm12,%xmm11
  .byte  69,15,40,227                        // movaps        %xmm11,%xmm12
  .byte  69,15,89,228                        // mulps         %xmm12,%xmm12
  .byte  68,15,40,45,229,15,1,0              // movaps        0x10fe5(%rip),%xmm13        # 3b0e0 <_sk_srcover_bgra_8888_sse2_lowp+0x1178>
  .byte  69,15,89,236                        // mulps         %xmm12,%xmm13
  .byte  68,15,88,45,233,15,1,0              // addps         0x10fe9(%rip),%xmm13        # 3b0f0 <_sk_srcover_bgra_8888_sse2_lowp+0x1188>
  .byte  69,15,89,236                        // mulps         %xmm12,%xmm13
  .byte  68,15,88,45,237,15,1,0              // addps         0x10fed(%rip),%xmm13        # 3b100 <_sk_srcover_bgra_8888_sse2_lowp+0x1198>
  .byte  69,15,89,236                        // mulps         %xmm12,%xmm13
  .byte  68,15,88,45,241,15,1,0              // addps         0x10ff1(%rip),%xmm13        # 3b110 <_sk_srcover_bgra_8888_sse2_lowp+0x11a8>
  .byte  69,15,89,235                        // mulps         %xmm11,%xmm13
  .byte  69,15,194,202,1                     // cmpltps       %xmm10,%xmm9
  .byte  68,15,40,21,240,15,1,0              // movaps        0x10ff0(%rip),%xmm10        # 3b120 <_sk_srcover_bgra_8888_sse2_lowp+0x11b8>
  .byte  69,15,92,213                        // subps         %xmm13,%xmm10
  .byte  69,15,84,209                        // andps         %xmm9,%xmm10
  .byte  69,15,85,205                        // andnps        %xmm13,%xmm9
  .byte  69,15,86,202                        // orps          %xmm10,%xmm9
  .byte  68,15,194,192,1                     // cmpltps       %xmm0,%xmm8
  .byte  68,15,40,21,243,9,1,0               // movaps        0x109f3(%rip),%xmm10        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  69,15,92,209                        // subps         %xmm9,%xmm10
  .byte  69,15,84,208                        // andps         %xmm8,%xmm10
  .byte  69,15,85,193                        // andnps        %xmm9,%xmm8
  .byte  69,15,86,194                        // orps          %xmm10,%xmm8
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,194,200,1                     // cmpltps       %xmm0,%xmm9
  .byte  68,15,40,21,226,9,1,0               // movaps        0x109e2(%rip),%xmm10        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,208                        // subps         %xmm8,%xmm10
  .byte  69,15,84,209                        // andps         %xmm9,%xmm10
  .byte  69,15,85,200                        // andnps        %xmm8,%xmm9
  .byte  69,15,86,202                        // orps          %xmm10,%xmm9
  .byte  65,15,194,193,7                     // cmpordps      %xmm9,%xmm0
  .byte  65,15,84,193                        // andps         %xmm9,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_radius_sse2
.globl _sk_xy_to_radius_sse2
FUNCTION(_sk_xy_to_radius_sse2)
_sk_xy_to_radius_sse2:
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  68,15,88,192                        // addps         %xmm0,%xmm8
  .byte  65,15,81,192                        // sqrtps        %xmm8,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_quadratic_first_sse2
.globl _sk_xy_to_2pt_conical_quadratic_first_sse2
FUNCTION(_sk_xy_to_2pt_conical_quadratic_first_sse2)
_sk_xy_to_2pt_conical_quadratic_first_sse2:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,80,64                  // movss         0x40(%rax),%xmm10
  .byte  243,15,16,64,68                     // movss         0x44(%rax),%xmm0
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,72                  // movss         0x48(%rax),%xmm11
  .byte  243,68,15,16,72,76                  // movss         0x4c(%rax),%xmm9
  .byte  243,69,15,89,203                    // mulss         %xmm11,%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  69,15,88,200                        // addps         %xmm8,%xmm9
  .byte  68,15,89,13,86,15,1,0               // mulps         0x10f56(%rip),%xmm9        # 3b130 <_sk_srcover_bgra_8888_sse2_lowp+0x11c8>
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  68,15,40,225                        // movaps        %xmm1,%xmm12
  .byte  69,15,89,228                        // mulps         %xmm12,%xmm12
  .byte  69,15,88,224                        // addps         %xmm8,%xmm12
  .byte  243,69,15,89,219                    // mulss         %xmm11,%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,92,227                        // subps         %xmm11,%xmm12
  .byte  68,15,89,21,64,15,1,0               // mulps         0x10f40(%rip),%xmm10        # 3b140 <_sk_srcover_bgra_8888_sse2_lowp+0x11d8>
  .byte  69,15,89,212                        // mulps         %xmm12,%xmm10
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  69,15,88,194                        // addps         %xmm10,%xmm8
  .byte  69,15,81,192                        // sqrtps        %xmm8,%xmm8
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  69,15,92,193                        // subps         %xmm9,%xmm8
  .byte  15,89,5,29,9,1,0                    // mulps         0x1091d(%rip),%xmm0        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_quadratic_second_sse2
.globl _sk_xy_to_2pt_conical_quadratic_second_sse2
FUNCTION(_sk_xy_to_2pt_conical_quadratic_second_sse2)
_sk_xy_to_2pt_conical_quadratic_second_sse2:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,80,64                  // movss         0x40(%rax),%xmm10
  .byte  243,15,16,64,68                     // movss         0x44(%rax),%xmm0
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,88,72                  // movss         0x48(%rax),%xmm11
  .byte  243,68,15,16,72,76                  // movss         0x4c(%rax),%xmm9
  .byte  243,69,15,89,203                    // mulss         %xmm11,%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  69,15,88,200                        // addps         %xmm8,%xmm9
  .byte  68,15,89,13,205,14,1,0              // mulps         0x10ecd(%rip),%xmm9        # 3b130 <_sk_srcover_bgra_8888_sse2_lowp+0x11c8>
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  68,15,40,225                        // movaps        %xmm1,%xmm12
  .byte  69,15,89,228                        // mulps         %xmm12,%xmm12
  .byte  69,15,88,224                        // addps         %xmm8,%xmm12
  .byte  243,69,15,89,219                    // mulss         %xmm11,%xmm11
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  69,15,92,227                        // subps         %xmm11,%xmm12
  .byte  68,15,89,21,183,14,1,0              // mulps         0x10eb7(%rip),%xmm10        # 3b140 <_sk_srcover_bgra_8888_sse2_lowp+0x11d8>
  .byte  69,15,89,212                        // mulps         %xmm12,%xmm10
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  69,15,88,194                        // addps         %xmm10,%xmm8
  .byte  69,15,81,192                        // sqrtps        %xmm8,%xmm8
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  68,15,87,13,183,13,1,0              // xorps         0x10db7(%rip),%xmm9        # 3b060 <_sk_srcover_bgra_8888_sse2_lowp+0x10f8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  15,89,5,140,8,1,0                   // mulps         0x1088c(%rip),%xmm0        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  65,15,89,193                        // mulps         %xmm9,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_2pt_conical_linear_sse2
.globl _sk_xy_to_2pt_conical_linear_sse2
FUNCTION(_sk_xy_to_2pt_conical_linear_sse2)
_sk_xy_to_2pt_conical_linear_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,72                  // movss         0x48(%rax),%xmm8
  .byte  243,68,15,16,72,76                  // movss         0x4c(%rax),%xmm9
  .byte  243,69,15,89,200                    // mulss         %xmm8,%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,88,200                        // addps         %xmm0,%xmm9
  .byte  68,15,89,13,80,14,1,0               // mulps         0x10e50(%rip),%xmm9        # 3b130 <_sk_srcover_bgra_8888_sse2_lowp+0x11c8>
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  68,15,40,209                        // movaps        %xmm1,%xmm10
  .byte  69,15,89,210                        // mulps         %xmm10,%xmm10
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  243,69,15,89,192                    // mulss         %xmm8,%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  65,15,92,192                        // subps         %xmm8,%xmm0
  .byte  15,87,5,92,13,1,0                   // xorps         0x10d5c(%rip),%xmm0        # 3b060 <_sk_srcover_bgra_8888_sse2_lowp+0x10f8>
  .byte  65,15,94,193                        // divps         %xmm9,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mask_2pt_conical_degenerates_sse2
.globl _sk_mask_2pt_conical_degenerates_sse2
FUNCTION(_sk_mask_2pt_conical_degenerates_sse2)
_sk_mask_2pt_conical_degenerates_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,72                  // movss         0x48(%rax),%xmm8
  .byte  243,68,15,16,72,76                  // movss         0x4c(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  69,15,88,200                        // addps         %xmm8,%xmm9
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  69,15,194,200,1                     // cmpltps       %xmm8,%xmm9
  .byte  68,15,194,192,3                     // cmpunordps    %xmm0,%xmm8
  .byte  69,15,86,193                        // orps          %xmm9,%xmm8
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,69,15,239,200                   // pxor          %xmm8,%xmm9
  .byte  68,15,85,192                        // andnps        %xmm0,%xmm8
  .byte  243,68,15,127,8                     // movdqu        %xmm9,(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_apply_vector_mask_sse2
.globl _sk_apply_vector_mask_sse2
FUNCTION(_sk_apply_vector_mask_sse2)
_sk_apply_vector_mask_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,15,16,0                          // movups        (%rax),%xmm8
  .byte  65,15,84,192                        // andps         %xmm8,%xmm0
  .byte  65,15,84,200                        // andps         %xmm8,%xmm1
  .byte  65,15,84,208                        // andps         %xmm8,%xmm2
  .byte  65,15,84,216                        // andps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_save_xy_sse2
.globl _sk_save_xy_sse2
FUNCTION(_sk_save_xy_sse2)
_sk_save_xy_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,15,40,5,195,7,1,0                // movaps        0x107c3(%rip),%xmm8        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,17,0                             // movups        %xmm0,(%rax)
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  69,15,88,200                        // addps         %xmm8,%xmm9
  .byte  243,69,15,91,209                    // cvttps2dq     %xmm9,%xmm10
  .byte  69,15,91,210                        // cvtdq2ps      %xmm10,%xmm10
  .byte  69,15,40,217                        // movaps        %xmm9,%xmm11
  .byte  69,15,194,218,1                     // cmpltps       %xmm10,%xmm11
  .byte  68,15,40,37,174,7,1,0               // movaps        0x107ae(%rip),%xmm12        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,84,220                        // andps         %xmm12,%xmm11
  .byte  69,15,92,211                        // subps         %xmm11,%xmm10
  .byte  69,15,92,202                        // subps         %xmm10,%xmm9
  .byte  68,15,88,193                        // addps         %xmm1,%xmm8
  .byte  243,69,15,91,208                    // cvttps2dq     %xmm8,%xmm10
  .byte  69,15,91,210                        // cvtdq2ps      %xmm10,%xmm10
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  69,15,194,218,1                     // cmpltps       %xmm10,%xmm11
  .byte  69,15,84,220                        // andps         %xmm12,%xmm11
  .byte  69,15,92,211                        // subps         %xmm11,%xmm10
  .byte  69,15,92,194                        // subps         %xmm10,%xmm8
  .byte  15,17,72,64                         // movups        %xmm1,0x40(%rax)
  .byte  68,15,17,136,128,0,0,0              // movups        %xmm9,0x80(%rax)
  .byte  68,15,17,128,192,0,0,0              // movups        %xmm8,0xc0(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_accumulate_sse2
.globl _sk_accumulate_sse2
FUNCTION(_sk_accumulate_sse2)
_sk_accumulate_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,15,16,128,0,1,0,0                // movups        0x100(%rax),%xmm8
  .byte  68,15,16,136,64,1,0,0               // movups        0x140(%rax),%xmm9
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  65,15,88,224                        // addps         %xmm8,%xmm4
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  68,15,89,193                        // mulps         %xmm1,%xmm8
  .byte  65,15,88,232                        // addps         %xmm8,%xmm5
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  68,15,89,194                        // mulps         %xmm2,%xmm8
  .byte  65,15,88,240                        // addps         %xmm8,%xmm6
  .byte  68,15,89,203                        // mulps         %xmm3,%xmm9
  .byte  65,15,88,249                        // addps         %xmm9,%xmm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_nx_sse2
.globl _sk_bilinear_nx_sse2
FUNCTION(_sk_bilinear_nx_sse2)
_sk_bilinear_nx_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  68,15,16,128,128,0,0,0              // movups        0x80(%rax),%xmm8
  .byte  15,88,5,14,13,1,0                   // addps         0x10d0e(%rip),%xmm0        # 3b150 <_sk_srcover_bgra_8888_sse2_lowp+0x11e8>
  .byte  68,15,40,13,6,7,1,0                 // movaps        0x10706(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  68,15,17,136,0,1,0,0                // movups        %xmm9,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_px_sse2
.globl _sk_bilinear_px_sse2
FUNCTION(_sk_bilinear_px_sse2)
_sk_bilinear_px_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  68,15,16,128,128,0,0,0              // movups        0x80(%rax),%xmm8
  .byte  15,88,5,210,6,1,0                   // addps         0x106d2(%rip),%xmm0        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,17,128,0,1,0,0                // movups        %xmm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_ny_sse2
.globl _sk_bilinear_ny_sse2
FUNCTION(_sk_bilinear_ny_sse2)
_sk_bilinear_ny_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,72,64                         // movups        0x40(%rax),%xmm1
  .byte  68,15,16,128,192,0,0,0              // movups        0xc0(%rax),%xmm8
  .byte  15,88,13,193,12,1,0                 // addps         0x10cc1(%rip),%xmm1        # 3b150 <_sk_srcover_bgra_8888_sse2_lowp+0x11e8>
  .byte  68,15,40,13,185,6,1,0               // movaps        0x106b9(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  68,15,17,136,64,1,0,0               // movups        %xmm9,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bilinear_py_sse2
.globl _sk_bilinear_py_sse2
FUNCTION(_sk_bilinear_py_sse2)
_sk_bilinear_py_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,72,64                         // movups        0x40(%rax),%xmm1
  .byte  68,15,16,128,192,0,0,0              // movups        0xc0(%rax),%xmm8
  .byte  15,88,13,132,6,1,0                  // addps         0x10684(%rip),%xmm1        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,17,128,64,1,0,0               // movups        %xmm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n3x_sse2
.globl _sk_bicubic_n3x_sse2
FUNCTION(_sk_bicubic_n3x_sse2)
_sk_bicubic_n3x_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  68,15,16,128,128,0,0,0              // movups        0x80(%rax),%xmm8
  .byte  15,88,5,132,12,1,0                  // addps         0x10c84(%rip),%xmm0        # 3b160 <_sk_srcover_bgra_8888_sse2_lowp+0x11f8>
  .byte  68,15,40,13,108,6,1,0               // movaps        0x1066c(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  68,15,89,13,120,12,1,0              // mulps         0x10c78(%rip),%xmm9        # 3b170 <_sk_srcover_bgra_8888_sse2_lowp+0x1208>
  .byte  68,15,88,13,80,8,1,0                // addps         0x10850(%rip),%xmm9        # 3ad50 <_sk_srcover_bgra_8888_sse2_lowp+0xde8>
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  68,15,17,136,0,1,0,0                // movups        %xmm9,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n1x_sse2
.globl _sk_bicubic_n1x_sse2
FUNCTION(_sk_bicubic_n1x_sse2)
_sk_bicubic_n1x_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  68,15,16,128,128,0,0,0              // movups        0x80(%rax),%xmm8
  .byte  15,88,5,44,12,1,0                   // addps         0x10c2c(%rip),%xmm0        # 3b150 <_sk_srcover_bgra_8888_sse2_lowp+0x11e8>
  .byte  68,15,40,13,36,6,1,0                // movaps        0x10624(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  68,15,40,5,72,12,1,0                // movaps        0x10c48(%rip),%xmm8        # 3b180 <_sk_srcover_bgra_8888_sse2_lowp+0x1218>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,88,5,76,12,1,0                // addps         0x10c4c(%rip),%xmm8        # 3b190 <_sk_srcover_bgra_8888_sse2_lowp+0x1228>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,88,5,240,5,1,0                // addps         0x105f0(%rip),%xmm8        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,88,5,68,12,1,0                // addps         0x10c44(%rip),%xmm8        # 3b1a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1238>
  .byte  68,15,17,128,0,1,0,0                // movups        %xmm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p1x_sse2
.globl _sk_bicubic_p1x_sse2
FUNCTION(_sk_bicubic_p1x_sse2)
_sk_bicubic_p1x_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,15,40,5,206,5,1,0                // movaps        0x105ce(%rip),%xmm8        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  68,15,16,136,128,0,0,0              // movups        0x80(%rax),%xmm9
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  68,15,40,21,247,11,1,0              // movaps        0x10bf7(%rip),%xmm10        # 3b180 <_sk_srcover_bgra_8888_sse2_lowp+0x1218>
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  68,15,88,21,251,11,1,0              // addps         0x10bfb(%rip),%xmm10        # 3b190 <_sk_srcover_bgra_8888_sse2_lowp+0x1228>
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,208                        // addps         %xmm8,%xmm10
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  68,15,88,21,247,11,1,0              // addps         0x10bf7(%rip),%xmm10        # 3b1a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1238>
  .byte  68,15,17,144,0,1,0,0                // movups        %xmm10,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p3x_sse2
.globl _sk_bicubic_p3x_sse2
FUNCTION(_sk_bicubic_p3x_sse2)
_sk_bicubic_p3x_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  68,15,16,128,128,0,0,0              // movups        0x80(%rax),%xmm8
  .byte  15,88,5,199,11,1,0                  // addps         0x10bc7(%rip),%xmm0        # 3b190 <_sk_srcover_bgra_8888_sse2_lowp+0x1228>
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  69,15,89,201                        // mulps         %xmm9,%xmm9
  .byte  68,15,89,5,151,11,1,0               // mulps         0x10b97(%rip),%xmm8        # 3b170 <_sk_srcover_bgra_8888_sse2_lowp+0x1208>
  .byte  68,15,88,5,111,7,1,0                // addps         0x1076f(%rip),%xmm8        # 3ad50 <_sk_srcover_bgra_8888_sse2_lowp+0xde8>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,17,128,0,1,0,0                // movups        %xmm8,0x100(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n3y_sse2
.globl _sk_bicubic_n3y_sse2
FUNCTION(_sk_bicubic_n3y_sse2)
_sk_bicubic_n3y_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,72,64                         // movups        0x40(%rax),%xmm1
  .byte  68,15,16,128,192,0,0,0              // movups        0xc0(%rax),%xmm8
  .byte  15,88,13,90,11,1,0                  // addps         0x10b5a(%rip),%xmm1        # 3b160 <_sk_srcover_bgra_8888_sse2_lowp+0x11f8>
  .byte  68,15,40,13,66,5,1,0                // movaps        0x10542(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  69,15,40,193                        // movaps        %xmm9,%xmm8
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  68,15,89,13,78,11,1,0               // mulps         0x10b4e(%rip),%xmm9        # 3b170 <_sk_srcover_bgra_8888_sse2_lowp+0x1208>
  .byte  68,15,88,13,38,7,1,0                // addps         0x10726(%rip),%xmm9        # 3ad50 <_sk_srcover_bgra_8888_sse2_lowp+0xde8>
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  68,15,17,136,64,1,0,0               // movups        %xmm9,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_n1y_sse2
.globl _sk_bicubic_n1y_sse2
FUNCTION(_sk_bicubic_n1y_sse2)
_sk_bicubic_n1y_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,72,64                         // movups        0x40(%rax),%xmm1
  .byte  68,15,16,128,192,0,0,0              // movups        0xc0(%rax),%xmm8
  .byte  15,88,13,1,11,1,0                   // addps         0x10b01(%rip),%xmm1        # 3b150 <_sk_srcover_bgra_8888_sse2_lowp+0x11e8>
  .byte  68,15,40,13,249,4,1,0               // movaps        0x104f9(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,92,200                        // subps         %xmm8,%xmm9
  .byte  68,15,40,5,29,11,1,0                // movaps        0x10b1d(%rip),%xmm8        # 3b180 <_sk_srcover_bgra_8888_sse2_lowp+0x1218>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,88,5,33,11,1,0                // addps         0x10b21(%rip),%xmm8        # 3b190 <_sk_srcover_bgra_8888_sse2_lowp+0x1228>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,88,5,197,4,1,0                // addps         0x104c5(%rip),%xmm8        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,88,5,25,11,1,0                // addps         0x10b19(%rip),%xmm8        # 3b1a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1238>
  .byte  68,15,17,128,64,1,0,0               // movups        %xmm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p1y_sse2
.globl _sk_bicubic_p1y_sse2
FUNCTION(_sk_bicubic_p1y_sse2)
_sk_bicubic_p1y_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,15,40,5,163,4,1,0                // movaps        0x104a3(%rip),%xmm8        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,16,72,64                         // movups        0x40(%rax),%xmm1
  .byte  68,15,16,136,192,0,0,0              // movups        0xc0(%rax),%xmm9
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  68,15,40,21,203,10,1,0              // movaps        0x10acb(%rip),%xmm10        # 3b180 <_sk_srcover_bgra_8888_sse2_lowp+0x1218>
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  68,15,88,21,207,10,1,0              // addps         0x10acf(%rip),%xmm10        # 3b190 <_sk_srcover_bgra_8888_sse2_lowp+0x1228>
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  69,15,88,208                        // addps         %xmm8,%xmm10
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  68,15,88,21,203,10,1,0              // addps         0x10acb(%rip),%xmm10        # 3b1a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1238>
  .byte  68,15,17,144,64,1,0,0               // movups        %xmm10,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_bicubic_p3y_sse2
.globl _sk_bicubic_p3y_sse2
FUNCTION(_sk_bicubic_p3y_sse2)
_sk_bicubic_p3y_sse2:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,16,72,64                         // movups        0x40(%rax),%xmm1
  .byte  68,15,16,128,192,0,0,0              // movups        0xc0(%rax),%xmm8
  .byte  15,88,13,154,10,1,0                 // addps         0x10a9a(%rip),%xmm1        # 3b190 <_sk_srcover_bgra_8888_sse2_lowp+0x1228>
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  69,15,89,201                        // mulps         %xmm9,%xmm9
  .byte  68,15,89,5,106,10,1,0               // mulps         0x10a6a(%rip),%xmm8        # 3b170 <_sk_srcover_bgra_8888_sse2_lowp+0x1208>
  .byte  68,15,88,5,66,6,1,0                 // addps         0x10642(%rip),%xmm8        # 3ad50 <_sk_srcover_bgra_8888_sse2_lowp+0xde8>
  .byte  69,15,89,193                        // mulps         %xmm9,%xmm8
  .byte  68,15,17,128,64,1,0,0               // movups        %xmm8,0x140(%rax)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_callback_sse2
.globl _sk_callback_sse2
FUNCTION(_sk_callback_sse2)
_sk_callback_sse2:
  .byte  85                                  // push          %rbp
  .byte  72,137,229                          // mov           %rsp,%rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,236,72                       // sub           $0x48,%rsp
  .byte  15,41,125,144                       // movaps        %xmm7,-0x70(%rbp)
  .byte  15,41,117,160                       // movaps        %xmm6,-0x60(%rbp)
  .byte  15,41,109,176                       // movaps        %xmm5,-0x50(%rbp)
  .byte  15,41,101,192                       // movaps        %xmm4,-0x40(%rbp)
  .byte  73,137,206                          // mov           %rcx,%r14
  .byte  73,137,215                          // mov           %rdx,%r15
  .byte  73,137,253                          // mov           %rdi,%r13
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,137,195                          // mov           %rax,%rbx
  .byte  73,137,244                          // mov           %rsi,%r12
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,20,225                           // unpcklps      %xmm1,%xmm4
  .byte  15,40,234                           // movaps        %xmm2,%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  15,21,193                           // unpckhps      %xmm1,%xmm0
  .byte  15,21,211                           // unpckhps      %xmm3,%xmm2
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  102,15,20,205                       // unpcklpd      %xmm5,%xmm1
  .byte  15,18,236                           // movhlps       %xmm4,%xmm5
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  102,15,20,218                       // unpcklpd      %xmm2,%xmm3
  .byte  102,15,17,75,8                      // movupd        %xmm1,0x8(%rbx)
  .byte  15,18,208                           // movhlps       %xmm0,%xmm2
  .byte  15,17,107,24                        // movups        %xmm5,0x18(%rbx)
  .byte  102,15,17,91,40                     // movupd        %xmm3,0x28(%rbx)
  .byte  15,17,83,56                         // movups        %xmm2,0x38(%rbx)
  .byte  77,133,237                          // test          %r13,%r13
  .byte  190,4,0,0,0                         // mov           $0x4,%esi
  .byte  65,15,69,245                        // cmovne        %r13d,%esi
  .byte  72,137,223                          // mov           %rbx,%rdi
  .byte  255,19                              // callq         *(%rbx)
  .byte  72,139,131,8,1,0,0                  // mov           0x108(%rbx),%rax
  .byte  15,16,32                            // movups        (%rax),%xmm4
  .byte  15,16,64,16                         // movups        0x10(%rax),%xmm0
  .byte  15,16,88,32                         // movups        0x20(%rax),%xmm3
  .byte  15,16,80,48                         // movups        0x30(%rax),%xmm2
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,20,202                           // unpcklps      %xmm2,%xmm1
  .byte  15,21,224                           // unpckhps      %xmm0,%xmm4
  .byte  15,21,218                           // unpckhps      %xmm2,%xmm3
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  102,15,20,193                       // unpcklpd      %xmm1,%xmm0
  .byte  15,18,205                           // movhlps       %xmm5,%xmm1
  .byte  15,40,212                           // movaps        %xmm4,%xmm2
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  15,18,220                           // movhlps       %xmm4,%xmm3
  .byte  76,137,230                          // mov           %r12,%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,137,239                          // mov           %r13,%rdi
  .byte  76,137,250                          // mov           %r15,%rdx
  .byte  76,137,241                          // mov           %r14,%rcx
  .byte  15,40,101,192                       // movaps        -0x40(%rbp),%xmm4
  .byte  15,40,109,176                       // movaps        -0x50(%rbp),%xmm5
  .byte  15,40,117,160                       // movaps        -0x60(%rbp),%xmm6
  .byte  15,40,125,144                       // movaps        -0x70(%rbp),%xmm7
  .byte  72,131,196,72                       // add           $0x48,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clut_3D_sse2
.globl _sk_clut_3D_sse2
FUNCTION(_sk_clut_3D_sse2)
_sk_clut_3D_sse2:
  .byte  83                                  // push          %rbx
  .byte  72,131,236,64                       // sub           $0x40,%rsp
  .byte  15,41,124,36,48                     // movaps        %xmm7,0x30(%rsp)
  .byte  15,41,116,36,32                     // movaps        %xmm6,0x20(%rsp)
  .byte  15,41,108,36,16                     // movaps        %xmm5,0x10(%rsp)
  .byte  15,41,36,36                         // movaps        %xmm4,(%rsp)
  .byte  15,41,92,36,240                     // movaps        %xmm3,-0x10(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,16                        // mov           0x10(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  102,65,15,110,217                   // movd          %r9d,%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,218                           // mulps         %xmm2,%xmm3
  .byte  243,68,15,91,235                    // cvttps2dq     %xmm3,%xmm13
  .byte  68,15,40,219                        // movaps        %xmm3,%xmm11
  .byte  68,15,41,92,36,224                  // movaps        %xmm11,-0x20(%rsp)
  .byte  102,65,15,110,208                   // movd          %r8d,%xmm2
  .byte  102,68,15,112,250,0                 // pshufd        $0x0,%xmm2,%xmm15
  .byte  68,139,64,12                        // mov           0xc(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  102,65,15,110,217                   // movd          %r9d,%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  15,91,251                           // cvtdq2ps      %xmm3,%xmm7
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  243,15,91,239                       // cvttps2dq     %xmm7,%xmm5
  .byte  102,15,127,108,36,128               // movdqa        %xmm5,-0x80(%rsp)
  .byte  15,41,124,36,144                    // movaps        %xmm7,-0x70(%rsp)
  .byte  102,15,112,205,245                  // pshufd        $0xf5,%xmm5,%xmm1
  .byte  102,65,15,244,207                   // pmuludq       %xmm15,%xmm1
  .byte  102,65,15,111,223                   // movdqa        %xmm15,%xmm3
  .byte  102,15,244,221                      // pmuludq       %xmm5,%xmm3
  .byte  102,68,15,112,211,232               // pshufd        $0xe8,%xmm3,%xmm10
  .byte  102,15,112,201,232                  // pshufd        $0xe8,%xmm1,%xmm1
  .byte  102,68,15,98,209                    // punpckldq     %xmm1,%xmm10
  .byte  102,65,15,110,200                   // movd          %r8d,%xmm1
  .byte  102,15,244,202                      // pmuludq       %xmm2,%xmm1
  .byte  102,15,112,209,0                    // pshufd        $0x0,%xmm1,%xmm2
  .byte  68,139,64,8                         // mov           0x8(%rax),%r8d
  .byte  65,255,200                          // dec           %r8d
  .byte  102,65,15,110,200                   // movd          %r8d,%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  68,15,91,241                        // cvtdq2ps      %xmm1,%xmm14
  .byte  68,15,89,240                        // mulps         %xmm0,%xmm14
  .byte  243,69,15,91,206                    // cvttps2dq     %xmm14,%xmm9
  .byte  102,65,15,112,193,245               // pshufd        $0xf5,%xmm9,%xmm0
  .byte  102,15,244,194                      // pmuludq       %xmm2,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,65,15,244,201                   // pmuludq       %xmm9,%xmm1
  .byte  102,15,112,217,232                  // pshufd        $0xe8,%xmm1,%xmm3
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,98,216                       // punpckldq     %xmm0,%xmm3
  .byte  102,15,127,92,36,176                // movdqa        %xmm3,-0x50(%rsp)
  .byte  102,65,15,111,202                   // movdqa        %xmm10,%xmm1
  .byte  102,65,15,254,205                   // paddd         %xmm13,%xmm1
  .byte  102,68,15,127,108,36,208            // movdqa        %xmm13,-0x30(%rsp)
  .byte  102,15,254,217                      // paddd         %xmm1,%xmm3
  .byte  102,68,15,111,5,177,8,1,0           // movdqa        0x108b1(%rip),%xmm8        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,15,112,195,245                  // pshufd        $0xf5,%xmm3,%xmm0
  .byte  102,65,15,244,216                   // pmuludq       %xmm8,%xmm3
  .byte  102,65,15,244,192                   // pmuludq       %xmm8,%xmm0
  .byte  102,15,112,224,232                  // pshufd        $0xe8,%xmm0,%xmm4
  .byte  102,15,112,195,232                  // pshufd        $0xe8,%xmm3,%xmm0
  .byte  102,15,98,196                       // punpckldq     %xmm4,%xmm0
  .byte  102,65,15,126,216                   // movd          %xmm3,%r8d
  .byte  102,15,112,216,229                  // pshufd        $0xe5,%xmm0,%xmm3
  .byte  102,65,15,126,217                   // movd          %xmm3,%r9d
  .byte  102,15,112,216,78                   // pshufd        $0x4e,%xmm0,%xmm3
  .byte  102,65,15,126,218                   // movd          %xmm3,%r10d
  .byte  102,15,112,216,231                  // pshufd        $0xe7,%xmm0,%xmm3
  .byte  102,65,15,126,219                   // movd          %xmm3,%r11d
  .byte  72,139,24                           // mov           (%rax),%rbx
  .byte  243,66,15,16,28,155                 // movss         (%rbx,%r11,4),%xmm3
  .byte  243,66,15,16,36,147                 // movss         (%rbx,%r10,4),%xmm4
  .byte  15,20,227                           // unpcklps      %xmm3,%xmm4
  .byte  243,66,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm3
  .byte  243,66,15,16,52,131                 // movss         (%rbx,%r8,4),%xmm6
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  102,15,20,244                       // unpcklpd      %xmm4,%xmm6
  .byte  102,15,118,228                      // pcmpeqd       %xmm4,%xmm4
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,15,250,220                      // psubd         %xmm4,%xmm3
  .byte  102,15,112,227,78                   // pshufd        $0x4e,%xmm3,%xmm4
  .byte  102,73,15,126,224                   // movq          %xmm4,%r8
  .byte  102,73,15,126,217                   // movq          %xmm3,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  243,66,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm4
  .byte  243,66,15,16,28,147                 // movss         (%rbx,%r10,4),%xmm3
  .byte  15,20,220                           // unpcklps      %xmm4,%xmm3
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm4
  .byte  243,66,15,16,44,139                 // movss         (%rbx,%r9,4),%xmm5
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  102,15,20,221                       // unpcklpd      %xmm5,%xmm3
  .byte  102,68,15,111,37,184,1,1,0          // movdqa        0x101b8(%rip),%xmm12        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,65,15,254,196                   // paddd         %xmm12,%xmm0
  .byte  102,15,112,224,78                   // pshufd        $0x4e,%xmm0,%xmm4
  .byte  102,73,15,126,224                   // movq          %xmm4,%r8
  .byte  102,73,15,126,193                   // movq          %xmm0,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  243,66,15,16,44,147                 // movss         (%rbx,%r10,4),%xmm5
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm0
  .byte  243,66,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm4
  .byte  15,20,224                           // unpcklps      %xmm0,%xmm4
  .byte  102,15,20,236                       // unpcklpd      %xmm4,%xmm5
  .byte  15,40,37,157,7,1,0                  // movaps        0x1079d(%rip),%xmm4        # 3b1b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1248>
  .byte  68,15,88,220                        // addps         %xmm4,%xmm11
  .byte  68,15,41,92,36,192                  // movaps        %xmm11,-0x40(%rsp)
  .byte  68,15,40,223                        // movaps        %xmm7,%xmm11
  .byte  68,15,88,220                        // addps         %xmm4,%xmm11
  .byte  65,15,88,230                        // addps         %xmm14,%xmm4
  .byte  243,15,91,228                       // cvttps2dq     %xmm4,%xmm4
  .byte  102,15,112,252,245                  // pshufd        $0xf5,%xmm4,%xmm7
  .byte  102,15,244,250                      // pmuludq       %xmm2,%xmm7
  .byte  102,15,244,212                      // pmuludq       %xmm4,%xmm2
  .byte  102,15,112,194,232                  // pshufd        $0xe8,%xmm2,%xmm0
  .byte  102,15,112,215,232                  // pshufd        $0xe8,%xmm7,%xmm2
  .byte  102,15,98,194                       // punpckldq     %xmm2,%xmm0
  .byte  102,15,127,68,36,160                // movdqa        %xmm0,-0x60(%rsp)
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,112,209,245                  // pshufd        $0xf5,%xmm1,%xmm2
  .byte  102,65,15,244,200                   // pmuludq       %xmm8,%xmm1
  .byte  102,65,15,244,208                   // pmuludq       %xmm8,%xmm2
  .byte  102,15,112,226,232                  // pshufd        $0xe8,%xmm2,%xmm4
  .byte  102,15,112,209,232                  // pshufd        $0xe8,%xmm1,%xmm2
  .byte  102,15,98,212                       // punpckldq     %xmm4,%xmm2
  .byte  102,65,15,126,200                   // movd          %xmm1,%r8d
  .byte  102,15,112,202,229                  // pshufd        $0xe5,%xmm2,%xmm1
  .byte  102,65,15,126,201                   // movd          %xmm1,%r9d
  .byte  102,15,112,202,78                   // pshufd        $0x4e,%xmm2,%xmm1
  .byte  102,65,15,126,202                   // movd          %xmm1,%r10d
  .byte  102,15,112,202,231                  // pshufd        $0xe7,%xmm2,%xmm1
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  243,66,15,16,36,147                 // movss         (%rbx,%r10,4),%xmm4
  .byte  15,20,225                           // unpcklps      %xmm1,%xmm4
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  243,66,15,16,60,131                 // movss         (%rbx,%r8,4),%xmm7
  .byte  15,20,249                           // unpcklps      %xmm1,%xmm7
  .byte  102,15,20,252                       // unpcklpd      %xmm4,%xmm7
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,250,13,18,7,1,0              // psubd         0x10712(%rip),%xmm1        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,15,112,225,78                   // pshufd        $0x4e,%xmm1,%xmm4
  .byte  102,73,15,126,224                   // movq          %xmm4,%r8
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  243,66,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm4
  .byte  15,20,225                           // unpcklps      %xmm1,%xmm4
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  15,20,193                           // unpcklps      %xmm1,%xmm0
  .byte  102,15,20,224                       // unpcklpd      %xmm0,%xmm4
  .byte  102,65,15,254,212                   // paddd         %xmm12,%xmm2
  .byte  102,15,112,194,78                   // pshufd        $0x4e,%xmm2,%xmm0
  .byte  102,73,15,126,192                   // movq          %xmm0,%r8
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  15,20,208                           // unpcklps      %xmm0,%xmm2
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm0
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  102,15,20,209                       // unpcklpd      %xmm1,%xmm2
  .byte  65,15,91,193                        // cvtdq2ps      %xmm9,%xmm0
  .byte  68,15,92,240                        // subps         %xmm0,%xmm14
  .byte  15,92,254                           // subps         %xmm6,%xmm7
  .byte  65,15,89,254                        // mulps         %xmm14,%xmm7
  .byte  15,88,254                           // addps         %xmm6,%xmm7
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  65,15,89,230                        // mulps         %xmm14,%xmm4
  .byte  15,88,227                           // addps         %xmm3,%xmm4
  .byte  15,92,213                           // subps         %xmm5,%xmm2
  .byte  65,15,89,214                        // mulps         %xmm14,%xmm2
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  243,65,15,91,195                    // cvttps2dq     %xmm11,%xmm0
  .byte  102,15,112,200,245                  // pshufd        $0xf5,%xmm0,%xmm1
  .byte  102,65,15,244,207                   // pmuludq       %xmm15,%xmm1
  .byte  102,68,15,244,248                   // pmuludq       %xmm0,%xmm15
  .byte  102,69,15,112,231,232               // pshufd        $0xe8,%xmm15,%xmm12
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,68,15,98,224                    // punpckldq     %xmm0,%xmm12
  .byte  102,65,15,111,244                   // movdqa        %xmm12,%xmm6
  .byte  102,65,15,254,245                   // paddd         %xmm13,%xmm6
  .byte  102,15,111,206                      // movdqa        %xmm6,%xmm1
  .byte  102,15,254,76,36,176                // paddd         -0x50(%rsp),%xmm1
  .byte  102,15,112,193,245                  // pshufd        $0xf5,%xmm1,%xmm0
  .byte  102,65,15,244,200                   // pmuludq       %xmm8,%xmm1
  .byte  102,65,15,244,192                   // pmuludq       %xmm8,%xmm0
  .byte  102,69,15,111,216                   // movdqa        %xmm8,%xmm11
  .byte  102,15,112,216,232                  // pshufd        $0xe8,%xmm0,%xmm3
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,98,195                       // punpckldq     %xmm3,%xmm0
  .byte  102,65,15,126,200                   // movd          %xmm1,%r8d
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,65,15,126,201                   // movd          %xmm1,%r9d
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,65,15,126,202                   // movd          %xmm1,%r10d
  .byte  102,15,112,200,231                  // pshufd        $0xe7,%xmm0,%xmm1
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  243,66,15,16,28,147                 // movss         (%rbx,%r10,4),%xmm3
  .byte  15,20,217                           // unpcklps      %xmm1,%xmm3
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  243,70,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm8
  .byte  68,15,20,193                        // unpcklps      %xmm1,%xmm8
  .byte  102,68,15,20,195                    // unpcklpd      %xmm3,%xmm8
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,65,15,250,201                   // psubd         %xmm9,%xmm1
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,73,15,126,216                   // movq          %xmm3,%r8
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  243,66,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm3
  .byte  15,20,217                           // unpcklps      %xmm1,%xmm3
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  15,20,233                           // unpcklps      %xmm1,%xmm5
  .byte  102,15,20,221                       // unpcklpd      %xmm5,%xmm3
  .byte  102,68,15,111,45,42,255,0,0         // movdqa        0xff2a(%rip),%xmm13        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,65,15,254,197                   // paddd         %xmm13,%xmm0
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,73,15,126,200                   // movq          %xmm1,%r8
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm0
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  102,15,20,205                       // unpcklpd      %xmm5,%xmm1
  .byte  102,15,254,116,36,160               // paddd         -0x60(%rsp),%xmm6
  .byte  102,15,112,198,245                  // pshufd        $0xf5,%xmm6,%xmm0
  .byte  102,65,15,244,243                   // pmuludq       %xmm11,%xmm6
  .byte  102,65,15,244,195                   // pmuludq       %xmm11,%xmm0
  .byte  102,15,112,232,232                  // pshufd        $0xe8,%xmm0,%xmm5
  .byte  102,15,112,198,232                  // pshufd        $0xe8,%xmm6,%xmm0
  .byte  102,15,98,197                       // punpckldq     %xmm5,%xmm0
  .byte  102,65,15,126,240                   // movd          %xmm6,%r8d
  .byte  102,15,112,232,229                  // pshufd        $0xe5,%xmm0,%xmm5
  .byte  102,65,15,126,233                   // movd          %xmm5,%r9d
  .byte  102,15,112,232,78                   // pshufd        $0x4e,%xmm0,%xmm5
  .byte  102,65,15,126,234                   // movd          %xmm5,%r10d
  .byte  102,15,112,232,231                  // pshufd        $0xe7,%xmm0,%xmm5
  .byte  102,15,126,232                      // movd          %xmm5,%eax
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  243,66,15,16,52,147                 // movss         (%rbx,%r10,4),%xmm6
  .byte  15,20,245                           // unpcklps      %xmm5,%xmm6
  .byte  243,66,15,16,44,139                 // movss         (%rbx,%r9,4),%xmm5
  .byte  243,70,15,16,60,131                 // movss         (%rbx,%r8,4),%xmm15
  .byte  68,15,20,253                        // unpcklps      %xmm5,%xmm15
  .byte  102,68,15,20,254                    // unpcklpd      %xmm6,%xmm15
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,65,15,250,233                   // psubd         %xmm9,%xmm5
  .byte  102,15,112,245,78                   // pshufd        $0x4e,%xmm5,%xmm6
  .byte  102,73,15,126,240                   // movq          %xmm6,%r8
  .byte  102,72,15,126,232                   // movq          %xmm5,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  243,70,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm11
  .byte  68,15,20,221                        // unpcklps      %xmm5,%xmm11
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm5
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  15,20,245                           // unpcklps      %xmm5,%xmm6
  .byte  102,68,15,20,222                    // unpcklpd      %xmm6,%xmm11
  .byte  102,65,15,254,197                   // paddd         %xmm13,%xmm0
  .byte  102,15,112,232,78                   // pshufd        $0x4e,%xmm0,%xmm5
  .byte  102,73,15,126,232                   // movq          %xmm5,%r8
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,70,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm9
  .byte  68,15,20,200                        // unpcklps      %xmm0,%xmm9
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm0
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  102,68,15,20,205                    // unpcklpd      %xmm5,%xmm9
  .byte  69,15,92,248                        // subps         %xmm8,%xmm15
  .byte  69,15,89,254                        // mulps         %xmm14,%xmm15
  .byte  69,15,88,248                        // addps         %xmm8,%xmm15
  .byte  68,15,92,219                        // subps         %xmm3,%xmm11
  .byte  69,15,89,222                        // mulps         %xmm14,%xmm11
  .byte  68,15,88,219                        // addps         %xmm3,%xmm11
  .byte  68,15,92,201                        // subps         %xmm1,%xmm9
  .byte  69,15,89,206                        // mulps         %xmm14,%xmm9
  .byte  68,15,88,201                        // addps         %xmm1,%xmm9
  .byte  15,91,68,36,128                     // cvtdq2ps      -0x80(%rsp),%xmm0
  .byte  15,40,76,36,144                     // movaps        -0x70(%rsp),%xmm1
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,41,76,36,144                     // movaps        %xmm1,-0x70(%rsp)
  .byte  68,15,92,255                        // subps         %xmm7,%xmm15
  .byte  68,15,89,249                        // mulps         %xmm1,%xmm15
  .byte  68,15,88,255                        // addps         %xmm7,%xmm15
  .byte  68,15,92,220                        // subps         %xmm4,%xmm11
  .byte  68,15,89,217                        // mulps         %xmm1,%xmm11
  .byte  68,15,88,220                        // addps         %xmm4,%xmm11
  .byte  68,15,92,202                        // subps         %xmm2,%xmm9
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  68,15,88,202                        // addps         %xmm2,%xmm9
  .byte  243,15,91,68,36,192                 // cvttps2dq     -0x40(%rsp),%xmm0
  .byte  102,15,127,68,36,128                // movdqa        %xmm0,-0x80(%rsp)
  .byte  102,68,15,254,208                   // paddd         %xmm0,%xmm10
  .byte  102,15,111,116,36,176               // movdqa        -0x50(%rsp),%xmm6
  .byte  102,15,111,206                      // movdqa        %xmm6,%xmm1
  .byte  102,65,15,254,202                   // paddd         %xmm10,%xmm1
  .byte  102,15,112,209,245                  // pshufd        $0xf5,%xmm1,%xmm2
  .byte  102,15,111,29,173,3,1,0             // movdqa        0x103ad(%rip),%xmm3        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,15,244,203                      // pmuludq       %xmm3,%xmm1
  .byte  102,15,244,211                      // pmuludq       %xmm3,%xmm2
  .byte  102,15,111,251                      // movdqa        %xmm3,%xmm7
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,112,217,232                  // pshufd        $0xe8,%xmm1,%xmm3
  .byte  102,15,98,218                       // punpckldq     %xmm2,%xmm3
  .byte  102,65,15,126,200                   // movd          %xmm1,%r8d
  .byte  102,15,112,203,229                  // pshufd        $0xe5,%xmm3,%xmm1
  .byte  102,65,15,126,201                   // movd          %xmm1,%r9d
  .byte  102,15,112,203,78                   // pshufd        $0x4e,%xmm3,%xmm1
  .byte  102,65,15,126,202                   // movd          %xmm1,%r10d
  .byte  102,15,112,203,231                  // pshufd        $0xe7,%xmm3,%xmm1
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  243,66,15,16,20,147                 // movss         (%rbx,%r10,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  243,66,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm4
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  15,20,204                           // unpcklps      %xmm4,%xmm1
  .byte  102,15,20,202                       // unpcklpd      %xmm2,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,69,15,118,237                   // pcmpeqd       %xmm13,%xmm13
  .byte  102,65,15,250,213                   // psubd         %xmm13,%xmm2
  .byte  102,15,112,226,78                   // pshufd        $0x4e,%xmm2,%xmm4
  .byte  102,73,15,126,224                   // movq          %xmm4,%r8
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,36,131                    // movss         (%rbx,%rax,4),%xmm4
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  15,20,212                           // unpcklps      %xmm4,%xmm2
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm4
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  102,15,20,213                       // unpcklpd      %xmm5,%xmm2
  .byte  102,15,111,5,189,252,0,0            // movdqa        0xfcbd(%rip),%xmm0        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,15,254,216                      // paddd         %xmm0,%xmm3
  .byte  102,15,112,227,78                   // pshufd        $0x4e,%xmm3,%xmm4
  .byte  102,73,15,126,224                   // movq          %xmm4,%r8
  .byte  102,72,15,126,216                   // movq          %xmm3,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,36,131                    // movss         (%rbx,%rax,4),%xmm4
  .byte  243,66,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm3
  .byte  15,20,220                           // unpcklps      %xmm4,%xmm3
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm4
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  102,15,20,221                       // unpcklpd      %xmm5,%xmm3
  .byte  102,68,15,254,84,36,160             // paddd         -0x60(%rsp),%xmm10
  .byte  102,65,15,112,226,245               // pshufd        $0xf5,%xmm10,%xmm4
  .byte  102,68,15,244,215                   // pmuludq       %xmm7,%xmm10
  .byte  102,15,244,231                      // pmuludq       %xmm7,%xmm4
  .byte  102,15,112,236,232                  // pshufd        $0xe8,%xmm4,%xmm5
  .byte  102,65,15,112,226,232               // pshufd        $0xe8,%xmm10,%xmm4
  .byte  102,15,98,229                       // punpckldq     %xmm5,%xmm4
  .byte  102,69,15,126,208                   // movd          %xmm10,%r8d
  .byte  102,15,112,236,229                  // pshufd        $0xe5,%xmm4,%xmm5
  .byte  102,65,15,126,233                   // movd          %xmm5,%r9d
  .byte  102,15,112,236,78                   // pshufd        $0x4e,%xmm4,%xmm5
  .byte  102,65,15,126,234                   // movd          %xmm5,%r10d
  .byte  102,15,112,236,231                  // pshufd        $0xe7,%xmm4,%xmm5
  .byte  102,15,126,232                      // movd          %xmm5,%eax
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  243,66,15,16,60,147                 // movss         (%rbx,%r10,4),%xmm7
  .byte  15,20,253                           // unpcklps      %xmm5,%xmm7
  .byte  243,66,15,16,44,139                 // movss         (%rbx,%r9,4),%xmm5
  .byte  243,70,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm8
  .byte  68,15,20,197                        // unpcklps      %xmm5,%xmm8
  .byte  102,68,15,20,199                    // unpcklpd      %xmm7,%xmm8
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,65,15,250,237                   // psubd         %xmm13,%xmm5
  .byte  102,15,112,253,78                   // pshufd        $0x4e,%xmm5,%xmm7
  .byte  102,73,15,126,248                   // movq          %xmm7,%r8
  .byte  102,72,15,126,232                   // movq          %xmm5,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  243,70,15,16,44,139                 // movss         (%rbx,%r9,4),%xmm13
  .byte  68,15,20,237                        // unpcklps      %xmm5,%xmm13
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm5
  .byte  243,15,16,60,131                    // movss         (%rbx,%rax,4),%xmm7
  .byte  15,20,253                           // unpcklps      %xmm5,%xmm7
  .byte  102,68,15,20,239                    // unpcklpd      %xmm7,%xmm13
  .byte  102,15,254,224                      // paddd         %xmm0,%xmm4
  .byte  102,15,112,236,78                   // pshufd        $0x4e,%xmm4,%xmm5
  .byte  102,73,15,126,232                   // movq          %xmm5,%r8
  .byte  102,72,15,126,224                   // movq          %xmm4,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,36,131                    // movss         (%rbx,%rax,4),%xmm4
  .byte  243,66,15,16,44,139                 // movss         (%rbx,%r9,4),%xmm5
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm4
  .byte  243,15,16,60,131                    // movss         (%rbx,%rax,4),%xmm7
  .byte  15,20,252                           // unpcklps      %xmm4,%xmm7
  .byte  102,15,20,239                       // unpcklpd      %xmm7,%xmm5
  .byte  68,15,92,193                        // subps         %xmm1,%xmm8
  .byte  69,15,89,198                        // mulps         %xmm14,%xmm8
  .byte  68,15,88,193                        // addps         %xmm1,%xmm8
  .byte  68,15,92,234                        // subps         %xmm2,%xmm13
  .byte  69,15,89,238                        // mulps         %xmm14,%xmm13
  .byte  68,15,88,234                        // addps         %xmm2,%xmm13
  .byte  15,92,235                           // subps         %xmm3,%xmm5
  .byte  65,15,89,238                        // mulps         %xmm14,%xmm5
  .byte  15,88,235                           // addps         %xmm3,%xmm5
  .byte  102,68,15,254,100,36,128            // paddd         -0x80(%rsp),%xmm12
  .byte  102,15,111,214                      // movdqa        %xmm6,%xmm2
  .byte  102,65,15,254,212                   // paddd         %xmm12,%xmm2
  .byte  102,15,112,194,245                  // pshufd        $0xf5,%xmm2,%xmm0
  .byte  102,15,111,13,138,1,1,0             // movdqa        0x1018a(%rip),%xmm1        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,193                      // pmuludq       %xmm1,%xmm0
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,112,200,232                  // pshufd        $0xe8,%xmm0,%xmm1
  .byte  102,15,112,194,232                  // pshufd        $0xe8,%xmm2,%xmm0
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  102,65,15,126,208                   // movd          %xmm2,%r8d
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,65,15,126,201                   // movd          %xmm1,%r9d
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,65,15,126,202                   // movd          %xmm1,%r10d
  .byte  102,15,112,200,231                  // pshufd        $0xe7,%xmm0,%xmm1
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  243,66,15,16,20,147                 // movss         (%rbx,%r10,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  243,70,15,16,20,131                 // movss         (%rbx,%r8,4),%xmm10
  .byte  68,15,20,209                        // unpcklps      %xmm1,%xmm10
  .byte  102,68,15,20,210                    // unpcklpd      %xmm2,%xmm10
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,250,13,47,1,1,0              // psubd         0x1012f(%rip),%xmm1        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,73,15,126,208                   // movq          %xmm2,%r8
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  243,66,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm4
  .byte  15,20,225                           // unpcklps      %xmm1,%xmm4
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  243,15,16,20,131                    // movss         (%rbx,%rax,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  102,15,20,226                       // unpcklpd      %xmm2,%xmm4
  .byte  102,15,254,5,154,250,0,0            // paddd         0xfa9a(%rip),%xmm0        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,73,15,126,200                   // movq          %xmm1,%r8
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,66,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm3
  .byte  15,20,216                           // unpcklps      %xmm0,%xmm3
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm0
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  102,15,20,217                       // unpcklpd      %xmm1,%xmm3
  .byte  102,68,15,254,100,36,160            // paddd         -0x60(%rsp),%xmm12
  .byte  102,65,15,112,196,245               // pshufd        $0xf5,%xmm12,%xmm0
  .byte  102,68,15,244,230                   // pmuludq       %xmm6,%xmm12
  .byte  102,15,244,198                      // pmuludq       %xmm6,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,65,15,112,212,232               // pshufd        $0xe8,%xmm12,%xmm2
  .byte  102,15,98,208                       // punpckldq     %xmm0,%xmm2
  .byte  102,69,15,126,224                   // movd          %xmm12,%r8d
  .byte  102,15,112,194,229                  // pshufd        $0xe5,%xmm2,%xmm0
  .byte  102,65,15,126,193                   // movd          %xmm0,%r9d
  .byte  102,15,112,194,78                   // pshufd        $0x4e,%xmm2,%xmm0
  .byte  102,65,15,126,194                   // movd          %xmm0,%r10d
  .byte  102,15,112,194,231                  // pshufd        $0xe7,%xmm2,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,66,15,16,12,147                 // movss         (%rbx,%r10,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,66,15,16,60,139                 // movss         (%rbx,%r9,4),%xmm7
  .byte  243,66,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm0
  .byte  15,20,199                           // unpcklps      %xmm7,%xmm0
  .byte  102,15,20,193                       // unpcklpd      %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,250,13,57,0,1,0              // psubd         0x10039(%rip),%xmm1        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,15,112,249,78                   // pshufd        $0x4e,%xmm1,%xmm7
  .byte  102,73,15,126,248                   // movq          %xmm7,%r8
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,60,131                    // movss         (%rbx,%rax,4),%xmm7
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  15,20,207                           // unpcklps      %xmm7,%xmm1
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,60,131                 // movss         (%rbx,%r8,4),%xmm7
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  15,20,247                           // unpcklps      %xmm7,%xmm6
  .byte  102,15,20,206                       // unpcklpd      %xmm6,%xmm1
  .byte  102,15,254,21,164,249,0,0           // paddd         0xf9a4(%rip),%xmm2        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,15,112,242,78                   // pshufd        $0x4e,%xmm2,%xmm6
  .byte  102,73,15,126,240                   // movq          %xmm6,%r8
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  15,20,214                           // unpcklps      %xmm6,%xmm2
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,52,131                 // movss         (%rbx,%r8,4),%xmm6
  .byte  243,15,16,60,131                    // movss         (%rbx,%rax,4),%xmm7
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  102,15,20,215                       // unpcklpd      %xmm7,%xmm2
  .byte  65,15,92,194                        // subps         %xmm10,%xmm0
  .byte  65,15,89,198                        // mulps         %xmm14,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  15,92,204                           // subps         %xmm4,%xmm1
  .byte  65,15,89,206                        // mulps         %xmm14,%xmm1
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  65,15,89,214                        // mulps         %xmm14,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  65,15,92,192                        // subps         %xmm8,%xmm0
  .byte  15,40,92,36,144                     // movaps        -0x70(%rsp),%xmm3
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  65,15,92,205                        // subps         %xmm13,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  65,15,88,205                        // addps         %xmm13,%xmm1
  .byte  15,92,213                           // subps         %xmm5,%xmm2
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,91,92,36,208                     // cvtdq2ps      -0x30(%rsp),%xmm3
  .byte  15,40,100,36,224                    // movaps        -0x20(%rsp),%xmm4
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  65,15,92,199                        // subps         %xmm15,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  65,15,88,199                        // addps         %xmm15,%xmm0
  .byte  65,15,92,203                        // subps         %xmm11,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  65,15,92,209                        // subps         %xmm9,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  65,15,88,209                        // addps         %xmm9,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,92,36,240                     // movaps        -0x10(%rsp),%xmm3
  .byte  15,40,36,36                         // movaps        (%rsp),%xmm4
  .byte  15,40,108,36,16                     // movaps        0x10(%rsp),%xmm5
  .byte  15,40,116,36,32                     // movaps        0x20(%rsp),%xmm6
  .byte  15,40,124,36,48                     // movaps        0x30(%rsp),%xmm7
  .byte  72,131,196,64                       // add           $0x40,%rsp
  .byte  91                                  // pop           %rbx
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clut_4D_sse2
.globl _sk_clut_4D_sse2
FUNCTION(_sk_clut_4D_sse2)
_sk_clut_4D_sse2:
  .byte  83                                  // push          %rbx
  .byte  72,129,236,160,0,0,0                // sub           $0xa0,%rsp
  .byte  15,41,188,36,144,0,0,0              // movaps        %xmm7,0x90(%rsp)
  .byte  15,41,180,36,128,0,0,0              // movaps        %xmm6,0x80(%rsp)
  .byte  15,41,108,36,112                    // movaps        %xmm5,0x70(%rsp)
  .byte  15,41,100,36,96                     // movaps        %xmm4,0x60(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  68,139,64,20                        // mov           0x14(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  102,65,15,110,225                   // movd          %r9d,%xmm4
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  102,65,15,110,216                   // movd          %r8d,%xmm3
  .byte  102,15,112,251,0                    // pshufd        $0x0,%xmm3,%xmm7
  .byte  102,15,127,124,36,128               // movdqa        %xmm7,-0x80(%rsp)
  .byte  68,139,64,16                        // mov           0x10(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  102,65,15,110,225                   // movd          %r9d,%xmm4
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,226                           // mulps         %xmm2,%xmm4
  .byte  243,15,91,244                       // cvttps2dq     %xmm4,%xmm6
  .byte  102,15,127,116,36,208               // movdqa        %xmm6,-0x30(%rsp)
  .byte  68,15,40,252                        // movaps        %xmm4,%xmm15
  .byte  68,15,41,124,36,240                 // movaps        %xmm15,-0x10(%rsp)
  .byte  102,15,112,214,245                  // pshufd        $0xf5,%xmm6,%xmm2
  .byte  102,15,244,215                      // pmuludq       %xmm7,%xmm2
  .byte  102,15,111,231                      // movdqa        %xmm7,%xmm4
  .byte  102,15,244,230                      // pmuludq       %xmm6,%xmm4
  .byte  102,68,15,112,244,232               // pshufd        $0xe8,%xmm4,%xmm14
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,68,15,98,242                    // punpckldq     %xmm2,%xmm14
  .byte  102,65,15,110,208                   // movd          %r8d,%xmm2
  .byte  102,15,244,211                      // pmuludq       %xmm3,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,244,216                      // pmuludq       %xmm0,%xmm3
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  102,15,98,211                       // punpckldq     %xmm3,%xmm2
  .byte  102,68,15,112,226,0                 // pshufd        $0x0,%xmm2,%xmm12
  .byte  68,139,64,12                        // mov           0xc(%rax),%r8d
  .byte  69,141,72,255                       // lea           -0x1(%r8),%r9d
  .byte  102,65,15,110,217                   // movd          %r9d,%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  68,15,91,219                        // cvtdq2ps      %xmm3,%xmm11
  .byte  68,15,89,217                        // mulps         %xmm1,%xmm11
  .byte  243,65,15,91,227                    // cvttps2dq     %xmm11,%xmm4
  .byte  102,15,127,100,36,192               // movdqa        %xmm4,-0x40(%rsp)
  .byte  68,15,41,92,36,144                  // movaps        %xmm11,-0x70(%rsp)
  .byte  102,15,112,204,245                  // pshufd        $0xf5,%xmm4,%xmm1
  .byte  102,65,15,244,204                   // pmuludq       %xmm12,%xmm1
  .byte  102,65,15,111,220                   // movdqa        %xmm12,%xmm3
  .byte  102,15,244,220                      // pmuludq       %xmm4,%xmm3
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  102,15,112,201,232                  // pshufd        $0xe8,%xmm1,%xmm1
  .byte  102,15,98,217                       // punpckldq     %xmm1,%xmm3
  .byte  102,15,127,28,36                    // movdqa        %xmm3,(%rsp)
  .byte  102,65,15,110,200                   // movd          %r8d,%xmm1
  .byte  102,15,244,202                      // pmuludq       %xmm2,%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  68,139,64,8                         // mov           0x8(%rax),%r8d
  .byte  65,255,200                          // dec           %r8d
  .byte  102,65,15,110,208                   // movd          %r8d,%xmm2
  .byte  102,15,112,210,0                    // pshufd        $0x0,%xmm2,%xmm2
  .byte  68,15,91,234                        // cvtdq2ps      %xmm2,%xmm13
  .byte  68,15,89,232                        // mulps         %xmm0,%xmm13
  .byte  243,69,15,91,205                    // cvttps2dq     %xmm13,%xmm9
  .byte  102,65,15,112,193,245               // pshufd        $0xf5,%xmm9,%xmm0
  .byte  102,15,244,193                      // pmuludq       %xmm1,%xmm0
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,65,15,244,209                   // pmuludq       %xmm9,%xmm2
  .byte  102,15,112,226,232                  // pshufd        $0xe8,%xmm2,%xmm4
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,98,224                       // punpckldq     %xmm0,%xmm4
  .byte  102,15,127,100,36,160               // movdqa        %xmm4,-0x60(%rsp)
  .byte  243,15,91,197                       // cvttps2dq     %xmm5,%xmm0
  .byte  102,15,127,68,36,48                 // movdqa        %xmm0,0x30(%rsp)
  .byte  68,15,40,197                        // movaps        %xmm5,%xmm8
  .byte  68,15,41,68,36,80                   // movaps        %xmm8,0x50(%rsp)
  .byte  102,69,15,111,214                   // movdqa        %xmm14,%xmm10
  .byte  102,68,15,254,208                   // paddd         %xmm0,%xmm10
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,65,15,254,210                   // paddd         %xmm10,%xmm2
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  102,15,254,218                      // paddd         %xmm2,%xmm3
  .byte  102,15,111,37,124,253,0,0           // movdqa        0xfd7c(%rip),%xmm4        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,15,112,195,245                  // pshufd        $0xf5,%xmm3,%xmm0
  .byte  102,15,244,220                      // pmuludq       %xmm4,%xmm3
  .byte  102,15,244,196                      // pmuludq       %xmm4,%xmm0
  .byte  102,15,112,224,232                  // pshufd        $0xe8,%xmm0,%xmm4
  .byte  102,15,112,195,232                  // pshufd        $0xe8,%xmm3,%xmm0
  .byte  102,15,98,196                       // punpckldq     %xmm4,%xmm0
  .byte  102,65,15,126,216                   // movd          %xmm3,%r8d
  .byte  102,15,112,216,229                  // pshufd        $0xe5,%xmm0,%xmm3
  .byte  102,65,15,126,217                   // movd          %xmm3,%r9d
  .byte  102,15,112,216,78                   // pshufd        $0x4e,%xmm0,%xmm3
  .byte  102,65,15,126,218                   // movd          %xmm3,%r10d
  .byte  102,15,112,216,231                  // pshufd        $0xe7,%xmm0,%xmm3
  .byte  102,65,15,126,219                   // movd          %xmm3,%r11d
  .byte  72,139,24                           // mov           (%rax),%rbx
  .byte  243,66,15,16,28,155                 // movss         (%rbx,%r11,4),%xmm3
  .byte  243,66,15,16,36,147                 // movss         (%rbx,%r10,4),%xmm4
  .byte  15,20,227                           // unpcklps      %xmm3,%xmm4
  .byte  243,66,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm3
  .byte  243,66,15,16,60,131                 // movss         (%rbx,%r8,4),%xmm7
  .byte  15,20,251                           // unpcklps      %xmm3,%xmm7
  .byte  102,15,20,252                       // unpcklpd      %xmm4,%xmm7
  .byte  102,15,118,228                      // pcmpeqd       %xmm4,%xmm4
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,15,250,220                      // psubd         %xmm4,%xmm3
  .byte  102,15,112,227,78                   // pshufd        $0x4e,%xmm3,%xmm4
  .byte  102,73,15,126,224                   // movq          %xmm4,%r8
  .byte  102,73,15,126,217                   // movq          %xmm3,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  243,66,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm4
  .byte  243,66,15,16,44,147                 // movss         (%rbx,%r10,4),%xmm5
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm4
  .byte  243,66,15,16,52,139                 // movss         (%rbx,%r9,4),%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  102,15,20,238                       // unpcklpd      %xmm6,%xmm5
  .byte  102,15,254,5,134,246,0,0            // paddd         0xf686(%rip),%xmm0        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,15,112,224,78                   // pshufd        $0x4e,%xmm0,%xmm4
  .byte  102,73,15,126,224                   // movq          %xmm4,%r8
  .byte  102,73,15,126,193                   // movq          %xmm0,%r9
  .byte  69,137,202                          // mov           %r9d,%r10d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  243,66,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm4
  .byte  243,66,15,16,28,147                 // movss         (%rbx,%r10,4),%xmm3
  .byte  15,20,220                           // unpcklps      %xmm4,%xmm3
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm4
  .byte  243,66,15,16,52,139                 // movss         (%rbx,%r9,4),%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  102,15,20,222                       // unpcklpd      %xmm6,%xmm3
  .byte  15,40,53,112,252,0,0                // movaps        0xfc70(%rip),%xmm6        # 3b1b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1248>
  .byte  68,15,88,198                        // addps         %xmm6,%xmm8
  .byte  68,15,41,68,36,176                  // movaps        %xmm8,-0x50(%rsp)
  .byte  68,15,88,254                        // addps         %xmm6,%xmm15
  .byte  68,15,41,124,36,64                  // movaps        %xmm15,0x40(%rsp)
  .byte  69,15,40,195                        // movaps        %xmm11,%xmm8
  .byte  68,15,88,198                        // addps         %xmm6,%xmm8
  .byte  65,15,88,245                        // addps         %xmm13,%xmm6
  .byte  243,15,91,246                       // cvttps2dq     %xmm6,%xmm6
  .byte  102,15,112,198,245                  // pshufd        $0xf5,%xmm6,%xmm0
  .byte  102,15,244,193                      // pmuludq       %xmm1,%xmm0
  .byte  102,15,244,206                      // pmuludq       %xmm6,%xmm1
  .byte  102,68,15,112,249,232               // pshufd        $0xe8,%xmm1,%xmm15
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,68,15,98,248                    // punpckldq     %xmm0,%xmm15
  .byte  102,65,15,254,215                   // paddd         %xmm15,%xmm2
  .byte  102,68,15,127,124,36,224            // movdqa        %xmm15,-0x20(%rsp)
  .byte  102,15,112,194,245                  // pshufd        $0xf5,%xmm2,%xmm0
  .byte  102,15,111,13,38,252,0,0            // movdqa        0xfc26(%rip),%xmm1        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,193                      // pmuludq       %xmm1,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,112,202,232                  // pshufd        $0xe8,%xmm2,%xmm1
  .byte  102,15,98,200                       // punpckldq     %xmm0,%xmm1
  .byte  102,65,15,126,208                   // movd          %xmm2,%r8d
  .byte  102,15,112,193,229                  // pshufd        $0xe5,%xmm1,%xmm0
  .byte  102,65,15,126,193                   // movd          %xmm0,%r9d
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,65,15,126,194                   // movd          %xmm0,%r10d
  .byte  102,15,112,193,231                  // pshufd        $0xe7,%xmm1,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,66,15,16,20,147                 // movss         (%rbx,%r10,4),%xmm2
  .byte  15,20,208                           // unpcklps      %xmm0,%xmm2
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  243,66,15,16,52,131                 // movss         (%rbx,%r8,4),%xmm6
  .byte  15,20,240                           // unpcklps      %xmm0,%xmm6
  .byte  102,15,20,242                       // unpcklpd      %xmm2,%xmm6
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,250,5,209,251,0,0            // psubd         0xfbd1(%rip),%xmm0        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,15,112,208,78                   // pshufd        $0x4e,%xmm0,%xmm2
  .byte  102,73,15,126,208                   // movq          %xmm2,%r8
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  15,20,208                           // unpcklps      %xmm0,%xmm2
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm0
  .byte  243,68,15,16,28,131                 // movss         (%rbx,%rax,4),%xmm11
  .byte  68,15,20,216                        // unpcklps      %xmm0,%xmm11
  .byte  102,65,15,20,211                    // unpcklpd      %xmm11,%xmm2
  .byte  102,15,254,13,57,245,0,0            // paddd         0xf539(%rip),%xmm1        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,73,15,126,192                   // movq          %xmm0,%r8
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm0
  .byte  243,15,16,36,131                    // movss         (%rbx,%rax,4),%xmm4
  .byte  15,20,224                           // unpcklps      %xmm0,%xmm4
  .byte  102,15,20,204                       // unpcklpd      %xmm4,%xmm1
  .byte  65,15,91,193                        // cvtdq2ps      %xmm9,%xmm0
  .byte  68,15,92,232                        // subps         %xmm0,%xmm13
  .byte  15,92,247                           // subps         %xmm7,%xmm6
  .byte  65,15,89,245                        // mulps         %xmm13,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  15,92,213                           // subps         %xmm5,%xmm2
  .byte  65,15,89,213                        // mulps         %xmm13,%xmm2
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  65,15,89,205                        // mulps         %xmm13,%xmm1
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  243,65,15,91,192                    // cvttps2dq     %xmm8,%xmm0
  .byte  102,15,112,216,245                  // pshufd        $0xf5,%xmm0,%xmm3
  .byte  102,65,15,244,220                   // pmuludq       %xmm12,%xmm3
  .byte  102,68,15,244,224                   // pmuludq       %xmm0,%xmm12
  .byte  102,65,15,112,228,232               // pshufd        $0xe8,%xmm12,%xmm4
  .byte  102,15,112,195,232                  // pshufd        $0xe8,%xmm3,%xmm0
  .byte  102,15,98,224                       // punpckldq     %xmm0,%xmm4
  .byte  102,15,127,100,36,16                // movdqa        %xmm4,0x10(%rsp)
  .byte  102,68,15,254,212                   // paddd         %xmm4,%xmm10
  .byte  102,65,15,111,194                   // movdqa        %xmm10,%xmm0
  .byte  102,15,254,68,36,160                // paddd         -0x60(%rsp),%xmm0
  .byte  102,15,112,216,245                  // pshufd        $0xf5,%xmm0,%xmm3
  .byte  102,15,111,37,208,250,0,0           // movdqa        0xfad0(%rip),%xmm4        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,15,244,196                      // pmuludq       %xmm4,%xmm0
  .byte  102,15,244,220                      // pmuludq       %xmm4,%xmm3
  .byte  102,68,15,111,220                   // movdqa        %xmm4,%xmm11
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  102,15,112,224,232                  // pshufd        $0xe8,%xmm0,%xmm4
  .byte  102,15,98,227                       // punpckldq     %xmm3,%xmm4
  .byte  102,65,15,126,192                   // movd          %xmm0,%r8d
  .byte  102,15,112,196,229                  // pshufd        $0xe5,%xmm4,%xmm0
  .byte  102,65,15,126,193                   // movd          %xmm0,%r9d
  .byte  102,15,112,196,78                   // pshufd        $0x4e,%xmm4,%xmm0
  .byte  102,65,15,126,194                   // movd          %xmm0,%r10d
  .byte  102,15,112,196,231                  // pshufd        $0xe7,%xmm4,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,66,15,16,44,147                 // movss         (%rbx,%r10,4),%xmm5
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  243,70,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm9
  .byte  68,15,20,200                        // unpcklps      %xmm0,%xmm9
  .byte  102,68,15,20,205                    // unpcklpd      %xmm5,%xmm9
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,69,15,118,228                   // pcmpeqd       %xmm12,%xmm12
  .byte  102,65,15,250,196                   // psubd         %xmm12,%xmm0
  .byte  102,15,112,232,78                   // pshufd        $0x4e,%xmm0,%xmm5
  .byte  102,73,15,126,232                   // movq          %xmm5,%r8
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  15,20,197                           // unpcklps      %xmm5,%xmm0
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm5
  .byte  243,15,16,60,131                    // movss         (%rbx,%rax,4),%xmm7
  .byte  15,20,253                           // unpcklps      %xmm5,%xmm7
  .byte  102,15,20,199                       // unpcklpd      %xmm7,%xmm0
  .byte  102,68,15,111,5,220,243,0,0         // movdqa        0xf3dc(%rip),%xmm8        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,65,15,254,224                   // paddd         %xmm8,%xmm4
  .byte  102,15,112,236,78                   // pshufd        $0x4e,%xmm4,%xmm5
  .byte  102,73,15,126,232                   // movq          %xmm5,%r8
  .byte  102,72,15,126,224                   // movq          %xmm4,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  243,66,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm4
  .byte  15,20,229                           // unpcklps      %xmm5,%xmm4
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm5
  .byte  243,15,16,60,131                    // movss         (%rbx,%rax,4),%xmm7
  .byte  15,20,253                           // unpcklps      %xmm5,%xmm7
  .byte  102,15,20,231                       // unpcklpd      %xmm7,%xmm4
  .byte  102,69,15,254,215                   // paddd         %xmm15,%xmm10
  .byte  102,65,15,112,234,245               // pshufd        $0xf5,%xmm10,%xmm5
  .byte  102,69,15,244,211                   // pmuludq       %xmm11,%xmm10
  .byte  102,65,15,244,235                   // pmuludq       %xmm11,%xmm5
  .byte  102,69,15,111,251                   // movdqa        %xmm11,%xmm15
  .byte  102,15,112,253,232                  // pshufd        $0xe8,%xmm5,%xmm7
  .byte  102,65,15,112,234,232               // pshufd        $0xe8,%xmm10,%xmm5
  .byte  102,15,98,239                       // punpckldq     %xmm7,%xmm5
  .byte  102,69,15,126,208                   // movd          %xmm10,%r8d
  .byte  102,15,112,253,229                  // pshufd        $0xe5,%xmm5,%xmm7
  .byte  102,65,15,126,249                   // movd          %xmm7,%r9d
  .byte  102,15,112,253,78                   // pshufd        $0x4e,%xmm5,%xmm7
  .byte  102,65,15,126,250                   // movd          %xmm7,%r10d
  .byte  102,15,112,253,231                  // pshufd        $0xe7,%xmm5,%xmm7
  .byte  102,15,126,248                      // movd          %xmm7,%eax
  .byte  243,15,16,60,131                    // movss         (%rbx,%rax,4),%xmm7
  .byte  243,66,15,16,28,147                 // movss         (%rbx,%r10,4),%xmm3
  .byte  15,20,223                           // unpcklps      %xmm7,%xmm3
  .byte  243,66,15,16,60,139                 // movss         (%rbx,%r9,4),%xmm7
  .byte  243,70,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm11
  .byte  68,15,20,223                        // unpcklps      %xmm7,%xmm11
  .byte  102,68,15,20,219                    // unpcklpd      %xmm3,%xmm11
  .byte  102,15,111,221                      // movdqa        %xmm5,%xmm3
  .byte  102,65,15,250,220                   // psubd         %xmm12,%xmm3
  .byte  102,15,112,251,78                   // pshufd        $0x4e,%xmm3,%xmm7
  .byte  102,73,15,126,248                   // movq          %xmm7,%r8
  .byte  102,72,15,126,216                   // movq          %xmm3,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,28,131                    // movss         (%rbx,%rax,4),%xmm3
  .byte  243,70,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm10
  .byte  68,15,20,211                        // unpcklps      %xmm3,%xmm10
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  243,15,16,60,131                    // movss         (%rbx,%rax,4),%xmm7
  .byte  15,20,251                           // unpcklps      %xmm3,%xmm7
  .byte  102,68,15,20,215                    // unpcklpd      %xmm7,%xmm10
  .byte  102,65,15,254,232                   // paddd         %xmm8,%xmm5
  .byte  102,15,112,221,78                   // pshufd        $0x4e,%xmm5,%xmm3
  .byte  102,73,15,126,216                   // movq          %xmm3,%r8
  .byte  102,72,15,126,232                   // movq          %xmm5,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,28,131                    // movss         (%rbx,%rax,4),%xmm3
  .byte  243,70,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm12
  .byte  68,15,20,227                        // unpcklps      %xmm3,%xmm12
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  243,15,16,60,131                    // movss         (%rbx,%rax,4),%xmm7
  .byte  15,20,251                           // unpcklps      %xmm3,%xmm7
  .byte  102,68,15,20,231                    // unpcklpd      %xmm7,%xmm12
  .byte  69,15,92,217                        // subps         %xmm9,%xmm11
  .byte  68,15,41,108,36,32                  // movaps        %xmm13,0x20(%rsp)
  .byte  69,15,89,221                        // mulps         %xmm13,%xmm11
  .byte  69,15,88,217                        // addps         %xmm9,%xmm11
  .byte  68,15,92,208                        // subps         %xmm0,%xmm10
  .byte  69,15,89,213                        // mulps         %xmm13,%xmm10
  .byte  68,15,88,208                        // addps         %xmm0,%xmm10
  .byte  68,15,92,228                        // subps         %xmm4,%xmm12
  .byte  69,15,89,229                        // mulps         %xmm13,%xmm12
  .byte  68,15,88,228                        // addps         %xmm4,%xmm12
  .byte  15,91,68,36,192                     // cvtdq2ps      -0x40(%rsp),%xmm0
  .byte  15,40,92,36,144                     // movaps        -0x70(%rsp),%xmm3
  .byte  15,92,216                           // subps         %xmm0,%xmm3
  .byte  15,41,92,36,144                     // movaps        %xmm3,-0x70(%rsp)
  .byte  68,15,92,222                        // subps         %xmm6,%xmm11
  .byte  68,15,89,219                        // mulps         %xmm3,%xmm11
  .byte  68,15,88,222                        // addps         %xmm6,%xmm11
  .byte  68,15,92,210                        // subps         %xmm2,%xmm10
  .byte  68,15,89,211                        // mulps         %xmm3,%xmm10
  .byte  68,15,88,210                        // addps         %xmm2,%xmm10
  .byte  68,15,92,225                        // subps         %xmm1,%xmm12
  .byte  68,15,89,227                        // mulps         %xmm3,%xmm12
  .byte  68,15,88,225                        // addps         %xmm1,%xmm12
  .byte  243,15,91,68,36,64                  // cvttps2dq     0x40(%rsp),%xmm0
  .byte  102,15,112,200,245                  // pshufd        $0xf5,%xmm0,%xmm1
  .byte  102,15,111,84,36,128                // movdqa        -0x80(%rsp),%xmm2
  .byte  102,15,244,202                      // pmuludq       %xmm2,%xmm1
  .byte  102,15,244,208                      // pmuludq       %xmm0,%xmm2
  .byte  102,68,15,112,202,232               // pshufd        $0xe8,%xmm2,%xmm9
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,68,15,98,200                    // punpckldq     %xmm0,%xmm9
  .byte  102,68,15,127,76,36,128             // movdqa        %xmm9,-0x80(%rsp)
  .byte  102,68,15,254,76,36,48              // paddd         0x30(%rsp),%xmm9
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,15,254,4,36                     // paddd         (%rsp),%xmm0
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,68,15,111,68,36,160             // movdqa        -0x60(%rsp),%xmm8
  .byte  102,65,15,254,208                   // paddd         %xmm8,%xmm2
  .byte  102,15,112,202,245                  // pshufd        $0xf5,%xmm2,%xmm1
  .byte  102,65,15,111,223                   // movdqa        %xmm15,%xmm3
  .byte  102,15,244,211                      // pmuludq       %xmm3,%xmm2
  .byte  102,15,244,203                      // pmuludq       %xmm3,%xmm1
  .byte  102,15,111,243                      // movdqa        %xmm3,%xmm6
  .byte  102,15,112,217,232                  // pshufd        $0xe8,%xmm1,%xmm3
  .byte  102,15,112,202,232                  // pshufd        $0xe8,%xmm2,%xmm1
  .byte  102,15,98,203                       // punpckldq     %xmm3,%xmm1
  .byte  102,65,15,126,208                   // movd          %xmm2,%r8d
  .byte  102,15,112,209,229                  // pshufd        $0xe5,%xmm1,%xmm2
  .byte  102,65,15,126,209                   // movd          %xmm2,%r9d
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,65,15,126,210                   // movd          %xmm2,%r10d
  .byte  102,15,112,209,231                  // pshufd        $0xe7,%xmm1,%xmm2
  .byte  102,15,126,208                      // movd          %xmm2,%eax
  .byte  243,15,16,20,131                    // movss         (%rbx,%rax,4),%xmm2
  .byte  243,66,15,16,36,147                 // movss         (%rbx,%r10,4),%xmm4
  .byte  15,20,226                           // unpcklps      %xmm2,%xmm4
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  102,15,20,220                       // unpcklpd      %xmm4,%xmm3
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,15,118,237                      // pcmpeqd       %xmm5,%xmm5
  .byte  102,15,250,213                      // psubd         %xmm5,%xmm2
  .byte  102,15,112,226,78                   // pshufd        $0x4e,%xmm2,%xmm4
  .byte  102,73,15,126,224                   // movq          %xmm4,%r8
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,20,131                    // movss         (%rbx,%rax,4),%xmm2
  .byte  243,66,15,16,60,139                 // movss         (%rbx,%r9,4),%xmm7
  .byte  15,20,250                           // unpcklps      %xmm2,%xmm7
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,20,131                 // movss         (%rbx,%r8,4),%xmm2
  .byte  243,15,16,36,131                    // movss         (%rbx,%rax,4),%xmm4
  .byte  15,20,226                           // unpcklps      %xmm2,%xmm4
  .byte  102,15,20,252                       // unpcklpd      %xmm4,%xmm7
  .byte  102,68,15,111,61,54,241,0,0         // movdqa        0xf136(%rip),%xmm15        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,65,15,254,207                   // paddd         %xmm15,%xmm1
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,73,15,126,208                   // movq          %xmm2,%r8
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  243,15,16,36,131                    // movss         (%rbx,%rax,4),%xmm4
  .byte  15,20,225                           // unpcklps      %xmm1,%xmm4
  .byte  102,15,20,212                       // unpcklpd      %xmm4,%xmm2
  .byte  102,68,15,111,108,36,224            // movdqa        -0x20(%rsp),%xmm13
  .byte  102,65,15,254,197                   // paddd         %xmm13,%xmm0
  .byte  102,15,112,200,245                  // pshufd        $0xf5,%xmm0,%xmm1
  .byte  102,15,244,198                      // pmuludq       %xmm6,%xmm0
  .byte  102,15,244,206                      // pmuludq       %xmm6,%xmm1
  .byte  102,15,112,201,232                  // pshufd        $0xe8,%xmm1,%xmm1
  .byte  102,15,112,224,232                  // pshufd        $0xe8,%xmm0,%xmm4
  .byte  102,15,98,225                       // punpckldq     %xmm1,%xmm4
  .byte  102,65,15,126,192                   // movd          %xmm0,%r8d
  .byte  102,15,112,196,229                  // pshufd        $0xe5,%xmm4,%xmm0
  .byte  102,65,15,126,193                   // movd          %xmm0,%r9d
  .byte  102,15,112,196,78                   // pshufd        $0x4e,%xmm4,%xmm0
  .byte  102,65,15,126,194                   // movd          %xmm0,%r10d
  .byte  102,15,112,196,231                  // pshufd        $0xe7,%xmm4,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,66,15,16,52,147                 // movss         (%rbx,%r10,4),%xmm6
  .byte  15,20,240                           // unpcklps      %xmm0,%xmm6
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  102,15,20,206                       // unpcklpd      %xmm6,%xmm1
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,15,250,197                      // psubd         %xmm5,%xmm0
  .byte  102,15,112,240,78                   // pshufd        $0x4e,%xmm0,%xmm6
  .byte  102,73,15,126,240                   // movq          %xmm6,%r8
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  15,20,198                           // unpcklps      %xmm6,%xmm0
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,52,131                 // movss         (%rbx,%r8,4),%xmm6
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  15,20,238                           // unpcklps      %xmm6,%xmm5
  .byte  102,15,20,197                       // unpcklpd      %xmm5,%xmm0
  .byte  102,65,15,254,231                   // paddd         %xmm15,%xmm4
  .byte  102,15,112,236,78                   // pshufd        $0x4e,%xmm4,%xmm5
  .byte  102,73,15,126,232                   // movq          %xmm5,%r8
  .byte  102,72,15,126,224                   // movq          %xmm4,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  243,66,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm4
  .byte  15,20,229                           // unpcklps      %xmm5,%xmm4
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm5
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  15,20,245                           // unpcklps      %xmm5,%xmm6
  .byte  102,15,20,230                       // unpcklpd      %xmm6,%xmm4
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,40,108,36,32                     // movaps        0x20(%rsp),%xmm5
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  15,92,199                           // subps         %xmm7,%xmm0
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,92,226                           // subps         %xmm2,%xmm4
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,88,226                           // addps         %xmm2,%xmm4
  .byte  102,68,15,254,76,36,16              // paddd         0x10(%rsp),%xmm9
  .byte  102,65,15,111,217                   // movdqa        %xmm9,%xmm3
  .byte  102,65,15,254,216                   // paddd         %xmm8,%xmm3
  .byte  102,15,112,211,245                  // pshufd        $0xf5,%xmm3,%xmm2
  .byte  102,15,111,45,5,246,0,0             // movdqa        0xf605(%rip),%xmm5        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,15,244,221                      // pmuludq       %xmm5,%xmm3
  .byte  102,15,244,213                      // pmuludq       %xmm5,%xmm2
  .byte  102,15,112,234,232                  // pshufd        $0xe8,%xmm2,%xmm5
  .byte  102,15,112,211,232                  // pshufd        $0xe8,%xmm3,%xmm2
  .byte  102,15,98,213                       // punpckldq     %xmm5,%xmm2
  .byte  102,65,15,126,216                   // movd          %xmm3,%r8d
  .byte  102,15,112,218,229                  // pshufd        $0xe5,%xmm2,%xmm3
  .byte  102,65,15,126,217                   // movd          %xmm3,%r9d
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,65,15,126,218                   // movd          %xmm3,%r10d
  .byte  102,15,112,218,231                  // pshufd        $0xe7,%xmm2,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  243,15,16,28,131                    // movss         (%rbx,%rax,4),%xmm3
  .byte  243,66,15,16,44,147                 // movss         (%rbx,%r10,4),%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  243,66,15,16,52,139                 // movss         (%rbx,%r9,4),%xmm6
  .byte  243,70,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm8
  .byte  68,15,20,198                        // unpcklps      %xmm6,%xmm8
  .byte  102,68,15,20,197                    // unpcklpd      %xmm5,%xmm8
  .byte  102,15,111,234                      // movdqa        %xmm2,%xmm5
  .byte  102,15,250,45,174,245,0,0           // psubd         0xf5ae(%rip),%xmm5        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,15,112,245,78                   // pshufd        $0x4e,%xmm5,%xmm6
  .byte  102,73,15,126,240                   // movq          %xmm6,%r8
  .byte  102,72,15,126,232                   // movq          %xmm5,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  243,66,15,16,60,139                 // movss         (%rbx,%r9,4),%xmm7
  .byte  15,20,253                           // unpcklps      %xmm5,%xmm7
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm5
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  15,20,245                           // unpcklps      %xmm5,%xmm6
  .byte  102,15,20,254                       // unpcklpd      %xmm6,%xmm7
  .byte  102,65,15,254,215                   // paddd         %xmm15,%xmm2
  .byte  102,15,112,234,78                   // pshufd        $0x4e,%xmm2,%xmm5
  .byte  102,73,15,126,232                   // movq          %xmm5,%r8
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  15,20,213                           // unpcklps      %xmm5,%xmm2
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm5
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  15,20,245                           // unpcklps      %xmm5,%xmm6
  .byte  102,15,20,214                       // unpcklpd      %xmm6,%xmm2
  .byte  102,69,15,254,205                   // paddd         %xmm13,%xmm9
  .byte  102,65,15,112,233,245               // pshufd        $0xf5,%xmm9,%xmm5
  .byte  102,15,111,29,12,245,0,0            // movdqa        0xf50c(%rip),%xmm3        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,68,15,244,203                   // pmuludq       %xmm3,%xmm9
  .byte  102,15,244,235                      // pmuludq       %xmm3,%xmm5
  .byte  102,15,112,237,232                  // pshufd        $0xe8,%xmm5,%xmm5
  .byte  102,69,15,112,249,232               // pshufd        $0xe8,%xmm9,%xmm15
  .byte  102,68,15,98,253                    // punpckldq     %xmm5,%xmm15
  .byte  102,69,15,126,200                   // movd          %xmm9,%r8d
  .byte  102,65,15,112,239,229               // pshufd        $0xe5,%xmm15,%xmm5
  .byte  102,65,15,126,233                   // movd          %xmm5,%r9d
  .byte  102,65,15,112,239,78                // pshufd        $0x4e,%xmm15,%xmm5
  .byte  102,65,15,126,234                   // movd          %xmm5,%r10d
  .byte  102,65,15,112,239,231               // pshufd        $0xe7,%xmm15,%xmm5
  .byte  102,15,126,232                      // movd          %xmm5,%eax
  .byte  243,68,15,16,12,131                 // movss         (%rbx,%rax,4),%xmm9
  .byte  243,66,15,16,44,147                 // movss         (%rbx,%r10,4),%xmm5
  .byte  65,15,20,233                        // unpcklps      %xmm9,%xmm5
  .byte  243,70,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm9
  .byte  243,70,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm13
  .byte  69,15,20,233                        // unpcklps      %xmm9,%xmm13
  .byte  102,68,15,20,237                    // unpcklpd      %xmm5,%xmm13
  .byte  102,65,15,111,239                   // movdqa        %xmm15,%xmm5
  .byte  102,15,250,45,172,244,0,0           // psubd         0xf4ac(%rip),%xmm5        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,15,112,221,78                   // pshufd        $0x4e,%xmm5,%xmm3
  .byte  102,73,15,126,216                   // movq          %xmm3,%r8
  .byte  102,72,15,126,232                   // movq          %xmm5,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,28,131                    // movss         (%rbx,%rax,4),%xmm3
  .byte  243,66,15,16,52,139                 // movss         (%rbx,%r9,4),%xmm6
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  102,15,20,245                       // unpcklpd      %xmm5,%xmm6
  .byte  102,68,15,111,13,22,238,0,0         // movdqa        0xee16(%rip),%xmm9        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,69,15,254,249                   // paddd         %xmm9,%xmm15
  .byte  102,65,15,112,223,78                // pshufd        $0x4e,%xmm15,%xmm3
  .byte  102,73,15,126,216                   // movq          %xmm3,%r8
  .byte  102,76,15,126,248                   // movq          %xmm15,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,28,131                    // movss         (%rbx,%rax,4),%xmm3
  .byte  243,70,15,16,60,139                 // movss         (%rbx,%r9,4),%xmm15
  .byte  68,15,20,251                        // unpcklps      %xmm3,%xmm15
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  102,68,15,20,253                    // unpcklpd      %xmm5,%xmm15
  .byte  69,15,92,232                        // subps         %xmm8,%xmm13
  .byte  15,40,92,36,32                      // movaps        0x20(%rsp),%xmm3
  .byte  68,15,89,235                        // mulps         %xmm3,%xmm13
  .byte  69,15,88,232                        // addps         %xmm8,%xmm13
  .byte  15,92,247                           // subps         %xmm7,%xmm6
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  68,15,92,250                        // subps         %xmm2,%xmm15
  .byte  68,15,89,251                        // mulps         %xmm3,%xmm15
  .byte  68,15,40,195                        // movaps        %xmm3,%xmm8
  .byte  68,15,88,250                        // addps         %xmm2,%xmm15
  .byte  68,15,92,233                        // subps         %xmm1,%xmm13
  .byte  15,40,84,36,144                     // movaps        -0x70(%rsp),%xmm2
  .byte  68,15,89,234                        // mulps         %xmm2,%xmm13
  .byte  68,15,88,233                        // addps         %xmm1,%xmm13
  .byte  65,15,40,205                        // movaps        %xmm13,%xmm1
  .byte  15,92,240                           // subps         %xmm0,%xmm6
  .byte  15,89,242                           // mulps         %xmm2,%xmm6
  .byte  15,88,240                           // addps         %xmm0,%xmm6
  .byte  68,15,92,252                        // subps         %xmm4,%xmm15
  .byte  68,15,89,250                        // mulps         %xmm2,%xmm15
  .byte  68,15,88,252                        // addps         %xmm4,%xmm15
  .byte  15,91,68,36,208                     // cvtdq2ps      -0x30(%rsp),%xmm0
  .byte  15,40,84,36,240                     // movaps        -0x10(%rsp),%xmm2
  .byte  15,92,208                           // subps         %xmm0,%xmm2
  .byte  15,41,84,36,240                     // movaps        %xmm2,-0x10(%rsp)
  .byte  65,15,92,203                        // subps         %xmm11,%xmm1
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  15,41,76,36,208                     // movaps        %xmm1,-0x30(%rsp)
  .byte  65,15,92,242                        // subps         %xmm10,%xmm6
  .byte  15,89,242                           // mulps         %xmm2,%xmm6
  .byte  65,15,88,242                        // addps         %xmm10,%xmm6
  .byte  15,41,116,36,192                    // movaps        %xmm6,-0x40(%rsp)
  .byte  69,15,92,252                        // subps         %xmm12,%xmm15
  .byte  68,15,89,250                        // mulps         %xmm2,%xmm15
  .byte  69,15,88,252                        // addps         %xmm12,%xmm15
  .byte  243,15,91,68,36,176                 // cvttps2dq     -0x50(%rsp),%xmm0
  .byte  102,15,127,68,36,176                // movdqa        %xmm0,-0x50(%rsp)
  .byte  102,68,15,254,240                   // paddd         %xmm0,%xmm14
  .byte  102,15,111,28,36                    // movdqa        (%rsp),%xmm3
  .byte  102,65,15,254,222                   // paddd         %xmm14,%xmm3
  .byte  102,68,15,111,92,36,160             // movdqa        -0x60(%rsp),%xmm11
  .byte  102,65,15,111,195                   // movdqa        %xmm11,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  102,15,112,200,245                  // pshufd        $0xf5,%xmm0,%xmm1
  .byte  102,15,111,21,71,243,0,0            // movdqa        0xf347(%rip),%xmm2        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,15,244,194                      // pmuludq       %xmm2,%xmm0
  .byte  102,15,244,202                      // pmuludq       %xmm2,%xmm1
  .byte  102,68,15,111,234                   // movdqa        %xmm2,%xmm13
  .byte  102,15,112,201,232                  // pshufd        $0xe8,%xmm1,%xmm1
  .byte  102,15,112,208,232                  // pshufd        $0xe8,%xmm0,%xmm2
  .byte  102,15,98,209                       // punpckldq     %xmm1,%xmm2
  .byte  102,65,15,126,192                   // movd          %xmm0,%r8d
  .byte  102,15,112,194,229                  // pshufd        $0xe5,%xmm2,%xmm0
  .byte  102,65,15,126,193                   // movd          %xmm0,%r9d
  .byte  102,15,112,194,78                   // pshufd        $0x4e,%xmm2,%xmm0
  .byte  102,65,15,126,194                   // movd          %xmm0,%r10d
  .byte  102,15,112,194,231                  // pshufd        $0xe7,%xmm2,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,66,15,16,36,147                 // movss         (%rbx,%r10,4),%xmm4
  .byte  15,20,224                           // unpcklps      %xmm0,%xmm4
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  102,15,20,204                       // unpcklpd      %xmm4,%xmm1
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,118,255                      // pcmpeqd       %xmm7,%xmm7
  .byte  102,15,250,199                      // psubd         %xmm7,%xmm0
  .byte  102,15,112,224,78                   // pshufd        $0x4e,%xmm0,%xmm4
  .byte  102,73,15,126,224                   // movq          %xmm4,%r8
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,36,131                    // movss         (%rbx,%rax,4),%xmm4
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  15,20,196                           // unpcklps      %xmm4,%xmm0
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm4
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  102,15,20,197                       // unpcklpd      %xmm5,%xmm0
  .byte  102,65,15,254,209                   // paddd         %xmm9,%xmm2
  .byte  102,15,112,226,78                   // pshufd        $0x4e,%xmm2,%xmm4
  .byte  102,73,15,126,224                   // movq          %xmm4,%r8
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,36,131                    // movss         (%rbx,%rax,4),%xmm4
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  15,20,212                           // unpcklps      %xmm4,%xmm2
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm4
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  102,15,20,213                       // unpcklpd      %xmm5,%xmm2
  .byte  102,68,15,111,84,36,224             // movdqa        -0x20(%rsp),%xmm10
  .byte  102,65,15,254,218                   // paddd         %xmm10,%xmm3
  .byte  102,15,112,227,245                  // pshufd        $0xf5,%xmm3,%xmm4
  .byte  102,65,15,244,221                   // pmuludq       %xmm13,%xmm3
  .byte  102,65,15,244,229                   // pmuludq       %xmm13,%xmm4
  .byte  102,15,112,236,232                  // pshufd        $0xe8,%xmm4,%xmm5
  .byte  102,15,112,227,232                  // pshufd        $0xe8,%xmm3,%xmm4
  .byte  102,15,98,229                       // punpckldq     %xmm5,%xmm4
  .byte  102,65,15,126,216                   // movd          %xmm3,%r8d
  .byte  102,15,112,220,229                  // pshufd        $0xe5,%xmm4,%xmm3
  .byte  102,65,15,126,217                   // movd          %xmm3,%r9d
  .byte  102,15,112,220,78                   // pshufd        $0x4e,%xmm4,%xmm3
  .byte  102,65,15,126,218                   // movd          %xmm3,%r10d
  .byte  102,15,112,220,231                  // pshufd        $0xe7,%xmm4,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  243,15,16,28,131                    // movss         (%rbx,%rax,4),%xmm3
  .byte  243,66,15,16,44,147                 // movss         (%rbx,%r10,4),%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  243,66,15,16,52,139                 // movss         (%rbx,%r9,4),%xmm6
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  15,20,222                           // unpcklps      %xmm6,%xmm3
  .byte  102,15,20,221                       // unpcklpd      %xmm5,%xmm3
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,250,239                      // psubd         %xmm7,%xmm5
  .byte  102,69,15,118,228                   // pcmpeqd       %xmm12,%xmm12
  .byte  102,15,112,245,78                   // pshufd        $0x4e,%xmm5,%xmm6
  .byte  102,73,15,126,240                   // movq          %xmm6,%r8
  .byte  102,72,15,126,232                   // movq          %xmm5,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  243,66,15,16,44,139                 // movss         (%rbx,%r9,4),%xmm5
  .byte  15,20,238                           // unpcklps      %xmm6,%xmm5
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,52,131                 // movss         (%rbx,%r8,4),%xmm6
  .byte  243,15,16,60,131                    // movss         (%rbx,%rax,4),%xmm7
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  102,15,20,239                       // unpcklpd      %xmm7,%xmm5
  .byte  102,65,15,254,225                   // paddd         %xmm9,%xmm4
  .byte  102,15,112,244,78                   // pshufd        $0x4e,%xmm4,%xmm6
  .byte  102,73,15,126,240                   // movq          %xmm6,%r8
  .byte  102,72,15,126,224                   // movq          %xmm4,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,36,131                    // movss         (%rbx,%rax,4),%xmm4
  .byte  243,66,15,16,60,139                 // movss         (%rbx,%r9,4),%xmm7
  .byte  15,20,252                           // unpcklps      %xmm4,%xmm7
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm4
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  102,15,20,254                       // unpcklpd      %xmm6,%xmm7
  .byte  15,92,217                           // subps         %xmm1,%xmm3
  .byte  65,15,89,216                        // mulps         %xmm8,%xmm3
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  15,92,232                           // subps         %xmm0,%xmm5
  .byte  65,15,89,232                        // mulps         %xmm8,%xmm5
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  15,92,250                           // subps         %xmm2,%xmm7
  .byte  65,15,89,248                        // mulps         %xmm8,%xmm7
  .byte  15,88,250                           // addps         %xmm2,%xmm7
  .byte  102,68,15,254,116,36,16             // paddd         0x10(%rsp),%xmm14
  .byte  102,65,15,111,206                   // movdqa        %xmm14,%xmm1
  .byte  102,65,15,254,203                   // paddd         %xmm11,%xmm1
  .byte  102,15,112,193,245                  // pshufd        $0xf5,%xmm1,%xmm0
  .byte  102,65,15,244,205                   // pmuludq       %xmm13,%xmm1
  .byte  102,65,15,244,197                   // pmuludq       %xmm13,%xmm0
  .byte  102,15,112,208,232                  // pshufd        $0xe8,%xmm0,%xmm2
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,98,194                       // punpckldq     %xmm2,%xmm0
  .byte  102,65,15,126,200                   // movd          %xmm1,%r8d
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,65,15,126,201                   // movd          %xmm1,%r9d
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,65,15,126,202                   // movd          %xmm1,%r10d
  .byte  102,15,112,200,231                  // pshufd        $0xe7,%xmm0,%xmm1
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  243,66,15,16,36,147                 // movss         (%rbx,%r10,4),%xmm4
  .byte  15,20,225                           // unpcklps      %xmm1,%xmm4
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  243,70,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm11
  .byte  68,15,20,217                        // unpcklps      %xmm1,%xmm11
  .byte  102,68,15,20,220                    // unpcklpd      %xmm4,%xmm11
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,65,15,250,204                   // psubd         %xmm12,%xmm1
  .byte  102,15,112,225,78                   // pshufd        $0x4e,%xmm1,%xmm4
  .byte  102,73,15,126,224                   // movq          %xmm4,%r8
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,36,131                    // movss         (%rbx,%rax,4),%xmm4
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  15,20,204                           // unpcklps      %xmm4,%xmm1
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm4
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  102,15,20,206                       // unpcklpd      %xmm6,%xmm1
  .byte  102,65,15,254,193                   // paddd         %xmm9,%xmm0
  .byte  102,15,112,224,78                   // pshufd        $0x4e,%xmm0,%xmm4
  .byte  102,73,15,126,224                   // movq          %xmm4,%r8
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,36,131                    // movss         (%rbx,%rax,4),%xmm4
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  15,20,196                           // unpcklps      %xmm4,%xmm0
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm4
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  102,15,20,198                       // unpcklpd      %xmm6,%xmm0
  .byte  102,69,15,254,242                   // paddd         %xmm10,%xmm14
  .byte  102,69,15,111,226                   // movdqa        %xmm10,%xmm12
  .byte  102,65,15,112,230,245               // pshufd        $0xf5,%xmm14,%xmm4
  .byte  102,69,15,244,245                   // pmuludq       %xmm13,%xmm14
  .byte  102,65,15,244,229                   // pmuludq       %xmm13,%xmm4
  .byte  102,15,112,244,232                  // pshufd        $0xe8,%xmm4,%xmm6
  .byte  102,65,15,112,230,232               // pshufd        $0xe8,%xmm14,%xmm4
  .byte  102,15,98,230                       // punpckldq     %xmm6,%xmm4
  .byte  102,69,15,126,240                   // movd          %xmm14,%r8d
  .byte  102,15,112,244,229                  // pshufd        $0xe5,%xmm4,%xmm6
  .byte  102,65,15,126,241                   // movd          %xmm6,%r9d
  .byte  102,15,112,244,78                   // pshufd        $0x4e,%xmm4,%xmm6
  .byte  102,65,15,126,242                   // movd          %xmm6,%r10d
  .byte  102,15,112,244,231                  // pshufd        $0xe7,%xmm4,%xmm6
  .byte  102,15,126,240                      // movd          %xmm6,%eax
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  243,66,15,16,20,147                 // movss         (%rbx,%r10,4),%xmm2
  .byte  15,20,214                           // unpcklps      %xmm6,%xmm2
  .byte  243,66,15,16,52,139                 // movss         (%rbx,%r9,4),%xmm6
  .byte  243,70,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm13
  .byte  68,15,20,238                        // unpcklps      %xmm6,%xmm13
  .byte  102,68,15,20,234                    // unpcklpd      %xmm2,%xmm13
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  102,15,250,21,227,239,0,0           // psubd         0xefe3(%rip),%xmm2        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,15,112,242,78                   // pshufd        $0x4e,%xmm2,%xmm6
  .byte  102,73,15,126,240                   // movq          %xmm6,%r8
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,20,131                    // movss         (%rbx,%rax,4),%xmm2
  .byte  243,70,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm10
  .byte  68,15,20,210                        // unpcklps      %xmm2,%xmm10
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,20,131                 // movss         (%rbx,%r8,4),%xmm2
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  102,68,15,20,214                    // unpcklpd      %xmm6,%xmm10
  .byte  102,65,15,254,225                   // paddd         %xmm9,%xmm4
  .byte  102,15,112,212,78                   // pshufd        $0x4e,%xmm4,%xmm2
  .byte  102,73,15,126,208                   // movq          %xmm2,%r8
  .byte  102,72,15,126,224                   // movq          %xmm4,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,20,131                    // movss         (%rbx,%rax,4),%xmm2
  .byte  243,70,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm9
  .byte  68,15,20,202                        // unpcklps      %xmm2,%xmm9
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,20,131                 // movss         (%rbx,%r8,4),%xmm2
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  102,68,15,20,206                    // unpcklpd      %xmm6,%xmm9
  .byte  69,15,92,235                        // subps         %xmm11,%xmm13
  .byte  69,15,89,232                        // mulps         %xmm8,%xmm13
  .byte  69,15,88,235                        // addps         %xmm11,%xmm13
  .byte  68,15,92,209                        // subps         %xmm1,%xmm10
  .byte  69,15,89,208                        // mulps         %xmm8,%xmm10
  .byte  68,15,88,209                        // addps         %xmm1,%xmm10
  .byte  68,15,92,200                        // subps         %xmm0,%xmm9
  .byte  69,15,89,200                        // mulps         %xmm8,%xmm9
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  68,15,88,200                        // addps         %xmm0,%xmm9
  .byte  68,15,92,235                        // subps         %xmm3,%xmm13
  .byte  15,40,68,36,144                     // movaps        -0x70(%rsp),%xmm0
  .byte  68,15,89,232                        // mulps         %xmm0,%xmm13
  .byte  68,15,88,235                        // addps         %xmm3,%xmm13
  .byte  68,15,92,213                        // subps         %xmm5,%xmm10
  .byte  68,15,89,208                        // mulps         %xmm0,%xmm10
  .byte  68,15,88,213                        // addps         %xmm5,%xmm10
  .byte  68,15,92,207                        // subps         %xmm7,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  68,15,88,207                        // addps         %xmm7,%xmm9
  .byte  102,15,111,68,36,128                // movdqa        -0x80(%rsp),%xmm0
  .byte  102,15,254,68,36,176                // paddd         -0x50(%rsp),%xmm0
  .byte  102,15,127,68,36,128                // movdqa        %xmm0,-0x80(%rsp)
  .byte  102,15,111,12,36                    // movdqa        (%rsp),%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,111,225                      // movdqa        %xmm1,%xmm4
  .byte  102,68,15,111,116,36,160            // movdqa        -0x60(%rsp),%xmm14
  .byte  102,65,15,254,198                   // paddd         %xmm14,%xmm0
  .byte  102,15,112,200,245                  // pshufd        $0xf5,%xmm0,%xmm1
  .byte  102,68,15,111,5,194,238,0,0         // movdqa        0xeec2(%rip),%xmm8        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,65,15,244,192                   // pmuludq       %xmm8,%xmm0
  .byte  102,65,15,244,200                   // pmuludq       %xmm8,%xmm1
  .byte  102,65,15,111,240                   // movdqa        %xmm8,%xmm6
  .byte  102,15,112,201,232                  // pshufd        $0xe8,%xmm1,%xmm1
  .byte  102,15,112,208,232                  // pshufd        $0xe8,%xmm0,%xmm2
  .byte  102,15,98,209                       // punpckldq     %xmm1,%xmm2
  .byte  102,65,15,126,192                   // movd          %xmm0,%r8d
  .byte  102,15,112,194,229                  // pshufd        $0xe5,%xmm2,%xmm0
  .byte  102,65,15,126,193                   // movd          %xmm0,%r9d
  .byte  102,15,112,194,78                   // pshufd        $0x4e,%xmm2,%xmm0
  .byte  102,65,15,126,194                   // movd          %xmm0,%r10d
  .byte  102,15,112,194,231                  // pshufd        $0xe7,%xmm2,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,66,15,16,12,147                 // movss         (%rbx,%r10,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,66,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm3
  .byte  243,66,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm0
  .byte  15,20,195                           // unpcklps      %xmm3,%xmm0
  .byte  102,15,20,193                       // unpcklpd      %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,118,255                      // pcmpeqd       %xmm7,%xmm7
  .byte  102,15,250,207                      // psubd         %xmm7,%xmm1
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,73,15,126,216                   // movq          %xmm3,%r8
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,28,131                    // movss         (%rbx,%rax,4),%xmm3
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  15,20,203                           // unpcklps      %xmm3,%xmm1
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  102,15,20,205                       // unpcklpd      %xmm5,%xmm1
  .byte  102,68,15,111,5,208,231,0,0         // movdqa        0xe7d0(%rip),%xmm8        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,65,15,254,208                   // paddd         %xmm8,%xmm2
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,73,15,126,216                   // movq          %xmm3,%r8
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,28,131                    // movss         (%rbx,%rax,4),%xmm3
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  15,20,211                           // unpcklps      %xmm3,%xmm2
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  102,15,20,213                       // unpcklpd      %xmm5,%xmm2
  .byte  102,65,15,254,228                   // paddd         %xmm12,%xmm4
  .byte  102,15,112,220,245                  // pshufd        $0xf5,%xmm4,%xmm3
  .byte  102,15,244,230                      // pmuludq       %xmm6,%xmm4
  .byte  102,15,244,222                      // pmuludq       %xmm6,%xmm3
  .byte  102,15,112,235,232                  // pshufd        $0xe8,%xmm3,%xmm5
  .byte  102,15,112,220,232                  // pshufd        $0xe8,%xmm4,%xmm3
  .byte  102,15,98,221                       // punpckldq     %xmm5,%xmm3
  .byte  102,65,15,126,224                   // movd          %xmm4,%r8d
  .byte  102,15,112,235,229                  // pshufd        $0xe5,%xmm3,%xmm5
  .byte  102,65,15,126,233                   // movd          %xmm5,%r9d
  .byte  102,15,112,235,78                   // pshufd        $0x4e,%xmm3,%xmm5
  .byte  102,65,15,126,234                   // movd          %xmm5,%r10d
  .byte  102,15,112,235,231                  // pshufd        $0xe7,%xmm3,%xmm5
  .byte  102,15,126,232                      // movd          %xmm5,%eax
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  243,66,15,16,52,147                 // movss         (%rbx,%r10,4),%xmm6
  .byte  15,20,245                           // unpcklps      %xmm5,%xmm6
  .byte  243,66,15,16,44,139                 // movss         (%rbx,%r9,4),%xmm5
  .byte  243,70,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm12
  .byte  68,15,20,229                        // unpcklps      %xmm5,%xmm12
  .byte  102,68,15,20,230                    // unpcklpd      %xmm6,%xmm12
  .byte  102,15,111,235                      // movdqa        %xmm3,%xmm5
  .byte  102,15,250,239                      // psubd         %xmm7,%xmm5
  .byte  102,15,112,245,78                   // pshufd        $0x4e,%xmm5,%xmm6
  .byte  102,73,15,126,240                   // movq          %xmm6,%r8
  .byte  102,72,15,126,232                   // movq          %xmm5,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,44,131                    // movss         (%rbx,%rax,4),%xmm5
  .byte  243,66,15,16,60,139                 // movss         (%rbx,%r9,4),%xmm7
  .byte  15,20,253                           // unpcklps      %xmm5,%xmm7
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm5
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  15,20,245                           // unpcklps      %xmm5,%xmm6
  .byte  102,15,20,254                       // unpcklpd      %xmm6,%xmm7
  .byte  102,65,15,254,216                   // paddd         %xmm8,%xmm3
  .byte  102,15,112,235,78                   // pshufd        $0x4e,%xmm3,%xmm5
  .byte  102,73,15,126,232                   // movq          %xmm5,%r8
  .byte  102,72,15,126,216                   // movq          %xmm3,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,28,131                    // movss         (%rbx,%rax,4),%xmm3
  .byte  243,66,15,16,44,139                 // movss         (%rbx,%r9,4),%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,28,131                 // movss         (%rbx,%r8,4),%xmm3
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  102,15,20,238                       // unpcklpd      %xmm6,%xmm5
  .byte  68,15,92,224                        // subps         %xmm0,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  68,15,88,224                        // addps         %xmm0,%xmm12
  .byte  15,92,249                           // subps         %xmm1,%xmm7
  .byte  65,15,89,251                        // mulps         %xmm11,%xmm7
  .byte  15,88,249                           // addps         %xmm1,%xmm7
  .byte  15,92,234                           // subps         %xmm2,%xmm5
  .byte  65,15,89,235                        // mulps         %xmm11,%xmm5
  .byte  15,88,234                           // addps         %xmm2,%xmm5
  .byte  102,15,111,68,36,128                // movdqa        -0x80(%rsp),%xmm0
  .byte  102,15,254,68,36,16                 // paddd         0x10(%rsp),%xmm0
  .byte  102,65,15,111,214                   // movdqa        %xmm14,%xmm2
  .byte  102,15,254,208                      // paddd         %xmm0,%xmm2
  .byte  102,15,111,240                      // movdqa        %xmm0,%xmm6
  .byte  102,15,112,194,245                  // pshufd        $0xf5,%xmm2,%xmm0
  .byte  102,15,111,37,156,236,0,0           // movdqa        0xec9c(%rip),%xmm4        # 3b1c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1258>
  .byte  102,15,244,212                      // pmuludq       %xmm4,%xmm2
  .byte  102,15,244,196                      // pmuludq       %xmm4,%xmm0
  .byte  102,15,112,200,232                  // pshufd        $0xe8,%xmm0,%xmm1
  .byte  102,15,112,194,232                  // pshufd        $0xe8,%xmm2,%xmm0
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  102,65,15,126,208                   // movd          %xmm2,%r8d
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,65,15,126,201                   // movd          %xmm1,%r9d
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,65,15,126,202                   // movd          %xmm1,%r10d
  .byte  102,15,112,200,231                  // pshufd        $0xe7,%xmm0,%xmm1
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  243,66,15,16,20,147                 // movss         (%rbx,%r10,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  243,70,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm8
  .byte  68,15,20,193                        // unpcklps      %xmm1,%xmm8
  .byte  102,68,15,20,194                    // unpcklpd      %xmm2,%xmm8
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,250,13,69,236,0,0            // psubd         0xec45(%rip),%xmm1        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,73,15,126,208                   // movq          %xmm2,%r8
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  243,70,15,16,52,139                 // movss         (%rbx,%r9,4),%xmm14
  .byte  68,15,20,241                        // unpcklps      %xmm1,%xmm14
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  243,15,16,20,131                    // movss         (%rbx,%rax,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  102,68,15,20,242                    // unpcklpd      %xmm2,%xmm14
  .byte  102,15,254,5,174,229,0,0            // paddd         0xe5ae(%rip),%xmm0        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,73,15,126,200                   // movq          %xmm1,%r8
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,66,15,16,28,139                 // movss         (%rbx,%r9,4),%xmm3
  .byte  15,20,216                           // unpcklps      %xmm0,%xmm3
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm0
  .byte  243,15,16,12,131                    // movss         (%rbx,%rax,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  102,15,20,217                       // unpcklpd      %xmm1,%xmm3
  .byte  102,15,111,206                      // movdqa        %xmm6,%xmm1
  .byte  102,15,254,76,36,224                // paddd         -0x20(%rsp),%xmm1
  .byte  102,15,112,193,245                  // pshufd        $0xf5,%xmm1,%xmm0
  .byte  102,15,244,204                      // pmuludq       %xmm4,%xmm1
  .byte  102,15,244,196                      // pmuludq       %xmm4,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,112,209,232                  // pshufd        $0xe8,%xmm1,%xmm2
  .byte  102,15,98,208                       // punpckldq     %xmm0,%xmm2
  .byte  102,65,15,126,200                   // movd          %xmm1,%r8d
  .byte  102,15,112,194,229                  // pshufd        $0xe5,%xmm2,%xmm0
  .byte  102,65,15,126,193                   // movd          %xmm0,%r9d
  .byte  102,15,112,194,78                   // pshufd        $0x4e,%xmm2,%xmm0
  .byte  102,65,15,126,194                   // movd          %xmm0,%r10d
  .byte  102,15,112,194,231                  // pshufd        $0xe7,%xmm2,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  243,15,16,4,131                     // movss         (%rbx,%rax,4),%xmm0
  .byte  243,66,15,16,12,147                 // movss         (%rbx,%r10,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,66,15,16,52,139                 // movss         (%rbx,%r9,4),%xmm6
  .byte  243,66,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm0
  .byte  15,20,198                           // unpcklps      %xmm6,%xmm0
  .byte  102,15,20,193                       // unpcklpd      %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,250,13,77,235,0,0            // psubd         0xeb4d(%rip),%xmm1        # 3b1d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1268>
  .byte  102,15,112,241,78                   // pshufd        $0x4e,%xmm1,%xmm6
  .byte  102,73,15,126,240                   // movq          %xmm6,%r8
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  15,20,206                           // unpcklps      %xmm6,%xmm1
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,52,131                 // movss         (%rbx,%r8,4),%xmm6
  .byte  243,15,16,36,131                    // movss         (%rbx,%rax,4),%xmm4
  .byte  15,20,230                           // unpcklps      %xmm6,%xmm4
  .byte  102,15,20,204                       // unpcklpd      %xmm4,%xmm1
  .byte  102,15,254,21,184,228,0,0           // paddd         0xe4b8(%rip),%xmm2        # 3ab80 <_sk_srcover_bgra_8888_sse2_lowp+0xc18>
  .byte  102,15,112,226,78                   // pshufd        $0x4e,%xmm2,%xmm4
  .byte  102,73,15,126,224                   // movq          %xmm4,%r8
  .byte  102,72,15,126,208                   // movq          %xmm2,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  243,15,16,36,131                    // movss         (%rbx,%rax,4),%xmm4
  .byte  243,66,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm2
  .byte  15,20,212                           // unpcklps      %xmm4,%xmm2
  .byte  68,137,192                          // mov           %r8d,%eax
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  243,66,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm4
  .byte  243,15,16,52,131                    // movss         (%rbx,%rax,4),%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  102,15,20,214                       // unpcklpd      %xmm6,%xmm2
  .byte  65,15,92,192                        // subps         %xmm8,%xmm0
  .byte  65,15,89,195                        // mulps         %xmm11,%xmm0
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  65,15,92,206                        // subps         %xmm14,%xmm1
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  65,15,88,206                        // addps         %xmm14,%xmm1
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  65,15,89,211                        // mulps         %xmm11,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  65,15,92,196                        // subps         %xmm12,%xmm0
  .byte  15,40,92,36,144                     // movaps        -0x70(%rsp),%xmm3
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  65,15,88,196                        // addps         %xmm12,%xmm0
  .byte  15,92,207                           // subps         %xmm7,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  15,92,213                           // subps         %xmm5,%xmm2
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  65,15,92,197                        // subps         %xmm13,%xmm0
  .byte  15,40,92,36,240                     // movaps        -0x10(%rsp),%xmm3
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  65,15,88,197                        // addps         %xmm13,%xmm0
  .byte  65,15,92,202                        // subps         %xmm10,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  65,15,92,209                        // subps         %xmm9,%xmm2
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  65,15,88,209                        // addps         %xmm9,%xmm2
  .byte  15,91,92,36,48                      // cvtdq2ps      0x30(%rsp),%xmm3
  .byte  15,40,100,36,80                     // movaps        0x50(%rsp),%xmm4
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  15,40,92,36,208                     // movaps        -0x30(%rsp),%xmm3
  .byte  15,92,195                           // subps         %xmm3,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,195                           // addps         %xmm3,%xmm0
  .byte  15,40,92,36,192                     // movaps        -0x40(%rsp),%xmm3
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  65,15,92,215                        // subps         %xmm15,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  65,15,88,215                        // addps         %xmm15,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,164,227,0,0                // movaps        0xe3a4(%rip),%xmm3        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,40,100,36,96                     // movaps        0x60(%rsp),%xmm4
  .byte  15,40,108,36,112                    // movaps        0x70(%rsp),%xmm5
  .byte  15,40,180,36,128,0,0,0              // movaps        0x80(%rsp),%xmm6
  .byte  15,40,188,36,144,0,0,0              // movaps        0x90(%rsp),%xmm7
  .byte  72,129,196,160,0,0,0                // add           $0xa0,%rsp
  .byte  91                                  // pop           %rbx
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gauss_a_to_rgba_sse2
.globl _sk_gauss_a_to_rgba_sse2
FUNCTION(_sk_gauss_a_to_rgba_sse2)
_sk_gauss_a_to_rgba_sse2:
  .byte  15,40,5,9,234,0,0                   // movaps        0xea09(%rip),%xmm0        # 3b1e0 <_sk_srcover_bgra_8888_sse2_lowp+0x1278>
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,5,15,234,0,0                  // addps         0xea0f(%rip),%xmm0        # 3b1f0 <_sk_srcover_bgra_8888_sse2_lowp+0x1288>
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,5,21,234,0,0                  // addps         0xea15(%rip),%xmm0        # 3b200 <_sk_srcover_bgra_8888_sse2_lowp+0x1298>
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,5,27,234,0,0                  // addps         0xea1b(%rip),%xmm0        # 3b210 <_sk_srcover_bgra_8888_sse2_lowp+0x12a8>
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,5,33,234,0,0                  // addps         0xea21(%rip),%xmm0        # 3b220 <_sk_srcover_bgra_8888_sse2_lowp+0x12b8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_start_pipeline_hsw_lowp
.globl _sk_start_pipeline_hsw_lowp
FUNCTION(_sk_start_pipeline_hsw_lowp)
_sk_start_pipeline_hsw_lowp:
  .byte  85                                  // push          %rbp
  .byte  72,137,229                          // mov           %rsp,%rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  73,137,215                          // mov           %rdx,%r15
  .byte  72,137,243                          // mov           %rsi,%rbx
  .byte  72,137,125,208                      // mov           %rdi,-0x30(%rbp)
  .byte  76,137,198                          // mov           %r8,%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  73,137,197                          // mov           %rax,%r13
  .byte  73,137,246                          // mov           %rsi,%r14
  .byte  72,137,77,192                       // mov           %rcx,-0x40(%rbp)
  .byte  72,57,203                           // cmp           %rcx,%rbx
  .byte  15,131,151,0,0,0                    // jae           2c8d6 <_sk_start_pipeline_hsw_lowp+0xca>
  .byte  72,139,69,208                       // mov           -0x30(%rbp),%rax
  .byte  72,141,64,16                        // lea           0x10(%rax),%rax
  .byte  72,137,69,200                       // mov           %rax,-0x38(%rbp)
  .byte  72,139,85,208                       // mov           -0x30(%rbp),%rdx
  .byte  76,57,125,200                       // cmp           %r15,-0x38(%rbp)
  .byte  119,67                              // ja            2c898 <_sk_start_pipeline_hsw_lowp+0x8c>
  .byte  76,139,101,208                      // mov           -0x30(%rbp),%r12
  .byte  49,255                              // xor           %edi,%edi
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  76,137,226                          // mov           %r12,%rdx
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  73,141,84,36,16                     // lea           0x10(%r12),%rdx
  .byte  73,131,196,32                       // add           $0x20,%r12
  .byte  77,57,252                           // cmp           %r15,%r12
  .byte  73,137,212                          // mov           %rdx,%r12
  .byte  118,193                             // jbe           2c859 <_sk_start_pipeline_hsw_lowp+0x4d>
  .byte  76,137,255                          // mov           %r15,%rdi
  .byte  72,41,215                           // sub           %rdx,%rdi
  .byte  116,41                              // je            2c8c9 <_sk_start_pipeline_hsw_lowp+0xbd>
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  72,255,195                          // inc           %rbx
  .byte  72,59,93,192                        // cmp           -0x40(%rbp),%rbx
  .byte  15,133,117,255,255,255              // jne           2c84b <_sk_start_pipeline_hsw_lowp+0x3f>
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  197,248,119                         // vzeroupper
  .byte  195                                 // retq

HIDDEN _sk_just_return_hsw_lowp
.globl _sk_just_return_hsw_lowp
FUNCTION(_sk_just_return_hsw_lowp)
_sk_just_return_hsw_lowp:
  .byte  195                                 // retq

HIDDEN _sk_seed_shader_hsw_lowp
.globl _sk_seed_shader_hsw_lowp
FUNCTION(_sk_seed_shader_hsw_lowp)
_sk_seed_shader_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,249,110,194                     // vmovd         %edx,%xmm0
  .byte  196,226,125,88,192                  // vpbroadcastd  %xmm0,%ymm0
  .byte  197,252,91,192                      // vcvtdq2ps     %ymm0,%ymm0
  .byte  197,252,88,72,32                    // vaddps        0x20(%rax),%ymm0,%ymm1
  .byte  197,252,88,0                        // vaddps        (%rax),%ymm0,%ymm0
  .byte  197,249,110,209                     // vmovd         %ecx,%xmm2
  .byte  196,226,125,88,210                  // vpbroadcastd  %xmm2,%ymm2
  .byte  197,252,91,210                      // vcvtdq2ps     %ymm2,%ymm2
  .byte  196,226,125,24,29,253,216,0,0       // vbroadcastss  0xd8fd(%rip),%ymm3        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,236,88,211                      // vaddps        %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,218                      // vmovaps       %ymm2,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_translate_hsw_lowp
.globl _sk_matrix_translate_hsw_lowp
FUNCTION(_sk_matrix_translate_hsw_lowp)
_sk_matrix_translate_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  196,193,116,88,200                  // vaddps        %ymm8,%ymm1,%ymm1
  .byte  196,98,125,24,64,4                  // vbroadcastss  0x4(%rax),%ymm8
  .byte  196,193,108,88,208                  // vaddps        %ymm8,%ymm2,%ymm2
  .byte  196,193,100,88,216                  // vaddps        %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_scale_translate_hsw_lowp
.globl _sk_matrix_scale_translate_hsw_lowp
FUNCTION(_sk_matrix_scale_translate_hsw_lowp)
_sk_matrix_scale_translate_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,0                     // vbroadcastss  (%rax),%ymm8
  .byte  196,98,125,24,72,8                  // vbroadcastss  0x8(%rax),%ymm9
  .byte  196,194,61,168,193                  // vfmadd213ps   %ymm9,%ymm8,%ymm0
  .byte  196,194,61,168,201                  // vfmadd213ps   %ymm9,%ymm8,%ymm1
  .byte  196,98,125,24,64,4                  // vbroadcastss  0x4(%rax),%ymm8
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,194,61,168,209                  // vfmadd213ps   %ymm9,%ymm8,%ymm2
  .byte  196,194,61,168,217                  // vfmadd213ps   %ymm9,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_2x3_hsw_lowp
.globl _sk_matrix_2x3_hsw_lowp
FUNCTION(_sk_matrix_2x3_hsw_lowp)
_sk_matrix_2x3_hsw_lowp:
  .byte  197,124,40,192                      // vmovaps       %ymm0,%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,16                    // vbroadcastss  (%rax),%ymm10
  .byte  196,226,125,24,64,8                 // vbroadcastss  0x8(%rax),%ymm0
  .byte  196,98,125,24,88,16                 // vbroadcastss  0x10(%rax),%ymm11
  .byte  197,124,40,200                      // vmovaps       %ymm0,%ymm9
  .byte  196,66,101,168,203                  // vfmadd213ps   %ymm11,%ymm3,%ymm9
  .byte  196,194,109,168,195                 // vfmadd213ps   %ymm11,%ymm2,%ymm0
  .byte  196,194,61,184,194                  // vfmadd231ps   %ymm10,%ymm8,%ymm0
  .byte  196,66,117,184,202                  // vfmadd231ps   %ymm10,%ymm1,%ymm9
  .byte  196,98,125,24,80,4                  // vbroadcastss  0x4(%rax),%ymm10
  .byte  196,98,125,24,88,12                 // vbroadcastss  0xc(%rax),%ymm11
  .byte  196,98,125,24,96,20                 // vbroadcastss  0x14(%rax),%ymm12
  .byte  196,194,37,168,220                  // vfmadd213ps   %ymm12,%ymm11,%ymm3
  .byte  196,66,109,168,220                  // vfmadd213ps   %ymm12,%ymm2,%ymm11
  .byte  196,66,45,168,195                   // vfmadd213ps   %ymm11,%ymm10,%ymm8
  .byte  196,194,117,184,218                 // vfmadd231ps   %ymm10,%ymm1,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,124,41,201                      // vmovaps       %ymm9,%ymm1
  .byte  197,124,41,194                      // vmovaps       %ymm8,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_perspective_hsw_lowp
.globl _sk_matrix_perspective_hsw_lowp
FUNCTION(_sk_matrix_perspective_hsw_lowp)
_sk_matrix_perspective_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,24,8                     // vbroadcastss  (%rax),%ymm9
  .byte  196,98,125,24,64,4                  // vbroadcastss  0x4(%rax),%ymm8
  .byte  196,98,125,24,80,8                  // vbroadcastss  0x8(%rax),%ymm10
  .byte  196,65,124,40,216                   // vmovaps       %ymm8,%ymm11
  .byte  196,66,109,168,218                  // vfmadd213ps   %ymm10,%ymm2,%ymm11
  .byte  196,66,101,168,194                  // vfmadd213ps   %ymm10,%ymm3,%ymm8
  .byte  196,66,117,184,193                  // vfmadd231ps   %ymm9,%ymm1,%ymm8
  .byte  196,66,125,184,217                  // vfmadd231ps   %ymm9,%ymm0,%ymm11
  .byte  196,98,125,24,72,12                 // vbroadcastss  0xc(%rax),%ymm9
  .byte  196,98,125,24,80,16                 // vbroadcastss  0x10(%rax),%ymm10
  .byte  196,98,125,24,96,20                 // vbroadcastss  0x14(%rax),%ymm12
  .byte  196,65,124,40,234                   // vmovaps       %ymm10,%ymm13
  .byte  196,66,109,168,236                  // vfmadd213ps   %ymm12,%ymm2,%ymm13
  .byte  196,66,101,168,212                  // vfmadd213ps   %ymm12,%ymm3,%ymm10
  .byte  196,66,117,184,209                  // vfmadd231ps   %ymm9,%ymm1,%ymm10
  .byte  196,66,125,184,233                  // vfmadd231ps   %ymm9,%ymm0,%ymm13
  .byte  196,98,125,24,72,24                 // vbroadcastss  0x18(%rax),%ymm9
  .byte  196,98,125,24,96,28                 // vbroadcastss  0x1c(%rax),%ymm12
  .byte  196,98,125,24,112,32                // vbroadcastss  0x20(%rax),%ymm14
  .byte  196,194,29,168,214                  // vfmadd213ps   %ymm14,%ymm12,%ymm2
  .byte  196,66,101,168,230                  // vfmadd213ps   %ymm14,%ymm3,%ymm12
  .byte  196,194,53,168,204                  // vfmadd213ps   %ymm12,%ymm9,%ymm1
  .byte  196,194,125,184,209                 // vfmadd231ps   %ymm9,%ymm0,%ymm2
  .byte  197,252,83,210                      // vrcpps        %ymm2,%ymm2
  .byte  197,252,83,217                      // vrcpps        %ymm1,%ymm3
  .byte  197,164,89,194                      // vmulps        %ymm2,%ymm11,%ymm0
  .byte  197,188,89,203                      // vmulps        %ymm3,%ymm8,%ymm1
  .byte  197,148,89,210                      // vmulps        %ymm2,%ymm13,%ymm2
  .byte  197,172,89,219                      // vmulps        %ymm3,%ymm10,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_uniform_color_hsw_lowp
.globl _sk_uniform_color_hsw_lowp
FUNCTION(_sk_uniform_color_hsw_lowp)
_sk_uniform_color_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,121,64,16               // vpbroadcastw  0x10(%rax),%ymm0
  .byte  196,226,125,121,72,18               // vpbroadcastw  0x12(%rax),%ymm1
  .byte  196,226,125,121,80,20               // vpbroadcastw  0x14(%rax),%ymm2
  .byte  196,226,125,121,88,22               // vpbroadcastw  0x16(%rax),%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_black_color_hsw_lowp
.globl _sk_black_color_hsw_lowp
FUNCTION(_sk_black_color_hsw_lowp)
_sk_black_color_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,121,29,228,221,0,0      // vpbroadcastw  0xdde4(%rip),%ymm3        # 3a880 <_sk_srcover_bgra_8888_sse2_lowp+0x918>
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_white_color_hsw_lowp
.globl _sk_white_color_hsw_lowp
FUNCTION(_sk_white_color_hsw_lowp)
_sk_white_color_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,121,5,205,221,0,0       // vpbroadcastw  0xddcd(%rip),%ymm0        # 3a882 <_sk_srcover_bgra_8888_sse2_lowp+0x91a>
  .byte  197,253,111,200                     // vmovdqa       %ymm0,%ymm1
  .byte  197,253,111,208                     // vmovdqa       %ymm0,%ymm2
  .byte  197,253,111,216                     // vmovdqa       %ymm0,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_set_rgb_hsw_lowp
.globl _sk_set_rgb_hsw_lowp
FUNCTION(_sk_set_rgb_hsw_lowp)
_sk_set_rgb_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,122,16,5,71,215,0,0             // vmovss        0xd747(%rip),%xmm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,250,16,21,111,215,0,0           // vmovss        0xd76f(%rip),%xmm2        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  197,250,16,0                        // vmovss        (%rax),%xmm0
  .byte  196,226,57,153,194                  // vfmadd132ss   %xmm2,%xmm8,%xmm0
  .byte  197,122,44,192                      // vcvttss2si    %xmm0,%r8d
  .byte  196,193,121,110,192                 // vmovd         %r8d,%xmm0
  .byte  196,226,125,121,192                 // vpbroadcastw  %xmm0,%ymm0
  .byte  197,250,16,72,4                     // vmovss        0x4(%rax),%xmm1
  .byte  196,226,57,153,202                  // vfmadd132ss   %xmm2,%xmm8,%xmm1
  .byte  197,122,44,193                      // vcvttss2si    %xmm1,%r8d
  .byte  196,193,121,110,200                 // vmovd         %r8d,%xmm1
  .byte  196,226,125,121,201                 // vpbroadcastw  %xmm1,%ymm1
  .byte  196,226,57,153,80,8                 // vfmadd132ss   0x8(%rax),%xmm8,%xmm2
  .byte  197,250,44,194                      // vcvttss2si    %xmm2,%eax
  .byte  197,249,110,208                     // vmovd         %eax,%xmm2
  .byte  196,226,125,121,210                 // vpbroadcastw  %xmm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_hsw_lowp
.globl _sk_clamp_a_hsw_lowp
FUNCTION(_sk_clamp_a_hsw_lowp)
_sk_clamp_a_hsw_lowp:
  .byte  196,226,125,58,195                  // vpminuw       %ymm3,%ymm0,%ymm0
  .byte  196,226,117,58,203                  // vpminuw       %ymm3,%ymm1,%ymm1
  .byte  196,226,109,58,211                  // vpminuw       %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_dst_hsw_lowp
.globl _sk_clamp_a_dst_hsw_lowp
FUNCTION(_sk_clamp_a_dst_hsw_lowp)
_sk_clamp_a_dst_hsw_lowp:
  .byte  196,226,93,58,231                   // vpminuw       %ymm7,%ymm4,%ymm4
  .byte  196,226,85,58,239                   // vpminuw       %ymm7,%ymm5,%ymm5
  .byte  196,226,77,58,247                   // vpminuw       %ymm7,%ymm6,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_hsw_lowp
.globl _sk_premul_hsw_lowp
FUNCTION(_sk_premul_hsw_lowp)
_sk_premul_hsw_lowp:
  .byte  197,229,213,192                     // vpmullw       %ymm0,%ymm3,%ymm0
  .byte  196,98,125,121,5,54,221,0,0         // vpbroadcastw  0xdd36(%rip),%ymm8        # 3a884 <_sk_srcover_bgra_8888_sse2_lowp+0x91c>
  .byte  196,193,125,253,192                 // vpaddw        %ymm8,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,229,213,201                     // vpmullw       %ymm1,%ymm3,%ymm1
  .byte  196,193,117,253,200                 // vpaddw        %ymm8,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,229,213,210                     // vpmullw       %ymm2,%ymm3,%ymm2
  .byte  196,193,109,253,208                 // vpaddw        %ymm8,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_dst_hsw_lowp
.globl _sk_premul_dst_hsw_lowp
FUNCTION(_sk_premul_dst_hsw_lowp)
_sk_premul_dst_hsw_lowp:
  .byte  197,197,213,228                     // vpmullw       %ymm4,%ymm7,%ymm4
  .byte  196,98,125,121,5,1,221,0,0          // vpbroadcastw  0xdd01(%rip),%ymm8        # 3a886 <_sk_srcover_bgra_8888_sse2_lowp+0x91e>
  .byte  196,193,93,253,224                  // vpaddw        %ymm8,%ymm4,%ymm4
  .byte  197,221,113,212,8                   // vpsrlw        $0x8,%ymm4,%ymm4
  .byte  197,197,213,237                     // vpmullw       %ymm5,%ymm7,%ymm5
  .byte  196,193,85,253,232                  // vpaddw        %ymm8,%ymm5,%ymm5
  .byte  197,213,113,213,8                   // vpsrlw        $0x8,%ymm5,%ymm5
  .byte  197,197,213,246                     // vpmullw       %ymm6,%ymm7,%ymm6
  .byte  196,193,77,253,240                  // vpaddw        %ymm8,%ymm6,%ymm6
  .byte  197,205,113,214,8                   // vpsrlw        $0x8,%ymm6,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_swap_rb_hsw_lowp
.globl _sk_swap_rb_hsw_lowp
FUNCTION(_sk_swap_rb_hsw_lowp)
_sk_swap_rb_hsw_lowp:
  .byte  197,124,40,192                      // vmovaps       %ymm0,%ymm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,194                      // vmovaps       %ymm2,%ymm0
  .byte  197,124,41,194                      // vmovaps       %ymm8,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_src_dst_hsw_lowp
.globl _sk_move_src_dst_hsw_lowp
FUNCTION(_sk_move_src_dst_hsw_lowp)
_sk_move_src_dst_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,224                      // vmovaps       %ymm0,%ymm4
  .byte  197,252,40,233                      // vmovaps       %ymm1,%ymm5
  .byte  197,252,40,242                      // vmovaps       %ymm2,%ymm6
  .byte  197,252,40,251                      // vmovaps       %ymm3,%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_dst_src_hsw_lowp
.globl _sk_move_dst_src_hsw_lowp
FUNCTION(_sk_move_dst_src_hsw_lowp)
_sk_move_dst_src_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,196                      // vmovaps       %ymm4,%ymm0
  .byte  197,252,40,205                      // vmovaps       %ymm5,%ymm1
  .byte  197,252,40,214                      // vmovaps       %ymm6,%ymm2
  .byte  197,252,40,223                      // vmovaps       %ymm7,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_invert_hsw_lowp
.globl _sk_invert_hsw_lowp
FUNCTION(_sk_invert_hsw_lowp)
_sk_invert_hsw_lowp:
  .byte  196,98,125,121,5,152,220,0,0        // vpbroadcastw  0xdc98(%rip),%ymm8        # 3a888 <_sk_srcover_bgra_8888_sse2_lowp+0x920>
  .byte  197,189,249,192                     // vpsubw        %ymm0,%ymm8,%ymm0
  .byte  197,189,249,201                     // vpsubw        %ymm1,%ymm8,%ymm1
  .byte  197,189,249,210                     // vpsubw        %ymm2,%ymm8,%ymm2
  .byte  197,189,249,219                     // vpsubw        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clear_hsw_lowp
.globl _sk_clear_hsw_lowp
FUNCTION(_sk_clear_hsw_lowp)
_sk_clear_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,87,192                      // vxorps        %ymm0,%ymm0,%ymm0
  .byte  197,244,87,201                      // vxorps        %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcatop_hsw_lowp
.globl _sk_srcatop_hsw_lowp
FUNCTION(_sk_srcatop_hsw_lowp)
_sk_srcatop_hsw_lowp:
  .byte  197,197,213,192                     // vpmullw       %ymm0,%ymm7,%ymm0
  .byte  196,98,125,121,5,101,220,0,0        // vpbroadcastw  0xdc65(%rip),%ymm8        # 3a88a <_sk_srcover_bgra_8888_sse2_lowp+0x922>
  .byte  197,189,249,219                     // vpsubw        %ymm3,%ymm8,%ymm3
  .byte  197,101,213,204                     // vpmullw       %ymm4,%ymm3,%ymm9
  .byte  196,193,125,253,192                 // vpaddw        %ymm8,%ymm0,%ymm0
  .byte  197,181,253,192                     // vpaddw        %ymm0,%ymm9,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,197,213,201                     // vpmullw       %ymm1,%ymm7,%ymm1
  .byte  197,101,213,205                     // vpmullw       %ymm5,%ymm3,%ymm9
  .byte  196,193,117,253,200                 // vpaddw        %ymm8,%ymm1,%ymm1
  .byte  197,181,253,201                     // vpaddw        %ymm1,%ymm9,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,197,213,210                     // vpmullw       %ymm2,%ymm7,%ymm2
  .byte  197,229,213,222                     // vpmullw       %ymm6,%ymm3,%ymm3
  .byte  196,193,109,253,208                 // vpaddw        %ymm8,%ymm2,%ymm2
  .byte  197,229,253,210                     // vpaddw        %ymm2,%ymm3,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  196,193,69,213,216                  // vpmullw       %ymm8,%ymm7,%ymm3
  .byte  196,193,101,253,216                 // vpaddw        %ymm8,%ymm3,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstatop_hsw_lowp
.globl _sk_dstatop_hsw_lowp
FUNCTION(_sk_dstatop_hsw_lowp)
_sk_dstatop_hsw_lowp:
  .byte  197,93,213,195                      // vpmullw       %ymm3,%ymm4,%ymm8
  .byte  196,98,125,121,13,5,220,0,0         // vpbroadcastw  0xdc05(%rip),%ymm9        # 3a88c <_sk_srcover_bgra_8888_sse2_lowp+0x924>
  .byte  197,53,249,215                      // vpsubw        %ymm7,%ymm9,%ymm10
  .byte  197,173,213,192                     // vpmullw       %ymm0,%ymm10,%ymm0
  .byte  196,65,61,253,193                   // vpaddw        %ymm9,%ymm8,%ymm8
  .byte  196,193,125,253,192                 // vpaddw        %ymm8,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,85,213,195                      // vpmullw       %ymm3,%ymm5,%ymm8
  .byte  197,173,213,201                     // vpmullw       %ymm1,%ymm10,%ymm1
  .byte  196,65,61,253,193                   // vpaddw        %ymm9,%ymm8,%ymm8
  .byte  196,193,117,253,200                 // vpaddw        %ymm8,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,77,213,195                      // vpmullw       %ymm3,%ymm6,%ymm8
  .byte  197,173,213,210                     // vpmullw       %ymm2,%ymm10,%ymm2
  .byte  196,65,61,253,193                   // vpaddw        %ymm9,%ymm8,%ymm8
  .byte  196,193,109,253,208                 // vpaddw        %ymm8,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  196,193,101,213,217                 // vpmullw       %ymm9,%ymm3,%ymm3
  .byte  196,193,101,253,217                 // vpaddw        %ymm9,%ymm3,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcin_hsw_lowp
.globl _sk_srcin_hsw_lowp
FUNCTION(_sk_srcin_hsw_lowp)
_sk_srcin_hsw_lowp:
  .byte  197,197,213,192                     // vpmullw       %ymm0,%ymm7,%ymm0
  .byte  196,98,125,121,5,162,219,0,0        // vpbroadcastw  0xdba2(%rip),%ymm8        # 3a88e <_sk_srcover_bgra_8888_sse2_lowp+0x926>
  .byte  196,193,125,253,192                 // vpaddw        %ymm8,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,197,213,201                     // vpmullw       %ymm1,%ymm7,%ymm1
  .byte  196,193,117,253,200                 // vpaddw        %ymm8,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,197,213,210                     // vpmullw       %ymm2,%ymm7,%ymm2
  .byte  196,193,109,253,208                 // vpaddw        %ymm8,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,197,213,219                     // vpmullw       %ymm3,%ymm7,%ymm3
  .byte  196,193,101,253,216                 // vpaddw        %ymm8,%ymm3,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstin_hsw_lowp
.globl _sk_dstin_hsw_lowp
FUNCTION(_sk_dstin_hsw_lowp)
_sk_dstin_hsw_lowp:
  .byte  197,221,213,195                     // vpmullw       %ymm3,%ymm4,%ymm0
  .byte  196,98,125,121,5,95,219,0,0         // vpbroadcastw  0xdb5f(%rip),%ymm8        # 3a890 <_sk_srcover_bgra_8888_sse2_lowp+0x928>
  .byte  196,193,125,253,192                 // vpaddw        %ymm8,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,213,213,203                     // vpmullw       %ymm3,%ymm5,%ymm1
  .byte  196,193,117,253,200                 // vpaddw        %ymm8,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,205,213,211                     // vpmullw       %ymm3,%ymm6,%ymm2
  .byte  196,193,109,253,208                 // vpaddw        %ymm8,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,197,213,219                     // vpmullw       %ymm3,%ymm7,%ymm3
  .byte  196,193,101,253,216                 // vpaddw        %ymm8,%ymm3,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcout_hsw_lowp
.globl _sk_srcout_hsw_lowp
FUNCTION(_sk_srcout_hsw_lowp)
_sk_srcout_hsw_lowp:
  .byte  196,98,125,121,5,32,219,0,0         // vpbroadcastw  0xdb20(%rip),%ymm8        # 3a892 <_sk_srcover_bgra_8888_sse2_lowp+0x92a>
  .byte  197,61,249,207                      // vpsubw        %ymm7,%ymm8,%ymm9
  .byte  197,181,213,192                     // vpmullw       %ymm0,%ymm9,%ymm0
  .byte  196,193,125,253,192                 // vpaddw        %ymm8,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,181,213,201                     // vpmullw       %ymm1,%ymm9,%ymm1
  .byte  196,193,117,253,200                 // vpaddw        %ymm8,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,181,213,210                     // vpmullw       %ymm2,%ymm9,%ymm2
  .byte  196,193,109,253,208                 // vpaddw        %ymm8,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,181,213,219                     // vpmullw       %ymm3,%ymm9,%ymm3
  .byte  196,193,101,253,216                 // vpaddw        %ymm8,%ymm3,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstout_hsw_lowp
.globl _sk_dstout_hsw_lowp
FUNCTION(_sk_dstout_hsw_lowp)
_sk_dstout_hsw_lowp:
  .byte  196,98,125,121,5,217,218,0,0        // vpbroadcastw  0xdad9(%rip),%ymm8        # 3a894 <_sk_srcover_bgra_8888_sse2_lowp+0x92c>
  .byte  197,189,249,219                     // vpsubw        %ymm3,%ymm8,%ymm3
  .byte  197,229,213,196                     // vpmullw       %ymm4,%ymm3,%ymm0
  .byte  196,193,125,253,192                 // vpaddw        %ymm8,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,229,213,205                     // vpmullw       %ymm5,%ymm3,%ymm1
  .byte  196,193,117,253,200                 // vpaddw        %ymm8,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,229,213,214                     // vpmullw       %ymm6,%ymm3,%ymm2
  .byte  196,193,109,253,208                 // vpaddw        %ymm8,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,229,213,223                     // vpmullw       %ymm7,%ymm3,%ymm3
  .byte  196,193,101,253,216                 // vpaddw        %ymm8,%ymm3,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_hsw_lowp
.globl _sk_srcover_hsw_lowp
FUNCTION(_sk_srcover_hsw_lowp)
_sk_srcover_hsw_lowp:
  .byte  196,98,125,121,5,146,218,0,0        // vpbroadcastw  0xda92(%rip),%ymm8        # 3a896 <_sk_srcover_bgra_8888_sse2_lowp+0x92e>
  .byte  197,61,249,203                      // vpsubw        %ymm3,%ymm8,%ymm9
  .byte  197,53,213,212                      // vpmullw       %ymm4,%ymm9,%ymm10
  .byte  196,65,45,253,208                   // vpaddw        %ymm8,%ymm10,%ymm10
  .byte  196,193,45,113,210,8                // vpsrlw        $0x8,%ymm10,%ymm10
  .byte  197,173,253,192                     // vpaddw        %ymm0,%ymm10,%ymm0
  .byte  197,53,213,213                      // vpmullw       %ymm5,%ymm9,%ymm10
  .byte  196,65,45,253,208                   // vpaddw        %ymm8,%ymm10,%ymm10
  .byte  196,193,45,113,210,8                // vpsrlw        $0x8,%ymm10,%ymm10
  .byte  197,173,253,201                     // vpaddw        %ymm1,%ymm10,%ymm1
  .byte  197,53,213,214                      // vpmullw       %ymm6,%ymm9,%ymm10
  .byte  196,65,45,253,208                   // vpaddw        %ymm8,%ymm10,%ymm10
  .byte  196,193,45,113,210,8                // vpsrlw        $0x8,%ymm10,%ymm10
  .byte  197,173,253,210                     // vpaddw        %ymm2,%ymm10,%ymm2
  .byte  197,53,213,207                      // vpmullw       %ymm7,%ymm9,%ymm9
  .byte  196,65,53,253,192                   // vpaddw        %ymm8,%ymm9,%ymm8
  .byte  196,193,61,113,208,8                // vpsrlw        $0x8,%ymm8,%ymm8
  .byte  197,189,253,219                     // vpaddw        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstover_hsw_lowp
.globl _sk_dstover_hsw_lowp
FUNCTION(_sk_dstover_hsw_lowp)
_sk_dstover_hsw_lowp:
  .byte  196,98,125,121,5,55,218,0,0         // vpbroadcastw  0xda37(%rip),%ymm8        # 3a898 <_sk_srcover_bgra_8888_sse2_lowp+0x930>
  .byte  197,61,249,207                      // vpsubw        %ymm7,%ymm8,%ymm9
  .byte  197,181,213,192                     // vpmullw       %ymm0,%ymm9,%ymm0
  .byte  196,193,125,253,192                 // vpaddw        %ymm8,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,253,253,196                     // vpaddw        %ymm4,%ymm0,%ymm0
  .byte  197,181,213,201                     // vpmullw       %ymm1,%ymm9,%ymm1
  .byte  196,193,117,253,200                 // vpaddw        %ymm8,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,245,253,205                     // vpaddw        %ymm5,%ymm1,%ymm1
  .byte  197,181,213,210                     // vpmullw       %ymm2,%ymm9,%ymm2
  .byte  196,193,109,253,208                 // vpaddw        %ymm8,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,237,253,214                     // vpaddw        %ymm6,%ymm2,%ymm2
  .byte  197,181,213,219                     // vpmullw       %ymm3,%ymm9,%ymm3
  .byte  196,193,101,253,216                 // vpaddw        %ymm8,%ymm3,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  197,229,253,223                     // vpaddw        %ymm7,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_modulate_hsw_lowp
.globl _sk_modulate_hsw_lowp
FUNCTION(_sk_modulate_hsw_lowp)
_sk_modulate_hsw_lowp:
  .byte  197,221,213,192                     // vpmullw       %ymm0,%ymm4,%ymm0
  .byte  196,98,125,121,5,220,217,0,0        // vpbroadcastw  0xd9dc(%rip),%ymm8        # 3a89a <_sk_srcover_bgra_8888_sse2_lowp+0x932>
  .byte  196,193,125,253,192                 // vpaddw        %ymm8,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,213,213,201                     // vpmullw       %ymm1,%ymm5,%ymm1
  .byte  196,193,117,253,200                 // vpaddw        %ymm8,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,205,213,210                     // vpmullw       %ymm2,%ymm6,%ymm2
  .byte  196,193,109,253,208                 // vpaddw        %ymm8,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,197,213,219                     // vpmullw       %ymm3,%ymm7,%ymm3
  .byte  196,193,101,253,216                 // vpaddw        %ymm8,%ymm3,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_multiply_hsw_lowp
.globl _sk_multiply_hsw_lowp
FUNCTION(_sk_multiply_hsw_lowp)
_sk_multiply_hsw_lowp:
  .byte  196,98,125,121,5,157,217,0,0        // vpbroadcastw  0xd99d(%rip),%ymm8        # 3a89c <_sk_srcover_bgra_8888_sse2_lowp+0x934>
  .byte  197,61,249,203                      // vpsubw        %ymm3,%ymm8,%ymm9
  .byte  197,53,213,212                      // vpmullw       %ymm4,%ymm9,%ymm10
  .byte  196,65,93,253,216                   // vpaddw        %ymm8,%ymm4,%ymm11
  .byte  197,37,249,223                      // vpsubw        %ymm7,%ymm11,%ymm11
  .byte  197,165,213,192                     // vpmullw       %ymm0,%ymm11,%ymm0
  .byte  196,65,45,253,208                   // vpaddw        %ymm8,%ymm10,%ymm10
  .byte  196,193,125,253,194                 // vpaddw        %ymm10,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,53,213,213                      // vpmullw       %ymm5,%ymm9,%ymm10
  .byte  196,65,85,253,216                   // vpaddw        %ymm8,%ymm5,%ymm11
  .byte  197,37,249,223                      // vpsubw        %ymm7,%ymm11,%ymm11
  .byte  197,165,213,201                     // vpmullw       %ymm1,%ymm11,%ymm1
  .byte  196,65,45,253,208                   // vpaddw        %ymm8,%ymm10,%ymm10
  .byte  196,193,117,253,202                 // vpaddw        %ymm10,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,53,213,214                      // vpmullw       %ymm6,%ymm9,%ymm10
  .byte  196,65,77,253,216                   // vpaddw        %ymm8,%ymm6,%ymm11
  .byte  197,37,249,223                      // vpsubw        %ymm7,%ymm11,%ymm11
  .byte  197,165,213,210                     // vpmullw       %ymm2,%ymm11,%ymm2
  .byte  196,65,45,253,208                   // vpaddw        %ymm8,%ymm10,%ymm10
  .byte  196,193,109,253,210                 // vpaddw        %ymm10,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,53,213,207                      // vpmullw       %ymm7,%ymm9,%ymm9
  .byte  196,193,101,213,216                 // vpmullw       %ymm8,%ymm3,%ymm3
  .byte  196,193,101,253,216                 // vpaddw        %ymm8,%ymm3,%ymm3
  .byte  197,181,253,219                     // vpaddw        %ymm3,%ymm9,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_plus__hsw_lowp
.globl _sk_plus__hsw_lowp
FUNCTION(_sk_plus__hsw_lowp)
_sk_plus__hsw_lowp:
  .byte  197,221,253,192                     // vpaddw        %ymm0,%ymm4,%ymm0
  .byte  196,98,125,121,5,19,217,0,0         // vpbroadcastw  0xd913(%rip),%ymm8        # 3a89e <_sk_srcover_bgra_8888_sse2_lowp+0x936>
  .byte  196,194,125,58,192                  // vpminuw       %ymm8,%ymm0,%ymm0
  .byte  197,213,253,201                     // vpaddw        %ymm1,%ymm5,%ymm1
  .byte  196,194,117,58,200                  // vpminuw       %ymm8,%ymm1,%ymm1
  .byte  197,205,253,210                     // vpaddw        %ymm2,%ymm6,%ymm2
  .byte  196,194,109,58,208                  // vpminuw       %ymm8,%ymm2,%ymm2
  .byte  197,197,253,219                     // vpaddw        %ymm3,%ymm7,%ymm3
  .byte  196,194,101,58,216                  // vpminuw       %ymm8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_screen_hsw_lowp
.globl _sk_screen_hsw_lowp
FUNCTION(_sk_screen_hsw_lowp)
_sk_screen_hsw_lowp:
  .byte  197,93,253,192                      // vpaddw        %ymm0,%ymm4,%ymm8
  .byte  197,221,213,192                     // vpmullw       %ymm0,%ymm4,%ymm0
  .byte  196,98,125,121,13,224,216,0,0       // vpbroadcastw  0xd8e0(%rip),%ymm9        # 3a8a0 <_sk_srcover_bgra_8888_sse2_lowp+0x938>
  .byte  196,193,125,253,193                 // vpaddw        %ymm9,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,189,249,192                     // vpsubw        %ymm0,%ymm8,%ymm0
  .byte  197,85,253,193                      // vpaddw        %ymm1,%ymm5,%ymm8
  .byte  197,213,213,201                     // vpmullw       %ymm1,%ymm5,%ymm1
  .byte  196,193,117,253,201                 // vpaddw        %ymm9,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,189,249,201                     // vpsubw        %ymm1,%ymm8,%ymm1
  .byte  197,77,253,194                      // vpaddw        %ymm2,%ymm6,%ymm8
  .byte  197,205,213,210                     // vpmullw       %ymm2,%ymm6,%ymm2
  .byte  196,193,109,253,209                 // vpaddw        %ymm9,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,189,249,210                     // vpsubw        %ymm2,%ymm8,%ymm2
  .byte  197,69,253,195                      // vpaddw        %ymm3,%ymm7,%ymm8
  .byte  197,197,213,219                     // vpmullw       %ymm3,%ymm7,%ymm3
  .byte  196,193,101,253,217                 // vpaddw        %ymm9,%ymm3,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  197,189,249,219                     // vpsubw        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xor__hsw_lowp
.globl _sk_xor__hsw_lowp
FUNCTION(_sk_xor__hsw_lowp)
_sk_xor__hsw_lowp:
  .byte  196,98,125,121,5,133,216,0,0        // vpbroadcastw  0xd885(%rip),%ymm8        # 3a8a2 <_sk_srcover_bgra_8888_sse2_lowp+0x93a>
  .byte  197,61,249,207                      // vpsubw        %ymm7,%ymm8,%ymm9
  .byte  197,181,213,192                     // vpmullw       %ymm0,%ymm9,%ymm0
  .byte  197,61,249,211                      // vpsubw        %ymm3,%ymm8,%ymm10
  .byte  197,45,213,220                      // vpmullw       %ymm4,%ymm10,%ymm11
  .byte  197,165,253,192                     // vpaddw        %ymm0,%ymm11,%ymm0
  .byte  196,193,125,253,192                 // vpaddw        %ymm8,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,181,213,201                     // vpmullw       %ymm1,%ymm9,%ymm1
  .byte  197,45,213,221                      // vpmullw       %ymm5,%ymm10,%ymm11
  .byte  197,165,253,201                     // vpaddw        %ymm1,%ymm11,%ymm1
  .byte  196,193,117,253,200                 // vpaddw        %ymm8,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,181,213,210                     // vpmullw       %ymm2,%ymm9,%ymm2
  .byte  197,45,213,222                      // vpmullw       %ymm6,%ymm10,%ymm11
  .byte  197,165,253,210                     // vpaddw        %ymm2,%ymm11,%ymm2
  .byte  196,193,109,253,208                 // vpaddw        %ymm8,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,181,213,219                     // vpmullw       %ymm3,%ymm9,%ymm3
  .byte  197,45,213,207                      // vpmullw       %ymm7,%ymm10,%ymm9
  .byte  197,181,253,219                     // vpaddw        %ymm3,%ymm9,%ymm3
  .byte  196,193,101,253,216                 // vpaddw        %ymm8,%ymm3,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_darken_hsw_lowp
.globl _sk_darken_hsw_lowp
FUNCTION(_sk_darken_hsw_lowp)
_sk_darken_hsw_lowp:
  .byte  197,93,253,192                      // vpaddw        %ymm0,%ymm4,%ymm8
  .byte  197,197,213,192                     // vpmullw       %ymm0,%ymm7,%ymm0
  .byte  197,93,213,203                      // vpmullw       %ymm3,%ymm4,%ymm9
  .byte  196,194,125,62,193                  // vpmaxuw       %ymm9,%ymm0,%ymm0
  .byte  196,98,125,121,13,9,216,0,0         // vpbroadcastw  0xd809(%rip),%ymm9        # 3a8a4 <_sk_srcover_bgra_8888_sse2_lowp+0x93c>
  .byte  196,193,125,253,193                 // vpaddw        %ymm9,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,189,249,192                     // vpsubw        %ymm0,%ymm8,%ymm0
  .byte  197,85,253,193                      // vpaddw        %ymm1,%ymm5,%ymm8
  .byte  197,197,213,201                     // vpmullw       %ymm1,%ymm7,%ymm1
  .byte  197,85,213,211                      // vpmullw       %ymm3,%ymm5,%ymm10
  .byte  196,194,117,62,202                  // vpmaxuw       %ymm10,%ymm1,%ymm1
  .byte  196,193,117,253,201                 // vpaddw        %ymm9,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,189,249,201                     // vpsubw        %ymm1,%ymm8,%ymm1
  .byte  197,77,253,194                      // vpaddw        %ymm2,%ymm6,%ymm8
  .byte  197,197,213,210                     // vpmullw       %ymm2,%ymm7,%ymm2
  .byte  197,77,213,211                      // vpmullw       %ymm3,%ymm6,%ymm10
  .byte  196,194,109,62,210                  // vpmaxuw       %ymm10,%ymm2,%ymm2
  .byte  196,193,109,253,209                 // vpaddw        %ymm9,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,189,249,210                     // vpsubw        %ymm2,%ymm8,%ymm2
  .byte  197,53,249,195                      // vpsubw        %ymm3,%ymm9,%ymm8
  .byte  197,61,213,199                      // vpmullw       %ymm7,%ymm8,%ymm8
  .byte  196,65,61,253,193                   // vpaddw        %ymm9,%ymm8,%ymm8
  .byte  196,193,61,113,208,8                // vpsrlw        $0x8,%ymm8,%ymm8
  .byte  197,189,253,219                     // vpaddw        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lighten_hsw_lowp
.globl _sk_lighten_hsw_lowp
FUNCTION(_sk_lighten_hsw_lowp)
_sk_lighten_hsw_lowp:
  .byte  197,93,253,192                      // vpaddw        %ymm0,%ymm4,%ymm8
  .byte  197,197,213,192                     // vpmullw       %ymm0,%ymm7,%ymm0
  .byte  197,93,213,203                      // vpmullw       %ymm3,%ymm4,%ymm9
  .byte  196,194,125,58,193                  // vpminuw       %ymm9,%ymm0,%ymm0
  .byte  196,98,125,121,13,138,215,0,0       // vpbroadcastw  0xd78a(%rip),%ymm9        # 3a8a6 <_sk_srcover_bgra_8888_sse2_lowp+0x93e>
  .byte  196,193,125,253,193                 // vpaddw        %ymm9,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,189,249,192                     // vpsubw        %ymm0,%ymm8,%ymm0
  .byte  197,85,253,193                      // vpaddw        %ymm1,%ymm5,%ymm8
  .byte  197,197,213,201                     // vpmullw       %ymm1,%ymm7,%ymm1
  .byte  197,85,213,211                      // vpmullw       %ymm3,%ymm5,%ymm10
  .byte  196,194,117,58,202                  // vpminuw       %ymm10,%ymm1,%ymm1
  .byte  196,193,117,253,201                 // vpaddw        %ymm9,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,189,249,201                     // vpsubw        %ymm1,%ymm8,%ymm1
  .byte  197,77,253,194                      // vpaddw        %ymm2,%ymm6,%ymm8
  .byte  197,197,213,210                     // vpmullw       %ymm2,%ymm7,%ymm2
  .byte  197,77,213,211                      // vpmullw       %ymm3,%ymm6,%ymm10
  .byte  196,194,109,58,210                  // vpminuw       %ymm10,%ymm2,%ymm2
  .byte  196,193,109,253,209                 // vpaddw        %ymm9,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,189,249,210                     // vpsubw        %ymm2,%ymm8,%ymm2
  .byte  197,53,249,195                      // vpsubw        %ymm3,%ymm9,%ymm8
  .byte  197,61,213,199                      // vpmullw       %ymm7,%ymm8,%ymm8
  .byte  196,65,61,253,193                   // vpaddw        %ymm9,%ymm8,%ymm8
  .byte  196,193,61,113,208,8                // vpsrlw        $0x8,%ymm8,%ymm8
  .byte  197,189,253,219                     // vpaddw        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_difference_hsw_lowp
.globl _sk_difference_hsw_lowp
FUNCTION(_sk_difference_hsw_lowp)
_sk_difference_hsw_lowp:
  .byte  197,93,253,192                      // vpaddw        %ymm0,%ymm4,%ymm8
  .byte  197,197,213,192                     // vpmullw       %ymm0,%ymm7,%ymm0
  .byte  197,93,213,203                      // vpmullw       %ymm3,%ymm4,%ymm9
  .byte  196,194,125,58,193                  // vpminuw       %ymm9,%ymm0,%ymm0
  .byte  196,98,125,121,13,11,215,0,0        // vpbroadcastw  0xd70b(%rip),%ymm9        # 3a8a8 <_sk_srcover_bgra_8888_sse2_lowp+0x940>
  .byte  196,193,125,253,193                 // vpaddw        %ymm9,%ymm0,%ymm0
  .byte  197,253,113,208,7                   // vpsrlw        $0x7,%ymm0,%ymm0
  .byte  196,98,125,121,21,250,214,0,0       // vpbroadcastw  0xd6fa(%rip),%ymm10        # 3a8aa <_sk_srcover_bgra_8888_sse2_lowp+0x942>
  .byte  196,193,125,219,194                 // vpand         %ymm10,%ymm0,%ymm0
  .byte  197,189,249,192                     // vpsubw        %ymm0,%ymm8,%ymm0
  .byte  197,85,253,193                      // vpaddw        %ymm1,%ymm5,%ymm8
  .byte  197,197,213,201                     // vpmullw       %ymm1,%ymm7,%ymm1
  .byte  197,85,213,219                      // vpmullw       %ymm3,%ymm5,%ymm11
  .byte  196,194,117,58,203                  // vpminuw       %ymm11,%ymm1,%ymm1
  .byte  196,193,117,253,201                 // vpaddw        %ymm9,%ymm1,%ymm1
  .byte  197,245,113,209,7                   // vpsrlw        $0x7,%ymm1,%ymm1
  .byte  196,193,117,219,202                 // vpand         %ymm10,%ymm1,%ymm1
  .byte  197,189,249,201                     // vpsubw        %ymm1,%ymm8,%ymm1
  .byte  197,77,253,194                      // vpaddw        %ymm2,%ymm6,%ymm8
  .byte  197,197,213,210                     // vpmullw       %ymm2,%ymm7,%ymm2
  .byte  197,77,213,219                      // vpmullw       %ymm3,%ymm6,%ymm11
  .byte  196,194,109,58,211                  // vpminuw       %ymm11,%ymm2,%ymm2
  .byte  196,193,109,253,209                 // vpaddw        %ymm9,%ymm2,%ymm2
  .byte  197,237,113,210,7                   // vpsrlw        $0x7,%ymm2,%ymm2
  .byte  196,193,109,219,210                 // vpand         %ymm10,%ymm2,%ymm2
  .byte  197,189,249,210                     // vpsubw        %ymm2,%ymm8,%ymm2
  .byte  197,53,249,195                      // vpsubw        %ymm3,%ymm9,%ymm8
  .byte  197,61,213,199                      // vpmullw       %ymm7,%ymm8,%ymm8
  .byte  196,65,61,253,193                   // vpaddw        %ymm9,%ymm8,%ymm8
  .byte  196,193,61,113,208,8                // vpsrlw        $0x8,%ymm8,%ymm8
  .byte  197,189,253,219                     // vpaddw        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_exclusion_hsw_lowp
.globl _sk_exclusion_hsw_lowp
FUNCTION(_sk_exclusion_hsw_lowp)
_sk_exclusion_hsw_lowp:
  .byte  197,93,253,192                      // vpaddw        %ymm0,%ymm4,%ymm8
  .byte  197,221,213,192                     // vpmullw       %ymm0,%ymm4,%ymm0
  .byte  196,98,125,121,13,127,214,0,0       // vpbroadcastw  0xd67f(%rip),%ymm9        # 3a8ac <_sk_srcover_bgra_8888_sse2_lowp+0x944>
  .byte  196,193,125,253,193                 // vpaddw        %ymm9,%ymm0,%ymm0
  .byte  197,253,113,208,7                   // vpsrlw        $0x7,%ymm0,%ymm0
  .byte  196,98,125,121,21,110,214,0,0       // vpbroadcastw  0xd66e(%rip),%ymm10        # 3a8ae <_sk_srcover_bgra_8888_sse2_lowp+0x946>
  .byte  196,193,125,219,194                 // vpand         %ymm10,%ymm0,%ymm0
  .byte  197,189,249,192                     // vpsubw        %ymm0,%ymm8,%ymm0
  .byte  197,85,253,193                      // vpaddw        %ymm1,%ymm5,%ymm8
  .byte  197,213,213,201                     // vpmullw       %ymm1,%ymm5,%ymm1
  .byte  196,193,117,253,201                 // vpaddw        %ymm9,%ymm1,%ymm1
  .byte  197,245,113,209,7                   // vpsrlw        $0x7,%ymm1,%ymm1
  .byte  196,193,117,219,202                 // vpand         %ymm10,%ymm1,%ymm1
  .byte  197,189,249,201                     // vpsubw        %ymm1,%ymm8,%ymm1
  .byte  197,77,253,194                      // vpaddw        %ymm2,%ymm6,%ymm8
  .byte  197,205,213,210                     // vpmullw       %ymm2,%ymm6,%ymm2
  .byte  196,193,109,253,209                 // vpaddw        %ymm9,%ymm2,%ymm2
  .byte  197,237,113,210,7                   // vpsrlw        $0x7,%ymm2,%ymm2
  .byte  196,193,109,219,210                 // vpand         %ymm10,%ymm2,%ymm2
  .byte  197,189,249,210                     // vpsubw        %ymm2,%ymm8,%ymm2
  .byte  197,53,249,195                      // vpsubw        %ymm3,%ymm9,%ymm8
  .byte  197,61,213,199                      // vpmullw       %ymm7,%ymm8,%ymm8
  .byte  196,65,61,253,193                   // vpaddw        %ymm9,%ymm8,%ymm8
  .byte  196,193,61,113,208,8                // vpsrlw        $0x8,%ymm8,%ymm8
  .byte  197,189,253,219                     // vpaddw        %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hardlight_hsw_lowp
.globl _sk_hardlight_hsw_lowp
FUNCTION(_sk_hardlight_hsw_lowp)
_sk_hardlight_hsw_lowp:
  .byte  197,125,253,192                     // vpaddw        %ymm0,%ymm0,%ymm8
  .byte  196,98,125,121,13,11,214,0,0        // vpbroadcastw  0xd60b(%rip),%ymm9        # 3a8b2 <_sk_srcover_bgra_8888_sse2_lowp+0x94a>
  .byte  196,65,101,239,209                  // vpxor         %ymm9,%ymm3,%ymm10
  .byte  196,65,61,239,217                   // vpxor         %ymm9,%ymm8,%ymm11
  .byte  196,65,37,101,218                   // vpcmpgtw      %ymm10,%ymm11,%ymm11
  .byte  197,61,213,228                      // vpmullw       %ymm4,%ymm8,%ymm12
  .byte  197,69,213,195                      // vpmullw       %ymm3,%ymm7,%ymm8
  .byte  197,101,249,232                     // vpsubw        %ymm0,%ymm3,%ymm13
  .byte  197,69,249,244                      // vpsubw        %ymm4,%ymm7,%ymm14
  .byte  196,65,21,213,238                   // vpmullw       %ymm14,%ymm13,%ymm13
  .byte  196,65,21,253,237                   // vpaddw        %ymm13,%ymm13,%ymm13
  .byte  196,65,61,249,237                   // vpsubw        %ymm13,%ymm8,%ymm13
  .byte  196,67,29,76,221,176                // vpblendvb     %ymm11,%ymm13,%ymm12,%ymm11
  .byte  197,117,253,225                     // vpaddw        %ymm1,%ymm1,%ymm12
  .byte  197,101,249,233                     // vpsubw        %ymm1,%ymm3,%ymm13
  .byte  197,69,249,245                      // vpsubw        %ymm5,%ymm7,%ymm14
  .byte  196,65,21,213,238                   // vpmullw       %ymm14,%ymm13,%ymm13
  .byte  196,65,29,239,241                   // vpxor         %ymm9,%ymm12,%ymm14
  .byte  196,65,13,101,242                   // vpcmpgtw      %ymm10,%ymm14,%ymm14
  .byte  197,29,213,229                      // vpmullw       %ymm5,%ymm12,%ymm12
  .byte  196,65,21,253,237                   // vpaddw        %ymm13,%ymm13,%ymm13
  .byte  196,65,61,249,237                   // vpsubw        %ymm13,%ymm8,%ymm13
  .byte  196,67,29,76,229,224                // vpblendvb     %ymm14,%ymm13,%ymm12,%ymm12
  .byte  197,109,253,234                     // vpaddw        %ymm2,%ymm2,%ymm13
  .byte  196,65,21,239,201                   // vpxor         %ymm9,%ymm13,%ymm9
  .byte  196,65,53,101,202                   // vpcmpgtw      %ymm10,%ymm9,%ymm9
  .byte  197,101,249,210                     // vpsubw        %ymm2,%ymm3,%ymm10
  .byte  197,69,249,246                      // vpsubw        %ymm6,%ymm7,%ymm14
  .byte  196,65,45,213,214                   // vpmullw       %ymm14,%ymm10,%ymm10
  .byte  196,98,125,121,53,130,213,0,0       // vpbroadcastw  0xd582(%rip),%ymm14        # 3a8b0 <_sk_srcover_bgra_8888_sse2_lowp+0x948>
  .byte  196,65,45,253,210                   // vpaddw        %ymm10,%ymm10,%ymm10
  .byte  196,65,61,249,194                   // vpsubw        %ymm10,%ymm8,%ymm8
  .byte  197,13,249,215                      // vpsubw        %ymm7,%ymm14,%ymm10
  .byte  197,173,213,192                     // vpmullw       %ymm0,%ymm10,%ymm0
  .byte  197,21,213,238                      // vpmullw       %ymm6,%ymm13,%ymm13
  .byte  196,67,21,76,192,144                // vpblendvb     %ymm9,%ymm8,%ymm13,%ymm8
  .byte  197,13,249,203                      // vpsubw        %ymm3,%ymm14,%ymm9
  .byte  197,53,213,236                      // vpmullw       %ymm4,%ymm9,%ymm13
  .byte  197,149,253,192                     // vpaddw        %ymm0,%ymm13,%ymm0
  .byte  196,65,37,253,222                   // vpaddw        %ymm14,%ymm11,%ymm11
  .byte  196,193,125,253,195                 // vpaddw        %ymm11,%ymm0,%ymm0
  .byte  197,173,213,201                     // vpmullw       %ymm1,%ymm10,%ymm1
  .byte  197,53,213,221                      // vpmullw       %ymm5,%ymm9,%ymm11
  .byte  197,165,253,201                     // vpaddw        %ymm1,%ymm11,%ymm1
  .byte  196,65,29,253,222                   // vpaddw        %ymm14,%ymm12,%ymm11
  .byte  196,193,117,253,203                 // vpaddw        %ymm11,%ymm1,%ymm1
  .byte  197,173,213,210                     // vpmullw       %ymm2,%ymm10,%ymm2
  .byte  197,53,213,214                      // vpmullw       %ymm6,%ymm9,%ymm10
  .byte  197,173,253,210                     // vpaddw        %ymm2,%ymm10,%ymm2
  .byte  196,65,61,253,198                   // vpaddw        %ymm14,%ymm8,%ymm8
  .byte  196,193,109,253,208                 // vpaddw        %ymm8,%ymm2,%ymm2
  .byte  197,53,213,199                      // vpmullw       %ymm7,%ymm9,%ymm8
  .byte  196,65,61,253,198                   // vpaddw        %ymm14,%ymm8,%ymm8
  .byte  196,193,61,113,208,8                // vpsrlw        $0x8,%ymm8,%ymm8
  .byte  197,189,253,219                     // vpaddw        %ymm3,%ymm8,%ymm3
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_overlay_hsw_lowp
.globl _sk_overlay_hsw_lowp
FUNCTION(_sk_overlay_hsw_lowp)
_sk_overlay_hsw_lowp:
  .byte  197,93,253,196                      // vpaddw        %ymm4,%ymm4,%ymm8
  .byte  196,98,125,121,13,247,212,0,0       // vpbroadcastw  0xd4f7(%rip),%ymm9        # 3a8b6 <_sk_srcover_bgra_8888_sse2_lowp+0x94e>
  .byte  196,65,69,239,209                   // vpxor         %ymm9,%ymm7,%ymm10
  .byte  196,65,61,239,193                   // vpxor         %ymm9,%ymm8,%ymm8
  .byte  196,65,61,101,218                   // vpcmpgtw      %ymm10,%ymm8,%ymm11
  .byte  197,125,213,196                     // vpmullw       %ymm4,%ymm0,%ymm8
  .byte  196,65,61,253,224                   // vpaddw        %ymm8,%ymm8,%ymm12
  .byte  197,69,213,195                      // vpmullw       %ymm3,%ymm7,%ymm8
  .byte  197,101,249,232                     // vpsubw        %ymm0,%ymm3,%ymm13
  .byte  197,69,249,244                      // vpsubw        %ymm4,%ymm7,%ymm14
  .byte  196,65,21,213,238                   // vpmullw       %ymm14,%ymm13,%ymm13
  .byte  196,65,21,253,237                   // vpaddw        %ymm13,%ymm13,%ymm13
  .byte  196,65,61,249,237                   // vpsubw        %ymm13,%ymm8,%ymm13
  .byte  196,67,29,76,221,176                // vpblendvb     %ymm11,%ymm13,%ymm12,%ymm11
  .byte  197,85,253,229                      // vpaddw        %ymm5,%ymm5,%ymm12
  .byte  196,65,29,239,225                   // vpxor         %ymm9,%ymm12,%ymm12
  .byte  196,65,29,101,226                   // vpcmpgtw      %ymm10,%ymm12,%ymm12
  .byte  197,101,249,233                     // vpsubw        %ymm1,%ymm3,%ymm13
  .byte  197,69,249,245                      // vpsubw        %ymm5,%ymm7,%ymm14
  .byte  196,65,21,213,238                   // vpmullw       %ymm14,%ymm13,%ymm13
  .byte  197,117,213,245                     // vpmullw       %ymm5,%ymm1,%ymm14
  .byte  196,65,13,253,246                   // vpaddw        %ymm14,%ymm14,%ymm14
  .byte  196,65,21,253,237                   // vpaddw        %ymm13,%ymm13,%ymm13
  .byte  196,65,61,249,237                   // vpsubw        %ymm13,%ymm8,%ymm13
  .byte  196,67,13,76,229,192                // vpblendvb     %ymm12,%ymm13,%ymm14,%ymm12
  .byte  196,98,125,121,45,127,212,0,0       // vpbroadcastw  0xd47f(%rip),%ymm13        # 3a8b4 <_sk_srcover_bgra_8888_sse2_lowp+0x94c>
  .byte  197,77,253,246                      // vpaddw        %ymm6,%ymm6,%ymm14
  .byte  196,65,13,239,201                   // vpxor         %ymm9,%ymm14,%ymm9
  .byte  196,65,53,101,202                   // vpcmpgtw      %ymm10,%ymm9,%ymm9
  .byte  197,101,249,210                     // vpsubw        %ymm2,%ymm3,%ymm10
  .byte  197,69,249,246                      // vpsubw        %ymm6,%ymm7,%ymm14
  .byte  196,65,45,213,214                   // vpmullw       %ymm14,%ymm10,%ymm10
  .byte  197,21,249,247                      // vpsubw        %ymm7,%ymm13,%ymm14
  .byte  197,141,213,192                     // vpmullw       %ymm0,%ymm14,%ymm0
  .byte  196,65,45,253,210                   // vpaddw        %ymm10,%ymm10,%ymm10
  .byte  196,65,61,249,194                   // vpsubw        %ymm10,%ymm8,%ymm8
  .byte  197,109,213,214                     // vpmullw       %ymm6,%ymm2,%ymm10
  .byte  196,65,45,253,210                   // vpaddw        %ymm10,%ymm10,%ymm10
  .byte  196,67,45,76,192,144                // vpblendvb     %ymm9,%ymm8,%ymm10,%ymm8
  .byte  197,21,249,203                      // vpsubw        %ymm3,%ymm13,%ymm9
  .byte  197,53,213,212                      // vpmullw       %ymm4,%ymm9,%ymm10
  .byte  197,173,253,192                     // vpaddw        %ymm0,%ymm10,%ymm0
  .byte  196,65,37,253,213                   // vpaddw        %ymm13,%ymm11,%ymm10
  .byte  196,193,125,253,194                 // vpaddw        %ymm10,%ymm0,%ymm0
  .byte  197,141,213,201                     // vpmullw       %ymm1,%ymm14,%ymm1
  .byte  197,53,213,213                      // vpmullw       %ymm5,%ymm9,%ymm10
  .byte  197,173,253,201                     // vpaddw        %ymm1,%ymm10,%ymm1
  .byte  196,65,29,253,213                   // vpaddw        %ymm13,%ymm12,%ymm10
  .byte  196,193,117,253,202                 // vpaddw        %ymm10,%ymm1,%ymm1
  .byte  197,141,213,210                     // vpmullw       %ymm2,%ymm14,%ymm2
  .byte  197,53,213,214                      // vpmullw       %ymm6,%ymm9,%ymm10
  .byte  197,173,253,210                     // vpaddw        %ymm2,%ymm10,%ymm2
  .byte  196,65,61,253,197                   // vpaddw        %ymm13,%ymm8,%ymm8
  .byte  196,193,109,253,208                 // vpaddw        %ymm8,%ymm2,%ymm2
  .byte  197,53,213,199                      // vpmullw       %ymm7,%ymm9,%ymm8
  .byte  196,65,61,253,197                   // vpaddw        %ymm13,%ymm8,%ymm8
  .byte  196,193,61,113,208,8                // vpsrlw        $0x8,%ymm8,%ymm8
  .byte  197,189,253,219                     // vpaddw        %ymm3,%ymm8,%ymm3
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_8888_hsw_lowp
.globl _sk_load_8888_hsw_lowp
FUNCTION(_sk_load_8888_hsw_lowp)
_sk_load_8888_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,55                              // ja            2d52b <_sk_load_8888_hsw_lowp+0x52>
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,162,1,0,0                 // lea           0x1a2(%rip),%r9        # 2d6a4 <_sk_load_8888_hsw_lowp+0x1cb>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  197,237,239,210                     // vpxor         %ymm2,%ymm2,%ymm2
  .byte  196,65,61,239,192                   // vpxor         %ymm8,%ymm8,%ymm8
  .byte  197,229,239,219                     // vpxor         %ymm3,%ymm3,%ymm3
  .byte  255,224                             // jmpq          *%rax
  .byte  196,193,121,110,12,144              // vmovd         (%r8,%rdx,4),%xmm1
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  233,39,1,0,0                        // jmpq          2d652 <_sk_load_8888_hsw_lowp+0x179>
  .byte  196,193,126,111,12,144              // vmovdqu       (%r8,%rdx,4),%ymm1
  .byte  196,193,126,111,68,144,32           // vmovdqu       0x20(%r8,%rdx,4),%ymm0
  .byte  233,21,1,0,0                        // jmpq          2d652 <_sk_load_8888_hsw_lowp+0x179>
  .byte  196,193,121,110,68,144,8            // vmovd         0x8(%r8,%rdx,4),%xmm0
  .byte  196,226,121,89,192                  // vpbroadcastq  %xmm0,%xmm0
  .byte  197,229,239,219                     // vpxor         %ymm3,%ymm3,%ymm3
  .byte  196,227,101,2,192,4                 // vpblendd      $0x4,%ymm0,%ymm3,%ymm0
  .byte  196,194,121,53,12,144               // vpmovzxdq     (%r8,%rdx,4),%xmm1
  .byte  197,249,112,201,232                 // vpshufd       $0xe8,%xmm1,%xmm1
  .byte  196,227,125,2,201,3                 // vpblendd      $0x3,%ymm1,%ymm0,%ymm1
  .byte  197,253,111,195                     // vmovdqa       %ymm3,%ymm0
  .byte  233,229,0,0,0                       // jmpq          2d652 <_sk_load_8888_hsw_lowp+0x179>
  .byte  196,193,121,110,68,144,24           // vmovd         0x18(%r8,%rdx,4),%xmm0
  .byte  196,226,125,89,192                  // vpbroadcastq  %xmm0,%ymm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,227,117,2,192,64                // vpblendd      $0x40,%ymm0,%ymm1,%ymm0
  .byte  196,227,125,57,194,1                // vextracti128  $0x1,%ymm0,%xmm2
  .byte  196,195,105,34,84,144,20,1          // vpinsrd       $0x1,0x14(%r8,%rdx,4),%xmm2,%xmm2
  .byte  196,227,125,56,194,1                // vinserti128   $0x1,%xmm2,%ymm0,%ymm0
  .byte  197,253,111,209                     // vmovdqa       %ymm1,%ymm2
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,195,113,34,76,144,16,0          // vpinsrd       $0x0,0x10(%r8,%rdx,4),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  197,125,111,194                     // vmovdqa       %ymm2,%ymm8
  .byte  196,193,122,111,12,144              // vmovdqu       (%r8,%rdx,4),%xmm1
  .byte  196,227,117,2,200,240               // vpblendd      $0xf0,%ymm0,%ymm1,%ymm1
  .byte  197,125,127,192                     // vmovdqa       %ymm8,%ymm0
  .byte  233,138,0,0,0                       // jmpq          2d652 <_sk_load_8888_hsw_lowp+0x179>
  .byte  196,193,121,110,68,144,40           // vmovd         0x28(%r8,%rdx,4),%xmm0
  .byte  196,226,121,89,192                  // vpbroadcastq  %xmm0,%xmm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,227,117,2,192,4                 // vpblendd      $0x4,%ymm0,%ymm1,%ymm0
  .byte  196,195,121,34,76,144,36,1          // vpinsrd       $0x1,0x24(%r8,%rdx,4),%xmm0,%xmm1
  .byte  196,227,125,2,193,15                // vpblendd      $0xf,%ymm1,%ymm0,%ymm0
  .byte  196,193,121,110,76,144,32           // vmovd         0x20(%r8,%rdx,4),%xmm1
  .byte  196,227,125,2,193,1                 // vpblendd      $0x1,%ymm1,%ymm0,%ymm0
  .byte  196,193,126,111,12,144              // vmovdqu       (%r8,%rdx,4),%ymm1
  .byte  235,81                              // jmp           2d652 <_sk_load_8888_hsw_lowp+0x179>
  .byte  196,193,121,110,68,144,56           // vmovd         0x38(%r8,%rdx,4),%xmm0
  .byte  196,226,125,89,192                  // vpbroadcastq  %xmm0,%ymm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,227,117,2,192,64                // vpblendd      $0x40,%ymm0,%ymm1,%ymm0
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,195,113,34,76,144,52,1          // vpinsrd       $0x1,0x34(%r8,%rdx,4),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,195,113,34,76,144,48,0          // vpinsrd       $0x0,0x30(%r8,%rdx,4),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,193,126,111,12,144              // vmovdqu       (%r8,%rdx,4),%ymm1
  .byte  196,193,122,111,84,144,32           // vmovdqu       0x20(%r8,%rdx,4),%xmm2
  .byte  196,227,109,2,192,240               // vpblendd      $0xf0,%ymm0,%ymm2,%ymm0
  .byte  196,227,117,56,208,1                // vinserti128   $0x1,%xmm0,%ymm1,%ymm2
  .byte  196,227,117,70,216,49               // vperm2i128    $0x31,%ymm0,%ymm1,%ymm3
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  196,227,101,14,200,170              // vpblendw      $0xaa,%ymm0,%ymm3,%ymm1
  .byte  196,227,109,14,192,170              // vpblendw      $0xaa,%ymm0,%ymm2,%ymm0
  .byte  196,226,125,43,201                  // vpackusdw     %ymm1,%ymm0,%ymm1
  .byte  197,125,111,5,69,210,0,0            // vmovdqa       0xd245(%rip),%ymm8        # 3a8c0 <_sk_srcover_bgra_8888_sse2_lowp+0x958>
  .byte  196,193,117,219,192                 // vpand         %ymm8,%ymm1,%ymm0
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,229,114,211,16                  // vpsrld        $0x10,%ymm3,%ymm3
  .byte  197,237,114,210,16                  // vpsrld        $0x10,%ymm2,%ymm2
  .byte  196,226,109,43,219                  // vpackusdw     %ymm3,%ymm2,%ymm3
  .byte  196,193,101,219,208                 // vpand         %ymm8,%ymm3,%ymm2
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  120,254                             // js            2d6a4 <_sk_load_8888_hsw_lowp+0x1cb>
  .byte  255                                 // (bad)
  .byte  255,175,254,255,255,153             // ljmp          *-0x66000002(%rdi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,15                              // decl          (%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,247                             // push          %rdi
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  223,254                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,201                             // dec           %ecx
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,85,255                          // callq         *-0x1(%rbp)
  .byte  255                                 // (bad)
  .byte  255,72,255                          // decl          -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  58,255                              // cmp           %bh,%bh
  .byte  255                                 // (bad)
  .byte  255,36,255                          // jmpq          *(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,155,255,255,255,135             // lcall         *-0x78000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,115,255                         // pushq         -0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,93,255                          // lcall         *-0x1(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_8888_dst_hsw_lowp
.globl _sk_load_8888_dst_hsw_lowp
FUNCTION(_sk_load_8888_dst_hsw_lowp)
_sk_load_8888_dst_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,55                              // ja            2d732 <_sk_load_8888_dst_hsw_lowp+0x52>
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,163,1,0,0                 // lea           0x1a3(%rip),%r9        # 2d8ac <_sk_load_8888_dst_hsw_lowp+0x1cc>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  197,205,239,246                     // vpxor         %ymm6,%ymm6,%ymm6
  .byte  196,65,61,239,192                   // vpxor         %ymm8,%ymm8,%ymm8
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  255,224                             // jmpq          *%rax
  .byte  196,193,121,110,44,144              // vmovd         (%r8,%rdx,4),%xmm5
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  233,39,1,0,0                        // jmpq          2d859 <_sk_load_8888_dst_hsw_lowp+0x179>
  .byte  196,193,126,111,44,144              // vmovdqu       (%r8,%rdx,4),%ymm5
  .byte  196,193,126,111,100,144,32          // vmovdqu       0x20(%r8,%rdx,4),%ymm4
  .byte  233,21,1,0,0                        // jmpq          2d859 <_sk_load_8888_dst_hsw_lowp+0x179>
  .byte  196,193,121,110,100,144,8           // vmovd         0x8(%r8,%rdx,4),%xmm4
  .byte  196,226,121,89,228                  // vpbroadcastq  %xmm4,%xmm4
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  196,227,69,2,228,4                  // vpblendd      $0x4,%ymm4,%ymm7,%ymm4
  .byte  196,194,121,53,44,144               // vpmovzxdq     (%r8,%rdx,4),%xmm5
  .byte  197,249,112,237,232                 // vpshufd       $0xe8,%xmm5,%xmm5
  .byte  196,227,93,2,237,3                  // vpblendd      $0x3,%ymm5,%ymm4,%ymm5
  .byte  197,253,111,231                     // vmovdqa       %ymm7,%ymm4
  .byte  233,229,0,0,0                       // jmpq          2d859 <_sk_load_8888_dst_hsw_lowp+0x179>
  .byte  196,193,121,110,100,144,24          // vmovd         0x18(%r8,%rdx,4),%xmm4
  .byte  196,226,125,89,228                  // vpbroadcastq  %xmm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,228,64                 // vpblendd      $0x40,%ymm4,%ymm5,%ymm4
  .byte  196,227,125,57,230,1                // vextracti128  $0x1,%ymm4,%xmm6
  .byte  196,195,73,34,116,144,20,1          // vpinsrd       $0x1,0x14(%r8,%rdx,4),%xmm6,%xmm6
  .byte  196,227,93,56,230,1                 // vinserti128   $0x1,%xmm6,%ymm4,%ymm4
  .byte  197,253,111,245                     // vmovdqa       %ymm5,%ymm6
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,195,81,34,108,144,16,0          // vpinsrd       $0x0,0x10(%r8,%rdx,4),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  197,125,111,198                     // vmovdqa       %ymm6,%ymm8
  .byte  196,193,122,111,44,144              // vmovdqu       (%r8,%rdx,4),%xmm5
  .byte  196,227,85,2,236,240                // vpblendd      $0xf0,%ymm4,%ymm5,%ymm5
  .byte  197,125,127,196                     // vmovdqa       %ymm8,%ymm4
  .byte  233,138,0,0,0                       // jmpq          2d859 <_sk_load_8888_dst_hsw_lowp+0x179>
  .byte  196,193,121,110,100,144,40          // vmovd         0x28(%r8,%rdx,4),%xmm4
  .byte  196,226,121,89,228                  // vpbroadcastq  %xmm4,%xmm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,228,4                  // vpblendd      $0x4,%ymm4,%ymm5,%ymm4
  .byte  196,195,89,34,108,144,36,1          // vpinsrd       $0x1,0x24(%r8,%rdx,4),%xmm4,%xmm5
  .byte  196,227,93,2,229,15                 // vpblendd      $0xf,%ymm5,%ymm4,%ymm4
  .byte  196,193,121,110,108,144,32          // vmovd         0x20(%r8,%rdx,4),%xmm5
  .byte  196,227,93,2,229,1                  // vpblendd      $0x1,%ymm5,%ymm4,%ymm4
  .byte  196,193,126,111,44,144              // vmovdqu       (%r8,%rdx,4),%ymm5
  .byte  235,81                              // jmp           2d859 <_sk_load_8888_dst_hsw_lowp+0x179>
  .byte  196,193,121,110,100,144,56          // vmovd         0x38(%r8,%rdx,4),%xmm4
  .byte  196,226,125,89,228                  // vpbroadcastq  %xmm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,228,64                 // vpblendd      $0x40,%ymm4,%ymm5,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,195,81,34,108,144,52,1          // vpinsrd       $0x1,0x34(%r8,%rdx,4),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,195,81,34,108,144,48,0          // vpinsrd       $0x0,0x30(%r8,%rdx,4),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,193,126,111,44,144              // vmovdqu       (%r8,%rdx,4),%ymm5
  .byte  196,193,122,111,116,144,32          // vmovdqu       0x20(%r8,%rdx,4),%xmm6
  .byte  196,227,77,2,228,240                // vpblendd      $0xf0,%ymm4,%ymm6,%ymm4
  .byte  196,227,85,56,244,1                 // vinserti128   $0x1,%xmm4,%ymm5,%ymm6
  .byte  196,227,85,70,252,49                // vperm2i128    $0x31,%ymm4,%ymm5,%ymm7
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  196,227,69,14,236,170               // vpblendw      $0xaa,%ymm4,%ymm7,%ymm5
  .byte  196,227,77,14,228,170               // vpblendw      $0xaa,%ymm4,%ymm6,%ymm4
  .byte  196,226,93,43,237                   // vpackusdw     %ymm5,%ymm4,%ymm5
  .byte  197,125,111,5,94,208,0,0            // vmovdqa       0xd05e(%rip),%ymm8        # 3a8e0 <_sk_srcover_bgra_8888_sse2_lowp+0x978>
  .byte  196,193,85,219,224                  // vpand         %ymm8,%ymm5,%ymm4
  .byte  197,213,113,213,8                   // vpsrlw        $0x8,%ymm5,%ymm5
  .byte  197,197,114,215,16                  // vpsrld        $0x10,%ymm7,%ymm7
  .byte  197,205,114,214,16                  // vpsrld        $0x10,%ymm6,%ymm6
  .byte  196,226,77,43,255                   // vpackusdw     %ymm7,%ymm6,%ymm7
  .byte  196,193,69,219,240                  // vpand         %ymm8,%ymm7,%ymm6
  .byte  197,197,113,215,8                   // vpsrlw        $0x8,%ymm7,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  119,254                             // ja            2d8ac <_sk_load_8888_dst_hsw_lowp+0x1cc>
  .byte  255                                 // (bad)
  .byte  255,174,254,255,255,152             // ljmp          *-0x67000002(%rsi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,14                              // decl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,246                             // push          %rsi
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  222,254                             // fdivrp        %st,%st(6)
  .byte  255                                 // (bad)
  .byte  255,200                             // dec           %eax
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,84,255,255                      // callq         *-0x1(%rdi,%rdi,8)
  .byte  255,71,255                          // incl          -0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  57,255                              // cmp           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,35                              // jmpq          *(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,154,255,255,255,134             // lcall         *-0x79000001(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,114,255                         // pushq         -0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,92,255,255                      // lcall         *-0x1(%rdi,%rdi,8)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_8888_hsw_lowp
.globl _sk_store_8888_hsw_lowp
FUNCTION(_sk_store_8888_hsw_lowp)
_sk_store_8888_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  197,189,113,241,8                   // vpsllw        $0x8,%ymm1,%ymm8
  .byte  197,61,235,192                      // vpor          %ymm0,%ymm8,%ymm8
  .byte  196,66,125,51,200                   // vpmovzxwd     %xmm8,%ymm9
  .byte  196,67,125,57,192,1                 // vextracti128  $0x1,%ymm8,%xmm8
  .byte  196,66,125,51,208                   // vpmovzxwd     %xmm8,%ymm10
  .byte  197,189,113,243,8                   // vpsllw        $0x8,%ymm3,%ymm8
  .byte  197,61,235,194                      // vpor          %ymm2,%ymm8,%ymm8
  .byte  196,67,125,57,195,1                 // vextracti128  $0x1,%ymm8,%xmm11
  .byte  196,66,125,51,219                   // vpmovzxwd     %xmm11,%ymm11
  .byte  196,66,125,51,192                   // vpmovzxwd     %xmm8,%ymm8
  .byte  196,193,61,114,240,16               // vpslld        $0x10,%ymm8,%ymm8
  .byte  196,65,61,235,193                   // vpor          %ymm9,%ymm8,%ymm8
  .byte  196,193,53,114,243,16               // vpslld        $0x10,%ymm11,%ymm9
  .byte  196,65,53,235,202                   // vpor          %ymm10,%ymm9,%ymm9
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,30                              // ja            2d969 <_sk_store_8888_hsw_lowp+0x81>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,195,0,0,0                 // lea           0xc3(%rip),%r9        # 2da18 <_sk_store_8888_hsw_lowp+0x130>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,121,126,4,144                // vmovd         %xmm8,(%r8,%rdx,4)
  .byte  233,171,0,0,0                       // jmpq          2da14 <_sk_store_8888_hsw_lowp+0x12c>
  .byte  196,65,126,127,4,144                // vmovdqu       %ymm8,(%r8,%rdx,4)
  .byte  196,65,126,127,76,144,32            // vmovdqu       %ymm9,0x20(%r8,%rdx,4)
  .byte  233,153,0,0,0                       // jmpq          2da14 <_sk_store_8888_hsw_lowp+0x12c>
  .byte  196,67,121,22,68,144,8,2            // vpextrd       $0x2,%xmm8,0x8(%r8,%rdx,4)
  .byte  196,65,121,214,4,144                // vmovq         %xmm8,(%r8,%rdx,4)
  .byte  233,134,0,0,0                       // jmpq          2da14 <_sk_store_8888_hsw_lowp+0x12c>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,22,76,144,24,2           // vpextrd       $0x2,%xmm9,0x18(%r8,%rdx,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,22,76,144,20,1           // vpextrd       $0x1,%xmm9,0x14(%r8,%rdx,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,121,126,76,144,16            // vmovd         %xmm9,0x10(%r8,%rdx,4)
  .byte  196,65,122,127,4,144                // vmovdqu       %xmm8,(%r8,%rdx,4)
  .byte  235,85                              // jmp           2da14 <_sk_store_8888_hsw_lowp+0x12c>
  .byte  196,67,121,22,76,144,40,2           // vpextrd       $0x2,%xmm9,0x28(%r8,%rdx,4)
  .byte  196,67,121,22,76,144,36,1           // vpextrd       $0x1,%xmm9,0x24(%r8,%rdx,4)
  .byte  196,65,121,126,76,144,32            // vmovd         %xmm9,0x20(%r8,%rdx,4)
  .byte  196,65,126,127,4,144                // vmovdqu       %ymm8,(%r8,%rdx,4)
  .byte  235,54                              // jmp           2da14 <_sk_store_8888_hsw_lowp+0x12c>
  .byte  196,67,125,57,202,1                 // vextracti128  $0x1,%ymm9,%xmm10
  .byte  196,67,121,22,84,144,56,2           // vpextrd       $0x2,%xmm10,0x38(%r8,%rdx,4)
  .byte  196,67,125,57,202,1                 // vextracti128  $0x1,%ymm9,%xmm10
  .byte  196,67,121,22,84,144,52,1           // vpextrd       $0x1,%xmm10,0x34(%r8,%rdx,4)
  .byte  196,67,125,57,202,1                 // vextracti128  $0x1,%ymm9,%xmm10
  .byte  196,65,121,126,84,144,48            // vmovd         %xmm10,0x30(%r8,%rdx,4)
  .byte  196,65,126,127,4,144                // vmovdqu       %ymm8,(%r8,%rdx,4)
  .byte  196,65,122,127,76,144,32            // vmovdqu       %xmm9,0x20(%r8,%rdx,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  70,255                              // rex.RX        (bad)
  .byte  255                                 // (bad)
  .byte  255,107,255                         // ljmp          *-0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,99,255                          // jmpq          *-0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,159,255,255,255,146             // lcall         *-0x6d000001(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,132,255,255,255,118,255         // incl          -0x890001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  190,255,255,255,183                 // mov           $0xb7ffffff,%esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,175,255,255,255,167             // ljmp          *-0x58000001(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  239                                 // out           %eax,(%dx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,226                             // jmpq          *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,212                             // callq         *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,198                             // inc           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_bgra_hsw_lowp
.globl _sk_load_bgra_hsw_lowp
FUNCTION(_sk_load_bgra_hsw_lowp)
_sk_load_bgra_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,55                              // ja            2daa6 <_sk_load_bgra_hsw_lowp+0x52>
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,163,1,0,0                 // lea           0x1a3(%rip),%r9        # 2dc20 <_sk_load_bgra_hsw_lowp+0x1cc>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  197,237,239,210                     // vpxor         %ymm2,%ymm2,%ymm2
  .byte  196,65,61,239,192                   // vpxor         %ymm8,%ymm8,%ymm8
  .byte  197,229,239,219                     // vpxor         %ymm3,%ymm3,%ymm3
  .byte  255,224                             // jmpq          *%rax
  .byte  196,193,121,110,12,144              // vmovd         (%r8,%rdx,4),%xmm1
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  233,39,1,0,0                        // jmpq          2dbcd <_sk_load_bgra_hsw_lowp+0x179>
  .byte  196,193,126,111,12,144              // vmovdqu       (%r8,%rdx,4),%ymm1
  .byte  196,193,126,111,68,144,32           // vmovdqu       0x20(%r8,%rdx,4),%ymm0
  .byte  233,21,1,0,0                        // jmpq          2dbcd <_sk_load_bgra_hsw_lowp+0x179>
  .byte  196,193,121,110,68,144,8            // vmovd         0x8(%r8,%rdx,4),%xmm0
  .byte  196,226,121,89,192                  // vpbroadcastq  %xmm0,%xmm0
  .byte  197,229,239,219                     // vpxor         %ymm3,%ymm3,%ymm3
  .byte  196,227,101,2,192,4                 // vpblendd      $0x4,%ymm0,%ymm3,%ymm0
  .byte  196,194,121,53,12,144               // vpmovzxdq     (%r8,%rdx,4),%xmm1
  .byte  197,249,112,201,232                 // vpshufd       $0xe8,%xmm1,%xmm1
  .byte  196,227,125,2,201,3                 // vpblendd      $0x3,%ymm1,%ymm0,%ymm1
  .byte  197,253,111,195                     // vmovdqa       %ymm3,%ymm0
  .byte  233,229,0,0,0                       // jmpq          2dbcd <_sk_load_bgra_hsw_lowp+0x179>
  .byte  196,193,121,110,68,144,24           // vmovd         0x18(%r8,%rdx,4),%xmm0
  .byte  196,226,125,89,192                  // vpbroadcastq  %xmm0,%ymm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,227,117,2,192,64                // vpblendd      $0x40,%ymm0,%ymm1,%ymm0
  .byte  196,227,125,57,194,1                // vextracti128  $0x1,%ymm0,%xmm2
  .byte  196,195,105,34,84,144,20,1          // vpinsrd       $0x1,0x14(%r8,%rdx,4),%xmm2,%xmm2
  .byte  196,227,125,56,194,1                // vinserti128   $0x1,%xmm2,%ymm0,%ymm0
  .byte  197,253,111,209                     // vmovdqa       %ymm1,%ymm2
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,195,113,34,76,144,16,0          // vpinsrd       $0x0,0x10(%r8,%rdx,4),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  197,125,111,194                     // vmovdqa       %ymm2,%ymm8
  .byte  196,193,122,111,12,144              // vmovdqu       (%r8,%rdx,4),%xmm1
  .byte  196,227,117,2,200,240               // vpblendd      $0xf0,%ymm0,%ymm1,%ymm1
  .byte  197,125,127,192                     // vmovdqa       %ymm8,%ymm0
  .byte  233,138,0,0,0                       // jmpq          2dbcd <_sk_load_bgra_hsw_lowp+0x179>
  .byte  196,193,121,110,68,144,40           // vmovd         0x28(%r8,%rdx,4),%xmm0
  .byte  196,226,121,89,192                  // vpbroadcastq  %xmm0,%xmm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,227,117,2,192,4                 // vpblendd      $0x4,%ymm0,%ymm1,%ymm0
  .byte  196,195,121,34,76,144,36,1          // vpinsrd       $0x1,0x24(%r8,%rdx,4),%xmm0,%xmm1
  .byte  196,227,125,2,193,15                // vpblendd      $0xf,%ymm1,%ymm0,%ymm0
  .byte  196,193,121,110,76,144,32           // vmovd         0x20(%r8,%rdx,4),%xmm1
  .byte  196,227,125,2,193,1                 // vpblendd      $0x1,%ymm1,%ymm0,%ymm0
  .byte  196,193,126,111,12,144              // vmovdqu       (%r8,%rdx,4),%ymm1
  .byte  235,81                              // jmp           2dbcd <_sk_load_bgra_hsw_lowp+0x179>
  .byte  196,193,121,110,68,144,56           // vmovd         0x38(%r8,%rdx,4),%xmm0
  .byte  196,226,125,89,192                  // vpbroadcastq  %xmm0,%ymm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,227,117,2,192,64                // vpblendd      $0x40,%ymm0,%ymm1,%ymm0
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,195,113,34,76,144,52,1          // vpinsrd       $0x1,0x34(%r8,%rdx,4),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,195,113,34,76,144,48,0          // vpinsrd       $0x0,0x30(%r8,%rdx,4),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,193,126,111,12,144              // vmovdqu       (%r8,%rdx,4),%ymm1
  .byte  196,193,122,111,84,144,32           // vmovdqu       0x20(%r8,%rdx,4),%xmm2
  .byte  196,227,109,2,192,240               // vpblendd      $0xf0,%ymm0,%ymm2,%ymm0
  .byte  196,227,117,56,216,1                // vinserti128   $0x1,%xmm0,%ymm1,%ymm3
  .byte  196,227,117,70,192,49               // vperm2i128    $0x31,%ymm0,%ymm1,%ymm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  196,227,125,14,209,170              // vpblendw      $0xaa,%ymm1,%ymm0,%ymm2
  .byte  196,227,101,14,201,170              // vpblendw      $0xaa,%ymm1,%ymm3,%ymm1
  .byte  196,226,117,43,202                  // vpackusdw     %ymm2,%ymm1,%ymm1
  .byte  197,125,111,5,10,205,0,0            // vmovdqa       0xcd0a(%rip),%ymm8        # 3a900 <_sk_srcover_bgra_8888_sse2_lowp+0x998>
  .byte  196,193,117,219,208                 // vpand         %ymm8,%ymm1,%ymm2
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,253,114,208,16                  // vpsrld        $0x10,%ymm0,%ymm0
  .byte  197,229,114,211,16                  // vpsrld        $0x10,%ymm3,%ymm3
  .byte  196,226,101,43,216                  // vpackusdw     %ymm0,%ymm3,%ymm3
  .byte  196,193,101,219,192                 // vpand         %ymm8,%ymm3,%ymm0
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  119,254                             // ja            2dc20 <_sk_load_bgra_hsw_lowp+0x1cc>
  .byte  255                                 // (bad)
  .byte  255,174,254,255,255,152             // ljmp          *-0x67000002(%rsi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,14                              // decl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,246                             // push          %rsi
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  222,254                             // fdivrp        %st,%st(6)
  .byte  255                                 // (bad)
  .byte  255,200                             // dec           %eax
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,84,255,255                      // callq         *-0x1(%rdi,%rdi,8)
  .byte  255,71,255                          // incl          -0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  57,255                              // cmp           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,35                              // jmpq          *(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,154,255,255,255,134             // lcall         *-0x79000001(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,114,255                         // pushq         -0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,92,255,255                      // lcall         *-0x1(%rdi,%rdi,8)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_bgra_dst_hsw_lowp
.globl _sk_load_bgra_dst_hsw_lowp
FUNCTION(_sk_load_bgra_dst_hsw_lowp)
_sk_load_bgra_dst_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,55                              // ja            2dcae <_sk_load_bgra_dst_hsw_lowp+0x52>
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,163,1,0,0                 // lea           0x1a3(%rip),%r9        # 2de28 <_sk_load_bgra_dst_hsw_lowp+0x1cc>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  197,205,239,246                     // vpxor         %ymm6,%ymm6,%ymm6
  .byte  196,65,61,239,192                   // vpxor         %ymm8,%ymm8,%ymm8
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  255,224                             // jmpq          *%rax
  .byte  196,193,121,110,44,144              // vmovd         (%r8,%rdx,4),%xmm5
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  233,39,1,0,0                        // jmpq          2ddd5 <_sk_load_bgra_dst_hsw_lowp+0x179>
  .byte  196,193,126,111,44,144              // vmovdqu       (%r8,%rdx,4),%ymm5
  .byte  196,193,126,111,100,144,32          // vmovdqu       0x20(%r8,%rdx,4),%ymm4
  .byte  233,21,1,0,0                        // jmpq          2ddd5 <_sk_load_bgra_dst_hsw_lowp+0x179>
  .byte  196,193,121,110,100,144,8           // vmovd         0x8(%r8,%rdx,4),%xmm4
  .byte  196,226,121,89,228                  // vpbroadcastq  %xmm4,%xmm4
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  196,227,69,2,228,4                  // vpblendd      $0x4,%ymm4,%ymm7,%ymm4
  .byte  196,194,121,53,44,144               // vpmovzxdq     (%r8,%rdx,4),%xmm5
  .byte  197,249,112,237,232                 // vpshufd       $0xe8,%xmm5,%xmm5
  .byte  196,227,93,2,237,3                  // vpblendd      $0x3,%ymm5,%ymm4,%ymm5
  .byte  197,253,111,231                     // vmovdqa       %ymm7,%ymm4
  .byte  233,229,0,0,0                       // jmpq          2ddd5 <_sk_load_bgra_dst_hsw_lowp+0x179>
  .byte  196,193,121,110,100,144,24          // vmovd         0x18(%r8,%rdx,4),%xmm4
  .byte  196,226,125,89,228                  // vpbroadcastq  %xmm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,228,64                 // vpblendd      $0x40,%ymm4,%ymm5,%ymm4
  .byte  196,227,125,57,230,1                // vextracti128  $0x1,%ymm4,%xmm6
  .byte  196,195,73,34,116,144,20,1          // vpinsrd       $0x1,0x14(%r8,%rdx,4),%xmm6,%xmm6
  .byte  196,227,93,56,230,1                 // vinserti128   $0x1,%xmm6,%ymm4,%ymm4
  .byte  197,253,111,245                     // vmovdqa       %ymm5,%ymm6
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,195,81,34,108,144,16,0          // vpinsrd       $0x0,0x10(%r8,%rdx,4),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  197,125,111,198                     // vmovdqa       %ymm6,%ymm8
  .byte  196,193,122,111,44,144              // vmovdqu       (%r8,%rdx,4),%xmm5
  .byte  196,227,85,2,236,240                // vpblendd      $0xf0,%ymm4,%ymm5,%ymm5
  .byte  197,125,127,196                     // vmovdqa       %ymm8,%ymm4
  .byte  233,138,0,0,0                       // jmpq          2ddd5 <_sk_load_bgra_dst_hsw_lowp+0x179>
  .byte  196,193,121,110,100,144,40          // vmovd         0x28(%r8,%rdx,4),%xmm4
  .byte  196,226,121,89,228                  // vpbroadcastq  %xmm4,%xmm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,228,4                  // vpblendd      $0x4,%ymm4,%ymm5,%ymm4
  .byte  196,195,89,34,108,144,36,1          // vpinsrd       $0x1,0x24(%r8,%rdx,4),%xmm4,%xmm5
  .byte  196,227,93,2,229,15                 // vpblendd      $0xf,%ymm5,%ymm4,%ymm4
  .byte  196,193,121,110,108,144,32          // vmovd         0x20(%r8,%rdx,4),%xmm5
  .byte  196,227,93,2,229,1                  // vpblendd      $0x1,%ymm5,%ymm4,%ymm4
  .byte  196,193,126,111,44,144              // vmovdqu       (%r8,%rdx,4),%ymm5
  .byte  235,81                              // jmp           2ddd5 <_sk_load_bgra_dst_hsw_lowp+0x179>
  .byte  196,193,121,110,100,144,56          // vmovd         0x38(%r8,%rdx,4),%xmm4
  .byte  196,226,125,89,228                  // vpbroadcastq  %xmm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,228,64                 // vpblendd      $0x40,%ymm4,%ymm5,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,195,81,34,108,144,52,1          // vpinsrd       $0x1,0x34(%r8,%rdx,4),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,195,81,34,108,144,48,0          // vpinsrd       $0x0,0x30(%r8,%rdx,4),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,193,126,111,44,144              // vmovdqu       (%r8,%rdx,4),%ymm5
  .byte  196,193,122,111,116,144,32          // vmovdqu       0x20(%r8,%rdx,4),%xmm6
  .byte  196,227,77,2,228,240                // vpblendd      $0xf0,%ymm4,%ymm6,%ymm4
  .byte  196,227,85,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm5,%ymm7
  .byte  196,227,85,70,228,49                // vperm2i128    $0x31,%ymm4,%ymm5,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,93,14,245,170               // vpblendw      $0xaa,%ymm5,%ymm4,%ymm6
  .byte  196,227,69,14,237,170               // vpblendw      $0xaa,%ymm5,%ymm7,%ymm5
  .byte  196,226,85,43,238                   // vpackusdw     %ymm6,%ymm5,%ymm5
  .byte  197,125,111,5,34,203,0,0            // vmovdqa       0xcb22(%rip),%ymm8        # 3a920 <_sk_srcover_bgra_8888_sse2_lowp+0x9b8>
  .byte  196,193,85,219,240                  // vpand         %ymm8,%ymm5,%ymm6
  .byte  197,213,113,213,8                   // vpsrlw        $0x8,%ymm5,%ymm5
  .byte  197,221,114,212,16                  // vpsrld        $0x10,%ymm4,%ymm4
  .byte  197,197,114,215,16                  // vpsrld        $0x10,%ymm7,%ymm7
  .byte  196,226,69,43,252                   // vpackusdw     %ymm4,%ymm7,%ymm7
  .byte  196,193,69,219,224                  // vpand         %ymm8,%ymm7,%ymm4
  .byte  197,197,113,215,8                   // vpsrlw        $0x8,%ymm7,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  119,254                             // ja            2de28 <_sk_load_bgra_dst_hsw_lowp+0x1cc>
  .byte  255                                 // (bad)
  .byte  255,174,254,255,255,152             // ljmp          *-0x67000002(%rsi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,14                              // decl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,246                             // push          %rsi
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  222,254                             // fdivrp        %st,%st(6)
  .byte  255                                 // (bad)
  .byte  255,200                             // dec           %eax
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,84,255,255                      // callq         *-0x1(%rdi,%rdi,8)
  .byte  255,71,255                          // incl          -0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  57,255                              // cmp           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,35                              // jmpq          *(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,154,255,255,255,134             // lcall         *-0x79000001(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,114,255                         // pushq         -0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,92,255,255                      // lcall         *-0x1(%rdi,%rdi,8)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_bgra_hsw_lowp
.globl _sk_store_bgra_hsw_lowp
FUNCTION(_sk_store_bgra_hsw_lowp)
_sk_store_bgra_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  197,189,113,241,8                   // vpsllw        $0x8,%ymm1,%ymm8
  .byte  197,61,235,194                      // vpor          %ymm2,%ymm8,%ymm8
  .byte  196,66,125,51,200                   // vpmovzxwd     %xmm8,%ymm9
  .byte  196,67,125,57,192,1                 // vextracti128  $0x1,%ymm8,%xmm8
  .byte  196,66,125,51,208                   // vpmovzxwd     %xmm8,%ymm10
  .byte  197,189,113,243,8                   // vpsllw        $0x8,%ymm3,%ymm8
  .byte  197,61,235,192                      // vpor          %ymm0,%ymm8,%ymm8
  .byte  196,67,125,57,195,1                 // vextracti128  $0x1,%ymm8,%xmm11
  .byte  196,66,125,51,219                   // vpmovzxwd     %xmm11,%ymm11
  .byte  196,66,125,51,192                   // vpmovzxwd     %xmm8,%ymm8
  .byte  196,193,61,114,240,16               // vpslld        $0x10,%ymm8,%ymm8
  .byte  196,65,61,235,193                   // vpor          %ymm9,%ymm8,%ymm8
  .byte  196,193,53,114,243,16               // vpslld        $0x10,%ymm11,%ymm9
  .byte  196,65,53,235,202                   // vpor          %ymm10,%ymm9,%ymm9
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,30                              // ja            2dee5 <_sk_store_bgra_hsw_lowp+0x81>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,195,0,0,0                 // lea           0xc3(%rip),%r9        # 2df94 <_sk_store_bgra_hsw_lowp+0x130>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,121,126,4,144                // vmovd         %xmm8,(%r8,%rdx,4)
  .byte  233,171,0,0,0                       // jmpq          2df90 <_sk_store_bgra_hsw_lowp+0x12c>
  .byte  196,65,126,127,4,144                // vmovdqu       %ymm8,(%r8,%rdx,4)
  .byte  196,65,126,127,76,144,32            // vmovdqu       %ymm9,0x20(%r8,%rdx,4)
  .byte  233,153,0,0,0                       // jmpq          2df90 <_sk_store_bgra_hsw_lowp+0x12c>
  .byte  196,67,121,22,68,144,8,2            // vpextrd       $0x2,%xmm8,0x8(%r8,%rdx,4)
  .byte  196,65,121,214,4,144                // vmovq         %xmm8,(%r8,%rdx,4)
  .byte  233,134,0,0,0                       // jmpq          2df90 <_sk_store_bgra_hsw_lowp+0x12c>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,22,76,144,24,2           // vpextrd       $0x2,%xmm9,0x18(%r8,%rdx,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,22,76,144,20,1           // vpextrd       $0x1,%xmm9,0x14(%r8,%rdx,4)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,121,126,76,144,16            // vmovd         %xmm9,0x10(%r8,%rdx,4)
  .byte  196,65,122,127,4,144                // vmovdqu       %xmm8,(%r8,%rdx,4)
  .byte  235,85                              // jmp           2df90 <_sk_store_bgra_hsw_lowp+0x12c>
  .byte  196,67,121,22,76,144,40,2           // vpextrd       $0x2,%xmm9,0x28(%r8,%rdx,4)
  .byte  196,67,121,22,76,144,36,1           // vpextrd       $0x1,%xmm9,0x24(%r8,%rdx,4)
  .byte  196,65,121,126,76,144,32            // vmovd         %xmm9,0x20(%r8,%rdx,4)
  .byte  196,65,126,127,4,144                // vmovdqu       %ymm8,(%r8,%rdx,4)
  .byte  235,54                              // jmp           2df90 <_sk_store_bgra_hsw_lowp+0x12c>
  .byte  196,67,125,57,202,1                 // vextracti128  $0x1,%ymm9,%xmm10
  .byte  196,67,121,22,84,144,56,2           // vpextrd       $0x2,%xmm10,0x38(%r8,%rdx,4)
  .byte  196,67,125,57,202,1                 // vextracti128  $0x1,%ymm9,%xmm10
  .byte  196,67,121,22,84,144,52,1           // vpextrd       $0x1,%xmm10,0x34(%r8,%rdx,4)
  .byte  196,67,125,57,202,1                 // vextracti128  $0x1,%ymm9,%xmm10
  .byte  196,65,121,126,84,144,48            // vmovd         %xmm10,0x30(%r8,%rdx,4)
  .byte  196,65,126,127,4,144                // vmovdqu       %ymm8,(%r8,%rdx,4)
  .byte  196,65,122,127,76,144,32            // vmovdqu       %xmm9,0x20(%r8,%rdx,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  70,255                              // rex.RX        (bad)
  .byte  255                                 // (bad)
  .byte  255,107,255                         // ljmp          *-0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,99,255                          // jmpq          *-0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,159,255,255,255,146             // lcall         *-0x6d000001(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,132,255,255,255,118,255         // incl          -0x890001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  190,255,255,255,183                 // mov           $0xb7ffffff,%esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,175,255,255,255,167             // ljmp          *-0x58000001(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  239                                 // out           %eax,(%dx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,226                             // jmpq          *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,212                             // callq         *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,198                             // inc           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_8888_hsw_lowp
.globl _sk_gather_8888_hsw_lowp
FUNCTION(_sk_gather_8888_hsw_lowp)
_sk_gather_8888_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,88,64,12                 // vpbroadcastd  0xc(%rax),%ymm8
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,65,61,254,193                   // vpaddd        %ymm9,%ymm8,%ymm8
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,193,124,95,194                  // vmaxps        %ymm10,%ymm0,%ymm0
  .byte  196,193,116,95,202                  // vmaxps        %ymm10,%ymm1,%ymm1
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,88,64,16                 // vpbroadcastd  0x10(%rax),%ymm8
  .byte  196,65,61,254,193                   // vpaddd        %ymm9,%ymm8,%ymm8
  .byte  196,193,100,95,218                  // vmaxps        %ymm10,%ymm3,%ymm3
  .byte  196,193,108,95,210                  // vmaxps        %ymm10,%ymm2,%ymm2
  .byte  196,193,108,93,208                  // vminps        %ymm8,%ymm2,%ymm2
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,219                      // vcvttps2dq    %ymm3,%ymm3
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,98,125,88,64,8                  // vpbroadcastd  0x8(%rax),%ymm8
  .byte  196,226,61,64,210                   // vpmulld       %ymm2,%ymm8,%ymm2
  .byte  196,226,61,64,219                   // vpmulld       %ymm3,%ymm8,%ymm3
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,237,254,192                     // vpaddd        %ymm0,%ymm2,%ymm0
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  197,229,254,201                     // vpaddd        %ymm1,%ymm3,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,229,239,219                     // vpxor         %ymm3,%ymm3,%ymm3
  .byte  196,194,109,144,28,128              // vpgatherdd    %ymm2,(%r8,%ymm0,4),%ymm3
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  196,194,53,144,4,136                // vpgatherdd    %ymm9,(%r8,%ymm1,4),%ymm0
  .byte  196,227,101,56,208,1                // vinserti128   $0x1,%xmm0,%ymm3,%ymm2
  .byte  196,227,101,70,216,49               // vperm2i128    $0x31,%ymm0,%ymm3,%ymm3
  .byte  196,195,101,14,194,170              // vpblendw      $0xaa,%ymm10,%ymm3,%ymm0
  .byte  196,195,109,14,202,170              // vpblendw      $0xaa,%ymm10,%ymm2,%ymm1
  .byte  196,226,117,43,200                  // vpackusdw     %ymm0,%ymm1,%ymm1
  .byte  197,125,111,5,190,200,0,0           // vmovdqa       0xc8be(%rip),%ymm8        # 3a940 <_sk_srcover_bgra_8888_sse2_lowp+0x9d8>
  .byte  196,193,117,219,192                 // vpand         %ymm8,%ymm1,%ymm0
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,229,114,211,16                  // vpsrld        $0x10,%ymm3,%ymm3
  .byte  197,237,114,210,16                  // vpsrld        $0x10,%ymm2,%ymm2
  .byte  196,226,109,43,219                  // vpackusdw     %ymm3,%ymm2,%ymm3
  .byte  196,193,101,219,208                 // vpand         %ymm8,%ymm3,%ymm2
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gather_bgra_hsw_lowp
.globl _sk_gather_bgra_hsw_lowp
FUNCTION(_sk_gather_bgra_hsw_lowp)
_sk_gather_bgra_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,88,64,12                 // vpbroadcastd  0xc(%rax),%ymm8
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,65,61,254,193                   // vpaddd        %ymm9,%ymm8,%ymm8
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,193,124,95,194                  // vmaxps        %ymm10,%ymm0,%ymm0
  .byte  196,193,116,95,202                  // vmaxps        %ymm10,%ymm1,%ymm1
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,88,64,16                 // vpbroadcastd  0x10(%rax),%ymm8
  .byte  196,65,61,254,193                   // vpaddd        %ymm9,%ymm8,%ymm8
  .byte  196,193,100,95,218                  // vmaxps        %ymm10,%ymm3,%ymm3
  .byte  196,193,108,95,210                  // vmaxps        %ymm10,%ymm2,%ymm2
  .byte  196,193,108,93,208                  // vminps        %ymm8,%ymm2,%ymm2
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,219                      // vcvttps2dq    %ymm3,%ymm3
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,98,125,88,64,8                  // vpbroadcastd  0x8(%rax),%ymm8
  .byte  196,226,61,64,210                   // vpmulld       %ymm2,%ymm8,%ymm2
  .byte  196,226,61,64,219                   // vpmulld       %ymm3,%ymm8,%ymm3
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,237,254,192                     // vpaddd        %ymm0,%ymm2,%ymm0
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  197,229,254,201                     // vpaddd        %ymm1,%ymm3,%ymm1
  .byte  197,237,118,210                     // vpcmpeqd      %ymm2,%ymm2,%ymm2
  .byte  197,229,239,219                     // vpxor         %ymm3,%ymm3,%ymm3
  .byte  196,194,109,144,28,128              // vpgatherdd    %ymm2,(%r8,%ymm0,4),%ymm3
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  196,194,53,144,4,136                // vpgatherdd    %ymm9,(%r8,%ymm1,4),%ymm0
  .byte  196,99,101,56,192,1                 // vinserti128   $0x1,%xmm0,%ymm3,%ymm8
  .byte  196,227,101,70,192,49               // vperm2i128    $0x31,%ymm0,%ymm3,%ymm0
  .byte  196,195,125,14,202,170              // vpblendw      $0xaa,%ymm10,%ymm0,%ymm1
  .byte  196,195,61,14,210,170               // vpblendw      $0xaa,%ymm10,%ymm8,%ymm2
  .byte  196,226,109,43,201                  // vpackusdw     %ymm1,%ymm2,%ymm1
  .byte  197,253,111,29,5,200,0,0            // vmovdqa       0xc805(%rip),%ymm3        # 3a960 <_sk_srcover_bgra_8888_sse2_lowp+0x9f8>
  .byte  197,245,219,211                     // vpand         %ymm3,%ymm1,%ymm2
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,253,114,208,16                  // vpsrld        $0x10,%ymm0,%ymm0
  .byte  196,193,61,114,208,16               // vpsrld        $0x10,%ymm8,%ymm8
  .byte  196,98,61,43,192                    // vpackusdw     %ymm0,%ymm8,%ymm8
  .byte  197,189,219,195                     // vpand         %ymm3,%ymm8,%ymm0
  .byte  196,193,101,113,208,8               // vpsrlw        $0x8,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_565_hsw_lowp
.globl _sk_load_565_hsw_lowp
FUNCTION(_sk_load_565_hsw_lowp)
_sk_load_565_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,37                              // ja            2e1c1 <_sk_load_565_hsw_lowp+0x3f>
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,130,1,0,0                 // lea           0x182(%rip),%r9        # 2e32c <_sk_load_565_hsw_lowp+0x1aa>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  233,8,1,0,0                         // jmpq          2e2c9 <_sk_load_565_hsw_lowp+0x147>
  .byte  196,193,126,111,4,80                // vmovdqu       (%r8,%rdx,2),%ymm0
  .byte  233,253,0,0,0                       // jmpq          2e2c9 <_sk_load_565_hsw_lowp+0x147>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,193,121,196,76,80,4,2           // vpinsrw       $0x2,0x4(%r8,%rdx,2),%xmm0,%xmm1
  .byte  196,227,117,56,192,1                // vinserti128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  196,193,121,110,12,80               // vmovd         (%r8,%rdx,2),%xmm1
  .byte  196,227,125,2,193,1                 // vpblendd      $0x1,%ymm1,%ymm0,%ymm0
  .byte  233,218,0,0,0                       // jmpq          2e2c9 <_sk_load_565_hsw_lowp+0x147>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,193,121,196,76,80,12,6          // vpinsrw       $0x6,0xc(%r8,%rdx,2),%xmm0,%xmm1
  .byte  196,227,117,56,192,1                // vinserti128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  196,193,121,196,76,80,10,5          // vpinsrw       $0x5,0xa(%r8,%rdx,2),%xmm0,%xmm1
  .byte  196,227,125,2,193,15                // vpblendd      $0xf,%ymm1,%ymm0,%ymm0
  .byte  196,193,121,196,76,80,8,4           // vpinsrw       $0x4,0x8(%r8,%rdx,2),%xmm0,%xmm1
  .byte  196,227,125,2,193,15                // vpblendd      $0xf,%ymm1,%ymm0,%ymm0
  .byte  196,193,122,126,12,80               // vmovq         (%r8,%rdx,2),%xmm1
  .byte  196,227,125,2,193,3                 // vpblendd      $0x3,%ymm1,%ymm0,%ymm0
  .byte  233,155,0,0,0                       // jmpq          2e2c9 <_sk_load_565_hsw_lowp+0x147>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,193,121,196,76,80,20,2          // vpinsrw       $0x2,0x14(%r8,%rdx,2),%xmm0,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,193,113,196,76,80,18,1          // vpinsrw       $0x1,0x12(%r8,%rdx,2),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,193,113,196,76,80,16,0          // vpinsrw       $0x0,0x10(%r8,%rdx,2),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,193,122,111,12,80               // vmovdqu       (%r8,%rdx,2),%xmm1
  .byte  196,227,117,2,192,240               // vpblendd      $0xf0,%ymm0,%ymm1,%ymm0
  .byte  235,83                              // jmp           2e2c9 <_sk_load_565_hsw_lowp+0x147>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,193,121,196,76,80,28,6          // vpinsrw       $0x6,0x1c(%r8,%rdx,2),%xmm0,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,193,113,196,76,80,26,5          // vpinsrw       $0x5,0x1a(%r8,%rdx,2),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,193,113,196,76,80,24,4          // vpinsrw       $0x4,0x18(%r8,%rdx,2),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,193,122,126,76,80,16            // vmovq         0x10(%r8,%rdx,2),%xmm1
  .byte  196,193,122,111,20,80               // vmovdqu       (%r8,%rdx,2),%xmm2
  .byte  196,227,109,56,201,1                // vinserti128   $0x1,%xmm1,%ymm2,%ymm1
  .byte  196,227,117,2,192,192               // vpblendd      $0xc0,%ymm0,%ymm1,%ymm0
  .byte  196,226,125,121,13,174,198,0,0      // vpbroadcastw  0xc6ae(%rip),%ymm1        # 3a980 <_sk_srcover_bgra_8888_sse2_lowp+0xa18>
  .byte  197,237,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm2
  .byte  197,237,219,201                     // vpand         %ymm1,%ymm2,%ymm1
  .byte  197,237,113,208,5                   // vpsrlw        $0x5,%ymm0,%ymm2
  .byte  196,226,125,121,29,153,198,0,0      // vpbroadcastw  0xc699(%rip),%ymm3        # 3a982 <_sk_srcover_bgra_8888_sse2_lowp+0xa1a>
  .byte  197,237,219,211                     // vpand         %ymm3,%ymm2,%ymm2
  .byte  196,226,125,121,29,142,198,0,0      // vpbroadcastw  0xc68e(%rip),%ymm3        # 3a984 <_sk_srcover_bgra_8888_sse2_lowp+0xa1c>
  .byte  197,253,219,219                     // vpand         %ymm3,%ymm0,%ymm3
  .byte  197,253,113,208,13                  // vpsrlw        $0xd,%ymm0,%ymm0
  .byte  197,245,235,192                     // vpor          %ymm0,%ymm1,%ymm0
  .byte  197,245,113,242,2                   // vpsllw        $0x2,%ymm2,%ymm1
  .byte  197,237,113,210,4                   // vpsrlw        $0x4,%ymm2,%ymm2
  .byte  197,245,235,202                     // vpor          %ymm2,%ymm1,%ymm1
  .byte  197,237,113,243,3                   // vpsllw        $0x3,%ymm3,%ymm2
  .byte  197,229,113,211,2                   // vpsrlw        $0x2,%ymm3,%ymm3
  .byte  197,237,235,211                     // vpor          %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,121,29,92,198,0,0       // vpbroadcastw  0xc65c(%rip),%ymm3        # 3a986 <_sk_srcover_bgra_8888_sse2_lowp+0xa1e>
  .byte  255,224                             // jmpq          *%rax
  .byte  135,254                             // xchg          %edi,%esi
  .byte  255                                 // (bad)
  .byte  255,178,254,255,255,160             // pushq         -0x5f000002(%rdx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,241                             // push          %rcx
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,227                             // jmpq          *%rbx
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,213                             // callq         *%rbp
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,195                             // inc           %ebx
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  60,255                              // cmp           $0xff,%al
  .byte  255                                 // (bad)
  .byte  255,40                              // ljmp          *(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,20,255                          // callq         *(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,2                               // incl          (%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,132,255,255,255,112,255         // incl          -0x8f0001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,92,255,255                      // lcall         *-0x1(%rdi,%rdi,8)
  .byte  255,74,255                          // decl          -0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_565_dst_hsw_lowp
.globl _sk_load_565_dst_hsw_lowp
FUNCTION(_sk_load_565_dst_hsw_lowp)
_sk_load_565_dst_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,37                              // ja            2e3a7 <_sk_load_565_dst_hsw_lowp+0x3f>
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,132,1,0,0                 // lea           0x184(%rip),%r9        # 2e514 <_sk_load_565_dst_hsw_lowp+0x1ac>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  233,8,1,0,0                         // jmpq          2e4af <_sk_load_565_dst_hsw_lowp+0x147>
  .byte  196,193,126,111,36,80               // vmovdqu       (%r8,%rdx,2),%ymm4
  .byte  233,253,0,0,0                       // jmpq          2e4af <_sk_load_565_dst_hsw_lowp+0x147>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,193,89,196,108,80,4,2           // vpinsrw       $0x2,0x4(%r8,%rdx,2),%xmm4,%xmm5
  .byte  196,227,85,56,228,1                 // vinserti128   $0x1,%xmm4,%ymm5,%ymm4
  .byte  196,193,121,110,44,80               // vmovd         (%r8,%rdx,2),%xmm5
  .byte  196,227,93,2,229,1                  // vpblendd      $0x1,%ymm5,%ymm4,%ymm4
  .byte  233,218,0,0,0                       // jmpq          2e4af <_sk_load_565_dst_hsw_lowp+0x147>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,193,89,196,108,80,12,6          // vpinsrw       $0x6,0xc(%r8,%rdx,2),%xmm4,%xmm5
  .byte  196,227,85,56,228,1                 // vinserti128   $0x1,%xmm4,%ymm5,%ymm4
  .byte  196,193,89,196,108,80,10,5          // vpinsrw       $0x5,0xa(%r8,%rdx,2),%xmm4,%xmm5
  .byte  196,227,93,2,229,15                 // vpblendd      $0xf,%ymm5,%ymm4,%ymm4
  .byte  196,193,89,196,108,80,8,4           // vpinsrw       $0x4,0x8(%r8,%rdx,2),%xmm4,%xmm5
  .byte  196,227,93,2,229,15                 // vpblendd      $0xf,%ymm5,%ymm4,%ymm4
  .byte  196,193,122,126,44,80               // vmovq         (%r8,%rdx,2),%xmm5
  .byte  196,227,93,2,229,3                  // vpblendd      $0x3,%ymm5,%ymm4,%ymm4
  .byte  233,155,0,0,0                       // jmpq          2e4af <_sk_load_565_dst_hsw_lowp+0x147>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,193,89,196,108,80,20,2          // vpinsrw       $0x2,0x14(%r8,%rdx,2),%xmm4,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,193,81,196,108,80,18,1          // vpinsrw       $0x1,0x12(%r8,%rdx,2),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,193,81,196,108,80,16,0          // vpinsrw       $0x0,0x10(%r8,%rdx,2),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,193,122,111,44,80               // vmovdqu       (%r8,%rdx,2),%xmm5
  .byte  196,227,85,2,228,240                // vpblendd      $0xf0,%ymm4,%ymm5,%ymm4
  .byte  235,83                              // jmp           2e4af <_sk_load_565_dst_hsw_lowp+0x147>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,193,89,196,108,80,28,6          // vpinsrw       $0x6,0x1c(%r8,%rdx,2),%xmm4,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,193,81,196,108,80,26,5          // vpinsrw       $0x5,0x1a(%r8,%rdx,2),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,193,81,196,108,80,24,4          // vpinsrw       $0x4,0x18(%r8,%rdx,2),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,193,122,126,108,80,16           // vmovq         0x10(%r8,%rdx,2),%xmm5
  .byte  196,193,122,111,52,80               // vmovdqu       (%r8,%rdx,2),%xmm6
  .byte  196,227,77,56,237,1                 // vinserti128   $0x1,%xmm5,%ymm6,%ymm5
  .byte  196,227,85,2,228,192                // vpblendd      $0xc0,%ymm4,%ymm5,%ymm4
  .byte  196,226,125,121,45,208,196,0,0      // vpbroadcastw  0xc4d0(%rip),%ymm5        # 3a988 <_sk_srcover_bgra_8888_sse2_lowp+0xa20>
  .byte  197,205,113,212,8                   // vpsrlw        $0x8,%ymm4,%ymm6
  .byte  197,205,219,237                     // vpand         %ymm5,%ymm6,%ymm5
  .byte  197,205,113,212,5                   // vpsrlw        $0x5,%ymm4,%ymm6
  .byte  196,226,125,121,61,187,196,0,0      // vpbroadcastw  0xc4bb(%rip),%ymm7        # 3a98a <_sk_srcover_bgra_8888_sse2_lowp+0xa22>
  .byte  197,205,219,247                     // vpand         %ymm7,%ymm6,%ymm6
  .byte  196,226,125,121,61,176,196,0,0      // vpbroadcastw  0xc4b0(%rip),%ymm7        # 3a98c <_sk_srcover_bgra_8888_sse2_lowp+0xa24>
  .byte  197,221,219,255                     // vpand         %ymm7,%ymm4,%ymm7
  .byte  197,221,113,212,13                  // vpsrlw        $0xd,%ymm4,%ymm4
  .byte  197,213,235,228                     // vpor          %ymm4,%ymm5,%ymm4
  .byte  197,213,113,246,2                   // vpsllw        $0x2,%ymm6,%ymm5
  .byte  197,205,113,214,4                   // vpsrlw        $0x4,%ymm6,%ymm6
  .byte  197,213,235,238                     // vpor          %ymm6,%ymm5,%ymm5
  .byte  197,205,113,247,3                   // vpsllw        $0x3,%ymm7,%ymm6
  .byte  197,197,113,215,2                   // vpsrlw        $0x2,%ymm7,%ymm7
  .byte  197,205,235,247                     // vpor          %ymm7,%ymm6,%ymm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,121,61,126,196,0,0      // vpbroadcastw  0xc47e(%rip),%ymm7        # 3a98e <_sk_srcover_bgra_8888_sse2_lowp+0xa26>
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  133,254                             // test          %edi,%esi
  .byte  255                                 // (bad)
  .byte  255,176,254,255,255,158             // pushq         -0x61000002(%rax)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  239                                 // out           %eax,(%dx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,225                             // jmpq          *%rcx
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,211                             // callq         *%rbx
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,193                             // inc           %ecx
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  58,255                              // cmp           %bh,%bh
  .byte  255                                 // (bad)
  .byte  255,38                              // jmpq          *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,18                              // callq         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,130,255,255,255,110             // incl          0x6effffff(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,90,255                          // lcall         *-0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,72,255                          // decl          -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_565_hsw_lowp
.globl _sk_store_565_hsw_lowp
FUNCTION(_sk_store_565_hsw_lowp)
_sk_store_565_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  196,98,125,121,5,39,196,0,0         // vpbroadcastw  0xc427(%rip),%ymm8        # 3a990 <_sk_srcover_bgra_8888_sse2_lowp+0xa28>
  .byte  197,181,113,240,8                   // vpsllw        $0x8,%ymm0,%ymm9
  .byte  196,65,53,219,192                   // vpand         %ymm8,%ymm9,%ymm8
  .byte  196,98,125,121,13,22,196,0,0        // vpbroadcastw  0xc416(%rip),%ymm9        # 3a992 <_sk_srcover_bgra_8888_sse2_lowp+0xa2a>
  .byte  197,173,113,241,3                   // vpsllw        $0x3,%ymm1,%ymm10
  .byte  196,65,45,219,201                   // vpand         %ymm9,%ymm10,%ymm9
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  197,181,113,210,3                   // vpsrlw        $0x3,%ymm2,%ymm9
  .byte  196,65,61,235,193                   // vpor          %ymm9,%ymm8,%ymm8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,31                              // ja            2e5be <_sk_store_565_hsw_lowp+0x6e>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,195,0,0,0                 // lea           0xc3(%rip),%r9        # 2e66c <_sk_store_565_hsw_lowp+0x11c>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,67,121,21,4,80,0                // vpextrw       $0x0,%xmm8,(%r8,%rdx,2)
  .byte  233,167,0,0,0                       // jmpq          2e665 <_sk_store_565_hsw_lowp+0x115>
  .byte  196,65,126,127,4,80                 // vmovdqu       %ymm8,(%r8,%rdx,2)
  .byte  233,156,0,0,0                       // jmpq          2e665 <_sk_store_565_hsw_lowp+0x115>
  .byte  196,67,121,21,68,80,4,2             // vpextrw       $0x2,%xmm8,0x4(%r8,%rdx,2)
  .byte  196,65,121,126,4,80                 // vmovd         %xmm8,(%r8,%rdx,2)
  .byte  233,137,0,0,0                       // jmpq          2e665 <_sk_store_565_hsw_lowp+0x115>
  .byte  196,67,121,21,68,80,12,6            // vpextrw       $0x6,%xmm8,0xc(%r8,%rdx,2)
  .byte  196,67,121,21,68,80,10,5            // vpextrw       $0x5,%xmm8,0xa(%r8,%rdx,2)
  .byte  196,67,121,21,68,80,8,4             // vpextrw       $0x4,%xmm8,0x8(%r8,%rdx,2)
  .byte  196,65,121,214,4,80                 // vmovq         %xmm8,(%r8,%rdx,2)
  .byte  235,105                             // jmp           2e665 <_sk_store_565_hsw_lowp+0x115>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,21,76,80,20,2            // vpextrw       $0x2,%xmm9,0x14(%r8,%rdx,2)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,21,76,80,18,1            // vpextrw       $0x1,%xmm9,0x12(%r8,%rdx,2)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,21,76,80,16,0            // vpextrw       $0x0,%xmm9,0x10(%r8,%rdx,2)
  .byte  235,55                              // jmp           2e65f <_sk_store_565_hsw_lowp+0x10f>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,21,76,80,28,6            // vpextrw       $0x6,%xmm9,0x1c(%r8,%rdx,2)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,21,76,80,26,5            // vpextrw       $0x5,%xmm9,0x1a(%r8,%rdx,2)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,21,76,80,24,4            // vpextrw       $0x4,%xmm9,0x18(%r8,%rdx,2)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,121,214,76,80,16             // vmovq         %xmm9,0x10(%r8,%rdx,2)
  .byte  196,65,122,127,4,80                 // vmovdqu       %xmm8,(%r8,%rdx,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  70,255                              // rex.RX        (bad)
  .byte  255                                 // (bad)
  .byte  255,101,255                         // jmpq          *-0x1(%rbp)
  .byte  255                                 // (bad)
  .byte  255,93,255                          // lcall         *-0x1(%rbp)
  .byte  255                                 // (bad)
  .byte  255,136,255,255,255,128             // decl          -0x7f000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  120,255                             // js            2e681 <_sk_store_565_hsw_lowp+0x131>
  .byte  255                                 // (bad)
  .byte  255,112,255                         // pushq         -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,243                             // push          %rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,172,255,255,255,158,255         // ljmp          *-0x610001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,144,255,255,255,230             // callq         *-0x19000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  216,255                             // fdivr         %st(7),%st
  .byte  255                                 // (bad)
  .byte  255,202                             // dec           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  188                                 // .byte         0xbc
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_565_hsw_lowp
.globl _sk_gather_565_hsw_lowp
FUNCTION(_sk_gather_565_hsw_lowp)
_sk_gather_565_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,88,64,12                 // vpbroadcastd  0xc(%rax),%ymm8
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,65,61,254,193                   // vpaddd        %ymm9,%ymm8,%ymm8
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,193,124,95,194                  // vmaxps        %ymm10,%ymm0,%ymm0
  .byte  196,193,116,95,202                  // vmaxps        %ymm10,%ymm1,%ymm1
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,88,64,16                 // vpbroadcastd  0x10(%rax),%ymm8
  .byte  196,65,61,254,193                   // vpaddd        %ymm9,%ymm8,%ymm8
  .byte  196,193,100,95,218                  // vmaxps        %ymm10,%ymm3,%ymm3
  .byte  196,193,108,95,210                  // vmaxps        %ymm10,%ymm2,%ymm2
  .byte  196,193,108,93,208                  // vminps        %ymm8,%ymm2,%ymm2
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,219                      // vcvttps2dq    %ymm3,%ymm3
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,98,125,88,64,8                  // vpbroadcastd  0x8(%rax),%ymm8
  .byte  196,226,61,64,210                   // vpmulld       %ymm2,%ymm8,%ymm2
  .byte  196,226,61,64,219                   // vpmulld       %ymm3,%ymm8,%ymm3
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,237,254,192                     // vpaddd        %ymm0,%ymm2,%ymm0
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  197,229,254,201                     // vpaddd        %ymm1,%ymm3,%ymm1
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,249,110,208                     // vmovd         %eax,%xmm2
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,183,4,72                      // movzwl        (%r8,%r9,2),%eax
  .byte  197,233,196,208,1                   // vpinsrw       $0x1,%eax,%xmm2,%xmm2
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,201,1                // vextracti128  $0x1,%ymm1,%xmm1
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,233,196,208,2                   // vpinsrw       $0x2,%eax,%xmm2,%xmm2
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  197,233,196,208,3                   // vpinsrw       $0x3,%eax,%xmm2,%xmm2
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,233,196,208,4                   // vpinsrw       $0x4,%eax,%xmm2,%xmm2
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,183,4,72                      // movzwl        (%r8,%r9,2),%eax
  .byte  197,233,196,200,5                   // vpinsrw       $0x5,%eax,%xmm2,%xmm1
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,241,196,200,6                   // vpinsrw       $0x6,%eax,%xmm1,%xmm1
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  197,241,196,200,7                   // vpinsrw       $0x7,%eax,%xmm1,%xmm1
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,249,110,208                     // vmovd         %eax,%xmm2
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,183,4,72                      // movzwl        (%r8,%r9,2),%eax
  .byte  197,233,196,208,1                   // vpinsrw       $0x1,%eax,%xmm2,%xmm2
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,233,196,208,2                   // vpinsrw       $0x2,%eax,%xmm2,%xmm2
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  197,233,196,208,3                   // vpinsrw       $0x3,%eax,%xmm2,%xmm2
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,233,196,208,4                   // vpinsrw       $0x4,%eax,%xmm2,%xmm2
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,183,4,72                      // movzwl        (%r8,%r9,2),%eax
  .byte  197,233,196,192,5                   // vpinsrw       $0x5,%eax,%xmm2,%xmm0
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,249,196,192,6                   // vpinsrw       $0x6,%eax,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  197,249,196,192,7                   // vpinsrw       $0x7,%eax,%xmm0,%xmm0
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,226,125,121,13,90,193,0,0       // vpbroadcastw  0xc15a(%rip),%ymm1        # 3a994 <_sk_srcover_bgra_8888_sse2_lowp+0xa2c>
  .byte  197,237,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm2
  .byte  197,237,219,201                     // vpand         %ymm1,%ymm2,%ymm1
  .byte  197,237,113,208,5                   // vpsrlw        $0x5,%ymm0,%ymm2
  .byte  196,226,125,121,29,69,193,0,0       // vpbroadcastw  0xc145(%rip),%ymm3        # 3a996 <_sk_srcover_bgra_8888_sse2_lowp+0xa2e>
  .byte  197,237,219,211                     // vpand         %ymm3,%ymm2,%ymm2
  .byte  196,226,125,121,29,58,193,0,0       // vpbroadcastw  0xc13a(%rip),%ymm3        # 3a998 <_sk_srcover_bgra_8888_sse2_lowp+0xa30>
  .byte  197,253,219,219                     // vpand         %ymm3,%ymm0,%ymm3
  .byte  197,253,113,208,13                  // vpsrlw        $0xd,%ymm0,%ymm0
  .byte  197,245,235,192                     // vpor          %ymm0,%ymm1,%ymm0
  .byte  197,245,113,242,2                   // vpsllw        $0x2,%ymm2,%ymm1
  .byte  197,237,113,210,4                   // vpsrlw        $0x4,%ymm2,%ymm2
  .byte  197,245,235,202                     // vpor          %ymm2,%ymm1,%ymm1
  .byte  197,237,113,243,3                   // vpsllw        $0x3,%ymm3,%ymm2
  .byte  197,229,113,211,2                   // vpsrlw        $0x2,%ymm3,%ymm3
  .byte  197,237,235,211                     // vpor          %ymm3,%ymm2,%ymm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,121,29,8,193,0,0        // vpbroadcastw  0xc108(%rip),%ymm3        # 3a99a <_sk_srcover_bgra_8888_sse2_lowp+0xa32>
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_4444_hsw_lowp
.globl _sk_load_4444_hsw_lowp
FUNCTION(_sk_load_4444_hsw_lowp)
_sk_load_4444_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,37                              // ja            2e8d3 <_sk_load_4444_hsw_lowp+0x3f>
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,112,1,0,0                 // lea           0x170(%rip),%r9        # 2ea2c <_sk_load_4444_hsw_lowp+0x198>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  233,8,1,0,0                         // jmpq          2e9db <_sk_load_4444_hsw_lowp+0x147>
  .byte  196,193,126,111,4,80                // vmovdqu       (%r8,%rdx,2),%ymm0
  .byte  233,253,0,0,0                       // jmpq          2e9db <_sk_load_4444_hsw_lowp+0x147>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,193,121,196,76,80,4,2           // vpinsrw       $0x2,0x4(%r8,%rdx,2),%xmm0,%xmm1
  .byte  196,227,117,56,192,1                // vinserti128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  196,193,121,110,12,80               // vmovd         (%r8,%rdx,2),%xmm1
  .byte  196,227,125,2,193,1                 // vpblendd      $0x1,%ymm1,%ymm0,%ymm0
  .byte  233,218,0,0,0                       // jmpq          2e9db <_sk_load_4444_hsw_lowp+0x147>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,193,121,196,76,80,12,6          // vpinsrw       $0x6,0xc(%r8,%rdx,2),%xmm0,%xmm1
  .byte  196,227,117,56,192,1                // vinserti128   $0x1,%xmm0,%ymm1,%ymm0
  .byte  196,193,121,196,76,80,10,5          // vpinsrw       $0x5,0xa(%r8,%rdx,2),%xmm0,%xmm1
  .byte  196,227,125,2,193,15                // vpblendd      $0xf,%ymm1,%ymm0,%ymm0
  .byte  196,193,121,196,76,80,8,4           // vpinsrw       $0x4,0x8(%r8,%rdx,2),%xmm0,%xmm1
  .byte  196,227,125,2,193,15                // vpblendd      $0xf,%ymm1,%ymm0,%ymm0
  .byte  196,193,122,126,12,80               // vmovq         (%r8,%rdx,2),%xmm1
  .byte  196,227,125,2,193,3                 // vpblendd      $0x3,%ymm1,%ymm0,%ymm0
  .byte  233,155,0,0,0                       // jmpq          2e9db <_sk_load_4444_hsw_lowp+0x147>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,193,121,196,76,80,20,2          // vpinsrw       $0x2,0x14(%r8,%rdx,2),%xmm0,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,193,113,196,76,80,18,1          // vpinsrw       $0x1,0x12(%r8,%rdx,2),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,193,113,196,76,80,16,0          // vpinsrw       $0x0,0x10(%r8,%rdx,2),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,193,122,111,12,80               // vmovdqu       (%r8,%rdx,2),%xmm1
  .byte  196,227,117,2,192,240               // vpblendd      $0xf0,%ymm0,%ymm1,%ymm0
  .byte  235,83                              // jmp           2e9db <_sk_load_4444_hsw_lowp+0x147>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,193,121,196,76,80,28,6          // vpinsrw       $0x6,0x1c(%r8,%rdx,2),%xmm0,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,193,113,196,76,80,26,5          // vpinsrw       $0x5,0x1a(%r8,%rdx,2),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,227,125,57,193,1                // vextracti128  $0x1,%ymm0,%xmm1
  .byte  196,193,113,196,76,80,24,4          // vpinsrw       $0x4,0x18(%r8,%rdx,2),%xmm1,%xmm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,193,122,126,76,80,16            // vmovq         0x10(%r8,%rdx,2),%xmm1
  .byte  196,193,122,111,20,80               // vmovdqu       (%r8,%rdx,2),%xmm2
  .byte  196,227,109,56,201,1                // vinserti128   $0x1,%xmm1,%ymm2,%ymm1
  .byte  196,227,117,2,192,192               // vpblendd      $0xc0,%ymm0,%ymm1,%ymm0
  .byte  197,245,113,208,12                  // vpsrlw        $0xc,%ymm0,%ymm1
  .byte  197,237,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm2
  .byte  196,226,125,121,29,174,191,0,0      // vpbroadcastw  0xbfae(%rip),%ymm3        # 3a99c <_sk_srcover_bgra_8888_sse2_lowp+0xa34>
  .byte  197,237,219,211                     // vpand         %ymm3,%ymm2,%ymm2
  .byte  197,189,113,208,4                   // vpsrlw        $0x4,%ymm0,%ymm8
  .byte  197,61,219,195                      // vpand         %ymm3,%ymm8,%ymm8
  .byte  197,253,219,219                     // vpand         %ymm3,%ymm0,%ymm3
  .byte  197,253,113,241,4                   // vpsllw        $0x4,%ymm1,%ymm0
  .byte  197,253,235,193                     // vpor          %ymm1,%ymm0,%ymm0
  .byte  197,245,113,242,4                   // vpsllw        $0x4,%ymm2,%ymm1
  .byte  197,245,235,202                     // vpor          %ymm2,%ymm1,%ymm1
  .byte  196,193,109,113,240,4               // vpsllw        $0x4,%ymm8,%ymm2
  .byte  196,193,109,235,208                 // vpor          %ymm8,%ymm2,%ymm2
  .byte  197,189,113,243,4                   // vpsllw        $0x4,%ymm3,%ymm8
  .byte  197,189,235,219                     // vpor          %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  153                                 // cltd
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,178,254,255,255,3               // pushq         0x3fffffe(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,245                             // push          %rbp
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,231                             // jmpq          *%rdi
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,213                             // callq         *%rbp
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,78,255                          // decl          -0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  58,255                              // cmp           %bh,%bh
  .byte  255                                 // (bad)
  .byte  255,38                              // jmpq          *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,20,255                          // callq         *(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,150,255,255,255,130             // callq         *-0x7d000001(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,110,255                         // ljmp          *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,92,255,255                      // lcall         *-0x1(%rdi,%rdi,8)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_4444_dst_hsw_lowp
.globl _sk_load_4444_dst_hsw_lowp
FUNCTION(_sk_load_4444_dst_hsw_lowp)
_sk_load_4444_dst_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,37                              // ja            2eaa7 <_sk_load_4444_dst_hsw_lowp+0x3f>
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,112,1,0,0                 // lea           0x170(%rip),%r9        # 2ec00 <_sk_load_4444_dst_hsw_lowp+0x198>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  233,8,1,0,0                         // jmpq          2ebaf <_sk_load_4444_dst_hsw_lowp+0x147>
  .byte  196,193,126,111,36,80               // vmovdqu       (%r8,%rdx,2),%ymm4
  .byte  233,253,0,0,0                       // jmpq          2ebaf <_sk_load_4444_dst_hsw_lowp+0x147>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,193,89,196,108,80,4,2           // vpinsrw       $0x2,0x4(%r8,%rdx,2),%xmm4,%xmm5
  .byte  196,227,85,56,228,1                 // vinserti128   $0x1,%xmm4,%ymm5,%ymm4
  .byte  196,193,121,110,44,80               // vmovd         (%r8,%rdx,2),%xmm5
  .byte  196,227,93,2,229,1                  // vpblendd      $0x1,%ymm5,%ymm4,%ymm4
  .byte  233,218,0,0,0                       // jmpq          2ebaf <_sk_load_4444_dst_hsw_lowp+0x147>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,193,89,196,108,80,12,6          // vpinsrw       $0x6,0xc(%r8,%rdx,2),%xmm4,%xmm5
  .byte  196,227,85,56,228,1                 // vinserti128   $0x1,%xmm4,%ymm5,%ymm4
  .byte  196,193,89,196,108,80,10,5          // vpinsrw       $0x5,0xa(%r8,%rdx,2),%xmm4,%xmm5
  .byte  196,227,93,2,229,15                 // vpblendd      $0xf,%ymm5,%ymm4,%ymm4
  .byte  196,193,89,196,108,80,8,4           // vpinsrw       $0x4,0x8(%r8,%rdx,2),%xmm4,%xmm5
  .byte  196,227,93,2,229,15                 // vpblendd      $0xf,%ymm5,%ymm4,%ymm4
  .byte  196,193,122,126,44,80               // vmovq         (%r8,%rdx,2),%xmm5
  .byte  196,227,93,2,229,3                  // vpblendd      $0x3,%ymm5,%ymm4,%ymm4
  .byte  233,155,0,0,0                       // jmpq          2ebaf <_sk_load_4444_dst_hsw_lowp+0x147>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,193,89,196,108,80,20,2          // vpinsrw       $0x2,0x14(%r8,%rdx,2),%xmm4,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,193,81,196,108,80,18,1          // vpinsrw       $0x1,0x12(%r8,%rdx,2),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,193,81,196,108,80,16,0          // vpinsrw       $0x0,0x10(%r8,%rdx,2),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,193,122,111,44,80               // vmovdqu       (%r8,%rdx,2),%xmm5
  .byte  196,227,85,2,228,240                // vpblendd      $0xf0,%ymm4,%ymm5,%ymm4
  .byte  235,83                              // jmp           2ebaf <_sk_load_4444_dst_hsw_lowp+0x147>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,193,89,196,108,80,28,6          // vpinsrw       $0x6,0x1c(%r8,%rdx,2),%xmm4,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,193,81,196,108,80,26,5          // vpinsrw       $0x5,0x1a(%r8,%rdx,2),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,193,81,196,108,80,24,4          // vpinsrw       $0x4,0x18(%r8,%rdx,2),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,193,122,126,108,80,16           // vmovq         0x10(%r8,%rdx,2),%xmm5
  .byte  196,193,122,111,52,80               // vmovdqu       (%r8,%rdx,2),%xmm6
  .byte  196,227,77,56,237,1                 // vinserti128   $0x1,%xmm5,%ymm6,%ymm5
  .byte  196,227,85,2,228,192                // vpblendd      $0xc0,%ymm4,%ymm5,%ymm4
  .byte  197,213,113,212,12                  // vpsrlw        $0xc,%ymm4,%ymm5
  .byte  197,205,113,212,8                   // vpsrlw        $0x8,%ymm4,%ymm6
  .byte  196,226,125,121,61,220,189,0,0      // vpbroadcastw  0xbddc(%rip),%ymm7        # 3a99e <_sk_srcover_bgra_8888_sse2_lowp+0xa36>
  .byte  197,205,219,247                     // vpand         %ymm7,%ymm6,%ymm6
  .byte  197,189,113,212,4                   // vpsrlw        $0x4,%ymm4,%ymm8
  .byte  197,61,219,199                      // vpand         %ymm7,%ymm8,%ymm8
  .byte  197,221,219,255                     // vpand         %ymm7,%ymm4,%ymm7
  .byte  197,221,113,245,4                   // vpsllw        $0x4,%ymm5,%ymm4
  .byte  197,221,235,229                     // vpor          %ymm5,%ymm4,%ymm4
  .byte  197,213,113,246,4                   // vpsllw        $0x4,%ymm6,%ymm5
  .byte  197,213,235,238                     // vpor          %ymm6,%ymm5,%ymm5
  .byte  196,193,77,113,240,4                // vpsllw        $0x4,%ymm8,%ymm6
  .byte  196,193,77,235,240                  // vpor          %ymm8,%ymm6,%ymm6
  .byte  197,189,113,247,4                   // vpsllw        $0x4,%ymm7,%ymm8
  .byte  197,189,235,255                     // vpor          %ymm7,%ymm8,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  153                                 // cltd
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,178,254,255,255,3               // pushq         0x3fffffe(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,245                             // push          %rbp
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,231                             // jmpq          *%rdi
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,213                             // callq         *%rbp
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,78,255                          // decl          -0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  58,255                              // cmp           %bh,%bh
  .byte  255                                 // (bad)
  .byte  255,38                              // jmpq          *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,20,255                          // callq         *(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,150,255,255,255,130             // callq         *-0x7d000001(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,110,255                         // ljmp          *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,92,255,255                      // lcall         *-0x1(%rdi,%rdi,8)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_4444_hsw_lowp
.globl _sk_store_4444_hsw_lowp
FUNCTION(_sk_store_4444_hsw_lowp)
_sk_store_4444_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  196,98,125,121,5,75,189,0,0         // vpbroadcastw  0xbd4b(%rip),%ymm8        # 3a9a0 <_sk_srcover_bgra_8888_sse2_lowp+0xa38>
  .byte  197,181,113,240,8                   // vpsllw        $0x8,%ymm0,%ymm9
  .byte  196,65,53,219,192                   // vpand         %ymm8,%ymm9,%ymm8
  .byte  197,181,113,241,4                   // vpsllw        $0x4,%ymm1,%ymm9
  .byte  197,53,219,13,84,189,0,0            // vpand         0xbd54(%rip),%ymm9,%ymm9        # 3a9c0 <_sk_srcover_bgra_8888_sse2_lowp+0xa58>
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  196,98,125,121,13,102,189,0,0       // vpbroadcastw  0xbd66(%rip),%ymm9        # 3a9e0 <_sk_srcover_bgra_8888_sse2_lowp+0xa78>
  .byte  196,65,109,219,201                  // vpand         %ymm9,%ymm2,%ymm9
  .byte  197,173,113,211,4                   // vpsrlw        $0x4,%ymm3,%ymm10
  .byte  196,65,53,235,202                   // vpor          %ymm10,%ymm9,%ymm9
  .byte  196,65,61,235,193                   // vpor          %ymm9,%ymm8,%ymm8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,31                              // ja            2ecb7 <_sk_store_4444_hsw_lowp+0x7b>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,194,0,0,0                 // lea           0xc2(%rip),%r9        # 2ed64 <_sk_store_4444_hsw_lowp+0x128>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,67,121,21,4,80,0                // vpextrw       $0x0,%xmm8,(%r8,%rdx,2)
  .byte  233,167,0,0,0                       // jmpq          2ed5e <_sk_store_4444_hsw_lowp+0x122>
  .byte  196,65,126,127,4,80                 // vmovdqu       %ymm8,(%r8,%rdx,2)
  .byte  233,156,0,0,0                       // jmpq          2ed5e <_sk_store_4444_hsw_lowp+0x122>
  .byte  196,67,121,21,68,80,4,2             // vpextrw       $0x2,%xmm8,0x4(%r8,%rdx,2)
  .byte  196,65,121,126,4,80                 // vmovd         %xmm8,(%r8,%rdx,2)
  .byte  233,137,0,0,0                       // jmpq          2ed5e <_sk_store_4444_hsw_lowp+0x122>
  .byte  196,67,121,21,68,80,12,6            // vpextrw       $0x6,%xmm8,0xc(%r8,%rdx,2)
  .byte  196,67,121,21,68,80,10,5            // vpextrw       $0x5,%xmm8,0xa(%r8,%rdx,2)
  .byte  196,67,121,21,68,80,8,4             // vpextrw       $0x4,%xmm8,0x8(%r8,%rdx,2)
  .byte  196,65,121,214,4,80                 // vmovq         %xmm8,(%r8,%rdx,2)
  .byte  235,105                             // jmp           2ed5e <_sk_store_4444_hsw_lowp+0x122>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,21,76,80,20,2            // vpextrw       $0x2,%xmm9,0x14(%r8,%rdx,2)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,21,76,80,18,1            // vpextrw       $0x1,%xmm9,0x12(%r8,%rdx,2)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,21,76,80,16,0            // vpextrw       $0x0,%xmm9,0x10(%r8,%rdx,2)
  .byte  235,55                              // jmp           2ed58 <_sk_store_4444_hsw_lowp+0x11c>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,21,76,80,28,6            // vpextrw       $0x6,%xmm9,0x1c(%r8,%rdx,2)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,21,76,80,26,5            // vpextrw       $0x5,%xmm9,0x1a(%r8,%rdx,2)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,21,76,80,24,4            // vpextrw       $0x4,%xmm9,0x18(%r8,%rdx,2)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,121,214,76,80,16             // vmovq         %xmm9,0x10(%r8,%rdx,2)
  .byte  196,65,122,127,4,80                 // vmovdqu       %xmm8,(%r8,%rdx,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  71,255                              // rex.RXB       (bad)
  .byte  255                                 // (bad)
  .byte  255,102,255                         // jmpq          *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,94,255                          // lcall         *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,137,255,255,255,129             // decl          -0x7e000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  121,255                             // jns           2ed79 <_sk_store_4444_hsw_lowp+0x13d>
  .byte  255                                 // (bad)
  .byte  255,113,255                         // pushq         -0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,244                             // push          %rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,173,255,255,255,159             // ljmp          *-0x60000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,145,255,255,255,231             // callq         *-0x18000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  217,255                             // fcos
  .byte  255                                 // (bad)
  .byte  255,203                             // dec           %ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  189                                 // .byte         0xbd
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_4444_hsw_lowp
.globl _sk_gather_4444_hsw_lowp
FUNCTION(_sk_gather_4444_hsw_lowp)
_sk_gather_4444_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,88,64,12                 // vpbroadcastd  0xc(%rax),%ymm8
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,65,61,254,193                   // vpaddd        %ymm9,%ymm8,%ymm8
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,193,124,95,194                  // vmaxps        %ymm10,%ymm0,%ymm0
  .byte  196,193,116,95,202                  // vmaxps        %ymm10,%ymm1,%ymm1
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,88,64,16                 // vpbroadcastd  0x10(%rax),%ymm8
  .byte  196,65,61,254,193                   // vpaddd        %ymm9,%ymm8,%ymm8
  .byte  196,193,100,95,218                  // vmaxps        %ymm10,%ymm3,%ymm3
  .byte  196,193,108,95,210                  // vmaxps        %ymm10,%ymm2,%ymm2
  .byte  196,193,108,93,208                  // vminps        %ymm8,%ymm2,%ymm2
  .byte  196,193,100,93,216                  // vminps        %ymm8,%ymm3,%ymm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,219                      // vcvttps2dq    %ymm3,%ymm3
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,98,125,88,64,8                  // vpbroadcastd  0x8(%rax),%ymm8
  .byte  196,226,61,64,210                   // vpmulld       %ymm2,%ymm8,%ymm2
  .byte  196,226,61,64,219                   // vpmulld       %ymm3,%ymm8,%ymm3
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,237,254,192                     // vpaddd        %ymm0,%ymm2,%ymm0
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  197,229,254,201                     // vpaddd        %ymm1,%ymm3,%ymm1
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,249,110,208                     // vmovd         %eax,%xmm2
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,183,4,72                      // movzwl        (%r8,%r9,2),%eax
  .byte  197,233,196,208,1                   // vpinsrw       $0x1,%eax,%xmm2,%xmm2
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,201,1                // vextracti128  $0x1,%ymm1,%xmm1
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,233,196,208,2                   // vpinsrw       $0x2,%eax,%xmm2,%xmm2
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  197,233,196,208,3                   // vpinsrw       $0x3,%eax,%xmm2,%xmm2
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,233,196,208,4                   // vpinsrw       $0x4,%eax,%xmm2,%xmm2
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,183,4,72                      // movzwl        (%r8,%r9,2),%eax
  .byte  197,233,196,200,5                   // vpinsrw       $0x5,%eax,%xmm2,%xmm1
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,241,196,200,6                   // vpinsrw       $0x6,%eax,%xmm1,%xmm1
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  197,241,196,200,7                   // vpinsrw       $0x7,%eax,%xmm1,%xmm1
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,249,110,208                     // vmovd         %eax,%xmm2
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,183,4,72                      // movzwl        (%r8,%r9,2),%eax
  .byte  197,233,196,208,1                   // vpinsrw       $0x1,%eax,%xmm2,%xmm2
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,233,196,208,2                   // vpinsrw       $0x2,%eax,%xmm2,%xmm2
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  197,233,196,208,3                   // vpinsrw       $0x3,%eax,%xmm2,%xmm2
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,233,196,208,4                   // vpinsrw       $0x4,%eax,%xmm2,%xmm2
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,183,4,72                      // movzwl        (%r8,%r9,2),%eax
  .byte  197,233,196,192,5                   // vpinsrw       $0x5,%eax,%xmm2,%xmm0
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  197,249,196,192,6                   // vpinsrw       $0x6,%eax,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  67,15,183,4,80                      // movzwl        (%r8,%r10,2),%eax
  .byte  197,249,196,192,7                   // vpinsrw       $0x7,%eax,%xmm0,%xmm0
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  197,245,113,208,12                  // vpsrlw        $0xc,%ymm0,%ymm1
  .byte  197,237,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm2
  .byte  196,226,125,121,29,166,186,0,0      // vpbroadcastw  0xbaa6(%rip),%ymm3        # 3a9e2 <_sk_srcover_bgra_8888_sse2_lowp+0xa7a>
  .byte  197,237,219,211                     // vpand         %ymm3,%ymm2,%ymm2
  .byte  197,189,113,208,4                   // vpsrlw        $0x4,%ymm0,%ymm8
  .byte  197,61,219,195                      // vpand         %ymm3,%ymm8,%ymm8
  .byte  197,253,219,219                     // vpand         %ymm3,%ymm0,%ymm3
  .byte  197,253,113,241,4                   // vpsllw        $0x4,%ymm1,%ymm0
  .byte  197,253,235,193                     // vpor          %ymm1,%ymm0,%ymm0
  .byte  197,245,113,242,4                   // vpsllw        $0x4,%ymm2,%ymm1
  .byte  197,245,235,202                     // vpor          %ymm2,%ymm1,%ymm1
  .byte  196,193,109,113,240,4               // vpsllw        $0x4,%ymm8,%ymm2
  .byte  196,193,109,235,208                 // vpor          %ymm8,%ymm2,%ymm2
  .byte  197,189,113,243,4                   // vpsllw        $0x4,%ymm3,%ymm8
  .byte  197,189,235,219                     // vpor          %ymm3,%ymm8,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_a8_hsw_lowp
.globl _sk_load_a8_hsw_lowp
FUNCTION(_sk_load_a8_hsw_lowp)
_sk_load_a8_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,37                              // ja            2efb3 <_sk_load_a8_hsw_lowp+0x3c>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,220,0,0,0                 // lea           0xdc(%rip),%r9        # 2f078 <_sk_load_a8_hsw_lowp+0x101>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  233,175,0,0,0                       // jmpq          2f062 <_sk_load_a8_hsw_lowp+0xeb>
  .byte  196,193,122,111,4,16                // vmovdqu       (%r8,%rdx,1),%xmm0
  .byte  233,164,0,0,0                       // jmpq          2f062 <_sk_load_a8_hsw_lowp+0xeb>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,195,121,32,68,16,2,2            // vpinsrb       $0x2,0x2(%r8,%rdx,1),%xmm0,%xmm0
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  197,249,110,200                     // vmovd         %eax,%xmm1
  .byte  196,227,121,14,193,1                // vpblendw      $0x1,%xmm1,%xmm0,%xmm0
  .byte  233,132,0,0,0                       // jmpq          2f062 <_sk_load_a8_hsw_lowp+0xeb>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,195,121,32,68,16,6,6            // vpinsrb       $0x6,0x6(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,195,121,32,68,16,5,5            // vpinsrb       $0x5,0x5(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,195,121,32,68,16,4,4            // vpinsrb       $0x4,0x4(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,193,121,110,12,16               // vmovd         (%r8,%rdx,1),%xmm1
  .byte  196,227,121,2,193,1                 // vpblendd      $0x1,%xmm1,%xmm0,%xmm0
  .byte  235,90                              // jmp           2f062 <_sk_load_a8_hsw_lowp+0xeb>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,195,121,32,68,16,10,10          // vpinsrb       $0xa,0xa(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,195,121,32,68,16,9,9            // vpinsrb       $0x9,0x9(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,195,121,32,68,16,8,8            // vpinsrb       $0x8,0x8(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,193,122,126,12,16               // vmovq         (%r8,%rdx,1),%xmm1
  .byte  196,227,113,2,192,12                // vpblendd      $0xc,%xmm0,%xmm1,%xmm0
  .byte  235,48                              // jmp           2f062 <_sk_load_a8_hsw_lowp+0xeb>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,195,121,32,68,16,14,14          // vpinsrb       $0xe,0xe(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,195,121,32,68,16,13,13          // vpinsrb       $0xd,0xd(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,195,121,32,68,16,12,12          // vpinsrb       $0xc,0xc(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,193,122,126,12,16               // vmovq         (%r8,%rdx,1),%xmm1
  .byte  196,195,113,34,76,16,8,2            // vpinsrd       $0x2,0x8(%r8,%rdx,1),%xmm1,%xmm1
  .byte  196,227,113,2,192,8                 // vpblendd      $0x8,%xmm0,%xmm1,%xmm0
  .byte  196,226,125,48,216                  // vpmovzxbw     %xmm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  255,224                             // jmpq          *%rax
  .byte  144                                 // nop
  .byte  45,255,255,255,82                   // sub           $0x52ffffff,%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,70,255                          // incl          -0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,130,255,255,255,122             // incl          0x7affffff(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,114,255                         // pushq         -0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,102,255                         // jmpq          *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,172,255,255,255,164,255         // ljmp          *-0x5b0001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,156,255,255,255,144,255         // lcall         *-0x6f0001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,214                             // callq         *%rsi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,206                             // dec           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,198                             // inc           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  186                                 // .byte         0xba
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_a8_dst_hsw_lowp
.globl _sk_load_a8_dst_hsw_lowp
FUNCTION(_sk_load_a8_dst_hsw_lowp)
_sk_load_a8_dst_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,37                              // ja            2f0f0 <_sk_load_a8_dst_hsw_lowp+0x3c>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,219,0,0,0                 // lea           0xdb(%rip),%r9        # 2f1b4 <_sk_load_a8_dst_hsw_lowp+0x100>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  233,175,0,0,0                       // jmpq          2f19f <_sk_load_a8_dst_hsw_lowp+0xeb>
  .byte  196,193,122,111,36,16               // vmovdqu       (%r8,%rdx,1),%xmm4
  .byte  233,164,0,0,0                       // jmpq          2f19f <_sk_load_a8_dst_hsw_lowp+0xeb>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,195,89,32,100,16,2,2            // vpinsrb       $0x2,0x2(%r8,%rdx,1),%xmm4,%xmm4
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  197,249,110,232                     // vmovd         %eax,%xmm5
  .byte  196,227,89,14,229,1                 // vpblendw      $0x1,%xmm5,%xmm4,%xmm4
  .byte  233,132,0,0,0                       // jmpq          2f19f <_sk_load_a8_dst_hsw_lowp+0xeb>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,195,89,32,100,16,6,6            // vpinsrb       $0x6,0x6(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,195,89,32,100,16,5,5            // vpinsrb       $0x5,0x5(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,195,89,32,100,16,4,4            // vpinsrb       $0x4,0x4(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,193,121,110,44,16               // vmovd         (%r8,%rdx,1),%xmm5
  .byte  196,227,89,2,229,1                  // vpblendd      $0x1,%xmm5,%xmm4,%xmm4
  .byte  235,90                              // jmp           2f19f <_sk_load_a8_dst_hsw_lowp+0xeb>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,195,89,32,100,16,10,10          // vpinsrb       $0xa,0xa(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,195,89,32,100,16,9,9            // vpinsrb       $0x9,0x9(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,195,89,32,100,16,8,8            // vpinsrb       $0x8,0x8(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,193,122,126,44,16               // vmovq         (%r8,%rdx,1),%xmm5
  .byte  196,227,81,2,228,12                 // vpblendd      $0xc,%xmm4,%xmm5,%xmm4
  .byte  235,48                              // jmp           2f19f <_sk_load_a8_dst_hsw_lowp+0xeb>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,195,89,32,100,16,14,14          // vpinsrb       $0xe,0xe(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,195,89,32,100,16,13,13          // vpinsrb       $0xd,0xd(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,195,89,32,100,16,12,12          // vpinsrb       $0xc,0xc(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,193,122,126,44,16               // vmovq         (%r8,%rdx,1),%xmm5
  .byte  196,195,81,34,108,16,8,2            // vpinsrd       $0x2,0x8(%r8,%rdx,1),%xmm5,%xmm5
  .byte  196,227,81,2,228,8                  // vpblendd      $0x8,%xmm4,%xmm5,%xmm4
  .byte  196,226,125,48,252                  // vpmovzxbw     %xmm4,%ymm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  255,224                             // jmpq          *%rax
  .byte  46,255                              // cs            (bad)
  .byte  255                                 // (bad)
  .byte  255,83,255                          // callq         *-0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,71,255                          // incl          -0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255,131,255,255,255,123             // incl          0x7bffffff(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,115,255                         // pushq         -0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,103,255                         // jmpq          *-0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255,173,255,255,255,165             // ljmp          *-0x5a000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,157,255,255,255,145             // lcall         *-0x6e000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,215                             // callq         *%rdi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,207                             // dec           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  187                                 // .byte         0xbb
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_a8_hsw_lowp
.globl _sk_store_a8_hsw_lowp
FUNCTION(_sk_store_a8_hsw_lowp)
_sk_store_a8_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  196,195,125,57,216,1                // vextracti128  $0x1,%ymm3,%xmm8
  .byte  197,121,111,13,53,192,0,0           // vmovdqa       0xc035(%rip),%xmm9        # 3b240 <_sk_srcover_bgra_8888_sse2_lowp+0x12d8>
  .byte  196,66,57,0,193                     // vpshufb       %xmm9,%xmm8,%xmm8
  .byte  196,66,97,0,201                     // vpshufb       %xmm9,%xmm3,%xmm9
  .byte  196,65,49,108,192                   // vpunpcklqdq   %xmm8,%xmm9,%xmm8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,28                              // ja            2f240 <_sk_store_a8_hsw_lowp+0x50>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,146,0,0,0                 // lea           0x92(%rip),%r9        # 2f2c0 <_sk_store_a8_hsw_lowp+0xd0>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,67,121,20,4,16,0                // vpextrb       $0x0,%xmm8,(%r8,%rdx,1)
  .byte  235,121                             // jmp           2f2b9 <_sk_store_a8_hsw_lowp+0xc9>
  .byte  196,65,122,127,4,16                 // vmovdqu       %xmm8,(%r8,%rdx,1)
  .byte  235,113                             // jmp           2f2b9 <_sk_store_a8_hsw_lowp+0xc9>
  .byte  196,67,121,20,68,16,2,2             // vpextrb       $0x2,%xmm8,0x2(%r8,%rdx,1)
  .byte  196,67,121,21,4,16,0                // vpextrw       $0x0,%xmm8,(%r8,%rdx,1)
  .byte  235,96                              // jmp           2f2b9 <_sk_store_a8_hsw_lowp+0xc9>
  .byte  196,67,121,20,68,16,6,6             // vpextrb       $0x6,%xmm8,0x6(%r8,%rdx,1)
  .byte  196,67,121,20,68,16,5,5             // vpextrb       $0x5,%xmm8,0x5(%r8,%rdx,1)
  .byte  196,67,121,20,68,16,4,4             // vpextrb       $0x4,%xmm8,0x4(%r8,%rdx,1)
  .byte  196,65,121,126,4,16                 // vmovd         %xmm8,(%r8,%rdx,1)
  .byte  235,64                              // jmp           2f2b9 <_sk_store_a8_hsw_lowp+0xc9>
  .byte  196,67,121,20,68,16,10,10           // vpextrb       $0xa,%xmm8,0xa(%r8,%rdx,1)
  .byte  196,67,121,20,68,16,9,9             // vpextrb       $0x9,%xmm8,0x9(%r8,%rdx,1)
  .byte  196,67,121,20,68,16,8,8             // vpextrb       $0x8,%xmm8,0x8(%r8,%rdx,1)
  .byte  235,32                              // jmp           2f2b3 <_sk_store_a8_hsw_lowp+0xc3>
  .byte  196,67,121,20,68,16,14,14           // vpextrb       $0xe,%xmm8,0xe(%r8,%rdx,1)
  .byte  196,67,121,20,68,16,13,13           // vpextrb       $0xd,%xmm8,0xd(%r8,%rdx,1)
  .byte  196,67,121,20,68,16,12,12           // vpextrb       $0xc,%xmm8,0xc(%r8,%rdx,1)
  .byte  196,67,121,22,68,16,8,2             // vpextrd       $0x2,%xmm8,0x8(%r8,%rdx,1)
  .byte  196,65,121,214,4,16                 // vmovq         %xmm8,(%r8,%rdx,1)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  119,255                             // ja            2f2c1 <_sk_store_a8_hsw_lowp+0xd1>
  .byte  255                                 // (bad)
  .byte  255,144,255,255,255,136             // callq         *-0x77000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,177,255,255,255,169             // pushq         -0x56000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,161,255,255,255,153             // jmpq          *-0x66000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,243                             // push          %rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,201                             // dec           %ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,193                             // inc           %ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  185,255,255,255,235                 // mov           $0xebffffff,%ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,227                             // jmpq          *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  219,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,211                             // callq         *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_a8_hsw_lowp
.globl _sk_gather_a8_hsw_lowp
FUNCTION(_sk_gather_a8_hsw_lowp)
_sk_gather_a8_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,88,64,12                 // vpbroadcastd  0xc(%rax),%ymm8
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,65,61,254,193                   // vpaddd        %ymm9,%ymm8,%ymm8
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,193,124,95,194                  // vmaxps        %ymm10,%ymm0,%ymm0
  .byte  196,193,116,95,202                  // vmaxps        %ymm10,%ymm1,%ymm1
  .byte  196,65,116,93,216                   // vminps        %ymm8,%ymm1,%ymm11
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,226,125,88,72,16                // vpbroadcastd  0x10(%rax),%ymm1
  .byte  196,193,117,254,201                 // vpaddd        %ymm9,%ymm1,%ymm1
  .byte  196,193,100,95,218                  // vmaxps        %ymm10,%ymm3,%ymm3
  .byte  196,193,108,95,210                  // vmaxps        %ymm10,%ymm2,%ymm2
  .byte  197,236,93,209                      // vminps        %ymm1,%ymm2,%ymm2
  .byte  197,228,93,201                      // vminps        %ymm1,%ymm3,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,226,125,88,88,8                 // vpbroadcastd  0x8(%rax),%ymm3
  .byte  196,226,101,64,210                  // vpmulld       %ymm2,%ymm3,%ymm2
  .byte  196,226,101,64,217                  // vpmulld       %ymm1,%ymm3,%ymm3
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,237,254,200                     // vpaddd        %ymm0,%ymm2,%ymm1
  .byte  196,193,126,91,195                  // vcvttps2dq    %ymm11,%ymm0
  .byte  197,229,254,192                     // vpaddd        %ymm0,%ymm3,%ymm0
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  197,249,110,208                     // vmovd         %eax,%xmm2
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,182,4,8                       // movzbl        (%r8,%r9,1),%eax
  .byte  196,227,105,32,208,1                // vpinsrb       $0x1,%eax,%xmm2,%xmm2
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,201,1                // vextracti128  $0x1,%ymm1,%xmm1
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,105,32,208,2                // vpinsrb       $0x2,%eax,%xmm2,%xmm2
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  196,227,105,32,208,3                // vpinsrb       $0x3,%eax,%xmm2,%xmm2
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,105,32,208,4                // vpinsrb       $0x4,%eax,%xmm2,%xmm2
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,182,4,8                       // movzbl        (%r8,%r9,1),%eax
  .byte  196,227,105,32,200,5                // vpinsrb       $0x5,%eax,%xmm2,%xmm1
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,113,32,200,6                // vpinsrb       $0x6,%eax,%xmm1,%xmm1
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  196,227,113,32,200,7                // vpinsrb       $0x7,%eax,%xmm1,%xmm1
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,113,32,200,8                // vpinsrb       $0x8,%eax,%xmm1,%xmm1
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,182,4,8                       // movzbl        (%r8,%r9,1),%eax
  .byte  196,227,113,32,200,9                // vpinsrb       $0x9,%eax,%xmm1,%xmm1
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,113,32,200,10               // vpinsrb       $0xa,%eax,%xmm1,%xmm1
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  196,227,113,32,200,11               // vpinsrb       $0xb,%eax,%xmm1,%xmm1
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,113,32,200,12               // vpinsrb       $0xc,%eax,%xmm1,%xmm1
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,182,4,8                       // movzbl        (%r8,%r9,1),%eax
  .byte  196,227,113,32,192,13               // vpinsrb       $0xd,%eax,%xmm1,%xmm0
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,121,32,192,14               // vpinsrb       $0xe,%eax,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  196,227,121,32,192,15               // vpinsrb       $0xf,%eax,%xmm0,%xmm0
  .byte  196,226,125,48,216                  // vpmovzxbw     %xmm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  197,237,239,210                     // vpxor         %ymm2,%ymm2,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_g8_hsw_lowp
.globl _sk_load_g8_hsw_lowp
FUNCTION(_sk_load_g8_hsw_lowp)
_sk_load_g8_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,37                              // ja            2f4df <_sk_load_g8_hsw_lowp+0x3c>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,224,0,0,0                 // lea           0xe0(%rip),%r9        # 2f5a8 <_sk_load_g8_hsw_lowp+0x105>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  197,249,110,192                     // vmovd         %eax,%xmm0
  .byte  233,175,0,0,0                       // jmpq          2f58e <_sk_load_g8_hsw_lowp+0xeb>
  .byte  196,193,122,111,4,16                // vmovdqu       (%r8,%rdx,1),%xmm0
  .byte  233,164,0,0,0                       // jmpq          2f58e <_sk_load_g8_hsw_lowp+0xeb>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,195,121,32,68,16,2,2            // vpinsrb       $0x2,0x2(%r8,%rdx,1),%xmm0,%xmm0
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  197,249,110,200                     // vmovd         %eax,%xmm1
  .byte  196,227,121,14,193,1                // vpblendw      $0x1,%xmm1,%xmm0,%xmm0
  .byte  233,132,0,0,0                       // jmpq          2f58e <_sk_load_g8_hsw_lowp+0xeb>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,195,121,32,68,16,6,6            // vpinsrb       $0x6,0x6(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,195,121,32,68,16,5,5            // vpinsrb       $0x5,0x5(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,195,121,32,68,16,4,4            // vpinsrb       $0x4,0x4(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,193,121,110,12,16               // vmovd         (%r8,%rdx,1),%xmm1
  .byte  196,227,121,2,193,1                 // vpblendd      $0x1,%xmm1,%xmm0,%xmm0
  .byte  235,90                              // jmp           2f58e <_sk_load_g8_hsw_lowp+0xeb>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,195,121,32,68,16,10,10          // vpinsrb       $0xa,0xa(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,195,121,32,68,16,9,9            // vpinsrb       $0x9,0x9(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,195,121,32,68,16,8,8            // vpinsrb       $0x8,0x8(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,193,122,126,12,16               // vmovq         (%r8,%rdx,1),%xmm1
  .byte  196,227,113,2,192,12                // vpblendd      $0xc,%xmm0,%xmm1,%xmm0
  .byte  235,48                              // jmp           2f58e <_sk_load_g8_hsw_lowp+0xeb>
  .byte  197,249,239,192                     // vpxor         %xmm0,%xmm0,%xmm0
  .byte  196,195,121,32,68,16,14,14          // vpinsrb       $0xe,0xe(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,195,121,32,68,16,13,13          // vpinsrb       $0xd,0xd(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,195,121,32,68,16,12,12          // vpinsrb       $0xc,0xc(%r8,%rdx,1),%xmm0,%xmm0
  .byte  196,193,122,126,12,16               // vmovq         (%r8,%rdx,1),%xmm1
  .byte  196,195,113,34,76,16,8,2            // vpinsrd       $0x2,0x8(%r8,%rdx,1),%xmm1,%xmm1
  .byte  196,227,113,2,192,8                 // vpblendd      $0x8,%xmm0,%xmm1,%xmm0
  .byte  196,226,125,48,192                  // vpmovzxbw     %xmm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,121,29,70,180,0,0       // vpbroadcastw  0xb446(%rip),%ymm3        # 3a9e4 <_sk_srcover_bgra_8888_sse2_lowp+0xa7c>
  .byte  197,253,111,200                     // vmovdqa       %ymm0,%ymm1
  .byte  197,253,111,208                     // vmovdqa       %ymm0,%ymm2
  .byte  255,224                             // jmpq          *%rax
  .byte  41,255                              // sub           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,78,255                          // decl          -0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,66,255                          // incl          -0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  126,255                             // jle           2f5b5 <_sk_load_g8_hsw_lowp+0x112>
  .byte  255                                 // (bad)
  .byte  255,118,255                         // pushq         -0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,110,255                         // ljmp          *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,98,255                          // jmpq          *-0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,168,255,255,255,160             // ljmp          *-0x5f000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,152,255,255,255,140             // lcall         *-0x73000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,202                             // dec           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,194                             // inc           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  182,255                             // mov           $0xff,%dh
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_g8_dst_hsw_lowp
.globl _sk_load_g8_dst_hsw_lowp
FUNCTION(_sk_load_g8_dst_hsw_lowp)
_sk_load_g8_dst_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,37                              // ja            2f620 <_sk_load_g8_dst_hsw_lowp+0x3c>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,227,0,0,0                 // lea           0xe3(%rip),%r9        # 2f6ec <_sk_load_g8_dst_hsw_lowp+0x108>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  197,249,110,224                     // vmovd         %eax,%xmm4
  .byte  233,175,0,0,0                       // jmpq          2f6cf <_sk_load_g8_dst_hsw_lowp+0xeb>
  .byte  196,193,122,111,36,16               // vmovdqu       (%r8,%rdx,1),%xmm4
  .byte  233,164,0,0,0                       // jmpq          2f6cf <_sk_load_g8_dst_hsw_lowp+0xeb>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,195,89,32,100,16,2,2            // vpinsrb       $0x2,0x2(%r8,%rdx,1),%xmm4,%xmm4
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  197,249,110,232                     // vmovd         %eax,%xmm5
  .byte  196,227,89,14,229,1                 // vpblendw      $0x1,%xmm5,%xmm4,%xmm4
  .byte  233,132,0,0,0                       // jmpq          2f6cf <_sk_load_g8_dst_hsw_lowp+0xeb>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,195,89,32,100,16,6,6            // vpinsrb       $0x6,0x6(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,195,89,32,100,16,5,5            // vpinsrb       $0x5,0x5(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,195,89,32,100,16,4,4            // vpinsrb       $0x4,0x4(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,193,121,110,44,16               // vmovd         (%r8,%rdx,1),%xmm5
  .byte  196,227,89,2,229,1                  // vpblendd      $0x1,%xmm5,%xmm4,%xmm4
  .byte  235,90                              // jmp           2f6cf <_sk_load_g8_dst_hsw_lowp+0xeb>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,195,89,32,100,16,10,10          // vpinsrb       $0xa,0xa(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,195,89,32,100,16,9,9            // vpinsrb       $0x9,0x9(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,195,89,32,100,16,8,8            // vpinsrb       $0x8,0x8(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,193,122,126,44,16               // vmovq         (%r8,%rdx,1),%xmm5
  .byte  196,227,81,2,228,12                 // vpblendd      $0xc,%xmm4,%xmm5,%xmm4
  .byte  235,48                              // jmp           2f6cf <_sk_load_g8_dst_hsw_lowp+0xeb>
  .byte  197,217,239,228                     // vpxor         %xmm4,%xmm4,%xmm4
  .byte  196,195,89,32,100,16,14,14          // vpinsrb       $0xe,0xe(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,195,89,32,100,16,13,13          // vpinsrb       $0xd,0xd(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,195,89,32,100,16,12,12          // vpinsrb       $0xc,0xc(%r8,%rdx,1),%xmm4,%xmm4
  .byte  196,193,122,126,44,16               // vmovq         (%r8,%rdx,1),%xmm5
  .byte  196,195,81,34,108,16,8,2            // vpinsrd       $0x2,0x8(%r8,%rdx,1),%xmm5,%xmm5
  .byte  196,227,81,2,228,8                  // vpblendd      $0x8,%xmm4,%xmm5,%xmm4
  .byte  196,226,125,48,228                  // vpmovzxbw     %xmm4,%ymm4
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,121,61,7,179,0,0        // vpbroadcastw  0xb307(%rip),%ymm7        # 3a9e6 <_sk_srcover_bgra_8888_sse2_lowp+0xa7e>
  .byte  197,253,111,236                     // vmovdqa       %ymm4,%ymm5
  .byte  197,253,111,244                     // vmovdqa       %ymm4,%ymm6
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  38,255                              // es            (bad)
  .byte  255                                 // (bad)
  .byte  255,75,255                          // decl          -0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  63                                  // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  123,255                             // jnp           2f6f9 <_sk_load_g8_dst_hsw_lowp+0x115>
  .byte  255                                 // (bad)
  .byte  255,115,255                         // pushq         -0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,107,255                         // ljmp          *-0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,95,255                          // lcall         *-0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255,165,255,255,255,157             // jmpq          *-0x62000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,149,255,255,255,137             // callq         *-0x76000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,207                             // dec           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  191,255,255,255,179                 // mov           $0xb3ffffff,%edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_luminance_to_alpha_hsw_lowp
.globl _sk_luminance_to_alpha_hsw_lowp
FUNCTION(_sk_luminance_to_alpha_hsw_lowp)
_sk_luminance_to_alpha_hsw_lowp:
  .byte  196,226,125,121,29,183,178,0,0      // vpbroadcastw  0xb2b7(%rip),%ymm3        # 3a9e8 <_sk_srcover_bgra_8888_sse2_lowp+0xa80>
  .byte  197,253,213,195                     // vpmullw       %ymm3,%ymm0,%ymm0
  .byte  196,226,125,121,29,172,178,0,0      // vpbroadcastw  0xb2ac(%rip),%ymm3        # 3a9ea <_sk_srcover_bgra_8888_sse2_lowp+0xa82>
  .byte  197,245,213,203                     // vpmullw       %ymm3,%ymm1,%ymm1
  .byte  197,245,253,192                     // vpaddw        %ymm0,%ymm1,%ymm0
  .byte  196,226,125,121,13,157,178,0,0      // vpbroadcastw  0xb29d(%rip),%ymm1        # 3a9ec <_sk_srcover_bgra_8888_sse2_lowp+0xa84>
  .byte  197,237,213,201                     // vpmullw       %ymm1,%ymm2,%ymm1
  .byte  197,253,253,193                     // vpaddw        %ymm1,%ymm0,%ymm0
  .byte  197,229,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,253,239,192                     // vpxor         %ymm0,%ymm0,%ymm0
  .byte  197,245,239,201                     // vpxor         %ymm1,%ymm1,%ymm1
  .byte  197,237,239,210                     // vpxor         %ymm2,%ymm2,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gather_g8_hsw_lowp
.globl _sk_gather_g8_hsw_lowp
FUNCTION(_sk_gather_g8_hsw_lowp)
_sk_gather_g8_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,98,125,88,64,12                 // vpbroadcastd  0xc(%rax),%ymm8
  .byte  196,65,53,118,201                   // vpcmpeqd      %ymm9,%ymm9,%ymm9
  .byte  196,65,61,254,193                   // vpaddd        %ymm9,%ymm8,%ymm8
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,193,124,95,194                  // vmaxps        %ymm10,%ymm0,%ymm0
  .byte  196,193,116,95,202                  // vmaxps        %ymm10,%ymm1,%ymm1
  .byte  196,65,116,93,216                   // vminps        %ymm8,%ymm1,%ymm11
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,226,125,88,72,16                // vpbroadcastd  0x10(%rax),%ymm1
  .byte  196,193,117,254,201                 // vpaddd        %ymm9,%ymm1,%ymm1
  .byte  196,193,100,95,218                  // vmaxps        %ymm10,%ymm3,%ymm3
  .byte  196,193,108,95,210                  // vmaxps        %ymm10,%ymm2,%ymm2
  .byte  197,236,93,209                      // vminps        %ymm1,%ymm2,%ymm2
  .byte  197,228,93,201                      // vminps        %ymm1,%ymm3,%ymm1
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,254,91,201                      // vcvttps2dq    %ymm1,%ymm1
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,226,125,88,88,8                 // vpbroadcastd  0x8(%rax),%ymm3
  .byte  196,226,101,64,210                  // vpmulld       %ymm2,%ymm3,%ymm2
  .byte  196,226,101,64,217                  // vpmulld       %ymm1,%ymm3,%ymm3
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  197,237,254,200                     // vpaddd        %ymm0,%ymm2,%ymm1
  .byte  196,193,126,91,195                  // vcvttps2dq    %ymm11,%ymm0
  .byte  197,229,254,192                     // vpaddd        %ymm0,%ymm3,%ymm0
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  197,249,110,208                     // vmovd         %eax,%xmm2
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,182,4,8                       // movzbl        (%r8,%r9,1),%eax
  .byte  196,227,105,32,208,1                // vpinsrb       $0x1,%eax,%xmm2,%xmm2
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,201,1                // vextracti128  $0x1,%ymm1,%xmm1
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,105,32,208,2                // vpinsrb       $0x2,%eax,%xmm2,%xmm2
  .byte  196,193,249,126,201                 // vmovq         %xmm1,%r9
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  196,227,105,32,208,3                // vpinsrb       $0x3,%eax,%xmm2,%xmm2
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,105,32,208,4                // vpinsrb       $0x4,%eax,%xmm2,%xmm2
  .byte  196,195,249,22,202,1                // vpextrq       $0x1,%xmm1,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,182,4,8                       // movzbl        (%r8,%r9,1),%eax
  .byte  196,227,105,32,200,5                // vpinsrb       $0x5,%eax,%xmm2,%xmm1
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,113,32,200,6                // vpinsrb       $0x6,%eax,%xmm1,%xmm1
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  196,227,113,32,200,7                // vpinsrb       $0x7,%eax,%xmm1,%xmm1
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,113,32,200,8                // vpinsrb       $0x8,%eax,%xmm1,%xmm1
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,182,4,8                       // movzbl        (%r8,%r9,1),%eax
  .byte  196,227,113,32,200,9                // vpinsrb       $0x9,%eax,%xmm1,%xmm1
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  196,227,125,57,192,1                // vextracti128  $0x1,%ymm0,%xmm0
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,113,32,200,10               // vpinsrb       $0xa,%eax,%xmm1,%xmm1
  .byte  196,193,249,126,193                 // vmovq         %xmm0,%r9
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  196,227,113,32,200,11               // vpinsrb       $0xb,%eax,%xmm1,%xmm1
  .byte  68,137,200                          // mov           %r9d,%eax
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,113,32,200,12               // vpinsrb       $0xc,%eax,%xmm1,%xmm1
  .byte  196,195,249,22,194,1                // vpextrq       $0x1,%xmm0,%r10
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  67,15,182,4,8                       // movzbl        (%r8,%r9,1),%eax
  .byte  196,227,113,32,192,13               // vpinsrb       $0xd,%eax,%xmm1,%xmm0
  .byte  68,137,208                          // mov           %r10d,%eax
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  196,227,121,32,192,14               // vpinsrb       $0xe,%eax,%xmm0,%xmm0
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  67,15,182,4,16                      // movzbl        (%r8,%r10,1),%eax
  .byte  196,227,121,32,192,15               // vpinsrb       $0xf,%eax,%xmm0,%xmm0
  .byte  196,226,125,48,192                  // vpmovzxbw     %xmm0,%ymm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,121,29,224,176,0,0      // vpbroadcastw  0xb0e0(%rip),%ymm3        # 3a9ee <_sk_srcover_bgra_8888_sse2_lowp+0xa86>
  .byte  197,253,111,200                     // vmovdqa       %ymm0,%ymm1
  .byte  197,253,111,208                     // vmovdqa       %ymm0,%ymm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_1_float_hsw_lowp
.globl _sk_scale_1_float_hsw_lowp
FUNCTION(_sk_scale_1_float_hsw_lowp)
_sk_scale_1_float_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,122,16,0                        // vmovss        (%rax),%xmm8
  .byte  197,122,16,13,30,169,0,0            // vmovss        0xa91e(%rip),%xmm9        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,98,57,169,13,229,168,0,0        // vfmadd213ss   0xa8e5(%rip),%xmm8,%xmm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,193,122,44,193                  // vcvttss2si    %xmm9,%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  196,66,125,121,192                  // vpbroadcastw  %xmm8,%ymm8
  .byte  197,189,213,192                     // vpmullw       %ymm0,%ymm8,%ymm0
  .byte  196,98,125,121,13,166,176,0,0       // vpbroadcastw  0xb0a6(%rip),%ymm9        # 3a9f0 <_sk_srcover_bgra_8888_sse2_lowp+0xa88>
  .byte  196,193,125,253,193                 // vpaddw        %ymm9,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,189,213,201                     // vpmullw       %ymm1,%ymm8,%ymm1
  .byte  196,193,117,253,201                 // vpaddw        %ymm9,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,189,213,210                     // vpmullw       %ymm2,%ymm8,%ymm2
  .byte  196,193,109,253,209                 // vpaddw        %ymm9,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,189,213,219                     // vpmullw       %ymm3,%ymm8,%ymm3
  .byte  196,193,101,253,217                 // vpaddw        %ymm9,%ymm3,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lerp_1_float_hsw_lowp
.globl _sk_lerp_1_float_hsw_lowp
FUNCTION(_sk_lerp_1_float_hsw_lowp)
_sk_lerp_1_float_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,122,16,0                        // vmovss        (%rax),%xmm8
  .byte  197,122,16,13,180,168,0,0           // vmovss        0xa8b4(%rip),%xmm9        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,98,57,169,13,123,168,0,0        // vfmadd213ss   0xa87b(%rip),%xmm8,%xmm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,193,122,44,193                  // vcvttss2si    %xmm9,%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  196,66,125,121,192                  // vpbroadcastw  %xmm8,%ymm8
  .byte  196,98,125,121,13,66,176,0,0        // vpbroadcastw  0xb042(%rip),%ymm9        # 3a9f2 <_sk_srcover_bgra_8888_sse2_lowp+0xa8a>
  .byte  196,65,53,249,208                   // vpsubw        %ymm8,%ymm9,%ymm10
  .byte  197,45,213,220                      // vpmullw       %ymm4,%ymm10,%ymm11
  .byte  197,189,213,192                     // vpmullw       %ymm0,%ymm8,%ymm0
  .byte  196,193,125,253,193                 // vpaddw        %ymm9,%ymm0,%ymm0
  .byte  197,165,253,192                     // vpaddw        %ymm0,%ymm11,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,45,213,221                      // vpmullw       %ymm5,%ymm10,%ymm11
  .byte  197,189,213,201                     // vpmullw       %ymm1,%ymm8,%ymm1
  .byte  196,193,117,253,201                 // vpaddw        %ymm9,%ymm1,%ymm1
  .byte  197,165,253,201                     // vpaddw        %ymm1,%ymm11,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,45,213,222                      // vpmullw       %ymm6,%ymm10,%ymm11
  .byte  197,189,213,210                     // vpmullw       %ymm2,%ymm8,%ymm2
  .byte  196,193,109,253,209                 // vpaddw        %ymm9,%ymm2,%ymm2
  .byte  197,165,253,210                     // vpaddw        %ymm2,%ymm11,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,45,213,215                      // vpmullw       %ymm7,%ymm10,%ymm10
  .byte  197,189,213,219                     // vpmullw       %ymm3,%ymm8,%ymm3
  .byte  196,193,101,253,217                 // vpaddw        %ymm9,%ymm3,%ymm3
  .byte  197,173,253,219                     // vpaddw        %ymm3,%ymm10,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_u8_hsw_lowp
.globl _sk_scale_u8_hsw_lowp
FUNCTION(_sk_scale_u8_hsw_lowp)
_sk_scale_u8_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,38                              // ja            2fa4e <_sk_scale_u8_hsw_lowp+0x3d>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,21,1,0,0                  // lea           0x115(%rip),%r9        # 2fb4c <_sk_scale_u8_hsw_lowp+0x13b>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  233,179,0,0,0                       // jmpq          2fb01 <_sk_scale_u8_hsw_lowp+0xf0>
  .byte  196,65,122,111,4,16                 // vmovdqu       (%r8,%rdx,1),%xmm8
  .byte  233,168,0,0,0                       // jmpq          2fb01 <_sk_scale_u8_hsw_lowp+0xf0>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,67,57,32,68,16,2,2              // vpinsrb       $0x2,0x2(%r8,%rdx,1),%xmm8,%xmm8
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  197,121,110,200                     // vmovd         %eax,%xmm9
  .byte  196,67,57,14,193,1                  // vpblendw      $0x1,%xmm9,%xmm8,%xmm8
  .byte  233,135,0,0,0                       // jmpq          2fb01 <_sk_scale_u8_hsw_lowp+0xf0>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,67,57,32,68,16,6,6              // vpinsrb       $0x6,0x6(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,67,57,32,68,16,5,5              // vpinsrb       $0x5,0x5(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,67,57,32,68,16,4,4              // vpinsrb       $0x4,0x4(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,65,121,110,12,16                // vmovd         (%r8,%rdx,1),%xmm9
  .byte  196,67,57,2,193,1                   // vpblendd      $0x1,%xmm9,%xmm8,%xmm8
  .byte  235,92                              // jmp           2fb01 <_sk_scale_u8_hsw_lowp+0xf0>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,67,57,32,68,16,10,10            // vpinsrb       $0xa,0xa(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,67,57,32,68,16,9,9              // vpinsrb       $0x9,0x9(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,67,57,32,68,16,8,8              // vpinsrb       $0x8,0x8(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,65,122,126,12,16                // vmovq         (%r8,%rdx,1),%xmm9
  .byte  196,67,49,2,192,12                  // vpblendd      $0xc,%xmm8,%xmm9,%xmm8
  .byte  235,49                              // jmp           2fb01 <_sk_scale_u8_hsw_lowp+0xf0>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,67,57,32,68,16,14,14            // vpinsrb       $0xe,0xe(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,67,57,32,68,16,13,13            // vpinsrb       $0xd,0xd(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,67,57,32,68,16,12,12            // vpinsrb       $0xc,0xc(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,65,122,126,12,16                // vmovq         (%r8,%rdx,1),%xmm9
  .byte  196,67,49,34,76,16,8,2              // vpinsrd       $0x2,0x8(%r8,%rdx,1),%xmm9,%xmm9
  .byte  196,67,49,2,192,8                   // vpblendd      $0x8,%xmm8,%xmm9,%xmm8
  .byte  196,66,125,48,192                   // vpmovzxbw     %xmm8,%ymm8
  .byte  197,189,213,192                     // vpmullw       %ymm0,%ymm8,%ymm0
  .byte  196,98,125,121,13,225,174,0,0       // vpbroadcastw  0xaee1(%rip),%ymm9        # 3a9f4 <_sk_srcover_bgra_8888_sse2_lowp+0xa8c>
  .byte  196,193,125,253,193                 // vpaddw        %ymm9,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,189,213,201                     // vpmullw       %ymm1,%ymm8,%ymm1
  .byte  196,193,117,253,201                 // vpaddw        %ymm9,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,189,213,210                     // vpmullw       %ymm2,%ymm8,%ymm2
  .byte  196,193,109,253,209                 // vpaddw        %ymm9,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,189,213,219                     // vpmullw       %ymm3,%ymm8,%ymm3
  .byte  196,193,101,253,217                 // vpaddw        %ymm9,%ymm3,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  144                                 // nop
  .byte  244                                 // hlt
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,26                              // lcall         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,13,255,255,255,75               // decl          0x4bffffff(%rip)        # 4c02fb58 <_sk_srcover_bgra_8888_sse2_lowp+0x4bff5bf0>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,67,255                          // incl          -0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  59,255                              // cmp           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,46                              // ljmp          *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,118,255                         // pushq         -0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,110,255                         // ljmp          *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,102,255                         // jmpq          *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,89,255                          // lcall         *-0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,161,255,255,255,153             // jmpq          *-0x66000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,145,255,255,255,132             // callq         *-0x7b000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_lerp_u8_hsw_lowp
.globl _sk_lerp_u8_hsw_lowp
FUNCTION(_sk_lerp_u8_hsw_lowp)
_sk_lerp_u8_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,38                              // ja            2fbc5 <_sk_lerp_u8_hsw_lowp+0x3d>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,58,1,0,0                  // lea           0x13a(%rip),%r9        # 2fce8 <_sk_lerp_u8_hsw_lowp+0x160>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  233,179,0,0,0                       // jmpq          2fc78 <_sk_lerp_u8_hsw_lowp+0xf0>
  .byte  196,65,122,111,4,16                 // vmovdqu       (%r8,%rdx,1),%xmm8
  .byte  233,168,0,0,0                       // jmpq          2fc78 <_sk_lerp_u8_hsw_lowp+0xf0>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,67,57,32,68,16,2,2              // vpinsrb       $0x2,0x2(%r8,%rdx,1),%xmm8,%xmm8
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  197,121,110,200                     // vmovd         %eax,%xmm9
  .byte  196,67,57,14,193,1                  // vpblendw      $0x1,%xmm9,%xmm8,%xmm8
  .byte  233,135,0,0,0                       // jmpq          2fc78 <_sk_lerp_u8_hsw_lowp+0xf0>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,67,57,32,68,16,6,6              // vpinsrb       $0x6,0x6(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,67,57,32,68,16,5,5              // vpinsrb       $0x5,0x5(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,67,57,32,68,16,4,4              // vpinsrb       $0x4,0x4(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,65,121,110,12,16                // vmovd         (%r8,%rdx,1),%xmm9
  .byte  196,67,57,2,193,1                   // vpblendd      $0x1,%xmm9,%xmm8,%xmm8
  .byte  235,92                              // jmp           2fc78 <_sk_lerp_u8_hsw_lowp+0xf0>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,67,57,32,68,16,10,10            // vpinsrb       $0xa,0xa(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,67,57,32,68,16,9,9              // vpinsrb       $0x9,0x9(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,67,57,32,68,16,8,8              // vpinsrb       $0x8,0x8(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,65,122,126,12,16                // vmovq         (%r8,%rdx,1),%xmm9
  .byte  196,67,49,2,192,12                  // vpblendd      $0xc,%xmm8,%xmm9,%xmm8
  .byte  235,49                              // jmp           2fc78 <_sk_lerp_u8_hsw_lowp+0xf0>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,67,57,32,68,16,14,14            // vpinsrb       $0xe,0xe(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,67,57,32,68,16,13,13            // vpinsrb       $0xd,0xd(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,67,57,32,68,16,12,12            // vpinsrb       $0xc,0xc(%r8,%rdx,1),%xmm8,%xmm8
  .byte  196,65,122,126,12,16                // vmovq         (%r8,%rdx,1),%xmm9
  .byte  196,67,49,34,76,16,8,2              // vpinsrd       $0x2,0x8(%r8,%rdx,1),%xmm9,%xmm9
  .byte  196,67,49,2,192,8                   // vpblendd      $0x8,%xmm8,%xmm9,%xmm8
  .byte  196,66,125,48,192                   // vpmovzxbw     %xmm8,%ymm8
  .byte  196,98,125,121,13,112,173,0,0       // vpbroadcastw  0xad70(%rip),%ymm9        # 3a9f6 <_sk_srcover_bgra_8888_sse2_lowp+0xa8e>
  .byte  196,65,61,239,209                   // vpxor         %ymm9,%ymm8,%ymm10
  .byte  197,45,213,220                      // vpmullw       %ymm4,%ymm10,%ymm11
  .byte  197,189,213,192                     // vpmullw       %ymm0,%ymm8,%ymm0
  .byte  196,193,125,253,193                 // vpaddw        %ymm9,%ymm0,%ymm0
  .byte  197,165,253,192                     // vpaddw        %ymm0,%ymm11,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,45,213,221                      // vpmullw       %ymm5,%ymm10,%ymm11
  .byte  197,189,213,201                     // vpmullw       %ymm1,%ymm8,%ymm1
  .byte  196,193,117,253,201                 // vpaddw        %ymm9,%ymm1,%ymm1
  .byte  197,165,253,201                     // vpaddw        %ymm1,%ymm11,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,45,213,222                      // vpmullw       %ymm6,%ymm10,%ymm11
  .byte  197,189,213,210                     // vpmullw       %ymm2,%ymm8,%ymm2
  .byte  196,193,109,253,209                 // vpaddw        %ymm9,%ymm2,%ymm2
  .byte  197,165,253,210                     // vpaddw        %ymm2,%ymm11,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,45,213,215                      // vpmullw       %ymm7,%ymm10,%ymm10
  .byte  197,189,213,219                     // vpmullw       %ymm3,%ymm8,%ymm3
  .byte  196,193,101,253,217                 // vpaddw        %ymm9,%ymm3,%ymm3
  .byte  197,173,253,219                     // vpaddw        %ymm3,%ymm10,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  144                                 // nop
  .byte  207                                 // iret
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,245                             // push          %rbp
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  232,254,255,255,38                  // callq         2702fcf3 <_sk_srcover_bgra_8888_sse2_lowp+0x26ff5d8b>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,30                              // lcall         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,22                              // callq         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,9                               // decl          (%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,81,255                          // callq         *-0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,73,255                          // decl          -0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,65,255                          // incl          -0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,52,255                          // pushq         (%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  124,255                             // jl            2fd15 <_sk_lerp_u8_hsw_lowp+0x18d>
  .byte  255                                 // (bad)
  .byte  255,116,255,255                     // pushq         -0x1(%rdi,%rdi,8)
  .byte  255,108,255,255                     // ljmp          *-0x1(%rdi,%rdi,8)
  .byte  255,95,255                          // lcall         *-0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_scale_565_hsw_lowp
.globl _sk_scale_565_hsw_lowp
FUNCTION(_sk_scale_565_hsw_lowp)
_sk_scale_565_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,38                              // ja            2fd64 <_sk_scale_565_hsw_lowp+0x40>
  .byte  196,65,61,239,192                   // vpxor         %ymm8,%ymm8,%ymm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,255,1,0,0                 // lea           0x1ff(%rip),%r9        # 2ff4c <_sk_scale_565_hsw_lowp+0x228>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  233,12,1,0,0                        // jmpq          2fe70 <_sk_scale_565_hsw_lowp+0x14c>
  .byte  196,65,126,111,4,80                 // vmovdqu       (%r8,%rdx,2),%ymm8
  .byte  233,1,1,0,0                         // jmpq          2fe70 <_sk_scale_565_hsw_lowp+0x14c>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,65,57,196,76,80,4,2             // vpinsrw       $0x2,0x4(%r8,%rdx,2),%xmm8,%xmm9
  .byte  196,67,53,56,192,1                  // vinserti128   $0x1,%xmm8,%ymm9,%ymm8
  .byte  196,65,121,110,12,80                // vmovd         (%r8,%rdx,2),%xmm9
  .byte  196,67,61,2,193,1                   // vpblendd      $0x1,%ymm9,%ymm8,%ymm8
  .byte  233,221,0,0,0                       // jmpq          2fe70 <_sk_scale_565_hsw_lowp+0x14c>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,65,57,196,76,80,12,6            // vpinsrw       $0x6,0xc(%r8,%rdx,2),%xmm8,%xmm9
  .byte  196,67,53,56,192,1                  // vinserti128   $0x1,%xmm8,%ymm9,%ymm8
  .byte  196,65,57,196,76,80,10,5            // vpinsrw       $0x5,0xa(%r8,%rdx,2),%xmm8,%xmm9
  .byte  196,67,61,2,193,15                  // vpblendd      $0xf,%ymm9,%ymm8,%ymm8
  .byte  196,65,57,196,76,80,8,4             // vpinsrw       $0x4,0x8(%r8,%rdx,2),%xmm8,%xmm9
  .byte  196,67,61,2,193,15                  // vpblendd      $0xf,%ymm9,%ymm8,%ymm8
  .byte  196,65,122,126,12,80                // vmovq         (%r8,%rdx,2),%xmm9
  .byte  196,67,61,2,193,3                   // vpblendd      $0x3,%ymm9,%ymm8,%ymm8
  .byte  233,157,0,0,0                       // jmpq          2fe70 <_sk_scale_565_hsw_lowp+0x14c>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,65,57,196,76,80,20,2            // vpinsrw       $0x2,0x14(%r8,%rdx,2),%xmm8,%xmm9
  .byte  196,67,61,56,193,1                  // vinserti128   $0x1,%xmm9,%ymm8,%ymm8
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,49,196,76,80,18,1            // vpinsrw       $0x1,0x12(%r8,%rdx,2),%xmm9,%xmm9
  .byte  196,67,61,56,193,1                  // vinserti128   $0x1,%xmm9,%ymm8,%ymm8
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,49,196,76,80,16,0            // vpinsrw       $0x0,0x10(%r8,%rdx,2),%xmm9,%xmm9
  .byte  196,67,61,56,193,1                  // vinserti128   $0x1,%xmm9,%ymm8,%ymm8
  .byte  196,65,122,111,12,80                // vmovdqu       (%r8,%rdx,2),%xmm9
  .byte  196,67,53,2,192,240                 // vpblendd      $0xf0,%ymm8,%ymm9,%ymm8
  .byte  235,84                              // jmp           2fe70 <_sk_scale_565_hsw_lowp+0x14c>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,65,57,196,76,80,28,6            // vpinsrw       $0x6,0x1c(%r8,%rdx,2),%xmm8,%xmm9
  .byte  196,67,61,56,193,1                  // vinserti128   $0x1,%xmm9,%ymm8,%ymm8
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,49,196,76,80,26,5            // vpinsrw       $0x5,0x1a(%r8,%rdx,2),%xmm9,%xmm9
  .byte  196,67,61,56,193,1                  // vinserti128   $0x1,%xmm9,%ymm8,%ymm8
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,49,196,76,80,24,4            // vpinsrw       $0x4,0x18(%r8,%rdx,2),%xmm9,%xmm9
  .byte  196,67,61,56,193,1                  // vinserti128   $0x1,%xmm9,%ymm8,%ymm8
  .byte  196,65,122,126,76,80,16             // vmovq         0x10(%r8,%rdx,2),%xmm9
  .byte  196,65,122,111,20,80                // vmovdqu       (%r8,%rdx,2),%xmm10
  .byte  196,67,45,56,201,1                  // vinserti128   $0x1,%xmm9,%ymm10,%ymm9
  .byte  196,67,53,2,192,192                 // vpblendd      $0xc0,%ymm8,%ymm9,%ymm8
  .byte  196,98,125,121,13,127,171,0,0       // vpbroadcastw  0xab7f(%rip),%ymm9        # 3a9f8 <_sk_srcover_bgra_8888_sse2_lowp+0xa90>
  .byte  196,193,45,113,208,8                // vpsrlw        $0x8,%ymm8,%ymm10
  .byte  196,65,45,219,201                   // vpand         %ymm9,%ymm10,%ymm9
  .byte  196,193,45,113,208,5                // vpsrlw        $0x5,%ymm8,%ymm10
  .byte  196,98,125,121,29,103,171,0,0       // vpbroadcastw  0xab67(%rip),%ymm11        # 3a9fa <_sk_srcover_bgra_8888_sse2_lowp+0xa92>
  .byte  196,65,45,219,211                   // vpand         %ymm11,%ymm10,%ymm10
  .byte  196,98,125,121,29,91,171,0,0        // vpbroadcastw  0xab5b(%rip),%ymm11        # 3a9fc <_sk_srcover_bgra_8888_sse2_lowp+0xa94>
  .byte  196,65,61,219,219                   // vpand         %ymm11,%ymm8,%ymm11
  .byte  196,193,61,113,208,13               // vpsrlw        $0xd,%ymm8,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  196,193,53,113,242,2                // vpsllw        $0x2,%ymm10,%ymm9
  .byte  196,193,45,113,210,4                // vpsrlw        $0x4,%ymm10,%ymm10
  .byte  196,65,53,235,202                   // vpor          %ymm10,%ymm9,%ymm9
  .byte  196,193,45,113,243,3                // vpsllw        $0x3,%ymm11,%ymm10
  .byte  196,193,37,113,211,2                // vpsrlw        $0x2,%ymm11,%ymm11
  .byte  196,65,45,235,211                   // vpor          %ymm11,%ymm10,%ymm10
  .byte  196,98,125,121,29,34,171,0,0        // vpbroadcastw  0xab22(%rip),%ymm11        # 3a9fe <_sk_srcover_bgra_8888_sse2_lowp+0xa96>
  .byte  196,65,101,239,227                  // vpxor         %ymm11,%ymm3,%ymm12
  .byte  196,65,69,239,219                   // vpxor         %ymm11,%ymm7,%ymm11
  .byte  196,65,37,101,220                   // vpcmpgtw      %ymm12,%ymm11,%ymm11
  .byte  196,66,53,58,226                    // vpminuw       %ymm10,%ymm9,%ymm12
  .byte  196,66,29,58,224                    // vpminuw       %ymm8,%ymm12,%ymm12
  .byte  196,66,53,62,234                    // vpmaxuw       %ymm10,%ymm9,%ymm13
  .byte  196,66,21,62,232                    // vpmaxuw       %ymm8,%ymm13,%ymm13
  .byte  196,67,21,76,220,176                // vpblendvb     %ymm11,%ymm12,%ymm13,%ymm11
  .byte  197,189,213,192                     // vpmullw       %ymm0,%ymm8,%ymm0
  .byte  196,98,125,121,5,238,170,0,0        // vpbroadcastw  0xaaee(%rip),%ymm8        # 3aa00 <_sk_srcover_bgra_8888_sse2_lowp+0xa98>
  .byte  196,193,125,253,192                 // vpaddw        %ymm8,%ymm0,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  197,181,213,201                     // vpmullw       %ymm1,%ymm9,%ymm1
  .byte  196,193,117,253,200                 // vpaddw        %ymm8,%ymm1,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  197,173,213,210                     // vpmullw       %ymm2,%ymm10,%ymm2
  .byte  196,193,109,253,208                 // vpaddw        %ymm8,%ymm2,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  197,165,213,219                     // vpmullw       %ymm3,%ymm11,%ymm3
  .byte  196,193,101,253,216                 // vpaddw        %ymm8,%ymm3,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  10,254                              // or            %dh,%bh
  .byte  255                                 // (bad)
  .byte  255,54                              // pushq         (%rsi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,35                              // jmpq          *(%rbx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,118,254                         // pushq         -0x2(%rsi)
  .byte  255                                 // (bad)
  .byte  255,104,254                         // ljmp          *-0x2(%rax)
  .byte  255                                 // (bad)
  .byte  255,90,254                          // lcall         *-0x2(%rdx)
  .byte  255                                 // (bad)
  .byte  255,71,254                          // incl          -0x2(%rdi)
  .byte  255                                 // (bad)
  .byte  255,194                             // inc           %edx
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,174,254,255,255,154             // ljmp          *-0x65000002(%rsi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,135,254,255,255,11              // incl          0xbfffffe(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,247                             // push          %rdi
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,227                             // jmpq          *%rbx
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_lerp_565_hsw_lowp
.globl _sk_lerp_565_hsw_lowp
FUNCTION(_sk_lerp_565_hsw_lowp)
_sk_lerp_565_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,15                               // and           $0xf,%al
  .byte  254,200                             // dec           %al
  .byte  60,14                               // cmp           $0xe,%al
  .byte  119,38                              // ja            2ffc8 <_sk_lerp_565_hsw_lowp+0x40>
  .byte  196,65,61,239,192                   // vpxor         %ymm8,%ymm8,%ymm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,51,2,0,0                  // lea           0x233(%rip),%r9        # 301e4 <_sk_lerp_565_hsw_lowp+0x25c>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  197,121,110,192                     // vmovd         %eax,%xmm8
  .byte  233,12,1,0,0                        // jmpq          300d4 <_sk_lerp_565_hsw_lowp+0x14c>
  .byte  196,65,126,111,4,80                 // vmovdqu       (%r8,%rdx,2),%ymm8
  .byte  233,1,1,0,0                         // jmpq          300d4 <_sk_lerp_565_hsw_lowp+0x14c>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,65,57,196,76,80,4,2             // vpinsrw       $0x2,0x4(%r8,%rdx,2),%xmm8,%xmm9
  .byte  196,67,53,56,192,1                  // vinserti128   $0x1,%xmm8,%ymm9,%ymm8
  .byte  196,65,121,110,12,80                // vmovd         (%r8,%rdx,2),%xmm9
  .byte  196,67,61,2,193,1                   // vpblendd      $0x1,%ymm9,%ymm8,%ymm8
  .byte  233,221,0,0,0                       // jmpq          300d4 <_sk_lerp_565_hsw_lowp+0x14c>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,65,57,196,76,80,12,6            // vpinsrw       $0x6,0xc(%r8,%rdx,2),%xmm8,%xmm9
  .byte  196,67,53,56,192,1                  // vinserti128   $0x1,%xmm8,%ymm9,%ymm8
  .byte  196,65,57,196,76,80,10,5            // vpinsrw       $0x5,0xa(%r8,%rdx,2),%xmm8,%xmm9
  .byte  196,67,61,2,193,15                  // vpblendd      $0xf,%ymm9,%ymm8,%ymm8
  .byte  196,65,57,196,76,80,8,4             // vpinsrw       $0x4,0x8(%r8,%rdx,2),%xmm8,%xmm9
  .byte  196,67,61,2,193,15                  // vpblendd      $0xf,%ymm9,%ymm8,%ymm8
  .byte  196,65,122,126,12,80                // vmovq         (%r8,%rdx,2),%xmm9
  .byte  196,67,61,2,193,3                   // vpblendd      $0x3,%ymm9,%ymm8,%ymm8
  .byte  233,157,0,0,0                       // jmpq          300d4 <_sk_lerp_565_hsw_lowp+0x14c>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,65,57,196,76,80,20,2            // vpinsrw       $0x2,0x14(%r8,%rdx,2),%xmm8,%xmm9
  .byte  196,67,61,56,193,1                  // vinserti128   $0x1,%xmm9,%ymm8,%ymm8
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,49,196,76,80,18,1            // vpinsrw       $0x1,0x12(%r8,%rdx,2),%xmm9,%xmm9
  .byte  196,67,61,56,193,1                  // vinserti128   $0x1,%xmm9,%ymm8,%ymm8
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,49,196,76,80,16,0            // vpinsrw       $0x0,0x10(%r8,%rdx,2),%xmm9,%xmm9
  .byte  196,67,61,56,193,1                  // vinserti128   $0x1,%xmm9,%ymm8,%ymm8
  .byte  196,65,122,111,12,80                // vmovdqu       (%r8,%rdx,2),%xmm9
  .byte  196,67,53,2,192,240                 // vpblendd      $0xf0,%ymm8,%ymm9,%ymm8
  .byte  235,84                              // jmp           300d4 <_sk_lerp_565_hsw_lowp+0x14c>
  .byte  196,65,57,239,192                   // vpxor         %xmm8,%xmm8,%xmm8
  .byte  196,65,57,196,76,80,28,6            // vpinsrw       $0x6,0x1c(%r8,%rdx,2),%xmm8,%xmm9
  .byte  196,67,61,56,193,1                  // vinserti128   $0x1,%xmm9,%ymm8,%ymm8
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,49,196,76,80,26,5            // vpinsrw       $0x5,0x1a(%r8,%rdx,2),%xmm9,%xmm9
  .byte  196,67,61,56,193,1                  // vinserti128   $0x1,%xmm9,%ymm8,%ymm8
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,49,196,76,80,24,4            // vpinsrw       $0x4,0x18(%r8,%rdx,2),%xmm9,%xmm9
  .byte  196,67,61,56,193,1                  // vinserti128   $0x1,%xmm9,%ymm8,%ymm8
  .byte  196,65,122,126,76,80,16             // vmovq         0x10(%r8,%rdx,2),%xmm9
  .byte  196,65,122,111,20,80                // vmovdqu       (%r8,%rdx,2),%xmm10
  .byte  196,67,45,56,201,1                  // vinserti128   $0x1,%xmm9,%ymm10,%ymm9
  .byte  196,67,53,2,192,192                 // vpblendd      $0xc0,%ymm8,%ymm9,%ymm8
  .byte  196,98,125,121,13,37,169,0,0        // vpbroadcastw  0xa925(%rip),%ymm9        # 3aa02 <_sk_srcover_bgra_8888_sse2_lowp+0xa9a>
  .byte  196,193,45,113,208,8                // vpsrlw        $0x8,%ymm8,%ymm10
  .byte  196,65,45,219,201                   // vpand         %ymm9,%ymm10,%ymm9
  .byte  196,193,45,113,208,5                // vpsrlw        $0x5,%ymm8,%ymm10
  .byte  196,98,125,121,29,13,169,0,0        // vpbroadcastw  0xa90d(%rip),%ymm11        # 3aa04 <_sk_srcover_bgra_8888_sse2_lowp+0xa9c>
  .byte  196,65,45,219,211                   // vpand         %ymm11,%ymm10,%ymm10
  .byte  196,98,125,121,29,1,169,0,0         // vpbroadcastw  0xa901(%rip),%ymm11        # 3aa06 <_sk_srcover_bgra_8888_sse2_lowp+0xa9e>
  .byte  196,65,61,219,219                   // vpand         %ymm11,%ymm8,%ymm11
  .byte  196,193,61,113,208,13               // vpsrlw        $0xd,%ymm8,%ymm8
  .byte  196,65,53,235,192                   // vpor          %ymm8,%ymm9,%ymm8
  .byte  196,193,53,113,242,2                // vpsllw        $0x2,%ymm10,%ymm9
  .byte  196,193,45,113,210,4                // vpsrlw        $0x4,%ymm10,%ymm10
  .byte  196,65,53,235,202                   // vpor          %ymm10,%ymm9,%ymm9
  .byte  196,193,45,113,243,3                // vpsllw        $0x3,%ymm11,%ymm10
  .byte  196,193,37,113,211,2                // vpsrlw        $0x2,%ymm11,%ymm11
  .byte  196,65,45,235,211                   // vpor          %ymm11,%ymm10,%ymm10
  .byte  196,98,125,121,29,200,168,0,0       // vpbroadcastw  0xa8c8(%rip),%ymm11        # 3aa08 <_sk_srcover_bgra_8888_sse2_lowp+0xaa0>
  .byte  196,65,101,239,227                  // vpxor         %ymm11,%ymm3,%ymm12
  .byte  196,65,69,239,219                   // vpxor         %ymm11,%ymm7,%ymm11
  .byte  196,65,37,101,220                   // vpcmpgtw      %ymm12,%ymm11,%ymm11
  .byte  196,66,53,58,226                    // vpminuw       %ymm10,%ymm9,%ymm12
  .byte  196,66,29,58,224                    // vpminuw       %ymm8,%ymm12,%ymm12
  .byte  196,66,53,62,234                    // vpmaxuw       %ymm10,%ymm9,%ymm13
  .byte  196,66,21,62,232                    // vpmaxuw       %ymm8,%ymm13,%ymm13
  .byte  196,67,21,76,220,176                // vpblendvb     %ymm11,%ymm12,%ymm13,%ymm11
  .byte  196,98,125,121,37,152,168,0,0       // vpbroadcastw  0xa898(%rip),%ymm12        # 3aa0a <_sk_srcover_bgra_8888_sse2_lowp+0xaa2>
  .byte  196,65,61,239,236                   // vpxor         %ymm12,%ymm8,%ymm13
  .byte  197,21,213,236                      // vpmullw       %ymm4,%ymm13,%ymm13
  .byte  197,189,213,192                     // vpmullw       %ymm0,%ymm8,%ymm0
  .byte  196,193,125,253,196                 // vpaddw        %ymm12,%ymm0,%ymm0
  .byte  197,149,253,192                     // vpaddw        %ymm0,%ymm13,%ymm0
  .byte  197,253,113,208,8                   // vpsrlw        $0x8,%ymm0,%ymm0
  .byte  196,65,53,239,196                   // vpxor         %ymm12,%ymm9,%ymm8
  .byte  197,61,213,197                      // vpmullw       %ymm5,%ymm8,%ymm8
  .byte  197,181,213,201                     // vpmullw       %ymm1,%ymm9,%ymm1
  .byte  196,193,117,253,204                 // vpaddw        %ymm12,%ymm1,%ymm1
  .byte  197,189,253,201                     // vpaddw        %ymm1,%ymm8,%ymm1
  .byte  197,245,113,209,8                   // vpsrlw        $0x8,%ymm1,%ymm1
  .byte  196,65,45,239,196                   // vpxor         %ymm12,%ymm10,%ymm8
  .byte  197,61,213,198                      // vpmullw       %ymm6,%ymm8,%ymm8
  .byte  197,173,213,210                     // vpmullw       %ymm2,%ymm10,%ymm2
  .byte  196,193,109,253,212                 // vpaddw        %ymm12,%ymm2,%ymm2
  .byte  197,189,253,210                     // vpaddw        %ymm2,%ymm8,%ymm2
  .byte  197,237,113,210,8                   // vpsrlw        $0x8,%ymm2,%ymm2
  .byte  196,65,37,239,196                   // vpxor         %ymm12,%ymm11,%ymm8
  .byte  197,61,213,199                      // vpmullw       %ymm7,%ymm8,%ymm8
  .byte  197,165,213,219                     // vpmullw       %ymm3,%ymm11,%ymm3
  .byte  196,193,101,253,220                 // vpaddw        %ymm12,%ymm3,%ymm3
  .byte  197,189,253,219                     // vpaddw        %ymm3,%ymm8,%ymm3
  .byte  197,229,113,211,8                   // vpsrlw        $0x8,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  214                                 // (bad)
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,2                               // incl          (%rdx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  239                                 // out           %eax,(%dx)
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,66,254                          // incl          -0x2(%rdx)
  .byte  255                                 // (bad)
  .byte  255,52,254                          // pushq         (%rsi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,38                              // jmpq          *(%rsi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,19                              // callq         *(%rbx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,142,254,255,255,122             // decl          0x7afffffe(%rsi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,102,254                         // jmpq          *-0x2(%rsi)
  .byte  255                                 // (bad)
  .byte  255,83,254                          // callq         *-0x2(%rbx)
  .byte  255                                 // (bad)
  .byte  255,215                             // callq         *%rdi
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,195                             // inc           %ebx
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,175,254,255,255,156             // ljmp          *-0x63000002(%rdi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_clamp_x_1_hsw_lowp
.globl _sk_clamp_x_1_hsw_lowp
FUNCTION(_sk_clamp_x_1_hsw_lowp)
_sk_clamp_x_1_hsw_lowp:
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,193,116,95,200                  // vmaxps        %ymm8,%ymm1,%ymm1
  .byte  196,193,124,95,192                  // vmaxps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,24,5,224,159,0,0         // vbroadcastss  0x9fe0(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_repeat_x_1_hsw_lowp
.globl _sk_repeat_x_1_hsw_lowp
FUNCTION(_sk_repeat_x_1_hsw_lowp)
_sk_repeat_x_1_hsw_lowp:
  .byte  196,99,125,8,192,1                  // vroundps      $0x1,%ymm0,%ymm8
  .byte  196,99,125,8,201,1                  // vroundps      $0x1,%ymm1,%ymm9
  .byte  196,193,124,92,192                  // vsubps        %ymm8,%ymm0,%ymm0
  .byte  196,193,116,92,201                  // vsubps        %ymm9,%ymm1,%ymm1
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,193,116,95,200                  // vmaxps        %ymm8,%ymm1,%ymm1
  .byte  196,193,124,95,192                  // vmaxps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,24,5,164,159,0,0         // vbroadcastss  0x9fa4(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_x_1_hsw_lowp
.globl _sk_mirror_x_1_hsw_lowp
FUNCTION(_sk_mirror_x_1_hsw_lowp)
_sk_mirror_x_1_hsw_lowp:
  .byte  196,98,125,24,5,165,159,0,0         // vbroadcastss  0x9fa5(%rip),%ymm8        # 3a230 <_sk_srcover_bgra_8888_sse2_lowp+0x2c8>
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  196,193,116,88,200                  // vaddps        %ymm8,%ymm1,%ymm1
  .byte  196,98,125,24,13,118,159,0,0        // vbroadcastss  0x9f76(%rip),%ymm9        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,65,116,89,209                   // vmulps        %ymm9,%ymm1,%ymm10
  .byte  196,65,124,89,201                   // vmulps        %ymm9,%ymm0,%ymm9
  .byte  196,67,125,8,201,1                  // vroundps      $0x1,%ymm9,%ymm9
  .byte  196,67,125,8,210,1                  // vroundps      $0x1,%ymm10,%ymm10
  .byte  196,65,44,88,210                    // vaddps        %ymm10,%ymm10,%ymm10
  .byte  196,65,52,88,201                    // vaddps        %ymm9,%ymm9,%ymm9
  .byte  196,193,124,92,193                  // vsubps        %ymm9,%ymm0,%ymm0
  .byte  196,193,116,92,202                  // vsubps        %ymm10,%ymm1,%ymm1
  .byte  196,193,116,88,200                  // vaddps        %ymm8,%ymm1,%ymm1
  .byte  196,193,124,88,192                  // vaddps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,24,5,205,160,0,0         // vbroadcastss  0xa0cd(%rip),%ymm8        # 3a3a8 <_sk_srcover_bgra_8888_sse2_lowp+0x440>
  .byte  196,193,124,84,192                  // vandps        %ymm8,%ymm0,%ymm0
  .byte  196,193,116,84,200                  // vandps        %ymm8,%ymm1,%ymm1
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,193,116,95,200                  // vmaxps        %ymm8,%ymm1,%ymm1
  .byte  196,193,124,95,192                  // vmaxps        %ymm8,%ymm0,%ymm0
  .byte  196,98,125,24,5,27,159,0,0          // vbroadcastss  0x9f1b(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  196,193,124,93,192                  // vminps        %ymm8,%ymm0,%ymm0
  .byte  196,193,116,93,200                  // vminps        %ymm8,%ymm1,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gradient_hsw_lowp
.globl _sk_gradient_hsw_lowp
FUNCTION(_sk_gradient_hsw_lowp)
_sk_gradient_hsw_lowp:
  .byte  72,129,236,152,0,0,0                // sub           $0x98,%rsp
  .byte  197,254,127,124,36,96               // vmovdqu       %ymm7,0x60(%rsp)
  .byte  197,252,17,116,36,64                // vmovups       %ymm6,0x40(%rsp)
  .byte  197,254,127,108,36,32               // vmovdqu       %ymm5,0x20(%rsp)
  .byte  197,254,127,36,36                   // vmovdqu       %ymm4,(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  73,131,248,2                        // cmp           $0x2,%r8
  .byte  114,60                              // jb            30378 <_sk_gradient_hsw_lowp+0x6d>
  .byte  76,139,72,72                        // mov           0x48(%rax),%r9
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  65,186,1,0,0,0                      // mov           $0x1,%r10d
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,130,125,24,20,145               // vbroadcastss  (%r9,%r10,4),%ymm2
  .byte  197,236,194,216,2                   // vcmpleps      %ymm0,%ymm2,%ymm3
  .byte  197,197,250,251                     // vpsubd        %ymm3,%ymm7,%ymm7
  .byte  197,236,194,209,2                   // vcmpleps      %ymm1,%ymm2,%ymm2
  .byte  197,213,250,234                     // vpsubd        %ymm2,%ymm5,%ymm5
  .byte  73,255,194                          // inc           %r10
  .byte  77,57,208                           // cmp           %r10,%r8
  .byte  117,224                             // jne           3034e <_sk_gradient_hsw_lowp+0x43>
  .byte  73,131,248,8                        // cmp           $0x8,%r8
  .byte  15,135,180,0,0,0                    // ja            3042c <_sk_gradient_hsw_lowp+0x121>
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  196,193,124,16,24                   // vmovups       (%r8),%ymm3
  .byte  196,226,69,22,211                   // vpermps       %ymm3,%ymm7,%ymm2
  .byte  196,226,85,22,219                   // vpermps       %ymm3,%ymm5,%ymm3
  .byte  76,139,64,40                        // mov           0x28(%rax),%r8
  .byte  196,193,124,16,32                   // vmovups       (%r8),%ymm4
  .byte  196,98,69,22,244                    // vpermps       %ymm4,%ymm7,%ymm14
  .byte  196,226,85,22,228                   // vpermps       %ymm4,%ymm5,%ymm4
  .byte  197,252,17,100,36,224               // vmovups       %ymm4,-0x20(%rsp)
  .byte  196,193,124,16,33                   // vmovups       (%r9),%ymm4
  .byte  196,98,69,22,196                    // vpermps       %ymm4,%ymm7,%ymm8
  .byte  196,98,85,22,204                    // vpermps       %ymm4,%ymm5,%ymm9
  .byte  76,139,64,48                        // mov           0x30(%rax),%r8
  .byte  196,193,124,16,32                   // vmovups       (%r8),%ymm4
  .byte  196,98,69,22,236                    // vpermps       %ymm4,%ymm7,%ymm13
  .byte  196,226,85,22,228                   // vpermps       %ymm4,%ymm5,%ymm4
  .byte  197,252,17,100,36,128               // vmovups       %ymm4,-0x80(%rsp)
  .byte  76,139,64,24                        // mov           0x18(%rax),%r8
  .byte  196,193,124,16,32                   // vmovups       (%r8),%ymm4
  .byte  196,98,69,22,212                    // vpermps       %ymm4,%ymm7,%ymm10
  .byte  196,98,85,22,220                    // vpermps       %ymm4,%ymm5,%ymm11
  .byte  76,139,64,56                        // mov           0x38(%rax),%r8
  .byte  196,193,124,16,48                   // vmovups       (%r8),%ymm6
  .byte  196,226,69,22,230                   // vpermps       %ymm6,%ymm7,%ymm4
  .byte  196,226,85,22,246                   // vpermps       %ymm6,%ymm5,%ymm6
  .byte  76,139,64,32                        // mov           0x20(%rax),%r8
  .byte  196,65,124,16,32                    // vmovups       (%r8),%ymm12
  .byte  196,66,69,22,252                    // vpermps       %ymm12,%ymm7,%ymm15
  .byte  197,124,17,124,36,192               // vmovups       %ymm15,-0x40(%rsp)
  .byte  196,66,85,22,228                    // vpermps       %ymm12,%ymm5,%ymm12
  .byte  197,124,17,100,36,160               // vmovups       %ymm12,-0x60(%rsp)
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  197,124,16,56                       // vmovups       (%rax),%ymm15
  .byte  196,66,69,22,231                    // vpermps       %ymm15,%ymm7,%ymm12
  .byte  196,194,85,22,255                   // vpermps       %ymm15,%ymm5,%ymm7
  .byte  233,34,1,0,0                        // jmpq          3054e <_sk_gradient_hsw_lowp+0x243>
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  196,194,101,146,20,184              // vgatherdps    %ymm3,(%r8,%ymm7,4),%ymm2
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  196,194,93,146,28,168               // vgatherdps    %ymm4,(%r8,%ymm5,4),%ymm3
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  196,66,93,146,4,185                 // vgatherdps    %ymm4,(%r9,%ymm7,4),%ymm8
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  196,66,93,146,12,169                // vgatherdps    %ymm4,(%r9,%ymm5,4),%ymm9
  .byte  76,139,64,24                        // mov           0x18(%rax),%r8
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  196,66,93,146,20,184                // vgatherdps    %ymm4,(%r8,%ymm7,4),%ymm10
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  196,66,93,146,28,168                // vgatherdps    %ymm4,(%r8,%ymm5,4),%ymm11
  .byte  76,139,64,32                        // mov           0x20(%rax),%r8
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  196,194,93,146,52,184               // vgatherdps    %ymm4,(%r8,%ymm7,4),%ymm6
  .byte  197,252,17,116,36,192               // vmovups       %ymm6,-0x40(%rsp)
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  196,194,93,146,52,168               // vgatherdps    %ymm4,(%r8,%ymm5,4),%ymm6
  .byte  197,252,17,116,36,160               // vmovups       %ymm6,-0x60(%rsp)
  .byte  76,139,64,40                        // mov           0x28(%rax),%r8
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,65,12,87,246                    // vxorps        %ymm14,%ymm14,%ymm14
  .byte  196,66,93,146,52,184                // vgatherdps    %ymm4,(%r8,%ymm7,4),%ymm14
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  196,194,93,146,52,168               // vgatherdps    %ymm4,(%r8,%ymm5,4),%ymm6
  .byte  197,252,17,116,36,224               // vmovups       %ymm6,-0x20(%rsp)
  .byte  76,139,64,48                        // mov           0x30(%rax),%r8
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,65,20,87,237                    // vxorps        %ymm13,%ymm13,%ymm13
  .byte  196,66,93,146,44,184                // vgatherdps    %ymm4,(%r8,%ymm7,4),%ymm13
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  196,194,93,146,52,168               // vgatherdps    %ymm4,(%r8,%ymm5,4),%ymm6
  .byte  197,252,17,116,36,128               // vmovups       %ymm6,-0x80(%rsp)
  .byte  76,139,64,56                        // mov           0x38(%rax),%r8
  .byte  197,205,118,246                     // vpcmpeqd      %ymm6,%ymm6,%ymm6
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  196,194,77,146,36,184               // vgatherdps    %ymm6,(%r8,%ymm7,4),%ymm4
  .byte  196,65,29,118,228                   // vpcmpeqd      %ymm12,%ymm12,%ymm12
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  196,194,29,146,52,168               // vgatherdps    %ymm12,(%r8,%ymm5,4),%ymm6
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  196,65,5,118,255                    // vpcmpeqd      %ymm15,%ymm15,%ymm15
  .byte  196,65,28,87,228                    // vxorps        %ymm12,%ymm12,%ymm12
  .byte  196,98,5,146,36,184                 // vgatherdps    %ymm15,(%rax,%ymm7,4),%ymm12
  .byte  196,65,5,118,255                    // vpcmpeqd      %ymm15,%ymm15,%ymm15
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  196,226,5,146,60,168                // vgatherdps    %ymm15,(%rax,%ymm5,4),%ymm7
  .byte  196,194,125,168,214                 // vfmadd213ps   %ymm14,%ymm0,%ymm2
  .byte  196,66,125,168,197                  // vfmadd213ps   %ymm13,%ymm0,%ymm8
  .byte  196,98,125,168,212                  // vfmadd213ps   %ymm4,%ymm0,%ymm10
  .byte  196,98,125,184,100,36,192           // vfmadd231ps   -0x40(%rsp),%ymm0,%ymm12
  .byte  196,226,117,168,92,36,224           // vfmadd213ps   -0x20(%rsp),%ymm1,%ymm3
  .byte  196,98,117,168,76,36,128            // vfmadd213ps   -0x80(%rsp),%ymm1,%ymm9
  .byte  196,98,117,168,222                  // vfmadd213ps   %ymm6,%ymm1,%ymm11
  .byte  196,226,117,184,124,36,160          // vfmadd231ps   -0x60(%rsp),%ymm1,%ymm7
  .byte  196,226,125,24,5,189,156,0,0        // vbroadcastss  0x9cbd(%rip),%ymm0        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,226,125,24,13,132,156,0,0       // vbroadcastss  0x9c84(%rip),%ymm1        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,226,125,168,217                 // vfmadd213ps   %ymm1,%ymm0,%ymm3
  .byte  196,226,125,168,209                 // vfmadd213ps   %ymm1,%ymm0,%ymm2
  .byte  196,98,125,168,201                  // vfmadd213ps   %ymm1,%ymm0,%ymm9
  .byte  196,98,125,168,193                  // vfmadd213ps   %ymm1,%ymm0,%ymm8
  .byte  196,98,125,168,217                  // vfmadd213ps   %ymm1,%ymm0,%ymm11
  .byte  196,98,125,168,209                  // vfmadd213ps   %ymm1,%ymm0,%ymm10
  .byte  196,226,125,168,249                 // vfmadd213ps   %ymm1,%ymm0,%ymm7
  .byte  196,98,125,168,225                  // vfmadd213ps   %ymm1,%ymm0,%ymm12
  .byte  197,254,91,194                      // vcvttps2dq    %ymm2,%ymm0
  .byte  197,253,111,37,92,164,0,0           // vmovdqa       0xa45c(%rip),%ymm4        # 3aa20 <_sk_srcover_bgra_8888_sse2_lowp+0xab8>
  .byte  196,226,125,0,196                   // vpshufb       %ymm4,%ymm0,%ymm0
  .byte  196,227,253,0,192,232               // vpermq        $0xe8,%ymm0,%ymm0
  .byte  197,254,91,203                      // vcvttps2dq    %ymm3,%ymm1
  .byte  196,226,117,0,204                   // vpshufb       %ymm4,%ymm1,%ymm1
  .byte  196,227,253,0,201,232               // vpermq        $0xe8,%ymm1,%ymm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,193,126,91,200                  // vcvttps2dq    %ymm8,%ymm1
  .byte  196,226,117,0,204                   // vpshufb       %ymm4,%ymm1,%ymm1
  .byte  196,227,253,0,201,232               // vpermq        $0xe8,%ymm1,%ymm1
  .byte  196,193,126,91,209                  // vcvttps2dq    %ymm9,%ymm2
  .byte  196,226,109,0,212                   // vpshufb       %ymm4,%ymm2,%ymm2
  .byte  196,227,253,0,210,232               // vpermq        $0xe8,%ymm2,%ymm2
  .byte  196,227,117,56,202,1                // vinserti128   $0x1,%xmm2,%ymm1,%ymm1
  .byte  196,193,126,91,210                  // vcvttps2dq    %ymm10,%ymm2
  .byte  196,226,109,0,212                   // vpshufb       %ymm4,%ymm2,%ymm2
  .byte  196,227,253,0,210,232               // vpermq        $0xe8,%ymm2,%ymm2
  .byte  196,193,126,91,219                  // vcvttps2dq    %ymm11,%ymm3
  .byte  196,226,101,0,220                   // vpshufb       %ymm4,%ymm3,%ymm3
  .byte  196,227,253,0,219,232               // vpermq        $0xe8,%ymm3,%ymm3
  .byte  196,227,109,56,211,1                // vinserti128   $0x1,%xmm3,%ymm2,%ymm2
  .byte  196,193,126,91,220                  // vcvttps2dq    %ymm12,%ymm3
  .byte  196,226,101,0,220                   // vpshufb       %ymm4,%ymm3,%ymm3
  .byte  197,254,91,239                      // vcvttps2dq    %ymm7,%ymm5
  .byte  196,226,85,0,228                    // vpshufb       %ymm4,%ymm5,%ymm4
  .byte  196,227,253,0,219,232               // vpermq        $0xe8,%ymm3,%ymm3
  .byte  196,227,253,0,228,232               // vpermq        $0xe8,%ymm4,%ymm4
  .byte  196,227,101,56,220,1                // vinserti128   $0x1,%xmm4,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,36,36                    // vmovups       (%rsp),%ymm4
  .byte  197,252,16,108,36,32                // vmovups       0x20(%rsp),%ymm5
  .byte  197,252,16,116,36,64                // vmovups       0x40(%rsp),%ymm6
  .byte  197,252,16,124,36,96                // vmovups       0x60(%rsp),%ymm7
  .byte  72,129,196,152,0,0,0                // add           $0x98,%rsp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_gradient_hsw_lowp
.globl _sk_evenly_spaced_gradient_hsw_lowp
FUNCTION(_sk_evenly_spaced_gradient_hsw_lowp)
_sk_evenly_spaced_gradient_hsw_lowp:
  .byte  72,129,236,152,0,0,0                // sub           $0x98,%rsp
  .byte  197,252,17,124,36,96                // vmovups       %ymm7,0x60(%rsp)
  .byte  197,252,17,116,36,64                // vmovups       %ymm6,0x40(%rsp)
  .byte  197,252,17,108,36,32                // vmovups       %ymm5,0x20(%rsp)
  .byte  197,254,127,36,36                   // vmovdqu       %ymm4,(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  77,137,193                          // mov           %r8,%r9
  .byte  73,255,201                          // dec           %r9
  .byte  120,7                               // js            306a9 <_sk_evenly_spaced_gradient_hsw_lowp+0x32>
  .byte  196,193,234,42,209                  // vcvtsi2ss     %r9,%xmm2,%xmm2
  .byte  235,22                              // jmp           306bf <_sk_evenly_spaced_gradient_hsw_lowp+0x48>
  .byte  77,137,202                          // mov           %r9,%r10
  .byte  73,209,234                          // shr           %r10
  .byte  65,131,225,1                        // and           $0x1,%r9d
  .byte  77,9,209                            // or            %r10,%r9
  .byte  196,193,234,42,209                  // vcvtsi2ss     %r9,%xmm2,%xmm2
  .byte  197,234,88,210                      // vaddss        %xmm2,%xmm2,%xmm2
  .byte  196,226,125,24,210                  // vbroadcastss  %xmm2,%ymm2
  .byte  197,252,89,218                      // vmulps        %ymm2,%ymm0,%ymm3
  .byte  197,244,89,210                      // vmulps        %ymm2,%ymm1,%ymm2
  .byte  197,126,91,242                      // vcvttps2dq    %ymm2,%ymm14
  .byte  197,254,91,251                      // vcvttps2dq    %ymm3,%ymm7
  .byte  73,131,248,8                        // cmp           $0x8,%r8
  .byte  15,135,180,0,0,0                    // ja            30792 <_sk_evenly_spaced_gradient_hsw_lowp+0x11b>
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  196,193,124,16,24                   // vmovups       (%r8),%ymm3
  .byte  196,226,69,22,211                   // vpermps       %ymm3,%ymm7,%ymm2
  .byte  196,226,13,22,219                   // vpermps       %ymm3,%ymm14,%ymm3
  .byte  76,139,64,40                        // mov           0x28(%rax),%r8
  .byte  196,193,124,16,32                   // vmovups       (%r8),%ymm4
  .byte  196,98,69,22,236                    // vpermps       %ymm4,%ymm7,%ymm13
  .byte  196,226,13,22,228                   // vpermps       %ymm4,%ymm14,%ymm4
  .byte  197,252,17,100,36,224               // vmovups       %ymm4,-0x20(%rsp)
  .byte  196,193,124,16,33                   // vmovups       (%r9),%ymm4
  .byte  196,98,69,22,196                    // vpermps       %ymm4,%ymm7,%ymm8
  .byte  196,98,13,22,204                    // vpermps       %ymm4,%ymm14,%ymm9
  .byte  76,139,64,48                        // mov           0x30(%rax),%r8
  .byte  196,193,124,16,40                   // vmovups       (%r8),%ymm5
  .byte  196,226,69,22,229                   // vpermps       %ymm5,%ymm7,%ymm4
  .byte  196,226,13,22,237                   // vpermps       %ymm5,%ymm14,%ymm5
  .byte  197,252,17,108,36,128               // vmovups       %ymm5,-0x80(%rsp)
  .byte  76,139,64,24                        // mov           0x18(%rax),%r8
  .byte  196,193,124,16,40                   // vmovups       (%r8),%ymm5
  .byte  196,98,69,22,213                    // vpermps       %ymm5,%ymm7,%ymm10
  .byte  196,98,13,22,221                    // vpermps       %ymm5,%ymm14,%ymm11
  .byte  76,139,64,56                        // mov           0x38(%rax),%r8
  .byte  196,193,124,16,48                   // vmovups       (%r8),%ymm6
  .byte  196,226,69,22,238                   // vpermps       %ymm6,%ymm7,%ymm5
  .byte  196,226,13,22,246                   // vpermps       %ymm6,%ymm14,%ymm6
  .byte  76,139,64,32                        // mov           0x20(%rax),%r8
  .byte  196,65,124,16,32                    // vmovups       (%r8),%ymm12
  .byte  196,66,69,22,252                    // vpermps       %ymm12,%ymm7,%ymm15
  .byte  197,124,17,124,36,192               // vmovups       %ymm15,-0x40(%rsp)
  .byte  196,66,13,22,228                    // vpermps       %ymm12,%ymm14,%ymm12
  .byte  197,124,17,100,36,160               // vmovups       %ymm12,-0x60(%rsp)
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  197,124,16,56                       // vmovups       (%rax),%ymm15
  .byte  196,66,69,22,231                    // vpermps       %ymm15,%ymm7,%ymm12
  .byte  196,194,13,22,255                   // vpermps       %ymm15,%ymm14,%ymm7
  .byte  233,33,1,0,0                        // jmpq          308b3 <_sk_evenly_spaced_gradient_hsw_lowp+0x23c>
  .byte  76,139,64,8                         // mov           0x8(%rax),%r8
  .byte  76,139,72,16                        // mov           0x10(%rax),%r9
  .byte  197,236,87,210                      // vxorps        %ymm2,%ymm2,%ymm2
  .byte  197,229,118,219                     // vpcmpeqd      %ymm3,%ymm3,%ymm3
  .byte  196,194,101,146,20,184              // vgatherdps    %ymm3,(%r8,%ymm7,4),%ymm2
  .byte  197,228,87,219                      // vxorps        %ymm3,%ymm3,%ymm3
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,130,93,146,28,176               // vgatherdps    %ymm4,(%r8,%ymm14,4),%ymm3
  .byte  196,65,60,87,192                    // vxorps        %ymm8,%ymm8,%ymm8
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,66,93,146,4,185                 // vgatherdps    %ymm4,(%r9,%ymm7,4),%ymm8
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,2,93,146,12,177                 // vgatherdps    %ymm4,(%r9,%ymm14,4),%ymm9
  .byte  76,139,64,24                        // mov           0x18(%rax),%r8
  .byte  196,65,44,87,210                    // vxorps        %ymm10,%ymm10,%ymm10
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,66,93,146,20,184                // vgatherdps    %ymm4,(%r8,%ymm7,4),%ymm10
  .byte  196,65,36,87,219                    // vxorps        %ymm11,%ymm11,%ymm11
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,2,93,146,28,176                 // vgatherdps    %ymm4,(%r8,%ymm14,4),%ymm11
  .byte  76,139,64,32                        // mov           0x20(%rax),%r8
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,194,93,146,44,184               // vgatherdps    %ymm4,(%r8,%ymm7,4),%ymm5
  .byte  197,252,17,108,36,192               // vmovups       %ymm5,-0x40(%rsp)
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,130,93,146,44,176               // vgatherdps    %ymm4,(%r8,%ymm14,4),%ymm5
  .byte  197,252,17,108,36,160               // vmovups       %ymm5,-0x60(%rsp)
  .byte  76,139,64,40                        // mov           0x28(%rax),%r8
  .byte  196,65,20,87,237                    // vxorps        %ymm13,%ymm13,%ymm13
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,66,93,146,44,184                // vgatherdps    %ymm4,(%r8,%ymm7,4),%ymm13
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,221,118,228                     // vpcmpeqd      %ymm4,%ymm4,%ymm4
  .byte  196,130,93,146,44,176               // vgatherdps    %ymm4,(%r8,%ymm14,4),%ymm5
  .byte  197,252,17,108,36,224               // vmovups       %ymm5,-0x20(%rsp)
  .byte  76,139,64,48                        // mov           0x30(%rax),%r8
  .byte  197,220,87,228                      // vxorps        %ymm4,%ymm4,%ymm4
  .byte  197,213,118,237                     // vpcmpeqd      %ymm5,%ymm5,%ymm5
  .byte  196,194,85,146,36,184               // vgatherdps    %ymm5,(%r8,%ymm7,4),%ymm4
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  197,213,118,237                     // vpcmpeqd      %ymm5,%ymm5,%ymm5
  .byte  196,130,85,146,52,176               // vgatherdps    %ymm5,(%r8,%ymm14,4),%ymm6
  .byte  197,252,17,116,36,128               // vmovups       %ymm6,-0x80(%rsp)
  .byte  76,139,64,56                        // mov           0x38(%rax),%r8
  .byte  197,212,87,237                      // vxorps        %ymm5,%ymm5,%ymm5
  .byte  197,205,118,246                     // vpcmpeqd      %ymm6,%ymm6,%ymm6
  .byte  196,194,77,146,44,184               // vgatherdps    %ymm6,(%r8,%ymm7,4),%ymm5
  .byte  197,204,87,246                      // vxorps        %ymm6,%ymm6,%ymm6
  .byte  196,65,29,118,228                   // vpcmpeqd      %ymm12,%ymm12,%ymm12
  .byte  196,130,29,146,52,176               // vgatherdps    %ymm12,(%r8,%ymm14,4),%ymm6
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  196,65,28,87,228                    // vxorps        %ymm12,%ymm12,%ymm12
  .byte  196,65,5,118,255                    // vpcmpeqd      %ymm15,%ymm15,%ymm15
  .byte  196,98,5,146,36,184                 // vgatherdps    %ymm15,(%rax,%ymm7,4),%ymm12
  .byte  196,65,5,118,255                    // vpcmpeqd      %ymm15,%ymm15,%ymm15
  .byte  197,196,87,255                      // vxorps        %ymm7,%ymm7,%ymm7
  .byte  196,162,5,146,60,176                // vgatherdps    %ymm15,(%rax,%ymm14,4),%ymm7
  .byte  196,194,125,168,213                 // vfmadd213ps   %ymm13,%ymm0,%ymm2
  .byte  196,98,125,168,196                  // vfmadd213ps   %ymm4,%ymm0,%ymm8
  .byte  196,98,125,168,213                  // vfmadd213ps   %ymm5,%ymm0,%ymm10
  .byte  196,98,125,184,100,36,192           // vfmadd231ps   -0x40(%rsp),%ymm0,%ymm12
  .byte  196,226,117,168,92,36,224           // vfmadd213ps   -0x20(%rsp),%ymm1,%ymm3
  .byte  196,98,117,168,76,36,128            // vfmadd213ps   -0x80(%rsp),%ymm1,%ymm9
  .byte  196,98,117,168,222                  // vfmadd213ps   %ymm6,%ymm1,%ymm11
  .byte  196,226,117,184,124,36,160          // vfmadd231ps   -0x60(%rsp),%ymm1,%ymm7
  .byte  196,226,125,24,5,88,153,0,0         // vbroadcastss  0x9958(%rip),%ymm0        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,226,125,24,13,31,153,0,0        // vbroadcastss  0x991f(%rip),%ymm1        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,226,125,168,217                 // vfmadd213ps   %ymm1,%ymm0,%ymm3
  .byte  196,226,125,168,209                 // vfmadd213ps   %ymm1,%ymm0,%ymm2
  .byte  196,98,125,168,201                  // vfmadd213ps   %ymm1,%ymm0,%ymm9
  .byte  196,98,125,168,193                  // vfmadd213ps   %ymm1,%ymm0,%ymm8
  .byte  196,98,125,168,217                  // vfmadd213ps   %ymm1,%ymm0,%ymm11
  .byte  196,98,125,168,209                  // vfmadd213ps   %ymm1,%ymm0,%ymm10
  .byte  196,226,125,168,249                 // vfmadd213ps   %ymm1,%ymm0,%ymm7
  .byte  196,98,125,168,225                  // vfmadd213ps   %ymm1,%ymm0,%ymm12
  .byte  197,254,91,194                      // vcvttps2dq    %ymm2,%ymm0
  .byte  197,253,111,37,23,161,0,0           // vmovdqa       0xa117(%rip),%ymm4        # 3aa40 <_sk_srcover_bgra_8888_sse2_lowp+0xad8>
  .byte  196,226,125,0,196                   // vpshufb       %ymm4,%ymm0,%ymm0
  .byte  196,227,253,0,192,232               // vpermq        $0xe8,%ymm0,%ymm0
  .byte  197,254,91,203                      // vcvttps2dq    %ymm3,%ymm1
  .byte  196,226,117,0,204                   // vpshufb       %ymm4,%ymm1,%ymm1
  .byte  196,227,253,0,201,232               // vpermq        $0xe8,%ymm1,%ymm1
  .byte  196,227,125,56,193,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm0
  .byte  196,193,126,91,200                  // vcvttps2dq    %ymm8,%ymm1
  .byte  196,226,117,0,204                   // vpshufb       %ymm4,%ymm1,%ymm1
  .byte  196,227,253,0,201,232               // vpermq        $0xe8,%ymm1,%ymm1
  .byte  196,193,126,91,209                  // vcvttps2dq    %ymm9,%ymm2
  .byte  196,226,109,0,212                   // vpshufb       %ymm4,%ymm2,%ymm2
  .byte  196,227,253,0,210,232               // vpermq        $0xe8,%ymm2,%ymm2
  .byte  196,227,117,56,202,1                // vinserti128   $0x1,%xmm2,%ymm1,%ymm1
  .byte  196,193,126,91,210                  // vcvttps2dq    %ymm10,%ymm2
  .byte  196,226,109,0,212                   // vpshufb       %ymm4,%ymm2,%ymm2
  .byte  196,227,253,0,210,232               // vpermq        $0xe8,%ymm2,%ymm2
  .byte  196,193,126,91,219                  // vcvttps2dq    %ymm11,%ymm3
  .byte  196,226,101,0,220                   // vpshufb       %ymm4,%ymm3,%ymm3
  .byte  196,227,253,0,219,232               // vpermq        $0xe8,%ymm3,%ymm3
  .byte  196,227,109,56,211,1                // vinserti128   $0x1,%xmm3,%ymm2,%ymm2
  .byte  196,193,126,91,220                  // vcvttps2dq    %ymm12,%ymm3
  .byte  196,226,101,0,220                   // vpshufb       %ymm4,%ymm3,%ymm3
  .byte  197,254,91,239                      // vcvttps2dq    %ymm7,%ymm5
  .byte  196,226,85,0,228                    // vpshufb       %ymm4,%ymm5,%ymm4
  .byte  196,227,253,0,219,232               // vpermq        $0xe8,%ymm3,%ymm3
  .byte  196,227,253,0,228,232               // vpermq        $0xe8,%ymm4,%ymm4
  .byte  196,227,101,56,220,1                // vinserti128   $0x1,%xmm4,%ymm3,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,16,36,36                    // vmovups       (%rsp),%ymm4
  .byte  197,252,16,108,36,32                // vmovups       0x20(%rsp),%ymm5
  .byte  197,252,16,116,36,64                // vmovups       0x40(%rsp),%ymm6
  .byte  197,252,16,124,36,96                // vmovups       0x60(%rsp),%ymm7
  .byte  72,129,196,152,0,0,0                // add           $0x98,%rsp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_2_stop_gradient_hsw_lowp
.globl _sk_evenly_spaced_2_stop_gradient_hsw_lowp
FUNCTION(_sk_evenly_spaced_2_stop_gradient_hsw_lowp)
_sk_evenly_spaced_2_stop_gradient_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  196,226,125,24,16                   // vbroadcastss  (%rax),%ymm2
  .byte  196,226,125,24,88,16                // vbroadcastss  0x10(%rax),%ymm3
  .byte  197,124,40,194                      // vmovaps       %ymm2,%ymm8
  .byte  196,98,125,168,195                  // vfmadd213ps   %ymm3,%ymm0,%ymm8
  .byte  196,226,117,168,211                 // vfmadd213ps   %ymm3,%ymm1,%ymm2
  .byte  196,226,125,24,29,68,152,0,0        // vbroadcastss  0x9844(%rip),%ymm3        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  196,98,125,24,29,11,152,0,0         // vbroadcastss  0x980b(%rip),%ymm11        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  196,194,101,168,211                 // vfmadd213ps   %ymm11,%ymm3,%ymm2
  .byte  196,66,101,168,195                  // vfmadd213ps   %ymm11,%ymm3,%ymm8
  .byte  196,65,126,91,192                   // vcvttps2dq    %ymm8,%ymm8
  .byte  197,125,111,21,64,160,0,0           // vmovdqa       0xa040(%rip),%ymm10        # 3aa60 <_sk_srcover_bgra_8888_sse2_lowp+0xaf8>
  .byte  196,66,61,0,194                     // vpshufb       %ymm10,%ymm8,%ymm8
  .byte  196,67,253,0,192,232                // vpermq        $0xe8,%ymm8,%ymm8
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,194,109,0,210                   // vpshufb       %ymm10,%ymm2,%ymm2
  .byte  196,227,253,0,210,232               // vpermq        $0xe8,%ymm2,%ymm2
  .byte  196,99,61,56,194,1                  // vinserti128   $0x1,%xmm2,%ymm8,%ymm8
  .byte  196,226,125,24,80,4                 // vbroadcastss  0x4(%rax),%ymm2
  .byte  196,98,125,24,72,20                 // vbroadcastss  0x14(%rax),%ymm9
  .byte  197,124,40,226                      // vmovaps       %ymm2,%ymm12
  .byte  196,66,125,168,225                  // vfmadd213ps   %ymm9,%ymm0,%ymm12
  .byte  196,194,117,168,209                 // vfmadd213ps   %ymm9,%ymm1,%ymm2
  .byte  196,194,101,168,211                 // vfmadd213ps   %ymm11,%ymm3,%ymm2
  .byte  196,66,101,168,227                  // vfmadd213ps   %ymm11,%ymm3,%ymm12
  .byte  196,65,126,91,204                   // vcvttps2dq    %ymm12,%ymm9
  .byte  196,66,53,0,202                     // vpshufb       %ymm10,%ymm9,%ymm9
  .byte  196,67,253,0,201,232                // vpermq        $0xe8,%ymm9,%ymm9
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,194,109,0,210                   // vpshufb       %ymm10,%ymm2,%ymm2
  .byte  196,227,253,0,210,232               // vpermq        $0xe8,%ymm2,%ymm2
  .byte  196,99,53,56,202,1                  // vinserti128   $0x1,%xmm2,%ymm9,%ymm9
  .byte  196,226,125,24,80,8                 // vbroadcastss  0x8(%rax),%ymm2
  .byte  196,98,125,24,96,24                 // vbroadcastss  0x18(%rax),%ymm12
  .byte  197,124,40,234                      // vmovaps       %ymm2,%ymm13
  .byte  196,66,125,168,236                  // vfmadd213ps   %ymm12,%ymm0,%ymm13
  .byte  196,194,117,168,212                 // vfmadd213ps   %ymm12,%ymm1,%ymm2
  .byte  196,194,101,168,211                 // vfmadd213ps   %ymm11,%ymm3,%ymm2
  .byte  196,66,101,168,235                  // vfmadd213ps   %ymm11,%ymm3,%ymm13
  .byte  196,65,126,91,229                   // vcvttps2dq    %ymm13,%ymm12
  .byte  196,66,29,0,226                     // vpshufb       %ymm10,%ymm12,%ymm12
  .byte  196,67,253,0,228,232                // vpermq        $0xe8,%ymm12,%ymm12
  .byte  197,254,91,210                      // vcvttps2dq    %ymm2,%ymm2
  .byte  196,194,109,0,210                   // vpshufb       %ymm10,%ymm2,%ymm2
  .byte  196,227,253,0,210,232               // vpermq        $0xe8,%ymm2,%ymm2
  .byte  196,227,29,56,210,1                 // vinserti128   $0x1,%xmm2,%ymm12,%ymm2
  .byte  196,98,125,24,96,12                 // vbroadcastss  0xc(%rax),%ymm12
  .byte  196,98,125,24,104,28                // vbroadcastss  0x1c(%rax),%ymm13
  .byte  196,194,29,168,197                  // vfmadd213ps   %ymm13,%ymm12,%ymm0
  .byte  196,66,117,168,229                  // vfmadd213ps   %ymm13,%ymm1,%ymm12
  .byte  196,66,101,168,227                  // vfmadd213ps   %ymm11,%ymm3,%ymm12
  .byte  196,194,101,168,195                 // vfmadd213ps   %ymm11,%ymm3,%ymm0
  .byte  197,254,91,192                      // vcvttps2dq    %ymm0,%ymm0
  .byte  196,194,125,0,194                   // vpshufb       %ymm10,%ymm0,%ymm0
  .byte  196,227,253,0,192,232               // vpermq        $0xe8,%ymm0,%ymm0
  .byte  196,193,126,91,204                  // vcvttps2dq    %ymm12,%ymm1
  .byte  196,194,117,0,202                   // vpshufb       %ymm10,%ymm1,%ymm1
  .byte  196,227,253,0,201,232               // vpermq        $0xe8,%ymm1,%ymm1
  .byte  196,227,125,56,217,1                // vinserti128   $0x1,%xmm1,%ymm0,%ymm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,125,127,192                     // vmovdqa       %ymm8,%ymm0
  .byte  197,125,127,201                     // vmovdqa       %ymm9,%ymm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_unit_angle_hsw_lowp
.globl _sk_xy_to_unit_angle_hsw_lowp
FUNCTION(_sk_xy_to_unit_angle_hsw_lowp)
_sk_xy_to_unit_angle_hsw_lowp:
  .byte  197,252,17,124,36,200               // vmovups       %ymm7,-0x38(%rsp)
  .byte  197,252,40,254                      // vmovaps       %ymm6,%ymm7
  .byte  197,252,40,245                      // vmovaps       %ymm5,%ymm6
  .byte  197,252,40,236                      // vmovaps       %ymm4,%ymm5
  .byte  197,252,40,227                      // vmovaps       %ymm3,%ymm4
  .byte  197,252,40,217                      // vmovaps       %ymm1,%ymm3
  .byte  197,252,40,200                      // vmovaps       %ymm0,%ymm1
  .byte  196,98,125,24,5,94,152,0,0          // vbroadcastss  0x985e(%rip),%ymm8        # 3a3a8 <_sk_srcover_bgra_8888_sse2_lowp+0x440>
  .byte  196,65,116,84,200                   // vandps        %ymm8,%ymm1,%ymm9
  .byte  196,65,100,84,208                   // vandps        %ymm8,%ymm3,%ymm10
  .byte  196,65,108,84,216                   // vandps        %ymm8,%ymm2,%ymm11
  .byte  196,65,92,84,192                    // vandps        %ymm8,%ymm4,%ymm8
  .byte  196,65,44,194,224,1                 // vcmpltps      %ymm8,%ymm10,%ymm12
  .byte  196,65,52,194,235,1                 // vcmpltps      %ymm11,%ymm9,%ymm13
  .byte  196,67,37,74,241,208                // vblendvps     %ymm13,%ymm9,%ymm11,%ymm14
  .byte  196,67,61,74,250,192                // vblendvps     %ymm12,%ymm10,%ymm8,%ymm15
  .byte  196,67,53,74,203,208                // vblendvps     %ymm13,%ymm11,%ymm9,%ymm9
  .byte  196,65,12,94,201                    // vdivps        %ymm9,%ymm14,%ymm9
  .byte  196,67,45,74,192,192                // vblendvps     %ymm12,%ymm8,%ymm10,%ymm8
  .byte  196,65,4,94,192                     // vdivps        %ymm8,%ymm15,%ymm8
  .byte  196,65,60,89,208                    // vmulps        %ymm8,%ymm8,%ymm10
  .byte  196,98,125,24,29,170,151,0,0        // vbroadcastss  0x97aa(%rip),%ymm11        # 3a344 <_sk_srcover_bgra_8888_sse2_lowp+0x3dc>
  .byte  196,98,125,24,53,165,151,0,0        // vbroadcastss  0x97a5(%rip),%ymm14        # 3a348 <_sk_srcover_bgra_8888_sse2_lowp+0x3e0>
  .byte  196,65,124,40,251                   // vmovaps       %ymm11,%ymm15
  .byte  196,66,45,168,254                   // vfmadd213ps   %ymm14,%ymm10,%ymm15
  .byte  196,193,52,89,193                   // vmulps        %ymm9,%ymm9,%ymm0
  .byte  196,66,125,168,222                  // vfmadd213ps   %ymm14,%ymm0,%ymm11
  .byte  196,98,125,24,53,140,151,0,0        // vbroadcastss  0x978c(%rip),%ymm14        # 3a34c <_sk_srcover_bgra_8888_sse2_lowp+0x3e4>
  .byte  196,66,125,168,222                  // vfmadd213ps   %ymm14,%ymm0,%ymm11
  .byte  196,66,45,168,254                   // vfmadd213ps   %ymm14,%ymm10,%ymm15
  .byte  196,98,125,24,53,125,151,0,0        // vbroadcastss  0x977d(%rip),%ymm14        # 3a350 <_sk_srcover_bgra_8888_sse2_lowp+0x3e8>
  .byte  196,66,45,168,254                   // vfmadd213ps   %ymm14,%ymm10,%ymm15
  .byte  196,66,125,168,222                  // vfmadd213ps   %ymm14,%ymm0,%ymm11
  .byte  196,193,52,89,195                   // vmulps        %ymm11,%ymm9,%ymm0
  .byte  196,98,125,24,13,105,151,0,0        // vbroadcastss  0x9769(%rip),%ymm9        # 3a354 <_sk_srcover_bgra_8888_sse2_lowp+0x3ec>
  .byte  197,52,92,208                       // vsubps        %ymm0,%ymm9,%ymm10
  .byte  196,195,125,74,194,208              // vblendvps     %ymm13,%ymm10,%ymm0,%ymm0
  .byte  196,65,60,89,199                    // vmulps        %ymm15,%ymm8,%ymm8
  .byte  196,65,52,92,200                    // vsubps        %ymm8,%ymm9,%ymm9
  .byte  196,67,61,74,193,192                // vblendvps     %ymm12,%ymm9,%ymm8,%ymm8
  .byte  196,65,52,87,201                    // vxorps        %ymm9,%ymm9,%ymm9
  .byte  196,193,116,194,201,1               // vcmpltps      %ymm9,%ymm1,%ymm1
  .byte  196,98,125,24,21,251,149,0,0        // vbroadcastss  0x95fb(%rip),%ymm10        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  197,44,92,216                       // vsubps        %ymm0,%ymm10,%ymm11
  .byte  196,195,125,74,195,16               // vblendvps     %ymm1,%ymm11,%ymm0,%ymm0
  .byte  196,193,100,194,201,1               // vcmpltps      %ymm9,%ymm3,%ymm1
  .byte  196,193,44,92,216                   // vsubps        %ymm8,%ymm10,%ymm3
  .byte  196,227,61,74,203,16                // vblendvps     %ymm1,%ymm3,%ymm8,%ymm1
  .byte  196,193,108,194,217,1               // vcmpltps      %ymm9,%ymm2,%ymm3
  .byte  196,98,125,24,5,213,149,0,0         // vbroadcastss  0x95d5(%rip),%ymm8        # 3a218 <_sk_srcover_bgra_8888_sse2_lowp+0x2b0>
  .byte  197,60,92,208                       // vsubps        %ymm0,%ymm8,%ymm10
  .byte  196,195,125,74,194,48               // vblendvps     %ymm3,%ymm10,%ymm0,%ymm0
  .byte  196,193,92,194,217,1                // vcmpltps      %ymm9,%ymm4,%ymm3
  .byte  197,60,92,193                       // vsubps        %ymm1,%ymm8,%ymm8
  .byte  196,195,117,74,200,48               // vblendvps     %ymm3,%ymm8,%ymm1,%ymm1
  .byte  196,193,124,194,217,7               // vcmpordps     %ymm9,%ymm0,%ymm3
  .byte  197,228,84,192                      // vandps        %ymm0,%ymm3,%ymm0
  .byte  196,193,116,194,217,7               // vcmpordps     %ymm9,%ymm1,%ymm3
  .byte  197,228,84,201                      // vandps        %ymm1,%ymm3,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  197,252,40,220                      // vmovaps       %ymm4,%ymm3
  .byte  197,252,40,229                      // vmovaps       %ymm5,%ymm4
  .byte  197,252,40,238                      // vmovaps       %ymm6,%ymm5
  .byte  197,252,40,247                      // vmovaps       %ymm7,%ymm6
  .byte  197,252,16,124,36,200               // vmovups       -0x38(%rsp),%ymm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_radius_hsw_lowp
.globl _sk_xy_to_radius_hsw_lowp
FUNCTION(_sk_xy_to_radius_hsw_lowp)
_sk_xy_to_radius_hsw_lowp:
  .byte  197,108,89,194                      // vmulps        %ymm2,%ymm2,%ymm8
  .byte  197,100,89,203                      // vmulps        %ymm3,%ymm3,%ymm9
  .byte  196,98,117,184,201                  // vfmadd231ps   %ymm1,%ymm1,%ymm9
  .byte  196,98,125,184,192                  // vfmadd231ps   %ymm0,%ymm0,%ymm8
  .byte  196,193,124,81,192                  // vsqrtps       %ymm8,%ymm0
  .byte  196,193,124,81,201                  // vsqrtps       %ymm9,%ymm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_rgba_8888_hsw_lowp
.globl _sk_srcover_rgba_8888_hsw_lowp
FUNCTION(_sk_srcover_rgba_8888_hsw_lowp)
_sk_srcover_rgba_8888_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  77,141,12,144                       // lea           (%r8,%rdx,4),%r9
  .byte  65,137,250                          // mov           %edi,%r10d
  .byte  65,128,226,15                       // and           $0xf,%r10b
  .byte  65,254,202                          // dec           %r10b
  .byte  69,15,182,194                       // movzbl        %r10b,%r8d
  .byte  65,128,248,14                       // cmp           $0xe,%r8b
  .byte  119,51                              // ja            30d07 <_sk_srcover_rgba_8888_hsw_lowp+0x5c>
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  76,141,29,237,2,0,0                 // lea           0x2ed(%rip),%r11        # 30fcc <_sk_srcover_rgba_8888_hsw_lowp+0x321>
  .byte  75,99,4,131                         // movslq        (%r11,%r8,4),%rax
  .byte  76,1,216                            // add           %r11,%rax
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  197,205,239,246                     // vpxor         %ymm6,%ymm6,%ymm6
  .byte  196,65,61,239,192                   // vpxor         %ymm8,%ymm8,%ymm8
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  255,224                             // jmpq          *%rax
  .byte  196,193,121,110,41                  // vmovd         (%r9),%xmm5
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  233,22,1,0,0                        // jmpq          30e1d <_sk_srcover_rgba_8888_hsw_lowp+0x172>
  .byte  196,193,126,111,41                  // vmovdqu       (%r9),%ymm5
  .byte  196,193,126,111,97,32               // vmovdqu       0x20(%r9),%ymm4
  .byte  233,6,1,0,0                         // jmpq          30e1d <_sk_srcover_rgba_8888_hsw_lowp+0x172>
  .byte  196,193,121,110,97,8                // vmovd         0x8(%r9),%xmm4
  .byte  196,226,121,89,228                  // vpbroadcastq  %xmm4,%xmm4
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  196,227,69,2,228,4                  // vpblendd      $0x4,%ymm4,%ymm7,%ymm4
  .byte  196,194,121,53,41                   // vpmovzxdq     (%r9),%xmm5
  .byte  197,249,112,237,232                 // vpshufd       $0xe8,%xmm5,%xmm5
  .byte  196,227,93,2,237,3                  // vpblendd      $0x3,%ymm5,%ymm4,%ymm5
  .byte  197,253,111,231                     // vmovdqa       %ymm7,%ymm4
  .byte  233,216,0,0,0                       // jmpq          30e1d <_sk_srcover_rgba_8888_hsw_lowp+0x172>
  .byte  196,193,121,110,97,24               // vmovd         0x18(%r9),%xmm4
  .byte  196,226,125,89,228                  // vpbroadcastq  %xmm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,228,64                 // vpblendd      $0x40,%ymm4,%ymm5,%ymm4
  .byte  196,227,125,57,230,1                // vextracti128  $0x1,%ymm4,%xmm6
  .byte  196,195,73,34,113,20,1              // vpinsrd       $0x1,0x14(%r9),%xmm6,%xmm6
  .byte  196,227,93,56,230,1                 // vinserti128   $0x1,%xmm6,%ymm4,%ymm4
  .byte  197,253,111,245                     // vmovdqa       %ymm5,%ymm6
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,195,81,34,105,16,0              // vpinsrd       $0x0,0x10(%r9),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  197,125,111,198                     // vmovdqa       %ymm6,%ymm8
  .byte  196,193,122,111,41                  // vmovdqu       (%r9),%xmm5
  .byte  196,227,85,2,236,240                // vpblendd      $0xf0,%ymm4,%ymm5,%ymm5
  .byte  197,125,127,196                     // vmovdqa       %ymm8,%ymm4
  .byte  233,129,0,0,0                       // jmpq          30e1d <_sk_srcover_rgba_8888_hsw_lowp+0x172>
  .byte  196,193,121,110,97,40               // vmovd         0x28(%r9),%xmm4
  .byte  196,226,121,89,228                  // vpbroadcastq  %xmm4,%xmm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,228,4                  // vpblendd      $0x4,%ymm4,%ymm5,%ymm4
  .byte  196,195,89,34,105,36,1              // vpinsrd       $0x1,0x24(%r9),%xmm4,%xmm5
  .byte  196,227,93,2,229,15                 // vpblendd      $0xf,%ymm5,%ymm4,%ymm4
  .byte  196,193,121,110,105,32              // vmovd         0x20(%r9),%xmm5
  .byte  196,227,93,2,229,1                  // vpblendd      $0x1,%ymm5,%ymm4,%ymm4
  .byte  196,193,126,111,41                  // vmovdqu       (%r9),%ymm5
  .byte  235,76                              // jmp           30e1d <_sk_srcover_rgba_8888_hsw_lowp+0x172>
  .byte  196,193,121,110,97,56               // vmovd         0x38(%r9),%xmm4
  .byte  196,226,125,89,228                  // vpbroadcastq  %xmm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,228,64                 // vpblendd      $0x40,%ymm4,%ymm5,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,195,81,34,105,52,1              // vpinsrd       $0x1,0x34(%r9),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,195,81,34,105,48,0              // vpinsrd       $0x0,0x30(%r9),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,193,126,111,41                  // vmovdqu       (%r9),%ymm5
  .byte  196,193,122,111,113,32              // vmovdqu       0x20(%r9),%xmm6
  .byte  196,227,77,2,228,240                // vpblendd      $0xf0,%ymm4,%ymm6,%ymm4
  .byte  196,227,85,56,244,1                 // vinserti128   $0x1,%xmm4,%ymm5,%ymm6
  .byte  196,227,85,70,252,49                // vperm2i128    $0x31,%ymm4,%ymm5,%ymm7
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  196,227,69,14,236,170               // vpblendw      $0xaa,%ymm4,%ymm7,%ymm5
  .byte  196,227,77,14,228,170               // vpblendw      $0xaa,%ymm4,%ymm6,%ymm4
  .byte  196,226,93,43,237                   // vpackusdw     %ymm5,%ymm4,%ymm5
  .byte  197,125,111,5,58,156,0,0            // vmovdqa       0x9c3a(%rip),%ymm8        # 3aa80 <_sk_srcover_bgra_8888_sse2_lowp+0xb18>
  .byte  196,193,85,219,224                  // vpand         %ymm8,%ymm5,%ymm4
  .byte  196,98,125,121,13,76,156,0,0        // vpbroadcastw  0x9c4c(%rip),%ymm9        # 3aaa0 <_sk_srcover_bgra_8888_sse2_lowp+0xb38>
  .byte  197,213,113,213,8                   // vpsrlw        $0x8,%ymm5,%ymm5
  .byte  197,197,114,215,16                  // vpsrld        $0x10,%ymm7,%ymm7
  .byte  197,205,114,214,16                  // vpsrld        $0x10,%ymm6,%ymm6
  .byte  196,226,77,43,255                   // vpackusdw     %ymm7,%ymm6,%ymm7
  .byte  196,193,69,219,240                  // vpand         %ymm8,%ymm7,%ymm6
  .byte  197,197,113,215,8                   // vpsrlw        $0x8,%ymm7,%ymm7
  .byte  197,53,249,195                      // vpsubw        %ymm3,%ymm9,%ymm8
  .byte  196,65,93,213,208                   // vpmullw       %ymm8,%ymm4,%ymm10
  .byte  196,65,45,253,209                   // vpaddw        %ymm9,%ymm10,%ymm10
  .byte  196,193,45,113,210,8                // vpsrlw        $0x8,%ymm10,%ymm10
  .byte  197,173,253,192                     // vpaddw        %ymm0,%ymm10,%ymm0
  .byte  196,65,85,213,208                   // vpmullw       %ymm8,%ymm5,%ymm10
  .byte  196,65,45,253,209                   // vpaddw        %ymm9,%ymm10,%ymm10
  .byte  196,193,45,113,210,8                // vpsrlw        $0x8,%ymm10,%ymm10
  .byte  197,173,253,201                     // vpaddw        %ymm1,%ymm10,%ymm1
  .byte  196,65,77,213,208                   // vpmullw       %ymm8,%ymm6,%ymm10
  .byte  196,65,45,253,209                   // vpaddw        %ymm9,%ymm10,%ymm10
  .byte  196,193,45,113,210,8                // vpsrlw        $0x8,%ymm10,%ymm10
  .byte  197,173,253,210                     // vpaddw        %ymm2,%ymm10,%ymm2
  .byte  196,65,69,213,192                   // vpmullw       %ymm8,%ymm7,%ymm8
  .byte  196,65,61,253,193                   // vpaddw        %ymm9,%ymm8,%ymm8
  .byte  196,193,61,113,208,8                // vpsrlw        $0x8,%ymm8,%ymm8
  .byte  197,189,253,219                     // vpaddw        %ymm3,%ymm8,%ymm3
  .byte  197,189,113,241,8                   // vpsllw        $0x8,%ymm1,%ymm8
  .byte  197,61,235,192                      // vpor          %ymm0,%ymm8,%ymm8
  .byte  196,66,125,51,200                   // vpmovzxwd     %xmm8,%ymm9
  .byte  196,67,125,57,192,1                 // vextracti128  $0x1,%ymm8,%xmm8
  .byte  196,66,125,51,208                   // vpmovzxwd     %xmm8,%ymm10
  .byte  197,189,113,243,8                   // vpsllw        $0x8,%ymm3,%ymm8
  .byte  197,61,235,194                      // vpor          %ymm2,%ymm8,%ymm8
  .byte  196,67,125,57,195,1                 // vextracti128  $0x1,%ymm8,%xmm11
  .byte  196,66,125,51,219                   // vpmovzxwd     %xmm11,%ymm11
  .byte  196,66,125,51,192                   // vpmovzxwd     %xmm8,%ymm8
  .byte  196,193,61,114,240,16               // vpslld        $0x10,%ymm8,%ymm8
  .byte  196,65,61,235,193                   // vpor          %ymm9,%ymm8,%ymm8
  .byte  196,193,53,114,243,16               // vpslld        $0x10,%ymm11,%ymm9
  .byte  196,65,53,235,202                   // vpor          %ymm10,%ymm9,%ymm9
  .byte  65,128,250,14                       // cmp           $0xe,%r10b
  .byte  119,26                              // ja            30f2e <_sk_srcover_rgba_8888_hsw_lowp+0x283>
  .byte  76,141,21,237,0,0,0                 // lea           0xed(%rip),%r10        # 31008 <_sk_srcover_rgba_8888_hsw_lowp+0x35d>
  .byte  75,99,4,130                         // movslq        (%r10,%r8,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,121,126,1                    // vmovd         %xmm8,(%r9)
  .byte  233,151,0,0,0                       // jmpq          30fc5 <_sk_srcover_rgba_8888_hsw_lowp+0x31a>
  .byte  196,65,126,127,1                    // vmovdqu       %ymm8,(%r9)
  .byte  196,65,126,127,73,32                // vmovdqu       %ymm9,0x20(%r9)
  .byte  233,135,0,0,0                       // jmpq          30fc5 <_sk_srcover_rgba_8888_hsw_lowp+0x31a>
  .byte  196,67,121,22,65,8,2                // vpextrd       $0x2,%xmm8,0x8(%r9)
  .byte  196,65,121,214,1                    // vmovq         %xmm8,(%r9)
  .byte  235,121                             // jmp           30fc5 <_sk_srcover_rgba_8888_hsw_lowp+0x31a>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,22,73,24,2               // vpextrd       $0x2,%xmm9,0x18(%r9)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,22,73,20,1               // vpextrd       $0x1,%xmm9,0x14(%r9)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,121,126,73,16                // vmovd         %xmm9,0x10(%r9)
  .byte  196,65,122,127,1                    // vmovdqu       %xmm8,(%r9)
  .byte  235,76                              // jmp           30fc5 <_sk_srcover_rgba_8888_hsw_lowp+0x31a>
  .byte  196,67,121,22,73,40,2               // vpextrd       $0x2,%xmm9,0x28(%r9)
  .byte  196,67,121,22,73,36,1               // vpextrd       $0x1,%xmm9,0x24(%r9)
  .byte  196,65,121,126,73,32                // vmovd         %xmm9,0x20(%r9)
  .byte  196,65,126,127,1                    // vmovdqu       %ymm8,(%r9)
  .byte  235,49                              // jmp           30fc5 <_sk_srcover_rgba_8888_hsw_lowp+0x31a>
  .byte  196,67,125,57,202,1                 // vextracti128  $0x1,%ymm9,%xmm10
  .byte  196,67,121,22,81,56,2               // vpextrd       $0x2,%xmm10,0x38(%r9)
  .byte  196,67,125,57,202,1                 // vextracti128  $0x1,%ymm9,%xmm10
  .byte  196,67,121,22,81,52,1               // vpextrd       $0x1,%xmm10,0x34(%r9)
  .byte  196,67,125,57,202,1                 // vextracti128  $0x1,%ymm9,%xmm10
  .byte  196,65,121,126,81,48                // vmovd         %xmm10,0x30(%r9)
  .byte  196,65,126,127,1                    // vmovdqu       %ymm8,(%r9)
  .byte  196,65,122,127,73,32                // vmovdqu       %xmm9,0x20(%r9)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  45,253,255,255,96                   // sub           $0x60fffffd,%eax
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,75,253                          // decl          -0x3(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  188,253,255,255,165                 // mov           $0xa5fffffd,%esp
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,142,253,255,255,121             // decl          0x79fffffd(%rsi)
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  254                                 // (bad)
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,242                             // push          %rdx
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,229                             // jmpq          *%rbp
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,64,254                          // incl          -0x2(%rax)
  .byte  255                                 // (bad)
  .byte  255,45,254,255,255,26               // ljmp          *0x1afffffe(%rip)        # 1b030fff <_sk_srcover_bgra_8888_sse2_lowp+0x1aff7097>
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,5,254,255,255,28                // incl          0x1cfffffe(%rip)        # 1d031007 <_sk_srcover_bgra_8888_sse2_lowp+0x1cff709f>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  61,255,255,255,54                   // cmp           $0x36ffffff,%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,106,255                         // ljmp          *-0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,94,255                          // lcall         *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,81,255                          // callq         *-0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,68,255,255                      // incl          -0x1(%rdi,%rdi,8)
  .byte  255,133,255,255,255,127             // incl          0x7fffffff(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  120,255                             // js            3102d <_sk_srcover_rgba_8888_hsw_lowp+0x382>
  .byte  255                                 // (bad)
  .byte  255,113,255                         // pushq         -0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,178,255,255,255,166             // pushq         -0x59000001(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,153,255,255,255,140             // lcall         *-0x73000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_srcover_bgra_8888_hsw_lowp
.globl _sk_srcover_bgra_8888_hsw_lowp
FUNCTION(_sk_srcover_bgra_8888_hsw_lowp)
_sk_srcover_bgra_8888_hsw_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  77,141,12,144                       // lea           (%r8,%rdx,4),%r9
  .byte  65,137,250                          // mov           %edi,%r10d
  .byte  65,128,226,15                       // and           $0xf,%r10b
  .byte  65,254,202                          // dec           %r10b
  .byte  69,15,182,194                       // movzbl        %r10b,%r8d
  .byte  65,128,248,14                       // cmp           $0xe,%r8b
  .byte  119,51                              // ja            310a0 <_sk_srcover_bgra_8888_hsw_lowp+0x5c>
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  76,141,29,236,2,0,0                 // lea           0x2ec(%rip),%r11        # 31364 <_sk_srcover_bgra_8888_hsw_lowp+0x320>
  .byte  75,99,4,131                         // movslq        (%r11,%r8,4),%rax
  .byte  76,1,216                            // add           %r11,%rax
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  197,205,239,246                     // vpxor         %ymm6,%ymm6,%ymm6
  .byte  196,65,61,239,192                   // vpxor         %ymm8,%ymm8,%ymm8
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  255,224                             // jmpq          *%rax
  .byte  196,193,121,110,41                  // vmovd         (%r9),%xmm5
  .byte  197,221,239,228                     // vpxor         %ymm4,%ymm4,%ymm4
  .byte  233,22,1,0,0                        // jmpq          311b6 <_sk_srcover_bgra_8888_hsw_lowp+0x172>
  .byte  196,193,126,111,41                  // vmovdqu       (%r9),%ymm5
  .byte  196,193,126,111,97,32               // vmovdqu       0x20(%r9),%ymm4
  .byte  233,6,1,0,0                         // jmpq          311b6 <_sk_srcover_bgra_8888_hsw_lowp+0x172>
  .byte  196,193,121,110,97,8                // vmovd         0x8(%r9),%xmm4
  .byte  196,226,121,89,228                  // vpbroadcastq  %xmm4,%xmm4
  .byte  197,197,239,255                     // vpxor         %ymm7,%ymm7,%ymm7
  .byte  196,227,69,2,228,4                  // vpblendd      $0x4,%ymm4,%ymm7,%ymm4
  .byte  196,194,121,53,41                   // vpmovzxdq     (%r9),%xmm5
  .byte  197,249,112,237,232                 // vpshufd       $0xe8,%xmm5,%xmm5
  .byte  196,227,93,2,237,3                  // vpblendd      $0x3,%ymm5,%ymm4,%ymm5
  .byte  197,253,111,231                     // vmovdqa       %ymm7,%ymm4
  .byte  233,216,0,0,0                       // jmpq          311b6 <_sk_srcover_bgra_8888_hsw_lowp+0x172>
  .byte  196,193,121,110,97,24               // vmovd         0x18(%r9),%xmm4
  .byte  196,226,125,89,228                  // vpbroadcastq  %xmm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,228,64                 // vpblendd      $0x40,%ymm4,%ymm5,%ymm4
  .byte  196,227,125,57,230,1                // vextracti128  $0x1,%ymm4,%xmm6
  .byte  196,195,73,34,113,20,1              // vpinsrd       $0x1,0x14(%r9),%xmm6,%xmm6
  .byte  196,227,93,56,230,1                 // vinserti128   $0x1,%xmm6,%ymm4,%ymm4
  .byte  197,253,111,245                     // vmovdqa       %ymm5,%ymm6
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,195,81,34,105,16,0              // vpinsrd       $0x0,0x10(%r9),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  197,125,111,198                     // vmovdqa       %ymm6,%ymm8
  .byte  196,193,122,111,41                  // vmovdqu       (%r9),%xmm5
  .byte  196,227,85,2,236,240                // vpblendd      $0xf0,%ymm4,%ymm5,%ymm5
  .byte  197,125,127,196                     // vmovdqa       %ymm8,%ymm4
  .byte  233,129,0,0,0                       // jmpq          311b6 <_sk_srcover_bgra_8888_hsw_lowp+0x172>
  .byte  196,193,121,110,97,40               // vmovd         0x28(%r9),%xmm4
  .byte  196,226,121,89,228                  // vpbroadcastq  %xmm4,%xmm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,228,4                  // vpblendd      $0x4,%ymm4,%ymm5,%ymm4
  .byte  196,195,89,34,105,36,1              // vpinsrd       $0x1,0x24(%r9),%xmm4,%xmm5
  .byte  196,227,93,2,229,15                 // vpblendd      $0xf,%ymm5,%ymm4,%ymm4
  .byte  196,193,121,110,105,32              // vmovd         0x20(%r9),%xmm5
  .byte  196,227,93,2,229,1                  // vpblendd      $0x1,%ymm5,%ymm4,%ymm4
  .byte  196,193,126,111,41                  // vmovdqu       (%r9),%ymm5
  .byte  235,76                              // jmp           311b6 <_sk_srcover_bgra_8888_hsw_lowp+0x172>
  .byte  196,193,121,110,97,56               // vmovd         0x38(%r9),%xmm4
  .byte  196,226,125,89,228                  // vpbroadcastq  %xmm4,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,85,2,228,64                 // vpblendd      $0x40,%ymm4,%ymm5,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,195,81,34,105,52,1              // vpinsrd       $0x1,0x34(%r9),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,227,125,57,229,1                // vextracti128  $0x1,%ymm4,%xmm5
  .byte  196,195,81,34,105,48,0              // vpinsrd       $0x0,0x30(%r9),%xmm5,%xmm5
  .byte  196,227,93,56,229,1                 // vinserti128   $0x1,%xmm5,%ymm4,%ymm4
  .byte  196,193,126,111,41                  // vmovdqu       (%r9),%ymm5
  .byte  196,193,122,111,113,32              // vmovdqu       0x20(%r9),%xmm6
  .byte  196,227,77,2,228,240                // vpblendd      $0xf0,%ymm4,%ymm6,%ymm4
  .byte  196,227,85,56,252,1                 // vinserti128   $0x1,%xmm4,%ymm5,%ymm7
  .byte  196,227,85,70,228,49                // vperm2i128    $0x31,%ymm4,%ymm5,%ymm4
  .byte  197,213,239,237                     // vpxor         %ymm5,%ymm5,%ymm5
  .byte  196,227,93,14,245,170               // vpblendw      $0xaa,%ymm5,%ymm4,%ymm6
  .byte  196,227,69,14,237,170               // vpblendw      $0xaa,%ymm5,%ymm7,%ymm5
  .byte  196,226,85,43,238                   // vpackusdw     %ymm6,%ymm5,%ymm5
  .byte  197,125,111,5,225,152,0,0           // vmovdqa       0x98e1(%rip),%ymm8        # 3aac0 <_sk_srcover_bgra_8888_sse2_lowp+0xb58>
  .byte  196,193,85,219,240                  // vpand         %ymm8,%ymm5,%ymm6
  .byte  196,98,125,121,13,243,152,0,0       // vpbroadcastw  0x98f3(%rip),%ymm9        # 3aae0 <_sk_srcover_bgra_8888_sse2_lowp+0xb78>
  .byte  197,213,113,213,8                   // vpsrlw        $0x8,%ymm5,%ymm5
  .byte  197,221,114,212,16                  // vpsrld        $0x10,%ymm4,%ymm4
  .byte  197,197,114,215,16                  // vpsrld        $0x10,%ymm7,%ymm7
  .byte  196,226,69,43,252                   // vpackusdw     %ymm4,%ymm7,%ymm7
  .byte  196,193,69,219,224                  // vpand         %ymm8,%ymm7,%ymm4
  .byte  197,197,113,215,8                   // vpsrlw        $0x8,%ymm7,%ymm7
  .byte  197,53,249,195                      // vpsubw        %ymm3,%ymm9,%ymm8
  .byte  196,65,93,213,208                   // vpmullw       %ymm8,%ymm4,%ymm10
  .byte  196,65,45,253,209                   // vpaddw        %ymm9,%ymm10,%ymm10
  .byte  196,193,45,113,210,8                // vpsrlw        $0x8,%ymm10,%ymm10
  .byte  197,173,253,192                     // vpaddw        %ymm0,%ymm10,%ymm0
  .byte  196,65,85,213,208                   // vpmullw       %ymm8,%ymm5,%ymm10
  .byte  196,65,45,253,209                   // vpaddw        %ymm9,%ymm10,%ymm10
  .byte  196,193,45,113,210,8                // vpsrlw        $0x8,%ymm10,%ymm10
  .byte  197,173,253,201                     // vpaddw        %ymm1,%ymm10,%ymm1
  .byte  196,65,77,213,208                   // vpmullw       %ymm8,%ymm6,%ymm10
  .byte  196,65,45,253,209                   // vpaddw        %ymm9,%ymm10,%ymm10
  .byte  196,193,45,113,210,8                // vpsrlw        $0x8,%ymm10,%ymm10
  .byte  197,173,253,210                     // vpaddw        %ymm2,%ymm10,%ymm2
  .byte  196,65,69,213,192                   // vpmullw       %ymm8,%ymm7,%ymm8
  .byte  196,65,61,253,193                   // vpaddw        %ymm9,%ymm8,%ymm8
  .byte  196,193,61,113,208,8                // vpsrlw        $0x8,%ymm8,%ymm8
  .byte  197,189,253,219                     // vpaddw        %ymm3,%ymm8,%ymm3
  .byte  197,189,113,241,8                   // vpsllw        $0x8,%ymm1,%ymm8
  .byte  197,61,235,194                      // vpor          %ymm2,%ymm8,%ymm8
  .byte  196,66,125,51,200                   // vpmovzxwd     %xmm8,%ymm9
  .byte  196,67,125,57,192,1                 // vextracti128  $0x1,%ymm8,%xmm8
  .byte  196,66,125,51,208                   // vpmovzxwd     %xmm8,%ymm10
  .byte  197,189,113,243,8                   // vpsllw        $0x8,%ymm3,%ymm8
  .byte  197,61,235,192                      // vpor          %ymm0,%ymm8,%ymm8
  .byte  196,67,125,57,195,1                 // vextracti128  $0x1,%ymm8,%xmm11
  .byte  196,66,125,51,219                   // vpmovzxwd     %xmm11,%ymm11
  .byte  196,66,125,51,192                   // vpmovzxwd     %xmm8,%ymm8
  .byte  196,193,61,114,240,16               // vpslld        $0x10,%ymm8,%ymm8
  .byte  196,65,61,235,193                   // vpor          %ymm9,%ymm8,%ymm8
  .byte  196,193,53,114,243,16               // vpslld        $0x10,%ymm11,%ymm9
  .byte  196,65,53,235,202                   // vpor          %ymm10,%ymm9,%ymm9
  .byte  65,128,250,14                       // cmp           $0xe,%r10b
  .byte  119,26                              // ja            312c7 <_sk_srcover_bgra_8888_hsw_lowp+0x283>
  .byte  76,141,21,236,0,0,0                 // lea           0xec(%rip),%r10        # 313a0 <_sk_srcover_bgra_8888_hsw_lowp+0x35c>
  .byte  75,99,4,130                         // movslq        (%r10,%r8,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  196,65,121,126,1                    // vmovd         %xmm8,(%r9)
  .byte  233,151,0,0,0                       // jmpq          3135e <_sk_srcover_bgra_8888_hsw_lowp+0x31a>
  .byte  196,65,126,127,1                    // vmovdqu       %ymm8,(%r9)
  .byte  196,65,126,127,73,32                // vmovdqu       %ymm9,0x20(%r9)
  .byte  233,135,0,0,0                       // jmpq          3135e <_sk_srcover_bgra_8888_hsw_lowp+0x31a>
  .byte  196,67,121,22,65,8,2                // vpextrd       $0x2,%xmm8,0x8(%r9)
  .byte  196,65,121,214,1                    // vmovq         %xmm8,(%r9)
  .byte  235,121                             // jmp           3135e <_sk_srcover_bgra_8888_hsw_lowp+0x31a>
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,22,73,24,2               // vpextrd       $0x2,%xmm9,0x18(%r9)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,67,121,22,73,20,1               // vpextrd       $0x1,%xmm9,0x14(%r9)
  .byte  196,67,125,57,193,1                 // vextracti128  $0x1,%ymm8,%xmm9
  .byte  196,65,121,126,73,16                // vmovd         %xmm9,0x10(%r9)
  .byte  196,65,122,127,1                    // vmovdqu       %xmm8,(%r9)
  .byte  235,76                              // jmp           3135e <_sk_srcover_bgra_8888_hsw_lowp+0x31a>
  .byte  196,67,121,22,73,40,2               // vpextrd       $0x2,%xmm9,0x28(%r9)
  .byte  196,67,121,22,73,36,1               // vpextrd       $0x1,%xmm9,0x24(%r9)
  .byte  196,65,121,126,73,32                // vmovd         %xmm9,0x20(%r9)
  .byte  196,65,126,127,1                    // vmovdqu       %ymm8,(%r9)
  .byte  235,49                              // jmp           3135e <_sk_srcover_bgra_8888_hsw_lowp+0x31a>
  .byte  196,67,125,57,202,1                 // vextracti128  $0x1,%ymm9,%xmm10
  .byte  196,67,121,22,81,56,2               // vpextrd       $0x2,%xmm10,0x38(%r9)
  .byte  196,67,125,57,202,1                 // vextracti128  $0x1,%ymm9,%xmm10
  .byte  196,67,121,22,81,52,1               // vpextrd       $0x1,%xmm10,0x34(%r9)
  .byte  196,67,125,57,202,1                 // vextracti128  $0x1,%ymm9,%xmm10
  .byte  196,65,121,126,81,48                // vmovd         %xmm10,0x30(%r9)
  .byte  196,65,126,127,1                    // vmovdqu       %ymm8,(%r9)
  .byte  196,65,122,127,73,32                // vmovdqu       %xmm9,0x20(%r9)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  46,253                              // cs            std
  .byte  255                                 // (bad)
  .byte  255,97,253                          // jmpq          *-0x3(%rcx)
  .byte  255                                 // (bad)
  .byte  255,76,253,255                      // decl          -0x1(%rbp,%rdi,8)
  .byte  255                                 // (bad)
  .byte  189,253,255,255,166                 // mov           $0xa6fffffd,%ebp
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,143,253,255,255,122             // decl          0x7afffffd(%rdi)
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,243                             // push          %rbx
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,230                             // jmpq          *%rsi
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,209                             // callq         *%rcx
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,65,254                          // incl          -0x2(%rcx)
  .byte  255                                 // (bad)
  .byte  255,46                              // ljmp          *(%rsi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,27                              // lcall         *(%rbx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,6                               // incl          (%rsi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,29,255,255,255,62               // lcall         *0x3effffff(%rip)        # 3f0313a4 <_sk_srcover_bgra_8888_sse2_lowp+0x3eff743c>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,55                              // pushq         (%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,107,255                         // ljmp          *-0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,95,255                          // lcall         *-0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255,82,255                          // callq         *-0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,69,255                          // incl          -0x1(%rbp)
  .byte  255                                 // (bad)
  .byte  255,134,255,255,255,128             // incl          -0x7f000001(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  121,255                             // jns           313c5 <_sk_srcover_bgra_8888_hsw_lowp+0x381>
  .byte  255                                 // (bad)
  .byte  255,114,255                         // pushq         -0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,179,255,255,255,167             // pushq         -0x58000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,154,255,255,255,141             // lcall         *-0x72000001(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_start_pipeline_sse41_lowp
.globl _sk_start_pipeline_sse41_lowp
FUNCTION(_sk_start_pipeline_sse41_lowp)
_sk_start_pipeline_sse41_lowp:
  .byte  85                                  // push          %rbp
  .byte  72,137,229                          // mov           %rsp,%rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  73,137,215                          // mov           %rdx,%r15
  .byte  72,137,243                          // mov           %rsi,%rbx
  .byte  72,137,125,208                      // mov           %rdi,-0x30(%rbp)
  .byte  76,137,198                          // mov           %r8,%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  73,137,197                          // mov           %rax,%r13
  .byte  73,137,246                          // mov           %rsi,%r14
  .byte  72,137,77,192                       // mov           %rcx,-0x40(%rbp)
  .byte  72,57,203                           // cmp           %rcx,%rbx
  .byte  15,131,131,0,0,0                    // jae           31492 <_sk_start_pipeline_sse41_lowp+0xb6>
  .byte  72,139,69,208                       // mov           -0x30(%rbp),%rax
  .byte  72,141,64,8                         // lea           0x8(%rax),%rax
  .byte  72,137,69,200                       // mov           %rax,-0x38(%rbp)
  .byte  76,57,125,200                       // cmp           %r15,-0x38(%rbp)
  .byte  72,139,85,208                       // mov           -0x30(%rbp),%rdx
  .byte  119,59                              // ja            31460 <_sk_start_pipeline_sse41_lowp+0x84>
  .byte  76,139,101,208                      // mov           -0x30(%rbp),%r12
  .byte  49,255                              // xor           %edi,%edi
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  76,137,226                          // mov           %r12,%rdx
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  73,141,84,36,8                      // lea           0x8(%r12),%rdx
  .byte  73,131,196,16                       // add           $0x10,%r12
  .byte  77,57,252                           // cmp           %r15,%r12
  .byte  73,137,212                          // mov           %rdx,%r12
  .byte  118,201                             // jbe           31429 <_sk_start_pipeline_sse41_lowp+0x4d>
  .byte  76,137,255                          // mov           %r15,%rdi
  .byte  72,41,215                           // sub           %rdx,%rdi
  .byte  116,33                              // je            31489 <_sk_start_pipeline_sse41_lowp+0xad>
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  72,255,195                          // inc           %rbx
  .byte  72,59,93,192                        // cmp           -0x40(%rbp),%rbx
  .byte  117,137                             // jne           3141b <_sk_start_pipeline_sse41_lowp+0x3f>
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  195                                 // retq

HIDDEN _sk_just_return_sse41_lowp
.globl _sk_just_return_sse41_lowp
FUNCTION(_sk_just_return_sse41_lowp)
_sk_just_return_sse41_lowp:
  .byte  195                                 // retq

HIDDEN _sk_seed_shader_sse41_lowp
.globl _sk_seed_shader_sse41_lowp
FUNCTION(_sk_seed_shader_sse41_lowp)
_sk_seed_shader_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,110,194                      // movd          %edx,%xmm0
  .byte  102,15,112,192,0                    // pshufd        $0x0,%xmm0,%xmm0
  .byte  15,91,208                           // cvtdq2ps      %xmm0,%xmm2
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  15,16,72,16                         // movups        0x10(%rax),%xmm1
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  102,15,110,209                      // movd          %ecx,%xmm2
  .byte  102,15,112,210,0                    // pshufd        $0x0,%xmm2,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,88,21,112,150,0,0                // addps         0x9670(%rip),%xmm2        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_translate_sse41_lowp
.globl _sk_matrix_translate_sse41_lowp
FUNCTION(_sk_matrix_translate_sse41_lowp)
_sk_matrix_translate_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  65,15,88,209                        // addps         %xmm9,%xmm2
  .byte  65,15,88,217                        // addps         %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_scale_translate_sse41_lowp
.globl _sk_matrix_scale_translate_sse41_lowp
FUNCTION(_sk_matrix_scale_translate_sse41_lowp)
_sk_matrix_scale_translate_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  65,15,89,217                        // mulps         %xmm9,%xmm3
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  65,15,88,208                        // addps         %xmm8,%xmm2
  .byte  65,15,88,216                        // addps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_2x3_sse41_lowp
.globl _sk_matrix_2x3_sse41_lowp
FUNCTION(_sk_matrix_2x3_sse41_lowp)
_sk_matrix_2x3_sse41_lowp:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,68,15,16,88,4                   // movss         0x4(%rax),%xmm11
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,72,16                  // movss         0x10(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,40,226                        // movaps        %xmm2,%xmm12
  .byte  69,15,89,226                        // mulps         %xmm10,%xmm12
  .byte  68,15,89,211                        // mulps         %xmm3,%xmm10
  .byte  69,15,88,209                        // addps         %xmm9,%xmm10
  .byte  69,15,88,225                        // addps         %xmm9,%xmm12
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,196                        // addps         %xmm12,%xmm0
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,80,12                  // movss         0xc(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,96,20                  // movss         0x14(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  65,15,89,210                        // mulps         %xmm10,%xmm2
  .byte  68,15,89,211                        // mulps         %xmm3,%xmm10
  .byte  69,15,88,212                        // addps         %xmm12,%xmm10
  .byte  65,15,88,212                        // addps         %xmm12,%xmm2
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  68,15,88,209                        // addps         %xmm1,%xmm10
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  65,15,88,211                        // addps         %xmm11,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  65,15,40,218                        // movaps        %xmm10,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_perspective_sse41_lowp
.globl _sk_matrix_perspective_sse41_lowp
FUNCTION(_sk_matrix_perspective_sse41_lowp)
_sk_matrix_perspective_sse41_lowp:
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,8                         // movss         (%rax),%xmm1
  .byte  243,68,15,16,80,4                   // movss         0x4(%rax),%xmm10
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,72,8                   // movss         0x8(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,40,219                        // movaps        %xmm3,%xmm11
  .byte  69,15,89,218                        // mulps         %xmm10,%xmm11
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  69,15,88,209                        // addps         %xmm9,%xmm10
  .byte  69,15,88,217                        // addps         %xmm9,%xmm11
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  243,68,15,16,96,12                  // movss         0xc(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,80,16                  // movss         0x10(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,104,20                 // movss         0x14(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  68,15,40,219                        // movaps        %xmm3,%xmm11
  .byte  69,15,89,218                        // mulps         %xmm10,%xmm11
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  69,15,88,213                        // addps         %xmm13,%xmm10
  .byte  69,15,88,221                        // addps         %xmm13,%xmm11
  .byte  68,15,40,232                        // movaps        %xmm0,%xmm13
  .byte  69,15,89,236                        // mulps         %xmm12,%xmm13
  .byte  69,15,88,213                        // addps         %xmm13,%xmm10
  .byte  69,15,89,224                        // mulps         %xmm8,%xmm12
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  243,68,15,16,96,24                  // movss         0x18(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,104,28                 // movss         0x1c(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  243,68,15,16,112,32                 // movss         0x20(%rax),%xmm14
  .byte  69,15,198,246,0                     // shufps        $0x0,%xmm14,%xmm14
  .byte  65,15,89,221                        // mulps         %xmm13,%xmm3
  .byte  68,15,89,234                        // mulps         %xmm2,%xmm13
  .byte  69,15,88,238                        // addps         %xmm14,%xmm13
  .byte  65,15,88,222                        // addps         %xmm14,%xmm3
  .byte  65,15,89,196                        // mulps         %xmm12,%xmm0
  .byte  65,15,88,197                        // addps         %xmm13,%xmm0
  .byte  69,15,89,224                        // mulps         %xmm8,%xmm12
  .byte  68,15,88,227                        // addps         %xmm3,%xmm12
  .byte  15,83,192                           // rcpps         %xmm0,%xmm0
  .byte  65,15,83,212                        // rcpps         %xmm12,%xmm2
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  68,15,89,208                        // mulps         %xmm0,%xmm10
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,40,219                        // movaps        %xmm11,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_uniform_color_sse41_lowp
.globl _sk_uniform_color_sse41_lowp
FUNCTION(_sk_uniform_color_sse41_lowp)
_sk_uniform_color_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,110,64,16                    // movd          0x10(%rax),%xmm0
  .byte  242,15,112,192,0                    // pshuflw       $0x0,%xmm0,%xmm0
  .byte  102,15,112,192,80                   // pshufd        $0x50,%xmm0,%xmm0
  .byte  68,15,183,64,18                     // movzwl        0x12(%rax),%r8d
  .byte  102,65,15,110,200                   // movd          %r8d,%xmm1
  .byte  242,15,112,201,0                    // pshuflw       $0x0,%xmm1,%xmm1
  .byte  102,15,112,201,80                   // pshufd        $0x50,%xmm1,%xmm1
  .byte  102,15,110,80,20                    // movd          0x14(%rax),%xmm2
  .byte  242,15,112,210,0                    // pshuflw       $0x0,%xmm2,%xmm2
  .byte  102,15,112,210,80                   // pshufd        $0x50,%xmm2,%xmm2
  .byte  15,183,64,22                        // movzwl        0x16(%rax),%eax
  .byte  102,15,110,216                      // movd          %eax,%xmm3
  .byte  242,15,112,219,0                    // pshuflw       $0x0,%xmm3,%xmm3
  .byte  102,15,112,219,80                   // pshufd        $0x50,%xmm3,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_black_color_sse41_lowp
.globl _sk_black_color_sse41_lowp
FUNCTION(_sk_black_color_sse41_lowp)
_sk_black_color_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,181,147,0,0                // movaps        0x93b5(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_white_color_sse41_lowp
.globl _sk_white_color_sse41_lowp
FUNCTION(_sk_white_color_sse41_lowp)
_sk_white_color_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,5,161,147,0,0                 // movaps        0x93a1(%rip),%xmm0        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_set_rgb_sse41_lowp
.globl _sk_set_rgb_sse41_lowp
FUNCTION(_sk_set_rgb_sse41_lowp)
_sk_set_rgb_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,21,224,138,0,0            // movss         0x8ae0(%rip),%xmm2        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,89,194                       // mulss         %xmm2,%xmm0
  .byte  243,68,15,16,5,159,138,0,0          // movss         0x8a9f(%rip),%xmm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  243,65,15,88,192                    // addss         %xmm8,%xmm0
  .byte  243,68,15,44,192                    // cvttss2si     %xmm0,%r8d
  .byte  102,65,15,110,192                   // movd          %r8d,%xmm0
  .byte  242,15,112,192,0                    // pshuflw       $0x0,%xmm0,%xmm0
  .byte  102,15,112,192,80                   // pshufd        $0x50,%xmm0,%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  243,15,89,202                       // mulss         %xmm2,%xmm1
  .byte  243,65,15,88,200                    // addss         %xmm8,%xmm1
  .byte  243,68,15,44,193                    // cvttss2si     %xmm1,%r8d
  .byte  102,65,15,110,200                   // movd          %r8d,%xmm1
  .byte  242,15,112,201,0                    // pshuflw       $0x0,%xmm1,%xmm1
  .byte  102,15,112,201,80                   // pshufd        $0x50,%xmm1,%xmm1
  .byte  243,15,89,80,8                      // mulss         0x8(%rax),%xmm2
  .byte  243,65,15,88,208                    // addss         %xmm8,%xmm2
  .byte  243,15,44,194                       // cvttss2si     %xmm2,%eax
  .byte  102,15,110,208                      // movd          %eax,%xmm2
  .byte  242,15,112,210,0                    // pshuflw       $0x0,%xmm2,%xmm2
  .byte  102,15,112,210,80                   // pshufd        $0x50,%xmm2,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_sse41_lowp
.globl _sk_clamp_a_sse41_lowp
FUNCTION(_sk_clamp_a_sse41_lowp)
_sk_clamp_a_sse41_lowp:
  .byte  102,15,56,58,195                    // pminuw        %xmm3,%xmm0
  .byte  102,15,56,58,203                    // pminuw        %xmm3,%xmm1
  .byte  102,15,56,58,211                    // pminuw        %xmm3,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_dst_sse41_lowp
.globl _sk_clamp_a_dst_sse41_lowp
FUNCTION(_sk_clamp_a_dst_sse41_lowp)
_sk_clamp_a_dst_sse41_lowp:
  .byte  102,15,56,58,231                    // pminuw        %xmm7,%xmm4
  .byte  102,15,56,58,239                    // pminuw        %xmm7,%xmm5
  .byte  102,15,56,58,247                    // pminuw        %xmm7,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_sse41_lowp
.globl _sk_premul_sse41_lowp
FUNCTION(_sk_premul_sse41_lowp)
_sk_premul_sse41_lowp:
  .byte  102,15,213,195                      // pmullw        %xmm3,%xmm0
  .byte  102,68,15,111,5,237,146,0,0         // movdqa        0x92ed(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,213,211                      // pmullw        %xmm3,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_dst_sse41_lowp
.globl _sk_premul_dst_sse41_lowp
FUNCTION(_sk_premul_dst_sse41_lowp)
_sk_premul_dst_sse41_lowp:
  .byte  102,15,213,231                      // pmullw        %xmm7,%xmm4
  .byte  102,68,15,111,5,182,146,0,0         // movdqa        0x92b6(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,224                   // paddw         %xmm8,%xmm4
  .byte  102,15,113,212,8                    // psrlw         $0x8,%xmm4
  .byte  102,15,213,239                      // pmullw        %xmm7,%xmm5
  .byte  102,65,15,253,232                   // paddw         %xmm8,%xmm5
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,15,213,247                      // pmullw        %xmm7,%xmm6
  .byte  102,65,15,253,240                   // paddw         %xmm8,%xmm6
  .byte  102,15,113,214,8                    // psrlw         $0x8,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_swap_rb_sse41_lowp
.globl _sk_swap_rb_sse41_lowp
FUNCTION(_sk_swap_rb_sse41_lowp)
_sk_swap_rb_sse41_lowp:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_src_dst_sse41_lowp
.globl _sk_move_src_dst_sse41_lowp
FUNCTION(_sk_move_src_dst_sse41_lowp)
_sk_move_src_dst_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,40,242                           // movaps        %xmm2,%xmm6
  .byte  15,40,251                           // movaps        %xmm3,%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_dst_src_sse41_lowp
.globl _sk_move_dst_src_sse41_lowp
FUNCTION(_sk_move_dst_src_sse41_lowp)
_sk_move_dst_src_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,40,223                           // movaps        %xmm7,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_invert_sse41_lowp
.globl _sk_invert_sse41_lowp
FUNCTION(_sk_invert_sse41_lowp)
_sk_invert_sse41_lowp:
  .byte  102,68,15,111,5,84,146,0,0          // movdqa        0x9254(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,68,15,249,200                   // psubw         %xmm0,%xmm9
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,249,209                   // psubw         %xmm1,%xmm10
  .byte  102,69,15,111,216                   // movdqa        %xmm8,%xmm11
  .byte  102,68,15,249,218                   // psubw         %xmm2,%xmm11
  .byte  102,68,15,249,195                   // psubw         %xmm3,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,65,15,111,202                   // movdqa        %xmm10,%xmm1
  .byte  102,65,15,111,211                   // movdqa        %xmm11,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clear_sse41_lowp
.globl _sk_clear_sse41_lowp
FUNCTION(_sk_clear_sse41_lowp)
_sk_clear_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcatop_sse41_lowp
.globl _sk_srcatop_sse41_lowp
FUNCTION(_sk_srcatop_sse41_lowp)
_sk_srcatop_sse41_lowp:
  .byte  102,68,15,111,195                   // movdqa        %xmm3,%xmm8
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,15,111,29,248,145,0,0           // movdqa        0x91f8(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,68,15,111,203                   // movdqa        %xmm3,%xmm9
  .byte  102,69,15,249,200                   // psubw         %xmm8,%xmm9
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,213,196                   // pmullw        %xmm4,%xmm8
  .byte  102,15,253,195                      // paddw         %xmm3,%xmm0
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,213,207                      // pmullw        %xmm7,%xmm1
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,213,197                   // pmullw        %xmm5,%xmm8
  .byte  102,15,253,203                      // paddw         %xmm3,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,68,15,213,206                   // pmullw        %xmm6,%xmm9
  .byte  102,15,253,211                      // paddw         %xmm3,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,68,15,111,199                   // movdqa        %xmm7,%xmm8
  .byte  102,68,15,213,195                   // pmullw        %xmm3,%xmm8
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstatop_sse41_lowp
.globl _sk_dstatop_sse41_lowp
FUNCTION(_sk_dstatop_sse41_lowp)
_sk_dstatop_sse41_lowp:
  .byte  102,68,15,111,196                   // movdqa        %xmm4,%xmm8
  .byte  102,68,15,213,195                   // pmullw        %xmm3,%xmm8
  .byte  102,68,15,111,13,120,145,0,0        // movdqa        0x9178(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,253,193                   // paddw         %xmm9,%xmm8
  .byte  102,68,15,111,213                   // movdqa        %xmm5,%xmm10
  .byte  102,68,15,213,211                   // pmullw        %xmm3,%xmm10
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,68,15,111,222                   // movdqa        %xmm6,%xmm11
  .byte  102,68,15,213,219                   // pmullw        %xmm3,%xmm11
  .byte  102,69,15,253,217                   // paddw         %xmm9,%xmm11
  .byte  102,65,15,213,217                   // pmullw        %xmm9,%xmm3
  .byte  102,65,15,253,217                   // paddw         %xmm9,%xmm3
  .byte  102,68,15,249,207                   // psubw         %xmm7,%xmm9
  .byte  102,65,15,213,193                   // pmullw        %xmm9,%xmm0
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,65,15,213,201                   // pmullw        %xmm9,%xmm1
  .byte  102,65,15,253,202                   // paddw         %xmm10,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,65,15,213,209                   // pmullw        %xmm9,%xmm2
  .byte  102,65,15,253,211                   // paddw         %xmm11,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcin_sse41_lowp
.globl _sk_srcin_sse41_lowp
FUNCTION(_sk_srcin_sse41_lowp)
_sk_srcin_sse41_lowp:
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,68,15,111,5,3,145,0,0           // movdqa        0x9103(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,213,207                      // pmullw        %xmm7,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstin_sse41_lowp
.globl _sk_dstin_sse41_lowp
FUNCTION(_sk_dstin_sse41_lowp)
_sk_dstin_sse41_lowp:
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,15,213,195                      // pmullw        %xmm3,%xmm0
  .byte  102,68,15,111,5,186,144,0,0         // movdqa        0x90ba(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,111,214                      // movdqa        %xmm6,%xmm2
  .byte  102,15,213,211                      // pmullw        %xmm3,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcout_sse41_lowp
.globl _sk_srcout_sse41_lowp
FUNCTION(_sk_srcout_sse41_lowp)
_sk_srcout_sse41_lowp:
  .byte  102,68,15,111,5,113,144,0,0         // movdqa        0x9071(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,68,15,249,207                   // psubw         %xmm7,%xmm9
  .byte  102,65,15,213,193                   // pmullw        %xmm9,%xmm0
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,65,15,213,201                   // pmullw        %xmm9,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,65,15,213,209                   // pmullw        %xmm9,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,65,15,213,217                   // pmullw        %xmm9,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstout_sse41_lowp
.globl _sk_dstout_sse41_lowp
FUNCTION(_sk_dstout_sse41_lowp)
_sk_dstout_sse41_lowp:
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,68,15,111,5,26,144,0,0          // movdqa        0x901a(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,249,216                      // psubw         %xmm0,%xmm3
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,213,196                      // pmullw        %xmm4,%xmm0
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,213,205                      // pmullw        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_sse41_lowp
.globl _sk_srcover_sse41_lowp
FUNCTION(_sk_srcover_sse41_lowp)
_sk_srcover_sse41_lowp:
  .byte  102,68,15,111,13,192,143,0,0        // movdqa        0x8fc0(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,249,195                   // psubw         %xmm3,%xmm8
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,213,212                   // pmullw        %xmm4,%xmm10
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,65,15,253,194                   // paddw         %xmm10,%xmm0
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,213,213                   // pmullw        %xmm5,%xmm10
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,65,15,253,202                   // paddw         %xmm10,%xmm1
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,213,214                   // pmullw        %xmm6,%xmm10
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,65,15,253,210                   // paddw         %xmm10,%xmm2
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,69,15,253,193                   // paddw         %xmm9,%xmm8
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstover_sse41_lowp
.globl _sk_dstover_sse41_lowp
FUNCTION(_sk_dstover_sse41_lowp)
_sk_dstover_sse41_lowp:
  .byte  102,68,15,111,5,70,143,0,0          // movdqa        0x8f46(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,68,15,249,207                   // psubw         %xmm7,%xmm9
  .byte  102,65,15,213,193                   // pmullw        %xmm9,%xmm0
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,253,196                      // paddw         %xmm4,%xmm0
  .byte  102,65,15,213,201                   // pmullw        %xmm9,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,253,205                      // paddw         %xmm5,%xmm1
  .byte  102,65,15,213,209                   // pmullw        %xmm9,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,253,214                      // paddw         %xmm6,%xmm2
  .byte  102,65,15,213,217                   // pmullw        %xmm9,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,253,223                      // paddw         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_modulate_sse41_lowp
.globl _sk_modulate_sse41_lowp
FUNCTION(_sk_modulate_sse41_lowp)
_sk_modulate_sse41_lowp:
  .byte  102,15,213,196                      // pmullw        %xmm4,%xmm0
  .byte  102,68,15,111,5,223,142,0,0         // movdqa        0x8edf(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,213,205                      // pmullw        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_multiply_sse41_lowp
.globl _sk_multiply_sse41_lowp
FUNCTION(_sk_multiply_sse41_lowp)
_sk_multiply_sse41_lowp:
  .byte  102,68,15,111,13,158,142,0,0        // movdqa        0x8e9e(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,249,195                   // psubw         %xmm3,%xmm8
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,213,212                   // pmullw        %xmm4,%xmm10
  .byte  102,68,15,111,220                   // movdqa        %xmm4,%xmm11
  .byte  102,69,15,253,217                   // paddw         %xmm9,%xmm11
  .byte  102,68,15,249,223                   // psubw         %xmm7,%xmm11
  .byte  102,65,15,213,195                   // pmullw        %xmm11,%xmm0
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,253,194                   // paddw         %xmm10,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,213,213                   // pmullw        %xmm5,%xmm10
  .byte  102,68,15,111,221                   // movdqa        %xmm5,%xmm11
  .byte  102,69,15,253,217                   // paddw         %xmm9,%xmm11
  .byte  102,68,15,249,223                   // psubw         %xmm7,%xmm11
  .byte  102,65,15,213,203                   // pmullw        %xmm11,%xmm1
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,253,202                   // paddw         %xmm10,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,213,214                   // pmullw        %xmm6,%xmm10
  .byte  102,68,15,111,222                   // movdqa        %xmm6,%xmm11
  .byte  102,69,15,253,217                   // paddw         %xmm9,%xmm11
  .byte  102,68,15,249,223                   // psubw         %xmm7,%xmm11
  .byte  102,65,15,213,211                   // pmullw        %xmm11,%xmm2
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,253,210                   // paddw         %xmm10,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,65,15,213,217                   // pmullw        %xmm9,%xmm3
  .byte  102,65,15,253,217                   // paddw         %xmm9,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_plus__sse41_lowp
.globl _sk_plus__sse41_lowp
FUNCTION(_sk_plus__sse41_lowp)
_sk_plus__sse41_lowp:
  .byte  102,15,253,196                      // paddw         %xmm4,%xmm0
  .byte  102,68,15,111,5,227,141,0,0         // movdqa        0x8de3(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,56,58,192                 // pminuw        %xmm8,%xmm0
  .byte  102,15,253,205                      // paddw         %xmm5,%xmm1
  .byte  102,65,15,56,58,200                 // pminuw        %xmm8,%xmm1
  .byte  102,15,253,214                      // paddw         %xmm6,%xmm2
  .byte  102,65,15,56,58,208                 // pminuw        %xmm8,%xmm2
  .byte  102,15,253,223                      // paddw         %xmm7,%xmm3
  .byte  102,65,15,56,58,216                 // pminuw        %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_screen_sse41_lowp
.globl _sk_screen_sse41_lowp
FUNCTION(_sk_screen_sse41_lowp)
_sk_screen_sse41_lowp:
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,15,253,193                      // paddw         %xmm1,%xmm0
  .byte  102,15,213,204                      // pmullw        %xmm4,%xmm1
  .byte  102,68,15,111,21,157,141,0,0        // movdqa        0x8d9d(%rip),%xmm10        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,202                   // paddw         %xmm10,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,249,193                      // psubw         %xmm1,%xmm0
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,68,15,213,197                   // pmullw        %xmm5,%xmm8
  .byte  102,69,15,253,194                   // paddw         %xmm10,%xmm8
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  102,65,15,249,200                   // psubw         %xmm8,%xmm1
  .byte  102,68,15,111,198                   // movdqa        %xmm6,%xmm8
  .byte  102,68,15,253,194                   // paddw         %xmm2,%xmm8
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,65,15,253,210                   // paddw         %xmm10,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,68,15,249,194                   // psubw         %xmm2,%xmm8
  .byte  102,68,15,111,207                   // movdqa        %xmm7,%xmm9
  .byte  102,68,15,253,203                   // paddw         %xmm3,%xmm9
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,65,15,253,218                   // paddw         %xmm10,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,68,15,249,203                   // psubw         %xmm3,%xmm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  102,65,15,111,217                   // movdqa        %xmm9,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xor__sse41_lowp
.globl _sk_xor__sse41_lowp
FUNCTION(_sk_xor__sse41_lowp)
_sk_xor__sse41_lowp:
  .byte  102,68,15,111,195                   // movdqa        %xmm3,%xmm8
  .byte  102,68,15,111,13,27,141,0,0         // movdqa        0x8d1b(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,209                   // movdqa        %xmm9,%xmm10
  .byte  102,68,15,249,215                   // psubw         %xmm7,%xmm10
  .byte  102,65,15,213,194                   // pmullw        %xmm10,%xmm0
  .byte  102,65,15,111,217                   // movdqa        %xmm9,%xmm3
  .byte  102,65,15,249,216                   // psubw         %xmm8,%xmm3
  .byte  102,68,15,111,219                   // movdqa        %xmm3,%xmm11
  .byte  102,68,15,213,220                   // pmullw        %xmm4,%xmm11
  .byte  102,65,15,253,195                   // paddw         %xmm11,%xmm0
  .byte  102,65,15,253,193                   // paddw         %xmm9,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,65,15,213,202                   // pmullw        %xmm10,%xmm1
  .byte  102,68,15,111,219                   // movdqa        %xmm3,%xmm11
  .byte  102,68,15,213,221                   // pmullw        %xmm5,%xmm11
  .byte  102,65,15,253,203                   // paddw         %xmm11,%xmm1
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,65,15,213,210                   // pmullw        %xmm10,%xmm2
  .byte  102,68,15,111,219                   // movdqa        %xmm3,%xmm11
  .byte  102,68,15,213,222                   // pmullw        %xmm6,%xmm11
  .byte  102,65,15,253,211                   // paddw         %xmm11,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,69,15,213,208                   // pmullw        %xmm8,%xmm10
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,65,15,253,218                   // paddw         %xmm10,%xmm3
  .byte  102,65,15,253,217                   // paddw         %xmm9,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_darken_sse41_lowp
.globl _sk_darken_sse41_lowp
FUNCTION(_sk_darken_sse41_lowp)
_sk_darken_sse41_lowp:
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,68,15,111,200                   // movdqa        %xmm0,%xmm9
  .byte  102,15,111,204                      // movdqa        %xmm4,%xmm1
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,65,15,253,193                   // paddw         %xmm9,%xmm0
  .byte  102,68,15,213,207                   // pmullw        %xmm7,%xmm9
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,65,15,56,62,201                 // pmaxuw        %xmm9,%xmm1
  .byte  102,68,15,111,13,98,140,0,0         // movdqa        0x8c62(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,249,193                      // psubw         %xmm1,%xmm0
  .byte  102,68,15,111,213                   // movdqa        %xmm5,%xmm10
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,68,15,213,211                   // pmullw        %xmm3,%xmm10
  .byte  102,69,15,56,62,208                 // pmaxuw        %xmm8,%xmm10
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,65,15,249,202                   // psubw         %xmm10,%xmm1
  .byte  102,68,15,111,214                   // movdqa        %xmm6,%xmm10
  .byte  102,68,15,111,198                   // movdqa        %xmm6,%xmm8
  .byte  102,68,15,253,194                   // paddw         %xmm2,%xmm8
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,68,15,213,211                   // pmullw        %xmm3,%xmm10
  .byte  102,68,15,56,62,210                 // pmaxuw        %xmm2,%xmm10
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,69,15,249,194                   // psubw         %xmm10,%xmm8
  .byte  102,65,15,111,209                   // movdqa        %xmm9,%xmm2
  .byte  102,15,249,211                      // psubw         %xmm3,%xmm2
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,253,218                      // paddw         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lighten_sse41_lowp
.globl _sk_lighten_sse41_lowp
FUNCTION(_sk_lighten_sse41_lowp)
_sk_lighten_sse41_lowp:
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,68,15,111,200                   // movdqa        %xmm0,%xmm9
  .byte  102,15,111,204                      // movdqa        %xmm4,%xmm1
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,65,15,253,193                   // paddw         %xmm9,%xmm0
  .byte  102,68,15,213,207                   // pmullw        %xmm7,%xmm9
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,65,15,56,58,201                 // pminuw        %xmm9,%xmm1
  .byte  102,68,15,111,13,165,139,0,0        // movdqa        0x8ba5(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,249,193                      // psubw         %xmm1,%xmm0
  .byte  102,68,15,111,213                   // movdqa        %xmm5,%xmm10
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,68,15,213,211                   // pmullw        %xmm3,%xmm10
  .byte  102,69,15,56,58,208                 // pminuw        %xmm8,%xmm10
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,65,15,249,202                   // psubw         %xmm10,%xmm1
  .byte  102,68,15,111,214                   // movdqa        %xmm6,%xmm10
  .byte  102,68,15,111,198                   // movdqa        %xmm6,%xmm8
  .byte  102,68,15,253,194                   // paddw         %xmm2,%xmm8
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,68,15,213,211                   // pmullw        %xmm3,%xmm10
  .byte  102,68,15,56,58,210                 // pminuw        %xmm2,%xmm10
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,69,15,249,194                   // psubw         %xmm10,%xmm8
  .byte  102,65,15,111,209                   // movdqa        %xmm9,%xmm2
  .byte  102,15,249,211                      // psubw         %xmm3,%xmm2
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,253,218                      // paddw         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_difference_sse41_lowp
.globl _sk_difference_sse41_lowp
FUNCTION(_sk_difference_sse41_lowp)
_sk_difference_sse41_lowp:
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,68,15,111,200                   // movdqa        %xmm0,%xmm9
  .byte  102,15,111,204                      // movdqa        %xmm4,%xmm1
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,65,15,253,193                   // paddw         %xmm9,%xmm0
  .byte  102,68,15,213,207                   // pmullw        %xmm7,%xmm9
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,65,15,56,58,201                 // pminuw        %xmm9,%xmm1
  .byte  102,68,15,111,13,232,138,0,0        // movdqa        0x8ae8(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,15,113,209,7                    // psrlw         $0x7,%xmm1
  .byte  102,68,15,111,21,53,146,0,0         // movdqa        0x9235(%rip),%xmm10        # 3b250 <_sk_srcover_bgra_8888_sse2_lowp+0x12e8>
  .byte  102,65,15,219,202                   // pand          %xmm10,%xmm1
  .byte  102,15,249,193                      // psubw         %xmm1,%xmm0
  .byte  102,68,15,111,221                   // movdqa        %xmm5,%xmm11
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,68,15,213,219                   // pmullw        %xmm3,%xmm11
  .byte  102,69,15,56,58,216                 // pminuw        %xmm8,%xmm11
  .byte  102,69,15,253,217                   // paddw         %xmm9,%xmm11
  .byte  102,65,15,113,211,7                 // psrlw         $0x7,%xmm11
  .byte  102,69,15,219,218                   // pand          %xmm10,%xmm11
  .byte  102,65,15,249,203                   // psubw         %xmm11,%xmm1
  .byte  102,68,15,111,222                   // movdqa        %xmm6,%xmm11
  .byte  102,68,15,111,198                   // movdqa        %xmm6,%xmm8
  .byte  102,68,15,253,194                   // paddw         %xmm2,%xmm8
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,68,15,213,219                   // pmullw        %xmm3,%xmm11
  .byte  102,68,15,56,58,218                 // pminuw        %xmm2,%xmm11
  .byte  102,69,15,253,217                   // paddw         %xmm9,%xmm11
  .byte  102,65,15,113,211,7                 // psrlw         $0x7,%xmm11
  .byte  102,69,15,219,218                   // pand          %xmm10,%xmm11
  .byte  102,69,15,249,195                   // psubw         %xmm11,%xmm8
  .byte  102,65,15,111,209                   // movdqa        %xmm9,%xmm2
  .byte  102,15,249,211                      // psubw         %xmm3,%xmm2
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,253,218                      // paddw         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_exclusion_sse41_lowp
.globl _sk_exclusion_sse41_lowp
FUNCTION(_sk_exclusion_sse41_lowp)
_sk_exclusion_sse41_lowp:
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,15,253,193                      // paddw         %xmm1,%xmm0
  .byte  102,15,213,204                      // pmullw        %xmm4,%xmm1
  .byte  102,68,15,111,13,36,138,0,0         // movdqa        0x8a24(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,15,113,209,7                    // psrlw         $0x7,%xmm1
  .byte  102,68,15,111,21,113,145,0,0        // movdqa        0x9171(%rip),%xmm10        # 3b250 <_sk_srcover_bgra_8888_sse2_lowp+0x12e8>
  .byte  102,65,15,219,202                   // pand          %xmm10,%xmm1
  .byte  102,15,249,193                      // psubw         %xmm1,%xmm0
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,68,15,213,197                   // pmullw        %xmm5,%xmm8
  .byte  102,69,15,253,193                   // paddw         %xmm9,%xmm8
  .byte  102,65,15,113,208,7                 // psrlw         $0x7,%xmm8
  .byte  102,69,15,219,194                   // pand          %xmm10,%xmm8
  .byte  102,65,15,249,200                   // psubw         %xmm8,%xmm1
  .byte  102,68,15,111,198                   // movdqa        %xmm6,%xmm8
  .byte  102,68,15,253,194                   // paddw         %xmm2,%xmm8
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,7                    // psrlw         $0x7,%xmm2
  .byte  102,65,15,219,210                   // pand          %xmm10,%xmm2
  .byte  102,68,15,249,194                   // psubw         %xmm2,%xmm8
  .byte  102,65,15,111,209                   // movdqa        %xmm9,%xmm2
  .byte  102,15,249,211                      // psubw         %xmm3,%xmm2
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,253,218                      // paddw         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hardlight_sse41_lowp
.globl _sk_hardlight_sse41_lowp
FUNCTION(_sk_hardlight_sse41_lowp)
_sk_hardlight_sse41_lowp:
  .byte  102,68,15,111,231                   // movdqa        %xmm7,%xmm12
  .byte  15,41,116,36,232                    // movaps        %xmm6,-0x18(%rsp)
  .byte  102,15,111,245                      // movdqa        %xmm5,%xmm6
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  102,68,15,111,29,127,137,0,0        // movdqa        0x897f(%rip),%xmm11        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,249,220                   // psubw         %xmm12,%xmm11
  .byte  102,65,15,111,227                   // movdqa        %xmm11,%xmm4
  .byte  102,65,15,213,224                   // pmullw        %xmm8,%xmm4
  .byte  102,68,15,111,251                   // movdqa        %xmm3,%xmm15
  .byte  102,69,15,249,248                   // psubw         %xmm8,%xmm15
  .byte  102,69,15,253,192                   // paddw         %xmm8,%xmm8
  .byte  102,68,15,111,13,200,144,0,0        // movdqa        0x90c8(%rip),%xmm9        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,68,15,111,243                   // movdqa        %xmm3,%xmm14
  .byte  102,69,15,239,241                   // pxor          %xmm9,%xmm14
  .byte  102,65,15,111,196                   // movdqa        %xmm12,%xmm0
  .byte  102,69,15,111,212                   // movdqa        %xmm12,%xmm10
  .byte  102,68,15,213,211                   // pmullw        %xmm3,%xmm10
  .byte  102,15,249,197                      // psubw         %xmm5,%xmm0
  .byte  102,65,15,213,199                   // pmullw        %xmm15,%xmm0
  .byte  102,15,253,192                      // paddw         %xmm0,%xmm0
  .byte  102,69,15,111,250                   // movdqa        %xmm10,%xmm15
  .byte  102,68,15,249,248                   // psubw         %xmm0,%xmm15
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  102,65,15,239,193                   // pxor          %xmm9,%xmm0
  .byte  102,65,15,101,198                   // pcmpgtw       %xmm14,%xmm0
  .byte  102,68,15,213,197                   // pmullw        %xmm5,%xmm8
  .byte  102,69,15,56,16,199                 // pblendvb      %xmm0,%xmm15,%xmm8
  .byte  102,65,15,111,196                   // movdqa        %xmm12,%xmm0
  .byte  102,68,15,111,251                   // movdqa        %xmm3,%xmm15
  .byte  102,68,15,249,249                   // psubw         %xmm1,%xmm15
  .byte  102,15,249,198                      // psubw         %xmm6,%xmm0
  .byte  102,65,15,213,199                   // pmullw        %xmm15,%xmm0
  .byte  102,15,253,192                      // paddw         %xmm0,%xmm0
  .byte  102,69,15,111,234                   // movdqa        %xmm10,%xmm13
  .byte  102,68,15,249,232                   // psubw         %xmm0,%xmm13
  .byte  102,69,15,111,251                   // movdqa        %xmm11,%xmm15
  .byte  102,68,15,213,249                   // pmullw        %xmm1,%xmm15
  .byte  102,15,253,201                      // paddw         %xmm1,%xmm1
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,65,15,239,193                   // pxor          %xmm9,%xmm0
  .byte  102,65,15,101,198                   // pcmpgtw       %xmm14,%xmm0
  .byte  102,15,213,206                      // pmullw        %xmm6,%xmm1
  .byte  102,65,15,56,16,205                 // pblendvb      %xmm0,%xmm13,%xmm1
  .byte  102,68,15,213,218                   // pmullw        %xmm2,%xmm11
  .byte  102,68,15,111,235                   // movdqa        %xmm3,%xmm13
  .byte  102,68,15,249,234                   // psubw         %xmm2,%xmm13
  .byte  102,15,253,210                      // paddw         %xmm2,%xmm2
  .byte  102,68,15,239,202                   // pxor          %xmm2,%xmm9
  .byte  102,69,15,101,206                   // pcmpgtw       %xmm14,%xmm9
  .byte  102,15,111,68,36,232                // movdqa        -0x18(%rsp),%xmm0
  .byte  102,15,249,248                      // psubw         %xmm0,%xmm7
  .byte  102,65,15,213,253                   // pmullw        %xmm13,%xmm7
  .byte  102,15,253,255                      // paddw         %xmm7,%xmm7
  .byte  102,68,15,249,215                   // psubw         %xmm7,%xmm10
  .byte  102,15,213,208                      // pmullw        %xmm0,%xmm2
  .byte  102,68,15,111,232                   // movdqa        %xmm0,%xmm13
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,65,15,56,16,210                 // pblendvb      %xmm0,%xmm10,%xmm2
  .byte  102,68,15,111,13,112,136,0,0        // movdqa        0x8870(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,15,249,195                      // psubw         %xmm3,%xmm0
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  102,15,213,253                      // pmullw        %xmm5,%xmm7
  .byte  102,15,253,252                      // paddw         %xmm4,%xmm7
  .byte  102,69,15,253,193                   // paddw         %xmm9,%xmm8
  .byte  102,68,15,253,199                   // paddw         %xmm7,%xmm8
  .byte  102,15,111,224                      // movdqa        %xmm0,%xmm4
  .byte  102,15,213,230                      // pmullw        %xmm6,%xmm4
  .byte  102,65,15,253,231                   // paddw         %xmm15,%xmm4
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,15,253,204                      // paddw         %xmm4,%xmm1
  .byte  102,15,111,224                      // movdqa        %xmm0,%xmm4
  .byte  102,65,15,213,229                   // pmullw        %xmm13,%xmm4
  .byte  102,65,15,253,227                   // paddw         %xmm11,%xmm4
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,253,212                      // paddw         %xmm4,%xmm2
  .byte  102,65,15,213,196                   // pmullw        %xmm12,%xmm0
  .byte  102,65,15,253,193                   // paddw         %xmm9,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,253,216                      // paddw         %xmm0,%xmm3
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,252                   // movdqa        %xmm12,%xmm7
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,65,15,111,245                   // movdqa        %xmm13,%xmm6
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_overlay_sse41_lowp
.globl _sk_overlay_sse41_lowp
FUNCTION(_sk_overlay_sse41_lowp)
_sk_overlay_sse41_lowp:
  .byte  102,68,15,111,231                   // movdqa        %xmm7,%xmm12
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  102,68,15,111,29,211,135,0,0        // movdqa        0x87d3(%rip),%xmm11        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,249,220                   // psubw         %xmm12,%xmm11
  .byte  102,65,15,111,195                   // movdqa        %xmm11,%xmm0
  .byte  102,65,15,213,192                   // pmullw        %xmm8,%xmm0
  .byte  102,15,127,68,36,232                // movdqa        %xmm0,-0x18(%rsp)
  .byte  102,68,15,111,243                   // movdqa        %xmm3,%xmm14
  .byte  102,69,15,249,240                   // psubw         %xmm8,%xmm14
  .byte  102,68,15,213,196                   // pmullw        %xmm4,%xmm8
  .byte  102,69,15,111,252                   // movdqa        %xmm12,%xmm15
  .byte  102,68,15,249,252                   // psubw         %xmm4,%xmm15
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,15,253,192                      // paddw         %xmm0,%xmm0
  .byte  102,68,15,111,13,4,143,0,0          // movdqa        0x8f04(%rip),%xmm9        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,69,15,111,212                   // movdqa        %xmm12,%xmm10
  .byte  102,68,15,213,211                   // pmullw        %xmm3,%xmm10
  .byte  102,69,15,213,254                   // pmullw        %xmm14,%xmm15
  .byte  102,69,15,253,255                   // paddw         %xmm15,%xmm15
  .byte  102,69,15,111,234                   // movdqa        %xmm10,%xmm13
  .byte  102,69,15,249,239                   // psubw         %xmm15,%xmm13
  .byte  102,69,15,111,244                   // movdqa        %xmm12,%xmm14
  .byte  102,69,15,239,241                   // pxor          %xmm9,%xmm14
  .byte  102,65,15,239,193                   // pxor          %xmm9,%xmm0
  .byte  102,65,15,101,198                   // pcmpgtw       %xmm14,%xmm0
  .byte  102,69,15,253,192                   // paddw         %xmm8,%xmm8
  .byte  102,69,15,56,16,197                 // pblendvb      %xmm0,%xmm13,%xmm8
  .byte  102,65,15,111,196                   // movdqa        %xmm12,%xmm0
  .byte  102,68,15,111,235                   // movdqa        %xmm3,%xmm13
  .byte  102,68,15,249,233                   // psubw         %xmm1,%xmm13
  .byte  102,15,249,197                      // psubw         %xmm5,%xmm0
  .byte  102,65,15,213,197                   // pmullw        %xmm13,%xmm0
  .byte  102,15,253,192                      // paddw         %xmm0,%xmm0
  .byte  102,69,15,111,234                   // movdqa        %xmm10,%xmm13
  .byte  102,68,15,249,232                   // psubw         %xmm0,%xmm13
  .byte  102,69,15,111,251                   // movdqa        %xmm11,%xmm15
  .byte  102,68,15,213,249                   // pmullw        %xmm1,%xmm15
  .byte  102,15,213,205                      // pmullw        %xmm5,%xmm1
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,253,192                      // paddw         %xmm0,%xmm0
  .byte  102,65,15,239,193                   // pxor          %xmm9,%xmm0
  .byte  102,65,15,101,198                   // pcmpgtw       %xmm14,%xmm0
  .byte  102,15,253,201                      // paddw         %xmm1,%xmm1
  .byte  102,65,15,56,16,205                 // pblendvb      %xmm0,%xmm13,%xmm1
  .byte  102,15,111,198                      // movdqa        %xmm6,%xmm0
  .byte  102,15,253,192                      // paddw         %xmm0,%xmm0
  .byte  102,68,15,239,200                   // pxor          %xmm0,%xmm9
  .byte  102,65,15,111,196                   // movdqa        %xmm12,%xmm0
  .byte  102,15,249,198                      // psubw         %xmm6,%xmm0
  .byte  102,69,15,101,206                   // pcmpgtw       %xmm14,%xmm9
  .byte  102,15,111,251                      // movdqa        %xmm3,%xmm7
  .byte  102,15,249,250                      // psubw         %xmm2,%xmm7
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,15,253,192                      // paddw         %xmm0,%xmm0
  .byte  102,68,15,249,208                   // psubw         %xmm0,%xmm10
  .byte  102,68,15,213,218                   // pmullw        %xmm2,%xmm11
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,15,253,210                      // paddw         %xmm2,%xmm2
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,65,15,56,16,210                 // pblendvb      %xmm0,%xmm10,%xmm2
  .byte  102,68,15,111,13,182,134,0,0        // movdqa        0x86b6(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,15,249,195                      // psubw         %xmm3,%xmm0
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  102,15,213,252                      // pmullw        %xmm4,%xmm7
  .byte  102,15,253,124,36,232               // paddw         -0x18(%rsp),%xmm7
  .byte  102,69,15,253,193                   // paddw         %xmm9,%xmm8
  .byte  102,68,15,253,199                   // paddw         %xmm7,%xmm8
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  102,15,213,253                      // pmullw        %xmm5,%xmm7
  .byte  102,65,15,253,255                   // paddw         %xmm15,%xmm7
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,15,253,207                      // paddw         %xmm7,%xmm1
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  102,15,213,254                      // pmullw        %xmm6,%xmm7
  .byte  102,65,15,253,251                   // paddw         %xmm11,%xmm7
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,253,215                      // paddw         %xmm7,%xmm2
  .byte  102,65,15,213,196                   // pmullw        %xmm12,%xmm0
  .byte  102,65,15,253,193                   // paddw         %xmm9,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,253,216                      // paddw         %xmm0,%xmm3
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,252                   // movdqa        %xmm12,%xmm7
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_8888_sse41_lowp
.globl _sk_load_8888_sse41_lowp
FUNCTION(_sk_load_8888_sse41_lowp)
_sk_load_8888_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,41                              // ja            324fc <_sk_load_8888_sse41_lowp+0x44>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,242,0,0,0                 // lea           0xf2(%rip),%r9        # 325d4 <_sk_load_8888_sse41_lowp+0x11c>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  255,224                             // jmpq          *%rax
  .byte  102,65,15,110,20,144                // movd          (%r8,%rdx,4),%xmm2
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  235,89                              // jmp           32555 <_sk_load_8888_sse41_lowp+0x9d>
  .byte  243,65,15,111,20,144                // movdqu        (%r8,%rdx,4),%xmm2
  .byte  243,69,15,111,68,144,16             // movdqu        0x10(%r8,%rdx,4),%xmm8
  .byte  235,74                              // jmp           32555 <_sk_load_8888_sse41_lowp+0x9d>
  .byte  102,65,15,110,68,144,8              // movd          0x8(%r8,%rdx,4),%xmm0
  .byte  102,68,15,112,192,69                // pshufd        $0x45,%xmm0,%xmm8
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  243,65,15,126,20,144                // movq          (%r8,%rdx,4),%xmm2
  .byte  102,65,15,58,14,208,240             // pblendw       $0xf0,%xmm8,%xmm2
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  235,37                              // jmp           32555 <_sk_load_8888_sse41_lowp+0x9d>
  .byte  102,65,15,110,68,144,24             // movd          0x18(%r8,%rdx,4),%xmm0
  .byte  102,68,15,112,192,69                // pshufd        $0x45,%xmm0,%xmm8
  .byte  102,69,15,58,34,68,144,20,1         // pinsrd        $0x1,0x14(%r8,%rdx,4),%xmm8
  .byte  102,69,15,58,34,68,144,16,0         // pinsrd        $0x0,0x10(%r8,%rdx,4),%xmm8
  .byte  243,65,15,111,20,144                // movdqu        (%r8,%rdx,4),%xmm2
  .byte  102,15,111,5,19,141,0,0             // movdqa        0x8d13(%rip),%xmm0        # 3b270 <_sk_srcover_bgra_8888_sse2_lowp+0x1308>
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,56,0,200                     // pshufb        %xmm0,%xmm1
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,56,0,216                     // pshufb        %xmm0,%xmm3
  .byte  102,15,108,203                      // punpcklqdq    %xmm3,%xmm1
  .byte  102,68,15,111,13,115,133,0,0        // movdqa        0x8573(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,65,15,219,193                   // pand          %xmm9,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,68,15,111,21,236,140,0,0        // movdqa        0x8cec(%rip),%xmm10        # 3b280 <_sk_srcover_bgra_8888_sse2_lowp+0x1318>
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,65,15,56,0,218                  // pshufb        %xmm10,%xmm3
  .byte  102,69,15,111,216                   // movdqa        %xmm8,%xmm11
  .byte  102,69,15,56,0,218                  // pshufb        %xmm10,%xmm11
  .byte  102,65,15,108,219                   // punpcklqdq    %xmm11,%xmm3
  .byte  102,68,15,111,21,217,140,0,0        // movdqa        0x8cd9(%rip),%xmm10        # 3b290 <_sk_srcover_bgra_8888_sse2_lowp+0x1328>
  .byte  102,65,15,56,0,210                  // pshufb        %xmm10,%xmm2
  .byte  102,69,15,56,0,194                  // pshufb        %xmm10,%xmm8
  .byte  102,65,15,108,208                   // punpcklqdq    %xmm8,%xmm2
  .byte  102,65,15,219,209                   // pand          %xmm9,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  27,255                              // sbb           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,72,255                          // decl          -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,55                              // pushq         (%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  123,255                             // jnp           325e1 <_sk_load_8888_sse41_lowp+0x129>
  .byte  255                                 // (bad)
  .byte  255,114,255                         // pushq         -0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,105,255                         // ljmp          *-0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,92,255,255                      // lcall         *-0x1(%rdi,%rdi,8)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_8888_dst_sse41_lowp
.globl _sk_load_8888_dst_sse41_lowp
FUNCTION(_sk_load_8888_dst_sse41_lowp)
_sk_load_8888_dst_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,41                              // ja            32634 <_sk_load_8888_dst_sse41_lowp+0x44>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,242,0,0,0                 // lea           0xf2(%rip),%r9        # 3270c <_sk_load_8888_dst_sse41_lowp+0x11c>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  255,224                             // jmpq          *%rax
  .byte  102,65,15,110,52,144                // movd          (%r8,%rdx,4),%xmm6
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  235,89                              // jmp           3268d <_sk_load_8888_dst_sse41_lowp+0x9d>
  .byte  243,65,15,111,52,144                // movdqu        (%r8,%rdx,4),%xmm6
  .byte  243,69,15,111,68,144,16             // movdqu        0x10(%r8,%rdx,4),%xmm8
  .byte  235,74                              // jmp           3268d <_sk_load_8888_dst_sse41_lowp+0x9d>
  .byte  102,65,15,110,100,144,8             // movd          0x8(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  243,65,15,126,52,144                // movq          (%r8,%rdx,4),%xmm6
  .byte  102,65,15,58,14,240,240             // pblendw       $0xf0,%xmm8,%xmm6
  .byte  102,68,15,111,196                   // movdqa        %xmm4,%xmm8
  .byte  235,37                              // jmp           3268d <_sk_load_8888_dst_sse41_lowp+0x9d>
  .byte  102,65,15,110,100,144,24            // movd          0x18(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  102,69,15,58,34,68,144,20,1         // pinsrd        $0x1,0x14(%r8,%rdx,4),%xmm8
  .byte  102,69,15,58,34,68,144,16,0         // pinsrd        $0x0,0x10(%r8,%rdx,4),%xmm8
  .byte  243,65,15,111,52,144                // movdqu        (%r8,%rdx,4),%xmm6
  .byte  102,15,111,37,219,139,0,0           // movdqa        0x8bdb(%rip),%xmm4        # 3b270 <_sk_srcover_bgra_8888_sse2_lowp+0x1308>
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,15,56,0,236                     // pshufb        %xmm4,%xmm5
  .byte  102,65,15,111,248                   // movdqa        %xmm8,%xmm7
  .byte  102,15,56,0,252                     // pshufb        %xmm4,%xmm7
  .byte  102,15,108,239                      // punpcklqdq    %xmm7,%xmm5
  .byte  102,68,15,111,13,59,132,0,0         // movdqa        0x843b(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,65,15,219,225                   // pand          %xmm9,%xmm4
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,68,15,111,21,180,139,0,0        // movdqa        0x8bb4(%rip),%xmm10        # 3b280 <_sk_srcover_bgra_8888_sse2_lowp+0x1318>
  .byte  102,15,111,254                      // movdqa        %xmm6,%xmm7
  .byte  102,65,15,56,0,250                  // pshufb        %xmm10,%xmm7
  .byte  102,69,15,111,216                   // movdqa        %xmm8,%xmm11
  .byte  102,69,15,56,0,218                  // pshufb        %xmm10,%xmm11
  .byte  102,65,15,108,251                   // punpcklqdq    %xmm11,%xmm7
  .byte  102,68,15,111,21,161,139,0,0        // movdqa        0x8ba1(%rip),%xmm10        # 3b290 <_sk_srcover_bgra_8888_sse2_lowp+0x1328>
  .byte  102,65,15,56,0,242                  // pshufb        %xmm10,%xmm6
  .byte  102,69,15,56,0,194                  // pshufb        %xmm10,%xmm8
  .byte  102,65,15,108,240                   // punpcklqdq    %xmm8,%xmm6
  .byte  102,65,15,219,241                   // pand          %xmm9,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  27,255                              // sbb           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,72,255                          // decl          -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,55                              // pushq         (%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  123,255                             // jnp           32719 <_sk_load_8888_dst_sse41_lowp+0x129>
  .byte  255                                 // (bad)
  .byte  255,114,255                         // pushq         -0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,105,255                         // ljmp          *-0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,92,255,255                      // lcall         *-0x1(%rdi,%rdi,8)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_8888_sse41_lowp
.globl _sk_store_8888_sse41_lowp
FUNCTION(_sk_store_8888_sse41_lowp)
_sk_store_8888_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,65,15,113,240,8                 // psllw         $0x8,%xmm8
  .byte  102,68,15,235,192                   // por           %xmm0,%xmm8
  .byte  102,69,15,112,200,78                // pshufd        $0x4e,%xmm8,%xmm9
  .byte  102,69,15,56,51,209                 // pmovzxwd      %xmm9,%xmm10
  .byte  102,69,15,56,51,216                 // pmovzxwd      %xmm8,%xmm11
  .byte  102,68,15,111,227                   // movdqa        %xmm3,%xmm12
  .byte  102,65,15,113,244,8                 // psllw         $0x8,%xmm12
  .byte  102,68,15,235,226                   // por           %xmm2,%xmm12
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  102,69,15,105,204                   // punpckhwd     %xmm12,%xmm9
  .byte  102,69,15,235,202                   // por           %xmm10,%xmm9
  .byte  102,69,15,97,196                    // punpcklwd     %xmm12,%xmm8
  .byte  102,69,15,235,195                   // por           %xmm11,%xmm8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,27                              // ja            327ae <_sk_store_8888_sse41_lowp+0x86>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,87,0,0,0                  // lea           0x57(%rip),%r9        # 327f4 <_sk_store_8888_sse41_lowp+0xcc>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,126,4,144                 // movd          %xmm8,(%r8,%rdx,4)
  .byte  235,63                              // jmp           327ed <_sk_store_8888_sse41_lowp+0xc5>
  .byte  243,69,15,127,4,144                 // movdqu        %xmm8,(%r8,%rdx,4)
  .byte  243,69,15,127,76,144,16             // movdqu        %xmm9,0x10(%r8,%rdx,4)
  .byte  235,48                              // jmp           327ed <_sk_store_8888_sse41_lowp+0xc5>
  .byte  102,69,15,58,22,68,144,8,2          // pextrd        $0x2,%xmm8,0x8(%r8,%rdx,4)
  .byte  102,69,15,214,4,144                 // movq          %xmm8,(%r8,%rdx,4)
  .byte  235,31                              // jmp           327ed <_sk_store_8888_sse41_lowp+0xc5>
  .byte  102,69,15,58,22,76,144,24,2         // pextrd        $0x2,%xmm9,0x18(%r8,%rdx,4)
  .byte  102,69,15,58,22,76,144,20,1         // pextrd        $0x1,%xmm9,0x14(%r8,%rdx,4)
  .byte  102,69,15,126,76,144,16             // movd          %xmm9,0x10(%r8,%rdx,4)
  .byte  243,69,15,127,4,144                 // movdqu        %xmm8,(%r8,%rdx,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  178,255                             // mov           $0xff,%dl
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,201                             // dec           %ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,243                             // push          %rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  236                                 // in            (%dx),%al
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,227                             // jmpq          *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  218,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_bgra_sse41_lowp
.globl _sk_load_bgra_sse41_lowp
FUNCTION(_sk_load_bgra_sse41_lowp)
_sk_load_bgra_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,41                              // ja            32854 <_sk_load_bgra_sse41_lowp+0x44>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,242,0,0,0                 // lea           0xf2(%rip),%r9        # 3292c <_sk_load_bgra_sse41_lowp+0x11c>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  255,224                             // jmpq          *%rax
  .byte  102,65,15,110,4,144                 // movd          (%r8,%rdx,4),%xmm0
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  235,89                              // jmp           328ad <_sk_load_bgra_sse41_lowp+0x9d>
  .byte  243,65,15,111,4,144                 // movdqu        (%r8,%rdx,4),%xmm0
  .byte  243,69,15,111,68,144,16             // movdqu        0x10(%r8,%rdx,4),%xmm8
  .byte  235,74                              // jmp           328ad <_sk_load_bgra_sse41_lowp+0x9d>
  .byte  102,65,15,110,68,144,8              // movd          0x8(%r8,%rdx,4),%xmm0
  .byte  102,68,15,112,192,69                // pshufd        $0x45,%xmm0,%xmm8
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  243,65,15,126,4,144                 // movq          (%r8,%rdx,4),%xmm0
  .byte  102,65,15,58,14,192,240             // pblendw       $0xf0,%xmm8,%xmm0
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  235,37                              // jmp           328ad <_sk_load_bgra_sse41_lowp+0x9d>
  .byte  102,65,15,110,68,144,24             // movd          0x18(%r8,%rdx,4),%xmm0
  .byte  102,68,15,112,192,69                // pshufd        $0x45,%xmm0,%xmm8
  .byte  102,69,15,58,34,68,144,20,1         // pinsrd        $0x1,0x14(%r8,%rdx,4),%xmm8
  .byte  102,69,15,58,34,68,144,16,0         // pinsrd        $0x0,0x10(%r8,%rdx,4),%xmm8
  .byte  243,65,15,111,4,144                 // movdqu        (%r8,%rdx,4),%xmm0
  .byte  102,15,111,21,187,137,0,0           // movdqa        0x89bb(%rip),%xmm2        # 3b270 <_sk_srcover_bgra_8888_sse2_lowp+0x1308>
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,56,0,202                     // pshufb        %xmm2,%xmm1
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,56,0,218                     // pshufb        %xmm2,%xmm3
  .byte  102,15,108,203                      // punpcklqdq    %xmm3,%xmm1
  .byte  102,68,15,111,13,27,130,0,0         // movdqa        0x821b(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,65,15,219,209                   // pand          %xmm9,%xmm2
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,68,15,111,21,148,137,0,0        // movdqa        0x8994(%rip),%xmm10        # 3b280 <_sk_srcover_bgra_8888_sse2_lowp+0x1318>
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,65,15,56,0,218                  // pshufb        %xmm10,%xmm3
  .byte  102,69,15,111,216                   // movdqa        %xmm8,%xmm11
  .byte  102,69,15,56,0,218                  // pshufb        %xmm10,%xmm11
  .byte  102,65,15,108,219                   // punpcklqdq    %xmm11,%xmm3
  .byte  102,68,15,111,21,129,137,0,0        // movdqa        0x8981(%rip),%xmm10        # 3b290 <_sk_srcover_bgra_8888_sse2_lowp+0x1328>
  .byte  102,65,15,56,0,194                  // pshufb        %xmm10,%xmm0
  .byte  102,69,15,56,0,194                  // pshufb        %xmm10,%xmm8
  .byte  102,65,15,108,192                   // punpcklqdq    %xmm8,%xmm0
  .byte  102,65,15,219,193                   // pand          %xmm9,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  27,255                              // sbb           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,72,255                          // decl          -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,55                              // pushq         (%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  123,255                             // jnp           32939 <_sk_load_bgra_sse41_lowp+0x129>
  .byte  255                                 // (bad)
  .byte  255,114,255                         // pushq         -0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,105,255                         // ljmp          *-0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,92,255,255                      // lcall         *-0x1(%rdi,%rdi,8)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_bgra_dst_sse41_lowp
.globl _sk_load_bgra_dst_sse41_lowp
FUNCTION(_sk_load_bgra_dst_sse41_lowp)
_sk_load_bgra_dst_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,41                              // ja            3298c <_sk_load_bgra_dst_sse41_lowp+0x44>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,242,0,0,0                 // lea           0xf2(%rip),%r9        # 32a64 <_sk_load_bgra_dst_sse41_lowp+0x11c>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  255,224                             // jmpq          *%rax
  .byte  102,65,15,110,36,144                // movd          (%r8,%rdx,4),%xmm4
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  235,89                              // jmp           329e5 <_sk_load_bgra_dst_sse41_lowp+0x9d>
  .byte  243,65,15,111,36,144                // movdqu        (%r8,%rdx,4),%xmm4
  .byte  243,69,15,111,68,144,16             // movdqu        0x10(%r8,%rdx,4),%xmm8
  .byte  235,74                              // jmp           329e5 <_sk_load_bgra_dst_sse41_lowp+0x9d>
  .byte  102,65,15,110,100,144,8             // movd          0x8(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  243,65,15,126,36,144                // movq          (%r8,%rdx,4),%xmm4
  .byte  102,65,15,58,14,224,240             // pblendw       $0xf0,%xmm8,%xmm4
  .byte  102,68,15,111,197                   // movdqa        %xmm5,%xmm8
  .byte  235,37                              // jmp           329e5 <_sk_load_bgra_dst_sse41_lowp+0x9d>
  .byte  102,65,15,110,100,144,24            // movd          0x18(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  102,69,15,58,34,68,144,20,1         // pinsrd        $0x1,0x14(%r8,%rdx,4),%xmm8
  .byte  102,69,15,58,34,68,144,16,0         // pinsrd        $0x0,0x10(%r8,%rdx,4),%xmm8
  .byte  243,65,15,111,36,144                // movdqu        (%r8,%rdx,4),%xmm4
  .byte  102,15,111,53,131,136,0,0           // movdqa        0x8883(%rip),%xmm6        # 3b270 <_sk_srcover_bgra_8888_sse2_lowp+0x1308>
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,56,0,238                     // pshufb        %xmm6,%xmm5
  .byte  102,65,15,111,248                   // movdqa        %xmm8,%xmm7
  .byte  102,15,56,0,254                     // pshufb        %xmm6,%xmm7
  .byte  102,15,108,239                      // punpcklqdq    %xmm7,%xmm5
  .byte  102,68,15,111,13,227,128,0,0        // movdqa        0x80e3(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,245                      // movdqa        %xmm5,%xmm6
  .byte  102,65,15,219,241                   // pand          %xmm9,%xmm6
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,68,15,111,21,92,136,0,0         // movdqa        0x885c(%rip),%xmm10        # 3b280 <_sk_srcover_bgra_8888_sse2_lowp+0x1318>
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,65,15,56,0,250                  // pshufb        %xmm10,%xmm7
  .byte  102,69,15,111,216                   // movdqa        %xmm8,%xmm11
  .byte  102,69,15,56,0,218                  // pshufb        %xmm10,%xmm11
  .byte  102,65,15,108,251                   // punpcklqdq    %xmm11,%xmm7
  .byte  102,68,15,111,21,73,136,0,0         // movdqa        0x8849(%rip),%xmm10        # 3b290 <_sk_srcover_bgra_8888_sse2_lowp+0x1328>
  .byte  102,65,15,56,0,226                  // pshufb        %xmm10,%xmm4
  .byte  102,69,15,56,0,194                  // pshufb        %xmm10,%xmm8
  .byte  102,65,15,108,224                   // punpcklqdq    %xmm8,%xmm4
  .byte  102,65,15,219,225                   // pand          %xmm9,%xmm4
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  27,255                              // sbb           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,72,255                          // decl          -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,55                              // pushq         (%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  123,255                             // jnp           32a71 <_sk_load_bgra_dst_sse41_lowp+0x129>
  .byte  255                                 // (bad)
  .byte  255,114,255                         // pushq         -0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,105,255                         // ljmp          *-0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,92,255,255                      // lcall         *-0x1(%rdi,%rdi,8)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_bgra_sse41_lowp
.globl _sk_store_bgra_sse41_lowp
FUNCTION(_sk_store_bgra_sse41_lowp)
_sk_store_bgra_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,65,15,113,240,8                 // psllw         $0x8,%xmm8
  .byte  102,68,15,235,194                   // por           %xmm2,%xmm8
  .byte  102,69,15,112,200,78                // pshufd        $0x4e,%xmm8,%xmm9
  .byte  102,69,15,56,51,209                 // pmovzxwd      %xmm9,%xmm10
  .byte  102,69,15,56,51,216                 // pmovzxwd      %xmm8,%xmm11
  .byte  102,68,15,111,227                   // movdqa        %xmm3,%xmm12
  .byte  102,65,15,113,244,8                 // psllw         $0x8,%xmm12
  .byte  102,68,15,235,224                   // por           %xmm0,%xmm12
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  102,69,15,105,204                   // punpckhwd     %xmm12,%xmm9
  .byte  102,69,15,235,202                   // por           %xmm10,%xmm9
  .byte  102,69,15,97,196                    // punpcklwd     %xmm12,%xmm8
  .byte  102,69,15,235,195                   // por           %xmm11,%xmm8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,27                              // ja            32b06 <_sk_store_bgra_sse41_lowp+0x86>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,87,0,0,0                  // lea           0x57(%rip),%r9        # 32b4c <_sk_store_bgra_sse41_lowp+0xcc>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,126,4,144                 // movd          %xmm8,(%r8,%rdx,4)
  .byte  235,63                              // jmp           32b45 <_sk_store_bgra_sse41_lowp+0xc5>
  .byte  243,69,15,127,4,144                 // movdqu        %xmm8,(%r8,%rdx,4)
  .byte  243,69,15,127,76,144,16             // movdqu        %xmm9,0x10(%r8,%rdx,4)
  .byte  235,48                              // jmp           32b45 <_sk_store_bgra_sse41_lowp+0xc5>
  .byte  102,69,15,58,22,68,144,8,2          // pextrd        $0x2,%xmm8,0x8(%r8,%rdx,4)
  .byte  102,69,15,214,4,144                 // movq          %xmm8,(%r8,%rdx,4)
  .byte  235,31                              // jmp           32b45 <_sk_store_bgra_sse41_lowp+0xc5>
  .byte  102,69,15,58,22,76,144,24,2         // pextrd        $0x2,%xmm9,0x18(%r8,%rdx,4)
  .byte  102,69,15,58,22,76,144,20,1         // pextrd        $0x1,%xmm9,0x14(%r8,%rdx,4)
  .byte  102,69,15,126,76,144,16             // movd          %xmm9,0x10(%r8,%rdx,4)
  .byte  243,69,15,127,4,144                 // movdqu        %xmm8,(%r8,%rdx,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  178,255                             // mov           $0xff,%dl
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,201                             // dec           %ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,243                             // push          %rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  236                                 // in            (%dx),%al
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,227                             // jmpq          *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  218,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_8888_sse41_lowp
.globl _sk_gather_8888_sse41_lowp
FUNCTION(_sk_gather_8888_sse41_lowp)
_sk_gather_8888_sse41_lowp:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  65,15,95,194                        // maxps         %xmm10,%xmm0
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  243,68,15,16,64,16                  // movss         0x10(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  65,15,95,218                        // maxps         %xmm10,%xmm3
  .byte  65,15,95,210                        // maxps         %xmm10,%xmm2
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,68,15,91,195                    // cvttps2dq     %xmm3,%xmm8
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  102,15,110,88,8                     // movd          0x8(%rax),%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  102,15,56,64,211                    // pmulld        %xmm3,%xmm2
  .byte  102,68,15,56,64,195                 // pmulld        %xmm3,%xmm8
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,194                      // paddd         %xmm2,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,65,15,254,200                   // paddd         %xmm8,%xmm1
  .byte  102,72,15,58,22,200,1               // pextrq        $0x1,%xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,72,15,58,22,195,1               // pextrq        $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,73,15,126,199                   // movq          %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  67,139,44,184                       // mov           (%r8,%r15,4),%ebp
  .byte  71,139,52,176                       // mov           (%r8,%r14,4),%r14d
  .byte  65,139,28,152                       // mov           (%r8,%rbx,4),%ebx
  .byte  71,139,28,152                       // mov           (%r8,%r11,4),%r11d
  .byte  71,139,20,144                       // mov           (%r8,%r10,4),%r10d
  .byte  71,139,12,136                       // mov           (%r8,%r9,4),%r9d
  .byte  65,139,4,128                        // mov           (%r8,%rax,4),%eax
  .byte  102,69,15,110,195                   // movd          %r11d,%xmm8
  .byte  102,69,15,58,34,194,1               // pinsrd        $0x1,%r10d,%xmm8
  .byte  102,69,15,58,34,193,2               // pinsrd        $0x2,%r9d,%xmm8
  .byte  102,68,15,58,34,192,3               // pinsrd        $0x3,%eax,%xmm8
  .byte  102,67,15,110,12,160                // movd          (%r8,%r12,4),%xmm1
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,15,58,34,213,1                  // pinsrd        $0x1,%ebp,%xmm2
  .byte  102,65,15,58,34,214,2               // pinsrd        $0x2,%r14d,%xmm2
  .byte  102,15,58,34,211,3                  // pinsrd        $0x3,%ebx,%xmm2
  .byte  102,15,196,205,1                    // pinsrw        $0x1,%ebp,%xmm1
  .byte  102,65,15,196,206,2                 // pinsrw        $0x2,%r14d,%xmm1
  .byte  102,15,196,203,3                    // pinsrw        $0x3,%ebx,%xmm1
  .byte  102,65,15,196,203,4                 // pinsrw        $0x4,%r11d,%xmm1
  .byte  102,65,15,196,202,5                 // pinsrw        $0x5,%r10d,%xmm1
  .byte  102,65,15,196,201,6                 // pinsrw        $0x6,%r9d,%xmm1
  .byte  102,15,196,200,7                    // pinsrw        $0x7,%eax,%xmm1
  .byte  102,68,15,111,13,76,126,0,0         // movdqa        0x7e4c(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,65,15,219,193                   // pand          %xmm9,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,68,15,111,21,197,133,0,0        // movdqa        0x85c5(%rip),%xmm10        # 3b280 <_sk_srcover_bgra_8888_sse2_lowp+0x1318>
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,65,15,56,0,218                  // pshufb        %xmm10,%xmm3
  .byte  102,69,15,111,216                   // movdqa        %xmm8,%xmm11
  .byte  102,69,15,56,0,218                  // pshufb        %xmm10,%xmm11
  .byte  102,65,15,108,219                   // punpcklqdq    %xmm11,%xmm3
  .byte  102,68,15,111,21,178,133,0,0        // movdqa        0x85b2(%rip),%xmm10        # 3b290 <_sk_srcover_bgra_8888_sse2_lowp+0x1328>
  .byte  102,65,15,56,0,210                  // pshufb        %xmm10,%xmm2
  .byte  102,69,15,56,0,194                  // pshufb        %xmm10,%xmm8
  .byte  102,65,15,108,208                   // punpcklqdq    %xmm8,%xmm2
  .byte  102,65,15,219,209                   // pand          %xmm9,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gather_bgra_sse41_lowp
.globl _sk_gather_bgra_sse41_lowp
FUNCTION(_sk_gather_bgra_sse41_lowp)
_sk_gather_bgra_sse41_lowp:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  65,15,95,194                        // maxps         %xmm10,%xmm0
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  243,68,15,16,64,16                  // movss         0x10(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  65,15,95,218                        // maxps         %xmm10,%xmm3
  .byte  65,15,95,210                        // maxps         %xmm10,%xmm2
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,68,15,91,195                    // cvttps2dq     %xmm3,%xmm8
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  102,15,110,88,8                     // movd          0x8(%rax),%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  102,15,56,64,211                    // pmulld        %xmm3,%xmm2
  .byte  102,68,15,56,64,195                 // pmulld        %xmm3,%xmm8
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,194                      // paddd         %xmm2,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,65,15,254,200                   // paddd         %xmm8,%xmm1
  .byte  102,72,15,58,22,200,1               // pextrq        $0x1,%xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,72,15,58,22,195,1               // pextrq        $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,73,15,126,199                   // movq          %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  67,139,44,184                       // mov           (%r8,%r15,4),%ebp
  .byte  71,139,52,176                       // mov           (%r8,%r14,4),%r14d
  .byte  65,139,28,152                       // mov           (%r8,%rbx,4),%ebx
  .byte  71,139,28,152                       // mov           (%r8,%r11,4),%r11d
  .byte  71,139,20,144                       // mov           (%r8,%r10,4),%r10d
  .byte  71,139,12,136                       // mov           (%r8,%r9,4),%r9d
  .byte  65,139,4,128                        // mov           (%r8,%rax,4),%eax
  .byte  102,69,15,110,195                   // movd          %r11d,%xmm8
  .byte  102,69,15,58,34,194,1               // pinsrd        $0x1,%r10d,%xmm8
  .byte  102,69,15,58,34,193,2               // pinsrd        $0x2,%r9d,%xmm8
  .byte  102,68,15,58,34,192,3               // pinsrd        $0x3,%eax,%xmm8
  .byte  102,67,15,110,12,160                // movd          (%r8,%r12,4),%xmm1
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,58,34,197,1                  // pinsrd        $0x1,%ebp,%xmm0
  .byte  102,65,15,58,34,198,2               // pinsrd        $0x2,%r14d,%xmm0
  .byte  102,15,58,34,195,3                  // pinsrd        $0x3,%ebx,%xmm0
  .byte  102,15,196,205,1                    // pinsrw        $0x1,%ebp,%xmm1
  .byte  102,65,15,196,206,2                 // pinsrw        $0x2,%r14d,%xmm1
  .byte  102,15,196,203,3                    // pinsrw        $0x3,%ebx,%xmm1
  .byte  102,65,15,196,203,4                 // pinsrw        $0x4,%r11d,%xmm1
  .byte  102,65,15,196,202,5                 // pinsrw        $0x5,%r10d,%xmm1
  .byte  102,65,15,196,201,6                 // pinsrw        $0x6,%r9d,%xmm1
  .byte  102,15,196,200,7                    // pinsrw        $0x7,%eax,%xmm1
  .byte  102,68,15,111,13,180,124,0,0        // movdqa        0x7cb4(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,65,15,219,209                   // pand          %xmm9,%xmm2
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,68,15,111,21,45,132,0,0         // movdqa        0x842d(%rip),%xmm10        # 3b280 <_sk_srcover_bgra_8888_sse2_lowp+0x1318>
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,65,15,56,0,218                  // pshufb        %xmm10,%xmm3
  .byte  102,69,15,111,216                   // movdqa        %xmm8,%xmm11
  .byte  102,69,15,56,0,218                  // pshufb        %xmm10,%xmm11
  .byte  102,65,15,108,219                   // punpcklqdq    %xmm11,%xmm3
  .byte  102,68,15,111,21,26,132,0,0         // movdqa        0x841a(%rip),%xmm10        # 3b290 <_sk_srcover_bgra_8888_sse2_lowp+0x1328>
  .byte  102,65,15,56,0,194                  // pshufb        %xmm10,%xmm0
  .byte  102,69,15,56,0,194                  // pshufb        %xmm10,%xmm8
  .byte  102,65,15,108,192                   // punpcklqdq    %xmm8,%xmm0
  .byte  102,65,15,219,193                   // pand          %xmm9,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_565_sse41_lowp
.globl _sk_load_565_sse41_lowp
FUNCTION(_sk_load_565_sse41_lowp)
_sk_load_565_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            32ed4 <_sk_load_565_sse41_lowp+0x3c>
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,196,0,0,0                 // lea           0xc4(%rip),%r9        # 32f84 <_sk_load_565_sse41_lowp+0xec>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  235,74                              // jmp           32f1e <_sk_load_565_sse41_lowp+0x86>
  .byte  243,65,15,111,4,80                  // movdqu        (%r8,%rdx,2),%xmm0
  .byte  235,66                              // jmp           32f1e <_sk_load_565_sse41_lowp+0x86>
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,65,15,196,76,80,4,2             // pinsrw        $0x2,0x4(%r8,%rdx,2),%xmm1
  .byte  102,65,15,110,4,80                  // movd          (%r8,%rdx,2),%xmm0
  .byte  102,15,58,14,193,252                // pblendw       $0xfc,%xmm1,%xmm0
  .byte  235,40                              // jmp           32f1e <_sk_load_565_sse41_lowp+0x86>
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,65,15,196,76,80,12,6            // pinsrw        $0x6,0xc(%r8,%rdx,2),%xmm1
  .byte  102,65,15,196,76,80,10,5            // pinsrw        $0x5,0xa(%r8,%rdx,2),%xmm1
  .byte  102,65,15,196,76,80,8,4             // pinsrw        $0x4,0x8(%r8,%rdx,2),%xmm1
  .byte  243,65,15,126,4,80                  // movq          (%r8,%rdx,2),%xmm0
  .byte  102,15,58,14,193,240                // pblendw       $0xf0,%xmm1,%xmm0
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,219,29,113,131,0,0           // pand          0x8371(%rip),%xmm3        # 3b2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1338>
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,113,209,5                    // psrlw         $0x5,%xmm1
  .byte  102,15,219,13,112,131,0,0           // pand          0x8370(%rip),%xmm1        # 3b2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1348>
  .byte  102,15,111,21,120,131,0,0           // movdqa        0x8378(%rip),%xmm2        # 3b2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1358>
  .byte  102,15,219,208                      // pand          %xmm0,%xmm2
  .byte  102,15,113,208,13                   // psrlw         $0xd,%xmm0
  .byte  102,15,235,195                      // por           %xmm3,%xmm0
  .byte  102,15,111,217                      // movdqa        %xmm1,%xmm3
  .byte  102,15,113,243,2                    // psllw         $0x2,%xmm3
  .byte  102,15,113,209,4                    // psrlw         $0x4,%xmm1
  .byte  102,15,235,203                      // por           %xmm3,%xmm1
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,113,243,3                    // psllw         $0x3,%xmm3
  .byte  102,15,113,210,2                    // psrlw         $0x2,%xmm2
  .byte  102,15,235,211                      // por           %xmm3,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,110,123,0,0                // movaps        0x7b6e(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  255,224                             // jmpq          *%rax
  .byte  69,255                              // rex.RB        (bad)
  .byte  255                                 // (bad)
  .byte  255,100,255,255                     // jmpq          *-0x1(%rdi,%rdi,8)
  .byte  255,88,255                          // lcall         *-0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,142,255,255,255,134             // decl          -0x79000001(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  126,255                             // jle           32f99 <_sk_load_565_sse41_lowp+0x101>
  .byte  255                                 // (bad)
  .byte  255,114,255                         // pushq         -0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_565_dst_sse41_lowp
.globl _sk_load_565_dst_sse41_lowp
FUNCTION(_sk_load_565_dst_sse41_lowp)
_sk_load_565_dst_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            32fdc <_sk_load_565_dst_sse41_lowp+0x3c>
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,196,0,0,0                 // lea           0xc4(%rip),%r9        # 3308c <_sk_load_565_dst_sse41_lowp+0xec>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  235,74                              // jmp           33026 <_sk_load_565_dst_sse41_lowp+0x86>
  .byte  243,65,15,111,36,80                 // movdqu        (%r8,%rdx,2),%xmm4
  .byte  235,66                              // jmp           33026 <_sk_load_565_dst_sse41_lowp+0x86>
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  102,65,15,196,108,80,4,2            // pinsrw        $0x2,0x4(%r8,%rdx,2),%xmm5
  .byte  102,65,15,110,36,80                 // movd          (%r8,%rdx,2),%xmm4
  .byte  102,15,58,14,229,252                // pblendw       $0xfc,%xmm5,%xmm4
  .byte  235,40                              // jmp           33026 <_sk_load_565_dst_sse41_lowp+0x86>
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  102,65,15,196,108,80,12,6           // pinsrw        $0x6,0xc(%r8,%rdx,2),%xmm5
  .byte  102,65,15,196,108,80,10,5           // pinsrw        $0x5,0xa(%r8,%rdx,2),%xmm5
  .byte  102,65,15,196,108,80,8,4            // pinsrw        $0x4,0x8(%r8,%rdx,2),%xmm5
  .byte  243,65,15,126,36,80                 // movq          (%r8,%rdx,2),%xmm4
  .byte  102,15,58,14,229,240                // pblendw       $0xf0,%xmm5,%xmm4
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,15,113,215,8                    // psrlw         $0x8,%xmm7
  .byte  102,15,219,61,105,130,0,0           // pand          0x8269(%rip),%xmm7        # 3b2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1338>
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,113,213,5                    // psrlw         $0x5,%xmm5
  .byte  102,15,219,45,104,130,0,0           // pand          0x8268(%rip),%xmm5        # 3b2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1348>
  .byte  102,15,111,53,112,130,0,0           // movdqa        0x8270(%rip),%xmm6        # 3b2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1358>
  .byte  102,15,219,244                      // pand          %xmm4,%xmm6
  .byte  102,15,113,212,13                   // psrlw         $0xd,%xmm4
  .byte  102,15,235,231                      // por           %xmm7,%xmm4
  .byte  102,15,111,253                      // movdqa        %xmm5,%xmm7
  .byte  102,15,113,247,2                    // psllw         $0x2,%xmm7
  .byte  102,15,113,213,4                    // psrlw         $0x4,%xmm5
  .byte  102,15,235,239                      // por           %xmm7,%xmm5
  .byte  102,15,111,254                      // movdqa        %xmm6,%xmm7
  .byte  102,15,113,247,3                    // psllw         $0x3,%xmm7
  .byte  102,15,113,214,2                    // psrlw         $0x2,%xmm6
  .byte  102,15,235,247                      // por           %xmm7,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,61,102,122,0,0                // movaps        0x7a66(%rip),%xmm7        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  255,224                             // jmpq          *%rax
  .byte  69,255                              // rex.RB        (bad)
  .byte  255                                 // (bad)
  .byte  255,100,255,255                     // jmpq          *-0x1(%rdi,%rdi,8)
  .byte  255,88,255                          // lcall         *-0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,142,255,255,255,134             // decl          -0x79000001(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  126,255                             // jle           330a1 <_sk_load_565_dst_sse41_lowp+0x101>
  .byte  255                                 // (bad)
  .byte  255,114,255                         // pushq         -0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_565_sse41_lowp
.globl _sk_store_565_sse41_lowp
FUNCTION(_sk_store_565_sse41_lowp)
_sk_store_565_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  102,65,15,113,240,8                 // psllw         $0x8,%xmm8
  .byte  102,68,15,219,5,4,130,0,0           // pand          0x8204(%rip),%xmm8        # 3b2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1368>
  .byte  102,68,15,111,201                   // movdqa        %xmm1,%xmm9
  .byte  102,65,15,113,241,3                 // psllw         $0x3,%xmm9
  .byte  102,68,15,219,13,0,130,0,0          // pand          0x8200(%rip),%xmm9        # 3b2e0 <_sk_srcover_bgra_8888_sse2_lowp+0x1378>
  .byte  102,69,15,235,200                   // por           %xmm8,%xmm9
  .byte  102,68,15,111,194                   // movdqa        %xmm2,%xmm8
  .byte  102,65,15,113,208,3                 // psrlw         $0x3,%xmm8
  .byte  102,69,15,235,193                   // por           %xmm9,%xmm8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,29                              // ja            3311c <_sk_store_565_sse41_lowp+0x74>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,83,0,0,0                  // lea           0x53(%rip),%r9        # 3315c <_sk_store_565_sse41_lowp+0xb4>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,58,21,4,80,0              // pextrw        $0x0,%xmm8,(%r8,%rdx,2)
  .byte  235,58                              // jmp           33156 <_sk_store_565_sse41_lowp+0xae>
  .byte  243,69,15,127,4,80                  // movdqu        %xmm8,(%r8,%rdx,2)
  .byte  235,50                              // jmp           33156 <_sk_store_565_sse41_lowp+0xae>
  .byte  102,69,15,58,21,68,80,4,2           // pextrw        $0x2,%xmm8,0x4(%r8,%rdx,2)
  .byte  102,69,15,126,4,80                  // movd          %xmm8,(%r8,%rdx,2)
  .byte  235,33                              // jmp           33156 <_sk_store_565_sse41_lowp+0xae>
  .byte  102,69,15,58,21,68,80,12,6          // pextrw        $0x6,%xmm8,0xc(%r8,%rdx,2)
  .byte  102,69,15,58,21,68,80,10,5          // pextrw        $0x5,%xmm8,0xa(%r8,%rdx,2)
  .byte  102,69,15,58,21,68,80,8,4           // pextrw        $0x4,%xmm8,0x8(%r8,%rdx,2)
  .byte  102,69,15,214,4,80                  // movq          %xmm8,(%r8,%rdx,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  182,255                             // mov           $0xff,%dh
  .byte  255                                 // (bad)
  .byte  255,209                             // callq         *%rcx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,200                             // dec           %eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,244                             // push          %rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  235,255                             // jmp           3316d <_sk_store_565_sse41_lowp+0xc5>
  .byte  255                                 // (bad)
  .byte  255,226                             // jmpq          *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  217,255                             // fcos
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_565_sse41_lowp
.globl _sk_gather_565_sse41_lowp
FUNCTION(_sk_gather_565_sse41_lowp)
_sk_gather_565_sse41_lowp:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  65,15,95,194                        // maxps         %xmm10,%xmm0
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  243,68,15,16,64,16                  // movss         0x10(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  65,15,95,218                        // maxps         %xmm10,%xmm3
  .byte  65,15,95,210                        // maxps         %xmm10,%xmm2
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,68,15,91,195                    // cvttps2dq     %xmm3,%xmm8
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  102,15,110,88,8                     // movd          0x8(%rax),%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  102,15,56,64,211                    // pmulld        %xmm3,%xmm2
  .byte  102,68,15,56,64,195                 // pmulld        %xmm3,%xmm8
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,194                      // paddd         %xmm2,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,65,15,254,200                   // paddd         %xmm8,%xmm1
  .byte  102,72,15,58,22,200,1               // pextrq        $0x1,%xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,72,15,58,22,195,1               // pextrq        $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,73,15,126,199                   // movq          %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,183,60,120                    // movzwl        (%r8,%r15,2),%r15d
  .byte  67,15,183,44,96                     // movzwl        (%r8,%r12,2),%ebp
  .byte  102,15,110,197                      // movd          %ebp,%xmm0
  .byte  102,65,15,196,199,1                 // pinsrw        $0x1,%r15d,%xmm0
  .byte  67,15,183,44,112                    // movzwl        (%r8,%r14,2),%ebp
  .byte  102,15,196,197,2                    // pinsrw        $0x2,%ebp,%xmm0
  .byte  65,15,183,28,88                     // movzwl        (%r8,%rbx,2),%ebx
  .byte  102,15,196,195,3                    // pinsrw        $0x3,%ebx,%xmm0
  .byte  67,15,183,44,88                     // movzwl        (%r8,%r11,2),%ebp
  .byte  102,15,196,197,4                    // pinsrw        $0x4,%ebp,%xmm0
  .byte  67,15,183,44,80                     // movzwl        (%r8,%r10,2),%ebp
  .byte  102,15,196,197,5                    // pinsrw        $0x5,%ebp,%xmm0
  .byte  67,15,183,44,72                     // movzwl        (%r8,%r9,2),%ebp
  .byte  102,15,196,197,6                    // pinsrw        $0x6,%ebp,%xmm0
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  102,15,196,192,7                    // pinsrw        $0x7,%eax,%xmm0
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,219,29,14,128,0,0            // pand          0x800e(%rip),%xmm3        # 3b2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1338>
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,113,209,5                    // psrlw         $0x5,%xmm1
  .byte  102,15,219,13,13,128,0,0            // pand          0x800d(%rip),%xmm1        # 3b2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1348>
  .byte  102,15,111,21,21,128,0,0            // movdqa        0x8015(%rip),%xmm2        # 3b2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1358>
  .byte  102,15,219,208                      // pand          %xmm0,%xmm2
  .byte  102,15,113,208,13                   // psrlw         $0xd,%xmm0
  .byte  102,15,235,195                      // por           %xmm3,%xmm0
  .byte  102,15,111,217                      // movdqa        %xmm1,%xmm3
  .byte  102,15,113,243,2                    // psllw         $0x2,%xmm3
  .byte  102,15,113,209,4                    // psrlw         $0x4,%xmm1
  .byte  102,15,235,203                      // por           %xmm3,%xmm1
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,113,243,3                    // psllw         $0x3,%xmm3
  .byte  102,15,113,210,2                    // psrlw         $0x2,%xmm2
  .byte  102,15,235,211                      // por           %xmm3,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,11,120,0,0                 // movaps        0x780b(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_4444_sse41_lowp
.globl _sk_load_4444_sse41_lowp
FUNCTION(_sk_load_4444_sse41_lowp)
_sk_load_4444_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,35                              // ja            3332c <_sk_load_4444_sse41_lowp+0x3d>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,209,0,0,0                 // lea           0xd1(%rip),%r9        # 333e8 <_sk_load_4444_sse41_lowp+0xf9>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  235,76                              // jmp           33378 <_sk_load_4444_sse41_lowp+0x89>
  .byte  243,69,15,111,4,80                  // movdqu        (%r8,%rdx,2),%xmm8
  .byte  235,68                              // jmp           33378 <_sk_load_4444_sse41_lowp+0x89>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,65,15,196,68,80,4,2             // pinsrw        $0x2,0x4(%r8,%rdx,2),%xmm0
  .byte  102,69,15,110,4,80                  // movd          (%r8,%rdx,2),%xmm8
  .byte  102,68,15,58,14,192,252             // pblendw       $0xfc,%xmm0,%xmm8
  .byte  235,41                              // jmp           33378 <_sk_load_4444_sse41_lowp+0x89>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,65,15,196,68,80,12,6            // pinsrw        $0x6,0xc(%r8,%rdx,2),%xmm0
  .byte  102,65,15,196,68,80,10,5            // pinsrw        $0x5,0xa(%r8,%rdx,2),%xmm0
  .byte  102,65,15,196,68,80,8,4             // pinsrw        $0x4,0x8(%r8,%rdx,2),%xmm0
  .byte  243,69,15,126,4,80                  // movq          (%r8,%rdx,2),%xmm8
  .byte  102,68,15,58,14,192,240             // pblendw       $0xf0,%xmm0,%xmm8
  .byte  102,65,15,111,200                   // movdqa        %xmm8,%xmm1
  .byte  102,15,113,209,12                   // psrlw         $0xc,%xmm1
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,111,5,92,127,0,0             // movdqa        0x7f5c(%rip),%xmm0        # 3b2f0 <_sk_srcover_bgra_8888_sse2_lowp+0x1388>
  .byte  102,15,219,208                      // pand          %xmm0,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,113,211,4                    // psrlw         $0x4,%xmm3
  .byte  102,15,219,216                      // pand          %xmm0,%xmm3
  .byte  102,68,15,219,192                   // pand          %xmm0,%xmm8
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,113,240,4                    // psllw         $0x4,%xmm0
  .byte  102,15,235,193                      // por           %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,113,241,4                    // psllw         $0x4,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,113,242,4                    // psllw         $0x4,%xmm2
  .byte  102,15,235,211                      // por           %xmm3,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,113,243,4                    // psllw         $0x4,%xmm3
  .byte  102,65,15,235,216                   // por           %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  56,255                              // cmp           %bh,%bh
  .byte  255                                 // (bad)
  .byte  255,88,255                          // lcall         *-0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,76,255,255                      // decl          -0x1(%rdi,%rdi,8)
  .byte  255,131,255,255,255,123             // incl          0x7bffffff(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,115,255                         // pushq         -0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,103,255                         // jmpq          *-0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_4444_dst_sse41_lowp
.globl _sk_load_4444_dst_sse41_lowp
FUNCTION(_sk_load_4444_dst_sse41_lowp)
_sk_load_4444_dst_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,35                              // ja            33441 <_sk_load_4444_dst_sse41_lowp+0x3d>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,208,0,0,0                 // lea           0xd0(%rip),%r9        # 334fc <_sk_load_4444_dst_sse41_lowp+0xf8>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  235,76                              // jmp           3348d <_sk_load_4444_dst_sse41_lowp+0x89>
  .byte  243,69,15,111,4,80                  // movdqu        (%r8,%rdx,2),%xmm8
  .byte  235,68                              // jmp           3348d <_sk_load_4444_dst_sse41_lowp+0x89>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,65,15,196,100,80,4,2            // pinsrw        $0x2,0x4(%r8,%rdx,2),%xmm4
  .byte  102,69,15,110,4,80                  // movd          (%r8,%rdx,2),%xmm8
  .byte  102,68,15,58,14,196,252             // pblendw       $0xfc,%xmm4,%xmm8
  .byte  235,41                              // jmp           3348d <_sk_load_4444_dst_sse41_lowp+0x89>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,65,15,196,100,80,12,6           // pinsrw        $0x6,0xc(%r8,%rdx,2),%xmm4
  .byte  102,65,15,196,100,80,10,5           // pinsrw        $0x5,0xa(%r8,%rdx,2),%xmm4
  .byte  102,65,15,196,100,80,8,4            // pinsrw        $0x4,0x8(%r8,%rdx,2),%xmm4
  .byte  243,69,15,126,4,80                  // movq          (%r8,%rdx,2),%xmm8
  .byte  102,68,15,58,14,196,240             // pblendw       $0xf0,%xmm4,%xmm8
  .byte  102,65,15,111,232                   // movdqa        %xmm8,%xmm5
  .byte  102,15,113,213,12                   // psrlw         $0xc,%xmm5
  .byte  102,65,15,111,240                   // movdqa        %xmm8,%xmm6
  .byte  102,15,113,214,8                    // psrlw         $0x8,%xmm6
  .byte  102,15,111,37,71,126,0,0            // movdqa        0x7e47(%rip),%xmm4        # 3b2f0 <_sk_srcover_bgra_8888_sse2_lowp+0x1388>
  .byte  102,15,219,244                      // pand          %xmm4,%xmm6
  .byte  102,65,15,111,248                   // movdqa        %xmm8,%xmm7
  .byte  102,15,113,215,4                    // psrlw         $0x4,%xmm7
  .byte  102,15,219,252                      // pand          %xmm4,%xmm7
  .byte  102,68,15,219,196                   // pand          %xmm4,%xmm8
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,113,244,4                    // psllw         $0x4,%xmm4
  .byte  102,15,235,229                      // por           %xmm5,%xmm4
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,15,113,245,4                    // psllw         $0x4,%xmm5
  .byte  102,15,235,238                      // por           %xmm6,%xmm5
  .byte  102,15,111,247                      // movdqa        %xmm7,%xmm6
  .byte  102,15,113,246,4                    // psllw         $0x4,%xmm6
  .byte  102,15,235,247                      // por           %xmm7,%xmm6
  .byte  102,65,15,111,248                   // movdqa        %xmm8,%xmm7
  .byte  102,15,113,247,4                    // psllw         $0x4,%xmm7
  .byte  102,65,15,235,248                   // por           %xmm8,%xmm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  57,255                              // cmp           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,89,255                          // lcall         *-0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,77,255                          // decl          -0x1(%rbp)
  .byte  255                                 // (bad)
  .byte  255,132,255,255,255,124,255         // incl          -0x830001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,116,255,255                     // pushq         -0x1(%rdi,%rdi,8)
  .byte  255,104,255                         // ljmp          *-0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_4444_sse41_lowp
.globl _sk_store_4444_sse41_lowp
FUNCTION(_sk_store_4444_sse41_lowp)
_sk_store_4444_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  102,65,15,113,240,8                 // psllw         $0x8,%xmm8
  .byte  102,68,15,219,5,196,125,0,0         // pand          0x7dc4(%rip),%xmm8        # 3b300 <_sk_srcover_bgra_8888_sse2_lowp+0x1398>
  .byte  102,68,15,111,201                   // movdqa        %xmm1,%xmm9
  .byte  102,65,15,113,241,4                 // psllw         $0x4,%xmm9
  .byte  102,68,15,219,13,192,125,0,0        // pand          0x7dc0(%rip),%xmm9        # 3b310 <_sk_srcover_bgra_8888_sse2_lowp+0x13a8>
  .byte  102,69,15,235,200                   // por           %xmm8,%xmm9
  .byte  102,68,15,111,21,194,125,0,0        // movdqa        0x7dc2(%rip),%xmm10        # 3b320 <_sk_srcover_bgra_8888_sse2_lowp+0x13b8>
  .byte  102,68,15,219,210                   // pand          %xmm2,%xmm10
  .byte  102,68,15,111,195                   // movdqa        %xmm3,%xmm8
  .byte  102,65,15,113,208,4                 // psrlw         $0x4,%xmm8
  .byte  102,69,15,235,194                   // por           %xmm10,%xmm8
  .byte  102,69,15,235,193                   // por           %xmm9,%xmm8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,29                              // ja            3359f <_sk_store_4444_sse41_lowp+0x87>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,84,0,0,0                  // lea           0x54(%rip),%r9        # 335e0 <_sk_store_4444_sse41_lowp+0xc8>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,58,21,4,80,0              // pextrw        $0x0,%xmm8,(%r8,%rdx,2)
  .byte  235,58                              // jmp           335d9 <_sk_store_4444_sse41_lowp+0xc1>
  .byte  243,69,15,127,4,80                  // movdqu        %xmm8,(%r8,%rdx,2)
  .byte  235,50                              // jmp           335d9 <_sk_store_4444_sse41_lowp+0xc1>
  .byte  102,69,15,58,21,68,80,4,2           // pextrw        $0x2,%xmm8,0x4(%r8,%rdx,2)
  .byte  102,69,15,126,4,80                  // movd          %xmm8,(%r8,%rdx,2)
  .byte  235,33                              // jmp           335d9 <_sk_store_4444_sse41_lowp+0xc1>
  .byte  102,69,15,58,21,68,80,12,6          // pextrw        $0x6,%xmm8,0xc(%r8,%rdx,2)
  .byte  102,69,15,58,21,68,80,10,5          // pextrw        $0x5,%xmm8,0xa(%r8,%rdx,2)
  .byte  102,69,15,58,21,68,80,8,4           // pextrw        $0x4,%xmm8,0x8(%r8,%rdx,2)
  .byte  102,69,15,214,4,80                  // movq          %xmm8,(%r8,%rdx,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  181,255                             // mov           $0xff,%ch
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,199                             // inc           %edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,243                             // push          %rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  234                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,225                             // jmpq          *%rcx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  216,255                             // fdivr         %st(7),%st
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_4444_sse41_lowp
.globl _sk_gather_4444_sse41_lowp
FUNCTION(_sk_gather_4444_sse41_lowp)
_sk_gather_4444_sse41_lowp:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  65,15,95,194                        // maxps         %xmm10,%xmm0
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  243,68,15,16,64,16                  // movss         0x10(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  65,15,95,218                        // maxps         %xmm10,%xmm3
  .byte  65,15,95,210                        // maxps         %xmm10,%xmm2
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,68,15,91,195                    // cvttps2dq     %xmm3,%xmm8
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  102,15,110,88,8                     // movd          0x8(%rax),%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  102,15,56,64,211                    // pmulld        %xmm3,%xmm2
  .byte  102,68,15,56,64,195                 // pmulld        %xmm3,%xmm8
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,194                      // paddd         %xmm2,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,65,15,254,200                   // paddd         %xmm8,%xmm1
  .byte  102,72,15,58,22,200,1               // pextrq        $0x1,%xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,72,15,58,22,195,1               // pextrq        $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,73,15,126,199                   // movq          %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,183,60,120                    // movzwl        (%r8,%r15,2),%r15d
  .byte  67,15,183,44,96                     // movzwl        (%r8,%r12,2),%ebp
  .byte  102,68,15,110,197                   // movd          %ebp,%xmm8
  .byte  102,69,15,196,199,1                 // pinsrw        $0x1,%r15d,%xmm8
  .byte  67,15,183,44,112                    // movzwl        (%r8,%r14,2),%ebp
  .byte  102,68,15,196,197,2                 // pinsrw        $0x2,%ebp,%xmm8
  .byte  65,15,183,28,88                     // movzwl        (%r8,%rbx,2),%ebx
  .byte  102,68,15,196,195,3                 // pinsrw        $0x3,%ebx,%xmm8
  .byte  67,15,183,44,88                     // movzwl        (%r8,%r11,2),%ebp
  .byte  102,68,15,196,197,4                 // pinsrw        $0x4,%ebp,%xmm8
  .byte  67,15,183,44,80                     // movzwl        (%r8,%r10,2),%ebp
  .byte  102,68,15,196,197,5                 // pinsrw        $0x5,%ebp,%xmm8
  .byte  67,15,183,44,72                     // movzwl        (%r8,%r9,2),%ebp
  .byte  102,68,15,196,197,6                 // pinsrw        $0x6,%ebp,%xmm8
  .byte  65,15,183,4,64                      // movzwl        (%r8,%rax,2),%eax
  .byte  102,68,15,196,192,7                 // pinsrw        $0x7,%eax,%xmm8
  .byte  102,65,15,111,200                   // movdqa        %xmm8,%xmm1
  .byte  102,15,113,209,12                   // psrlw         $0xc,%xmm1
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,111,5,200,123,0,0            // movdqa        0x7bc8(%rip),%xmm0        # 3b2f0 <_sk_srcover_bgra_8888_sse2_lowp+0x1388>
  .byte  102,15,219,208                      // pand          %xmm0,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,113,211,4                    // psrlw         $0x4,%xmm3
  .byte  102,15,219,216                      // pand          %xmm0,%xmm3
  .byte  102,68,15,219,192                   // pand          %xmm0,%xmm8
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,113,240,4                    // psllw         $0x4,%xmm0
  .byte  102,15,235,193                      // por           %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,113,241,4                    // psllw         $0x4,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,113,242,4                    // psllw         $0x4,%xmm2
  .byte  102,15,235,211                      // por           %xmm3,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,113,243,4                    // psllw         $0x4,%xmm3
  .byte  102,65,15,235,216                   // por           %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_a8_sse41_lowp
.globl _sk_load_a8_sse41_lowp
FUNCTION(_sk_load_a8_sse41_lowp)
_sk_load_a8_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            337ba <_sk_load_a8_sse41_lowp+0x39>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,146,0,0,0                 // lea           0x92(%rip),%r9        # 33838 <_sk_load_a8_sse41_lowp+0xb7>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  102,15,110,216                      // movd          %eax,%xmm3
  .byte  235,100                             // jmp           3381e <_sk_load_a8_sse41_lowp+0x9d>
  .byte  102,65,15,56,48,28,16               // pmovzxbw      (%r8,%rdx,1),%xmm3
  .byte  235,91                              // jmp           3381e <_sk_load_a8_sse41_lowp+0x9d>
  .byte  65,15,182,68,16,2                   // movzbl        0x2(%r8,%rdx,1),%eax
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,196,192,2                    // pinsrw        $0x2,%eax,%xmm0
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  102,15,110,200                      // movd          %eax,%xmm1
  .byte  102,15,56,48,217                    // pmovzxbw      %xmm1,%xmm3
  .byte  102,15,58,14,216,252                // pblendw       $0xfc,%xmm0,%xmm3
  .byte  235,54                              // jmp           3381e <_sk_load_a8_sse41_lowp+0x9d>
  .byte  65,15,182,68,16,6                   // movzbl        0x6(%r8,%rdx,1),%eax
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,196,192,6                    // pinsrw        $0x6,%eax,%xmm0
  .byte  65,15,182,68,16,5                   // movzbl        0x5(%r8,%rdx,1),%eax
  .byte  102,15,196,192,5                    // pinsrw        $0x5,%eax,%xmm0
  .byte  65,15,182,68,16,4                   // movzbl        0x4(%r8,%rdx,1),%eax
  .byte  102,15,196,192,4                    // pinsrw        $0x4,%eax,%xmm0
  .byte  102,65,15,110,12,16                 // movd          (%r8,%rdx,1),%xmm1
  .byte  102,15,56,48,217                    // pmovzxbw      %xmm1,%xmm3
  .byte  102,15,58,14,216,240                // pblendw       $0xf0,%xmm0,%xmm3
  .byte  102,15,219,29,202,114,0,0           // pand          0x72ca(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  119,255                             // ja            33839 <_sk_load_a8_sse41_lowp+0xb8>
  .byte  255                                 // (bad)
  .byte  255,154,255,255,255,139             // lcall         *-0x74000001(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,213                             // callq         *%rbp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,202                             // dec           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  191,255,255,255,176                 // mov           $0xb0ffffff,%edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_a8_dst_sse41_lowp
.globl _sk_load_a8_dst_sse41_lowp
FUNCTION(_sk_load_a8_dst_sse41_lowp)
_sk_load_a8_dst_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            3388d <_sk_load_a8_dst_sse41_lowp+0x39>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,143,0,0,0                 // lea           0x8f(%rip),%r9        # 33908 <_sk_load_a8_dst_sse41_lowp+0xb4>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  102,15,110,248                      // movd          %eax,%xmm7
  .byte  235,100                             // jmp           338f1 <_sk_load_a8_dst_sse41_lowp+0x9d>
  .byte  102,65,15,56,48,60,16               // pmovzxbw      (%r8,%rdx,1),%xmm7
  .byte  235,91                              // jmp           338f1 <_sk_load_a8_dst_sse41_lowp+0x9d>
  .byte  65,15,182,68,16,2                   // movzbl        0x2(%r8,%rdx,1),%eax
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,224,2                    // pinsrw        $0x2,%eax,%xmm4
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  102,15,110,232                      // movd          %eax,%xmm5
  .byte  102,15,56,48,253                    // pmovzxbw      %xmm5,%xmm7
  .byte  102,15,58,14,252,252                // pblendw       $0xfc,%xmm4,%xmm7
  .byte  235,54                              // jmp           338f1 <_sk_load_a8_dst_sse41_lowp+0x9d>
  .byte  65,15,182,68,16,6                   // movzbl        0x6(%r8,%rdx,1),%eax
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,224,6                    // pinsrw        $0x6,%eax,%xmm4
  .byte  65,15,182,68,16,5                   // movzbl        0x5(%r8,%rdx,1),%eax
  .byte  102,15,196,224,5                    // pinsrw        $0x5,%eax,%xmm4
  .byte  65,15,182,68,16,4                   // movzbl        0x4(%r8,%rdx,1),%eax
  .byte  102,15,196,224,4                    // pinsrw        $0x4,%eax,%xmm4
  .byte  102,65,15,110,44,16                 // movd          (%r8,%rdx,1),%xmm5
  .byte  102,15,56,48,253                    // pmovzxbw      %xmm5,%xmm7
  .byte  102,15,58,14,252,240                // pblendw       $0xf0,%xmm4,%xmm7
  .byte  102,15,219,61,247,113,0,0           // pand          0x71f7(%rip),%xmm7        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  255,224                             // jmpq          *%rax
  .byte  122,255                             // jp            33909 <_sk_load_a8_dst_sse41_lowp+0xb5>
  .byte  255                                 // (bad)
  .byte  255,157,255,255,255,142             // lcall         *-0x71000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  216,255                             // fdivr         %st(7),%st
  .byte  255                                 // (bad)
  .byte  255,205                             // dec           %ebp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,194                             // inc           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  179,255                             // mov           $0xff,%bl
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_a8_sse41_lowp
.globl _sk_store_a8_sse41_lowp
FUNCTION(_sk_store_a8_sse41_lowp)
_sk_store_a8_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,29                              // ja            33958 <_sk_store_a8_sse41_lowp+0x34>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,131,0,0,0                 // lea           0x83(%rip),%r9        # 339c8 <_sk_store_a8_sse41_lowp+0xa4>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,65,15,58,20,28,16,0             // pextrb        $0x0,%xmm3,(%r8,%rdx,1)
  .byte  235,105                             // jmp           339c1 <_sk_store_a8_sse41_lowp+0x9d>
  .byte  102,68,15,111,195                   // movdqa        %xmm3,%xmm8
  .byte  102,68,15,56,0,5,217,120,0,0        // pshufb        0x78d9(%rip),%xmm8        # 3b240 <_sk_srcover_bgra_8888_sse2_lowp+0x12d8>
  .byte  102,69,15,214,4,16                  // movq          %xmm8,(%r8,%rdx,1)
  .byte  235,82                              // jmp           339c1 <_sk_store_a8_sse41_lowp+0x9d>
  .byte  102,65,15,58,20,92,16,2,4           // pextrb        $0x4,%xmm3,0x2(%r8,%rdx,1)
  .byte  102,68,15,111,195                   // movdqa        %xmm3,%xmm8
  .byte  102,68,15,56,0,5,121,113,0,0        // pshufb        0x7179(%rip),%xmm8        # 3ab00 <_sk_srcover_bgra_8888_sse2_lowp+0xb98>
  .byte  102,69,15,58,21,4,16,0              // pextrw        $0x0,%xmm8,(%r8,%rdx,1)
  .byte  235,48                              // jmp           339c1 <_sk_store_a8_sse41_lowp+0x9d>
  .byte  102,65,15,58,20,92,16,6,12          // pextrb        $0xc,%xmm3,0x6(%r8,%rdx,1)
  .byte  102,65,15,58,20,92,16,5,10          // pextrb        $0xa,%xmm3,0x5(%r8,%rdx,1)
  .byte  102,65,15,58,20,92,16,4,8           // pextrb        $0x8,%xmm3,0x4(%r8,%rdx,1)
  .byte  102,68,15,111,195                   // movdqa        %xmm3,%xmm8
  .byte  102,68,15,56,0,5,85,113,0,0         // pshufb        0x7155(%rip),%xmm8        # 3ab10 <_sk_srcover_bgra_8888_sse2_lowp+0xba8>
  .byte  102,69,15,126,4,16                  // movd          %xmm8,(%r8,%rdx,1)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  134,255                             // xchg          %bh,%bh
  .byte  255                                 // (bad)
  .byte  255,176,255,255,255,167             // pushq         -0x58000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,228                             // jmpq          *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  219,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,201                             // dec           %ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_a8_sse41_lowp
.globl _sk_gather_a8_sse41_lowp
FUNCTION(_sk_gather_a8_sse41_lowp)
_sk_gather_a8_sse41_lowp:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  65,15,95,194                        // maxps         %xmm10,%xmm0
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  243,68,15,16,64,16                  // movss         0x10(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  65,15,95,218                        // maxps         %xmm10,%xmm3
  .byte  65,15,95,210                        // maxps         %xmm10,%xmm2
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,68,15,91,195                    // cvttps2dq     %xmm3,%xmm8
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  102,15,110,88,8                     // movd          0x8(%rax),%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  102,15,56,64,211                    // pmulld        %xmm3,%xmm2
  .byte  102,68,15,56,64,195                 // pmulld        %xmm3,%xmm8
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,194                      // paddd         %xmm2,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,65,15,254,200                   // paddd         %xmm8,%xmm1
  .byte  102,72,15,58,22,200,1               // pextrq        $0x1,%xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,72,15,58,22,195,1               // pextrq        $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,73,15,126,199                   // movq          %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,182,60,56                     // movzbl        (%r8,%r15,1),%r15d
  .byte  67,15,182,44,32                     // movzbl        (%r8,%r12,1),%ebp
  .byte  102,15,110,197                      // movd          %ebp,%xmm0
  .byte  102,65,15,58,32,199,1               // pinsrb        $0x1,%r15d,%xmm0
  .byte  67,15,182,44,48                     // movzbl        (%r8,%r14,1),%ebp
  .byte  102,15,58,32,197,2                  // pinsrb        $0x2,%ebp,%xmm0
  .byte  65,15,182,28,24                     // movzbl        (%r8,%rbx,1),%ebx
  .byte  102,15,58,32,195,3                  // pinsrb        $0x3,%ebx,%xmm0
  .byte  67,15,182,44,24                     // movzbl        (%r8,%r11,1),%ebp
  .byte  102,15,58,32,197,4                  // pinsrb        $0x4,%ebp,%xmm0
  .byte  67,15,182,44,16                     // movzbl        (%r8,%r10,1),%ebp
  .byte  102,15,58,32,197,5                  // pinsrb        $0x5,%ebp,%xmm0
  .byte  67,15,182,44,8                      // movzbl        (%r8,%r9,1),%ebp
  .byte  102,15,58,32,197,6                  // pinsrb        $0x6,%ebp,%xmm0
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  102,15,58,32,192,7                  // pinsrb        $0x7,%eax,%xmm0
  .byte  102,15,56,48,216                    // pmovzxbw      %xmm0,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_g8_sse41_lowp
.globl _sk_load_g8_sse41_lowp
FUNCTION(_sk_load_g8_sse41_lowp)
_sk_load_g8_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            33b4a <_sk_load_g8_sse41_lowp+0x39>
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,150,0,0,0                 // lea           0x96(%rip),%r9        # 33bcc <_sk_load_g8_sse41_lowp+0xbb>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  235,100                             // jmp           33bae <_sk_load_g8_sse41_lowp+0x9d>
  .byte  102,65,15,56,48,4,16                // pmovzxbw      (%r8,%rdx,1),%xmm0
  .byte  235,91                              // jmp           33bae <_sk_load_g8_sse41_lowp+0x9d>
  .byte  65,15,182,68,16,2                   // movzbl        0x2(%r8,%rdx,1),%eax
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,15,196,200,2                    // pinsrw        $0x2,%eax,%xmm1
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,15,56,48,192                    // pmovzxbw      %xmm0,%xmm0
  .byte  102,15,58,14,193,252                // pblendw       $0xfc,%xmm1,%xmm0
  .byte  235,54                              // jmp           33bae <_sk_load_g8_sse41_lowp+0x9d>
  .byte  65,15,182,68,16,6                   // movzbl        0x6(%r8,%rdx,1),%eax
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,15,196,200,6                    // pinsrw        $0x6,%eax,%xmm1
  .byte  65,15,182,68,16,5                   // movzbl        0x5(%r8,%rdx,1),%eax
  .byte  102,15,196,200,5                    // pinsrw        $0x5,%eax,%xmm1
  .byte  65,15,182,68,16,4                   // movzbl        0x4(%r8,%rdx,1),%eax
  .byte  102,15,196,200,4                    // pinsrw        $0x4,%eax,%xmm1
  .byte  102,65,15,110,4,16                  // movd          (%r8,%rdx,1),%xmm0
  .byte  102,15,56,48,192                    // pmovzxbw      %xmm0,%xmm0
  .byte  102,15,58,14,193,240                // pblendw       $0xf0,%xmm1,%xmm0
  .byte  102,15,219,5,58,111,0,0             // pand          0x6f3a(%rip),%xmm0        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,49,111,0,0                 // movaps        0x6f31(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  115,255                             // jae           33bcd <_sk_load_g8_sse41_lowp+0xbc>
  .byte  255                                 // (bad)
  .byte  255,150,255,255,255,135             // callq         *-0x78000001(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,209                             // callq         *%rcx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,198                             // inc           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  187,255,255,255,172                 // mov           $0xacffffff,%ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_g8_dst_sse41_lowp
.globl _sk_load_g8_dst_sse41_lowp
FUNCTION(_sk_load_g8_dst_sse41_lowp)
_sk_load_g8_dst_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            33c21 <_sk_load_g8_dst_sse41_lowp+0x39>
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,147,0,0,0                 // lea           0x93(%rip),%r9        # 33ca0 <_sk_load_g8_dst_sse41_lowp+0xb8>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  235,100                             // jmp           33c85 <_sk_load_g8_dst_sse41_lowp+0x9d>
  .byte  102,65,15,56,48,36,16               // pmovzxbw      (%r8,%rdx,1),%xmm4
  .byte  235,91                              // jmp           33c85 <_sk_load_g8_dst_sse41_lowp+0x9d>
  .byte  65,15,182,68,16,2                   // movzbl        0x2(%r8,%rdx,1),%eax
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  102,15,196,232,2                    // pinsrw        $0x2,%eax,%xmm5
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  102,15,56,48,228                    // pmovzxbw      %xmm4,%xmm4
  .byte  102,15,58,14,229,252                // pblendw       $0xfc,%xmm5,%xmm4
  .byte  235,54                              // jmp           33c85 <_sk_load_g8_dst_sse41_lowp+0x9d>
  .byte  65,15,182,68,16,6                   // movzbl        0x6(%r8,%rdx,1),%eax
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  102,15,196,232,6                    // pinsrw        $0x6,%eax,%xmm5
  .byte  65,15,182,68,16,5                   // movzbl        0x5(%r8,%rdx,1),%eax
  .byte  102,15,196,232,5                    // pinsrw        $0x5,%eax,%xmm5
  .byte  65,15,182,68,16,4                   // movzbl        0x4(%r8,%rdx,1),%eax
  .byte  102,15,196,232,4                    // pinsrw        $0x4,%eax,%xmm5
  .byte  102,65,15,110,36,16                 // movd          (%r8,%rdx,1),%xmm4
  .byte  102,15,56,48,228                    // pmovzxbw      %xmm4,%xmm4
  .byte  102,15,58,14,229,240                // pblendw       $0xf0,%xmm5,%xmm4
  .byte  102,15,219,37,99,110,0,0            // pand          0x6e63(%rip),%xmm4        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,61,90,110,0,0                 // movaps        0x6e5a(%rip),%xmm7        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  255,224                             // jmpq          *%rax
  .byte  118,255                             // jbe           33ca1 <_sk_load_g8_dst_sse41_lowp+0xb9>
  .byte  255                                 // (bad)
  .byte  255,153,255,255,255,138             // lcall         *-0x75000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,212                             // callq         *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,201                             // dec           %ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  190,255,255,255,175                 // mov           $0xafffffff,%esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_luminance_to_alpha_sse41_lowp
.globl _sk_luminance_to_alpha_sse41_lowp
FUNCTION(_sk_luminance_to_alpha_sse41_lowp)
_sk_luminance_to_alpha_sse41_lowp:
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,213,5,104,118,0,0            // pmullw        0x7668(%rip),%xmm0        # 3b330 <_sk_srcover_bgra_8888_sse2_lowp+0x13c8>
  .byte  102,15,213,13,112,118,0,0           // pmullw        0x7670(%rip),%xmm1        # 3b340 <_sk_srcover_bgra_8888_sse2_lowp+0x13d8>
  .byte  102,15,253,200                      // paddw         %xmm0,%xmm1
  .byte  102,15,213,29,116,118,0,0           // pmullw        0x7674(%rip),%xmm3        # 3b350 <_sk_srcover_bgra_8888_sse2_lowp+0x13e8>
  .byte  102,15,253,217                      // paddw         %xmm1,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gather_g8_sse41_lowp
.globl _sk_gather_g8_sse41_lowp
FUNCTION(_sk_gather_g8_sse41_lowp)
_sk_gather_g8_sse41_lowp:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  65,15,95,194                        // maxps         %xmm10,%xmm0
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  243,68,15,16,64,16                  // movss         0x10(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  65,15,95,218                        // maxps         %xmm10,%xmm3
  .byte  65,15,95,210                        // maxps         %xmm10,%xmm2
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  243,68,15,91,195                    // cvttps2dq     %xmm3,%xmm8
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  102,15,110,88,8                     // movd          0x8(%rax),%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  102,15,56,64,211                    // pmulld        %xmm3,%xmm2
  .byte  102,68,15,56,64,195                 // pmulld        %xmm3,%xmm8
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,194                      // paddd         %xmm2,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,65,15,254,200                   // paddd         %xmm8,%xmm1
  .byte  102,72,15,58,22,200,1               // pextrq        $0x1,%xmm1,%rax
  .byte  65,137,193                          // mov           %eax,%r9d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,72,15,58,22,195,1               // pextrq        $0x1,%xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,73,15,126,199                   // movq          %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,182,60,56                     // movzbl        (%r8,%r15,1),%r15d
  .byte  67,15,182,44,32                     // movzbl        (%r8,%r12,1),%ebp
  .byte  102,15,110,197                      // movd          %ebp,%xmm0
  .byte  102,65,15,58,32,199,1               // pinsrb        $0x1,%r15d,%xmm0
  .byte  67,15,182,44,48                     // movzbl        (%r8,%r14,1),%ebp
  .byte  102,15,58,32,197,2                  // pinsrb        $0x2,%ebp,%xmm0
  .byte  65,15,182,28,24                     // movzbl        (%r8,%rbx,1),%ebx
  .byte  102,15,58,32,195,3                  // pinsrb        $0x3,%ebx,%xmm0
  .byte  67,15,182,44,24                     // movzbl        (%r8,%r11,1),%ebp
  .byte  102,15,58,32,197,4                  // pinsrb        $0x4,%ebp,%xmm0
  .byte  67,15,182,44,16                     // movzbl        (%r8,%r10,1),%ebp
  .byte  102,15,58,32,197,5                  // pinsrb        $0x5,%ebp,%xmm0
  .byte  67,15,182,44,8                      // movzbl        (%r8,%r9,1),%ebp
  .byte  102,15,58,32,197,6                  // pinsrb        $0x6,%ebp,%xmm0
  .byte  65,15,182,4,0                       // movzbl        (%r8,%rax,1),%eax
  .byte  102,15,58,32,192,7                  // pinsrb        $0x7,%eax,%xmm0
  .byte  102,15,56,48,192                    // pmovzxbw      %xmm0,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,221,108,0,0                // movaps        0x6cdd(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_1_float_sse41_lowp
.globl _sk_scale_1_float_sse41_lowp
FUNCTION(_sk_scale_1_float_sse41_lowp)
_sk_scale_1_float_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,89,5,15,100,0,0           // mulss         0x640f(%rip),%xmm8        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  243,68,15,88,5,214,99,0,0           // addss         0x63d6(%rip),%xmm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  243,65,15,44,192                    // cvttss2si     %xmm8,%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  242,69,15,112,192,0                 // pshuflw       $0x0,%xmm8,%xmm8
  .byte  102,69,15,112,192,80                // pshufd        $0x50,%xmm8,%xmm8
  .byte  102,65,15,213,192                   // pmullw        %xmm8,%xmm0
  .byte  102,68,15,111,13,142,108,0,0        // movdqa        0x6c8e(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,193                   // paddw         %xmm9,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,65,15,213,200                   // pmullw        %xmm8,%xmm1
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,65,15,213,208                   // pmullw        %xmm8,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,65,15,213,216                   // pmullw        %xmm8,%xmm3
  .byte  102,65,15,253,217                   // paddw         %xmm9,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lerp_1_float_sse41_lowp
.globl _sk_lerp_1_float_sse41_lowp
FUNCTION(_sk_lerp_1_float_sse41_lowp)
_sk_lerp_1_float_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,89,5,151,99,0,0           // mulss         0x6397(%rip),%xmm8        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  243,68,15,88,5,94,99,0,0            // addss         0x635e(%rip),%xmm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  243,65,15,44,192                    // cvttss2si     %xmm8,%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  242,69,15,112,192,0                 // pshuflw       $0x0,%xmm8,%xmm8
  .byte  102,69,15,112,192,80                // pshufd        $0x50,%xmm8,%xmm8
  .byte  102,68,15,111,13,27,108,0,0         // movdqa        0x6c1b(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,213,192                   // pmullw        %xmm8,%xmm0
  .byte  102,65,15,253,193                   // paddw         %xmm9,%xmm0
  .byte  102,65,15,213,200                   // pmullw        %xmm8,%xmm1
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,65,15,213,208                   // pmullw        %xmm8,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,65,15,213,216                   // pmullw        %xmm8,%xmm3
  .byte  102,65,15,253,217                   // paddw         %xmm9,%xmm3
  .byte  102,69,15,249,200                   // psubw         %xmm8,%xmm9
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,213,196                   // pmullw        %xmm4,%xmm8
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,213,197                   // pmullw        %xmm5,%xmm8
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,213,198                   // pmullw        %xmm6,%xmm8
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,68,15,213,207                   // pmullw        %xmm7,%xmm9
  .byte  102,65,15,253,217                   // paddw         %xmm9,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_u8_sse41_lowp
.globl _sk_scale_u8_sse41_lowp
FUNCTION(_sk_scale_u8_sse41_lowp)
_sk_scale_u8_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,36                              // ja            33f8c <_sk_scale_u8_sse41_lowp+0x3b>
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,221,0,0,0                 // lea           0xdd(%rip),%r9        # 34054 <_sk_scale_u8_sse41_lowp+0x103>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  235,111                             // jmp           33ffb <_sk_scale_u8_sse41_lowp+0xaa>
  .byte  102,69,15,56,48,4,16                // pmovzxbw      (%r8,%rdx,1),%xmm8
  .byte  235,102                             // jmp           33ffb <_sk_scale_u8_sse41_lowp+0xaa>
  .byte  65,15,182,68,16,2                   // movzbl        0x2(%r8,%rdx,1),%eax
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  102,68,15,196,200,2                 // pinsrw        $0x2,%eax,%xmm9
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,56,48,192                 // pmovzxbw      %xmm8,%xmm8
  .byte  102,69,15,58,14,193,252             // pblendw       $0xfc,%xmm9,%xmm8
  .byte  235,60                              // jmp           33ffb <_sk_scale_u8_sse41_lowp+0xaa>
  .byte  65,15,182,68,16,6                   // movzbl        0x6(%r8,%rdx,1),%eax
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  102,68,15,196,200,6                 // pinsrw        $0x6,%eax,%xmm9
  .byte  65,15,182,68,16,5                   // movzbl        0x5(%r8,%rdx,1),%eax
  .byte  102,68,15,196,200,5                 // pinsrw        $0x5,%eax,%xmm9
  .byte  65,15,182,68,16,4                   // movzbl        0x4(%r8,%rdx,1),%eax
  .byte  102,68,15,196,200,4                 // pinsrw        $0x4,%eax,%xmm9
  .byte  102,69,15,110,4,16                  // movd          (%r8,%rdx,1),%xmm8
  .byte  102,69,15,56,48,192                 // pmovzxbw      %xmm8,%xmm8
  .byte  102,69,15,58,14,193,240             // pblendw       $0xf0,%xmm9,%xmm8
  .byte  102,68,15,219,5,236,106,0,0         // pand          0x6aec(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,213,192                   // pmullw        %xmm8,%xmm0
  .byte  102,68,15,111,13,222,106,0,0        // movdqa        0x6ade(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,193                   // paddw         %xmm9,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,65,15,213,200                   // pmullw        %xmm8,%xmm1
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,65,15,213,208                   // pmullw        %xmm8,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,68,15,213,195                   // pmullw        %xmm3,%xmm8
  .byte  102,69,15,253,193                   // paddw         %xmm9,%xmm8
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  144                                 // nop
  .byte  44,255                              // sub           $0xff,%al
  .byte  255                                 // (bad)
  .byte  255,82,255                          // callq         *-0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,65,255                          // incl          -0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,148,255,255,255,136,255         // callq         *-0x770001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  124,255                             // jl            34069 <_sk_scale_u8_sse41_lowp+0x118>
  .byte  255                                 // (bad)
  .byte  255,107,255                         // ljmp          *-0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_lerp_u8_sse41_lowp
.globl _sk_lerp_u8_sse41_lowp
FUNCTION(_sk_lerp_u8_sse41_lowp)
_sk_lerp_u8_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,36                              // ja            340ab <_sk_lerp_u8_sse41_lowp+0x3b>
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,30,1,0,0                  // lea           0x11e(%rip),%r9        # 341b4 <_sk_lerp_u8_sse41_lowp+0x144>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  235,111                             // jmp           3411a <_sk_lerp_u8_sse41_lowp+0xaa>
  .byte  102,69,15,56,48,4,16                // pmovzxbw      (%r8,%rdx,1),%xmm8
  .byte  235,102                             // jmp           3411a <_sk_lerp_u8_sse41_lowp+0xaa>
  .byte  65,15,182,68,16,2                   // movzbl        0x2(%r8,%rdx,1),%eax
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  102,68,15,196,200,2                 // pinsrw        $0x2,%eax,%xmm9
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,69,15,56,48,192                 // pmovzxbw      %xmm8,%xmm8
  .byte  102,69,15,58,14,193,252             // pblendw       $0xfc,%xmm9,%xmm8
  .byte  235,60                              // jmp           3411a <_sk_lerp_u8_sse41_lowp+0xaa>
  .byte  65,15,182,68,16,6                   // movzbl        0x6(%r8,%rdx,1),%eax
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  102,68,15,196,200,6                 // pinsrw        $0x6,%eax,%xmm9
  .byte  65,15,182,68,16,5                   // movzbl        0x5(%r8,%rdx,1),%eax
  .byte  102,68,15,196,200,5                 // pinsrw        $0x5,%eax,%xmm9
  .byte  65,15,182,68,16,4                   // movzbl        0x4(%r8,%rdx,1),%eax
  .byte  102,68,15,196,200,4                 // pinsrw        $0x4,%eax,%xmm9
  .byte  102,69,15,110,4,16                  // movd          (%r8,%rdx,1),%xmm8
  .byte  102,69,15,56,48,192                 // pmovzxbw      %xmm8,%xmm8
  .byte  102,69,15,58,14,193,240             // pblendw       $0xf0,%xmm9,%xmm8
  .byte  102,68,15,219,5,205,105,0,0         // pand          0x69cd(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,68,15,111,21,196,105,0,0        // movdqa        0x69c4(%rip),%xmm10        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,69,15,239,202                   // pxor          %xmm10,%xmm9
  .byte  102,69,15,111,217                   // movdqa        %xmm9,%xmm11
  .byte  102,68,15,213,220                   // pmullw        %xmm4,%xmm11
  .byte  102,65,15,213,192                   // pmullw        %xmm8,%xmm0
  .byte  102,65,15,253,194                   // paddw         %xmm10,%xmm0
  .byte  102,65,15,253,195                   // paddw         %xmm11,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,69,15,111,217                   // movdqa        %xmm9,%xmm11
  .byte  102,68,15,213,221                   // pmullw        %xmm5,%xmm11
  .byte  102,65,15,213,200                   // pmullw        %xmm8,%xmm1
  .byte  102,65,15,253,202                   // paddw         %xmm10,%xmm1
  .byte  102,65,15,253,203                   // paddw         %xmm11,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,69,15,111,217                   // movdqa        %xmm9,%xmm11
  .byte  102,68,15,213,222                   // pmullw        %xmm6,%xmm11
  .byte  102,65,15,213,208                   // pmullw        %xmm8,%xmm2
  .byte  102,65,15,253,210                   // paddw         %xmm10,%xmm2
  .byte  102,65,15,253,211                   // paddw         %xmm11,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,68,15,213,207                   // pmullw        %xmm7,%xmm9
  .byte  102,68,15,213,195                   // pmullw        %xmm3,%xmm8
  .byte  102,69,15,253,194                   // paddw         %xmm10,%xmm8
  .byte  102,69,15,253,193                   // paddw         %xmm9,%xmm8
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  144                                 // nop
  .byte  235,254                             // jmp           341b4 <_sk_lerp_u8_sse41_lowp+0x144>
  .byte  255                                 // (bad)
  .byte  255,17                              // callq         *(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,83,255                          // callq         *-0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,71,255                          // incl          -0x1(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  59,255                              // cmp           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,42                              // ljmp          *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_scale_565_sse41_lowp
.globl _sk_scale_565_sse41_lowp
FUNCTION(_sk_scale_565_sse41_lowp)
_sk_scale_565_sse41_lowp:
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,35                              // ja            34212 <_sk_scale_565_sse41_lowp+0x42>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,111,1,0,0                 // lea           0x16f(%rip),%r9        # 3436c <_sk_scale_565_sse41_lowp+0x19c>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  102,68,15,110,200                   // movd          %eax,%xmm9
  .byte  235,76                              // jmp           3425e <_sk_scale_565_sse41_lowp+0x8e>
  .byte  243,69,15,111,12,80                 // movdqu        (%r8,%rdx,2),%xmm9
  .byte  235,68                              // jmp           3425e <_sk_scale_565_sse41_lowp+0x8e>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,65,15,196,68,80,4,2             // pinsrw        $0x2,0x4(%r8,%rdx,2),%xmm0
  .byte  102,69,15,110,12,80                 // movd          (%r8,%rdx,2),%xmm9
  .byte  102,68,15,58,14,200,252             // pblendw       $0xfc,%xmm0,%xmm9
  .byte  235,41                              // jmp           3425e <_sk_scale_565_sse41_lowp+0x8e>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,65,15,196,68,80,12,6            // pinsrw        $0x6,0xc(%r8,%rdx,2),%xmm0
  .byte  102,65,15,196,68,80,10,5            // pinsrw        $0x5,0xa(%r8,%rdx,2),%xmm0
  .byte  102,65,15,196,68,80,8,4             // pinsrw        $0x4,0x8(%r8,%rdx,2),%xmm0
  .byte  243,69,15,126,12,80                 // movq          (%r8,%rdx,2),%xmm9
  .byte  102,68,15,58,14,200,240             // pblendw       $0xf0,%xmm0,%xmm9
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,219,5,48,112,0,0             // pand          0x7030(%rip),%xmm0        # 3b2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1338>
  .byte  102,69,15,111,209                   // movdqa        %xmm9,%xmm10
  .byte  102,65,15,113,210,5                 // psrlw         $0x5,%xmm10
  .byte  102,68,15,219,21,44,112,0,0         // pand          0x702c(%rip),%xmm10        # 3b2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1348>
  .byte  102,68,15,111,29,51,112,0,0         // movdqa        0x7033(%rip),%xmm11        # 3b2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1358>
  .byte  102,69,15,219,217                   // pand          %xmm9,%xmm11
  .byte  102,65,15,113,209,13                // psrlw         $0xd,%xmm9
  .byte  102,68,15,235,200                   // por           %xmm0,%xmm9
  .byte  102,65,15,111,194                   // movdqa        %xmm10,%xmm0
  .byte  102,15,113,240,2                    // psllw         $0x2,%xmm0
  .byte  102,65,15,113,210,4                 // psrlw         $0x4,%xmm10
  .byte  102,68,15,235,208                   // por           %xmm0,%xmm10
  .byte  102,65,15,111,195                   // movdqa        %xmm11,%xmm0
  .byte  102,15,113,240,3                    // psllw         $0x3,%xmm0
  .byte  102,65,15,113,211,2                 // psrlw         $0x2,%xmm11
  .byte  102,68,15,235,216                   // por           %xmm0,%xmm11
  .byte  102,15,111,5,145,111,0,0            // movdqa        0x6f91(%rip),%xmm0        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,68,15,111,227                   // movdqa        %xmm3,%xmm12
  .byte  102,68,15,239,224                   // pxor          %xmm0,%xmm12
  .byte  102,15,239,199                      // pxor          %xmm7,%xmm0
  .byte  102,65,15,101,196                   // pcmpgtw       %xmm12,%xmm0
  .byte  102,69,15,111,234                   // movdqa        %xmm10,%xmm13
  .byte  102,69,15,56,58,235                 // pminuw        %xmm11,%xmm13
  .byte  102,69,15,56,58,233                 // pminuw        %xmm9,%xmm13
  .byte  102,69,15,111,226                   // movdqa        %xmm10,%xmm12
  .byte  102,69,15,56,62,227                 // pmaxuw        %xmm11,%xmm12
  .byte  102,69,15,56,62,225                 // pmaxuw        %xmm9,%xmm12
  .byte  102,69,15,56,16,229                 // pblendvb      %xmm0,%xmm13,%xmm12
  .byte  102,69,15,213,200                   // pmullw        %xmm8,%xmm9
  .byte  102,15,111,5,217,103,0,0            // movdqa        0x67d9(%rip),%xmm0        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,68,15,253,200                   // paddw         %xmm0,%xmm9
  .byte  102,65,15,113,209,8                 // psrlw         $0x8,%xmm9
  .byte  102,68,15,213,209                   // pmullw        %xmm1,%xmm10
  .byte  102,68,15,253,208                   // paddw         %xmm0,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,68,15,213,218                   // pmullw        %xmm2,%xmm11
  .byte  102,68,15,253,216                   // paddw         %xmm0,%xmm11
  .byte  102,65,15,113,211,8                 // psrlw         $0x8,%xmm11
  .byte  102,68,15,213,227                   // pmullw        %xmm3,%xmm12
  .byte  102,68,15,253,224                   // paddw         %xmm0,%xmm12
  .byte  102,65,15,113,212,8                 // psrlw         $0x8,%xmm12
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,65,15,111,202                   // movdqa        %xmm10,%xmm1
  .byte  102,65,15,111,211                   // movdqa        %xmm11,%xmm2
  .byte  102,65,15,111,220                   // movdqa        %xmm12,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  154                                 // (bad)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  186,254,255,255,174                 // mov           $0xaefffffe,%edx
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,229                             // jmpq          *%rbp
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  221,254                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,213                             // callq         *%rbp
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,201                             // dec           %ecx
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_lerp_565_sse41_lowp
.globl _sk_lerp_565_sse41_lowp
FUNCTION(_sk_lerp_565_sse41_lowp)
_sk_lerp_565_sse41_lowp:
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,35                              // ja            343ca <_sk_lerp_565_sse41_lowp+0x42>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,187,1,0,0                 // lea           0x1bb(%rip),%r9        # 34570 <_sk_lerp_565_sse41_lowp+0x1e8>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  102,68,15,110,200                   // movd          %eax,%xmm9
  .byte  235,76                              // jmp           34416 <_sk_lerp_565_sse41_lowp+0x8e>
  .byte  243,69,15,111,12,80                 // movdqu        (%r8,%rdx,2),%xmm9
  .byte  235,68                              // jmp           34416 <_sk_lerp_565_sse41_lowp+0x8e>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,65,15,196,68,80,4,2             // pinsrw        $0x2,0x4(%r8,%rdx,2),%xmm0
  .byte  102,69,15,110,12,80                 // movd          (%r8,%rdx,2),%xmm9
  .byte  102,68,15,58,14,200,252             // pblendw       $0xfc,%xmm0,%xmm9
  .byte  235,41                              // jmp           34416 <_sk_lerp_565_sse41_lowp+0x8e>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,65,15,196,68,80,12,6            // pinsrw        $0x6,0xc(%r8,%rdx,2),%xmm0
  .byte  102,65,15,196,68,80,10,5            // pinsrw        $0x5,0xa(%r8,%rdx,2),%xmm0
  .byte  102,65,15,196,68,80,8,4             // pinsrw        $0x4,0x8(%r8,%rdx,2),%xmm0
  .byte  243,69,15,126,12,80                 // movq          (%r8,%rdx,2),%xmm9
  .byte  102,68,15,58,14,200,240             // pblendw       $0xf0,%xmm0,%xmm9
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,219,5,120,110,0,0            // pand          0x6e78(%rip),%xmm0        # 3b2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1338>
  .byte  102,69,15,111,209                   // movdqa        %xmm9,%xmm10
  .byte  102,65,15,113,210,5                 // psrlw         $0x5,%xmm10
  .byte  102,68,15,219,21,116,110,0,0        // pand          0x6e74(%rip),%xmm10        # 3b2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1348>
  .byte  102,68,15,111,29,123,110,0,0        // movdqa        0x6e7b(%rip),%xmm11        # 3b2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1358>
  .byte  102,69,15,219,217                   // pand          %xmm9,%xmm11
  .byte  102,65,15,113,209,13                // psrlw         $0xd,%xmm9
  .byte  102,68,15,235,200                   // por           %xmm0,%xmm9
  .byte  102,65,15,111,194                   // movdqa        %xmm10,%xmm0
  .byte  102,15,113,240,2                    // psllw         $0x2,%xmm0
  .byte  102,65,15,113,210,4                 // psrlw         $0x4,%xmm10
  .byte  102,68,15,235,208                   // por           %xmm0,%xmm10
  .byte  102,65,15,111,195                   // movdqa        %xmm11,%xmm0
  .byte  102,15,113,240,3                    // psllw         $0x3,%xmm0
  .byte  102,65,15,113,211,2                 // psrlw         $0x2,%xmm11
  .byte  102,68,15,235,216                   // por           %xmm0,%xmm11
  .byte  102,15,111,5,217,109,0,0            // movdqa        0x6dd9(%rip),%xmm0        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,68,15,111,227                   // movdqa        %xmm3,%xmm12
  .byte  102,68,15,239,224                   // pxor          %xmm0,%xmm12
  .byte  102,15,239,199                      // pxor          %xmm7,%xmm0
  .byte  102,65,15,101,196                   // pcmpgtw       %xmm12,%xmm0
  .byte  102,69,15,111,234                   // movdqa        %xmm10,%xmm13
  .byte  102,69,15,56,58,235                 // pminuw        %xmm11,%xmm13
  .byte  102,69,15,56,58,233                 // pminuw        %xmm9,%xmm13
  .byte  102,69,15,111,226                   // movdqa        %xmm10,%xmm12
  .byte  102,69,15,56,62,227                 // pmaxuw        %xmm11,%xmm12
  .byte  102,69,15,56,62,225                 // pmaxuw        %xmm9,%xmm12
  .byte  102,69,15,56,16,229                 // pblendvb      %xmm0,%xmm13,%xmm12
  .byte  102,68,15,111,45,37,102,0,0         // movdqa        0x6625(%rip),%xmm13        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,65,15,239,197                   // pxor          %xmm13,%xmm0
  .byte  102,15,213,196                      // pmullw        %xmm4,%xmm0
  .byte  102,69,15,213,200                   // pmullw        %xmm8,%xmm9
  .byte  102,69,15,253,205                   // paddw         %xmm13,%xmm9
  .byte  102,68,15,253,200                   // paddw         %xmm0,%xmm9
  .byte  102,65,15,113,209,8                 // psrlw         $0x8,%xmm9
  .byte  102,65,15,111,194                   // movdqa        %xmm10,%xmm0
  .byte  102,65,15,239,197                   // pxor          %xmm13,%xmm0
  .byte  102,15,213,197                      // pmullw        %xmm5,%xmm0
  .byte  102,68,15,213,209                   // pmullw        %xmm1,%xmm10
  .byte  102,69,15,253,213                   // paddw         %xmm13,%xmm10
  .byte  102,68,15,253,208                   // paddw         %xmm0,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,65,15,111,195                   // movdqa        %xmm11,%xmm0
  .byte  102,65,15,239,197                   // pxor          %xmm13,%xmm0
  .byte  102,15,213,198                      // pmullw        %xmm6,%xmm0
  .byte  102,68,15,213,218                   // pmullw        %xmm2,%xmm11
  .byte  102,69,15,253,221                   // paddw         %xmm13,%xmm11
  .byte  102,68,15,253,216                   // paddw         %xmm0,%xmm11
  .byte  102,65,15,113,211,8                 // psrlw         $0x8,%xmm11
  .byte  102,65,15,111,196                   // movdqa        %xmm12,%xmm0
  .byte  102,65,15,239,197                   // pxor          %xmm13,%xmm0
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,68,15,213,227                   // pmullw        %xmm3,%xmm12
  .byte  102,69,15,253,229                   // paddw         %xmm13,%xmm12
  .byte  102,68,15,253,224                   // paddw         %xmm0,%xmm12
  .byte  102,65,15,113,212,8                 // psrlw         $0x8,%xmm12
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,65,15,111,202                   // movdqa        %xmm10,%xmm1
  .byte  102,65,15,111,211                   // movdqa        %xmm11,%xmm2
  .byte  102,65,15,111,220                   // movdqa        %xmm12,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  144                                 // nop
  .byte  78,254                              // rex.WRX       (bad)
  .byte  255                                 // (bad)
  .byte  255,110,254                         // ljmp          *-0x2(%rsi)
  .byte  255                                 // (bad)
  .byte  255,98,254                          // jmpq          *-0x2(%rdx)
  .byte  255                                 // (bad)
  .byte  255,153,254,255,255,145             // lcall         *-0x6e000002(%rcx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,137,254,255,255,125             // decl          0x7dfffffe(%rcx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_clamp_x_1_sse41_lowp
.globl _sk_clamp_x_1_sse41_lowp
FUNCTION(_sk_clamp_x_1_sse41_lowp)
_sk_clamp_x_1_sse41_lowp:
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  65,15,95,200                        // maxps         %xmm8,%xmm1
  .byte  65,15,95,192                        // maxps         %xmm8,%xmm0
  .byte  68,15,40,5,176,101,0,0              // movaps        0x65b0(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_repeat_x_1_sse41_lowp
.globl _sk_repeat_x_1_sse41_lowp
FUNCTION(_sk_repeat_x_1_sse41_lowp)
_sk_repeat_x_1_sse41_lowp:
  .byte  102,68,15,58,8,192,1                // roundps       $0x1,%xmm0,%xmm8
  .byte  102,68,15,58,8,201,1                // roundps       $0x1,%xmm1,%xmm9
  .byte  65,15,92,192                        // subps         %xmm8,%xmm0
  .byte  65,15,92,201                        // subps         %xmm9,%xmm1
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  65,15,95,200                        // maxps         %xmm8,%xmm1
  .byte  65,15,95,192                        // maxps         %xmm8,%xmm0
  .byte  68,15,40,5,122,101,0,0              // movaps        0x657a(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_x_1_sse41_lowp
.globl _sk_mirror_x_1_sse41_lowp
FUNCTION(_sk_mirror_x_1_sse41_lowp)
_sk_mirror_x_1_sse41_lowp:
  .byte  68,15,40,5,198,101,0,0              // movaps        0x65c6(%rip),%xmm8        # 3abb0 <_sk_srcover_bgra_8888_sse2_lowp+0xc48>
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  68,15,40,13,70,101,0,0              // movaps        0x6546(%rip),%xmm9        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,40,209                        // movaps        %xmm1,%xmm10
  .byte  69,15,89,209                        // mulps         %xmm9,%xmm10
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  102,69,15,58,8,201,1                // roundps       $0x1,%xmm9,%xmm9
  .byte  102,69,15,58,8,210,1                // roundps       $0x1,%xmm10,%xmm10
  .byte  69,15,88,210                        // addps         %xmm10,%xmm10
  .byte  69,15,88,201                        // addps         %xmm9,%xmm9
  .byte  65,15,92,193                        // subps         %xmm9,%xmm0
  .byte  65,15,92,202                        // subps         %xmm10,%xmm1
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  68,15,40,5,60,106,0,0               // movaps        0x6a3c(%rip),%xmm8        # 3b070 <_sk_srcover_bgra_8888_sse2_lowp+0x1108>
  .byte  65,15,84,192                        // andps         %xmm8,%xmm0
  .byte  65,15,84,200                        // andps         %xmm8,%xmm1
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  65,15,95,200                        // maxps         %xmm8,%xmm1
  .byte  65,15,95,192                        // maxps         %xmm8,%xmm0
  .byte  68,15,40,5,0,101,0,0                // movaps        0x6500(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gradient_sse41_lowp
.globl _sk_gradient_sse41_lowp
FUNCTION(_sk_gradient_sse41_lowp)
_sk_gradient_sse41_lowp:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  15,41,124,36,232                    // movaps        %xmm7,-0x18(%rsp)
  .byte  15,41,116,36,216                    // movaps        %xmm6,-0x28(%rsp)
  .byte  72,137,76,36,208                    // mov           %rcx,-0x30(%rsp)
  .byte  72,137,84,36,200                    // mov           %rdx,-0x38(%rsp)
  .byte  72,137,124,36,192                   // mov           %rdi,-0x40(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,137,116,36,184                   // mov           %rsi,-0x48(%rsp)
  .byte  72,139,8                            // mov           (%rax),%rcx
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  72,131,249,2                        // cmp           $0x2,%rcx
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  114,57                              // jb            346d1 <_sk_gradient_sse41_lowp+0x75>
  .byte  72,139,80,72                        // mov           0x48(%rax),%rdx
  .byte  72,255,201                          // dec           %rcx
  .byte  72,131,194,4                        // add           $0x4,%rdx
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  243,15,16,18                        // movss         (%rdx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,194,248,2                        // cmpleps       %xmm0,%xmm7
  .byte  102,68,15,250,207                   // psubd         %xmm7,%xmm9
  .byte  15,194,209,2                        // cmpleps       %xmm1,%xmm2
  .byte  102,15,250,218                      // psubd         %xmm2,%xmm3
  .byte  72,131,194,4                        // add           $0x4,%rdx
  .byte  72,255,201                          // dec           %rcx
  .byte  117,219                             // jne           346ac <_sk_gradient_sse41_lowp+0x50>
  .byte  102,72,15,58,22,219,1               // pextrq        $0x1,%xmm3,%rbx
  .byte  65,137,221                          // mov           %ebx,%r13d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,72,15,126,221                   // movq          %xmm3,%rbp
  .byte  137,239                             // mov           %ebp,%edi
  .byte  72,193,237,32                       // shr           $0x20,%rbp
  .byte  102,69,15,126,200                   // movd          %xmm9,%r8d
  .byte  102,69,15,58,22,201,1               // pextrd        $0x1,%xmm9,%r9d
  .byte  102,69,15,58,22,202,2               // pextrd        $0x2,%xmm9,%r10d
  .byte  72,139,72,8                         // mov           0x8(%rax),%rcx
  .byte  243,68,15,16,44,185                 // movss         (%rcx,%rdi,4),%xmm13
  .byte  102,68,15,58,33,44,169,16           // insertps      $0x10,(%rcx,%rbp,4),%xmm13
  .byte  243,66,15,16,20,169                 // movss         (%rcx,%r13,4),%xmm2
  .byte  243,68,15,16,4,153                  // movss         (%rcx,%rbx,4),%xmm8
  .byte  243,66,15,16,28,129                 // movss         (%rcx,%r8,4),%xmm3
  .byte  102,66,15,58,33,28,137,16           // insertps      $0x10,(%rcx,%r9,4),%xmm3
  .byte  102,66,15,58,33,28,145,32           // insertps      $0x20,(%rcx,%r10,4),%xmm3
  .byte  102,69,15,58,22,203,3               // pextrd        $0x3,%xmm9,%r11d
  .byte  102,66,15,58,33,28,153,48           // insertps      $0x30,(%rcx,%r11,4),%xmm3
  .byte  102,68,15,58,33,234,32              // insertps      $0x20,%xmm2,%xmm13
  .byte  76,139,96,16                        // mov           0x10(%rax),%r12
  .byte  243,69,15,16,12,188                 // movss         (%r12,%rdi,4),%xmm9
  .byte  76,139,120,24                       // mov           0x18(%rax),%r15
  .byte  243,69,15,16,28,191                 // movss         (%r15,%rdi,4),%xmm11
  .byte  76,139,112,32                       // mov           0x20(%rax),%r14
  .byte  243,69,15,16,20,190                 // movss         (%r14,%rdi,4),%xmm10
  .byte  72,139,112,40                       // mov           0x28(%rax),%rsi
  .byte  243,68,15,16,60,190                 // movss         (%rsi,%rdi,4),%xmm15
  .byte  72,139,80,48                        // mov           0x30(%rax),%rdx
  .byte  243,68,15,16,52,186                 // movss         (%rdx,%rdi,4),%xmm14
  .byte  72,139,72,56                        // mov           0x38(%rax),%rcx
  .byte  243,15,16,20,185                    // movss         (%rcx,%rdi,4),%xmm2
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  243,68,15,16,36,184                 // movss         (%rax,%rdi,4),%xmm12
  .byte  102,69,15,58,33,12,172,16           // insertps      $0x10,(%r12,%rbp,4),%xmm9
  .byte  102,69,15,58,33,28,175,16           // insertps      $0x10,(%r15,%rbp,4),%xmm11
  .byte  102,69,15,58,33,20,174,16           // insertps      $0x10,(%r14,%rbp,4),%xmm10
  .byte  102,68,15,58,33,60,174,16           // insertps      $0x10,(%rsi,%rbp,4),%xmm15
  .byte  102,68,15,58,33,52,170,16           // insertps      $0x10,(%rdx,%rbp,4),%xmm14
  .byte  102,15,58,33,20,169,16              // insertps      $0x10,(%rcx,%rbp,4),%xmm2
  .byte  102,68,15,58,33,36,168,16           // insertps      $0x10,(%rax,%rbp,4),%xmm12
  .byte  102,69,15,58,33,232,48              // insertps      $0x30,%xmm8,%xmm13
  .byte  243,67,15,16,60,172                 // movss         (%r12,%r13,4),%xmm7
  .byte  102,68,15,58,33,207,32              // insertps      $0x20,%xmm7,%xmm9
  .byte  243,65,15,16,60,156                 // movss         (%r12,%rbx,4),%xmm7
  .byte  102,68,15,58,33,207,48              // insertps      $0x30,%xmm7,%xmm9
  .byte  243,67,15,16,60,175                 // movss         (%r15,%r13,4),%xmm7
  .byte  102,68,15,58,33,223,32              // insertps      $0x20,%xmm7,%xmm11
  .byte  243,65,15,16,60,159                 // movss         (%r15,%rbx,4),%xmm7
  .byte  102,68,15,58,33,223,48              // insertps      $0x30,%xmm7,%xmm11
  .byte  243,67,15,16,60,174                 // movss         (%r14,%r13,4),%xmm7
  .byte  102,68,15,58,33,215,32              // insertps      $0x20,%xmm7,%xmm10
  .byte  243,65,15,16,60,158                 // movss         (%r14,%rbx,4),%xmm7
  .byte  102,68,15,58,33,215,48              // insertps      $0x30,%xmm7,%xmm10
  .byte  243,66,15,16,60,174                 // movss         (%rsi,%r13,4),%xmm7
  .byte  102,68,15,58,33,255,32              // insertps      $0x20,%xmm7,%xmm15
  .byte  243,15,16,60,158                    // movss         (%rsi,%rbx,4),%xmm7
  .byte  102,68,15,58,33,255,48              // insertps      $0x30,%xmm7,%xmm15
  .byte  243,66,15,16,60,170                 // movss         (%rdx,%r13,4),%xmm7
  .byte  102,68,15,58,33,247,32              // insertps      $0x20,%xmm7,%xmm14
  .byte  243,15,16,60,154                    // movss         (%rdx,%rbx,4),%xmm7
  .byte  102,68,15,58,33,247,48              // insertps      $0x30,%xmm7,%xmm14
  .byte  243,66,15,16,60,169                 // movss         (%rcx,%r13,4),%xmm7
  .byte  102,15,58,33,215,32                 // insertps      $0x20,%xmm7,%xmm2
  .byte  243,15,16,60,153                    // movss         (%rcx,%rbx,4),%xmm7
  .byte  102,15,58,33,215,48                 // insertps      $0x30,%xmm7,%xmm2
  .byte  243,66,15,16,60,168                 // movss         (%rax,%r13,4),%xmm7
  .byte  102,68,15,58,33,231,32              // insertps      $0x20,%xmm7,%xmm12
  .byte  243,15,16,60,152                    // movss         (%rax,%rbx,4),%xmm7
  .byte  102,68,15,58,33,231,48              // insertps      $0x30,%xmm7,%xmm12
  .byte  243,66,15,16,60,134                 // movss         (%rsi,%r8,4),%xmm7
  .byte  102,66,15,58,33,60,142,16           // insertps      $0x10,(%rsi,%r9,4),%xmm7
  .byte  102,66,15,58,33,60,150,32           // insertps      $0x20,(%rsi,%r10,4),%xmm7
  .byte  102,66,15,58,33,60,158,48           // insertps      $0x30,(%rsi,%r11,4),%xmm7
  .byte  68,15,89,233                        // mulps         %xmm1,%xmm13
  .byte  69,15,88,239                        // addps         %xmm15,%xmm13
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  15,40,61,131,99,0,0                 // movaps        0x6383(%rip),%xmm7        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  68,15,89,239                        // mulps         %xmm7,%xmm13
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  68,15,40,61,132,98,0,0              // movaps        0x6284(%rip),%xmm15        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  69,15,88,239                        // addps         %xmm15,%xmm13
  .byte  65,15,88,223                        // addps         %xmm15,%xmm3
  .byte  243,65,15,91,245                    // cvttps2dq     %xmm13,%xmm6
  .byte  102,68,15,111,45,158,105,0,0        // movdqa        0x699e(%rip),%xmm13        # 3b270 <_sk_srcover_bgra_8888_sse2_lowp+0x1308>
  .byte  102,65,15,56,0,245                  // pshufb        %xmm13,%xmm6
  .byte  243,68,15,91,195                    // cvttps2dq     %xmm3,%xmm8
  .byte  102,69,15,56,0,197                  // pshufb        %xmm13,%xmm8
  .byte  102,68,15,108,198                   // punpcklqdq    %xmm6,%xmm8
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  69,15,88,206                        // addps         %xmm14,%xmm9
  .byte  243,67,15,16,28,132                 // movss         (%r12,%r8,4),%xmm3
  .byte  102,67,15,58,33,28,140,16           // insertps      $0x10,(%r12,%r9,4),%xmm3
  .byte  102,67,15,58,33,28,148,32           // insertps      $0x20,(%r12,%r10,4),%xmm3
  .byte  102,67,15,58,33,28,156,48           // insertps      $0x30,(%r12,%r11,4),%xmm3
  .byte  243,66,15,16,52,130                 // movss         (%rdx,%r8,4),%xmm6
  .byte  102,66,15,58,33,52,138,16           // insertps      $0x10,(%rdx,%r9,4),%xmm6
  .byte  102,66,15,58,33,52,146,32           // insertps      $0x20,(%rdx,%r10,4),%xmm6
  .byte  102,66,15,58,33,52,154,48           // insertps      $0x30,(%rdx,%r11,4),%xmm6
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,88,222                           // addps         %xmm6,%xmm3
  .byte  68,15,89,207                        // mulps         %xmm7,%xmm9
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  69,15,88,207                        // addps         %xmm15,%xmm9
  .byte  65,15,88,223                        // addps         %xmm15,%xmm3
  .byte  243,65,15,91,241                    // cvttps2dq     %xmm9,%xmm6
  .byte  102,65,15,56,0,245                  // pshufb        %xmm13,%xmm6
  .byte  243,68,15,91,203                    // cvttps2dq     %xmm3,%xmm9
  .byte  102,69,15,56,0,205                  // pshufb        %xmm13,%xmm9
  .byte  102,68,15,108,206                   // punpcklqdq    %xmm6,%xmm9
  .byte  243,67,15,16,28,135                 // movss         (%r15,%r8,4),%xmm3
  .byte  102,67,15,58,33,28,143,16           // insertps      $0x10,(%r15,%r9,4),%xmm3
  .byte  102,67,15,58,33,28,151,32           // insertps      $0x20,(%r15,%r10,4),%xmm3
  .byte  102,67,15,58,33,28,159,48           // insertps      $0x30,(%r15,%r11,4),%xmm3
  .byte  68,15,89,217                        // mulps         %xmm1,%xmm11
  .byte  68,15,88,218                        // addps         %xmm2,%xmm11
  .byte  243,66,15,16,20,129                 // movss         (%rcx,%r8,4),%xmm2
  .byte  102,66,15,58,33,20,137,16           // insertps      $0x10,(%rcx,%r9,4),%xmm2
  .byte  102,66,15,58,33,20,145,32           // insertps      $0x20,(%rcx,%r10,4),%xmm2
  .byte  102,66,15,58,33,20,153,48           // insertps      $0x30,(%rcx,%r11,4),%xmm2
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  68,15,89,223                        // mulps         %xmm7,%xmm11
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  69,15,88,223                        // addps         %xmm15,%xmm11
  .byte  65,15,88,223                        // addps         %xmm15,%xmm3
  .byte  243,65,15,91,243                    // cvttps2dq     %xmm11,%xmm6
  .byte  102,65,15,56,0,245                  // pshufb        %xmm13,%xmm6
  .byte  243,15,91,211                       // cvttps2dq     %xmm3,%xmm2
  .byte  102,65,15,56,0,213                  // pshufb        %xmm13,%xmm2
  .byte  102,15,108,214                      // punpcklqdq    %xmm6,%xmm2
  .byte  68,15,89,209                        // mulps         %xmm1,%xmm10
  .byte  69,15,88,212                        // addps         %xmm12,%xmm10
  .byte  243,67,15,16,12,134                 // movss         (%r14,%r8,4),%xmm1
  .byte  102,67,15,58,33,12,142,16           // insertps      $0x10,(%r14,%r9,4),%xmm1
  .byte  102,67,15,58,33,12,150,32           // insertps      $0x20,(%r14,%r10,4),%xmm1
  .byte  102,67,15,58,33,12,158,48           // insertps      $0x30,(%r14,%r11,4),%xmm1
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  243,66,15,16,4,128                  // movss         (%rax,%r8,4),%xmm0
  .byte  102,66,15,58,33,4,136,16            // insertps      $0x10,(%rax,%r9,4),%xmm0
  .byte  102,66,15,58,33,4,144,32            // insertps      $0x20,(%rax,%r10,4),%xmm0
  .byte  102,66,15,58,33,4,152,48            // insertps      $0x30,(%rax,%r11,4),%xmm0
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  68,15,89,215                        // mulps         %xmm7,%xmm10
  .byte  15,89,207                           // mulps         %xmm7,%xmm1
  .byte  69,15,88,215                        // addps         %xmm15,%xmm10
  .byte  65,15,88,207                        // addps         %xmm15,%xmm1
  .byte  243,65,15,91,194                    // cvttps2dq     %xmm10,%xmm0
  .byte  102,65,15,56,0,197                  // pshufb        %xmm13,%xmm0
  .byte  243,15,91,217                       // cvttps2dq     %xmm1,%xmm3
  .byte  102,65,15,56,0,221                  // pshufb        %xmm13,%xmm3
  .byte  102,15,108,216                      // punpcklqdq    %xmm0,%xmm3
  .byte  72,139,116,36,184                   // mov           -0x48(%rsp),%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,139,124,36,192                   // mov           -0x40(%rsp),%rdi
  .byte  72,139,84,36,200                    // mov           -0x38(%rsp),%rdx
  .byte  72,139,76,36,208                    // mov           -0x30(%rsp),%rcx
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  15,40,116,36,216                    // movaps        -0x28(%rsp),%xmm6
  .byte  15,40,124,36,232                    // movaps        -0x18(%rsp),%xmm7
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_gradient_sse41_lowp
.globl _sk_evenly_spaced_gradient_sse41_lowp
FUNCTION(_sk_evenly_spaced_gradient_sse41_lowp)
_sk_evenly_spaced_gradient_sse41_lowp:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  80                                  // push          %rax
  .byte  15,41,124,36,240                    // movaps        %xmm7,-0x10(%rsp)
  .byte  15,41,116,36,224                    // movaps        %xmm6,-0x20(%rsp)
  .byte  15,41,108,36,208                    // movaps        %xmm5,-0x30(%rsp)
  .byte  15,41,100,36,192                    // movaps        %xmm4,-0x40(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,139,24                           // mov           (%rax),%rbx
  .byte  72,139,104,8                        // mov           0x8(%rax),%rbp
  .byte  72,255,203                          // dec           %rbx
  .byte  120,7                               // js            34aaa <_sk_evenly_spaced_gradient_sse41_lowp+0x34>
  .byte  243,72,15,42,211                    // cvtsi2ss      %rbx,%xmm2
  .byte  235,21                              // jmp           34abf <_sk_evenly_spaced_gradient_sse41_lowp+0x49>
  .byte  73,137,216                          // mov           %rbx,%r8
  .byte  73,209,232                          // shr           %r8
  .byte  131,227,1                           // and           $0x1,%ebx
  .byte  76,9,195                            // or            %r8,%rbx
  .byte  243,72,15,42,211                    // cvtsi2ss      %rbx,%xmm2
  .byte  243,15,88,210                       // addss         %xmm2,%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,41,68,36,176                     // movaps        %xmm0,-0x50(%rsp)
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  15,89,218                           // mulps         %xmm2,%xmm3
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  243,15,91,194                       // cvttps2dq     %xmm2,%xmm0
  .byte  102,73,15,58,22,194,1               // pextrq        $0x1,%xmm0,%r10
  .byte  69,137,214                          // mov           %r10d,%r14d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,73,15,126,197                   // movq          %xmm0,%r13
  .byte  69,137,236                          // mov           %r13d,%r12d
  .byte  73,193,237,32                       // shr           $0x20,%r13
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  102,73,15,58,22,192,1               // pextrq        $0x1,%xmm0,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  102,73,15,126,195                   // movq          %xmm0,%r11
  .byte  69,137,223                          // mov           %r11d,%r15d
  .byte  73,193,235,32                       // shr           $0x20,%r11
  .byte  243,70,15,16,68,189,0               // movss         0x0(%rbp,%r15,4),%xmm8
  .byte  102,70,15,58,33,68,157,0,16         // insertps      $0x10,0x0(%rbp,%r11,4),%xmm8
  .byte  243,66,15,16,68,141,0               // movss         0x0(%rbp,%r9,4),%xmm0
  .byte  243,66,15,16,84,133,0               // movss         0x0(%rbp,%r8,4),%xmm2
  .byte  15,41,76,36,160                     // movaps        %xmm1,-0x60(%rsp)
  .byte  243,66,15,16,92,165,0               // movss         0x0(%rbp,%r12,4),%xmm3
  .byte  102,66,15,58,33,92,173,0,16         // insertps      $0x10,0x0(%rbp,%r13,4),%xmm3
  .byte  243,66,15,16,100,181,0              // movss         0x0(%rbp,%r14,4),%xmm4
  .byte  243,66,15,16,108,149,0              // movss         0x0(%rbp,%r10,4),%xmm5
  .byte  102,68,15,58,33,192,32              // insertps      $0x20,%xmm0,%xmm8
  .byte  102,68,15,58,33,194,48              // insertps      $0x30,%xmm2,%xmm8
  .byte  72,139,88,16                        // mov           0x10(%rax),%rbx
  .byte  243,70,15,16,12,187                 // movss         (%rbx,%r15,4),%xmm9
  .byte  102,70,15,58,33,12,155,16           // insertps      $0x10,(%rbx,%r11,4),%xmm9
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  243,66,15,16,20,163                 // movss         (%rbx,%r12,4),%xmm2
  .byte  102,66,15,58,33,20,171,16           // insertps      $0x10,(%rbx,%r13,4),%xmm2
  .byte  243,66,15,16,52,179                 // movss         (%rbx,%r14,4),%xmm6
  .byte  243,66,15,16,60,147                 // movss         (%rbx,%r10,4),%xmm7
  .byte  102,15,58,33,220,32                 // insertps      $0x20,%xmm4,%xmm3
  .byte  102,15,58,33,221,48                 // insertps      $0x30,%xmm5,%xmm3
  .byte  102,68,15,58,33,200,32              // insertps      $0x20,%xmm0,%xmm9
  .byte  102,68,15,58,33,201,48              // insertps      $0x30,%xmm1,%xmm9
  .byte  102,15,58,33,214,32                 // insertps      $0x20,%xmm6,%xmm2
  .byte  102,15,58,33,215,48                 // insertps      $0x30,%xmm7,%xmm2
  .byte  72,139,88,24                        // mov           0x18(%rax),%rbx
  .byte  243,70,15,16,28,187                 // movss         (%rbx,%r15,4),%xmm11
  .byte  102,70,15,58,33,28,155,16           // insertps      $0x10,(%rbx,%r11,4),%xmm11
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  243,70,15,16,44,163                 // movss         (%rbx,%r12,4),%xmm13
  .byte  102,70,15,58,33,44,171,16           // insertps      $0x10,(%rbx,%r13,4),%xmm13
  .byte  243,66,15,16,36,179                 // movss         (%rbx,%r14,4),%xmm4
  .byte  243,66,15,16,44,147                 // movss         (%rbx,%r10,4),%xmm5
  .byte  102,68,15,58,33,216,32              // insertps      $0x20,%xmm0,%xmm11
  .byte  102,68,15,58,33,217,48              // insertps      $0x30,%xmm1,%xmm11
  .byte  102,68,15,58,33,236,32              // insertps      $0x20,%xmm4,%xmm13
  .byte  102,68,15,58,33,237,48              // insertps      $0x30,%xmm5,%xmm13
  .byte  72,139,88,32                        // mov           0x20(%rax),%rbx
  .byte  243,70,15,16,20,187                 // movss         (%rbx,%r15,4),%xmm10
  .byte  102,70,15,58,33,20,155,16           // insertps      $0x10,(%rbx,%r11,4),%xmm10
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  102,68,15,58,33,208,32              // insertps      $0x20,%xmm0,%xmm10
  .byte  243,66,15,16,4,131                  // movss         (%rbx,%r8,4),%xmm0
  .byte  102,68,15,58,33,208,48              // insertps      $0x30,%xmm0,%xmm10
  .byte  243,70,15,16,36,163                 // movss         (%rbx,%r12,4),%xmm12
  .byte  102,70,15,58,33,36,171,16           // insertps      $0x10,(%rbx,%r13,4),%xmm12
  .byte  243,66,15,16,4,179                  // movss         (%rbx,%r14,4),%xmm0
  .byte  243,66,15,16,12,147                 // movss         (%rbx,%r10,4),%xmm1
  .byte  102,68,15,58,33,224,32              // insertps      $0x20,%xmm0,%xmm12
  .byte  102,68,15,58,33,225,48              // insertps      $0x30,%xmm1,%xmm12
  .byte  72,139,88,40                        // mov           0x28(%rax),%rbx
  .byte  243,66,15,16,36,163                 // movss         (%rbx,%r12,4),%xmm4
  .byte  102,66,15,58,33,36,171,16           // insertps      $0x10,(%rbx,%r13,4),%xmm4
  .byte  243,66,15,16,4,179                  // movss         (%rbx,%r14,4),%xmm0
  .byte  102,15,58,33,224,32                 // insertps      $0x20,%xmm0,%xmm4
  .byte  243,66,15,16,4,147                  // movss         (%rbx,%r10,4),%xmm0
  .byte  102,15,58,33,224,48                 // insertps      $0x30,%xmm0,%xmm4
  .byte  243,66,15,16,4,187                  // movss         (%rbx,%r15,4),%xmm0
  .byte  102,66,15,58,33,4,155,16            // insertps      $0x10,(%rbx,%r11,4),%xmm0
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  102,15,58,33,193,32                 // insertps      $0x20,%xmm1,%xmm0
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  102,15,58,33,193,48                 // insertps      $0x30,%xmm1,%xmm0
  .byte  72,139,88,48                        // mov           0x30(%rax),%rbx
  .byte  243,66,15,16,60,163                 // movss         (%rbx,%r12,4),%xmm7
  .byte  102,66,15,58,33,60,171,16           // insertps      $0x10,(%rbx,%r13,4),%xmm7
  .byte  243,66,15,16,12,179                 // movss         (%rbx,%r14,4),%xmm1
  .byte  102,15,58,33,249,32                 // insertps      $0x20,%xmm1,%xmm7
  .byte  243,66,15,16,12,147                 // movss         (%rbx,%r10,4),%xmm1
  .byte  102,15,58,33,249,48                 // insertps      $0x30,%xmm1,%xmm7
  .byte  243,66,15,16,12,187                 // movss         (%rbx,%r15,4),%xmm1
  .byte  102,66,15,58,33,12,155,16           // insertps      $0x10,(%rbx,%r11,4),%xmm1
  .byte  243,66,15,16,44,139                 // movss         (%rbx,%r9,4),%xmm5
  .byte  102,15,58,33,205,32                 // insertps      $0x20,%xmm5,%xmm1
  .byte  243,66,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm5
  .byte  102,15,58,33,205,48                 // insertps      $0x30,%xmm5,%xmm1
  .byte  72,139,88,56                        // mov           0x38(%rax),%rbx
  .byte  243,66,15,16,52,163                 // movss         (%rbx,%r12,4),%xmm6
  .byte  102,66,15,58,33,52,171,16           // insertps      $0x10,(%rbx,%r13,4),%xmm6
  .byte  243,66,15,16,44,179                 // movss         (%rbx,%r14,4),%xmm5
  .byte  102,15,58,33,245,32                 // insertps      $0x20,%xmm5,%xmm6
  .byte  243,66,15,16,44,147                 // movss         (%rbx,%r10,4),%xmm5
  .byte  102,15,58,33,245,48                 // insertps      $0x30,%xmm5,%xmm6
  .byte  15,41,116,36,128                    // movaps        %xmm6,-0x80(%rsp)
  .byte  243,66,15,16,44,187                 // movss         (%rbx,%r15,4),%xmm5
  .byte  102,66,15,58,33,44,155,16           // insertps      $0x10,(%rbx,%r11,4),%xmm5
  .byte  243,66,15,16,52,139                 // movss         (%rbx,%r9,4),%xmm6
  .byte  102,15,58,33,238,32                 // insertps      $0x20,%xmm6,%xmm5
  .byte  243,66,15,16,52,131                 // movss         (%rbx,%r8,4),%xmm6
  .byte  102,15,58,33,238,48                 // insertps      $0x30,%xmm6,%xmm5
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  243,70,15,16,52,160                 // movss         (%rax,%r12,4),%xmm14
  .byte  102,70,15,58,33,52,168,16           // insertps      $0x10,(%rax,%r13,4),%xmm14
  .byte  243,66,15,16,52,176                 // movss         (%rax,%r14,4),%xmm6
  .byte  102,68,15,58,33,246,32              // insertps      $0x20,%xmm6,%xmm14
  .byte  243,66,15,16,52,144                 // movss         (%rax,%r10,4),%xmm6
  .byte  102,68,15,58,33,246,48              // insertps      $0x30,%xmm6,%xmm14
  .byte  68,15,41,116,36,144                 // movaps        %xmm14,-0x70(%rsp)
  .byte  243,70,15,16,60,184                 // movss         (%rax,%r15,4),%xmm15
  .byte  102,70,15,58,33,60,152,16           // insertps      $0x10,(%rax,%r11,4),%xmm15
  .byte  243,70,15,16,52,136                 // movss         (%rax,%r9,4),%xmm14
  .byte  102,69,15,58,33,254,32              // insertps      $0x20,%xmm14,%xmm15
  .byte  243,66,15,16,52,128                 // movss         (%rax,%r8,4),%xmm6
  .byte  102,68,15,58,33,254,48              // insertps      $0x30,%xmm6,%xmm15
  .byte  15,40,116,36,160                    // movaps        -0x60(%rsp),%xmm6
  .byte  15,89,222                           // mulps         %xmm6,%xmm3
  .byte  15,88,220                           // addps         %xmm4,%xmm3
  .byte  15,40,100,36,176                    // movaps        -0x50(%rsp),%xmm4
  .byte  68,15,89,196                        // mulps         %xmm4,%xmm8
  .byte  68,15,88,192                        // addps         %xmm0,%xmm8
  .byte  15,40,5,96,94,0,0                   // movaps        0x5e60(%rip),%xmm0        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  68,15,40,53,97,93,0,0               // movaps        0x5d61(%rip),%xmm14        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  69,15,88,198                        // addps         %xmm14,%xmm8
  .byte  65,15,88,222                        // addps         %xmm14,%xmm3
  .byte  243,15,91,219                       // cvttps2dq     %xmm3,%xmm3
  .byte  102,15,111,5,125,100,0,0            // movdqa        0x647d(%rip),%xmm0        # 3b270 <_sk_srcover_bgra_8888_sse2_lowp+0x1308>
  .byte  102,15,56,0,216                     // pshufb        %xmm0,%xmm3
  .byte  243,69,15,91,192                    // cvttps2dq     %xmm8,%xmm8
  .byte  102,68,15,56,0,192                  // pshufb        %xmm0,%xmm8
  .byte  102,68,15,108,195                   // punpcklqdq    %xmm3,%xmm8
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  68,15,89,203                        // mulps         %xmm3,%xmm9
  .byte  68,15,88,201                        // addps         %xmm1,%xmm9
  .byte  15,40,13,16,94,0,0                  // movaps        0x5e10(%rip),%xmm1        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  69,15,88,206                        // addps         %xmm14,%xmm9
  .byte  65,15,88,214                        // addps         %xmm14,%xmm2
  .byte  243,15,91,202                       // cvttps2dq     %xmm2,%xmm1
  .byte  102,15,56,0,200                     // pshufb        %xmm0,%xmm1
  .byte  243,69,15,91,201                    // cvttps2dq     %xmm9,%xmm9
  .byte  102,68,15,56,0,200                  // pshufb        %xmm0,%xmm9
  .byte  102,68,15,108,201                   // punpcklqdq    %xmm1,%xmm9
  .byte  68,15,89,238                        // mulps         %xmm6,%xmm13
  .byte  68,15,88,108,36,128                 // addps         -0x80(%rsp),%xmm13
  .byte  68,15,89,219                        // mulps         %xmm3,%xmm11
  .byte  68,15,88,221                        // addps         %xmm5,%xmm11
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  68,15,89,233                        // mulps         %xmm1,%xmm13
  .byte  68,15,89,217                        // mulps         %xmm1,%xmm11
  .byte  69,15,88,222                        // addps         %xmm14,%xmm11
  .byte  69,15,88,238                        // addps         %xmm14,%xmm13
  .byte  243,65,15,91,205                    // cvttps2dq     %xmm13,%xmm1
  .byte  102,15,56,0,200                     // pshufb        %xmm0,%xmm1
  .byte  243,65,15,91,211                    // cvttps2dq     %xmm11,%xmm2
  .byte  102,15,56,0,208                     // pshufb        %xmm0,%xmm2
  .byte  102,15,108,209                      // punpcklqdq    %xmm1,%xmm2
  .byte  68,15,89,230                        // mulps         %xmm6,%xmm12
  .byte  68,15,88,100,36,144                 // addps         -0x70(%rsp),%xmm12
  .byte  68,15,89,211                        // mulps         %xmm3,%xmm10
  .byte  69,15,88,215                        // addps         %xmm15,%xmm10
  .byte  68,15,89,228                        // mulps         %xmm4,%xmm12
  .byte  68,15,89,212                        // mulps         %xmm4,%xmm10
  .byte  69,15,88,214                        // addps         %xmm14,%xmm10
  .byte  69,15,88,230                        // addps         %xmm14,%xmm12
  .byte  243,65,15,91,204                    // cvttps2dq     %xmm12,%xmm1
  .byte  102,15,56,0,200                     // pshufb        %xmm0,%xmm1
  .byte  243,65,15,91,218                    // cvttps2dq     %xmm10,%xmm3
  .byte  102,15,56,0,216                     // pshufb        %xmm0,%xmm3
  .byte  102,15,108,217                      // punpcklqdq    %xmm1,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  15,40,100,36,192                    // movaps        -0x40(%rsp),%xmm4
  .byte  15,40,108,36,208                    // movaps        -0x30(%rsp),%xmm5
  .byte  15,40,116,36,224                    // movaps        -0x20(%rsp),%xmm6
  .byte  15,40,124,36,240                    // movaps        -0x10(%rsp),%xmm7
  .byte  72,131,196,8                        // add           $0x8,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_2_stop_gradient_sse41_lowp
.globl _sk_evenly_spaced_2_stop_gradient_sse41_lowp
FUNCTION(_sk_evenly_spaced_2_stop_gradient_sse41_lowp)
_sk_evenly_spaced_2_stop_gradient_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,24                        // movss         (%rax),%xmm3
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  243,68,15,16,64,16                  // movss         0x10(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  65,15,88,216                        // addps         %xmm8,%xmm3
  .byte  65,15,88,208                        // addps         %xmm8,%xmm2
  .byte  68,15,40,21,10,93,0,0               // movaps        0x5d0a(%rip),%xmm10        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  65,15,89,210                        // mulps         %xmm10,%xmm2
  .byte  65,15,89,218                        // mulps         %xmm10,%xmm3
  .byte  68,15,40,37,10,92,0,0               // movaps        0x5c0a(%rip),%xmm12        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  65,15,88,220                        // addps         %xmm12,%xmm3
  .byte  65,15,88,212                        // addps         %xmm12,%xmm2
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  102,68,15,111,29,37,99,0,0          // movdqa        0x6325(%rip),%xmm11        # 3b270 <_sk_srcover_bgra_8888_sse2_lowp+0x1308>
  .byte  102,65,15,56,0,211                  // pshufb        %xmm11,%xmm2
  .byte  243,68,15,91,195                    // cvttps2dq     %xmm3,%xmm8
  .byte  102,69,15,56,0,195                  // pshufb        %xmm11,%xmm8
  .byte  102,68,15,108,194                   // punpcklqdq    %xmm2,%xmm8
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  243,15,16,80,20                     // movss         0x14(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  65,15,89,217                        // mulps         %xmm9,%xmm3
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  68,15,88,202                        // addps         %xmm2,%xmm9
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  65,15,89,218                        // mulps         %xmm10,%xmm3
  .byte  69,15,89,202                        // mulps         %xmm10,%xmm9
  .byte  69,15,88,204                        // addps         %xmm12,%xmm9
  .byte  65,15,88,220                        // addps         %xmm12,%xmm3
  .byte  243,15,91,211                       // cvttps2dq     %xmm3,%xmm2
  .byte  102,65,15,56,0,211                  // pshufb        %xmm11,%xmm2
  .byte  243,69,15,91,201                    // cvttps2dq     %xmm9,%xmm9
  .byte  102,69,15,56,0,203                  // pshufb        %xmm11,%xmm9
  .byte  102,68,15,108,202                   // punpcklqdq    %xmm2,%xmm9
  .byte  243,15,16,80,8                      // movss         0x8(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,68,15,16,104,24                 // movss         0x18(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  15,89,218                           // mulps         %xmm2,%xmm3
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  65,15,88,213                        // addps         %xmm13,%xmm2
  .byte  65,15,88,221                        // addps         %xmm13,%xmm3
  .byte  65,15,89,218                        // mulps         %xmm10,%xmm3
  .byte  65,15,89,210                        // mulps         %xmm10,%xmm2
  .byte  65,15,88,212                        // addps         %xmm12,%xmm2
  .byte  65,15,88,220                        // addps         %xmm12,%xmm3
  .byte  243,15,91,219                       // cvttps2dq     %xmm3,%xmm3
  .byte  102,65,15,56,0,219                  // pshufb        %xmm11,%xmm3
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  102,65,15,56,0,211                  // pshufb        %xmm11,%xmm2
  .byte  102,15,108,211                      // punpcklqdq    %xmm3,%xmm2
  .byte  243,15,16,88,12                     // movss         0xc(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  243,68,15,16,104,28                 // movss         0x1c(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  65,15,88,221                        // addps         %xmm13,%xmm3
  .byte  65,15,88,205                        // addps         %xmm13,%xmm1
  .byte  65,15,89,202                        // mulps         %xmm10,%xmm1
  .byte  65,15,89,218                        // mulps         %xmm10,%xmm3
  .byte  65,15,88,220                        // addps         %xmm12,%xmm3
  .byte  65,15,88,204                        // addps         %xmm12,%xmm1
  .byte  243,15,91,193                       // cvttps2dq     %xmm1,%xmm0
  .byte  102,65,15,56,0,195                  // pshufb        %xmm11,%xmm0
  .byte  243,15,91,219                       // cvttps2dq     %xmm3,%xmm3
  .byte  102,65,15,56,0,219                  // pshufb        %xmm11,%xmm3
  .byte  102,15,108,216                      // punpcklqdq    %xmm0,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_unit_angle_sse41_lowp
.globl _sk_xy_to_unit_angle_sse41_lowp
FUNCTION(_sk_xy_to_unit_angle_sse41_lowp)
_sk_xy_to_unit_angle_sse41_lowp:
  .byte  15,41,124,36,232                    // movaps        %xmm7,-0x18(%rsp)
  .byte  15,41,116,36,216                    // movaps        %xmm6,-0x28(%rsp)
  .byte  15,41,108,36,200                    // movaps        %xmm5,-0x38(%rsp)
  .byte  15,41,100,36,184                    // movaps        %xmm4,-0x48(%rsp)
  .byte  15,40,251                           // movaps        %xmm3,%xmm7
  .byte  15,40,242                           // movaps        %xmm2,%xmm6
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  15,40,37,251,95,0,0                 // movaps        0x5ffb(%rip),%xmm4        # 3b070 <_sk_srcover_bgra_8888_sse2_lowp+0x1108>
  .byte  68,15,40,233                        // movaps        %xmm1,%xmm13
  .byte  68,15,84,236                        // andps         %xmm4,%xmm13
  .byte  69,15,40,216                        // movaps        %xmm8,%xmm11
  .byte  68,15,84,220                        // andps         %xmm4,%xmm11
  .byte  68,15,40,231                        // movaps        %xmm7,%xmm12
  .byte  68,15,84,228                        // andps         %xmm4,%xmm12
  .byte  15,84,230                           // andps         %xmm6,%xmm4
  .byte  69,15,40,211                        // movaps        %xmm11,%xmm10
  .byte  68,15,194,212,1                     // cmpltps       %xmm4,%xmm10
  .byte  69,15,40,205                        // movaps        %xmm13,%xmm9
  .byte  69,15,194,204,1                     // cmpltps       %xmm12,%xmm9
  .byte  69,15,40,244                        // movaps        %xmm12,%xmm14
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,69,15,56,20,245                 // blendvps      %xmm0,%xmm13,%xmm14
  .byte  68,15,40,252                        // movaps        %xmm4,%xmm15
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  102,69,15,56,20,251                 // blendvps      %xmm0,%xmm11,%xmm15
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,69,15,56,20,236                 // blendvps      %xmm0,%xmm12,%xmm13
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  102,68,15,56,20,220                 // blendvps      %xmm0,%xmm4,%xmm11
  .byte  69,15,94,251                        // divps         %xmm11,%xmm15
  .byte  65,15,40,199                        // movaps        %xmm15,%xmm0
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  68,15,40,29,251,95,0,0              // movaps        0x5ffb(%rip),%xmm11        # 3b0e0 <_sk_srcover_bgra_8888_sse2_lowp+0x1178>
  .byte  68,15,40,224                        // movaps        %xmm0,%xmm12
  .byte  69,15,89,227                        // mulps         %xmm11,%xmm12
  .byte  68,15,88,37,251,95,0,0              // addps         0x5ffb(%rip),%xmm12        # 3b0f0 <_sk_srcover_bgra_8888_sse2_lowp+0x1188>
  .byte  68,15,89,224                        // mulps         %xmm0,%xmm12
  .byte  15,40,45,0,96,0,0                   // movaps        0x6000(%rip),%xmm5        # 3b100 <_sk_srcover_bgra_8888_sse2_lowp+0x1198>
  .byte  68,15,88,229                        // addps         %xmm5,%xmm12
  .byte  68,15,89,224                        // mulps         %xmm0,%xmm12
  .byte  15,40,37,1,96,0,0                   // movaps        0x6001(%rip),%xmm4        # 3b110 <_sk_srcover_bgra_8888_sse2_lowp+0x11a8>
  .byte  68,15,88,228                        // addps         %xmm4,%xmm12
  .byte  69,15,89,231                        // mulps         %xmm15,%xmm12
  .byte  15,40,21,2,96,0,0                   // movaps        0x6002(%rip),%xmm2        # 3b120 <_sk_srcover_bgra_8888_sse2_lowp+0x11b8>
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  65,15,92,212                        // subps         %xmm12,%xmm2
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  102,68,15,56,20,226                 // blendvps      %xmm0,%xmm2,%xmm12
  .byte  69,15,94,245                        // divps         %xmm13,%xmm14
  .byte  65,15,40,198                        // movaps        %xmm14,%xmm0
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  68,15,89,216                        // mulps         %xmm0,%xmm11
  .byte  68,15,88,29,170,95,0,0              // addps         0x5faa(%rip),%xmm11        # 3b0f0 <_sk_srcover_bgra_8888_sse2_lowp+0x1188>
  .byte  68,15,89,216                        // mulps         %xmm0,%xmm11
  .byte  68,15,88,221                        // addps         %xmm5,%xmm11
  .byte  68,15,89,216                        // mulps         %xmm0,%xmm11
  .byte  68,15,88,220                        // addps         %xmm4,%xmm11
  .byte  69,15,89,222                        // mulps         %xmm14,%xmm11
  .byte  65,15,92,219                        // subps         %xmm11,%xmm3
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  102,68,15,56,20,219                 // blendvps      %xmm0,%xmm3,%xmm11
  .byte  69,15,87,201                        // xorps         %xmm9,%xmm9
  .byte  69,15,194,193,1                     // cmpltps       %xmm9,%xmm8
  .byte  15,40,21,200,89,0,0                 // movaps        0x59c8(%rip),%xmm2        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  65,15,92,212                        // subps         %xmm12,%xmm2
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  102,68,15,56,20,226                 // blendvps      %xmm0,%xmm2,%xmm12
  .byte  65,15,194,201,1                     // cmpltps       %xmm9,%xmm1
  .byte  65,15,92,219                        // subps         %xmm11,%xmm3
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  102,68,15,56,20,219                 // blendvps      %xmm0,%xmm3,%xmm11
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  65,15,194,193,1                     // cmpltps       %xmm9,%xmm0
  .byte  15,40,13,166,89,0,0                 // movaps        0x59a6(%rip),%xmm1        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  65,15,92,204                        // subps         %xmm12,%xmm1
  .byte  102,68,15,56,20,225                 // blendvps      %xmm0,%xmm1,%xmm12
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  65,15,194,193,1                     // cmpltps       %xmm9,%xmm0
  .byte  65,15,92,211                        // subps         %xmm11,%xmm2
  .byte  102,68,15,56,20,218                 // blendvps      %xmm0,%xmm2,%xmm11
  .byte  65,15,40,203                        // movaps        %xmm11,%xmm1
  .byte  65,15,194,201,7                     // cmpordps      %xmm9,%xmm1
  .byte  69,15,194,204,7                     // cmpordps      %xmm12,%xmm9
  .byte  69,15,84,204                        // andps         %xmm12,%xmm9
  .byte  65,15,84,203                        // andps         %xmm11,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,40,223                           // movaps        %xmm7,%xmm3
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  15,40,100,36,184                    // movaps        -0x48(%rsp),%xmm4
  .byte  15,40,108,36,200                    // movaps        -0x38(%rsp),%xmm5
  .byte  15,40,116,36,216                    // movaps        -0x28(%rsp),%xmm6
  .byte  15,40,124,36,232                    // movaps        -0x18(%rsp),%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_radius_sse41_lowp
.globl _sk_xy_to_radius_sse41_lowp
FUNCTION(_sk_xy_to_radius_sse41_lowp)
_sk_xy_to_radius_sse41_lowp:
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  15,89,201                           // mulps         %xmm1,%xmm1
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  68,15,88,192                        // addps         %xmm0,%xmm8
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  69,15,89,201                        // mulps         %xmm9,%xmm9
  .byte  68,15,88,201                        // addps         %xmm1,%xmm9
  .byte  65,15,81,192                        // sqrtps        %xmm8,%xmm0
  .byte  65,15,81,201                        // sqrtps        %xmm9,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_rgba_8888_sse41_lowp
.globl _sk_srcover_rgba_8888_sse41_lowp
FUNCTION(_sk_srcover_rgba_8888_sse41_lowp)
_sk_srcover_rgba_8888_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  65,137,250                          // mov           %edi,%r10d
  .byte  65,128,226,7                        // and           $0x7,%r10b
  .byte  65,254,202                          // dec           %r10b
  .byte  69,15,182,202                       // movzbl        %r10b,%r9d
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,38                              // ja            35276 <_sk_srcover_rgba_8888_sse41_lowp+0x4b>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  76,141,29,20,2,0,0                  // lea           0x214(%rip),%r11        # 35470 <_sk_srcover_rgba_8888_sse41_lowp+0x245>
  .byte  75,99,4,139                         // movslq        (%r11,%r9,4),%rax
  .byte  76,1,216                            // add           %r11,%rax
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  255,224                             // jmpq          *%rax
  .byte  102,65,15,110,52,144                // movd          (%r8,%rdx,4),%xmm6
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  235,89                              // jmp           352cf <_sk_srcover_rgba_8888_sse41_lowp+0xa4>
  .byte  243,65,15,111,52,144                // movdqu        (%r8,%rdx,4),%xmm6
  .byte  243,69,15,111,68,144,16             // movdqu        0x10(%r8,%rdx,4),%xmm8
  .byte  235,74                              // jmp           352cf <_sk_srcover_rgba_8888_sse41_lowp+0xa4>
  .byte  102,65,15,110,100,144,8             // movd          0x8(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  243,65,15,126,52,144                // movq          (%r8,%rdx,4),%xmm6
  .byte  102,65,15,58,14,240,240             // pblendw       $0xf0,%xmm8,%xmm6
  .byte  102,68,15,111,196                   // movdqa        %xmm4,%xmm8
  .byte  235,37                              // jmp           352cf <_sk_srcover_rgba_8888_sse41_lowp+0xa4>
  .byte  102,65,15,110,100,144,24            // movd          0x18(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  102,69,15,58,34,68,144,20,1         // pinsrd        $0x1,0x14(%r8,%rdx,4),%xmm8
  .byte  102,69,15,58,34,68,144,16,0         // pinsrd        $0x0,0x10(%r8,%rdx,4),%xmm8
  .byte  243,65,15,111,52,144                // movdqu        (%r8,%rdx,4),%xmm6
  .byte  102,15,111,37,153,95,0,0            // movdqa        0x5f99(%rip),%xmm4        # 3b270 <_sk_srcover_bgra_8888_sse2_lowp+0x1308>
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,15,56,0,236                     // pshufb        %xmm4,%xmm5
  .byte  102,65,15,111,248                   // movdqa        %xmm8,%xmm7
  .byte  102,15,56,0,252                     // pshufb        %xmm4,%xmm7
  .byte  102,15,108,239                      // punpcklqdq    %xmm7,%xmm5
  .byte  102,68,15,111,37,249,87,0,0         // movdqa        0x57f9(%rip),%xmm12        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,65,15,219,228                   // pand          %xmm12,%xmm4
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,68,15,111,13,114,95,0,0         // movdqa        0x5f72(%rip),%xmm9        # 3b280 <_sk_srcover_bgra_8888_sse2_lowp+0x1318>
  .byte  102,15,111,254                      // movdqa        %xmm6,%xmm7
  .byte  102,65,15,56,0,249                  // pshufb        %xmm9,%xmm7
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,69,15,56,0,209                  // pshufb        %xmm9,%xmm10
  .byte  102,65,15,108,250                   // punpcklqdq    %xmm10,%xmm7
  .byte  102,68,15,111,13,95,95,0,0          // movdqa        0x5f5f(%rip),%xmm9        # 3b290 <_sk_srcover_bgra_8888_sse2_lowp+0x1328>
  .byte  102,65,15,56,0,241                  // pshufb        %xmm9,%xmm6
  .byte  102,69,15,56,0,193                  // pshufb        %xmm9,%xmm8
  .byte  102,65,15,108,240                   // punpcklqdq    %xmm8,%xmm6
  .byte  102,65,15,219,244                   // pand          %xmm12,%xmm6
  .byte  102,69,15,111,196                   // movdqa        %xmm12,%xmm8
  .byte  102,68,15,249,195                   // psubw         %xmm3,%xmm8
  .byte  102,68,15,111,204                   // movdqa        %xmm4,%xmm9
  .byte  102,69,15,213,200                   // pmullw        %xmm8,%xmm9
  .byte  102,69,15,253,204                   // paddw         %xmm12,%xmm9
  .byte  102,65,15,113,209,8                 // psrlw         $0x8,%xmm9
  .byte  102,68,15,253,200                   // paddw         %xmm0,%xmm9
  .byte  102,68,15,111,213                   // movdqa        %xmm5,%xmm10
  .byte  102,69,15,213,208                   // pmullw        %xmm8,%xmm10
  .byte  102,69,15,253,212                   // paddw         %xmm12,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,68,15,253,209                   // paddw         %xmm1,%xmm10
  .byte  102,68,15,111,222                   // movdqa        %xmm6,%xmm11
  .byte  102,69,15,213,216                   // pmullw        %xmm8,%xmm11
  .byte  102,69,15,253,220                   // paddw         %xmm12,%xmm11
  .byte  102,65,15,113,211,8                 // psrlw         $0x8,%xmm11
  .byte  102,68,15,253,218                   // paddw         %xmm2,%xmm11
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,69,15,253,196                   // paddw         %xmm12,%xmm8
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  102,68,15,253,195                   // paddw         %xmm3,%xmm8
  .byte  102,65,15,111,194                   // movdqa        %xmm10,%xmm0
  .byte  102,15,113,240,8                    // psllw         $0x8,%xmm0
  .byte  102,65,15,235,193                   // por           %xmm9,%xmm0
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,15,56,51,209                    // pmovzxwd      %xmm1,%xmm2
  .byte  102,68,15,56,51,224                 // pmovzxwd      %xmm0,%xmm12
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,113,243,8                    // psllw         $0x8,%xmm3
  .byte  102,65,15,235,219                   // por           %xmm11,%xmm3
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,15,105,203                      // punpckhwd     %xmm3,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  102,15,97,195                       // punpcklwd     %xmm3,%xmm0
  .byte  102,65,15,235,196                   // por           %xmm12,%xmm0
  .byte  65,128,250,6                        // cmp           $0x6,%r10b
  .byte  119,24                              // ja            35419 <_sk_srcover_rgba_8888_sse41_lowp+0x1ee>
  .byte  76,141,21,132,0,0,0                 // lea           0x84(%rip),%r10        # 3548c <_sk_srcover_rgba_8888_sse41_lowp+0x261>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,65,15,126,4,144                 // movd          %xmm0,(%r8,%rdx,4)
  .byte  235,63                              // jmp           35458 <_sk_srcover_rgba_8888_sse41_lowp+0x22d>
  .byte  243,65,15,127,4,144                 // movdqu        %xmm0,(%r8,%rdx,4)
  .byte  243,65,15,127,76,144,16             // movdqu        %xmm1,0x10(%r8,%rdx,4)
  .byte  235,48                              // jmp           35458 <_sk_srcover_rgba_8888_sse41_lowp+0x22d>
  .byte  102,65,15,58,22,68,144,8,2          // pextrd        $0x2,%xmm0,0x8(%r8,%rdx,4)
  .byte  102,65,15,214,4,144                 // movq          %xmm0,(%r8,%rdx,4)
  .byte  235,31                              // jmp           35458 <_sk_srcover_rgba_8888_sse41_lowp+0x22d>
  .byte  102,65,15,58,22,76,144,24,2         // pextrd        $0x2,%xmm1,0x18(%r8,%rdx,4)
  .byte  102,65,15,58,22,76,144,20,1         // pextrd        $0x1,%xmm1,0x14(%r8,%rdx,4)
  .byte  102,65,15,126,76,144,16             // movd          %xmm1,0x10(%r8,%rdx,4)
  .byte  243,65,15,127,4,144                 // movdqu        %xmm0,(%r8,%rdx,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,65,15,111,202                   // movdqa        %xmm10,%xmm1
  .byte  102,65,15,111,211                   // movdqa        %xmm11,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  249                                 // stc
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,38                              // jmpq          *(%rsi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,21,254,255,255,89               // callq         *0x59fffffe(%rip)        # 5a03547b <_sk_srcover_bgra_8888_sse2_lowp+0x59ffb513>
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,80,254                          // callq         *-0x2(%rax)
  .byte  255                                 // (bad)
  .byte  255,71,254                          // incl          -0x2(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  58,254                              // cmp           %dh,%bh
  .byte  255                                 // (bad)
  .byte  255,133,255,255,255,165             // incl          -0x5a000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,156,255,255,255,198,255         // lcall         *-0x390001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  191,255,255,255,182                 // mov           $0xb6ffffff,%edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  173                                 // lods          %ds:(%rsi),%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_srcover_bgra_8888_sse41_lowp
.globl _sk_srcover_bgra_8888_sse41_lowp
FUNCTION(_sk_srcover_bgra_8888_sse41_lowp)
_sk_srcover_bgra_8888_sse41_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  65,137,250                          // mov           %edi,%r10d
  .byte  65,128,226,7                        // and           $0x7,%r10b
  .byte  65,254,202                          // dec           %r10b
  .byte  69,15,182,202                       // movzbl        %r10b,%r9d
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,38                              // ja            354f3 <_sk_srcover_bgra_8888_sse41_lowp+0x4b>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  76,141,29,23,2,0,0                  // lea           0x217(%rip),%r11        # 356f0 <_sk_srcover_bgra_8888_sse41_lowp+0x248>
  .byte  75,99,4,139                         // movslq        (%r11,%r9,4),%rax
  .byte  76,1,216                            // add           %r11,%rax
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  255,224                             // jmpq          *%rax
  .byte  102,65,15,110,36,144                // movd          (%r8,%rdx,4),%xmm4
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  235,89                              // jmp           3554c <_sk_srcover_bgra_8888_sse41_lowp+0xa4>
  .byte  243,65,15,111,36,144                // movdqu        (%r8,%rdx,4),%xmm4
  .byte  243,69,15,111,68,144,16             // movdqu        0x10(%r8,%rdx,4),%xmm8
  .byte  235,74                              // jmp           3554c <_sk_srcover_bgra_8888_sse41_lowp+0xa4>
  .byte  102,65,15,110,100,144,8             // movd          0x8(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  243,65,15,126,36,144                // movq          (%r8,%rdx,4),%xmm4
  .byte  102,65,15,58,14,224,240             // pblendw       $0xf0,%xmm8,%xmm4
  .byte  102,68,15,111,197                   // movdqa        %xmm5,%xmm8
  .byte  235,37                              // jmp           3554c <_sk_srcover_bgra_8888_sse41_lowp+0xa4>
  .byte  102,65,15,110,100,144,24            // movd          0x18(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  102,69,15,58,34,68,144,20,1         // pinsrd        $0x1,0x14(%r8,%rdx,4),%xmm8
  .byte  102,69,15,58,34,68,144,16,0         // pinsrd        $0x0,0x10(%r8,%rdx,4),%xmm8
  .byte  243,65,15,111,36,144                // movdqu        (%r8,%rdx,4),%xmm4
  .byte  102,15,111,53,28,93,0,0             // movdqa        0x5d1c(%rip),%xmm6        # 3b270 <_sk_srcover_bgra_8888_sse2_lowp+0x1308>
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,56,0,238                     // pshufb        %xmm6,%xmm5
  .byte  102,65,15,111,248                   // movdqa        %xmm8,%xmm7
  .byte  102,15,56,0,254                     // pshufb        %xmm6,%xmm7
  .byte  102,15,108,239                      // punpcklqdq    %xmm7,%xmm5
  .byte  102,68,15,111,37,124,85,0,0         // movdqa        0x557c(%rip),%xmm12        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,245                      // movdqa        %xmm5,%xmm6
  .byte  102,65,15,219,244                   // pand          %xmm12,%xmm6
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,68,15,111,13,245,92,0,0         // movdqa        0x5cf5(%rip),%xmm9        # 3b280 <_sk_srcover_bgra_8888_sse2_lowp+0x1318>
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,65,15,56,0,249                  // pshufb        %xmm9,%xmm7
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,69,15,56,0,209                  // pshufb        %xmm9,%xmm10
  .byte  102,65,15,108,250                   // punpcklqdq    %xmm10,%xmm7
  .byte  102,68,15,111,13,226,92,0,0         // movdqa        0x5ce2(%rip),%xmm9        # 3b290 <_sk_srcover_bgra_8888_sse2_lowp+0x1328>
  .byte  102,65,15,56,0,225                  // pshufb        %xmm9,%xmm4
  .byte  102,69,15,56,0,193                  // pshufb        %xmm9,%xmm8
  .byte  102,65,15,108,224                   // punpcklqdq    %xmm8,%xmm4
  .byte  102,65,15,219,228                   // pand          %xmm12,%xmm4
  .byte  102,69,15,111,196                   // movdqa        %xmm12,%xmm8
  .byte  102,68,15,249,195                   // psubw         %xmm3,%xmm8
  .byte  102,68,15,111,204                   // movdqa        %xmm4,%xmm9
  .byte  102,69,15,213,200                   // pmullw        %xmm8,%xmm9
  .byte  102,69,15,253,204                   // paddw         %xmm12,%xmm9
  .byte  102,65,15,113,209,8                 // psrlw         $0x8,%xmm9
  .byte  102,68,15,253,200                   // paddw         %xmm0,%xmm9
  .byte  102,68,15,111,213                   // movdqa        %xmm5,%xmm10
  .byte  102,69,15,213,208                   // pmullw        %xmm8,%xmm10
  .byte  102,69,15,253,212                   // paddw         %xmm12,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,68,15,253,209                   // paddw         %xmm1,%xmm10
  .byte  102,68,15,111,222                   // movdqa        %xmm6,%xmm11
  .byte  102,69,15,213,216                   // pmullw        %xmm8,%xmm11
  .byte  102,69,15,253,220                   // paddw         %xmm12,%xmm11
  .byte  102,65,15,113,211,8                 // psrlw         $0x8,%xmm11
  .byte  102,68,15,253,218                   // paddw         %xmm2,%xmm11
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,69,15,253,196                   // paddw         %xmm12,%xmm8
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  102,68,15,253,195                   // paddw         %xmm3,%xmm8
  .byte  102,65,15,111,194                   // movdqa        %xmm10,%xmm0
  .byte  102,15,113,240,8                    // psllw         $0x8,%xmm0
  .byte  102,65,15,235,195                   // por           %xmm11,%xmm0
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,15,56,51,209                    // pmovzxwd      %xmm1,%xmm2
  .byte  102,68,15,56,51,224                 // pmovzxwd      %xmm0,%xmm12
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,113,243,8                    // psllw         $0x8,%xmm3
  .byte  102,65,15,235,217                   // por           %xmm9,%xmm3
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,15,105,203                      // punpckhwd     %xmm3,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  102,15,97,195                       // punpcklwd     %xmm3,%xmm0
  .byte  102,65,15,235,196                   // por           %xmm12,%xmm0
  .byte  65,128,250,6                        // cmp           $0x6,%r10b
  .byte  119,24                              // ja            35696 <_sk_srcover_bgra_8888_sse41_lowp+0x1ee>
  .byte  76,141,21,135,0,0,0                 // lea           0x87(%rip),%r10        # 3570c <_sk_srcover_bgra_8888_sse41_lowp+0x264>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,65,15,126,4,144                 // movd          %xmm0,(%r8,%rdx,4)
  .byte  235,63                              // jmp           356d5 <_sk_srcover_bgra_8888_sse41_lowp+0x22d>
  .byte  243,65,15,127,4,144                 // movdqu        %xmm0,(%r8,%rdx,4)
  .byte  243,65,15,127,76,144,16             // movdqu        %xmm1,0x10(%r8,%rdx,4)
  .byte  235,48                              // jmp           356d5 <_sk_srcover_bgra_8888_sse41_lowp+0x22d>
  .byte  102,65,15,58,22,68,144,8,2          // pextrd        $0x2,%xmm0,0x8(%r8,%rdx,4)
  .byte  102,65,15,214,4,144                 // movq          %xmm0,(%r8,%rdx,4)
  .byte  235,31                              // jmp           356d5 <_sk_srcover_bgra_8888_sse41_lowp+0x22d>
  .byte  102,65,15,58,22,76,144,24,2         // pextrd        $0x2,%xmm1,0x18(%r8,%rdx,4)
  .byte  102,65,15,58,22,76,144,20,1         // pextrd        $0x1,%xmm1,0x14(%r8,%rdx,4)
  .byte  102,65,15,126,76,144,16             // movd          %xmm1,0x10(%r8,%rdx,4)
  .byte  243,65,15,127,4,144                 // movdqu        %xmm0,(%r8,%rdx,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,65,15,111,202                   // movdqa        %xmm10,%xmm1
  .byte  102,65,15,111,211                   // movdqa        %xmm11,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  246,253                             // idiv          %ch
  .byte  255                                 // (bad)
  .byte  255,35                              // jmpq          *(%rbx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,18                              // callq         *(%rdx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,86,254                          // callq         *-0x2(%rsi)
  .byte  255                                 // (bad)
  .byte  255,77,254                          // decl          -0x2(%rbp)
  .byte  255                                 // (bad)
  .byte  255,68,254,255                      // incl          -0x1(%rsi,%rdi,8)
  .byte  255,55                              // pushq         (%rdi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,130,255,255,255,162             // incl          -0x5d000001(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,153,255,255,255,195             // lcall         *-0x3c000001(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  188,255,255,255,179                 // mov           $0xb3ffffff,%esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_start_pipeline_sse2_lowp
.globl _sk_start_pipeline_sse2_lowp
FUNCTION(_sk_start_pipeline_sse2_lowp)
_sk_start_pipeline_sse2_lowp:
  .byte  85                                  // push          %rbp
  .byte  72,137,229                          // mov           %rsp,%rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,131,236,24                       // sub           $0x18,%rsp
  .byte  73,137,215                          // mov           %rdx,%r15
  .byte  72,137,243                          // mov           %rsi,%rbx
  .byte  72,137,125,208                      // mov           %rdi,-0x30(%rbp)
  .byte  76,137,198                          // mov           %r8,%rsi
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  73,137,197                          // mov           %rax,%r13
  .byte  73,137,246                          // mov           %rsi,%r14
  .byte  72,137,77,192                       // mov           %rcx,-0x40(%rbp)
  .byte  72,57,203                           // cmp           %rcx,%rbx
  .byte  15,131,131,0,0,0                    // jae           357de <_sk_start_pipeline_sse2_lowp+0xb6>
  .byte  72,139,69,208                       // mov           -0x30(%rbp),%rax
  .byte  72,141,64,8                         // lea           0x8(%rax),%rax
  .byte  72,137,69,200                       // mov           %rax,-0x38(%rbp)
  .byte  76,57,125,200                       // cmp           %r15,-0x38(%rbp)
  .byte  72,139,85,208                       // mov           -0x30(%rbp),%rdx
  .byte  119,59                              // ja            357ac <_sk_start_pipeline_sse2_lowp+0x84>
  .byte  76,139,101,208                      // mov           -0x30(%rbp),%r12
  .byte  49,255                              // xor           %edi,%edi
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  76,137,226                          // mov           %r12,%rdx
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  73,141,84,36,8                      // lea           0x8(%r12),%rdx
  .byte  73,131,196,16                       // add           $0x10,%r12
  .byte  77,57,252                           // cmp           %r15,%r12
  .byte  73,137,212                          // mov           %rdx,%r12
  .byte  118,201                             // jbe           35775 <_sk_start_pipeline_sse2_lowp+0x4d>
  .byte  76,137,255                          // mov           %r15,%rdi
  .byte  72,41,215                           // sub           %rdx,%rdi
  .byte  116,33                              // je            357d5 <_sk_start_pipeline_sse2_lowp+0xad>
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  76,137,246                          // mov           %r14,%rsi
  .byte  72,137,217                          // mov           %rbx,%rcx
  .byte  65,255,213                          // callq         *%r13
  .byte  72,255,195                          // inc           %rbx
  .byte  72,59,93,192                        // cmp           -0x40(%rbp),%rbx
  .byte  117,137                             // jne           35767 <_sk_start_pipeline_sse2_lowp+0x3f>
  .byte  72,131,196,24                       // add           $0x18,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  195                                 // retq

HIDDEN _sk_just_return_sse2_lowp
.globl _sk_just_return_sse2_lowp
FUNCTION(_sk_just_return_sse2_lowp)
_sk_just_return_sse2_lowp:
  .byte  195                                 // retq

HIDDEN _sk_seed_shader_sse2_lowp
.globl _sk_seed_shader_sse2_lowp
FUNCTION(_sk_seed_shader_sse2_lowp)
_sk_seed_shader_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,110,194                      // movd          %edx,%xmm0
  .byte  102,15,112,192,0                    // pshufd        $0x0,%xmm0,%xmm0
  .byte  15,91,208                           // cvtdq2ps      %xmm0,%xmm2
  .byte  15,16,0                             // movups        (%rax),%xmm0
  .byte  15,16,72,16                         // movups        0x10(%rax),%xmm1
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  102,15,110,209                      // movd          %ecx,%xmm2
  .byte  102,15,112,210,0                    // pshufd        $0x0,%xmm2,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,88,21,36,83,0,0                  // addps         0x5324(%rip),%xmm2        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_translate_sse2_lowp
.globl _sk_matrix_translate_sse2_lowp
FUNCTION(_sk_matrix_translate_sse2_lowp)
_sk_matrix_translate_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  65,15,88,209                        // addps         %xmm9,%xmm2
  .byte  65,15,88,217                        // addps         %xmm9,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_scale_translate_sse2_lowp
.globl _sk_matrix_scale_translate_sse2_lowp
FUNCTION(_sk_matrix_scale_translate_sse2_lowp)
_sk_matrix_scale_translate_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,194                        // addps         %xmm10,%xmm0
  .byte  65,15,88,202                        // addps         %xmm10,%xmm1
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  65,15,89,217                        // mulps         %xmm9,%xmm3
  .byte  65,15,89,209                        // mulps         %xmm9,%xmm2
  .byte  65,15,88,208                        // addps         %xmm8,%xmm2
  .byte  65,15,88,216                        // addps         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_2x3_sse2_lowp
.globl _sk_matrix_2x3_sse2_lowp
FUNCTION(_sk_matrix_2x3_sse2_lowp)
_sk_matrix_2x3_sse2_lowp:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,68,15,16,88,4                   // movss         0x4(%rax),%xmm11
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,68,15,16,80,8                   // movss         0x8(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,72,16                  // movss         0x10(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,40,226                        // movaps        %xmm2,%xmm12
  .byte  69,15,89,226                        // mulps         %xmm10,%xmm12
  .byte  68,15,89,211                        // mulps         %xmm3,%xmm10
  .byte  69,15,88,209                        // addps         %xmm9,%xmm10
  .byte  69,15,88,225                        // addps         %xmm9,%xmm12
  .byte  68,15,40,201                        // movaps        %xmm1,%xmm9
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  65,15,89,192                        // mulps         %xmm8,%xmm0
  .byte  65,15,88,196                        // addps         %xmm12,%xmm0
  .byte  69,15,198,219,0                     // shufps        $0x0,%xmm11,%xmm11
  .byte  243,68,15,16,80,12                  // movss         0xc(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,96,20                  // movss         0x14(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  65,15,89,210                        // mulps         %xmm10,%xmm2
  .byte  68,15,89,211                        // mulps         %xmm3,%xmm10
  .byte  69,15,88,212                        // addps         %xmm12,%xmm10
  .byte  65,15,88,212                        // addps         %xmm12,%xmm2
  .byte  65,15,89,203                        // mulps         %xmm11,%xmm1
  .byte  68,15,88,209                        // addps         %xmm1,%xmm10
  .byte  69,15,89,216                        // mulps         %xmm8,%xmm11
  .byte  65,15,88,211                        // addps         %xmm11,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,201                        // movaps        %xmm9,%xmm1
  .byte  65,15,40,218                        // movaps        %xmm10,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_matrix_perspective_sse2_lowp
.globl _sk_matrix_perspective_sse2_lowp
FUNCTION(_sk_matrix_perspective_sse2_lowp)
_sk_matrix_perspective_sse2_lowp:
  .byte  68,15,40,193                        // movaps        %xmm1,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,8                         // movss         (%rax),%xmm1
  .byte  243,68,15,16,80,4                   // movss         0x4(%rax),%xmm10
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,72,8                   // movss         0x8(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  68,15,40,219                        // movaps        %xmm3,%xmm11
  .byte  69,15,89,218                        // mulps         %xmm10,%xmm11
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  69,15,88,209                        // addps         %xmm9,%xmm10
  .byte  69,15,88,217                        // addps         %xmm9,%xmm11
  .byte  68,15,40,200                        // movaps        %xmm0,%xmm9
  .byte  68,15,89,201                        // mulps         %xmm1,%xmm9
  .byte  69,15,88,202                        // addps         %xmm10,%xmm9
  .byte  65,15,89,200                        // mulps         %xmm8,%xmm1
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  243,68,15,16,96,12                  // movss         0xc(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,80,16                  // movss         0x10(%rax),%xmm10
  .byte  69,15,198,210,0                     // shufps        $0x0,%xmm10,%xmm10
  .byte  243,68,15,16,104,20                 // movss         0x14(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  68,15,40,219                        // movaps        %xmm3,%xmm11
  .byte  69,15,89,218                        // mulps         %xmm10,%xmm11
  .byte  68,15,89,210                        // mulps         %xmm2,%xmm10
  .byte  69,15,88,213                        // addps         %xmm13,%xmm10
  .byte  69,15,88,221                        // addps         %xmm13,%xmm11
  .byte  68,15,40,232                        // movaps        %xmm0,%xmm13
  .byte  69,15,89,236                        // mulps         %xmm12,%xmm13
  .byte  69,15,88,213                        // addps         %xmm13,%xmm10
  .byte  69,15,89,224                        // mulps         %xmm8,%xmm12
  .byte  69,15,88,220                        // addps         %xmm12,%xmm11
  .byte  243,68,15,16,96,24                  // movss         0x18(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  243,68,15,16,104,28                 // movss         0x1c(%rax),%xmm13
  .byte  69,15,198,237,0                     // shufps        $0x0,%xmm13,%xmm13
  .byte  243,68,15,16,112,32                 // movss         0x20(%rax),%xmm14
  .byte  69,15,198,246,0                     // shufps        $0x0,%xmm14,%xmm14
  .byte  65,15,89,221                        // mulps         %xmm13,%xmm3
  .byte  68,15,89,234                        // mulps         %xmm2,%xmm13
  .byte  69,15,88,238                        // addps         %xmm14,%xmm13
  .byte  65,15,88,222                        // addps         %xmm14,%xmm3
  .byte  65,15,89,196                        // mulps         %xmm12,%xmm0
  .byte  65,15,88,197                        // addps         %xmm13,%xmm0
  .byte  69,15,89,224                        // mulps         %xmm8,%xmm12
  .byte  68,15,88,227                        // addps         %xmm3,%xmm12
  .byte  15,83,192                           // rcpps         %xmm0,%xmm0
  .byte  65,15,83,212                        // rcpps         %xmm12,%xmm2
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  68,15,89,208                        // mulps         %xmm0,%xmm10
  .byte  68,15,89,218                        // mulps         %xmm2,%xmm11
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  65,15,40,193                        // movaps        %xmm9,%xmm0
  .byte  65,15,40,210                        // movaps        %xmm10,%xmm2
  .byte  65,15,40,219                        // movaps        %xmm11,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_uniform_color_sse2_lowp
.globl _sk_uniform_color_sse2_lowp
FUNCTION(_sk_uniform_color_sse2_lowp)
_sk_uniform_color_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,110,64,16                    // movd          0x10(%rax),%xmm0
  .byte  242,15,112,192,0                    // pshuflw       $0x0,%xmm0,%xmm0
  .byte  102,15,112,192,80                   // pshufd        $0x50,%xmm0,%xmm0
  .byte  68,15,183,64,18                     // movzwl        0x12(%rax),%r8d
  .byte  102,65,15,110,200                   // movd          %r8d,%xmm1
  .byte  242,15,112,201,0                    // pshuflw       $0x0,%xmm1,%xmm1
  .byte  102,15,112,201,80                   // pshufd        $0x50,%xmm1,%xmm1
  .byte  102,15,110,80,20                    // movd          0x14(%rax),%xmm2
  .byte  242,15,112,210,0                    // pshuflw       $0x0,%xmm2,%xmm2
  .byte  102,15,112,210,80                   // pshufd        $0x50,%xmm2,%xmm2
  .byte  15,183,64,22                        // movzwl        0x16(%rax),%eax
  .byte  102,15,110,216                      // movd          %eax,%xmm3
  .byte  242,15,112,219,0                    // pshuflw       $0x0,%xmm3,%xmm3
  .byte  102,15,112,219,80                   // pshufd        $0x50,%xmm3,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_black_color_sse2_lowp
.globl _sk_black_color_sse2_lowp
FUNCTION(_sk_black_color_sse2_lowp)
_sk_black_color_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,105,80,0,0                 // movaps        0x5069(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_white_color_sse2_lowp
.globl _sk_white_color_sse2_lowp
FUNCTION(_sk_white_color_sse2_lowp)
_sk_white_color_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,5,85,80,0,0                   // movaps        0x5055(%rip),%xmm0        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_set_rgb_sse2_lowp
.globl _sk_set_rgb_sse2_lowp
FUNCTION(_sk_set_rgb_sse2_lowp)
_sk_set_rgb_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,21,148,71,0,0             // movss         0x4794(%rip),%xmm2        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  243,15,16,0                         // movss         (%rax),%xmm0
  .byte  243,15,89,194                       // mulss         %xmm2,%xmm0
  .byte  243,68,15,16,5,83,71,0,0            // movss         0x4753(%rip),%xmm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  243,65,15,88,192                    // addss         %xmm8,%xmm0
  .byte  243,68,15,44,192                    // cvttss2si     %xmm0,%r8d
  .byte  102,65,15,110,192                   // movd          %r8d,%xmm0
  .byte  242,15,112,192,0                    // pshuflw       $0x0,%xmm0,%xmm0
  .byte  102,15,112,192,80                   // pshufd        $0x50,%xmm0,%xmm0
  .byte  243,15,16,72,4                      // movss         0x4(%rax),%xmm1
  .byte  243,15,89,202                       // mulss         %xmm2,%xmm1
  .byte  243,65,15,88,200                    // addss         %xmm8,%xmm1
  .byte  243,68,15,44,193                    // cvttss2si     %xmm1,%r8d
  .byte  102,65,15,110,200                   // movd          %r8d,%xmm1
  .byte  242,15,112,201,0                    // pshuflw       $0x0,%xmm1,%xmm1
  .byte  102,15,112,201,80                   // pshufd        $0x50,%xmm1,%xmm1
  .byte  243,15,89,80,8                      // mulss         0x8(%rax),%xmm2
  .byte  243,65,15,88,208                    // addss         %xmm8,%xmm2
  .byte  243,15,44,194                       // cvttss2si     %xmm2,%eax
  .byte  102,15,110,208                      // movd          %eax,%xmm2
  .byte  242,15,112,210,0                    // pshuflw       $0x0,%xmm2,%xmm2
  .byte  102,15,112,210,80                   // pshufd        $0x50,%xmm2,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_sse2_lowp
.globl _sk_clamp_a_sse2_lowp
FUNCTION(_sk_clamp_a_sse2_lowp)
_sk_clamp_a_sse2_lowp:
  .byte  102,68,15,111,5,59,87,0,0           // movdqa        0x573b(%rip),%xmm8        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,68,15,111,200                   // movdqa        %xmm0,%xmm9
  .byte  102,69,15,239,200                   // pxor          %xmm8,%xmm9
  .byte  102,68,15,111,211                   // movdqa        %xmm3,%xmm10
  .byte  102,69,15,239,208                   // pxor          %xmm8,%xmm10
  .byte  102,69,15,111,218                   // movdqa        %xmm10,%xmm11
  .byte  102,69,15,101,217                   // pcmpgtw       %xmm9,%xmm11
  .byte  102,65,15,219,195                   // pand          %xmm11,%xmm0
  .byte  102,68,15,223,219                   // pandn         %xmm3,%xmm11
  .byte  102,65,15,235,195                   // por           %xmm11,%xmm0
  .byte  102,68,15,111,201                   // movdqa        %xmm1,%xmm9
  .byte  102,69,15,239,200                   // pxor          %xmm8,%xmm9
  .byte  102,69,15,111,218                   // movdqa        %xmm10,%xmm11
  .byte  102,69,15,101,217                   // pcmpgtw       %xmm9,%xmm11
  .byte  102,65,15,219,203                   // pand          %xmm11,%xmm1
  .byte  102,68,15,223,219                   // pandn         %xmm3,%xmm11
  .byte  102,65,15,235,203                   // por           %xmm11,%xmm1
  .byte  102,68,15,239,194                   // pxor          %xmm2,%xmm8
  .byte  102,69,15,101,208                   // pcmpgtw       %xmm8,%xmm10
  .byte  102,65,15,219,210                   // pand          %xmm10,%xmm2
  .byte  102,68,15,223,211                   // pandn         %xmm3,%xmm10
  .byte  102,65,15,235,210                   // por           %xmm10,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clamp_a_dst_sse2_lowp
.globl _sk_clamp_a_dst_sse2_lowp
FUNCTION(_sk_clamp_a_dst_sse2_lowp)
_sk_clamp_a_dst_sse2_lowp:
  .byte  102,68,15,111,5,197,86,0,0          // movdqa        0x56c5(%rip),%xmm8        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,68,15,111,204                   // movdqa        %xmm4,%xmm9
  .byte  102,69,15,239,200                   // pxor          %xmm8,%xmm9
  .byte  102,68,15,111,215                   // movdqa        %xmm7,%xmm10
  .byte  102,69,15,239,208                   // pxor          %xmm8,%xmm10
  .byte  102,69,15,111,218                   // movdqa        %xmm10,%xmm11
  .byte  102,69,15,101,217                   // pcmpgtw       %xmm9,%xmm11
  .byte  102,65,15,219,227                   // pand          %xmm11,%xmm4
  .byte  102,68,15,223,223                   // pandn         %xmm7,%xmm11
  .byte  102,65,15,235,227                   // por           %xmm11,%xmm4
  .byte  102,68,15,111,205                   // movdqa        %xmm5,%xmm9
  .byte  102,69,15,239,200                   // pxor          %xmm8,%xmm9
  .byte  102,69,15,111,218                   // movdqa        %xmm10,%xmm11
  .byte  102,69,15,101,217                   // pcmpgtw       %xmm9,%xmm11
  .byte  102,65,15,219,235                   // pand          %xmm11,%xmm5
  .byte  102,68,15,223,223                   // pandn         %xmm7,%xmm11
  .byte  102,65,15,235,235                   // por           %xmm11,%xmm5
  .byte  102,68,15,239,198                   // pxor          %xmm6,%xmm8
  .byte  102,69,15,101,208                   // pcmpgtw       %xmm8,%xmm10
  .byte  102,65,15,219,242                   // pand          %xmm10,%xmm6
  .byte  102,68,15,223,215                   // pandn         %xmm7,%xmm10
  .byte  102,65,15,235,242                   // por           %xmm10,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_sse2_lowp
.globl _sk_premul_sse2_lowp
FUNCTION(_sk_premul_sse2_lowp)
_sk_premul_sse2_lowp:
  .byte  102,15,213,195                      // pmullw        %xmm3,%xmm0
  .byte  102,68,15,111,5,219,78,0,0          // movdqa        0x4edb(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,213,211                      // pmullw        %xmm3,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_premul_dst_sse2_lowp
.globl _sk_premul_dst_sse2_lowp
FUNCTION(_sk_premul_dst_sse2_lowp)
_sk_premul_dst_sse2_lowp:
  .byte  102,15,213,231                      // pmullw        %xmm7,%xmm4
  .byte  102,68,15,111,5,164,78,0,0          // movdqa        0x4ea4(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,224                   // paddw         %xmm8,%xmm4
  .byte  102,15,113,212,8                    // psrlw         $0x8,%xmm4
  .byte  102,15,213,239                      // pmullw        %xmm7,%xmm5
  .byte  102,65,15,253,232                   // paddw         %xmm8,%xmm5
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,15,213,247                      // pmullw        %xmm7,%xmm6
  .byte  102,65,15,253,240                   // paddw         %xmm8,%xmm6
  .byte  102,15,113,214,8                    // psrlw         $0x8,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_swap_rb_sse2_lowp
.globl _sk_swap_rb_sse2_lowp
FUNCTION(_sk_swap_rb_sse2_lowp)
_sk_swap_rb_sse2_lowp:
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  65,15,40,208                        // movaps        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_src_dst_sse2_lowp
.globl _sk_move_src_dst_sse2_lowp
FUNCTION(_sk_move_src_dst_sse2_lowp)
_sk_move_src_dst_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,40,242                           // movaps        %xmm2,%xmm6
  .byte  15,40,251                           // movaps        %xmm3,%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_move_dst_src_sse2_lowp
.globl _sk_move_dst_src_sse2_lowp
FUNCTION(_sk_move_dst_src_sse2_lowp)
_sk_move_dst_src_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,40,223                           // movaps        %xmm7,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_invert_sse2_lowp
.globl _sk_invert_sse2_lowp
FUNCTION(_sk_invert_sse2_lowp)
_sk_invert_sse2_lowp:
  .byte  102,68,15,111,5,66,78,0,0           // movdqa        0x4e42(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,68,15,249,200                   // psubw         %xmm0,%xmm9
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,249,209                   // psubw         %xmm1,%xmm10
  .byte  102,69,15,111,216                   // movdqa        %xmm8,%xmm11
  .byte  102,68,15,249,218                   // psubw         %xmm2,%xmm11
  .byte  102,68,15,249,195                   // psubw         %xmm3,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,65,15,111,202                   // movdqa        %xmm10,%xmm1
  .byte  102,65,15,111,211                   // movdqa        %xmm11,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_clear_sse2_lowp
.globl _sk_clear_sse2_lowp
FUNCTION(_sk_clear_sse2_lowp)
_sk_clear_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcatop_sse2_lowp
.globl _sk_srcatop_sse2_lowp
FUNCTION(_sk_srcatop_sse2_lowp)
_sk_srcatop_sse2_lowp:
  .byte  102,68,15,111,195                   // movdqa        %xmm3,%xmm8
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,15,111,29,230,77,0,0            // movdqa        0x4de6(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,68,15,111,203                   // movdqa        %xmm3,%xmm9
  .byte  102,69,15,249,200                   // psubw         %xmm8,%xmm9
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,213,196                   // pmullw        %xmm4,%xmm8
  .byte  102,15,253,195                      // paddw         %xmm3,%xmm0
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,213,207                      // pmullw        %xmm7,%xmm1
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,213,197                   // pmullw        %xmm5,%xmm8
  .byte  102,15,253,203                      // paddw         %xmm3,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,68,15,213,206                   // pmullw        %xmm6,%xmm9
  .byte  102,15,253,211                      // paddw         %xmm3,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,68,15,111,199                   // movdqa        %xmm7,%xmm8
  .byte  102,68,15,213,195                   // pmullw        %xmm3,%xmm8
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstatop_sse2_lowp
.globl _sk_dstatop_sse2_lowp
FUNCTION(_sk_dstatop_sse2_lowp)
_sk_dstatop_sse2_lowp:
  .byte  102,68,15,111,196                   // movdqa        %xmm4,%xmm8
  .byte  102,68,15,213,195                   // pmullw        %xmm3,%xmm8
  .byte  102,68,15,111,13,102,77,0,0         // movdqa        0x4d66(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,253,193                   // paddw         %xmm9,%xmm8
  .byte  102,68,15,111,213                   // movdqa        %xmm5,%xmm10
  .byte  102,68,15,213,211                   // pmullw        %xmm3,%xmm10
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,68,15,111,222                   // movdqa        %xmm6,%xmm11
  .byte  102,68,15,213,219                   // pmullw        %xmm3,%xmm11
  .byte  102,69,15,253,217                   // paddw         %xmm9,%xmm11
  .byte  102,65,15,213,217                   // pmullw        %xmm9,%xmm3
  .byte  102,65,15,253,217                   // paddw         %xmm9,%xmm3
  .byte  102,68,15,249,207                   // psubw         %xmm7,%xmm9
  .byte  102,65,15,213,193                   // pmullw        %xmm9,%xmm0
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,65,15,213,201                   // pmullw        %xmm9,%xmm1
  .byte  102,65,15,253,202                   // paddw         %xmm10,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,65,15,213,209                   // pmullw        %xmm9,%xmm2
  .byte  102,65,15,253,211                   // paddw         %xmm11,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcin_sse2_lowp
.globl _sk_srcin_sse2_lowp
FUNCTION(_sk_srcin_sse2_lowp)
_sk_srcin_sse2_lowp:
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,68,15,111,5,241,76,0,0          // movdqa        0x4cf1(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,213,207                      // pmullw        %xmm7,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstin_sse2_lowp
.globl _sk_dstin_sse2_lowp
FUNCTION(_sk_dstin_sse2_lowp)
_sk_dstin_sse2_lowp:
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,15,213,195                      // pmullw        %xmm3,%xmm0
  .byte  102,68,15,111,5,168,76,0,0          // movdqa        0x4ca8(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,111,214                      // movdqa        %xmm6,%xmm2
  .byte  102,15,213,211                      // pmullw        %xmm3,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcout_sse2_lowp
.globl _sk_srcout_sse2_lowp
FUNCTION(_sk_srcout_sse2_lowp)
_sk_srcout_sse2_lowp:
  .byte  102,68,15,111,5,95,76,0,0           // movdqa        0x4c5f(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,68,15,249,207                   // psubw         %xmm7,%xmm9
  .byte  102,65,15,213,193                   // pmullw        %xmm9,%xmm0
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,65,15,213,201                   // pmullw        %xmm9,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,65,15,213,209                   // pmullw        %xmm9,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,65,15,213,217                   // pmullw        %xmm9,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstout_sse2_lowp
.globl _sk_dstout_sse2_lowp
FUNCTION(_sk_dstout_sse2_lowp)
_sk_dstout_sse2_lowp:
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,68,15,111,5,8,76,0,0            // movdqa        0x4c08(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,249,216                      // psubw         %xmm0,%xmm3
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,213,196                      // pmullw        %xmm4,%xmm0
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,213,205                      // pmullw        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_sse2_lowp
.globl _sk_srcover_sse2_lowp
FUNCTION(_sk_srcover_sse2_lowp)
_sk_srcover_sse2_lowp:
  .byte  102,68,15,111,13,174,75,0,0         // movdqa        0x4bae(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,249,195                   // psubw         %xmm3,%xmm8
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,213,212                   // pmullw        %xmm4,%xmm10
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,65,15,253,194                   // paddw         %xmm10,%xmm0
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,213,213                   // pmullw        %xmm5,%xmm10
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,65,15,253,202                   // paddw         %xmm10,%xmm1
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,213,214                   // pmullw        %xmm6,%xmm10
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,65,15,253,210                   // paddw         %xmm10,%xmm2
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,69,15,253,193                   // paddw         %xmm9,%xmm8
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_dstover_sse2_lowp
.globl _sk_dstover_sse2_lowp
FUNCTION(_sk_dstover_sse2_lowp)
_sk_dstover_sse2_lowp:
  .byte  102,68,15,111,5,52,75,0,0           // movdqa        0x4b34(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,68,15,249,207                   // psubw         %xmm7,%xmm9
  .byte  102,65,15,213,193                   // pmullw        %xmm9,%xmm0
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,253,196                      // paddw         %xmm4,%xmm0
  .byte  102,65,15,213,201                   // pmullw        %xmm9,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,253,205                      // paddw         %xmm5,%xmm1
  .byte  102,65,15,213,209                   // pmullw        %xmm9,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,253,214                      // paddw         %xmm6,%xmm2
  .byte  102,65,15,213,217                   // pmullw        %xmm9,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,253,223                      // paddw         %xmm7,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_modulate_sse2_lowp
.globl _sk_modulate_sse2_lowp
FUNCTION(_sk_modulate_sse2_lowp)
_sk_modulate_sse2_lowp:
  .byte  102,15,213,196                      // pmullw        %xmm4,%xmm0
  .byte  102,68,15,111,5,205,74,0,0          // movdqa        0x4acd(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,213,205                      // pmullw        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_multiply_sse2_lowp
.globl _sk_multiply_sse2_lowp
FUNCTION(_sk_multiply_sse2_lowp)
_sk_multiply_sse2_lowp:
  .byte  102,68,15,111,13,140,74,0,0         // movdqa        0x4a8c(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,249,195                   // psubw         %xmm3,%xmm8
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,213,212                   // pmullw        %xmm4,%xmm10
  .byte  102,68,15,111,220                   // movdqa        %xmm4,%xmm11
  .byte  102,69,15,253,217                   // paddw         %xmm9,%xmm11
  .byte  102,68,15,249,223                   // psubw         %xmm7,%xmm11
  .byte  102,65,15,213,195                   // pmullw        %xmm11,%xmm0
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,253,194                   // paddw         %xmm10,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,213,213                   // pmullw        %xmm5,%xmm10
  .byte  102,68,15,111,221                   // movdqa        %xmm5,%xmm11
  .byte  102,69,15,253,217                   // paddw         %xmm9,%xmm11
  .byte  102,68,15,249,223                   // psubw         %xmm7,%xmm11
  .byte  102,65,15,213,203                   // pmullw        %xmm11,%xmm1
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,253,202                   // paddw         %xmm10,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,68,15,213,214                   // pmullw        %xmm6,%xmm10
  .byte  102,68,15,111,222                   // movdqa        %xmm6,%xmm11
  .byte  102,69,15,253,217                   // paddw         %xmm9,%xmm11
  .byte  102,68,15,249,223                   // psubw         %xmm7,%xmm11
  .byte  102,65,15,213,211                   // pmullw        %xmm11,%xmm2
  .byte  102,69,15,253,209                   // paddw         %xmm9,%xmm10
  .byte  102,65,15,253,210                   // paddw         %xmm10,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,65,15,213,217                   // pmullw        %xmm9,%xmm3
  .byte  102,65,15,253,217                   // paddw         %xmm9,%xmm3
  .byte  102,65,15,253,216                   // paddw         %xmm8,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_plus__sse2_lowp
.globl _sk_plus__sse2_lowp
FUNCTION(_sk_plus__sse2_lowp)
_sk_plus__sse2_lowp:
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,253,204                      // paddw         %xmm4,%xmm1
  .byte  102,68,15,111,21,56,82,0,0          // movdqa        0x5238(%rip),%xmm10        # 3b360 <_sk_srcover_bgra_8888_sse2_lowp+0x13f8>
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,65,15,217,194                   // psubusw       %xmm10,%xmm0
  .byte  102,69,15,239,228                   // pxor          %xmm12,%xmm12
  .byte  102,65,15,117,196                   // pcmpeqw       %xmm12,%xmm0
  .byte  102,68,15,111,29,172,73,0,0         // movdqa        0x49ac(%rip),%xmm11        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,219,200                      // pand          %xmm0,%xmm1
  .byte  102,65,15,223,195                   // pandn         %xmm11,%xmm0
  .byte  102,15,235,193                      // por           %xmm1,%xmm0
  .byte  102,68,15,253,197                   // paddw         %xmm5,%xmm8
  .byte  102,65,15,111,200                   // movdqa        %xmm8,%xmm1
  .byte  102,65,15,217,202                   // psubusw       %xmm10,%xmm1
  .byte  102,65,15,117,204                   // pcmpeqw       %xmm12,%xmm1
  .byte  102,68,15,219,193                   // pand          %xmm1,%xmm8
  .byte  102,65,15,223,203                   // pandn         %xmm11,%xmm1
  .byte  102,65,15,235,200                   // por           %xmm8,%xmm1
  .byte  102,15,253,214                      // paddw         %xmm6,%xmm2
  .byte  102,68,15,111,194                   // movdqa        %xmm2,%xmm8
  .byte  102,69,15,217,194                   // psubusw       %xmm10,%xmm8
  .byte  102,69,15,117,196                   // pcmpeqw       %xmm12,%xmm8
  .byte  102,65,15,219,208                   // pand          %xmm8,%xmm2
  .byte  102,69,15,223,195                   // pandn         %xmm11,%xmm8
  .byte  102,68,15,235,194                   // por           %xmm2,%xmm8
  .byte  102,15,253,223                      // paddw         %xmm7,%xmm3
  .byte  102,68,15,111,203                   // movdqa        %xmm3,%xmm9
  .byte  102,69,15,217,202                   // psubusw       %xmm10,%xmm9
  .byte  102,69,15,117,204                   // pcmpeqw       %xmm12,%xmm9
  .byte  102,65,15,219,217                   // pand          %xmm9,%xmm3
  .byte  102,69,15,223,203                   // pandn         %xmm11,%xmm9
  .byte  102,68,15,235,203                   // por           %xmm3,%xmm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  102,65,15,111,217                   // movdqa        %xmm9,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_screen_sse2_lowp
.globl _sk_screen_sse2_lowp
FUNCTION(_sk_screen_sse2_lowp)
_sk_screen_sse2_lowp:
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,15,253,193                      // paddw         %xmm1,%xmm0
  .byte  102,15,213,204                      // pmullw        %xmm4,%xmm1
  .byte  102,68,15,111,21,12,73,0,0          // movdqa        0x490c(%rip),%xmm10        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,202                   // paddw         %xmm10,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,249,193                      // psubw         %xmm1,%xmm0
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,68,15,213,197                   // pmullw        %xmm5,%xmm8
  .byte  102,69,15,253,194                   // paddw         %xmm10,%xmm8
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  102,65,15,249,200                   // psubw         %xmm8,%xmm1
  .byte  102,68,15,111,198                   // movdqa        %xmm6,%xmm8
  .byte  102,68,15,253,194                   // paddw         %xmm2,%xmm8
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,65,15,253,210                   // paddw         %xmm10,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,68,15,249,194                   // psubw         %xmm2,%xmm8
  .byte  102,68,15,111,207                   // movdqa        %xmm7,%xmm9
  .byte  102,68,15,253,203                   // paddw         %xmm3,%xmm9
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,65,15,253,218                   // paddw         %xmm10,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,68,15,249,203                   // psubw         %xmm3,%xmm9
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  102,65,15,111,217                   // movdqa        %xmm9,%xmm3
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xor__sse2_lowp
.globl _sk_xor__sse2_lowp
FUNCTION(_sk_xor__sse2_lowp)
_sk_xor__sse2_lowp:
  .byte  102,68,15,111,195                   // movdqa        %xmm3,%xmm8
  .byte  102,68,15,111,13,138,72,0,0         // movdqa        0x488a(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,209                   // movdqa        %xmm9,%xmm10
  .byte  102,68,15,249,215                   // psubw         %xmm7,%xmm10
  .byte  102,65,15,213,194                   // pmullw        %xmm10,%xmm0
  .byte  102,65,15,111,217                   // movdqa        %xmm9,%xmm3
  .byte  102,65,15,249,216                   // psubw         %xmm8,%xmm3
  .byte  102,68,15,111,219                   // movdqa        %xmm3,%xmm11
  .byte  102,68,15,213,220                   // pmullw        %xmm4,%xmm11
  .byte  102,65,15,253,195                   // paddw         %xmm11,%xmm0
  .byte  102,65,15,253,193                   // paddw         %xmm9,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,65,15,213,202                   // pmullw        %xmm10,%xmm1
  .byte  102,68,15,111,219                   // movdqa        %xmm3,%xmm11
  .byte  102,68,15,213,221                   // pmullw        %xmm5,%xmm11
  .byte  102,65,15,253,203                   // paddw         %xmm11,%xmm1
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,65,15,213,210                   // pmullw        %xmm10,%xmm2
  .byte  102,68,15,111,219                   // movdqa        %xmm3,%xmm11
  .byte  102,68,15,213,222                   // pmullw        %xmm6,%xmm11
  .byte  102,65,15,253,211                   // paddw         %xmm11,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,69,15,213,208                   // pmullw        %xmm8,%xmm10
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,65,15,253,218                   // paddw         %xmm10,%xmm3
  .byte  102,65,15,253,217                   // paddw         %xmm9,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_darken_sse2_lowp
.globl _sk_darken_sse2_lowp
FUNCTION(_sk_darken_sse2_lowp)
_sk_darken_sse2_lowp:
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,68,15,111,208                   // movdqa        %xmm0,%xmm10
  .byte  102,68,15,111,228                   // movdqa        %xmm4,%xmm12
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,65,15,253,194                   // paddw         %xmm10,%xmm0
  .byte  102,68,15,213,215                   // pmullw        %xmm7,%xmm10
  .byte  102,68,15,213,227                   // pmullw        %xmm3,%xmm12
  .byte  102,68,15,111,13,69,79,0,0          // movdqa        0x4f45(%rip),%xmm9        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,69,15,111,218                   // movdqa        %xmm10,%xmm11
  .byte  102,69,15,239,217                   // pxor          %xmm9,%xmm11
  .byte  102,65,15,111,204                   // movdqa        %xmm12,%xmm1
  .byte  102,65,15,239,201                   // pxor          %xmm9,%xmm1
  .byte  102,65,15,101,203                   // pcmpgtw       %xmm11,%xmm1
  .byte  102,68,15,219,225                   // pand          %xmm1,%xmm12
  .byte  102,65,15,223,202                   // pandn         %xmm10,%xmm1
  .byte  102,65,15,235,204                   // por           %xmm12,%xmm1
  .byte  102,68,15,111,21,164,71,0,0         // movdqa        0x47a4(%rip),%xmm10        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,202                   // paddw         %xmm10,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,249,193                      // psubw         %xmm1,%xmm0
  .byte  102,68,15,111,221                   // movdqa        %xmm5,%xmm11
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,68,15,213,219                   // pmullw        %xmm3,%xmm11
  .byte  102,69,15,111,224                   // movdqa        %xmm8,%xmm12
  .byte  102,69,15,239,225                   // pxor          %xmm9,%xmm12
  .byte  102,69,15,111,235                   // movdqa        %xmm11,%xmm13
  .byte  102,69,15,239,233                   // pxor          %xmm9,%xmm13
  .byte  102,69,15,101,236                   // pcmpgtw       %xmm12,%xmm13
  .byte  102,69,15,219,221                   // pand          %xmm13,%xmm11
  .byte  102,69,15,223,232                   // pandn         %xmm8,%xmm13
  .byte  102,69,15,235,235                   // por           %xmm11,%xmm13
  .byte  102,69,15,253,234                   // paddw         %xmm10,%xmm13
  .byte  102,65,15,113,213,8                 // psrlw         $0x8,%xmm13
  .byte  102,65,15,249,205                   // psubw         %xmm13,%xmm1
  .byte  102,68,15,111,222                   // movdqa        %xmm6,%xmm11
  .byte  102,68,15,111,198                   // movdqa        %xmm6,%xmm8
  .byte  102,68,15,253,194                   // paddw         %xmm2,%xmm8
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,68,15,213,219                   // pmullw        %xmm3,%xmm11
  .byte  102,68,15,111,226                   // movdqa        %xmm2,%xmm12
  .byte  102,69,15,239,225                   // pxor          %xmm9,%xmm12
  .byte  102,69,15,239,203                   // pxor          %xmm11,%xmm9
  .byte  102,69,15,101,204                   // pcmpgtw       %xmm12,%xmm9
  .byte  102,69,15,219,217                   // pand          %xmm9,%xmm11
  .byte  102,68,15,223,202                   // pandn         %xmm2,%xmm9
  .byte  102,69,15,235,203                   // por           %xmm11,%xmm9
  .byte  102,69,15,253,202                   // paddw         %xmm10,%xmm9
  .byte  102,65,15,113,209,8                 // psrlw         $0x8,%xmm9
  .byte  102,69,15,249,193                   // psubw         %xmm9,%xmm8
  .byte  102,65,15,111,210                   // movdqa        %xmm10,%xmm2
  .byte  102,15,249,211                      // psubw         %xmm3,%xmm2
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,65,15,253,210                   // paddw         %xmm10,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,253,218                      // paddw         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lighten_sse2_lowp
.globl _sk_lighten_sse2_lowp
FUNCTION(_sk_lighten_sse2_lowp)
_sk_lighten_sse2_lowp:
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,68,15,111,224                   // movdqa        %xmm0,%xmm12
  .byte  102,68,15,111,212                   // movdqa        %xmm4,%xmm10
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,65,15,253,196                   // paddw         %xmm12,%xmm0
  .byte  102,68,15,213,231                   // pmullw        %xmm7,%xmm12
  .byte  102,68,15,213,211                   // pmullw        %xmm3,%xmm10
  .byte  102,68,15,111,13,28,78,0,0          // movdqa        0x4e1c(%rip),%xmm9        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,69,15,111,220                   // movdqa        %xmm12,%xmm11
  .byte  102,69,15,239,217                   // pxor          %xmm9,%xmm11
  .byte  102,65,15,111,202                   // movdqa        %xmm10,%xmm1
  .byte  102,65,15,239,201                   // pxor          %xmm9,%xmm1
  .byte  102,65,15,101,203                   // pcmpgtw       %xmm11,%xmm1
  .byte  102,68,15,219,225                   // pand          %xmm1,%xmm12
  .byte  102,65,15,223,202                   // pandn         %xmm10,%xmm1
  .byte  102,65,15,235,204                   // por           %xmm12,%xmm1
  .byte  102,68,15,111,21,123,70,0,0         // movdqa        0x467b(%rip),%xmm10        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,202                   // paddw         %xmm10,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,249,193                      // psubw         %xmm1,%xmm0
  .byte  102,68,15,111,221                   // movdqa        %xmm5,%xmm11
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,68,15,213,219                   // pmullw        %xmm3,%xmm11
  .byte  102,69,15,111,224                   // movdqa        %xmm8,%xmm12
  .byte  102,69,15,239,225                   // pxor          %xmm9,%xmm12
  .byte  102,69,15,111,235                   // movdqa        %xmm11,%xmm13
  .byte  102,69,15,239,233                   // pxor          %xmm9,%xmm13
  .byte  102,69,15,101,236                   // pcmpgtw       %xmm12,%xmm13
  .byte  102,69,15,219,197                   // pand          %xmm13,%xmm8
  .byte  102,69,15,223,235                   // pandn         %xmm11,%xmm13
  .byte  102,69,15,235,232                   // por           %xmm8,%xmm13
  .byte  102,69,15,253,234                   // paddw         %xmm10,%xmm13
  .byte  102,65,15,113,213,8                 // psrlw         $0x8,%xmm13
  .byte  102,65,15,249,205                   // psubw         %xmm13,%xmm1
  .byte  102,68,15,111,222                   // movdqa        %xmm6,%xmm11
  .byte  102,68,15,111,198                   // movdqa        %xmm6,%xmm8
  .byte  102,68,15,253,194                   // paddw         %xmm2,%xmm8
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,68,15,213,219                   // pmullw        %xmm3,%xmm11
  .byte  102,68,15,111,226                   // movdqa        %xmm2,%xmm12
  .byte  102,69,15,239,225                   // pxor          %xmm9,%xmm12
  .byte  102,69,15,239,203                   // pxor          %xmm11,%xmm9
  .byte  102,69,15,101,204                   // pcmpgtw       %xmm12,%xmm9
  .byte  102,65,15,219,209                   // pand          %xmm9,%xmm2
  .byte  102,69,15,223,203                   // pandn         %xmm11,%xmm9
  .byte  102,68,15,235,202                   // por           %xmm2,%xmm9
  .byte  102,69,15,253,202                   // paddw         %xmm10,%xmm9
  .byte  102,65,15,113,209,8                 // psrlw         $0x8,%xmm9
  .byte  102,69,15,249,193                   // psubw         %xmm9,%xmm8
  .byte  102,65,15,111,210                   // movdqa        %xmm10,%xmm2
  .byte  102,15,249,211                      // psubw         %xmm3,%xmm2
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,65,15,253,210                   // paddw         %xmm10,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,253,218                      // paddw         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_difference_sse2_lowp
.globl _sk_difference_sse2_lowp
FUNCTION(_sk_difference_sse2_lowp)
_sk_difference_sse2_lowp:
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,68,15,111,224                   // movdqa        %xmm0,%xmm12
  .byte  102,68,15,111,212                   // movdqa        %xmm4,%xmm10
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,65,15,253,196                   // paddw         %xmm12,%xmm0
  .byte  102,68,15,213,231                   // pmullw        %xmm7,%xmm12
  .byte  102,68,15,213,211                   // pmullw        %xmm3,%xmm10
  .byte  102,68,15,111,13,243,76,0,0         // movdqa        0x4cf3(%rip),%xmm9        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,69,15,111,220                   // movdqa        %xmm12,%xmm11
  .byte  102,69,15,239,217                   // pxor          %xmm9,%xmm11
  .byte  102,65,15,111,202                   // movdqa        %xmm10,%xmm1
  .byte  102,65,15,239,201                   // pxor          %xmm9,%xmm1
  .byte  102,65,15,101,203                   // pcmpgtw       %xmm11,%xmm1
  .byte  102,68,15,219,225                   // pand          %xmm1,%xmm12
  .byte  102,65,15,223,202                   // pandn         %xmm10,%xmm1
  .byte  102,65,15,235,204                   // por           %xmm12,%xmm1
  .byte  102,68,15,111,21,82,69,0,0          // movdqa        0x4552(%rip),%xmm10        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,202                   // paddw         %xmm10,%xmm1
  .byte  102,15,113,209,7                    // psrlw         $0x7,%xmm1
  .byte  102,68,15,111,29,159,76,0,0         // movdqa        0x4c9f(%rip),%xmm11        # 3b250 <_sk_srcover_bgra_8888_sse2_lowp+0x12e8>
  .byte  102,65,15,219,203                   // pand          %xmm11,%xmm1
  .byte  102,15,249,193                      // psubw         %xmm1,%xmm0
  .byte  102,68,15,111,229                   // movdqa        %xmm5,%xmm12
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,68,15,213,227                   // pmullw        %xmm3,%xmm12
  .byte  102,69,15,111,232                   // movdqa        %xmm8,%xmm13
  .byte  102,69,15,239,233                   // pxor          %xmm9,%xmm13
  .byte  102,69,15,111,244                   // movdqa        %xmm12,%xmm14
  .byte  102,69,15,239,241                   // pxor          %xmm9,%xmm14
  .byte  102,69,15,101,245                   // pcmpgtw       %xmm13,%xmm14
  .byte  102,69,15,219,198                   // pand          %xmm14,%xmm8
  .byte  102,69,15,223,244                   // pandn         %xmm12,%xmm14
  .byte  102,69,15,235,240                   // por           %xmm8,%xmm14
  .byte  102,69,15,253,242                   // paddw         %xmm10,%xmm14
  .byte  102,65,15,113,214,7                 // psrlw         $0x7,%xmm14
  .byte  102,69,15,219,243                   // pand          %xmm11,%xmm14
  .byte  102,65,15,249,206                   // psubw         %xmm14,%xmm1
  .byte  102,68,15,111,230                   // movdqa        %xmm6,%xmm12
  .byte  102,68,15,111,198                   // movdqa        %xmm6,%xmm8
  .byte  102,68,15,253,194                   // paddw         %xmm2,%xmm8
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,68,15,213,227                   // pmullw        %xmm3,%xmm12
  .byte  102,68,15,111,234                   // movdqa        %xmm2,%xmm13
  .byte  102,69,15,239,233                   // pxor          %xmm9,%xmm13
  .byte  102,69,15,239,204                   // pxor          %xmm12,%xmm9
  .byte  102,69,15,101,205                   // pcmpgtw       %xmm13,%xmm9
  .byte  102,65,15,219,209                   // pand          %xmm9,%xmm2
  .byte  102,69,15,223,204                   // pandn         %xmm12,%xmm9
  .byte  102,68,15,235,202                   // por           %xmm2,%xmm9
  .byte  102,69,15,253,202                   // paddw         %xmm10,%xmm9
  .byte  102,65,15,113,209,7                 // psrlw         $0x7,%xmm9
  .byte  102,69,15,219,203                   // pand          %xmm11,%xmm9
  .byte  102,69,15,249,193                   // psubw         %xmm9,%xmm8
  .byte  102,65,15,111,210                   // movdqa        %xmm10,%xmm2
  .byte  102,15,249,211                      // psubw         %xmm3,%xmm2
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,65,15,253,210                   // paddw         %xmm10,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,253,218                      // paddw         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_exclusion_sse2_lowp
.globl _sk_exclusion_sse2_lowp
FUNCTION(_sk_exclusion_sse2_lowp)
_sk_exclusion_sse2_lowp:
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,15,253,193                      // paddw         %xmm1,%xmm0
  .byte  102,15,213,204                      // pmullw        %xmm4,%xmm1
  .byte  102,68,15,111,13,79,68,0,0          // movdqa        0x444f(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,15,113,209,7                    // psrlw         $0x7,%xmm1
  .byte  102,68,15,111,21,156,75,0,0         // movdqa        0x4b9c(%rip),%xmm10        # 3b250 <_sk_srcover_bgra_8888_sse2_lowp+0x12e8>
  .byte  102,65,15,219,202                   // pand          %xmm10,%xmm1
  .byte  102,15,249,193                      // psubw         %xmm1,%xmm0
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,68,15,213,197                   // pmullw        %xmm5,%xmm8
  .byte  102,69,15,253,193                   // paddw         %xmm9,%xmm8
  .byte  102,65,15,113,208,7                 // psrlw         $0x7,%xmm8
  .byte  102,69,15,219,194                   // pand          %xmm10,%xmm8
  .byte  102,65,15,249,200                   // psubw         %xmm8,%xmm1
  .byte  102,68,15,111,198                   // movdqa        %xmm6,%xmm8
  .byte  102,68,15,253,194                   // paddw         %xmm2,%xmm8
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,7                    // psrlw         $0x7,%xmm2
  .byte  102,65,15,219,210                   // pand          %xmm10,%xmm2
  .byte  102,68,15,249,194                   // psubw         %xmm2,%xmm8
  .byte  102,65,15,111,209                   // movdqa        %xmm9,%xmm2
  .byte  102,15,249,211                      // psubw         %xmm3,%xmm2
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,253,218                      // paddw         %xmm2,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_hardlight_sse2_lowp
.globl _sk_hardlight_sse2_lowp
FUNCTION(_sk_hardlight_sse2_lowp)
_sk_hardlight_sse2_lowp:
  .byte  15,41,116,36,232                    // movaps        %xmm6,-0x18(%rsp)
  .byte  102,15,111,245                      // movdqa        %xmm5,%xmm6
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,68,15,111,194                   // movdqa        %xmm2,%xmm8
  .byte  102,68,15,111,200                   // movdqa        %xmm0,%xmm9
  .byte  102,15,111,21,171,67,0,0            // movdqa        0x43ab(%rip),%xmm2        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,68,15,111,226                   // movdqa        %xmm2,%xmm12
  .byte  102,68,15,249,231                   // psubw         %xmm7,%xmm12
  .byte  102,65,15,111,196                   // movdqa        %xmm12,%xmm0
  .byte  102,65,15,213,193                   // pmullw        %xmm9,%xmm0
  .byte  102,68,15,111,218                   // movdqa        %xmm2,%xmm11
  .byte  102,68,15,249,219                   // psubw         %xmm3,%xmm11
  .byte  102,69,15,111,251                   // movdqa        %xmm11,%xmm15
  .byte  102,68,15,213,253                   // pmullw        %xmm5,%xmm15
  .byte  102,68,15,253,248                   // paddw         %xmm0,%xmm15
  .byte  102,68,15,111,243                   // movdqa        %xmm3,%xmm14
  .byte  102,69,15,249,241                   // psubw         %xmm9,%xmm14
  .byte  102,69,15,253,201                   // paddw         %xmm9,%xmm9
  .byte  102,15,111,21,215,74,0,0            // movdqa        0x4ad7(%rip),%xmm2        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,15,111,199                      // movdqa        %xmm7,%xmm0
  .byte  102,68,15,111,215                   // movdqa        %xmm7,%xmm10
  .byte  102,15,111,231                      // movdqa        %xmm7,%xmm4
  .byte  102,68,15,213,211                   // pmullw        %xmm3,%xmm10
  .byte  102,15,249,197                      // psubw         %xmm5,%xmm0
  .byte  102,65,15,213,198                   // pmullw        %xmm14,%xmm0
  .byte  102,15,253,192                      // paddw         %xmm0,%xmm0
  .byte  102,69,15,111,234                   // movdqa        %xmm10,%xmm13
  .byte  102,68,15,249,232                   // psubw         %xmm0,%xmm13
  .byte  102,68,15,111,243                   // movdqa        %xmm3,%xmm14
  .byte  102,68,15,239,242                   // pxor          %xmm2,%xmm14
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,15,239,194                      // pxor          %xmm2,%xmm0
  .byte  102,65,15,101,198                   // pcmpgtw       %xmm14,%xmm0
  .byte  102,68,15,213,205                   // pmullw        %xmm5,%xmm9
  .byte  102,68,15,219,232                   // pand          %xmm0,%xmm13
  .byte  102,65,15,223,193                   // pandn         %xmm9,%xmm0
  .byte  102,65,15,235,197                   // por           %xmm13,%xmm0
  .byte  102,15,253,5,10,67,0,0              // paddw         0x430a(%rip),%xmm0        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,199                   // paddw         %xmm15,%xmm0
  .byte  102,69,15,111,204                   // movdqa        %xmm12,%xmm9
  .byte  102,68,15,213,201                   // pmullw        %xmm1,%xmm9
  .byte  102,69,15,111,235                   // movdqa        %xmm11,%xmm13
  .byte  102,68,15,213,238                   // pmullw        %xmm6,%xmm13
  .byte  102,69,15,253,233                   // paddw         %xmm9,%xmm13
  .byte  102,68,15,111,203                   // movdqa        %xmm3,%xmm9
  .byte  102,68,15,249,201                   // psubw         %xmm1,%xmm9
  .byte  102,68,15,111,252                   // movdqa        %xmm4,%xmm15
  .byte  102,68,15,249,254                   // psubw         %xmm6,%xmm15
  .byte  102,69,15,213,249                   // pmullw        %xmm9,%xmm15
  .byte  102,69,15,253,255                   // paddw         %xmm15,%xmm15
  .byte  102,65,15,111,250                   // movdqa        %xmm10,%xmm7
  .byte  102,65,15,249,255                   // psubw         %xmm15,%xmm7
  .byte  102,15,253,201                      // paddw         %xmm1,%xmm1
  .byte  102,68,15,111,201                   // movdqa        %xmm1,%xmm9
  .byte  102,68,15,239,202                   // pxor          %xmm2,%xmm9
  .byte  102,69,15,101,206                   // pcmpgtw       %xmm14,%xmm9
  .byte  102,15,213,206                      // pmullw        %xmm6,%xmm1
  .byte  102,65,15,219,249                   // pand          %xmm9,%xmm7
  .byte  102,68,15,223,201                   // pandn         %xmm1,%xmm9
  .byte  102,68,15,235,207                   // por           %xmm7,%xmm9
  .byte  102,68,15,253,13,149,66,0,0         // paddw         0x4295(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,253,205                   // paddw         %xmm13,%xmm9
  .byte  102,69,15,213,224                   // pmullw        %xmm8,%xmm12
  .byte  102,69,15,111,251                   // movdqa        %xmm11,%xmm15
  .byte  102,15,111,76,36,232                // movdqa        -0x18(%rsp),%xmm1
  .byte  102,68,15,213,249                   // pmullw        %xmm1,%xmm15
  .byte  102,69,15,253,252                   // paddw         %xmm12,%xmm15
  .byte  102,68,15,111,227                   // movdqa        %xmm3,%xmm12
  .byte  102,69,15,249,224                   // psubw         %xmm8,%xmm12
  .byte  102,69,15,253,192                   // paddw         %xmm8,%xmm8
  .byte  102,65,15,239,208                   // pxor          %xmm8,%xmm2
  .byte  102,65,15,101,214                   // pcmpgtw       %xmm14,%xmm2
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,15,249,249                      // psubw         %xmm1,%xmm7
  .byte  102,65,15,213,252                   // pmullw        %xmm12,%xmm7
  .byte  102,15,253,255                      // paddw         %xmm7,%xmm7
  .byte  102,68,15,249,215                   // psubw         %xmm7,%xmm10
  .byte  102,68,15,213,193                   // pmullw        %xmm1,%xmm8
  .byte  102,68,15,111,225                   // movdqa        %xmm1,%xmm12
  .byte  102,68,15,219,210                   // pand          %xmm2,%xmm10
  .byte  102,65,15,223,208                   // pandn         %xmm8,%xmm2
  .byte  102,65,15,235,210                   // por           %xmm10,%xmm2
  .byte  102,68,15,111,5,37,66,0,0           // movdqa        0x4225(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,65,15,253,215                   // paddw         %xmm15,%xmm2
  .byte  102,68,15,213,220                   // pmullw        %xmm4,%xmm11
  .byte  102,69,15,253,216                   // paddw         %xmm8,%xmm11
  .byte  102,65,15,113,211,8                 // psrlw         $0x8,%xmm11
  .byte  102,65,15,253,219                   // paddw         %xmm11,%xmm3
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,65,15,113,209,8                 // psrlw         $0x8,%xmm9
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,65,15,111,244                   // movdqa        %xmm12,%xmm6
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_overlay_sse2_lowp
.globl _sk_overlay_sse2_lowp
FUNCTION(_sk_overlay_sse2_lowp)
_sk_overlay_sse2_lowp:
  .byte  102,68,15,111,247                   // movdqa        %xmm7,%xmm14
  .byte  15,41,116,36,216                    // movaps        %xmm6,-0x28(%rsp)
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,15,127,124,36,232               // movdqa        %xmm7,-0x18(%rsp)
  .byte  102,68,15,111,193                   // movdqa        %xmm1,%xmm8
  .byte  102,68,15,111,248                   // movdqa        %xmm0,%xmm15
  .byte  102,15,111,53,182,65,0,0            // movdqa        0x41b6(%rip),%xmm6        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,68,15,111,222                   // movdqa        %xmm6,%xmm11
  .byte  102,69,15,249,222                   // psubw         %xmm14,%xmm11
  .byte  102,65,15,111,203                   // movdqa        %xmm11,%xmm1
  .byte  102,65,15,213,207                   // pmullw        %xmm15,%xmm1
  .byte  102,68,15,111,214                   // movdqa        %xmm6,%xmm10
  .byte  102,68,15,249,211                   // psubw         %xmm3,%xmm10
  .byte  102,65,15,111,194                   // movdqa        %xmm10,%xmm0
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,15,253,193                      // paddw         %xmm1,%xmm0
  .byte  102,68,15,111,235                   // movdqa        %xmm3,%xmm13
  .byte  102,69,15,249,239                   // psubw         %xmm15,%xmm13
  .byte  102,68,15,213,255                   // pmullw        %xmm7,%xmm15
  .byte  102,65,15,111,206                   // movdqa        %xmm14,%xmm1
  .byte  102,15,249,207                      // psubw         %xmm7,%xmm1
  .byte  102,15,253,255                      // paddw         %xmm7,%xmm7
  .byte  102,69,15,111,206                   // movdqa        %xmm14,%xmm9
  .byte  102,68,15,213,203                   // pmullw        %xmm3,%xmm9
  .byte  102,65,15,213,205                   // pmullw        %xmm13,%xmm1
  .byte  102,15,253,201                      // paddw         %xmm1,%xmm1
  .byte  102,69,15,111,225                   // movdqa        %xmm9,%xmm12
  .byte  102,68,15,249,225                   // psubw         %xmm1,%xmm12
  .byte  102,15,111,13,186,72,0,0            // movdqa        0x48ba(%rip),%xmm1        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,69,15,111,238                   // movdqa        %xmm14,%xmm13
  .byte  102,68,15,239,233                   // pxor          %xmm1,%xmm13
  .byte  102,15,239,249                      // pxor          %xmm1,%xmm7
  .byte  102,65,15,101,253                   // pcmpgtw       %xmm13,%xmm7
  .byte  102,69,15,253,255                   // paddw         %xmm15,%xmm15
  .byte  102,68,15,219,231                   // pand          %xmm7,%xmm12
  .byte  102,65,15,223,255                   // pandn         %xmm15,%xmm7
  .byte  102,65,15,235,252                   // por           %xmm12,%xmm7
  .byte  102,15,253,254                      // paddw         %xmm6,%xmm7
  .byte  102,15,253,199                      // paddw         %xmm7,%xmm0
  .byte  102,65,15,111,227                   // movdqa        %xmm11,%xmm4
  .byte  102,65,15,213,224                   // pmullw        %xmm8,%xmm4
  .byte  102,65,15,111,202                   // movdqa        %xmm10,%xmm1
  .byte  102,15,213,205                      // pmullw        %xmm5,%xmm1
  .byte  102,15,253,204                      // paddw         %xmm4,%xmm1
  .byte  102,68,15,111,227                   // movdqa        %xmm3,%xmm12
  .byte  102,69,15,249,224                   // psubw         %xmm8,%xmm12
  .byte  102,65,15,111,230                   // movdqa        %xmm14,%xmm4
  .byte  102,15,249,229                      // psubw         %xmm5,%xmm4
  .byte  102,65,15,213,228                   // pmullw        %xmm12,%xmm4
  .byte  102,15,253,228                      // paddw         %xmm4,%xmm4
  .byte  102,69,15,111,225                   // movdqa        %xmm9,%xmm12
  .byte  102,68,15,249,228                   // psubw         %xmm4,%xmm12
  .byte  102,68,15,213,197                   // pmullw        %xmm5,%xmm8
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,253,228                      // paddw         %xmm4,%xmm4
  .byte  102,15,111,61,57,72,0,0             // movdqa        0x4839(%rip),%xmm7        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,15,239,231                      // pxor          %xmm7,%xmm4
  .byte  102,65,15,101,229                   // pcmpgtw       %xmm13,%xmm4
  .byte  102,69,15,253,192                   // paddw         %xmm8,%xmm8
  .byte  102,68,15,219,228                   // pand          %xmm4,%xmm12
  .byte  102,65,15,223,224                   // pandn         %xmm8,%xmm4
  .byte  102,65,15,235,228                   // por           %xmm12,%xmm4
  .byte  102,15,253,230                      // paddw         %xmm6,%xmm4
  .byte  102,68,15,111,230                   // movdqa        %xmm6,%xmm12
  .byte  102,15,253,204                      // paddw         %xmm4,%xmm1
  .byte  102,68,15,213,218                   // pmullw        %xmm2,%xmm11
  .byte  102,69,15,111,194                   // movdqa        %xmm10,%xmm8
  .byte  102,15,111,116,36,216               // movdqa        -0x28(%rsp),%xmm6
  .byte  102,68,15,213,198                   // pmullw        %xmm6,%xmm8
  .byte  102,69,15,253,195                   // paddw         %xmm11,%xmm8
  .byte  102,15,111,230                      // movdqa        %xmm6,%xmm4
  .byte  102,15,253,228                      // paddw         %xmm4,%xmm4
  .byte  102,15,239,231                      // pxor          %xmm7,%xmm4
  .byte  102,69,15,111,222                   // movdqa        %xmm14,%xmm11
  .byte  102,68,15,249,222                   // psubw         %xmm6,%xmm11
  .byte  102,65,15,101,229                   // pcmpgtw       %xmm13,%xmm4
  .byte  102,15,111,251                      // movdqa        %xmm3,%xmm7
  .byte  102,15,249,250                      // psubw         %xmm2,%xmm7
  .byte  102,68,15,213,223                   // pmullw        %xmm7,%xmm11
  .byte  102,69,15,253,219                   // paddw         %xmm11,%xmm11
  .byte  102,69,15,249,203                   // psubw         %xmm11,%xmm9
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,15,253,210                      // paddw         %xmm2,%xmm2
  .byte  102,68,15,219,204                   // pand          %xmm4,%xmm9
  .byte  102,15,223,226                      // pandn         %xmm2,%xmm4
  .byte  102,65,15,235,225                   // por           %xmm9,%xmm4
  .byte  102,65,15,111,212                   // movdqa        %xmm12,%xmm2
  .byte  102,15,253,226                      // paddw         %xmm2,%xmm4
  .byte  102,68,15,253,196                   // paddw         %xmm4,%xmm8
  .byte  102,69,15,213,214                   // pmullw        %xmm14,%xmm10
  .byte  102,68,15,253,210                   // paddw         %xmm2,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,65,15,253,218                   // paddw         %xmm10,%xmm3
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,100,36,232                    // movaps        -0x18(%rsp),%xmm4
  .byte  102,65,15,111,254                   // movdqa        %xmm14,%xmm7
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_8888_sse2_lowp
.globl _sk_load_8888_sse2_lowp
FUNCTION(_sk_load_8888_sse2_lowp)
_sk_load_8888_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,41                              // ja            36b3d <_sk_load_8888_sse2_lowp+0x44>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,25,1,0,0                  // lea           0x119(%rip),%r9        # 36c3c <_sk_load_8888_sse2_lowp+0x143>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  255,224                             // jmpq          *%rax
  .byte  243,65,15,16,28,144                 // movss         (%r8,%rdx,4),%xmm3
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  235,102                             // jmp           36ba3 <_sk_load_8888_sse2_lowp+0xaa>
  .byte  102,65,15,16,28,144                 // movupd        (%r8,%rdx,4),%xmm3
  .byte  243,69,15,111,68,144,16             // movdqu        0x10(%r8,%rdx,4),%xmm8
  .byte  235,87                              // jmp           36ba3 <_sk_load_8888_sse2_lowp+0xaa>
  .byte  102,65,15,110,68,144,8              // movd          0x8(%r8,%rdx,4),%xmm0
  .byte  102,68,15,112,192,69                // pshufd        $0x45,%xmm0,%xmm8
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,69,15,18,4,144                  // movlpd        (%r8,%rdx,4),%xmm8
  .byte  102,65,15,40,216                    // movapd        %xmm8,%xmm3
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  235,52                              // jmp           36ba3 <_sk_load_8888_sse2_lowp+0xaa>
  .byte  102,65,15,110,68,144,24             // movd          0x18(%r8,%rdx,4),%xmm0
  .byte  102,68,15,112,192,69                // pshufd        $0x45,%xmm0,%xmm8
  .byte  243,65,15,16,68,144,20              // movss         0x14(%r8,%rdx,4),%xmm0
  .byte  65,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm0
  .byte  65,15,198,192,226                   // shufps        $0xe2,%xmm8,%xmm0
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  243,65,15,16,68,144,16              // movss         0x10(%r8,%rdx,4),%xmm0
  .byte  243,68,15,16,192                    // movss         %xmm0,%xmm8
  .byte  102,65,15,16,28,144                 // movupd        (%r8,%rdx,4),%xmm3
  .byte  102,15,40,203                       // movapd        %xmm3,%xmm1
  .byte  102,15,114,241,16                   // pslld         $0x10,%xmm1
  .byte  102,15,114,225,16                   // psrad         $0x10,%xmm1
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,107,200                      // packssdw      %xmm0,%xmm1
  .byte  102,68,15,111,13,35,63,0,0          // movdqa        0x3f23(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,65,15,219,193                   // pand          %xmm9,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,65,15,114,210,16                // psrld         $0x10,%xmm10
  .byte  102,15,40,211                       // movapd        %xmm3,%xmm2
  .byte  102,15,114,210,16                   // psrld         $0x10,%xmm2
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  102,15,114,227,16                   // psrad         $0x10,%xmm3
  .byte  102,65,15,114,208,24                // psrld         $0x18,%xmm8
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,114,224,16                // psrad         $0x10,%xmm8
  .byte  102,65,15,107,216                   // packssdw      %xmm8,%xmm3
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,114,226,16                   // psrad         $0x10,%xmm2
  .byte  102,65,15,114,242,16                // pslld         $0x10,%xmm10
  .byte  102,65,15,114,226,16                // psrad         $0x10,%xmm10
  .byte  102,65,15,107,210                   // packssdw      %xmm10,%xmm2
  .byte  102,65,15,219,209                   // pand          %xmm9,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  244                                 // hlt
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,33                              // jmpq          *(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,16                              // callq         *(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,97,255                          // jmpq          *-0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,85,255                          // callq         *-0x1(%rbp)
  .byte  255                                 // (bad)
  .byte  255,64,255                          // incl          -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,51                              // pushq         (%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_8888_dst_sse2_lowp
.globl _sk_load_8888_dst_sse2_lowp
FUNCTION(_sk_load_8888_dst_sse2_lowp)
_sk_load_8888_dst_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,41                              // ja            36c9c <_sk_load_8888_dst_sse2_lowp+0x44>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,22,1,0,0                  // lea           0x116(%rip),%r9        # 36d98 <_sk_load_8888_dst_sse2_lowp+0x140>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  255,224                             // jmpq          *%rax
  .byte  243,65,15,16,60,144                 // movss         (%r8,%rdx,4),%xmm7
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  235,102                             // jmp           36d02 <_sk_load_8888_dst_sse2_lowp+0xaa>
  .byte  102,65,15,16,60,144                 // movupd        (%r8,%rdx,4),%xmm7
  .byte  243,69,15,111,68,144,16             // movdqu        0x10(%r8,%rdx,4),%xmm8
  .byte  235,87                              // jmp           36d02 <_sk_load_8888_dst_sse2_lowp+0xaa>
  .byte  102,65,15,110,100,144,8             // movd          0x8(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,69,15,18,4,144                  // movlpd        (%r8,%rdx,4),%xmm8
  .byte  102,65,15,40,248                    // movapd        %xmm8,%xmm7
  .byte  102,68,15,111,196                   // movdqa        %xmm4,%xmm8
  .byte  235,52                              // jmp           36d02 <_sk_load_8888_dst_sse2_lowp+0xaa>
  .byte  102,65,15,110,100,144,24            // movd          0x18(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  243,65,15,16,100,144,20             // movss         0x14(%r8,%rdx,4),%xmm4
  .byte  65,15,198,224,0                     // shufps        $0x0,%xmm8,%xmm4
  .byte  65,15,198,224,226                   // shufps        $0xe2,%xmm8,%xmm4
  .byte  68,15,40,196                        // movaps        %xmm4,%xmm8
  .byte  243,65,15,16,100,144,16             // movss         0x10(%r8,%rdx,4),%xmm4
  .byte  243,68,15,16,196                    // movss         %xmm4,%xmm8
  .byte  102,65,15,16,60,144                 // movupd        (%r8,%rdx,4),%xmm7
  .byte  102,15,40,239                       // movapd        %xmm7,%xmm5
  .byte  102,15,114,245,16                   // pslld         $0x10,%xmm5
  .byte  102,15,114,229,16                   // psrad         $0x10,%xmm5
  .byte  102,65,15,111,224                   // movdqa        %xmm8,%xmm4
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,107,236                      // packssdw      %xmm4,%xmm5
  .byte  102,68,15,111,13,196,61,0,0         // movdqa        0x3dc4(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,65,15,219,225                   // pand          %xmm9,%xmm4
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,65,15,114,210,16                // psrld         $0x10,%xmm10
  .byte  102,15,40,247                       // movapd        %xmm7,%xmm6
  .byte  102,15,114,214,16                   // psrld         $0x10,%xmm6
  .byte  102,15,114,215,24                   // psrld         $0x18,%xmm7
  .byte  102,15,114,247,16                   // pslld         $0x10,%xmm7
  .byte  102,15,114,231,16                   // psrad         $0x10,%xmm7
  .byte  102,65,15,114,208,24                // psrld         $0x18,%xmm8
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,114,224,16                // psrad         $0x10,%xmm8
  .byte  102,65,15,107,248                   // packssdw      %xmm8,%xmm7
  .byte  102,15,114,246,16                   // pslld         $0x10,%xmm6
  .byte  102,15,114,230,16                   // psrad         $0x10,%xmm6
  .byte  102,65,15,114,242,16                // pslld         $0x10,%xmm10
  .byte  102,65,15,114,226,16                // psrad         $0x10,%xmm10
  .byte  102,65,15,107,242                   // packssdw      %xmm10,%xmm6
  .byte  102,65,15,219,241                   // pand          %xmm9,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  247,254                             // idiv          %esi
  .byte  255                                 // (bad)
  .byte  255,36,255                          // jmpq          *(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,19                              // callq         *(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,100,255,255                     // jmpq          *-0x1(%rdi,%rdi,8)
  .byte  255,88,255                          // lcall         *-0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,67,255                          // incl          -0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,54                              // pushq         (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_8888_sse2_lowp
.globl _sk_store_8888_sse2_lowp
FUNCTION(_sk_store_8888_sse2_lowp)
_sk_store_8888_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  102,68,15,111,209                   // movdqa        %xmm1,%xmm10
  .byte  102,65,15,113,242,8                 // psllw         $0x8,%xmm10
  .byte  102,68,15,235,208                   // por           %xmm0,%xmm10
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,69,15,111,218                   // movdqa        %xmm10,%xmm11
  .byte  102,69,15,97,216                    // punpcklwd     %xmm8,%xmm11
  .byte  102,69,15,105,208                   // punpckhwd     %xmm8,%xmm10
  .byte  102,68,15,111,227                   // movdqa        %xmm3,%xmm12
  .byte  102,65,15,113,244,8                 // psllw         $0x8,%xmm12
  .byte  102,68,15,235,226                   // por           %xmm2,%xmm12
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  102,69,15,97,204                    // punpcklwd     %xmm12,%xmm9
  .byte  102,69,15,235,203                   // por           %xmm11,%xmm9
  .byte  102,69,15,105,196                   // punpckhwd     %xmm12,%xmm8
  .byte  102,69,15,235,194                   // por           %xmm10,%xmm8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,27                              // ja            36e37 <_sk_store_8888_sse2_lowp+0x83>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,98,0,0,0                  // lea           0x62(%rip),%r9        # 36e88 <_sk_store_8888_sse2_lowp+0xd4>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,126,12,144                // movd          %xmm9,(%r8,%rdx,4)
  .byte  235,75                              // jmp           36e82 <_sk_store_8888_sse2_lowp+0xce>
  .byte  243,69,15,127,12,144                // movdqu        %xmm9,(%r8,%rdx,4)
  .byte  243,69,15,127,68,144,16             // movdqu        %xmm8,0x10(%r8,%rdx,4)
  .byte  235,60                              // jmp           36e82 <_sk_store_8888_sse2_lowp+0xce>
  .byte  102,69,15,112,193,78                // pshufd        $0x4e,%xmm9,%xmm8
  .byte  102,69,15,126,68,144,8              // movd          %xmm8,0x8(%r8,%rdx,4)
  .byte  102,69,15,214,12,144                // movq          %xmm9,(%r8,%rdx,4)
  .byte  235,39                              // jmp           36e82 <_sk_store_8888_sse2_lowp+0xce>
  .byte  102,69,15,112,208,78                // pshufd        $0x4e,%xmm8,%xmm10
  .byte  102,69,15,126,84,144,24             // movd          %xmm10,0x18(%r8,%rdx,4)
  .byte  102,69,15,112,208,229               // pshufd        $0xe5,%xmm8,%xmm10
  .byte  102,69,15,126,84,144,20             // movd          %xmm10,0x14(%r8,%rdx,4)
  .byte  102,69,15,126,68,144,16             // movd          %xmm8,0x10(%r8,%rdx,4)
  .byte  243,69,15,127,12,144                // movdqu        %xmm9,(%r8,%rdx,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  167                                 // cmpsl         %es:(%rdi),%ds:(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,203                             // dec           %ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  190,255,255,255,244                 // mov           $0xf4ffffff,%esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  237                                 // in            (%dx),%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,224                             // jmpq          *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,211                             // callq         *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_bgra_sse2_lowp
.globl _sk_load_bgra_sse2_lowp
FUNCTION(_sk_load_bgra_sse2_lowp)
_sk_load_bgra_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,41                              // ja            36ee8 <_sk_load_bgra_sse2_lowp+0x44>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,22,1,0,0                  // lea           0x116(%rip),%r9        # 36fe4 <_sk_load_bgra_sse2_lowp+0x140>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  255,224                             // jmpq          *%rax
  .byte  243,65,15,16,28,144                 // movss         (%r8,%rdx,4),%xmm3
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  235,102                             // jmp           36f4e <_sk_load_bgra_sse2_lowp+0xaa>
  .byte  102,65,15,16,28,144                 // movupd        (%r8,%rdx,4),%xmm3
  .byte  243,69,15,111,68,144,16             // movdqu        0x10(%r8,%rdx,4),%xmm8
  .byte  235,87                              // jmp           36f4e <_sk_load_bgra_sse2_lowp+0xaa>
  .byte  102,65,15,110,68,144,8              // movd          0x8(%r8,%rdx,4),%xmm0
  .byte  102,68,15,112,192,69                // pshufd        $0x45,%xmm0,%xmm8
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,69,15,18,4,144                  // movlpd        (%r8,%rdx,4),%xmm8
  .byte  102,65,15,40,216                    // movapd        %xmm8,%xmm3
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  235,52                              // jmp           36f4e <_sk_load_bgra_sse2_lowp+0xaa>
  .byte  102,65,15,110,68,144,24             // movd          0x18(%r8,%rdx,4),%xmm0
  .byte  102,68,15,112,192,69                // pshufd        $0x45,%xmm0,%xmm8
  .byte  243,65,15,16,68,144,20              // movss         0x14(%r8,%rdx,4),%xmm0
  .byte  65,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm0
  .byte  65,15,198,192,226                   // shufps        $0xe2,%xmm8,%xmm0
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  243,65,15,16,68,144,16              // movss         0x10(%r8,%rdx,4),%xmm0
  .byte  243,68,15,16,192                    // movss         %xmm0,%xmm8
  .byte  102,65,15,16,28,144                 // movupd        (%r8,%rdx,4),%xmm3
  .byte  102,15,40,203                       // movapd        %xmm3,%xmm1
  .byte  102,15,114,241,16                   // pslld         $0x10,%xmm1
  .byte  102,15,114,225,16                   // psrad         $0x10,%xmm1
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,107,200                      // packssdw      %xmm0,%xmm1
  .byte  102,68,15,111,13,120,59,0,0         // movdqa        0x3b78(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,65,15,219,209                   // pand          %xmm9,%xmm2
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,65,15,114,210,16                // psrld         $0x10,%xmm10
  .byte  102,15,40,195                       // movapd        %xmm3,%xmm0
  .byte  102,15,114,208,16                   // psrld         $0x10,%xmm0
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  102,15,114,227,16                   // psrad         $0x10,%xmm3
  .byte  102,65,15,114,208,24                // psrld         $0x18,%xmm8
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,114,224,16                // psrad         $0x10,%xmm8
  .byte  102,65,15,107,216                   // packssdw      %xmm8,%xmm3
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,65,15,114,242,16                // pslld         $0x10,%xmm10
  .byte  102,65,15,114,226,16                // psrad         $0x10,%xmm10
  .byte  102,65,15,107,194                   // packssdw      %xmm10,%xmm0
  .byte  102,65,15,219,193                   // pand          %xmm9,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  247,254                             // idiv          %esi
  .byte  255                                 // (bad)
  .byte  255,36,255                          // jmpq          *(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,19                              // callq         *(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,100,255,255                     // jmpq          *-0x1(%rdi,%rdi,8)
  .byte  255,88,255                          // lcall         *-0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,67,255                          // incl          -0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,54                              // pushq         (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_bgra_dst_sse2_lowp
.globl _sk_load_bgra_dst_sse2_lowp
FUNCTION(_sk_load_bgra_dst_sse2_lowp)
_sk_load_bgra_dst_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,41                              // ja            37044 <_sk_load_bgra_dst_sse2_lowp+0x44>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,22,1,0,0                  // lea           0x116(%rip),%r9        # 37140 <_sk_load_bgra_dst_sse2_lowp+0x140>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  255,224                             // jmpq          *%rax
  .byte  243,65,15,16,60,144                 // movss         (%r8,%rdx,4),%xmm7
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  235,102                             // jmp           370aa <_sk_load_bgra_dst_sse2_lowp+0xaa>
  .byte  102,65,15,16,60,144                 // movupd        (%r8,%rdx,4),%xmm7
  .byte  243,69,15,111,68,144,16             // movdqu        0x10(%r8,%rdx,4),%xmm8
  .byte  235,87                              // jmp           370aa <_sk_load_bgra_dst_sse2_lowp+0xaa>
  .byte  102,65,15,110,100,144,8             // movd          0x8(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,69,15,18,4,144                  // movlpd        (%r8,%rdx,4),%xmm8
  .byte  102,65,15,40,248                    // movapd        %xmm8,%xmm7
  .byte  102,68,15,111,196                   // movdqa        %xmm4,%xmm8
  .byte  235,52                              // jmp           370aa <_sk_load_bgra_dst_sse2_lowp+0xaa>
  .byte  102,65,15,110,100,144,24            // movd          0x18(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  243,65,15,16,100,144,20             // movss         0x14(%r8,%rdx,4),%xmm4
  .byte  65,15,198,224,0                     // shufps        $0x0,%xmm8,%xmm4
  .byte  65,15,198,224,226                   // shufps        $0xe2,%xmm8,%xmm4
  .byte  68,15,40,196                        // movaps        %xmm4,%xmm8
  .byte  243,65,15,16,100,144,16             // movss         0x10(%r8,%rdx,4),%xmm4
  .byte  243,68,15,16,196                    // movss         %xmm4,%xmm8
  .byte  102,65,15,16,60,144                 // movupd        (%r8,%rdx,4),%xmm7
  .byte  102,15,40,239                       // movapd        %xmm7,%xmm5
  .byte  102,15,114,245,16                   // pslld         $0x10,%xmm5
  .byte  102,15,114,229,16                   // psrad         $0x10,%xmm5
  .byte  102,65,15,111,224                   // movdqa        %xmm8,%xmm4
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,107,236                      // packssdw      %xmm4,%xmm5
  .byte  102,68,15,111,13,28,58,0,0          // movdqa        0x3a1c(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,245                      // movdqa        %xmm5,%xmm6
  .byte  102,65,15,219,241                   // pand          %xmm9,%xmm6
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,65,15,114,210,16                // psrld         $0x10,%xmm10
  .byte  102,15,40,231                       // movapd        %xmm7,%xmm4
  .byte  102,15,114,212,16                   // psrld         $0x10,%xmm4
  .byte  102,15,114,215,24                   // psrld         $0x18,%xmm7
  .byte  102,15,114,247,16                   // pslld         $0x10,%xmm7
  .byte  102,15,114,231,16                   // psrad         $0x10,%xmm7
  .byte  102,65,15,114,208,24                // psrld         $0x18,%xmm8
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,114,224,16                // psrad         $0x10,%xmm8
  .byte  102,65,15,107,248                   // packssdw      %xmm8,%xmm7
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,65,15,114,242,16                // pslld         $0x10,%xmm10
  .byte  102,65,15,114,226,16                // psrad         $0x10,%xmm10
  .byte  102,65,15,107,226                   // packssdw      %xmm10,%xmm4
  .byte  102,65,15,219,225                   // pand          %xmm9,%xmm4
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  247,254                             // idiv          %esi
  .byte  255                                 // (bad)
  .byte  255,36,255                          // jmpq          *(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,19                              // callq         *(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,100,255,255                     // jmpq          *-0x1(%rdi,%rdi,8)
  .byte  255,88,255                          // lcall         *-0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,67,255                          // incl          -0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,54                              // pushq         (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_bgra_sse2_lowp
.globl _sk_store_bgra_sse2_lowp
FUNCTION(_sk_store_bgra_sse2_lowp)
_sk_store_bgra_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  102,68,15,111,209                   // movdqa        %xmm1,%xmm10
  .byte  102,65,15,113,242,8                 // psllw         $0x8,%xmm10
  .byte  102,68,15,235,210                   // por           %xmm2,%xmm10
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,69,15,111,218                   // movdqa        %xmm10,%xmm11
  .byte  102,69,15,97,216                    // punpcklwd     %xmm8,%xmm11
  .byte  102,69,15,105,208                   // punpckhwd     %xmm8,%xmm10
  .byte  102,68,15,111,227                   // movdqa        %xmm3,%xmm12
  .byte  102,65,15,113,244,8                 // psllw         $0x8,%xmm12
  .byte  102,68,15,235,224                   // por           %xmm0,%xmm12
  .byte  102,69,15,239,201                   // pxor          %xmm9,%xmm9
  .byte  102,69,15,97,204                    // punpcklwd     %xmm12,%xmm9
  .byte  102,69,15,235,203                   // por           %xmm11,%xmm9
  .byte  102,69,15,105,196                   // punpckhwd     %xmm12,%xmm8
  .byte  102,69,15,235,194                   // por           %xmm10,%xmm8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,27                              // ja            371df <_sk_store_bgra_sse2_lowp+0x83>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,98,0,0,0                  // lea           0x62(%rip),%r9        # 37230 <_sk_store_bgra_sse2_lowp+0xd4>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,126,12,144                // movd          %xmm9,(%r8,%rdx,4)
  .byte  235,75                              // jmp           3722a <_sk_store_bgra_sse2_lowp+0xce>
  .byte  243,69,15,127,12,144                // movdqu        %xmm9,(%r8,%rdx,4)
  .byte  243,69,15,127,68,144,16             // movdqu        %xmm8,0x10(%r8,%rdx,4)
  .byte  235,60                              // jmp           3722a <_sk_store_bgra_sse2_lowp+0xce>
  .byte  102,69,15,112,193,78                // pshufd        $0x4e,%xmm9,%xmm8
  .byte  102,69,15,126,68,144,8              // movd          %xmm8,0x8(%r8,%rdx,4)
  .byte  102,69,15,214,12,144                // movq          %xmm9,(%r8,%rdx,4)
  .byte  235,39                              // jmp           3722a <_sk_store_bgra_sse2_lowp+0xce>
  .byte  102,69,15,112,208,78                // pshufd        $0x4e,%xmm8,%xmm10
  .byte  102,69,15,126,84,144,24             // movd          %xmm10,0x18(%r8,%rdx,4)
  .byte  102,69,15,112,208,229               // pshufd        $0xe5,%xmm8,%xmm10
  .byte  102,69,15,126,84,144,20             // movd          %xmm10,0x14(%r8,%rdx,4)
  .byte  102,69,15,126,68,144,16             // movd          %xmm8,0x10(%r8,%rdx,4)
  .byte  243,69,15,127,12,144                // movdqu        %xmm9,(%r8,%rdx,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  167                                 // cmpsl         %es:(%rdi),%ds:(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,203                             // dec           %ebx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  190,255,255,255,244                 // mov           $0xf4ffffff,%esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  237                                 // in            (%dx),%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,224                             // jmpq          *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,211                             // callq         *%rbx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_8888_sse2_lowp
.globl _sk_gather_8888_sse2_lowp
FUNCTION(_sk_gather_8888_sse2_lowp)
_sk_gather_8888_sse2_lowp:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  65,15,95,194                        // maxps         %xmm10,%xmm0
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  243,68,15,16,64,16                  // movss         0x10(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  65,15,95,218                        // maxps         %xmm10,%xmm3
  .byte  65,15,95,210                        // maxps         %xmm10,%xmm2
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  243,68,15,91,195                    // cvttps2dq     %xmm3,%xmm8
  .byte  243,68,15,91,202                    // cvttps2dq     %xmm2,%xmm9
  .byte  102,15,110,88,8                     // movd          0x8(%rax),%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  102,69,15,112,209,245               // pshufd        $0xf5,%xmm9,%xmm10
  .byte  102,68,15,244,211                   // pmuludq       %xmm3,%xmm10
  .byte  102,68,15,111,219                   // movdqa        %xmm3,%xmm11
  .byte  102,69,15,112,224,245               // pshufd        $0xf5,%xmm8,%xmm12
  .byte  102,68,15,244,227                   // pmuludq       %xmm3,%xmm12
  .byte  102,65,15,244,217                   // pmuludq       %xmm9,%xmm3
  .byte  72,139,0                            // mov           (%rax),%rax
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  102,65,15,112,210,232               // pshufd        $0xe8,%xmm10,%xmm2
  .byte  102,15,98,218                       // punpckldq     %xmm2,%xmm3
  .byte  102,69,15,244,216                   // pmuludq       %xmm8,%xmm11
  .byte  102,69,15,112,195,232               // pshufd        $0xe8,%xmm11,%xmm8
  .byte  102,65,15,112,212,232               // pshufd        $0xe8,%xmm12,%xmm2
  .byte  102,68,15,98,194                    // punpckldq     %xmm2,%xmm8
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,65,15,254,200                   // paddd         %xmm8,%xmm1
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,73,15,126,208                   // movq          %xmm2,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,73,15,126,199                   // movq          %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  102,66,15,110,4,184                 // movd          (%rax,%r15,4),%xmm0
  .byte  102,66,15,110,28,160                // movd          (%rax,%r12,4),%xmm3
  .byte  102,15,98,216                       // punpckldq     %xmm0,%xmm3
  .byte  102,15,110,4,152                    // movd          (%rax,%rbx,4),%xmm0
  .byte  102,66,15,110,12,176                // movd          (%rax,%r14,4),%xmm1
  .byte  102,15,98,200                       // punpckldq     %xmm0,%xmm1
  .byte  102,15,108,217                      // punpcklqdq    %xmm1,%xmm3
  .byte  102,66,15,110,4,144                 // movd          (%rax,%r10,4),%xmm0
  .byte  102,70,15,110,4,152                 // movd          (%rax,%r11,4),%xmm8
  .byte  102,68,15,98,192                    // punpckldq     %xmm0,%xmm8
  .byte  102,66,15,110,4,128                 // movd          (%rax,%r8,4),%xmm0
  .byte  102,66,15,110,12,136                // movd          (%rax,%r9,4),%xmm1
  .byte  102,15,98,200                       // punpckldq     %xmm0,%xmm1
  .byte  102,68,15,108,193                   // punpcklqdq    %xmm1,%xmm8
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,114,241,16                   // pslld         $0x10,%xmm1
  .byte  102,15,114,225,16                   // psrad         $0x10,%xmm1
  .byte  102,15,107,200                      // packssdw      %xmm0,%xmm1
  .byte  102,68,15,111,13,56,55,0,0          // movdqa        0x3738(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,65,15,219,193                   // pand          %xmm9,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,114,210,16                   // psrld         $0x10,%xmm2
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,65,15,114,210,16                // psrld         $0x10,%xmm10
  .byte  102,65,15,114,208,24                // psrld         $0x18,%xmm8
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,114,224,16                // psrad         $0x10,%xmm8
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  102,15,114,227,16                   // psrad         $0x10,%xmm3
  .byte  102,65,15,107,216                   // packssdw      %xmm8,%xmm3
  .byte  102,65,15,114,242,16                // pslld         $0x10,%xmm10
  .byte  102,65,15,114,226,16                // psrad         $0x10,%xmm10
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,114,226,16                   // psrad         $0x10,%xmm2
  .byte  102,65,15,107,210                   // packssdw      %xmm10,%xmm2
  .byte  102,65,15,219,209                   // pand          %xmm9,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gather_bgra_sse2_lowp
.globl _sk_gather_bgra_sse2_lowp
FUNCTION(_sk_gather_bgra_sse2_lowp)
_sk_gather_bgra_sse2_lowp:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  65,15,95,194                        // maxps         %xmm10,%xmm0
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  243,68,15,16,64,16                  // movss         0x10(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  65,15,95,218                        // maxps         %xmm10,%xmm3
  .byte  65,15,95,210                        // maxps         %xmm10,%xmm2
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  243,68,15,91,195                    // cvttps2dq     %xmm3,%xmm8
  .byte  243,68,15,91,202                    // cvttps2dq     %xmm2,%xmm9
  .byte  102,15,110,88,8                     // movd          0x8(%rax),%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  102,69,15,112,209,245               // pshufd        $0xf5,%xmm9,%xmm10
  .byte  102,68,15,244,211                   // pmuludq       %xmm3,%xmm10
  .byte  102,68,15,111,219                   // movdqa        %xmm3,%xmm11
  .byte  102,69,15,112,224,245               // pshufd        $0xf5,%xmm8,%xmm12
  .byte  102,68,15,244,227                   // pmuludq       %xmm3,%xmm12
  .byte  102,65,15,244,217                   // pmuludq       %xmm9,%xmm3
  .byte  72,139,0                            // mov           (%rax),%rax
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  102,65,15,112,210,232               // pshufd        $0xe8,%xmm10,%xmm2
  .byte  102,15,98,218                       // punpckldq     %xmm2,%xmm3
  .byte  102,69,15,244,216                   // pmuludq       %xmm8,%xmm11
  .byte  102,69,15,112,195,232               // pshufd        $0xe8,%xmm11,%xmm8
  .byte  102,65,15,112,212,232               // pshufd        $0xe8,%xmm12,%xmm2
  .byte  102,68,15,98,194                    // punpckldq     %xmm2,%xmm8
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,65,15,254,200                   // paddd         %xmm8,%xmm1
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,73,15,126,208                   // movq          %xmm2,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  102,73,15,126,202                   // movq          %xmm1,%r10
  .byte  69,137,211                          // mov           %r10d,%r11d
  .byte  73,193,234,32                       // shr           $0x20,%r10
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,72,15,126,203                   // movq          %xmm1,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,73,15,126,199                   // movq          %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  102,66,15,110,4,184                 // movd          (%rax,%r15,4),%xmm0
  .byte  102,66,15,110,28,160                // movd          (%rax,%r12,4),%xmm3
  .byte  102,15,98,216                       // punpckldq     %xmm0,%xmm3
  .byte  102,15,110,4,152                    // movd          (%rax,%rbx,4),%xmm0
  .byte  102,66,15,110,12,176                // movd          (%rax,%r14,4),%xmm1
  .byte  102,15,98,200                       // punpckldq     %xmm0,%xmm1
  .byte  102,15,108,217                      // punpcklqdq    %xmm1,%xmm3
  .byte  102,66,15,110,4,144                 // movd          (%rax,%r10,4),%xmm0
  .byte  102,70,15,110,4,152                 // movd          (%rax,%r11,4),%xmm8
  .byte  102,68,15,98,192                    // punpckldq     %xmm0,%xmm8
  .byte  102,66,15,110,4,128                 // movd          (%rax,%r8,4),%xmm0
  .byte  102,66,15,110,12,136                // movd          (%rax,%r9,4),%xmm1
  .byte  102,15,98,200                       // punpckldq     %xmm0,%xmm1
  .byte  102,68,15,108,193                   // punpcklqdq    %xmm1,%xmm8
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,114,241,16                   // pslld         $0x10,%xmm1
  .byte  102,15,114,225,16                   // psrad         $0x10,%xmm1
  .byte  102,15,107,200                      // packssdw      %xmm0,%xmm1
  .byte  102,68,15,111,13,89,53,0,0          // movdqa        0x3559(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,65,15,219,209                   // pand          %xmm9,%xmm2
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,114,208,16                   // psrld         $0x10,%xmm0
  .byte  102,69,15,111,208                   // movdqa        %xmm8,%xmm10
  .byte  102,65,15,114,210,16                // psrld         $0x10,%xmm10
  .byte  102,65,15,114,208,24                // psrld         $0x18,%xmm8
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,114,224,16                // psrad         $0x10,%xmm8
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  102,15,114,227,16                   // psrad         $0x10,%xmm3
  .byte  102,65,15,107,216                   // packssdw      %xmm8,%xmm3
  .byte  102,65,15,114,242,16                // pslld         $0x10,%xmm10
  .byte  102,65,15,114,226,16                // psrad         $0x10,%xmm10
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,65,15,107,194                   // packssdw      %xmm10,%xmm0
  .byte  102,65,15,219,193                   // pand          %xmm9,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_565_sse2_lowp
.globl _sk_load_565_sse2_lowp
FUNCTION(_sk_load_565_sse2_lowp)
_sk_load_565_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            37646 <_sk_load_565_sse2_lowp+0x3c>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,190,0,0,0                 // lea           0xbe(%rip),%r9        # 376f0 <_sk_load_565_sse2_lowp+0xe6>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  235,66                              // jmp           37688 <_sk_load_565_sse2_lowp+0x7e>
  .byte  243,65,15,111,4,80                  // movdqu        (%r8,%rdx,2),%xmm0
  .byte  235,58                              // jmp           37688 <_sk_load_565_sse2_lowp+0x7e>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,65,15,196,68,80,4,2             // pinsrw        $0x2,0x4(%r8,%rdx,2),%xmm0
  .byte  243,65,15,16,12,80                  // movss         (%r8,%rdx,2),%xmm1
  .byte  243,15,16,193                       // movss         %xmm1,%xmm0
  .byte  235,34                              // jmp           37688 <_sk_load_565_sse2_lowp+0x7e>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,65,15,196,68,80,12,6            // pinsrw        $0x6,0xc(%r8,%rdx,2),%xmm0
  .byte  102,65,15,196,68,80,10,5            // pinsrw        $0x5,0xa(%r8,%rdx,2),%xmm0
  .byte  102,65,15,196,68,80,8,4             // pinsrw        $0x4,0x8(%r8,%rdx,2),%xmm0
  .byte  102,65,15,18,4,80                   // movlpd        (%r8,%rdx,2),%xmm0
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,219,29,7,60,0,0              // pand          0x3c07(%rip),%xmm3        # 3b2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1338>
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,113,209,5                    // psrlw         $0x5,%xmm1
  .byte  102,15,219,13,6,60,0,0              // pand          0x3c06(%rip),%xmm1        # 3b2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1348>
  .byte  102,15,111,21,14,60,0,0             // movdqa        0x3c0e(%rip),%xmm2        # 3b2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1358>
  .byte  102,15,219,208                      // pand          %xmm0,%xmm2
  .byte  102,15,113,208,13                   // psrlw         $0xd,%xmm0
  .byte  102,15,235,195                      // por           %xmm3,%xmm0
  .byte  102,15,111,217                      // movdqa        %xmm1,%xmm3
  .byte  102,15,113,243,2                    // psllw         $0x2,%xmm3
  .byte  102,15,113,209,4                    // psrlw         $0x4,%xmm1
  .byte  102,15,235,203                      // por           %xmm3,%xmm1
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,113,243,3                    // psllw         $0x3,%xmm3
  .byte  102,15,113,210,2                    // psrlw         $0x2,%xmm2
  .byte  102,15,235,211                      // por           %xmm3,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,4,52,0,0                   // movaps        0x3404(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  75,255                              // rex.WXB       (bad)
  .byte  255                                 // (bad)
  .byte  255,106,255                         // ljmp          *-0x1(%rdx)
  .byte  255                                 // (bad)
  .byte  255,94,255                          // lcall         *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,146,255,255,255,138             // callq         *-0x75000001(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,130,255,255,255,118             // incl          0x76ffffff(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_565_dst_sse2_lowp
.globl _sk_load_565_dst_sse2_lowp
FUNCTION(_sk_load_565_dst_sse2_lowp)
_sk_load_565_dst_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            37748 <_sk_load_565_dst_sse2_lowp+0x3c>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,188,0,0,0                 // lea           0xbc(%rip),%r9        # 377f0 <_sk_load_565_dst_sse2_lowp+0xe4>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  235,66                              // jmp           3778a <_sk_load_565_dst_sse2_lowp+0x7e>
  .byte  243,65,15,111,36,80                 // movdqu        (%r8,%rdx,2),%xmm4
  .byte  235,58                              // jmp           3778a <_sk_load_565_dst_sse2_lowp+0x7e>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,65,15,196,100,80,4,2            // pinsrw        $0x2,0x4(%r8,%rdx,2),%xmm4
  .byte  243,65,15,16,44,80                  // movss         (%r8,%rdx,2),%xmm5
  .byte  243,15,16,229                       // movss         %xmm5,%xmm4
  .byte  235,34                              // jmp           3778a <_sk_load_565_dst_sse2_lowp+0x7e>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,65,15,196,100,80,12,6           // pinsrw        $0x6,0xc(%r8,%rdx,2),%xmm4
  .byte  102,65,15,196,100,80,10,5           // pinsrw        $0x5,0xa(%r8,%rdx,2),%xmm4
  .byte  102,65,15,196,100,80,8,4            // pinsrw        $0x4,0x8(%r8,%rdx,2),%xmm4
  .byte  102,65,15,18,36,80                  // movlpd        (%r8,%rdx,2),%xmm4
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,15,113,215,8                    // psrlw         $0x8,%xmm7
  .byte  102,15,219,61,5,59,0,0              // pand          0x3b05(%rip),%xmm7        # 3b2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1338>
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,113,213,5                    // psrlw         $0x5,%xmm5
  .byte  102,15,219,45,4,59,0,0              // pand          0x3b04(%rip),%xmm5        # 3b2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1348>
  .byte  102,15,111,53,12,59,0,0             // movdqa        0x3b0c(%rip),%xmm6        # 3b2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1358>
  .byte  102,15,219,244                      // pand          %xmm4,%xmm6
  .byte  102,15,113,212,13                   // psrlw         $0xd,%xmm4
  .byte  102,15,235,231                      // por           %xmm7,%xmm4
  .byte  102,15,111,253                      // movdqa        %xmm5,%xmm7
  .byte  102,15,113,247,2                    // psllw         $0x2,%xmm7
  .byte  102,15,113,213,4                    // psrlw         $0x4,%xmm5
  .byte  102,15,235,239                      // por           %xmm7,%xmm5
  .byte  102,15,111,254                      // movdqa        %xmm6,%xmm7
  .byte  102,15,113,247,3                    // psllw         $0x3,%xmm7
  .byte  102,15,113,214,2                    // psrlw         $0x2,%xmm6
  .byte  102,15,235,247                      // por           %xmm7,%xmm6
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,61,2,51,0,0                   // movaps        0x3302(%rip),%xmm7        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  255,224                             // jmpq          *%rax
  .byte  77,255                              // rex.WRB       (bad)
  .byte  255                                 // (bad)
  .byte  255,108,255,255                     // ljmp          *-0x1(%rdi,%rdi,8)
  .byte  255,96,255                          // jmpq          *-0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,148,255,255,255,140,255         // callq         *-0x730001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,132,255,255,255,120,255         // incl          -0x870001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_565_sse2_lowp
.globl _sk_store_565_sse2_lowp
FUNCTION(_sk_store_565_sse2_lowp)
_sk_store_565_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  102,65,15,113,240,8                 // psllw         $0x8,%xmm8
  .byte  102,68,15,219,5,160,58,0,0          // pand          0x3aa0(%rip),%xmm8        # 3b2d0 <_sk_srcover_bgra_8888_sse2_lowp+0x1368>
  .byte  102,68,15,111,201                   // movdqa        %xmm1,%xmm9
  .byte  102,65,15,113,241,3                 // psllw         $0x3,%xmm9
  .byte  102,68,15,219,13,156,58,0,0         // pand          0x3a9c(%rip),%xmm9        # 3b2e0 <_sk_srcover_bgra_8888_sse2_lowp+0x1378>
  .byte  102,69,15,235,200                   // por           %xmm8,%xmm9
  .byte  102,68,15,111,194                   // movdqa        %xmm2,%xmm8
  .byte  102,65,15,113,208,3                 // psrlw         $0x3,%xmm8
  .byte  102,69,15,235,193                   // por           %xmm9,%xmm8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,31                              // ja            37882 <_sk_store_565_sse2_lowp+0x76>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,95,0,0,0                  // lea           0x5f(%rip),%r9        # 378cc <_sk_store_565_sse2_lowp+0xc0>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,68,15,126,192                   // movd          %xmm8,%eax
  .byte  102,65,137,4,80                     // mov           %ax,(%r8,%rdx,2)
  .byte  235,70                              // jmp           378c8 <_sk_store_565_sse2_lowp+0xbc>
  .byte  243,69,15,127,4,80                  // movdqu        %xmm8,(%r8,%rdx,2)
  .byte  235,62                              // jmp           378c8 <_sk_store_565_sse2_lowp+0xbc>
  .byte  102,65,15,197,192,2                 // pextrw        $0x2,%xmm8,%eax
  .byte  102,65,137,68,80,4                  // mov           %ax,0x4(%r8,%rdx,2)
  .byte  102,69,15,126,4,80                  // movd          %xmm8,(%r8,%rdx,2)
  .byte  235,42                              // jmp           378c8 <_sk_store_565_sse2_lowp+0xbc>
  .byte  102,65,15,197,192,6                 // pextrw        $0x6,%xmm8,%eax
  .byte  102,65,137,68,80,12                 // mov           %ax,0xc(%r8,%rdx,2)
  .byte  102,65,15,197,192,5                 // pextrw        $0x5,%xmm8,%eax
  .byte  102,65,137,68,80,10                 // mov           %ax,0xa(%r8,%rdx,2)
  .byte  102,65,15,197,192,4                 // pextrw        $0x4,%xmm8,%eax
  .byte  102,65,137,68,80,8                  // mov           %ax,0x8(%r8,%rdx,2)
  .byte  102,69,15,214,4,80                  // movq          %xmm8,(%r8,%rdx,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,202                             // dec           %edx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  190,255,255,255,246                 // mov           $0xf6ffffff,%esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  234                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  222,255                             // fdivrp        %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,210                             // callq         *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_565_sse2_lowp
.globl _sk_gather_565_sse2_lowp
FUNCTION(_sk_gather_565_sse2_lowp)
_sk_gather_565_sse2_lowp:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,95,194                        // maxps         %xmm10,%xmm0
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  243,68,15,16,64,16                  // movss         0x10(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  65,15,95,210                        // maxps         %xmm10,%xmm2
  .byte  65,15,95,218                        // maxps         %xmm10,%xmm3
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  243,68,15,91,194                    // cvttps2dq     %xmm2,%xmm8
  .byte  243,68,15,91,203                    // cvttps2dq     %xmm3,%xmm9
  .byte  102,15,110,80,8                     // movd          0x8(%rax),%xmm2
  .byte  102,15,112,210,0                    // pshufd        $0x0,%xmm2,%xmm2
  .byte  102,69,15,112,209,245               // pshufd        $0xf5,%xmm9,%xmm10
  .byte  102,68,15,244,210                   // pmuludq       %xmm2,%xmm10
  .byte  102,68,15,111,218                   // movdqa        %xmm2,%xmm11
  .byte  102,69,15,112,224,245               // pshufd        $0xf5,%xmm8,%xmm12
  .byte  102,68,15,244,226                   // pmuludq       %xmm2,%xmm12
  .byte  102,65,15,244,209                   // pmuludq       %xmm9,%xmm2
  .byte  76,139,16                           // mov           (%rax),%r10
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,65,15,112,218,232               // pshufd        $0xe8,%xmm10,%xmm3
  .byte  102,15,98,211                       // punpckldq     %xmm3,%xmm2
  .byte  102,69,15,244,216                   // pmuludq       %xmm8,%xmm11
  .byte  102,69,15,112,195,232               // pshufd        $0xe8,%xmm11,%xmm8
  .byte  102,65,15,112,220,232               // pshufd        $0xe8,%xmm12,%xmm3
  .byte  102,68,15,98,195                    // punpckldq     %xmm3,%xmm8
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,15,254,202                      // paddd         %xmm2,%xmm1
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,65,15,254,192                   // paddd         %xmm8,%xmm0
  .byte  102,15,112,208,78                   // pshufd        $0x4e,%xmm0,%xmm2
  .byte  102,73,15,126,208                   // movq          %xmm2,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,195                          // mov           %eax,%r11d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,72,15,126,195                   // movq          %xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,73,15,126,207                   // movq          %xmm1,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  67,15,183,44,122                    // movzwl        (%r10,%r15,2),%ebp
  .byte  102,15,110,197                      // movd          %ebp,%xmm0
  .byte  67,15,183,44,98                     // movzwl        (%r10,%r12,2),%ebp
  .byte  102,15,110,205                      // movd          %ebp,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  65,15,183,28,90                     // movzwl        (%r10,%rbx,2),%ebx
  .byte  102,15,110,195                      // movd          %ebx,%xmm0
  .byte  67,15,183,28,114                    // movzwl        (%r10,%r14,2),%ebx
  .byte  102,15,110,211                      // movd          %ebx,%xmm2
  .byte  102,15,97,208                       // punpcklwd     %xmm0,%xmm2
  .byte  102,15,98,202                       // punpckldq     %xmm2,%xmm1
  .byte  65,15,183,4,66                      // movzwl        (%r10,%rax,2),%eax
  .byte  102,15,110,208                      // movd          %eax,%xmm2
  .byte  67,15,183,4,90                      // movzwl        (%r10,%r11,2),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,15,97,194                       // punpcklwd     %xmm2,%xmm0
  .byte  67,15,183,4,66                      // movzwl        (%r10,%r8,2),%eax
  .byte  102,15,110,208                      // movd          %eax,%xmm2
  .byte  67,15,183,4,74                      // movzwl        (%r10,%r9,2),%eax
  .byte  102,15,110,216                      // movd          %eax,%xmm3
  .byte  102,15,97,218                       // punpcklwd     %xmm2,%xmm3
  .byte  102,15,98,195                       // punpckldq     %xmm3,%xmm0
  .byte  102,15,108,193                      // punpcklqdq    %xmm1,%xmm0
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,219,29,73,56,0,0             // pand          0x3849(%rip),%xmm3        # 3b2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1338>
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,113,209,5                    // psrlw         $0x5,%xmm1
  .byte  102,15,219,13,72,56,0,0             // pand          0x3848(%rip),%xmm1        # 3b2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1348>
  .byte  102,15,111,21,80,56,0,0             // movdqa        0x3850(%rip),%xmm2        # 3b2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1358>
  .byte  102,15,219,208                      // pand          %xmm0,%xmm2
  .byte  102,15,113,208,13                   // psrlw         $0xd,%xmm0
  .byte  102,15,235,195                      // por           %xmm3,%xmm0
  .byte  102,15,111,217                      // movdqa        %xmm1,%xmm3
  .byte  102,15,113,243,2                    // psllw         $0x2,%xmm3
  .byte  102,15,113,209,4                    // psrlw         $0x4,%xmm1
  .byte  102,15,235,203                      // por           %xmm3,%xmm1
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,113,243,3                    // psllw         $0x3,%xmm3
  .byte  102,15,113,210,2                    // psrlw         $0x2,%xmm2
  .byte  102,15,235,211                      // por           %xmm3,%xmm2
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,70,48,0,0                  // movaps        0x3046(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_4444_sse2_lowp
.globl _sk_load_4444_sse2_lowp
FUNCTION(_sk_load_4444_sse2_lowp)
_sk_load_4444_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,36                              // ja            37af2 <_sk_load_4444_sse2_lowp+0x3e>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,199,0,0,0                 // lea           0xc7(%rip),%r9        # 37ba4 <_sk_load_4444_sse2_lowp+0xf0>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  235,69                              // jmp           37b37 <_sk_load_4444_sse2_lowp+0x83>
  .byte  243,69,15,111,4,80                  // movdqu        (%r8,%rdx,2),%xmm8
  .byte  235,61                              // jmp           37b37 <_sk_load_4444_sse2_lowp+0x83>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,69,15,196,68,80,4,2             // pinsrw        $0x2,0x4(%r8,%rdx,2),%xmm8
  .byte  243,65,15,16,4,80                   // movss         (%r8,%rdx,2),%xmm0
  .byte  243,68,15,16,192                    // movss         %xmm0,%xmm8
  .byte  235,35                              // jmp           37b37 <_sk_load_4444_sse2_lowp+0x83>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,69,15,196,68,80,12,6            // pinsrw        $0x6,0xc(%r8,%rdx,2),%xmm8
  .byte  102,69,15,196,68,80,10,5            // pinsrw        $0x5,0xa(%r8,%rdx,2),%xmm8
  .byte  102,69,15,196,68,80,8,4             // pinsrw        $0x4,0x8(%r8,%rdx,2),%xmm8
  .byte  102,69,15,18,4,80                   // movlpd        (%r8,%rdx,2),%xmm8
  .byte  102,65,15,111,200                   // movdqa        %xmm8,%xmm1
  .byte  102,15,113,209,12                   // psrlw         $0xc,%xmm1
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,111,5,157,55,0,0             // movdqa        0x379d(%rip),%xmm0        # 3b2f0 <_sk_srcover_bgra_8888_sse2_lowp+0x1388>
  .byte  102,15,219,208                      // pand          %xmm0,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,113,211,4                    // psrlw         $0x4,%xmm3
  .byte  102,15,219,216                      // pand          %xmm0,%xmm3
  .byte  102,68,15,219,192                   // pand          %xmm0,%xmm8
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,113,240,4                    // psllw         $0x4,%xmm0
  .byte  102,15,235,193                      // por           %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,113,241,4                    // psllw         $0x4,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,113,242,4                    // psllw         $0x4,%xmm2
  .byte  102,15,235,211                      // por           %xmm3,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,113,243,4                    // psllw         $0x4,%xmm3
  .byte  102,65,15,235,216                   // por           %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  66,255                              // rex.X         (bad)
  .byte  255                                 // (bad)
  .byte  255,99,255                          // jmpq          *-0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,86,255                          // callq         *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,141,255,255,255,133             // decl          -0x7a000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  125,255                             // jge           37bb9 <_sk_load_4444_sse2_lowp+0x105>
  .byte  255                                 // (bad)
  .byte  255,112,255                         // pushq         -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_4444_dst_sse2_lowp
.globl _sk_load_4444_dst_sse2_lowp
FUNCTION(_sk_load_4444_dst_sse2_lowp)
_sk_load_4444_dst_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,36                              // ja            37bfe <_sk_load_4444_dst_sse2_lowp+0x3e>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,199,0,0,0                 // lea           0xc7(%rip),%r9        # 37cb0 <_sk_load_4444_dst_sse2_lowp+0xf0>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  235,69                              // jmp           37c43 <_sk_load_4444_dst_sse2_lowp+0x83>
  .byte  243,69,15,111,4,80                  // movdqu        (%r8,%rdx,2),%xmm8
  .byte  235,61                              // jmp           37c43 <_sk_load_4444_dst_sse2_lowp+0x83>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,69,15,196,68,80,4,2             // pinsrw        $0x2,0x4(%r8,%rdx,2),%xmm8
  .byte  243,65,15,16,36,80                  // movss         (%r8,%rdx,2),%xmm4
  .byte  243,68,15,16,196                    // movss         %xmm4,%xmm8
  .byte  235,35                              // jmp           37c43 <_sk_load_4444_dst_sse2_lowp+0x83>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,69,15,196,68,80,12,6            // pinsrw        $0x6,0xc(%r8,%rdx,2),%xmm8
  .byte  102,69,15,196,68,80,10,5            // pinsrw        $0x5,0xa(%r8,%rdx,2),%xmm8
  .byte  102,69,15,196,68,80,8,4             // pinsrw        $0x4,0x8(%r8,%rdx,2),%xmm8
  .byte  102,69,15,18,4,80                   // movlpd        (%r8,%rdx,2),%xmm8
  .byte  102,65,15,111,232                   // movdqa        %xmm8,%xmm5
  .byte  102,15,113,213,12                   // psrlw         $0xc,%xmm5
  .byte  102,65,15,111,240                   // movdqa        %xmm8,%xmm6
  .byte  102,15,113,214,8                    // psrlw         $0x8,%xmm6
  .byte  102,15,111,37,145,54,0,0            // movdqa        0x3691(%rip),%xmm4        # 3b2f0 <_sk_srcover_bgra_8888_sse2_lowp+0x1388>
  .byte  102,15,219,244                      // pand          %xmm4,%xmm6
  .byte  102,65,15,111,248                   // movdqa        %xmm8,%xmm7
  .byte  102,15,113,215,4                    // psrlw         $0x4,%xmm7
  .byte  102,15,219,252                      // pand          %xmm4,%xmm7
  .byte  102,68,15,219,196                   // pand          %xmm4,%xmm8
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,113,244,4                    // psllw         $0x4,%xmm4
  .byte  102,15,235,229                      // por           %xmm5,%xmm4
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,15,113,245,4                    // psllw         $0x4,%xmm5
  .byte  102,15,235,238                      // por           %xmm6,%xmm5
  .byte  102,15,111,247                      // movdqa        %xmm7,%xmm6
  .byte  102,15,113,246,4                    // psllw         $0x4,%xmm6
  .byte  102,15,235,247                      // por           %xmm7,%xmm6
  .byte  102,65,15,111,248                   // movdqa        %xmm8,%xmm7
  .byte  102,15,113,247,4                    // psllw         $0x4,%xmm7
  .byte  102,65,15,235,248                   // por           %xmm8,%xmm7
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  66,255                              // rex.X         (bad)
  .byte  255                                 // (bad)
  .byte  255,99,255                          // jmpq          *-0x1(%rbx)
  .byte  255                                 // (bad)
  .byte  255,86,255                          // callq         *-0x1(%rsi)
  .byte  255                                 // (bad)
  .byte  255,141,255,255,255,133             // decl          -0x7a000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  125,255                             // jge           37cc5 <_sk_load_4444_dst_sse2_lowp+0x105>
  .byte  255                                 // (bad)
  .byte  255,112,255                         // pushq         -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_4444_sse2_lowp
.globl _sk_store_4444_sse2_lowp
FUNCTION(_sk_store_4444_sse2_lowp)
_sk_store_4444_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  102,68,15,111,192                   // movdqa        %xmm0,%xmm8
  .byte  102,65,15,113,240,8                 // psllw         $0x8,%xmm8
  .byte  102,68,15,219,5,16,54,0,0           // pand          0x3610(%rip),%xmm8        # 3b300 <_sk_srcover_bgra_8888_sse2_lowp+0x1398>
  .byte  102,68,15,111,201                   // movdqa        %xmm1,%xmm9
  .byte  102,65,15,113,241,4                 // psllw         $0x4,%xmm9
  .byte  102,68,15,219,13,12,54,0,0          // pand          0x360c(%rip),%xmm9        # 3b310 <_sk_srcover_bgra_8888_sse2_lowp+0x13a8>
  .byte  102,69,15,235,200                   // por           %xmm8,%xmm9
  .byte  102,68,15,111,21,14,54,0,0          // movdqa        0x360e(%rip),%xmm10        # 3b320 <_sk_srcover_bgra_8888_sse2_lowp+0x13b8>
  .byte  102,68,15,219,210                   // pand          %xmm2,%xmm10
  .byte  102,68,15,111,195                   // movdqa        %xmm3,%xmm8
  .byte  102,65,15,113,208,4                 // psrlw         $0x4,%xmm8
  .byte  102,69,15,235,194                   // por           %xmm10,%xmm8
  .byte  102,69,15,235,193                   // por           %xmm9,%xmm8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,31                              // ja            37d55 <_sk_store_4444_sse2_lowp+0x89>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,96,0,0,0                  // lea           0x60(%rip),%r9        # 37da0 <_sk_store_4444_sse2_lowp+0xd4>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,68,15,126,192                   // movd          %xmm8,%eax
  .byte  102,65,137,4,80                     // mov           %ax,(%r8,%rdx,2)
  .byte  235,70                              // jmp           37d9b <_sk_store_4444_sse2_lowp+0xcf>
  .byte  243,69,15,127,4,80                  // movdqu        %xmm8,(%r8,%rdx,2)
  .byte  235,62                              // jmp           37d9b <_sk_store_4444_sse2_lowp+0xcf>
  .byte  102,65,15,197,192,2                 // pextrw        $0x2,%xmm8,%eax
  .byte  102,65,137,68,80,4                  // mov           %ax,0x4(%r8,%rdx,2)
  .byte  102,69,15,126,4,80                  // movd          %xmm8,(%r8,%rdx,2)
  .byte  235,42                              // jmp           37d9b <_sk_store_4444_sse2_lowp+0xcf>
  .byte  102,65,15,197,192,6                 // pextrw        $0x6,%xmm8,%eax
  .byte  102,65,137,68,80,12                 // mov           %ax,0xc(%r8,%rdx,2)
  .byte  102,65,15,197,192,5                 // pextrw        $0x5,%xmm8,%eax
  .byte  102,65,137,68,80,10                 // mov           %ax,0xa(%r8,%rdx,2)
  .byte  102,65,15,197,192,4                 // pextrw        $0x4,%xmm8,%eax
  .byte  102,65,137,68,80,8                  // mov           %ax,0x8(%r8,%rdx,2)
  .byte  102,69,15,214,4,80                  // movq          %xmm8,(%r8,%rdx,2)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  144                                 // nop
  .byte  169,255,255,255,201                 // test          $0xc9ffffff,%eax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  189,255,255,255,245                 // mov           $0xf5ffffff,%ebp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  233,255,255,255,221                 // jmpq          ffffffffde037db4 <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffddffde4c>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,209                             // callq         *%rcx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_4444_sse2_lowp
.globl _sk_gather_4444_sse2_lowp
FUNCTION(_sk_gather_4444_sse2_lowp)
_sk_gather_4444_sse2_lowp:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,64,12                  // movss         0xc(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,118,201                   // pcmpeqd       %xmm9,%xmm9
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  69,15,87,210                        // xorps         %xmm10,%xmm10
  .byte  65,15,95,202                        // maxps         %xmm10,%xmm1
  .byte  65,15,95,194                        // maxps         %xmm10,%xmm0
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  243,68,15,16,64,16                  // movss         0x10(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  102,69,15,254,193                   // paddd         %xmm9,%xmm8
  .byte  65,15,95,210                        // maxps         %xmm10,%xmm2
  .byte  65,15,95,218                        // maxps         %xmm10,%xmm3
  .byte  65,15,93,216                        // minps         %xmm8,%xmm3
  .byte  65,15,93,208                        // minps         %xmm8,%xmm2
  .byte  243,68,15,91,194                    // cvttps2dq     %xmm2,%xmm8
  .byte  243,68,15,91,203                    // cvttps2dq     %xmm3,%xmm9
  .byte  102,15,110,80,8                     // movd          0x8(%rax),%xmm2
  .byte  102,15,112,210,0                    // pshufd        $0x0,%xmm2,%xmm2
  .byte  102,69,15,112,209,245               // pshufd        $0xf5,%xmm9,%xmm10
  .byte  102,68,15,244,210                   // pmuludq       %xmm2,%xmm10
  .byte  102,68,15,111,218                   // movdqa        %xmm2,%xmm11
  .byte  102,69,15,112,224,245               // pshufd        $0xf5,%xmm8,%xmm12
  .byte  102,68,15,244,226                   // pmuludq       %xmm2,%xmm12
  .byte  102,65,15,244,209                   // pmuludq       %xmm9,%xmm2
  .byte  76,139,16                           // mov           (%rax),%r10
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,65,15,112,218,232               // pshufd        $0xe8,%xmm10,%xmm3
  .byte  102,15,98,211                       // punpckldq     %xmm3,%xmm2
  .byte  102,69,15,244,216                   // pmuludq       %xmm8,%xmm11
  .byte  102,69,15,112,195,232               // pshufd        $0xe8,%xmm11,%xmm8
  .byte  102,65,15,112,220,232               // pshufd        $0xe8,%xmm12,%xmm3
  .byte  102,68,15,98,195                    // punpckldq     %xmm3,%xmm8
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,15,254,202                      // paddd         %xmm2,%xmm1
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,65,15,254,192                   // paddd         %xmm8,%xmm0
  .byte  102,15,112,208,78                   // pshufd        $0x4e,%xmm0,%xmm2
  .byte  102,73,15,126,208                   // movq          %xmm2,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  102,72,15,126,192                   // movq          %xmm0,%rax
  .byte  65,137,195                          // mov           %eax,%r11d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,72,15,126,195                   // movq          %xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,73,15,126,207                   // movq          %xmm1,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  67,15,183,44,122                    // movzwl        (%r10,%r15,2),%ebp
  .byte  102,15,110,197                      // movd          %ebp,%xmm0
  .byte  67,15,183,44,98                     // movzwl        (%r10,%r12,2),%ebp
  .byte  102,15,110,205                      // movd          %ebp,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  65,15,183,28,90                     // movzwl        (%r10,%rbx,2),%ebx
  .byte  102,15,110,195                      // movd          %ebx,%xmm0
  .byte  67,15,183,28,114                    // movzwl        (%r10,%r14,2),%ebx
  .byte  102,15,110,211                      // movd          %ebx,%xmm2
  .byte  102,15,97,208                       // punpcklwd     %xmm0,%xmm2
  .byte  102,15,98,202                       // punpckldq     %xmm2,%xmm1
  .byte  65,15,183,4,66                      // movzwl        (%r10,%rax,2),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  67,15,183,4,90                      // movzwl        (%r10,%r11,2),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  102,68,15,97,192                    // punpcklwd     %xmm0,%xmm8
  .byte  67,15,183,4,66                      // movzwl        (%r10,%r8,2),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  67,15,183,4,74                      // movzwl        (%r10,%r9,2),%eax
  .byte  102,15,110,208                      // movd          %eax,%xmm2
  .byte  102,15,97,208                       // punpcklwd     %xmm0,%xmm2
  .byte  102,68,15,98,194                    // punpckldq     %xmm2,%xmm8
  .byte  102,68,15,108,193                   // punpcklqdq    %xmm1,%xmm8
  .byte  102,65,15,111,200                   // movdqa        %xmm8,%xmm1
  .byte  102,15,113,209,12                   // psrlw         $0xc,%xmm1
  .byte  102,65,15,111,208                   // movdqa        %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,111,5,182,51,0,0             // movdqa        0x33b6(%rip),%xmm0        # 3b2f0 <_sk_srcover_bgra_8888_sse2_lowp+0x1388>
  .byte  102,15,219,208                      // pand          %xmm0,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,113,211,4                    // psrlw         $0x4,%xmm3
  .byte  102,15,219,216                      // pand          %xmm0,%xmm3
  .byte  102,68,15,219,192                   // pand          %xmm0,%xmm8
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,113,240,4                    // psllw         $0x4,%xmm0
  .byte  102,15,235,193                      // por           %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,113,241,4                    // psllw         $0x4,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,113,242,4                    // psllw         $0x4,%xmm2
  .byte  102,15,235,211                      // por           %xmm3,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  102,15,113,243,4                    // psllw         $0x4,%xmm3
  .byte  102,65,15,235,216                   // por           %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_a8_sse2_lowp
.globl _sk_load_a8_sse2_lowp
FUNCTION(_sk_load_a8_sse2_lowp)
_sk_load_a8_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            37fcc <_sk_load_a8_sse2_lowp+0x39>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,140,0,0,0                 // lea           0x8c(%rip),%r9        # 38044 <_sk_load_a8_sse2_lowp+0xb1>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  102,15,110,216                      // movd          %eax,%xmm3
  .byte  235,97                              // jmp           3802d <_sk_load_a8_sse2_lowp+0x9a>
  .byte  243,65,15,126,28,16                 // movq          (%r8,%rdx,1),%xmm3
  .byte  102,15,96,216                       // punpcklbw     %xmm0,%xmm3
  .byte  235,85                              // jmp           3802d <_sk_load_a8_sse2_lowp+0x9a>
  .byte  65,15,182,68,16,2                   // movzbl        0x2(%r8,%rdx,1),%eax
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,196,216,2                    // pinsrw        $0x2,%eax,%xmm3
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  102,15,96,192                       // punpcklbw     %xmm0,%xmm0
  .byte  243,15,16,216                       // movss         %xmm0,%xmm3
  .byte  235,51                              // jmp           3802d <_sk_load_a8_sse2_lowp+0x9a>
  .byte  65,15,182,68,16,6                   // movzbl        0x6(%r8,%rdx,1),%eax
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,196,216,6                    // pinsrw        $0x6,%eax,%xmm3
  .byte  65,15,182,68,16,5                   // movzbl        0x5(%r8,%rdx,1),%eax
  .byte  102,15,196,216,5                    // pinsrw        $0x5,%eax,%xmm3
  .byte  65,15,182,68,16,4                   // movzbl        0x4(%r8,%rdx,1),%eax
  .byte  102,15,196,216,4                    // pinsrw        $0x4,%eax,%xmm3
  .byte  102,65,15,110,4,16                  // movd          (%r8,%rdx,1),%xmm0
  .byte  102,15,96,192                       // punpcklbw     %xmm0,%xmm0
  .byte  242,15,16,216                       // movsd         %xmm0,%xmm3
  .byte  102,15,219,29,187,42,0,0            // pand          0x2abb(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  125,255                             // jge           38045 <_sk_load_a8_sse2_lowp+0xb2>
  .byte  255                                 // (bad)
  .byte  255,163,255,255,255,148             // jmpq          *-0x6b000001(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  219,255                             // (bad)
  .byte  255                                 // (bad)
  .byte  255,208                             // callq         *%rax
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,197                             // inc           %ebp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  182,255                             // mov           $0xff,%dh
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_a8_dst_sse2_lowp
.globl _sk_load_a8_dst_sse2_lowp
FUNCTION(_sk_load_a8_dst_sse2_lowp)
_sk_load_a8_dst_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            38099 <_sk_load_a8_dst_sse2_lowp+0x39>
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,139,0,0,0                 // lea           0x8b(%rip),%r9        # 38110 <_sk_load_a8_dst_sse2_lowp+0xb0>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  102,15,110,248                      // movd          %eax,%xmm7
  .byte  235,97                              // jmp           380fa <_sk_load_a8_dst_sse2_lowp+0x9a>
  .byte  243,65,15,126,60,16                 // movq          (%r8,%rdx,1),%xmm7
  .byte  102,15,96,248                       // punpcklbw     %xmm0,%xmm7
  .byte  235,85                              // jmp           380fa <_sk_load_a8_dst_sse2_lowp+0x9a>
  .byte  65,15,182,68,16,2                   // movzbl        0x2(%r8,%rdx,1),%eax
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  102,15,196,248,2                    // pinsrw        $0x2,%eax,%xmm7
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  243,15,16,252                       // movss         %xmm4,%xmm7
  .byte  235,51                              // jmp           380fa <_sk_load_a8_dst_sse2_lowp+0x9a>
  .byte  65,15,182,68,16,6                   // movzbl        0x6(%r8,%rdx,1),%eax
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  102,15,196,248,6                    // pinsrw        $0x6,%eax,%xmm7
  .byte  65,15,182,68,16,5                   // movzbl        0x5(%r8,%rdx,1),%eax
  .byte  102,15,196,248,5                    // pinsrw        $0x5,%eax,%xmm7
  .byte  65,15,182,68,16,4                   // movzbl        0x4(%r8,%rdx,1),%eax
  .byte  102,15,196,248,4                    // pinsrw        $0x4,%eax,%xmm7
  .byte  102,65,15,110,36,16                 // movd          (%r8,%rdx,1),%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  242,15,16,252                       // movsd         %xmm4,%xmm7
  .byte  102,15,219,61,238,41,0,0            // pand          0x29ee(%rip),%xmm7        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  255,224                             // jmpq          *%rax
  .byte  144                                 // nop
  .byte  126,255                             // jle           38111 <_sk_load_a8_dst_sse2_lowp+0xb1>
  .byte  255                                 // (bad)
  .byte  255,164,255,255,255,149,255         // jmpq          *-0x6a0001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  220,255                             // fdivr         %st,%st(7)
  .byte  255                                 // (bad)
  .byte  255,209                             // callq         *%rcx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,198                             // inc           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  183,255                             // mov           $0xff,%bh
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_store_a8_sse2_lowp
.globl _sk_store_a8_sse2_lowp
FUNCTION(_sk_store_a8_sse2_lowp)
_sk_store_a8_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,29                              // ja            38160 <_sk_store_a8_sse2_lowp+0x34>
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,147,0,0,0                 // lea           0x93(%rip),%r9        # 381e0 <_sk_store_a8_sse2_lowp+0xb4>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  65,136,4,16                         // mov           %al,(%r8,%rdx,1)
  .byte  235,123                             // jmp           381db <_sk_store_a8_sse2_lowp+0xaf>
  .byte  102,68,15,111,5,135,41,0,0          // movdqa        0x2987(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,68,15,219,195                   // pand          %xmm3,%xmm8
  .byte  102,69,15,103,192                   // packuswb      %xmm8,%xmm8
  .byte  102,69,15,214,4,16                  // movq          %xmm8,(%r8,%rdx,1)
  .byte  235,96                              // jmp           381db <_sk_store_a8_sse2_lowp+0xaf>
  .byte  102,15,197,195,2                    // pextrw        $0x2,%xmm3,%eax
  .byte  65,136,68,16,2                      // mov           %al,0x2(%r8,%rdx,1)
  .byte  102,68,15,111,5,98,41,0,0           // movdqa        0x2962(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,68,15,219,195                   // pand          %xmm3,%xmm8
  .byte  102,69,15,103,192                   // packuswb      %xmm8,%xmm8
  .byte  102,68,15,126,192                   // movd          %xmm8,%eax
  .byte  102,65,137,4,16                     // mov           %ax,(%r8,%rdx,1)
  .byte  235,55                              // jmp           381db <_sk_store_a8_sse2_lowp+0xaf>
  .byte  102,15,197,195,6                    // pextrw        $0x6,%xmm3,%eax
  .byte  65,136,68,16,6                      // mov           %al,0x6(%r8,%rdx,1)
  .byte  102,15,197,195,5                    // pextrw        $0x5,%xmm3,%eax
  .byte  65,136,68,16,5                      // mov           %al,0x5(%r8,%rdx,1)
  .byte  102,15,197,195,4                    // pextrw        $0x4,%xmm3,%eax
  .byte  65,136,68,16,4                      // mov           %al,0x4(%r8,%rdx,1)
  .byte  102,68,15,111,5,37,41,0,0           // movdqa        0x2925(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,68,15,219,195                   // pand          %xmm3,%xmm8
  .byte  102,69,15,103,192                   // packuswb      %xmm8,%xmm8
  .byte  102,69,15,126,4,16                  // movd          %xmm8,(%r8,%rdx,1)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  144                                 // nop
  .byte  118,255                             // jbe           381e1 <_sk_store_a8_sse2_lowp+0xb5>
  .byte  255                                 // (bad)
  .byte  255,165,255,255,255,155             // jmpq          *-0x64000001(%rbp)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,226                             // jmpq          *%rdx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  216,255                             // fdivr         %st(7),%st
  .byte  255                                 // (bad)
  .byte  255,206                             // dec           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,196                             // inc           %esp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_gather_a8_sse2_lowp
.globl _sk_gather_a8_sse2_lowp
FUNCTION(_sk_gather_a8_sse2_lowp)
_sk_gather_a8_sse2_lowp:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,72,12                  // movss         0xc(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  102,69,15,118,210                   // pcmpeqd       %xmm10,%xmm10
  .byte  102,69,15,254,202                   // paddd         %xmm10,%xmm9
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  65,15,95,192                        // maxps         %xmm8,%xmm0
  .byte  65,15,95,200                        // maxps         %xmm8,%xmm1
  .byte  65,15,93,201                        // minps         %xmm9,%xmm1
  .byte  65,15,93,193                        // minps         %xmm9,%xmm0
  .byte  243,68,15,16,72,16                  // movss         0x10(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  102,69,15,254,202                   // paddd         %xmm10,%xmm9
  .byte  65,15,95,216                        // maxps         %xmm8,%xmm3
  .byte  65,15,95,208                        // maxps         %xmm8,%xmm2
  .byte  65,15,93,209                        // minps         %xmm9,%xmm2
  .byte  65,15,93,217                        // minps         %xmm9,%xmm3
  .byte  243,68,15,91,203                    // cvttps2dq     %xmm3,%xmm9
  .byte  243,68,15,91,210                    // cvttps2dq     %xmm2,%xmm10
  .byte  102,15,110,88,8                     // movd          0x8(%rax),%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  102,69,15,112,218,245               // pshufd        $0xf5,%xmm10,%xmm11
  .byte  102,68,15,244,219                   // pmuludq       %xmm3,%xmm11
  .byte  102,68,15,111,227                   // movdqa        %xmm3,%xmm12
  .byte  102,69,15,112,233,245               // pshufd        $0xf5,%xmm9,%xmm13
  .byte  102,68,15,244,235                   // pmuludq       %xmm3,%xmm13
  .byte  102,65,15,244,218                   // pmuludq       %xmm10,%xmm3
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  102,65,15,112,211,232               // pshufd        $0xe8,%xmm11,%xmm2
  .byte  102,15,98,218                       // punpckldq     %xmm2,%xmm3
  .byte  76,139,16                           // mov           (%rax),%r10
  .byte  102,69,15,244,225                   // pmuludq       %xmm9,%xmm12
  .byte  102,69,15,112,204,232               // pshufd        $0xe8,%xmm12,%xmm9
  .byte  102,65,15,112,213,232               // pshufd        $0xe8,%xmm13,%xmm2
  .byte  102,68,15,98,202                    // punpckldq     %xmm2,%xmm9
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,65,15,254,201                   // paddd         %xmm9,%xmm1
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,73,15,126,208                   // movq          %xmm2,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,195                          // mov           %eax,%r11d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,72,15,126,195                   // movq          %xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,15,112,192,78                   // pshufd        $0x4e,%xmm0,%xmm0
  .byte  102,73,15,126,199                   // movq          %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,182,36,34                     // movzbl        (%r10,%r12,1),%r12d
  .byte  67,15,182,44,58                     // movzbl        (%r10,%r15,1),%ebp
  .byte  193,229,8                           // shl           $0x8,%ebp
  .byte  68,9,229                            // or            %r12d,%ebp
  .byte  71,15,182,52,50                     // movzbl        (%r10,%r14,1),%r14d
  .byte  65,15,182,28,26                     // movzbl        (%r10,%rbx,1),%ebx
  .byte  193,227,8                           // shl           $0x8,%ebx
  .byte  68,9,243                            // or            %r14d,%ebx
  .byte  102,15,110,219                      // movd          %ebx,%xmm3
  .byte  102,15,196,221,1                    // pinsrw        $0x1,%ebp,%xmm3
  .byte  67,15,182,44,26                     // movzbl        (%r10,%r11,1),%ebp
  .byte  65,15,182,4,2                       // movzbl        (%r10,%rax,1),%eax
  .byte  193,224,8                           // shl           $0x8,%eax
  .byte  9,232                               // or            %ebp,%eax
  .byte  102,15,196,216,2                    // pinsrw        $0x2,%eax,%xmm3
  .byte  67,15,182,4,10                      // movzbl        (%r10,%r9,1),%eax
  .byte  67,15,182,44,2                      // movzbl        (%r10,%r8,1),%ebp
  .byte  193,229,8                           // shl           $0x8,%ebp
  .byte  9,197                               // or            %eax,%ebp
  .byte  102,15,196,221,3                    // pinsrw        $0x3,%ebp,%xmm3
  .byte  102,65,15,96,216                    // punpcklbw     %xmm8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_load_g8_sse2_lowp
.globl _sk_load_g8_sse2_lowp
FUNCTION(_sk_load_g8_sse2_lowp)
_sk_load_g8_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            3839d <_sk_load_g8_sse2_lowp+0x39>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,147,0,0,0                 // lea           0x93(%rip),%r9        # 3841c <_sk_load_g8_sse2_lowp+0xb8>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  102,15,110,192                      // movd          %eax,%xmm0
  .byte  235,97                              // jmp           383fe <_sk_load_g8_sse2_lowp+0x9a>
  .byte  243,65,15,126,4,16                  // movq          (%r8,%rdx,1),%xmm0
  .byte  102,15,96,192                       // punpcklbw     %xmm0,%xmm0
  .byte  235,85                              // jmp           383fe <_sk_load_g8_sse2_lowp+0x9a>
  .byte  65,15,182,68,16,2                   // movzbl        0x2(%r8,%rdx,1),%eax
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,196,192,2                    // pinsrw        $0x2,%eax,%xmm0
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  102,15,110,200                      // movd          %eax,%xmm1
  .byte  102,15,96,200                       // punpcklbw     %xmm0,%xmm1
  .byte  243,15,16,193                       // movss         %xmm1,%xmm0
  .byte  235,51                              // jmp           383fe <_sk_load_g8_sse2_lowp+0x9a>
  .byte  65,15,182,68,16,6                   // movzbl        0x6(%r8,%rdx,1),%eax
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,196,192,6                    // pinsrw        $0x6,%eax,%xmm0
  .byte  65,15,182,68,16,5                   // movzbl        0x5(%r8,%rdx,1),%eax
  .byte  102,15,196,192,5                    // pinsrw        $0x5,%eax,%xmm0
  .byte  65,15,182,68,16,4                   // movzbl        0x4(%r8,%rdx,1),%eax
  .byte  102,15,196,192,4                    // pinsrw        $0x4,%eax,%xmm0
  .byte  102,65,15,110,12,16                 // movd          (%r8,%rdx,1),%xmm1
  .byte  102,15,96,200                       // punpcklbw     %xmm0,%xmm1
  .byte  242,15,16,193                       // movsd         %xmm1,%xmm0
  .byte  102,15,219,5,234,38,0,0             // pand          0x26ea(%rip),%xmm0        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,225,38,0,0                 // movaps        0x26e1(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  118,255                             // jbe           3841d <_sk_load_g8_sse2_lowp+0xb9>
  .byte  255                                 // (bad)
  .byte  255,156,255,255,255,141,255         // lcall         *-0x720001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,212                             // callq         *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,201                             // dec           %ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  190,255,255,255,175                 // mov           $0xafffffff,%esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_load_g8_dst_sse2_lowp
.globl _sk_load_g8_dst_sse2_lowp
FUNCTION(_sk_load_g8_dst_sse2_lowp)
_sk_load_g8_dst_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            38471 <_sk_load_g8_dst_sse2_lowp+0x39>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,147,0,0,0                 // lea           0x93(%rip),%r9        # 384f0 <_sk_load_g8_dst_sse2_lowp+0xb8>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  235,97                              // jmp           384d2 <_sk_load_g8_dst_sse2_lowp+0x9a>
  .byte  243,65,15,126,36,16                 // movq          (%r8,%rdx,1),%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  235,85                              // jmp           384d2 <_sk_load_g8_dst_sse2_lowp+0x9a>
  .byte  65,15,182,68,16,2                   // movzbl        0x2(%r8,%rdx,1),%eax
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,224,2                    // pinsrw        $0x2,%eax,%xmm4
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  102,15,110,232                      // movd          %eax,%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  243,15,16,229                       // movss         %xmm5,%xmm4
  .byte  235,51                              // jmp           384d2 <_sk_load_g8_dst_sse2_lowp+0x9a>
  .byte  65,15,182,68,16,6                   // movzbl        0x6(%r8,%rdx,1),%eax
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,224,6                    // pinsrw        $0x6,%eax,%xmm4
  .byte  65,15,182,68,16,5                   // movzbl        0x5(%r8,%rdx,1),%eax
  .byte  102,15,196,224,5                    // pinsrw        $0x5,%eax,%xmm4
  .byte  65,15,182,68,16,4                   // movzbl        0x4(%r8,%rdx,1),%eax
  .byte  102,15,196,224,4                    // pinsrw        $0x4,%eax,%xmm4
  .byte  102,65,15,110,44,16                 // movd          (%r8,%rdx,1),%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  242,15,16,229                       // movsd         %xmm5,%xmm4
  .byte  102,15,219,37,22,38,0,0             // pand          0x2616(%rip),%xmm4        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,61,13,38,0,0                  // movaps        0x260d(%rip),%xmm7        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  118,255                             // jbe           384f1 <_sk_load_g8_dst_sse2_lowp+0xb9>
  .byte  255                                 // (bad)
  .byte  255,156,255,255,255,141,255         // lcall         *-0x720001(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,212                             // callq         *%rsp
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,201                             // dec           %ecx
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  190,255,255,255,175                 // mov           $0xafffffff,%esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_luminance_to_alpha_sse2_lowp
.globl _sk_luminance_to_alpha_sse2_lowp
FUNCTION(_sk_luminance_to_alpha_sse2_lowp)
_sk_luminance_to_alpha_sse2_lowp:
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,213,5,24,46,0,0              // pmullw        0x2e18(%rip),%xmm0        # 3b330 <_sk_srcover_bgra_8888_sse2_lowp+0x13c8>
  .byte  102,15,213,13,32,46,0,0             // pmullw        0x2e20(%rip),%xmm1        # 3b340 <_sk_srcover_bgra_8888_sse2_lowp+0x13d8>
  .byte  102,15,253,200                      // paddw         %xmm0,%xmm1
  .byte  102,15,213,29,36,46,0,0             // pmullw        0x2e24(%rip),%xmm3        # 3b350 <_sk_srcover_bgra_8888_sse2_lowp+0x13e8>
  .byte  102,15,253,217                      // paddw         %xmm1,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gather_g8_sse2_lowp
.globl _sk_gather_g8_sse2_lowp
FUNCTION(_sk_gather_g8_sse2_lowp)
_sk_gather_g8_sse2_lowp:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,72,12                  // movss         0xc(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  102,69,15,118,210                   // pcmpeqd       %xmm10,%xmm10
  .byte  102,69,15,254,202                   // paddd         %xmm10,%xmm9
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  65,15,95,192                        // maxps         %xmm8,%xmm0
  .byte  65,15,95,200                        // maxps         %xmm8,%xmm1
  .byte  65,15,93,201                        // minps         %xmm9,%xmm1
  .byte  65,15,93,193                        // minps         %xmm9,%xmm0
  .byte  243,68,15,16,72,16                  // movss         0x10(%rax),%xmm9
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  102,69,15,254,202                   // paddd         %xmm10,%xmm9
  .byte  65,15,95,216                        // maxps         %xmm8,%xmm3
  .byte  65,15,95,208                        // maxps         %xmm8,%xmm2
  .byte  65,15,93,209                        // minps         %xmm9,%xmm2
  .byte  65,15,93,217                        // minps         %xmm9,%xmm3
  .byte  243,68,15,91,203                    // cvttps2dq     %xmm3,%xmm9
  .byte  243,68,15,91,210                    // cvttps2dq     %xmm2,%xmm10
  .byte  102,15,110,88,8                     // movd          0x8(%rax),%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  102,69,15,112,218,245               // pshufd        $0xf5,%xmm10,%xmm11
  .byte  102,68,15,244,219                   // pmuludq       %xmm3,%xmm11
  .byte  102,68,15,111,227                   // movdqa        %xmm3,%xmm12
  .byte  102,69,15,112,233,245               // pshufd        $0xf5,%xmm9,%xmm13
  .byte  102,68,15,244,235                   // pmuludq       %xmm3,%xmm13
  .byte  102,65,15,244,218                   // pmuludq       %xmm10,%xmm3
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  102,65,15,112,211,232               // pshufd        $0xe8,%xmm11,%xmm2
  .byte  102,15,98,218                       // punpckldq     %xmm2,%xmm3
  .byte  76,139,16                           // mov           (%rax),%r10
  .byte  102,69,15,244,225                   // pmuludq       %xmm9,%xmm12
  .byte  102,69,15,112,204,232               // pshufd        $0xe8,%xmm12,%xmm9
  .byte  102,65,15,112,213,232               // pshufd        $0xe8,%xmm13,%xmm2
  .byte  102,68,15,98,202                    // punpckldq     %xmm2,%xmm9
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,65,15,254,201                   // paddd         %xmm9,%xmm1
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,73,15,126,208                   // movq          %xmm2,%r8
  .byte  69,137,193                          // mov           %r8d,%r9d
  .byte  73,193,232,32                       // shr           $0x20,%r8
  .byte  102,72,15,126,200                   // movq          %xmm1,%rax
  .byte  65,137,195                          // mov           %eax,%r11d
  .byte  72,193,232,32                       // shr           $0x20,%rax
  .byte  102,72,15,126,195                   // movq          %xmm0,%rbx
  .byte  65,137,222                          // mov           %ebx,%r14d
  .byte  72,193,235,32                       // shr           $0x20,%rbx
  .byte  102,15,112,192,78                   // pshufd        $0x4e,%xmm0,%xmm0
  .byte  102,73,15,126,199                   // movq          %xmm0,%r15
  .byte  69,137,252                          // mov           %r15d,%r12d
  .byte  73,193,239,32                       // shr           $0x20,%r15
  .byte  71,15,182,36,34                     // movzbl        (%r10,%r12,1),%r12d
  .byte  67,15,182,44,58                     // movzbl        (%r10,%r15,1),%ebp
  .byte  193,229,8                           // shl           $0x8,%ebp
  .byte  68,9,229                            // or            %r12d,%ebp
  .byte  71,15,182,52,50                     // movzbl        (%r10,%r14,1),%r14d
  .byte  65,15,182,28,26                     // movzbl        (%r10,%rbx,1),%ebx
  .byte  193,227,8                           // shl           $0x8,%ebx
  .byte  68,9,243                            // or            %r14d,%ebx
  .byte  102,15,110,195                      // movd          %ebx,%xmm0
  .byte  102,15,196,197,1                    // pinsrw        $0x1,%ebp,%xmm0
  .byte  67,15,182,44,26                     // movzbl        (%r10,%r11,1),%ebp
  .byte  65,15,182,4,2                       // movzbl        (%r10,%rax,1),%eax
  .byte  193,224,8                           // shl           $0x8,%eax
  .byte  9,232                               // or            %ebp,%eax
  .byte  102,15,196,192,2                    // pinsrw        $0x2,%eax,%xmm0
  .byte  67,15,182,4,10                      // movzbl        (%r10,%r9,1),%eax
  .byte  67,15,182,44,2                      // movzbl        (%r10,%r8,1),%ebp
  .byte  193,229,8                           // shl           $0x8,%ebp
  .byte  9,197                               // or            %eax,%ebp
  .byte  102,15,196,197,3                    // pinsrw        $0x3,%ebp,%xmm0
  .byte  102,65,15,96,192                    // punpcklbw     %xmm8,%xmm0
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,29,82,36,0,0                  // movaps        0x2452(%rip),%xmm3        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_1_float_sse2_lowp
.globl _sk_scale_1_float_sse2_lowp
FUNCTION(_sk_scale_1_float_sse2_lowp)
_sk_scale_1_float_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,89,5,132,27,0,0           // mulss         0x1b84(%rip),%xmm8        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  243,68,15,88,5,75,27,0,0            // addss         0x1b4b(%rip),%xmm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  243,65,15,44,192                    // cvttss2si     %xmm8,%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  242,69,15,112,192,0                 // pshuflw       $0x0,%xmm8,%xmm8
  .byte  102,69,15,112,192,80                // pshufd        $0x50,%xmm8,%xmm8
  .byte  102,65,15,213,192                   // pmullw        %xmm8,%xmm0
  .byte  102,68,15,111,13,3,36,0,0           // movdqa        0x2403(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,193                   // paddw         %xmm9,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,65,15,213,200                   // pmullw        %xmm8,%xmm1
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,65,15,213,208                   // pmullw        %xmm8,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,65,15,213,216                   // pmullw        %xmm8,%xmm3
  .byte  102,65,15,253,217                   // paddw         %xmm9,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_lerp_1_float_sse2_lowp
.globl _sk_lerp_1_float_sse2_lowp
FUNCTION(_sk_lerp_1_float_sse2_lowp)
_sk_lerp_1_float_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,68,15,16,0                      // movss         (%rax),%xmm8
  .byte  243,68,15,89,5,12,27,0,0            // mulss         0x1b0c(%rip),%xmm8        # 3a244 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc>
  .byte  243,68,15,88,5,211,26,0,0           // addss         0x1ad3(%rip),%xmm8        # 3a214 <_sk_srcover_bgra_8888_sse2_lowp+0x2ac>
  .byte  243,65,15,44,192                    // cvttss2si     %xmm8,%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  242,69,15,112,192,0                 // pshuflw       $0x0,%xmm8,%xmm8
  .byte  102,69,15,112,192,80                // pshufd        $0x50,%xmm8,%xmm8
  .byte  102,68,15,111,13,144,35,0,0         // movdqa        0x2390(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,213,192                   // pmullw        %xmm8,%xmm0
  .byte  102,65,15,253,193                   // paddw         %xmm9,%xmm0
  .byte  102,65,15,213,200                   // pmullw        %xmm8,%xmm1
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,65,15,213,208                   // pmullw        %xmm8,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,65,15,213,216                   // pmullw        %xmm8,%xmm3
  .byte  102,65,15,253,217                   // paddw         %xmm9,%xmm3
  .byte  102,69,15,249,200                   // psubw         %xmm8,%xmm9
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,213,196                   // pmullw        %xmm4,%xmm8
  .byte  102,65,15,253,192                   // paddw         %xmm8,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,213,197                   // pmullw        %xmm5,%xmm8
  .byte  102,65,15,253,200                   // paddw         %xmm8,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,69,15,111,193                   // movdqa        %xmm9,%xmm8
  .byte  102,68,15,213,198                   // pmullw        %xmm6,%xmm8
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,68,15,213,207                   // pmullw        %xmm7,%xmm9
  .byte  102,65,15,253,217                   // paddw         %xmm9,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_scale_u8_sse2_lowp
.globl _sk_scale_u8_sse2_lowp
FUNCTION(_sk_scale_u8_sse2_lowp)
_sk_scale_u8_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,36                              // ja            38817 <_sk_scale_u8_sse2_lowp+0x3b>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,218,0,0,0                 // lea           0xda(%rip),%r9        # 388dc <_sk_scale_u8_sse2_lowp+0x100>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  235,109                             // jmp           38884 <_sk_scale_u8_sse2_lowp+0xa8>
  .byte  243,69,15,126,4,16                  // movq          (%r8,%rdx,1),%xmm8
  .byte  102,68,15,96,192                    // punpcklbw     %xmm0,%xmm8
  .byte  235,96                              // jmp           38884 <_sk_scale_u8_sse2_lowp+0xa8>
  .byte  65,15,182,68,16,2                   // movzbl        0x2(%r8,%rdx,1),%eax
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,68,15,196,192,2                 // pinsrw        $0x2,%eax,%xmm8
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  102,68,15,110,200                   // movd          %eax,%xmm9
  .byte  102,68,15,96,200                    // punpcklbw     %xmm0,%xmm9
  .byte  243,69,15,16,193                    // movss         %xmm9,%xmm8
  .byte  235,57                              // jmp           38884 <_sk_scale_u8_sse2_lowp+0xa8>
  .byte  65,15,182,68,16,6                   // movzbl        0x6(%r8,%rdx,1),%eax
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,68,15,196,192,6                 // pinsrw        $0x6,%eax,%xmm8
  .byte  65,15,182,68,16,5                   // movzbl        0x5(%r8,%rdx,1),%eax
  .byte  102,68,15,196,192,5                 // pinsrw        $0x5,%eax,%xmm8
  .byte  65,15,182,68,16,4                   // movzbl        0x4(%r8,%rdx,1),%eax
  .byte  102,68,15,196,192,4                 // pinsrw        $0x4,%eax,%xmm8
  .byte  102,69,15,110,12,16                 // movd          (%r8,%rdx,1),%xmm9
  .byte  102,68,15,96,200                    // punpcklbw     %xmm0,%xmm9
  .byte  242,69,15,16,193                    // movsd         %xmm9,%xmm8
  .byte  102,68,15,219,5,99,34,0,0           // pand          0x2263(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,213,192                   // pmullw        %xmm8,%xmm0
  .byte  102,68,15,111,13,85,34,0,0          // movdqa        0x2255(%rip),%xmm9        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,253,193                   // paddw         %xmm9,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,65,15,213,200                   // pmullw        %xmm8,%xmm1
  .byte  102,65,15,253,201                   // paddw         %xmm9,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,65,15,213,208                   // pmullw        %xmm8,%xmm2
  .byte  102,65,15,253,209                   // paddw         %xmm9,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,68,15,213,195                   // pmullw        %xmm3,%xmm8
  .byte  102,69,15,253,193                   // paddw         %xmm9,%xmm8
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  47                                  // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,89,255                          // lcall         *-0x1(%rcx)
  .byte  255                                 // (bad)
  .byte  255,72,255                          // decl          -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255,152,255,255,255,140             // lcall         *-0x73000001(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,128,255,255,255,111             // incl          0x6fffffff(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_lerp_u8_sse2_lowp
.globl _sk_lerp_u8_sse2_lowp
FUNCTION(_sk_lerp_u8_sse2_lowp)
_sk_lerp_u8_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,36                              // ja            38933 <_sk_lerp_u8_sse2_lowp+0x3b>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,30,1,0,0                  // lea           0x11e(%rip),%r9        # 38a3c <_sk_lerp_u8_sse2_lowp+0x144>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,182,4,16                      // movzbl        (%r8,%rdx,1),%eax
  .byte  102,68,15,110,192                   // movd          %eax,%xmm8
  .byte  235,109                             // jmp           389a0 <_sk_lerp_u8_sse2_lowp+0xa8>
  .byte  243,69,15,126,4,16                  // movq          (%r8,%rdx,1),%xmm8
  .byte  102,68,15,96,192                    // punpcklbw     %xmm0,%xmm8
  .byte  235,96                              // jmp           389a0 <_sk_lerp_u8_sse2_lowp+0xa8>
  .byte  65,15,182,68,16,2                   // movzbl        0x2(%r8,%rdx,1),%eax
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,68,15,196,192,2                 // pinsrw        $0x2,%eax,%xmm8
  .byte  65,15,183,4,16                      // movzwl        (%r8,%rdx,1),%eax
  .byte  102,68,15,110,200                   // movd          %eax,%xmm9
  .byte  102,68,15,96,200                    // punpcklbw     %xmm0,%xmm9
  .byte  243,69,15,16,193                    // movss         %xmm9,%xmm8
  .byte  235,57                              // jmp           389a0 <_sk_lerp_u8_sse2_lowp+0xa8>
  .byte  65,15,182,68,16,6                   // movzbl        0x6(%r8,%rdx,1),%eax
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  102,68,15,196,192,6                 // pinsrw        $0x6,%eax,%xmm8
  .byte  65,15,182,68,16,5                   // movzbl        0x5(%r8,%rdx,1),%eax
  .byte  102,68,15,196,192,5                 // pinsrw        $0x5,%eax,%xmm8
  .byte  65,15,182,68,16,4                   // movzbl        0x4(%r8,%rdx,1),%eax
  .byte  102,68,15,196,192,4                 // pinsrw        $0x4,%eax,%xmm8
  .byte  102,69,15,110,12,16                 // movd          (%r8,%rdx,1),%xmm9
  .byte  102,68,15,96,200                    // punpcklbw     %xmm0,%xmm9
  .byte  242,69,15,16,193                    // movsd         %xmm9,%xmm8
  .byte  102,68,15,219,5,71,33,0,0           // pand          0x2147(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,68,15,111,21,62,33,0,0          // movdqa        0x213e(%rip),%xmm10        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,69,15,239,202                   // pxor          %xmm10,%xmm9
  .byte  102,69,15,111,217                   // movdqa        %xmm9,%xmm11
  .byte  102,68,15,213,220                   // pmullw        %xmm4,%xmm11
  .byte  102,65,15,213,192                   // pmullw        %xmm8,%xmm0
  .byte  102,65,15,253,194                   // paddw         %xmm10,%xmm0
  .byte  102,65,15,253,195                   // paddw         %xmm11,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,69,15,111,217                   // movdqa        %xmm9,%xmm11
  .byte  102,68,15,213,221                   // pmullw        %xmm5,%xmm11
  .byte  102,65,15,213,200                   // pmullw        %xmm8,%xmm1
  .byte  102,65,15,253,202                   // paddw         %xmm10,%xmm1
  .byte  102,65,15,253,203                   // paddw         %xmm11,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,69,15,111,217                   // movdqa        %xmm9,%xmm11
  .byte  102,68,15,213,222                   // pmullw        %xmm6,%xmm11
  .byte  102,65,15,213,208                   // pmullw        %xmm8,%xmm2
  .byte  102,65,15,253,210                   // paddw         %xmm10,%xmm2
  .byte  102,65,15,253,211                   // paddw         %xmm11,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,68,15,213,207                   // pmullw        %xmm7,%xmm9
  .byte  102,68,15,213,195                   // pmullw        %xmm3,%xmm8
  .byte  102,69,15,253,194                   // paddw         %xmm10,%xmm8
  .byte  102,69,15,253,193                   // paddw         %xmm9,%xmm8
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  15,31,0                             // nopl          (%rax)
  .byte  235,254                             // jmp           38a3c <_sk_lerp_u8_sse2_lowp+0x144>
  .byte  255                                 // (bad)
  .byte  255,21,255,255,255,4                // callq         *0x4ffffff(%rip)        # 5038a44 <_sk_srcover_bgra_8888_sse2_lowp+0x4ffeadc>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,84,255,255                      // callq         *-0x1(%rdi,%rdi,8)
  .byte  255,72,255                          // decl          -0x1(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  60,255                              // cmp           $0xff,%al
  .byte  255                                 // (bad)
  .byte  255,43                              // ljmp          *(%rbx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_scale_565_sse2_lowp
.globl _sk_scale_565_sse2_lowp
FUNCTION(_sk_scale_565_sse2_lowp)
_sk_scale_565_sse2_lowp:
  .byte  102,15,127,116,36,232               // movdqa        %xmm6,-0x18(%rsp)
  .byte  15,41,108,36,216                    // movaps        %xmm5,-0x28(%rsp)
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            38aa3 <_sk_scale_565_sse2_lowp+0x4b>
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,229,1,0,0                 // lea           0x1e5(%rip),%r9        # 38c74 <_sk_scale_565_sse2_lowp+0x21c>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  102,15,110,240                      // movd          %eax,%xmm6
  .byte  235,67                              // jmp           38ae6 <_sk_scale_565_sse2_lowp+0x8e>
  .byte  243,65,15,111,52,80                 // movdqu        (%r8,%rdx,2),%xmm6
  .byte  235,59                              // jmp           38ae6 <_sk_scale_565_sse2_lowp+0x8e>
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  102,65,15,196,116,80,4,2            // pinsrw        $0x2,0x4(%r8,%rdx,2),%xmm6
  .byte  243,69,15,16,12,80                  // movss         (%r8,%rdx,2),%xmm9
  .byte  243,65,15,16,241                    // movss         %xmm9,%xmm6
  .byte  235,34                              // jmp           38ae6 <_sk_scale_565_sse2_lowp+0x8e>
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  102,65,15,196,116,80,12,6           // pinsrw        $0x6,0xc(%r8,%rdx,2),%xmm6
  .byte  102,65,15,196,116,80,10,5           // pinsrw        $0x5,0xa(%r8,%rdx,2),%xmm6
  .byte  102,65,15,196,116,80,8,4            // pinsrw        $0x4,0x8(%r8,%rdx,2),%xmm6
  .byte  102,65,15,18,52,80                  // movlpd        (%r8,%rdx,2),%xmm6
  .byte  102,68,15,111,222                   // movdqa        %xmm6,%xmm11
  .byte  102,65,15,113,211,8                 // psrlw         $0x8,%xmm11
  .byte  102,68,15,219,29,166,39,0,0         // pand          0x27a6(%rip),%xmm11        # 3b2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1338>
  .byte  102,68,15,111,206                   // movdqa        %xmm6,%xmm9
  .byte  102,65,15,113,209,5                 // psrlw         $0x5,%xmm9
  .byte  102,68,15,219,13,162,39,0,0         // pand          0x27a2(%rip),%xmm9        # 3b2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1348>
  .byte  102,68,15,111,21,169,39,0,0         // movdqa        0x27a9(%rip),%xmm10        # 3b2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1358>
  .byte  102,68,15,219,214                   // pand          %xmm6,%xmm10
  .byte  102,15,113,214,13                   // psrlw         $0xd,%xmm6
  .byte  102,65,15,235,243                   // por           %xmm11,%xmm6
  .byte  102,69,15,111,217                   // movdqa        %xmm9,%xmm11
  .byte  102,65,15,113,243,2                 // psllw         $0x2,%xmm11
  .byte  102,65,15,113,209,4                 // psrlw         $0x4,%xmm9
  .byte  102,69,15,235,203                   // por           %xmm11,%xmm9
  .byte  102,69,15,111,218                   // movdqa        %xmm10,%xmm11
  .byte  102,65,15,113,243,3                 // psllw         $0x3,%xmm11
  .byte  102,65,15,113,210,2                 // psrlw         $0x2,%xmm10
  .byte  102,69,15,235,211                   // por           %xmm11,%xmm10
  .byte  102,68,15,111,37,5,39,0,0           // movdqa        0x2705(%rip),%xmm12        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,68,15,111,235                   // movdqa        %xmm3,%xmm13
  .byte  102,69,15,239,236                   // pxor          %xmm12,%xmm13
  .byte  102,68,15,111,223                   // movdqa        %xmm7,%xmm11
  .byte  102,69,15,239,220                   // pxor          %xmm12,%xmm11
  .byte  102,69,15,101,221                   // pcmpgtw       %xmm13,%xmm11
  .byte  102,69,15,111,234                   // movdqa        %xmm10,%xmm13
  .byte  102,69,15,239,236                   // pxor          %xmm12,%xmm13
  .byte  102,69,15,111,241                   // movdqa        %xmm9,%xmm14
  .byte  102,69,15,239,244                   // pxor          %xmm12,%xmm14
  .byte  102,69,15,101,238                   // pcmpgtw       %xmm14,%xmm13
  .byte  102,69,15,111,245                   // movdqa        %xmm13,%xmm14
  .byte  102,69,15,223,242                   // pandn         %xmm10,%xmm14
  .byte  102,69,15,111,249                   // movdqa        %xmm9,%xmm15
  .byte  102,69,15,219,253                   // pand          %xmm13,%xmm15
  .byte  102,69,15,235,254                   // por           %xmm14,%xmm15
  .byte  102,69,15,111,247                   // movdqa        %xmm15,%xmm14
  .byte  102,69,15,239,244                   // pxor          %xmm12,%xmm14
  .byte  102,68,15,111,198                   // movdqa        %xmm6,%xmm8
  .byte  102,69,15,235,196                   // por           %xmm12,%xmm8
  .byte  102,69,15,101,240                   // pcmpgtw       %xmm8,%xmm14
  .byte  102,15,111,198                      // movdqa        %xmm6,%xmm0
  .byte  102,65,15,219,198                   // pand          %xmm14,%xmm0
  .byte  102,69,15,223,247                   // pandn         %xmm15,%xmm14
  .byte  102,68,15,235,240                   // por           %xmm0,%xmm14
  .byte  102,65,15,111,194                   // movdqa        %xmm10,%xmm0
  .byte  102,65,15,219,197                   // pand          %xmm13,%xmm0
  .byte  102,69,15,223,233                   // pandn         %xmm9,%xmm13
  .byte  102,68,15,235,232                   // por           %xmm0,%xmm13
  .byte  102,69,15,239,229                   // pxor          %xmm13,%xmm12
  .byte  102,69,15,101,224                   // pcmpgtw       %xmm8,%xmm12
  .byte  102,69,15,219,236                   // pand          %xmm12,%xmm13
  .byte  102,68,15,223,230                   // pandn         %xmm6,%xmm12
  .byte  102,69,15,235,229                   // por           %xmm13,%xmm12
  .byte  102,69,15,219,243                   // pand          %xmm11,%xmm14
  .byte  102,69,15,223,220                   // pandn         %xmm12,%xmm11
  .byte  102,69,15,235,222                   // por           %xmm14,%xmm11
  .byte  102,15,213,245                      // pmullw        %xmm5,%xmm6
  .byte  102,68,15,213,201                   // pmullw        %xmm1,%xmm9
  .byte  102,68,15,213,210                   // pmullw        %xmm2,%xmm10
  .byte  102,68,15,213,219                   // pmullw        %xmm3,%xmm11
  .byte  102,15,111,5,199,30,0,0             // movdqa        0x1ec7(%rip),%xmm0        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,253,240                      // paddw         %xmm0,%xmm6
  .byte  102,68,15,253,200                   // paddw         %xmm0,%xmm9
  .byte  102,68,15,253,208                   // paddw         %xmm0,%xmm10
  .byte  102,68,15,253,216                   // paddw         %xmm0,%xmm11
  .byte  102,15,113,214,8                    // psrlw         $0x8,%xmm6
  .byte  102,65,15,113,209,8                 // psrlw         $0x8,%xmm9
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,65,15,113,211,8                 // psrlw         $0x8,%xmm11
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,111,198                      // movdqa        %xmm6,%xmm0
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  102,65,15,111,210                   // movdqa        %xmm10,%xmm2
  .byte  102,65,15,111,219                   // movdqa        %xmm11,%xmm3
  .byte  15,40,108,36,216                    // movaps        -0x28(%rsp),%xmm5
  .byte  15,40,116,36,232                    // movaps        -0x18(%rsp),%xmm6
  .byte  255,224                             // jmpq          *%rax
  .byte  36,254                              // and           $0xfe,%al
  .byte  255                                 // (bad)
  .byte  255,67,254                          // incl          -0x2(%rbx)
  .byte  255                                 // (bad)
  .byte  255,55                              // pushq         (%rdi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,108,254,255                     // ljmp          *-0x1(%rsi,%rdi,8)
  .byte  255,100,254,255                     // jmpq          *-0x1(%rsi,%rdi,8)
  .byte  255,92,254,255                      // lcall         *-0x1(%rsi,%rdi,8)
  .byte  255,80,254                          // callq         *-0x2(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_lerp_565_sse2_lowp
.globl _sk_lerp_565_sse2_lowp
FUNCTION(_sk_lerp_565_sse2_lowp)
_sk_lerp_565_sse2_lowp:
  .byte  102,15,127,84,36,232                // movdqa        %xmm2,-0x18(%rsp)
  .byte  15,41,76,36,216                     // movaps        %xmm1,-0x28(%rsp)
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  77,1,192                            // add           %r8,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  137,248                             // mov           %edi,%eax
  .byte  36,7                                // and           $0x7,%al
  .byte  254,200                             // dec           %al
  .byte  60,6                                // cmp           $0x6,%al
  .byte  119,34                              // ja            38cdb <_sk_lerp_565_sse2_lowp+0x4b>
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  15,182,192                          // movzbl        %al,%eax
  .byte  76,141,13,45,2,0,0                  // lea           0x22d(%rip),%r9        # 38ef4 <_sk_lerp_565_sse2_lowp+0x264>
  .byte  73,99,4,129                         // movslq        (%r9,%rax,4),%rax
  .byte  76,1,200                            // add           %r9,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  65,15,183,4,80                      // movzwl        (%r8,%rdx,2),%eax
  .byte  102,15,110,208                      // movd          %eax,%xmm2
  .byte  235,67                              // jmp           38d1e <_sk_lerp_565_sse2_lowp+0x8e>
  .byte  243,65,15,111,20,80                 // movdqu        (%r8,%rdx,2),%xmm2
  .byte  235,59                              // jmp           38d1e <_sk_lerp_565_sse2_lowp+0x8e>
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  102,65,15,196,84,80,4,2             // pinsrw        $0x2,0x4(%r8,%rdx,2),%xmm2
  .byte  243,69,15,16,12,80                  // movss         (%r8,%rdx,2),%xmm9
  .byte  243,65,15,16,209                    // movss         %xmm9,%xmm2
  .byte  235,34                              // jmp           38d1e <_sk_lerp_565_sse2_lowp+0x8e>
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  102,65,15,196,84,80,12,6            // pinsrw        $0x6,0xc(%r8,%rdx,2),%xmm2
  .byte  102,65,15,196,84,80,10,5            // pinsrw        $0x5,0xa(%r8,%rdx,2),%xmm2
  .byte  102,65,15,196,84,80,8,4             // pinsrw        $0x4,0x8(%r8,%rdx,2),%xmm2
  .byte  102,65,15,18,20,80                  // movlpd        (%r8,%rdx,2),%xmm2
  .byte  102,68,15,111,218                   // movdqa        %xmm2,%xmm11
  .byte  102,65,15,113,211,8                 // psrlw         $0x8,%xmm11
  .byte  102,68,15,219,29,110,37,0,0         // pand          0x256e(%rip),%xmm11        # 3b2a0 <_sk_srcover_bgra_8888_sse2_lowp+0x1338>
  .byte  102,68,15,111,202                   // movdqa        %xmm2,%xmm9
  .byte  102,65,15,113,209,5                 // psrlw         $0x5,%xmm9
  .byte  102,68,15,219,13,106,37,0,0         // pand          0x256a(%rip),%xmm9        # 3b2b0 <_sk_srcover_bgra_8888_sse2_lowp+0x1348>
  .byte  102,68,15,111,21,113,37,0,0         // movdqa        0x2571(%rip),%xmm10        # 3b2c0 <_sk_srcover_bgra_8888_sse2_lowp+0x1358>
  .byte  102,68,15,219,210                   // pand          %xmm2,%xmm10
  .byte  102,15,113,210,13                   // psrlw         $0xd,%xmm2
  .byte  102,65,15,235,211                   // por           %xmm11,%xmm2
  .byte  102,69,15,111,217                   // movdqa        %xmm9,%xmm11
  .byte  102,65,15,113,243,2                 // psllw         $0x2,%xmm11
  .byte  102,65,15,113,209,4                 // psrlw         $0x4,%xmm9
  .byte  102,69,15,235,203                   // por           %xmm11,%xmm9
  .byte  102,69,15,111,218                   // movdqa        %xmm10,%xmm11
  .byte  102,65,15,113,243,3                 // psllw         $0x3,%xmm11
  .byte  102,65,15,113,210,2                 // psrlw         $0x2,%xmm10
  .byte  102,69,15,235,211                   // por           %xmm11,%xmm10
  .byte  102,68,15,111,37,205,36,0,0         // movdqa        0x24cd(%rip),%xmm12        # 3b260 <_sk_srcover_bgra_8888_sse2_lowp+0x12f8>
  .byte  102,68,15,111,235                   // movdqa        %xmm3,%xmm13
  .byte  102,69,15,239,236                   // pxor          %xmm12,%xmm13
  .byte  102,68,15,111,223                   // movdqa        %xmm7,%xmm11
  .byte  102,69,15,239,220                   // pxor          %xmm12,%xmm11
  .byte  102,69,15,101,221                   // pcmpgtw       %xmm13,%xmm11
  .byte  102,69,15,111,234                   // movdqa        %xmm10,%xmm13
  .byte  102,69,15,239,236                   // pxor          %xmm12,%xmm13
  .byte  102,69,15,111,241                   // movdqa        %xmm9,%xmm14
  .byte  102,69,15,239,244                   // pxor          %xmm12,%xmm14
  .byte  102,69,15,101,238                   // pcmpgtw       %xmm14,%xmm13
  .byte  102,69,15,111,245                   // movdqa        %xmm13,%xmm14
  .byte  102,69,15,223,242                   // pandn         %xmm10,%xmm14
  .byte  102,69,15,111,249                   // movdqa        %xmm9,%xmm15
  .byte  102,69,15,219,253                   // pand          %xmm13,%xmm15
  .byte  102,69,15,235,254                   // por           %xmm14,%xmm15
  .byte  102,69,15,111,247                   // movdqa        %xmm15,%xmm14
  .byte  102,69,15,239,244                   // pxor          %xmm12,%xmm14
  .byte  102,68,15,111,194                   // movdqa        %xmm2,%xmm8
  .byte  102,69,15,235,196                   // por           %xmm12,%xmm8
  .byte  102,69,15,101,240                   // pcmpgtw       %xmm8,%xmm14
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,65,15,219,198                   // pand          %xmm14,%xmm0
  .byte  102,69,15,223,247                   // pandn         %xmm15,%xmm14
  .byte  102,68,15,235,240                   // por           %xmm0,%xmm14
  .byte  102,65,15,111,194                   // movdqa        %xmm10,%xmm0
  .byte  102,65,15,219,197                   // pand          %xmm13,%xmm0
  .byte  102,69,15,223,233                   // pandn         %xmm9,%xmm13
  .byte  102,68,15,235,232                   // por           %xmm0,%xmm13
  .byte  102,69,15,239,229                   // pxor          %xmm13,%xmm12
  .byte  102,69,15,101,224                   // pcmpgtw       %xmm8,%xmm12
  .byte  102,69,15,219,236                   // pand          %xmm12,%xmm13
  .byte  102,68,15,223,226                   // pandn         %xmm2,%xmm12
  .byte  102,69,15,235,229                   // por           %xmm13,%xmm12
  .byte  102,69,15,219,243                   // pand          %xmm11,%xmm14
  .byte  102,69,15,223,220                   // pandn         %xmm12,%xmm11
  .byte  102,69,15,235,222                   // por           %xmm14,%xmm11
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,213,209                      // pmullw        %xmm1,%xmm2
  .byte  102,68,15,111,5,153,28,0,0          // movdqa        0x1c99(%rip),%xmm8        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,65,15,239,192                   // pxor          %xmm8,%xmm0
  .byte  102,15,213,196                      // pmullw        %xmm4,%xmm0
  .byte  102,65,15,253,208                   // paddw         %xmm8,%xmm2
  .byte  102,15,253,208                      // paddw         %xmm0,%xmm2
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,68,15,213,76,36,216             // pmullw        -0x28(%rsp),%xmm9
  .byte  102,65,15,239,192                   // pxor          %xmm8,%xmm0
  .byte  102,15,213,197                      // pmullw        %xmm5,%xmm0
  .byte  102,69,15,253,200                   // paddw         %xmm8,%xmm9
  .byte  102,68,15,253,200                   // paddw         %xmm0,%xmm9
  .byte  102,65,15,111,194                   // movdqa        %xmm10,%xmm0
  .byte  102,68,15,213,84,36,232             // pmullw        -0x18(%rsp),%xmm10
  .byte  102,65,15,239,192                   // pxor          %xmm8,%xmm0
  .byte  102,15,213,198                      // pmullw        %xmm6,%xmm0
  .byte  102,69,15,253,208                   // paddw         %xmm8,%xmm10
  .byte  102,68,15,253,208                   // paddw         %xmm0,%xmm10
  .byte  102,65,15,111,195                   // movdqa        %xmm11,%xmm0
  .byte  102,68,15,213,219                   // pmullw        %xmm3,%xmm11
  .byte  102,65,15,239,192                   // pxor          %xmm8,%xmm0
  .byte  102,69,15,253,216                   // paddw         %xmm8,%xmm11
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,68,15,253,216                   // paddw         %xmm0,%xmm11
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,65,15,113,209,8                 // psrlw         $0x8,%xmm9
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,65,15,113,211,8                 // psrlw         $0x8,%xmm11
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  102,65,15,111,210                   // movdqa        %xmm10,%xmm2
  .byte  102,65,15,111,219                   // movdqa        %xmm11,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  102,144                             // xchg          %ax,%ax
  .byte  220,253                             // fdivr         %st,%st(5)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  251                                 // sti
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  239                                 // out           %eax,(%dx)
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,36,254                          // jmpq          *(%rsi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,28,254                          // lcall         *(%rsi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,20,254                          // callq         *(%rsi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  255,8                               // decl          (%rax)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_clamp_x_1_sse2_lowp
.globl _sk_clamp_x_1_sse2_lowp
FUNCTION(_sk_clamp_x_1_sse2_lowp)
_sk_clamp_x_1_sse2_lowp:
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  65,15,95,200                        // maxps         %xmm8,%xmm1
  .byte  65,15,95,192                        // maxps         %xmm8,%xmm0
  .byte  68,15,40,5,44,28,0,0                // movaps        0x1c2c(%rip),%xmm8        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  65,15,93,192                        // minps         %xmm8,%xmm0
  .byte  65,15,93,200                        // minps         %xmm8,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_repeat_x_1_sse2_lowp
.globl _sk_repeat_x_1_sse2_lowp
FUNCTION(_sk_repeat_x_1_sse2_lowp)
_sk_repeat_x_1_sse2_lowp:
  .byte  243,68,15,91,193                    // cvttps2dq     %xmm1,%xmm8
  .byte  243,68,15,91,200                    // cvttps2dq     %xmm0,%xmm9
  .byte  69,15,91,201                        // cvtdq2ps      %xmm9,%xmm9
  .byte  69,15,91,192                        // cvtdq2ps      %xmm8,%xmm8
  .byte  68,15,40,209                        // movaps        %xmm1,%xmm10
  .byte  69,15,194,208,1                     // cmpltps       %xmm8,%xmm10
  .byte  68,15,40,216                        // movaps        %xmm0,%xmm11
  .byte  69,15,194,217,1                     // cmpltps       %xmm9,%xmm11
  .byte  68,15,40,37,244,27,0,0              // movaps        0x1bf4(%rip),%xmm12        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,84,220                        // andps         %xmm12,%xmm11
  .byte  69,15,84,212                        // andps         %xmm12,%xmm10
  .byte  69,15,87,237                        // xorps         %xmm13,%xmm13
  .byte  69,15,92,194                        // subps         %xmm10,%xmm8
  .byte  69,15,92,203                        // subps         %xmm11,%xmm9
  .byte  65,15,92,193                        // subps         %xmm9,%xmm0
  .byte  65,15,92,200                        // subps         %xmm8,%xmm1
  .byte  65,15,95,205                        // maxps         %xmm13,%xmm1
  .byte  65,15,95,197                        // maxps         %xmm13,%xmm0
  .byte  65,15,93,196                        // minps         %xmm12,%xmm0
  .byte  65,15,93,204                        // minps         %xmm12,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_mirror_x_1_sse2_lowp
.globl _sk_mirror_x_1_sse2_lowp
FUNCTION(_sk_mirror_x_1_sse2_lowp)
_sk_mirror_x_1_sse2_lowp:
  .byte  68,15,40,5,28,28,0,0                // movaps        0x1c1c(%rip),%xmm8        # 3abb0 <_sk_srcover_bgra_8888_sse2_lowp+0xc48>
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  68,15,40,21,156,27,0,0              // movaps        0x1b9c(%rip),%xmm10        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,40,217                        // movaps        %xmm1,%xmm11
  .byte  69,15,89,218                        // mulps         %xmm10,%xmm11
  .byte  68,15,89,208                        // mulps         %xmm0,%xmm10
  .byte  243,69,15,91,202                    // cvttps2dq     %xmm10,%xmm9
  .byte  243,69,15,91,227                    // cvttps2dq     %xmm11,%xmm12
  .byte  69,15,91,228                        // cvtdq2ps      %xmm12,%xmm12
  .byte  69,15,91,233                        // cvtdq2ps      %xmm9,%xmm13
  .byte  69,15,194,213,1                     // cmpltps       %xmm13,%xmm10
  .byte  69,15,194,220,1                     // cmpltps       %xmm12,%xmm11
  .byte  68,15,40,13,124,27,0,0              // movaps        0x1b7c(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,84,217                        // andps         %xmm9,%xmm11
  .byte  69,15,84,209                        // andps         %xmm9,%xmm10
  .byte  69,15,87,246                        // xorps         %xmm14,%xmm14
  .byte  69,15,92,234                        // subps         %xmm10,%xmm13
  .byte  69,15,92,227                        // subps         %xmm11,%xmm12
  .byte  69,15,88,228                        // addps         %xmm12,%xmm12
  .byte  69,15,88,237                        // addps         %xmm13,%xmm13
  .byte  65,15,92,197                        // subps         %xmm13,%xmm0
  .byte  65,15,92,204                        // subps         %xmm12,%xmm1
  .byte  65,15,88,200                        // addps         %xmm8,%xmm1
  .byte  65,15,88,192                        // addps         %xmm8,%xmm0
  .byte  68,15,40,5,104,32,0,0               // movaps        0x2068(%rip),%xmm8        # 3b070 <_sk_srcover_bgra_8888_sse2_lowp+0x1108>
  .byte  65,15,84,192                        // andps         %xmm8,%xmm0
  .byte  65,15,84,200                        // andps         %xmm8,%xmm1
  .byte  65,15,95,206                        // maxps         %xmm14,%xmm1
  .byte  65,15,95,198                        // maxps         %xmm14,%xmm0
  .byte  65,15,93,193                        // minps         %xmm9,%xmm0
  .byte  65,15,93,201                        // minps         %xmm9,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_gradient_sse2_lowp
.globl _sk_gradient_sse2_lowp
FUNCTION(_sk_gradient_sse2_lowp)
_sk_gradient_sse2_lowp:
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  15,41,124,36,240                    // movaps        %xmm7,-0x10(%rsp)
  .byte  15,41,116,36,224                    // movaps        %xmm6,-0x20(%rsp)
  .byte  15,41,108,36,208                    // movaps        %xmm5,-0x30(%rsp)
  .byte  15,41,100,36,192                    // movaps        %xmm4,-0x40(%rsp)
  .byte  68,15,40,249                        // movaps        %xmm1,%xmm15
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,139,0                            // mov           (%rax),%r8
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  73,131,248,2                        // cmp           $0x2,%r8
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  114,56                              // jb            39090 <_sk_gradient_sse2_lowp+0x6c>
  .byte  72,139,88,72                        // mov           0x48(%rax),%rbx
  .byte  73,255,200                          // dec           %r8
  .byte  72,131,195,4                        // add           $0x4,%rbx
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  243,15,16,35                        // movss         (%rbx),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,194,232,2                        // cmpleps       %xmm0,%xmm5
  .byte  102,15,250,213                      // psubd         %xmm5,%xmm2
  .byte  65,15,194,231,2                     // cmpleps       %xmm15,%xmm4
  .byte  102,15,250,220                      // psubd         %xmm4,%xmm3
  .byte  72,131,195,4                        // add           $0x4,%rbx
  .byte  73,255,200                          // dec           %r8
  .byte  117,219                             // jne           3906b <_sk_gradient_sse2_lowp+0x47>
  .byte  102,15,112,227,78                   // pshufd        $0x4e,%xmm3,%xmm4
  .byte  102,73,15,126,225                   // movq          %xmm4,%r9
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  102,73,15,126,219                   // movq          %xmm3,%r11
  .byte  69,137,218                          // mov           %r11d,%r10d
  .byte  73,193,235,32                       // shr           $0x20,%r11
  .byte  102,65,15,126,214                   // movd          %xmm2,%r14d
  .byte  102,68,15,112,194,229               // pshufd        $0xe5,%xmm2,%xmm8
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,65,15,126,223                   // movd          %xmm3,%r15d
  .byte  102,15,112,210,231                  // pshufd        $0xe7,%xmm2,%xmm2
  .byte  102,65,15,126,212                   // movd          %xmm2,%r12d
  .byte  72,139,88,8                         // mov           0x8(%rax),%rbx
  .byte  243,70,15,16,20,155                 // movss         (%rbx,%r11,4),%xmm10
  .byte  243,70,15,16,12,147                 // movss         (%rbx,%r10,4),%xmm9
  .byte  243,66,15,16,44,139                 // movss         (%rbx,%r9,4),%xmm5
  .byte  243,66,15,16,52,131                 // movss         (%rbx,%r8,4),%xmm6
  .byte  243,66,15,16,60,163                 // movss         (%rbx,%r12,4),%xmm7
  .byte  243,66,15,16,36,187                 // movss         (%rbx,%r15,4),%xmm4
  .byte  243,66,15,16,28,179                 // movss         (%rbx,%r14,4),%xmm3
  .byte  102,69,15,126,197                   // movd          %xmm8,%r13d
  .byte  243,66,15,16,20,171                 // movss         (%rbx,%r13,4),%xmm2
  .byte  69,15,20,202                        // unpcklps      %xmm10,%xmm9
  .byte  15,20,245                           // unpcklps      %xmm5,%xmm6
  .byte  102,68,15,20,206                    // unpcklpd      %xmm6,%xmm9
  .byte  15,20,231                           // unpcklps      %xmm7,%xmm4
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  102,15,20,220                       // unpcklpd      %xmm4,%xmm3
  .byte  72,139,88,16                        // mov           0x10(%rax),%rbx
  .byte  243,70,15,16,4,155                  // movss         (%rbx,%r11,4),%xmm8
  .byte  243,70,15,16,36,147                 // movss         (%rbx,%r10,4),%xmm12
  .byte  243,70,15,16,20,139                 // movss         (%rbx,%r9,4),%xmm10
  .byte  243,66,15,16,52,131                 // movss         (%rbx,%r8,4),%xmm6
  .byte  243,66,15,16,60,163                 // movss         (%rbx,%r12,4),%xmm7
  .byte  243,66,15,16,36,187                 // movss         (%rbx,%r15,4),%xmm4
  .byte  243,66,15,16,20,179                 // movss         (%rbx,%r14,4),%xmm2
  .byte  243,66,15,16,44,171                 // movss         (%rbx,%r13,4),%xmm5
  .byte  69,15,20,224                        // unpcklps      %xmm8,%xmm12
  .byte  65,15,20,242                        // unpcklps      %xmm10,%xmm6
  .byte  102,68,15,20,230                    // unpcklpd      %xmm6,%xmm12
  .byte  15,20,231                           // unpcklps      %xmm7,%xmm4
  .byte  15,20,213                           // unpcklps      %xmm5,%xmm2
  .byte  102,15,20,212                       // unpcklpd      %xmm4,%xmm2
  .byte  72,139,88,24                        // mov           0x18(%rax),%rbx
  .byte  243,66,15,16,36,155                 // movss         (%rbx,%r11,4),%xmm4
  .byte  243,70,15,16,28,147                 // movss         (%rbx,%r10,4),%xmm11
  .byte  68,15,20,220                        // unpcklps      %xmm4,%xmm11
  .byte  243,66,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm4
  .byte  243,66,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm5
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  243,66,15,16,36,163                 // movss         (%rbx,%r12,4),%xmm4
  .byte  243,66,15,16,52,187                 // movss         (%rbx,%r15,4),%xmm6
  .byte  243,70,15,16,52,179                 // movss         (%rbx,%r14,4),%xmm14
  .byte  243,66,15,16,60,171                 // movss         (%rbx,%r13,4),%xmm7
  .byte  102,68,15,20,221                    // unpcklpd      %xmm5,%xmm11
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  68,15,20,247                        // unpcklps      %xmm7,%xmm14
  .byte  102,68,15,20,246                    // unpcklpd      %xmm6,%xmm14
  .byte  72,139,88,32                        // mov           0x20(%rax),%rbx
  .byte  243,66,15,16,36,155                 // movss         (%rbx,%r11,4),%xmm4
  .byte  243,70,15,16,20,147                 // movss         (%rbx,%r10,4),%xmm10
  .byte  68,15,20,212                        // unpcklps      %xmm4,%xmm10
  .byte  243,66,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm4
  .byte  243,66,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm5
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  102,68,15,20,213                    // unpcklpd      %xmm5,%xmm10
  .byte  243,66,15,16,36,163                 // movss         (%rbx,%r12,4),%xmm4
  .byte  243,66,15,16,44,187                 // movss         (%rbx,%r15,4),%xmm5
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  243,70,15,16,44,179                 // movss         (%rbx,%r14,4),%xmm13
  .byte  243,66,15,16,36,171                 // movss         (%rbx,%r13,4),%xmm4
  .byte  68,15,20,236                        // unpcklps      %xmm4,%xmm13
  .byte  102,68,15,20,237                    // unpcklpd      %xmm5,%xmm13
  .byte  72,139,88,40                        // mov           0x28(%rax),%rbx
  .byte  243,66,15,16,36,163                 // movss         (%rbx,%r12,4),%xmm4
  .byte  243,66,15,16,52,187                 // movss         (%rbx,%r15,4),%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  243,66,15,16,44,179                 // movss         (%rbx,%r14,4),%xmm5
  .byte  243,66,15,16,36,171                 // movss         (%rbx,%r13,4),%xmm4
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  102,15,20,238                       // unpcklpd      %xmm6,%xmm5
  .byte  243,66,15,16,52,155                 // movss         (%rbx,%r11,4),%xmm6
  .byte  243,66,15,16,36,147                 // movss         (%rbx,%r10,4),%xmm4
  .byte  15,20,230                           // unpcklps      %xmm6,%xmm4
  .byte  243,66,15,16,52,139                 // movss         (%rbx,%r9,4),%xmm6
  .byte  243,66,15,16,60,131                 // movss         (%rbx,%r8,4),%xmm7
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  102,15,20,231                       // unpcklpd      %xmm7,%xmm4
  .byte  72,139,88,48                        // mov           0x30(%rax),%rbx
  .byte  243,66,15,16,60,163                 // movss         (%rbx,%r12,4),%xmm7
  .byte  243,66,15,16,52,187                 // movss         (%rbx,%r15,4),%xmm6
  .byte  15,20,247                           // unpcklps      %xmm7,%xmm6
  .byte  243,66,15,16,12,179                 // movss         (%rbx,%r14,4),%xmm1
  .byte  243,66,15,16,60,171                 // movss         (%rbx,%r13,4),%xmm7
  .byte  15,20,207                           // unpcklps      %xmm7,%xmm1
  .byte  102,15,20,206                       // unpcklpd      %xmm6,%xmm1
  .byte  102,15,41,76,36,144                 // movapd        %xmm1,-0x70(%rsp)
  .byte  243,66,15,16,60,155                 // movss         (%rbx,%r11,4),%xmm7
  .byte  243,70,15,16,4,147                  // movss         (%rbx,%r10,4),%xmm8
  .byte  68,15,20,199                        // unpcklps      %xmm7,%xmm8
  .byte  243,66,15,16,60,139                 // movss         (%rbx,%r9,4),%xmm7
  .byte  243,66,15,16,52,131                 // movss         (%rbx,%r8,4),%xmm6
  .byte  15,20,247                           // unpcklps      %xmm7,%xmm6
  .byte  102,68,15,20,198                    // unpcklpd      %xmm6,%xmm8
  .byte  72,139,88,56                        // mov           0x38(%rax),%rbx
  .byte  243,66,15,16,60,163                 // movss         (%rbx,%r12,4),%xmm7
  .byte  243,66,15,16,52,187                 // movss         (%rbx,%r15,4),%xmm6
  .byte  15,20,247                           // unpcklps      %xmm7,%xmm6
  .byte  243,66,15,16,12,179                 // movss         (%rbx,%r14,4),%xmm1
  .byte  243,66,15,16,60,171                 // movss         (%rbx,%r13,4),%xmm7
  .byte  15,20,207                           // unpcklps      %xmm7,%xmm1
  .byte  102,15,20,206                       // unpcklpd      %xmm6,%xmm1
  .byte  102,15,41,76,36,160                 // movapd        %xmm1,-0x60(%rsp)
  .byte  243,66,15,16,60,155                 // movss         (%rbx,%r11,4),%xmm7
  .byte  243,66,15,16,12,147                 // movss         (%rbx,%r10,4),%xmm1
  .byte  15,20,207                           // unpcklps      %xmm7,%xmm1
  .byte  243,66,15,16,60,139                 // movss         (%rbx,%r9,4),%xmm7
  .byte  243,66,15,16,52,131                 // movss         (%rbx,%r8,4),%xmm6
  .byte  15,20,247                           // unpcklps      %xmm7,%xmm6
  .byte  102,15,20,206                       // unpcklpd      %xmm6,%xmm1
  .byte  102,15,41,76,36,128                 // movapd        %xmm1,-0x80(%rsp)
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  243,66,15,16,52,160                 // movss         (%rax,%r12,4),%xmm6
  .byte  243,66,15,16,60,184                 // movss         (%rax,%r15,4),%xmm7
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  243,66,15,16,12,176                 // movss         (%rax,%r14,4),%xmm1
  .byte  243,66,15,16,52,168                 // movss         (%rax,%r13,4),%xmm6
  .byte  15,20,206                           // unpcklps      %xmm6,%xmm1
  .byte  102,15,20,207                       // unpcklpd      %xmm7,%xmm1
  .byte  102,15,41,76,36,176                 // movapd        %xmm1,-0x50(%rsp)
  .byte  243,66,15,16,52,152                 // movss         (%rax,%r11,4),%xmm6
  .byte  243,66,15,16,12,144                 // movss         (%rax,%r10,4),%xmm1
  .byte  15,20,206                           // unpcklps      %xmm6,%xmm1
  .byte  243,66,15,16,52,136                 // movss         (%rax,%r9,4),%xmm6
  .byte  243,66,15,16,60,128                 // movss         (%rax,%r8,4),%xmm7
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  102,15,20,207                       // unpcklpd      %xmm7,%xmm1
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  69,15,89,207                        // mulps         %xmm15,%xmm9
  .byte  68,15,88,204                        // addps         %xmm4,%xmm9
  .byte  15,40,53,227,24,0,0                 // movaps        0x18e3(%rip),%xmm6        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  15,89,222                           // mulps         %xmm6,%xmm3
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  15,40,37,229,23,0,0                 // movaps        0x17e5(%rip),%xmm4        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,88,204                        // addps         %xmm4,%xmm9
  .byte  15,88,220                           // addps         %xmm4,%xmm3
  .byte  243,15,91,219                       // cvttps2dq     %xmm3,%xmm3
  .byte  242,15,112,219,232                  // pshuflw       $0xe8,%xmm3,%xmm3
  .byte  243,15,112,219,232                  // pshufhw       $0xe8,%xmm3,%xmm3
  .byte  102,15,112,235,232                  // pshufd        $0xe8,%xmm3,%xmm5
  .byte  243,65,15,91,217                    // cvttps2dq     %xmm9,%xmm3
  .byte  242,15,112,219,232                  // pshuflw       $0xe8,%xmm3,%xmm3
  .byte  243,15,112,219,232                  // pshufhw       $0xe8,%xmm3,%xmm3
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  102,15,108,235                      // punpcklqdq    %xmm3,%xmm5
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,88,84,36,144                     // addps         -0x70(%rsp),%xmm2
  .byte  69,15,89,231                        // mulps         %xmm15,%xmm12
  .byte  69,15,88,224                        // addps         %xmm8,%xmm12
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  68,15,89,230                        // mulps         %xmm6,%xmm12
  .byte  68,15,88,228                        // addps         %xmm4,%xmm12
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  242,15,112,210,232                  // pshuflw       $0xe8,%xmm2,%xmm2
  .byte  243,15,112,210,232                  // pshufhw       $0xe8,%xmm2,%xmm2
  .byte  102,68,15,112,202,232               // pshufd        $0xe8,%xmm2,%xmm9
  .byte  243,65,15,91,212                    // cvttps2dq     %xmm12,%xmm2
  .byte  242,15,112,210,232                  // pshuflw       $0xe8,%xmm2,%xmm2
  .byte  243,15,112,210,232                  // pshufhw       $0xe8,%xmm2,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,68,15,108,202                   // punpcklqdq    %xmm2,%xmm9
  .byte  68,15,89,240                        // mulps         %xmm0,%xmm14
  .byte  68,15,88,116,36,160                 // addps         -0x60(%rsp),%xmm14
  .byte  69,15,89,223                        // mulps         %xmm15,%xmm11
  .byte  68,15,88,92,36,128                  // addps         -0x80(%rsp),%xmm11
  .byte  68,15,89,246                        // mulps         %xmm6,%xmm14
  .byte  68,15,89,222                        // mulps         %xmm6,%xmm11
  .byte  68,15,88,220                        // addps         %xmm4,%xmm11
  .byte  68,15,88,244                        // addps         %xmm4,%xmm14
  .byte  243,65,15,91,214                    // cvttps2dq     %xmm14,%xmm2
  .byte  242,15,112,210,232                  // pshuflw       $0xe8,%xmm2,%xmm2
  .byte  243,15,112,210,232                  // pshufhw       $0xe8,%xmm2,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  243,65,15,91,219                    // cvttps2dq     %xmm11,%xmm3
  .byte  242,15,112,219,232                  // pshuflw       $0xe8,%xmm3,%xmm3
  .byte  243,15,112,219,232                  // pshufhw       $0xe8,%xmm3,%xmm3
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  102,15,108,211                      // punpcklqdq    %xmm3,%xmm2
  .byte  68,15,89,232                        // mulps         %xmm0,%xmm13
  .byte  68,15,88,108,36,176                 // addps         -0x50(%rsp),%xmm13
  .byte  69,15,89,215                        // mulps         %xmm15,%xmm10
  .byte  68,15,88,209                        // addps         %xmm1,%xmm10
  .byte  68,15,89,238                        // mulps         %xmm6,%xmm13
  .byte  68,15,89,214                        // mulps         %xmm6,%xmm10
  .byte  68,15,88,212                        // addps         %xmm4,%xmm10
  .byte  68,15,88,236                        // addps         %xmm4,%xmm13
  .byte  243,65,15,91,197                    // cvttps2dq     %xmm13,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,216,232                  // pshufd        $0xe8,%xmm0,%xmm3
  .byte  243,65,15,91,194                    // cvttps2dq     %xmm10,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,108,216                      // punpcklqdq    %xmm0,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  15,40,100,36,192                    // movaps        -0x40(%rsp),%xmm4
  .byte  15,40,108,36,208                    // movaps        -0x30(%rsp),%xmm5
  .byte  15,40,116,36,224                    // movaps        -0x20(%rsp),%xmm6
  .byte  15,40,124,36,240                    // movaps        -0x10(%rsp),%xmm7
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_gradient_sse2_lowp
.globl _sk_evenly_spaced_gradient_sse2_lowp
FUNCTION(_sk_evenly_spaced_gradient_sse2_lowp)
_sk_evenly_spaced_gradient_sse2_lowp:
  .byte  85                                  // push          %rbp
  .byte  65,87                               // push          %r15
  .byte  65,86                               // push          %r14
  .byte  65,85                               // push          %r13
  .byte  65,84                               // push          %r12
  .byte  83                                  // push          %rbx
  .byte  80                                  // push          %rax
  .byte  15,41,124,36,240                    // movaps        %xmm7,-0x10(%rsp)
  .byte  15,41,116,36,224                    // movaps        %xmm6,-0x20(%rsp)
  .byte  15,41,108,36,208                    // movaps        %xmm5,-0x30(%rsp)
  .byte  15,41,100,36,192                    // movaps        %xmm4,-0x40(%rsp)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  72,139,24                           // mov           (%rax),%rbx
  .byte  72,139,104,8                        // mov           0x8(%rax),%rbp
  .byte  72,255,203                          // dec           %rbx
  .byte  120,7                               // js            394d4 <_sk_evenly_spaced_gradient_sse2_lowp+0x34>
  .byte  243,72,15,42,211                    // cvtsi2ss      %rbx,%xmm2
  .byte  235,21                              // jmp           394e9 <_sk_evenly_spaced_gradient_sse2_lowp+0x49>
  .byte  73,137,216                          // mov           %rbx,%r8
  .byte  73,209,232                          // shr           %r8
  .byte  131,227,1                           // and           $0x1,%ebx
  .byte  76,9,195                            // or            %r8,%rbx
  .byte  243,72,15,42,211                    // cvtsi2ss      %rbx,%xmm2
  .byte  243,15,88,210                       // addss         %xmm2,%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,41,68,36,176                     // movaps        %xmm0,-0x50(%rsp)
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  243,15,91,218                       // cvttps2dq     %xmm2,%xmm3
  .byte  15,41,76,36,160                     // movaps        %xmm1,-0x60(%rsp)
  .byte  102,15,112,211,78                   // pshufd        $0x4e,%xmm3,%xmm2
  .byte  102,73,15,126,214                   // movq          %xmm2,%r14
  .byte  69,137,242                          // mov           %r14d,%r10d
  .byte  73,193,238,32                       // shr           $0x20,%r14
  .byte  102,73,15,126,221                   // movq          %xmm3,%r13
  .byte  69,137,239                          // mov           %r13d,%r15d
  .byte  73,193,237,32                       // shr           $0x20,%r13
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,73,15,126,201                   // movq          %xmm1,%r9
  .byte  69,137,200                          // mov           %r9d,%r8d
  .byte  73,193,233,32                       // shr           $0x20,%r9
  .byte  102,73,15,126,196                   // movq          %xmm0,%r12
  .byte  69,137,227                          // mov           %r12d,%r11d
  .byte  73,193,236,32                       // shr           $0x20,%r12
  .byte  243,66,15,16,68,165,0               // movss         0x0(%rbp,%r12,4),%xmm0
  .byte  243,70,15,16,68,157,0               // movss         0x0(%rbp,%r11,4),%xmm8
  .byte  243,66,15,16,76,141,0               // movss         0x0(%rbp,%r9,4),%xmm1
  .byte  243,66,15,16,84,133,0               // movss         0x0(%rbp,%r8,4),%xmm2
  .byte  243,66,15,16,100,173,0              // movss         0x0(%rbp,%r13,4),%xmm4
  .byte  243,66,15,16,92,189,0               // movss         0x0(%rbp,%r15,4),%xmm3
  .byte  243,66,15,16,108,181,0              // movss         0x0(%rbp,%r14,4),%xmm5
  .byte  243,66,15,16,116,149,0              // movss         0x0(%rbp,%r10,4),%xmm6
  .byte  68,15,20,192                        // unpcklps      %xmm0,%xmm8
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  102,68,15,20,194                    // unpcklpd      %xmm2,%xmm8
  .byte  15,20,220                           // unpcklps      %xmm4,%xmm3
  .byte  15,20,245                           // unpcklps      %xmm5,%xmm6
  .byte  102,15,20,222                       // unpcklpd      %xmm6,%xmm3
  .byte  72,139,88,16                        // mov           0x10(%rax),%rbx
  .byte  243,66,15,16,4,163                  // movss         (%rbx,%r12,4),%xmm0
  .byte  243,70,15,16,12,155                 // movss         (%rbx,%r11,4),%xmm9
  .byte  243,66,15,16,12,139                 // movss         (%rbx,%r9,4),%xmm1
  .byte  243,66,15,16,36,131                 // movss         (%rbx,%r8,4),%xmm4
  .byte  243,66,15,16,44,171                 // movss         (%rbx,%r13,4),%xmm5
  .byte  243,66,15,16,20,187                 // movss         (%rbx,%r15,4),%xmm2
  .byte  243,66,15,16,52,179                 // movss         (%rbx,%r14,4),%xmm6
  .byte  243,66,15,16,60,147                 // movss         (%rbx,%r10,4),%xmm7
  .byte  68,15,20,200                        // unpcklps      %xmm0,%xmm9
  .byte  15,20,225                           // unpcklps      %xmm1,%xmm4
  .byte  102,68,15,20,204                    // unpcklpd      %xmm4,%xmm9
  .byte  15,20,213                           // unpcklps      %xmm5,%xmm2
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  102,15,20,215                       // unpcklpd      %xmm7,%xmm2
  .byte  72,139,88,24                        // mov           0x18(%rax),%rbx
  .byte  243,66,15,16,4,163                  // movss         (%rbx,%r12,4),%xmm0
  .byte  243,70,15,16,28,155                 // movss         (%rbx,%r11,4),%xmm11
  .byte  68,15,20,216                        // unpcklps      %xmm0,%xmm11
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,66,15,16,4,171                  // movss         (%rbx,%r13,4),%xmm0
  .byte  243,70,15,16,44,187                 // movss         (%rbx,%r15,4),%xmm13
  .byte  243,66,15,16,36,179                 // movss         (%rbx,%r14,4),%xmm4
  .byte  243,66,15,16,44,147                 // movss         (%rbx,%r10,4),%xmm5
  .byte  102,68,15,20,217                    // unpcklpd      %xmm1,%xmm11
  .byte  68,15,20,232                        // unpcklps      %xmm0,%xmm13
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  102,68,15,20,237                    // unpcklpd      %xmm5,%xmm13
  .byte  72,139,88,32                        // mov           0x20(%rax),%rbx
  .byte  243,66,15,16,4,163                  // movss         (%rbx,%r12,4),%xmm0
  .byte  243,70,15,16,20,155                 // movss         (%rbx,%r11,4),%xmm10
  .byte  68,15,20,208                        // unpcklps      %xmm0,%xmm10
  .byte  243,66,15,16,4,139                  // movss         (%rbx,%r9,4),%xmm0
  .byte  243,66,15,16,12,131                 // movss         (%rbx,%r8,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  102,68,15,20,209                    // unpcklpd      %xmm1,%xmm10
  .byte  243,66,15,16,4,171                  // movss         (%rbx,%r13,4),%xmm0
  .byte  243,70,15,16,36,187                 // movss         (%rbx,%r15,4),%xmm12
  .byte  68,15,20,224                        // unpcklps      %xmm0,%xmm12
  .byte  243,66,15,16,4,179                  // movss         (%rbx,%r14,4),%xmm0
  .byte  243,66,15,16,12,147                 // movss         (%rbx,%r10,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  102,68,15,20,225                    // unpcklpd      %xmm1,%xmm12
  .byte  72,139,88,40                        // mov           0x28(%rax),%rbx
  .byte  243,66,15,16,12,171                 // movss         (%rbx,%r13,4),%xmm1
  .byte  243,66,15,16,4,187                  // movss         (%rbx,%r15,4),%xmm0
  .byte  15,20,193                           // unpcklps      %xmm1,%xmm0
  .byte  243,66,15,16,12,179                 // movss         (%rbx,%r14,4),%xmm1
  .byte  243,66,15,16,36,147                 // movss         (%rbx,%r10,4),%xmm4
  .byte  15,20,225                           // unpcklps      %xmm1,%xmm4
  .byte  102,15,20,196                       // unpcklpd      %xmm4,%xmm0
  .byte  243,66,15,16,36,163                 // movss         (%rbx,%r12,4),%xmm4
  .byte  243,66,15,16,12,155                 // movss         (%rbx,%r11,4),%xmm1
  .byte  15,20,204                           // unpcklps      %xmm4,%xmm1
  .byte  243,66,15,16,36,139                 // movss         (%rbx,%r9,4),%xmm4
  .byte  243,66,15,16,44,131                 // movss         (%rbx,%r8,4),%xmm5
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  102,15,20,205                       // unpcklpd      %xmm5,%xmm1
  .byte  72,139,88,48                        // mov           0x30(%rax),%rbx
  .byte  243,66,15,16,36,171                 // movss         (%rbx,%r13,4),%xmm4
  .byte  243,70,15,16,52,187                 // movss         (%rbx,%r15,4),%xmm14
  .byte  68,15,20,244                        // unpcklps      %xmm4,%xmm14
  .byte  243,66,15,16,36,179                 // movss         (%rbx,%r14,4),%xmm4
  .byte  243,66,15,16,44,147                 // movss         (%rbx,%r10,4),%xmm5
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  102,68,15,20,245                    // unpcklpd      %xmm5,%xmm14
  .byte  243,66,15,16,44,163                 // movss         (%rbx,%r12,4),%xmm5
  .byte  243,66,15,16,36,155                 // movss         (%rbx,%r11,4),%xmm4
  .byte  15,20,229                           // unpcklps      %xmm5,%xmm4
  .byte  243,66,15,16,44,139                 // movss         (%rbx,%r9,4),%xmm5
  .byte  243,66,15,16,60,131                 // movss         (%rbx,%r8,4),%xmm7
  .byte  15,20,253                           // unpcklps      %xmm5,%xmm7
  .byte  102,15,20,231                       // unpcklpd      %xmm7,%xmm4
  .byte  72,139,88,56                        // mov           0x38(%rax),%rbx
  .byte  243,66,15,16,44,171                 // movss         (%rbx,%r13,4),%xmm5
  .byte  243,66,15,16,52,187                 // movss         (%rbx,%r15,4),%xmm6
  .byte  15,20,245                           // unpcklps      %xmm5,%xmm6
  .byte  243,66,15,16,44,179                 // movss         (%rbx,%r14,4),%xmm5
  .byte  243,66,15,16,60,147                 // movss         (%rbx,%r10,4),%xmm7
  .byte  15,20,253                           // unpcklps      %xmm5,%xmm7
  .byte  102,15,20,247                       // unpcklpd      %xmm7,%xmm6
  .byte  102,15,41,116,36,128                // movapd        %xmm6,-0x80(%rsp)
  .byte  243,66,15,16,60,163                 // movss         (%rbx,%r12,4),%xmm7
  .byte  243,66,15,16,44,155                 // movss         (%rbx,%r11,4),%xmm5
  .byte  15,20,239                           // unpcklps      %xmm7,%xmm5
  .byte  243,66,15,16,60,139                 // movss         (%rbx,%r9,4),%xmm7
  .byte  243,66,15,16,52,131                 // movss         (%rbx,%r8,4),%xmm6
  .byte  15,20,247                           // unpcklps      %xmm7,%xmm6
  .byte  102,15,20,238                       // unpcklpd      %xmm6,%xmm5
  .byte  72,139,64,64                        // mov           0x40(%rax),%rax
  .byte  243,66,15,16,52,168                 // movss         (%rax,%r13,4),%xmm6
  .byte  243,66,15,16,60,184                 // movss         (%rax,%r15,4),%xmm7
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  243,70,15,16,60,176                 // movss         (%rax,%r14,4),%xmm15
  .byte  243,66,15,16,52,144                 // movss         (%rax,%r10,4),%xmm6
  .byte  65,15,20,247                        // unpcklps      %xmm15,%xmm6
  .byte  102,15,20,254                       // unpcklpd      %xmm6,%xmm7
  .byte  102,15,41,124,36,144                // movapd        %xmm7,-0x70(%rsp)
  .byte  243,66,15,16,52,160                 // movss         (%rax,%r12,4),%xmm6
  .byte  243,66,15,16,60,152                 // movss         (%rax,%r11,4),%xmm7
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  243,66,15,16,52,136                 // movss         (%rax,%r9,4),%xmm6
  .byte  243,70,15,16,60,128                 // movss         (%rax,%r8,4),%xmm15
  .byte  68,15,20,254                        // unpcklps      %xmm6,%xmm15
  .byte  102,65,15,20,255                    // unpcklpd      %xmm15,%xmm7
  .byte  68,15,40,124,36,160                 // movaps        -0x60(%rsp),%xmm15
  .byte  65,15,89,223                        // mulps         %xmm15,%xmm3
  .byte  15,88,216                           // addps         %xmm0,%xmm3
  .byte  15,40,68,36,176                     // movaps        -0x50(%rsp),%xmm0
  .byte  68,15,89,192                        // mulps         %xmm0,%xmm8
  .byte  68,15,88,193                        // addps         %xmm1,%xmm8
  .byte  15,40,13,111,20,0,0                 // movaps        0x146f(%rip),%xmm1        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  68,15,89,193                        // mulps         %xmm1,%xmm8
  .byte  15,40,13,113,19,0,0                 // movaps        0x1371(%rip),%xmm1        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,88,193                        // addps         %xmm1,%xmm8
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  243,15,91,219                       // cvttps2dq     %xmm3,%xmm3
  .byte  242,15,112,219,232                  // pshuflw       $0xe8,%xmm3,%xmm3
  .byte  243,15,112,219,232                  // pshufhw       $0xe8,%xmm3,%xmm3
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  243,65,15,91,240                    // cvttps2dq     %xmm8,%xmm6
  .byte  242,15,112,246,232                  // pshuflw       $0xe8,%xmm6,%xmm6
  .byte  243,15,112,246,232                  // pshufhw       $0xe8,%xmm6,%xmm6
  .byte  102,68,15,112,198,232               // pshufd        $0xe8,%xmm6,%xmm8
  .byte  102,68,15,108,195                   // punpcklqdq    %xmm3,%xmm8
  .byte  65,15,89,215                        // mulps         %xmm15,%xmm2
  .byte  65,15,88,214                        // addps         %xmm14,%xmm2
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  68,15,89,206                        // mulps         %xmm6,%xmm9
  .byte  68,15,88,204                        // addps         %xmm4,%xmm9
  .byte  15,40,5,19,20,0,0                   // movaps        0x1413(%rip),%xmm0        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  68,15,88,201                        // addps         %xmm1,%xmm9
  .byte  15,88,209                           // addps         %xmm1,%xmm2
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  242,15,112,210,232                  // pshuflw       $0xe8,%xmm2,%xmm2
  .byte  243,15,112,210,232                  // pshufhw       $0xe8,%xmm2,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  243,65,15,91,217                    // cvttps2dq     %xmm9,%xmm3
  .byte  242,15,112,219,232                  // pshuflw       $0xe8,%xmm3,%xmm3
  .byte  243,15,112,219,232                  // pshufhw       $0xe8,%xmm3,%xmm3
  .byte  102,68,15,112,203,232               // pshufd        $0xe8,%xmm3,%xmm9
  .byte  102,68,15,108,202                   // punpcklqdq    %xmm2,%xmm9
  .byte  69,15,89,239                        // mulps         %xmm15,%xmm13
  .byte  68,15,88,108,36,128                 // addps         -0x80(%rsp),%xmm13
  .byte  68,15,89,222                        // mulps         %xmm6,%xmm11
  .byte  68,15,88,221                        // addps         %xmm5,%xmm11
  .byte  68,15,89,232                        // mulps         %xmm0,%xmm13
  .byte  68,15,89,216                        // mulps         %xmm0,%xmm11
  .byte  68,15,88,217                        // addps         %xmm1,%xmm11
  .byte  68,15,88,233                        // addps         %xmm1,%xmm13
  .byte  243,65,15,91,213                    // cvttps2dq     %xmm13,%xmm2
  .byte  242,15,112,210,232                  // pshuflw       $0xe8,%xmm2,%xmm2
  .byte  243,15,112,210,232                  // pshufhw       $0xe8,%xmm2,%xmm2
  .byte  102,15,112,218,232                  // pshufd        $0xe8,%xmm2,%xmm3
  .byte  243,65,15,91,211                    // cvttps2dq     %xmm11,%xmm2
  .byte  242,15,112,210,232                  // pshuflw       $0xe8,%xmm2,%xmm2
  .byte  243,15,112,210,232                  // pshufhw       $0xe8,%xmm2,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,108,211                      // punpcklqdq    %xmm3,%xmm2
  .byte  69,15,89,231                        // mulps         %xmm15,%xmm12
  .byte  68,15,88,100,36,144                 // addps         -0x70(%rsp),%xmm12
  .byte  68,15,89,214                        // mulps         %xmm6,%xmm10
  .byte  68,15,88,215                        // addps         %xmm7,%xmm10
  .byte  68,15,89,224                        // mulps         %xmm0,%xmm12
  .byte  68,15,89,208                        // mulps         %xmm0,%xmm10
  .byte  68,15,88,209                        // addps         %xmm1,%xmm10
  .byte  68,15,88,225                        // addps         %xmm1,%xmm12
  .byte  243,65,15,91,196                    // cvttps2dq     %xmm12,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  243,65,15,91,202                    // cvttps2dq     %xmm10,%xmm1
  .byte  242,15,112,201,232                  // pshuflw       $0xe8,%xmm1,%xmm1
  .byte  243,15,112,201,232                  // pshufhw       $0xe8,%xmm1,%xmm1
  .byte  102,15,112,217,232                  // pshufd        $0xe8,%xmm1,%xmm3
  .byte  102,15,108,216                      // punpcklqdq    %xmm0,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  15,40,100,36,192                    // movaps        -0x40(%rsp),%xmm4
  .byte  15,40,108,36,208                    // movaps        -0x30(%rsp),%xmm5
  .byte  15,40,116,36,224                    // movaps        -0x20(%rsp),%xmm6
  .byte  15,40,124,36,240                    // movaps        -0x10(%rsp),%xmm7
  .byte  72,131,196,8                        // add           $0x8,%rsp
  .byte  91                                  // pop           %rbx
  .byte  65,92                               // pop           %r12
  .byte  65,93                               // pop           %r13
  .byte  65,94                               // pop           %r14
  .byte  65,95                               // pop           %r15
  .byte  93                                  // pop           %rbp
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_evenly_spaced_2_stop_gradient_sse2_lowp
.globl _sk_evenly_spaced_2_stop_gradient_sse2_lowp
FUNCTION(_sk_evenly_spaced_2_stop_gradient_sse2_lowp)
_sk_evenly_spaced_2_stop_gradient_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  243,15,16,24                        // movss         (%rax),%xmm3
  .byte  243,68,15,16,72,4                   // movss         0x4(%rax),%xmm9
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  243,68,15,16,64,16                  // movss         0x10(%rax),%xmm8
  .byte  69,15,198,192,0                     // shufps        $0x0,%xmm8,%xmm8
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  65,15,88,216                        // addps         %xmm8,%xmm3
  .byte  65,15,88,208                        // addps         %xmm8,%xmm2
  .byte  68,15,40,21,216,18,0,0              // movaps        0x12d8(%rip),%xmm10        # 3ac30 <_sk_srcover_bgra_8888_sse2_lowp+0xcc8>
  .byte  65,15,89,210                        // mulps         %xmm10,%xmm2
  .byte  65,15,89,218                        // mulps         %xmm10,%xmm3
  .byte  68,15,40,29,216,17,0,0              // movaps        0x11d8(%rip),%xmm11        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  65,15,88,219                        // addps         %xmm11,%xmm3
  .byte  65,15,88,211                        // addps         %xmm11,%xmm2
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  242,15,112,210,232                  // pshuflw       $0xe8,%xmm2,%xmm2
  .byte  243,15,112,210,232                  // pshufhw       $0xe8,%xmm2,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  243,15,91,219                       // cvttps2dq     %xmm3,%xmm3
  .byte  242,15,112,219,232                  // pshuflw       $0xe8,%xmm3,%xmm3
  .byte  243,15,112,219,232                  // pshufhw       $0xe8,%xmm3,%xmm3
  .byte  102,68,15,112,195,232               // pshufd        $0xe8,%xmm3,%xmm8
  .byte  102,68,15,108,194                   // punpcklqdq    %xmm2,%xmm8
  .byte  69,15,198,201,0                     // shufps        $0x0,%xmm9,%xmm9
  .byte  243,15,16,80,20                     // movss         0x14(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  65,15,89,217                        // mulps         %xmm9,%xmm3
  .byte  68,15,89,200                        // mulps         %xmm0,%xmm9
  .byte  68,15,88,202                        // addps         %xmm2,%xmm9
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  65,15,89,218                        // mulps         %xmm10,%xmm3
  .byte  69,15,89,202                        // mulps         %xmm10,%xmm9
  .byte  69,15,88,203                        // addps         %xmm11,%xmm9
  .byte  65,15,88,219                        // addps         %xmm11,%xmm3
  .byte  243,15,91,211                       // cvttps2dq     %xmm3,%xmm2
  .byte  242,15,112,210,232                  // pshuflw       $0xe8,%xmm2,%xmm2
  .byte  243,15,112,210,232                  // pshufhw       $0xe8,%xmm2,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  243,65,15,91,217                    // cvttps2dq     %xmm9,%xmm3
  .byte  242,15,112,219,232                  // pshuflw       $0xe8,%xmm3,%xmm3
  .byte  243,15,112,219,232                  // pshufhw       $0xe8,%xmm3,%xmm3
  .byte  102,68,15,112,203,232               // pshufd        $0xe8,%xmm3,%xmm9
  .byte  102,68,15,108,202                   // punpcklqdq    %xmm2,%xmm9
  .byte  243,15,16,80,8                      // movss         0x8(%rax),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,68,15,16,96,24                  // movss         0x18(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  15,89,218                           // mulps         %xmm2,%xmm3
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  65,15,88,212                        // addps         %xmm12,%xmm2
  .byte  65,15,88,220                        // addps         %xmm12,%xmm3
  .byte  65,15,89,218                        // mulps         %xmm10,%xmm3
  .byte  65,15,89,210                        // mulps         %xmm10,%xmm2
  .byte  65,15,88,211                        // addps         %xmm11,%xmm2
  .byte  65,15,88,219                        // addps         %xmm11,%xmm3
  .byte  243,15,91,219                       // cvttps2dq     %xmm3,%xmm3
  .byte  242,15,112,219,232                  // pshuflw       $0xe8,%xmm3,%xmm3
  .byte  243,15,112,219,232                  // pshufhw       $0xe8,%xmm3,%xmm3
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  242,15,112,210,232                  // pshuflw       $0xe8,%xmm2,%xmm2
  .byte  243,15,112,210,232                  // pshufhw       $0xe8,%xmm2,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,108,211                      // punpcklqdq    %xmm3,%xmm2
  .byte  243,15,16,88,12                     // movss         0xc(%rax),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  243,68,15,16,96,28                  // movss         0x1c(%rax),%xmm12
  .byte  69,15,198,228,0                     // shufps        $0x0,%xmm12,%xmm12
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  65,15,88,220                        // addps         %xmm12,%xmm3
  .byte  65,15,88,204                        // addps         %xmm12,%xmm1
  .byte  65,15,89,202                        // mulps         %xmm10,%xmm1
  .byte  65,15,89,218                        // mulps         %xmm10,%xmm3
  .byte  65,15,88,219                        // addps         %xmm11,%xmm3
  .byte  65,15,88,203                        // addps         %xmm11,%xmm1
  .byte  243,15,91,193                       // cvttps2dq     %xmm1,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  243,15,91,203                       // cvttps2dq     %xmm3,%xmm1
  .byte  242,15,112,201,232                  // pshuflw       $0xe8,%xmm1,%xmm1
  .byte  243,15,112,201,232                  // pshufhw       $0xe8,%xmm1,%xmm1
  .byte  102,15,112,217,232                  // pshufd        $0xe8,%xmm1,%xmm3
  .byte  102,15,108,216                      // punpcklqdq    %xmm0,%xmm3
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,192                   // movdqa        %xmm8,%xmm0
  .byte  102,65,15,111,201                   // movdqa        %xmm9,%xmm1
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_unit_angle_sse2_lowp
.globl _sk_xy_to_unit_angle_sse2_lowp
FUNCTION(_sk_xy_to_unit_angle_sse2_lowp)
_sk_xy_to_unit_angle_sse2_lowp:
  .byte  15,41,124,36,232                    // movaps        %xmm7,-0x18(%rsp)
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  68,15,40,37,140,21,0,0              // movaps        0x158c(%rip),%xmm12        # 3b070 <_sk_srcover_bgra_8888_sse2_lowp+0x1108>
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  69,15,84,196                        // andps         %xmm12,%xmm8
  .byte  68,15,40,217                        // movaps        %xmm1,%xmm11
  .byte  69,15,84,220                        // andps         %xmm12,%xmm11
  .byte  68,15,40,236                        // movaps        %xmm4,%xmm13
  .byte  69,15,84,236                        // andps         %xmm12,%xmm13
  .byte  68,15,84,227                        // andps         %xmm3,%xmm12
  .byte  69,15,40,211                        // movaps        %xmm11,%xmm10
  .byte  69,15,194,212,1                     // cmpltps       %xmm12,%xmm10
  .byte  69,15,40,200                        // movaps        %xmm8,%xmm9
  .byte  69,15,194,205,1                     // cmpltps       %xmm13,%xmm9
  .byte  69,15,40,241                        // movaps        %xmm9,%xmm14
  .byte  69,15,85,245                        // andnps        %xmm13,%xmm14
  .byte  69,15,40,249                        // movaps        %xmm9,%xmm15
  .byte  69,15,85,248                        // andnps        %xmm8,%xmm15
  .byte  69,15,84,193                        // andps         %xmm9,%xmm8
  .byte  69,15,86,198                        // orps          %xmm14,%xmm8
  .byte  69,15,40,242                        // movaps        %xmm10,%xmm14
  .byte  69,15,85,244                        // andnps        %xmm12,%xmm14
  .byte  65,15,40,194                        // movaps        %xmm10,%xmm0
  .byte  65,15,85,195                        // andnps        %xmm11,%xmm0
  .byte  69,15,84,218                        // andps         %xmm10,%xmm11
  .byte  69,15,86,222                        // orps          %xmm14,%xmm11
  .byte  69,15,84,233                        // andps         %xmm9,%xmm13
  .byte  69,15,86,239                        // orps          %xmm15,%xmm13
  .byte  69,15,94,197                        // divps         %xmm13,%xmm8
  .byte  69,15,84,226                        // andps         %xmm10,%xmm12
  .byte  68,15,86,224                        // orps          %xmm0,%xmm12
  .byte  69,15,94,220                        // divps         %xmm12,%xmm11
  .byte  69,15,40,240                        // movaps        %xmm8,%xmm14
  .byte  69,15,89,246                        // mulps         %xmm14,%xmm14
  .byte  65,15,40,195                        // movaps        %xmm11,%xmm0
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  68,15,40,37,111,21,0,0              // movaps        0x156f(%rip),%xmm12        # 3b0e0 <_sk_srcover_bgra_8888_sse2_lowp+0x1178>
  .byte  68,15,40,232                        // movaps        %xmm0,%xmm13
  .byte  69,15,89,236                        // mulps         %xmm12,%xmm13
  .byte  69,15,89,230                        // mulps         %xmm14,%xmm12
  .byte  68,15,40,61,107,21,0,0              // movaps        0x156b(%rip),%xmm15        # 3b0f0 <_sk_srcover_bgra_8888_sse2_lowp+0x1188>
  .byte  69,15,88,231                        // addps         %xmm15,%xmm12
  .byte  69,15,88,239                        // addps         %xmm15,%xmm13
  .byte  68,15,89,232                        // mulps         %xmm0,%xmm13
  .byte  69,15,89,230                        // mulps         %xmm14,%xmm12
  .byte  68,15,40,61,99,21,0,0               // movaps        0x1563(%rip),%xmm15        # 3b100 <_sk_srcover_bgra_8888_sse2_lowp+0x1198>
  .byte  69,15,88,231                        // addps         %xmm15,%xmm12
  .byte  69,15,88,239                        // addps         %xmm15,%xmm13
  .byte  68,15,89,232                        // mulps         %xmm0,%xmm13
  .byte  69,15,89,230                        // mulps         %xmm14,%xmm12
  .byte  15,40,5,92,21,0,0                   // movaps        0x155c(%rip),%xmm0        # 3b110 <_sk_srcover_bgra_8888_sse2_lowp+0x11a8>
  .byte  68,15,88,224                        // addps         %xmm0,%xmm12
  .byte  68,15,88,232                        // addps         %xmm0,%xmm13
  .byte  69,15,89,235                        // mulps         %xmm11,%xmm13
  .byte  69,15,89,224                        // mulps         %xmm8,%xmm12
  .byte  15,40,5,85,21,0,0                   // movaps        0x1555(%rip),%xmm0        # 3b120 <_sk_srcover_bgra_8888_sse2_lowp+0x11b8>
  .byte  68,15,40,192                        // movaps        %xmm0,%xmm8
  .byte  65,15,92,197                        // subps         %xmm13,%xmm0
  .byte  65,15,84,194                        // andps         %xmm10,%xmm0
  .byte  69,15,85,213                        // andnps        %xmm13,%xmm10
  .byte  69,15,92,196                        // subps         %xmm12,%xmm8
  .byte  68,15,86,208                        // orps          %xmm0,%xmm10
  .byte  69,15,84,193                        // andps         %xmm9,%xmm8
  .byte  69,15,85,204                        // andnps        %xmm12,%xmm9
  .byte  69,15,86,200                        // orps          %xmm8,%xmm9
  .byte  69,15,87,192                        // xorps         %xmm8,%xmm8
  .byte  65,15,194,200,1                     // cmpltps       %xmm8,%xmm1
  .byte  15,40,5,65,15,0,0                   // movaps        0xf41(%rip),%xmm0        # 3ab40 <_sk_srcover_bgra_8888_sse2_lowp+0xbd8>
  .byte  68,15,40,216                        // movaps        %xmm0,%xmm11
  .byte  65,15,92,194                        // subps         %xmm10,%xmm0
  .byte  15,84,193                           // andps         %xmm1,%xmm0
  .byte  65,15,85,202                        // andnps        %xmm10,%xmm1
  .byte  65,15,194,208,1                     // cmpltps       %xmm8,%xmm2
  .byte  69,15,92,217                        // subps         %xmm9,%xmm11
  .byte  15,86,200                           // orps          %xmm0,%xmm1
  .byte  68,15,84,218                        // andps         %xmm2,%xmm11
  .byte  65,15,85,209                        // andnps        %xmm9,%xmm2
  .byte  65,15,86,211                        // orps          %xmm11,%xmm2
  .byte  68,15,40,219                        // movaps        %xmm3,%xmm11
  .byte  69,15,194,216,1                     // cmpltps       %xmm8,%xmm11
  .byte  68,15,40,13,25,15,0,0               // movaps        0xf19(%rip),%xmm9        # 3ab50 <_sk_srcover_bgra_8888_sse2_lowp+0xbe8>
  .byte  69,15,40,209                        // movaps        %xmm9,%xmm10
  .byte  68,15,92,201                        // subps         %xmm1,%xmm9
  .byte  69,15,84,203                        // andps         %xmm11,%xmm9
  .byte  68,15,85,217                        // andnps        %xmm1,%xmm11
  .byte  69,15,86,217                        // orps          %xmm9,%xmm11
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  65,15,194,192,1                     // cmpltps       %xmm8,%xmm0
  .byte  68,15,92,210                        // subps         %xmm2,%xmm10
  .byte  68,15,84,208                        // andps         %xmm0,%xmm10
  .byte  15,85,194                           // andnps        %xmm2,%xmm0
  .byte  65,15,86,194                        // orps          %xmm10,%xmm0
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  65,15,194,200,7                     // cmpordps      %xmm8,%xmm1
  .byte  69,15,194,195,7                     // cmpordps      %xmm11,%xmm8
  .byte  69,15,84,195                        // andps         %xmm11,%xmm8
  .byte  15,84,200                           // andps         %xmm0,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  65,15,40,192                        // movaps        %xmm8,%xmm0
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,40,238                           // movaps        %xmm6,%xmm5
  .byte  15,40,247                           // movaps        %xmm7,%xmm6
  .byte  15,40,124,36,232                    // movaps        -0x18(%rsp),%xmm7
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_xy_to_radius_sse2_lowp
.globl _sk_xy_to_radius_sse2_lowp
FUNCTION(_sk_xy_to_radius_sse2_lowp)
_sk_xy_to_radius_sse2_lowp:
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  15,89,201                           // mulps         %xmm1,%xmm1
  .byte  68,15,40,194                        // movaps        %xmm2,%xmm8
  .byte  69,15,89,192                        // mulps         %xmm8,%xmm8
  .byte  68,15,88,192                        // addps         %xmm0,%xmm8
  .byte  68,15,40,203                        // movaps        %xmm3,%xmm9
  .byte  69,15,89,201                        // mulps         %xmm9,%xmm9
  .byte  68,15,88,201                        // addps         %xmm1,%xmm9
  .byte  65,15,81,192                        // sqrtps        %xmm8,%xmm0
  .byte  65,15,81,201                        // sqrtps        %xmm9,%xmm1
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  255,224                             // jmpq          *%rax

HIDDEN _sk_srcover_rgba_8888_sse2_lowp
.globl _sk_srcover_rgba_8888_sse2_lowp
FUNCTION(_sk_srcover_rgba_8888_sse2_lowp)
_sk_srcover_rgba_8888_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  65,137,250                          // mov           %edi,%r10d
  .byte  65,128,226,7                        // and           $0x7,%r10b
  .byte  65,254,202                          // dec           %r10b
  .byte  69,15,182,202                       // movzbl        %r10b,%r9d
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,38                              // ja            39d07 <_sk_srcover_rgba_8888_sse2_lowp+0x4b>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  76,141,29,67,2,0,0                  // lea           0x243(%rip),%r11        # 39f30 <_sk_srcover_rgba_8888_sse2_lowp+0x274>
  .byte  75,99,4,139                         // movslq        (%r11,%r9,4),%rax
  .byte  76,1,216                            // add           %r11,%rax
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  255,224                             // jmpq          *%rax
  .byte  243,65,15,16,60,144                 // movss         (%r8,%rdx,4),%xmm7
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  235,102                             // jmp           39d6d <_sk_srcover_rgba_8888_sse2_lowp+0xb1>
  .byte  102,65,15,16,60,144                 // movupd        (%r8,%rdx,4),%xmm7
  .byte  243,69,15,111,68,144,16             // movdqu        0x10(%r8,%rdx,4),%xmm8
  .byte  235,87                              // jmp           39d6d <_sk_srcover_rgba_8888_sse2_lowp+0xb1>
  .byte  102,65,15,110,100,144,8             // movd          0x8(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,69,15,18,4,144                  // movlpd        (%r8,%rdx,4),%xmm8
  .byte  102,65,15,40,248                    // movapd        %xmm8,%xmm7
  .byte  102,68,15,111,196                   // movdqa        %xmm4,%xmm8
  .byte  235,52                              // jmp           39d6d <_sk_srcover_rgba_8888_sse2_lowp+0xb1>
  .byte  102,65,15,110,100,144,24            // movd          0x18(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  243,65,15,16,100,144,20             // movss         0x14(%r8,%rdx,4),%xmm4
  .byte  65,15,198,224,0                     // shufps        $0x0,%xmm8,%xmm4
  .byte  65,15,198,224,226                   // shufps        $0xe2,%xmm8,%xmm4
  .byte  68,15,40,196                        // movaps        %xmm4,%xmm8
  .byte  243,65,15,16,100,144,16             // movss         0x10(%r8,%rdx,4),%xmm4
  .byte  243,68,15,16,196                    // movss         %xmm4,%xmm8
  .byte  102,65,15,16,60,144                 // movupd        (%r8,%rdx,4),%xmm7
  .byte  102,15,40,239                       // movapd        %xmm7,%xmm5
  .byte  102,15,114,245,16                   // pslld         $0x10,%xmm5
  .byte  102,15,114,229,16                   // psrad         $0x10,%xmm5
  .byte  102,65,15,111,224                   // movdqa        %xmm8,%xmm4
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,107,236                      // packssdw      %xmm4,%xmm5
  .byte  102,68,15,111,37,89,13,0,0          // movdqa        0xd59(%rip),%xmm12        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,65,15,219,228                   // pand          %xmm12,%xmm4
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,65,15,114,209,16                // psrld         $0x10,%xmm9
  .byte  102,15,40,247                       // movapd        %xmm7,%xmm6
  .byte  102,15,114,214,16                   // psrld         $0x10,%xmm6
  .byte  102,15,114,215,24                   // psrld         $0x18,%xmm7
  .byte  102,15,114,247,16                   // pslld         $0x10,%xmm7
  .byte  102,15,114,231,16                   // psrad         $0x10,%xmm7
  .byte  102,65,15,114,208,24                // psrld         $0x18,%xmm8
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,114,224,16                // psrad         $0x10,%xmm8
  .byte  102,65,15,107,248                   // packssdw      %xmm8,%xmm7
  .byte  102,15,114,246,16                   // pslld         $0x10,%xmm6
  .byte  102,15,114,230,16                   // psrad         $0x10,%xmm6
  .byte  102,65,15,114,241,16                // pslld         $0x10,%xmm9
  .byte  102,65,15,114,225,16                // psrad         $0x10,%xmm9
  .byte  102,65,15,107,241                   // packssdw      %xmm9,%xmm6
  .byte  102,65,15,219,244                   // pand          %xmm12,%xmm6
  .byte  102,69,15,111,196                   // movdqa        %xmm12,%xmm8
  .byte  102,68,15,249,195                   // psubw         %xmm3,%xmm8
  .byte  102,68,15,111,204                   // movdqa        %xmm4,%xmm9
  .byte  102,69,15,213,200                   // pmullw        %xmm8,%xmm9
  .byte  102,69,15,253,204                   // paddw         %xmm12,%xmm9
  .byte  102,65,15,113,209,8                 // psrlw         $0x8,%xmm9
  .byte  102,68,15,253,200                   // paddw         %xmm0,%xmm9
  .byte  102,68,15,111,213                   // movdqa        %xmm5,%xmm10
  .byte  102,69,15,213,208                   // pmullw        %xmm8,%xmm10
  .byte  102,69,15,253,212                   // paddw         %xmm12,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,68,15,253,209                   // paddw         %xmm1,%xmm10
  .byte  102,68,15,111,222                   // movdqa        %xmm6,%xmm11
  .byte  102,69,15,213,216                   // pmullw        %xmm8,%xmm11
  .byte  102,69,15,253,220                   // paddw         %xmm12,%xmm11
  .byte  102,65,15,113,211,8                 // psrlw         $0x8,%xmm11
  .byte  102,68,15,253,218                   // paddw         %xmm2,%xmm11
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,69,15,253,196                   // paddw         %xmm12,%xmm8
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  102,68,15,253,195                   // paddw         %xmm3,%xmm8
  .byte  102,65,15,111,210                   // movdqa        %xmm10,%xmm2
  .byte  102,15,113,242,8                    // psllw         $0x8,%xmm2
  .byte  102,65,15,235,209                   // por           %xmm9,%xmm2
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,97,216                       // punpcklwd     %xmm0,%xmm3
  .byte  102,15,105,208                      // punpckhwd     %xmm0,%xmm2
  .byte  102,65,15,111,200                   // movdqa        %xmm8,%xmm1
  .byte  102,15,113,241,8                    // psllw         $0x8,%xmm1
  .byte  102,65,15,235,203                   // por           %xmm11,%xmm1
  .byte  102,69,15,239,228                   // pxor          %xmm12,%xmm12
  .byte  102,68,15,97,225                    // punpcklwd     %xmm1,%xmm12
  .byte  102,68,15,235,227                   // por           %xmm3,%xmm12
  .byte  102,15,105,193                      // punpckhwd     %xmm1,%xmm0
  .byte  102,15,235,194                      // por           %xmm2,%xmm0
  .byte  65,128,250,6                        // cmp           $0x6,%r10b
  .byte  119,24                              // ja            39ecf <_sk_srcover_rgba_8888_sse2_lowp+0x213>
  .byte  76,141,21,142,0,0,0                 // lea           0x8e(%rip),%r10        # 39f4c <_sk_srcover_rgba_8888_sse2_lowp+0x290>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,126,36,144                // movd          %xmm12,(%r8,%rdx,4)
  .byte  235,73                              // jmp           39f18 <_sk_srcover_rgba_8888_sse2_lowp+0x25c>
  .byte  243,69,15,127,36,144                // movdqu        %xmm12,(%r8,%rdx,4)
  .byte  243,65,15,127,68,144,16             // movdqu        %xmm0,0x10(%r8,%rdx,4)
  .byte  235,58                              // jmp           39f18 <_sk_srcover_rgba_8888_sse2_lowp+0x25c>
  .byte  102,65,15,112,196,78                // pshufd        $0x4e,%xmm12,%xmm0
  .byte  102,65,15,126,68,144,8              // movd          %xmm0,0x8(%r8,%rdx,4)
  .byte  102,69,15,214,36,144                // movq          %xmm12,(%r8,%rdx,4)
  .byte  235,37                              // jmp           39f18 <_sk_srcover_rgba_8888_sse2_lowp+0x25c>
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,65,15,126,76,144,24             // movd          %xmm1,0x18(%r8,%rdx,4)
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,65,15,126,76,144,20             // movd          %xmm1,0x14(%r8,%rdx,4)
  .byte  102,65,15,126,68,144,16             // movd          %xmm0,0x10(%r8,%rdx,4)
  .byte  243,69,15,127,36,144                // movdqu        %xmm12,(%r8,%rdx,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,65,15,111,202                   // movdqa        %xmm10,%xmm1
  .byte  102,65,15,111,211                   // movdqa        %xmm11,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  202,253,255                         // lret          $0xfffd
  .byte  255,247                             // push          %rdi
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,230                             // jmpq          *%rsi
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,55                              // pushq         (%rdi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,43                              // ljmp          *(%rbx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,22                              // callq         *(%rsi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,9                               // decl          (%rcx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  123,255                             // jnp           39f4d <_sk_srcover_rgba_8888_sse2_lowp+0x291>
  .byte  255                                 // (bad)
  .byte  255,159,255,255,255,146             // lcall         *-0x6d000001(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,198                             // inc           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  191,255,255,255,179                 // mov           $0xb3ffffff,%edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  167                                 // cmpsl         %es:(%rdi),%ds:(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

HIDDEN _sk_srcover_bgra_8888_sse2_lowp
.globl _sk_srcover_bgra_8888_sse2_lowp
FUNCTION(_sk_srcover_bgra_8888_sse2_lowp)
_sk_srcover_bgra_8888_sse2_lowp:
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  76,99,64,8                          // movslq        0x8(%rax),%r8
  .byte  76,15,175,193                       // imul          %rcx,%r8
  .byte  73,193,224,2                        // shl           $0x2,%r8
  .byte  76,3,0                              // add           (%rax),%r8
  .byte  65,137,250                          // mov           %edi,%r10d
  .byte  65,128,226,7                        // and           $0x7,%r10b
  .byte  65,254,202                          // dec           %r10b
  .byte  69,15,182,202                       // movzbl        %r10b,%r9d
  .byte  65,128,249,6                        // cmp           $0x6,%r9b
  .byte  119,38                              // ja            39fb3 <_sk_srcover_bgra_8888_sse2_lowp+0x4b>
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  76,141,29,67,2,0,0                  // lea           0x243(%rip),%r11        # 3a1dc <_sk_srcover_bgra_8888_sse2_lowp+0x274>
  .byte  75,99,4,139                         // movslq        (%r11,%r9,4),%rax
  .byte  76,1,216                            // add           %r11,%rax
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  255,224                             // jmpq          *%rax
  .byte  243,65,15,16,60,144                 // movss         (%r8,%rdx,4),%xmm7
  .byte  102,69,15,239,192                   // pxor          %xmm8,%xmm8
  .byte  235,102                             // jmp           3a019 <_sk_srcover_bgra_8888_sse2_lowp+0xb1>
  .byte  102,65,15,16,60,144                 // movupd        (%r8,%rdx,4),%xmm7
  .byte  243,69,15,111,68,144,16             // movdqu        0x10(%r8,%rdx,4),%xmm8
  .byte  235,87                              // jmp           3a019 <_sk_srcover_bgra_8888_sse2_lowp+0xb1>
  .byte  102,65,15,110,100,144,8             // movd          0x8(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,69,15,18,4,144                  // movlpd        (%r8,%rdx,4),%xmm8
  .byte  102,65,15,40,248                    // movapd        %xmm8,%xmm7
  .byte  102,68,15,111,196                   // movdqa        %xmm4,%xmm8
  .byte  235,52                              // jmp           3a019 <_sk_srcover_bgra_8888_sse2_lowp+0xb1>
  .byte  102,65,15,110,100,144,24            // movd          0x18(%r8,%rdx,4),%xmm4
  .byte  102,68,15,112,196,69                // pshufd        $0x45,%xmm4,%xmm8
  .byte  243,65,15,16,100,144,20             // movss         0x14(%r8,%rdx,4),%xmm4
  .byte  65,15,198,224,0                     // shufps        $0x0,%xmm8,%xmm4
  .byte  65,15,198,224,226                   // shufps        $0xe2,%xmm8,%xmm4
  .byte  68,15,40,196                        // movaps        %xmm4,%xmm8
  .byte  243,65,15,16,100,144,16             // movss         0x10(%r8,%rdx,4),%xmm4
  .byte  243,68,15,16,196                    // movss         %xmm4,%xmm8
  .byte  102,65,15,16,60,144                 // movupd        (%r8,%rdx,4),%xmm7
  .byte  102,15,40,239                       // movapd        %xmm7,%xmm5
  .byte  102,15,114,245,16                   // pslld         $0x10,%xmm5
  .byte  102,15,114,229,16                   // psrad         $0x10,%xmm5
  .byte  102,65,15,111,224                   // movdqa        %xmm8,%xmm4
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,107,236                      // packssdw      %xmm4,%xmm5
  .byte  102,68,15,111,37,173,10,0,0         // movdqa        0xaad(%rip),%xmm12        # 3aaf0 <_sk_srcover_bgra_8888_sse2_lowp+0xb88>
  .byte  102,15,111,245                      // movdqa        %xmm5,%xmm6
  .byte  102,65,15,219,244                   // pand          %xmm12,%xmm6
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,69,15,111,200                   // movdqa        %xmm8,%xmm9
  .byte  102,65,15,114,209,16                // psrld         $0x10,%xmm9
  .byte  102,15,40,231                       // movapd        %xmm7,%xmm4
  .byte  102,15,114,212,16                   // psrld         $0x10,%xmm4
  .byte  102,15,114,215,24                   // psrld         $0x18,%xmm7
  .byte  102,15,114,247,16                   // pslld         $0x10,%xmm7
  .byte  102,15,114,231,16                   // psrad         $0x10,%xmm7
  .byte  102,65,15,114,208,24                // psrld         $0x18,%xmm8
  .byte  102,65,15,114,240,16                // pslld         $0x10,%xmm8
  .byte  102,65,15,114,224,16                // psrad         $0x10,%xmm8
  .byte  102,65,15,107,248                   // packssdw      %xmm8,%xmm7
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,65,15,114,241,16                // pslld         $0x10,%xmm9
  .byte  102,65,15,114,225,16                // psrad         $0x10,%xmm9
  .byte  102,65,15,107,225                   // packssdw      %xmm9,%xmm4
  .byte  102,65,15,219,228                   // pand          %xmm12,%xmm4
  .byte  102,69,15,111,196                   // movdqa        %xmm12,%xmm8
  .byte  102,68,15,249,195                   // psubw         %xmm3,%xmm8
  .byte  102,68,15,111,204                   // movdqa        %xmm4,%xmm9
  .byte  102,69,15,213,200                   // pmullw        %xmm8,%xmm9
  .byte  102,69,15,253,204                   // paddw         %xmm12,%xmm9
  .byte  102,65,15,113,209,8                 // psrlw         $0x8,%xmm9
  .byte  102,68,15,253,200                   // paddw         %xmm0,%xmm9
  .byte  102,68,15,111,213                   // movdqa        %xmm5,%xmm10
  .byte  102,69,15,213,208                   // pmullw        %xmm8,%xmm10
  .byte  102,69,15,253,212                   // paddw         %xmm12,%xmm10
  .byte  102,65,15,113,210,8                 // psrlw         $0x8,%xmm10
  .byte  102,68,15,253,209                   // paddw         %xmm1,%xmm10
  .byte  102,68,15,111,222                   // movdqa        %xmm6,%xmm11
  .byte  102,69,15,213,216                   // pmullw        %xmm8,%xmm11
  .byte  102,69,15,253,220                   // paddw         %xmm12,%xmm11
  .byte  102,65,15,113,211,8                 // psrlw         $0x8,%xmm11
  .byte  102,68,15,253,218                   // paddw         %xmm2,%xmm11
  .byte  102,68,15,213,199                   // pmullw        %xmm7,%xmm8
  .byte  102,69,15,253,196                   // paddw         %xmm12,%xmm8
  .byte  102,65,15,113,208,8                 // psrlw         $0x8,%xmm8
  .byte  102,68,15,253,195                   // paddw         %xmm3,%xmm8
  .byte  102,65,15,111,210                   // movdqa        %xmm10,%xmm2
  .byte  102,15,113,242,8                    // psllw         $0x8,%xmm2
  .byte  102,65,15,235,211                   // por           %xmm11,%xmm2
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,97,216                       // punpcklwd     %xmm0,%xmm3
  .byte  102,15,105,208                      // punpckhwd     %xmm0,%xmm2
  .byte  102,65,15,111,200                   // movdqa        %xmm8,%xmm1
  .byte  102,15,113,241,8                    // psllw         $0x8,%xmm1
  .byte  102,65,15,235,201                   // por           %xmm9,%xmm1
  .byte  102,69,15,239,228                   // pxor          %xmm12,%xmm12
  .byte  102,68,15,97,225                    // punpcklwd     %xmm1,%xmm12
  .byte  102,68,15,235,227                   // por           %xmm3,%xmm12
  .byte  102,15,105,193                      // punpckhwd     %xmm1,%xmm0
  .byte  102,15,235,194                      // por           %xmm2,%xmm0
  .byte  65,128,250,6                        // cmp           $0x6,%r10b
  .byte  119,24                              // ja            3a17b <_sk_srcover_bgra_8888_sse2_lowp+0x213>
  .byte  76,141,21,142,0,0,0                 // lea           0x8e(%rip),%r10        # 3a1f8 <_sk_srcover_bgra_8888_sse2_lowp+0x290>
  .byte  75,99,4,138                         // movslq        (%r10,%r9,4),%rax
  .byte  76,1,208                            // add           %r10,%rax
  .byte  255,224                             // jmpq          *%rax
  .byte  102,69,15,126,36,144                // movd          %xmm12,(%r8,%rdx,4)
  .byte  235,73                              // jmp           3a1c4 <_sk_srcover_bgra_8888_sse2_lowp+0x25c>
  .byte  243,69,15,127,36,144                // movdqu        %xmm12,(%r8,%rdx,4)
  .byte  243,65,15,127,68,144,16             // movdqu        %xmm0,0x10(%r8,%rdx,4)
  .byte  235,58                              // jmp           3a1c4 <_sk_srcover_bgra_8888_sse2_lowp+0x25c>
  .byte  102,65,15,112,196,78                // pshufd        $0x4e,%xmm12,%xmm0
  .byte  102,65,15,126,68,144,8              // movd          %xmm0,0x8(%r8,%rdx,4)
  .byte  102,69,15,214,36,144                // movq          %xmm12,(%r8,%rdx,4)
  .byte  235,37                              // jmp           3a1c4 <_sk_srcover_bgra_8888_sse2_lowp+0x25c>
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,65,15,126,76,144,24             // movd          %xmm1,0x18(%r8,%rdx,4)
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,65,15,126,76,144,20             // movd          %xmm1,0x14(%r8,%rdx,4)
  .byte  102,65,15,126,68,144,16             // movd          %xmm0,0x10(%r8,%rdx,4)
  .byte  243,69,15,127,36,144                // movdqu        %xmm12,(%r8,%rdx,4)
  .byte  72,173                              // lods          %ds:(%rsi),%rax
  .byte  102,65,15,111,193                   // movdqa        %xmm9,%xmm0
  .byte  102,65,15,111,202                   // movdqa        %xmm10,%xmm1
  .byte  102,65,15,111,211                   // movdqa        %xmm11,%xmm2
  .byte  102,65,15,111,216                   // movdqa        %xmm8,%xmm3
  .byte  255,224                             // jmpq          *%rax
  .byte  202,253,255                         // lret          $0xfffd
  .byte  255,247                             // push          %rdi
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,230                             // jmpq          *%rsi
  .byte  253                                 // std
  .byte  255                                 // (bad)
  .byte  255,55                              // pushq         (%rdi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,43                              // ljmp          *(%rbx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,22                              // callq         *(%rsi)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,9                               // decl          (%rcx)
  .byte  254                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  123,255                             // jnp           3a1f9 <_sk_srcover_bgra_8888_sse2_lowp+0x291>
  .byte  255                                 // (bad)
  .byte  255,159,255,255,255,146             // lcall         *-0x6d000001(%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,198                             // inc           %esi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  191,255,255,255,179                 // mov           $0xb3ffffff,%edi
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff
  .byte  167                                 // cmpsl         %es:(%rdi),%ds:(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // .byte         0xff

BALIGN4
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,63,1                            // cmpb          $0x1,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,4,0                               // add           %al,(%rax,%rax,1)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  2,0                                 // add           (%rax),%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,60,0,0                          // cmpb          $0x0,(%rax,%rax,1)
  .byte  252                                 // cld
  .byte  190,0,0,128,191                     // mov           $0xbf800000,%esi
  .byte  0,0                                 // add           %al,(%rax)
  .byte  224,64                              // loopne        3a278 <.literal4+0x64>
  .byte  154                                 // (bad)
  .byte  153                                 // cltd
  .byte  153                                 // cltd
  .byte  62,61,10,23,63,174                  // ds            cmp $0xae3f170a,%eax
  .byte  71,225,61                           // rex.RXB       loope 3a281 <.literal4+0x6d>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  127,67                              // jg            3a28b <.literal4+0x77>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,127,145,131                     // cmpb          $0x83,-0x6f(%rdi)
  .byte  158                                 // sahf
  .byte  61,92,143,50,63                     // cmp           $0x3f328f5c,%eax
  .byte  10,215                              // or            %bh,%dl
  .byte  35,59                               // and           (%rbx),%edi
  .byte  174                                 // scas          %es:(%rdi),%al
  .byte  71,97                               // rex.RXB       (bad)
  .byte  61,82,184,78,65                     // cmp           $0x414eb852,%eax
  .byte  186,159,98,60,57                    // mov           $0x393c629f,%edx
  .byte  215                                 // xlat          %ds:(%rbx)
  .byte  32,187,180,164,144,63               // and           %bh,0x3f90a4b4(%rbx)
  .byte  252                                 // cld
  .byte  199                                 // (bad)
  .byte  16,62                               // adc           %bh,(%rsi)
  .byte  168,177                             // test          $0xb1,%al
  .byte  152                                 // cwtl
  .byte  59,0                                // cmp           (%rax),%eax
  .byte  0,192                               // add           %al,%al
  .byte  64,0,0                              // add           %al,(%rax)
  .byte  0,64,0                              // add           %al,0x0(%rax)
  .byte  0,128,64,171,170,42                 // add           %al,0x2aaaab40(%rax)
  .byte  62,171                              // ds            stos %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  62,171                              // ds            stos %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  42,63                               // sub           (%rdi),%bh
  .byte  171                                 // stos          %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  190,129,128,128,59                  // mov           $0x3b808081,%esi
  .byte  0,248                               // add           %bh,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  8,33                                // or            %ah,(%rcx)
  .byte  132,55                              // test          %dh,(%rdi)
  .byte  224,7                               // loopne        3a2a5 <.literal4+0x91>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  33,8                                // and           %ecx,(%rax)
  .byte  2,58                                // add           (%rdx),%bh
  .byte  31                                  // (bad)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,8                                 // add           %cl,(%rax)
  .byte  33,4,61,128,0,128,55                // and           %eax,0x37800080(,%rdi,1)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,52,255                            // add           %dh,(%rdi,%rdi,8)
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            3a2b8 <.literal4+0xa4>
  .byte  119,115                             // ja            3a32d <.literal4+0x119>
  .byte  248                                 // clc
  .byte  194,117,191                         // retq          $0xbf75
  .byte  191,63,249,68,180                   // mov           $0xb444f93f,%edi
  .byte  62,163,233,220,63,81,140,242,66,141 // movabs        %eax,%ds:0x8d42f28c513fdce9
  .byte  188,190,63,248,245                  // mov           $0xf5f83fbe,%esp
  .byte  154                                 // (bad)
  .byte  64,254                              // rex           (bad)
  .byte  210,221                             // rcr           %cl,%ch
  .byte  65,0,0                              // add           %al,(%r8)
  .byte  0,75,0                              // add           %cl,0x0(%rbx)
  .byte  0,200                               // add           %cl,%al
  .byte  66,0,0                              // rex.X         add %al,(%rax)
  .byte  0,195                               // add           %al,%bl
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,65,203,61                       // addb          $0x3d,-0x35(%rcx)
  .byte  13,60,111,18,3                      // or            $0x3126f3c,%eax
  .byte  59,10                               // cmp           (%rdx),%ecx
  .byte  215                                 // xlat          %ds:(%rbx)
  .byte  163,59,194,24,17,60,203,61,13       // movabs        %eax,0xd3dcb3c1118c23b
  .byte  190,80,128,3,62                     // mov           $0x3e038050,%esi
  .byte  31                                  // (bad)
  .byte  215                                 // xlat          %ds:(%rbx)
  .byte  118,63                              // jbe           3a343 <.literal4+0x12f>
  .byte  246,64,83,63                        // testb         $0x3f,0x53(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  248                                 // clc
  .byte  65,0,0                              // add           %al,(%r8)
  .byte  124,66                              // jl            3a352 <.literal4+0x13e>
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  137,136,136,55,0,15                 // mov           %ecx,0xf003788(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  137,136,136,57,240,0                // mov           %ecx,0xf03988(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  137,136,136,59,15,0                 // mov           %ecx,0xf3b88(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  137,136,136,61,0,0                  // mov           %ecx,0x3d88(%rax)
  .byte  112,65                              // jo            3a375 <.literal4+0x161>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,71                              // jg            3a37f <.literal4+0x16b>
  .byte  89                                  // pop           %rcx
  .byte  23                                  // (bad)
  .byte  55                                  // (bad)
  .byte  63                                  // (bad)
  .byte  208                                 // (bad)
  .byte  179,89                              // mov           $0x59,%bl
  .byte  62,152                              // ds            cwtl
  .byte  221,147,61,111,43,231               // fstl          -0x18d490c3(%rbx)
  .byte  187,159,215,202,60                  // mov           $0x3ccad79f,%ebx
  .byte  212                                 // (bad)
  .byte  100,84                              // fs            push %rsp
  .byte  189,169,240,34,62                   // mov           $0x3e22f0a9,%ebp
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,62,0                            // cmpb          $0x0,(%rsi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  192,0,0                             // rolb          $0x0,(%rax)
  .byte  128,192,0                           // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,0,0                             // addb          $0x0,(%rax)
  .byte  0,191,0,0,192,191                   // add           %bh,-0x40400000(%rdi)
  .byte  114,28                              // jb            3a38a <.literal4+0x176>
  .byte  199                                 // (bad)
  .byte  62,85                               // ds            push %rbp
  .byte  85                                  // push          %rbp
  .byte  149                                 // xchg          %eax,%ebp
  .byte  191,0,0,192,63                      // mov           $0x3fc00000,%edi
  .byte  57,142,99,61,114,249                // cmp           %ecx,-0x68dc29d(%rsi)
  .byte  127,63                              // jg            3a3bf <_sk_srcover_bgra_8888_sse2_lowp+0x457>
  .byte  3,0                                 // add           (%rax),%eax
  .byte  0,0                                 // add           %al,(%rax)
  .byte  45,16,17,192,18                     // sub           $0x12c01110,%eax
  .byte  120,57                              // js            3a3c4 <_sk_srcover_bgra_8888_sse2_lowp+0x45c>
  .byte  64,32,148,90,62,4,157,30            // and           %dl,0x1e9d043e(%rdx,%rbx,2)
  .byte  62,0,24                             // add           %bl,%ds:(%rax)
  .byte  161,57,109,165,144,63,252,191,16    // movabs        0x10bffc3f90a56d39,%eax
  .byte  62,0,4,0                            // add           %al,%ds:(%rax,%rax,1)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  56,255                              // cmp           %bh,%bh
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            3a3ad <.literal4+0x199>
  .byte  0,128,56,0,64,254                   // add           %al,-0x1bfffc8(%rax)
  .byte  255                                 // .byte         0xff

BALIGN32
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  1,0                                 // add           %eax,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  2,0                                 // add           (%rax),%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  3,0                                 // add           (%rax),%eax
  .byte  0,0                                 // add           %al,(%rax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  5,0,0,0,6                           // add           $0x6000000,%eax
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,7                                 // add           %al,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,1                                 // add           %al,(%rcx)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,2                                 // add           %al,(%rdx)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,3                                 // add           %al,(%rbx)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,4,0                               // add           %al,(%rax,%rax,1)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  5,0,0,0,6                           // add           $0x6000000,%eax
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,7                                 // add           %al,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,1                                 // add           %al,(%rcx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,5,255,255,255,9                 // incl          0x9ffffff(%rip)        # a03a428 <_sk_srcover_bgra_8888_sse2_lowp+0xa0004c0>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,13,255,255,255,17               // decl          0x11ffffff(%rip)        # 1203a430 <_sk_srcover_bgra_8888_sse2_lowp+0x120004c8>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,21,255,255,255,25               // callq         *0x19ffffff(%rip)        # 1a03a438 <_sk_srcover_bgra_8888_sse2_lowp+0x1a0004d0>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,29,255,255,255,2                // lcall         *0x2ffffff(%rip)        # 303a440 <_sk_srcover_bgra_8888_sse2_lowp+0x30004d8>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,6                               // incl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,10                              // decl          (%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,14                              // decl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,18                              // callq         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,22                              // callq         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,26                              // lcall         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,30                              // lcall         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  1,255                               // add           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,5,255,255,255,9                 // incl          0x9ffffff(%rip)        # a03a488 <_sk_srcover_bgra_8888_sse2_lowp+0xa000520>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,13,255,255,255,17               // decl          0x11ffffff(%rip)        # 1203a490 <_sk_srcover_bgra_8888_sse2_lowp+0x12000528>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,21,255,255,255,25               // callq         *0x19ffffff(%rip)        # 1a03a498 <_sk_srcover_bgra_8888_sse2_lowp+0x1a000530>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,29,255,255,255,2                // lcall         *0x2ffffff(%rip)        # 303a4a0 <_sk_srcover_bgra_8888_sse2_lowp+0x3000538>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,6                               // incl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,10                              // decl          (%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,14                              // decl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,18                              // callq         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,22                              // callq         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,26                              // lcall         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,30                              // lcall         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  1,255                               // add           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,5,255,255,255,9                 // incl          0x9ffffff(%rip)        # a03a4e8 <_sk_srcover_bgra_8888_sse2_lowp+0xa000580>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,13,255,255,255,17               // decl          0x11ffffff(%rip)        # 1203a4f0 <_sk_srcover_bgra_8888_sse2_lowp+0x12000588>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,21,255,255,255,25               // callq         *0x19ffffff(%rip)        # 1a03a4f8 <_sk_srcover_bgra_8888_sse2_lowp+0x1a000590>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,29,255,255,255,2                // lcall         *0x2ffffff(%rip)        # 303a500 <_sk_srcover_bgra_8888_sse2_lowp+0x3000598>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,6                               // incl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,10                              // decl          (%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,14                              // decl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,18                              // callq         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,22                              // callq         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,26                              // lcall         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,30                              // lcall         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  1,255                               // add           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,5,255,255,255,9                 // incl          0x9ffffff(%rip)        # a03a548 <_sk_srcover_bgra_8888_sse2_lowp+0xa0005e0>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,13,255,255,255,17               // decl          0x11ffffff(%rip)        # 1203a550 <_sk_srcover_bgra_8888_sse2_lowp+0x120005e8>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,21,255,255,255,25               // callq         *0x19ffffff(%rip)        # 1a03a558 <_sk_srcover_bgra_8888_sse2_lowp+0x1a0005f0>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,29,255,255,255,2                // lcall         *0x2ffffff(%rip)        # 303a560 <_sk_srcover_bgra_8888_sse2_lowp+0x30005f8>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,6                               // incl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,10                              // decl          (%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,14                              // decl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,18                              // callq         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,22                              // callq         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,26                              // lcall         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,30                              // lcall         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  1,255                               // add           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,5,255,255,255,9                 // incl          0x9ffffff(%rip)        # a03a5a8 <_sk_srcover_bgra_8888_sse2_lowp+0xa000640>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,13,255,255,255,17               // decl          0x11ffffff(%rip)        # 1203a5b0 <_sk_srcover_bgra_8888_sse2_lowp+0x12000648>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,21,255,255,255,25               // callq         *0x19ffffff(%rip)        # 1a03a5b8 <_sk_srcover_bgra_8888_sse2_lowp+0x1a000650>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,29,255,255,255,2                // lcall         *0x2ffffff(%rip)        # 303a5c0 <_sk_srcover_bgra_8888_sse2_lowp+0x3000658>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,6                               // incl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,10                              // decl          (%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,14                              // decl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,18                              // callq         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,22                              // callq         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,26                              // lcall         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,30                              // lcall         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  1,255                               // add           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,5,255,255,255,9                 // incl          0x9ffffff(%rip)        # a03a608 <_sk_srcover_bgra_8888_sse2_lowp+0xa0006a0>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,13,255,255,255,17               // decl          0x11ffffff(%rip)        # 1203a610 <_sk_srcover_bgra_8888_sse2_lowp+0x120006a8>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,21,255,255,255,25               // callq         *0x19ffffff(%rip)        # 1a03a618 <_sk_srcover_bgra_8888_sse2_lowp+0x1a0006b0>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,29,255,255,255,2                // lcall         *0x2ffffff(%rip)        # 303a620 <_sk_srcover_bgra_8888_sse2_lowp+0x30006b8>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,6                               // incl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,10                              // decl          (%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,14                              // decl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,18                              // callq         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,22                              // callq         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,26                              // lcall         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,30                              // lcall         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  1,255                               // add           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,5,255,255,255,9                 // incl          0x9ffffff(%rip)        # a03a668 <_sk_srcover_bgra_8888_sse2_lowp+0xa000700>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,13,255,255,255,17               // decl          0x11ffffff(%rip)        # 1203a670 <_sk_srcover_bgra_8888_sse2_lowp+0x12000708>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,21,255,255,255,25               // callq         *0x19ffffff(%rip)        # 1a03a678 <_sk_srcover_bgra_8888_sse2_lowp+0x1a000710>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,29,255,255,255,2                // lcall         *0x2ffffff(%rip)        # 303a680 <_sk_srcover_bgra_8888_sse2_lowp+0x3000718>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,6                               // incl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,10                              // decl          (%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,14                              // decl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,18                              // callq         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,22                              // callq         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,26                              // lcall         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,30                              // lcall         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  1,255                               // add           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,5,255,255,255,9                 // incl          0x9ffffff(%rip)        # a03a6c8 <_sk_srcover_bgra_8888_sse2_lowp+0xa000760>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,13,255,255,255,17               // decl          0x11ffffff(%rip)        # 1203a6d0 <_sk_srcover_bgra_8888_sse2_lowp+0x12000768>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,21,255,255,255,25               // callq         *0x19ffffff(%rip)        # 1a03a6d8 <_sk_srcover_bgra_8888_sse2_lowp+0x1a000770>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,29,255,255,255,2                // lcall         *0x2ffffff(%rip)        # 303a6e0 <_sk_srcover_bgra_8888_sse2_lowp+0x3000778>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,6                               // incl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,10                              // decl          (%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,14                              // decl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,18                              // callq         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,22                              // callq         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,26                              // lcall         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,30                              // lcall         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  1,255                               // add           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,5,255,255,255,9                 // incl          0x9ffffff(%rip)        # a03a728 <_sk_srcover_bgra_8888_sse2_lowp+0xa0007c0>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,13,255,255,255,17               // decl          0x11ffffff(%rip)        # 1203a730 <_sk_srcover_bgra_8888_sse2_lowp+0x120007c8>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,21,255,255,255,25               // callq         *0x19ffffff(%rip)        # 1a03a738 <_sk_srcover_bgra_8888_sse2_lowp+0x1a0007d0>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,29,255,255,255,2                // lcall         *0x2ffffff(%rip)        # 303a740 <_sk_srcover_bgra_8888_sse2_lowp+0x30007d8>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,6                               // incl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,10                              // decl          (%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,14                              // decl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,18                              // callq         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,22                              // callq         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,26                              // lcall         *(%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,30                              // lcall         *(%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  254,1                               // incb          (%rcx)
  .byte  255,0                               // incl          (%rax)
  .byte  254,1                               // incb          (%rcx)
  .byte  255,0                               // incl          (%rax)
  .byte  0,128,255,0,0,128                   // add           %al,-0x7fffff01(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  248                                 // clc
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,248                               // add           %bh,%al
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,0                                 // add           %al,(%rax)
  .byte  248                                 // clc
  .byte  224,255                             // loopne        3a993 <.const+0x5d3>
  .byte  248                                 // clc
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  240,0,0                             // lock          add %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  240,255,15                          // lock          decl (%rdi)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,54                                // add           %dh,(%rsi)
  .byte  0,183,0,19,0,255                    // add           %dh,-0xffed00(%rdi)
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,248                               // add           %bh,%al
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,255,0                           // cmp           $0x0,%bh
  .byte  248                                 // clc
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,255,0                           // cmp           $0x0,%bh
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,1                                 // add           %al,(%rcx)
  .byte  4,5                                 // add           $0x5,%al
  .byte  8,9                                 // or            %cl,(%rcx)
  .byte  12,13                               // or            $0xd,%al
  .byte  8,9                                 // or            %cl,(%rcx)
  .byte  12,13                               // or            $0xd,%al
  .byte  12,13                               // or            $0xd,%al
  .byte  14                                  // (bad)
  .byte  15,16,17                            // movups        (%rcx),%xmm2
  .byte  20,21                               // adc           $0x15,%al
  .byte  24,25                               // sbb           %bl,(%rcx)
  .byte  28,29                               // sbb           $0x1d,%al
  .byte  24,25                               // sbb           %bl,(%rcx)
  .byte  28,29                               // sbb           $0x1d,%al
  .byte  28,29                               // sbb           $0x1d,%al
  .byte  30                                  // (bad)
  .byte  31                                  // (bad)
  .byte  0,1                                 // add           %al,(%rcx)
  .byte  4,5                                 // add           $0x5,%al
  .byte  8,9                                 // or            %cl,(%rcx)
  .byte  12,13                               // or            $0xd,%al
  .byte  8,9                                 // or            %cl,(%rcx)
  .byte  12,13                               // or            $0xd,%al
  .byte  12,13                               // or            $0xd,%al
  .byte  14                                  // (bad)
  .byte  15,16,17                            // movups        (%rcx),%xmm2
  .byte  20,21                               // adc           $0x15,%al
  .byte  24,25                               // sbb           %bl,(%rcx)
  .byte  28,29                               // sbb           $0x1d,%al
  .byte  24,25                               // sbb           %bl,(%rcx)
  .byte  28,29                               // sbb           $0x1d,%al
  .byte  28,29                               // sbb           $0x1d,%al
  .byte  30                                  // (bad)
  .byte  31                                  // (bad)
  .byte  0,1                                 // add           %al,(%rcx)
  .byte  4,5                                 // add           $0x5,%al
  .byte  8,9                                 // or            %cl,(%rcx)
  .byte  12,13                               // or            $0xd,%al
  .byte  8,9                                 // or            %cl,(%rcx)
  .byte  12,13                               // or            $0xd,%al
  .byte  12,13                               // or            $0xd,%al
  .byte  14                                  // (bad)
  .byte  15,16,17                            // movups        (%rcx),%xmm2
  .byte  20,21                               // adc           $0x15,%al
  .byte  24,25                               // sbb           %bl,(%rcx)
  .byte  28,29                               // sbb           $0x1d,%al
  .byte  24,25                               // sbb           %bl,(%rcx)
  .byte  28,29                               // sbb           $0x1d,%al
  .byte  28,29                               // sbb           $0x1d,%al
  .byte  30                                  // (bad)
  .byte  31                                  // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)

BALIGN16
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,2                                 // add           %al,(%rdx)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,2                                 // add           %al,(%rdx)
  .byte  4,6                                 // add           $0x6,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  1,0                                 // add           %eax,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  2,0                                 // add           (%rax),%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  3,0                                 // add           (%rax),%eax
  .byte  0,0                                 // add           %al,(%rax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  5,0,0,0,6                           // add           $0x6000000,%eax
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,7                                 // add           %al,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  63                                  // (bad)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,63,0                            // cmpb          $0x0,(%rdi)
  .byte  0,128,63,0,0,128                    // add           %al,-0x7fffffc1(%rax)
  .byte  63                                  // (bad)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,63,1                            // cmpb          $0x1,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,1                                 // add           %al,(%rcx)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,1                                 // add           %al,(%rcx)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,1                                 // add           %al,(%rcx)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,4,0                               // add           %al,(%rax,%rax,1)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  2,0                                 // add           (%rax),%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  2,0                                 // add           (%rax),%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  2,0                                 // add           (%rax),%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  2,0                                 // add           (%rax),%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,60,0,0                          // cmpb          $0x0,(%rax,%rax,1)
  .byte  128,60,0,0                          // cmpb          $0x0,(%rax,%rax,1)
  .byte  128,60,0,0                          // cmpb          $0x0,(%rax,%rax,1)
  .byte  128,60,0,0                          // cmpb          $0x0,(%rax,%rax,1)
  .byte  252                                 // cld
  .byte  190,0,0,252,190                     // mov           $0xbefc0000,%esi
  .byte  0,0                                 // add           %al,(%rax)
  .byte  252                                 // cld
  .byte  190,0,0,252,190                     // mov           $0xbefc0000,%esi
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,191,0,0,128,191,0               // cmpb          $0x0,-0x40800000(%rdi)
  .byte  0,128,191,0,0,128                   // add           %al,-0x7fffff41(%rax)
  .byte  191,0,0,224,64                      // mov           $0x40e00000,%edi
  .byte  0,0                                 // add           %al,(%rax)
  .byte  224,64                              // loopne        3ac08 <.literal16+0x118>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  224,64                              // loopne        3ac0c <.literal16+0x11c>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  224,64                              // loopne        3ac10 <.literal16+0x120>
  .byte  154                                 // (bad)
  .byte  153                                 // cltd
  .byte  153                                 // cltd
  .byte  62,154                              // ds            (bad)
  .byte  153                                 // cltd
  .byte  153                                 // cltd
  .byte  62,154                              // ds            (bad)
  .byte  153                                 // cltd
  .byte  153                                 // cltd
  .byte  62,154                              // ds            (bad)
  .byte  153                                 // cltd
  .byte  153                                 // cltd
  .byte  62,61,10,23,63,61                   // ds            cmp $0x3d3f170a,%eax
  .byte  10,23                               // or            (%rdi),%dl
  .byte  63                                  // (bad)
  .byte  61,10,23,63,61                      // cmp           $0x3d3f170a,%eax
  .byte  10,23                               // or            (%rdi),%dl
  .byte  63                                  // (bad)
  .byte  174                                 // scas          %es:(%rdi),%al
  .byte  71,225,61                           // rex.RXB       loope 3ac31 <.literal16+0x141>
  .byte  174                                 // scas          %es:(%rdi),%al
  .byte  71,225,61                           // rex.RXB       loope 3ac35 <.literal16+0x145>
  .byte  174                                 // scas          %es:(%rdi),%al
  .byte  71,225,61                           // rex.RXB       loope 3ac39 <.literal16+0x149>
  .byte  174                                 // scas          %es:(%rdi),%al
  .byte  71,225,61                           // rex.RXB       loope 3ac3d <.literal16+0x14d>
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  1,255                               // add           %edi,%edi
  .byte  255                                 // (bad)
  .byte  255,5,255,255,255,9                 // incl          0x9ffffff(%rip)        # a03ac18 <_sk_srcover_bgra_8888_sse2_lowp+0xa000cb0>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,13,255,255,255,2                // decl          0x2ffffff(%rip)        # 303ac20 <_sk_srcover_bgra_8888_sse2_lowp+0x3000cb8>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,6                               // incl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,10                              // decl          (%rdx)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,14                              // decl          (%rsi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  0,127,67                            // add           %bh,0x43(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  127,67                              // jg            3ac7b <.literal16+0x18b>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  127,67                              // jg            3ac7f <.literal16+0x18f>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  127,67                              // jg            3ac83 <.literal16+0x193>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,127,0,0                         // cmpb          $0x0,0x0(%rdi)
  .byte  128,127,0,0                         // cmpb          $0x0,0x0(%rdi)
  .byte  128,127,0,0                         // cmpb          $0x0,0x0(%rdi)
  .byte  128,127,145,131                     // cmpb          $0x83,-0x6f(%rdi)
  .byte  158                                 // sahf
  .byte  61,145,131,158,61                   // cmp           $0x3d9e8391,%eax
  .byte  145                                 // xchg          %eax,%ecx
  .byte  131,158,61,145,131,158,61           // sbbl          $0x3d,-0x617c6ec3(%rsi)
  .byte  92                                  // pop           %rsp
  .byte  143                                 // (bad)
  .byte  50,63                               // xor           (%rdi),%bh
  .byte  92                                  // pop           %rsp
  .byte  143                                 // (bad)
  .byte  50,63                               // xor           (%rdi),%bh
  .byte  92                                  // pop           %rsp
  .byte  143                                 // (bad)
  .byte  50,63                               // xor           (%rdi),%bh
  .byte  92                                  // pop           %rsp
  .byte  143                                 // (bad)
  .byte  50,63                               // xor           (%rdi),%bh
  .byte  10,215                              // or            %bh,%dl
  .byte  35,59                               // and           (%rbx),%edi
  .byte  10,215                              // or            %bh,%dl
  .byte  35,59                               // and           (%rbx),%edi
  .byte  10,215                              // or            %bh,%dl
  .byte  35,59                               // and           (%rbx),%edi
  .byte  10,215                              // or            %bh,%dl
  .byte  35,59                               // and           (%rbx),%edi
  .byte  174                                 // scas          %es:(%rdi),%al
  .byte  71,97                               // rex.RXB       (bad)
  .byte  61,174,71,97,61                     // cmp           $0x3d6147ae,%eax
  .byte  174                                 // scas          %es:(%rdi),%al
  .byte  71,97                               // rex.RXB       (bad)
  .byte  61,174,71,97,61                     // cmp           $0x3d6147ae,%eax
  .byte  82                                  // push          %rdx
  .byte  184,78,65,82,184                    // mov           $0xb852414e,%eax
  .byte  78                                  // rex.WRX
  .byte  65,82                               // push          %r10
  .byte  184,78,65,82,184                    // mov           $0xb852414e,%eax
  .byte  78                                  // rex.WRX
  .byte  65,57,215                           // cmp           %edx,%r15d
  .byte  32,187,57,215,32,187                // and           %bh,-0x44df28c7(%rbx)
  .byte  57,215                              // cmp           %edx,%edi
  .byte  32,187,57,215,32,187                // and           %bh,-0x44df28c7(%rbx)
  .byte  186,159,98,60,186                   // mov           $0xba3c629f,%edx
  .byte  159                                 // lahf
  .byte  98                                  // (bad)
  .byte  60,186                              // cmp           $0xba,%al
  .byte  159                                 // lahf
  .byte  98                                  // (bad)
  .byte  60,186                              // cmp           $0xba,%al
  .byte  159                                 // lahf
  .byte  98                                  // (bad)
  .byte  60,109                              // cmp           $0x6d,%al
  .byte  165                                 // movsl         %ds:(%rsi),%es:(%rdi)
  .byte  144                                 // nop
  .byte  63                                  // (bad)
  .byte  109                                 // insl          (%dx),%es:(%rdi)
  .byte  165                                 // movsl         %ds:(%rsi),%es:(%rdi)
  .byte  144                                 // nop
  .byte  63                                  // (bad)
  .byte  109                                 // insl          (%dx),%es:(%rdi)
  .byte  165                                 // movsl         %ds:(%rsi),%es:(%rdi)
  .byte  144                                 // nop
  .byte  63                                  // (bad)
  .byte  109                                 // insl          (%dx),%es:(%rdi)
  .byte  165                                 // movsl         %ds:(%rsi),%es:(%rdi)
  .byte  144                                 // nop
  .byte  63                                  // (bad)
  .byte  252                                 // cld
  .byte  191,16,62,252,191                   // mov           $0xbffc3e10,%edi
  .byte  16,62                               // adc           %bh,(%rsi)
  .byte  252                                 // cld
  .byte  191,16,62,252,191                   // mov           $0xbffc3e10,%edi
  .byte  16,62                               // adc           %bh,(%rsi)
  .byte  168,177                             // test          $0xb1,%al
  .byte  152                                 // cwtl
  .byte  59,168,177,152,59,168               // cmp           -0x57c4674f(%rax),%ebp
  .byte  177,152                             // mov           $0x98,%cl
  .byte  59,168,177,152,59,0                 // cmp           0x3b98b1(%rax),%ebp
  .byte  0,192                               // add           %al,%al
  .byte  64,0,0                              // add           %al,(%rax)
  .byte  192,64,0,0                          // rolb          $0x0,0x0(%rax)
  .byte  192,64,0,0                          // rolb          $0x0,0x0(%rax)
  .byte  192,64,0,0                          // rolb          $0x0,0x0(%rax)
  .byte  0,64,0                              // add           %al,0x0(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  64,0,0                              // add           %al,(%rax)
  .byte  0,64,0                              // add           %al,0x0(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  64,0,0                              // add           %al,(%rax)
  .byte  128,64,0,0                          // addb          $0x0,0x0(%rax)
  .byte  128,64,0,0                          // addb          $0x0,0x0(%rax)
  .byte  128,64,0,0                          // addb          $0x0,0x0(%rax)
  .byte  128,64,171,170                      // addb          $0xaa,-0x55(%rax)
  .byte  42,62                               // sub           (%rsi),%bh
  .byte  171                                 // stos          %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  42,62                               // sub           (%rsi),%bh
  .byte  171                                 // stos          %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  42,62                               // sub           (%rsi),%bh
  .byte  171                                 // stos          %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  42,62                               // sub           (%rsi),%bh
  .byte  171                                 // stos          %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  62,171                              // ds            stos %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  62,171                              // ds            stos %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  62,171                              // ds            stos %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  62,171                              // ds            stos %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  42,63                               // sub           (%rdi),%bh
  .byte  171                                 // stos          %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  42,63                               // sub           (%rdi),%bh
  .byte  171                                 // stos          %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  42,63                               // sub           (%rdi),%bh
  .byte  171                                 // stos          %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  42,63                               // sub           (%rdi),%bh
  .byte  171                                 // stos          %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  190,171,170,170,190                 // mov           $0xbeaaaaab,%esi
  .byte  171                                 // stos          %eax,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  170                                 // stos          %al,%es:(%rdi)
  .byte  190,171,170,170,190                 // mov           $0xbeaaaaab,%esi
  .byte  129,128,128,59,129,128,128,59,129,128// addl          $0x80813b80,-0x7f7ec480(%rax)
  .byte  128,59,129                          // cmpb          $0x81,(%rbx)
  .byte  128,128,59,0,248,0,0                // addb          $0x0,0xf8003b(%rax)
  .byte  0,248                               // add           %bh,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,248                               // add           %bh,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,248                               // add           %bh,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  8,33                                // or            %ah,(%rcx)
  .byte  132,55                              // test          %dh,(%rdi)
  .byte  8,33                                // or            %ah,(%rcx)
  .byte  132,55                              // test          %dh,(%rdi)
  .byte  8,33                                // or            %ah,(%rcx)
  .byte  132,55                              // test          %dh,(%rdi)
  .byte  8,33                                // or            %ah,(%rcx)
  .byte  132,55                              // test          %dh,(%rdi)
  .byte  224,7                               // loopne        3ad99 <.literal16+0x2a9>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  224,7                               // loopne        3ad9d <.literal16+0x2ad>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  224,7                               // loopne        3ada1 <.literal16+0x2b1>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  224,7                               // loopne        3ada5 <.literal16+0x2b5>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  33,8                                // and           %ecx,(%rax)
  .byte  2,58                                // add           (%rdx),%bh
  .byte  33,8                                // and           %ecx,(%rax)
  .byte  2,58                                // add           (%rdx),%bh
  .byte  33,8                                // and           %ecx,(%rax)
  .byte  2,58                                // add           (%rdx),%bh
  .byte  33,8                                // and           %ecx,(%rax)
  .byte  2,58                                // add           (%rdx),%bh
  .byte  31                                  // (bad)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,8                                 // add           %cl,(%rax)
  .byte  33,4,61,8,33,4,61                   // and           %eax,0x3d042108(,%rdi,1)
  .byte  8,33                                // or            %ah,(%rcx)
  .byte  4,61                                // add           $0x3d,%al
  .byte  8,33                                // or            %ah,(%rcx)
  .byte  4,61                                // add           $0x3d,%al
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  8,255                               // or            %bh,%bh
  .byte  10,255                              // or            %bh,%bh
  .byte  12,255                              // or            $0xff,%al
  .byte  14                                  // (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,128,0,128,55,128                  // add           %al,-0x7fc88000(%rax)
  .byte  0,128,55,128,0,128                  // add           %al,-0x7fff7fc9(%rax)
  .byte  55                                  // (bad)
  .byte  128,0,128                           // addb          $0x80,(%rax)
  .byte  55                                  // (bad)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,52,0                              // add           %dh,(%rax,%rax,1)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  52,0                                // xor           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  52,0                                // xor           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  52,255                              // xor           $0xff,%al
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            3ae14 <.literal16+0x324>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            3ae18 <.literal16+0x328>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            3ae1c <.literal16+0x32c>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            3ae20 <.literal16+0x330>
  .byte  119,115                             // ja            3ae95 <.literal16+0x3a5>
  .byte  248                                 // clc
  .byte  194,119,115                         // retq          $0x7377
  .byte  248                                 // clc
  .byte  194,119,115                         // retq          $0x7377
  .byte  248                                 // clc
  .byte  194,119,115                         // retq          $0x7377
  .byte  248                                 // clc
  .byte  194,117,191                         // retq          $0xbf75
  .byte  191,63,117,191,191                  // mov           $0xbfbf753f,%edi
  .byte  63                                  // (bad)
  .byte  117,191                             // jne           3adf9 <.literal16+0x309>
  .byte  191,63,117,191,191                  // mov           $0xbfbf753f,%edi
  .byte  63                                  // (bad)
  .byte  249                                 // stc
  .byte  68,180,62                           // rex.R         mov $0x3e,%spl
  .byte  249                                 // stc
  .byte  68,180,62                           // rex.R         mov $0x3e,%spl
  .byte  249                                 // stc
  .byte  68,180,62                           // rex.R         mov $0x3e,%spl
  .byte  249                                 // stc
  .byte  68,180,62                           // rex.R         mov $0x3e,%spl
  .byte  163,233,220,63,163,233,220,63,163   // movabs        %eax,0xa33fdce9a33fdce9
  .byte  233,220,63,163,233                  // jmpq          ffffffffe9a6ee3a <_sk_srcover_bgra_8888_sse2_lowp+0xffffffffe9a34ed2>
  .byte  220,63                              // fdivrl        (%rdi)
  .byte  81                                  // push          %rcx
  .byte  140,242                             // mov           %?,%edx
  .byte  66,81                               // rex.X         push %rcx
  .byte  140,242                             // mov           %?,%edx
  .byte  66,81                               // rex.X         push %rcx
  .byte  140,242                             // mov           %?,%edx
  .byte  66,81                               // rex.X         push %rcx
  .byte  140,242                             // mov           %?,%edx
  .byte  66,141,188,190,63,141,188,190       // lea           -0x414372c1(%rsi,%r15,4),%edi
  .byte  63                                  // (bad)
  .byte  141,188,190,63,141,188,190          // lea           -0x414372c1(%rsi,%rdi,4),%edi
  .byte  63                                  // (bad)
  .byte  248                                 // clc
  .byte  245                                 // cmc
  .byte  154                                 // (bad)
  .byte  64,248                              // rex           clc
  .byte  245                                 // cmc
  .byte  154                                 // (bad)
  .byte  64,248                              // rex           clc
  .byte  245                                 // cmc
  .byte  154                                 // (bad)
  .byte  64,248                              // rex           clc
  .byte  245                                 // cmc
  .byte  154                                 // (bad)
  .byte  64,254                              // rex           (bad)
  .byte  210,221                             // rcr           %cl,%ch
  .byte  65,254                              // rex.B         (bad)
  .byte  210,221                             // rcr           %cl,%ch
  .byte  65,254                              // rex.B         (bad)
  .byte  210,221                             // rcr           %cl,%ch
  .byte  65,254                              // rex.B         (bad)
  .byte  210,221                             // rcr           %cl,%ch
  .byte  65,0,0                              // add           %al,(%r8)
  .byte  0,75,0                              // add           %cl,0x0(%rbx)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  75,0,0                              // rex.WXB       add %al,(%r8)
  .byte  0,75,0                              // add           %cl,0x0(%rbx)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  75,0,0                              // rex.WXB       add %al,(%r8)
  .byte  200,66,0,0                          // enterq        $0x42,$0x0
  .byte  200,66,0,0                          // enterq        $0x42,$0x0
  .byte  200,66,0,0                          // enterq        $0x42,$0x0
  .byte  200,66,0,0                          // enterq        $0x42,$0x0
  .byte  0,195                               // add           %al,%bl
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,195                               // add           %al,%bl
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,195                               // add           %al,%bl
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,195                               // add           %al,%bl
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,65,0,0                          // addb          $0x0,0x0(%rcx)
  .byte  128,65,0,0                          // addb          $0x0,0x0(%rcx)
  .byte  128,65,0,0                          // addb          $0x0,0x0(%rcx)
  .byte  128,65,203,61                       // addb          $0x3d,-0x35(%rcx)
  .byte  13,60,203,61,13                     // or            $0xd3dcb3c,%eax
  .byte  60,203                              // cmp           $0xcb,%al
  .byte  61,13,60,203,61                     // cmp           $0x3dcb3c0d,%eax
  .byte  13,60,111,18,3                      // or            $0x3126f3c,%eax
  .byte  59,111,18                           // cmp           0x12(%rdi),%ebp
  .byte  3,59                                // add           (%rbx),%edi
  .byte  111                                 // outsl         %ds:(%rsi),(%dx)
  .byte  18,3                                // adc           (%rbx),%al
  .byte  59,111,18                           // cmp           0x12(%rdi),%ebp
  .byte  3,59                                // add           (%rbx),%edi
  .byte  10,215                              // or            %bh,%dl
  .byte  163,59,10,215,163,59,10,215,163     // movabs        %eax,0xa3d70a3ba3d70a3b
  .byte  59,10                               // cmp           (%rdx),%ecx
  .byte  215                                 // xlat          %ds:(%rbx)
  .byte  163,59,194,24,17,60,194,24,17       // movabs        %eax,0x1118c23c1118c23b
  .byte  60,194                              // cmp           $0xc2,%al
  .byte  24,17                               // sbb           %dl,(%rcx)
  .byte  60,194                              // cmp           $0xc2,%al
  .byte  24,17                               // sbb           %dl,(%rcx)
  .byte  60,203                              // cmp           $0xcb,%al
  .byte  61,13,190,203,61                    // cmp           $0x3dcbbe0d,%eax
  .byte  13,190,203,61,13                    // or            $0xd3dcbbe,%eax
  .byte  190,203,61,13,190                   // mov           $0xbe0d3dcb,%esi
  .byte  80                                  // push          %rax
  .byte  128,3,62                            // addb          $0x3e,(%rbx)
  .byte  80                                  // push          %rax
  .byte  128,3,62                            // addb          $0x3e,(%rbx)
  .byte  80                                  // push          %rax
  .byte  128,3,62                            // addb          $0x3e,(%rbx)
  .byte  80                                  // push          %rax
  .byte  128,3,62                            // addb          $0x3e,(%rbx)
  .byte  31                                  // (bad)
  .byte  215                                 // xlat          %ds:(%rbx)
  .byte  118,63                              // jbe           3af83 <.literal16+0x493>
  .byte  31                                  // (bad)
  .byte  215                                 // xlat          %ds:(%rbx)
  .byte  118,63                              // jbe           3af87 <.literal16+0x497>
  .byte  31                                  // (bad)
  .byte  215                                 // xlat          %ds:(%rbx)
  .byte  118,63                              // jbe           3af8b <.literal16+0x49b>
  .byte  31                                  // (bad)
  .byte  215                                 // xlat          %ds:(%rbx)
  .byte  118,63                              // jbe           3af8f <.literal16+0x49f>
  .byte  246,64,83,63                        // testb         $0x3f,0x53(%rax)
  .byte  246,64,83,63                        // testb         $0x3f,0x53(%rax)
  .byte  246,64,83,63                        // testb         $0x3f,0x53(%rax)
  .byte  246,64,83,63                        // testb         $0x3f,0x53(%rax)
  .byte  0,4,0                               // add           %al,(%rax,%rax,1)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,248                               // add           %bh,%al
  .byte  65,0,0                              // add           %al,(%r8)
  .byte  248                                 // clc
  .byte  65,0,0                              // add           %al,(%r8)
  .byte  248                                 // clc
  .byte  65,0,0                              // add           %al,(%r8)
  .byte  248                                 // clc
  .byte  65,0,0                              // add           %al,(%r8)
  .byte  124,66                              // jl            3afc6 <.literal16+0x4d6>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  124,66                              // jl            3afca <.literal16+0x4da>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  124,66                              // jl            3afce <.literal16+0x4de>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  124,66                              // jl            3afd2 <.literal16+0x4e2>
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  137,136,136,55,137,136              // mov           %ecx,-0x7776c878(%rax)
  .byte  136,55                              // mov           %dh,(%rdi)
  .byte  137,136,136,55,137,136              // mov           %ecx,-0x7776c878(%rax)
  .byte  136,55                              // mov           %dh,(%rdi)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  137,136,136,57,137,136              // mov           %ecx,-0x7776c678(%rax)
  .byte  136,57                              // mov           %bh,(%rcx)
  .byte  137,136,136,57,137,136              // mov           %ecx,-0x7776c678(%rax)
  .byte  136,57                              // mov           %bh,(%rcx)
  .byte  240,0,0                             // lock          add %al,(%rax)
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,137,136,136,59,137                // add           %cl,-0x76c47778(%rcx)
  .byte  136,136,59,137,136,136              // mov           %cl,-0x777776c5(%rax)
  .byte  59,137,136,136,59,15                // cmp           0xf3b8888(%rcx),%ecx
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,137,136,136,61,137                // add           %cl,-0x76c27778(%rcx)
  .byte  136,136,61,137,136,136              // mov           %cl,-0x777776c3(%rax)
  .byte  61,137,136,136,61                   // cmp           $0x3d888889,%eax
  .byte  0,0                                 // add           %al,(%rax)
  .byte  112,65                              // jo            3b055 <.literal16+0x565>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  112,65                              // jo            3b059 <.literal16+0x569>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  112,65                              // jo            3b05d <.literal16+0x56d>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  112,65                              // jo            3b061 <.literal16+0x571>
  .byte  0,128,0,0,0,128                     // add           %al,-0x80000000(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,128,0,0,0,128                     // add           %al,-0x80000000(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            3b033 <.literal16+0x543>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,0                               // jg            3b037 <.literal16+0x547>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,0                               // jg            3b03b <.literal16+0x54b>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,0                               // jg            3b03f <.literal16+0x54f>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  56,0                                // cmp           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  56,0                                // cmp           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  56,0                                // cmp           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  56,0                                // cmp           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,0,0                             // addb          $0x0,(%rax)
  .byte  0,128,0,0,0,128                     // add           %al,-0x80000000(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,128,255,255,255,127               // add           %al,0x7fffffff(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  127,255                             // jg            3b078 <.literal16+0x588>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  127,255                             // jg            3b07c <.literal16+0x58c>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            3b081 <.literal16+0x591>
  .byte  0,128,56,0,0,128                    // add           %al,-0x7fffffc8(%rax)
  .byte  56,0                                // cmp           %al,(%rax)
  .byte  0,128,56,0,0,128                    // add           %al,-0x7fffffc8(%rax)
  .byte  56,0                                // cmp           %al,(%rax)
  .byte  64,254                              // rex           (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  64,254                              // rex           (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  64,254                              // rex           (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  64,254                              // rex           (bad)
  .byte  255,0                               // incl          (%rax)
  .byte  255                                 // (bad)
  .byte  127,71                              // jg            3b0eb <.literal16+0x5fb>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,71                              // jg            3b0ef <.literal16+0x5ff>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,71                              // jg            3b0f3 <.literal16+0x603>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,71                              // jg            3b0f7 <.literal16+0x607>
  .byte  208                                 // (bad)
  .byte  179,89                              // mov           $0x59,%bl
  .byte  62,208                              // ds            (bad)
  .byte  179,89                              // mov           $0x59,%bl
  .byte  62,208                              // ds            (bad)
  .byte  179,89                              // mov           $0x59,%bl
  .byte  62,208                              // ds            (bad)
  .byte  179,89                              // mov           $0x59,%bl
  .byte  62,89                               // ds            pop %rcx
  .byte  23                                  // (bad)
  .byte  55                                  // (bad)
  .byte  63                                  // (bad)
  .byte  89                                  // pop           %rcx
  .byte  23                                  // (bad)
  .byte  55                                  // (bad)
  .byte  63                                  // (bad)
  .byte  89                                  // pop           %rcx
  .byte  23                                  // (bad)
  .byte  55                                  // (bad)
  .byte  63                                  // (bad)
  .byte  89                                  // pop           %rcx
  .byte  23                                  // (bad)
  .byte  55                                  // (bad)
  .byte  63                                  // (bad)
  .byte  152                                 // cwtl
  .byte  221,147,61,152,221,147              // fstl          -0x6c2267c3(%rbx)
  .byte  61,152,221,147,61                   // cmp           $0x3d93dd98,%eax
  .byte  152                                 // cwtl
  .byte  221,147,61,111,43,231               // fstl          -0x18d490c3(%rbx)
  .byte  187,111,43,231,187                  // mov           $0xbbe72b6f,%ebx
  .byte  111                                 // outsl         %ds:(%rsi),(%dx)
  .byte  43,231                              // sub           %edi,%esp
  .byte  187,111,43,231,187                  // mov           $0xbbe72b6f,%ebx
  .byte  159                                 // lahf
  .byte  215                                 // xlat          %ds:(%rbx)
  .byte  202,60,159                          // lret          $0x9f3c
  .byte  215                                 // xlat          %ds:(%rbx)
  .byte  202,60,159                          // lret          $0x9f3c
  .byte  215                                 // xlat          %ds:(%rbx)
  .byte  202,60,159                          // lret          $0x9f3c
  .byte  215                                 // xlat          %ds:(%rbx)
  .byte  202,60,212                          // lret          $0xd43c
  .byte  100,84                              // fs            push %rsp
  .byte  189,212,100,84,189                  // mov           $0xbd5464d4,%ebp
  .byte  212                                 // (bad)
  .byte  100,84                              // fs            push %rsp
  .byte  189,212,100,84,189                  // mov           $0xbd5464d4,%ebp
  .byte  169,240,34,62,169                   // test          $0xa93e22f0,%eax
  .byte  240,34,62                           // lock          and (%rsi),%bh
  .byte  169,240,34,62,169                   // test          $0xa93e22f0,%eax
  .byte  240,34,62                           // lock          and (%rsi),%bh
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,62,0                            // cmpb          $0x0,(%rsi)
  .byte  0,128,62,0,0,128                    // add           %al,-0x7fffffc2(%rax)
  .byte  62,0,0                              // add           %al,%ds:(%rax)
  .byte  128,62,0                            // cmpb          $0x0,(%rsi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  192,0,0                             // rolb          $0x0,(%rax)
  .byte  0,192                               // add           %al,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,192                               // add           %al,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,192                               // add           %al,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,192,0                           // add           $0x0,%al
  .byte  0,128,192,0,0,128                   // add           %al,-0x7fffff40(%rax)
  .byte  192,0,0                             // rolb          $0x0,(%rax)
  .byte  128,192,0                           // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  191,0,0,0,191                       // mov           $0xbf000000,%edi
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,191,0,0,0,191                     // add           %bh,-0x41000000(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  192,191,0,0,192,191,0               // sarb          $0x0,-0x40400000(%rdi)
  .byte  0,192                               // add           %al,%al
  .byte  191,0,0,192,191                     // mov           $0xbfc00000,%edi
  .byte  114,28                              // jb            3b18e <.literal16+0x69e>
  .byte  199                                 // (bad)
  .byte  62,114,28                           // jb,pt         3b192 <.literal16+0x6a2>
  .byte  199                                 // (bad)
  .byte  62,114,28                           // jb,pt         3b196 <.literal16+0x6a6>
  .byte  199                                 // (bad)
  .byte  62,114,28                           // jb,pt         3b19a <.literal16+0x6aa>
  .byte  199                                 // (bad)
  .byte  62,85                               // ds            push %rbp
  .byte  85                                  // push          %rbp
  .byte  149                                 // xchg          %eax,%ebp
  .byte  191,85,85,149,191                   // mov           $0xbf955555,%edi
  .byte  85                                  // push          %rbp
  .byte  85                                  // push          %rbp
  .byte  149                                 // xchg          %eax,%ebp
  .byte  191,85,85,149,191                   // mov           $0xbf955555,%edi
  .byte  0,0                                 // add           %al,(%rax)
  .byte  192,63,0                            // sarb          $0x0,(%rdi)
  .byte  0,192                               // add           %al,%al
  .byte  63                                  // (bad)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  192,63,0                            // sarb          $0x0,(%rdi)
  .byte  0,192                               // add           %al,%al
  .byte  63                                  // (bad)
  .byte  57,142,99,61,57,142                 // cmp           %ecx,-0x71c6c29d(%rsi)
  .byte  99,61,57,142,99,61                  // movslq        0x3d638e39(%rip),%edi        # 3d673fe5 <_sk_srcover_bgra_8888_sse2_lowp+0x3d63a07d>
  .byte  57,142,99,61,114,249                // cmp           %ecx,-0x68dc29d(%rsi)
  .byte  127,63                              // jg            3b1f3 <.literal16+0x703>
  .byte  114,249                             // jb            3b1af <.literal16+0x6bf>
  .byte  127,63                              // jg            3b1f7 <.literal16+0x707>
  .byte  114,249                             // jb            3b1b3 <.literal16+0x6c3>
  .byte  127,63                              // jg            3b1fb <.literal16+0x70b>
  .byte  114,249                             // jb            3b1b7 <.literal16+0x6c7>
  .byte  127,63                              // jg            3b1ff <.literal16+0x70f>
  .byte  3,0                                 // add           (%rax),%eax
  .byte  0,0                                 // add           %al,(%rax)
  .byte  3,0                                 // add           (%rax),%eax
  .byte  0,0                                 // add           %al,(%rax)
  .byte  3,0                                 // add           (%rax),%eax
  .byte  0,0                                 // add           %al,(%rax)
  .byte  3,0                                 // add           (%rax),%eax
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,45,16,17,192,45                 // ljmp          *0x2dc01110(%rip)        # 2dc3c2f5 <_sk_srcover_bgra_8888_sse2_lowp+0x2dc0238d>
  .byte  16,17                               // adc           %dl,(%rcx)
  .byte  192,45,16,17,192,45,16              // shrb          $0x10,0x2dc01110(%rip)        # 2dc3c2fe <_sk_srcover_bgra_8888_sse2_lowp+0x2dc02396>
  .byte  17,192                              // adc           %eax,%eax
  .byte  18,120,57                           // adc           0x39(%rax),%bh
  .byte  64,18,120,57                        // adc           0x39(%rax),%dil
  .byte  64,18,120,57                        // adc           0x39(%rax),%dil
  .byte  64,18,120,57                        // adc           0x39(%rax),%dil
  .byte  64,32,148,90,62,32,148,90           // and           %dl,0x5a94203e(%rdx,%rbx,2)
  .byte  62,32,148,90,62,32,148,90           // and           %dl,%ds:0x5a94203e(%rdx,%rbx,2)
  .byte  62,4,157                            // ds            add $0x9d,%al
  .byte  30                                  // (bad)
  .byte  62,4,157                            // ds            add $0x9d,%al
  .byte  30                                  // (bad)
  .byte  62,4,157                            // ds            add $0x9d,%al
  .byte  30                                  // (bad)
  .byte  62,4,157                            // ds            add $0x9d,%al
  .byte  30                                  // (bad)
  .byte  62,0,24                             // add           %bl,%ds:(%rax)
  .byte  161,57,0,24,161,57,0,24,161         // movabs        0xa1180039a1180039,%eax
  .byte  57,0                                // cmp           %eax,(%rax)
  .byte  24,161,57,0,0,255                   // sbb           %ah,-0xffffc7(%rcx)
  .byte  255,0                               // incl          (%rax)
  .byte  0,255                               // add           %bh,%bh
  .byte  255,0                               // incl          (%rax)
  .byte  0,255                               // add           %bh,%bh
  .byte  255,0                               // incl          (%rax)
  .byte  0,255                               // add           %bh,%bh
  .byte  255,0                               // incl          (%rax)
  .byte  2,4,6                               // add           (%rsi,%rax,1),%al
  .byte  8,10                                // or            %cl,(%rdx)
  .byte  12,14                               // or            $0xe,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  254,1                               // incb          (%rcx)
  .byte  254,1                               // incb          (%rcx)
  .byte  254,1                               // incb          (%rcx)
  .byte  254,1                               // incb          (%rcx)
  .byte  254,1                               // incb          (%rcx)
  .byte  254,1                               // incb          (%rcx)
  .byte  254,1                               // incb          (%rcx)
  .byte  254,1                               // incb          (%rcx)
  .byte  0,128,0,128,0,128                   // add           %al,-0x7fff8000(%rax)
  .byte  0,128,0,128,0,128                   // add           %al,-0x7fff8000(%rax)
  .byte  0,128,0,128,0,1                     // add           %al,0x1008000(%rax)
  .byte  4,5                                 // add           $0x5,%al
  .byte  8,9                                 // or            %cl,(%rcx)
  .byte  12,13                               // or            $0xd,%al
  .byte  8,9                                 // or            %cl,(%rcx)
  .byte  12,13                               // or            $0xd,%al
  .byte  12,13                               // or            $0xd,%al
  .byte  14                                  // (bad)
  .byte  15,3,255                            // lsl           %di,%edi
  .byte  7                                   // (bad)
  .byte  255,11                              // decl          (%rbx)
  .byte  255,15                              // decl          (%rdi)
  .byte  255,11                              // decl          (%rbx)
  .byte  255,15                              // decl          (%rdi)
  .byte  255,15                              // decl          (%rdi)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255,2                               // incl          (%rdx)
  .byte  3,6                                 // add           (%rsi),%eax
  .byte  7                                   // (bad)
  .byte  10,11                               // or            (%rbx),%cl
  .byte  14                                  // (bad)
  .byte  15,10                               // (bad)
  .byte  11,14                               // or            (%rsi),%ecx
  .byte  15,14                               // femms
  .byte  15,255                              // (bad)
  .byte  255                                 // (bad)
  .byte  248                                 // clc
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,63                                // add           %bh,(%rdi)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,31                                // add           %bl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  248                                 // clc
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  224,255                             // loopne        3b2e1 <.literal16+0x7f1>
  .byte  224,255                             // loopne        3b2e3 <.literal16+0x7f3>
  .byte  224,255                             // loopne        3b2e5 <.literal16+0x7f5>
  .byte  224,255                             // loopne        3b2e7 <.literal16+0x7f7>
  .byte  224,255                             // loopne        3b2e9 <.literal16+0x7f9>
  .byte  224,255                             // loopne        3b2eb <.literal16+0x7fb>
  .byte  224,255                             // loopne        3b2ed <.literal16+0x7fd>
  .byte  224,255                             // loopne        3b2ef <.literal16+0x7ff>
  .byte  15,0,15                             // str           (%rdi)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,15                                // add           %cl,(%rdi)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  240,0,240                           // lock          add %dh,%al
  .byte  0,240                               // add           %dh,%al
  .byte  0,240                               // add           %dh,%al
  .byte  0,240                               // add           %dh,%al
  .byte  0,240                               // add           %dh,%al
  .byte  0,240                               // add           %dh,%al
  .byte  0,240                               // add           %dh,%al
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  240,255,240                         // lock          push %rax
  .byte  255,240                             // push          %rax
  .byte  255,240                             // push          %rax
  .byte  255,240                             // push          %rax
  .byte  255,240                             // push          %rax
  .byte  255,240                             // push          %rax
  .byte  255,240                             // push          %rax
  .byte  255,54                              // pushq         (%rsi)
  .byte  0,54                                // add           %dh,(%rsi)
  .byte  0,54                                // add           %dh,(%rsi)
  .byte  0,54                                // add           %dh,(%rsi)
  .byte  0,54                                // add           %dh,(%rsi)
  .byte  0,54                                // add           %dh,(%rsi)
  .byte  0,54                                // add           %dh,(%rsi)
  .byte  0,54                                // add           %dh,(%rsi)
  .byte  0,183,0,183,0,183                   // add           %dh,-0x48ff4900(%rdi)
  .byte  0,183,0,183,0,183                   // add           %dh,-0x48ff4900(%rdi)
  .byte  0,183,0,183,0,19                    // add           %dh,0x1300b700(%rdi)
  .byte  0,19                                // add           %dl,(%rbx)
  .byte  0,19                                // add           %dl,(%rbx)
  .byte  0,19                                // add           %dl,(%rbx)
  .byte  0,19                                // add           %dl,(%rbx)
  .byte  0,19                                // add           %dl,(%rbx)
  .byte  0,19                                // add           %dl,(%rbx)
  .byte  0,19                                // add           %dl,(%rbx)
  .byte  0,254                               // add           %bh,%dh
  .byte  0,254                               // add           %bh,%dh
  .byte  0,254                               // add           %bh,%dh
  .byte  0,254                               // add           %bh,%dh
  .byte  0,254                               // add           %bh,%dh
  .byte  0,254                               // add           %bh,%dh
  .byte  0,254                               // add           %bh,%dh
  .byte  0,254                               // add           %bh,%dh
  .byte  0                                   // .byte         0x0

BALIGN8
  .byte  1,0                                 // add           %eax,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  1,0                                 // add           %eax,(%rax)
  .byte  0,0                                 // add           %al,(%rax)
  .byte  2,0                                 // add           (%rax),%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  2,0                                 // add           (%rax),%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%rax)
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            3b38b <.literal8+0x1b>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,0                               // jg            3b38f <.literal8+0x1f>
  .byte  0,0                                 // add           %al,(%rax)
  .byte  128,0,0                             // addb          $0x0,(%rax)
  .byte  0                                   // .byte         0x0
  .byte  128,0,0                             // addb          $0x0,(%rax)
#elif defined(__i386__)
BALIGN32

HIDDEN _sk_start_pipeline_sse2
.globl _sk_start_pipeline_sse2
FUNCTION(_sk_start_pipeline_sse2)
_sk_start_pipeline_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  59,69,20                            // cmp           0x14(%ebp),%eax
  .byte  15,131,161,0,0,0                    // jae           b6 <_sk_start_pipeline_sse2+0xb6>
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,117,24                          // mov           0x18(%ebp),%esi
  .byte  139,62                              // mov           (%esi),%edi
  .byte  131,198,4                           // add           $0x4,%esi
  .byte  141,73,4                            // lea           0x4(%ecx),%ecx
  .byte  137,77,240                          // mov           %ecx,-0x10(%ebp)
  .byte  57,85,240                           // cmp           %edx,-0x10(%ebp)
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  137,77,152                          // mov           %ecx,-0x68(%ebp)
  .byte  137,69,236                          // mov           %eax,-0x14(%ebp)
  .byte  137,69,156                          // mov           %eax,-0x64(%ebp)
  .byte  199,69,160,0,0,0,0                  // movl          $0x0,-0x60(%ebp)
  .byte  141,69,168                          // lea           -0x58(%ebp),%eax
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,41,64,48                         // movaps        %xmm0,0x30(%eax)
  .byte  15,41,64,32                         // movaps        %xmm0,0x20(%eax)
  .byte  15,41,64,16                         // movaps        %xmm0,0x10(%eax)
  .byte  15,41,0                             // movaps        %xmm0,(%eax)
  .byte  137,200                             // mov           %ecx,%eax
  .byte  141,93,152                          // lea           -0x68(%ebp),%ebx
  .byte  119,41                              // ja            84 <_sk_start_pipeline_sse2+0x84>
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  86                                  // push          %esi
  .byte  83                                  // push          %ebx
  .byte  255,215                             // call          *%edi
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  131,196,16                          // add           $0x10,%esp
  .byte  139,77,152                          // mov           -0x68(%ebp),%ecx
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  137,69,152                          // mov           %eax,-0x68(%ebp)
  .byte  131,193,8                           // add           $0x8,%ecx
  .byte  57,209                              // cmp           %edx,%ecx
  .byte  118,215                             // jbe           5b <_sk_start_pipeline_sse2+0x5b>
  .byte  137,209                             // mov           %edx,%ecx
  .byte  41,193                              // sub           %eax,%ecx
  .byte  116,31                              // je            a9 <_sk_start_pipeline_sse2+0xa9>
  .byte  137,77,160                          // mov           %ecx,-0x60(%ebp)
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  86                                  // push          %esi
  .byte  141,69,152                          // lea           -0x68(%ebp),%eax
  .byte  80                                  // push          %eax
  .byte  255,215                             // call          *%edi
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  131,196,16                          // add           $0x10,%esp
  .byte  139,69,236                          // mov           -0x14(%ebp),%eax
  .byte  64                                  // inc           %eax
  .byte  59,69,20                            // cmp           0x14(%ebp),%eax
  .byte  15,133,115,255,255,255              // jne           29 <_sk_start_pipeline_sse2+0x29>
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_just_return_sse2
.globl _sk_just_return_sse2
FUNCTION(_sk_just_return_sse2)
_sk_just_return_sse2:
  .byte  195                                 // ret

HIDDEN _sk_seed_shader_sse2
.globl _sk_seed_shader_sse2
FUNCTION(_sk_seed_shader_sse2)
_sk_seed_shader_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  80                                  // push          %eax
  .byte  232,0,0,0,0                         // call          c9 <_sk_seed_shader_sse2+0xa>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  102,15,110,1                        // movd          (%ecx),%xmm0
  .byte  102,15,112,192,0                    // pshufd        $0x0,%xmm0,%xmm0
  .byte  15,91,200                           // cvtdq2ps      %xmm0,%xmm1
  .byte  15,16,6                             // movups        (%esi),%xmm0
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  102,15,110,73,4                     // movd          0x4(%ecx),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,88,136,71,250,0,0                // addps         0xfa47(%eax),%xmm1
  .byte  141,114,8                           // lea           0x8(%edx),%esi
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,41,81,64                         // movaps        %xmm2,0x40(%ecx)
  .byte  15,41,81,48                         // movaps        %xmm2,0x30(%ecx)
  .byte  15,41,81,32                         // movaps        %xmm2,0x20(%ecx)
  .byte  15,41,81,16                         // movaps        %xmm2,0x10(%ecx)
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,144,87,250,0,0                // movaps        0xfa57(%eax),%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  86                                  // push          %esi
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,20                          // add           $0x14,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_dither_sse2
.globl _sk_dither_sse2
FUNCTION(_sk_dither_sse2)
_sk_dither_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  131,236,36                          // sub           $0x24,%esp
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  15,41,85,232                        // movaps        %xmm2,-0x18(%ebp)
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  232,0,0,0,0                         // call          140 <_sk_dither_sse2+0x1a>
  .byte  89                                  // pop           %ecx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  102,15,110,32                       // movd          (%eax),%xmm4
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  102,15,254,161,240,249,0,0          // paddd         0xf9f0(%ecx),%xmm4
  .byte  102,15,110,104,4                    // movd          0x4(%eax),%xmm5
  .byte  102,15,112,253,0                    // pshufd        $0x0,%xmm5,%xmm7
  .byte  102,15,239,252                      // pxor          %xmm4,%xmm7
  .byte  102,15,111,177,0,250,0,0            // movdqa        0xfa00(%ecx),%xmm6
  .byte  102,15,111,207                      // movdqa        %xmm7,%xmm1
  .byte  102,15,219,206                      // pand          %xmm6,%xmm1
  .byte  102,15,114,241,5                    // pslld         $0x5,%xmm1
  .byte  102,15,111,129,32,250,0,0           // movdqa        0xfa20(%ecx),%xmm0
  .byte  102,15,111,239                      // movdqa        %xmm7,%xmm5
  .byte  102,15,219,232                      // pand          %xmm0,%xmm5
  .byte  102,15,114,245,2                    // pslld         $0x2,%xmm5
  .byte  102,15,235,233                      // por           %xmm1,%xmm5
  .byte  102,15,219,244                      // pand          %xmm4,%xmm6
  .byte  102,15,114,246,4                    // pslld         $0x4,%xmm6
  .byte  102,15,219,196                      // pand          %xmm4,%xmm0
  .byte  102,15,254,192                      // paddd         %xmm0,%xmm0
  .byte  102,15,235,198                      // por           %xmm6,%xmm0
  .byte  102,15,111,137,16,250,0,0           // movdqa        0xfa10(%ecx),%xmm1
  .byte  102,15,219,249                      // pand          %xmm1,%xmm7
  .byte  102,15,219,225                      // pand          %xmm1,%xmm4
  .byte  102,15,114,212,2                    // psrld         $0x2,%xmm4
  .byte  102,15,235,224                      // por           %xmm0,%xmm4
  .byte  102,15,235,229                      // por           %xmm5,%xmm4
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  102,15,114,215,1                    // psrld         $0x1,%xmm7
  .byte  102,15,235,231                      // por           %xmm7,%xmm4
  .byte  15,91,196                           // cvtdq2ps      %xmm4,%xmm0
  .byte  15,89,129,48,250,0,0                // mulps         0xfa30(%ecx),%xmm0
  .byte  15,88,129,64,250,0,0                // addps         0xfa40(%ecx),%xmm0
  .byte  243,15,16,14                        // movss         (%esi),%xmm1
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,88,209                           // addps         %xmm1,%xmm2
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  15,88,77,232                        // addps         -0x18(%ebp),%xmm1
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,93,208                           // minps         %xmm0,%xmm2
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  15,95,234                           // maxps         %xmm2,%xmm5
  .byte  15,93,216                           // minps         %xmm0,%xmm3
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,227                           // maxps         %xmm3,%xmm4
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,93,200                           // minps         %xmm0,%xmm1
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  15,95,209                           // maxps         %xmm1,%xmm2
  .byte  141,74,8                            // lea           0x8(%edx),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  81                                  // push          %ecx
  .byte  80                                  // push          %eax
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,52                          // add           $0x34,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_uniform_color_sse2
.globl _sk_uniform_color_sse2
FUNCTION(_sk_uniform_color_sse2)
_sk_uniform_color_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,1                         // movss         (%ecx),%xmm0
  .byte  243,15,16,73,4                      // movss         0x4(%ecx),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,81,8                      // movss         0x8(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,89,12                     // movss         0xc(%ecx),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_black_color_sse2
.globl _sk_black_color_sse2
FUNCTION(_sk_black_color_sse2)
_sk_black_color_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          27c <_sk_black_color_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,81,4                            // lea           0x4(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,152,164,248,0,0               // movaps        0xf8a4(%eax),%xmm3
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  82                                  // push          %edx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_white_color_sse2
.globl _sk_white_color_sse2
FUNCTION(_sk_white_color_sse2)
_sk_white_color_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          2ac <_sk_white_color_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,81,4                            // lea           0x4(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,128,116,248,0,0               // movaps        0xf874(%eax),%xmm0
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  82                                  // push          %edx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_load_rgba_sse2
.globl _sk_load_rgba_sse2
FUNCTION(_sk_load_rgba_sse2)
_sk_load_rgba_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  15,16,1                             // movups        (%ecx),%xmm0
  .byte  15,16,73,16                         // movups        0x10(%ecx),%xmm1
  .byte  15,16,81,32                         // movups        0x20(%ecx),%xmm2
  .byte  15,16,89,48                         // movups        0x30(%ecx),%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_store_rgba_sse2
.globl _sk_store_rgba_sse2
FUNCTION(_sk_store_rgba_sse2)
_sk_store_rgba_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  15,17,2                             // movups        %xmm0,(%edx)
  .byte  15,17,74,16                         // movups        %xmm1,0x10(%edx)
  .byte  15,17,82,32                         // movups        %xmm2,0x20(%edx)
  .byte  15,17,90,48                         // movups        %xmm3,0x30(%edx)
  .byte  141,81,8                            // lea           0x8(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_clear_sse2
.globl _sk_clear_sse2
FUNCTION(_sk_clear_sse2)
_sk_clear_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  141,72,4                            // lea           0x4(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_srcatop_sse2
.globl _sk_srcatop_sse2
FUNCTION(_sk_srcatop_sse2)
_sk_srcatop_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          35b <_sk_srcatop_sse2+0xb>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,40,97,64                         // movaps        0x40(%ecx),%xmm4
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,40,170,197,247,0,0               // movaps        0xf7c5(%edx),%xmm5
  .byte  15,92,235                           // subps         %xmm3,%xmm5
  .byte  15,40,113,16                        // movaps        0x10(%ecx),%xmm6
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,40,113,32                        // movaps        0x20(%ecx),%xmm6
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,40,113,48                        // movaps        0x30(%ecx),%xmm6
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_dstatop_sse2
.globl _sk_dstatop_sse2
FUNCTION(_sk_dstatop_sse2)
_sk_dstatop_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          3ba <_sk_dstatop_sse2+0xb>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,40,105,64                        // movaps        0x40(%ecx),%xmm5
  .byte  15,40,113,16                        // movaps        0x10(%ecx),%xmm6
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,40,162,102,247,0,0               // movaps        0xf766(%edx),%xmm4
  .byte  15,92,229                           // subps         %xmm5,%xmm4
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,40,113,32                        // movaps        0x20(%ecx),%xmm6
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,40,113,48                        // movaps        0x30(%ecx),%xmm6
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  15,89,235                           // mulps         %xmm3,%xmm5
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  15,88,229                           // addps         %xmm5,%xmm4
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_srcin_sse2
.globl _sk_srcin_sse2
FUNCTION(_sk_srcin_sse2)
_sk_srcin_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,40,97,64                         // movaps        0x40(%ecx),%xmm4
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_dstin_sse2
.globl _sk_dstin_sse2
FUNCTION(_sk_dstin_sse2)
_sk_dstin_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,40,65,16                         // movaps        0x10(%ecx),%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,40,73,32                         // movaps        0x20(%ecx),%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,40,81,48                         // movaps        0x30(%ecx),%xmm2
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,89,89,64                         // mulps         0x40(%ecx),%xmm3
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_srcout_sse2
.globl _sk_srcout_sse2
FUNCTION(_sk_srcout_sse2)
_sk_srcout_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          47b <_sk_srcout_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  15,40,160,165,246,0,0               // movaps        0xf6a5(%eax),%xmm4
  .byte  15,92,98,64                         // subps         0x40(%edx),%xmm4
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  82                                  // push          %edx
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_dstout_sse2
.globl _sk_dstout_sse2
FUNCTION(_sk_dstout_sse2)
_sk_dstout_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          4b3 <_sk_dstout_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  15,40,160,109,246,0,0               // movaps        0xf66d(%eax),%xmm4
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  15,40,66,16                         // movaps        0x10(%edx),%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,40,74,32                         // movaps        0x20(%edx),%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,40,82,48                         // movaps        0x30(%edx),%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,89,98,64                         // mulps         0x40(%edx),%xmm4
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  80                                  // push          %eax
  .byte  82                                  // push          %edx
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_srcover_sse2
.globl _sk_srcover_sse2
FUNCTION(_sk_srcover_sse2)
_sk_srcover_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          4fa <_sk_srcover_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  15,40,160,38,246,0,0                // movaps        0xf626(%eax),%xmm4
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  15,40,106,16                        // movaps        0x10(%edx),%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,40,106,32                        // movaps        0x20(%edx),%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  15,40,106,48                        // movaps        0x30(%edx),%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,89,98,64                         // mulps         0x40(%edx),%xmm4
  .byte  15,88,220                           // addps         %xmm4,%xmm3
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  82                                  // push          %edx
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_dstover_sse2
.globl _sk_dstover_sse2
FUNCTION(_sk_dstover_sse2)
_sk_dstover_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          54a <_sk_dstover_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  15,40,106,64                        // movaps        0x40(%edx),%xmm5
  .byte  15,40,160,214,245,0,0               // movaps        0xf5d6(%eax),%xmm4
  .byte  15,92,229                           // subps         %xmm5,%xmm4
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,66,16                         // addps         0x10(%edx),%xmm0
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,74,32                         // addps         0x20(%edx),%xmm1
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,82,48                         // addps         0x30(%edx),%xmm2
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  15,88,229                           // addps         %xmm5,%xmm4
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  80                                  // push          %eax
  .byte  82                                  // push          %edx
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_modulate_sse2
.globl _sk_modulate_sse2
FUNCTION(_sk_modulate_sse2)
_sk_modulate_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,89,65,16                         // mulps         0x10(%ecx),%xmm0
  .byte  15,89,73,32                         // mulps         0x20(%ecx),%xmm1
  .byte  15,89,81,48                         // mulps         0x30(%ecx),%xmm2
  .byte  15,89,89,64                         // mulps         0x40(%ecx),%xmm3
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_multiply_sse2
.globl _sk_multiply_sse2
FUNCTION(_sk_multiply_sse2)
_sk_multiply_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,56                          // sub           $0x38,%esp
  .byte  15,41,85,216                        // movaps        %xmm2,-0x28(%ebp)
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  232,0,0,0,0                         // call          5c9 <_sk_multiply_sse2+0x12>
  .byte  89                                  // pop           %ecx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  15,40,80,64                         // movaps        0x40(%eax),%xmm2
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  15,40,129,87,245,0,0                // movaps        0xf557(%ecx),%xmm0
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,92,242                           // subps         %xmm2,%xmm6
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  15,89,253                           // mulps         %xmm5,%xmm7
  .byte  15,92,195                           // subps         %xmm3,%xmm0
  .byte  15,40,80,16                         // movaps        0x10(%eax),%xmm2
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,89,226                           // mulps         %xmm2,%xmm4
  .byte  15,88,231                           // addps         %xmm7,%xmm4
  .byte  15,89,234                           // mulps         %xmm2,%xmm5
  .byte  15,88,236                           // addps         %xmm4,%xmm5
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  15,40,96,32                         // movaps        0x20(%eax),%xmm4
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  15,89,252                           // mulps         %xmm4,%xmm7
  .byte  15,88,250                           // addps         %xmm2,%xmm7
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  15,41,77,232                        // movaps        %xmm1,-0x18(%ebp)
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,40,85,216                        // movaps        -0x28(%ebp),%xmm2
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,40,96,48                         // movaps        0x30(%eax),%xmm4
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  15,89,252                           // mulps         %xmm4,%xmm7
  .byte  15,88,249                           // addps         %xmm1,%xmm7
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,40,77,200                        // movaps        -0x38(%ebp),%xmm1
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  15,88,216                           // addps         %xmm0,%xmm3
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,81,4                            // lea           0x4(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,40,77,232                        // movaps        -0x18(%ebp),%xmm1
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,72                          // add           $0x48,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_plus__sse2
.globl _sk_plus__sse2
FUNCTION(_sk_plus__sse2)
_sk_plus__sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          66f <_sk_plus__sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  15,88,66,16                         // addps         0x10(%edx),%xmm0
  .byte  15,40,160,177,244,0,0               // movaps        0xf4b1(%eax),%xmm4
  .byte  15,93,196                           // minps         %xmm4,%xmm0
  .byte  15,88,74,32                         // addps         0x20(%edx),%xmm1
  .byte  15,93,204                           // minps         %xmm4,%xmm1
  .byte  15,88,82,48                         // addps         0x30(%edx),%xmm2
  .byte  15,93,212                           // minps         %xmm4,%xmm2
  .byte  15,88,90,64                         // addps         0x40(%edx),%xmm3
  .byte  15,93,220                           // minps         %xmm4,%xmm3
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  82                                  // push          %edx
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_screen_sse2
.globl _sk_screen_sse2
FUNCTION(_sk_screen_sse2)
_sk_screen_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,40,105,16                        // movaps        0x10(%ecx),%xmm5
  .byte  15,40,113,32                        // movaps        0x20(%ecx),%xmm6
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,88,224                           // addps         %xmm0,%xmm4
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  15,92,229                           // subps         %xmm5,%xmm4
  .byte  15,40,238                           // movaps        %xmm6,%xmm5
  .byte  15,88,233                           // addps         %xmm1,%xmm5
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  15,92,238                           // subps         %xmm6,%xmm5
  .byte  15,40,65,48                         // movaps        0x30(%ecx),%xmm0
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,88,242                           // addps         %xmm2,%xmm6
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,92,240                           // subps         %xmm0,%xmm6
  .byte  15,40,65,64                         // movaps        0x40(%ecx),%xmm0
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  15,88,251                           // addps         %xmm3,%xmm7
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,92,248                           // subps         %xmm0,%xmm7
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,40,223                           // movaps        %xmm7,%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_xor__sse2
.globl _sk_xor__sse2
FUNCTION(_sk_xor__sse2)
_sk_xor__sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  232,0,0,0,0                         // call          71d <_sk_xor__sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,40,105,64                        // movaps        0x40(%ecx),%xmm5
  .byte  15,40,154,3,244,0,0                 // movaps        0xf403(%edx),%xmm3
  .byte  15,40,243                           // movaps        %xmm3,%xmm6
  .byte  15,92,245                           // subps         %xmm5,%xmm6
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,92,220                           // subps         %xmm4,%xmm3
  .byte  15,40,121,16                        // movaps        0x10(%ecx),%xmm7
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,40,121,32                        // movaps        0x20(%ecx),%xmm7
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,40,121,48                        // movaps        0x30(%ecx),%xmm7
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  15,89,221                           // mulps         %xmm5,%xmm3
  .byte  15,88,222                           // addps         %xmm6,%xmm3
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_darken_sse2
.globl _sk_darken_sse2
FUNCTION(_sk_darken_sse2)
_sk_darken_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  232,0,0,0,0                         // call          785 <_sk_darken_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,40,113,64                        // movaps        0x40(%ecx),%xmm6
  .byte  15,40,105,16                        // movaps        0x10(%ecx),%xmm5
  .byte  15,40,121,32                        // movaps        0x20(%ecx),%xmm7
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  15,89,235                           // mulps         %xmm3,%xmm5
  .byte  15,95,229                           // maxps         %xmm5,%xmm4
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,40,231                           // movaps        %xmm7,%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,95,207                           // maxps         %xmm7,%xmm1
  .byte  15,92,225                           // subps         %xmm1,%xmm4
  .byte  15,40,73,48                         // movaps        0x30(%ecx),%xmm1
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,88,234                           // addps         %xmm2,%xmm5
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,95,209                           // maxps         %xmm1,%xmm2
  .byte  15,92,234                           // subps         %xmm2,%xmm5
  .byte  15,40,138,155,243,0,0               // movaps        0xf39b(%edx),%xmm1
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  15,40,213                           // movaps        %xmm5,%xmm2
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_lighten_sse2
.globl _sk_lighten_sse2
FUNCTION(_sk_lighten_sse2)
_sk_lighten_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  232,0,0,0,0                         // call          805 <_sk_lighten_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,40,113,64                        // movaps        0x40(%ecx),%xmm6
  .byte  15,40,105,16                        // movaps        0x10(%ecx),%xmm5
  .byte  15,40,121,32                        // movaps        0x20(%ecx),%xmm7
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  15,89,235                           // mulps         %xmm3,%xmm5
  .byte  15,93,229                           // minps         %xmm5,%xmm4
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,40,231                           // movaps        %xmm7,%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,93,207                           // minps         %xmm7,%xmm1
  .byte  15,92,225                           // subps         %xmm1,%xmm4
  .byte  15,40,73,48                         // movaps        0x30(%ecx),%xmm1
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,88,234                           // addps         %xmm2,%xmm5
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,93,209                           // minps         %xmm1,%xmm2
  .byte  15,92,234                           // subps         %xmm2,%xmm5
  .byte  15,40,138,27,243,0,0                // movaps        0xf31b(%edx),%xmm1
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  15,40,213                           // movaps        %xmm5,%xmm2
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_difference_sse2
.globl _sk_difference_sse2
FUNCTION(_sk_difference_sse2)
_sk_difference_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          888 <_sk_difference_sse2+0x11>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,40,105,64                        // movaps        0x40(%ecx),%xmm5
  .byte  15,40,113,16                        // movaps        0x10(%ecx),%xmm6
  .byte  15,40,121,32                        // movaps        0x20(%ecx),%xmm7
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,93,206                           // minps         %xmm6,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,40,207                           // movaps        %xmm7,%xmm1
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,93,231                           // minps         %xmm7,%xmm4
  .byte  15,88,228                           // addps         %xmm4,%xmm4
  .byte  15,92,204                           // subps         %xmm4,%xmm1
  .byte  15,40,113,48                        // movaps        0x30(%ecx),%xmm6
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  15,88,226                           // addps         %xmm2,%xmm4
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,93,214                           // minps         %xmm6,%xmm2
  .byte  15,88,210                           // addps         %xmm2,%xmm2
  .byte  15,92,226                           // subps         %xmm2,%xmm4
  .byte  15,40,146,152,242,0,0               // movaps        0xf298(%edx),%xmm2
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,212                           // movaps        %xmm4,%xmm2
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_exclusion_sse2
.globl _sk_exclusion_sse2
FUNCTION(_sk_exclusion_sse2)
_sk_exclusion_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  232,0,0,0,0                         // call          90e <_sk_exclusion_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,40,105,16                        // movaps        0x10(%ecx),%xmm5
  .byte  15,40,113,32                        // movaps        0x20(%ecx),%xmm6
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,88,237                           // addps         %xmm5,%xmm5
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  15,88,246                           // addps         %xmm6,%xmm6
  .byte  15,92,230                           // subps         %xmm6,%xmm4
  .byte  15,40,73,48                         // movaps        0x30(%ecx),%xmm1
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,88,234                           // addps         %xmm2,%xmm5
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  15,40,138,18,242,0,0                // movaps        0xf212(%edx),%xmm1
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,89,73,64                         // mulps         0x40(%ecx),%xmm1
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  15,40,213                           // movaps        %xmm5,%xmm2
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_colorburn_sse2
.globl _sk_colorburn_sse2
FUNCTION(_sk_colorburn_sse2)
_sk_colorburn_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,88                          // sub           $0x58,%esp
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  15,41,85,168                        // movaps        %xmm2,-0x58(%ebp)
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  232,0,0,0,0                         // call          98d <_sk_colorburn_sse2+0x19>
  .byte  89                                  // pop           %ecx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  15,40,72,64                         // movaps        0x40(%eax),%xmm1
  .byte  15,40,104,16                        // movaps        0x10(%eax),%xmm5
  .byte  15,41,109,232                       // movaps        %xmm5,-0x18(%ebp)
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,83,244                           // rcpps         %xmm4,%xmm6
  .byte  15,89,240                           // mulps         %xmm0,%xmm6
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,93,198                           // minps         %xmm6,%xmm0
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,92,232                           // subps         %xmm0,%xmm5
  .byte  15,40,177,147,241,0,0               // movaps        0xf193(%ecx),%xmm6
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,41,69,200                        // movaps        %xmm0,-0x38(%ebp)
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  15,89,252                           // mulps         %xmm4,%xmm7
  .byte  15,40,93,232                        // movaps        -0x18(%ebp),%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  15,88,239                           // addps         %xmm7,%xmm5
  .byte  15,92,240                           // subps         %xmm0,%xmm6
  .byte  15,41,117,184                       // movaps        %xmm6,-0x48(%ebp)
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,40,117,232                       // movaps        -0x18(%ebp),%xmm6
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  15,194,231,0                        // cmpeqps       %xmm7,%xmm4
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  15,84,196                           // andps         %xmm4,%xmm0
  .byte  15,85,229                           // andnps        %xmm5,%xmm4
  .byte  15,86,224                           // orps          %xmm0,%xmm4
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,194,193,0                        // cmpeqps       %xmm1,%xmm0
  .byte  15,84,216                           // andps         %xmm0,%xmm3
  .byte  15,85,196                           // andnps        %xmm4,%xmm0
  .byte  15,86,195                           // orps          %xmm3,%xmm0
  .byte  15,41,69,232                        // movaps        %xmm0,-0x18(%ebp)
  .byte  15,40,96,32                         // movaps        0x20(%eax),%xmm4
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,40,109,216                       // movaps        -0x28(%ebp),%xmm5
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,83,218                           // rcpps         %xmm2,%xmm3
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,93,195                           // minps         %xmm3,%xmm0
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  15,92,216                           // subps         %xmm0,%xmm3
  .byte  15,40,117,200                       // movaps        -0x38(%ebp),%xmm6
  .byte  15,89,242                           // mulps         %xmm2,%xmm6
  .byte  15,40,69,184                        // movaps        -0x48(%ebp),%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,194,215,0                        // cmpeqps       %xmm7,%xmm2
  .byte  15,89,221                           // mulps         %xmm5,%xmm3
  .byte  15,88,222                           // addps         %xmm6,%xmm3
  .byte  15,88,216                           // addps         %xmm0,%xmm3
  .byte  15,84,194                           // andps         %xmm2,%xmm0
  .byte  15,85,211                           // andnps        %xmm3,%xmm2
  .byte  15,86,208                           // orps          %xmm0,%xmm2
  .byte  15,88,244                           // addps         %xmm4,%xmm6
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,194,233,0                        // cmpeqps       %xmm1,%xmm5
  .byte  15,84,245                           // andps         %xmm5,%xmm6
  .byte  15,85,234                           // andnps        %xmm2,%xmm5
  .byte  15,86,238                           // orps          %xmm6,%xmm5
  .byte  15,40,69,168                        // movaps        -0x58(%ebp),%xmm0
  .byte  15,40,117,200                       // movaps        -0x38(%ebp),%xmm6
  .byte  15,89,240                           // mulps         %xmm0,%xmm6
  .byte  15,41,117,200                       // movaps        %xmm6,-0x38(%ebp)
  .byte  15,194,248,0                        // cmpeqps       %xmm0,%xmm7
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  15,40,80,48                         // movaps        0x30(%eax),%xmm2
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,92,194                           // subps         %xmm2,%xmm0
  .byte  15,89,69,216                        // mulps         -0x28(%ebp),%xmm0
  .byte  15,83,219                           // rcpps         %xmm3,%xmm3
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,93,227                           // minps         %xmm3,%xmm4
  .byte  15,40,222                           // movaps        %xmm6,%xmm3
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  15,40,69,184                        // movaps        -0x48(%ebp),%xmm0
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,89,242                           // mulps         %xmm2,%xmm6
  .byte  15,194,209,0                        // cmpeqps       %xmm1,%xmm2
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,41,69,184                        // movaps        %xmm0,-0x48(%ebp)
  .byte  15,92,204                           // subps         %xmm4,%xmm1
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,88,77,200                        // addps         -0x38(%ebp),%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,84,247                           // andps         %xmm7,%xmm6
  .byte  15,85,249                           // andnps        %xmm1,%xmm7
  .byte  15,86,254                           // orps          %xmm6,%xmm7
  .byte  15,84,218                           // andps         %xmm2,%xmm3
  .byte  15,85,215                           // andnps        %xmm7,%xmm2
  .byte  15,86,211                           // orps          %xmm3,%xmm2
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  15,88,93,184                        // addps         -0x48(%ebp),%xmm3
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,81,4                            // lea           0x4(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,69,232                        // movaps        -0x18(%ebp),%xmm0
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,104                         // add           $0x68,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_colordodge_sse2
.globl _sk_colordodge_sse2
FUNCTION(_sk_colordodge_sse2)
_sk_colordodge_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,88                          // sub           $0x58,%esp
  .byte  15,40,243                           // movaps        %xmm3,%xmm6
  .byte  15,41,85,168                        // movaps        %xmm2,-0x58(%ebp)
  .byte  15,41,77,232                        // movaps        %xmm1,-0x18(%ebp)
  .byte  232,0,0,0,0                         // call          b16 <_sk_colordodge_sse2+0x16>
  .byte  89                                  // pop           %ecx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  15,40,72,16                         // movaps        0x10(%eax),%xmm1
  .byte  15,40,145,10,240,0,0                // movaps        0xf00a(%ecx),%xmm2
  .byte  15,40,226                           // movaps        %xmm2,%xmm4
  .byte  15,92,214                           // subps         %xmm6,%xmm2
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,41,85,184                        // movaps        %xmm2,-0x48(%ebp)
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  15,41,77,216                        // movaps        %xmm1,-0x28(%ebp)
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,92,216                           // subps         %xmm0,%xmm3
  .byte  15,83,219                           // rcpps         %xmm3,%xmm3
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  15,40,104,64                        // movaps        0x40(%eax),%xmm5
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,93,203                           // minps         %xmm3,%xmm1
  .byte  15,92,229                           // subps         %xmm5,%xmm4
  .byte  15,41,101,200                       // movaps        %xmm4,-0x38(%ebp)
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,194,230,0                        // cmpeqps       %xmm6,%xmm4
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  15,84,196                           // andps         %xmm4,%xmm0
  .byte  15,85,225                           // andnps        %xmm1,%xmm4
  .byte  15,86,224                           // orps          %xmm0,%xmm4
  .byte  15,88,231                           // addps         %xmm7,%xmm4
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,40,125,216                       // movaps        -0x28(%ebp),%xmm7
  .byte  15,194,248,0                        // cmpeqps       %xmm0,%xmm7
  .byte  15,84,223                           // andps         %xmm7,%xmm3
  .byte  15,85,252                           // andnps        %xmm4,%xmm7
  .byte  15,86,251                           // orps          %xmm3,%xmm7
  .byte  15,41,125,216                       // movaps        %xmm7,-0x28(%ebp)
  .byte  15,40,64,32                         // movaps        0x20(%eax),%xmm0
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,89,248                           // mulps         %xmm0,%xmm7
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  15,40,85,232                        // movaps        -0x18(%ebp),%xmm2
  .byte  15,92,226                           // subps         %xmm2,%xmm4
  .byte  15,83,228                           // rcpps         %xmm4,%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,93,204                           // minps         %xmm4,%xmm1
  .byte  15,40,101,200                       // movaps        -0x38(%ebp),%xmm4
  .byte  15,89,226                           // mulps         %xmm2,%xmm4
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,194,198,0                        // cmpeqps       %xmm6,%xmm0
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  15,84,208                           // andps         %xmm0,%xmm2
  .byte  15,85,193                           // andnps        %xmm1,%xmm0
  .byte  15,86,194                           // orps          %xmm2,%xmm0
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,194,217,0                        // cmpeqps       %xmm1,%xmm3
  .byte  15,84,227                           // andps         %xmm3,%xmm4
  .byte  15,85,216                           // andnps        %xmm0,%xmm3
  .byte  15,86,220                           // orps          %xmm4,%xmm3
  .byte  15,40,64,48                         // movaps        0x30(%eax),%xmm0
  .byte  15,194,200,0                        // cmpeqps       %xmm0,%xmm1
  .byte  15,41,77,232                        // movaps        %xmm1,-0x18(%ebp)
  .byte  15,40,77,184                        // movaps        -0x48(%ebp),%xmm1
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  15,40,125,168                       // movaps        -0x58(%ebp),%xmm7
  .byte  15,92,231                           // subps         %xmm7,%xmm4
  .byte  15,83,228                           // rcpps         %xmm4,%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,93,236                           // minps         %xmm4,%xmm5
  .byte  15,40,231                           // movaps        %xmm7,%xmm4
  .byte  15,40,125,200                       // movaps        -0x38(%ebp),%xmm7
  .byte  15,89,252                           // mulps         %xmm4,%xmm7
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,194,198,0                        // cmpeqps       %xmm6,%xmm0
  .byte  15,89,238                           // mulps         %xmm6,%xmm5
  .byte  15,88,239                           // addps         %xmm7,%xmm5
  .byte  15,84,224                           // andps         %xmm0,%xmm4
  .byte  15,85,197                           // andnps        %xmm5,%xmm0
  .byte  15,86,196                           // orps          %xmm4,%xmm0
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,40,85,232                        // movaps        -0x18(%ebp),%xmm2
  .byte  15,84,250                           // andps         %xmm2,%xmm7
  .byte  15,85,208                           // andnps        %xmm0,%xmm2
  .byte  15,86,215                           // orps          %xmm7,%xmm2
  .byte  15,88,241                           // addps         %xmm1,%xmm6
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,81,4                            // lea           0x4(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,40,222                           // movaps        %xmm6,%xmm3
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,104                         // add           $0x68,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_hardlight_sse2
.globl _sk_hardlight_sse2
FUNCTION(_sk_hardlight_sse2)
_sk_hardlight_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,88                          // sub           $0x58,%esp
  .byte  15,40,243                           // movaps        %xmm3,%xmm6
  .byte  15,41,85,168                        // movaps        %xmm2,-0x58(%ebp)
  .byte  15,41,77,232                        // movaps        %xmm1,-0x18(%ebp)
  .byte  232,0,0,0,0                         // call          c77 <_sk_hardlight_sse2+0x16>
  .byte  89                                  // pop           %ecx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  15,40,72,64                         // movaps        0x40(%eax),%xmm1
  .byte  15,40,145,169,238,0,0               // movaps        0xeea9(%ecx),%xmm2
  .byte  15,40,234                           // movaps        %xmm2,%xmm5
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,40,253                           // movaps        %xmm5,%xmm7
  .byte  15,89,248                           // mulps         %xmm0,%xmm7
  .byte  15,92,214                           // subps         %xmm6,%xmm2
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  15,40,88,16                         // movaps        0x10(%eax),%xmm3
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  15,40,212                           // movaps        %xmm4,%xmm2
  .byte  15,41,85,216                        // movaps        %xmm2,-0x28(%ebp)
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,92,251                           // subps         %xmm3,%xmm7
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  15,41,125,184                       // movaps        %xmm7,-0x48(%ebp)
  .byte  15,88,228                           // addps         %xmm4,%xmm4
  .byte  15,92,252                           // subps         %xmm4,%xmm7
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,88,228                           // addps         %xmm4,%xmm4
  .byte  15,194,230,2                        // cmpleps       %xmm6,%xmm4
  .byte  15,88,219                           // addps         %xmm3,%xmm3
  .byte  15,84,220                           // andps         %xmm4,%xmm3
  .byte  15,85,231                           // andnps        %xmm7,%xmm4
  .byte  15,86,227                           // orps          %xmm3,%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,40,85,232                        // movaps        -0x18(%ebp),%xmm2
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,40,88,32                         // movaps        0x20(%eax),%xmm3
  .byte  15,40,69,200                        // movaps        -0x38(%ebp),%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  15,40,77,216                        // movaps        -0x28(%ebp),%xmm1
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  15,92,250                           // subps         %xmm2,%xmm7
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  15,88,255                           // addps         %xmm7,%xmm7
  .byte  15,40,85,184                        // movaps        -0x48(%ebp),%xmm2
  .byte  15,92,215                           // subps         %xmm7,%xmm2
  .byte  15,40,77,232                        // movaps        -0x18(%ebp),%xmm1
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,194,206,2                        // cmpleps       %xmm6,%xmm1
  .byte  15,88,219                           // addps         %xmm3,%xmm3
  .byte  15,84,217                           // andps         %xmm1,%xmm3
  .byte  15,85,202                           // andnps        %xmm2,%xmm1
  .byte  15,86,203                           // orps          %xmm3,%xmm1
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  15,40,125,168                       // movaps        -0x58(%ebp),%xmm7
  .byte  15,89,239                           // mulps         %xmm7,%xmm5
  .byte  15,40,80,48                         // movaps        0x30(%eax),%xmm2
  .byte  15,40,93,200                        // movaps        -0x38(%ebp),%xmm3
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,41,69,232                        // movaps        %xmm0,-0x18(%ebp)
  .byte  15,40,239                           // movaps        %xmm7,%xmm5
  .byte  15,88,237                           // addps         %xmm5,%xmm5
  .byte  15,194,238,2                        // cmpleps       %xmm6,%xmm5
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,92,194                           // subps         %xmm2,%xmm0
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,88,222                           // addps         %xmm6,%xmm3
  .byte  15,92,247                           // subps         %xmm7,%xmm6
  .byte  15,89,240                           // mulps         %xmm0,%xmm6
  .byte  15,88,246                           // addps         %xmm6,%xmm6
  .byte  15,40,125,184                       // movaps        -0x48(%ebp),%xmm7
  .byte  15,92,254                           // subps         %xmm6,%xmm7
  .byte  15,88,210                           // addps         %xmm2,%xmm2
  .byte  15,84,213                           // andps         %xmm5,%xmm2
  .byte  15,85,239                           // andnps        %xmm7,%xmm5
  .byte  15,86,234                           // orps          %xmm2,%xmm5
  .byte  15,88,109,232                       // addps         -0x18(%ebp),%xmm5
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,81,4                            // lea           0x4(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,40,213                           // movaps        %xmm5,%xmm2
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,104                         // add           $0x68,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_overlay_sse2
.globl _sk_overlay_sse2
FUNCTION(_sk_overlay_sse2)
_sk_overlay_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,104                         // sub           $0x68,%esp
  .byte  15,41,93,232                        // movaps        %xmm3,-0x18(%ebp)
  .byte  15,41,85,152                        // movaps        %xmm2,-0x68(%ebp)
  .byte  15,41,77,168                        // movaps        %xmm1,-0x58(%ebp)
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  232,0,0,0,0                         // call          dc2 <_sk_overlay_sse2+0x1a>
  .byte  89                                  // pop           %ecx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  15,40,80,64                         // movaps        0x40(%eax),%xmm2
  .byte  15,40,161,94,237,0,0                // movaps        0xed5e(%ecx),%xmm4
  .byte  15,40,244                           // movaps        %xmm4,%xmm6
  .byte  15,92,242                           // subps         %xmm2,%xmm6
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  15,41,101,200                       // movaps        %xmm4,-0x38(%ebp)
  .byte  15,40,64,16                         // movaps        0x10(%eax),%xmm0
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,92,248                           // subps         %xmm0,%xmm7
  .byte  15,41,69,216                        // movaps        %xmm0,-0x28(%ebp)
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,40,77,232                        // movaps        -0x18(%ebp),%xmm1
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,92,229                           // subps         %xmm5,%xmm4
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,40,234                           // movaps        %xmm2,%xmm5
  .byte  15,89,233                           // mulps         %xmm1,%xmm5
  .byte  15,41,109,184                       // movaps        %xmm5,-0x48(%ebp)
  .byte  15,88,228                           // addps         %xmm4,%xmm4
  .byte  15,92,236                           // subps         %xmm4,%xmm5
  .byte  15,40,77,216                        // movaps        -0x28(%ebp),%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,194,202,2                        // cmpleps       %xmm2,%xmm1
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,84,193                           // andps         %xmm1,%xmm0
  .byte  15,85,205                           // andnps        %xmm5,%xmm1
  .byte  15,86,200                           // orps          %xmm0,%xmm1
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  15,41,77,216                        // movaps        %xmm1,-0x28(%ebp)
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,40,69,168                        // movaps        -0x58(%ebp),%xmm0
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,40,88,32                         // movaps        0x20(%eax),%xmm3
  .byte  15,40,101,200                       // movaps        -0x38(%ebp),%xmm4
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,40,235                           // movaps        %xmm3,%xmm5
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,40,125,232                       // movaps        -0x18(%ebp),%xmm7
  .byte  15,92,248                           // subps         %xmm0,%xmm7
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  15,88,255                           // addps         %xmm7,%xmm7
  .byte  15,40,77,184                        // movaps        -0x48(%ebp),%xmm1
  .byte  15,92,207                           // subps         %xmm7,%xmm1
  .byte  15,88,237                           // addps         %xmm5,%xmm5
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,194,239,2                        // cmpleps       %xmm7,%xmm5
  .byte  15,88,219                           // addps         %xmm3,%xmm3
  .byte  15,84,221                           // andps         %xmm5,%xmm3
  .byte  15,85,233                           // andnps        %xmm1,%xmm5
  .byte  15,86,235                           // orps          %xmm3,%xmm5
  .byte  15,88,236                           // addps         %xmm4,%xmm5
  .byte  15,40,93,152                        // movaps        -0x68(%ebp),%xmm3
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,40,72,48                         // movaps        0x30(%eax),%xmm1
  .byte  15,40,101,200                       // movaps        -0x38(%ebp),%xmm4
  .byte  15,40,212                           // movaps        %xmm4,%xmm2
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  15,40,241                           // movaps        %xmm1,%xmm6
  .byte  15,88,246                           // addps         %xmm6,%xmm6
  .byte  15,194,247,2                        // cmpleps       %xmm7,%xmm6
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,92,249                           // subps         %xmm1,%xmm7
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,40,251                           // movaps        %xmm3,%xmm7
  .byte  15,40,93,232                        // movaps        -0x18(%ebp),%xmm3
  .byte  15,88,227                           // addps         %xmm3,%xmm4
  .byte  15,92,223                           // subps         %xmm7,%xmm3
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,88,219                           // addps         %xmm3,%xmm3
  .byte  15,40,125,184                       // movaps        -0x48(%ebp),%xmm7
  .byte  15,92,251                           // subps         %xmm3,%xmm7
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,84,206                           // andps         %xmm6,%xmm1
  .byte  15,85,247                           // andnps        %xmm7,%xmm6
  .byte  15,86,241                           // orps          %xmm1,%xmm6
  .byte  15,88,242                           // addps         %xmm2,%xmm6
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,81,4                            // lea           0x4(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,120                         // add           $0x78,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_softlight_sse2
.globl _sk_softlight_sse2
FUNCTION(_sk_softlight_sse2)
_sk_softlight_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  129,236,184,0,0,0                   // sub           $0xb8,%esp
  .byte  15,41,93,168                        // movaps        %xmm3,-0x58(%ebp)
  .byte  15,41,149,88,255,255,255            // movaps        %xmm2,-0xa8(%ebp)
  .byte  15,41,77,136                        // movaps        %xmm1,-0x78(%ebp)
  .byte  15,41,69,216                        // movaps        %xmm0,-0x28(%ebp)
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  15,40,88,64                         // movaps        0x40(%eax),%xmm3
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,194,195,1                        // cmpltps       %xmm3,%xmm0
  .byte  15,41,69,200                        // movaps        %xmm0,-0x38(%ebp)
  .byte  15,40,104,16                        // movaps        0x10(%eax),%xmm5
  .byte  15,40,213                           // movaps        %xmm5,%xmm2
  .byte  15,94,211                           // divps         %xmm3,%xmm2
  .byte  15,84,208                           // andps         %xmm0,%xmm2
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,40,241                           // movaps        %xmm1,%xmm6
  .byte  15,89,246                           // mulps         %xmm6,%xmm6
  .byte  15,88,241                           // addps         %xmm1,%xmm6
  .byte  232,0,0,0,0                         // call          f52 <_sk_softlight_sse2+0x52>
  .byte  89                                  // pop           %ecx
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,40,137,62,236,0,0                // movaps        0xec3e(%ecx),%xmm1
  .byte  15,41,141,104,255,255,255           // movaps        %xmm1,-0x98(%ebp)
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,40,185,206,235,0,0               // movaps        0xebce(%ecx),%xmm7
  .byte  15,41,125,232                       // movaps        %xmm7,-0x18(%ebp)
  .byte  15,92,250                           // subps         %xmm2,%xmm7
  .byte  15,82,242                           // rsqrtps       %xmm2,%xmm6
  .byte  15,83,206                           // rcpps         %xmm6,%xmm1
  .byte  15,92,202                           // subps         %xmm2,%xmm1
  .byte  15,40,161,78,236,0,0                // movaps        0xec4e(%ecx),%xmm4
  .byte  15,41,101,152                       // movaps        %xmm4,-0x68(%ebp)
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,40,243                           // movaps        %xmm3,%xmm6
  .byte  15,41,117,184                       // movaps        %xmm6,-0x48(%ebp)
  .byte  15,194,198,2                        // cmpleps       %xmm6,%xmm0
  .byte  15,84,208                           // andps         %xmm0,%xmm2
  .byte  15,85,193                           // andnps        %xmm1,%xmm0
  .byte  15,86,194                           // orps          %xmm2,%xmm0
  .byte  15,40,85,216                        // movaps        -0x28(%ebp),%xmm2
  .byte  15,88,210                           // addps         %xmm2,%xmm2
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,40,93,168                        // movaps        -0x58(%ebp),%xmm3
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  15,88,251                           // addps         %xmm3,%xmm7
  .byte  15,89,253                           // mulps         %xmm5,%xmm7
  .byte  15,40,101,232                       // movaps        -0x18(%ebp),%xmm4
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  15,41,141,120,255,255,255           // movaps        %xmm1,-0x88(%ebp)
  .byte  15,40,117,216                       // movaps        -0x28(%ebp),%xmm6
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  15,41,101,216                       // movaps        %xmm4,-0x28(%ebp)
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,88,245                           // addps         %xmm5,%xmm6
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,194,211,2                        // cmpleps       %xmm3,%xmm2
  .byte  15,40,243                           // movaps        %xmm3,%xmm6
  .byte  15,84,250                           // andps         %xmm2,%xmm7
  .byte  15,85,208                           // andnps        %xmm0,%xmm2
  .byte  15,86,215                           // orps          %xmm7,%xmm2
  .byte  15,88,209                           // addps         %xmm1,%xmm2
  .byte  15,41,149,72,255,255,255            // movaps        %xmm2,-0xb8(%ebp)
  .byte  15,40,64,32                         // movaps        0x20(%eax),%xmm0
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,94,101,184                       // divps         -0x48(%ebp),%xmm4
  .byte  15,84,101,200                       // andps         -0x38(%ebp),%xmm4
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,88,201                           // addps         %xmm1,%xmm1
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  15,89,219                           // mulps         %xmm3,%xmm3
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  15,88,141,104,255,255,255           // addps         -0x98(%ebp),%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,40,125,232                       // movaps        -0x18(%ebp),%xmm7
  .byte  15,92,252                           // subps         %xmm4,%xmm7
  .byte  15,82,220                           // rsqrtps       %xmm4,%xmm3
  .byte  15,83,235                           // rcpps         %xmm3,%xmm5
  .byte  15,92,236                           // subps         %xmm4,%xmm5
  .byte  15,89,101,152                       // mulps         -0x68(%ebp),%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  15,40,93,136                        // movaps        -0x78(%ebp),%xmm3
  .byte  15,88,219                           // addps         %xmm3,%xmm3
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  15,88,254                           // addps         %xmm6,%xmm7
  .byte  15,89,248                           // mulps         %xmm0,%xmm7
  .byte  15,40,117,216                       // movaps        -0x28(%ebp),%xmm6
  .byte  15,89,240                           // mulps         %xmm0,%xmm6
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,194,69,184,2                     // cmpleps       -0x48(%ebp),%xmm0
  .byte  15,84,224                           // andps         %xmm0,%xmm4
  .byte  15,85,197                           // andnps        %xmm5,%xmm0
  .byte  15,86,196                           // orps          %xmm4,%xmm0
  .byte  15,40,101,184                       // movaps        -0x48(%ebp),%xmm4
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,40,109,168                       // movaps        -0x58(%ebp),%xmm5
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,40,77,136                        // movaps        -0x78(%ebp),%xmm1
  .byte  15,89,141,120,255,255,255           // mulps         -0x88(%ebp),%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,194,221,2                        // cmpleps       %xmm5,%xmm3
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  15,84,251                           // andps         %xmm3,%xmm7
  .byte  15,85,216                           // andnps        %xmm0,%xmm3
  .byte  15,86,223                           // orps          %xmm7,%xmm3
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  15,40,64,48                         // movaps        0x30(%eax),%xmm0
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  15,94,252                           // divps         %xmm4,%xmm7
  .byte  15,84,125,200                       // andps         -0x38(%ebp),%xmm7
  .byte  15,40,77,232                        // movaps        -0x18(%ebp),%xmm1
  .byte  15,92,207                           // subps         %xmm7,%xmm1
  .byte  15,41,77,232                        // movaps        %xmm1,-0x18(%ebp)
  .byte  15,40,173,104,255,255,255           // movaps        -0x98(%ebp),%xmm5
  .byte  15,88,239                           // addps         %xmm7,%xmm5
  .byte  15,40,101,152                       // movaps        -0x68(%ebp),%xmm4
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,82,207                           // rsqrtps       %xmm7,%xmm1
  .byte  15,83,201                           // rcpps         %xmm1,%xmm1
  .byte  15,92,207                           // subps         %xmm7,%xmm1
  .byte  15,41,77,200                        // movaps        %xmm1,-0x38(%ebp)
  .byte  15,88,255                           // addps         %xmm7,%xmm7
  .byte  15,88,255                           // addps         %xmm7,%xmm7
  .byte  15,40,215                           // movaps        %xmm7,%xmm2
  .byte  15,89,210                           // mulps         %xmm2,%xmm2
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  15,40,173,88,255,255,255            // movaps        -0xa8(%ebp),%xmm5
  .byte  15,88,237                           // addps         %xmm5,%xmm5
  .byte  15,40,213                           // movaps        %xmm5,%xmm2
  .byte  15,92,214                           // subps         %xmm6,%xmm2
  .byte  15,40,101,232                       // movaps        -0x18(%ebp),%xmm4
  .byte  15,89,226                           // mulps         %xmm2,%xmm4
  .byte  15,88,230                           // addps         %xmm6,%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,41,101,232                       // movaps        %xmm4,-0x18(%ebp)
  .byte  15,40,101,216                       // movaps        -0x28(%ebp),%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,40,125,184                       // movaps        -0x48(%ebp),%xmm7
  .byte  15,194,199,2                        // cmpleps       %xmm7,%xmm0
  .byte  15,84,200                           // andps         %xmm0,%xmm1
  .byte  15,85,69,200                        // andnps        -0x38(%ebp),%xmm0
  .byte  15,86,193                           // orps          %xmm1,%xmm0
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,40,85,168                        // movaps        -0x58(%ebp),%xmm2
  .byte  15,89,242                           // mulps         %xmm2,%xmm6
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,40,141,88,255,255,255            // movaps        -0xa8(%ebp),%xmm1
  .byte  15,89,141,120,255,255,255           // mulps         -0x88(%ebp),%xmm1
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  15,194,234,2                        // cmpleps       %xmm2,%xmm5
  .byte  15,40,226                           // movaps        %xmm2,%xmm4
  .byte  15,40,85,232                        // movaps        -0x18(%ebp),%xmm2
  .byte  15,84,213                           // andps         %xmm5,%xmm2
  .byte  15,85,232                           // andnps        %xmm0,%xmm5
  .byte  15,86,234                           // orps          %xmm2,%xmm5
  .byte  15,88,233                           // addps         %xmm1,%xmm5
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,89,199                           // mulps         %xmm7,%xmm0
  .byte  15,88,224                           // addps         %xmm0,%xmm4
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,81,4                            // lea           0x4(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,133,72,255,255,255            // movaps        -0xb8(%ebp),%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,40,213                           // movaps        %xmm5,%xmm2
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,17                              // call          *(%ecx)
  .byte  129,196,200,0,0,0                   // add           $0xc8,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_hue_sse2
.globl _sk_hue_sse2
FUNCTION(_sk_hue_sse2)
_sk_hue_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  129,236,184,0,0,0                   // sub           $0xb8,%esp
  .byte  15,40,251                           // movaps        %xmm3,%xmm7
  .byte  15,41,85,232                        // movaps        %xmm2,-0x18(%ebp)
  .byte  15,40,241                           // movaps        %xmm1,%xmm6
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  15,40,72,16                         // movaps        0x10(%eax),%xmm1
  .byte  15,40,64,32                         // movaps        0x20(%eax),%xmm0
  .byte  15,41,69,136                        // movaps        %xmm0,-0x78(%ebp)
  .byte  15,40,88,48                         // movaps        0x30(%eax),%xmm3
  .byte  15,41,93,200                        // movaps        %xmm3,-0x38(%ebp)
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,95,211                           // maxps         %xmm3,%xmm2
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,41,77,152                        // movaps        %xmm1,-0x68(%ebp)
  .byte  15,95,226                           // maxps         %xmm2,%xmm4
  .byte  15,93,195                           // minps         %xmm3,%xmm0
  .byte  15,93,200                           // minps         %xmm0,%xmm1
  .byte  15,92,225                           // subps         %xmm1,%xmm4
  .byte  15,41,101,168                       // movaps        %xmm4,-0x58(%ebp)
  .byte  232,0,0,0,0                         // call          1213 <_sk_hue_sse2+0x4f>
  .byte  89                                  // pop           %ecx
  .byte  15,40,221                           // movaps        %xmm5,%xmm3
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,40,226                           // movaps        %xmm2,%xmm4
  .byte  15,40,72,64                         // movaps        0x40(%eax),%xmm1
  .byte  15,41,77,216                        // movaps        %xmm1,-0x28(%ebp)
  .byte  15,40,169,13,233,0,0                // movaps        0xe90d(%ecx),%xmm5
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,41,133,72,255,255,255            // movaps        %xmm0,-0xb8(%ebp)
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,41,181,104,255,255,255           // movaps        %xmm6,-0x98(%ebp)
  .byte  15,40,69,232                        // movaps        -0x18(%ebp),%xmm0
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  15,41,173,88,255,255,255            // movaps        %xmm5,-0xa8(%ebp)
  .byte  15,40,215                           // movaps        %xmm7,%xmm2
  .byte  15,41,85,184                        // movaps        %xmm2,-0x48(%ebp)
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,93,200                           // minps         %xmm0,%xmm1
  .byte  15,40,243                           // movaps        %xmm3,%xmm6
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  15,93,249                           // minps         %xmm1,%xmm7
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,95,200                           // maxps         %xmm0,%xmm1
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  15,95,225                           // maxps         %xmm1,%xmm4
  .byte  15,92,231                           // subps         %xmm7,%xmm4
  .byte  15,92,247                           // subps         %xmm7,%xmm6
  .byte  15,92,239                           // subps         %xmm7,%xmm5
  .byte  15,92,199                           // subps         %xmm7,%xmm0
  .byte  15,40,77,168                        // movaps        -0x58(%ebp),%xmm1
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,89,233                           // mulps         %xmm1,%xmm5
  .byte  15,41,173,120,255,255,255           // movaps        %xmm5,-0x88(%ebp)
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,40,153,157,233,0,0               // movaps        0xe99d(%ecx),%xmm3
  .byte  15,41,93,232                        // movaps        %xmm3,-0x18(%ebp)
  .byte  15,40,117,152                       // movaps        -0x68(%ebp),%xmm6
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,40,153,173,233,0,0               // movaps        0xe9ad(%ecx),%xmm3
  .byte  15,40,109,136                       // movaps        -0x78(%ebp),%xmm5
  .byte  15,40,253                           // movaps        %xmm5,%xmm7
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,88,249                           // addps         %xmm1,%xmm7
  .byte  15,40,137,13,233,0,0                // movaps        0xe90d(%ecx),%xmm1
  .byte  15,92,77,184                        // subps         -0x48(%ebp),%xmm1
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  15,41,117,152                       // movaps        %xmm6,-0x68(%ebp)
  .byte  15,89,233                           // mulps         %xmm1,%xmm5
  .byte  15,41,109,136                       // movaps        %xmm5,-0x78(%ebp)
  .byte  15,40,241                           // movaps        %xmm1,%xmm6
  .byte  15,40,77,200                        // movaps        -0x38(%ebp),%xmm1
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  15,41,117,168                       // movaps        %xmm6,-0x58(%ebp)
  .byte  15,40,169,189,233,0,0               // movaps        0xe9bd(%ecx),%xmm5
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  15,94,212                           // divps         %xmm4,%xmm2
  .byte  15,40,181,120,255,255,255           // movaps        -0x88(%ebp),%xmm6
  .byte  15,94,244                           // divps         %xmm4,%xmm6
  .byte  15,94,196                           // divps         %xmm4,%xmm0
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  15,194,231,4                        // cmpneqps      %xmm7,%xmm4
  .byte  15,84,212                           // andps         %xmm4,%xmm2
  .byte  15,84,244                           // andps         %xmm4,%xmm6
  .byte  15,84,224                           // andps         %xmm0,%xmm4
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,89,69,232                        // mulps         -0x18(%ebp),%xmm0
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,89,77,184                        // mulps         -0x48(%ebp),%xmm1
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,88,209                           // addps         %xmm1,%xmm2
  .byte  15,88,241                           // addps         %xmm1,%xmm6
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,93,193                           // minps         %xmm1,%xmm0
  .byte  15,40,226                           // movaps        %xmm2,%xmm4
  .byte  15,93,224                           // minps         %xmm0,%xmm4
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,95,193                           // maxps         %xmm1,%xmm0
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,95,248                           // maxps         %xmm0,%xmm7
  .byte  15,40,69,232                        // movaps        -0x18(%ebp),%xmm0
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,89,222                           // mulps         %xmm6,%xmm3
  .byte  15,88,216                           // addps         %xmm0,%xmm3
  .byte  15,89,233                           // mulps         %xmm1,%xmm5
  .byte  15,88,235                           // addps         %xmm3,%xmm5
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,194,196,2                        // cmpleps       %xmm4,%xmm0
  .byte  15,40,221                           // movaps        %xmm5,%xmm3
  .byte  15,92,220                           // subps         %xmm4,%xmm3
  .byte  15,41,93,232                        // movaps        %xmm3,-0x18(%ebp)
  .byte  15,40,226                           // movaps        %xmm2,%xmm4
  .byte  15,92,229                           // subps         %xmm5,%xmm4
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,94,227                           // divps         %xmm3,%xmm4
  .byte  15,88,229                           // addps         %xmm5,%xmm4
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  15,85,220                           // andnps        %xmm4,%xmm3
  .byte  15,40,226                           // movaps        %xmm2,%xmm4
  .byte  15,84,224                           // andps         %xmm0,%xmm4
  .byte  15,86,227                           // orps          %xmm3,%xmm4
  .byte  15,40,85,216                        // movaps        -0x28(%ebp),%xmm2
  .byte  15,40,93,184                        // movaps        -0x48(%ebp),%xmm3
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,88,93,216                        // addps         -0x28(%ebp),%xmm3
  .byte  15,92,218                           // subps         %xmm2,%xmm3
  .byte  15,41,93,184                        // movaps        %xmm3,-0x48(%ebp)
  .byte  15,41,85,216                        // movaps        %xmm2,-0x28(%ebp)
  .byte  15,194,215,1                        // cmpltps       %xmm7,%xmm2
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,85,220                           // andnps        %xmm4,%xmm3
  .byte  15,41,93,200                        // movaps        %xmm3,-0x38(%ebp)
  .byte  15,92,229                           // subps         %xmm5,%xmm4
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  15,92,221                           // subps         %xmm5,%xmm3
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  15,92,253                           // subps         %xmm5,%xmm7
  .byte  15,94,231                           // divps         %xmm7,%xmm4
  .byte  15,88,229                           // addps         %xmm5,%xmm4
  .byte  15,84,226                           // andps         %xmm2,%xmm4
  .byte  15,86,101,200                       // orps          -0x38(%ebp),%xmm4
  .byte  15,41,101,200                       // movaps        %xmm4,-0x38(%ebp)
  .byte  15,40,222                           // movaps        %xmm6,%xmm3
  .byte  15,92,221                           // subps         %xmm5,%xmm3
  .byte  15,89,221                           // mulps         %xmm5,%xmm3
  .byte  15,94,93,232                        // divps         -0x18(%ebp),%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,85,227                           // andnps        %xmm3,%xmm4
  .byte  15,84,240                           // andps         %xmm0,%xmm6
  .byte  15,86,244                           // orps          %xmm4,%xmm6
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  15,85,220                           // andnps        %xmm4,%xmm3
  .byte  15,92,229                           // subps         %xmm5,%xmm4
  .byte  15,40,117,216                       // movaps        -0x28(%ebp),%xmm6
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  15,94,231                           // divps         %xmm7,%xmm4
  .byte  15,88,229                           // addps         %xmm5,%xmm4
  .byte  15,84,226                           // andps         %xmm2,%xmm4
  .byte  15,86,227                           // orps          %xmm3,%xmm4
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  15,92,221                           // subps         %xmm5,%xmm3
  .byte  15,89,221                           // mulps         %xmm5,%xmm3
  .byte  15,94,93,232                        // divps         -0x18(%ebp),%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  15,84,200                           // andps         %xmm0,%xmm1
  .byte  15,85,195                           // andnps        %xmm3,%xmm0
  .byte  15,86,193                           // orps          %xmm1,%xmm0
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,85,200                           // andnps        %xmm0,%xmm1
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,94,199                           // divps         %xmm7,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,84,194                           // andps         %xmm2,%xmm0
  .byte  15,86,193                           // orps          %xmm1,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,40,85,200                        // movaps        -0x38(%ebp),%xmm2
  .byte  15,95,209                           // maxps         %xmm1,%xmm2
  .byte  15,95,225                           // maxps         %xmm1,%xmm4
  .byte  15,95,193                           // maxps         %xmm1,%xmm0
  .byte  15,40,157,72,255,255,255            // movaps        -0xb8(%ebp),%xmm3
  .byte  15,88,93,152                        // addps         -0x68(%ebp),%xmm3
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  15,40,141,104,255,255,255           // movaps        -0x98(%ebp),%xmm1
  .byte  15,88,77,136                        // addps         -0x78(%ebp),%xmm1
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  15,40,85,168                        // movaps        -0x58(%ebp),%xmm2
  .byte  15,88,149,88,255,255,255            // addps         -0xa8(%ebp),%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,81,4                            // lea           0x4(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,40,93,184                        // movaps        -0x48(%ebp),%xmm3
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,17                              // call          *(%ecx)
  .byte  129,196,200,0,0,0                   // add           $0xc8,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_saturation_sse2
.globl _sk_saturation_sse2
FUNCTION(_sk_saturation_sse2)
_sk_saturation_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  129,236,216,0,0,0                   // sub           $0xd8,%esp
  .byte  15,41,149,40,255,255,255            // movaps        %xmm2,-0xd8(%ebp)
  .byte  15,41,141,56,255,255,255            // movaps        %xmm1,-0xc8(%ebp)
  .byte  15,41,133,72,255,255,255            // movaps        %xmm0,-0xb8(%ebp)
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  15,40,112,16                        // movaps        0x10(%eax),%xmm6
  .byte  15,41,117,184                       // movaps        %xmm6,-0x48(%ebp)
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,95,226                           // maxps         %xmm2,%xmm4
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  15,95,236                           // maxps         %xmm4,%xmm5
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,93,226                           // minps         %xmm2,%xmm4
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,93,212                           // minps         %xmm4,%xmm2
  .byte  15,40,64,32                         // movaps        0x20(%eax),%xmm0
  .byte  15,92,234                           // subps         %xmm2,%xmm5
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  15,40,120,48                        // movaps        0x30(%eax),%xmm7
  .byte  15,41,125,200                       // movaps        %xmm7,-0x38(%ebp)
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  15,93,207                           // minps         %xmm7,%xmm1
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,93,209                           // minps         %xmm1,%xmm2
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,95,207                           // maxps         %xmm7,%xmm1
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,95,225                           // maxps         %xmm1,%xmm4
  .byte  15,92,226                           // subps         %xmm2,%xmm4
  .byte  15,92,194                           // subps         %xmm2,%xmm0
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,92,218                           // subps         %xmm2,%xmm3
  .byte  15,92,250                           // subps         %xmm2,%xmm7
  .byte  15,40,64,64                         // movaps        0x40(%eax),%xmm0
  .byte  15,41,69,152                        // movaps        %xmm0,-0x68(%ebp)
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,41,77,168                        // movaps        %xmm1,-0x58(%ebp)
  .byte  15,89,221                           // mulps         %xmm5,%xmm3
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,89,253                           // mulps         %xmm5,%xmm7
  .byte  232,0,0,0,0                         // call          1567 <_sk_saturation_sse2+0xb0>
  .byte  89                                  // pop           %ecx
  .byte  15,40,153,73,230,0,0                // movaps        0xe649(%ecx),%xmm3
  .byte  15,41,157,88,255,255,255            // movaps        %xmm3,-0xa8(%ebp)
  .byte  15,40,77,184                        // movaps        -0x48(%ebp),%xmm1
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,40,153,89,230,0,0                // movaps        0xe659(%ecx),%xmm3
  .byte  15,41,93,232                        // movaps        %xmm3,-0x18(%ebp)
  .byte  15,40,238                           // movaps        %xmm6,%xmm5
  .byte  15,89,235                           // mulps         %xmm3,%xmm5
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  15,40,129,185,229,0,0               // movaps        0xe5b9(%ecx),%xmm0
  .byte  15,41,133,104,255,255,255           // movaps        %xmm0,-0x98(%ebp)
  .byte  15,92,69,216                        // subps         -0x28(%ebp),%xmm0
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,41,77,184                        // movaps        %xmm1,-0x48(%ebp)
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  15,41,117,136                       // movaps        %xmm6,-0x78(%ebp)
  .byte  15,40,69,200                        // movaps        -0x38(%ebp),%xmm0
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,41,141,120,255,255,255           // movaps        %xmm1,-0x88(%ebp)
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,129,105,230,0,0               // movaps        0xe669(%ecx),%xmm0
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  15,40,109,168                       // movaps        -0x58(%ebp),%xmm5
  .byte  15,94,236                           // divps         %xmm4,%xmm5
  .byte  15,94,212                           // divps         %xmm4,%xmm2
  .byte  15,94,252                           // divps         %xmm4,%xmm7
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,194,227,4                        // cmpneqps      %xmm3,%xmm4
  .byte  15,84,236                           // andps         %xmm4,%xmm5
  .byte  15,84,212                           // andps         %xmm4,%xmm2
  .byte  15,84,231                           // andps         %xmm7,%xmm4
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  15,40,165,88,255,255,255            // movaps        -0xa8(%ebp),%xmm4
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,89,125,232                       // mulps         -0x18(%ebp),%xmm7
  .byte  15,88,254                           // addps         %xmm6,%xmm7
  .byte  15,40,243                           // movaps        %xmm3,%xmm6
  .byte  15,89,240                           // mulps         %xmm0,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  15,89,77,216                        // mulps         -0x28(%ebp),%xmm1
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  15,88,233                           // addps         %xmm1,%xmm5
  .byte  15,88,209                           // addps         %xmm1,%xmm2
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,93,217                           // minps         %xmm1,%xmm3
  .byte  15,40,253                           // movaps        %xmm5,%xmm7
  .byte  15,93,251                           // minps         %xmm3,%xmm7
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,95,217                           // maxps         %xmm1,%xmm3
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  15,95,243                           // maxps         %xmm3,%xmm6
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,40,93,232                        // movaps        -0x18(%ebp),%xmm3
  .byte  15,89,218                           // mulps         %xmm2,%xmm3
  .byte  15,88,220                           // addps         %xmm4,%xmm3
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,88,195                           // addps         %xmm3,%xmm0
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,194,223,2                        // cmpleps       %xmm7,%xmm3
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,92,215                           // subps         %xmm7,%xmm2
  .byte  15,41,85,232                        // movaps        %xmm2,-0x18(%ebp)
  .byte  15,40,253                           // movaps        %xmm5,%xmm7
  .byte  15,92,248                           // subps         %xmm0,%xmm7
  .byte  15,89,248                           // mulps         %xmm0,%xmm7
  .byte  15,94,250                           // divps         %xmm2,%xmm7
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,85,215                           // andnps        %xmm7,%xmm2
  .byte  15,84,235                           // andps         %xmm3,%xmm5
  .byte  15,86,234                           // orps          %xmm2,%xmm5
  .byte  15,40,125,152                       // movaps        -0x68(%ebp),%xmm7
  .byte  15,40,215                           // movaps        %xmm7,%xmm2
  .byte  15,40,101,216                       // movaps        -0x28(%ebp),%xmm4
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,231                           // addps         %xmm7,%xmm4
  .byte  15,92,226                           // subps         %xmm2,%xmm4
  .byte  15,41,101,216                       // movaps        %xmm4,-0x28(%ebp)
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,194,214,1                        // cmpltps       %xmm6,%xmm2
  .byte  15,40,226                           // movaps        %xmm2,%xmm4
  .byte  15,85,229                           // andnps        %xmm5,%xmm4
  .byte  15,92,232                           // subps         %xmm0,%xmm5
  .byte  15,92,248                           // subps         %xmm0,%xmm7
  .byte  15,89,239                           // mulps         %xmm7,%xmm5
  .byte  15,92,240                           // subps         %xmm0,%xmm6
  .byte  15,94,238                           // divps         %xmm6,%xmm5
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  15,84,234                           // andps         %xmm2,%xmm5
  .byte  15,86,236                           // orps          %xmm4,%xmm5
  .byte  15,41,109,168                       // movaps        %xmm5,-0x58(%ebp)
  .byte  15,40,101,200                       // movaps        -0x38(%ebp),%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,94,101,232                       // divps         -0x18(%ebp),%xmm4
  .byte  15,88,224                           // addps         %xmm0,%xmm4
  .byte  15,40,235                           // movaps        %xmm3,%xmm5
  .byte  15,85,236                           // andnps        %xmm4,%xmm5
  .byte  15,40,101,200                       // movaps        -0x38(%ebp),%xmm4
  .byte  15,84,227                           // andps         %xmm3,%xmm4
  .byte  15,86,229                           // orps          %xmm5,%xmm4
  .byte  15,40,234                           // movaps        %xmm2,%xmm5
  .byte  15,85,236                           // andnps        %xmm4,%xmm5
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,94,230                           // divps         %xmm6,%xmm4
  .byte  15,88,224                           // addps         %xmm0,%xmm4
  .byte  15,84,226                           // andps         %xmm2,%xmm4
  .byte  15,86,229                           // orps          %xmm5,%xmm4
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,94,101,232                       // divps         -0x18(%ebp),%xmm4
  .byte  15,88,224                           // addps         %xmm0,%xmm4
  .byte  15,84,203                           // andps         %xmm3,%xmm1
  .byte  15,85,220                           // andnps        %xmm4,%xmm3
  .byte  15,86,217                           // orps          %xmm1,%xmm3
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,85,203                           // andnps        %xmm3,%xmm1
  .byte  15,92,216                           // subps         %xmm0,%xmm3
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  15,94,222                           // divps         %xmm6,%xmm3
  .byte  15,88,216                           // addps         %xmm0,%xmm3
  .byte  15,84,218                           // andps         %xmm2,%xmm3
  .byte  15,86,217                           // orps          %xmm1,%xmm3
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,40,77,168                        // movaps        -0x58(%ebp),%xmm1
  .byte  15,95,200                           // maxps         %xmm0,%xmm1
  .byte  15,95,232                           // maxps         %xmm0,%xmm5
  .byte  15,95,216                           // maxps         %xmm0,%xmm3
  .byte  15,40,165,104,255,255,255           // movaps        -0x98(%ebp),%xmm4
  .byte  15,92,101,152                       // subps         -0x68(%ebp),%xmm4
  .byte  15,40,133,72,255,255,255            // movaps        -0xb8(%ebp),%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,69,184                        // addps         -0x48(%ebp),%xmm0
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  15,40,141,56,255,255,255            // movaps        -0xc8(%ebp),%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,77,136                        // addps         -0x78(%ebp),%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  15,89,165,40,255,255,255            // mulps         -0xd8(%ebp),%xmm4
  .byte  15,40,149,120,255,255,255           // movaps        -0x88(%ebp),%xmm2
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,81,4                            // lea           0x4(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,17                              // call          *(%ecx)
  .byte  129,196,232,0,0,0                   // add           $0xe8,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_color_sse2
.globl _sk_color_sse2
FUNCTION(_sk_color_sse2)
_sk_color_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  129,236,200,0,0,0                   // sub           $0xc8,%esp
  .byte  15,41,93,200                        // movaps        %xmm3,-0x38(%ebp)
  .byte  15,41,85,152                        // movaps        %xmm2,-0x68(%ebp)
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,41,165,104,255,255,255           // movaps        %xmm4,-0x98(%ebp)
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  15,41,173,120,255,255,255           // movaps        %xmm5,-0x88(%ebp)
  .byte  232,0,0,0,0                         // call          17c2 <_sk_color_sse2+0x2a>
  .byte  89                                  // pop           %ecx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  15,40,80,16                         // movaps        0x10(%eax),%xmm2
  .byte  15,40,72,32                         // movaps        0x20(%eax),%xmm1
  .byte  15,40,177,238,227,0,0               // movaps        0xe3ee(%ecx),%xmm6
  .byte  15,41,117,216                       // movaps        %xmm6,-0x28(%ebp)
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,40,153,254,227,0,0               // movaps        0xe3fe(%ecx),%xmm3
  .byte  15,41,93,184                        // movaps        %xmm3,-0x48(%ebp)
  .byte  15,40,241                           // movaps        %xmm1,%xmm6
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,88,240                           // addps         %xmm0,%xmm6
  .byte  15,40,129,94,227,0,0                // movaps        0xe35e(%ecx),%xmm0
  .byte  15,41,69,168                        // movaps        %xmm0,-0x58(%ebp)
  .byte  15,92,69,200                        // subps         -0x38(%ebp),%xmm0
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,41,149,56,255,255,255            // movaps        %xmm2,-0xc8(%ebp)
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,41,141,88,255,255,255            // movaps        %xmm1,-0xa8(%ebp)
  .byte  15,40,80,48                         // movaps        0x30(%eax),%xmm2
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,41,133,72,255,255,255            // movaps        %xmm0,-0xb8(%ebp)
  .byte  15,40,137,14,228,0,0                // movaps        0xe40e(%ecx),%xmm1
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  15,40,88,64                         // movaps        0x40(%eax),%xmm3
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,40,243                           // movaps        %xmm3,%xmm6
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  15,89,109,216                       // mulps         -0x28(%ebp),%xmm5
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  15,89,125,184                       // mulps         -0x48(%ebp),%xmm7
  .byte  15,88,253                           // addps         %xmm5,%xmm7
  .byte  15,40,109,168                       // movaps        -0x58(%ebp),%xmm5
  .byte  15,92,235                           // subps         %xmm3,%xmm5
  .byte  15,41,109,168                       // movaps        %xmm5,-0x58(%ebp)
  .byte  15,40,109,200                       // movaps        -0x38(%ebp),%xmm5
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,41,93,232                        // movaps        %xmm3,-0x18(%ebp)
  .byte  15,40,101,232                       // movaps        -0x18(%ebp),%xmm4
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,41,101,232                       // movaps        %xmm4,-0x18(%ebp)
  .byte  15,88,235                           // addps         %xmm3,%xmm5
  .byte  15,41,109,200                       // movaps        %xmm5,-0x38(%ebp)
  .byte  15,40,235                           // movaps        %xmm3,%xmm5
  .byte  15,89,109,152                       // mulps         -0x68(%ebp),%xmm5
  .byte  15,40,221                           // movaps        %xmm5,%xmm3
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,88,242                           // addps         %xmm2,%xmm6
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,40,222                           // movaps        %xmm6,%xmm3
  .byte  15,93,218                           // minps         %xmm2,%xmm3
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,93,227                           // minps         %xmm3,%xmm4
  .byte  15,40,222                           // movaps        %xmm6,%xmm3
  .byte  15,95,218                           // maxps         %xmm2,%xmm3
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  15,95,235                           // maxps         %xmm3,%xmm5
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,40,125,184                       // movaps        -0x48(%ebp),%xmm7
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  15,88,251                           // addps         %xmm3,%xmm7
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  15,194,252,2                        // cmpleps       %xmm4,%xmm7
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  15,92,220                           // subps         %xmm4,%xmm3
  .byte  15,41,93,184                        // movaps        %xmm3,-0x48(%ebp)
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,92,225                           // subps         %xmm1,%xmm4
  .byte  15,89,225                           // mulps         %xmm1,%xmm4
  .byte  15,94,227                           // divps         %xmm3,%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  15,40,223                           // movaps        %xmm7,%xmm3
  .byte  15,85,220                           // andnps        %xmm4,%xmm3
  .byte  15,84,199                           // andps         %xmm7,%xmm0
  .byte  15,86,195                           // orps          %xmm3,%xmm0
  .byte  15,40,93,200                        // movaps        -0x38(%ebp),%xmm3
  .byte  15,40,101,232                       // movaps        -0x18(%ebp),%xmm4
  .byte  15,92,220                           // subps         %xmm4,%xmm3
  .byte  15,41,93,200                        // movaps        %xmm3,-0x38(%ebp)
  .byte  15,41,101,216                       // movaps        %xmm4,-0x28(%ebp)
  .byte  15,194,229,1                        // cmpltps       %xmm5,%xmm4
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,85,216                           // andnps        %xmm0,%xmm3
  .byte  15,41,93,232                        // movaps        %xmm3,-0x18(%ebp)
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  15,92,217                           // subps         %xmm1,%xmm3
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  15,41,109,136                       // movaps        %xmm5,-0x78(%ebp)
  .byte  15,94,197                           // divps         %xmm5,%xmm0
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  15,84,196                           // andps         %xmm4,%xmm0
  .byte  15,86,69,232                        // orps          -0x18(%ebp),%xmm0
  .byte  15,40,222                           // movaps        %xmm6,%xmm3
  .byte  15,92,217                           // subps         %xmm1,%xmm3
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  15,94,93,184                        // divps         -0x48(%ebp),%xmm3
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  15,41,125,232                       // movaps        %xmm7,-0x18(%ebp)
  .byte  15,40,109,232                       // movaps        -0x18(%ebp),%xmm5
  .byte  15,85,235                           // andnps        %xmm3,%xmm5
  .byte  15,41,109,232                       // movaps        %xmm5,-0x18(%ebp)
  .byte  15,84,247                           // andps         %xmm7,%xmm6
  .byte  15,86,117,232                       // orps          -0x18(%ebp),%xmm6
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,85,222                           // andnps        %xmm6,%xmm3
  .byte  15,92,241                           // subps         %xmm1,%xmm6
  .byte  15,89,117,216                       // mulps         -0x28(%ebp),%xmm6
  .byte  15,40,109,136                       // movaps        -0x78(%ebp),%xmm5
  .byte  15,94,245                           // divps         %xmm5,%xmm6
  .byte  15,88,241                           // addps         %xmm1,%xmm6
  .byte  15,84,244                           // andps         %xmm4,%xmm6
  .byte  15,86,243                           // orps          %xmm3,%xmm6
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,92,217                           // subps         %xmm1,%xmm3
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  15,94,93,184                        // divps         -0x48(%ebp),%xmm3
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  15,84,215                           // andps         %xmm7,%xmm2
  .byte  15,85,251                           // andnps        %xmm3,%xmm7
  .byte  15,86,250                           // orps          %xmm2,%xmm7
  .byte  15,40,212                           // movaps        %xmm4,%xmm2
  .byte  15,85,215                           // andnps        %xmm7,%xmm2
  .byte  15,92,249                           // subps         %xmm1,%xmm7
  .byte  15,89,125,216                       // mulps         -0x28(%ebp),%xmm7
  .byte  15,94,253                           // divps         %xmm5,%xmm7
  .byte  15,88,249                           // addps         %xmm1,%xmm7
  .byte  15,84,252                           // andps         %xmm4,%xmm7
  .byte  15,86,250                           // orps          %xmm2,%xmm7
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,95,193                           // maxps         %xmm1,%xmm0
  .byte  15,95,241                           // maxps         %xmm1,%xmm6
  .byte  15,95,249                           // maxps         %xmm1,%xmm7
  .byte  15,40,141,120,255,255,255           // movaps        -0x88(%ebp),%xmm1
  .byte  15,40,85,168                        // movaps        -0x58(%ebp),%xmm2
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,88,141,56,255,255,255            // addps         -0xc8(%ebp),%xmm1
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,40,141,104,255,255,255           // movaps        -0x98(%ebp),%xmm1
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,88,141,88,255,255,255            // addps         -0xa8(%ebp),%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,40,85,152                        // movaps        -0x68(%ebp),%xmm2
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,88,149,72,255,255,255            // addps         -0xb8(%ebp),%xmm2
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,81,4                            // lea           0x4(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,93,200                        // movaps        -0x38(%ebp),%xmm3
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,17                              // call          *(%ecx)
  .byte  129,196,216,0,0,0                   // add           $0xd8,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_luminosity_sse2
.globl _sk_luminosity_sse2
FUNCTION(_sk_luminosity_sse2)
_sk_luminosity_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  129,236,184,0,0,0                   // sub           $0xb8,%esp
  .byte  15,40,242                           // movaps        %xmm2,%xmm6
  .byte  232,0,0,0,0                         // call          1a25 <_sk_luminosity_sse2+0x11>
  .byte  89                                  // pop           %ecx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  15,40,161,139,225,0,0               // movaps        0xe18b(%ecx),%xmm4
  .byte  15,41,101,232                       // movaps        %xmm4,-0x18(%ebp)
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,40,161,155,225,0,0               // movaps        0xe19b(%ecx),%xmm4
  .byte  15,41,101,216                       // movaps        %xmm4,-0x28(%ebp)
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,88,234                           // addps         %xmm2,%xmm5
  .byte  15,40,80,64                         // movaps        0x40(%eax),%xmm2
  .byte  15,41,85,184                        // movaps        %xmm2,-0x48(%ebp)
  .byte  15,40,161,251,224,0,0               // movaps        0xe0fb(%ecx),%xmm4
  .byte  15,40,252                           // movaps        %xmm4,%xmm7
  .byte  15,92,250                           // subps         %xmm2,%xmm7
  .byte  15,89,199                           // mulps         %xmm7,%xmm0
  .byte  15,41,133,72,255,255,255            // movaps        %xmm0,-0xb8(%ebp)
  .byte  15,89,207                           // mulps         %xmm7,%xmm1
  .byte  15,41,141,88,255,255,255            // movaps        %xmm1,-0xa8(%ebp)
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  15,41,189,104,255,255,255           // movaps        %xmm7,-0x98(%ebp)
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,40,137,171,225,0,0               // movaps        0xe1ab(%ecx),%xmm1
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,40,104,16                        // movaps        0x10(%eax),%xmm5
  .byte  15,41,109,136                       // movaps        %xmm5,-0x78(%ebp)
  .byte  15,89,235                           // mulps         %xmm3,%xmm5
  .byte  15,40,112,32                        // movaps        0x20(%eax),%xmm6
  .byte  15,41,117,152                       // movaps        %xmm6,-0x68(%ebp)
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,89,69,232                        // mulps         -0x18(%ebp),%xmm0
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  15,89,125,216                       // mulps         -0x28(%ebp),%xmm7
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  15,41,93,168                        // movaps        %xmm3,-0x58(%ebp)
  .byte  15,40,69,136                        // movaps        -0x78(%ebp),%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,41,69,136                        // movaps        %xmm0,-0x78(%ebp)
  .byte  15,40,69,152                        // movaps        -0x68(%ebp),%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,41,69,152                        // movaps        %xmm0,-0x68(%ebp)
  .byte  15,40,64,48                         // movaps        0x30(%eax),%xmm0
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,41,165,120,255,255,255           // movaps        %xmm4,-0x88(%ebp)
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,40,93,184                        // movaps        -0x48(%ebp),%xmm3
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,92,208                           // subps         %xmm0,%xmm2
  .byte  15,88,234                           // addps         %xmm2,%xmm5
  .byte  15,88,242                           // addps         %xmm2,%xmm6
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,93,194                           // minps         %xmm2,%xmm0
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,93,224                           // minps         %xmm0,%xmm4
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,95,194                           // maxps         %xmm2,%xmm0
  .byte  15,40,253                           // movaps        %xmm5,%xmm7
  .byte  15,95,248                           // maxps         %xmm0,%xmm7
  .byte  15,41,125,200                       // movaps        %xmm7,-0x38(%ebp)
  .byte  15,40,69,232                        // movaps        -0x18(%ebp),%xmm0
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,40,125,216                       // movaps        -0x28(%ebp),%xmm7
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,194,196,2                        // cmpleps       %xmm4,%xmm0
  .byte  15,40,249                           // movaps        %xmm1,%xmm7
  .byte  15,92,252                           // subps         %xmm4,%xmm7
  .byte  15,41,125,216                       // movaps        %xmm7,-0x28(%ebp)
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,92,225                           // subps         %xmm1,%xmm4
  .byte  15,89,225                           // mulps         %xmm1,%xmm4
  .byte  15,94,231                           // divps         %xmm7,%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  15,85,252                           // andnps        %xmm4,%xmm7
  .byte  15,84,232                           // andps         %xmm0,%xmm5
  .byte  15,86,239                           // orps          %xmm7,%xmm5
  .byte  15,40,251                           // movaps        %xmm3,%xmm7
  .byte  15,40,231                           // movaps        %xmm7,%xmm4
  .byte  15,40,93,168                        // movaps        -0x58(%ebp),%xmm3
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  15,92,220                           // subps         %xmm4,%xmm3
  .byte  15,41,93,168                        // movaps        %xmm3,-0x58(%ebp)
  .byte  15,41,101,232                       // movaps        %xmm4,-0x18(%ebp)
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,40,125,200                       // movaps        -0x38(%ebp),%xmm7
  .byte  15,194,223,1                        // cmpltps       %xmm7,%xmm3
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  15,85,229                           // andnps        %xmm5,%xmm4
  .byte  15,41,101,184                       // movaps        %xmm4,-0x48(%ebp)
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  15,40,101,232                       // movaps        -0x18(%ebp),%xmm4
  .byte  15,92,225                           // subps         %xmm1,%xmm4
  .byte  15,41,101,232                       // movaps        %xmm4,-0x18(%ebp)
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,92,249                           // subps         %xmm1,%xmm7
  .byte  15,41,125,200                       // movaps        %xmm7,-0x38(%ebp)
  .byte  15,94,239                           // divps         %xmm7,%xmm5
  .byte  15,88,233                           // addps         %xmm1,%xmm5
  .byte  15,84,235                           // andps         %xmm3,%xmm5
  .byte  15,86,109,184                       // orps          -0x48(%ebp),%xmm5
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  15,92,225                           // subps         %xmm1,%xmm4
  .byte  15,89,225                           // mulps         %xmm1,%xmm4
  .byte  15,94,101,216                       // divps         -0x28(%ebp),%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  15,85,252                           // andnps        %xmm4,%xmm7
  .byte  15,84,240                           // andps         %xmm0,%xmm6
  .byte  15,86,247                           // orps          %xmm7,%xmm6
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  15,85,230                           // andnps        %xmm6,%xmm4
  .byte  15,92,241                           // subps         %xmm1,%xmm6
  .byte  15,40,125,232                       // movaps        -0x18(%ebp),%xmm7
  .byte  15,89,247                           // mulps         %xmm7,%xmm6
  .byte  15,94,117,200                       // divps         -0x38(%ebp),%xmm6
  .byte  15,88,241                           // addps         %xmm1,%xmm6
  .byte  15,84,243                           // andps         %xmm3,%xmm6
  .byte  15,86,244                           // orps          %xmm4,%xmm6
  .byte  15,40,226                           // movaps        %xmm2,%xmm4
  .byte  15,92,225                           // subps         %xmm1,%xmm4
  .byte  15,89,225                           // mulps         %xmm1,%xmm4
  .byte  15,94,101,216                       // divps         -0x28(%ebp),%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  15,84,208                           // andps         %xmm0,%xmm2
  .byte  15,85,196                           // andnps        %xmm4,%xmm0
  .byte  15,86,194                           // orps          %xmm2,%xmm0
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,85,208                           // andnps        %xmm0,%xmm2
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,89,199                           // mulps         %xmm7,%xmm0
  .byte  15,94,69,200                        // divps         -0x38(%ebp),%xmm0
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  15,84,195                           // andps         %xmm3,%xmm0
  .byte  15,86,194                           // orps          %xmm2,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,95,233                           // maxps         %xmm1,%xmm5
  .byte  15,95,241                           // maxps         %xmm1,%xmm6
  .byte  15,95,193                           // maxps         %xmm1,%xmm0
  .byte  15,40,157,72,255,255,255            // movaps        -0xb8(%ebp),%xmm3
  .byte  15,88,93,136                        // addps         -0x78(%ebp),%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  15,40,141,88,255,255,255            // movaps        -0xa8(%ebp),%xmm1
  .byte  15,88,77,152                        // addps         -0x68(%ebp),%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,40,149,120,255,255,255           // movaps        -0x88(%ebp),%xmm2
  .byte  15,88,149,104,255,255,255           // addps         -0x98(%ebp),%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,81,4                            // lea           0x4(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,40,93,168                        // movaps        -0x58(%ebp),%xmm3
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,17                              // call          *(%ecx)
  .byte  129,196,200,0,0,0                   // add           $0xc8,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_srcover_rgba_8888_sse2
.globl _sk_srcover_rgba_8888_sse2
FUNCTION(_sk_srcover_rgba_8888_sse2)
_sk_srcover_rgba_8888_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,44                          // sub           $0x2c,%esp
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  102,15,127,77,216                   // movdqa        %xmm1,-0x28(%ebp)
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  232,0,0,0,0                         // call          1c94 <_sk_srcover_rgba_8888_sse2+0x1b>
  .byte  95                                  // pop           %edi
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,48                              // mov           (%eax),%esi
  .byte  139,86,4                            // mov           0x4(%esi),%edx
  .byte  15,175,81,4                         // imul          0x4(%ecx),%edx
  .byte  193,226,2                           // shl           $0x2,%edx
  .byte  3,22                                // add           (%esi),%edx
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,49                              // mov           (%ecx),%esi
  .byte  15,133,2,1,0,0                      // jne           1db8 <_sk_srcover_rgba_8888_sse2+0x13f>
  .byte  243,15,111,12,178                   // movdqu        (%edx,%esi,4),%xmm1
  .byte  102,15,111,135,76,223,0,0           // movdqa        0xdf4c(%edi),%xmm0
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,15,219,208                      // pand          %xmm0,%xmm2
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,114,214,8                    // psrld         $0x8,%xmm6
  .byte  102,15,219,240                      // pand          %xmm0,%xmm6
  .byte  102,15,111,249                      // movdqa        %xmm1,%xmm7
  .byte  102,15,114,215,16                   // psrld         $0x10,%xmm7
  .byte  102,15,219,248                      // pand          %xmm0,%xmm7
  .byte  15,91,194                           // cvtdq2ps      %xmm2,%xmm0
  .byte  15,41,65,16                         // movaps        %xmm0,0x10(%ecx)
  .byte  15,40,167,140,222,0,0               // movaps        0xde8c(%edi),%xmm4
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  15,40,151,92,223,0,0                // movaps        0xdf5c(%edi),%xmm2
  .byte  15,89,234                           // mulps         %xmm2,%xmm5
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,91,238                           // cvtdq2ps      %xmm6,%xmm5
  .byte  15,41,105,32                        // movaps        %xmm5,0x20(%ecx)
  .byte  15,40,117,216                       // movaps        -0x28(%ebp),%xmm6
  .byte  15,89,242                           // mulps         %xmm2,%xmm6
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,88,238                           // addps         %xmm6,%xmm5
  .byte  15,91,247                           // cvtdq2ps      %xmm7,%xmm6
  .byte  15,41,113,48                        // movaps        %xmm6,0x30(%ecx)
  .byte  15,40,125,200                       // movaps        -0x38(%ebp),%xmm7
  .byte  15,89,250                           // mulps         %xmm2,%xmm7
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  102,15,114,209,24                   // psrld         $0x18,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,41,73,64                         // movaps        %xmm1,0x40(%ecx)
  .byte  15,89,218                           // mulps         %xmm2,%xmm3
  .byte  15,89,225                           // mulps         %xmm1,%xmm4
  .byte  15,88,227                           // addps         %xmm3,%xmm4
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,95,200                           // maxps         %xmm0,%xmm1
  .byte  15,93,202                           // minps         %xmm2,%xmm1
  .byte  102,15,91,201                       // cvtps2dq      %xmm1,%xmm1
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,95,221                           // maxps         %xmm5,%xmm3
  .byte  15,93,218                           // minps         %xmm2,%xmm3
  .byte  102,15,91,219                       // cvtps2dq      %xmm3,%xmm3
  .byte  102,15,114,243,8                    // pslld         $0x8,%xmm3
  .byte  102,15,235,217                      // por           %xmm1,%xmm3
  .byte  102,15,87,201                       // xorpd         %xmm1,%xmm1
  .byte  15,95,206                           // maxps         %xmm6,%xmm1
  .byte  15,93,202                           // minps         %xmm2,%xmm1
  .byte  15,95,252                           // maxps         %xmm4,%xmm7
  .byte  15,93,250                           // minps         %xmm2,%xmm7
  .byte  102,15,91,209                       // cvtps2dq      %xmm1,%xmm2
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,91,207                       // cvtps2dq      %xmm7,%xmm1
  .byte  102,15,114,241,24                   // pslld         $0x18,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  102,15,235,203                      // por           %xmm3,%xmm1
  .byte  133,219                             // test          %ebx,%ebx
  .byte  117,92                              // jne           1df3 <_sk_srcover_rgba_8888_sse2+0x17a>
  .byte  243,15,127,12,178                   // movdqu        %xmm1,(%edx,%esi,4)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,60                          // add           $0x3c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  137,216                             // mov           %ebx,%eax
  .byte  136,69,243                          // mov           %al,-0xd(%ebp)
  .byte  128,101,243,3                       // andb          $0x3,-0xd(%ebp)
  .byte  128,125,243,1                       // cmpb          $0x1,-0xd(%ebp)
  .byte  116,80                              // je            1e17 <_sk_srcover_rgba_8888_sse2+0x19e>
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  128,125,243,2                       // cmpb          $0x2,-0xd(%ebp)
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  116,21                              // je            1de9 <_sk_srcover_rgba_8888_sse2+0x170>
  .byte  128,125,243,3                       // cmpb          $0x3,-0xd(%ebp)
  .byte  15,133,221,254,255,255              // jne           1cbb <_sk_srcover_rgba_8888_sse2+0x42>
  .byte  102,15,110,68,178,8                 // movd          0x8(%edx,%esi,4),%xmm0
  .byte  102,15,112,200,69                   // pshufd        $0x45,%xmm0,%xmm1
  .byte  102,15,18,12,178                    // movlpd        (%edx,%esi,4),%xmm1
  .byte  233,200,254,255,255                 // jmp           1cbb <_sk_srcover_rgba_8888_sse2+0x42>
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,41                              // je            1e24 <_sk_srcover_rgba_8888_sse2+0x1ab>
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,16                              // je            1e10 <_sk_srcover_rgba_8888_sse2+0x197>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,151                             // jne           1d9c <_sk_srcover_rgba_8888_sse2+0x123>
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,15,126,84,178,8                 // movd          %xmm2,0x8(%edx,%esi,4)
  .byte  102,15,214,12,178                   // movq          %xmm1,(%edx,%esi,4)
  .byte  235,133                             // jmp           1d9c <_sk_srcover_rgba_8888_sse2+0x123>
  .byte  102,15,110,12,178                   // movd          (%edx,%esi,4),%xmm1
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  233,151,254,255,255                 // jmp           1cbb <_sk_srcover_rgba_8888_sse2+0x42>
  .byte  102,15,126,12,178                   // movd          %xmm1,(%edx,%esi,4)
  .byte  233,110,255,255,255                 // jmp           1d9c <_sk_srcover_rgba_8888_sse2+0x123>

HIDDEN _sk_srcover_bgra_8888_sse2
.globl _sk_srcover_bgra_8888_sse2
FUNCTION(_sk_srcover_bgra_8888_sse2)
_sk_srcover_bgra_8888_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,44                          // sub           $0x2c,%esp
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  15,41,77,216                        // movaps        %xmm1,-0x28(%ebp)
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  232,0,0,0,0                         // call          1e48 <_sk_srcover_bgra_8888_sse2+0x1a>
  .byte  95                                  // pop           %edi
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,48                              // mov           (%eax),%esi
  .byte  139,86,4                            // mov           0x4(%esi),%edx
  .byte  15,175,81,4                         // imul          0x4(%ecx),%edx
  .byte  193,226,2                           // shl           $0x2,%edx
  .byte  3,22                                // add           (%esi),%edx
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,49                              // mov           (%ecx),%esi
  .byte  15,133,252,0,0,0                    // jne           1f66 <_sk_srcover_bgra_8888_sse2+0x138>
  .byte  243,15,111,36,178                   // movdqu        (%edx,%esi,4),%xmm4
  .byte  102,15,111,135,152,221,0,0          // movdqa        0xdd98(%edi),%xmm0
  .byte  102,15,111,204                      // movdqa        %xmm4,%xmm1
  .byte  102,15,219,200                      // pand          %xmm0,%xmm1
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,114,213,8                    // psrld         $0x8,%xmm5
  .byte  102,15,219,232                      // pand          %xmm0,%xmm5
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,114,214,16                   // psrld         $0x10,%xmm6
  .byte  102,15,219,240                      // pand          %xmm0,%xmm6
  .byte  15,91,209                           // cvtdq2ps      %xmm1,%xmm2
  .byte  15,41,81,48                         // movaps        %xmm2,0x30(%ecx)
  .byte  15,91,205                           // cvtdq2ps      %xmm5,%xmm1
  .byte  15,41,73,32                         // movaps        %xmm1,0x20(%ecx)
  .byte  15,91,198                           // cvtdq2ps      %xmm6,%xmm0
  .byte  15,41,65,16                         // movaps        %xmm0,0x10(%ecx)
  .byte  15,40,175,216,220,0,0               // movaps        0xdcd8(%edi),%xmm5
  .byte  15,92,235                           // subps         %xmm3,%xmm5
  .byte  15,40,183,168,221,0,0               // movaps        0xdda8(%edi),%xmm6
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,40,125,216                       // movaps        -0x28(%ebp),%xmm7
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  15,40,125,200                       // movaps        -0x38(%ebp),%xmm7
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  102,15,114,212,24                   // psrld         $0x18,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,41,97,64                         // movaps        %xmm4,0x40(%ecx)
  .byte  15,89,222                           // mulps         %xmm6,%xmm3
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,88,235                           // addps         %xmm3,%xmm5
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,95,218                           // maxps         %xmm2,%xmm3
  .byte  15,93,222                           // minps         %xmm6,%xmm3
  .byte  102,15,91,219                       // cvtps2dq      %xmm3,%xmm3
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,225                           // maxps         %xmm1,%xmm4
  .byte  15,93,230                           // minps         %xmm6,%xmm4
  .byte  102,15,91,228                       // cvtps2dq      %xmm4,%xmm4
  .byte  102,15,114,244,8                    // pslld         $0x8,%xmm4
  .byte  102,15,235,227                      // por           %xmm3,%xmm4
  .byte  102,15,87,219                       // xorpd         %xmm3,%xmm3
  .byte  15,95,216                           // maxps         %xmm0,%xmm3
  .byte  15,93,222                           // minps         %xmm6,%xmm3
  .byte  15,95,253                           // maxps         %xmm5,%xmm7
  .byte  15,93,254                           // minps         %xmm6,%xmm7
  .byte  102,15,91,243                       // cvtps2dq      %xmm3,%xmm6
  .byte  102,15,114,246,16                   // pslld         $0x10,%xmm6
  .byte  102,15,91,223                       // cvtps2dq      %xmm7,%xmm3
  .byte  102,15,114,243,24                   // pslld         $0x18,%xmm3
  .byte  102,15,235,222                      // por           %xmm6,%xmm3
  .byte  102,15,235,220                      // por           %xmm4,%xmm3
  .byte  133,219                             // test          %ebx,%ebx
  .byte  117,86                              // jne           1fa1 <_sk_srcover_bgra_8888_sse2+0x173>
  .byte  243,15,127,28,178                   // movdqu        %xmm3,(%edx,%esi,4)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,221                           // movaps        %xmm5,%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,60                          // add           $0x3c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  137,216                             // mov           %ebx,%eax
  .byte  136,69,243                          // mov           %al,-0xd(%ebp)
  .byte  128,101,243,3                       // andb          $0x3,-0xd(%ebp)
  .byte  128,125,243,1                       // cmpb          $0x1,-0xd(%ebp)
  .byte  116,80                              // je            1fc5 <_sk_srcover_bgra_8888_sse2+0x197>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  128,125,243,2                       // cmpb          $0x2,-0xd(%ebp)
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  116,21                              // je            1f97 <_sk_srcover_bgra_8888_sse2+0x169>
  .byte  128,125,243,3                       // cmpb          $0x3,-0xd(%ebp)
  .byte  15,133,227,254,255,255              // jne           1e6f <_sk_srcover_bgra_8888_sse2+0x41>
  .byte  102,15,110,68,178,8                 // movd          0x8(%edx,%esi,4),%xmm0
  .byte  102,15,112,224,69                   // pshufd        $0x45,%xmm0,%xmm4
  .byte  102,15,18,36,178                    // movlpd        (%edx,%esi,4),%xmm4
  .byte  233,206,254,255,255                 // jmp           1e6f <_sk_srcover_bgra_8888_sse2+0x41>
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,41                              // je            1fd2 <_sk_srcover_bgra_8888_sse2+0x1a4>
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,16                              // je            1fbe <_sk_srcover_bgra_8888_sse2+0x190>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,157                             // jne           1f50 <_sk_srcover_bgra_8888_sse2+0x122>
  .byte  102,15,112,227,78                   // pshufd        $0x4e,%xmm3,%xmm4
  .byte  102,15,126,100,178,8                // movd          %xmm4,0x8(%edx,%esi,4)
  .byte  102,15,214,28,178                   // movq          %xmm3,(%edx,%esi,4)
  .byte  235,139                             // jmp           1f50 <_sk_srcover_bgra_8888_sse2+0x122>
  .byte  102,15,110,36,178                   // movd          (%edx,%esi,4),%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  233,157,254,255,255                 // jmp           1e6f <_sk_srcover_bgra_8888_sse2+0x41>
  .byte  102,15,126,28,178                   // movd          %xmm3,(%edx,%esi,4)
  .byte  233,116,255,255,255                 // jmp           1f50 <_sk_srcover_bgra_8888_sse2+0x122>

HIDDEN _sk_clamp_0_sse2
.globl _sk_clamp_0_sse2
FUNCTION(_sk_clamp_0_sse2)
_sk_clamp_0_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,196                           // maxps         %xmm4,%xmm0
  .byte  15,95,204                           // maxps         %xmm4,%xmm1
  .byte  15,95,212                           // maxps         %xmm4,%xmm2
  .byte  15,95,220                           // maxps         %xmm4,%xmm3
  .byte  141,72,4                            // lea           0x4(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_clamp_1_sse2
.globl _sk_clamp_1_sse2
FUNCTION(_sk_clamp_1_sse2)
_sk_clamp_1_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          2010 <_sk_clamp_1_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  15,40,160,16,219,0,0                // movaps        0xdb10(%eax),%xmm4
  .byte  15,93,196                           // minps         %xmm4,%xmm0
  .byte  15,93,204                           // minps         %xmm4,%xmm1
  .byte  15,93,212                           // minps         %xmm4,%xmm2
  .byte  15,93,220                           // minps         %xmm4,%xmm3
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_clamp_a_sse2
.globl _sk_clamp_a_sse2
FUNCTION(_sk_clamp_a_sse2)
_sk_clamp_a_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          2043 <_sk_clamp_a_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  15,93,152,221,218,0,0               // minps         0xdadd(%eax),%xmm3
  .byte  15,93,195                           // minps         %xmm3,%xmm0
  .byte  15,93,203                           // minps         %xmm3,%xmm1
  .byte  15,93,211                           // minps         %xmm3,%xmm2
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_clamp_a_dst_sse2
.globl _sk_clamp_a_dst_sse2
FUNCTION(_sk_clamp_a_dst_sse2)
_sk_clamp_a_dst_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          2073 <_sk_clamp_a_dst_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  15,40,98,64                         // movaps        0x40(%edx),%xmm4
  .byte  15,93,160,173,218,0,0               // minps         0xdaad(%eax),%xmm4
  .byte  15,41,98,64                         // movaps        %xmm4,0x40(%edx)
  .byte  15,40,106,16                        // movaps        0x10(%edx),%xmm5
  .byte  15,40,114,32                        // movaps        0x20(%edx),%xmm6
  .byte  15,93,236                           // minps         %xmm4,%xmm5
  .byte  15,41,106,16                        // movaps        %xmm5,0x10(%edx)
  .byte  15,93,244                           // minps         %xmm4,%xmm6
  .byte  15,41,114,32                        // movaps        %xmm6,0x20(%edx)
  .byte  15,40,106,48                        // movaps        0x30(%edx),%xmm5
  .byte  15,93,236                           // minps         %xmm4,%xmm5
  .byte  15,41,106,48                        // movaps        %xmm5,0x30(%edx)
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  82                                  // push          %edx
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_set_rgb_sse2
.globl _sk_set_rgb_sse2
FUNCTION(_sk_set_rgb_sse2)
_sk_set_rgb_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,1                         // movss         (%ecx),%xmm0
  .byte  243,15,16,73,4                      // movss         0x4(%ecx),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,81,8                      // movss         0x8(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_swap_rb_sse2
.globl _sk_swap_rb_sse2
FUNCTION(_sk_swap_rb_sse2)
_sk_swap_rb_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  141,72,4                            // lea           0x4(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,40,212                           // movaps        %xmm4,%xmm2
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_invert_sse2
.globl _sk_invert_sse2
FUNCTION(_sk_invert_sse2)
_sk_invert_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          211e <_sk_invert_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  15,40,160,2,218,0,0                 // movaps        0xda02(%eax),%xmm4
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,92,232                           // subps         %xmm0,%xmm5
  .byte  15,40,244                           // movaps        %xmm4,%xmm6
  .byte  15,92,241                           // subps         %xmm1,%xmm6
  .byte  15,40,252                           // movaps        %xmm4,%xmm7
  .byte  15,92,250                           // subps         %xmm2,%xmm7
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,40,215                           // movaps        %xmm7,%xmm2
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_move_src_dst_sse2
.globl _sk_move_src_dst_sse2
FUNCTION(_sk_move_src_dst_sse2)
_sk_move_src_dst_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,41,65,16                         // movaps        %xmm0,0x10(%ecx)
  .byte  15,41,73,32                         // movaps        %xmm1,0x20(%ecx)
  .byte  15,41,81,48                         // movaps        %xmm2,0x30(%ecx)
  .byte  15,41,89,64                         // movaps        %xmm3,0x40(%ecx)
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_move_dst_src_sse2
.globl _sk_move_dst_src_sse2
FUNCTION(_sk_move_dst_src_sse2)
_sk_move_dst_src_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,40,65,16                         // movaps        0x10(%ecx),%xmm0
  .byte  15,40,73,32                         // movaps        0x20(%ecx),%xmm1
  .byte  15,40,81,48                         // movaps        0x30(%ecx),%xmm2
  .byte  15,40,89,64                         // movaps        0x40(%ecx),%xmm3
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_premul_sse2
.globl _sk_premul_sse2
FUNCTION(_sk_premul_sse2)
_sk_premul_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  141,72,4                            // lea           0x4(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_premul_dst_sse2
.globl _sk_premul_dst_sse2
FUNCTION(_sk_premul_dst_sse2)
_sk_premul_dst_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  15,40,97,64                         // movaps        0x40(%ecx),%xmm4
  .byte  15,40,105,16                        // movaps        0x10(%ecx),%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,41,105,16                        // movaps        %xmm5,0x10(%ecx)
  .byte  15,40,105,32                        // movaps        0x20(%ecx),%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,41,105,32                        // movaps        %xmm5,0x20(%ecx)
  .byte  15,89,97,48                         // mulps         0x30(%ecx),%xmm4
  .byte  15,41,97,48                         // movaps        %xmm4,0x30(%ecx)
  .byte  141,80,4                            // lea           0x4(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_unpremul_sse2
.globl _sk_unpremul_sse2
FUNCTION(_sk_unpremul_sse2)
_sk_unpremul_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          221c <_sk_unpremul_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  15,40,160,4,217,0,0                 // movaps        0xd904(%eax),%xmm4
  .byte  15,94,227                           // divps         %xmm3,%xmm4
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,194,168,228,217,0,0,1            // cmpltps       0xd9e4(%eax),%xmm5
  .byte  15,84,236                           // andps         %xmm4,%xmm5
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_from_srgb_sse2
.globl _sk_from_srgb_sse2
FUNCTION(_sk_from_srgb_sse2)
_sk_from_srgb_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,56                          // sub           $0x38,%esp
  .byte  15,41,93,200                        // movaps        %xmm3,-0x38(%ebp)
  .byte  15,40,234                           // movaps        %xmm2,%xmm5
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  232,0,0,0,0                         // call          226a <_sk_from_srgb_sse2+0x18>
  .byte  88                                  // pop           %eax
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,89,201                           // mulps         %xmm1,%xmm1
  .byte  15,40,160,70,217,0,0                // movaps        0xd946(%eax),%xmm4
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,40,176,182,217,0,0               // movaps        0xd9b6(%eax),%xmm6
  .byte  15,41,117,216                       // movaps        %xmm6,-0x28(%ebp)
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,40,176,166,217,0,0               // movaps        0xd9a6(%eax),%xmm6
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,40,184,198,217,0,0               // movaps        0xd9c6(%eax),%xmm7
  .byte  15,41,125,232                       // movaps        %xmm7,-0x18(%ebp)
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,40,184,214,217,0,0               // movaps        0xd9d6(%eax),%xmm7
  .byte  15,194,215,1                        // cmpltps       %xmm7,%xmm2
  .byte  15,84,202                           // andps         %xmm2,%xmm1
  .byte  15,85,208                           // andnps        %xmm0,%xmm2
  .byte  15,86,209                           // orps          %xmm1,%xmm2
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,77,216                        // addps         -0x28(%ebp),%xmm1
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,88,77,232                        // addps         -0x18(%ebp),%xmm1
  .byte  15,194,223,1                        // cmpltps       %xmm7,%xmm3
  .byte  15,84,195                           // andps         %xmm3,%xmm0
  .byte  15,85,217                           // andnps        %xmm1,%xmm3
  .byte  15,86,216                           // orps          %xmm0,%xmm3
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,88,101,216                       // addps         -0x28(%ebp),%xmm4
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,88,101,232                       // addps         -0x18(%ebp),%xmm4
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,194,239,1                        // cmpltps       %xmm7,%xmm5
  .byte  15,84,245                           // andps         %xmm5,%xmm6
  .byte  15,85,236                           // andnps        %xmm4,%xmm5
  .byte  15,86,238                           // orps          %xmm6,%xmm5
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  141,72,4                            // lea           0x4(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,40,213                           // movaps        %xmm5,%xmm2
  .byte  15,40,93,200                        // movaps        -0x38(%ebp),%xmm3
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,72                          // add           $0x48,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_from_srgb_dst_sse2
.globl _sk_from_srgb_dst_sse2
FUNCTION(_sk_from_srgb_dst_sse2)
_sk_from_srgb_dst_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,72                          // sub           $0x48,%esp
  .byte  15,41,93,184                        // movaps        %xmm3,-0x48(%ebp)
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  15,41,77,216                        // movaps        %xmm1,-0x28(%ebp)
  .byte  15,41,69,232                        // movaps        %xmm0,-0x18(%ebp)
  .byte  232,0,0,0,0                         // call          2345 <_sk_from_srgb_dst_sse2+0x1b>
  .byte  89                                  // pop           %ecx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  15,40,72,16                         // movaps        0x10(%eax),%xmm1
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,89,237                           // mulps         %xmm5,%xmm5
  .byte  15,40,161,107,216,0,0               // movaps        0xd86b(%ecx),%xmm4
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,40,177,219,216,0,0               // movaps        0xd8db(%ecx),%xmm6
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,40,169,203,216,0,0               // movaps        0xd8cb(%ecx),%xmm5
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,40,185,235,216,0,0               // movaps        0xd8eb(%ecx),%xmm7
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,40,153,251,216,0,0               // movaps        0xd8fb(%ecx),%xmm3
  .byte  15,194,203,1                        // cmpltps       %xmm3,%xmm1
  .byte  15,84,209                           // andps         %xmm1,%xmm2
  .byte  15,85,200                           // andnps        %xmm0,%xmm1
  .byte  15,86,202                           // orps          %xmm2,%xmm1
  .byte  15,40,64,32                         // movaps        0x20(%eax),%xmm0
  .byte  15,41,72,16                         // movaps        %xmm1,0x10(%eax)
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,89,201                           // mulps         %xmm1,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  15,194,195,1                        // cmpltps       %xmm3,%xmm0
  .byte  15,84,200                           // andps         %xmm0,%xmm1
  .byte  15,85,194                           // andnps        %xmm2,%xmm0
  .byte  15,86,193                           // orps          %xmm1,%xmm0
  .byte  15,41,64,32                         // movaps        %xmm0,0x20(%eax)
  .byte  15,40,64,48                         // movaps        0x30(%eax),%xmm0
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,88,230                           // addps         %xmm6,%xmm4
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,89,201                           // mulps         %xmm1,%xmm1
  .byte  15,89,225                           // mulps         %xmm1,%xmm4
  .byte  15,88,231                           // addps         %xmm7,%xmm4
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  15,194,195,1                        // cmpltps       %xmm3,%xmm0
  .byte  15,84,232                           // andps         %xmm0,%xmm5
  .byte  15,85,196                           // andnps        %xmm4,%xmm0
  .byte  15,86,197                           // orps          %xmm5,%xmm0
  .byte  15,41,64,48                         // movaps        %xmm0,0x30(%eax)
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,81,4                            // lea           0x4(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,69,232                        // movaps        -0x18(%ebp),%xmm0
  .byte  15,40,77,216                        // movaps        -0x28(%ebp),%xmm1
  .byte  15,40,85,200                        // movaps        -0x38(%ebp),%xmm2
  .byte  15,40,93,184                        // movaps        -0x48(%ebp),%xmm3
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,88                          // add           $0x58,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_to_srgb_sse2
.globl _sk_to_srgb_sse2
FUNCTION(_sk_to_srgb_sse2)
_sk_to_srgb_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,72                          // sub           $0x48,%esp
  .byte  15,41,93,184                        // movaps        %xmm3,-0x48(%ebp)
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,40,241                           // movaps        %xmm1,%xmm6
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  232,0,0,0,0                         // call          2430 <_sk_to_srgb_sse2+0x18>
  .byte  88                                  // pop           %eax
  .byte  15,82,218                           // rsqrtps       %xmm2,%xmm3
  .byte  15,40,160,48,216,0,0                // movaps        0xd830(%eax),%xmm4
  .byte  15,40,235                           // movaps        %xmm3,%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,40,128,64,216,0,0                // movaps        0xd840(%eax),%xmm0
  .byte  15,41,69,232                        // movaps        %xmm0,-0x18(%ebp)
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  15,89,235                           // mulps         %xmm3,%xmm5
  .byte  15,40,128,80,216,0,0                // movaps        0xd850(%eax),%xmm0
  .byte  15,41,69,200                        // movaps        %xmm0,-0x38(%ebp)
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  15,40,128,96,216,0,0                // movaps        0xd860(%eax),%xmm0
  .byte  15,41,69,216                        // movaps        %xmm0,-0x28(%ebp)
  .byte  15,88,216                           // addps         %xmm0,%xmm3
  .byte  15,83,195                           // rcpps         %xmm3,%xmm0
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,40,168,32,216,0,0                // movaps        0xd820(%eax),%xmm5
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,40,152,112,216,0,0               // movaps        0xd870(%eax),%xmm3
  .byte  15,194,211,1                        // cmpltps       %xmm3,%xmm2
  .byte  15,84,202                           // andps         %xmm2,%xmm1
  .byte  15,85,208                           // andnps        %xmm0,%xmm2
  .byte  15,86,209                           // orps          %xmm1,%xmm2
  .byte  15,82,198                           // rsqrtps       %xmm6,%xmm0
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,77,232                        // addps         -0x18(%ebp),%xmm1
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,88,77,200                        // addps         -0x38(%ebp),%xmm1
  .byte  15,88,69,216                        // addps         -0x28(%ebp),%xmm0
  .byte  15,83,192                           // rcpps         %xmm0,%xmm0
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,194,243,1                        // cmpltps       %xmm3,%xmm6
  .byte  15,84,206                           // andps         %xmm6,%xmm1
  .byte  15,85,240                           // andnps        %xmm0,%xmm6
  .byte  15,86,241                           // orps          %xmm1,%xmm6
  .byte  15,82,199                           // rsqrtps       %xmm7,%xmm0
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,88,101,232                       // addps         -0x18(%ebp),%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,88,101,200                       // addps         -0x38(%ebp),%xmm4
  .byte  15,88,69,216                        // addps         -0x28(%ebp),%xmm0
  .byte  15,83,192                           // rcpps         %xmm0,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,89,239                           // mulps         %xmm7,%xmm5
  .byte  15,194,251,1                        // cmpltps       %xmm3,%xmm7
  .byte  15,84,239                           // andps         %xmm7,%xmm5
  .byte  15,85,248                           // andnps        %xmm0,%xmm7
  .byte  15,86,253                           // orps          %xmm5,%xmm7
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  141,72,4                            // lea           0x4(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,40,215                           // movaps        %xmm7,%xmm2
  .byte  15,40,93,184                        // movaps        -0x48(%ebp),%xmm3
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,88                          // add           $0x58,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_rgb_to_hsl_sse2
.globl _sk_rgb_to_hsl_sse2
FUNCTION(_sk_rgb_to_hsl_sse2)
_sk_rgb_to_hsl_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,56                          // sub           $0x38,%esp
  .byte  15,41,93,200                        // movaps        %xmm3,-0x38(%ebp)
  .byte  15,40,249                           // movaps        %xmm1,%xmm7
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  232,0,0,0,0                         // call          2527 <_sk_rgb_to_hsl_sse2+0x15>
  .byte  88                                  // pop           %eax
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  15,95,194                           // maxps         %xmm2,%xmm0
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,95,216                           // maxps         %xmm0,%xmm3
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  15,93,194                           // minps         %xmm2,%xmm0
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  15,93,200                           // minps         %xmm0,%xmm1
  .byte  15,41,77,232                        // movaps        %xmm1,-0x18(%ebp)
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,41,69,216                        // movaps        %xmm0,-0x28(%ebp)
  .byte  15,40,136,249,213,0,0               // movaps        0xd5f9(%eax),%xmm1
  .byte  15,94,200                           // divps         %xmm0,%xmm1
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  15,92,194                           // subps         %xmm2,%xmm0
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,40,239                           // movaps        %xmm7,%xmm5
  .byte  15,194,234,1                        // cmpltps       %xmm2,%xmm5
  .byte  15,84,168,137,215,0,0               // andps         0xd789(%eax),%xmm5
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,194,196,0                        // cmpeqps       %xmm4,%xmm0
  .byte  15,40,243                           // movaps        %xmm3,%xmm6
  .byte  15,194,247,0                        // cmpeqps       %xmm7,%xmm6
  .byte  15,92,212                           // subps         %xmm4,%xmm2
  .byte  15,92,231                           // subps         %xmm7,%xmm4
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  15,89,225                           // mulps         %xmm1,%xmm4
  .byte  15,40,136,153,215,0,0               // movaps        0xd799(%eax),%xmm1
  .byte  15,88,209                           // addps         %xmm1,%xmm2
  .byte  15,88,160,169,215,0,0               // addps         0xd7a9(%eax),%xmm4
  .byte  15,84,214                           // andps         %xmm6,%xmm2
  .byte  15,85,244                           // andnps        %xmm4,%xmm6
  .byte  15,86,242                           // orps          %xmm2,%xmm6
  .byte  15,84,232                           // andps         %xmm0,%xmm5
  .byte  15,85,198                           // andnps        %xmm6,%xmm0
  .byte  15,86,197                           // orps          %xmm5,%xmm0
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  15,40,85,232                        // movaps        -0x18(%ebp),%xmm2
  .byte  15,194,226,4                        // cmpneqps      %xmm2,%xmm4
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  15,40,168,233,213,0,0               // movaps        0xd5e9(%eax),%xmm5
  .byte  15,92,202                           // subps         %xmm2,%xmm1
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,194,234,1                        // cmpltps       %xmm2,%xmm5
  .byte  15,84,205                           // andps         %xmm5,%xmm1
  .byte  15,85,235                           // andnps        %xmm3,%xmm5
  .byte  15,86,233                           // orps          %xmm1,%xmm5
  .byte  15,40,77,216                        // movaps        -0x28(%ebp),%xmm1
  .byte  15,94,205                           // divps         %xmm5,%xmm1
  .byte  15,89,128,185,215,0,0               // mulps         0xd7b9(%eax),%xmm0
  .byte  15,84,196                           // andps         %xmm4,%xmm0
  .byte  15,84,204                           // andps         %xmm4,%xmm1
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  141,72,4                            // lea           0x4(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,93,200                        // movaps        -0x38(%ebp),%xmm3
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,72                          // add           $0x48,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_hsl_to_rgb_sse2
.globl _sk_hsl_to_rgb_sse2
FUNCTION(_sk_hsl_to_rgb_sse2)
_sk_hsl_to_rgb_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  129,236,200,0,0,0                   // sub           $0xc8,%esp
  .byte  15,41,157,56,255,255,255            // movaps        %xmm3,-0xc8(%ebp)
  .byte  15,41,69,184                        // movaps        %xmm0,-0x48(%ebp)
  .byte  232,0,0,0,0                         // call          2622 <_sk_hsl_to_rgb_sse2+0x19>
  .byte  88                                  // pop           %eax
  .byte  15,40,160,238,212,0,0               // movaps        0xd4ee(%eax),%xmm4
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,41,165,104,255,255,255           // movaps        %xmm4,-0x98(%ebp)
  .byte  15,194,218,2                        // cmpleps       %xmm2,%xmm3
  .byte  15,40,241                           // movaps        %xmm1,%xmm6
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,194,233,0                        // cmpeqps       %xmm1,%xmm5
  .byte  15,41,109,232                       // movaps        %xmm5,-0x18(%ebp)
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,92,241                           // subps         %xmm1,%xmm6
  .byte  15,84,243                           // andps         %xmm3,%xmm6
  .byte  15,85,217                           // andnps        %xmm1,%xmm3
  .byte  15,86,222                           // orps          %xmm6,%xmm3
  .byte  15,40,168,206,214,0,0               // movaps        0xd6ce(%eax),%xmm5
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  243,15,91,205                       // cvttps2dq     %xmm5,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,194,193,1                        // cmpltps       %xmm1,%xmm0
  .byte  15,40,176,254,212,0,0               // movaps        0xd4fe(%eax),%xmm6
  .byte  15,41,117,136                       // movaps        %xmm6,-0x78(%ebp)
  .byte  15,84,198                           // andps         %xmm6,%xmm0
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  15,41,149,72,255,255,255            // movaps        %xmm2,-0xb8(%ebp)
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  15,88,210                           // addps         %xmm2,%xmm2
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,40,184,222,214,0,0               // movaps        0xd6de(%eax),%xmm7
  .byte  15,41,189,88,255,255,255            // movaps        %xmm7,-0xa8(%ebp)
  .byte  15,194,253,2                        // cmpleps       %xmm5,%xmm7
  .byte  15,92,218                           // subps         %xmm2,%xmm3
  .byte  15,41,93,200                        // movaps        %xmm3,-0x38(%ebp)
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  15,194,205,2                        // cmpleps       %xmm5,%xmm1
  .byte  15,40,160,190,214,0,0               // movaps        0xd6be(%eax),%xmm4
  .byte  15,41,165,120,255,255,255           // movaps        %xmm4,-0x88(%ebp)
  .byte  15,194,229,2                        // cmpleps       %xmm5,%xmm4
  .byte  15,40,176,142,214,0,0               // movaps        0xd68e(%eax),%xmm6
  .byte  15,89,238                           // mulps         %xmm6,%xmm5
  .byte  15,40,128,174,214,0,0               // movaps        0xd6ae(%eax),%xmm0
  .byte  15,41,69,168                        // movaps        %xmm0,-0x58(%ebp)
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,84,223                           // andps         %xmm7,%xmm3
  .byte  15,85,248                           // andnps        %xmm0,%xmm7
  .byte  15,86,251                           // orps          %xmm3,%xmm7
  .byte  15,84,249                           // andps         %xmm1,%xmm7
  .byte  15,85,77,216                        // andnps        -0x28(%ebp),%xmm1
  .byte  15,86,207                           // orps          %xmm7,%xmm1
  .byte  15,40,125,200                       // movaps        -0x38(%ebp),%xmm7
  .byte  15,89,239                           // mulps         %xmm7,%xmm5
  .byte  15,88,234                           // addps         %xmm2,%xmm5
  .byte  15,84,204                           // andps         %xmm4,%xmm1
  .byte  15,85,229                           // andnps        %xmm5,%xmm4
  .byte  15,86,225                           // orps          %xmm1,%xmm4
  .byte  15,40,69,232                        // movaps        -0x18(%ebp),%xmm0
  .byte  15,85,196                           // andnps        %xmm4,%xmm0
  .byte  15,41,69,152                        // movaps        %xmm0,-0x68(%ebp)
  .byte  15,40,93,184                        // movaps        -0x48(%ebp),%xmm3
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,194,200,1                        // cmpltps       %xmm0,%xmm1
  .byte  15,84,136,254,212,0,0               // andps         0xd4fe(%eax),%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,40,128,222,214,0,0               // movaps        0xd6de(%eax),%xmm0
  .byte  15,194,193,2                        // cmpleps       %xmm1,%xmm0
  .byte  15,40,152,238,212,0,0               // movaps        0xd4ee(%eax),%xmm3
  .byte  15,194,217,2                        // cmpleps       %xmm1,%xmm3
  .byte  15,40,160,190,214,0,0               // movaps        0xd6be(%eax),%xmm4
  .byte  15,194,225,2                        // cmpleps       %xmm1,%xmm4
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,40,168,174,214,0,0               // movaps        0xd6ae(%eax),%xmm5
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  15,89,239                           // mulps         %xmm7,%xmm5
  .byte  15,88,234                           // addps         %xmm2,%xmm5
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,84,248                           // andps         %xmm0,%xmm7
  .byte  15,85,197                           // andnps        %xmm5,%xmm0
  .byte  15,86,199                           // orps          %xmm7,%xmm0
  .byte  15,84,195                           // andps         %xmm3,%xmm0
  .byte  15,85,93,216                        // andnps        -0x28(%ebp),%xmm3
  .byte  15,86,216                           // orps          %xmm0,%xmm3
  .byte  15,40,109,200                       // movaps        -0x38(%ebp),%xmm5
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  15,84,220                           // andps         %xmm4,%xmm3
  .byte  15,85,225                           // andnps        %xmm1,%xmm4
  .byte  15,86,227                           // orps          %xmm3,%xmm4
  .byte  15,40,125,232                       // movaps        -0x18(%ebp),%xmm7
  .byte  15,85,252                           // andnps        %xmm4,%xmm7
  .byte  15,40,93,184                        // movaps        -0x48(%ebp),%xmm3
  .byte  15,88,152,238,214,0,0               // addps         0xd6ee(%eax),%xmm3
  .byte  243,15,91,195                       // cvttps2dq     %xmm3,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,194,200,1                        // cmpltps       %xmm0,%xmm1
  .byte  15,84,77,136                        // andps         -0x78(%ebp),%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,92,216                           // subps         %xmm0,%xmm3
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,40,77,168                        // movaps        -0x58(%ebp),%xmm1
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,226                           // addps         %xmm2,%xmm4
  .byte  15,88,242                           // addps         %xmm2,%xmm6
  .byte  15,40,141,88,255,255,255            // movaps        -0xa8(%ebp),%xmm1
  .byte  15,194,203,2                        // cmpleps       %xmm3,%xmm1
  .byte  15,84,209                           // andps         %xmm1,%xmm2
  .byte  15,85,204                           // andnps        %xmm4,%xmm1
  .byte  15,86,202                           // orps          %xmm2,%xmm1
  .byte  15,40,133,104,255,255,255           // movaps        -0x98(%ebp),%xmm0
  .byte  15,194,195,2                        // cmpleps       %xmm3,%xmm0
  .byte  15,84,200                           // andps         %xmm0,%xmm1
  .byte  15,85,69,216                        // andnps        -0x28(%ebp),%xmm0
  .byte  15,86,193                           // orps          %xmm1,%xmm0
  .byte  15,40,141,120,255,255,255           // movaps        -0x88(%ebp),%xmm1
  .byte  15,194,203,2                        // cmpleps       %xmm3,%xmm1
  .byte  15,84,193                           // andps         %xmm1,%xmm0
  .byte  15,85,206                           // andnps        %xmm6,%xmm1
  .byte  15,86,200                           // orps          %xmm0,%xmm1
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  15,40,157,72,255,255,255            // movaps        -0xb8(%ebp),%xmm3
  .byte  15,40,77,232                        // movaps        -0x18(%ebp),%xmm1
  .byte  15,84,217                           // andps         %xmm1,%xmm3
  .byte  15,85,202                           // andnps        %xmm2,%xmm1
  .byte  15,40,69,152                        // movaps        -0x68(%ebp),%xmm0
  .byte  15,86,195                           // orps          %xmm3,%xmm0
  .byte  15,86,251                           // orps          %xmm3,%xmm7
  .byte  15,86,217                           // orps          %xmm1,%xmm3
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  141,72,4                            // lea           0x4(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,207                           // movaps        %xmm7,%xmm1
  .byte  15,40,157,56,255,255,255            // movaps        -0xc8(%ebp),%xmm3
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,16                              // call          *(%eax)
  .byte  129,196,216,0,0,0                   // add           $0xd8,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_scale_1_float_sse2
.globl _sk_scale_1_float_sse2
FUNCTION(_sk_scale_1_float_sse2)
_sk_scale_1_float_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,33                        // movss         (%ecx),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_scale_u8_sse2
.globl _sk_scale_u8_sse2
FUNCTION(_sk_scale_u8_sse2)
_sk_scale_u8_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          289c <_sk_scale_u8_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  117,65                              // jne           28f8 <_sk_scale_u8_sse2+0x6a>
  .byte  102,15,110,36,62                    // movd          (%esi,%edi,1),%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  102,15,97,224                       // punpcklwd     %xmm0,%xmm4
  .byte  102,15,219,162,68,211,0,0           // pand          0xd344(%edx),%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,162,132,212,0,0               // mulps         0xd484(%edx),%xmm4
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,50                              // je            2932 <_sk_scale_u8_sse2+0xa4>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,19                              // je            291c <_sk_scale_u8_sse2+0x8e>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,182                             // jne           28c4 <_sk_scale_u8_sse2+0x36>
  .byte  15,182,92,62,2                      // movzbl        0x2(%esi,%edi,1),%ebx
  .byte  102,15,110,227                      // movd          %ebx,%xmm4
  .byte  102,15,112,228,69                   // pshufd        $0x45,%xmm4,%xmm4
  .byte  15,183,52,62                        // movzwl        (%esi,%edi,1),%esi
  .byte  102,15,110,238                      // movd          %esi,%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  102,15,97,232                       // punpcklwd     %xmm0,%xmm5
  .byte  242,15,16,229                       // movsd         %xmm5,%xmm4
  .byte  235,146                             // jmp           28c4 <_sk_scale_u8_sse2+0x36>
  .byte  15,182,52,62                        // movzbl        (%esi,%edi,1),%esi
  .byte  102,15,110,230                      // movd          %esi,%xmm4
  .byte  235,136                             // jmp           28c4 <_sk_scale_u8_sse2+0x36>

HIDDEN _sk_scale_565_sse2
.globl _sk_scale_565_sse2
FUNCTION(_sk_scale_565_sse2)
_sk_scale_565_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,44                          // sub           $0x2c,%esp
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  15,41,77,216                        // movaps        %xmm1,-0x28(%ebp)
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          2956 <_sk_scale_565_sse2+0x1a>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  1,246                               // add           %esi,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  15,133,157,0,0,0                    // jne           2a14 <_sk_scale_565_sse2+0xd8>
  .byte  243,15,126,52,126                   // movq          (%esi,%edi,2),%xmm6
  .byte  102,15,97,240                       // punpcklwd     %xmm0,%xmm6
  .byte  102,15,111,162,218,211,0,0          // movdqa        0xd3da(%edx),%xmm4
  .byte  102,15,219,230                      // pand          %xmm6,%xmm4
  .byte  15,91,212                           // cvtdq2ps      %xmm4,%xmm2
  .byte  15,89,146,234,211,0,0               // mulps         0xd3ea(%edx),%xmm2
  .byte  102,15,111,170,250,211,0,0          // movdqa        0xd3fa(%edx),%xmm5
  .byte  102,15,219,238                      // pand          %xmm6,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  15,89,170,10,212,0,0                // mulps         0xd40a(%edx),%xmm5
  .byte  102,15,219,178,26,212,0,0           // pand          0xd41a(%edx),%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,89,178,42,212,0,0                // mulps         0xd42a(%edx),%xmm6
  .byte  15,40,253                           // movaps        %xmm5,%xmm7
  .byte  15,93,254                           // minps         %xmm6,%xmm7
  .byte  15,40,226                           // movaps        %xmm2,%xmm4
  .byte  15,93,231                           // minps         %xmm7,%xmm4
  .byte  15,40,253                           // movaps        %xmm5,%xmm7
  .byte  15,95,254                           // maxps         %xmm6,%xmm7
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,95,199                           // maxps         %xmm7,%xmm0
  .byte  15,40,251                           // movaps        %xmm3,%xmm7
  .byte  15,194,121,64,1                     // cmpltps       0x40(%ecx),%xmm7
  .byte  15,84,231                           // andps         %xmm7,%xmm4
  .byte  15,85,248                           // andnps        %xmm0,%xmm7
  .byte  15,86,252                           // orps          %xmm4,%xmm7
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  15,89,109,216                       // mulps         -0x28(%ebp),%xmm5
  .byte  15,89,117,200                       // mulps         -0x38(%ebp),%xmm6
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,40,223                           // movaps        %xmm7,%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,60                          // add           $0x3c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,51                              // je            2a4f <_sk_scale_565_sse2+0x113>
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,23                              // je            2a3c <_sk_scale_565_sse2+0x100>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  15,133,82,255,255,255               // jne           2980 <_sk_scale_565_sse2+0x44>
  .byte  15,183,92,126,4                     // movzwl        0x4(%esi,%edi,2),%ebx
  .byte  102,15,110,227                      // movd          %ebx,%xmm4
  .byte  102,15,112,244,69                   // pshufd        $0x45,%xmm4,%xmm6
  .byte  102,15,110,36,126                   // movd          (%esi,%edi,2),%xmm4
  .byte  242,15,112,228,212                  // pshuflw       $0xd4,%xmm4,%xmm4
  .byte  242,15,16,244                       // movsd         %xmm4,%xmm6
  .byte  233,49,255,255,255                  // jmp           2980 <_sk_scale_565_sse2+0x44>
  .byte  15,183,52,126                       // movzwl        (%esi,%edi,2),%esi
  .byte  102,15,110,246                      // movd          %esi,%xmm6
  .byte  233,36,255,255,255                  // jmp           2980 <_sk_scale_565_sse2+0x44>

HIDDEN _sk_lerp_1_float_sse2
.globl _sk_lerp_1_float_sse2
FUNCTION(_sk_lerp_1_float_sse2)
_sk_lerp_1_float_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  243,15,16,34                        // movss         (%edx),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,40,104,16                        // movaps        0x10(%eax),%xmm5
  .byte  15,40,112,32                        // movaps        0x20(%eax),%xmm6
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,40,104,48                        // movaps        0x30(%eax),%xmm5
  .byte  15,92,213                           // subps         %xmm5,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,40,104,64                        // movaps        0x40(%eax),%xmm5
  .byte  15,92,221                           // subps         %xmm5,%xmm3
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  141,81,8                            // lea           0x8(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_lerp_u8_sse2
.globl _sk_lerp_u8_sse2
FUNCTION(_sk_lerp_u8_sse2)
_sk_lerp_u8_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          2ac4 <_sk_lerp_u8_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  117,102                             // jne           2b45 <_sk_lerp_u8_sse2+0x8f>
  .byte  102,15,110,36,62                    // movd          (%esi,%edi,1),%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  102,15,97,224                       // punpcklwd     %xmm0,%xmm4
  .byte  102,15,219,162,28,209,0,0           // pand          0xd11c(%edx),%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,162,92,210,0,0                // mulps         0xd25c(%edx),%xmm4
  .byte  15,40,105,16                        // movaps        0x10(%ecx),%xmm5
  .byte  15,40,113,32                        // movaps        0x20(%ecx),%xmm6
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,40,105,48                        // movaps        0x30(%ecx),%xmm5
  .byte  15,92,213                           // subps         %xmm5,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,40,105,64                        // movaps        0x40(%ecx),%xmm5
  .byte  15,92,221                           // subps         %xmm5,%xmm3
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,53                              // je            2b82 <_sk_lerp_u8_sse2+0xcc>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,19                              // je            2b69 <_sk_lerp_u8_sse2+0xb3>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,145                             // jne           2aec <_sk_lerp_u8_sse2+0x36>
  .byte  15,182,92,62,2                      // movzbl        0x2(%esi,%edi,1),%ebx
  .byte  102,15,110,227                      // movd          %ebx,%xmm4
  .byte  102,15,112,228,69                   // pshufd        $0x45,%xmm4,%xmm4
  .byte  15,183,52,62                        // movzwl        (%esi,%edi,1),%esi
  .byte  102,15,110,238                      // movd          %esi,%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  102,15,97,232                       // punpcklwd     %xmm0,%xmm5
  .byte  242,15,16,229                       // movsd         %xmm5,%xmm4
  .byte  233,106,255,255,255                 // jmp           2aec <_sk_lerp_u8_sse2+0x36>
  .byte  15,182,52,62                        // movzbl        (%esi,%edi,1),%esi
  .byte  102,15,110,230                      // movd          %esi,%xmm4
  .byte  233,93,255,255,255                  // jmp           2aec <_sk_lerp_u8_sse2+0x36>

HIDDEN _sk_lerp_565_sse2
.globl _sk_lerp_565_sse2
FUNCTION(_sk_lerp_565_sse2)
_sk_lerp_565_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,108                         // sub           $0x6c,%esp
  .byte  15,41,93,168                        // movaps        %xmm3,-0x58(%ebp)
  .byte  15,41,85,136                        // movaps        %xmm2,-0x78(%ebp)
  .byte  15,41,77,152                        // movaps        %xmm1,-0x68(%ebp)
  .byte  102,15,127,69,184                   // movdqa        %xmm0,-0x48(%ebp)
  .byte  232,0,0,0,0                         // call          2bae <_sk_lerp_565_sse2+0x1f>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  1,246                               // add           %esi,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  15,133,211,0,0,0                    // jne           2ca2 <_sk_lerp_565_sse2+0x113>
  .byte  243,15,126,44,126                   // movq          (%esi,%edi,2),%xmm5
  .byte  102,15,97,232                       // punpcklwd     %xmm0,%xmm5
  .byte  102,15,111,162,130,209,0,0          // movdqa        0xd182(%edx),%xmm4
  .byte  102,15,219,229                      // pand          %xmm5,%xmm4
  .byte  15,91,204                           // cvtdq2ps      %xmm4,%xmm1
  .byte  15,89,138,146,209,0,0               // mulps         0xd192(%edx),%xmm1
  .byte  102,15,111,178,162,209,0,0          // movdqa        0xd1a2(%edx),%xmm6
  .byte  102,15,219,245                      // pand          %xmm5,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,89,178,178,209,0,0               // mulps         0xd1b2(%edx),%xmm6
  .byte  102,15,219,170,194,209,0,0          // pand          0xd1c2(%edx),%xmm5
  .byte  15,91,213                           // cvtdq2ps      %xmm5,%xmm2
  .byte  15,89,146,210,209,0,0               // mulps         0xd1d2(%edx),%xmm2
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,41,93,200                        // movaps        %xmm3,-0x38(%ebp)
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  15,40,65,32                         // movaps        0x20(%ecx),%xmm0
  .byte  15,41,69,216                        // movaps        %xmm0,-0x28(%ebp)
  .byte  15,40,101,152                       // movaps        -0x68(%ebp),%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  15,93,243                           // minps         %xmm3,%xmm6
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  15,40,65,16                         // movaps        0x10(%ecx),%xmm0
  .byte  15,40,109,184                       // movaps        -0x48(%ebp),%xmm5
  .byte  15,92,232                           // subps         %xmm0,%xmm5
  .byte  15,89,233                           // mulps         %xmm1,%xmm5
  .byte  15,93,206                           // minps         %xmm6,%xmm1
  .byte  15,40,113,64                        // movaps        0x40(%ecx),%xmm6
  .byte  15,95,251                           // maxps         %xmm3,%xmm7
  .byte  15,95,215                           // maxps         %xmm7,%xmm2
  .byte  15,40,93,168                        // movaps        -0x58(%ebp),%xmm3
  .byte  15,40,251                           // movaps        %xmm3,%xmm7
  .byte  15,194,254,1                        // cmpltps       %xmm6,%xmm7
  .byte  15,84,207                           // andps         %xmm7,%xmm1
  .byte  15,85,250                           // andnps        %xmm2,%xmm7
  .byte  15,86,249                           // orps          %xmm1,%xmm7
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  15,88,101,216                       // addps         -0x28(%ebp),%xmm4
  .byte  15,40,65,48                         // movaps        0x30(%ecx),%xmm0
  .byte  15,40,85,136                        // movaps        -0x78(%ebp),%xmm2
  .byte  15,92,208                           // subps         %xmm0,%xmm2
  .byte  15,89,85,200                        // mulps         -0x38(%ebp),%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  15,92,222                           // subps         %xmm6,%xmm3
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  15,88,222                           // addps         %xmm6,%xmm3
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,124                         // add           $0x7c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,51                              // je            2cdd <_sk_lerp_565_sse2+0x14e>
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,23                              // je            2cca <_sk_lerp_565_sse2+0x13b>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  15,133,28,255,255,255               // jne           2bd8 <_sk_lerp_565_sse2+0x49>
  .byte  15,183,92,126,4                     // movzwl        0x4(%esi,%edi,2),%ebx
  .byte  102,15,110,227                      // movd          %ebx,%xmm4
  .byte  102,15,112,236,69                   // pshufd        $0x45,%xmm4,%xmm5
  .byte  102,15,110,36,126                   // movd          (%esi,%edi,2),%xmm4
  .byte  242,15,112,228,212                  // pshuflw       $0xd4,%xmm4,%xmm4
  .byte  242,15,16,236                       // movsd         %xmm4,%xmm5
  .byte  233,251,254,255,255                 // jmp           2bd8 <_sk_lerp_565_sse2+0x49>
  .byte  15,183,52,126                       // movzwl        (%esi,%edi,2),%esi
  .byte  102,15,110,238                      // movd          %esi,%xmm5
  .byte  233,238,254,255,255                 // jmp           2bd8 <_sk_lerp_565_sse2+0x49>

HIDDEN _sk_load_tables_sse2
.globl _sk_load_tables_sse2
FUNCTION(_sk_load_tables_sse2)
_sk_load_tables_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          2cf8 <_sk_load_tables_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,48                              // mov           (%eax),%esi
  .byte  139,65,8                            // mov           0x8(%ecx),%eax
  .byte  133,192                             // test          %eax,%eax
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  139,30                              // mov           (%esi),%ebx
  .byte  15,133,22,1,0,0                     // jne           2e26 <_sk_load_tables_sse2+0x13c>
  .byte  243,15,111,28,187                   // movdqu        (%ebx,%edi,4),%xmm3
  .byte  102,15,111,146,232,206,0,0          // movdqa        0xcee8(%edx),%xmm2
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,15,112,224,231                  // pshufd        $0xe7,%xmm0,%xmm4
  .byte  102,15,126,224                      // movd          %xmm4,%eax
  .byte  139,126,4                           // mov           0x4(%esi),%edi
  .byte  243,15,16,36,135                    // movss         (%edi,%eax,4),%xmm4
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  243,15,16,44,135                    // movss         (%edi,%eax,4),%xmm5
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  243,15,16,4,135                     // movss         (%edi,%eax,4),%xmm0
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  243,15,16,12,135                    // movss         (%edi,%eax,4),%xmm1
  .byte  139,70,8                            // mov           0x8(%esi),%eax
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  15,20,193                           // unpcklps      %xmm1,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,114,209,8                    // psrld         $0x8,%xmm1
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  102,15,112,225,78                   // pshufd        $0x4e,%xmm1,%xmm4
  .byte  102,15,112,241,231                  // pshufd        $0xe7,%xmm1,%xmm6
  .byte  102,15,126,247                      // movd          %xmm6,%edi
  .byte  243,15,16,52,184                    // movss         (%eax,%edi,4),%xmm6
  .byte  102,15,126,231                      // movd          %xmm4,%edi
  .byte  243,15,16,36,184                    // movss         (%eax,%edi,4),%xmm4
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,249,229                  // pshufd        $0xe5,%xmm1,%xmm7
  .byte  243,15,16,12,184                    // movss         (%eax,%edi,4),%xmm1
  .byte  102,15,126,255                      // movd          %xmm7,%edi
  .byte  243,15,16,60,184                    // movss         (%eax,%edi,4),%xmm7
  .byte  102,15,20,197                       // unpcklpd      %xmm5,%xmm0
  .byte  15,20,230                           // unpcklps      %xmm6,%xmm4
  .byte  15,20,207                           // unpcklps      %xmm7,%xmm1
  .byte  139,70,12                           // mov           0xc(%esi),%eax
  .byte  102,15,111,235                      // movdqa        %xmm3,%xmm5
  .byte  102,15,114,213,16                   // psrld         $0x10,%xmm5
  .byte  102,15,219,234                      // pand          %xmm2,%xmm5
  .byte  102,15,112,213,78                   // pshufd        $0x4e,%xmm5,%xmm2
  .byte  102,15,112,245,231                  // pshufd        $0xe7,%xmm5,%xmm6
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  243,15,16,52,176                    // movss         (%eax,%esi,4),%xmm6
  .byte  102,15,126,214                      // movd          %xmm2,%esi
  .byte  243,15,16,60,176                    // movss         (%eax,%esi,4),%xmm7
  .byte  102,15,126,238                      // movd          %xmm5,%esi
  .byte  102,15,112,237,229                  // pshufd        $0xe5,%xmm5,%xmm5
  .byte  243,15,16,20,176                    // movss         (%eax,%esi,4),%xmm2
  .byte  102,15,126,238                      // movd          %xmm5,%esi
  .byte  243,15,16,44,176                    // movss         (%eax,%esi,4),%xmm5
  .byte  102,15,20,204                       // unpcklpd      %xmm4,%xmm1
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  15,20,213                           // unpcklps      %xmm5,%xmm2
  .byte  102,15,20,215                       // unpcklpd      %xmm7,%xmm2
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,154,40,208,0,0                // mulps         0xd028(%edx),%xmm3
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  137,194                             // mov           %eax,%edx
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  36,3                                // and           $0x3,%al
  .byte  60,1                                // cmp           $0x1,%al
  .byte  116,37                              // je            2e51 <_sk_load_tables_sse2+0x167>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  60,2                                // cmp           $0x2,%al
  .byte  116,19                              // je            2e47 <_sk_load_tables_sse2+0x15d>
  .byte  60,3                                // cmp           $0x3,%al
  .byte  15,133,217,254,255,255              // jne           2d15 <_sk_load_tables_sse2+0x2b>
  .byte  102,15,110,68,187,8                 // movd          0x8(%ebx,%edi,4),%xmm0
  .byte  102,15,112,216,69                   // pshufd        $0x45,%xmm0,%xmm3
  .byte  102,15,18,28,187                    // movlpd        (%ebx,%edi,4),%xmm3
  .byte  233,196,254,255,255                 // jmp           2d15 <_sk_load_tables_sse2+0x2b>
  .byte  102,15,110,28,187                   // movd          (%ebx,%edi,4),%xmm3
  .byte  233,186,254,255,255                 // jmp           2d15 <_sk_load_tables_sse2+0x2b>

HIDDEN _sk_load_tables_u16_be_sse2
.globl _sk_load_tables_u16_be_sse2
FUNCTION(_sk_load_tables_u16_be_sse2)
_sk_load_tables_u16_be_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,44                          // sub           $0x2c,%esp
  .byte  232,0,0,0,0                         // call          2e69 <_sk_load_tables_u16_be_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  139,65,8                            // mov           0x8(%ecx),%eax
  .byte  193,231,2                           // shl           $0x2,%edi
  .byte  133,192                             // test          %eax,%eax
  .byte  139,54                              // mov           (%esi),%esi
  .byte  139,30                              // mov           (%esi),%ebx
  .byte  15,133,210,1,0,0                    // jne           3056 <_sk_load_tables_u16_be_sse2+0x1fb>
  .byte  102,15,16,4,123                     // movupd        (%ebx,%edi,2),%xmm0
  .byte  243,15,111,76,123,16                // movdqu        0x10(%ebx,%edi,2),%xmm1
  .byte  102,15,40,216                       // movapd        %xmm0,%xmm3
  .byte  102,15,97,217                       // punpcklwd     %xmm1,%xmm3
  .byte  102,15,105,193                      // punpckhwd     %xmm1,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  102,15,105,216                      // punpckhwd     %xmm0,%xmm3
  .byte  102,15,126,77,208                   // movd          %xmm1,-0x30(%ebp)
  .byte  102,15,112,193,229                  // pshufd        $0xe5,%xmm1,%xmm0
  .byte  102,15,126,69,212                   // movd          %xmm0,-0x2c(%ebp)
  .byte  243,15,126,69,208                   // movq          -0x30(%ebp),%xmm0
  .byte  102,15,97,192                       // punpcklwd     %xmm0,%xmm0
  .byte  102,15,112,209,231                  // pshufd        $0xe7,%xmm1,%xmm2
  .byte  102,15,126,85,220                   // movd          %xmm2,-0x24(%ebp)
  .byte  102,15,112,201,78                   // pshufd        $0x4e,%xmm1,%xmm1
  .byte  102,15,126,77,216                   // movd          %xmm1,-0x28(%ebp)
  .byte  243,15,126,77,216                   // movq          -0x28(%ebp),%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  102,15,126,93,224                   // movd          %xmm3,-0x20(%ebp)
  .byte  102,15,112,211,229                  // pshufd        $0xe5,%xmm3,%xmm2
  .byte  102,15,126,85,228                   // movd          %xmm2,-0x1c(%ebp)
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,111,146,39,207,0,0           // movdqa        0xcf27(%edx),%xmm2
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,97,196                       // punpcklwd     %xmm4,%xmm0
  .byte  102,15,112,232,78                   // pshufd        $0x4e,%xmm0,%xmm5
  .byte  102,15,112,240,231                  // pshufd        $0xe7,%xmm0,%xmm6
  .byte  102,15,126,240                      // movd          %xmm6,%eax
  .byte  139,126,4                           // mov           0x4(%esi),%edi
  .byte  243,15,16,52,135                    // movss         (%edi,%eax,4),%xmm6
  .byte  102,15,126,232                      // movd          %xmm5,%eax
  .byte  243,15,16,44,135                    // movss         (%edi,%eax,4),%xmm5
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,248,229                  // pshufd        $0xe5,%xmm0,%xmm7
  .byte  243,15,16,4,135                     // movss         (%edi,%eax,4),%xmm0
  .byte  102,15,126,248                      // movd          %xmm7,%eax
  .byte  243,15,16,60,135                    // movss         (%edi,%eax,4),%xmm7
  .byte  139,70,8                            // mov           0x8(%esi),%eax
  .byte  15,20,238                           // unpcklps      %xmm6,%xmm5
  .byte  15,20,199                           // unpcklps      %xmm7,%xmm0
  .byte  102,15,20,197                       // unpcklpd      %xmm5,%xmm0
  .byte  242,15,112,201,232                  // pshuflw       $0xe8,%xmm1,%xmm1
  .byte  243,15,112,201,232                  // pshufhw       $0xe8,%xmm1,%xmm1
  .byte  102,15,112,201,232                  // pshufd        $0xe8,%xmm1,%xmm1
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  102,15,97,204                       // punpcklwd     %xmm4,%xmm1
  .byte  102,15,112,233,78                   // pshufd        $0x4e,%xmm1,%xmm5
  .byte  102,15,112,241,231                  // pshufd        $0xe7,%xmm1,%xmm6
  .byte  102,15,126,247                      // movd          %xmm6,%edi
  .byte  243,15,16,52,184                    // movss         (%eax,%edi,4),%xmm6
  .byte  102,15,126,239                      // movd          %xmm5,%edi
  .byte  243,15,16,44,184                    // movss         (%eax,%edi,4),%xmm5
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,249,229                  // pshufd        $0xe5,%xmm1,%xmm7
  .byte  243,15,16,12,184                    // movss         (%eax,%edi,4),%xmm1
  .byte  102,15,126,255                      // movd          %xmm7,%edi
  .byte  243,15,16,60,184                    // movss         (%eax,%edi,4),%xmm7
  .byte  15,20,238                           // unpcklps      %xmm6,%xmm5
  .byte  243,15,126,117,224                  // movq          -0x20(%ebp),%xmm6
  .byte  102,15,97,240                       // punpcklwd     %xmm0,%xmm6
  .byte  15,20,207                           // unpcklps      %xmm7,%xmm1
  .byte  102,15,20,205                       // unpcklpd      %xmm5,%xmm1
  .byte  139,70,12                           // mov           0xc(%esi),%eax
  .byte  242,15,112,238,232                  // pshuflw       $0xe8,%xmm6,%xmm5
  .byte  243,15,112,237,232                  // pshufhw       $0xe8,%xmm5,%xmm5
  .byte  102,15,112,237,232                  // pshufd        $0xe8,%xmm5,%xmm5
  .byte  102,15,219,234                      // pand          %xmm2,%xmm5
  .byte  102,15,97,236                       // punpcklwd     %xmm4,%xmm5
  .byte  102,15,112,213,78                   // pshufd        $0x4e,%xmm5,%xmm2
  .byte  102,15,112,245,231                  // pshufd        $0xe7,%xmm5,%xmm6
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  243,15,16,52,176                    // movss         (%eax,%esi,4),%xmm6
  .byte  102,15,126,214                      // movd          %xmm2,%esi
  .byte  243,15,16,60,176                    // movss         (%eax,%esi,4),%xmm7
  .byte  102,15,126,238                      // movd          %xmm5,%esi
  .byte  102,15,112,237,229                  // pshufd        $0xe5,%xmm5,%xmm5
  .byte  243,15,16,20,176                    // movss         (%eax,%esi,4),%xmm2
  .byte  102,15,126,238                      // movd          %xmm5,%esi
  .byte  243,15,16,44,176                    // movss         (%eax,%esi,4),%xmm5
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  15,20,213                           // unpcklps      %xmm5,%xmm2
  .byte  102,15,20,215                       // unpcklpd      %xmm7,%xmm2
  .byte  102,15,112,219,78                   // pshufd        $0x4e,%xmm3,%xmm3
  .byte  102,15,111,235                      // movdqa        %xmm3,%xmm5
  .byte  102,15,113,245,8                    // psllw         $0x8,%xmm5
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,235,221                      // por           %xmm5,%xmm3
  .byte  102,15,126,93,232                   // movd          %xmm3,-0x18(%ebp)
  .byte  102,15,112,219,229                  // pshufd        $0xe5,%xmm3,%xmm3
  .byte  102,15,126,93,236                   // movd          %xmm3,-0x14(%ebp)
  .byte  243,15,126,93,232                   // movq          -0x18(%ebp),%xmm3
  .byte  102,15,97,220                       // punpcklwd     %xmm4,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,154,55,207,0,0                // mulps         0xcf37(%edx),%xmm3
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  137,194                             // mov           %eax,%edx
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,60                          // add           $0x3c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  242,15,16,4,123                     // movsd         (%ebx,%edi,2),%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  131,248,1                           // cmp           $0x1,%eax
  .byte  15,132,39,254,255,255               // je            2e8f <_sk_load_tables_u16_be_sse2+0x34>
  .byte  102,15,22,68,123,8                  // movhpd        0x8(%ebx,%edi,2),%xmm0
  .byte  131,248,3                           // cmp           $0x3,%eax
  .byte  15,130,24,254,255,255               // jb            2e8f <_sk_load_tables_u16_be_sse2+0x34>
  .byte  243,15,126,76,123,16                // movq          0x10(%ebx,%edi,2),%xmm1
  .byte  233,13,254,255,255                  // jmp           2e8f <_sk_load_tables_u16_be_sse2+0x34>

HIDDEN _sk_load_tables_rgb_u16_be_sse2
.globl _sk_load_tables_rgb_u16_be_sse2
FUNCTION(_sk_load_tables_rgb_u16_be_sse2)
_sk_load_tables_rgb_u16_be_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,28                          // sub           $0x1c,%esp
  .byte  232,0,0,0,0                         // call          3090 <_sk_load_tables_rgb_u16_be_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,65,8                            // mov           0x8(%ecx),%eax
  .byte  107,57,3                            // imul          $0x3,(%ecx),%edi
  .byte  133,192                             // test          %eax,%eax
  .byte  139,54                              // mov           (%esi),%esi
  .byte  139,30                              // mov           (%esi),%ebx
  .byte  15,133,179,1,0,0                    // jne           325c <_sk_load_tables_rgb_u16_be_sse2+0x1da>
  .byte  243,15,111,4,123                    // movdqu        (%ebx,%edi,2),%xmm0
  .byte  243,15,111,92,123,8                 // movdqu        0x8(%ebx,%edi,2),%xmm3
  .byte  102,15,115,219,4                    // psrldq        $0x4,%xmm3
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,115,217,6                    // psrldq        $0x6,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,115,218,6                    // psrldq        $0x6,%xmm2
  .byte  102,15,97,202                       // punpcklwd     %xmm2,%xmm1
  .byte  102,15,97,195                       // punpcklwd     %xmm3,%xmm0
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,15,97,209                       // punpcklwd     %xmm1,%xmm2
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,15,105,193                      // punpckhwd     %xmm1,%xmm0
  .byte  102,15,126,85,216                   // movd          %xmm2,-0x28(%ebp)
  .byte  102,15,112,202,229                  // pshufd        $0xe5,%xmm2,%xmm1
  .byte  102,15,126,77,220                   // movd          %xmm1,-0x24(%ebp)
  .byte  243,15,126,85,216                   // movq          -0x28(%ebp),%xmm2
  .byte  102,15,97,208                       // punpcklwd     %xmm0,%xmm2
  .byte  102,15,126,93,224                   // movd          %xmm3,-0x20(%ebp)
  .byte  102,15,112,203,229                  // pshufd        $0xe5,%xmm3,%xmm1
  .byte  102,15,126,77,228                   // movd          %xmm1,-0x1c(%ebp)
  .byte  243,15,126,77,224                   // movq          -0x20(%ebp),%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  102,15,126,69,232                   // movd          %xmm0,-0x18(%ebp)
  .byte  102,15,112,192,229                  // pshufd        $0xe5,%xmm0,%xmm0
  .byte  102,15,126,69,236                   // movd          %xmm0,-0x14(%ebp)
  .byte  242,15,112,194,232                  // pshuflw       $0xe8,%xmm2,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,111,146,0,205,0,0            // movdqa        0xcd00(%edx),%xmm2
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,97,195                       // punpcklwd     %xmm3,%xmm0
  .byte  102,15,112,224,78                   // pshufd        $0x4e,%xmm0,%xmm4
  .byte  102,15,112,232,231                  // pshufd        $0xe7,%xmm0,%xmm5
  .byte  102,15,126,232                      // movd          %xmm5,%eax
  .byte  139,126,4                           // mov           0x4(%esi),%edi
  .byte  243,15,16,44,135                    // movss         (%edi,%eax,4),%xmm5
  .byte  102,15,126,224                      // movd          %xmm4,%eax
  .byte  243,15,16,36,135                    // movss         (%edi,%eax,4),%xmm4
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,240,229                  // pshufd        $0xe5,%xmm0,%xmm6
  .byte  243,15,16,4,135                     // movss         (%edi,%eax,4),%xmm0
  .byte  102,15,126,240                      // movd          %xmm6,%eax
  .byte  243,15,16,52,135                    // movss         (%edi,%eax,4),%xmm6
  .byte  139,70,8                            // mov           0x8(%esi),%eax
  .byte  15,20,229                           // unpcklps      %xmm5,%xmm4
  .byte  15,20,198                           // unpcklps      %xmm6,%xmm0
  .byte  242,15,112,201,232                  // pshuflw       $0xe8,%xmm1,%xmm1
  .byte  243,15,112,201,232                  // pshufhw       $0xe8,%xmm1,%xmm1
  .byte  102,15,112,201,232                  // pshufd        $0xe8,%xmm1,%xmm1
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  102,15,97,203                       // punpcklwd     %xmm3,%xmm1
  .byte  102,15,112,233,78                   // pshufd        $0x4e,%xmm1,%xmm5
  .byte  102,15,112,241,231                  // pshufd        $0xe7,%xmm1,%xmm6
  .byte  102,15,126,247                      // movd          %xmm6,%edi
  .byte  243,15,16,52,184                    // movss         (%eax,%edi,4),%xmm6
  .byte  102,15,126,239                      // movd          %xmm5,%edi
  .byte  243,15,16,44,184                    // movss         (%eax,%edi,4),%xmm5
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,249,229                  // pshufd        $0xe5,%xmm1,%xmm7
  .byte  243,15,16,12,184                    // movss         (%eax,%edi,4),%xmm1
  .byte  102,15,126,255                      // movd          %xmm7,%edi
  .byte  243,15,16,60,184                    // movss         (%eax,%edi,4),%xmm7
  .byte  102,15,20,196                       // unpcklpd      %xmm4,%xmm0
  .byte  243,15,126,101,232                  // movq          -0x18(%ebp),%xmm4
  .byte  102,15,97,224                       // punpcklwd     %xmm0,%xmm4
  .byte  15,20,238                           // unpcklps      %xmm6,%xmm5
  .byte  139,70,12                           // mov           0xc(%esi),%eax
  .byte  242,15,112,228,232                  // pshuflw       $0xe8,%xmm4,%xmm4
  .byte  243,15,112,228,232                  // pshufhw       $0xe8,%xmm4,%xmm4
  .byte  102,15,112,228,232                  // pshufd        $0xe8,%xmm4,%xmm4
  .byte  102,15,219,226                      // pand          %xmm2,%xmm4
  .byte  102,15,97,227                       // punpcklwd     %xmm3,%xmm4
  .byte  102,15,112,212,78                   // pshufd        $0x4e,%xmm4,%xmm2
  .byte  102,15,112,220,231                  // pshufd        $0xe7,%xmm4,%xmm3
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  243,15,16,28,176                    // movss         (%eax,%esi,4),%xmm3
  .byte  102,15,126,214                      // movd          %xmm2,%esi
  .byte  243,15,16,52,176                    // movss         (%eax,%esi,4),%xmm6
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  102,15,112,228,229                  // pshufd        $0xe5,%xmm4,%xmm4
  .byte  243,15,16,20,176                    // movss         (%eax,%esi,4),%xmm2
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  243,15,16,36,176                    // movss         (%eax,%esi,4),%xmm4
  .byte  15,20,207                           // unpcklps      %xmm7,%xmm1
  .byte  102,15,20,205                       // unpcklpd      %xmm5,%xmm1
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  15,20,212                           // unpcklps      %xmm4,%xmm2
  .byte  102,15,20,214                       // unpcklpd      %xmm6,%xmm2
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  137,198                             // mov           %eax,%esi
  .byte  141,70,8                            // lea           0x8(%esi),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,154,144,202,0,0               // movaps        0xca90(%edx),%xmm3
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,86,4                            // call          *0x4(%esi)
  .byte  131,196,44                          // add           $0x2c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  102,15,110,4,123                    // movd          (%ebx,%edi,2),%xmm0
  .byte  102,15,196,68,123,4,2               // pinsrw        $0x2,0x4(%ebx,%edi,2),%xmm0
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  131,248,1                           // cmp           $0x1,%eax
  .byte  117,13                              // jne           327e <_sk_load_tables_rgb_u16_be_sse2+0x1fc>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  233,77,254,255,255                  // jmp           30cb <_sk_load_tables_rgb_u16_be_sse2+0x49>
  .byte  102,15,110,76,123,6                 // movd          0x6(%ebx,%edi,2),%xmm1
  .byte  102,15,196,76,123,10,2              // pinsrw        $0x2,0xa(%ebx,%edi,2),%xmm1
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  131,248,3                           // cmp           $0x3,%eax
  .byte  114,18                              // jb            32a6 <_sk_load_tables_rgb_u16_be_sse2+0x224>
  .byte  102,15,110,92,123,12                // movd          0xc(%ebx,%edi,2),%xmm3
  .byte  102,15,196,92,123,16,2              // pinsrw        $0x2,0x10(%ebx,%edi,2),%xmm3
  .byte  233,37,254,255,255                  // jmp           30cb <_sk_load_tables_rgb_u16_be_sse2+0x49>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  233,28,254,255,255                  // jmp           30cb <_sk_load_tables_rgb_u16_be_sse2+0x49>

HIDDEN _sk_byte_tables_sse2
.globl _sk_byte_tables_sse2
FUNCTION(_sk_byte_tables_sse2)
_sk_byte_tables_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          32bd <_sk_byte_tables_sse2+0xe>
  .byte  89                                  // pop           %ecx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,16                              // mov           (%eax),%edx
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,95,232                           // maxps         %xmm0,%xmm5
  .byte  15,40,129,99,200,0,0                // movaps        0xc863(%ecx),%xmm0
  .byte  15,93,232                           // minps         %xmm0,%xmm5
  .byte  15,40,161,51,201,0,0                // movaps        0xc933(%ecx),%xmm4
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  102,15,91,237                       // cvtps2dq      %xmm5,%xmm5
  .byte  102,15,112,245,78                   // pshufd        $0x4e,%xmm5,%xmm6
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  102,15,112,245,231                  // pshufd        $0xe7,%xmm5,%xmm6
  .byte  139,58                              // mov           (%edx),%edi
  .byte  15,182,52,55                        // movzbl        (%edi,%esi,1),%esi
  .byte  102,15,126,243                      // movd          %xmm6,%ebx
  .byte  15,182,28,31                        // movzbl        (%edi,%ebx,1),%ebx
  .byte  193,227,8                           // shl           $0x8,%ebx
  .byte  9,243                               // or            %esi,%ebx
  .byte  102,15,112,245,229                  // pshufd        $0xe5,%xmm5,%xmm6
  .byte  102,15,126,238                      // movd          %xmm5,%esi
  .byte  15,182,52,55                        // movzbl        (%edi,%esi,1),%esi
  .byte  102,15,126,240                      // movd          %xmm6,%eax
  .byte  15,182,4,7                          // movzbl        (%edi,%eax,1),%eax
  .byte  193,224,8                           // shl           $0x8,%eax
  .byte  9,240                               // or            %esi,%eax
  .byte  102,15,110,232                      // movd          %eax,%xmm5
  .byte  139,66,4                            // mov           0x4(%edx),%eax
  .byte  102,15,196,235,1                    // pinsrw        $0x1,%ebx,%xmm5
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  15,95,241                           // maxps         %xmm1,%xmm6
  .byte  15,93,240                           // minps         %xmm0,%xmm6
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  102,15,91,206                       // cvtps2dq      %xmm6,%xmm1
  .byte  102,15,112,241,78                   // pshufd        $0x4e,%xmm1,%xmm6
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  102,15,112,241,231                  // pshufd        $0xe7,%xmm1,%xmm6
  .byte  15,182,52,48                        // movzbl        (%eax,%esi,1),%esi
  .byte  102,15,126,247                      // movd          %xmm6,%edi
  .byte  15,182,60,56                        // movzbl        (%eax,%edi,1),%edi
  .byte  193,231,8                           // shl           $0x8,%edi
  .byte  9,247                               // or            %esi,%edi
  .byte  102,15,112,241,229                  // pshufd        $0xe5,%xmm1,%xmm6
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  15,182,52,48                        // movzbl        (%eax,%esi,1),%esi
  .byte  102,15,126,243                      // movd          %xmm6,%ebx
  .byte  15,182,4,24                         // movzbl        (%eax,%ebx,1),%eax
  .byte  193,224,8                           // shl           $0x8,%eax
  .byte  9,240                               // or            %esi,%eax
  .byte  102,15,110,200                      // movd          %eax,%xmm1
  .byte  102,15,196,207,1                    // pinsrw        $0x1,%edi,%xmm1
  .byte  139,66,8                            // mov           0x8(%edx),%eax
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  15,95,242                           // maxps         %xmm2,%xmm6
  .byte  15,93,240                           // minps         %xmm0,%xmm6
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  102,15,91,214                       // cvtps2dq      %xmm6,%xmm2
  .byte  102,15,112,242,78                   // pshufd        $0x4e,%xmm2,%xmm6
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  102,15,112,242,231                  // pshufd        $0xe7,%xmm2,%xmm6
  .byte  15,182,52,48                        // movzbl        (%eax,%esi,1),%esi
  .byte  102,15,126,247                      // movd          %xmm6,%edi
  .byte  15,182,60,56                        // movzbl        (%eax,%edi,1),%edi
  .byte  193,231,8                           // shl           $0x8,%edi
  .byte  9,247                               // or            %esi,%edi
  .byte  102,15,112,242,229                  // pshufd        $0xe5,%xmm2,%xmm6
  .byte  102,15,126,214                      // movd          %xmm2,%esi
  .byte  15,182,52,48                        // movzbl        (%eax,%esi,1),%esi
  .byte  102,15,126,243                      // movd          %xmm6,%ebx
  .byte  15,182,4,24                         // movzbl        (%eax,%ebx,1),%eax
  .byte  193,224,8                           // shl           $0x8,%eax
  .byte  9,240                               // or            %esi,%eax
  .byte  102,15,87,210                       // xorpd         %xmm2,%xmm2
  .byte  15,95,211                           // maxps         %xmm3,%xmm2
  .byte  15,93,208                           // minps         %xmm0,%xmm2
  .byte  102,15,110,216                      // movd          %eax,%xmm3
  .byte  102,15,196,223,1                    // pinsrw        $0x1,%edi,%xmm3
  .byte  139,66,12                           // mov           0xc(%edx),%eax
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  102,15,91,194                       // cvtps2dq      %xmm2,%xmm0
  .byte  102,15,112,208,78                   // pshufd        $0x4e,%xmm0,%xmm2
  .byte  102,15,126,210                      // movd          %xmm2,%edx
  .byte  102,15,112,208,231                  // pshufd        $0xe7,%xmm0,%xmm2
  .byte  102,15,126,214                      // movd          %xmm2,%esi
  .byte  15,182,20,16                        // movzbl        (%eax,%edx,1),%edx
  .byte  15,182,52,48                        // movzbl        (%eax,%esi,1),%esi
  .byte  193,230,8                           // shl           $0x8,%esi
  .byte  9,214                               // or            %edx,%esi
  .byte  102,15,126,194                      // movd          %xmm0,%edx
  .byte  102,15,112,192,229                  // pshufd        $0xe5,%xmm0,%xmm0
  .byte  15,182,20,16                        // movzbl        (%eax,%edx,1),%edx
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  15,182,4,56                         // movzbl        (%eax,%edi,1),%eax
  .byte  193,224,8                           // shl           $0x8,%eax
  .byte  9,208                               // or            %edx,%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  102,15,196,230,1                    // pinsrw        $0x1,%esi,%xmm4
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  102,15,96,234                       // punpcklbw     %xmm2,%xmm5
  .byte  102,15,97,234                       // punpcklwd     %xmm2,%xmm5
  .byte  15,91,197                           // cvtdq2ps      %xmm5,%xmm0
  .byte  102,15,96,202                       // punpcklbw     %xmm2,%xmm1
  .byte  102,15,97,202                       // punpcklwd     %xmm2,%xmm1
  .byte  102,15,96,218                       // punpcklbw     %xmm2,%xmm3
  .byte  102,15,97,218                       // punpcklwd     %xmm2,%xmm3
  .byte  102,15,96,226                       // punpcklbw     %xmm2,%xmm4
  .byte  102,15,97,226                       // punpcklwd     %xmm2,%xmm4
  .byte  15,40,169,99,202,0,0                // movaps        0xca63(%ecx),%xmm5
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,91,211                           // cvtdq2ps      %xmm3,%xmm2
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,91,220                           // cvtdq2ps      %xmm4,%xmm3
  .byte  15,89,221                           // mulps         %xmm5,%xmm3
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,65,8                            // lea           0x8(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_byte_tables_rgb_sse2
.globl _sk_byte_tables_rgb_sse2
FUNCTION(_sk_byte_tables_rgb_sse2)
_sk_byte_tables_rgb_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          3490 <_sk_byte_tables_rgb_sse2+0xe>
  .byte  89                                  // pop           %ecx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,16                              // mov           (%eax),%edx
  .byte  139,114,12                          // mov           0xc(%edx),%esi
  .byte  78                                  // dec           %esi
  .byte  102,15,110,230                      // movd          %esi,%xmm4
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,95,232                           // maxps         %xmm0,%xmm5
  .byte  15,40,129,144,198,0,0               // movaps        0xc690(%ecx),%xmm0
  .byte  15,93,232                           // minps         %xmm0,%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  102,15,91,237                       // cvtps2dq      %xmm5,%xmm5
  .byte  102,15,112,245,78                   // pshufd        $0x4e,%xmm5,%xmm6
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  102,15,112,245,231                  // pshufd        $0xe7,%xmm5,%xmm6
  .byte  139,58                              // mov           (%edx),%edi
  .byte  15,182,52,55                        // movzbl        (%edi,%esi,1),%esi
  .byte  102,15,126,243                      // movd          %xmm6,%ebx
  .byte  15,182,28,31                        // movzbl        (%edi,%ebx,1),%ebx
  .byte  193,227,8                           // shl           $0x8,%ebx
  .byte  9,243                               // or            %esi,%ebx
  .byte  102,15,112,245,229                  // pshufd        $0xe5,%xmm5,%xmm6
  .byte  102,15,126,238                      // movd          %xmm5,%esi
  .byte  15,182,52,55                        // movzbl        (%edi,%esi,1),%esi
  .byte  102,15,126,240                      // movd          %xmm6,%eax
  .byte  15,182,4,7                          // movzbl        (%edi,%eax,1),%eax
  .byte  193,224,8                           // shl           $0x8,%eax
  .byte  9,240                               // or            %esi,%eax
  .byte  102,15,110,232                      // movd          %eax,%xmm5
  .byte  139,66,4                            // mov           0x4(%edx),%eax
  .byte  102,15,196,235,1                    // pinsrw        $0x1,%ebx,%xmm5
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  15,95,241                           // maxps         %xmm1,%xmm6
  .byte  15,93,240                           // minps         %xmm0,%xmm6
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  102,15,91,206                       // cvtps2dq      %xmm6,%xmm1
  .byte  102,15,112,241,78                   // pshufd        $0x4e,%xmm1,%xmm6
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  102,15,112,241,231                  // pshufd        $0xe7,%xmm1,%xmm6
  .byte  15,182,52,48                        // movzbl        (%eax,%esi,1),%esi
  .byte  102,15,126,247                      // movd          %xmm6,%edi
  .byte  15,182,60,56                        // movzbl        (%eax,%edi,1),%edi
  .byte  193,231,8                           // shl           $0x8,%edi
  .byte  9,247                               // or            %esi,%edi
  .byte  102,15,112,241,229                  // pshufd        $0xe5,%xmm1,%xmm6
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  15,182,52,48                        // movzbl        (%eax,%esi,1),%esi
  .byte  102,15,126,243                      // movd          %xmm6,%ebx
  .byte  15,182,4,24                         // movzbl        (%eax,%ebx,1),%eax
  .byte  193,224,8                           // shl           $0x8,%eax
  .byte  9,240                               // or            %esi,%eax
  .byte  102,15,87,201                       // xorpd         %xmm1,%xmm1
  .byte  15,95,202                           // maxps         %xmm2,%xmm1
  .byte  15,93,200                           // minps         %xmm0,%xmm1
  .byte  102,15,110,208                      // movd          %eax,%xmm2
  .byte  102,15,196,215,1                    // pinsrw        $0x1,%edi,%xmm2
  .byte  139,66,8                            // mov           0x8(%edx),%eax
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  102,15,91,193                       // cvtps2dq      %xmm1,%xmm0
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,15,126,202                      // movd          %xmm1,%edx
  .byte  102,15,112,200,231                  // pshufd        $0xe7,%xmm0,%xmm1
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  15,182,20,16                        // movzbl        (%eax,%edx,1),%edx
  .byte  15,182,52,48                        // movzbl        (%eax,%esi,1),%esi
  .byte  193,230,8                           // shl           $0x8,%esi
  .byte  9,214                               // or            %edx,%esi
  .byte  102,15,126,194                      // movd          %xmm0,%edx
  .byte  102,15,112,192,229                  // pshufd        $0xe5,%xmm0,%xmm0
  .byte  15,182,20,16                        // movzbl        (%eax,%edx,1),%edx
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  15,182,4,56                         // movzbl        (%eax,%edi,1),%eax
  .byte  193,224,8                           // shl           $0x8,%eax
  .byte  9,208                               // or            %edx,%eax
  .byte  102,15,110,224                      // movd          %eax,%xmm4
  .byte  102,15,196,230,1                    // pinsrw        $0x1,%esi,%xmm4
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,15,96,233                       // punpcklbw     %xmm1,%xmm5
  .byte  102,15,97,233                       // punpcklwd     %xmm1,%xmm5
  .byte  15,91,197                           // cvtdq2ps      %xmm5,%xmm0
  .byte  102,15,96,209                       // punpcklbw     %xmm1,%xmm2
  .byte  102,15,97,209                       // punpcklwd     %xmm1,%xmm2
  .byte  102,15,96,225                       // punpcklbw     %xmm1,%xmm4
  .byte  102,15,97,225                       // punpcklwd     %xmm1,%xmm4
  .byte  15,40,169,144,200,0,0               // movaps        0xc890(%ecx),%xmm5
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,91,202                           // cvtdq2ps      %xmm2,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,91,212                           // cvtdq2ps      %xmm4,%xmm2
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,65,8                            // lea           0x8(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_table_r_sse2
.globl _sk_table_r_sse2
FUNCTION(_sk_table_r_sse2)
_sk_table_r_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,81,4                            // mov           0x4(%ecx),%edx
  .byte  74                                  // dec           %edx
  .byte  102,15,110,226                      // movd          %edx,%xmm4
  .byte  232,0,0,0,0                         // call          3612 <_sk_table_r_sse2+0x18>
  .byte  90                                  // pop           %edx
  .byte  139,9                               // mov           (%ecx),%ecx
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,95,232                           // maxps         %xmm0,%xmm5
  .byte  15,93,170,14,197,0,0                // minps         0xc50e(%edx),%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  102,15,91,197                       // cvtps2dq      %xmm5,%xmm0
  .byte  102,15,112,224,78                   // pshufd        $0x4e,%xmm0,%xmm4
  .byte  102,15,112,232,231                  // pshufd        $0xe7,%xmm0,%xmm5
  .byte  102,15,126,234                      // movd          %xmm5,%edx
  .byte  243,15,16,44,145                    // movss         (%ecx,%edx,4),%xmm5
  .byte  102,15,126,226                      // movd          %xmm4,%edx
  .byte  243,15,16,36,145                    // movss         (%ecx,%edx,4),%xmm4
  .byte  102,15,126,194                      // movd          %xmm0,%edx
  .byte  102,15,112,240,229                  // pshufd        $0xe5,%xmm0,%xmm6
  .byte  243,15,16,4,145                     // movss         (%ecx,%edx,4),%xmm0
  .byte  102,15,126,242                      // movd          %xmm6,%edx
  .byte  243,15,16,52,145                    // movss         (%ecx,%edx,4),%xmm6
  .byte  15,20,229                           // unpcklps      %xmm5,%xmm4
  .byte  15,20,198                           // unpcklps      %xmm6,%xmm0
  .byte  102,15,20,196                       // unpcklpd      %xmm4,%xmm0
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_table_g_sse2
.globl _sk_table_g_sse2
FUNCTION(_sk_table_g_sse2)
_sk_table_g_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,81,4                            // mov           0x4(%ecx),%edx
  .byte  74                                  // dec           %edx
  .byte  102,15,110,226                      // movd          %edx,%xmm4
  .byte  232,0,0,0,0                         // call          3698 <_sk_table_g_sse2+0x18>
  .byte  90                                  // pop           %edx
  .byte  139,9                               // mov           (%ecx),%ecx
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,95,233                           // maxps         %xmm1,%xmm5
  .byte  15,93,170,136,196,0,0               // minps         0xc488(%edx),%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  102,15,91,205                       // cvtps2dq      %xmm5,%xmm1
  .byte  102,15,112,225,78                   // pshufd        $0x4e,%xmm1,%xmm4
  .byte  102,15,112,233,231                  // pshufd        $0xe7,%xmm1,%xmm5
  .byte  102,15,126,234                      // movd          %xmm5,%edx
  .byte  243,15,16,44,145                    // movss         (%ecx,%edx,4),%xmm5
  .byte  102,15,126,226                      // movd          %xmm4,%edx
  .byte  243,15,16,36,145                    // movss         (%ecx,%edx,4),%xmm4
  .byte  102,15,126,202                      // movd          %xmm1,%edx
  .byte  102,15,112,241,229                  // pshufd        $0xe5,%xmm1,%xmm6
  .byte  243,15,16,12,145                    // movss         (%ecx,%edx,4),%xmm1
  .byte  102,15,126,242                      // movd          %xmm6,%edx
  .byte  243,15,16,52,145                    // movss         (%ecx,%edx,4),%xmm6
  .byte  15,20,229                           // unpcklps      %xmm5,%xmm4
  .byte  15,20,206                           // unpcklps      %xmm6,%xmm1
  .byte  102,15,20,204                       // unpcklpd      %xmm4,%xmm1
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_table_b_sse2
.globl _sk_table_b_sse2
FUNCTION(_sk_table_b_sse2)
_sk_table_b_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,81,4                            // mov           0x4(%ecx),%edx
  .byte  74                                  // dec           %edx
  .byte  102,15,110,226                      // movd          %edx,%xmm4
  .byte  232,0,0,0,0                         // call          371e <_sk_table_b_sse2+0x18>
  .byte  90                                  // pop           %edx
  .byte  139,9                               // mov           (%ecx),%ecx
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,95,234                           // maxps         %xmm2,%xmm5
  .byte  15,93,170,2,196,0,0                 // minps         0xc402(%edx),%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  102,15,91,213                       // cvtps2dq      %xmm5,%xmm2
  .byte  102,15,112,226,78                   // pshufd        $0x4e,%xmm2,%xmm4
  .byte  102,15,112,234,231                  // pshufd        $0xe7,%xmm2,%xmm5
  .byte  102,15,126,234                      // movd          %xmm5,%edx
  .byte  243,15,16,44,145                    // movss         (%ecx,%edx,4),%xmm5
  .byte  102,15,126,226                      // movd          %xmm4,%edx
  .byte  243,15,16,36,145                    // movss         (%ecx,%edx,4),%xmm4
  .byte  102,15,126,210                      // movd          %xmm2,%edx
  .byte  102,15,112,242,229                  // pshufd        $0xe5,%xmm2,%xmm6
  .byte  243,15,16,20,145                    // movss         (%ecx,%edx,4),%xmm2
  .byte  102,15,126,242                      // movd          %xmm6,%edx
  .byte  243,15,16,52,145                    // movss         (%ecx,%edx,4),%xmm6
  .byte  15,20,229                           // unpcklps      %xmm5,%xmm4
  .byte  15,20,214                           // unpcklps      %xmm6,%xmm2
  .byte  102,15,20,212                       // unpcklpd      %xmm4,%xmm2
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_table_a_sse2
.globl _sk_table_a_sse2
FUNCTION(_sk_table_a_sse2)
_sk_table_a_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,81,4                            // mov           0x4(%ecx),%edx
  .byte  74                                  // dec           %edx
  .byte  102,15,110,226                      // movd          %edx,%xmm4
  .byte  232,0,0,0,0                         // call          37a4 <_sk_table_a_sse2+0x18>
  .byte  90                                  // pop           %edx
  .byte  139,9                               // mov           (%ecx),%ecx
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,95,235                           // maxps         %xmm3,%xmm5
  .byte  15,93,170,124,195,0,0               // minps         0xc37c(%edx),%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  102,15,91,221                       // cvtps2dq      %xmm5,%xmm3
  .byte  102,15,112,227,78                   // pshufd        $0x4e,%xmm3,%xmm4
  .byte  102,15,112,235,231                  // pshufd        $0xe7,%xmm3,%xmm5
  .byte  102,15,126,234                      // movd          %xmm5,%edx
  .byte  243,15,16,44,145                    // movss         (%ecx,%edx,4),%xmm5
  .byte  102,15,126,226                      // movd          %xmm4,%edx
  .byte  243,15,16,36,145                    // movss         (%ecx,%edx,4),%xmm4
  .byte  102,15,126,218                      // movd          %xmm3,%edx
  .byte  102,15,112,243,229                  // pshufd        $0xe5,%xmm3,%xmm6
  .byte  243,15,16,28,145                    // movss         (%ecx,%edx,4),%xmm3
  .byte  102,15,126,242                      // movd          %xmm6,%edx
  .byte  243,15,16,52,145                    // movss         (%ecx,%edx,4),%xmm6
  .byte  15,20,229                           // unpcklps      %xmm5,%xmm4
  .byte  15,20,222                           // unpcklps      %xmm6,%xmm3
  .byte  102,15,20,220                       // unpcklpd      %xmm4,%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_parametric_r_sse2
.globl _sk_parametric_r_sse2
FUNCTION(_sk_parametric_r_sse2)
_sk_parametric_r_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,40                          // sub           $0x28,%esp
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  15,41,85,232                        // movaps        %xmm2,-0x18(%ebp)
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          382b <_sk_parametric_r_sse2+0x19>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,113,16                    // movss         0x10(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,81,12                     // movss         0xc(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  243,15,16,105,4                     // movss         0x4(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,89,233                           // mulps         %xmm1,%xmm5
  .byte  15,194,206,2                        // cmpleps       %xmm6,%xmm1
  .byte  243,15,16,113,24                    // movss         0x18(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  243,15,16,113,8                     // movss         0x8(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,88,238                           // addps         %xmm6,%xmm5
  .byte  15,91,245                           // cvtdq2ps      %xmm5,%xmm6
  .byte  15,89,178,133,197,0,0               // mulps         0xc585(%edx),%xmm6
  .byte  15,40,186,149,197,0,0               // movaps        0xc595(%edx),%xmm7
  .byte  15,84,253                           // andps         %xmm5,%xmm7
  .byte  15,86,186,229,194,0,0               // orps          0xc2e5(%edx),%xmm7
  .byte  15,88,178,165,197,0,0               // addps         0xc5a5(%edx),%xmm6
  .byte  15,40,162,181,197,0,0               // movaps        0xc5b5(%edx),%xmm4
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,92,244                           // subps         %xmm4,%xmm6
  .byte  15,88,186,197,197,0,0               // addps         0xc5c5(%edx),%xmm7
  .byte  15,40,162,213,197,0,0               // movaps        0xc5d5(%edx),%xmm4
  .byte  15,94,231                           // divps         %xmm7,%xmm4
  .byte  15,92,244                           // subps         %xmm4,%xmm6
  .byte  243,15,16,33                        // movss         (%ecx),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  243,15,91,230                       // cvttps2dq     %xmm6,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,194,196,1                        // cmpltps       %xmm4,%xmm0
  .byte  15,40,186,245,194,0,0               // movaps        0xc2f5(%edx),%xmm7
  .byte  15,84,199                           // andps         %xmm7,%xmm0
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,88,178,229,197,0,0               // addps         0xc5e5(%edx),%xmm6
  .byte  15,40,162,245,197,0,0               // movaps        0xc5f5(%edx),%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,92,244                           // subps         %xmm4,%xmm6
  .byte  15,40,162,5,198,0,0                 // movaps        0xc605(%edx),%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,40,130,21,198,0,0                // movaps        0xc615(%edx),%xmm0
  .byte  15,94,196                           // divps         %xmm4,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,89,130,37,198,0,0                // mulps         0xc625(%edx),%xmm0
  .byte  102,15,91,192                       // cvtps2dq      %xmm0,%xmm0
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,194,236,4                        // cmpneqps      %xmm4,%xmm5
  .byte  15,84,232                           // andps         %xmm0,%xmm5
  .byte  243,15,16,65,20                     // movss         0x14(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,84,209                           // andps         %xmm1,%xmm2
  .byte  15,85,200                           // andnps        %xmm0,%xmm1
  .byte  15,86,202                           // orps          %xmm2,%xmm1
  .byte  15,95,204                           // maxps         %xmm4,%xmm1
  .byte  15,93,207                           // minps         %xmm7,%xmm1
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,40,85,232                        // movaps        -0x18(%ebp),%xmm2
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,56                          // add           $0x38,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_parametric_g_sse2
.globl _sk_parametric_g_sse2
FUNCTION(_sk_parametric_g_sse2)
_sk_parametric_g_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,40                          // sub           $0x28,%esp
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  15,41,85,232                        // movaps        %xmm2,-0x18(%ebp)
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  232,0,0,0,0                         // call          396e <_sk_parametric_g_sse2+0x16>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,113,16                    // movss         0x10(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,81,12                     // movss         0xc(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  243,15,16,105,4                     // movss         0x4(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,89,233                           // mulps         %xmm1,%xmm5
  .byte  15,194,206,2                        // cmpleps       %xmm6,%xmm1
  .byte  243,15,16,113,24                    // movss         0x18(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  243,15,16,113,8                     // movss         0x8(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,88,238                           // addps         %xmm6,%xmm5
  .byte  15,91,245                           // cvtdq2ps      %xmm5,%xmm6
  .byte  15,89,178,66,196,0,0                // mulps         0xc442(%edx),%xmm6
  .byte  15,40,186,82,196,0,0                // movaps        0xc452(%edx),%xmm7
  .byte  15,84,253                           // andps         %xmm5,%xmm7
  .byte  15,86,186,162,193,0,0               // orps          0xc1a2(%edx),%xmm7
  .byte  15,88,178,98,196,0,0                // addps         0xc462(%edx),%xmm6
  .byte  15,40,162,114,196,0,0               // movaps        0xc472(%edx),%xmm4
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,92,244                           // subps         %xmm4,%xmm6
  .byte  15,88,186,130,196,0,0               // addps         0xc482(%edx),%xmm7
  .byte  15,40,162,146,196,0,0               // movaps        0xc492(%edx),%xmm4
  .byte  15,94,231                           // divps         %xmm7,%xmm4
  .byte  15,92,244                           // subps         %xmm4,%xmm6
  .byte  243,15,16,33                        // movss         (%ecx),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  243,15,91,230                       // cvttps2dq     %xmm6,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,194,196,1                        // cmpltps       %xmm4,%xmm0
  .byte  15,40,186,178,193,0,0               // movaps        0xc1b2(%edx),%xmm7
  .byte  15,84,199                           // andps         %xmm7,%xmm0
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,88,178,162,196,0,0               // addps         0xc4a2(%edx),%xmm6
  .byte  15,40,162,178,196,0,0               // movaps        0xc4b2(%edx),%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,92,244                           // subps         %xmm4,%xmm6
  .byte  15,40,162,194,196,0,0               // movaps        0xc4c2(%edx),%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,40,130,210,196,0,0               // movaps        0xc4d2(%edx),%xmm0
  .byte  15,94,196                           // divps         %xmm4,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,89,130,226,196,0,0               // mulps         0xc4e2(%edx),%xmm0
  .byte  102,15,91,192                       // cvtps2dq      %xmm0,%xmm0
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,194,236,4                        // cmpneqps      %xmm4,%xmm5
  .byte  15,84,232                           // andps         %xmm0,%xmm5
  .byte  243,15,16,65,20                     // movss         0x14(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,84,209                           // andps         %xmm1,%xmm2
  .byte  15,85,200                           // andnps        %xmm0,%xmm1
  .byte  15,86,202                           // orps          %xmm2,%xmm1
  .byte  15,95,204                           // maxps         %xmm4,%xmm1
  .byte  15,93,207                           // minps         %xmm7,%xmm1
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,40,85,232                        // movaps        -0x18(%ebp),%xmm2
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,56                          // add           $0x38,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_parametric_b_sse2
.globl _sk_parametric_b_sse2
FUNCTION(_sk_parametric_b_sse2)
_sk_parametric_b_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,40                          // sub           $0x28,%esp
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  15,41,77,232                        // movaps        %xmm1,-0x18(%ebp)
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  232,0,0,0,0                         // call          3aae <_sk_parametric_b_sse2+0x16>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,113,16                    // movss         0x10(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,73,12                     // movss         0xc(%ecx),%xmm1
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  243,15,16,105,4                     // movss         0x4(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,89,234                           // mulps         %xmm2,%xmm5
  .byte  15,194,214,2                        // cmpleps       %xmm6,%xmm2
  .byte  243,15,16,113,24                    // movss         0x18(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  243,15,16,113,8                     // movss         0x8(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,88,238                           // addps         %xmm6,%xmm5
  .byte  15,91,245                           // cvtdq2ps      %xmm5,%xmm6
  .byte  15,89,178,2,195,0,0                 // mulps         0xc302(%edx),%xmm6
  .byte  15,40,186,18,195,0,0                // movaps        0xc312(%edx),%xmm7
  .byte  15,84,253                           // andps         %xmm5,%xmm7
  .byte  15,86,186,98,192,0,0                // orps          0xc062(%edx),%xmm7
  .byte  15,88,178,34,195,0,0                // addps         0xc322(%edx),%xmm6
  .byte  15,40,162,50,195,0,0                // movaps        0xc332(%edx),%xmm4
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,92,244                           // subps         %xmm4,%xmm6
  .byte  15,88,186,66,195,0,0                // addps         0xc342(%edx),%xmm7
  .byte  15,40,162,82,195,0,0                // movaps        0xc352(%edx),%xmm4
  .byte  15,94,231                           // divps         %xmm7,%xmm4
  .byte  15,92,244                           // subps         %xmm4,%xmm6
  .byte  243,15,16,33                        // movss         (%ecx),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  243,15,91,230                       // cvttps2dq     %xmm6,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,194,196,1                        // cmpltps       %xmm4,%xmm0
  .byte  15,40,186,114,192,0,0               // movaps        0xc072(%edx),%xmm7
  .byte  15,84,199                           // andps         %xmm7,%xmm0
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,88,178,98,195,0,0                // addps         0xc362(%edx),%xmm6
  .byte  15,40,162,114,195,0,0               // movaps        0xc372(%edx),%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,92,244                           // subps         %xmm4,%xmm6
  .byte  15,40,162,130,195,0,0               // movaps        0xc382(%edx),%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,40,130,146,195,0,0               // movaps        0xc392(%edx),%xmm0
  .byte  15,94,196                           // divps         %xmm4,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,89,130,162,195,0,0               // mulps         0xc3a2(%edx),%xmm0
  .byte  102,15,91,192                       // cvtps2dq      %xmm0,%xmm0
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,194,236,4                        // cmpneqps      %xmm4,%xmm5
  .byte  15,84,232                           // andps         %xmm0,%xmm5
  .byte  243,15,16,65,20                     // movss         0x14(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,84,202                           // andps         %xmm2,%xmm1
  .byte  15,85,208                           // andnps        %xmm0,%xmm2
  .byte  15,86,209                           // orps          %xmm1,%xmm2
  .byte  15,95,212                           // maxps         %xmm4,%xmm2
  .byte  15,93,215                           // minps         %xmm7,%xmm2
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,40,77,232                        // movaps        -0x18(%ebp),%xmm1
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,56                          // add           $0x38,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_parametric_a_sse2
.globl _sk_parametric_a_sse2
FUNCTION(_sk_parametric_a_sse2)
_sk_parametric_a_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,40                          // sub           $0x28,%esp
  .byte  15,41,85,216                        // movaps        %xmm2,-0x28(%ebp)
  .byte  15,41,77,232                        // movaps        %xmm1,-0x18(%ebp)
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  232,0,0,0,0                         // call          3bee <_sk_parametric_a_sse2+0x16>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,113,16                    // movss         0x10(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,73,12                     // movss         0xc(%ecx),%xmm1
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  243,15,16,105,4                     // movss         0x4(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,89,235                           // mulps         %xmm3,%xmm5
  .byte  15,194,222,2                        // cmpleps       %xmm6,%xmm3
  .byte  243,15,16,113,24                    // movss         0x18(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  243,15,16,113,8                     // movss         0x8(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,88,238                           // addps         %xmm6,%xmm5
  .byte  15,91,245                           // cvtdq2ps      %xmm5,%xmm6
  .byte  15,89,178,194,193,0,0               // mulps         0xc1c2(%edx),%xmm6
  .byte  15,40,186,210,193,0,0               // movaps        0xc1d2(%edx),%xmm7
  .byte  15,84,253                           // andps         %xmm5,%xmm7
  .byte  15,86,186,34,191,0,0                // orps          0xbf22(%edx),%xmm7
  .byte  15,88,178,226,193,0,0               // addps         0xc1e2(%edx),%xmm6
  .byte  15,40,162,242,193,0,0               // movaps        0xc1f2(%edx),%xmm4
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,92,244                           // subps         %xmm4,%xmm6
  .byte  15,88,186,2,194,0,0                 // addps         0xc202(%edx),%xmm7
  .byte  15,40,162,18,194,0,0                // movaps        0xc212(%edx),%xmm4
  .byte  15,94,231                           // divps         %xmm7,%xmm4
  .byte  15,92,244                           // subps         %xmm4,%xmm6
  .byte  243,15,16,33                        // movss         (%ecx),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  243,15,91,230                       // cvttps2dq     %xmm6,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,194,196,1                        // cmpltps       %xmm4,%xmm0
  .byte  15,40,186,50,191,0,0                // movaps        0xbf32(%edx),%xmm7
  .byte  15,84,199                           // andps         %xmm7,%xmm0
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,88,178,34,194,0,0                // addps         0xc222(%edx),%xmm6
  .byte  15,40,162,50,194,0,0                // movaps        0xc232(%edx),%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,92,244                           // subps         %xmm4,%xmm6
  .byte  15,40,162,66,194,0,0                // movaps        0xc242(%edx),%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,40,130,82,194,0,0                // movaps        0xc252(%edx),%xmm0
  .byte  15,94,196                           // divps         %xmm4,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,89,130,98,194,0,0                // mulps         0xc262(%edx),%xmm0
  .byte  102,15,91,192                       // cvtps2dq      %xmm0,%xmm0
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,194,236,4                        // cmpneqps      %xmm4,%xmm5
  .byte  15,84,232                           // andps         %xmm0,%xmm5
  .byte  243,15,16,65,20                     // movss         0x14(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,84,203                           // andps         %xmm3,%xmm1
  .byte  15,85,216                           // andnps        %xmm0,%xmm3
  .byte  15,86,217                           // orps          %xmm1,%xmm3
  .byte  15,95,220                           // maxps         %xmm4,%xmm3
  .byte  15,93,223                           // minps         %xmm7,%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,40,77,232                        // movaps        -0x18(%ebp),%xmm1
  .byte  15,40,85,216                        // movaps        -0x28(%ebp),%xmm2
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,56                          // add           $0x38,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_gamma_sse2
.globl _sk_gamma_sse2
FUNCTION(_sk_gamma_sse2)
_sk_gamma_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,88                          // sub           $0x58,%esp
  .byte  15,41,93,168                        // movaps        %xmm3,-0x58(%ebp)
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  15,41,77,232                        // movaps        %xmm1,-0x18(%ebp)
  .byte  15,41,69,184                        // movaps        %xmm0,-0x48(%ebp)
  .byte  232,0,0,0,0                         // call          3d33 <_sk_gamma_sse2+0x1b>
  .byte  88                                  // pop           %eax
  .byte  15,91,232                           // cvtdq2ps      %xmm0,%xmm5
  .byte  15,89,168,125,192,0,0               // mulps         0xc07d(%eax),%xmm5
  .byte  15,40,160,141,192,0,0               // movaps        0xc08d(%eax),%xmm4
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,84,212                           // andps         %xmm4,%xmm2
  .byte  15,86,144,221,189,0,0               // orps          0xbddd(%eax),%xmm2
  .byte  15,88,168,157,192,0,0               // addps         0xc09d(%eax),%xmm5
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,89,136,173,192,0,0               // mulps         0xc0ad(%eax),%xmm1
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  15,88,144,189,192,0,0               // addps         0xc0bd(%eax),%xmm2
  .byte  15,40,136,205,192,0,0               // movaps        0xc0cd(%eax),%xmm1
  .byte  15,94,202                           // divps         %xmm2,%xmm1
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  243,15,16,2                         // movss         (%edx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,41,69,216                        // movaps        %xmm0,-0x28(%ebp)
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  243,15,91,197                       // cvttps2dq     %xmm5,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,194,200,1                        // cmpltps       %xmm0,%xmm1
  .byte  15,84,136,237,189,0,0               // andps         0xbded(%eax),%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,88,168,221,192,0,0               // addps         0xc0dd(%eax),%xmm5
  .byte  15,40,184,253,192,0,0               // movaps        0xc0fd(%eax),%xmm7
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,40,176,237,192,0,0               // movaps        0xc0ed(%eax),%xmm6
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  15,40,144,13,193,0,0                // movaps        0xc10d(%eax),%xmm2
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,94,216                           // divps         %xmm0,%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  15,40,77,232                        // movaps        -0x18(%ebp),%xmm1
  .byte  15,91,193                           // cvtdq2ps      %xmm1,%xmm0
  .byte  15,89,128,125,192,0,0               // mulps         0xc07d(%eax),%xmm0
  .byte  15,84,204                           // andps         %xmm4,%xmm1
  .byte  15,86,136,221,189,0,0               // orps          0xbddd(%eax),%xmm1
  .byte  15,88,128,157,192,0,0               // addps         0xc09d(%eax),%xmm0
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,89,168,173,192,0,0               // mulps         0xc0ad(%eax),%xmm5
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,88,136,189,192,0,0               // addps         0xc0bd(%eax),%xmm1
  .byte  15,40,168,205,192,0,0               // movaps        0xc0cd(%eax),%xmm5
  .byte  15,94,233                           // divps         %xmm1,%xmm5
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,89,69,216                        // mulps         -0x28(%ebp),%xmm0
  .byte  243,15,91,200                       // cvttps2dq     %xmm0,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  15,194,233,1                        // cmpltps       %xmm1,%xmm5
  .byte  15,84,168,237,189,0,0               // andps         0xbded(%eax),%xmm5
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  15,88,128,221,192,0,0               // addps         0xc0dd(%eax),%xmm0
  .byte  15,40,207                           // movaps        %xmm7,%xmm1
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  15,89,238                           // mulps         %xmm6,%xmm5
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,40,234                           // movaps        %xmm2,%xmm5
  .byte  15,94,233                           // divps         %xmm1,%xmm5
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  15,40,77,200                        // movaps        -0x38(%ebp),%xmm1
  .byte  15,91,193                           // cvtdq2ps      %xmm1,%xmm0
  .byte  15,89,128,125,192,0,0               // mulps         0xc07d(%eax),%xmm0
  .byte  15,84,225                           // andps         %xmm1,%xmm4
  .byte  15,86,160,221,189,0,0               // orps          0xbddd(%eax),%xmm4
  .byte  15,88,128,157,192,0,0               // addps         0xc09d(%eax),%xmm0
  .byte  15,40,136,173,192,0,0               // movaps        0xc0ad(%eax),%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,88,160,189,192,0,0               // addps         0xc0bd(%eax),%xmm4
  .byte  15,40,136,205,192,0,0               // movaps        0xc0cd(%eax),%xmm1
  .byte  15,94,204                           // divps         %xmm4,%xmm1
  .byte  15,92,193                           // subps         %xmm1,%xmm0
  .byte  15,89,69,216                        // mulps         -0x28(%ebp),%xmm0
  .byte  243,15,91,200                       // cvttps2dq     %xmm0,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,194,225,1                        // cmpltps       %xmm1,%xmm4
  .byte  15,84,160,237,189,0,0               // andps         0xbded(%eax),%xmm4
  .byte  15,92,204                           // subps         %xmm4,%xmm1
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,92,225                           // subps         %xmm1,%xmm4
  .byte  15,88,128,221,192,0,0               // addps         0xc0dd(%eax),%xmm0
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  15,92,198                           // subps         %xmm6,%xmm0
  .byte  15,92,252                           // subps         %xmm4,%xmm7
  .byte  15,94,215                           // divps         %xmm7,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  15,40,128,29,193,0,0                // movaps        0xc11d(%eax),%xmm0
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  102,15,91,203                       // cvtps2dq      %xmm3,%xmm1
  .byte  15,40,69,184                        // movaps        -0x48(%ebp),%xmm0
  .byte  15,194,196,4                        // cmpneqps      %xmm4,%xmm0
  .byte  15,84,193                           // andps         %xmm1,%xmm0
  .byte  102,15,91,205                       // cvtps2dq      %xmm5,%xmm1
  .byte  15,40,93,232                        // movaps        -0x18(%ebp),%xmm3
  .byte  15,194,220,4                        // cmpneqps      %xmm4,%xmm3
  .byte  15,84,217                           // andps         %xmm1,%xmm3
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,40,93,200                        // movaps        -0x38(%ebp),%xmm3
  .byte  15,194,220,4                        // cmpneqps      %xmm4,%xmm3
  .byte  102,15,91,210                       // cvtps2dq      %xmm2,%xmm2
  .byte  15,84,218                           // andps         %xmm2,%xmm3
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  141,65,8                            // lea           0x8(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,93,168                        // movaps        -0x58(%ebp),%xmm3
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,104                         // add           $0x68,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_gamma_dst_sse2
.globl _sk_gamma_dst_sse2
FUNCTION(_sk_gamma_dst_sse2)
_sk_gamma_dst_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  129,236,212,0,0,0                   // sub           $0xd4,%esp
  .byte  15,41,157,40,255,255,255            // movaps        %xmm3,-0xd8(%ebp)
  .byte  15,41,149,56,255,255,255            // movaps        %xmm2,-0xc8(%ebp)
  .byte  15,41,141,72,255,255,255            // movaps        %xmm1,-0xb8(%ebp)
  .byte  15,41,133,88,255,255,255            // movaps        %xmm0,-0xa8(%ebp)
  .byte  232,0,0,0,0                         // call          3f5a <_sk_gamma_dst_sse2+0x2b>
  .byte  94                                  // pop           %esi
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  15,40,72,16                         // movaps        0x10(%eax),%xmm1
  .byte  15,91,193                           // cvtdq2ps      %xmm1,%xmm0
  .byte  15,40,150,86,190,0,0                // movaps        0xbe56(%esi),%xmm2
  .byte  15,41,149,104,255,255,255           // movaps        %xmm2,-0x98(%ebp)
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,40,166,102,190,0,0               // movaps        0xbe66(%esi),%xmm4
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  15,84,212                           // andps         %xmm4,%xmm2
  .byte  15,40,158,182,187,0,0               // movaps        0xbbb6(%esi),%xmm3
  .byte  15,41,157,120,255,255,255           // movaps        %xmm3,-0x88(%ebp)
  .byte  15,86,211                           // orps          %xmm3,%xmm2
  .byte  15,40,158,118,190,0,0               // movaps        0xbe76(%esi),%xmm3
  .byte  15,41,93,136                        // movaps        %xmm3,-0x78(%ebp)
  .byte  15,88,195                           // addps         %xmm3,%xmm0
  .byte  15,40,174,134,190,0,0               // movaps        0xbe86(%esi),%xmm5
  .byte  15,41,109,152                       // movaps        %xmm5,-0x68(%ebp)
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,89,221                           // mulps         %xmm5,%xmm3
  .byte  15,92,195                           // subps         %xmm3,%xmm0
  .byte  15,40,158,150,190,0,0               // movaps        0xbe96(%esi),%xmm3
  .byte  15,41,93,168                        // movaps        %xmm3,-0x58(%ebp)
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  15,40,158,166,190,0,0               // movaps        0xbea6(%esi),%xmm3
  .byte  15,41,93,184                        // movaps        %xmm3,-0x48(%ebp)
  .byte  15,94,218                           // divps         %xmm2,%xmm3
  .byte  15,92,195                           // subps         %xmm3,%xmm0
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  243,15,16,18                        // movss         (%edx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  243,15,91,208                       // cvttps2dq     %xmm0,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  15,194,218,1                        // cmpltps       %xmm2,%xmm3
  .byte  15,40,174,198,187,0,0               // movaps        0xbbc6(%esi),%xmm5
  .byte  15,41,109,200                       // movaps        %xmm5,-0x38(%ebp)
  .byte  15,84,221                           // andps         %xmm5,%xmm3
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  15,92,218                           // subps         %xmm2,%xmm3
  .byte  15,40,150,182,190,0,0               // movaps        0xbeb6(%esi),%xmm2
  .byte  15,41,85,216                        // movaps        %xmm2,-0x28(%ebp)
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,40,190,214,190,0,0               // movaps        0xbed6(%esi),%xmm7
  .byte  15,40,239                           // movaps        %xmm7,%xmm5
  .byte  15,92,235                           // subps         %xmm3,%xmm5
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,40,182,198,190,0,0               // movaps        0xbec6(%esi),%xmm6
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,92,194                           // subps         %xmm2,%xmm0
  .byte  15,40,158,230,190,0,0               // movaps        0xbee6(%esi),%xmm3
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,94,213                           // divps         %xmm5,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  15,40,134,246,190,0,0               // movaps        0xbef6(%esi),%xmm0
  .byte  15,41,69,232                        // movaps        %xmm0,-0x18(%ebp)
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  102,15,91,194                       // cvtps2dq      %xmm2,%xmm0
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,194,202,4                        // cmpneqps      %xmm2,%xmm1
  .byte  15,84,200                           // andps         %xmm0,%xmm1
  .byte  15,40,64,32                         // movaps        0x20(%eax),%xmm0
  .byte  15,41,72,16                         // movaps        %xmm1,0x10(%eax)
  .byte  15,91,200                           // cvtdq2ps      %xmm0,%xmm1
  .byte  15,89,141,104,255,255,255           // mulps         -0x98(%ebp),%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,84,212                           // andps         %xmm4,%xmm2
  .byte  15,86,149,120,255,255,255           // orps          -0x88(%ebp),%xmm2
  .byte  15,88,77,136                        // addps         -0x78(%ebp),%xmm1
  .byte  15,40,234                           // movaps        %xmm2,%xmm5
  .byte  15,89,109,152                       // mulps         -0x68(%ebp),%xmm5
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  15,88,85,168                        // addps         -0x58(%ebp),%xmm2
  .byte  15,40,109,184                       // movaps        -0x48(%ebp),%xmm5
  .byte  15,94,234                           // divps         %xmm2,%xmm5
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  243,15,16,18                        // movss         (%edx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  243,15,91,209                       // cvttps2dq     %xmm1,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,194,234,1                        // cmpltps       %xmm2,%xmm5
  .byte  15,84,109,200                       // andps         -0x38(%ebp),%xmm5
  .byte  15,92,213                           // subps         %xmm5,%xmm2
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,92,234                           // subps         %xmm2,%xmm5
  .byte  15,88,77,216                        // addps         -0x28(%ebp),%xmm1
  .byte  15,40,215                           // movaps        %xmm7,%xmm2
  .byte  15,92,213                           // subps         %xmm5,%xmm2
  .byte  15,89,238                           // mulps         %xmm6,%xmm5
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  15,40,235                           // movaps        %xmm3,%xmm5
  .byte  15,94,234                           // divps         %xmm2,%xmm5
  .byte  15,88,233                           // addps         %xmm1,%xmm5
  .byte  15,89,109,232                       // mulps         -0x18(%ebp),%xmm5
  .byte  102,15,91,205                       // cvtps2dq      %xmm5,%xmm1
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,194,197,4                        // cmpneqps      %xmm5,%xmm0
  .byte  15,84,193                           // andps         %xmm1,%xmm0
  .byte  15,41,64,32                         // movaps        %xmm0,0x20(%eax)
  .byte  15,40,64,48                         // movaps        0x30(%eax),%xmm0
  .byte  15,91,200                           // cvtdq2ps      %xmm0,%xmm1
  .byte  15,89,141,104,255,255,255           // mulps         -0x98(%ebp),%xmm1
  .byte  15,84,224                           // andps         %xmm0,%xmm4
  .byte  15,86,165,120,255,255,255           // orps          -0x88(%ebp),%xmm4
  .byte  15,88,77,136                        // addps         -0x78(%ebp),%xmm1
  .byte  15,40,85,152                        // movaps        -0x68(%ebp),%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,92,202                           // subps         %xmm2,%xmm1
  .byte  15,88,101,168                       // addps         -0x58(%ebp),%xmm4
  .byte  15,40,85,184                        // movaps        -0x48(%ebp),%xmm2
  .byte  15,94,212                           // divps         %xmm4,%xmm2
  .byte  15,92,202                           // subps         %xmm2,%xmm1
  .byte  243,15,16,18                        // movss         (%edx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  243,15,91,209                       // cvttps2dq     %xmm1,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,194,226,1                        // cmpltps       %xmm2,%xmm4
  .byte  15,84,101,200                       // andps         -0x38(%ebp),%xmm4
  .byte  15,92,212                           // subps         %xmm4,%xmm2
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,92,226                           // subps         %xmm2,%xmm4
  .byte  15,88,77,216                        // addps         -0x28(%ebp),%xmm1
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  15,92,252                           // subps         %xmm4,%xmm7
  .byte  15,94,223                           // divps         %xmm7,%xmm3
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  15,89,93,232                        // mulps         -0x18(%ebp),%xmm3
  .byte  15,194,197,4                        // cmpneqps      %xmm5,%xmm0
  .byte  102,15,91,203                       // cvtps2dq      %xmm3,%xmm1
  .byte  15,84,193                           // andps         %xmm1,%xmm0
  .byte  15,41,64,48                         // movaps        %xmm0,0x30(%eax)
  .byte  141,81,8                            // lea           0x8(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,133,88,255,255,255            // movaps        -0xa8(%ebp),%xmm0
  .byte  15,40,141,72,255,255,255            // movaps        -0xb8(%ebp),%xmm1
  .byte  15,40,149,56,255,255,255            // movaps        -0xc8(%ebp),%xmm2
  .byte  15,40,157,40,255,255,255            // movaps        -0xd8(%ebp),%xmm3
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  129,196,228,0,0,0                   // add           $0xe4,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_lab_to_xyz_sse2
.globl _sk_lab_to_xyz_sse2
FUNCTION(_sk_lab_to_xyz_sse2)
_sk_lab_to_xyz_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,24                          // sub           $0x18,%esp
  .byte  15,41,93,232                        // movaps        %xmm3,-0x18(%ebp)
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  232,0,0,0,0                         // call          41b6 <_sk_lab_to_xyz_sse2+0x15>
  .byte  88                                  // pop           %eax
  .byte  15,89,144,170,188,0,0               // mulps         0xbcaa(%eax),%xmm2
  .byte  15,40,160,58,186,0,0                // movaps        0xba3a(%eax),%xmm4
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,40,168,186,188,0,0               // movaps        0xbcba(%eax),%xmm5
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  15,88,144,202,188,0,0               // addps         0xbcca(%eax),%xmm2
  .byte  15,89,144,218,188,0,0               // mulps         0xbcda(%eax),%xmm2
  .byte  15,89,136,234,188,0,0               // mulps         0xbcea(%eax),%xmm1
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  15,89,152,250,188,0,0               // mulps         0xbcfa(%eax),%xmm3
  .byte  15,40,234                           // movaps        %xmm2,%xmm5
  .byte  15,92,235                           // subps         %xmm3,%xmm5
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,40,152,10,189,0,0                // movaps        0xbd0a(%eax),%xmm3
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  15,194,224,1                        // cmpltps       %xmm0,%xmm4
  .byte  15,40,176,26,189,0,0                // movaps        0xbd1a(%eax),%xmm6
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,40,184,42,189,0,0                // movaps        0xbd2a(%eax),%xmm7
  .byte  15,89,207                           // mulps         %xmm7,%xmm1
  .byte  15,84,196                           // andps         %xmm4,%xmm0
  .byte  15,85,225                           // andnps        %xmm1,%xmm4
  .byte  15,86,224                           // orps          %xmm0,%xmm4
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,194,200,1                        // cmpltps       %xmm0,%xmm1
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,84,193                           // andps         %xmm1,%xmm0
  .byte  15,85,202                           // andnps        %xmm2,%xmm1
  .byte  15,86,200                           // orps          %xmm0,%xmm1
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,88,238                           // addps         %xmm6,%xmm5
  .byte  15,89,239                           // mulps         %xmm7,%xmm5
  .byte  15,194,216,1                        // cmpltps       %xmm0,%xmm3
  .byte  15,84,195                           // andps         %xmm3,%xmm0
  .byte  15,85,221                           // andnps        %xmm5,%xmm3
  .byte  15,86,216                           // orps          %xmm0,%xmm3
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  15,89,160,58,189,0,0                // mulps         0xbd3a(%eax),%xmm4
  .byte  15,89,152,74,189,0,0                // mulps         0xbd4a(%eax),%xmm3
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,40,93,232                        // movaps        -0x18(%ebp),%xmm3
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,40                          // add           $0x28,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_load_a8_sse2
.globl _sk_load_a8_sse2
FUNCTION(_sk_load_a8_sse2)
_sk_load_a8_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          42a6 <_sk_load_a8_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  117,60                              // jne           42fd <_sk_load_a8_sse2+0x65>
  .byte  102,15,110,4,62                     // movd          (%esi,%edi,1),%xmm0
  .byte  102,15,96,192                       // punpcklbw     %xmm0,%xmm0
  .byte  102,15,97,192                       // punpcklwd     %xmm0,%xmm0
  .byte  102,15,219,130,58,185,0,0           // pand          0xb93a(%edx),%xmm0
  .byte  15,91,216                           // cvtdq2ps      %xmm0,%xmm3
  .byte  15,89,154,122,186,0,0               // mulps         0xba7a(%edx),%xmm3
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  102,15,87,201                       // xorpd         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,50                              // je            4337 <_sk_load_a8_sse2+0x9f>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,19                              // je            4321 <_sk_load_a8_sse2+0x89>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,187                             // jne           42ce <_sk_load_a8_sse2+0x36>
  .byte  15,182,92,62,2                      // movzbl        0x2(%esi,%edi,1),%ebx
  .byte  102,15,110,195                      // movd          %ebx,%xmm0
  .byte  102,15,112,192,69                   // pshufd        $0x45,%xmm0,%xmm0
  .byte  15,183,52,62                        // movzwl        (%esi,%edi,1),%esi
  .byte  102,15,110,206                      // movd          %esi,%xmm1
  .byte  102,15,96,200                       // punpcklbw     %xmm0,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  242,15,16,193                       // movsd         %xmm1,%xmm0
  .byte  235,151                             // jmp           42ce <_sk_load_a8_sse2+0x36>
  .byte  15,182,52,62                        // movzbl        (%esi,%edi,1),%esi
  .byte  102,15,110,198                      // movd          %esi,%xmm0
  .byte  235,141                             // jmp           42ce <_sk_load_a8_sse2+0x36>

HIDDEN _sk_load_a8_dst_sse2
.globl _sk_load_a8_dst_sse2
FUNCTION(_sk_load_a8_dst_sse2)
_sk_load_a8_dst_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,16                              // mov           (%eax),%edx
  .byte  139,49                              // mov           (%ecx),%esi
  .byte  139,122,4                           // mov           0x4(%edx),%edi
  .byte  15,175,121,4                        // imul          0x4(%ecx),%edi
  .byte  3,58                                // add           (%edx),%edi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,127,97,48                    // movdqa        %xmm4,0x30(%ecx)
  .byte  102,15,127,97,32                    // movdqa        %xmm4,0x20(%ecx)
  .byte  102,15,127,97,16                    // movdqa        %xmm4,0x10(%ecx)
  .byte  133,219                             // test          %ebx,%ebx
  .byte  232,0,0,0,0                         // call          437a <_sk_load_a8_dst_sse2+0x39>
  .byte  90                                  // pop           %edx
  .byte  117,54                              // jne           43b3 <_sk_load_a8_dst_sse2+0x72>
  .byte  102,15,110,36,55                    // movd          (%edi,%esi,1),%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  102,15,97,224                       // punpcklwd     %xmm0,%xmm4
  .byte  102,15,219,162,102,184,0,0          // pand          0xb866(%edx),%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,162,166,185,0,0               // mulps         0xb9a6(%edx),%xmm4
  .byte  15,41,97,64                         // movaps        %xmm4,0x40(%ecx)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,46                              // je            43e9 <_sk_load_a8_dst_sse2+0xa8>
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,19                              // je            43d3 <_sk_load_a8_dst_sse2+0x92>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,197                             // jne           438a <_sk_load_a8_dst_sse2+0x49>
  .byte  15,182,92,55,2                      // movzbl        0x2(%edi,%esi,1),%ebx
  .byte  102,15,110,227                      // movd          %ebx,%xmm4
  .byte  102,15,112,228,69                   // pshufd        $0x45,%xmm4,%xmm4
  .byte  15,183,52,55                        // movzwl        (%edi,%esi,1),%esi
  .byte  102,15,110,238                      // movd          %esi,%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  102,15,97,232                       // punpcklwd     %xmm0,%xmm5
  .byte  242,15,16,229                       // movsd         %xmm5,%xmm4
  .byte  235,161                             // jmp           438a <_sk_load_a8_dst_sse2+0x49>
  .byte  15,182,52,55                        // movzbl        (%edi,%esi,1),%esi
  .byte  102,15,110,230                      // movd          %esi,%xmm4
  .byte  235,151                             // jmp           438a <_sk_load_a8_dst_sse2+0x49>

HIDDEN _sk_gather_a8_sse2
.globl _sk_gather_a8_sse2
FUNCTION(_sk_gather_a8_sse2)
_sk_gather_a8_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,81,8                      // movss         0x8(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,15,118,219                      // pcmpeqd       %xmm3,%xmm3
  .byte  102,15,254,211                      // paddd         %xmm3,%xmm2
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,224                           // maxps         %xmm0,%xmm4
  .byte  15,93,226                           // minps         %xmm2,%xmm4
  .byte  243,15,16,65,12                     // movss         0xc(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,95,209                           // maxps         %xmm1,%xmm2
  .byte  15,93,208                           // minps         %xmm0,%xmm2
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  243,15,91,194                       // cvttps2dq     %xmm2,%xmm0
  .byte  102,15,110,73,4                     // movd          0x4(%ecx),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,208,245                  // pshufd        $0xf5,%xmm0,%xmm2
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,202,232                  // pshufd        $0xe8,%xmm2,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,15,91,204                       // cvttps2dq     %xmm4,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  102,15,112,193,229                  // pshufd        $0xe5,%xmm1,%xmm0
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,15,126,214                      // movd          %xmm2,%esi
  .byte  102,15,112,201,231                  // pshufd        $0xe7,%xmm1,%xmm1
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  15,182,52,50                        // movzbl        (%edx,%esi,1),%esi
  .byte  15,182,60,58                        // movzbl        (%edx,%edi,1),%edi
  .byte  193,231,8                           // shl           $0x8,%edi
  .byte  9,247                               // or            %esi,%edi
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  15,182,12,10                        // movzbl        (%edx,%ecx,1),%ecx
  .byte  15,182,20,50                        // movzbl        (%edx,%esi,1),%edx
  .byte  193,226,8                           // shl           $0x8,%edx
  .byte  9,202                               // or            %ecx,%edx
  .byte  102,15,110,194                      // movd          %edx,%xmm0
  .byte  102,15,196,199,1                    // pinsrw        $0x1,%edi,%xmm0
  .byte  232,0,0,0,0                         // call          44a7 <_sk_gather_a8_sse2+0xb4>
  .byte  89                                  // pop           %ecx
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,15,96,193                       // punpcklbw     %xmm1,%xmm0
  .byte  102,15,97,193                       // punpcklwd     %xmm1,%xmm0
  .byte  15,91,216                           // cvtdq2ps      %xmm0,%xmm3
  .byte  15,89,153,121,184,0,0               // mulps         0xb879(%ecx),%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,16                          // add           $0x10,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_store_a8_sse2
.globl _sk_store_a8_sse2
FUNCTION(_sk_store_a8_sse2)
_sk_store_a8_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          44eb <_sk_store_a8_sse2+0xe>
  .byte  94                                  // pop           %esi
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,87,4                            // mov           0x4(%edi),%edx
  .byte  15,175,81,4                         // imul          0x4(%ecx),%edx
  .byte  3,23                                // add           (%edi),%edx
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,227                           // maxps         %xmm3,%xmm4
  .byte  15,93,166,53,182,0,0                // minps         0xb635(%esi),%xmm4
  .byte  15,89,166,5,183,0,0                 // mulps         0xb705(%esi),%xmm4
  .byte  102,15,91,228                       // cvtps2dq      %xmm4,%xmm4
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,107,224                      // packssdw      %xmm0,%xmm4
  .byte  102,15,103,224                      // packuswb      %xmm0,%xmm4
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  117,26                              // jne           454a <_sk_store_a8_sse2+0x6d>
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  137,52,58                           // mov           %esi,(%edx,%edi,1)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  102,15,97,224                       // punpcklwd     %xmm0,%xmm4
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,54                              // je            4590 <_sk_store_a8_sse2+0xb3>
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,14                              // je            456d <_sk_store_a8_sse2+0x90>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,211                             // jne           4537 <_sk_store_a8_sse2+0x5a>
  .byte  102,15,197,220,4                    // pextrw        $0x4,%xmm4,%ebx
  .byte  136,92,58,2                         // mov           %bl,0x2(%edx,%edi,1)
  .byte  102,15,112,228,212                  // pshufd        $0xd4,%xmm4,%xmm4
  .byte  102,15,219,166,37,186,0,0           // pand          0xba25(%esi),%xmm4
  .byte  102,15,103,228                      // packuswb      %xmm4,%xmm4
  .byte  102,15,103,228                      // packuswb      %xmm4,%xmm4
  .byte  102,15,103,228                      // packuswb      %xmm4,%xmm4
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  102,137,52,58                       // mov           %si,(%edx,%edi,1)
  .byte  235,167                             // jmp           4537 <_sk_store_a8_sse2+0x5a>
  .byte  102,15,126,227                      // movd          %xmm4,%ebx
  .byte  136,28,58                           // mov           %bl,(%edx,%edi,1)
  .byte  235,158                             // jmp           4537 <_sk_store_a8_sse2+0x5a>

HIDDEN _sk_load_g8_sse2
.globl _sk_load_g8_sse2
FUNCTION(_sk_load_g8_sse2)
_sk_load_g8_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          45a7 <_sk_load_g8_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  117,63                              // jne           4601 <_sk_load_g8_sse2+0x68>
  .byte  102,15,110,4,62                     // movd          (%esi,%edi,1),%xmm0
  .byte  102,15,96,192                       // punpcklbw     %xmm0,%xmm0
  .byte  102,15,97,192                       // punpcklwd     %xmm0,%xmm0
  .byte  102,15,219,130,57,182,0,0           // pand          0xb639(%edx),%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,130,121,183,0,0               // mulps         0xb779(%edx),%xmm0
  .byte  141,112,8                           // lea           0x8(%eax),%esi
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,154,121,181,0,0               // movaps        0xb579(%edx),%xmm3
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  86                                  // push          %esi
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,50                              // je            463b <_sk_load_g8_sse2+0xa2>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,19                              // je            4625 <_sk_load_g8_sse2+0x8c>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,184                             // jne           45cf <_sk_load_g8_sse2+0x36>
  .byte  15,182,92,62,2                      // movzbl        0x2(%esi,%edi,1),%ebx
  .byte  102,15,110,195                      // movd          %ebx,%xmm0
  .byte  102,15,112,192,69                   // pshufd        $0x45,%xmm0,%xmm0
  .byte  15,183,52,62                        // movzwl        (%esi,%edi,1),%esi
  .byte  102,15,110,206                      // movd          %esi,%xmm1
  .byte  102,15,96,200                       // punpcklbw     %xmm0,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  242,15,16,193                       // movsd         %xmm1,%xmm0
  .byte  235,148                             // jmp           45cf <_sk_load_g8_sse2+0x36>
  .byte  15,182,52,62                        // movzbl        (%esi,%edi,1),%esi
  .byte  102,15,110,198                      // movd          %esi,%xmm0
  .byte  235,138                             // jmp           45cf <_sk_load_g8_sse2+0x36>

HIDDEN _sk_load_g8_dst_sse2
.globl _sk_load_g8_dst_sse2
FUNCTION(_sk_load_g8_dst_sse2)
_sk_load_g8_dst_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          4653 <_sk_load_g8_dst_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  117,73                              // jne           46b7 <_sk_load_g8_dst_sse2+0x72>
  .byte  102,15,110,36,62                    // movd          (%esi,%edi,1),%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  102,15,97,224                       // punpcklwd     %xmm0,%xmm4
  .byte  102,15,219,162,141,181,0,0          // pand          0xb58d(%edx),%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,162,205,182,0,0               // mulps         0xb6cd(%edx),%xmm4
  .byte  15,41,97,48                         // movaps        %xmm4,0x30(%ecx)
  .byte  15,41,97,32                         // movaps        %xmm4,0x20(%ecx)
  .byte  15,41,97,16                         // movaps        %xmm4,0x10(%ecx)
  .byte  15,40,162,205,180,0,0               // movaps        0xb4cd(%edx),%xmm4
  .byte  15,41,97,64                         // movaps        %xmm4,0x40(%ecx)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,50                              // je            46f1 <_sk_load_g8_dst_sse2+0xac>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,19                              // je            46db <_sk_load_g8_dst_sse2+0x96>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,174                             // jne           467b <_sk_load_g8_dst_sse2+0x36>
  .byte  15,182,92,62,2                      // movzbl        0x2(%esi,%edi,1),%ebx
  .byte  102,15,110,227                      // movd          %ebx,%xmm4
  .byte  102,15,112,228,69                   // pshufd        $0x45,%xmm4,%xmm4
  .byte  15,183,52,62                        // movzwl        (%esi,%edi,1),%esi
  .byte  102,15,110,238                      // movd          %esi,%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  102,15,97,232                       // punpcklwd     %xmm0,%xmm5
  .byte  242,15,16,229                       // movsd         %xmm5,%xmm4
  .byte  235,138                             // jmp           467b <_sk_load_g8_dst_sse2+0x36>
  .byte  15,182,52,62                        // movzbl        (%esi,%edi,1),%esi
  .byte  102,15,110,230                      // movd          %esi,%xmm4
  .byte  235,128                             // jmp           467b <_sk_load_g8_dst_sse2+0x36>

HIDDEN _sk_gather_g8_sse2
.globl _sk_gather_g8_sse2
FUNCTION(_sk_gather_g8_sse2)
_sk_gather_g8_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,81,8                      // movss         0x8(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,15,118,219                      // pcmpeqd       %xmm3,%xmm3
  .byte  102,15,254,211                      // paddd         %xmm3,%xmm2
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,224                           // maxps         %xmm0,%xmm4
  .byte  15,93,226                           // minps         %xmm2,%xmm4
  .byte  243,15,16,65,12                     // movss         0xc(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,95,209                           // maxps         %xmm1,%xmm2
  .byte  15,93,208                           // minps         %xmm0,%xmm2
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  243,15,91,194                       // cvttps2dq     %xmm2,%xmm0
  .byte  102,15,110,73,4                     // movd          0x4(%ecx),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,208,245                  // pshufd        $0xf5,%xmm0,%xmm2
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,202,232                  // pshufd        $0xe8,%xmm2,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,15,91,204                       // cvttps2dq     %xmm4,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  102,15,112,193,229                  // pshufd        $0xe5,%xmm1,%xmm0
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,15,126,214                      // movd          %xmm2,%esi
  .byte  102,15,112,201,231                  // pshufd        $0xe7,%xmm1,%xmm1
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  15,182,52,50                        // movzbl        (%edx,%esi,1),%esi
  .byte  15,182,60,58                        // movzbl        (%edx,%edi,1),%edi
  .byte  193,231,8                           // shl           $0x8,%edi
  .byte  9,247                               // or            %esi,%edi
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  15,182,12,10                        // movzbl        (%edx,%ecx,1),%ecx
  .byte  15,182,20,50                        // movzbl        (%edx,%esi,1),%edx
  .byte  193,226,8                           // shl           $0x8,%edx
  .byte  9,202                               // or            %ecx,%edx
  .byte  102,15,110,194                      // movd          %edx,%xmm0
  .byte  232,0,0,0,0                         // call          47aa <_sk_gather_g8_sse2+0xaf>
  .byte  89                                  // pop           %ecx
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  102,15,196,199,1                    // pinsrw        $0x1,%edi,%xmm0
  .byte  102,15,96,193                       // punpcklbw     %xmm1,%xmm0
  .byte  102,15,97,193                       // punpcklwd     %xmm1,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,129,118,181,0,0               // mulps         0xb576(%ecx),%xmm0
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,153,118,179,0,0               // movaps        0xb376(%ecx),%xmm3
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  82                                  // push          %edx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,16                          // add           $0x10,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_load_565_sse2
.globl _sk_load_565_sse2
FUNCTION(_sk_load_565_sse2)
_sk_load_565_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          47f5 <_sk_load_565_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  1,246                               // add           %esi,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  117,97                              // jne           4873 <_sk_load_565_sse2+0x8c>
  .byte  243,15,126,20,126                   // movq          (%esi,%edi,2),%xmm2
  .byte  102,15,97,208                       // punpcklwd     %xmm0,%xmm2
  .byte  102,15,111,130,59,181,0,0           // movdqa        0xb53b(%edx),%xmm0
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,130,75,181,0,0                // mulps         0xb54b(%edx),%xmm0
  .byte  102,15,111,138,91,181,0,0           // movdqa        0xb55b(%edx),%xmm1
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,138,107,181,0,0               // mulps         0xb56b(%edx),%xmm1
  .byte  102,15,219,146,123,181,0,0          // pand          0xb57b(%edx),%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,146,139,181,0,0               // mulps         0xb58b(%edx),%xmm2
  .byte  141,112,8                           // lea           0x8(%eax),%esi
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,154,43,179,0,0                // movaps        0xb32b(%edx),%xmm3
  .byte  86                                  // push          %esi
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,47                              // je            48aa <_sk_load_565_sse2+0xc3>
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,19                              // je            4897 <_sk_load_565_sse2+0xb0>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,146                             // jne           481b <_sk_load_565_sse2+0x34>
  .byte  15,183,92,126,4                     // movzwl        0x4(%esi,%edi,2),%ebx
  .byte  102,15,110,195                      // movd          %ebx,%xmm0
  .byte  102,15,112,208,69                   // pshufd        $0x45,%xmm0,%xmm2
  .byte  102,15,110,4,126                    // movd          (%esi,%edi,2),%xmm0
  .byte  242,15,112,192,212                  // pshuflw       $0xd4,%xmm0,%xmm0
  .byte  242,15,16,208                       // movsd         %xmm0,%xmm2
  .byte  233,113,255,255,255                 // jmp           481b <_sk_load_565_sse2+0x34>
  .byte  15,183,52,126                       // movzwl        (%esi,%edi,2),%esi
  .byte  102,15,110,214                      // movd          %esi,%xmm2
  .byte  233,100,255,255,255                 // jmp           481b <_sk_load_565_sse2+0x34>

HIDDEN _sk_load_565_dst_sse2
.globl _sk_load_565_dst_sse2
FUNCTION(_sk_load_565_dst_sse2)
_sk_load_565_dst_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          48c5 <_sk_load_565_dst_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  1,246                               // add           %esi,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  117,113                             // jne           4953 <_sk_load_565_dst_sse2+0x9c>
  .byte  243,15,126,36,126                   // movq          (%esi,%edi,2),%xmm4
  .byte  102,15,97,224                       // punpcklwd     %xmm0,%xmm4
  .byte  102,15,111,170,107,180,0,0          // movdqa        0xb46b(%edx),%xmm5
  .byte  102,15,219,236                      // pand          %xmm4,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  15,89,170,123,180,0,0               // mulps         0xb47b(%edx),%xmm5
  .byte  15,41,105,16                        // movaps        %xmm5,0x10(%ecx)
  .byte  102,15,111,170,139,180,0,0          // movdqa        0xb48b(%edx),%xmm5
  .byte  102,15,219,236                      // pand          %xmm4,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  15,89,170,155,180,0,0               // mulps         0xb49b(%edx),%xmm5
  .byte  15,41,105,32                        // movaps        %xmm5,0x20(%ecx)
  .byte  102,15,219,162,171,180,0,0          // pand          0xb4ab(%edx),%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,162,187,180,0,0               // mulps         0xb4bb(%edx),%xmm4
  .byte  15,41,97,48                         // movaps        %xmm4,0x30(%ecx)
  .byte  15,40,162,91,178,0,0                // movaps        0xb25b(%edx),%xmm4
  .byte  15,41,97,64                         // movaps        %xmm4,0x40(%ecx)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,47                              // je            498a <_sk_load_565_dst_sse2+0xd3>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,19                              // je            4977 <_sk_load_565_dst_sse2+0xc0>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,130                             // jne           48eb <_sk_load_565_dst_sse2+0x34>
  .byte  15,183,92,126,4                     // movzwl        0x4(%esi,%edi,2),%ebx
  .byte  102,15,110,227                      // movd          %ebx,%xmm4
  .byte  102,15,112,228,69                   // pshufd        $0x45,%xmm4,%xmm4
  .byte  102,15,110,44,126                   // movd          (%esi,%edi,2),%xmm5
  .byte  242,15,112,237,212                  // pshuflw       $0xd4,%xmm5,%xmm5
  .byte  242,15,16,229                       // movsd         %xmm5,%xmm4
  .byte  233,97,255,255,255                  // jmp           48eb <_sk_load_565_dst_sse2+0x34>
  .byte  15,183,52,126                       // movzwl        (%esi,%edi,2),%esi
  .byte  102,15,110,230                      // movd          %esi,%xmm4
  .byte  233,84,255,255,255                  // jmp           48eb <_sk_load_565_dst_sse2+0x34>

HIDDEN _sk_gather_565_sse2
.globl _sk_gather_565_sse2
FUNCTION(_sk_gather_565_sse2)
_sk_gather_565_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,81,8                      // movss         0x8(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,15,118,219                      // pcmpeqd       %xmm3,%xmm3
  .byte  102,15,254,211                      // paddd         %xmm3,%xmm2
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,224                           // maxps         %xmm0,%xmm4
  .byte  15,93,226                           // minps         %xmm2,%xmm4
  .byte  243,15,16,65,12                     // movss         0xc(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,95,209                           // maxps         %xmm1,%xmm2
  .byte  15,93,208                           // minps         %xmm0,%xmm2
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  243,15,91,194                       // cvttps2dq     %xmm2,%xmm0
  .byte  102,15,110,73,4                     // movd          0x4(%ecx),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,208,245                  // pshufd        $0xf5,%xmm0,%xmm2
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,202,232                  // pshufd        $0xe8,%xmm2,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,15,91,204                       // cvttps2dq     %xmm4,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  102,15,112,193,229                  // pshufd        $0xe5,%xmm1,%xmm0
  .byte  15,183,12,74                        // movzwl        (%edx,%ecx,2),%ecx
  .byte  102,15,110,209                      // movd          %ecx,%xmm2
  .byte  102,15,126,193                      // movd          %xmm0,%ecx
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  15,183,12,74                        // movzwl        (%edx,%ecx,2),%ecx
  .byte  102,15,196,209,1                    // pinsrw        $0x1,%ecx,%xmm2
  .byte  102,15,126,193                      // movd          %xmm0,%ecx
  .byte  102,15,112,193,231                  // pshufd        $0xe7,%xmm1,%xmm0
  .byte  15,183,12,74                        // movzwl        (%edx,%ecx,2),%ecx
  .byte  102,15,196,209,2                    // pinsrw        $0x2,%ecx,%xmm2
  .byte  102,15,126,193                      // movd          %xmm0,%ecx
  .byte  15,183,12,74                        // movzwl        (%edx,%ecx,2),%ecx
  .byte  232,0,0,0,0                         // call          4a47 <_sk_gather_565_sse2+0xb0>
  .byte  90                                  // pop           %edx
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,196,209,3                    // pinsrw        $0x3,%ecx,%xmm2
  .byte  102,15,97,208                       // punpcklwd     %xmm0,%xmm2
  .byte  102,15,111,130,233,178,0,0          // movdqa        0xb2e9(%edx),%xmm0
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,130,249,178,0,0               // mulps         0xb2f9(%edx),%xmm0
  .byte  102,15,111,138,9,179,0,0            // movdqa        0xb309(%edx),%xmm1
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,138,25,179,0,0                // mulps         0xb319(%edx),%xmm1
  .byte  102,15,219,146,41,179,0,0           // pand          0xb329(%edx),%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,146,57,179,0,0                // mulps         0xb339(%edx),%xmm2
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,154,217,176,0,0               // movaps        0xb0d9(%edx),%xmm3
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_store_565_sse2
.globl _sk_store_565_sse2
FUNCTION(_sk_store_565_sse2)
_sk_store_565_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          4aba <_sk_store_565_sse2+0xe>
  .byte  94                                  // pop           %esi
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,95,232                           // maxps         %xmm0,%xmm5
  .byte  15,40,182,102,176,0,0               // movaps        0xb066(%esi),%xmm6
  .byte  15,93,238                           // minps         %xmm6,%xmm5
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  15,95,249                           // maxps         %xmm1,%xmm7
  .byte  15,93,254                           // minps         %xmm6,%xmm7
  .byte  15,95,226                           // maxps         %xmm2,%xmm4
  .byte  15,93,230                           // minps         %xmm6,%xmm4
  .byte  15,40,182,102,180,0,0               // movaps        0xb466(%esi),%xmm6
  .byte  15,89,238                           // mulps         %xmm6,%xmm5
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  102,15,91,237                       // cvtps2dq      %xmm5,%xmm5
  .byte  102,15,114,245,11                   // pslld         $0xb,%xmm5
  .byte  102,15,91,228                       // cvtps2dq      %xmm4,%xmm4
  .byte  102,15,86,229                       // orpd          %xmm5,%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,87,4                            // mov           0x4(%edi),%edx
  .byte  15,175,81,4                         // imul          0x4(%ecx),%edx
  .byte  1,210                               // add           %edx,%edx
  .byte  3,23                                // add           (%edi),%edx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  15,89,190,118,180,0,0               // mulps         0xb476(%esi),%xmm7
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  102,15,91,239                       // cvtps2dq      %xmm7,%xmm5
  .byte  102,15,114,245,5                    // pslld         $0x5,%xmm5
  .byte  102,15,86,229                       // orpd          %xmm5,%xmm4
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,107,224                      // packssdw      %xmm0,%xmm4
  .byte  102,15,126,101,232                  // movd          %xmm4,-0x18(%ebp)
  .byte  102,15,112,236,229                  // pshufd        $0xe5,%xmm4,%xmm5
  .byte  102,15,126,109,236                  // movd          %xmm5,-0x14(%ebp)
  .byte  133,219                             // test          %ebx,%ebx
  .byte  117,34                              // jne           4b6a <_sk_store_565_sse2+0xbe>
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  102,15,126,235                      // movd          %xmm5,%ebx
  .byte  137,52,122                          // mov           %esi,(%edx,%edi,2)
  .byte  137,92,122,4                        // mov           %ebx,0x4(%edx,%edi,2)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  243,15,126,101,232                  // movq          -0x18(%ebp),%xmm4
  .byte  102,15,97,224                       // punpcklwd     %xmm0,%xmm4
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,37                              // je            4ba0 <_sk_store_565_sse2+0xf4>
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,15                              // je            4b8f <_sk_store_565_sse2+0xe3>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,210                             // jne           4b57 <_sk_store_565_sse2+0xab>
  .byte  102,15,197,244,4                    // pextrw        $0x4,%xmm4,%esi
  .byte  102,137,116,122,4                   // mov           %si,0x4(%edx,%edi,2)
  .byte  102,15,112,228,212                  // pshufd        $0xd4,%xmm4,%xmm4
  .byte  242,15,112,228,232                  // pshuflw       $0xe8,%xmm4,%xmm4
  .byte  102,15,126,36,122                   // movd          %xmm4,(%edx,%edi,2)
  .byte  235,183                             // jmp           4b57 <_sk_store_565_sse2+0xab>
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  102,137,52,122                      // mov           %si,(%edx,%edi,2)
  .byte  235,173                             // jmp           4b57 <_sk_store_565_sse2+0xab>

HIDDEN _sk_load_4444_sse2
.globl _sk_load_4444_sse2
FUNCTION(_sk_load_4444_sse2)
_sk_load_4444_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          4bb8 <_sk_load_4444_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  1,246                               // add           %esi,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  117,112                             // jne           4c45 <_sk_load_4444_sse2+0x9b>
  .byte  243,15,126,28,126                   // movq          (%esi,%edi,2),%xmm3
  .byte  102,15,97,216                       // punpcklwd     %xmm0,%xmm3
  .byte  102,15,111,130,136,179,0,0          // movdqa        0xb388(%edx),%xmm0
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,130,152,179,0,0               // mulps         0xb398(%edx),%xmm0
  .byte  102,15,111,138,168,179,0,0          // movdqa        0xb3a8(%edx),%xmm1
  .byte  102,15,219,203                      // pand          %xmm3,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,138,184,179,0,0               // mulps         0xb3b8(%edx),%xmm1
  .byte  102,15,111,146,200,179,0,0          // movdqa        0xb3c8(%edx),%xmm2
  .byte  102,15,219,211                      // pand          %xmm3,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,146,216,179,0,0               // mulps         0xb3d8(%edx),%xmm2
  .byte  102,15,219,154,232,179,0,0          // pand          0xb3e8(%edx),%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,154,248,179,0,0               // mulps         0xb3f8(%edx),%xmm3
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,47                              // je            4c7c <_sk_load_4444_sse2+0xd2>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,19                              // je            4c69 <_sk_load_4444_sse2+0xbf>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,131                             // jne           4bde <_sk_load_4444_sse2+0x34>
  .byte  15,183,92,126,4                     // movzwl        0x4(%esi,%edi,2),%ebx
  .byte  102,15,110,195                      // movd          %ebx,%xmm0
  .byte  102,15,112,216,69                   // pshufd        $0x45,%xmm0,%xmm3
  .byte  102,15,110,4,126                    // movd          (%esi,%edi,2),%xmm0
  .byte  242,15,112,192,212                  // pshuflw       $0xd4,%xmm0,%xmm0
  .byte  242,15,16,216                       // movsd         %xmm0,%xmm3
  .byte  233,98,255,255,255                  // jmp           4bde <_sk_load_4444_sse2+0x34>
  .byte  15,183,52,126                       // movzwl        (%esi,%edi,2),%esi
  .byte  102,15,110,222                      // movd          %esi,%xmm3
  .byte  233,85,255,255,255                  // jmp           4bde <_sk_load_4444_sse2+0x34>

HIDDEN _sk_load_4444_dst_sse2
.globl _sk_load_4444_dst_sse2
FUNCTION(_sk_load_4444_dst_sse2)
_sk_load_4444_dst_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          4c97 <_sk_load_4444_dst_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  1,246                               // add           %esi,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  15,133,128,0,0,0                    // jne           4d38 <_sk_load_4444_dst_sse2+0xaf>
  .byte  243,15,126,36,126                   // movq          (%esi,%edi,2),%xmm4
  .byte  102,15,97,224                       // punpcklwd     %xmm0,%xmm4
  .byte  102,15,111,170,169,178,0,0          // movdqa        0xb2a9(%edx),%xmm5
  .byte  102,15,219,236                      // pand          %xmm4,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  15,89,170,185,178,0,0               // mulps         0xb2b9(%edx),%xmm5
  .byte  15,41,105,16                        // movaps        %xmm5,0x10(%ecx)
  .byte  102,15,111,170,201,178,0,0          // movdqa        0xb2c9(%edx),%xmm5
  .byte  102,15,219,236                      // pand          %xmm4,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  15,89,170,217,178,0,0               // mulps         0xb2d9(%edx),%xmm5
  .byte  15,41,105,32                        // movaps        %xmm5,0x20(%ecx)
  .byte  102,15,111,170,233,178,0,0          // movdqa        0xb2e9(%edx),%xmm5
  .byte  102,15,219,236                      // pand          %xmm4,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  15,89,170,249,178,0,0               // mulps         0xb2f9(%edx),%xmm5
  .byte  15,41,105,48                        // movaps        %xmm5,0x30(%ecx)
  .byte  102,15,219,162,9,179,0,0            // pand          0xb309(%edx),%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,162,25,179,0,0                // mulps         0xb319(%edx),%xmm4
  .byte  15,41,97,64                         // movaps        %xmm4,0x40(%ecx)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,51                              // je            4d73 <_sk_load_4444_dst_sse2+0xea>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,23                              // je            4d60 <_sk_load_4444_dst_sse2+0xd7>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  15,133,111,255,255,255              // jne           4cc1 <_sk_load_4444_dst_sse2+0x38>
  .byte  15,183,92,126,4                     // movzwl        0x4(%esi,%edi,2),%ebx
  .byte  102,15,110,227                      // movd          %ebx,%xmm4
  .byte  102,15,112,228,69                   // pshufd        $0x45,%xmm4,%xmm4
  .byte  102,15,110,44,126                   // movd          (%esi,%edi,2),%xmm5
  .byte  242,15,112,237,212                  // pshuflw       $0xd4,%xmm5,%xmm5
  .byte  242,15,16,229                       // movsd         %xmm5,%xmm4
  .byte  233,78,255,255,255                  // jmp           4cc1 <_sk_load_4444_dst_sse2+0x38>
  .byte  15,183,52,126                       // movzwl        (%esi,%edi,2),%esi
  .byte  102,15,110,230                      // movd          %esi,%xmm4
  .byte  233,65,255,255,255                  // jmp           4cc1 <_sk_load_4444_dst_sse2+0x38>

HIDDEN _sk_gather_4444_sse2
.globl _sk_gather_4444_sse2
FUNCTION(_sk_gather_4444_sse2)
_sk_gather_4444_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,81,8                      // movss         0x8(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,15,118,219                      // pcmpeqd       %xmm3,%xmm3
  .byte  102,15,254,211                      // paddd         %xmm3,%xmm2
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,224                           // maxps         %xmm0,%xmm4
  .byte  15,93,226                           // minps         %xmm2,%xmm4
  .byte  243,15,16,65,12                     // movss         0xc(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,95,209                           // maxps         %xmm1,%xmm2
  .byte  15,93,208                           // minps         %xmm0,%xmm2
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  243,15,91,194                       // cvttps2dq     %xmm2,%xmm0
  .byte  102,15,110,73,4                     // movd          0x4(%ecx),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,208,245                  // pshufd        $0xf5,%xmm0,%xmm2
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,202,232                  // pshufd        $0xe8,%xmm2,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,15,91,204                       // cvttps2dq     %xmm4,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  102,15,112,193,229                  // pshufd        $0xe5,%xmm1,%xmm0
  .byte  15,183,12,74                        // movzwl        (%edx,%ecx,2),%ecx
  .byte  102,15,110,217                      // movd          %ecx,%xmm3
  .byte  102,15,126,193                      // movd          %xmm0,%ecx
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  15,183,12,74                        // movzwl        (%edx,%ecx,2),%ecx
  .byte  102,15,196,217,1                    // pinsrw        $0x1,%ecx,%xmm3
  .byte  102,15,126,193                      // movd          %xmm0,%ecx
  .byte  102,15,112,193,231                  // pshufd        $0xe7,%xmm1,%xmm0
  .byte  15,183,12,74                        // movzwl        (%edx,%ecx,2),%ecx
  .byte  102,15,196,217,2                    // pinsrw        $0x2,%ecx,%xmm3
  .byte  102,15,126,193                      // movd          %xmm0,%ecx
  .byte  15,183,12,74                        // movzwl        (%edx,%ecx,2),%ecx
  .byte  102,15,196,217,3                    // pinsrw        $0x3,%ecx,%xmm3
  .byte  232,0,0,0,0                         // call          4e35 <_sk_gather_4444_sse2+0xb5>
  .byte  89                                  // pop           %ecx
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,97,216                       // punpcklwd     %xmm0,%xmm3
  .byte  102,15,111,129,11,177,0,0           // movdqa        0xb10b(%ecx),%xmm0
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,129,27,177,0,0                // mulps         0xb11b(%ecx),%xmm0
  .byte  102,15,111,137,43,177,0,0           // movdqa        0xb12b(%ecx),%xmm1
  .byte  102,15,219,203                      // pand          %xmm3,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,137,59,177,0,0                // mulps         0xb13b(%ecx),%xmm1
  .byte  102,15,111,145,75,177,0,0           // movdqa        0xb14b(%ecx),%xmm2
  .byte  102,15,219,211                      // pand          %xmm3,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,145,91,177,0,0                // mulps         0xb15b(%ecx),%xmm2
  .byte  102,15,219,153,107,177,0,0          // pand          0xb16b(%ecx),%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,153,123,177,0,0               // mulps         0xb17b(%ecx),%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_store_4444_sse2
.globl _sk_store_4444_sse2
FUNCTION(_sk_store_4444_sse2)
_sk_store_4444_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,44                          // sub           $0x2c,%esp
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  232,0,0,0,0                         // call          4eb6 <_sk_store_4444_sse2+0x12>
  .byte  88                                  // pop           %eax
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,224                           // maxps         %xmm0,%xmm4
  .byte  15,40,168,106,172,0,0               // movaps        0xac6a(%eax),%xmm5
  .byte  15,93,229                           // minps         %xmm5,%xmm4
  .byte  15,40,176,10,177,0,0                // movaps        0xb10a(%eax),%xmm6
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  102,15,91,228                       // cvtps2dq      %xmm4,%xmm4
  .byte  102,15,114,244,12                   // pslld         $0xc,%xmm4
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  15,95,249                           // maxps         %xmm1,%xmm7
  .byte  15,93,253                           // minps         %xmm5,%xmm7
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  102,15,91,255                       // cvtps2dq      %xmm7,%xmm7
  .byte  102,15,114,247,8                    // pslld         $0x8,%xmm7
  .byte  102,15,235,252                      // por           %xmm4,%xmm7
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  15,95,226                           // maxps         %xmm2,%xmm4
  .byte  15,93,229                           // minps         %xmm5,%xmm4
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,95,93,216                        // maxps         -0x28(%ebp),%xmm3
  .byte  15,93,221                           // minps         %xmm5,%xmm3
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  15,89,222                           // mulps         %xmm6,%xmm3
  .byte  102,15,91,236                       // cvtps2dq      %xmm4,%xmm5
  .byte  102,15,114,245,4                    // pslld         $0x4,%xmm5
  .byte  102,15,91,227                       // cvtps2dq      %xmm3,%xmm4
  .byte  102,15,86,229                       // orpd          %xmm5,%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  1,246                               // add           %esi,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  102,15,86,231                       // orpd          %xmm7,%xmm4
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,107,224                      // packssdw      %xmm0,%xmm4
  .byte  102,15,126,101,232                  // movd          %xmm4,-0x18(%ebp)
  .byte  102,15,112,236,229                  // pshufd        $0xe5,%xmm4,%xmm5
  .byte  102,15,126,109,236                  // movd          %xmm5,-0x14(%ebp)
  .byte  133,219                             // test          %ebx,%ebx
  .byte  117,42                              // jne           4f89 <_sk_store_4444_sse2+0xe5>
  .byte  102,15,126,231                      // movd          %xmm4,%edi
  .byte  102,15,126,235                      // movd          %xmm5,%ebx
  .byte  137,60,86                           // mov           %edi,(%esi,%edx,2)
  .byte  137,92,86,4                         // mov           %ebx,0x4(%esi,%edx,2)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,85,200                        // movaps        -0x38(%ebp),%xmm2
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,60                          // add           $0x3c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  243,15,126,101,232                  // movq          -0x18(%ebp),%xmm4
  .byte  102,15,97,224                       // punpcklwd     %xmm0,%xmm4
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,37                              // je            4fbf <_sk_store_4444_sse2+0x11b>
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,15                              // je            4fae <_sk_store_4444_sse2+0x10a>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,202                             // jne           4f6e <_sk_store_4444_sse2+0xca>
  .byte  102,15,197,252,4                    // pextrw        $0x4,%xmm4,%edi
  .byte  102,137,124,86,4                    // mov           %di,0x4(%esi,%edx,2)
  .byte  102,15,112,220,212                  // pshufd        $0xd4,%xmm4,%xmm3
  .byte  242,15,112,219,232                  // pshuflw       $0xe8,%xmm3,%xmm3
  .byte  102,15,126,28,86                    // movd          %xmm3,(%esi,%edx,2)
  .byte  235,175                             // jmp           4f6e <_sk_store_4444_sse2+0xca>
  .byte  102,15,126,231                      // movd          %xmm4,%edi
  .byte  102,137,60,86                       // mov           %di,(%esi,%edx,2)
  .byte  235,165                             // jmp           4f6e <_sk_store_4444_sse2+0xca>

HIDDEN _sk_load_8888_sse2
.globl _sk_load_8888_sse2
FUNCTION(_sk_load_8888_sse2)
_sk_load_8888_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          4fd7 <_sk_load_8888_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  193,230,2                           // shl           $0x2,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  117,102                             // jne           505b <_sk_load_8888_sse2+0x92>
  .byte  243,15,111,28,190                   // movdqu        (%esi,%edi,4),%xmm3
  .byte  102,15,111,146,9,172,0,0            // movdqa        0xac09(%edx),%xmm2
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,40,162,73,173,0,0                // movaps        0xad49(%edx),%xmm4
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,114,209,8                    // psrld         $0x8,%xmm1
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  102,15,111,235                      // movdqa        %xmm3,%xmm5
  .byte  102,15,114,213,16                   // psrld         $0x10,%xmm5
  .byte  102,15,219,234                      // pand          %xmm2,%xmm5
  .byte  15,91,213                           // cvtdq2ps      %xmm5,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,35                              // je            5086 <_sk_load_8888_sse2+0xbd>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,16                              // je            507c <_sk_load_8888_sse2+0xb3>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,137                             // jne           4ffa <_sk_load_8888_sse2+0x31>
  .byte  102,15,110,68,190,8                 // movd          0x8(%esi,%edi,4),%xmm0
  .byte  102,15,112,216,69                   // pshufd        $0x45,%xmm0,%xmm3
  .byte  102,15,18,28,190                    // movlpd        (%esi,%edi,4),%xmm3
  .byte  233,116,255,255,255                 // jmp           4ffa <_sk_load_8888_sse2+0x31>
  .byte  102,15,110,28,190                   // movd          (%esi,%edi,4),%xmm3
  .byte  233,106,255,255,255                 // jmp           4ffa <_sk_load_8888_sse2+0x31>

HIDDEN _sk_load_8888_dst_sse2
.globl _sk_load_8888_dst_sse2
FUNCTION(_sk_load_8888_dst_sse2)
_sk_load_8888_dst_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          509e <_sk_load_8888_dst_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  193,230,2                           // shl           $0x2,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  117,118                             // jne           5132 <_sk_load_8888_dst_sse2+0xa2>
  .byte  243,15,111,36,190                   // movdqu        (%esi,%edi,4),%xmm4
  .byte  102,15,111,170,66,171,0,0           // movdqa        0xab42(%edx),%xmm5
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,219,245                      // pand          %xmm5,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,40,186,130,172,0,0               // movaps        0xac82(%edx),%xmm7
  .byte  15,89,247                           // mulps         %xmm7,%xmm6
  .byte  15,41,113,16                        // movaps        %xmm6,0x10(%ecx)
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,114,214,8                    // psrld         $0x8,%xmm6
  .byte  102,15,219,245                      // pand          %xmm5,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,89,247                           // mulps         %xmm7,%xmm6
  .byte  15,41,113,32                        // movaps        %xmm6,0x20(%ecx)
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,114,214,16                   // psrld         $0x10,%xmm6
  .byte  102,15,219,245                      // pand          %xmm5,%xmm6
  .byte  15,91,238                           // cvtdq2ps      %xmm6,%xmm5
  .byte  15,89,239                           // mulps         %xmm7,%xmm5
  .byte  15,41,105,48                        // movaps        %xmm5,0x30(%ecx)
  .byte  102,15,114,212,24                   // psrld         $0x18,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,41,97,64                         // movaps        %xmm4,0x40(%ecx)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,39                              // je            5161 <_sk_load_8888_dst_sse2+0xd1>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,20                              // je            5157 <_sk_load_8888_dst_sse2+0xc7>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  15,133,117,255,255,255              // jne           50c1 <_sk_load_8888_dst_sse2+0x31>
  .byte  102,15,110,100,190,8                // movd          0x8(%esi,%edi,4),%xmm4
  .byte  102,15,112,228,69                   // pshufd        $0x45,%xmm4,%xmm4
  .byte  102,15,18,36,190                    // movlpd        (%esi,%edi,4),%xmm4
  .byte  233,96,255,255,255                  // jmp           50c1 <_sk_load_8888_dst_sse2+0x31>
  .byte  102,15,110,36,190                   // movd          (%esi,%edi,4),%xmm4
  .byte  233,86,255,255,255                  // jmp           50c1 <_sk_load_8888_dst_sse2+0x31>

HIDDEN _sk_gather_8888_sse2
.globl _sk_gather_8888_sse2
FUNCTION(_sk_gather_8888_sse2)
_sk_gather_8888_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,81,8                      // movss         0x8(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,15,118,219                      // pcmpeqd       %xmm3,%xmm3
  .byte  102,15,254,211                      // paddd         %xmm3,%xmm2
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,95,232                           // maxps         %xmm0,%xmm5
  .byte  15,93,234                           // minps         %xmm2,%xmm5
  .byte  243,15,16,65,12                     // movss         0xc(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  15,95,225                           // maxps         %xmm1,%xmm4
  .byte  15,93,224                           // minps         %xmm0,%xmm4
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  243,15,91,196                       // cvttps2dq     %xmm4,%xmm0
  .byte  102,15,110,73,4                     // movd          0x4(%ecx),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,208,245                  // pshufd        $0xf5,%xmm0,%xmm2
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,202,232                  // pshufd        $0xe8,%xmm2,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,15,91,205                       // cvttps2dq     %xmm5,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,15,112,209,231                  // pshufd        $0xe7,%xmm1,%xmm2
  .byte  102,15,126,209                      // movd          %xmm2,%ecx
  .byte  102,15,110,20,138                   // movd          (%edx,%ecx,4),%xmm2
  .byte  102,15,126,193                      // movd          %xmm0,%ecx
  .byte  102,15,110,4,138                    // movd          (%edx,%ecx,4),%xmm0
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  102,15,112,201,229                  // pshufd        $0xe5,%xmm1,%xmm1
  .byte  102,15,110,28,138                   // movd          (%edx,%ecx,4),%xmm3
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  102,15,110,12,138                   // movd          (%edx,%ecx,4),%xmm1
  .byte  232,0,0,0,0                         // call          5211 <_sk_gather_8888_sse2+0xa6>
  .byte  89                                  // pop           %ecx
  .byte  102,15,98,194                       // punpckldq     %xmm2,%xmm0
  .byte  102,15,98,217                       // punpckldq     %xmm1,%xmm3
  .byte  102,15,108,216                      // punpcklqdq    %xmm0,%xmm3
  .byte  102,15,111,145,207,169,0,0          // movdqa        0xa9cf(%ecx),%xmm2
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,219,194                      // pand          %xmm2,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,40,161,15,171,0,0                // movaps        0xab0f(%ecx),%xmm4
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,114,209,8                    // psrld         $0x8,%xmm1
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  102,15,111,235                      // movdqa        %xmm3,%xmm5
  .byte  102,15,114,213,16                   // psrld         $0x10,%xmm5
  .byte  102,15,219,234                      // pand          %xmm2,%xmm5
  .byte  15,91,213                           // cvtdq2ps      %xmm5,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_store_8888_sse2
.globl _sk_store_8888_sse2
FUNCTION(_sk_store_8888_sse2)
_sk_store_8888_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,44                          // sub           $0x2c,%esp
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  232,0,0,0,0                         // call          5290 <_sk_store_8888_sse2+0x12>
  .byte  88                                  // pop           %eax
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,224                           // maxps         %xmm0,%xmm4
  .byte  15,40,168,144,168,0,0               // movaps        0xa890(%eax),%xmm5
  .byte  15,93,229                           // minps         %xmm5,%xmm4
  .byte  15,40,176,96,169,0,0                // movaps        0xa960(%eax),%xmm6
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  102,15,91,228                       // cvtps2dq      %xmm4,%xmm4
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  15,95,249                           // maxps         %xmm1,%xmm7
  .byte  15,93,253                           // minps         %xmm5,%xmm7
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  102,15,91,255                       // cvtps2dq      %xmm7,%xmm7
  .byte  102,15,114,247,8                    // pslld         $0x8,%xmm7
  .byte  102,15,235,252                      // por           %xmm4,%xmm7
  .byte  102,15,87,228                       // xorpd         %xmm4,%xmm4
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  15,95,226                           // maxps         %xmm2,%xmm4
  .byte  15,93,229                           // minps         %xmm5,%xmm4
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,95,93,216                        // maxps         -0x28(%ebp),%xmm3
  .byte  15,93,221                           // minps         %xmm5,%xmm3
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  15,89,222                           // mulps         %xmm6,%xmm3
  .byte  102,15,91,236                       // cvtps2dq      %xmm4,%xmm5
  .byte  102,15,114,245,16                   // pslld         $0x10,%xmm5
  .byte  102,15,91,227                       // cvtps2dq      %xmm3,%xmm4
  .byte  102,15,114,244,24                   // pslld         $0x18,%xmm4
  .byte  102,15,235,229                      // por           %xmm5,%xmm4
  .byte  102,15,235,231                      // por           %xmm7,%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  193,230,2                           // shl           $0x2,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  117,32                              // jne           533d <_sk_store_8888_sse2+0xbf>
  .byte  243,15,127,36,150                   // movdqu        %xmm4,(%esi,%edx,4)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,85,200                        // movaps        -0x38(%ebp),%xmm2
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,60                          // add           $0x3c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,28                              // je            5361 <_sk_store_8888_sse2+0xe3>
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,16                              // je            535a <_sk_store_8888_sse2+0xdc>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,211                             // jne           5322 <_sk_store_8888_sse2+0xa4>
  .byte  102,15,112,220,78                   // pshufd        $0x4e,%xmm4,%xmm3
  .byte  102,15,126,92,150,8                 // movd          %xmm3,0x8(%esi,%edx,4)
  .byte  102,15,214,36,150                   // movq          %xmm4,(%esi,%edx,4)
  .byte  235,193                             // jmp           5322 <_sk_store_8888_sse2+0xa4>
  .byte  102,15,126,36,150                   // movd          %xmm4,(%esi,%edx,4)
  .byte  235,186                             // jmp           5322 <_sk_store_8888_sse2+0xa4>

HIDDEN _sk_load_bgra_sse2
.globl _sk_load_bgra_sse2
FUNCTION(_sk_load_bgra_sse2)
_sk_load_bgra_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          5376 <_sk_load_bgra_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  193,230,2                           // shl           $0x2,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  117,102                             // jne           53fa <_sk_load_bgra_sse2+0x92>
  .byte  243,15,111,28,190                   // movdqu        (%esi,%edi,4),%xmm3
  .byte  102,15,111,130,106,168,0,0          // movdqa        0xa86a(%edx),%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,219,200                      // pand          %xmm0,%xmm1
  .byte  15,91,209                           // cvtdq2ps      %xmm1,%xmm2
  .byte  15,40,162,170,169,0,0               // movaps        0xa9aa(%edx),%xmm4
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,114,209,8                    // psrld         $0x8,%xmm1
  .byte  102,15,219,200                      // pand          %xmm0,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  102,15,111,235                      // movdqa        %xmm3,%xmm5
  .byte  102,15,114,213,16                   // psrld         $0x10,%xmm5
  .byte  102,15,219,232                      // pand          %xmm0,%xmm5
  .byte  15,91,197                           // cvtdq2ps      %xmm5,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,35                              // je            5425 <_sk_load_bgra_sse2+0xbd>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,16                              // je            541b <_sk_load_bgra_sse2+0xb3>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,137                             // jne           5399 <_sk_load_bgra_sse2+0x31>
  .byte  102,15,110,68,190,8                 // movd          0x8(%esi,%edi,4),%xmm0
  .byte  102,15,112,216,69                   // pshufd        $0x45,%xmm0,%xmm3
  .byte  102,15,18,28,190                    // movlpd        (%esi,%edi,4),%xmm3
  .byte  233,116,255,255,255                 // jmp           5399 <_sk_load_bgra_sse2+0x31>
  .byte  102,15,110,28,190                   // movd          (%esi,%edi,4),%xmm3
  .byte  233,106,255,255,255                 // jmp           5399 <_sk_load_bgra_sse2+0x31>

HIDDEN _sk_load_bgra_dst_sse2
.globl _sk_load_bgra_dst_sse2
FUNCTION(_sk_load_bgra_dst_sse2)
_sk_load_bgra_dst_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  232,0,0,0,0                         // call          543d <_sk_load_bgra_dst_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  193,230,2                           // shl           $0x2,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  117,118                             // jne           54d1 <_sk_load_bgra_dst_sse2+0xa2>
  .byte  243,15,111,36,190                   // movdqu        (%esi,%edi,4),%xmm4
  .byte  102,15,111,170,163,167,0,0          // movdqa        0xa7a3(%edx),%xmm5
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,219,245                      // pand          %xmm5,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,40,186,227,168,0,0               // movaps        0xa8e3(%edx),%xmm7
  .byte  15,89,247                           // mulps         %xmm7,%xmm6
  .byte  15,41,113,48                        // movaps        %xmm6,0x30(%ecx)
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,114,214,8                    // psrld         $0x8,%xmm6
  .byte  102,15,219,245                      // pand          %xmm5,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,89,247                           // mulps         %xmm7,%xmm6
  .byte  15,41,113,32                        // movaps        %xmm6,0x20(%ecx)
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,114,214,16                   // psrld         $0x10,%xmm6
  .byte  102,15,219,245                      // pand          %xmm5,%xmm6
  .byte  15,91,238                           // cvtdq2ps      %xmm6,%xmm5
  .byte  15,89,239                           // mulps         %xmm7,%xmm5
  .byte  15,41,105,16                        // movaps        %xmm5,0x10(%ecx)
  .byte  102,15,114,212,24                   // psrld         $0x18,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,41,97,64                         // movaps        %xmm4,0x40(%ecx)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,39                              // je            5500 <_sk_load_bgra_dst_sse2+0xd1>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,20                              // je            54f6 <_sk_load_bgra_dst_sse2+0xc7>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  15,133,117,255,255,255              // jne           5460 <_sk_load_bgra_dst_sse2+0x31>
  .byte  102,15,110,100,190,8                // movd          0x8(%esi,%edi,4),%xmm4
  .byte  102,15,112,228,69                   // pshufd        $0x45,%xmm4,%xmm4
  .byte  102,15,18,36,190                    // movlpd        (%esi,%edi,4),%xmm4
  .byte  233,96,255,255,255                  // jmp           5460 <_sk_load_bgra_dst_sse2+0x31>
  .byte  102,15,110,36,190                   // movd          (%esi,%edi,4),%xmm4
  .byte  233,86,255,255,255                  // jmp           5460 <_sk_load_bgra_dst_sse2+0x31>

HIDDEN _sk_gather_bgra_sse2
.globl _sk_gather_bgra_sse2
FUNCTION(_sk_gather_bgra_sse2)
_sk_gather_bgra_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,81,8                      // movss         0x8(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,15,118,219                      // pcmpeqd       %xmm3,%xmm3
  .byte  102,15,254,211                      // paddd         %xmm3,%xmm2
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,95,232                           // maxps         %xmm0,%xmm5
  .byte  15,93,234                           // minps         %xmm2,%xmm5
  .byte  243,15,16,65,12                     // movss         0xc(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  15,95,225                           // maxps         %xmm1,%xmm4
  .byte  15,93,224                           // minps         %xmm0,%xmm4
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  243,15,91,196                       // cvttps2dq     %xmm4,%xmm0
  .byte  102,15,110,73,4                     // movd          0x4(%ecx),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,208,245                  // pshufd        $0xf5,%xmm0,%xmm2
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,202,232                  // pshufd        $0xe8,%xmm2,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,15,91,205                       // cvttps2dq     %xmm5,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,15,112,209,231                  // pshufd        $0xe7,%xmm1,%xmm2
  .byte  102,15,126,209                      // movd          %xmm2,%ecx
  .byte  102,15,110,20,138                   // movd          (%edx,%ecx,4),%xmm2
  .byte  102,15,126,193                      // movd          %xmm0,%ecx
  .byte  102,15,110,4,138                    // movd          (%edx,%ecx,4),%xmm0
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  102,15,112,201,229                  // pshufd        $0xe5,%xmm1,%xmm1
  .byte  102,15,110,28,138                   // movd          (%edx,%ecx,4),%xmm3
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  102,15,110,12,138                   // movd          (%edx,%ecx,4),%xmm1
  .byte  232,0,0,0,0                         // call          55b0 <_sk_gather_bgra_sse2+0xa6>
  .byte  89                                  // pop           %ecx
  .byte  102,15,98,194                       // punpckldq     %xmm2,%xmm0
  .byte  102,15,98,217                       // punpckldq     %xmm1,%xmm3
  .byte  102,15,108,216                      // punpcklqdq    %xmm0,%xmm3
  .byte  102,15,111,129,48,166,0,0           // movdqa        0xa630(%ecx),%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,219,200                      // pand          %xmm0,%xmm1
  .byte  15,91,209                           // cvtdq2ps      %xmm1,%xmm2
  .byte  15,40,161,112,167,0,0               // movaps        0xa770(%ecx),%xmm4
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,114,209,8                    // psrld         $0x8,%xmm1
  .byte  102,15,219,200                      // pand          %xmm0,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  102,15,111,235                      // movdqa        %xmm3,%xmm5
  .byte  102,15,114,213,16                   // psrld         $0x10,%xmm5
  .byte  102,15,219,232                      // pand          %xmm0,%xmm5
  .byte  15,91,197                           // cvtdq2ps      %xmm5,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_store_bgra_sse2
.globl _sk_store_bgra_sse2
FUNCTION(_sk_store_bgra_sse2)
_sk_store_bgra_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,44                          // sub           $0x2c,%esp
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  232,0,0,0,0                         // call          562f <_sk_store_bgra_sse2+0x12>
  .byte  88                                  // pop           %eax
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  15,95,226                           // maxps         %xmm2,%xmm4
  .byte  15,40,168,241,164,0,0               // movaps        0xa4f1(%eax),%xmm5
  .byte  15,93,229                           // minps         %xmm5,%xmm4
  .byte  15,40,176,193,165,0,0               // movaps        0xa5c1(%eax),%xmm6
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  102,15,91,228                       // cvtps2dq      %xmm4,%xmm4
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  15,95,249                           // maxps         %xmm1,%xmm7
  .byte  15,93,253                           // minps         %xmm5,%xmm7
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  102,15,91,255                       // cvtps2dq      %xmm7,%xmm7
  .byte  102,15,114,247,8                    // pslld         $0x8,%xmm7
  .byte  102,15,235,252                      // por           %xmm4,%xmm7
  .byte  102,15,87,228                       // xorpd         %xmm4,%xmm4
  .byte  15,95,224                           // maxps         %xmm0,%xmm4
  .byte  15,93,229                           // minps         %xmm5,%xmm4
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,95,93,216                        // maxps         -0x28(%ebp),%xmm3
  .byte  15,93,221                           // minps         %xmm5,%xmm3
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  15,89,222                           // mulps         %xmm6,%xmm3
  .byte  102,15,91,236                       // cvtps2dq      %xmm4,%xmm5
  .byte  102,15,114,245,16                   // pslld         $0x10,%xmm5
  .byte  102,15,91,227                       // cvtps2dq      %xmm3,%xmm4
  .byte  102,15,114,244,24                   // pslld         $0x18,%xmm4
  .byte  102,15,235,229                      // por           %xmm5,%xmm4
  .byte  102,15,235,231                      // por           %xmm7,%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  193,230,2                           // shl           $0x2,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  117,32                              // jne           56dc <_sk_store_bgra_sse2+0xbf>
  .byte  243,15,127,36,150                   // movdqu        %xmm4,(%esi,%edx,4)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,85,200                        // movaps        -0x38(%ebp),%xmm2
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,60                          // add           $0x3c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  128,227,3                           // and           $0x3,%bl
  .byte  128,251,1                           // cmp           $0x1,%bl
  .byte  116,28                              // je            5700 <_sk_store_bgra_sse2+0xe3>
  .byte  128,251,2                           // cmp           $0x2,%bl
  .byte  116,16                              // je            56f9 <_sk_store_bgra_sse2+0xdc>
  .byte  128,251,3                           // cmp           $0x3,%bl
  .byte  117,211                             // jne           56c1 <_sk_store_bgra_sse2+0xa4>
  .byte  102,15,112,220,78                   // pshufd        $0x4e,%xmm4,%xmm3
  .byte  102,15,126,92,150,8                 // movd          %xmm3,0x8(%esi,%edx,4)
  .byte  102,15,214,36,150                   // movq          %xmm4,(%esi,%edx,4)
  .byte  235,193                             // jmp           56c1 <_sk_store_bgra_sse2+0xa4>
  .byte  102,15,126,36,150                   // movd          %xmm4,(%esi,%edx,4)
  .byte  235,186                             // jmp           56c1 <_sk_store_bgra_sse2+0xa4>

HIDDEN _sk_load_f16_sse2
.globl _sk_load_f16_sse2
FUNCTION(_sk_load_f16_sse2)
_sk_load_f16_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,108                         // sub           $0x6c,%esp
  .byte  232,0,0,0,0                         // call          5715 <_sk_load_f16_sse2+0xe>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  193,230,3                           // shl           $0x3,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  15,133,173,1,0,0                    // jne           58e4 <_sk_load_f16_sse2+0x1dd>
  .byte  102,15,16,4,254                     // movupd        (%esi,%edi,8),%xmm0
  .byte  243,15,111,76,254,16                // movdqu        0x10(%esi,%edi,8),%xmm1
  .byte  102,15,40,216                       // movapd        %xmm0,%xmm3
  .byte  102,15,97,217                       // punpcklwd     %xmm1,%xmm3
  .byte  102,15,105,193                      // punpckhwd     %xmm1,%xmm0
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,97,208                       // punpcklwd     %xmm0,%xmm2
  .byte  102,15,105,216                      // punpckhwd     %xmm0,%xmm3
  .byte  102,15,126,85,208                   // movd          %xmm2,-0x30(%ebp)
  .byte  102,15,112,194,229                  // pshufd        $0xe5,%xmm2,%xmm0
  .byte  102,15,126,69,212                   // movd          %xmm0,-0x2c(%ebp)
  .byte  243,15,126,77,208                   // movq          -0x30(%ebp),%xmm1
  .byte  102,15,112,194,231                  // pshufd        $0xe7,%xmm2,%xmm0
  .byte  102,15,126,69,220                   // movd          %xmm0,-0x24(%ebp)
  .byte  102,15,112,194,78                   // pshufd        $0x4e,%xmm2,%xmm0
  .byte  102,15,126,69,216                   // movd          %xmm0,-0x28(%ebp)
  .byte  243,15,126,101,216                  // movq          -0x28(%ebp),%xmm4
  .byte  102,15,126,93,224                   // movd          %xmm3,-0x20(%ebp)
  .byte  102,15,112,195,229                  // pshufd        $0xe5,%xmm3,%xmm0
  .byte  102,15,126,69,228                   // movd          %xmm0,-0x1c(%ebp)
  .byte  242,15,16,69,224                    // movsd         -0x20(%ebp),%xmm0
  .byte  15,41,69,152                        // movaps        %xmm0,-0x68(%ebp)
  .byte  102,15,112,195,231                  // pshufd        $0xe7,%xmm3,%xmm0
  .byte  102,15,126,69,236                   // movd          %xmm0,-0x14(%ebp)
  .byte  102,15,112,195,78                   // pshufd        $0x4e,%xmm3,%xmm0
  .byte  102,15,126,69,232                   // movd          %xmm0,-0x18(%ebp)
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  102,15,111,170,187,168,0,0          // movdqa        0xa8bb(%edx),%xmm5
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,219,245                      // pand          %xmm5,%xmm6
  .byte  102,15,219,138,203,168,0,0          // pand          0xa8cb(%edx),%xmm1
  .byte  102,15,111,130,219,168,0,0          // movdqa        0xa8db(%edx),%xmm0
  .byte  102,15,127,69,184                   // movdqa        %xmm0,-0x48(%ebp)
  .byte  102,15,114,246,16                   // pslld         $0x10,%xmm6
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,15,102,217                      // pcmpgtd       %xmm1,%xmm3
  .byte  102,15,127,93,136                   // movdqa        %xmm3,-0x78(%ebp)
  .byte  102,15,114,241,13                   // pslld         $0xd,%xmm1
  .byte  102,15,235,206                      // por           %xmm6,%xmm1
  .byte  102,15,97,226                       // punpcklwd     %xmm2,%xmm4
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  102,15,219,213                      // pand          %xmm5,%xmm2
  .byte  102,15,111,154,203,168,0,0          // movdqa        0xa8cb(%edx),%xmm3
  .byte  102,15,219,227                      // pand          %xmm3,%xmm4
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,102,196                      // pcmpgtd       %xmm4,%xmm0
  .byte  102,15,127,69,168                   // movdqa        %xmm0,-0x58(%ebp)
  .byte  102,15,114,244,13                   // pslld         $0xd,%xmm4
  .byte  102,15,235,226                      // por           %xmm2,%xmm4
  .byte  102,15,111,69,152                   // movdqa        -0x68(%ebp),%xmm0
  .byte  102,15,97,199                       // punpcklwd     %xmm7,%xmm0
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  102,15,219,253                      // pand          %xmm5,%xmm7
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  102,15,114,247,16                   // pslld         $0x10,%xmm7
  .byte  102,15,111,146,219,168,0,0          // movdqa        0xa8db(%edx),%xmm2
  .byte  102,15,102,208                      // pcmpgtd       %xmm0,%xmm2
  .byte  102,15,114,240,13                   // pslld         $0xd,%xmm0
  .byte  102,15,235,199                      // por           %xmm7,%xmm0
  .byte  243,15,126,125,232                  // movq          -0x18(%ebp),%xmm7
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  102,15,97,254                       // punpcklwd     %xmm6,%xmm7
  .byte  102,15,219,239                      // pand          %xmm7,%xmm5
  .byte  102,15,219,251                      // pand          %xmm3,%xmm7
  .byte  102,15,114,245,16                   // pslld         $0x10,%xmm5
  .byte  102,15,111,93,184                   // movdqa        -0x48(%ebp),%xmm3
  .byte  102,15,102,223                      // pcmpgtd       %xmm7,%xmm3
  .byte  102,15,127,93,184                   // movdqa        %xmm3,-0x48(%ebp)
  .byte  102,15,114,247,13                   // pslld         $0xd,%xmm7
  .byte  102,15,235,253                      // por           %xmm5,%xmm7
  .byte  102,15,111,154,235,168,0,0          // movdqa        0xa8eb(%edx),%xmm3
  .byte  102,15,254,203                      // paddd         %xmm3,%xmm1
  .byte  102,15,254,227                      // paddd         %xmm3,%xmm4
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  102,15,254,251                      // paddd         %xmm3,%xmm7
  .byte  102,15,111,93,136                   // movdqa        -0x78(%ebp),%xmm3
  .byte  102,15,223,217                      // pandn         %xmm1,%xmm3
  .byte  102,15,111,77,168                   // movdqa        -0x58(%ebp),%xmm1
  .byte  102,15,223,204                      // pandn         %xmm4,%xmm1
  .byte  102,15,223,208                      // pandn         %xmm0,%xmm2
  .byte  102,15,111,101,184                  // movdqa        -0x48(%ebp),%xmm4
  .byte  102,15,223,231                      // pandn         %xmm7,%xmm4
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,124                         // add           $0x7c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  242,15,16,4,254                     // movsd         (%esi,%edi,8),%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  131,251,1                           // cmp           $0x1,%ebx
  .byte  15,132,76,254,255,255               // je            5742 <_sk_load_f16_sse2+0x3b>
  .byte  102,15,22,68,254,8                  // movhpd        0x8(%esi,%edi,8),%xmm0
  .byte  131,251,3                           // cmp           $0x3,%ebx
  .byte  15,130,61,254,255,255               // jb            5742 <_sk_load_f16_sse2+0x3b>
  .byte  243,15,126,76,254,16                // movq          0x10(%esi,%edi,8),%xmm1
  .byte  233,50,254,255,255                  // jmp           5742 <_sk_load_f16_sse2+0x3b>

HIDDEN _sk_load_f16_dst_sse2
.globl _sk_load_f16_dst_sse2
FUNCTION(_sk_load_f16_dst_sse2)
_sk_load_f16_dst_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,124                         // sub           $0x7c,%esp
  .byte  15,41,157,120,255,255,255           // movaps        %xmm3,-0x88(%ebp)
  .byte  15,41,85,136                        // movaps        %xmm2,-0x78(%ebp)
  .byte  102,15,127,77,152                   // movdqa        %xmm1,-0x68(%ebp)
  .byte  15,41,69,168                        // movaps        %xmm0,-0x58(%ebp)
  .byte  232,0,0,0,0                         // call          5932 <_sk_load_f16_dst_sse2+0x22>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  193,230,3                           // shl           $0x3,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  133,219                             // test          %ebx,%ebx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  15,133,168,1,0,0                    // jne           5afc <_sk_load_f16_dst_sse2+0x1ec>
  .byte  102,15,16,4,254                     // movupd        (%esi,%edi,8),%xmm0
  .byte  243,15,111,76,254,16                // movdqu        0x10(%esi,%edi,8),%xmm1
  .byte  102,15,40,208                       // movapd        %xmm0,%xmm2
  .byte  102,15,97,209                       // punpcklwd     %xmm1,%xmm2
  .byte  102,15,105,193                      // punpckhwd     %xmm1,%xmm0
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,97,216                       // punpcklwd     %xmm0,%xmm3
  .byte  102,15,105,208                      // punpckhwd     %xmm0,%xmm2
  .byte  102,15,126,93,208                   // movd          %xmm3,-0x30(%ebp)
  .byte  102,15,112,195,229                  // pshufd        $0xe5,%xmm3,%xmm0
  .byte  102,15,126,69,212                   // movd          %xmm0,-0x2c(%ebp)
  .byte  243,15,126,77,208                   // movq          -0x30(%ebp),%xmm1
  .byte  102,15,112,195,231                  // pshufd        $0xe7,%xmm3,%xmm0
  .byte  102,15,126,69,220                   // movd          %xmm0,-0x24(%ebp)
  .byte  102,15,112,195,78                   // pshufd        $0x4e,%xmm3,%xmm0
  .byte  102,15,126,69,216                   // movd          %xmm0,-0x28(%ebp)
  .byte  243,15,126,69,216                   // movq          -0x28(%ebp),%xmm0
  .byte  102,15,126,85,224                   // movd          %xmm2,-0x20(%ebp)
  .byte  102,15,112,218,229                  // pshufd        $0xe5,%xmm2,%xmm3
  .byte  102,15,126,93,228                   // movd          %xmm3,-0x1c(%ebp)
  .byte  243,15,126,117,224                  // movq          -0x20(%ebp),%xmm6
  .byte  102,15,112,218,231                  // pshufd        $0xe7,%xmm2,%xmm3
  .byte  102,15,126,93,236                   // movd          %xmm3,-0x14(%ebp)
  .byte  102,15,112,210,78                   // pshufd        $0x4e,%xmm2,%xmm2
  .byte  102,15,126,85,232                   // movd          %xmm2,-0x18(%ebp)
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  102,15,97,202                       // punpcklwd     %xmm2,%xmm1
  .byte  102,15,111,186,158,166,0,0          // movdqa        0xa69e(%edx),%xmm7
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,15,219,215                      // pand          %xmm7,%xmm2
  .byte  102,15,111,154,174,166,0,0          // movdqa        0xa6ae(%edx),%xmm3
  .byte  102,15,219,203                      // pand          %xmm3,%xmm1
  .byte  102,15,111,162,190,166,0,0          // movdqa        0xa6be(%edx),%xmm4
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,102,233                      // pcmpgtd       %xmm1,%xmm5
  .byte  102,15,114,241,13                   // pslld         $0xd,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  102,15,111,146,206,166,0,0          // movdqa        0xa6ce(%edx),%xmm2
  .byte  102,15,127,85,184                   // movdqa        %xmm2,-0x48(%ebp)
  .byte  102,15,254,202                      // paddd         %xmm2,%xmm1
  .byte  102,15,223,233                      // pandn         %xmm1,%xmm5
  .byte  243,15,126,77,232                   // movq          -0x18(%ebp),%xmm1
  .byte  102,15,127,105,16                   // movdqa        %xmm5,0x10(%ecx)
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  102,15,97,194                       // punpcklwd     %xmm2,%xmm0
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,219,239                      // pand          %xmm7,%xmm5
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,114,245,16                   // pslld         $0x10,%xmm5
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  102,15,102,216                      // pcmpgtd       %xmm0,%xmm3
  .byte  102,15,114,240,13                   // pslld         $0xd,%xmm0
  .byte  102,15,235,197                      // por           %xmm5,%xmm0
  .byte  102,15,111,109,184                  // movdqa        -0x48(%ebp),%xmm5
  .byte  102,15,254,197                      // paddd         %xmm5,%xmm0
  .byte  102,15,223,216                      // pandn         %xmm0,%xmm3
  .byte  102,15,127,89,32                    // movdqa        %xmm3,0x20(%ecx)
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,97,240                       // punpcklwd     %xmm0,%xmm6
  .byte  102,15,111,198                      // movdqa        %xmm6,%xmm0
  .byte  102,15,219,199                      // pand          %xmm7,%xmm0
  .byte  102,15,219,242                      // pand          %xmm2,%xmm6
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  102,15,102,222                      // pcmpgtd       %xmm6,%xmm3
  .byte  102,15,114,246,13                   // pslld         $0xd,%xmm6
  .byte  102,15,235,240                      // por           %xmm0,%xmm6
  .byte  102,15,254,245                      // paddd         %xmm5,%xmm6
  .byte  102,15,223,222                      // pandn         %xmm6,%xmm3
  .byte  102,15,127,89,48                    // movdqa        %xmm3,0x30(%ecx)
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,97,203                       // punpcklwd     %xmm3,%xmm1
  .byte  102,15,219,249                      // pand          %xmm1,%xmm7
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  102,15,114,247,16                   // pslld         $0x10,%xmm7
  .byte  102,15,102,225                      // pcmpgtd       %xmm1,%xmm4
  .byte  102,15,114,241,13                   // pslld         $0xd,%xmm1
  .byte  102,15,235,207                      // por           %xmm7,%xmm1
  .byte  102,15,254,205                      // paddd         %xmm5,%xmm1
  .byte  102,15,223,225                      // pandn         %xmm1,%xmm4
  .byte  102,15,127,97,64                    // movdqa        %xmm4,0x40(%ecx)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,69,168                        // movaps        -0x58(%ebp),%xmm0
  .byte  15,40,77,152                        // movaps        -0x68(%ebp),%xmm1
  .byte  15,40,85,136                        // movaps        -0x78(%ebp),%xmm2
  .byte  15,40,157,120,255,255,255           // movaps        -0x88(%ebp),%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  129,196,140,0,0,0                   // add           $0x8c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  242,15,16,4,254                     // movsd         (%esi,%edi,8),%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  131,251,1                           // cmp           $0x1,%ebx
  .byte  15,132,81,254,255,255               // je            595f <_sk_load_f16_dst_sse2+0x4f>
  .byte  102,15,22,68,254,8                  // movhpd        0x8(%esi,%edi,8),%xmm0
  .byte  131,251,3                           // cmp           $0x3,%ebx
  .byte  15,130,66,254,255,255               // jb            595f <_sk_load_f16_dst_sse2+0x4f>
  .byte  243,15,126,76,254,16                // movq          0x10(%esi,%edi,8),%xmm1
  .byte  233,55,254,255,255                  // jmp           595f <_sk_load_f16_dst_sse2+0x4f>

HIDDEN _sk_gather_f16_sse2
.globl _sk_gather_f16_sse2
FUNCTION(_sk_gather_f16_sse2)
_sk_gather_f16_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,88                          // sub           $0x58,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,81,8                      // movss         0x8(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  102,15,118,219                      // pcmpeqd       %xmm3,%xmm3
  .byte  102,15,254,211                      // paddd         %xmm3,%xmm2
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,224                           // maxps         %xmm0,%xmm4
  .byte  15,93,226                           // minps         %xmm2,%xmm4
  .byte  243,15,16,65,12                     // movss         0xc(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,95,209                           // maxps         %xmm1,%xmm2
  .byte  15,93,208                           // minps         %xmm0,%xmm2
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  243,15,91,194                       // cvttps2dq     %xmm2,%xmm0
  .byte  102,15,110,73,4                     // movd          0x4(%ecx),%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,112,208,245                  // pshufd        $0xf5,%xmm0,%xmm2
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,112,202,232                  // pshufd        $0xe8,%xmm2,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  243,15,91,204                       // cvttps2dq     %xmm4,%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,15,112,209,231                  // pshufd        $0xe7,%xmm1,%xmm2
  .byte  102,15,126,209                      // movd          %xmm2,%ecx
  .byte  243,15,126,20,202                   // movq          (%edx,%ecx,8),%xmm2
  .byte  102,15,126,193                      // movd          %xmm0,%ecx
  .byte  243,15,126,4,202                    // movq          (%edx,%ecx,8),%xmm0
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  102,15,112,201,229                  // pshufd        $0xe5,%xmm1,%xmm1
  .byte  243,15,126,28,202                   // movq          (%edx,%ecx,8),%xmm3
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  243,15,126,12,202                   // movq          (%edx,%ecx,8),%xmm1
  .byte  232,0,0,0,0                         // call          5bce <_sk_gather_f16_sse2+0xa6>
  .byte  89                                  // pop           %ecx
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  102,15,108,194                      // punpcklqdq    %xmm2,%xmm0
  .byte  102,15,108,217                      // punpcklqdq    %xmm1,%xmm3
  .byte  102,15,111,227                      // movdqa        %xmm3,%xmm4
  .byte  102,15,97,224                       // punpcklwd     %xmm0,%xmm4
  .byte  102,15,105,216                      // punpckhwd     %xmm0,%xmm3
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,15,97,195                       // punpcklwd     %xmm3,%xmm0
  .byte  102,15,105,227                      // punpckhwd     %xmm3,%xmm4
  .byte  102,15,126,69,224                   // movd          %xmm0,-0x20(%ebp)
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,15,126,77,228                   // movd          %xmm1,-0x1c(%ebp)
  .byte  243,15,126,77,224                   // movq          -0x20(%ebp),%xmm1
  .byte  102,15,112,208,231                  // pshufd        $0xe7,%xmm0,%xmm2
  .byte  102,15,126,85,236                   // movd          %xmm2,-0x14(%ebp)
  .byte  102,15,112,192,78                   // pshufd        $0x4e,%xmm0,%xmm0
  .byte  102,15,126,69,232                   // movd          %xmm0,-0x18(%ebp)
  .byte  243,15,126,109,232                  // movq          -0x18(%ebp),%xmm5
  .byte  102,15,126,101,240                  // movd          %xmm4,-0x10(%ebp)
  .byte  102,15,112,196,229                  // pshufd        $0xe5,%xmm4,%xmm0
  .byte  102,15,126,69,244                   // movd          %xmm0,-0xc(%ebp)
  .byte  242,15,16,69,240                    // movsd         -0x10(%ebp),%xmm0
  .byte  15,41,69,184                        // movaps        %xmm0,-0x48(%ebp)
  .byte  102,15,112,196,231                  // pshufd        $0xe7,%xmm4,%xmm0
  .byte  102,15,126,69,252                   // movd          %xmm0,-0x4(%ebp)
  .byte  102,15,112,196,78                   // pshufd        $0x4e,%xmm4,%xmm0
  .byte  102,15,126,69,248                   // movd          %xmm0,-0x8(%ebp)
  .byte  102,15,97,206                       // punpcklwd     %xmm6,%xmm1
  .byte  102,15,239,210                      // pxor          %xmm2,%xmm2
  .byte  102,15,111,177,2,164,0,0            // movdqa        0xa402(%ecx),%xmm6
  .byte  102,15,111,225                      // movdqa        %xmm1,%xmm4
  .byte  102,15,219,230                      // pand          %xmm6,%xmm4
  .byte  102,15,219,137,18,164,0,0           // pand          0xa412(%ecx),%xmm1
  .byte  102,15,111,129,34,164,0,0           // movdqa        0xa422(%ecx),%xmm0
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,15,102,217                      // pcmpgtd       %xmm1,%xmm3
  .byte  102,15,127,93,168                   // movdqa        %xmm3,-0x58(%ebp)
  .byte  102,15,114,241,13                   // pslld         $0xd,%xmm1
  .byte  102,15,235,204                      // por           %xmm4,%xmm1
  .byte  102,15,97,234                       // punpcklwd     %xmm2,%xmm5
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  102,15,111,213                      // movdqa        %xmm5,%xmm2
  .byte  102,15,219,214                      // pand          %xmm6,%xmm2
  .byte  102,15,111,153,18,164,0,0           // movdqa        0xa412(%ecx),%xmm3
  .byte  102,15,219,235                      // pand          %xmm3,%xmm5
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,111,224                      // movdqa        %xmm0,%xmm4
  .byte  102,15,102,229                      // pcmpgtd       %xmm5,%xmm4
  .byte  102,15,127,101,200                  // movdqa        %xmm4,-0x38(%ebp)
  .byte  102,15,114,245,13                   // pslld         $0xd,%xmm5
  .byte  102,15,235,234                      // por           %xmm2,%xmm5
  .byte  102,15,111,69,184                   // movdqa        -0x48(%ebp),%xmm0
  .byte  102,15,97,199                       // punpcklwd     %xmm7,%xmm0
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  102,15,219,254                      // pand          %xmm6,%xmm7
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  102,15,114,247,16                   // pslld         $0x10,%xmm7
  .byte  102,15,111,145,34,164,0,0           // movdqa        0xa422(%ecx),%xmm2
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,102,216                      // pcmpgtd       %xmm0,%xmm3
  .byte  102,15,114,240,13                   // pslld         $0xd,%xmm0
  .byte  102,15,235,199                      // por           %xmm7,%xmm0
  .byte  243,15,126,125,248                  // movq          -0x8(%ebp),%xmm7
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,97,252                       // punpcklwd     %xmm4,%xmm7
  .byte  102,15,219,247                      // pand          %xmm7,%xmm6
  .byte  102,15,219,185,18,164,0,0           // pand          0xa412(%ecx),%xmm7
  .byte  102,15,114,246,16                   // pslld         $0x10,%xmm6
  .byte  102,15,102,215                      // pcmpgtd       %xmm7,%xmm2
  .byte  102,15,114,247,13                   // pslld         $0xd,%xmm7
  .byte  102,15,235,254                      // por           %xmm6,%xmm7
  .byte  102,15,111,161,50,164,0,0           // movdqa        0xa432(%ecx),%xmm4
  .byte  102,15,254,204                      // paddd         %xmm4,%xmm1
  .byte  102,15,254,236                      // paddd         %xmm4,%xmm5
  .byte  102,15,254,196                      // paddd         %xmm4,%xmm0
  .byte  102,15,254,252                      // paddd         %xmm4,%xmm7
  .byte  102,15,111,117,168                  // movdqa        -0x58(%ebp),%xmm6
  .byte  102,15,223,241                      // pandn         %xmm1,%xmm6
  .byte  102,15,111,77,200                   // movdqa        -0x38(%ebp),%xmm1
  .byte  102,15,223,205                      // pandn         %xmm5,%xmm1
  .byte  102,15,223,216                      // pandn         %xmm0,%xmm3
  .byte  102,15,111,234                      // movdqa        %xmm2,%xmm5
  .byte  102,15,223,239                      // pandn         %xmm7,%xmm5
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  102,15,111,198                      // movdqa        %xmm6,%xmm0
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,111,221                      // movdqa        %xmm5,%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,104                         // add           $0x68,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_store_f16_sse2
.globl _sk_store_f16_sse2
FUNCTION(_sk_store_f16_sse2)
_sk_store_f16_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,96                          // sub           $0x60,%esp
  .byte  15,41,93,184                        // movaps        %xmm3,-0x48(%ebp)
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  232,0,0,0,0                         // call          5d92 <_sk_store_f16_sse2+0x19>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,152,126,162,0,0          // movdqa        0xa27e(%eax),%xmm3
  .byte  102,15,111,224                      // movdqa        %xmm0,%xmm4
  .byte  102,15,219,227                      // pand          %xmm3,%xmm4
  .byte  102,15,111,136,174,162,0,0          // movdqa        0xa2ae(%eax),%xmm1
  .byte  102,15,127,77,232                   // movdqa        %xmm1,-0x18(%ebp)
  .byte  102,15,111,240                      // movdqa        %xmm0,%xmm6
  .byte  102,15,114,246,3                    // pslld         $0x3,%xmm6
  .byte  102,15,219,241                      // pand          %xmm1,%xmm6
  .byte  102,15,254,244                      // paddd         %xmm4,%xmm6
  .byte  102,15,111,184,142,162,0,0          // movdqa        0xa28e(%eax),%xmm7
  .byte  102,15,127,69,168                   // movdqa        %xmm0,-0x58(%ebp)
  .byte  102,15,219,199                      // pand          %xmm7,%xmm0
  .byte  102,15,111,168,158,162,0,0          // movdqa        0xa29e(%eax),%xmm5
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,15,102,200                      // pcmpgtd       %xmm0,%xmm1
  .byte  102,15,111,128,46,159,0,0           // movdqa        0x9f2e(%eax),%xmm0
  .byte  102,15,127,69,216                   // movdqa        %xmm0,-0x28(%ebp)
  .byte  102,15,254,240                      // paddd         %xmm0,%xmm6
  .byte  102,15,114,230,16                   // psrad         $0x10,%xmm6
  .byte  102,15,223,206                      // pandn         %xmm6,%xmm1
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  102,15,111,242                      // movdqa        %xmm2,%xmm6
  .byte  102,15,114,246,3                    // pslld         $0x3,%xmm6
  .byte  102,15,219,117,232                  // pand          -0x18(%ebp),%xmm6
  .byte  102,15,254,240                      // paddd         %xmm0,%xmm6
  .byte  102,15,127,85,152                   // movdqa        %xmm2,-0x68(%ebp)
  .byte  102,15,219,215                      // pand          %xmm7,%xmm2
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,102,226                      // pcmpgtd       %xmm2,%xmm4
  .byte  102,15,254,117,216                  // paddd         -0x28(%ebp),%xmm6
  .byte  102,15,114,230,16                   // psrad         $0x10,%xmm6
  .byte  102,15,223,230                      // pandn         %xmm6,%xmm4
  .byte  102,15,107,200                      // packssdw      %xmm0,%xmm1
  .byte  102,15,107,224                      // packssdw      %xmm0,%xmm4
  .byte  102,15,97,204                       // punpcklwd     %xmm4,%xmm1
  .byte  102,15,111,85,200                   // movdqa        -0x38(%ebp),%xmm2
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  102,15,111,226                      // movdqa        %xmm2,%xmm4
  .byte  102,15,114,244,3                    // pslld         $0x3,%xmm4
  .byte  102,15,219,101,232                  // pand          -0x18(%ebp),%xmm4
  .byte  102,15,254,224                      // paddd         %xmm0,%xmm4
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,219,199                      // pand          %xmm7,%xmm0
  .byte  102,15,111,245                      // movdqa        %xmm5,%xmm6
  .byte  102,15,102,240                      // pcmpgtd       %xmm0,%xmm6
  .byte  102,15,111,85,216                   // movdqa        -0x28(%ebp),%xmm2
  .byte  102,15,254,226                      // paddd         %xmm2,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,223,244                      // pandn         %xmm4,%xmm6
  .byte  102,15,111,101,184                  // movdqa        -0x48(%ebp),%xmm4
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,15,114,240,3                    // pslld         $0x3,%xmm0
  .byte  102,15,219,69,232                   // pand          -0x18(%ebp),%xmm0
  .byte  102,15,219,220                      // pand          %xmm4,%xmm3
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  102,15,254,194                      // paddd         %xmm2,%xmm0
  .byte  102,15,219,252                      // pand          %xmm4,%xmm7
  .byte  102,15,102,239                      // pcmpgtd       %xmm7,%xmm5
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,223,232                      // pandn         %xmm0,%xmm5
  .byte  102,15,107,240                      // packssdw      %xmm0,%xmm6
  .byte  102,15,107,232                      // packssdw      %xmm0,%xmm5
  .byte  102,15,97,245                       // punpcklwd     %xmm5,%xmm6
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  193,230,3                           // shl           $0x3,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,121,8                           // mov           0x8(%ecx),%edi
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,98,198                       // punpckldq     %xmm6,%xmm0
  .byte  133,255                             // test          %edi,%edi
  .byte  117,48                              // jne           5f13 <_sk_store_f16_sse2+0x19a>
  .byte  15,17,4,214                         // movups        %xmm0,(%esi,%edx,8)
  .byte  102,15,106,206                      // punpckhdq     %xmm6,%xmm1
  .byte  243,15,127,76,214,16                // movdqu        %xmm1,0x10(%esi,%edx,8)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,69,168                        // movaps        -0x58(%ebp),%xmm0
  .byte  15,40,77,152                        // movaps        -0x68(%ebp),%xmm1
  .byte  15,40,85,200                        // movaps        -0x38(%ebp),%xmm2
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,112                         // add           $0x70,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  102,15,214,4,214                    // movq          %xmm0,(%esi,%edx,8)
  .byte  131,255,1                           // cmp           $0x1,%edi
  .byte  116,212                             // je            5ef1 <_sk_store_f16_sse2+0x178>
  .byte  102,15,23,68,214,8                  // movhpd        %xmm0,0x8(%esi,%edx,8)
  .byte  131,255,3                           // cmp           $0x3,%edi
  .byte  114,201                             // jb            5ef1 <_sk_store_f16_sse2+0x178>
  .byte  102,15,106,206                      // punpckhdq     %xmm6,%xmm1
  .byte  102,15,214,76,214,16                // movq          %xmm1,0x10(%esi,%edx,8)
  .byte  235,189                             // jmp           5ef1 <_sk_store_f16_sse2+0x178>

HIDDEN _sk_load_u16_be_sse2
.globl _sk_load_u16_be_sse2
FUNCTION(_sk_load_u16_be_sse2)
_sk_load_u16_be_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,44                          // sub           $0x2c,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,16                              // mov           (%eax),%edx
  .byte  139,49                              // mov           (%ecx),%esi
  .byte  139,122,4                           // mov           0x4(%edx),%edi
  .byte  15,175,121,4                        // imul          0x4(%ecx),%edi
  .byte  1,255                               // add           %edi,%edi
  .byte  3,58                                // add           (%edx),%edi
  .byte  139,89,8                            // mov           0x8(%ecx),%ebx
  .byte  193,230,2                           // shl           $0x2,%esi
  .byte  133,219                             // test          %ebx,%ebx
  .byte  232,0,0,0,0                         // call          5f5f <_sk_load_u16_be_sse2+0x2b>
  .byte  90                                  // pop           %edx
  .byte  15,133,11,1,0,0                     // jne           6071 <_sk_load_u16_be_sse2+0x13d>
  .byte  102,15,16,4,119                     // movupd        (%edi,%esi,2),%xmm0
  .byte  243,15,111,76,119,16                // movdqu        0x10(%edi,%esi,2),%xmm1
  .byte  102,15,40,208                       // movapd        %xmm0,%xmm2
  .byte  102,15,97,209                       // punpcklwd     %xmm1,%xmm2
  .byte  102,15,105,193                      // punpckhwd     %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  102,15,105,208                      // punpckhwd     %xmm0,%xmm2
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,113,240,8                    // psllw         $0x8,%xmm0
  .byte  102,15,112,233,78                   // pshufd        $0x4e,%xmm1,%xmm5
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,235,200                      // por           %xmm0,%xmm1
  .byte  102,15,126,77,216                   // movd          %xmm1,-0x28(%ebp)
  .byte  102,15,112,193,229                  // pshufd        $0xe5,%xmm1,%xmm0
  .byte  102,15,126,69,220                   // movd          %xmm0,-0x24(%ebp)
  .byte  243,15,126,69,216                   // movq          -0x28(%ebp),%xmm0
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,97,195                       // punpcklwd     %xmm3,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,40,162,65,158,0,0                // movaps        0x9e41(%edx),%xmm4
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,15,113,241,8                    // psllw         $0x8,%xmm1
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,15,235,233                      // por           %xmm1,%xmm5
  .byte  102,15,126,109,208                  // movd          %xmm5,-0x30(%ebp)
  .byte  102,15,112,205,229                  // pshufd        $0xe5,%xmm5,%xmm1
  .byte  102,15,126,77,212                   // movd          %xmm1,-0x2c(%ebp)
  .byte  243,15,126,77,208                   // movq          -0x30(%ebp),%xmm1
  .byte  102,15,97,203                       // punpcklwd     %xmm3,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  102,15,111,234                      // movdqa        %xmm2,%xmm5
  .byte  102,15,113,245,8                    // psllw         $0x8,%xmm5
  .byte  102,15,112,242,78                   // pshufd        $0x4e,%xmm2,%xmm6
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,235,213                      // por           %xmm5,%xmm2
  .byte  102,15,126,85,232                   // movd          %xmm2,-0x18(%ebp)
  .byte  102,15,112,210,229                  // pshufd        $0xe5,%xmm2,%xmm2
  .byte  102,15,126,85,236                   // movd          %xmm2,-0x14(%ebp)
  .byte  243,15,126,85,232                   // movq          -0x18(%ebp),%xmm2
  .byte  102,15,97,211                       // punpcklwd     %xmm3,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,15,113,245,8                    // psllw         $0x8,%xmm5
  .byte  102,15,113,214,8                    // psrlw         $0x8,%xmm6
  .byte  102,15,235,245                      // por           %xmm5,%xmm6
  .byte  102,15,126,117,224                  // movd          %xmm6,-0x20(%ebp)
  .byte  102,15,112,238,229                  // pshufd        $0xe5,%xmm6,%xmm5
  .byte  102,15,126,109,228                  // movd          %xmm5,-0x1c(%ebp)
  .byte  243,15,126,109,224                  // movq          -0x20(%ebp),%xmm5
  .byte  102,15,97,235                       // punpcklwd     %xmm3,%xmm5
  .byte  15,91,221                           // cvtdq2ps      %xmm5,%xmm3
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,60                          // add           $0x3c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  242,15,16,4,119                     // movsd         (%edi,%esi,2),%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  131,251,1                           // cmp           $0x1,%ebx
  .byte  15,132,238,254,255,255              // je            5f71 <_sk_load_u16_be_sse2+0x3d>
  .byte  102,15,22,68,119,8                  // movhpd        0x8(%edi,%esi,2),%xmm0
  .byte  131,251,3                           // cmp           $0x3,%ebx
  .byte  15,130,223,254,255,255              // jb            5f71 <_sk_load_u16_be_sse2+0x3d>
  .byte  243,15,126,76,119,16                // movq          0x10(%edi,%esi,2),%xmm1
  .byte  233,212,254,255,255                 // jmp           5f71 <_sk_load_u16_be_sse2+0x3d>

HIDDEN _sk_load_rgb_u16_be_sse2
.globl _sk_load_rgb_u16_be_sse2
FUNCTION(_sk_load_rgb_u16_be_sse2)
_sk_load_rgb_u16_be_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,28                          // sub           $0x1c,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,16                              // mov           (%eax),%edx
  .byte  139,121,8                           // mov           0x8(%ecx),%edi
  .byte  139,114,4                           // mov           0x4(%edx),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  1,246                               // add           %esi,%esi
  .byte  3,50                                // add           (%edx),%esi
  .byte  107,25,3                            // imul          $0x3,(%ecx),%ebx
  .byte  133,255                             // test          %edi,%edi
  .byte  232,0,0,0,0                         // call          60c6 <_sk_load_rgb_u16_be_sse2+0x29>
  .byte  90                                  // pop           %edx
  .byte  15,133,240,0,0,0                    // jne           61bd <_sk_load_rgb_u16_be_sse2+0x120>
  .byte  243,15,111,20,94                    // movdqu        (%esi,%ebx,2),%xmm2
  .byte  243,15,111,92,94,8                  // movdqu        0x8(%esi,%ebx,2),%xmm3
  .byte  102,15,115,219,4                    // psrldq        $0x4,%xmm3
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,115,216,6                    // psrldq        $0x6,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,115,217,6                    // psrldq        $0x6,%xmm1
  .byte  102,15,97,193                       // punpcklwd     %xmm1,%xmm0
  .byte  102,15,97,211                       // punpcklwd     %xmm3,%xmm2
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,97,200                       // punpcklwd     %xmm0,%xmm1
  .byte  102,15,112,225,78                   // pshufd        $0x4e,%xmm1,%xmm4
  .byte  102,15,105,208                      // punpckhwd     %xmm0,%xmm2
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,113,240,8                    // psllw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,235,200                      // por           %xmm0,%xmm1
  .byte  102,15,126,77,224                   // movd          %xmm1,-0x20(%ebp)
  .byte  102,15,112,193,229                  // pshufd        $0xe5,%xmm1,%xmm0
  .byte  102,15,126,69,228                   // movd          %xmm0,-0x1c(%ebp)
  .byte  243,15,126,69,224                   // movq          -0x20(%ebp),%xmm0
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,97,195                       // punpcklwd     %xmm3,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,40,170,218,156,0,0               // movaps        0x9cda(%edx),%xmm5
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  102,15,111,204                      // movdqa        %xmm4,%xmm1
  .byte  102,15,113,241,8                    // psllw         $0x8,%xmm1
  .byte  102,15,113,212,8                    // psrlw         $0x8,%xmm4
  .byte  102,15,235,225                      // por           %xmm1,%xmm4
  .byte  102,15,126,101,216                  // movd          %xmm4,-0x28(%ebp)
  .byte  102,15,112,204,229                  // pshufd        $0xe5,%xmm4,%xmm1
  .byte  102,15,126,77,220                   // movd          %xmm1,-0x24(%ebp)
  .byte  243,15,126,77,216                   // movq          -0x28(%ebp),%xmm1
  .byte  102,15,97,203                       // punpcklwd     %xmm3,%xmm1
  .byte  15,91,201                           // cvtdq2ps      %xmm1,%xmm1
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  102,15,111,226                      // movdqa        %xmm2,%xmm4
  .byte  102,15,113,244,8                    // psllw         $0x8,%xmm4
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,235,212                      // por           %xmm4,%xmm2
  .byte  102,15,126,85,232                   // movd          %xmm2,-0x18(%ebp)
  .byte  102,15,112,210,229                  // pshufd        $0xe5,%xmm2,%xmm2
  .byte  102,15,126,85,236                   // movd          %xmm2,-0x14(%ebp)
  .byte  243,15,126,85,232                   // movq          -0x18(%ebp),%xmm2
  .byte  102,15,97,211                       // punpcklwd     %xmm3,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  141,112,8                           // lea           0x8(%eax),%esi
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,154,90,154,0,0                // movaps        0x9a5a(%edx),%xmm3
  .byte  86                                  // push          %esi
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,44                          // add           $0x2c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  102,15,110,20,94                    // movd          (%esi,%ebx,2),%xmm2
  .byte  102,15,196,84,94,4,2                // pinsrw        $0x2,0x4(%esi,%ebx,2),%xmm2
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  131,255,1                           // cmp           $0x1,%edi
  .byte  117,13                              // jne           61df <_sk_load_rgb_u16_be_sse2+0x142>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  233,16,255,255,255                  // jmp           60ef <_sk_load_rgb_u16_be_sse2+0x52>
  .byte  102,15,110,68,94,6                  // movd          0x6(%esi,%ebx,2),%xmm0
  .byte  102,15,196,68,94,10,2               // pinsrw        $0x2,0xa(%esi,%ebx,2),%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  131,255,3                           // cmp           $0x3,%edi
  .byte  114,18                              // jb            6207 <_sk_load_rgb_u16_be_sse2+0x16a>
  .byte  102,15,110,92,94,12                 // movd          0xc(%esi,%ebx,2),%xmm3
  .byte  102,15,196,92,94,16,2               // pinsrw        $0x2,0x10(%esi,%ebx,2),%xmm3
  .byte  233,232,254,255,255                 // jmp           60ef <_sk_load_rgb_u16_be_sse2+0x52>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  233,223,254,255,255                 // jmp           60ef <_sk_load_rgb_u16_be_sse2+0x52>

HIDDEN _sk_store_u16_be_sse2
.globl _sk_store_u16_be_sse2
FUNCTION(_sk_store_u16_be_sse2)
_sk_store_u16_be_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,32                          // sub           $0x20,%esp
  .byte  15,41,93,232                        // movaps        %xmm3,-0x18(%ebp)
  .byte  232,0,0,0,0                         // call          6221 <_sk_store_u16_be_sse2+0x11>
  .byte  88                                  // pop           %eax
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,224                           // maxps         %xmm0,%xmm4
  .byte  15,40,168,255,152,0,0               // movaps        0x98ff(%eax),%xmm5
  .byte  15,93,229                           // minps         %xmm5,%xmm4
  .byte  15,40,176,47,158,0,0                // movaps        0x9e2f(%eax),%xmm6
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  102,15,91,228                       // cvtps2dq      %xmm4,%xmm4
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,107,224                      // packssdw      %xmm0,%xmm4
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,15,113,247,8                    // psllw         $0x8,%xmm7
  .byte  102,15,113,212,8                    // psrlw         $0x8,%xmm4
  .byte  102,15,235,231                      // por           %xmm7,%xmm4
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  15,95,249                           // maxps         %xmm1,%xmm7
  .byte  15,93,253                           // minps         %xmm5,%xmm7
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  102,15,91,255                       // cvtps2dq      %xmm7,%xmm7
  .byte  102,15,114,247,16                   // pslld         $0x10,%xmm7
  .byte  102,15,114,231,16                   // psrad         $0x10,%xmm7
  .byte  102,15,107,248                      // packssdw      %xmm0,%xmm7
  .byte  102,15,111,223                      // movdqa        %xmm7,%xmm3
  .byte  102,15,113,243,8                    // psllw         $0x8,%xmm3
  .byte  102,15,113,215,8                    // psrlw         $0x8,%xmm7
  .byte  102,15,235,251                      // por           %xmm3,%xmm7
  .byte  102,15,97,231                       // punpcklwd     %xmm7,%xmm4
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  15,41,85,216                        // movaps        %xmm2,-0x28(%ebp)
  .byte  15,95,218                           // maxps         %xmm2,%xmm3
  .byte  15,93,221                           // minps         %xmm5,%xmm3
  .byte  15,89,222                           // mulps         %xmm6,%xmm3
  .byte  102,15,91,251                       // cvtps2dq      %xmm3,%xmm7
  .byte  102,15,114,247,16                   // pslld         $0x10,%xmm7
  .byte  102,15,114,231,16                   // psrad         $0x10,%xmm7
  .byte  102,15,107,248                      // packssdw      %xmm0,%xmm7
  .byte  102,15,111,223                      // movdqa        %xmm7,%xmm3
  .byte  102,15,113,243,8                    // psllw         $0x8,%xmm3
  .byte  102,15,113,215,8                    // psrlw         $0x8,%xmm7
  .byte  102,15,235,251                      // por           %xmm3,%xmm7
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  15,95,93,232                        // maxps         -0x18(%ebp),%xmm3
  .byte  15,93,221                           // minps         %xmm5,%xmm3
  .byte  15,89,222                           // mulps         %xmm6,%xmm3
  .byte  102,15,91,219                       // cvtps2dq      %xmm3,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  102,15,114,227,16                   // psrad         $0x10,%xmm3
  .byte  102,15,107,216                      // packssdw      %xmm0,%xmm3
  .byte  102,15,111,235                      // movdqa        %xmm3,%xmm5
  .byte  102,15,113,245,8                    // psllw         $0x8,%xmm5
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,235,221                      // por           %xmm5,%xmm3
  .byte  102,15,97,251                       // punpcklwd     %xmm3,%xmm7
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,56                              // mov           (%eax),%edi
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  139,119,4                           // mov           0x4(%edi),%esi
  .byte  15,175,113,4                        // imul          0x4(%ecx),%esi
  .byte  1,246                               // add           %esi,%esi
  .byte  3,55                                // add           (%edi),%esi
  .byte  139,121,8                           // mov           0x8(%ecx),%edi
  .byte  193,226,2                           // shl           $0x2,%edx
  .byte  133,255                             // test          %edi,%edi
  .byte  117,49                              // jne           6350 <_sk_store_u16_be_sse2+0x140>
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  102,15,98,223                       // punpckldq     %xmm7,%xmm3
  .byte  243,15,127,28,86                    // movdqu        %xmm3,(%esi,%edx,2)
  .byte  102,15,106,231                      // punpckhdq     %xmm7,%xmm4
  .byte  243,15,127,100,86,16                // movdqu        %xmm4,0x10(%esi,%edx,2)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,85,216                        // movaps        -0x28(%ebp),%xmm2
  .byte  15,40,93,232                        // movaps        -0x18(%ebp),%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,48                          // add           $0x30,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,98,239                       // punpckldq     %xmm7,%xmm5
  .byte  102,15,214,44,86                    // movq          %xmm5,(%esi,%edx,2)
  .byte  131,255,1                           // cmp           $0x1,%edi
  .byte  116,212                             // je            6336 <_sk_store_u16_be_sse2+0x126>
  .byte  102,15,23,108,86,8                  // movhpd        %xmm5,0x8(%esi,%edx,2)
  .byte  131,255,3                           // cmp           $0x3,%edi
  .byte  114,201                             // jb            6336 <_sk_store_u16_be_sse2+0x126>
  .byte  102,15,106,231                      // punpckhdq     %xmm7,%xmm4
  .byte  102,15,214,100,86,16                // movq          %xmm4,0x10(%esi,%edx,2)
  .byte  235,189                             // jmp           6336 <_sk_store_u16_be_sse2+0x126>

HIDDEN _sk_load_f32_sse2
.globl _sk_load_f32_sse2
FUNCTION(_sk_load_f32_sse2)
_sk_load_f32_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,48                              // mov           (%eax),%esi
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  139,86,4                            // mov           0x4(%esi),%edx
  .byte  15,175,81,4                         // imul          0x4(%ecx),%edx
  .byte  193,226,2                           // shl           $0x2,%edx
  .byte  3,22                                // add           (%esi),%edx
  .byte  141,52,189,0,0,0,0                  // lea           0x0(,%edi,4),%esi
  .byte  193,231,4                           // shl           $0x4,%edi
  .byte  15,16,36,23                         // movups        (%edi,%edx,1),%xmm4
  .byte  139,121,8                           // mov           0x8(%ecx),%edi
  .byte  133,255                             // test          %edi,%edi
  .byte  117,71                              // jne           63f0 <_sk_load_f32_sse2+0x77>
  .byte  15,16,84,178,16                     // movups        0x10(%edx,%esi,4),%xmm2
  .byte  15,16,92,178,32                     // movups        0x20(%edx,%esi,4),%xmm3
  .byte  15,16,68,178,48                     // movups        0x30(%edx,%esi,4),%xmm0
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,20,234                           // unpcklps      %xmm2,%xmm5
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  15,21,226                           // unpckhps      %xmm2,%xmm4
  .byte  15,21,216                           // unpckhps      %xmm0,%xmm3
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  102,15,20,193                       // unpcklpd      %xmm1,%xmm0
  .byte  15,18,205                           // movhlps       %xmm5,%xmm1
  .byte  15,40,212                           // movaps        %xmm4,%xmm2
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  15,18,220                           // movhlps       %xmm4,%xmm3
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,16                          // add           $0x10,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  131,255,1                           // cmp           $0x1,%edi
  .byte  117,8                               // jne           6400 <_sk_load_f32_sse2+0x87>
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  235,184                             // jmp           63b8 <_sk_load_f32_sse2+0x3f>
  .byte  15,16,84,178,16                     // movups        0x10(%edx,%esi,4),%xmm2
  .byte  131,255,3                           // cmp           $0x3,%edi
  .byte  114,7                               // jb            6411 <_sk_load_f32_sse2+0x98>
  .byte  15,16,92,178,32                     // movups        0x20(%edx,%esi,4),%xmm3
  .byte  235,167                             // jmp           63b8 <_sk_load_f32_sse2+0x3f>
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  235,162                             // jmp           63b8 <_sk_load_f32_sse2+0x3f>

HIDDEN _sk_load_f32_dst_sse2
.globl _sk_load_f32_dst_sse2
FUNCTION(_sk_load_f32_dst_sse2)
_sk_load_f32_dst_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,32                          // sub           $0x20,%esp
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  15,41,85,232                        // movaps        %xmm2,-0x18(%ebp)
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,48                              // mov           (%eax),%esi
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  139,86,4                            // mov           0x4(%esi),%edx
  .byte  15,175,81,4                         // imul          0x4(%ecx),%edx
  .byte  193,226,2                           // shl           $0x2,%edx
  .byte  3,22                                // add           (%esi),%edx
  .byte  141,52,189,0,0,0,0                  // lea           0x0(,%edi,4),%esi
  .byte  193,231,4                           // shl           $0x4,%edi
  .byte  15,16,52,23                         // movups        (%edi,%edx,1),%xmm6
  .byte  139,121,8                           // mov           0x8(%ecx),%edi
  .byte  133,255                             // test          %edi,%edi
  .byte  117,97                              // jne           64b2 <_sk_load_f32_dst_sse2+0x9c>
  .byte  15,16,124,178,16                    // movups        0x10(%edx,%esi,4),%xmm7
  .byte  15,16,92,178,32                     // movups        0x20(%edx,%esi,4),%xmm3
  .byte  15,16,84,178,48                     // movups        0x30(%edx,%esi,4),%xmm2
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  15,20,231                           // unpcklps      %xmm7,%xmm4
  .byte  15,40,235                           // movaps        %xmm3,%xmm5
  .byte  15,20,234                           // unpcklps      %xmm2,%xmm5
  .byte  15,21,247                           // unpckhps      %xmm7,%xmm6
  .byte  15,21,218                           // unpckhps      %xmm2,%xmm3
  .byte  15,40,212                           // movaps        %xmm4,%xmm2
  .byte  102,15,20,213                       // unpcklpd      %xmm5,%xmm2
  .byte  15,18,236                           // movhlps       %xmm4,%xmm5
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  102,15,20,227                       // unpcklpd      %xmm3,%xmm4
  .byte  15,18,222                           // movhlps       %xmm6,%xmm3
  .byte  102,15,41,81,16                     // movapd        %xmm2,0x10(%ecx)
  .byte  15,41,105,32                        // movaps        %xmm5,0x20(%ecx)
  .byte  102,15,41,97,48                     // movapd        %xmm4,0x30(%ecx)
  .byte  15,41,89,64                         // movaps        %xmm3,0x40(%ecx)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,85,232                        // movaps        -0x18(%ebp),%xmm2
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,48                          // add           $0x30,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  131,255,1                           // cmp           $0x1,%edi
  .byte  117,8                               // jne           64c2 <_sk_load_f32_dst_sse2+0xac>
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  235,158                             // jmp           6460 <_sk_load_f32_dst_sse2+0x4a>
  .byte  15,16,124,178,16                    // movups        0x10(%edx,%esi,4),%xmm7
  .byte  131,255,3                           // cmp           $0x3,%edi
  .byte  114,7                               // jb            64d3 <_sk_load_f32_dst_sse2+0xbd>
  .byte  15,16,92,178,32                     // movups        0x20(%edx,%esi,4),%xmm3
  .byte  235,141                             // jmp           6460 <_sk_load_f32_dst_sse2+0x4a>
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  235,136                             // jmp           6460 <_sk_load_f32_dst_sse2+0x4a>

HIDDEN _sk_store_f32_sse2
.globl _sk_store_f32_sse2
FUNCTION(_sk_store_f32_sse2)
_sk_store_f32_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,48                              // mov           (%eax),%esi
  .byte  139,25                              // mov           (%ecx),%ebx
  .byte  139,86,4                            // mov           0x4(%esi),%edx
  .byte  15,175,81,4                         // imul          0x4(%ecx),%edx
  .byte  193,226,2                           // shl           $0x2,%edx
  .byte  3,22                                // add           (%esi),%edx
  .byte  141,52,157,0,0,0,0                  // lea           0x0(,%ebx,4),%esi
  .byte  193,227,4                           // shl           $0x4,%ebx
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  15,20,233                           // unpcklps      %xmm1,%xmm5
  .byte  15,40,226                           // movaps        %xmm2,%xmm4
  .byte  15,20,227                           // unpcklps      %xmm3,%xmm4
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  102,15,20,244                       // unpcklpd      %xmm4,%xmm6
  .byte  139,121,8                           // mov           0x8(%ecx),%edi
  .byte  102,15,17,52,19                     // movupd        %xmm6,(%ebx,%edx,1)
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,21,241                           // unpckhps      %xmm1,%xmm6
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,21,251                           // unpckhps      %xmm3,%xmm7
  .byte  15,18,229                           // movhlps       %xmm5,%xmm4
  .byte  15,40,238                           // movaps        %xmm6,%xmm5
  .byte  102,15,20,239                       // unpcklpd      %xmm7,%xmm5
  .byte  133,255                             // test          %edi,%edi
  .byte  117,40                              // jne           655e <_sk_store_f32_sse2+0x86>
  .byte  102,15,21,247                       // unpckhpd      %xmm7,%xmm6
  .byte  15,17,100,178,16                    // movups        %xmm4,0x10(%edx,%esi,4)
  .byte  102,15,17,108,178,32                // movupd        %xmm5,0x20(%edx,%esi,4)
  .byte  102,15,17,116,178,48                // movupd        %xmm6,0x30(%edx,%esi,4)
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  131,255,1                           // cmp           $0x1,%edi
  .byte  116,232                             // je            654b <_sk_store_f32_sse2+0x73>
  .byte  15,17,100,178,16                    // movups        %xmm4,0x10(%edx,%esi,4)
  .byte  131,255,3                           // cmp           $0x3,%edi
  .byte  114,222                             // jb            654b <_sk_store_f32_sse2+0x73>
  .byte  102,15,17,108,178,32                // movupd        %xmm5,0x20(%edx,%esi,4)
  .byte  235,214                             // jmp           654b <_sk_store_f32_sse2+0x73>

HIDDEN _sk_repeat_x_sse2
.globl _sk_repeat_x_sse2
FUNCTION(_sk_repeat_x_sse2)
_sk_repeat_x_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          6580 <_sk_repeat_x_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  243,15,16,34                        // movss         (%edx),%xmm4
  .byte  243,15,16,106,4                     // movss         0x4(%edx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  243,15,91,245                       // cvttps2dq     %xmm5,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,194,238,1                        // cmpltps       %xmm6,%xmm5
  .byte  15,84,168,160,149,0,0               // andps         0x95a0(%eax),%xmm5
  .byte  15,92,245                           // subps         %xmm5,%xmm6
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  141,65,8                            // lea           0x8(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_repeat_y_sse2
.globl _sk_repeat_y_sse2
FUNCTION(_sk_repeat_y_sse2)
_sk_repeat_y_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          65d2 <_sk_repeat_y_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  243,15,16,34                        // movss         (%edx),%xmm4
  .byte  243,15,16,106,4                     // movss         0x4(%edx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,89,233                           // mulps         %xmm1,%xmm5
  .byte  243,15,91,245                       // cvttps2dq     %xmm5,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,194,238,1                        // cmpltps       %xmm6,%xmm5
  .byte  15,84,168,78,149,0,0                // andps         0x954e(%eax),%xmm5
  .byte  15,92,245                           // subps         %xmm5,%xmm6
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  15,92,204                           // subps         %xmm4,%xmm1
  .byte  141,65,8                            // lea           0x8(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_mirror_x_sse2
.globl _sk_mirror_x_sse2
FUNCTION(_sk_mirror_x_sse2)
_sk_mirror_x_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          6624 <_sk_mirror_x_sse2+0xb>
  .byte  89                                  // pop           %ecx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,16                              // mov           (%eax),%edx
  .byte  243,15,16,34                        // movss         (%edx),%xmm4
  .byte  243,15,16,106,4                     // movss         0x4(%edx),%xmm5
  .byte  15,40,244                           // movaps        %xmm4,%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,92,198                           // subps         %xmm6,%xmm0
  .byte  243,15,89,169,220,156,0,0           // mulss         0x9cdc(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  243,15,91,253                       // cvttps2dq     %xmm5,%xmm7
  .byte  15,91,255                           // cvtdq2ps      %xmm7,%xmm7
  .byte  15,194,239,1                        // cmpltps       %xmm7,%xmm5
  .byte  15,84,169,252,148,0,0               // andps         0x94fc(%ecx),%xmm5
  .byte  15,92,253                           // subps         %xmm5,%xmm7
  .byte  243,15,88,228                       // addss         %xmm4,%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,89,252                           // mulps         %xmm4,%xmm7
  .byte  15,92,199                           // subps         %xmm7,%xmm0
  .byte  15,92,198                           // subps         %xmm6,%xmm0
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,84,196                           // andps         %xmm4,%xmm0
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_mirror_y_sse2
.globl _sk_mirror_y_sse2
FUNCTION(_sk_mirror_y_sse2)
_sk_mirror_y_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          6698 <_sk_mirror_y_sse2+0xb>
  .byte  89                                  // pop           %ecx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,16                              // mov           (%eax),%edx
  .byte  243,15,16,34                        // movss         (%edx),%xmm4
  .byte  243,15,16,106,4                     // movss         0x4(%edx),%xmm5
  .byte  15,40,244                           // movaps        %xmm4,%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  243,15,89,169,104,156,0,0           // mulss         0x9c68(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,89,233                           // mulps         %xmm1,%xmm5
  .byte  243,15,91,253                       // cvttps2dq     %xmm5,%xmm7
  .byte  15,91,255                           // cvtdq2ps      %xmm7,%xmm7
  .byte  15,194,239,1                        // cmpltps       %xmm7,%xmm5
  .byte  15,84,169,136,148,0,0               // andps         0x9488(%ecx),%xmm5
  .byte  15,92,253                           // subps         %xmm5,%xmm7
  .byte  243,15,88,228                       // addss         %xmm4,%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,89,252                           // mulps         %xmm4,%xmm7
  .byte  15,92,207                           // subps         %xmm7,%xmm1
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,92,225                           // subps         %xmm1,%xmm4
  .byte  15,84,204                           // andps         %xmm4,%xmm1
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_clamp_x_1_sse2
.globl _sk_clamp_x_1_sse2
FUNCTION(_sk_clamp_x_1_sse2)
_sk_clamp_x_1_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          670c <_sk_clamp_x_1_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,224                           // maxps         %xmm0,%xmm4
  .byte  15,93,160,20,148,0,0                // minps         0x9414(%eax),%xmm4
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_repeat_x_1_sse2
.globl _sk_repeat_x_1_sse2
FUNCTION(_sk_repeat_x_1_sse2)
_sk_repeat_x_1_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          673c <_sk_repeat_x_1_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  243,15,91,224                       // cvttps2dq     %xmm0,%xmm4
  .byte  15,91,236                           // cvtdq2ps      %xmm4,%xmm5
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,194,245,1                        // cmpltps       %xmm5,%xmm6
  .byte  15,40,184,228,147,0,0               // movaps        0x93e4(%eax),%xmm7
  .byte  15,84,247                           // andps         %xmm7,%xmm6
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,92,238                           // subps         %xmm6,%xmm5
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,95,224                           // maxps         %xmm0,%xmm4
  .byte  15,93,231                           // minps         %xmm7,%xmm4
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_mirror_x_1_sse2
.globl _sk_mirror_x_1_sse2
FUNCTION(_sk_mirror_x_1_sse2)
_sk_mirror_x_1_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          6786 <_sk_mirror_x_1_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  15,40,160,10,148,0,0                // movaps        0x940a(%eax),%xmm4
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,40,168,138,147,0,0               // movaps        0x938a(%eax),%xmm5
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  243,15,91,245                       // cvttps2dq     %xmm5,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,194,238,1                        // cmpltps       %xmm6,%xmm5
  .byte  15,40,184,154,147,0,0               // movaps        0x939a(%eax),%xmm7
  .byte  15,84,239                           // andps         %xmm7,%xmm5
  .byte  15,92,245                           // subps         %xmm5,%xmm6
  .byte  15,88,246                           // addps         %xmm6,%xmm6
  .byte  15,92,198                           // subps         %xmm6,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,84,224                           // andps         %xmm0,%xmm4
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,95,196                           // maxps         %xmm4,%xmm0
  .byte  15,93,199                           // minps         %xmm7,%xmm0
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  141,72,4                            // lea           0x4(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_luminance_to_alpha_sse2
.globl _sk_luminance_to_alpha_sse2
FUNCTION(_sk_luminance_to_alpha_sse2)
_sk_luminance_to_alpha_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  232,0,0,0,0                         // call          67f0 <_sk_luminance_to_alpha_sse2+0xe>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  15,89,128,112,152,0,0               // mulps         0x9870(%eax),%xmm0
  .byte  15,89,136,128,152,0,0               // mulps         0x9880(%eax),%xmm1
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  15,89,152,144,152,0,0               // mulps         0x9890(%eax),%xmm3
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_matrix_translate_sse2
.globl _sk_matrix_translate_sse2
FUNCTION(_sk_matrix_translate_sse2)
_sk_matrix_translate_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,33                        // movss         (%ecx),%xmm4
  .byte  243,15,16,105,4                     // movss         0x4(%ecx),%xmm5
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_matrix_scale_translate_sse2
.globl _sk_matrix_scale_translate_sse2
FUNCTION(_sk_matrix_scale_translate_sse2)
_sk_matrix_scale_translate_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,33                        // movss         (%ecx),%xmm4
  .byte  243,15,16,105,4                     // movss         0x4(%ecx),%xmm5
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  243,15,16,113,8                     // movss         0x8(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  243,15,16,97,12                     // movss         0xc(%ecx),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_matrix_2x3_sse2
.globl _sk_matrix_2x3_sse2
FUNCTION(_sk_matrix_2x3_sse2)
_sk_matrix_2x3_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,1                         // movss         (%ecx),%xmm0
  .byte  243,15,16,73,4                      // movss         0x4(%ecx),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,15,16,113,8                     // movss         0x8(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,121,16                    // movss         0x10(%ecx),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,113,12                    // movss         0xc(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,121,20                    // movss         0x14(%ecx),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_matrix_3x4_sse2
.globl _sk_matrix_3x4_sse2
FUNCTION(_sk_matrix_3x4_sse2)
_sk_matrix_3x4_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,1                         // movss         (%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,15,16,105,24                    // movss         0x18(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  243,15,16,113,36                    // movss         0x24(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,234                           // mulps         %xmm2,%xmm5
  .byte  15,88,238                           // addps         %xmm6,%xmm5
  .byte  243,15,16,113,12                    // movss         0xc(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  15,88,245                           // addps         %xmm5,%xmm6
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  243,15,16,105,28                    // movss         0x1c(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  243,15,16,113,40                    // movss         0x28(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,234                           // mulps         %xmm2,%xmm5
  .byte  15,88,238                           // addps         %xmm6,%xmm5
  .byte  243,15,16,113,16                    // movss         0x10(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  15,88,245                           // addps         %xmm5,%xmm6
  .byte  243,15,16,105,4                     // movss         0x4(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,88,238                           // addps         %xmm6,%xmm5
  .byte  243,15,16,113,32                    // movss         0x20(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,242                           // mulps         %xmm2,%xmm6
  .byte  243,15,16,81,44                     // movss         0x2c(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,88,242                           // addps         %xmm2,%xmm6
  .byte  243,15,16,121,20                    // movss         0x14(%ecx),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,89,249                           // mulps         %xmm1,%xmm7
  .byte  15,88,254                           // addps         %xmm6,%xmm7
  .byte  243,15,16,81,8                      // movss         0x8(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_matrix_4x5_sse2
.globl _sk_matrix_4x5_sse2
FUNCTION(_sk_matrix_4x5_sse2)
_sk_matrix_4x5_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,1                         // movss         (%ecx),%xmm0
  .byte  243,15,16,73,4                      // movss         0x4(%ecx),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,15,16,113,48                    // movss         0x30(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,121,64                    // movss         0x40(%ecx),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  243,15,16,121,32                    // movss         0x20(%ecx),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,89,250                           // mulps         %xmm2,%xmm7
  .byte  15,88,254                           // addps         %xmm6,%xmm7
  .byte  243,15,16,113,16                    // movss         0x10(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,113,52                    // movss         0x34(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,121,68                    // movss         0x44(%ecx),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  243,15,16,121,36                    // movss         0x24(%ecx),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,89,250                           // mulps         %xmm2,%xmm7
  .byte  15,88,254                           // addps         %xmm6,%xmm7
  .byte  243,15,16,113,20                    // movss         0x14(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  243,15,16,113,56                    // movss         0x38(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,121,72                    // movss         0x48(%ecx),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  243,15,16,121,40                    // movss         0x28(%ecx),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,89,250                           // mulps         %xmm2,%xmm7
  .byte  15,88,254                           // addps         %xmm6,%xmm7
  .byte  243,15,16,113,24                    // movss         0x18(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  243,15,16,121,8                     // movss         0x8(%ecx),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,89,252                           // mulps         %xmm4,%xmm7
  .byte  15,88,254                           // addps         %xmm6,%xmm7
  .byte  243,15,16,113,60                    // movss         0x3c(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  243,15,16,89,76                     // movss         0x4c(%ecx),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  15,88,243                           // addps         %xmm3,%xmm6
  .byte  243,15,16,89,44                     // movss         0x2c(%ecx),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  15,89,218                           // mulps         %xmm2,%xmm3
  .byte  15,88,222                           // addps         %xmm6,%xmm3
  .byte  243,15,16,81,28                     // movss         0x1c(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  243,15,16,89,12                     // movss         0xc(%ecx),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,215                           // movaps        %xmm7,%xmm2
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_matrix_4x3_sse2
.globl _sk_matrix_4x3_sse2
FUNCTION(_sk_matrix_4x3_sse2)
_sk_matrix_4x3_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,1                         // movss         (%ecx),%xmm0
  .byte  243,15,16,73,4                      // movss         0x4(%ecx),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,15,16,81,16                     // movss         0x10(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,89,32                     // movss         0x20(%ecx),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,81,20                     // movss         0x14(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,89,36                     // movss         0x24(%ecx),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  243,15,16,81,8                      // movss         0x8(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,89,24                     // movss         0x18(%ecx),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  243,15,16,113,40                    // movss         0x28(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,221                           // mulps         %xmm5,%xmm3
  .byte  15,88,222                           // addps         %xmm6,%xmm3
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  243,15,16,89,12                     // movss         0xc(%ecx),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  243,15,16,113,28                    // movss         0x1c(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,121,44                    // movss         0x2c(%ecx),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  15,88,222                           // addps         %xmm6,%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_matrix_perspective_sse2
.globl _sk_matrix_perspective_sse2
FUNCTION(_sk_matrix_perspective_sse2)
_sk_matrix_perspective_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,1                         // movss         (%ecx),%xmm0
  .byte  243,15,16,105,4                     // movss         0x4(%ecx),%xmm5
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  243,15,16,113,8                     // movss         0x8(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,233                           // mulps         %xmm1,%xmm5
  .byte  15,88,238                           // addps         %xmm6,%xmm5
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  243,15,16,113,16                    // movss         0x10(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,105,20                    // movss         0x14(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  15,88,245                           // addps         %xmm5,%xmm6
  .byte  243,15,16,105,12                    // movss         0xc(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,88,238                           // addps         %xmm6,%xmm5
  .byte  243,15,16,113,28                    // movss         0x1c(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  243,15,16,73,32                     // movss         0x20(%ecx),%xmm1
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  15,88,241                           // addps         %xmm1,%xmm6
  .byte  243,15,16,73,24                     // movss         0x18(%ecx),%xmm1
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,83,201                           // rcpps         %xmm1,%xmm1
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,89,233                           // mulps         %xmm1,%xmm5
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_evenly_spaced_gradient_sse2
.globl _sk_evenly_spaced_gradient_sse2
FUNCTION(_sk_evenly_spaced_gradient_sse2)
_sk_evenly_spaced_gradient_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,60                          // sub           $0x3c,%esp
  .byte  15,41,69,184                        // movaps        %xmm0,-0x48(%ebp)
  .byte  232,0,0,0,0                         // call          6c86 <_sk_evenly_spaced_gradient_sse2+0x12>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,49                              // mov           (%ecx),%esi
  .byte  139,65,4                            // mov           0x4(%ecx),%eax
  .byte  78                                  // dec           %esi
  .byte  102,15,110,206                      // movd          %esi,%xmm1
  .byte  102,15,112,201,0                    // pshufd        $0x0,%xmm1,%xmm1
  .byte  102,15,111,146,10,148,0,0           // movdqa        0x940a(%edx),%xmm2
  .byte  102,15,219,209                      // pand          %xmm1,%xmm2
  .byte  102,15,235,146,202,145,0,0          // por           0x91ca(%edx),%xmm2
  .byte  102,15,114,209,16                   // psrld         $0x10,%xmm1
  .byte  102,15,235,138,26,148,0,0           // por           0x941a(%edx),%xmm1
  .byte  15,88,138,42,148,0,0                // addps         0x942a(%edx),%xmm1
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,15,112,209,229                  // pshufd        $0xe5,%xmm1,%xmm2
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,15,126,218                      // movd          %xmm3,%edx
  .byte  102,15,112,217,231                  // pshufd        $0xe7,%xmm1,%xmm3
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  243,15,16,52,144                    // movss         (%eax,%edx,4),%xmm6
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  243,15,16,36,176                    // movss         (%eax,%esi,4),%xmm4
  .byte  102,15,126,211                      // movd          %xmm2,%ebx
  .byte  243,15,16,12,152                    // movss         (%eax,%ebx,4),%xmm1
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  139,65,20                           // mov           0x14(%ecx),%eax
  .byte  243,15,16,20,184                    // movss         (%eax,%edi,4),%xmm2
  .byte  243,15,16,28,144                    // movss         (%eax,%edx,4),%xmm3
  .byte  243,15,16,4,176                     // movss         (%eax,%esi,4),%xmm0
  .byte  243,15,16,60,152                    // movss         (%eax,%ebx,4),%xmm7
  .byte  15,20,225                           // unpcklps      %xmm1,%xmm4
  .byte  102,15,20,230                       // unpcklpd      %xmm6,%xmm4
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  15,20,199                           // unpcklps      %xmm7,%xmm0
  .byte  139,65,8                            // mov           0x8(%ecx),%eax
  .byte  243,15,16,20,184                    // movss         (%eax,%edi,4),%xmm2
  .byte  243,15,16,52,144                    // movss         (%eax,%edx,4),%xmm6
  .byte  243,15,16,12,176                    // movss         (%eax,%esi,4),%xmm1
  .byte  243,15,16,60,152                    // movss         (%eax,%ebx,4),%xmm7
  .byte  102,15,20,195                       // unpcklpd      %xmm3,%xmm0
  .byte  102,15,41,69,200                    // movapd        %xmm0,-0x38(%ebp)
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  15,20,207                           // unpcklps      %xmm7,%xmm1
  .byte  102,15,20,206                       // unpcklpd      %xmm6,%xmm1
  .byte  139,65,24                           // mov           0x18(%ecx),%eax
  .byte  243,15,16,20,184                    // movss         (%eax,%edi,4),%xmm2
  .byte  243,15,16,28,144                    // movss         (%eax,%edx,4),%xmm3
  .byte  243,15,16,4,176                     // movss         (%eax,%esi,4),%xmm0
  .byte  243,15,16,60,152                    // movss         (%eax,%ebx,4),%xmm7
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  15,20,199                           // unpcklps      %xmm7,%xmm0
  .byte  102,15,20,195                       // unpcklpd      %xmm3,%xmm0
  .byte  102,15,41,69,216                    // movapd        %xmm0,-0x28(%ebp)
  .byte  139,65,12                           // mov           0xc(%ecx),%eax
  .byte  243,15,16,20,184                    // movss         (%eax,%edi,4),%xmm2
  .byte  243,15,16,28,144                    // movss         (%eax,%edx,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  243,15,16,20,176                    // movss         (%eax,%esi,4),%xmm2
  .byte  243,15,16,60,152                    // movss         (%eax,%ebx,4),%xmm7
  .byte  15,20,215                           // unpcklps      %xmm7,%xmm2
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  139,65,28                           // mov           0x1c(%ecx),%eax
  .byte  243,15,16,60,184                    // movss         (%eax,%edi,4),%xmm7
  .byte  243,15,16,28,144                    // movss         (%eax,%edx,4),%xmm3
  .byte  15,20,223                           // unpcklps      %xmm7,%xmm3
  .byte  243,15,16,60,176                    // movss         (%eax,%esi,4),%xmm7
  .byte  243,15,16,44,152                    // movss         (%eax,%ebx,4),%xmm5
  .byte  15,20,253                           // unpcklps      %xmm5,%xmm7
  .byte  102,15,20,251                       // unpcklpd      %xmm3,%xmm7
  .byte  139,65,16                           // mov           0x10(%ecx),%eax
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  243,15,16,44,144                    // movss         (%eax,%edx,4),%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  243,15,16,28,176                    // movss         (%eax,%esi,4),%xmm3
  .byte  243,15,16,4,152                     // movss         (%eax,%ebx,4),%xmm0
  .byte  15,20,216                           // unpcklps      %xmm0,%xmm3
  .byte  102,15,20,221                       // unpcklpd      %xmm5,%xmm3
  .byte  139,65,32                           // mov           0x20(%ecx),%eax
  .byte  243,15,16,4,184                     // movss         (%eax,%edi,4),%xmm0
  .byte  243,15,16,44,144                    // movss         (%eax,%edx,4),%xmm5
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  243,15,16,4,176                     // movss         (%eax,%esi,4),%xmm0
  .byte  243,15,16,52,152                    // movss         (%eax,%ebx,4),%xmm6
  .byte  15,20,198                           // unpcklps      %xmm6,%xmm0
  .byte  102,15,20,197                       // unpcklpd      %xmm5,%xmm0
  .byte  15,40,109,184                       // movaps        -0x48(%ebp),%xmm5
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,88,101,200                       // addps         -0x38(%ebp),%xmm4
  .byte  15,89,205                           // mulps         %xmm5,%xmm1
  .byte  15,88,77,216                        // addps         -0x28(%ebp),%xmm1
  .byte  15,89,213                           // mulps         %xmm5,%xmm2
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  15,89,221                           // mulps         %xmm5,%xmm3
  .byte  15,88,216                           // addps         %xmm0,%xmm3
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,65,8                            // lea           0x8(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,76                          // add           $0x4c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_gradient_sse2
.globl _sk_gradient_sse2
FUNCTION(_sk_gradient_sse2)
_sk_gradient_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,60                          // sub           $0x3c,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,16                              // mov           (%eax),%edx
  .byte  139,10                              // mov           (%edx),%ecx
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  131,249,2                           // cmp           $0x2,%ecx
  .byte  114,33                              // jb            6e6e <_sk_gradient_sse2+0x3a>
  .byte  139,114,36                          // mov           0x24(%edx),%esi
  .byte  73                                  // dec           %ecx
  .byte  131,198,4                           // add           $0x4,%esi
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  243,15,16,22                        // movss         (%esi),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,194,208,2                        // cmpleps       %xmm0,%xmm2
  .byte  102,15,250,202                      // psubd         %xmm2,%xmm1
  .byte  131,198,4                           // add           $0x4,%esi
  .byte  73                                  // dec           %ecx
  .byte  117,234                             // jne           6e58 <_sk_gradient_sse2+0x24>
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,112,209,229                  // pshufd        $0xe5,%xmm1,%xmm2
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  102,15,112,201,231                  // pshufd        $0xe7,%xmm1,%xmm1
  .byte  102,15,126,203                      // movd          %xmm1,%ebx
  .byte  139,66,4                            // mov           0x4(%edx),%eax
  .byte  243,15,16,12,152                    // movss         (%eax,%ebx,4),%xmm1
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  243,15,16,36,176                    // movss         (%eax,%esi,4),%xmm4
  .byte  102,15,126,209                      // movd          %xmm2,%ecx
  .byte  243,15,16,20,136                    // movss         (%eax,%ecx,4),%xmm2
  .byte  15,20,217                           // unpcklps      %xmm1,%xmm3
  .byte  139,66,20                           // mov           0x14(%edx),%eax
  .byte  243,15,16,12,152                    // movss         (%eax,%ebx,4),%xmm1
  .byte  243,15,16,52,184                    // movss         (%eax,%edi,4),%xmm6
  .byte  243,15,16,44,176                    // movss         (%eax,%esi,4),%xmm5
  .byte  243,15,16,60,136                    // movss         (%eax,%ecx,4),%xmm7
  .byte  15,20,226                           // unpcklps      %xmm2,%xmm4
  .byte  102,15,20,227                       // unpcklpd      %xmm3,%xmm4
  .byte  102,15,41,101,184                   // movapd        %xmm4,-0x48(%ebp)
  .byte  15,20,241                           // unpcklps      %xmm1,%xmm6
  .byte  15,20,239                           // unpcklps      %xmm7,%xmm5
  .byte  139,66,8                            // mov           0x8(%edx),%eax
  .byte  243,15,16,20,152                    // movss         (%eax,%ebx,4),%xmm2
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  243,15,16,12,176                    // movss         (%eax,%esi,4),%xmm1
  .byte  243,15,16,60,136                    // movss         (%eax,%ecx,4),%xmm7
  .byte  102,15,20,238                       // unpcklpd      %xmm6,%xmm5
  .byte  102,15,41,109,200                   // movapd        %xmm5,-0x38(%ebp)
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  15,20,207                           // unpcklps      %xmm7,%xmm1
  .byte  102,15,20,203                       // unpcklpd      %xmm3,%xmm1
  .byte  139,66,24                           // mov           0x18(%edx),%eax
  .byte  243,15,16,20,152                    // movss         (%eax,%ebx,4),%xmm2
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  243,15,16,36,176                    // movss         (%eax,%esi,4),%xmm4
  .byte  243,15,16,60,136                    // movss         (%eax,%ecx,4),%xmm7
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  15,20,231                           // unpcklps      %xmm7,%xmm4
  .byte  102,15,20,227                       // unpcklpd      %xmm3,%xmm4
  .byte  102,15,41,101,216                   // movapd        %xmm4,-0x28(%ebp)
  .byte  139,66,12                           // mov           0xc(%edx),%eax
  .byte  243,15,16,20,152                    // movss         (%eax,%ebx,4),%xmm2
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  243,15,16,20,176                    // movss         (%eax,%esi,4),%xmm2
  .byte  243,15,16,60,136                    // movss         (%eax,%ecx,4),%xmm7
  .byte  15,20,215                           // unpcklps      %xmm7,%xmm2
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  139,66,28                           // mov           0x1c(%edx),%eax
  .byte  243,15,16,60,152                    // movss         (%eax,%ebx,4),%xmm7
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  15,20,223                           // unpcklps      %xmm7,%xmm3
  .byte  243,15,16,60,176                    // movss         (%eax,%esi,4),%xmm7
  .byte  243,15,16,44,136                    // movss         (%eax,%ecx,4),%xmm5
  .byte  15,20,253                           // unpcklps      %xmm5,%xmm7
  .byte  102,15,20,251                       // unpcklpd      %xmm3,%xmm7
  .byte  139,66,16                           // mov           0x10(%edx),%eax
  .byte  243,15,16,28,152                    // movss         (%eax,%ebx,4),%xmm3
  .byte  243,15,16,44,184                    // movss         (%eax,%edi,4),%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  243,15,16,28,176                    // movss         (%eax,%esi,4),%xmm3
  .byte  243,15,16,52,136                    // movss         (%eax,%ecx,4),%xmm6
  .byte  15,20,222                           // unpcklps      %xmm6,%xmm3
  .byte  102,15,20,221                       // unpcklpd      %xmm5,%xmm3
  .byte  139,66,32                           // mov           0x20(%edx),%eax
  .byte  243,15,16,44,152                    // movss         (%eax,%ebx,4),%xmm5
  .byte  243,15,16,52,184                    // movss         (%eax,%edi,4),%xmm6
  .byte  15,20,245                           // unpcklps      %xmm5,%xmm6
  .byte  243,15,16,44,176                    // movss         (%eax,%esi,4),%xmm5
  .byte  243,15,16,36,136                    // movss         (%eax,%ecx,4),%xmm4
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  102,15,20,238                       // unpcklpd      %xmm6,%xmm5
  .byte  15,40,101,184                       // movaps        -0x48(%ebp),%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,88,101,200                       // addps         -0x38(%ebp),%xmm4
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,88,77,216                        // addps         -0x28(%ebp),%xmm1
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  137,193                             // mov           %eax,%ecx
  .byte  141,65,8                            // lea           0x8(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,76                          // add           $0x4c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_evenly_spaced_2_stop_gradient_sse2
.globl _sk_evenly_spaced_2_stop_gradient_sse2
FUNCTION(_sk_evenly_spaced_2_stop_gradient_sse2)
_sk_evenly_spaced_2_stop_gradient_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,1                         // movss         (%ecx),%xmm0
  .byte  243,15,16,73,4                      // movss         0x4(%ecx),%xmm1
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,15,16,81,16                     // movss         0x10(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  243,15,16,81,20                     // movss         0x14(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  243,15,16,81,8                      // movss         0x8(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,89,24                     // movss         0x18(%ecx),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  243,15,16,89,12                     // movss         0xc(%ecx),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  243,15,16,105,28                    // movss         0x1c(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_xy_to_unit_angle_sse2
.globl _sk_xy_to_unit_angle_sse2
FUNCTION(_sk_xy_to_unit_angle_sse2)
_sk_xy_to_unit_angle_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,24                          // sub           $0x18,%esp
  .byte  15,41,93,232                        // movaps        %xmm3,-0x18(%ebp)
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          7076 <_sk_xy_to_unit_angle_sse2+0x18>
  .byte  88                                  // pop           %eax
  .byte  15,87,237                           // xorps         %xmm5,%xmm5
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  15,84,233                           // andps         %xmm1,%xmm5
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,92,226                           // subps         %xmm2,%xmm4
  .byte  15,84,226                           // andps         %xmm2,%xmm4
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  15,93,244                           // minps         %xmm4,%xmm6
  .byte  15,40,253                           // movaps        %xmm5,%xmm7
  .byte  15,95,252                           // maxps         %xmm4,%xmm7
  .byte  15,94,247                           // divps         %xmm7,%xmm6
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  15,89,255                           // mulps         %xmm7,%xmm7
  .byte  15,40,128,74,144,0,0                // movaps        0x904a(%eax),%xmm0
  .byte  15,89,199                           // mulps         %xmm7,%xmm0
  .byte  15,88,128,90,144,0,0                // addps         0x905a(%eax),%xmm0
  .byte  15,89,199                           // mulps         %xmm7,%xmm0
  .byte  15,88,128,106,144,0,0               // addps         0x906a(%eax),%xmm0
  .byte  15,89,199                           // mulps         %xmm7,%xmm0
  .byte  15,88,128,122,144,0,0               // addps         0x907a(%eax),%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,194,236,1                        // cmpltps       %xmm4,%xmm5
  .byte  15,40,176,138,144,0,0               // movaps        0x908a(%eax),%xmm6
  .byte  15,92,240                           // subps         %xmm0,%xmm6
  .byte  15,84,245                           // andps         %xmm5,%xmm6
  .byte  15,85,232                           // andnps        %xmm0,%xmm5
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,86,238                           // orps          %xmm6,%xmm5
  .byte  15,194,204,1                        // cmpltps       %xmm4,%xmm1
  .byte  15,40,128,154,138,0,0               // movaps        0x8a9a(%eax),%xmm0
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,84,193                           // andps         %xmm1,%xmm0
  .byte  15,85,205                           // andnps        %xmm5,%xmm1
  .byte  15,86,200                           // orps          %xmm0,%xmm1
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,194,196,1                        // cmpltps       %xmm4,%xmm0
  .byte  15,40,168,170,138,0,0               // movaps        0x8aaa(%eax),%xmm5
  .byte  15,92,233                           // subps         %xmm1,%xmm5
  .byte  15,84,232                           // andps         %xmm0,%xmm5
  .byte  15,85,193                           // andnps        %xmm1,%xmm0
  .byte  15,86,197                           // orps          %xmm5,%xmm0
  .byte  15,194,224,7                        // cmpordps      %xmm0,%xmm4
  .byte  15,84,224                           // andps         %xmm0,%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  141,72,4                            // lea           0x4(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,40,93,232                        // movaps        -0x18(%ebp),%xmm3
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,40                          // add           $0x28,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_xy_to_radius_sse2
.globl _sk_xy_to_radius_sse2
FUNCTION(_sk_xy_to_radius_sse2)
_sk_xy_to_radius_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,89,228                           // mulps         %xmm4,%xmm4
  .byte  15,88,224                           // addps         %xmm0,%xmm4
  .byte  15,81,196                           // sqrtps        %xmm4,%xmm0
  .byte  141,72,4                            // lea           0x4(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_xy_to_2pt_conical_quadratic_first_sse2
.globl _sk_xy_to_2pt_conical_quadratic_first_sse2
FUNCTION(_sk_xy_to_2pt_conical_quadratic_first_sse2)
_sk_xy_to_2pt_conical_quadratic_first_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,105,72                    // movss         0x48(%ecx),%xmm5
  .byte  243,15,16,97,76                     // movss         0x4c(%ecx),%xmm4
  .byte  243,15,89,229                       // mulss         %xmm5,%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,88,224                           // addps         %xmm0,%xmm4
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  15,40,241                           // movaps        %xmm1,%xmm6
  .byte  15,89,246                           // mulps         %xmm6,%xmm6
  .byte  15,88,240                           // addps         %xmm0,%xmm6
  .byte  232,0,0,0,0                         // call          7193 <_sk_xy_to_2pt_conical_quadratic_first_sse2+0x31>
  .byte  90                                  // pop           %edx
  .byte  243,15,89,237                       // mulss         %xmm5,%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,92,245                           // subps         %xmm5,%xmm6
  .byte  243,15,16,65,64                     // movss         0x40(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,89,162,125,143,0,0               // mulps         0x8f7d(%edx),%xmm4
  .byte  15,89,130,141,143,0,0               // mulps         0x8f8d(%edx),%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,89,237                           // mulps         %xmm5,%xmm5
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  15,81,237                           // sqrtps        %xmm5,%xmm5
  .byte  15,92,236                           // subps         %xmm4,%xmm5
  .byte  243,15,16,65,68                     // movss         0x44(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,89,130,125,137,0,0               // mulps         0x897d(%edx),%xmm0
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_xy_to_2pt_conical_quadratic_second_sse2
.globl _sk_xy_to_2pt_conical_quadratic_second_sse2
FUNCTION(_sk_xy_to_2pt_conical_quadratic_second_sse2)
_sk_xy_to_2pt_conical_quadratic_second_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,105,72                    // movss         0x48(%ecx),%xmm5
  .byte  243,15,16,97,76                     // movss         0x4c(%ecx),%xmm4
  .byte  243,15,89,229                       // mulss         %xmm5,%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,88,224                           // addps         %xmm0,%xmm4
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  15,40,241                           // movaps        %xmm1,%xmm6
  .byte  15,89,246                           // mulps         %xmm6,%xmm6
  .byte  15,88,240                           // addps         %xmm0,%xmm6
  .byte  232,0,0,0,0                         // call          721e <_sk_xy_to_2pt_conical_quadratic_second_sse2+0x31>
  .byte  90                                  // pop           %edx
  .byte  243,15,89,237                       // mulss         %xmm5,%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,92,245                           // subps         %xmm5,%xmm6
  .byte  243,15,16,65,64                     // movss         0x40(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,89,162,242,142,0,0               // mulps         0x8ef2(%edx),%xmm4
  .byte  15,89,130,2,143,0,0                 // mulps         0x8f02(%edx),%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,89,237                           // mulps         %xmm5,%xmm5
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  15,81,197                           // sqrtps        %xmm5,%xmm0
  .byte  15,87,162,242,141,0,0               // xorps         0x8df2(%edx),%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  243,15,16,65,68                     // movss         0x44(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,89,130,242,136,0,0               // mulps         0x88f2(%edx),%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_xy_to_2pt_conical_linear_sse2
.globl _sk_xy_to_2pt_conical_linear_sse2
FUNCTION(_sk_xy_to_2pt_conical_linear_sse2)
_sk_xy_to_2pt_conical_linear_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          728a <_sk_xy_to_2pt_conical_linear_sse2+0xb>
  .byte  89                                  // pop           %ecx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,16                              // mov           (%eax),%edx
  .byte  243,15,16,98,72                     // movss         0x48(%edx),%xmm4
  .byte  243,15,16,106,76                    // movss         0x4c(%edx),%xmm5
  .byte  243,15,89,236                       // mulss         %xmm4,%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  15,89,169,134,142,0,0               // mulps         0x8e86(%ecx),%xmm5
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  15,40,241                           // movaps        %xmm1,%xmm6
  .byte  15,89,246                           // mulps         %xmm6,%xmm6
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  243,15,89,228                       // mulss         %xmm4,%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,87,129,134,141,0,0               // xorps         0x8d86(%ecx),%xmm0
  .byte  15,94,197                           // divps         %xmm5,%xmm0
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_mask_2pt_conical_degenerates_sse2
.globl _sk_mask_2pt_conical_degenerates_sse2
FUNCTION(_sk_mask_2pt_conical_degenerates_sse2)
_sk_mask_2pt_conical_degenerates_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  243,15,16,98,72                     // movss         0x48(%edx),%xmm4
  .byte  243,15,16,106,76                    // movss         0x4c(%edx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  15,88,236                           // addps         %xmm4,%xmm5
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,194,236,1                        // cmpltps       %xmm4,%xmm5
  .byte  15,194,224,3                        // cmpunordps    %xmm0,%xmm4
  .byte  15,86,229                           // orps          %xmm5,%xmm4
  .byte  102,15,118,237                      // pcmpeqd       %xmm5,%xmm5
  .byte  102,15,239,236                      // pxor          %xmm4,%xmm5
  .byte  243,15,127,42                       // movdqu        %xmm5,(%edx)
  .byte  141,81,8                            // lea           0x8(%ecx),%edx
  .byte  15,85,224                           // andnps        %xmm0,%xmm4
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_apply_vector_mask_sse2
.globl _sk_apply_vector_mask_sse2
FUNCTION(_sk_apply_vector_mask_sse2)
_sk_apply_vector_mask_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  15,16,33                            // movups        (%ecx),%xmm4
  .byte  15,84,196                           // andps         %xmm4,%xmm0
  .byte  15,84,204                           // andps         %xmm4,%xmm1
  .byte  15,84,212                           // andps         %xmm4,%xmm2
  .byte  15,84,220                           // andps         %xmm4,%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_save_xy_sse2
.globl _sk_save_xy_sse2
FUNCTION(_sk_save_xy_sse2)
_sk_save_xy_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,24                          // sub           $0x18,%esp
  .byte  15,41,93,232                        // movaps        %xmm3,-0x18(%ebp)
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  232,0,0,0,0                         // call          7373 <_sk_save_xy_sse2+0x12>
  .byte  88                                  // pop           %eax
  .byte  15,40,160,157,135,0,0               // movaps        0x879d(%eax),%xmm4
  .byte  15,40,232                           // movaps        %xmm0,%xmm5
  .byte  15,88,236                           // addps         %xmm4,%xmm5
  .byte  243,15,91,245                       // cvttps2dq     %xmm5,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,40,253                           // movaps        %xmm5,%xmm7
  .byte  15,194,254,1                        // cmpltps       %xmm6,%xmm7
  .byte  15,40,144,173,135,0,0               // movaps        0x87ad(%eax),%xmm2
  .byte  15,84,250                           // andps         %xmm2,%xmm7
  .byte  15,92,247                           // subps         %xmm7,%xmm6
  .byte  15,92,238                           // subps         %xmm6,%xmm5
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  243,15,91,244                       // cvttps2dq     %xmm4,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,40,252                           // movaps        %xmm4,%xmm7
  .byte  15,194,254,1                        // cmpltps       %xmm6,%xmm7
  .byte  15,84,250                           // andps         %xmm2,%xmm7
  .byte  15,92,247                           // subps         %xmm7,%xmm6
  .byte  15,92,230                           // subps         %xmm6,%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  15,17,1                             // movups        %xmm0,(%ecx)
  .byte  15,17,73,64                         // movups        %xmm1,0x40(%ecx)
  .byte  15,17,169,128,0,0,0                 // movups        %xmm5,0x80(%ecx)
  .byte  15,17,161,192,0,0,0                 // movups        %xmm4,0xc0(%ecx)
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  141,80,8                            // lea           0x8(%eax),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,40,93,232                        // movaps        -0x18(%ebp),%xmm3
  .byte  82                                  // push          %edx
  .byte  81                                  // push          %ecx
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,40                          // add           $0x28,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_accumulate_sse2
.globl _sk_accumulate_sse2
FUNCTION(_sk_accumulate_sse2)
_sk_accumulate_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,17                              // mov           (%ecx),%edx
  .byte  15,16,162,0,1,0,0                   // movups        0x100(%edx),%xmm4
  .byte  15,16,170,64,1,0,0                  // movups        0x140(%edx),%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,88,96,16                         // addps         0x10(%eax),%xmm4
  .byte  15,41,96,16                         // movaps        %xmm4,0x10(%eax)
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,89,225                           // mulps         %xmm1,%xmm4
  .byte  15,88,96,32                         // addps         0x20(%eax),%xmm4
  .byte  15,41,96,32                         // movaps        %xmm4,0x20(%eax)
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,89,226                           // mulps         %xmm2,%xmm4
  .byte  15,88,96,48                         // addps         0x30(%eax),%xmm4
  .byte  15,41,96,48                         // movaps        %xmm4,0x30(%eax)
  .byte  15,89,235                           // mulps         %xmm3,%xmm5
  .byte  15,88,104,64                        // addps         0x40(%eax),%xmm5
  .byte  15,41,104,64                        // movaps        %xmm5,0x40(%eax)
  .byte  141,81,8                            // lea           0x8(%ecx),%edx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  82                                  // push          %edx
  .byte  80                                  // push          %eax
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_bilinear_nx_sse2
.globl _sk_bilinear_nx_sse2
FUNCTION(_sk_bilinear_nx_sse2)
_sk_bilinear_nx_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  80                                  // push          %eax
  .byte  232,0,0,0,0                         // call          745b <_sk_bilinear_nx_sse2+0xa>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  15,16,6                             // movups        (%esi),%xmm0
  .byte  15,16,166,128,0,0,0                 // movups        0x80(%esi),%xmm4
  .byte  15,88,128,213,140,0,0               // addps         0x8cd5(%eax),%xmm0
  .byte  15,40,168,197,134,0,0               // movaps        0x86c5(%eax),%xmm5
  .byte  15,92,236                           // subps         %xmm4,%xmm5
  .byte  15,17,174,0,1,0,0                   // movups        %xmm5,0x100(%esi)
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,20                          // add           $0x14,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_bilinear_px_sse2
.globl _sk_bilinear_px_sse2
FUNCTION(_sk_bilinear_px_sse2)
_sk_bilinear_px_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  80                                  // push          %eax
  .byte  232,0,0,0,0                         // call          74a1 <_sk_bilinear_px_sse2+0xa>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  15,16,6                             // movups        (%esi),%xmm0
  .byte  15,16,166,128,0,0,0                 // movups        0x80(%esi),%xmm4
  .byte  15,88,128,111,134,0,0               // addps         0x866f(%eax),%xmm0
  .byte  15,17,166,0,1,0,0                   // movups        %xmm4,0x100(%esi)
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,20                          // add           $0x14,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_bilinear_ny_sse2
.globl _sk_bilinear_ny_sse2
FUNCTION(_sk_bilinear_ny_sse2)
_sk_bilinear_ny_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  80                                  // push          %eax
  .byte  232,0,0,0,0                         // call          74dd <_sk_bilinear_ny_sse2+0xa>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  15,16,78,64                         // movups        0x40(%esi),%xmm1
  .byte  15,16,166,192,0,0,0                 // movups        0xc0(%esi),%xmm4
  .byte  15,88,136,83,140,0,0                // addps         0x8c53(%eax),%xmm1
  .byte  15,40,168,67,134,0,0                // movaps        0x8643(%eax),%xmm5
  .byte  15,92,236                           // subps         %xmm4,%xmm5
  .byte  15,17,174,64,1,0,0                  // movups        %xmm5,0x140(%esi)
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,20                          // add           $0x14,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_bilinear_py_sse2
.globl _sk_bilinear_py_sse2
FUNCTION(_sk_bilinear_py_sse2)
_sk_bilinear_py_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  80                                  // push          %eax
  .byte  232,0,0,0,0                         // call          7524 <_sk_bilinear_py_sse2+0xa>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  15,16,78,64                         // movups        0x40(%esi),%xmm1
  .byte  15,16,166,192,0,0,0                 // movups        0xc0(%esi),%xmm4
  .byte  15,88,136,236,133,0,0               // addps         0x85ec(%eax),%xmm1
  .byte  15,17,166,64,1,0,0                  // movups        %xmm4,0x140(%esi)
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,20                          // add           $0x14,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_bicubic_n3x_sse2
.globl _sk_bicubic_n3x_sse2
FUNCTION(_sk_bicubic_n3x_sse2)
_sk_bicubic_n3x_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  80                                  // push          %eax
  .byte  232,0,0,0,0                         // call          7561 <_sk_bicubic_n3x_sse2+0xa>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  15,16,6                             // movups        (%esi),%xmm0
  .byte  15,16,166,128,0,0,0                 // movups        0x80(%esi),%xmm4
  .byte  15,88,128,223,139,0,0               // addps         0x8bdf(%eax),%xmm0
  .byte  15,40,168,191,133,0,0               // movaps        0x85bf(%eax),%xmm5
  .byte  15,92,236                           // subps         %xmm4,%xmm5
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,89,228                           // mulps         %xmm4,%xmm4
  .byte  15,89,168,239,139,0,0               // mulps         0x8bef(%eax),%xmm5
  .byte  15,88,168,175,135,0,0               // addps         0x87af(%eax),%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,17,174,0,1,0,0                   // movups        %xmm5,0x100(%esi)
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,20                          // add           $0x14,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_bicubic_n1x_sse2
.globl _sk_bicubic_n1x_sse2
FUNCTION(_sk_bicubic_n1x_sse2)
_sk_bicubic_n1x_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  80                                  // push          %eax
  .byte  232,0,0,0,0                         // call          75be <_sk_bicubic_n1x_sse2+0xa>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  15,16,6                             // movups        (%esi),%xmm0
  .byte  15,16,166,128,0,0,0                 // movups        0x80(%esi),%xmm4
  .byte  15,88,128,114,139,0,0               // addps         0x8b72(%eax),%xmm0
  .byte  15,40,168,98,133,0,0                // movaps        0x8562(%eax),%xmm5
  .byte  15,92,236                           // subps         %xmm4,%xmm5
  .byte  15,40,160,162,139,0,0               // movaps        0x8ba2(%eax),%xmm4
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,88,160,178,139,0,0               // addps         0x8bb2(%eax),%xmm4
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,88,160,82,133,0,0                // addps         0x8552(%eax),%xmm4
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,88,160,194,139,0,0               // addps         0x8bc2(%eax),%xmm4
  .byte  15,17,166,0,1,0,0                   // movups        %xmm4,0x100(%esi)
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,20                          // add           $0x14,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_bicubic_p1x_sse2
.globl _sk_bicubic_p1x_sse2
FUNCTION(_sk_bicubic_p1x_sse2)
_sk_bicubic_p1x_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  80                                  // push          %eax
  .byte  232,0,0,0,0                         // call          7629 <_sk_bicubic_p1x_sse2+0xa>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  15,40,160,231,132,0,0               // movaps        0x84e7(%eax),%xmm4
  .byte  15,16,6                             // movups        (%esi),%xmm0
  .byte  15,16,174,128,0,0,0                 // movups        0x80(%esi),%xmm5
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,40,176,55,139,0,0                // movaps        0x8b37(%eax),%xmm6
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,176,71,139,0,0                // addps         0x8b47(%eax),%xmm6
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,244                           // addps         %xmm4,%xmm6
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,176,87,139,0,0                // addps         0x8b57(%eax),%xmm6
  .byte  15,17,182,0,1,0,0                   // movups        %xmm6,0x100(%esi)
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,20                          // add           $0x14,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_bicubic_p3x_sse2
.globl _sk_bicubic_p3x_sse2
FUNCTION(_sk_bicubic_p3x_sse2)
_sk_bicubic_p3x_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  80                                  // push          %eax
  .byte  232,0,0,0,0                         // call          7689 <_sk_bicubic_p3x_sse2+0xa>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  15,16,6                             // movups        (%esi),%xmm0
  .byte  15,16,166,128,0,0,0                 // movups        0x80(%esi),%xmm4
  .byte  15,88,128,231,138,0,0               // addps         0x8ae7(%eax),%xmm0
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,89,237                           // mulps         %xmm5,%xmm5
  .byte  15,89,160,199,138,0,0               // mulps         0x8ac7(%eax),%xmm4
  .byte  15,88,160,135,134,0,0               // addps         0x8687(%eax),%xmm4
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,17,166,0,1,0,0                   // movups        %xmm4,0x100(%esi)
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,20                          // add           $0x14,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_bicubic_n3y_sse2
.globl _sk_bicubic_n3y_sse2
FUNCTION(_sk_bicubic_n3y_sse2)
_sk_bicubic_n3y_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  80                                  // push          %eax
  .byte  232,0,0,0,0                         // call          76dc <_sk_bicubic_n3y_sse2+0xa>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  15,16,78,64                         // movups        0x40(%esi),%xmm1
  .byte  15,16,166,192,0,0,0                 // movups        0xc0(%esi),%xmm4
  .byte  15,88,136,100,138,0,0               // addps         0x8a64(%eax),%xmm1
  .byte  15,40,168,68,132,0,0                // movaps        0x8444(%eax),%xmm5
  .byte  15,92,236                           // subps         %xmm4,%xmm5
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,89,228                           // mulps         %xmm4,%xmm4
  .byte  15,89,168,116,138,0,0               // mulps         0x8a74(%eax),%xmm5
  .byte  15,88,168,52,134,0,0                // addps         0x8634(%eax),%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,17,174,64,1,0,0                  // movups        %xmm5,0x140(%esi)
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,20                          // add           $0x14,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_bicubic_n1y_sse2
.globl _sk_bicubic_n1y_sse2
FUNCTION(_sk_bicubic_n1y_sse2)
_sk_bicubic_n1y_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  80                                  // push          %eax
  .byte  232,0,0,0,0                         // call          773a <_sk_bicubic_n1y_sse2+0xa>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  15,16,78,64                         // movups        0x40(%esi),%xmm1
  .byte  15,16,166,192,0,0,0                 // movups        0xc0(%esi),%xmm4
  .byte  15,88,136,246,137,0,0               // addps         0x89f6(%eax),%xmm1
  .byte  15,40,168,230,131,0,0               // movaps        0x83e6(%eax),%xmm5
  .byte  15,92,236                           // subps         %xmm4,%xmm5
  .byte  15,40,160,38,138,0,0                // movaps        0x8a26(%eax),%xmm4
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,88,160,54,138,0,0                // addps         0x8a36(%eax),%xmm4
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,88,160,214,131,0,0               // addps         0x83d6(%eax),%xmm4
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,88,160,70,138,0,0                // addps         0x8a46(%eax),%xmm4
  .byte  15,17,166,64,1,0,0                  // movups        %xmm4,0x140(%esi)
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,20                          // add           $0x14,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_bicubic_p1y_sse2
.globl _sk_bicubic_p1y_sse2
FUNCTION(_sk_bicubic_p1y_sse2)
_sk_bicubic_p1y_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  80                                  // push          %eax
  .byte  232,0,0,0,0                         // call          77a6 <_sk_bicubic_p1y_sse2+0xa>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  15,40,160,106,131,0,0               // movaps        0x836a(%eax),%xmm4
  .byte  15,16,78,64                         // movups        0x40(%esi),%xmm1
  .byte  15,16,174,192,0,0,0                 // movups        0xc0(%esi),%xmm5
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  15,40,176,186,137,0,0               // movaps        0x89ba(%eax),%xmm6
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,176,202,137,0,0               // addps         0x89ca(%eax),%xmm6
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,244                           // addps         %xmm4,%xmm6
  .byte  15,89,245                           // mulps         %xmm5,%xmm6
  .byte  15,88,176,218,137,0,0               // addps         0x89da(%eax),%xmm6
  .byte  15,17,182,64,1,0,0                  // movups        %xmm6,0x140(%esi)
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,20                          // add           $0x14,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_bicubic_p3y_sse2
.globl _sk_bicubic_p3y_sse2
FUNCTION(_sk_bicubic_p3y_sse2)
_sk_bicubic_p3y_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  86                                  // push          %esi
  .byte  80                                  // push          %eax
  .byte  232,0,0,0,0                         // call          7807 <_sk_bicubic_p3y_sse2+0xa>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  15,16,78,64                         // movups        0x40(%esi),%xmm1
  .byte  15,16,166,192,0,0,0                 // movups        0xc0(%esi),%xmm4
  .byte  15,88,136,105,137,0,0               // addps         0x8969(%eax),%xmm1
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,89,237                           // mulps         %xmm5,%xmm5
  .byte  15,89,160,73,137,0,0                // mulps         0x8949(%eax),%xmm4
  .byte  15,88,160,9,133,0,0                 // addps         0x8509(%eax),%xmm4
  .byte  15,89,229                           // mulps         %xmm5,%xmm4
  .byte  15,17,166,64,1,0,0                  // movups        %xmm4,0x140(%esi)
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  81                                  // push          %ecx
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,20                          // add           $0x14,%esp
  .byte  94                                  // pop           %esi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_callback_sse2
.globl _sk_callback_sse2
FUNCTION(_sk_callback_sse2)
_sk_callback_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,12                          // sub           $0xc,%esp
  .byte  139,117,8                           // mov           0x8(%ebp),%esi
  .byte  139,125,12                          // mov           0xc(%ebp),%edi
  .byte  139,31                              // mov           (%edi),%ebx
  .byte  139,70,8                            // mov           0x8(%esi),%eax
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,20,225                           // unpcklps      %xmm1,%xmm4
  .byte  15,40,234                           // movaps        %xmm2,%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  15,21,193                           // unpckhps      %xmm1,%xmm0
  .byte  15,21,211                           // unpckhps      %xmm3,%xmm2
  .byte  15,40,204                           // movaps        %xmm4,%xmm1
  .byte  102,15,20,205                       // unpcklpd      %xmm5,%xmm1
  .byte  15,18,236                           // movhlps       %xmm4,%xmm5
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  102,15,20,218                       // unpcklpd      %xmm2,%xmm3
  .byte  102,15,17,75,4                      // movupd        %xmm1,0x4(%ebx)
  .byte  15,18,208                           // movhlps       %xmm0,%xmm2
  .byte  15,17,107,20                        // movups        %xmm5,0x14(%ebx)
  .byte  102,15,17,91,36                     // movupd        %xmm3,0x24(%ebx)
  .byte  15,17,83,52                         // movups        %xmm2,0x34(%ebx)
  .byte  133,192                             // test          %eax,%eax
  .byte  185,4,0,0,0                         // mov           $0x4,%ecx
  .byte  15,69,200                           // cmovne        %eax,%ecx
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  81                                  // push          %ecx
  .byte  83                                  // push          %ebx
  .byte  255,19                              // call          *(%ebx)
  .byte  131,196,16                          // add           $0x10,%esp
  .byte  139,131,4,1,0,0                     // mov           0x104(%ebx),%eax
  .byte  15,16,32                            // movups        (%eax),%xmm4
  .byte  15,16,64,16                         // movups        0x10(%eax),%xmm0
  .byte  15,16,88,32                         // movups        0x20(%eax),%xmm3
  .byte  15,16,80,48                         // movups        0x30(%eax),%xmm2
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,20,202                           // unpcklps      %xmm2,%xmm1
  .byte  15,21,224                           // unpckhps      %xmm0,%xmm4
  .byte  15,21,218                           // unpckhps      %xmm2,%xmm3
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  102,15,20,193                       // unpcklpd      %xmm1,%xmm0
  .byte  15,18,205                           // movhlps       %xmm5,%xmm1
  .byte  15,40,212                           // movaps        %xmm4,%xmm2
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  15,18,220                           // movhlps       %xmm4,%xmm3
  .byte  141,71,8                            // lea           0x8(%edi),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  80                                  // push          %eax
  .byte  86                                  // push          %esi
  .byte  255,87,4                            // call          *0x4(%edi)
  .byte  131,196,28                          // add           $0x1c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_clut_3D_sse2
.globl _sk_clut_3D_sse2
FUNCTION(_sk_clut_3D_sse2)
_sk_clut_3D_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,28,1,0,0                    // sub           $0x11c,%esp
  .byte  15,41,157,216,254,255,255           // movaps        %xmm3,-0x128(%ebp)
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,81,12                           // mov           0xc(%ecx),%edx
  .byte  141,114,255                         // lea           -0x1(%edx),%esi
  .byte  102,15,110,198                      // movd          %esi,%xmm0
  .byte  102,15,112,192,0                    // pshufd        $0x0,%xmm0,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,41,165,248,254,255,255           // movaps        %xmm4,-0x108(%ebp)
  .byte  102,15,110,194                      // movd          %edx,%xmm0
  .byte  102,15,112,240,0                    // pshufd        $0x0,%xmm0,%xmm6
  .byte  102,15,127,117,152                  // movdqa        %xmm6,-0x68(%ebp)
  .byte  139,81,8                            // mov           0x8(%ecx),%edx
  .byte  141,114,255                         // lea           -0x1(%edx),%esi
  .byte  102,15,110,214                      // movd          %esi,%xmm2
  .byte  102,15,112,210,0                    // pshufd        $0x0,%xmm2,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  15,41,149,88,255,255,255            // movaps        %xmm2,-0xa8(%ebp)
  .byte  243,15,91,234                       // cvttps2dq     %xmm2,%xmm5
  .byte  102,15,127,173,40,255,255,255       // movdqa        %xmm5,-0xd8(%ebp)
  .byte  102,15,112,205,245                  // pshufd        $0xf5,%xmm5,%xmm1
  .byte  102,15,244,206                      // pmuludq       %xmm6,%xmm1
  .byte  102,15,111,214                      // movdqa        %xmm6,%xmm2
  .byte  102,15,244,213                      // pmuludq       %xmm5,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,112,201,232                  // pshufd        $0xe8,%xmm1,%xmm1
  .byte  102,15,98,209                       // punpckldq     %xmm1,%xmm2
  .byte  102,15,111,234                      // movdqa        %xmm2,%xmm5
  .byte  102,15,127,109,168                  // movdqa        %xmm5,-0x58(%ebp)
  .byte  102,15,110,202                      // movd          %edx,%xmm1
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  139,81,4                            // mov           0x4(%ecx),%edx
  .byte  74                                  // dec           %edx
  .byte  102,15,110,194                      // movd          %edx,%xmm0
  .byte  102,15,112,192,0                    // pshufd        $0x0,%xmm0,%xmm0
  .byte  15,91,192                           // cvtdq2ps      %xmm0,%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,41,69,216                        // movaps        %xmm0,-0x28(%ebp)
  .byte  102,15,112,209,0                    // pshufd        $0x0,%xmm1,%xmm2
  .byte  243,15,91,216                       // cvttps2dq     %xmm0,%xmm3
  .byte  102,15,127,93,184                   // movdqa        %xmm3,-0x48(%ebp)
  .byte  102,15,112,195,245                  // pshufd        $0xf5,%xmm3,%xmm0
  .byte  102,15,244,194                      // pmuludq       %xmm2,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,244,203                      // pmuludq       %xmm3,%xmm1
  .byte  102,15,112,201,232                  // pshufd        $0xe8,%xmm1,%xmm1
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,98,200                       // punpckldq     %xmm0,%xmm1
  .byte  102,15,127,77,136                   // movdqa        %xmm1,-0x78(%ebp)
  .byte  232,0,0,0,0                         // call          79ed <_sk_clut_3D_sse2+0xee>
  .byte  90                                  // pop           %edx
  .byte  243,15,91,196                       // cvttps2dq     %xmm4,%xmm0
  .byte  102,15,127,133,8,255,255,255        // movdqa        %xmm0,-0xf8(%ebp)
  .byte  102,15,111,221                      // movdqa        %xmm5,%xmm3
  .byte  102,15,254,216                      // paddd         %xmm0,%xmm3
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,254,195                      // paddd         %xmm3,%xmm0
  .byte  102,15,111,162,179,135,0,0          // movdqa        0x87b3(%edx),%xmm4
  .byte  102,15,127,165,120,255,255,255      // movdqa        %xmm4,-0x88(%ebp)
  .byte  102,15,112,200,245                  // pshufd        $0xf5,%xmm0,%xmm1
  .byte  102,15,244,196                      // pmuludq       %xmm4,%xmm0
  .byte  102,15,244,204                      // pmuludq       %xmm4,%xmm1
  .byte  102,15,112,225,232                  // pshufd        $0xe8,%xmm1,%xmm4
  .byte  102,15,112,200,232                  // pshufd        $0xe8,%xmm0,%xmm1
  .byte  102,15,98,204                       // punpckldq     %xmm4,%xmm1
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,112,193,229                  // pshufd        $0xe5,%xmm1,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  102,15,112,193,231                  // pshufd        $0xe7,%xmm1,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  139,9                               // mov           (%ecx),%ecx
  .byte  243,15,16,4,129                     // movss         (%ecx,%eax,4),%xmm0
  .byte  243,15,16,36,153                    // movss         (%ecx,%ebx,4),%xmm4
  .byte  15,20,224                           // unpcklps      %xmm0,%xmm4
  .byte  243,15,16,4,185                     // movss         (%ecx,%edi,4),%xmm0
  .byte  243,15,16,44,177                    // movss         (%ecx,%esi,4),%xmm5
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  102,15,20,236                       // unpcklpd      %xmm4,%xmm5
  .byte  102,15,118,228                      // pcmpeqd       %xmm4,%xmm4
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,250,196                      // psubd         %xmm4,%xmm0
  .byte  102,15,112,224,229                  // pshufd        $0xe5,%xmm0,%xmm4
  .byte  102,15,126,224                      // movd          %xmm4,%eax
  .byte  102,15,112,224,78                   // pshufd        $0x4e,%xmm0,%xmm4
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,153                     // movss         (%ecx,%ebx,4),%xmm0
  .byte  243,15,16,36,177                    // movss         (%ecx,%esi,4),%xmm4
  .byte  15,20,224                           // unpcklps      %xmm0,%xmm4
  .byte  243,15,16,60,185                    // movss         (%ecx,%edi,4),%xmm7
  .byte  243,15,16,4,129                     // movss         (%ecx,%eax,4),%xmm0
  .byte  15,20,248                           // unpcklps      %xmm0,%xmm7
  .byte  102,15,20,252                       // unpcklpd      %xmm4,%xmm7
  .byte  102,15,111,130,115,129,0,0          // movdqa        0x8173(%edx),%xmm0
  .byte  102,15,127,133,104,255,255,255      // movdqa        %xmm0,-0x98(%ebp)
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,112,193,229                  // pshufd        $0xe5,%xmm1,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,193,231                  // pshufd        $0xe7,%xmm1,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,153                     // movss         (%ecx,%ebx,4),%xmm0
  .byte  243,15,16,12,177                    // movss         (%ecx,%esi,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,15,16,52,185                    // movss         (%ecx,%edi,4),%xmm6
  .byte  243,15,16,4,129                     // movss         (%ecx,%eax,4),%xmm0
  .byte  15,20,240                           // unpcklps      %xmm0,%xmm6
  .byte  102,15,20,241                       // unpcklpd      %xmm1,%xmm6
  .byte  15,40,130,163,135,0,0               // movaps        0x87a3(%edx),%xmm0
  .byte  15,40,141,248,254,255,255           // movaps        -0x108(%ebp),%xmm1
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  15,41,77,200                        // movaps        %xmm1,-0x38(%ebp)
  .byte  15,40,141,88,255,255,255            // movaps        -0xa8(%ebp),%xmm1
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  15,41,141,72,255,255,255            // movaps        %xmm1,-0xb8(%ebp)
  .byte  15,88,69,216                        // addps         -0x28(%ebp),%xmm0
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,112,200,245                  // pshufd        $0xf5,%xmm0,%xmm1
  .byte  102,15,244,202                      // pmuludq       %xmm2,%xmm1
  .byte  102,15,244,208                      // pmuludq       %xmm0,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,98,208                       // punpckldq     %xmm0,%xmm2
  .byte  102,15,127,149,24,255,255,255       // movdqa        %xmm2,-0xe8(%ebp)
  .byte  102,15,254,218                      // paddd         %xmm2,%xmm3
  .byte  102,15,112,195,245                  // pshufd        $0xf5,%xmm3,%xmm0
  .byte  102,15,111,141,120,255,255,255      // movdqa        -0x88(%ebp),%xmm1
  .byte  102,15,244,217                      // pmuludq       %xmm1,%xmm3
  .byte  102,15,244,193                      // pmuludq       %xmm1,%xmm0
  .byte  102,15,112,200,232                  // pshufd        $0xe8,%xmm0,%xmm1
  .byte  102,15,112,195,232                  // pshufd        $0xe8,%xmm3,%xmm0
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,15,126,202                      // movd          %xmm1,%edx
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,112,200,231                  // pshufd        $0xe7,%xmm0,%xmm1
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  243,15,16,12,185                    // movss         (%ecx,%edi,4),%xmm1
  .byte  243,15,16,20,177                    // movss         (%ecx,%esi,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  243,15,16,12,145                    // movss         (%ecx,%edx,4),%xmm1
  .byte  243,15,16,28,129                    // movss         (%ecx,%eax,4),%xmm3
  .byte  15,20,217                           // unpcklps      %xmm1,%xmm3
  .byte  102,15,20,218                       // unpcklpd      %xmm2,%xmm3
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,118,210                      // pcmpeqd       %xmm2,%xmm2
  .byte  102,15,250,202                      // psubd         %xmm2,%xmm1
  .byte  102,15,112,209,229                  // pshufd        $0xe5,%xmm1,%xmm2
  .byte  102,15,126,208                      // movd          %xmm2,%eax
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,15,126,210                      // movd          %xmm2,%edx
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,112,201,231                  // pshufd        $0xe7,%xmm1,%xmm1
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  243,15,16,20,185                    // movss         (%ecx,%edi,4),%xmm2
  .byte  243,15,16,12,145                    // movss         (%ecx,%edx,4),%xmm1
  .byte  15,20,202                           // unpcklps      %xmm2,%xmm1
  .byte  243,15,16,20,177                    // movss         (%ecx,%esi,4),%xmm2
  .byte  243,15,16,36,129                    // movss         (%ecx,%eax,4),%xmm4
  .byte  15,20,212                           // unpcklps      %xmm4,%xmm2
  .byte  102,15,20,209                       // unpcklpd      %xmm1,%xmm2
  .byte  102,15,254,133,104,255,255,255      // paddd         -0x98(%ebp),%xmm0
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,15,126,202                      // movd          %xmm1,%edx
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  243,15,16,4,185                     // movss         (%ecx,%edi,4),%xmm0
  .byte  243,15,16,36,145                    // movss         (%ecx,%edx,4),%xmm4
  .byte  15,20,224                           // unpcklps      %xmm0,%xmm4
  .byte  243,15,16,12,177                    // movss         (%ecx,%esi,4),%xmm1
  .byte  243,15,16,4,129                     // movss         (%ecx,%eax,4),%xmm0
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  102,15,20,204                       // unpcklpd      %xmm4,%xmm1
  .byte  15,91,69,184                        // cvtdq2ps      -0x48(%ebp),%xmm0
  .byte  15,40,101,216                       // movaps        -0x28(%ebp),%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,41,101,216                       // movaps        %xmm4,-0x28(%ebp)
  .byte  15,92,221                           // subps         %xmm5,%xmm3
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  15,41,93,184                        // movaps        %xmm3,-0x48(%ebp)
  .byte  15,92,215                           // subps         %xmm7,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  15,41,149,56,255,255,255            // movaps        %xmm2,-0xc8(%ebp)
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,41,141,232,254,255,255           // movaps        %xmm1,-0x118(%ebp)
  .byte  243,15,91,133,72,255,255,255        // cvttps2dq     -0xb8(%ebp),%xmm0
  .byte  102,15,112,224,245                  // pshufd        $0xf5,%xmm0,%xmm4
  .byte  102,15,111,77,152                   // movdqa        -0x68(%ebp),%xmm1
  .byte  102,15,244,225                      // pmuludq       %xmm1,%xmm4
  .byte  102,15,111,233                      // movdqa        %xmm1,%xmm5
  .byte  102,15,244,232                      // pmuludq       %xmm0,%xmm5
  .byte  102,15,112,253,232                  // pshufd        $0xe8,%xmm5,%xmm7
  .byte  102,15,112,196,232                  // pshufd        $0xe8,%xmm4,%xmm0
  .byte  102,15,98,248                       // punpckldq     %xmm0,%xmm7
  .byte  102,15,127,125,152                  // movdqa        %xmm7,-0x68(%ebp)
  .byte  102,15,254,189,8,255,255,255        // paddd         -0xf8(%ebp),%xmm7
  .byte  102,15,111,199                      // movdqa        %xmm7,%xmm0
  .byte  102,15,254,69,136                   // paddd         -0x78(%ebp),%xmm0
  .byte  102,15,112,224,245                  // pshufd        $0xf5,%xmm0,%xmm4
  .byte  102,15,111,141,120,255,255,255      // movdqa        -0x88(%ebp),%xmm1
  .byte  102,15,244,193                      // pmuludq       %xmm1,%xmm0
  .byte  102,15,244,225                      // pmuludq       %xmm1,%xmm4
  .byte  102,15,112,228,232                  // pshufd        $0xe8,%xmm4,%xmm4
  .byte  102,15,112,232,232                  // pshufd        $0xe8,%xmm0,%xmm5
  .byte  102,15,98,236                       // punpckldq     %xmm4,%xmm5
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,197,229                  // pshufd        $0xe5,%xmm5,%xmm0
  .byte  102,15,126,194                      // movd          %xmm0,%edx
  .byte  102,15,112,197,78                   // pshufd        $0x4e,%xmm5,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,112,197,231                  // pshufd        $0xe7,%xmm5,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  243,15,16,4,185                     // movss         (%ecx,%edi,4),%xmm0
  .byte  243,15,16,36,177                    // movss         (%ecx,%esi,4),%xmm4
  .byte  15,20,224                           // unpcklps      %xmm0,%xmm4
  .byte  243,15,16,4,145                     // movss         (%ecx,%edx,4),%xmm0
  .byte  243,15,16,20,129                    // movss         (%ecx,%eax,4),%xmm2
  .byte  15,20,208                           // unpcklps      %xmm0,%xmm2
  .byte  102,15,20,212                       // unpcklpd      %xmm4,%xmm2
  .byte  102,15,41,149,72,255,255,255        // movapd        %xmm2,-0xb8(%ebp)
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,118,219                      // pcmpeqd       %xmm3,%xmm3
  .byte  102,15,250,195                      // psubd         %xmm3,%xmm0
  .byte  102,15,118,210                      // pcmpeqd       %xmm2,%xmm2
  .byte  102,15,112,224,229                  // pshufd        $0xe5,%xmm0,%xmm4
  .byte  102,15,126,224                      // movd          %xmm4,%eax
  .byte  102,15,112,224,78                   // pshufd        $0x4e,%xmm0,%xmm4
  .byte  102,15,126,226                      // movd          %xmm4,%edx
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  243,15,16,36,185                    // movss         (%ecx,%edi,4),%xmm4
  .byte  243,15,16,4,145                     // movss         (%ecx,%edx,4),%xmm0
  .byte  15,20,196                           // unpcklps      %xmm4,%xmm0
  .byte  243,15,16,36,177                    // movss         (%ecx,%esi,4),%xmm4
  .byte  243,15,16,52,129                    // movss         (%ecx,%eax,4),%xmm6
  .byte  15,20,230                           // unpcklps      %xmm6,%xmm4
  .byte  102,15,20,224                       // unpcklpd      %xmm0,%xmm4
  .byte  102,15,111,157,104,255,255,255      // movdqa        -0x98(%ebp),%xmm3
  .byte  102,15,254,235                      // paddd         %xmm3,%xmm5
  .byte  102,15,112,197,229                  // pshufd        $0xe5,%xmm5,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,197,78                   // pshufd        $0x4e,%xmm5,%xmm0
  .byte  102,15,126,194                      // movd          %xmm0,%edx
  .byte  102,15,126,238                      // movd          %xmm5,%esi
  .byte  102,15,112,197,231                  // pshufd        $0xe7,%xmm5,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  243,15,16,4,185                     // movss         (%ecx,%edi,4),%xmm0
  .byte  243,15,16,52,145                    // movss         (%ecx,%edx,4),%xmm6
  .byte  15,20,240                           // unpcklps      %xmm0,%xmm6
  .byte  243,15,16,44,177                    // movss         (%ecx,%esi,4),%xmm5
  .byte  243,15,16,4,129                     // movss         (%ecx,%eax,4),%xmm0
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  102,15,20,238                       // unpcklpd      %xmm6,%xmm5
  .byte  102,15,254,189,24,255,255,255       // paddd         -0xe8(%ebp),%xmm7
  .byte  102,15,112,199,245                  // pshufd        $0xf5,%xmm7,%xmm0
  .byte  102,15,244,249                      // pmuludq       %xmm1,%xmm7
  .byte  102,15,244,193                      // pmuludq       %xmm1,%xmm0
  .byte  102,15,112,240,232                  // pshufd        $0xe8,%xmm0,%xmm6
  .byte  102,15,112,199,232                  // pshufd        $0xe8,%xmm7,%xmm0
  .byte  102,15,98,198                       // punpckldq     %xmm6,%xmm0
  .byte  102,15,126,248                      // movd          %xmm7,%eax
  .byte  102,15,112,240,229                  // pshufd        $0xe5,%xmm0,%xmm6
  .byte  102,15,126,242                      // movd          %xmm6,%edx
  .byte  102,15,112,240,78                   // pshufd        $0x4e,%xmm0,%xmm6
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  102,15,112,240,231                  // pshufd        $0xe7,%xmm0,%xmm6
  .byte  102,15,126,247                      // movd          %xmm6,%edi
  .byte  243,15,16,52,185                    // movss         (%ecx,%edi,4),%xmm6
  .byte  243,15,16,60,177                    // movss         (%ecx,%esi,4),%xmm7
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  243,15,16,52,145                    // movss         (%ecx,%edx,4),%xmm6
  .byte  243,15,16,12,129                    // movss         (%ecx,%eax,4),%xmm1
  .byte  15,20,206                           // unpcklps      %xmm6,%xmm1
  .byte  102,15,20,207                       // unpcklpd      %xmm7,%xmm1
  .byte  102,15,111,240                      // movdqa        %xmm0,%xmm6
  .byte  102,15,250,242                      // psubd         %xmm2,%xmm6
  .byte  102,15,112,254,229                  // pshufd        $0xe5,%xmm6,%xmm7
  .byte  102,15,126,248                      // movd          %xmm7,%eax
  .byte  102,15,112,254,78                   // pshufd        $0x4e,%xmm6,%xmm7
  .byte  102,15,126,250                      // movd          %xmm7,%edx
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  102,15,112,246,231                  // pshufd        $0xe7,%xmm6,%xmm6
  .byte  102,15,126,247                      // movd          %xmm6,%edi
  .byte  243,15,16,52,185                    // movss         (%ecx,%edi,4),%xmm6
  .byte  243,15,16,60,145                    // movss         (%ecx,%edx,4),%xmm7
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  243,15,16,20,177                    // movss         (%ecx,%esi,4),%xmm2
  .byte  243,15,16,52,129                    // movss         (%ecx,%eax,4),%xmm6
  .byte  15,20,214                           // unpcklps      %xmm6,%xmm2
  .byte  102,15,20,215                       // unpcklpd      %xmm7,%xmm2
  .byte  102,15,111,251                      // movdqa        %xmm3,%xmm7
  .byte  102,15,254,199                      // paddd         %xmm7,%xmm0
  .byte  102,15,112,240,229                  // pshufd        $0xe5,%xmm0,%xmm6
  .byte  102,15,126,240                      // movd          %xmm6,%eax
  .byte  102,15,112,240,78                   // pshufd        $0x4e,%xmm0,%xmm6
  .byte  102,15,126,242                      // movd          %xmm6,%edx
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  243,15,16,4,185                     // movss         (%ecx,%edi,4),%xmm0
  .byte  243,15,16,52,145                    // movss         (%ecx,%edx,4),%xmm6
  .byte  15,20,240                           // unpcklps      %xmm0,%xmm6
  .byte  243,15,16,28,177                    // movss         (%ecx,%esi,4),%xmm3
  .byte  243,15,16,4,129                     // movss         (%ecx,%eax,4),%xmm0
  .byte  15,20,216                           // unpcklps      %xmm0,%xmm3
  .byte  102,15,20,222                       // unpcklpd      %xmm6,%xmm3
  .byte  15,40,181,72,255,255,255            // movaps        -0xb8(%ebp),%xmm6
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,92,212                           // subps         %xmm4,%xmm2
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  15,92,221                           // subps         %xmm5,%xmm3
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  15,91,133,40,255,255,255            // cvtdq2ps      -0xd8(%ebp),%xmm0
  .byte  15,40,165,88,255,255,255            // movaps        -0xa8(%ebp),%xmm4
  .byte  15,92,224                           // subps         %xmm0,%xmm4
  .byte  15,41,165,88,255,255,255            // movaps        %xmm4,-0xa8(%ebp)
  .byte  15,40,69,184                        // movaps        -0x48(%ebp),%xmm0
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  15,41,77,184                        // movaps        %xmm1,-0x48(%ebp)
  .byte  15,40,133,56,255,255,255            // movaps        -0xc8(%ebp),%xmm0
  .byte  15,92,208                           // subps         %xmm0,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  15,41,149,56,255,255,255            // movaps        %xmm2,-0xc8(%ebp)
  .byte  15,40,133,232,254,255,255           // movaps        -0x118(%ebp),%xmm0
  .byte  15,92,216                           // subps         %xmm0,%xmm3
  .byte  15,89,220                           // mulps         %xmm4,%xmm3
  .byte  15,88,216                           // addps         %xmm0,%xmm3
  .byte  15,41,157,40,255,255,255            // movaps        %xmm3,-0xd8(%ebp)
  .byte  243,15,91,77,200                    // cvttps2dq     -0x38(%ebp),%xmm1
  .byte  102,15,127,77,200                   // movdqa        %xmm1,-0x38(%ebp)
  .byte  102,15,111,69,168                   // movdqa        -0x58(%ebp),%xmm0
  .byte  102,15,254,193                      // paddd         %xmm1,%xmm0
  .byte  102,15,111,77,136                   // movdqa        -0x78(%ebp),%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,111,240                      // movdqa        %xmm0,%xmm6
  .byte  102,15,112,209,245                  // pshufd        $0xf5,%xmm1,%xmm2
  .byte  102,15,111,133,120,255,255,255      // movdqa        -0x88(%ebp),%xmm0
  .byte  102,15,244,200                      // pmuludq       %xmm0,%xmm1
  .byte  102,15,244,208                      // pmuludq       %xmm0,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,112,217,232                  // pshufd        $0xe8,%xmm1,%xmm3
  .byte  102,15,98,218                       // punpckldq     %xmm2,%xmm3
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  102,15,112,203,229                  // pshufd        $0xe5,%xmm3,%xmm1
  .byte  102,15,126,202                      // movd          %xmm1,%edx
  .byte  102,15,112,203,78                   // pshufd        $0x4e,%xmm3,%xmm1
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,112,203,231                  // pshufd        $0xe7,%xmm3,%xmm1
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  243,15,16,12,185                    // movss         (%ecx,%edi,4),%xmm1
  .byte  243,15,16,20,177                    // movss         (%ecx,%esi,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  243,15,16,36,145                    // movss         (%ecx,%edx,4),%xmm4
  .byte  243,15,16,4,129                     // movss         (%ecx,%eax,4),%xmm0
  .byte  15,20,196                           // unpcklps      %xmm4,%xmm0
  .byte  102,15,20,194                       // unpcklpd      %xmm2,%xmm0
  .byte  102,15,41,69,168                    // movapd        %xmm0,-0x58(%ebp)
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,118,192                      // pcmpeqd       %xmm0,%xmm0
  .byte  102,15,250,208                      // psubd         %xmm0,%xmm2
  .byte  102,15,112,226,229                  // pshufd        $0xe5,%xmm2,%xmm4
  .byte  102,15,126,224                      // movd          %xmm4,%eax
  .byte  102,15,112,226,78                   // pshufd        $0x4e,%xmm2,%xmm4
  .byte  102,15,126,226                      // movd          %xmm4,%edx
  .byte  102,15,126,214                      // movd          %xmm2,%esi
  .byte  102,15,112,210,231                  // pshufd        $0xe7,%xmm2,%xmm2
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  243,15,16,20,185                    // movss         (%ecx,%edi,4),%xmm2
  .byte  243,15,16,36,145                    // movss         (%ecx,%edx,4),%xmm4
  .byte  15,20,226                           // unpcklps      %xmm2,%xmm4
  .byte  243,15,16,20,177                    // movss         (%ecx,%esi,4),%xmm2
  .byte  243,15,16,44,129                    // movss         (%ecx,%eax,4),%xmm5
  .byte  15,20,213                           // unpcklps      %xmm5,%xmm2
  .byte  102,15,20,212                       // unpcklpd      %xmm4,%xmm2
  .byte  102,15,254,223                      // paddd         %xmm7,%xmm3
  .byte  102,15,112,227,229                  // pshufd        $0xe5,%xmm3,%xmm4
  .byte  102,15,126,224                      // movd          %xmm4,%eax
  .byte  102,15,112,227,78                   // pshufd        $0x4e,%xmm3,%xmm4
  .byte  102,15,126,226                      // movd          %xmm4,%edx
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,112,219,231                  // pshufd        $0xe7,%xmm3,%xmm3
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  243,15,16,28,185                    // movss         (%ecx,%edi,4),%xmm3
  .byte  243,15,16,36,145                    // movss         (%ecx,%edx,4),%xmm4
  .byte  15,20,227                           // unpcklps      %xmm3,%xmm4
  .byte  243,15,16,44,177                    // movss         (%ecx,%esi,4),%xmm5
  .byte  243,15,16,28,129                    // movss         (%ecx,%eax,4),%xmm3
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  102,15,20,236                       // unpcklpd      %xmm4,%xmm5
  .byte  102,15,111,230                      // movdqa        %xmm6,%xmm4
  .byte  102,15,254,165,24,255,255,255       // paddd         -0xe8(%ebp),%xmm4
  .byte  102,15,112,220,245                  // pshufd        $0xf5,%xmm4,%xmm3
  .byte  102,15,111,141,120,255,255,255      // movdqa        -0x88(%ebp),%xmm1
  .byte  102,15,244,225                      // pmuludq       %xmm1,%xmm4
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,244,217                      // pmuludq       %xmm1,%xmm3
  .byte  102,15,112,227,232                  // pshufd        $0xe8,%xmm3,%xmm4
  .byte  102,15,112,222,232                  // pshufd        $0xe8,%xmm6,%xmm3
  .byte  102,15,98,220                       // punpckldq     %xmm4,%xmm3
  .byte  102,15,126,240                      // movd          %xmm6,%eax
  .byte  102,15,112,227,229                  // pshufd        $0xe5,%xmm3,%xmm4
  .byte  102,15,126,226                      // movd          %xmm4,%edx
  .byte  102,15,112,227,78                   // pshufd        $0x4e,%xmm3,%xmm4
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  102,15,112,227,231                  // pshufd        $0xe7,%xmm3,%xmm4
  .byte  102,15,126,231                      // movd          %xmm4,%edi
  .byte  243,15,16,36,185                    // movss         (%ecx,%edi,4),%xmm4
  .byte  243,15,16,52,177                    // movss         (%ecx,%esi,4),%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  243,15,16,36,145                    // movss         (%ecx,%edx,4),%xmm4
  .byte  243,15,16,12,129                    // movss         (%ecx,%eax,4),%xmm1
  .byte  15,20,204                           // unpcklps      %xmm4,%xmm1
  .byte  102,15,20,206                       // unpcklpd      %xmm6,%xmm1
  .byte  102,15,111,227                      // movdqa        %xmm3,%xmm4
  .byte  102,15,250,224                      // psubd         %xmm0,%xmm4
  .byte  102,15,112,244,229                  // pshufd        $0xe5,%xmm4,%xmm6
  .byte  102,15,126,240                      // movd          %xmm6,%eax
  .byte  102,15,112,244,78                   // pshufd        $0x4e,%xmm4,%xmm6
  .byte  102,15,126,242                      // movd          %xmm6,%edx
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  102,15,112,228,231                  // pshufd        $0xe7,%xmm4,%xmm4
  .byte  102,15,126,231                      // movd          %xmm4,%edi
  .byte  243,15,16,36,185                    // movss         (%ecx,%edi,4),%xmm4
  .byte  243,15,16,4,145                     // movss         (%ecx,%edx,4),%xmm0
  .byte  15,20,196                           // unpcklps      %xmm4,%xmm0
  .byte  243,15,16,60,177                    // movss         (%ecx,%esi,4),%xmm7
  .byte  243,15,16,36,129                    // movss         (%ecx,%eax,4),%xmm4
  .byte  15,20,252                           // unpcklps      %xmm4,%xmm7
  .byte  102,15,20,248                       // unpcklpd      %xmm0,%xmm7
  .byte  102,15,111,165,104,255,255,255      // movdqa        -0x98(%ebp),%xmm4
  .byte  102,15,254,220                      // paddd         %xmm4,%xmm3
  .byte  102,15,112,195,229                  // pshufd        $0xe5,%xmm3,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,195,78                   // pshufd        $0x4e,%xmm3,%xmm0
  .byte  102,15,126,194                      // movd          %xmm0,%edx
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,112,195,231                  // pshufd        $0xe7,%xmm3,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  243,15,16,4,185                     // movss         (%ecx,%edi,4),%xmm0
  .byte  243,15,16,28,145                    // movss         (%ecx,%edx,4),%xmm3
  .byte  15,20,216                           // unpcklps      %xmm0,%xmm3
  .byte  243,15,16,52,177                    // movss         (%ecx,%esi,4),%xmm6
  .byte  243,15,16,4,129                     // movss         (%ecx,%eax,4),%xmm0
  .byte  15,20,240                           // unpcklps      %xmm0,%xmm6
  .byte  102,15,20,243                       // unpcklpd      %xmm3,%xmm6
  .byte  15,40,93,168                        // movaps        -0x58(%ebp),%xmm3
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  15,41,77,168                        // movaps        %xmm1,-0x58(%ebp)
  .byte  15,92,250                           // subps         %xmm2,%xmm7
  .byte  15,89,248                           // mulps         %xmm0,%xmm7
  .byte  15,88,250                           // addps         %xmm2,%xmm7
  .byte  15,92,245                           // subps         %xmm5,%xmm6
  .byte  15,89,240                           // mulps         %xmm0,%xmm6
  .byte  15,88,245                           // addps         %xmm5,%xmm6
  .byte  102,15,111,69,152                   // movdqa        -0x68(%ebp),%xmm0
  .byte  102,15,254,69,200                   // paddd         -0x38(%ebp),%xmm0
  .byte  102,15,127,69,152                   // movdqa        %xmm0,-0x68(%ebp)
  .byte  102,15,111,85,136                   // movdqa        -0x78(%ebp),%xmm2
  .byte  102,15,254,208                      // paddd         %xmm0,%xmm2
  .byte  102,15,112,194,245                  // pshufd        $0xf5,%xmm2,%xmm0
  .byte  102,15,111,157,120,255,255,255      // movdqa        -0x88(%ebp),%xmm3
  .byte  102,15,244,211                      // pmuludq       %xmm3,%xmm2
  .byte  102,15,244,195                      // pmuludq       %xmm3,%xmm0
  .byte  102,15,112,200,232                  // pshufd        $0xe8,%xmm0,%xmm1
  .byte  102,15,112,194,232                  // pshufd        $0xe8,%xmm2,%xmm0
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  102,15,126,208                      // movd          %xmm2,%eax
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,15,126,202                      // movd          %xmm1,%edx
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,112,200,231                  // pshufd        $0xe7,%xmm0,%xmm1
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  243,15,16,12,185                    // movss         (%ecx,%edi,4),%xmm1
  .byte  243,15,16,20,177                    // movss         (%ecx,%esi,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  243,15,16,12,145                    // movss         (%ecx,%edx,4),%xmm1
  .byte  243,15,16,44,129                    // movss         (%ecx,%eax,4),%xmm5
  .byte  15,20,233                           // unpcklps      %xmm1,%xmm5
  .byte  102,15,20,234                       // unpcklpd      %xmm2,%xmm5
  .byte  102,15,41,109,136                   // movapd        %xmm5,-0x78(%ebp)
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,118,210                      // pcmpeqd       %xmm2,%xmm2
  .byte  102,15,250,202                      // psubd         %xmm2,%xmm1
  .byte  102,15,112,209,229                  // pshufd        $0xe5,%xmm1,%xmm2
  .byte  102,15,126,208                      // movd          %xmm2,%eax
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,15,126,210                      // movd          %xmm2,%edx
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,112,201,231                  // pshufd        $0xe7,%xmm1,%xmm1
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  243,15,16,12,185                    // movss         (%ecx,%edi,4),%xmm1
  .byte  243,15,16,20,145                    // movss         (%ecx,%edx,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  243,15,16,44,177                    // movss         (%ecx,%esi,4),%xmm5
  .byte  243,15,16,12,129                    // movss         (%ecx,%eax,4),%xmm1
  .byte  15,20,233                           // unpcklps      %xmm1,%xmm5
  .byte  102,15,20,234                       // unpcklpd      %xmm2,%xmm5
  .byte  102,15,41,109,200                   // movapd        %xmm5,-0x38(%ebp)
  .byte  102,15,254,196                      // paddd         %xmm4,%xmm0
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,15,126,202                      // movd          %xmm1,%edx
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  243,15,16,4,185                     // movss         (%ecx,%edi,4),%xmm0
  .byte  243,15,16,12,145                    // movss         (%ecx,%edx,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,15,16,36,177                    // movss         (%ecx,%esi,4),%xmm4
  .byte  243,15,16,4,129                     // movss         (%ecx,%eax,4),%xmm0
  .byte  15,20,224                           // unpcklps      %xmm0,%xmm4
  .byte  102,15,20,225                       // unpcklpd      %xmm1,%xmm4
  .byte  102,15,111,77,152                   // movdqa        -0x68(%ebp),%xmm1
  .byte  102,15,254,141,24,255,255,255       // paddd         -0xe8(%ebp),%xmm1
  .byte  102,15,112,193,245                  // pshufd        $0xf5,%xmm1,%xmm0
  .byte  102,15,244,203                      // pmuludq       %xmm3,%xmm1
  .byte  102,15,244,195                      // pmuludq       %xmm3,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,112,209,232                  // pshufd        $0xe8,%xmm1,%xmm2
  .byte  102,15,98,208                       // punpckldq     %xmm0,%xmm2
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  102,15,112,194,229                  // pshufd        $0xe5,%xmm2,%xmm0
  .byte  102,15,126,194                      // movd          %xmm0,%edx
  .byte  102,15,112,194,78                   // pshufd        $0x4e,%xmm2,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,112,194,231                  // pshufd        $0xe7,%xmm2,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  243,15,16,4,185                     // movss         (%ecx,%edi,4),%xmm0
  .byte  243,15,16,12,177                    // movss         (%ecx,%esi,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,15,16,28,145                    // movss         (%ecx,%edx,4),%xmm3
  .byte  243,15,16,4,129                     // movss         (%ecx,%eax,4),%xmm0
  .byte  15,20,195                           // unpcklps      %xmm3,%xmm0
  .byte  102,15,20,193                       // unpcklpd      %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,118,219                      // pcmpeqd       %xmm3,%xmm3
  .byte  102,15,250,203                      // psubd         %xmm3,%xmm1
  .byte  102,15,112,217,229                  // pshufd        $0xe5,%xmm1,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,15,126,218                      // movd          %xmm3,%edx
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,112,201,231                  // pshufd        $0xe7,%xmm1,%xmm1
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  243,15,16,12,185                    // movss         (%ecx,%edi,4),%xmm1
  .byte  243,15,16,28,145                    // movss         (%ecx,%edx,4),%xmm3
  .byte  15,20,217                           // unpcklps      %xmm1,%xmm3
  .byte  243,15,16,12,177                    // movss         (%ecx,%esi,4),%xmm1
  .byte  243,15,16,44,129                    // movss         (%ecx,%eax,4),%xmm5
  .byte  15,20,205                           // unpcklps      %xmm5,%xmm1
  .byte  102,15,20,203                       // unpcklpd      %xmm3,%xmm1
  .byte  102,15,254,149,104,255,255,255      // paddd         -0x98(%ebp),%xmm2
  .byte  102,15,112,218,229                  // pshufd        $0xe5,%xmm2,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,15,126,218                      // movd          %xmm3,%edx
  .byte  102,15,126,214                      // movd          %xmm2,%esi
  .byte  102,15,112,210,231                  // pshufd        $0xe7,%xmm2,%xmm2
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  243,15,16,20,185                    // movss         (%ecx,%edi,4),%xmm2
  .byte  243,15,16,28,145                    // movss         (%ecx,%edx,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  243,15,16,20,177                    // movss         (%ecx,%esi,4),%xmm2
  .byte  243,15,16,44,129                    // movss         (%ecx,%eax,4),%xmm5
  .byte  15,20,213                           // unpcklps      %xmm5,%xmm2
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  15,40,109,136                       // movaps        -0x78(%ebp),%xmm5
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,40,109,200                       // movaps        -0x38(%ebp),%xmm5
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  15,92,212                           // subps         %xmm4,%xmm2
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  15,40,101,168                       // movaps        -0x58(%ebp),%xmm4
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,40,157,88,255,255,255            // movaps        -0xa8(%ebp),%xmm3
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,92,207                           // subps         %xmm7,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  15,92,214                           // subps         %xmm6,%xmm2
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,88,214                           // addps         %xmm6,%xmm2
  .byte  15,91,157,8,255,255,255             // cvtdq2ps      -0xf8(%ebp),%xmm3
  .byte  15,40,165,248,254,255,255           // movaps        -0x108(%ebp),%xmm4
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  15,40,93,184                        // movaps        -0x48(%ebp),%xmm3
  .byte  15,92,195                           // subps         %xmm3,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,195                           // addps         %xmm3,%xmm0
  .byte  15,40,157,56,255,255,255            // movaps        -0xc8(%ebp),%xmm3
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  15,40,157,40,255,255,255            // movaps        -0xd8(%ebp),%xmm3
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  141,65,8                            // lea           0x8(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,157,216,254,255,255           // movaps        -0x128(%ebp),%xmm3
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  129,196,44,1,0,0                    // add           $0x12c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_clut_4D_sse2
.globl _sk_clut_4D_sse2
FUNCTION(_sk_clut_4D_sse2)
_sk_clut_4D_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,76,1,0,0                    // sub           $0x14c,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,16                              // mov           (%eax),%edx
  .byte  139,74,16                           // mov           0x10(%edx),%ecx
  .byte  141,113,255                         // lea           -0x1(%ecx),%esi
  .byte  102,15,110,230                      // movd          %esi,%xmm4
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  102,15,110,217                      // movd          %ecx,%xmm3
  .byte  102,15,112,251,0                    // pshufd        $0x0,%xmm3,%xmm7
  .byte  102,15,127,189,24,255,255,255       // movdqa        %xmm7,-0xe8(%ebp)
  .byte  139,74,12                           // mov           0xc(%edx),%ecx
  .byte  141,113,255                         // lea           -0x1(%ecx),%esi
  .byte  102,15,110,230                      // movd          %esi,%xmm4
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,89,226                           // mulps         %xmm2,%xmm4
  .byte  15,41,165,248,254,255,255           // movaps        %xmm4,-0x108(%ebp)
  .byte  243,15,91,244                       // cvttps2dq     %xmm4,%xmm6
  .byte  102,15,127,181,216,254,255,255      // movdqa        %xmm6,-0x128(%ebp)
  .byte  102,15,112,214,245                  // pshufd        $0xf5,%xmm6,%xmm2
  .byte  102,15,244,215                      // pmuludq       %xmm7,%xmm2
  .byte  102,15,111,231                      // movdqa        %xmm7,%xmm4
  .byte  102,15,244,230                      // pmuludq       %xmm6,%xmm4
  .byte  102,15,112,228,232                  // pshufd        $0xe8,%xmm4,%xmm4
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,98,226                       // punpckldq     %xmm2,%xmm4
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,127,181,8,255,255,255        // movdqa        %xmm6,-0xf8(%ebp)
  .byte  102,15,110,209                      // movd          %ecx,%xmm2
  .byte  102,15,244,211                      // pmuludq       %xmm3,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,244,216                      // pmuludq       %xmm0,%xmm3
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  102,15,98,211                       // punpckldq     %xmm3,%xmm2
  .byte  139,74,8                            // mov           0x8(%edx),%ecx
  .byte  141,113,255                         // lea           -0x1(%ecx),%esi
  .byte  102,15,110,222                      // movd          %esi,%xmm3
  .byte  102,15,112,219,0                    // pshufd        $0x0,%xmm3,%xmm3
  .byte  15,91,219                           // cvtdq2ps      %xmm3,%xmm3
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  15,41,157,56,255,255,255            // movaps        %xmm3,-0xc8(%ebp)
  .byte  102,15,112,250,0                    // pshufd        $0x0,%xmm2,%xmm7
  .byte  102,15,127,189,88,255,255,255       // movdqa        %xmm7,-0xa8(%ebp)
  .byte  243,15,91,227                       // cvttps2dq     %xmm3,%xmm4
  .byte  102,15,127,165,40,255,255,255       // movdqa        %xmm4,-0xd8(%ebp)
  .byte  102,15,112,204,245                  // pshufd        $0xf5,%xmm4,%xmm1
  .byte  102,15,244,207                      // pmuludq       %xmm7,%xmm1
  .byte  102,15,111,223                      // movdqa        %xmm7,%xmm3
  .byte  102,15,244,220                      // pmuludq       %xmm4,%xmm3
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  102,15,112,201,232                  // pshufd        $0xe8,%xmm1,%xmm1
  .byte  102,15,98,217                       // punpckldq     %xmm1,%xmm3
  .byte  102,15,111,227                      // movdqa        %xmm3,%xmm4
  .byte  102,15,127,165,72,255,255,255       // movdqa        %xmm4,-0xb8(%ebp)
  .byte  102,15,110,201                      // movd          %ecx,%xmm1
  .byte  102,15,244,202                      // pmuludq       %xmm2,%xmm1
  .byte  139,74,4                            // mov           0x4(%edx),%ecx
  .byte  73                                  // dec           %ecx
  .byte  102,15,110,209                      // movd          %ecx,%xmm2
  .byte  102,15,112,210,0                    // pshufd        $0x0,%xmm2,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,41,85,216                        // movaps        %xmm2,-0x28(%ebp)
  .byte  102,15,112,217,0                    // pshufd        $0x0,%xmm1,%xmm3
  .byte  102,15,127,93,168                   // movdqa        %xmm3,-0x58(%ebp)
  .byte  243,15,91,194                       // cvttps2dq     %xmm2,%xmm0
  .byte  102,15,127,133,104,255,255,255      // movdqa        %xmm0,-0x98(%ebp)
  .byte  102,15,112,200,245                  // pshufd        $0xf5,%xmm0,%xmm1
  .byte  102,15,244,203                      // pmuludq       %xmm3,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,244,208                      // pmuludq       %xmm0,%xmm2
  .byte  102,15,112,218,232                  // pshufd        $0xe8,%xmm2,%xmm3
  .byte  102,15,112,201,232                  // pshufd        $0xe8,%xmm1,%xmm1
  .byte  102,15,98,217                       // punpckldq     %xmm1,%xmm3
  .byte  102,15,127,93,152                   // movdqa        %xmm3,-0x68(%ebp)
  .byte  232,0,0,0,0                         // call          8579 <_sk_clut_4D_sse2+0x165>
  .byte  89                                  // pop           %ecx
  .byte  15,40,197                           // movaps        %xmm5,%xmm0
  .byte  15,41,133,168,254,255,255           // movaps        %xmm0,-0x158(%ebp)
  .byte  243,15,91,200                       // cvttps2dq     %xmm0,%xmm1
  .byte  102,15,127,141,200,254,255,255      // movdqa        %xmm1,-0x138(%ebp)
  .byte  102,15,254,241                      // paddd         %xmm1,%xmm6
  .byte  102,15,127,117,200                  // movdqa        %xmm6,-0x38(%ebp)
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  102,15,254,214                      // paddd         %xmm6,%xmm2
  .byte  102,15,254,218                      // paddd         %xmm2,%xmm3
  .byte  102,15,111,161,39,124,0,0           // movdqa        0x7c27(%ecx),%xmm4
  .byte  102,15,112,203,245                  // pshufd        $0xf5,%xmm3,%xmm1
  .byte  102,15,244,220                      // pmuludq       %xmm4,%xmm3
  .byte  102,15,244,204                      // pmuludq       %xmm4,%xmm1
  .byte  102,15,112,233,232                  // pshufd        $0xe8,%xmm1,%xmm5
  .byte  102,15,112,203,232                  // pshufd        $0xe8,%xmm3,%xmm1
  .byte  102,15,98,205                       // punpckldq     %xmm5,%xmm1
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,112,217,229                  // pshufd        $0xe5,%xmm1,%xmm3
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,15,126,219                      // movd          %xmm3,%ebx
  .byte  102,15,112,217,231                  // pshufd        $0xe7,%xmm1,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  139,18                              // mov           (%edx),%edx
  .byte  243,15,16,28,130                    // movss         (%edx,%eax,4),%xmm3
  .byte  243,15,16,52,154                    // movss         (%edx,%ebx,4),%xmm6
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  243,15,16,28,186                    // movss         (%edx,%edi,4),%xmm3
  .byte  243,15,16,36,178                    // movss         (%edx,%esi,4),%xmm4
  .byte  15,20,227                           // unpcklps      %xmm3,%xmm4
  .byte  102,15,20,230                       // unpcklpd      %xmm6,%xmm4
  .byte  102,15,41,101,184                   // movapd        %xmm4,-0x48(%ebp)
  .byte  102,15,118,228                      // pcmpeqd       %xmm4,%xmm4
  .byte  102,15,111,217                      // movdqa        %xmm1,%xmm3
  .byte  102,15,250,220                      // psubd         %xmm4,%xmm3
  .byte  102,15,118,237                      // pcmpeqd       %xmm5,%xmm5
  .byte  102,15,112,243,229                  // pshufd        $0xe5,%xmm3,%xmm6
  .byte  102,15,126,240                      // movd          %xmm6,%eax
  .byte  102,15,112,243,78                   // pshufd        $0x4e,%xmm3,%xmm6
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  102,15,112,219,231                  // pshufd        $0xe7,%xmm3,%xmm3
  .byte  102,15,126,219                      // movd          %xmm3,%ebx
  .byte  243,15,16,28,154                    // movss         (%edx,%ebx,4),%xmm3
  .byte  243,15,16,52,178                    // movss         (%edx,%esi,4),%xmm6
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  243,15,16,28,186                    // movss         (%edx,%edi,4),%xmm3
  .byte  243,15,16,60,130                    // movss         (%edx,%eax,4),%xmm7
  .byte  15,20,223                           // unpcklps      %xmm7,%xmm3
  .byte  102,15,20,222                       // unpcklpd      %xmm6,%xmm3
  .byte  102,15,41,157,232,254,255,255       // movapd        %xmm3,-0x118(%ebp)
  .byte  102,15,254,137,231,117,0,0          // paddd         0x75e7(%ecx),%xmm1
  .byte  102,15,112,241,229                  // pshufd        $0xe5,%xmm1,%xmm6
  .byte  102,15,126,240                      // movd          %xmm6,%eax
  .byte  102,15,112,241,78                   // pshufd        $0x4e,%xmm1,%xmm6
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,201,231                  // pshufd        $0xe7,%xmm1,%xmm1
  .byte  102,15,126,203                      // movd          %xmm1,%ebx
  .byte  243,15,16,12,154                    // movss         (%edx,%ebx,4),%xmm1
  .byte  243,15,16,52,178                    // movss         (%edx,%esi,4),%xmm6
  .byte  15,20,241                           // unpcklps      %xmm1,%xmm6
  .byte  243,15,16,28,186                    // movss         (%edx,%edi,4),%xmm3
  .byte  243,15,16,60,130                    // movss         (%edx,%eax,4),%xmm7
  .byte  15,20,223                           // unpcklps      %xmm7,%xmm3
  .byte  102,15,20,222                       // unpcklpd      %xmm6,%xmm3
  .byte  15,40,185,23,124,0,0                // movaps        0x7c17(%ecx),%xmm7
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,41,133,120,255,255,255           // movaps        %xmm0,-0x88(%ebp)
  .byte  15,40,133,248,254,255,255           // movaps        -0x108(%ebp),%xmm0
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,41,69,136                        // movaps        %xmm0,-0x78(%ebp)
  .byte  15,40,133,56,255,255,255            // movaps        -0xc8(%ebp),%xmm0
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,41,133,184,254,255,255           // movaps        %xmm0,-0x148(%ebp)
  .byte  15,88,125,216                       // addps         -0x28(%ebp),%xmm7
  .byte  243,15,91,255                       // cvttps2dq     %xmm7,%xmm7
  .byte  102,15,112,199,245                  // pshufd        $0xf5,%xmm7,%xmm0
  .byte  102,15,111,117,168                  // movdqa        -0x58(%ebp),%xmm6
  .byte  102,15,244,198                      // pmuludq       %xmm6,%xmm0
  .byte  102,15,244,247                      // pmuludq       %xmm7,%xmm6
  .byte  102,15,112,230,232                  // pshufd        $0xe8,%xmm6,%xmm4
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,98,224                       // punpckldq     %xmm0,%xmm4
  .byte  102,15,127,101,168                  // movdqa        %xmm4,-0x58(%ebp)
  .byte  102,15,254,212                      // paddd         %xmm4,%xmm2
  .byte  102,15,112,194,245                  // pshufd        $0xf5,%xmm2,%xmm0
  .byte  102,15,111,161,39,124,0,0           // movdqa        0x7c27(%ecx),%xmm4
  .byte  102,15,244,212                      // pmuludq       %xmm4,%xmm2
  .byte  102,15,244,196                      // pmuludq       %xmm4,%xmm0
  .byte  102,15,112,240,232                  // pshufd        $0xe8,%xmm0,%xmm6
  .byte  102,15,112,194,232                  // pshufd        $0xe8,%xmm2,%xmm0
  .byte  102,15,98,198                       // punpckldq     %xmm6,%xmm0
  .byte  102,15,126,208                      // movd          %xmm2,%eax
  .byte  102,15,112,208,229                  // pshufd        $0xe5,%xmm0,%xmm2
  .byte  102,15,126,214                      // movd          %xmm2,%esi
  .byte  102,15,112,208,78                   // pshufd        $0x4e,%xmm0,%xmm2
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  102,15,112,208,231                  // pshufd        $0xe7,%xmm0,%xmm2
  .byte  102,15,126,211                      // movd          %xmm2,%ebx
  .byte  243,15,16,20,154                    // movss         (%edx,%ebx,4),%xmm2
  .byte  243,15,16,52,186                    // movss         (%edx,%edi,4),%xmm6
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  243,15,16,20,178                    // movss         (%edx,%esi,4),%xmm2
  .byte  243,15,16,12,130                    // movss         (%edx,%eax,4),%xmm1
  .byte  15,20,202                           // unpcklps      %xmm2,%xmm1
  .byte  102,15,20,206                       // unpcklpd      %xmm6,%xmm1
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,15,250,213                      // psubd         %xmm5,%xmm2
  .byte  102,15,112,242,229                  // pshufd        $0xe5,%xmm2,%xmm6
  .byte  102,15,126,240                      // movd          %xmm6,%eax
  .byte  102,15,112,242,78                   // pshufd        $0x4e,%xmm2,%xmm6
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  102,15,112,210,231                  // pshufd        $0xe7,%xmm2,%xmm2
  .byte  102,15,126,211                      // movd          %xmm2,%ebx
  .byte  243,15,16,20,154                    // movss         (%edx,%ebx,4),%xmm2
  .byte  243,15,16,52,178                    // movss         (%edx,%esi,4),%xmm6
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  243,15,16,20,186                    // movss         (%edx,%edi,4),%xmm2
  .byte  243,15,16,44,130                    // movss         (%edx,%eax,4),%xmm5
  .byte  15,20,213                           // unpcklps      %xmm5,%xmm2
  .byte  102,15,20,214                       // unpcklpd      %xmm6,%xmm2
  .byte  102,15,254,129,231,117,0,0          // paddd         0x75e7(%ecx),%xmm0
  .byte  102,15,112,232,229                  // pshufd        $0xe5,%xmm0,%xmm5
  .byte  102,15,126,232                      // movd          %xmm5,%eax
  .byte  102,15,112,232,78                   // pshufd        $0x4e,%xmm0,%xmm5
  .byte  102,15,126,238                      // movd          %xmm5,%esi
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,44,178                    // movss         (%edx,%esi,4),%xmm5
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  243,15,16,60,186                    // movss         (%edx,%edi,4),%xmm7
  .byte  243,15,16,52,130                    // movss         (%edx,%eax,4),%xmm6
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  102,15,20,253                       // unpcklpd      %xmm5,%xmm7
  .byte  15,91,173,104,255,255,255           // cvtdq2ps      -0x98(%ebp),%xmm5
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,41,69,216                        // movaps        %xmm0,-0x28(%ebp)
  .byte  15,40,109,184                       // movaps        -0x48(%ebp),%xmm5
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  15,41,141,104,255,255,255           // movaps        %xmm1,-0x98(%ebp)
  .byte  15,40,141,232,254,255,255           // movaps        -0x118(%ebp),%xmm1
  .byte  15,92,209                           // subps         %xmm1,%xmm2
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,88,209                           // addps         %xmm1,%xmm2
  .byte  15,41,85,184                        // movaps        %xmm2,-0x48(%ebp)
  .byte  15,92,251                           // subps         %xmm3,%xmm7
  .byte  15,89,248                           // mulps         %xmm0,%xmm7
  .byte  15,88,251                           // addps         %xmm3,%xmm7
  .byte  243,15,91,141,184,254,255,255       // cvttps2dq     -0x148(%ebp),%xmm1
  .byte  102,15,112,217,245                  // pshufd        $0xf5,%xmm1,%xmm3
  .byte  102,15,111,133,88,255,255,255       // movdqa        -0xa8(%ebp),%xmm0
  .byte  102,15,244,216                      // pmuludq       %xmm0,%xmm3
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,244,233                      // pmuludq       %xmm1,%xmm5
  .byte  102,15,112,197,232                  // pshufd        $0xe8,%xmm5,%xmm0
  .byte  102,15,112,203,232                  // pshufd        $0xe8,%xmm3,%xmm1
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  102,15,127,133,88,255,255,255       // movdqa        %xmm0,-0xa8(%ebp)
  .byte  102,15,111,85,200                   // movdqa        -0x38(%ebp),%xmm2
  .byte  102,15,254,208                      // paddd         %xmm0,%xmm2
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,254,93,152                   // paddd         -0x68(%ebp),%xmm3
  .byte  102,15,112,203,245                  // pshufd        $0xf5,%xmm3,%xmm1
  .byte  102,15,244,220                      // pmuludq       %xmm4,%xmm3
  .byte  102,15,244,204                      // pmuludq       %xmm4,%xmm1
  .byte  102,15,112,233,232                  // pshufd        $0xe8,%xmm1,%xmm5
  .byte  102,15,112,203,232                  // pshufd        $0xe8,%xmm3,%xmm1
  .byte  102,15,98,205                       // punpckldq     %xmm5,%xmm1
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,217,229                  // pshufd        $0xe5,%xmm1,%xmm3
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  102,15,112,217,231                  // pshufd        $0xe7,%xmm1,%xmm3
  .byte  102,15,126,219                      // movd          %xmm3,%ebx
  .byte  243,15,16,28,154                    // movss         (%edx,%ebx,4),%xmm3
  .byte  243,15,16,44,186                    // movss         (%edx,%edi,4),%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  243,15,16,52,178                    // movss         (%edx,%esi,4),%xmm6
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,198                           // unpcklps      %xmm6,%xmm0
  .byte  102,15,20,197                       // unpcklpd      %xmm5,%xmm0
  .byte  102,15,41,69,200                    // movapd        %xmm0,-0x38(%ebp)
  .byte  102,15,111,233                      // movdqa        %xmm1,%xmm5
  .byte  102,15,118,219                      // pcmpeqd       %xmm3,%xmm3
  .byte  102,15,250,235                      // psubd         %xmm3,%xmm5
  .byte  102,15,112,245,229                  // pshufd        $0xe5,%xmm5,%xmm6
  .byte  102,15,126,240                      // movd          %xmm6,%eax
  .byte  102,15,112,245,78                   // pshufd        $0x4e,%xmm5,%xmm6
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  102,15,126,239                      // movd          %xmm5,%edi
  .byte  102,15,112,237,231                  // pshufd        $0xe7,%xmm5,%xmm5
  .byte  102,15,126,235                      // movd          %xmm5,%ebx
  .byte  243,15,16,44,154                    // movss         (%edx,%ebx,4),%xmm5
  .byte  243,15,16,4,178                     // movss         (%edx,%esi,4),%xmm0
  .byte  15,20,197                           // unpcklps      %xmm5,%xmm0
  .byte  243,15,16,52,186                    // movss         (%edx,%edi,4),%xmm6
  .byte  243,15,16,44,130                    // movss         (%edx,%eax,4),%xmm5
  .byte  15,20,245                           // unpcklps      %xmm5,%xmm6
  .byte  102,15,20,240                       // unpcklpd      %xmm0,%xmm6
  .byte  102,15,254,137,231,117,0,0          // paddd         0x75e7(%ecx),%xmm1
  .byte  102,15,112,193,229                  // pshufd        $0xe5,%xmm1,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,193,231                  // pshufd        $0xe7,%xmm1,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,44,178                    // movss         (%edx,%esi,4),%xmm5
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  243,15,16,36,186                    // movss         (%edx,%edi,4),%xmm4
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,224                           // unpcklps      %xmm0,%xmm4
  .byte  102,15,20,229                       // unpcklpd      %xmm5,%xmm4
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,254,77,168                   // paddd         -0x58(%ebp),%xmm1
  .byte  102,15,112,193,245                  // pshufd        $0xf5,%xmm1,%xmm0
  .byte  102,15,111,145,39,124,0,0           // movdqa        0x7c27(%ecx),%xmm2
  .byte  102,15,244,202                      // pmuludq       %xmm2,%xmm1
  .byte  102,15,244,194                      // pmuludq       %xmm2,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,112,233,232                  // pshufd        $0xe8,%xmm1,%xmm5
  .byte  102,15,98,232                       // punpckldq     %xmm0,%xmm5
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  102,15,112,197,229                  // pshufd        $0xe5,%xmm5,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,112,197,78                   // pshufd        $0x4e,%xmm5,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,197,231                  // pshufd        $0xe7,%xmm5,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,12,154                    // movss         (%edx,%ebx,4),%xmm1
  .byte  243,15,16,4,186                     // movss         (%edx,%edi,4),%xmm0
  .byte  15,20,193                           // unpcklps      %xmm1,%xmm0
  .byte  243,15,16,12,178                    // movss         (%edx,%esi,4),%xmm1
  .byte  243,15,16,20,130                    // movss         (%edx,%eax,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  102,15,20,208                       // unpcklpd      %xmm0,%xmm2
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,250,195                      // psubd         %xmm3,%xmm0
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,12,178                    // movss         (%edx,%esi,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,15,16,28,186                    // movss         (%edx,%edi,4),%xmm3
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,216                           // unpcklps      %xmm0,%xmm3
  .byte  102,15,20,217                       // unpcklpd      %xmm1,%xmm3
  .byte  102,15,254,169,231,117,0,0          // paddd         0x75e7(%ecx),%xmm5
  .byte  102,15,112,197,229                  // pshufd        $0xe5,%xmm5,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,197,78                   // pshufd        $0x4e,%xmm5,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,126,239                      // movd          %xmm5,%edi
  .byte  102,15,112,197,231                  // pshufd        $0xe7,%xmm5,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,12,178                    // movss         (%edx,%esi,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,15,16,44,186                    // movss         (%edx,%edi,4),%xmm5
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  102,15,20,233                       // unpcklpd      %xmm1,%xmm5
  .byte  15,40,77,200                        // movaps        -0x38(%ebp),%xmm1
  .byte  15,92,209                           // subps         %xmm1,%xmm2
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,88,209                           // addps         %xmm1,%xmm2
  .byte  15,92,222                           // subps         %xmm6,%xmm3
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,88,222                           // addps         %xmm6,%xmm3
  .byte  15,92,236                           // subps         %xmm4,%xmm5
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  15,88,236                           // addps         %xmm4,%xmm5
  .byte  15,91,133,40,255,255,255            // cvtdq2ps      -0xd8(%ebp),%xmm0
  .byte  15,40,141,56,255,255,255            // movaps        -0xc8(%ebp),%xmm1
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,41,141,56,255,255,255            // movaps        %xmm1,-0xc8(%ebp)
  .byte  15,40,133,104,255,255,255           // movaps        -0x98(%ebp),%xmm0
  .byte  15,92,208                           // subps         %xmm0,%xmm2
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  15,41,149,40,255,255,255            // movaps        %xmm2,-0xd8(%ebp)
  .byte  15,40,69,184                        // movaps        -0x48(%ebp),%xmm0
  .byte  15,92,216                           // subps         %xmm0,%xmm3
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  15,88,216                           // addps         %xmm0,%xmm3
  .byte  15,41,157,104,255,255,255           // movaps        %xmm3,-0x98(%ebp)
  .byte  15,92,239                           // subps         %xmm7,%xmm5
  .byte  15,89,233                           // mulps         %xmm1,%xmm5
  .byte  15,88,239                           // addps         %xmm7,%xmm5
  .byte  15,41,109,184                       // movaps        %xmm5,-0x48(%ebp)
  .byte  243,15,91,69,136                    // cvttps2dq     -0x78(%ebp),%xmm0
  .byte  102,15,112,200,245                  // pshufd        $0xf5,%xmm0,%xmm1
  .byte  102,15,111,149,24,255,255,255       // movdqa        -0xe8(%ebp),%xmm2
  .byte  102,15,244,202                      // pmuludq       %xmm2,%xmm1
  .byte  102,15,244,208                      // pmuludq       %xmm0,%xmm2
  .byte  102,15,112,226,232                  // pshufd        $0xe8,%xmm2,%xmm4
  .byte  102,15,112,193,232                  // pshufd        $0xe8,%xmm1,%xmm0
  .byte  102,15,98,224                       // punpckldq     %xmm0,%xmm4
  .byte  102,15,127,165,24,255,255,255       // movdqa        %xmm4,-0xe8(%ebp)
  .byte  102,15,254,165,200,254,255,255      // paddd         -0x138(%ebp),%xmm4
  .byte  102,15,127,101,200                  // movdqa        %xmm4,-0x38(%ebp)
  .byte  102,15,111,204                      // movdqa        %xmm4,%xmm1
  .byte  102,15,254,141,72,255,255,255       // paddd         -0xb8(%ebp),%xmm1
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,15,254,85,152                   // paddd         -0x68(%ebp),%xmm2
  .byte  102,15,112,194,245                  // pshufd        $0xf5,%xmm2,%xmm0
  .byte  102,15,111,153,39,124,0,0           // movdqa        0x7c27(%ecx),%xmm3
  .byte  102,15,244,211                      // pmuludq       %xmm3,%xmm2
  .byte  102,15,244,195                      // pmuludq       %xmm3,%xmm0
  .byte  102,15,111,251                      // movdqa        %xmm3,%xmm7
  .byte  102,15,112,216,232                  // pshufd        $0xe8,%xmm0,%xmm3
  .byte  102,15,112,194,232                  // pshufd        $0xe8,%xmm2,%xmm0
  .byte  102,15,98,195                       // punpckldq     %xmm3,%xmm0
  .byte  102,15,126,208                      // movd          %xmm2,%eax
  .byte  102,15,112,208,229                  // pshufd        $0xe5,%xmm0,%xmm2
  .byte  102,15,126,214                      // movd          %xmm2,%esi
  .byte  102,15,112,208,78                   // pshufd        $0x4e,%xmm0,%xmm2
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  102,15,112,208,231                  // pshufd        $0xe7,%xmm0,%xmm2
  .byte  102,15,126,211                      // movd          %xmm2,%ebx
  .byte  243,15,16,20,154                    // movss         (%edx,%ebx,4),%xmm2
  .byte  243,15,16,28,186                    // movss         (%edx,%edi,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  243,15,16,20,178                    // movss         (%edx,%esi,4),%xmm2
  .byte  243,15,16,36,130                    // movss         (%edx,%eax,4),%xmm4
  .byte  15,20,226                           // unpcklps      %xmm2,%xmm4
  .byte  102,15,20,227                       // unpcklpd      %xmm3,%xmm4
  .byte  102,15,41,101,136                   // movapd        %xmm4,-0x78(%ebp)
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,15,118,246                      // pcmpeqd       %xmm6,%xmm6
  .byte  102,15,250,214                      // psubd         %xmm6,%xmm2
  .byte  102,15,112,218,229                  // pshufd        $0xe5,%xmm2,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  102,15,112,210,231                  // pshufd        $0xe7,%xmm2,%xmm2
  .byte  102,15,126,211                      // movd          %xmm2,%ebx
  .byte  243,15,16,20,154                    // movss         (%edx,%ebx,4),%xmm2
  .byte  243,15,16,28,178                    // movss         (%edx,%esi,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  243,15,16,36,186                    // movss         (%edx,%edi,4),%xmm4
  .byte  243,15,16,44,130                    // movss         (%edx,%eax,4),%xmm5
  .byte  15,20,229                           // unpcklps      %xmm5,%xmm4
  .byte  102,15,20,227                       // unpcklpd      %xmm3,%xmm4
  .byte  102,15,254,129,231,117,0,0          // paddd         0x75e7(%ecx),%xmm0
  .byte  102,15,112,216,229                  // pshufd        $0xe5,%xmm0,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,216,78                   // pshufd        $0x4e,%xmm0,%xmm3
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,28,178                    // movss         (%edx,%esi,4),%xmm3
  .byte  15,20,216                           // unpcklps      %xmm0,%xmm3
  .byte  243,15,16,20,186                    // movss         (%edx,%edi,4),%xmm2
  .byte  243,15,16,44,130                    // movss         (%edx,%eax,4),%xmm5
  .byte  15,20,213                           // unpcklps      %xmm5,%xmm2
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  102,15,254,77,168                   // paddd         -0x58(%ebp),%xmm1
  .byte  102,15,112,217,245                  // pshufd        $0xf5,%xmm1,%xmm3
  .byte  102,15,244,207                      // pmuludq       %xmm7,%xmm1
  .byte  102,15,244,223                      // pmuludq       %xmm7,%xmm3
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  102,15,112,249,232                  // pshufd        $0xe8,%xmm1,%xmm7
  .byte  102,15,98,251                       // punpckldq     %xmm3,%xmm7
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  102,15,112,207,229                  // pshufd        $0xe5,%xmm7,%xmm1
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,112,207,78                   // pshufd        $0x4e,%xmm7,%xmm1
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,207,231                  // pshufd        $0xe7,%xmm7,%xmm1
  .byte  102,15,126,203                      // movd          %xmm1,%ebx
  .byte  243,15,16,12,154                    // movss         (%edx,%ebx,4),%xmm1
  .byte  243,15,16,28,186                    // movss         (%edx,%edi,4),%xmm3
  .byte  15,20,217                           // unpcklps      %xmm1,%xmm3
  .byte  243,15,16,12,178                    // movss         (%edx,%esi,4),%xmm1
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,193                           // unpcklps      %xmm1,%xmm0
  .byte  102,15,20,195                       // unpcklpd      %xmm3,%xmm0
  .byte  102,15,111,207                      // movdqa        %xmm7,%xmm1
  .byte  102,15,250,206                      // psubd         %xmm6,%xmm1
  .byte  102,15,112,217,229                  // pshufd        $0xe5,%xmm1,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,201,231                  // pshufd        $0xe7,%xmm1,%xmm1
  .byte  102,15,126,203                      // movd          %xmm1,%ebx
  .byte  243,15,16,12,154                    // movss         (%edx,%ebx,4),%xmm1
  .byte  243,15,16,28,178                    // movss         (%edx,%esi,4),%xmm3
  .byte  15,20,217                           // unpcklps      %xmm1,%xmm3
  .byte  243,15,16,44,186                    // movss         (%edx,%edi,4),%xmm5
  .byte  243,15,16,52,130                    // movss         (%edx,%eax,4),%xmm6
  .byte  15,20,238                           // unpcklps      %xmm6,%xmm5
  .byte  102,15,20,235                       // unpcklpd      %xmm3,%xmm5
  .byte  102,15,111,137,231,117,0,0          // movdqa        0x75e7(%ecx),%xmm1
  .byte  102,15,254,249                      // paddd         %xmm1,%xmm7
  .byte  102,15,112,223,229                  // pshufd        $0xe5,%xmm7,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,223,78                   // pshufd        $0x4e,%xmm7,%xmm3
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,126,255                      // movd          %xmm7,%edi
  .byte  102,15,112,223,231                  // pshufd        $0xe7,%xmm7,%xmm3
  .byte  102,15,126,219                      // movd          %xmm3,%ebx
  .byte  243,15,16,28,154                    // movss         (%edx,%ebx,4),%xmm3
  .byte  243,15,16,52,178                    // movss         (%edx,%esi,4),%xmm6
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  243,15,16,60,186                    // movss         (%edx,%edi,4),%xmm7
  .byte  243,15,16,28,130                    // movss         (%edx,%eax,4),%xmm3
  .byte  15,20,251                           // unpcklps      %xmm3,%xmm7
  .byte  102,15,20,254                       // unpcklpd      %xmm6,%xmm7
  .byte  15,40,117,136                       // movaps        -0x78(%ebp),%xmm6
  .byte  15,92,198                           // subps         %xmm6,%xmm0
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,41,69,136                        // movaps        %xmm0,-0x78(%ebp)
  .byte  15,92,236                           // subps         %xmm4,%xmm5
  .byte  15,89,235                           // mulps         %xmm3,%xmm5
  .byte  15,88,236                           // addps         %xmm4,%xmm5
  .byte  15,92,250                           // subps         %xmm2,%xmm7
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,88,250                           // addps         %xmm2,%xmm7
  .byte  102,15,111,85,200                   // movdqa        -0x38(%ebp),%xmm2
  .byte  102,15,254,149,88,255,255,255       // paddd         -0xa8(%ebp),%xmm2
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,111,226                      // movdqa        %xmm2,%xmm4
  .byte  102,15,254,69,152                   // paddd         -0x68(%ebp),%xmm0
  .byte  102,15,112,208,245                  // pshufd        $0xf5,%xmm0,%xmm2
  .byte  102,15,111,153,39,124,0,0           // movdqa        0x7c27(%ecx),%xmm3
  .byte  102,15,244,195                      // pmuludq       %xmm3,%xmm0
  .byte  102,15,244,211                      // pmuludq       %xmm3,%xmm2
  .byte  102,15,112,218,232                  // pshufd        $0xe8,%xmm2,%xmm3
  .byte  102,15,112,208,232                  // pshufd        $0xe8,%xmm0,%xmm2
  .byte  102,15,98,211                       // punpckldq     %xmm3,%xmm2
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,194,229                  // pshufd        $0xe5,%xmm2,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,112,194,78                   // pshufd        $0x4e,%xmm2,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,194,231                  // pshufd        $0xe7,%xmm2,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,28,186                    // movss         (%edx,%edi,4),%xmm3
  .byte  15,20,216                           // unpcklps      %xmm0,%xmm3
  .byte  243,15,16,4,178                     // movss         (%edx,%esi,4),%xmm0
  .byte  243,15,16,52,130                    // movss         (%edx,%eax,4),%xmm6
  .byte  15,20,240                           // unpcklps      %xmm0,%xmm6
  .byte  102,15,20,243                       // unpcklpd      %xmm3,%xmm6
  .byte  102,15,41,117,200                   // movapd        %xmm6,-0x38(%ebp)
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,118,219                      // pcmpeqd       %xmm3,%xmm3
  .byte  102,15,250,195                      // psubd         %xmm3,%xmm0
  .byte  102,15,112,216,229                  // pshufd        $0xe5,%xmm0,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,216,78                   // pshufd        $0x4e,%xmm0,%xmm3
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,28,154                    // movss         (%edx,%ebx,4),%xmm3
  .byte  243,15,16,4,178                     // movss         (%edx,%esi,4),%xmm0
  .byte  15,20,195                           // unpcklps      %xmm3,%xmm0
  .byte  243,15,16,28,186                    // movss         (%edx,%edi,4),%xmm3
  .byte  243,15,16,52,130                    // movss         (%edx,%eax,4),%xmm6
  .byte  15,20,222                           // unpcklps      %xmm6,%xmm3
  .byte  102,15,20,216                       // unpcklpd      %xmm0,%xmm3
  .byte  102,15,41,157,232,254,255,255       // movapd        %xmm3,-0x118(%ebp)
  .byte  102,15,254,209                      // paddd         %xmm1,%xmm2
  .byte  102,15,112,194,229                  // pshufd        $0xe5,%xmm2,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,194,78                   // pshufd        $0x4e,%xmm2,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  102,15,112,194,231                  // pshufd        $0xe7,%xmm2,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,52,178                    // movss         (%edx,%esi,4),%xmm6
  .byte  15,20,240                           // unpcklps      %xmm0,%xmm6
  .byte  243,15,16,28,186                    // movss         (%edx,%edi,4),%xmm3
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,216                           // unpcklps      %xmm0,%xmm3
  .byte  102,15,20,222                       // unpcklpd      %xmm6,%xmm3
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  102,15,254,85,168                   // paddd         -0x58(%ebp),%xmm2
  .byte  102,15,112,194,245                  // pshufd        $0xf5,%xmm2,%xmm0
  .byte  102,15,111,137,39,124,0,0           // movdqa        0x7c27(%ecx),%xmm1
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,193                      // pmuludq       %xmm1,%xmm0
  .byte  102,15,112,240,232                  // pshufd        $0xe8,%xmm0,%xmm6
  .byte  102,15,112,194,232                  // pshufd        $0xe8,%xmm2,%xmm0
  .byte  102,15,98,198                       // punpckldq     %xmm6,%xmm0
  .byte  102,15,126,208                      // movd          %xmm2,%eax
  .byte  102,15,112,224,229                  // pshufd        $0xe5,%xmm0,%xmm4
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  102,15,112,224,78                   // pshufd        $0x4e,%xmm0,%xmm4
  .byte  102,15,126,231                      // movd          %xmm4,%edi
  .byte  102,15,112,224,231                  // pshufd        $0xe7,%xmm0,%xmm4
  .byte  102,15,126,227                      // movd          %xmm4,%ebx
  .byte  243,15,16,36,154                    // movss         (%edx,%ebx,4),%xmm4
  .byte  243,15,16,52,186                    // movss         (%edx,%edi,4),%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  243,15,16,36,178                    // movss         (%edx,%esi,4),%xmm4
  .byte  243,15,16,12,130                    // movss         (%edx,%eax,4),%xmm1
  .byte  15,20,204                           // unpcklps      %xmm4,%xmm1
  .byte  102,15,20,206                       // unpcklpd      %xmm6,%xmm1
  .byte  102,15,111,224                      // movdqa        %xmm0,%xmm4
  .byte  102,15,118,210                      // pcmpeqd       %xmm2,%xmm2
  .byte  102,15,250,226                      // psubd         %xmm2,%xmm4
  .byte  102,15,112,244,229                  // pshufd        $0xe5,%xmm4,%xmm6
  .byte  102,15,126,240                      // movd          %xmm6,%eax
  .byte  102,15,112,244,78                   // pshufd        $0x4e,%xmm4,%xmm6
  .byte  102,15,126,246                      // movd          %xmm6,%esi
  .byte  102,15,126,231                      // movd          %xmm4,%edi
  .byte  102,15,112,228,231                  // pshufd        $0xe7,%xmm4,%xmm4
  .byte  102,15,126,227                      // movd          %xmm4,%ebx
  .byte  243,15,16,36,154                    // movss         (%edx,%ebx,4),%xmm4
  .byte  243,15,16,52,178                    // movss         (%edx,%esi,4),%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  243,15,16,20,186                    // movss         (%edx,%edi,4),%xmm2
  .byte  243,15,16,36,130                    // movss         (%edx,%eax,4),%xmm4
  .byte  15,20,212                           // unpcklps      %xmm4,%xmm2
  .byte  102,15,20,214                       // unpcklpd      %xmm6,%xmm2
  .byte  102,15,254,129,231,117,0,0          // paddd         0x75e7(%ecx),%xmm0
  .byte  102,15,112,224,229                  // pshufd        $0xe5,%xmm0,%xmm4
  .byte  102,15,126,224                      // movd          %xmm4,%eax
  .byte  102,15,112,224,78                   // pshufd        $0x4e,%xmm0,%xmm4
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,36,178                    // movss         (%edx,%esi,4),%xmm4
  .byte  15,20,224                           // unpcklps      %xmm0,%xmm4
  .byte  243,15,16,52,186                    // movss         (%edx,%edi,4),%xmm6
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,240                           // unpcklps      %xmm0,%xmm6
  .byte  102,15,20,244                       // unpcklpd      %xmm4,%xmm6
  .byte  15,40,101,200                       // movaps        -0x38(%ebp),%xmm4
  .byte  15,92,204                           // subps         %xmm4,%xmm1
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  15,40,165,232,254,255,255           // movaps        -0x118(%ebp),%xmm4
  .byte  15,92,212                           // subps         %xmm4,%xmm2
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  15,92,243                           // subps         %xmm3,%xmm6
  .byte  15,89,240                           // mulps         %xmm0,%xmm6
  .byte  15,88,243                           // addps         %xmm3,%xmm6
  .byte  15,40,93,136                        // movaps        -0x78(%ebp),%xmm3
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,40,133,56,255,255,255            // movaps        -0xc8(%ebp),%xmm0
  .byte  15,89,200                           // mulps         %xmm0,%xmm1
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  15,92,213                           // subps         %xmm5,%xmm2
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,92,247                           // subps         %xmm7,%xmm6
  .byte  15,89,240                           // mulps         %xmm0,%xmm6
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  15,91,133,216,254,255,255           // cvtdq2ps      -0x128(%ebp),%xmm0
  .byte  15,40,141,248,254,255,255           // movaps        -0x108(%ebp),%xmm1
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,41,141,248,254,255,255           // movaps        %xmm1,-0x108(%ebp)
  .byte  15,40,133,40,255,255,255            // movaps        -0xd8(%ebp),%xmm0
  .byte  15,92,216                           // subps         %xmm0,%xmm3
  .byte  15,89,217                           // mulps         %xmm1,%xmm3
  .byte  15,88,216                           // addps         %xmm0,%xmm3
  .byte  15,41,157,40,255,255,255            // movaps        %xmm3,-0xd8(%ebp)
  .byte  15,40,133,104,255,255,255           // movaps        -0x98(%ebp),%xmm0
  .byte  15,92,208                           // subps         %xmm0,%xmm2
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  15,41,149,104,255,255,255           // movaps        %xmm2,-0x98(%ebp)
  .byte  15,40,69,184                        // movaps        -0x48(%ebp),%xmm0
  .byte  15,92,240                           // subps         %xmm0,%xmm6
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  15,88,240                           // addps         %xmm0,%xmm6
  .byte  15,41,181,216,254,255,255           // movaps        %xmm6,-0x128(%ebp)
  .byte  243,15,91,141,120,255,255,255       // cvttps2dq     -0x88(%ebp),%xmm1
  .byte  102,15,127,77,136                   // movdqa        %xmm1,-0x78(%ebp)
  .byte  102,15,111,133,8,255,255,255        // movdqa        -0xf8(%ebp),%xmm0
  .byte  102,15,254,193                      // paddd         %xmm1,%xmm0
  .byte  102,15,127,133,8,255,255,255        // movdqa        %xmm0,-0xf8(%ebp)
  .byte  102,15,111,141,72,255,255,255       // movdqa        -0xb8(%ebp),%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,111,93,152                   // movdqa        -0x68(%ebp),%xmm3
  .byte  102,15,254,217                      // paddd         %xmm1,%xmm3
  .byte  102,15,112,211,245                  // pshufd        $0xf5,%xmm3,%xmm2
  .byte  102,15,111,129,39,124,0,0           // movdqa        0x7c27(%ecx),%xmm0
  .byte  102,15,244,216                      // pmuludq       %xmm0,%xmm3
  .byte  102,15,244,208                      // pmuludq       %xmm0,%xmm2
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  102,15,112,226,232                  // pshufd        $0xe8,%xmm2,%xmm4
  .byte  102,15,112,211,232                  // pshufd        $0xe8,%xmm3,%xmm2
  .byte  102,15,98,212                       // punpckldq     %xmm4,%xmm2
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,218,229                  // pshufd        $0xe5,%xmm2,%xmm3
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  102,15,112,218,231                  // pshufd        $0xe7,%xmm2,%xmm3
  .byte  102,15,126,219                      // movd          %xmm3,%ebx
  .byte  243,15,16,28,154                    // movss         (%edx,%ebx,4),%xmm3
  .byte  243,15,16,44,186                    // movss         (%edx,%edi,4),%xmm5
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  243,15,16,28,178                    // movss         (%edx,%esi,4),%xmm3
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,195                           // unpcklps      %xmm3,%xmm0
  .byte  102,15,20,197                       // unpcklpd      %xmm5,%xmm0
  .byte  102,15,41,133,120,255,255,255       // movapd        %xmm0,-0x88(%ebp)
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,118,192                      // pcmpeqd       %xmm0,%xmm0
  .byte  102,15,250,216                      // psubd         %xmm0,%xmm3
  .byte  102,15,112,235,229                  // pshufd        $0xe5,%xmm3,%xmm5
  .byte  102,15,126,232                      // movd          %xmm5,%eax
  .byte  102,15,112,235,78                   // pshufd        $0x4e,%xmm3,%xmm5
  .byte  102,15,126,238                      // movd          %xmm5,%esi
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  102,15,112,219,231                  // pshufd        $0xe7,%xmm3,%xmm3
  .byte  102,15,126,219                      // movd          %xmm3,%ebx
  .byte  243,15,16,28,154                    // movss         (%edx,%ebx,4),%xmm3
  .byte  243,15,16,52,178                    // movss         (%edx,%esi,4),%xmm6
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  243,15,16,44,186                    // movss         (%edx,%edi,4),%xmm5
  .byte  243,15,16,28,130                    // movss         (%edx,%eax,4),%xmm3
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  102,15,20,238                       // unpcklpd      %xmm6,%xmm5
  .byte  102,15,254,145,231,117,0,0          // paddd         0x75e7(%ecx),%xmm2
  .byte  102,15,112,218,229                  // pshufd        $0xe5,%xmm2,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  102,15,112,210,231                  // pshufd        $0xe7,%xmm2,%xmm2
  .byte  102,15,126,211                      // movd          %xmm2,%ebx
  .byte  243,15,16,20,154                    // movss         (%edx,%ebx,4),%xmm2
  .byte  243,15,16,28,178                    // movss         (%edx,%esi,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  243,15,16,52,186                    // movss         (%edx,%edi,4),%xmm6
  .byte  243,15,16,20,130                    // movss         (%edx,%eax,4),%xmm2
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  102,15,20,243                       // unpcklpd      %xmm3,%xmm6
  .byte  102,15,254,77,168                   // paddd         -0x58(%ebp),%xmm1
  .byte  102,15,112,209,245                  // pshufd        $0xf5,%xmm1,%xmm2
  .byte  102,15,244,207                      // pmuludq       %xmm7,%xmm1
  .byte  102,15,244,215                      // pmuludq       %xmm7,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,112,217,232                  // pshufd        $0xe8,%xmm1,%xmm3
  .byte  102,15,98,218                       // punpckldq     %xmm2,%xmm3
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  102,15,112,203,229                  // pshufd        $0xe5,%xmm3,%xmm1
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,112,203,78                   // pshufd        $0x4e,%xmm3,%xmm1
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,203,231                  // pshufd        $0xe7,%xmm3,%xmm1
  .byte  102,15,126,203                      // movd          %xmm1,%ebx
  .byte  243,15,16,12,154                    // movss         (%edx,%ebx,4),%xmm1
  .byte  243,15,16,20,186                    // movss         (%edx,%edi,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  243,15,16,60,178                    // movss         (%edx,%esi,4),%xmm7
  .byte  243,15,16,36,130                    // movss         (%edx,%eax,4),%xmm4
  .byte  15,20,231                           // unpcklps      %xmm7,%xmm4
  .byte  102,15,20,226                       // unpcklpd      %xmm2,%xmm4
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,250,208                      // psubd         %xmm0,%xmm2
  .byte  102,15,112,250,229                  // pshufd        $0xe5,%xmm2,%xmm7
  .byte  102,15,126,248                      // movd          %xmm7,%eax
  .byte  102,15,112,250,78                   // pshufd        $0x4e,%xmm2,%xmm7
  .byte  102,15,126,254                      // movd          %xmm7,%esi
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  102,15,112,210,231                  // pshufd        $0xe7,%xmm2,%xmm2
  .byte  102,15,126,211                      // movd          %xmm2,%ebx
  .byte  243,15,16,20,154                    // movss         (%edx,%ebx,4),%xmm2
  .byte  243,15,16,60,178                    // movss         (%edx,%esi,4),%xmm7
  .byte  15,20,250                           // unpcklps      %xmm2,%xmm7
  .byte  243,15,16,20,186                    // movss         (%edx,%edi,4),%xmm2
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,208                           // unpcklps      %xmm0,%xmm2
  .byte  102,15,20,215                       // unpcklpd      %xmm7,%xmm2
  .byte  102,15,111,137,231,117,0,0          // movdqa        0x75e7(%ecx),%xmm1
  .byte  102,15,254,217                      // paddd         %xmm1,%xmm3
  .byte  102,15,112,195,229                  // pshufd        $0xe5,%xmm3,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,195,78                   // pshufd        $0x4e,%xmm3,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  102,15,112,195,231                  // pshufd        $0xe7,%xmm3,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,60,178                    // movss         (%edx,%esi,4),%xmm7
  .byte  15,20,248                           // unpcklps      %xmm0,%xmm7
  .byte  243,15,16,28,186                    // movss         (%edx,%edi,4),%xmm3
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,216                           // unpcklps      %xmm0,%xmm3
  .byte  102,15,20,223                       // unpcklpd      %xmm7,%xmm3
  .byte  15,40,189,120,255,255,255           // movaps        -0x88(%ebp),%xmm7
  .byte  15,92,231                           // subps         %xmm7,%xmm4
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,88,231                           // addps         %xmm7,%xmm4
  .byte  15,41,165,120,255,255,255           // movaps        %xmm4,-0x88(%ebp)
  .byte  15,92,213                           // subps         %xmm5,%xmm2
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  15,92,222                           // subps         %xmm6,%xmm3
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,88,222                           // addps         %xmm6,%xmm3
  .byte  15,41,93,184                        // movaps        %xmm3,-0x48(%ebp)
  .byte  102,15,111,149,8,255,255,255        // movdqa        -0xf8(%ebp),%xmm2
  .byte  102,15,254,149,88,255,255,255       // paddd         -0xa8(%ebp),%xmm2
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,254,69,152                   // paddd         -0x68(%ebp),%xmm0
  .byte  102,15,112,224,245                  // pshufd        $0xf5,%xmm0,%xmm4
  .byte  102,15,111,169,39,124,0,0           // movdqa        0x7c27(%ecx),%xmm5
  .byte  102,15,111,221                      // movdqa        %xmm5,%xmm3
  .byte  102,15,244,195                      // pmuludq       %xmm3,%xmm0
  .byte  102,15,244,227                      // pmuludq       %xmm3,%xmm4
  .byte  102,15,112,228,232                  // pshufd        $0xe8,%xmm4,%xmm4
  .byte  102,15,112,240,232                  // pshufd        $0xe8,%xmm0,%xmm6
  .byte  102,15,98,244                       // punpckldq     %xmm4,%xmm6
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,198,229                  // pshufd        $0xe5,%xmm6,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,112,198,78                   // pshufd        $0x4e,%xmm6,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,198,231                  // pshufd        $0xe7,%xmm6,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,44,186                    // movss         (%edx,%edi,4),%xmm5
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  243,15,16,4,178                     // movss         (%edx,%esi,4),%xmm0
  .byte  243,15,16,36,130                    // movss         (%edx,%eax,4),%xmm4
  .byte  15,20,224                           // unpcklps      %xmm0,%xmm4
  .byte  102,15,20,229                       // unpcklpd      %xmm5,%xmm4
  .byte  102,15,111,198                      // movdqa        %xmm6,%xmm0
  .byte  102,15,118,219                      // pcmpeqd       %xmm3,%xmm3
  .byte  102,15,250,195                      // psubd         %xmm3,%xmm0
  .byte  102,15,112,232,229                  // pshufd        $0xe5,%xmm0,%xmm5
  .byte  102,15,126,232                      // movd          %xmm5,%eax
  .byte  102,15,112,232,78                   // pshufd        $0x4e,%xmm0,%xmm5
  .byte  102,15,126,238                      // movd          %xmm5,%esi
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,60,178                    // movss         (%edx,%esi,4),%xmm7
  .byte  15,20,248                           // unpcklps      %xmm0,%xmm7
  .byte  243,15,16,44,186                    // movss         (%edx,%edi,4),%xmm5
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,232                           // unpcklps      %xmm0,%xmm5
  .byte  102,15,20,239                       // unpcklpd      %xmm7,%xmm5
  .byte  102,15,254,241                      // paddd         %xmm1,%xmm6
  .byte  102,15,112,198,229                  // pshufd        $0xe5,%xmm6,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,198,78                   // pshufd        $0x4e,%xmm6,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,126,247                      // movd          %xmm6,%edi
  .byte  102,15,112,198,231                  // pshufd        $0xe7,%xmm6,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,60,178                    // movss         (%edx,%esi,4),%xmm7
  .byte  15,20,248                           // unpcklps      %xmm0,%xmm7
  .byte  243,15,16,52,186                    // movss         (%edx,%edi,4),%xmm6
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,240                           // unpcklps      %xmm0,%xmm6
  .byte  102,15,20,247                       // unpcklpd      %xmm7,%xmm6
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,254,77,168                   // paddd         -0x58(%ebp),%xmm1
  .byte  102,15,112,193,245                  // pshufd        $0xf5,%xmm1,%xmm0
  .byte  102,15,111,145,39,124,0,0           // movdqa        0x7c27(%ecx),%xmm2
  .byte  102,15,244,202                      // pmuludq       %xmm2,%xmm1
  .byte  102,15,244,194                      // pmuludq       %xmm2,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,112,249,232                  // pshufd        $0xe8,%xmm1,%xmm7
  .byte  102,15,98,248                       // punpckldq     %xmm0,%xmm7
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  102,15,112,199,229                  // pshufd        $0xe5,%xmm7,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,112,199,78                   // pshufd        $0x4e,%xmm7,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,199,231                  // pshufd        $0xe7,%xmm7,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,12,154                    // movss         (%edx,%ebx,4),%xmm1
  .byte  243,15,16,4,186                     // movss         (%edx,%edi,4),%xmm0
  .byte  15,20,193                           // unpcklps      %xmm1,%xmm0
  .byte  243,15,16,12,178                    // movss         (%edx,%esi,4),%xmm1
  .byte  243,15,16,20,130                    // movss         (%edx,%eax,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  102,15,20,208                       // unpcklpd      %xmm0,%xmm2
  .byte  102,15,111,199                      // movdqa        %xmm7,%xmm0
  .byte  102,15,250,195                      // psubd         %xmm3,%xmm0
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,12,178                    // movss         (%edx,%esi,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,15,16,28,186                    // movss         (%edx,%edi,4),%xmm3
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,216                           // unpcklps      %xmm0,%xmm3
  .byte  102,15,20,217                       // unpcklpd      %xmm1,%xmm3
  .byte  102,15,254,185,231,117,0,0          // paddd         0x75e7(%ecx),%xmm7
  .byte  102,15,112,199,229                  // pshufd        $0xe5,%xmm7,%xmm0
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,199,78                   // pshufd        $0x4e,%xmm7,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,126,255                      // movd          %xmm7,%edi
  .byte  102,15,112,199,231                  // pshufd        $0xe7,%xmm7,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,12,178                    // movss         (%edx,%esi,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,15,16,60,186                    // movss         (%edx,%edi,4),%xmm7
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,248                           // unpcklps      %xmm0,%xmm7
  .byte  102,15,20,249                       // unpcklpd      %xmm1,%xmm7
  .byte  15,92,212                           // subps         %xmm4,%xmm2
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  15,92,221                           // subps         %xmm5,%xmm3
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,88,221                           // addps         %xmm5,%xmm3
  .byte  15,92,254                           // subps         %xmm6,%xmm7
  .byte  15,89,248                           // mulps         %xmm0,%xmm7
  .byte  15,88,254                           // addps         %xmm6,%xmm7
  .byte  15,40,141,120,255,255,255           // movaps        -0x88(%ebp),%xmm1
  .byte  15,92,209                           // subps         %xmm1,%xmm2
  .byte  15,40,133,56,255,255,255            // movaps        -0xc8(%ebp),%xmm0
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,88,209                           // addps         %xmm1,%xmm2
  .byte  15,41,149,8,255,255,255             // movaps        %xmm2,-0xf8(%ebp)
  .byte  15,40,77,200                        // movaps        -0x38(%ebp),%xmm1
  .byte  15,92,217                           // subps         %xmm1,%xmm3
  .byte  15,89,216                           // mulps         %xmm0,%xmm3
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  15,41,157,120,255,255,255           // movaps        %xmm3,-0x88(%ebp)
  .byte  15,40,77,184                        // movaps        -0x48(%ebp),%xmm1
  .byte  15,92,249                           // subps         %xmm1,%xmm7
  .byte  15,89,248                           // mulps         %xmm0,%xmm7
  .byte  15,88,249                           // addps         %xmm1,%xmm7
  .byte  15,41,125,184                       // movaps        %xmm7,-0x48(%ebp)
  .byte  102,15,111,133,24,255,255,255       // movdqa        -0xe8(%ebp),%xmm0
  .byte  102,15,254,69,136                   // paddd         -0x78(%ebp),%xmm0
  .byte  102,15,127,133,24,255,255,255       // movdqa        %xmm0,-0xe8(%ebp)
  .byte  102,15,111,141,72,255,255,255       // movdqa        -0xb8(%ebp),%xmm1
  .byte  102,15,254,200                      // paddd         %xmm0,%xmm1
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,111,233                      // movdqa        %xmm1,%xmm5
  .byte  102,15,254,69,152                   // paddd         -0x68(%ebp),%xmm0
  .byte  102,15,112,200,245                  // pshufd        $0xf5,%xmm0,%xmm1
  .byte  102,15,111,145,39,124,0,0           // movdqa        0x7c27(%ecx),%xmm2
  .byte  102,15,244,194                      // pmuludq       %xmm2,%xmm0
  .byte  102,15,244,202                      // pmuludq       %xmm2,%xmm1
  .byte  102,15,111,250                      // movdqa        %xmm2,%xmm7
  .byte  102,15,112,201,232                  // pshufd        $0xe8,%xmm1,%xmm1
  .byte  102,15,112,208,232                  // pshufd        $0xe8,%xmm0,%xmm2
  .byte  102,15,98,209                       // punpckldq     %xmm1,%xmm2
  .byte  102,15,126,192                      // movd          %xmm0,%eax
  .byte  102,15,112,194,229                  // pshufd        $0xe5,%xmm2,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,112,194,78                   // pshufd        $0x4e,%xmm2,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,194,231                  // pshufd        $0xe7,%xmm2,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,12,186                    // movss         (%edx,%edi,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,15,16,28,178                    // movss         (%edx,%esi,4),%xmm3
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,195                           // unpcklps      %xmm3,%xmm0
  .byte  102,15,20,193                       // unpcklpd      %xmm1,%xmm0
  .byte  102,15,41,133,72,255,255,255        // movapd        %xmm0,-0xb8(%ebp)
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,118,246                      // pcmpeqd       %xmm6,%xmm6
  .byte  102,15,250,206                      // psubd         %xmm6,%xmm1
  .byte  102,15,112,217,229                  // pshufd        $0xe5,%xmm1,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,201,231                  // pshufd        $0xe7,%xmm1,%xmm1
  .byte  102,15,126,203                      // movd          %xmm1,%ebx
  .byte  243,15,16,12,154                    // movss         (%edx,%ebx,4),%xmm1
  .byte  243,15,16,28,178                    // movss         (%edx,%esi,4),%xmm3
  .byte  15,20,217                           // unpcklps      %xmm1,%xmm3
  .byte  243,15,16,12,186                    // movss         (%edx,%edi,4),%xmm1
  .byte  243,15,16,36,130                    // movss         (%edx,%eax,4),%xmm4
  .byte  15,20,204                           // unpcklps      %xmm4,%xmm1
  .byte  102,15,20,203                       // unpcklpd      %xmm3,%xmm1
  .byte  102,15,254,145,231,117,0,0          // paddd         0x75e7(%ecx),%xmm2
  .byte  102,15,112,218,229                  // pshufd        $0xe5,%xmm2,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  102,15,112,210,231                  // pshufd        $0xe7,%xmm2,%xmm2
  .byte  102,15,126,211                      // movd          %xmm2,%ebx
  .byte  243,15,16,20,154                    // movss         (%edx,%ebx,4),%xmm2
  .byte  243,15,16,28,178                    // movss         (%edx,%esi,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  243,15,16,20,186                    // movss         (%edx,%edi,4),%xmm2
  .byte  243,15,16,36,130                    // movss         (%edx,%eax,4),%xmm4
  .byte  15,20,212                           // unpcklps      %xmm4,%xmm2
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,254,101,168                  // paddd         -0x58(%ebp),%xmm4
  .byte  102,15,112,220,245                  // pshufd        $0xf5,%xmm4,%xmm3
  .byte  102,15,244,231                      // pmuludq       %xmm7,%xmm4
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,244,223                      // pmuludq       %xmm7,%xmm3
  .byte  102,15,112,227,232                  // pshufd        $0xe8,%xmm3,%xmm4
  .byte  102,15,112,221,232                  // pshufd        $0xe8,%xmm5,%xmm3
  .byte  102,15,98,220                       // punpckldq     %xmm4,%xmm3
  .byte  102,15,126,232                      // movd          %xmm5,%eax
  .byte  102,15,112,227,229                  // pshufd        $0xe5,%xmm3,%xmm4
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  102,15,112,227,78                   // pshufd        $0x4e,%xmm3,%xmm4
  .byte  102,15,126,231                      // movd          %xmm4,%edi
  .byte  102,15,112,227,231                  // pshufd        $0xe7,%xmm3,%xmm4
  .byte  102,15,126,227                      // movd          %xmm4,%ebx
  .byte  243,15,16,36,154                    // movss         (%edx,%ebx,4),%xmm4
  .byte  243,15,16,44,186                    // movss         (%edx,%edi,4),%xmm5
  .byte  15,20,236                           // unpcklps      %xmm4,%xmm5
  .byte  243,15,16,36,178                    // movss         (%edx,%esi,4),%xmm4
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,196                           // unpcklps      %xmm4,%xmm0
  .byte  102,15,20,197                       // unpcklpd      %xmm5,%xmm0
  .byte  102,15,111,227                      // movdqa        %xmm3,%xmm4
  .byte  102,15,250,230                      // psubd         %xmm6,%xmm4
  .byte  102,15,112,236,229                  // pshufd        $0xe5,%xmm4,%xmm5
  .byte  102,15,126,232                      // movd          %xmm5,%eax
  .byte  102,15,112,236,78                   // pshufd        $0x4e,%xmm4,%xmm5
  .byte  102,15,126,238                      // movd          %xmm5,%esi
  .byte  102,15,126,231                      // movd          %xmm4,%edi
  .byte  102,15,112,228,231                  // pshufd        $0xe7,%xmm4,%xmm4
  .byte  102,15,126,227                      // movd          %xmm4,%ebx
  .byte  243,15,16,36,154                    // movss         (%edx,%ebx,4),%xmm4
  .byte  243,15,16,52,178                    // movss         (%edx,%esi,4),%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  243,15,16,60,186                    // movss         (%edx,%edi,4),%xmm7
  .byte  243,15,16,36,130                    // movss         (%edx,%eax,4),%xmm4
  .byte  15,20,252                           // unpcklps      %xmm4,%xmm7
  .byte  102,15,20,254                       // unpcklpd      %xmm6,%xmm7
  .byte  102,15,254,153,231,117,0,0          // paddd         0x75e7(%ecx),%xmm3
  .byte  102,15,112,227,229                  // pshufd        $0xe5,%xmm3,%xmm4
  .byte  102,15,126,224                      // movd          %xmm4,%eax
  .byte  102,15,112,227,78                   // pshufd        $0x4e,%xmm3,%xmm4
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  102,15,112,219,231                  // pshufd        $0xe7,%xmm3,%xmm3
  .byte  102,15,126,219                      // movd          %xmm3,%ebx
  .byte  243,15,16,28,154                    // movss         (%edx,%ebx,4),%xmm3
  .byte  243,15,16,52,178                    // movss         (%edx,%esi,4),%xmm6
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  243,15,16,44,186                    // movss         (%edx,%edi,4),%xmm5
  .byte  243,15,16,28,130                    // movss         (%edx,%eax,4),%xmm3
  .byte  15,20,235                           // unpcklps      %xmm3,%xmm5
  .byte  102,15,20,238                       // unpcklpd      %xmm6,%xmm5
  .byte  15,40,165,72,255,255,255            // movaps        -0xb8(%ebp),%xmm4
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,41,133,72,255,255,255            // movaps        %xmm0,-0xb8(%ebp)
  .byte  15,92,249                           // subps         %xmm1,%xmm7
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,88,249                           // addps         %xmm1,%xmm7
  .byte  15,92,234                           // subps         %xmm2,%xmm5
  .byte  15,89,235                           // mulps         %xmm3,%xmm5
  .byte  15,88,234                           // addps         %xmm2,%xmm5
  .byte  102,15,111,133,24,255,255,255       // movdqa        -0xe8(%ebp),%xmm0
  .byte  102,15,254,133,88,255,255,255       // paddd         -0xa8(%ebp),%xmm0
  .byte  102,15,111,85,152                   // movdqa        -0x68(%ebp),%xmm2
  .byte  102,15,254,208                      // paddd         %xmm0,%xmm2
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,15,112,194,245                  // pshufd        $0xf5,%xmm2,%xmm0
  .byte  102,15,111,137,39,124,0,0           // movdqa        0x7c27(%ecx),%xmm1
  .byte  102,15,244,209                      // pmuludq       %xmm1,%xmm2
  .byte  102,15,244,193                      // pmuludq       %xmm1,%xmm0
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,112,200,232                  // pshufd        $0xe8,%xmm0,%xmm1
  .byte  102,15,112,194,232                  // pshufd        $0xe8,%xmm2,%xmm0
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  102,15,126,208                      // movd          %xmm2,%eax
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,200,231                  // pshufd        $0xe7,%xmm0,%xmm1
  .byte  102,15,126,203                      // movd          %xmm1,%ebx
  .byte  243,15,16,12,154                    // movss         (%edx,%ebx,4),%xmm1
  .byte  243,15,16,20,186                    // movss         (%edx,%edi,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  243,15,16,12,178                    // movss         (%edx,%esi,4),%xmm1
  .byte  243,15,16,36,130                    // movss         (%edx,%eax,4),%xmm4
  .byte  15,20,225                           // unpcklps      %xmm1,%xmm4
  .byte  102,15,20,226                       // unpcklpd      %xmm2,%xmm4
  .byte  102,15,41,101,152                   // movapd        %xmm4,-0x68(%ebp)
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,118,210                      // pcmpeqd       %xmm2,%xmm2
  .byte  102,15,250,202                      // psubd         %xmm2,%xmm1
  .byte  102,15,112,209,229                  // pshufd        $0xe5,%xmm1,%xmm2
  .byte  102,15,126,208                      // movd          %xmm2,%eax
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  102,15,126,214                      // movd          %xmm2,%esi
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,201,231                  // pshufd        $0xe7,%xmm1,%xmm1
  .byte  102,15,126,203                      // movd          %xmm1,%ebx
  .byte  243,15,16,12,154                    // movss         (%edx,%ebx,4),%xmm1
  .byte  243,15,16,20,178                    // movss         (%edx,%esi,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  243,15,16,36,186                    // movss         (%edx,%edi,4),%xmm4
  .byte  243,15,16,12,130                    // movss         (%edx,%eax,4),%xmm1
  .byte  15,20,225                           // unpcklps      %xmm1,%xmm4
  .byte  102,15,20,226                       // unpcklpd      %xmm2,%xmm4
  .byte  102,15,41,165,88,255,255,255        // movapd        %xmm4,-0xa8(%ebp)
  .byte  102,15,254,129,231,117,0,0          // paddd         0x75e7(%ecx),%xmm0
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,12,178                    // movss         (%edx,%esi,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,15,16,36,186                    // movss         (%edx,%edi,4),%xmm4
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,224                           // unpcklps      %xmm0,%xmm4
  .byte  102,15,20,225                       // unpcklpd      %xmm1,%xmm4
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,254,77,168                   // paddd         -0x58(%ebp),%xmm1
  .byte  102,15,112,193,245                  // pshufd        $0xf5,%xmm1,%xmm0
  .byte  102,15,244,206                      // pmuludq       %xmm6,%xmm1
  .byte  102,15,244,198                      // pmuludq       %xmm6,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,112,209,232                  // pshufd        $0xe8,%xmm1,%xmm2
  .byte  102,15,98,208                       // punpckldq     %xmm0,%xmm2
  .byte  102,15,126,200                      // movd          %xmm1,%eax
  .byte  102,15,112,194,229                  // pshufd        $0xe5,%xmm2,%xmm0
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  102,15,112,194,78                   // pshufd        $0x4e,%xmm2,%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,194,231                  // pshufd        $0xe7,%xmm2,%xmm0
  .byte  102,15,126,195                      // movd          %xmm0,%ebx
  .byte  243,15,16,4,154                     // movss         (%edx,%ebx,4),%xmm0
  .byte  243,15,16,12,186                    // movss         (%edx,%edi,4),%xmm1
  .byte  15,20,200                           // unpcklps      %xmm0,%xmm1
  .byte  243,15,16,28,178                    // movss         (%edx,%esi,4),%xmm3
  .byte  243,15,16,4,130                     // movss         (%edx,%eax,4),%xmm0
  .byte  15,20,195                           // unpcklps      %xmm3,%xmm0
  .byte  102,15,20,193                       // unpcklpd      %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,118,219                      // pcmpeqd       %xmm3,%xmm3
  .byte  102,15,250,203                      // psubd         %xmm3,%xmm1
  .byte  102,15,112,217,229                  // pshufd        $0xe5,%xmm1,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,201,231                  // pshufd        $0xe7,%xmm1,%xmm1
  .byte  102,15,126,203                      // movd          %xmm1,%ebx
  .byte  243,15,16,12,154                    // movss         (%edx,%ebx,4),%xmm1
  .byte  243,15,16,28,178                    // movss         (%edx,%esi,4),%xmm3
  .byte  15,20,217                           // unpcklps      %xmm1,%xmm3
  .byte  243,15,16,12,186                    // movss         (%edx,%edi,4),%xmm1
  .byte  243,15,16,52,130                    // movss         (%edx,%eax,4),%xmm6
  .byte  15,20,206                           // unpcklps      %xmm6,%xmm1
  .byte  102,15,20,203                       // unpcklpd      %xmm3,%xmm1
  .byte  102,15,254,145,231,117,0,0          // paddd         0x75e7(%ecx),%xmm2
  .byte  102,15,112,218,229                  // pshufd        $0xe5,%xmm2,%xmm3
  .byte  102,15,126,216                      // movd          %xmm3,%eax
  .byte  102,15,112,218,78                   // pshufd        $0x4e,%xmm2,%xmm3
  .byte  102,15,126,222                      // movd          %xmm3,%esi
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  102,15,112,210,231                  // pshufd        $0xe7,%xmm2,%xmm2
  .byte  102,15,126,211                      // movd          %xmm2,%ebx
  .byte  243,15,16,20,154                    // movss         (%edx,%ebx,4),%xmm2
  .byte  243,15,16,28,178                    // movss         (%edx,%esi,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  243,15,16,20,186                    // movss         (%edx,%edi,4),%xmm2
  .byte  243,15,16,52,130                    // movss         (%edx,%eax,4),%xmm6
  .byte  15,20,214                           // unpcklps      %xmm6,%xmm2
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  15,40,117,152                       // movaps        -0x68(%ebp),%xmm6
  .byte  15,92,198                           // subps         %xmm6,%xmm0
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,198                           // addps         %xmm6,%xmm0
  .byte  15,40,181,88,255,255,255            // movaps        -0xa8(%ebp),%xmm6
  .byte  15,92,206                           // subps         %xmm6,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,88,206                           // addps         %xmm6,%xmm1
  .byte  15,92,212                           // subps         %xmm4,%xmm2
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  15,40,165,72,255,255,255            // movaps        -0xb8(%ebp),%xmm4
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,40,157,56,255,255,255            // movaps        -0xc8(%ebp),%xmm3
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,92,207                           // subps         %xmm7,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  15,92,213                           // subps         %xmm5,%xmm2
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,40,165,8,255,255,255             // movaps        -0xf8(%ebp),%xmm4
  .byte  15,92,196                           // subps         %xmm4,%xmm0
  .byte  15,40,157,248,254,255,255           // movaps        -0x108(%ebp),%xmm3
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,196                           // addps         %xmm4,%xmm0
  .byte  15,40,165,120,255,255,255           // movaps        -0x88(%ebp),%xmm4
  .byte  15,92,204                           // subps         %xmm4,%xmm1
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  15,40,101,184                       // movaps        -0x48(%ebp),%xmm4
  .byte  15,92,212                           // subps         %xmm4,%xmm2
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  15,91,157,200,254,255,255           // cvtdq2ps      -0x138(%ebp),%xmm3
  .byte  15,40,165,168,254,255,255           // movaps        -0x158(%ebp),%xmm4
  .byte  15,92,227                           // subps         %xmm3,%xmm4
  .byte  15,40,157,40,255,255,255            // movaps        -0xd8(%ebp),%xmm3
  .byte  15,92,195                           // subps         %xmm3,%xmm0
  .byte  15,89,196                           // mulps         %xmm4,%xmm0
  .byte  15,88,195                           // addps         %xmm3,%xmm0
  .byte  15,40,157,104,255,255,255           // movaps        -0x98(%ebp),%xmm3
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  15,40,157,216,254,255,255           // movaps        -0x128(%ebp),%xmm3
  .byte  15,92,211                           // subps         %xmm3,%xmm2
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  141,66,8                            // lea           0x8(%edx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,153,167,117,0,0               // movaps        0x75a7(%ecx),%xmm3
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  129,196,92,1,0,0                    // add           $0x15c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_gauss_a_to_rgba_sse2
.globl _sk_gauss_a_to_rgba_sse2
FUNCTION(_sk_gauss_a_to_rgba_sse2)
_sk_gauss_a_to_rgba_sse2:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  232,0,0,0,0                         // call          99ce <_sk_gauss_a_to_rgba_sse2+0xb>
  .byte  88                                  // pop           %eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  15,40,128,226,103,0,0               // movaps        0x67e2(%eax),%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,128,242,103,0,0               // addps         0x67f2(%eax),%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,128,2,104,0,0                 // addps         0x6802(%eax),%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,128,18,104,0,0                // addps         0x6812(%eax),%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,128,34,104,0,0                // addps         0x6822(%eax),%xmm0
  .byte  141,65,4                            // lea           0x4(%ecx),%eax
  .byte  131,236,8                           // sub           $0x8,%esp
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  80                                  // push          %eax
  .byte  255,117,8                           // pushl         0x8(%ebp)
  .byte  255,17                              // call          *(%ecx)
  .byte  131,196,24                          // add           $0x18,%esp
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  144                                 // nop

HIDDEN _sk_start_pipeline_sse2_lowp
.globl _sk_start_pipeline_sse2_lowp
FUNCTION(_sk_start_pipeline_sse2_lowp)
_sk_start_pipeline_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  139,125,12                          // mov           0xc(%ebp),%edi
  .byte  59,125,20                           // cmp           0x14(%ebp),%edi
  .byte  15,131,193,0,0,0                    // jae           9af2 <_sk_start_pipeline_sse2_lowp+0xd6>
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,117,24                          // mov           0x18(%ebp),%esi
  .byte  139,30                              // mov           (%esi),%ebx
  .byte  131,198,4                           // add           $0x4,%esi
  .byte  141,64,8                            // lea           0x8(%eax),%eax
  .byte  137,69,236                          // mov           %eax,-0x14(%ebp)
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  137,125,240                         // mov           %edi,-0x10(%ebp)
  .byte  57,85,236                           // cmp           %edx,-0x14(%ebp)
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  137,223                             // mov           %ebx,%edi
  .byte  137,243                             // mov           %esi,%ebx
  .byte  119,77                              // ja            9aa4 <_sk_start_pipeline_sse2_lowp+0x88>
  .byte  139,117,8                           // mov           0x8(%ebp),%esi
  .byte  15,41,68,36,64                      // movaps        %xmm0,0x40(%esp)
  .byte  15,41,68,36,48                      // movaps        %xmm0,0x30(%esp)
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  139,69,240                          // mov           -0x10(%ebp),%eax
  .byte  137,68,36,12                        // mov           %eax,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,92,36,4                         // mov           %ebx,0x4(%esp)
  .byte  199,4,36,0,0,0,0                    // movl          $0x0,(%esp)
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  255,215                             // call          *%edi
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  141,70,8                            // lea           0x8(%esi),%eax
  .byte  131,198,16                          // add           $0x10,%esi
  .byte  57,214                              // cmp           %edx,%esi
  .byte  137,198                             // mov           %eax,%esi
  .byte  118,182                             // jbe           9a5a <_sk_start_pipeline_sse2_lowp+0x3e>
  .byte  137,209                             // mov           %edx,%ecx
  .byte  41,193                              // sub           %eax,%ecx
  .byte  137,222                             // mov           %ebx,%esi
  .byte  137,251                             // mov           %edi,%ebx
  .byte  139,125,240                         // mov           -0x10(%ebp),%edi
  .byte  116,55                              // je            9ae8 <_sk_start_pipeline_sse2_lowp+0xcc>
  .byte  15,41,68,36,64                      // movaps        %xmm0,0x40(%esp)
  .byte  15,41,68,36,48                      // movaps        %xmm0,0x30(%esp)
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,68,36,8                         // mov           %eax,0x8(%esp)
  .byte  137,116,36,4                        // mov           %esi,0x4(%esp)
  .byte  137,12,36                           // mov           %ecx,(%esp)
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  255,211                             // call          *%ebx
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  71                                  // inc           %edi
  .byte  59,125,20                           // cmp           0x14(%ebp),%edi
  .byte  15,133,86,255,255,255               // jne           9a48 <_sk_start_pipeline_sse2_lowp+0x2c>
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_just_return_sse2_lowp
.globl _sk_just_return_sse2_lowp
FUNCTION(_sk_just_return_sse2_lowp)
_sk_just_return_sse2_lowp:
  .byte  195                                 // ret

HIDDEN _sk_seed_shader_sse2_lowp
.globl _sk_seed_shader_sse2_lowp
FUNCTION(_sk_seed_shader_sse2_lowp)
_sk_seed_shader_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          9b08 <_sk_seed_shader_sse2_lowp+0xd>
  .byte  89                                  // pop           %ecx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  15,40,93,24                         // movaps        0x18(%ebp),%xmm3
  .byte  15,40,101,40                        // movaps        0x28(%ebp),%xmm4
  .byte  15,40,109,56                        // movaps        0x38(%ebp),%xmm5
  .byte  15,40,117,72                        // movaps        0x48(%ebp),%xmm6
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  139,62                              // mov           (%esi),%edi
  .byte  15,16,7                             // movups        (%edi),%xmm0
  .byte  15,16,79,16                         // movups        0x10(%edi),%xmm1
  .byte  139,125,16                          // mov           0x10(%ebp),%edi
  .byte  102,15,110,215                      // movd          %edi,%xmm2
  .byte  102,15,112,210,0                    // pshufd        $0x0,%xmm2,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,88,202                           // addps         %xmm2,%xmm1
  .byte  102,15,110,210                      // movd          %edx,%xmm2
  .byte  102,15,112,210,0                    // pshufd        $0x0,%xmm2,%xmm2
  .byte  15,91,210                           // cvtdq2ps      %xmm2,%xmm2
  .byte  15,88,145,8,96,0,0                  // addps         0x6008(%ecx),%xmm2
  .byte  141,78,8                            // lea           0x8(%esi),%ecx
  .byte  15,41,116,36,64                     // movaps        %xmm6,0x40(%esp)
  .byte  15,41,108,36,48                     // movaps        %xmm5,0x30(%esp)
  .byte  15,41,100,36,32                     // movaps        %xmm4,0x20(%esp)
  .byte  15,41,92,36,16                      // movaps        %xmm3,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,124,36,8                        // mov           %edi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  255,86,4                            // call          *0x4(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_matrix_translate_sse2_lowp
.globl _sk_matrix_translate_sse2_lowp
FUNCTION(_sk_matrix_translate_sse2_lowp)
_sk_matrix_translate_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  139,62                              // mov           (%esi),%edi
  .byte  243,15,16,63                        // movss         (%edi),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  243,15,16,127,4                     // movss         0x4(%edi),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  141,126,8                           // lea           0x8(%esi),%edi
  .byte  15,41,124,36,64                     // movaps        %xmm7,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,86,4                            // call          *0x4(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_matrix_scale_translate_sse2_lowp
.globl _sk_matrix_scale_translate_sse2_lowp
FUNCTION(_sk_matrix_scale_translate_sse2_lowp)
_sk_matrix_scale_translate_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  243,15,16,63                        // movss         (%edi),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,89,207                           // mulps         %xmm7,%xmm1
  .byte  15,89,199                           // mulps         %xmm7,%xmm0
  .byte  243,15,16,127,8                     // movss         0x8(%edi),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,88,199                           // addps         %xmm7,%xmm0
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  243,15,16,127,4                     // movss         0x4(%edi),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,89,223                           // mulps         %xmm7,%xmm3
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  243,15,16,127,12                    // movss         0xc(%edi),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  15,88,223                           // addps         %xmm7,%xmm3
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  141,121,8                           // lea           0x8(%ecx),%edi
  .byte  15,41,124,36,64                     // movaps        %xmm7,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_matrix_2x3_sse2_lowp
.globl _sk_matrix_2x3_sse2_lowp
FUNCTION(_sk_matrix_2x3_sse2_lowp)
_sk_matrix_2x3_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,40,248                           // movaps        %xmm0,%xmm7
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  243,15,16,7                         // movss         (%edi),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  243,15,16,119,8                     // movss         0x8(%edi),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,111,16                    // movss         0x10(%edi),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,89,214                           // mulps         %xmm6,%xmm2
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  15,88,245                           // addps         %xmm5,%xmm6
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,40,233                           // movaps        %xmm1,%xmm5
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  15,88,238                           // addps         %xmm6,%xmm5
  .byte  15,89,199                           // mulps         %xmm7,%xmm0
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  243,15,16,119,12                    // movss         0xc(%edi),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  15,89,222                           // mulps         %xmm6,%xmm3
  .byte  15,89,244                           // mulps         %xmm4,%xmm6
  .byte  243,15,16,87,20                     // movss         0x14(%edi),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,88,242                           // addps         %xmm2,%xmm6
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  243,15,16,87,4                      // movss         0x4(%edi),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,88,241                           // addps         %xmm1,%xmm6
  .byte  15,40,77,40                         // movaps        0x28(%ebp),%xmm1
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,40,101,56                        // movaps        0x38(%ebp),%xmm4
  .byte  15,88,218                           // addps         %xmm2,%xmm3
  .byte  15,40,85,72                         // movaps        0x48(%ebp),%xmm2
  .byte  141,121,8                           // lea           0x8(%ecx),%edi
  .byte  15,41,84,36,64                      // movaps        %xmm2,0x40(%esp)
  .byte  15,41,100,36,48                     // movaps        %xmm4,0x30(%esp)
  .byte  15,41,76,36,32                      // movaps        %xmm1,0x20(%esp)
  .byte  15,40,77,24                         // movaps        0x18(%ebp),%xmm1
  .byte  15,41,76,36,16                      // movaps        %xmm1,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,40,222                           // movaps        %xmm6,%xmm3
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_matrix_perspective_sse2_lowp
.globl _sk_matrix_perspective_sse2_lowp
FUNCTION(_sk_matrix_perspective_sse2_lowp)
_sk_matrix_perspective_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,112                         // sub           $0x70,%esp
  .byte  15,40,235                           // movaps        %xmm3,%xmm5
  .byte  15,41,77,232                        // movaps        %xmm1,-0x18(%ebp)
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,9                         // movss         (%ecx),%xmm1
  .byte  243,15,16,113,4                     // movss         0x4(%ecx),%xmm6
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,97,8                      // movss         0x8(%ecx),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  15,40,253                           // movaps        %xmm5,%xmm7
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  15,89,242                           // mulps         %xmm2,%xmm6
  .byte  15,41,85,216                        // movaps        %xmm2,-0x28(%ebp)
  .byte  15,88,244                           // addps         %xmm4,%xmm6
  .byte  15,88,252                           // addps         %xmm4,%xmm7
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  15,89,225                           // mulps         %xmm1,%xmm4
  .byte  15,88,230                           // addps         %xmm6,%xmm4
  .byte  15,89,77,232                        // mulps         -0x18(%ebp),%xmm1
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  243,15,16,113,16                    // movss         0x10(%ecx),%xmm6
  .byte  15,198,246,0                        // shufps        $0x0,%xmm6,%xmm6
  .byte  243,15,16,65,20                     // movss         0x14(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,40,253                           // movaps        %xmm5,%xmm7
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  15,89,242                           // mulps         %xmm2,%xmm6
  .byte  15,88,240                           // addps         %xmm0,%xmm6
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  243,15,16,65,12                     // movss         0xc(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,89,208                           // mulps         %xmm0,%xmm2
  .byte  15,88,242                           // addps         %xmm2,%xmm6
  .byte  15,89,69,232                        // mulps         -0x18(%ebp),%xmm0
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  243,15,16,65,28                     // movss         0x1c(%ecx),%xmm0
  .byte  15,198,192,0                        // shufps        $0x0,%xmm0,%xmm0
  .byte  15,89,232                           // mulps         %xmm0,%xmm5
  .byte  15,89,69,216                        // mulps         -0x28(%ebp),%xmm0
  .byte  243,15,16,81,32                     // movss         0x20(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,88,234                           // addps         %xmm2,%xmm5
  .byte  243,15,16,81,24                     // movss         0x18(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,89,218                           // mulps         %xmm2,%xmm3
  .byte  15,88,216                           // addps         %xmm0,%xmm3
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  15,89,85,232                        // mulps         -0x18(%ebp),%xmm2
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  15,83,219                           // rcpps         %xmm3,%xmm3
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,40,93,56                         // movaps        0x38(%ebp),%xmm3
  .byte  15,83,210                           // rcpps         %xmm2,%xmm2
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,89,250                           // mulps         %xmm2,%xmm7
  .byte  15,40,85,72                         // movaps        0x48(%ebp),%xmm2
  .byte  141,120,8                           // lea           0x8(%eax),%edi
  .byte  15,41,84,36,64                      // movaps        %xmm2,0x40(%esp)
  .byte  15,41,92,36,48                      // movaps        %xmm3,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,12,36                           // mov           %ecx,(%esp)
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,40,214                           // movaps        %xmm6,%xmm2
  .byte  15,40,223                           // movaps        %xmm7,%xmm3
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,112                         // add           $0x70,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_uniform_color_sse2_lowp
.globl _sk_uniform_color_sse2_lowp
FUNCTION(_sk_uniform_color_sse2_lowp)
_sk_uniform_color_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  15,183,126,18                       // movzwl        0x12(%esi),%edi
  .byte  102,15,110,207                      // movd          %edi,%xmm1
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  102,15,110,70,16                    // movd          0x10(%esi),%xmm0
  .byte  242,15,112,192,0                    // pshuflw       $0x0,%xmm0,%xmm0
  .byte  102,15,112,192,80                   // pshufd        $0x50,%xmm0,%xmm0
  .byte  242,15,112,201,0                    // pshuflw       $0x0,%xmm1,%xmm1
  .byte  102,15,112,201,80                   // pshufd        $0x50,%xmm1,%xmm1
  .byte  102,15,110,86,20                    // movd          0x14(%esi),%xmm2
  .byte  242,15,112,210,0                    // pshuflw       $0x0,%xmm2,%xmm2
  .byte  102,15,112,210,80                   // pshufd        $0x50,%xmm2,%xmm2
  .byte  15,183,118,22                       // movzwl        0x16(%esi),%esi
  .byte  102,15,110,222                      // movd          %esi,%xmm3
  .byte  242,15,112,219,0                    // pshuflw       $0x0,%xmm3,%xmm3
  .byte  102,15,112,219,80                   // pshufd        $0x50,%xmm3,%xmm3
  .byte  141,114,8                           // lea           0x8(%edx),%esi
  .byte  15,41,124,36,64                     // movaps        %xmm7,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,116,36,4                        // mov           %esi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,82,4                            // call          *0x4(%edx)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_black_color_sse2_lowp
.globl _sk_black_color_sse2_lowp
FUNCTION(_sk_black_color_sse2_lowp)
_sk_black_color_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  232,0,0,0,0                         // call          9f27 <_sk_black_color_sse2_lowp+0xe>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,40,77,40                         // movaps        0x28(%ebp),%xmm1
  .byte  15,40,85,56                         // movaps        0x38(%ebp),%xmm2
  .byte  15,40,93,72                         // movaps        0x48(%ebp),%xmm3
  .byte  139,125,12                          // mov           0xc(%ebp),%edi
  .byte  141,95,4                            // lea           0x4(%edi),%ebx
  .byte  15,41,92,36,64                      // movaps        %xmm3,0x40(%esp)
  .byte  15,41,84,36,48                      // movaps        %xmm2,0x30(%esp)
  .byte  15,41,76,36,32                      // movaps        %xmm1,0x20(%esp)
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,92,36,4                         // mov           %ebx,0x4(%esp)
  .byte  137,12,36                           // mov           %ecx,(%esp)
  .byte  15,40,152,217,98,0,0                // movaps        0x62d9(%eax),%xmm3
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,23                              // call          *(%edi)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_white_color_sse2_lowp
.globl _sk_white_color_sse2_lowp
FUNCTION(_sk_white_color_sse2_lowp)
_sk_white_color_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  232,0,0,0,0                         // call          9f92 <_sk_white_color_sse2_lowp+0xe>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,40,77,40                         // movaps        0x28(%ebp),%xmm1
  .byte  15,40,85,56                         // movaps        0x38(%ebp),%xmm2
  .byte  15,40,93,72                         // movaps        0x48(%ebp),%xmm3
  .byte  139,125,12                          // mov           0xc(%ebp),%edi
  .byte  141,95,4                            // lea           0x4(%edi),%ebx
  .byte  15,41,92,36,64                      // movaps        %xmm3,0x40(%esp)
  .byte  15,41,84,36,48                      // movaps        %xmm2,0x30(%esp)
  .byte  15,41,76,36,32                      // movaps        %xmm1,0x20(%esp)
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,92,36,4                         // mov           %ebx,0x4(%esp)
  .byte  137,12,36                           // mov           %ecx,(%esp)
  .byte  15,40,128,110,98,0,0                // movaps        0x626e(%eax),%xmm0
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  255,23                              // call          *(%edi)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_set_rgb_sse2_lowp
.globl _sk_set_rgb_sse2_lowp
FUNCTION(_sk_set_rgb_sse2_lowp)
_sk_set_rgb_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          9ffc <_sk_set_rgb_sse2_lowp+0xd>
  .byte  94                                  // pop           %esi
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  243,15,16,150,8,99,0,0              // movss         0x6308(%esi),%xmm2
  .byte  243,15,16,7                         // movss         (%edi),%xmm0
  .byte  243,15,89,194                       // mulss         %xmm2,%xmm0
  .byte  243,15,16,142,4,99,0,0              // movss         0x6304(%esi),%xmm1
  .byte  243,15,88,193                       // addss         %xmm1,%xmm0
  .byte  243,15,44,240                       // cvttss2si     %xmm0,%esi
  .byte  102,15,110,198                      // movd          %esi,%xmm0
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  243,15,16,127,4                     // movss         0x4(%edi),%xmm7
  .byte  243,15,89,250                       // mulss         %xmm2,%xmm7
  .byte  243,15,88,249                       // addss         %xmm1,%xmm7
  .byte  243,15,89,87,8                      // mulss         0x8(%edi),%xmm2
  .byte  243,15,44,255                       // cvttss2si     %xmm7,%edi
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  242,15,112,192,0                    // pshuflw       $0x0,%xmm0,%xmm0
  .byte  102,15,112,192,80                   // pshufd        $0x50,%xmm0,%xmm0
  .byte  243,15,88,209                       // addss         %xmm1,%xmm2
  .byte  102,15,110,207                      // movd          %edi,%xmm1
  .byte  242,15,112,201,0                    // pshuflw       $0x0,%xmm1,%xmm1
  .byte  102,15,112,201,80                   // pshufd        $0x50,%xmm1,%xmm1
  .byte  243,15,44,250                       // cvttss2si     %xmm2,%edi
  .byte  102,15,110,215                      // movd          %edi,%xmm2
  .byte  242,15,112,210,0                    // pshuflw       $0x0,%xmm2,%xmm2
  .byte  102,15,112,210,80                   // pshufd        $0x50,%xmm2,%xmm2
  .byte  141,121,8                           // lea           0x8(%ecx),%edi
  .byte  15,41,124,36,64                     // movaps        %xmm7,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_clamp_a_sse2_lowp
.globl _sk_clamp_a_sse2_lowp
FUNCTION(_sk_clamp_a_sse2_lowp)
_sk_clamp_a_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          a0c0 <_sk_clamp_a_sse2_lowp+0xd>
  .byte  94                                  // pop           %esi
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  102,15,111,166,80,97,0,0            // movdqa        0x6150(%esi),%xmm4
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,239,236                      // pxor          %xmm4,%xmm5
  .byte  102,15,111,243                      // movdqa        %xmm3,%xmm6
  .byte  102,15,239,244                      // pxor          %xmm4,%xmm6
  .byte  102,15,111,254                      // movdqa        %xmm6,%xmm7
  .byte  102,15,101,253                      // pcmpgtw       %xmm5,%xmm7
  .byte  102,15,219,199                      // pand          %xmm7,%xmm0
  .byte  102,15,223,251                      // pandn         %xmm3,%xmm7
  .byte  102,15,235,199                      // por           %xmm7,%xmm0
  .byte  102,15,111,233                      // movdqa        %xmm1,%xmm5
  .byte  102,15,239,236                      // pxor          %xmm4,%xmm5
  .byte  102,15,111,254                      // movdqa        %xmm6,%xmm7
  .byte  102,15,101,253                      // pcmpgtw       %xmm5,%xmm7
  .byte  15,40,109,24                        // movaps        0x18(%ebp),%xmm5
  .byte  102,15,219,207                      // pand          %xmm7,%xmm1
  .byte  102,15,223,251                      // pandn         %xmm3,%xmm7
  .byte  102,15,235,207                      // por           %xmm7,%xmm1
  .byte  15,40,125,40                        // movaps        0x28(%ebp),%xmm7
  .byte  102,15,239,226                      // pxor          %xmm2,%xmm4
  .byte  102,15,101,244                      // pcmpgtw       %xmm4,%xmm6
  .byte  15,40,101,56                        // movaps        0x38(%ebp),%xmm4
  .byte  102,15,219,214                      // pand          %xmm6,%xmm2
  .byte  102,15,223,243                      // pandn         %xmm3,%xmm6
  .byte  102,15,235,214                      // por           %xmm6,%xmm2
  .byte  15,40,117,72                        // movaps        0x48(%ebp),%xmm6
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  15,41,116,36,64                     // movaps        %xmm6,0x40(%esp)
  .byte  15,41,100,36,48                     // movaps        %xmm4,0x30(%esp)
  .byte  15,41,124,36,32                     // movaps        %xmm7,0x20(%esp)
  .byte  15,41,108,36,16                     // movaps        %xmm5,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_clamp_a_dst_sse2_lowp
.globl _sk_clamp_a_dst_sse2_lowp
FUNCTION(_sk_clamp_a_dst_sse2_lowp)
_sk_clamp_a_dst_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,128,0,0,0                   // sub           $0x80,%esp
  .byte  15,41,93,200                        // movaps        %xmm3,-0x38(%ebp)
  .byte  15,41,85,216                        // movaps        %xmm2,-0x28(%ebp)
  .byte  15,41,77,232                        // movaps        %xmm1,-0x18(%ebp)
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  232,0,0,0,0                         // call          a187 <_sk_clamp_a_dst_sse2_lowp+0x1f>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,101,72                   // movdqa        0x48(%ebp),%xmm4
  .byte  102,15,111,77,24                    // movdqa        0x18(%ebp),%xmm1
  .byte  102,15,111,144,137,96,0,0           // movdqa        0x6089(%eax),%xmm2
  .byte  102,15,111,249                      // movdqa        %xmm1,%xmm7
  .byte  102,15,239,250                      // pxor          %xmm2,%xmm7
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,239,242                      // pxor          %xmm2,%xmm6
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,15,101,239                      // pcmpgtw       %xmm7,%xmm5
  .byte  102,15,219,205                      // pand          %xmm5,%xmm1
  .byte  102,15,223,236                      // pandn         %xmm4,%xmm5
  .byte  102,15,235,233                      // por           %xmm1,%xmm5
  .byte  102,15,111,77,40                    // movdqa        0x28(%ebp),%xmm1
  .byte  102,15,111,249                      // movdqa        %xmm1,%xmm7
  .byte  102,15,239,250                      // pxor          %xmm2,%xmm7
  .byte  102,15,111,198                      // movdqa        %xmm6,%xmm0
  .byte  102,15,101,199                      // pcmpgtw       %xmm7,%xmm0
  .byte  102,15,219,200                      // pand          %xmm0,%xmm1
  .byte  102,15,223,196                      // pandn         %xmm4,%xmm0
  .byte  102,15,235,193                      // por           %xmm1,%xmm0
  .byte  102,15,111,77,56                    // movdqa        0x38(%ebp),%xmm1
  .byte  102,15,239,209                      // pxor          %xmm1,%xmm2
  .byte  102,15,101,242                      // pcmpgtw       %xmm2,%xmm6
  .byte  102,15,219,206                      // pand          %xmm6,%xmm1
  .byte  102,15,223,244                      // pandn         %xmm4,%xmm6
  .byte  102,15,235,241                      // por           %xmm1,%xmm6
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,100,36,64                // movdqa        %xmm4,0x40(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  102,15,127,116,36,48                // movdqa        %xmm6,0x30(%esp)
  .byte  102,15,127,68,36,32                 // movdqa        %xmm0,0x20(%esp)
  .byte  102,15,127,108,36,16                // movdqa        %xmm5,0x10(%esp)
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  15,40,77,232                        // movaps        -0x18(%ebp),%xmm1
  .byte  15,40,85,216                        // movaps        -0x28(%ebp),%xmm2
  .byte  15,40,93,200                        // movaps        -0x38(%ebp),%xmm3
  .byte  255,22                              // call          *(%esi)
  .byte  129,196,128,0,0,0                   // add           $0x80,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_premul_sse2_lowp
.globl _sk_premul_sse2_lowp
FUNCTION(_sk_premul_sse2_lowp)
_sk_premul_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          a256 <_sk_premul_sse2_lowp+0xd>
  .byte  90                                  // pop           %edx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  102,15,213,195                      // pmullw        %xmm3,%xmm0
  .byte  102,15,111,186,170,95,0,0           // movdqa        0x5faa(%edx),%xmm7
  .byte  102,15,253,199                      // paddw         %xmm7,%xmm0
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,15,253,207                      // paddw         %xmm7,%xmm1
  .byte  102,15,213,211                      // pmullw        %xmm3,%xmm2
  .byte  102,15,253,215                      // paddw         %xmm7,%xmm2
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  139,85,12                           // mov           0xc(%ebp),%edx
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  141,122,4                           // lea           0x4(%edx),%edi
  .byte  15,41,124,36,64                     // movaps        %xmm7,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,18                              // call          *(%edx)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_premul_dst_sse2_lowp
.globl _sk_premul_dst_sse2_lowp
FUNCTION(_sk_premul_dst_sse2_lowp)
_sk_premul_dst_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,96                          // sub           $0x60,%esp
  .byte  15,41,93,232                        // movaps        %xmm3,-0x18(%ebp)
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          a2eb <_sk_premul_dst_sse2_lowp+0x1a>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,101,72                   // movdqa        0x48(%ebp),%xmm4
  .byte  102,15,111,109,24                   // movdqa        0x18(%ebp),%xmm5
  .byte  102,15,213,236                      // pmullw        %xmm4,%xmm5
  .byte  102,15,111,176,21,95,0,0            // movdqa        0x5f15(%eax),%xmm6
  .byte  102,15,253,238                      // paddw         %xmm6,%xmm5
  .byte  102,15,111,125,40                   // movdqa        0x28(%ebp),%xmm7
  .byte  102,15,213,252                      // pmullw        %xmm4,%xmm7
  .byte  102,15,253,254                      // paddw         %xmm6,%xmm7
  .byte  102,15,111,69,56                    // movdqa        0x38(%ebp),%xmm0
  .byte  102,15,213,196                      // pmullw        %xmm4,%xmm0
  .byte  102,15,253,198                      // paddw         %xmm6,%xmm0
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,15,113,215,8                    // psrlw         $0x8,%xmm7
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,100,36,64                // movdqa        %xmm4,0x40(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  102,15,127,68,36,48                 // movdqa        %xmm0,0x30(%esp)
  .byte  102,15,127,124,36,32                // movdqa        %xmm7,0x20(%esp)
  .byte  102,15,127,108,36,16                // movdqa        %xmm5,0x10(%esp)
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,40,93,232                        // movaps        -0x18(%ebp),%xmm3
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,96                          // add           $0x60,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_swap_rb_sse2_lowp
.globl _sk_swap_rb_sse2_lowp
FUNCTION(_sk_swap_rb_sse2_lowp)
_sk_swap_rb_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  15,41,124,36,64                     // movaps        %xmm7,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  15,40,194                           // movaps        %xmm2,%xmm0
  .byte  15,40,212                           // movaps        %xmm4,%xmm2
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_move_src_dst_sse2_lowp
.globl _sk_move_src_dst_sse2_lowp
FUNCTION(_sk_move_src_dst_sse2_lowp)
_sk_move_src_dst_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  15,41,92,36,64                      // movaps        %xmm3,0x40(%esp)
  .byte  15,41,84,36,48                      // movaps        %xmm2,0x30(%esp)
  .byte  15,41,76,36,32                      // movaps        %xmm1,0x20(%esp)
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_move_dst_src_sse2_lowp
.globl _sk_move_dst_src_sse2_lowp
FUNCTION(_sk_move_dst_src_sse2_lowp)
_sk_move_dst_src_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,40,77,40                         // movaps        0x28(%ebp),%xmm1
  .byte  15,40,85,56                         // movaps        0x38(%ebp),%xmm2
  .byte  15,40,93,72                         // movaps        0x48(%ebp),%xmm3
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  15,41,92,36,64                      // movaps        %xmm3,0x40(%esp)
  .byte  15,41,84,36,48                      // movaps        %xmm2,0x30(%esp)
  .byte  15,41,76,36,32                      // movaps        %xmm1,0x20(%esp)
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_invert_sse2_lowp
.globl _sk_invert_sse2_lowp
FUNCTION(_sk_invert_sse2_lowp)
_sk_invert_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          a47a <_sk_invert_sse2_lowp+0xd>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  102,15,111,160,134,93,0,0           // movdqa        0x5d86(%eax),%xmm4
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,249,232                      // psubw         %xmm0,%xmm5
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,249,241                      // psubw         %xmm1,%xmm6
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,15,249,250                      // psubw         %xmm2,%xmm7
  .byte  15,40,69,56                         // movaps        0x38(%ebp),%xmm0
  .byte  102,15,249,227                      // psubw         %xmm3,%xmm4
  .byte  15,40,77,72                         // movaps        0x48(%ebp),%xmm1
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  141,120,4                           // lea           0x4(%eax),%edi
  .byte  15,41,76,36,64                      // movaps        %xmm1,0x40(%esp)
  .byte  15,41,68,36,48                      // movaps        %xmm0,0x30(%esp)
  .byte  15,40,69,40                         // movaps        0x28(%ebp),%xmm0
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,12,36                           // mov           %ecx,(%esp)
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,111,206                      // movdqa        %xmm6,%xmm1
  .byte  102,15,111,215                      // movdqa        %xmm7,%xmm2
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_clear_sse2_lowp
.globl _sk_clear_sse2_lowp
FUNCTION(_sk_clear_sse2_lowp)
_sk_clear_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,40,77,40                         // movaps        0x28(%ebp),%xmm1
  .byte  15,40,85,56                         // movaps        0x38(%ebp),%xmm2
  .byte  15,40,93,72                         // movaps        0x48(%ebp),%xmm3
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  15,41,92,36,64                      // movaps        %xmm3,0x40(%esp)
  .byte  15,41,84,36,48                      // movaps        %xmm2,0x30(%esp)
  .byte  15,41,76,36,32                      // movaps        %xmm1,0x20(%esp)
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_srcatop_sse2_lowp
.globl _sk_srcatop_sse2_lowp
FUNCTION(_sk_srcatop_sse2_lowp)
_sk_srcatop_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  102,15,111,234                      // movdqa        %xmm2,%xmm5
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          a572 <_sk_srcatop_sse2_lowp+0x19>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,117,72                   // movdqa        0x48(%ebp),%xmm6
  .byte  102,15,213,206                      // pmullw        %xmm6,%xmm1
  .byte  102,15,111,128,142,92,0,0           // movdqa        0x5c8e(%eax),%xmm0
  .byte  102,15,253,200                      // paddw         %xmm0,%xmm1
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,15,253,208                      // paddw         %xmm0,%xmm2
  .byte  102,15,213,238                      // pmullw        %xmm6,%xmm5
  .byte  102,15,253,232                      // paddw         %xmm0,%xmm5
  .byte  102,15,111,230                      // movdqa        %xmm6,%xmm4
  .byte  102,15,213,224                      // pmullw        %xmm0,%xmm4
  .byte  102,15,253,224                      // paddw         %xmm0,%xmm4
  .byte  102,15,249,195                      // psubw         %xmm3,%xmm0
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,15,213,93,24                    // pmullw        0x18(%ebp),%xmm3
  .byte  102,15,253,203                      // paddw         %xmm3,%xmm1
  .byte  102,15,111,93,40                    // movdqa        0x28(%ebp),%xmm3
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  102,15,213,251                      // pmullw        %xmm3,%xmm7
  .byte  102,15,253,215                      // paddw         %xmm7,%xmm2
  .byte  102,15,111,125,56                   // movdqa        0x38(%ebp),%xmm7
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,15,253,232                      // paddw         %xmm0,%xmm5
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,15,113,212,8                    // psrlw         $0x8,%xmm4
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,116,36,64                // movdqa        %xmm6,0x40(%esp)
  .byte  102,15,127,124,36,48                // movdqa        %xmm7,0x30(%esp)
  .byte  102,15,127,92,36,32                 // movdqa        %xmm3,0x20(%esp)
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,111,213                      // movdqa        %xmm5,%xmm2
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_dstatop_sse2_lowp
.globl _sk_dstatop_sse2_lowp
FUNCTION(_sk_dstatop_sse2_lowp)
_sk_dstatop_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          a646 <_sk_dstatop_sse2_lowp+0xd>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,101,40                   // movdqa        0x28(%ebp),%xmm4
  .byte  102,15,111,117,24                   // movdqa        0x18(%ebp),%xmm6
  .byte  102,15,213,243                      // pmullw        %xmm3,%xmm6
  .byte  102,15,111,184,186,91,0,0           // movdqa        0x5bba(%eax),%xmm7
  .byte  102,15,253,247                      // paddw         %xmm7,%xmm6
  .byte  102,15,213,227                      // pmullw        %xmm3,%xmm4
  .byte  102,15,253,231                      // paddw         %xmm7,%xmm4
  .byte  102,15,111,109,56                   // movdqa        0x38(%ebp),%xmm5
  .byte  102,15,213,235                      // pmullw        %xmm3,%xmm5
  .byte  102,15,253,239                      // paddw         %xmm7,%xmm5
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,15,253,223                      // paddw         %xmm7,%xmm3
  .byte  102,15,249,125,72                   // psubw         0x48(%ebp),%xmm7
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,15,253,198                      // paddw         %xmm6,%xmm0
  .byte  102,15,213,207                      // pmullw        %xmm7,%xmm1
  .byte  102,15,253,204                      // paddw         %xmm4,%xmm1
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,15,253,213                      // paddw         %xmm5,%xmm2
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  15,40,101,72                        // movaps        0x48(%ebp),%xmm4
  .byte  15,41,100,36,64                     // movaps        %xmm4,0x40(%esp)
  .byte  15,40,101,56                        // movaps        0x38(%ebp),%xmm4
  .byte  15,41,100,36,48                     // movaps        %xmm4,0x30(%esp)
  .byte  15,40,101,40                        // movaps        0x28(%ebp),%xmm4
  .byte  15,41,100,36,32                     // movaps        %xmm4,0x20(%esp)
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_srcin_sse2_lowp
.globl _sk_srcin_sse2_lowp
FUNCTION(_sk_srcin_sse2_lowp)
_sk_srcin_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          a707 <_sk_srcin_sse2_lowp+0xd>
  .byte  94                                  // pop           %esi
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  102,15,111,117,72                   // movdqa        0x48(%ebp),%xmm6
  .byte  102,15,213,198                      // pmullw        %xmm6,%xmm0
  .byte  102,15,111,190,249,90,0,0           // movdqa        0x5af9(%esi),%xmm7
  .byte  102,15,253,199                      // paddw         %xmm7,%xmm0
  .byte  102,15,213,206                      // pmullw        %xmm6,%xmm1
  .byte  102,15,253,207                      // paddw         %xmm7,%xmm1
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,15,253,215                      // paddw         %xmm7,%xmm2
  .byte  102,15,213,222                      // pmullw        %xmm6,%xmm3
  .byte  102,15,253,223                      // paddw         %xmm7,%xmm3
  .byte  15,40,125,56                        // movaps        0x38(%ebp),%xmm7
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,116,36,64                // movdqa        %xmm6,0x40(%esp)
  .byte  15,41,124,36,48                     // movaps        %xmm7,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_dstin_sse2_lowp
.globl _sk_dstin_sse2_lowp
FUNCTION(_sk_dstin_sse2_lowp)
_sk_dstin_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          a79e <_sk_dstin_sse2_lowp+0xd>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,85,56                    // movdqa        0x38(%ebp),%xmm2
  .byte  102,15,111,109,40                   // movdqa        0x28(%ebp),%xmm5
  .byte  102,15,111,117,24                   // movdqa        0x18(%ebp),%xmm6
  .byte  102,15,111,198                      // movdqa        %xmm6,%xmm0
  .byte  102,15,213,195                      // pmullw        %xmm3,%xmm0
  .byte  102,15,111,184,98,90,0,0            // movdqa        0x5a62(%eax),%xmm7
  .byte  102,15,253,199                      // paddw         %xmm7,%xmm0
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,15,253,207                      // paddw         %xmm7,%xmm1
  .byte  102,15,213,211                      // pmullw        %xmm3,%xmm2
  .byte  102,15,253,215                      // paddw         %xmm7,%xmm2
  .byte  102,15,111,101,72                   // movdqa        0x48(%ebp),%xmm4
  .byte  102,15,213,220                      // pmullw        %xmm4,%xmm3
  .byte  102,15,253,223                      // paddw         %xmm7,%xmm3
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,100,36,64                // movdqa        %xmm4,0x40(%esp)
  .byte  15,40,101,56                        // movaps        0x38(%ebp),%xmm4
  .byte  15,41,100,36,48                     // movaps        %xmm4,0x30(%esp)
  .byte  102,15,127,108,36,32                // movdqa        %xmm5,0x20(%esp)
  .byte  102,15,127,116,36,16                // movdqa        %xmm6,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_srcout_sse2_lowp
.globl _sk_srcout_sse2_lowp
FUNCTION(_sk_srcout_sse2_lowp)
_sk_srcout_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          a846 <_sk_srcout_sse2_lowp+0xd>
  .byte  94                                  // pop           %esi
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  102,15,111,109,72                   // movdqa        0x48(%ebp),%xmm5
  .byte  102,15,111,182,186,89,0,0           // movdqa        0x59ba(%esi),%xmm6
  .byte  102,15,111,254                      // movdqa        %xmm6,%xmm7
  .byte  102,15,249,253                      // psubw         %xmm5,%xmm7
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,15,213,207                      // pmullw        %xmm7,%xmm1
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  15,40,125,40                        // movaps        0x28(%ebp),%xmm7
  .byte  102,15,253,198                      // paddw         %xmm6,%xmm0
  .byte  102,15,253,206                      // paddw         %xmm6,%xmm1
  .byte  102,15,253,214                      // paddw         %xmm6,%xmm2
  .byte  102,15,253,222                      // paddw         %xmm6,%xmm3
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,108,36,64                // movdqa        %xmm5,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,41,124,36,32                     // movaps        %xmm7,0x20(%esp)
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_dstout_sse2_lowp
.globl _sk_dstout_sse2_lowp
FUNCTION(_sk_dstout_sse2_lowp)
_sk_dstout_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  232,0,0,0,0                         // call          a8e9 <_sk_dstout_sse2_lowp+0x11>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,109,56                   // movdqa        0x38(%ebp),%xmm5
  .byte  102,15,111,117,24                   // movdqa        0x18(%ebp),%xmm6
  .byte  102,15,111,184,23,89,0,0            // movdqa        0x5917(%eax),%xmm7
  .byte  102,15,111,223                      // movdqa        %xmm7,%xmm3
  .byte  102,15,249,216                      // psubw         %xmm0,%xmm3
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,213,198                      // pmullw        %xmm6,%xmm0
  .byte  102,15,253,199                      // paddw         %xmm7,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,213,77,40                    // pmullw        0x28(%ebp),%xmm1
  .byte  102,15,253,207                      // paddw         %xmm7,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,213,213                      // pmullw        %xmm5,%xmm2
  .byte  102,15,253,215                      // paddw         %xmm7,%xmm2
  .byte  102,15,111,101,72                   // movdqa        0x48(%ebp),%xmm4
  .byte  102,15,213,220                      // pmullw        %xmm4,%xmm3
  .byte  102,15,253,223                      // paddw         %xmm7,%xmm3
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,100,36,64                // movdqa        %xmm4,0x40(%esp)
  .byte  102,15,127,108,36,48                // movdqa        %xmm5,0x30(%esp)
  .byte  15,40,101,40                        // movaps        0x28(%ebp),%xmm4
  .byte  15,41,100,36,32                     // movaps        %xmm4,0x20(%esp)
  .byte  102,15,127,116,36,16                // movdqa        %xmm6,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_srcover_sse2_lowp
.globl _sk_srcover_sse2_lowp
FUNCTION(_sk_srcover_sse2_lowp)
_sk_srcover_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,96                          // sub           $0x60,%esp
  .byte  15,41,85,232                        // movaps        %xmm2,-0x18(%ebp)
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,15,111,224                      // movdqa        %xmm0,%xmm4
  .byte  232,0,0,0,0                         // call          a9a5 <_sk_srcover_sse2_lowp+0x19>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,136,91,88,0,0            // movdqa        0x585b(%eax),%xmm1
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,249,195                      // psubw         %xmm3,%xmm0
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  102,15,213,125,24                   // pmullw        0x18(%ebp),%xmm7
  .byte  102,15,253,249                      // paddw         %xmm1,%xmm7
  .byte  102,15,113,215,8                    // psrlw         $0x8,%xmm7
  .byte  102,15,253,231                      // paddw         %xmm7,%xmm4
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,213,109,40                   // pmullw        0x28(%ebp),%xmm5
  .byte  102,15,253,233                      // paddw         %xmm1,%xmm5
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,15,253,213                      // paddw         %xmm5,%xmm2
  .byte  102,15,111,234                      // movdqa        %xmm2,%xmm5
  .byte  102,15,111,125,56                   // movdqa        0x38(%ebp),%xmm7
  .byte  102,15,111,240                      // movdqa        %xmm0,%xmm6
  .byte  102,15,213,247                      // pmullw        %xmm7,%xmm6
  .byte  102,15,253,241                      // paddw         %xmm1,%xmm6
  .byte  102,15,113,214,8                    // psrlw         $0x8,%xmm6
  .byte  102,15,111,85,232                   // movdqa        -0x18(%ebp),%xmm2
  .byte  102,15,253,214                      // paddw         %xmm6,%xmm2
  .byte  102,15,111,117,72                   // movdqa        0x48(%ebp),%xmm6
  .byte  102,15,213,198                      // pmullw        %xmm6,%xmm0
  .byte  102,15,253,193                      // paddw         %xmm1,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,253,216                      // paddw         %xmm0,%xmm3
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,116,36,64                // movdqa        %xmm6,0x40(%esp)
  .byte  102,15,127,124,36,48                // movdqa        %xmm7,0x30(%esp)
  .byte  15,40,69,40                         // movaps        0x28(%ebp),%xmm0
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,96                          // add           $0x60,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_dstover_sse2_lowp
.globl _sk_dstover_sse2_lowp
FUNCTION(_sk_dstover_sse2_lowp)
_sk_dstover_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          aa75 <_sk_dstover_sse2_lowp+0xd>
  .byte  95                                  // pop           %edi
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  102,15,111,101,56                   // movdqa        0x38(%ebp),%xmm4
  .byte  102,15,111,109,72                   // movdqa        0x48(%ebp),%xmm5
  .byte  102,15,111,183,139,87,0,0           // movdqa        0x578b(%edi),%xmm6
  .byte  102,15,111,254                      // movdqa        %xmm6,%xmm7
  .byte  102,15,249,253                      // psubw         %xmm5,%xmm7
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,15,213,207                      // pmullw        %xmm7,%xmm1
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,15,111,125,40                   // movdqa        0x28(%ebp),%xmm7
  .byte  102,15,253,198                      // paddw         %xmm6,%xmm0
  .byte  102,15,253,206                      // paddw         %xmm6,%xmm1
  .byte  102,15,253,214                      // paddw         %xmm6,%xmm2
  .byte  102,15,253,222                      // paddw         %xmm6,%xmm3
  .byte  102,15,111,117,24                   // movdqa        0x18(%ebp),%xmm6
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,253,198                      // paddw         %xmm6,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,253,207                      // paddw         %xmm7,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,253,212                      // paddw         %xmm4,%xmm2
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,253,221                      // paddw         %xmm5,%xmm3
  .byte  141,120,4                           // lea           0x4(%eax),%edi
  .byte  102,15,127,108,36,64                // movdqa        %xmm5,0x40(%esp)
  .byte  102,15,127,100,36,48                // movdqa        %xmm4,0x30(%esp)
  .byte  102,15,127,124,36,32                // movdqa        %xmm7,0x20(%esp)
  .byte  102,15,127,116,36,16                // movdqa        %xmm6,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,12,36                           // mov           %ecx,(%esp)
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_modulate_sse2_lowp
.globl _sk_modulate_sse2_lowp
FUNCTION(_sk_modulate_sse2_lowp)
_sk_modulate_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          ab2a <_sk_modulate_sse2_lowp+0xd>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,109,40                   // movdqa        0x28(%ebp),%xmm5
  .byte  102,15,111,117,24                   // movdqa        0x18(%ebp),%xmm6
  .byte  102,15,213,198                      // pmullw        %xmm6,%xmm0
  .byte  102,15,111,184,214,86,0,0           // movdqa        0x56d6(%eax),%xmm7
  .byte  102,15,253,199                      // paddw         %xmm7,%xmm0
  .byte  102,15,213,205                      // pmullw        %xmm5,%xmm1
  .byte  102,15,253,207                      // paddw         %xmm7,%xmm1
  .byte  102,15,213,85,56                    // pmullw        0x38(%ebp),%xmm2
  .byte  102,15,253,215                      // paddw         %xmm7,%xmm2
  .byte  102,15,111,101,72                   // movdqa        0x48(%ebp),%xmm4
  .byte  102,15,213,220                      // pmullw        %xmm4,%xmm3
  .byte  102,15,253,223                      // paddw         %xmm7,%xmm3
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,100,36,64                // movdqa        %xmm4,0x40(%esp)
  .byte  15,40,101,56                        // movaps        0x38(%ebp),%xmm4
  .byte  15,41,100,36,48                     // movaps        %xmm4,0x30(%esp)
  .byte  102,15,127,108,36,32                // movdqa        %xmm5,0x20(%esp)
  .byte  102,15,127,116,36,16                // movdqa        %xmm6,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_multiply_sse2_lowp
.globl _sk_multiply_sse2_lowp
FUNCTION(_sk_multiply_sse2_lowp)
_sk_multiply_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          abc6 <_sk_multiply_sse2_lowp+0xd>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,109,24                   // movdqa        0x18(%ebp),%xmm5
  .byte  102,15,111,160,58,86,0,0            // movdqa        0x563a(%eax),%xmm4
  .byte  102,15,111,245                      // movdqa        %xmm5,%xmm6
  .byte  102,15,253,244                      // paddw         %xmm4,%xmm6
  .byte  102,15,249,117,72                   // psubw         0x48(%ebp),%xmm6
  .byte  102,15,213,198                      // pmullw        %xmm6,%xmm0
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,249,243                      // psubw         %xmm3,%xmm6
  .byte  102,15,111,254                      // movdqa        %xmm6,%xmm7
  .byte  102,15,213,253                      // pmullw        %xmm5,%xmm7
  .byte  102,15,253,252                      // paddw         %xmm4,%xmm7
  .byte  102,15,253,199                      // paddw         %xmm7,%xmm0
  .byte  102,15,111,125,40                   // movdqa        0x28(%ebp),%xmm7
  .byte  102,15,253,252                      // paddw         %xmm4,%xmm7
  .byte  102,15,111,109,72                   // movdqa        0x48(%ebp),%xmm5
  .byte  102,15,249,253                      // psubw         %xmm5,%xmm7
  .byte  102,15,213,207                      // pmullw        %xmm7,%xmm1
  .byte  102,15,111,254                      // movdqa        %xmm6,%xmm7
  .byte  102,15,213,125,40                   // pmullw        0x28(%ebp),%xmm7
  .byte  102,15,253,252                      // paddw         %xmm4,%xmm7
  .byte  102,15,253,207                      // paddw         %xmm7,%xmm1
  .byte  102,15,111,125,56                   // movdqa        0x38(%ebp),%xmm7
  .byte  102,15,253,252                      // paddw         %xmm4,%xmm7
  .byte  102,15,249,253                      // psubw         %xmm5,%xmm7
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,15,111,254                      // movdqa        %xmm6,%xmm7
  .byte  102,15,213,125,56                   // pmullw        0x38(%ebp),%xmm7
  .byte  102,15,253,252                      // paddw         %xmm4,%xmm7
  .byte  102,15,253,215                      // paddw         %xmm7,%xmm2
  .byte  102,15,213,220                      // pmullw        %xmm4,%xmm3
  .byte  102,15,253,220                      // paddw         %xmm4,%xmm3
  .byte  102,15,213,245                      // pmullw        %xmm5,%xmm6
  .byte  102,15,253,222                      // paddw         %xmm6,%xmm3
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,108,36,64                // movdqa        %xmm5,0x40(%esp)
  .byte  15,40,101,56                        // movaps        0x38(%ebp),%xmm4
  .byte  15,41,100,36,48                     // movaps        %xmm4,0x30(%esp)
  .byte  15,40,101,40                        // movaps        0x28(%ebp),%xmm4
  .byte  15,41,100,36,32                     // movaps        %xmm4,0x20(%esp)
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_plus__sse2_lowp
.globl _sk_plus__sse2_lowp
FUNCTION(_sk_plus__sse2_lowp)
_sk_plus__sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,96                          // sub           $0x60,%esp
  .byte  102,15,111,225                      // movdqa        %xmm1,%xmm4
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          acc7 <_sk_plus__sse2_lowp+0x15>
  .byte  88                                  // pop           %eax
  .byte  102,15,253,77,24                    // paddw         0x18(%ebp),%xmm1
  .byte  102,15,111,168,89,85,0,0            // movdqa        0x5559(%eax),%xmm5
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,217,197                      // psubusw       %xmm5,%xmm0
  .byte  102,15,127,109,232                  // movdqa        %xmm5,-0x18(%ebp)
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  102,15,117,199                      // pcmpeqw       %xmm7,%xmm0
  .byte  102,15,219,200                      // pand          %xmm0,%xmm1
  .byte  102,15,111,176,57,85,0,0            // movdqa        0x5539(%eax),%xmm6
  .byte  102,15,223,198                      // pandn         %xmm6,%xmm0
  .byte  102,15,235,193                      // por           %xmm1,%xmm0
  .byte  102,15,253,101,40                   // paddw         0x28(%ebp),%xmm4
  .byte  102,15,111,204                      // movdqa        %xmm4,%xmm1
  .byte  102,15,217,205                      // psubusw       %xmm5,%xmm1
  .byte  102,15,117,207                      // pcmpeqw       %xmm7,%xmm1
  .byte  102,15,219,225                      // pand          %xmm1,%xmm4
  .byte  102,15,223,206                      // pandn         %xmm6,%xmm1
  .byte  102,15,235,204                      // por           %xmm4,%xmm1
  .byte  102,15,253,85,56                    // paddw         0x38(%ebp),%xmm2
  .byte  102,15,111,226                      // movdqa        %xmm2,%xmm4
  .byte  102,15,217,229                      // psubusw       %xmm5,%xmm4
  .byte  102,15,117,231                      // pcmpeqw       %xmm7,%xmm4
  .byte  102,15,219,212                      // pand          %xmm4,%xmm2
  .byte  102,15,223,230                      // pandn         %xmm6,%xmm4
  .byte  102,15,235,226                      // por           %xmm2,%xmm4
  .byte  102,15,111,85,72                    // movdqa        0x48(%ebp),%xmm2
  .byte  102,15,253,218                      // paddw         %xmm2,%xmm3
  .byte  102,15,111,235                      // movdqa        %xmm3,%xmm5
  .byte  102,15,217,109,232                  // psubusw       -0x18(%ebp),%xmm5
  .byte  102,15,117,239                      // pcmpeqw       %xmm7,%xmm5
  .byte  102,15,219,221                      // pand          %xmm5,%xmm3
  .byte  102,15,223,238                      // pandn         %xmm6,%xmm5
  .byte  102,15,235,235                      // por           %xmm3,%xmm5
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,84,36,64                 // movdqa        %xmm2,0x40(%esp)
  .byte  15,40,85,56                         // movaps        0x38(%ebp),%xmm2
  .byte  15,41,84,36,48                      // movaps        %xmm2,0x30(%esp)
  .byte  15,40,85,40                         // movaps        0x28(%ebp),%xmm2
  .byte  15,41,84,36,32                      // movaps        %xmm2,0x20(%esp)
  .byte  15,40,85,24                         // movaps        0x18(%ebp),%xmm2
  .byte  15,41,84,36,16                      // movaps        %xmm2,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  102,15,111,221                      // movdqa        %xmm5,%xmm3
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,96                          // add           $0x60,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_screen_sse2_lowp
.globl _sk_screen_sse2_lowp
FUNCTION(_sk_screen_sse2_lowp)
_sk_screen_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  102,15,111,225                      // movdqa        %xmm1,%xmm4
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          adbf <_sk_screen_sse2_lowp+0x15>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,109,40                   // movdqa        0x28(%ebp),%xmm5
  .byte  102,15,111,117,24                   // movdqa        0x18(%ebp),%xmm6
  .byte  102,15,111,198                      // movdqa        %xmm6,%xmm0
  .byte  102,15,253,193                      // paddw         %xmm1,%xmm0
  .byte  102,15,213,206                      // pmullw        %xmm6,%xmm1
  .byte  102,15,111,176,65,84,0,0            // movdqa        0x5441(%eax),%xmm6
  .byte  102,15,253,206                      // paddw         %xmm6,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,249,193                      // psubw         %xmm1,%xmm0
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,15,253,204                      // paddw         %xmm4,%xmm1
  .byte  102,15,213,229                      // pmullw        %xmm5,%xmm4
  .byte  102,15,253,230                      // paddw         %xmm6,%xmm4
  .byte  102,15,113,212,8                    // psrlw         $0x8,%xmm4
  .byte  102,15,249,204                      // psubw         %xmm4,%xmm1
  .byte  102,15,111,125,56                   // movdqa        0x38(%ebp),%xmm7
  .byte  102,15,111,231                      // movdqa        %xmm7,%xmm4
  .byte  102,15,253,226                      // paddw         %xmm2,%xmm4
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,15,253,214                      // paddw         %xmm6,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,249,226                      // psubw         %xmm2,%xmm4
  .byte  102,15,111,85,72                    // movdqa        0x48(%ebp),%xmm2
  .byte  102,15,111,234                      // movdqa        %xmm2,%xmm5
  .byte  102,15,253,235                      // paddw         %xmm3,%xmm5
  .byte  102,15,213,218                      // pmullw        %xmm2,%xmm3
  .byte  102,15,253,222                      // paddw         %xmm6,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,249,235                      // psubw         %xmm3,%xmm5
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,84,36,64                 // movdqa        %xmm2,0x40(%esp)
  .byte  102,15,127,124,36,48                // movdqa        %xmm7,0x30(%esp)
  .byte  15,40,85,40                         // movaps        0x28(%ebp),%xmm2
  .byte  15,41,84,36,32                      // movaps        %xmm2,0x20(%esp)
  .byte  15,40,85,24                         // movaps        0x18(%ebp),%xmm2
  .byte  15,41,84,36,16                      // movaps        %xmm2,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  102,15,111,221                      // movdqa        %xmm5,%xmm3
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_xor__sse2_lowp
.globl _sk_xor__sse2_lowp
FUNCTION(_sk_xor__sse2_lowp)
_sk_xor__sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,96                          // sub           $0x60,%esp
  .byte  102,15,127,93,232                   // movdqa        %xmm3,-0x18(%ebp)
  .byte  232,0,0,0,0                         // call          ae9f <_sk_xor__sse2_lowp+0x12>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,176,97,83,0,0            // movdqa        0x5361(%eax),%xmm6
  .byte  102,15,111,254                      // movdqa        %xmm6,%xmm7
  .byte  102,15,249,125,72                   // psubw         0x48(%ebp),%xmm7
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,15,249,235                      // psubw         %xmm3,%xmm5
  .byte  102,15,111,221                      // movdqa        %xmm5,%xmm3
  .byte  102,15,213,93,24                    // pmullw        0x18(%ebp),%xmm3
  .byte  102,15,253,195                      // paddw         %xmm3,%xmm0
  .byte  102,15,213,207                      // pmullw        %xmm7,%xmm1
  .byte  102,15,111,221                      // movdqa        %xmm5,%xmm3
  .byte  102,15,213,93,40                    // pmullw        0x28(%ebp),%xmm3
  .byte  102,15,253,203                      // paddw         %xmm3,%xmm1
  .byte  102,15,213,215                      // pmullw        %xmm7,%xmm2
  .byte  102,15,111,93,56                    // movdqa        0x38(%ebp),%xmm3
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,213,227                      // pmullw        %xmm3,%xmm4
  .byte  102,15,253,212                      // paddw         %xmm4,%xmm2
  .byte  102,15,213,125,232                  // pmullw        -0x18(%ebp),%xmm7
  .byte  102,15,111,101,72                   // movdqa        0x48(%ebp),%xmm4
  .byte  102,15,213,236                      // pmullw        %xmm4,%xmm5
  .byte  102,15,253,239                      // paddw         %xmm7,%xmm5
  .byte  102,15,253,198                      // paddw         %xmm6,%xmm0
  .byte  102,15,253,206                      // paddw         %xmm6,%xmm1
  .byte  102,15,253,214                      // paddw         %xmm6,%xmm2
  .byte  102,15,253,238                      // paddw         %xmm6,%xmm5
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,100,36,64                // movdqa        %xmm4,0x40(%esp)
  .byte  102,15,127,92,36,48                 // movdqa        %xmm3,0x30(%esp)
  .byte  15,40,93,40                         // movaps        0x28(%ebp),%xmm3
  .byte  15,41,92,36,32                      // movaps        %xmm3,0x20(%esp)
  .byte  15,40,93,24                         // movaps        0x18(%ebp),%xmm3
  .byte  15,41,92,36,16                      // movaps        %xmm3,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  102,15,111,221                      // movdqa        %xmm5,%xmm3
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,96                          // add           $0x60,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_darken_sse2_lowp
.globl _sk_darken_sse2_lowp
FUNCTION(_sk_darken_sse2_lowp)
_sk_darken_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,144,0,0,0                   // sub           $0x90,%esp
  .byte  102,15,111,251                      // movdqa        %xmm3,%xmm7
  .byte  102,15,127,125,216                  // movdqa        %xmm7,-0x28(%ebp)
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  102,15,111,225                      // movdqa        %xmm1,%xmm4
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          af94 <_sk_darken_sse2_lowp+0x25>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,117,72                   // movdqa        0x48(%ebp),%xmm6
  .byte  102,15,111,109,24                   // movdqa        0x18(%ebp),%xmm5
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,253,193                      // paddw         %xmm1,%xmm0
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,15,213,206                      // pmullw        %xmm6,%xmm1
  .byte  102,15,111,222                      // movdqa        %xmm6,%xmm3
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,15,111,184,124,82,0,0           // movdqa        0x527c(%eax),%xmm7
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,239,247                      // pxor          %xmm7,%xmm6
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,239,239                      // pxor          %xmm7,%xmm5
  .byte  102,15,101,238                      // pcmpgtw       %xmm6,%xmm5
  .byte  102,15,219,197                      // pand          %xmm5,%xmm0
  .byte  102,15,223,233                      // pandn         %xmm1,%xmm5
  .byte  102,15,235,232                      // por           %xmm0,%xmm5
  .byte  102,15,111,128,108,82,0,0           // movdqa        0x526c(%eax),%xmm0
  .byte  102,15,127,69,232                   // movdqa        %xmm0,-0x18(%ebp)
  .byte  102,15,253,232                      // paddw         %xmm0,%xmm5
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,15,249,213                      // psubw         %xmm5,%xmm2
  .byte  102,15,127,85,184                   // movdqa        %xmm2,-0x48(%ebp)
  .byte  102,15,111,77,40                    // movdqa        0x28(%ebp),%xmm1
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,253,244                      // paddw         %xmm4,%xmm6
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,213,224                      // pmullw        %xmm0,%xmm4
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,15,111,93,216                   // movdqa        -0x28(%ebp),%xmm3
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,239,239                      // pxor          %xmm7,%xmm5
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,239,199                      // pxor          %xmm7,%xmm0
  .byte  102,15,101,197                      // pcmpgtw       %xmm5,%xmm0
  .byte  102,15,219,200                      // pand          %xmm0,%xmm1
  .byte  102,15,223,196                      // pandn         %xmm4,%xmm0
  .byte  102,15,235,193                      // por           %xmm1,%xmm0
  .byte  102,15,253,69,232                   // paddw         -0x18(%ebp),%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,249,240                      // psubw         %xmm0,%xmm6
  .byte  102,15,111,109,56                   // movdqa        0x38(%ebp),%xmm5
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,111,69,200                   // movdqa        -0x38(%ebp),%xmm0
  .byte  102,15,253,224                      // paddw         %xmm0,%xmm4
  .byte  102,15,213,194                      // pmullw        %xmm2,%xmm0
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,213,195                      // pmullw        %xmm3,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,239,207                      // pxor          %xmm7,%xmm1
  .byte  102,15,239,248                      // pxor          %xmm0,%xmm7
  .byte  102,15,101,249                      // pcmpgtw       %xmm1,%xmm7
  .byte  102,15,219,199                      // pand          %xmm7,%xmm0
  .byte  102,15,223,250                      // pandn         %xmm2,%xmm7
  .byte  102,15,235,248                      // por           %xmm0,%xmm7
  .byte  102,15,111,77,232                   // movdqa        -0x18(%ebp),%xmm1
  .byte  102,15,253,249                      // paddw         %xmm1,%xmm7
  .byte  102,15,113,215,8                    // psrlw         $0x8,%xmm7
  .byte  102,15,249,231                      // psubw         %xmm7,%xmm4
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,15,249,195                      // psubw         %xmm3,%xmm0
  .byte  102,15,111,125,72                   // movdqa        0x48(%ebp),%xmm7
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,15,253,194                      // paddw         %xmm2,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,253,216                      // paddw         %xmm0,%xmm3
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,124,36,64                // movdqa        %xmm7,0x40(%esp)
  .byte  102,15,127,108,36,48                // movdqa        %xmm5,0x30(%esp)
  .byte  15,40,69,40                         // movaps        0x28(%ebp),%xmm0
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  15,40,69,184                        // movaps        -0x48(%ebp),%xmm0
  .byte  102,15,111,206                      // movdqa        %xmm6,%xmm1
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  255,22                              // call          *(%esi)
  .byte  129,196,144,0,0,0                   // add           $0x90,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_lighten_sse2_lowp
.globl _sk_lighten_sse2_lowp
FUNCTION(_sk_lighten_sse2_lowp)
_sk_lighten_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,144,0,0,0                   // sub           $0x90,%esp
  .byte  102,15,111,243                      // movdqa        %xmm3,%xmm6
  .byte  102,15,127,117,216                  // movdqa        %xmm6,-0x28(%ebp)
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  102,15,111,225                      // movdqa        %xmm1,%xmm4
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          b13d <_sk_lighten_sse2_lowp+0x25>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,109,24                   // movdqa        0x18(%ebp),%xmm5
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,253,193                      // paddw         %xmm1,%xmm0
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,15,213,77,72                    // pmullw        0x48(%ebp),%xmm1
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,213,198                      // pmullw        %xmm6,%xmm0
  .byte  102,15,111,184,211,80,0,0           // movdqa        0x50d3(%eax),%xmm7
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,239,247                      // pxor          %xmm7,%xmm6
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,239,239                      // pxor          %xmm7,%xmm5
  .byte  102,15,101,238                      // pcmpgtw       %xmm6,%xmm5
  .byte  102,15,219,205                      // pand          %xmm5,%xmm1
  .byte  102,15,223,232                      // pandn         %xmm0,%xmm5
  .byte  102,15,235,233                      // por           %xmm1,%xmm5
  .byte  102,15,111,128,195,80,0,0           // movdqa        0x50c3(%eax),%xmm0
  .byte  102,15,253,232                      // paddw         %xmm0,%xmm5
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,15,127,85,232                   // movdqa        %xmm2,-0x18(%ebp)
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,15,249,221                      // psubw         %xmm5,%xmm3
  .byte  102,15,127,93,184                   // movdqa        %xmm3,-0x48(%ebp)
  .byte  102,15,111,77,40                    // movdqa        0x28(%ebp),%xmm1
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,253,244                      // paddw         %xmm4,%xmm6
  .byte  102,15,111,69,72                    // movdqa        0x48(%ebp),%xmm0
  .byte  102,15,213,224                      // pmullw        %xmm0,%xmm4
  .byte  102,15,111,93,216                   // movdqa        -0x28(%ebp),%xmm3
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,239,239                      // pxor          %xmm7,%xmm5
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,239,199                      // pxor          %xmm7,%xmm0
  .byte  102,15,101,197                      // pcmpgtw       %xmm5,%xmm0
  .byte  102,15,219,224                      // pand          %xmm0,%xmm4
  .byte  102,15,223,193                      // pandn         %xmm1,%xmm0
  .byte  102,15,235,196                      // por           %xmm4,%xmm0
  .byte  102,15,253,194                      // paddw         %xmm2,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,249,240                      // psubw         %xmm0,%xmm6
  .byte  102,15,111,109,56                   // movdqa        0x38(%ebp),%xmm5
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,111,85,200                   // movdqa        -0x38(%ebp),%xmm2
  .byte  102,15,253,226                      // paddw         %xmm2,%xmm4
  .byte  102,15,213,85,72                    // pmullw        0x48(%ebp),%xmm2
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,213,195                      // pmullw        %xmm3,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,239,207                      // pxor          %xmm7,%xmm1
  .byte  102,15,239,248                      // pxor          %xmm0,%xmm7
  .byte  102,15,101,249                      // pcmpgtw       %xmm1,%xmm7
  .byte  102,15,219,215                      // pand          %xmm7,%xmm2
  .byte  102,15,223,248                      // pandn         %xmm0,%xmm7
  .byte  102,15,235,250                      // por           %xmm2,%xmm7
  .byte  102,15,111,77,232                   // movdqa        -0x18(%ebp),%xmm1
  .byte  102,15,253,249                      // paddw         %xmm1,%xmm7
  .byte  102,15,113,215,8                    // psrlw         $0x8,%xmm7
  .byte  102,15,249,231                      // psubw         %xmm7,%xmm4
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,111,249                      // movdqa        %xmm1,%xmm7
  .byte  102,15,249,195                      // psubw         %xmm3,%xmm0
  .byte  102,15,111,85,72                    // movdqa        0x48(%ebp),%xmm2
  .byte  102,15,213,194                      // pmullw        %xmm2,%xmm0
  .byte  102,15,253,199                      // paddw         %xmm7,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,253,216                      // paddw         %xmm0,%xmm3
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,84,36,64                 // movdqa        %xmm2,0x40(%esp)
  .byte  102,15,127,108,36,48                // movdqa        %xmm5,0x30(%esp)
  .byte  15,40,69,40                         // movaps        0x28(%ebp),%xmm0
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  15,40,69,184                        // movaps        -0x48(%ebp),%xmm0
  .byte  102,15,111,206                      // movdqa        %xmm6,%xmm1
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  255,22                              // call          *(%esi)
  .byte  129,196,144,0,0,0                   // add           $0x90,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_difference_sse2_lowp
.globl _sk_difference_sse2_lowp
FUNCTION(_sk_difference_sse2_lowp)
_sk_difference_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,160,0,0,0                   // sub           $0xa0,%esp
  .byte  102,15,111,251                      // movdqa        %xmm3,%xmm7
  .byte  102,15,127,125,200                  // movdqa        %xmm7,-0x38(%ebp)
  .byte  15,41,85,184                        // movaps        %xmm2,-0x48(%ebp)
  .byte  102,15,111,225                      // movdqa        %xmm1,%xmm4
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          b2db <_sk_difference_sse2_lowp+0x25>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,117,72                   // movdqa        0x48(%ebp),%xmm6
  .byte  102,15,111,109,24                   // movdqa        0x18(%ebp),%xmm5
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,253,193                      // paddw         %xmm1,%xmm0
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,15,213,206                      // pmullw        %xmm6,%xmm1
  .byte  102,15,111,222                      // movdqa        %xmm6,%xmm3
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,15,111,184,53,79,0,0            // movdqa        0x4f35(%eax),%xmm7
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,239,247                      // pxor          %xmm7,%xmm6
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,239,239                      // pxor          %xmm7,%xmm5
  .byte  102,15,101,238                      // pcmpgtw       %xmm6,%xmm5
  .byte  102,15,219,205                      // pand          %xmm5,%xmm1
  .byte  102,15,223,232                      // pandn         %xmm0,%xmm5
  .byte  102,15,235,233                      // por           %xmm1,%xmm5
  .byte  102,15,111,128,37,79,0,0            // movdqa        0x4f25(%eax),%xmm0
  .byte  102,15,127,69,216                   // movdqa        %xmm0,-0x28(%ebp)
  .byte  102,15,253,232                      // paddw         %xmm0,%xmm5
  .byte  102,15,113,213,7                    // psrlw         $0x7,%xmm5
  .byte  102,15,111,128,85,79,0,0            // movdqa        0x4f55(%eax),%xmm0
  .byte  102,15,127,69,232                   // movdqa        %xmm0,-0x18(%ebp)
  .byte  102,15,219,232                      // pand          %xmm0,%xmm5
  .byte  102,15,249,213                      // psubw         %xmm5,%xmm2
  .byte  102,15,127,85,168                   // movdqa        %xmm2,-0x58(%ebp)
  .byte  102,15,111,77,40                    // movdqa        0x28(%ebp),%xmm1
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,253,244                      // paddw         %xmm4,%xmm6
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,213,224                      // pmullw        %xmm0,%xmm4
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,15,111,93,200                   // movdqa        -0x38(%ebp),%xmm3
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,239,239                      // pxor          %xmm7,%xmm5
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,239,199                      // pxor          %xmm7,%xmm0
  .byte  102,15,101,197                      // pcmpgtw       %xmm5,%xmm0
  .byte  102,15,219,224                      // pand          %xmm0,%xmm4
  .byte  102,15,223,193                      // pandn         %xmm1,%xmm0
  .byte  102,15,235,196                      // por           %xmm4,%xmm0
  .byte  102,15,253,69,216                   // paddw         -0x28(%ebp),%xmm0
  .byte  102,15,113,208,7                    // psrlw         $0x7,%xmm0
  .byte  102,15,219,69,232                   // pand          -0x18(%ebp),%xmm0
  .byte  102,15,249,240                      // psubw         %xmm0,%xmm6
  .byte  102,15,111,109,56                   // movdqa        0x38(%ebp),%xmm5
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,111,69,184                   // movdqa        -0x48(%ebp),%xmm0
  .byte  102,15,253,224                      // paddw         %xmm0,%xmm4
  .byte  102,15,213,194                      // pmullw        %xmm2,%xmm0
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,213,195                      // pmullw        %xmm3,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,239,207                      // pxor          %xmm7,%xmm1
  .byte  102,15,239,248                      // pxor          %xmm0,%xmm7
  .byte  102,15,101,249                      // pcmpgtw       %xmm1,%xmm7
  .byte  102,15,219,215                      // pand          %xmm7,%xmm2
  .byte  102,15,223,248                      // pandn         %xmm0,%xmm7
  .byte  102,15,235,250                      // por           %xmm2,%xmm7
  .byte  102,15,111,77,216                   // movdqa        -0x28(%ebp),%xmm1
  .byte  102,15,253,249                      // paddw         %xmm1,%xmm7
  .byte  102,15,113,215,7                    // psrlw         $0x7,%xmm7
  .byte  102,15,219,125,232                  // pand          -0x18(%ebp),%xmm7
  .byte  102,15,249,231                      // psubw         %xmm7,%xmm4
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,111,249                      // movdqa        %xmm1,%xmm7
  .byte  102,15,249,195                      // psubw         %xmm3,%xmm0
  .byte  102,15,111,85,72                    // movdqa        0x48(%ebp),%xmm2
  .byte  102,15,213,194                      // pmullw        %xmm2,%xmm0
  .byte  102,15,253,199                      // paddw         %xmm7,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,253,216                      // paddw         %xmm0,%xmm3
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,84,36,64                 // movdqa        %xmm2,0x40(%esp)
  .byte  102,15,127,108,36,48                // movdqa        %xmm5,0x30(%esp)
  .byte  15,40,69,40                         // movaps        0x28(%ebp),%xmm0
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  15,40,69,168                        // movaps        -0x58(%ebp),%xmm0
  .byte  102,15,111,206                      // movdqa        %xmm6,%xmm1
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  255,22                              // call          *(%esi)
  .byte  129,196,160,0,0,0                   // add           $0xa0,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_exclusion_sse2_lowp
.globl _sk_exclusion_sse2_lowp
FUNCTION(_sk_exclusion_sse2_lowp)
_sk_exclusion_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  102,15,111,225                      // movdqa        %xmm1,%xmm4
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          b48f <_sk_exclusion_sse2_lowp+0x15>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,109,24                   // movdqa        0x18(%ebp),%xmm5
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,253,193                      // paddw         %xmm1,%xmm0
  .byte  102,15,213,205                      // pmullw        %xmm5,%xmm1
  .byte  102,15,111,184,113,77,0,0           // movdqa        0x4d71(%eax),%xmm7
  .byte  102,15,253,207                      // paddw         %xmm7,%xmm1
  .byte  102,15,113,209,7                    // psrlw         $0x7,%xmm1
  .byte  102,15,111,176,161,77,0,0           // movdqa        0x4da1(%eax),%xmm6
  .byte  102,15,219,206                      // pand          %xmm6,%xmm1
  .byte  102,15,249,193                      // psubw         %xmm1,%xmm0
  .byte  102,15,111,109,40                   // movdqa        0x28(%ebp),%xmm5
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,15,253,204                      // paddw         %xmm4,%xmm1
  .byte  102,15,213,229                      // pmullw        %xmm5,%xmm4
  .byte  102,15,253,231                      // paddw         %xmm7,%xmm4
  .byte  102,15,113,212,7                    // psrlw         $0x7,%xmm4
  .byte  102,15,219,230                      // pand          %xmm6,%xmm4
  .byte  102,15,249,204                      // psubw         %xmm4,%xmm1
  .byte  102,15,111,109,56                   // movdqa        0x38(%ebp),%xmm5
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,253,226                      // paddw         %xmm2,%xmm4
  .byte  102,15,213,213                      // pmullw        %xmm5,%xmm2
  .byte  102,15,253,215                      // paddw         %xmm7,%xmm2
  .byte  102,15,113,210,7                    // psrlw         $0x7,%xmm2
  .byte  102,15,219,214                      // pand          %xmm6,%xmm2
  .byte  102,15,249,226                      // psubw         %xmm2,%xmm4
  .byte  102,15,111,215                      // movdqa        %xmm7,%xmm2
  .byte  102,15,249,211                      // psubw         %xmm3,%xmm2
  .byte  102,15,111,117,72                   // movdqa        0x48(%ebp),%xmm6
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,15,253,215                      // paddw         %xmm7,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,253,218                      // paddw         %xmm2,%xmm3
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,116,36,64                // movdqa        %xmm6,0x40(%esp)
  .byte  102,15,127,108,36,48                // movdqa        %xmm5,0x30(%esp)
  .byte  15,40,85,40                         // movaps        0x28(%ebp),%xmm2
  .byte  15,41,84,36,32                      // movaps        %xmm2,0x20(%esp)
  .byte  15,40,85,24                         // movaps        0x18(%ebp),%xmm2
  .byte  15,41,84,36,16                      // movaps        %xmm2,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_hardlight_sse2_lowp
.globl _sk_hardlight_sse2_lowp
FUNCTION(_sk_hardlight_sse2_lowp)
_sk_hardlight_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,176,0,0,0                   // sub           $0xb0,%esp
  .byte  15,41,85,152                        // movaps        %xmm2,-0x68(%ebp)
  .byte  102,15,111,233                      // movdqa        %xmm1,%xmm5
  .byte  102,15,111,224                      // movdqa        %xmm0,%xmm4
  .byte  232,0,0,0,0                         // call          b589 <_sk_hardlight_sse2_lowp+0x1c>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,184,119,76,0,0           // movdqa        0x4c77(%eax),%xmm7
  .byte  102,15,127,125,200                  // movdqa        %xmm7,-0x38(%ebp)
  .byte  102,15,111,215                      // movdqa        %xmm7,%xmm2
  .byte  102,15,249,85,72                    // psubw         0x48(%ebp),%xmm2
  .byte  102,15,127,85,168                   // movdqa        %xmm2,-0x58(%ebp)
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,213,196                      // pmullw        %xmm4,%xmm0
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,249,250                      // psubw         %xmm2,%xmm7
  .byte  102,15,127,125,232                  // movdqa        %xmm7,-0x18(%ebp)
  .byte  102,15,111,117,24                   // movdqa        0x18(%ebp),%xmm6
  .byte  102,15,213,254                      // pmullw        %xmm6,%xmm7
  .byte  102,15,253,248                      // paddw         %xmm0,%xmm7
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,249,196                      // psubw         %xmm4,%xmm0
  .byte  102,15,111,93,72                    // movdqa        0x48(%ebp),%xmm3
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,249,206                      // psubw         %xmm6,%xmm1
  .byte  102,15,213,200                      // pmullw        %xmm0,%xmm1
  .byte  102,15,111,243                      // movdqa        %xmm3,%xmm6
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,127,93,216                   // movdqa        %xmm3,-0x28(%ebp)
  .byte  102,15,213,243                      // pmullw        %xmm3,%xmm6
  .byte  102,15,253,201                      // paddw         %xmm1,%xmm1
  .byte  102,15,111,214                      // movdqa        %xmm6,%xmm2
  .byte  102,15,249,209                      // psubw         %xmm1,%xmm2
  .byte  102,15,253,228                      // paddw         %xmm4,%xmm4
  .byte  102,15,111,128,135,76,0,0           // movdqa        0x4c87(%eax),%xmm0
  .byte  102,15,239,216                      // pxor          %xmm0,%xmm3
  .byte  102,15,127,93,184                   // movdqa        %xmm3,-0x48(%ebp)
  .byte  102,15,111,204                      // movdqa        %xmm4,%xmm1
  .byte  102,15,239,200                      // pxor          %xmm0,%xmm1
  .byte  102,15,101,203                      // pcmpgtw       %xmm3,%xmm1
  .byte  102,15,213,101,24                   // pmullw        0x18(%ebp),%xmm4
  .byte  102,15,219,209                      // pand          %xmm1,%xmm2
  .byte  102,15,223,204                      // pandn         %xmm4,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  102,15,253,125,200                  // paddw         -0x38(%ebp),%xmm7
  .byte  102,15,253,207                      // paddw         %xmm7,%xmm1
  .byte  102,15,111,85,168                   // movdqa        -0x58(%ebp),%xmm2
  .byte  102,15,213,213                      // pmullw        %xmm5,%xmm2
  .byte  102,15,111,93,40                    // movdqa        0x28(%ebp),%xmm3
  .byte  102,15,111,125,232                  // movdqa        -0x18(%ebp),%xmm7
  .byte  102,15,213,251                      // pmullw        %xmm3,%xmm7
  .byte  102,15,253,250                      // paddw         %xmm2,%xmm7
  .byte  102,15,111,85,216                   // movdqa        -0x28(%ebp),%xmm2
  .byte  102,15,249,213                      // psubw         %xmm5,%xmm2
  .byte  102,15,111,101,72                   // movdqa        0x48(%ebp),%xmm4
  .byte  102,15,249,227                      // psubw         %xmm3,%xmm4
  .byte  102,15,213,226                      // pmullw        %xmm2,%xmm4
  .byte  102,15,253,228                      // paddw         %xmm4,%xmm4
  .byte  102,15,111,214                      // movdqa        %xmm6,%xmm2
  .byte  102,15,249,212                      // psubw         %xmm4,%xmm2
  .byte  102,15,253,237                      // paddw         %xmm5,%xmm5
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,239,224                      // pxor          %xmm0,%xmm4
  .byte  102,15,101,101,184                  // pcmpgtw       -0x48(%ebp),%xmm4
  .byte  102,15,213,235                      // pmullw        %xmm3,%xmm5
  .byte  102,15,219,212                      // pand          %xmm4,%xmm2
  .byte  102,15,223,229                      // pandn         %xmm5,%xmm4
  .byte  102,15,235,226                      // por           %xmm2,%xmm4
  .byte  102,15,253,125,200                  // paddw         -0x38(%ebp),%xmm7
  .byte  102,15,253,231                      // paddw         %xmm7,%xmm4
  .byte  102,15,111,93,152                   // movdqa        -0x68(%ebp),%xmm3
  .byte  102,15,111,85,168                   // movdqa        -0x58(%ebp),%xmm2
  .byte  102,15,213,211                      // pmullw        %xmm3,%xmm2
  .byte  102,15,111,109,232                  // movdqa        -0x18(%ebp),%xmm5
  .byte  102,15,213,109,56                   // pmullw        0x38(%ebp),%xmm5
  .byte  102,15,253,234                      // paddw         %xmm2,%xmm5
  .byte  102,15,111,85,216                   // movdqa        -0x28(%ebp),%xmm2
  .byte  102,15,249,211                      // psubw         %xmm3,%xmm2
  .byte  102,15,253,219                      // paddw         %xmm3,%xmm3
  .byte  102,15,239,195                      // pxor          %xmm3,%xmm0
  .byte  102,15,101,69,184                   // pcmpgtw       -0x48(%ebp),%xmm0
  .byte  102,15,111,125,72                   // movdqa        0x48(%ebp),%xmm7
  .byte  102,15,249,125,56                   // psubw         0x38(%ebp),%xmm7
  .byte  102,15,213,250                      // pmullw        %xmm2,%xmm7
  .byte  102,15,253,255                      // paddw         %xmm7,%xmm7
  .byte  102,15,249,247                      // psubw         %xmm7,%xmm6
  .byte  102,15,111,125,56                   // movdqa        0x38(%ebp),%xmm7
  .byte  102,15,213,223                      // pmullw        %xmm7,%xmm3
  .byte  102,15,219,240                      // pand          %xmm0,%xmm6
  .byte  102,15,223,195                      // pandn         %xmm3,%xmm0
  .byte  102,15,235,198                      // por           %xmm6,%xmm0
  .byte  102,15,111,93,200                   // movdqa        -0x38(%ebp),%xmm3
  .byte  102,15,253,235                      // paddw         %xmm3,%xmm5
  .byte  102,15,253,232                      // paddw         %xmm0,%xmm5
  .byte  102,15,111,69,72                    // movdqa        0x48(%ebp),%xmm0
  .byte  102,15,111,85,232                   // movdqa        -0x18(%ebp),%xmm2
  .byte  102,15,213,208                      // pmullw        %xmm0,%xmm2
  .byte  102,15,253,211                      // paddw         %xmm3,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,111,93,216                   // movdqa        -0x28(%ebp),%xmm3
  .byte  102,15,253,218                      // paddw         %xmm2,%xmm3
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,212,8                    // psrlw         $0x8,%xmm4
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,68,36,64                 // movdqa        %xmm0,0x40(%esp)
  .byte  102,15,127,124,36,48                // movdqa        %xmm7,0x30(%esp)
  .byte  15,40,69,40                         // movaps        0x28(%ebp),%xmm0
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,111,204                      // movdqa        %xmm4,%xmm1
  .byte  102,15,111,213                      // movdqa        %xmm5,%xmm2
  .byte  255,22                              // call          *(%esi)
  .byte  129,196,176,0,0,0                   // add           $0xb0,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_overlay_sse2_lowp
.globl _sk_overlay_sse2_lowp
FUNCTION(_sk_overlay_sse2_lowp)
_sk_overlay_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,208,0,0,0                   // sub           $0xd0,%esp
  .byte  15,41,85,152                        // movaps        %xmm2,-0x68(%ebp)
  .byte  15,41,141,120,255,255,255           // movaps        %xmm1,-0x88(%ebp)
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          b7ab <_sk_overlay_sse2_lowp+0x1f>
  .byte  88                                  // pop           %eax
  .byte  102,15,111,69,72                    // movdqa        0x48(%ebp),%xmm0
  .byte  102,15,111,184,85,74,0,0            // movdqa        0x4a55(%eax),%xmm7
  .byte  102,15,127,125,232                  // movdqa        %xmm7,-0x18(%ebp)
  .byte  102,15,111,215                      // movdqa        %xmm7,%xmm2
  .byte  102,15,249,208                      // psubw         %xmm0,%xmm2
  .byte  102,15,127,85,168                   // movdqa        %xmm2,-0x58(%ebp)
  .byte  102,15,111,240                      // movdqa        %xmm0,%xmm6
  .byte  102,15,213,209                      // pmullw        %xmm1,%xmm2
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,249,248                      // psubw         %xmm0,%xmm7
  .byte  102,15,111,231                      // movdqa        %xmm7,%xmm4
  .byte  102,15,213,101,24                   // pmullw        0x18(%ebp),%xmm4
  .byte  102,15,253,226                      // paddw         %xmm2,%xmm4
  .byte  102,15,127,101,216                  // movdqa        %xmm4,-0x28(%ebp)
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,127,69,200                   // movdqa        %xmm0,-0x38(%ebp)
  .byte  102,15,249,233                      // psubw         %xmm1,%xmm5
  .byte  102,15,111,230                      // movdqa        %xmm6,%xmm4
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  102,15,111,93,24                    // movdqa        0x18(%ebp),%xmm3
  .byte  102,15,249,211                      // psubw         %xmm3,%xmm2
  .byte  102,15,213,213                      // pmullw        %xmm5,%xmm2
  .byte  102,15,213,240                      // pmullw        %xmm0,%xmm6
  .byte  102,15,253,210                      // paddw         %xmm2,%xmm2
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,15,249,234                      // psubw         %xmm2,%xmm5
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,253,192                      // paddw         %xmm0,%xmm0
  .byte  102,15,111,144,101,74,0,0           // movdqa        0x4a65(%eax),%xmm2
  .byte  102,15,127,85,184                   // movdqa        %xmm2,-0x48(%ebp)
  .byte  102,15,239,226                      // pxor          %xmm2,%xmm4
  .byte  102,15,239,194                      // pxor          %xmm2,%xmm0
  .byte  102,15,101,196                      // pcmpgtw       %xmm4,%xmm0
  .byte  102,15,127,101,136                  // movdqa        %xmm4,-0x78(%ebp)
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,15,253,201                      // paddw         %xmm1,%xmm1
  .byte  102,15,219,232                      // pand          %xmm0,%xmm5
  .byte  102,15,223,193                      // pandn         %xmm1,%xmm0
  .byte  102,15,235,197                      // por           %xmm5,%xmm0
  .byte  102,15,111,85,232                   // movdqa        -0x18(%ebp),%xmm2
  .byte  102,15,111,77,216                   // movdqa        -0x28(%ebp),%xmm1
  .byte  102,15,253,202                      // paddw         %xmm2,%xmm1
  .byte  102,15,253,200                      // paddw         %xmm0,%xmm1
  .byte  102,15,127,77,216                   // movdqa        %xmm1,-0x28(%ebp)
  .byte  102,15,111,69,168                   // movdqa        -0x58(%ebp),%xmm0
  .byte  102,15,111,141,120,255,255,255      // movdqa        -0x88(%ebp),%xmm1
  .byte  102,15,213,193                      // pmullw        %xmm1,%xmm0
  .byte  102,15,111,85,40                    // movdqa        0x28(%ebp),%xmm2
  .byte  102,15,111,223                      // movdqa        %xmm7,%xmm3
  .byte  102,15,213,218                      // pmullw        %xmm2,%xmm3
  .byte  102,15,253,216                      // paddw         %xmm0,%xmm3
  .byte  102,15,111,69,200                   // movdqa        -0x38(%ebp),%xmm0
  .byte  102,15,249,193                      // psubw         %xmm1,%xmm0
  .byte  102,15,111,109,72                   // movdqa        0x48(%ebp),%xmm5
  .byte  102,15,249,234                      // psubw         %xmm2,%xmm5
  .byte  102,15,213,232                      // pmullw        %xmm0,%xmm5
  .byte  102,15,253,237                      // paddw         %xmm5,%xmm5
  .byte  102,15,111,198                      // movdqa        %xmm6,%xmm0
  .byte  102,15,249,197                      // psubw         %xmm5,%xmm0
  .byte  102,15,111,234                      // movdqa        %xmm2,%xmm5
  .byte  102,15,253,237                      // paddw         %xmm5,%xmm5
  .byte  102,15,239,109,184                  // pxor          -0x48(%ebp),%xmm5
  .byte  102,15,101,236                      // pcmpgtw       %xmm4,%xmm5
  .byte  102,15,213,202                      // pmullw        %xmm2,%xmm1
  .byte  102,15,253,201                      // paddw         %xmm1,%xmm1
  .byte  102,15,219,197                      // pand          %xmm5,%xmm0
  .byte  102,15,223,233                      // pandn         %xmm1,%xmm5
  .byte  102,15,235,232                      // por           %xmm0,%xmm5
  .byte  102,15,253,93,232                   // paddw         -0x18(%ebp),%xmm3
  .byte  102,15,253,221                      // paddw         %xmm5,%xmm3
  .byte  102,15,111,109,152                  // movdqa        -0x68(%ebp),%xmm5
  .byte  102,15,111,69,168                   // movdqa        -0x58(%ebp),%xmm0
  .byte  102,15,213,197                      // pmullw        %xmm5,%xmm0
  .byte  102,15,111,77,56                    // movdqa        0x38(%ebp),%xmm1
  .byte  102,15,111,231                      // movdqa        %xmm7,%xmm4
  .byte  102,15,213,225                      // pmullw        %xmm1,%xmm4
  .byte  102,15,253,224                      // paddw         %xmm0,%xmm4
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,253,192                      // paddw         %xmm0,%xmm0
  .byte  102,15,239,69,184                   // pxor          -0x48(%ebp),%xmm0
  .byte  102,15,101,69,136                   // pcmpgtw       -0x78(%ebp),%xmm0
  .byte  102,15,111,85,200                   // movdqa        -0x38(%ebp),%xmm2
  .byte  102,15,249,213                      // psubw         %xmm5,%xmm2
  .byte  102,15,111,77,72                    // movdqa        0x48(%ebp),%xmm1
  .byte  102,15,111,233                      // movdqa        %xmm1,%xmm5
  .byte  102,15,111,77,56                    // movdqa        0x38(%ebp),%xmm1
  .byte  102,15,249,233                      // psubw         %xmm1,%xmm5
  .byte  102,15,213,234                      // pmullw        %xmm2,%xmm5
  .byte  102,15,253,237                      // paddw         %xmm5,%xmm5
  .byte  102,15,249,245                      // psubw         %xmm5,%xmm6
  .byte  102,15,111,85,152                   // movdqa        -0x68(%ebp),%xmm2
  .byte  102,15,213,209                      // pmullw        %xmm1,%xmm2
  .byte  102,15,253,210                      // paddw         %xmm2,%xmm2
  .byte  102,15,219,240                      // pand          %xmm0,%xmm6
  .byte  102,15,223,194                      // pandn         %xmm2,%xmm0
  .byte  102,15,235,198                      // por           %xmm6,%xmm0
  .byte  102,15,111,85,232                   // movdqa        -0x18(%ebp),%xmm2
  .byte  102,15,253,226                      // paddw         %xmm2,%xmm4
  .byte  102,15,253,224                      // paddw         %xmm0,%xmm4
  .byte  102,15,111,69,72                    // movdqa        0x48(%ebp),%xmm0
  .byte  102,15,213,248                      // pmullw        %xmm0,%xmm7
  .byte  102,15,253,250                      // paddw         %xmm2,%xmm7
  .byte  102,15,113,215,8                    // psrlw         $0x8,%xmm7
  .byte  102,15,111,109,200                  // movdqa        -0x38(%ebp),%xmm5
  .byte  102,15,253,239                      // paddw         %xmm7,%xmm5
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  102,15,111,77,216                   // movdqa        -0x28(%ebp),%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,113,212,8                    // psrlw         $0x8,%xmm4
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  102,15,127,68,36,64                 // movdqa        %xmm0,0x40(%esp)
  .byte  15,40,69,56                         // movaps        0x38(%ebp),%xmm0
  .byte  15,41,68,36,48                      // movaps        %xmm0,0x30(%esp)
  .byte  15,40,69,40                         // movaps        0x28(%ebp),%xmm0
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  102,15,111,221                      // movdqa        %xmm5,%xmm3
  .byte  255,22                              // call          *(%esi)
  .byte  129,196,208,0,0,0                   // add           $0xd0,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_load_8888_sse2_lowp
.globl _sk_load_8888_sse2_lowp
FUNCTION(_sk_load_8888_sse2_lowp)
_sk_load_8888_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  193,227,2                           // shl           $0x2,%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          ba1a <_sk_load_8888_sse2_lowp+0x30>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,32                              // ja            ba40 <_sk_load_8888_sse2_lowp+0x56>
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,50,1,0,0                // mov           0x132(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  255,225                             // jmp           *%ecx
  .byte  243,15,16,28,179                    // movss         (%ebx,%esi,4),%xmm3
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  235,73                              // jmp           ba89 <_sk_load_8888_sse2_lowp+0x9f>
  .byte  102,15,16,28,179                    // movupd        (%ebx,%esi,4),%xmm3
  .byte  15,16,116,179,16                    // movups        0x10(%ebx,%esi,4),%xmm6
  .byte  235,61                              // jmp           ba89 <_sk_load_8888_sse2_lowp+0x9f>
  .byte  102,15,110,68,179,8                 // movd          0x8(%ebx,%esi,4),%xmm0
  .byte  102,15,112,216,69                   // pshufd        $0x45,%xmm0,%xmm3
  .byte  102,15,18,28,179                    // movlpd        (%ebx,%esi,4),%xmm3
  .byte  235,43                              // jmp           ba89 <_sk_load_8888_sse2_lowp+0x9f>
  .byte  102,15,110,68,179,24                // movd          0x18(%ebx,%esi,4),%xmm0
  .byte  102,15,112,240,69                   // pshufd        $0x45,%xmm0,%xmm6
  .byte  243,15,16,68,179,20                 // movss         0x14(%ebx,%esi,4),%xmm0
  .byte  15,198,198,0                        // shufps        $0x0,%xmm6,%xmm0
  .byte  15,198,198,226                      // shufps        $0xe2,%xmm6,%xmm0
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  243,15,16,68,179,16                 // movss         0x10(%ebx,%esi,4),%xmm0
  .byte  243,15,16,240                       // movss         %xmm0,%xmm6
  .byte  102,15,16,28,179                    // movupd        (%ebx,%esi,4),%xmm3
  .byte  102,15,40,203                       // movapd        %xmm3,%xmm1
  .byte  102,15,114,241,16                   // pslld         $0x10,%xmm1
  .byte  102,15,114,225,16                   // psrad         $0x10,%xmm1
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,107,200                      // packssdw      %xmm0,%xmm1
  .byte  102,15,111,175,230,71,0,0           // movdqa        0x47e6(%edi),%xmm5
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,219,197                      // pand          %xmm5,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  102,15,114,212,16                   // psrld         $0x10,%xmm4
  .byte  102,15,40,211                       // movapd        %xmm3,%xmm2
  .byte  102,15,114,210,16                   // psrld         $0x10,%xmm2
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  102,15,114,227,16                   // psrad         $0x10,%xmm3
  .byte  102,15,114,214,24                   // psrld         $0x18,%xmm6
  .byte  102,15,114,246,16                   // pslld         $0x10,%xmm6
  .byte  102,15,114,230,16                   // psrad         $0x10,%xmm6
  .byte  102,15,107,222                      // packssdw      %xmm6,%xmm3
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,114,226,16                   // psrad         $0x10,%xmm2
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,107,212                      // packssdw      %xmm4,%xmm2
  .byte  102,15,219,213                      // pand          %xmm5,%xmm2
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,41,124,36,64                     // movaps        %xmm7,0x40(%esp)
  .byte  15,40,101,56                        // movaps        0x38(%ebp),%xmm4
  .byte  15,41,100,36,48                     // movaps        %xmm4,0x30(%esp)
  .byte  15,40,101,40                        // movaps        0x28(%ebp),%xmm4
  .byte  15,41,100,36,32                     // movaps        %xmm4,0x20(%esp)
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  28,0                                // sbb           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  61,0,0,0,50                         // cmp           $0x32000000,%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,106,0                             // add           %ch,0x0(%edx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  96                                  // pusha
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,79,0                              // add           %cl,0x0(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  68                                  // inc           %esp
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_load_8888_dst_sse2_lowp
.globl _sk_load_8888_dst_sse2_lowp
FUNCTION(_sk_load_8888_dst_sse2_lowp)
_sk_load_8888_dst_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,140,0,0,0                   // sub           $0x8c,%esp
  .byte  102,15,127,93,184                   // movdqa        %xmm3,-0x48(%ebp)
  .byte  102,15,127,85,200                   // movdqa        %xmm2,-0x38(%ebp)
  .byte  15,41,77,216                        // movaps        %xmm1,-0x28(%ebp)
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  193,227,2                           // shl           $0x2,%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          bba5 <_sk_load_8888_dst_sse2_lowp+0x3d>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,32                              // ja            bbcb <_sk_load_8888_dst_sse2_lowp+0x63>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,59,1,0,0                // mov           0x13b(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  255,225                             // jmp           *%ecx
  .byte  243,15,16,60,179                    // movss         (%ebx,%esi,4),%xmm7
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  235,73                              // jmp           bc14 <_sk_load_8888_dst_sse2_lowp+0xac>
  .byte  102,15,16,60,179                    // movupd        (%ebx,%esi,4),%xmm7
  .byte  15,16,92,179,16                     // movups        0x10(%ebx,%esi,4),%xmm3
  .byte  235,61                              // jmp           bc14 <_sk_load_8888_dst_sse2_lowp+0xac>
  .byte  102,15,110,84,179,8                 // movd          0x8(%ebx,%esi,4),%xmm2
  .byte  102,15,112,250,69                   // pshufd        $0x45,%xmm2,%xmm7
  .byte  102,15,18,60,179                    // movlpd        (%ebx,%esi,4),%xmm7
  .byte  235,43                              // jmp           bc14 <_sk_load_8888_dst_sse2_lowp+0xac>
  .byte  102,15,110,84,179,24                // movd          0x18(%ebx,%esi,4),%xmm2
  .byte  102,15,112,218,69                   // pshufd        $0x45,%xmm2,%xmm3
  .byte  243,15,16,84,179,20                 // movss         0x14(%ebx,%esi,4),%xmm2
  .byte  15,198,211,0                        // shufps        $0x0,%xmm3,%xmm2
  .byte  15,198,211,226                      // shufps        $0xe2,%xmm3,%xmm2
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  243,15,16,84,179,16                 // movss         0x10(%ebx,%esi,4),%xmm2
  .byte  243,15,16,218                       // movss         %xmm2,%xmm3
  .byte  102,15,16,60,179                    // movupd        (%ebx,%esi,4),%xmm7
  .byte  102,15,40,247                       // movapd        %xmm7,%xmm6
  .byte  102,15,114,246,16                   // pslld         $0x10,%xmm6
  .byte  102,15,114,230,16                   // psrad         $0x10,%xmm6
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,114,226,16                   // psrad         $0x10,%xmm2
  .byte  102,15,107,242                      // packssdw      %xmm2,%xmm6
  .byte  102,15,111,151,91,70,0,0            // movdqa        0x465b(%edi),%xmm2
  .byte  102,15,111,206                      // movdqa        %xmm6,%xmm1
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  102,15,113,214,8                    // psrlw         $0x8,%xmm6
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  102,15,114,212,16                   // psrld         $0x10,%xmm4
  .byte  102,15,40,239                       // movapd        %xmm7,%xmm5
  .byte  102,15,114,213,16                   // psrld         $0x10,%xmm5
  .byte  102,15,114,215,24                   // psrld         $0x18,%xmm7
  .byte  102,15,114,247,16                   // pslld         $0x10,%xmm7
  .byte  102,15,114,231,16                   // psrad         $0x10,%xmm7
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  102,15,114,227,16                   // psrad         $0x10,%xmm3
  .byte  102,15,107,251                      // packssdw      %xmm3,%xmm7
  .byte  102,15,114,245,16                   // pslld         $0x10,%xmm5
  .byte  102,15,114,229,16                   // psrad         $0x10,%xmm5
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,107,236                      // packssdw      %xmm4,%xmm5
  .byte  102,15,219,234                      // pand          %xmm2,%xmm5
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  102,15,127,124,36,64                // movdqa        %xmm7,0x40(%esp)
  .byte  102,15,127,116,36,32                // movdqa        %xmm6,0x20(%esp)
  .byte  102,15,127,76,36,16                 // movdqa        %xmm1,0x10(%esp)
  .byte  102,15,127,108,36,48                // movdqa        %xmm5,0x30(%esp)
  .byte  15,40,77,216                        // movaps        -0x28(%ebp),%xmm1
  .byte  15,40,85,200                        // movaps        -0x38(%ebp),%xmm2
  .byte  15,40,93,184                        // movaps        -0x48(%ebp),%xmm3
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  129,196,140,0,0,0                   // add           $0x8c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  102,144                             // xchg          %ax,%ax
  .byte  28,0                                // sbb           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  61,0,0,0,50                         // cmp           $0x32000000,%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,106,0                             // add           %ch,0x0(%edx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  96                                  // pusha
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,79,0                              // add           %cl,0x0(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  68                                  // inc           %esp
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_store_8888_sse2_lowp
.globl _sk_store_8888_sse2_lowp
FUNCTION(_sk_store_8888_sse2_lowp)
_sk_store_8888_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,108                         // sub           $0x6c,%esp
  .byte  102,15,111,225                      // movdqa        %xmm1,%xmm4
  .byte  102,15,113,244,8                    // psllw         $0x8,%xmm4
  .byte  102,15,235,224                      // por           %xmm0,%xmm4
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,97,238                       // punpcklwd     %xmm6,%xmm5
  .byte  102,15,127,93,216                   // movdqa        %xmm3,-0x28(%ebp)
  .byte  102,15,113,243,8                    // psllw         $0x8,%xmm3
  .byte  102,15,235,218                      // por           %xmm2,%xmm3
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  102,15,97,251                       // punpcklwd     %xmm3,%xmm7
  .byte  102,15,235,253                      // por           %xmm5,%xmm7
  .byte  102,15,105,230                      // punpckhwd     %xmm6,%xmm4
  .byte  102,15,105,243                      // punpckhwd     %xmm3,%xmm6
  .byte  15,40,93,72                         // movaps        0x48(%ebp),%xmm3
  .byte  102,15,235,244                      // por           %xmm4,%xmm6
  .byte  102,15,111,101,56                   // movdqa        0x38(%ebp),%xmm4
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,93,8                            // mov           0x8(%ebp),%ebx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,121,4                           // mov           0x4(%ecx),%edi
  .byte  15,175,250                          // imul          %edx,%edi
  .byte  193,231,2                           // shl           $0x2,%edi
  .byte  3,57                                // add           (%ecx),%edi
  .byte  128,227,7                           // and           $0x7,%bl
  .byte  254,203                             // dec           %bl
  .byte  128,251,6                           // cmp           $0x6,%bl
  .byte  232,0,0,0,0                         // call          bd70 <_sk_store_8888_sse2_lowp+0x74>
  .byte  89                                  // pop           %ecx
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  119,19                              // ja            bd8d <_sk_store_8888_sse2_lowp+0x91>
  .byte  15,182,219                          // movzbl        %bl,%ebx
  .byte  3,140,153,184,0,0,0                 // add           0xb8(%ecx,%ebx,4),%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  102,15,126,60,183                   // movd          %xmm7,(%edi,%esi,4)
  .byte  235,93                              // jmp           bdea <_sk_store_8888_sse2_lowp+0xee>
  .byte  243,15,127,60,183                   // movdqu        %xmm7,(%edi,%esi,4)
  .byte  243,15,127,116,183,16               // movdqu        %xmm6,0x10(%edi,%esi,4)
  .byte  235,80                              // jmp           bdea <_sk_store_8888_sse2_lowp+0xee>
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  102,15,112,223,78                   // pshufd        $0x4e,%xmm7,%xmm3
  .byte  102,15,126,92,183,8                 // movd          %xmm3,0x8(%edi,%esi,4)
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  102,15,111,230                      // movdqa        %xmm6,%xmm4
  .byte  102,15,214,60,183                   // movq          %xmm7,(%edi,%esi,4)
  .byte  235,48                              // jmp           bdea <_sk_store_8888_sse2_lowp+0xee>
  .byte  102,15,112,222,78                   // pshufd        $0x4e,%xmm6,%xmm3
  .byte  102,15,126,92,183,24                // movd          %xmm3,0x18(%edi,%esi,4)
  .byte  15,40,93,72                         // movaps        0x48(%ebp),%xmm3
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  102,15,112,222,229                  // pshufd        $0xe5,%xmm6,%xmm3
  .byte  102,15,126,92,183,20                // movd          %xmm3,0x14(%edi,%esi,4)
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  102,15,111,101,56                   // movdqa        0x38(%ebp),%xmm4
  .byte  102,15,126,116,183,16               // movd          %xmm6,0x10(%edi,%esi,4)
  .byte  243,15,127,60,183                   // movdqu        %xmm7,(%edi,%esi,4)
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,41,92,36,64                      // movaps        %xmm3,0x40(%esp)
  .byte  102,15,127,100,36,48                // movdqa        %xmm4,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,40,93,24                         // movaps        0x18(%ebp),%xmm3
  .byte  15,41,92,36,16                      // movaps        %xmm3,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  137,12,36                           // mov           %ecx,(%esp)
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,108                         // add           $0x6c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  144                                 // nop
  .byte  22                                  // push          %ss
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,67,0                              // add           %al,0x0(%ebx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  42,0                                // sub           (%eax),%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  117,0                               // jne           be36 <_sk_store_8888_sse2_lowp+0x13a>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  111                                 // outsl         %ds:(%esi),(%dx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,89,0                              // add           %bl,0x0(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  74                                  // dec           %edx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_load_bgra_sse2_lowp
.globl _sk_load_bgra_sse2_lowp
FUNCTION(_sk_load_bgra_sse2_lowp)
_sk_load_bgra_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  193,227,2                           // shl           $0x2,%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          be74 <_sk_load_bgra_sse2_lowp+0x30>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,32                              // ja            be9a <_sk_load_bgra_sse2_lowp+0x56>
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,52,1,0,0                // mov           0x134(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  255,225                             // jmp           *%ecx
  .byte  243,15,16,28,179                    // movss         (%ebx,%esi,4),%xmm3
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  235,73                              // jmp           bee3 <_sk_load_bgra_sse2_lowp+0x9f>
  .byte  102,15,16,28,179                    // movupd        (%ebx,%esi,4),%xmm3
  .byte  15,16,116,179,16                    // movups        0x10(%ebx,%esi,4),%xmm6
  .byte  235,61                              // jmp           bee3 <_sk_load_bgra_sse2_lowp+0x9f>
  .byte  102,15,110,68,179,8                 // movd          0x8(%ebx,%esi,4),%xmm0
  .byte  102,15,112,216,69                   // pshufd        $0x45,%xmm0,%xmm3
  .byte  102,15,18,28,179                    // movlpd        (%ebx,%esi,4),%xmm3
  .byte  235,43                              // jmp           bee3 <_sk_load_bgra_sse2_lowp+0x9f>
  .byte  102,15,110,68,179,24                // movd          0x18(%ebx,%esi,4),%xmm0
  .byte  102,15,112,240,69                   // pshufd        $0x45,%xmm0,%xmm6
  .byte  243,15,16,68,179,20                 // movss         0x14(%ebx,%esi,4),%xmm0
  .byte  15,198,198,0                        // shufps        $0x0,%xmm6,%xmm0
  .byte  15,198,198,226                      // shufps        $0xe2,%xmm6,%xmm0
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  243,15,16,68,179,16                 // movss         0x10(%ebx,%esi,4),%xmm0
  .byte  243,15,16,240                       // movss         %xmm0,%xmm6
  .byte  102,15,16,28,179                    // movupd        (%ebx,%esi,4),%xmm3
  .byte  102,15,40,203                       // movapd        %xmm3,%xmm1
  .byte  102,15,114,241,16                   // pslld         $0x10,%xmm1
  .byte  102,15,114,225,16                   // psrad         $0x10,%xmm1
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,107,200                      // packssdw      %xmm0,%xmm1
  .byte  102,15,111,175,140,67,0,0           // movdqa        0x438c(%edi),%xmm5
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,15,219,213                      // pand          %xmm5,%xmm2
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  102,15,114,212,16                   // psrld         $0x10,%xmm4
  .byte  102,15,40,195                       // movapd        %xmm3,%xmm0
  .byte  102,15,114,208,16                   // psrld         $0x10,%xmm0
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  102,15,114,227,16                   // psrad         $0x10,%xmm3
  .byte  102,15,114,214,24                   // psrld         $0x18,%xmm6
  .byte  102,15,114,246,16                   // pslld         $0x10,%xmm6
  .byte  102,15,114,230,16                   // psrad         $0x10,%xmm6
  .byte  102,15,107,222                      // packssdw      %xmm6,%xmm3
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,107,196                      // packssdw      %xmm4,%xmm0
  .byte  102,15,219,197                      // pand          %xmm5,%xmm0
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,41,124,36,64                     // movaps        %xmm7,0x40(%esp)
  .byte  15,40,101,56                        // movaps        0x38(%ebp),%xmm4
  .byte  15,41,100,36,48                     // movaps        %xmm4,0x30(%esp)
  .byte  15,40,101,40                        // movaps        0x28(%ebp),%xmm4
  .byte  15,41,100,36,32                     // movaps        %xmm4,0x20(%esp)
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  102,144                             // xchg          %ax,%ax
  .byte  28,0                                // sbb           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  61,0,0,0,50                         // cmp           $0x32000000,%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,106,0                             // add           %ch,0x0(%edx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  96                                  // pusha
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,79,0                              // add           %cl,0x0(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  68                                  // inc           %esp
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_load_bgra_dst_sse2_lowp
.globl _sk_load_bgra_dst_sse2_lowp
FUNCTION(_sk_load_bgra_dst_sse2_lowp)
_sk_load_bgra_dst_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,140,0,0,0                   // sub           $0x8c,%esp
  .byte  102,15,127,93,184                   // movdqa        %xmm3,-0x48(%ebp)
  .byte  102,15,127,85,200                   // movdqa        %xmm2,-0x38(%ebp)
  .byte  15,41,77,216                        // movaps        %xmm1,-0x28(%ebp)
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  193,227,2                           // shl           $0x2,%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          c001 <_sk_load_bgra_dst_sse2_lowp+0x3d>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,32                              // ja            c027 <_sk_load_bgra_dst_sse2_lowp+0x63>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,59,1,0,0                // mov           0x13b(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  255,225                             // jmp           *%ecx
  .byte  243,15,16,60,179                    // movss         (%ebx,%esi,4),%xmm7
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  235,73                              // jmp           c070 <_sk_load_bgra_dst_sse2_lowp+0xac>
  .byte  102,15,16,60,179                    // movupd        (%ebx,%esi,4),%xmm7
  .byte  15,16,92,179,16                     // movups        0x10(%ebx,%esi,4),%xmm3
  .byte  235,61                              // jmp           c070 <_sk_load_bgra_dst_sse2_lowp+0xac>
  .byte  102,15,110,84,179,8                 // movd          0x8(%ebx,%esi,4),%xmm2
  .byte  102,15,112,250,69                   // pshufd        $0x45,%xmm2,%xmm7
  .byte  102,15,18,60,179                    // movlpd        (%ebx,%esi,4),%xmm7
  .byte  235,43                              // jmp           c070 <_sk_load_bgra_dst_sse2_lowp+0xac>
  .byte  102,15,110,84,179,24                // movd          0x18(%ebx,%esi,4),%xmm2
  .byte  102,15,112,218,69                   // pshufd        $0x45,%xmm2,%xmm3
  .byte  243,15,16,84,179,20                 // movss         0x14(%ebx,%esi,4),%xmm2
  .byte  15,198,211,0                        // shufps        $0x0,%xmm3,%xmm2
  .byte  15,198,211,226                      // shufps        $0xe2,%xmm3,%xmm2
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  243,15,16,84,179,16                 // movss         0x10(%ebx,%esi,4),%xmm2
  .byte  243,15,16,218                       // movss         %xmm2,%xmm3
  .byte  102,15,16,60,179                    // movupd        (%ebx,%esi,4),%xmm7
  .byte  102,15,40,247                       // movapd        %xmm7,%xmm6
  .byte  102,15,114,246,16                   // pslld         $0x10,%xmm6
  .byte  102,15,114,230,16                   // psrad         $0x10,%xmm6
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,114,226,16                   // psrad         $0x10,%xmm2
  .byte  102,15,107,242                      // packssdw      %xmm2,%xmm6
  .byte  102,15,111,151,255,65,0,0           // movdqa        0x41ff(%edi),%xmm2
  .byte  102,15,111,206                      // movdqa        %xmm6,%xmm1
  .byte  102,15,219,202                      // pand          %xmm2,%xmm1
  .byte  102,15,113,214,8                    // psrlw         $0x8,%xmm6
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  102,15,114,212,16                   // psrld         $0x10,%xmm4
  .byte  102,15,40,239                       // movapd        %xmm7,%xmm5
  .byte  102,15,114,213,16                   // psrld         $0x10,%xmm5
  .byte  102,15,114,215,24                   // psrld         $0x18,%xmm7
  .byte  102,15,114,247,16                   // pslld         $0x10,%xmm7
  .byte  102,15,114,231,16                   // psrad         $0x10,%xmm7
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  102,15,114,227,16                   // psrad         $0x10,%xmm3
  .byte  102,15,107,251                      // packssdw      %xmm3,%xmm7
  .byte  102,15,114,245,16                   // pslld         $0x10,%xmm5
  .byte  102,15,114,229,16                   // psrad         $0x10,%xmm5
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,107,236                      // packssdw      %xmm4,%xmm5
  .byte  102,15,219,234                      // pand          %xmm2,%xmm5
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  102,15,127,124,36,64                // movdqa        %xmm7,0x40(%esp)
  .byte  102,15,127,76,36,48                 // movdqa        %xmm1,0x30(%esp)
  .byte  102,15,127,116,36,32                // movdqa        %xmm6,0x20(%esp)
  .byte  102,15,127,108,36,16                // movdqa        %xmm5,0x10(%esp)
  .byte  15,40,77,216                        // movaps        -0x28(%ebp),%xmm1
  .byte  15,40,85,200                        // movaps        -0x38(%ebp),%xmm2
  .byte  15,40,93,184                        // movaps        -0x48(%ebp),%xmm3
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  129,196,140,0,0,0                   // add           $0x8c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  102,144                             // xchg          %ax,%ax
  .byte  28,0                                // sbb           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  61,0,0,0,50                         // cmp           $0x32000000,%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,106,0                             // add           %ch,0x0(%edx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  96                                  // pusha
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,79,0                              // add           %cl,0x0(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  68                                  // inc           %esp
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_store_bgra_sse2_lowp
.globl _sk_store_bgra_sse2_lowp
FUNCTION(_sk_store_bgra_sse2_lowp)
_sk_store_bgra_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,108                         // sub           $0x6c,%esp
  .byte  102,15,111,225                      // movdqa        %xmm1,%xmm4
  .byte  102,15,113,244,8                    // psllw         $0x8,%xmm4
  .byte  102,15,235,226                      // por           %xmm2,%xmm4
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,97,238                       // punpcklwd     %xmm6,%xmm5
  .byte  102,15,127,93,216                   // movdqa        %xmm3,-0x28(%ebp)
  .byte  102,15,113,243,8                    // psllw         $0x8,%xmm3
  .byte  102,15,235,216                      // por           %xmm0,%xmm3
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  102,15,97,251                       // punpcklwd     %xmm3,%xmm7
  .byte  102,15,235,253                      // por           %xmm5,%xmm7
  .byte  102,15,105,230                      // punpckhwd     %xmm6,%xmm4
  .byte  102,15,105,243                      // punpckhwd     %xmm3,%xmm6
  .byte  15,40,93,72                         // movaps        0x48(%ebp),%xmm3
  .byte  102,15,235,244                      // por           %xmm4,%xmm6
  .byte  102,15,111,101,56                   // movdqa        0x38(%ebp),%xmm4
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,93,8                            // mov           0x8(%ebp),%ebx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,121,4                           // mov           0x4(%ecx),%edi
  .byte  15,175,250                          // imul          %edx,%edi
  .byte  193,231,2                           // shl           $0x2,%edi
  .byte  3,57                                // add           (%ecx),%edi
  .byte  128,227,7                           // and           $0x7,%bl
  .byte  254,203                             // dec           %bl
  .byte  128,251,6                           // cmp           $0x6,%bl
  .byte  232,0,0,0,0                         // call          c1cc <_sk_store_bgra_sse2_lowp+0x74>
  .byte  89                                  // pop           %ecx
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  119,19                              // ja            c1e9 <_sk_store_bgra_sse2_lowp+0x91>
  .byte  15,182,219                          // movzbl        %bl,%ebx
  .byte  3,140,153,184,0,0,0                 // add           0xb8(%ecx,%ebx,4),%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  102,15,126,60,183                   // movd          %xmm7,(%edi,%esi,4)
  .byte  235,93                              // jmp           c246 <_sk_store_bgra_sse2_lowp+0xee>
  .byte  243,15,127,60,183                   // movdqu        %xmm7,(%edi,%esi,4)
  .byte  243,15,127,116,183,16               // movdqu        %xmm6,0x10(%edi,%esi,4)
  .byte  235,80                              // jmp           c246 <_sk_store_bgra_sse2_lowp+0xee>
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  102,15,112,223,78                   // pshufd        $0x4e,%xmm7,%xmm3
  .byte  102,15,126,92,183,8                 // movd          %xmm3,0x8(%edi,%esi,4)
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  102,15,111,230                      // movdqa        %xmm6,%xmm4
  .byte  102,15,214,60,183                   // movq          %xmm7,(%edi,%esi,4)
  .byte  235,48                              // jmp           c246 <_sk_store_bgra_sse2_lowp+0xee>
  .byte  102,15,112,222,78                   // pshufd        $0x4e,%xmm6,%xmm3
  .byte  102,15,126,92,183,24                // movd          %xmm3,0x18(%edi,%esi,4)
  .byte  15,40,93,72                         // movaps        0x48(%ebp),%xmm3
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  102,15,112,222,229                  // pshufd        $0xe5,%xmm6,%xmm3
  .byte  102,15,126,92,183,20                // movd          %xmm3,0x14(%edi,%esi,4)
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  102,15,111,101,56                   // movdqa        0x38(%ebp),%xmm4
  .byte  102,15,126,116,183,16               // movd          %xmm6,0x10(%edi,%esi,4)
  .byte  243,15,127,60,183                   // movdqu        %xmm7,(%edi,%esi,4)
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,41,92,36,64                      // movaps        %xmm3,0x40(%esp)
  .byte  102,15,127,100,36,48                // movdqa        %xmm4,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,40,93,24                         // movaps        0x18(%ebp),%xmm3
  .byte  15,41,92,36,16                      // movaps        %xmm3,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  137,12,36                           // mov           %ecx,(%esp)
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,108                         // add           $0x6c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  144                                 // nop
  .byte  22                                  // push          %ss
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,67,0                              // add           %al,0x0(%ebx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  42,0                                // sub           (%eax),%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  117,0                               // jne           c292 <_sk_store_bgra_sse2_lowp+0x13a>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  111                                 // outsl         %ds:(%esi),(%dx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,89,0                              // add           %bl,0x0(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  74                                  // dec           %edx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_gather_8888_sse2_lowp
.globl _sk_gather_8888_sse2_lowp
FUNCTION(_sk_gather_8888_sse2_lowp)
_sk_gather_8888_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,96                          // sub           $0x60,%esp
  .byte  232,0,0,0,0                         // call          c2ad <_sk_gather_8888_sse2_lowp+0xd>
  .byte  90                                  // pop           %edx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  243,15,16,103,8                     // movss         0x8(%edi),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  102,15,118,237                      // pcmpeqd       %xmm5,%xmm5
  .byte  102,15,254,229                      // paddd         %xmm5,%xmm4
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,95,198                           // maxps         %xmm6,%xmm0
  .byte  15,95,206                           // maxps         %xmm6,%xmm1
  .byte  15,93,204                           // minps         %xmm4,%xmm1
  .byte  15,93,196                           // minps         %xmm4,%xmm0
  .byte  243,15,16,103,12                    // movss         0xc(%edi),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  102,15,254,229                      // paddd         %xmm5,%xmm4
  .byte  15,95,222                           // maxps         %xmm6,%xmm3
  .byte  15,95,214                           // maxps         %xmm6,%xmm2
  .byte  15,93,212                           // minps         %xmm4,%xmm2
  .byte  15,93,220                           // minps         %xmm4,%xmm3
  .byte  139,55                              // mov           (%edi),%esi
  .byte  243,15,91,219                       // cvttps2dq     %xmm3,%xmm3
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  102,15,110,103,4                    // movd          0x4(%edi),%xmm4
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  102,15,112,234,245                  // pshufd        $0xf5,%xmm2,%xmm5
  .byte  102,15,244,236                      // pmuludq       %xmm4,%xmm5
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,112,251,245                  // pshufd        $0xf5,%xmm3,%xmm7
  .byte  102,15,244,252                      // pmuludq       %xmm4,%xmm7
  .byte  102,15,244,226                      // pmuludq       %xmm2,%xmm4
  .byte  102,15,112,212,232                  // pshufd        $0xe8,%xmm4,%xmm2
  .byte  102,15,112,229,232                  // pshufd        $0xe8,%xmm5,%xmm4
  .byte  102,15,98,212                       // punpckldq     %xmm4,%xmm2
  .byte  102,15,244,243                      // pmuludq       %xmm3,%xmm6
  .byte  102,15,112,222,232                  // pshufd        $0xe8,%xmm6,%xmm3
  .byte  102,15,112,231,232                  // pshufd        $0xe8,%xmm7,%xmm4
  .byte  102,15,98,220                       // punpckldq     %xmm4,%xmm3
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,194                      // paddd         %xmm2,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,15,254,203                      // paddd         %xmm3,%xmm1
  .byte  102,15,112,208,78                   // pshufd        $0x4e,%xmm0,%xmm2
  .byte  102,15,112,216,231                  // pshufd        $0xe7,%xmm0,%xmm3
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  243,15,16,28,190                    // movss         (%esi,%edi,4),%xmm3
  .byte  15,41,93,232                        // movaps        %xmm3,-0x18(%ebp)
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  102,15,110,36,190                   // movd          (%esi,%edi,4),%xmm4
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,192,229                  // pshufd        $0xe5,%xmm0,%xmm0
  .byte  102,15,110,28,190                   // movd          (%esi,%edi,4),%xmm3
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,15,112,233,231                  // pshufd        $0xe7,%xmm1,%xmm5
  .byte  102,15,110,52,190                   // movd          (%esi,%edi,4),%xmm6
  .byte  102,15,126,239                      // movd          %xmm5,%edi
  .byte  102,15,110,60,190                   // movd          (%esi,%edi,4),%xmm7
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,110,20,190                   // movd          (%esi,%edi,4),%xmm2
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,201,229                  // pshufd        $0xe5,%xmm1,%xmm1
  .byte  102,15,110,4,190                    // movd          (%esi,%edi,4),%xmm0
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,110,12,190                   // movd          (%esi,%edi,4),%xmm1
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  102,15,98,101,232                   // punpckldq     -0x18(%ebp),%xmm4
  .byte  102,15,98,222                       // punpckldq     %xmm6,%xmm3
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  102,15,108,220                      // punpcklqdq    %xmm4,%xmm3
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  102,15,98,215                       // punpckldq     %xmm7,%xmm2
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  102,15,108,194                      // punpcklqdq    %xmm2,%xmm0
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,114,226,16                   // psrad         $0x10,%xmm2
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,114,241,16                   // pslld         $0x10,%xmm1
  .byte  102,15,114,225,16                   // psrad         $0x10,%xmm1
  .byte  102,15,107,202                      // packssdw      %xmm2,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,111,224                      // movdqa        %xmm0,%xmm4
  .byte  102,15,114,208,24                   // psrld         $0x18,%xmm0
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  102,15,114,227,16                   // psrad         $0x10,%xmm3
  .byte  102,15,107,216                      // packssdw      %xmm0,%xmm3
  .byte  102,15,111,186,83,63,0,0            // movdqa        0x3f53(%edx),%xmm7
  .byte  102,15,114,210,16                   // psrld         $0x10,%xmm2
  .byte  102,15,114,212,16                   // psrld         $0x10,%xmm4
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,114,226,16                   // psrad         $0x10,%xmm2
  .byte  102,15,107,212                      // packssdw      %xmm4,%xmm2
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,219,199                      // pand          %xmm7,%xmm0
  .byte  102,15,219,215                      // pand          %xmm7,%xmm2
  .byte  15,40,101,72                        // movaps        0x48(%ebp),%xmm4
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  141,81,8                            // lea           0x8(%ecx),%edx
  .byte  15,41,100,36,64                     // movaps        %xmm4,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,84,36,4                         // mov           %edx,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,96                          // add           $0x60,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_gather_bgra_sse2_lowp
.globl _sk_gather_bgra_sse2_lowp
FUNCTION(_sk_gather_bgra_sse2_lowp)
_sk_gather_bgra_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          c4a8 <_sk_gather_bgra_sse2_lowp+0xd>
  .byte  90                                  // pop           %edx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  243,15,16,103,8                     // movss         0x8(%edi),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  102,15,118,237                      // pcmpeqd       %xmm5,%xmm5
  .byte  102,15,254,229                      // paddd         %xmm5,%xmm4
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,95,198                           // maxps         %xmm6,%xmm0
  .byte  15,95,206                           // maxps         %xmm6,%xmm1
  .byte  15,93,204                           // minps         %xmm4,%xmm1
  .byte  15,93,196                           // minps         %xmm4,%xmm0
  .byte  243,15,16,103,12                    // movss         0xc(%edi),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  102,15,254,229                      // paddd         %xmm5,%xmm4
  .byte  15,95,222                           // maxps         %xmm6,%xmm3
  .byte  15,95,214                           // maxps         %xmm6,%xmm2
  .byte  15,93,212                           // minps         %xmm4,%xmm2
  .byte  15,93,220                           // minps         %xmm4,%xmm3
  .byte  139,55                              // mov           (%edi),%esi
  .byte  243,15,91,219                       // cvttps2dq     %xmm3,%xmm3
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  102,15,110,103,4                    // movd          0x4(%edi),%xmm4
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  102,15,112,234,245                  // pshufd        $0xf5,%xmm2,%xmm5
  .byte  102,15,244,236                      // pmuludq       %xmm4,%xmm5
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,112,251,245                  // pshufd        $0xf5,%xmm3,%xmm7
  .byte  102,15,244,252                      // pmuludq       %xmm4,%xmm7
  .byte  102,15,244,226                      // pmuludq       %xmm2,%xmm4
  .byte  102,15,112,212,232                  // pshufd        $0xe8,%xmm4,%xmm2
  .byte  102,15,112,229,232                  // pshufd        $0xe8,%xmm5,%xmm4
  .byte  102,15,98,212                       // punpckldq     %xmm4,%xmm2
  .byte  102,15,244,243                      // pmuludq       %xmm3,%xmm6
  .byte  102,15,112,222,232                  // pshufd        $0xe8,%xmm6,%xmm3
  .byte  102,15,112,231,232                  // pshufd        $0xe8,%xmm7,%xmm4
  .byte  102,15,98,220                       // punpckldq     %xmm4,%xmm3
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,194                      // paddd         %xmm2,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,15,254,203                      // paddd         %xmm3,%xmm1
  .byte  102,15,112,208,78                   // pshufd        $0x4e,%xmm0,%xmm2
  .byte  102,15,112,216,231                  // pshufd        $0xe7,%xmm0,%xmm3
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  102,15,110,36,190                   // movd          (%esi,%edi,4),%xmm4
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  102,15,110,52,190                   // movd          (%esi,%edi,4),%xmm6
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,192,229                  // pshufd        $0xe5,%xmm0,%xmm0
  .byte  102,15,110,28,190                   // movd          (%esi,%edi,4),%xmm3
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,193,78                   // pshufd        $0x4e,%xmm1,%xmm0
  .byte  102,15,112,209,231                  // pshufd        $0xe7,%xmm1,%xmm2
  .byte  102,15,110,44,190                   // movd          (%esi,%edi,4),%xmm5
  .byte  102,15,126,215                      // movd          %xmm2,%edi
  .byte  102,15,110,60,190                   // movd          (%esi,%edi,4),%xmm7
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,110,4,190                    // movd          (%esi,%edi,4),%xmm0
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,201,229                  // pshufd        $0xe5,%xmm1,%xmm1
  .byte  102,15,110,20,190                   // movd          (%esi,%edi,4),%xmm2
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,110,12,190                   // movd          (%esi,%edi,4),%xmm1
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  102,15,98,244                       // punpckldq     %xmm4,%xmm6
  .byte  102,15,98,221                       // punpckldq     %xmm5,%xmm3
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  102,15,108,222                      // punpcklqdq    %xmm6,%xmm3
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  102,15,98,199                       // punpckldq     %xmm7,%xmm0
  .byte  102,15,98,209                       // punpckldq     %xmm1,%xmm2
  .byte  102,15,108,208                      // punpcklqdq    %xmm0,%xmm2
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,114,241,16                   // pslld         $0x10,%xmm1
  .byte  102,15,114,225,16                   // psrad         $0x10,%xmm1
  .byte  102,15,107,200                      // packssdw      %xmm0,%xmm1
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,111,250                      // movdqa        %xmm2,%xmm7
  .byte  102,15,114,210,24                   // psrld         $0x18,%xmm2
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,114,226,16                   // psrad         $0x10,%xmm2
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  102,15,114,227,16                   // psrad         $0x10,%xmm3
  .byte  102,15,107,218                      // packssdw      %xmm2,%xmm3
  .byte  102,15,111,162,88,61,0,0            // movdqa        0x3d58(%edx),%xmm4
  .byte  102,15,114,208,16                   // psrld         $0x10,%xmm0
  .byte  102,15,114,215,16                   // psrld         $0x10,%xmm7
  .byte  102,15,114,247,16                   // pslld         $0x10,%xmm7
  .byte  102,15,114,231,16                   // psrad         $0x10,%xmm7
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,107,199                      // packssdw      %xmm7,%xmm0
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,15,219,212                      // pand          %xmm4,%xmm2
  .byte  102,15,219,196                      // pand          %xmm4,%xmm0
  .byte  15,40,101,72                        // movaps        0x48(%ebp),%xmm4
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  141,81,8                            // lea           0x8(%ecx),%edx
  .byte  15,41,100,36,64                     // movaps        %xmm4,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,84,36,4                         // mov           %edx,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_load_565_sse2_lowp
.globl _sk_load_565_sse2_lowp
FUNCTION(_sk_load_565_sse2_lowp)
_sk_load_565_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  15,40,117,72                        // movaps        0x48(%ebp),%xmm6
  .byte  15,40,109,56                        // movaps        0x38(%ebp),%xmm5
  .byte  15,40,101,40                        // movaps        0x28(%ebp),%xmm4
  .byte  15,40,93,24                         // movaps        0x18(%ebp),%xmm3
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  1,219                               // add           %ebx,%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          c6cc <_sk_load_565_sse2_lowp+0x3b>
  .byte  94                                  // pop           %esi
  .byte  139,125,16                          // mov           0x10(%ebp),%edi
  .byte  119,28                              // ja            c6ee <_sk_load_565_sse2_lowp+0x5d>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,142,244,0,0,0               // mov           0xf4(%esi,%ecx,4),%ecx
  .byte  1,241                               // add           %esi,%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  15,183,12,123                       // movzwl        (%ebx,%edi,2),%ecx
  .byte  102,15,110,193                      // movd          %ecx,%xmm0
  .byte  235,59                              // jmp           c729 <_sk_load_565_sse2_lowp+0x98>
  .byte  243,15,111,4,123                    // movdqu        (%ebx,%edi,2),%xmm0
  .byte  235,52                              // jmp           c729 <_sk_load_565_sse2_lowp+0x98>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,196,68,123,4,2               // pinsrw        $0x2,0x4(%ebx,%edi,2),%xmm0
  .byte  243,15,16,12,123                    // movss         (%ebx,%edi,2),%xmm1
  .byte  243,15,16,193                       // movss         %xmm1,%xmm0
  .byte  235,30                              // jmp           c729 <_sk_load_565_sse2_lowp+0x98>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,196,68,123,12,6              // pinsrw        $0x6,0xc(%ebx,%edi,2),%xmm0
  .byte  102,15,196,68,123,10,5              // pinsrw        $0x5,0xa(%ebx,%edi,2),%xmm0
  .byte  102,15,196,68,123,8,4               // pinsrw        $0x4,0x8(%ebx,%edi,2),%xmm0
  .byte  102,15,18,4,123                     // movlpd        (%ebx,%edi,2),%xmm0
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  102,15,113,215,8                    // psrlw         $0x8,%xmm7
  .byte  102,15,219,190,116,59,0,0           // pand          0x3b74(%esi),%xmm7
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,113,209,5                    // psrlw         $0x5,%xmm1
  .byte  102,15,219,142,132,59,0,0           // pand          0x3b84(%esi),%xmm1
  .byte  102,15,111,150,148,59,0,0           // movdqa        0x3b94(%esi),%xmm2
  .byte  102,15,219,208                      // pand          %xmm0,%xmm2
  .byte  102,15,113,208,13                   // psrlw         $0xd,%xmm0
  .byte  102,15,235,199                      // por           %xmm7,%xmm0
  .byte  102,15,111,249                      // movdqa        %xmm1,%xmm7
  .byte  102,15,113,247,2                    // psllw         $0x2,%xmm7
  .byte  102,15,113,209,4                    // psrlw         $0x4,%xmm1
  .byte  102,15,235,207                      // por           %xmm7,%xmm1
  .byte  102,15,111,250                      // movdqa        %xmm2,%xmm7
  .byte  102,15,113,247,3                    // psllw         $0x3,%xmm7
  .byte  102,15,113,210,2                    // psrlw         $0x2,%xmm2
  .byte  102,15,235,215                      // por           %xmm7,%xmm2
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,41,116,36,64                     // movaps        %xmm6,0x40(%esp)
  .byte  15,41,108,36,48                     // movaps        %xmm5,0x30(%esp)
  .byte  15,41,100,36,32                     // movaps        %xmm4,0x20(%esp)
  .byte  15,41,92,36,16                      // movaps        %xmm3,0x10(%esp)
  .byte  139,93,20                           // mov           0x14(%ebp),%ebx
  .byte  137,92,36,12                        // mov           %ebx,0xc(%esp)
  .byte  137,124,36,8                        // mov           %edi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  15,40,158,52,59,0,0                 // movaps        0x3b34(%esi),%xmm3
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  144                                 // nop
  .byte  24,0                                // sbb           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  52,0                                // xor           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  41,0                                // sub           %eax,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  88                                  // pop           %eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,81,0                              // add           %dl,0x0(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  74                                  // dec           %edx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_load_565_dst_sse2_lowp
.globl _sk_load_565_dst_sse2_lowp
FUNCTION(_sk_load_565_dst_sse2_lowp)
_sk_load_565_dst_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  1,219                               // add           %ebx,%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          c807 <_sk_load_565_dst_sse2_lowp+0x2b>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,28                              // ja            c829 <_sk_load_565_dst_sse2_lowp+0x4d>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,249,0,0,0               // mov           0xf9(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  15,183,12,115                       // movzwl        (%ebx,%esi,2),%ecx
  .byte  102,15,110,225                      // movd          %ecx,%xmm4
  .byte  235,59                              // jmp           c864 <_sk_load_565_dst_sse2_lowp+0x88>
  .byte  243,15,111,36,115                   // movdqu        (%ebx,%esi,2),%xmm4
  .byte  235,52                              // jmp           c864 <_sk_load_565_dst_sse2_lowp+0x88>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,100,115,4,2              // pinsrw        $0x2,0x4(%ebx,%esi,2),%xmm4
  .byte  243,15,16,44,115                    // movss         (%ebx,%esi,2),%xmm5
  .byte  243,15,16,229                       // movss         %xmm5,%xmm4
  .byte  235,30                              // jmp           c864 <_sk_load_565_dst_sse2_lowp+0x88>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,100,115,12,6             // pinsrw        $0x6,0xc(%ebx,%esi,2),%xmm4
  .byte  102,15,196,100,115,10,5             // pinsrw        $0x5,0xa(%ebx,%esi,2),%xmm4
  .byte  102,15,196,100,115,8,4              // pinsrw        $0x4,0x8(%ebx,%esi,2),%xmm4
  .byte  102,15,18,36,115                    // movlpd        (%ebx,%esi,2),%xmm4
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,113,214,8                    // psrlw         $0x8,%xmm6
  .byte  102,15,219,183,57,58,0,0            // pand          0x3a39(%edi),%xmm6
  .byte  102,15,111,236                      // movdqa        %xmm4,%xmm5
  .byte  102,15,113,213,5                    // psrlw         $0x5,%xmm5
  .byte  102,15,219,175,73,58,0,0            // pand          0x3a49(%edi),%xmm5
  .byte  102,15,111,191,89,58,0,0            // movdqa        0x3a59(%edi),%xmm7
  .byte  102,15,219,252                      // pand          %xmm4,%xmm7
  .byte  102,15,113,212,13                   // psrlw         $0xd,%xmm4
  .byte  102,15,235,230                      // por           %xmm6,%xmm4
  .byte  102,15,111,245                      // movdqa        %xmm5,%xmm6
  .byte  102,15,113,246,2                    // psllw         $0x2,%xmm6
  .byte  102,15,113,213,4                    // psrlw         $0x4,%xmm5
  .byte  102,15,235,238                      // por           %xmm6,%xmm5
  .byte  102,15,111,247                      // movdqa        %xmm7,%xmm6
  .byte  102,15,113,246,3                    // psllw         $0x3,%xmm6
  .byte  102,15,113,215,2                    // psrlw         $0x2,%xmm7
  .byte  102,15,235,254                      // por           %xmm6,%xmm7
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,40,183,249,57,0,0                // movaps        0x39f9(%edi),%xmm6
  .byte  15,41,116,36,64                     // movaps        %xmm6,0x40(%esp)
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  102,15,127,124,36,48                // movdqa        %xmm7,0x30(%esp)
  .byte  102,15,127,100,36,16                // movdqa        %xmm4,0x10(%esp)
  .byte  102,15,127,108,36,32                // movdqa        %xmm5,0x20(%esp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  15,31,0                             // nopl          (%eax)
  .byte  24,0                                // sbb           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  52,0                                // xor           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  41,0                                // sub           %eax,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  88                                  // pop           %eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,81,0                              // add           %dl,0x0(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  74                                  // dec           %edx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_store_565_sse2_lowp
.globl _sk_store_565_sse2_lowp
FUNCTION(_sk_store_565_sse2_lowp)
_sk_store_565_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  102,15,111,226                      // movdqa        %xmm2,%xmm4
  .byte  232,0,0,0,0                         // call          c92e <_sk_store_565_sse2_lowp+0x12>
  .byte  95                                  // pop           %edi
  .byte  15,40,109,72                        // movaps        0x48(%ebp),%xmm5
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  102,15,113,242,8                    // psllw         $0x8,%xmm2
  .byte  102,15,219,151,66,57,0,0            // pand          0x3942(%edi),%xmm2
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,113,246,3                    // psllw         $0x3,%xmm6
  .byte  102,15,219,183,82,57,0,0            // pand          0x3952(%edi),%xmm6
  .byte  102,15,235,242                      // por           %xmm2,%xmm6
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  102,15,113,210,3                    // psrlw         $0x3,%xmm2
  .byte  102,15,235,214                      // por           %xmm6,%xmm2
  .byte  15,40,117,40                        // movaps        0x28(%ebp),%xmm6
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  1,219                               // add           %ebx,%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  15,40,125,24                        // movaps        0x18(%ebp),%xmm7
  .byte  119,22                              // ja            c9a6 <_sk_store_565_sse2_lowp+0x8a>
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  3,188,143,242,0,0,0                 // add           0xf2(%edi,%ecx,4),%edi
  .byte  255,231                             // jmp           *%edi
  .byte  102,15,126,209                      // movd          %xmm2,%ecx
  .byte  102,137,12,115                      // mov           %cx,(%ebx,%esi,2)
  .byte  235,59                              // jmp           c9e1 <_sk_store_565_sse2_lowp+0xc5>
  .byte  243,15,127,20,115                   // movdqu        %xmm2,(%ebx,%esi,2)
  .byte  235,52                              // jmp           c9e1 <_sk_store_565_sse2_lowp+0xc5>
  .byte  102,15,197,202,2                    // pextrw        $0x2,%xmm2,%ecx
  .byte  102,137,76,115,4                    // mov           %cx,0x4(%ebx,%esi,2)
  .byte  102,15,126,20,115                   // movd          %xmm2,(%ebx,%esi,2)
  .byte  235,35                              // jmp           c9e1 <_sk_store_565_sse2_lowp+0xc5>
  .byte  102,15,197,202,6                    // pextrw        $0x6,%xmm2,%ecx
  .byte  102,137,76,115,12                   // mov           %cx,0xc(%ebx,%esi,2)
  .byte  102,15,197,202,5                    // pextrw        $0x5,%xmm2,%ecx
  .byte  102,137,76,115,10                   // mov           %cx,0xa(%ebx,%esi,2)
  .byte  102,15,197,202,4                    // pextrw        $0x4,%xmm2,%ecx
  .byte  102,137,76,115,8                    // mov           %cx,0x8(%ebx,%esi,2)
  .byte  102,15,214,20,115                   // movq          %xmm2,(%ebx,%esi,2)
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,41,108,36,64                     // movaps        %xmm5,0x40(%esp)
  .byte  15,40,85,56                         // movaps        0x38(%ebp),%xmm2
  .byte  15,41,84,36,48                      // movaps        %xmm2,0x30(%esp)
  .byte  15,41,116,36,32                     // movaps        %xmm6,0x20(%esp)
  .byte  15,41,124,36,16                     // movaps        %xmm7,0x10(%esp)
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  15,31,0                             // nopl          (%eax)
  .byte  110                                 // outsb         %ds:(%esi),(%dx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,137,0,0,0,127                     // add           %cl,0x7f000000(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,174,0,0,0,164                     // add           %ch,-0x5c000000(%esi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,154,0,0,0,144                     // add           %bl,-0x70000000(%edx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_gather_565_sse2_lowp
.globl _sk_gather_565_sse2_lowp
FUNCTION(_sk_gather_565_sse2_lowp)
_sk_gather_565_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,108                         // sub           $0x6c,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,16                              // mov           (%eax),%edx
  .byte  243,15,16,98,8                      // movss         0x8(%edx),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  102,15,118,237                      // pcmpeqd       %xmm5,%xmm5
  .byte  102,15,254,229                      // paddd         %xmm5,%xmm4
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,95,198                           // maxps         %xmm6,%xmm0
  .byte  15,95,206                           // maxps         %xmm6,%xmm1
  .byte  15,93,204                           // minps         %xmm4,%xmm1
  .byte  15,93,196                           // minps         %xmm4,%xmm0
  .byte  243,15,16,98,12                     // movss         0xc(%edx),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  102,15,254,229                      // paddd         %xmm5,%xmm4
  .byte  15,95,222                           // maxps         %xmm6,%xmm3
  .byte  15,95,214                           // maxps         %xmm6,%xmm2
  .byte  15,93,212                           // minps         %xmm4,%xmm2
  .byte  15,93,220                           // minps         %xmm4,%xmm3
  .byte  243,15,91,219                       // cvttps2dq     %xmm3,%xmm3
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  102,15,110,98,4                     // movd          0x4(%edx),%xmm4
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  102,15,112,234,245                  // pshufd        $0xf5,%xmm2,%xmm5
  .byte  102,15,244,236                      // pmuludq       %xmm4,%xmm5
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,244,242                      // pmuludq       %xmm2,%xmm6
  .byte  102,15,112,211,245                  // pshufd        $0xf5,%xmm3,%xmm2
  .byte  102,15,244,212                      // pmuludq       %xmm4,%xmm2
  .byte  232,0,0,0,0                         // call          cab4 <_sk_gather_565_sse2_lowp+0x78>
  .byte  89                                  // pop           %ecx
  .byte  139,50                              // mov           (%edx),%esi
  .byte  102,15,112,246,232                  // pshufd        $0xe8,%xmm6,%xmm6
  .byte  102,15,112,237,232                  // pshufd        $0xe8,%xmm5,%xmm5
  .byte  102,15,98,245                       // punpckldq     %xmm5,%xmm6
  .byte  102,15,244,227                      // pmuludq       %xmm3,%xmm4
  .byte  102,15,112,220,232                  // pshufd        $0xe8,%xmm4,%xmm3
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,98,218                       // punpckldq     %xmm2,%xmm3
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,198                      // paddd         %xmm6,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,15,254,203                      // paddd         %xmm3,%xmm1
  .byte  102,15,126,194                      // movd          %xmm0,%edx
  .byte  102,15,112,208,229                  // pshufd        $0xe5,%xmm0,%xmm2
  .byte  102,15,127,85,216                   // movdqa        %xmm2,-0x28(%ebp)
  .byte  102,15,112,216,78                   // pshufd        $0x4e,%xmm0,%xmm3
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,112,225,78                   // pshufd        $0x4e,%xmm1,%xmm4
  .byte  102,15,112,233,231                  // pshufd        $0xe7,%xmm1,%xmm5
  .byte  102,15,126,239                      // movd          %xmm5,%edi
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  102,15,110,239                      // movd          %edi,%xmm5
  .byte  102,15,126,231                      // movd          %xmm4,%edi
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  102,15,110,231                      // movd          %edi,%xmm4
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,201,229                  // pshufd        $0xe5,%xmm1,%xmm1
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  102,15,110,247                      // movd          %edi,%xmm6
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  102,15,110,215                      // movd          %edi,%xmm2
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  102,15,110,255                      // movd          %edi,%xmm7
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  102,15,110,207                      // movd          %edi,%xmm1
  .byte  102,15,111,69,216                   // movdqa        -0x28(%ebp),%xmm0
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  15,183,20,86                        // movzwl        (%esi,%edx,2),%edx
  .byte  102,15,110,194                      // movd          %edx,%xmm0
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  102,15,97,229                       // punpcklwd     %xmm5,%xmm4
  .byte  102,15,110,239                      // movd          %edi,%xmm5
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  102,15,97,242                       // punpcklwd     %xmm2,%xmm6
  .byte  15,40,93,24                         // movaps        0x18(%ebp),%xmm3
  .byte  102,15,98,244                       // punpckldq     %xmm4,%xmm6
  .byte  15,40,101,40                        // movaps        0x28(%ebp),%xmm4
  .byte  102,15,97,207                       // punpcklwd     %xmm7,%xmm1
  .byte  15,40,125,56                        // movaps        0x38(%ebp),%xmm7
  .byte  102,15,97,197                       // punpcklwd     %xmm5,%xmm0
  .byte  102,15,98,193                       // punpckldq     %xmm1,%xmm0
  .byte  102,15,108,198                      // punpcklqdq    %xmm6,%xmm0
  .byte  102,15,111,232                      // movdqa        %xmm0,%xmm5
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,15,219,169,140,55,0,0           // pand          0x378c(%ecx),%xmm5
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,113,209,5                    // psrlw         $0x5,%xmm1
  .byte  102,15,219,137,156,55,0,0           // pand          0x379c(%ecx),%xmm1
  .byte  102,15,111,145,172,55,0,0           // movdqa        0x37ac(%ecx),%xmm2
  .byte  102,15,219,208                      // pand          %xmm0,%xmm2
  .byte  102,15,113,208,13                   // psrlw         $0xd,%xmm0
  .byte  102,15,235,197                      // por           %xmm5,%xmm0
  .byte  102,15,111,233                      // movdqa        %xmm1,%xmm5
  .byte  102,15,113,245,2                    // psllw         $0x2,%xmm5
  .byte  102,15,113,209,4                    // psrlw         $0x4,%xmm1
  .byte  102,15,235,205                      // por           %xmm5,%xmm1
  .byte  102,15,111,234                      // movdqa        %xmm2,%xmm5
  .byte  102,15,113,245,3                    // psllw         $0x3,%xmm5
  .byte  102,15,113,210,2                    // psrlw         $0x2,%xmm2
  .byte  102,15,235,213                      // por           %xmm5,%xmm2
  .byte  15,40,109,72                        // movaps        0x48(%ebp),%xmm5
  .byte  141,88,8                            // lea           0x8(%eax),%ebx
  .byte  15,41,108,36,64                     // movaps        %xmm5,0x40(%esp)
  .byte  15,41,124,36,48                     // movaps        %xmm7,0x30(%esp)
  .byte  15,41,100,36,32                     // movaps        %xmm4,0x20(%esp)
  .byte  15,41,92,36,16                      // movaps        %xmm3,0x10(%esp)
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,92,36,4                         // mov           %ebx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  15,40,153,76,55,0,0                 // movaps        0x374c(%ecx),%xmm3
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,108                         // add           $0x6c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_load_4444_sse2_lowp
.globl _sk_load_4444_sse2_lowp
FUNCTION(_sk_load_4444_sse2_lowp)
_sk_load_4444_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  1,219                               // add           %ebx,%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          cc6e <_sk_load_4444_sse2_lowp+0x37>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,28                              // ja            cc90 <_sk_load_4444_sse2_lowp+0x59>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,250,0,0,0               // mov           0xfa(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  15,183,12,115                       // movzwl        (%ebx,%esi,2),%ecx
  .byte  102,15,110,225                      // movd          %ecx,%xmm4
  .byte  235,59                              // jmp           cccb <_sk_load_4444_sse2_lowp+0x94>
  .byte  243,15,111,36,115                   // movdqu        (%ebx,%esi,2),%xmm4
  .byte  235,52                              // jmp           cccb <_sk_load_4444_sse2_lowp+0x94>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,100,115,4,2              // pinsrw        $0x2,0x4(%ebx,%esi,2),%xmm4
  .byte  243,15,16,4,115                     // movss         (%ebx,%esi,2),%xmm0
  .byte  243,15,16,224                       // movss         %xmm0,%xmm4
  .byte  235,30                              // jmp           cccb <_sk_load_4444_sse2_lowp+0x94>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,100,115,12,6             // pinsrw        $0x6,0xc(%ebx,%esi,2),%xmm4
  .byte  102,15,196,100,115,10,5             // pinsrw        $0x5,0xa(%ebx,%esi,2),%xmm4
  .byte  102,15,196,100,115,8,4              // pinsrw        $0x4,0x8(%ebx,%esi,2),%xmm4
  .byte  102,15,18,36,115                    // movlpd        (%ebx,%esi,2),%xmm4
  .byte  102,15,111,204                      // movdqa        %xmm4,%xmm1
  .byte  102,15,113,209,12                   // psrlw         $0xc,%xmm1
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,111,135,34,54,0,0            // movdqa        0x3622(%edi),%xmm0
  .byte  102,15,219,208                      // pand          %xmm0,%xmm2
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  102,15,113,211,4                    // psrlw         $0x4,%xmm3
  .byte  102,15,219,216                      // pand          %xmm0,%xmm3
  .byte  102,15,219,224                      // pand          %xmm0,%xmm4
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,113,240,4                    // psllw         $0x4,%xmm0
  .byte  102,15,235,193                      // por           %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,113,241,4                    // psllw         $0x4,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,113,242,4                    // psllw         $0x4,%xmm2
  .byte  102,15,235,211                      // por           %xmm3,%xmm2
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  102,15,113,243,4                    // psllw         $0x4,%xmm3
  .byte  102,15,235,220                      // por           %xmm4,%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,41,124,36,64                     // movaps        %xmm7,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  102,144                             // xchg          %ax,%ax
  .byte  24,0                                // sbb           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  52,0                                // xor           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  41,0                                // sub           %eax,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  88                                  // pop           %eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,81,0                              // add           %dl,0x0(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  74                                  // dec           %edx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_load_4444_dst_sse2_lowp
.globl _sk_load_4444_dst_sse2_lowp
FUNCTION(_sk_load_4444_dst_sse2_lowp)
_sk_load_4444_dst_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,108                         // sub           $0x6c,%esp
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  1,219                               // add           %ebx,%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          cdb3 <_sk_load_4444_dst_sse2_lowp+0x2f>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,28                              // ja            cdd5 <_sk_load_4444_dst_sse2_lowp+0x51>
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,253,0,0,0               // mov           0xfd(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  15,183,12,115                       // movzwl        (%ebx,%esi,2),%ecx
  .byte  102,15,110,249                      // movd          %ecx,%xmm7
  .byte  235,59                              // jmp           ce10 <_sk_load_4444_dst_sse2_lowp+0x8c>
  .byte  243,15,111,60,115                   // movdqu        (%ebx,%esi,2),%xmm7
  .byte  235,52                              // jmp           ce10 <_sk_load_4444_dst_sse2_lowp+0x8c>
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  102,15,196,124,115,4,2              // pinsrw        $0x2,0x4(%ebx,%esi,2),%xmm7
  .byte  243,15,16,44,115                    // movss         (%ebx,%esi,2),%xmm5
  .byte  243,15,16,253                       // movss         %xmm5,%xmm7
  .byte  235,30                              // jmp           ce10 <_sk_load_4444_dst_sse2_lowp+0x8c>
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  102,15,196,124,115,12,6             // pinsrw        $0x6,0xc(%ebx,%esi,2),%xmm7
  .byte  102,15,196,124,115,10,5             // pinsrw        $0x5,0xa(%ebx,%esi,2),%xmm7
  .byte  102,15,196,124,115,8,4              // pinsrw        $0x4,0x8(%ebx,%esi,2),%xmm7
  .byte  102,15,18,60,115                    // movlpd        (%ebx,%esi,2),%xmm7
  .byte  102,15,111,239                      // movdqa        %xmm7,%xmm5
  .byte  102,15,113,213,12                   // psrlw         $0xc,%xmm5
  .byte  102,15,111,247                      // movdqa        %xmm7,%xmm6
  .byte  102,15,113,214,8                    // psrlw         $0x8,%xmm6
  .byte  102,15,111,159,221,52,0,0           // movdqa        0x34dd(%edi),%xmm3
  .byte  102,15,219,243                      // pand          %xmm3,%xmm6
  .byte  102,15,111,231                      // movdqa        %xmm7,%xmm4
  .byte  102,15,113,212,4                    // psrlw         $0x4,%xmm4
  .byte  102,15,219,227                      // pand          %xmm3,%xmm4
  .byte  102,15,219,251                      // pand          %xmm3,%xmm7
  .byte  102,15,111,221                      // movdqa        %xmm5,%xmm3
  .byte  102,15,113,243,4                    // psllw         $0x4,%xmm3
  .byte  102,15,235,221                      // por           %xmm5,%xmm3
  .byte  102,15,111,238                      // movdqa        %xmm6,%xmm5
  .byte  102,15,113,245,4                    // psllw         $0x4,%xmm5
  .byte  102,15,235,238                      // por           %xmm6,%xmm5
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,113,246,4                    // psllw         $0x4,%xmm6
  .byte  102,15,235,244                      // por           %xmm4,%xmm6
  .byte  102,15,111,231                      // movdqa        %xmm7,%xmm4
  .byte  102,15,113,244,4                    // psllw         $0x4,%xmm4
  .byte  102,15,235,231                      // por           %xmm7,%xmm4
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  102,15,127,100,36,64                // movdqa        %xmm4,0x40(%esp)
  .byte  102,15,127,92,36,16                 // movdqa        %xmm3,0x10(%esp)
  .byte  102,15,127,116,36,48                // movdqa        %xmm6,0x30(%esp)
  .byte  102,15,127,108,36,32                // movdqa        %xmm5,0x20(%esp)
  .byte  15,40,93,216                        // movaps        -0x28(%ebp),%xmm3
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,108                         // add           $0x6c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  144                                 // nop
  .byte  24,0                                // sbb           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  52,0                                // xor           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  41,0                                // sub           %eax,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  88                                  // pop           %eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,81,0                              // add           %dl,0x0(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  74                                  // dec           %edx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_store_4444_sse2_lowp
.globl _sk_store_4444_sse2_lowp
FUNCTION(_sk_store_4444_sse2_lowp)
_sk_store_4444_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  102,15,111,227                      // movdqa        %xmm3,%xmm4
  .byte  232,0,0,0,0                         // call          cede <_sk_store_4444_sse2_lowp+0x12>
  .byte  94                                  // pop           %esi
  .byte  102,15,111,216                      // movdqa        %xmm0,%xmm3
  .byte  102,15,113,243,8                    // psllw         $0x8,%xmm3
  .byte  102,15,219,158,194,51,0,0           // pand          0x33c2(%esi),%xmm3
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,113,246,4                    // psllw         $0x4,%xmm6
  .byte  102,15,219,182,210,51,0,0           // pand          0x33d2(%esi),%xmm6
  .byte  102,15,235,243                      // por           %xmm3,%xmm6
  .byte  102,15,111,174,226,51,0,0           // movdqa        0x33e2(%esi),%xmm5
  .byte  102,15,219,234                      // pand          %xmm2,%xmm5
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  102,15,113,211,4                    // psrlw         $0x4,%xmm3
  .byte  102,15,235,221                      // por           %xmm5,%xmm3
  .byte  15,40,109,56                        // movaps        0x38(%ebp),%xmm5
  .byte  102,15,235,222                      // por           %xmm6,%xmm3
  .byte  15,40,117,40                        // movaps        0x28(%ebp),%xmm6
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  1,219                               // add           %ebx,%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  139,125,16                          // mov           0x10(%ebp),%edi
  .byte  15,40,125,24                        // movaps        0x18(%ebp),%xmm7
  .byte  119,22                              // ja            cf66 <_sk_store_4444_sse2_lowp+0x9a>
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  3,180,142,2,1,0,0                   // add           0x102(%esi,%ecx,4),%esi
  .byte  255,230                             // jmp           *%esi
  .byte  102,15,126,217                      // movd          %xmm3,%ecx
  .byte  102,137,12,123                      // mov           %cx,(%ebx,%edi,2)
  .byte  235,59                              // jmp           cfa1 <_sk_store_4444_sse2_lowp+0xd5>
  .byte  243,15,127,28,123                   // movdqu        %xmm3,(%ebx,%edi,2)
  .byte  235,52                              // jmp           cfa1 <_sk_store_4444_sse2_lowp+0xd5>
  .byte  102,15,197,203,2                    // pextrw        $0x2,%xmm3,%ecx
  .byte  102,137,76,123,4                    // mov           %cx,0x4(%ebx,%edi,2)
  .byte  102,15,126,28,123                   // movd          %xmm3,(%ebx,%edi,2)
  .byte  235,35                              // jmp           cfa1 <_sk_store_4444_sse2_lowp+0xd5>
  .byte  102,15,197,203,6                    // pextrw        $0x6,%xmm3,%ecx
  .byte  102,137,76,123,12                   // mov           %cx,0xc(%ebx,%edi,2)
  .byte  102,15,197,203,5                    // pextrw        $0x5,%xmm3,%ecx
  .byte  102,137,76,123,10                   // mov           %cx,0xa(%ebx,%edi,2)
  .byte  102,15,197,203,4                    // pextrw        $0x4,%xmm3,%ecx
  .byte  102,137,76,123,8                    // mov           %cx,0x8(%ebx,%edi,2)
  .byte  102,15,214,28,123                   // movq          %xmm3,(%ebx,%edi,2)
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,40,93,72                         // movaps        0x48(%ebp),%xmm3
  .byte  15,41,92,36,64                      // movaps        %xmm3,0x40(%esp)
  .byte  15,41,108,36,48                     // movaps        %xmm5,0x30(%esp)
  .byte  15,41,116,36,32                     // movaps        %xmm6,0x20(%esp)
  .byte  15,41,124,36,16                     // movaps        %xmm7,0x10(%esp)
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,124,36,8                        // mov           %edi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  15,31,0                             // nopl          (%eax)
  .byte  126,0                               // jle           cfe2 <_sk_store_4444_sse2_lowp+0x116>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  153                                 // cltd
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,143,0,0,0,190                     // add           %cl,-0x42000000(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,180,0,0,0,170,0                   // add           %dh,0xaa0000(%eax,%eax,1)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  160                                 // .byte         0xa0
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_gather_4444_sse2_lowp
.globl _sk_gather_4444_sse2_lowp
FUNCTION(_sk_gather_4444_sse2_lowp)
_sk_gather_4444_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          d009 <_sk_gather_4444_sse2_lowp+0xd>
  .byte  90                                  // pop           %edx
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  243,15,16,103,8                     // movss         0x8(%edi),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  102,15,118,237                      // pcmpeqd       %xmm5,%xmm5
  .byte  102,15,254,229                      // paddd         %xmm5,%xmm4
  .byte  15,87,246                           // xorps         %xmm6,%xmm6
  .byte  15,95,198                           // maxps         %xmm6,%xmm0
  .byte  15,95,206                           // maxps         %xmm6,%xmm1
  .byte  15,93,204                           // minps         %xmm4,%xmm1
  .byte  15,93,196                           // minps         %xmm4,%xmm0
  .byte  243,15,16,103,12                    // movss         0xc(%edi),%xmm4
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  102,15,254,229                      // paddd         %xmm5,%xmm4
  .byte  15,95,222                           // maxps         %xmm6,%xmm3
  .byte  15,95,214                           // maxps         %xmm6,%xmm2
  .byte  15,93,212                           // minps         %xmm4,%xmm2
  .byte  15,93,220                           // minps         %xmm4,%xmm3
  .byte  139,55                              // mov           (%edi),%esi
  .byte  243,15,91,219                       // cvttps2dq     %xmm3,%xmm3
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  102,15,110,103,4                    // movd          0x4(%edi),%xmm4
  .byte  102,15,112,228,0                    // pshufd        $0x0,%xmm4,%xmm4
  .byte  102,15,112,234,245                  // pshufd        $0xf5,%xmm2,%xmm5
  .byte  102,15,244,236                      // pmuludq       %xmm4,%xmm5
  .byte  102,15,111,244                      // movdqa        %xmm4,%xmm6
  .byte  102,15,112,251,245                  // pshufd        $0xf5,%xmm3,%xmm7
  .byte  102,15,244,252                      // pmuludq       %xmm4,%xmm7
  .byte  102,15,244,226                      // pmuludq       %xmm2,%xmm4
  .byte  102,15,112,212,232                  // pshufd        $0xe8,%xmm4,%xmm2
  .byte  102,15,112,229,232                  // pshufd        $0xe8,%xmm5,%xmm4
  .byte  102,15,98,212                       // punpckldq     %xmm4,%xmm2
  .byte  102,15,244,243                      // pmuludq       %xmm3,%xmm6
  .byte  102,15,112,222,232                  // pshufd        $0xe8,%xmm6,%xmm3
  .byte  102,15,112,231,232                  // pshufd        $0xe8,%xmm7,%xmm4
  .byte  102,15,98,220                       // punpckldq     %xmm4,%xmm3
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,194                      // paddd         %xmm2,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,15,254,203                      // paddd         %xmm3,%xmm1
  .byte  102,15,112,248,78                   // pshufd        $0x4e,%xmm0,%xmm7
  .byte  102,15,112,216,231                  // pshufd        $0xe7,%xmm0,%xmm3
  .byte  102,15,112,225,78                   // pshufd        $0x4e,%xmm1,%xmm4
  .byte  102,15,112,233,231                  // pshufd        $0xe7,%xmm1,%xmm5
  .byte  102,15,126,239                      // movd          %xmm5,%edi
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  102,15,110,239                      // movd          %edi,%xmm5
  .byte  102,15,126,231                      // movd          %xmm4,%edi
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  102,15,110,247                      // movd          %edi,%xmm6
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  102,15,112,201,229                  // pshufd        $0xe5,%xmm1,%xmm1
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  102,15,110,215                      // movd          %edi,%xmm2
  .byte  102,15,126,207                      // movd          %xmm1,%edi
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  102,15,110,231                      // movd          %edi,%xmm4
  .byte  102,15,126,223                      // movd          %xmm3,%edi
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  102,15,110,223                      // movd          %edi,%xmm3
  .byte  102,15,126,255                      // movd          %xmm7,%edi
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  102,15,110,207                      // movd          %edi,%xmm1
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,192,229                  // pshufd        $0xe5,%xmm0,%xmm0
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  102,15,110,255                      // movd          %edi,%xmm7
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  15,183,60,126                       // movzwl        (%esi,%edi,2),%edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  102,15,110,199                      // movd          %edi,%xmm0
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  102,15,97,245                       // punpcklwd     %xmm5,%xmm6
  .byte  102,15,97,212                       // punpcklwd     %xmm4,%xmm2
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  102,15,98,214                       // punpckldq     %xmm6,%xmm2
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  102,15,97,203                       // punpcklwd     %xmm3,%xmm1
  .byte  102,15,97,248                       // punpcklwd     %xmm0,%xmm7
  .byte  102,15,98,249                       // punpckldq     %xmm1,%xmm7
  .byte  102,15,108,250                      // punpcklqdq    %xmm2,%xmm7
  .byte  102,15,111,207                      // movdqa        %xmm7,%xmm1
  .byte  102,15,113,209,12                   // psrlw         $0xc,%xmm1
  .byte  102,15,111,215                      // movdqa        %xmm7,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,111,130,135,50,0,0           // movdqa        0x3287(%edx),%xmm0
  .byte  102,15,219,208                      // pand          %xmm0,%xmm2
  .byte  102,15,111,223                      // movdqa        %xmm7,%xmm3
  .byte  102,15,113,211,4                    // psrlw         $0x4,%xmm3
  .byte  102,15,219,216                      // pand          %xmm0,%xmm3
  .byte  102,15,219,248                      // pand          %xmm0,%xmm7
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,113,240,4                    // psllw         $0x4,%xmm0
  .byte  102,15,235,193                      // por           %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,113,241,4                    // psllw         $0x4,%xmm1
  .byte  102,15,235,202                      // por           %xmm2,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,113,242,4                    // psllw         $0x4,%xmm2
  .byte  102,15,235,211                      // por           %xmm3,%xmm2
  .byte  102,15,111,223                      // movdqa        %xmm7,%xmm3
  .byte  102,15,113,243,4                    // psllw         $0x4,%xmm3
  .byte  102,15,235,223                      // por           %xmm7,%xmm3
  .byte  15,40,101,72                        // movaps        0x48(%ebp),%xmm4
  .byte  141,81,8                            // lea           0x8(%ecx),%edx
  .byte  15,41,100,36,64                     // movaps        %xmm4,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,84,36,4                         // mov           %edx,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_load_a8_sse2_lowp
.globl _sk_load_a8_sse2_lowp
FUNCTION(_sk_load_a8_sse2_lowp)
_sk_load_a8_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  15,40,101,72                        // movaps        0x48(%ebp),%xmm4
  .byte  15,40,85,56                         // movaps        0x38(%ebp),%xmm2
  .byte  15,40,77,40                         // movaps        0x28(%ebp),%xmm1
  .byte  102,15,111,69,24                    // movdqa        0x18(%ebp),%xmm0
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          d226 <_sk_load_a8_sse2_lowp+0x3a>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,28                              // ja            d248 <_sk_load_a8_sse2_lowp+0x5c>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,198,0,0,0               // mov           0xc6(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  15,182,12,51                        // movzbl        (%ebx,%esi,1),%ecx
  .byte  102,15,110,217                      // movd          %ecx,%xmm3
  .byte  235,90                              // jmp           d2a2 <_sk_load_a8_sse2_lowp+0xb6>
  .byte  243,15,126,28,51                    // movq          (%ebx,%esi,1),%xmm3
  .byte  102,15,96,216                       // punpcklbw     %xmm0,%xmm3
  .byte  235,79                              // jmp           d2a2 <_sk_load_a8_sse2_lowp+0xb6>
  .byte  15,182,76,51,2                      // movzbl        0x2(%ebx,%esi,1),%ecx
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,196,217,2                    // pinsrw        $0x2,%ecx,%xmm3
  .byte  15,183,12,51                        // movzwl        (%ebx,%esi,1),%ecx
  .byte  102,15,110,233                      // movd          %ecx,%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  243,15,16,221                       // movss         %xmm5,%xmm3
  .byte  235,47                              // jmp           d2a2 <_sk_load_a8_sse2_lowp+0xb6>
  .byte  15,182,76,51,6                      // movzbl        0x6(%ebx,%esi,1),%ecx
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,196,217,6                    // pinsrw        $0x6,%ecx,%xmm3
  .byte  15,182,76,51,5                      // movzbl        0x5(%ebx,%esi,1),%ecx
  .byte  102,15,196,217,5                    // pinsrw        $0x5,%ecx,%xmm3
  .byte  15,182,76,51,4                      // movzbl        0x4(%ebx,%esi,1),%ecx
  .byte  102,15,196,217,4                    // pinsrw        $0x4,%ecx,%xmm3
  .byte  102,15,110,44,51                    // movd          (%ebx,%esi,1),%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  242,15,16,221                       // movsd         %xmm5,%xmm3
  .byte  102,15,219,159,218,47,0,0           // pand          0x2fda(%edi),%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,41,100,36,64                     // movaps        %xmm4,0x40(%esp)
  .byte  15,41,84,36,48                      // movaps        %xmm2,0x30(%esp)
  .byte  15,41,76,36,32                      // movaps        %xmm1,0x20(%esp)
  .byte  102,15,127,68,36,16                 // movdqa        %xmm0,0x10(%esp)
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  15,31,0                             // nopl          (%eax)
  .byte  24,0                                // sbb           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  59,0                                // cmp           (%eax),%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  45,0,0,0,111                        // sub           $0x6f000000,%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,101,0                             // add           %ah,0x0(%ebp)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  91                                  // pop           %ebx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,77,0                              // add           %cl,0x0(%ebp)
  .byte  0,0                                 // add           %al,(%eax)

HIDDEN _sk_load_a8_dst_sse2_lowp
.globl _sk_load_a8_dst_sse2_lowp
FUNCTION(_sk_load_a8_dst_sse2_lowp)
_sk_load_a8_dst_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          d331 <_sk_load_a8_dst_sse2_lowp+0x29>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,28                              // ja            d353 <_sk_load_a8_dst_sse2_lowp+0x4b>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,195,0,0,0               // mov           0xc3(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  15,182,12,51                        // movzbl        (%ebx,%esi,1),%ecx
  .byte  102,15,110,225                      // movd          %ecx,%xmm4
  .byte  235,90                              // jmp           d3ad <_sk_load_a8_dst_sse2_lowp+0xa5>
  .byte  243,15,126,36,51                    // movq          (%ebx,%esi,1),%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  235,79                              // jmp           d3ad <_sk_load_a8_dst_sse2_lowp+0xa5>
  .byte  15,182,76,51,2                      // movzbl        0x2(%ebx,%esi,1),%ecx
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,225,2                    // pinsrw        $0x2,%ecx,%xmm4
  .byte  15,183,12,51                        // movzwl        (%ebx,%esi,1),%ecx
  .byte  102,15,110,233                      // movd          %ecx,%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  243,15,16,229                       // movss         %xmm5,%xmm4
  .byte  235,47                              // jmp           d3ad <_sk_load_a8_dst_sse2_lowp+0xa5>
  .byte  15,182,76,51,6                      // movzbl        0x6(%ebx,%esi,1),%ecx
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,225,6                    // pinsrw        $0x6,%ecx,%xmm4
  .byte  15,182,76,51,5                      // movzbl        0x5(%ebx,%esi,1),%ecx
  .byte  102,15,196,225,5                    // pinsrw        $0x5,%ecx,%xmm4
  .byte  15,182,76,51,4                      // movzbl        0x4(%ebx,%esi,1),%ecx
  .byte  102,15,196,225,4                    // pinsrw        $0x4,%ecx,%xmm4
  .byte  102,15,110,44,51                    // movd          (%ebx,%esi,1),%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  242,15,16,229                       // movsd         %xmm5,%xmm4
  .byte  102,15,219,167,207,46,0,0           // pand          0x2ecf(%edi),%xmm4
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  102,15,127,100,36,64                // movdqa        %xmm4,0x40(%esp)
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,127,100,36,48                // movdqa        %xmm4,0x30(%esp)
  .byte  102,15,127,100,36,32                // movdqa        %xmm4,0x20(%esp)
  .byte  102,15,127,100,36,16                // movdqa        %xmm4,0x10(%esp)
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  15,31,0                             // nopl          (%eax)
  .byte  24,0                                // sbb           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  59,0                                // cmp           (%eax),%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  45,0,0,0,111                        // sub           $0x6f000000,%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,101,0                             // add           %ah,0x0(%ebp)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  91                                  // pop           %ebx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,77,0                              // add           %cl,0x0(%ebp)
  .byte  0,0                                 // add           %al,(%eax)

HIDDEN _sk_store_a8_sse2_lowp
.globl _sk_store_a8_sse2_lowp
FUNCTION(_sk_store_a8_sse2_lowp)
_sk_store_a8_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,121,4                           // mov           0x4(%ecx),%edi
  .byte  15,175,125,20                       // imul          0x14(%ebp),%edi
  .byte  3,57                                // add           (%ecx),%edi
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          d449 <_sk_store_a8_sse2_lowp+0x39>
  .byte  91                                  // pop           %ebx
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,26                              // ja            d469 <_sk_store_a8_sse2_lowp+0x59>
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,139,223,0,0,0               // mov           0xdf(%ebx,%ecx,4),%ecx
  .byte  1,217                               // add           %ebx,%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  102,15,126,217                      // movd          %xmm3,%ecx
  .byte  136,12,55                           // mov           %cl,(%edi,%esi,1)
  .byte  233,136,0,0,0                       // jmp           d4f1 <_sk_store_a8_sse2_lowp+0xe1>
  .byte  102,15,111,163,183,45,0,0           // movdqa        0x2db7(%ebx),%xmm4
  .byte  102,15,219,227                      // pand          %xmm3,%xmm4
  .byte  102,15,103,228                      // packuswb      %xmm4,%xmm4
  .byte  102,15,214,36,55                    // movq          %xmm4,(%edi,%esi,1)
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  235,109                             // jmp           d4f1 <_sk_store_a8_sse2_lowp+0xe1>
  .byte  102,15,197,203,2                    // pextrw        $0x2,%xmm3,%ecx
  .byte  136,76,55,2                         // mov           %cl,0x2(%edi,%esi,1)
  .byte  102,15,111,163,183,45,0,0           // movdqa        0x2db7(%ebx),%xmm4
  .byte  102,15,219,227                      // pand          %xmm3,%xmm4
  .byte  102,15,103,228                      // packuswb      %xmm4,%xmm4
  .byte  102,15,126,225                      // movd          %xmm4,%ecx
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  102,137,12,55                       // mov           %cx,(%edi,%esi,1)
  .byte  235,70                              // jmp           d4f1 <_sk_store_a8_sse2_lowp+0xe1>
  .byte  102,15,197,203,6                    // pextrw        $0x6,%xmm3,%ecx
  .byte  136,76,55,6                         // mov           %cl,0x6(%edi,%esi,1)
  .byte  102,15,197,203,5                    // pextrw        $0x5,%xmm3,%ecx
  .byte  136,76,55,5                         // mov           %cl,0x5(%edi,%esi,1)
  .byte  102,15,197,203,4                    // pextrw        $0x4,%xmm3,%ecx
  .byte  136,76,55,4                         // mov           %cl,0x4(%edi,%esi,1)
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  102,15,111,163,183,45,0,0           // movdqa        0x2db7(%ebx),%xmm4
  .byte  102,15,219,227                      // pand          %xmm3,%xmm4
  .byte  102,15,103,228                      // packuswb      %xmm4,%xmm4
  .byte  102,15,126,36,55                    // movd          %xmm4,(%edi,%esi,1)
  .byte  15,40,229                           // movaps        %xmm5,%xmm4
  .byte  15,40,238                           // movaps        %xmm6,%xmm5
  .byte  15,40,247                           // movaps        %xmm7,%xmm6
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,41,124,36,64                     // movaps        %xmm7,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  15,31,0                             // nopl          (%eax)
  .byte  20,0                                // adc           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  68                                  // inc           %esp
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,59                                // add           %bh,(%ebx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,125,0                             // add           %bh,0x0(%ebp)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  116,0                               // je            d53a <_sk_store_a8_sse2_lowp+0x12a>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  107,0,0                             // imul          $0x0,(%eax),%eax
  .byte  0,98,0                              // add           %ah,0x0(%edx)
  .byte  0,0                                 // add           %al,(%eax)

HIDDEN _sk_gather_a8_sse2_lowp
.globl _sk_gather_a8_sse2_lowp
FUNCTION(_sk_gather_a8_sse2_lowp)
_sk_gather_a8_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,105,8                     // movss         0x8(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  102,15,118,246                      // pcmpeqd       %xmm6,%xmm6
  .byte  102,15,254,238                      // paddd         %xmm6,%xmm5
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,196                           // maxps         %xmm4,%xmm0
  .byte  15,95,204                           // maxps         %xmm4,%xmm1
  .byte  15,93,205                           // minps         %xmm5,%xmm1
  .byte  15,93,197                           // minps         %xmm5,%xmm0
  .byte  243,15,16,105,12                    // movss         0xc(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  102,15,254,238                      // paddd         %xmm6,%xmm5
  .byte  15,95,220                           // maxps         %xmm4,%xmm3
  .byte  15,95,212                           // maxps         %xmm4,%xmm2
  .byte  15,93,213                           // minps         %xmm5,%xmm2
  .byte  15,93,221                           // minps         %xmm5,%xmm3
  .byte  243,15,91,234                       // cvttps2dq     %xmm2,%xmm5
  .byte  102,15,110,81,4                     // movd          0x4(%ecx),%xmm2
  .byte  102,15,112,210,0                    // pshufd        $0x0,%xmm2,%xmm2
  .byte  102,15,111,242                      // movdqa        %xmm2,%xmm6
  .byte  102,15,244,245                      // pmuludq       %xmm5,%xmm6
  .byte  102,15,112,237,245                  // pshufd        $0xf5,%xmm5,%xmm5
  .byte  102,15,244,234                      // pmuludq       %xmm2,%xmm5
  .byte  102,15,112,246,232                  // pshufd        $0xe8,%xmm6,%xmm6
  .byte  102,15,112,237,232                  // pshufd        $0xe8,%xmm5,%xmm5
  .byte  102,15,98,245                       // punpckldq     %xmm5,%xmm6
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,198                      // paddd         %xmm6,%xmm0
  .byte  102,15,112,232,78                   // pshufd        $0x4e,%xmm0,%xmm5
  .byte  102,15,126,234                      // movd          %xmm5,%edx
  .byte  102,15,112,232,231                  // pshufd        $0xe7,%xmm0,%xmm5
  .byte  102,15,126,238                      // movd          %xmm5,%esi
  .byte  139,9                               // mov           (%ecx),%ecx
  .byte  243,15,91,219                       // cvttps2dq     %xmm3,%xmm3
  .byte  102,15,126,199                      // movd          %xmm0,%edi
  .byte  102,15,112,192,229                  // pshufd        $0xe5,%xmm0,%xmm0
  .byte  15,182,20,17                        // movzbl        (%ecx,%edx,1),%edx
  .byte  15,182,52,49                        // movzbl        (%ecx,%esi,1),%esi
  .byte  193,230,8                           // shl           $0x8,%esi
  .byte  9,214                               // or            %edx,%esi
  .byte  102,15,126,194                      // movd          %xmm0,%edx
  .byte  102,15,112,195,245                  // pshufd        $0xf5,%xmm3,%xmm0
  .byte  102,15,244,194                      // pmuludq       %xmm2,%xmm0
  .byte  15,182,60,57                        // movzbl        (%ecx,%edi,1),%edi
  .byte  15,182,20,17                        // movzbl        (%ecx,%edx,1),%edx
  .byte  193,226,8                           // shl           $0x8,%edx
  .byte  9,250                               // or            %edi,%edx
  .byte  139,125,8                           // mov           0x8(%ebp),%edi
  .byte  102,15,244,211                      // pmuludq       %xmm3,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,98,208                       // punpckldq     %xmm0,%xmm2
  .byte  243,15,91,193                       // cvttps2dq     %xmm1,%xmm0
  .byte  102,15,254,194                      // paddd         %xmm2,%xmm0
  .byte  102,15,110,218                      // movd          %edx,%xmm3
  .byte  102,15,126,194                      // movd          %xmm0,%edx
  .byte  102,15,112,200,229                  // pshufd        $0xe5,%xmm0,%xmm1
  .byte  102,15,196,222,1                    // pinsrw        $0x1,%esi,%xmm3
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  102,15,112,200,78                   // pshufd        $0x4e,%xmm0,%xmm1
  .byte  15,182,20,17                        // movzbl        (%ecx,%edx,1),%edx
  .byte  15,182,52,49                        // movzbl        (%ecx,%esi,1),%esi
  .byte  193,230,8                           // shl           $0x8,%esi
  .byte  9,214                               // or            %edx,%esi
  .byte  102,15,126,202                      // movd          %xmm1,%edx
  .byte  102,15,112,192,231                  // pshufd        $0xe7,%xmm0,%xmm0
  .byte  102,15,196,222,2                    // pinsrw        $0x2,%esi,%xmm3
  .byte  102,15,126,198                      // movd          %xmm0,%esi
  .byte  15,182,20,17                        // movzbl        (%ecx,%edx,1),%edx
  .byte  15,182,12,49                        // movzbl        (%ecx,%esi,1),%ecx
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  193,225,8                           // shl           $0x8,%ecx
  .byte  9,209                               // or            %edx,%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,40,77,40                         // movaps        0x28(%ebp),%xmm1
  .byte  15,40,85,56                         // movaps        0x38(%ebp),%xmm2
  .byte  102,15,196,217,3                    // pinsrw        $0x3,%ecx,%xmm3
  .byte  102,15,96,220                       // punpcklbw     %xmm4,%xmm3
  .byte  15,40,101,72                        // movaps        0x48(%ebp),%xmm4
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,41,100,36,64                     // movaps        %xmm4,0x40(%esp)
  .byte  15,41,84,36,48                      // movaps        %xmm2,0x30(%esp)
  .byte  15,41,76,36,32                      // movaps        %xmm1,0x20(%esp)
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,60,36                           // mov           %edi,(%esp)
  .byte  15,87,192                           // xorps         %xmm0,%xmm0
  .byte  15,87,201                           // xorps         %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_load_g8_sse2_lowp
.globl _sk_load_g8_sse2_lowp
FUNCTION(_sk_load_g8_sse2_lowp)
_sk_load_g8_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  15,40,101,72                        // movaps        0x48(%ebp),%xmm4
  .byte  15,40,93,56                         // movaps        0x38(%ebp),%xmm3
  .byte  15,40,85,40                         // movaps        0x28(%ebp),%xmm2
  .byte  15,40,77,24                         // movaps        0x18(%ebp),%xmm1
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          d6fc <_sk_load_g8_sse2_lowp+0x39>
  .byte  94                                  // pop           %esi
  .byte  139,125,16                          // mov           0x10(%ebp),%edi
  .byte  119,28                              // ja            d71e <_sk_load_g8_sse2_lowp+0x5b>
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,142,200,0,0,0               // mov           0xc8(%esi,%ecx,4),%ecx
  .byte  1,241                               // add           %esi,%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  15,182,12,59                        // movzbl        (%ebx,%edi,1),%ecx
  .byte  102,15,110,193                      // movd          %ecx,%xmm0
  .byte  235,90                              // jmp           d778 <_sk_load_g8_sse2_lowp+0xb5>
  .byte  243,15,126,4,59                     // movq          (%ebx,%edi,1),%xmm0
  .byte  102,15,96,192                       // punpcklbw     %xmm0,%xmm0
  .byte  235,79                              // jmp           d778 <_sk_load_g8_sse2_lowp+0xb5>
  .byte  15,182,76,59,2                      // movzbl        0x2(%ebx,%edi,1),%ecx
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,196,193,2                    // pinsrw        $0x2,%ecx,%xmm0
  .byte  15,183,12,59                        // movzwl        (%ebx,%edi,1),%ecx
  .byte  102,15,110,233                      // movd          %ecx,%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  243,15,16,197                       // movss         %xmm5,%xmm0
  .byte  235,47                              // jmp           d778 <_sk_load_g8_sse2_lowp+0xb5>
  .byte  15,182,76,59,6                      // movzbl        0x6(%ebx,%edi,1),%ecx
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,196,193,6                    // pinsrw        $0x6,%ecx,%xmm0
  .byte  15,182,76,59,5                      // movzbl        0x5(%ebx,%edi,1),%ecx
  .byte  102,15,196,193,5                    // pinsrw        $0x5,%ecx,%xmm0
  .byte  15,182,76,59,4                      // movzbl        0x4(%ebx,%edi,1),%ecx
  .byte  102,15,196,193,4                    // pinsrw        $0x4,%ecx,%xmm0
  .byte  102,15,110,44,59                    // movd          (%ebx,%edi,1),%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  242,15,16,197                       // movsd         %xmm5,%xmm0
  .byte  102,15,219,134,4,43,0,0             // pand          0x2b04(%esi),%xmm0
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,41,100,36,64                     // movaps        %xmm4,0x40(%esp)
  .byte  15,41,92,36,48                      // movaps        %xmm3,0x30(%esp)
  .byte  15,41,84,36,32                      // movaps        %xmm2,0x20(%esp)
  .byte  15,41,76,36,16                      // movaps        %xmm1,0x10(%esp)
  .byte  139,93,20                           // mov           0x14(%ebp),%ebx
  .byte  137,92,36,12                        // mov           %ebx,0xc(%esp)
  .byte  137,124,36,8                        // mov           %edi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  15,40,158,4,43,0,0                  // movaps        0x2b04(%esi),%xmm3
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  144                                 // nop
  .byte  24,0                                // sbb           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  59,0                                // cmp           (%eax),%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  45,0,0,0,111                        // sub           $0x6f000000,%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,101,0                             // add           %ah,0x0(%ebp)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  91                                  // pop           %ebx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,77,0                              // add           %cl,0x0(%ebp)
  .byte  0,0                                 // add           %al,(%eax)

HIDDEN _sk_load_g8_dst_sse2_lowp
.globl _sk_load_g8_dst_sse2_lowp
FUNCTION(_sk_load_g8_dst_sse2_lowp)
_sk_load_g8_dst_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          d809 <_sk_load_g8_dst_sse2_lowp+0x29>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,28                              // ja            d82b <_sk_load_g8_dst_sse2_lowp+0x4b>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,195,0,0,0               // mov           0xc3(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  15,182,12,51                        // movzbl        (%ebx,%esi,1),%ecx
  .byte  102,15,110,225                      // movd          %ecx,%xmm4
  .byte  235,90                              // jmp           d885 <_sk_load_g8_dst_sse2_lowp+0xa5>
  .byte  243,15,126,36,51                    // movq          (%ebx,%esi,1),%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  235,79                              // jmp           d885 <_sk_load_g8_dst_sse2_lowp+0xa5>
  .byte  15,182,76,51,2                      // movzbl        0x2(%ebx,%esi,1),%ecx
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,225,2                    // pinsrw        $0x2,%ecx,%xmm4
  .byte  15,183,12,51                        // movzwl        (%ebx,%esi,1),%ecx
  .byte  102,15,110,233                      // movd          %ecx,%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  243,15,16,229                       // movss         %xmm5,%xmm4
  .byte  235,47                              // jmp           d885 <_sk_load_g8_dst_sse2_lowp+0xa5>
  .byte  15,182,76,51,6                      // movzbl        0x6(%ebx,%esi,1),%ecx
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,225,6                    // pinsrw        $0x6,%ecx,%xmm4
  .byte  15,182,76,51,5                      // movzbl        0x5(%ebx,%esi,1),%ecx
  .byte  102,15,196,225,5                    // pinsrw        $0x5,%ecx,%xmm4
  .byte  15,182,76,51,4                      // movzbl        0x4(%ebx,%esi,1),%ecx
  .byte  102,15,196,225,4                    // pinsrw        $0x4,%ecx,%xmm4
  .byte  102,15,110,44,51                    // movd          (%ebx,%esi,1),%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  242,15,16,229                       // movsd         %xmm5,%xmm4
  .byte  102,15,219,167,247,41,0,0           // pand          0x29f7(%edi),%xmm4
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,40,175,247,41,0,0                // movaps        0x29f7(%edi),%xmm5
  .byte  15,41,108,36,64                     // movaps        %xmm5,0x40(%esp)
  .byte  102,15,127,100,36,48                // movdqa        %xmm4,0x30(%esp)
  .byte  102,15,127,100,36,32                // movdqa        %xmm4,0x20(%esp)
  .byte  102,15,127,100,36,16                // movdqa        %xmm4,0x10(%esp)
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  144                                 // nop
  .byte  24,0                                // sbb           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  59,0                                // cmp           (%eax),%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  45,0,0,0,111                        // sub           $0x6f000000,%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,101,0                             // add           %ah,0x0(%ebp)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  91                                  // pop           %ebx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,77,0                              // add           %cl,0x0(%ebp)
  .byte  0,0                                 // add           %al,(%eax)

HIDDEN _sk_luminance_to_alpha_sse2_lowp
.globl _sk_luminance_to_alpha_sse2_lowp
FUNCTION(_sk_luminance_to_alpha_sse2_lowp)
_sk_luminance_to_alpha_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  232,0,0,0,0                         // call          d8f9 <_sk_luminance_to_alpha_sse2_lowp+0x11>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  15,40,85,24                         // movaps        0x18(%ebp),%xmm2
  .byte  15,40,101,40                        // movaps        0x28(%ebp),%xmm4
  .byte  15,40,109,56                        // movaps        0x38(%ebp),%xmm5
  .byte  15,40,117,72                        // movaps        0x48(%ebp),%xmm6
  .byte  139,125,12                          // mov           0xc(%ebp),%edi
  .byte  102,15,213,128,215,41,0,0           // pmullw        0x29d7(%eax),%xmm0
  .byte  102,15,213,136,231,41,0,0           // pmullw        0x29e7(%eax),%xmm1
  .byte  102,15,253,200                      // paddw         %xmm0,%xmm1
  .byte  102,15,213,152,247,41,0,0           // pmullw        0x29f7(%eax),%xmm3
  .byte  102,15,253,217                      // paddw         %xmm1,%xmm3
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  141,71,4                            // lea           0x4(%edi),%eax
  .byte  15,41,116,36,64                     // movaps        %xmm6,0x40(%esp)
  .byte  15,41,108,36,48                     // movaps        %xmm5,0x30(%esp)
  .byte  15,41,100,36,32                     // movaps        %xmm4,0x20(%esp)
  .byte  15,41,84,36,16                      // movaps        %xmm2,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,68,36,4                         // mov           %eax,0x4(%esp)
  .byte  137,12,36                           // mov           %ecx,(%esp)
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,239,201                      // pxor          %xmm1,%xmm1
  .byte  15,87,210                           // xorps         %xmm2,%xmm2
  .byte  255,23                              // call          *(%edi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_gather_g8_sse2_lowp
.globl _sk_gather_g8_sse2_lowp
FUNCTION(_sk_gather_g8_sse2_lowp)
_sk_gather_g8_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,105,8                     // movss         0x8(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  102,15,118,246                      // pcmpeqd       %xmm6,%xmm6
  .byte  102,15,254,238                      // paddd         %xmm6,%xmm5
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,196                           // maxps         %xmm4,%xmm0
  .byte  15,95,204                           // maxps         %xmm4,%xmm1
  .byte  15,93,205                           // minps         %xmm5,%xmm1
  .byte  15,93,197                           // minps         %xmm5,%xmm0
  .byte  243,15,16,105,12                    // movss         0xc(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  102,15,254,238                      // paddd         %xmm6,%xmm5
  .byte  15,95,220                           // maxps         %xmm4,%xmm3
  .byte  15,95,212                           // maxps         %xmm4,%xmm2
  .byte  15,93,213                           // minps         %xmm5,%xmm2
  .byte  15,93,221                           // minps         %xmm5,%xmm3
  .byte  243,15,91,234                       // cvttps2dq     %xmm2,%xmm5
  .byte  102,15,110,81,4                     // movd          0x4(%ecx),%xmm2
  .byte  102,15,112,210,0                    // pshufd        $0x0,%xmm2,%xmm2
  .byte  102,15,111,242                      // movdqa        %xmm2,%xmm6
  .byte  102,15,244,245                      // pmuludq       %xmm5,%xmm6
  .byte  102,15,112,237,245                  // pshufd        $0xf5,%xmm5,%xmm5
  .byte  102,15,244,234                      // pmuludq       %xmm2,%xmm5
  .byte  102,15,112,246,232                  // pshufd        $0xe8,%xmm6,%xmm6
  .byte  102,15,112,237,232                  // pshufd        $0xe8,%xmm5,%xmm5
  .byte  102,15,98,245                       // punpckldq     %xmm5,%xmm6
  .byte  243,15,91,192                       // cvttps2dq     %xmm0,%xmm0
  .byte  102,15,254,198                      // paddd         %xmm6,%xmm0
  .byte  102,15,112,232,78                   // pshufd        $0x4e,%xmm0,%xmm5
  .byte  102,15,126,234                      // movd          %xmm5,%edx
  .byte  102,15,112,232,231                  // pshufd        $0xe7,%xmm0,%xmm5
  .byte  102,15,126,238                      // movd          %xmm5,%esi
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  243,15,91,219                       // cvttps2dq     %xmm3,%xmm3
  .byte  102,15,126,193                      // movd          %xmm0,%ecx
  .byte  102,15,112,192,229                  // pshufd        $0xe5,%xmm0,%xmm0
  .byte  15,182,20,23                        // movzbl        (%edi,%edx,1),%edx
  .byte  15,182,52,55                        // movzbl        (%edi,%esi,1),%esi
  .byte  193,230,8                           // shl           $0x8,%esi
  .byte  9,214                               // or            %edx,%esi
  .byte  102,15,126,194                      // movd          %xmm0,%edx
  .byte  102,15,112,195,245                  // pshufd        $0xf5,%xmm3,%xmm0
  .byte  102,15,244,194                      // pmuludq       %xmm2,%xmm0
  .byte  15,182,12,15                        // movzbl        (%edi,%ecx,1),%ecx
  .byte  15,182,20,23                        // movzbl        (%edi,%edx,1),%edx
  .byte  193,226,8                           // shl           $0x8,%edx
  .byte  9,202                               // or            %ecx,%edx
  .byte  232,0,0,0,0                         // call          da3e <_sk_gather_g8_sse2_lowp+0xc9>
  .byte  89                                  // pop           %ecx
  .byte  102,15,244,211                      // pmuludq       %xmm3,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,98,208                       // punpckldq     %xmm0,%xmm2
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  102,15,254,202                      // paddd         %xmm2,%xmm1
  .byte  102,15,110,194                      // movd          %edx,%xmm0
  .byte  102,15,126,202                      // movd          %xmm1,%edx
  .byte  102,15,112,209,229                  // pshufd        $0xe5,%xmm1,%xmm2
  .byte  102,15,196,198,1                    // pinsrw        $0x1,%esi,%xmm0
  .byte  102,15,126,214                      // movd          %xmm2,%esi
  .byte  102,15,112,209,78                   // pshufd        $0x4e,%xmm1,%xmm2
  .byte  15,182,20,23                        // movzbl        (%edi,%edx,1),%edx
  .byte  15,182,52,55                        // movzbl        (%edi,%esi,1),%esi
  .byte  193,230,8                           // shl           $0x8,%esi
  .byte  9,214                               // or            %edx,%esi
  .byte  102,15,126,210                      // movd          %xmm2,%edx
  .byte  102,15,112,201,231                  // pshufd        $0xe7,%xmm1,%xmm1
  .byte  102,15,196,198,2                    // pinsrw        $0x2,%esi,%xmm0
  .byte  102,15,126,206                      // movd          %xmm1,%esi
  .byte  15,182,20,23                        // movzbl        (%edi,%edx,1),%edx
  .byte  15,182,52,55                        // movzbl        (%edi,%esi,1),%esi
  .byte  139,125,8                           // mov           0x8(%ebp),%edi
  .byte  193,230,8                           // shl           $0x8,%esi
  .byte  9,214                               // or            %edx,%esi
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  102,15,196,198,3                    // pinsrw        $0x3,%esi,%xmm0
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  15,40,77,24                         // movaps        0x18(%ebp),%xmm1
  .byte  15,40,85,40                         // movaps        0x28(%ebp),%xmm2
  .byte  15,40,93,56                         // movaps        0x38(%ebp),%xmm3
  .byte  102,15,96,196                       // punpcklbw     %xmm4,%xmm0
  .byte  15,40,101,72                        // movaps        0x48(%ebp),%xmm4
  .byte  141,88,8                            // lea           0x8(%eax),%ebx
  .byte  15,41,100,36,64                     // movaps        %xmm4,0x40(%esp)
  .byte  15,41,92,36,48                      // movaps        %xmm3,0x30(%esp)
  .byte  15,41,84,36,32                      // movaps        %xmm2,0x20(%esp)
  .byte  15,41,76,36,16                      // movaps        %xmm1,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,92,36,4                         // mov           %ebx,0x4(%esp)
  .byte  137,60,36                           // mov           %edi,(%esp)
  .byte  15,40,153,194,39,0,0                // movaps        0x27c2(%ecx),%xmm3
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,111,208                      // movdqa        %xmm0,%xmm2
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_scale_1_float_sse2_lowp
.globl _sk_scale_1_float_sse2_lowp
FUNCTION(_sk_scale_1_float_sse2_lowp)
_sk_scale_1_float_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          db0f <_sk_scale_1_float_sse2_lowp+0xd>
  .byte  94                                  // pop           %esi
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,77,12                           // mov           0xc(%ebp),%ecx
  .byte  139,57                              // mov           (%ecx),%edi
  .byte  243,15,16,39                        // movss         (%edi),%xmm4
  .byte  243,15,89,166,245,39,0,0            // mulss         0x27f5(%esi),%xmm4
  .byte  243,15,88,166,241,39,0,0            // addss         0x27f1(%esi),%xmm4
  .byte  243,15,44,252                       // cvttss2si     %xmm4,%edi
  .byte  102,15,110,239                      // movd          %edi,%xmm5
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,40,117,40                        // movaps        0x28(%ebp),%xmm6
  .byte  15,40,125,56                        // movaps        0x38(%ebp),%xmm7
  .byte  242,15,112,237,0                    // pshuflw       $0x0,%xmm5,%xmm5
  .byte  102,15,112,237,80                   // pshufd        $0x50,%xmm5,%xmm5
  .byte  102,15,213,197                      // pmullw        %xmm5,%xmm0
  .byte  102,15,213,205                      // pmullw        %xmm5,%xmm1
  .byte  102,15,213,213                      // pmullw        %xmm5,%xmm2
  .byte  102,15,213,221                      // pmullw        %xmm5,%xmm3
  .byte  102,15,111,174,241,38,0,0           // movdqa        0x26f1(%esi),%xmm5
  .byte  102,15,253,197                      // paddw         %xmm5,%xmm0
  .byte  102,15,253,205                      // paddw         %xmm5,%xmm1
  .byte  102,15,253,213                      // paddw         %xmm5,%xmm2
  .byte  102,15,253,221                      // paddw         %xmm5,%xmm3
  .byte  15,40,109,72                        // movaps        0x48(%ebp),%xmm5
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  141,113,8                           // lea           0x8(%ecx),%esi
  .byte  15,41,108,36,64                     // movaps        %xmm5,0x40(%esp)
  .byte  15,41,124,36,48                     // movaps        %xmm7,0x30(%esp)
  .byte  15,41,116,36,32                     // movaps        %xmm6,0x20(%esp)
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,116,36,4                        // mov           %esi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_lerp_1_float_sse2_lowp
.globl _sk_lerp_1_float_sse2_lowp
FUNCTION(_sk_lerp_1_float_sse2_lowp)
_sk_lerp_1_float_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  102,15,111,227                      // movdqa        %xmm3,%xmm4
  .byte  102,15,111,218                      // movdqa        %xmm2,%xmm3
  .byte  102,15,111,209                      // movdqa        %xmm1,%xmm2
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          dbdd <_sk_lerp_1_float_sse2_lowp+0x1d>
  .byte  89                                  // pop           %ecx
  .byte  102,15,111,109,24                   // movdqa        0x18(%ebp),%xmm5
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,16                              // mov           (%eax),%edx
  .byte  243,15,16,50                        // movss         (%edx),%xmm6
  .byte  243,15,89,177,39,39,0,0             // mulss         0x2727(%ecx),%xmm6
  .byte  243,15,88,177,35,39,0,0             // addss         0x2723(%ecx),%xmm6
  .byte  243,15,44,214                       // cvttss2si     %xmm6,%edx
  .byte  102,15,110,242                      // movd          %edx,%xmm6
  .byte  242,15,112,246,0                    // pshuflw       $0x0,%xmm6,%xmm6
  .byte  102,15,112,246,80                   // pshufd        $0x50,%xmm6,%xmm6
  .byte  102,15,111,129,35,38,0,0            // movdqa        0x2623(%ecx),%xmm0
  .byte  102,15,213,206                      // pmullw        %xmm6,%xmm1
  .byte  102,15,253,200                      // paddw         %xmm0,%xmm1
  .byte  102,15,213,214                      // pmullw        %xmm6,%xmm2
  .byte  102,15,253,208                      // paddw         %xmm0,%xmm2
  .byte  102,15,213,222                      // pmullw        %xmm6,%xmm3
  .byte  102,15,253,216                      // paddw         %xmm0,%xmm3
  .byte  102,15,213,230                      // pmullw        %xmm6,%xmm4
  .byte  102,15,253,224                      // paddw         %xmm0,%xmm4
  .byte  102,15,249,198                      // psubw         %xmm6,%xmm0
  .byte  102,15,111,240                      // movdqa        %xmm0,%xmm6
  .byte  102,15,213,245                      // pmullw        %xmm5,%xmm6
  .byte  102,15,253,206                      // paddw         %xmm6,%xmm1
  .byte  102,15,111,240                      // movdqa        %xmm0,%xmm6
  .byte  102,15,213,117,40                   // pmullw        0x28(%ebp),%xmm6
  .byte  102,15,253,214                      // paddw         %xmm6,%xmm2
  .byte  102,15,111,117,56                   // movdqa        0x38(%ebp),%xmm6
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  102,15,213,254                      // pmullw        %xmm6,%xmm7
  .byte  102,15,253,223                      // paddw         %xmm7,%xmm3
  .byte  102,15,111,125,72                   // movdqa        0x48(%ebp),%xmm7
  .byte  102,15,213,199                      // pmullw        %xmm7,%xmm0
  .byte  102,15,253,224                      // paddw         %xmm0,%xmm4
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,113,212,8                    // psrlw         $0x8,%xmm4
  .byte  141,120,8                           // lea           0x8(%eax),%edi
  .byte  102,15,127,124,36,64                // movdqa        %xmm7,0x40(%esp)
  .byte  102,15,127,116,36,48                // movdqa        %xmm6,0x30(%esp)
  .byte  15,40,69,40                         // movaps        0x28(%ebp),%xmm0
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  102,15,127,108,36,16                // movdqa        %xmm5,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,12,36                           // mov           %ecx,(%esp)
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_scale_u8_sse2_lowp
.globl _sk_scale_u8_sse2_lowp
FUNCTION(_sk_scale_u8_sse2_lowp)
_sk_scale_u8_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,92                          // sub           $0x5c,%esp
  .byte  15,40,125,56                        // movaps        0x38(%ebp),%xmm7
  .byte  15,40,117,40                        // movaps        0x28(%ebp),%xmm6
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          dd06 <_sk_scale_u8_sse2_lowp+0x31>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,28                              // ja            dd28 <_sk_scale_u8_sse2_lowp+0x53>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,2,1,0,0                 // mov           0x102(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  15,182,12,51                        // movzbl        (%ebx,%esi,1),%ecx
  .byte  102,15,110,225                      // movd          %ecx,%xmm4
  .byte  235,90                              // jmp           dd82 <_sk_scale_u8_sse2_lowp+0xad>
  .byte  243,15,126,36,51                    // movq          (%ebx,%esi,1),%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  235,79                              // jmp           dd82 <_sk_scale_u8_sse2_lowp+0xad>
  .byte  15,182,76,51,2                      // movzbl        0x2(%ebx,%esi,1),%ecx
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,225,2                    // pinsrw        $0x2,%ecx,%xmm4
  .byte  15,183,12,51                        // movzwl        (%ebx,%esi,1),%ecx
  .byte  102,15,110,233                      // movd          %ecx,%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  243,15,16,229                       // movss         %xmm5,%xmm4
  .byte  235,47                              // jmp           dd82 <_sk_scale_u8_sse2_lowp+0xad>
  .byte  15,182,76,51,6                      // movzbl        0x6(%ebx,%esi,1),%ecx
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  102,15,196,225,6                    // pinsrw        $0x6,%ecx,%xmm4
  .byte  15,182,76,51,5                      // movzbl        0x5(%ebx,%esi,1),%ecx
  .byte  102,15,196,225,5                    // pinsrw        $0x5,%ecx,%xmm4
  .byte  15,182,76,51,4                      // movzbl        0x4(%ebx,%esi,1),%ecx
  .byte  102,15,196,225,4                    // pinsrw        $0x4,%ecx,%xmm4
  .byte  102,15,110,44,51                    // movd          (%ebx,%esi,1),%xmm5
  .byte  102,15,96,232                       // punpcklbw     %xmm0,%xmm5
  .byte  242,15,16,229                       // movsd         %xmm5,%xmm4
  .byte  102,15,219,167,250,36,0,0           // pand          0x24fa(%edi),%xmm4
  .byte  102,15,213,196                      // pmullw        %xmm4,%xmm0
  .byte  102,15,111,175,250,36,0,0           // movdqa        0x24fa(%edi),%xmm5
  .byte  102,15,253,197                      // paddw         %xmm5,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,213,204                      // pmullw        %xmm4,%xmm1
  .byte  102,15,253,205                      // paddw         %xmm5,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,213,212                      // pmullw        %xmm4,%xmm2
  .byte  102,15,253,213                      // paddw         %xmm5,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,213,227                      // pmullw        %xmm3,%xmm4
  .byte  102,15,253,229                      // paddw         %xmm5,%xmm4
  .byte  102,15,113,212,8                    // psrlw         $0x8,%xmm4
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,40,93,72                         // movaps        0x48(%ebp),%xmm3
  .byte  15,41,92,36,64                      // movaps        %xmm3,0x40(%esp)
  .byte  15,41,124,36,48                     // movaps        %xmm7,0x30(%esp)
  .byte  15,41,116,36,32                     // movaps        %xmm6,0x20(%esp)
  .byte  15,40,93,24                         // movaps        0x18(%ebp),%xmm3
  .byte  15,41,92,36,16                      // movaps        %xmm3,0x10(%esp)
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  102,15,111,220                      // movdqa        %xmm4,%xmm3
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,92                          // add           $0x5c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  102,144                             // xchg          %ax,%ax
  .byte  24,0                                // sbb           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  59,0                                // cmp           (%eax),%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  45,0,0,0,111                        // sub           $0x6f000000,%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,101,0                             // add           %ah,0x0(%ebp)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  91                                  // pop           %ebx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,77,0                              // add           %cl,0x0(%ebp)
  .byte  0,0                                 // add           %al,(%eax)

HIDDEN _sk_lerp_u8_sse2_lowp
.globl _sk_lerp_u8_sse2_lowp
FUNCTION(_sk_lerp_u8_sse2_lowp)
_sk_lerp_u8_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,108                         // sub           $0x6c,%esp
  .byte  102,15,127,93,216                   // movdqa        %xmm3,-0x28(%ebp)
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          de52 <_sk_lerp_u8_sse2_lowp+0x2e>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,28                              // ja            de74 <_sk_lerp_u8_sse2_lowp+0x50>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,74,1,0,0                // mov           0x14a(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  15,182,12,51                        // movzbl        (%ebx,%esi,1),%ecx
  .byte  102,15,110,217                      // movd          %ecx,%xmm3
  .byte  235,90                              // jmp           dece <_sk_lerp_u8_sse2_lowp+0xaa>
  .byte  243,15,126,28,51                    // movq          (%ebx,%esi,1),%xmm3
  .byte  102,15,96,216                       // punpcklbw     %xmm0,%xmm3
  .byte  235,79                              // jmp           dece <_sk_lerp_u8_sse2_lowp+0xaa>
  .byte  15,182,76,51,2                      // movzbl        0x2(%ebx,%esi,1),%ecx
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,196,217,2                    // pinsrw        $0x2,%ecx,%xmm3
  .byte  15,183,12,51                        // movzwl        (%ebx,%esi,1),%ecx
  .byte  102,15,110,225                      // movd          %ecx,%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  243,15,16,220                       // movss         %xmm4,%xmm3
  .byte  235,47                              // jmp           dece <_sk_lerp_u8_sse2_lowp+0xaa>
  .byte  15,182,76,51,6                      // movzbl        0x6(%ebx,%esi,1),%ecx
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,196,217,6                    // pinsrw        $0x6,%ecx,%xmm3
  .byte  15,182,76,51,5                      // movzbl        0x5(%ebx,%esi,1),%ecx
  .byte  102,15,196,217,5                    // pinsrw        $0x5,%ecx,%xmm3
  .byte  15,182,76,51,4                      // movzbl        0x4(%ebx,%esi,1),%ecx
  .byte  102,15,196,217,4                    // pinsrw        $0x4,%ecx,%xmm3
  .byte  102,15,110,36,51                    // movd          (%ebx,%esi,1),%xmm4
  .byte  102,15,96,224                       // punpcklbw     %xmm0,%xmm4
  .byte  242,15,16,220                       // movsd         %xmm4,%xmm3
  .byte  102,15,219,159,174,35,0,0           // pand          0x23ae(%edi),%xmm3
  .byte  102,15,111,183,174,35,0,0           // movdqa        0x23ae(%edi),%xmm6
  .byte  102,15,111,227                      // movdqa        %xmm3,%xmm4
  .byte  102,15,239,230                      // pxor          %xmm6,%xmm4
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,15,111,109,24                   // movdqa        0x18(%ebp),%xmm5
  .byte  102,15,213,253                      // pmullw        %xmm5,%xmm7
  .byte  102,15,213,195                      // pmullw        %xmm3,%xmm0
  .byte  102,15,253,198                      // paddw         %xmm6,%xmm0
  .byte  102,15,253,199                      // paddw         %xmm7,%xmm0
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,15,111,109,40                   // movdqa        0x28(%ebp),%xmm5
  .byte  102,15,213,253                      // pmullw        %xmm5,%xmm7
  .byte  102,15,213,203                      // pmullw        %xmm3,%xmm1
  .byte  102,15,253,206                      // paddw         %xmm6,%xmm1
  .byte  102,15,253,207                      // paddw         %xmm7,%xmm1
  .byte  102,15,111,252                      // movdqa        %xmm4,%xmm7
  .byte  102,15,111,109,56                   // movdqa        0x38(%ebp),%xmm5
  .byte  102,15,213,253                      // pmullw        %xmm5,%xmm7
  .byte  102,15,213,211                      // pmullw        %xmm3,%xmm2
  .byte  102,15,253,214                      // paddw         %xmm6,%xmm2
  .byte  102,15,253,215                      // paddw         %xmm7,%xmm2
  .byte  102,15,213,93,216                   // pmullw        -0x28(%ebp),%xmm3
  .byte  102,15,253,222                      // paddw         %xmm6,%xmm3
  .byte  102,15,111,117,72                   // movdqa        0x48(%ebp),%xmm6
  .byte  102,15,213,230                      // pmullw        %xmm6,%xmm4
  .byte  102,15,253,220                      // paddw         %xmm4,%xmm3
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  102,15,127,116,36,64                // movdqa        %xmm6,0x40(%esp)
  .byte  102,15,127,108,36,48                // movdqa        %xmm5,0x30(%esp)
  .byte  15,40,101,40                        // movaps        0x28(%ebp),%xmm4
  .byte  15,41,100,36,32                     // movaps        %xmm4,0x20(%esp)
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,108                         // add           $0x6c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  15,31,0                             // nopl          (%eax)
  .byte  24,0                                // sbb           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  59,0                                // cmp           (%eax),%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  45,0,0,0,111                        // sub           $0x6f000000,%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,101,0                             // add           %ah,0x0(%ebp)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  91                                  // pop           %ebx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,77,0                              // add           %cl,0x0(%ebp)
  .byte  0,0                                 // add           %al,(%eax)

HIDDEN _sk_scale_565_sse2_lowp
.globl _sk_scale_565_sse2_lowp
FUNCTION(_sk_scale_565_sse2_lowp)
_sk_scale_565_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,188,0,0,0                   // sub           $0xbc,%esp
  .byte  102,15,111,243                      // movdqa        %xmm3,%xmm6
  .byte  15,41,85,136                        // movaps        %xmm2,-0x78(%ebp)
  .byte  15,41,77,152                        // movaps        %xmm1,-0x68(%ebp)
  .byte  15,41,69,168                        // movaps        %xmm0,-0x58(%ebp)
  .byte  102,15,111,125,72                   // movdqa        0x48(%ebp),%xmm7
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  1,219                               // add           %ebx,%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          dffb <_sk_scale_565_sse2_lowp+0x43>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,28                              // ja            e01d <_sk_scale_565_sse2_lowp+0x65>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,249,1,0,0               // mov           0x1f9(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  15,183,12,115                       // movzwl        (%ebx,%esi,2),%ecx
  .byte  102,15,110,217                      // movd          %ecx,%xmm3
  .byte  235,59                              // jmp           e058 <_sk_scale_565_sse2_lowp+0xa0>
  .byte  243,15,111,28,115                   // movdqu        (%ebx,%esi,2),%xmm3
  .byte  235,52                              // jmp           e058 <_sk_scale_565_sse2_lowp+0xa0>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,196,92,115,4,2               // pinsrw        $0x2,0x4(%ebx,%esi,2),%xmm3
  .byte  243,15,16,12,115                    // movss         (%ebx,%esi,2),%xmm1
  .byte  243,15,16,217                       // movss         %xmm1,%xmm3
  .byte  235,30                              // jmp           e058 <_sk_scale_565_sse2_lowp+0xa0>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,196,92,115,12,6              // pinsrw        $0x6,0xc(%ebx,%esi,2),%xmm3
  .byte  102,15,196,92,115,10,5              // pinsrw        $0x5,0xa(%ebx,%esi,2),%xmm3
  .byte  102,15,196,92,115,8,4               // pinsrw        $0x4,0x8(%ebx,%esi,2),%xmm3
  .byte  102,15,18,28,115                    // movlpd        (%ebx,%esi,2),%xmm3
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,219,143,69,34,0,0            // pand          0x2245(%edi),%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,113,210,5                    // psrlw         $0x5,%xmm2
  .byte  102,15,219,151,85,34,0,0            // pand          0x2255(%edi),%xmm2
  .byte  102,15,111,135,101,34,0,0           // movdqa        0x2265(%edi),%xmm0
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  102,15,113,211,13                   // psrlw         $0xd,%xmm3
  .byte  102,15,235,217                      // por           %xmm1,%xmm3
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,113,241,2                    // psllw         $0x2,%xmm1
  .byte  102,15,113,210,4                    // psrlw         $0x4,%xmm2
  .byte  102,15,235,209                      // por           %xmm1,%xmm2
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,113,241,3                    // psllw         $0x3,%xmm1
  .byte  102,15,113,208,2                    // psrlw         $0x2,%xmm0
  .byte  102,15,235,193                      // por           %xmm1,%xmm0
  .byte  102,15,127,69,200                   // movdqa        %xmm0,-0x38(%ebp)
  .byte  102,15,111,167,21,34,0,0            // movdqa        0x2215(%edi),%xmm4
  .byte  15,41,117,184                       // movaps        %xmm6,-0x48(%ebp)
  .byte  102,15,239,244                      // pxor          %xmm4,%xmm6
  .byte  102,15,239,252                      // pxor          %xmm4,%xmm7
  .byte  102,15,101,254                      // pcmpgtw       %xmm6,%xmm7
  .byte  102,15,111,240                      // movdqa        %xmm0,%xmm6
  .byte  102,15,239,244                      // pxor          %xmm4,%xmm6
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,239,204                      // pxor          %xmm4,%xmm1
  .byte  102,15,101,241                      // pcmpgtw       %xmm1,%xmm6
  .byte  102,15,111,206                      // movdqa        %xmm6,%xmm1
  .byte  102,15,223,200                      // pandn         %xmm0,%xmm1
  .byte  102,15,111,234                      // movdqa        %xmm2,%xmm5
  .byte  102,15,219,238                      // pand          %xmm6,%xmm5
  .byte  102,15,235,233                      // por           %xmm1,%xmm5
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,15,239,204                      // pxor          %xmm4,%xmm1
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,235,196                      // por           %xmm4,%xmm0
  .byte  102,15,127,69,216                   // movdqa        %xmm0,-0x28(%ebp)
  .byte  102,15,101,200                      // pcmpgtw       %xmm0,%xmm1
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,219,193                      // pand          %xmm1,%xmm0
  .byte  102,15,223,205                      // pandn         %xmm5,%xmm1
  .byte  102,15,235,200                      // por           %xmm0,%xmm1
  .byte  102,15,111,109,200                  // movdqa        -0x38(%ebp),%xmm5
  .byte  102,15,111,197                      // movdqa        %xmm5,%xmm0
  .byte  102,15,219,198                      // pand          %xmm6,%xmm0
  .byte  102,15,223,242                      // pandn         %xmm2,%xmm6
  .byte  102,15,235,240                      // por           %xmm0,%xmm6
  .byte  102,15,239,230                      // pxor          %xmm6,%xmm4
  .byte  102,15,101,101,216                  // pcmpgtw       -0x28(%ebp),%xmm4
  .byte  102,15,219,244                      // pand          %xmm4,%xmm6
  .byte  102,15,223,227                      // pandn         %xmm3,%xmm4
  .byte  102,15,235,230                      // por           %xmm6,%xmm4
  .byte  102,15,219,207                      // pand          %xmm7,%xmm1
  .byte  102,15,223,252                      // pandn         %xmm4,%xmm7
  .byte  102,15,235,249                      // por           %xmm1,%xmm7
  .byte  102,15,213,93,168                   // pmullw        -0x58(%ebp),%xmm3
  .byte  102,15,213,85,152                   // pmullw        -0x68(%ebp),%xmm2
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,213,101,136                  // pmullw        -0x78(%ebp),%xmm4
  .byte  102,15,213,125,184                  // pmullw        -0x48(%ebp),%xmm7
  .byte  102,15,111,135,5,34,0,0             // movdqa        0x2205(%edi),%xmm0
  .byte  102,15,253,216                      // paddw         %xmm0,%xmm3
  .byte  102,15,253,208                      // paddw         %xmm0,%xmm2
  .byte  102,15,253,224                      // paddw         %xmm0,%xmm4
  .byte  102,15,253,248                      // paddw         %xmm0,%xmm7
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,212,8                    // psrlw         $0x8,%xmm4
  .byte  102,15,113,215,8                    // psrlw         $0x8,%xmm7
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,40,69,72                         // movaps        0x48(%ebp),%xmm0
  .byte  15,41,68,36,64                      // movaps        %xmm0,0x40(%esp)
  .byte  15,40,69,56                         // movaps        0x38(%ebp),%xmm0
  .byte  15,41,68,36,48                      // movaps        %xmm0,0x30(%esp)
  .byte  15,40,69,40                         // movaps        0x28(%ebp),%xmm0
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  102,15,111,223                      // movdqa        %xmm7,%xmm3
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  129,196,188,0,0,0                   // add           $0xbc,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  102,144                             // xchg          %ax,%ax
  .byte  24,0                                // sbb           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  52,0                                // xor           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  41,0                                // sub           %eax,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  88                                  // pop           %eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,81,0                              // add           %dl,0x0(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  74                                  // dec           %edx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_lerp_565_sse2_lowp
.globl _sk_lerp_565_sse2_lowp
FUNCTION(_sk_lerp_565_sse2_lowp)
_sk_lerp_565_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,188,0,0,0                   // sub           $0xbc,%esp
  .byte  102,15,111,243                      // movdqa        %xmm3,%xmm6
  .byte  15,41,85,136                        // movaps        %xmm2,-0x78(%ebp)
  .byte  15,41,77,152                        // movaps        %xmm1,-0x68(%ebp)
  .byte  15,41,69,168                        // movaps        %xmm0,-0x58(%ebp)
  .byte  102,15,111,125,72                   // movdqa        0x48(%ebp),%xmm7
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,89,4                            // mov           0x4(%ecx),%ebx
  .byte  15,175,93,20                        // imul          0x14(%ebp),%ebx
  .byte  1,219                               // add           %ebx,%ebx
  .byte  3,25                                // add           (%ecx),%ebx
  .byte  137,209                             // mov           %edx,%ecx
  .byte  128,225,7                           // and           $0x7,%cl
  .byte  254,201                             // dec           %cl
  .byte  128,249,6                           // cmp           $0x6,%cl
  .byte  232,0,0,0,0                         // call          e253 <_sk_lerp_565_sse2_lowp+0x43>
  .byte  95                                  // pop           %edi
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  119,28                              // ja            e275 <_sk_lerp_565_sse2_lowp+0x65>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  15,182,201                          // movzbl        %cl,%ecx
  .byte  139,140,143,73,2,0,0                // mov           0x249(%edi,%ecx,4),%ecx
  .byte  1,249                               // add           %edi,%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  15,183,12,115                       // movzwl        (%ebx,%esi,2),%ecx
  .byte  102,15,110,217                      // movd          %ecx,%xmm3
  .byte  235,59                              // jmp           e2b0 <_sk_lerp_565_sse2_lowp+0xa0>
  .byte  243,15,111,28,115                   // movdqu        (%ebx,%esi,2),%xmm3
  .byte  235,52                              // jmp           e2b0 <_sk_lerp_565_sse2_lowp+0xa0>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,196,92,115,4,2               // pinsrw        $0x2,0x4(%ebx,%esi,2),%xmm3
  .byte  243,15,16,12,115                    // movss         (%ebx,%esi,2),%xmm1
  .byte  243,15,16,217                       // movss         %xmm1,%xmm3
  .byte  235,30                              // jmp           e2b0 <_sk_lerp_565_sse2_lowp+0xa0>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,196,92,115,12,6              // pinsrw        $0x6,0xc(%ebx,%esi,2),%xmm3
  .byte  102,15,196,92,115,10,5              // pinsrw        $0x5,0xa(%ebx,%esi,2),%xmm3
  .byte  102,15,196,92,115,8,4               // pinsrw        $0x4,0x8(%ebx,%esi,2),%xmm3
  .byte  102,15,18,28,115                    // movlpd        (%ebx,%esi,2),%xmm3
  .byte  102,15,111,203                      // movdqa        %xmm3,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,219,143,237,31,0,0           // pand          0x1fed(%edi),%xmm1
  .byte  102,15,111,211                      // movdqa        %xmm3,%xmm2
  .byte  102,15,113,210,5                    // psrlw         $0x5,%xmm2
  .byte  102,15,219,151,253,31,0,0           // pand          0x1ffd(%edi),%xmm2
  .byte  102,15,111,175,13,32,0,0            // movdqa        0x200d(%edi),%xmm5
  .byte  102,15,219,235                      // pand          %xmm3,%xmm5
  .byte  102,15,113,211,13                   // psrlw         $0xd,%xmm3
  .byte  102,15,235,217                      // por           %xmm1,%xmm3
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,113,241,2                    // psllw         $0x2,%xmm1
  .byte  102,15,113,210,4                    // psrlw         $0x4,%xmm2
  .byte  102,15,235,209                      // por           %xmm1,%xmm2
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,15,113,241,3                    // psllw         $0x3,%xmm1
  .byte  102,15,113,213,2                    // psrlw         $0x2,%xmm5
  .byte  102,15,235,233                      // por           %xmm1,%xmm5
  .byte  102,15,127,109,216                  // movdqa        %xmm5,-0x28(%ebp)
  .byte  102,15,111,167,189,31,0,0           // movdqa        0x1fbd(%edi),%xmm4
  .byte  102,15,111,198                      // movdqa        %xmm6,%xmm0
  .byte  102,15,111,200                      // movdqa        %xmm0,%xmm1
  .byte  102,15,239,204                      // pxor          %xmm4,%xmm1
  .byte  102,15,239,252                      // pxor          %xmm4,%xmm7
  .byte  102,15,101,249                      // pcmpgtw       %xmm1,%xmm7
  .byte  102,15,111,245                      // movdqa        %xmm5,%xmm6
  .byte  102,15,239,244                      // pxor          %xmm4,%xmm6
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,239,204                      // pxor          %xmm4,%xmm1
  .byte  102,15,101,241                      // pcmpgtw       %xmm1,%xmm6
  .byte  102,15,111,206                      // movdqa        %xmm6,%xmm1
  .byte  102,15,223,205                      // pandn         %xmm5,%xmm1
  .byte  102,15,127,69,184                   // movdqa        %xmm0,-0x48(%ebp)
  .byte  102,15,111,234                      // movdqa        %xmm2,%xmm5
  .byte  102,15,219,238                      // pand          %xmm6,%xmm5
  .byte  102,15,235,233                      // por           %xmm1,%xmm5
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  102,15,239,204                      // pxor          %xmm4,%xmm1
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,235,196                      // por           %xmm4,%xmm0
  .byte  102,15,127,69,200                   // movdqa        %xmm0,-0x38(%ebp)
  .byte  102,15,101,200                      // pcmpgtw       %xmm0,%xmm1
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,219,193                      // pand          %xmm1,%xmm0
  .byte  102,15,223,205                      // pandn         %xmm5,%xmm1
  .byte  102,15,235,200                      // por           %xmm0,%xmm1
  .byte  102,15,111,69,216                   // movdqa        -0x28(%ebp),%xmm0
  .byte  102,15,219,198                      // pand          %xmm6,%xmm0
  .byte  102,15,223,242                      // pandn         %xmm2,%xmm6
  .byte  102,15,235,240                      // por           %xmm0,%xmm6
  .byte  102,15,239,230                      // pxor          %xmm6,%xmm4
  .byte  102,15,101,101,200                  // pcmpgtw       -0x38(%ebp),%xmm4
  .byte  102,15,219,244                      // pand          %xmm4,%xmm6
  .byte  102,15,223,227                      // pandn         %xmm3,%xmm4
  .byte  102,15,235,230                      // por           %xmm6,%xmm4
  .byte  102,15,219,207                      // pand          %xmm7,%xmm1
  .byte  102,15,223,252                      // pandn         %xmm4,%xmm7
  .byte  102,15,235,249                      // por           %xmm1,%xmm7
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,213,93,168                   // pmullw        -0x58(%ebp),%xmm3
  .byte  102,15,111,143,173,31,0,0           // movdqa        0x1fad(%edi),%xmm1
  .byte  102,15,239,193                      // pxor          %xmm1,%xmm0
  .byte  102,15,111,101,24                   // movdqa        0x18(%ebp),%xmm4
  .byte  102,15,213,196                      // pmullw        %xmm4,%xmm0
  .byte  102,15,253,217                      // paddw         %xmm1,%xmm3
  .byte  102,15,253,216                      // paddw         %xmm0,%xmm3
  .byte  102,15,111,194                      // movdqa        %xmm2,%xmm0
  .byte  102,15,213,85,152                   // pmullw        -0x68(%ebp),%xmm2
  .byte  102,15,239,193                      // pxor          %xmm1,%xmm0
  .byte  102,15,111,109,40                   // movdqa        0x28(%ebp),%xmm5
  .byte  102,15,213,197                      // pmullw        %xmm5,%xmm0
  .byte  102,15,253,209                      // paddw         %xmm1,%xmm2
  .byte  102,15,253,208                      // paddw         %xmm0,%xmm2
  .byte  102,15,111,101,216                  // movdqa        -0x28(%ebp),%xmm4
  .byte  102,15,111,196                      // movdqa        %xmm4,%xmm0
  .byte  102,15,213,101,136                  // pmullw        -0x78(%ebp),%xmm4
  .byte  102,15,239,193                      // pxor          %xmm1,%xmm0
  .byte  102,15,111,117,56                   // movdqa        0x38(%ebp),%xmm6
  .byte  102,15,213,198                      // pmullw        %xmm6,%xmm0
  .byte  102,15,253,225                      // paddw         %xmm1,%xmm4
  .byte  102,15,253,224                      // paddw         %xmm0,%xmm4
  .byte  102,15,111,199                      // movdqa        %xmm7,%xmm0
  .byte  102,15,213,125,184                  // pmullw        -0x48(%ebp),%xmm7
  .byte  102,15,239,193                      // pxor          %xmm1,%xmm0
  .byte  102,15,253,249                      // paddw         %xmm1,%xmm7
  .byte  102,15,111,77,72                    // movdqa        0x48(%ebp),%xmm1
  .byte  102,15,213,193                      // pmullw        %xmm1,%xmm0
  .byte  102,15,253,248                      // paddw         %xmm0,%xmm7
  .byte  102,15,113,211,8                    // psrlw         $0x8,%xmm3
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,113,212,8                    // psrlw         $0x8,%xmm4
  .byte  102,15,113,215,8                    // psrlw         $0x8,%xmm7
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  102,15,127,76,36,64                 // movdqa        %xmm1,0x40(%esp)
  .byte  102,15,127,116,36,48                // movdqa        %xmm6,0x30(%esp)
  .byte  102,15,127,108,36,32                // movdqa        %xmm5,0x20(%esp)
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  102,15,111,195                      // movdqa        %xmm3,%xmm0
  .byte  102,15,111,202                      // movdqa        %xmm2,%xmm1
  .byte  102,15,111,212                      // movdqa        %xmm4,%xmm2
  .byte  102,15,111,223                      // movdqa        %xmm7,%xmm3
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  129,196,188,0,0,0                   // add           $0xbc,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  144                                 // nop
  .byte  24,0                                // sbb           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  52,0                                // xor           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  41,0                                // sub           %eax,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  88                                  // pop           %eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,81,0                              // add           %dl,0x0(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  74                                  // dec           %edx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_clamp_x_1_sse2_lowp
.globl _sk_clamp_x_1_sse2_lowp
FUNCTION(_sk_clamp_x_1_sse2_lowp)
_sk_clamp_x_1_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          e4c5 <_sk_clamp_x_1_sse2_lowp+0xd>
  .byte  88                                  // pop           %eax
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  15,87,255                           // xorps         %xmm7,%xmm7
  .byte  15,95,207                           // maxps         %xmm7,%xmm1
  .byte  15,95,199                           // maxps         %xmm7,%xmm0
  .byte  15,40,184,91,22,0,0                 // movaps        0x165b(%eax),%xmm7
  .byte  15,93,199                           // minps         %xmm7,%xmm0
  .byte  15,93,207                           // minps         %xmm7,%xmm1
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  141,120,4                           // lea           0x4(%eax),%edi
  .byte  15,41,124,36,64                     // movaps        %xmm7,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,12,36                           // mov           %ecx,(%esp)
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_repeat_x_1_sse2_lowp
.globl _sk_repeat_x_1_sse2_lowp
FUNCTION(_sk_repeat_x_1_sse2_lowp)
_sk_repeat_x_1_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  232,0,0,0,0                         // call          e534 <_sk_repeat_x_1_sse2_lowp+0xd>
  .byte  94                                  // pop           %esi
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  243,15,91,225                       // cvttps2dq     %xmm1,%xmm4
  .byte  243,15,91,232                       // cvttps2dq     %xmm0,%xmm5
  .byte  15,91,237                           // cvtdq2ps      %xmm5,%xmm5
  .byte  15,91,228                           // cvtdq2ps      %xmm4,%xmm4
  .byte  15,40,241                           // movaps        %xmm1,%xmm6
  .byte  15,194,244,1                        // cmpltps       %xmm4,%xmm6
  .byte  15,40,190,236,21,0,0                // movaps        0x15ec(%esi),%xmm7
  .byte  15,84,247                           // andps         %xmm7,%xmm6
  .byte  15,92,230                           // subps         %xmm6,%xmm4
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,194,245,1                        // cmpltps       %xmm5,%xmm6
  .byte  15,84,247                           // andps         %xmm7,%xmm6
  .byte  15,92,238                           // subps         %xmm6,%xmm5
  .byte  15,40,117,24                        // movaps        0x18(%ebp),%xmm6
  .byte  15,92,197                           // subps         %xmm5,%xmm0
  .byte  15,40,109,40                        // movaps        0x28(%ebp),%xmm5
  .byte  15,92,204                           // subps         %xmm4,%xmm1
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,204                           // maxps         %xmm4,%xmm1
  .byte  15,95,196                           // maxps         %xmm4,%xmm0
  .byte  15,40,101,56                        // movaps        0x38(%ebp),%xmm4
  .byte  15,93,199                           // minps         %xmm7,%xmm0
  .byte  15,93,207                           // minps         %xmm7,%xmm1
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  15,41,124,36,64                     // movaps        %xmm7,0x40(%esp)
  .byte  15,41,100,36,48                     // movaps        %xmm4,0x30(%esp)
  .byte  15,41,108,36,32                     // movaps        %xmm5,0x20(%esp)
  .byte  15,41,116,36,16                     // movaps        %xmm6,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_mirror_x_1_sse2_lowp
.globl _sk_mirror_x_1_sse2_lowp
FUNCTION(_sk_mirror_x_1_sse2_lowp)
_sk_mirror_x_1_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,96                          // sub           $0x60,%esp
  .byte  15,41,93,232                        // movaps        %xmm3,-0x18(%ebp)
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  232,0,0,0,0                         // call          e5de <_sk_mirror_x_1_sse2_lowp+0x1a>
  .byte  88                                  // pop           %eax
  .byte  15,40,160,178,21,0,0                // movaps        0x15b2(%eax),%xmm4
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  15,40,176,50,21,0,0                 // movaps        0x1532(%eax),%xmm6
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,89,254                           // mulps         %xmm6,%xmm7
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  243,15,91,238                       // cvttps2dq     %xmm6,%xmm5
  .byte  15,91,197                           // cvtdq2ps      %xmm5,%xmm0
  .byte  15,194,240,1                        // cmpltps       %xmm0,%xmm6
  .byte  15,40,168,66,21,0,0                 // movaps        0x1542(%eax),%xmm5
  .byte  15,84,245                           // andps         %xmm5,%xmm6
  .byte  15,92,198                           // subps         %xmm6,%xmm0
  .byte  243,15,91,247                       // cvttps2dq     %xmm7,%xmm6
  .byte  15,91,246                           // cvtdq2ps      %xmm6,%xmm6
  .byte  15,194,254,1                        // cmpltps       %xmm6,%xmm7
  .byte  15,84,253                           // andps         %xmm5,%xmm7
  .byte  15,92,247                           // subps         %xmm7,%xmm6
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  15,88,192                           // addps         %xmm0,%xmm0
  .byte  15,92,200                           // subps         %xmm0,%xmm1
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,88,246                           // addps         %xmm6,%xmm6
  .byte  15,92,214                           // subps         %xmm6,%xmm2
  .byte  15,40,117,40                        // movaps        0x28(%ebp),%xmm6
  .byte  15,88,212                           // addps         %xmm4,%xmm2
  .byte  15,88,204                           // addps         %xmm4,%xmm1
  .byte  15,40,160,66,26,0,0                 // movaps        0x1a42(%eax),%xmm4
  .byte  15,84,204                           // andps         %xmm4,%xmm1
  .byte  15,84,212                           // andps         %xmm4,%xmm2
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,95,212                           // maxps         %xmm4,%xmm2
  .byte  15,95,204                           // maxps         %xmm4,%xmm1
  .byte  15,40,101,56                        // movaps        0x38(%ebp),%xmm4
  .byte  15,93,205                           // minps         %xmm5,%xmm1
  .byte  15,93,213                           // minps         %xmm5,%xmm2
  .byte  15,40,109,72                        // movaps        0x48(%ebp),%xmm5
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  141,120,4                           // lea           0x4(%eax),%edi
  .byte  15,41,108,36,64                     // movaps        %xmm5,0x40(%esp)
  .byte  15,41,100,36,48                     // movaps        %xmm4,0x30(%esp)
  .byte  15,41,116,36,32                     // movaps        %xmm6,0x20(%esp)
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,12,36                           // mov           %ecx,(%esp)
  .byte  15,40,193                           // movaps        %xmm1,%xmm0
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  15,40,211                           // movaps        %xmm3,%xmm2
  .byte  15,40,93,232                        // movaps        -0x18(%ebp),%xmm3
  .byte  255,16                              // call          *(%eax)
  .byte  131,196,96                          // add           $0x60,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_gradient_sse2_lowp
.globl _sk_gradient_sse2_lowp
FUNCTION(_sk_gradient_sse2_lowp)
_sk_gradient_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,108,1,0,0                   // sub           $0x16c,%esp
  .byte  232,0,0,0,0                         // call          e6bc <_sk_gradient_sse2_lowp+0x11>
  .byte  88                                  // pop           %eax
  .byte  137,69,164                          // mov           %eax,-0x5c(%ebp)
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,0                               // mov           (%eax),%eax
  .byte  137,198                             // mov           %eax,%esi
  .byte  139,0                               // mov           (%eax),%eax
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  131,248,2                           // cmp           $0x2,%eax
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  114,48                              // jb            e706 <_sk_gradient_sse2_lowp+0x5b>
  .byte  139,78,36                           // mov           0x24(%esi),%ecx
  .byte  72                                  // dec           %eax
  .byte  131,193,4                           // add           $0x4,%ecx
  .byte  102,15,239,255                      // pxor          %xmm7,%xmm7
  .byte  102,15,239,237                      // pxor          %xmm5,%xmm5
  .byte  243,15,16,17                        // movss         (%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,194,216,2                        // cmpleps       %xmm0,%xmm3
  .byte  102,15,250,251                      // psubd         %xmm3,%xmm7
  .byte  15,194,209,2                        // cmpleps       %xmm1,%xmm2
  .byte  102,15,250,234                      // psubd         %xmm2,%xmm5
  .byte  131,193,4                           // add           $0x4,%ecx
  .byte  72                                  // dec           %eax
  .byte  117,223                             // jne           e6e5 <_sk_gradient_sse2_lowp+0x3a>
  .byte  102,15,112,215,229                  // pshufd        $0xe5,%xmm7,%xmm2
  .byte  102,15,112,223,78                   // pshufd        $0x4e,%xmm7,%xmm3
  .byte  15,41,141,104,255,255,255           // movaps        %xmm1,-0x98(%ebp)
  .byte  15,41,133,248,254,255,255           // movaps        %xmm0,-0x108(%ebp)
  .byte  102,15,112,229,78                   // pshufd        $0x4e,%xmm5,%xmm4
  .byte  102,15,126,225                      // movd          %xmm4,%ecx
  .byte  137,77,136                          // mov           %ecx,-0x78(%ebp)
  .byte  102,15,112,229,231                  // pshufd        $0xe7,%xmm5,%xmm4
  .byte  102,15,126,226                      // movd          %xmm4,%edx
  .byte  139,70,4                            // mov           0x4(%esi),%eax
  .byte  243,15,16,36,144                    // movss         (%eax,%edx,4),%xmm4
  .byte  137,85,232                          // mov           %edx,-0x18(%ebp)
  .byte  243,15,16,52,136                    // movss         (%eax,%ecx,4),%xmm6
  .byte  15,20,244                           // unpcklps      %xmm4,%xmm6
  .byte  102,15,112,229,229                  // pshufd        $0xe5,%xmm5,%xmm4
  .byte  102,15,126,233                      // movd          %xmm5,%ecx
  .byte  137,77,168                          // mov           %ecx,-0x58(%ebp)
  .byte  243,15,16,4,136                     // movss         (%eax,%ecx,4),%xmm0
  .byte  102,15,126,225                      // movd          %xmm4,%ecx
  .byte  137,77,184                          // mov           %ecx,-0x48(%ebp)
  .byte  243,15,16,12,136                    // movss         (%eax,%ecx,4),%xmm1
  .byte  15,20,193                           // unpcklps      %xmm1,%xmm0
  .byte  102,15,112,207,231                  // pshufd        $0xe7,%xmm7,%xmm1
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  137,77,240                          // mov           %ecx,-0x10(%ebp)
  .byte  243,15,16,12,136                    // movss         (%eax,%ecx,4),%xmm1
  .byte  102,15,126,217                      // movd          %xmm3,%ecx
  .byte  243,15,16,28,136                    // movss         (%eax,%ecx,4),%xmm3
  .byte  137,207                             // mov           %ecx,%edi
  .byte  137,125,200                         // mov           %edi,-0x38(%ebp)
  .byte  102,15,126,249                      // movd          %xmm7,%ecx
  .byte  137,77,236                          // mov           %ecx,-0x14(%ebp)
  .byte  243,15,16,36,136                    // movss         (%eax,%ecx,4),%xmm4
  .byte  137,117,228                         // mov           %esi,-0x1c(%ebp)
  .byte  102,15,126,209                      // movd          %xmm2,%ecx
  .byte  243,15,16,20,136                    // movss         (%eax,%ecx,4),%xmm2
  .byte  137,203                             // mov           %ecx,%ebx
  .byte  137,93,224                          // mov           %ebx,-0x20(%ebp)
  .byte  102,15,20,198                       // unpcklpd      %xmm6,%xmm0
  .byte  102,15,41,133,120,255,255,255       // movapd        %xmm0,-0x88(%ebp)
  .byte  15,20,217                           // unpcklps      %xmm1,%xmm3
  .byte  15,20,226                           // unpcklps      %xmm2,%xmm4
  .byte  102,15,20,227                       // unpcklpd      %xmm3,%xmm4
  .byte  139,70,8                            // mov           0x8(%esi),%eax
  .byte  243,15,16,12,144                    // movss         (%eax,%edx,4),%xmm1
  .byte  139,117,136                         // mov           -0x78(%ebp),%esi
  .byte  243,15,16,28,176                    // movss         (%eax,%esi,4),%xmm3
  .byte  15,20,217                           // unpcklps      %xmm1,%xmm3
  .byte  139,77,168                          // mov           -0x58(%ebp),%ecx
  .byte  243,15,16,4,136                     // movss         (%eax,%ecx,4),%xmm0
  .byte  139,85,184                          // mov           -0x48(%ebp),%edx
  .byte  243,15,16,12,144                    // movss         (%eax,%edx,4),%xmm1
  .byte  15,20,193                           // unpcklps      %xmm1,%xmm0
  .byte  102,15,20,195                       // unpcklpd      %xmm3,%xmm0
  .byte  102,15,41,133,8,255,255,255         // movapd        %xmm0,-0xf8(%ebp)
  .byte  139,85,240                          // mov           -0x10(%ebp),%edx
  .byte  243,15,16,12,144                    // movss         (%eax,%edx,4),%xmm1
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  15,20,217                           // unpcklps      %xmm1,%xmm3
  .byte  139,125,236                         // mov           -0x14(%ebp),%edi
  .byte  243,15,16,44,184                    // movss         (%eax,%edi,4),%xmm5
  .byte  243,15,16,12,152                    // movss         (%eax,%ebx,4),%xmm1
  .byte  15,20,233                           // unpcklps      %xmm1,%xmm5
  .byte  102,15,20,235                       // unpcklpd      %xmm3,%xmm5
  .byte  139,93,228                          // mov           -0x1c(%ebp),%ebx
  .byte  139,67,12                           // mov           0xc(%ebx),%eax
  .byte  139,125,232                         // mov           -0x18(%ebp),%edi
  .byte  243,15,16,12,184                    // movss         (%eax,%edi,4),%xmm1
  .byte  243,15,16,52,176                    // movss         (%eax,%esi,4),%xmm6
  .byte  15,20,241                           // unpcklps      %xmm1,%xmm6
  .byte  243,15,16,28,136                    // movss         (%eax,%ecx,4),%xmm3
  .byte  139,77,184                          // mov           -0x48(%ebp),%ecx
  .byte  243,15,16,12,136                    // movss         (%eax,%ecx,4),%xmm1
  .byte  15,20,217                           // unpcklps      %xmm1,%xmm3
  .byte  102,15,20,222                       // unpcklpd      %xmm6,%xmm3
  .byte  102,15,41,157,232,254,255,255       // movapd        %xmm3,-0x118(%ebp)
  .byte  243,15,16,12,144                    // movss         (%eax,%edx,4),%xmm1
  .byte  139,85,200                          // mov           -0x38(%ebp),%edx
  .byte  243,15,16,52,144                    // movss         (%eax,%edx,4),%xmm6
  .byte  15,20,241                           // unpcklps      %xmm1,%xmm6
  .byte  139,117,236                         // mov           -0x14(%ebp),%esi
  .byte  243,15,16,4,176                     // movss         (%eax,%esi,4),%xmm0
  .byte  139,125,224                         // mov           -0x20(%ebp),%edi
  .byte  243,15,16,60,184                    // movss         (%eax,%edi,4),%xmm7
  .byte  15,20,199                           // unpcklps      %xmm7,%xmm0
  .byte  102,15,20,198                       // unpcklpd      %xmm6,%xmm0
  .byte  102,15,41,133,72,255,255,255        // movapd        %xmm0,-0xb8(%ebp)
  .byte  139,67,16                           // mov           0x10(%ebx),%eax
  .byte  139,93,232                          // mov           -0x18(%ebp),%ebx
  .byte  243,15,16,52,152                    // movss         (%eax,%ebx,4),%xmm6
  .byte  139,125,136                         // mov           -0x78(%ebp),%edi
  .byte  243,15,16,60,184                    // movss         (%eax,%edi,4),%xmm7
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  139,125,168                         // mov           -0x58(%ebp),%edi
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  243,15,16,52,136                    // movss         (%eax,%ecx,4),%xmm6
  .byte  15,20,222                           // unpcklps      %xmm6,%xmm3
  .byte  102,15,20,223                       // unpcklpd      %xmm7,%xmm3
  .byte  102,15,41,157,216,254,255,255       // movapd        %xmm3,-0x128(%ebp)
  .byte  139,77,240                          // mov           -0x10(%ebp),%ecx
  .byte  243,15,16,52,136                    // movss         (%eax,%ecx,4),%xmm6
  .byte  243,15,16,60,144                    // movss         (%eax,%edx,4),%xmm7
  .byte  15,20,254                           // unpcklps      %xmm6,%xmm7
  .byte  243,15,16,52,176                    // movss         (%eax,%esi,4),%xmm6
  .byte  139,125,224                         // mov           -0x20(%ebp),%edi
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  102,15,20,247                       // unpcklpd      %xmm7,%xmm6
  .byte  139,85,228                          // mov           -0x1c(%ebp),%edx
  .byte  139,66,20                           // mov           0x14(%edx),%eax
  .byte  243,15,16,28,136                    // movss         (%eax,%ecx,4),%xmm3
  .byte  139,77,200                          // mov           -0x38(%ebp),%ecx
  .byte  243,15,16,60,136                    // movss         (%eax,%ecx,4),%xmm7
  .byte  15,20,251                           // unpcklps      %xmm3,%xmm7
  .byte  243,15,16,12,176                    // movss         (%eax,%esi,4),%xmm1
  .byte  137,249                             // mov           %edi,%ecx
  .byte  243,15,16,28,136                    // movss         (%eax,%ecx,4),%xmm3
  .byte  137,206                             // mov           %ecx,%esi
  .byte  15,20,203                           // unpcklps      %xmm3,%xmm1
  .byte  102,15,20,207                       // unpcklpd      %xmm7,%xmm1
  .byte  243,15,16,28,152                    // movss         (%eax,%ebx,4),%xmm3
  .byte  139,77,136                          // mov           -0x78(%ebp),%ecx
  .byte  243,15,16,60,136                    // movss         (%eax,%ecx,4),%xmm7
  .byte  15,20,251                           // unpcklps      %xmm3,%xmm7
  .byte  139,125,168                         // mov           -0x58(%ebp),%edi
  .byte  243,15,16,20,184                    // movss         (%eax,%edi,4),%xmm2
  .byte  139,125,184                         // mov           -0x48(%ebp),%edi
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  15,20,211                           // unpcklps      %xmm3,%xmm2
  .byte  102,15,20,215                       // unpcklpd      %xmm7,%xmm2
  .byte  139,66,24                           // mov           0x18(%edx),%eax
  .byte  139,85,240                          // mov           -0x10(%ebp),%edx
  .byte  243,15,16,28,144                    // movss         (%eax,%edx,4),%xmm3
  .byte  139,93,200                          // mov           -0x38(%ebp),%ebx
  .byte  243,15,16,60,152                    // movss         (%eax,%ebx,4),%xmm7
  .byte  15,20,251                           // unpcklps      %xmm3,%xmm7
  .byte  139,93,236                          // mov           -0x14(%ebp),%ebx
  .byte  243,15,16,4,152                     // movss         (%eax,%ebx,4),%xmm0
  .byte  243,15,16,28,176                    // movss         (%eax,%esi,4),%xmm3
  .byte  15,20,195                           // unpcklps      %xmm3,%xmm0
  .byte  102,15,20,199                       // unpcklpd      %xmm7,%xmm0
  .byte  102,15,41,133,40,255,255,255        // movapd        %xmm0,-0xd8(%ebp)
  .byte  139,117,232                         // mov           -0x18(%ebp),%esi
  .byte  243,15,16,28,176                    // movss         (%eax,%esi,4),%xmm3
  .byte  243,15,16,60,136                    // movss         (%eax,%ecx,4),%xmm7
  .byte  15,20,251                           // unpcklps      %xmm3,%xmm7
  .byte  139,77,168                          // mov           -0x58(%ebp),%ecx
  .byte  243,15,16,4,136                     // movss         (%eax,%ecx,4),%xmm0
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  15,20,195                           // unpcklps      %xmm3,%xmm0
  .byte  102,15,20,199                       // unpcklpd      %xmm7,%xmm0
  .byte  102,15,41,133,88,255,255,255        // movapd        %xmm0,-0xa8(%ebp)
  .byte  139,69,228                          // mov           -0x1c(%ebp),%eax
  .byte  139,64,28                           // mov           0x1c(%eax),%eax
  .byte  243,15,16,28,144                    // movss         (%eax,%edx,4),%xmm3
  .byte  139,77,200                          // mov           -0x38(%ebp),%ecx
  .byte  243,15,16,60,136                    // movss         (%eax,%ecx,4),%xmm7
  .byte  15,20,251                           // unpcklps      %xmm3,%xmm7
  .byte  243,15,16,4,152                     // movss         (%eax,%ebx,4),%xmm0
  .byte  139,77,224                          // mov           -0x20(%ebp),%ecx
  .byte  243,15,16,28,136                    // movss         (%eax,%ecx,4),%xmm3
  .byte  15,20,195                           // unpcklps      %xmm3,%xmm0
  .byte  102,15,20,199                       // unpcklpd      %xmm7,%xmm0
  .byte  102,15,41,133,24,255,255,255        // movapd        %xmm0,-0xe8(%ebp)
  .byte  139,117,232                         // mov           -0x18(%ebp),%esi
  .byte  243,15,16,28,176                    // movss         (%eax,%esi,4),%xmm3
  .byte  139,125,136                         // mov           -0x78(%ebp),%edi
  .byte  243,15,16,60,184                    // movss         (%eax,%edi,4),%xmm7
  .byte  15,20,251                           // unpcklps      %xmm3,%xmm7
  .byte  139,93,168                          // mov           -0x58(%ebp),%ebx
  .byte  243,15,16,4,152                     // movss         (%eax,%ebx,4),%xmm0
  .byte  139,85,184                          // mov           -0x48(%ebp),%edx
  .byte  243,15,16,28,144                    // movss         (%eax,%edx,4),%xmm3
  .byte  15,20,195                           // unpcklps      %xmm3,%xmm0
  .byte  102,15,20,199                       // unpcklpd      %xmm7,%xmm0
  .byte  102,15,41,133,56,255,255,255        // movapd        %xmm0,-0xc8(%ebp)
  .byte  139,69,228                          // mov           -0x1c(%ebp),%eax
  .byte  139,64,32                           // mov           0x20(%eax),%eax
  .byte  139,85,240                          // mov           -0x10(%ebp),%edx
  .byte  243,15,16,28,144                    // movss         (%eax,%edx,4),%xmm3
  .byte  139,85,200                          // mov           -0x38(%ebp),%edx
  .byte  243,15,16,60,144                    // movss         (%eax,%edx,4),%xmm7
  .byte  15,20,251                           // unpcklps      %xmm3,%xmm7
  .byte  139,85,236                          // mov           -0x14(%ebp),%edx
  .byte  243,15,16,4,144                     // movss         (%eax,%edx,4),%xmm0
  .byte  243,15,16,28,136                    // movss         (%eax,%ecx,4),%xmm3
  .byte  15,20,195                           // unpcklps      %xmm3,%xmm0
  .byte  102,15,20,199                       // unpcklpd      %xmm7,%xmm0
  .byte  102,15,41,69,200                    // movapd        %xmm0,-0x38(%ebp)
  .byte  243,15,16,28,176                    // movss         (%eax,%esi,4),%xmm3
  .byte  243,15,16,60,184                    // movss         (%eax,%edi,4),%xmm7
  .byte  15,20,251                           // unpcklps      %xmm3,%xmm7
  .byte  243,15,16,4,152                     // movss         (%eax,%ebx,4),%xmm0
  .byte  139,77,184                          // mov           -0x48(%ebp),%ecx
  .byte  243,15,16,28,136                    // movss         (%eax,%ecx,4),%xmm3
  .byte  15,20,195                           // unpcklps      %xmm3,%xmm0
  .byte  102,15,20,199                       // unpcklpd      %xmm7,%xmm0
  .byte  102,15,41,69,184                    // movapd        %xmm0,-0x48(%ebp)
  .byte  15,40,189,248,254,255,255           // movaps        -0x108(%ebp),%xmm7
  .byte  15,89,231                           // mulps         %xmm7,%xmm4
  .byte  15,88,225                           // addps         %xmm1,%xmm4
  .byte  15,40,157,104,255,255,255           // movaps        -0x98(%ebp),%xmm3
  .byte  15,40,133,120,255,255,255           // movaps        -0x88(%ebp),%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  139,69,164                          // mov           -0x5c(%ebp),%eax
  .byte  15,40,136,52,21,0,0                 // movaps        0x1534(%eax),%xmm1
  .byte  15,89,225                           // mulps         %xmm1,%xmm4
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,40,144,84,20,0,0                 // movaps        0x1454(%eax),%xmm2
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,41,133,120,255,255,255           // movaps        %xmm0,-0x88(%ebp)
  .byte  15,88,226                           // addps         %xmm2,%xmm4
  .byte  243,15,91,196                       // cvttps2dq     %xmm4,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,224,232                  // pshufd        $0xe8,%xmm0,%xmm4
  .byte  243,15,91,133,120,255,255,255       // cvttps2dq     -0x88(%ebp),%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,108,224                      // punpcklqdq    %xmm0,%xmm4
  .byte  102,15,127,101,168                  // movdqa        %xmm4,-0x58(%ebp)
  .byte  15,89,239                           // mulps         %xmm7,%xmm5
  .byte  15,88,173,40,255,255,255            // addps         -0xd8(%ebp),%xmm5
  .byte  15,40,133,8,255,255,255             // movaps        -0xf8(%ebp),%xmm0
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,133,88,255,255,255            // addps         -0xa8(%ebp),%xmm0
  .byte  15,89,233                           // mulps         %xmm1,%xmm5
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,40,217                           // movaps        %xmm1,%xmm3
  .byte  15,88,194                           // addps         %xmm2,%xmm0
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,88,234                           // addps         %xmm2,%xmm5
  .byte  15,40,202                           // movaps        %xmm2,%xmm1
  .byte  243,15,91,197                       // cvttps2dq     %xmm5,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,208,232                  // pshufd        $0xe8,%xmm0,%xmm2
  .byte  243,15,91,196                       // cvttps2dq     %xmm4,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,108,208                      // punpcklqdq    %xmm0,%xmm2
  .byte  102,15,127,85,136                   // movdqa        %xmm2,-0x78(%ebp)
  .byte  15,40,149,72,255,255,255            // movaps        -0xb8(%ebp),%xmm2
  .byte  15,89,215                           // mulps         %xmm7,%xmm2
  .byte  15,88,149,24,255,255,255            // addps         -0xe8(%ebp),%xmm2
  .byte  15,40,133,232,254,255,255           // movaps        -0x118(%ebp),%xmm0
  .byte  15,40,173,104,255,255,255           // movaps        -0x98(%ebp),%xmm5
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,88,133,56,255,255,255            // addps         -0xc8(%ebp),%xmm0
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,88,209                           // addps         %xmm1,%xmm2
  .byte  243,15,91,194                       // cvttps2dq     %xmm2,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,208,232                  // pshufd        $0xe8,%xmm0,%xmm2
  .byte  243,15,91,196                       // cvttps2dq     %xmm4,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,108,208                      // punpcklqdq    %xmm0,%xmm2
  .byte  15,89,247                           // mulps         %xmm7,%xmm6
  .byte  15,88,117,200                       // addps         -0x38(%ebp),%xmm6
  .byte  15,40,133,216,254,255,255           // movaps        -0x128(%ebp),%xmm0
  .byte  15,89,197                           // mulps         %xmm5,%xmm0
  .byte  15,88,69,184                        // addps         -0x48(%ebp),%xmm0
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,193                           // addps         %xmm1,%xmm0
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  15,88,241                           // addps         %xmm1,%xmm6
  .byte  243,15,91,198                       // cvttps2dq     %xmm6,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,216,232                  // pshufd        $0xe8,%xmm0,%xmm3
  .byte  243,15,91,196                       // cvttps2dq     %xmm4,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  102,15,108,216                      // punpcklqdq    %xmm0,%xmm3
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  137,193                             // mov           %eax,%ecx
  .byte  141,65,8                            // lea           0x8(%ecx),%eax
  .byte  15,40,69,72                         // movaps        0x48(%ebp),%xmm0
  .byte  15,41,68,36,64                      // movaps        %xmm0,0x40(%esp)
  .byte  15,40,69,56                         // movaps        0x38(%ebp),%xmm0
  .byte  15,41,68,36,48                      // movaps        %xmm0,0x30(%esp)
  .byte  15,40,69,40                         // movaps        0x28(%ebp),%xmm0
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,68,36,4                         // mov           %eax,0x4(%esp)
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  15,40,69,168                        // movaps        -0x58(%ebp),%xmm0
  .byte  15,40,77,136                        // movaps        -0x78(%ebp),%xmm1
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  129,196,108,1,0,0                   // add           $0x16c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_evenly_spaced_gradient_sse2_lowp
.globl _sk_evenly_spaced_gradient_sse2_lowp
FUNCTION(_sk_evenly_spaced_gradient_sse2_lowp)
_sk_evenly_spaced_gradient_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,92,1,0,0                    // sub           $0x15c,%esp
  .byte  15,41,141,232,254,255,255           // movaps        %xmm1,-0x118(%ebp)
  .byte  15,41,69,136                        // movaps        %xmm0,-0x78(%ebp)
  .byte  232,0,0,0,0                         // call          ec2e <_sk_evenly_spaced_gradient_sse2_lowp+0x1c>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,48                              // mov           (%eax),%esi
  .byte  139,14                              // mov           (%esi),%ecx
  .byte  139,70,4                            // mov           0x4(%esi),%eax
  .byte  137,243                             // mov           %esi,%ebx
  .byte  73                                  // dec           %ecx
  .byte  102,15,110,209                      // movd          %ecx,%xmm2
  .byte  102,15,112,210,0                    // pshufd        $0x0,%xmm2,%xmm2
  .byte  137,85,164                          // mov           %edx,-0x5c(%ebp)
  .byte  102,15,111,154,98,20,0,0            // movdqa        0x1462(%edx),%xmm3
  .byte  102,15,219,218                      // pand          %xmm2,%xmm3
  .byte  102,15,235,154,34,18,0,0            // por           0x1222(%edx),%xmm3
  .byte  102,15,114,210,16                   // psrld         $0x10,%xmm2
  .byte  102,15,235,146,114,20,0,0           // por           0x1472(%edx),%xmm2
  .byte  15,88,146,130,20,0,0                // addps         0x1482(%edx),%xmm2
  .byte  15,88,211                           // addps         %xmm3,%xmm2
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  15,89,218                           // mulps         %xmm2,%xmm3
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  243,15,91,194                       // cvttps2dq     %xmm2,%xmm0
  .byte  243,15,91,203                       // cvttps2dq     %xmm3,%xmm1
  .byte  102,15,112,209,229                  // pshufd        $0xe5,%xmm1,%xmm2
  .byte  102,15,112,217,78                   // pshufd        $0x4e,%xmm1,%xmm3
  .byte  102,15,112,225,231                  // pshufd        $0xe7,%xmm1,%xmm4
  .byte  102,15,126,230                      // movd          %xmm4,%esi
  .byte  102,15,112,232,229                  // pshufd        $0xe5,%xmm0,%xmm5
  .byte  243,15,16,36,176                    // movss         (%eax,%esi,4),%xmm4
  .byte  137,117,224                         // mov           %esi,-0x20(%ebp)
  .byte  102,15,126,217                      // movd          %xmm3,%ecx
  .byte  137,77,200                          // mov           %ecx,-0x38(%ebp)
  .byte  243,15,16,28,136                    // movss         (%eax,%ecx,4),%xmm3
  .byte  15,20,220                           // unpcklps      %xmm4,%xmm3
  .byte  102,15,112,240,78                   // pshufd        $0x4e,%xmm0,%xmm6
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  243,15,16,60,136                    // movss         (%eax,%ecx,4),%xmm7
  .byte  137,202                             // mov           %ecx,%edx
  .byte  137,85,184                          // mov           %edx,-0x48(%ebp)
  .byte  102,15,126,209                      // movd          %xmm2,%ecx
  .byte  137,77,228                          // mov           %ecx,-0x1c(%ebp)
  .byte  243,15,16,12,136                    // movss         (%eax,%ecx,4),%xmm1
  .byte  15,20,249                           // unpcklps      %xmm1,%xmm7
  .byte  102,15,112,200,231                  // pshufd        $0xe7,%xmm0,%xmm1
  .byte  102,15,126,201                      // movd          %xmm1,%ecx
  .byte  137,77,240                          // mov           %ecx,-0x10(%ebp)
  .byte  243,15,16,12,136                    // movss         (%eax,%ecx,4),%xmm1
  .byte  102,15,126,241                      // movd          %xmm6,%ecx
  .byte  137,77,168                          // mov           %ecx,-0x58(%ebp)
  .byte  243,15,16,20,136                    // movss         (%eax,%ecx,4),%xmm2
  .byte  102,15,126,193                      // movd          %xmm0,%ecx
  .byte  243,15,16,36,136                    // movss         (%eax,%ecx,4),%xmm4
  .byte  137,207                             // mov           %ecx,%edi
  .byte  137,125,232                         // mov           %edi,-0x18(%ebp)
  .byte  102,15,126,233                      // movd          %xmm5,%ecx
  .byte  137,77,236                          // mov           %ecx,-0x14(%ebp)
  .byte  243,15,16,44,136                    // movss         (%eax,%ecx,4),%xmm5
  .byte  102,15,20,251                       // unpcklpd      %xmm3,%xmm7
  .byte  102,15,41,189,24,255,255,255        // movapd        %xmm7,-0xe8(%ebp)
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  15,20,229                           // unpcklps      %xmm5,%xmm4
  .byte  102,15,20,226                       // unpcklpd      %xmm2,%xmm4
  .byte  137,217                             // mov           %ebx,%ecx
  .byte  137,77,220                          // mov           %ecx,-0x24(%ebp)
  .byte  139,65,8                            // mov           0x8(%ecx),%eax
  .byte  243,15,16,12,176                    // movss         (%eax,%esi,4),%xmm1
  .byte  139,117,200                         // mov           -0x38(%ebp),%esi
  .byte  243,15,16,20,176                    // movss         (%eax,%esi,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  243,15,16,4,144                     // movss         (%eax,%edx,4),%xmm0
  .byte  139,93,228                          // mov           -0x1c(%ebp),%ebx
  .byte  243,15,16,12,152                    // movss         (%eax,%ebx,4),%xmm1
  .byte  15,20,193                           // unpcklps      %xmm1,%xmm0
  .byte  102,15,20,194                       // unpcklpd      %xmm2,%xmm0
  .byte  102,15,41,133,72,255,255,255        // movapd        %xmm0,-0xb8(%ebp)
  .byte  139,85,240                          // mov           -0x10(%ebp),%edx
  .byte  243,15,16,12,144                    // movss         (%eax,%edx,4),%xmm1
  .byte  139,117,168                         // mov           -0x58(%ebp),%esi
  .byte  243,15,16,20,176                    // movss         (%eax,%esi,4),%xmm2
  .byte  15,20,209                           // unpcklps      %xmm1,%xmm2
  .byte  243,15,16,12,184                    // movss         (%eax,%edi,4),%xmm1
  .byte  139,125,236                         // mov           -0x14(%ebp),%edi
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  15,20,203                           // unpcklps      %xmm3,%xmm1
  .byte  102,15,20,202                       // unpcklpd      %xmm2,%xmm1
  .byte  139,65,12                           // mov           0xc(%ecx),%eax
  .byte  139,85,224                          // mov           -0x20(%ebp),%edx
  .byte  243,15,16,20,144                    // movss         (%eax,%edx,4),%xmm2
  .byte  139,77,200                          // mov           -0x38(%ebp),%ecx
  .byte  243,15,16,28,136                    // movss         (%eax,%ecx,4),%xmm3
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  139,77,184                          // mov           -0x48(%ebp),%ecx
  .byte  243,15,16,20,136                    // movss         (%eax,%ecx,4),%xmm2
  .byte  243,15,16,52,152                    // movss         (%eax,%ebx,4),%xmm6
  .byte  15,20,214                           // unpcklps      %xmm6,%xmm2
  .byte  102,15,20,211                       // unpcklpd      %xmm3,%xmm2
  .byte  102,15,41,149,8,255,255,255         // movapd        %xmm2,-0xf8(%ebp)
  .byte  139,93,240                          // mov           -0x10(%ebp),%ebx
  .byte  243,15,16,28,152                    // movss         (%eax,%ebx,4),%xmm3
  .byte  243,15,16,52,176                    // movss         (%eax,%esi,4),%xmm6
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  139,117,232                         // mov           -0x18(%ebp),%esi
  .byte  243,15,16,60,176                    // movss         (%eax,%esi,4),%xmm7
  .byte  243,15,16,28,184                    // movss         (%eax,%edi,4),%xmm3
  .byte  15,20,251                           // unpcklps      %xmm3,%xmm7
  .byte  102,15,20,254                       // unpcklpd      %xmm6,%xmm7
  .byte  139,117,220                         // mov           -0x24(%ebp),%esi
  .byte  139,70,16                           // mov           0x10(%esi),%eax
  .byte  243,15,16,28,144                    // movss         (%eax,%edx,4),%xmm3
  .byte  139,85,200                          // mov           -0x38(%ebp),%edx
  .byte  243,15,16,52,144                    // movss         (%eax,%edx,4),%xmm6
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  139,85,184                          // mov           -0x48(%ebp),%edx
  .byte  243,15,16,20,144                    // movss         (%eax,%edx,4),%xmm2
  .byte  139,85,228                          // mov           -0x1c(%ebp),%edx
  .byte  243,15,16,28,144                    // movss         (%eax,%edx,4),%xmm3
  .byte  15,20,211                           // unpcklps      %xmm3,%xmm2
  .byte  102,15,20,214                       // unpcklpd      %xmm6,%xmm2
  .byte  102,15,41,149,248,254,255,255       // movapd        %xmm2,-0x108(%ebp)
  .byte  243,15,16,28,152                    // movss         (%eax,%ebx,4),%xmm3
  .byte  139,125,168                         // mov           -0x58(%ebp),%edi
  .byte  243,15,16,52,184                    // movss         (%eax,%edi,4),%xmm6
  .byte  15,20,243                           // unpcklps      %xmm3,%xmm6
  .byte  139,85,232                          // mov           -0x18(%ebp),%edx
  .byte  243,15,16,4,144                     // movss         (%eax,%edx,4),%xmm0
  .byte  139,77,236                          // mov           -0x14(%ebp),%ecx
  .byte  243,15,16,20,136                    // movss         (%eax,%ecx,4),%xmm2
  .byte  15,20,194                           // unpcklps      %xmm2,%xmm0
  .byte  102,15,20,198                       // unpcklpd      %xmm6,%xmm0
  .byte  102,15,41,133,104,255,255,255       // movapd        %xmm0,-0x98(%ebp)
  .byte  139,70,20                           // mov           0x14(%esi),%eax
  .byte  243,15,16,20,152                    // movss         (%eax,%ebx,4),%xmm2
  .byte  243,15,16,52,184                    // movss         (%eax,%edi,4),%xmm6
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  243,15,16,28,144                    // movss         (%eax,%edx,4),%xmm3
  .byte  243,15,16,20,136                    // movss         (%eax,%ecx,4),%xmm2
  .byte  15,20,218                           // unpcklps      %xmm2,%xmm3
  .byte  102,15,20,222                       // unpcklpd      %xmm6,%xmm3
  .byte  139,93,224                          // mov           -0x20(%ebp),%ebx
  .byte  243,15,16,20,152                    // movss         (%eax,%ebx,4),%xmm2
  .byte  139,125,200                         // mov           -0x38(%ebp),%edi
  .byte  243,15,16,52,184                    // movss         (%eax,%edi,4),%xmm6
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  139,77,184                          // mov           -0x48(%ebp),%ecx
  .byte  243,15,16,44,136                    // movss         (%eax,%ecx,4),%xmm5
  .byte  139,77,228                          // mov           -0x1c(%ebp),%ecx
  .byte  243,15,16,20,136                    // movss         (%eax,%ecx,4),%xmm2
  .byte  15,20,234                           // unpcklps      %xmm2,%xmm5
  .byte  102,15,20,238                       // unpcklpd      %xmm6,%xmm5
  .byte  139,69,220                          // mov           -0x24(%ebp),%eax
  .byte  139,64,24                           // mov           0x18(%eax),%eax
  .byte  139,117,240                         // mov           -0x10(%ebp),%esi
  .byte  243,15,16,20,176                    // movss         (%eax,%esi,4),%xmm2
  .byte  139,117,168                         // mov           -0x58(%ebp),%esi
  .byte  243,15,16,52,176                    // movss         (%eax,%esi,4),%xmm6
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  243,15,16,4,144                     // movss         (%eax,%edx,4),%xmm0
  .byte  139,85,236                          // mov           -0x14(%ebp),%edx
  .byte  243,15,16,20,144                    // movss         (%eax,%edx,4),%xmm2
  .byte  15,20,194                           // unpcklps      %xmm2,%xmm0
  .byte  102,15,20,198                       // unpcklpd      %xmm6,%xmm0
  .byte  102,15,41,133,56,255,255,255        // movapd        %xmm0,-0xc8(%ebp)
  .byte  243,15,16,20,152                    // movss         (%eax,%ebx,4),%xmm2
  .byte  243,15,16,52,184                    // movss         (%eax,%edi,4),%xmm6
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  139,117,184                         // mov           -0x48(%ebp),%esi
  .byte  243,15,16,4,176                     // movss         (%eax,%esi,4),%xmm0
  .byte  243,15,16,20,136                    // movss         (%eax,%ecx,4),%xmm2
  .byte  15,20,194                           // unpcklps      %xmm2,%xmm0
  .byte  102,15,20,198                       // unpcklpd      %xmm6,%xmm0
  .byte  102,15,41,133,120,255,255,255       // movapd        %xmm0,-0x88(%ebp)
  .byte  139,125,220                         // mov           -0x24(%ebp),%edi
  .byte  139,71,28                           // mov           0x1c(%edi),%eax
  .byte  139,93,240                          // mov           -0x10(%ebp),%ebx
  .byte  243,15,16,20,152                    // movss         (%eax,%ebx,4),%xmm2
  .byte  139,77,168                          // mov           -0x58(%ebp),%ecx
  .byte  243,15,16,52,136                    // movss         (%eax,%ecx,4),%xmm6
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  139,77,232                          // mov           -0x18(%ebp),%ecx
  .byte  243,15,16,4,136                     // movss         (%eax,%ecx,4),%xmm0
  .byte  243,15,16,20,144                    // movss         (%eax,%edx,4),%xmm2
  .byte  15,20,194                           // unpcklps      %xmm2,%xmm0
  .byte  102,15,20,198                       // unpcklpd      %xmm6,%xmm0
  .byte  102,15,41,133,40,255,255,255        // movapd        %xmm0,-0xd8(%ebp)
  .byte  139,77,224                          // mov           -0x20(%ebp),%ecx
  .byte  243,15,16,20,136                    // movss         (%eax,%ecx,4),%xmm2
  .byte  139,85,200                          // mov           -0x38(%ebp),%edx
  .byte  243,15,16,52,144                    // movss         (%eax,%edx,4),%xmm6
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  243,15,16,4,176                     // movss         (%eax,%esi,4),%xmm0
  .byte  139,117,228                         // mov           -0x1c(%ebp),%esi
  .byte  243,15,16,20,176                    // movss         (%eax,%esi,4),%xmm2
  .byte  15,20,194                           // unpcklps      %xmm2,%xmm0
  .byte  102,15,20,198                       // unpcklpd      %xmm6,%xmm0
  .byte  102,15,41,133,88,255,255,255        // movapd        %xmm0,-0xa8(%ebp)
  .byte  139,71,32                           // mov           0x20(%edi),%eax
  .byte  243,15,16,20,152                    // movss         (%eax,%ebx,4),%xmm2
  .byte  139,125,168                         // mov           -0x58(%ebp),%edi
  .byte  243,15,16,52,184                    // movss         (%eax,%edi,4),%xmm6
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  139,125,232                         // mov           -0x18(%ebp),%edi
  .byte  243,15,16,4,184                     // movss         (%eax,%edi,4),%xmm0
  .byte  139,125,236                         // mov           -0x14(%ebp),%edi
  .byte  243,15,16,20,184                    // movss         (%eax,%edi,4),%xmm2
  .byte  15,20,194                           // unpcklps      %xmm2,%xmm0
  .byte  102,15,20,198                       // unpcklpd      %xmm6,%xmm0
  .byte  102,15,41,69,168                    // movapd        %xmm0,-0x58(%ebp)
  .byte  243,15,16,20,136                    // movss         (%eax,%ecx,4),%xmm2
  .byte  243,15,16,52,144                    // movss         (%eax,%edx,4),%xmm6
  .byte  15,20,242                           // unpcklps      %xmm2,%xmm6
  .byte  139,77,184                          // mov           -0x48(%ebp),%ecx
  .byte  243,15,16,4,136                     // movss         (%eax,%ecx,4),%xmm0
  .byte  243,15,16,20,176                    // movss         (%eax,%esi,4),%xmm2
  .byte  15,20,194                           // unpcklps      %xmm2,%xmm0
  .byte  102,15,20,198                       // unpcklpd      %xmm6,%xmm0
  .byte  102,15,41,69,200                    // movapd        %xmm0,-0x38(%ebp)
  .byte  15,40,181,232,254,255,255           // movaps        -0x118(%ebp),%xmm6
  .byte  15,89,230                           // mulps         %xmm6,%xmm4
  .byte  15,88,227                           // addps         %xmm3,%xmm4
  .byte  15,40,133,24,255,255,255            // movaps        -0xe8(%ebp),%xmm0
  .byte  15,89,69,136                        // mulps         -0x78(%ebp),%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  139,69,164                          // mov           -0x5c(%ebp),%eax
  .byte  15,40,152,194,15,0,0                // movaps        0xfc2(%eax),%xmm3
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,40,168,226,14,0,0                // movaps        0xee2(%eax),%xmm5
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,88,229                           // addps         %xmm5,%xmm4
  .byte  243,15,91,196                       // cvttps2dq     %xmm4,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  242,15,112,210,232                  // pshuflw       $0xe8,%xmm2,%xmm2
  .byte  243,15,112,210,232                  // pshufhw       $0xe8,%xmm2,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,108,208                      // punpcklqdq    %xmm0,%xmm2
  .byte  102,15,127,85,184                   // movdqa        %xmm2,-0x48(%ebp)
  .byte  15,89,206                           // mulps         %xmm6,%xmm1
  .byte  15,40,230                           // movaps        %xmm6,%xmm4
  .byte  15,88,141,56,255,255,255            // addps         -0xc8(%ebp),%xmm1
  .byte  15,40,85,136                        // movaps        -0x78(%ebp),%xmm2
  .byte  15,40,133,72,255,255,255            // movaps        -0xb8(%ebp),%xmm0
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,88,133,120,255,255,255           // addps         -0x88(%ebp),%xmm0
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,40,240                           // movaps        %xmm0,%xmm6
  .byte  15,88,205                           // addps         %xmm5,%xmm1
  .byte  243,15,91,193                       // cvttps2dq     %xmm1,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  243,15,91,206                       // cvttps2dq     %xmm6,%xmm1
  .byte  242,15,112,201,232                  // pshuflw       $0xe8,%xmm1,%xmm1
  .byte  243,15,112,201,232                  // pshufhw       $0xe8,%xmm1,%xmm1
  .byte  102,15,112,241,232                  // pshufd        $0xe8,%xmm1,%xmm6
  .byte  102,15,108,240                      // punpcklqdq    %xmm0,%xmm6
  .byte  15,89,252                           // mulps         %xmm4,%xmm7
  .byte  15,88,189,40,255,255,255            // addps         -0xd8(%ebp),%xmm7
  .byte  15,40,133,8,255,255,255             // movaps        -0xf8(%ebp),%xmm0
  .byte  15,89,194                           // mulps         %xmm2,%xmm0
  .byte  15,88,133,88,255,255,255            // addps         -0xa8(%ebp),%xmm0
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,89,195                           // mulps         %xmm3,%xmm0
  .byte  15,88,197                           // addps         %xmm5,%xmm0
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,88,253                           // addps         %xmm5,%xmm7
  .byte  243,15,91,199                       // cvttps2dq     %xmm7,%xmm0
  .byte  242,15,112,192,232                  // pshuflw       $0xe8,%xmm0,%xmm0
  .byte  243,15,112,192,232                  // pshufhw       $0xe8,%xmm0,%xmm0
  .byte  102,15,112,192,232                  // pshufd        $0xe8,%xmm0,%xmm0
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  242,15,112,201,232                  // pshuflw       $0xe8,%xmm1,%xmm1
  .byte  243,15,112,201,232                  // pshufhw       $0xe8,%xmm1,%xmm1
  .byte  102,15,112,209,232                  // pshufd        $0xe8,%xmm1,%xmm2
  .byte  102,15,108,208                      // punpcklqdq    %xmm0,%xmm2
  .byte  15,40,189,104,255,255,255           // movaps        -0x98(%ebp),%xmm7
  .byte  15,89,252                           // mulps         %xmm4,%xmm7
  .byte  15,88,125,168                       // addps         -0x58(%ebp),%xmm7
  .byte  15,40,165,248,254,255,255           // movaps        -0x108(%ebp),%xmm4
  .byte  15,89,101,136                       // mulps         -0x78(%ebp),%xmm4
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  15,88,101,200                       // addps         -0x38(%ebp),%xmm4
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  15,40,77,40                         // movaps        0x28(%ebp),%xmm1
  .byte  15,88,229                           // addps         %xmm5,%xmm4
  .byte  15,88,253                           // addps         %xmm5,%xmm7
  .byte  15,40,69,56                         // movaps        0x38(%ebp),%xmm0
  .byte  243,15,91,223                       // cvttps2dq     %xmm7,%xmm3
  .byte  242,15,112,219,232                  // pshuflw       $0xe8,%xmm3,%xmm3
  .byte  243,15,112,219,232                  // pshufhw       $0xe8,%xmm3,%xmm3
  .byte  102,15,112,251,232                  // pshufd        $0xe8,%xmm3,%xmm7
  .byte  243,15,91,220                       // cvttps2dq     %xmm4,%xmm3
  .byte  242,15,112,219,232                  // pshuflw       $0xe8,%xmm3,%xmm3
  .byte  243,15,112,219,232                  // pshufhw       $0xe8,%xmm3,%xmm3
  .byte  102,15,112,219,232                  // pshufd        $0xe8,%xmm3,%xmm3
  .byte  102,15,108,223                      // punpcklqdq    %xmm7,%xmm3
  .byte  15,40,125,72                        // movaps        0x48(%ebp),%xmm7
  .byte  139,125,12                          // mov           0xc(%ebp),%edi
  .byte  141,119,8                           // lea           0x8(%edi),%esi
  .byte  15,41,124,36,64                     // movaps        %xmm7,0x40(%esp)
  .byte  15,41,68,36,48                      // movaps        %xmm0,0x30(%esp)
  .byte  15,41,76,36,32                      // movaps        %xmm1,0x20(%esp)
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,116,36,4                        // mov           %esi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  15,40,69,184                        // movaps        -0x48(%ebp),%xmm0
  .byte  102,15,111,206                      // movdqa        %xmm6,%xmm1
  .byte  255,87,4                            // call          *0x4(%edi)
  .byte  129,196,92,1,0,0                    // add           $0x15c,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_evenly_spaced_2_stop_gradient_sse2_lowp
.globl _sk_evenly_spaced_2_stop_gradient_sse2_lowp
FUNCTION(_sk_evenly_spaced_2_stop_gradient_sse2_lowp)
_sk_evenly_spaced_2_stop_gradient_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,96                          // sub           $0x60,%esp
  .byte  15,40,241                           // movaps        %xmm1,%xmm6
  .byte  232,0,0,0,0                         // call          f16d <_sk_evenly_spaced_2_stop_gradient_sse2_lowp+0x10>
  .byte  90                                  // pop           %edx
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  243,15,16,33                        // movss         (%ecx),%xmm4
  .byte  243,15,16,81,4                      // movss         0x4(%ecx),%xmm2
  .byte  15,198,228,0                        // shufps        $0x0,%xmm4,%xmm4
  .byte  243,15,16,89,16                     // movss         0x10(%ecx),%xmm3
  .byte  15,198,219,0                        // shufps        $0x0,%xmm3,%xmm3
  .byte  15,40,238                           // movaps        %xmm6,%xmm5
  .byte  15,89,236                           // mulps         %xmm4,%xmm5
  .byte  15,89,224                           // mulps         %xmm0,%xmm4
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,88,227                           // addps         %xmm3,%xmm4
  .byte  15,88,235                           // addps         %xmm3,%xmm5
  .byte  15,40,154,131,10,0,0                // movaps        0xa83(%edx),%xmm3
  .byte  15,89,235                           // mulps         %xmm3,%xmm5
  .byte  15,89,227                           // mulps         %xmm3,%xmm4
  .byte  15,40,130,163,9,0,0                 // movaps        0x9a3(%edx),%xmm0
  .byte  15,88,224                           // addps         %xmm0,%xmm4
  .byte  15,88,232                           // addps         %xmm0,%xmm5
  .byte  243,15,91,237                       // cvttps2dq     %xmm5,%xmm5
  .byte  242,15,112,237,232                  // pshuflw       $0xe8,%xmm5,%xmm5
  .byte  243,15,112,237,232                  // pshufhw       $0xe8,%xmm5,%xmm5
  .byte  102,15,112,237,232                  // pshufd        $0xe8,%xmm5,%xmm5
  .byte  243,15,91,228                       // cvttps2dq     %xmm4,%xmm4
  .byte  242,15,112,228,232                  // pshuflw       $0xe8,%xmm4,%xmm4
  .byte  243,15,112,228,232                  // pshufhw       $0xe8,%xmm4,%xmm4
  .byte  102,15,112,228,232                  // pshufd        $0xe8,%xmm4,%xmm4
  .byte  102,15,108,229                      // punpcklqdq    %xmm5,%xmm4
  .byte  102,15,127,101,232                  // movdqa        %xmm4,-0x18(%ebp)
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,105,20                    // movss         0x14(%ecx),%xmm5
  .byte  15,198,237,0                        // shufps        $0x0,%xmm5,%xmm5
  .byte  15,40,254                           // movaps        %xmm6,%xmm7
  .byte  15,89,250                           // mulps         %xmm2,%xmm7
  .byte  15,89,209                           // mulps         %xmm1,%xmm2
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,88,213                           // addps         %xmm5,%xmm2
  .byte  15,88,253                           // addps         %xmm5,%xmm7
  .byte  15,89,251                           // mulps         %xmm3,%xmm7
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  243,15,91,239                       // cvttps2dq     %xmm7,%xmm5
  .byte  242,15,112,237,232                  // pshuflw       $0xe8,%xmm5,%xmm5
  .byte  243,15,112,237,232                  // pshufhw       $0xe8,%xmm5,%xmm5
  .byte  102,15,112,253,232                  // pshufd        $0xe8,%xmm5,%xmm7
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  242,15,112,210,232                  // pshuflw       $0xe8,%xmm2,%xmm2
  .byte  243,15,112,210,232                  // pshufhw       $0xe8,%xmm2,%xmm2
  .byte  102,15,112,234,232                  // pshufd        $0xe8,%xmm2,%xmm5
  .byte  102,15,108,239                      // punpcklqdq    %xmm7,%xmm5
  .byte  243,15,16,81,8                      // movss         0x8(%ecx),%xmm2
  .byte  15,198,210,0                        // shufps        $0x0,%xmm2,%xmm2
  .byte  243,15,16,121,24                    // movss         0x18(%ecx),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,40,206                           // movaps        %xmm6,%xmm1
  .byte  15,89,202                           // mulps         %xmm2,%xmm1
  .byte  15,89,212                           // mulps         %xmm4,%xmm2
  .byte  15,88,215                           // addps         %xmm7,%xmm2
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  139,125,20                          // mov           0x14(%ebp),%edi
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,89,211                           // mulps         %xmm3,%xmm2
  .byte  15,88,208                           // addps         %xmm0,%xmm2
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  242,15,112,201,232                  // pshuflw       $0xe8,%xmm1,%xmm1
  .byte  243,15,112,201,232                  // pshufhw       $0xe8,%xmm1,%xmm1
  .byte  102,15,112,201,232                  // pshufd        $0xe8,%xmm1,%xmm1
  .byte  243,15,91,210                       // cvttps2dq     %xmm2,%xmm2
  .byte  242,15,112,210,232                  // pshuflw       $0xe8,%xmm2,%xmm2
  .byte  243,15,112,210,232                  // pshufhw       $0xe8,%xmm2,%xmm2
  .byte  102,15,112,210,232                  // pshufd        $0xe8,%xmm2,%xmm2
  .byte  102,15,108,209                      // punpcklqdq    %xmm1,%xmm2
  .byte  243,15,16,73,12                     // movss         0xc(%ecx),%xmm1
  .byte  15,198,201,0                        // shufps        $0x0,%xmm1,%xmm1
  .byte  15,89,241                           // mulps         %xmm1,%xmm6
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  243,15,16,121,28                    // movss         0x1c(%ecx),%xmm7
  .byte  15,198,255,0                        // shufps        $0x0,%xmm7,%xmm7
  .byte  15,88,207                           // addps         %xmm7,%xmm1
  .byte  15,88,247                           // addps         %xmm7,%xmm6
  .byte  15,40,101,24                        // movaps        0x18(%ebp),%xmm4
  .byte  15,89,243                           // mulps         %xmm3,%xmm6
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,40,125,40                        // movaps        0x28(%ebp),%xmm7
  .byte  15,88,200                           // addps         %xmm0,%xmm1
  .byte  15,88,240                           // addps         %xmm0,%xmm6
  .byte  15,40,69,56                         // movaps        0x38(%ebp),%xmm0
  .byte  243,15,91,222                       // cvttps2dq     %xmm6,%xmm3
  .byte  242,15,112,219,232                  // pshuflw       $0xe8,%xmm3,%xmm3
  .byte  243,15,112,219,232                  // pshufhw       $0xe8,%xmm3,%xmm3
  .byte  102,15,112,243,232                  // pshufd        $0xe8,%xmm3,%xmm6
  .byte  243,15,91,201                       // cvttps2dq     %xmm1,%xmm1
  .byte  242,15,112,201,232                  // pshuflw       $0xe8,%xmm1,%xmm1
  .byte  243,15,112,201,232                  // pshufhw       $0xe8,%xmm1,%xmm1
  .byte  102,15,112,217,232                  // pshufd        $0xe8,%xmm1,%xmm3
  .byte  102,15,108,222                      // punpcklqdq    %xmm6,%xmm3
  .byte  15,40,77,72                         // movaps        0x48(%ebp),%xmm1
  .byte  141,72,8                            // lea           0x8(%eax),%ecx
  .byte  15,41,76,36,64                      // movaps        %xmm1,0x40(%esp)
  .byte  15,41,68,36,48                      // movaps        %xmm0,0x30(%esp)
  .byte  15,41,124,36,32                     // movaps        %xmm7,0x20(%esp)
  .byte  15,41,100,36,16                     // movaps        %xmm4,0x10(%esp)
  .byte  137,124,36,12                       // mov           %edi,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,76,36,4                         // mov           %ecx,0x4(%esp)
  .byte  137,20,36                           // mov           %edx,(%esp)
  .byte  15,40,69,232                        // movaps        -0x18(%ebp),%xmm0
  .byte  102,15,111,205                      // movdqa        %xmm5,%xmm1
  .byte  255,80,4                            // call          *0x4(%eax)
  .byte  131,196,96                          // add           $0x60,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_xy_to_unit_angle_sse2_lowp
.globl _sk_xy_to_unit_angle_sse2_lowp
FUNCTION(_sk_xy_to_unit_angle_sse2_lowp)
_sk_xy_to_unit_angle_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,160,0,0,0                   // sub           $0xa0,%esp
  .byte  15,41,93,168                        // movaps        %xmm3,-0x58(%ebp)
  .byte  15,41,85,232                        // movaps        %xmm2,-0x18(%ebp)
  .byte  15,41,77,184                        // movaps        %xmm1,-0x48(%ebp)
  .byte  15,40,208                           // movaps        %xmm0,%xmm2
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  232,0,0,0,0                         // call          f358 <_sk_xy_to_unit_angle_sse2_lowp+0x23>
  .byte  88                                  // pop           %eax
  .byte  15,40,128,200,12,0,0                // movaps        0xcc8(%eax),%xmm0
  .byte  15,40,225                           // movaps        %xmm1,%xmm4
  .byte  15,84,224                           // andps         %xmm0,%xmm4
  .byte  15,40,203                           // movaps        %xmm3,%xmm1
  .byte  15,84,200                           // andps         %xmm0,%xmm1
  .byte  15,40,236                           // movaps        %xmm4,%xmm5
  .byte  15,194,233,1                        // cmpltps       %xmm1,%xmm5
  .byte  15,40,245                           // movaps        %xmm5,%xmm6
  .byte  15,85,241                           // andnps        %xmm1,%xmm6
  .byte  15,40,221                           // movaps        %xmm5,%xmm3
  .byte  15,85,220                           // andnps        %xmm4,%xmm3
  .byte  15,41,93,216                        // movaps        %xmm3,-0x28(%ebp)
  .byte  15,84,229                           // andps         %xmm5,%xmm4
  .byte  15,86,230                           // orps          %xmm6,%xmm4
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,84,248                           // andps         %xmm0,%xmm7
  .byte  15,84,69,232                        // andps         -0x18(%ebp),%xmm0
  .byte  15,40,215                           // movaps        %xmm7,%xmm2
  .byte  15,194,208,1                        // cmpltps       %xmm0,%xmm2
  .byte  15,40,242                           // movaps        %xmm2,%xmm6
  .byte  15,85,240                           // andnps        %xmm0,%xmm6
  .byte  15,40,218                           // movaps        %xmm2,%xmm3
  .byte  15,85,223                           // andnps        %xmm7,%xmm3
  .byte  15,84,250                           // andps         %xmm2,%xmm7
  .byte  15,86,254                           // orps          %xmm6,%xmm7
  .byte  15,84,205                           // andps         %xmm5,%xmm1
  .byte  15,86,77,216                        // orps          -0x28(%ebp),%xmm1
  .byte  15,94,225                           // divps         %xmm1,%xmm4
  .byte  15,84,194                           // andps         %xmm2,%xmm0
  .byte  15,86,195                           // orps          %xmm3,%xmm0
  .byte  15,94,248                           // divps         %xmm0,%xmm7
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  15,89,219                           // mulps         %xmm3,%xmm3
  .byte  15,40,247                           // movaps        %xmm7,%xmm6
  .byte  15,89,246                           // mulps         %xmm6,%xmm6
  .byte  15,40,136,104,13,0,0                // movaps        0xd68(%eax),%xmm1
  .byte  15,40,198                           // movaps        %xmm6,%xmm0
  .byte  15,89,193                           // mulps         %xmm1,%xmm0
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,88,136,120,13,0,0                // addps         0xd78(%eax),%xmm1
  .byte  15,88,128,120,13,0,0                // addps         0xd78(%eax),%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,88,136,136,13,0,0                // addps         0xd88(%eax),%xmm1
  .byte  15,88,128,136,13,0,0                // addps         0xd88(%eax),%xmm0
  .byte  15,89,198                           // mulps         %xmm6,%xmm0
  .byte  15,89,203                           // mulps         %xmm3,%xmm1
  .byte  15,40,152,152,13,0,0                // movaps        0xd98(%eax),%xmm3
  .byte  15,88,203                           // addps         %xmm3,%xmm1
  .byte  15,88,195                           // addps         %xmm3,%xmm0
  .byte  15,89,199                           // mulps         %xmm7,%xmm0
  .byte  15,89,204                           // mulps         %xmm4,%xmm1
  .byte  15,40,152,168,13,0,0                // movaps        0xda8(%eax),%xmm3
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  15,92,216                           // subps         %xmm0,%xmm3
  .byte  15,84,218                           // andps         %xmm2,%xmm3
  .byte  15,85,208                           // andnps        %xmm0,%xmm2
  .byte  15,86,211                           // orps          %xmm3,%xmm2
  .byte  15,92,225                           // subps         %xmm1,%xmm4
  .byte  15,84,229                           // andps         %xmm5,%xmm4
  .byte  15,85,233                           // andnps        %xmm1,%xmm5
  .byte  15,86,236                           // orps          %xmm4,%xmm5
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  15,40,93,200                        // movaps        -0x38(%ebp),%xmm3
  .byte  15,194,220,1                        // cmpltps       %xmm4,%xmm3
  .byte  15,40,128,184,7,0,0                 // movaps        0x7b8(%eax),%xmm0
  .byte  15,40,200                           // movaps        %xmm0,%xmm1
  .byte  15,92,194                           // subps         %xmm2,%xmm0
  .byte  15,84,195                           // andps         %xmm3,%xmm0
  .byte  15,85,218                           // andnps        %xmm2,%xmm3
  .byte  139,77,8                            // mov           0x8(%ebp),%ecx
  .byte  139,85,16                           // mov           0x10(%ebp),%edx
  .byte  139,117,20                          // mov           0x14(%ebp),%esi
  .byte  15,40,85,184                        // movaps        -0x48(%ebp),%xmm2
  .byte  15,194,212,1                        // cmpltps       %xmm4,%xmm2
  .byte  15,92,205                           // subps         %xmm5,%xmm1
  .byte  15,86,216                           // orps          %xmm0,%xmm3
  .byte  15,84,202                           // andps         %xmm2,%xmm1
  .byte  15,85,213                           // andnps        %xmm5,%xmm2
  .byte  15,86,209                           // orps          %xmm1,%xmm2
  .byte  15,40,242                           // movaps        %xmm2,%xmm6
  .byte  15,40,125,232                       // movaps        -0x18(%ebp),%xmm7
  .byte  15,40,199                           // movaps        %xmm7,%xmm0
  .byte  15,194,196,1                        // cmpltps       %xmm4,%xmm0
  .byte  15,40,136,200,7,0,0                 // movaps        0x7c8(%eax),%xmm1
  .byte  15,40,209                           // movaps        %xmm1,%xmm2
  .byte  15,92,203                           // subps         %xmm3,%xmm1
  .byte  15,84,200                           // andps         %xmm0,%xmm1
  .byte  15,85,195                           // andnps        %xmm3,%xmm0
  .byte  15,86,193                           // orps          %xmm1,%xmm0
  .byte  15,40,93,168                        // movaps        -0x58(%ebp),%xmm3
  .byte  15,40,235                           // movaps        %xmm3,%xmm5
  .byte  15,194,236,1                        // cmpltps       %xmm4,%xmm5
  .byte  15,92,214                           // subps         %xmm6,%xmm2
  .byte  15,84,213                           // andps         %xmm5,%xmm2
  .byte  15,85,238                           // andnps        %xmm6,%xmm5
  .byte  15,40,117,40                        // movaps        0x28(%ebp),%xmm6
  .byte  15,86,234                           // orps          %xmm2,%xmm5
  .byte  15,40,205                           // movaps        %xmm5,%xmm1
  .byte  15,194,204,7                        // cmpordps      %xmm4,%xmm1
  .byte  15,194,224,7                        // cmpordps      %xmm0,%xmm4
  .byte  15,84,224                           // andps         %xmm0,%xmm4
  .byte  15,40,69,56                         // movaps        0x38(%ebp),%xmm0
  .byte  15,84,205                           // andps         %xmm5,%xmm1
  .byte  15,40,85,72                         // movaps        0x48(%ebp),%xmm2
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  141,120,4                           // lea           0x4(%eax),%edi
  .byte  15,41,84,36,64                      // movaps        %xmm2,0x40(%esp)
  .byte  15,41,68,36,48                      // movaps        %xmm0,0x30(%esp)
  .byte  15,41,116,36,32                     // movaps        %xmm6,0x20(%esp)
  .byte  15,40,69,24                         // movaps        0x18(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  137,116,36,12                       // mov           %esi,0xc(%esp)
  .byte  137,84,36,8                         // mov           %edx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,12,36                           // mov           %ecx,(%esp)
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  15,40,215                           // movaps        %xmm7,%xmm2
  .byte  255,16                              // call          *(%eax)
  .byte  129,196,160,0,0,0                   // add           $0xa0,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_xy_to_radius_sse2_lowp
.globl _sk_xy_to_radius_sse2_lowp
FUNCTION(_sk_xy_to_radius_sse2_lowp)
_sk_xy_to_radius_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  131,236,80                          // sub           $0x50,%esp
  .byte  15,40,227                           // movaps        %xmm3,%xmm4
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  139,77,16                           // mov           0x10(%ebp),%ecx
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  15,40,117,56                        // movaps        0x38(%ebp),%xmm6
  .byte  15,89,192                           // mulps         %xmm0,%xmm0
  .byte  15,89,201                           // mulps         %xmm1,%xmm1
  .byte  15,40,250                           // movaps        %xmm2,%xmm7
  .byte  15,89,255                           // mulps         %xmm7,%xmm7
  .byte  15,88,248                           // addps         %xmm0,%xmm7
  .byte  15,89,219                           // mulps         %xmm3,%xmm3
  .byte  15,88,217                           // addps         %xmm1,%xmm3
  .byte  15,40,109,72                        // movaps        0x48(%ebp),%xmm5
  .byte  139,117,12                          // mov           0xc(%ebp),%esi
  .byte  15,81,199                           // sqrtps        %xmm7,%xmm0
  .byte  15,81,203                           // sqrtps        %xmm3,%xmm1
  .byte  141,126,4                           // lea           0x4(%esi),%edi
  .byte  15,41,108,36,64                     // movaps        %xmm5,0x40(%esp)
  .byte  15,41,116,36,48                     // movaps        %xmm6,0x30(%esp)
  .byte  15,40,93,40                         // movaps        0x28(%ebp),%xmm3
  .byte  15,41,92,36,32                      // movaps        %xmm3,0x20(%esp)
  .byte  15,40,93,24                         // movaps        0x18(%ebp),%xmm3
  .byte  15,41,92,36,16                      // movaps        %xmm3,0x10(%esp)
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,76,36,8                         // mov           %ecx,0x8(%esp)
  .byte  137,124,36,4                        // mov           %edi,0x4(%esp)
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  15,40,220                           // movaps        %xmm4,%xmm3
  .byte  255,22                              // call          *(%esi)
  .byte  131,196,80                          // add           $0x50,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret

HIDDEN _sk_srcover_rgba_8888_sse2_lowp
.globl _sk_srcover_rgba_8888_sse2_lowp
FUNCTION(_sk_srcover_rgba_8888_sse2_lowp)
_sk_srcover_rgba_8888_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,172,0,0,0                   // sub           $0xac,%esp
  .byte  102,15,111,227                      // movdqa        %xmm3,%xmm4
  .byte  15,41,85,200                        // movaps        %xmm2,-0x38(%ebp)
  .byte  15,41,77,216                        // movaps        %xmm1,-0x28(%ebp)
  .byte  102,15,111,248                      // movdqa        %xmm0,%xmm7
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,121,4                           // mov           0x4(%ecx),%edi
  .byte  15,175,125,20                       // imul          0x14(%ebp),%edi
  .byte  193,231,2                           // shl           $0x2,%edi
  .byte  3,57                                // add           (%ecx),%edi
  .byte  137,211                             // mov           %edx,%ebx
  .byte  128,227,7                           // and           $0x7,%bl
  .byte  254,203                             // dec           %bl
  .byte  128,251,6                           // cmp           $0x6,%bl
  .byte  232,0,0,0,0                         // call          f5c0 <_sk_srcover_rgba_8888_sse2_lowp+0x3f>
  .byte  89                                  // pop           %ecx
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  15,182,211                          // movzbl        %bl,%edx
  .byte  119,29                              // ja            f5e6 <_sk_srcover_rgba_8888_sse2_lowp+0x65>
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  139,132,145,76,2,0,0                // mov           0x24c(%ecx,%edx,4),%eax
  .byte  1,200                               // add           %ecx,%eax
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  255,224                             // jmp           *%eax
  .byte  243,15,16,52,183                    // movss         (%edi,%esi,4),%xmm6
  .byte  15,87,219                           // xorps         %xmm3,%xmm3
  .byte  235,73                              // jmp           f62f <_sk_srcover_rgba_8888_sse2_lowp+0xae>
  .byte  102,15,16,52,183                    // movupd        (%edi,%esi,4),%xmm6
  .byte  15,16,92,183,16                     // movups        0x10(%edi,%esi,4),%xmm3
  .byte  235,61                              // jmp           f62f <_sk_srcover_rgba_8888_sse2_lowp+0xae>
  .byte  102,15,110,68,183,8                 // movd          0x8(%edi,%esi,4),%xmm0
  .byte  102,15,112,240,69                   // pshufd        $0x45,%xmm0,%xmm6
  .byte  102,15,18,52,183                    // movlpd        (%edi,%esi,4),%xmm6
  .byte  235,43                              // jmp           f62f <_sk_srcover_rgba_8888_sse2_lowp+0xae>
  .byte  102,15,110,68,183,24                // movd          0x18(%edi,%esi,4),%xmm0
  .byte  102,15,112,216,69                   // pshufd        $0x45,%xmm0,%xmm3
  .byte  243,15,16,68,183,20                 // movss         0x14(%edi,%esi,4),%xmm0
  .byte  15,198,195,0                        // shufps        $0x0,%xmm3,%xmm0
  .byte  15,198,195,226                      // shufps        $0xe2,%xmm3,%xmm0
  .byte  15,40,216                           // movaps        %xmm0,%xmm3
  .byte  243,15,16,68,183,16                 // movss         0x10(%edi,%esi,4),%xmm0
  .byte  243,15,16,216                       // movss         %xmm0,%xmm3
  .byte  102,15,16,52,183                    // movupd        (%edi,%esi,4),%xmm6
  .byte  102,15,40,206                       // movapd        %xmm6,%xmm1
  .byte  102,15,114,241,16                   // pslld         $0x10,%xmm1
  .byte  102,15,114,225,16                   // psrad         $0x10,%xmm1
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,107,200                      // packssdw      %xmm0,%xmm1
  .byte  15,40,195                           // movaps        %xmm3,%xmm0
  .byte  102,15,40,214                       // movapd        %xmm6,%xmm2
  .byte  102,15,114,214,24                   // psrld         $0x18,%xmm6
  .byte  102,15,114,246,16                   // pslld         $0x10,%xmm6
  .byte  102,15,114,230,16                   // psrad         $0x10,%xmm6
  .byte  102,15,114,211,24                   // psrld         $0x18,%xmm3
  .byte  102,15,114,243,16                   // pslld         $0x10,%xmm3
  .byte  102,15,114,227,16                   // psrad         $0x10,%xmm3
  .byte  102,15,107,243                      // packssdw      %xmm3,%xmm6
  .byte  102,15,111,153,64,12,0,0            // movdqa        0xc40(%ecx),%xmm3
  .byte  102,15,114,208,16                   // psrld         $0x10,%xmm0
  .byte  102,15,114,210,16                   // psrld         $0x10,%xmm2
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,114,226,16                   // psrad         $0x10,%xmm2
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,107,208                      // packssdw      %xmm0,%xmm2
  .byte  102,15,111,193                      // movdqa        %xmm1,%xmm0
  .byte  102,15,219,195                      // pand          %xmm3,%xmm0
  .byte  102,15,111,235                      // movdqa        %xmm3,%xmm5
  .byte  102,15,249,236                      // psubw         %xmm4,%xmm5
  .byte  102,15,127,69,184                   // movdqa        %xmm0,-0x48(%ebp)
  .byte  102,15,213,197                      // pmullw        %xmm5,%xmm0
  .byte  102,15,253,195                      // paddw         %xmm3,%xmm0
  .byte  102,15,113,208,8                    // psrlw         $0x8,%xmm0
  .byte  102,15,253,199                      // paddw         %xmm7,%xmm0
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,127,77,152                   // movdqa        %xmm1,-0x68(%ebp)
  .byte  102,15,213,205                      // pmullw        %xmm5,%xmm1
  .byte  102,15,253,203                      // paddw         %xmm3,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,253,77,216                   // paddw         -0x28(%ebp),%xmm1
  .byte  102,15,219,211                      // pand          %xmm3,%xmm2
  .byte  102,15,127,85,216                   // movdqa        %xmm2,-0x28(%ebp)
  .byte  102,15,111,250                      // movdqa        %xmm2,%xmm7
  .byte  102,15,213,253                      // pmullw        %xmm5,%xmm7
  .byte  102,15,253,251                      // paddw         %xmm3,%xmm7
  .byte  102,15,113,215,8                    // psrlw         $0x8,%xmm7
  .byte  102,15,253,125,200                  // paddw         -0x38(%ebp),%xmm7
  .byte  102,15,127,117,200                  // movdqa        %xmm6,-0x38(%ebp)
  .byte  102,15,213,238                      // pmullw        %xmm6,%xmm5
  .byte  102,15,253,235                      // paddw         %xmm3,%xmm5
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,15,253,236                      // paddw         %xmm4,%xmm5
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,113,246,8                    // psllw         $0x8,%xmm6
  .byte  102,15,127,69,168                   // movdqa        %xmm0,-0x58(%ebp)
  .byte  102,15,235,240                      // por           %xmm0,%xmm6
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,111,214                      // movdqa        %xmm6,%xmm2
  .byte  102,15,97,211                       // punpcklwd     %xmm3,%xmm2
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,113,244,8                    // psllw         $0x8,%xmm4
  .byte  102,15,235,231                      // por           %xmm7,%xmm4
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,97,196                       // punpcklwd     %xmm4,%xmm0
  .byte  102,15,235,194                      // por           %xmm2,%xmm0
  .byte  102,15,105,243                      // punpckhwd     %xmm3,%xmm6
  .byte  102,15,105,220                      // punpckhwd     %xmm4,%xmm3
  .byte  102,15,235,222                      // por           %xmm6,%xmm3
  .byte  128,251,6                           // cmp           $0x6,%bl
  .byte  119,16                              // ja            f770 <_sk_srcover_rgba_8888_sse2_lowp+0x1ef>
  .byte  3,140,145,104,2,0,0                 // add           0x268(%ecx,%edx,4),%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  102,15,126,4,183                    // movd          %xmm0,(%edi,%esi,4)
  .byte  235,64                              // jmp           f7b0 <_sk_srcover_rgba_8888_sse2_lowp+0x22f>
  .byte  243,15,127,4,183                    // movdqu        %xmm0,(%edi,%esi,4)
  .byte  243,15,127,92,183,16                // movdqu        %xmm3,0x10(%edi,%esi,4)
  .byte  235,51                              // jmp           f7b0 <_sk_srcover_rgba_8888_sse2_lowp+0x22f>
  .byte  102,15,112,208,78                   // pshufd        $0x4e,%xmm0,%xmm2
  .byte  102,15,126,84,183,8                 // movd          %xmm2,0x8(%edi,%esi,4)
  .byte  102,15,214,4,183                    // movq          %xmm0,(%edi,%esi,4)
  .byte  235,33                              // jmp           f7b0 <_sk_srcover_rgba_8888_sse2_lowp+0x22f>
  .byte  102,15,112,211,78                   // pshufd        $0x4e,%xmm3,%xmm2
  .byte  102,15,126,84,183,24                // movd          %xmm2,0x18(%edi,%esi,4)
  .byte  102,15,112,211,229                  // pshufd        $0xe5,%xmm3,%xmm2
  .byte  102,15,126,84,183,20                // movd          %xmm2,0x14(%edi,%esi,4)
  .byte  102,15,126,92,183,16                // movd          %xmm3,0x10(%edi,%esi,4)
  .byte  243,15,127,4,183                    // movdqu        %xmm0,(%edi,%esi,4)
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  137,193                             // mov           %eax,%ecx
  .byte  141,65,8                            // lea           0x8(%ecx),%eax
  .byte  15,40,69,200                        // movaps        -0x38(%ebp),%xmm0
  .byte  15,41,68,36,64                      // movaps        %xmm0,0x40(%esp)
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,41,68,36,48                      // movaps        %xmm0,0x30(%esp)
  .byte  15,40,69,152                        // movaps        -0x68(%ebp),%xmm0
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  15,40,69,184                        // movaps        -0x48(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,68,36,4                         // mov           %eax,0x4(%esp)
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  15,40,69,168                        // movaps        -0x58(%ebp),%xmm0
  .byte  102,15,111,215                      // movdqa        %xmm7,%xmm2
  .byte  102,15,111,221                      // movdqa        %xmm5,%xmm3
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  129,196,172,0,0,0                   // add           $0xac,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  144                                 // nop
  .byte  28,0                                // sbb           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  61,0,0,0,50                         // cmp           $0x32000000,%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,106,0                             // add           %ch,0x0(%edx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  96                                  // pusha
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,79,0                              // add           %cl,0x0(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  68                                  // inc           %esp
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,169,1,0,0,200                     // add           %ch,-0x37ffffff(%ecx)
  .byte  1,0                                 // add           %eax,(%eax)
  .byte  0,189,1,0,0,235                     // add           %bh,-0x14ffffff(%ebp)
  .byte  1,0                                 // add           %eax,(%eax)
  .byte  0,229                               // add           %ah,%ch
  .byte  1,0                                 // add           %eax,(%eax)
  .byte  0,218                               // add           %bl,%dl
  .byte  1,0                                 // add           %eax,(%eax)
  .byte  0,207                               // add           %cl,%bh
  .byte  1,0                                 // add           %eax,(%eax)
  .byte  0                                   // .byte         0x0

HIDDEN _sk_srcover_bgra_8888_sse2_lowp
.globl _sk_srcover_bgra_8888_sse2_lowp
FUNCTION(_sk_srcover_bgra_8888_sse2_lowp)
_sk_srcover_bgra_8888_sse2_lowp:
  .byte  85                                  // push          %ebp
  .byte  137,229                             // mov           %esp,%ebp
  .byte  83                                  // push          %ebx
  .byte  87                                  // push          %edi
  .byte  86                                  // push          %esi
  .byte  129,236,188,0,0,0                   // sub           $0xbc,%esp
  .byte  102,15,111,251                      // movdqa        %xmm3,%xmm7
  .byte  15,41,85,184                        // movaps        %xmm2,-0x48(%ebp)
  .byte  15,41,77,200                        // movaps        %xmm1,-0x38(%ebp)
  .byte  102,15,127,69,216                   // movdqa        %xmm0,-0x28(%ebp)
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  139,85,8                            // mov           0x8(%ebp),%edx
  .byte  139,8                               // mov           (%eax),%ecx
  .byte  139,121,4                           // mov           0x4(%ecx),%edi
  .byte  15,175,125,20                       // imul          0x14(%ebp),%edi
  .byte  193,231,2                           // shl           $0x2,%edi
  .byte  3,57                                // add           (%ecx),%edi
  .byte  137,211                             // mov           %edx,%ebx
  .byte  128,227,7                           // and           $0x7,%bl
  .byte  254,203                             // dec           %bl
  .byte  128,251,6                           // cmp           $0x6,%bl
  .byte  232,0,0,0,0                         // call          f884 <_sk_srcover_bgra_8888_sse2_lowp+0x40>
  .byte  89                                  // pop           %ecx
  .byte  139,117,16                          // mov           0x10(%ebp),%esi
  .byte  15,182,211                          // movzbl        %bl,%edx
  .byte  119,29                              // ja            f8aa <_sk_srcover_bgra_8888_sse2_lowp+0x66>
  .byte  102,15,239,228                      // pxor          %xmm4,%xmm4
  .byte  139,132,145,80,2,0,0                // mov           0x250(%ecx,%edx,4),%eax
  .byte  1,200                               // add           %ecx,%eax
  .byte  102,15,239,246                      // pxor          %xmm6,%xmm6
  .byte  255,224                             // jmp           *%eax
  .byte  243,15,16,52,183                    // movss         (%edi,%esi,4),%xmm6
  .byte  15,87,228                           // xorps         %xmm4,%xmm4
  .byte  235,73                              // jmp           f8f3 <_sk_srcover_bgra_8888_sse2_lowp+0xaf>
  .byte  102,15,16,52,183                    // movupd        (%edi,%esi,4),%xmm6
  .byte  15,16,100,183,16                    // movups        0x10(%edi,%esi,4),%xmm4
  .byte  235,61                              // jmp           f8f3 <_sk_srcover_bgra_8888_sse2_lowp+0xaf>
  .byte  102,15,110,68,183,8                 // movd          0x8(%edi,%esi,4),%xmm0
  .byte  102,15,112,240,69                   // pshufd        $0x45,%xmm0,%xmm6
  .byte  102,15,18,52,183                    // movlpd        (%edi,%esi,4),%xmm6
  .byte  235,43                              // jmp           f8f3 <_sk_srcover_bgra_8888_sse2_lowp+0xaf>
  .byte  102,15,110,68,183,24                // movd          0x18(%edi,%esi,4),%xmm0
  .byte  102,15,112,224,69                   // pshufd        $0x45,%xmm0,%xmm4
  .byte  243,15,16,68,183,20                 // movss         0x14(%edi,%esi,4),%xmm0
  .byte  15,198,196,0                        // shufps        $0x0,%xmm4,%xmm0
  .byte  15,198,196,226                      // shufps        $0xe2,%xmm4,%xmm0
  .byte  15,40,224                           // movaps        %xmm0,%xmm4
  .byte  243,15,16,68,183,16                 // movss         0x10(%edi,%esi,4),%xmm0
  .byte  243,15,16,224                       // movss         %xmm0,%xmm4
  .byte  102,15,16,52,183                    // movupd        (%edi,%esi,4),%xmm6
  .byte  102,15,40,206                       // movapd        %xmm6,%xmm1
  .byte  102,15,114,241,16                   // pslld         $0x10,%xmm1
  .byte  102,15,114,225,16                   // psrad         $0x10,%xmm1
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,107,200                      // packssdw      %xmm0,%xmm1
  .byte  15,40,196                           // movaps        %xmm4,%xmm0
  .byte  102,15,40,214                       // movapd        %xmm6,%xmm2
  .byte  102,15,114,214,24                   // psrld         $0x18,%xmm6
  .byte  102,15,114,246,16                   // pslld         $0x10,%xmm6
  .byte  102,15,114,230,16                   // psrad         $0x10,%xmm6
  .byte  102,15,114,212,24                   // psrld         $0x18,%xmm4
  .byte  102,15,114,244,16                   // pslld         $0x10,%xmm4
  .byte  102,15,114,228,16                   // psrad         $0x10,%xmm4
  .byte  102,15,107,244                      // packssdw      %xmm4,%xmm6
  .byte  102,15,111,153,124,9,0,0            // movdqa        0x97c(%ecx),%xmm3
  .byte  102,15,114,208,16                   // psrld         $0x10,%xmm0
  .byte  102,15,114,210,16                   // psrld         $0x10,%xmm2
  .byte  102,15,114,242,16                   // pslld         $0x10,%xmm2
  .byte  102,15,114,226,16                   // psrad         $0x10,%xmm2
  .byte  102,15,114,240,16                   // pslld         $0x10,%xmm0
  .byte  102,15,114,224,16                   // psrad         $0x10,%xmm0
  .byte  102,15,107,208                      // packssdw      %xmm0,%xmm2
  .byte  102,15,219,211                      // pand          %xmm3,%xmm2
  .byte  102,15,111,235                      // movdqa        %xmm3,%xmm5
  .byte  102,15,249,239                      // psubw         %xmm7,%xmm5
  .byte  102,15,127,85,136                   // movdqa        %xmm2,-0x78(%ebp)
  .byte  102,15,213,213                      // pmullw        %xmm5,%xmm2
  .byte  102,15,253,211                      // paddw         %xmm3,%xmm2
  .byte  102,15,113,210,8                    // psrlw         $0x8,%xmm2
  .byte  102,15,253,85,216                   // paddw         -0x28(%ebp),%xmm2
  .byte  102,15,111,225                      // movdqa        %xmm1,%xmm4
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,127,77,216                   // movdqa        %xmm1,-0x28(%ebp)
  .byte  102,15,213,205                      // pmullw        %xmm5,%xmm1
  .byte  102,15,253,203                      // paddw         %xmm3,%xmm1
  .byte  102,15,113,209,8                    // psrlw         $0x8,%xmm1
  .byte  102,15,253,77,200                   // paddw         -0x38(%ebp),%xmm1
  .byte  102,15,219,227                      // pand          %xmm3,%xmm4
  .byte  102,15,127,101,168                  // movdqa        %xmm4,-0x58(%ebp)
  .byte  102,15,213,229                      // pmullw        %xmm5,%xmm4
  .byte  102,15,253,227                      // paddw         %xmm3,%xmm4
  .byte  102,15,113,212,8                    // psrlw         $0x8,%xmm4
  .byte  102,15,253,101,184                  // paddw         -0x48(%ebp),%xmm4
  .byte  102,15,127,117,184                  // movdqa        %xmm6,-0x48(%ebp)
  .byte  102,15,213,238                      // pmullw        %xmm6,%xmm5
  .byte  102,15,253,235                      // paddw         %xmm3,%xmm5
  .byte  102,15,113,213,8                    // psrlw         $0x8,%xmm5
  .byte  102,15,253,239                      // paddw         %xmm7,%xmm5
  .byte  102,15,111,241                      // movdqa        %xmm1,%xmm6
  .byte  102,15,113,246,8                    // psllw         $0x8,%xmm6
  .byte  102,15,127,101,152                  // movdqa        %xmm4,-0x68(%ebp)
  .byte  102,15,235,244                      // por           %xmm4,%xmm6
  .byte  102,15,239,219                      // pxor          %xmm3,%xmm3
  .byte  102,15,111,254                      // movdqa        %xmm6,%xmm7
  .byte  102,15,97,251                       // punpcklwd     %xmm3,%xmm7
  .byte  102,15,111,229                      // movdqa        %xmm5,%xmm4
  .byte  102,15,113,244,8                    // psllw         $0x8,%xmm4
  .byte  102,15,127,85,200                   // movdqa        %xmm2,-0x38(%ebp)
  .byte  102,15,235,226                      // por           %xmm2,%xmm4
  .byte  102,15,239,192                      // pxor          %xmm0,%xmm0
  .byte  102,15,97,196                       // punpcklwd     %xmm4,%xmm0
  .byte  102,15,235,199                      // por           %xmm7,%xmm0
  .byte  102,15,105,243                      // punpckhwd     %xmm3,%xmm6
  .byte  102,15,105,220                      // punpckhwd     %xmm4,%xmm3
  .byte  102,15,235,222                      // por           %xmm6,%xmm3
  .byte  128,251,6                           // cmp           $0x6,%bl
  .byte  119,16                              // ja            fa36 <_sk_srcover_bgra_8888_sse2_lowp+0x1f2>
  .byte  3,140,145,108,2,0,0                 // add           0x26c(%ecx,%edx,4),%ecx
  .byte  255,225                             // jmp           *%ecx
  .byte  102,15,126,4,183                    // movd          %xmm0,(%edi,%esi,4)
  .byte  235,64                              // jmp           fa76 <_sk_srcover_bgra_8888_sse2_lowp+0x232>
  .byte  243,15,127,4,183                    // movdqu        %xmm0,(%edi,%esi,4)
  .byte  243,15,127,92,183,16                // movdqu        %xmm3,0x10(%edi,%esi,4)
  .byte  235,51                              // jmp           fa76 <_sk_srcover_bgra_8888_sse2_lowp+0x232>
  .byte  102,15,112,208,78                   // pshufd        $0x4e,%xmm0,%xmm2
  .byte  102,15,126,84,183,8                 // movd          %xmm2,0x8(%edi,%esi,4)
  .byte  102,15,214,4,183                    // movq          %xmm0,(%edi,%esi,4)
  .byte  235,33                              // jmp           fa76 <_sk_srcover_bgra_8888_sse2_lowp+0x232>
  .byte  102,15,112,211,78                   // pshufd        $0x4e,%xmm3,%xmm2
  .byte  102,15,126,84,183,24                // movd          %xmm2,0x18(%edi,%esi,4)
  .byte  102,15,112,211,229                  // pshufd        $0xe5,%xmm3,%xmm2
  .byte  102,15,126,84,183,20                // movd          %xmm2,0x14(%edi,%esi,4)
  .byte  102,15,126,92,183,16                // movd          %xmm3,0x10(%edi,%esi,4)
  .byte  243,15,127,4,183                    // movdqu        %xmm0,(%edi,%esi,4)
  .byte  139,69,12                           // mov           0xc(%ebp),%eax
  .byte  137,193                             // mov           %eax,%ecx
  .byte  141,65,8                            // lea           0x8(%ecx),%eax
  .byte  15,40,69,184                        // movaps        -0x48(%ebp),%xmm0
  .byte  15,41,68,36,64                      // movaps        %xmm0,0x40(%esp)
  .byte  15,40,69,168                        // movaps        -0x58(%ebp),%xmm0
  .byte  15,41,68,36,48                      // movaps        %xmm0,0x30(%esp)
  .byte  15,40,69,216                        // movaps        -0x28(%ebp),%xmm0
  .byte  15,41,68,36,32                      // movaps        %xmm0,0x20(%esp)
  .byte  15,40,69,136                        // movaps        -0x78(%ebp),%xmm0
  .byte  15,41,68,36,16                      // movaps        %xmm0,0x10(%esp)
  .byte  139,85,20                           // mov           0x14(%ebp),%edx
  .byte  137,84,36,12                        // mov           %edx,0xc(%esp)
  .byte  137,116,36,8                        // mov           %esi,0x8(%esp)
  .byte  137,68,36,4                         // mov           %eax,0x4(%esp)
  .byte  139,69,8                            // mov           0x8(%ebp),%eax
  .byte  137,4,36                            // mov           %eax,(%esp)
  .byte  15,40,69,200                        // movaps        -0x38(%ebp),%xmm0
  .byte  15,40,85,152                        // movaps        -0x68(%ebp),%xmm2
  .byte  102,15,111,221                      // movdqa        %xmm5,%xmm3
  .byte  255,81,4                            // call          *0x4(%ecx)
  .byte  129,196,188,0,0,0                   // add           $0xbc,%esp
  .byte  94                                  // pop           %esi
  .byte  95                                  // pop           %edi
  .byte  91                                  // pop           %ebx
  .byte  93                                  // pop           %ebp
  .byte  195                                 // ret
  .byte  15,31,0                             // nopl          (%eax)
  .byte  28,0                                // sbb           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  61,0,0,0,50                         // cmp           $0x32000000,%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,106,0                             // add           %ch,0x0(%edx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  96                                  // pusha
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,79,0                              // add           %cl,0x0(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  68                                  // inc           %esp
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,171,1,0,0,202                     // add           %ch,-0x35ffffff(%ebx)
  .byte  1,0                                 // add           %eax,(%eax)
  .byte  0,191,1,0,0,237                     // add           %bh,-0x12ffffff(%edi)
  .byte  1,0                                 // add           %eax,(%eax)
  .byte  0,231                               // add           %ah,%bh
  .byte  1,0                                 // add           %eax,(%eax)
  .byte  0,220                               // add           %bl,%ah
  .byte  1,0                                 // add           %eax,(%eax)
  .byte  0,209                               // add           %dl,%cl
  .byte  1,0                                 // add           %eax,(%eax)
  .byte  0                                   // .byte         0x0

BALIGN16
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  128,63,0                            // cmpb          $0x0,(%edi)
  .byte  0,128,63,0,0,128                    // add           %al,-0x7fffffc1(%eax)
  .byte  63                                  // aas
  .byte  0,0                                 // add           %al,(%eax)
  .byte  128,63,0                            // cmpb          $0x0,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,1                                 // add           %al,(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,2                                 // add           %al,(%edx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,3                                 // add           %al,(%ebx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,1                                 // add           %al,(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,1                                 // add           %al,(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,1                                 // add           %al,(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,1                                 // add           %al,(%ecx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,4,0                               // add           %al,(%eax,%eax,1)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  2,0                                 // add           (%eax),%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  2,0                                 // add           (%eax),%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  2,0                                 // add           (%eax),%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  2,0                                 // add           (%eax),%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  128,60,0,0                          // cmpb          $0x0,(%eax,%eax,1)
  .byte  128,60,0,0                          // cmpb          $0x0,(%eax,%eax,1)
  .byte  128,60,0,0                          // cmpb          $0x0,(%eax,%eax,1)
  .byte  128,60,0,0                          // cmpb          $0x0,(%eax,%eax,1)
  .byte  252                                 // cld
  .byte  190,0,0,252,190                     // mov           $0xbefc0000,%esi
  .byte  0,0                                 // add           %al,(%eax)
  .byte  252                                 // cld
  .byte  190,0,0,252,190                     // mov           $0xbefc0000,%esi
  .byte  0,0                                 // add           %al,(%eax)
  .byte  128,191,0,0,128,191,0               // cmpb          $0x0,-0x40800000(%edi)
  .byte  0,128,191,0,0,128                   // add           %al,-0x7fffff41(%eax)
  .byte  191,0,0,224,64                      // mov           $0x40e00000,%edi
  .byte  0,0                                 // add           %al,(%eax)
  .byte  224,64                              // loopne        fbe8 <.literal16+0xd8>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  224,64                              // loopne        fbec <.literal16+0xdc>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  224,64                              // loopne        fbf0 <.literal16+0xe0>
  .byte  154,153,153,62,154,153,153          // lcall         $0x9999,$0x9a3e9999
  .byte  62,154,153,153,62,154,153,153       // ds            lcall $0x9999,$0x9a3e9999
  .byte  62,61,10,23,63,61                   // ds            cmp $0x3d3f170a,%eax
  .byte  10,23                               // or            (%edi),%dl
  .byte  63                                  // aas
  .byte  61,10,23,63,61                      // cmp           $0x3d3f170a,%eax
  .byte  10,23                               // or            (%edi),%dl
  .byte  63                                  // aas
  .byte  174                                 // scas          %es:(%edi),%al
  .byte  71                                  // inc           %edi
  .byte  225,61                              // loope         fc11 <.literal16+0x101>
  .byte  174                                 // scas          %es:(%edi),%al
  .byte  71                                  // inc           %edi
  .byte  225,61                              // loope         fc15 <.literal16+0x105>
  .byte  174                                 // scas          %es:(%edi),%al
  .byte  71                                  // inc           %edi
  .byte  225,61                              // loope         fc19 <.literal16+0x109>
  .byte  174                                 // scas          %es:(%edi),%al
  .byte  71                                  // inc           %edi
  .byte  225,61                              // loope         fc1d <.literal16+0x10d>
  .byte  255,0                               // incl          (%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  255,0                               // incl          (%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  255,0                               // incl          (%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  255,0                               // incl          (%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  127,67                              // jg            fc37 <.literal16+0x127>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  127,67                              // jg            fc3b <.literal16+0x12b>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  127,67                              // jg            fc3f <.literal16+0x12f>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  127,67                              // jg            fc43 <.literal16+0x133>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  128,127,0,0                         // cmpb          $0x0,0x0(%edi)
  .byte  128,127,0,0                         // cmpb          $0x0,0x0(%edi)
  .byte  128,127,0,0                         // cmpb          $0x0,0x0(%edi)
  .byte  128,127,145,131                     // cmpb          $0x83,-0x6f(%edi)
  .byte  158                                 // sahf
  .byte  61,145,131,158,61                   // cmp           $0x3d9e8391,%eax
  .byte  145                                 // xchg          %eax,%ecx
  .byte  131,158,61,145,131,158,61           // sbbl          $0x3d,-0x617c6ec3(%esi)
  .byte  92                                  // pop           %esp
  .byte  143                                 // (bad)
  .byte  50,63                               // xor           (%edi),%bh
  .byte  92                                  // pop           %esp
  .byte  143                                 // (bad)
  .byte  50,63                               // xor           (%edi),%bh
  .byte  92                                  // pop           %esp
  .byte  143                                 // (bad)
  .byte  50,63                               // xor           (%edi),%bh
  .byte  92                                  // pop           %esp
  .byte  143                                 // (bad)
  .byte  50,63                               // xor           (%edi),%bh
  .byte  10,215                              // or            %bh,%dl
  .byte  35,59                               // and           (%ebx),%edi
  .byte  10,215                              // or            %bh,%dl
  .byte  35,59                               // and           (%ebx),%edi
  .byte  10,215                              // or            %bh,%dl
  .byte  35,59                               // and           (%ebx),%edi
  .byte  10,215                              // or            %bh,%dl
  .byte  35,59                               // and           (%ebx),%edi
  .byte  174                                 // scas          %es:(%edi),%al
  .byte  71                                  // inc           %edi
  .byte  97                                  // popa
  .byte  61,174,71,97,61                     // cmp           $0x3d6147ae,%eax
  .byte  174                                 // scas          %es:(%edi),%al
  .byte  71                                  // inc           %edi
  .byte  97                                  // popa
  .byte  61,174,71,97,61                     // cmp           $0x3d6147ae,%eax
  .byte  82                                  // push          %edx
  .byte  184,78,65,82,184                    // mov           $0xb852414e,%eax
  .byte  78                                  // dec           %esi
  .byte  65                                  // inc           %ecx
  .byte  82                                  // push          %edx
  .byte  184,78,65,82,184                    // mov           $0xb852414e,%eax
  .byte  78                                  // dec           %esi
  .byte  65                                  // inc           %ecx
  .byte  57,215                              // cmp           %edx,%edi
  .byte  32,187,57,215,32,187                // and           %bh,-0x44df28c7(%ebx)
  .byte  57,215                              // cmp           %edx,%edi
  .byte  32,187,57,215,32,187                // and           %bh,-0x44df28c7(%ebx)
  .byte  186,159,98,60,186                   // mov           $0xba3c629f,%edx
  .byte  159                                 // lahf
  .byte  98,60,186                           // bound         %edi,(%edx,%edi,4)
  .byte  159                                 // lahf
  .byte  98,60,186                           // bound         %edi,(%edx,%edi,4)
  .byte  159                                 // lahf
  .byte  98,60,109,165,144,63,109            // bound         %edi,0x6d3f90a5(,%ebp,2)
  .byte  165                                 // movsl         %ds:(%esi),%es:(%edi)
  .byte  144                                 // nop
  .byte  63                                  // aas
  .byte  109                                 // insl          (%dx),%es:(%edi)
  .byte  165                                 // movsl         %ds:(%esi),%es:(%edi)
  .byte  144                                 // nop
  .byte  63                                  // aas
  .byte  109                                 // insl          (%dx),%es:(%edi)
  .byte  165                                 // movsl         %ds:(%esi),%es:(%edi)
  .byte  144                                 // nop
  .byte  63                                  // aas
  .byte  252                                 // cld
  .byte  191,16,62,252,191                   // mov           $0xbffc3e10,%edi
  .byte  16,62                               // adc           %bh,(%esi)
  .byte  252                                 // cld
  .byte  191,16,62,252,191                   // mov           $0xbffc3e10,%edi
  .byte  16,62                               // adc           %bh,(%esi)
  .byte  168,177                             // test          $0xb1,%al
  .byte  152                                 // cwtl
  .byte  59,168,177,152,59,168               // cmp           -0x57c4674f(%eax),%ebp
  .byte  177,152                             // mov           $0x98,%cl
  .byte  59,168,177,152,59,0                 // cmp           0x3b98b1(%eax),%ebp
  .byte  0,192                               // add           %al,%al
  .byte  64                                  // inc           %eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  192,64,0,0                          // rolb          $0x0,0x0(%eax)
  .byte  192,64,0,0                          // rolb          $0x0,0x0(%eax)
  .byte  192,64,0,0                          // rolb          $0x0,0x0(%eax)
  .byte  0,64,0                              // add           %al,0x0(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  64                                  // inc           %eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,64,0                              // add           %al,0x0(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  64                                  // inc           %eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  128,64,0,0                          // addb          $0x0,0x0(%eax)
  .byte  128,64,0,0                          // addb          $0x0,0x0(%eax)
  .byte  128,64,0,0                          // addb          $0x0,0x0(%eax)
  .byte  128,64,171,170                      // addb          $0xaa,-0x55(%eax)
  .byte  42,62                               // sub           (%esi),%bh
  .byte  171                                 // stos          %eax,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  42,62                               // sub           (%esi),%bh
  .byte  171                                 // stos          %eax,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  42,62                               // sub           (%esi),%bh
  .byte  171                                 // stos          %eax,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  42,62                               // sub           (%esi),%bh
  .byte  171                                 // stos          %eax,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  62,171                              // ds            stos %eax,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  62,171                              // ds            stos %eax,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  62,171                              // ds            stos %eax,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  62,171                              // ds            stos %eax,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  42,63                               // sub           (%edi),%bh
  .byte  171                                 // stos          %eax,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  42,63                               // sub           (%edi),%bh
  .byte  171                                 // stos          %eax,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  42,63                               // sub           (%edi),%bh
  .byte  171                                 // stos          %eax,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  42,63                               // sub           (%edi),%bh
  .byte  171                                 // stos          %eax,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  190,171,170,170,190                 // mov           $0xbeaaaaab,%esi
  .byte  171                                 // stos          %eax,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  170                                 // stos          %al,%es:(%edi)
  .byte  190,171,170,170,190                 // mov           $0xbeaaaaab,%esi
  .byte  129,128,128,59,129,128,128,59,129,128// addl          $0x80813b80,-0x7f7ec480(%eax)
  .byte  128,59,129                          // cmpb          $0x81,(%ebx)
  .byte  128,128,59,0,248,0,0                // addb          $0x0,0xf8003b(%eax)
  .byte  0,248                               // add           %bh,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,248                               // add           %bh,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,248                               // add           %bh,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  8,33                                // or            %ah,(%ecx)
  .byte  132,55                              // test          %dh,(%edi)
  .byte  8,33                                // or            %ah,(%ecx)
  .byte  132,55                              // test          %dh,(%edi)
  .byte  8,33                                // or            %ah,(%ecx)
  .byte  132,55                              // test          %dh,(%edi)
  .byte  8,33                                // or            %ah,(%ecx)
  .byte  132,55                              // test          %dh,(%edi)
  .byte  224,7                               // loopne        fd59 <.literal16+0x249>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  224,7                               // loopne        fd5d <.literal16+0x24d>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  224,7                               // loopne        fd61 <.literal16+0x251>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  224,7                               // loopne        fd65 <.literal16+0x255>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  33,8                                // and           %ecx,(%eax)
  .byte  2,58                                // add           (%edx),%bh
  .byte  33,8                                // and           %ecx,(%eax)
  .byte  2,58                                // add           (%edx),%bh
  .byte  33,8                                // and           %ecx,(%eax)
  .byte  2,58                                // add           (%edx),%bh
  .byte  33,8                                // and           %ecx,(%eax)
  .byte  2,58                                // add           (%edx),%bh
  .byte  31                                  // pop           %ds
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,31                                // add           %bl,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,31                                // add           %bl,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,31                                // add           %bl,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,8                                 // add           %cl,(%eax)
  .byte  33,4,61,8,33,4,61                   // and           %eax,0x3d042108(,%edi,1)
  .byte  8,33                                // or            %ah,(%ecx)
  .byte  4,61                                // add           $0x3d,%al
  .byte  8,33                                // or            %ah,(%ecx)
  .byte  4,61                                // add           $0x3d,%al
  .byte  255,0                               // incl          (%eax)
  .byte  255,0                               // incl          (%eax)
  .byte  255,0                               // incl          (%eax)
  .byte  255,0                               // incl          (%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  128,0,128                           // addb          $0x80,(%eax)
  .byte  55                                  // aaa
  .byte  128,0,128                           // addb          $0x80,(%eax)
  .byte  55                                  // aaa
  .byte  128,0,128                           // addb          $0x80,(%eax)
  .byte  55                                  // aaa
  .byte  128,0,128                           // addb          $0x80,(%eax)
  .byte  55                                  // aaa
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,52,0                              // add           %dh,(%eax,%eax,1)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  52,0                                // xor           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  52,0                                // xor           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  52,255                              // xor           $0xff,%al
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            fdc4 <.literal16+0x2b4>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            fdc8 <.literal16+0x2b8>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            fdcc <.literal16+0x2bc>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            fdd0 <.literal16+0x2c0>
  .byte  119,115                             // ja            fe45 <.literal16+0x335>
  .byte  248                                 // clc
  .byte  194,119,115                         // ret           $0x7377
  .byte  248                                 // clc
  .byte  194,119,115                         // ret           $0x7377
  .byte  248                                 // clc
  .byte  194,119,115                         // ret           $0x7377
  .byte  248                                 // clc
  .byte  194,117,191                         // ret           $0xbf75
  .byte  191,63,117,191,191                  // mov           $0xbfbf753f,%edi
  .byte  63                                  // aas
  .byte  117,191                             // jne           fda9 <.literal16+0x299>
  .byte  191,63,117,191,191                  // mov           $0xbfbf753f,%edi
  .byte  63                                  // aas
  .byte  249                                 // stc
  .byte  68                                  // inc           %esp
  .byte  180,62                              // mov           $0x3e,%ah
  .byte  249                                 // stc
  .byte  68                                  // inc           %esp
  .byte  180,62                              // mov           $0x3e,%ah
  .byte  249                                 // stc
  .byte  68                                  // inc           %esp
  .byte  180,62                              // mov           $0x3e,%ah
  .byte  249                                 // stc
  .byte  68                                  // inc           %esp
  .byte  180,62                              // mov           $0x3e,%ah
  .byte  163,233,220,63,163                  // mov           %eax,0xa33fdce9
  .byte  233,220,63,163,233                  // jmp           e9a43de6 <_sk_srcover_bgra_8888_sse2_lowp+0xe9a345a2>
  .byte  220,63                              // fdivrl        (%edi)
  .byte  163,233,220,63,81                   // mov           %eax,0x513fdce9
  .byte  140,242                             // mov           %?,%edx
  .byte  66                                  // inc           %edx
  .byte  81                                  // push          %ecx
  .byte  140,242                             // mov           %?,%edx
  .byte  66                                  // inc           %edx
  .byte  81                                  // push          %ecx
  .byte  140,242                             // mov           %?,%edx
  .byte  66                                  // inc           %edx
  .byte  81                                  // push          %ecx
  .byte  140,242                             // mov           %?,%edx
  .byte  66                                  // inc           %edx
  .byte  141,188,190,63,141,188,190          // lea           -0x414372c1(%esi,%edi,4),%edi
  .byte  63                                  // aas
  .byte  141,188,190,63,141,188,190          // lea           -0x414372c1(%esi,%edi,4),%edi
  .byte  63                                  // aas
  .byte  248                                 // clc
  .byte  245                                 // cmc
  .byte  154,64,248,245,154,64,248           // lcall         $0xf840,$0x9af5f840
  .byte  245                                 // cmc
  .byte  154,64,248,245,154,64,254           // lcall         $0xfe40,$0x9af5f840
  .byte  210,221                             // rcr           %cl,%ch
  .byte  65                                  // inc           %ecx
  .byte  254                                 // (bad)
  .byte  210,221                             // rcr           %cl,%ch
  .byte  65                                  // inc           %ecx
  .byte  254                                 // (bad)
  .byte  210,221                             // rcr           %cl,%ch
  .byte  65                                  // inc           %ecx
  .byte  254                                 // (bad)
  .byte  210,221                             // rcr           %cl,%ch
  .byte  65                                  // inc           %ecx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,75,0                              // add           %cl,0x0(%ebx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  75                                  // dec           %ebx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,75,0                              // add           %cl,0x0(%ebx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  75                                  // dec           %ebx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  200,66,0,0                          // enter         $0x42,$0x0
  .byte  200,66,0,0                          // enter         $0x42,$0x0
  .byte  200,66,0,0                          // enter         $0x42,$0x0
  .byte  200,66,0,0                          // enter         $0x42,$0x0
  .byte  0,195                               // add           %al,%bl
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,195                               // add           %al,%bl
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,195                               // add           %al,%bl
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,195                               // add           %al,%bl
  .byte  0,0                                 // add           %al,(%eax)
  .byte  128,65,0,0                          // addb          $0x0,0x0(%ecx)
  .byte  128,65,0,0                          // addb          $0x0,0x0(%ecx)
  .byte  128,65,0,0                          // addb          $0x0,0x0(%ecx)
  .byte  128,65,203,61                       // addb          $0x3d,-0x35(%ecx)
  .byte  13,60,203,61,13                     // or            $0xd3dcb3c,%eax
  .byte  60,203                              // cmp           $0xcb,%al
  .byte  61,13,60,203,61                     // cmp           $0x3dcb3c0d,%eax
  .byte  13,60,111,18,3                      // or            $0x3126f3c,%eax
  .byte  59,111,18                           // cmp           0x12(%edi),%ebp
  .byte  3,59                                // add           (%ebx),%edi
  .byte  111                                 // outsl         %ds:(%esi),(%dx)
  .byte  18,3                                // adc           (%ebx),%al
  .byte  59,111,18                           // cmp           0x12(%edi),%ebp
  .byte  3,59                                // add           (%ebx),%edi
  .byte  10,215                              // or            %bh,%dl
  .byte  163,59,10,215,163                   // mov           %eax,0xa3d70a3b
  .byte  59,10                               // cmp           (%edx),%ecx
  .byte  215                                 // xlat          %ds:(%ebx)
  .byte  163,59,10,215,163                   // mov           %eax,0xa3d70a3b
  .byte  59,194                              // cmp           %edx,%eax
  .byte  24,17                               // sbb           %dl,(%ecx)
  .byte  60,194                              // cmp           $0xc2,%al
  .byte  24,17                               // sbb           %dl,(%ecx)
  .byte  60,194                              // cmp           $0xc2,%al
  .byte  24,17                               // sbb           %dl,(%ecx)
  .byte  60,194                              // cmp           $0xc2,%al
  .byte  24,17                               // sbb           %dl,(%ecx)
  .byte  60,203                              // cmp           $0xcb,%al
  .byte  61,13,190,203,61                    // cmp           $0x3dcbbe0d,%eax
  .byte  13,190,203,61,13                    // or            $0xd3dcbbe,%eax
  .byte  190,203,61,13,190                   // mov           $0xbe0d3dcb,%esi
  .byte  80                                  // push          %eax
  .byte  128,3,62                            // addb          $0x3e,(%ebx)
  .byte  80                                  // push          %eax
  .byte  128,3,62                            // addb          $0x3e,(%ebx)
  .byte  80                                  // push          %eax
  .byte  128,3,62                            // addb          $0x3e,(%ebx)
  .byte  80                                  // push          %eax
  .byte  128,3,62                            // addb          $0x3e,(%ebx)
  .byte  31                                  // pop           %ds
  .byte  215                                 // xlat          %ds:(%ebx)
  .byte  118,63                              // jbe           ff33 <.literal16+0x423>
  .byte  31                                  // pop           %ds
  .byte  215                                 // xlat          %ds:(%ebx)
  .byte  118,63                              // jbe           ff37 <.literal16+0x427>
  .byte  31                                  // pop           %ds
  .byte  215                                 // xlat          %ds:(%ebx)
  .byte  118,63                              // jbe           ff3b <.literal16+0x42b>
  .byte  31                                  // pop           %ds
  .byte  215                                 // xlat          %ds:(%ebx)
  .byte  118,63                              // jbe           ff3f <.literal16+0x42f>
  .byte  246,64,83,63                        // testb         $0x3f,0x53(%eax)
  .byte  246,64,83,63                        // testb         $0x3f,0x53(%eax)
  .byte  246,64,83,63                        // testb         $0x3f,0x53(%eax)
  .byte  246,64,83,63                        // testb         $0x3f,0x53(%eax)
  .byte  255,0                               // incl          (%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  255,0                               // incl          (%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  248                                 // clc
  .byte  65                                  // inc           %ecx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  248                                 // clc
  .byte  65                                  // inc           %ecx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  248                                 // clc
  .byte  65                                  // inc           %ecx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  248                                 // clc
  .byte  65                                  // inc           %ecx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  124,66                              // jl            ff76 <.literal16+0x466>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  124,66                              // jl            ff7a <.literal16+0x46a>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  124,66                              // jl            ff7e <.literal16+0x46e>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  124,66                              // jl            ff82 <.literal16+0x472>
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  137,136,136,55,137,136              // mov           %ecx,-0x7776c878(%eax)
  .byte  136,55                              // mov           %dh,(%edi)
  .byte  137,136,136,55,137,136              // mov           %ecx,-0x7776c878(%eax)
  .byte  136,55                              // mov           %dh,(%edi)
  .byte  0,15                                // add           %cl,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,15                                // add           %cl,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,15                                // add           %cl,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,15                                // add           %cl,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  137,136,136,57,137,136              // mov           %ecx,-0x7776c678(%eax)
  .byte  136,57                              // mov           %bh,(%ecx)
  .byte  137,136,136,57,137,136              // mov           %ecx,-0x7776c678(%eax)
  .byte  136,57                              // mov           %bh,(%ecx)
  .byte  240,0,0                             // lock          add %al,(%eax)
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,240                               // add           %dh,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,137,136,136,59,137                // add           %cl,-0x76c47778(%ecx)
  .byte  136,136,59,137,136,136              // mov           %cl,-0x777776c5(%eax)
  .byte  59,137,136,136,59,15                // cmp           0xf3b8888(%ecx),%ecx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,15                                // add           %cl,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,15                                // add           %cl,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,15                                // add           %cl,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,137,136,136,61,137                // add           %cl,-0x76c27778(%ecx)
  .byte  136,136,61,137,136,136              // mov           %cl,-0x777776c3(%eax)
  .byte  61,137,136,136,61                   // cmp           $0x3d888889,%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  112,65                              // jo            10005 <.literal16+0x4f5>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  112,65                              // jo            10009 <.literal16+0x4f9>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  112,65                              // jo            1000d <.literal16+0x4fd>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  112,65                              // jo            10011 <.literal16+0x501>
  .byte  0,128,0,0,0,128                     // add           %al,-0x80000000(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,128,0,0,0,128                     // add           %al,-0x80000000(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            ffe3 <.literal16+0x4d3>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,0                               // jg            ffe7 <.literal16+0x4d7>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,0                               // jg            ffeb <.literal16+0x4db>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,0                               // jg            ffef <.literal16+0x4df>
  .byte  0,0                                 // add           %al,(%eax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  4,0                                 // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  56,0                                // cmp           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  56,0                                // cmp           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  56,0                                // cmp           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  56,0                                // cmp           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  128,0,0                             // addb          $0x0,(%eax)
  .byte  0,128,0,0,0,128                     // add           %al,-0x80000000(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,128,255,255,255,127               // add           %al,0x7fffffff(%eax)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  127,255                             // jg            10028 <.literal16+0x518>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  127,255                             // jg            1002c <.literal16+0x51c>
  .byte  255                                 // (bad)
  .byte  255                                 // (bad)
  .byte  127,0                               // jg            10031 <.literal16+0x521>
  .byte  0,128,56,0,0,128                    // add           %al,-0x7fffffc8(%eax)
  .byte  56,0                                // cmp           %al,(%eax)
  .byte  0,128,56,0,0,128                    // add           %al,-0x7fffffc8(%eax)
  .byte  56,0                                // cmp           %al,(%eax)
  .byte  0,255                               // add           %bh,%bh
  .byte  255,0                               // incl          (%eax)
  .byte  0,255                               // add           %bh,%bh
  .byte  255,0                               // incl          (%eax)
  .byte  0,255                               // add           %bh,%bh
  .byte  255,0                               // incl          (%eax)
  .byte  0,255                               // add           %bh,%bh
  .byte  255,0                               // incl          (%eax)
  .byte  255                                 // (bad)
  .byte  127,71                              // jg            1009b <.literal16+0x58b>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,71                              // jg            1009f <.literal16+0x58f>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,71                              // jg            100a3 <.literal16+0x593>
  .byte  0,255                               // add           %bh,%bh
  .byte  127,71                              // jg            100a7 <.literal16+0x597>
  .byte  208                                 // (bad)
  .byte  179,89                              // mov           $0x59,%bl
  .byte  62,208                              // ds            (bad)
  .byte  179,89                              // mov           $0x59,%bl
  .byte  62,208                              // ds            (bad)
  .byte  179,89                              // mov           $0x59,%bl
  .byte  62,208                              // ds            (bad)
  .byte  179,89                              // mov           $0x59,%bl
  .byte  62,89                               // ds            pop %ecx
  .byte  23                                  // pop           %ss
  .byte  55                                  // aaa
  .byte  63                                  // aas
  .byte  89                                  // pop           %ecx
  .byte  23                                  // pop           %ss
  .byte  55                                  // aaa
  .byte  63                                  // aas
  .byte  89                                  // pop           %ecx
  .byte  23                                  // pop           %ss
  .byte  55                                  // aaa
  .byte  63                                  // aas
  .byte  89                                  // pop           %ecx
  .byte  23                                  // pop           %ss
  .byte  55                                  // aaa
  .byte  63                                  // aas
  .byte  152                                 // cwtl
  .byte  221,147,61,152,221,147              // fstl          -0x6c2267c3(%ebx)
  .byte  61,152,221,147,61                   // cmp           $0x3d93dd98,%eax
  .byte  152                                 // cwtl
  .byte  221,147,61,255,255,0                // fstl          0xffff3d(%ebx)
  .byte  0,255                               // add           %bh,%bh
  .byte  255,0                               // incl          (%eax)
  .byte  0,255                               // add           %bh,%bh
  .byte  255,0                               // incl          (%eax)
  .byte  0,255                               // add           %bh,%bh
  .byte  255,0                               // incl          (%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  83                                  // push          %ebx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,83,0                              // add           %dl,0x0(%ebx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  83                                  // push          %ebx
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,83,128                            // add           %dl,-0x80(%ebx)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  211,128,0,0,211,128                 // roll          %cl,-0x7f2d0000(%eax)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  211,128,0,0,211,111                 // roll          %cl,0x6fd30000(%eax)
  .byte  43,231                              // sub           %edi,%esp
  .byte  187,111,43,231,187                  // mov           $0xbbe72b6f,%ebx
  .byte  111                                 // outsl         %ds:(%esi),(%dx)
  .byte  43,231                              // sub           %edi,%esp
  .byte  187,111,43,231,187                  // mov           $0xbbe72b6f,%ebx
  .byte  159                                 // lahf
  .byte  215                                 // xlat          %ds:(%ebx)
  .byte  202,60,159                          // lret          $0x9f3c
  .byte  215                                 // xlat          %ds:(%ebx)
  .byte  202,60,159                          // lret          $0x9f3c
  .byte  215                                 // xlat          %ds:(%ebx)
  .byte  202,60,159                          // lret          $0x9f3c
  .byte  215                                 // xlat          %ds:(%ebx)
  .byte  202,60,212                          // lret          $0xd43c
  .byte  100,84                              // fs            push %esp
  .byte  189,212,100,84,189                  // mov           $0xbd5464d4,%ebp
  .byte  212,100                             // aam           $0x64
  .byte  84                                  // push          %esp
  .byte  189,212,100,84,189                  // mov           $0xbd5464d4,%ebp
  .byte  169,240,34,62,169                   // test          $0xa93e22f0,%eax
  .byte  240,34,62                           // lock          and (%esi),%bh
  .byte  169,240,34,62,169                   // test          $0xa93e22f0,%eax
  .byte  240,34,62                           // lock          and (%esi),%bh
  .byte  0,0                                 // add           %al,(%eax)
  .byte  128,62,0                            // cmpb          $0x0,(%esi)
  .byte  0,128,62,0,0,128                    // add           %al,-0x7fffffc2(%eax)
  .byte  62,0,0                              // add           %al,%ds:(%eax)
  .byte  128,62,0                            // cmpb          $0x0,(%esi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  192,0,0                             // rolb          $0x0,(%eax)
  .byte  0,192                               // add           %al,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,192                               // add           %al,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,192                               // add           %al,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  128,192,0                           // add           $0x0,%al
  .byte  0,128,192,0,0,128                   // add           %al,-0x7fffff40(%eax)
  .byte  192,0,0                             // rolb          $0x0,(%eax)
  .byte  128,192,0                           // add           $0x0,%al
  .byte  0,0                                 // add           %al,(%eax)
  .byte  191,0,0,0,191                       // mov           $0xbf000000,%edi
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,191,0,0,0,191                     // add           %bh,-0x41000000(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  192,191,0,0,192,191,0               // sarb          $0x0,-0x40400000(%edi)
  .byte  0,192                               // add           %al,%al
  .byte  191,0,0,192,191                     // mov           $0xbfc00000,%edi
  .byte  114,28                              // jb            1016e <.literal16+0x65e>
  .byte  199                                 // (bad)
  .byte  62,114,28                           // jb,pt         10172 <.literal16+0x662>
  .byte  199                                 // (bad)
  .byte  62,114,28                           // jb,pt         10176 <.literal16+0x666>
  .byte  199                                 // (bad)
  .byte  62,114,28                           // jb,pt         1017a <.literal16+0x66a>
  .byte  199                                 // (bad)
  .byte  62,85                               // ds            push %ebp
  .byte  85                                  // push          %ebp
  .byte  149                                 // xchg          %eax,%ebp
  .byte  191,85,85,149,191                   // mov           $0xbf955555,%edi
  .byte  85                                  // push          %ebp
  .byte  85                                  // push          %ebp
  .byte  149                                 // xchg          %eax,%ebp
  .byte  191,85,85,149,191                   // mov           $0xbf955555,%edi
  .byte  0,0                                 // add           %al,(%eax)
  .byte  192,63,0                            // sarb          $0x0,(%edi)
  .byte  0,192                               // add           %al,%al
  .byte  63                                  // aas
  .byte  0,0                                 // add           %al,(%eax)
  .byte  192,63,0                            // sarb          $0x0,(%edi)
  .byte  0,192                               // add           %al,%al
  .byte  63                                  // aas
  .byte  57,142,99,61,57,142                 // cmp           %ecx,-0x71c6c29d(%esi)
  .byte  99,61,57,142,99,61                  // arpl          %di,0x3d638e39
  .byte  57,142,99,61,114,249                // cmp           %ecx,-0x68dc29d(%esi)
  .byte  127,63                              // jg            101d3 <.literal16+0x6c3>
  .byte  114,249                             // jb            1018f <.literal16+0x67f>
  .byte  127,63                              // jg            101d7 <.literal16+0x6c7>
  .byte  114,249                             // jb            10193 <.literal16+0x683>
  .byte  127,63                              // jg            101db <.literal16+0x6cb>
  .byte  114,249                             // jb            10197 <.literal16+0x687>
  .byte  127,63                              // jg            101df <.literal16+0x6cf>
  .byte  3,0                                 // add           (%eax),%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  3,0                                 // add           (%eax),%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  3,0                                 // add           (%eax),%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  3,0                                 // add           (%eax),%eax
  .byte  0,0                                 // add           %al,(%eax)
  .byte  45,16,17,192,45                     // sub           $0x2dc01110,%eax
  .byte  16,17                               // adc           %dl,(%ecx)
  .byte  192,45,16,17,192,45,16              // shrb          $0x10,0x2dc01110
  .byte  17,192                              // adc           %eax,%eax
  .byte  18,120,57                           // adc           0x39(%eax),%bh
  .byte  64                                  // inc           %eax
  .byte  18,120,57                           // adc           0x39(%eax),%bh
  .byte  64                                  // inc           %eax
  .byte  18,120,57                           // adc           0x39(%eax),%bh
  .byte  64                                  // inc           %eax
  .byte  18,120,57                           // adc           0x39(%eax),%bh
  .byte  64                                  // inc           %eax
  .byte  32,148,90,62,32,148,90              // and           %dl,0x5a94203e(%edx,%ebx,2)
  .byte  62,32,148,90,62,32,148,90           // and           %dl,%ds:0x5a94203e(%edx,%ebx,2)
  .byte  62,4,157                            // ds            add $0x9d,%al
  .byte  30                                  // push          %ds
  .byte  62,4,157                            // ds            add $0x9d,%al
  .byte  30                                  // push          %ds
  .byte  62,4,157                            // ds            add $0x9d,%al
  .byte  30                                  // push          %ds
  .byte  62,4,157                            // ds            add $0x9d,%al
  .byte  30                                  // push          %ds
  .byte  62,0,24                             // add           %bl,%ds:(%eax)
  .byte  161,57,0,24,161                     // mov           0xa1180039,%eax
  .byte  57,0                                // cmp           %eax,(%eax)
  .byte  24,161,57,0,24,161                  // sbb           %ah,-0x5ee7ffc7(%ecx)
  .byte  57,255                              // cmp           %edi,%edi
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,0                                 // add           %al,(%eax)
  .byte  128,0,128                           // addb          $0x80,(%eax)
  .byte  0,128,0,128,0,128                   // add           %al,-0x7fff8000(%eax)
  .byte  0,128,0,128,0,128                   // add           %al,-0x7fff8000(%eax)
  .byte  254,0                               // incb          (%eax)
  .byte  254,0                               // incb          (%eax)
  .byte  254,0                               // incb          (%eax)
  .byte  254,0                               // incb          (%eax)
  .byte  254,0                               // incb          (%eax)
  .byte  254,0                               // incb          (%eax)
  .byte  254,0                               // incb          (%eax)
  .byte  254,0                               // incb          (%eax)
  .byte  254,1                               // incb          (%ecx)
  .byte  254,1                               // incb          (%ecx)
  .byte  254,1                               // incb          (%ecx)
  .byte  254,1                               // incb          (%ecx)
  .byte  254,1                               // incb          (%ecx)
  .byte  254,1                               // incb          (%ecx)
  .byte  254,1                               // incb          (%ecx)
  .byte  254,1                               // incb          (%ecx)
  .byte  248                                 // clc
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,31                                // add           %bl,(%edi)
  .byte  0,31                                // add           %bl,(%edi)
  .byte  0,31                                // add           %bl,(%edi)
  .byte  0,31                                // add           %bl,(%edi)
  .byte  0,31                                // add           %bl,(%edi)
  .byte  0,31                                // add           %bl,(%edi)
  .byte  0,31                                // add           %bl,(%edi)
  .byte  0,31                                // add           %bl,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  248                                 // clc
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  0,248                               // add           %bh,%al
  .byte  224,255                             // loopne        10281 <.literal16+0x771>
  .byte  224,255                             // loopne        10283 <.literal16+0x773>
  .byte  224,255                             // loopne        10285 <.literal16+0x775>
  .byte  224,255                             // loopne        10287 <.literal16+0x777>
  .byte  224,255                             // loopne        10289 <.literal16+0x779>
  .byte  224,255                             // loopne        1028b <.literal16+0x77b>
  .byte  224,255                             // loopne        1028d <.literal16+0x77d>
  .byte  224,255                             // loopne        1028f <.literal16+0x77f>
  .byte  15,0,15                             // str           (%edi)
  .byte  0,15                                // add           %cl,(%edi)
  .byte  0,15                                // add           %cl,(%edi)
  .byte  0,15                                // add           %cl,(%edi)
  .byte  0,15                                // add           %cl,(%edi)
  .byte  0,15                                // add           %cl,(%edi)
  .byte  0,15                                // add           %cl,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  240,0,240                           // lock          add %dh,%al
  .byte  0,240                               // add           %dh,%al
  .byte  0,240                               // add           %dh,%al
  .byte  0,240                               // add           %dh,%al
  .byte  0,240                               // add           %dh,%al
  .byte  0,240                               // add           %dh,%al
  .byte  0,240                               // add           %dh,%al
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  0,255                               // add           %bh,%bh
  .byte  240,255,240                         // lock          push %eax
  .byte  255,240                             // push          %eax
  .byte  255,240                             // push          %eax
  .byte  255,240                             // push          %eax
  .byte  255,240                             // push          %eax
  .byte  255,240                             // push          %eax
  .byte  255,240                             // push          %eax
  .byte  255,54                              // pushl         (%esi)
  .byte  0,54                                // add           %dh,(%esi)
  .byte  0,54                                // add           %dh,(%esi)
  .byte  0,54                                // add           %dh,(%esi)
  .byte  0,54                                // add           %dh,(%esi)
  .byte  0,54                                // add           %dh,(%esi)
  .byte  0,54                                // add           %dh,(%esi)
  .byte  0,54                                // add           %dh,(%esi)
  .byte  0,183,0,183,0,183                   // add           %dh,-0x48ff4900(%edi)
  .byte  0,183,0,183,0,183                   // add           %dh,-0x48ff4900(%edi)
  .byte  0,183,0,183,0,19                    // add           %dh,0x1300b700(%edi)
  .byte  0,19                                // add           %dl,(%ebx)
  .byte  0,19                                // add           %dl,(%ebx)
  .byte  0,19                                // add           %dl,(%ebx)
  .byte  0,19                                // add           %dl,(%ebx)
  .byte  0,19                                // add           %dl,(%ebx)
  .byte  0,19                                // add           %dl,(%ebx)
  .byte  0,19                                // add           %dl,(%ebx)
  .byte  0                                   // .byte         0x0

BALIGN4
  .byte  0,0                                 // add           %al,(%eax)
  .byte  0,63                                // add           %bh,(%edi)
  .byte  0,0                                 // add           %al,(%eax)
  .byte  127,67                              // jg            1034b <_sk_srcover_bgra_8888_sse2_lowp+0xb07>
#endif
